-- MySQL dump 10.13  Distrib 5.6.36, for Linux (x86_64)
--
-- Host: localhost    Database: d7_forum-plus
-- ------------------------------------------------------
-- Server version	5.6.30

/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8 */;
/*!40103 SET @OLD_TIME_ZONE=@@TIME_ZONE */;
/*!40103 SET TIME_ZONE='+00:00' */;
/*!40014 SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0 */;
/*!40014 SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0 */;
/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO' */;
/*!40111 SET @OLD_SQL_NOTES=@@SQL_NOTES, SQL_NOTES=0 */;

--
-- Table structure for table `accesslog`
--

DROP TABLE IF EXISTS `accesslog`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `accesslog` (
  `aid` int(11) NOT NULL AUTO_INCREMENT COMMENT 'Primary Key: Unique accesslog ID.',
  `sid` varchar(128) NOT NULL DEFAULT '' COMMENT 'Browser session ID of user that visited page.',
  `title` varchar(255) DEFAULT NULL COMMENT 'Title of page visited.',
  `path` varchar(255) DEFAULT NULL COMMENT 'Internal path to page visited (relative to Drupal root.)',
  `url` text COMMENT 'Referrer URI.',
  `hostname` varchar(128) DEFAULT NULL COMMENT 'Hostname of user that visited the page.',
  `uid` int(10) unsigned DEFAULT '0' COMMENT 'User users.uid that visited the page.',
  `timer` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Time in milliseconds that the page took to load.',
  `timestamp` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Timestamp of when the page was visited.',
  PRIMARY KEY (`aid`),
  KEY `accesslog_timestamp` (`timestamp`),
  KEY `uid` (`uid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Stores site access information for statistics.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `accesslog`
--

LOCK TABLES `accesslog` WRITE;
/*!40000 ALTER TABLE `accesslog` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `accesslog` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `actions`
--

DROP TABLE IF EXISTS `actions`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `actions` (
  `aid` varchar(255) NOT NULL DEFAULT '0' COMMENT 'Primary Key: Unique actions ID.',
  `type` varchar(32) NOT NULL DEFAULT '' COMMENT 'The object that that action acts on (node, user, comment, system or custom types.)',
  `callback` varchar(255) NOT NULL DEFAULT '' COMMENT 'The callback function that executes when the action runs.',
  `parameters` longblob NOT NULL COMMENT 'Parameters to be passed to the callback function.',
  `label` varchar(255) NOT NULL DEFAULT '0' COMMENT 'Label of the action.',
  PRIMARY KEY (`aid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Stores action information.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `actions`
--

LOCK TABLES `actions` WRITE;
/*!40000 ALTER TABLE `actions` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `actions` VALUES ('comment_publish_action','comment','comment_publish_action','','Publish comment'),('comment_save_action','comment','comment_save_action','','Save comment'),('comment_unpublish_action','comment','comment_unpublish_action','','Unpublish comment'),('node_make_sticky_action','node','node_make_sticky_action','','Make content sticky'),('node_make_unsticky_action','node','node_make_unsticky_action','','Make content unsticky'),('node_promote_action','node','node_promote_action','','Promote content to front page'),('node_publish_action','node','node_publish_action','','Publish content'),('node_save_action','node','node_save_action','','Save content'),('node_unpromote_action','node','node_unpromote_action','','Remove content from front page'),('node_unpublish_action','node','node_unpublish_action','','Unpublish content'),('pathauto_node_update_action','node','pathauto_node_update_action','','Update node alias'),('pathauto_taxonomy_term_update_action','taxonomy_term','pathauto_taxonomy_term_update_action','','Update taxonomy term alias'),('pathauto_user_update_action','user','pathauto_user_update_action','','Update user alias'),('system_block_ip_action','user','system_block_ip_action','','Ban IP address of current user'),('user_block_user_action','user','user_block_user_action','','Block current user');
/*!40000 ALTER TABLE `actions` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `authmap`
--

DROP TABLE IF EXISTS `authmap`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `authmap` (
  `aid` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Primary Key: Unique authmap ID.',
  `uid` int(11) NOT NULL DEFAULT '0' COMMENT 'User’s users.uid.',
  `authname` varchar(128) NOT NULL DEFAULT '' COMMENT 'Unique authentication name.',
  `module` varchar(128) NOT NULL DEFAULT '' COMMENT 'Module which is controlling the authentication.',
  PRIMARY KEY (`aid`),
  UNIQUE KEY `authname` (`authname`),
  KEY `uid_module` (`uid`,`module`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Stores distributed authentication mapping.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `authmap`
--

LOCK TABLES `authmap` WRITE;
/*!40000 ALTER TABLE `authmap` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `authmap` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `batch`
--

DROP TABLE IF EXISTS `batch`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `batch` (
  `bid` int(10) unsigned NOT NULL COMMENT 'Primary Key: Unique batch ID.',
  `token` varchar(64) NOT NULL COMMENT 'A string token generated against the current user’s session id and the batch id, used to ensure that only the user who submitted the batch can effectively access it.',
  `timestamp` int(11) NOT NULL COMMENT 'A Unix timestamp indicating when this batch was submitted for processing. Stale batches are purged at cron time.',
  `batch` longblob COMMENT 'A serialized array containing the processing data for the batch.',
  PRIMARY KEY (`bid`),
  KEY `token` (`token`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Stores details about batches (processes that run in...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `batch`
--

LOCK TABLES `batch` WRITE;
/*!40000 ALTER TABLE `batch` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `batch` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `block`
--

DROP TABLE IF EXISTS `block`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `block` (
  `bid` int(11) NOT NULL AUTO_INCREMENT COMMENT 'Primary Key: Unique block ID.',
  `module` varchar(64) NOT NULL DEFAULT '' COMMENT 'The module from which the block originates; for example, ’user’ for the Who’s Online block, and ’block’ for any custom blocks.',
  `delta` varchar(32) NOT NULL DEFAULT '0' COMMENT 'Unique ID for block within a module.',
  `theme` varchar(64) NOT NULL DEFAULT '' COMMENT 'The theme under which the block settings apply.',
  `status` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'Block enabled status. (1 = enabled, 0 = disabled)',
  `weight` int(11) NOT NULL DEFAULT '0' COMMENT 'Block weight within region.',
  `region` varchar(64) NOT NULL DEFAULT '' COMMENT 'Theme region within which the block is set.',
  `custom` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'Flag to indicate how users may control visibility of the block. (0 = Users cannot control, 1 = On by default, but can be hidden, 2 = Hidden by default, but can be shown)',
  `visibility` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'Flag to indicate how to show blocks on pages. (0 = Show on all pages except listed pages, 1 = Show only on listed pages, 2 = Use custom PHP code to determine visibility)',
  `pages` text NOT NULL COMMENT 'Contents of the "Pages" block; contains either a list of paths on which to include/exclude the block or PHP code, depending on "visibility" setting.',
  `title` varchar(255) NOT NULL DEFAULT '' COMMENT 'Custom title for the block. (Empty string will use block default title, <none> will remove the title, text will cause block to use specified title.)',
  `cache` tinyint(4) NOT NULL DEFAULT '1' COMMENT 'Binary flag to indicate block cache mode. (-2: Custom cache, -1: Do not cache, 1: Cache per role, 2: Cache per user, 4: Cache per page, 8: Block cache global) See DRUPAL_CACHE_* constants in ../includes/common.inc for more detailed information.',
  `i18n_mode` int(11) NOT NULL DEFAULT '0' COMMENT 'Block multilingual mode.',
  `css_class` varchar(255) NOT NULL DEFAULT '' COMMENT 'String containing the classes for the block.',
  PRIMARY KEY (`bid`),
  UNIQUE KEY `tmd` (`theme`,`module`,`delta`),
  KEY `list` (`theme`,`status`,`region`,`weight`,`module`)
) ENGINE=InnoDB AUTO_INCREMENT=287 DEFAULT CHARSET=utf8 COMMENT='Stores block settings, such as region and visibility...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `block`
--

LOCK TABLES `block` WRITE;
/*!40000 ALTER TABLE `block` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `block` VALUES (1,'system','main','bartik',1,0,'content',0,0,'','',-1,0,''),(2,'search','form','bartik',0,-1,'-1',0,0,'','',-1,0,''),(3,'node','recent','seven',1,10,'dashboard_main',0,0,'','',-1,0,''),(4,'user','login','bartik',0,0,'-1',0,0,'','',-1,0,''),(5,'system','navigation','bartik',0,0,'-1',0,0,'','',-1,0,''),(6,'system','powered-by','bartik',1,10,'footer',0,0,'','',-1,0,''),(7,'system','help','bartik',1,0,'help',0,0,'','',-1,0,''),(8,'system','main','seven',1,0,'content',0,0,'','',-1,0,''),(9,'system','help','seven',1,0,'help',0,0,'','',-1,0,''),(10,'user','login','seven',1,10,'content',0,0,'','',-1,0,''),(11,'user','new','seven',1,0,'dashboard_sidebar',0,1,'blogs\r\nblogs/mix\r\nblogs/teaser\r\nblog\r\nblog/*\r\nvideo/*\r\narticle/*','',-1,0,''),(12,'search','form','seven',1,-10,'dashboard_sidebar',0,0,'','',-1,0,''),(13,'comment','recent','bartik',0,0,'-1',0,0,'','',1,0,''),(14,'node','syndicate','bartik',0,0,'-1',0,0,'','',-1,0,''),(15,'node','recent','bartik',0,0,'-1',0,0,'','',1,0,''),(16,'shortcut','shortcuts','bartik',0,0,'-1',0,0,'','',-1,0,''),(17,'system','management','bartik',0,0,'-1',0,0,'','',-1,0,''),(18,'system','user-menu','bartik',0,0,'-1',0,0,'','<none>',-1,0,''),(19,'system','main-menu','bartik',0,0,'-1',0,0,'megamenu','<none>',-1,0,''),(20,'user','new','bartik',0,0,'-1',0,1,'blogs\r\nblogs/mix\r\nblogs/teaser\r\nblog\r\nblog/*\r\nvideo/*\r\narticle/*','',1,0,''),(21,'user','online','bartik',0,0,'-1',0,1,'blogs\r\nblogs/mix\r\nblogs/teaser\r\nblogs/two\r\nblog\r\nblog/*\r\nvideo/*\r\narticle/*','',-1,0,''),(22,'comment','recent','seven',1,0,'dashboard_inactive',0,0,'','',1,0,''),(23,'node','syndicate','seven',0,0,'-1',0,0,'','',-1,0,''),(24,'shortcut','shortcuts','seven',0,0,'-1',0,0,'','',-1,0,''),(25,'system','powered-by','seven',0,10,'-1',0,0,'','',-1,0,''),(26,'system','navigation','seven',0,0,'-1',0,0,'','',-1,0,''),(27,'system','management','seven',0,0,'-1',0,0,'','',-1,0,''),(28,'system','user-menu','seven',0,0,'-1',0,0,'','<none>',-1,0,''),(29,'system','main-menu','seven',0,0,'-1',0,0,'megamenu','<none>',-1,0,''),(30,'user','online','seven',1,0,'dashboard_inactive',0,1,'blogs\r\nblogs/mix\r\nblogs/teaser\r\nblogs/two\r\nblog\r\nblog/*\r\nvideo/*\r\narticle/*','',-1,0,''),(31,'blog','recent','bartik',0,0,'-1',0,0,'','',1,0,''),(32,'book','navigation','bartik',0,0,'-1',0,0,'','',5,0,''),(33,'forum','active','bartik',0,0,'-1',0,1,'blogs\r\nblogs/mix\r\nblogs/teaser\r\nblog\r\nblog/*\r\nvideo/*\r\narticles\r\narticles/*\r\narticle/*\r\narticles-teaser\r\nforum\r\nactivity-stream','',-2,0,''),(34,'forum','new','bartik',0,0,'-1',0,0,'','Recent Topics',-2,0,''),(35,'blog','recent','seven',1,0,'dashboard_inactive',0,0,'','',1,0,''),(36,'book','navigation','seven',0,0,'-1',0,0,'','',5,0,''),(37,'forum','active','seven',1,0,'dashboard_inactive',0,1,'blogs\r\nblogs/mix\r\nblogs/teaser\r\nblog\r\nblog/*\r\nvideo/*\r\narticles\r\narticles/*\r\narticle/*\r\narticles-teaser\r\nforum\r\nactivity-stream','',-2,0,''),(38,'forum','new','seven',1,0,'dashboard_inactive',0,0,'','Recent Topics',-2,0,''),(39,'blog','recent','forum_plus',0,0,'-1',0,0,'','',1,0,''),(40,'book','navigation','forum_plus',0,0,'-1',0,0,'','',5,0,''),(41,'comment','recent','forum_plus',0,0,'-1',0,0,'','',1,0,''),(42,'forum','active','forum_plus',1,0,'sidebar_first',0,1,'blogs\r\nblogs/mix\r\nblogs/teaser\r\nblog\r\nblog/*\r\nvideo/*\r\narticles\r\narticles/*\r\narticle/*\r\narticles-teaser\r\nforum\r\nactivity-stream','',-2,0,''),(43,'forum','new','forum_plus',0,0,'-1',0,0,'','Recent Topics',-2,0,''),(44,'node','recent','forum_plus',0,0,'-1',0,0,'','',1,0,''),(45,'node','syndicate','forum_plus',0,0,'-1',0,0,'','',-1,0,''),(46,'search','form','forum_plus',1,-14,'headline',0,0,'','',-1,0,''),(47,'shortcut','shortcuts','forum_plus',0,0,'-1',0,0,'','',-1,0,''),(48,'system','help','forum_plus',1,0,'help',0,0,'','',-1,0,''),(49,'system','main','forum_plus',1,-28,'content',0,0,'','',-1,0,''),(50,'system','main-menu','forum_plus',1,0,'main_menu',0,0,'megamenu','<none>',-1,0,''),(51,'system','management','forum_plus',0,0,'-1',0,0,'','',-1,0,''),(52,'system','navigation','forum_plus',0,0,'-1',0,0,'','',-1,0,''),(53,'system','powered-by','forum_plus',0,10,'-1',0,0,'','',-1,0,''),(54,'system','user-menu','forum_plus',1,-16,'headline',0,0,'','<none>',-1,0,''),(55,'user','login','forum_plus',0,-15,'-1',0,0,'','',-1,0,''),(56,'user','new','forum_plus',1,0,'sidebar_first',0,1,'blogs\r\nblogs/mix\r\nblogs/teaser\r\nblog\r\nblog/*\r\nvideo/*\r\narticle/*','',1,0,''),(57,'user','online','forum_plus',1,0,'sidebar_first',0,1,'blogs\r\nblogs/mix\r\nblogs/teaser\r\nblogs/two\r\nblog\r\nblog/*\r\nvideo/*\r\narticle/*','',-1,0,''),(58,'block','1','bartik',0,0,'-1',0,0,'','',-1,0,''),(59,'block','1','forum_plus',1,-17,'headline',0,0,'','',-1,0,''),(60,'block','1','seven',0,0,'-1',0,0,'','',-1,0,''),(61,'lang_dropdown','language','bartik',0,0,'-1',0,0,'','<none>',-1,0,''),(62,'locale','language','bartik',0,0,'-1',0,0,'','',-1,0,''),(63,'lang_dropdown','language','forum_plus',1,0,'panel_second',0,0,'','<none>',-1,0,''),(64,'locale','language','forum_plus',0,0,'-1',0,0,'','',-1,0,''),(65,'lang_dropdown','language','seven',0,0,'-1',0,0,'','<none>',-1,0,''),(66,'locale','language','seven',0,0,'-1',0,0,'','',-1,0,''),(67,'menu','menu-links','forum_plus',1,0,'panel_footer_2',0,0,'','',-1,0,''),(68,'block','2','bartik',0,0,'-1',0,0,'','About US',-1,0,''),(69,'block','2','forum_plus',1,0,'panel_footer_3',0,0,'','About US',-1,0,''),(70,'block','2','seven',0,0,'-1',0,0,'','About US',-1,0,''),(71,'block','3','bartik',0,0,'-1',0,0,'','Contact',-1,0,'last-block'),(72,'block','3','forum_plus',1,-13,'panel_footer_4',0,0,'','Contact',-1,0,'last-block'),(73,'block','3','seven',0,0,'-1',0,0,'','Contact',-1,0,'last-block'),(74,'block','4','bartik',0,0,'-1',0,0,'','',-1,0,''),(75,'block','4','forum_plus',1,-12,'panel_footer_4',0,0,'','',-1,0,''),(76,'block','4','seven',0,0,'-1',0,0,'','',-1,0,''),(77,'menu','menu-links','bartik',0,0,'-1',0,0,'','',-1,0,''),(78,'menu','menu-links','seven',0,0,'-1',0,0,'','',-1,0,''),(79,'block','5','bartik',0,0,'-1',0,0,'','',-1,0,''),(80,'block','5','forum_plus',1,-15,'footer',0,0,'','',-1,0,''),(81,'block','5','seven',0,0,'-1',0,0,'','',-1,0,''),(82,'block','6','bartik',0,0,'-1',0,1,'contact','Get In Touch',-1,0,''),(83,'block','6','forum_plus',1,-27,'content',0,1,'contact','Get In Touch',-1,0,''),(84,'block','6','seven',0,0,'-1',0,1,'contact','Get In Touch',-1,0,''),(85,'menu','menu-footer-menu','forum_plus',1,-16,'footer',0,0,'','<none>',-1,0,''),(86,'menu','menu-footer-menu','bartik',0,0,'-1',0,0,'','<none>',-1,0,''),(87,'menu','menu-footer-menu','seven',0,0,'-1',0,0,'','<none>',-1,0,''),(88,'block','7','bartik',0,0,'-1',0,1,'<front>','',-1,0,''),(89,'block','7','forum_plus',1,0,'panel_first',0,1,'<front>','',-1,0,''),(90,'block','7','seven',0,0,'-1',0,1,'<front>','',-1,0,''),(94,'tagclouds','2','bartik',0,0,'-1',0,0,'','',8,0,''),(95,'tagclouds','1','bartik',0,0,'-1',0,1,'blogs\r\nblogs/*\r\nblog\r\nblog/*\r\nvideo/*\r\narticles\r\narticles/*\r\narticle/*\r\narticles-teaser\r\nforum\r\nactivity-stream','Tags',8,0,''),(96,'tagclouds','2','forum_plus',0,0,'-1',0,0,'','',8,0,''),(97,'tagclouds','1','forum_plus',1,-23,'sidebar_first',0,1,'blogs\r\nblogs/*\r\nblog\r\nblog/*\r\nvideo/*\r\narticles\r\narticles/*\r\narticle/*\r\narticles-teaser\r\nforum\r\nactivity-stream','Tags',8,0,''),(98,'tagclouds','2','seven',0,0,'-1',0,0,'','',8,0,''),(99,'tagclouds','1','seven',0,0,'-1',0,1,'blogs\r\nblogs/*\r\nblog\r\nblog/*\r\nvideo/*\r\narticles\r\narticles/*\r\narticle/*\r\narticles-teaser\r\nforum\r\nactivity-stream','Tags',8,0,''),(100,'author_pane','delta-0','bartik',0,0,'-1',0,0,'','',-1,0,''),(101,'author_pane','delta-0','forum_plus',0,0,'-1',0,0,'','',-1,0,''),(102,'author_pane','delta-0','seven',0,0,'-1',0,0,'','',-1,0,''),(103,'statistics','popular','bartik',0,0,'-1',0,0,'','',-1,0,''),(104,'statistics','popular','forum_plus',0,0,'-1',0,0,'','',-1,0,''),(105,'statistics','popular','seven',0,0,'-1',0,0,'','',-1,0,''),(106,'menu','features','bartik',0,0,'-1',0,0,'','',-1,0,''),(107,'menu','features','forum_plus',0,0,'-1',0,0,'','',-1,0,''),(108,'menu','features','seven',0,0,'-1',0,0,'','',-1,0,''),(124,'views','recent_blogs-block','bartik',0,0,'-1',0,0,'','',-1,0,''),(125,'views','recent_blogs-block_1','bartik',0,0,'-1',0,0,'','',-1,0,''),(126,'views','recent_blogs-block_2','bartik',0,0,'-1',0,0,'','',-1,0,''),(127,'views','recent_blogs-block','forum_plus',0,0,'-1',0,0,'','',-1,0,''),(128,'views','recent_blogs-block_1','forum_plus',0,0,'-1',0,0,'','',-1,0,''),(129,'views','recent_blogs-block_2','forum_plus',0,0,'-1',0,0,'','',-1,0,''),(130,'views','recent_blogs-block','seven',0,0,'-1',0,0,'','',-1,0,''),(131,'views','recent_blogs-block_1','seven',0,0,'-1',0,0,'','',-1,0,''),(132,'views','recent_blogs-block_2','seven',0,0,'-1',0,0,'','',-1,0,''),(133,'quicktabs','quicktab','seven',0,0,'-1',0,1,'blogs\r\nblogs/*\r\nblog\r\nblog/*\r\nvideo/*\r\nactivity-stream','<none>',-1,0,''),(134,'quicktabs','quicktab','forum_plus',1,-28,'sidebar_first',0,1,'blogs\r\nblogs/*\r\nblog\r\nblog/*\r\nvideo/*\r\nactivity-stream','<none>',-1,0,''),(135,'quicktabs','quicktab','bartik',0,0,'-1',0,1,'blogs\r\nblogs/*\r\nblog\r\nblog/*\r\nvideo/*\r\nactivity-stream','<none>',-1,0,''),(136,'views','comments-block','forum_plus',1,-27,'sidebar_first',0,1,'blogs\r\nblogs/mix\r\nblogs/teaser\r\nblogs/two\r\nblog\r\nblog/*\r\nvideo/*\r\nactivity-stream','',-1,0,''),(137,'views','comments-block','bartik',0,0,'-1',0,1,'blogs\r\nblogs/mix\r\nblogs/teaser\r\nblogs/two\r\nblog\r\nblog/*\r\nvideo/*\r\nactivity-stream','',-1,0,''),(138,'views','comments-block','seven',0,0,'-1',0,1,'blogs\r\nblogs/mix\r\nblogs/teaser\r\nblogs/two\r\nblog\r\nblog/*\r\nvideo/*\r\nactivity-stream','',-1,0,''),(142,'tagclouds','3','bartik',0,0,'-1',0,0,'','',8,0,''),(143,'tagclouds','4','bartik',0,0,'-1',0,0,'','',8,0,''),(144,'tagclouds','3','forum_plus',0,0,'-1',0,0,'','',8,0,''),(145,'tagclouds','4','forum_plus',0,0,'-1',0,0,'','',8,0,''),(146,'tagclouds','3','seven',0,0,'-1',0,0,'','',8,0,''),(147,'tagclouds','4','seven',0,0,'-1',0,0,'','',8,0,''),(148,'menu','menu-categories','forum_plus',1,-25,'sidebar_first',0,1,'articles\r\narticles-teaser\r\narticles/*\r\narticle/*','',-1,0,''),(149,'menu','menu-sections','forum_plus',1,-26,'sidebar_first',0,1,'articles\r\narticles-teaser\r\narticles/*\r\narticle/*\r\nsections/*\r\ntaxonomy/*','',-1,0,''),(150,'menu','menu-categories','bartik',0,0,'-1',0,1,'articles\r\narticles-teaser\r\narticles/*\r\narticle/*','',-1,0,''),(151,'menu','menu-categories','seven',0,0,'-1',0,1,'articles\r\narticles-teaser\r\narticles/*\r\narticle/*','',-1,0,''),(152,'menu','menu-sections','bartik',0,0,'-1',0,1,'articles\r\narticles-teaser\r\narticles/*\r\narticle/*\r\nsections/*\r\ntaxonomy/*','',-1,0,''),(153,'menu','menu-sections','seven',0,0,'-1',0,1,'articles\r\narticles-teaser\r\narticles/*\r\narticle/*\r\nsections/*\r\ntaxonomy/*','',-1,0,''),(154,'block','9','bartik',0,0,'-1',0,1,'<front>','<none>',-1,0,'welcome-block'),(155,'block','9','forum_plus',1,0,'welcome',0,1,'<front>','<none>',-1,0,'welcome-block'),(156,'block','9','seven',0,0,'-1',0,1,'<front>','<none>',-1,0,'welcome-block'),(157,'views','recent_topics-block','forum_plus',1,0,'panel_footer_1',0,0,'','',-1,0,''),(158,'calendar','calendar_legend','bartik',0,0,'-1',0,0,'','',1,0,''),(159,'views','recent_topics-block','bartik',0,0,'-1',0,0,'','',-1,0,''),(160,'calendar','calendar_legend','forum_plus',0,0,'-1',0,0,'','',1,0,''),(161,'calendar','calendar_legend','seven',0,0,'-1',0,0,'','',1,0,''),(162,'views','recent_topics-block','seven',0,0,'-1',0,0,'','',-1,0,''),(163,'faq','faq_categories','bartik',0,0,'-1',0,0,'','',1,0,''),(164,'views','faq-faq_recent','bartik',0,0,'-1',0,0,'','',-1,0,''),(165,'views','faq-faq_random','bartik',0,0,'-1',0,0,'','',-1,0,''),(166,'faq','faq_categories','forum_plus',0,0,'-1',0,0,'','',1,0,''),(167,'views','faq-faq_recent','forum_plus',0,0,'-1',0,0,'','',-1,0,''),(168,'views','faq-faq_random','forum_plus',0,0,'-1',0,0,'','',-1,0,''),(169,'faq','faq_categories','seven',0,0,'-1',0,0,'','',1,0,''),(170,'views','faq-faq_recent','seven',0,0,'-1',0,0,'','',-1,0,''),(171,'views','faq-faq_random','seven',0,0,'-1',0,0,'','',-1,0,''),(172,'views','archive-block','bartik',0,0,'-1',0,0,'','',-1,0,''),(173,'views','archive-block','forum_plus',0,0,'-1',0,0,'','',-1,0,''),(174,'views','archive-block','seven',0,0,'-1',0,0,'','',-1,0,''),(175,'views','new_forum_posts-block','forum_plus',1,-29,'sidebar_first',0,1,'forum','',-1,0,''),(176,'views','new_forum_posts-block','bartik',0,0,'-1',0,0,'forum','',-1,0,''),(177,'views','new_forum_posts-block','seven',0,0,'-1',0,0,'forum','',-1,0,''),(181,'block','11','bartik',0,0,'-1',0,1,'contact\r\ncontact-us\r\ncontact-us-2','<none>',-1,0,''),(182,'block','11','forum_plus',1,0,'gmap',0,1,'contact\r\ncontact-us\r\ncontact-us-2','<none>',-1,0,''),(183,'block','11','seven',0,0,'-1',0,1,'contact\r\ncontact-us\r\ncontact-us-2','<none>',-1,0,''),(184,'sharethis','sharethis_block','bartik',0,0,'-1',0,0,'','',4,0,''),(185,'sharethis','sharethis_block','forum_plus',0,0,'-1',0,0,'','',4,0,''),(186,'sharethis','sharethis_block','seven',0,0,'-1',0,0,'','',4,0,''),(217,'views','what_is_news-block','forum_plus',0,0,'-1',0,0,'','',-1,0,''),(218,'views','what_is_news-block','bartik',0,0,'-1',0,0,'','',-1,0,''),(219,'views','what_is_news-block','seven',0,0,'-1',0,0,'','',-1,0,''),(220,'views','hot_video-block','forum_plus',1,-24,'sidebar_first',0,1,'blogs\r\nblogs/*\r\nblog\r\nblog/*\r\nvideo/*','',-1,0,'no-padding'),(221,'views','hot_video-block','bartik',0,0,'-1',0,1,'blogs\r\nblogs/*\r\nblog\r\nblog/*\r\nvideo/*','',-1,0,'no-padding'),(222,'views','hot_video-block','seven',0,0,'-1',0,1,'blogs\r\nblogs/*\r\nblog\r\nblog/*\r\nvideo/*','',-1,0,'no-padding'),(223,'views','get_products-block','forum_plus',1,-21,'sidebar_first',0,1,'blogs\r\nblogs/*\r\nblog\r\nblog/*\r\nvideo/*\r\n<front>','Get This Theme',-1,0,'no-padding'),(224,'views','get_products-block','bartik',0,0,'-1',0,1,'blogs\r\nblogs/*\r\nblog\r\nblog/*\r\nvideo/*\r\n<front>','Get This Theme',-1,0,'no-padding'),(225,'views','get_products-block','seven',0,0,'-1',0,1,'blogs\r\nblogs/*\r\nblog\r\nblog/*\r\nvideo/*\r\n<front>','Get This Theme',-1,0,'no-padding'),(226,'block','12','bartik',0,0,'-1',0,0,'','<none>',-1,0,'submenu-extend'),(227,'block','12','forum_plus',1,0,'header',0,0,'','<none>',-1,0,'submenu-extend'),(228,'block','12','seven',0,0,'-1',0,0,'','<none>',-1,0,'submenu-extend'),(229,'author_pane','delta-0','we_backend',0,0,'-1',0,0,'','',-1,0,''),(230,'block','1','we_backend',1,-17,'header',0,0,'','',-1,0,''),(231,'block','11','we_backend',1,0,'header',0,1,'contact\r\ncontact-us\r\ncontact-us-2','<none>',-1,0,''),(232,'block','12','we_backend',1,0,'header',0,0,'','<none>',-1,0,'submenu-extend'),(233,'block','2','we_backend',1,0,'header',0,0,'','About US',-1,0,''),(234,'block','3','we_backend',1,-13,'header',0,0,'','Contact',-1,0,'last-block'),(235,'block','4','we_backend',1,-12,'header',0,0,'','',-1,0,''),(236,'block','5','we_backend',1,-15,'footer',0,0,'','',-1,0,''),(237,'block','6','we_backend',1,-27,'content',0,1,'contact','Get In Touch',-1,0,''),(238,'block','7','we_backend',1,0,'header',0,1,'<front>','',-1,0,''),(239,'block','9','we_backend',1,0,'header',0,1,'<front>','<none>',-1,0,'welcome-block'),(240,'blog','recent','we_backend',1,0,'dashboard_inactive',0,0,'','',1,0,''),(241,'book','navigation','we_backend',0,0,'-1',0,0,'','',5,0,''),(242,'calendar','calendar_legend','we_backend',0,0,'-1',0,0,'','',1,0,''),(243,'comment','recent','we_backend',1,0,'dashboard_inactive',0,0,'','',1,0,''),(244,'faq','faq_categories','we_backend',0,0,'-1',0,0,'','',1,0,''),(245,'forum','active','we_backend',1,0,'sidebar_first',0,1,'blogs\r\nblogs/mix\r\nblogs/teaser\r\nblog\r\nblog/*\r\nvideo/*\r\narticles\r\narticles/*\r\narticle/*\r\narticles-teaser\r\nforum\r\nactivity-stream','',-2,0,''),(246,'forum','new','we_backend',1,0,'dashboard_inactive',0,0,'','Recent Topics',-2,0,''),(247,'lang_dropdown','language','we_backend',1,0,'header',0,0,'','<none>',-1,0,''),(248,'locale','language','we_backend',0,0,'-1',0,0,'','',-1,0,''),(249,'menu','features','we_backend',0,0,'-1',0,0,'','',-1,0,''),(250,'menu','menu-categories','we_backend',1,-25,'sidebar_first',0,1,'articles\r\narticles-teaser\r\narticles/*\r\narticle/*','',-1,0,''),(251,'menu','menu-footer-menu','we_backend',0,-16,'-1',0,0,'','<none>',-1,0,''),(252,'menu','menu-links','we_backend',1,0,'header',0,0,'','',-1,0,''),(253,'menu','menu-sections','we_backend',1,-26,'sidebar_first',0,1,'articles\r\narticles-teaser\r\narticles/*\r\narticle/*\r\nsections/*\r\ntaxonomy/*','',-1,0,''),(254,'node','recent','we_backend',1,0,'dashboard_inactive',0,0,'','',1,0,''),(255,'node','syndicate','we_backend',0,0,'-1',0,0,'','',-1,0,''),(256,'quicktabs','quicktab','we_backend',1,-28,'sidebar_first',0,1,'blogs\r\nblogs/*\r\nblog\r\nblog/*\r\nvideo/*\r\nactivity-stream','<none>',-1,0,''),(257,'search','form','we_backend',1,-14,'header',0,0,'','',-1,0,''),(258,'sharethis','sharethis_block','we_backend',0,0,'-1',0,0,'','',4,0,''),(259,'shortcut','shortcuts','we_backend',0,0,'-1',0,0,'','',-1,0,''),(260,'statistics','popular','we_backend',0,0,'-1',0,0,'','',-1,0,''),(261,'system','help','we_backend',1,0,'help',0,0,'','',-1,0,''),(262,'system','main','we_backend',1,-28,'content',0,0,'','',-1,0,''),(263,'system','main-menu','we_backend',1,0,'header',0,0,'megamenu','<none>',-1,0,''),(264,'system','management','we_backend',0,0,'-1',0,0,'','',-1,0,''),(265,'system','navigation','we_backend',0,0,'-1',0,0,'','',-1,0,''),(266,'system','powered-by','we_backend',0,10,'-1',0,0,'','',-1,0,''),(267,'system','user-menu','we_backend',1,-16,'header',0,0,'','<none>',-1,0,''),(268,'tagclouds','1','we_backend',1,-23,'sidebar_first',0,1,'blogs\r\nblogs/*\r\nblog\r\nblog/*\r\nvideo/*\r\narticles\r\narticles/*\r\narticle/*\r\narticles-teaser\r\nforum\r\nactivity-stream','Tags',8,0,''),(269,'tagclouds','2','we_backend',0,0,'-1',0,0,'','',8,0,''),(270,'tagclouds','3','we_backend',0,0,'-1',0,0,'','',8,0,''),(271,'tagclouds','4','we_backend',0,0,'-1',0,0,'','',8,0,''),(272,'user','login','we_backend',0,-15,'-1',0,0,'','',-1,0,''),(273,'user','new','we_backend',1,0,'sidebar_first',0,1,'blogs\r\nblogs/mix\r\nblogs/teaser\r\nblog\r\nblog/*\r\nvideo/*\r\narticle/*','',1,0,''),(274,'user','online','we_backend',1,0,'sidebar_first',0,1,'blogs\r\nblogs/mix\r\nblogs/teaser\r\nblogs/two\r\nblog\r\nblog/*\r\nvideo/*\r\narticle/*','',-1,0,''),(275,'views','archive-block','we_backend',0,0,'-1',0,0,'','',-1,0,''),(276,'views','comments-block','we_backend',1,-27,'sidebar_first',0,1,'blogs\r\nblogs/mix\r\nblogs/teaser\r\nblogs/two\r\nblog\r\nblog/*\r\nvideo/*\r\nactivity-stream','',-1,0,''),(277,'views','faq-faq_random','we_backend',0,0,'-1',0,0,'','',-1,0,''),(278,'views','faq-faq_recent','we_backend',0,0,'-1',0,0,'','',-1,0,''),(279,'views','get_products-block','we_backend',1,-21,'sidebar_first',0,1,'blogs\r\nblogs/*\r\nblog\r\nblog/*\r\nvideo/*\r\n<front>','Get This Theme',-1,0,'no-padding'),(280,'views','hot_video-block','we_backend',1,-24,'sidebar_first',0,1,'blogs\r\nblogs/*\r\nblog\r\nblog/*\r\nvideo/*','',-1,0,'no-padding'),(281,'views','new_forum_posts-block','we_backend',1,-29,'sidebar_first',0,1,'forum','',-1,0,''),(282,'views','recent_blogs-block','we_backend',0,0,'-1',0,0,'','',-1,0,''),(283,'views','recent_blogs-block_1','we_backend',0,0,'-1',0,0,'','',-1,0,''),(284,'views','recent_blogs-block_2','we_backend',0,0,'-1',0,0,'','',-1,0,''),(285,'views','recent_topics-block','we_backend',1,0,'header',0,0,'','',-1,0,''),(286,'views','what_is_news-block','we_backend',0,0,'-1',0,0,'','',-1,0,'');
/*!40000 ALTER TABLE `block` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `block_custom`
--

DROP TABLE IF EXISTS `block_custom`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `block_custom` (
  `bid` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'The block’s block.bid.',
  `body` longtext COMMENT 'Block contents.',
  `info` varchar(128) NOT NULL DEFAULT '' COMMENT 'Block description.',
  `format` varchar(255) DEFAULT NULL COMMENT 'The filter_format.format of the block body.',
  PRIMARY KEY (`bid`),
  UNIQUE KEY `info` (`info`)
) ENGINE=InnoDB AUTO_INCREMENT=13 DEFAULT CHARSET=utf8 COMMENT='Stores contents of custom-made blocks.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `block_custom`
--

LOCK TABLES `block_custom` WRITE;
/*!40000 ALTER TABLE `block_custom` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `block_custom` VALUES (1,'<ul class=\"social-list\">\r\n<li><a class=\"fa fa-facebook\" href=\"#\" title=\"Facebook\"><span>Facebook</span></a></li>\r\n<li><a class=\"fa fa-twitter\" href=\"#\" title=\"Twitter\"><span>Twitter</span></a></li>\r\n<li><a class=\"fa fa-google-plus\" href=\"#\" title=\"Google+\"><span>Google+</span></a></li>\r\n<li><a class=\"fa fa-pinterest\" href=\"#\" title=\"Pinterest\"><span>Pinterest</span></a></li>\r\n<li><a class=\"fa fa-rss\" href=\"#\" title=\"RSS\"><span>RSS</span></a></li>\r\n</ul>','Social Menu','full_html'),(2,'<p>We are a web development team with a concentration on open-source Content Management Systems (CMS), especially Drupal.</p>\r\n\r\n<p>We provide web services from small products: <a href=\"http://weebpal.com/drupal-themes\">Drupal themes</a>, modules...</p>\r\n','About US','filtered_html'),(3,'<address><i class=\"fa fa-phone\"></i> (123) 123-4567<br><i class=\"fa fa-map-marker\"></i> 7801 NW 15 Street<br>Ste #CO32314 Doral, Florida 33126<br><i class=\"fa fa-envelope\"></i> <a href=\"mailto:contact@weebpal.com\">contact@weebpal.com</a></address>','Contact','full_html'),(4,'<ul class=\"social-list\">\r\n<li><a class=\"fa fa-facebook\" href=\"#\" title=\"Facebook\"><span>Facebook</span></a></li>\r\n<li><a class=\"fa fa-twitter\" href=\"#\" title=\"Twitter\"><span>Twitter</span></a></li>\r\n<li><a class=\"fa fa-google-plus\" href=\"#\" title=\"Google+\"><span>Google+</span></a></li>\r\n<li><a class=\"fa fa-pinterest\" href=\"#\" title=\"Pinterest\"><span>Pinterest</span></a></li>\r\n<li><a class=\"fa fa-rss\" href=\"#\" title=\"RSS\"><span>RSS</span></a></li>\r\n</ul>','Social Menu 1','full_html'),(5,'<p>Powered by <a href=\"http://drupal.org\" target=\"_blank\">Drupal</a>. Designed by <a href=\"http://weebpal.com\" target=\"_blank\">WeebPal Drupal Themes</a>. Copyright © 2014. All Rights Reserved.</p>\r\n','Copyright','full_html'),(6,'<div class=\"contact-content clearfix\">\r\n<p>Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur. Excepteur sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum. Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium, totam rem aperiam, eaque ipsa quae ab illo inventore veritatis et quasi architecto .</p>\r\n\r\n<address>\r\n<i class=\"fa fa-map-marker\"></i> Alexander Street. Vancouver, BC<br> V6A 1E1 Canada<br><i class=\"fa fa-phone\"></i> 012.345.6789<br><i class=\"fa fa-print\"></i> 012.345.6789<br><i class=\"fa fa-envelope\"></i> support@weebpal.com</address>\r\n</div>','Get In Touch','full_html'),(7,'If this is your first visit, be sure to check out the <a href=\"<?php echo base_path(); ?>faq-page\" title=\"FAQ\">FAQ</a> by clicking the link above. You may have to <a href=\"<?php echo base_path(); ?>user/register\" title=\"register \">register </a>before you can post click the register link above to proceed. To start viewing messages, select the forum that you want to visit from the selection below. ','Custom block','php_code'),(9,'<span class=\"welcome-message\">Welcome to forum Plus</span>','Welcome to forum','php_code'),(11,'<div class=\"iframe-map\">\r\n<iframe class=\"contact_map\" height=\"380\" src=\"https://maps.google.com/maps?f=q&amp;source=s_q&amp;hl=vi&amp;q=795+Folsom+Ave+%236000,+Hayward,+Alameda,+California+94544&amp;sll=37.0625,-95.677068&amp;sspn=56.112526,114.169922&amp;ie=UTF8&amp;geocode=FZQfPgIdJnC5-A&amp;split=0&amp;hq=&amp;hnear=795+Folsom+Ave+%236000,+Hayward,+Alameda,+California+94544&amp;t=m&amp;z=14&amp;ll=37.625748,-122.064858&amp;output=embed\"></iframe>\r\n</div>\r\n','Gmap','full_html'),(12,'<?php echo date(\'l, F d, Y\'); ?>','Date','php_code');
/*!40000 ALTER TABLE `block_custom` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `block_node_type`
--

DROP TABLE IF EXISTS `block_node_type`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `block_node_type` (
  `module` varchar(64) NOT NULL COMMENT 'The block’s origin module, from block.module.',
  `delta` varchar(32) NOT NULL COMMENT 'The block’s unique delta within module, from block.delta.',
  `type` varchar(32) NOT NULL COMMENT 'The machine-readable name of this type from node_type.type.',
  PRIMARY KEY (`module`,`delta`,`type`),
  KEY `type` (`type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Sets up display criteria for blocks based on content types';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `block_node_type`
--

LOCK TABLES `block_node_type` WRITE;
/*!40000 ALTER TABLE `block_node_type` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `block_node_type` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `block_role`
--

DROP TABLE IF EXISTS `block_role`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `block_role` (
  `module` varchar(64) NOT NULL COMMENT 'The block’s origin module, from block.module.',
  `delta` varchar(32) NOT NULL COMMENT 'The block’s unique delta within module, from block.delta.',
  `rid` int(10) unsigned NOT NULL COMMENT 'The user’s role ID from users_roles.rid.',
  PRIMARY KEY (`module`,`delta`,`rid`),
  KEY `rid` (`rid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Sets up access permissions for blocks based on user roles';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `block_role`
--

LOCK TABLES `block_role` WRITE;
/*!40000 ALTER TABLE `block_role` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `block_role` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `blocked_ips`
--

DROP TABLE IF EXISTS `blocked_ips`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `blocked_ips` (
  `iid` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Primary Key: unique ID for IP addresses.',
  `ip` varchar(40) NOT NULL DEFAULT '' COMMENT 'IP address',
  PRIMARY KEY (`iid`),
  KEY `blocked_ip` (`ip`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Stores blocked IP addresses.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `blocked_ips`
--

LOCK TABLES `blocked_ips` WRITE;
/*!40000 ALTER TABLE `blocked_ips` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `blocked_ips` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `book`
--

DROP TABLE IF EXISTS `book`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `book` (
  `mlid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The book page’s menu_links.mlid.',
  `nid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The book page’s node.nid.',
  `bid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The book ID is the book.nid of the top-level page.',
  PRIMARY KEY (`mlid`),
  UNIQUE KEY `nid` (`nid`),
  KEY `bid` (`bid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Stores book outline information. Uniquely connects each...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `book`
--

LOCK TABLES `book` WRITE;
/*!40000 ALTER TABLE `book` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `book` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `cache`
--

DROP TABLE IF EXISTS `cache`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `cache` (
  `cid` varchar(255) NOT NULL DEFAULT '' COMMENT 'Primary Key: Unique cache ID.',
  `data` longblob COMMENT 'A collection of data to cache.',
  `expire` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry should expire, or 0 for never.',
  `created` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry was created.',
  `serialized` smallint(6) NOT NULL DEFAULT '0' COMMENT 'A flag to indicate whether content is serialized (1) or not (0).',
  PRIMARY KEY (`cid`),
  KEY `expire` (`expire`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Generic cache table for caching things not separated out...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `cache`
--

LOCK TABLES `cache` WRITE;
/*!40000 ALTER TABLE `cache` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `cache` VALUES ('advanced_forum_stats_replies','23',0,1512620327,0),('ctools_plugin_files:advanced_forum:styles','a:2:{s:14:\"advanced_forum\";a:8:{s:5:\"naked\";O:8:\"stdClass\":3:{s:3:\"uri\";s:56:\"sites/all/modules/advanced_forum/styles/naked/naked.info\";s:8:\"filename\";s:10:\"naked.info\";s:4:\"name\";s:5:\"naked\";}s:12:\"silver_bells\";O:8:\"stdClass\":3:{s:3:\"uri\";s:70:\"sites/all/modules/advanced_forum/styles/silver_bells/silver_bells.info\";s:8:\"filename\";s:17:\"silver_bells.info\";s:4:\"name\";s:12:\"silver_bells\";}s:19:\"blue_lagoon_stacked\";O:8:\"stdClass\":3:{s:3:\"uri\";s:84:\"sites/all/modules/advanced_forum/styles/blue_lagoon_stacked/blue_lagoon_stacked.info\";s:8:\"filename\";s:24:\"blue_lagoon_stacked.info\";s:4:\"name\";s:19:\"blue_lagoon_stacked\";}s:13:\"cloudless_day\";O:8:\"stdClass\":3:{s:3:\"uri\";s:72:\"sites/all/modules/advanced_forum/styles/cloudless_day/cloudless_day.info\";s:8:\"filename\";s:18:\"cloudless_day.info\";s:4:\"name\";s:13:\"cloudless_day\";}s:21:\"cloudless_day_stacked\";O:8:\"stdClass\":3:{s:3:\"uri\";s:88:\"sites/all/modules/advanced_forum/styles/cloudless_day_stacked/cloudless_day_stacked.info\";s:8:\"filename\";s:26:\"cloudless_day_stacked.info\";s:4:\"name\";s:21:\"cloudless_day_stacked\";}s:20:\"silver_bells_stacked\";O:8:\"stdClass\":3:{s:3:\"uri\";s:86:\"sites/all/modules/advanced_forum/styles/silver_bells_stacked/silver_bells_stacked.info\";s:8:\"filename\";s:25:\"silver_bells_stacked.info\";s:4:\"name\";s:20:\"silver_bells_stacked\";}s:13:\"naked_stacked\";O:8:\"stdClass\":3:{s:3:\"uri\";s:72:\"sites/all/modules/advanced_forum/styles/naked_stacked/naked_stacked.info\";s:8:\"filename\";s:18:\"naked_stacked.info\";s:4:\"name\";s:13:\"naked_stacked\";}s:11:\"blue_lagoon\";O:8:\"stdClass\":3:{s:3:\"uri\";s:68:\"sites/all/modules/advanced_forum/styles/blue_lagoon/blue_lagoon.info\";s:8:\"filename\";s:16:\"blue_lagoon.info\";s:4:\"name\";s:11:\"blue_lagoon\";}}s:10:\"forum_plus\";a:1:{s:4:\"plus\";O:8:\"stdClass\":3:{s:3:\"uri\";s:61:\"sites/all/themes/forum_plus/css/advanced_forum/plus/plus.info\";s:8:\"filename\";s:9:\"plus.info\";s:4:\"name\";s:4:\"plus\";}}}',0,1512620340,1),('ctools_plugin_files:ctools:content_types','a:7:{s:11:\"author_pane\";a:1:{s:11:\"author_pane\";O:8:\"stdClass\":3:{s:3:\"uri\";s:67:\"sites/all/modules/author_pane/plugins/content_types/author_pane.inc\";s:8:\"filename\";s:15:\"author_pane.inc\";s:4:\"name\";s:11:\"author_pane\";}}s:6:\"ctools\";a:62:{s:9:\"term_name\";O:8:\"stdClass\":3:{s:3:\"uri\";s:73:\"sites/all/modules/ctools/plugins/content_types/term_context/term_name.inc\";s:8:\"filename\";s:13:\"term_name.inc\";s:4:\"name\";s:9:\"term_name\";}s:16:\"term_description\";O:8:\"stdClass\":3:{s:3:\"uri\";s:80:\"sites/all/modules/ctools/plugins/content_types/term_context/term_description.inc\";s:8:\"filename\";s:20:\"term_description.inc\";s:4:\"name\";s:16:\"term_description\";}s:9:\"term_list\";O:8:\"stdClass\":3:{s:3:\"uri\";s:73:\"sites/all/modules/ctools/plugins/content_types/term_context/term_list.inc\";s:8:\"filename\";s:13:\"term_list.inc\";s:4:\"name\";s:9:\"term_list\";}s:12:\"user_profile\";O:8:\"stdClass\":3:{s:3:\"uri\";s:76:\"sites/all/modules/ctools/plugins/content_types/user_context/user_profile.inc\";s:8:\"filename\";s:16:\"user_profile.inc\";s:4:\"name\";s:12:\"user_profile\";}s:10:\"user_links\";O:8:\"stdClass\":3:{s:3:\"uri\";s:74:\"sites/all/modules/ctools/plugins/content_types/user_context/user_links.inc\";s:8:\"filename\";s:14:\"user_links.inc\";s:4:\"name\";s:10:\"user_links\";}s:14:\"profile_fields\";O:8:\"stdClass\":3:{s:3:\"uri\";s:78:\"sites/all/modules/ctools/plugins/content_types/user_context/profile_fields.inc\";s:8:\"filename\";s:18:\"profile_fields.inc\";s:4:\"name\";s:14:\"profile_fields\";}s:12:\"user_picture\";O:8:\"stdClass\":3:{s:3:\"uri\";s:76:\"sites/all/modules/ctools/plugins/content_types/user_context/user_picture.inc\";s:8:\"filename\";s:16:\"user_picture.inc\";s:4:\"name\";s:12:\"user_picture\";}s:14:\"user_signature\";O:8:\"stdClass\":3:{s:3:\"uri\";s:78:\"sites/all/modules/ctools/plugins/content_types/user_context/user_signature.inc\";s:8:\"filename\";s:18:\"user_signature.inc\";s:4:\"name\";s:14:\"user_signature\";}s:18:\"comment_reply_form\";O:8:\"stdClass\":3:{s:3:\"uri\";s:77:\"sites/all/modules/ctools/plugins/content_types/comment/comment_reply_form.inc\";s:8:\"filename\";s:22:\"comment_reply_form.inc\";s:4:\"name\";s:18:\"comment_reply_form\";}s:15:\"comment_created\";O:8:\"stdClass\":3:{s:3:\"uri\";s:74:\"sites/all/modules/ctools/plugins/content_types/comment/comment_created.inc\";s:8:\"filename\";s:19:\"comment_created.inc\";s:4:\"name\";s:15:\"comment_created\";}s:13:\"comment_links\";O:8:\"stdClass\":3:{s:3:\"uri\";s:72:\"sites/all/modules/ctools/plugins/content_types/comment/comment_links.inc\";s:8:\"filename\";s:17:\"comment_links.inc\";s:4:\"name\";s:13:\"comment_links\";}s:15:\"page_feed_icons\";O:8:\"stdClass\":3:{s:3:\"uri\";s:71:\"sites/all/modules/ctools/plugins/content_types/page/page_feed_icons.inc\";s:8:\"filename\";s:19:\"page_feed_icons.inc\";s:4:\"name\";s:15:\"page_feed_icons\";}s:15:\"page_breadcrumb\";O:8:\"stdClass\":3:{s:3:\"uri\";s:71:\"sites/all/modules/ctools/plugins/content_types/page/page_breadcrumb.inc\";s:8:\"filename\";s:19:\"page_breadcrumb.inc\";s:4:\"name\";s:15:\"page_breadcrumb\";}s:20:\"page_secondary_links\";O:8:\"stdClass\":3:{s:3:\"uri\";s:76:\"sites/all/modules/ctools/plugins/content_types/page/page_secondary_links.inc\";s:8:\"filename\";s:24:\"page_secondary_links.inc\";s:4:\"name\";s:20:\"page_secondary_links\";}s:12:\"page_actions\";O:8:\"stdClass\":3:{s:3:\"uri\";s:68:\"sites/all/modules/ctools/plugins/content_types/page/page_actions.inc\";s:8:\"filename\";s:16:\"page_actions.inc\";s:4:\"name\";s:12:\"page_actions\";}s:11:\"page_slogan\";O:8:\"stdClass\":3:{s:3:\"uri\";s:67:\"sites/all/modules/ctools/plugins/content_types/page/page_slogan.inc\";s:8:\"filename\";s:15:\"page_slogan.inc\";s:4:\"name\";s:11:\"page_slogan\";}s:13:\"page_messages\";O:8:\"stdClass\":3:{s:3:\"uri\";s:69:\"sites/all/modules/ctools/plugins/content_types/page/page_messages.inc\";s:8:\"filename\";s:17:\"page_messages.inc\";s:4:\"name\";s:13:\"page_messages\";}s:9:\"page_help\";O:8:\"stdClass\":3:{s:3:\"uri\";s:65:\"sites/all/modules/ctools/plugins/content_types/page/page_help.inc\";s:8:\"filename\";s:13:\"page_help.inc\";s:4:\"name\";s:9:\"page_help\";}s:14:\"page_site_name\";O:8:\"stdClass\":3:{s:3:\"uri\";s:70:\"sites/all/modules/ctools/plugins/content_types/page/page_site_name.inc\";s:8:\"filename\";s:18:\"page_site_name.inc\";s:4:\"name\";s:14:\"page_site_name\";}s:9:\"page_logo\";O:8:\"stdClass\":3:{s:3:\"uri\";s:65:\"sites/all/modules/ctools/plugins/content_types/page/page_logo.inc\";s:8:\"filename\";s:13:\"page_logo.inc\";s:4:\"name\";s:9:\"page_logo\";}s:9:\"page_tabs\";O:8:\"stdClass\":3:{s:3:\"uri\";s:65:\"sites/all/modules/ctools/plugins/content_types/page/page_tabs.inc\";s:8:\"filename\";s:13:\"page_tabs.inc\";s:4:\"name\";s:9:\"page_tabs\";}s:18:\"page_primary_links\";O:8:\"stdClass\":3:{s:3:\"uri\";s:74:\"sites/all/modules/ctools/plugins/content_types/page/page_primary_links.inc\";s:8:\"filename\";s:22:\"page_primary_links.inc\";s:4:\"name\";s:18:\"page_primary_links\";}s:10:\"page_title\";O:8:\"stdClass\":3:{s:3:\"uri\";s:66:\"sites/all/modules/ctools/plugins/content_types/page/page_title.inc\";s:8:\"filename\";s:14:\"page_title.inc\";s:4:\"name\";s:10:\"page_title\";}s:11:\"search_form\";O:8:\"stdClass\":3:{s:3:\"uri\";s:69:\"sites/all/modules/ctools/plugins/content_types/search/search_form.inc\";s:8:\"filename\";s:15:\"search_form.inc\";s:4:\"name\";s:11:\"search_form\";}s:13:\"search_result\";O:8:\"stdClass\":3:{s:3:\"uri\";s:71:\"sites/all/modules/ctools/plugins/content_types/search/search_result.inc\";s:8:\"filename\";s:17:\"search_result.inc\";s:4:\"name\";s:13:\"search_result\";}s:18:\"node_book_children\";O:8:\"stdClass\":3:{s:3:\"uri\";s:82:\"sites/all/modules/ctools/plugins/content_types/node_context/node_book_children.inc\";s:8:\"filename\";s:22:\"node_book_children.inc\";s:4:\"name\";s:18:\"node_book_children\";}s:10:\"node_title\";O:8:\"stdClass\":3:{s:3:\"uri\";s:74:\"sites/all/modules/ctools/plugins/content_types/node_context/node_title.inc\";s:8:\"filename\";s:14:\"node_title.inc\";s:4:\"name\";s:10:\"node_title\";}s:14:\"node_type_desc\";O:8:\"stdClass\":3:{s:3:\"uri\";s:78:\"sites/all/modules/ctools/plugins/content_types/node_context/node_type_desc.inc\";s:8:\"filename\";s:18:\"node_type_desc.inc\";s:4:\"name\";s:14:\"node_type_desc\";}s:10:\"node_links\";O:8:\"stdClass\":3:{s:3:\"uri\";s:74:\"sites/all/modules/ctools/plugins/content_types/node_context/node_links.inc\";s:8:\"filename\";s:14:\"node_links.inc\";s:4:\"name\";s:10:\"node_links\";}s:17:\"node_comment_form\";O:8:\"stdClass\":3:{s:3:\"uri\";s:81:\"sites/all/modules/ctools/plugins/content_types/node_context/node_comment_form.inc\";s:8:\"filename\";s:21:\"node_comment_form.inc\";s:4:\"name\";s:17:\"node_comment_form\";}s:12:\"node_content\";O:8:\"stdClass\":3:{s:3:\"uri\";s:76:\"sites/all/modules/ctools/plugins/content_types/node_context/node_content.inc\";s:8:\"filename\";s:16:\"node_content.inc\";s:4:\"name\";s:12:\"node_content\";}s:10:\"node_terms\";O:8:\"stdClass\":3:{s:3:\"uri\";s:74:\"sites/all/modules/ctools/plugins/content_types/node_context/node_terms.inc\";s:8:\"filename\";s:14:\"node_terms.inc\";s:4:\"name\";s:10:\"node_terms\";}s:12:\"node_updated\";O:8:\"stdClass\":3:{s:3:\"uri\";s:76:\"sites/all/modules/ctools/plugins/content_types/node_context/node_updated.inc\";s:8:\"filename\";s:16:\"node_updated.inc\";s:4:\"name\";s:12:\"node_updated\";}s:12:\"node_created\";O:8:\"stdClass\":3:{s:3:\"uri\";s:76:\"sites/all/modules/ctools/plugins/content_types/node_context/node_created.inc\";s:8:\"filename\";s:16:\"node_created.inc\";s:4:\"name\";s:12:\"node_created\";}s:16:\"node_attachments\";O:8:\"stdClass\":3:{s:3:\"uri\";s:80:\"sites/all/modules/ctools/plugins/content_types/node_context/node_attachments.inc\";s:8:\"filename\";s:20:\"node_attachments.inc\";s:4:\"name\";s:16:\"node_attachments\";}s:20:\"node_comment_wrapper\";O:8:\"stdClass\":3:{s:3:\"uri\";s:84:\"sites/all/modules/ctools/plugins/content_types/node_context/node_comment_wrapper.inc\";s:8:\"filename\";s:24:\"node_comment_wrapper.inc\";s:4:\"name\";s:20:\"node_comment_wrapper\";}s:9:\"node_body\";O:8:\"stdClass\":3:{s:3:\"uri\";s:73:\"sites/all/modules/ctools/plugins/content_types/node_context/node_body.inc\";s:8:\"filename\";s:13:\"node_body.inc\";s:4:\"name\";s:9:\"node_body\";}s:13:\"node_comments\";O:8:\"stdClass\":3:{s:3:\"uri\";s:77:\"sites/all/modules/ctools/plugins/content_types/node_context/node_comments.inc\";s:8:\"filename\";s:17:\"node_comments.inc\";s:4:\"name\";s:13:\"node_comments\";}s:13:\"node_book_nav\";O:8:\"stdClass\":3:{s:3:\"uri\";s:77:\"sites/all/modules/ctools/plugins/content_types/node_context/node_book_nav.inc\";s:8:\"filename\";s:17:\"node_book_nav.inc\";s:4:\"name\";s:13:\"node_book_nav\";}s:11:\"node_author\";O:8:\"stdClass\":3:{s:3:\"uri\";s:75:\"sites/all/modules/ctools/plugins/content_types/node_context/node_author.inc\";s:8:\"filename\";s:15:\"node_author.inc\";s:4:\"name\";s:11:\"node_author\";}s:18:\"entity_field_extra\";O:8:\"stdClass\":3:{s:3:\"uri\";s:84:\"sites/all/modules/ctools/plugins/content_types/entity_context/entity_field_extra.inc\";s:8:\"filename\";s:22:\"entity_field_extra.inc\";s:4:\"name\";s:18:\"entity_field_extra\";}s:12:\"entity_field\";O:8:\"stdClass\":3:{s:3:\"uri\";s:78:\"sites/all/modules/ctools/plugins/content_types/entity_context/entity_field.inc\";s:8:\"filename\";s:16:\"entity_field.inc\";s:4:\"name\";s:12:\"entity_field\";}s:12:\"user_contact\";O:8:\"stdClass\":3:{s:3:\"uri\";s:71:\"sites/all/modules/ctools/plugins/content_types/contact/user_contact.inc\";s:8:\"filename\";s:16:\"user_contact.inc\";s:4:\"name\";s:12:\"user_contact\";}s:7:\"contact\";O:8:\"stdClass\":3:{s:3:\"uri\";s:66:\"sites/all/modules/ctools/plugins/content_types/contact/contact.inc\";s:8:\"filename\";s:11:\"contact.inc\";s:4:\"name\";s:7:\"contact\";}s:4:\"form\";O:8:\"stdClass\":3:{s:3:\"uri\";s:60:\"sites/all/modules/ctools/plugins/content_types/form/form.inc\";s:8:\"filename\";s:8:\"form.inc\";s:4:\"name\";s:4:\"form\";}s:17:\"entity_form_field\";O:8:\"stdClass\":3:{s:3:\"uri\";s:73:\"sites/all/modules/ctools/plugins/content_types/form/entity_form_field.inc\";s:8:\"filename\";s:21:\"entity_form_field.inc\";s:4:\"name\";s:17:\"entity_form_field\";}s:16:\"vocabulary_terms\";O:8:\"stdClass\":3:{s:3:\"uri\";s:86:\"sites/all/modules/ctools/plugins/content_types/vocabulary_context/vocabulary_terms.inc\";s:8:\"filename\";s:20:\"vocabulary_terms.inc\";s:4:\"name\";s:16:\"vocabulary_terms\";}s:14:\"node_form_path\";O:8:\"stdClass\":3:{s:3:\"uri\";s:75:\"sites/all/modules/ctools/plugins/content_types/node_form/node_form_path.inc\";s:8:\"filename\";s:18:\"node_form_path.inc\";s:4:\"name\";s:14:\"node_form_path\";}s:18:\"node_form_language\";O:8:\"stdClass\":3:{s:3:\"uri\";s:79:\"sites/all/modules/ctools/plugins/content_types/node_form/node_form_language.inc\";s:8:\"filename\";s:22:\"node_form_language.inc\";s:4:\"name\";s:18:\"node_form_language\";}s:13:\"node_form_log\";O:8:\"stdClass\":3:{s:3:\"uri\";s:74:\"sites/all/modules/ctools/plugins/content_types/node_form/node_form_log.inc\";s:8:\"filename\";s:17:\"node_form_log.inc\";s:4:\"name\";s:13:\"node_form_log\";}s:17:\"node_form_comment\";O:8:\"stdClass\":3:{s:3:\"uri\";s:78:\"sites/all/modules/ctools/plugins/content_types/node_form/node_form_comment.inc\";s:8:\"filename\";s:21:\"node_form_comment.inc\";s:4:\"name\";s:17:\"node_form_comment\";}s:21:\"node_form_attachments\";O:8:\"stdClass\":3:{s:3:\"uri\";s:82:\"sites/all/modules/ctools/plugins/content_types/node_form/node_form_attachments.inc\";s:8:\"filename\";s:25:\"node_form_attachments.inc\";s:4:\"name\";s:21:\"node_form_attachments\";}s:16:\"node_form_author\";O:8:\"stdClass\":3:{s:3:\"uri\";s:77:\"sites/all/modules/ctools/plugins/content_types/node_form/node_form_author.inc\";s:8:\"filename\";s:20:\"node_form_author.inc\";s:4:\"name\";s:16:\"node_form_author\";}s:14:\"node_form_menu\";O:8:\"stdClass\":3:{s:3:\"uri\";s:75:\"sites/all/modules/ctools/plugins/content_types/node_form/node_form_menu.inc\";s:8:\"filename\";s:18:\"node_form_menu.inc\";s:4:\"name\";s:14:\"node_form_menu\";}s:14:\"node_form_book\";O:8:\"stdClass\":3:{s:3:\"uri\";s:75:\"sites/all/modules/ctools/plugins/content_types/node_form/node_form_book.inc\";s:8:\"filename\";s:18:\"node_form_book.inc\";s:4:\"name\";s:14:\"node_form_book\";}s:15:\"node_form_title\";O:8:\"stdClass\":3:{s:3:\"uri\";s:76:\"sites/all/modules/ctools/plugins/content_types/node_form/node_form_title.inc\";s:8:\"filename\";s:19:\"node_form_title.inc\";s:4:\"name\";s:15:\"node_form_title\";}s:17:\"node_form_buttons\";O:8:\"stdClass\":3:{s:3:\"uri\";s:78:\"sites/all/modules/ctools/plugins/content_types/node_form/node_form_buttons.inc\";s:8:\"filename\";s:21:\"node_form_buttons.inc\";s:4:\"name\";s:17:\"node_form_buttons\";}s:20:\"node_form_publishing\";O:8:\"stdClass\":3:{s:3:\"uri\";s:81:\"sites/all/modules/ctools/plugins/content_types/node_form/node_form_publishing.inc\";s:8:\"filename\";s:24:\"node_form_publishing.inc\";s:4:\"name\";s:20:\"node_form_publishing\";}s:5:\"token\";O:8:\"stdClass\":3:{s:3:\"uri\";s:62:\"sites/all/modules/ctools/plugins/content_types/token/token.inc\";s:8:\"filename\";s:9:\"token.inc\";s:4:\"name\";s:5:\"token\";}s:4:\"node\";O:8:\"stdClass\":3:{s:3:\"uri\";s:60:\"sites/all/modules/ctools/plugins/content_types/node/node.inc\";s:8:\"filename\";s:8:\"node.inc\";s:4:\"name\";s:4:\"node\";}s:5:\"block\";O:8:\"stdClass\":3:{s:3:\"uri\";s:62:\"sites/all/modules/ctools/plugins/content_types/block/block.inc\";s:8:\"filename\";s:9:\"block.inc\";s:4:\"name\";s:5:\"block\";}s:6:\"custom\";O:8:\"stdClass\":3:{s:3:\"uri\";s:64:\"sites/all/modules/ctools/plugins/content_types/custom/custom.inc\";s:8:\"filename\";s:10:\"custom.inc\";s:4:\"name\";s:6:\"custom\";}}s:6:\"entity\";a:1:{s:11:\"entity_view\";O:8:\"stdClass\":3:{s:3:\"uri\";s:61:\"sites/all/modules/entity/ctools/content_types/entity_view.inc\";s:8:\"filename\";s:15:\"entity_view.inc\";s:4:\"name\";s:11:\"entity_view\";}}s:16:\"field_collection\";a:0:{}s:7:\"message\";a:1:{s:14:\"message_render\";O:8:\"stdClass\":3:{s:3:\"uri\";s:65:\"sites/all/modules/message/ctools/content_types/message_render.inc\";s:8:\"filename\";s:18:\"message_render.inc\";s:4:\"name\";s:14:\"message_render\";}}s:9:\"sharethis\";a:1:{s:9:\"sharethis\";O:8:\"stdClass\":3:{s:3:\"uri\";s:73:\"sites/all/modules/sharethis/plugins/content_types/sharethis/sharethis.inc\";s:8:\"filename\";s:13:\"sharethis.inc\";s:4:\"name\";s:9:\"sharethis\";}}s:14:\"advanced_forum\";a:11:{s:18:\"forum_topic_legend\";O:8:\"stdClass\":3:{s:3:\"uri\";s:77:\"sites/all/modules/advanced_forum/plugins/content_types/forum_topic_legend.inc\";s:8:\"filename\";s:22:\"forum_topic_legend.inc\";s:4:\"name\";s:18:\"forum_topic_legend\";}s:16:\"forum_statistics\";O:8:\"stdClass\":3:{s:3:\"uri\";s:75:\"sites/all/modules/advanced_forum/plugins/content_types/forum_statistics.inc\";s:8:\"filename\";s:20:\"forum_statistics.inc\";s:4:\"name\";s:16:\"forum_statistics\";}s:12:\"forum_search\";O:8:\"stdClass\":3:{s:3:\"uri\";s:71:\"sites/all/modules/advanced_forum/plugins/content_types/forum_search.inc\";s:8:\"filename\";s:16:\"forum_search.inc\";s:4:\"name\";s:12:\"forum_search\";}s:22:\"forum_node_create_list\";O:8:\"stdClass\":3:{s:3:\"uri\";s:81:\"sites/all/modules/advanced_forum/plugins/content_types/forum_node_create_list.inc\";s:8:\"filename\";s:26:\"forum_node_create_list.inc\";s:4:\"name\";s:22:\"forum_node_create_list\";}s:10:\"forum_list\";O:8:\"stdClass\":3:{s:3:\"uri\";s:69:\"sites/all/modules/advanced_forum/plugins/content_types/forum_list.inc\";s:8:\"filename\";s:14:\"forum_list.inc\";s:4:\"name\";s:10:\"forum_list\";}s:24:\"forum_most_active_poster\";O:8:\"stdClass\":3:{s:3:\"uri\";s:83:\"sites/all/modules/advanced_forum/plugins/content_types/forum_most_active_poster.inc\";s:8:\"filename\";s:28:\"forum_most_active_poster.inc\";s:4:\"name\";s:24:\"forum_most_active_poster\";}s:12:\"forum_legend\";O:8:\"stdClass\":3:{s:3:\"uri\";s:71:\"sites/all/modules/advanced_forum/plugins/content_types/forum_legend.inc\";s:8:\"filename\";s:16:\"forum_legend.inc\";s:4:\"name\";s:12:\"forum_legend\";}s:15:\"forum_mark_read\";O:8:\"stdClass\":3:{s:3:\"uri\";s:74:\"sites/all/modules/advanced_forum/plugins/content_types/forum_mark_read.inc\";s:8:\"filename\";s:19:\"forum_mark_read.inc\";s:4:\"name\";s:15:\"forum_mark_read\";}s:16:\"forum_topic_list\";O:8:\"stdClass\":3:{s:3:\"uri\";s:75:\"sites/all/modules/advanced_forum/plugins/content_types/forum_topic_list.inc\";s:8:\"filename\";s:20:\"forum_topic_list.inc\";s:4:\"name\";s:16:\"forum_topic_list\";}s:11:\"forum_tools\";O:8:\"stdClass\":3:{s:3:\"uri\";s:70:\"sites/all/modules/advanced_forum/plugins/content_types/forum_tools.inc\";s:8:\"filename\";s:15:\"forum_tools.inc\";s:4:\"name\";s:11:\"forum_tools\";}s:21:\"forum_topic_list_sort\";O:8:\"stdClass\":3:{s:3:\"uri\";s:80:\"sites/all/modules/advanced_forum/plugins/content_types/forum_topic_list_sort.inc\";s:8:\"filename\";s:25:\"forum_topic_list_sort.inc\";s:4:\"name\";s:21:\"forum_topic_list_sort\";}}}',0,1512620340,1),('ctools_plugin_files:ctools:export_ui','a:9:{s:11:\"author_pane\";a:0:{}s:6:\"ctools\";a:1:{s:16:\"ctools_export_ui\";O:8:\"stdClass\":3:{s:3:\"uri\";s:63:\"sites/all/modules/ctools/plugins/export_ui/ctools_export_ui.inc\";s:8:\"filename\";s:20:\"ctools_export_ui.inc\";s:4:\"name\";s:16:\"ctools_export_ui\";}}s:16:\"field_collection\";a:0:{}s:10:\"flexslider\";a:1:{s:27:\"flexslider_ctools_export_ui\";O:8:\"stdClass\":3:{s:3:\"uri\";s:78:\"sites/all/modules/flexslider/plugins/export_ui/flexslider_ctools_export_ui.inc\";s:8:\"filename\";s:31:\"flexslider_ctools_export_ui.inc\";s:4:\"name\";s:27:\"flexslider_ctools_export_ui\";}}s:7:\"message\";a:0:{}s:9:\"sharethis\";a:0:{}s:17:\"video_embed_field\";a:1:{s:27:\"video_embed_field_export_ui\";O:8:\"stdClass\":3:{s:3:\"uri\";s:85:\"sites/all/modules/video_embed_field/plugins/export_ui/video_embed_field_export_ui.inc\";s:8:\"filename\";s:31:\"video_embed_field_export_ui.inc\";s:4:\"name\";s:27:\"video_embed_field_export_ui\";}}s:8:\"views_ui\";a:1:{s:8:\"views_ui\";O:8:\"stdClass\":3:{s:3:\"uri\";s:54:\"sites/all/modules/views/plugins/export_ui/views_ui.inc\";s:8:\"filename\";s:12:\"views_ui.inc\";s:4:\"name\";s:8:\"views_ui\";}}s:14:\"advanced_forum\";a:0:{}}',0,1512620348,1),('ctools_plugin_type_info','a:5:{s:6:\"ctools\";a:7:{s:8:\"contexts\";a:14:{s:13:\"child plugins\";b:1;s:6:\"module\";s:6:\"ctools\";s:4:\"type\";s:8:\"contexts\";s:5:\"cache\";b:0;s:11:\"cache table\";s:5:\"cache\";s:7:\"classes\";a:0:{}s:9:\"use hooks\";b:0;s:8:\"defaults\";a:0:{}s:7:\"process\";s:0:\"\";s:9:\"alterable\";b:1;s:9:\"extension\";s:3:\"inc\";s:9:\"info file\";b:0;s:4:\"hook\";s:15:\"ctools_contexts\";s:11:\"load themes\";b:0;}s:9:\"arguments\";a:14:{s:13:\"child plugins\";b:1;s:6:\"module\";s:6:\"ctools\";s:4:\"type\";s:9:\"arguments\";s:5:\"cache\";b:0;s:11:\"cache table\";s:5:\"cache\";s:7:\"classes\";a:0:{}s:9:\"use hooks\";b:0;s:8:\"defaults\";a:0:{}s:7:\"process\";s:0:\"\";s:9:\"alterable\";b:1;s:9:\"extension\";s:3:\"inc\";s:9:\"info file\";b:0;s:4:\"hook\";s:16:\"ctools_arguments\";s:11:\"load themes\";b:0;}s:13:\"relationships\";a:14:{s:13:\"child plugins\";b:1;s:6:\"module\";s:6:\"ctools\";s:4:\"type\";s:13:\"relationships\";s:5:\"cache\";b:0;s:11:\"cache table\";s:5:\"cache\";s:7:\"classes\";a:0:{}s:9:\"use hooks\";b:0;s:8:\"defaults\";a:0:{}s:7:\"process\";s:0:\"\";s:9:\"alterable\";b:1;s:9:\"extension\";s:3:\"inc\";s:9:\"info file\";b:0;s:4:\"hook\";s:20:\"ctools_relationships\";s:11:\"load themes\";b:0;}s:6:\"access\";a:14:{s:13:\"child plugins\";b:1;s:6:\"module\";s:6:\"ctools\";s:4:\"type\";s:6:\"access\";s:5:\"cache\";b:0;s:11:\"cache table\";s:5:\"cache\";s:7:\"classes\";a:0:{}s:9:\"use hooks\";b:0;s:8:\"defaults\";a:0:{}s:7:\"process\";s:0:\"\";s:9:\"alterable\";b:1;s:9:\"extension\";s:3:\"inc\";s:9:\"info file\";b:0;s:4:\"hook\";s:13:\"ctools_access\";s:11:\"load themes\";b:0;}s:9:\"export_ui\";a:13:{s:7:\"process\";a:3:{s:8:\"function\";s:24:\"ctools_export_ui_process\";s:4:\"file\";s:13:\"export-ui.inc\";s:4:\"path\";s:33:\"sites/all/modules/ctools/includes\";}s:7:\"classes\";a:1:{i:0;s:7:\"handler\";}s:6:\"module\";s:6:\"ctools\";s:4:\"type\";s:9:\"export_ui\";s:5:\"cache\";b:0;s:11:\"cache table\";s:5:\"cache\";s:9:\"use hooks\";b:0;s:8:\"defaults\";a:0:{}s:9:\"alterable\";b:1;s:9:\"extension\";s:3:\"inc\";s:9:\"info file\";b:0;s:4:\"hook\";s:16:\"ctools_export_ui\";s:11:\"load themes\";b:0;}s:5:\"cache\";a:13:{s:6:\"module\";s:6:\"ctools\";s:4:\"type\";s:5:\"cache\";s:5:\"cache\";b:0;s:11:\"cache table\";s:5:\"cache\";s:7:\"classes\";a:0:{}s:9:\"use hooks\";b:0;s:8:\"defaults\";a:0:{}s:7:\"process\";s:0:\"\";s:9:\"alterable\";b:1;s:9:\"extension\";s:3:\"inc\";s:9:\"info file\";b:0;s:4:\"hook\";s:12:\"ctools_cache\";s:11:\"load themes\";b:0;}s:13:\"content_types\";a:13:{s:5:\"cache\";b:0;s:7:\"process\";a:3:{s:8:\"function\";s:22:\"ctools_content_process\";s:4:\"file\";s:11:\"content.inc\";s:4:\"path\";s:33:\"sites/all/modules/ctools/includes\";}s:6:\"module\";s:6:\"ctools\";s:4:\"type\";s:13:\"content_types\";s:11:\"cache table\";s:5:\"cache\";s:7:\"classes\";a:0:{}s:9:\"use hooks\";b:0;s:8:\"defaults\";a:0:{}s:9:\"alterable\";b:1;s:9:\"extension\";s:3:\"inc\";s:9:\"info file\";b:0;s:4:\"hook\";s:20:\"ctools_content_types\";s:11:\"load themes\";b:0;}}s:15:\"entityreference\";a:2:{s:9:\"selection\";a:13:{s:7:\"classes\";a:1:{i:0;s:5:\"class\";}s:6:\"module\";s:15:\"entityreference\";s:4:\"type\";s:9:\"selection\";s:5:\"cache\";b:0;s:11:\"cache table\";s:5:\"cache\";s:9:\"use hooks\";b:0;s:8:\"defaults\";a:0:{}s:7:\"process\";s:0:\"\";s:9:\"alterable\";b:1;s:9:\"extension\";s:3:\"inc\";s:9:\"info file\";b:0;s:4:\"hook\";s:25:\"entityreference_selection\";s:11:\"load themes\";b:0;}s:8:\"behavior\";a:13:{s:7:\"classes\";a:1:{i:0;s:5:\"class\";}s:7:\"process\";s:39:\"entityreference_behavior_plugin_process\";s:6:\"module\";s:15:\"entityreference\";s:4:\"type\";s:8:\"behavior\";s:5:\"cache\";b:0;s:11:\"cache table\";s:5:\"cache\";s:9:\"use hooks\";b:0;s:8:\"defaults\";a:0:{}s:9:\"alterable\";b:1;s:9:\"extension\";s:3:\"inc\";s:9:\"info file\";b:0;s:4:\"hook\";s:24:\"entityreference_behavior\";s:11:\"load themes\";b:0;}}s:9:\"quicktabs\";a:2:{s:9:\"renderers\";a:13:{s:5:\"cache\";b:1;s:9:\"use hooks\";b:1;s:7:\"classes\";a:1:{i:0;s:7:\"handler\";}s:6:\"module\";s:9:\"quicktabs\";s:4:\"type\";s:9:\"renderers\";s:11:\"cache table\";s:5:\"cache\";s:8:\"defaults\";a:0:{}s:7:\"process\";s:0:\"\";s:9:\"alterable\";b:1;s:9:\"extension\";s:3:\"inc\";s:9:\"info file\";b:0;s:4:\"hook\";s:19:\"quicktabs_renderers\";s:11:\"load themes\";b:0;}s:8:\"contents\";a:13:{s:5:\"cache\";b:1;s:9:\"use hooks\";b:1;s:7:\"classes\";a:1:{i:0;s:7:\"handler\";}s:6:\"module\";s:9:\"quicktabs\";s:4:\"type\";s:8:\"contents\";s:11:\"cache table\";s:5:\"cache\";s:8:\"defaults\";a:0:{}s:7:\"process\";s:0:\"\";s:9:\"alterable\";b:1;s:9:\"extension\";s:3:\"inc\";s:9:\"info file\";b:0;s:4:\"hook\";s:18:\"quicktabs_contents\";s:11:\"load themes\";b:0;}}s:8:\"views_ui\";a:1:{s:12:\"views_wizard\";a:14:{s:13:\"child plugins\";b:1;s:7:\"classes\";a:1:{i:0;s:17:\"form_wizard_class\";}s:8:\"defaults\";a:6:{s:12:\"get children\";N;s:9:\"get child\";N;s:5:\"title\";s:0:\"\";s:10:\"base_table\";N;s:12:\"get_instance\";s:33:\"views_ui_get_form_wizard_instance\";s:17:\"form_wizard_class\";a:2:{s:4:\"file\";s:26:\"views_ui_base_views_wizard\";s:5:\"class\";s:22:\"ViewsUiBaseViewsWizard\";}}s:6:\"module\";s:8:\"views_ui\";s:4:\"type\";s:12:\"views_wizard\";s:5:\"cache\";b:0;s:11:\"cache table\";s:5:\"cache\";s:9:\"use hooks\";b:0;s:7:\"process\";s:0:\"\";s:9:\"alterable\";b:1;s:9:\"extension\";s:3:\"inc\";s:9:\"info file\";b:0;s:4:\"hook\";s:21:\"views_ui_views_wizard\";s:11:\"load themes\";b:0;}}s:14:\"advanced_forum\";a:1:{s:6:\"styles\";a:13:{s:9:\"info file\";b:1;s:11:\"load themes\";b:1;s:6:\"module\";s:14:\"advanced_forum\";s:4:\"type\";s:6:\"styles\";s:5:\"cache\";b:0;s:11:\"cache table\";s:5:\"cache\";s:7:\"classes\";a:0:{}s:9:\"use hooks\";b:0;s:8:\"defaults\";a:0:{}s:7:\"process\";s:0:\"\";s:9:\"alterable\";b:1;s:9:\"extension\";s:3:\"inc\";s:4:\"hook\";s:21:\"advanced_forum_styles\";}}}',0,1512620340,1),('entity_info:en','a:11:{s:7:\"comment\";a:24:{s:5:\"label\";s:7:\"Comment\";s:10:\"base table\";s:7:\"comment\";s:12:\"uri callback\";s:11:\"comment_uri\";s:9:\"fieldable\";b:1;s:16:\"controller class\";s:17:\"CommentController\";s:11:\"entity keys\";a:5:{s:2:\"id\";s:3:\"cid\";s:6:\"bundle\";s:9:\"node_type\";s:5:\"label\";s:7:\"subject\";s:8:\"language\";s:8:\"language\";s:8:\"revision\";s:0:\"\";}s:7:\"bundles\";a:9:{s:20:\"comment_node_article\";a:3:{s:5:\"label\";s:15:\"Article comment\";s:11:\"node bundle\";s:7:\"article\";s:5:\"admin\";a:4:{s:4:\"path\";s:55:\"admin/structure/types/manage/%comment_node_type/comment\";s:15:\"bundle argument\";i:4;s:9:\"real path\";s:44:\"admin/structure/types/manage/article/comment\";s:16:\"access arguments\";a:1:{i:0;s:24:\"administer content types\";}}}s:17:\"comment_node_page\";a:3:{s:5:\"label\";s:18:\"Basic page comment\";s:11:\"node bundle\";s:4:\"page\";s:5:\"admin\";a:4:{s:4:\"path\";s:55:\"admin/structure/types/manage/%comment_node_type/comment\";s:15:\"bundle argument\";i:4;s:9:\"real path\";s:41:\"admin/structure/types/manage/page/comment\";s:16:\"access arguments\";a:1:{i:0;s:24:\"administer content types\";}}}s:17:\"comment_node_blog\";a:3:{s:5:\"label\";s:18:\"Blog entry comment\";s:11:\"node bundle\";s:4:\"blog\";s:5:\"admin\";a:4:{s:4:\"path\";s:55:\"admin/structure/types/manage/%comment_node_type/comment\";s:15:\"bundle argument\";i:4;s:9:\"real path\";s:41:\"admin/structure/types/manage/blog/comment\";s:16:\"access arguments\";a:1:{i:0;s:24:\"administer content types\";}}}s:17:\"comment_node_book\";a:3:{s:5:\"label\";s:17:\"Book page comment\";s:11:\"node bundle\";s:4:\"book\";s:5:\"admin\";a:4:{s:4:\"path\";s:55:\"admin/structure/types/manage/%comment_node_type/comment\";s:15:\"bundle argument\";i:4;s:9:\"real path\";s:41:\"admin/structure/types/manage/book/comment\";s:16:\"access arguments\";a:1:{i:0;s:24:\"administer content types\";}}}s:16:\"comment_node_faq\";a:3:{s:5:\"label\";s:11:\"FAQ comment\";s:11:\"node bundle\";s:3:\"faq\";s:5:\"admin\";a:4:{s:4:\"path\";s:55:\"admin/structure/types/manage/%comment_node_type/comment\";s:15:\"bundle argument\";i:4;s:9:\"real path\";s:40:\"admin/structure/types/manage/faq/comment\";s:16:\"access arguments\";a:1:{i:0;s:24:\"administer content types\";}}}s:18:\"comment_node_forum\";a:3:{s:5:\"label\";s:19:\"Forum topic comment\";s:11:\"node bundle\";s:5:\"forum\";s:5:\"admin\";a:4:{s:4:\"path\";s:55:\"admin/structure/types/manage/%comment_node_type/comment\";s:15:\"bundle argument\";i:4;s:9:\"real path\";s:42:\"admin/structure/types/manage/forum/comment\";s:16:\"access arguments\";a:1:{i:0;s:24:\"administer content types\";}}}s:21:\"comment_node_products\";a:3:{s:5:\"label\";s:16:\"Products comment\";s:11:\"node bundle\";s:8:\"products\";s:5:\"admin\";a:4:{s:4:\"path\";s:55:\"admin/structure/types/manage/%comment_node_type/comment\";s:15:\"bundle argument\";i:4;s:9:\"real path\";s:45:\"admin/structure/types/manage/products/comment\";s:16:\"access arguments\";a:1:{i:0;s:24:\"administer content types\";}}}s:18:\"comment_node_video\";a:3:{s:5:\"label\";s:13:\"Video comment\";s:11:\"node bundle\";s:5:\"video\";s:5:\"admin\";a:4:{s:4:\"path\";s:55:\"admin/structure/types/manage/%comment_node_type/comment\";s:15:\"bundle argument\";i:4;s:9:\"real path\";s:42:\"admin/structure/types/manage/video/comment\";s:16:\"access arguments\";a:1:{i:0;s:24:\"administer content types\";}}}s:20:\"comment_node_webform\";a:3:{s:5:\"label\";s:15:\"Webform comment\";s:11:\"node bundle\";s:7:\"webform\";s:5:\"admin\";a:4:{s:4:\"path\";s:55:\"admin/structure/types/manage/%comment_node_type/comment\";s:15:\"bundle argument\";i:4;s:9:\"real path\";s:44:\"admin/structure/types/manage/webform/comment\";s:16:\"access arguments\";a:1:{i:0;s:24:\"administer content types\";}}}}s:10:\"view modes\";a:2:{s:4:\"full\";a:2:{s:5:\"label\";s:12:\"Full comment\";s:15:\"custom settings\";b:0;}s:5:\"token\";a:2:{s:5:\"label\";s:6:\"Tokens\";s:15:\"custom settings\";b:0;}}s:12:\"static cache\";b:0;s:11:\"field cache\";b:1;s:9:\"load hook\";s:12:\"comment_load\";s:11:\"translation\";a:1:{s:6:\"locale\";b:1;}s:22:\"base table field types\";a:14:{s:3:\"cid\";s:6:\"serial\";s:3:\"pid\";s:3:\"int\";s:3:\"nid\";s:3:\"int\";s:3:\"uid\";s:3:\"int\";s:7:\"subject\";s:7:\"varchar\";s:8:\"hostname\";s:7:\"varchar\";s:7:\"created\";s:3:\"int\";s:7:\"changed\";s:3:\"int\";s:6:\"status\";s:3:\"int\";s:6:\"thread\";s:7:\"varchar\";s:4:\"name\";s:7:\"varchar\";s:4:\"mail\";s:7:\"varchar\";s:8:\"homepage\";s:7:\"varchar\";s:8:\"language\";s:7:\"varchar\";}s:17:\"schema_fields_sql\";a:1:{s:10:\"base table\";a:14:{i:0;s:3:\"cid\";i:1;s:3:\"pid\";i:2;s:3:\"nid\";i:3;s:3:\"uid\";i:4;s:7:\"subject\";i:5;s:8:\"hostname\";i:6;s:7:\"created\";i:7;s:7:\"changed\";i:8;s:6:\"status\";i:9;s:6:\"thread\";i:10;s:4:\"name\";i:11;s:4:\"mail\";i:12;s:8:\"homepage\";i:13;s:8:\"language\";}}s:10:\"token type\";s:7:\"comment\";s:12:\"plural label\";s:8:\"Comments\";s:11:\"description\";s:37:\"Remark or note that refers to a node.\";s:15:\"access callback\";s:30:\"entity_metadata_comment_access\";s:17:\"creation callback\";s:30:\"entity_metadata_create_comment\";s:13:\"save callback\";s:12:\"comment_save\";s:17:\"deletion callback\";s:14:\"comment_delete\";s:13:\"view callback\";s:28:\"entity_metadata_view_comment\";s:13:\"form callback\";s:28:\"entity_metadata_form_comment\";s:13:\"configuration\";b:0;}s:21:\"field_collection_item\";a:24:{s:5:\"label\";s:21:\"Field collection item\";s:14:\"label callback\";s:18:\"entity_class_label\";s:12:\"uri callback\";s:16:\"entity_class_uri\";s:12:\"entity class\";s:25:\"FieldCollectionItemEntity\";s:16:\"controller class\";s:19:\"EntityAPIController\";s:10:\"base table\";s:21:\"field_collection_item\";s:14:\"revision table\";s:30:\"field_collection_item_revision\";s:9:\"fieldable\";b:1;s:8:\"redirect\";b:0;s:11:\"entity keys\";a:3:{s:2:\"id\";s:7:\"item_id\";s:8:\"revision\";s:11:\"revision_id\";s:6:\"bundle\";s:10:\"field_name\";}s:6:\"module\";s:16:\"field_collection\";s:10:\"view modes\";a:2:{s:4:\"full\";a:2:{s:5:\"label\";s:12:\"Full content\";s:15:\"custom settings\";b:0;}s:5:\"token\";a:2:{s:5:\"label\";s:6:\"Tokens\";s:15:\"custom settings\";b:0;}}s:15:\"access callback\";s:28:\"field_collection_item_access\";s:17:\"deletion callback\";s:28:\"field_collection_item_delete\";s:25:\"metadata controller class\";s:37:\"FieldCollectionItemMetadataController\";s:7:\"bundles\";a:1:{s:19:\"field_extra_content\";a:2:{s:5:\"label\";s:36:\"Field collection field_extra_content\";s:5:\"admin\";a:4:{s:4:\"path\";s:62:\"admin/structure/field-collections/%field_collection_field_name\";s:9:\"real path\";s:53:\"admin/structure/field-collections/field-extra-content\";s:15:\"bundle argument\";i:3;s:16:\"access arguments\";a:1:{i:0;s:28:\"administer field collections\";}}}}s:12:\"static cache\";b:1;s:11:\"field cache\";b:1;s:9:\"load hook\";s:26:\"field_collection_item_load\";s:11:\"translation\";a:0:{}s:22:\"base table field types\";a:4:{s:7:\"item_id\";s:6:\"serial\";s:11:\"revision_id\";s:3:\"int\";s:10:\"field_name\";s:7:\"varchar\";s:8:\"archived\";s:3:\"int\";}s:17:\"schema_fields_sql\";a:2:{s:10:\"base table\";a:4:{i:0;s:7:\"item_id\";i:1;s:11:\"revision_id\";i:2;s:10:\"field_name\";i:3;s:8:\"archived\";}s:14:\"revision table\";a:2:{i:0;s:11:\"revision_id\";i:1;s:7:\"item_id\";}}s:10:\"token type\";s:21:\"field_collection_item\";s:13:\"configuration\";b:0;}s:16:\"i18n_translation\";a:16:{s:5:\"label\";s:15:\"Translation set\";s:16:\"controller class\";s:28:\"I18nTranslationSetController\";s:10:\"base table\";s:20:\"i18n_translation_set\";s:9:\"fieldable\";b:0;s:11:\"entity keys\";a:4:{s:2:\"id\";s:4:\"tsid\";s:6:\"bundle\";s:4:\"type\";s:5:\"label\";s:5:\"title\";s:8:\"revision\";s:0:\"\";}s:11:\"bundle keys\";a:1:{s:6:\"bundle\";s:4:\"type\";}s:7:\"bundles\";a:1:{s:13:\"taxonomy_term\";a:1:{s:5:\"label\";s:13:\"Taxonomy term\";}}s:12:\"static cache\";b:1;s:11:\"field cache\";b:1;s:9:\"load hook\";s:21:\"i18n_translation_load\";s:10:\"view modes\";a:0:{}s:11:\"translation\";a:0:{}s:22:\"base table field types\";a:8:{s:4:\"tsid\";s:6:\"serial\";s:5:\"title\";s:7:\"varchar\";s:4:\"type\";s:7:\"varchar\";s:6:\"bundle\";s:7:\"varchar\";s:9:\"master_id\";s:3:\"int\";s:6:\"status\";s:3:\"int\";s:7:\"created\";s:3:\"int\";s:7:\"changed\";s:3:\"int\";}s:17:\"schema_fields_sql\";a:1:{s:10:\"base table\";a:8:{i:0;s:4:\"tsid\";i:1;s:5:\"title\";i:2;s:4:\"type\";i:3;s:6:\"bundle\";i:4;s:9:\"master_id\";i:5;s:6:\"status\";i:6;s:7:\"created\";i:7;s:7:\"changed\";}}s:10:\"token type\";s:16:\"i18n_translation\";s:13:\"configuration\";b:0;}s:21:\"message_type_category\";a:21:{s:5:\"label\";s:21:\"Message type category\";s:16:\"controller class\";s:29:\"EntityAPIControllerExportable\";s:12:\"entity class\";s:19:\"MessageTypeCategory\";s:10:\"base table\";s:21:\"message_type_category\";s:9:\"fieldable\";b:1;s:11:\"entity keys\";a:5:{s:2:\"id\";s:2:\"id\";s:5:\"label\";s:11:\"description\";s:4:\"name\";s:8:\"category\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";}s:10:\"exportable\";b:1;s:6:\"export\";a:1:{s:12:\"default hook\";s:29:\"default_message_type_category\";}s:9:\"bundle of\";s:12:\"message_type\";s:6:\"module\";s:7:\"message\";s:15:\"access callback\";s:28:\"message_type_category_access\";s:12:\"static cache\";b:1;s:11:\"field cache\";b:1;s:9:\"load hook\";s:26:\"message_type_category_load\";s:7:\"bundles\";a:1:{s:21:\"message_type_category\";a:1:{s:5:\"label\";s:21:\"Message type category\";}}s:10:\"view modes\";a:1:{s:5:\"token\";a:2:{s:5:\"label\";s:6:\"Tokens\";s:15:\"custom settings\";b:0;}}s:11:\"translation\";a:0:{}s:22:\"base table field types\";a:6:{s:2:\"id\";s:6:\"serial\";s:8:\"category\";s:7:\"varchar\";s:11:\"description\";s:7:\"varchar\";s:8:\"language\";s:7:\"varchar\";s:6:\"status\";s:3:\"int\";s:6:\"module\";s:7:\"varchar\";}s:17:\"schema_fields_sql\";a:1:{s:10:\"base table\";a:6:{i:0;s:2:\"id\";i:1;s:8:\"category\";i:2;s:11:\"description\";i:3;s:8:\"language\";i:4;s:6:\"status\";i:5;s:6:\"module\";}}s:10:\"token type\";s:21:\"message_type_category\";s:13:\"configuration\";b:1;}s:12:\"message_type\";a:24:{s:5:\"label\";s:12:\"Message type\";s:16:\"controller class\";s:29:\"EntityAPIControllerExportable\";s:12:\"entity class\";s:11:\"MessageType\";s:10:\"base table\";s:12:\"message_type\";s:9:\"fieldable\";b:1;s:11:\"entity keys\";a:5:{s:2:\"id\";s:2:\"id\";s:5:\"label\";s:11:\"description\";s:4:\"name\";s:4:\"name\";s:6:\"bundle\";s:8:\"category\";s:8:\"revision\";s:0:\"\";}s:7:\"bundles\";a:0:{}s:11:\"bundle keys\";a:1:{s:6:\"bundle\";s:8:\"category\";}s:10:\"exportable\";b:1;s:6:\"export\";a:1:{s:12:\"default hook\";s:20:\"default_message_type\";}s:9:\"bundle of\";s:7:\"message\";s:6:\"module\";s:7:\"message\";s:15:\"access callback\";s:19:\"message_type_access\";s:12:\"entity cache\";b:0;s:8:\"admin ui\";a:3:{s:4:\"path\";s:24:\"admin/structure/messages\";s:4:\"file\";s:26:\"includes/message.admin.inc\";s:16:\"controller class\";s:23:\"MessageTypeUIController\";}s:11:\"translation\";a:1:{s:6:\"locale\";b:1;}s:12:\"static cache\";b:1;s:11:\"field cache\";b:1;s:9:\"load hook\";s:17:\"message_type_load\";s:10:\"view modes\";a:1:{s:5:\"token\";a:2:{s:5:\"label\";s:6:\"Tokens\";s:15:\"custom settings\";b:0;}}s:22:\"base table field types\";a:10:{s:2:\"id\";s:6:\"serial\";s:4:\"name\";s:7:\"varchar\";s:8:\"category\";s:7:\"varchar\";s:11:\"description\";s:7:\"varchar\";s:13:\"argument_keys\";s:4:\"text\";s:8:\"language\";s:7:\"varchar\";s:6:\"status\";s:3:\"int\";s:6:\"module\";s:7:\"varchar\";s:9:\"arguments\";s:4:\"text\";s:4:\"data\";s:4:\"text\";}s:17:\"schema_fields_sql\";a:1:{s:10:\"base table\";a:10:{i:0;s:2:\"id\";i:1;s:4:\"name\";i:2;s:8:\"category\";i:3;s:11:\"description\";i:4;s:13:\"argument_keys\";i:5;s:8:\"language\";i:6;s:6:\"status\";i:7;s:6:\"module\";i:8;s:9:\"arguments\";i:9;s:4:\"data\";}}s:10:\"token type\";s:12:\"message_type\";s:13:\"configuration\";b:1;}s:7:\"message\";a:22:{s:5:\"label\";s:7:\"Message\";s:16:\"controller class\";s:19:\"EntityAPIController\";s:12:\"entity class\";s:7:\"Message\";s:10:\"base table\";s:7:\"message\";s:9:\"fieldable\";b:1;s:15:\"access callback\";s:14:\"message_access\";s:11:\"entity keys\";a:4:{s:2:\"id\";s:3:\"mid\";s:5:\"label\";b:0;s:6:\"bundle\";s:4:\"type\";s:8:\"revision\";s:0:\"\";}s:7:\"bundles\";a:3:{s:22:\"example_create_comment\";a:2:{s:5:\"label\";s:24:\"Example - Create comment\";s:5:\"admin\";a:4:{s:4:\"path\";s:45:\"admin/structure/messages/manage/%message_type\";s:9:\"real path\";s:54:\"admin/structure/messages/manage/example_create_comment\";s:15:\"bundle argument\";i:4;s:16:\"access arguments\";a:1:{i:0;s:24:\"administer message types\";}}}s:19:\"example_create_node\";a:2:{s:5:\"label\";s:21:\"Example - Create node\";s:5:\"admin\";a:4:{s:4:\"path\";s:45:\"admin/structure/messages/manage/%message_type\";s:9:\"real path\";s:51:\"admin/structure/messages/manage/example_create_node\";s:15:\"bundle argument\";i:4;s:16:\"access arguments\";a:1:{i:0;s:24:\"administer message types\";}}}s:21:\"example_user_register\";a:2:{s:5:\"label\";s:23:\"Example - User register\";s:5:\"admin\";a:4:{s:4:\"path\";s:45:\"admin/structure/messages/manage/%message_type\";s:9:\"real path\";s:53:\"admin/structure/messages/manage/example_user_register\";s:15:\"bundle argument\";i:4;s:16:\"access arguments\";a:1:{i:0;s:24:\"administer message types\";}}}}s:11:\"bundle keys\";a:1:{s:6:\"bundle\";s:4:\"name\";}s:10:\"view modes\";a:2:{s:4:\"full\";a:2:{s:5:\"label\";s:4:\"Full\";s:15:\"custom settings\";b:0;}s:5:\"token\";a:2:{s:5:\"label\";s:6:\"Tokens\";s:15:\"custom settings\";b:0;}}s:6:\"module\";s:7:\"message\";s:25:\"metadata controller class\";s:25:\"MessageMetadataController\";s:22:\"views controller class\";s:22:\"MessageViewsController\";s:12:\"entity cache\";b:0;s:12:\"static cache\";b:1;s:11:\"field cache\";b:1;s:9:\"load hook\";s:12:\"message_load\";s:11:\"translation\";a:0:{}s:22:\"base table field types\";a:6:{s:3:\"mid\";s:6:\"serial\";s:4:\"type\";s:7:\"varchar\";s:9:\"arguments\";s:4:\"text\";s:3:\"uid\";s:3:\"int\";s:9:\"timestamp\";s:3:\"int\";s:8:\"language\";s:7:\"varchar\";}s:17:\"schema_fields_sql\";a:1:{s:10:\"base table\";a:6:{i:0;s:3:\"mid\";i:1;s:4:\"type\";i:2;s:9:\"arguments\";i:3;s:3:\"uid\";i:4;s:9:\"timestamp\";i:5;s:8:\"language\";}}s:10:\"token type\";s:7:\"message\";s:13:\"configuration\";b:0;}s:4:\"node\";a:27:{s:5:\"label\";s:4:\"Node\";s:16:\"controller class\";s:14:\"NodeController\";s:10:\"base table\";s:4:\"node\";s:14:\"revision table\";s:13:\"node_revision\";s:12:\"uri callback\";s:8:\"node_uri\";s:9:\"fieldable\";b:1;s:11:\"entity keys\";a:5:{s:2:\"id\";s:3:\"nid\";s:8:\"revision\";s:3:\"vid\";s:6:\"bundle\";s:4:\"type\";s:5:\"label\";s:5:\"title\";s:8:\"language\";s:8:\"language\";}s:11:\"bundle keys\";a:1:{s:6:\"bundle\";s:4:\"type\";}s:7:\"bundles\";a:9:{s:7:\"article\";a:2:{s:5:\"label\";s:7:\"Article\";s:5:\"admin\";a:4:{s:4:\"path\";s:39:\"admin/structure/types/manage/%node_type\";s:9:\"real path\";s:36:\"admin/structure/types/manage/article\";s:15:\"bundle argument\";i:4;s:16:\"access arguments\";a:1:{i:0;s:24:\"administer content types\";}}}s:4:\"page\";a:2:{s:5:\"label\";s:10:\"Basic page\";s:5:\"admin\";a:4:{s:4:\"path\";s:39:\"admin/structure/types/manage/%node_type\";s:9:\"real path\";s:33:\"admin/structure/types/manage/page\";s:15:\"bundle argument\";i:4;s:16:\"access arguments\";a:1:{i:0;s:24:\"administer content types\";}}}s:4:\"blog\";a:2:{s:5:\"label\";s:10:\"Blog entry\";s:5:\"admin\";a:4:{s:4:\"path\";s:39:\"admin/structure/types/manage/%node_type\";s:9:\"real path\";s:33:\"admin/structure/types/manage/blog\";s:15:\"bundle argument\";i:4;s:16:\"access arguments\";a:1:{i:0;s:24:\"administer content types\";}}}s:4:\"book\";a:2:{s:5:\"label\";s:9:\"Book page\";s:5:\"admin\";a:4:{s:4:\"path\";s:39:\"admin/structure/types/manage/%node_type\";s:9:\"real path\";s:33:\"admin/structure/types/manage/book\";s:15:\"bundle argument\";i:4;s:16:\"access arguments\";a:1:{i:0;s:24:\"administer content types\";}}}s:3:\"faq\";a:2:{s:5:\"label\";s:3:\"FAQ\";s:5:\"admin\";a:4:{s:4:\"path\";s:39:\"admin/structure/types/manage/%node_type\";s:9:\"real path\";s:32:\"admin/structure/types/manage/faq\";s:15:\"bundle argument\";i:4;s:16:\"access arguments\";a:1:{i:0;s:24:\"administer content types\";}}}s:5:\"forum\";a:2:{s:5:\"label\";s:11:\"Forum topic\";s:5:\"admin\";a:4:{s:4:\"path\";s:39:\"admin/structure/types/manage/%node_type\";s:9:\"real path\";s:34:\"admin/structure/types/manage/forum\";s:15:\"bundle argument\";i:4;s:16:\"access arguments\";a:1:{i:0;s:24:\"administer content types\";}}}s:8:\"products\";a:2:{s:5:\"label\";s:8:\"Products\";s:5:\"admin\";a:4:{s:4:\"path\";s:39:\"admin/structure/types/manage/%node_type\";s:9:\"real path\";s:37:\"admin/structure/types/manage/products\";s:15:\"bundle argument\";i:4;s:16:\"access arguments\";a:1:{i:0;s:24:\"administer content types\";}}}s:5:\"video\";a:2:{s:5:\"label\";s:5:\"Video\";s:5:\"admin\";a:4:{s:4:\"path\";s:39:\"admin/structure/types/manage/%node_type\";s:9:\"real path\";s:34:\"admin/structure/types/manage/video\";s:15:\"bundle argument\";i:4;s:16:\"access arguments\";a:1:{i:0;s:24:\"administer content types\";}}}s:7:\"webform\";a:2:{s:5:\"label\";s:7:\"Webform\";s:5:\"admin\";a:4:{s:4:\"path\";s:39:\"admin/structure/types/manage/%node_type\";s:9:\"real path\";s:36:\"admin/structure/types/manage/webform\";s:15:\"bundle argument\";i:4;s:16:\"access arguments\";a:1:{i:0;s:24:\"administer content types\";}}}}s:10:\"view modes\";a:7:{s:4:\"full\";a:2:{s:5:\"label\";s:12:\"Full content\";s:15:\"custom settings\";b:0;}s:6:\"teaser\";a:2:{s:5:\"label\";s:6:\"Teaser\";s:15:\"custom settings\";b:1;}s:3:\"rss\";a:2:{s:5:\"label\";s:3:\"RSS\";s:15:\"custom settings\";b:0;}s:12:\"search_index\";a:2:{s:5:\"label\";s:12:\"Search index\";s:15:\"custom settings\";b:0;}s:13:\"search_result\";a:2:{s:5:\"label\";s:32:\"Search result highlighting input\";s:15:\"custom settings\";b:0;}s:5:\"print\";a:2:{s:5:\"label\";s:5:\"Print\";s:15:\"custom settings\";b:0;}s:5:\"token\";a:2:{s:5:\"label\";s:6:\"Tokens\";s:15:\"custom settings\";b:0;}}s:12:\"static cache\";b:1;s:11:\"field cache\";b:1;s:9:\"load hook\";s:9:\"node_load\";s:11:\"translation\";a:1:{s:6:\"locale\";b:1;}s:22:\"base table field types\";a:14:{s:3:\"nid\";s:6:\"serial\";s:3:\"vid\";s:3:\"int\";s:4:\"type\";s:7:\"varchar\";s:8:\"language\";s:7:\"varchar\";s:5:\"title\";s:7:\"varchar\";s:3:\"uid\";s:3:\"int\";s:6:\"status\";s:3:\"int\";s:7:\"created\";s:3:\"int\";s:7:\"changed\";s:3:\"int\";s:7:\"comment\";s:3:\"int\";s:7:\"promote\";s:3:\"int\";s:6:\"sticky\";s:3:\"int\";s:4:\"tnid\";s:3:\"int\";s:9:\"translate\";s:3:\"int\";}s:17:\"schema_fields_sql\";a:2:{s:10:\"base table\";a:14:{i:0;s:3:\"nid\";i:1;s:3:\"vid\";i:2;s:4:\"type\";i:3;s:8:\"language\";i:4;s:5:\"title\";i:5;s:3:\"uid\";i:6;s:6:\"status\";i:7;s:7:\"created\";i:8;s:7:\"changed\";i:9;s:7:\"comment\";i:10;s:7:\"promote\";i:11;s:6:\"sticky\";i:12;s:4:\"tnid\";i:13;s:9:\"translate\";}s:14:\"revision table\";a:10:{i:0;s:3:\"nid\";i:1;s:3:\"vid\";i:2;s:3:\"uid\";i:3;s:5:\"title\";i:4;s:3:\"log\";i:5;s:9:\"timestamp\";i:6;s:6:\"status\";i:7;s:7:\"comment\";i:8;s:7:\"promote\";i:9;s:6:\"sticky\";}}s:10:\"token type\";s:4:\"node\";s:12:\"plural label\";s:5:\"Nodes\";s:11:\"description\";s:44:\"Nodes represent the main site content items.\";s:15:\"access callback\";s:35:\"entity_metadata_no_hook_node_access\";s:17:\"creation callback\";s:27:\"entity_metadata_create_node\";s:13:\"save callback\";s:9:\"node_save\";s:17:\"deletion callback\";s:11:\"node_delete\";s:26:\"revision deletion callback\";s:20:\"node_revision_delete\";s:13:\"form callback\";s:25:\"entity_metadata_form_node\";s:13:\"view callback\";s:25:\"entity_metadata_view_node\";s:13:\"configuration\";b:0;}s:4:\"file\";a:21:{s:5:\"label\";s:4:\"File\";s:10:\"base table\";s:12:\"file_managed\";s:11:\"entity keys\";a:4:{s:2:\"id\";s:3:\"fid\";s:5:\"label\";s:8:\"filename\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";}s:12:\"static cache\";b:0;s:9:\"fieldable\";b:0;s:16:\"controller class\";s:29:\"DrupalDefaultEntityController\";s:11:\"field cache\";b:1;s:9:\"load hook\";s:9:\"file_load\";s:7:\"bundles\";a:1:{s:4:\"file\";a:1:{s:5:\"label\";s:4:\"File\";}}s:10:\"view modes\";a:0:{}s:11:\"translation\";a:0:{}s:22:\"base table field types\";a:8:{s:3:\"fid\";s:6:\"serial\";s:3:\"uid\";s:3:\"int\";s:8:\"filename\";s:7:\"varchar\";s:3:\"uri\";s:7:\"varchar\";s:8:\"filemime\";s:7:\"varchar\";s:8:\"filesize\";s:3:\"int\";s:6:\"status\";s:3:\"int\";s:9:\"timestamp\";s:3:\"int\";}s:17:\"schema_fields_sql\";a:1:{s:10:\"base table\";a:8:{i:0;s:3:\"fid\";i:1;s:3:\"uid\";i:2;s:8:\"filename\";i:3;s:3:\"uri\";i:4;s:8:\"filemime\";i:5;s:8:\"filesize\";i:6;s:6:\"status\";i:7;s:9:\"timestamp\";}}s:10:\"token type\";s:4:\"file\";s:12:\"plural label\";s:5:\"Files\";s:11:\"description\";s:14:\"Uploaded file.\";s:15:\"access callback\";s:27:\"entity_metadata_file_access\";s:13:\"save callback\";s:9:\"file_save\";s:17:\"deletion callback\";s:27:\"entity_metadata_delete_file\";s:12:\"uri callback\";s:24:\"entity_metadata_uri_file\";s:13:\"configuration\";b:0;}s:13:\"taxonomy_term\";a:26:{s:5:\"label\";s:13:\"Taxonomy term\";s:16:\"controller class\";s:22:\"TaxonomyTermController\";s:10:\"base table\";s:18:\"taxonomy_term_data\";s:12:\"uri callback\";s:17:\"taxonomy_term_uri\";s:9:\"fieldable\";b:1;s:11:\"entity keys\";a:5:{s:2:\"id\";s:3:\"tid\";s:6:\"bundle\";s:23:\"vocabulary_machine_name\";s:5:\"label\";s:4:\"name\";s:8:\"revision\";s:0:\"\";s:8:\"language\";s:8:\"language\";}s:11:\"bundle keys\";a:1:{s:6:\"bundle\";s:12:\"machine_name\";}s:7:\"bundles\";a:4:{s:4:\"tags\";a:2:{s:5:\"label\";s:4:\"Tags\";s:5:\"admin\";a:4:{s:4:\"path\";s:58:\"admin/structure/taxonomy/%taxonomy_vocabulary_machine_name\";s:9:\"real path\";s:29:\"admin/structure/taxonomy/tags\";s:15:\"bundle argument\";i:3;s:16:\"access arguments\";a:1:{i:0;s:19:\"administer taxonomy\";}}}s:6:\"forums\";a:3:{s:5:\"label\";s:6:\"Forums\";s:5:\"admin\";a:4:{s:4:\"path\";s:58:\"admin/structure/taxonomy/%taxonomy_vocabulary_machine_name\";s:9:\"real path\";s:31:\"admin/structure/taxonomy/forums\";s:15:\"bundle argument\";i:3;s:16:\"access arguments\";a:1:{i:0;s:19:\"administer taxonomy\";}}s:12:\"uri callback\";s:9:\"forum_uri\";}s:10:\"categories\";a:2:{s:5:\"label\";s:10:\"Categories\";s:5:\"admin\";a:4:{s:4:\"path\";s:58:\"admin/structure/taxonomy/%taxonomy_vocabulary_machine_name\";s:9:\"real path\";s:35:\"admin/structure/taxonomy/categories\";s:15:\"bundle argument\";i:3;s:16:\"access arguments\";a:1:{i:0;s:19:\"administer taxonomy\";}}}s:8:\"sections\";a:2:{s:5:\"label\";s:8:\"Sections\";s:5:\"admin\";a:4:{s:4:\"path\";s:58:\"admin/structure/taxonomy/%taxonomy_vocabulary_machine_name\";s:9:\"real path\";s:33:\"admin/structure/taxonomy/sections\";s:15:\"bundle argument\";i:3;s:16:\"access arguments\";a:1:{i:0;s:19:\"administer taxonomy\";}}}}s:10:\"view modes\";a:2:{s:4:\"full\";a:2:{s:5:\"label\";s:18:\"Taxonomy term page\";s:15:\"custom settings\";b:0;}s:5:\"token\";a:2:{s:5:\"label\";s:6:\"Tokens\";s:15:\"custom settings\";b:0;}}s:12:\"static cache\";b:1;s:11:\"field cache\";b:1;s:9:\"load hook\";s:18:\"taxonomy_term_load\";s:11:\"translation\";a:0:{}s:22:\"base table field types\";a:8:{s:3:\"tid\";s:6:\"serial\";s:3:\"vid\";s:3:\"int\";s:4:\"name\";s:7:\"varchar\";s:11:\"description\";s:4:\"text\";s:6:\"format\";s:7:\"varchar\";s:6:\"weight\";s:3:\"int\";s:8:\"language\";s:7:\"varchar\";s:9:\"i18n_tsid\";s:3:\"int\";}s:17:\"schema_fields_sql\";a:1:{s:10:\"base table\";a:8:{i:0;s:3:\"tid\";i:1;s:3:\"vid\";i:2;s:4:\"name\";i:3;s:11:\"description\";i:4;s:6:\"format\";i:5;s:6:\"weight\";i:6;s:8:\"language\";i:7;s:9:\"i18n_tsid\";}}s:10:\"token type\";s:4:\"term\";s:14:\"label callback\";s:33:\"i18n_taxonomy_taxonomy_term_label\";s:12:\"plural label\";s:14:\"Taxonomy terms\";s:11:\"description\";s:48:\"Taxonomy terms are used for classifying content.\";s:15:\"access callback\";s:31:\"entity_metadata_taxonomy_access\";s:17:\"creation callback\";s:29:\"entity_metadata_create_object\";s:13:\"save callback\";s:18:\"taxonomy_term_save\";s:17:\"deletion callback\";s:20:\"taxonomy_term_delete\";s:13:\"view callback\";s:27:\"entity_metadata_view_single\";s:13:\"form callback\";s:34:\"entity_metadata_form_taxonomy_term\";s:13:\"configuration\";b:0;}s:19:\"taxonomy_vocabulary\";a:22:{s:5:\"label\";s:19:\"Taxonomy vocabulary\";s:16:\"controller class\";s:28:\"TaxonomyVocabularyController\";s:10:\"base table\";s:19:\"taxonomy_vocabulary\";s:11:\"entity keys\";a:4:{s:2:\"id\";s:3:\"vid\";s:5:\"label\";s:4:\"name\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";}s:9:\"fieldable\";b:0;s:12:\"static cache\";b:1;s:11:\"field cache\";b:1;s:9:\"load hook\";s:24:\"taxonomy_vocabulary_load\";s:7:\"bundles\";a:1:{s:19:\"taxonomy_vocabulary\";a:1:{s:5:\"label\";s:19:\"Taxonomy vocabulary\";}}s:10:\"view modes\";a:0:{}s:11:\"translation\";a:0:{}s:22:\"base table field types\";a:9:{s:3:\"vid\";s:6:\"serial\";s:4:\"name\";s:7:\"varchar\";s:12:\"machine_name\";s:7:\"varchar\";s:11:\"description\";s:4:\"text\";s:9:\"hierarchy\";s:3:\"int\";s:6:\"module\";s:7:\"varchar\";s:6:\"weight\";s:3:\"int\";s:8:\"language\";s:7:\"varchar\";s:9:\"i18n_mode\";s:3:\"int\";}s:17:\"schema_fields_sql\";a:1:{s:10:\"base table\";a:9:{i:0;s:3:\"vid\";i:1;s:4:\"name\";i:2;s:12:\"machine_name\";i:3;s:11:\"description\";i:4;s:9:\"hierarchy\";i:5;s:6:\"module\";i:6;s:6:\"weight\";i:7;s:8:\"language\";i:8;s:9:\"i18n_mode\";}}s:10:\"token type\";s:10:\"vocabulary\";s:12:\"plural label\";s:21:\"Taxonomy vocabularies\";s:11:\"description\";s:84:\"Vocabularies contain related taxonomy terms, which are used for classifying content.\";s:15:\"access callback\";s:31:\"entity_metadata_taxonomy_access\";s:17:\"creation callback\";s:29:\"entity_metadata_create_object\";s:13:\"save callback\";s:24:\"taxonomy_vocabulary_save\";s:17:\"deletion callback\";s:26:\"taxonomy_vocabulary_delete\";s:13:\"form callback\";s:40:\"entity_metadata_form_taxonomy_vocabulary\";s:13:\"configuration\";b:0;}s:4:\"user\";a:25:{s:5:\"label\";s:4:\"User\";s:16:\"controller class\";s:14:\"UserController\";s:10:\"base table\";s:5:\"users\";s:12:\"uri callback\";s:8:\"user_uri\";s:14:\"label callback\";s:15:\"format_username\";s:9:\"fieldable\";b:1;s:11:\"entity keys\";a:3:{s:2:\"id\";s:3:\"uid\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";}s:7:\"bundles\";a:1:{s:4:\"user\";a:2:{s:5:\"label\";s:4:\"User\";s:5:\"admin\";a:2:{s:4:\"path\";s:28:\"admin/config/people/accounts\";s:16:\"access arguments\";a:1:{i:0;s:16:\"administer users\";}}}}s:10:\"view modes\";a:2:{s:4:\"full\";a:2:{s:5:\"label\";s:12:\"User account\";s:15:\"custom settings\";b:0;}s:5:\"token\";a:2:{s:5:\"label\";s:6:\"Tokens\";s:15:\"custom settings\";b:0;}}s:12:\"static cache\";b:1;s:11:\"field cache\";b:1;s:9:\"load hook\";s:9:\"user_load\";s:11:\"translation\";a:0:{}s:22:\"base table field types\";a:16:{s:3:\"uid\";s:3:\"int\";s:4:\"name\";s:7:\"varchar\";s:4:\"pass\";s:7:\"varchar\";s:4:\"mail\";s:7:\"varchar\";s:5:\"theme\";s:7:\"varchar\";s:9:\"signature\";s:7:\"varchar\";s:16:\"signature_format\";s:7:\"varchar\";s:7:\"created\";s:3:\"int\";s:6:\"access\";s:3:\"int\";s:5:\"login\";s:3:\"int\";s:6:\"status\";s:3:\"int\";s:8:\"timezone\";s:7:\"varchar\";s:8:\"language\";s:7:\"varchar\";s:7:\"picture\";s:3:\"int\";s:4:\"init\";s:7:\"varchar\";s:4:\"data\";s:4:\"blob\";}s:17:\"schema_fields_sql\";a:1:{s:10:\"base table\";a:16:{i:0;s:3:\"uid\";i:1;s:4:\"name\";i:2;s:4:\"pass\";i:3;s:4:\"mail\";i:4;s:5:\"theme\";i:5;s:9:\"signature\";i:6;s:16:\"signature_format\";i:7;s:7:\"created\";i:8;s:6:\"access\";i:9;s:5:\"login\";i:10;s:6:\"status\";i:11;s:8:\"timezone\";i:12;s:8:\"language\";i:13;s:7:\"picture\";i:14;s:4:\"init\";i:15;s:4:\"data\";}}s:10:\"token type\";s:4:\"user\";s:12:\"plural label\";s:5:\"Users\";s:11:\"description\";s:45:\"Users who have created accounts on your site.\";s:15:\"access callback\";s:27:\"entity_metadata_user_access\";s:17:\"creation callback\";s:29:\"entity_metadata_create_object\";s:13:\"save callback\";s:25:\"entity_metadata_user_save\";s:17:\"deletion callback\";s:11:\"user_delete\";s:13:\"form callback\";s:25:\"entity_metadata_form_user\";s:13:\"view callback\";s:27:\"entity_metadata_view_single\";s:13:\"configuration\";b:0;}}',0,1512620340,1),('entity_property_info:en','a:11:{s:21:\"field_collection_item\";a:2:{s:10:\"properties\";a:6:{s:7:\"item_id\";a:5:{s:4:\"type\";s:7:\"integer\";s:5:\"label\";s:24:\"Field collection item ID\";s:12:\"schema field\";s:7:\"item_id\";s:19:\"validation callback\";s:41:\"entity_metadata_validate_integer_positive\";s:11:\"description\";s:43:\"The unique ID of the field collection item.\";}s:11:\"revision_id\";a:4:{s:4:\"type\";s:7:\"integer\";s:5:\"label\";s:11:\"Revision_id\";s:12:\"schema field\";s:11:\"revision_id\";s:11:\"description\";s:45:\"Field collection item \"revision_id\" property.\";}s:10:\"field_name\";a:6:{s:4:\"type\";s:5:\"token\";s:5:\"label\";s:10:\"Field name\";s:12:\"schema field\";s:10:\"field_name\";s:11:\"description\";s:77:\"The machine-readable name of the field collection field containing this item.\";s:12:\"options list\";a:2:{i:0;s:37:\"FieldCollectionItemMetadataController\";i:1;s:17:\"bundleOptionsList\";}s:8:\"required\";b:1;}s:8:\"archived\";a:4:{s:4:\"type\";s:7:\"integer\";s:5:\"label\";s:8:\"Archived\";s:12:\"schema field\";s:8:\"archived\";s:11:\"description\";s:42:\"Field collection item \"archived\" property.\";}s:3:\"url\";a:6:{s:5:\"label\";s:3:\"URL\";s:11:\"description\";s:22:\"The URL of the entity.\";s:15:\"getter callback\";s:37:\"entity_metadata_entity_get_properties\";s:4:\"type\";s:3:\"uri\";s:8:\"computed\";b:1;s:18:\"entity views field\";b:1;}s:11:\"host_entity\";a:6:{s:5:\"label\";s:11:\"Host entity\";s:4:\"type\";s:6:\"entity\";s:11:\"description\";s:49:\"The entity containing the field collection field.\";s:15:\"getter callback\";s:37:\"field_collection_item_get_host_entity\";s:15:\"setter callback\";s:37:\"field_collection_item_set_host_entity\";s:8:\"required\";b:1;}}s:7:\"bundles\";a:1:{s:19:\"field_extra_content\";a:1:{s:10:\"properties\";a:3:{s:11:\"field_image\";a:12:{s:5:\"label\";s:5:\"Image\";s:4:\"type\";s:16:\"field_item_image\";s:11:\"description\";s:20:\"Field \"field_image\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_verbatim_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_verbatim_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:0;s:13:\"auto creation\";s:38:\"entity_metadata_field_file_create_item\";s:19:\"validation callback\";s:40:\"entity_metadata_field_file_validate_item\";s:13:\"property info\";a:1:{s:4:\"file\";a:5:{s:4:\"type\";s:4:\"file\";s:5:\"label\";s:15:\"The image file.\";s:15:\"getter callback\";s:30:\"entity_metadata_field_file_get\";s:15:\"setter callback\";s:30:\"entity_metadata_field_file_set\";s:8:\"required\";b:1;}}}s:16:\"field_video_link\";a:11:{s:5:\"label\";s:10:\"Video Link\";s:4:\"type\";s:17:\"video_embed_field\";s:11:\"description\";s:25:\"Field \"field_video_link\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_verbatim_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_verbatim_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:0;s:13:\"property info\";a:3:{s:9:\"video_url\";a:4:{s:5:\"label\";s:9:\"Video URL\";s:4:\"type\";s:3:\"uri\";s:15:\"setter callback\";s:28:\"entity_property_verbatim_set\";s:11:\"description\";s:59:\"Video URL of field <em class=\"placeholder\">Video embed</em>\";}s:14:\"thumbnail_path\";a:4:{s:5:\"label\";s:14:\"Thumbnail path\";s:4:\"type\";s:3:\"uri\";s:15:\"getter callback\";s:32:\"entity_property_verbatim_get_url\";s:11:\"description\";s:64:\"Thumbnail path of field <em class=\"placeholder\">Video embed</em>\";}s:11:\"description\";a:4:{s:5:\"label\";s:11:\"Description\";s:4:\"type\";s:4:\"text\";s:15:\"setter callback\";s:28:\"entity_property_verbatim_set\";s:11:\"description\";s:61:\"Description of field <em class=\"placeholder\">Video embed</em>\";}}}s:17:\"field_description\";a:10:{s:5:\"label\";s:11:\"Description\";s:4:\"type\";s:4:\"text\";s:11:\"description\";s:26:\"Field \"field_description\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_property_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_property_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:0;}}}}}s:21:\"message_type_category\";a:1:{s:10:\"properties\";a:6:{s:2:\"id\";a:5:{s:4:\"type\";s:7:\"integer\";s:5:\"label\";s:42:\"Internal, numeric message type category ID\";s:12:\"schema field\";s:2:\"id\";s:19:\"validation callback\";s:41:\"entity_metadata_validate_integer_positive\";s:11:\"description\";s:62:\"The ID used to identify this message type category internally.\";}s:8:\"category\";a:4:{s:4:\"type\";s:5:\"token\";s:5:\"label\";s:21:\"Machine-readable name\";s:12:\"schema field\";s:8:\"category\";s:11:\"description\";s:65:\"The machine-readable name identifying this message type category.\";}s:11:\"description\";a:4:{s:4:\"type\";s:4:\"text\";s:5:\"label\";s:5:\"Label\";s:12:\"schema field\";s:11:\"description\";s:11:\"description\";s:25:\"The human readable label.\";}s:8:\"language\";a:4:{s:4:\"type\";s:4:\"text\";s:5:\"label\";s:8:\"Language\";s:12:\"schema field\";s:8:\"language\";s:11:\"description\";s:42:\"Message type category \"language\" property.\";}s:6:\"status\";a:4:{s:4:\"type\";s:7:\"integer\";s:5:\"label\";s:6:\"Status\";s:12:\"schema field\";s:6:\"status\";s:11:\"description\";s:40:\"Message type category \"status\" property.\";}s:6:\"module\";a:4:{s:4:\"type\";s:4:\"text\";s:5:\"label\";s:6:\"Module\";s:12:\"schema field\";s:6:\"module\";s:11:\"description\";s:40:\"Message type category \"module\" property.\";}}}s:12:\"message_type\";a:2:{s:10:\"properties\";a:10:{s:2:\"id\";a:5:{s:4:\"type\";s:7:\"integer\";s:5:\"label\";s:33:\"Internal, numeric message type ID\";s:12:\"schema field\";s:2:\"id\";s:19:\"validation callback\";s:41:\"entity_metadata_validate_integer_positive\";s:11:\"description\";s:53:\"The ID used to identify this message type internally.\";}s:4:\"name\";a:4:{s:4:\"type\";s:5:\"token\";s:5:\"label\";s:21:\"Machine-readable name\";s:12:\"schema field\";s:4:\"name\";s:11:\"description\";s:56:\"The machine-readable name identifying this message type.\";}s:8:\"category\";a:5:{s:4:\"type\";s:5:\"token\";s:5:\"label\";s:8:\"Category\";s:12:\"schema field\";s:8:\"category\";s:11:\"description\";s:33:\"Message type \"category\" property.\";s:12:\"options list\";a:2:{i:0;s:31:\"EntityDefaultMetadataController\";i:1;s:17:\"bundleOptionsList\";}}s:11:\"description\";a:4:{s:4:\"type\";s:4:\"text\";s:5:\"label\";s:5:\"Label\";s:12:\"schema field\";s:11:\"description\";s:11:\"description\";s:25:\"The human readable label.\";}s:13:\"argument_keys\";a:4:{s:4:\"type\";s:4:\"text\";s:5:\"label\";s:13:\"Argument_keys\";s:12:\"schema field\";s:13:\"argument_keys\";s:11:\"description\";s:38:\"Message type \"argument_keys\" property.\";}s:8:\"language\";a:4:{s:4:\"type\";s:4:\"text\";s:5:\"label\";s:8:\"Language\";s:12:\"schema field\";s:8:\"language\";s:11:\"description\";s:33:\"Message type \"language\" property.\";}s:6:\"status\";a:4:{s:4:\"type\";s:7:\"integer\";s:5:\"label\";s:6:\"Status\";s:12:\"schema field\";s:6:\"status\";s:11:\"description\";s:31:\"Message type \"status\" property.\";}s:6:\"module\";a:4:{s:4:\"type\";s:4:\"text\";s:5:\"label\";s:6:\"Module\";s:12:\"schema field\";s:6:\"module\";s:11:\"description\";s:31:\"Message type \"module\" property.\";}s:9:\"arguments\";a:4:{s:4:\"type\";s:4:\"text\";s:5:\"label\";s:9:\"Arguments\";s:12:\"schema field\";s:9:\"arguments\";s:11:\"description\";s:34:\"Message type \"arguments\" property.\";}s:4:\"data\";a:4:{s:4:\"type\";s:4:\"text\";s:5:\"label\";s:4:\"Data\";s:12:\"schema field\";s:4:\"data\";s:11:\"description\";s:29:\"Message type \"data\" property.\";}}s:7:\"bundles\";a:1:{s:12:\"message_type\";a:1:{s:10:\"properties\";a:1:{s:12:\"message_text\";a:11:{s:5:\"label\";s:12:\"Message text\";s:4:\"type\";s:20:\"list<text_formatted>\";s:11:\"description\";s:21:\"Field \"message_text\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_verbatim_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_verbatim_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:12:\"translatable\";b:1;s:5:\"field\";b:1;s:8:\"required\";b:1;s:13:\"property info\";a:2:{s:5:\"value\";a:7:{s:4:\"type\";s:4:\"text\";s:5:\"label\";s:4:\"Text\";s:9:\"sanitized\";b:1;s:15:\"getter callback\";s:30:\"entity_metadata_field_text_get\";s:15:\"setter callback\";s:28:\"entity_property_verbatim_set\";s:17:\"setter permission\";s:16:\"administer nodes\";s:19:\"raw getter callback\";s:28:\"entity_property_verbatim_get\";}s:6:\"format\";a:6:{s:4:\"type\";s:5:\"token\";s:5:\"label\";s:11:\"Text format\";s:12:\"options list\";s:34:\"entity_metadata_field_text_formats\";s:15:\"getter callback\";s:28:\"entity_property_verbatim_get\";s:15:\"setter callback\";s:28:\"entity_property_verbatim_set\";s:18:\"setter permissions\";s:18:\"administer filters\";}}s:13:\"auto creation\";s:28:\"entity_property_create_array\";}}}}}s:7:\"message\";a:2:{s:10:\"properties\";a:6:{s:3:\"mid\";a:5:{s:4:\"type\";s:7:\"integer\";s:5:\"label\";s:10:\"Message ID\";s:12:\"schema field\";s:3:\"mid\";s:19:\"validation callback\";s:41:\"entity_metadata_validate_integer_positive\";s:11:\"description\";s:29:\"The unique ID of the message.\";}s:4:\"type\";a:7:{s:15:\"setter callback\";s:28:\"entity_property_verbatim_set\";s:8:\"required\";b:1;s:11:\"description\";s:17:\"The message type.\";s:4:\"type\";s:12:\"message_type\";s:5:\"label\";s:4:\"Type\";s:12:\"schema field\";s:4:\"type\";s:12:\"options list\";a:2:{i:0;s:25:\"MessageMetadataController\";i:1;s:17:\"bundleOptionsList\";}}s:9:\"timestamp\";a:5:{s:4:\"type\";s:4:\"date\";s:15:\"setter callback\";s:28:\"entity_property_verbatim_set\";s:11:\"description\";s:37:\"The time the message has been logged.\";s:5:\"label\";s:9:\"Timestamp\";s:12:\"schema field\";s:9:\"timestamp\";}s:8:\"language\";a:4:{s:4:\"type\";s:4:\"text\";s:5:\"label\";s:8:\"Language\";s:12:\"schema field\";s:8:\"language\";s:11:\"description\";s:28:\"Message \"language\" property.\";}s:4:\"user\";a:7:{s:5:\"label\";s:4:\"User\";s:4:\"type\";s:4:\"user\";s:11:\"description\";s:38:\"The user for which to log the message.\";s:15:\"getter callback\";s:29:\"entity_property_getter_method\";s:15:\"setter callback\";s:29:\"entity_property_setter_method\";s:12:\"schema field\";s:3:\"uid\";s:8:\"required\";b:1;}s:4:\"text\";a:5:{s:4:\"type\";s:4:\"text\";s:5:\"label\";s:16:\"The message text\";s:15:\"getter callback\";s:25:\"message_property_get_text\";s:11:\"description\";s:56:\"The message text with all replacement arguments applied.\";s:8:\"sanitize\";b:1;}}s:7:\"bundles\";a:3:{s:22:\"example_create_comment\";a:1:{s:10:\"properties\";a:4:{s:9:\"arguments\";a:6:{s:5:\"label\";s:17:\"Message arguments\";s:4:\"type\";s:6:\"struct\";s:11:\"description\";s:44:\"The arguments to associate with the message.\";s:15:\"getter callback\";s:28:\"entity_property_verbatim_get\";s:15:\"setter callback\";s:28:\"entity_property_verbatim_set\";s:13:\"property info\";a:1:{s:6:\"teaser\";a:7:{s:4:\"type\";s:4:\"text\";s:5:\"label\";s:16:\"Argument !teaser\";s:11:\"description\";s:33:\"The replacement value for !teaser\";s:15:\"getter callback\";s:29:\"message_property_get_argument\";s:15:\"setter callback\";s:29:\"message_property_set_argument\";s:9:\"sanitized\";b:1;s:20:\"message_replace_char\";s:1:\"!\";}}}s:17:\"field_comment_ref\";a:10:{s:5:\"label\";s:17:\"Comment reference\";s:4:\"type\";s:7:\"comment\";s:11:\"description\";s:26:\"Field \"field_comment_ref\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_property_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_property_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:1;}s:14:\"field_node_ref\";a:10:{s:5:\"label\";s:14:\"Node reference\";s:4:\"type\";s:4:\"node\";s:11:\"description\";s:23:\"Field \"field_node_ref\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_property_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_property_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:1;}s:15:\"field_published\";a:11:{s:5:\"label\";s:9:\"Published\";s:4:\"type\";s:7:\"boolean\";s:11:\"description\";s:24:\"Field \"field_published\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_property_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_property_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:0;s:12:\"options list\";s:34:\"entity_metadata_field_options_list\";}}}s:19:\"example_create_node\";a:1:{s:10:\"properties\";a:3:{s:9:\"arguments\";a:6:{s:5:\"label\";s:17:\"Message arguments\";s:4:\"type\";s:6:\"struct\";s:11:\"description\";s:44:\"The arguments to associate with the message.\";s:15:\"getter callback\";s:28:\"entity_property_verbatim_get\";s:15:\"setter callback\";s:28:\"entity_property_verbatim_set\";s:13:\"property info\";a:0:{}}s:14:\"field_node_ref\";a:10:{s:5:\"label\";s:14:\"Node reference\";s:4:\"type\";s:4:\"node\";s:11:\"description\";s:23:\"Field \"field_node_ref\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_property_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_property_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:1;}s:15:\"field_published\";a:11:{s:5:\"label\";s:9:\"Published\";s:4:\"type\";s:7:\"boolean\";s:11:\"description\";s:24:\"Field \"field_published\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_property_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_property_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:0;s:12:\"options list\";s:34:\"entity_metadata_field_options_list\";}}}s:21:\"example_user_register\";a:1:{s:10:\"properties\";a:2:{s:9:\"arguments\";a:6:{s:5:\"label\";s:17:\"Message arguments\";s:4:\"type\";s:6:\"struct\";s:11:\"description\";s:44:\"The arguments to associate with the message.\";s:15:\"getter callback\";s:28:\"entity_property_verbatim_get\";s:15:\"setter callback\";s:28:\"entity_property_verbatim_set\";s:13:\"property info\";a:0:{}}s:15:\"field_published\";a:11:{s:5:\"label\";s:9:\"Published\";s:4:\"type\";s:7:\"boolean\";s:11:\"description\";s:24:\"Field \"field_published\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_property_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_property_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:0;s:12:\"options list\";s:34:\"entity_metadata_field_options_list\";}}}}}s:7:\"comment\";a:2:{s:10:\"properties\";a:14:{s:3:\"cid\";a:4:{s:5:\"label\";s:10:\"Comment ID\";s:4:\"type\";s:7:\"integer\";s:11:\"description\";s:29:\"The unique ID of the comment.\";s:12:\"schema field\";s:3:\"cid\";}s:8:\"hostname\";a:4:{s:5:\"label\";s:10:\"IP Address\";s:11:\"description\";s:59:\"The IP address of the computer the comment was posted from.\";s:15:\"access callback\";s:41:\"entity_metadata_comment_properties_access\";s:12:\"schema field\";s:8:\"hostname\";}s:4:\"name\";a:7:{s:5:\"label\";s:4:\"Name\";s:11:\"description\";s:36:\"The name left by the comment author.\";s:15:\"getter callback\";s:38:\"entity_metadata_comment_get_properties\";s:15:\"setter callback\";s:28:\"entity_property_verbatim_set\";s:17:\"setter permission\";s:19:\"administer comments\";s:8:\"sanitize\";s:10:\"filter_xss\";s:12:\"schema field\";s:4:\"name\";}s:4:\"mail\";a:7:{s:5:\"label\";s:13:\"Email address\";s:11:\"description\";s:45:\"The email address left by the comment author.\";s:15:\"getter callback\";s:38:\"entity_metadata_comment_get_properties\";s:15:\"setter callback\";s:28:\"entity_property_verbatim_set\";s:19:\"validation callback\";s:19:\"valid_email_address\";s:15:\"access callback\";s:41:\"entity_metadata_comment_properties_access\";s:12:\"schema field\";s:4:\"mail\";}s:8:\"homepage\";a:6:{s:5:\"label\";s:9:\"Home page\";s:11:\"description\";s:45:\"The home page URL left by the comment author.\";s:8:\"sanitize\";s:23:\"filter_xss_bad_protocol\";s:15:\"setter callback\";s:28:\"entity_property_verbatim_set\";s:17:\"setter permission\";s:19:\"administer comments\";s:12:\"schema field\";s:8:\"homepage\";}s:7:\"subject\";a:6:{s:5:\"label\";s:7:\"Subject\";s:11:\"description\";s:27:\"The subject of the comment.\";s:15:\"setter callback\";s:28:\"entity_property_verbatim_set\";s:8:\"sanitize\";s:10:\"filter_xss\";s:8:\"required\";b:1;s:12:\"schema field\";s:7:\"subject\";}s:3:\"url\";a:5:{s:5:\"label\";s:3:\"URL\";s:11:\"description\";s:23:\"The URL of the comment.\";s:15:\"getter callback\";s:37:\"entity_metadata_entity_get_properties\";s:4:\"type\";s:3:\"uri\";s:8:\"computed\";b:1;}s:8:\"edit_url\";a:5:{s:5:\"label\";s:8:\"Edit URL\";s:11:\"description\";s:35:\"The URL of the comment\'s edit page.\";s:15:\"getter callback\";s:38:\"entity_metadata_comment_get_properties\";s:4:\"type\";s:3:\"uri\";s:8:\"computed\";b:1;}s:7:\"created\";a:6:{s:5:\"label\";s:12:\"Date created\";s:11:\"description\";s:32:\"The date the comment was posted.\";s:4:\"type\";s:4:\"date\";s:15:\"setter callback\";s:28:\"entity_property_verbatim_set\";s:17:\"setter permission\";s:19:\"administer comments\";s:12:\"schema field\";s:7:\"created\";}s:6:\"parent\";a:6:{s:5:\"label\";s:6:\"Parent\";s:11:\"description\";s:53:\"The comment\'s parent, if comment threading is active.\";s:4:\"type\";s:7:\"comment\";s:15:\"getter callback\";s:38:\"entity_metadata_comment_get_properties\";s:17:\"setter permission\";s:19:\"administer comments\";s:12:\"schema field\";s:3:\"pid\";}s:4:\"node\";a:7:{s:5:\"label\";s:4:\"Node\";s:11:\"description\";s:35:\"The node the comment was posted to.\";s:4:\"type\";s:4:\"node\";s:15:\"setter callback\";s:30:\"entity_metadata_comment_setter\";s:17:\"setter permission\";s:19:\"administer comments\";s:8:\"required\";b:1;s:12:\"schema field\";s:3:\"nid\";}s:6:\"author\";a:7:{s:5:\"label\";s:6:\"Author\";s:11:\"description\";s:26:\"The author of the comment.\";s:4:\"type\";s:4:\"user\";s:15:\"setter callback\";s:28:\"entity_property_verbatim_set\";s:17:\"setter permission\";s:19:\"administer comments\";s:8:\"required\";b:1;s:12:\"schema field\";s:3:\"uid\";}s:6:\"status\";a:7:{s:5:\"label\";s:6:\"Status\";s:11:\"description\";s:48:\"Whether the comment is published or unpublished.\";s:15:\"setter callback\";s:28:\"entity_property_verbatim_set\";s:4:\"type\";s:7:\"integer\";s:12:\"options list\";s:35:\"entity_metadata_status_options_list\";s:15:\"access callback\";s:41:\"entity_metadata_comment_properties_access\";s:12:\"schema field\";s:6:\"status\";}s:12:\"comment_body\";a:7:{s:4:\"type\";s:14:\"text_formatted\";s:5:\"label\";s:18:\"The main body text\";s:15:\"getter callback\";s:34:\"entity_metadata_field_verbatim_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_verbatim_set\";s:13:\"property info\";a:2:{s:5:\"value\";a:7:{s:4:\"type\";s:4:\"text\";s:5:\"label\";s:4:\"Text\";s:9:\"sanitized\";b:1;s:15:\"getter callback\";s:30:\"entity_metadata_field_text_get\";s:15:\"setter callback\";s:28:\"entity_property_verbatim_set\";s:17:\"setter permission\";s:16:\"administer nodes\";s:19:\"raw getter callback\";s:28:\"entity_property_verbatim_get\";}s:6:\"format\";a:6:{s:4:\"type\";s:5:\"token\";s:5:\"label\";s:11:\"Text format\";s:12:\"options list\";s:34:\"entity_metadata_field_text_formats\";s:15:\"getter callback\";s:28:\"entity_property_verbatim_get\";s:15:\"setter callback\";s:28:\"entity_property_verbatim_set\";s:18:\"setter permissions\";s:18:\"administer filters\";}}s:5:\"field\";b:1;s:8:\"required\";b:1;}}s:7:\"bundles\";a:9:{s:17:\"comment_node_page\";a:1:{s:10:\"properties\";a:1:{s:12:\"comment_body\";a:11:{s:5:\"label\";s:7:\"Comment\";s:4:\"type\";s:14:\"text_formatted\";s:11:\"description\";s:21:\"Field \"comment_body\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_verbatim_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_verbatim_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:1;s:13:\"property info\";a:2:{s:5:\"value\";a:7:{s:4:\"type\";s:4:\"text\";s:5:\"label\";s:4:\"Text\";s:9:\"sanitized\";b:1;s:15:\"getter callback\";s:30:\"entity_metadata_field_text_get\";s:15:\"setter callback\";s:28:\"entity_property_verbatim_set\";s:17:\"setter permission\";s:16:\"administer nodes\";s:19:\"raw getter callback\";s:28:\"entity_property_verbatim_get\";}s:6:\"format\";a:6:{s:4:\"type\";s:5:\"token\";s:5:\"label\";s:11:\"Text format\";s:12:\"options list\";s:34:\"entity_metadata_field_text_formats\";s:15:\"getter callback\";s:28:\"entity_property_verbatim_get\";s:15:\"setter callback\";s:28:\"entity_property_verbatim_set\";s:18:\"setter permissions\";s:18:\"administer filters\";}}s:13:\"auto creation\";s:28:\"entity_property_create_array\";}}}s:20:\"comment_node_article\";a:1:{s:10:\"properties\";a:1:{s:12:\"comment_body\";a:11:{s:5:\"label\";s:7:\"Comment\";s:4:\"type\";s:14:\"text_formatted\";s:11:\"description\";s:21:\"Field \"comment_body\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_verbatim_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_verbatim_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:1;s:13:\"property info\";a:2:{s:5:\"value\";a:7:{s:4:\"type\";s:4:\"text\";s:5:\"label\";s:4:\"Text\";s:9:\"sanitized\";b:1;s:15:\"getter callback\";s:30:\"entity_metadata_field_text_get\";s:15:\"setter callback\";s:28:\"entity_property_verbatim_set\";s:17:\"setter permission\";s:16:\"administer nodes\";s:19:\"raw getter callback\";s:28:\"entity_property_verbatim_get\";}s:6:\"format\";a:6:{s:4:\"type\";s:5:\"token\";s:5:\"label\";s:11:\"Text format\";s:12:\"options list\";s:34:\"entity_metadata_field_text_formats\";s:15:\"getter callback\";s:28:\"entity_property_verbatim_get\";s:15:\"setter callback\";s:28:\"entity_property_verbatim_set\";s:18:\"setter permissions\";s:18:\"administer filters\";}}s:13:\"auto creation\";s:28:\"entity_property_create_array\";}}}s:17:\"comment_node_blog\";a:1:{s:10:\"properties\";a:1:{s:12:\"comment_body\";a:11:{s:5:\"label\";s:7:\"Comment\";s:4:\"type\";s:14:\"text_formatted\";s:11:\"description\";s:21:\"Field \"comment_body\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_verbatim_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_verbatim_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:1;s:13:\"property info\";a:2:{s:5:\"value\";a:7:{s:4:\"type\";s:4:\"text\";s:5:\"label\";s:4:\"Text\";s:9:\"sanitized\";b:1;s:15:\"getter callback\";s:30:\"entity_metadata_field_text_get\";s:15:\"setter callback\";s:28:\"entity_property_verbatim_set\";s:17:\"setter permission\";s:16:\"administer nodes\";s:19:\"raw getter callback\";s:28:\"entity_property_verbatim_get\";}s:6:\"format\";a:6:{s:4:\"type\";s:5:\"token\";s:5:\"label\";s:11:\"Text format\";s:12:\"options list\";s:34:\"entity_metadata_field_text_formats\";s:15:\"getter callback\";s:28:\"entity_property_verbatim_get\";s:15:\"setter callback\";s:28:\"entity_property_verbatim_set\";s:18:\"setter permissions\";s:18:\"administer filters\";}}s:13:\"auto creation\";s:28:\"entity_property_create_array\";}}}s:17:\"comment_node_book\";a:1:{s:10:\"properties\";a:1:{s:12:\"comment_body\";a:11:{s:5:\"label\";s:7:\"Comment\";s:4:\"type\";s:14:\"text_formatted\";s:11:\"description\";s:21:\"Field \"comment_body\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_verbatim_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_verbatim_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:1;s:13:\"property info\";a:2:{s:5:\"value\";a:7:{s:4:\"type\";s:4:\"text\";s:5:\"label\";s:4:\"Text\";s:9:\"sanitized\";b:1;s:15:\"getter callback\";s:30:\"entity_metadata_field_text_get\";s:15:\"setter callback\";s:28:\"entity_property_verbatim_set\";s:17:\"setter permission\";s:16:\"administer nodes\";s:19:\"raw getter callback\";s:28:\"entity_property_verbatim_get\";}s:6:\"format\";a:6:{s:4:\"type\";s:5:\"token\";s:5:\"label\";s:11:\"Text format\";s:12:\"options list\";s:34:\"entity_metadata_field_text_formats\";s:15:\"getter callback\";s:28:\"entity_property_verbatim_get\";s:15:\"setter callback\";s:28:\"entity_property_verbatim_set\";s:18:\"setter permissions\";s:18:\"administer filters\";}}s:13:\"auto creation\";s:28:\"entity_property_create_array\";}}}s:18:\"comment_node_forum\";a:1:{s:10:\"properties\";a:2:{s:12:\"comment_body\";a:11:{s:5:\"label\";s:7:\"Comment\";s:4:\"type\";s:14:\"text_formatted\";s:11:\"description\";s:21:\"Field \"comment_body\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_verbatim_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_verbatim_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:1;s:13:\"property info\";a:2:{s:5:\"value\";a:7:{s:4:\"type\";s:4:\"text\";s:5:\"label\";s:4:\"Text\";s:9:\"sanitized\";b:1;s:15:\"getter callback\";s:30:\"entity_metadata_field_text_get\";s:15:\"setter callback\";s:28:\"entity_property_verbatim_set\";s:17:\"setter permission\";s:16:\"administer nodes\";s:19:\"raw getter callback\";s:28:\"entity_property_verbatim_get\";}s:6:\"format\";a:6:{s:4:\"type\";s:5:\"token\";s:5:\"label\";s:11:\"Text format\";s:12:\"options list\";s:34:\"entity_metadata_field_text_formats\";s:15:\"getter callback\";s:28:\"entity_property_verbatim_get\";s:15:\"setter callback\";s:28:\"entity_property_verbatim_set\";s:18:\"setter permissions\";s:18:\"administer filters\";}}s:13:\"auto creation\";s:28:\"entity_property_create_array\";}s:10:\"field_vote\";a:11:{s:5:\"label\";s:4:\"Vote\";s:4:\"type\";s:8:\"fivestar\";s:11:\"description\";s:19:\"Field \"field_vote\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_property_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_property_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:0;s:13:\"property info\";a:3:{s:14:\"average_rating\";a:3:{s:5:\"label\";s:14:\"Average Rating\";s:4:\"type\";s:4:\"text\";s:9:\"microdata\";b:1;}s:11:\"user_rating\";a:3:{s:5:\"label\";s:13:\"User\'s Rating\";s:4:\"type\";s:4:\"text\";s:9:\"microdata\";b:1;}s:12:\"rating_count\";a:3:{s:5:\"label\";s:12:\"Rating count\";s:4:\"type\";s:4:\"text\";s:9:\"microdata\";b:1;}}}}}s:16:\"comment_node_faq\";a:1:{s:10:\"properties\";a:1:{s:12:\"comment_body\";a:11:{s:5:\"label\";s:7:\"Comment\";s:4:\"type\";s:14:\"text_formatted\";s:11:\"description\";s:21:\"Field \"comment_body\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_verbatim_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_verbatim_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:1;s:13:\"property info\";a:2:{s:5:\"value\";a:7:{s:4:\"type\";s:4:\"text\";s:5:\"label\";s:4:\"Text\";s:9:\"sanitized\";b:1;s:15:\"getter callback\";s:30:\"entity_metadata_field_text_get\";s:15:\"setter callback\";s:28:\"entity_property_verbatim_set\";s:17:\"setter permission\";s:16:\"administer nodes\";s:19:\"raw getter callback\";s:28:\"entity_property_verbatim_get\";}s:6:\"format\";a:6:{s:4:\"type\";s:5:\"token\";s:5:\"label\";s:11:\"Text format\";s:12:\"options list\";s:34:\"entity_metadata_field_text_formats\";s:15:\"getter callback\";s:28:\"entity_property_verbatim_get\";s:15:\"setter callback\";s:28:\"entity_property_verbatim_set\";s:18:\"setter permissions\";s:18:\"administer filters\";}}s:13:\"auto creation\";s:28:\"entity_property_create_array\";}}}s:18:\"comment_node_video\";a:1:{s:10:\"properties\";a:1:{s:12:\"comment_body\";a:11:{s:5:\"label\";s:7:\"Comment\";s:4:\"type\";s:14:\"text_formatted\";s:11:\"description\";s:21:\"Field \"comment_body\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_verbatim_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_verbatim_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:1;s:13:\"property info\";a:2:{s:5:\"value\";a:7:{s:4:\"type\";s:4:\"text\";s:5:\"label\";s:4:\"Text\";s:9:\"sanitized\";b:1;s:15:\"getter callback\";s:30:\"entity_metadata_field_text_get\";s:15:\"setter callback\";s:28:\"entity_property_verbatim_set\";s:17:\"setter permission\";s:16:\"administer nodes\";s:19:\"raw getter callback\";s:28:\"entity_property_verbatim_get\";}s:6:\"format\";a:6:{s:4:\"type\";s:5:\"token\";s:5:\"label\";s:11:\"Text format\";s:12:\"options list\";s:34:\"entity_metadata_field_text_formats\";s:15:\"getter callback\";s:28:\"entity_property_verbatim_get\";s:15:\"setter callback\";s:28:\"entity_property_verbatim_set\";s:18:\"setter permissions\";s:18:\"administer filters\";}}s:13:\"auto creation\";s:28:\"entity_property_create_array\";}}}s:20:\"comment_node_webform\";a:1:{s:10:\"properties\";a:1:{s:12:\"comment_body\";a:11:{s:5:\"label\";s:7:\"Comment\";s:4:\"type\";s:14:\"text_formatted\";s:11:\"description\";s:21:\"Field \"comment_body\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_verbatim_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_verbatim_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:1;s:13:\"property info\";a:2:{s:5:\"value\";a:7:{s:4:\"type\";s:4:\"text\";s:5:\"label\";s:4:\"Text\";s:9:\"sanitized\";b:1;s:15:\"getter callback\";s:30:\"entity_metadata_field_text_get\";s:15:\"setter callback\";s:28:\"entity_property_verbatim_set\";s:17:\"setter permission\";s:16:\"administer nodes\";s:19:\"raw getter callback\";s:28:\"entity_property_verbatim_get\";}s:6:\"format\";a:6:{s:4:\"type\";s:5:\"token\";s:5:\"label\";s:11:\"Text format\";s:12:\"options list\";s:34:\"entity_metadata_field_text_formats\";s:15:\"getter callback\";s:28:\"entity_property_verbatim_get\";s:15:\"setter callback\";s:28:\"entity_property_verbatim_set\";s:18:\"setter permissions\";s:18:\"administer filters\";}}s:13:\"auto creation\";s:28:\"entity_property_create_array\";}}}s:21:\"comment_node_products\";a:1:{s:10:\"properties\";a:1:{s:12:\"comment_body\";a:11:{s:5:\"label\";s:7:\"Comment\";s:4:\"type\";s:14:\"text_formatted\";s:11:\"description\";s:21:\"Field \"comment_body\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_verbatim_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_verbatim_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:1;s:13:\"property info\";a:2:{s:5:\"value\";a:7:{s:4:\"type\";s:4:\"text\";s:5:\"label\";s:4:\"Text\";s:9:\"sanitized\";b:1;s:15:\"getter callback\";s:30:\"entity_metadata_field_text_get\";s:15:\"setter callback\";s:28:\"entity_property_verbatim_set\";s:17:\"setter permission\";s:16:\"administer nodes\";s:19:\"raw getter callback\";s:28:\"entity_property_verbatim_get\";}s:6:\"format\";a:6:{s:4:\"type\";s:5:\"token\";s:5:\"label\";s:11:\"Text format\";s:12:\"options list\";s:34:\"entity_metadata_field_text_formats\";s:15:\"getter callback\";s:28:\"entity_property_verbatim_get\";s:15:\"setter callback\";s:28:\"entity_property_verbatim_set\";s:18:\"setter permissions\";s:18:\"administer filters\";}}s:13:\"auto creation\";s:28:\"entity_property_create_array\";}}}}}s:4:\"node\";a:2:{s:7:\"bundles\";a:9:{s:4:\"page\";a:1:{s:10:\"properties\";a:1:{s:4:\"body\";a:11:{s:5:\"label\";s:4:\"Body\";s:4:\"type\";s:14:\"text_formatted\";s:11:\"description\";s:13:\"Field \"body\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_verbatim_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_verbatim_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:0;s:13:\"property info\";a:3:{s:5:\"value\";a:7:{s:4:\"type\";s:4:\"text\";s:5:\"label\";s:4:\"Text\";s:9:\"sanitized\";b:1;s:15:\"getter callback\";s:30:\"entity_metadata_field_text_get\";s:15:\"setter callback\";s:28:\"entity_property_verbatim_set\";s:17:\"setter permission\";s:16:\"administer nodes\";s:19:\"raw getter callback\";s:28:\"entity_property_verbatim_get\";}s:7:\"summary\";a:7:{s:4:\"type\";s:4:\"text\";s:5:\"label\";s:7:\"Summary\";s:9:\"sanitized\";b:1;s:15:\"getter callback\";s:30:\"entity_metadata_field_text_get\";s:15:\"setter callback\";s:28:\"entity_property_verbatim_set\";s:17:\"setter permission\";s:16:\"administer nodes\";s:19:\"raw getter callback\";s:28:\"entity_property_verbatim_get\";}s:6:\"format\";a:6:{s:4:\"type\";s:5:\"token\";s:5:\"label\";s:11:\"Text format\";s:12:\"options list\";s:34:\"entity_metadata_field_text_formats\";s:15:\"getter callback\";s:28:\"entity_property_verbatim_get\";s:15:\"setter callback\";s:28:\"entity_property_verbatim_set\";s:18:\"setter permissions\";s:18:\"administer filters\";}}s:13:\"auto creation\";s:28:\"entity_property_create_array\";}}}s:7:\"article\";a:1:{s:10:\"properties\";a:6:{s:4:\"body\";a:11:{s:5:\"label\";s:4:\"Body\";s:4:\"type\";s:14:\"text_formatted\";s:11:\"description\";s:13:\"Field \"body\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_verbatim_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_verbatim_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:0;s:13:\"property info\";a:3:{s:5:\"value\";a:7:{s:4:\"type\";s:4:\"text\";s:5:\"label\";s:4:\"Text\";s:9:\"sanitized\";b:1;s:15:\"getter callback\";s:30:\"entity_metadata_field_text_get\";s:15:\"setter callback\";s:28:\"entity_property_verbatim_set\";s:17:\"setter permission\";s:16:\"administer nodes\";s:19:\"raw getter callback\";s:28:\"entity_property_verbatim_get\";}s:7:\"summary\";a:7:{s:4:\"type\";s:4:\"text\";s:5:\"label\";s:7:\"Summary\";s:9:\"sanitized\";b:1;s:15:\"getter callback\";s:30:\"entity_metadata_field_text_get\";s:15:\"setter callback\";s:28:\"entity_property_verbatim_set\";s:17:\"setter permission\";s:16:\"administer nodes\";s:19:\"raw getter callback\";s:28:\"entity_property_verbatim_get\";}s:6:\"format\";a:6:{s:4:\"type\";s:5:\"token\";s:5:\"label\";s:11:\"Text format\";s:12:\"options list\";s:34:\"entity_metadata_field_text_formats\";s:15:\"getter callback\";s:28:\"entity_property_verbatim_get\";s:15:\"setter callback\";s:28:\"entity_property_verbatim_set\";s:18:\"setter permissions\";s:18:\"administer filters\";}}s:13:\"auto creation\";s:28:\"entity_property_create_array\";}s:10:\"field_tags\";a:11:{s:5:\"label\";s:4:\"Tags\";s:4:\"type\";s:19:\"list<taxonomy_term>\";s:11:\"description\";s:19:\"Field \"field_tags\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_property_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_property_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:0;s:6:\"bundle\";s:4:\"tags\";}s:11:\"field_image\";a:12:{s:5:\"label\";s:5:\"Image\";s:4:\"type\";s:16:\"field_item_image\";s:11:\"description\";s:20:\"Field \"field_image\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_verbatim_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_verbatim_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:0;s:13:\"auto creation\";s:38:\"entity_metadata_field_file_create_item\";s:19:\"validation callback\";s:40:\"entity_metadata_field_file_validate_item\";s:13:\"property info\";a:2:{s:4:\"file\";a:5:{s:4:\"type\";s:4:\"file\";s:5:\"label\";s:15:\"The image file.\";s:15:\"getter callback\";s:30:\"entity_metadata_field_file_get\";s:15:\"setter callback\";s:30:\"entity_metadata_field_file_set\";s:8:\"required\";b:1;}s:3:\"alt\";a:3:{s:4:\"type\";s:4:\"text\";s:5:\"label\";s:24:\"The \"Alt\" attribute text\";s:15:\"setter callback\";s:28:\"entity_property_verbatim_set\";}}}s:13:\"field_section\";a:12:{s:5:\"label\";s:7:\"Section\";s:4:\"type\";s:13:\"taxonomy_term\";s:11:\"description\";s:22:\"Field \"field_section\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_property_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_property_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:0;s:6:\"bundle\";s:8:\"sections\";s:12:\"options list\";s:34:\"entity_metadata_field_options_list\";}s:14:\"field_category\";a:12:{s:5:\"label\";s:8:\"Category\";s:4:\"type\";s:13:\"taxonomy_term\";s:11:\"description\";s:23:\"Field \"field_category\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_property_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_property_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:0;s:6:\"bundle\";s:10:\"categories\";s:12:\"options list\";s:34:\"entity_metadata_field_options_list\";}s:19:\"field_extra_content\";a:11:{s:5:\"label\";s:13:\"Extra content\";s:4:\"type\";s:27:\"list<field_collection_item>\";s:11:\"description\";s:28:\"Field \"field_extra_content\".\";s:15:\"getter callback\";s:35:\"field_collection_field_property_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_property_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:0;s:6:\"bundle\";s:19:\"field_extra_content\";}}}s:4:\"blog\";a:1:{s:10:\"properties\";a:5:{s:4:\"body\";a:11:{s:5:\"label\";s:4:\"Body\";s:4:\"type\";s:14:\"text_formatted\";s:11:\"description\";s:13:\"Field \"body\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_verbatim_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_verbatim_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:0;s:13:\"property info\";a:3:{s:5:\"value\";a:7:{s:4:\"type\";s:4:\"text\";s:5:\"label\";s:4:\"Text\";s:9:\"sanitized\";b:1;s:15:\"getter callback\";s:30:\"entity_metadata_field_text_get\";s:15:\"setter callback\";s:28:\"entity_property_verbatim_set\";s:17:\"setter permission\";s:16:\"administer nodes\";s:19:\"raw getter callback\";s:28:\"entity_property_verbatim_get\";}s:7:\"summary\";a:7:{s:4:\"type\";s:4:\"text\";s:5:\"label\";s:7:\"Summary\";s:9:\"sanitized\";b:1;s:15:\"getter callback\";s:30:\"entity_metadata_field_text_get\";s:15:\"setter callback\";s:28:\"entity_property_verbatim_set\";s:17:\"setter permission\";s:16:\"administer nodes\";s:19:\"raw getter callback\";s:28:\"entity_property_verbatim_get\";}s:6:\"format\";a:6:{s:4:\"type\";s:5:\"token\";s:5:\"label\";s:11:\"Text format\";s:12:\"options list\";s:34:\"entity_metadata_field_text_formats\";s:15:\"getter callback\";s:28:\"entity_property_verbatim_get\";s:15:\"setter callback\";s:28:\"entity_property_verbatim_set\";s:18:\"setter permissions\";s:18:\"administer filters\";}}s:13:\"auto creation\";s:28:\"entity_property_create_array\";}s:10:\"field_tags\";a:11:{s:5:\"label\";s:4:\"Tags\";s:4:\"type\";s:19:\"list<taxonomy_term>\";s:11:\"description\";s:19:\"Field \"field_tags\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_property_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_property_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:0;s:6:\"bundle\";s:4:\"tags\";}s:11:\"field_image\";a:12:{s:5:\"label\";s:5:\"Image\";s:4:\"type\";s:16:\"field_item_image\";s:11:\"description\";s:20:\"Field \"field_image\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_verbatim_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_verbatim_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:0;s:13:\"auto creation\";s:38:\"entity_metadata_field_file_create_item\";s:19:\"validation callback\";s:40:\"entity_metadata_field_file_validate_item\";s:13:\"property info\";a:1:{s:4:\"file\";a:5:{s:4:\"type\";s:4:\"file\";s:5:\"label\";s:15:\"The image file.\";s:15:\"getter callback\";s:30:\"entity_metadata_field_file_get\";s:15:\"setter callback\";s:30:\"entity_metadata_field_file_set\";s:8:\"required\";b:1;}}}s:10:\"field_vote\";a:11:{s:5:\"label\";s:4:\"Vote\";s:4:\"type\";s:8:\"fivestar\";s:11:\"description\";s:19:\"Field \"field_vote\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_property_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_property_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:0;s:13:\"property info\";a:3:{s:14:\"average_rating\";a:3:{s:5:\"label\";s:14:\"Average Rating\";s:4:\"type\";s:4:\"text\";s:9:\"microdata\";b:1;}s:11:\"user_rating\";a:3:{s:5:\"label\";s:13:\"User\'s Rating\";s:4:\"type\";s:4:\"text\";s:9:\"microdata\";b:1;}s:12:\"rating_count\";a:3:{s:5:\"label\";s:12:\"Rating count\";s:4:\"type\";s:4:\"text\";s:9:\"microdata\";b:1;}}}s:19:\"field_extra_content\";a:11:{s:5:\"label\";s:13:\"Extra content\";s:4:\"type\";s:27:\"list<field_collection_item>\";s:11:\"description\";s:28:\"Field \"field_extra_content\".\";s:15:\"getter callback\";s:35:\"field_collection_field_property_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_property_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:0;s:6:\"bundle\";s:19:\"field_extra_content\";}}}s:4:\"book\";a:1:{s:10:\"properties\";a:1:{s:4:\"body\";a:11:{s:5:\"label\";s:4:\"Body\";s:4:\"type\";s:14:\"text_formatted\";s:11:\"description\";s:13:\"Field \"body\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_verbatim_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_verbatim_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:0;s:13:\"property info\";a:3:{s:5:\"value\";a:7:{s:4:\"type\";s:4:\"text\";s:5:\"label\";s:4:\"Text\";s:9:\"sanitized\";b:1;s:15:\"getter callback\";s:30:\"entity_metadata_field_text_get\";s:15:\"setter callback\";s:28:\"entity_property_verbatim_set\";s:17:\"setter permission\";s:16:\"administer nodes\";s:19:\"raw getter callback\";s:28:\"entity_property_verbatim_get\";}s:7:\"summary\";a:7:{s:4:\"type\";s:4:\"text\";s:5:\"label\";s:7:\"Summary\";s:9:\"sanitized\";b:1;s:15:\"getter callback\";s:30:\"entity_metadata_field_text_get\";s:15:\"setter callback\";s:28:\"entity_property_verbatim_set\";s:17:\"setter permission\";s:16:\"administer nodes\";s:19:\"raw getter callback\";s:28:\"entity_property_verbatim_get\";}s:6:\"format\";a:6:{s:4:\"type\";s:5:\"token\";s:5:\"label\";s:11:\"Text format\";s:12:\"options list\";s:34:\"entity_metadata_field_text_formats\";s:15:\"getter callback\";s:28:\"entity_property_verbatim_get\";s:15:\"setter callback\";s:28:\"entity_property_verbatim_set\";s:18:\"setter permissions\";s:18:\"administer filters\";}}s:13:\"auto creation\";s:28:\"entity_property_create_array\";}}}s:5:\"forum\";a:1:{s:10:\"properties\";a:4:{s:4:\"body\";a:11:{s:5:\"label\";s:4:\"Body\";s:4:\"type\";s:14:\"text_formatted\";s:11:\"description\";s:13:\"Field \"body\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_verbatim_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_verbatim_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:0;s:13:\"property info\";a:3:{s:5:\"value\";a:7:{s:4:\"type\";s:4:\"text\";s:5:\"label\";s:4:\"Text\";s:9:\"sanitized\";b:1;s:15:\"getter callback\";s:30:\"entity_metadata_field_text_get\";s:15:\"setter callback\";s:28:\"entity_property_verbatim_set\";s:17:\"setter permission\";s:16:\"administer nodes\";s:19:\"raw getter callback\";s:28:\"entity_property_verbatim_get\";}s:7:\"summary\";a:7:{s:4:\"type\";s:4:\"text\";s:5:\"label\";s:7:\"Summary\";s:9:\"sanitized\";b:1;s:15:\"getter callback\";s:30:\"entity_metadata_field_text_get\";s:15:\"setter callback\";s:28:\"entity_property_verbatim_set\";s:17:\"setter permission\";s:16:\"administer nodes\";s:19:\"raw getter callback\";s:28:\"entity_property_verbatim_get\";}s:6:\"format\";a:6:{s:4:\"type\";s:5:\"token\";s:5:\"label\";s:11:\"Text format\";s:12:\"options list\";s:34:\"entity_metadata_field_text_formats\";s:15:\"getter callback\";s:28:\"entity_property_verbatim_get\";s:15:\"setter callback\";s:28:\"entity_property_verbatim_set\";s:18:\"setter permissions\";s:18:\"administer filters\";}}s:13:\"auto creation\";s:28:\"entity_property_create_array\";}s:15:\"taxonomy_forums\";a:12:{s:5:\"label\";s:6:\"Forums\";s:4:\"type\";s:13:\"taxonomy_term\";s:11:\"description\";s:24:\"Field \"taxonomy_forums\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_property_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_property_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:1;s:6:\"bundle\";s:6:\"forums\";s:12:\"options list\";s:34:\"entity_metadata_field_options_list\";}s:10:\"field_vote\";a:11:{s:5:\"label\";s:4:\"Vote\";s:4:\"type\";s:8:\"fivestar\";s:11:\"description\";s:19:\"Field \"field_vote\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_property_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_property_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:0;s:13:\"property info\";a:3:{s:14:\"average_rating\";a:3:{s:5:\"label\";s:14:\"Average Rating\";s:4:\"type\";s:4:\"text\";s:9:\"microdata\";b:1;}s:11:\"user_rating\";a:3:{s:5:\"label\";s:13:\"User\'s Rating\";s:4:\"type\";s:4:\"text\";s:9:\"microdata\";b:1;}s:12:\"rating_count\";a:3:{s:5:\"label\";s:12:\"Rating count\";s:4:\"type\";s:4:\"text\";s:9:\"microdata\";b:1;}}}s:19:\"field_extra_content\";a:11:{s:5:\"label\";s:13:\"Extra content\";s:4:\"type\";s:27:\"list<field_collection_item>\";s:11:\"description\";s:28:\"Field \"field_extra_content\".\";s:15:\"getter callback\";s:35:\"field_collection_field_property_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_property_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:0;s:6:\"bundle\";s:19:\"field_extra_content\";}}}s:3:\"faq\";a:1:{s:10:\"properties\";a:2:{s:4:\"body\";a:11:{s:5:\"label\";s:4:\"Body\";s:4:\"type\";s:14:\"text_formatted\";s:11:\"description\";s:13:\"Field \"body\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_verbatim_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_verbatim_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:0;s:13:\"property info\";a:3:{s:5:\"value\";a:7:{s:4:\"type\";s:4:\"text\";s:5:\"label\";s:4:\"Text\";s:9:\"sanitized\";b:1;s:15:\"getter callback\";s:30:\"entity_metadata_field_text_get\";s:15:\"setter callback\";s:28:\"entity_property_verbatim_set\";s:17:\"setter permission\";s:16:\"administer nodes\";s:19:\"raw getter callback\";s:28:\"entity_property_verbatim_get\";}s:7:\"summary\";a:7:{s:4:\"type\";s:4:\"text\";s:5:\"label\";s:7:\"Summary\";s:9:\"sanitized\";b:1;s:15:\"getter callback\";s:30:\"entity_metadata_field_text_get\";s:15:\"setter callback\";s:28:\"entity_property_verbatim_set\";s:17:\"setter permission\";s:16:\"administer nodes\";s:19:\"raw getter callback\";s:28:\"entity_property_verbatim_get\";}s:6:\"format\";a:6:{s:4:\"type\";s:5:\"token\";s:5:\"label\";s:11:\"Text format\";s:12:\"options list\";s:34:\"entity_metadata_field_text_formats\";s:15:\"getter callback\";s:28:\"entity_property_verbatim_get\";s:15:\"setter callback\";s:28:\"entity_property_verbatim_set\";s:18:\"setter permissions\";s:18:\"administer filters\";}}s:13:\"auto creation\";s:28:\"entity_property_create_array\";}s:23:\"field_detailed_question\";a:11:{s:5:\"label\";s:17:\"Detailed question\";s:4:\"type\";s:14:\"text_formatted\";s:11:\"description\";s:32:\"Field \"field_detailed_question\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_verbatim_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_verbatim_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:0;s:13:\"property info\";a:2:{s:5:\"value\";a:7:{s:4:\"type\";s:4:\"text\";s:5:\"label\";s:4:\"Text\";s:9:\"sanitized\";b:1;s:15:\"getter callback\";s:30:\"entity_metadata_field_text_get\";s:15:\"setter callback\";s:28:\"entity_property_verbatim_set\";s:17:\"setter permission\";s:16:\"administer nodes\";s:19:\"raw getter callback\";s:28:\"entity_property_verbatim_get\";}s:6:\"format\";a:6:{s:4:\"type\";s:5:\"token\";s:5:\"label\";s:11:\"Text format\";s:12:\"options list\";s:34:\"entity_metadata_field_text_formats\";s:15:\"getter callback\";s:28:\"entity_property_verbatim_get\";s:15:\"setter callback\";s:28:\"entity_property_verbatim_set\";s:18:\"setter permissions\";s:18:\"administer filters\";}}s:13:\"auto creation\";s:28:\"entity_property_create_array\";}}}s:5:\"video\";a:1:{s:10:\"properties\";a:3:{s:4:\"body\";a:11:{s:5:\"label\";s:4:\"Body\";s:4:\"type\";s:14:\"text_formatted\";s:11:\"description\";s:13:\"Field \"body\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_verbatim_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_verbatim_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:0;s:13:\"property info\";a:3:{s:5:\"value\";a:7:{s:4:\"type\";s:4:\"text\";s:5:\"label\";s:4:\"Text\";s:9:\"sanitized\";b:1;s:15:\"getter callback\";s:30:\"entity_metadata_field_text_get\";s:15:\"setter callback\";s:28:\"entity_property_verbatim_set\";s:17:\"setter permission\";s:16:\"administer nodes\";s:19:\"raw getter callback\";s:28:\"entity_property_verbatim_get\";}s:7:\"summary\";a:7:{s:4:\"type\";s:4:\"text\";s:5:\"label\";s:7:\"Summary\";s:9:\"sanitized\";b:1;s:15:\"getter callback\";s:30:\"entity_metadata_field_text_get\";s:15:\"setter callback\";s:28:\"entity_property_verbatim_set\";s:17:\"setter permission\";s:16:\"administer nodes\";s:19:\"raw getter callback\";s:28:\"entity_property_verbatim_get\";}s:6:\"format\";a:6:{s:4:\"type\";s:5:\"token\";s:5:\"label\";s:11:\"Text format\";s:12:\"options list\";s:34:\"entity_metadata_field_text_formats\";s:15:\"getter callback\";s:28:\"entity_property_verbatim_get\";s:15:\"setter callback\";s:28:\"entity_property_verbatim_set\";s:18:\"setter permissions\";s:18:\"administer filters\";}}s:13:\"auto creation\";s:28:\"entity_property_create_array\";}s:10:\"field_tags\";a:11:{s:5:\"label\";s:4:\"Tags\";s:4:\"type\";s:19:\"list<taxonomy_term>\";s:11:\"description\";s:19:\"Field \"field_tags\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_property_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_property_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:0;s:6:\"bundle\";s:4:\"tags\";}s:16:\"field_video_link\";a:11:{s:5:\"label\";s:10:\"Video Link\";s:4:\"type\";s:17:\"video_embed_field\";s:11:\"description\";s:25:\"Field \"field_video_link\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_verbatim_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_verbatim_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:14:\"query callback\";s:27:\"entity_metadata_field_query\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:0;s:13:\"property info\";a:3:{s:9:\"video_url\";a:4:{s:5:\"label\";s:9:\"Video URL\";s:4:\"type\";s:3:\"uri\";s:15:\"setter callback\";s:28:\"entity_property_verbatim_set\";s:11:\"description\";s:59:\"Video URL of field <em class=\"placeholder\">Video embed</em>\";}s:14:\"thumbnail_path\";a:4:{s:5:\"label\";s:14:\"Thumbnail path\";s:4:\"type\";s:3:\"uri\";s:15:\"getter callback\";s:32:\"entity_property_verbatim_get_url\";s:11:\"description\";s:64:\"Thumbnail path of field <em class=\"placeholder\">Video embed</em>\";}s:11:\"description\";a:4:{s:5:\"label\";s:11:\"Description\";s:4:\"type\";s:4:\"text\";s:15:\"setter callback\";s:28:\"entity_property_verbatim_set\";s:11:\"description\";s:61:\"Description of field <em class=\"placeholder\">Video embed</em>\";}}}}}s:7:\"webform\";a:1:{s:10:\"properties\";a:1:{s:4:\"body\";a:11:{s:5:\"label\";s:4:\"Body\";s:4:\"type\";s:14:\"text_formatted\";s:11:\"description\";s:13:\"Field \"body\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_verbatim_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_verbatim_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:0;s:13:\"property info\";a:3:{s:5:\"value\";a:7:{s:4:\"type\";s:4:\"text\";s:5:\"label\";s:4:\"Text\";s:9:\"sanitized\";b:1;s:15:\"getter callback\";s:30:\"entity_metadata_field_text_get\";s:15:\"setter callback\";s:28:\"entity_property_verbatim_set\";s:17:\"setter permission\";s:16:\"administer nodes\";s:19:\"raw getter callback\";s:28:\"entity_property_verbatim_get\";}s:7:\"summary\";a:7:{s:4:\"type\";s:4:\"text\";s:5:\"label\";s:7:\"Summary\";s:9:\"sanitized\";b:1;s:15:\"getter callback\";s:30:\"entity_metadata_field_text_get\";s:15:\"setter callback\";s:28:\"entity_property_verbatim_set\";s:17:\"setter permission\";s:16:\"administer nodes\";s:19:\"raw getter callback\";s:28:\"entity_property_verbatim_get\";}s:6:\"format\";a:6:{s:4:\"type\";s:5:\"token\";s:5:\"label\";s:11:\"Text format\";s:12:\"options list\";s:34:\"entity_metadata_field_text_formats\";s:15:\"getter callback\";s:28:\"entity_property_verbatim_get\";s:15:\"setter callback\";s:28:\"entity_property_verbatim_set\";s:18:\"setter permissions\";s:18:\"administer filters\";}}s:13:\"auto creation\";s:28:\"entity_property_create_array\";}}}s:8:\"products\";a:1:{s:10:\"properties\";a:3:{s:4:\"body\";a:11:{s:5:\"label\";s:4:\"Body\";s:4:\"type\";s:14:\"text_formatted\";s:11:\"description\";s:13:\"Field \"body\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_verbatim_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_verbatim_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:0;s:13:\"property info\";a:3:{s:5:\"value\";a:7:{s:4:\"type\";s:4:\"text\";s:5:\"label\";s:4:\"Text\";s:9:\"sanitized\";b:1;s:15:\"getter callback\";s:30:\"entity_metadata_field_text_get\";s:15:\"setter callback\";s:28:\"entity_property_verbatim_set\";s:17:\"setter permission\";s:16:\"administer nodes\";s:19:\"raw getter callback\";s:28:\"entity_property_verbatim_get\";}s:7:\"summary\";a:7:{s:4:\"type\";s:4:\"text\";s:5:\"label\";s:7:\"Summary\";s:9:\"sanitized\";b:1;s:15:\"getter callback\";s:30:\"entity_metadata_field_text_get\";s:15:\"setter callback\";s:28:\"entity_property_verbatim_set\";s:17:\"setter permission\";s:16:\"administer nodes\";s:19:\"raw getter callback\";s:28:\"entity_property_verbatim_get\";}s:6:\"format\";a:6:{s:4:\"type\";s:5:\"token\";s:5:\"label\";s:11:\"Text format\";s:12:\"options list\";s:34:\"entity_metadata_field_text_formats\";s:15:\"getter callback\";s:28:\"entity_property_verbatim_get\";s:15:\"setter callback\";s:28:\"entity_property_verbatim_set\";s:18:\"setter permissions\";s:18:\"administer filters\";}}s:13:\"auto creation\";s:28:\"entity_property_create_array\";}s:11:\"field_image\";a:12:{s:5:\"label\";s:5:\"Image\";s:4:\"type\";s:16:\"field_item_image\";s:11:\"description\";s:20:\"Field \"field_image\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_verbatim_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_verbatim_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:0;s:13:\"auto creation\";s:38:\"entity_metadata_field_file_create_item\";s:19:\"validation callback\";s:40:\"entity_metadata_field_file_validate_item\";s:13:\"property info\";a:1:{s:4:\"file\";a:5:{s:4:\"type\";s:4:\"file\";s:5:\"label\";s:15:\"The image file.\";s:15:\"getter callback\";s:30:\"entity_metadata_field_file_get\";s:15:\"setter callback\";s:30:\"entity_metadata_field_file_set\";s:8:\"required\";b:1;}}}s:10:\"field_link\";a:11:{s:5:\"label\";s:4:\"Link\";s:4:\"type\";s:15:\"field_item_link\";s:11:\"description\";s:19:\"Field \"field_link\".\";s:15:\"getter callback\";s:34:\"entity_metadata_field_verbatim_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_verbatim_set\";s:15:\"access callback\";s:37:\"entity_metadata_field_access_callback\";s:12:\"translatable\";b:0;s:5:\"field\";b:1;s:8:\"required\";b:0;s:13:\"auto creation\";s:22:\"link_field_item_create\";s:13:\"property info\";a:3:{s:5:\"title\";a:4:{s:4:\"type\";s:4:\"text\";s:5:\"label\";s:22:\"The title of the link.\";s:15:\"setter callback\";s:28:\"entity_property_verbatim_set\";s:8:\"required\";b:0;}s:3:\"url\";a:4:{s:4:\"type\";s:3:\"uri\";s:5:\"label\";s:20:\"The URL of the link.\";s:15:\"setter callback\";s:28:\"entity_property_verbatim_set\";s:8:\"required\";b:1;}s:10:\"attributes\";a:4:{s:4:\"type\";s:6:\"struct\";s:5:\"label\";s:27:\"The attributes of the link.\";s:15:\"setter callback\";s:28:\"entity_property_verbatim_set\";s:15:\"getter callback\";s:27:\"link_attribute_property_get\";}}}}}}s:10:\"properties\";a:27:{s:3:\"nid\";a:4:{s:5:\"label\";s:7:\"Node ID\";s:4:\"type\";s:7:\"integer\";s:11:\"description\";s:26:\"The unique ID of the node.\";s:12:\"schema field\";s:3:\"nid\";}s:3:\"vid\";a:4:{s:5:\"label\";s:11:\"Revision ID\";s:4:\"type\";s:7:\"integer\";s:11:\"description\";s:37:\"The unique ID of the node\'s revision.\";s:12:\"schema field\";s:3:\"vid\";}s:6:\"is_new\";a:4:{s:5:\"label\";s:6:\"Is new\";s:4:\"type\";s:7:\"boolean\";s:11:\"description\";s:58:\"Whether the node is new and not saved to the database yet.\";s:15:\"getter callback\";s:35:\"entity_metadata_node_get_properties\";}s:4:\"type\";a:8:{s:5:\"label\";s:12:\"Content type\";s:4:\"type\";s:5:\"token\";s:11:\"description\";s:21:\"The type of the node.\";s:15:\"setter callback\";s:28:\"entity_property_verbatim_set\";s:17:\"setter permission\";s:16:\"administer nodes\";s:12:\"options list\";s:19:\"node_type_get_names\";s:8:\"required\";b:1;s:12:\"schema field\";s:4:\"type\";}s:5:\"title\";a:5:{s:5:\"label\";s:5:\"Title\";s:11:\"description\";s:22:\"The title of the node.\";s:15:\"setter callback\";s:28:\"entity_property_verbatim_set\";s:12:\"schema field\";s:5:\"title\";s:8:\"required\";b:1;}s:8:\"language\";a:7:{s:5:\"label\";s:8:\"Language\";s:4:\"type\";s:5:\"token\";s:11:\"description\";s:36:\"The language the node is written in.\";s:15:\"setter callback\";s:28:\"entity_property_verbatim_set\";s:12:\"options list\";s:29:\"entity_metadata_language_list\";s:12:\"schema field\";s:8:\"language\";s:17:\"setter permission\";s:16:\"administer nodes\";}s:3:\"url\";a:5:{s:5:\"label\";s:3:\"URL\";s:11:\"description\";s:20:\"The URL of the node.\";s:15:\"getter callback\";s:37:\"entity_metadata_entity_get_properties\";s:4:\"type\";s:3:\"uri\";s:8:\"computed\";b:1;}s:8:\"edit_url\";a:5:{s:5:\"label\";s:8:\"Edit URL\";s:11:\"description\";s:32:\"The URL of the node\'s edit page.\";s:15:\"getter callback\";s:35:\"entity_metadata_node_get_properties\";s:4:\"type\";s:3:\"uri\";s:8:\"computed\";b:1;}s:6:\"status\";a:7:{s:5:\"label\";s:6:\"Status\";s:11:\"description\";s:45:\"Whether the node is published or unpublished.\";s:4:\"type\";s:7:\"integer\";s:12:\"options list\";s:35:\"entity_metadata_status_options_list\";s:15:\"setter callback\";s:28:\"entity_property_verbatim_set\";s:17:\"setter permission\";s:16:\"administer nodes\";s:12:\"schema field\";s:6:\"status\";}s:7:\"promote\";a:6:{s:5:\"label\";s:21:\"Promoted to frontpage\";s:11:\"description\";s:46:\"Whether the node is promoted to the frontpage.\";s:15:\"setter callback\";s:28:\"entity_property_verbatim_set\";s:17:\"setter permission\";s:16:\"administer nodes\";s:12:\"schema field\";s:7:\"promote\";s:4:\"type\";s:7:\"boolean\";}s:6:\"sticky\";a:6:{s:5:\"label\";s:15:\"Sticky in lists\";s:11:\"description\";s:70:\"Whether the node is displayed at the top of lists in which it appears.\";s:15:\"setter callback\";s:28:\"entity_property_verbatim_set\";s:17:\"setter permission\";s:16:\"administer nodes\";s:12:\"schema field\";s:6:\"sticky\";s:4:\"type\";s:7:\"boolean\";}s:7:\"created\";a:6:{s:5:\"label\";s:12:\"Date created\";s:4:\"type\";s:4:\"date\";s:11:\"description\";s:29:\"The date the node was posted.\";s:15:\"setter callback\";s:28:\"entity_property_verbatim_set\";s:17:\"setter permission\";s:16:\"administer nodes\";s:12:\"schema field\";s:7:\"created\";}s:7:\"changed\";a:4:{s:5:\"label\";s:12:\"Date changed\";s:4:\"type\";s:4:\"date\";s:12:\"schema field\";s:7:\"changed\";s:11:\"description\";s:44:\"The date the node was most recently updated.\";}s:6:\"author\";a:8:{s:5:\"label\";s:6:\"Author\";s:4:\"type\";s:4:\"user\";s:11:\"description\";s:23:\"The author of the node.\";s:15:\"getter callback\";s:35:\"entity_metadata_node_get_properties\";s:15:\"setter callback\";s:28:\"entity_property_verbatim_set\";s:17:\"setter permission\";s:16:\"administer nodes\";s:8:\"required\";b:1;s:12:\"schema field\";s:3:\"uid\";}s:6:\"source\";a:4:{s:5:\"label\";s:23:\"Translation source node\";s:4:\"type\";s:4:\"node\";s:11:\"description\";s:58:\"The original-language version of this node, if one exists.\";s:15:\"getter callback\";s:35:\"entity_metadata_node_get_properties\";}s:3:\"log\";a:5:{s:5:\"label\";s:20:\"Revision log message\";s:4:\"type\";s:4:\"text\";s:11:\"description\";s:93:\"In case a new revision is to be saved, the log entry explaining the changes for this version.\";s:15:\"setter callback\";s:28:\"entity_property_verbatim_set\";s:15:\"access callback\";s:36:\"entity_metadata_node_revision_access\";}s:8:\"revision\";a:5:{s:5:\"label\";s:16:\"Creates revision\";s:4:\"type\";s:7:\"boolean\";s:11:\"description\";s:48:\"Whether saving this node creates a new revision.\";s:15:\"setter callback\";s:28:\"entity_property_verbatim_set\";s:15:\"access callback\";s:36:\"entity_metadata_node_revision_access\";}s:4:\"book\";a:4:{s:5:\"label\";s:4:\"Book\";s:4:\"type\";s:4:\"node\";s:11:\"description\";s:60:\"If part of a book, the book to which this book page belongs.\";s:15:\"getter callback\";s:35:\"entity_metadata_book_get_properties\";}s:14:\"book_ancestors\";a:5:{s:5:\"label\";s:14:\"Book ancestors\";s:4:\"type\";s:10:\"list<node>\";s:8:\"computed\";b:1;s:11:\"description\";s:74:\"If part of a book, a list of all book pages upwards in the book hierarchy.\";s:15:\"getter callback\";s:35:\"entity_metadata_book_get_properties\";}s:7:\"comment\";a:5:{s:5:\"label\";s:16:\"Comments allowed\";s:11:\"description\";s:97:\"Whether comments are allowed on this node: 0 = no, 1 = closed (read only), 2 = open (read/write).\";s:15:\"setter callback\";s:28:\"entity_property_verbatim_set\";s:17:\"setter permission\";s:19:\"administer comments\";s:4:\"type\";s:7:\"integer\";}s:8:\"comments\";a:5:{s:5:\"label\";s:8:\"Comments\";s:4:\"type\";s:13:\"list<comment>\";s:11:\"description\";s:18:\"The node comments.\";s:15:\"getter callback\";s:43:\"entity_metadata_comment_get_node_properties\";s:8:\"computed\";b:1;}s:13:\"comment_count\";a:4:{s:5:\"label\";s:13:\"Comment count\";s:11:\"description\";s:40:\"The number of comments posted on a node.\";s:15:\"getter callback\";s:43:\"entity_metadata_comment_get_node_properties\";s:4:\"type\";s:7:\"integer\";}s:17:\"comment_count_new\";a:4:{s:5:\"label\";s:17:\"New comment count\";s:11:\"description\";s:72:\"The number of comments posted on a node since the reader last viewed it.\";s:15:\"getter callback\";s:43:\"entity_metadata_comment_get_node_properties\";s:4:\"type\";s:7:\"integer\";}s:4:\"body\";a:7:{s:4:\"type\";s:14:\"text_formatted\";s:5:\"label\";s:18:\"The main body text\";s:15:\"getter callback\";s:34:\"entity_metadata_field_verbatim_get\";s:15:\"setter callback\";s:34:\"entity_metadata_field_verbatim_set\";s:13:\"property info\";a:3:{s:5:\"value\";a:7:{s:4:\"type\";s:4:\"text\";s:5:\"label\";s:4:\"Text\";s:9:\"sanitized\";b:1;s:15:\"getter callback\";s:30:\"entity_metadata_field_text_get\";s:15:\"setter callback\";s:28:\"entity_property_verbatim_set\";s:17:\"setter permission\";s:16:\"administer nodes\";s:19:\"raw getter callback\";s:28:\"entity_property_verbatim_get\";}s:7:\"summary\";a:7:{s:4:\"type\";s:4:\"text\";s:5:\"label\";s:7:\"Summary\";s:9:\"sanitized\";b:1;s:15:\"getter callback\";s:30:\"entity_metadata_field_text_get\";s:15:\"setter callback\";s:28:\"entity_property_verbatim_set\";s:17:\"setter permission\";s:16:\"administer nodes\";s:19:\"raw getter callback\";s:28:\"entity_property_verbatim_get\";}s:6:\"format\";a:6:{s:4:\"type\";s:5:\"token\";s:5:\"label\";s:11:\"Text format\";s:12:\"options list\";s:34:\"entity_metadata_field_text_formats\";s:15:\"getter callback\";s:28:\"entity_property_verbatim_get\";s:15:\"setter callback\";s:28:\"entity_property_verbatim_set\";s:18:\"setter permissions\";s:18:\"administer filters\";}}s:13:\"auto creation\";s:28:\"entity_property_create_array\";s:5:\"field\";b:1;}s:5:\"views\";a:6:{s:5:\"label\";s:15:\"Number of views\";s:11:\"description\";s:46:\"The number of visitors who have read the node.\";s:4:\"type\";s:7:\"integer\";s:15:\"getter callback\";s:46:\"entity_metadata_statistics_node_get_properties\";s:8:\"computed\";b:1;s:15:\"access callback\";s:44:\"entity_metadata_statistics_properties_access\";}s:9:\"day_views\";a:6:{s:5:\"label\";s:11:\"Views today\";s:11:\"description\";s:52:\"The number of visitors who have read the node today.\";s:4:\"type\";s:7:\"integer\";s:15:\"getter callback\";s:46:\"entity_metadata_statistics_node_get_properties\";s:8:\"computed\";b:1;s:15:\"access callback\";s:44:\"entity_metadata_statistics_properties_access\";}s:9:\"last_view\";a:6:{s:5:\"label\";s:9:\"Last view\";s:11:\"description\";s:47:\"The date on which a visitor last read the node.\";s:4:\"type\";s:4:\"date\";s:15:\"getter callback\";s:46:\"entity_metadata_statistics_node_get_properties\";s:8:\"computed\";b:1;s:15:\"access callback\";s:44:\"entity_metadata_statistics_properties_access\";}}}s:13:\"taxonomy_term\";a:1:{s:10:\"properties\";a:9:{s:3:\"tid\";a:4:{s:5:\"label\";s:7:\"Term ID\";s:11:\"description\";s:35:\"The unique ID of the taxonomy term.\";s:4:\"type\";s:7:\"integer\";s:12:\"schema field\";s:3:\"tid\";}s:4:\"name\";a:5:{s:5:\"label\";s:4:\"Name\";s:11:\"description\";s:30:\"The name of the taxonomy term.\";s:15:\"setter callback\";s:28:\"entity_property_verbatim_set\";s:8:\"required\";b:1;s:12:\"schema field\";s:4:\"name\";}s:11:\"description\";a:7:{s:5:\"label\";s:11:\"Description\";s:11:\"description\";s:46:\"The optional description of the taxonomy term.\";s:9:\"sanitized\";b:1;s:19:\"raw getter callback\";s:28:\"entity_property_verbatim_get\";s:15:\"getter callback\";s:44:\"entity_metadata_taxonomy_term_get_properties\";s:15:\"setter callback\";s:28:\"entity_property_verbatim_set\";s:12:\"schema field\";s:11:\"description\";}s:6:\"weight\";a:5:{s:5:\"label\";s:6:\"Weight\";s:4:\"type\";s:7:\"integer\";s:11:\"description\";s:72:\"The weight of the term, which is used for ordering terms during display.\";s:15:\"setter callback\";s:28:\"entity_property_verbatim_set\";s:12:\"schema field\";s:6:\"weight\";}s:10:\"node_count\";a:5:{s:5:\"label\";s:10:\"Node count\";s:4:\"type\";s:7:\"integer\";s:11:\"description\";s:50:\"The number of nodes tagged with the taxonomy term.\";s:15:\"getter callback\";s:44:\"entity_metadata_taxonomy_term_get_properties\";s:8:\"computed\";b:1;}s:3:\"url\";a:5:{s:5:\"label\";s:3:\"URL\";s:11:\"description\";s:29:\"The URL of the taxonomy term.\";s:15:\"getter callback\";s:37:\"entity_metadata_entity_get_properties\";s:4:\"type\";s:3:\"uri\";s:8:\"computed\";b:1;}s:10:\"vocabulary\";a:6:{s:5:\"label\";s:10:\"Vocabulary\";s:11:\"description\";s:44:\"The vocabulary the taxonomy term belongs to.\";s:15:\"setter callback\";s:36:\"entity_metadata_taxonomy_term_setter\";s:4:\"type\";s:19:\"taxonomy_vocabulary\";s:8:\"required\";b:1;s:12:\"schema field\";s:3:\"vid\";}s:6:\"parent\";a:5:{s:5:\"label\";s:12:\"Parent terms\";s:11:\"description\";s:38:\"The parent terms of the taxonomy term.\";s:15:\"getter callback\";s:44:\"entity_metadata_taxonomy_term_get_properties\";s:15:\"setter callback\";s:36:\"entity_metadata_taxonomy_term_setter\";s:4:\"type\";s:19:\"list<taxonomy_term>\";}s:11:\"parents_all\";a:5:{s:5:\"label\";s:16:\"All parent terms\";s:11:\"description\";s:65:\"Ancestors of the term, i.e. parent of all above hierarchy levels.\";s:15:\"getter callback\";s:44:\"entity_metadata_taxonomy_term_get_properties\";s:4:\"type\";s:19:\"list<taxonomy_term>\";s:8:\"computed\";b:1;}}}s:19:\"taxonomy_vocabulary\";a:1:{s:10:\"properties\";a:5:{s:3:\"vid\";a:4:{s:5:\"label\";s:13:\"Vocabulary ID\";s:11:\"description\";s:41:\"The unique ID of the taxonomy vocabulary.\";s:4:\"type\";s:7:\"integer\";s:12:\"schema field\";s:3:\"vid\";}s:4:\"name\";a:5:{s:5:\"label\";s:4:\"Name\";s:11:\"description\";s:36:\"The name of the taxonomy vocabulary.\";s:15:\"setter callback\";s:28:\"entity_property_verbatim_set\";s:8:\"required\";b:1;s:12:\"schema field\";s:4:\"name\";}s:12:\"machine_name\";a:6:{s:5:\"label\";s:12:\"Machine name\";s:4:\"type\";s:5:\"token\";s:11:\"description\";s:44:\"The machine name of the taxonomy vocabulary.\";s:15:\"setter callback\";s:28:\"entity_property_verbatim_set\";s:8:\"required\";b:1;s:12:\"schema field\";s:12:\"machine_name\";}s:11:\"description\";a:5:{s:5:\"label\";s:11:\"Description\";s:11:\"description\";s:52:\"The optional description of the taxonomy vocabulary.\";s:15:\"setter callback\";s:28:\"entity_property_verbatim_set\";s:8:\"sanitize\";s:10:\"filter_xss\";s:12:\"schema field\";s:11:\"description\";}s:10:\"term_count\";a:5:{s:5:\"label\";s:10:\"Term count\";s:4:\"type\";s:7:\"integer\";s:11:\"description\";s:57:\"The number of terms belonging to the taxonomy vocabulary.\";s:15:\"getter callback\";s:50:\"entity_metadata_taxonomy_vocabulary_get_properties\";s:8:\"computed\";b:1;}}}s:4:\"user\";a:1:{s:10:\"properties\";a:12:{s:3:\"uid\";a:4:{s:5:\"label\";s:7:\"User ID\";s:4:\"type\";s:7:\"integer\";s:11:\"description\";s:34:\"The unique ID of the user account.\";s:12:\"schema field\";s:3:\"uid\";}s:4:\"name\";a:8:{s:5:\"label\";s:4:\"Name\";s:11:\"description\";s:35:\"The login name of the user account.\";s:15:\"getter callback\";s:35:\"entity_metadata_user_get_properties\";s:15:\"setter callback\";s:28:\"entity_property_verbatim_set\";s:8:\"sanitize\";s:10:\"filter_xss\";s:8:\"required\";b:1;s:15:\"access callback\";s:38:\"entity_metadata_user_properties_access\";s:12:\"schema field\";s:4:\"name\";}s:4:\"mail\";a:7:{s:5:\"label\";s:5:\"Email\";s:11:\"description\";s:38:\"The email address of the user account.\";s:15:\"setter callback\";s:28:\"entity_property_verbatim_set\";s:19:\"validation callback\";s:19:\"valid_email_address\";s:8:\"required\";b:1;s:15:\"access callback\";s:38:\"entity_metadata_user_properties_access\";s:12:\"schema field\";s:4:\"mail\";}s:3:\"url\";a:5:{s:5:\"label\";s:3:\"URL\";s:11:\"description\";s:36:\"The URL of the account profile page.\";s:15:\"getter callback\";s:35:\"entity_metadata_user_get_properties\";s:4:\"type\";s:3:\"uri\";s:8:\"computed\";b:1;}s:8:\"edit_url\";a:5:{s:5:\"label\";s:8:\"Edit URL\";s:11:\"description\";s:33:\"The url of the account edit page.\";s:15:\"getter callback\";s:35:\"entity_metadata_user_get_properties\";s:4:\"type\";s:3:\"uri\";s:8:\"computed\";b:1;}s:11:\"last_access\";a:6:{s:5:\"label\";s:11:\"Last access\";s:11:\"description\";s:41:\"The date the user last accessed the site.\";s:15:\"getter callback\";s:35:\"entity_metadata_user_get_properties\";s:4:\"type\";s:4:\"date\";s:15:\"access callback\";s:38:\"entity_metadata_user_properties_access\";s:12:\"schema field\";s:6:\"access\";}s:10:\"last_login\";a:6:{s:5:\"label\";s:10:\"Last login\";s:11:\"description\";s:45:\"The date the user last logged in to the site.\";s:15:\"getter callback\";s:35:\"entity_metadata_user_get_properties\";s:4:\"type\";s:4:\"date\";s:15:\"access callback\";s:38:\"entity_metadata_user_properties_access\";s:12:\"schema field\";s:5:\"login\";}s:7:\"created\";a:5:{s:5:\"label\";s:7:\"Created\";s:11:\"description\";s:38:\"The date the user account was created.\";s:4:\"type\";s:4:\"date\";s:12:\"schema field\";s:7:\"created\";s:17:\"setter permission\";s:16:\"administer users\";}s:5:\"roles\";a:7:{s:5:\"label\";s:10:\"User roles\";s:11:\"description\";s:22:\"The roles of the user.\";s:4:\"type\";s:13:\"list<integer>\";s:15:\"getter callback\";s:35:\"entity_metadata_user_get_properties\";s:15:\"setter callback\";s:35:\"entity_metadata_user_set_properties\";s:12:\"options list\";s:26:\"entity_metadata_user_roles\";s:15:\"access callback\";s:38:\"entity_metadata_user_properties_access\";}s:6:\"status\";a:7:{s:5:\"label\";s:6:\"Status\";s:11:\"description\";s:38:\"Whether the user is active or blocked.\";s:15:\"setter callback\";s:28:\"entity_property_verbatim_set\";s:4:\"type\";s:7:\"integer\";s:12:\"options list\";s:40:\"entity_metadata_user_status_options_list\";s:15:\"access callback\";s:38:\"entity_metadata_user_properties_access\";s:12:\"schema field\";s:6:\"status\";}s:5:\"theme\";a:6:{s:5:\"label\";s:13:\"Default theme\";s:11:\"description\";s:25:\"The user\'s default theme.\";s:15:\"getter callback\";s:35:\"entity_metadata_user_get_properties\";s:15:\"setter callback\";s:28:\"entity_property_verbatim_set\";s:15:\"access callback\";s:38:\"entity_metadata_user_properties_access\";s:12:\"schema field\";s:5:\"theme\";}s:8:\"language\";a:8:{s:5:\"label\";s:8:\"Language\";s:11:\"description\";s:90:\"This account\'s default language for e-mails, and preferred language for site presentation.\";s:4:\"type\";s:5:\"token\";s:15:\"getter callback\";s:40:\"entity_metadata_locale_get_user_language\";s:15:\"setter callback\";s:28:\"entity_property_verbatim_set\";s:12:\"options list\";s:29:\"entity_metadata_language_list\";s:12:\"schema field\";s:8:\"language\";s:17:\"setter permission\";s:16:\"administer users\";}}}s:4:\"site\";a:1:{s:10:\"properties\";a:8:{s:4:\"name\";a:4:{s:5:\"label\";s:4:\"Name\";s:11:\"description\";s:21:\"The name of the site.\";s:15:\"getter callback\";s:37:\"entity_metadata_system_get_properties\";s:8:\"sanitize\";s:11:\"check_plain\";}s:6:\"slogan\";a:4:{s:5:\"label\";s:6:\"Slogan\";s:11:\"description\";s:23:\"The slogan of the site.\";s:15:\"getter callback\";s:37:\"entity_metadata_system_get_properties\";s:8:\"sanitize\";s:11:\"check_plain\";}s:4:\"mail\";a:3:{s:5:\"label\";s:5:\"Email\";s:11:\"description\";s:46:\"The administrative email address for the site.\";s:15:\"getter callback\";s:37:\"entity_metadata_system_get_properties\";}s:3:\"url\";a:4:{s:5:\"label\";s:3:\"URL\";s:11:\"description\";s:33:\"The URL of the site\'s front page.\";s:15:\"getter callback\";s:37:\"entity_metadata_system_get_properties\";s:4:\"type\";s:3:\"uri\";}s:9:\"login_url\";a:4:{s:5:\"label\";s:10:\"Login page\";s:11:\"description\";s:33:\"The URL of the site\'s login page.\";s:15:\"getter callback\";s:37:\"entity_metadata_system_get_properties\";s:4:\"type\";s:3:\"uri\";}s:12:\"current_user\";a:4:{s:5:\"label\";s:14:\"Logged in user\";s:11:\"description\";s:29:\"The currently logged in user.\";s:15:\"getter callback\";s:37:\"entity_metadata_system_get_properties\";s:4:\"type\";s:4:\"user\";}s:12:\"current_date\";a:4:{s:5:\"label\";s:12:\"Current date\";s:11:\"description\";s:26:\"The current date and time.\";s:15:\"getter callback\";s:37:\"entity_metadata_system_get_properties\";s:4:\"type\";s:4:\"date\";}s:12:\"current_page\";a:5:{s:5:\"label\";s:12:\"Current page\";s:11:\"description\";s:48:\"Information related to the current page request.\";s:15:\"getter callback\";s:37:\"entity_metadata_system_get_properties\";s:4:\"type\";s:6:\"struct\";s:13:\"property info\";a:4:{s:4:\"path\";a:4:{s:5:\"label\";s:4:\"Path\";s:11:\"description\";s:53:\"The internal Drupal path of the current page request.\";s:15:\"getter callback\";s:12:\"current_path\";s:4:\"type\";s:4:\"text\";}s:3:\"url\";a:4:{s:5:\"label\";s:3:\"URL\";s:11:\"description\";s:41:\"The full URL of the current page request.\";s:15:\"getter callback\";s:42:\"entity_metadata_system_get_page_properties\";s:4:\"type\";s:3:\"uri\";}s:8:\"language\";a:5:{s:5:\"label\";s:18:\"Interface language\";s:11:\"description\";s:57:\"The language code of the current user interface language.\";s:4:\"type\";s:5:\"token\";s:15:\"getter callback\";s:36:\"entity_metadata_locale_get_languages\";s:12:\"options list\";s:29:\"entity_metadata_language_list\";}s:16:\"language_content\";a:5:{s:5:\"label\";s:16:\"Content language\";s:11:\"description\";s:50:\"The language code of the current content language.\";s:4:\"type\";s:5:\"token\";s:15:\"getter callback\";s:36:\"entity_metadata_locale_get_languages\";s:12:\"options list\";s:29:\"entity_metadata_language_list\";}}}}}s:4:\"file\";a:1:{s:10:\"properties\";a:7:{s:3:\"fid\";a:5:{s:5:\"label\";s:7:\"File ID\";s:11:\"description\";s:35:\"The unique ID of the uploaded file.\";s:4:\"type\";s:7:\"integer\";s:19:\"validation callback\";s:41:\"entity_metadata_validate_integer_positive\";s:12:\"schema field\";s:3:\"fid\";}s:4:\"name\";a:4:{s:5:\"label\";s:9:\"File name\";s:11:\"description\";s:29:\"The name of the file on disk.\";s:15:\"getter callback\";s:42:\"entity_metadata_system_get_file_properties\";s:12:\"schema field\";s:8:\"filename\";}s:4:\"mime\";a:5:{s:5:\"label\";s:9:\"MIME type\";s:11:\"description\";s:26:\"The MIME type of the file.\";s:15:\"getter callback\";s:42:\"entity_metadata_system_get_file_properties\";s:8:\"sanitize\";s:10:\"filter_xss\";s:12:\"schema field\";s:8:\"filemime\";}s:4:\"size\";a:5:{s:5:\"label\";s:9:\"File size\";s:11:\"description\";s:35:\"The size of the file, in kilobytes.\";s:15:\"getter callback\";s:42:\"entity_metadata_system_get_file_properties\";s:4:\"type\";s:7:\"integer\";s:12:\"schema field\";s:8:\"filesize\";}s:3:\"url\";a:3:{s:5:\"label\";s:3:\"URL\";s:11:\"description\";s:36:\"The web-accessible URL for the file.\";s:15:\"getter callback\";s:42:\"entity_metadata_system_get_file_properties\";}s:9:\"timestamp\";a:4:{s:5:\"label\";s:9:\"Timestamp\";s:11:\"description\";s:44:\"The date the file was most recently changed.\";s:4:\"type\";s:4:\"date\";s:12:\"schema field\";s:9:\"timestamp\";}s:5:\"owner\";a:5:{s:5:\"label\";s:5:\"Owner\";s:11:\"description\";s:42:\"The user who originally uploaded the file.\";s:4:\"type\";s:4:\"user\";s:15:\"getter callback\";s:42:\"entity_metadata_system_get_file_properties\";s:12:\"schema field\";s:3:\"uid\";}}}}',0,1512620340,1),('filter_formats:en','a:4:{s:13:\"filtered_html\";O:8:\"stdClass\":5:{s:6:\"format\";s:13:\"filtered_html\";s:4:\"name\";s:13:\"Filtered HTML\";s:5:\"cache\";s:1:\"1\";s:6:\"status\";s:1:\"1\";s:6:\"weight\";s:1:\"0\";}s:9:\"full_html\";O:8:\"stdClass\":5:{s:6:\"format\";s:9:\"full_html\";s:4:\"name\";s:9:\"Full HTML\";s:5:\"cache\";s:1:\"1\";s:6:\"status\";s:1:\"1\";s:6:\"weight\";s:1:\"1\";}s:10:\"plain_text\";O:8:\"stdClass\":5:{s:6:\"format\";s:10:\"plain_text\";s:4:\"name\";s:10:\"Plain text\";s:5:\"cache\";s:1:\"1\";s:6:\"status\";s:1:\"1\";s:6:\"weight\";s:2:\"10\";}s:8:\"php_code\";O:8:\"stdClass\":5:{s:6:\"format\";s:8:\"php_code\";s:4:\"name\";s:8:\"PHP code\";s:5:\"cache\";s:1:\"0\";s:6:\"status\";s:1:\"1\";s:6:\"weight\";s:2:\"11\";}}',0,1512620340,1),('filter_list_format','a:4:{s:8:\"php_code\";a:9:{s:11:\"filter_html\";O:8:\"stdClass\":6:{s:6:\"format\";s:8:\"php_code\";s:6:\"module\";s:6:\"filter\";s:4:\"name\";s:11:\"filter_html\";s:6:\"weight\";s:3:\"-10\";s:6:\"status\";s:1:\"0\";s:8:\"settings\";s:168:\"a:3:{s:12:\"allowed_html\";s:74:\"<a> <em> <strong> <cite> <blockquote> <code> <ul> <ol> <li> <dl> <dt> <dd>\";s:16:\"filter_html_help\";i:1;s:20:\"filter_html_nofollow\";i:0;}\";}s:18:\"filter_html_escape\";O:8:\"stdClass\":6:{s:6:\"format\";s:8:\"php_code\";s:6:\"module\";s:6:\"filter\";s:4:\"name\";s:18:\"filter_html_escape\";s:6:\"weight\";s:3:\"-10\";s:6:\"status\";s:1:\"0\";s:8:\"settings\";s:6:\"a:0:{}\";}s:9:\"faq_embed\";O:8:\"stdClass\":6:{s:6:\"format\";s:8:\"php_code\";s:6:\"module\";s:3:\"faq\";s:4:\"name\";s:9:\"faq_embed\";s:6:\"weight\";s:1:\"0\";s:6:\"status\";s:1:\"0\";s:8:\"settings\";s:6:\"a:0:{}\";}s:12:\"filter_autop\";O:8:\"stdClass\":6:{s:6:\"format\";s:8:\"php_code\";s:6:\"module\";s:6:\"filter\";s:4:\"name\";s:12:\"filter_autop\";s:6:\"weight\";s:1:\"0\";s:6:\"status\";s:1:\"0\";s:8:\"settings\";s:6:\"a:0:{}\";}s:10:\"filter_url\";O:8:\"stdClass\":6:{s:6:\"format\";s:8:\"php_code\";s:6:\"module\";s:6:\"filter\";s:4:\"name\";s:10:\"filter_url\";s:6:\"weight\";s:1:\"0\";s:6:\"status\";s:1:\"0\";s:8:\"settings\";s:36:\"a:1:{s:17:\"filter_url_length\";i:72;}\";}s:8:\"php_code\";O:8:\"stdClass\":6:{s:6:\"format\";s:8:\"php_code\";s:6:\"module\";s:3:\"php\";s:4:\"name\";s:8:\"php_code\";s:6:\"weight\";s:1:\"0\";s:6:\"status\";s:1:\"1\";s:8:\"settings\";s:6:\"a:0:{}\";}s:9:\"shortcode\";O:8:\"stdClass\":6:{s:6:\"format\";s:8:\"php_code\";s:6:\"module\";s:9:\"shortcode\";s:4:\"name\";s:9:\"shortcode\";s:6:\"weight\";s:1:\"0\";s:6:\"status\";s:1:\"0\";s:8:\"settings\";s:6:\"a:0:{}\";}s:24:\"shortcode_text_corrector\";O:8:\"stdClass\":6:{s:6:\"format\";s:8:\"php_code\";s:6:\"module\";s:9:\"shortcode\";s:4:\"name\";s:24:\"shortcode_text_corrector\";s:6:\"weight\";s:1:\"0\";s:6:\"status\";s:1:\"0\";s:8:\"settings\";s:6:\"a:0:{}\";}s:20:\"filter_htmlcorrector\";O:8:\"stdClass\":6:{s:6:\"format\";s:8:\"php_code\";s:6:\"module\";s:6:\"filter\";s:4:\"name\";s:20:\"filter_htmlcorrector\";s:6:\"weight\";s:2:\"10\";s:6:\"status\";s:1:\"0\";s:8:\"settings\";s:6:\"a:0:{}\";}}s:9:\"full_html\";a:8:{s:11:\"filter_html\";O:8:\"stdClass\":6:{s:6:\"format\";s:9:\"full_html\";s:6:\"module\";s:6:\"filter\";s:4:\"name\";s:11:\"filter_html\";s:6:\"weight\";s:3:\"-10\";s:6:\"status\";s:1:\"0\";s:8:\"settings\";s:168:\"a:3:{s:12:\"allowed_html\";s:74:\"<a> <em> <strong> <cite> <blockquote> <code> <ul> <ol> <li> <dl> <dt> <dd>\";s:16:\"filter_html_help\";i:1;s:20:\"filter_html_nofollow\";i:0;}\";}s:18:\"filter_html_escape\";O:8:\"stdClass\":6:{s:6:\"format\";s:9:\"full_html\";s:6:\"module\";s:6:\"filter\";s:4:\"name\";s:18:\"filter_html_escape\";s:6:\"weight\";s:3:\"-10\";s:6:\"status\";s:1:\"0\";s:8:\"settings\";s:6:\"a:0:{}\";}s:9:\"faq_embed\";O:8:\"stdClass\":6:{s:6:\"format\";s:9:\"full_html\";s:6:\"module\";s:3:\"faq\";s:4:\"name\";s:9:\"faq_embed\";s:6:\"weight\";s:1:\"0\";s:6:\"status\";s:1:\"0\";s:8:\"settings\";s:6:\"a:0:{}\";}s:10:\"filter_url\";O:8:\"stdClass\":6:{s:6:\"format\";s:9:\"full_html\";s:6:\"module\";s:6:\"filter\";s:4:\"name\";s:10:\"filter_url\";s:6:\"weight\";s:1:\"0\";s:6:\"status\";s:1:\"1\";s:8:\"settings\";s:40:\"a:1:{s:17:\"filter_url_length\";s:2:\"72\";}\";}s:9:\"shortcode\";O:8:\"stdClass\":6:{s:6:\"format\";s:9:\"full_html\";s:6:\"module\";s:9:\"shortcode\";s:4:\"name\";s:9:\"shortcode\";s:6:\"weight\";s:1:\"0\";s:6:\"status\";s:1:\"1\";s:8:\"settings\";s:233:\"a:13:{s:5:\"quote\";i:1;s:3:\"img\";i:1;s:9:\"highlight\";i:1;s:6:\"button\";i:1;s:7:\"dropcap\";i:1;s:4:\"item\";i:1;s:5:\"clear\";i:1;s:4:\"link\";i:1;s:6:\"random\";i:1;s:13:\"embed_content\";i:1;s:5:\"video\";i:1;s:7:\"tooltip\";i:1;s:8:\"collapse\";i:1;}\";}s:24:\"shortcode_text_corrector\";O:8:\"stdClass\":6:{s:6:\"format\";s:9:\"full_html\";s:6:\"module\";s:9:\"shortcode\";s:4:\"name\";s:24:\"shortcode_text_corrector\";s:6:\"weight\";s:1:\"0\";s:6:\"status\";s:1:\"0\";s:8:\"settings\";s:6:\"a:0:{}\";}s:12:\"filter_autop\";O:8:\"stdClass\":6:{s:6:\"format\";s:9:\"full_html\";s:6:\"module\";s:6:\"filter\";s:4:\"name\";s:12:\"filter_autop\";s:6:\"weight\";s:1:\"1\";s:6:\"status\";s:1:\"1\";s:8:\"settings\";s:6:\"a:0:{}\";}s:20:\"filter_htmlcorrector\";O:8:\"stdClass\":6:{s:6:\"format\";s:9:\"full_html\";s:6:\"module\";s:6:\"filter\";s:4:\"name\";s:20:\"filter_htmlcorrector\";s:6:\"weight\";s:2:\"10\";s:6:\"status\";s:1:\"1\";s:8:\"settings\";s:6:\"a:0:{}\";}}s:10:\"plain_text\";a:5:{s:11:\"filter_html\";O:8:\"stdClass\":6:{s:6:\"format\";s:10:\"plain_text\";s:6:\"module\";s:6:\"filter\";s:4:\"name\";s:11:\"filter_html\";s:6:\"weight\";s:3:\"-10\";s:6:\"status\";s:1:\"0\";s:8:\"settings\";s:168:\"a:3:{s:12:\"allowed_html\";s:74:\"<a> <em> <strong> <cite> <blockquote> <code> <ul> <ol> <li> <dl> <dt> <dd>\";s:16:\"filter_html_help\";i:1;s:20:\"filter_html_nofollow\";i:0;}\";}s:18:\"filter_html_escape\";O:8:\"stdClass\":6:{s:6:\"format\";s:10:\"plain_text\";s:6:\"module\";s:6:\"filter\";s:4:\"name\";s:18:\"filter_html_escape\";s:6:\"weight\";s:1:\"0\";s:6:\"status\";s:1:\"1\";s:8:\"settings\";s:6:\"a:0:{}\";}s:10:\"filter_url\";O:8:\"stdClass\":6:{s:6:\"format\";s:10:\"plain_text\";s:6:\"module\";s:6:\"filter\";s:4:\"name\";s:10:\"filter_url\";s:6:\"weight\";s:1:\"1\";s:6:\"status\";s:1:\"1\";s:8:\"settings\";s:36:\"a:1:{s:17:\"filter_url_length\";i:72;}\";}s:12:\"filter_autop\";O:8:\"stdClass\":6:{s:6:\"format\";s:10:\"plain_text\";s:6:\"module\";s:6:\"filter\";s:4:\"name\";s:12:\"filter_autop\";s:6:\"weight\";s:1:\"2\";s:6:\"status\";s:1:\"1\";s:8:\"settings\";s:6:\"a:0:{}\";}s:20:\"filter_htmlcorrector\";O:8:\"stdClass\":6:{s:6:\"format\";s:10:\"plain_text\";s:6:\"module\";s:6:\"filter\";s:4:\"name\";s:20:\"filter_htmlcorrector\";s:6:\"weight\";s:2:\"10\";s:6:\"status\";s:1:\"0\";s:8:\"settings\";s:6:\"a:0:{}\";}}s:13:\"filtered_html\";a:10:{s:18:\"filter_html_escape\";O:8:\"stdClass\":6:{s:6:\"format\";s:13:\"filtered_html\";s:6:\"module\";s:6:\"filter\";s:4:\"name\";s:18:\"filter_html_escape\";s:6:\"weight\";s:3:\"-10\";s:6:\"status\";s:1:\"0\";s:8:\"settings\";s:6:\"a:0:{}\";}s:9:\"faq_embed\";O:8:\"stdClass\":6:{s:6:\"format\";s:13:\"filtered_html\";s:6:\"module\";s:3:\"faq\";s:4:\"name\";s:9:\"faq_embed\";s:6:\"weight\";s:1:\"0\";s:6:\"status\";s:1:\"0\";s:8:\"settings\";s:6:\"a:0:{}\";}s:10:\"filter_url\";O:8:\"stdClass\":6:{s:6:\"format\";s:13:\"filtered_html\";s:6:\"module\";s:6:\"filter\";s:4:\"name\";s:10:\"filter_url\";s:6:\"weight\";s:1:\"0\";s:6:\"status\";s:1:\"1\";s:8:\"settings\";s:40:\"a:1:{s:17:\"filter_url_length\";s:2:\"72\";}\";}s:8:\"php_code\";O:8:\"stdClass\":6:{s:6:\"format\";s:13:\"filtered_html\";s:6:\"module\";s:3:\"php\";s:4:\"name\";s:8:\"php_code\";s:6:\"weight\";s:1:\"0\";s:6:\"status\";s:1:\"0\";s:8:\"settings\";s:6:\"a:0:{}\";}s:9:\"shortcode\";O:8:\"stdClass\":6:{s:6:\"format\";s:13:\"filtered_html\";s:6:\"module\";s:9:\"shortcode\";s:4:\"name\";s:9:\"shortcode\";s:6:\"weight\";s:1:\"0\";s:6:\"status\";s:1:\"0\";s:8:\"settings\";s:233:\"a:13:{s:5:\"quote\";i:0;s:3:\"img\";i:0;s:9:\"highlight\";i:0;s:6:\"button\";i:0;s:7:\"dropcap\";i:0;s:4:\"item\";i:0;s:5:\"clear\";i:0;s:4:\"link\";i:0;s:6:\"random\";i:0;s:13:\"embed_content\";i:0;s:5:\"video\";i:0;s:7:\"tooltip\";i:0;s:8:\"collapse\";i:0;}\";}s:24:\"shortcode_text_corrector\";O:8:\"stdClass\":6:{s:6:\"format\";s:13:\"filtered_html\";s:6:\"module\";s:9:\"shortcode\";s:4:\"name\";s:24:\"shortcode_text_corrector\";s:6:\"weight\";s:1:\"0\";s:6:\"status\";s:1:\"0\";s:8:\"settings\";s:6:\"a:0:{}\";}s:17:\"video_embed_field\";O:8:\"stdClass\":6:{s:6:\"format\";s:13:\"filtered_html\";s:6:\"module\";s:17:\"video_embed_field\";s:4:\"name\";s:17:\"video_embed_field\";s:6:\"weight\";s:1:\"0\";s:6:\"status\";s:1:\"0\";s:8:\"settings\";s:6:\"a:0:{}\";}s:11:\"filter_html\";O:8:\"stdClass\":6:{s:6:\"format\";s:13:\"filtered_html\";s:6:\"module\";s:6:\"filter\";s:4:\"name\";s:11:\"filter_html\";s:6:\"weight\";s:1:\"1\";s:6:\"status\";s:1:\"1\";s:8:\"settings\";s:205:\"a:3:{s:12:\"allowed_html\";s:110:\"<a> <em> <strong> <cite> <blockquote> <code> <ul> <ol> <li> <dl> <dt> <dd> <footer> <cite> <h1> <h2> <h3> <h4>\";s:16:\"filter_html_help\";i:1;s:20:\"filter_html_nofollow\";i:0;}\";}s:12:\"filter_autop\";O:8:\"stdClass\":6:{s:6:\"format\";s:13:\"filtered_html\";s:6:\"module\";s:6:\"filter\";s:4:\"name\";s:12:\"filter_autop\";s:6:\"weight\";s:1:\"2\";s:6:\"status\";s:1:\"1\";s:8:\"settings\";s:6:\"a:0:{}\";}s:20:\"filter_htmlcorrector\";O:8:\"stdClass\":6:{s:6:\"format\";s:13:\"filtered_html\";s:6:\"module\";s:6:\"filter\";s:4:\"name\";s:20:\"filter_htmlcorrector\";s:6:\"weight\";s:2:\"10\";s:6:\"status\";s:1:\"1\";s:8:\"settings\";s:6:\"a:0:{}\";}}}',0,1512620340,1),('image_effects:en','a:6:{s:10:\"image_crop\";a:9:{s:5:\"label\";s:4:\"Crop\";s:4:\"help\";s:78:\"Cropping will remove portions of an image to make it the specified dimensions.\";s:15:\"effect callback\";s:17:\"image_crop_effect\";s:19:\"dimensions callback\";s:23:\"image_resize_dimensions\";s:13:\"form callback\";s:15:\"image_crop_form\";s:13:\"summary theme\";s:18:\"image_crop_summary\";s:6:\"module\";s:5:\"image\";s:4:\"name\";s:10:\"image_crop\";s:4:\"data\";a:0:{}}s:16:\"image_desaturate\";a:7:{s:5:\"label\";s:10:\"Desaturate\";s:4:\"help\";s:42:\"Desaturate converts an image to grayscale.\";s:15:\"effect callback\";s:23:\"image_desaturate_effect\";s:22:\"dimensions passthrough\";b:1;s:6:\"module\";s:5:\"image\";s:4:\"name\";s:16:\"image_desaturate\";s:4:\"data\";a:0:{}}s:12:\"image_resize\";a:9:{s:5:\"label\";s:6:\"Resize\";s:4:\"help\";s:121:\"Resizing will make images an exact set of dimensions. This may cause images to be stretched or shrunk disproportionately.\";s:15:\"effect callback\";s:19:\"image_resize_effect\";s:19:\"dimensions callback\";s:23:\"image_resize_dimensions\";s:13:\"form callback\";s:17:\"image_resize_form\";s:13:\"summary theme\";s:20:\"image_resize_summary\";s:6:\"module\";s:5:\"image\";s:4:\"name\";s:12:\"image_resize\";s:4:\"data\";a:0:{}}s:12:\"image_rotate\";a:9:{s:5:\"label\";s:6:\"Rotate\";s:4:\"help\";s:87:\"Rotating an image may cause the dimensions of an image to increase to fit the diagonal.\";s:15:\"effect callback\";s:19:\"image_rotate_effect\";s:19:\"dimensions callback\";s:23:\"image_rotate_dimensions\";s:13:\"form callback\";s:17:\"image_rotate_form\";s:13:\"summary theme\";s:20:\"image_rotate_summary\";s:6:\"module\";s:5:\"image\";s:4:\"name\";s:12:\"image_rotate\";s:4:\"data\";a:0:{}}s:11:\"image_scale\";a:9:{s:5:\"label\";s:5:\"Scale\";s:4:\"help\";s:142:\"Scaling will maintain the aspect-ratio of the original image. If only a single dimension is specified, the other dimension will be calculated.\";s:15:\"effect callback\";s:18:\"image_scale_effect\";s:19:\"dimensions callback\";s:22:\"image_scale_dimensions\";s:13:\"form callback\";s:16:\"image_scale_form\";s:13:\"summary theme\";s:19:\"image_scale_summary\";s:6:\"module\";s:5:\"image\";s:4:\"name\";s:11:\"image_scale\";s:4:\"data\";a:0:{}}s:20:\"image_scale_and_crop\";a:9:{s:5:\"label\";s:14:\"Scale and crop\";s:4:\"help\";s:191:\"Scale and crop will maintain the aspect-ratio of the original image, then crop the larger dimension. This is most useful for creating perfectly square thumbnails without stretching the image.\";s:15:\"effect callback\";s:27:\"image_scale_and_crop_effect\";s:19:\"dimensions callback\";s:23:\"image_resize_dimensions\";s:13:\"form callback\";s:17:\"image_resize_form\";s:13:\"summary theme\";s:20:\"image_resize_summary\";s:6:\"module\";s:5:\"image\";s:4:\"name\";s:20:\"image_scale_and_crop\";s:4:\"data\";a:0:{}}}',0,1512620340,1),('image_styles','a:11:{s:15:\"flexslider_full\";a:5:{s:7:\"effects\";a:1:{i:0;a:10:{s:5:\"label\";s:14:\"Scale and crop\";s:4:\"help\";s:191:\"Scale and crop will maintain the aspect-ratio of the original image, then crop the larger dimension. This is most useful for creating perfectly square thumbnails without stretching the image.\";s:15:\"effect callback\";s:27:\"image_scale_and_crop_effect\";s:19:\"dimensions callback\";s:23:\"image_resize_dimensions\";s:13:\"form callback\";s:17:\"image_resize_form\";s:13:\"summary theme\";s:20:\"image_resize_summary\";s:6:\"module\";s:5:\"image\";s:4:\"name\";s:20:\"image_scale_and_crop\";s:4:\"data\";a:2:{s:5:\"width\";i:800;s:6:\"height\";i:500;}s:6:\"weight\";i:0;}}s:4:\"name\";s:15:\"flexslider_full\";s:5:\"label\";s:15:\"flexslider_full\";s:6:\"module\";s:10:\"flexslider\";s:7:\"storage\";i:4;}s:20:\"flexslider_thumbnail\";a:5:{s:7:\"effects\";a:1:{i:0;a:10:{s:5:\"label\";s:14:\"Scale and crop\";s:4:\"help\";s:191:\"Scale and crop will maintain the aspect-ratio of the original image, then crop the larger dimension. This is most useful for creating perfectly square thumbnails without stretching the image.\";s:15:\"effect callback\";s:27:\"image_scale_and_crop_effect\";s:19:\"dimensions callback\";s:23:\"image_resize_dimensions\";s:13:\"form callback\";s:17:\"image_resize_form\";s:13:\"summary theme\";s:20:\"image_resize_summary\";s:6:\"module\";s:5:\"image\";s:4:\"name\";s:20:\"image_scale_and_crop\";s:4:\"data\";a:2:{s:5:\"width\";i:160;s:6:\"height\";i:100;}s:6:\"weight\";i:0;}}s:4:\"name\";s:20:\"flexslider_thumbnail\";s:5:\"label\";s:20:\"flexslider_thumbnail\";s:6:\"module\";s:10:\"flexslider\";s:7:\"storage\";i:4;}s:9:\"thumbnail\";a:6:{s:4:\"isid\";s:1:\"2\";s:4:\"name\";s:9:\"thumbnail\";s:5:\"label\";s:19:\"Thumbnail (100x100)\";s:6:\"module\";s:5:\"image\";s:7:\"storage\";i:2;s:7:\"effects\";a:1:{i:2;a:12:{s:5:\"label\";s:5:\"Scale\";s:4:\"help\";s:142:\"Scaling will maintain the aspect-ratio of the original image. If only a single dimension is specified, the other dimension will be calculated.\";s:15:\"effect callback\";s:18:\"image_scale_effect\";s:19:\"dimensions callback\";s:22:\"image_scale_dimensions\";s:13:\"form callback\";s:16:\"image_scale_form\";s:13:\"summary theme\";s:19:\"image_scale_summary\";s:6:\"module\";s:5:\"image\";s:4:\"name\";s:11:\"image_scale\";s:4:\"data\";a:3:{s:5:\"width\";s:2:\"50\";s:6:\"height\";s:2:\"50\";s:7:\"upscale\";i:1;}s:4:\"ieid\";s:1:\"2\";s:4:\"isid\";s:1:\"2\";s:6:\"weight\";s:1:\"0\";}}}s:6:\"medium\";a:5:{s:5:\"label\";s:16:\"Medium (220x220)\";s:7:\"effects\";a:1:{i:0;a:10:{s:5:\"label\";s:5:\"Scale\";s:4:\"help\";s:142:\"Scaling will maintain the aspect-ratio of the original image. If only a single dimension is specified, the other dimension will be calculated.\";s:15:\"effect callback\";s:18:\"image_scale_effect\";s:19:\"dimensions callback\";s:22:\"image_scale_dimensions\";s:13:\"form callback\";s:16:\"image_scale_form\";s:13:\"summary theme\";s:19:\"image_scale_summary\";s:6:\"module\";s:5:\"image\";s:4:\"name\";s:11:\"image_scale\";s:4:\"data\";a:3:{s:5:\"width\";i:220;s:6:\"height\";i:220;s:7:\"upscale\";i:1;}s:6:\"weight\";i:0;}}s:4:\"name\";s:6:\"medium\";s:6:\"module\";s:5:\"image\";s:7:\"storage\";i:4;}s:5:\"large\";a:6:{s:4:\"isid\";s:1:\"4\";s:4:\"name\";s:5:\"large\";s:5:\"label\";s:15:\"Large (880x350)\";s:6:\"module\";s:5:\"image\";s:7:\"storage\";i:2;s:7:\"effects\";a:1:{i:5;a:12:{s:5:\"label\";s:14:\"Scale and crop\";s:4:\"help\";s:191:\"Scale and crop will maintain the aspect-ratio of the original image, then crop the larger dimension. This is most useful for creating perfectly square thumbnails without stretching the image.\";s:15:\"effect callback\";s:27:\"image_scale_and_crop_effect\";s:19:\"dimensions callback\";s:23:\"image_resize_dimensions\";s:13:\"form callback\";s:17:\"image_resize_form\";s:13:\"summary theme\";s:20:\"image_resize_summary\";s:6:\"module\";s:5:\"image\";s:4:\"name\";s:20:\"image_scale_and_crop\";s:4:\"data\";a:2:{s:5:\"width\";s:3:\"880\";s:6:\"height\";s:3:\"350\";}s:4:\"ieid\";s:1:\"5\";s:4:\"isid\";s:1:\"4\";s:6:\"weight\";s:1:\"2\";}}}s:8:\"blog_mix\";a:6:{s:4:\"isid\";s:1:\"8\";s:4:\"name\";s:8:\"blog_mix\";s:5:\"label\";s:8:\"Blog Mix\";s:6:\"module\";N;s:7:\"storage\";i:1;s:7:\"effects\";a:1:{i:9;a:12:{s:5:\"label\";s:14:\"Scale and crop\";s:4:\"help\";s:191:\"Scale and crop will maintain the aspect-ratio of the original image, then crop the larger dimension. This is most useful for creating perfectly square thumbnails without stretching the image.\";s:15:\"effect callback\";s:27:\"image_scale_and_crop_effect\";s:19:\"dimensions callback\";s:23:\"image_resize_dimensions\";s:13:\"form callback\";s:17:\"image_resize_form\";s:13:\"summary theme\";s:20:\"image_resize_summary\";s:6:\"module\";s:5:\"image\";s:4:\"name\";s:20:\"image_scale_and_crop\";s:4:\"data\";a:2:{s:5:\"width\";s:3:\"350\";s:6:\"height\";s:3:\"300\";}s:4:\"ieid\";s:1:\"9\";s:4:\"isid\";s:1:\"8\";s:6:\"weight\";s:1:\"1\";}}}s:12:\"four_columns\";a:6:{s:4:\"isid\";s:1:\"7\";s:4:\"name\";s:12:\"four_columns\";s:5:\"label\";s:12:\"Four Columns\";s:6:\"module\";N;s:7:\"storage\";i:1;s:7:\"effects\";a:1:{i:8;a:12:{s:5:\"label\";s:14:\"Scale and crop\";s:4:\"help\";s:191:\"Scale and crop will maintain the aspect-ratio of the original image, then crop the larger dimension. This is most useful for creating perfectly square thumbnails without stretching the image.\";s:15:\"effect callback\";s:27:\"image_scale_and_crop_effect\";s:19:\"dimensions callback\";s:23:\"image_resize_dimensions\";s:13:\"form callback\";s:17:\"image_resize_form\";s:13:\"summary theme\";s:20:\"image_resize_summary\";s:6:\"module\";s:5:\"image\";s:4:\"name\";s:20:\"image_scale_and_crop\";s:4:\"data\";a:2:{s:5:\"width\";s:3:\"260\";s:6:\"height\";s:3:\"140\";}s:4:\"ieid\";s:1:\"8\";s:4:\"isid\";s:1:\"7\";s:6:\"weight\";s:1:\"1\";}}}s:9:\"hot_video\";a:6:{s:4:\"isid\";s:1:\"9\";s:4:\"name\";s:9:\"hot_video\";s:5:\"label\";s:9:\"Hot Video\";s:6:\"module\";N;s:7:\"storage\";i:1;s:7:\"effects\";a:1:{i:10;a:12:{s:5:\"label\";s:14:\"Scale and crop\";s:4:\"help\";s:191:\"Scale and crop will maintain the aspect-ratio of the original image, then crop the larger dimension. This is most useful for creating perfectly square thumbnails without stretching the image.\";s:15:\"effect callback\";s:27:\"image_scale_and_crop_effect\";s:19:\"dimensions callback\";s:23:\"image_resize_dimensions\";s:13:\"form callback\";s:17:\"image_resize_form\";s:13:\"summary theme\";s:20:\"image_resize_summary\";s:6:\"module\";s:5:\"image\";s:4:\"name\";s:20:\"image_scale_and_crop\";s:4:\"data\";a:2:{s:5:\"width\";s:3:\"290\";s:6:\"height\";s:3:\"156\";}s:4:\"ieid\";s:2:\"10\";s:4:\"isid\";s:1:\"9\";s:6:\"weight\";s:1:\"1\";}}}s:5:\"small\";a:6:{s:4:\"isid\";s:2:\"10\";s:4:\"name\";s:5:\"small\";s:5:\"label\";s:15:\"small (45 x 45)\";s:6:\"module\";N;s:7:\"storage\";i:1;s:7:\"effects\";a:1:{i:11;a:12:{s:5:\"label\";s:14:\"Scale and crop\";s:4:\"help\";s:191:\"Scale and crop will maintain the aspect-ratio of the original image, then crop the larger dimension. This is most useful for creating perfectly square thumbnails without stretching the image.\";s:15:\"effect callback\";s:27:\"image_scale_and_crop_effect\";s:19:\"dimensions callback\";s:23:\"image_resize_dimensions\";s:13:\"form callback\";s:17:\"image_resize_form\";s:13:\"summary theme\";s:20:\"image_resize_summary\";s:6:\"module\";s:5:\"image\";s:4:\"name\";s:20:\"image_scale_and_crop\";s:4:\"data\";a:2:{s:5:\"width\";s:2:\"45\";s:6:\"height\";s:2:\"45\";}s:4:\"ieid\";s:2:\"11\";s:4:\"isid\";s:2:\"10\";s:6:\"weight\";s:1:\"1\";}}}s:13:\"three_columns\";a:6:{s:4:\"isid\";s:1:\"6\";s:4:\"name\";s:13:\"three_columns\";s:5:\"label\";s:13:\"Three Columns\";s:6:\"module\";N;s:7:\"storage\";i:1;s:7:\"effects\";a:1:{i:7;a:12:{s:5:\"label\";s:14:\"Scale and crop\";s:4:\"help\";s:191:\"Scale and crop will maintain the aspect-ratio of the original image, then crop the larger dimension. This is most useful for creating perfectly square thumbnails without stretching the image.\";s:15:\"effect callback\";s:27:\"image_scale_and_crop_effect\";s:19:\"dimensions callback\";s:23:\"image_resize_dimensions\";s:13:\"form callback\";s:17:\"image_resize_form\";s:13:\"summary theme\";s:20:\"image_resize_summary\";s:6:\"module\";s:5:\"image\";s:4:\"name\";s:20:\"image_scale_and_crop\";s:4:\"data\";a:2:{s:5:\"width\";s:3:\"272\";s:6:\"height\";s:3:\"167\";}s:4:\"ieid\";s:1:\"7\";s:4:\"isid\";s:1:\"6\";s:6:\"weight\";s:1:\"1\";}}}s:11:\"two_columns\";a:6:{s:4:\"isid\";s:1:\"5\";s:4:\"name\";s:11:\"two_columns\";s:5:\"label\";s:11:\"Two Columns\";s:6:\"module\";N;s:7:\"storage\";i:1;s:7:\"effects\";a:1:{i:6;a:12:{s:5:\"label\";s:14:\"Scale and crop\";s:4:\"help\";s:191:\"Scale and crop will maintain the aspect-ratio of the original image, then crop the larger dimension. This is most useful for creating perfectly square thumbnails without stretching the image.\";s:15:\"effect callback\";s:27:\"image_scale_and_crop_effect\";s:19:\"dimensions callback\";s:23:\"image_resize_dimensions\";s:13:\"form callback\";s:17:\"image_resize_form\";s:13:\"summary theme\";s:20:\"image_resize_summary\";s:6:\"module\";s:5:\"image\";s:4:\"name\";s:20:\"image_scale_and_crop\";s:4:\"data\";a:2:{s:5:\"width\";s:3:\"416\";s:6:\"height\";s:3:\"261\";}s:4:\"ieid\";s:1:\"6\";s:4:\"isid\";s:1:\"5\";s:6:\"weight\";s:1:\"1\";}}}}',0,1512620340,1),('node_types:en','O:8:\"stdClass\":2:{s:5:\"types\";a:9:{s:4:\"blog\";O:8:\"stdClass\":14:{s:4:\"type\";s:4:\"blog\";s:4:\"name\";s:10:\"Blog entry\";s:4:\"base\";s:4:\"blog\";s:6:\"module\";s:4:\"blog\";s:11:\"description\";s:58:\"Use for multi-user blogs. Every user gets a personal blog.\";s:4:\"help\";s:0:\"\";s:9:\"has_title\";s:1:\"1\";s:11:\"title_label\";s:5:\"Title\";s:6:\"custom\";s:1:\"0\";s:8:\"modified\";s:1:\"1\";s:6:\"locked\";s:1:\"1\";s:8:\"disabled\";b:0;s:9:\"orig_type\";s:4:\"blog\";s:16:\"disabled_changed\";b:0;}s:3:\"faq\";O:8:\"stdClass\":15:{s:4:\"name\";s:3:\"FAQ\";s:4:\"base\";s:3:\"faq\";s:11:\"description\";s:43:\"A frequently asked question and its answer.\";s:9:\"has_title\";b:1;s:11:\"title_label\";s:8:\"Question\";s:4:\"type\";s:3:\"faq\";s:4:\"help\";s:0:\"\";s:6:\"custom\";i:0;s:8:\"modified\";i:0;s:6:\"locked\";i:1;s:8:\"disabled\";b:0;s:6:\"is_new\";i:1;s:6:\"module\";s:3:\"faq\";s:9:\"orig_type\";s:3:\"faq\";s:16:\"disabled_changed\";b:0;}s:5:\"forum\";O:8:\"stdClass\":14:{s:4:\"type\";s:5:\"forum\";s:4:\"name\";s:11:\"Forum topic\";s:4:\"base\";s:5:\"forum\";s:6:\"module\";s:5:\"forum\";s:11:\"description\";s:69:\"A <em>forum topic</em> starts a new discussion thread within a forum.\";s:4:\"help\";s:0:\"\";s:9:\"has_title\";s:1:\"1\";s:11:\"title_label\";s:7:\"Subject\";s:6:\"custom\";s:1:\"0\";s:8:\"modified\";s:1:\"1\";s:6:\"locked\";s:1:\"1\";s:8:\"disabled\";b:0;s:9:\"orig_type\";s:5:\"forum\";s:16:\"disabled_changed\";b:0;}s:7:\"article\";O:8:\"stdClass\":14:{s:4:\"type\";s:7:\"article\";s:4:\"name\";s:7:\"Article\";s:4:\"base\";s:12:\"node_content\";s:6:\"module\";s:4:\"node\";s:11:\"description\";s:89:\"Use <em>articles</em> for time-sensitive content like news, press releases or blog posts.\";s:4:\"help\";s:0:\"\";s:9:\"has_title\";s:1:\"1\";s:11:\"title_label\";s:5:\"Title\";s:6:\"custom\";s:1:\"1\";s:8:\"modified\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:8:\"disabled\";s:1:\"0\";s:9:\"orig_type\";s:7:\"article\";s:16:\"disabled_changed\";b:0;}s:4:\"book\";O:8:\"stdClass\":14:{s:4:\"type\";s:4:\"book\";s:4:\"name\";s:9:\"Book page\";s:4:\"base\";s:12:\"node_content\";s:6:\"module\";s:4:\"node\";s:11:\"description\";s:87:\"<em>Books</em> have a built-in hierarchical navigation. Use for handbooks or tutorials.\";s:4:\"help\";s:0:\"\";s:9:\"has_title\";s:1:\"1\";s:11:\"title_label\";s:5:\"Title\";s:6:\"custom\";s:1:\"1\";s:8:\"modified\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:8:\"disabled\";s:1:\"0\";s:9:\"orig_type\";s:4:\"book\";s:16:\"disabled_changed\";b:0;}s:4:\"page\";O:8:\"stdClass\":14:{s:4:\"type\";s:4:\"page\";s:4:\"name\";s:10:\"Basic page\";s:4:\"base\";s:12:\"node_content\";s:6:\"module\";s:4:\"node\";s:11:\"description\";s:77:\"Use <em>basic pages</em> for your static content, such as an \'About us\' page.\";s:4:\"help\";s:0:\"\";s:9:\"has_title\";s:1:\"1\";s:11:\"title_label\";s:5:\"Title\";s:6:\"custom\";s:1:\"1\";s:8:\"modified\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:8:\"disabled\";s:1:\"0\";s:9:\"orig_type\";s:4:\"page\";s:16:\"disabled_changed\";b:0;}s:8:\"products\";O:8:\"stdClass\":14:{s:4:\"type\";s:8:\"products\";s:4:\"name\";s:8:\"Products\";s:4:\"base\";s:12:\"node_content\";s:6:\"module\";s:4:\"node\";s:11:\"description\";s:0:\"\";s:4:\"help\";s:0:\"\";s:9:\"has_title\";s:1:\"1\";s:11:\"title_label\";s:5:\"Title\";s:6:\"custom\";s:1:\"1\";s:8:\"modified\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:8:\"disabled\";s:1:\"0\";s:9:\"orig_type\";s:8:\"products\";s:16:\"disabled_changed\";b:0;}s:5:\"video\";O:8:\"stdClass\":14:{s:4:\"type\";s:5:\"video\";s:4:\"name\";s:5:\"Video\";s:4:\"base\";s:12:\"node_content\";s:6:\"module\";s:4:\"node\";s:11:\"description\";s:0:\"\";s:4:\"help\";s:0:\"\";s:9:\"has_title\";s:1:\"1\";s:11:\"title_label\";s:5:\"Title\";s:6:\"custom\";s:1:\"1\";s:8:\"modified\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:8:\"disabled\";s:1:\"0\";s:9:\"orig_type\";s:5:\"video\";s:16:\"disabled_changed\";b:0;}s:7:\"webform\";O:8:\"stdClass\":14:{s:4:\"type\";s:7:\"webform\";s:4:\"name\";s:7:\"Webform\";s:4:\"base\";s:12:\"node_content\";s:6:\"module\";s:4:\"node\";s:11:\"description\";s:138:\"Create a new form or questionnaire accessible to users. Submission results and statistics are recorded and accessible to privileged users.\";s:4:\"help\";s:0:\"\";s:9:\"has_title\";s:1:\"1\";s:11:\"title_label\";s:5:\"Title\";s:6:\"custom\";s:1:\"1\";s:8:\"modified\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:8:\"disabled\";s:1:\"0\";s:9:\"orig_type\";s:7:\"webform\";s:16:\"disabled_changed\";b:0;}}s:5:\"names\";a:9:{s:7:\"article\";s:7:\"Article\";s:4:\"page\";s:10:\"Basic page\";s:4:\"blog\";s:10:\"Blog entry\";s:4:\"book\";s:9:\"Book page\";s:3:\"faq\";s:3:\"FAQ\";s:5:\"forum\";s:11:\"Forum topic\";s:8:\"products\";s:8:\"Products\";s:5:\"video\";s:5:\"Video\";s:7:\"webform\";s:7:\"Webform\";}}',0,1512620340,1),('schema','a:155:{s:5:\"block\";a:6:{s:6:\"fields\";a:14:{s:3:\"bid\";a:2:{s:4:\"type\";s:6:\"serial\";s:8:\"not null\";b:1;}s:6:\"module\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:64;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:1:\"0\";}s:5:\"theme\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:64;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"status\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:4:\"size\";s:4:\"tiny\";}s:6:\"weight\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:6:\"region\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:64;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"custom\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:4:\"size\";s:4:\"tiny\";}s:10:\"visibility\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:4:\"size\";s:4:\"tiny\";}s:5:\"pages\";a:2:{s:4:\"type\";s:4:\"text\";s:8:\"not null\";b:1;}s:5:\"title\";a:5:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:12:\"translatable\";b:1;}s:5:\"cache\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:1;s:4:\"size\";s:4:\"tiny\";}s:9:\"css_class\";a:5:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:11:\"description\";s:44:\"String containing the classes for the block.\";}s:9:\"i18n_mode\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:11:\"description\";s:24:\"Block multilingual mode.\";}}s:11:\"primary key\";a:1:{i:0;s:3:\"bid\";}s:11:\"unique keys\";a:1:{s:3:\"tmd\";a:3:{i:0;s:5:\"theme\";i:1;s:6:\"module\";i:2;s:5:\"delta\";}}s:7:\"indexes\";a:1:{s:4:\"list\";a:5:{i:0;s:5:\"theme\";i:1;s:6:\"status\";i:2;s:6:\"region\";i:3;s:6:\"weight\";i:4;s:6:\"module\";}}s:6:\"module\";s:5:\"block\";s:4:\"name\";s:5:\"block\";}s:10:\"block_role\";a:5:{s:6:\"fields\";a:3:{s:6:\"module\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:64;s:8:\"not null\";b:1;}s:5:\"delta\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;}s:3:\"rid\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}}s:11:\"primary key\";a:3:{i:0;s:6:\"module\";i:1;s:5:\"delta\";i:2;s:3:\"rid\";}s:7:\"indexes\";a:1:{s:3:\"rid\";a:1:{i:0;s:3:\"rid\";}}s:6:\"module\";s:5:\"block\";s:4:\"name\";s:10:\"block_role\";}s:12:\"block_custom\";a:5:{s:6:\"fields\";a:4:{s:3:\"bid\";a:3:{s:4:\"type\";s:6:\"serial\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:4:\"body\";a:4:{s:4:\"type\";s:4:\"text\";s:8:\"not null\";b:0;s:4:\"size\";s:3:\"big\";s:12:\"translatable\";b:1;}s:4:\"info\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"unique keys\";a:1:{s:4:\"info\";a:1:{i:0;s:4:\"info\";}}s:11:\"primary key\";a:1:{i:0;s:3:\"bid\";}s:6:\"module\";s:5:\"block\";s:4:\"name\";s:12:\"block_custom\";}s:11:\"cache_block\";a:5:{s:6:\"fields\";a:5:{s:3:\"cid\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:4:\"data\";a:3:{s:4:\"type\";s:4:\"blob\";s:8:\"not null\";b:0;s:4:\"size\";s:3:\"big\";}s:6:\"expire\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:7:\"created\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:10:\"serialized\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:5:\"small\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}}s:7:\"indexes\";a:1:{s:6:\"expire\";a:1:{i:0;s:6:\"expire\";}}s:11:\"primary key\";a:1:{i:0;s:3:\"cid\";}s:6:\"module\";s:5:\"block\";s:4:\"name\";s:11:\"cache_block\";}s:7:\"webform\";a:4:{s:6:\"fields\";a:30:{s:3:\"nid\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"next_serial\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:1;}s:12:\"confirmation\";a:2:{s:4:\"type\";s:4:\"text\";s:8:\"not null\";b:1;}s:19:\"confirmation_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}s:12:\"redirect_url\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:2048;s:7:\"default\";s:14:\"<confirmation>\";}s:6:\"status\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:1;}s:5:\"block\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:11:\"allow_draft\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"auto_save\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:13:\"submit_notice\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:1;}s:12:\"confidential\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:11:\"submit_text\";a:2:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;}s:12:\"submit_limit\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:-1;}s:15:\"submit_interval\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:-1;}s:18:\"total_submit_limit\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:-1;}s:21:\"total_submit_interval\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:-1;}s:15:\"progressbar_bar\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:23:\"progressbar_page_number\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:19:\"progressbar_percent\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:28:\"progressbar_pagebreak_labels\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:32:\"progressbar_include_confirmation\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:23:\"progressbar_label_first\";a:2:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;}s:30:\"progressbar_label_confirmation\";a:2:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;}s:7:\"preview\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:25:\"preview_next_button_label\";a:2:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;}s:25:\"preview_prev_button_label\";a:2:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;}s:13:\"preview_title\";a:2:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;}s:15:\"preview_message\";a:2:{s:4:\"type\";s:4:\"text\";s:8:\"not null\";b:1;}s:22:\"preview_message_format\";a:2:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;}s:27:\"preview_excluded_components\";a:2:{s:4:\"type\";s:4:\"text\";s:8:\"not null\";b:1;}}s:11:\"primary key\";a:1:{i:0;s:3:\"nid\";}s:6:\"module\";s:7:\"webform\";s:4:\"name\";s:7:\"webform\";}s:17:\"webform_component\";a:4:{s:6:\"fields\";a:10:{s:3:\"nid\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:3:\"cid\";a:5:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:5:\"small\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:3:\"pid\";a:5:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:5:\"small\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:8:\"form_key\";a:2:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;}s:4:\"name\";a:2:{s:4:\"type\";s:4:\"text\";s:8:\"not null\";b:1;}s:4:\"type\";a:2:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:16;}s:5:\"value\";a:2:{s:4:\"type\";s:4:\"text\";s:8:\"not null\";b:1;}s:5:\"extra\";a:2:{s:4:\"type\";s:4:\"text\";s:8:\"not null\";b:1;}s:8:\"required\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:6:\"weight\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:5:\"small\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}}s:11:\"primary key\";a:2:{i:0;s:3:\"nid\";i:1;s:3:\"cid\";}s:6:\"module\";s:7:\"webform\";s:4:\"name\";s:17:\"webform_component\";}s:19:\"webform_conditional\";a:4:{s:6:\"fields\";a:4:{s:3:\"nid\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:4:\"rgid\";a:5:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:5:\"small\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:5:\"andor\";a:2:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;}s:6:\"weight\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:5:\"small\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}}s:11:\"primary key\";a:2:{i:0;s:3:\"nid\";i:1;s:4:\"rgid\";}s:6:\"module\";s:7:\"webform\";s:4:\"name\";s:19:\"webform_conditional\";}s:25:\"webform_conditional_rules\";a:4:{s:6:\"fields\";a:7:{s:3:\"nid\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:4:\"rgid\";a:5:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:5:\"small\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:3:\"rid\";a:5:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:5:\"small\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:11:\"source_type\";a:2:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;}s:6:\"source\";a:5:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:5:\"small\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:8:\"operator\";a:2:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;}s:5:\"value\";a:1:{s:4:\"type\";s:4:\"text\";}}s:11:\"primary key\";a:3:{i:0;s:3:\"nid\";i:1;s:4:\"rgid\";i:2;s:3:\"rid\";}s:6:\"module\";s:7:\"webform\";s:4:\"name\";s:25:\"webform_conditional_rules\";}s:27:\"webform_conditional_actions\";a:4:{s:6:\"fields\";a:8:{s:3:\"nid\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:4:\"rgid\";a:5:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:5:\"small\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:3:\"aid\";a:5:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:5:\"small\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:11:\"target_type\";a:2:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;}s:6:\"target\";a:2:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;}s:6:\"invert\";a:5:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:5:\"small\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:6:\"action\";a:2:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;}s:8:\"argument\";a:1:{s:4:\"type\";s:4:\"text\";}}s:11:\"primary key\";a:3:{i:0;s:3:\"nid\";i:1;s:4:\"rgid\";i:2;s:3:\"aid\";}s:6:\"module\";s:7:\"webform\";s:4:\"name\";s:27:\"webform_conditional_actions\";}s:14:\"webform_emails\";a:4:{s:6:\"fields\";a:13:{s:3:\"nid\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:3:\"eid\";a:5:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:4:\"size\";s:5:\"small\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:5:\"email\";a:2:{s:4:\"type\";s:4:\"text\";s:8:\"not null\";b:0;}s:7:\"subject\";a:2:{s:4:\"type\";s:4:\"text\";s:8:\"not null\";b:0;}s:9:\"from_name\";a:2:{s:4:\"type\";s:4:\"text\";s:8:\"not null\";b:0;}s:12:\"from_address\";a:2:{s:4:\"type\";s:4:\"text\";s:8:\"not null\";b:0;}s:8:\"template\";a:2:{s:4:\"type\";s:4:\"text\";s:8:\"not null\";b:0;}s:19:\"excluded_components\";a:2:{s:4:\"type\";s:4:\"text\";s:8:\"not null\";b:1;}s:4:\"html\";a:5:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:11:\"attachments\";a:5:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:13:\"exclude_empty\";a:5:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:5:\"extra\";a:2:{s:4:\"type\";s:4:\"text\";s:8:\"not null\";b:1;}s:6:\"status\";a:5:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:1;}}s:11:\"primary key\";a:2:{i:0;s:3:\"nid\";i:1;s:3:\"eid\";}s:6:\"module\";s:7:\"webform\";s:4:\"name\";s:14:\"webform_emails\";}s:13:\"webform_roles\";a:4:{s:6:\"fields\";a:2:{s:3:\"nid\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:3:\"rid\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}}s:11:\"primary key\";a:2:{i:0;s:3:\"nid\";i:1;s:3:\"rid\";}s:6:\"module\";s:7:\"webform\";s:4:\"name\";s:13:\"webform_roles\";}s:19:\"webform_submissions\";a:6:{s:6:\"fields\";a:10:{s:3:\"sid\";a:3:{s:4:\"type\";s:6:\"serial\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:3:\"nid\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:6:\"serial\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:3:\"uid\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:8:\"is_draft\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:18:\"highest_valid_page\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:5:\"small\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"submitted\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"completed\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:8:\"modified\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:11:\"remote_addr\";a:2:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;}}s:11:\"primary key\";a:1:{i:0;s:3:\"sid\";}s:11:\"unique keys\";a:2:{s:7:\"sid_nid\";a:2:{i:0;s:3:\"sid\";i:1;s:3:\"nid\";}s:10:\"nid_serial\";a:2:{i:0;s:3:\"nid\";i:1;s:6:\"serial\";}}s:7:\"indexes\";a:2:{s:11:\"nid_uid_sid\";a:3:{i:0;s:3:\"nid\";i:1;s:3:\"uid\";i:2;s:3:\"sid\";}s:7:\"nid_sid\";a:2:{i:0;s:3:\"nid\";i:1;s:3:\"sid\";}}s:6:\"module\";s:7:\"webform\";s:4:\"name\";s:19:\"webform_submissions\";}s:22:\"webform_submitted_data\";a:5:{s:6:\"fields\";a:5:{s:3:\"nid\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:3:\"sid\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:3:\"cid\";a:5:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:5:\"small\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:2:\"no\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:1:\"0\";}s:4:\"data\";a:3:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:6:\"medium\";s:8:\"not null\";b:1;}}s:11:\"primary key\";a:4:{i:0;s:3:\"nid\";i:1;s:3:\"sid\";i:2;s:3:\"cid\";i:3;s:2:\"no\";}s:7:\"indexes\";a:2:{s:3:\"nid\";a:1:{i:0;s:3:\"nid\";}s:7:\"sid_nid\";a:2:{i:0;s:3:\"sid\";i:1;s:3:\"nid\";}}s:6:\"module\";s:7:\"webform\";s:4:\"name\";s:22:\"webform_submitted_data\";}s:21:\"webform_last_download\";a:4:{s:6:\"fields\";a:4:{s:3:\"nid\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:3:\"uid\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:3:\"sid\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"requested\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}}s:11:\"primary key\";a:2:{i:0;s:3:\"nid\";i:1;s:3:\"uid\";}s:6:\"module\";s:7:\"webform\";s:4:\"name\";s:21:\"webform_last_download\";}s:4:\"book\";a:6:{s:6:\"fields\";a:3:{s:4:\"mlid\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:3:\"nid\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:3:\"bid\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}}s:11:\"primary key\";a:1:{i:0;s:4:\"mlid\";}s:11:\"unique keys\";a:1:{s:3:\"nid\";a:1:{i:0;s:3:\"nid\";}}s:7:\"indexes\";a:1:{s:3:\"bid\";a:1:{i:0;s:3:\"bid\";}}s:6:\"module\";s:4:\"book\";s:4:\"name\";s:4:\"book\";}s:17:\"ckeditor_settings\";a:4:{s:6:\"fields\";a:2:{s:4:\"name\";a:4:{s:4:\"type\";s:7:\"varchar\";s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:6:\"length\";i:128;}s:8:\"settings\";a:1:{s:4:\"type\";s:4:\"text\";}}s:11:\"primary key\";a:1:{i:0;s:4:\"name\";}s:6:\"module\";s:8:\"ckeditor\";s:4:\"name\";s:17:\"ckeditor_settings\";}s:21:\"ckeditor_input_format\";a:4:{s:6:\"fields\";a:2:{s:4:\"name\";a:4:{s:4:\"type\";s:7:\"varchar\";s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:6:\"length\";i:128;}s:6:\"format\";a:4:{s:4:\"type\";s:7:\"varchar\";s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:6:\"length\";i:128;}}s:11:\"primary key\";a:2:{i:0;s:4:\"name\";i:1;s:6:\"format\";}s:6:\"module\";s:8:\"ckeditor\";s:4:\"name\";s:21:\"ckeditor_input_format\";}s:7:\"comment\";a:6:{s:6:\"fields\";a:14:{s:3:\"cid\";a:2:{s:4:\"type\";s:6:\"serial\";s:8:\"not null\";b:1;}s:3:\"pid\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:3:\"nid\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:3:\"uid\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:7:\"subject\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:64;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:8:\"hostname\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"created\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:7:\"changed\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:6:\"status\";a:5:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:1;s:4:\"size\";s:4:\"tiny\";}s:6:\"thread\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;}s:4:\"name\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:60;s:8:\"not null\";b:0;}s:4:\"mail\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:64;s:8:\"not null\";b:0;}s:8:\"homepage\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:12;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}}s:7:\"indexes\";a:5:{s:18:\"comment_status_pid\";a:2:{i:0;s:3:\"pid\";i:1;s:6:\"status\";}s:15:\"comment_num_new\";a:5:{i:0;s:3:\"nid\";i:1;s:6:\"status\";i:2;s:7:\"created\";i:3;s:3:\"cid\";i:4;s:6:\"thread\";}s:11:\"comment_uid\";a:1:{i:0;s:3:\"uid\";}s:20:\"comment_nid_language\";a:2:{i:0;s:3:\"nid\";i:1;s:8:\"language\";}s:15:\"comment_created\";a:1:{i:0;s:7:\"created\";}}s:11:\"primary key\";a:1:{i:0;s:3:\"cid\";}s:12:\"foreign keys\";a:2:{s:12:\"comment_node\";a:2:{s:5:\"table\";s:4:\"node\";s:7:\"columns\";a:1:{s:3:\"nid\";s:3:\"nid\";}}s:14:\"comment_author\";a:2:{s:5:\"table\";s:5:\"users\";s:7:\"columns\";a:1:{s:3:\"uid\";s:3:\"uid\";}}}s:6:\"module\";s:7:\"comment\";s:4:\"name\";s:7:\"comment\";}s:23:\"node_comment_statistics\";a:6:{s:6:\"fields\";a:6:{s:3:\"nid\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:3:\"cid\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:22:\"last_comment_timestamp\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:17:\"last_comment_name\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:60;s:8:\"not null\";b:0;}s:16:\"last_comment_uid\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:13:\"comment_count\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}}s:11:\"primary key\";a:1:{i:0;s:3:\"nid\";}s:7:\"indexes\";a:3:{s:22:\"node_comment_timestamp\";a:1:{i:0;s:22:\"last_comment_timestamp\";}s:13:\"comment_count\";a:1:{i:0;s:13:\"comment_count\";}s:16:\"last_comment_uid\";a:1:{i:0;s:16:\"last_comment_uid\";}}s:12:\"foreign keys\";a:2:{s:15:\"statistics_node\";a:2:{s:5:\"table\";s:4:\"node\";s:7:\"columns\";a:1:{s:3:\"nid\";s:3:\"nid\";}}s:19:\"last_comment_author\";a:2:{s:5:\"table\";s:5:\"users\";s:7:\"columns\";a:1:{s:16:\"last_comment_uid\";s:3:\"uid\";}}}s:6:\"module\";s:7:\"comment\";s:4:\"name\";s:23:\"node_comment_statistics\";}s:7:\"contact\";a:6:{s:6:\"fields\";a:6:{s:3:\"cid\";a:3:{s:4:\"type\";s:6:\"serial\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:8:\"category\";a:5:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:12:\"translatable\";b:1;}s:10:\"recipients\";a:3:{s:4:\"type\";s:4:\"text\";s:8:\"not null\";b:1;s:4:\"size\";s:3:\"big\";}s:5:\"reply\";a:3:{s:4:\"type\";s:4:\"text\";s:8:\"not null\";b:1;s:4:\"size\";s:3:\"big\";}s:6:\"weight\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:8:\"selected\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:4:\"size\";s:4:\"tiny\";}}s:11:\"primary key\";a:1:{i:0;s:3:\"cid\";}s:11:\"unique keys\";a:1:{s:8:\"category\";a:1:{i:0;s:8:\"category\";}}s:7:\"indexes\";a:1:{s:4:\"list\";a:2:{i:0;s:6:\"weight\";i:1;s:8:\"category\";}}s:6:\"module\";s:7:\"contact\";s:4:\"name\";s:7:\"contact\";}s:19:\"ctools_object_cache\";a:5:{s:6:\"fields\";a:5:{s:3:\"sid\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:2:\"64\";s:8:\"not null\";b:1;}s:4:\"name\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;}s:3:\"obj\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;}s:7:\"updated\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:4:\"data\";a:3:{s:4:\"type\";s:4:\"blob\";s:4:\"size\";s:3:\"big\";s:9:\"serialize\";b:1;}}s:11:\"primary key\";a:3:{i:0;s:3:\"sid\";i:1;s:3:\"obj\";i:2;s:4:\"name\";}s:7:\"indexes\";a:1:{s:7:\"updated\";a:1:{i:0;s:7:\"updated\";}}s:6:\"module\";s:6:\"ctools\";s:4:\"name\";s:19:\"ctools_object_cache\";}s:16:\"ctools_css_cache\";a:4:{s:6:\"fields\";a:4:{s:3:\"cid\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"128\";s:8:\"not null\";b:1;}s:8:\"filename\";a:2:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";}s:3:\"css\";a:3:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:3:\"big\";s:9:\"serialize\";b:1;}s:6:\"filter\";a:2:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";}}s:11:\"primary key\";a:1:{i:0;s:3:\"cid\";}s:6:\"module\";s:6:\"ctools\";s:4:\"name\";s:16:\"ctools_css_cache\";}s:8:\"watchdog\";a:5:{s:6:\"fields\";a:11:{s:3:\"wid\";a:2:{s:4:\"type\";s:6:\"serial\";s:8:\"not null\";b:1;}s:3:\"uid\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:4:\"type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:64;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"message\";a:3:{s:4:\"type\";s:4:\"text\";s:8:\"not null\";b:1;s:4:\"size\";s:3:\"big\";}s:9:\"variables\";a:3:{s:4:\"type\";s:4:\"blob\";s:8:\"not null\";b:1;s:4:\"size\";s:3:\"big\";}s:8:\"severity\";a:5:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;s:4:\"size\";s:4:\"tiny\";}s:4:\"link\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;s:7:\"default\";s:0:\"\";}s:8:\"location\";a:2:{s:4:\"type\";s:4:\"text\";s:8:\"not null\";b:1;}s:7:\"referer\";a:2:{s:4:\"type\";s:4:\"text\";s:8:\"not null\";b:0;}s:8:\"hostname\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:9:\"timestamp\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}}s:11:\"primary key\";a:1:{i:0;s:3:\"wid\";}s:7:\"indexes\";a:3:{s:4:\"type\";a:1:{i:0;s:4:\"type\";}s:3:\"uid\";a:1:{i:0;s:3:\"uid\";}s:8:\"severity\";a:1:{i:0;s:8:\"severity\";}}s:6:\"module\";s:5:\"dblog\";s:4:\"name\";s:8:\"watchdog\";}s:11:\"faq_weights\";a:4:{s:6:\"fields\";a:3:{s:3:\"tid\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:3:\"nid\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:6:\"weight\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}}s:11:\"primary key\";a:2:{i:0;s:3:\"nid\";i:1;s:3:\"tid\";}s:6:\"module\";s:3:\"faq\";s:4:\"name\";s:11:\"faq_weights\";}s:13:\"faq_questions\";a:4:{s:6:\"fields\";a:4:{s:3:\"nid\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:3:\"vid\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:8:\"question\";a:3:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:6:\"normal\";s:8:\"not null\";b:1;}s:17:\"detailed_question\";a:3:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:6:\"normal\";s:8:\"not null\";b:0;}}s:11:\"primary key\";a:2:{i:0;s:3:\"nid\";i:1;s:3:\"vid\";}s:6:\"module\";s:3:\"faq\";s:4:\"name\";s:13:\"faq_questions\";}s:12:\"field_config\";a:5:{s:6:\"fields\";a:13:{s:2:\"id\";a:2:{s:4:\"type\";s:6:\"serial\";s:8:\"not null\";b:1;}s:10:\"field_name\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;}s:4:\"type\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;}s:6:\"module\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"active\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:12:\"storage_type\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;}s:14:\"storage_module\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:14:\"storage_active\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:6:\"locked\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:4:\"data\";a:4:{s:4:\"type\";s:4:\"blob\";s:4:\"size\";s:3:\"big\";s:8:\"not null\";b:1;s:9:\"serialize\";b:1;}s:11:\"cardinality\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:12:\"translatable\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}}s:11:\"primary key\";a:1:{i:0;s:2:\"id\";}s:7:\"indexes\";a:8:{s:10:\"field_name\";a:1:{i:0;s:10:\"field_name\";}s:6:\"active\";a:1:{i:0;s:6:\"active\";}s:14:\"storage_active\";a:1:{i:0;s:14:\"storage_active\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:6:\"module\";a:1:{i:0;s:6:\"module\";}s:14:\"storage_module\";a:1:{i:0;s:14:\"storage_module\";}s:4:\"type\";a:1:{i:0;s:4:\"type\";}s:12:\"storage_type\";a:1:{i:0;s:12:\"storage_type\";}}s:6:\"module\";s:5:\"field\";s:4:\"name\";s:12:\"field_config\";}s:21:\"field_config_instance\";a:5:{s:6:\"fields\";a:7:{s:2:\"id\";a:2:{s:4:\"type\";s:6:\"serial\";s:8:\"not null\";b:1;}s:8:\"field_id\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;}s:10:\"field_name\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:4:\"data\";a:4:{s:4:\"type\";s:4:\"blob\";s:4:\"size\";s:3:\"big\";s:8:\"not null\";b:1;s:9:\"serialize\";b:1;}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}}s:11:\"primary key\";a:1:{i:0;s:2:\"id\";}s:7:\"indexes\";a:2:{s:17:\"field_name_bundle\";a:3:{i:0;s:10:\"field_name\";i:1;s:11:\"entity_type\";i:2;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}}s:6:\"module\";s:5:\"field\";s:4:\"name\";s:21:\"field_config_instance\";}s:11:\"cache_field\";a:5:{s:6:\"fields\";a:5:{s:3:\"cid\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:4:\"data\";a:3:{s:4:\"type\";s:4:\"blob\";s:8:\"not null\";b:0;s:4:\"size\";s:3:\"big\";}s:6:\"expire\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:7:\"created\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:10:\"serialized\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:5:\"small\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}}s:7:\"indexes\";a:1:{s:6:\"expire\";a:1:{i:0;s:6:\"expire\";}}s:11:\"primary key\";a:1:{i:0;s:3:\"cid\";}s:6:\"module\";s:5:\"field\";s:4:\"name\";s:11:\"cache_field\";}s:21:\"field_collection_item\";a:4:{s:6:\"fields\";a:4:{s:7:\"item_id\";a:2:{s:4:\"type\";s:6:\"serial\";s:8:\"not null\";b:1;}s:11:\"revision_id\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;}s:10:\"field_name\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;}s:8:\"archived\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}}s:11:\"primary key\";a:1:{i:0;s:7:\"item_id\";}s:6:\"module\";s:16:\"field_collection\";s:4:\"name\";s:21:\"field_collection_item\";}s:30:\"field_collection_item_revision\";a:6:{s:6:\"fields\";a:2:{s:11:\"revision_id\";a:2:{s:4:\"type\";s:6:\"serial\";s:8:\"not null\";b:1;}s:7:\"item_id\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;}}s:11:\"primary key\";a:1:{i:0;s:11:\"revision_id\";}s:7:\"indexes\";a:1:{s:7:\"item_id\";a:1:{i:0;s:7:\"item_id\";}}s:12:\"foreign keys\";a:1:{s:31:\"versioned_field_collection_item\";a:2:{s:5:\"table\";s:21:\"field_collection_item\";s:7:\"columns\";a:1:{s:7:\"item_id\";s:7:\"item_id\";}}}s:6:\"module\";s:16:\"field_collection\";s:4:\"name\";s:30:\"field_collection_item_revision\";}s:23:\"field_data_comment_body\";a:6:{s:6:\"fields\";a:9:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:18:\"comment_body_value\";a:3:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:3:\"big\";s:8:\"not null\";b:0;}s:19:\"comment_body_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:5:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:19:\"comment_body_format\";a:1:{i:0;s:19:\"comment_body_format\";}}s:12:\"foreign keys\";a:1:{s:19:\"comment_body_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:19:\"comment_body_format\";s:6:\"format\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:23:\"field_data_comment_body\";}s:27:\"field_revision_comment_body\";a:6:{s:6:\"fields\";a:9:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:18:\"comment_body_value\";a:3:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:3:\"big\";s:8:\"not null\";b:0;}s:19:\"comment_body_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:6:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:11:\"revision_id\";i:3;s:7:\"deleted\";i:4;s:5:\"delta\";i:5;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:19:\"comment_body_format\";a:1:{i:0;s:19:\"comment_body_format\";}}s:12:\"foreign keys\";a:1:{s:19:\"comment_body_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:19:\"comment_body_format\";s:6:\"format\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:27:\"field_revision_comment_body\";}s:15:\"field_data_body\";a:6:{s:6:\"fields\";a:10:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:10:\"body_value\";a:3:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:3:\"big\";s:8:\"not null\";b:0;}s:12:\"body_summary\";a:3:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:3:\"big\";s:8:\"not null\";b:0;}s:11:\"body_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:5:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:11:\"body_format\";a:1:{i:0;s:11:\"body_format\";}}s:12:\"foreign keys\";a:1:{s:11:\"body_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:11:\"body_format\";s:6:\"format\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:15:\"field_data_body\";}s:19:\"field_revision_body\";a:6:{s:6:\"fields\";a:10:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:10:\"body_value\";a:3:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:3:\"big\";s:8:\"not null\";b:0;}s:12:\"body_summary\";a:3:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:3:\"big\";s:8:\"not null\";b:0;}s:11:\"body_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:6:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:11:\"revision_id\";i:3;s:7:\"deleted\";i:4;s:5:\"delta\";i:5;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:11:\"body_format\";a:1:{i:0;s:11:\"body_format\";}}s:12:\"foreign keys\";a:1:{s:11:\"body_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:11:\"body_format\";s:6:\"format\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:19:\"field_revision_body\";}s:21:\"field_data_field_tags\";a:6:{s:6:\"fields\";a:8:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:14:\"field_tags_tid\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:5:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:14:\"field_tags_tid\";a:1:{i:0;s:14:\"field_tags_tid\";}}s:12:\"foreign keys\";a:1:{s:14:\"field_tags_tid\";a:2:{s:5:\"table\";s:18:\"taxonomy_term_data\";s:7:\"columns\";a:1:{s:14:\"field_tags_tid\";s:3:\"tid\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:21:\"field_data_field_tags\";}s:25:\"field_revision_field_tags\";a:6:{s:6:\"fields\";a:8:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:14:\"field_tags_tid\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:6:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:11:\"revision_id\";i:3;s:7:\"deleted\";i:4;s:5:\"delta\";i:5;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:14:\"field_tags_tid\";a:1:{i:0;s:14:\"field_tags_tid\";}}s:12:\"foreign keys\";a:1:{s:14:\"field_tags_tid\";a:2:{s:5:\"table\";s:18:\"taxonomy_term_data\";s:7:\"columns\";a:1:{s:14:\"field_tags_tid\";s:3:\"tid\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:25:\"field_revision_field_tags\";}s:22:\"field_data_field_image\";a:6:{s:6:\"fields\";a:12:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:15:\"field_image_fid\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;s:8:\"unsigned\";b:1;}s:15:\"field_image_alt\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:512;s:8:\"not null\";b:0;}s:17:\"field_image_title\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:1024;s:8:\"not null\";b:0;}s:17:\"field_image_width\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;}s:18:\"field_image_height\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;}}s:11:\"primary key\";a:5:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:15:\"field_image_fid\";a:1:{i:0;s:15:\"field_image_fid\";}}s:12:\"foreign keys\";a:1:{s:15:\"field_image_fid\";a:2:{s:5:\"table\";s:12:\"file_managed\";s:7:\"columns\";a:1:{s:15:\"field_image_fid\";s:3:\"fid\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:22:\"field_data_field_image\";}s:26:\"field_revision_field_image\";a:6:{s:6:\"fields\";a:12:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:15:\"field_image_fid\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;s:8:\"unsigned\";b:1;}s:15:\"field_image_alt\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:512;s:8:\"not null\";b:0;}s:17:\"field_image_title\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:1024;s:8:\"not null\";b:0;}s:17:\"field_image_width\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;}s:18:\"field_image_height\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;}}s:11:\"primary key\";a:6:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:11:\"revision_id\";i:3;s:7:\"deleted\";i:4;s:5:\"delta\";i:5;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:15:\"field_image_fid\";a:1:{i:0;s:15:\"field_image_fid\";}}s:12:\"foreign keys\";a:1:{s:15:\"field_image_fid\";a:2:{s:5:\"table\";s:12:\"file_managed\";s:7:\"columns\";a:1:{s:15:\"field_image_fid\";s:3:\"fid\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:26:\"field_revision_field_image\";}s:26:\"field_data_taxonomy_forums\";a:6:{s:6:\"fields\";a:8:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:19:\"taxonomy_forums_tid\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:5:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:19:\"taxonomy_forums_tid\";a:1:{i:0;s:19:\"taxonomy_forums_tid\";}}s:12:\"foreign keys\";a:1:{s:19:\"taxonomy_forums_tid\";a:2:{s:5:\"table\";s:18:\"taxonomy_term_data\";s:7:\"columns\";a:1:{s:19:\"taxonomy_forums_tid\";s:3:\"tid\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:26:\"field_data_taxonomy_forums\";}s:30:\"field_revision_taxonomy_forums\";a:6:{s:6:\"fields\";a:8:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:19:\"taxonomy_forums_tid\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:6:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:11:\"revision_id\";i:3;s:7:\"deleted\";i:4;s:5:\"delta\";i:5;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:19:\"taxonomy_forums_tid\";a:1:{i:0;s:19:\"taxonomy_forums_tid\";}}s:12:\"foreign keys\";a:1:{s:19:\"taxonomy_forums_tid\";a:2:{s:5:\"table\";s:18:\"taxonomy_term_data\";s:7:\"columns\";a:1:{s:19:\"taxonomy_forums_tid\";s:3:\"tid\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:30:\"field_revision_taxonomy_forums\";}s:21:\"field_data_field_vote\";a:5:{s:6:\"fields\";a:9:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:17:\"field_vote_rating\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;s:8:\"sortable\";b:1;}s:17:\"field_vote_target\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:5:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"language\";}s:7:\"indexes\";a:6:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:21:\"field_data_field_vote\";}s:25:\"field_revision_field_vote\";a:5:{s:6:\"fields\";a:9:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:17:\"field_vote_rating\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;s:8:\"sortable\";b:1;}s:17:\"field_vote_target\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:6:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:11:\"revision_id\";i:3;s:7:\"deleted\";i:4;s:5:\"delta\";i:5;s:8:\"language\";}s:7:\"indexes\";a:6:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:25:\"field_revision_field_vote\";}s:23:\"field_data_message_text\";a:6:{s:6:\"fields\";a:9:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:18:\"message_text_value\";a:3:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:3:\"big\";s:8:\"not null\";b:0;}s:19:\"message_text_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:5:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:19:\"message_text_format\";a:1:{i:0;s:19:\"message_text_format\";}}s:12:\"foreign keys\";a:1:{s:19:\"message_text_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:19:\"message_text_format\";s:6:\"format\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:23:\"field_data_message_text\";}s:27:\"field_revision_message_text\";a:6:{s:6:\"fields\";a:9:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:18:\"message_text_value\";a:3:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:3:\"big\";s:8:\"not null\";b:0;}s:19:\"message_text_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:6:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:11:\"revision_id\";i:3;s:7:\"deleted\";i:4;s:5:\"delta\";i:5;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:19:\"message_text_format\";a:1:{i:0;s:19:\"message_text_format\";}}s:12:\"foreign keys\";a:1:{s:19:\"message_text_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:19:\"message_text_format\";s:6:\"format\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:27:\"field_revision_message_text\";}s:28:\"field_data_field_comment_ref\";a:5:{s:6:\"fields\";a:8:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:27:\"field_comment_ref_target_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}}s:11:\"primary key\";a:5:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:27:\"field_comment_ref_target_id\";a:1:{i:0;s:27:\"field_comment_ref_target_id\";}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:28:\"field_data_field_comment_ref\";}s:32:\"field_revision_field_comment_ref\";a:5:{s:6:\"fields\";a:8:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:27:\"field_comment_ref_target_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}}s:11:\"primary key\";a:6:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:11:\"revision_id\";i:3;s:7:\"deleted\";i:4;s:5:\"delta\";i:5;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:27:\"field_comment_ref_target_id\";a:1:{i:0;s:27:\"field_comment_ref_target_id\";}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:32:\"field_revision_field_comment_ref\";}s:25:\"field_data_field_node_ref\";a:5:{s:6:\"fields\";a:8:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:24:\"field_node_ref_target_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}}s:11:\"primary key\";a:5:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:24:\"field_node_ref_target_id\";a:1:{i:0;s:24:\"field_node_ref_target_id\";}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:25:\"field_data_field_node_ref\";}s:29:\"field_revision_field_node_ref\";a:5:{s:6:\"fields\";a:8:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:24:\"field_node_ref_target_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}}s:11:\"primary key\";a:6:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:11:\"revision_id\";i:3;s:7:\"deleted\";i:4;s:5:\"delta\";i:5;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:24:\"field_node_ref_target_id\";a:1:{i:0;s:24:\"field_node_ref_target_id\";}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:29:\"field_revision_field_node_ref\";}s:26:\"field_data_field_published\";a:5:{s:6:\"fields\";a:8:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:21:\"field_published_value\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;}}s:11:\"primary key\";a:5:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:21:\"field_published_value\";a:1:{i:0;s:21:\"field_published_value\";}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:26:\"field_data_field_published\";}s:30:\"field_revision_field_published\";a:5:{s:6:\"fields\";a:8:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:21:\"field_published_value\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;}}s:11:\"primary key\";a:6:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:11:\"revision_id\";i:3;s:7:\"deleted\";i:4;s:5:\"delta\";i:5;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:21:\"field_published_value\";a:1:{i:0;s:21:\"field_published_value\";}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:30:\"field_revision_field_published\";}s:24:\"field_data_field_section\";a:6:{s:6:\"fields\";a:8:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:17:\"field_section_tid\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:5:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:17:\"field_section_tid\";a:1:{i:0;s:17:\"field_section_tid\";}}s:12:\"foreign keys\";a:1:{s:17:\"field_section_tid\";a:2:{s:5:\"table\";s:18:\"taxonomy_term_data\";s:7:\"columns\";a:1:{s:17:\"field_section_tid\";s:3:\"tid\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:24:\"field_data_field_section\";}s:28:\"field_revision_field_section\";a:6:{s:6:\"fields\";a:8:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:17:\"field_section_tid\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:6:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:11:\"revision_id\";i:3;s:7:\"deleted\";i:4;s:5:\"delta\";i:5;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:17:\"field_section_tid\";a:1:{i:0;s:17:\"field_section_tid\";}}s:12:\"foreign keys\";a:1:{s:17:\"field_section_tid\";a:2:{s:5:\"table\";s:18:\"taxonomy_term_data\";s:7:\"columns\";a:1:{s:17:\"field_section_tid\";s:3:\"tid\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:28:\"field_revision_field_section\";}s:25:\"field_data_field_category\";a:6:{s:6:\"fields\";a:8:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:18:\"field_category_tid\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:5:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:18:\"field_category_tid\";a:1:{i:0;s:18:\"field_category_tid\";}}s:12:\"foreign keys\";a:1:{s:18:\"field_category_tid\";a:2:{s:5:\"table\";s:18:\"taxonomy_term_data\";s:7:\"columns\";a:1:{s:18:\"field_category_tid\";s:3:\"tid\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:25:\"field_data_field_category\";}s:29:\"field_revision_field_category\";a:6:{s:6:\"fields\";a:8:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:18:\"field_category_tid\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:6:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:11:\"revision_id\";i:3;s:7:\"deleted\";i:4;s:5:\"delta\";i:5;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:18:\"field_category_tid\";a:1:{i:0;s:18:\"field_category_tid\";}}s:12:\"foreign keys\";a:1:{s:18:\"field_category_tid\";a:2:{s:5:\"table\";s:18:\"taxonomy_term_data\";s:7:\"columns\";a:1:{s:18:\"field_category_tid\";s:3:\"tid\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:29:\"field_revision_field_category\";}s:27:\"field_data_field_video_link\";a:5:{s:6:\"fields\";a:12:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:26:\"field_video_link_video_url\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:512;s:7:\"default\";s:0:\"\";}s:31:\"field_video_link_thumbnail_path\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:512;s:7:\"default\";s:0:\"\";}s:27:\"field_video_link_video_data\";a:4:{s:4:\"type\";s:4:\"blob\";s:8:\"not null\";b:0;s:4:\"size\";s:3:\"big\";s:9:\"serialize\";b:1;}s:27:\"field_video_link_embed_code\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:1024;s:7:\"default\";s:0:\"\";}s:28:\"field_video_link_description\";a:2:{s:4:\"type\";s:4:\"text\";s:8:\"not null\";b:0;}}s:11:\"primary key\";a:5:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"language\";}s:7:\"indexes\";a:6:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:27:\"field_data_field_video_link\";}s:31:\"field_revision_field_video_link\";a:5:{s:6:\"fields\";a:12:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:26:\"field_video_link_video_url\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:512;s:7:\"default\";s:0:\"\";}s:31:\"field_video_link_thumbnail_path\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:512;s:7:\"default\";s:0:\"\";}s:27:\"field_video_link_video_data\";a:4:{s:4:\"type\";s:4:\"blob\";s:8:\"not null\";b:0;s:4:\"size\";s:3:\"big\";s:9:\"serialize\";b:1;}s:27:\"field_video_link_embed_code\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:1024;s:7:\"default\";s:0:\"\";}s:28:\"field_video_link_description\";a:2:{s:4:\"type\";s:4:\"text\";s:8:\"not null\";b:0;}}s:11:\"primary key\";a:6:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:11:\"revision_id\";i:3;s:7:\"deleted\";i:4;s:5:\"delta\";i:5;s:8:\"language\";}s:7:\"indexes\";a:6:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:31:\"field_revision_field_video_link\";}s:21:\"field_data_field_link\";a:5:{s:6:\"fields\";a:10:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:14:\"field_link_url\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:2048;s:8:\"not null\";b:0;s:8:\"sortable\";b:1;}s:16:\"field_link_title\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;s:8:\"sortable\";b:1;}s:21:\"field_link_attributes\";a:3:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:6:\"medium\";s:8:\"not null\";b:0;}}s:11:\"primary key\";a:5:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"language\";}s:7:\"indexes\";a:6:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:21:\"field_data_field_link\";}s:25:\"field_revision_field_link\";a:5:{s:6:\"fields\";a:10:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:14:\"field_link_url\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:2048;s:8:\"not null\";b:0;s:8:\"sortable\";b:1;}s:16:\"field_link_title\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;s:8:\"sortable\";b:1;}s:21:\"field_link_attributes\";a:3:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:6:\"medium\";s:8:\"not null\";b:0;}}s:11:\"primary key\";a:6:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:11:\"revision_id\";i:3;s:7:\"deleted\";i:4;s:5:\"delta\";i:5;s:8:\"language\";}s:7:\"indexes\";a:6:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:25:\"field_revision_field_link\";}s:30:\"field_data_field_extra_content\";a:5:{s:6:\"fields\";a:9:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:25:\"field_extra_content_value\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;}s:31:\"field_extra_content_revision_id\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;}}s:11:\"primary key\";a:5:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:31:\"field_extra_content_revision_id\";a:1:{i:0;s:31:\"field_extra_content_revision_id\";}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:30:\"field_data_field_extra_content\";}s:34:\"field_revision_field_extra_content\";a:5:{s:6:\"fields\";a:9:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:25:\"field_extra_content_value\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;}s:31:\"field_extra_content_revision_id\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;}}s:11:\"primary key\";a:6:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:11:\"revision_id\";i:3;s:7:\"deleted\";i:4;s:5:\"delta\";i:5;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:31:\"field_extra_content_revision_id\";a:1:{i:0;s:31:\"field_extra_content_revision_id\";}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:34:\"field_revision_field_extra_content\";}s:28:\"field_data_field_description\";a:6:{s:6:\"fields\";a:9:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:23:\"field_description_value\";a:3:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:3:\"big\";s:8:\"not null\";b:0;}s:24:\"field_description_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:5:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:24:\"field_description_format\";a:1:{i:0;s:24:\"field_description_format\";}}s:12:\"foreign keys\";a:1:{s:24:\"field_description_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:24:\"field_description_format\";s:6:\"format\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:28:\"field_data_field_description\";}s:32:\"field_revision_field_description\";a:6:{s:6:\"fields\";a:9:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:23:\"field_description_value\";a:3:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:3:\"big\";s:8:\"not null\";b:0;}s:24:\"field_description_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:6:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:11:\"revision_id\";i:3;s:7:\"deleted\";i:4;s:5:\"delta\";i:5;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:24:\"field_description_format\";a:1:{i:0;s:24:\"field_description_format\";}}s:12:\"foreign keys\";a:1:{s:24:\"field_description_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:24:\"field_description_format\";s:6:\"format\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:32:\"field_revision_field_description\";}s:34:\"field_data_field_detailed_question\";a:6:{s:6:\"fields\";a:9:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:29:\"field_detailed_question_value\";a:3:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:3:\"big\";s:8:\"not null\";b:0;}s:30:\"field_detailed_question_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:5:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:7:\"deleted\";i:3;s:5:\"delta\";i:4;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:30:\"field_detailed_question_format\";a:1:{i:0;s:30:\"field_detailed_question_format\";}}s:12:\"foreign keys\";a:1:{s:30:\"field_detailed_question_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:30:\"field_detailed_question_format\";s:6:\"format\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:34:\"field_data_field_detailed_question\";}s:38:\"field_revision_field_detailed_question\";a:6:{s:6:\"fields\";a:9:{s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"deleted\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"entity_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"delta\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:29:\"field_detailed_question_value\";a:3:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:3:\"big\";s:8:\"not null\";b:0;}s:30:\"field_detailed_question_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:6:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:11:\"revision_id\";i:3;s:7:\"deleted\";i:4;s:5:\"delta\";i:5;s:8:\"language\";}s:7:\"indexes\";a:7:{s:11:\"entity_type\";a:1:{i:0;s:11:\"entity_type\";}s:6:\"bundle\";a:1:{i:0;s:6:\"bundle\";}s:7:\"deleted\";a:1:{i:0;s:7:\"deleted\";}s:9:\"entity_id\";a:1:{i:0;s:9:\"entity_id\";}s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}s:30:\"field_detailed_question_format\";a:1:{i:0;s:30:\"field_detailed_question_format\";}}s:12:\"foreign keys\";a:1:{s:30:\"field_detailed_question_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:30:\"field_detailed_question_format\";s:6:\"format\";}}}s:6:\"module\";s:17:\"field_sql_storage\";s:4:\"name\";s:38:\"field_revision_field_detailed_question\";}s:6:\"filter\";a:5:{s:6:\"fields\";a:6:{s:6:\"format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;}s:6:\"module\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:64;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:4:\"name\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"weight\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:6:\"status\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:8:\"settings\";a:4:{s:4:\"type\";s:4:\"blob\";s:8:\"not null\";b:0;s:4:\"size\";s:3:\"big\";s:9:\"serialize\";b:1;}}s:11:\"primary key\";a:2:{i:0;s:6:\"format\";i:1;s:4:\"name\";}s:7:\"indexes\";a:1:{s:4:\"list\";a:3:{i:0;s:6:\"weight\";i:1;s:6:\"module\";i:2;s:4:\"name\";}}s:6:\"module\";s:6:\"filter\";s:4:\"name\";s:6:\"filter\";}s:13:\"filter_format\";a:6:{s:6:\"fields\";a:5:{s:6:\"format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;}s:4:\"name\";a:5:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:12:\"translatable\";b:1;}s:5:\"cache\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:4:\"size\";s:4:\"tiny\";}s:6:\"status\";a:5:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:1;s:4:\"size\";s:4:\"tiny\";}s:6:\"weight\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}}s:11:\"primary key\";a:1:{i:0;s:6:\"format\";}s:11:\"unique keys\";a:1:{s:4:\"name\";a:1:{i:0;s:4:\"name\";}}s:7:\"indexes\";a:1:{s:13:\"status_weight\";a:2:{i:0;s:6:\"status\";i:1;s:6:\"weight\";}}s:6:\"module\";s:6:\"filter\";s:4:\"name\";s:13:\"filter_format\";}s:12:\"cache_filter\";a:5:{s:6:\"fields\";a:5:{s:3:\"cid\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:4:\"data\";a:3:{s:4:\"type\";s:4:\"blob\";s:8:\"not null\";b:0;s:4:\"size\";s:3:\"big\";}s:6:\"expire\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:7:\"created\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:10:\"serialized\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:5:\"small\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}}s:7:\"indexes\";a:1:{s:6:\"expire\";a:1:{i:0;s:6:\"expire\";}}s:11:\"primary key\";a:1:{i:0;s:3:\"cid\";}s:6:\"module\";s:6:\"filter\";s:4:\"name\";s:12:\"cache_filter\";}s:20:\"flexslider_optionset\";a:5:{s:6:\"export\";a:4:{s:3:\"key\";s:4:\"name\";s:10:\"identifier\";s:6:\"preset\";s:12:\"default hook\";s:26:\"flexslider_default_presets\";s:3:\"api\";a:4:{s:5:\"owner\";s:10:\"flexslider\";s:3:\"api\";s:25:\"flexslider_default_preset\";s:15:\"minimum_version\";i:1;s:15:\"current_version\";i:1;}}s:6:\"fields\";a:6:{s:4:\"name\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;}s:5:\"title\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;}s:5:\"theme\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:7:\"classic\";}s:17:\"imagestyle_normal\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:15:\"flexslider_full\";}s:20:\"imagestyle_thumbnail\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:20:\"flexslider_thumbnail\";}s:7:\"options\";a:3:{s:4:\"type\";s:4:\"blob\";s:4:\"size\";s:3:\"big\";s:9:\"serialize\";b:1;}}s:11:\"primary key\";a:1:{i:0;s:4:\"name\";}s:6:\"module\";s:10:\"flexslider\";s:4:\"name\";s:20:\"flexslider_optionset\";}s:20:\"i18n_translation_set\";a:5:{s:6:\"fields\";a:8:{s:4:\"tsid\";a:3:{s:4:\"type\";s:6:\"serial\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:5:\"title\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:4:\"type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:9:\"master_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:6:\"status\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:1;}s:7:\"created\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:7:\"changed\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}}s:7:\"indexes\";a:1:{s:13:\"entity_bundle\";a:2:{i:0;s:4:\"type\";i:1;s:6:\"bundle\";}}s:11:\"primary key\";a:1:{i:0;s:4:\"tsid\";}s:6:\"module\";s:16:\"i18n_translation\";s:4:\"name\";s:20:\"i18n_translation_set\";}s:11:\"cache_image\";a:5:{s:6:\"fields\";a:5:{s:3:\"cid\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:4:\"data\";a:3:{s:4:\"type\";s:4:\"blob\";s:8:\"not null\";b:0;s:4:\"size\";s:3:\"big\";}s:6:\"expire\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:7:\"created\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:10:\"serialized\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:5:\"small\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}}s:7:\"indexes\";a:1:{s:6:\"expire\";a:1:{i:0;s:6:\"expire\";}}s:11:\"primary key\";a:1:{i:0;s:3:\"cid\";}s:6:\"module\";s:5:\"image\";s:4:\"name\";s:11:\"cache_image\";}s:12:\"image_styles\";a:5:{s:6:\"fields\";a:3:{s:4:\"isid\";a:3:{s:4:\"type\";s:6:\"serial\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:4:\"name\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;}s:5:\"label\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}}s:11:\"primary key\";a:1:{i:0;s:4:\"isid\";}s:11:\"unique keys\";a:1:{s:4:\"name\";a:1:{i:0;s:4:\"name\";}}s:6:\"module\";s:5:\"image\";s:4:\"name\";s:12:\"image_styles\";}s:13:\"image_effects\";a:6:{s:6:\"fields\";a:5:{s:4:\"ieid\";a:3:{s:4:\"type\";s:6:\"serial\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:4:\"isid\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:6:\"weight\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:0;s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:4:\"name\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;}s:4:\"data\";a:4:{s:4:\"type\";s:4:\"blob\";s:8:\"not null\";b:1;s:4:\"size\";s:3:\"big\";s:9:\"serialize\";b:1;}}s:11:\"primary key\";a:1:{i:0;s:4:\"ieid\";}s:7:\"indexes\";a:2:{s:4:\"isid\";a:1:{i:0;s:4:\"isid\";}s:6:\"weight\";a:1:{i:0;s:6:\"weight\";}}s:12:\"foreign keys\";a:1:{s:11:\"image_style\";a:2:{s:5:\"table\";s:12:\"image_styles\";s:7:\"columns\";a:1:{s:4:\"isid\";s:4:\"isid\";}}}s:6:\"module\";s:5:\"image\";s:4:\"name\";s:13:\"image_effects\";}s:15:\"cache_libraries\";a:5:{s:6:\"fields\";a:5:{s:3:\"cid\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:4:\"data\";a:3:{s:4:\"type\";s:4:\"blob\";s:8:\"not null\";b:0;s:4:\"size\";s:3:\"big\";}s:6:\"expire\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:7:\"created\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:10:\"serialized\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:5:\"small\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}}s:7:\"indexes\";a:1:{s:6:\"expire\";a:1:{i:0;s:6:\"expire\";}}s:11:\"primary key\";a:1:{i:0;s:3:\"cid\";}s:6:\"module\";s:9:\"libraries\";s:4:\"name\";s:15:\"cache_libraries\";}s:9:\"languages\";a:5:{s:6:\"fields\";a:11:{s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:12;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:4:\"name\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:64;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"native\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:64;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:9:\"direction\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:7:\"enabled\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:7:\"plurals\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:7:\"formula\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"domain\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"prefix\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"weight\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:10:\"javascript\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:64;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}}s:11:\"primary key\";a:1:{i:0;s:8:\"language\";}s:7:\"indexes\";a:1:{s:4:\"list\";a:2:{i:0;s:6:\"weight\";i:1;s:4:\"name\";}}s:6:\"module\";s:6:\"locale\";s:4:\"name\";s:9:\"languages\";}s:14:\"locales_source\";a:5:{s:6:\"fields\";a:6:{s:3:\"lid\";a:2:{s:4:\"type\";s:6:\"serial\";s:8:\"not null\";b:1;}s:8:\"location\";a:3:{s:4:\"type\";s:4:\"text\";s:8:\"not null\";b:0;s:4:\"size\";s:3:\"big\";}s:9:\"textgroup\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:7:\"default\";}s:6:\"source\";a:3:{s:4:\"type\";s:4:\"text\";s:10:\"mysql_type\";s:4:\"blob\";s:8:\"not null\";b:1;}s:7:\"context\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"version\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:20;s:8:\"not null\";b:1;s:7:\"default\";s:4:\"none\";}}s:11:\"primary key\";a:1:{i:0;s:3:\"lid\";}s:7:\"indexes\";a:1:{s:14:\"source_context\";a:2:{i:0;a:2:{i:0;s:6:\"source\";i:1;i:30;}i:1;s:7:\"context\";}}s:6:\"module\";s:6:\"locale\";s:4:\"name\";s:14:\"locales_source\";}s:14:\"locales_target\";a:6:{s:6:\"fields\";a:6:{s:3:\"lid\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:11:\"translation\";a:3:{s:4:\"type\";s:4:\"text\";s:10:\"mysql_type\";s:4:\"blob\";s:8:\"not null\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:12;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:4:\"plid\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:6:\"plural\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:11:\"i18n_status\";a:4:{s:11:\"description\";s:66:\"A boolean indicating whether this translation needs to be updated.\";s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}}s:11:\"primary key\";a:3:{i:0;s:8:\"language\";i:1;s:3:\"lid\";i:2;s:6:\"plural\";}s:12:\"foreign keys\";a:1:{s:14:\"locales_source\";a:2:{s:5:\"table\";s:14:\"locales_source\";s:7:\"columns\";a:1:{s:3:\"lid\";s:3:\"lid\";}}}s:7:\"indexes\";a:3:{s:3:\"lid\";a:1:{i:0;s:3:\"lid\";}s:4:\"plid\";a:1:{i:0;s:4:\"plid\";}s:6:\"plural\";a:1:{i:0;s:6:\"plural\";}}s:6:\"module\";s:6:\"locale\";s:4:\"name\";s:14:\"locales_target\";}s:11:\"menu_custom\";a:4:{s:6:\"fields\";a:3:{s:9:\"menu_name\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"title\";a:5:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:12:\"translatable\";b:1;}s:11:\"description\";a:3:{s:4:\"type\";s:4:\"text\";s:8:\"not null\";b:0;s:12:\"translatable\";b:1;}}s:11:\"primary key\";a:1:{i:0;s:9:\"menu_name\";}s:6:\"module\";s:4:\"menu\";s:4:\"name\";s:11:\"menu_custom\";}s:21:\"message_type_category\";a:5:{s:6:\"fields\";a:6:{s:2:\"id\";a:2:{s:4:\"type\";s:6:\"serial\";s:8:\"not null\";b:1;}s:8:\"category\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:11:\"description\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:12;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"status\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:1;s:4:\"size\";s:4:\"tiny\";}s:6:\"module\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:1:{i:0;s:2:\"id\";}s:11:\"unique keys\";a:1:{s:8:\"category\";a:1:{i:0;s:8:\"category\";}}s:6:\"module\";s:7:\"message\";s:4:\"name\";s:21:\"message_type_category\";}s:12:\"message_type\";a:5:{s:6:\"fields\";a:10:{s:2:\"id\";a:2:{s:4:\"type\";s:6:\"serial\";s:8:\"not null\";b:1;}s:4:\"name\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:8:\"category\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:12:\"message_type\";}s:11:\"description\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:13:\"argument_keys\";a:2:{s:4:\"type\";s:4:\"text\";s:9:\"serialize\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:12;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"status\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:1;s:4:\"size\";s:4:\"tiny\";}s:6:\"module\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}s:9:\"arguments\";a:2:{s:4:\"type\";s:4:\"text\";s:9:\"serialize\";b:1;}s:4:\"data\";a:3:{s:4:\"type\";s:4:\"text\";s:9:\"serialize\";b:1;s:4:\"size\";s:3:\"big\";}}s:11:\"primary key\";a:1:{i:0;s:2:\"id\";}s:11:\"unique keys\";a:1:{s:4:\"name\";a:1:{i:0;s:4:\"name\";}}s:6:\"module\";s:7:\"message\";s:4:\"name\";s:12:\"message_type\";}s:7:\"message\";a:6:{s:6:\"fields\";a:6:{s:3:\"mid\";a:2:{s:4:\"type\";s:6:\"serial\";s:8:\"unsigned\";b:1;}s:4:\"type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:9:\"arguments\";a:2:{s:4:\"type\";s:4:\"text\";s:9:\"serialize\";b:1;}s:3:\"uid\";a:3:{s:4:\"type\";s:3:\"int\";s:13:\"default value\";N;s:8:\"unsigned\";b:1;}s:9:\"timestamp\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:8:\"unsigned\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:12;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}}s:12:\"foreign keys\";a:2:{s:12:\"message_type\";a:2:{s:5:\"table\";s:12:\"message_type\";s:7:\"columns\";a:1:{s:4:\"type\";s:4:\"name\";}}s:5:\"owner\";a:2:{s:5:\"table\";s:5:\"users\";s:7:\"columns\";a:1:{s:3:\"uid\";s:3:\"uid\";}}}s:11:\"primary key\";a:1:{i:0;s:3:\"mid\";}s:7:\"indexes\";a:2:{s:10:\"type_index\";a:1:{i:0;s:4:\"type\";}s:9:\"timestamp\";a:1:{i:0;s:9:\"timestamp\";}}s:6:\"module\";s:7:\"message\";s:4:\"name\";s:7:\"message\";}s:34:\"cache_entity_message_type_category\";a:5:{s:6:\"fields\";a:5:{s:3:\"cid\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:4:\"data\";a:3:{s:4:\"type\";s:4:\"blob\";s:8:\"not null\";b:0;s:4:\"size\";s:3:\"big\";}s:6:\"expire\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:7:\"created\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:10:\"serialized\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:5:\"small\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}}s:7:\"indexes\";a:1:{s:6:\"expire\";a:1:{i:0;s:6:\"expire\";}}s:11:\"primary key\";a:1:{i:0;s:3:\"cid\";}s:6:\"module\";s:7:\"message\";s:4:\"name\";s:34:\"cache_entity_message_type_category\";}s:25:\"cache_entity_message_type\";a:5:{s:6:\"fields\";a:5:{s:3:\"cid\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:4:\"data\";a:3:{s:4:\"type\";s:4:\"blob\";s:8:\"not null\";b:0;s:4:\"size\";s:3:\"big\";}s:6:\"expire\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:7:\"created\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:10:\"serialized\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:5:\"small\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}}s:7:\"indexes\";a:1:{s:6:\"expire\";a:1:{i:0;s:6:\"expire\";}}s:11:\"primary key\";a:1:{i:0;s:3:\"cid\";}s:6:\"module\";s:7:\"message\";s:4:\"name\";s:25:\"cache_entity_message_type\";}s:20:\"cache_entity_message\";a:5:{s:6:\"fields\";a:5:{s:3:\"cid\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:4:\"data\";a:3:{s:4:\"type\";s:4:\"blob\";s:8:\"not null\";b:0;s:4:\"size\";s:3:\"big\";}s:6:\"expire\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:7:\"created\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:10:\"serialized\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:5:\"small\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}}s:7:\"indexes\";a:1:{s:6:\"expire\";a:1:{i:0;s:6:\"expire\";}}s:11:\"primary key\";a:1:{i:0;s:3:\"cid\";}s:6:\"module\";s:7:\"message\";s:4:\"name\";s:20:\"cache_entity_message\";}s:4:\"node\";a:7:{s:6:\"fields\";a:14:{s:3:\"nid\";a:3:{s:4:\"type\";s:6:\"serial\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:3:\"vid\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;s:7:\"default\";N;}s:4:\"type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:12;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"title\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:3:\"uid\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:6:\"status\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:1;}s:7:\"created\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:7:\"changed\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:7:\"comment\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:7:\"promote\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:6:\"sticky\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:4:\"tnid\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"translate\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}}s:7:\"indexes\";a:10:{s:12:\"node_changed\";a:1:{i:0;s:7:\"changed\";}s:12:\"node_created\";a:1:{i:0;s:7:\"created\";}s:14:\"node_frontpage\";a:4:{i:0;s:7:\"promote\";i:1;s:6:\"status\";i:2;s:6:\"sticky\";i:3;s:7:\"created\";}s:16:\"node_status_type\";a:3:{i:0;s:6:\"status\";i:1;s:4:\"type\";i:2;s:3:\"nid\";}s:15:\"node_title_type\";a:2:{i:0;s:5:\"title\";i:1;a:2:{i:0;s:4:\"type\";i:1;i:4;}}s:9:\"node_type\";a:1:{i:0;a:2:{i:0;s:4:\"type\";i:1;i:4;}}s:3:\"uid\";a:1:{i:0;s:3:\"uid\";}s:4:\"tnid\";a:1:{i:0;s:4:\"tnid\";}s:9:\"translate\";a:1:{i:0;s:9:\"translate\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}}s:11:\"unique keys\";a:1:{s:3:\"vid\";a:1:{i:0;s:3:\"vid\";}}s:12:\"foreign keys\";a:2:{s:13:\"node_revision\";a:2:{s:5:\"table\";s:13:\"node_revision\";s:7:\"columns\";a:1:{s:3:\"vid\";s:3:\"vid\";}}s:11:\"node_author\";a:2:{s:5:\"table\";s:5:\"users\";s:7:\"columns\";a:1:{s:3:\"uid\";s:3:\"uid\";}}}s:11:\"primary key\";a:1:{i:0;s:3:\"nid\";}s:6:\"module\";s:4:\"node\";s:4:\"name\";s:4:\"node\";}s:11:\"node_access\";a:5:{s:6:\"fields\";a:6:{s:3:\"nid\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:3:\"gid\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:5:\"realm\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:10:\"grant_view\";a:5:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;s:4:\"size\";s:4:\"tiny\";}s:12:\"grant_update\";a:5:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;s:4:\"size\";s:4:\"tiny\";}s:12:\"grant_delete\";a:5:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;s:4:\"size\";s:4:\"tiny\";}}s:11:\"primary key\";a:3:{i:0;s:3:\"nid\";i:1;s:3:\"gid\";i:2;s:5:\"realm\";}s:12:\"foreign keys\";a:1:{s:13:\"affected_node\";a:2:{s:5:\"table\";s:4:\"node\";s:7:\"columns\";a:1:{s:3:\"nid\";s:3:\"nid\";}}}s:6:\"module\";s:4:\"node\";s:4:\"name\";s:11:\"node_access\";}s:13:\"node_revision\";a:6:{s:6:\"fields\";a:10:{s:3:\"nid\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:3:\"vid\";a:3:{s:4:\"type\";s:6:\"serial\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:3:\"uid\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:5:\"title\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:3:\"log\";a:3:{s:4:\"type\";s:4:\"text\";s:8:\"not null\";b:1;s:4:\"size\";s:3:\"big\";}s:9:\"timestamp\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:6:\"status\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:1;}s:7:\"comment\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:7:\"promote\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:6:\"sticky\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}}s:7:\"indexes\";a:2:{s:3:\"nid\";a:1:{i:0;s:3:\"nid\";}s:3:\"uid\";a:1:{i:0;s:3:\"uid\";}}s:11:\"primary key\";a:1:{i:0;s:3:\"vid\";}s:12:\"foreign keys\";a:2:{s:14:\"versioned_node\";a:2:{s:5:\"table\";s:4:\"node\";s:7:\"columns\";a:1:{s:3:\"nid\";s:3:\"nid\";}}s:14:\"version_author\";a:2:{s:5:\"table\";s:5:\"users\";s:7:\"columns\";a:1:{s:3:\"uid\";s:3:\"uid\";}}}s:6:\"module\";s:4:\"node\";s:4:\"name\";s:13:\"node_revision\";}s:9:\"node_type\";a:4:{s:6:\"fields\";a:13:{s:4:\"type\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;}s:4:\"name\";a:5:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:12:\"translatable\";b:1;}s:4:\"base\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;}s:6:\"module\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;}s:11:\"description\";a:4:{s:4:\"type\";s:4:\"text\";s:8:\"not null\";b:1;s:4:\"size\";s:6:\"medium\";s:12:\"translatable\";b:1;}s:4:\"help\";a:4:{s:4:\"type\";s:4:\"text\";s:8:\"not null\";b:1;s:4:\"size\";s:6:\"medium\";s:12:\"translatable\";b:1;}s:9:\"has_title\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:4:\"size\";s:4:\"tiny\";}s:11:\"title_label\";a:5:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:12:\"translatable\";b:1;}s:6:\"custom\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:4:\"size\";s:4:\"tiny\";}s:8:\"modified\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:4:\"size\";s:4:\"tiny\";}s:6:\"locked\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:4:\"size\";s:4:\"tiny\";}s:8:\"disabled\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:4:\"size\";s:4:\"tiny\";}s:9:\"orig_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}}s:11:\"primary key\";a:1:{i:0;s:4:\"type\";}s:6:\"module\";s:4:\"node\";s:4:\"name\";s:9:\"node_type\";}s:15:\"block_node_type\";a:5:{s:6:\"fields\";a:3:{s:6:\"module\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:64;s:8:\"not null\";b:1;}s:5:\"delta\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;}s:4:\"type\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;}}s:11:\"primary key\";a:3:{i:0;s:6:\"module\";i:1;s:5:\"delta\";i:2;s:4:\"type\";}s:7:\"indexes\";a:1:{s:4:\"type\";a:1:{i:0;s:4:\"type\";}}s:6:\"module\";s:4:\"node\";s:4:\"name\";s:15:\"block_node_type\";}s:7:\"history\";a:5:{s:6:\"fields\";a:3:{s:3:\"uid\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:3:\"nid\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"timestamp\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}}s:11:\"primary key\";a:2:{i:0;s:3:\"uid\";i:1;s:3:\"nid\";}s:7:\"indexes\";a:1:{s:3:\"nid\";a:1:{i:0;s:3:\"nid\";}}s:6:\"module\";s:4:\"node\";s:4:\"name\";s:7:\"history\";}s:10:\"node_class\";a:4:{s:6:\"fields\";a:2:{s:3:\"nid\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:2:\"32\";s:8:\"not null\";b:1;}s:9:\"css_class\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}}s:11:\"primary key\";a:1:{i:0;s:3:\"nid\";}s:6:\"module\";s:10:\"node_class\";s:4:\"name\";s:10:\"node_class\";}s:9:\"quicktabs\";a:5:{s:6:\"export\";a:5:{s:3:\"key\";s:12:\"machine_name\";s:10:\"identifier\";s:9:\"quicktabs\";s:12:\"default hook\";s:27:\"quicktabs_default_quicktabs\";s:3:\"api\";a:4:{s:5:\"owner\";s:9:\"quicktabs\";s:3:\"api\";s:9:\"quicktabs\";s:15:\"minimum_version\";i:1;s:15:\"current_version\";i:1;}s:15:\"export callback\";s:16:\"quicktabs_export\";}s:6:\"fields\";a:9:{s:12:\"machine_name\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;}s:4:\"ajax\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:15:\"hide_empty_tabs\";a:5:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:11:\"default_tab\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:5:\"title\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;}s:4:\"tabs\";a:4:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:6:\"medium\";s:8:\"not null\";b:1;s:9:\"serialize\";b:1;}s:8:\"renderer\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;}s:5:\"style\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;}s:7:\"options\";a:4:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:6:\"medium\";s:8:\"not null\";b:0;s:9:\"serialize\";b:1;}}s:11:\"primary key\";a:1:{i:0;s:12:\"machine_name\";}s:6:\"module\";s:9:\"quicktabs\";s:4:\"name\";s:9:\"quicktabs\";}s:14:\"search_dataset\";a:4:{s:6:\"fields\";a:4:{s:3:\"sid\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:4:\"type\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:16;s:8:\"not null\";b:1;}s:4:\"data\";a:3:{s:4:\"type\";s:4:\"text\";s:8:\"not null\";b:1;s:4:\"size\";s:3:\"big\";}s:7:\"reindex\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}}s:11:\"primary key\";a:2:{i:0;s:3:\"sid\";i:1;s:4:\"type\";}s:6:\"module\";s:6:\"search\";s:4:\"name\";s:14:\"search_dataset\";}s:12:\"search_index\";a:6:{s:6:\"fields\";a:4:{s:4:\"word\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:50;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:3:\"sid\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:4:\"type\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:16;s:8:\"not null\";b:1;}s:5:\"score\";a:2:{s:4:\"type\";s:5:\"float\";s:8:\"not null\";b:0;}}s:7:\"indexes\";a:1:{s:8:\"sid_type\";a:2:{i:0;s:3:\"sid\";i:1;s:4:\"type\";}}s:12:\"foreign keys\";a:1:{s:14:\"search_dataset\";a:2:{s:5:\"table\";s:14:\"search_dataset\";s:7:\"columns\";a:2:{s:3:\"sid\";s:3:\"sid\";s:4:\"type\";s:4:\"type\";}}}s:11:\"primary key\";a:3:{i:0;s:4:\"word\";i:1;s:3:\"sid\";i:2;s:4:\"type\";}s:6:\"module\";s:6:\"search\";s:4:\"name\";s:12:\"search_index\";}s:12:\"search_total\";a:4:{s:6:\"fields\";a:2:{s:4:\"word\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:50;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"count\";a:2:{s:4:\"type\";s:5:\"float\";s:8:\"not null\";b:0;}}s:11:\"primary key\";a:1:{i:0;s:4:\"word\";}s:6:\"module\";s:6:\"search\";s:4:\"name\";s:12:\"search_total\";}s:17:\"search_node_links\";a:5:{s:6:\"fields\";a:4:{s:3:\"sid\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:4:\"type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:16;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:3:\"nid\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:7:\"caption\";a:3:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:3:\"big\";s:8:\"not null\";b:0;}}s:11:\"primary key\";a:3:{i:0;s:3:\"sid\";i:1;s:4:\"type\";i:2;s:3:\"nid\";}s:7:\"indexes\";a:1:{s:3:\"nid\";a:1:{i:0;s:3:\"nid\";}}s:6:\"module\";s:6:\"search\";s:4:\"name\";s:17:\"search_node_links\";}s:12:\"shortcut_set\";a:5:{s:6:\"fields\";a:2:{s:8:\"set_name\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"title\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}}s:11:\"primary key\";a:1:{i:0;s:8:\"set_name\";}s:12:\"foreign keys\";a:1:{s:9:\"menu_name\";a:2:{s:5:\"table\";s:10:\"menu_links\";s:7:\"columns\";a:1:{s:8:\"set_name\";s:9:\"menu_name\";}}}s:6:\"module\";s:8:\"shortcut\";s:4:\"name\";s:12:\"shortcut_set\";}s:18:\"shortcut_set_users\";a:6:{s:6:\"fields\";a:2:{s:3:\"uid\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:8:\"set_name\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}}s:11:\"primary key\";a:1:{i:0;s:3:\"uid\";}s:7:\"indexes\";a:1:{s:8:\"set_name\";a:1:{i:0;s:8:\"set_name\";}}s:12:\"foreign keys\";a:2:{s:8:\"set_user\";a:2:{s:5:\"table\";s:5:\"users\";s:7:\"columns\";a:1:{s:3:\"uid\";s:3:\"uid\";}}s:8:\"set_name\";a:2:{s:5:\"table\";s:12:\"shortcut_set\";s:7:\"columns\";a:1:{s:8:\"set_name\";s:8:\"set_name\";}}}s:6:\"module\";s:8:\"shortcut\";s:4:\"name\";s:18:\"shortcut_set_users\";}s:9:\"accesslog\";a:6:{s:6:\"fields\";a:9:{s:3:\"aid\";a:2:{s:4:\"type\";s:6:\"serial\";s:8:\"not null\";b:1;}s:3:\"sid\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"title\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}s:4:\"path\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}s:3:\"url\";a:2:{s:4:\"type\";s:4:\"text\";s:8:\"not null\";b:0;}s:8:\"hostname\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:0;}s:3:\"uid\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;s:7:\"default\";i:0;}s:5:\"timer\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"timestamp\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}}s:7:\"indexes\";a:2:{s:19:\"accesslog_timestamp\";a:1:{i:0;s:9:\"timestamp\";}s:3:\"uid\";a:1:{i:0;s:3:\"uid\";}}s:11:\"primary key\";a:1:{i:0;s:3:\"aid\";}s:12:\"foreign keys\";a:1:{s:7:\"visitor\";a:2:{s:5:\"table\";s:5:\"users\";s:7:\"columns\";a:1:{s:3:\"uid\";s:3:\"uid\";}}}s:6:\"module\";s:10:\"statistics\";s:4:\"name\";s:9:\"accesslog\";}s:12:\"node_counter\";a:4:{s:6:\"fields\";a:4:{s:3:\"nid\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:10:\"totalcount\";a:5:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;s:4:\"size\";s:3:\"big\";}s:8:\"daycount\";a:5:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;s:4:\"size\";s:6:\"medium\";}s:9:\"timestamp\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}}s:11:\"primary key\";a:1:{i:0;s:3:\"nid\";}s:6:\"module\";s:10:\"statistics\";s:4:\"name\";s:12:\"node_counter\";}s:8:\"variable\";a:5:{s:6:\"fields\";a:2:{s:4:\"name\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"value\";a:5:{s:4:\"type\";s:4:\"blob\";s:8:\"not null\";b:1;s:4:\"size\";s:3:\"big\";s:12:\"translatable\";b:1;s:9:\"serialize\";b:1;}}s:11:\"primary key\";a:1:{i:0;s:4:\"name\";}s:6:\"module\";s:6:\"system\";s:4:\"name\";s:8:\"variable\";s:6:\"export\";a:4:{s:3:\"key\";s:4:\"name\";s:10:\"identifier\";s:9:\"strongarm\";s:12:\"default hook\";s:9:\"strongarm\";s:3:\"api\";a:4:{s:5:\"owner\";s:9:\"strongarm\";s:3:\"api\";s:9:\"strongarm\";s:15:\"minimum_version\";i:1;s:15:\"current_version\";i:1;}}}s:7:\"actions\";a:4:{s:6:\"fields\";a:5:{s:3:\"aid\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:1:\"0\";}s:4:\"type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:8:\"callback\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:10:\"parameters\";a:3:{s:4:\"type\";s:4:\"blob\";s:8:\"not null\";b:1;s:4:\"size\";s:3:\"big\";}s:5:\"label\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:1:\"0\";}}s:11:\"primary key\";a:1:{i:0;s:3:\"aid\";}s:6:\"module\";s:6:\"system\";s:4:\"name\";s:7:\"actions\";}s:5:\"batch\";a:5:{s:6:\"fields\";a:4:{s:3:\"bid\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:5:\"token\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:64;s:8:\"not null\";b:1;}s:9:\"timestamp\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;}s:5:\"batch\";a:3:{s:4:\"type\";s:4:\"blob\";s:8:\"not null\";b:0;s:4:\"size\";s:3:\"big\";}}s:11:\"primary key\";a:1:{i:0;s:3:\"bid\";}s:7:\"indexes\";a:1:{s:5:\"token\";a:1:{i:0;s:5:\"token\";}}s:6:\"module\";s:6:\"system\";s:4:\"name\";s:5:\"batch\";}s:11:\"blocked_ips\";a:5:{s:6:\"fields\";a:2:{s:3:\"iid\";a:3:{s:4:\"type\";s:6:\"serial\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:2:\"ip\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:40;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}}s:7:\"indexes\";a:1:{s:10:\"blocked_ip\";a:1:{i:0;s:2:\"ip\";}}s:11:\"primary key\";a:1:{i:0;s:3:\"iid\";}s:6:\"module\";s:6:\"system\";s:4:\"name\";s:11:\"blocked_ips\";}s:5:\"cache\";a:5:{s:6:\"fields\";a:5:{s:3:\"cid\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:4:\"data\";a:3:{s:4:\"type\";s:4:\"blob\";s:8:\"not null\";b:0;s:4:\"size\";s:3:\"big\";}s:6:\"expire\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:7:\"created\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:10:\"serialized\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:5:\"small\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}}s:7:\"indexes\";a:1:{s:6:\"expire\";a:1:{i:0;s:6:\"expire\";}}s:11:\"primary key\";a:1:{i:0;s:3:\"cid\";}s:6:\"module\";s:6:\"system\";s:4:\"name\";s:5:\"cache\";}s:15:\"cache_bootstrap\";a:5:{s:6:\"fields\";a:5:{s:3:\"cid\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:4:\"data\";a:3:{s:4:\"type\";s:4:\"blob\";s:8:\"not null\";b:0;s:4:\"size\";s:3:\"big\";}s:6:\"expire\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:7:\"created\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:10:\"serialized\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:5:\"small\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}}s:7:\"indexes\";a:1:{s:6:\"expire\";a:1:{i:0;s:6:\"expire\";}}s:11:\"primary key\";a:1:{i:0;s:3:\"cid\";}s:6:\"module\";s:6:\"system\";s:4:\"name\";s:15:\"cache_bootstrap\";}s:10:\"cache_form\";a:5:{s:6:\"fields\";a:5:{s:3:\"cid\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:4:\"data\";a:3:{s:4:\"type\";s:4:\"blob\";s:8:\"not null\";b:0;s:4:\"size\";s:3:\"big\";}s:6:\"expire\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:7:\"created\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:10:\"serialized\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:5:\"small\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}}s:7:\"indexes\";a:1:{s:6:\"expire\";a:1:{i:0;s:6:\"expire\";}}s:11:\"primary key\";a:1:{i:0;s:3:\"cid\";}s:6:\"module\";s:6:\"system\";s:4:\"name\";s:10:\"cache_form\";}s:10:\"cache_page\";a:5:{s:6:\"fields\";a:5:{s:3:\"cid\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:4:\"data\";a:3:{s:4:\"type\";s:4:\"blob\";s:8:\"not null\";b:0;s:4:\"size\";s:3:\"big\";}s:6:\"expire\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:7:\"created\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:10:\"serialized\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:5:\"small\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}}s:7:\"indexes\";a:1:{s:6:\"expire\";a:1:{i:0;s:6:\"expire\";}}s:11:\"primary key\";a:1:{i:0;s:3:\"cid\";}s:6:\"module\";s:6:\"system\";s:4:\"name\";s:10:\"cache_page\";}s:10:\"cache_menu\";a:5:{s:6:\"fields\";a:5:{s:3:\"cid\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:4:\"data\";a:3:{s:4:\"type\";s:4:\"blob\";s:8:\"not null\";b:0;s:4:\"size\";s:3:\"big\";}s:6:\"expire\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:7:\"created\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:10:\"serialized\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:5:\"small\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}}s:7:\"indexes\";a:1:{s:6:\"expire\";a:1:{i:0;s:6:\"expire\";}}s:11:\"primary key\";a:1:{i:0;s:3:\"cid\";}s:6:\"module\";s:6:\"system\";s:4:\"name\";s:10:\"cache_menu\";}s:10:\"cache_path\";a:5:{s:6:\"fields\";a:5:{s:3:\"cid\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:4:\"data\";a:3:{s:4:\"type\";s:4:\"blob\";s:8:\"not null\";b:0;s:4:\"size\";s:3:\"big\";}s:6:\"expire\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:7:\"created\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:10:\"serialized\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:5:\"small\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}}s:7:\"indexes\";a:1:{s:6:\"expire\";a:1:{i:0;s:6:\"expire\";}}s:11:\"primary key\";a:1:{i:0;s:3:\"cid\";}s:6:\"module\";s:6:\"system\";s:4:\"name\";s:10:\"cache_path\";}s:16:\"date_format_type\";a:5:{s:6:\"fields\";a:3:{s:4:\"type\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:64;s:8:\"not null\";b:1;}s:5:\"title\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;}s:6:\"locked\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:7:\"default\";i:0;s:8:\"not null\";b:1;}}s:11:\"primary key\";a:1:{i:0;s:4:\"type\";}s:7:\"indexes\";a:1:{s:5:\"title\";a:1:{i:0;s:5:\"title\";}}s:6:\"module\";s:6:\"system\";s:4:\"name\";s:16:\"date_format_type\";}s:12:\"date_formats\";a:5:{s:6:\"fields\";a:4:{s:4:\"dfid\";a:3:{s:4:\"type\";s:6:\"serial\";s:8:\"not null\";b:1;s:8:\"unsigned\";b:1;}s:6:\"format\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:100;s:8:\"not null\";b:1;s:6:\"binary\";b:1;}s:4:\"type\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:64;s:8:\"not null\";b:1;}s:6:\"locked\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:4:\"tiny\";s:7:\"default\";i:0;s:8:\"not null\";b:1;}}s:11:\"primary key\";a:1:{i:0;s:4:\"dfid\";}s:11:\"unique keys\";a:1:{s:7:\"formats\";a:2:{i:0;s:6:\"format\";i:1;s:4:\"type\";}}s:6:\"module\";s:6:\"system\";s:4:\"name\";s:12:\"date_formats\";}s:18:\"date_format_locale\";a:4:{s:6:\"fields\";a:3:{s:6:\"format\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:100;s:8:\"not null\";b:1;s:6:\"binary\";b:1;}s:4:\"type\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:64;s:8:\"not null\";b:1;}s:8:\"language\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:12;s:8:\"not null\";b:1;}}s:11:\"primary key\";a:2:{i:0;s:4:\"type\";i:1;s:8:\"language\";}s:6:\"module\";s:6:\"system\";s:4:\"name\";s:18:\"date_format_locale\";}s:12:\"file_managed\";a:7:{s:6:\"fields\";a:8:{s:3:\"fid\";a:3:{s:4:\"type\";s:6:\"serial\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:3:\"uid\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:8:\"filename\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:3:\"uri\";a:5:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:6:\"binary\";b:1;}s:8:\"filemime\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:8:\"filesize\";a:5:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:3:\"big\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:6:\"status\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:4:\"size\";s:4:\"tiny\";}s:9:\"timestamp\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}}s:7:\"indexes\";a:3:{s:3:\"uid\";a:1:{i:0;s:3:\"uid\";}s:6:\"status\";a:1:{i:0;s:6:\"status\";}s:9:\"timestamp\";a:1:{i:0;s:9:\"timestamp\";}}s:11:\"unique keys\";a:1:{s:3:\"uri\";a:1:{i:0;s:3:\"uri\";}}s:11:\"primary key\";a:1:{i:0;s:3:\"fid\";}s:12:\"foreign keys\";a:1:{s:10:\"file_owner\";a:2:{s:5:\"table\";s:5:\"users\";s:7:\"columns\";a:1:{s:3:\"uid\";s:3:\"uid\";}}}s:6:\"module\";s:6:\"system\";s:4:\"name\";s:12:\"file_managed\";}s:10:\"file_usage\";a:5:{s:6:\"fields\";a:5:{s:3:\"fid\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:6:\"module\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:4:\"type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:64;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:2:\"id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:5:\"count\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}}s:11:\"primary key\";a:4:{i:0;s:3:\"fid\";i:1;s:4:\"type\";i:2;s:2:\"id\";i:3;s:6:\"module\";}s:7:\"indexes\";a:3:{s:7:\"type_id\";a:2:{i:0;s:4:\"type\";i:1;s:2:\"id\";}s:9:\"fid_count\";a:2:{i:0;s:3:\"fid\";i:1;s:5:\"count\";}s:10:\"fid_module\";a:2:{i:0;s:3:\"fid\";i:1;s:6:\"module\";}}s:6:\"module\";s:6:\"system\";s:4:\"name\";s:10:\"file_usage\";}s:5:\"flood\";a:5:{s:6:\"fields\";a:5:{s:3:\"fid\";a:2:{s:4:\"type\";s:6:\"serial\";s:8:\"not null\";b:1;}s:5:\"event\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:64;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:10:\"identifier\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:9:\"timestamp\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:10:\"expiration\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}}s:11:\"primary key\";a:1:{i:0;s:3:\"fid\";}s:7:\"indexes\";a:2:{s:5:\"allow\";a:3:{i:0;s:5:\"event\";i:1;s:10:\"identifier\";i:2;s:9:\"timestamp\";}s:5:\"purge\";a:1:{i:0;s:10:\"expiration\";}}s:6:\"module\";s:6:\"system\";s:4:\"name\";s:5:\"flood\";}s:11:\"menu_router\";a:5:{s:6:\"fields\";a:23:{s:4:\"path\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:14:\"load_functions\";a:2:{s:4:\"type\";s:4:\"blob\";s:8:\"not null\";b:1;}s:16:\"to_arg_functions\";a:2:{s:4:\"type\";s:4:\"blob\";s:8:\"not null\";b:1;}s:15:\"access_callback\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:16:\"access_arguments\";a:2:{s:4:\"type\";s:4:\"blob\";s:8:\"not null\";b:0;}s:13:\"page_callback\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:14:\"page_arguments\";a:2:{s:4:\"type\";s:4:\"blob\";s:8:\"not null\";b:0;}s:17:\"delivery_callback\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:3:\"fit\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:12:\"number_parts\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:4:\"size\";s:5:\"small\";}s:7:\"context\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:10:\"tab_parent\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:8:\"tab_root\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"title\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:14:\"title_callback\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:15:\"title_arguments\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:14:\"theme_callback\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:15:\"theme_arguments\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:4:\"type\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:11:\"description\";a:2:{s:4:\"type\";s:4:\"text\";s:8:\"not null\";b:1;}s:8:\"position\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"weight\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:12:\"include_file\";a:2:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:6:\"medium\";}}s:7:\"indexes\";a:3:{s:3:\"fit\";a:1:{i:0;s:3:\"fit\";}s:10:\"tab_parent\";a:3:{i:0;a:2:{i:0;s:10:\"tab_parent\";i:1;i:64;}i:1;s:6:\"weight\";i:2;s:5:\"title\";}s:21:\"tab_root_weight_title\";a:3:{i:0;a:2:{i:0;s:8:\"tab_root\";i:1;i:64;}i:1;s:6:\"weight\";i:2;s:5:\"title\";}}s:11:\"primary key\";a:1:{i:0;s:4:\"path\";}s:6:\"module\";s:6:\"system\";s:4:\"name\";s:11:\"menu_router\";}s:10:\"menu_links\";a:5:{s:6:\"fields\";a:25:{s:9:\"menu_name\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:4:\"mlid\";a:3:{s:4:\"type\";s:6:\"serial\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:4:\"plid\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"link_path\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:11:\"router_path\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:10:\"link_title\";a:5:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:12:\"translatable\";b:1;}s:7:\"options\";a:3:{s:4:\"type\";s:4:\"blob\";s:8:\"not null\";b:0;s:12:\"translatable\";b:1;}s:6:\"module\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:6:\"system\";}s:6:\"hidden\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:4:\"size\";s:5:\"small\";}s:8:\"external\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:4:\"size\";s:5:\"small\";}s:12:\"has_children\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:4:\"size\";s:5:\"small\";}s:8:\"expanded\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:4:\"size\";s:5:\"small\";}s:6:\"weight\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:5:\"depth\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:4:\"size\";s:5:\"small\";}s:10:\"customized\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:4:\"size\";s:5:\"small\";}s:2:\"p1\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:2:\"p2\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:2:\"p3\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:2:\"p4\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:2:\"p5\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:2:\"p6\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:2:\"p7\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:2:\"p8\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:2:\"p9\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:7:\"updated\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:4:\"size\";s:5:\"small\";}}s:7:\"indexes\";a:4:{s:9:\"path_menu\";a:2:{i:0;a:2:{i:0;s:9:\"link_path\";i:1;i:128;}i:1;s:9:\"menu_name\";}s:22:\"menu_plid_expand_child\";a:4:{i:0;s:9:\"menu_name\";i:1;s:4:\"plid\";i:2;s:8:\"expanded\";i:3;s:12:\"has_children\";}s:12:\"menu_parents\";a:10:{i:0;s:9:\"menu_name\";i:1;s:2:\"p1\";i:2;s:2:\"p2\";i:3;s:2:\"p3\";i:4;s:2:\"p4\";i:5;s:2:\"p5\";i:6;s:2:\"p6\";i:7;s:2:\"p7\";i:8;s:2:\"p8\";i:9;s:2:\"p9\";}s:11:\"router_path\";a:1:{i:0;a:2:{i:0;s:11:\"router_path\";i:1;i:128;}}}s:11:\"primary key\";a:1:{i:0;s:4:\"mlid\";}s:6:\"module\";s:6:\"system\";s:4:\"name\";s:10:\"menu_links\";}s:5:\"queue\";a:5:{s:6:\"fields\";a:5:{s:7:\"item_id\";a:3:{s:4:\"type\";s:6:\"serial\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:4:\"name\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:4:\"data\";a:4:{s:4:\"type\";s:4:\"blob\";s:8:\"not null\";b:0;s:4:\"size\";s:3:\"big\";s:9:\"serialize\";b:1;}s:6:\"expire\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:7:\"created\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}}s:11:\"primary key\";a:1:{i:0;s:7:\"item_id\";}s:7:\"indexes\";a:2:{s:12:\"name_created\";a:2:{i:0;s:4:\"name\";i:1;s:7:\"created\";}s:6:\"expire\";a:1:{i:0;s:6:\"expire\";}}s:6:\"module\";s:6:\"system\";s:4:\"name\";s:5:\"queue\";}s:8:\"registry\";a:5:{s:6:\"fields\";a:5:{s:4:\"name\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:4:\"type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:9;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:8:\"filename\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;}s:6:\"module\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"weight\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}}s:11:\"primary key\";a:2:{i:0;s:4:\"name\";i:1;s:4:\"type\";}s:7:\"indexes\";a:1:{s:4:\"hook\";a:3:{i:0;s:4:\"type\";i:1;s:6:\"weight\";i:2;s:6:\"module\";}}s:6:\"module\";s:6:\"system\";s:4:\"name\";s:8:\"registry\";}s:13:\"registry_file\";a:4:{s:6:\"fields\";a:2:{s:8:\"filename\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;}s:4:\"hash\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:64;s:8:\"not null\";b:1;}}s:11:\"primary key\";a:1:{i:0;s:8:\"filename\";}s:6:\"module\";s:6:\"system\";s:4:\"name\";s:13:\"registry_file\";}s:9:\"semaphore\";a:5:{s:6:\"fields\";a:3:{s:4:\"name\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"value\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"expire\";a:3:{s:4:\"type\";s:5:\"float\";s:4:\"size\";s:3:\"big\";s:8:\"not null\";b:1;}}s:7:\"indexes\";a:2:{s:5:\"value\";a:1:{i:0;s:5:\"value\";}s:6:\"expire\";a:1:{i:0;s:6:\"expire\";}}s:11:\"primary key\";a:1:{i:0;s:4:\"name\";}s:6:\"module\";s:6:\"system\";s:4:\"name\";s:9:\"semaphore\";}s:9:\"sequences\";a:4:{s:6:\"fields\";a:1:{s:5:\"value\";a:3:{s:4:\"type\";s:6:\"serial\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}}s:11:\"primary key\";a:1:{i:0;s:5:\"value\";}s:6:\"module\";s:6:\"system\";s:4:\"name\";s:9:\"sequences\";}s:8:\"sessions\";a:6:{s:6:\"fields\";a:7:{s:3:\"uid\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:3:\"sid\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;}s:4:\"ssid\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:8:\"hostname\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:9:\"timestamp\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:5:\"cache\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:7:\"session\";a:3:{s:4:\"type\";s:4:\"blob\";s:8:\"not null\";b:0;s:4:\"size\";s:3:\"big\";}}s:11:\"primary key\";a:2:{i:0;s:3:\"sid\";i:1;s:4:\"ssid\";}s:7:\"indexes\";a:3:{s:9:\"timestamp\";a:1:{i:0;s:9:\"timestamp\";}s:3:\"uid\";a:1:{i:0;s:3:\"uid\";}s:4:\"ssid\";a:1:{i:0;s:4:\"ssid\";}}s:12:\"foreign keys\";a:1:{s:12:\"session_user\";a:2:{s:5:\"table\";s:5:\"users\";s:7:\"columns\";a:1:{s:3:\"uid\";s:3:\"uid\";}}}s:6:\"module\";s:6:\"system\";s:4:\"name\";s:8:\"sessions\";}s:6:\"system\";a:5:{s:6:\"fields\";a:9:{s:8:\"filename\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:4:\"name\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:4:\"type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:12;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"owner\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"status\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"bootstrap\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:14:\"schema_version\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:-1;s:4:\"size\";s:5:\"small\";}s:6:\"weight\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:4:\"info\";a:2:{s:4:\"type\";s:4:\"blob\";s:8:\"not null\";b:0;}}s:11:\"primary key\";a:1:{i:0;s:8:\"filename\";}s:7:\"indexes\";a:2:{s:11:\"system_list\";a:5:{i:0;s:6:\"status\";i:1;s:9:\"bootstrap\";i:2;s:4:\"type\";i:3;s:6:\"weight\";i:4;s:4:\"name\";}s:9:\"type_name\";a:2:{i:0;s:4:\"type\";i:1;s:4:\"name\";}}s:6:\"module\";s:6:\"system\";s:4:\"name\";s:6:\"system\";}s:9:\"url_alias\";a:5:{s:6:\"fields\";a:4:{s:3:\"pid\";a:3:{s:4:\"type\";s:6:\"serial\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:6:\"source\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"alias\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:12;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}}s:11:\"primary key\";a:1:{i:0;s:3:\"pid\";}s:7:\"indexes\";a:2:{s:18:\"alias_language_pid\";a:3:{i:0;s:5:\"alias\";i:1;s:8:\"language\";i:2;s:3:\"pid\";}s:19:\"source_language_pid\";a:3:{i:0;s:6:\"source\";i:1;s:8:\"language\";i:2;s:3:\"pid\";}}s:6:\"module\";s:6:\"system\";s:4:\"name\";s:9:\"url_alias\";}s:18:\"taxonomy_term_data\";a:6:{s:6:\"fields\";a:8:{s:3:\"tid\";a:3:{s:4:\"type\";s:6:\"serial\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:3:\"vid\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:4:\"name\";a:5:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:12:\"translatable\";b:1;}s:11:\"description\";a:4:{s:4:\"type\";s:4:\"text\";s:8:\"not null\";b:0;s:4:\"size\";s:3:\"big\";s:12:\"translatable\";b:1;}s:6:\"format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}s:6:\"weight\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:12;s:8:\"not null\";b:1;s:7:\"default\";s:3:\"und\";}s:9:\"i18n_tsid\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}}s:11:\"primary key\";a:1:{i:0;s:3:\"tid\";}s:12:\"foreign keys\";a:1:{s:10:\"vocabulary\";a:2:{s:5:\"table\";s:19:\"taxonomy_vocabulary\";s:7:\"columns\";a:1:{s:3:\"vid\";s:3:\"vid\";}}}s:7:\"indexes\";a:3:{s:13:\"taxonomy_tree\";a:3:{i:0;s:3:\"vid\";i:1;s:6:\"weight\";i:2;s:4:\"name\";}s:8:\"vid_name\";a:2:{i:0;s:3:\"vid\";i:1;s:4:\"name\";}s:4:\"name\";a:1:{i:0;s:4:\"name\";}}s:6:\"module\";s:8:\"taxonomy\";s:4:\"name\";s:18:\"taxonomy_term_data\";}s:23:\"taxonomy_term_hierarchy\";a:6:{s:6:\"fields\";a:2:{s:3:\"tid\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:6:\"parent\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}}s:7:\"indexes\";a:1:{s:6:\"parent\";a:1:{i:0;s:6:\"parent\";}}s:12:\"foreign keys\";a:1:{s:18:\"taxonomy_term_data\";a:2:{s:5:\"table\";s:18:\"taxonomy_term_data\";s:7:\"columns\";a:1:{s:3:\"tid\";s:3:\"tid\";}}}s:11:\"primary key\";a:2:{i:0;s:3:\"tid\";i:1;s:6:\"parent\";}s:6:\"module\";s:8:\"taxonomy\";s:4:\"name\";s:23:\"taxonomy_term_hierarchy\";}s:19:\"taxonomy_vocabulary\";a:6:{s:6:\"fields\";a:9:{s:3:\"vid\";a:3:{s:4:\"type\";s:6:\"serial\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:4:\"name\";a:5:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:12:\"translatable\";b:1;}s:12:\"machine_name\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:11:\"description\";a:4:{s:4:\"type\";s:4:\"text\";s:8:\"not null\";b:0;s:4:\"size\";s:3:\"big\";s:12:\"translatable\";b:1;}s:9:\"hierarchy\";a:5:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;s:4:\"size\";s:4:\"tiny\";}s:6:\"module\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"weight\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:12;s:8:\"not null\";b:1;s:7:\"default\";s:3:\"und\";}s:9:\"i18n_mode\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}}s:11:\"primary key\";a:1:{i:0;s:3:\"vid\";}s:7:\"indexes\";a:1:{s:4:\"list\";a:2:{i:0;s:6:\"weight\";i:1;s:4:\"name\";}}s:11:\"unique keys\";a:1:{s:12:\"machine_name\";a:1:{i:0;s:12:\"machine_name\";}}s:6:\"module\";s:8:\"taxonomy\";s:4:\"name\";s:19:\"taxonomy_vocabulary\";}s:14:\"taxonomy_index\";a:5:{s:6:\"fields\";a:4:{s:3:\"nid\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:3:\"tid\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:6:\"sticky\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;s:7:\"default\";i:0;s:4:\"size\";s:4:\"tiny\";}s:7:\"created\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}}s:7:\"indexes\";a:2:{s:9:\"term_node\";a:3:{i:0;s:3:\"tid\";i:1;s:6:\"sticky\";i:2;s:7:\"created\";}s:3:\"nid\";a:1:{i:0;s:3:\"nid\";}}s:12:\"foreign keys\";a:2:{s:12:\"tracked_node\";a:2:{s:5:\"table\";s:4:\"node\";s:7:\"columns\";a:1:{s:3:\"nid\";s:3:\"nid\";}}s:4:\"term\";a:2:{s:5:\"table\";s:18:\"taxonomy_term_data\";s:7:\"columns\";a:1:{s:3:\"tid\";s:3:\"tid\";}}}s:6:\"module\";s:8:\"taxonomy\";s:4:\"name\";s:14:\"taxonomy_index\";}s:13:\"taxonomy_menu\";a:5:{s:6:\"fields\";a:3:{s:4:\"mlid\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:3:\"tid\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:3:\"vid\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}}s:11:\"primary key\";a:2:{i:0;s:4:\"mlid\";i:1;s:3:\"tid\";}s:7:\"indexes\";a:1:{s:3:\"vid\";a:1:{i:0;s:3:\"vid\";}}s:6:\"module\";s:13:\"taxonomy_menu\";s:4:\"name\";s:13:\"taxonomy_menu\";}s:11:\"cache_token\";a:5:{s:6:\"fields\";a:5:{s:3:\"cid\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:4:\"data\";a:3:{s:4:\"type\";s:4:\"blob\";s:8:\"not null\";b:0;s:4:\"size\";s:3:\"big\";}s:6:\"expire\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:7:\"created\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:10:\"serialized\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:5:\"small\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}}s:7:\"indexes\";a:1:{s:6:\"expire\";a:1:{i:0;s:6:\"expire\";}}s:11:\"primary key\";a:1:{i:0;s:3:\"cid\";}s:6:\"module\";s:5:\"token\";s:4:\"name\";s:11:\"cache_token\";}s:12:\"token_custom\";a:4:{s:6:\"fields\";a:6:{s:12:\"machine_name\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;}s:4:\"name\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;}s:11:\"description\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;}s:4:\"type\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;}s:7:\"content\";a:3:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:3:\"big\";s:8:\"not null\";b:1;}s:6:\"format\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;s:7:\"default\";s:8:\"php_code\";}}s:11:\"primary key\";a:1:{i:0;s:12:\"machine_name\";}s:6:\"module\";s:12:\"token_custom\";s:4:\"name\";s:12:\"token_custom\";}s:12:\"cache_update\";a:5:{s:6:\"fields\";a:5:{s:3:\"cid\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:4:\"data\";a:3:{s:4:\"type\";s:4:\"blob\";s:8:\"not null\";b:0;s:4:\"size\";s:3:\"big\";}s:6:\"expire\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:7:\"created\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:10:\"serialized\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:5:\"small\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}}s:7:\"indexes\";a:1:{s:6:\"expire\";a:1:{i:0;s:6:\"expire\";}}s:11:\"primary key\";a:1:{i:0;s:3:\"cid\";}s:6:\"module\";s:6:\"update\";s:4:\"name\";s:12:\"cache_update\";}s:7:\"authmap\";a:7:{s:6:\"fields\";a:4:{s:3:\"aid\";a:3:{s:4:\"type\";s:6:\"serial\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:3:\"uid\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:8:\"authname\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"module\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}}s:11:\"unique keys\";a:1:{s:8:\"authname\";a:1:{i:0;s:8:\"authname\";}}s:11:\"primary key\";a:1:{i:0;s:3:\"aid\";}s:12:\"foreign keys\";a:1:{s:4:\"user\";a:2:{s:5:\"table\";s:5:\"users\";s:7:\"columns\";a:1:{s:3:\"uid\";s:3:\"uid\";}}}s:7:\"indexes\";a:1:{s:10:\"uid_module\";a:2:{i:0;s:3:\"uid\";i:1;s:6:\"module\";}}s:6:\"module\";s:4:\"user\";s:4:\"name\";s:7:\"authmap\";}s:15:\"role_permission\";a:6:{s:6:\"fields\";a:3:{s:3:\"rid\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:10:\"permission\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"module\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}}s:11:\"primary key\";a:2:{i:0;s:3:\"rid\";i:1;s:10:\"permission\";}s:7:\"indexes\";a:1:{s:10:\"permission\";a:1:{i:0;s:10:\"permission\";}}s:12:\"foreign keys\";a:1:{s:4:\"role\";a:2:{s:5:\"table\";s:4:\"role\";s:7:\"columns\";a:1:{s:3:\"rid\";s:3:\"rid\";}}}s:6:\"module\";s:4:\"user\";s:4:\"name\";s:15:\"role_permission\";}s:4:\"role\";a:6:{s:6:\"fields\";a:3:{s:3:\"rid\";a:3:{s:4:\"type\";s:6:\"serial\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:4:\"name\";a:5:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:64;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:12:\"translatable\";b:1;}s:6:\"weight\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}}s:11:\"unique keys\";a:1:{s:4:\"name\";a:1:{i:0;s:4:\"name\";}}s:11:\"primary key\";a:1:{i:0;s:3:\"rid\";}s:7:\"indexes\";a:1:{s:11:\"name_weight\";a:2:{i:0;s:4:\"name\";i:1;s:6:\"weight\";}}s:6:\"module\";s:4:\"user\";s:4:\"name\";s:4:\"role\";}s:5:\"users\";a:7:{s:6:\"fields\";a:16:{s:3:\"uid\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:4:\"name\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:60;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:4:\"pass\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:4:\"mail\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:254;s:8:\"not null\";b:0;s:7:\"default\";s:0:\"\";}s:5:\"theme\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:9:\"signature\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:16:\"signature_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}s:7:\"created\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:6:\"access\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:5:\"login\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:6:\"status\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:4:\"size\";s:4:\"tiny\";}s:8:\"timezone\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:12;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"picture\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:4:\"init\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:254;s:8:\"not null\";b:0;s:7:\"default\";s:0:\"\";}s:4:\"data\";a:4:{s:4:\"type\";s:4:\"blob\";s:8:\"not null\";b:0;s:4:\"size\";s:3:\"big\";s:9:\"serialize\";b:1;}}s:7:\"indexes\";a:4:{s:6:\"access\";a:1:{i:0;s:6:\"access\";}s:7:\"created\";a:1:{i:0;s:7:\"created\";}s:4:\"mail\";a:1:{i:0;s:4:\"mail\";}s:7:\"picture\";a:1:{i:0;s:7:\"picture\";}}s:11:\"unique keys\";a:1:{s:4:\"name\";a:1:{i:0;s:4:\"name\";}}s:11:\"primary key\";a:1:{i:0;s:3:\"uid\";}s:12:\"foreign keys\";a:1:{s:16:\"signature_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:16:\"signature_format\";s:6:\"format\";}}}s:6:\"module\";s:4:\"user\";s:4:\"name\";s:5:\"users\";}s:11:\"users_roles\";a:6:{s:6:\"fields\";a:2:{s:3:\"uid\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:3:\"rid\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}}s:11:\"primary key\";a:2:{i:0;s:3:\"uid\";i:1;s:3:\"rid\";}s:7:\"indexes\";a:1:{s:3:\"rid\";a:1:{i:0;s:3:\"rid\";}}s:12:\"foreign keys\";a:2:{s:4:\"user\";a:2:{s:5:\"table\";s:5:\"users\";s:7:\"columns\";a:1:{s:3:\"uid\";s:3:\"uid\";}}s:4:\"role\";a:2:{s:5:\"table\";s:4:\"role\";s:7:\"columns\";a:1:{s:3:\"rid\";s:3:\"rid\";}}}s:6:\"module\";s:4:\"user\";s:4:\"name\";s:11:\"users_roles\";}s:14:\"cache_variable\";a:5:{s:6:\"fields\";a:5:{s:3:\"cid\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:4:\"data\";a:3:{s:4:\"type\";s:4:\"blob\";s:8:\"not null\";b:0;s:4:\"size\";s:3:\"big\";}s:6:\"expire\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:7:\"created\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:10:\"serialized\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:5:\"small\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}}s:7:\"indexes\";a:1:{s:6:\"expire\";a:1:{i:0;s:6:\"expire\";}}s:11:\"primary key\";a:1:{i:0;s:3:\"cid\";}s:6:\"module\";s:8:\"variable\";s:4:\"name\";s:14:\"cache_variable\";}s:16:\"vef_video_styles\";a:5:{s:6:\"export\";a:4:{s:3:\"key\";s:4:\"name\";s:10:\"identifier\";s:17:\"video_embed_style\";s:12:\"default hook\";s:26:\"default_video_embed_styles\";s:3:\"api\";a:4:{s:5:\"owner\";s:17:\"video_embed_field\";s:3:\"api\";s:26:\"default_video_embed_styles\";s:15:\"minimum_version\";i:1;s:15:\"current_version\";i:1;}}s:6:\"fields\";a:3:{s:4:\"name\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;}s:5:\"title\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;}s:4:\"data\";a:4:{s:4:\"type\";s:4:\"blob\";s:4:\"size\";s:3:\"big\";s:8:\"not null\";b:1;s:9:\"serialize\";b:1;}}s:11:\"primary key\";a:1:{i:0;s:4:\"name\";}s:6:\"module\";s:17:\"video_embed_field\";s:4:\"name\";s:16:\"vef_video_styles\";}s:14:\"votingapi_vote\";a:5:{s:6:\"fields\";a:9:{s:7:\"vote_id\";a:3:{s:4:\"type\";s:6:\"serial\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:64;s:8:\"not null\";b:1;s:7:\"default\";s:4:\"node\";}s:9:\"entity_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:5:\"value\";a:3:{s:4:\"type\";s:5:\"float\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:10:\"value_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:64;s:8:\"not null\";b:1;s:7:\"default\";s:7:\"percent\";}s:3:\"tag\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:64;s:8:\"not null\";b:1;s:7:\"default\";s:4:\"vote\";}s:3:\"uid\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"timestamp\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:11:\"vote_source\";a:2:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;}}s:11:\"primary key\";a:1:{i:0;s:7:\"vote_id\";}s:7:\"indexes\";a:4:{s:11:\"content_uid\";a:3:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:3:\"uid\";}s:13:\"content_uid_2\";a:2:{i:0;s:11:\"entity_type\";i:1;s:3:\"uid\";}s:14:\"content_source\";a:3:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:11:\"vote_source\";}s:17:\"content_value_tag\";a:4:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:10:\"value_type\";i:3;s:3:\"tag\";}}s:6:\"module\";s:9:\"votingapi\";s:4:\"name\";s:14:\"votingapi_vote\";}s:15:\"votingapi_cache\";a:5:{s:6:\"fields\";a:8:{s:13:\"vote_cache_id\";a:3:{s:4:\"type\";s:6:\"serial\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:64;s:8:\"not null\";b:1;s:7:\"default\";s:4:\"node\";}s:9:\"entity_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:5:\"value\";a:3:{s:4:\"type\";s:5:\"float\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:10:\"value_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:64;s:8:\"not null\";b:1;s:7:\"default\";s:7:\"percent\";}s:3:\"tag\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:64;s:8:\"not null\";b:1;s:7:\"default\";s:4:\"vote\";}s:8:\"function\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:64;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:9:\"timestamp\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}}s:11:\"primary key\";a:1:{i:0;s:13:\"vote_cache_id\";}s:7:\"indexes\";a:5:{s:7:\"content\";a:2:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";}s:16:\"content_function\";a:3:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:8:\"function\";}s:16:\"content_tag_func\";a:4:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:3:\"tag\";i:3;s:8:\"function\";}s:17:\"content_vtype_tag\";a:4:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:10:\"value_type\";i:3;s:3:\"tag\";}s:22:\"content_vtype_tag_func\";a:5:{i:0;s:11:\"entity_type\";i:1;s:9:\"entity_id\";i:2;s:10:\"value_type\";i:3;s:3:\"tag\";i:4;s:8:\"function\";}}s:6:\"module\";s:9:\"votingapi\";s:4:\"name\";s:15:\"votingapi_cache\";}s:28:\"we_content_migration_mapping\";a:5:{s:6:\"fields\";a:7:{s:2:\"id\";a:3:{s:4:\"type\";s:6:\"serial\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:15:\"old_entity_type\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:0;}s:10:\"old_bundle\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:0;}s:13:\"old_entity_id\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;}s:15:\"new_entity_type\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;}s:10:\"new_bundle\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;}s:13:\"new_entity_id\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;}}s:7:\"indexes\";a:1:{s:7:\"mapping\";a:6:{i:0;s:15:\"old_entity_type\";i:1;s:10:\"old_bundle\";i:2;s:13:\"old_entity_id\";i:3;s:15:\"new_entity_type\";i:4;s:10:\"new_bundle\";i:5;s:13:\"new_entity_id\";}}s:11:\"primary key\";a:1:{i:0;s:2:\"id\";}s:6:\"module\";s:20:\"we_content_migration\";s:4:\"name\";s:28:\"we_content_migration_mapping\";}s:38:\"we_content_migration_mapping_reference\";a:5:{s:6:\"fields\";a:8:{s:2:\"id\";a:3:{s:4:\"type\";s:6:\"serial\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:11:\"entity_type\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;}s:6:\"bundle\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;}s:3:\"eid\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;}s:10:\"field_name\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;}s:11:\"field_value\";a:2:{s:4:\"type\";s:4:\"text\";s:8:\"not null\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:12;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"status\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}}s:7:\"indexes\";a:1:{s:17:\"mapping_reference\";a:5:{i:0;s:11:\"entity_type\";i:1;s:6:\"bundle\";i:2;s:3:\"eid\";i:3;s:10:\"field_name\";i:4;s:6:\"status\";}}s:11:\"primary key\";a:1:{i:0;s:2:\"id\";}s:6:\"module\";s:20:\"we_content_migration\";s:4:\"name\";s:38:\"we_content_migration_mapping_reference\";}s:11:\"field_group\";a:7:{s:6:\"export\";a:8:{s:3:\"key\";s:10:\"identifier\";s:10:\"identifier\";s:11:\"field_group\";s:12:\"default hook\";s:16:\"field_group_info\";s:13:\"load callback\";s:36:\"field_group_group_load_by_identifier\";s:13:\"save callback\";s:22:\"field_group_group_save\";s:15:\"delete callback\";s:31:\"field_group_group_export_delete\";s:11:\"can disable\";b:1;s:3:\"api\";a:4:{s:5:\"owner\";s:11:\"field_group\";s:3:\"api\";s:11:\"field_group\";s:15:\"minimum_version\";i:1;s:15:\"current_version\";i:1;}}s:6:\"fields\";a:8:{s:2:\"id\";a:3:{s:4:\"type\";s:6:\"serial\";s:8:\"not null\";b:1;s:9:\"no export\";b:1;}s:10:\"identifier\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:10:\"group_name\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:4:\"mode\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:11:\"parent_name\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:4:\"data\";a:4:{s:4:\"type\";s:4:\"blob\";s:4:\"size\";s:3:\"big\";s:8:\"not null\";b:1;s:9:\"serialize\";b:1;}}s:11:\"primary key\";a:1:{i:0;s:2:\"id\";}s:7:\"indexes\";a:1:{s:10:\"group_name\";a:1:{i:0;s:10:\"group_name\";}}s:11:\"unique keys\";a:1:{s:10:\"identifier\";a:1:{i:0;s:10:\"identifier\";}}s:6:\"module\";s:11:\"field_group\";s:4:\"name\";s:11:\"field_group\";}s:5:\"forum\";a:6:{s:6:\"fields\";a:3:{s:3:\"nid\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:3:\"vid\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:3:\"tid\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}}s:7:\"indexes\";a:2:{s:11:\"forum_topic\";a:2:{i:0;s:3:\"nid\";i:1;s:3:\"tid\";}s:3:\"tid\";a:1:{i:0;s:3:\"tid\";}}s:11:\"primary key\";a:1:{i:0;s:3:\"vid\";}s:12:\"foreign keys\";a:1:{s:10:\"forum_node\";a:2:{s:5:\"table\";s:4:\"node\";s:7:\"columns\";a:2:{s:3:\"nid\";s:3:\"nid\";s:3:\"vid\";s:3:\"vid\";}}}s:6:\"module\";s:5:\"forum\";s:4:\"name\";s:5:\"forum\";}s:11:\"forum_index\";a:5:{s:6:\"fields\";a:7:{s:3:\"nid\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:5:\"title\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:3:\"tid\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:6:\"sticky\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;s:7:\"default\";i:0;s:4:\"size\";s:4:\"tiny\";}s:7:\"created\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:22:\"last_comment_timestamp\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:13:\"comment_count\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}}s:7:\"indexes\";a:3:{s:12:\"forum_topics\";a:4:{i:0;s:3:\"nid\";i:1;s:3:\"tid\";i:2;s:6:\"sticky\";i:3;s:22:\"last_comment_timestamp\";}s:7:\"created\";a:1:{i:0;s:7:\"created\";}s:22:\"last_comment_timestamp\";a:1:{i:0;s:22:\"last_comment_timestamp\";}}s:12:\"foreign keys\";a:2:{s:12:\"tracked_node\";a:2:{s:5:\"table\";s:4:\"node\";s:7:\"columns\";a:1:{s:3:\"nid\";s:3:\"nid\";}}s:4:\"term\";a:2:{s:5:\"table\";s:18:\"taxonomy_term_data\";s:7:\"columns\";a:1:{s:3:\"tid\";s:3:\"tid\";}}}s:6:\"module\";s:5:\"forum\";s:4:\"name\";s:11:\"forum_index\";}s:11:\"i18n_string\";a:5:{s:6:\"fields\";a:8:{s:3:\"lid\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"textgroup\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:50;s:8:\"not null\";b:1;s:7:\"default\";s:7:\"default\";}s:7:\"context\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:8:\"objectid\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:4:\"type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:8:\"property\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:11:\"objectindex\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:6:\"format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:1:{i:0;s:3:\"lid\";}s:7:\"indexes\";a:1:{s:13:\"group_context\";a:2:{i:0;s:9:\"textgroup\";i:1;a:2:{i:0;s:7:\"context\";i:1;i:50;}}}s:6:\"module\";s:11:\"i18n_string\";s:4:\"name\";s:11:\"i18n_string\";}s:10:\"views_view\";a:6:{s:6:\"export\";a:17:{s:10:\"identifier\";s:4:\"view\";s:11:\"bulk export\";b:1;s:11:\"primary key\";s:3:\"vid\";s:12:\"default hook\";s:19:\"views_default_views\";s:11:\"admin_title\";s:10:\"human_name\";s:17:\"admin_description\";s:11:\"description\";s:3:\"api\";a:4:{s:5:\"owner\";s:5:\"views\";s:3:\"api\";s:13:\"views_default\";s:15:\"minimum_version\";s:1:\"2\";s:15:\"current_version\";s:3:\"3.0\";}s:6:\"object\";s:4:\"view\";s:19:\"subrecords callback\";s:26:\"views_load_display_records\";s:6:\"status\";s:14:\"views_defaults\";s:15:\"create callback\";s:14:\"views_new_view\";s:13:\"save callback\";s:15:\"views_save_view\";s:15:\"delete callback\";s:17:\"views_delete_view\";s:15:\"export callback\";s:17:\"views_export_view\";s:15:\"status callback\";s:19:\"views_export_status\";s:14:\"cache defaults\";b:1;s:17:\"default cache bin\";s:11:\"cache_views\";}s:6:\"fields\";a:7:{s:3:\"vid\";a:4:{s:4:\"type\";s:6:\"serial\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:9:\"no export\";b:1;}s:4:\"name\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:7:\"default\";s:0:\"\";s:8:\"not null\";b:1;}s:11:\"description\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:7:\"default\";s:0:\"\";}s:3:\"tag\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:7:\"default\";s:0:\"\";}s:10:\"base_table\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:64;s:7:\"default\";s:0:\"\";s:8:\"not null\";b:1;}s:10:\"human_name\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:7:\"default\";s:0:\"\";}s:4:\"core\";a:2:{s:4:\"type\";s:3:\"int\";s:7:\"default\";i:0;}}s:11:\"primary key\";a:1:{i:0;s:3:\"vid\";}s:11:\"unique keys\";a:1:{s:4:\"name\";a:1:{i:0;s:4:\"name\";}}s:6:\"module\";s:5:\"views\";s:4:\"name\";s:10:\"views_view\";}s:13:\"views_display\";a:5:{s:6:\"fields\";a:6:{s:3:\"vid\";a:5:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;s:9:\"no export\";b:1;}s:2:\"id\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:2:\"64\";s:7:\"default\";s:0:\"\";s:8:\"not null\";b:1;}s:13:\"display_title\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:2:\"64\";s:7:\"default\";s:0:\"\";s:8:\"not null\";b:1;}s:14:\"display_plugin\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:2:\"64\";s:7:\"default\";s:0:\"\";s:8:\"not null\";b:1;}s:8:\"position\";a:2:{s:4:\"type\";s:3:\"int\";s:7:\"default\";i:0;}s:15:\"display_options\";a:4:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:3:\"big\";s:9:\"serialize\";b:1;s:18:\"serialized default\";s:6:\"a:0:{}\";}}s:7:\"indexes\";a:1:{s:3:\"vid\";a:2:{i:0;s:3:\"vid\";i:1;s:8:\"position\";}}s:11:\"primary key\";a:2:{i:0;s:3:\"vid\";i:1;s:2:\"id\";}s:6:\"module\";s:5:\"views\";s:4:\"name\";s:13:\"views_display\";}s:11:\"cache_views\";a:5:{s:6:\"fields\";a:5:{s:3:\"cid\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:4:\"data\";a:3:{s:4:\"type\";s:4:\"blob\";s:8:\"not null\";b:0;s:4:\"size\";s:3:\"big\";}s:6:\"expire\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:7:\"created\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:10:\"serialized\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:5:\"small\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}}s:7:\"indexes\";a:1:{s:6:\"expire\";a:1:{i:0;s:6:\"expire\";}}s:11:\"primary key\";a:1:{i:0;s:3:\"cid\";}s:6:\"module\";s:5:\"views\";s:4:\"name\";s:11:\"cache_views\";}s:16:\"cache_views_data\";a:5:{s:6:\"fields\";a:5:{s:3:\"cid\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:4:\"data\";a:3:{s:4:\"type\";s:4:\"blob\";s:8:\"not null\";b:0;s:4:\"size\";s:3:\"big\";}s:6:\"expire\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:7:\"created\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:10:\"serialized\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:5:\"small\";s:8:\"not null\";b:1;s:7:\"default\";i:1;}}s:7:\"indexes\";a:1:{s:6:\"expire\";a:1:{i:0;s:6:\"expire\";}}s:11:\"primary key\";a:1:{i:0;s:3:\"cid\";}s:6:\"module\";s:5:\"views\";s:4:\"name\";s:16:\"cache_views_data\";}s:14:\"cache_features\";a:5:{s:6:\"fields\";a:5:{s:3:\"cid\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:4:\"data\";a:3:{s:4:\"type\";s:4:\"blob\";s:8:\"not null\";b:0;s:4:\"size\";s:3:\"big\";}s:6:\"expire\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:7:\"created\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:10:\"serialized\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:5:\"small\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}}s:7:\"indexes\";a:1:{s:6:\"expire\";a:1:{i:0;s:6:\"expire\";}}s:11:\"primary key\";a:1:{i:0;s:3:\"cid\";}s:6:\"module\";s:8:\"features\";s:4:\"name\";s:14:\"cache_features\";}s:16:\"cache_admin_menu\";a:5:{s:6:\"fields\";a:5:{s:3:\"cid\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:4:\"data\";a:3:{s:4:\"type\";s:4:\"blob\";s:8:\"not null\";b:0;s:4:\"size\";s:3:\"big\";}s:6:\"expire\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:7:\"created\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:10:\"serialized\";a:4:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:5:\"small\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}}s:7:\"indexes\";a:1:{s:6:\"expire\";a:1:{i:0;s:6:\"expire\";}}s:11:\"primary key\";a:1:{i:0;s:3:\"cid\";}s:6:\"module\";s:10:\"admin_menu\";s:4:\"name\";s:16:\"cache_admin_menu\";}s:19:\"i18n_block_language\";a:5:{s:6:\"fields\";a:3:{s:6:\"module\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:64;s:8:\"not null\";b:1;}s:5:\"delta\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:12;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}}s:11:\"primary key\";a:3:{i:0;s:6:\"module\";i:1;s:5:\"delta\";i:2;s:8:\"language\";}s:7:\"indexes\";a:1:{s:8:\"language\";a:1:{i:0;s:8:\"language\";}}s:6:\"module\";s:10:\"i18n_block\";s:4:\"name\";s:19:\"i18n_block_language\";}}',0,1512620340,1),('schema:runtime:','a:1:{s:5:\"users\";a:7:{s:6:\"fields\";a:16:{s:3:\"uid\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:4:\"name\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:60;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:4:\"pass\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:4:\"mail\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:254;s:8:\"not null\";b:0;s:7:\"default\";s:0:\"\";}s:5:\"theme\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:9:\"signature\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:16:\"signature_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}s:7:\"created\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:6:\"access\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:5:\"login\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:6:\"status\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:4:\"size\";s:4:\"tiny\";}s:8:\"timezone\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:12;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"picture\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:4:\"init\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:254;s:8:\"not null\";b:0;s:7:\"default\";s:0:\"\";}s:4:\"data\";a:4:{s:4:\"type\";s:4:\"blob\";s:8:\"not null\";b:0;s:4:\"size\";s:3:\"big\";s:9:\"serialize\";b:1;}}s:7:\"indexes\";a:4:{s:6:\"access\";a:1:{i:0;s:6:\"access\";}s:7:\"created\";a:1:{i:0;s:7:\"created\";}s:4:\"mail\";a:1:{i:0;s:4:\"mail\";}s:7:\"picture\";a:1:{i:0;s:7:\"picture\";}}s:11:\"unique keys\";a:1:{s:4:\"name\";a:1:{i:0;s:4:\"name\";}}s:11:\"primary key\";a:1:{i:0;s:3:\"uid\";}s:12:\"foreign keys\";a:1:{s:16:\"signature_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:16:\"signature_format\";s:6:\"format\";}}}s:6:\"module\";s:4:\"user\";s:4:\"name\";s:5:\"users\";}}',0,1512620348,1),('schema:runtime:1','a:20:{s:7:\"comment\";a:6:{s:6:\"fields\";a:14:{s:3:\"cid\";a:2:{s:4:\"type\";s:6:\"serial\";s:8:\"not null\";b:1;}s:3:\"pid\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:3:\"nid\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:3:\"uid\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:7:\"subject\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:64;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:8:\"hostname\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"created\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:7:\"changed\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:6:\"status\";a:5:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:1;s:4:\"size\";s:4:\"tiny\";}s:6:\"thread\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;}s:4:\"name\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:60;s:8:\"not null\";b:0;}s:4:\"mail\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:64;s:8:\"not null\";b:0;}s:8:\"homepage\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:12;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}}s:7:\"indexes\";a:5:{s:18:\"comment_status_pid\";a:2:{i:0;s:3:\"pid\";i:1;s:6:\"status\";}s:15:\"comment_num_new\";a:5:{i:0;s:3:\"nid\";i:1;s:6:\"status\";i:2;s:7:\"created\";i:3;s:3:\"cid\";i:4;s:6:\"thread\";}s:11:\"comment_uid\";a:1:{i:0;s:3:\"uid\";}s:20:\"comment_nid_language\";a:2:{i:0;s:3:\"nid\";i:1;s:8:\"language\";}s:15:\"comment_created\";a:1:{i:0;s:7:\"created\";}}s:11:\"primary key\";a:1:{i:0;s:3:\"cid\";}s:12:\"foreign keys\";a:2:{s:12:\"comment_node\";a:2:{s:5:\"table\";s:4:\"node\";s:7:\"columns\";a:1:{s:3:\"nid\";s:3:\"nid\";}}s:14:\"comment_author\";a:2:{s:5:\"table\";s:5:\"users\";s:7:\"columns\";a:1:{s:3:\"uid\";s:3:\"uid\";}}}s:6:\"module\";s:7:\"comment\";s:4:\"name\";s:7:\"comment\";}s:21:\"field_collection_item\";a:4:{s:6:\"fields\";a:4:{s:7:\"item_id\";a:2:{s:4:\"type\";s:6:\"serial\";s:8:\"not null\";b:1;}s:11:\"revision_id\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;}s:10:\"field_name\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;}s:8:\"archived\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}}s:11:\"primary key\";a:1:{i:0;s:7:\"item_id\";}s:6:\"module\";s:16:\"field_collection\";s:4:\"name\";s:21:\"field_collection_item\";}s:30:\"field_collection_item_revision\";a:6:{s:6:\"fields\";a:2:{s:11:\"revision_id\";a:2:{s:4:\"type\";s:6:\"serial\";s:8:\"not null\";b:1;}s:7:\"item_id\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;}}s:11:\"primary key\";a:1:{i:0;s:11:\"revision_id\";}s:7:\"indexes\";a:1:{s:7:\"item_id\";a:1:{i:0;s:7:\"item_id\";}}s:12:\"foreign keys\";a:1:{s:31:\"versioned_field_collection_item\";a:2:{s:5:\"table\";s:21:\"field_collection_item\";s:7:\"columns\";a:1:{s:7:\"item_id\";s:7:\"item_id\";}}}s:6:\"module\";s:16:\"field_collection\";s:4:\"name\";s:30:\"field_collection_item_revision\";}s:20:\"i18n_translation_set\";a:5:{s:6:\"fields\";a:8:{s:4:\"tsid\";a:3:{s:4:\"type\";s:6:\"serial\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:5:\"title\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:4:\"type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:9:\"master_id\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:6:\"status\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:1;}s:7:\"created\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:7:\"changed\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}}s:7:\"indexes\";a:1:{s:13:\"entity_bundle\";a:2:{i:0;s:4:\"type\";i:1;s:6:\"bundle\";}}s:11:\"primary key\";a:1:{i:0;s:4:\"tsid\";}s:6:\"module\";s:16:\"i18n_translation\";s:4:\"name\";s:20:\"i18n_translation_set\";}s:21:\"message_type_category\";a:5:{s:6:\"fields\";a:6:{s:2:\"id\";a:2:{s:4:\"type\";s:6:\"serial\";s:8:\"not null\";b:1;}s:8:\"category\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:11:\"description\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:12;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"status\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:1;s:4:\"size\";s:4:\"tiny\";}s:6:\"module\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:11:\"primary key\";a:1:{i:0;s:2:\"id\";}s:11:\"unique keys\";a:1:{s:8:\"category\";a:1:{i:0;s:8:\"category\";}}s:6:\"module\";s:7:\"message\";s:4:\"name\";s:21:\"message_type_category\";}s:12:\"message_type\";a:5:{s:6:\"fields\";a:10:{s:2:\"id\";a:2:{s:4:\"type\";s:6:\"serial\";s:8:\"not null\";b:1;}s:4:\"name\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:8:\"category\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:12:\"message_type\";}s:11:\"description\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:13:\"argument_keys\";a:2:{s:4:\"type\";s:4:\"text\";s:9:\"serialize\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:12;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"status\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:1;s:4:\"size\";s:4:\"tiny\";}s:6:\"module\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}s:9:\"arguments\";a:2:{s:4:\"type\";s:4:\"text\";s:9:\"serialize\";b:1;}s:4:\"data\";a:3:{s:4:\"type\";s:4:\"text\";s:9:\"serialize\";b:1;s:4:\"size\";s:3:\"big\";}}s:11:\"primary key\";a:1:{i:0;s:2:\"id\";}s:11:\"unique keys\";a:1:{s:4:\"name\";a:1:{i:0;s:4:\"name\";}}s:6:\"module\";s:7:\"message\";s:4:\"name\";s:12:\"message_type\";}s:7:\"message\";a:6:{s:6:\"fields\";a:6:{s:3:\"mid\";a:2:{s:4:\"type\";s:6:\"serial\";s:8:\"unsigned\";b:1;}s:4:\"type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:9:\"arguments\";a:2:{s:4:\"type\";s:4:\"text\";s:9:\"serialize\";b:1;}s:3:\"uid\";a:3:{s:4:\"type\";s:3:\"int\";s:13:\"default value\";N;s:8:\"unsigned\";b:1;}s:9:\"timestamp\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:8:\"unsigned\";b:1;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:12;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}}s:12:\"foreign keys\";a:2:{s:12:\"message_type\";a:2:{s:5:\"table\";s:12:\"message_type\";s:7:\"columns\";a:1:{s:4:\"type\";s:4:\"name\";}}s:5:\"owner\";a:2:{s:5:\"table\";s:5:\"users\";s:7:\"columns\";a:1:{s:3:\"uid\";s:3:\"uid\";}}}s:11:\"primary key\";a:1:{i:0;s:3:\"mid\";}s:7:\"indexes\";a:2:{s:10:\"type_index\";a:1:{i:0;s:4:\"type\";}s:9:\"timestamp\";a:1:{i:0;s:9:\"timestamp\";}}s:6:\"module\";s:7:\"message\";s:4:\"name\";s:7:\"message\";}s:4:\"node\";a:7:{s:6:\"fields\";a:14:{s:3:\"nid\";a:3:{s:4:\"type\";s:6:\"serial\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:3:\"vid\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;s:7:\"default\";N;}s:4:\"type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:12;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"title\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:3:\"uid\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:6:\"status\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:1;}s:7:\"created\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:7:\"changed\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:7:\"comment\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:7:\"promote\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:6:\"sticky\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:4:\"tnid\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"translate\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}}s:7:\"indexes\";a:10:{s:12:\"node_changed\";a:1:{i:0;s:7:\"changed\";}s:12:\"node_created\";a:1:{i:0;s:7:\"created\";}s:14:\"node_frontpage\";a:4:{i:0;s:7:\"promote\";i:1;s:6:\"status\";i:2;s:6:\"sticky\";i:3;s:7:\"created\";}s:16:\"node_status_type\";a:3:{i:0;s:6:\"status\";i:1;s:4:\"type\";i:2;s:3:\"nid\";}s:15:\"node_title_type\";a:2:{i:0;s:5:\"title\";i:1;a:2:{i:0;s:4:\"type\";i:1;i:4;}}s:9:\"node_type\";a:1:{i:0;a:2:{i:0;s:4:\"type\";i:1;i:4;}}s:3:\"uid\";a:1:{i:0;s:3:\"uid\";}s:4:\"tnid\";a:1:{i:0;s:4:\"tnid\";}s:9:\"translate\";a:1:{i:0;s:9:\"translate\";}s:8:\"language\";a:1:{i:0;s:8:\"language\";}}s:11:\"unique keys\";a:1:{s:3:\"vid\";a:1:{i:0;s:3:\"vid\";}}s:12:\"foreign keys\";a:2:{s:13:\"node_revision\";a:2:{s:5:\"table\";s:13:\"node_revision\";s:7:\"columns\";a:1:{s:3:\"vid\";s:3:\"vid\";}}s:11:\"node_author\";a:2:{s:5:\"table\";s:5:\"users\";s:7:\"columns\";a:1:{s:3:\"uid\";s:3:\"uid\";}}}s:11:\"primary key\";a:1:{i:0;s:3:\"nid\";}s:6:\"module\";s:4:\"node\";s:4:\"name\";s:4:\"node\";}s:13:\"node_revision\";a:6:{s:6:\"fields\";a:10:{s:3:\"nid\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:3:\"vid\";a:3:{s:4:\"type\";s:6:\"serial\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:3:\"uid\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:5:\"title\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:3:\"log\";a:3:{s:4:\"type\";s:4:\"text\";s:8:\"not null\";b:1;s:4:\"size\";s:3:\"big\";}s:9:\"timestamp\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:6:\"status\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:1;}s:7:\"comment\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:7:\"promote\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:6:\"sticky\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}}s:7:\"indexes\";a:2:{s:3:\"nid\";a:1:{i:0;s:3:\"nid\";}s:3:\"uid\";a:1:{i:0;s:3:\"uid\";}}s:11:\"primary key\";a:1:{i:0;s:3:\"vid\";}s:12:\"foreign keys\";a:2:{s:14:\"versioned_node\";a:2:{s:5:\"table\";s:4:\"node\";s:7:\"columns\";a:1:{s:3:\"nid\";s:3:\"nid\";}}s:14:\"version_author\";a:2:{s:5:\"table\";s:5:\"users\";s:7:\"columns\";a:1:{s:3:\"uid\";s:3:\"uid\";}}}s:6:\"module\";s:4:\"node\";s:4:\"name\";s:13:\"node_revision\";}s:12:\"file_managed\";a:7:{s:6:\"fields\";a:8:{s:3:\"fid\";a:3:{s:4:\"type\";s:6:\"serial\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:3:\"uid\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:8:\"filename\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:3:\"uri\";a:5:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:6:\"binary\";b:1;}s:8:\"filemime\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:8:\"filesize\";a:5:{s:4:\"type\";s:3:\"int\";s:4:\"size\";s:3:\"big\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:6:\"status\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:4:\"size\";s:4:\"tiny\";}s:9:\"timestamp\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}}s:7:\"indexes\";a:3:{s:3:\"uid\";a:1:{i:0;s:3:\"uid\";}s:6:\"status\";a:1:{i:0;s:6:\"status\";}s:9:\"timestamp\";a:1:{i:0;s:9:\"timestamp\";}}s:11:\"unique keys\";a:1:{s:3:\"uri\";a:1:{i:0;s:3:\"uri\";}}s:11:\"primary key\";a:1:{i:0;s:3:\"fid\";}s:12:\"foreign keys\";a:1:{s:10:\"file_owner\";a:2:{s:5:\"table\";s:5:\"users\";s:7:\"columns\";a:1:{s:3:\"uid\";s:3:\"uid\";}}}s:6:\"module\";s:6:\"system\";s:4:\"name\";s:12:\"file_managed\";}s:18:\"taxonomy_term_data\";a:6:{s:6:\"fields\";a:8:{s:3:\"tid\";a:3:{s:4:\"type\";s:6:\"serial\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:3:\"vid\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:4:\"name\";a:5:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:12:\"translatable\";b:1;}s:11:\"description\";a:4:{s:4:\"type\";s:4:\"text\";s:8:\"not null\";b:0;s:4:\"size\";s:3:\"big\";s:12:\"translatable\";b:1;}s:6:\"format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}s:6:\"weight\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:12;s:8:\"not null\";b:1;s:7:\"default\";s:3:\"und\";}s:9:\"i18n_tsid\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}}s:11:\"primary key\";a:1:{i:0;s:3:\"tid\";}s:12:\"foreign keys\";a:1:{s:10:\"vocabulary\";a:2:{s:5:\"table\";s:19:\"taxonomy_vocabulary\";s:7:\"columns\";a:1:{s:3:\"vid\";s:3:\"vid\";}}}s:7:\"indexes\";a:3:{s:13:\"taxonomy_tree\";a:3:{i:0;s:3:\"vid\";i:1;s:6:\"weight\";i:2;s:4:\"name\";}s:8:\"vid_name\";a:2:{i:0;s:3:\"vid\";i:1;s:4:\"name\";}s:4:\"name\";a:1:{i:0;s:4:\"name\";}}s:6:\"module\";s:8:\"taxonomy\";s:4:\"name\";s:18:\"taxonomy_term_data\";}s:19:\"taxonomy_vocabulary\";a:6:{s:6:\"fields\";a:9:{s:3:\"vid\";a:3:{s:4:\"type\";s:6:\"serial\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:4:\"name\";a:5:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:12:\"translatable\";b:1;}s:12:\"machine_name\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:11:\"description\";a:4:{s:4:\"type\";s:4:\"text\";s:8:\"not null\";b:0;s:4:\"size\";s:3:\"big\";s:12:\"translatable\";b:1;}s:9:\"hierarchy\";a:5:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;s:4:\"size\";s:4:\"tiny\";}s:6:\"module\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"weight\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:12;s:8:\"not null\";b:1;s:7:\"default\";s:3:\"und\";}s:9:\"i18n_mode\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}}s:11:\"primary key\";a:1:{i:0;s:3:\"vid\";}s:7:\"indexes\";a:1:{s:4:\"list\";a:2:{i:0;s:6:\"weight\";i:1;s:4:\"name\";}}s:11:\"unique keys\";a:1:{s:12:\"machine_name\";a:1:{i:0;s:12:\"machine_name\";}}s:6:\"module\";s:8:\"taxonomy\";s:4:\"name\";s:19:\"taxonomy_vocabulary\";}s:5:\"users\";a:7:{s:6:\"fields\";a:16:{s:3:\"uid\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:4:\"name\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:60;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:4:\"pass\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:4:\"mail\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:254;s:8:\"not null\";b:0;s:7:\"default\";s:0:\"\";}s:5:\"theme\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:9:\"signature\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:16:\"signature_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}s:7:\"created\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:6:\"access\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:5:\"login\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:6:\"status\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:4:\"size\";s:4:\"tiny\";}s:8:\"timezone\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:12;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"picture\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:4:\"init\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:254;s:8:\"not null\";b:0;s:7:\"default\";s:0:\"\";}s:4:\"data\";a:4:{s:4:\"type\";s:4:\"blob\";s:8:\"not null\";b:0;s:4:\"size\";s:3:\"big\";s:9:\"serialize\";b:1;}}s:7:\"indexes\";a:4:{s:6:\"access\";a:1:{i:0;s:6:\"access\";}s:7:\"created\";a:1:{i:0;s:7:\"created\";}s:4:\"mail\";a:1:{i:0;s:4:\"mail\";}s:7:\"picture\";a:1:{i:0;s:7:\"picture\";}}s:11:\"unique keys\";a:1:{s:4:\"name\";a:1:{i:0;s:4:\"name\";}}s:11:\"primary key\";a:1:{i:0;s:3:\"uid\";}s:12:\"foreign keys\";a:1:{s:16:\"signature_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:16:\"signature_format\";s:6:\"format\";}}}s:6:\"module\";s:4:\"user\";s:4:\"name\";s:5:\"users\";}s:10:\"views_view\";a:6:{s:6:\"export\";a:17:{s:10:\"identifier\";s:4:\"view\";s:11:\"bulk export\";b:1;s:11:\"primary key\";s:3:\"vid\";s:12:\"default hook\";s:19:\"views_default_views\";s:11:\"admin_title\";s:10:\"human_name\";s:17:\"admin_description\";s:11:\"description\";s:3:\"api\";a:4:{s:5:\"owner\";s:5:\"views\";s:3:\"api\";s:13:\"views_default\";s:15:\"minimum_version\";s:1:\"2\";s:15:\"current_version\";s:3:\"3.0\";}s:6:\"object\";s:4:\"view\";s:19:\"subrecords callback\";s:26:\"views_load_display_records\";s:6:\"status\";s:14:\"views_defaults\";s:15:\"create callback\";s:14:\"views_new_view\";s:13:\"save callback\";s:15:\"views_save_view\";s:15:\"delete callback\";s:17:\"views_delete_view\";s:15:\"export callback\";s:17:\"views_export_view\";s:15:\"status callback\";s:19:\"views_export_status\";s:14:\"cache defaults\";b:1;s:17:\"default cache bin\";s:11:\"cache_views\";}s:6:\"fields\";a:7:{s:3:\"vid\";a:4:{s:4:\"type\";s:6:\"serial\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:9:\"no export\";b:1;}s:4:\"name\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:7:\"default\";s:0:\"\";s:8:\"not null\";b:1;}s:11:\"description\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:7:\"default\";s:0:\"\";}s:3:\"tag\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:7:\"default\";s:0:\"\";}s:10:\"base_table\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:64;s:7:\"default\";s:0:\"\";s:8:\"not null\";b:1;}s:10:\"human_name\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:7:\"default\";s:0:\"\";}s:4:\"core\";a:2:{s:4:\"type\";s:3:\"int\";s:7:\"default\";i:0;}}s:11:\"primary key\";a:1:{i:0;s:3:\"vid\";}s:11:\"unique keys\";a:1:{s:4:\"name\";a:1:{i:0;s:4:\"name\";}}s:6:\"module\";s:5:\"views\";s:4:\"name\";s:10:\"views_view\";}s:13:\"views_display\";a:5:{s:6:\"fields\";a:6:{s:3:\"vid\";a:5:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;s:9:\"no export\";b:1;}s:2:\"id\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:2:\"64\";s:7:\"default\";s:0:\"\";s:8:\"not null\";b:1;}s:13:\"display_title\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:2:\"64\";s:7:\"default\";s:0:\"\";s:8:\"not null\";b:1;}s:14:\"display_plugin\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:2:\"64\";s:7:\"default\";s:0:\"\";s:8:\"not null\";b:1;}s:8:\"position\";a:2:{s:4:\"type\";s:3:\"int\";s:7:\"default\";i:0;}s:15:\"display_options\";a:4:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:3:\"big\";s:9:\"serialize\";b:1;s:18:\"serialized default\";s:6:\"a:0:{}\";}}s:7:\"indexes\";a:1:{s:3:\"vid\";a:2:{i:0;s:3:\"vid\";i:1;s:8:\"position\";}}s:11:\"primary key\";a:2:{i:0;s:3:\"vid\";i:1;s:2:\"id\";}s:6:\"module\";s:5:\"views\";s:4:\"name\";s:13:\"views_display\";}s:11:\"field_group\";a:7:{s:6:\"export\";a:8:{s:3:\"key\";s:10:\"identifier\";s:10:\"identifier\";s:11:\"field_group\";s:12:\"default hook\";s:16:\"field_group_info\";s:13:\"load callback\";s:36:\"field_group_group_load_by_identifier\";s:13:\"save callback\";s:22:\"field_group_group_save\";s:15:\"delete callback\";s:31:\"field_group_group_export_delete\";s:11:\"can disable\";b:1;s:3:\"api\";a:4:{s:5:\"owner\";s:11:\"field_group\";s:3:\"api\";s:11:\"field_group\";s:15:\"minimum_version\";i:1;s:15:\"current_version\";i:1;}}s:6:\"fields\";a:8:{s:2:\"id\";a:3:{s:4:\"type\";s:6:\"serial\";s:8:\"not null\";b:1;s:9:\"no export\";b:1;}s:10:\"identifier\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:10:\"group_name\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:11:\"entity_type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"bundle\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:4:\"mode\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:11:\"parent_name\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:4:\"data\";a:4:{s:4:\"type\";s:4:\"blob\";s:4:\"size\";s:3:\"big\";s:8:\"not null\";b:1;s:9:\"serialize\";b:1;}}s:11:\"primary key\";a:1:{i:0;s:2:\"id\";}s:7:\"indexes\";a:1:{s:10:\"group_name\";a:1:{i:0;s:10:\"group_name\";}}s:11:\"unique keys\";a:1:{s:10:\"identifier\";a:1:{i:0;s:10:\"identifier\";}}s:6:\"module\";s:11:\"field_group\";s:4:\"name\";s:11:\"field_group\";}s:11:\"menu_router\";a:5:{s:6:\"fields\";a:23:{s:4:\"path\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:14:\"load_functions\";a:2:{s:4:\"type\";s:4:\"blob\";s:8:\"not null\";b:1;}s:16:\"to_arg_functions\";a:2:{s:4:\"type\";s:4:\"blob\";s:8:\"not null\";b:1;}s:15:\"access_callback\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:16:\"access_arguments\";a:2:{s:4:\"type\";s:4:\"blob\";s:8:\"not null\";b:0;}s:13:\"page_callback\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:14:\"page_arguments\";a:2:{s:4:\"type\";s:4:\"blob\";s:8:\"not null\";b:0;}s:17:\"delivery_callback\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:3:\"fit\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:12:\"number_parts\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:4:\"size\";s:5:\"small\";}s:7:\"context\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:10:\"tab_parent\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:8:\"tab_root\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"title\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:14:\"title_callback\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:15:\"title_arguments\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:14:\"theme_callback\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:15:\"theme_arguments\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:4:\"type\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:11:\"description\";a:2:{s:4:\"type\";s:4:\"text\";s:8:\"not null\";b:1;}s:8:\"position\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"weight\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:12:\"include_file\";a:2:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:6:\"medium\";}}s:7:\"indexes\";a:3:{s:3:\"fit\";a:1:{i:0;s:3:\"fit\";}s:10:\"tab_parent\";a:3:{i:0;a:2:{i:0;s:10:\"tab_parent\";i:1;i:64;}i:1;s:6:\"weight\";i:2;s:5:\"title\";}s:21:\"tab_root_weight_title\";a:3:{i:0;a:2:{i:0;s:8:\"tab_root\";i:1;i:64;}i:1;s:6:\"weight\";i:2;s:5:\"title\";}}s:11:\"primary key\";a:1:{i:0;s:4:\"path\";}s:6:\"module\";s:6:\"system\";s:4:\"name\";s:11:\"menu_router\";}s:10:\"menu_links\";a:5:{s:6:\"fields\";a:25:{s:9:\"menu_name\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:4:\"mlid\";a:3:{s:4:\"type\";s:6:\"serial\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:4:\"plid\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"link_path\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:11:\"router_path\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:10:\"link_title\";a:5:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:12:\"translatable\";b:1;}s:7:\"options\";a:3:{s:4:\"type\";s:4:\"blob\";s:8:\"not null\";b:0;s:12:\"translatable\";b:1;}s:6:\"module\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:6:\"system\";}s:6:\"hidden\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:4:\"size\";s:5:\"small\";}s:8:\"external\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:4:\"size\";s:5:\"small\";}s:12:\"has_children\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:4:\"size\";s:5:\"small\";}s:8:\"expanded\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:4:\"size\";s:5:\"small\";}s:6:\"weight\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:5:\"depth\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:4:\"size\";s:5:\"small\";}s:10:\"customized\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:4:\"size\";s:5:\"small\";}s:2:\"p1\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:2:\"p2\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:2:\"p3\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:2:\"p4\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:2:\"p5\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:2:\"p6\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:2:\"p7\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:2:\"p8\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:2:\"p9\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:7:\"updated\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:4:\"size\";s:5:\"small\";}}s:7:\"indexes\";a:4:{s:9:\"path_menu\";a:2:{i:0;a:2:{i:0;s:9:\"link_path\";i:1;i:128;}i:1;s:9:\"menu_name\";}s:22:\"menu_plid_expand_child\";a:4:{i:0;s:9:\"menu_name\";i:1;s:4:\"plid\";i:2;s:8:\"expanded\";i:3;s:12:\"has_children\";}s:12:\"menu_parents\";a:10:{i:0;s:9:\"menu_name\";i:1;s:2:\"p1\";i:2;s:2:\"p2\";i:3;s:2:\"p3\";i:4;s:2:\"p4\";i:5;s:2:\"p5\";i:6;s:2:\"p6\";i:7;s:2:\"p7\";i:8;s:2:\"p8\";i:9;s:2:\"p9\";}s:11:\"router_path\";a:1:{i:0;a:2:{i:0;s:11:\"router_path\";i:1;i:128;}}}s:11:\"primary key\";a:1:{i:0;s:4:\"mlid\";}s:6:\"module\";s:6:\"system\";s:4:\"name\";s:10:\"menu_links\";}s:20:\"flexslider_optionset\";a:5:{s:6:\"export\";a:4:{s:3:\"key\";s:4:\"name\";s:10:\"identifier\";s:6:\"preset\";s:12:\"default hook\";s:26:\"flexslider_default_presets\";s:3:\"api\";a:4:{s:5:\"owner\";s:10:\"flexslider\";s:3:\"api\";s:25:\"flexslider_default_preset\";s:15:\"minimum_version\";i:1;s:15:\"current_version\";i:1;}}s:6:\"fields\";a:6:{s:4:\"name\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;}s:5:\"title\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;}s:5:\"theme\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:7:\"classic\";}s:17:\"imagestyle_normal\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:15:\"flexslider_full\";}s:20:\"imagestyle_thumbnail\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:20:\"flexslider_thumbnail\";}s:7:\"options\";a:3:{s:4:\"type\";s:4:\"blob\";s:4:\"size\";s:3:\"big\";s:9:\"serialize\";b:1;}}s:11:\"primary key\";a:1:{i:0;s:4:\"name\";}s:6:\"module\";s:10:\"flexslider\";s:4:\"name\";s:20:\"flexslider_optionset\";}s:16:\"vef_video_styles\";a:5:{s:6:\"export\";a:4:{s:3:\"key\";s:4:\"name\";s:10:\"identifier\";s:17:\"video_embed_style\";s:12:\"default hook\";s:26:\"default_video_embed_styles\";s:3:\"api\";a:4:{s:5:\"owner\";s:17:\"video_embed_field\";s:3:\"api\";s:26:\"default_video_embed_styles\";s:15:\"minimum_version\";i:1;s:15:\"current_version\";i:1;}}s:6:\"fields\";a:3:{s:4:\"name\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;}s:5:\"title\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;}s:4:\"data\";a:4:{s:4:\"type\";s:4:\"blob\";s:4:\"size\";s:3:\"big\";s:8:\"not null\";b:1;s:9:\"serialize\";b:1;}}s:11:\"primary key\";a:1:{i:0;s:4:\"name\";}s:6:\"module\";s:17:\"video_embed_field\";s:4:\"name\";s:16:\"vef_video_styles\";}}',0,1512620348,1),('theme_registry:build:modules','a:466:{s:16:\"admin_menu_links\";a:6:{s:14:\"render element\";s:8:\"elements\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:28:\"sites/all/modules/admin_menu\";s:8:\"function\";s:22:\"theme_admin_menu_links\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:15:\"admin_menu_icon\";a:8:{s:9:\"variables\";a:2:{s:3:\"src\";N;s:3:\"alt\";N;}s:4:\"file\";s:14:\"admin_menu.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:28:\"sites/all/modules/admin_menu\";s:8:\"function\";s:21:\"theme_admin_menu_icon\";s:8:\"includes\";a:1:{i:0;s:43:\"sites/all/modules/admin_menu/admin_menu.inc\";}s:20:\"preprocess functions\";a:1:{i:0;s:35:\"template_preprocess_admin_menu_icon\";}s:17:\"process functions\";a:0:{}}s:22:\"features_module_status\";a:9:{s:9:\"variables\";a:2:{s:6:\"module\";N;s:6:\"status\";N;}s:4:\"path\";s:32:\"sites/all/modules/features/theme\";s:4:\"file\";s:9:\"theme.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:26:\"sites/all/modules/features\";s:8:\"function\";s:28:\"theme_features_module_status\";s:8:\"includes\";a:1:{i:0;s:42:\"sites/all/modules/features/theme/theme.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:19:\"features_components\";a:9:{s:9:\"variables\";a:2:{s:4:\"info\";N;s:7:\"sources\";N;}s:4:\"path\";s:32:\"sites/all/modules/features/theme\";s:4:\"file\";s:9:\"theme.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:26:\"sites/all/modules/features\";s:8:\"function\";s:25:\"theme_features_components\";s:8:\"includes\";a:1:{i:0;s:42:\"sites/all/modules/features/theme/theme.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:22:\"features_component_key\";a:8:{s:4:\"path\";s:32:\"sites/all/modules/features/theme\";s:4:\"file\";s:9:\"theme.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:26:\"sites/all/modules/features\";s:8:\"function\";s:28:\"theme_features_component_key\";s:8:\"includes\";a:1:{i:0;s:42:\"sites/all/modules/features/theme/theme.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:23:\"features_component_list\";a:9:{s:9:\"variables\";a:3:{s:10:\"components\";a:0:{}s:6:\"source\";a:0:{}s:9:\"conflicts\";a:0:{}}s:4:\"path\";s:32:\"sites/all/modules/features/theme\";s:4:\"file\";s:9:\"theme.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:26:\"sites/all/modules/features\";s:8:\"function\";s:29:\"theme_features_component_list\";s:8:\"includes\";a:1:{i:0;s:42:\"sites/all/modules/features/theme/theme.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:21:\"features_storage_link\";a:9:{s:9:\"variables\";a:4:{s:7:\"storage\";N;s:4:\"text\";N;s:4:\"path\";N;s:7:\"options\";a:0:{}}s:4:\"path\";s:32:\"sites/all/modules/features/theme\";s:4:\"file\";s:9:\"theme.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:26:\"sites/all/modules/features\";s:8:\"function\";s:27:\"theme_features_storage_link\";s:8:\"includes\";a:1:{i:0;s:42:\"sites/all/modules/features/theme/theme.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:18:\"features_lock_link\";a:9:{s:9:\"variables\";a:3:{s:7:\"feature\";N;s:9:\"component\";N;s:6:\"locked\";b:0;}s:4:\"path\";s:32:\"sites/all/modules/features/theme\";s:4:\"file\";s:9:\"theme.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:26:\"sites/all/modules/features\";s:8:\"function\";s:24:\"theme_features_lock_link\";s:8:\"includes\";a:1:{i:0;s:42:\"sites/all/modules/features/theme/theme.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:21:\"features_form_package\";a:9:{s:14:\"render element\";s:4:\"form\";s:4:\"path\";s:32:\"sites/all/modules/features/theme\";s:4:\"file\";s:9:\"theme.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:26:\"sites/all/modules/features\";s:8:\"function\";s:27:\"theme_features_form_package\";s:8:\"includes\";a:1:{i:0;s:42:\"sites/all/modules/features/theme/theme.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:20:\"features_form_export\";a:9:{s:14:\"render element\";s:4:\"form\";s:4:\"path\";s:32:\"sites/all/modules/features/theme\";s:4:\"file\";s:9:\"theme.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:26:\"sites/all/modules/features\";s:8:\"function\";s:26:\"theme_features_form_export\";s:8:\"includes\";a:1:{i:0;s:42:\"sites/all/modules/features/theme/theme.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:24:\"features_form_components\";a:9:{s:14:\"render element\";s:4:\"form\";s:4:\"path\";s:32:\"sites/all/modules/features/theme\";s:4:\"file\";s:9:\"theme.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:26:\"sites/all/modules/features\";s:8:\"function\";s:30:\"theme_features_form_components\";s:8:\"includes\";a:1:{i:0;s:42:\"sites/all/modules/features/theme/theme.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:21:\"features_form_buttons\";a:9:{s:14:\"render element\";s:7:\"element\";s:4:\"path\";s:32:\"sites/all/modules/features/theme\";s:4:\"file\";s:9:\"theme.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:26:\"sites/all/modules/features\";s:8:\"function\";s:27:\"theme_features_form_buttons\";s:8:\"includes\";a:1:{i:0;s:42:\"sites/all/modules/features/theme/theme.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:25:\"features_admin_components\";a:9:{s:14:\"render element\";s:4:\"form\";s:8:\"template\";s:25:\"features-admin-components\";s:4:\"path\";s:32:\"sites/all/modules/features/theme\";s:4:\"file\";s:9:\"theme.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:26:\"sites/all/modules/features\";s:8:\"includes\";a:1:{i:0;s:42:\"sites/all/modules/features/theme/theme.inc\";}s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:45:\"template_preprocess_features_admin_components\";i:2;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:26:\"advanced_forum_topic_pager\";a:7:{s:8:\"template\";s:32:\"advanced-forum.naked.topic-pager\";s:4:\"path\";s:45:\"sites/all/modules/advanced_forum/styles/naked\";s:9:\"variables\";a:2:{s:9:\"pagecount\";N;s:5:\"topic\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/advanced_forum\";s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:21:\"contextual_preprocess\";i:2;s:52:\"advanced_forum_preprocess_advanced_forum_topic_pager\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:28:\"advanced_forum_active_poster\";a:7:{s:8:\"template\";s:34:\"advanced-forum.naked.active-poster\";s:4:\"path\";s:45:\"sites/all/modules/advanced_forum/styles/naked\";s:9:\"variables\";a:5:{s:5:\"forum\";N;s:7:\"account\";N;s:5:\"posts\";N;s:6:\"topics\";N;s:9:\"last_post\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/advanced_forum\";s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:21:\"contextual_preprocess\";i:2;s:54:\"advanced_forum_preprocess_advanced_forum_active_poster\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:36:\"advanced_forum_topic_list_outer_view\";a:6:{s:8:\"template\";s:42:\"advanced-forum.naked.topic-list-outer-view\";s:4:\"path\";s:45:\"sites/all/modules/advanced_forum/styles/naked\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/advanced_forum\";s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:19:\"advanced_forum_post\";a:6:{s:8:\"template\";s:25:\"advanced-forum.naked.post\";s:4:\"path\";s:45:\"sites/all/modules/advanced_forum/styles/naked\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/advanced_forum\";s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:28:\"advanced_forum_search_result\";a:6:{s:8:\"template\";s:34:\"advanced-forum.naked.search-result\";s:4:\"path\";s:45:\"sites/all/modules/advanced_forum/styles/naked\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/advanced_forum\";s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:25:\"advanced_forum_topic_icon\";a:6:{s:8:\"template\";s:31:\"advanced-forum.naked.topic-icon\";s:4:\"path\";s:45:\"sites/all/modules/advanced_forum/styles/naked\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/advanced_forum\";s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:21:\"advanced_forum_forums\";a:6:{s:8:\"template\";s:27:\"advanced-forum.naked.forums\";s:4:\"path\";s:45:\"sites/all/modules/advanced_forum/styles/naked\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/advanced_forum\";s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:27:\"advanced_forum_search_topic\";a:6:{s:8:\"template\";s:33:\"advanced-forum.naked.search-topic\";s:4:\"path\";s:45:\"sites/all/modules/advanced_forum/styles/naked\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/advanced_forum\";s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:21:\"contextual_preprocess\";i:2;s:53:\"advanced_forum_preprocess_advanced_forum_search_topic\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:26:\"advanced_forum_post_edited\";a:7:{s:8:\"template\";s:32:\"advanced-forum.naked.post-edited\";s:4:\"path\";s:45:\"sites/all/modules/advanced_forum/styles/naked\";s:9:\"variables\";a:3:{s:3:\"who\";N;s:4:\"when\";N;s:3:\"why\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/advanced_forum\";s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:21:\"contextual_preprocess\";i:2;s:52:\"advanced_forum_preprocess_advanced_forum_post_edited\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:25:\"advanced_forum_topic_list\";a:6:{s:8:\"template\";s:31:\"advanced-forum.naked.topic-list\";s:4:\"path\";s:45:\"sites/all/modules/advanced_forum/styles/naked\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/advanced_forum\";s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:25:\"advanced_forum_forum_list\";a:6:{s:8:\"template\";s:31:\"advanced-forum.naked.forum-list\";s:4:\"path\";s:45:\"sites/all/modules/advanced_forum/styles/naked\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/advanced_forum\";s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:30:\"advanced_forum_topic_list_view\";a:9:{s:8:\"template\";s:36:\"advanced-forum.naked.topic-list-view\";s:4:\"path\";s:45:\"sites/all/modules/advanced_forum/styles/naked\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/advanced_forum\";s:8:\"includes\";a:1:{i:0;s:51:\"sites/all/modules/advanced_forum/includes/theme.inc\";}s:7:\"pattern\";s:32:\"advanced_forum_topic_list_view__\";s:9:\"variables\";a:4:{s:4:\"view\";N;s:7:\"options\";N;s:4:\"rows\";N;s:5:\"title\";N;}s:20:\"preprocess functions\";a:6:{i:0;s:19:\"template_preprocess\";i:1;s:50:\"template_preprocess_advanced_forum_topic_list_view\";i:2;s:21:\"contextual_preprocess\";i:3;s:19:\"template_preprocess\";i:4;s:50:\"template_preprocess_advanced_forum_topic_list_view\";i:5;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:4:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";i:2;s:16:\"template_process\";i:3;s:14:\"ctools_process\";}}s:27:\"advanced_forum_topic_legend\";a:6:{s:8:\"template\";s:32:\"advanced-forum.plus.topic-legend\";s:4:\"path\";s:51:\"sites/all/themes/forum_plus/css/advanced_forum/plus\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/advanced_forum\";s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:21:\"contextual_preprocess\";i:2;s:53:\"advanced_forum_preprocess_advanced_forum_topic_legend\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:27:\"advanced_forum_topic_header\";a:7:{s:8:\"template\";s:33:\"advanced-forum.naked.topic-header\";s:4:\"path\";s:45:\"sites/all/modules/advanced_forum/styles/naked\";s:9:\"variables\";a:2:{s:4:\"node\";N;s:13:\"comment_count\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/advanced_forum\";s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:21:\"contextual_preprocess\";i:2;s:53:\"advanced_forum_preprocess_advanced_forum_topic_header\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:28:\"advanced_forum_post_repeated\";a:6:{s:8:\"template\";s:34:\"advanced-forum.naked.post-repeated\";s:4:\"path\";s:45:\"sites/all/modules/advanced_forum/styles/naked\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/advanced_forum\";s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:24:\"advanced_forum_submitted\";a:6:{s:8:\"template\";s:30:\"advanced-forum.naked.submitted\";s:4:\"path\";s:45:\"sites/all/modules/advanced_forum/styles/naked\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/advanced_forum\";s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:27:\"advanced_forum_search_forum\";a:6:{s:8:\"template\";s:33:\"advanced-forum.naked.search-forum\";s:4:\"path\";s:45:\"sites/all/modules/advanced_forum/styles/naked\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/advanced_forum\";s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:21:\"contextual_preprocess\";i:2;s:53:\"advanced_forum_preprocess_advanced_forum_search_forum\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:25:\"advanced_forum_statistics\";a:6:{s:8:\"template\";s:31:\"advanced-forum.naked.statistics\";s:4:\"path\";s:45:\"sites/all/modules/advanced_forum/styles/naked\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/advanced_forum\";s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:21:\"contextual_preprocess\";i:2;s:51:\"advanced_forum_preprocess_advanced_forum_statistics\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:26:\"advanced_forum_author_pane\";a:6:{s:8:\"template\";s:31:\"advanced-forum.plus.author-pane\";s:4:\"path\";s:51:\"sites/all/themes/forum_plus/css/advanced_forum/plus\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/advanced_forum\";s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:27:\"advanced_forum_post_preview\";a:6:{s:8:\"template\";s:33:\"advanced-forum.naked.post-preview\";s:4:\"path\";s:45:\"sites/all/modules/advanced_forum/styles/naked\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/advanced_forum\";s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:27:\"advanced_forum_shadow_topic\";a:7:{s:8:\"template\";s:33:\"advanced-forum.naked.shadow-topic\";s:4:\"path\";s:45:\"sites/all/modules/advanced_forum/styles/naked\";s:9:\"variables\";a:3:{s:5:\"title\";N;s:3:\"nid\";N;s:9:\"new_forum\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/advanced_forum\";s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:21:\"contextual_preprocess\";i:2;s:53:\"advanced_forum_preprocess_advanced_forum_shadow_topic\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:27:\"advanced_forum_forum_legend\";a:6:{s:8:\"template\";s:32:\"advanced-forum.plus.forum-legend\";s:4:\"path\";s:51:\"sites/all/themes/forum_plus/css/advanced_forum/plus\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/advanced_forum\";s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:21:\"contextual_preprocess\";i:2;s:53:\"advanced_forum_preprocess_advanced_forum_forum_legend\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:30:\"advanced_forum_comment_wrapper\";a:6:{s:8:\"template\";s:36:\"advanced-forum.naked.comment-wrapper\";s:4:\"path\";s:45:\"sites/all/modules/advanced_forum/styles/naked\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/advanced_forum\";s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:42:\"advanced_forum_group_topic_list_outer_view\";a:6:{s:8:\"template\";s:48:\"advanced-forum.naked.group-topic-list-outer-view\";s:4:\"path\";s:45:\"sites/all/modules/advanced_forum/styles/naked\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/advanced_forum\";s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:16:\"advanced_forum_l\";a:6:{s:9:\"variables\";a:4:{s:4:\"text\";N;s:4:\"path\";N;s:7:\"options\";a:0:{}s:12:\"button_class\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/advanced_forum\";s:8:\"function\";s:22:\"theme_advanced_forum_l\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:27:\"advanced_forum_user_picture\";a:6:{s:9:\"variables\";a:1:{s:7:\"account\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/advanced_forum\";s:8:\"function\";s:33:\"theme_advanced_forum_user_picture\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:25:\"advanced_forum_reply_link\";a:6:{s:9:\"variables\";a:1:{s:4:\"node\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/advanced_forum\";s:8:\"function\";s:31:\"theme_advanced_forum_reply_link\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:28:\"advanced_forum_subforum_list\";a:6:{s:9:\"variables\";a:1:{s:13:\"subforum_list\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/advanced_forum\";s:8:\"function\";s:34:\"theme_advanced_forum_subforum_list\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:32:\"advanced_forum_subcontainer_list\";a:6:{s:9:\"variables\";a:1:{s:17:\"subcontainer_list\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/advanced_forum\";s:8:\"function\";s:38:\"theme_advanced_forum_subcontainer_list\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:33:\"advanced_forum_simple_author_pane\";a:6:{s:9:\"variables\";a:1:{s:7:\"context\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/advanced_forum\";s:8:\"function\";s:39:\"theme_advanced_forum_simple_author_pane\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:36:\"advanced_forum_node_type_create_list\";a:6:{s:9:\"variables\";a:1:{s:8:\"forum_id\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/advanced_forum\";s:8:\"function\";s:42:\"theme_advanced_forum_node_type_create_list\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:37:\"views_view__advanced_forum_topic_list\";a:6:{s:9:\"variables\";a:1:{s:4:\"view\";N;}s:8:\"template\";s:69:\"sites/all/modules/advanced_forum/advanced-forum-topic-list-outer-view\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/advanced_forum\";s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:21:\"contextual_preprocess\";i:2;s:63:\"advanced_forum_preprocess_views_view__advanced_forum_topic_list\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:43:\"views_view__advanced_forum_group_topic_list\";a:6:{s:9:\"variables\";a:1:{s:4:\"view\";N;}s:8:\"template\";s:75:\"sites/all/modules/advanced_forum/advanced-forum-group-topic-list-outer-view\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/advanced_forum\";s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:21:\"contextual_preprocess\";i:2;s:69:\"advanced_forum_preprocess_views_view__advanced_forum_group_topic_list\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:16:\"views_mini_pager\";a:10:{s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:29:\"sites/all/modules/views/theme\";s:9:\"variables\";a:3:{s:4:\"tags\";a:0:{}s:7:\"element\";i:0;s:10:\"parameters\";a:0:{}}s:7:\"pattern\";s:18:\"views_mini_pager__\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:23:\"sites/all/modules/views\";s:8:\"function\";s:22:\"theme_views_mini_pager\";s:8:\"includes\";a:1:{i:0;s:39:\"sites/all/modules/views/theme/theme.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:16:\"views_view_field\";a:10:{s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:29:\"sites/all/modules/views/theme\";s:7:\"pattern\";s:18:\"views_view_field__\";s:9:\"variables\";a:3:{s:4:\"view\";N;s:5:\"field\";N;s:3:\"row\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:23:\"sites/all/modules/views\";s:8:\"function\";s:22:\"theme_views_view_field\";s:8:\"includes\";a:1:{i:0;s:39:\"sites/all/modules/views/theme/theme.inc\";}s:20:\"preprocess functions\";a:1:{i:0;s:36:\"template_preprocess_views_view_field\";}s:17:\"process functions\";a:0:{}}s:19:\"views_view_grouping\";a:10:{s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:29:\"sites/all/modules/views/theme\";s:7:\"pattern\";s:21:\"views_view_grouping__\";s:9:\"variables\";a:5:{s:4:\"view\";N;s:8:\"grouping\";N;s:14:\"grouping_level\";N;s:4:\"rows\";N;s:5:\"title\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:23:\"sites/all/modules/views\";s:8:\"function\";s:25:\"theme_views_view_grouping\";s:8:\"includes\";a:1:{i:0;s:39:\"sites/all/modules/views/theme/theme.inc\";}s:20:\"preprocess functions\";a:1:{i:0;s:39:\"template_preprocess_views_view_grouping\";}s:17:\"process functions\";a:0:{}}s:10:\"views_view\";a:10:{s:7:\"pattern\";s:12:\"views_view__\";s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:29:\"sites/all/modules/views/theme\";s:9:\"variables\";a:2:{s:10:\"view_array\";a:0:{}s:4:\"view\";N;}s:8:\"template\";s:10:\"views-view\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:23:\"sites/all/modules/views\";s:8:\"includes\";a:1:{i:0;s:39:\"sites/all/modules/views/theme/theme.inc\";}s:20:\"preprocess functions\";a:5:{i:0;s:19:\"template_preprocess\";i:1;s:30:\"template_preprocess_views_view\";i:2;s:21:\"contextual_preprocess\";i:3;s:32:\"date_views_preprocess_views_view\";i:4;s:30:\"views_ui_preprocess_views_view\";}s:17:\"process functions\";a:3:{i:0;s:16:\"template_process\";i:1;s:27:\"template_process_views_view\";i:2;s:14:\"ctools_process\";}}s:14:\"calendar_style\";a:10:{s:7:\"pattern\";s:16:\"calendar_style__\";s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:32:\"sites/all/modules/calendar/theme\";s:9:\"variables\";a:4:{s:4:\"view\";N;s:7:\"options\";N;s:4:\"rows\";N;s:5:\"title\";N;}s:8:\"template\";s:14:\"calendar-style\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:23:\"sites/all/modules/views\";s:8:\"includes\";a:1:{i:0;s:42:\"sites/all/modules/calendar/theme/theme.inc\";}s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:34:\"template_preprocess_calendar_style\";i:2;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:13:\"calendar_mini\";a:10:{s:7:\"pattern\";s:15:\"calendar_mini__\";s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:32:\"sites/all/modules/calendar/theme\";s:9:\"variables\";a:4:{s:4:\"view\";N;s:7:\"options\";N;s:4:\"rows\";N;s:5:\"title\";N;}s:8:\"template\";s:13:\"calendar-mini\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:23:\"sites/all/modules/views\";s:8:\"includes\";a:1:{i:0;s:42:\"sites/all/modules/calendar/theme/theme.inc\";}s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:33:\"template_preprocess_calendar_mini\";i:2;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:12:\"calendar_day\";a:10:{s:7:\"pattern\";s:14:\"calendar_day__\";s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:32:\"sites/all/modules/calendar/theme\";s:9:\"variables\";a:4:{s:4:\"view\";N;s:7:\"options\";N;s:4:\"rows\";N;s:5:\"title\";N;}s:8:\"template\";s:12:\"calendar-day\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:23:\"sites/all/modules/views\";s:8:\"includes\";a:1:{i:0;s:42:\"sites/all/modules/calendar/theme/theme.inc\";}s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:32:\"template_preprocess_calendar_day\";i:2;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:13:\"calendar_week\";a:10:{s:7:\"pattern\";s:15:\"calendar_week__\";s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:32:\"sites/all/modules/calendar/theme\";s:9:\"variables\";a:4:{s:4:\"view\";N;s:7:\"options\";N;s:4:\"rows\";N;s:5:\"title\";N;}s:8:\"template\";s:13:\"calendar-week\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:23:\"sites/all/modules/views\";s:8:\"includes\";a:1:{i:0;s:42:\"sites/all/modules/calendar/theme/theme.inc\";}s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:33:\"template_preprocess_calendar_week\";i:2;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:14:\"calendar_month\";a:10:{s:7:\"pattern\";s:16:\"calendar_month__\";s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:32:\"sites/all/modules/calendar/theme\";s:9:\"variables\";a:4:{s:4:\"view\";N;s:7:\"options\";N;s:4:\"rows\";N;s:5:\"title\";N;}s:8:\"template\";s:14:\"calendar-month\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:23:\"sites/all/modules/views\";s:8:\"includes\";a:1:{i:0;s:42:\"sites/all/modules/calendar/theme/theme.inc\";}s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:34:\"template_preprocess_calendar_month\";i:2;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:13:\"calendar_year\";a:10:{s:7:\"pattern\";s:15:\"calendar_year__\";s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:32:\"sites/all/modules/calendar/theme\";s:9:\"variables\";a:4:{s:4:\"view\";N;s:7:\"options\";N;s:4:\"rows\";N;s:5:\"title\";N;}s:8:\"template\";s:13:\"calendar-year\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:23:\"sites/all/modules/views\";s:8:\"includes\";a:1:{i:0;s:42:\"sites/all/modules/calendar/theme/theme.inc\";}s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:33:\"template_preprocess_calendar_year\";i:2;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:20:\"calendar_day_overlap\";a:10:{s:7:\"pattern\";s:22:\"calendar_day_overlap__\";s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:32:\"sites/all/modules/calendar/theme\";s:9:\"variables\";a:4:{s:4:\"view\";N;s:7:\"options\";N;s:4:\"rows\";N;s:5:\"title\";N;}s:8:\"template\";s:20:\"calendar-day-overlap\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:23:\"sites/all/modules/views\";s:8:\"includes\";a:1:{i:0;s:42:\"sites/all/modules/calendar/theme/theme.inc\";}s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:40:\"template_preprocess_calendar_day_overlap\";i:2;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:21:\"calendar_week_overlap\";a:10:{s:7:\"pattern\";s:23:\"calendar_week_overlap__\";s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:32:\"sites/all/modules/calendar/theme\";s:9:\"variables\";a:4:{s:4:\"view\";N;s:7:\"options\";N;s:4:\"rows\";N;s:5:\"title\";N;}s:8:\"template\";s:21:\"calendar-week-overlap\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:23:\"sites/all/modules/views\";s:8:\"includes\";a:1:{i:0;s:42:\"sites/all/modules/calendar/theme/theme.inc\";}s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:41:\"template_preprocess_calendar_week_overlap\";i:2;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:15:\"date_navigation\";a:10:{s:7:\"pattern\";s:17:\"date_navigation__\";s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:39:\"sites/all/modules/date/date_views/theme\";s:9:\"variables\";a:4:{s:4:\"view\";N;s:7:\"options\";N;s:4:\"rows\";N;s:5:\"title\";N;}s:8:\"template\";s:15:\"date-navigation\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:23:\"sites/all/modules/views\";s:8:\"includes\";a:1:{i:0;s:49:\"sites/all/modules/date/date_views/theme/theme.inc\";}s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:22:\"views_view_unformatted\";a:10:{s:7:\"pattern\";s:24:\"views_view_unformatted__\";s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:29:\"sites/all/modules/views/theme\";s:9:\"variables\";a:4:{s:4:\"view\";N;s:7:\"options\";N;s:4:\"rows\";N;s:5:\"title\";N;}s:8:\"template\";s:22:\"views-view-unformatted\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:23:\"sites/all/modules/views\";s:8:\"includes\";a:1:{i:0;s:39:\"sites/all/modules/views/theme/theme.inc\";}s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:42:\"template_preprocess_views_view_unformatted\";i:2;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:16:\"flexslider_views\";a:10:{s:7:\"pattern\";s:18:\"flexslider_views__\";s:4:\"file\";s:26:\"flexslider_views.theme.inc\";s:4:\"path\";s:51:\"sites/all/modules/flexslider/flexslider_views/theme\";s:9:\"variables\";a:4:{s:4:\"view\";N;s:7:\"options\";N;s:4:\"rows\";N;s:5:\"title\";N;}s:8:\"template\";s:16:\"flexslider-views\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:23:\"sites/all/modules/views\";s:8:\"includes\";a:1:{i:0;s:78:\"sites/all/modules/flexslider/flexslider_views/theme/flexslider_views.theme.inc\";}s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:3:{i:0;s:16:\"template_process\";i:1;s:33:\"template_process_flexslider_views\";i:2;s:14:\"ctools_process\";}}s:14:\"quicktabs_view\";a:10:{s:7:\"pattern\";s:16:\"quicktabs_view__\";s:4:\"file\";s:19:\"quicktabs.views.inc\";s:4:\"path\";s:27:\"sites/all/modules/quicktabs\";s:9:\"variables\";a:4:{s:4:\"view\";N;s:7:\"options\";N;s:4:\"rows\";N;s:5:\"title\";N;}s:8:\"template\";s:14:\"quicktabs-view\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:23:\"sites/all/modules/views\";s:8:\"includes\";a:1:{i:0;s:47:\"sites/all/modules/quicktabs/quicktabs.views.inc\";}s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:15:\"views_slideshow\";a:10:{s:7:\"pattern\";s:17:\"views_slideshow__\";s:4:\"file\";s:25:\"views_slideshow.theme.inc\";s:4:\"path\";s:39:\"sites/all/modules/views_slideshow/theme\";s:9:\"variables\";a:4:{s:4:\"view\";N;s:7:\"options\";N;s:4:\"rows\";N;s:5:\"title\";N;}s:8:\"template\";s:15:\"views-slideshow\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:23:\"sites/all/modules/views\";s:8:\"includes\";a:1:{i:0;s:65:\"sites/all/modules/views_slideshow/theme/views_slideshow.theme.inc\";}s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:35:\"template_preprocess_views_slideshow\";i:2;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:15:\"views_view_list\";a:10:{s:7:\"pattern\";s:17:\"views_view_list__\";s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:29:\"sites/all/modules/views/theme\";s:9:\"variables\";a:4:{s:4:\"view\";N;s:7:\"options\";N;s:4:\"rows\";N;s:5:\"title\";N;}s:8:\"template\";s:15:\"views-view-list\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:23:\"sites/all/modules/views\";s:8:\"includes\";a:1:{i:0;s:39:\"sites/all/modules/views/theme/theme.inc\";}s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:35:\"template_preprocess_views_view_list\";i:2;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:15:\"views_view_grid\";a:10:{s:7:\"pattern\";s:17:\"views_view_grid__\";s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:29:\"sites/all/modules/views/theme\";s:9:\"variables\";a:4:{s:4:\"view\";N;s:7:\"options\";N;s:4:\"rows\";N;s:5:\"title\";N;}s:8:\"template\";s:15:\"views-view-grid\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:23:\"sites/all/modules/views\";s:8:\"includes\";a:1:{i:0;s:39:\"sites/all/modules/views/theme/theme.inc\";}s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:35:\"template_preprocess_views_view_grid\";i:2;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:16:\"views_view_table\";a:10:{s:7:\"pattern\";s:18:\"views_view_table__\";s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:29:\"sites/all/modules/views/theme\";s:9:\"variables\";a:4:{s:4:\"view\";N;s:7:\"options\";N;s:4:\"rows\";N;s:5:\"title\";N;}s:8:\"template\";s:16:\"views-view-table\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:23:\"sites/all/modules/views\";s:8:\"includes\";a:1:{i:0;s:39:\"sites/all/modules/views/theme/theme.inc\";}s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:36:\"template_preprocess_views_view_table\";i:2;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:18:\"views_view_summary\";a:10:{s:7:\"pattern\";s:20:\"views_view_summary__\";s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:29:\"sites/all/modules/views/theme\";s:9:\"variables\";a:4:{s:4:\"view\";N;s:7:\"options\";N;s:4:\"rows\";N;s:5:\"title\";N;}s:8:\"template\";s:18:\"views-view-summary\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:23:\"sites/all/modules/views\";s:8:\"includes\";a:1:{i:0;s:39:\"sites/all/modules/views/theme/theme.inc\";}s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:38:\"template_preprocess_views_view_summary\";i:2;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:30:\"views_view_summary_unformatted\";a:10:{s:7:\"pattern\";s:32:\"views_view_summary_unformatted__\";s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:29:\"sites/all/modules/views/theme\";s:9:\"variables\";a:4:{s:4:\"view\";N;s:7:\"options\";N;s:4:\"rows\";N;s:5:\"title\";N;}s:8:\"template\";s:30:\"views-view-summary-unformatted\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:23:\"sites/all/modules/views\";s:8:\"includes\";a:1:{i:0;s:39:\"sites/all/modules/views/theme/theme.inc\";}s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:50:\"template_preprocess_views_view_summary_unformatted\";i:2;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:14:\"views_view_rss\";a:10:{s:7:\"pattern\";s:16:\"views_view_rss__\";s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:29:\"sites/all/modules/views/theme\";s:9:\"variables\";a:4:{s:4:\"view\";N;s:7:\"options\";N;s:4:\"rows\";N;s:5:\"title\";N;}s:8:\"template\";s:14:\"views-view-rss\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:23:\"sites/all/modules/views\";s:8:\"includes\";a:1:{i:0;s:39:\"sites/all/modules/views/theme/theme.inc\";}s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:34:\"template_preprocess_views_view_rss\";i:2;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:28:\"views_view_summary_jump_menu\";a:10:{s:7:\"pattern\";s:30:\"views_view_summary_jump_menu__\";s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:29:\"sites/all/modules/views/theme\";s:9:\"variables\";a:4:{s:4:\"view\";N;s:7:\"options\";N;s:4:\"rows\";N;s:5:\"title\";N;}s:8:\"template\";s:28:\"views-view-summary-jump-menu\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:23:\"sites/all/modules/views\";s:8:\"includes\";a:1:{i:0;s:39:\"sites/all/modules/views/theme/theme.inc\";}s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:20:\"views_view_jump_menu\";a:10:{s:7:\"pattern\";s:22:\"views_view_jump_menu__\";s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:29:\"sites/all/modules/views/theme\";s:9:\"variables\";a:4:{s:4:\"view\";N;s:7:\"options\";N;s:4:\"rows\";N;s:5:\"title\";N;}s:8:\"template\";s:20:\"views-view-jump-menu\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:23:\"sites/all/modules/views\";s:8:\"includes\";a:1:{i:0;s:39:\"sites/all/modules/views/theme/theme.inc\";}s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:17:\"views_view_fields\";a:10:{s:7:\"pattern\";s:19:\"views_view_fields__\";s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:29:\"sites/all/modules/views/theme\";s:9:\"variables\";a:4:{s:4:\"view\";N;s:7:\"options\";N;s:3:\"row\";N;s:11:\"field_alias\";N;}s:8:\"template\";s:17:\"views-view-fields\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:23:\"sites/all/modules/views\";s:8:\"includes\";a:1:{i:0;s:39:\"sites/all/modules/views/theme/theme.inc\";}s:20:\"preprocess functions\";a:4:{i:0;s:19:\"template_preprocess\";i:1;s:37:\"template_preprocess_views_view_fields\";i:2;s:21:\"contextual_preprocess\";i:3;s:44:\"views_fieldsets_preprocess_views_view_fields\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:22:\"views_view_row_comment\";a:10:{s:7:\"pattern\";s:24:\"views_view_row_comment__\";s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:29:\"sites/all/modules/views/theme\";s:9:\"variables\";a:4:{s:4:\"view\";N;s:7:\"options\";N;s:3:\"row\";N;s:11:\"field_alias\";N;}s:8:\"template\";s:22:\"views-view-row-comment\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:23:\"sites/all/modules/views\";s:8:\"includes\";a:1:{i:0;s:39:\"sites/all/modules/views/theme/theme.inc\";}s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:42:\"template_preprocess_views_view_row_comment\";i:2;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:18:\"views_view_row_rss\";a:10:{s:7:\"pattern\";s:20:\"views_view_row_rss__\";s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:29:\"sites/all/modules/views/theme\";s:9:\"variables\";a:4:{s:4:\"view\";N;s:7:\"options\";N;s:3:\"row\";N;s:11:\"field_alias\";N;}s:8:\"template\";s:18:\"views-view-row-rss\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:23:\"sites/all/modules/views\";s:8:\"includes\";a:1:{i:0;s:39:\"sites/all/modules/views/theme/theme.inc\";}s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:38:\"template_preprocess_views_view_row_rss\";i:2;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:21:\"views_form_views_form\";a:9:{s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:29:\"sites/all/modules/views/theme\";s:14:\"render element\";s:4:\"form\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:23:\"sites/all/modules/views\";s:8:\"function\";s:27:\"theme_views_form_views_form\";s:8:\"includes\";a:1:{i:0;s:39:\"sites/all/modules/views/theme/theme.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:18:\"views_exposed_form\";a:10:{s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:29:\"sites/all/modules/views/theme\";s:8:\"template\";s:18:\"views-exposed-form\";s:7:\"pattern\";s:20:\"views_exposed_form__\";s:14:\"render element\";s:4:\"form\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:23:\"sites/all/modules/views\";s:8:\"includes\";a:1:{i:0;s:39:\"sites/all/modules/views/theme/theme.inc\";}s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:38:\"template_preprocess_views_exposed_form\";i:2;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:10:\"views_more\";a:10:{s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:29:\"sites/all/modules/views/theme\";s:8:\"template\";s:10:\"views-more\";s:7:\"pattern\";s:12:\"views_more__\";s:9:\"variables\";a:3:{s:8:\"more_url\";N;s:9:\"link_text\";s:4:\"more\";s:4:\"view\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:23:\"sites/all/modules/views\";s:8:\"includes\";a:1:{i:0;s:39:\"sites/all/modules/views/theme/theme.inc\";}s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:6:\"forums\";a:6:{s:8:\"template\";s:20:\"modules/forum/forums\";s:9:\"variables\";a:6:{s:6:\"forums\";N;s:6:\"topics\";N;s:7:\"parents\";N;s:3:\"tid\";N;s:6:\"sortby\";N;s:14:\"forum_per_page\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:13:\"modules/forum\";s:20:\"preprocess functions\";a:4:{i:0;s:19:\"template_preprocess\";i:1;s:26:\"template_preprocess_forums\";i:2;s:21:\"contextual_preprocess\";i:3;s:32:\"advanced_forum_preprocess_forums\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:10:\"forum_list\";a:6:{s:8:\"template\";s:24:\"modules/forum/forum-list\";s:9:\"variables\";a:3:{s:6:\"forums\";N;s:7:\"parents\";N;s:3:\"tid\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:13:\"modules/forum\";s:20:\"preprocess functions\";a:4:{i:0;s:19:\"template_preprocess\";i:1;s:30:\"template_preprocess_forum_list\";i:2;s:21:\"contextual_preprocess\";i:3;s:36:\"advanced_forum_preprocess_forum_list\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:16:\"forum_topic_list\";a:6:{s:8:\"template\";s:30:\"modules/forum/forum-topic-list\";s:9:\"variables\";a:4:{s:3:\"tid\";N;s:6:\"topics\";N;s:6:\"sortby\";N;s:14:\"forum_per_page\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:13:\"modules/forum\";s:20:\"preprocess functions\";a:4:{i:0;s:19:\"template_preprocess\";i:1;s:36:\"template_preprocess_forum_topic_list\";i:2;s:21:\"contextual_preprocess\";i:3;s:42:\"advanced_forum_preprocess_forum_topic_list\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:10:\"forum_icon\";a:6:{s:8:\"template\";s:24:\"modules/forum/forum-icon\";s:9:\"variables\";a:5:{s:9:\"new_posts\";N;s:9:\"num_posts\";i:0;s:12:\"comment_mode\";i:0;s:6:\"sticky\";i:0;s:9:\"first_new\";b:0;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:13:\"modules/forum\";s:20:\"preprocess functions\";a:4:{i:0;s:19:\"template_preprocess\";i:1;s:30:\"template_preprocess_forum_icon\";i:2;s:21:\"contextual_preprocess\";i:3;s:36:\"advanced_forum_preprocess_forum_icon\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:15:\"forum_submitted\";a:6:{s:8:\"template\";s:29:\"modules/forum/forum-submitted\";s:9:\"variables\";a:1:{s:5:\"topic\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:13:\"modules/forum\";s:20:\"preprocess functions\";a:4:{i:0;s:19:\"template_preprocess\";i:1;s:35:\"template_preprocess_forum_submitted\";i:2;s:21:\"contextual_preprocess\";i:3;s:41:\"advanced_forum_preprocess_forum_submitted\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:10:\"forum_form\";a:8:{s:14:\"render element\";s:4:\"form\";s:4:\"file\";s:15:\"forum.admin.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:13:\"modules/forum\";s:8:\"function\";s:16:\"theme_forum_form\";s:8:\"includes\";a:1:{i:0;s:29:\"modules/forum/forum.admin.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:15:\"horizontal_tabs\";a:6:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:29:\"sites/all/modules/field_group\";s:8:\"function\";s:21:\"theme_horizontal_tabs\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:9:\"multipage\";a:6:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:29:\"sites/all/modules/field_group\";s:8:\"function\";s:15:\"theme_multipage\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:14:\"multipage_pane\";a:6:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:29:\"sites/all/modules/field_group\";s:8:\"function\";s:20:\"theme_multipage_pane\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:33:\"we_content_migration_form_package\";a:9:{s:14:\"render element\";s:4:\"form\";s:4:\"path\";s:44:\"sites/all/modules/we_content_migration/theme\";s:4:\"file\";s:9:\"theme.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:38:\"sites/all/modules/we_content_migration\";s:8:\"function\";s:39:\"theme_we_content_migration_form_package\";s:8:\"includes\";a:1:{i:0;s:54:\"sites/all/modules/we_content_migration/theme/theme.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:17:\"shortcode_tooltip\";a:6:{s:9:\"variables\";a:6:{s:2:\"id\";s:0:\"\";s:5:\"class\";s:0:\"\";s:9:\"placement\";s:0:\"\";s:5:\"title\";s:0:\"\";s:3:\"tag\";s:0:\"\";s:4:\"text\";s:0:\"\";}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/wee_shortcode\";s:8:\"function\";s:23:\"theme_shortcode_tooltip\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:18:\"shortcode_collapse\";a:7:{s:9:\"variables\";a:2:{s:10:\"accordions\";s:0:\"\";s:2:\"id\";s:0:\"\";}s:8:\"template\";s:8:\"collapse\";s:4:\"path\";s:35:\"sites/all/modules/wee_shortcode/tpl\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/wee_shortcode\";s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:28:\"views_ui_display_tab_setting\";a:7:{s:9:\"variables\";a:7:{s:11:\"description\";s:0:\"\";s:4:\"link\";s:0:\"\";s:14:\"settings_links\";a:0:{}s:10:\"overridden\";b:0;s:9:\"defaulted\";b:0;s:21:\"description_separator\";b:1;s:5:\"class\";a:0:{}}s:8:\"template\";s:28:\"views-ui-display-tab-setting\";s:4:\"path\";s:29:\"sites/all/modules/views/theme\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:23:\"sites/all/modules/views\";s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:48:\"template_preprocess_views_ui_display_tab_setting\";i:2;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:27:\"views_ui_display_tab_bucket\";a:7:{s:14:\"render element\";s:7:\"element\";s:8:\"template\";s:27:\"views-ui-display-tab-bucket\";s:4:\"path\";s:29:\"sites/all/modules/views/theme\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:23:\"sites/all/modules/views\";s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:47:\"template_preprocess_views_ui_display_tab_bucket\";i:2;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:23:\"views_ui_rearrange_form\";a:6:{s:14:\"render element\";s:4:\"form\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:23:\"sites/all/modules/views\";s:8:\"function\";s:29:\"theme_views_ui_rearrange_form\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:30:\"views_ui_rearrange_filter_form\";a:8:{s:14:\"render element\";s:4:\"form\";s:4:\"file\";s:18:\"includes/admin.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:23:\"sites/all/modules/views\";s:8:\"function\";s:36:\"theme_views_ui_rearrange_filter_form\";s:8:\"includes\";a:1:{i:0;s:42:\"sites/all/modules/views/includes/admin.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:27:\"views_ui_expose_filter_form\";a:8:{s:14:\"render element\";s:4:\"form\";s:4:\"file\";s:18:\"includes/admin.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:23:\"sites/all/modules/views\";s:8:\"function\";s:33:\"theme_views_ui_expose_filter_form\";s:8:\"includes\";a:1:{i:0;s:42:\"sites/all/modules/views/includes/admin.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:18:\"views_ui_view_info\";a:8:{s:9:\"variables\";a:2:{s:4:\"view\";N;s:4:\"base\";N;}s:4:\"file\";s:18:\"includes/admin.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:23:\"sites/all/modules/views\";s:8:\"function\";s:24:\"theme_views_ui_view_info\";s:8:\"includes\";a:1:{i:0;s:42:\"sites/all/modules/views/includes/admin.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:32:\"views_ui_build_group_filter_form\";a:8:{s:14:\"render element\";s:4:\"form\";s:4:\"file\";s:18:\"includes/admin.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:23:\"sites/all/modules/views\";s:8:\"function\";s:38:\"theme_views_ui_build_group_filter_form\";s:8:\"includes\";a:1:{i:0;s:42:\"sites/all/modules/views/includes/admin.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:12:\"views_tabset\";a:6:{s:9:\"variables\";a:1:{s:4:\"tabs\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:23:\"sites/all/modules/views\";s:8:\"function\";s:18:\"theme_views_tabset\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:9:\"views_tab\";a:6:{s:9:\"variables\";a:1:{s:4:\"body\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:23:\"sites/all/modules/views\";s:8:\"function\";s:15:\"theme_views_tab\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:30:\"views_ui_reorder_displays_form\";a:8:{s:14:\"render element\";s:4:\"form\";s:4:\"file\";s:18:\"includes/admin.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:23:\"sites/all/modules/views\";s:8:\"function\";s:36:\"theme_views_ui_reorder_displays_form\";s:8:\"includes\";a:1:{i:0;s:42:\"sites/all/modules/views/includes/admin.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:27:\"views_ui_style_plugin_table\";a:6:{s:14:\"render element\";s:4:\"form\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:23:\"sites/all/modules/views\";s:8:\"function\";s:33:\"theme_views_ui_style_plugin_table\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:29:\"views_ui_view_preview_section\";a:6:{s:9:\"variables\";a:4:{s:4:\"view\";N;s:7:\"section\";N;s:7:\"content\";N;s:5:\"links\";s:0:\"\";}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:23:\"sites/all/modules/views\";s:8:\"function\";s:35:\"theme_views_ui_view_preview_section\";s:20:\"preprocess functions\";a:1:{i:0;s:49:\"template_preprocess_views_ui_view_preview_section\";}s:17:\"process functions\";a:0:{}}s:15:\"views_container\";a:8:{s:14:\"render element\";s:7:\"element\";s:4:\"file\";s:15:\"theme/theme.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:23:\"sites/all/modules/views\";s:8:\"function\";s:21:\"theme_views_container\";s:8:\"includes\";a:1:{i:0;s:39:\"sites/all/modules/views/theme/theme.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:21:\"views_slideshow_cycle\";a:9:{s:9:\"variables\";a:4:{s:4:\"view\";N;s:8:\"settings\";a:0:{}s:4:\"rows\";a:0:{}s:5:\"title\";s:0:\"\";}s:8:\"template\";s:91:\"sites/all/modules/views_slideshow/contrib/views_slideshow_cycle/theme/views-slideshow-cycle\";s:4:\"file\";s:37:\"theme/views_slideshow_cycle.theme.inc\";s:7:\"pattern\";s:23:\"views_slideshow_cycle__\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:63:\"sites/all/modules/views_slideshow/contrib/views_slideshow_cycle\";s:8:\"includes\";a:1:{i:0;s:101:\"sites/all/modules/views_slideshow/contrib/views_slideshow_cycle/theme/views_slideshow_cycle.theme.inc\";}s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:32:\"views_slideshow_cycle_main_frame\";a:7:{s:9:\"variables\";a:4:{s:6:\"vss_id\";N;s:4:\"view\";N;s:8:\"settings\";N;s:4:\"rows\";N;}s:8:\"template\";s:102:\"sites/all/modules/views_slideshow/contrib/views_slideshow_cycle/theme/views-slideshow-cycle-main-frame\";s:7:\"pattern\";s:34:\"views_slideshow_cycle_main_frame__\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:63:\"sites/all/modules/views_slideshow/contrib/views_slideshow_cycle\";s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:52:\"template_preprocess_views_slideshow_cycle_main_frame\";i:2;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:36:\"views_slideshow_cycle_main_frame_row\";a:7:{s:9:\"variables\";a:4:{s:6:\"vss_id\";N;s:5:\"items\";N;s:5:\"count\";N;s:4:\"view\";N;}s:8:\"template\";s:106:\"sites/all/modules/views_slideshow/contrib/views_slideshow_cycle/theme/views-slideshow-cycle-main-frame-row\";s:7:\"pattern\";s:38:\"views_slideshow_cycle_main_frame_row__\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:63:\"sites/all/modules/views_slideshow/contrib/views_slideshow_cycle\";s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:56:\"template_preprocess_views_slideshow_cycle_main_frame_row\";i:2;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:41:\"views_slideshow_cycle_main_frame_row_item\";a:7:{s:9:\"variables\";a:5:{s:4:\"item\";N;s:10:\"item_count\";N;s:5:\"count\";N;s:4:\"view\";N;s:6:\"length\";N;}s:8:\"template\";s:111:\"sites/all/modules/views_slideshow/contrib/views_slideshow_cycle/theme/views-slideshow-cycle-main-frame-row-item\";i:0;s:43:\"views_slideshow_cycle_main_frame_row_item__\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:63:\"sites/all/modules/views_slideshow/contrib/views_slideshow_cycle\";s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:61:\"template_preprocess_views_slideshow_cycle_main_frame_row_item\";i:2;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:28:\"views_slideshow_main_section\";a:9:{s:9:\"variables\";a:3:{s:6:\"vss_id\";N;s:6:\"slides\";N;s:6:\"plugin\";N;}s:4:\"file\";s:31:\"theme/views_slideshow.theme.inc\";s:7:\"pattern\";s:30:\"views_slideshow_main_section__\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:33:\"sites/all/modules/views_slideshow\";s:8:\"function\";s:34:\"theme_views_slideshow_main_section\";s:8:\"includes\";a:1:{i:0;s:65:\"sites/all/modules/views_slideshow/theme/views_slideshow.theme.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:35:\"views_slideshow_pager_widget_render\";a:9:{s:9:\"variables\";a:5:{s:6:\"vss_id\";N;s:4:\"view\";N;s:8:\"settings\";a:0:{}s:8:\"location\";N;s:4:\"rows\";a:0:{}}s:4:\"file\";s:31:\"theme/views_slideshow.theme.inc\";s:7:\"pattern\";s:37:\"views_slideshow_pager_widget_render__\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:33:\"sites/all/modules/views_slideshow\";s:8:\"function\";s:41:\"theme_views_slideshow_pager_widget_render\";s:8:\"includes\";a:1:{i:0;s:65:\"sites/all/modules/views_slideshow/theme/views_slideshow.theme.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:28:\"views_slideshow_pager_fields\";a:7:{s:9:\"variables\";a:5:{s:6:\"vss_id\";N;s:4:\"view\";N;s:8:\"settings\";a:0:{}s:8:\"location\";N;s:10:\"attributes\";a:0:{}}s:8:\"template\";s:68:\"sites/all/modules/views_slideshow/theme/views-slideshow-pager-fields\";s:7:\"pattern\";s:30:\"views_slideshow_pager_fields__\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:33:\"sites/all/modules/views_slideshow\";s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:48:\"template_preprocess_views_slideshow_pager_fields\";i:2;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:33:\"views_slideshow_pager_field_field\";a:9:{s:9:\"variables\";a:3:{s:4:\"view\";N;s:5:\"field\";N;s:5:\"count\";N;}s:8:\"template\";s:73:\"sites/all/modules/views_slideshow/theme/views-slideshow-pager-field-field\";s:4:\"file\";s:31:\"theme/views_slideshow.theme.inc\";s:7:\"pattern\";s:35:\"views_slideshow_pager_field_field__\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:33:\"sites/all/modules/views_slideshow\";s:8:\"includes\";a:1:{i:0;s:65:\"sites/all/modules/views_slideshow/theme/views_slideshow.theme.inc\";}s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:32:\"views_slideshow_pager_field_item\";a:7:{s:9:\"variables\";a:5:{s:6:\"vss_id\";N;s:4:\"item\";N;s:5:\"count\";N;s:8:\"location\";N;s:6:\"length\";N;}s:8:\"template\";s:72:\"sites/all/modules/views_slideshow/theme/views-slideshow-pager-field-item\";s:7:\"pattern\";s:34:\"views_slideshow_pager_field_item__\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:33:\"sites/all/modules/views_slideshow\";s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:52:\"template_preprocess_views_slideshow_pager_field_item\";i:2;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:38:\"views_slideshow_controls_widget_render\";a:9:{s:9:\"variables\";a:5:{s:6:\"vss_id\";N;s:4:\"view\";N;s:8:\"settings\";a:0:{}s:8:\"location\";N;s:4:\"rows\";a:0:{}}s:4:\"file\";s:31:\"theme/views_slideshow.theme.inc\";s:7:\"pattern\";s:40:\"views_slideshow_controls_widget_render__\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:33:\"sites/all/modules/views_slideshow\";s:8:\"function\";s:44:\"theme_views_slideshow_controls_widget_render\";s:8:\"includes\";a:1:{i:0;s:65:\"sites/all/modules/views_slideshow/theme/views_slideshow.theme.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:29:\"views_slideshow_controls_text\";a:7:{s:9:\"variables\";a:5:{s:6:\"vss_id\";N;s:4:\"view\";N;s:8:\"settings\";a:0:{}s:8:\"location\";N;s:4:\"rows\";a:0:{}}s:8:\"template\";s:69:\"sites/all/modules/views_slideshow/theme/views-slideshow-controls-text\";s:7:\"pattern\";s:31:\"views_slideshow_controls_text__\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:33:\"sites/all/modules/views_slideshow\";s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:49:\"template_preprocess_views_slideshow_controls_text\";i:2;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:38:\"views_slideshow_controls_text_previous\";a:7:{s:9:\"variables\";a:3:{s:6:\"vss_id\";N;s:4:\"view\";N;s:8:\"settings\";a:0:{}}s:8:\"template\";s:78:\"sites/all/modules/views_slideshow/theme/views-slideshow-controls-text-previous\";s:7:\"pattern\";s:40:\"views_slideshow_controls_text_previous__\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:33:\"sites/all/modules/views_slideshow\";s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:58:\"template_preprocess_views_slideshow_controls_text_previous\";i:2;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:35:\"views_slideshow_controls_text_pause\";a:7:{s:9:\"variables\";a:3:{s:6:\"vss_id\";N;s:4:\"view\";N;s:8:\"settings\";a:0:{}}s:8:\"template\";s:75:\"sites/all/modules/views_slideshow/theme/views-slideshow-controls-text-pause\";s:7:\"pattern\";s:37:\"views_slideshow_controls_text_pause__\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:33:\"sites/all/modules/views_slideshow\";s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:55:\"template_preprocess_views_slideshow_controls_text_pause\";i:2;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:34:\"views_slideshow_controls_text_next\";a:7:{s:9:\"variables\";a:3:{s:6:\"vss_id\";N;s:4:\"view\";N;s:8:\"settings\";a:0:{}}s:8:\"template\";s:74:\"sites/all/modules/views_slideshow/theme/views-slideshow-controls-text-next\";s:7:\"pattern\";s:36:\"views_slideshow_controls_text_next__\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:33:\"sites/all/modules/views_slideshow\";s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:54:\"template_preprocess_views_slideshow_controls_text_next\";i:2;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:43:\"views_slideshow_slide_counter_widget_render\";a:9:{s:9:\"variables\";a:5:{s:6:\"vss_id\";N;s:4:\"view\";N;s:8:\"settings\";a:0:{}s:8:\"location\";N;s:4:\"rows\";a:0:{}}s:4:\"file\";s:31:\"theme/views_slideshow.theme.inc\";s:7:\"pattern\";s:39:\"views_slideshow_counter_widget_render__\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:33:\"sites/all/modules/views_slideshow\";s:8:\"function\";s:49:\"theme_views_slideshow_slide_counter_widget_render\";s:8:\"includes\";a:1:{i:0;s:65:\"sites/all/modules/views_slideshow/theme/views_slideshow.theme.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:29:\"views_slideshow_slide_counter\";a:7:{s:9:\"variables\";a:5:{s:6:\"vss_id\";N;s:4:\"view\";N;s:8:\"settings\";a:0:{}s:8:\"location\";N;s:4:\"rows\";a:0:{}}s:8:\"template\";s:69:\"sites/all/modules/views_slideshow/theme/views-slideshow-slide-counter\";s:7:\"pattern\";s:31:\"views_slideshow_slide_counter__\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:33:\"sites/all/modules/views_slideshow\";s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:49:\"template_preprocess_views_slideshow_slide_counter\";i:2;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:30:\"views_fieldsets_rearrange_form\";a:6:{s:14:\"render element\";s:4:\"form\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:33:\"sites/all/modules/views_fieldsets\";s:8:\"function\";s:36:\"theme_views_fieldsets_rearrange_form\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:24:\"views_fieldsets_fieldset\";a:7:{s:9:\"variables\";a:2:{s:8:\"fieldset\";s:0:\"\";s:7:\"content\";s:0:\"\";}s:8:\"template\";s:24:\"views-fieldsets-fieldset\";s:4:\"path\";s:43:\"sites/all/modules/views_fieldsets/templates\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:33:\"sites/all/modules/views_fieldsets\";s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:44:\"template_preprocess_views_fieldsets_fieldset\";i:2;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:34:\"video_embed_field_video_style_list\";a:6:{s:9:\"variables\";a:1:{s:6:\"styles\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:35:\"sites/all/modules/video_embed_field\";s:8:\"function\";s:40:\"theme_video_embed_field_video_style_list\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:28:\"video_embed_field_embed_code\";a:6:{s:8:\"template\";s:64:\"sites/all/modules/video_embed_field/video-embed-field-embed-code\";s:9:\"variables\";a:3:{s:3:\"url\";N;s:5:\"style\";s:6:\"normal\";s:10:\"video_data\";a:0:{}}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:35:\"sites/all/modules/video_embed_field\";s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:48:\"template_preprocess_video_embed_field_embed_code\";i:2;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:31:\"video_embed_field_colorbox_code\";a:6:{s:9:\"variables\";a:6:{s:9:\"image_url\";N;s:11:\"image_style\";s:6:\"normal\";s:9:\"image_alt\";N;s:9:\"video_url\";N;s:11:\"video_style\";N;s:10:\"video_data\";a:0:{}}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:35:\"sites/all/modules/video_embed_field\";s:8:\"function\";s:37:\"theme_video_embed_field_colorbox_code\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:21:\"variable_table_select\";a:8:{s:14:\"render element\";s:7:\"element\";s:4:\"file\";s:17:\"variable.form.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:26:\"sites/all/modules/variable\";s:8:\"function\";s:27:\"theme_variable_table_select\";s:8:\"includes\";a:1:{i:0;s:44:\"sites/all/modules/variable/variable.form.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:12:\"user_picture\";a:6:{s:9:\"variables\";a:1:{s:7:\"account\";N;}s:8:\"template\";s:25:\"modules/user/user-picture\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:12:\"modules/user\";s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:32:\"template_preprocess_user_picture\";i:2;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:12:\"user_profile\";a:8:{s:14:\"render element\";s:8:\"elements\";s:8:\"template\";s:25:\"modules/user/user-profile\";s:4:\"file\";s:14:\"user.pages.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:12:\"modules/user\";s:8:\"includes\";a:1:{i:0;s:27:\"modules/user/user.pages.inc\";}s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:32:\"template_preprocess_user_profile\";i:2;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:21:\"user_profile_category\";a:8:{s:14:\"render element\";s:7:\"element\";s:8:\"template\";s:34:\"modules/user/user-profile-category\";s:4:\"file\";s:14:\"user.pages.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:12:\"modules/user\";s:8:\"includes\";a:1:{i:0;s:27:\"modules/user/user.pages.inc\";}s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:41:\"template_preprocess_user_profile_category\";i:2;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:17:\"user_profile_item\";a:8:{s:14:\"render element\";s:7:\"element\";s:8:\"template\";s:30:\"modules/user/user-profile-item\";s:4:\"file\";s:14:\"user.pages.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:12:\"modules/user\";s:8:\"includes\";a:1:{i:0;s:27:\"modules/user/user.pages.inc\";}s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:37:\"template_preprocess_user_profile_item\";i:2;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:9:\"user_list\";a:6:{s:9:\"variables\";a:2:{s:5:\"users\";N;s:5:\"title\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:12:\"modules/user\";s:8:\"function\";s:15:\"theme_user_list\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:22:\"user_admin_permissions\";a:8:{s:14:\"render element\";s:4:\"form\";s:4:\"file\";s:14:\"user.admin.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:12:\"modules/user\";s:8:\"function\";s:28:\"theme_user_admin_permissions\";s:8:\"includes\";a:1:{i:0;s:27:\"modules/user/user.admin.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:16:\"user_admin_roles\";a:8:{s:14:\"render element\";s:4:\"form\";s:4:\"file\";s:14:\"user.admin.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:12:\"modules/user\";s:8:\"function\";s:22:\"theme_user_admin_roles\";s:8:\"includes\";a:1:{i:0;s:27:\"modules/user/user.admin.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:27:\"user_permission_description\";a:8:{s:9:\"variables\";a:2:{s:15:\"permission_item\";N;s:4:\"hide\";N;}s:4:\"file\";s:14:\"user.admin.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:12:\"modules/user\";s:8:\"function\";s:33:\"theme_user_permission_description\";s:8:\"includes\";a:1:{i:0;s:27:\"modules/user/user.admin.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:14:\"user_signature\";a:6:{s:9:\"variables\";a:1:{s:9:\"signature\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:12:\"modules/user\";s:8:\"function\";s:20:\"theme_user_signature\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:26:\"update_manager_update_form\";a:8:{s:14:\"render element\";s:4:\"form\";s:4:\"file\";s:18:\"update.manager.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/update\";s:8:\"function\";s:32:\"theme_update_manager_update_form\";s:8:\"includes\";a:1:{i:0;s:33:\"modules/update/update.manager.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:17:\"update_last_check\";a:6:{s:9:\"variables\";a:1:{s:4:\"last\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/update\";s:8:\"function\";s:23:\"theme_update_last_check\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:13:\"update_report\";a:8:{s:9:\"variables\";a:1:{s:4:\"data\";N;}s:4:\"file\";s:17:\"update.report.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/update\";s:8:\"function\";s:19:\"theme_update_report\";s:8:\"includes\";a:1:{i:0;s:32:\"modules/update/update.report.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:14:\"update_version\";a:8:{s:9:\"variables\";a:3:{s:7:\"version\";N;s:3:\"tag\";N;s:5:\"class\";a:0:{}}s:4:\"file\";s:17:\"update.report.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/update\";s:8:\"function\";s:20:\"theme_update_version\";s:8:\"includes\";a:1:{i:0;s:32:\"modules/update/update.report.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:19:\"update_status_label\";a:8:{s:9:\"variables\";a:1:{s:6:\"status\";N;}s:4:\"file\";s:17:\"update.report.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/update\";s:8:\"function\";s:25:\"theme_update_status_label\";s:8:\"includes\";a:1:{i:0;s:32:\"modules/update/update.report.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:10:\"tree_table\";a:8:{s:9:\"variables\";a:5:{s:6:\"header\";a:0:{}s:4:\"rows\";a:0:{}s:10:\"attributes\";a:0:{}s:5:\"empty\";s:0:\"\";s:7:\"caption\";s:0:\"\";}s:4:\"file\";s:15:\"token.pages.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:23:\"sites/all/modules/token\";s:8:\"function\";s:16:\"theme_tree_table\";s:8:\"includes\";a:1:{i:0;s:39:\"sites/all/modules/token/token.pages.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:10:\"token_tree\";a:8:{s:9:\"variables\";a:6:{s:11:\"token_types\";a:0:{}s:12:\"global_types\";b:1;s:12:\"click_insert\";b:1;s:15:\"show_restricted\";b:0;s:15:\"recursion_limit\";i:3;s:6:\"dialog\";b:0;}s:4:\"file\";s:15:\"token.pages.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:23:\"sites/all/modules/token\";s:8:\"function\";s:16:\"theme_token_tree\";s:8:\"includes\";a:1:{i:0;s:39:\"sites/all/modules/token/token.pages.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:15:\"token_tree_link\";a:8:{s:9:\"variables\";a:8:{s:4:\"text\";N;s:7:\"options\";a:0:{}s:6:\"dialog\";b:1;s:11:\"token_types\";a:0:{}s:12:\"global_types\";b:1;s:12:\"click_insert\";b:1;s:15:\"show_restricted\";b:0;s:15:\"recursion_limit\";i:3;}s:4:\"file\";s:15:\"token.pages.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:23:\"sites/all/modules/token\";s:8:\"function\";s:21:\"theme_token_tree_link\";s:8:\"includes\";a:1:{i:0;s:39:\"sites/all/modules/token/token.pages.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:30:\"taxonomy_overview_vocabularies\";a:6:{s:14:\"render element\";s:4:\"form\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:16:\"modules/taxonomy\";s:8:\"function\";s:36:\"theme_taxonomy_overview_vocabularies\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:23:\"taxonomy_overview_terms\";a:6:{s:14:\"render element\";s:4:\"form\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:16:\"modules/taxonomy\";s:8:\"function\";s:29:\"theme_taxonomy_overview_terms\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:13:\"taxonomy_term\";a:6:{s:14:\"render element\";s:8:\"elements\";s:8:\"template\";s:30:\"modules/taxonomy/taxonomy-term\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:16:\"modules/taxonomy\";s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:33:\"template_preprocess_taxonomy_term\";i:2;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:18:\"tagclouds_list_box\";a:6:{s:9:\"arguments\";a:2:{s:10:\"vocabulary\";N;s:4:\"tags\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:27:\"sites/all/modules/tagclouds\";s:8:\"function\";s:24:\"theme_tagclouds_list_box\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:18:\"tagclouds_weighted\";a:6:{s:9:\"arguments\";a:1:{s:5:\"terms\";a:0:{}}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:27:\"sites/all/modules/tagclouds\";s:8:\"function\";s:24:\"theme_tagclouds_weighted\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:4:\"html\";a:6:{s:14:\"render element\";s:4:\"page\";s:8:\"template\";s:19:\"modules/system/html\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:20:\"preprocess functions\";a:6:{i:0;s:19:\"template_preprocess\";i:1;s:24:\"template_preprocess_html\";i:2;s:21:\"contextual_preprocess\";i:3;s:23:\"overlay_preprocess_html\";i:4;s:20:\"i18n_preprocess_html\";i:5;s:21:\"views_preprocess_html\";}s:17:\"process functions\";a:3:{i:0;s:16:\"template_process\";i:1;s:21:\"template_process_html\";i:2;s:14:\"ctools_process\";}}s:4:\"page\";a:6:{s:14:\"render element\";s:4:\"page\";s:8:\"template\";s:19:\"modules/system/page\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:20:\"preprocess functions\";a:8:{i:0;s:19:\"template_preprocess\";i:1;s:24:\"template_preprocess_page\";i:2;s:21:\"contextual_preprocess\";i:3;s:19:\"faq_preprocess_page\";i:4;s:23:\"overlay_preprocess_page\";i:5;s:24:\"shortcut_preprocess_page\";i:6;s:21:\"views_preprocess_page\";i:7;s:30:\"advanced_forum_preprocess_page\";}s:17:\"process functions\";a:3:{i:0;s:16:\"template_process\";i:1;s:21:\"template_process_page\";i:2;s:14:\"ctools_process\";}}s:6:\"region\";a:6:{s:14:\"render element\";s:8:\"elements\";s:8:\"template\";s:21:\"modules/system/region\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:26:\"template_preprocess_region\";i:2;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:15:\"status_messages\";a:6:{s:9:\"variables\";a:1:{s:7:\"display\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:21:\"theme_status_messages\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:4:\"link\";a:6:{s:9:\"variables\";a:3:{s:4:\"text\";N;s:4:\"path\";N;s:7:\"options\";a:0:{}}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:10:\"theme_link\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:5:\"links\";a:6:{s:9:\"variables\";a:3:{s:5:\"links\";N;s:10:\"attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:5:\"links\";}}s:7:\"heading\";a:0:{}}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:11:\"theme_links\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:5:\"image\";a:6:{s:9:\"variables\";a:6:{s:4:\"path\";N;s:5:\"width\";N;s:6:\"height\";N;s:3:\"alt\";s:0:\"\";s:5:\"title\";N;s:10:\"attributes\";a:0:{}}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:11:\"theme_image\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:10:\"breadcrumb\";a:6:{s:9:\"variables\";a:1:{s:10:\"breadcrumb\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:16:\"theme_breadcrumb\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:4:\"help\";a:6:{s:9:\"variables\";a:0:{}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:10:\"theme_help\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:5:\"table\";a:6:{s:9:\"variables\";a:7:{s:6:\"header\";N;s:4:\"rows\";N;s:10:\"attributes\";a:0:{}s:7:\"caption\";N;s:9:\"colgroups\";a:0:{}s:6:\"sticky\";b:1;s:5:\"empty\";s:0:\"\";}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:11:\"theme_table\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:19:\"tablesort_indicator\";a:6:{s:9:\"variables\";a:1:{s:5:\"style\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:25:\"theme_tablesort_indicator\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:4:\"mark\";a:6:{s:9:\"variables\";a:1:{s:4:\"type\";i:1;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:10:\"theme_mark\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:9:\"item_list\";a:6:{s:9:\"variables\";a:4:{s:5:\"items\";a:0:{}s:5:\"title\";N;s:4:\"type\";s:2:\"ul\";s:10:\"attributes\";a:0:{}}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:15:\"theme_item_list\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:14:\"more_help_link\";a:6:{s:9:\"variables\";a:1:{s:3:\"url\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:20:\"theme_more_help_link\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:9:\"feed_icon\";a:6:{s:9:\"variables\";a:2:{s:3:\"url\";N;s:5:\"title\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:15:\"theme_feed_icon\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:9:\"more_link\";a:6:{s:9:\"variables\";a:2:{s:3:\"url\";N;s:5:\"title\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:15:\"theme_more_link\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:8:\"username\";a:6:{s:9:\"variables\";a:1:{s:7:\"account\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:14:\"theme_username\";s:20:\"preprocess functions\";a:1:{i:0;s:28:\"template_preprocess_username\";}s:17:\"process functions\";a:1:{i:0;s:25:\"template_process_username\";}}s:12:\"progress_bar\";a:6:{s:9:\"variables\";a:2:{s:7:\"percent\";N;s:7:\"message\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:18:\"theme_progress_bar\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:11:\"indentation\";a:6:{s:9:\"variables\";a:1:{s:4:\"size\";i:1;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:17:\"theme_indentation\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:8:\"html_tag\";a:6:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:14:\"theme_html_tag\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:16:\"maintenance_page\";a:6:{s:9:\"variables\";a:2:{s:7:\"content\";N;s:13:\"show_messages\";b:1;}s:8:\"template\";s:31:\"modules/system/maintenance-page\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:20:\"preprocess functions\";a:4:{i:0;s:19:\"template_preprocess\";i:1;s:36:\"template_preprocess_maintenance_page\";i:2;s:21:\"contextual_preprocess\";i:3;s:35:\"overlay_preprocess_maintenance_page\";}s:17:\"process functions\";a:3:{i:0;s:16:\"template_process\";i:1;s:33:\"template_process_maintenance_page\";i:2;s:14:\"ctools_process\";}}s:11:\"update_page\";a:6:{s:9:\"variables\";a:2:{s:7:\"content\";N;s:13:\"show_messages\";b:1;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:17:\"theme_update_page\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:12:\"install_page\";a:6:{s:9:\"variables\";a:1:{s:7:\"content\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:18:\"theme_install_page\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:9:\"task_list\";a:6:{s:9:\"variables\";a:2:{s:5:\"items\";N;s:6:\"active\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:15:\"theme_task_list\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:17:\"authorize_message\";a:6:{s:9:\"variables\";a:2:{s:7:\"message\";N;s:7:\"success\";b:1;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:23:\"theme_authorize_message\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:16:\"authorize_report\";a:6:{s:9:\"variables\";a:1:{s:8:\"messages\";a:0:{}}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:22:\"theme_authorize_report\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:5:\"pager\";a:6:{s:9:\"variables\";a:4:{s:4:\"tags\";a:0:{}s:7:\"element\";i:0;s:10:\"parameters\";a:0:{}s:8:\"quantity\";i:9;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:11:\"theme_pager\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:11:\"pager_first\";a:6:{s:9:\"variables\";a:3:{s:4:\"text\";N;s:7:\"element\";i:0;s:10:\"parameters\";a:0:{}}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:17:\"theme_pager_first\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:14:\"pager_previous\";a:6:{s:9:\"variables\";a:4:{s:4:\"text\";N;s:7:\"element\";i:0;s:8:\"interval\";i:1;s:10:\"parameters\";a:0:{}}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:20:\"theme_pager_previous\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:10:\"pager_next\";a:6:{s:9:\"variables\";a:4:{s:4:\"text\";N;s:7:\"element\";i:0;s:8:\"interval\";i:1;s:10:\"parameters\";a:0:{}}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:16:\"theme_pager_next\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:10:\"pager_last\";a:6:{s:9:\"variables\";a:3:{s:4:\"text\";N;s:7:\"element\";i:0;s:10:\"parameters\";a:0:{}}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:16:\"theme_pager_last\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:10:\"pager_link\";a:6:{s:9:\"variables\";a:5:{s:4:\"text\";N;s:8:\"page_new\";N;s:7:\"element\";N;s:10:\"parameters\";a:0:{}s:10:\"attributes\";a:0:{}}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:16:\"theme_pager_link\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:9:\"menu_link\";a:6:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:15:\"theme_menu_link\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:9:\"menu_tree\";a:6:{s:14:\"render element\";s:4:\"tree\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:15:\"theme_menu_tree\";s:20:\"preprocess functions\";a:1:{i:0;s:29:\"template_preprocess_menu_tree\";}s:17:\"process functions\";a:0:{}}s:15:\"menu_local_task\";a:6:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:21:\"theme_menu_local_task\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:17:\"menu_local_action\";a:6:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:23:\"theme_menu_local_action\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:16:\"menu_local_tasks\";a:6:{s:9:\"variables\";a:2:{s:7:\"primary\";a:0:{}s:9:\"secondary\";a:0:{}}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:22:\"theme_menu_local_tasks\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:6:\"select\";a:6:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:12:\"theme_select\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:8:\"fieldset\";a:6:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:14:\"theme_fieldset\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:5:\"radio\";a:6:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:11:\"theme_radio\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:6:\"radios\";a:6:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:12:\"theme_radios\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:4:\"date\";a:6:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:10:\"theme_date\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:15:\"exposed_filters\";a:6:{s:14:\"render element\";s:4:\"form\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:21:\"theme_exposed_filters\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:8:\"checkbox\";a:6:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:14:\"theme_checkbox\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:10:\"checkboxes\";a:6:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:16:\"theme_checkboxes\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:6:\"button\";a:6:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:12:\"theme_button\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:12:\"image_button\";a:6:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:18:\"theme_image_button\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:6:\"hidden\";a:6:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:12:\"theme_hidden\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:9:\"textfield\";a:6:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:15:\"theme_textfield\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:4:\"form\";a:6:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:10:\"theme_form\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:8:\"textarea\";a:6:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:14:\"theme_textarea\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:8:\"password\";a:6:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:14:\"theme_password\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:4:\"file\";a:6:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:10:\"theme_file\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:11:\"tableselect\";a:6:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:17:\"theme_tableselect\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:12:\"form_element\";a:6:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:18:\"theme_form_element\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:20:\"form_required_marker\";a:6:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:26:\"theme_form_required_marker\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:18:\"form_element_label\";a:6:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:24:\"theme_form_element_label\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:13:\"vertical_tabs\";a:6:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:19:\"theme_vertical_tabs\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:9:\"container\";a:6:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:15:\"theme_container\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:18:\"system_themes_page\";a:8:{s:9:\"variables\";a:1:{s:12:\"theme_groups\";N;}s:4:\"file\";s:16:\"system.admin.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:24:\"theme_system_themes_page\";s:8:\"includes\";a:1:{i:0;s:31:\"modules/system/system.admin.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:20:\"system_settings_form\";a:6:{s:14:\"render element\";s:4:\"form\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:26:\"theme_system_settings_form\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:12:\"confirm_form\";a:6:{s:14:\"render element\";s:4:\"form\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:18:\"theme_confirm_form\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:23:\"system_modules_fieldset\";a:8:{s:14:\"render element\";s:4:\"form\";s:4:\"file\";s:16:\"system.admin.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:29:\"theme_system_modules_fieldset\";s:8:\"includes\";a:1:{i:0;s:31:\"modules/system/system.admin.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:27:\"system_modules_incompatible\";a:8:{s:9:\"variables\";a:1:{s:7:\"message\";N;}s:4:\"file\";s:16:\"system.admin.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:33:\"theme_system_modules_incompatible\";s:8:\"includes\";a:1:{i:0;s:31:\"modules/system/system.admin.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:24:\"system_modules_uninstall\";a:8:{s:14:\"render element\";s:4:\"form\";s:4:\"file\";s:16:\"system.admin.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:30:\"theme_system_modules_uninstall\";s:8:\"includes\";a:1:{i:0;s:31:\"modules/system/system.admin.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:13:\"status_report\";a:8:{s:14:\"render element\";s:12:\"requirements\";s:4:\"file\";s:16:\"system.admin.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:19:\"theme_status_report\";s:8:\"includes\";a:1:{i:0;s:31:\"modules/system/system.admin.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:10:\"admin_page\";a:8:{s:9:\"variables\";a:1:{s:6:\"blocks\";N;}s:4:\"file\";s:16:\"system.admin.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:16:\"theme_admin_page\";s:8:\"includes\";a:1:{i:0;s:31:\"modules/system/system.admin.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:11:\"admin_block\";a:8:{s:9:\"variables\";a:1:{s:5:\"block\";N;}s:4:\"file\";s:16:\"system.admin.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:17:\"theme_admin_block\";s:8:\"includes\";a:1:{i:0;s:31:\"modules/system/system.admin.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:19:\"admin_block_content\";a:8:{s:9:\"variables\";a:1:{s:7:\"content\";N;}s:4:\"file\";s:16:\"system.admin.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:25:\"theme_admin_block_content\";s:8:\"includes\";a:1:{i:0;s:31:\"modules/system/system.admin.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:18:\"system_admin_index\";a:8:{s:9:\"variables\";a:1:{s:10:\"menu_items\";N;}s:4:\"file\";s:16:\"system.admin.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:24:\"theme_system_admin_index\";s:8:\"includes\";a:1:{i:0;s:31:\"modules/system/system.admin.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:17:\"system_powered_by\";a:6:{s:9:\"variables\";a:0:{}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:23:\"theme_system_powered_by\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:19:\"system_compact_link\";a:6:{s:9:\"variables\";a:0:{}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:25:\"theme_system_compact_link\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:25:\"system_date_time_settings\";a:8:{s:14:\"render element\";s:4:\"form\";s:4:\"file\";s:16:\"system.admin.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:31:\"theme_system_date_time_settings\";s:8:\"includes\";a:1:{i:0;s:31:\"modules/system/system.admin.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:22:\"shortcut_set_customize\";a:8:{s:14:\"render element\";s:4:\"form\";s:4:\"file\";s:18:\"shortcut.admin.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:16:\"modules/shortcut\";s:8:\"function\";s:28:\"theme_shortcut_set_customize\";s:8:\"includes\";a:1:{i:0;s:35:\"modules/shortcut/shortcut.admin.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:27:\"shortcode_video_embed_error\";a:6:{s:9:\"variables\";a:2:{s:9:\"video_url\";s:0:\"\";s:5:\"class\";s:21:\"video-embedding-error\";}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:43:\"sites/all/modules/shortcode/shortcode_video\";s:8:\"function\";s:33:\"theme_shortcode_video_embed_error\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:33:\"shortcode_video_embed_no_provider\";a:6:{s:9:\"variables\";a:2:{s:9:\"video_url\";s:0:\"\";s:5:\"class\";s:27:\"video-embedding-no-provider\";}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:43:\"sites/all/modules/shortcode/shortcode_video\";s:8:\"function\";s:39:\"theme_shortcode_video_embed_no_provider\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:29:\"shortcode_video_embed_youtube\";a:6:{s:9:\"variables\";a:2:{s:9:\"video_url\";s:0:\"\";s:10:\"attributes\";a:0:{}}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:43:\"sites/all/modules/shortcode/shortcode_video\";s:8:\"function\";s:35:\"theme_shortcode_video_embed_youtube\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:16:\"shortcode_button\";a:6:{s:9:\"variables\";a:3:{s:4:\"link\";s:1:\"#\";s:4:\"text\";s:0:\"\";s:5:\"class\";s:6:\"button\";}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:48:\"sites/all/modules/shortcode/shortcode_basic_tags\";s:8:\"function\";s:22:\"theme_shortcode_button\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:15:\"shortcode_quote\";a:6:{s:9:\"variables\";a:3:{s:4:\"text\";s:0:\"\";s:6:\"author\";b:0;s:5:\"class\";s:5:\"quote\";}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:48:\"sites/all/modules/shortcode/shortcode_basic_tags\";s:8:\"function\";s:21:\"theme_shortcode_quote\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:13:\"shortcode_img\";a:6:{s:9:\"variables\";a:3:{s:3:\"src\";s:0:\"\";s:3:\"alt\";s:0:\"\";s:5:\"class\";s:3:\"img\";}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:48:\"sites/all/modules/shortcode/shortcode_basic_tags\";s:8:\"function\";s:19:\"theme_shortcode_img\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:17:\"shortcode_dropcap\";a:6:{s:9:\"variables\";a:2:{s:4:\"text\";s:0:\"\";s:5:\"class\";s:7:\"dropcap\";}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:48:\"sites/all/modules/shortcode/shortcode_basic_tags\";s:8:\"function\";s:23:\"theme_shortcode_dropcap\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:14:\"shortcode_item\";a:6:{s:9:\"variables\";a:4:{s:4:\"text\";s:0:\"\";s:2:\"id\";s:0:\"\";s:5:\"class\";s:0:\"\";s:4:\"type\";s:3:\"div\";}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:48:\"sites/all/modules/shortcode/shortcode_basic_tags\";s:8:\"function\";s:20:\"theme_shortcode_item\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:15:\"shortcode_clear\";a:6:{s:9:\"variables\";a:4:{s:4:\"text\";s:0:\"\";s:2:\"id\";s:0:\"\";s:5:\"class\";s:0:\"\";s:4:\"type\";s:3:\"div\";}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:48:\"sites/all/modules/shortcode/shortcode_basic_tags\";s:8:\"function\";s:21:\"theme_shortcode_clear\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:9:\"sharethis\";a:6:{s:9:\"variables\";a:3:{s:12:\"data_options\";N;s:6:\"m_path\";N;s:7:\"m_title\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:27:\"sites/all/modules/sharethis\";s:8:\"function\";s:15:\"theme_sharethis\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:17:\"search_block_form\";a:6:{s:14:\"render element\";s:4:\"form\";s:8:\"template\";s:32:\"modules/search/search-block-form\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/search\";s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:37:\"template_preprocess_search_block_form\";i:2;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:13:\"search_result\";a:8:{s:9:\"variables\";a:2:{s:6:\"result\";N;s:6:\"module\";N;}s:4:\"file\";s:16:\"search.pages.inc\";s:8:\"template\";s:28:\"modules/search/search-result\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/search\";s:8:\"includes\";a:1:{i:0;s:31:\"modules/search/search.pages.inc\";}s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:33:\"template_preprocess_search_result\";i:2;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:14:\"search_results\";a:8:{s:9:\"variables\";a:2:{s:7:\"results\";N;s:6:\"module\";N;}s:4:\"file\";s:16:\"search.pages.inc\";s:8:\"template\";s:29:\"modules/search/search-results\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/search\";s:8:\"includes\";a:1:{i:0;s:31:\"modules/search/search.pages.inc\";}s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:34:\"template_preprocess_search_results\";i:2;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:25:\"quicktabs_admin_form_tabs\";a:8:{s:14:\"render element\";s:4:\"tabs\";s:4:\"file\";s:19:\"quicktabs.admin.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:27:\"sites/all/modules/quicktabs\";s:8:\"function\";s:31:\"theme_quicktabs_admin_form_tabs\";s:8:\"includes\";a:1:{i:0;s:47:\"sites/all/modules/quicktabs/quicktabs.admin.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:10:\"qt_ui_tabs\";a:6:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:27:\"sites/all/modules/quicktabs\";s:8:\"function\";s:16:\"theme_qt_ui_tabs\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:17:\"qt_ui_tabs_tabset\";a:6:{s:14:\"render element\";s:6:\"tabset\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:27:\"sites/all/modules/quicktabs\";s:8:\"function\";s:23:\"theme_qt_ui_tabs_tabset\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:12:\"qt_quicktabs\";a:6:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:27:\"sites/all/modules/quicktabs\";s:8:\"function\";s:18:\"theme_qt_quicktabs\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:19:\"qt_quicktabs_tabset\";a:6:{s:14:\"render element\";s:6:\"tabset\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:27:\"sites/all/modules/quicktabs\";s:8:\"function\";s:25:\"theme_qt_quicktabs_tabset\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:12:\"qt_accordion\";a:6:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:27:\"sites/all/modules/quicktabs\";s:8:\"function\";s:18:\"theme_qt_accordion\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:27:\"quicktabs_tab_access_denied\";a:6:{s:9:\"variables\";a:1:{i:0;s:3:\"tab\";}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:27:\"sites/all/modules/quicktabs\";s:8:\"function\";s:33:\"theme_quicktabs_tab_access_denied\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:7:\"overlay\";a:6:{s:14:\"render element\";s:4:\"page\";s:8:\"template\";s:23:\"modules/overlay/overlay\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:15:\"modules/overlay\";s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:27:\"template_preprocess_overlay\";i:2;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:3:{i:0;s:16:\"template_process\";i:1;s:24:\"template_process_overlay\";i:2;s:14:\"ctools_process\";}}s:23:\"overlay_disable_message\";a:6:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:15:\"modules/overlay\";s:8:\"function\";s:29:\"theme_overlay_disable_message\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:12:\"options_none\";a:6:{s:9:\"variables\";a:2:{s:8:\"instance\";N;s:6:\"option\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:29:\"modules/field/modules/options\";s:8:\"function\";s:18:\"theme_options_none\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:4:\"node\";a:6:{s:14:\"render element\";s:8:\"elements\";s:8:\"template\";s:17:\"modules/node/node\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:12:\"modules/node\";s:20:\"preprocess functions\";a:8:{i:0;s:19:\"template_preprocess\";i:1;s:24:\"template_preprocess_node\";i:2;s:21:\"contextual_preprocess\";i:3;s:22:\"ctools_preprocess_node\";i:4;s:26:\"node_class_preprocess_node\";i:5;s:39:\"shortcode_embed_content_preprocess_node\";i:6;s:21:\"views_preprocess_node\";i:7;s:30:\"advanced_forum_preprocess_node\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:17:\"node_search_admin\";a:6:{s:14:\"render element\";s:4:\"form\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:12:\"modules/node\";s:8:\"function\";s:23:\"theme_node_search_admin\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:13:\"node_add_list\";a:8:{s:9:\"variables\";a:1:{s:7:\"content\";N;}s:4:\"file\";s:14:\"node.pages.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:12:\"modules/node\";s:8:\"function\";s:19:\"theme_node_add_list\";s:8:\"includes\";a:1:{i:0;s:27:\"modules/node/node.pages.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:12:\"node_preview\";a:8:{s:9:\"variables\";a:1:{s:4:\"node\";N;}s:4:\"file\";s:14:\"node.pages.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:12:\"modules/node\";s:8:\"function\";s:18:\"theme_node_preview\";s:8:\"includes\";a:1:{i:0;s:27:\"modules/node/node.pages.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:19:\"node_admin_overview\";a:8:{s:9:\"variables\";a:2:{s:4:\"name\";N;s:4:\"type\";N;}s:4:\"file\";s:17:\"content_types.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:12:\"modules/node\";s:8:\"function\";s:25:\"theme_node_admin_overview\";s:8:\"includes\";a:1:{i:0;s:30:\"modules/node/content_types.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:17:\"node_recent_block\";a:6:{s:9:\"variables\";a:1:{s:5:\"nodes\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:12:\"modules/node\";s:8:\"function\";s:23:\"theme_node_recent_block\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:19:\"node_recent_content\";a:6:{s:9:\"variables\";a:1:{s:4:\"node\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:12:\"modules/node\";s:8:\"function\";s:25:\"theme_node_recent_content\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:13:\"module_filter\";a:8:{s:14:\"render element\";s:7:\"element\";s:4:\"file\";s:23:\"module_filter.theme.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/module_filter\";s:8:\"function\";s:19:\"theme_module_filter\";s:8:\"includes\";a:1:{i:0;s:55:\"sites/all/modules/module_filter/module_filter.theme.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:33:\"module_filter_system_modules_tabs\";a:8:{s:14:\"render element\";s:4:\"form\";s:4:\"file\";s:23:\"module_filter.theme.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/module_filter\";s:8:\"function\";s:39:\"theme_module_filter_system_modules_tabs\";s:8:\"includes\";a:1:{i:0;s:55:\"sites/all/modules/module_filter/module_filter.theme.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:24:\"module_filter_operations\";a:8:{s:9:\"variables\";a:2:{s:5:\"links\";a:0:{}s:10:\"dropbutton\";b:0;}s:4:\"file\";s:23:\"module_filter.theme.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/module_filter\";s:8:\"function\";s:30:\"theme_module_filter_operations\";s:8:\"includes\";a:1:{i:0;s:55:\"sites/all/modules/module_filter/module_filter.theme.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:7:\"message\";a:6:{s:14:\"render element\";s:8:\"elements\";s:8:\"template\";s:33:\"sites/all/modules/message/message\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:25:\"sites/all/modules/message\";s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:27:\"template_preprocess_message\";i:2;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:27:\"menu_breadcrumb_menus_table\";a:6:{s:14:\"render element\";s:4:\"form\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:33:\"sites/all/modules/menu_breadcrumb\";s:8:\"function\";s:33:\"theme_menu_breadcrumb_menus_table\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:18:\"menu_overview_form\";a:8:{s:4:\"file\";s:14:\"menu.admin.inc\";s:14:\"render element\";s:4:\"form\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:12:\"modules/menu\";s:8:\"function\";s:24:\"theme_menu_overview_form\";s:8:\"includes\";a:1:{i:0;s:27:\"modules/menu/menu.admin.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:19:\"menu_admin_overview\";a:8:{s:4:\"file\";s:14:\"menu.admin.inc\";s:9:\"variables\";a:3:{s:5:\"title\";N;s:4:\"name\";N;s:11:\"description\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:12:\"modules/menu\";s:8:\"function\";s:25:\"theme_menu_admin_overview\";s:8:\"includes\";a:1:{i:0;s:27:\"modules/menu/menu.admin.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:30:\"locale_languages_overview_form\";a:6:{s:14:\"render element\";s:4:\"form\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/locale\";s:8:\"function\";s:36:\"theme_locale_languages_overview_form\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:31:\"locale_languages_configure_form\";a:6:{s:14:\"render element\";s:4:\"form\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/locale\";s:8:\"function\";s:37:\"theme_locale_languages_configure_form\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:23:\"locale_date_format_form\";a:6:{s:14:\"render element\";s:4:\"form\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/locale\";s:8:\"function\";s:29:\"theme_locale_date_format_form\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:27:\"link_formatter_link_default\";a:6:{s:9:\"variables\";a:2:{s:7:\"element\";N;s:5:\"field\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:22:\"sites/all/modules/link\";s:8:\"function\";s:33:\"theme_link_formatter_link_default\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:25:\"link_formatter_link_plain\";a:6:{s:9:\"variables\";a:2:{s:7:\"element\";N;s:5:\"field\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:22:\"sites/all/modules/link\";s:8:\"function\";s:31:\"theme_link_formatter_link_plain\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:28:\"link_formatter_link_absolute\";a:6:{s:9:\"variables\";a:2:{s:7:\"element\";N;s:5:\"field\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:22:\"sites/all/modules/link\";s:8:\"function\";s:34:\"theme_link_formatter_link_absolute\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:26:\"link_formatter_link_domain\";a:6:{s:9:\"variables\";a:3:{s:7:\"element\";N;s:7:\"display\";N;s:5:\"field\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:22:\"sites/all/modules/link\";s:8:\"function\";s:32:\"theme_link_formatter_link_domain\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:31:\"link_formatter_link_title_plain\";a:6:{s:9:\"variables\";a:2:{s:7:\"element\";N;s:5:\"field\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:22:\"sites/all/modules/link\";s:8:\"function\";s:37:\"theme_link_formatter_link_title_plain\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:23:\"link_formatter_link_url\";a:6:{s:9:\"variables\";a:2:{s:7:\"element\";N;s:5:\"field\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:22:\"sites/all/modules/link\";s:8:\"function\";s:29:\"theme_link_formatter_link_url\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:25:\"link_formatter_link_short\";a:6:{s:9:\"variables\";a:2:{s:7:\"element\";N;s:5:\"field\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:22:\"sites/all/modules/link\";s:8:\"function\";s:31:\"theme_link_formatter_link_short\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:25:\"link_formatter_link_label\";a:6:{s:9:\"variables\";a:2:{s:7:\"element\";N;s:5:\"field\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:22:\"sites/all/modules/link\";s:8:\"function\";s:31:\"theme_link_formatter_link_label\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:28:\"link_formatter_link_separate\";a:6:{s:9:\"variables\";a:2:{s:7:\"element\";N;s:5:\"field\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:22:\"sites/all/modules/link\";s:8:\"function\";s:34:\"theme_link_formatter_link_separate\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:10:\"link_field\";a:6:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:22:\"sites/all/modules/link\";s:8:\"function\";s:16:\"theme_link_field\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:37:\"lang_dropdown_hideout_hiddenlanguages\";a:6:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:53:\"sites/all/modules/lang_dropdown/lang_dropdown_hideout\";s:8:\"function\";s:43:\"theme_lang_dropdown_hideout_hiddenlanguages\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:18:\"languageicons_icon\";a:6:{s:9:\"variables\";a:2:{s:8:\"language\";N;s:5:\"title\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/languageicons\";s:8:\"function\";s:24:\"theme_languageicons_icon\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:19:\"languageicons_place\";a:6:{s:9:\"variables\";a:3:{s:4:\"text\";N;s:4:\"icon\";N;s:9:\"separator\";s:1:\" \";}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/languageicons\";s:8:\"function\";s:25:\"theme_languageicons_place\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:11:\"image_style\";a:6:{s:9:\"variables\";a:7:{s:10:\"style_name\";N;s:4:\"path\";N;s:5:\"width\";N;s:6:\"height\";N;s:3:\"alt\";s:0:\"\";s:5:\"title\";N;s:10:\"attributes\";a:0:{}}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:13:\"modules/image\";s:8:\"function\";s:17:\"theme_image_style\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:16:\"image_style_list\";a:6:{s:9:\"variables\";a:1:{s:6:\"styles\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:13:\"modules/image\";s:8:\"function\";s:22:\"theme_image_style_list\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:19:\"image_style_effects\";a:6:{s:14:\"render element\";s:4:\"form\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:13:\"modules/image\";s:8:\"function\";s:25:\"theme_image_style_effects\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:19:\"image_style_preview\";a:6:{s:9:\"variables\";a:1:{s:5:\"style\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:13:\"modules/image\";s:8:\"function\";s:25:\"theme_image_style_preview\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:12:\"image_anchor\";a:6:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:13:\"modules/image\";s:8:\"function\";s:18:\"theme_image_anchor\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:20:\"image_resize_summary\";a:6:{s:9:\"variables\";a:1:{s:4:\"data\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:13:\"modules/image\";s:8:\"function\";s:26:\"theme_image_resize_summary\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:19:\"image_scale_summary\";a:6:{s:9:\"variables\";a:1:{s:4:\"data\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:13:\"modules/image\";s:8:\"function\";s:25:\"theme_image_scale_summary\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:18:\"image_crop_summary\";a:6:{s:9:\"variables\";a:1:{s:4:\"data\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:13:\"modules/image\";s:8:\"function\";s:24:\"theme_image_crop_summary\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:20:\"image_rotate_summary\";a:6:{s:9:\"variables\";a:1:{s:4:\"data\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:13:\"modules/image\";s:8:\"function\";s:26:\"theme_image_rotate_summary\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:12:\"image_widget\";a:6:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:13:\"modules/image\";s:8:\"function\";s:18:\"theme_image_widget\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:15:\"image_formatter\";a:6:{s:9:\"variables\";a:3:{s:4:\"item\";N;s:4:\"path\";N;s:11:\"image_style\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:13:\"modules/image\";s:8:\"function\";s:21:\"theme_image_formatter\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:10:\"flexslider\";a:8:{s:9:\"variables\";a:2:{s:5:\"items\";a:0:{}s:8:\"settings\";a:0:{}}s:8:\"template\";s:45:\"sites/all/modules/flexslider/theme/flexslider\";s:4:\"file\";s:26:\"theme/flexslider.theme.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:28:\"sites/all/modules/flexslider\";s:8:\"includes\";a:1:{i:0;s:55:\"sites/all/modules/flexslider/theme/flexslider.theme.inc\";}s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:3:{i:0;s:16:\"template_process\";i:1;s:27:\"template_process_flexslider\";i:2;s:14:\"ctools_process\";}}s:15:\"flexslider_list\";a:8:{s:9:\"variables\";a:2:{s:5:\"items\";a:0:{}s:8:\"settings\";a:0:{}}s:4:\"file\";s:26:\"theme/flexslider.theme.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:28:\"sites/all/modules/flexslider\";s:8:\"function\";s:21:\"theme_flexslider_list\";s:8:\"includes\";a:1:{i:0;s:55:\"sites/all/modules/flexslider/theme/flexslider.theme.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:1:{i:0;s:32:\"template_process_flexslider_list\";}}s:20:\"flexslider_list_item\";a:8:{s:9:\"variables\";a:3:{s:4:\"item\";a:0:{}s:8:\"settings\";a:0:{}s:7:\"caption\";s:0:\"\";}s:4:\"file\";s:26:\"theme/flexslider.theme.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:28:\"sites/all/modules/flexslider\";s:8:\"function\";s:26:\"theme_flexslider_list_item\";s:8:\"includes\";a:1:{i:0;s:55:\"sites/all/modules/flexslider/theme/flexslider.theme.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:1:{i:0;s:37:\"template_process_flexslider_list_item\";}}s:8:\"fivestar\";a:8:{s:14:\"render element\";s:7:\"element\";s:4:\"file\";s:27:\"includes/fivestar.theme.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:26:\"sites/all/modules/fivestar\";s:8:\"function\";s:14:\"theme_fivestar\";s:8:\"includes\";a:1:{i:0;s:54:\"sites/all/modules/fivestar/includes/fivestar.theme.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:15:\"fivestar_select\";a:8:{s:14:\"render element\";s:7:\"element\";s:4:\"file\";s:27:\"includes/fivestar.theme.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:26:\"sites/all/modules/fivestar\";s:8:\"function\";s:21:\"theme_fivestar_select\";s:8:\"includes\";a:1:{i:0;s:54:\"sites/all/modules/fivestar/includes/fivestar.theme.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:15:\"fivestar_static\";a:8:{s:9:\"variables\";a:4:{s:6:\"rating\";N;s:5:\"stars\";i:5;s:3:\"tag\";s:4:\"vote\";s:6:\"widget\";a:2:{s:4:\"name\";s:7:\"default\";s:3:\"css\";s:0:\"\";}}s:4:\"file\";s:27:\"includes/fivestar.theme.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:26:\"sites/all/modules/fivestar\";s:8:\"function\";s:21:\"theme_fivestar_static\";s:8:\"includes\";a:1:{i:0;s:54:\"sites/all/modules/fivestar/includes/fivestar.theme.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:23:\"fivestar_static_element\";a:8:{s:9:\"variables\";a:3:{s:12:\"star_display\";N;s:5:\"title\";N;s:11:\"description\";N;}s:4:\"file\";s:27:\"includes/fivestar.theme.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:26:\"sites/all/modules/fivestar\";s:8:\"function\";s:29:\"theme_fivestar_static_element\";s:8:\"includes\";a:1:{i:0;s:54:\"sites/all/modules/fivestar/includes/fivestar.theme.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:16:\"fivestar_summary\";a:8:{s:9:\"variables\";a:5:{s:11:\"user_rating\";N;s:14:\"average_rating\";N;s:5:\"votes\";i:0;s:5:\"stars\";i:5;s:9:\"microdata\";a:0:{}}s:4:\"file\";s:27:\"includes/fivestar.theme.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:26:\"sites/all/modules/fivestar\";s:8:\"function\";s:22:\"theme_fivestar_summary\";s:8:\"includes\";a:1:{i:0;s:54:\"sites/all/modules/fivestar/includes/fivestar.theme.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:16:\"fivestar_preview\";a:8:{s:9:\"variables\";a:5:{s:5:\"style\";N;s:4:\"text\";N;s:5:\"stars\";N;s:6:\"unvote\";N;s:5:\"title\";N;}s:4:\"file\";s:27:\"includes/fivestar.theme.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:26:\"sites/all/modules/fivestar\";s:8:\"function\";s:22:\"theme_fivestar_preview\";s:8:\"includes\";a:1:{i:0;s:54:\"sites/all/modules/fivestar/includes/fivestar.theme.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:23:\"fivestar_preview_widget\";a:8:{s:9:\"variables\";a:2:{s:3:\"css\";N;s:4:\"name\";N;}s:4:\"file\";s:27:\"includes/fivestar.theme.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:26:\"sites/all/modules/fivestar\";s:8:\"function\";s:29:\"theme_fivestar_preview_widget\";s:8:\"includes\";a:1:{i:0;s:54:\"sites/all/modules/fivestar/includes/fivestar.theme.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:24:\"fivestar_preview_wrapper\";a:8:{s:9:\"variables\";a:2:{s:7:\"content\";N;s:4:\"type\";s:6:\"direct\";}s:4:\"file\";s:27:\"includes/fivestar.theme.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:26:\"sites/all/modules/fivestar\";s:8:\"function\";s:30:\"theme_fivestar_preview_wrapper\";s:8:\"includes\";a:1:{i:0;s:54:\"sites/all/modules/fivestar/includes/fivestar.theme.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:17:\"fivestar_settings\";a:8:{s:14:\"render element\";s:4:\"form\";s:4:\"file\";s:27:\"includes/fivestar.theme.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:26:\"sites/all/modules/fivestar\";s:8:\"function\";s:23:\"theme_fivestar_settings\";s:8:\"includes\";a:1:{i:0;s:54:\"sites/all/modules/fivestar/includes/fivestar.theme.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:19:\"fivestar_color_form\";a:8:{s:14:\"render element\";s:4:\"form\";s:4:\"file\";s:27:\"includes/fivestar.theme.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:26:\"sites/all/modules/fivestar\";s:8:\"function\";s:25:\"theme_fivestar_color_form\";s:8:\"includes\";a:1:{i:0;s:54:\"sites/all/modules/fivestar/includes/fivestar.theme.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:26:\"fivestar_formatter_default\";a:8:{s:14:\"render element\";s:7:\"element\";s:4:\"file\";s:27:\"includes/fivestar.theme.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:26:\"sites/all/modules/fivestar\";s:8:\"function\";s:32:\"theme_fivestar_formatter_default\";s:8:\"includes\";a:1:{i:0;s:54:\"sites/all/modules/fivestar/includes/fivestar.theme.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:25:\"fivestar_formatter_rating\";a:8:{s:14:\"render element\";s:7:\"element\";s:4:\"file\";s:27:\"includes/fivestar.theme.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:26:\"sites/all/modules/fivestar\";s:8:\"function\";s:31:\"theme_fivestar_formatter_rating\";s:8:\"includes\";a:1:{i:0;s:54:\"sites/all/modules/fivestar/includes/fivestar.theme.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:29:\"fivestar_formatter_percentage\";a:8:{s:14:\"render element\";s:7:\"element\";s:4:\"file\";s:27:\"includes/fivestar.theme.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:26:\"sites/all/modules/fivestar\";s:8:\"function\";s:35:\"theme_fivestar_formatter_percentage\";s:8:\"includes\";a:1:{i:0;s:54:\"sites/all/modules/fivestar/includes/fivestar.theme.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:21:\"filter_admin_overview\";a:8:{s:14:\"render element\";s:4:\"form\";s:4:\"file\";s:16:\"filter.admin.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/filter\";s:8:\"function\";s:27:\"theme_filter_admin_overview\";s:8:\"includes\";a:1:{i:0;s:31:\"modules/filter/filter.admin.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:32:\"filter_admin_format_filter_order\";a:8:{s:14:\"render element\";s:7:\"element\";s:4:\"file\";s:16:\"filter.admin.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/filter\";s:8:\"function\";s:38:\"theme_filter_admin_format_filter_order\";s:8:\"includes\";a:1:{i:0;s:31:\"modules/filter/filter.admin.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:11:\"filter_tips\";a:8:{s:9:\"variables\";a:2:{s:4:\"tips\";N;s:4:\"long\";b:0;}s:4:\"file\";s:16:\"filter.pages.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/filter\";s:8:\"function\";s:17:\"theme_filter_tips\";s:8:\"includes\";a:1:{i:0;s:31:\"modules/filter/filter.pages.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:19:\"text_format_wrapper\";a:6:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/filter\";s:8:\"function\";s:25:\"theme_text_format_wrapper\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:21:\"filter_tips_more_info\";a:6:{s:9:\"variables\";a:0:{}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/filter\";s:8:\"function\";s:27:\"theme_filter_tips_more_info\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:17:\"filter_guidelines\";a:6:{s:9:\"variables\";a:1:{s:6:\"format\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/filter\";s:8:\"function\";s:23:\"theme_filter_guidelines\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:9:\"file_link\";a:6:{s:9:\"variables\";a:2:{s:4:\"file\";N;s:14:\"icon_directory\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:12:\"modules/file\";s:8:\"function\";s:15:\"theme_file_link\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:9:\"file_icon\";a:6:{s:9:\"variables\";a:3:{s:4:\"file\";N;s:14:\"icon_directory\";N;s:3:\"alt\";s:0:\"\";}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:12:\"modules/file\";s:8:\"function\";s:15:\"theme_file_icon\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:17:\"file_managed_file\";a:6:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:12:\"modules/file\";s:8:\"function\";s:23:\"theme_file_managed_file\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:11:\"file_widget\";a:6:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:12:\"modules/file\";s:8:\"function\";s:17:\"theme_file_widget\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:20:\"file_widget_multiple\";a:6:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:12:\"modules/file\";s:8:\"function\";s:26:\"theme_file_widget_multiple\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:20:\"file_formatter_table\";a:6:{s:9:\"variables\";a:1:{s:5:\"items\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:12:\"modules/file\";s:8:\"function\";s:26:\"theme_file_formatter_table\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:16:\"file_upload_help\";a:6:{s:9:\"variables\";a:2:{s:11:\"description\";N;s:17:\"upload_validators\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:12:\"modules/file\";s:8:\"function\";s:22:\"theme_file_upload_help\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:14:\"field_ui_table\";a:6:{s:14:\"render element\";s:8:\"elements\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:16:\"modules/field_ui\";s:8:\"function\";s:20:\"theme_field_ui_table\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:21:\"field_collection_item\";a:6:{s:14:\"render element\";s:8:\"elements\";s:8:\"template\";s:56:\"sites/all/modules/field_collection/field-collection-item\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:34:\"sites/all/modules/field_collection\";s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:21:\"field_collection_view\";a:6:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:34:\"sites/all/modules/field_collection\";s:8:\"function\";s:27:\"theme_field_collection_view\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:5:\"field\";a:6:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:13:\"modules/field\";s:8:\"function\";s:11:\"theme_field\";s:20:\"preprocess functions\";a:1:{i:0;s:25:\"template_preprocess_field\";}s:17:\"process functions\";a:1:{i:0;s:22:\"template_process_field\";}}s:25:\"field_multiple_value_form\";a:6:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:13:\"modules/field\";s:8:\"function\";s:31:\"theme_field_multiple_value_form\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:23:\"field_detailed_question\";a:6:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:21:\"sites/all/modules/faq\";s:8:\"function\";s:29:\"theme_field_detailed_question\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:34:\"faq_draggable_question_order_table\";a:6:{s:14:\"render element\";s:4:\"form\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:21:\"sites/all/modules/faq\";s:8:\"function\";s:40:\"theme_faq_draggable_question_order_table\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:17:\"faq_questions_top\";a:9:{s:4:\"path\";s:30:\"sites/all/modules/faq/includes\";s:4:\"file\";s:21:\"faq.questions_top.inc\";s:8:\"template\";s:17:\"faq-questions-top\";s:9:\"variables\";a:1:{s:4:\"data\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:21:\"sites/all/modules/faq\";s:8:\"includes\";a:1:{i:0;s:52:\"sites/all/modules/faq/includes/faq.questions_top.inc\";}s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:37:\"template_preprocess_faq_questions_top\";i:2;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:26:\"faq_category_questions_top\";a:9:{s:4:\"path\";s:30:\"sites/all/modules/faq/includes\";s:4:\"file\";s:21:\"faq.questions_top.inc\";s:8:\"template\";s:26:\"faq-category-questions-top\";s:9:\"variables\";a:6:{s:4:\"data\";N;s:14:\"display_header\";i:0;s:16:\"category_display\";N;s:4:\"term\";N;s:5:\"class\";N;s:11:\"parent_term\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:21:\"sites/all/modules/faq\";s:8:\"includes\";a:1:{i:0;s:52:\"sites/all/modules/faq/includes/faq.questions_top.inc\";}s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:46:\"template_preprocess_faq_category_questions_top\";i:2;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:34:\"faq_category_questions_top_answers\";a:9:{s:4:\"path\";s:30:\"sites/all/modules/faq/includes\";s:4:\"file\";s:21:\"faq.questions_top.inc\";s:8:\"template\";s:34:\"faq-category-questions-top-answers\";s:9:\"variables\";a:6:{s:4:\"data\";N;s:14:\"display_header\";i:0;s:16:\"category_display\";N;s:4:\"term\";N;s:5:\"class\";N;s:11:\"parent_term\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:21:\"sites/all/modules/faq\";s:8:\"includes\";a:1:{i:0;s:52:\"sites/all/modules/faq/includes/faq.questions_top.inc\";}s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:54:\"template_preprocess_faq_category_questions_top_answers\";i:2;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:15:\"faq_hide_answer\";a:9:{s:4:\"path\";s:30:\"sites/all/modules/faq/includes\";s:4:\"file\";s:19:\"faq.hide_answer.inc\";s:8:\"template\";s:15:\"faq-hide-answer\";s:9:\"variables\";a:1:{s:4:\"data\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:21:\"sites/all/modules/faq\";s:8:\"includes\";a:1:{i:0;s:50:\"sites/all/modules/faq/includes/faq.hide_answer.inc\";}s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:35:\"template_preprocess_faq_hide_answer\";i:2;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:24:\"faq_category_hide_answer\";a:9:{s:4:\"path\";s:30:\"sites/all/modules/faq/includes\";s:4:\"file\";s:19:\"faq.hide_answer.inc\";s:8:\"template\";s:24:\"faq-category-hide-answer\";s:9:\"variables\";a:6:{s:4:\"data\";N;s:14:\"display_header\";i:0;s:16:\"category_display\";N;s:4:\"term\";N;s:5:\"class\";N;s:11:\"parent_term\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:21:\"sites/all/modules/faq\";s:8:\"includes\";a:1:{i:0;s:50:\"sites/all/modules/faq/includes/faq.hide_answer.inc\";}s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:44:\"template_preprocess_faq_category_hide_answer\";i:2;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:20:\"faq_questions_inline\";a:9:{s:4:\"path\";s:30:\"sites/all/modules/faq/includes\";s:4:\"file\";s:24:\"faq.questions_inline.inc\";s:8:\"template\";s:20:\"faq-questions-inline\";s:9:\"variables\";a:1:{s:4:\"data\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:21:\"sites/all/modules/faq\";s:8:\"includes\";a:1:{i:0;s:55:\"sites/all/modules/faq/includes/faq.questions_inline.inc\";}s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:40:\"template_preprocess_faq_questions_inline\";i:2;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:29:\"faq_category_questions_inline\";a:9:{s:4:\"path\";s:30:\"sites/all/modules/faq/includes\";s:4:\"file\";s:24:\"faq.questions_inline.inc\";s:8:\"template\";s:29:\"faq-category-questions-inline\";s:9:\"variables\";a:6:{s:4:\"data\";N;s:14:\"display_header\";i:0;s:16:\"category_display\";N;s:4:\"term\";N;s:5:\"class\";N;s:11:\"parent_term\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:21:\"sites/all/modules/faq\";s:8:\"includes\";a:1:{i:0;s:55:\"sites/all/modules/faq/includes/faq.questions_inline.inc\";}s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:49:\"template_preprocess_faq_category_questions_inline\";i:2;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:12:\"faq_new_page\";a:9:{s:4:\"path\";s:30:\"sites/all/modules/faq/includes\";s:4:\"file\";s:16:\"faq.new_page.inc\";s:8:\"template\";s:12:\"faq-new-page\";s:9:\"variables\";a:1:{s:4:\"data\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:21:\"sites/all/modules/faq\";s:8:\"includes\";a:1:{i:0;s:47:\"sites/all/modules/faq/includes/faq.new_page.inc\";}s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:32:\"template_preprocess_faq_new_page\";i:2;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:21:\"faq_category_new_page\";a:9:{s:4:\"path\";s:30:\"sites/all/modules/faq/includes\";s:4:\"file\";s:16:\"faq.new_page.inc\";s:8:\"template\";s:21:\"faq-category-new-page\";s:9:\"variables\";a:6:{s:4:\"data\";N;s:14:\"display_header\";i:0;s:16:\"category_display\";N;s:4:\"term\";N;s:5:\"class\";N;s:11:\"parent_term\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:21:\"sites/all/modules/faq\";s:8:\"includes\";a:1:{i:0;s:47:\"sites/all/modules/faq/includes/faq.new_page.inc\";}s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:41:\"template_preprocess_faq_category_new_page\";i:2;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:8:\"faq_page\";a:6:{s:9:\"variables\";a:3:{s:7:\"content\";s:0:\"\";s:7:\"answers\";s:0:\"\";s:11:\"description\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:21:\"sites/all/modules/faq\";s:8:\"function\";s:14:\"theme_faq_page\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:13:\"entity_status\";a:8:{s:9:\"variables\";a:2:{s:6:\"status\";N;s:4:\"html\";b:1;}s:4:\"file\";s:22:\"theme/entity.theme.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:24:\"sites/all/modules/entity\";s:8:\"function\";s:19:\"theme_entity_status\";s:8:\"includes\";a:1:{i:0;s:47:\"sites/all/modules/entity/theme/entity.theme.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:6:\"entity\";a:10:{s:14:\"render element\";s:8:\"elements\";s:8:\"template\";s:6:\"entity\";s:7:\"pattern\";s:73:\"(field_collection_item|message_type_category|message_type|message)(\\.|__)\";s:4:\"path\";s:30:\"sites/all/modules/entity/theme\";s:4:\"file\";s:16:\"entity.theme.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:24:\"sites/all/modules/entity\";s:8:\"includes\";a:1:{i:0;s:47:\"sites/all/modules/entity/theme/entity.theme.inc\";}s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:26:\"template_preprocess_entity\";i:2;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:15:\"entity_property\";a:8:{s:14:\"render element\";s:8:\"elements\";s:4:\"file\";s:22:\"theme/entity.theme.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:24:\"sites/all/modules/entity\";s:8:\"function\";s:21:\"theme_entity_property\";s:8:\"includes\";a:1:{i:0;s:47:\"sites/all/modules/entity/theme/entity.theme.inc\";}s:20:\"preprocess functions\";a:1:{i:0;s:35:\"template_preprocess_entity_property\";}s:17:\"process functions\";a:1:{i:0;s:32:\"template_process_entity_property\";}}s:23:\"entity_ui_overview_item\";a:8:{s:9:\"variables\";a:4:{s:5:\"label\";N;s:11:\"entity_type\";N;s:3:\"url\";b:0;s:4:\"name\";b:0;}s:4:\"file\";s:22:\"includes/entity.ui.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:24:\"sites/all/modules/entity\";s:8:\"function\";s:29:\"theme_entity_ui_overview_item\";s:8:\"includes\";a:1:{i:0;s:47:\"sites/all/modules/entity/includes/entity.ui.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:13:\"dblog_message\";a:8:{s:9:\"variables\";a:2:{s:5:\"event\";N;s:4:\"link\";b:0;}s:4:\"file\";s:15:\"dblog.admin.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:13:\"modules/dblog\";s:8:\"function\";s:19:\"theme_dblog_message\";s:8:\"includes\";a:1:{i:0;s:29:\"modules/dblog/dblog.admin.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:14:\"date_nav_title\";a:9:{s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:39:\"sites/all/modules/date/date_views/theme\";s:9:\"variables\";a:4:{s:11:\"granularity\";N;s:4:\"view\";N;s:4:\"link\";N;s:6:\"format\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:33:\"sites/all/modules/date/date_views\";s:8:\"function\";s:20:\"theme_date_nav_title\";s:8:\"includes\";a:2:{i:0;s:47:\"sites/all/modules/date/date_api/theme/theme.inc\";i:1;s:49:\"sites/all/modules/date/date_views/theme/theme.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:22:\"date_views_filter_form\";a:9:{s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:39:\"sites/all/modules/date/date_views/theme\";s:8:\"template\";s:22:\"date-views-filter-form\";s:14:\"render element\";s:4:\"form\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:33:\"sites/all/modules/date/date_views\";s:8:\"includes\";a:2:{i:0;s:47:\"sites/all/modules/date/date_api/theme/theme.inc\";i:1;s:49:\"sites/all/modules/date/date_views/theme/theme.inc\";}s:20:\"preprocess functions\";a:5:{i:0;s:19:\"template_preprocess\";i:1;s:21:\"contextual_preprocess\";i:2;s:19:\"template_preprocess\";i:3;s:42:\"template_preprocess_date_views_filter_form\";i:4;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:4:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";i:2;s:16:\"template_process\";i:3;s:14:\"ctools_process\";}}s:17:\"date_calendar_day\";a:9:{s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:39:\"sites/all/modules/date/date_views/theme\";s:9:\"variables\";a:1:{s:4:\"date\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:33:\"sites/all/modules/date/date_views\";s:8:\"function\";s:23:\"theme_date_calendar_day\";s:8:\"includes\";a:2:{i:0;s:47:\"sites/all/modules/date/date_api/theme/theme.inc\";i:1;s:49:\"sites/all/modules/date/date_views/theme/theme.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:16:\"date_views_pager\";a:10:{s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:39:\"sites/all/modules/date/date_views/theme\";s:9:\"variables\";a:2:{s:6:\"plugin\";N;s:5:\"input\";N;}s:7:\"pattern\";s:18:\"date_views_pager__\";s:8:\"template\";s:16:\"date-views-pager\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:33:\"sites/all/modules/date/date_views\";s:8:\"includes\";a:1:{i:0;s:49:\"sites/all/modules/date/date_views/theme/theme.inc\";}s:20:\"preprocess functions\";a:4:{i:0;s:19:\"template_preprocess\";i:1;s:36:\"template_preprocess_date_views_pager\";i:2;s:36:\"calendar_preprocess_date_views_pager\";i:3;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:13:\"date_timezone\";a:9:{s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:37:\"sites/all/modules/date/date_api/theme\";s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/date/date_api\";s:8:\"function\";s:19:\"theme_date_timezone\";s:8:\"includes\";a:1:{i:0;s:47:\"sites/all/modules/date/date_api/theme/theme.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:11:\"date_select\";a:9:{s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:37:\"sites/all/modules/date/date_api/theme\";s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/date/date_api\";s:8:\"function\";s:17:\"theme_date_select\";s:8:\"includes\";a:1:{i:0;s:47:\"sites/all/modules/date/date_api/theme/theme.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:9:\"date_text\";a:9:{s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:37:\"sites/all/modules/date/date_api/theme\";s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/date/date_api\";s:8:\"function\";s:15:\"theme_date_text\";s:8:\"includes\";a:1:{i:0;s:47:\"sites/all/modules/date/date_api/theme/theme.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:19:\"date_select_element\";a:9:{s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:37:\"sites/all/modules/date/date_api/theme\";s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/date/date_api\";s:8:\"function\";s:25:\"theme_date_select_element\";s:8:\"includes\";a:1:{i:0;s:47:\"sites/all/modules/date/date_api/theme/theme.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:22:\"date_textfield_element\";a:9:{s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:37:\"sites/all/modules/date/date_api/theme\";s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/date/date_api\";s:8:\"function\";s:28:\"theme_date_textfield_element\";s:8:\"includes\";a:1:{i:0;s:47:\"sites/all/modules/date/date_api/theme/theme.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:21:\"date_part_hour_prefix\";a:9:{s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:37:\"sites/all/modules/date/date_api/theme\";s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/date/date_api\";s:8:\"function\";s:27:\"theme_date_part_hour_prefix\";s:8:\"includes\";a:1:{i:0;s:47:\"sites/all/modules/date/date_api/theme/theme.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:23:\"date_part_minsec_prefix\";a:9:{s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:37:\"sites/all/modules/date/date_api/theme\";s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/date/date_api\";s:8:\"function\";s:29:\"theme_date_part_minsec_prefix\";s:8:\"includes\";a:1:{i:0;s:47:\"sites/all/modules/date/date_api/theme/theme.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:20:\"date_part_label_year\";a:9:{s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:37:\"sites/all/modules/date/date_api/theme\";s:9:\"variables\";a:2:{s:9:\"date_part\";N;s:7:\"element\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/date/date_api\";s:8:\"function\";s:26:\"theme_date_part_label_year\";s:8:\"includes\";a:1:{i:0;s:47:\"sites/all/modules/date/date_api/theme/theme.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:21:\"date_part_label_month\";a:9:{s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:37:\"sites/all/modules/date/date_api/theme\";s:9:\"variables\";a:2:{s:9:\"date_part\";N;s:7:\"element\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/date/date_api\";s:8:\"function\";s:27:\"theme_date_part_label_month\";s:8:\"includes\";a:1:{i:0;s:47:\"sites/all/modules/date/date_api/theme/theme.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:19:\"date_part_label_day\";a:9:{s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:37:\"sites/all/modules/date/date_api/theme\";s:9:\"variables\";a:2:{s:9:\"date_part\";N;s:7:\"element\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/date/date_api\";s:8:\"function\";s:25:\"theme_date_part_label_day\";s:8:\"includes\";a:1:{i:0;s:47:\"sites/all/modules/date/date_api/theme/theme.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:20:\"date_part_label_hour\";a:9:{s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:37:\"sites/all/modules/date/date_api/theme\";s:9:\"variables\";a:2:{s:9:\"date_part\";N;s:7:\"element\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/date/date_api\";s:8:\"function\";s:26:\"theme_date_part_label_hour\";s:8:\"includes\";a:1:{i:0;s:47:\"sites/all/modules/date/date_api/theme/theme.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:22:\"date_part_label_minute\";a:9:{s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:37:\"sites/all/modules/date/date_api/theme\";s:9:\"variables\";a:2:{s:9:\"date_part\";N;s:7:\"element\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/date/date_api\";s:8:\"function\";s:28:\"theme_date_part_label_minute\";s:8:\"includes\";a:1:{i:0;s:47:\"sites/all/modules/date/date_api/theme/theme.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:22:\"date_part_label_second\";a:9:{s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:37:\"sites/all/modules/date/date_api/theme\";s:9:\"variables\";a:2:{s:9:\"date_part\";N;s:7:\"element\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/date/date_api\";s:8:\"function\";s:28:\"theme_date_part_label_second\";s:8:\"includes\";a:1:{i:0;s:47:\"sites/all/modules/date/date_api/theme/theme.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:20:\"date_part_label_ampm\";a:9:{s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:37:\"sites/all/modules/date/date_api/theme\";s:9:\"variables\";a:2:{s:9:\"date_part\";N;s:7:\"element\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/date/date_api\";s:8:\"function\";s:26:\"theme_date_part_label_ampm\";s:8:\"includes\";a:1:{i:0;s:47:\"sites/all/modules/date/date_api/theme/theme.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:24:\"date_part_label_timezone\";a:9:{s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:37:\"sites/all/modules/date/date_api/theme\";s:9:\"variables\";a:2:{s:9:\"date_part\";N;s:7:\"element\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/date/date_api\";s:8:\"function\";s:30:\"theme_date_part_label_timezone\";s:8:\"includes\";a:1:{i:0;s:47:\"sites/all/modules/date/date_api/theme/theme.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:20:\"date_part_label_date\";a:9:{s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:37:\"sites/all/modules/date/date_api/theme\";s:9:\"variables\";a:2:{s:9:\"date_part\";N;s:7:\"element\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/date/date_api\";s:8:\"function\";s:26:\"theme_date_part_label_date\";s:8:\"includes\";a:1:{i:0;s:47:\"sites/all/modules/date/date_api/theme/theme.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:20:\"date_part_label_time\";a:9:{s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:37:\"sites/all/modules/date/date_api/theme\";s:9:\"variables\";a:2:{s:9:\"date_part\";N;s:7:\"element\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/date/date_api\";s:8:\"function\";s:26:\"theme_date_part_label_time\";s:8:\"includes\";a:1:{i:0;s:47:\"sites/all/modules/date/date_api/theme/theme.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:13:\"date_time_ago\";a:9:{s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:37:\"sites/all/modules/date/date_api/theme\";s:9:\"variables\";a:3:{s:10:\"start_date\";N;s:8:\"end_date\";N;s:8:\"interval\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/date/date_api\";s:8:\"function\";s:19:\"theme_date_time_ago\";s:8:\"includes\";a:1:{i:0;s:47:\"sites/all/modules/date/date_api/theme/theme.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:9:\"dashboard\";a:6:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:17:\"modules/dashboard\";s:8:\"function\";s:15:\"theme_dashboard\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:15:\"dashboard_admin\";a:6:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:17:\"modules/dashboard\";s:8:\"function\";s:21:\"theme_dashboard_admin\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:16:\"dashboard_region\";a:6:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:17:\"modules/dashboard\";s:8:\"function\";s:22:\"theme_dashboard_region\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:25:\"dashboard_disabled_blocks\";a:6:{s:9:\"variables\";a:1:{s:6:\"blocks\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:17:\"modules/dashboard\";s:8:\"function\";s:31:\"theme_dashboard_disabled_blocks\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:24:\"dashboard_disabled_block\";a:6:{s:9:\"variables\";a:1:{s:5:\"block\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:17:\"modules/dashboard\";s:8:\"function\";s:30:\"theme_dashboard_disabled_block\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:28:\"dashboard_admin_display_form\";a:9:{s:8:\"template\";s:24:\"block-admin-display-form\";s:4:\"path\";s:13:\"modules/block\";s:4:\"file\";s:15:\"block.admin.inc\";s:14:\"render element\";s:4:\"form\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:17:\"modules/dashboard\";s:8:\"includes\";a:1:{i:0;s:29:\"modules/block/block.admin.inc\";}s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:48:\"template_preprocess_dashboard_admin_display_form\";i:2;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:15:\"ctools_dropdown\";a:8:{s:9:\"variables\";a:4:{s:5:\"title\";N;s:5:\"links\";N;s:5:\"image\";b:0;s:5:\"class\";s:0:\"\";}s:4:\"file\";s:27:\"includes/dropdown.theme.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:24:\"sites/all/modules/ctools\";s:8:\"function\";s:21:\"theme_ctools_dropdown\";s:8:\"includes\";a:1:{i:0;s:52:\"sites/all/modules/ctools/includes/dropdown.theme.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:18:\"ctools_collapsible\";a:8:{s:9:\"variables\";a:3:{s:6:\"handle\";N;s:7:\"content\";N;s:9:\"collapsed\";b:0;}s:4:\"file\";s:30:\"includes/collapsible.theme.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:24:\"sites/all/modules/ctools\";s:8:\"function\";s:24:\"theme_ctools_collapsible\";s:8:\"includes\";a:1:{i:0;s:55:\"sites/all/modules/ctools/includes/collapsible.theme.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:29:\"ctools_collapsible_remembered\";a:8:{s:9:\"variables\";a:4:{s:2:\"id\";N;s:6:\"handle\";N;s:7:\"content\";N;s:9:\"collapsed\";b:0;}s:4:\"file\";s:30:\"includes/collapsible.theme.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:24:\"sites/all/modules/ctools\";s:8:\"function\";s:35:\"theme_ctools_collapsible_remembered\";s:8:\"includes\";a:1:{i:0;s:55:\"sites/all/modules/ctools/includes/collapsible.theme.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:19:\"ctools_wizard_trail\";a:8:{s:9:\"variables\";a:3:{s:5:\"trail\";N;s:9:\"form_info\";N;s:7:\"divider\";s:4:\" » \";}s:4:\"file\";s:25:\"includes/wizard.theme.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:24:\"sites/all/modules/ctools\";s:8:\"function\";s:25:\"theme_ctools_wizard_trail\";s:8:\"includes\";a:1:{i:0;s:50:\"sites/all/modules/ctools/includes/wizard.theme.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:24:\"links__ctools_dropbutton\";a:8:{s:9:\"variables\";a:4:{s:5:\"title\";N;s:5:\"links\";N;s:5:\"image\";b:0;s:5:\"class\";N;}s:4:\"file\";s:29:\"includes/dropbutton.theme.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:24:\"sites/all/modules/ctools\";s:8:\"function\";s:30:\"theme_links__ctools_dropbutton\";s:8:\"includes\";a:1:{i:0;s:54:\"sites/all/modules/ctools/includes/dropbutton.theme.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:33:\"ctools_stylizer_color_scheme_form\";a:8:{s:14:\"render element\";s:4:\"form\";s:4:\"file\";s:21:\"includes/stylizer.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:24:\"sites/all/modules/ctools\";s:8:\"function\";s:39:\"theme_ctools_stylizer_color_scheme_form\";s:8:\"includes\";a:1:{i:0;s:46:\"sites/all/modules/ctools/includes/stylizer.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:28:\"ctools_stylizer_preview_form\";a:8:{s:14:\"render element\";s:4:\"form\";s:4:\"file\";s:21:\"includes/stylizer.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:24:\"sites/all/modules/ctools\";s:8:\"function\";s:34:\"theme_ctools_stylizer_preview_form\";s:8:\"includes\";a:1:{i:0;s:46:\"sites/all/modules/ctools/includes/stylizer.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:17:\"ctools_style_icon\";a:8:{s:9:\"variables\";a:2:{s:5:\"image\";N;s:5:\"title\";N;}s:4:\"file\";s:21:\"includes/stylizer.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:24:\"sites/all/modules/ctools\";s:8:\"function\";s:23:\"theme_ctools_style_icon\";s:8:\"includes\";a:1:{i:0;s:46:\"sites/all/modules/ctools/includes/stylizer.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:33:\"ctools_menu_local_actions_wrapper\";a:8:{s:14:\"render element\";s:5:\"links\";s:4:\"file\";s:31:\"includes/action-links.theme.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:24:\"sites/all/modules/ctools\";s:8:\"function\";s:39:\"theme_ctools_menu_local_actions_wrapper\";s:8:\"includes\";a:1:{i:0;s:56:\"sites/all/modules/ctools/includes/action-links.theme.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:19:\"ctools_context_list\";a:8:{s:9:\"variables\";a:1:{s:6:\"object\";N;}s:4:\"file\";s:26:\"includes/context.theme.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:24:\"sites/all/modules/ctools\";s:8:\"function\";s:25:\"theme_ctools_context_list\";s:8:\"includes\";a:1:{i:0;s:51:\"sites/all/modules/ctools/includes/context.theme.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:28:\"ctools_context_list_no_table\";a:8:{s:9:\"variables\";a:1:{s:6:\"object\";N;}s:4:\"file\";s:26:\"includes/context.theme.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:24:\"sites/all/modules/ctools\";s:8:\"function\";s:34:\"theme_ctools_context_list_no_table\";s:8:\"includes\";a:1:{i:0;s:51:\"sites/all/modules/ctools/includes/context.theme.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:24:\"ctools_context_item_form\";a:8:{s:14:\"render element\";s:4:\"form\";s:4:\"file\";s:26:\"includes/context.theme.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:24:\"sites/all/modules/ctools\";s:8:\"function\";s:30:\"theme_ctools_context_item_form\";s:8:\"includes\";a:1:{i:0;s:51:\"sites/all/modules/ctools/includes/context.theme.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:23:\"ctools_context_item_row\";a:8:{s:9:\"variables\";a:5:{s:4:\"type\";N;s:4:\"form\";N;s:8:\"position\";N;s:5:\"count\";N;s:7:\"with_tr\";b:1;}s:4:\"file\";s:26:\"includes/context.theme.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:24:\"sites/all/modules/ctools\";s:8:\"function\";s:29:\"theme_ctools_context_item_row\";s:8:\"includes\";a:1:{i:0;s:51:\"sites/all/modules/ctools/includes/context.theme.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:23:\"ctools_access_admin_add\";a:8:{s:14:\"render element\";s:4:\"form\";s:4:\"file\";s:33:\"includes/context-access-admin.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:24:\"sites/all/modules/ctools\";s:8:\"function\";s:29:\"theme_ctools_access_admin_add\";s:8:\"includes\";a:1:{i:0;s:58:\"sites/all/modules/ctools/includes/context-access-admin.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:13:\"comment_block\";a:6:{s:9:\"variables\";a:0:{}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:15:\"modules/comment\";s:8:\"function\";s:19:\"theme_comment_block\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:15:\"comment_preview\";a:6:{s:9:\"variables\";a:1:{s:7:\"comment\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:15:\"modules/comment\";s:8:\"function\";s:21:\"theme_comment_preview\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:7:\"comment\";a:6:{s:8:\"template\";s:23:\"modules/comment/comment\";s:14:\"render element\";s:8:\"elements\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:15:\"modules/comment\";s:20:\"preprocess functions\";a:5:{i:0;s:19:\"template_preprocess\";i:1;s:27:\"template_preprocess_comment\";i:2;s:21:\"contextual_preprocess\";i:3;s:24:\"views_preprocess_comment\";i:4;s:33:\"advanced_forum_preprocess_comment\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:22:\"comment_post_forbidden\";a:6:{s:9:\"variables\";a:1:{s:4:\"node\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:15:\"modules/comment\";s:8:\"function\";s:28:\"theme_comment_post_forbidden\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:15:\"comment_wrapper\";a:6:{s:8:\"template\";s:31:\"modules/comment/comment-wrapper\";s:14:\"render element\";s:7:\"content\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:15:\"modules/comment\";s:20:\"preprocess functions\";a:4:{i:0;s:19:\"template_preprocess\";i:1;s:35:\"template_preprocess_comment_wrapper\";i:2;s:21:\"contextual_preprocess\";i:3;s:41:\"advanced_forum_preprocess_comment_wrapper\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:17:\"color_scheme_form\";a:6:{s:14:\"render element\";s:4:\"form\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:13:\"modules/color\";s:8:\"function\";s:23:\"theme_color_scheme_form\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:13:\"calendar_item\";a:9:{s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:32:\"sites/all/modules/calendar/theme\";s:8:\"template\";s:13:\"calendar-item\";s:9:\"variables\";a:3:{s:4:\"view\";N;s:15:\"rendered_fields\";N;s:4:\"item\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:26:\"sites/all/modules/calendar\";s:8:\"includes\";a:1:{i:0;s:42:\"sites/all/modules/calendar/theme/theme.inc\";}s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:33:\"template_preprocess_calendar_item\";i:2;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:16:\"calendar_datebox\";a:9:{s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:32:\"sites/all/modules/calendar/theme\";s:8:\"template\";s:16:\"calendar-datebox\";s:9:\"variables\";a:4:{s:4:\"date\";N;s:4:\"view\";N;s:5:\"items\";N;s:8:\"selected\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:26:\"sites/all/modules/calendar\";s:8:\"includes\";a:1:{i:0;s:42:\"sites/all/modules/calendar/theme/theme.inc\";}s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:36:\"template_preprocess_calendar_datebox\";i:2;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:18:\"calendar_empty_day\";a:9:{s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:32:\"sites/all/modules/calendar/theme\";s:9:\"variables\";a:2:{s:6:\"curday\";N;s:4:\"view\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:26:\"sites/all/modules/calendar\";s:8:\"function\";s:24:\"theme_calendar_empty_day\";s:8:\"includes\";a:1:{i:0;s:42:\"sites/all/modules/calendar/theme/theme.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:22:\"calendar_stripe_legend\";a:9:{s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:32:\"sites/all/modules/calendar/theme\";s:9:\"variables\";a:1:{s:4:\"view\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:26:\"sites/all/modules/calendar\";s:8:\"function\";s:28:\"theme_calendar_stripe_legend\";s:8:\"includes\";a:1:{i:0;s:42:\"sites/all/modules/calendar/theme/theme.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:22:\"calendar_stripe_stripe\";a:9:{s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:32:\"sites/all/modules/calendar/theme\";s:9:\"variables\";a:1:{s:4:\"node\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:26:\"sites/all/modules/calendar\";s:8:\"function\";s:28:\"theme_calendar_stripe_stripe\";s:8:\"includes\";a:1:{i:0;s:42:\"sites/all/modules/calendar/theme/theme.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:25:\"calendar_time_row_heading\";a:9:{s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:32:\"sites/all/modules/calendar/theme\";s:9:\"variables\";a:3:{s:10:\"start_time\";N;s:15:\"next_start_time\";N;s:11:\"curday_date\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:26:\"sites/all/modules/calendar\";s:8:\"function\";s:31:\"theme_calendar_time_row_heading\";s:8:\"includes\";a:1:{i:0;s:42:\"sites/all/modules/calendar/theme/theme.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:18:\"calendar_month_col\";a:9:{s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:32:\"sites/all/modules/calendar/theme\";s:8:\"template\";s:18:\"calendar-month-col\";s:9:\"variables\";a:1:{s:4:\"item\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:26:\"sites/all/modules/calendar\";s:8:\"includes\";a:1:{i:0;s:42:\"sites/all/modules/calendar/theme/theme.inc\";}s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:18:\"calendar_month_row\";a:9:{s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:32:\"sites/all/modules/calendar/theme\";s:8:\"template\";s:18:\"calendar-month-row\";s:9:\"variables\";a:3:{s:5:\"inner\";N;s:5:\"class\";N;s:6:\"iehint\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:26:\"sites/all/modules/calendar\";s:8:\"includes\";a:1:{i:0;s:42:\"sites/all/modules/calendar/theme/theme.inc\";}s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:30:\"calendar_month_multiple_entity\";a:9:{s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:32:\"sites/all/modules/calendar/theme\";s:8:\"template\";s:30:\"calendar-month-multiple-entity\";s:9:\"variables\";a:4:{s:16:\"\n         curday\";N;s:5:\"count\";N;s:4:\"view\";N;s:3:\"ids\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:26:\"sites/all/modules/calendar\";s:8:\"includes\";a:1:{i:0;s:42:\"sites/all/modules/calendar/theme/theme.inc\";}s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:50:\"template_preprocess_calendar_month_multiple_entity\";i:2;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:15:\"book_navigation\";a:6:{s:9:\"variables\";a:1:{s:9:\"book_link\";N;}s:8:\"template\";s:28:\"modules/book/book-navigation\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:12:\"modules/book\";s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:35:\"template_preprocess_book_navigation\";i:2;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:16:\"book_export_html\";a:6:{s:9:\"variables\";a:3:{s:5:\"title\";N;s:8:\"contents\";N;s:5:\"depth\";N;}s:8:\"template\";s:29:\"modules/book/book-export-html\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:12:\"modules/book\";s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:36:\"template_preprocess_book_export_html\";i:2;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:16:\"book_admin_table\";a:6:{s:14:\"render element\";s:4:\"form\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:12:\"modules/book\";s:8:\"function\";s:22:\"theme_book_admin_table\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:15:\"book_title_link\";a:6:{s:9:\"variables\";a:1:{s:4:\"link\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:12:\"modules/book\";s:8:\"function\";s:21:\"theme_book_title_link\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:20:\"book_all_books_block\";a:6:{s:14:\"render element\";s:10:\"book_menus\";s:8:\"template\";s:33:\"modules/book/book-all-books-block\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:12:\"modules/book\";s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:40:\"template_preprocess_book_all_books_block\";i:2;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:21:\"book_node_export_html\";a:6:{s:9:\"variables\";a:2:{s:4:\"node\";N;s:8:\"children\";N;}s:8:\"template\";s:34:\"modules/book/book-node-export-html\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:12:\"modules/book\";s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:41:\"template_preprocess_book_node_export_html\";i:2;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:11:\"author_pane\";a:6:{s:8:\"template\";s:41:\"sites/all/modules/author_pane/author-pane\";s:9:\"variables\";a:6:{s:7:\"account\";N;s:6:\"caller\";N;s:14:\"picture_preset\";N;s:7:\"context\";N;s:11:\"disable_css\";N;s:14:\"join_date_type\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:29:\"sites/all/modules/author_pane\";s:20:\"preprocess functions\";a:5:{i:0;s:19:\"template_preprocess\";i:1;s:31:\"template_preprocess_author_pane\";i:2;s:30:\"contact_preprocess_author_pane\";i:3;s:21:\"contextual_preprocess\";i:4;s:37:\"advanced_forum_preprocess_author_pane\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:24:\"author_pane_user_picture\";a:6:{s:8:\"template\";s:54:\"sites/all/modules/author_pane/author-pane-user-picture\";s:9:\"variables\";a:3:{s:7:\"account\";N;s:6:\"caller\";N;s:14:\"picture_preset\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:29:\"sites/all/modules/author_pane\";s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:44:\"template_preprocess_author_pane_user_picture\";i:2;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:12:\"webform_view\";a:6:{s:14:\"render element\";s:7:\"webform\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:25:\"sites/all/modules/webform\";s:8:\"function\";s:18:\"theme_webform_view\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:21:\"webform_view_messages\";a:6:{s:9:\"variables\";a:8:{s:4:\"node\";N;s:4:\"page\";N;s:16:\"submission_count\";N;s:19:\"user_limit_exceeded\";N;s:20:\"total_limit_exceeded\";N;s:13:\"allowed_roles\";N;s:6:\"closed\";N;s:6:\"cached\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:25:\"sites/all/modules/webform\";s:8:\"function\";s:27:\"theme_webform_view_messages\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:12:\"webform_form\";a:7:{s:14:\"render element\";s:4:\"form\";s:8:\"template\";s:48:\"sites/all/modules/webform/templates/webform-form\";s:7:\"pattern\";s:19:\"webform_form_[0-9]+\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:25:\"sites/all/modules/webform\";s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:32:\"template_preprocess_webform_form\";i:2;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:20:\"webform_confirmation\";a:7:{s:9:\"variables\";a:2:{s:4:\"node\";N;s:3:\"sid\";N;}s:8:\"template\";s:56:\"sites/all/modules/webform/templates/webform-confirmation\";s:7:\"pattern\";s:27:\"webform_confirmation_[0-9]+\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:25:\"sites/all/modules/webform\";s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:40:\"template_preprocess_webform_confirmation\";i:2;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:15:\"webform_element\";a:6:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:25:\"sites/all/modules/webform\";s:8:\"function\";s:21:\"theme_webform_element\";s:20:\"preprocess functions\";a:1:{i:0;s:35:\"template_preprocess_webform_element\";}s:17:\"process functions\";a:0:{}}s:20:\"webform_element_text\";a:6:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:25:\"sites/all/modules/webform\";s:8:\"function\";s:26:\"theme_webform_element_text\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:20:\"webform_inline_radio\";a:6:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:25:\"sites/all/modules/webform\";s:8:\"function\";s:26:\"theme_webform_inline_radio\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:26:\"webform_inline_radio_label\";a:6:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:25:\"sites/all/modules/webform\";s:8:\"function\";s:32:\"theme_webform_inline_radio_label\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:19:\"webform_progressbar\";a:6:{s:9:\"variables\";a:4:{s:4:\"node\";N;s:8:\"page_num\";N;s:10:\"page_count\";N;s:11:\"page_labels\";a:0:{}}s:8:\"template\";s:55:\"sites/all/modules/webform/templates/webform-progressbar\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:25:\"sites/all/modules/webform\";s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:39:\"template_preprocess_webform_progressbar\";i:2;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:20:\"webform_mail_message\";a:7:{s:9:\"variables\";a:3:{s:4:\"node\";N;s:10:\"submission\";N;s:5:\"email\";N;}s:8:\"template\";s:48:\"sites/all/modules/webform/templates/webform-mail\";s:7:\"pattern\";s:22:\"webform_mail(_[0-9]+)?\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:25:\"sites/all/modules/webform\";s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:40:\"template_preprocess_webform_mail_message\";i:2;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:20:\"webform_mail_headers\";a:7:{s:9:\"variables\";a:3:{s:4:\"node\";N;s:10:\"submission\";N;s:5:\"email\";N;}s:7:\"pattern\";s:27:\"webform_mail_headers_[0-9]+\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:25:\"sites/all/modules/webform\";s:8:\"function\";s:26:\"theme_webform_mail_headers\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:18:\"webform_token_help\";a:6:{s:9:\"variables\";a:1:{s:6:\"groups\";a:1:{i:0;s:4:\"node\";}}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:25:\"sites/all/modules/webform\";s:8:\"function\";s:24:\"theme_webform_token_help\";s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:22:\"webform_admin_settings\";a:8:{s:14:\"render element\";s:4:\"form\";s:4:\"file\";s:26:\"includes/webform.admin.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:25:\"sites/all/modules/webform\";s:8:\"function\";s:28:\"theme_webform_admin_settings\";s:8:\"includes\";a:1:{i:0;s:52:\"sites/all/modules/webform/includes/webform.admin.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:21:\"webform_admin_content\";a:8:{s:9:\"variables\";a:1:{s:5:\"nodes\";N;}s:4:\"file\";s:26:\"includes/webform.admin.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:25:\"sites/all/modules/webform\";s:8:\"function\";s:27:\"theme_webform_admin_content\";s:8:\"includes\";a:1:{i:0;s:52:\"sites/all/modules/webform/includes/webform.admin.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:19:\"webform_emails_form\";a:8:{s:14:\"render element\";s:4:\"form\";s:4:\"file\";s:27:\"includes/webform.emails.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:25:\"sites/all/modules/webform\";s:8:\"function\";s:25:\"theme_webform_emails_form\";s:8:\"includes\";a:1:{i:0;s:53:\"sites/all/modules/webform/includes/webform.emails.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:31:\"webform_email_component_mapping\";a:8:{s:14:\"render element\";s:7:\"element\";s:4:\"file\";s:27:\"includes/webform.emails.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:25:\"sites/all/modules/webform\";s:8:\"function\";s:37:\"theme_webform_email_component_mapping\";s:8:\"includes\";a:1:{i:0;s:53:\"sites/all/modules/webform/includes/webform.emails.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:22:\"webform_email_add_form\";a:8:{s:14:\"render element\";s:4:\"form\";s:4:\"file\";s:27:\"includes/webform.emails.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:25:\"sites/all/modules/webform\";s:8:\"function\";s:28:\"theme_webform_email_add_form\";s:8:\"includes\";a:1:{i:0;s:53:\"sites/all/modules/webform/includes/webform.emails.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:23:\"webform_email_edit_form\";a:8:{s:14:\"render element\";s:4:\"form\";s:4:\"file\";s:27:\"includes/webform.emails.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:25:\"sites/all/modules/webform\";s:8:\"function\";s:29:\"theme_webform_email_edit_form\";s:8:\"includes\";a:1:{i:0;s:53:\"sites/all/modules/webform/includes/webform.emails.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:23:\"webform_components_page\";a:8:{s:9:\"variables\";a:2:{s:4:\"node\";N;s:4:\"form\";N;}s:4:\"file\";s:31:\"includes/webform.components.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:25:\"sites/all/modules/webform\";s:8:\"function\";s:29:\"theme_webform_components_page\";s:8:\"includes\";a:1:{i:0;s:57:\"sites/all/modules/webform/includes/webform.components.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:23:\"webform_components_form\";a:8:{s:14:\"render element\";s:4:\"form\";s:4:\"file\";s:31:\"includes/webform.components.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:25:\"sites/all/modules/webform\";s:8:\"function\";s:29:\"theme_webform_components_form\";s:8:\"includes\";a:1:{i:0;s:57:\"sites/all/modules/webform/includes/webform.components.inc\";}s:20:\"preprocess functions\";a:1:{i:0;s:43:\"template_preprocess_webform_components_form\";}s:17:\"process functions\";a:0:{}}s:24:\"webform_component_select\";a:8:{s:14:\"render element\";s:7:\"element\";s:4:\"file\";s:31:\"includes/webform.components.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:25:\"sites/all/modules/webform\";s:8:\"function\";s:30:\"theme_webform_component_select\";s:8:\"includes\";a:1:{i:0;s:57:\"sites/all/modules/webform/includes/webform.components.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:26:\"webform_conditional_groups\";a:8:{s:14:\"render element\";s:7:\"element\";s:4:\"file\";s:33:\"includes/webform.conditionals.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:25:\"sites/all/modules/webform\";s:8:\"function\";s:32:\"theme_webform_conditional_groups\";s:8:\"includes\";a:1:{i:0;s:59:\"sites/all/modules/webform/includes/webform.conditionals.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:29:\"webform_conditional_group_row\";a:8:{s:14:\"render element\";s:7:\"element\";s:4:\"file\";s:33:\"includes/webform.conditionals.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:25:\"sites/all/modules/webform\";s:8:\"function\";s:35:\"theme_webform_conditional_group_row\";s:8:\"includes\";a:1:{i:0;s:59:\"sites/all/modules/webform/includes/webform.conditionals.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:19:\"webform_conditional\";a:8:{s:14:\"render element\";s:7:\"element\";s:4:\"file\";s:33:\"includes/webform.conditionals.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:25:\"sites/all/modules/webform\";s:8:\"function\";s:25:\"theme_webform_conditional\";s:8:\"includes\";a:1:{i:0;s:59:\"sites/all/modules/webform/includes/webform.conditionals.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:33:\"webform_advanced_redirection_form\";a:8:{s:14:\"render element\";s:4:\"form\";s:4:\"file\";s:26:\"includes/webform.pages.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:25:\"sites/all/modules/webform\";s:8:\"function\";s:39:\"theme_webform_advanced_redirection_form\";s:8:\"includes\";a:1:{i:0;s:52:\"sites/all/modules/webform/includes/webform.pages.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:34:\"webform_advanced_submit_limit_form\";a:8:{s:14:\"render element\";s:4:\"form\";s:4:\"file\";s:26:\"includes/webform.pages.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:25:\"sites/all/modules/webform\";s:8:\"function\";s:40:\"theme_webform_advanced_submit_limit_form\";s:8:\"includes\";a:1:{i:0;s:52:\"sites/all/modules/webform/includes/webform.pages.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:40:\"webform_advanced_total_submit_limit_form\";a:8:{s:14:\"render element\";s:4:\"form\";s:4:\"file\";s:26:\"includes/webform.pages.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:25:\"sites/all/modules/webform\";s:8:\"function\";s:46:\"theme_webform_advanced_total_submit_limit_form\";s:8:\"includes\";a:1:{i:0;s:52:\"sites/all/modules/webform/includes/webform.pages.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:24:\"webform_results_per_page\";a:8:{s:9:\"variables\";a:2:{s:11:\"total_count\";N;s:11:\"pager_count\";N;}s:4:\"file\";s:27:\"includes/webform.report.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:25:\"sites/all/modules/webform\";s:8:\"function\";s:30:\"theme_webform_results_per_page\";s:8:\"includes\";a:1:{i:0;s:53:\"sites/all/modules/webform/includes/webform.report.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:34:\"webform_results_submissions_header\";a:8:{s:9:\"variables\";a:1:{s:4:\"node\";N;}s:4:\"file\";s:27:\"includes/webform.report.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:25:\"sites/all/modules/webform\";s:8:\"function\";s:40:\"theme_webform_results_submissions_header\";s:8:\"includes\";a:1:{i:0;s:53:\"sites/all/modules/webform/includes/webform.report.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:27:\"webform_results_submissions\";a:8:{s:14:\"render element\";s:7:\"element\";s:8:\"template\";s:63:\"sites/all/modules/webform/templates/webform-results-submissions\";s:4:\"file\";s:27:\"includes/webform.report.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:25:\"sites/all/modules/webform\";s:8:\"includes\";a:1:{i:0;s:53:\"sites/all/modules/webform/includes/webform.report.inc\";}s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:47:\"template_preprocess_webform_results_submissions\";i:2;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:28:\"webform_results_table_header\";a:8:{s:9:\"variables\";a:1:{s:4:\"node\";N;}s:4:\"file\";s:27:\"includes/webform.report.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:25:\"sites/all/modules/webform\";s:8:\"function\";s:34:\"theme_webform_results_table_header\";s:8:\"includes\";a:1:{i:0;s:53:\"sites/all/modules/webform/includes/webform.report.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:21:\"webform_results_table\";a:8:{s:9:\"variables\";a:5:{s:4:\"node\";N;s:10:\"components\";N;s:11:\"submissions\";N;s:11:\"total_count\";N;s:11:\"pager_count\";N;}s:4:\"file\";s:27:\"includes/webform.report.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:25:\"sites/all/modules/webform\";s:8:\"function\";s:27:\"theme_webform_results_table\";s:8:\"includes\";a:1:{i:0;s:53:\"sites/all/modules/webform/includes/webform.report.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:30:\"webform_results_download_range\";a:8:{s:14:\"render element\";s:7:\"element\";s:4:\"file\";s:27:\"includes/webform.report.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:25:\"sites/all/modules/webform\";s:8:\"function\";s:36:\"theme_webform_results_download_range\";s:8:\"includes\";a:1:{i:0;s:53:\"sites/all/modules/webform/includes/webform.report.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:38:\"webform_results_download_select_format\";a:8:{s:14:\"render element\";s:7:\"element\";s:4:\"file\";s:27:\"includes/webform.report.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:25:\"sites/all/modules/webform\";s:8:\"function\";s:44:\"theme_webform_results_download_select_format\";s:8:\"includes\";a:1:{i:0;s:53:\"sites/all/modules/webform/includes/webform.report.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:16:\"webform_analysis\";a:8:{s:14:\"render element\";s:8:\"analysis\";s:8:\"template\";s:52:\"sites/all/modules/webform/templates/webform-analysis\";s:4:\"file\";s:27:\"includes/webform.report.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:25:\"sites/all/modules/webform\";s:8:\"includes\";a:1:{i:0;s:53:\"sites/all/modules/webform/includes/webform.report.inc\";}s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:36:\"template_preprocess_webform_analysis\";i:2;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:26:\"webform_analysis_component\";a:8:{s:14:\"render element\";s:18:\"component_analysis\";s:8:\"template\";s:62:\"sites/all/modules/webform/templates/webform-analysis-component\";s:4:\"file\";s:27:\"includes/webform.report.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:25:\"sites/all/modules/webform\";s:8:\"includes\";a:1:{i:0;s:53:\"sites/all/modules/webform/includes/webform.report.inc\";}s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:46:\"template_preprocess_webform_analysis_component\";i:2;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:32:\"webform_analysis_component_basic\";a:8:{s:9:\"variables\";a:2:{s:9:\"component\";N;s:4:\"data\";N;}s:4:\"file\";s:27:\"includes/webform.report.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:25:\"sites/all/modules/webform\";s:8:\"function\";s:38:\"theme_webform_analysis_component_basic\";s:8:\"includes\";a:1:{i:0;s:53:\"sites/all/modules/webform/includes/webform.report.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:18:\"webform_submission\";a:9:{s:14:\"render element\";s:10:\"renderable\";s:8:\"template\";s:54:\"sites/all/modules/webform/templates/webform-submission\";s:7:\"pattern\";s:25:\"webform_submission_[0-9]+\";s:4:\"file\";s:32:\"includes/webform.submissions.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:25:\"sites/all/modules/webform\";s:8:\"includes\";a:1:{i:0;s:58:\"sites/all/modules/webform/includes/webform.submissions.inc\";}s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:38:\"template_preprocess_webform_submission\";i:2;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:23:\"webform_submission_page\";a:8:{s:9:\"variables\";a:7:{s:4:\"node\";N;s:10:\"submission\";N;s:18:\"submission_content\";N;s:21:\"submission_navigation\";N;s:22:\"submission_information\";N;s:18:\"submission_actions\";N;s:4:\"mode\";N;}s:8:\"template\";s:59:\"sites/all/modules/webform/templates/webform-submission-page\";s:4:\"file\";s:32:\"includes/webform.submissions.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:25:\"sites/all/modules/webform\";s:8:\"includes\";a:1:{i:0;s:58:\"sites/all/modules/webform/includes/webform.submissions.inc\";}s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:30:\"webform_submission_information\";a:8:{s:9:\"variables\";a:3:{s:4:\"node\";N;s:10:\"submission\";N;s:4:\"mode\";s:7:\"display\";}s:8:\"template\";s:66:\"sites/all/modules/webform/templates/webform-submission-information\";s:4:\"file\";s:32:\"includes/webform.submissions.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:25:\"sites/all/modules/webform\";s:8:\"includes\";a:1:{i:0;s:58:\"sites/all/modules/webform/includes/webform.submissions.inc\";}s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:50:\"template_preprocess_webform_submission_information\";i:2;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:29:\"webform_submission_navigation\";a:8:{s:9:\"variables\";a:3:{s:4:\"node\";N;s:10:\"submission\";N;s:4:\"mode\";N;}s:8:\"template\";s:65:\"sites/all/modules/webform/templates/webform-submission-navigation\";s:4:\"file\";s:32:\"includes/webform.submissions.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:25:\"sites/all/modules/webform\";s:8:\"includes\";a:1:{i:0;s:58:\"sites/all/modules/webform/includes/webform.submissions.inc\";}s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:49:\"template_preprocess_webform_submission_navigation\";i:2;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:25:\"webform_submission_resend\";a:8:{s:14:\"render element\";s:4:\"form\";s:4:\"file\";s:32:\"includes/webform.submissions.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:25:\"sites/all/modules/webform\";s:8:\"function\";s:31:\"theme_webform_submission_resend\";s:8:\"includes\";a:1:{i:0;s:58:\"sites/all/modules/webform/includes/webform.submissions.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:12:\"webform_date\";a:8:{s:14:\"render element\";s:7:\"element\";s:4:\"file\";s:19:\"components/date.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:25:\"sites/all/modules/webform\";s:8:\"function\";s:18:\"theme_webform_date\";s:8:\"includes\";a:1:{i:0;s:45:\"sites/all/modules/webform/components/date.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:20:\"webform_display_date\";a:8:{s:14:\"render element\";s:7:\"element\";s:4:\"file\";s:19:\"components/date.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:25:\"sites/all/modules/webform\";s:8:\"function\";s:26:\"theme_webform_display_date\";s:8:\"includes\";a:1:{i:0;s:45:\"sites/all/modules/webform/components/date.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:16:\"webform_calendar\";a:6:{s:9:\"variables\";a:2:{s:9:\"component\";N;s:16:\"calendar_classes\";N;}s:8:\"template\";s:52:\"sites/all/modules/webform/templates/webform-calendar\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:25:\"sites/all/modules/webform\";s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:13:\"webform_email\";a:8:{s:14:\"render element\";s:7:\"element\";s:4:\"file\";s:20:\"components/email.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:25:\"sites/all/modules/webform\";s:8:\"function\";s:19:\"theme_webform_email\";s:8:\"includes\";a:1:{i:0;s:46:\"sites/all/modules/webform/components/email.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:21:\"webform_display_email\";a:8:{s:14:\"render element\";s:7:\"element\";s:4:\"file\";s:20:\"components/email.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:25:\"sites/all/modules/webform\";s:8:\"function\";s:27:\"theme_webform_display_email\";s:8:\"includes\";a:1:{i:0;s:46:\"sites/all/modules/webform/components/email.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:28:\"webform_edit_file_extensions\";a:8:{s:14:\"render element\";s:7:\"element\";s:4:\"file\";s:19:\"components/file.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:25:\"sites/all/modules/webform\";s:8:\"function\";s:34:\"theme_webform_edit_file_extensions\";s:8:\"includes\";a:1:{i:0;s:45:\"sites/all/modules/webform/components/file.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:20:\"webform_display_file\";a:8:{s:14:\"render element\";s:7:\"element\";s:4:\"file\";s:19:\"components/file.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:25:\"sites/all/modules/webform\";s:8:\"function\";s:26:\"theme_webform_display_file\";s:8:\"includes\";a:1:{i:0;s:45:\"sites/all/modules/webform/components/file.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:20:\"webform_managed_file\";a:8:{s:14:\"render element\";s:7:\"element\";s:4:\"file\";s:19:\"components/file.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:25:\"sites/all/modules/webform\";s:8:\"function\";s:26:\"theme_webform_managed_file\";s:8:\"includes\";a:1:{i:0;s:45:\"sites/all/modules/webform/components/file.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:12:\"webform_grid\";a:8:{s:14:\"render element\";s:7:\"element\";s:4:\"file\";s:19:\"components/grid.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:25:\"sites/all/modules/webform\";s:8:\"function\";s:18:\"theme_webform_grid\";s:8:\"includes\";a:1:{i:0;s:45:\"sites/all/modules/webform/components/grid.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:20:\"webform_display_grid\";a:8:{s:14:\"render element\";s:7:\"element\";s:4:\"file\";s:19:\"components/grid.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:25:\"sites/all/modules/webform\";s:8:\"function\";s:26:\"theme_webform_display_grid\";s:8:\"includes\";a:1:{i:0;s:45:\"sites/all/modules/webform/components/grid.inc\";}s:20:\"preprocess functions\";a:1:{i:0;s:40:\"template_preprocess_webform_display_grid\";}s:17:\"process functions\";a:0:{}}s:22:\"webform_display_hidden\";a:8:{s:14:\"render element\";s:7:\"element\";s:4:\"file\";s:21:\"components/hidden.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:25:\"sites/all/modules/webform\";s:8:\"function\";s:28:\"theme_webform_display_hidden\";s:8:\"includes\";a:1:{i:0;s:47:\"sites/all/modules/webform/components/hidden.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:22:\"webform_display_markup\";a:8:{s:14:\"render element\";s:7:\"element\";s:4:\"file\";s:21:\"components/markup.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:25:\"sites/all/modules/webform\";s:8:\"function\";s:28:\"theme_webform_display_markup\";s:8:\"includes\";a:1:{i:0;s:47:\"sites/all/modules/webform/components/markup.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:14:\"webform_number\";a:8:{s:14:\"render element\";s:7:\"element\";s:4:\"file\";s:21:\"components/number.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:25:\"sites/all/modules/webform\";s:8:\"function\";s:20:\"theme_webform_number\";s:8:\"includes\";a:1:{i:0;s:47:\"sites/all/modules/webform/components/number.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:22:\"webform_display_number\";a:8:{s:14:\"render element\";s:7:\"element\";s:4:\"file\";s:21:\"components/number.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:25:\"sites/all/modules/webform\";s:8:\"function\";s:28:\"theme_webform_display_number\";s:8:\"includes\";a:1:{i:0;s:47:\"sites/all/modules/webform/components/number.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:25:\"webform_display_pagebreak\";a:8:{s:14:\"render element\";s:7:\"element\";s:4:\"file\";s:24:\"components/pagebreak.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:25:\"sites/all/modules/webform\";s:8:\"function\";s:31:\"theme_webform_display_pagebreak\";s:8:\"includes\";a:1:{i:0;s:50:\"sites/all/modules/webform/components/pagebreak.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:22:\"webform_display_select\";a:8:{s:14:\"render element\";s:7:\"element\";s:4:\"file\";s:21:\"components/select.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:25:\"sites/all/modules/webform\";s:8:\"function\";s:28:\"theme_webform_display_select\";s:8:\"includes\";a:1:{i:0;s:47:\"sites/all/modules/webform/components/select.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:24:\"webform_display_textarea\";a:8:{s:14:\"render element\";s:7:\"element\";s:4:\"file\";s:23:\"components/textarea.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:25:\"sites/all/modules/webform\";s:8:\"function\";s:30:\"theme_webform_display_textarea\";s:8:\"includes\";a:1:{i:0;s:49:\"sites/all/modules/webform/components/textarea.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:25:\"webform_display_textfield\";a:8:{s:14:\"render element\";s:7:\"element\";s:4:\"file\";s:24:\"components/textfield.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:25:\"sites/all/modules/webform\";s:8:\"function\";s:31:\"theme_webform_display_textfield\";s:8:\"includes\";a:1:{i:0;s:50:\"sites/all/modules/webform/components/textfield.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:12:\"webform_time\";a:8:{s:14:\"render element\";s:7:\"element\";s:4:\"file\";s:19:\"components/time.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:25:\"sites/all/modules/webform\";s:8:\"function\";s:18:\"theme_webform_time\";s:8:\"includes\";a:1:{i:0;s:45:\"sites/all/modules/webform/components/time.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:20:\"webform_display_time\";a:8:{s:14:\"render element\";s:7:\"element\";s:4:\"file\";s:19:\"components/time.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:25:\"sites/all/modules/webform\";s:8:\"function\";s:26:\"theme_webform_display_time\";s:8:\"includes\";a:1:{i:0;s:45:\"sites/all/modules/webform/components/time.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:5:\"block\";a:6:{s:14:\"render element\";s:8:\"elements\";s:8:\"template\";s:19:\"modules/block/block\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:13:\"modules/block\";s:20:\"preprocess functions\";a:5:{i:0;s:19:\"template_preprocess\";i:1;s:25:\"template_preprocess_block\";i:2;s:28:\"block_class_preprocess_block\";i:3;s:21:\"contextual_preprocess\";i:4;s:23:\"system_preprocess_block\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:24:\"block_admin_display_form\";a:8:{s:8:\"template\";s:38:\"modules/block/block-admin-display-form\";s:4:\"file\";s:15:\"block.admin.inc\";s:14:\"render element\";s:4:\"form\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:13:\"modules/block\";s:8:\"includes\";a:1:{i:0;s:29:\"modules/block/block.admin.inc\";}s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:44:\"template_preprocess_block_admin_display_form\";i:2;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:28:\"remember_me_settings_display\";a:8:{s:9:\"variables\";a:1:{s:4:\"vars\";a:0:{}}s:4:\"file\";s:21:\"remember_me.admin.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:29:\"sites/all/modules/remember_me\";s:8:\"function\";s:34:\"theme_remember_me_settings_display\";s:8:\"includes\";a:1:{i:0;s:51:\"sites/all/modules/remember_me/remember_me.admin.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}s:20:\"strongarm_admin_form\";a:9:{s:14:\"render element\";s:4:\"form\";s:4:\"file\";s:19:\"strongarm.admin.inc\";s:4:\"path\";s:27:\"sites/all/modules/strongarm\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:27:\"sites/all/modules/strongarm\";s:8:\"function\";s:26:\"theme_strongarm_admin_form\";s:8:\"includes\";a:1:{i:0;s:47:\"sites/all/modules/strongarm/strongarm.admin.inc\";}s:20:\"preprocess functions\";a:0:{}s:17:\"process functions\";a:0:{}}}',0,1512620340,1),('theme_registry:forum_plus','a:472:{s:12:\"render_panel\";a:6:{s:9:\"variables\";a:3:{s:4:\"page\";a:0:{}s:11:\"panels_list\";a:0:{}s:19:\"panel_regions_width\";a:0:{}}s:20:\"preprocess functions\";a:1:{i:0;s:34:\"forum_plus_preprocess_render_panel\";}s:8:\"template\";s:5:\"panel\";s:4:\"path\";s:31:\"sites/all/themes/forum_plus/tpl\";s:4:\"type\";s:5:\"theme\";s:10:\"theme path\";s:27:\"sites/all/themes/forum_plus\";}s:14:\"date_nav_title\";a:5:{s:8:\"function\";s:25:\"forum_plus_date_nav_title\";s:4:\"type\";s:12:\"theme_engine\";s:10:\"theme path\";s:27:\"sites/all/themes/forum_plus\";s:8:\"includes\";a:2:{i:0;s:47:\"sites/all/modules/date/date_api/theme/theme.inc\";i:1;s:49:\"sites/all/modules/date/date_views/theme/theme.inc\";}s:9:\"variables\";a:4:{s:11:\"granularity\";N;s:4:\"view\";N;s:4:\"link\";N;s:6:\"format\";N;}}s:15:\"views_view_grid\";a:9:{s:8:\"template\";s:15:\"views-view-grid\";s:4:\"path\";s:31:\"sites/all/themes/forum_plus/tpl\";s:4:\"type\";s:12:\"theme_engine\";s:10:\"theme path\";s:27:\"sites/all/themes/forum_plus\";s:8:\"includes\";a:1:{i:0;s:39:\"sites/all/modules/views/theme/theme.inc\";}s:7:\"pattern\";s:17:\"views_view_grid__\";s:9:\"variables\";a:4:{s:4:\"view\";N;s:7:\"options\";N;s:4:\"rows\";N;s:5:\"title\";N;}s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:35:\"template_preprocess_views_view_grid\";i:2;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:5:\"block\";a:7:{s:8:\"template\";s:5:\"block\";s:4:\"path\";s:31:\"sites/all/themes/forum_plus/tpl\";s:4:\"type\";s:12:\"theme_engine\";s:10:\"theme path\";s:27:\"sites/all/themes/forum_plus\";s:14:\"render element\";s:8:\"elements\";s:20:\"preprocess functions\";a:5:{i:0;s:19:\"template_preprocess\";i:1;s:25:\"template_preprocess_block\";i:2;s:28:\"block_class_preprocess_block\";i:3;s:21:\"contextual_preprocess\";i:4;s:23:\"system_preprocess_block\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:4:\"html\";a:7:{s:8:\"template\";s:4:\"html\";s:4:\"path\";s:31:\"sites/all/themes/forum_plus/tpl\";s:4:\"type\";s:12:\"theme_engine\";s:10:\"theme path\";s:27:\"sites/all/themes/forum_plus\";s:14:\"render element\";s:4:\"page\";s:20:\"preprocess functions\";a:7:{i:0;s:19:\"template_preprocess\";i:1;s:24:\"template_preprocess_html\";i:2;s:21:\"contextual_preprocess\";i:3;s:23:\"overlay_preprocess_html\";i:4;s:20:\"i18n_preprocess_html\";i:5;s:21:\"views_preprocess_html\";i:6;s:26:\"forum_plus_preprocess_html\";}s:17:\"process functions\";a:4:{i:0;s:16:\"template_process\";i:1;s:21:\"template_process_html\";i:2;s:14:\"ctools_process\";i:3;s:23:\"forum_plus_process_html\";}}s:16:\"maintenance_page\";a:7:{s:8:\"template\";s:16:\"maintenance-page\";s:4:\"path\";s:31:\"sites/all/themes/forum_plus/tpl\";s:4:\"type\";s:12:\"theme_engine\";s:10:\"theme path\";s:27:\"sites/all/themes/forum_plus\";s:9:\"variables\";a:2:{s:7:\"content\";N;s:13:\"show_messages\";b:1;}s:20:\"preprocess functions\";a:5:{i:0;s:19:\"template_preprocess\";i:1;s:36:\"template_preprocess_maintenance_page\";i:2;s:21:\"contextual_preprocess\";i:3;s:35:\"overlay_preprocess_maintenance_page\";i:4;s:38:\"forum_plus_preprocess_maintenance_page\";}s:17:\"process functions\";a:3:{i:0;s:16:\"template_process\";i:1;s:33:\"template_process_maintenance_page\";i:2;s:14:\"ctools_process\";}}s:4:\"node\";a:7:{s:8:\"template\";s:4:\"node\";s:4:\"path\";s:31:\"sites/all/themes/forum_plus/tpl\";s:4:\"type\";s:12:\"theme_engine\";s:10:\"theme path\";s:27:\"sites/all/themes/forum_plus\";s:14:\"render element\";s:8:\"elements\";s:20:\"preprocess functions\";a:10:{i:0;s:19:\"template_preprocess\";i:1;s:24:\"template_preprocess_node\";i:2;s:21:\"contextual_preprocess\";i:3;s:22:\"ctools_preprocess_node\";i:4;s:26:\"node_class_preprocess_node\";i:5;s:39:\"shortcode_embed_content_preprocess_node\";i:6;s:21:\"views_preprocess_node\";i:7;s:30:\"advanced_forum_preprocess_node\";i:8;s:26:\"forum_plus_preprocess_node\";i:10;s:31:\"field_group_build_entity_groups\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:4:\"page\";a:7:{s:8:\"template\";s:4:\"page\";s:4:\"path\";s:31:\"sites/all/themes/forum_plus/tpl\";s:4:\"type\";s:12:\"theme_engine\";s:10:\"theme path\";s:27:\"sites/all/themes/forum_plus\";s:14:\"render element\";s:4:\"page\";s:20:\"preprocess functions\";a:9:{i:0;s:19:\"template_preprocess\";i:1;s:24:\"template_preprocess_page\";i:2;s:21:\"contextual_preprocess\";i:3;s:19:\"faq_preprocess_page\";i:4;s:23:\"overlay_preprocess_page\";i:5;s:24:\"shortcut_preprocess_page\";i:6;s:21:\"views_preprocess_page\";i:7;s:30:\"advanced_forum_preprocess_page\";i:8;s:26:\"forum_plus_preprocess_page\";}s:17:\"process functions\";a:3:{i:0;s:16:\"template_process\";i:1;s:21:\"template_process_page\";i:2;s:14:\"ctools_process\";}}s:16:\"views_view__page\";a:6:{s:8:\"template\";s:16:\"views-view--page\";s:4:\"path\";s:31:\"sites/all/themes/forum_plus/tpl\";s:9:\"variables\";a:2:{s:10:\"view_array\";a:0:{}s:4:\"view\";N;}s:9:\"base hook\";s:10:\"views_view\";s:4:\"type\";s:12:\"theme_engine\";s:10:\"theme path\";s:27:\"sites/all/themes/forum_plus\";}s:9:\"html__404\";a:6:{s:8:\"template\";s:9:\"html--404\";s:4:\"path\";s:31:\"sites/all/themes/forum_plus/tpl\";s:14:\"render element\";s:4:\"page\";s:9:\"base hook\";s:4:\"html\";s:4:\"type\";s:12:\"theme_engine\";s:10:\"theme path\";s:27:\"sites/all/themes/forum_plus\";}s:13:\"node__article\";a:6:{s:8:\"template\";s:13:\"node--article\";s:4:\"path\";s:31:\"sites/all/themes/forum_plus/tpl\";s:14:\"render element\";s:8:\"elements\";s:9:\"base hook\";s:4:\"node\";s:4:\"type\";s:12:\"theme_engine\";s:10:\"theme path\";s:27:\"sites/all/themes/forum_plus\";}s:10:\"node__blog\";a:6:{s:8:\"template\";s:10:\"node--blog\";s:4:\"path\";s:31:\"sites/all/themes/forum_plus/tpl\";s:14:\"render element\";s:8:\"elements\";s:9:\"base hook\";s:4:\"node\";s:4:\"type\";s:12:\"theme_engine\";s:10:\"theme path\";s:27:\"sites/all/themes/forum_plus\";}s:11:\"node__video\";a:6:{s:8:\"template\";s:11:\"node--video\";s:4:\"path\";s:31:\"sites/all/themes/forum_plus/tpl\";s:14:\"render element\";s:8:\"elements\";s:9:\"base hook\";s:4:\"node\";s:4:\"type\";s:12:\"theme_engine\";s:10:\"theme path\";s:27:\"sites/all/themes/forum_plus\";}s:16:\"admin_menu_links\";a:4:{s:14:\"render element\";s:8:\"elements\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:28:\"sites/all/modules/admin_menu\";s:8:\"function\";s:22:\"theme_admin_menu_links\";}s:15:\"admin_menu_icon\";a:7:{s:9:\"variables\";a:2:{s:3:\"src\";N;s:3:\"alt\";N;}s:4:\"file\";s:14:\"admin_menu.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:28:\"sites/all/modules/admin_menu\";s:8:\"function\";s:21:\"theme_admin_menu_icon\";s:8:\"includes\";a:1:{i:0;s:43:\"sites/all/modules/admin_menu/admin_menu.inc\";}s:20:\"preprocess functions\";a:1:{i:0;s:35:\"template_preprocess_admin_menu_icon\";}}s:22:\"features_module_status\";a:7:{s:9:\"variables\";a:2:{s:6:\"module\";N;s:6:\"status\";N;}s:4:\"path\";s:32:\"sites/all/modules/features/theme\";s:4:\"file\";s:9:\"theme.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:26:\"sites/all/modules/features\";s:8:\"function\";s:28:\"theme_features_module_status\";s:8:\"includes\";a:1:{i:0;s:42:\"sites/all/modules/features/theme/theme.inc\";}}s:19:\"features_components\";a:7:{s:9:\"variables\";a:2:{s:4:\"info\";N;s:7:\"sources\";N;}s:4:\"path\";s:32:\"sites/all/modules/features/theme\";s:4:\"file\";s:9:\"theme.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:26:\"sites/all/modules/features\";s:8:\"function\";s:25:\"theme_features_components\";s:8:\"includes\";a:1:{i:0;s:42:\"sites/all/modules/features/theme/theme.inc\";}}s:22:\"features_component_key\";a:6:{s:4:\"path\";s:32:\"sites/all/modules/features/theme\";s:4:\"file\";s:9:\"theme.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:26:\"sites/all/modules/features\";s:8:\"function\";s:28:\"theme_features_component_key\";s:8:\"includes\";a:1:{i:0;s:42:\"sites/all/modules/features/theme/theme.inc\";}}s:23:\"features_component_list\";a:7:{s:9:\"variables\";a:3:{s:10:\"components\";a:0:{}s:6:\"source\";a:0:{}s:9:\"conflicts\";a:0:{}}s:4:\"path\";s:32:\"sites/all/modules/features/theme\";s:4:\"file\";s:9:\"theme.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:26:\"sites/all/modules/features\";s:8:\"function\";s:29:\"theme_features_component_list\";s:8:\"includes\";a:1:{i:0;s:42:\"sites/all/modules/features/theme/theme.inc\";}}s:21:\"features_storage_link\";a:7:{s:9:\"variables\";a:4:{s:7:\"storage\";N;s:4:\"text\";N;s:4:\"path\";N;s:7:\"options\";a:0:{}}s:4:\"path\";s:32:\"sites/all/modules/features/theme\";s:4:\"file\";s:9:\"theme.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:26:\"sites/all/modules/features\";s:8:\"function\";s:27:\"theme_features_storage_link\";s:8:\"includes\";a:1:{i:0;s:42:\"sites/all/modules/features/theme/theme.inc\";}}s:18:\"features_lock_link\";a:7:{s:9:\"variables\";a:3:{s:7:\"feature\";N;s:9:\"component\";N;s:6:\"locked\";b:0;}s:4:\"path\";s:32:\"sites/all/modules/features/theme\";s:4:\"file\";s:9:\"theme.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:26:\"sites/all/modules/features\";s:8:\"function\";s:24:\"theme_features_lock_link\";s:8:\"includes\";a:1:{i:0;s:42:\"sites/all/modules/features/theme/theme.inc\";}}s:21:\"features_form_package\";a:7:{s:14:\"render element\";s:4:\"form\";s:4:\"path\";s:32:\"sites/all/modules/features/theme\";s:4:\"file\";s:9:\"theme.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:26:\"sites/all/modules/features\";s:8:\"function\";s:27:\"theme_features_form_package\";s:8:\"includes\";a:1:{i:0;s:42:\"sites/all/modules/features/theme/theme.inc\";}}s:20:\"features_form_export\";a:7:{s:14:\"render element\";s:4:\"form\";s:4:\"path\";s:32:\"sites/all/modules/features/theme\";s:4:\"file\";s:9:\"theme.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:26:\"sites/all/modules/features\";s:8:\"function\";s:26:\"theme_features_form_export\";s:8:\"includes\";a:1:{i:0;s:42:\"sites/all/modules/features/theme/theme.inc\";}}s:24:\"features_form_components\";a:7:{s:14:\"render element\";s:4:\"form\";s:4:\"path\";s:32:\"sites/all/modules/features/theme\";s:4:\"file\";s:9:\"theme.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:26:\"sites/all/modules/features\";s:8:\"function\";s:30:\"theme_features_form_components\";s:8:\"includes\";a:1:{i:0;s:42:\"sites/all/modules/features/theme/theme.inc\";}}s:21:\"features_form_buttons\";a:7:{s:14:\"render element\";s:7:\"element\";s:4:\"path\";s:32:\"sites/all/modules/features/theme\";s:4:\"file\";s:9:\"theme.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:26:\"sites/all/modules/features\";s:8:\"function\";s:27:\"theme_features_form_buttons\";s:8:\"includes\";a:1:{i:0;s:42:\"sites/all/modules/features/theme/theme.inc\";}}s:25:\"features_admin_components\";a:9:{s:14:\"render element\";s:4:\"form\";s:8:\"template\";s:25:\"features-admin-components\";s:4:\"path\";s:32:\"sites/all/modules/features/theme\";s:4:\"file\";s:9:\"theme.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:26:\"sites/all/modules/features\";s:8:\"includes\";a:1:{i:0;s:42:\"sites/all/modules/features/theme/theme.inc\";}s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:45:\"template_preprocess_features_admin_components\";i:2;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:26:\"advanced_forum_topic_pager\";a:7:{s:8:\"template\";s:32:\"advanced-forum.naked.topic-pager\";s:4:\"path\";s:45:\"sites/all/modules/advanced_forum/styles/naked\";s:9:\"variables\";a:2:{s:9:\"pagecount\";N;s:5:\"topic\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/advanced_forum\";s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:21:\"contextual_preprocess\";i:2;s:52:\"advanced_forum_preprocess_advanced_forum_topic_pager\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:28:\"advanced_forum_active_poster\";a:7:{s:8:\"template\";s:34:\"advanced-forum.naked.active-poster\";s:4:\"path\";s:45:\"sites/all/modules/advanced_forum/styles/naked\";s:9:\"variables\";a:5:{s:5:\"forum\";N;s:7:\"account\";N;s:5:\"posts\";N;s:6:\"topics\";N;s:9:\"last_post\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/advanced_forum\";s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:21:\"contextual_preprocess\";i:2;s:54:\"advanced_forum_preprocess_advanced_forum_active_poster\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:36:\"advanced_forum_topic_list_outer_view\";a:6:{s:8:\"template\";s:42:\"advanced-forum.naked.topic-list-outer-view\";s:4:\"path\";s:45:\"sites/all/modules/advanced_forum/styles/naked\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/advanced_forum\";s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:19:\"advanced_forum_post\";a:6:{s:8:\"template\";s:25:\"advanced-forum.naked.post\";s:4:\"path\";s:45:\"sites/all/modules/advanced_forum/styles/naked\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/advanced_forum\";s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:28:\"advanced_forum_search_result\";a:6:{s:8:\"template\";s:34:\"advanced-forum.naked.search-result\";s:4:\"path\";s:45:\"sites/all/modules/advanced_forum/styles/naked\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/advanced_forum\";s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:25:\"advanced_forum_topic_icon\";a:6:{s:8:\"template\";s:31:\"advanced-forum.naked.topic-icon\";s:4:\"path\";s:45:\"sites/all/modules/advanced_forum/styles/naked\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/advanced_forum\";s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:21:\"advanced_forum_forums\";a:6:{s:8:\"template\";s:27:\"advanced-forum.naked.forums\";s:4:\"path\";s:45:\"sites/all/modules/advanced_forum/styles/naked\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/advanced_forum\";s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:27:\"advanced_forum_search_topic\";a:6:{s:8:\"template\";s:33:\"advanced-forum.naked.search-topic\";s:4:\"path\";s:45:\"sites/all/modules/advanced_forum/styles/naked\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/advanced_forum\";s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:21:\"contextual_preprocess\";i:2;s:53:\"advanced_forum_preprocess_advanced_forum_search_topic\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:26:\"advanced_forum_post_edited\";a:7:{s:8:\"template\";s:32:\"advanced-forum.naked.post-edited\";s:4:\"path\";s:45:\"sites/all/modules/advanced_forum/styles/naked\";s:9:\"variables\";a:3:{s:3:\"who\";N;s:4:\"when\";N;s:3:\"why\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/advanced_forum\";s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:21:\"contextual_preprocess\";i:2;s:52:\"advanced_forum_preprocess_advanced_forum_post_edited\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:25:\"advanced_forum_topic_list\";a:6:{s:8:\"template\";s:31:\"advanced-forum.naked.topic-list\";s:4:\"path\";s:45:\"sites/all/modules/advanced_forum/styles/naked\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/advanced_forum\";s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:25:\"advanced_forum_forum_list\";a:6:{s:8:\"template\";s:31:\"advanced-forum.naked.forum-list\";s:4:\"path\";s:45:\"sites/all/modules/advanced_forum/styles/naked\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/advanced_forum\";s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:30:\"advanced_forum_topic_list_view\";a:9:{s:8:\"template\";s:36:\"advanced-forum.naked.topic-list-view\";s:4:\"path\";s:45:\"sites/all/modules/advanced_forum/styles/naked\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/advanced_forum\";s:8:\"includes\";a:1:{i:0;s:51:\"sites/all/modules/advanced_forum/includes/theme.inc\";}s:7:\"pattern\";s:32:\"advanced_forum_topic_list_view__\";s:9:\"variables\";a:4:{s:4:\"view\";N;s:7:\"options\";N;s:4:\"rows\";N;s:5:\"title\";N;}s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:50:\"template_preprocess_advanced_forum_topic_list_view\";i:2;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:27:\"advanced_forum_topic_legend\";a:6:{s:8:\"template\";s:32:\"advanced-forum.plus.topic-legend\";s:4:\"path\";s:51:\"sites/all/themes/forum_plus/css/advanced_forum/plus\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/advanced_forum\";s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:21:\"contextual_preprocess\";i:2;s:53:\"advanced_forum_preprocess_advanced_forum_topic_legend\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:27:\"advanced_forum_topic_header\";a:7:{s:8:\"template\";s:33:\"advanced-forum.naked.topic-header\";s:4:\"path\";s:45:\"sites/all/modules/advanced_forum/styles/naked\";s:9:\"variables\";a:2:{s:4:\"node\";N;s:13:\"comment_count\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/advanced_forum\";s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:21:\"contextual_preprocess\";i:2;s:53:\"advanced_forum_preprocess_advanced_forum_topic_header\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:28:\"advanced_forum_post_repeated\";a:6:{s:8:\"template\";s:34:\"advanced-forum.naked.post-repeated\";s:4:\"path\";s:45:\"sites/all/modules/advanced_forum/styles/naked\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/advanced_forum\";s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:24:\"advanced_forum_submitted\";a:6:{s:8:\"template\";s:30:\"advanced-forum.naked.submitted\";s:4:\"path\";s:45:\"sites/all/modules/advanced_forum/styles/naked\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/advanced_forum\";s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:27:\"advanced_forum_search_forum\";a:6:{s:8:\"template\";s:33:\"advanced-forum.naked.search-forum\";s:4:\"path\";s:45:\"sites/all/modules/advanced_forum/styles/naked\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/advanced_forum\";s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:21:\"contextual_preprocess\";i:2;s:53:\"advanced_forum_preprocess_advanced_forum_search_forum\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:25:\"advanced_forum_statistics\";a:6:{s:8:\"template\";s:31:\"advanced-forum.naked.statistics\";s:4:\"path\";s:45:\"sites/all/modules/advanced_forum/styles/naked\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/advanced_forum\";s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:21:\"contextual_preprocess\";i:2;s:51:\"advanced_forum_preprocess_advanced_forum_statistics\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:26:\"advanced_forum_author_pane\";a:6:{s:8:\"template\";s:31:\"advanced-forum.plus.author-pane\";s:4:\"path\";s:51:\"sites/all/themes/forum_plus/css/advanced_forum/plus\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/advanced_forum\";s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:27:\"advanced_forum_post_preview\";a:6:{s:8:\"template\";s:33:\"advanced-forum.naked.post-preview\";s:4:\"path\";s:45:\"sites/all/modules/advanced_forum/styles/naked\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/advanced_forum\";s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:27:\"advanced_forum_shadow_topic\";a:7:{s:8:\"template\";s:33:\"advanced-forum.naked.shadow-topic\";s:4:\"path\";s:45:\"sites/all/modules/advanced_forum/styles/naked\";s:9:\"variables\";a:3:{s:5:\"title\";N;s:3:\"nid\";N;s:9:\"new_forum\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/advanced_forum\";s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:21:\"contextual_preprocess\";i:2;s:53:\"advanced_forum_preprocess_advanced_forum_shadow_topic\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:27:\"advanced_forum_forum_legend\";a:6:{s:8:\"template\";s:32:\"advanced-forum.plus.forum-legend\";s:4:\"path\";s:51:\"sites/all/themes/forum_plus/css/advanced_forum/plus\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/advanced_forum\";s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:21:\"contextual_preprocess\";i:2;s:53:\"advanced_forum_preprocess_advanced_forum_forum_legend\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:30:\"advanced_forum_comment_wrapper\";a:6:{s:8:\"template\";s:36:\"advanced-forum.naked.comment-wrapper\";s:4:\"path\";s:45:\"sites/all/modules/advanced_forum/styles/naked\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/advanced_forum\";s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:42:\"advanced_forum_group_topic_list_outer_view\";a:6:{s:8:\"template\";s:48:\"advanced-forum.naked.group-topic-list-outer-view\";s:4:\"path\";s:45:\"sites/all/modules/advanced_forum/styles/naked\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/advanced_forum\";s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:16:\"advanced_forum_l\";a:4:{s:9:\"variables\";a:4:{s:4:\"text\";N;s:4:\"path\";N;s:7:\"options\";a:0:{}s:12:\"button_class\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/advanced_forum\";s:8:\"function\";s:22:\"theme_advanced_forum_l\";}s:27:\"advanced_forum_user_picture\";a:4:{s:9:\"variables\";a:1:{s:7:\"account\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/advanced_forum\";s:8:\"function\";s:33:\"theme_advanced_forum_user_picture\";}s:25:\"advanced_forum_reply_link\";a:4:{s:9:\"variables\";a:1:{s:4:\"node\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/advanced_forum\";s:8:\"function\";s:31:\"theme_advanced_forum_reply_link\";}s:28:\"advanced_forum_subforum_list\";a:4:{s:9:\"variables\";a:1:{s:13:\"subforum_list\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/advanced_forum\";s:8:\"function\";s:34:\"theme_advanced_forum_subforum_list\";}s:32:\"advanced_forum_subcontainer_list\";a:4:{s:9:\"variables\";a:1:{s:17:\"subcontainer_list\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/advanced_forum\";s:8:\"function\";s:38:\"theme_advanced_forum_subcontainer_list\";}s:33:\"advanced_forum_simple_author_pane\";a:4:{s:9:\"variables\";a:1:{s:7:\"context\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/advanced_forum\";s:8:\"function\";s:39:\"theme_advanced_forum_simple_author_pane\";}s:36:\"advanced_forum_node_type_create_list\";a:4:{s:9:\"variables\";a:1:{s:8:\"forum_id\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/advanced_forum\";s:8:\"function\";s:42:\"theme_advanced_forum_node_type_create_list\";}s:37:\"views_view__advanced_forum_topic_list\";a:6:{s:9:\"variables\";a:1:{s:4:\"view\";N;}s:8:\"template\";s:69:\"sites/all/modules/advanced_forum/advanced-forum-topic-list-outer-view\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/advanced_forum\";s:20:\"preprocess functions\";a:4:{i:0;s:19:\"template_preprocess\";i:1;s:30:\"template_preprocess_views_view\";i:2;s:21:\"contextual_preprocess\";i:3;s:63:\"advanced_forum_preprocess_views_view__advanced_forum_topic_list\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:43:\"views_view__advanced_forum_group_topic_list\";a:6:{s:9:\"variables\";a:1:{s:4:\"view\";N;}s:8:\"template\";s:75:\"sites/all/modules/advanced_forum/advanced-forum-group-topic-list-outer-view\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:32:\"sites/all/modules/advanced_forum\";s:20:\"preprocess functions\";a:4:{i:0;s:19:\"template_preprocess\";i:1;s:30:\"template_preprocess_views_view\";i:2;s:21:\"contextual_preprocess\";i:3;s:69:\"advanced_forum_preprocess_views_view__advanced_forum_group_topic_list\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:16:\"views_mini_pager\";a:8:{s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:29:\"sites/all/modules/views/theme\";s:9:\"variables\";a:3:{s:4:\"tags\";a:0:{}s:7:\"element\";i:0;s:10:\"parameters\";a:0:{}}s:7:\"pattern\";s:18:\"views_mini_pager__\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:23:\"sites/all/modules/views\";s:8:\"function\";s:22:\"theme_views_mini_pager\";s:8:\"includes\";a:1:{i:0;s:39:\"sites/all/modules/views/theme/theme.inc\";}}s:16:\"views_view_field\";a:9:{s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:29:\"sites/all/modules/views/theme\";s:7:\"pattern\";s:18:\"views_view_field__\";s:9:\"variables\";a:3:{s:4:\"view\";N;s:5:\"field\";N;s:3:\"row\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:23:\"sites/all/modules/views\";s:8:\"function\";s:22:\"theme_views_view_field\";s:8:\"includes\";a:1:{i:0;s:39:\"sites/all/modules/views/theme/theme.inc\";}s:20:\"preprocess functions\";a:1:{i:0;s:36:\"template_preprocess_views_view_field\";}}s:19:\"views_view_grouping\";a:9:{s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:29:\"sites/all/modules/views/theme\";s:7:\"pattern\";s:21:\"views_view_grouping__\";s:9:\"variables\";a:5:{s:4:\"view\";N;s:8:\"grouping\";N;s:14:\"grouping_level\";N;s:4:\"rows\";N;s:5:\"title\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:23:\"sites/all/modules/views\";s:8:\"function\";s:25:\"theme_views_view_grouping\";s:8:\"includes\";a:1:{i:0;s:39:\"sites/all/modules/views/theme/theme.inc\";}s:20:\"preprocess functions\";a:1:{i:0;s:39:\"template_preprocess_views_view_grouping\";}}s:10:\"views_view\";a:10:{s:7:\"pattern\";s:12:\"views_view__\";s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:29:\"sites/all/modules/views/theme\";s:9:\"variables\";a:2:{s:10:\"view_array\";a:0:{}s:4:\"view\";N;}s:8:\"template\";s:10:\"views-view\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:23:\"sites/all/modules/views\";s:8:\"includes\";a:1:{i:0;s:39:\"sites/all/modules/views/theme/theme.inc\";}s:20:\"preprocess functions\";a:5:{i:0;s:19:\"template_preprocess\";i:1;s:30:\"template_preprocess_views_view\";i:2;s:21:\"contextual_preprocess\";i:3;s:32:\"date_views_preprocess_views_view\";i:4;s:30:\"views_ui_preprocess_views_view\";}s:17:\"process functions\";a:3:{i:0;s:16:\"template_process\";i:1;s:27:\"template_process_views_view\";i:2;s:14:\"ctools_process\";}}s:14:\"calendar_style\";a:10:{s:7:\"pattern\";s:16:\"calendar_style__\";s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:32:\"sites/all/modules/calendar/theme\";s:9:\"variables\";a:4:{s:4:\"view\";N;s:7:\"options\";N;s:4:\"rows\";N;s:5:\"title\";N;}s:8:\"template\";s:14:\"calendar-style\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:23:\"sites/all/modules/views\";s:8:\"includes\";a:1:{i:0;s:42:\"sites/all/modules/calendar/theme/theme.inc\";}s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:34:\"template_preprocess_calendar_style\";i:2;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:13:\"calendar_mini\";a:10:{s:7:\"pattern\";s:15:\"calendar_mini__\";s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:32:\"sites/all/modules/calendar/theme\";s:9:\"variables\";a:4:{s:4:\"view\";N;s:7:\"options\";N;s:4:\"rows\";N;s:5:\"title\";N;}s:8:\"template\";s:13:\"calendar-mini\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:23:\"sites/all/modules/views\";s:8:\"includes\";a:1:{i:0;s:42:\"sites/all/modules/calendar/theme/theme.inc\";}s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:33:\"template_preprocess_calendar_mini\";i:2;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:12:\"calendar_day\";a:10:{s:7:\"pattern\";s:14:\"calendar_day__\";s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:32:\"sites/all/modules/calendar/theme\";s:9:\"variables\";a:4:{s:4:\"view\";N;s:7:\"options\";N;s:4:\"rows\";N;s:5:\"title\";N;}s:8:\"template\";s:12:\"calendar-day\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:23:\"sites/all/modules/views\";s:8:\"includes\";a:1:{i:0;s:42:\"sites/all/modules/calendar/theme/theme.inc\";}s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:32:\"template_preprocess_calendar_day\";i:2;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:13:\"calendar_week\";a:10:{s:7:\"pattern\";s:15:\"calendar_week__\";s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:32:\"sites/all/modules/calendar/theme\";s:9:\"variables\";a:4:{s:4:\"view\";N;s:7:\"options\";N;s:4:\"rows\";N;s:5:\"title\";N;}s:8:\"template\";s:13:\"calendar-week\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:23:\"sites/all/modules/views\";s:8:\"includes\";a:1:{i:0;s:42:\"sites/all/modules/calendar/theme/theme.inc\";}s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:33:\"template_preprocess_calendar_week\";i:2;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:14:\"calendar_month\";a:10:{s:7:\"pattern\";s:16:\"calendar_month__\";s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:32:\"sites/all/modules/calendar/theme\";s:9:\"variables\";a:4:{s:4:\"view\";N;s:7:\"options\";N;s:4:\"rows\";N;s:5:\"title\";N;}s:8:\"template\";s:14:\"calendar-month\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:23:\"sites/all/modules/views\";s:8:\"includes\";a:1:{i:0;s:42:\"sites/all/modules/calendar/theme/theme.inc\";}s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:34:\"template_preprocess_calendar_month\";i:2;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:13:\"calendar_year\";a:10:{s:7:\"pattern\";s:15:\"calendar_year__\";s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:32:\"sites/all/modules/calendar/theme\";s:9:\"variables\";a:4:{s:4:\"view\";N;s:7:\"options\";N;s:4:\"rows\";N;s:5:\"title\";N;}s:8:\"template\";s:13:\"calendar-year\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:23:\"sites/all/modules/views\";s:8:\"includes\";a:1:{i:0;s:42:\"sites/all/modules/calendar/theme/theme.inc\";}s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:33:\"template_preprocess_calendar_year\";i:2;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:20:\"calendar_day_overlap\";a:10:{s:7:\"pattern\";s:22:\"calendar_day_overlap__\";s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:32:\"sites/all/modules/calendar/theme\";s:9:\"variables\";a:4:{s:4:\"view\";N;s:7:\"options\";N;s:4:\"rows\";N;s:5:\"title\";N;}s:8:\"template\";s:20:\"calendar-day-overlap\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:23:\"sites/all/modules/views\";s:8:\"includes\";a:1:{i:0;s:42:\"sites/all/modules/calendar/theme/theme.inc\";}s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:40:\"template_preprocess_calendar_day_overlap\";i:2;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:21:\"calendar_week_overlap\";a:10:{s:7:\"pattern\";s:23:\"calendar_week_overlap__\";s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:32:\"sites/all/modules/calendar/theme\";s:9:\"variables\";a:4:{s:4:\"view\";N;s:7:\"options\";N;s:4:\"rows\";N;s:5:\"title\";N;}s:8:\"template\";s:21:\"calendar-week-overlap\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:23:\"sites/all/modules/views\";s:8:\"includes\";a:1:{i:0;s:42:\"sites/all/modules/calendar/theme/theme.inc\";}s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:41:\"template_preprocess_calendar_week_overlap\";i:2;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:15:\"date_navigation\";a:10:{s:7:\"pattern\";s:17:\"date_navigation__\";s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:39:\"sites/all/modules/date/date_views/theme\";s:9:\"variables\";a:4:{s:4:\"view\";N;s:7:\"options\";N;s:4:\"rows\";N;s:5:\"title\";N;}s:8:\"template\";s:15:\"date-navigation\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:23:\"sites/all/modules/views\";s:8:\"includes\";a:1:{i:0;s:49:\"sites/all/modules/date/date_views/theme/theme.inc\";}s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:22:\"views_view_unformatted\";a:10:{s:7:\"pattern\";s:24:\"views_view_unformatted__\";s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:29:\"sites/all/modules/views/theme\";s:9:\"variables\";a:4:{s:4:\"view\";N;s:7:\"options\";N;s:4:\"rows\";N;s:5:\"title\";N;}s:8:\"template\";s:22:\"views-view-unformatted\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:23:\"sites/all/modules/views\";s:8:\"includes\";a:1:{i:0;s:39:\"sites/all/modules/views/theme/theme.inc\";}s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:42:\"template_preprocess_views_view_unformatted\";i:2;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:16:\"flexslider_views\";a:10:{s:7:\"pattern\";s:18:\"flexslider_views__\";s:4:\"file\";s:26:\"flexslider_views.theme.inc\";s:4:\"path\";s:51:\"sites/all/modules/flexslider/flexslider_views/theme\";s:9:\"variables\";a:4:{s:4:\"view\";N;s:7:\"options\";N;s:4:\"rows\";N;s:5:\"title\";N;}s:8:\"template\";s:16:\"flexslider-views\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:23:\"sites/all/modules/views\";s:8:\"includes\";a:1:{i:0;s:78:\"sites/all/modules/flexslider/flexslider_views/theme/flexslider_views.theme.inc\";}s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:3:{i:0;s:16:\"template_process\";i:1;s:33:\"template_process_flexslider_views\";i:2;s:14:\"ctools_process\";}}s:14:\"quicktabs_view\";a:10:{s:7:\"pattern\";s:16:\"quicktabs_view__\";s:4:\"file\";s:19:\"quicktabs.views.inc\";s:4:\"path\";s:27:\"sites/all/modules/quicktabs\";s:9:\"variables\";a:4:{s:4:\"view\";N;s:7:\"options\";N;s:4:\"rows\";N;s:5:\"title\";N;}s:8:\"template\";s:14:\"quicktabs-view\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:23:\"sites/all/modules/views\";s:8:\"includes\";a:1:{i:0;s:47:\"sites/all/modules/quicktabs/quicktabs.views.inc\";}s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:15:\"views_slideshow\";a:10:{s:7:\"pattern\";s:17:\"views_slideshow__\";s:4:\"file\";s:25:\"views_slideshow.theme.inc\";s:4:\"path\";s:39:\"sites/all/modules/views_slideshow/theme\";s:9:\"variables\";a:4:{s:4:\"view\";N;s:7:\"options\";N;s:4:\"rows\";N;s:5:\"title\";N;}s:8:\"template\";s:15:\"views-slideshow\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:23:\"sites/all/modules/views\";s:8:\"includes\";a:1:{i:0;s:65:\"sites/all/modules/views_slideshow/theme/views_slideshow.theme.inc\";}s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:35:\"template_preprocess_views_slideshow\";i:2;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:15:\"views_view_list\";a:10:{s:7:\"pattern\";s:17:\"views_view_list__\";s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:29:\"sites/all/modules/views/theme\";s:9:\"variables\";a:4:{s:4:\"view\";N;s:7:\"options\";N;s:4:\"rows\";N;s:5:\"title\";N;}s:8:\"template\";s:15:\"views-view-list\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:23:\"sites/all/modules/views\";s:8:\"includes\";a:1:{i:0;s:39:\"sites/all/modules/views/theme/theme.inc\";}s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:35:\"template_preprocess_views_view_list\";i:2;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:16:\"views_view_table\";a:10:{s:7:\"pattern\";s:18:\"views_view_table__\";s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:29:\"sites/all/modules/views/theme\";s:9:\"variables\";a:4:{s:4:\"view\";N;s:7:\"options\";N;s:4:\"rows\";N;s:5:\"title\";N;}s:8:\"template\";s:16:\"views-view-table\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:23:\"sites/all/modules/views\";s:8:\"includes\";a:1:{i:0;s:39:\"sites/all/modules/views/theme/theme.inc\";}s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:36:\"template_preprocess_views_view_table\";i:2;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:18:\"views_view_summary\";a:10:{s:7:\"pattern\";s:20:\"views_view_summary__\";s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:29:\"sites/all/modules/views/theme\";s:9:\"variables\";a:4:{s:4:\"view\";N;s:7:\"options\";N;s:4:\"rows\";N;s:5:\"title\";N;}s:8:\"template\";s:18:\"views-view-summary\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:23:\"sites/all/modules/views\";s:8:\"includes\";a:1:{i:0;s:39:\"sites/all/modules/views/theme/theme.inc\";}s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:38:\"template_preprocess_views_view_summary\";i:2;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:30:\"views_view_summary_unformatted\";a:10:{s:7:\"pattern\";s:32:\"views_view_summary_unformatted__\";s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:29:\"sites/all/modules/views/theme\";s:9:\"variables\";a:4:{s:4:\"view\";N;s:7:\"options\";N;s:4:\"rows\";N;s:5:\"title\";N;}s:8:\"template\";s:30:\"views-view-summary-unformatted\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:23:\"sites/all/modules/views\";s:8:\"includes\";a:1:{i:0;s:39:\"sites/all/modules/views/theme/theme.inc\";}s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:50:\"template_preprocess_views_view_summary_unformatted\";i:2;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:14:\"views_view_rss\";a:10:{s:7:\"pattern\";s:16:\"views_view_rss__\";s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:29:\"sites/all/modules/views/theme\";s:9:\"variables\";a:4:{s:4:\"view\";N;s:7:\"options\";N;s:4:\"rows\";N;s:5:\"title\";N;}s:8:\"template\";s:14:\"views-view-rss\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:23:\"sites/all/modules/views\";s:8:\"includes\";a:1:{i:0;s:39:\"sites/all/modules/views/theme/theme.inc\";}s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:34:\"template_preprocess_views_view_rss\";i:2;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:28:\"views_view_summary_jump_menu\";a:10:{s:7:\"pattern\";s:30:\"views_view_summary_jump_menu__\";s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:29:\"sites/all/modules/views/theme\";s:9:\"variables\";a:4:{s:4:\"view\";N;s:7:\"options\";N;s:4:\"rows\";N;s:5:\"title\";N;}s:8:\"template\";s:28:\"views-view-summary-jump-menu\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:23:\"sites/all/modules/views\";s:8:\"includes\";a:1:{i:0;s:39:\"sites/all/modules/views/theme/theme.inc\";}s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:20:\"views_view_jump_menu\";a:10:{s:7:\"pattern\";s:22:\"views_view_jump_menu__\";s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:29:\"sites/all/modules/views/theme\";s:9:\"variables\";a:4:{s:4:\"view\";N;s:7:\"options\";N;s:4:\"rows\";N;s:5:\"title\";N;}s:8:\"template\";s:20:\"views-view-jump-menu\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:23:\"sites/all/modules/views\";s:8:\"includes\";a:1:{i:0;s:39:\"sites/all/modules/views/theme/theme.inc\";}s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:17:\"views_view_fields\";a:10:{s:7:\"pattern\";s:19:\"views_view_fields__\";s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:29:\"sites/all/modules/views/theme\";s:9:\"variables\";a:4:{s:4:\"view\";N;s:7:\"options\";N;s:3:\"row\";N;s:11:\"field_alias\";N;}s:8:\"template\";s:17:\"views-view-fields\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:27:\"sites/all/themes/forum_plus\";s:8:\"includes\";a:1:{i:0;s:39:\"sites/all/modules/views/theme/theme.inc\";}s:20:\"preprocess functions\";a:5:{i:0;s:19:\"template_preprocess\";i:1;s:37:\"template_preprocess_views_view_fields\";i:2;s:21:\"contextual_preprocess\";i:3;s:44:\"views_fieldsets_preprocess_views_view_fields\";i:4;s:39:\"forum_plus_preprocess_views_view_fields\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:22:\"views_view_row_comment\";a:10:{s:7:\"pattern\";s:24:\"views_view_row_comment__\";s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:29:\"sites/all/modules/views/theme\";s:9:\"variables\";a:4:{s:4:\"view\";N;s:7:\"options\";N;s:3:\"row\";N;s:11:\"field_alias\";N;}s:8:\"template\";s:22:\"views-view-row-comment\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:23:\"sites/all/modules/views\";s:8:\"includes\";a:1:{i:0;s:39:\"sites/all/modules/views/theme/theme.inc\";}s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:42:\"template_preprocess_views_view_row_comment\";i:2;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:18:\"views_view_row_rss\";a:10:{s:7:\"pattern\";s:20:\"views_view_row_rss__\";s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:29:\"sites/all/modules/views/theme\";s:9:\"variables\";a:4:{s:4:\"view\";N;s:7:\"options\";N;s:3:\"row\";N;s:11:\"field_alias\";N;}s:8:\"template\";s:18:\"views-view-row-rss\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:23:\"sites/all/modules/views\";s:8:\"includes\";a:1:{i:0;s:39:\"sites/all/modules/views/theme/theme.inc\";}s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:38:\"template_preprocess_views_view_row_rss\";i:2;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:21:\"views_form_views_form\";a:7:{s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:29:\"sites/all/modules/views/theme\";s:14:\"render element\";s:4:\"form\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:23:\"sites/all/modules/views\";s:8:\"function\";s:27:\"theme_views_form_views_form\";s:8:\"includes\";a:1:{i:0;s:39:\"sites/all/modules/views/theme/theme.inc\";}}s:18:\"views_exposed_form\";a:10:{s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:29:\"sites/all/modules/views/theme\";s:8:\"template\";s:18:\"views-exposed-form\";s:7:\"pattern\";s:20:\"views_exposed_form__\";s:14:\"render element\";s:4:\"form\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:23:\"sites/all/modules/views\";s:8:\"includes\";a:1:{i:0;s:39:\"sites/all/modules/views/theme/theme.inc\";}s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:38:\"template_preprocess_views_exposed_form\";i:2;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:10:\"views_more\";a:10:{s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:29:\"sites/all/modules/views/theme\";s:8:\"template\";s:10:\"views-more\";s:7:\"pattern\";s:12:\"views_more__\";s:9:\"variables\";a:3:{s:8:\"more_url\";N;s:9:\"link_text\";s:4:\"more\";s:4:\"view\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:23:\"sites/all/modules/views\";s:8:\"includes\";a:1:{i:0;s:39:\"sites/all/modules/views/theme/theme.inc\";}s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:6:\"forums\";a:6:{s:8:\"template\";s:20:\"modules/forum/forums\";s:9:\"variables\";a:6:{s:6:\"forums\";N;s:6:\"topics\";N;s:7:\"parents\";N;s:3:\"tid\";N;s:6:\"sortby\";N;s:14:\"forum_per_page\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:13:\"modules/forum\";s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:2;s:21:\"contextual_preprocess\";i:3;s:32:\"advanced_forum_preprocess_forums\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:10:\"forum_list\";a:6:{s:8:\"template\";s:24:\"modules/forum/forum-list\";s:9:\"variables\";a:3:{s:6:\"forums\";N;s:7:\"parents\";N;s:3:\"tid\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:13:\"modules/forum\";s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:2;s:21:\"contextual_preprocess\";i:3;s:36:\"advanced_forum_preprocess_forum_list\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:16:\"forum_topic_list\";a:6:{s:8:\"template\";s:30:\"modules/forum/forum-topic-list\";s:9:\"variables\";a:4:{s:3:\"tid\";N;s:6:\"topics\";N;s:6:\"sortby\";N;s:14:\"forum_per_page\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:13:\"modules/forum\";s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:2;s:21:\"contextual_preprocess\";i:3;s:42:\"advanced_forum_preprocess_forum_topic_list\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:10:\"forum_icon\";a:6:{s:8:\"template\";s:24:\"modules/forum/forum-icon\";s:9:\"variables\";a:5:{s:9:\"new_posts\";N;s:9:\"num_posts\";i:0;s:12:\"comment_mode\";i:0;s:6:\"sticky\";i:0;s:9:\"first_new\";b:0;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:13:\"modules/forum\";s:20:\"preprocess functions\";a:4:{i:0;s:19:\"template_preprocess\";i:1;s:30:\"template_preprocess_forum_icon\";i:2;s:21:\"contextual_preprocess\";i:3;s:36:\"advanced_forum_preprocess_forum_icon\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:15:\"forum_submitted\";a:6:{s:8:\"template\";s:29:\"modules/forum/forum-submitted\";s:9:\"variables\";a:1:{s:5:\"topic\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:13:\"modules/forum\";s:20:\"preprocess functions\";a:4:{i:0;s:19:\"template_preprocess\";i:1;s:35:\"template_preprocess_forum_submitted\";i:2;s:21:\"contextual_preprocess\";i:3;s:41:\"advanced_forum_preprocess_forum_submitted\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:10:\"forum_form\";a:6:{s:14:\"render element\";s:4:\"form\";s:4:\"file\";s:15:\"forum.admin.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:13:\"modules/forum\";s:8:\"function\";s:16:\"theme_forum_form\";s:8:\"includes\";a:1:{i:0;s:29:\"modules/forum/forum.admin.inc\";}}s:15:\"horizontal_tabs\";a:4:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:29:\"sites/all/modules/field_group\";s:8:\"function\";s:21:\"theme_horizontal_tabs\";}s:9:\"multipage\";a:4:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:29:\"sites/all/modules/field_group\";s:8:\"function\";s:15:\"theme_multipage\";}s:14:\"multipage_pane\";a:4:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:29:\"sites/all/modules/field_group\";s:8:\"function\";s:20:\"theme_multipage_pane\";}s:33:\"we_content_migration_form_package\";a:7:{s:14:\"render element\";s:4:\"form\";s:4:\"path\";s:44:\"sites/all/modules/we_content_migration/theme\";s:4:\"file\";s:9:\"theme.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:38:\"sites/all/modules/we_content_migration\";s:8:\"function\";s:39:\"theme_we_content_migration_form_package\";s:8:\"includes\";a:1:{i:0;s:54:\"sites/all/modules/we_content_migration/theme/theme.inc\";}}s:17:\"shortcode_tooltip\";a:4:{s:9:\"variables\";a:6:{s:2:\"id\";s:0:\"\";s:5:\"class\";s:0:\"\";s:9:\"placement\";s:0:\"\";s:5:\"title\";s:0:\"\";s:3:\"tag\";s:0:\"\";s:4:\"text\";s:0:\"\";}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/wee_shortcode\";s:8:\"function\";s:23:\"theme_shortcode_tooltip\";}s:18:\"shortcode_collapse\";a:7:{s:9:\"variables\";a:2:{s:10:\"accordions\";s:0:\"\";s:2:\"id\";s:0:\"\";}s:8:\"template\";s:8:\"collapse\";s:4:\"path\";s:35:\"sites/all/modules/wee_shortcode/tpl\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/wee_shortcode\";s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:28:\"views_ui_display_tab_setting\";a:7:{s:9:\"variables\";a:7:{s:11:\"description\";s:0:\"\";s:4:\"link\";s:0:\"\";s:14:\"settings_links\";a:0:{}s:10:\"overridden\";b:0;s:9:\"defaulted\";b:0;s:21:\"description_separator\";b:1;s:5:\"class\";a:0:{}}s:8:\"template\";s:28:\"views-ui-display-tab-setting\";s:4:\"path\";s:29:\"sites/all/modules/views/theme\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:23:\"sites/all/modules/views\";s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:48:\"template_preprocess_views_ui_display_tab_setting\";i:2;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:27:\"views_ui_display_tab_bucket\";a:7:{s:14:\"render element\";s:7:\"element\";s:8:\"template\";s:27:\"views-ui-display-tab-bucket\";s:4:\"path\";s:29:\"sites/all/modules/views/theme\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:23:\"sites/all/modules/views\";s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:47:\"template_preprocess_views_ui_display_tab_bucket\";i:2;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:23:\"views_ui_rearrange_form\";a:4:{s:14:\"render element\";s:4:\"form\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:23:\"sites/all/modules/views\";s:8:\"function\";s:29:\"theme_views_ui_rearrange_form\";}s:30:\"views_ui_rearrange_filter_form\";a:6:{s:14:\"render element\";s:4:\"form\";s:4:\"file\";s:18:\"includes/admin.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:23:\"sites/all/modules/views\";s:8:\"function\";s:36:\"theme_views_ui_rearrange_filter_form\";s:8:\"includes\";a:1:{i:0;s:42:\"sites/all/modules/views/includes/admin.inc\";}}s:27:\"views_ui_expose_filter_form\";a:6:{s:14:\"render element\";s:4:\"form\";s:4:\"file\";s:18:\"includes/admin.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:23:\"sites/all/modules/views\";s:8:\"function\";s:33:\"theme_views_ui_expose_filter_form\";s:8:\"includes\";a:1:{i:0;s:42:\"sites/all/modules/views/includes/admin.inc\";}}s:18:\"views_ui_view_info\";a:6:{s:9:\"variables\";a:2:{s:4:\"view\";N;s:4:\"base\";N;}s:4:\"file\";s:18:\"includes/admin.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:23:\"sites/all/modules/views\";s:8:\"function\";s:24:\"theme_views_ui_view_info\";s:8:\"includes\";a:1:{i:0;s:42:\"sites/all/modules/views/includes/admin.inc\";}}s:32:\"views_ui_build_group_filter_form\";a:6:{s:14:\"render element\";s:4:\"form\";s:4:\"file\";s:18:\"includes/admin.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:23:\"sites/all/modules/views\";s:8:\"function\";s:38:\"theme_views_ui_build_group_filter_form\";s:8:\"includes\";a:1:{i:0;s:42:\"sites/all/modules/views/includes/admin.inc\";}}s:12:\"views_tabset\";a:4:{s:9:\"variables\";a:1:{s:4:\"tabs\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:23:\"sites/all/modules/views\";s:8:\"function\";s:18:\"theme_views_tabset\";}s:9:\"views_tab\";a:4:{s:9:\"variables\";a:1:{s:4:\"body\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:23:\"sites/all/modules/views\";s:8:\"function\";s:15:\"theme_views_tab\";}s:30:\"views_ui_reorder_displays_form\";a:6:{s:14:\"render element\";s:4:\"form\";s:4:\"file\";s:18:\"includes/admin.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:23:\"sites/all/modules/views\";s:8:\"function\";s:36:\"theme_views_ui_reorder_displays_form\";s:8:\"includes\";a:1:{i:0;s:42:\"sites/all/modules/views/includes/admin.inc\";}}s:27:\"views_ui_style_plugin_table\";a:4:{s:14:\"render element\";s:4:\"form\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:23:\"sites/all/modules/views\";s:8:\"function\";s:33:\"theme_views_ui_style_plugin_table\";}s:29:\"views_ui_view_preview_section\";a:5:{s:9:\"variables\";a:4:{s:4:\"view\";N;s:7:\"section\";N;s:7:\"content\";N;s:5:\"links\";s:0:\"\";}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:23:\"sites/all/modules/views\";s:8:\"function\";s:35:\"theme_views_ui_view_preview_section\";s:20:\"preprocess functions\";a:1:{i:0;s:49:\"template_preprocess_views_ui_view_preview_section\";}}s:15:\"views_container\";a:6:{s:14:\"render element\";s:7:\"element\";s:4:\"file\";s:15:\"theme/theme.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:23:\"sites/all/modules/views\";s:8:\"function\";s:21:\"theme_views_container\";s:8:\"includes\";a:1:{i:0;s:39:\"sites/all/modules/views/theme/theme.inc\";}}s:21:\"views_slideshow_cycle\";a:9:{s:9:\"variables\";a:4:{s:4:\"view\";N;s:8:\"settings\";a:0:{}s:4:\"rows\";a:0:{}s:5:\"title\";s:0:\"\";}s:8:\"template\";s:91:\"sites/all/modules/views_slideshow/contrib/views_slideshow_cycle/theme/views-slideshow-cycle\";s:4:\"file\";s:37:\"theme/views_slideshow_cycle.theme.inc\";s:7:\"pattern\";s:23:\"views_slideshow_cycle__\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:63:\"sites/all/modules/views_slideshow/contrib/views_slideshow_cycle\";s:8:\"includes\";a:1:{i:0;s:101:\"sites/all/modules/views_slideshow/contrib/views_slideshow_cycle/theme/views_slideshow_cycle.theme.inc\";}s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:32:\"views_slideshow_cycle_main_frame\";a:7:{s:9:\"variables\";a:4:{s:6:\"vss_id\";N;s:4:\"view\";N;s:8:\"settings\";N;s:4:\"rows\";N;}s:8:\"template\";s:102:\"sites/all/modules/views_slideshow/contrib/views_slideshow_cycle/theme/views-slideshow-cycle-main-frame\";s:7:\"pattern\";s:34:\"views_slideshow_cycle_main_frame__\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:63:\"sites/all/modules/views_slideshow/contrib/views_slideshow_cycle\";s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:52:\"template_preprocess_views_slideshow_cycle_main_frame\";i:2;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:36:\"views_slideshow_cycle_main_frame_row\";a:7:{s:9:\"variables\";a:4:{s:6:\"vss_id\";N;s:5:\"items\";N;s:5:\"count\";N;s:4:\"view\";N;}s:8:\"template\";s:106:\"sites/all/modules/views_slideshow/contrib/views_slideshow_cycle/theme/views-slideshow-cycle-main-frame-row\";s:7:\"pattern\";s:38:\"views_slideshow_cycle_main_frame_row__\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:63:\"sites/all/modules/views_slideshow/contrib/views_slideshow_cycle\";s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:56:\"template_preprocess_views_slideshow_cycle_main_frame_row\";i:2;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:41:\"views_slideshow_cycle_main_frame_row_item\";a:7:{s:9:\"variables\";a:5:{s:4:\"item\";N;s:10:\"item_count\";N;s:5:\"count\";N;s:4:\"view\";N;s:6:\"length\";N;}s:8:\"template\";s:111:\"sites/all/modules/views_slideshow/contrib/views_slideshow_cycle/theme/views-slideshow-cycle-main-frame-row-item\";i:0;s:43:\"views_slideshow_cycle_main_frame_row_item__\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:63:\"sites/all/modules/views_slideshow/contrib/views_slideshow_cycle\";s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:61:\"template_preprocess_views_slideshow_cycle_main_frame_row_item\";i:2;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:28:\"views_slideshow_main_section\";a:7:{s:9:\"variables\";a:3:{s:6:\"vss_id\";N;s:6:\"slides\";N;s:6:\"plugin\";N;}s:4:\"file\";s:31:\"theme/views_slideshow.theme.inc\";s:7:\"pattern\";s:30:\"views_slideshow_main_section__\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:33:\"sites/all/modules/views_slideshow\";s:8:\"function\";s:34:\"theme_views_slideshow_main_section\";s:8:\"includes\";a:1:{i:0;s:65:\"sites/all/modules/views_slideshow/theme/views_slideshow.theme.inc\";}}s:35:\"views_slideshow_pager_widget_render\";a:7:{s:9:\"variables\";a:5:{s:6:\"vss_id\";N;s:4:\"view\";N;s:8:\"settings\";a:0:{}s:8:\"location\";N;s:4:\"rows\";a:0:{}}s:4:\"file\";s:31:\"theme/views_slideshow.theme.inc\";s:7:\"pattern\";s:37:\"views_slideshow_pager_widget_render__\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:33:\"sites/all/modules/views_slideshow\";s:8:\"function\";s:41:\"theme_views_slideshow_pager_widget_render\";s:8:\"includes\";a:1:{i:0;s:65:\"sites/all/modules/views_slideshow/theme/views_slideshow.theme.inc\";}}s:28:\"views_slideshow_pager_fields\";a:7:{s:9:\"variables\";a:5:{s:6:\"vss_id\";N;s:4:\"view\";N;s:8:\"settings\";a:0:{}s:8:\"location\";N;s:10:\"attributes\";a:0:{}}s:8:\"template\";s:68:\"sites/all/modules/views_slideshow/theme/views-slideshow-pager-fields\";s:7:\"pattern\";s:30:\"views_slideshow_pager_fields__\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:33:\"sites/all/modules/views_slideshow\";s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:48:\"template_preprocess_views_slideshow_pager_fields\";i:2;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:33:\"views_slideshow_pager_field_field\";a:9:{s:9:\"variables\";a:3:{s:4:\"view\";N;s:5:\"field\";N;s:5:\"count\";N;}s:8:\"template\";s:73:\"sites/all/modules/views_slideshow/theme/views-slideshow-pager-field-field\";s:4:\"file\";s:31:\"theme/views_slideshow.theme.inc\";s:7:\"pattern\";s:35:\"views_slideshow_pager_field_field__\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:33:\"sites/all/modules/views_slideshow\";s:8:\"includes\";a:1:{i:0;s:65:\"sites/all/modules/views_slideshow/theme/views_slideshow.theme.inc\";}s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:32:\"views_slideshow_pager_field_item\";a:7:{s:9:\"variables\";a:5:{s:6:\"vss_id\";N;s:4:\"item\";N;s:5:\"count\";N;s:8:\"location\";N;s:6:\"length\";N;}s:8:\"template\";s:72:\"sites/all/modules/views_slideshow/theme/views-slideshow-pager-field-item\";s:7:\"pattern\";s:34:\"views_slideshow_pager_field_item__\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:33:\"sites/all/modules/views_slideshow\";s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:52:\"template_preprocess_views_slideshow_pager_field_item\";i:2;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:38:\"views_slideshow_controls_widget_render\";a:7:{s:9:\"variables\";a:5:{s:6:\"vss_id\";N;s:4:\"view\";N;s:8:\"settings\";a:0:{}s:8:\"location\";N;s:4:\"rows\";a:0:{}}s:4:\"file\";s:31:\"theme/views_slideshow.theme.inc\";s:7:\"pattern\";s:40:\"views_slideshow_controls_widget_render__\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:33:\"sites/all/modules/views_slideshow\";s:8:\"function\";s:44:\"theme_views_slideshow_controls_widget_render\";s:8:\"includes\";a:1:{i:0;s:65:\"sites/all/modules/views_slideshow/theme/views_slideshow.theme.inc\";}}s:29:\"views_slideshow_controls_text\";a:7:{s:9:\"variables\";a:5:{s:6:\"vss_id\";N;s:4:\"view\";N;s:8:\"settings\";a:0:{}s:8:\"location\";N;s:4:\"rows\";a:0:{}}s:8:\"template\";s:69:\"sites/all/modules/views_slideshow/theme/views-slideshow-controls-text\";s:7:\"pattern\";s:31:\"views_slideshow_controls_text__\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:33:\"sites/all/modules/views_slideshow\";s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:49:\"template_preprocess_views_slideshow_controls_text\";i:2;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:38:\"views_slideshow_controls_text_previous\";a:7:{s:9:\"variables\";a:3:{s:6:\"vss_id\";N;s:4:\"view\";N;s:8:\"settings\";a:0:{}}s:8:\"template\";s:78:\"sites/all/modules/views_slideshow/theme/views-slideshow-controls-text-previous\";s:7:\"pattern\";s:40:\"views_slideshow_controls_text_previous__\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:33:\"sites/all/modules/views_slideshow\";s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:58:\"template_preprocess_views_slideshow_controls_text_previous\";i:2;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:35:\"views_slideshow_controls_text_pause\";a:7:{s:9:\"variables\";a:3:{s:6:\"vss_id\";N;s:4:\"view\";N;s:8:\"settings\";a:0:{}}s:8:\"template\";s:75:\"sites/all/modules/views_slideshow/theme/views-slideshow-controls-text-pause\";s:7:\"pattern\";s:37:\"views_slideshow_controls_text_pause__\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:33:\"sites/all/modules/views_slideshow\";s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:55:\"template_preprocess_views_slideshow_controls_text_pause\";i:2;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:34:\"views_slideshow_controls_text_next\";a:7:{s:9:\"variables\";a:3:{s:6:\"vss_id\";N;s:4:\"view\";N;s:8:\"settings\";a:0:{}}s:8:\"template\";s:74:\"sites/all/modules/views_slideshow/theme/views-slideshow-controls-text-next\";s:7:\"pattern\";s:36:\"views_slideshow_controls_text_next__\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:33:\"sites/all/modules/views_slideshow\";s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:54:\"template_preprocess_views_slideshow_controls_text_next\";i:2;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:43:\"views_slideshow_slide_counter_widget_render\";a:7:{s:9:\"variables\";a:5:{s:6:\"vss_id\";N;s:4:\"view\";N;s:8:\"settings\";a:0:{}s:8:\"location\";N;s:4:\"rows\";a:0:{}}s:4:\"file\";s:31:\"theme/views_slideshow.theme.inc\";s:7:\"pattern\";s:39:\"views_slideshow_counter_widget_render__\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:33:\"sites/all/modules/views_slideshow\";s:8:\"function\";s:49:\"theme_views_slideshow_slide_counter_widget_render\";s:8:\"includes\";a:1:{i:0;s:65:\"sites/all/modules/views_slideshow/theme/views_slideshow.theme.inc\";}}s:29:\"views_slideshow_slide_counter\";a:7:{s:9:\"variables\";a:5:{s:6:\"vss_id\";N;s:4:\"view\";N;s:8:\"settings\";a:0:{}s:8:\"location\";N;s:4:\"rows\";a:0:{}}s:8:\"template\";s:69:\"sites/all/modules/views_slideshow/theme/views-slideshow-slide-counter\";s:7:\"pattern\";s:31:\"views_slideshow_slide_counter__\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:33:\"sites/all/modules/views_slideshow\";s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:49:\"template_preprocess_views_slideshow_slide_counter\";i:2;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:30:\"views_fieldsets_rearrange_form\";a:4:{s:14:\"render element\";s:4:\"form\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:33:\"sites/all/modules/views_fieldsets\";s:8:\"function\";s:36:\"theme_views_fieldsets_rearrange_form\";}s:24:\"views_fieldsets_fieldset\";a:7:{s:9:\"variables\";a:2:{s:8:\"fieldset\";s:0:\"\";s:7:\"content\";s:0:\"\";}s:8:\"template\";s:24:\"views-fieldsets-fieldset\";s:4:\"path\";s:43:\"sites/all/modules/views_fieldsets/templates\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:33:\"sites/all/modules/views_fieldsets\";s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:44:\"template_preprocess_views_fieldsets_fieldset\";i:2;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:34:\"video_embed_field_video_style_list\";a:4:{s:9:\"variables\";a:1:{s:6:\"styles\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:35:\"sites/all/modules/video_embed_field\";s:8:\"function\";s:40:\"theme_video_embed_field_video_style_list\";}s:28:\"video_embed_field_embed_code\";a:6:{s:8:\"template\";s:64:\"sites/all/modules/video_embed_field/video-embed-field-embed-code\";s:9:\"variables\";a:3:{s:3:\"url\";N;s:5:\"style\";s:6:\"normal\";s:10:\"video_data\";a:0:{}}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:35:\"sites/all/modules/video_embed_field\";s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:48:\"template_preprocess_video_embed_field_embed_code\";i:2;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:31:\"video_embed_field_colorbox_code\";a:4:{s:9:\"variables\";a:6:{s:9:\"image_url\";N;s:11:\"image_style\";s:6:\"normal\";s:9:\"image_alt\";N;s:9:\"video_url\";N;s:11:\"video_style\";N;s:10:\"video_data\";a:0:{}}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:35:\"sites/all/modules/video_embed_field\";s:8:\"function\";s:37:\"theme_video_embed_field_colorbox_code\";}s:21:\"variable_table_select\";a:6:{s:14:\"render element\";s:7:\"element\";s:4:\"file\";s:17:\"variable.form.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:26:\"sites/all/modules/variable\";s:8:\"function\";s:27:\"theme_variable_table_select\";s:8:\"includes\";a:1:{i:0;s:44:\"sites/all/modules/variable/variable.form.inc\";}}s:12:\"user_picture\";a:6:{s:9:\"variables\";a:1:{s:7:\"account\";N;}s:8:\"template\";s:25:\"modules/user/user-picture\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:12:\"modules/user\";s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:32:\"template_preprocess_user_picture\";i:2;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:12:\"user_profile\";a:8:{s:14:\"render element\";s:8:\"elements\";s:8:\"template\";s:25:\"modules/user/user-profile\";s:4:\"file\";s:14:\"user.pages.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:12:\"modules/user\";s:8:\"includes\";a:1:{i:0;s:27:\"modules/user/user.pages.inc\";}s:20:\"preprocess functions\";a:4:{i:0;s:19:\"template_preprocess\";i:1;s:32:\"template_preprocess_user_profile\";i:2;s:21:\"contextual_preprocess\";i:3;s:31:\"field_group_build_entity_groups\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:21:\"user_profile_category\";a:8:{s:14:\"render element\";s:7:\"element\";s:8:\"template\";s:34:\"modules/user/user-profile-category\";s:4:\"file\";s:14:\"user.pages.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:12:\"modules/user\";s:8:\"includes\";a:1:{i:0;s:27:\"modules/user/user.pages.inc\";}s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:41:\"template_preprocess_user_profile_category\";i:2;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:17:\"user_profile_item\";a:8:{s:14:\"render element\";s:7:\"element\";s:8:\"template\";s:30:\"modules/user/user-profile-item\";s:4:\"file\";s:14:\"user.pages.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:12:\"modules/user\";s:8:\"includes\";a:1:{i:0;s:27:\"modules/user/user.pages.inc\";}s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:37:\"template_preprocess_user_profile_item\";i:2;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:9:\"user_list\";a:4:{s:9:\"variables\";a:2:{s:5:\"users\";N;s:5:\"title\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:12:\"modules/user\";s:8:\"function\";s:15:\"theme_user_list\";}s:22:\"user_admin_permissions\";a:6:{s:14:\"render element\";s:4:\"form\";s:4:\"file\";s:14:\"user.admin.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:12:\"modules/user\";s:8:\"function\";s:28:\"theme_user_admin_permissions\";s:8:\"includes\";a:1:{i:0;s:27:\"modules/user/user.admin.inc\";}}s:16:\"user_admin_roles\";a:6:{s:14:\"render element\";s:4:\"form\";s:4:\"file\";s:14:\"user.admin.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:12:\"modules/user\";s:8:\"function\";s:22:\"theme_user_admin_roles\";s:8:\"includes\";a:1:{i:0;s:27:\"modules/user/user.admin.inc\";}}s:27:\"user_permission_description\";a:6:{s:9:\"variables\";a:2:{s:15:\"permission_item\";N;s:4:\"hide\";N;}s:4:\"file\";s:14:\"user.admin.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:12:\"modules/user\";s:8:\"function\";s:33:\"theme_user_permission_description\";s:8:\"includes\";a:1:{i:0;s:27:\"modules/user/user.admin.inc\";}}s:14:\"user_signature\";a:4:{s:9:\"variables\";a:1:{s:9:\"signature\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:12:\"modules/user\";s:8:\"function\";s:20:\"theme_user_signature\";}s:26:\"update_manager_update_form\";a:6:{s:14:\"render element\";s:4:\"form\";s:4:\"file\";s:18:\"update.manager.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/update\";s:8:\"function\";s:32:\"theme_update_manager_update_form\";s:8:\"includes\";a:1:{i:0;s:33:\"modules/update/update.manager.inc\";}}s:17:\"update_last_check\";a:4:{s:9:\"variables\";a:1:{s:4:\"last\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/update\";s:8:\"function\";s:23:\"theme_update_last_check\";}s:13:\"update_report\";a:6:{s:9:\"variables\";a:1:{s:4:\"data\";N;}s:4:\"file\";s:17:\"update.report.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/update\";s:8:\"function\";s:19:\"theme_update_report\";s:8:\"includes\";a:1:{i:0;s:32:\"modules/update/update.report.inc\";}}s:14:\"update_version\";a:6:{s:9:\"variables\";a:3:{s:7:\"version\";N;s:3:\"tag\";N;s:5:\"class\";a:0:{}}s:4:\"file\";s:17:\"update.report.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/update\";s:8:\"function\";s:20:\"theme_update_version\";s:8:\"includes\";a:1:{i:0;s:32:\"modules/update/update.report.inc\";}}s:19:\"update_status_label\";a:6:{s:9:\"variables\";a:1:{s:6:\"status\";N;}s:4:\"file\";s:17:\"update.report.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/update\";s:8:\"function\";s:25:\"theme_update_status_label\";s:8:\"includes\";a:1:{i:0;s:32:\"modules/update/update.report.inc\";}}s:10:\"tree_table\";a:6:{s:9:\"variables\";a:5:{s:6:\"header\";a:0:{}s:4:\"rows\";a:0:{}s:10:\"attributes\";a:0:{}s:5:\"empty\";s:0:\"\";s:7:\"caption\";s:0:\"\";}s:4:\"file\";s:15:\"token.pages.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:23:\"sites/all/modules/token\";s:8:\"function\";s:16:\"theme_tree_table\";s:8:\"includes\";a:1:{i:0;s:39:\"sites/all/modules/token/token.pages.inc\";}}s:10:\"token_tree\";a:6:{s:9:\"variables\";a:6:{s:11:\"token_types\";a:0:{}s:12:\"global_types\";b:1;s:12:\"click_insert\";b:1;s:15:\"show_restricted\";b:0;s:15:\"recursion_limit\";i:3;s:6:\"dialog\";b:0;}s:4:\"file\";s:15:\"token.pages.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:23:\"sites/all/modules/token\";s:8:\"function\";s:16:\"theme_token_tree\";s:8:\"includes\";a:1:{i:0;s:39:\"sites/all/modules/token/token.pages.inc\";}}s:15:\"token_tree_link\";a:6:{s:9:\"variables\";a:8:{s:4:\"text\";N;s:7:\"options\";a:0:{}s:6:\"dialog\";b:1;s:11:\"token_types\";a:0:{}s:12:\"global_types\";b:1;s:12:\"click_insert\";b:1;s:15:\"show_restricted\";b:0;s:15:\"recursion_limit\";i:3;}s:4:\"file\";s:15:\"token.pages.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:23:\"sites/all/modules/token\";s:8:\"function\";s:21:\"theme_token_tree_link\";s:8:\"includes\";a:1:{i:0;s:39:\"sites/all/modules/token/token.pages.inc\";}}s:30:\"taxonomy_overview_vocabularies\";a:4:{s:14:\"render element\";s:4:\"form\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:16:\"modules/taxonomy\";s:8:\"function\";s:36:\"theme_taxonomy_overview_vocabularies\";}s:23:\"taxonomy_overview_terms\";a:4:{s:14:\"render element\";s:4:\"form\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:16:\"modules/taxonomy\";s:8:\"function\";s:29:\"theme_taxonomy_overview_terms\";}s:13:\"taxonomy_term\";a:6:{s:14:\"render element\";s:8:\"elements\";s:8:\"template\";s:30:\"modules/taxonomy/taxonomy-term\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:16:\"modules/taxonomy\";s:20:\"preprocess functions\";a:4:{i:0;s:19:\"template_preprocess\";i:1;s:33:\"template_preprocess_taxonomy_term\";i:2;s:21:\"contextual_preprocess\";i:3;s:31:\"field_group_build_entity_groups\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:18:\"tagclouds_list_box\";a:4:{s:9:\"arguments\";a:2:{s:10:\"vocabulary\";N;s:4:\"tags\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:27:\"sites/all/modules/tagclouds\";s:8:\"function\";s:24:\"theme_tagclouds_list_box\";}s:18:\"tagclouds_weighted\";a:4:{s:9:\"arguments\";a:1:{s:5:\"terms\";a:0:{}}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:27:\"sites/all/modules/tagclouds\";s:8:\"function\";s:24:\"theme_tagclouds_weighted\";}s:6:\"region\";a:6:{s:14:\"render element\";s:8:\"elements\";s:8:\"template\";s:21:\"modules/system/region\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:26:\"template_preprocess_region\";i:2;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:15:\"status_messages\";a:4:{s:9:\"variables\";a:1:{s:7:\"display\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:21:\"theme_status_messages\";}s:4:\"link\";a:4:{s:9:\"variables\";a:3:{s:4:\"text\";N;s:4:\"path\";N;s:7:\"options\";a:0:{}}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:10:\"theme_link\";}s:5:\"links\";a:4:{s:9:\"variables\";a:3:{s:5:\"links\";N;s:10:\"attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:5:\"links\";}}s:7:\"heading\";a:0:{}}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:11:\"theme_links\";}s:5:\"image\";a:4:{s:9:\"variables\";a:6:{s:4:\"path\";N;s:5:\"width\";N;s:6:\"height\";N;s:3:\"alt\";s:0:\"\";s:5:\"title\";N;s:10:\"attributes\";a:0:{}}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:11:\"theme_image\";}s:10:\"breadcrumb\";a:4:{s:9:\"variables\";a:1:{s:10:\"breadcrumb\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:16:\"theme_breadcrumb\";}s:4:\"help\";a:4:{s:9:\"variables\";a:0:{}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:10:\"theme_help\";}s:5:\"table\";a:4:{s:9:\"variables\";a:7:{s:6:\"header\";N;s:4:\"rows\";N;s:10:\"attributes\";a:0:{}s:7:\"caption\";N;s:9:\"colgroups\";a:0:{}s:6:\"sticky\";b:1;s:5:\"empty\";s:0:\"\";}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:11:\"theme_table\";}s:19:\"tablesort_indicator\";a:4:{s:9:\"variables\";a:1:{s:5:\"style\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:25:\"theme_tablesort_indicator\";}s:4:\"mark\";a:4:{s:9:\"variables\";a:1:{s:4:\"type\";i:1;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:10:\"theme_mark\";}s:9:\"item_list\";a:4:{s:9:\"variables\";a:4:{s:5:\"items\";a:0:{}s:5:\"title\";N;s:4:\"type\";s:2:\"ul\";s:10:\"attributes\";a:0:{}}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:15:\"theme_item_list\";}s:14:\"more_help_link\";a:4:{s:9:\"variables\";a:1:{s:3:\"url\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:20:\"theme_more_help_link\";}s:9:\"feed_icon\";a:4:{s:9:\"variables\";a:2:{s:3:\"url\";N;s:5:\"title\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:15:\"theme_feed_icon\";}s:9:\"more_link\";a:4:{s:9:\"variables\";a:2:{s:3:\"url\";N;s:5:\"title\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:15:\"theme_more_link\";}s:8:\"username\";a:6:{s:9:\"variables\";a:1:{s:7:\"account\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:14:\"theme_username\";s:20:\"preprocess functions\";a:1:{i:0;s:28:\"template_preprocess_username\";}s:17:\"process functions\";a:1:{i:0;s:25:\"template_process_username\";}}s:12:\"progress_bar\";a:4:{s:9:\"variables\";a:2:{s:7:\"percent\";N;s:7:\"message\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:18:\"theme_progress_bar\";}s:11:\"indentation\";a:4:{s:9:\"variables\";a:1:{s:4:\"size\";i:1;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:17:\"theme_indentation\";}s:8:\"html_tag\";a:4:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:14:\"theme_html_tag\";}s:11:\"update_page\";a:4:{s:9:\"variables\";a:2:{s:7:\"content\";N;s:13:\"show_messages\";b:1;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:17:\"theme_update_page\";}s:12:\"install_page\";a:4:{s:9:\"variables\";a:1:{s:7:\"content\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:18:\"theme_install_page\";}s:9:\"task_list\";a:4:{s:9:\"variables\";a:2:{s:5:\"items\";N;s:6:\"active\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:15:\"theme_task_list\";}s:17:\"authorize_message\";a:4:{s:9:\"variables\";a:2:{s:7:\"message\";N;s:7:\"success\";b:1;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:23:\"theme_authorize_message\";}s:16:\"authorize_report\";a:4:{s:9:\"variables\";a:1:{s:8:\"messages\";a:0:{}}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:22:\"theme_authorize_report\";}s:5:\"pager\";a:4:{s:9:\"variables\";a:4:{s:4:\"tags\";a:0:{}s:7:\"element\";i:0;s:10:\"parameters\";a:0:{}s:8:\"quantity\";i:9;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:11:\"theme_pager\";}s:11:\"pager_first\";a:4:{s:9:\"variables\";a:3:{s:4:\"text\";N;s:7:\"element\";i:0;s:10:\"parameters\";a:0:{}}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:17:\"theme_pager_first\";}s:14:\"pager_previous\";a:4:{s:9:\"variables\";a:4:{s:4:\"text\";N;s:7:\"element\";i:0;s:8:\"interval\";i:1;s:10:\"parameters\";a:0:{}}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:20:\"theme_pager_previous\";}s:10:\"pager_next\";a:4:{s:9:\"variables\";a:4:{s:4:\"text\";N;s:7:\"element\";i:0;s:8:\"interval\";i:1;s:10:\"parameters\";a:0:{}}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:16:\"theme_pager_next\";}s:10:\"pager_last\";a:4:{s:9:\"variables\";a:3:{s:4:\"text\";N;s:7:\"element\";i:0;s:10:\"parameters\";a:0:{}}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:16:\"theme_pager_last\";}s:10:\"pager_link\";a:4:{s:9:\"variables\";a:5:{s:4:\"text\";N;s:8:\"page_new\";N;s:7:\"element\";N;s:10:\"parameters\";a:0:{}s:10:\"attributes\";a:0:{}}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:16:\"theme_pager_link\";}s:9:\"menu_link\";a:4:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:15:\"theme_menu_link\";}s:9:\"menu_tree\";a:5:{s:14:\"render element\";s:4:\"tree\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:15:\"theme_menu_tree\";s:20:\"preprocess functions\";a:1:{i:0;s:29:\"template_preprocess_menu_tree\";}}s:15:\"menu_local_task\";a:4:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:21:\"theme_menu_local_task\";}s:17:\"menu_local_action\";a:4:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:23:\"theme_menu_local_action\";}s:16:\"menu_local_tasks\";a:4:{s:9:\"variables\";a:2:{s:7:\"primary\";a:0:{}s:9:\"secondary\";a:0:{}}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:22:\"theme_menu_local_tasks\";}s:6:\"select\";a:4:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:12:\"theme_select\";}s:8:\"fieldset\";a:4:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:14:\"theme_fieldset\";}s:5:\"radio\";a:4:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:11:\"theme_radio\";}s:6:\"radios\";a:4:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:12:\"theme_radios\";}s:4:\"date\";a:4:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:10:\"theme_date\";}s:15:\"exposed_filters\";a:4:{s:14:\"render element\";s:4:\"form\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:21:\"theme_exposed_filters\";}s:8:\"checkbox\";a:4:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:14:\"theme_checkbox\";}s:10:\"checkboxes\";a:4:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:16:\"theme_checkboxes\";}s:6:\"button\";a:4:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:12:\"theme_button\";}s:12:\"image_button\";a:4:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:18:\"theme_image_button\";}s:6:\"hidden\";a:4:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:12:\"theme_hidden\";}s:9:\"textfield\";a:4:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:15:\"theme_textfield\";}s:4:\"form\";a:4:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:10:\"theme_form\";}s:8:\"textarea\";a:4:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:14:\"theme_textarea\";}s:8:\"password\";a:4:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:14:\"theme_password\";}s:4:\"file\";a:4:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:10:\"theme_file\";}s:11:\"tableselect\";a:4:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:17:\"theme_tableselect\";}s:12:\"form_element\";a:4:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:18:\"theme_form_element\";}s:20:\"form_required_marker\";a:4:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:26:\"theme_form_required_marker\";}s:18:\"form_element_label\";a:4:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:24:\"theme_form_element_label\";}s:13:\"vertical_tabs\";a:4:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:19:\"theme_vertical_tabs\";}s:9:\"container\";a:4:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:15:\"theme_container\";}s:18:\"system_themes_page\";a:6:{s:9:\"variables\";a:1:{s:12:\"theme_groups\";N;}s:4:\"file\";s:16:\"system.admin.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:24:\"theme_system_themes_page\";s:8:\"includes\";a:1:{i:0;s:31:\"modules/system/system.admin.inc\";}}s:20:\"system_settings_form\";a:4:{s:14:\"render element\";s:4:\"form\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:26:\"theme_system_settings_form\";}s:12:\"confirm_form\";a:4:{s:14:\"render element\";s:4:\"form\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:18:\"theme_confirm_form\";}s:23:\"system_modules_fieldset\";a:6:{s:14:\"render element\";s:4:\"form\";s:4:\"file\";s:16:\"system.admin.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:29:\"theme_system_modules_fieldset\";s:8:\"includes\";a:1:{i:0;s:31:\"modules/system/system.admin.inc\";}}s:27:\"system_modules_incompatible\";a:6:{s:9:\"variables\";a:1:{s:7:\"message\";N;}s:4:\"file\";s:16:\"system.admin.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:33:\"theme_system_modules_incompatible\";s:8:\"includes\";a:1:{i:0;s:31:\"modules/system/system.admin.inc\";}}s:24:\"system_modules_uninstall\";a:6:{s:14:\"render element\";s:4:\"form\";s:4:\"file\";s:16:\"system.admin.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:30:\"theme_system_modules_uninstall\";s:8:\"includes\";a:1:{i:0;s:31:\"modules/system/system.admin.inc\";}}s:13:\"status_report\";a:6:{s:14:\"render element\";s:12:\"requirements\";s:4:\"file\";s:16:\"system.admin.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:19:\"theme_status_report\";s:8:\"includes\";a:1:{i:0;s:31:\"modules/system/system.admin.inc\";}}s:10:\"admin_page\";a:6:{s:9:\"variables\";a:1:{s:6:\"blocks\";N;}s:4:\"file\";s:16:\"system.admin.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:16:\"theme_admin_page\";s:8:\"includes\";a:1:{i:0;s:31:\"modules/system/system.admin.inc\";}}s:11:\"admin_block\";a:6:{s:9:\"variables\";a:1:{s:5:\"block\";N;}s:4:\"file\";s:16:\"system.admin.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:17:\"theme_admin_block\";s:8:\"includes\";a:1:{i:0;s:31:\"modules/system/system.admin.inc\";}}s:19:\"admin_block_content\";a:6:{s:9:\"variables\";a:1:{s:7:\"content\";N;}s:4:\"file\";s:16:\"system.admin.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:25:\"theme_admin_block_content\";s:8:\"includes\";a:1:{i:0;s:31:\"modules/system/system.admin.inc\";}}s:18:\"system_admin_index\";a:6:{s:9:\"variables\";a:1:{s:10:\"menu_items\";N;}s:4:\"file\";s:16:\"system.admin.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:24:\"theme_system_admin_index\";s:8:\"includes\";a:1:{i:0;s:31:\"modules/system/system.admin.inc\";}}s:17:\"system_powered_by\";a:4:{s:9:\"variables\";a:0:{}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:23:\"theme_system_powered_by\";}s:19:\"system_compact_link\";a:4:{s:9:\"variables\";a:0:{}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:25:\"theme_system_compact_link\";}s:25:\"system_date_time_settings\";a:6:{s:14:\"render element\";s:4:\"form\";s:4:\"file\";s:16:\"system.admin.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:31:\"theme_system_date_time_settings\";s:8:\"includes\";a:1:{i:0;s:31:\"modules/system/system.admin.inc\";}}s:22:\"shortcut_set_customize\";a:6:{s:14:\"render element\";s:4:\"form\";s:4:\"file\";s:18:\"shortcut.admin.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:16:\"modules/shortcut\";s:8:\"function\";s:28:\"theme_shortcut_set_customize\";s:8:\"includes\";a:1:{i:0;s:35:\"modules/shortcut/shortcut.admin.inc\";}}s:27:\"shortcode_video_embed_error\";a:4:{s:9:\"variables\";a:2:{s:9:\"video_url\";s:0:\"\";s:5:\"class\";s:21:\"video-embedding-error\";}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:43:\"sites/all/modules/shortcode/shortcode_video\";s:8:\"function\";s:33:\"theme_shortcode_video_embed_error\";}s:33:\"shortcode_video_embed_no_provider\";a:4:{s:9:\"variables\";a:2:{s:9:\"video_url\";s:0:\"\";s:5:\"class\";s:27:\"video-embedding-no-provider\";}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:43:\"sites/all/modules/shortcode/shortcode_video\";s:8:\"function\";s:39:\"theme_shortcode_video_embed_no_provider\";}s:29:\"shortcode_video_embed_youtube\";a:4:{s:9:\"variables\";a:2:{s:9:\"video_url\";s:0:\"\";s:10:\"attributes\";a:0:{}}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:43:\"sites/all/modules/shortcode/shortcode_video\";s:8:\"function\";s:35:\"theme_shortcode_video_embed_youtube\";}s:16:\"shortcode_button\";a:4:{s:9:\"variables\";a:3:{s:4:\"link\";s:1:\"#\";s:4:\"text\";s:0:\"\";s:5:\"class\";s:6:\"button\";}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:48:\"sites/all/modules/shortcode/shortcode_basic_tags\";s:8:\"function\";s:22:\"theme_shortcode_button\";}s:15:\"shortcode_quote\";a:4:{s:9:\"variables\";a:3:{s:4:\"text\";s:0:\"\";s:6:\"author\";b:0;s:5:\"class\";s:5:\"quote\";}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:48:\"sites/all/modules/shortcode/shortcode_basic_tags\";s:8:\"function\";s:21:\"theme_shortcode_quote\";}s:13:\"shortcode_img\";a:4:{s:9:\"variables\";a:3:{s:3:\"src\";s:0:\"\";s:3:\"alt\";s:0:\"\";s:5:\"class\";s:3:\"img\";}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:48:\"sites/all/modules/shortcode/shortcode_basic_tags\";s:8:\"function\";s:19:\"theme_shortcode_img\";}s:17:\"shortcode_dropcap\";a:4:{s:9:\"variables\";a:2:{s:4:\"text\";s:0:\"\";s:5:\"class\";s:7:\"dropcap\";}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:48:\"sites/all/modules/shortcode/shortcode_basic_tags\";s:8:\"function\";s:23:\"theme_shortcode_dropcap\";}s:14:\"shortcode_item\";a:4:{s:9:\"variables\";a:4:{s:4:\"text\";s:0:\"\";s:2:\"id\";s:0:\"\";s:5:\"class\";s:0:\"\";s:4:\"type\";s:3:\"div\";}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:48:\"sites/all/modules/shortcode/shortcode_basic_tags\";s:8:\"function\";s:20:\"theme_shortcode_item\";}s:15:\"shortcode_clear\";a:4:{s:9:\"variables\";a:4:{s:4:\"text\";s:0:\"\";s:2:\"id\";s:0:\"\";s:5:\"class\";s:0:\"\";s:4:\"type\";s:3:\"div\";}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:48:\"sites/all/modules/shortcode/shortcode_basic_tags\";s:8:\"function\";s:21:\"theme_shortcode_clear\";}s:9:\"sharethis\";a:4:{s:9:\"variables\";a:3:{s:12:\"data_options\";N;s:6:\"m_path\";N;s:7:\"m_title\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:27:\"sites/all/modules/sharethis\";s:8:\"function\";s:15:\"theme_sharethis\";}s:17:\"search_block_form\";a:6:{s:14:\"render element\";s:4:\"form\";s:8:\"template\";s:32:\"modules/search/search-block-form\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/search\";s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:37:\"template_preprocess_search_block_form\";i:2;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:13:\"search_result\";a:8:{s:9:\"variables\";a:2:{s:6:\"result\";N;s:6:\"module\";N;}s:4:\"file\";s:16:\"search.pages.inc\";s:8:\"template\";s:28:\"modules/search/search-result\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/search\";s:8:\"includes\";a:1:{i:0;s:31:\"modules/search/search.pages.inc\";}s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:33:\"template_preprocess_search_result\";i:2;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:14:\"search_results\";a:8:{s:9:\"variables\";a:2:{s:7:\"results\";N;s:6:\"module\";N;}s:4:\"file\";s:16:\"search.pages.inc\";s:8:\"template\";s:29:\"modules/search/search-results\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/search\";s:8:\"includes\";a:1:{i:0;s:31:\"modules/search/search.pages.inc\";}s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:34:\"template_preprocess_search_results\";i:2;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:25:\"quicktabs_admin_form_tabs\";a:6:{s:14:\"render element\";s:4:\"tabs\";s:4:\"file\";s:19:\"quicktabs.admin.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:27:\"sites/all/modules/quicktabs\";s:8:\"function\";s:31:\"theme_quicktabs_admin_form_tabs\";s:8:\"includes\";a:1:{i:0;s:47:\"sites/all/modules/quicktabs/quicktabs.admin.inc\";}}s:10:\"qt_ui_tabs\";a:4:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:27:\"sites/all/modules/quicktabs\";s:8:\"function\";s:16:\"theme_qt_ui_tabs\";}s:17:\"qt_ui_tabs_tabset\";a:4:{s:14:\"render element\";s:6:\"tabset\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:27:\"sites/all/modules/quicktabs\";s:8:\"function\";s:23:\"theme_qt_ui_tabs_tabset\";}s:12:\"qt_quicktabs\";a:4:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:27:\"sites/all/modules/quicktabs\";s:8:\"function\";s:18:\"theme_qt_quicktabs\";}s:19:\"qt_quicktabs_tabset\";a:4:{s:14:\"render element\";s:6:\"tabset\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:27:\"sites/all/modules/quicktabs\";s:8:\"function\";s:25:\"theme_qt_quicktabs_tabset\";}s:12:\"qt_accordion\";a:4:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:27:\"sites/all/modules/quicktabs\";s:8:\"function\";s:18:\"theme_qt_accordion\";}s:27:\"quicktabs_tab_access_denied\";a:4:{s:9:\"variables\";a:1:{i:0;s:3:\"tab\";}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:27:\"sites/all/modules/quicktabs\";s:8:\"function\";s:33:\"theme_quicktabs_tab_access_denied\";}s:7:\"overlay\";a:6:{s:14:\"render element\";s:4:\"page\";s:8:\"template\";s:23:\"modules/overlay/overlay\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:15:\"modules/overlay\";s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:27:\"template_preprocess_overlay\";i:2;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:3:{i:0;s:16:\"template_process\";i:1;s:24:\"template_process_overlay\";i:2;s:14:\"ctools_process\";}}s:23:\"overlay_disable_message\";a:4:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:15:\"modules/overlay\";s:8:\"function\";s:29:\"theme_overlay_disable_message\";}s:12:\"options_none\";a:4:{s:9:\"variables\";a:2:{s:8:\"instance\";N;s:6:\"option\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:29:\"modules/field/modules/options\";s:8:\"function\";s:18:\"theme_options_none\";}s:17:\"node_search_admin\";a:4:{s:14:\"render element\";s:4:\"form\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:12:\"modules/node\";s:8:\"function\";s:23:\"theme_node_search_admin\";}s:13:\"node_add_list\";a:6:{s:9:\"variables\";a:1:{s:7:\"content\";N;}s:4:\"file\";s:14:\"node.pages.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:12:\"modules/node\";s:8:\"function\";s:19:\"theme_node_add_list\";s:8:\"includes\";a:1:{i:0;s:27:\"modules/node/node.pages.inc\";}}s:12:\"node_preview\";a:6:{s:9:\"variables\";a:1:{s:4:\"node\";N;}s:4:\"file\";s:14:\"node.pages.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:12:\"modules/node\";s:8:\"function\";s:18:\"theme_node_preview\";s:8:\"includes\";a:1:{i:0;s:27:\"modules/node/node.pages.inc\";}}s:19:\"node_admin_overview\";a:6:{s:9:\"variables\";a:2:{s:4:\"name\";N;s:4:\"type\";N;}s:4:\"file\";s:17:\"content_types.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:12:\"modules/node\";s:8:\"function\";s:25:\"theme_node_admin_overview\";s:8:\"includes\";a:1:{i:0;s:30:\"modules/node/content_types.inc\";}}s:17:\"node_recent_block\";a:4:{s:9:\"variables\";a:1:{s:5:\"nodes\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:12:\"modules/node\";s:8:\"function\";s:23:\"theme_node_recent_block\";}s:19:\"node_recent_content\";a:4:{s:9:\"variables\";a:1:{s:4:\"node\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:12:\"modules/node\";s:8:\"function\";s:25:\"theme_node_recent_content\";}s:13:\"module_filter\";a:6:{s:14:\"render element\";s:7:\"element\";s:4:\"file\";s:23:\"module_filter.theme.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/module_filter\";s:8:\"function\";s:19:\"theme_module_filter\";s:8:\"includes\";a:1:{i:0;s:55:\"sites/all/modules/module_filter/module_filter.theme.inc\";}}s:33:\"module_filter_system_modules_tabs\";a:6:{s:14:\"render element\";s:4:\"form\";s:4:\"file\";s:23:\"module_filter.theme.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/module_filter\";s:8:\"function\";s:39:\"theme_module_filter_system_modules_tabs\";s:8:\"includes\";a:1:{i:0;s:55:\"sites/all/modules/module_filter/module_filter.theme.inc\";}}s:24:\"module_filter_operations\";a:6:{s:9:\"variables\";a:2:{s:5:\"links\";a:0:{}s:10:\"dropbutton\";b:0;}s:4:\"file\";s:23:\"module_filter.theme.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/module_filter\";s:8:\"function\";s:30:\"theme_module_filter_operations\";s:8:\"includes\";a:1:{i:0;s:55:\"sites/all/modules/module_filter/module_filter.theme.inc\";}}s:7:\"message\";a:6:{s:14:\"render element\";s:8:\"elements\";s:8:\"template\";s:33:\"sites/all/modules/message/message\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:25:\"sites/all/modules/message\";s:20:\"preprocess functions\";a:4:{i:0;s:19:\"template_preprocess\";i:1;s:27:\"template_preprocess_message\";i:2;s:21:\"contextual_preprocess\";i:3;s:31:\"field_group_build_entity_groups\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:27:\"menu_breadcrumb_menus_table\";a:4:{s:14:\"render element\";s:4:\"form\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:33:\"sites/all/modules/menu_breadcrumb\";s:8:\"function\";s:33:\"theme_menu_breadcrumb_menus_table\";}s:18:\"menu_overview_form\";a:6:{s:4:\"file\";s:14:\"menu.admin.inc\";s:14:\"render element\";s:4:\"form\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:12:\"modules/menu\";s:8:\"function\";s:24:\"theme_menu_overview_form\";s:8:\"includes\";a:1:{i:0;s:27:\"modules/menu/menu.admin.inc\";}}s:19:\"menu_admin_overview\";a:6:{s:4:\"file\";s:14:\"menu.admin.inc\";s:9:\"variables\";a:3:{s:5:\"title\";N;s:4:\"name\";N;s:11:\"description\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:12:\"modules/menu\";s:8:\"function\";s:25:\"theme_menu_admin_overview\";s:8:\"includes\";a:1:{i:0;s:27:\"modules/menu/menu.admin.inc\";}}s:30:\"locale_languages_overview_form\";a:4:{s:14:\"render element\";s:4:\"form\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/locale\";s:8:\"function\";s:36:\"theme_locale_languages_overview_form\";}s:31:\"locale_languages_configure_form\";a:4:{s:14:\"render element\";s:4:\"form\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/locale\";s:8:\"function\";s:37:\"theme_locale_languages_configure_form\";}s:23:\"locale_date_format_form\";a:4:{s:14:\"render element\";s:4:\"form\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/locale\";s:8:\"function\";s:29:\"theme_locale_date_format_form\";}s:27:\"link_formatter_link_default\";a:4:{s:9:\"variables\";a:2:{s:7:\"element\";N;s:5:\"field\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:22:\"sites/all/modules/link\";s:8:\"function\";s:33:\"theme_link_formatter_link_default\";}s:25:\"link_formatter_link_plain\";a:4:{s:9:\"variables\";a:2:{s:7:\"element\";N;s:5:\"field\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:22:\"sites/all/modules/link\";s:8:\"function\";s:31:\"theme_link_formatter_link_plain\";}s:28:\"link_formatter_link_absolute\";a:4:{s:9:\"variables\";a:2:{s:7:\"element\";N;s:5:\"field\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:22:\"sites/all/modules/link\";s:8:\"function\";s:34:\"theme_link_formatter_link_absolute\";}s:26:\"link_formatter_link_domain\";a:4:{s:9:\"variables\";a:3:{s:7:\"element\";N;s:7:\"display\";N;s:5:\"field\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:22:\"sites/all/modules/link\";s:8:\"function\";s:32:\"theme_link_formatter_link_domain\";}s:31:\"link_formatter_link_title_plain\";a:4:{s:9:\"variables\";a:2:{s:7:\"element\";N;s:5:\"field\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:22:\"sites/all/modules/link\";s:8:\"function\";s:37:\"theme_link_formatter_link_title_plain\";}s:23:\"link_formatter_link_url\";a:4:{s:9:\"variables\";a:2:{s:7:\"element\";N;s:5:\"field\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:22:\"sites/all/modules/link\";s:8:\"function\";s:29:\"theme_link_formatter_link_url\";}s:25:\"link_formatter_link_short\";a:4:{s:9:\"variables\";a:2:{s:7:\"element\";N;s:5:\"field\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:22:\"sites/all/modules/link\";s:8:\"function\";s:31:\"theme_link_formatter_link_short\";}s:25:\"link_formatter_link_label\";a:4:{s:9:\"variables\";a:2:{s:7:\"element\";N;s:5:\"field\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:22:\"sites/all/modules/link\";s:8:\"function\";s:31:\"theme_link_formatter_link_label\";}s:28:\"link_formatter_link_separate\";a:4:{s:9:\"variables\";a:2:{s:7:\"element\";N;s:5:\"field\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:22:\"sites/all/modules/link\";s:8:\"function\";s:34:\"theme_link_formatter_link_separate\";}s:10:\"link_field\";a:4:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:22:\"sites/all/modules/link\";s:8:\"function\";s:16:\"theme_link_field\";}s:37:\"lang_dropdown_hideout_hiddenlanguages\";a:4:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:53:\"sites/all/modules/lang_dropdown/lang_dropdown_hideout\";s:8:\"function\";s:43:\"theme_lang_dropdown_hideout_hiddenlanguages\";}s:18:\"languageicons_icon\";a:4:{s:9:\"variables\";a:2:{s:8:\"language\";N;s:5:\"title\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/languageicons\";s:8:\"function\";s:24:\"theme_languageicons_icon\";}s:19:\"languageicons_place\";a:4:{s:9:\"variables\";a:3:{s:4:\"text\";N;s:4:\"icon\";N;s:9:\"separator\";s:1:\" \";}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/languageicons\";s:8:\"function\";s:25:\"theme_languageicons_place\";}s:11:\"image_style\";a:4:{s:9:\"variables\";a:7:{s:10:\"style_name\";N;s:4:\"path\";N;s:5:\"width\";N;s:6:\"height\";N;s:3:\"alt\";s:0:\"\";s:5:\"title\";N;s:10:\"attributes\";a:0:{}}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:13:\"modules/image\";s:8:\"function\";s:17:\"theme_image_style\";}s:16:\"image_style_list\";a:4:{s:9:\"variables\";a:1:{s:6:\"styles\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:13:\"modules/image\";s:8:\"function\";s:22:\"theme_image_style_list\";}s:19:\"image_style_effects\";a:4:{s:14:\"render element\";s:4:\"form\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:13:\"modules/image\";s:8:\"function\";s:25:\"theme_image_style_effects\";}s:19:\"image_style_preview\";a:4:{s:9:\"variables\";a:1:{s:5:\"style\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:13:\"modules/image\";s:8:\"function\";s:25:\"theme_image_style_preview\";}s:12:\"image_anchor\";a:4:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:13:\"modules/image\";s:8:\"function\";s:18:\"theme_image_anchor\";}s:20:\"image_resize_summary\";a:4:{s:9:\"variables\";a:1:{s:4:\"data\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:13:\"modules/image\";s:8:\"function\";s:26:\"theme_image_resize_summary\";}s:19:\"image_scale_summary\";a:4:{s:9:\"variables\";a:1:{s:4:\"data\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:13:\"modules/image\";s:8:\"function\";s:25:\"theme_image_scale_summary\";}s:18:\"image_crop_summary\";a:4:{s:9:\"variables\";a:1:{s:4:\"data\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:13:\"modules/image\";s:8:\"function\";s:24:\"theme_image_crop_summary\";}s:20:\"image_rotate_summary\";a:4:{s:9:\"variables\";a:1:{s:4:\"data\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:13:\"modules/image\";s:8:\"function\";s:26:\"theme_image_rotate_summary\";}s:12:\"image_widget\";a:4:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:13:\"modules/image\";s:8:\"function\";s:18:\"theme_image_widget\";}s:15:\"image_formatter\";a:4:{s:9:\"variables\";a:3:{s:4:\"item\";N;s:4:\"path\";N;s:11:\"image_style\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:13:\"modules/image\";s:8:\"function\";s:21:\"theme_image_formatter\";}s:10:\"flexslider\";a:8:{s:9:\"variables\";a:2:{s:5:\"items\";a:0:{}s:8:\"settings\";a:0:{}}s:8:\"template\";s:45:\"sites/all/modules/flexslider/theme/flexslider\";s:4:\"file\";s:26:\"theme/flexslider.theme.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:28:\"sites/all/modules/flexslider\";s:8:\"includes\";a:1:{i:0;s:55:\"sites/all/modules/flexslider/theme/flexslider.theme.inc\";}s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:3:{i:0;s:16:\"template_process\";i:1;s:27:\"template_process_flexslider\";i:2;s:14:\"ctools_process\";}}s:15:\"flexslider_list\";a:7:{s:9:\"variables\";a:2:{s:5:\"items\";a:0:{}s:8:\"settings\";a:0:{}}s:4:\"file\";s:26:\"theme/flexslider.theme.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:28:\"sites/all/modules/flexslider\";s:8:\"function\";s:21:\"theme_flexslider_list\";s:8:\"includes\";a:1:{i:0;s:55:\"sites/all/modules/flexslider/theme/flexslider.theme.inc\";}s:17:\"process functions\";a:1:{i:0;s:32:\"template_process_flexslider_list\";}}s:20:\"flexslider_list_item\";a:7:{s:9:\"variables\";a:3:{s:4:\"item\";a:0:{}s:8:\"settings\";a:0:{}s:7:\"caption\";s:0:\"\";}s:4:\"file\";s:26:\"theme/flexslider.theme.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:28:\"sites/all/modules/flexslider\";s:8:\"function\";s:26:\"theme_flexslider_list_item\";s:8:\"includes\";a:1:{i:0;s:55:\"sites/all/modules/flexslider/theme/flexslider.theme.inc\";}s:17:\"process functions\";a:1:{i:0;s:37:\"template_process_flexslider_list_item\";}}s:8:\"fivestar\";a:6:{s:14:\"render element\";s:7:\"element\";s:4:\"file\";s:27:\"includes/fivestar.theme.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:26:\"sites/all/modules/fivestar\";s:8:\"function\";s:14:\"theme_fivestar\";s:8:\"includes\";a:1:{i:0;s:54:\"sites/all/modules/fivestar/includes/fivestar.theme.inc\";}}s:15:\"fivestar_select\";a:6:{s:14:\"render element\";s:7:\"element\";s:4:\"file\";s:27:\"includes/fivestar.theme.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:26:\"sites/all/modules/fivestar\";s:8:\"function\";s:21:\"theme_fivestar_select\";s:8:\"includes\";a:1:{i:0;s:54:\"sites/all/modules/fivestar/includes/fivestar.theme.inc\";}}s:15:\"fivestar_static\";a:6:{s:9:\"variables\";a:4:{s:6:\"rating\";N;s:5:\"stars\";i:5;s:3:\"tag\";s:4:\"vote\";s:6:\"widget\";a:2:{s:4:\"name\";s:7:\"default\";s:3:\"css\";s:0:\"\";}}s:4:\"file\";s:27:\"includes/fivestar.theme.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:26:\"sites/all/modules/fivestar\";s:8:\"function\";s:21:\"theme_fivestar_static\";s:8:\"includes\";a:1:{i:0;s:54:\"sites/all/modules/fivestar/includes/fivestar.theme.inc\";}}s:23:\"fivestar_static_element\";a:6:{s:9:\"variables\";a:3:{s:12:\"star_display\";N;s:5:\"title\";N;s:11:\"description\";N;}s:4:\"file\";s:27:\"includes/fivestar.theme.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:26:\"sites/all/modules/fivestar\";s:8:\"function\";s:29:\"theme_fivestar_static_element\";s:8:\"includes\";a:1:{i:0;s:54:\"sites/all/modules/fivestar/includes/fivestar.theme.inc\";}}s:16:\"fivestar_summary\";a:6:{s:9:\"variables\";a:5:{s:11:\"user_rating\";N;s:14:\"average_rating\";N;s:5:\"votes\";i:0;s:5:\"stars\";i:5;s:9:\"microdata\";a:0:{}}s:4:\"file\";s:27:\"includes/fivestar.theme.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:26:\"sites/all/modules/fivestar\";s:8:\"function\";s:22:\"theme_fivestar_summary\";s:8:\"includes\";a:1:{i:0;s:54:\"sites/all/modules/fivestar/includes/fivestar.theme.inc\";}}s:16:\"fivestar_preview\";a:6:{s:9:\"variables\";a:5:{s:5:\"style\";N;s:4:\"text\";N;s:5:\"stars\";N;s:6:\"unvote\";N;s:5:\"title\";N;}s:4:\"file\";s:27:\"includes/fivestar.theme.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:26:\"sites/all/modules/fivestar\";s:8:\"function\";s:22:\"theme_fivestar_preview\";s:8:\"includes\";a:1:{i:0;s:54:\"sites/all/modules/fivestar/includes/fivestar.theme.inc\";}}s:23:\"fivestar_preview_widget\";a:6:{s:9:\"variables\";a:2:{s:3:\"css\";N;s:4:\"name\";N;}s:4:\"file\";s:27:\"includes/fivestar.theme.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:26:\"sites/all/modules/fivestar\";s:8:\"function\";s:29:\"theme_fivestar_preview_widget\";s:8:\"includes\";a:1:{i:0;s:54:\"sites/all/modules/fivestar/includes/fivestar.theme.inc\";}}s:24:\"fivestar_preview_wrapper\";a:6:{s:9:\"variables\";a:2:{s:7:\"content\";N;s:4:\"type\";s:6:\"direct\";}s:4:\"file\";s:27:\"includes/fivestar.theme.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:26:\"sites/all/modules/fivestar\";s:8:\"function\";s:30:\"theme_fivestar_preview_wrapper\";s:8:\"includes\";a:1:{i:0;s:54:\"sites/all/modules/fivestar/includes/fivestar.theme.inc\";}}s:17:\"fivestar_settings\";a:6:{s:14:\"render element\";s:4:\"form\";s:4:\"file\";s:27:\"includes/fivestar.theme.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:26:\"sites/all/modules/fivestar\";s:8:\"function\";s:23:\"theme_fivestar_settings\";s:8:\"includes\";a:1:{i:0;s:54:\"sites/all/modules/fivestar/includes/fivestar.theme.inc\";}}s:19:\"fivestar_color_form\";a:6:{s:14:\"render element\";s:4:\"form\";s:4:\"file\";s:27:\"includes/fivestar.theme.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:26:\"sites/all/modules/fivestar\";s:8:\"function\";s:25:\"theme_fivestar_color_form\";s:8:\"includes\";a:1:{i:0;s:54:\"sites/all/modules/fivestar/includes/fivestar.theme.inc\";}}s:26:\"fivestar_formatter_default\";a:6:{s:14:\"render element\";s:7:\"element\";s:4:\"file\";s:27:\"includes/fivestar.theme.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:26:\"sites/all/modules/fivestar\";s:8:\"function\";s:32:\"theme_fivestar_formatter_default\";s:8:\"includes\";a:1:{i:0;s:54:\"sites/all/modules/fivestar/includes/fivestar.theme.inc\";}}s:25:\"fivestar_formatter_rating\";a:6:{s:14:\"render element\";s:7:\"element\";s:4:\"file\";s:27:\"includes/fivestar.theme.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:26:\"sites/all/modules/fivestar\";s:8:\"function\";s:31:\"theme_fivestar_formatter_rating\";s:8:\"includes\";a:1:{i:0;s:54:\"sites/all/modules/fivestar/includes/fivestar.theme.inc\";}}s:29:\"fivestar_formatter_percentage\";a:6:{s:14:\"render element\";s:7:\"element\";s:4:\"file\";s:27:\"includes/fivestar.theme.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:26:\"sites/all/modules/fivestar\";s:8:\"function\";s:35:\"theme_fivestar_formatter_percentage\";s:8:\"includes\";a:1:{i:0;s:54:\"sites/all/modules/fivestar/includes/fivestar.theme.inc\";}}s:21:\"filter_admin_overview\";a:6:{s:14:\"render element\";s:4:\"form\";s:4:\"file\";s:16:\"filter.admin.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/filter\";s:8:\"function\";s:27:\"theme_filter_admin_overview\";s:8:\"includes\";a:1:{i:0;s:31:\"modules/filter/filter.admin.inc\";}}s:32:\"filter_admin_format_filter_order\";a:6:{s:14:\"render element\";s:7:\"element\";s:4:\"file\";s:16:\"filter.admin.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/filter\";s:8:\"function\";s:38:\"theme_filter_admin_format_filter_order\";s:8:\"includes\";a:1:{i:0;s:31:\"modules/filter/filter.admin.inc\";}}s:11:\"filter_tips\";a:6:{s:9:\"variables\";a:2:{s:4:\"tips\";N;s:4:\"long\";b:0;}s:4:\"file\";s:16:\"filter.pages.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/filter\";s:8:\"function\";s:17:\"theme_filter_tips\";s:8:\"includes\";a:1:{i:0;s:31:\"modules/filter/filter.pages.inc\";}}s:19:\"text_format_wrapper\";a:4:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/filter\";s:8:\"function\";s:25:\"theme_text_format_wrapper\";}s:21:\"filter_tips_more_info\";a:4:{s:9:\"variables\";a:0:{}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/filter\";s:8:\"function\";s:27:\"theme_filter_tips_more_info\";}s:17:\"filter_guidelines\";a:4:{s:9:\"variables\";a:1:{s:6:\"format\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/filter\";s:8:\"function\";s:23:\"theme_filter_guidelines\";}s:9:\"file_link\";a:4:{s:9:\"variables\";a:2:{s:4:\"file\";N;s:14:\"icon_directory\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:12:\"modules/file\";s:8:\"function\";s:15:\"theme_file_link\";}s:9:\"file_icon\";a:4:{s:9:\"variables\";a:3:{s:4:\"file\";N;s:14:\"icon_directory\";N;s:3:\"alt\";s:0:\"\";}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:12:\"modules/file\";s:8:\"function\";s:15:\"theme_file_icon\";}s:17:\"file_managed_file\";a:4:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:12:\"modules/file\";s:8:\"function\";s:23:\"theme_file_managed_file\";}s:11:\"file_widget\";a:4:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:12:\"modules/file\";s:8:\"function\";s:17:\"theme_file_widget\";}s:20:\"file_widget_multiple\";a:4:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:12:\"modules/file\";s:8:\"function\";s:26:\"theme_file_widget_multiple\";}s:20:\"file_formatter_table\";a:4:{s:9:\"variables\";a:1:{s:5:\"items\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:12:\"modules/file\";s:8:\"function\";s:26:\"theme_file_formatter_table\";}s:16:\"file_upload_help\";a:4:{s:9:\"variables\";a:2:{s:11:\"description\";N;s:17:\"upload_validators\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:12:\"modules/file\";s:8:\"function\";s:22:\"theme_file_upload_help\";}s:14:\"field_ui_table\";a:4:{s:14:\"render element\";s:8:\"elements\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:16:\"modules/field_ui\";s:8:\"function\";s:20:\"theme_field_ui_table\";}s:21:\"field_collection_item\";a:6:{s:14:\"render element\";s:8:\"elements\";s:8:\"template\";s:56:\"sites/all/modules/field_collection/field-collection-item\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:34:\"sites/all/modules/field_collection\";s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:21:\"contextual_preprocess\";i:2;s:31:\"field_group_build_entity_groups\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:21:\"field_collection_view\";a:4:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:34:\"sites/all/modules/field_collection\";s:8:\"function\";s:27:\"theme_field_collection_view\";}s:5:\"field\";a:6:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:13:\"modules/field\";s:8:\"function\";s:11:\"theme_field\";s:20:\"preprocess functions\";a:1:{i:0;s:25:\"template_preprocess_field\";}s:17:\"process functions\";a:1:{i:0;s:22:\"template_process_field\";}}s:25:\"field_multiple_value_form\";a:4:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:13:\"modules/field\";s:8:\"function\";s:31:\"theme_field_multiple_value_form\";}s:23:\"field_detailed_question\";a:4:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:21:\"sites/all/modules/faq\";s:8:\"function\";s:29:\"theme_field_detailed_question\";}s:34:\"faq_draggable_question_order_table\";a:4:{s:14:\"render element\";s:4:\"form\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:21:\"sites/all/modules/faq\";s:8:\"function\";s:40:\"theme_faq_draggable_question_order_table\";}s:17:\"faq_questions_top\";a:9:{s:4:\"path\";s:30:\"sites/all/modules/faq/includes\";s:4:\"file\";s:21:\"faq.questions_top.inc\";s:8:\"template\";s:17:\"faq-questions-top\";s:9:\"variables\";a:1:{s:4:\"data\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:21:\"sites/all/modules/faq\";s:8:\"includes\";a:1:{i:0;s:52:\"sites/all/modules/faq/includes/faq.questions_top.inc\";}s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:37:\"template_preprocess_faq_questions_top\";i:2;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:26:\"faq_category_questions_top\";a:9:{s:4:\"path\";s:30:\"sites/all/modules/faq/includes\";s:4:\"file\";s:21:\"faq.questions_top.inc\";s:8:\"template\";s:26:\"faq-category-questions-top\";s:9:\"variables\";a:6:{s:4:\"data\";N;s:14:\"display_header\";i:0;s:16:\"category_display\";N;s:4:\"term\";N;s:5:\"class\";N;s:11:\"parent_term\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:21:\"sites/all/modules/faq\";s:8:\"includes\";a:1:{i:0;s:52:\"sites/all/modules/faq/includes/faq.questions_top.inc\";}s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:46:\"template_preprocess_faq_category_questions_top\";i:2;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:34:\"faq_category_questions_top_answers\";a:9:{s:4:\"path\";s:30:\"sites/all/modules/faq/includes\";s:4:\"file\";s:21:\"faq.questions_top.inc\";s:8:\"template\";s:34:\"faq-category-questions-top-answers\";s:9:\"variables\";a:6:{s:4:\"data\";N;s:14:\"display_header\";i:0;s:16:\"category_display\";N;s:4:\"term\";N;s:5:\"class\";N;s:11:\"parent_term\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:21:\"sites/all/modules/faq\";s:8:\"includes\";a:1:{i:0;s:52:\"sites/all/modules/faq/includes/faq.questions_top.inc\";}s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:54:\"template_preprocess_faq_category_questions_top_answers\";i:2;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:15:\"faq_hide_answer\";a:9:{s:4:\"path\";s:30:\"sites/all/modules/faq/includes\";s:4:\"file\";s:19:\"faq.hide_answer.inc\";s:8:\"template\";s:15:\"faq-hide-answer\";s:9:\"variables\";a:1:{s:4:\"data\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:21:\"sites/all/modules/faq\";s:8:\"includes\";a:1:{i:0;s:50:\"sites/all/modules/faq/includes/faq.hide_answer.inc\";}s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:35:\"template_preprocess_faq_hide_answer\";i:2;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:24:\"faq_category_hide_answer\";a:9:{s:4:\"path\";s:30:\"sites/all/modules/faq/includes\";s:4:\"file\";s:19:\"faq.hide_answer.inc\";s:8:\"template\";s:24:\"faq-category-hide-answer\";s:9:\"variables\";a:6:{s:4:\"data\";N;s:14:\"display_header\";i:0;s:16:\"category_display\";N;s:4:\"term\";N;s:5:\"class\";N;s:11:\"parent_term\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:21:\"sites/all/modules/faq\";s:8:\"includes\";a:1:{i:0;s:50:\"sites/all/modules/faq/includes/faq.hide_answer.inc\";}s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:44:\"template_preprocess_faq_category_hide_answer\";i:2;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:20:\"faq_questions_inline\";a:9:{s:4:\"path\";s:30:\"sites/all/modules/faq/includes\";s:4:\"file\";s:24:\"faq.questions_inline.inc\";s:8:\"template\";s:20:\"faq-questions-inline\";s:9:\"variables\";a:1:{s:4:\"data\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:21:\"sites/all/modules/faq\";s:8:\"includes\";a:1:{i:0;s:55:\"sites/all/modules/faq/includes/faq.questions_inline.inc\";}s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:40:\"template_preprocess_faq_questions_inline\";i:2;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:29:\"faq_category_questions_inline\";a:9:{s:4:\"path\";s:30:\"sites/all/modules/faq/includes\";s:4:\"file\";s:24:\"faq.questions_inline.inc\";s:8:\"template\";s:29:\"faq-category-questions-inline\";s:9:\"variables\";a:6:{s:4:\"data\";N;s:14:\"display_header\";i:0;s:16:\"category_display\";N;s:4:\"term\";N;s:5:\"class\";N;s:11:\"parent_term\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:21:\"sites/all/modules/faq\";s:8:\"includes\";a:1:{i:0;s:55:\"sites/all/modules/faq/includes/faq.questions_inline.inc\";}s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:49:\"template_preprocess_faq_category_questions_inline\";i:2;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:12:\"faq_new_page\";a:9:{s:4:\"path\";s:30:\"sites/all/modules/faq/includes\";s:4:\"file\";s:16:\"faq.new_page.inc\";s:8:\"template\";s:12:\"faq-new-page\";s:9:\"variables\";a:1:{s:4:\"data\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:21:\"sites/all/modules/faq\";s:8:\"includes\";a:1:{i:0;s:47:\"sites/all/modules/faq/includes/faq.new_page.inc\";}s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:32:\"template_preprocess_faq_new_page\";i:2;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:21:\"faq_category_new_page\";a:9:{s:4:\"path\";s:30:\"sites/all/modules/faq/includes\";s:4:\"file\";s:16:\"faq.new_page.inc\";s:8:\"template\";s:21:\"faq-category-new-page\";s:9:\"variables\";a:6:{s:4:\"data\";N;s:14:\"display_header\";i:0;s:16:\"category_display\";N;s:4:\"term\";N;s:5:\"class\";N;s:11:\"parent_term\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:21:\"sites/all/modules/faq\";s:8:\"includes\";a:1:{i:0;s:47:\"sites/all/modules/faq/includes/faq.new_page.inc\";}s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:41:\"template_preprocess_faq_category_new_page\";i:2;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:8:\"faq_page\";a:4:{s:9:\"variables\";a:3:{s:7:\"content\";s:0:\"\";s:7:\"answers\";s:0:\"\";s:11:\"description\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:21:\"sites/all/modules/faq\";s:8:\"function\";s:14:\"theme_faq_page\";}s:13:\"entity_status\";a:6:{s:9:\"variables\";a:2:{s:6:\"status\";N;s:4:\"html\";b:1;}s:4:\"file\";s:22:\"theme/entity.theme.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:24:\"sites/all/modules/entity\";s:8:\"function\";s:19:\"theme_entity_status\";s:8:\"includes\";a:1:{i:0;s:47:\"sites/all/modules/entity/theme/entity.theme.inc\";}}s:6:\"entity\";a:10:{s:14:\"render element\";s:8:\"elements\";s:8:\"template\";s:6:\"entity\";s:7:\"pattern\";s:73:\"(field_collection_item|message_type_category|message_type|message)(\\.|__)\";s:4:\"path\";s:30:\"sites/all/modules/entity/theme\";s:4:\"file\";s:16:\"entity.theme.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:24:\"sites/all/modules/entity\";s:8:\"includes\";a:1:{i:0;s:47:\"sites/all/modules/entity/theme/entity.theme.inc\";}s:20:\"preprocess functions\";a:4:{i:0;s:19:\"template_preprocess\";i:1;s:26:\"template_preprocess_entity\";i:2;s:21:\"contextual_preprocess\";i:3;s:31:\"field_group_build_entity_groups\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:15:\"entity_property\";a:8:{s:14:\"render element\";s:8:\"elements\";s:4:\"file\";s:22:\"theme/entity.theme.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:24:\"sites/all/modules/entity\";s:8:\"function\";s:21:\"theme_entity_property\";s:8:\"includes\";a:1:{i:0;s:47:\"sites/all/modules/entity/theme/entity.theme.inc\";}s:20:\"preprocess functions\";a:1:{i:0;s:35:\"template_preprocess_entity_property\";}s:17:\"process functions\";a:1:{i:0;s:32:\"template_process_entity_property\";}}s:23:\"entity_ui_overview_item\";a:6:{s:9:\"variables\";a:4:{s:5:\"label\";N;s:11:\"entity_type\";N;s:3:\"url\";b:0;s:4:\"name\";b:0;}s:4:\"file\";s:22:\"includes/entity.ui.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:24:\"sites/all/modules/entity\";s:8:\"function\";s:29:\"theme_entity_ui_overview_item\";s:8:\"includes\";a:1:{i:0;s:47:\"sites/all/modules/entity/includes/entity.ui.inc\";}}s:13:\"dblog_message\";a:6:{s:9:\"variables\";a:2:{s:5:\"event\";N;s:4:\"link\";b:0;}s:4:\"file\";s:15:\"dblog.admin.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:13:\"modules/dblog\";s:8:\"function\";s:19:\"theme_dblog_message\";s:8:\"includes\";a:1:{i:0;s:29:\"modules/dblog/dblog.admin.inc\";}}s:22:\"date_views_filter_form\";a:9:{s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:39:\"sites/all/modules/date/date_views/theme\";s:8:\"template\";s:22:\"date-views-filter-form\";s:14:\"render element\";s:4:\"form\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:33:\"sites/all/modules/date/date_views\";s:8:\"includes\";a:2:{i:0;s:47:\"sites/all/modules/date/date_api/theme/theme.inc\";i:1;s:49:\"sites/all/modules/date/date_views/theme/theme.inc\";}s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:21:\"contextual_preprocess\";i:3;s:42:\"template_preprocess_date_views_filter_form\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:17:\"date_calendar_day\";a:7:{s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:39:\"sites/all/modules/date/date_views/theme\";s:9:\"variables\";a:1:{s:4:\"date\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:33:\"sites/all/modules/date/date_views\";s:8:\"function\";s:23:\"theme_date_calendar_day\";s:8:\"includes\";a:2:{i:0;s:47:\"sites/all/modules/date/date_api/theme/theme.inc\";i:1;s:49:\"sites/all/modules/date/date_views/theme/theme.inc\";}}s:16:\"date_views_pager\";a:10:{s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:39:\"sites/all/modules/date/date_views/theme\";s:9:\"variables\";a:2:{s:6:\"plugin\";N;s:5:\"input\";N;}s:7:\"pattern\";s:18:\"date_views_pager__\";s:8:\"template\";s:16:\"date-views-pager\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:33:\"sites/all/modules/date/date_views\";s:8:\"includes\";a:1:{i:0;s:49:\"sites/all/modules/date/date_views/theme/theme.inc\";}s:20:\"preprocess functions\";a:4:{i:0;s:19:\"template_preprocess\";i:1;s:36:\"template_preprocess_date_views_pager\";i:2;s:36:\"calendar_preprocess_date_views_pager\";i:3;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:13:\"date_timezone\";a:7:{s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:37:\"sites/all/modules/date/date_api/theme\";s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/date/date_api\";s:8:\"function\";s:19:\"theme_date_timezone\";s:8:\"includes\";a:1:{i:0;s:47:\"sites/all/modules/date/date_api/theme/theme.inc\";}}s:11:\"date_select\";a:7:{s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:37:\"sites/all/modules/date/date_api/theme\";s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/date/date_api\";s:8:\"function\";s:17:\"theme_date_select\";s:8:\"includes\";a:1:{i:0;s:47:\"sites/all/modules/date/date_api/theme/theme.inc\";}}s:9:\"date_text\";a:7:{s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:37:\"sites/all/modules/date/date_api/theme\";s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/date/date_api\";s:8:\"function\";s:15:\"theme_date_text\";s:8:\"includes\";a:1:{i:0;s:47:\"sites/all/modules/date/date_api/theme/theme.inc\";}}s:19:\"date_select_element\";a:7:{s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:37:\"sites/all/modules/date/date_api/theme\";s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/date/date_api\";s:8:\"function\";s:25:\"theme_date_select_element\";s:8:\"includes\";a:1:{i:0;s:47:\"sites/all/modules/date/date_api/theme/theme.inc\";}}s:22:\"date_textfield_element\";a:7:{s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:37:\"sites/all/modules/date/date_api/theme\";s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/date/date_api\";s:8:\"function\";s:28:\"theme_date_textfield_element\";s:8:\"includes\";a:1:{i:0;s:47:\"sites/all/modules/date/date_api/theme/theme.inc\";}}s:21:\"date_part_hour_prefix\";a:7:{s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:37:\"sites/all/modules/date/date_api/theme\";s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/date/date_api\";s:8:\"function\";s:27:\"theme_date_part_hour_prefix\";s:8:\"includes\";a:1:{i:0;s:47:\"sites/all/modules/date/date_api/theme/theme.inc\";}}s:23:\"date_part_minsec_prefix\";a:7:{s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:37:\"sites/all/modules/date/date_api/theme\";s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/date/date_api\";s:8:\"function\";s:29:\"theme_date_part_minsec_prefix\";s:8:\"includes\";a:1:{i:0;s:47:\"sites/all/modules/date/date_api/theme/theme.inc\";}}s:20:\"date_part_label_year\";a:7:{s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:37:\"sites/all/modules/date/date_api/theme\";s:9:\"variables\";a:2:{s:9:\"date_part\";N;s:7:\"element\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/date/date_api\";s:8:\"function\";s:26:\"theme_date_part_label_year\";s:8:\"includes\";a:1:{i:0;s:47:\"sites/all/modules/date/date_api/theme/theme.inc\";}}s:21:\"date_part_label_month\";a:7:{s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:37:\"sites/all/modules/date/date_api/theme\";s:9:\"variables\";a:2:{s:9:\"date_part\";N;s:7:\"element\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/date/date_api\";s:8:\"function\";s:27:\"theme_date_part_label_month\";s:8:\"includes\";a:1:{i:0;s:47:\"sites/all/modules/date/date_api/theme/theme.inc\";}}s:19:\"date_part_label_day\";a:7:{s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:37:\"sites/all/modules/date/date_api/theme\";s:9:\"variables\";a:2:{s:9:\"date_part\";N;s:7:\"element\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/date/date_api\";s:8:\"function\";s:25:\"theme_date_part_label_day\";s:8:\"includes\";a:1:{i:0;s:47:\"sites/all/modules/date/date_api/theme/theme.inc\";}}s:20:\"date_part_label_hour\";a:7:{s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:37:\"sites/all/modules/date/date_api/theme\";s:9:\"variables\";a:2:{s:9:\"date_part\";N;s:7:\"element\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/date/date_api\";s:8:\"function\";s:26:\"theme_date_part_label_hour\";s:8:\"includes\";a:1:{i:0;s:47:\"sites/all/modules/date/date_api/theme/theme.inc\";}}s:22:\"date_part_label_minute\";a:7:{s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:37:\"sites/all/modules/date/date_api/theme\";s:9:\"variables\";a:2:{s:9:\"date_part\";N;s:7:\"element\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/date/date_api\";s:8:\"function\";s:28:\"theme_date_part_label_minute\";s:8:\"includes\";a:1:{i:0;s:47:\"sites/all/modules/date/date_api/theme/theme.inc\";}}s:22:\"date_part_label_second\";a:7:{s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:37:\"sites/all/modules/date/date_api/theme\";s:9:\"variables\";a:2:{s:9:\"date_part\";N;s:7:\"element\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/date/date_api\";s:8:\"function\";s:28:\"theme_date_part_label_second\";s:8:\"includes\";a:1:{i:0;s:47:\"sites/all/modules/date/date_api/theme/theme.inc\";}}s:20:\"date_part_label_ampm\";a:7:{s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:37:\"sites/all/modules/date/date_api/theme\";s:9:\"variables\";a:2:{s:9:\"date_part\";N;s:7:\"element\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/date/date_api\";s:8:\"function\";s:26:\"theme_date_part_label_ampm\";s:8:\"includes\";a:1:{i:0;s:47:\"sites/all/modules/date/date_api/theme/theme.inc\";}}s:24:\"date_part_label_timezone\";a:7:{s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:37:\"sites/all/modules/date/date_api/theme\";s:9:\"variables\";a:2:{s:9:\"date_part\";N;s:7:\"element\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/date/date_api\";s:8:\"function\";s:30:\"theme_date_part_label_timezone\";s:8:\"includes\";a:1:{i:0;s:47:\"sites/all/modules/date/date_api/theme/theme.inc\";}}s:20:\"date_part_label_date\";a:7:{s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:37:\"sites/all/modules/date/date_api/theme\";s:9:\"variables\";a:2:{s:9:\"date_part\";N;s:7:\"element\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/date/date_api\";s:8:\"function\";s:26:\"theme_date_part_label_date\";s:8:\"includes\";a:1:{i:0;s:47:\"sites/all/modules/date/date_api/theme/theme.inc\";}}s:20:\"date_part_label_time\";a:7:{s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:37:\"sites/all/modules/date/date_api/theme\";s:9:\"variables\";a:2:{s:9:\"date_part\";N;s:7:\"element\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/date/date_api\";s:8:\"function\";s:26:\"theme_date_part_label_time\";s:8:\"includes\";a:1:{i:0;s:47:\"sites/all/modules/date/date_api/theme/theme.inc\";}}s:13:\"date_time_ago\";a:7:{s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:37:\"sites/all/modules/date/date_api/theme\";s:9:\"variables\";a:3:{s:10:\"start_date\";N;s:8:\"end_date\";N;s:8:\"interval\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/date/date_api\";s:8:\"function\";s:19:\"theme_date_time_ago\";s:8:\"includes\";a:1:{i:0;s:47:\"sites/all/modules/date/date_api/theme/theme.inc\";}}s:9:\"dashboard\";a:4:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:17:\"modules/dashboard\";s:8:\"function\";s:15:\"theme_dashboard\";}s:15:\"dashboard_admin\";a:4:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:17:\"modules/dashboard\";s:8:\"function\";s:21:\"theme_dashboard_admin\";}s:16:\"dashboard_region\";a:4:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:17:\"modules/dashboard\";s:8:\"function\";s:22:\"theme_dashboard_region\";}s:25:\"dashboard_disabled_blocks\";a:4:{s:9:\"variables\";a:1:{s:6:\"blocks\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:17:\"modules/dashboard\";s:8:\"function\";s:31:\"theme_dashboard_disabled_blocks\";}s:24:\"dashboard_disabled_block\";a:4:{s:9:\"variables\";a:1:{s:5:\"block\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:17:\"modules/dashboard\";s:8:\"function\";s:30:\"theme_dashboard_disabled_block\";}s:28:\"dashboard_admin_display_form\";a:9:{s:8:\"template\";s:24:\"block-admin-display-form\";s:4:\"path\";s:13:\"modules/block\";s:4:\"file\";s:15:\"block.admin.inc\";s:14:\"render element\";s:4:\"form\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:17:\"modules/dashboard\";s:8:\"includes\";a:1:{i:0;s:29:\"modules/block/block.admin.inc\";}s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:48:\"template_preprocess_dashboard_admin_display_form\";i:2;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:15:\"ctools_dropdown\";a:6:{s:9:\"variables\";a:4:{s:5:\"title\";N;s:5:\"links\";N;s:5:\"image\";b:0;s:5:\"class\";s:0:\"\";}s:4:\"file\";s:27:\"includes/dropdown.theme.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:24:\"sites/all/modules/ctools\";s:8:\"function\";s:21:\"theme_ctools_dropdown\";s:8:\"includes\";a:1:{i:0;s:52:\"sites/all/modules/ctools/includes/dropdown.theme.inc\";}}s:18:\"ctools_collapsible\";a:6:{s:9:\"variables\";a:3:{s:6:\"handle\";N;s:7:\"content\";N;s:9:\"collapsed\";b:0;}s:4:\"file\";s:30:\"includes/collapsible.theme.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:24:\"sites/all/modules/ctools\";s:8:\"function\";s:24:\"theme_ctools_collapsible\";s:8:\"includes\";a:1:{i:0;s:55:\"sites/all/modules/ctools/includes/collapsible.theme.inc\";}}s:29:\"ctools_collapsible_remembered\";a:6:{s:9:\"variables\";a:4:{s:2:\"id\";N;s:6:\"handle\";N;s:7:\"content\";N;s:9:\"collapsed\";b:0;}s:4:\"file\";s:30:\"includes/collapsible.theme.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:24:\"sites/all/modules/ctools\";s:8:\"function\";s:35:\"theme_ctools_collapsible_remembered\";s:8:\"includes\";a:1:{i:0;s:55:\"sites/all/modules/ctools/includes/collapsible.theme.inc\";}}s:19:\"ctools_wizard_trail\";a:6:{s:9:\"variables\";a:3:{s:5:\"trail\";N;s:9:\"form_info\";N;s:7:\"divider\";s:4:\" » \";}s:4:\"file\";s:25:\"includes/wizard.theme.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:24:\"sites/all/modules/ctools\";s:8:\"function\";s:25:\"theme_ctools_wizard_trail\";s:8:\"includes\";a:1:{i:0;s:50:\"sites/all/modules/ctools/includes/wizard.theme.inc\";}}s:24:\"links__ctools_dropbutton\";a:6:{s:9:\"variables\";a:4:{s:5:\"title\";N;s:5:\"links\";N;s:5:\"image\";b:0;s:5:\"class\";N;}s:4:\"file\";s:29:\"includes/dropbutton.theme.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:24:\"sites/all/modules/ctools\";s:8:\"function\";s:30:\"theme_links__ctools_dropbutton\";s:8:\"includes\";a:1:{i:0;s:54:\"sites/all/modules/ctools/includes/dropbutton.theme.inc\";}}s:33:\"ctools_stylizer_color_scheme_form\";a:6:{s:14:\"render element\";s:4:\"form\";s:4:\"file\";s:21:\"includes/stylizer.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:24:\"sites/all/modules/ctools\";s:8:\"function\";s:39:\"theme_ctools_stylizer_color_scheme_form\";s:8:\"includes\";a:1:{i:0;s:46:\"sites/all/modules/ctools/includes/stylizer.inc\";}}s:28:\"ctools_stylizer_preview_form\";a:6:{s:14:\"render element\";s:4:\"form\";s:4:\"file\";s:21:\"includes/stylizer.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:24:\"sites/all/modules/ctools\";s:8:\"function\";s:34:\"theme_ctools_stylizer_preview_form\";s:8:\"includes\";a:1:{i:0;s:46:\"sites/all/modules/ctools/includes/stylizer.inc\";}}s:17:\"ctools_style_icon\";a:6:{s:9:\"variables\";a:2:{s:5:\"image\";N;s:5:\"title\";N;}s:4:\"file\";s:21:\"includes/stylizer.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:24:\"sites/all/modules/ctools\";s:8:\"function\";s:23:\"theme_ctools_style_icon\";s:8:\"includes\";a:1:{i:0;s:46:\"sites/all/modules/ctools/includes/stylizer.inc\";}}s:33:\"ctools_menu_local_actions_wrapper\";a:6:{s:14:\"render element\";s:5:\"links\";s:4:\"file\";s:31:\"includes/action-links.theme.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:24:\"sites/all/modules/ctools\";s:8:\"function\";s:39:\"theme_ctools_menu_local_actions_wrapper\";s:8:\"includes\";a:1:{i:0;s:56:\"sites/all/modules/ctools/includes/action-links.theme.inc\";}}s:19:\"ctools_context_list\";a:6:{s:9:\"variables\";a:1:{s:6:\"object\";N;}s:4:\"file\";s:26:\"includes/context.theme.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:24:\"sites/all/modules/ctools\";s:8:\"function\";s:25:\"theme_ctools_context_list\";s:8:\"includes\";a:1:{i:0;s:51:\"sites/all/modules/ctools/includes/context.theme.inc\";}}s:28:\"ctools_context_list_no_table\";a:6:{s:9:\"variables\";a:1:{s:6:\"object\";N;}s:4:\"file\";s:26:\"includes/context.theme.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:24:\"sites/all/modules/ctools\";s:8:\"function\";s:34:\"theme_ctools_context_list_no_table\";s:8:\"includes\";a:1:{i:0;s:51:\"sites/all/modules/ctools/includes/context.theme.inc\";}}s:24:\"ctools_context_item_form\";a:6:{s:14:\"render element\";s:4:\"form\";s:4:\"file\";s:26:\"includes/context.theme.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:24:\"sites/all/modules/ctools\";s:8:\"function\";s:30:\"theme_ctools_context_item_form\";s:8:\"includes\";a:1:{i:0;s:51:\"sites/all/modules/ctools/includes/context.theme.inc\";}}s:23:\"ctools_context_item_row\";a:6:{s:9:\"variables\";a:5:{s:4:\"type\";N;s:4:\"form\";N;s:8:\"position\";N;s:5:\"count\";N;s:7:\"with_tr\";b:1;}s:4:\"file\";s:26:\"includes/context.theme.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:24:\"sites/all/modules/ctools\";s:8:\"function\";s:29:\"theme_ctools_context_item_row\";s:8:\"includes\";a:1:{i:0;s:51:\"sites/all/modules/ctools/includes/context.theme.inc\";}}s:23:\"ctools_access_admin_add\";a:6:{s:14:\"render element\";s:4:\"form\";s:4:\"file\";s:33:\"includes/context-access-admin.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:24:\"sites/all/modules/ctools\";s:8:\"function\";s:29:\"theme_ctools_access_admin_add\";s:8:\"includes\";a:1:{i:0;s:58:\"sites/all/modules/ctools/includes/context-access-admin.inc\";}}s:13:\"comment_block\";a:4:{s:9:\"variables\";a:0:{}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:15:\"modules/comment\";s:8:\"function\";s:19:\"theme_comment_block\";}s:15:\"comment_preview\";a:4:{s:9:\"variables\";a:1:{s:7:\"comment\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:15:\"modules/comment\";s:8:\"function\";s:21:\"theme_comment_preview\";}s:7:\"comment\";a:6:{s:8:\"template\";s:23:\"modules/comment/comment\";s:14:\"render element\";s:8:\"elements\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:27:\"sites/all/themes/forum_plus\";s:20:\"preprocess functions\";a:7:{i:0;s:19:\"template_preprocess\";i:1;s:27:\"template_preprocess_comment\";i:2;s:21:\"contextual_preprocess\";i:3;s:24:\"views_preprocess_comment\";i:4;s:33:\"advanced_forum_preprocess_comment\";i:5;s:29:\"forum_plus_preprocess_comment\";i:6;s:31:\"field_group_build_entity_groups\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:22:\"comment_post_forbidden\";a:4:{s:9:\"variables\";a:1:{s:4:\"node\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:15:\"modules/comment\";s:8:\"function\";s:28:\"theme_comment_post_forbidden\";}s:15:\"comment_wrapper\";a:6:{s:8:\"template\";s:31:\"modules/comment/comment-wrapper\";s:14:\"render element\";s:7:\"content\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:15:\"modules/comment\";s:20:\"preprocess functions\";a:4:{i:0;s:19:\"template_preprocess\";i:1;s:35:\"template_preprocess_comment_wrapper\";i:2;s:21:\"contextual_preprocess\";i:3;s:41:\"advanced_forum_preprocess_comment_wrapper\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:17:\"color_scheme_form\";a:4:{s:14:\"render element\";s:4:\"form\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:13:\"modules/color\";s:8:\"function\";s:23:\"theme_color_scheme_form\";}s:13:\"calendar_item\";a:9:{s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:32:\"sites/all/modules/calendar/theme\";s:8:\"template\";s:13:\"calendar-item\";s:9:\"variables\";a:3:{s:4:\"view\";N;s:15:\"rendered_fields\";N;s:4:\"item\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:26:\"sites/all/modules/calendar\";s:8:\"includes\";a:1:{i:0;s:42:\"sites/all/modules/calendar/theme/theme.inc\";}s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:33:\"template_preprocess_calendar_item\";i:2;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:16:\"calendar_datebox\";a:9:{s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:32:\"sites/all/modules/calendar/theme\";s:8:\"template\";s:16:\"calendar-datebox\";s:9:\"variables\";a:4:{s:4:\"date\";N;s:4:\"view\";N;s:5:\"items\";N;s:8:\"selected\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:26:\"sites/all/modules/calendar\";s:8:\"includes\";a:1:{i:0;s:42:\"sites/all/modules/calendar/theme/theme.inc\";}s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:36:\"template_preprocess_calendar_datebox\";i:2;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:18:\"calendar_empty_day\";a:7:{s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:32:\"sites/all/modules/calendar/theme\";s:9:\"variables\";a:2:{s:6:\"curday\";N;s:4:\"view\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:26:\"sites/all/modules/calendar\";s:8:\"function\";s:24:\"theme_calendar_empty_day\";s:8:\"includes\";a:1:{i:0;s:42:\"sites/all/modules/calendar/theme/theme.inc\";}}s:22:\"calendar_stripe_legend\";a:7:{s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:32:\"sites/all/modules/calendar/theme\";s:9:\"variables\";a:1:{s:4:\"view\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:26:\"sites/all/modules/calendar\";s:8:\"function\";s:28:\"theme_calendar_stripe_legend\";s:8:\"includes\";a:1:{i:0;s:42:\"sites/all/modules/calendar/theme/theme.inc\";}}s:22:\"calendar_stripe_stripe\";a:7:{s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:32:\"sites/all/modules/calendar/theme\";s:9:\"variables\";a:1:{s:4:\"node\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:26:\"sites/all/modules/calendar\";s:8:\"function\";s:28:\"theme_calendar_stripe_stripe\";s:8:\"includes\";a:1:{i:0;s:42:\"sites/all/modules/calendar/theme/theme.inc\";}}s:25:\"calendar_time_row_heading\";a:7:{s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:32:\"sites/all/modules/calendar/theme\";s:9:\"variables\";a:3:{s:10:\"start_time\";N;s:15:\"next_start_time\";N;s:11:\"curday_date\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:26:\"sites/all/modules/calendar\";s:8:\"function\";s:31:\"theme_calendar_time_row_heading\";s:8:\"includes\";a:1:{i:0;s:42:\"sites/all/modules/calendar/theme/theme.inc\";}}s:18:\"calendar_month_col\";a:9:{s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:32:\"sites/all/modules/calendar/theme\";s:8:\"template\";s:18:\"calendar-month-col\";s:9:\"variables\";a:1:{s:4:\"item\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:26:\"sites/all/modules/calendar\";s:8:\"includes\";a:1:{i:0;s:42:\"sites/all/modules/calendar/theme/theme.inc\";}s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:18:\"calendar_month_row\";a:9:{s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:32:\"sites/all/modules/calendar/theme\";s:8:\"template\";s:18:\"calendar-month-row\";s:9:\"variables\";a:3:{s:5:\"inner\";N;s:5:\"class\";N;s:6:\"iehint\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:26:\"sites/all/modules/calendar\";s:8:\"includes\";a:1:{i:0;s:42:\"sites/all/modules/calendar/theme/theme.inc\";}s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:30:\"calendar_month_multiple_entity\";a:9:{s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:32:\"sites/all/modules/calendar/theme\";s:8:\"template\";s:30:\"calendar-month-multiple-entity\";s:9:\"variables\";a:4:{s:16:\"\n         curday\";N;s:5:\"count\";N;s:4:\"view\";N;s:3:\"ids\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:26:\"sites/all/modules/calendar\";s:8:\"includes\";a:1:{i:0;s:42:\"sites/all/modules/calendar/theme/theme.inc\";}s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:50:\"template_preprocess_calendar_month_multiple_entity\";i:2;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:15:\"book_navigation\";a:6:{s:9:\"variables\";a:1:{s:9:\"book_link\";N;}s:8:\"template\";s:28:\"modules/book/book-navigation\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:12:\"modules/book\";s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:35:\"template_preprocess_book_navigation\";i:2;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:16:\"book_export_html\";a:6:{s:9:\"variables\";a:3:{s:5:\"title\";N;s:8:\"contents\";N;s:5:\"depth\";N;}s:8:\"template\";s:29:\"modules/book/book-export-html\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:12:\"modules/book\";s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:36:\"template_preprocess_book_export_html\";i:2;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:16:\"book_admin_table\";a:4:{s:14:\"render element\";s:4:\"form\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:12:\"modules/book\";s:8:\"function\";s:22:\"theme_book_admin_table\";}s:15:\"book_title_link\";a:4:{s:9:\"variables\";a:1:{s:4:\"link\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:12:\"modules/book\";s:8:\"function\";s:21:\"theme_book_title_link\";}s:20:\"book_all_books_block\";a:6:{s:14:\"render element\";s:10:\"book_menus\";s:8:\"template\";s:33:\"modules/book/book-all-books-block\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:12:\"modules/book\";s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:40:\"template_preprocess_book_all_books_block\";i:2;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:21:\"book_node_export_html\";a:6:{s:9:\"variables\";a:2:{s:4:\"node\";N;s:8:\"children\";N;}s:8:\"template\";s:34:\"modules/book/book-node-export-html\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:12:\"modules/book\";s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:41:\"template_preprocess_book_node_export_html\";i:2;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:11:\"author_pane\";a:6:{s:8:\"template\";s:41:\"sites/all/modules/author_pane/author-pane\";s:9:\"variables\";a:6:{s:7:\"account\";N;s:6:\"caller\";N;s:14:\"picture_preset\";N;s:7:\"context\";N;s:11:\"disable_css\";N;s:14:\"join_date_type\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:29:\"sites/all/modules/author_pane\";s:20:\"preprocess functions\";a:5:{i:0;s:19:\"template_preprocess\";i:1;s:31:\"template_preprocess_author_pane\";i:2;s:30:\"contact_preprocess_author_pane\";i:3;s:21:\"contextual_preprocess\";i:4;s:37:\"advanced_forum_preprocess_author_pane\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:24:\"author_pane_user_picture\";a:6:{s:8:\"template\";s:54:\"sites/all/modules/author_pane/author-pane-user-picture\";s:9:\"variables\";a:3:{s:7:\"account\";N;s:6:\"caller\";N;s:14:\"picture_preset\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:29:\"sites/all/modules/author_pane\";s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:44:\"template_preprocess_author_pane_user_picture\";i:2;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:12:\"webform_view\";a:4:{s:14:\"render element\";s:7:\"webform\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:25:\"sites/all/modules/webform\";s:8:\"function\";s:18:\"theme_webform_view\";}s:21:\"webform_view_messages\";a:4:{s:9:\"variables\";a:8:{s:4:\"node\";N;s:4:\"page\";N;s:16:\"submission_count\";N;s:19:\"user_limit_exceeded\";N;s:20:\"total_limit_exceeded\";N;s:13:\"allowed_roles\";N;s:6:\"closed\";N;s:6:\"cached\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:25:\"sites/all/modules/webform\";s:8:\"function\";s:27:\"theme_webform_view_messages\";}s:12:\"webform_form\";a:7:{s:14:\"render element\";s:4:\"form\";s:8:\"template\";s:48:\"sites/all/modules/webform/templates/webform-form\";s:7:\"pattern\";s:19:\"webform_form_[0-9]+\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:25:\"sites/all/modules/webform\";s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:32:\"template_preprocess_webform_form\";i:2;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:20:\"webform_confirmation\";a:7:{s:9:\"variables\";a:2:{s:4:\"node\";N;s:3:\"sid\";N;}s:8:\"template\";s:56:\"sites/all/modules/webform/templates/webform-confirmation\";s:7:\"pattern\";s:27:\"webform_confirmation_[0-9]+\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:25:\"sites/all/modules/webform\";s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:40:\"template_preprocess_webform_confirmation\";i:2;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:15:\"webform_element\";a:5:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:25:\"sites/all/modules/webform\";s:8:\"function\";s:21:\"theme_webform_element\";s:20:\"preprocess functions\";a:1:{i:0;s:35:\"template_preprocess_webform_element\";}}s:20:\"webform_element_text\";a:4:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:25:\"sites/all/modules/webform\";s:8:\"function\";s:26:\"theme_webform_element_text\";}s:20:\"webform_inline_radio\";a:4:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:25:\"sites/all/modules/webform\";s:8:\"function\";s:26:\"theme_webform_inline_radio\";}s:26:\"webform_inline_radio_label\";a:4:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:25:\"sites/all/modules/webform\";s:8:\"function\";s:32:\"theme_webform_inline_radio_label\";}s:19:\"webform_progressbar\";a:6:{s:9:\"variables\";a:4:{s:4:\"node\";N;s:8:\"page_num\";N;s:10:\"page_count\";N;s:11:\"page_labels\";a:0:{}}s:8:\"template\";s:55:\"sites/all/modules/webform/templates/webform-progressbar\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:25:\"sites/all/modules/webform\";s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:39:\"template_preprocess_webform_progressbar\";i:2;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:20:\"webform_mail_message\";a:7:{s:9:\"variables\";a:3:{s:4:\"node\";N;s:10:\"submission\";N;s:5:\"email\";N;}s:8:\"template\";s:48:\"sites/all/modules/webform/templates/webform-mail\";s:7:\"pattern\";s:22:\"webform_mail(_[0-9]+)?\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:25:\"sites/all/modules/webform\";s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:40:\"template_preprocess_webform_mail_message\";i:2;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:20:\"webform_mail_headers\";a:5:{s:9:\"variables\";a:3:{s:4:\"node\";N;s:10:\"submission\";N;s:5:\"email\";N;}s:7:\"pattern\";s:27:\"webform_mail_headers_[0-9]+\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:25:\"sites/all/modules/webform\";s:8:\"function\";s:26:\"theme_webform_mail_headers\";}s:18:\"webform_token_help\";a:4:{s:9:\"variables\";a:1:{s:6:\"groups\";a:1:{i:0;s:4:\"node\";}}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:25:\"sites/all/modules/webform\";s:8:\"function\";s:24:\"theme_webform_token_help\";}s:22:\"webform_admin_settings\";a:6:{s:14:\"render element\";s:4:\"form\";s:4:\"file\";s:26:\"includes/webform.admin.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:25:\"sites/all/modules/webform\";s:8:\"function\";s:28:\"theme_webform_admin_settings\";s:8:\"includes\";a:1:{i:0;s:52:\"sites/all/modules/webform/includes/webform.admin.inc\";}}s:21:\"webform_admin_content\";a:6:{s:9:\"variables\";a:1:{s:5:\"nodes\";N;}s:4:\"file\";s:26:\"includes/webform.admin.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:25:\"sites/all/modules/webform\";s:8:\"function\";s:27:\"theme_webform_admin_content\";s:8:\"includes\";a:1:{i:0;s:52:\"sites/all/modules/webform/includes/webform.admin.inc\";}}s:19:\"webform_emails_form\";a:6:{s:14:\"render element\";s:4:\"form\";s:4:\"file\";s:27:\"includes/webform.emails.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:25:\"sites/all/modules/webform\";s:8:\"function\";s:25:\"theme_webform_emails_form\";s:8:\"includes\";a:1:{i:0;s:53:\"sites/all/modules/webform/includes/webform.emails.inc\";}}s:31:\"webform_email_component_mapping\";a:6:{s:14:\"render element\";s:7:\"element\";s:4:\"file\";s:27:\"includes/webform.emails.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:25:\"sites/all/modules/webform\";s:8:\"function\";s:37:\"theme_webform_email_component_mapping\";s:8:\"includes\";a:1:{i:0;s:53:\"sites/all/modules/webform/includes/webform.emails.inc\";}}s:22:\"webform_email_add_form\";a:6:{s:14:\"render element\";s:4:\"form\";s:4:\"file\";s:27:\"includes/webform.emails.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:25:\"sites/all/modules/webform\";s:8:\"function\";s:28:\"theme_webform_email_add_form\";s:8:\"includes\";a:1:{i:0;s:53:\"sites/all/modules/webform/includes/webform.emails.inc\";}}s:23:\"webform_email_edit_form\";a:6:{s:14:\"render element\";s:4:\"form\";s:4:\"file\";s:27:\"includes/webform.emails.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:25:\"sites/all/modules/webform\";s:8:\"function\";s:29:\"theme_webform_email_edit_form\";s:8:\"includes\";a:1:{i:0;s:53:\"sites/all/modules/webform/includes/webform.emails.inc\";}}s:23:\"webform_components_page\";a:6:{s:9:\"variables\";a:2:{s:4:\"node\";N;s:4:\"form\";N;}s:4:\"file\";s:31:\"includes/webform.components.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:25:\"sites/all/modules/webform\";s:8:\"function\";s:29:\"theme_webform_components_page\";s:8:\"includes\";a:1:{i:0;s:57:\"sites/all/modules/webform/includes/webform.components.inc\";}}s:23:\"webform_components_form\";a:7:{s:14:\"render element\";s:4:\"form\";s:4:\"file\";s:31:\"includes/webform.components.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:25:\"sites/all/modules/webform\";s:8:\"function\";s:29:\"theme_webform_components_form\";s:8:\"includes\";a:1:{i:0;s:57:\"sites/all/modules/webform/includes/webform.components.inc\";}s:20:\"preprocess functions\";a:1:{i:0;s:43:\"template_preprocess_webform_components_form\";}}s:24:\"webform_component_select\";a:6:{s:14:\"render element\";s:7:\"element\";s:4:\"file\";s:31:\"includes/webform.components.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:25:\"sites/all/modules/webform\";s:8:\"function\";s:30:\"theme_webform_component_select\";s:8:\"includes\";a:1:{i:0;s:57:\"sites/all/modules/webform/includes/webform.components.inc\";}}s:26:\"webform_conditional_groups\";a:6:{s:14:\"render element\";s:7:\"element\";s:4:\"file\";s:33:\"includes/webform.conditionals.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:25:\"sites/all/modules/webform\";s:8:\"function\";s:32:\"theme_webform_conditional_groups\";s:8:\"includes\";a:1:{i:0;s:59:\"sites/all/modules/webform/includes/webform.conditionals.inc\";}}s:29:\"webform_conditional_group_row\";a:6:{s:14:\"render element\";s:7:\"element\";s:4:\"file\";s:33:\"includes/webform.conditionals.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:25:\"sites/all/modules/webform\";s:8:\"function\";s:35:\"theme_webform_conditional_group_row\";s:8:\"includes\";a:1:{i:0;s:59:\"sites/all/modules/webform/includes/webform.conditionals.inc\";}}s:19:\"webform_conditional\";a:6:{s:14:\"render element\";s:7:\"element\";s:4:\"file\";s:33:\"includes/webform.conditionals.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:25:\"sites/all/modules/webform\";s:8:\"function\";s:25:\"theme_webform_conditional\";s:8:\"includes\";a:1:{i:0;s:59:\"sites/all/modules/webform/includes/webform.conditionals.inc\";}}s:33:\"webform_advanced_redirection_form\";a:6:{s:14:\"render element\";s:4:\"form\";s:4:\"file\";s:26:\"includes/webform.pages.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:25:\"sites/all/modules/webform\";s:8:\"function\";s:39:\"theme_webform_advanced_redirection_form\";s:8:\"includes\";a:1:{i:0;s:52:\"sites/all/modules/webform/includes/webform.pages.inc\";}}s:34:\"webform_advanced_submit_limit_form\";a:6:{s:14:\"render element\";s:4:\"form\";s:4:\"file\";s:26:\"includes/webform.pages.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:25:\"sites/all/modules/webform\";s:8:\"function\";s:40:\"theme_webform_advanced_submit_limit_form\";s:8:\"includes\";a:1:{i:0;s:52:\"sites/all/modules/webform/includes/webform.pages.inc\";}}s:40:\"webform_advanced_total_submit_limit_form\";a:6:{s:14:\"render element\";s:4:\"form\";s:4:\"file\";s:26:\"includes/webform.pages.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:25:\"sites/all/modules/webform\";s:8:\"function\";s:46:\"theme_webform_advanced_total_submit_limit_form\";s:8:\"includes\";a:1:{i:0;s:52:\"sites/all/modules/webform/includes/webform.pages.inc\";}}s:24:\"webform_results_per_page\";a:6:{s:9:\"variables\";a:2:{s:11:\"total_count\";N;s:11:\"pager_count\";N;}s:4:\"file\";s:27:\"includes/webform.report.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:25:\"sites/all/modules/webform\";s:8:\"function\";s:30:\"theme_webform_results_per_page\";s:8:\"includes\";a:1:{i:0;s:53:\"sites/all/modules/webform/includes/webform.report.inc\";}}s:34:\"webform_results_submissions_header\";a:6:{s:9:\"variables\";a:1:{s:4:\"node\";N;}s:4:\"file\";s:27:\"includes/webform.report.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:25:\"sites/all/modules/webform\";s:8:\"function\";s:40:\"theme_webform_results_submissions_header\";s:8:\"includes\";a:1:{i:0;s:53:\"sites/all/modules/webform/includes/webform.report.inc\";}}s:27:\"webform_results_submissions\";a:8:{s:14:\"render element\";s:7:\"element\";s:8:\"template\";s:63:\"sites/all/modules/webform/templates/webform-results-submissions\";s:4:\"file\";s:27:\"includes/webform.report.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:25:\"sites/all/modules/webform\";s:8:\"includes\";a:1:{i:0;s:53:\"sites/all/modules/webform/includes/webform.report.inc\";}s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:47:\"template_preprocess_webform_results_submissions\";i:2;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:28:\"webform_results_table_header\";a:6:{s:9:\"variables\";a:1:{s:4:\"node\";N;}s:4:\"file\";s:27:\"includes/webform.report.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:25:\"sites/all/modules/webform\";s:8:\"function\";s:34:\"theme_webform_results_table_header\";s:8:\"includes\";a:1:{i:0;s:53:\"sites/all/modules/webform/includes/webform.report.inc\";}}s:21:\"webform_results_table\";a:6:{s:9:\"variables\";a:5:{s:4:\"node\";N;s:10:\"components\";N;s:11:\"submissions\";N;s:11:\"total_count\";N;s:11:\"pager_count\";N;}s:4:\"file\";s:27:\"includes/webform.report.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:25:\"sites/all/modules/webform\";s:8:\"function\";s:27:\"theme_webform_results_table\";s:8:\"includes\";a:1:{i:0;s:53:\"sites/all/modules/webform/includes/webform.report.inc\";}}s:30:\"webform_results_download_range\";a:6:{s:14:\"render element\";s:7:\"element\";s:4:\"file\";s:27:\"includes/webform.report.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:25:\"sites/all/modules/webform\";s:8:\"function\";s:36:\"theme_webform_results_download_range\";s:8:\"includes\";a:1:{i:0;s:53:\"sites/all/modules/webform/includes/webform.report.inc\";}}s:38:\"webform_results_download_select_format\";a:6:{s:14:\"render element\";s:7:\"element\";s:4:\"file\";s:27:\"includes/webform.report.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:25:\"sites/all/modules/webform\";s:8:\"function\";s:44:\"theme_webform_results_download_select_format\";s:8:\"includes\";a:1:{i:0;s:53:\"sites/all/modules/webform/includes/webform.report.inc\";}}s:16:\"webform_analysis\";a:8:{s:14:\"render element\";s:8:\"analysis\";s:8:\"template\";s:52:\"sites/all/modules/webform/templates/webform-analysis\";s:4:\"file\";s:27:\"includes/webform.report.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:25:\"sites/all/modules/webform\";s:8:\"includes\";a:1:{i:0;s:53:\"sites/all/modules/webform/includes/webform.report.inc\";}s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:36:\"template_preprocess_webform_analysis\";i:2;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:26:\"webform_analysis_component\";a:8:{s:14:\"render element\";s:18:\"component_analysis\";s:8:\"template\";s:62:\"sites/all/modules/webform/templates/webform-analysis-component\";s:4:\"file\";s:27:\"includes/webform.report.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:25:\"sites/all/modules/webform\";s:8:\"includes\";a:1:{i:0;s:53:\"sites/all/modules/webform/includes/webform.report.inc\";}s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:46:\"template_preprocess_webform_analysis_component\";i:2;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:32:\"webform_analysis_component_basic\";a:6:{s:9:\"variables\";a:2:{s:9:\"component\";N;s:4:\"data\";N;}s:4:\"file\";s:27:\"includes/webform.report.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:25:\"sites/all/modules/webform\";s:8:\"function\";s:38:\"theme_webform_analysis_component_basic\";s:8:\"includes\";a:1:{i:0;s:53:\"sites/all/modules/webform/includes/webform.report.inc\";}}s:18:\"webform_submission\";a:9:{s:14:\"render element\";s:10:\"renderable\";s:8:\"template\";s:54:\"sites/all/modules/webform/templates/webform-submission\";s:7:\"pattern\";s:25:\"webform_submission_[0-9]+\";s:4:\"file\";s:32:\"includes/webform.submissions.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:25:\"sites/all/modules/webform\";s:8:\"includes\";a:1:{i:0;s:58:\"sites/all/modules/webform/includes/webform.submissions.inc\";}s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:38:\"template_preprocess_webform_submission\";i:2;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:23:\"webform_submission_page\";a:8:{s:9:\"variables\";a:7:{s:4:\"node\";N;s:10:\"submission\";N;s:18:\"submission_content\";N;s:21:\"submission_navigation\";N;s:22:\"submission_information\";N;s:18:\"submission_actions\";N;s:4:\"mode\";N;}s:8:\"template\";s:59:\"sites/all/modules/webform/templates/webform-submission-page\";s:4:\"file\";s:32:\"includes/webform.submissions.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:25:\"sites/all/modules/webform\";s:8:\"includes\";a:1:{i:0;s:58:\"sites/all/modules/webform/includes/webform.submissions.inc\";}s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:30:\"webform_submission_information\";a:8:{s:9:\"variables\";a:3:{s:4:\"node\";N;s:10:\"submission\";N;s:4:\"mode\";s:7:\"display\";}s:8:\"template\";s:66:\"sites/all/modules/webform/templates/webform-submission-information\";s:4:\"file\";s:32:\"includes/webform.submissions.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:25:\"sites/all/modules/webform\";s:8:\"includes\";a:1:{i:0;s:58:\"sites/all/modules/webform/includes/webform.submissions.inc\";}s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:50:\"template_preprocess_webform_submission_information\";i:2;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:29:\"webform_submission_navigation\";a:8:{s:9:\"variables\";a:3:{s:4:\"node\";N;s:10:\"submission\";N;s:4:\"mode\";N;}s:8:\"template\";s:65:\"sites/all/modules/webform/templates/webform-submission-navigation\";s:4:\"file\";s:32:\"includes/webform.submissions.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:25:\"sites/all/modules/webform\";s:8:\"includes\";a:1:{i:0;s:58:\"sites/all/modules/webform/includes/webform.submissions.inc\";}s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:49:\"template_preprocess_webform_submission_navigation\";i:2;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:25:\"webform_submission_resend\";a:6:{s:14:\"render element\";s:4:\"form\";s:4:\"file\";s:32:\"includes/webform.submissions.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:25:\"sites/all/modules/webform\";s:8:\"function\";s:31:\"theme_webform_submission_resend\";s:8:\"includes\";a:1:{i:0;s:58:\"sites/all/modules/webform/includes/webform.submissions.inc\";}}s:12:\"webform_date\";a:6:{s:14:\"render element\";s:7:\"element\";s:4:\"file\";s:19:\"components/date.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:25:\"sites/all/modules/webform\";s:8:\"function\";s:18:\"theme_webform_date\";s:8:\"includes\";a:1:{i:0;s:45:\"sites/all/modules/webform/components/date.inc\";}}s:20:\"webform_display_date\";a:6:{s:14:\"render element\";s:7:\"element\";s:4:\"file\";s:19:\"components/date.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:25:\"sites/all/modules/webform\";s:8:\"function\";s:26:\"theme_webform_display_date\";s:8:\"includes\";a:1:{i:0;s:45:\"sites/all/modules/webform/components/date.inc\";}}s:16:\"webform_calendar\";a:6:{s:9:\"variables\";a:2:{s:9:\"component\";N;s:16:\"calendar_classes\";N;}s:8:\"template\";s:52:\"sites/all/modules/webform/templates/webform-calendar\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:25:\"sites/all/modules/webform\";s:20:\"preprocess functions\";a:2:{i:0;s:19:\"template_preprocess\";i:1;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:13:\"webform_email\";a:6:{s:14:\"render element\";s:7:\"element\";s:4:\"file\";s:20:\"components/email.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:25:\"sites/all/modules/webform\";s:8:\"function\";s:19:\"theme_webform_email\";s:8:\"includes\";a:1:{i:0;s:46:\"sites/all/modules/webform/components/email.inc\";}}s:21:\"webform_display_email\";a:6:{s:14:\"render element\";s:7:\"element\";s:4:\"file\";s:20:\"components/email.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:25:\"sites/all/modules/webform\";s:8:\"function\";s:27:\"theme_webform_display_email\";s:8:\"includes\";a:1:{i:0;s:46:\"sites/all/modules/webform/components/email.inc\";}}s:28:\"webform_edit_file_extensions\";a:6:{s:14:\"render element\";s:7:\"element\";s:4:\"file\";s:19:\"components/file.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:25:\"sites/all/modules/webform\";s:8:\"function\";s:34:\"theme_webform_edit_file_extensions\";s:8:\"includes\";a:1:{i:0;s:45:\"sites/all/modules/webform/components/file.inc\";}}s:20:\"webform_display_file\";a:6:{s:14:\"render element\";s:7:\"element\";s:4:\"file\";s:19:\"components/file.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:25:\"sites/all/modules/webform\";s:8:\"function\";s:26:\"theme_webform_display_file\";s:8:\"includes\";a:1:{i:0;s:45:\"sites/all/modules/webform/components/file.inc\";}}s:20:\"webform_managed_file\";a:6:{s:14:\"render element\";s:7:\"element\";s:4:\"file\";s:19:\"components/file.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:25:\"sites/all/modules/webform\";s:8:\"function\";s:26:\"theme_webform_managed_file\";s:8:\"includes\";a:1:{i:0;s:45:\"sites/all/modules/webform/components/file.inc\";}}s:12:\"webform_grid\";a:6:{s:14:\"render element\";s:7:\"element\";s:4:\"file\";s:19:\"components/grid.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:25:\"sites/all/modules/webform\";s:8:\"function\";s:18:\"theme_webform_grid\";s:8:\"includes\";a:1:{i:0;s:45:\"sites/all/modules/webform/components/grid.inc\";}}s:20:\"webform_display_grid\";a:7:{s:14:\"render element\";s:7:\"element\";s:4:\"file\";s:19:\"components/grid.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:25:\"sites/all/modules/webform\";s:8:\"function\";s:26:\"theme_webform_display_grid\";s:8:\"includes\";a:1:{i:0;s:45:\"sites/all/modules/webform/components/grid.inc\";}s:20:\"preprocess functions\";a:1:{i:0;s:40:\"template_preprocess_webform_display_grid\";}}s:22:\"webform_display_hidden\";a:6:{s:14:\"render element\";s:7:\"element\";s:4:\"file\";s:21:\"components/hidden.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:25:\"sites/all/modules/webform\";s:8:\"function\";s:28:\"theme_webform_display_hidden\";s:8:\"includes\";a:1:{i:0;s:47:\"sites/all/modules/webform/components/hidden.inc\";}}s:22:\"webform_display_markup\";a:6:{s:14:\"render element\";s:7:\"element\";s:4:\"file\";s:21:\"components/markup.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:25:\"sites/all/modules/webform\";s:8:\"function\";s:28:\"theme_webform_display_markup\";s:8:\"includes\";a:1:{i:0;s:47:\"sites/all/modules/webform/components/markup.inc\";}}s:14:\"webform_number\";a:6:{s:14:\"render element\";s:7:\"element\";s:4:\"file\";s:21:\"components/number.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:25:\"sites/all/modules/webform\";s:8:\"function\";s:20:\"theme_webform_number\";s:8:\"includes\";a:1:{i:0;s:47:\"sites/all/modules/webform/components/number.inc\";}}s:22:\"webform_display_number\";a:6:{s:14:\"render element\";s:7:\"element\";s:4:\"file\";s:21:\"components/number.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:25:\"sites/all/modules/webform\";s:8:\"function\";s:28:\"theme_webform_display_number\";s:8:\"includes\";a:1:{i:0;s:47:\"sites/all/modules/webform/components/number.inc\";}}s:25:\"webform_display_pagebreak\";a:6:{s:14:\"render element\";s:7:\"element\";s:4:\"file\";s:24:\"components/pagebreak.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:25:\"sites/all/modules/webform\";s:8:\"function\";s:31:\"theme_webform_display_pagebreak\";s:8:\"includes\";a:1:{i:0;s:50:\"sites/all/modules/webform/components/pagebreak.inc\";}}s:22:\"webform_display_select\";a:6:{s:14:\"render element\";s:7:\"element\";s:4:\"file\";s:21:\"components/select.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:25:\"sites/all/modules/webform\";s:8:\"function\";s:28:\"theme_webform_display_select\";s:8:\"includes\";a:1:{i:0;s:47:\"sites/all/modules/webform/components/select.inc\";}}s:24:\"webform_display_textarea\";a:6:{s:14:\"render element\";s:7:\"element\";s:4:\"file\";s:23:\"components/textarea.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:25:\"sites/all/modules/webform\";s:8:\"function\";s:30:\"theme_webform_display_textarea\";s:8:\"includes\";a:1:{i:0;s:49:\"sites/all/modules/webform/components/textarea.inc\";}}s:25:\"webform_display_textfield\";a:6:{s:14:\"render element\";s:7:\"element\";s:4:\"file\";s:24:\"components/textfield.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:25:\"sites/all/modules/webform\";s:8:\"function\";s:31:\"theme_webform_display_textfield\";s:8:\"includes\";a:1:{i:0;s:50:\"sites/all/modules/webform/components/textfield.inc\";}}s:12:\"webform_time\";a:6:{s:14:\"render element\";s:7:\"element\";s:4:\"file\";s:19:\"components/time.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:25:\"sites/all/modules/webform\";s:8:\"function\";s:18:\"theme_webform_time\";s:8:\"includes\";a:1:{i:0;s:45:\"sites/all/modules/webform/components/time.inc\";}}s:20:\"webform_display_time\";a:6:{s:14:\"render element\";s:7:\"element\";s:4:\"file\";s:19:\"components/time.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:25:\"sites/all/modules/webform\";s:8:\"function\";s:26:\"theme_webform_display_time\";s:8:\"includes\";a:1:{i:0;s:45:\"sites/all/modules/webform/components/time.inc\";}}s:24:\"block_admin_display_form\";a:8:{s:8:\"template\";s:38:\"modules/block/block-admin-display-form\";s:4:\"file\";s:15:\"block.admin.inc\";s:14:\"render element\";s:4:\"form\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:13:\"modules/block\";s:8:\"includes\";a:1:{i:0;s:29:\"modules/block/block.admin.inc\";}s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:44:\"template_preprocess_block_admin_display_form\";i:2;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:28:\"remember_me_settings_display\";a:6:{s:9:\"variables\";a:1:{s:4:\"vars\";a:0:{}}s:4:\"file\";s:21:\"remember_me.admin.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:29:\"sites/all/modules/remember_me\";s:8:\"function\";s:34:\"theme_remember_me_settings_display\";s:8:\"includes\";a:1:{i:0;s:51:\"sites/all/modules/remember_me/remember_me.admin.inc\";}}s:20:\"strongarm_admin_form\";a:7:{s:14:\"render element\";s:4:\"form\";s:4:\"file\";s:19:\"strongarm.admin.inc\";s:4:\"path\";s:27:\"sites/all/modules/strongarm\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:27:\"sites/all/modules/strongarm\";s:8:\"function\";s:26:\"theme_strongarm_admin_form\";s:8:\"includes\";a:1:{i:0;s:47:\"sites/all/modules/strongarm/strongarm.admin.inc\";}}}',0,1512620340,1),('theme_registry:runtime:forum_plus','a:472:{s:12:\"render_panel\";a:6:{s:9:\"variables\";a:3:{s:4:\"page\";a:0:{}s:11:\"panels_list\";a:0:{}s:19:\"panel_regions_width\";a:0:{}}s:20:\"preprocess functions\";a:1:{i:0;s:34:\"forum_plus_preprocess_render_panel\";}s:8:\"template\";s:5:\"panel\";s:4:\"path\";s:31:\"sites/all/themes/forum_plus/tpl\";s:4:\"type\";s:5:\"theme\";s:10:\"theme path\";s:27:\"sites/all/themes/forum_plus\";}s:14:\"date_nav_title\";N;s:15:\"views_view_grid\";N;s:5:\"block\";a:7:{s:8:\"template\";s:5:\"block\";s:4:\"path\";s:31:\"sites/all/themes/forum_plus/tpl\";s:4:\"type\";s:12:\"theme_engine\";s:10:\"theme path\";s:27:\"sites/all/themes/forum_plus\";s:14:\"render element\";s:8:\"elements\";s:20:\"preprocess functions\";a:5:{i:0;s:19:\"template_preprocess\";i:1;s:25:\"template_preprocess_block\";i:2;s:28:\"block_class_preprocess_block\";i:3;s:21:\"contextual_preprocess\";i:4;s:23:\"system_preprocess_block\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:4:\"html\";a:7:{s:8:\"template\";s:4:\"html\";s:4:\"path\";s:31:\"sites/all/themes/forum_plus/tpl\";s:4:\"type\";s:12:\"theme_engine\";s:10:\"theme path\";s:27:\"sites/all/themes/forum_plus\";s:14:\"render element\";s:4:\"page\";s:20:\"preprocess functions\";a:7:{i:0;s:19:\"template_preprocess\";i:1;s:24:\"template_preprocess_html\";i:2;s:21:\"contextual_preprocess\";i:3;s:23:\"overlay_preprocess_html\";i:4;s:20:\"i18n_preprocess_html\";i:5;s:21:\"views_preprocess_html\";i:6;s:26:\"forum_plus_preprocess_html\";}s:17:\"process functions\";a:4:{i:0;s:16:\"template_process\";i:1;s:21:\"template_process_html\";i:2;s:14:\"ctools_process\";i:3;s:23:\"forum_plus_process_html\";}}s:16:\"maintenance_page\";N;s:4:\"node\";N;s:4:\"page\";a:7:{s:8:\"template\";s:4:\"page\";s:4:\"path\";s:31:\"sites/all/themes/forum_plus/tpl\";s:4:\"type\";s:12:\"theme_engine\";s:10:\"theme path\";s:27:\"sites/all/themes/forum_plus\";s:14:\"render element\";s:4:\"page\";s:20:\"preprocess functions\";a:9:{i:0;s:19:\"template_preprocess\";i:1;s:24:\"template_preprocess_page\";i:2;s:21:\"contextual_preprocess\";i:3;s:19:\"faq_preprocess_page\";i:4;s:23:\"overlay_preprocess_page\";i:5;s:24:\"shortcut_preprocess_page\";i:6;s:21:\"views_preprocess_page\";i:7;s:30:\"advanced_forum_preprocess_page\";i:8;s:26:\"forum_plus_preprocess_page\";}s:17:\"process functions\";a:3:{i:0;s:16:\"template_process\";i:1;s:21:\"template_process_page\";i:2;s:14:\"ctools_process\";}}s:16:\"views_view__page\";N;s:9:\"html__404\";N;s:13:\"node__article\";N;s:10:\"node__blog\";N;s:11:\"node__video\";N;s:16:\"admin_menu_links\";a:4:{s:14:\"render element\";s:8:\"elements\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:28:\"sites/all/modules/admin_menu\";s:8:\"function\";s:22:\"theme_admin_menu_links\";}s:15:\"admin_menu_icon\";a:7:{s:9:\"variables\";a:2:{s:3:\"src\";N;s:3:\"alt\";N;}s:4:\"file\";s:14:\"admin_menu.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:28:\"sites/all/modules/admin_menu\";s:8:\"function\";s:21:\"theme_admin_menu_icon\";s:8:\"includes\";a:1:{i:0;s:43:\"sites/all/modules/admin_menu/admin_menu.inc\";}s:20:\"preprocess functions\";a:1:{i:0;s:35:\"template_preprocess_admin_menu_icon\";}}s:22:\"features_module_status\";N;s:19:\"features_components\";N;s:22:\"features_component_key\";N;s:23:\"features_component_list\";N;s:21:\"features_storage_link\";N;s:18:\"features_lock_link\";N;s:21:\"features_form_package\";N;s:20:\"features_form_export\";N;s:24:\"features_form_components\";N;s:21:\"features_form_buttons\";N;s:25:\"features_admin_components\";N;s:26:\"advanced_forum_topic_pager\";N;s:28:\"advanced_forum_active_poster\";N;s:36:\"advanced_forum_topic_list_outer_view\";N;s:19:\"advanced_forum_post\";N;s:28:\"advanced_forum_search_result\";N;s:25:\"advanced_forum_topic_icon\";N;s:21:\"advanced_forum_forums\";N;s:27:\"advanced_forum_search_topic\";N;s:26:\"advanced_forum_post_edited\";N;s:25:\"advanced_forum_topic_list\";N;s:25:\"advanced_forum_forum_list\";N;s:30:\"advanced_forum_topic_list_view\";N;s:27:\"advanced_forum_topic_legend\";N;s:27:\"advanced_forum_topic_header\";N;s:28:\"advanced_forum_post_repeated\";N;s:24:\"advanced_forum_submitted\";N;s:27:\"advanced_forum_search_forum\";N;s:25:\"advanced_forum_statistics\";N;s:26:\"advanced_forum_author_pane\";N;s:27:\"advanced_forum_post_preview\";N;s:27:\"advanced_forum_shadow_topic\";N;s:27:\"advanced_forum_forum_legend\";N;s:30:\"advanced_forum_comment_wrapper\";N;s:42:\"advanced_forum_group_topic_list_outer_view\";N;s:16:\"advanced_forum_l\";N;s:27:\"advanced_forum_user_picture\";N;s:25:\"advanced_forum_reply_link\";N;s:28:\"advanced_forum_subforum_list\";N;s:32:\"advanced_forum_subcontainer_list\";N;s:33:\"advanced_forum_simple_author_pane\";N;s:36:\"advanced_forum_node_type_create_list\";N;s:37:\"views_view__advanced_forum_topic_list\";N;s:43:\"views_view__advanced_forum_group_topic_list\";N;s:16:\"views_mini_pager\";N;s:16:\"views_view_field\";a:9:{s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:29:\"sites/all/modules/views/theme\";s:7:\"pattern\";s:18:\"views_view_field__\";s:9:\"variables\";a:3:{s:4:\"view\";N;s:5:\"field\";N;s:3:\"row\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:23:\"sites/all/modules/views\";s:8:\"function\";s:22:\"theme_views_view_field\";s:8:\"includes\";a:1:{i:0;s:39:\"sites/all/modules/views/theme/theme.inc\";}s:20:\"preprocess functions\";a:1:{i:0;s:36:\"template_preprocess_views_view_field\";}}s:19:\"views_view_grouping\";N;s:10:\"views_view\";a:10:{s:7:\"pattern\";s:12:\"views_view__\";s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:29:\"sites/all/modules/views/theme\";s:9:\"variables\";a:2:{s:10:\"view_array\";a:0:{}s:4:\"view\";N;}s:8:\"template\";s:10:\"views-view\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:23:\"sites/all/modules/views\";s:8:\"includes\";a:1:{i:0;s:39:\"sites/all/modules/views/theme/theme.inc\";}s:20:\"preprocess functions\";a:5:{i:0;s:19:\"template_preprocess\";i:1;s:30:\"template_preprocess_views_view\";i:2;s:21:\"contextual_preprocess\";i:3;s:32:\"date_views_preprocess_views_view\";i:4;s:30:\"views_ui_preprocess_views_view\";}s:17:\"process functions\";a:3:{i:0;s:16:\"template_process\";i:1;s:27:\"template_process_views_view\";i:2;s:14:\"ctools_process\";}}s:14:\"calendar_style\";N;s:13:\"calendar_mini\";N;s:12:\"calendar_day\";N;s:13:\"calendar_week\";N;s:14:\"calendar_month\";N;s:13:\"calendar_year\";N;s:20:\"calendar_day_overlap\";N;s:21:\"calendar_week_overlap\";N;s:15:\"date_navigation\";N;s:22:\"views_view_unformatted\";a:10:{s:7:\"pattern\";s:24:\"views_view_unformatted__\";s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:29:\"sites/all/modules/views/theme\";s:9:\"variables\";a:4:{s:4:\"view\";N;s:7:\"options\";N;s:4:\"rows\";N;s:5:\"title\";N;}s:8:\"template\";s:22:\"views-view-unformatted\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:23:\"sites/all/modules/views\";s:8:\"includes\";a:1:{i:0;s:39:\"sites/all/modules/views/theme/theme.inc\";}s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:42:\"template_preprocess_views_view_unformatted\";i:2;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:16:\"flexslider_views\";N;s:14:\"quicktabs_view\";N;s:15:\"views_slideshow\";N;s:15:\"views_view_list\";N;s:16:\"views_view_table\";N;s:18:\"views_view_summary\";N;s:30:\"views_view_summary_unformatted\";N;s:14:\"views_view_rss\";N;s:28:\"views_view_summary_jump_menu\";N;s:20:\"views_view_jump_menu\";N;s:17:\"views_view_fields\";a:10:{s:7:\"pattern\";s:19:\"views_view_fields__\";s:4:\"file\";s:9:\"theme.inc\";s:4:\"path\";s:29:\"sites/all/modules/views/theme\";s:9:\"variables\";a:4:{s:4:\"view\";N;s:7:\"options\";N;s:3:\"row\";N;s:11:\"field_alias\";N;}s:8:\"template\";s:17:\"views-view-fields\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:27:\"sites/all/themes/forum_plus\";s:8:\"includes\";a:1:{i:0;s:39:\"sites/all/modules/views/theme/theme.inc\";}s:20:\"preprocess functions\";a:5:{i:0;s:19:\"template_preprocess\";i:1;s:37:\"template_preprocess_views_view_fields\";i:2;s:21:\"contextual_preprocess\";i:3;s:44:\"views_fieldsets_preprocess_views_view_fields\";i:4;s:39:\"forum_plus_preprocess_views_view_fields\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:22:\"views_view_row_comment\";N;s:18:\"views_view_row_rss\";N;s:21:\"views_form_views_form\";N;s:18:\"views_exposed_form\";N;s:10:\"views_more\";N;s:6:\"forums\";N;s:10:\"forum_list\";N;s:16:\"forum_topic_list\";N;s:10:\"forum_icon\";N;s:15:\"forum_submitted\";N;s:10:\"forum_form\";N;s:15:\"horizontal_tabs\";N;s:9:\"multipage\";N;s:14:\"multipage_pane\";N;s:33:\"we_content_migration_form_package\";N;s:17:\"shortcode_tooltip\";N;s:18:\"shortcode_collapse\";N;s:28:\"views_ui_display_tab_setting\";N;s:27:\"views_ui_display_tab_bucket\";N;s:23:\"views_ui_rearrange_form\";N;s:30:\"views_ui_rearrange_filter_form\";N;s:27:\"views_ui_expose_filter_form\";N;s:18:\"views_ui_view_info\";N;s:32:\"views_ui_build_group_filter_form\";N;s:12:\"views_tabset\";N;s:9:\"views_tab\";N;s:30:\"views_ui_reorder_displays_form\";N;s:27:\"views_ui_style_plugin_table\";N;s:29:\"views_ui_view_preview_section\";N;s:15:\"views_container\";N;s:21:\"views_slideshow_cycle\";N;s:32:\"views_slideshow_cycle_main_frame\";N;s:36:\"views_slideshow_cycle_main_frame_row\";N;s:41:\"views_slideshow_cycle_main_frame_row_item\";N;s:28:\"views_slideshow_main_section\";N;s:35:\"views_slideshow_pager_widget_render\";N;s:28:\"views_slideshow_pager_fields\";N;s:33:\"views_slideshow_pager_field_field\";N;s:32:\"views_slideshow_pager_field_item\";N;s:38:\"views_slideshow_controls_widget_render\";N;s:29:\"views_slideshow_controls_text\";N;s:38:\"views_slideshow_controls_text_previous\";N;s:35:\"views_slideshow_controls_text_pause\";N;s:34:\"views_slideshow_controls_text_next\";N;s:43:\"views_slideshow_slide_counter_widget_render\";N;s:29:\"views_slideshow_slide_counter\";N;s:30:\"views_fieldsets_rearrange_form\";N;s:24:\"views_fieldsets_fieldset\";N;s:34:\"video_embed_field_video_style_list\";N;s:28:\"video_embed_field_embed_code\";N;s:31:\"video_embed_field_colorbox_code\";N;s:21:\"variable_table_select\";N;s:12:\"user_picture\";a:6:{s:9:\"variables\";a:1:{s:7:\"account\";N;}s:8:\"template\";s:25:\"modules/user/user-picture\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:12:\"modules/user\";s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:32:\"template_preprocess_user_picture\";i:2;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:12:\"user_profile\";a:8:{s:14:\"render element\";s:8:\"elements\";s:8:\"template\";s:25:\"modules/user/user-profile\";s:4:\"file\";s:14:\"user.pages.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:12:\"modules/user\";s:8:\"includes\";a:1:{i:0;s:27:\"modules/user/user.pages.inc\";}s:20:\"preprocess functions\";a:4:{i:0;s:19:\"template_preprocess\";i:1;s:32:\"template_preprocess_user_profile\";i:2;s:21:\"contextual_preprocess\";i:3;s:31:\"field_group_build_entity_groups\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:21:\"user_profile_category\";a:8:{s:14:\"render element\";s:7:\"element\";s:8:\"template\";s:34:\"modules/user/user-profile-category\";s:4:\"file\";s:14:\"user.pages.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:12:\"modules/user\";s:8:\"includes\";a:1:{i:0;s:27:\"modules/user/user.pages.inc\";}s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:41:\"template_preprocess_user_profile_category\";i:2;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:17:\"user_profile_item\";a:8:{s:14:\"render element\";s:7:\"element\";s:8:\"template\";s:30:\"modules/user/user-profile-item\";s:4:\"file\";s:14:\"user.pages.inc\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:12:\"modules/user\";s:8:\"includes\";a:1:{i:0;s:27:\"modules/user/user.pages.inc\";}s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:37:\"template_preprocess_user_profile_item\";i:2;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:9:\"user_list\";N;s:22:\"user_admin_permissions\";N;s:16:\"user_admin_roles\";N;s:27:\"user_permission_description\";N;s:14:\"user_signature\";N;s:26:\"update_manager_update_form\";N;s:17:\"update_last_check\";N;s:13:\"update_report\";N;s:14:\"update_version\";N;s:19:\"update_status_label\";N;s:10:\"tree_table\";N;s:10:\"token_tree\";N;s:15:\"token_tree_link\";N;s:30:\"taxonomy_overview_vocabularies\";N;s:23:\"taxonomy_overview_terms\";N;s:13:\"taxonomy_term\";N;s:18:\"tagclouds_list_box\";N;s:18:\"tagclouds_weighted\";N;s:6:\"region\";a:6:{s:14:\"render element\";s:8:\"elements\";s:8:\"template\";s:21:\"modules/system/region\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:26:\"template_preprocess_region\";i:2;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:15:\"status_messages\";a:4:{s:9:\"variables\";a:1:{s:7:\"display\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:21:\"theme_status_messages\";}s:4:\"link\";a:4:{s:9:\"variables\";a:3:{s:4:\"text\";N;s:4:\"path\";N;s:7:\"options\";a:0:{}}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:10:\"theme_link\";}s:5:\"links\";a:4:{s:9:\"variables\";a:3:{s:5:\"links\";N;s:10:\"attributes\";a:1:{s:5:\"class\";a:1:{i:0;s:5:\"links\";}}s:7:\"heading\";a:0:{}}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:11:\"theme_links\";}s:5:\"image\";a:4:{s:9:\"variables\";a:6:{s:4:\"path\";N;s:5:\"width\";N;s:6:\"height\";N;s:3:\"alt\";s:0:\"\";s:5:\"title\";N;s:10:\"attributes\";a:0:{}}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:11:\"theme_image\";}s:10:\"breadcrumb\";a:4:{s:9:\"variables\";a:1:{s:10:\"breadcrumb\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:16:\"theme_breadcrumb\";}s:4:\"help\";N;s:5:\"table\";N;s:19:\"tablesort_indicator\";N;s:4:\"mark\";N;s:9:\"item_list\";N;s:14:\"more_help_link\";N;s:9:\"feed_icon\";N;s:9:\"more_link\";N;s:8:\"username\";a:6:{s:9:\"variables\";a:1:{s:7:\"account\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:14:\"theme_username\";s:20:\"preprocess functions\";a:1:{i:0;s:28:\"template_preprocess_username\";}s:17:\"process functions\";a:1:{i:0;s:25:\"template_process_username\";}}s:12:\"progress_bar\";N;s:11:\"indentation\";N;s:8:\"html_tag\";a:4:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:14:\"theme_html_tag\";}s:11:\"update_page\";N;s:12:\"install_page\";N;s:9:\"task_list\";N;s:17:\"authorize_message\";N;s:16:\"authorize_report\";N;s:5:\"pager\";N;s:11:\"pager_first\";N;s:14:\"pager_previous\";N;s:10:\"pager_next\";N;s:10:\"pager_last\";N;s:10:\"pager_link\";N;s:9:\"menu_link\";a:4:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:15:\"theme_menu_link\";}s:9:\"menu_tree\";a:5:{s:14:\"render element\";s:4:\"tree\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:15:\"theme_menu_tree\";s:20:\"preprocess functions\";a:1:{i:0;s:29:\"template_preprocess_menu_tree\";}}s:15:\"menu_local_task\";a:4:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:21:\"theme_menu_local_task\";}s:17:\"menu_local_action\";N;s:16:\"menu_local_tasks\";a:4:{s:9:\"variables\";a:2:{s:7:\"primary\";a:0:{}s:9:\"secondary\";a:0:{}}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:22:\"theme_menu_local_tasks\";}s:6:\"select\";a:4:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:12:\"theme_select\";}s:8:\"fieldset\";N;s:5:\"radio\";N;s:6:\"radios\";N;s:4:\"date\";N;s:15:\"exposed_filters\";N;s:8:\"checkbox\";a:4:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:14:\"theme_checkbox\";}s:10:\"checkboxes\";N;s:6:\"button\";a:4:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:12:\"theme_button\";}s:12:\"image_button\";N;s:6:\"hidden\";a:4:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:12:\"theme_hidden\";}s:9:\"textfield\";a:4:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:15:\"theme_textfield\";}s:4:\"form\";a:4:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:10:\"theme_form\";}s:8:\"textarea\";N;s:8:\"password\";a:4:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:14:\"theme_password\";}s:4:\"file\";N;s:11:\"tableselect\";N;s:12:\"form_element\";a:4:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:18:\"theme_form_element\";}s:20:\"form_required_marker\";a:4:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:26:\"theme_form_required_marker\";}s:18:\"form_element_label\";a:4:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:24:\"theme_form_element_label\";}s:13:\"vertical_tabs\";N;s:9:\"container\";a:4:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/system\";s:8:\"function\";s:15:\"theme_container\";}s:18:\"system_themes_page\";N;s:20:\"system_settings_form\";N;s:12:\"confirm_form\";N;s:23:\"system_modules_fieldset\";N;s:27:\"system_modules_incompatible\";N;s:24:\"system_modules_uninstall\";N;s:13:\"status_report\";N;s:10:\"admin_page\";N;s:11:\"admin_block\";N;s:19:\"admin_block_content\";N;s:18:\"system_admin_index\";N;s:17:\"system_powered_by\";N;s:19:\"system_compact_link\";N;s:25:\"system_date_time_settings\";N;s:22:\"shortcut_set_customize\";N;s:27:\"shortcode_video_embed_error\";N;s:33:\"shortcode_video_embed_no_provider\";N;s:29:\"shortcode_video_embed_youtube\";N;s:16:\"shortcode_button\";N;s:15:\"shortcode_quote\";N;s:13:\"shortcode_img\";N;s:17:\"shortcode_dropcap\";N;s:14:\"shortcode_item\";N;s:15:\"shortcode_clear\";N;s:9:\"sharethis\";N;s:17:\"search_block_form\";a:6:{s:14:\"render element\";s:4:\"form\";s:8:\"template\";s:32:\"modules/search/search-block-form\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:14:\"modules/search\";s:20:\"preprocess functions\";a:3:{i:0;s:19:\"template_preprocess\";i:1;s:37:\"template_preprocess_search_block_form\";i:2;s:21:\"contextual_preprocess\";}s:17:\"process functions\";a:2:{i:0;s:16:\"template_process\";i:1;s:14:\"ctools_process\";}}s:13:\"search_result\";N;s:14:\"search_results\";N;s:25:\"quicktabs_admin_form_tabs\";N;s:10:\"qt_ui_tabs\";N;s:17:\"qt_ui_tabs_tabset\";N;s:12:\"qt_quicktabs\";N;s:19:\"qt_quicktabs_tabset\";N;s:12:\"qt_accordion\";N;s:27:\"quicktabs_tab_access_denied\";N;s:7:\"overlay\";N;s:23:\"overlay_disable_message\";a:4:{s:14:\"render element\";s:7:\"element\";s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:15:\"modules/overlay\";s:8:\"function\";s:29:\"theme_overlay_disable_message\";}s:12:\"options_none\";N;s:17:\"node_search_admin\";N;s:13:\"node_add_list\";N;s:12:\"node_preview\";N;s:19:\"node_admin_overview\";N;s:17:\"node_recent_block\";N;s:19:\"node_recent_content\";N;s:13:\"module_filter\";N;s:33:\"module_filter_system_modules_tabs\";N;s:24:\"module_filter_operations\";N;s:7:\"message\";N;s:27:\"menu_breadcrumb_menus_table\";N;s:18:\"menu_overview_form\";N;s:19:\"menu_admin_overview\";N;s:30:\"locale_languages_overview_form\";N;s:31:\"locale_languages_configure_form\";N;s:23:\"locale_date_format_form\";N;s:27:\"link_formatter_link_default\";N;s:25:\"link_formatter_link_plain\";N;s:28:\"link_formatter_link_absolute\";N;s:26:\"link_formatter_link_domain\";N;s:31:\"link_formatter_link_title_plain\";N;s:23:\"link_formatter_link_url\";N;s:25:\"link_formatter_link_short\";N;s:25:\"link_formatter_link_label\";N;s:28:\"link_formatter_link_separate\";N;s:10:\"link_field\";N;s:37:\"lang_dropdown_hideout_hiddenlanguages\";N;s:18:\"languageicons_icon\";a:4:{s:9:\"variables\";a:2:{s:8:\"language\";N;s:5:\"title\";N;}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/languageicons\";s:8:\"function\";s:24:\"theme_languageicons_icon\";}s:19:\"languageicons_place\";a:4:{s:9:\"variables\";a:3:{s:4:\"text\";N;s:4:\"icon\";N;s:9:\"separator\";s:1:\" \";}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:31:\"sites/all/modules/languageicons\";s:8:\"function\";s:25:\"theme_languageicons_place\";}s:11:\"image_style\";a:4:{s:9:\"variables\";a:7:{s:10:\"style_name\";N;s:4:\"path\";N;s:5:\"width\";N;s:6:\"height\";N;s:3:\"alt\";s:0:\"\";s:5:\"title\";N;s:10:\"attributes\";a:0:{}}s:4:\"type\";s:6:\"module\";s:10:\"theme path\";s:13:\"modules/image\";s:8:\"function\";s:17:\"theme_image_style\";}s:16:\"image_style_list\";N;s:19:\"image_style_effects\";N;s:19:\"image_style_preview\";N;s:12:\"image_anchor\";N;s:20:\"image_resize_summary\";N;s:19:\"image_scale_summary\";N;s:18:\"image_crop_summary\";N;s:20:\"image_rotate_summary\";N;s:12:\"image_widget\";N;s:15:\"image_formatter\";N;s:10:\"flexslider\";N;s:15:\"flexslider_list\";N;s:20:\"flexslider_list_item\";N;s:8:\"fivestar\";N;s:15:\"fivestar_select\";N;s:15:\"fivestar_static\";N;s:23:\"fivestar_static_element\";N;s:16:\"fivestar_summary\";N;s:16:\"fivestar_preview\";N;s:23:\"fivestar_preview_widget\";N;s:24:\"fivestar_preview_wrapper\";N;s:17:\"fivestar_settings\";N;s:19:\"fivestar_color_form\";N;s:26:\"fivestar_formatter_default\";N;s:25:\"fivestar_formatter_rating\";N;s:29:\"fivestar_formatter_percentage\";N;s:21:\"filter_admin_overview\";N;s:32:\"filter_admin_format_filter_order\";N;s:11:\"filter_tips\";N;s:19:\"text_format_wrapper\";N;s:21:\"filter_tips_more_info\";N;s:17:\"filter_guidelines\";N;s:9:\"file_link\";N;s:9:\"file_icon\";N;s:17:\"file_managed_file\";N;s:11:\"file_widget\";N;s:20:\"file_widget_multiple\";N;s:20:\"file_formatter_table\";N;s:16:\"file_upload_help\";N;s:14:\"field_ui_table\";N;s:21:\"field_collection_item\";N;s:21:\"field_collection_view\";N;s:5:\"field\";N;s:25:\"field_multiple_value_form\";N;s:23:\"field_detailed_question\";N;s:34:\"faq_draggable_question_order_table\";N;s:17:\"faq_questions_top\";N;s:26:\"faq_category_questions_top\";N;s:34:\"faq_category_questions_top_answers\";N;s:15:\"faq_hide_answer\";N;s:24:\"faq_category_hide_answer\";N;s:20:\"faq_questions_inline\";N;s:29:\"faq_category_questions_inline\";N;s:12:\"faq_new_page\";N;s:21:\"faq_category_new_page\";N;s:8:\"faq_page\";N;s:13:\"entity_status\";N;s:6:\"entity\";N;s:15:\"entity_property\";N;s:23:\"entity_ui_overview_item\";N;s:13:\"dblog_message\";N;s:22:\"date_views_filter_form\";N;s:17:\"date_calendar_day\";N;s:16:\"date_views_pager\";N;s:13:\"date_timezone\";N;s:11:\"date_select\";N;s:9:\"date_text\";N;s:19:\"date_select_element\";N;s:22:\"date_textfield_element\";N;s:21:\"date_part_hour_prefix\";N;s:23:\"date_part_minsec_prefix\";N;s:20:\"date_part_label_year\";N;s:21:\"date_part_label_month\";N;s:19:\"date_part_label_day\";N;s:20:\"date_part_label_hour\";N;s:22:\"date_part_label_minute\";N;s:22:\"date_part_label_second\";N;s:20:\"date_part_label_ampm\";N;s:24:\"date_part_label_timezone\";N;s:20:\"date_part_label_date\";N;s:20:\"date_part_label_time\";N;s:13:\"date_time_ago\";N;s:9:\"dashboard\";N;s:15:\"dashboard_admin\";N;s:16:\"dashboard_region\";N;s:25:\"dashboard_disabled_blocks\";N;s:24:\"dashboard_disabled_block\";N;s:28:\"dashboard_admin_display_form\";N;s:15:\"ctools_dropdown\";N;s:18:\"ctools_collapsible\";N;s:29:\"ctools_collapsible_remembered\";N;s:19:\"ctools_wizard_trail\";N;s:24:\"links__ctools_dropbutton\";N;s:33:\"ctools_stylizer_color_scheme_form\";N;s:28:\"ctools_stylizer_preview_form\";N;s:17:\"ctools_style_icon\";N;s:33:\"ctools_menu_local_actions_wrapper\";N;s:19:\"ctools_context_list\";N;s:28:\"ctools_context_list_no_table\";N;s:24:\"ctools_context_item_form\";N;s:23:\"ctools_context_item_row\";N;s:23:\"ctools_access_admin_add\";N;s:13:\"comment_block\";N;s:15:\"comment_preview\";N;s:7:\"comment\";N;s:22:\"comment_post_forbidden\";N;s:15:\"comment_wrapper\";N;s:17:\"color_scheme_form\";N;s:13:\"calendar_item\";N;s:16:\"calendar_datebox\";N;s:18:\"calendar_empty_day\";N;s:22:\"calendar_stripe_legend\";N;s:22:\"calendar_stripe_stripe\";N;s:25:\"calendar_time_row_heading\";N;s:18:\"calendar_month_col\";N;s:18:\"calendar_month_row\";N;s:30:\"calendar_month_multiple_entity\";N;s:15:\"book_navigation\";N;s:16:\"book_export_html\";N;s:16:\"book_admin_table\";N;s:15:\"book_title_link\";N;s:20:\"book_all_books_block\";N;s:21:\"book_node_export_html\";N;s:11:\"author_pane\";N;s:24:\"author_pane_user_picture\";N;s:12:\"webform_view\";N;s:21:\"webform_view_messages\";N;s:12:\"webform_form\";N;s:20:\"webform_confirmation\";N;s:15:\"webform_element\";N;s:20:\"webform_element_text\";N;s:20:\"webform_inline_radio\";N;s:26:\"webform_inline_radio_label\";N;s:19:\"webform_progressbar\";N;s:20:\"webform_mail_message\";N;s:20:\"webform_mail_headers\";N;s:18:\"webform_token_help\";N;s:22:\"webform_admin_settings\";N;s:21:\"webform_admin_content\";N;s:19:\"webform_emails_form\";N;s:31:\"webform_email_component_mapping\";N;s:22:\"webform_email_add_form\";N;s:23:\"webform_email_edit_form\";N;s:23:\"webform_components_page\";N;s:23:\"webform_components_form\";N;s:24:\"webform_component_select\";N;s:26:\"webform_conditional_groups\";N;s:29:\"webform_conditional_group_row\";N;s:19:\"webform_conditional\";N;s:33:\"webform_advanced_redirection_form\";N;s:34:\"webform_advanced_submit_limit_form\";N;s:40:\"webform_advanced_total_submit_limit_form\";N;s:24:\"webform_results_per_page\";N;s:34:\"webform_results_submissions_header\";N;s:27:\"webform_results_submissions\";N;s:28:\"webform_results_table_header\";N;s:21:\"webform_results_table\";N;s:30:\"webform_results_download_range\";N;s:38:\"webform_results_download_select_format\";N;s:16:\"webform_analysis\";N;s:26:\"webform_analysis_component\";N;s:32:\"webform_analysis_component_basic\";N;s:18:\"webform_submission\";N;s:23:\"webform_submission_page\";N;s:30:\"webform_submission_information\";N;s:29:\"webform_submission_navigation\";N;s:25:\"webform_submission_resend\";N;s:12:\"webform_date\";N;s:20:\"webform_display_date\";N;s:16:\"webform_calendar\";N;s:13:\"webform_email\";N;s:21:\"webform_display_email\";N;s:28:\"webform_edit_file_extensions\";N;s:20:\"webform_display_file\";N;s:20:\"webform_managed_file\";N;s:12:\"webform_grid\";N;s:20:\"webform_display_grid\";N;s:22:\"webform_display_hidden\";N;s:22:\"webform_display_markup\";N;s:14:\"webform_number\";N;s:22:\"webform_display_number\";N;s:25:\"webform_display_pagebreak\";N;s:22:\"webform_display_select\";N;s:24:\"webform_display_textarea\";N;s:25:\"webform_display_textfield\";N;s:12:\"webform_time\";N;s:20:\"webform_display_time\";N;s:24:\"block_admin_display_form\";N;s:28:\"remember_me_settings_display\";N;s:20:\"strongarm_admin_form\";N;}',0,1512620348,1),('video_embed_field_handlers','a:2:{s:7:\"youtube\";a:9:{s:5:\"title\";s:7:\"Youtube\";s:8:\"function\";s:32:\"video_embed_field_handle_youtube\";s:18:\"thumbnail_function\";s:42:\"video_embed_field_handle_youtube_thumbnail\";s:17:\"thumbnail_default\";s:51:\"sites/all/modules/video_embed_field/img/youtube.jpg\";s:13:\"data_function\";s:37:\"video_embed_field_handle_youtube_data\";s:4:\"form\";s:38:\"video_embed_field_handler_youtube_form\";s:13:\"form_validate\";s:47:\"video_embed_field_handler_youtube_form_validate\";s:7:\"domains\";a:2:{i:0;s:11:\"youtube.com\";i:1;s:8:\"youtu.be\";}s:8:\"defaults\";a:12:{s:5:\"width\";i:640;s:6:\"height\";i:360;s:8:\"autoplay\";i:0;s:2:\"vq\";s:5:\"large\";s:3:\"rel\";i:0;s:8:\"controls\";i:1;s:8:\"autohide\";i:2;s:8:\"showinfo\";i:1;s:14:\"modestbranding\";i:0;s:5:\"theme\";s:4:\"dark\";s:14:\"iv_load_policy\";i:1;s:5:\"class\";s:0:\"\";}}s:5:\"vimeo\";a:9:{s:5:\"title\";s:5:\"Vimeo\";s:8:\"function\";s:30:\"video_embed_field_handle_vimeo\";s:18:\"thumbnail_function\";s:40:\"video_embed_field_handle_vimeo_thumbnail\";s:17:\"thumbnail_default\";s:49:\"sites/all/modules/video_embed_field/img/vimeo.jpg\";s:13:\"data_function\";s:33:\"_video_embed_field_get_vimeo_data\";s:4:\"form\";s:36:\"video_embed_field_handler_vimeo_form\";s:13:\"form_validate\";s:45:\"video_embed_field_handler_vimeo_form_validate\";s:7:\"domains\";a:1:{i:0;s:9:\"vimeo.com\";}s:8:\"defaults\";a:10:{s:5:\"width\";i:640;s:6:\"height\";i:360;s:5:\"color\";s:6:\"00adef\";s:8:\"portrait\";i:1;s:5:\"title\";i:1;s:6:\"byline\";i:1;s:8:\"autoplay\";i:0;s:4:\"loop\";i:0;s:10:\"froogaloop\";i:0;s:5:\"class\";s:0:\"\";}}}',0,1512620340,1),('views:plugin_data:en','a:12:{s:7:\"display\";a:8:{s:8:\"date_nav\";a:15:{s:5:\"title\";s:12:\"Date browser\";s:4:\"help\";s:82:\"Date back/next navigation to attach to other displays. Requires the Date argument.\";s:7:\"handler\";s:30:\"date_plugin_display_attachment\";s:6:\"parent\";s:10:\"attachment\";s:4:\"path\";s:42:\"sites/all/modules/date/date_views/includes\";s:5:\"theme\";s:10:\"views_view\";s:8:\"use ajax\";b:1;s:5:\"admin\";s:12:\"Date browser\";s:10:\"help topic\";s:12:\"date-browser\";s:6:\"module\";s:10:\"date_views\";s:10:\"theme path\";s:33:\"sites/all/modules/date/date_views\";s:10:\"theme file\";s:20:\"date_views.views.inc\";s:4:\"file\";s:34:\"date_plugin_display_attachment.inc\";s:4:\"name\";s:8:\"date_nav\";s:16:\"contextual links\";a:1:{s:8:\"views_ui\";a:2:{s:11:\"parent path\";s:26:\"admin/structure/views/view\";s:19:\"argument properties\";a:1:{i:0;s:4:\"name\";}}}}s:15:\"entityreference\";a:17:{s:5:\"title\";s:16:\"Entity Reference\";s:5:\"admin\";s:23:\"Entity Reference Source\";s:4:\"help\";s:60:\"Selects referenceable entities for an entity reference field\";s:7:\"handler\";s:30:\"entityreference_plugin_display\";s:14:\"uses hook menu\";b:0;s:8:\"use ajax\";b:0;s:9:\"use pager\";b:0;s:18:\"accept attachments\";b:0;s:23:\"entityreference display\";b:1;s:6:\"module\";s:15:\"entityreference\";s:10:\"theme path\";s:33:\"sites/all/modules/entityreference\";s:10:\"theme file\";s:25:\"entityreference.views.inc\";s:4:\"path\";s:33:\"sites/all/modules/entityreference\";s:4:\"file\";s:34:\"entityreference_plugin_display.inc\";s:6:\"parent\";s:6:\"parent\";s:4:\"name\";s:15:\"entityreference\";s:16:\"contextual links\";a:1:{s:8:\"views_ui\";a:2:{s:11:\"parent path\";s:26:\"admin/structure/views/view\";s:19:\"argument properties\";a:1:{i:0;s:4:\"name\";}}}}s:7:\"default\";a:20:{s:5:\"title\";s:6:\"Master\";s:4:\"help\";s:31:\"Default settings for this view.\";s:7:\"handler\";s:28:\"views_plugin_display_default\";s:5:\"theme\";s:10:\"views_view\";s:5:\"no ui\";b:1;s:9:\"no remove\";b:1;s:2:\"js\";a:6:{i:0;s:12:\"misc/form.js\";i:1;s:16:\"misc/collapse.js\";i:2;s:16:\"misc/textarea.js\";i:3;s:17:\"misc/tabledrag.js\";i:4;s:20:\"misc/autocomplete.js\";i:5;s:40:\"sites/all/modules/ctools/js/dependent.js\";}s:8:\"use ajax\";b:1;s:9:\"use pager\";b:1;s:8:\"use more\";b:1;s:18:\"accept attachments\";b:1;s:10:\"help topic\";s:15:\"display-default\";s:6:\"module\";s:5:\"views\";s:10:\"theme path\";s:29:\"sites/all/modules/views/theme\";s:10:\"theme file\";s:9:\"theme.inc\";s:4:\"path\";s:31:\"sites/all/modules/views/plugins\";s:4:\"file\";s:32:\"views_plugin_display_default.inc\";s:6:\"parent\";s:6:\"parent\";s:4:\"name\";s:7:\"default\";s:16:\"contextual links\";a:1:{s:8:\"views_ui\";a:2:{s:11:\"parent path\";s:26:\"admin/structure/views/view\";s:19:\"argument properties\";a:1:{i:0;s:4:\"name\";}}}}s:4:\"page\";a:20:{s:5:\"title\";s:4:\"Page\";s:4:\"help\";s:54:\"Display the view as a page, with a URL and menu links.\";s:7:\"handler\";s:25:\"views_plugin_display_page\";s:5:\"theme\";s:10:\"views_view\";s:14:\"uses hook menu\";b:1;s:26:\"contextual links locations\";a:1:{i:0;s:4:\"page\";}s:8:\"use ajax\";b:1;s:9:\"use pager\";b:1;s:8:\"use more\";b:1;s:18:\"accept attachments\";b:1;s:5:\"admin\";s:4:\"Page\";s:10:\"help topic\";s:12:\"display-page\";s:6:\"module\";s:5:\"views\";s:10:\"theme path\";s:29:\"sites/all/modules/views/theme\";s:10:\"theme file\";s:9:\"theme.inc\";s:4:\"path\";s:31:\"sites/all/modules/views/plugins\";s:4:\"file\";s:29:\"views_plugin_display_page.inc\";s:6:\"parent\";s:6:\"parent\";s:4:\"name\";s:4:\"page\";s:16:\"contextual links\";a:1:{s:8:\"views_ui\";a:2:{s:11:\"parent path\";s:26:\"admin/structure/views/view\";s:19:\"argument properties\";a:1:{i:0;s:4:\"name\";}}}}s:5:\"block\";a:20:{s:5:\"title\";s:5:\"Block\";s:4:\"help\";s:28:\"Display the view as a block.\";s:7:\"handler\";s:26:\"views_plugin_display_block\";s:5:\"theme\";s:10:\"views_view\";s:15:\"uses hook block\";b:1;s:26:\"contextual links locations\";a:1:{i:0;s:5:\"block\";}s:8:\"use ajax\";b:1;s:9:\"use pager\";b:1;s:8:\"use more\";b:1;s:18:\"accept attachments\";b:1;s:5:\"admin\";s:5:\"Block\";s:10:\"help topic\";s:13:\"display-block\";s:6:\"module\";s:5:\"views\";s:10:\"theme path\";s:29:\"sites/all/modules/views/theme\";s:10:\"theme file\";s:9:\"theme.inc\";s:4:\"path\";s:31:\"sites/all/modules/views/plugins\";s:4:\"file\";s:30:\"views_plugin_display_block.inc\";s:6:\"parent\";s:6:\"parent\";s:4:\"name\";s:5:\"block\";s:16:\"contextual links\";a:1:{s:8:\"views_ui\";a:2:{s:11:\"parent path\";s:26:\"admin/structure/views/view\";s:19:\"argument properties\";a:1:{i:0;s:4:\"name\";}}}}s:10:\"attachment\";a:18:{s:5:\"title\";s:10:\"Attachment\";s:4:\"help\";s:79:\"Attachments added to other displays to achieve multiple views in the same view.\";s:7:\"handler\";s:31:\"views_plugin_display_attachment\";s:5:\"theme\";s:10:\"views_view\";s:26:\"contextual links locations\";a:0:{}s:8:\"use ajax\";b:1;s:9:\"use pager\";b:0;s:8:\"use more\";b:1;s:18:\"accept attachments\";b:0;s:10:\"help topic\";s:18:\"display-attachment\";s:6:\"module\";s:5:\"views\";s:10:\"theme path\";s:29:\"sites/all/modules/views/theme\";s:10:\"theme file\";s:9:\"theme.inc\";s:4:\"path\";s:31:\"sites/all/modules/views/plugins\";s:4:\"file\";s:35:\"views_plugin_display_attachment.inc\";s:6:\"parent\";s:6:\"parent\";s:4:\"name\";s:10:\"attachment\";s:16:\"contextual links\";a:1:{s:8:\"views_ui\";a:2:{s:11:\"parent path\";s:26:\"admin/structure/views/view\";s:19:\"argument properties\";a:1:{i:0;s:4:\"name\";}}}}s:4:\"feed\";a:17:{s:5:\"title\";s:4:\"Feed\";s:4:\"help\";s:48:\"Display the view as a feed, such as an RSS feed.\";s:7:\"handler\";s:25:\"views_plugin_display_feed\";s:14:\"uses hook menu\";b:1;s:8:\"use ajax\";b:0;s:9:\"use pager\";b:0;s:18:\"accept attachments\";b:0;s:5:\"admin\";s:4:\"Feed\";s:10:\"help topic\";s:12:\"display-feed\";s:6:\"module\";s:5:\"views\";s:10:\"theme path\";s:29:\"sites/all/modules/views/theme\";s:10:\"theme file\";s:9:\"theme.inc\";s:4:\"path\";s:31:\"sites/all/modules/views/plugins\";s:4:\"file\";s:29:\"views_plugin_display_feed.inc\";s:6:\"parent\";s:6:\"parent\";s:4:\"name\";s:4:\"feed\";s:16:\"contextual links\";a:1:{s:8:\"views_ui\";a:2:{s:11:\"parent path\";s:26:\"admin/structure/views/view\";s:19:\"argument properties\";a:1:{i:0;s:4:\"name\";}}}}s:5:\"embed\";a:18:{s:5:\"title\";s:5:\"Embed\";s:4:\"help\";s:60:\"Provide a display which can be embedded using the views api.\";s:7:\"handler\";s:26:\"views_plugin_display_embed\";s:5:\"theme\";s:10:\"views_view\";s:14:\"uses hook menu\";b:0;s:8:\"use ajax\";b:1;s:9:\"use pager\";b:1;s:18:\"accept attachments\";b:0;s:5:\"admin\";s:5:\"Embed\";s:5:\"no ui\";b:1;s:6:\"module\";s:5:\"views\";s:10:\"theme path\";s:29:\"sites/all/modules/views/theme\";s:10:\"theme file\";s:9:\"theme.inc\";s:4:\"path\";s:31:\"sites/all/modules/views/plugins\";s:4:\"file\";s:30:\"views_plugin_display_embed.inc\";s:6:\"parent\";s:6:\"parent\";s:4:\"name\";s:5:\"embed\";s:16:\"contextual links\";a:1:{s:8:\"views_ui\";a:2:{s:11:\"parent path\";s:26:\"admin/structure/views/view\";s:19:\"argument properties\";a:1:{i:0;s:4:\"name\";}}}}}s:5:\"style\";a:16:{s:14:\"calendar_style\";a:19:{s:5:\"title\";s:8:\"Calendar\";s:4:\"help\";s:35:\"Present view results as a Calendar.\";s:7:\"handler\";s:21:\"calendar_plugin_style\";s:4:\"path\";s:35:\"sites/all/modules/calendar/includes\";s:5:\"theme\";s:14:\"calendar_style\";s:10:\"theme file\";s:9:\"theme.inc\";s:10:\"theme path\";s:32:\"sites/all/modules/calendar/theme\";s:17:\"additional themes\";a:7:{s:13:\"calendar_mini\";s:5:\"style\";s:12:\"calendar_day\";s:5:\"style\";s:13:\"calendar_week\";s:5:\"style\";s:14:\"calendar_month\";s:5:\"style\";s:13:\"calendar_year\";s:5:\"style\";s:20:\"calendar_day_overlap\";s:5:\"style\";s:21:\"calendar_week_overlap\";s:5:\"style\";}s:11:\"uses fields\";b:1;s:13:\"uses grouping\";b:0;s:15:\"uses row plugin\";b:1;s:12:\"uses options\";b:1;s:4:\"type\";s:6:\"normal\";s:10:\"even empty\";b:1;s:4:\"base\";a:14:{i:0;s:7:\"comment\";i:1;s:21:\"field_collection_item\";i:2;s:30:\"field_collection_item_revision\";i:3;s:20:\"i18n_translation_set\";i:4;s:21:\"message_type_category\";i:5;s:12:\"message_type\";i:6;s:7:\"message\";i:7;s:4:\"node\";i:8;s:13:\"node_revision\";i:9;s:12:\"file_managed\";i:10;s:18:\"taxonomy_term_data\";i:11;s:19:\"taxonomy_vocabulary\";i:12;s:5:\"users\";i:13;s:19:\"webform_submissions\";}s:6:\"module\";s:8:\"calendar\";s:4:\"file\";s:25:\"calendar_plugin_style.inc\";s:6:\"parent\";s:6:\"parent\";s:4:\"name\";s:14:\"calendar_style\";}s:8:\"date_nav\";a:16:{s:5:\"title\";s:18:\"Date browser style\";s:4:\"help\";s:29:\"Creates back/next navigation.\";s:7:\"handler\";s:28:\"date_navigation_plugin_style\";s:4:\"path\";s:42:\"sites/all/modules/date/date_views/includes\";s:5:\"theme\";s:15:\"date_navigation\";s:10:\"theme file\";s:9:\"theme.inc\";s:10:\"theme path\";s:39:\"sites/all/modules/date/date_views/theme\";s:15:\"uses row plugin\";b:0;s:11:\"uses fields\";b:0;s:12:\"uses options\";b:1;s:4:\"type\";s:8:\"date_nav\";s:10:\"even empty\";b:1;s:6:\"module\";s:10:\"date_views\";s:4:\"file\";s:32:\"date_navigation_plugin_style.inc\";s:6:\"parent\";s:6:\"parent\";s:4:\"name\";s:8:\"date_nav\";}s:21:\"entityreference_style\";a:16:{s:5:\"title\";s:21:\"Entity Reference list\";s:4:\"help\";s:59:\"Returns results as a PHP array of labels and rendered rows.\";s:7:\"handler\";s:28:\"entityreference_plugin_style\";s:5:\"theme\";s:22:\"views_view_unformatted\";s:15:\"uses row plugin\";b:1;s:11:\"uses fields\";b:1;s:12:\"uses options\";b:1;s:4:\"type\";s:15:\"entityreference\";s:10:\"even empty\";b:1;s:6:\"module\";s:15:\"entityreference\";s:10:\"theme path\";s:33:\"sites/all/modules/entityreference\";s:10:\"theme file\";s:25:\"entityreference.views.inc\";s:4:\"path\";s:33:\"sites/all/modules/entityreference\";s:4:\"file\";s:32:\"entityreference_plugin_style.inc\";s:6:\"parent\";s:6:\"parent\";s:4:\"name\";s:21:\"entityreference_style\";}s:10:\"flexslider\";a:16:{s:5:\"title\";s:10:\"FlexSlider\";s:4:\"help\";s:43:\"Display the results in a FlexSlider widget.\";s:7:\"handler\";s:40:\"flexslider_views_plugin_style_flexslider\";s:5:\"theme\";s:16:\"flexslider_views\";s:10:\"theme file\";s:26:\"flexslider_views.theme.inc\";s:10:\"theme path\";s:51:\"sites/all/modules/flexslider/flexslider_views/theme\";s:15:\"uses row plugin\";b:1;s:11:\"uses fields\";b:1;s:12:\"uses options\";b:1;s:4:\"type\";s:6:\"normal\";s:10:\"even empty\";b:0;s:6:\"module\";s:16:\"flexslider_views\";s:4:\"path\";s:45:\"sites/all/modules/flexslider/flexslider_views\";s:4:\"file\";s:44:\"flexslider_views_plugin_style_flexslider.inc\";s:6:\"parent\";s:6:\"parent\";s:4:\"name\";s:10:\"flexslider\";}s:9:\"quicktabs\";a:14:{s:5:\"title\";s:9:\"Quicktabs\";s:4:\"help\";s:26:\"Display view in Quicktabs.\";s:7:\"handler\";s:22:\"quicktabs_style_plugin\";s:4:\"path\";s:36:\"sites/all/modules/quicktabs/includes\";s:5:\"theme\";s:14:\"quicktabs_view\";s:15:\"uses row plugin\";b:1;s:12:\"uses options\";b:1;s:4:\"type\";s:6:\"normal\";s:6:\"module\";s:9:\"quicktabs\";s:10:\"theme path\";s:27:\"sites/all/modules/quicktabs\";s:10:\"theme file\";s:19:\"quicktabs.views.inc\";s:4:\"file\";s:26:\"quicktabs_style_plugin.inc\";s:6:\"parent\";s:6:\"parent\";s:4:\"name\";s:9:\"quicktabs\";}s:9:\"slideshow\";a:16:{s:5:\"title\";s:9:\"Slideshow\";s:4:\"help\";s:35:\"Display the results as a slideshow.\";s:7:\"handler\";s:38:\"views_slideshow_plugin_style_slideshow\";s:12:\"uses options\";b:1;s:15:\"uses row plugin\";b:1;s:13:\"uses grouping\";b:0;s:14:\"uses row class\";b:1;s:4:\"type\";s:6:\"normal\";s:4:\"path\";s:33:\"sites/all/modules/views_slideshow\";s:5:\"theme\";s:15:\"views_slideshow\";s:10:\"theme path\";s:39:\"sites/all/modules/views_slideshow/theme\";s:10:\"theme file\";s:25:\"views_slideshow.theme.inc\";s:6:\"module\";s:15:\"views_slideshow\";s:4:\"file\";s:42:\"views_slideshow_plugin_style_slideshow.inc\";s:6:\"parent\";s:6:\"parent\";s:4:\"name\";s:9:\"slideshow\";}s:7:\"default\";a:17:{s:5:\"title\";s:16:\"Unformatted list\";s:4:\"help\";s:32:\"Displays rows one after another.\";s:7:\"handler\";s:26:\"views_plugin_style_default\";s:5:\"theme\";s:22:\"views_view_unformatted\";s:15:\"uses row plugin\";b:1;s:14:\"uses row class\";b:1;s:13:\"uses grouping\";b:1;s:12:\"uses options\";b:1;s:4:\"type\";s:6:\"normal\";s:10:\"help topic\";s:17:\"style-unformatted\";s:6:\"module\";s:5:\"views\";s:10:\"theme path\";s:29:\"sites/all/modules/views/theme\";s:10:\"theme file\";s:9:\"theme.inc\";s:4:\"path\";s:31:\"sites/all/modules/views/plugins\";s:4:\"file\";s:30:\"views_plugin_style_default.inc\";s:6:\"parent\";s:6:\"parent\";s:4:\"name\";s:7:\"default\";}s:4:\"list\";a:16:{s:5:\"title\";s:9:\"HTML list\";s:4:\"help\";s:30:\"Displays rows as an HTML list.\";s:7:\"handler\";s:23:\"views_plugin_style_list\";s:5:\"theme\";s:15:\"views_view_list\";s:15:\"uses row plugin\";b:1;s:14:\"uses row class\";b:1;s:12:\"uses options\";b:1;s:4:\"type\";s:6:\"normal\";s:10:\"help topic\";s:10:\"style-list\";s:6:\"module\";s:5:\"views\";s:10:\"theme path\";s:29:\"sites/all/modules/views/theme\";s:10:\"theme file\";s:9:\"theme.inc\";s:4:\"path\";s:31:\"sites/all/modules/views/plugins\";s:4:\"file\";s:27:\"views_plugin_style_list.inc\";s:6:\"parent\";s:6:\"parent\";s:4:\"name\";s:4:\"list\";}s:4:\"grid\";a:17:{s:5:\"title\";s:4:\"Grid\";s:4:\"help\";s:24:\"Displays rows in a grid.\";s:7:\"handler\";s:23:\"views_plugin_style_grid\";s:5:\"theme\";s:15:\"views_view_grid\";s:11:\"uses fields\";b:0;s:15:\"uses row plugin\";b:1;s:14:\"uses row class\";b:1;s:12:\"uses options\";b:1;s:4:\"type\";s:6:\"normal\";s:10:\"help topic\";s:10:\"style-grid\";s:6:\"module\";s:5:\"views\";s:10:\"theme path\";s:29:\"sites/all/modules/views/theme\";s:10:\"theme file\";s:9:\"theme.inc\";s:4:\"path\";s:31:\"sites/all/modules/views/plugins\";s:4:\"file\";s:27:\"views_plugin_style_grid.inc\";s:6:\"parent\";s:6:\"parent\";s:4:\"name\";s:4:\"grid\";}s:5:\"table\";a:17:{s:5:\"title\";s:5:\"Table\";s:4:\"help\";s:25:\"Displays rows in a table.\";s:7:\"handler\";s:24:\"views_plugin_style_table\";s:5:\"theme\";s:16:\"views_view_table\";s:15:\"uses row plugin\";b:0;s:14:\"uses row class\";b:1;s:11:\"uses fields\";b:1;s:12:\"uses options\";b:1;s:4:\"type\";s:6:\"normal\";s:10:\"help topic\";s:11:\"style-table\";s:6:\"module\";s:5:\"views\";s:10:\"theme path\";s:29:\"sites/all/modules/views/theme\";s:10:\"theme file\";s:9:\"theme.inc\";s:4:\"path\";s:31:\"sites/all/modules/views/plugins\";s:4:\"file\";s:28:\"views_plugin_style_table.inc\";s:6:\"parent\";s:6:\"parent\";s:4:\"name\";s:5:\"table\";}s:15:\"default_summary\";a:14:{s:5:\"title\";s:4:\"List\";s:4:\"help\";s:39:\"Displays the default summary as a list.\";s:7:\"handler\";s:26:\"views_plugin_style_summary\";s:5:\"theme\";s:18:\"views_view_summary\";s:4:\"type\";s:7:\"summary\";s:12:\"uses options\";b:1;s:10:\"help topic\";s:13:\"style-summary\";s:6:\"module\";s:5:\"views\";s:10:\"theme path\";s:29:\"sites/all/modules/views/theme\";s:10:\"theme file\";s:9:\"theme.inc\";s:4:\"path\";s:31:\"sites/all/modules/views/plugins\";s:4:\"file\";s:30:\"views_plugin_style_summary.inc\";s:6:\"parent\";s:6:\"parent\";s:4:\"name\";s:15:\"default_summary\";}s:19:\"unformatted_summary\";a:14:{s:5:\"title\";s:11:\"Unformatted\";s:4:\"help\";s:78:\"Displays the summary unformatted, with option for one after another or inline.\";s:7:\"handler\";s:38:\"views_plugin_style_summary_unformatted\";s:5:\"theme\";s:30:\"views_view_summary_unformatted\";s:4:\"type\";s:7:\"summary\";s:12:\"uses options\";b:1;s:10:\"help topic\";s:25:\"style-summary-unformatted\";s:6:\"module\";s:5:\"views\";s:10:\"theme path\";s:29:\"sites/all/modules/views/theme\";s:10:\"theme file\";s:9:\"theme.inc\";s:4:\"path\";s:31:\"sites/all/modules/views/plugins\";s:4:\"file\";s:42:\"views_plugin_style_summary_unformatted.inc\";s:6:\"parent\";s:6:\"parent\";s:4:\"name\";s:19:\"unformatted_summary\";}s:3:\"rss\";a:15:{s:5:\"title\";s:8:\"RSS Feed\";s:4:\"help\";s:34:\"Generates an RSS feed from a view.\";s:7:\"handler\";s:22:\"views_plugin_style_rss\";s:5:\"theme\";s:14:\"views_view_rss\";s:15:\"uses row plugin\";b:1;s:12:\"uses options\";b:1;s:4:\"type\";s:4:\"feed\";s:10:\"help topic\";s:9:\"style-rss\";s:6:\"module\";s:5:\"views\";s:10:\"theme path\";s:29:\"sites/all/modules/views/theme\";s:10:\"theme file\";s:9:\"theme.inc\";s:4:\"path\";s:31:\"sites/all/modules/views/plugins\";s:4:\"file\";s:26:\"views_plugin_style_rss.inc\";s:6:\"parent\";s:6:\"parent\";s:4:\"name\";s:3:\"rss\";}s:17:\"jump_menu_summary\";a:14:{s:5:\"title\";s:9:\"Jump menu\";s:4:\"help\";s:111:\"Puts all of the results into a select box and allows the user to go to a different page based upon the results.\";s:7:\"handler\";s:36:\"views_plugin_style_summary_jump_menu\";s:5:\"theme\";s:28:\"views_view_summary_jump_menu\";s:4:\"type\";s:7:\"summary\";s:12:\"uses options\";b:1;s:10:\"help topic\";s:23:\"style-summary-jump-menu\";s:6:\"module\";s:5:\"views\";s:10:\"theme path\";s:29:\"sites/all/modules/views/theme\";s:10:\"theme file\";s:9:\"theme.inc\";s:4:\"path\";s:31:\"sites/all/modules/views/plugins\";s:4:\"file\";s:40:\"views_plugin_style_summary_jump_menu.inc\";s:6:\"parent\";s:6:\"parent\";s:4:\"name\";s:17:\"jump_menu_summary\";}s:9:\"jump_menu\";a:16:{s:5:\"title\";s:9:\"Jump menu\";s:4:\"help\";s:111:\"Puts all of the results into a select box and allows the user to go to a different page based upon the results.\";s:7:\"handler\";s:28:\"views_plugin_style_jump_menu\";s:5:\"theme\";s:20:\"views_view_jump_menu\";s:15:\"uses row plugin\";b:1;s:11:\"uses fields\";b:1;s:12:\"uses options\";b:1;s:4:\"type\";s:6:\"normal\";s:10:\"help topic\";s:15:\"style-jump-menu\";s:6:\"module\";s:5:\"views\";s:10:\"theme path\";s:29:\"sites/all/modules/views/theme\";s:10:\"theme file\";s:9:\"theme.inc\";s:4:\"path\";s:31:\"sites/all/modules/views/plugins\";s:4:\"file\";s:32:\"views_plugin_style_jump_menu.inc\";s:6:\"parent\";s:6:\"parent\";s:4:\"name\";s:9:\"jump_menu\";}s:16:\"forum_topic_list\";a:15:{s:6:\"parent\";s:5:\"table\";s:4:\"path\";s:47:\"sites/all/modules/advanced_forum/includes/views\";s:5:\"title\";s:16:\"Forum topic list\";s:4:\"help\";s:40:\"Displays the forum topic list as a view.\";s:7:\"handler\";s:44:\"advanced_forum_plugin_style_forum_topic_list\";s:10:\"theme path\";s:41:\"sites/all/modules/advanced_forum/includes\";s:10:\"theme file\";s:9:\"theme.inc\";s:5:\"theme\";s:30:\"advanced_forum_topic_list_view\";s:15:\"uses row plugin\";b:0;s:11:\"uses fields\";b:1;s:12:\"uses options\";b:1;s:4:\"type\";s:6:\"normal\";s:6:\"module\";s:14:\"advanced_forum\";s:4:\"file\";s:48:\"advanced_forum_plugin_style_forum_topic_list.inc\";s:4:\"name\";s:16:\"forum_topic_list\";}}s:3:\"row\";a:12:{s:18:\"webform_submission\";a:12:{s:5:\"title\";s:20:\"Rendered submissions\";s:4:\"help\";s:31:\"Display the rendered submission\";s:7:\"handler\";s:40:\"webform_views_plugin_row_submission_view\";s:12:\"uses options\";b:1;s:4:\"type\";s:6:\"normal\";s:6:\"module\";s:7:\"webform\";s:10:\"theme path\";s:25:\"sites/all/modules/webform\";s:10:\"theme file\";s:17:\"webform.views.inc\";s:4:\"path\";s:25:\"sites/all/modules/webform\";s:4:\"file\";s:44:\"webform_views_plugin_row_submission_view.inc\";s:6:\"parent\";s:6:\"parent\";s:4:\"name\";s:18:\"webform_submission\";}s:13:\"calendar_node\";a:15:{s:5:\"title\";s:56:\"Calendar Items (DEPRECATED, switch to Calendar Entities)\";s:4:\"help\";s:47:\"Displays each selected node as a Calendar item.\";s:7:\"handler\";s:24:\"calendar_plugin_row_node\";s:4:\"path\";s:35:\"sites/all/modules/calendar/includes\";s:4:\"base\";a:1:{i:0;s:4:\"node\";}s:12:\"uses options\";b:1;s:11:\"uses fields\";b:1;s:4:\"type\";s:6:\"normal\";s:5:\"no ui\";b:1;s:6:\"module\";s:8:\"calendar\";s:10:\"theme path\";s:26:\"sites/all/modules/calendar\";s:10:\"theme file\";s:18:\"calendar.views.inc\";s:4:\"file\";s:28:\"calendar_plugin_row_node.inc\";s:6:\"parent\";s:6:\"parent\";s:4:\"name\";s:13:\"calendar_node\";}s:15:\"calendar_entity\";a:15:{s:5:\"title\";s:17:\"Calendar Entities\";s:4:\"help\";s:49:\"Displays each selected entity as a Calendar item.\";s:7:\"handler\";s:19:\"calendar_plugin_row\";s:5:\"theme\";s:17:\"views_view_fields\";s:4:\"path\";s:35:\"sites/all/modules/calendar/includes\";s:4:\"base\";a:14:{i:0;s:7:\"comment\";i:1;s:21:\"field_collection_item\";i:2;s:30:\"field_collection_item_revision\";i:3;s:20:\"i18n_translation_set\";i:4;s:21:\"message_type_category\";i:5;s:12:\"message_type\";i:6;s:7:\"message\";i:7;s:4:\"node\";i:8;s:13:\"node_revision\";i:9;s:12:\"file_managed\";i:10;s:18:\"taxonomy_term_data\";i:11;s:19:\"taxonomy_vocabulary\";i:12;s:5:\"users\";i:13;s:19:\"webform_submissions\";}s:12:\"uses options\";b:1;s:11:\"uses fields\";b:1;s:4:\"type\";s:6:\"normal\";s:6:\"module\";s:8:\"calendar\";s:10:\"theme path\";s:26:\"sites/all/modules/calendar\";s:10:\"theme file\";s:18:\"calendar.views.inc\";s:4:\"file\";s:23:\"calendar_plugin_row.inc\";s:6:\"parent\";s:6:\"parent\";s:4:\"name\";s:15:\"calendar_entity\";}s:7:\"comment\";a:15:{s:5:\"title\";s:7:\"Comment\";s:4:\"help\";s:47:\"Display the comment with standard comment view.\";s:7:\"handler\";s:29:\"views_plugin_row_comment_view\";s:5:\"theme\";s:22:\"views_view_row_comment\";s:4:\"path\";s:39:\"sites/all/modules/views/modules/comment\";s:4:\"base\";a:1:{i:0;s:7:\"comment\";}s:12:\"uses options\";b:1;s:4:\"type\";s:6:\"normal\";s:10:\"help topic\";s:13:\"style-comment\";s:6:\"module\";s:5:\"views\";s:10:\"theme path\";s:29:\"sites/all/modules/views/theme\";s:10:\"theme file\";s:9:\"theme.inc\";s:4:\"file\";s:33:\"views_plugin_row_comment_view.inc\";s:6:\"parent\";s:6:\"parent\";s:4:\"name\";s:7:\"comment\";}s:11:\"comment_rss\";a:15:{s:5:\"title\";s:7:\"Comment\";s:4:\"help\";s:27:\"Display the comment as RSS.\";s:7:\"handler\";s:28:\"views_plugin_row_comment_rss\";s:5:\"theme\";s:18:\"views_view_row_rss\";s:4:\"path\";s:39:\"sites/all/modules/views/modules/comment\";s:4:\"base\";a:1:{i:0;s:7:\"comment\";}s:12:\"uses options\";b:1;s:4:\"type\";s:4:\"feed\";s:10:\"help topic\";s:17:\"style-comment-rss\";s:6:\"module\";s:5:\"views\";s:10:\"theme path\";s:29:\"sites/all/modules/views/theme\";s:10:\"theme file\";s:9:\"theme.inc\";s:4:\"file\";s:32:\"views_plugin_row_comment_rss.inc\";s:6:\"parent\";s:6:\"parent\";s:4:\"name\";s:11:\"comment_rss\";}s:6:\"entity\";a:14:{s:5:\"title\";s:15:\"Rendered entity\";s:4:\"help\";s:62:\"Renders a single entity in a specific view mode (e.g. teaser).\";s:7:\"handler\";s:35:\"entity_views_plugin_row_entity_view\";s:11:\"uses fields\";b:0;s:12:\"uses options\";b:1;s:4:\"type\";s:6:\"normal\";s:4:\"base\";a:11:{i:0;s:7:\"comment\";i:1;s:21:\"field_collection_item\";i:2;s:30:\"field_collection_item_revision\";i:3;s:21:\"message_type_category\";i:4;s:12:\"message_type\";i:5;s:7:\"message\";i:6;s:4:\"node\";i:7;s:13:\"node_revision\";i:8;s:12:\"file_managed\";i:9;s:18:\"taxonomy_term_data\";i:10;s:5:\"users\";}s:6:\"module\";s:6:\"entity\";s:10:\"theme path\";s:24:\"sites/all/modules/entity\";s:10:\"theme file\";s:16:\"entity.views.inc\";s:4:\"path\";s:24:\"sites/all/modules/entity\";s:4:\"file\";s:39:\"entity_views_plugin_row_entity_view.inc\";s:6:\"parent\";s:6:\"parent\";s:4:\"name\";s:6:\"entity\";}s:22:\"entityreference_fields\";a:14:{s:5:\"title\";s:13:\"Inline fields\";s:4:\"help\";s:46:\"Displays the fields with an optional template.\";s:7:\"handler\";s:33:\"entityreference_plugin_row_fields\";s:5:\"theme\";s:17:\"views_view_fields\";s:10:\"theme path\";s:29:\"sites/all/modules/views/theme\";s:10:\"theme file\";s:9:\"theme.inc\";s:11:\"uses fields\";b:1;s:12:\"uses options\";b:1;s:4:\"type\";s:15:\"entityreference\";s:6:\"module\";s:15:\"entityreference\";s:4:\"path\";s:33:\"sites/all/modules/entityreference\";s:4:\"file\";s:37:\"entityreference_plugin_row_fields.inc\";s:6:\"parent\";s:6:\"parent\";s:4:\"name\";s:22:\"entityreference_fields\";}s:4:\"node\";a:14:{s:5:\"title\";s:7:\"Content\";s:4:\"help\";s:44:\"Display the content with standard node view.\";s:7:\"handler\";s:26:\"views_plugin_row_node_view\";s:4:\"path\";s:36:\"sites/all/modules/views/modules/node\";s:4:\"base\";a:1:{i:0;s:4:\"node\";}s:12:\"uses options\";b:1;s:4:\"type\";s:6:\"normal\";s:10:\"help topic\";s:10:\"style-node\";s:6:\"module\";s:5:\"views\";s:10:\"theme path\";s:29:\"sites/all/modules/views/theme\";s:10:\"theme file\";s:9:\"theme.inc\";s:4:\"file\";s:30:\"views_plugin_row_node_view.inc\";s:6:\"parent\";s:6:\"parent\";s:4:\"name\";s:4:\"node\";}s:8:\"node_rss\";a:15:{s:5:\"title\";s:7:\"Content\";s:4:\"help\";s:44:\"Display the content with standard node view.\";s:7:\"handler\";s:25:\"views_plugin_row_node_rss\";s:4:\"path\";s:36:\"sites/all/modules/views/modules/node\";s:5:\"theme\";s:18:\"views_view_row_rss\";s:4:\"base\";a:1:{i:0;s:4:\"node\";}s:12:\"uses options\";b:1;s:4:\"type\";s:4:\"feed\";s:10:\"help topic\";s:14:\"style-node-rss\";s:6:\"module\";s:5:\"views\";s:10:\"theme path\";s:29:\"sites/all/modules/views/theme\";s:10:\"theme file\";s:9:\"theme.inc\";s:4:\"file\";s:29:\"views_plugin_row_node_rss.inc\";s:6:\"parent\";s:6:\"parent\";s:4:\"name\";s:8:\"node_rss\";}s:4:\"user\";a:14:{s:5:\"title\";s:4:\"User\";s:4:\"help\";s:41:\"Display the user with standard user view.\";s:7:\"handler\";s:26:\"views_plugin_row_user_view\";s:4:\"base\";a:1:{i:0;s:5:\"users\";}s:12:\"uses options\";b:1;s:4:\"type\";s:6:\"normal\";s:10:\"help topic\";s:11:\"style-users\";s:6:\"module\";s:5:\"views\";s:10:\"theme path\";s:29:\"sites/all/modules/views/theme\";s:10:\"theme file\";s:9:\"theme.inc\";s:4:\"path\";s:31:\"sites/all/modules/views/plugins\";s:4:\"file\";s:30:\"views_plugin_row_user_view.inc\";s:6:\"parent\";s:6:\"parent\";s:4:\"name\";s:4:\"user\";}s:6:\"fields\";a:15:{s:5:\"title\";s:6:\"Fields\";s:4:\"help\";s:46:\"Displays the fields with an optional template.\";s:7:\"handler\";s:23:\"views_plugin_row_fields\";s:5:\"theme\";s:17:\"views_view_fields\";s:11:\"uses fields\";b:1;s:12:\"uses options\";b:1;s:4:\"type\";s:6:\"normal\";s:10:\"help topic\";s:16:\"style-row-fields\";s:6:\"module\";s:5:\"views\";s:10:\"theme path\";s:29:\"sites/all/modules/views/theme\";s:10:\"theme file\";s:9:\"theme.inc\";s:4:\"path\";s:31:\"sites/all/modules/views/plugins\";s:4:\"file\";s:27:\"views_plugin_row_fields.inc\";s:6:\"parent\";s:6:\"parent\";s:4:\"name\";s:6:\"fields\";}s:10:\"rss_fields\";a:15:{s:5:\"title\";s:6:\"Fields\";s:4:\"help\";s:28:\"Display fields as RSS items.\";s:7:\"handler\";s:27:\"views_plugin_row_rss_fields\";s:5:\"theme\";s:18:\"views_view_row_rss\";s:11:\"uses fields\";b:1;s:12:\"uses options\";b:1;s:4:\"type\";s:4:\"feed\";s:10:\"help topic\";s:16:\"style-row-fields\";s:6:\"module\";s:5:\"views\";s:10:\"theme path\";s:29:\"sites/all/modules/views/theme\";s:10:\"theme file\";s:9:\"theme.inc\";s:4:\"path\";s:31:\"sites/all/modules/views/plugins\";s:4:\"file\";s:31:\"views_plugin_row_rss_fields.inc\";s:6:\"parent\";s:6:\"parent\";s:4:\"name\";s:10:\"rss_fields\";}}s:16:\"argument default\";a:9:{s:9:\"book_root\";a:9:{s:5:\"title\";s:27:\"Book root from current node\";s:7:\"handler\";s:39:\"views_plugin_argument_default_book_root\";s:6:\"module\";s:5:\"views\";s:10:\"theme path\";s:29:\"sites/all/modules/views/theme\";s:10:\"theme file\";s:9:\"theme.inc\";s:4:\"path\";s:31:\"sites/all/modules/views/plugins\";s:4:\"file\";s:43:\"views_plugin_argument_default_book_root.inc\";s:6:\"parent\";s:6:\"parent\";s:4:\"name\";s:9:\"book_root\";}s:4:\"node\";a:9:{s:5:\"title\";s:19:\"Content ID from URL\";s:7:\"handler\";s:34:\"views_plugin_argument_default_node\";s:6:\"module\";s:5:\"views\";s:10:\"theme path\";s:29:\"sites/all/modules/views/theme\";s:10:\"theme file\";s:9:\"theme.inc\";s:4:\"path\";s:31:\"sites/all/modules/views/plugins\";s:4:\"file\";s:38:\"views_plugin_argument_default_node.inc\";s:6:\"parent\";s:6:\"parent\";s:4:\"name\";s:4:\"node\";}s:12:\"taxonomy_tid\";a:9:{s:5:\"title\";s:25:\"Taxonomy term ID from URL\";s:7:\"handler\";s:42:\"views_plugin_argument_default_taxonomy_tid\";s:4:\"path\";s:40:\"sites/all/modules/views/modules/taxonomy\";s:6:\"parent\";s:5:\"fixed\";s:6:\"module\";s:5:\"views\";s:10:\"theme path\";s:29:\"sites/all/modules/views/theme\";s:10:\"theme file\";s:9:\"theme.inc\";s:4:\"file\";s:46:\"views_plugin_argument_default_taxonomy_tid.inc\";s:4:\"name\";s:12:\"taxonomy_tid\";}s:4:\"user\";a:9:{s:5:\"title\";s:16:\"User ID from URL\";s:7:\"handler\";s:34:\"views_plugin_argument_default_user\";s:4:\"path\";s:36:\"sites/all/modules/views/modules/user\";s:6:\"module\";s:5:\"views\";s:10:\"theme path\";s:29:\"sites/all/modules/views/theme\";s:10:\"theme file\";s:9:\"theme.inc\";s:4:\"file\";s:38:\"views_plugin_argument_default_user.inc\";s:6:\"parent\";s:6:\"parent\";s:4:\"name\";s:4:\"user\";}s:12:\"current_user\";a:9:{s:5:\"title\";s:27:\"User ID from logged in user\";s:7:\"handler\";s:42:\"views_plugin_argument_default_current_user\";s:4:\"path\";s:36:\"sites/all/modules/views/modules/user\";s:6:\"module\";s:5:\"views\";s:10:\"theme path\";s:29:\"sites/all/modules/views/theme\";s:10:\"theme file\";s:9:\"theme.inc\";s:4:\"file\";s:46:\"views_plugin_argument_default_current_user.inc\";s:6:\"parent\";s:6:\"parent\";s:4:\"name\";s:12:\"current_user\";}s:6:\"parent\";a:9:{s:5:\"no ui\";b:1;s:7:\"handler\";s:29:\"views_plugin_argument_default\";s:6:\"parent\";s:0:\"\";s:6:\"module\";s:5:\"views\";s:10:\"theme path\";s:29:\"sites/all/modules/views/theme\";s:10:\"theme file\";s:9:\"theme.inc\";s:4:\"path\";s:31:\"sites/all/modules/views/plugins\";s:4:\"file\";s:33:\"views_plugin_argument_default.inc\";s:4:\"name\";s:6:\"parent\";}s:5:\"fixed\";a:9:{s:5:\"title\";s:11:\"Fixed value\";s:7:\"handler\";s:35:\"views_plugin_argument_default_fixed\";s:6:\"module\";s:5:\"views\";s:10:\"theme path\";s:29:\"sites/all/modules/views/theme\";s:10:\"theme file\";s:9:\"theme.inc\";s:4:\"path\";s:31:\"sites/all/modules/views/plugins\";s:4:\"file\";s:39:\"views_plugin_argument_default_fixed.inc\";s:6:\"parent\";s:6:\"parent\";s:4:\"name\";s:5:\"fixed\";}s:3:\"php\";a:9:{s:5:\"title\";s:8:\"PHP Code\";s:7:\"handler\";s:33:\"views_plugin_argument_default_php\";s:6:\"module\";s:5:\"views\";s:10:\"theme path\";s:29:\"sites/all/modules/views/theme\";s:10:\"theme file\";s:9:\"theme.inc\";s:4:\"path\";s:31:\"sites/all/modules/views/plugins\";s:4:\"file\";s:37:\"views_plugin_argument_default_php.inc\";s:6:\"parent\";s:6:\"parent\";s:4:\"name\";s:3:\"php\";}s:3:\"raw\";a:9:{s:5:\"title\";s:18:\"Raw value from URL\";s:7:\"handler\";s:33:\"views_plugin_argument_default_raw\";s:6:\"module\";s:5:\"views\";s:10:\"theme path\";s:29:\"sites/all/modules/views/theme\";s:10:\"theme file\";s:9:\"theme.inc\";s:4:\"path\";s:31:\"sites/all/modules/views/plugins\";s:4:\"file\";s:37:\"views_plugin_argument_default_raw.inc\";s:6:\"parent\";s:6:\"parent\";s:4:\"name\";s:3:\"raw\";}}s:18:\"argument validator\";a:5:{s:4:\"node\";a:9:{s:5:\"title\";s:7:\"Content\";s:7:\"handler\";s:35:\"views_plugin_argument_validate_node\";s:6:\"module\";s:5:\"views\";s:10:\"theme path\";s:29:\"sites/all/modules/views/theme\";s:10:\"theme file\";s:9:\"theme.inc\";s:4:\"path\";s:31:\"sites/all/modules/views/plugins\";s:4:\"file\";s:39:\"views_plugin_argument_validate_node.inc\";s:6:\"parent\";s:6:\"parent\";s:4:\"name\";s:4:\"node\";}s:13:\"taxonomy_term\";a:9:{s:5:\"title\";s:13:\"Taxonomy term\";s:7:\"handler\";s:44:\"views_plugin_argument_validate_taxonomy_term\";s:4:\"path\";s:40:\"sites/all/modules/views/modules/taxonomy\";s:6:\"module\";s:5:\"views\";s:10:\"theme path\";s:29:\"sites/all/modules/views/theme\";s:10:\"theme file\";s:9:\"theme.inc\";s:4:\"file\";s:48:\"views_plugin_argument_validate_taxonomy_term.inc\";s:6:\"parent\";s:6:\"parent\";s:4:\"name\";s:13:\"taxonomy_term\";}s:4:\"user\";a:9:{s:5:\"title\";s:4:\"User\";s:7:\"handler\";s:35:\"views_plugin_argument_validate_user\";s:4:\"path\";s:36:\"sites/all/modules/views/modules/user\";s:6:\"module\";s:5:\"views\";s:10:\"theme path\";s:29:\"sites/all/modules/views/theme\";s:10:\"theme file\";s:9:\"theme.inc\";s:4:\"file\";s:39:\"views_plugin_argument_validate_user.inc\";s:6:\"parent\";s:6:\"parent\";s:4:\"name\";s:4:\"user\";}s:3:\"php\";a:9:{s:5:\"title\";s:8:\"PHP Code\";s:7:\"handler\";s:34:\"views_plugin_argument_validate_php\";s:6:\"module\";s:5:\"views\";s:10:\"theme path\";s:29:\"sites/all/modules/views/theme\";s:10:\"theme file\";s:9:\"theme.inc\";s:4:\"path\";s:31:\"sites/all/modules/views/plugins\";s:4:\"file\";s:38:\"views_plugin_argument_validate_php.inc\";s:6:\"parent\";s:6:\"parent\";s:4:\"name\";s:3:\"php\";}s:7:\"numeric\";a:9:{s:5:\"title\";s:7:\"Numeric\";s:7:\"handler\";s:38:\"views_plugin_argument_validate_numeric\";s:6:\"module\";s:5:\"views\";s:10:\"theme path\";s:29:\"sites/all/modules/views/theme\";s:10:\"theme file\";s:9:\"theme.inc\";s:4:\"path\";s:31:\"sites/all/modules/views/plugins\";s:4:\"file\";s:42:\"views_plugin_argument_validate_numeric.inc\";s:6:\"parent\";s:6:\"parent\";s:4:\"name\";s:7:\"numeric\";}}s:6:\"access\";a:3:{s:4:\"none\";a:11:{s:5:\"title\";s:4:\"None\";s:4:\"help\";s:31:\"Will be available to all users.\";s:7:\"handler\";s:24:\"views_plugin_access_none\";s:10:\"help topic\";s:11:\"access-none\";s:6:\"module\";s:5:\"views\";s:10:\"theme path\";s:29:\"sites/all/modules/views/theme\";s:10:\"theme file\";s:9:\"theme.inc\";s:4:\"path\";s:31:\"sites/all/modules/views/plugins\";s:4:\"file\";s:28:\"views_plugin_access_none.inc\";s:6:\"parent\";s:6:\"parent\";s:4:\"name\";s:4:\"none\";}s:4:\"role\";a:12:{s:5:\"title\";s:4:\"Role\";s:4:\"help\";s:64:\"Access will be granted to users with any of the specified roles.\";s:7:\"handler\";s:24:\"views_plugin_access_role\";s:12:\"uses options\";b:1;s:10:\"help topic\";s:11:\"access-role\";s:6:\"module\";s:5:\"views\";s:10:\"theme path\";s:29:\"sites/all/modules/views/theme\";s:10:\"theme file\";s:9:\"theme.inc\";s:4:\"path\";s:31:\"sites/all/modules/views/plugins\";s:4:\"file\";s:28:\"views_plugin_access_role.inc\";s:6:\"parent\";s:6:\"parent\";s:4:\"name\";s:4:\"role\";}s:4:\"perm\";a:12:{s:5:\"title\";s:10:\"Permission\";s:4:\"help\";s:69:\"Access will be granted to users with the specified permission string.\";s:7:\"handler\";s:24:\"views_plugin_access_perm\";s:12:\"uses options\";b:1;s:10:\"help topic\";s:11:\"access-perm\";s:6:\"module\";s:5:\"views\";s:10:\"theme path\";s:29:\"sites/all/modules/views/theme\";s:10:\"theme file\";s:9:\"theme.inc\";s:4:\"path\";s:31:\"sites/all/modules/views/plugins\";s:4:\"file\";s:28:\"views_plugin_access_perm.inc\";s:6:\"parent\";s:6:\"parent\";s:4:\"name\";s:4:\"perm\";}}s:5:\"cache\";a:3:{s:6:\"parent\";a:9:{s:5:\"no ui\";b:1;s:7:\"handler\";s:18:\"views_plugin_cache\";s:6:\"parent\";s:0:\"\";s:6:\"module\";s:5:\"views\";s:10:\"theme path\";s:29:\"sites/all/modules/views/theme\";s:10:\"theme file\";s:9:\"theme.inc\";s:4:\"path\";s:31:\"sites/all/modules/views/plugins\";s:4:\"file\";s:22:\"views_plugin_cache.inc\";s:4:\"name\";s:6:\"parent\";}s:4:\"none\";a:11:{s:5:\"title\";s:4:\"None\";s:4:\"help\";s:25:\"No caching of Views data.\";s:7:\"handler\";s:23:\"views_plugin_cache_none\";s:10:\"help topic\";s:10:\"cache-none\";s:6:\"module\";s:5:\"views\";s:10:\"theme path\";s:29:\"sites/all/modules/views/theme\";s:10:\"theme file\";s:9:\"theme.inc\";s:4:\"path\";s:31:\"sites/all/modules/views/plugins\";s:4:\"file\";s:27:\"views_plugin_cache_none.inc\";s:6:\"parent\";s:6:\"parent\";s:4:\"name\";s:4:\"none\";}s:4:\"time\";a:12:{s:5:\"title\";s:10:\"Time-based\";s:4:\"help\";s:34:\"Simple time-based caching of data.\";s:7:\"handler\";s:23:\"views_plugin_cache_time\";s:12:\"uses options\";b:1;s:10:\"help topic\";s:10:\"cache-time\";s:6:\"module\";s:5:\"views\";s:10:\"theme path\";s:29:\"sites/all/modules/views/theme\";s:10:\"theme file\";s:9:\"theme.inc\";s:4:\"path\";s:31:\"sites/all/modules/views/plugins\";s:4:\"file\";s:27:\"views_plugin_cache_time.inc\";s:6:\"parent\";s:6:\"parent\";s:4:\"name\";s:4:\"time\";}}s:12:\"exposed_form\";a:3:{s:6:\"parent\";a:9:{s:5:\"no ui\";b:1;s:7:\"handler\";s:25:\"views_plugin_exposed_form\";s:6:\"parent\";s:0:\"\";s:6:\"module\";s:5:\"views\";s:10:\"theme path\";s:29:\"sites/all/modules/views/theme\";s:10:\"theme file\";s:9:\"theme.inc\";s:4:\"path\";s:31:\"sites/all/modules/views/plugins\";s:4:\"file\";s:29:\"views_plugin_exposed_form.inc\";s:4:\"name\";s:6:\"parent\";}s:5:\"basic\";a:12:{s:5:\"title\";s:5:\"Basic\";s:4:\"help\";s:18:\"Basic exposed form\";s:7:\"handler\";s:31:\"views_plugin_exposed_form_basic\";s:12:\"uses options\";b:1;s:10:\"help topic\";s:18:\"exposed-form-basic\";s:6:\"module\";s:5:\"views\";s:10:\"theme path\";s:29:\"sites/all/modules/views/theme\";s:10:\"theme file\";s:9:\"theme.inc\";s:4:\"path\";s:31:\"sites/all/modules/views/plugins\";s:4:\"file\";s:35:\"views_plugin_exposed_form_basic.inc\";s:6:\"parent\";s:6:\"parent\";s:4:\"name\";s:5:\"basic\";}s:14:\"input_required\";a:12:{s:5:\"title\";s:14:\"Input required\";s:4:\"help\";s:73:\"An exposed form that only renders a view if the form contains user input.\";s:7:\"handler\";s:40:\"views_plugin_exposed_form_input_required\";s:12:\"uses options\";b:1;s:10:\"help topic\";s:27:\"exposed-form-input-required\";s:6:\"module\";s:5:\"views\";s:10:\"theme path\";s:29:\"sites/all/modules/views/theme\";s:10:\"theme file\";s:9:\"theme.inc\";s:4:\"path\";s:31:\"sites/all/modules/views/plugins\";s:4:\"file\";s:44:\"views_plugin_exposed_form_input_required.inc\";s:6:\"parent\";s:6:\"parent\";s:4:\"name\";s:14:\"input_required\";}}s:5:\"pager\";a:6:{s:16:\"date_views_pager\";a:12:{s:5:\"title\";s:12:\"Page by date\";s:4:\"help\";s:37:\"Page using the value of a date field.\";s:7:\"handler\";s:23:\"date_views_plugin_pager\";s:4:\"path\";s:42:\"sites/all/modules/date/date_views/includes\";s:10:\"help topic\";s:16:\"date-views-pager\";s:12:\"uses options\";b:1;s:6:\"module\";s:10:\"date_views\";s:10:\"theme path\";s:33:\"sites/all/modules/date/date_views\";s:10:\"theme file\";s:20:\"date_views.views.inc\";s:4:\"file\";s:27:\"date_views_plugin_pager.inc\";s:6:\"parent\";s:6:\"parent\";s:4:\"name\";s:16:\"date_views_pager\";}s:6:\"parent\";a:9:{s:5:\"no ui\";b:1;s:7:\"handler\";s:18:\"views_plugin_pager\";s:6:\"parent\";s:0:\"\";s:6:\"module\";s:5:\"views\";s:10:\"theme path\";s:29:\"sites/all/modules/views/theme\";s:10:\"theme file\";s:9:\"theme.inc\";s:4:\"path\";s:31:\"sites/all/modules/views/plugins\";s:4:\"file\";s:22:\"views_plugin_pager.inc\";s:4:\"name\";s:6:\"parent\";}s:4:\"none\";a:13:{s:5:\"title\";s:17:\"Display all items\";s:4:\"help\";s:43:\"Display all items that this view might find\";s:7:\"handler\";s:23:\"views_plugin_pager_none\";s:10:\"help topic\";s:10:\"pager-none\";s:12:\"uses options\";b:1;s:4:\"type\";s:5:\"basic\";s:6:\"module\";s:5:\"views\";s:10:\"theme path\";s:29:\"sites/all/modules/views/theme\";s:10:\"theme file\";s:9:\"theme.inc\";s:4:\"path\";s:31:\"sites/all/modules/views/plugins\";s:4:\"file\";s:27:\"views_plugin_pager_none.inc\";s:6:\"parent\";s:6:\"parent\";s:4:\"name\";s:4:\"none\";}s:4:\"some\";a:13:{s:5:\"title\";s:35:\"Display a specified number of items\";s:4:\"help\";s:57:\"Display a limited number items that this view might find.\";s:7:\"handler\";s:23:\"views_plugin_pager_some\";s:10:\"help topic\";s:10:\"pager-some\";s:12:\"uses options\";b:1;s:4:\"type\";s:5:\"basic\";s:6:\"module\";s:5:\"views\";s:10:\"theme path\";s:29:\"sites/all/modules/views/theme\";s:10:\"theme file\";s:9:\"theme.inc\";s:4:\"path\";s:31:\"sites/all/modules/views/plugins\";s:4:\"file\";s:27:\"views_plugin_pager_some.inc\";s:6:\"parent\";s:6:\"parent\";s:4:\"name\";s:4:\"some\";}s:4:\"full\";a:13:{s:5:\"title\";s:24:\"Paged output, full pager\";s:11:\"short title\";s:4:\"Full\";s:4:\"help\";s:31:\"Paged output, full Drupal style\";s:7:\"handler\";s:23:\"views_plugin_pager_full\";s:10:\"help topic\";s:10:\"pager-full\";s:12:\"uses options\";b:1;s:6:\"module\";s:5:\"views\";s:10:\"theme path\";s:29:\"sites/all/modules/views/theme\";s:10:\"theme file\";s:9:\"theme.inc\";s:4:\"path\";s:31:\"sites/all/modules/views/plugins\";s:4:\"file\";s:27:\"views_plugin_pager_full.inc\";s:6:\"parent\";s:6:\"parent\";s:4:\"name\";s:4:\"full\";}s:4:\"mini\";a:13:{s:5:\"title\";s:24:\"Paged output, mini pager\";s:11:\"short title\";s:4:\"Mini\";s:4:\"help\";s:26:\"Use the mini pager output.\";s:7:\"handler\";s:23:\"views_plugin_pager_mini\";s:10:\"help topic\";s:10:\"pager-mini\";s:12:\"uses options\";b:1;s:6:\"parent\";s:4:\"full\";s:6:\"module\";s:5:\"views\";s:10:\"theme path\";s:29:\"sites/all/modules/views/theme\";s:10:\"theme file\";s:9:\"theme.inc\";s:4:\"path\";s:31:\"sites/all/modules/views/plugins\";s:4:\"file\";s:27:\"views_plugin_pager_mini.inc\";s:4:\"name\";s:4:\"mini\";}}s:16:\"display_extender\";a:2:{s:15:\"views_fieldsets\";a:12:{s:5:\"title\";s:23:\"Views fieldsets options\";s:4:\"help\";s:32:\"A way to export Views Fieldsets.\";s:7:\"handler\";s:32:\"views_fieldsets_display_extender\";s:7:\"enabled\";b:1;s:5:\"no ui\";b:1;s:6:\"module\";s:15:\"views_fieldsets\";s:10:\"theme path\";s:33:\"sites/all/modules/views_fieldsets\";s:10:\"theme file\";s:25:\"views_fieldsets.views.inc\";s:4:\"path\";s:33:\"sites/all/modules/views_fieldsets\";s:4:\"file\";s:36:\"views_fieldsets_display_extender.inc\";s:6:\"parent\";s:6:\"parent\";s:4:\"name\";s:15:\"views_fieldsets\";}s:7:\"default\";a:12:{s:5:\"title\";s:22:\"Empty display extender\";s:4:\"help\";s:31:\"Default settings for this view.\";s:7:\"handler\";s:29:\"views_plugin_display_extender\";s:7:\"enabled\";b:0;s:5:\"no ui\";b:1;s:6:\"module\";s:5:\"views\";s:10:\"theme path\";s:29:\"sites/all/modules/views/theme\";s:10:\"theme file\";s:9:\"theme.inc\";s:4:\"path\";s:31:\"sites/all/modules/views/plugins\";s:4:\"file\";s:33:\"views_plugin_display_extender.inc\";s:6:\"parent\";s:6:\"parent\";s:4:\"name\";s:7:\"default\";}}s:5:\"query\";a:2:{s:6:\"parent\";a:9:{s:5:\"no ui\";b:1;s:7:\"handler\";s:18:\"views_plugin_query\";s:6:\"parent\";s:0:\"\";s:6:\"module\";s:5:\"views\";s:10:\"theme path\";s:29:\"sites/all/modules/views/theme\";s:10:\"theme file\";s:9:\"theme.inc\";s:4:\"path\";s:31:\"sites/all/modules/views/plugins\";s:4:\"file\";s:22:\"views_plugin_query.inc\";s:4:\"name\";s:6:\"parent\";}s:11:\"views_query\";a:10:{s:5:\"title\";s:9:\"SQL Query\";s:4:\"help\";s:62:\"Query will be generated and run using the Drupal database API.\";s:7:\"handler\";s:26:\"views_plugin_query_default\";s:6:\"module\";s:5:\"views\";s:10:\"theme path\";s:29:\"sites/all/modules/views/theme\";s:10:\"theme file\";s:9:\"theme.inc\";s:4:\"path\";s:31:\"sites/all/modules/views/plugins\";s:4:\"file\";s:30:\"views_plugin_query_default.inc\";s:6:\"parent\";s:6:\"parent\";s:4:\"name\";s:11:\"views_query\";}}s:12:\"localization\";a:3:{s:6:\"parent\";a:9:{s:5:\"no ui\";b:1;s:7:\"handler\";s:25:\"views_plugin_localization\";s:6:\"parent\";s:0:\"\";s:6:\"module\";s:5:\"views\";s:10:\"theme path\";s:29:\"sites/all/modules/views/theme\";s:10:\"theme file\";s:9:\"theme.inc\";s:4:\"path\";s:31:\"sites/all/modules/views/plugins\";s:4:\"file\";s:29:\"views_plugin_localization.inc\";s:4:\"name\";s:6:\"parent\";}s:4:\"none\";a:11:{s:5:\"title\";s:4:\"None\";s:4:\"help\";s:42:\"Do not pass admin strings for translation.\";s:7:\"handler\";s:30:\"views_plugin_localization_none\";s:10:\"help topic\";s:17:\"localization-none\";s:6:\"module\";s:5:\"views\";s:10:\"theme path\";s:29:\"sites/all/modules/views/theme\";s:10:\"theme file\";s:9:\"theme.inc\";s:4:\"path\";s:31:\"sites/all/modules/views/plugins\";s:4:\"file\";s:34:\"views_plugin_localization_none.inc\";s:6:\"parent\";s:6:\"parent\";s:4:\"name\";s:4:\"none\";}s:4:\"core\";a:11:{s:5:\"title\";s:4:\"Core\";s:4:\"help\";s:283:\"Use Drupal core t() function. Not recommended, as it doesn\'t support updates to existing strings. If you need to translate Views labels into other languages, consider installing the <a href=\"http://drupal.org/project/i18n\">Internationalization</a> package\'s Views translation module.\";s:7:\"handler\";s:30:\"views_plugin_localization_core\";s:10:\"help topic\";s:17:\"localization-core\";s:6:\"module\";s:5:\"views\";s:10:\"theme path\";s:29:\"sites/all/modules/views/theme\";s:10:\"theme file\";s:9:\"theme.inc\";s:4:\"path\";s:31:\"sites/all/modules/views/plugins\";s:4:\"file\";s:34:\"views_plugin_localization_core.inc\";s:6:\"parent\";s:6:\"parent\";s:4:\"name\";s:4:\"core\";}}}',0,1512620340,1);
/*!40000 ALTER TABLE `cache` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `cache_admin_menu`
--

DROP TABLE IF EXISTS `cache_admin_menu`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `cache_admin_menu` (
  `cid` varchar(255) NOT NULL DEFAULT '' COMMENT 'Primary Key: Unique cache ID.',
  `data` longblob COMMENT 'A collection of data to cache.',
  `expire` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry should expire, or 0 for never.',
  `created` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry was created.',
  `serialized` smallint(6) NOT NULL DEFAULT '0' COMMENT 'A flag to indicate whether content is serialized (1) or not (0).',
  PRIMARY KEY (`cid`),
  KEY `expire` (`expire`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Cache table for Administration menu to store client-side...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `cache_admin_menu`
--

LOCK TABLES `cache_admin_menu` WRITE;
/*!40000 ALTER TABLE `cache_admin_menu` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `cache_admin_menu` VALUES ('admin_menu:1:3QV5Ae0ANwuTwt8MXjAOg_CobIrc5KhTkGsHK1_UoJc:en','eb993f39b4766b02f03cc8ac1ad42aae',0,1512620348,0);
/*!40000 ALTER TABLE `cache_admin_menu` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `cache_block`
--

DROP TABLE IF EXISTS `cache_block`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `cache_block` (
  `cid` varchar(255) NOT NULL DEFAULT '' COMMENT 'Primary Key: Unique cache ID.',
  `data` longblob COMMENT 'A collection of data to cache.',
  `expire` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry should expire, or 0 for never.',
  `created` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry was created.',
  `serialized` smallint(6) NOT NULL DEFAULT '0' COMMENT 'A flag to indicate whether content is serialized (1) or not (0).',
  PRIMARY KEY (`cid`),
  KEY `expire` (`expire`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Cache table for the Block module to store already built...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `cache_block`
--

LOCK TABLES `cache_block` WRITE;
/*!40000 ALTER TABLE `cache_block` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `cache_block` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `cache_bootstrap`
--

DROP TABLE IF EXISTS `cache_bootstrap`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `cache_bootstrap` (
  `cid` varchar(255) NOT NULL DEFAULT '' COMMENT 'Primary Key: Unique cache ID.',
  `data` longblob COMMENT 'A collection of data to cache.',
  `expire` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry should expire, or 0 for never.',
  `created` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry was created.',
  `serialized` smallint(6) NOT NULL DEFAULT '0' COMMENT 'A flag to indicate whether content is serialized (1) or not (0).',
  PRIMARY KEY (`cid`),
  KEY `expire` (`expire`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Cache table for data required to bootstrap Drupal, may be...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `cache_bootstrap`
--

LOCK TABLES `cache_bootstrap` WRITE;
/*!40000 ALTER TABLE `cache_bootstrap` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `cache_bootstrap` VALUES ('bootstrap_modules','a:6:{s:5:\"dblog\";O:8:\"stdClass\":2:{s:4:\"name\";s:5:\"dblog\";s:8:\"filename\";s:26:\"modules/dblog/dblog.module\";}s:7:\"overlay\";O:8:\"stdClass\":2:{s:4:\"name\";s:7:\"overlay\";s:8:\"filename\";s:30:\"modules/overlay/overlay.module\";}s:10:\"statistics\";O:8:\"stdClass\":2:{s:4:\"name\";s:10:\"statistics\";s:8:\"filename\";s:36:\"modules/statistics/statistics.module\";}s:6:\"system\";O:8:\"stdClass\":2:{s:4:\"name\";s:6:\"system\";s:8:\"filename\";s:28:\"modules/system/system.module\";}s:8:\"variable\";O:8:\"stdClass\":2:{s:4:\"name\";s:8:\"variable\";s:8:\"filename\";s:42:\"sites/all/modules/variable/variable.module\";}s:4:\"i18n\";O:8:\"stdClass\":2:{s:4:\"name\";s:4:\"i18n\";s:8:\"filename\";s:34:\"sites/all/modules/i18n/i18n.module\";}}',0,1512620340,1),('hook_info','a:22:{s:20:\"entity_property_info\";a:1:{s:5:\"group\";s:4:\"info\";}s:26:\"entity_property_info_alter\";a:1:{s:5:\"group\";s:4:\"info\";}s:25:\"i18n_translation_set_info\";a:1:{s:5:\"group\";s:4:\"i18n\";}s:10:\"token_info\";a:1:{s:5:\"group\";s:6:\"tokens\";}s:16:\"token_info_alter\";a:1:{s:5:\"group\";s:6:\"tokens\";}s:6:\"tokens\";a:1:{s:5:\"group\";s:6:\"tokens\";}s:12:\"tokens_alter\";a:1:{s:5:\"group\";s:6:\"tokens\";}s:13:\"variable_info\";a:1:{s:5:\"group\";s:8:\"variable\";}s:19:\"variable_group_info\";a:1:{s:5:\"group\";s:8:\"variable\";}s:18:\"variable_type_info\";a:1:{s:5:\"group\";s:8:\"variable\";}s:28:\"variable_settings_form_alter\";a:1:{s:5:\"group\";s:8:\"variable\";}s:8:\"pathauto\";a:1:{s:5:\"group\";s:8:\"pathauto\";}s:16:\"path_alias_types\";a:1:{s:5:\"group\";s:8:\"pathauto\";}s:16:\"i18n_object_info\";a:1:{s:5:\"group\";s:4:\"i18n\";}s:19:\"i18n_string_objects\";a:1:{s:5:\"group\";s:4:\"i18n\";}s:19:\"i18n_string_refresh\";a:1:{s:5:\"group\";s:4:\"i18n\";}s:16:\"i18n_string_list\";a:1:{s:5:\"group\";s:4:\"i18n\";}s:16:\"i18n_string_info\";a:1:{s:5:\"group\";s:4:\"i18n\";}s:12:\"features_api\";a:1:{s:5:\"group\";s:8:\"features\";}s:19:\"features_pipe_alter\";a:1:{s:5:\"group\";s:8:\"features\";}s:21:\"features_export_alter\";a:1:{s:5:\"group\";s:8:\"features\";}s:29:\"features_export_options_alter\";a:1:{s:5:\"group\";s:8:\"features\";}}',0,1512620340,1),('lookup_cache','a:48:{s:30:\"cDrupalDefaultEntityController\";s:19:\"includes/entity.inc\";s:7:\"cEntity\";s:44:\"sites/all/modules/entity/includes/entity.inc\";s:20:\"cEntityAPIController\";s:55:\"sites/all/modules/entity/includes/entity.controller.inc\";s:33:\"cviews_handler_field_machine_name\";s:69:\"sites/all/modules/views/handlers/views_handler_field_machine_name.inc\";s:20:\"cviews_handler_field\";s:56:\"sites/all/modules/views/handlers/views_handler_field.inc\";s:25:\"cEntityFieldHandlerHelper\";s:77:\"sites/all/modules/entity/views/handlers/entity_views_field_handler_helper.inc\";s:5:\"cview\";s:41:\"sites/all/modules/views/includes/view.inc\";s:29:\"cviews_plugin_display_default\";s:64:\"sites/all/modules/views/plugins/views_plugin_display_default.inc\";s:21:\"cviews_plugin_display\";s:56:\"sites/all/modules/views/plugins/views_plugin_display.inc\";s:31:\"cviews_plugin_localization_core\";s:66:\"sites/all/modules/views/plugins/views_plugin_localization_core.inc\";s:26:\"cviews_plugin_localization\";s:61:\"sites/all/modules/views/plugins/views_plugin_localization.inc\";s:26:\"cviews_plugin_display_page\";s:61:\"sites/all/modules/views/plugins/views_plugin_display_page.inc\";s:27:\"cviews_plugin_display_block\";s:62:\"sites/all/modules/views/plugins/views_plugin_display_block.inc\";s:32:\"cviews_plugin_display_attachment\";s:67:\"sites/all/modules/views/plugins/views_plugin_display_attachment.inc\";s:26:\"cviews_plugin_display_feed\";s:61:\"sites/all/modules/views/plugins/views_plugin_display_feed.inc\";s:25:\"cviews_plugin_access_perm\";s:60:\"sites/all/modules/views/plugins/views_plugin_access_perm.inc\";s:20:\"cviews_plugin_access\";s:55:\"sites/all/modules/views/plugins/views_plugin_access.inc\";s:33:\"cviews_handler_field_user_picture\";s:73:\"sites/all/modules/views/modules/user/views_handler_field_user_picture.inc\";s:25:\"cviews_handler_field_node\";s:65:\"sites/all/modules/views/modules/node/views_handler_field_node.inc\";s:30:\"cviews_handler_field_user_name\";s:70:\"sites/all/modules/views/modules/user/views_handler_field_user_name.inc\";s:25:\"cviews_handler_field_user\";s:65:\"sites/all/modules/views/modules/user/views_handler_field_user.inc\";s:25:\"cviews_handler_field_date\";s:61:\"sites/all/modules/views/handlers/views_handler_field_date.inc\";s:24:\"cviews_handler_sort_date\";s:60:\"sites/all/modules/views/handlers/views_handler_sort_date.inc\";s:19:\"cviews_handler_sort\";s:55:\"sites/all/modules/views/handlers/views_handler_sort.inc\";s:38:\"cviews_handler_filter_boolean_operator\";s:74:\"sites/all/modules/views/handlers/views_handler_filter_boolean_operator.inc\";s:21:\"cviews_handler_filter\";s:57:\"sites/all/modules/views/handlers/views_handler_filter.inc\";s:31:\"cviews_handler_filter_node_type\";s:71:\"sites/all/modules/views/modules/node/views_handler_filter_node_type.inc\";s:33:\"cviews_handler_filter_in_operator\";s:69:\"sites/all/modules/views/handlers/views_handler_filter_in_operator.inc\";s:27:\"cviews_handler_relationship\";s:63:\"sites/all/modules/views/handlers/views_handler_relationship.inc\";s:27:\"cviews_plugin_query_default\";s:62:\"sites/all/modules/views/plugins/views_plugin_query_default.inc\";s:19:\"cviews_plugin_query\";s:54:\"sites/all/modules/views/plugins/views_plugin_query.inc\";s:27:\"cviews_plugin_style_default\";s:62:\"sites/all/modules/views/plugins/views_plugin_style_default.inc\";s:19:\"cviews_plugin_style\";s:54:\"sites/all/modules/views/plugins/views_plugin_style.inc\";s:24:\"cviews_plugin_row_fields\";s:59:\"sites/all/modules/views/plugins/views_plugin_row_fields.inc\";s:17:\"cviews_plugin_row\";s:52:\"sites/all/modules/views/plugins/views_plugin_row.inc\";s:24:\"cviews_plugin_pager_some\";s:59:\"sites/all/modules/views/plugins/views_plugin_pager_some.inc\";s:19:\"cviews_plugin_pager\";s:54:\"sites/all/modules/views/plugins/views_plugin_pager.inc\";s:24:\"cviews_plugin_cache_none\";s:59:\"sites/all/modules/views/plugins/views_plugin_cache_none.inc\";s:19:\"cviews_plugin_cache\";s:54:\"sites/all/modules/views/plugins/views_plugin_cache.inc\";s:32:\"cviews_plugin_exposed_form_basic\";s:67:\"sites/all/modules/views/plugins/views_plugin_exposed_form_basic.inc\";s:26:\"cviews_plugin_exposed_form\";s:61:\"sites/all/modules/views/plugins/views_plugin_exposed_form.inc\";s:20:\"cSelectQueryExtender\";s:28:\"includes/database/select.inc\";s:13:\"cviews_plugin\";s:44:\"sites/all/modules/views/includes/plugins.inc\";s:17:\"cctools_export_ui\";s:69:\"sites/all/modules/ctools/plugins/export_ui/ctools_export_ui.class.php\";s:9:\"cviews_ui\";s:60:\"sites/all/modules/views/plugins/export_ui/views_ui.class.php\";s:27:\"ci18n_string_object_wrapper\";s:50:\"sites/all/modules/i18n/i18n_string/i18n_string.inc\";s:20:\"ci18n_object_wrapper\";s:38:\"sites/all/modules/i18n/i18n_object.inc\";s:12:\"cMessageType\";s:59:\"sites/all/modules/message/includes/message.message_type.inc\";}',0,1512620348,1),('module_implements','a:168:{s:15:\"stream_wrappers\";a:1:{s:6:\"system\";b:0;}s:23:\"module_implements_alter\";a:5:{s:6:\"entity\";b:0;s:5:\"token\";b:0;s:8:\"variable\";b:0;s:8:\"pathauto\";b:0;s:14:\"advanced_forum\";b:0;}s:21:\"stream_wrappers_alter\";a:0:{}s:17:\"url_inbound_alter\";a:0:{}s:12:\"custom_theme\";a:2:{s:6:\"system\";b:0;s:8:\"views_ui\";b:0;}s:19:\"menu_get_item_alter\";a:0:{}s:18:\"url_outbound_alter\";a:1:{s:6:\"locale\";b:0;}s:13:\"library_alter\";a:4:{s:10:\"flexslider\";b:0;s:13:\"jquery_update\";b:0;s:6:\"locale\";b:0;s:8:\"views_ui\";b:0;}s:4:\"init\";a:11:{s:11:\"remember_me\";b:0;s:6:\"ctools\";b:0;s:5:\"dblog\";b:0;s:15:\"entityreference\";b:0;s:6:\"locale\";b:0;s:15:\"menu_breadcrumb\";b:0;s:11:\"modal_forms\";b:0;s:7:\"overlay\";b:0;s:6:\"system\";b:0;s:9:\"tagclouds\";b:0;s:6:\"update\";b:0;}s:17:\"date_format_types\";a:1:{s:6:\"system\";b:0;}s:23:\"date_format_types_alter\";a:0:{}s:25:\"menu_breadcrumb_menu_list\";a:0:{}s:11:\"query_alter\";a:0:{}s:32:\"query_preferred_menu_links_alter\";a:0:{}s:24:\"query_translatable_alter\";a:0:{}s:26:\"translated_menu_link_alter\";a:3:{s:13:\"taxonomy_menu\";b:0;s:4:\"user\";b:0;s:10:\"admin_menu\";b:0;}s:21:\"menu_breadcrumb_alter\";a:1:{s:15:\"menu_breadcrumb\";b:0;}s:5:\"theme\";a:61:{s:9:\"strongarm\";b:0;s:11:\"remember_me\";b:0;s:5:\"block\";b:0;s:7:\"webform\";b:0;s:11:\"author_pane\";b:0;s:4:\"book\";b:0;s:8:\"calendar\";b:0;s:5:\"color\";b:0;s:7:\"comment\";b:0;s:6:\"ctools\";b:0;s:9:\"dashboard\";b:0;s:8:\"date_api\";b:0;s:10:\"date_views\";b:0;s:5:\"dblog\";b:0;s:6:\"entity\";b:0;s:3:\"faq\";b:0;s:5:\"field\";b:0;s:16:\"field_collection\";b:0;s:8:\"field_ui\";b:0;s:4:\"file\";b:0;s:6:\"filter\";b:0;s:8:\"fivestar\";b:0;s:10:\"flexslider\";b:0;s:5:\"image\";b:0;s:13:\"languageicons\";b:0;s:21:\"lang_dropdown_hideout\";b:0;s:4:\"link\";b:0;s:6:\"locale\";b:0;s:4:\"menu\";b:0;s:15:\"menu_breadcrumb\";b:0;s:7:\"message\";b:0;s:13:\"module_filter\";b:0;s:4:\"node\";b:0;s:7:\"options\";b:0;s:7:\"overlay\";b:0;s:9:\"quicktabs\";b:0;s:6:\"search\";b:0;s:9:\"sharethis\";b:0;s:20:\"shortcode_basic_tags\";b:0;s:15:\"shortcode_video\";b:0;s:8:\"shortcut\";b:0;s:6:\"system\";b:0;s:9:\"tagclouds\";b:0;s:8:\"taxonomy\";b:0;s:5:\"token\";b:0;s:6:\"update\";b:0;s:4:\"user\";b:0;s:8:\"variable\";b:0;s:17:\"video_embed_field\";b:0;s:15:\"views_fieldsets\";b:0;s:15:\"views_slideshow\";b:0;s:21:\"views_slideshow_cycle\";b:0;s:8:\"views_ui\";b:0;s:13:\"wee_shortcode\";b:0;s:20:\"we_content_migration\";b:0;s:11:\"field_group\";b:0;s:5:\"forum\";b:0;s:5:\"views\";b:0;s:14:\"advanced_forum\";b:0;s:8:\"features\";b:0;s:10:\"admin_menu\";b:0;}s:22:\"webform_component_info\";a:1:{s:7:\"webform\";b:0;}s:28:\"webform_component_info_alter\";a:0:{}s:18:\"ctools_plugin_type\";a:5:{s:6:\"ctools\";b:0;s:15:\"entityreference\";b:0;s:9:\"quicktabs\";b:0;s:8:\"views_ui\";b:0;s:14:\"advanced_forum\";b:0;}s:23:\"ctools_plugin_directory\";a:11:{s:11:\"author_pane\";b:0;s:6:\"ctools\";b:0;s:6:\"entity\";b:0;s:15:\"entityreference\";b:0;s:16:\"field_collection\";b:0;s:10:\"flexslider\";b:0;s:7:\"message\";b:0;s:9:\"sharethis\";b:0;s:17:\"video_embed_field\";b:0;s:8:\"views_ui\";b:0;s:14:\"advanced_forum\";b:0;}s:23:\"ctools_plugin_pre_alter\";a:0:{}s:24:\"ctools_plugin_post_alter\";a:0:{}s:11:\"entity_info\";a:8:{s:7:\"comment\";b:0;s:16:\"field_collection\";b:0;s:16:\"i18n_translation\";b:0;s:7:\"message\";b:0;s:4:\"node\";b:0;s:6:\"system\";b:0;s:8:\"taxonomy\";b:0;s:4:\"user\";b:0;}s:9:\"node_info\";a:3:{s:4:\"blog\";b:0;s:3:\"faq\";b:0;s:5:\"forum\";b:0;}s:28:\"query_node_type_access_alter\";a:0:{}s:16:\"field_read_field\";a:0:{}s:25:\"i18n_translation_set_info\";a:1:{s:13:\"i18n_taxonomy\";s:4:\"i18n\";}s:31:\"i18n_translation_set_info_alter\";a:0:{}s:6:\"schema\";a:44:{s:5:\"block\";b:0;s:7:\"webform\";b:0;s:4:\"book\";b:0;s:8:\"ckeditor\";b:0;s:7:\"comment\";b:0;s:7:\"contact\";b:0;s:6:\"ctools\";b:0;s:5:\"dblog\";b:0;s:3:\"faq\";b:0;s:5:\"field\";b:0;s:16:\"field_collection\";b:0;s:17:\"field_sql_storage\";b:0;s:6:\"filter\";b:0;s:10:\"flexslider\";b:0;s:16:\"i18n_translation\";b:0;s:5:\"image\";b:0;s:9:\"libraries\";b:0;s:6:\"locale\";b:0;s:4:\"menu\";b:0;s:7:\"message\";b:0;s:4:\"node\";b:0;s:10:\"node_class\";b:0;s:9:\"quicktabs\";b:0;s:6:\"search\";b:0;s:8:\"shortcut\";b:0;s:10:\"statistics\";b:0;s:6:\"system\";b:0;s:8:\"taxonomy\";b:0;s:13:\"taxonomy_menu\";b:0;s:5:\"token\";b:0;s:12:\"token_custom\";b:0;s:6:\"update\";b:0;s:4:\"user\";b:0;s:8:\"variable\";b:0;s:17:\"video_embed_field\";b:0;s:9:\"votingapi\";b:0;s:20:\"we_content_migration\";b:0;s:11:\"field_group\";b:0;s:5:\"forum\";b:0;s:11:\"i18n_string\";b:0;s:5:\"views\";b:0;s:8:\"features\";b:0;s:10:\"admin_menu\";b:0;s:10:\"i18n_block\";b:0;}s:12:\"schema_alter\";a:5:{s:9:\"strongarm\";b:0;s:11:\"block_class\";b:0;s:13:\"i18n_taxonomy\";b:0;s:11:\"i18n_string\";b:0;s:10:\"i18n_block\";b:0;}s:17:\"entity_info_alter\";a:6:{s:4:\"book\";b:0;s:6:\"locale\";b:0;s:5:\"token\";b:0;s:5:\"forum\";b:0;s:13:\"i18n_taxonomy\";b:0;s:6:\"entity\";b:0;}s:9:\"views_api\";a:34:{s:7:\"webform\";b:0;s:4:\"book\";b:0;s:8:\"calendar\";b:0;s:7:\"comment\";b:0;s:7:\"contact\";b:0;s:10:\"date_views\";b:0;s:6:\"entity\";b:0;s:15:\"entityreference\";b:0;s:3:\"faq\";b:0;s:5:\"field\";b:0;s:16:\"field_collection\";b:0;s:4:\"file\";b:0;s:6:\"filter\";b:0;s:16:\"flexslider_views\";b:0;s:5:\"image\";b:0;s:4:\"link\";b:0;s:6:\"locale\";b:0;s:7:\"message\";b:0;s:15:\"message_example\";b:0;s:4:\"node\";b:0;s:9:\"quicktabs\";b:0;s:6:\"search\";b:0;s:9:\"sharethis\";b:0;s:10:\"statistics\";b:0;s:6:\"system\";b:0;s:8:\"taxonomy\";b:0;s:4:\"user\";b:0;s:17:\"video_embed_field\";b:0;s:15:\"views_fieldsets\";b:0;s:15:\"views_slideshow\";b:0;s:9:\"votingapi\";b:0;s:13:\"i18n_taxonomy\";b:0;s:5:\"views\";b:0;s:14:\"advanced_forum\";b:0;}s:15:\"views_api_alter\";a:0:{}s:13:\"views_plugins\";a:17:{s:7:\"webform\";b:0;s:4:\"book\";b:0;s:8:\"calendar\";b:0;s:7:\"comment\";b:0;s:10:\"date_views\";b:0;s:6:\"entity\";b:0;s:15:\"entityreference\";b:0;s:16:\"flexslider_views\";b:0;s:4:\"node\";b:0;s:9:\"quicktabs\";b:0;s:6:\"search\";b:0;s:8:\"taxonomy\";b:0;s:4:\"user\";b:0;s:15:\"views_fieldsets\";b:0;s:15:\"views_slideshow\";b:0;s:5:\"views\";b:0;s:14:\"advanced_forum\";b:0;}s:23:\"date_views_extra_tables\";a:2:{s:7:\"webform\";b:0;s:10:\"date_views\";b:0;}s:10:\"views_data\";a:20:{s:7:\"webform\";b:0;s:4:\"book\";b:0;s:7:\"comment\";b:0;s:10:\"date_views\";b:0;s:6:\"entity\";b:0;s:3:\"faq\";b:0;s:5:\"field\";b:0;s:6:\"filter\";b:0;s:6:\"locale\";b:0;s:4:\"node\";b:0;s:6:\"search\";b:0;s:9:\"sharethis\";b:0;s:10:\"statistics\";b:0;s:6:\"system\";b:0;s:8:\"taxonomy\";b:0;s:4:\"user\";b:0;s:15:\"views_fieldsets\";b:0;s:9:\"votingapi\";b:0;s:5:\"views\";b:0;s:14:\"advanced_forum\";b:0;}s:20:\"entity_property_info\";a:1:{s:6:\"entity\";s:4:\"info\";}s:10:\"field_info\";a:11:{s:15:\"entityreference\";b:0;s:16:\"field_collection\";b:0;s:4:\"file\";b:0;s:8:\"fivestar\";b:0;s:5:\"image\";b:0;s:4:\"link\";b:0;s:4:\"list\";b:0;s:6:\"number\";b:0;s:8:\"taxonomy\";b:0;s:4:\"text\";b:0;s:17:\"video_embed_field\";b:0;}s:24:\"video_embed_handler_info\";a:1:{s:17:\"video_embed_field\";b:0;}s:30:\"video_embed_handler_info_alter\";a:0:{}s:16:\"field_info_alter\";a:4:{s:6:\"entity\";b:0;s:5:\"token\";b:0;s:4:\"user\";b:0;s:13:\"i18n_taxonomy\";b:0;}s:17:\"field_widget_info\";a:11:{s:15:\"entityreference\";b:0;s:16:\"field_collection\";b:0;s:4:\"file\";b:0;s:8:\"fivestar\";b:0;s:5:\"image\";b:0;s:4:\"link\";b:0;s:6:\"number\";b:0;s:7:\"options\";b:0;s:8:\"taxonomy\";b:0;s:4:\"text\";b:0;s:17:\"video_embed_field\";b:0;}s:23:\"field_widget_info_alter\";a:4:{s:6:\"chosen\";b:0;s:15:\"entityreference\";b:0;s:4:\"list\";b:0;s:8:\"taxonomy\";b:0;}s:20:\"field_formatter_info\";a:13:{s:15:\"entityreference\";b:0;s:16:\"field_collection\";b:0;s:4:\"file\";b:0;s:8:\"fivestar\";b:0;s:17:\"flexslider_fields\";b:0;s:5:\"image\";b:0;s:4:\"link\";b:0;s:4:\"list\";b:0;s:6:\"number\";b:0;s:8:\"taxonomy\";b:0;s:4:\"text\";b:0;s:17:\"video_embed_field\";b:0;s:13:\"i18n_taxonomy\";b:0;}s:26:\"field_formatter_info_alter\";a:0:{}s:18:\"field_storage_info\";a:1:{s:17:\"field_sql_storage\";b:0;}s:24:\"field_storage_info_alter\";a:0:{}s:27:\"field_storage_details_alter\";a:1:{s:13:\"i18n_taxonomy\";b:0;}s:19:\"field_read_instance\";a:0:{}s:26:\"entity_property_info_alter\";a:1:{s:6:\"entity\";s:4:\"info\";}s:33:\"entity_views_field_handlers_alter\";a:0:{}s:22:\"field_views_data_alter\";a:1:{s:10:\"date_views\";b:0;}s:16:\"views_data_alter\";a:10:{s:7:\"webform\";b:0;s:7:\"comment\";b:0;s:7:\"contact\";b:0;s:10:\"date_views\";b:0;s:5:\"field\";b:0;s:6:\"locale\";b:0;s:9:\"sharethis\";b:0;s:8:\"taxonomy\";b:0;s:9:\"votingapi\";b:0;s:14:\"advanced_forum\";b:0;}s:19:\"views_plugins_alter\";a:1:{s:8:\"views_ui\";b:0;}s:20:\"theme_registry_alter\";a:2:{s:11:\"field_group\";b:0;s:14:\"advanced_forum\";b:0;}s:14:\"file_url_alter\";a:0:{}s:11:\"admin_paths\";a:11:{s:5:\"block\";b:0;s:7:\"webform\";b:0;s:4:\"book\";b:0;s:16:\"field_collection\";b:0;s:4:\"node\";b:0;s:7:\"overlay\";b:0;s:8:\"shortcut\";b:0;s:6:\"system\";b:0;s:8:\"taxonomy\";b:0;s:4:\"user\";b:0;s:13:\"i18n_taxonomy\";b:0;}s:17:\"admin_paths_alter\";a:0:{}s:22:\"menu_site_status_alter\";a:1:{s:4:\"user\";b:0;}s:12:\"element_info\";a:13:{s:7:\"webform\";b:0;s:10:\"contextual\";b:0;s:8:\"date_api\";b:0;s:8:\"field_ui\";b:0;s:4:\"file\";b:0;s:6:\"filter\";b:0;s:8:\"fivestar\";b:0;s:4:\"link\";b:0;s:13:\"module_filter\";b:0;s:6:\"system\";b:0;s:4:\"user\";b:0;s:8:\"variable\";b:0;s:11:\"field_group\";b:0;}s:18:\"element_info_alter\";a:3:{s:6:\"chosen\";b:0;s:8:\"ckeditor\";b:0;s:6:\"ctools\";b:0;}s:10:\"form_alter\";a:14:{s:11:\"remember_me\";b:0;s:7:\"webform\";b:0;s:11:\"block_class\";b:0;s:6:\"locale\";b:0;s:11:\"modal_forms\";b:0;s:10:\"node_class\";b:0;s:7:\"overlay\";b:0;s:13:\"taxonomy_menu\";b:0;s:5:\"token\";b:0;s:13:\"webform_hints\";b:0;s:13:\"i18n_taxonomy\";b:0;s:14:\"advanced_forum\";b:0;s:10:\"admin_menu\";b:0;s:8:\"variable\";b:0;}s:21:\"form_user_login_alter\";a:0:{}s:28:\"page_delivery_callback_alter\";a:1:{s:7:\"overlay\";b:0;}s:10:\"page_build\";a:5:{s:5:\"block\";b:0;s:8:\"ckeditor\";b:0;s:9:\"dashboard\";b:0;s:10:\"admin_menu\";b:0;s:18:\"admin_menu_toolbar\";b:0;}s:22:\"query_block_load_alter\";a:0:{}s:16:\"block_list_alter\";a:6:{s:5:\"block\";b:0;s:6:\"ctools\";b:0;s:9:\"dashboard\";b:0;s:4:\"node\";b:0;s:7:\"overlay\";b:0;s:10:\"i18n_block\";b:0;}s:17:\"dashboard_regions\";a:1:{s:9:\"dashboard\";b:0;}s:23:\"dashboard_regions_alter\";a:0:{}s:11:\"node_grants\";a:0:{}s:11:\"filter_info\";a:5:{s:3:\"faq\";b:0;s:6:\"filter\";b:0;s:3:\"php\";b:0;s:9:\"shortcode\";b:0;s:17:\"video_embed_field\";b:0;}s:17:\"filter_info_alter\";a:0:{}s:14:\"shortcode_info\";a:4:{s:20:\"shortcode_basic_tags\";b:0;s:23:\"shortcode_embed_content\";b:0;s:15:\"shortcode_video\";b:0;s:13:\"wee_shortcode\";b:0;}s:20:\"shortcode_info_alter\";a:0:{}s:16:\"block_view_alter\";a:3:{s:4:\"menu\";b:0;s:5:\"token\";b:0;s:10:\"i18n_block\";b:0;}s:24:\"block_view_block_1_alter\";a:0:{}s:33:\"block_view_system_user_menu_alter\";a:0:{}s:5:\"forms\";a:7:{s:7:\"webform\";b:0;s:7:\"comment\";b:0;s:9:\"dashboard\";b:0;s:6:\"entity\";b:0;s:4:\"node\";b:0;s:6:\"search\";b:0;s:5:\"views\";b:0;}s:21:\"form_search_box_alter\";a:0:{}s:28:\"form_search_block_form_alter\";a:0:{}s:28:\"block_view_search_form_alter\";a:0:{}s:25:\"block_view_block_12_alter\";a:0:{}s:23:\"query_node_access_alter\";a:1:{s:4:\"node\";b:0;}s:11:\"search_info\";a:2:{s:4:\"node\";b:0;s:4:\"user\";b:0;}s:11:\"node_access\";a:2:{s:3:\"faq\";b:0;s:4:\"node\";b:0;}s:33:\"block_view_system_main_menu_alter\";a:0:{}s:22:\"menu_local_tasks_alter\";a:5:{s:4:\"blog\";b:0;s:8:\"calendar\";b:0;s:6:\"ctools\";b:0;s:4:\"node\";b:0;s:14:\"advanced_forum\";b:0;}s:4:\"help\";a:61:{s:9:\"strongarm\";b:0;s:11:\"remember_me\";b:0;s:5:\"block\";b:0;s:7:\"webform\";b:0;s:4:\"blog\";b:0;s:4:\"book\";b:0;s:8:\"calendar\";b:0;s:8:\"ckeditor\";b:0;s:5:\"color\";b:0;s:7:\"comment\";b:0;s:7:\"contact\";b:0;s:10:\"contextual\";b:0;s:9:\"dashboard\";b:0;s:5:\"dblog\";b:0;s:3:\"faq\";b:0;s:5:\"field\";b:0;s:16:\"field_collection\";b:0;s:17:\"field_sql_storage\";b:0;s:8:\"field_ui\";b:0;s:4:\"file\";b:0;s:6:\"filter\";b:0;s:8:\"fivestar\";b:0;s:10:\"flexslider\";b:0;s:4:\"help\";b:0;s:5:\"image\";b:0;s:13:\"jquery_update\";b:0;s:13:\"languageicons\";b:0;s:13:\"lang_dropdown\";b:0;s:21:\"lang_dropdown_hideout\";b:0;s:4:\"list\";b:0;s:6:\"locale\";b:0;s:4:\"menu\";b:0;s:15:\"menu_breadcrumb\";b:0;s:4:\"node\";b:0;s:6:\"number\";b:0;s:7:\"options\";b:0;s:7:\"overlay\";b:0;s:4:\"path\";b:0;s:3:\"php\";b:0;s:9:\"quicktabs\";b:0;s:6:\"search\";b:0;s:9:\"sharethis\";b:0;s:8:\"shortcut\";b:0;s:10:\"statistics\";b:0;s:6:\"system\";b:0;s:8:\"taxonomy\";b:0;s:4:\"text\";b:0;s:5:\"token\";b:0;s:12:\"token_custom\";b:0;s:6:\"update\";b:0;s:4:\"user\";b:0;s:15:\"views_slideshow\";b:0;s:21:\"views_slideshow_cycle\";b:0;s:5:\"forum\";b:0;s:8:\"pathauto\";b:0;s:13:\"i18n_taxonomy\";b:0;s:4:\"i18n\";b:0;s:11:\"i18n_string\";b:0;s:8:\"features\";b:0;s:10:\"admin_menu\";b:0;s:10:\"i18n_block\";b:0;}s:28:\"block_view_system_help_alter\";a:0:{}s:28:\"block_view_system_main_alter\";a:0:{}s:27:\"language_switch_links_alter\";a:3:{s:13:\"languageicons\";b:0;s:21:\"lang_dropdown_hideout\";b:0;s:4:\"i18n\";b:0;}s:19:\"i18n_translate_path\";a:1:{s:13:\"i18n_taxonomy\";b:0;}s:25:\"i18n_translate_path_alter\";a:0:{}s:29:\"form_lang_dropdown_form_alter\";a:0:{}s:39:\"block_view_lang_dropdown_language_alter\";a:0:{}s:45:\"query_taxonomy_vocabulary_load_multiple_alter\";a:0:{}s:11:\"entity_load\";a:0:{}s:24:\"taxonomy_vocabulary_load\";a:0:{}s:25:\"views_default_views_alter\";a:0:{}s:23:\"translation_pre_process\";a:0:{}s:24:\"translation_post_process\";a:0:{}s:14:\"views_pre_view\";a:1:{s:7:\"webform\";b:0;}s:15:\"views_pre_build\";a:0:{}s:17:\"views_query_alter\";a:0:{}s:25:\"views_query_substitutions\";a:3:{s:4:\"node\";b:0;s:4:\"user\";b:0;s:5:\"views\";b:0;}s:16:\"views_post_build\";a:0:{}s:17:\"views_pre_execute\";a:0:{}s:17:\"query_views_alter\";a:1:{s:5:\"views\";b:0;}s:31:\"query_views_recent_topics_alter\";a:0:{}s:23:\"query_user_access_alter\";a:0:{}s:18:\"views_post_execute\";a:0:{}s:16:\"views_pre_render\";a:1:{s:8:\"calendar\";b:0;}s:30:\"query_file_load_multiple_alter\";a:0:{}s:9:\"file_load\";a:0:{}s:20:\"image_default_styles\";a:2:{s:10:\"flexslider\";b:0;s:5:\"image\";b:0;}s:17:\"image_effect_info\";a:1:{s:5:\"image\";b:0;}s:23:\"image_effect_info_alter\";a:0:{}s:18:\"image_styles_alter\";a:0:{}s:14:\"username_alter\";a:0:{}s:17:\"views_post_render\";a:1:{s:14:\"advanced_forum\";b:0;}s:42:\"block_view_views_recent_topics_block_alter\";a:0:{}s:32:\"block_view_menu_menu_links_alter\";a:0:{}s:24:\"block_view_block_2_alter\";a:0:{}s:24:\"block_view_block_3_alter\";a:0:{}s:24:\"block_view_block_4_alter\";a:0:{}s:38:\"block_view_menu_menu_footer_menu_alter\";a:0:{}s:24:\"block_view_block_5_alter\";a:0:{}s:10:\"page_alter\";a:6:{s:4:\"book\";b:0;s:6:\"ctools\";b:0;s:7:\"overlay\";b:0;s:8:\"shortcut\";b:0;s:6:\"system\";b:0;s:5:\"views\";b:0;}s:8:\"js_alter\";a:1:{s:6:\"locale\";b:0;}s:15:\"html_head_alter\";a:0:{}s:9:\"css_alter\";a:1:{s:6:\"locale\";b:0;}s:4:\"exit\";a:2:{s:7:\"overlay\";b:0;s:10:\"statistics\";b:0;}s:30:\"query_user_load_multiple_alter\";a:0:{}s:9:\"user_load\";a:0:{}s:25:\"overlay_parent_initialize\";a:1:{s:7:\"overlay\";b:0;}s:22:\"entity_view_mode_alter\";a:0:{}s:19:\"entity_prepare_view\";a:0:{}s:23:\"field_attach_view_alter\";a:2:{s:11:\"field_group\";b:0;s:13:\"i18n_taxonomy\";b:0;}s:17:\"ctools_plugin_api\";a:5:{s:10:\"flexslider\";b:0;s:15:\"message_example\";b:0;s:17:\"video_embed_field\";b:0;s:11:\"field_group\";b:0;s:14:\"advanced_forum\";b:0;}s:23:\"ctools_plugin_api_alter\";a:0:{}s:22:\"field_group_info_alter\";a:0:{}s:9:\"user_view\";a:2:{s:4:\"blog\";b:0;s:4:\"user\";b:0;}s:11:\"entity_view\";a:0:{}s:15:\"user_view_alter\";a:0:{}s:17:\"entity_view_alter\";a:0:{}s:14:\"admin_menu_map\";a:6:{s:8:\"field_ui\";b:0;s:6:\"filter\";b:0;s:4:\"menu\";b:0;s:4:\"node\";b:0;s:8:\"taxonomy\";b:0;s:8:\"views_ui\";b:0;}s:20:\"admin_menu_map_alter\";a:0:{}s:16:\"i18n_object_info\";a:3:{s:6:\"entity\";s:4:\"i18n\";s:13:\"i18n_taxonomy\";s:4:\"i18n\";s:10:\"i18n_block\";s:4:\"i18n\";}s:22:\"i18n_object_info_alter\";a:1:{s:11:\"i18n_string\";b:0;}s:21:\"admin_menu_cache_info\";a:3:{s:6:\"system\";b:0;s:6:\"update\";b:0;s:10:\"admin_menu\";b:0;}s:23:\"admin_menu_output_build\";a:2:{s:10:\"admin_menu\";b:0;s:18:\"admin_menu_toolbar\";b:0;}s:23:\"admin_menu_output_alter\";a:3:{s:5:\"token\";b:0;s:10:\"admin_menu\";b:0;s:18:\"admin_menu_toolbar\";b:0;}s:23:\"admin_menu_replacements\";a:1:{s:10:\"admin_menu\";b:0;}s:20:\"shortcut_default_set\";a:0:{}s:27:\"menu_contextual_links_alter\";a:0:{}s:27:\"contextual_links_view_alter\";a:3:{s:9:\"sharethis\";b:0;s:8:\"views_ui\";b:0;s:5:\"views\";b:0;}s:18:\"field_extra_fields\";a:12:{s:7:\"webform\";b:0;s:8:\"ckeditor\";b:0;s:7:\"comment\";b:0;s:6:\"entity\";b:0;s:7:\"message\";b:0;s:4:\"node\";b:0;s:4:\"path\";b:0;s:9:\"sharethis\";b:0;s:8:\"taxonomy\";b:0;s:4:\"user\";b:0;s:11:\"field_group\";b:0;s:13:\"i18n_taxonomy\";b:0;}s:38:\"query_message_type_load_multiple_alter\";a:0:{}s:22:\"field_storage_pre_load\";a:0:{}s:31:\"field_available_languages_alter\";a:0:{}s:17:\"field_attach_load\";a:0:{}s:17:\"message_type_load\";a:0:{}s:20:\"field_language_alter\";a:1:{s:6:\"locale\";b:0;}s:24:\"field_extra_fields_alter\";a:0:{}s:32:\"field_extra_fields_display_alter\";a:0:{}s:29:\"field_attach_preprocess_alter\";a:0:{}}',0,1512620348,1),('system_list','a:3:{s:14:\"module_enabled\";a:99:{s:9:\"strongarm\";O:8:\"stdClass\":9:{s:8:\"filename\";s:44:\"sites/all/modules/strongarm/strongarm.module\";s:4:\"name\";s:9:\"strongarm\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:4:\"7201\";s:6:\"weight\";s:5:\"-1000\";s:4:\"info\";a:12:{s:4:\"name\";s:9:\"Strongarm\";s:11:\"description\";s:87:\"Enforces variable values defined by modules that need settings set to operate properly.\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:1:{i:0;s:6:\"ctools\";}s:5:\"files\";a:3:{i:0;s:19:\"strongarm.admin.inc\";i:1;s:17:\"strongarm.install\";i:2;s:16:\"strongarm.module\";}s:7:\"version\";s:7:\"7.x-2.0\";s:7:\"project\";s:9:\"strongarm\";s:9:\"datestamp\";s:10:\"1339604214\";s:5:\"mtime\";i:1499928385;s:7:\"package\";s:5:\"Other\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}}s:11:\"remember_me\";O:8:\"stdClass\":9:{s:8:\"filename\";s:48:\"sites/all/modules/remember_me/remember_me.module\";s:4:\"name\";s:11:\"remember_me\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:1:\"0\";s:6:\"weight\";s:3:\"-99\";s:4:\"info\";a:12:{s:4:\"name\";s:11:\"Remember me\";s:11:\"description\";s:47:\"Adds a \'\'Remember me\'\' checkbox to login forms.\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:4:{i:0;s:19:\"remember_me.install\";i:1;s:18:\"remember_me.module\";i:2;s:30:\"includes/remember_me.admin.inc\";i:3;s:24:\"includes/remember_me.inc\";}s:7:\"version\";s:7:\"7.x-1.1\";s:7:\"project\";s:11:\"remember_me\";s:9:\"datestamp\";s:10:\"1492928945\";s:5:\"mtime\";i:1492928945;s:12:\"dependencies\";a:0:{}s:7:\"package\";s:5:\"Other\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}}s:5:\"block\";O:8:\"stdClass\":9:{s:8:\"filename\";s:26:\"modules/block/block.module\";s:4:\"name\";s:5:\"block\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:4:\"7009\";s:6:\"weight\";s:2:\"-5\";s:4:\"info\";a:13:{s:4:\"name\";s:5:\"Block\";s:11:\"description\";s:140:\"Controls the visual building blocks a page is constructed with. Blocks are boxes of content rendered into an area, or region, of a web page.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:10:\"block.test\";}s:9:\"configure\";s:21:\"admin/structure/block\";s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}}s:7:\"webform\";O:8:\"stdClass\":9:{s:8:\"filename\";s:40:\"sites/all/modules/webform/webform.module\";s:4:\"name\";s:7:\"webform\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:4:\"7430\";s:6:\"weight\";s:2:\"-1\";s:4:\"info\";a:14:{s:4:\"name\";s:7:\"Webform\";s:11:\"description\";s:49:\"Enables the creation of forms and questionnaires.\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:7:\"Webform\";s:9:\"configure\";s:28:\"admin/config/content/webform\";s:3:\"php\";s:3:\"5.3\";s:12:\"dependencies\";a:2:{i:0;s:6:\"ctools\";i:1;s:5:\"views\";}s:17:\"test_dependencies\";a:1:{i:0;s:5:\"token\";}s:5:\"files\";a:27:{i:0;s:40:\"includes/webform.webformconditionals.inc\";i:1;s:49:\"includes/exporters/webform_exporter_delimited.inc\";i:2;s:55:\"includes/exporters/webform_exporter_excel_delimited.inc\";i:3;s:50:\"includes/exporters/webform_exporter_excel_xlsx.inc\";i:4;s:39:\"includes/exporters/webform_exporter.inc\";i:5;s:43:\"views/webform_handler_area_result_pager.inc\";i:6;s:41:\"views/webform_handler_field_form_body.inc\";i:7;s:40:\"views/webform_handler_field_is_draft.inc\";i:8;s:46:\"views/webform_handler_field_node_link_edit.inc\";i:9;s:49:\"views/webform_handler_field_node_link_results.inc\";i:10;s:48:\"views/webform_handler_field_submission_count.inc\";i:11;s:47:\"views/webform_handler_field_submission_data.inc\";i:12;s:47:\"views/webform_handler_field_submission_link.inc\";i:13;s:46:\"views/webform_handler_field_webform_status.inc\";i:14;s:41:\"views/webform_handler_filter_is_draft.inc\";i:15;s:48:\"views/webform_handler_filter_submission_data.inc\";i:16;s:47:\"views/webform_handler_filter_webform_status.inc\";i:17;s:38:\"views/webform_handler_numeric_data.inc\";i:18;s:54:\"views/webform_handler_relationship_submission_data.inc\";i:19;s:44:\"views/webform_plugin_row_submission_view.inc\";i:20;s:23:\"views/webform.views.inc\";i:21;s:36:\"tests/WebformComponentsTestCase.test\";i:22;s:38:\"tests/WebformConditionalsTestCase.test\";i:23;s:33:\"tests/WebformGeneralTestCase.test\";i:24;s:37:\"tests/WebformPermissionsTestCase.test\";i:25;s:36:\"tests/WebformSubmissionTestCase.test\";i:26;s:26:\"tests/WebformTestCase.test\";}s:7:\"version\";s:8:\"7.x-4.15\";s:7:\"project\";s:7:\"webform\";s:9:\"datestamp\";s:10:\"1492107249\";s:5:\"mtime\";i:1492107249;s:9:\"bootstrap\";i:0;}}s:11:\"author_pane\";O:8:\"stdClass\":9:{s:8:\"filename\";s:48:\"sites/all/modules/author_pane/author_pane.module\";s:4:\"name\";s:11:\"author_pane\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:12:{s:4:\"name\";s:11:\"Author Pane\";s:11:\"description\";s:93:\"Gathers information from core and user related contrib modules and displays it in a template.\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:13:{i:0;s:32:\"author-pane-user-picture.tpl.php\";i:1;s:19:\"author-pane.tpl.php\";i:2;s:18:\"author_pane.module\";i:3;s:31:\"modules/contact.author-pane.inc\";i:4;s:34:\"modules/fasttoggle.author-pane.inc\";i:5;s:32:\"modules/location.author-pane.inc\";i:6;s:26:\"modules/og.author-pane.inc\";i:7;s:31:\"modules/profile.author-pane.inc\";i:8;s:29:\"modules/troll.author-pane.inc\";i:9;s:35:\"modules/user_badges.author-pane.inc\";i:10;s:35:\"modules/user_titles.author-pane.inc\";i:11;s:34:\"modules/userpoints.author-pane.inc\";i:12;s:29:\"content_types/author_pane.inc\";}s:7:\"version\";s:7:\"7.x-2.0\";s:7:\"project\";s:11:\"author_pane\";s:9:\"datestamp\";s:10:\"1392987849\";s:5:\"mtime\";i:1499928385;s:12:\"dependencies\";a:0:{}s:7:\"package\";s:5:\"Other\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}}s:11:\"block_class\";O:8:\"stdClass\":9:{s:8:\"filename\";s:48:\"sites/all/modules/block_class/block_class.module\";s:4:\"name\";s:11:\"block_class\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:4:\"7103\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:13:{s:4:\"name\";s:11:\"Block Class\";s:11:\"description\";s:39:\"Allows assigning CSS classes to blocks.\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:1:{i:0;s:5:\"block\";}s:5:\"files\";a:1:{i:0;s:16:\"block_class.test\";}s:17:\"test_dependencies\";a:3:{i:0;s:7:\"context\";i:1;s:14:\"features (2.x)\";i:2;s:14:\"features_extra\";}s:7:\"version\";s:7:\"7.x-2.3\";s:7:\"project\";s:11:\"block_class\";s:9:\"datestamp\";s:10:\"1450415951\";s:5:\"mtime\";i:1450415951;s:7:\"package\";s:5:\"Other\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}}s:4:\"blog\";O:8:\"stdClass\":9:{s:8:\"filename\";s:24:\"modules/blog/blog.module\";s:4:\"name\";s:4:\"blog\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:12:{s:4:\"name\";s:4:\"Blog\";s:11:\"description\";s:25:\"Enables multi-user blogs.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:9:\"blog.test\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}}s:4:\"book\";O:8:\"stdClass\":9:{s:8:\"filename\";s:24:\"modules/book/book.module\";s:4:\"name\";s:4:\"book\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:14:{s:4:\"name\";s:4:\"Book\";s:11:\"description\";s:66:\"Allows users to create and organize related content in an outline.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:9:\"book.test\";}s:9:\"configure\";s:27:\"admin/content/book/settings\";s:11:\"stylesheets\";a:1:{s:3:\"all\";a:1:{s:8:\"book.css\";s:21:\"modules/book/book.css\";}}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}}s:8:\"calendar\";O:8:\"stdClass\":9:{s:8:\"filename\";s:42:\"sites/all/modules/calendar/calendar.module\";s:4:\"name\";s:8:\"calendar\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:4:\"7002\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:13:{s:4:\"name\";s:8:\"Calendar\";s:11:\"description\";s:60:\"Views plugin to display views containing dates as Calendars.\";s:12:\"dependencies\";a:3:{i:0;s:5:\"views\";i:1;s:8:\"date_api\";i:2;s:10:\"date_views\";}s:7:\"package\";s:9:\"Date/Time\";s:4:\"core\";s:3:\"7.x\";s:11:\"stylesheets\";a:1:{s:3:\"all\";a:1:{s:25:\"css/calendar_multiday.css\";s:52:\"sites/all/modules/calendar/css/calendar_multiday.css\";}}s:5:\"files\";a:8:{i:0;s:16:\"calendar.install\";i:1;s:15:\"calendar.module\";i:2;s:27:\"includes/calendar.views.inc\";i:3;s:34:\"includes/calendar_plugin_style.inc\";i:4;s:32:\"includes/calendar_plugin_row.inc\";i:5;s:36:\"includes/calendar.views_template.inc\";i:6;s:15:\"theme/theme.inc\";i:7;s:28:\"theme/calendar-style.tpl.php\";}s:7:\"version\";s:7:\"7.x-3.5\";s:7:\"project\";s:8:\"calendar\";s:9:\"datestamp\";s:10:\"1413299943\";s:5:\"mtime\";i:1499928385;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}}s:6:\"chosen\";O:8:\"stdClass\":9:{s:8:\"filename\";s:38:\"sites/all/modules/chosen/chosen.module\";s:4:\"name\";s:6:\"chosen\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:4:\"7203\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:13:{s:4:\"name\";s:6:\"Chosen\";s:11:\"description\";s:104:\"Makes select elements more user-friendly using <a href=\"http://harvesthq.github.com/chosen/\">Chosen</a>.\";s:7:\"package\";s:14:\"User interface\";s:9:\"configure\";s:34:\"admin/config/user-interface/chosen\";s:4:\"core\";s:3:\"7.x\";s:7:\"version\";s:13:\"7.x-2.0-beta4\";s:7:\"project\";s:6:\"chosen\";s:9:\"datestamp\";s:10:\"1394256505\";s:5:\"mtime\";i:1499928385;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}}s:8:\"ckeditor\";O:8:\"stdClass\":9:{s:8:\"filename\";s:42:\"sites/all/modules/ckeditor/ckeditor.module\";s:4:\"name\";s:8:\"ckeditor\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:4:\"7005\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:13:{s:4:\"name\";s:8:\"CKEditor\";s:11:\"description\";s:76:\"Enables CKEditor (WYSIWYG HTML editor) for use instead of plain text fields.\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:14:\"User interface\";s:9:\"configure\";s:29:\"admin/config/content/ckeditor\";s:7:\"version\";s:8:\"7.x-1.16\";s:7:\"project\";s:8:\"ckeditor\";s:9:\"datestamp\";s:10:\"1413311935\";s:5:\"mtime\";i:1499928385;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}}s:5:\"color\";O:8:\"stdClass\":9:{s:8:\"filename\";s:26:\"modules/color/color.module\";s:4:\"name\";s:5:\"color\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:4:\"7001\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:12:{s:4:\"name\";s:5:\"Color\";s:11:\"description\";s:70:\"Allows administrators to change the color scheme of compatible themes.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:10:\"color.test\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}}s:7:\"comment\";O:8:\"stdClass\":9:{s:8:\"filename\";s:30:\"modules/comment/comment.module\";s:4:\"name\";s:7:\"comment\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:4:\"7009\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:14:{s:4:\"name\";s:7:\"Comment\";s:11:\"description\";s:57:\"Allows users to comment on and discuss published content.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:1:{i:0;s:4:\"text\";}s:5:\"files\";a:2:{i:0;s:14:\"comment.module\";i:1;s:12:\"comment.test\";}s:9:\"configure\";s:21:\"admin/content/comment\";s:11:\"stylesheets\";a:1:{s:3:\"all\";a:1:{s:11:\"comment.css\";s:27:\"modules/comment/comment.css\";}}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}}s:7:\"contact\";O:8:\"stdClass\":9:{s:8:\"filename\";s:30:\"modules/contact/contact.module\";s:4:\"name\";s:7:\"contact\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:4:\"7003\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:13:{s:4:\"name\";s:7:\"Contact\";s:11:\"description\";s:61:\"Enables the use of both personal and site-wide contact forms.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:12:\"contact.test\";}s:9:\"configure\";s:23:\"admin/structure/contact\";s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}}s:10:\"contextual\";O:8:\"stdClass\":9:{s:8:\"filename\";s:36:\"modules/contextual/contextual.module\";s:4:\"name\";s:10:\"contextual\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:12:{s:4:\"name\";s:16:\"Contextual links\";s:11:\"description\";s:75:\"Provides contextual links to perform actions related to elements on a page.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:15:\"contextual.test\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}}s:6:\"ctools\";O:8:\"stdClass\":9:{s:8:\"filename\";s:38:\"sites/all/modules/ctools/ctools.module\";s:4:\"name\";s:6:\"ctools\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:4:\"7001\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:12:{s:4:\"name\";s:11:\"Chaos tools\";s:11:\"description\";s:46:\"A library of helpful tools by Merlin of Chaos.\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:16:\"Chaos tool suite\";s:7:\"version\";s:7:\"7.x-1.9\";s:5:\"files\";a:5:{i:0;s:20:\"includes/context.inc\";i:1;s:22:\"includes/css-cache.inc\";i:2;s:22:\"includes/math-expr.inc\";i:3;s:21:\"includes/stylizer.inc\";i:4;s:20:\"tests/css_cache.test\";}s:7:\"project\";s:6:\"ctools\";s:9:\"datestamp\";s:10:\"1440020680\";s:5:\"mtime\";i:1499928385;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}}s:9:\"dashboard\";O:8:\"stdClass\":9:{s:8:\"filename\";s:34:\"modules/dashboard/dashboard.module\";s:4:\"name\";s:9:\"dashboard\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:13:{s:4:\"name\";s:9:\"Dashboard\";s:11:\"description\";s:136:\"Provides a dashboard page in the administrative interface for organizing administrative tasks and tracking information within your site.\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:5:\"files\";a:1:{i:0;s:14:\"dashboard.test\";}s:12:\"dependencies\";a:1:{i:0;s:5:\"block\";}s:9:\"configure\";s:25:\"admin/dashboard/customize\";s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}}s:8:\"date_api\";O:8:\"stdClass\":9:{s:8:\"filename\";s:47:\"sites/all/modules/date/date_api/date_api.module\";s:4:\"name\";s:8:\"date_api\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:4:\"7001\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:13:{s:4:\"name\";s:8:\"Date API\";s:11:\"description\";s:45:\"A Date API that can be used by other modules.\";s:7:\"package\";s:9:\"Date/Time\";s:4:\"core\";s:3:\"7.x\";s:3:\"php\";s:3:\"5.2\";s:11:\"stylesheets\";a:1:{s:3:\"all\";a:1:{s:8:\"date.css\";s:40:\"sites/all/modules/date/date_api/date.css\";}}s:5:\"files\";a:2:{i:0;s:15:\"date_api.module\";i:1;s:16:\"date_api_sql.inc\";}s:7:\"version\";s:7:\"7.x-2.8\";s:7:\"project\";s:4:\"date\";s:9:\"datestamp\";s:10:\"1406653438\";s:5:\"mtime\";i:1499928385;s:12:\"dependencies\";a:0:{}s:9:\"bootstrap\";i:0;}}s:10:\"date_views\";O:8:\"stdClass\":9:{s:8:\"filename\";s:51:\"sites/all/modules/date/date_views/date_views.module\";s:4:\"name\";s:10:\"date_views\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:12:{s:4:\"name\";s:10:\"Date Views\";s:11:\"description\";s:57:\"Views integration for date fields and date functionality.\";s:7:\"package\";s:9:\"Date/Time\";s:12:\"dependencies\";a:2:{i:0;s:8:\"date_api\";i:1;s:5:\"views\";}s:4:\"core\";s:3:\"7.x\";s:3:\"php\";s:3:\"5.2\";s:5:\"files\";a:6:{i:0;s:40:\"includes/date_views_argument_handler.inc\";i:1;s:47:\"includes/date_views_argument_handler_simple.inc\";i:2;s:38:\"includes/date_views_filter_handler.inc\";i:3;s:45:\"includes/date_views_filter_handler_simple.inc\";i:4;s:29:\"includes/date_views.views.inc\";i:5;s:36:\"includes/date_views_plugin_pager.inc\";}s:7:\"version\";s:7:\"7.x-2.8\";s:7:\"project\";s:4:\"date\";s:9:\"datestamp\";s:10:\"1406653438\";s:5:\"mtime\";i:1499928385;s:9:\"bootstrap\";i:0;}}s:5:\"dblog\";O:8:\"stdClass\":9:{s:8:\"filename\";s:26:\"modules/dblog/dblog.module\";s:4:\"name\";s:5:\"dblog\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"1\";s:14:\"schema_version\";s:4:\"7003\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:12:{s:4:\"name\";s:16:\"Database logging\";s:11:\"description\";s:47:\"Logs and records system events to the database.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:10:\"dblog.test\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}}s:6:\"entity\";O:8:\"stdClass\":9:{s:8:\"filename\";s:38:\"sites/all/modules/entity/entity.module\";s:4:\"name\";s:6:\"entity\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:4:\"7003\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:12:{s:4:\"name\";s:10:\"Entity API\";s:11:\"description\";s:69:\"Enables modules to work with any entity type and to provide entities.\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:24:{i:0;s:19:\"entity.features.inc\";i:1;s:15:\"entity.i18n.inc\";i:2;s:15:\"entity.info.inc\";i:3;s:16:\"entity.rules.inc\";i:4;s:11:\"entity.test\";i:5;s:19:\"includes/entity.inc\";i:6;s:30:\"includes/entity.controller.inc\";i:7;s:22:\"includes/entity.ui.inc\";i:8;s:27:\"includes/entity.wrapper.inc\";i:9;s:22:\"views/entity.views.inc\";i:10;s:52:\"views/handlers/entity_views_field_handler_helper.inc\";i:11;s:51:\"views/handlers/entity_views_handler_area_entity.inc\";i:12;s:53:\"views/handlers/entity_views_handler_field_boolean.inc\";i:13;s:50:\"views/handlers/entity_views_handler_field_date.inc\";i:14;s:54:\"views/handlers/entity_views_handler_field_duration.inc\";i:15;s:52:\"views/handlers/entity_views_handler_field_entity.inc\";i:16;s:51:\"views/handlers/entity_views_handler_field_field.inc\";i:17;s:53:\"views/handlers/entity_views_handler_field_numeric.inc\";i:18;s:53:\"views/handlers/entity_views_handler_field_options.inc\";i:19;s:50:\"views/handlers/entity_views_handler_field_text.inc\";i:20;s:49:\"views/handlers/entity_views_handler_field_uri.inc\";i:21;s:62:\"views/handlers/entity_views_handler_relationship_by_bundle.inc\";i:22;s:52:\"views/handlers/entity_views_handler_relationship.inc\";i:23;s:53:\"views/plugins/entity_views_plugin_row_entity_view.inc\";}s:7:\"version\";s:7:\"7.x-1.6\";s:7:\"project\";s:6:\"entity\";s:9:\"datestamp\";s:10:\"1424876582\";s:5:\"mtime\";i:1499928385;s:12:\"dependencies\";a:0:{}s:7:\"package\";s:5:\"Other\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}}s:15:\"entityreference\";O:8:\"stdClass\":9:{s:8:\"filename\";s:56:\"sites/all/modules/entityreference/entityreference.module\";s:4:\"name\";s:15:\"entityreference\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:4:\"7002\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:14:{s:4:\"name\";s:16:\"Entity Reference\";s:11:\"description\";s:51:\"Provides a field that can reference other entities.\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:6:\"Fields\";s:12:\"dependencies\";a:2:{i:0;s:6:\"entity\";i:1;s:6:\"ctools\";}s:5:\"files\";a:11:{i:0;s:27:\"entityreference.migrate.inc\";i:1;s:30:\"plugins/selection/abstract.inc\";i:2;s:27:\"plugins/selection/views.inc\";i:3;s:29:\"plugins/behavior/abstract.inc\";i:4;s:40:\"views/entityreference_plugin_display.inc\";i:5;s:38:\"views/entityreference_plugin_style.inc\";i:6;s:43:\"views/entityreference_plugin_row_fields.inc\";i:7;s:35:\"tests/entityreference.handlers.test\";i:8;s:35:\"tests/entityreference.taxonomy.test\";i:9;s:32:\"tests/entityreference.admin.test\";i:10;s:32:\"tests/entityreference.feeds.test\";}s:7:\"version\";s:7:\"7.x-1.1\";s:7:\"project\";s:15:\"entityreference\";s:9:\"datestamp\";s:10:\"1384973110\";s:5:\"mtime\";i:1499928385;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;s:8:\"required\";b:1;s:11:\"explanation\";s:76:\"Field type(s) in use - see <a href=\"/en/admin/reports/fields\">Field list</a>\";}}s:12:\"entity_token\";O:8:\"stdClass\":9:{s:8:\"filename\";s:44:\"sites/all/modules/entity/entity_token.module\";s:4:\"name\";s:12:\"entity_token\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:12:{s:4:\"name\";s:13:\"Entity tokens\";s:11:\"description\";s:99:\"Provides token replacements for all properties that have no tokens and are known to the entity API.\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:2:{i:0;s:23:\"entity_token.tokens.inc\";i:1;s:19:\"entity_token.module\";}s:12:\"dependencies\";a:1:{i:0;s:6:\"entity\";}s:7:\"version\";s:7:\"7.x-1.6\";s:7:\"project\";s:6:\"entity\";s:9:\"datestamp\";s:10:\"1424876582\";s:5:\"mtime\";i:1499928385;s:7:\"package\";s:5:\"Other\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}}s:3:\"faq\";O:8:\"stdClass\":9:{s:8:\"filename\";s:32:\"sites/all/modules/faq/faq.module\";s:4:\"name\";s:3:\"faq\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:4:\"7002\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:13:{s:4:\"name\";s:26:\"Frequently Asked Questions\";s:11:\"description\";s:50:\"Manages configuration of questions for a FAQ page.\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:18:{i:0;s:13:\"faq.admin.inc\";i:1;s:11:\"faq.install\";i:2;s:10:\"faq.module\";i:3;s:8:\"faq.test\";i:4;s:41:\"includes/faq-category-hide-answer.tpl.php\";i:5;s:38:\"includes/faq-category-new-page.tpl.php\";i:6;s:46:\"includes/faq-category-questions-inline.tpl.php\";i:7;s:51:\"includes/faq-category-questions-top-answers.tpl.php\";i:8;s:43:\"includes/faq-category-questions-top.tpl.php\";i:9;s:32:\"includes/faq-hide-answer.tpl.php\";i:10;s:29:\"includes/faq-new-page.tpl.php\";i:11;s:37:\"includes/faq-questions-inline.tpl.php\";i:12;s:34:\"includes/faq-questions-top.tpl.php\";i:13;s:28:\"includes/faq.hide_answer.inc\";i:14;s:25:\"includes/faq.new_page.inc\";i:15;s:33:\"includes/faq.questions_inline.inc\";i:16;s:30:\"includes/faq.questions_top.inc\";i:17;s:19:\"views/faq.views.inc\";}s:9:\"configure\";s:24:\"admin/config/content/faq\";s:7:\"version\";s:11:\"7.x-1.0-rc3\";s:7:\"project\";s:3:\"faq\";s:9:\"datestamp\";s:10:\"1415528891\";s:5:\"mtime\";i:1499928385;s:12:\"dependencies\";a:0:{}s:7:\"package\";s:5:\"Other\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}}s:5:\"field\";O:8:\"stdClass\":9:{s:8:\"filename\";s:26:\"modules/field/field.module\";s:4:\"name\";s:5:\"field\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:4:\"7004\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:14:{s:4:\"name\";s:5:\"Field\";s:11:\"description\";s:57:\"Field API to add fields to entities like nodes and users.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:4:{i:0;s:12:\"field.module\";i:1;s:16:\"field.attach.inc\";i:2;s:20:\"field.info.class.inc\";i:3;s:16:\"tests/field.test\";}s:12:\"dependencies\";a:1:{i:0;s:17:\"field_sql_storage\";}s:8:\"required\";b:1;s:11:\"stylesheets\";a:1:{s:3:\"all\";a:1:{s:15:\"theme/field.css\";s:29:\"modules/field/theme/field.css\";}}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}}s:16:\"field_collection\";O:8:\"stdClass\":9:{s:8:\"filename\";s:58:\"sites/all/modules/field_collection/field_collection.module\";s:4:\"name\";s:16:\"field_collection\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:4:\"7006\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:15:{s:4:\"name\";s:16:\"Field collection\";s:11:\"description\";s:81:\"Provides a field collection field, to which any number of fields can be attached.\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:1:{i:0;s:6:\"entity\";}s:5:\"files\";a:4:{i:0;s:21:\"field_collection.test\";i:1;s:25:\"field_collection.info.inc\";i:2;s:47:\"views/field_collection_handler_relationship.inc\";i:3;s:28:\"field_collection.migrate.inc\";}s:9:\"configure\";s:33:\"admin/structure/field-collections\";s:7:\"package\";s:6:\"Fields\";s:7:\"version\";s:13:\"7.x-1.0-beta8\";s:7:\"project\";s:16:\"field_collection\";s:9:\"datestamp\";s:10:\"1415122384\";s:5:\"mtime\";i:1499928385;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;s:8:\"required\";b:1;s:11:\"explanation\";s:76:\"Field type(s) in use - see <a href=\"/en/admin/reports/fields\">Field list</a>\";}}s:17:\"field_sql_storage\";O:8:\"stdClass\":9:{s:8:\"filename\";s:64:\"modules/field/modules/field_sql_storage/field_sql_storage.module\";s:4:\"name\";s:17:\"field_sql_storage\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:4:\"7002\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:13:{s:4:\"name\";s:17:\"Field SQL storage\";s:11:\"description\";s:37:\"Stores field data in an SQL database.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:1:{i:0;s:5:\"field\";}s:5:\"files\";a:1:{i:0;s:22:\"field_sql_storage.test\";}s:8:\"required\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}}s:8:\"field_ui\";O:8:\"stdClass\":9:{s:8:\"filename\";s:32:\"modules/field_ui/field_ui.module\";s:4:\"name\";s:8:\"field_ui\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:12:{s:4:\"name\";s:8:\"Field UI\";s:11:\"description\";s:33:\"User interface for the Field API.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:1:{i:0;s:5:\"field\";}s:5:\"files\";a:1:{i:0;s:13:\"field_ui.test\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}}s:4:\"file\";O:8:\"stdClass\":9:{s:8:\"filename\";s:24:\"modules/file/file.module\";s:4:\"name\";s:4:\"file\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:12:{s:4:\"name\";s:4:\"File\";s:11:\"description\";s:26:\"Defines a file field type.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:1:{i:0;s:5:\"field\";}s:5:\"files\";a:1:{i:0;s:15:\"tests/file.test\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}}s:6:\"filter\";O:8:\"stdClass\":9:{s:8:\"filename\";s:28:\"modules/filter/filter.module\";s:4:\"name\";s:6:\"filter\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:4:\"7010\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:14:{s:4:\"name\";s:6:\"Filter\";s:11:\"description\";s:43:\"Filters content in preparation for display.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:11:\"filter.test\";}s:8:\"required\";b:1;s:9:\"configure\";s:28:\"admin/config/content/formats\";s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}}s:8:\"fivestar\";O:8:\"stdClass\":9:{s:8:\"filename\";s:42:\"sites/all/modules/fivestar/fivestar.module\";s:4:\"name\";s:8:\"fivestar\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:4:\"7208\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:15:{s:4:\"name\";s:8:\"Fivestar\";s:11:\"description\";s:48:\"Enables fivestar ratings on content, users, etc.\";s:7:\"package\";s:6:\"Voting\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:1:{i:0;s:9:\"votingapi\";}s:9:\"configure\";s:29:\"admin/config/content/fivestar\";s:5:\"files\";a:2:{i:0;s:23:\"test/fivestar.base.test\";i:1;s:24:\"test/fivestar.field.test\";}s:7:\"version\";s:7:\"7.x-2.1\";s:7:\"project\";s:8:\"fivestar\";s:9:\"datestamp\";s:10:\"1395087839\";s:5:\"mtime\";i:1499928385;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;s:8:\"required\";b:1;s:11:\"explanation\";s:76:\"Field type(s) in use - see <a href=\"/en/admin/reports/fields\">Field list</a>\";}}s:10:\"flexslider\";O:8:\"stdClass\":9:{s:8:\"filename\";s:46:\"sites/all/modules/flexslider/flexslider.module\";s:4:\"name\";s:10:\"flexslider\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:4:\"7201\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:13:{s:4:\"name\";s:10:\"FlexSlider\";s:11:\"description\";s:46:\"Integrate the FlexSlider 2 library with Drupal\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:10:\"FlexSlider\";s:12:\"dependencies\";a:3:{i:0;s:17:\"libraries (>=2.x)\";i:1;s:6:\"ctools\";i:2;s:5:\"image\";}s:5:\"files\";a:2:{i:0;s:26:\"theme/flexslider.theme.inc\";i:1;s:15:\"flexslider.test\";}s:9:\"configure\";s:29:\"admin/config/media/flexslider\";s:7:\"version\";s:14:\"7.x-2.0-alpha3\";s:7:\"project\";s:10:\"flexslider\";s:9:\"datestamp\";s:10:\"1378663043\";s:5:\"mtime\";i:1499928385;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}}s:17:\"flexslider_fields\";O:8:\"stdClass\":9:{s:8:\"filename\";s:71:\"sites/all/modules/flexslider/flexslider_fields/flexslider_fields.module\";s:4:\"name\";s:17:\"flexslider_fields\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:12:{s:4:\"name\";s:17:\"FlexSlider Fields\";s:11:\"description\";s:44:\"Adds a display mode in Fields for FlexSlider\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:10:\"FlexSlider\";s:12:\"dependencies\";a:1:{i:0;s:10:\"flexslider\";}s:7:\"version\";s:14:\"7.x-2.0-alpha3\";s:7:\"project\";s:10:\"flexslider\";s:9:\"datestamp\";s:10:\"1378663043\";s:5:\"mtime\";i:1499928385;s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}}s:16:\"flexslider_views\";O:8:\"stdClass\":9:{s:8:\"filename\";s:69:\"sites/all/modules/flexslider/flexslider_views/flexslider_views.module\";s:4:\"name\";s:16:\"flexslider_views\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:12:{s:4:\"name\";s:22:\"FlexSlider Views Style\";s:11:\"description\";s:40:\"Adds a Views style plugin for FlexSlider\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:10:\"FlexSlider\";s:12:\"dependencies\";a:2:{i:0;s:5:\"views\";i:1;s:10:\"flexslider\";}s:5:\"files\";a:3:{i:0;s:23:\"flexslider_views.module\";i:1;s:26:\"flexslider_views.views.inc\";i:2;s:44:\"flexslider_views_plugin_style_flexslider.inc\";}s:7:\"version\";s:14:\"7.x-2.0-alpha3\";s:7:\"project\";s:10:\"flexslider\";s:9:\"datestamp\";s:10:\"1378663043\";s:5:\"mtime\";i:1499928385;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}}s:4:\"help\";O:8:\"stdClass\":9:{s:8:\"filename\";s:24:\"modules/help/help.module\";s:4:\"name\";s:4:\"help\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:12:{s:4:\"name\";s:4:\"Help\";s:11:\"description\";s:35:\"Manages the display of online help.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:9:\"help.test\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}}s:16:\"i18n_translation\";O:8:\"stdClass\":9:{s:8:\"filename\";s:63:\"sites/all/modules/i18n/i18n_translation/i18n_translation.module\";s:4:\"name\";s:16:\"i18n_translation\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:12:{s:4:\"name\";s:16:\"Translation sets\";s:11:\"description\";s:47:\"Simple translation sets API for generic objects\";s:12:\"dependencies\";a:1:{i:0;s:4:\"i18n\";}s:7:\"package\";s:35:\"Multilingual - Internationalization\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:20:\"i18n_translation.inc\";}s:7:\"version\";s:8:\"7.x-1.13\";s:7:\"project\";s:4:\"i18n\";s:9:\"datestamp\";s:10:\"1430999922\";s:5:\"mtime\";i:1499928385;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}}s:5:\"image\";O:8:\"stdClass\":9:{s:8:\"filename\";s:26:\"modules/image/image.module\";s:4:\"name\";s:5:\"image\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:4:\"7005\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:15:{s:4:\"name\";s:5:\"Image\";s:11:\"description\";s:34:\"Provides image manipulation tools.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:1:{i:0;s:4:\"file\";}s:5:\"files\";a:1:{i:0;s:10:\"image.test\";}s:9:\"configure\";s:31:\"admin/config/media/image-styles\";s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;s:8:\"required\";b:1;s:11:\"explanation\";s:76:\"Field type(s) in use - see <a href=\"/en/admin/reports/fields\">Field list</a>\";}}s:13:\"jquery_update\";O:8:\"stdClass\":9:{s:8:\"filename\";s:52:\"sites/all/modules/jquery_update/jquery_update.module\";s:4:\"name\";s:13:\"jquery_update\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:4:\"7000\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:13:{s:4:\"name\";s:13:\"jQuery Update\";s:11:\"description\";s:53:\"Update jQuery and jQuery UI to a more recent version.\";s:7:\"package\";s:14:\"User interface\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:2:{i:0;s:20:\"jquery_update.module\";i:1;s:21:\"jquery_update.install\";}s:9:\"configure\";s:38:\"admin/config/development/jquery_update\";s:7:\"version\";s:7:\"7.x-2.7\";s:7:\"project\";s:13:\"jquery_update\";s:9:\"datestamp\";s:10:\"1445379855\";s:5:\"mtime\";i:1445379855;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}}s:13:\"languageicons\";O:8:\"stdClass\":9:{s:8:\"filename\";s:52:\"sites/all/modules/languageicons/languageicons.module\";s:4:\"name\";s:13:\"languageicons\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:4:\"6200\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:13:{s:4:\"name\";s:14:\"Language Icons\";s:11:\"description\";s:29:\"Adds icons to language links.\";s:12:\"dependencies\";a:1:{i:0;s:6:\"locale\";}s:7:\"package\";s:12:\"Multilingual\";s:4:\"core\";s:3:\"7.x\";s:9:\"configure\";s:36:\"admin/config/regional/language/icons\";s:7:\"version\";s:7:\"7.x-1.1\";s:7:\"project\";s:13:\"languageicons\";s:9:\"datestamp\";s:10:\"1399825730\";s:5:\"mtime\";i:1499928385;s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}}s:13:\"lang_dropdown\";O:8:\"stdClass\":9:{s:8:\"filename\";s:52:\"sites/all/modules/lang_dropdown/lang_dropdown.module\";s:4:\"name\";s:13:\"lang_dropdown\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:4:\"7201\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:13:{s:4:\"name\";s:26:\"Language Switcher Dropdown\";s:7:\"package\";s:12:\"Multilingual\";s:11:\"description\";s:65:\"Provides a dropdown select to switch between available languages.\";s:12:\"dependencies\";a:1:{i:0;s:6:\"locale\";}s:9:\"configure\";s:21:\"admin/structure/block\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:2:{i:0;s:20:\"lang_dropdown.module\";i:1;s:21:\"lang_dropdown.install\";}s:7:\"version\";s:7:\"7.x-2.5\";s:7:\"project\";s:13:\"lang_dropdown\";s:9:\"datestamp\";s:10:\"1387127905\";s:5:\"mtime\";i:1499928385;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}}s:21:\"lang_dropdown_hideout\";O:8:\"stdClass\":9:{s:8:\"filename\";s:82:\"sites/all/modules/lang_dropdown/lang_dropdown_hideout/lang_dropdown_hideout.module\";s:4:\"name\";s:21:\"lang_dropdown_hideout\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:13:{s:4:\"name\";s:34:\"Language Switcher Dropdown Hideout\";s:7:\"package\";s:12:\"Multilingual\";s:11:\"description\";s:69:\"Allow to hide specific languages from the switcher for certain roles.\";s:12:\"dependencies\";a:1:{i:0;s:6:\"locale\";}s:9:\"configure\";s:21:\"admin/structure/block\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:2:{i:0;s:28:\"lang_dropdown_hideout.module\";i:1;s:29:\"lang_dropdown_hideout.install\";}s:7:\"version\";s:7:\"7.x-2.5\";s:7:\"project\";s:13:\"lang_dropdown\";s:9:\"datestamp\";s:10:\"1387127905\";s:5:\"mtime\";i:1499928385;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}}s:9:\"libraries\";O:8:\"stdClass\":9:{s:8:\"filename\";s:44:\"sites/all/modules/libraries/libraries.module\";s:4:\"name\";s:9:\"libraries\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:4:\"7200\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:12:{s:4:\"name\";s:9:\"Libraries\";s:11:\"description\";s:64:\"Allows version-dependent and shared usage of external libraries.\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:1:{i:0;s:15:\"system (>=7.11)\";}s:5:\"files\";a:1:{i:0;s:20:\"tests/libraries.test\";}s:7:\"version\";s:7:\"7.x-2.2\";s:7:\"project\";s:9:\"libraries\";s:9:\"datestamp\";s:10:\"1391965716\";s:5:\"mtime\";i:1499928385;s:7:\"package\";s:5:\"Other\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}}s:4:\"link\";O:8:\"stdClass\":9:{s:8:\"filename\";s:34:\"sites/all/modules/link/link.module\";s:4:\"name\";s:4:\"link\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:4:\"7001\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:14:{s:4:\"name\";s:4:\"Link\";s:11:\"description\";s:32:\"Defines simple link field types.\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:6:\"Fields\";s:5:\"files\";a:10:{i:0;s:11:\"link.module\";i:1;s:16:\"link.migrate.inc\";i:2;s:15:\"tests/link.test\";i:3;s:25:\"tests/link.attribute.test\";i:4;s:20:\"tests/link.crud.test\";i:5;s:28:\"tests/link.crud_browser.test\";i:6;s:21:\"tests/link.token.test\";i:7;s:24:\"tests/link.validate.test\";i:8;s:44:\"views/link_views_handler_argument_target.inc\";i:9;s:44:\"views/link_views_handler_filter_protocol.inc\";}s:7:\"version\";s:7:\"7.x-1.3\";s:7:\"project\";s:4:\"link\";s:9:\"datestamp\";s:10:\"1413924830\";s:5:\"mtime\";i:1499928385;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;s:8:\"required\";b:1;s:11:\"explanation\";s:76:\"Field type(s) in use - see <a href=\"/en/admin/reports/fields\">Field list</a>\";}}s:4:\"list\";O:8:\"stdClass\":9:{s:8:\"filename\";s:38:\"modules/field/modules/list/list.module\";s:4:\"name\";s:4:\"list\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:4:\"7002\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:14:{s:4:\"name\";s:4:\"List\";s:11:\"description\";s:69:\"Defines list field types. Use with Options to create selection lists.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:2:{i:0;s:5:\"field\";i:1;s:7:\"options\";}s:5:\"files\";a:1:{i:0;s:15:\"tests/list.test\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;s:8:\"required\";b:1;s:11:\"explanation\";s:76:\"Field type(s) in use - see <a href=\"/en/admin/reports/fields\">Field list</a>\";}}s:6:\"locale\";O:8:\"stdClass\":9:{s:8:\"filename\";s:28:\"modules/locale/locale.module\";s:4:\"name\";s:6:\"locale\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:4:\"7005\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:13:{s:4:\"name\";s:6:\"Locale\";s:11:\"description\";s:119:\"Adds language handling functionality and enables the translation of the user interface to languages other than English.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:11:\"locale.test\";}s:9:\"configure\";s:30:\"admin/config/regional/language\";s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}}s:4:\"menu\";O:8:\"stdClass\":9:{s:8:\"filename\";s:24:\"modules/menu/menu.module\";s:4:\"name\";s:4:\"menu\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:4:\"7003\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:13:{s:4:\"name\";s:4:\"Menu\";s:11:\"description\";s:60:\"Allows administrators to customize the site navigation menu.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:9:\"menu.test\";}s:9:\"configure\";s:20:\"admin/structure/menu\";s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}}s:15:\"menu_breadcrumb\";O:8:\"stdClass\":9:{s:8:\"filename\";s:56:\"sites/all/modules/menu_breadcrumb/menu_breadcrumb.module\";s:4:\"name\";s:15:\"menu_breadcrumb\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:4:\"6100\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:13:{s:4:\"name\";s:15:\"Menu breadcrumb\";s:11:\"description\";s:74:\"Allows you to use the menu the current page belongs to for the breadcrumb.\";s:12:\"dependencies\";a:1:{i:0;s:4:\"menu\";}s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:23:\"menu_breadcrumb.install\";}s:9:\"configure\";s:43:\"admin/config/user-interface/menu-breadcrumb\";s:7:\"version\";s:7:\"7.x-1.6\";s:7:\"project\";s:15:\"menu_breadcrumb\";s:9:\"datestamp\";s:10:\"1425993992\";s:5:\"mtime\";i:1499928385;s:7:\"package\";s:5:\"Other\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}}s:7:\"message\";O:8:\"stdClass\":9:{s:8:\"filename\";s:40:\"sites/all/modules/message/message.module\";s:4:\"name\";s:7:\"message\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:4:\"7012\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:12:{s:4:\"name\";s:7:\"Message\";s:11:\"description\";s:34:\"A general message logging utility.\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:7:\"Message\";s:12:\"dependencies\";a:1:{i:0;s:6:\"entity\";}s:5:\"files\";a:11:{i:0;s:16:\"message.info.inc\";i:1;s:26:\"includes/message.admin.inc\";i:2;s:30:\"includes/message.exception.inc\";i:3;s:42:\"includes/message.message_type_category.inc\";i:4;s:33:\"includes/message.message_type.inc\";i:5;s:28:\"includes/message.message.inc\";i:6;s:12:\"message.test\";i:7;s:32:\"includes/views/message.views.inc\";i:8;s:64:\"includes/views/handlers/message_handler_field_message_render.inc\";i:9;s:63:\"includes/views/handlers/message_handler_filter_message_type.inc\";i:10;s:72:\"includes/views/handlers/message_handler_filter_message_type_category.inc\";}s:7:\"version\";s:7:\"7.x-1.9\";s:7:\"project\";s:7:\"message\";s:9:\"datestamp\";s:10:\"1374541036\";s:5:\"mtime\";i:1499928385;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}}s:15:\"message_example\";O:8:\"stdClass\":9:{s:8:\"filename\";s:64:\"sites/all/modules/message/message_example/message_example.module\";s:4:\"name\";s:15:\"message_example\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:14:{s:4:\"name\";s:15:\"Message example\";s:11:\"description\";s:16:\"Message example.\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:7:\"Message\";s:3:\"php\";s:5:\"5.2.4\";s:12:\"dependencies\";a:8:{i:0;s:12:\"entity_token\";i:1;s:15:\"entityreference\";i:2;s:8:\"features\";i:3;s:4:\"list\";i:4;s:7:\"message\";i:5;s:9:\"strongarm\";i:6;s:5:\"token\";i:7;s:5:\"views\";}s:11:\"stylesheets\";a:1:{s:3:\"all\";a:1:{s:23:\"css/message_example.css\";s:65:\"sites/all/modules/message/message_example/css/message_example.css\";}}s:8:\"features\";a:6:{s:6:\"ctools\";a:2:{i:0;s:21:\"strongarm:strongarm:1\";i:1;s:23:\"views:views_default:3.0\";}s:12:\"features_api\";a:1:{i:0;s:5:\"api:1\";}s:5:\"field\";a:6:{i:0;s:48:\"message-example_create_comment-field_comment_ref\";i:1;s:45:\"message-example_create_comment-field_node_ref\";i:2;s:46:\"message-example_create_comment-field_published\";i:3;s:42:\"message-example_create_node-field_node_ref\";i:4;s:43:\"message-example_create_node-field_published\";i:5;s:45:\"message-example_user_register-field_published\";}s:12:\"message_type\";a:3:{i:0;s:22:\"example_create_comment\";i:1;s:19:\"example_create_node\";i:2;s:21:\"example_user_register\";}s:8:\"variable\";a:3:{i:0;s:53:\"field_bundle_settings_message__example_create_comment\";i:1;s:50:\"field_bundle_settings_message__example_create_node\";i:2;s:52:\"field_bundle_settings_message__example_user_register\";}s:10:\"views_view\";a:1:{i:0;s:15:\"message_example\";}}s:7:\"version\";s:7:\"7.x-1.9\";s:7:\"project\";s:7:\"message\";s:9:\"datestamp\";s:10:\"1374541036\";s:5:\"mtime\";i:1499928385;s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}}s:11:\"modal_forms\";O:8:\"stdClass\":9:{s:8:\"filename\";s:48:\"sites/all/modules/modal_forms/modal_forms.module\";s:4:\"name\";s:11:\"modal_forms\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:13:{s:4:\"name\";s:11:\"Modal forms\";s:11:\"description\";s:81:\"This module use ctools modal feature to open some common forms in a modal window.\";s:12:\"dependencies\";a:1:{i:0;s:6:\"ctools\";}s:4:\"core\";s:3:\"7.x\";s:9:\"configure\";s:36:\"admin/config/development/modal_forms\";s:7:\"version\";s:7:\"7.x-1.2\";s:7:\"project\";s:11:\"modal_forms\";s:9:\"datestamp\";s:10:\"1353326875\";s:5:\"mtime\";i:1499928385;s:7:\"package\";s:5:\"Other\";s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}}s:13:\"module_filter\";O:8:\"stdClass\":9:{s:8:\"filename\";s:52:\"sites/all/modules/module_filter/module_filter.module\";s:4:\"name\";s:13:\"module_filter\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:4:\"7201\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:13:{s:4:\"name\";s:13:\"Module filter\";s:11:\"description\";s:24:\"Filter the modules list.\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:14:\"Administration\";s:5:\"files\";a:9:{i:0;s:21:\"module_filter.install\";i:1;s:16:\"module_filter.js\";i:2;s:20:\"module_filter.module\";i:3;s:23:\"module_filter.admin.inc\";i:4;s:23:\"module_filter.theme.inc\";i:5;s:21:\"css/module_filter.css\";i:6;s:25:\"css/module_filter_tab.css\";i:7;s:19:\"js/module_filter.js\";i:8;s:23:\"js/module_filter_tab.js\";}s:9:\"configure\";s:40:\"admin/config/user-interface/modulefilter\";s:7:\"version\";s:7:\"7.x-2.0\";s:7:\"project\";s:13:\"module_filter\";s:9:\"datestamp\";s:10:\"1424631189\";s:5:\"mtime\";i:1499928385;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}}s:4:\"node\";O:8:\"stdClass\":9:{s:8:\"filename\";s:24:\"modules/node/node.module\";s:4:\"name\";s:4:\"node\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:4:\"7016\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:15:{s:4:\"name\";s:4:\"Node\";s:11:\"description\";s:66:\"Allows content to be submitted to the site and displayed on pages.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:2:{i:0;s:11:\"node.module\";i:1;s:9:\"node.test\";}s:8:\"required\";b:1;s:9:\"configure\";s:21:\"admin/structure/types\";s:11:\"stylesheets\";a:1:{s:3:\"all\";a:1:{s:8:\"node.css\";s:21:\"modules/node/node.css\";}}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}}s:10:\"node_class\";O:8:\"stdClass\":9:{s:8:\"filename\";s:46:\"sites/all/modules/node_class/node_class.module\";s:4:\"name\";s:10:\"node_class\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:12:{s:4:\"name\";s:10:\"Node Class\";s:11:\"description\";s:38:\"Allows assigning CSS classes to nodes.\";s:4:\"core\";s:3:\"7.x\";s:7:\"version\";s:7:\"7.x-1.3\";s:7:\"project\";s:10:\"node_class\";s:9:\"datestamp\";s:10:\"1388997876\";s:5:\"mtime\";i:1499928385;s:12:\"dependencies\";a:0:{}s:7:\"package\";s:5:\"Other\";s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}}s:6:\"number\";O:8:\"stdClass\":9:{s:8:\"filename\";s:42:\"modules/field/modules/number/number.module\";s:4:\"name\";s:6:\"number\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:12:{s:4:\"name\";s:6:\"Number\";s:11:\"description\";s:28:\"Defines numeric field types.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:1:{i:0;s:5:\"field\";}s:5:\"files\";a:1:{i:0;s:11:\"number.test\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}}s:7:\"options\";O:8:\"stdClass\":9:{s:8:\"filename\";s:44:\"modules/field/modules/options/options.module\";s:4:\"name\";s:7:\"options\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:12:{s:4:\"name\";s:7:\"Options\";s:11:\"description\";s:82:\"Defines selection, check box and radio button widgets for text and numeric fields.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:1:{i:0;s:5:\"field\";}s:5:\"files\";a:1:{i:0;s:12:\"options.test\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}}s:7:\"overlay\";O:8:\"stdClass\":9:{s:8:\"filename\";s:30:\"modules/overlay/overlay.module\";s:4:\"name\";s:7:\"overlay\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"1\";s:14:\"schema_version\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:12:{s:4:\"name\";s:7:\"Overlay\";s:11:\"description\";s:59:\"Displays the Drupal administration interface in an overlay.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}}s:4:\"path\";O:8:\"stdClass\":9:{s:8:\"filename\";s:24:\"modules/path/path.module\";s:4:\"name\";s:4:\"path\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:13:{s:4:\"name\";s:4:\"Path\";s:11:\"description\";s:28:\"Allows users to rename URLs.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:9:\"path.test\";}s:9:\"configure\";s:24:\"admin/config/search/path\";s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}}s:3:\"php\";O:8:\"stdClass\":9:{s:8:\"filename\";s:22:\"modules/php/php.module\";s:4:\"name\";s:3:\"php\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:12:{s:4:\"name\";s:10:\"PHP filter\";s:11:\"description\";s:50:\"Allows embedded PHP code/snippets to be evaluated.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:8:\"php.test\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}}s:9:\"quicktabs\";O:8:\"stdClass\":9:{s:8:\"filename\";s:44:\"sites/all/modules/quicktabs/quicktabs.module\";s:4:\"name\";s:9:\"quicktabs\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:4:\"7303\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:13:{s:4:\"name\";s:9:\"Quicktabs\";s:11:\"description\";s:49:\"Render content with tabs and other display styles\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:4:{i:0;s:16:\"quicktabs.module\";i:1;s:21:\"quicktabs.classes.inc\";i:2;s:35:\"includes/quicktabs_style_plugin.inc\";i:3;s:20:\"tests/quicktabs.test\";}s:9:\"configure\";s:25:\"admin/structure/quicktabs\";s:12:\"dependencies\";a:1:{i:0;s:6:\"ctools\";}s:7:\"version\";s:7:\"7.x-3.6\";s:7:\"project\";s:9:\"quicktabs\";s:9:\"datestamp\";s:10:\"1380731929\";s:5:\"mtime\";i:1499928385;s:7:\"package\";s:5:\"Other\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}}s:6:\"search\";O:8:\"stdClass\":9:{s:8:\"filename\";s:28:\"modules/search/search.module\";s:4:\"name\";s:6:\"search\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:4:\"7000\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:14:{s:4:\"name\";s:6:\"Search\";s:11:\"description\";s:36:\"Enables site-wide keyword searching.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:2:{i:0;s:19:\"search.extender.inc\";i:1;s:11:\"search.test\";}s:9:\"configure\";s:28:\"admin/config/search/settings\";s:11:\"stylesheets\";a:1:{s:3:\"all\";a:1:{s:10:\"search.css\";s:25:\"modules/search/search.css\";}}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}}s:9:\"sharethis\";O:8:\"stdClass\":9:{s:8:\"filename\";s:44:\"sites/all/modules/sharethis/sharethis.module\";s:4:\"name\";s:9:\"sharethis\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:4:\"7001\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:13:{s:4:\"name\";s:9:\"ShareThis\";s:11:\"description\";s:87:\"Add the <a href=\"http://www.sharethis.com/\">ShareThis</a> widget to nodes on your site.\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:7:\"Sharing\";s:9:\"configure\";s:31:\"admin/config/services/sharethis\";s:5:\"files\";a:1:{i:0;s:38:\"views/sharethis_handler_field_link.inc\";}s:7:\"version\";s:8:\"7.x-2.10\";s:7:\"project\";s:9:\"sharethis\";s:9:\"datestamp\";s:10:\"1422441977\";s:5:\"mtime\";i:1499928385;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}}s:9:\"shortcode\";O:8:\"stdClass\":9:{s:8:\"filename\";s:44:\"sites/all/modules/shortcode/shortcode.module\";s:4:\"name\";s:9:\"shortcode\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:12:{s:4:\"name\";s:9:\"Shortcode\";s:11:\"description\";s:65:\"Provides shortcodes filter framework and API (like WP shortcodes)\";s:7:\"package\";s:9:\"Shortcode\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:1:{i:0;s:6:\"filter\";}s:7:\"version\";s:7:\"7.x-2.2\";s:7:\"project\";s:9:\"shortcode\";s:9:\"datestamp\";s:10:\"1423035812\";s:5:\"mtime\";i:1499928385;s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}}s:20:\"shortcode_basic_tags\";O:8:\"stdClass\":9:{s:8:\"filename\";s:76:\"sites/all/modules/shortcode/shortcode_basic_tags/shortcode_basic_tags.module\";s:4:\"name\";s:20:\"shortcode_basic_tags\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:12:{s:4:\"name\";s:20:\"Shortcode Basic Tags\";s:11:\"description\";s:59:\"Provides basic shortcode tags like highlight, dropcap, etc.\";s:7:\"package\";s:9:\"Shortcode\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:1:{i:0;s:9:\"shortcode\";}s:7:\"version\";s:7:\"7.x-2.2\";s:7:\"project\";s:9:\"shortcode\";s:9:\"datestamp\";s:10:\"1423035812\";s:5:\"mtime\";i:1499928385;s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}}s:23:\"shortcode_embed_content\";O:8:\"stdClass\":9:{s:8:\"filename\";s:82:\"sites/all/modules/shortcode/shortcode_embed_content/shortcode_embed_content.module\";s:4:\"name\";s:23:\"shortcode_embed_content\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:12:{s:4:\"name\";s:27:\"Shortcode Embed Content Tag\";s:11:\"description\";s:64:\"Provides a shortcode tag for embedding a node content into text.\";s:7:\"package\";s:9:\"Shortcode\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:2:{i:0;s:6:\"filter\";i:1;s:9:\"shortcode\";}s:7:\"version\";s:7:\"7.x-2.2\";s:7:\"project\";s:9:\"shortcode\";s:9:\"datestamp\";s:10:\"1423035812\";s:5:\"mtime\";i:1499928385;s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}}s:15:\"shortcode_video\";O:8:\"stdClass\":9:{s:8:\"filename\";s:66:\"sites/all/modules/shortcode/shortcode_video/shortcode_video.module\";s:4:\"name\";s:15:\"shortcode_video\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:12:{s:4:\"name\";s:21:\"Shortcode Video Macro\";s:11:\"description\";s:68:\"Provides easy video embedding to contents. Supports YouTube sharing.\";s:7:\"package\";s:9:\"Shortcode\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:2:{i:0;s:6:\"filter\";i:1;s:9:\"shortcode\";}s:7:\"version\";s:7:\"7.x-2.2\";s:7:\"project\";s:9:\"shortcode\";s:9:\"datestamp\";s:10:\"1423035812\";s:5:\"mtime\";i:1499928385;s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}}s:8:\"shortcut\";O:8:\"stdClass\":9:{s:8:\"filename\";s:32:\"modules/shortcut/shortcut.module\";s:4:\"name\";s:8:\"shortcut\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:13:{s:4:\"name\";s:8:\"Shortcut\";s:11:\"description\";s:60:\"Allows users to manage customizable lists of shortcut links.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:13:\"shortcut.test\";}s:9:\"configure\";s:36:\"admin/config/user-interface/shortcut\";s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}}s:10:\"statistics\";O:8:\"stdClass\":9:{s:8:\"filename\";s:36:\"modules/statistics/statistics.module\";s:4:\"name\";s:10:\"statistics\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"1\";s:14:\"schema_version\";s:4:\"7000\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:13:{s:4:\"name\";s:10:\"Statistics\";s:11:\"description\";s:37:\"Logs access statistics for your site.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:15:\"statistics.test\";}s:9:\"configure\";s:30:\"admin/config/system/statistics\";s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}}s:6:\"system\";O:8:\"stdClass\":9:{s:8:\"filename\";s:28:\"modules/system/system.module\";s:4:\"name\";s:6:\"system\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"1\";s:14:\"schema_version\";s:4:\"7081\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:14:{s:4:\"name\";s:6:\"System\";s:11:\"description\";s:54:\"Handles general site configuration for administrators.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:6:{i:0;s:19:\"system.archiver.inc\";i:1;s:15:\"system.mail.inc\";i:2;s:16:\"system.queue.inc\";i:3;s:14:\"system.tar.inc\";i:4;s:18:\"system.updater.inc\";i:5;s:11:\"system.test\";}s:8:\"required\";b:1;s:9:\"configure\";s:19:\"admin/config/system\";s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}}s:9:\"tagclouds\";O:8:\"stdClass\":9:{s:8:\"filename\";s:44:\"sites/all/modules/tagclouds/tagclouds.module\";s:4:\"name\";s:9:\"tagclouds\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:13:{s:4:\"name\";s:9:\"TagClouds\";s:11:\"description\";s:61:\"TagClouds makes weighted tag clouds from your taxonomy terms.\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:1:{i:0;s:8:\"taxonomy\";}s:7:\"package\";s:8:\"Taxonomy\";s:9:\"configure\";s:30:\"admin/config/content/tagclouds\";s:7:\"version\";s:8:\"7.x-1.10\";s:7:\"project\";s:9:\"tagclouds\";s:9:\"datestamp\";s:10:\"1404152332\";s:5:\"mtime\";i:1499928385;s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}}s:8:\"taxonomy\";O:8:\"stdClass\":9:{s:8:\"filename\";s:32:\"modules/taxonomy/taxonomy.module\";s:4:\"name\";s:8:\"taxonomy\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:4:\"7011\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:15:{s:4:\"name\";s:8:\"Taxonomy\";s:11:\"description\";s:38:\"Enables the categorization of content.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:1:{i:0;s:7:\"options\";}s:5:\"files\";a:2:{i:0;s:15:\"taxonomy.module\";i:1;s:13:\"taxonomy.test\";}s:9:\"configure\";s:24:\"admin/structure/taxonomy\";s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;s:8:\"required\";b:1;s:11:\"explanation\";s:76:\"Field type(s) in use - see <a href=\"/en/admin/reports/fields\">Field list</a>\";}}s:13:\"taxonomy_menu\";O:8:\"stdClass\":9:{s:8:\"filename\";s:52:\"sites/all/modules/taxonomy_menu/taxonomy_menu.module\";s:4:\"name\";s:13:\"taxonomy_menu\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:4:\"7000\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:12:{s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:2:{i:0;s:8:\"taxonomy\";i:1;s:4:\"menu\";}s:11:\"description\";s:39:\"Adds links to taxonomy terms to a menu.\";s:4:\"name\";s:13:\"Taxonomy menu\";s:7:\"package\";s:13:\"Taxonomy menu\";s:5:\"files\";a:5:{i:0;s:23:\"taxonomy_menu.batch.inc\";i:1;s:26:\"taxonomy_menu.database.inc\";i:2;s:20:\"taxonomy_menu.module\";i:3;s:18:\"taxonomy_menu.test\";i:4;s:21:\"taxonomy_menu.install\";}s:7:\"version\";s:7:\"7.x-1.5\";s:7:\"project\";s:13:\"taxonomy_menu\";s:9:\"datestamp\";s:10:\"1396359247\";s:5:\"mtime\";i:1499928385;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}}s:4:\"text\";O:8:\"stdClass\":9:{s:8:\"filename\";s:38:\"modules/field/modules/text/text.module\";s:4:\"name\";s:4:\"text\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:4:\"7000\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:14:{s:4:\"name\";s:4:\"Text\";s:11:\"description\";s:32:\"Defines simple text field types.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:1:{i:0;s:5:\"field\";}s:5:\"files\";a:1:{i:0;s:9:\"text.test\";}s:8:\"required\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;s:11:\"explanation\";s:76:\"Field type(s) in use - see <a href=\"/en/admin/reports/fields\">Field list</a>\";}}s:5:\"token\";O:8:\"stdClass\":9:{s:8:\"filename\";s:36:\"sites/all/modules/token/token.module\";s:4:\"name\";s:5:\"token\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:4:\"7001\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:12:{s:4:\"name\";s:5:\"Token\";s:11:\"description\";s:73:\"Provides a user interface for the Token API and some missing core tokens.\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:10:\"token.test\";}s:7:\"version\";s:7:\"7.x-1.6\";s:7:\"project\";s:5:\"token\";s:9:\"datestamp\";s:10:\"1425149060\";s:5:\"mtime\";i:1499928385;s:12:\"dependencies\";a:0:{}s:7:\"package\";s:5:\"Other\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}}s:12:\"token_custom\";O:8:\"stdClass\":9:{s:8:\"filename\";s:50:\"sites/all/modules/token_custom/token_custom.module\";s:4:\"name\";s:12:\"token_custom\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:4:\"7002\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:13:{s:4:\"name\";s:13:\"Custom tokens\";s:11:\"description\";s:61:\"Allow users to define custom tokens to use thoughout the site\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:1:{i:0;s:6:\"filter\";}s:9:\"configure\";s:28:\"admin/structure/token-custom\";s:7:\"version\";s:13:\"7.x-2.0-beta3\";s:7:\"project\";s:12:\"token_custom\";s:9:\"datestamp\";s:10:\"1348426268\";s:5:\"mtime\";i:1499928385;s:7:\"package\";s:5:\"Other\";s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}}s:6:\"update\";O:8:\"stdClass\":9:{s:8:\"filename\";s:28:\"modules/update/update.module\";s:4:\"name\";s:6:\"update\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:4:\"7001\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:13:{s:4:\"name\";s:14:\"Update manager\";s:11:\"description\";s:104:\"Checks for available updates, and can securely install or update modules and themes via a web interface.\";s:7:\"version\";s:4:\"7.56\";s:7:\"package\";s:4:\"Core\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:11:\"update.test\";}s:9:\"configure\";s:30:\"admin/reports/updates/settings\";s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}}s:4:\"user\";O:8:\"stdClass\":9:{s:8:\"filename\";s:24:\"modules/user/user.module\";s:4:\"name\";s:4:\"user\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:4:\"7019\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:15:{s:4:\"name\";s:4:\"User\";s:11:\"description\";s:47:\"Manages the user registration and login system.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:2:{i:0;s:11:\"user.module\";i:1;s:9:\"user.test\";}s:8:\"required\";b:1;s:9:\"configure\";s:19:\"admin/config/people\";s:11:\"stylesheets\";a:1:{s:3:\"all\";a:1:{s:8:\"user.css\";s:21:\"modules/user/user.css\";}}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}}s:8:\"variable\";O:8:\"stdClass\":9:{s:8:\"filename\";s:42:\"sites/all/modules/variable/variable.module\";s:4:\"name\";s:8:\"variable\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"1\";s:14:\"schema_version\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:12:{s:4:\"name\";s:8:\"Variable\";s:11:\"description\";s:43:\"Variable Information and basic variable API\";s:7:\"package\";s:8:\"Variable\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:9:{i:0;s:27:\"includes/forum.variable.inc\";i:1;s:28:\"includes/locale.variable.inc\";i:2;s:26:\"includes/menu.variable.inc\";i:3;s:26:\"includes/node.variable.inc\";i:4;s:28:\"includes/system.variable.inc\";i:5;s:30:\"includes/taxonomy.variable.inc\";i:6;s:33:\"includes/translation.variable.inc\";i:7;s:26:\"includes/user.variable.inc\";i:8;s:13:\"variable.test\";}s:7:\"version\";s:7:\"7.x-2.5\";s:7:\"project\";s:8:\"variable\";s:9:\"datestamp\";s:10:\"1398250128\";s:5:\"mtime\";i:1499928385;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}}s:17:\"video_embed_field\";O:8:\"stdClass\":9:{s:8:\"filename\";s:60:\"sites/all/modules/video_embed_field/video_embed_field.module\";s:4:\"name\";s:17:\"video_embed_field\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:4:\"7010\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:15:{s:4:\"name\";s:17:\"Video Embed Field\";s:11:\"description\";s:63:\"Expose a field type for embedding videos from youtube or vimeo.\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:5:\"Media\";s:9:\"configure\";s:22:\"admin/config/media/vef\";s:5:\"files\";a:2:{i:0;s:29:\"video_embed_field.migrate.inc\";i:1;s:71:\"views/handlers/views_embed_field_views_handler_field_thumbnail_path.inc\";}s:12:\"dependencies\";a:2:{i:0;s:6:\"ctools\";i:1;s:5:\"image\";}s:7:\"version\";s:14:\"7.x-2.0-beta11\";s:7:\"project\";s:17:\"video_embed_field\";s:9:\"datestamp\";s:10:\"1441639440\";s:5:\"mtime\";i:1499928385;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;s:8:\"required\";b:1;s:11:\"explanation\";s:76:\"Field type(s) in use - see <a href=\"/en/admin/reports/fields\">Field list</a>\";}}s:15:\"views_fieldsets\";O:8:\"stdClass\":9:{s:8:\"filename\";s:56:\"sites/all/modules/views_fieldsets/views_fieldsets.module\";s:4:\"name\";s:15:\"views_fieldsets\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:12:{s:4:\"name\";s:15:\"Views fieldsets\";s:11:\"description\";s:44:\"Output several Views fields into a fieldset.\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:5:\"Views\";s:12:\"dependencies\";a:1:{i:0;s:5:\"views\";}s:5:\"files\";a:1:{i:0;s:48:\"views/views_fieldsets_fieldset_field_handler.inc\";}s:7:\"version\";s:7:\"7.x-1.3\";s:7:\"project\";s:15:\"views_fieldsets\";s:9:\"datestamp\";s:10:\"1425515886\";s:5:\"mtime\";i:1499928385;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}}s:15:\"views_slideshow\";O:8:\"stdClass\":9:{s:8:\"filename\";s:56:\"sites/all/modules/views_slideshow/views_slideshow.module\";s:4:\"name\";s:15:\"views_slideshow\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:12:{s:4:\"name\";s:15:\"Views Slideshow\";s:11:\"description\";s:155:\"Provides a View style that displays rows as a jQuery slideshow.  This is an API and requires Views Slideshow Cycle or another module that supports the API.\";s:12:\"dependencies\";a:1:{i:0;s:13:\"views (>=3.0)\";}s:7:\"package\";s:5:\"Views\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:4:{i:0;s:22:\"views_slideshow.module\";i:1;s:31:\"theme/views_slideshow.theme.inc\";i:2;s:25:\"views_slideshow.views.inc\";i:3;s:42:\"views_slideshow_plugin_style_slideshow.inc\";}s:7:\"version\";s:7:\"7.x-3.1\";s:7:\"project\";s:15:\"views_slideshow\";s:9:\"datestamp\";s:10:\"1382584826\";s:5:\"mtime\";i:1499928385;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}}s:21:\"views_slideshow_cycle\";O:8:\"stdClass\":9:{s:8:\"filename\";s:92:\"sites/all/modules/views_slideshow/contrib/views_slideshow_cycle/views_slideshow_cycle.module\";s:4:\"name\";s:21:\"views_slideshow_cycle\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:12:{s:4:\"name\";s:22:\"Views Slideshow: Cycle\";s:11:\"description\";s:50:\"Adds a Rotating slideshow mode to Views Slideshow.\";s:12:\"dependencies\";a:2:{i:0;s:15:\"views_slideshow\";i:1;s:9:\"libraries\";}s:7:\"package\";s:5:\"Views\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:3:{i:0;s:28:\"views_slideshow_cycle.module\";i:1;s:41:\"views_slideshow_cycle.views_slideshow.inc\";i:2;s:37:\"theme/views_slideshow_cycle.theme.inc\";}s:7:\"version\";s:7:\"7.x-3.1\";s:7:\"project\";s:15:\"views_slideshow\";s:9:\"datestamp\";s:10:\"1382584826\";s:5:\"mtime\";i:1499928385;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}}s:8:\"views_ui\";O:8:\"stdClass\":9:{s:8:\"filename\";s:39:\"sites/all/modules/views/views_ui.module\";s:4:\"name\";s:8:\"views_ui\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:13:{s:4:\"name\";s:8:\"Views UI\";s:11:\"description\";s:93:\"Administrative interface to views. Without this module, you cannot create or edit your views.\";s:7:\"package\";s:5:\"Views\";s:4:\"core\";s:3:\"7.x\";s:9:\"configure\";s:21:\"admin/structure/views\";s:12:\"dependencies\";a:1:{i:0;s:5:\"views\";}s:5:\"files\";a:2:{i:0;s:15:\"views_ui.module\";i:1;s:57:\"plugins/views_wizard/views_ui_base_views_wizard.class.php\";}s:7:\"version\";s:8:\"7.x-3.16\";s:7:\"project\";s:5:\"views\";s:9:\"datestamp\";s:10:\"1491158591\";s:5:\"mtime\";i:1491158591;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}}s:9:\"votingapi\";O:8:\"stdClass\":9:{s:8:\"filename\";s:44:\"sites/all/modules/votingapi/votingapi.module\";s:4:\"name\";s:9:\"votingapi\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:4:\"7203\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:13:{s:4:\"name\";s:10:\"Voting API\";s:11:\"description\";s:47:\"Provides a shared voting API for other modules.\";s:7:\"package\";s:6:\"Voting\";s:4:\"core\";s:3:\"7.x\";s:9:\"configure\";s:29:\"admin/config/search/votingapi\";s:5:\"files\";a:4:{i:0;s:20:\"tests/votingapi.test\";i:1;s:45:\"views/votingapi_views_handler_field_value.inc\";i:2;s:47:\"views/votingapi_views_handler_sort_nullable.inc\";i:3;s:46:\"views/votingapi_views_handler_relationship.inc\";}s:7:\"version\";s:8:\"7.x-2.12\";s:7:\"project\";s:9:\"votingapi\";s:9:\"datestamp\";s:10:\"1407995929\";s:5:\"mtime\";i:1499928385;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}}s:13:\"webform_hints\";O:8:\"stdClass\":9:{s:8:\"filename\";s:52:\"sites/all/modules/webform_hints/webform_hints.module\";s:4:\"name\";s:13:\"webform_hints\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:13:{s:4:\"name\";s:13:\"Webform Hints\";s:11:\"description\";s:93:\"Turns field labels into placeholder hints on Webform textareas, textfields, and email fields.\";s:7:\"package\";s:7:\"Webform\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:2:{i:0;s:7:\"webform\";i:1;s:17:\"libraries (>=2.x)\";}s:9:\"configure\";s:34:\"admin/config/content/webform-hints\";s:7:\"version\";s:7:\"7.x-1.5\";s:7:\"project\";s:13:\"webform_hints\";s:9:\"datestamp\";s:10:\"1407952128\";s:5:\"mtime\";i:1499928385;s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}}s:13:\"wee_shortcode\";O:8:\"stdClass\":9:{s:8:\"filename\";s:52:\"sites/all/modules/wee_shortcode/wee_shortcode.module\";s:4:\"name\";s:13:\"wee_shortcode\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:10:{s:4:\"name\";s:29:\"Extra Shortcode For Bootstrap\";s:11:\"description\";s:41:\"Provides bootstrap component to contents.\";s:7:\"package\";s:9:\"Shortcode\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:1:{i:0;s:9:\"shortcode\";}s:5:\"mtime\";i:1499928385;s:7:\"version\";N;s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}}s:20:\"we_content_migration\";O:8:\"stdClass\":9:{s:8:\"filename\";s:66:\"sites/all/modules/we_content_migration/we_content_migration.module\";s:4:\"name\";s:20:\"we_content_migration\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:12:{s:4:\"name\";s:17:\"Content Migration\";s:11:\"description\";s:29:\"Migrate Content for Drupal 7.\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:17:\"Content Migration\";s:7:\"version\";s:11:\"7.x-1.x-dev\";s:7:\"project\";s:20:\"we_content_migration\";s:9:\"datestamp\";s:10:\"1499677744\";s:5:\"mtime\";i:1499652544;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}}s:11:\"field_group\";O:8:\"stdClass\":9:{s:8:\"filename\";s:48:\"sites/all/modules/field_group/field_group.module\";s:4:\"name\";s:11:\"field_group\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:4:\"7008\";s:6:\"weight\";s:1:\"1\";s:4:\"info\";a:12:{s:4:\"name\";s:11:\"Field Group\";s:11:\"description\";s:67:\"Provides the ability to group your fields on both form and display.\";s:7:\"package\";s:6:\"Fields\";s:12:\"dependencies\";a:2:{i:0;s:5:\"field\";i:1;s:6:\"ctools\";}s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:2:{i:0;s:25:\"tests/field_group.ui.test\";i:1;s:30:\"tests/field_group.display.test\";}s:7:\"version\";s:7:\"7.x-1.5\";s:7:\"project\";s:11:\"field_group\";s:9:\"datestamp\";s:10:\"1452033709\";s:5:\"mtime\";i:1452033709;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}}s:5:\"forum\";O:8:\"stdClass\":9:{s:8:\"filename\";s:26:\"modules/forum/forum.module\";s:4:\"name\";s:5:\"forum\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:4:\"7012\";s:6:\"weight\";s:1:\"1\";s:4:\"info\";a:14:{s:4:\"name\";s:5:\"Forum\";s:11:\"description\";s:27:\"Provides discussion forums.\";s:12:\"dependencies\";a:2:{i:0;s:8:\"taxonomy\";i:1;s:7:\"comment\";}s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:10:\"forum.test\";}s:9:\"configure\";s:21:\"admin/structure/forum\";s:11:\"stylesheets\";a:1:{s:3:\"all\";a:1:{s:9:\"forum.css\";s:23:\"modules/forum/forum.css\";}}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}}s:8:\"pathauto\";O:8:\"stdClass\":9:{s:8:\"filename\";s:42:\"sites/all/modules/pathauto/pathauto.module\";s:4:\"name\";s:8:\"pathauto\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:4:\"7005\";s:6:\"weight\";s:1:\"1\";s:4:\"info\";a:14:{s:4:\"name\";s:8:\"Pathauto\";s:11:\"description\";s:95:\"Provides a mechanism for modules to automatically generate aliases for the content they manage.\";s:12:\"dependencies\";a:2:{i:0;s:4:\"path\";i:1;s:5:\"token\";}s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:13:\"pathauto.test\";}s:9:\"configure\";s:33:\"admin/config/search/path/patterns\";s:10:\"recommends\";a:1:{i:0;s:8:\"redirect\";}s:7:\"version\";s:7:\"7.x-1.2\";s:7:\"project\";s:8:\"pathauto\";s:9:\"datestamp\";s:10:\"1344525185\";s:5:\"mtime\";i:1499928385;s:7:\"package\";s:5:\"Other\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}}s:13:\"i18n_taxonomy\";O:8:\"stdClass\":9:{s:8:\"filename\";s:57:\"sites/all/modules/i18n/i18n_taxonomy/i18n_taxonomy.module\";s:4:\"name\";s:13:\"i18n_taxonomy\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:4:\"7004\";s:6:\"weight\";s:1:\"5\";s:4:\"info\";a:12:{s:4:\"name\";s:20:\"Taxonomy translation\";s:11:\"description\";s:30:\"Enables multilingual taxonomy.\";s:12:\"dependencies\";a:3:{i:0;s:8:\"taxonomy\";i:1;s:11:\"i18n_string\";i:2;s:16:\"i18n_translation\";}s:7:\"package\";s:35:\"Multilingual - Internationalization\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:4:{i:0;s:17:\"i18n_taxonomy.inc\";i:1;s:23:\"i18n_taxonomy.pages.inc\";i:2;s:23:\"i18n_taxonomy.admin.inc\";i:3;s:18:\"i18n_taxonomy.test\";}s:7:\"version\";s:8:\"7.x-1.13\";s:7:\"project\";s:4:\"i18n\";s:9:\"datestamp\";s:10:\"1430999922\";s:5:\"mtime\";i:1499928385;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}}s:4:\"i18n\";O:8:\"stdClass\":9:{s:8:\"filename\";s:34:\"sites/all/modules/i18n/i18n.module\";s:4:\"name\";s:4:\"i18n\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"1\";s:14:\"schema_version\";s:4:\"7001\";s:6:\"weight\";s:2:\"10\";s:4:\"info\";a:13:{s:4:\"name\";s:20:\"Internationalization\";s:11:\"description\";s:49:\"Extends Drupal support for multilingual features.\";s:12:\"dependencies\";a:2:{i:0;s:6:\"locale\";i:1;s:8:\"variable\";}s:7:\"package\";s:35:\"Multilingual - Internationalization\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:2:{i:0;s:15:\"i18n_object.inc\";i:1;s:9:\"i18n.test\";}s:9:\"configure\";s:26:\"admin/config/regional/i18n\";s:7:\"version\";s:8:\"7.x-1.13\";s:7:\"project\";s:4:\"i18n\";s:9:\"datestamp\";s:10:\"1430999922\";s:5:\"mtime\";i:1499928385;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}}s:11:\"i18n_string\";O:8:\"stdClass\":9:{s:8:\"filename\";s:53:\"sites/all/modules/i18n/i18n_string/i18n_string.module\";s:4:\"name\";s:11:\"i18n_string\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:4:\"7002\";s:6:\"weight\";s:2:\"10\";s:4:\"info\";a:13:{s:4:\"name\";s:18:\"String translation\";s:11:\"description\";s:57:\"Provides support for translation of user defined strings.\";s:12:\"dependencies\";a:2:{i:0;s:6:\"locale\";i:1;s:4:\"i18n\";}s:7:\"package\";s:35:\"Multilingual - Internationalization\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:3:{i:0;s:21:\"i18n_string.admin.inc\";i:1;s:15:\"i18n_string.inc\";i:2;s:16:\"i18n_string.test\";}s:9:\"configure\";s:34:\"admin/config/regional/i18n/strings\";s:7:\"version\";s:8:\"7.x-1.13\";s:7:\"project\";s:4:\"i18n\";s:9:\"datestamp\";s:10:\"1430999922\";s:5:\"mtime\";i:1499928385;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}}s:5:\"views\";O:8:\"stdClass\":9:{s:8:\"filename\";s:36:\"sites/all/modules/views/views.module\";s:4:\"name\";s:5:\"views\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:4:\"7302\";s:6:\"weight\";s:2:\"10\";s:4:\"info\";a:13:{s:4:\"name\";s:5:\"Views\";s:11:\"description\";s:55:\"Create customized lists and queries from your database.\";s:7:\"package\";s:5:\"Views\";s:4:\"core\";s:3:\"7.x\";s:11:\"stylesheets\";a:1:{s:3:\"all\";a:1:{s:13:\"css/views.css\";s:37:\"sites/all/modules/views/css/views.css\";}}s:12:\"dependencies\";a:1:{i:0;s:6:\"ctools\";}s:5:\"files\";a:313:{i:0;s:31:\"handlers/views_handler_area.inc\";i:1;s:40:\"handlers/views_handler_area_messages.inc\";i:2;s:38:\"handlers/views_handler_area_result.inc\";i:3;s:36:\"handlers/views_handler_area_text.inc\";i:4;s:43:\"handlers/views_handler_area_text_custom.inc\";i:5;s:36:\"handlers/views_handler_area_view.inc\";i:6;s:35:\"handlers/views_handler_argument.inc\";i:7;s:40:\"handlers/views_handler_argument_date.inc\";i:8;s:43:\"handlers/views_handler_argument_formula.inc\";i:9;s:47:\"handlers/views_handler_argument_many_to_one.inc\";i:10;s:40:\"handlers/views_handler_argument_null.inc\";i:11;s:43:\"handlers/views_handler_argument_numeric.inc\";i:12;s:42:\"handlers/views_handler_argument_string.inc\";i:13;s:52:\"handlers/views_handler_argument_group_by_numeric.inc\";i:14;s:32:\"handlers/views_handler_field.inc\";i:15;s:40:\"handlers/views_handler_field_counter.inc\";i:16;s:40:\"handlers/views_handler_field_boolean.inc\";i:17;s:49:\"handlers/views_handler_field_contextual_links.inc\";i:18;s:48:\"handlers/views_handler_field_ctools_dropdown.inc\";i:19;s:39:\"handlers/views_handler_field_custom.inc\";i:20;s:37:\"handlers/views_handler_field_date.inc\";i:21;s:39:\"handlers/views_handler_field_entity.inc\";i:22;s:38:\"handlers/views_handler_field_links.inc\";i:23;s:39:\"handlers/views_handler_field_markup.inc\";i:24;s:37:\"handlers/views_handler_field_math.inc\";i:25;s:40:\"handlers/views_handler_field_numeric.inc\";i:26;s:47:\"handlers/views_handler_field_prerender_list.inc\";i:27;s:46:\"handlers/views_handler_field_time_interval.inc\";i:28;s:43:\"handlers/views_handler_field_serialized.inc\";i:29;s:45:\"handlers/views_handler_field_machine_name.inc\";i:30;s:36:\"handlers/views_handler_field_url.inc\";i:31;s:33:\"handlers/views_handler_filter.inc\";i:32;s:50:\"handlers/views_handler_filter_boolean_operator.inc\";i:33;s:57:\"handlers/views_handler_filter_boolean_operator_string.inc\";i:34;s:41:\"handlers/views_handler_filter_combine.inc\";i:35;s:38:\"handlers/views_handler_filter_date.inc\";i:36;s:42:\"handlers/views_handler_filter_equality.inc\";i:37;s:47:\"handlers/views_handler_filter_entity_bundle.inc\";i:38;s:50:\"handlers/views_handler_filter_group_by_numeric.inc\";i:39;s:45:\"handlers/views_handler_filter_in_operator.inc\";i:40;s:45:\"handlers/views_handler_filter_many_to_one.inc\";i:41;s:41:\"handlers/views_handler_filter_numeric.inc\";i:42;s:40:\"handlers/views_handler_filter_string.inc\";i:43;s:48:\"handlers/views_handler_filter_fields_compare.inc\";i:44;s:39:\"handlers/views_handler_relationship.inc\";i:45;s:53:\"handlers/views_handler_relationship_groupwise_max.inc\";i:46;s:31:\"handlers/views_handler_sort.inc\";i:47;s:36:\"handlers/views_handler_sort_date.inc\";i:48;s:39:\"handlers/views_handler_sort_formula.inc\";i:49;s:48:\"handlers/views_handler_sort_group_by_numeric.inc\";i:50;s:46:\"handlers/views_handler_sort_menu_hierarchy.inc\";i:51;s:38:\"handlers/views_handler_sort_random.inc\";i:52;s:17:\"includes/base.inc\";i:53;s:21:\"includes/handlers.inc\";i:54;s:20:\"includes/plugins.inc\";i:55;s:17:\"includes/view.inc\";i:56;s:60:\"modules/aggregator/views_handler_argument_aggregator_fid.inc\";i:57;s:60:\"modules/aggregator/views_handler_argument_aggregator_iid.inc\";i:58;s:69:\"modules/aggregator/views_handler_argument_aggregator_category_cid.inc\";i:59;s:64:\"modules/aggregator/views_handler_field_aggregator_title_link.inc\";i:60;s:62:\"modules/aggregator/views_handler_field_aggregator_category.inc\";i:61;s:70:\"modules/aggregator/views_handler_field_aggregator_item_description.inc\";i:62;s:57:\"modules/aggregator/views_handler_field_aggregator_xss.inc\";i:63;s:67:\"modules/aggregator/views_handler_filter_aggregator_category_cid.inc\";i:64;s:54:\"modules/aggregator/views_plugin_row_aggregator_rss.inc\";i:65;s:56:\"modules/book/views_plugin_argument_default_book_root.inc\";i:66;s:59:\"modules/comment/views_handler_argument_comment_user_uid.inc\";i:67;s:47:\"modules/comment/views_handler_field_comment.inc\";i:68;s:53:\"modules/comment/views_handler_field_comment_depth.inc\";i:69;s:52:\"modules/comment/views_handler_field_comment_link.inc\";i:70;s:60:\"modules/comment/views_handler_field_comment_link_approve.inc\";i:71;s:59:\"modules/comment/views_handler_field_comment_link_delete.inc\";i:72;s:57:\"modules/comment/views_handler_field_comment_link_edit.inc\";i:73;s:58:\"modules/comment/views_handler_field_comment_link_reply.inc\";i:74;s:57:\"modules/comment/views_handler_field_comment_node_link.inc\";i:75;s:56:\"modules/comment/views_handler_field_comment_username.inc\";i:76;s:61:\"modules/comment/views_handler_field_ncs_last_comment_name.inc\";i:77;s:56:\"modules/comment/views_handler_field_ncs_last_updated.inc\";i:78;s:52:\"modules/comment/views_handler_field_node_comment.inc\";i:79;s:57:\"modules/comment/views_handler_field_node_new_comments.inc\";i:80;s:62:\"modules/comment/views_handler_field_last_comment_timestamp.inc\";i:81;s:57:\"modules/comment/views_handler_filter_comment_user_uid.inc\";i:82;s:57:\"modules/comment/views_handler_filter_ncs_last_updated.inc\";i:83;s:53:\"modules/comment/views_handler_filter_node_comment.inc\";i:84;s:53:\"modules/comment/views_handler_sort_comment_thread.inc\";i:85;s:60:\"modules/comment/views_handler_sort_ncs_last_comment_name.inc\";i:86;s:55:\"modules/comment/views_handler_sort_ncs_last_updated.inc\";i:87;s:48:\"modules/comment/views_plugin_row_comment_rss.inc\";i:88;s:49:\"modules/comment/views_plugin_row_comment_view.inc\";i:89;s:52:\"modules/contact/views_handler_field_contact_link.inc\";i:90;s:43:\"modules/field/views_handler_field_field.inc\";i:91;s:59:\"modules/field/views_handler_relationship_entity_reverse.inc\";i:92;s:51:\"modules/field/views_handler_argument_field_list.inc\";i:93;s:57:\"modules/field/views_handler_filter_field_list_boolean.inc\";i:94;s:58:\"modules/field/views_handler_argument_field_list_string.inc\";i:95;s:49:\"modules/field/views_handler_filter_field_list.inc\";i:96;s:57:\"modules/filter/views_handler_field_filter_format_name.inc\";i:97;s:52:\"modules/locale/views_handler_field_node_language.inc\";i:98;s:53:\"modules/locale/views_handler_filter_node_language.inc\";i:99;s:54:\"modules/locale/views_handler_argument_locale_group.inc\";i:100;s:57:\"modules/locale/views_handler_argument_locale_language.inc\";i:101;s:51:\"modules/locale/views_handler_field_locale_group.inc\";i:102;s:54:\"modules/locale/views_handler_field_locale_language.inc\";i:103;s:55:\"modules/locale/views_handler_field_locale_link_edit.inc\";i:104;s:52:\"modules/locale/views_handler_filter_locale_group.inc\";i:105;s:55:\"modules/locale/views_handler_filter_locale_language.inc\";i:106;s:54:\"modules/locale/views_handler_filter_locale_version.inc\";i:107;s:51:\"modules/locale/views_handler_sort_node_language.inc\";i:108;s:53:\"modules/node/views_handler_argument_dates_various.inc\";i:109;s:53:\"modules/node/views_handler_argument_node_language.inc\";i:110;s:48:\"modules/node/views_handler_argument_node_nid.inc\";i:111;s:49:\"modules/node/views_handler_argument_node_type.inc\";i:112;s:48:\"modules/node/views_handler_argument_node_vid.inc\";i:113;s:57:\"modules/node/views_handler_argument_node_uid_revision.inc\";i:114;s:59:\"modules/node/views_handler_field_history_user_timestamp.inc\";i:115;s:41:\"modules/node/views_handler_field_node.inc\";i:116;s:46:\"modules/node/views_handler_field_node_link.inc\";i:117;s:53:\"modules/node/views_handler_field_node_link_delete.inc\";i:118;s:51:\"modules/node/views_handler_field_node_link_edit.inc\";i:119;s:50:\"modules/node/views_handler_field_node_revision.inc\";i:120;s:55:\"modules/node/views_handler_field_node_revision_link.inc\";i:121;s:62:\"modules/node/views_handler_field_node_revision_link_delete.inc\";i:122;s:62:\"modules/node/views_handler_field_node_revision_link_revert.inc\";i:123;s:46:\"modules/node/views_handler_field_node_path.inc\";i:124;s:46:\"modules/node/views_handler_field_node_type.inc\";i:125;s:55:\"modules/node/views_handler_field_node_version_count.inc\";i:126;s:60:\"modules/node/views_handler_filter_history_user_timestamp.inc\";i:127;s:49:\"modules/node/views_handler_filter_node_access.inc\";i:128;s:49:\"modules/node/views_handler_filter_node_status.inc\";i:129;s:47:\"modules/node/views_handler_filter_node_type.inc\";i:130;s:55:\"modules/node/views_handler_filter_node_uid_revision.inc\";i:131;s:56:\"modules/node/views_handler_filter_node_version_count.inc\";i:132;s:54:\"modules/node/views_handler_sort_node_version_count.inc\";i:133;s:51:\"modules/node/views_plugin_argument_default_node.inc\";i:134;s:52:\"modules/node/views_plugin_argument_validate_node.inc\";i:135;s:42:\"modules/node/views_plugin_row_node_rss.inc\";i:136;s:43:\"modules/node/views_plugin_row_node_view.inc\";i:137;s:52:\"modules/profile/views_handler_field_profile_date.inc\";i:138;s:52:\"modules/profile/views_handler_field_profile_list.inc\";i:139;s:58:\"modules/profile/views_handler_filter_profile_selection.inc\";i:140;s:48:\"modules/search/views_handler_argument_search.inc\";i:141;s:51:\"modules/search/views_handler_field_search_score.inc\";i:142;s:46:\"modules/search/views_handler_filter_search.inc\";i:143;s:50:\"modules/search/views_handler_sort_search_score.inc\";i:144;s:47:\"modules/search/views_plugin_row_search_view.inc\";i:145;s:57:\"modules/statistics/views_handler_field_accesslog_path.inc\";i:146;s:65:\"modules/statistics/views_handler_field_node_counter_timestamp.inc\";i:147;s:61:\"modules/statistics/views_handler_field_statistics_numeric.inc\";i:148;s:50:\"modules/system/views_handler_argument_file_fid.inc\";i:149;s:43:\"modules/system/views_handler_field_file.inc\";i:150;s:53:\"modules/system/views_handler_field_file_extension.inc\";i:151;s:52:\"modules/system/views_handler_field_file_filemime.inc\";i:152;s:47:\"modules/system/views_handler_field_file_uri.inc\";i:153;s:50:\"modules/system/views_handler_field_file_status.inc\";i:154;s:51:\"modules/system/views_handler_filter_file_status.inc\";i:155;s:52:\"modules/taxonomy/views_handler_argument_taxonomy.inc\";i:156;s:57:\"modules/taxonomy/views_handler_argument_term_node_tid.inc\";i:157;s:63:\"modules/taxonomy/views_handler_argument_term_node_tid_depth.inc\";i:158;s:68:\"modules/taxonomy/views_handler_argument_term_node_tid_depth_join.inc\";i:159;s:72:\"modules/taxonomy/views_handler_argument_term_node_tid_depth_modifier.inc\";i:160;s:58:\"modules/taxonomy/views_handler_argument_vocabulary_vid.inc\";i:161;s:67:\"modules/taxonomy/views_handler_argument_vocabulary_machine_name.inc\";i:162;s:49:\"modules/taxonomy/views_handler_field_taxonomy.inc\";i:163;s:54:\"modules/taxonomy/views_handler_field_term_node_tid.inc\";i:164;s:55:\"modules/taxonomy/views_handler_field_term_link_edit.inc\";i:165;s:55:\"modules/taxonomy/views_handler_filter_term_node_tid.inc\";i:166;s:61:\"modules/taxonomy/views_handler_filter_term_node_tid_depth.inc\";i:167;s:66:\"modules/taxonomy/views_handler_filter_term_node_tid_depth_join.inc\";i:168;s:56:\"modules/taxonomy/views_handler_filter_vocabulary_vid.inc\";i:169;s:65:\"modules/taxonomy/views_handler_filter_vocabulary_machine_name.inc\";i:170;s:62:\"modules/taxonomy/views_handler_relationship_node_term_data.inc\";i:171;s:65:\"modules/taxonomy/views_plugin_argument_validate_taxonomy_term.inc\";i:172;s:63:\"modules/taxonomy/views_plugin_argument_default_taxonomy_tid.inc\";i:173;s:67:\"modules/tracker/views_handler_argument_tracker_comment_user_uid.inc\";i:174;s:65:\"modules/tracker/views_handler_filter_tracker_comment_user_uid.inc\";i:175;s:65:\"modules/tracker/views_handler_filter_tracker_boolean_operator.inc\";i:176;s:51:\"modules/system/views_handler_filter_system_type.inc\";i:177;s:56:\"modules/translation/views_handler_argument_node_tnid.inc\";i:178;s:63:\"modules/translation/views_handler_field_node_link_translate.inc\";i:179;s:65:\"modules/translation/views_handler_field_node_translation_link.inc\";i:180;s:54:\"modules/translation/views_handler_filter_node_tnid.inc\";i:181;s:60:\"modules/translation/views_handler_filter_node_tnid_child.inc\";i:182;s:62:\"modules/translation/views_handler_relationship_translation.inc\";i:183;s:48:\"modules/user/views_handler_argument_user_uid.inc\";i:184;s:55:\"modules/user/views_handler_argument_users_roles_rid.inc\";i:185;s:41:\"modules/user/views_handler_field_user.inc\";i:186;s:50:\"modules/user/views_handler_field_user_language.inc\";i:187;s:46:\"modules/user/views_handler_field_user_link.inc\";i:188;s:53:\"modules/user/views_handler_field_user_link_cancel.inc\";i:189;s:51:\"modules/user/views_handler_field_user_link_edit.inc\";i:190;s:46:\"modules/user/views_handler_field_user_mail.inc\";i:191;s:46:\"modules/user/views_handler_field_user_name.inc\";i:192;s:53:\"modules/user/views_handler_field_user_permissions.inc\";i:193;s:49:\"modules/user/views_handler_field_user_picture.inc\";i:194;s:47:\"modules/user/views_handler_field_user_roles.inc\";i:195;s:50:\"modules/user/views_handler_filter_user_current.inc\";i:196;s:47:\"modules/user/views_handler_filter_user_name.inc\";i:197;s:54:\"modules/user/views_handler_filter_user_permissions.inc\";i:198;s:48:\"modules/user/views_handler_filter_user_roles.inc\";i:199;s:59:\"modules/user/views_plugin_argument_default_current_user.inc\";i:200;s:51:\"modules/user/views_plugin_argument_default_user.inc\";i:201;s:52:\"modules/user/views_plugin_argument_validate_user.inc\";i:202;s:43:\"modules/user/views_plugin_row_user_view.inc\";i:203;s:31:\"plugins/views_plugin_access.inc\";i:204;s:36:\"plugins/views_plugin_access_none.inc\";i:205;s:36:\"plugins/views_plugin_access_perm.inc\";i:206;s:36:\"plugins/views_plugin_access_role.inc\";i:207;s:41:\"plugins/views_plugin_argument_default.inc\";i:208;s:45:\"plugins/views_plugin_argument_default_php.inc\";i:209;s:47:\"plugins/views_plugin_argument_default_fixed.inc\";i:210;s:45:\"plugins/views_plugin_argument_default_raw.inc\";i:211;s:42:\"plugins/views_plugin_argument_validate.inc\";i:212;s:50:\"plugins/views_plugin_argument_validate_numeric.inc\";i:213;s:46:\"plugins/views_plugin_argument_validate_php.inc\";i:214;s:30:\"plugins/views_plugin_cache.inc\";i:215;s:35:\"plugins/views_plugin_cache_none.inc\";i:216;s:35:\"plugins/views_plugin_cache_time.inc\";i:217;s:32:\"plugins/views_plugin_display.inc\";i:218;s:43:\"plugins/views_plugin_display_attachment.inc\";i:219;s:38:\"plugins/views_plugin_display_block.inc\";i:220;s:40:\"plugins/views_plugin_display_default.inc\";i:221;s:38:\"plugins/views_plugin_display_embed.inc\";i:222;s:41:\"plugins/views_plugin_display_extender.inc\";i:223;s:37:\"plugins/views_plugin_display_feed.inc\";i:224;s:37:\"plugins/views_plugin_display_page.inc\";i:225;s:43:\"plugins/views_plugin_exposed_form_basic.inc\";i:226;s:37:\"plugins/views_plugin_exposed_form.inc\";i:227;s:52:\"plugins/views_plugin_exposed_form_input_required.inc\";i:228;s:42:\"plugins/views_plugin_localization_core.inc\";i:229;s:37:\"plugins/views_plugin_localization.inc\";i:230;s:42:\"plugins/views_plugin_localization_none.inc\";i:231;s:30:\"plugins/views_plugin_pager.inc\";i:232;s:35:\"plugins/views_plugin_pager_full.inc\";i:233;s:35:\"plugins/views_plugin_pager_mini.inc\";i:234;s:35:\"plugins/views_plugin_pager_none.inc\";i:235;s:35:\"plugins/views_plugin_pager_some.inc\";i:236;s:30:\"plugins/views_plugin_query.inc\";i:237;s:38:\"plugins/views_plugin_query_default.inc\";i:238;s:28:\"plugins/views_plugin_row.inc\";i:239;s:35:\"plugins/views_plugin_row_fields.inc\";i:240;s:39:\"plugins/views_plugin_row_rss_fields.inc\";i:241;s:30:\"plugins/views_plugin_style.inc\";i:242;s:38:\"plugins/views_plugin_style_default.inc\";i:243;s:35:\"plugins/views_plugin_style_grid.inc\";i:244;s:35:\"plugins/views_plugin_style_list.inc\";i:245;s:40:\"plugins/views_plugin_style_jump_menu.inc\";i:246;s:38:\"plugins/views_plugin_style_mapping.inc\";i:247;s:34:\"plugins/views_plugin_style_rss.inc\";i:248;s:38:\"plugins/views_plugin_style_summary.inc\";i:249;s:48:\"plugins/views_plugin_style_summary_jump_menu.inc\";i:250;s:50:\"plugins/views_plugin_style_summary_unformatted.inc\";i:251;s:36:\"plugins/views_plugin_style_table.inc\";i:252;s:34:\"tests/handlers/views_handlers.test\";i:253;s:43:\"tests/handlers/views_handler_area_text.test\";i:254;s:47:\"tests/handlers/views_handler_argument_null.test\";i:255;s:49:\"tests/handlers/views_handler_argument_string.test\";i:256;s:39:\"tests/handlers/views_handler_field.test\";i:257;s:47:\"tests/handlers/views_handler_field_boolean.test\";i:258;s:46:\"tests/handlers/views_handler_field_custom.test\";i:259;s:47:\"tests/handlers/views_handler_field_counter.test\";i:260;s:44:\"tests/handlers/views_handler_field_date.test\";i:261;s:54:\"tests/handlers/views_handler_field_file_extension.test\";i:262;s:49:\"tests/handlers/views_handler_field_file_size.test\";i:263;s:44:\"tests/handlers/views_handler_field_math.test\";i:264;s:43:\"tests/handlers/views_handler_field_url.test\";i:265;s:43:\"tests/handlers/views_handler_field_xss.test\";i:266;s:48:\"tests/handlers/views_handler_filter_combine.test\";i:267;s:45:\"tests/handlers/views_handler_filter_date.test\";i:268;s:49:\"tests/handlers/views_handler_filter_equality.test\";i:269;s:52:\"tests/handlers/views_handler_filter_in_operator.test\";i:270;s:48:\"tests/handlers/views_handler_filter_numeric.test\";i:271;s:47:\"tests/handlers/views_handler_filter_string.test\";i:272;s:45:\"tests/handlers/views_handler_sort_random.test\";i:273;s:43:\"tests/handlers/views_handler_sort_date.test\";i:274;s:38:\"tests/handlers/views_handler_sort.test\";i:275;s:46:\"tests/test_handlers/views_test_area_access.inc\";i:276;s:60:\"tests/test_plugins/views_test_plugin_access_test_dynamic.inc\";i:277;s:59:\"tests/test_plugins/views_test_plugin_access_test_static.inc\";i:278;s:59:\"tests/test_plugins/views_test_plugin_style_test_mapping.inc\";i:279;s:39:\"tests/plugins/views_plugin_display.test\";i:280;s:46:\"tests/styles/views_plugin_style_jump_menu.test\";i:281;s:36:\"tests/styles/views_plugin_style.test\";i:282;s:41:\"tests/styles/views_plugin_style_base.test\";i:283;s:44:\"tests/styles/views_plugin_style_mapping.test\";i:284;s:48:\"tests/styles/views_plugin_style_unformatted.test\";i:285;s:23:\"tests/views_access.test\";i:286;s:24:\"tests/views_analyze.test\";i:287;s:22:\"tests/views_basic.test\";i:288;s:33:\"tests/views_argument_default.test\";i:289;s:35:\"tests/views_argument_validator.test\";i:290;s:29:\"tests/views_exposed_form.test\";i:291;s:31:\"tests/field/views_fieldapi.test\";i:292;s:25:\"tests/views_glossary.test\";i:293;s:24:\"tests/views_groupby.test\";i:294;s:25:\"tests/views_handlers.test\";i:295;s:23:\"tests/views_module.test\";i:296;s:22:\"tests/views_pager.test\";i:297;s:40:\"tests/views_plugin_localization_test.inc\";i:298;s:29:\"tests/views_translatable.test\";i:299;s:22:\"tests/views_query.test\";i:300;s:24:\"tests/views_upgrade.test\";i:301;s:34:\"tests/views_test.views_default.inc\";i:302;s:58:\"tests/comment/views_handler_argument_comment_user_uid.test\";i:303;s:56:\"tests/comment/views_handler_filter_comment_user_uid.test\";i:304;s:45:\"tests/node/views_node_revision_relations.test\";i:305;s:61:\"tests/taxonomy/views_handler_relationship_node_term_data.test\";i:306;s:45:\"tests/user/views_handler_field_user_name.test\";i:307;s:43:\"tests/user/views_user_argument_default.test\";i:308;s:44:\"tests/user/views_user_argument_validate.test\";i:309;s:26:\"tests/user/views_user.test\";i:310;s:22:\"tests/views_cache.test\";i:311;s:21:\"tests/views_view.test\";i:312;s:19:\"tests/views_ui.test\";}s:7:\"version\";s:8:\"7.x-3.16\";s:7:\"project\";s:5:\"views\";s:9:\"datestamp\";s:10:\"1491158591\";s:5:\"mtime\";i:1491158591;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}}s:14:\"advanced_forum\";O:8:\"stdClass\":9:{s:8:\"filename\";s:54:\"sites/all/modules/advanced_forum/advanced_forum.module\";s:4:\"name\";s:14:\"advanced_forum\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:4:\"7200\";s:6:\"weight\";s:2:\"15\";s:4:\"info\";a:13:{s:4:\"name\";s:14:\"Advanced Forum\";s:11:\"description\";s:58:\"Enables the look and feel of other popular forum software.\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:14:\"Advanced Forum\";s:12:\"dependencies\";a:3:{i:0;s:5:\"forum\";i:1;s:6:\"ctools\";i:2;s:5:\"views\";}s:9:\"configure\";s:35:\"admin/config/content/advanced-forum\";s:5:\"files\";a:4:{i:0;s:63:\"includes/views/advanced_forum_handler_field_node_topic_icon.inc\";i:1;s:64:\"includes/views/advanced_forum_handler_field_node_topic_pager.inc\";i:2;s:63:\"includes/views/advanced_forum_plugin_style_forum_topic_list.inc\";i:3;s:13:\"tests/af.test\";}s:7:\"version\";s:7:\"7.x-2.5\";s:7:\"project\";s:14:\"advanced_forum\";s:9:\"datestamp\";s:10:\"1423590792\";s:5:\"mtime\";i:1499928385;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}}s:8:\"features\";O:8:\"stdClass\":9:{s:8:\"filename\";s:42:\"sites/all/modules/features/features.module\";s:4:\"name\";s:8:\"features\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:4:\"7200\";s:6:\"weight\";s:2:\"20\";s:4:\"info\";a:14:{s:4:\"name\";s:8:\"Features\";s:11:\"description\";s:39:\"Provides feature management for Drupal.\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:8:\"Features\";s:5:\"files\";a:1:{i:0;s:19:\"tests/features.test\";}s:17:\"test_dependencies\";a:4:{i:0;s:5:\"image\";i:1;s:9:\"strongarm\";i:2;s:8:\"taxonomy\";i:3;s:5:\"views\";}s:9:\"configure\";s:33:\"admin/structure/features/settings\";s:7:\"version\";s:8:\"7.x-2.10\";s:7:\"project\";s:8:\"features\";s:9:\"datestamp\";s:10:\"1461011641\";s:5:\"mtime\";i:1461011641;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}}s:10:\"admin_menu\";O:8:\"stdClass\":9:{s:8:\"filename\";s:46:\"sites/all/modules/admin_menu/admin_menu.module\";s:4:\"name\";s:10:\"admin_menu\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:4:\"7304\";s:6:\"weight\";s:3:\"100\";s:4:\"info\";a:13:{s:4:\"name\";s:19:\"Administration menu\";s:11:\"description\";s:123:\"Provides a dropdown menu to most administrative tasks and other common destinations (to users with the proper permissions).\";s:7:\"package\";s:14:\"Administration\";s:4:\"core\";s:3:\"7.x\";s:9:\"configure\";s:38:\"admin/config/administration/admin_menu\";s:12:\"dependencies\";a:1:{i:0;s:14:\"system (>7.10)\";}s:5:\"files\";a:1:{i:0;s:21:\"tests/admin_menu.test\";}s:7:\"version\";s:11:\"7.x-3.0-rc5\";s:7:\"project\";s:10:\"admin_menu\";s:9:\"datestamp\";s:10:\"1419029284\";s:5:\"mtime\";i:1499928385;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}}s:10:\"i18n_block\";O:8:\"stdClass\":9:{s:8:\"filename\";s:51:\"sites/all/modules/i18n/i18n_block/i18n_block.module\";s:4:\"name\";s:10:\"i18n_block\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:4:\"7001\";s:6:\"weight\";s:3:\"100\";s:4:\"info\";a:12:{s:4:\"name\";s:15:\"Block languages\";s:11:\"description\";s:68:\"Enables language selector for blocks and optional block translation.\";s:12:\"dependencies\";a:2:{i:0;s:5:\"block\";i:1;s:11:\"i18n_string\";}s:7:\"package\";s:35:\"Multilingual - Internationalization\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:2:{i:0;s:14:\"i18n_block.inc\";i:1;s:15:\"i18n_block.test\";}s:7:\"version\";s:8:\"7.x-1.13\";s:7:\"project\";s:4:\"i18n\";s:9:\"datestamp\";s:10:\"1430999922\";s:5:\"mtime\";i:1499928385;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}}s:18:\"admin_menu_toolbar\";O:8:\"stdClass\":9:{s:8:\"filename\";s:73:\"sites/all/modules/admin_menu/admin_menu_toolbar/admin_menu_toolbar.module\";s:4:\"name\";s:18:\"admin_menu_toolbar\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:4:\"6300\";s:6:\"weight\";s:3:\"101\";s:4:\"info\";a:12:{s:4:\"name\";s:33:\"Administration menu Toolbar style\";s:11:\"description\";s:17:\"A better Toolbar.\";s:7:\"package\";s:14:\"Administration\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:1:{i:0;s:10:\"admin_menu\";}s:7:\"version\";s:11:\"7.x-3.0-rc5\";s:7:\"project\";s:10:\"admin_menu\";s:9:\"datestamp\";s:10:\"1419029284\";s:5:\"mtime\";i:1499928385;s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}}s:8:\"standard\";O:8:\"stdClass\":9:{s:8:\"filename\";s:34:\"profiles/standard/standard.profile\";s:4:\"name\";s:8:\"standard\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:1:\"0\";s:6:\"weight\";s:4:\"1000\";s:4:\"info\";a:15:{s:4:\"name\";s:8:\"Standard\";s:11:\"description\";s:51:\"Install with commonly used features pre-configured.\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:21:{i:0;s:5:\"block\";i:1;s:5:\"color\";i:2;s:7:\"comment\";i:3;s:10:\"contextual\";i:4;s:9:\"dashboard\";i:5;s:4:\"help\";i:6;s:5:\"image\";i:7;s:4:\"list\";i:8;s:4:\"menu\";i:9;s:6:\"number\";i:10;s:7:\"options\";i:11;s:4:\"path\";i:12;s:8:\"taxonomy\";i:13;s:5:\"dblog\";i:14;s:6:\"search\";i:15;s:8:\"shortcut\";i:16;s:7:\"toolbar\";i:17;s:7:\"overlay\";i:18;s:8:\"field_ui\";i:19;s:4:\"file\";i:20;s:3:\"rdf\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:7:\"package\";s:5:\"Other\";s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;s:6:\"hidden\";b:1;s:8:\"required\";b:1;s:17:\"distribution_name\";s:6:\"Drupal\";}}}s:5:\"theme\";a:7:{s:6:\"bartik\";O:8:\"stdClass\":10:{s:8:\"filename\";s:25:\"themes/bartik/bartik.info\";s:4:\"name\";s:6:\"bartik\";s:4:\"type\";s:5:\"theme\";s:5:\"owner\";s:45:\"themes/engines/phptemplate/phptemplate.engine\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:2:\"-1\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:19:{s:4:\"name\";s:6:\"Bartik\";s:11:\"description\";s:48:\"A flexible, recolorable theme with many regions.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:11:\"stylesheets\";a:2:{s:3:\"all\";a:3:{s:14:\"css/layout.css\";s:28:\"themes/bartik/css/layout.css\";s:13:\"css/style.css\";s:27:\"themes/bartik/css/style.css\";s:14:\"css/colors.css\";s:28:\"themes/bartik/css/colors.css\";}s:5:\"print\";a:1:{s:13:\"css/print.css\";s:27:\"themes/bartik/css/print.css\";}}s:7:\"regions\";a:20:{s:6:\"header\";s:6:\"Header\";s:4:\"help\";s:4:\"Help\";s:8:\"page_top\";s:8:\"Page top\";s:11:\"page_bottom\";s:11:\"Page bottom\";s:11:\"highlighted\";s:11:\"Highlighted\";s:8:\"featured\";s:8:\"Featured\";s:7:\"content\";s:7:\"Content\";s:13:\"sidebar_first\";s:13:\"Sidebar first\";s:14:\"sidebar_second\";s:14:\"Sidebar second\";s:14:\"triptych_first\";s:14:\"Triptych first\";s:15:\"triptych_middle\";s:15:\"Triptych middle\";s:13:\"triptych_last\";s:13:\"Triptych last\";s:18:\"footer_firstcolumn\";s:19:\"Footer first column\";s:19:\"footer_secondcolumn\";s:20:\"Footer second column\";s:18:\"footer_thirdcolumn\";s:19:\"Footer third column\";s:19:\"footer_fourthcolumn\";s:20:\"Footer fourth column\";s:6:\"footer\";s:6:\"Footer\";s:14:\"dashboard_main\";s:16:\"Dashboard (main)\";s:17:\"dashboard_sidebar\";s:19:\"Dashboard (sidebar)\";s:18:\"dashboard_inactive\";s:20:\"Dashboard (inactive)\";}s:8:\"settings\";a:1:{s:20:\"shortcut_module_link\";s:1:\"0\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:6:\"engine\";s:11:\"phptemplate\";s:8:\"features\";a:9:{i:0;s:4:\"logo\";i:1;s:7:\"favicon\";i:2;s:4:\"name\";i:3;s:6:\"slogan\";i:4;s:17:\"node_user_picture\";i:5;s:20:\"comment_user_picture\";i:6;s:25:\"comment_user_verification\";i:7;s:9:\"main_menu\";i:8;s:14:\"secondary_menu\";}s:10:\"screenshot\";s:28:\"themes/bartik/screenshot.png\";s:3:\"php\";s:5:\"5.2.4\";s:7:\"scripts\";a:0:{}s:5:\"mtime\";i:1498069849;s:15:\"overlay_regions\";a:5:{i:0;s:14:\"dashboard_main\";i:1;s:17:\"dashboard_sidebar\";i:2;s:18:\"dashboard_inactive\";i:3;s:7:\"content\";i:4;s:4:\"help\";}s:14:\"regions_hidden\";a:2:{i:0;s:8:\"page_top\";i:1;s:11:\"page_bottom\";}s:28:\"overlay_supplemental_regions\";a:1:{i:0;s:11:\"page_bottom\";}}s:6:\"prefix\";s:11:\"phptemplate\";}s:10:\"forum_plus\";O:8:\"stdClass\":10:{s:8:\"filename\";s:43:\"sites/all/themes/forum_plus/forum_plus.info\";s:4:\"name\";s:10:\"forum_plus\";s:4:\"type\";s:5:\"theme\";s:5:\"owner\";s:45:\"themes/engines/phptemplate/phptemplate.engine\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:2:\"-1\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:20:{s:4:\"name\";s:10:\"Forum Plus\";s:11:\"description\";s:23:\"Theme for the Companies\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:6:\"engine\";s:11:\"phptemplate\";s:11:\"stylesheets\";a:1:{s:3:\"all\";a:3:{s:34:\"vendor/bootstrap/css/bootstrap.css\";s:62:\"sites/all/themes/forum_plus/vendor/bootstrap/css/bootstrap.css\";s:40:\"vendor/bootstrap/css/bootstrap-theme.css\";s:68:\"sites/all/themes/forum_plus/vendor/bootstrap/css/bootstrap-theme.css\";s:14:\"css/styles.css\";s:42:\"sites/all/themes/forum_plus/css/styles.css\";}}s:7:\"scripts\";a:8:{s:32:\"vendor/bootstrap/js/bootstrap.js\";s:60:\"sites/all/themes/forum_plus/vendor/bootstrap/js/bootstrap.js\";s:26:\"js/jquery.smooth-scroll.js\";s:54:\"sites/all/themes/forum_plus/js/jquery.smooth-scroll.js\";s:19:\"js/jquery.cookie.js\";s:47:\"sites/all/themes/forum_plus/js/jquery.cookie.js\";s:24:\"js/jquery.matchHeight.js\";s:52:\"sites/all/themes/forum_plus/js/jquery.matchHeight.js\";s:12:\"js/moment.js\";s:40:\"sites/all/themes/forum_plus/js/moment.js\";s:20:\"js/accordion_menu.js\";s:48:\"sites/all/themes/forum_plus/js/accordion_menu.js\";s:13:\"js/weebpal.js\";s:41:\"sites/all/themes/forum_plus/js/weebpal.js\";s:16:\"js/forum_plus.js\";s:44:\"sites/all/themes/forum_plus/js/forum_plus.js\";}s:8:\"features\";a:7:{i:0;s:4:\"logo\";i:1;s:4:\"name\";i:2;s:6:\"slogan\";i:3;s:17:\"node_user_picture\";i:4;s:20:\"comment_user_picture\";i:5;s:25:\"comment_user_verification\";i:6;s:7:\"favicon\";}s:7:\"regions\";a:25:{s:8:\"headline\";s:8:\"Headline\";s:6:\"header\";s:6:\"Header\";s:9:\"main_menu\";s:9:\"Main Menu\";s:9:\"slideshow\";s:9:\"Slideshow\";s:4:\"help\";s:4:\"Help\";s:8:\"page_top\";s:8:\"Page top\";s:11:\"page_bottom\";s:11:\"Page bottom\";s:11:\"highlighted\";s:11:\"Highlighted\";s:8:\"featured\";s:8:\"Featured\";s:7:\"content\";s:7:\"Content\";s:13:\"sidebar_first\";s:13:\"Sidebar first\";s:14:\"sidebar_second\";s:14:\"Sidebar second\";s:7:\"welcome\";s:7:\"Welcome\";s:11:\"panel_first\";s:11:\"Panel First\";s:12:\"panel_second\";s:12:\"Panel Second\";s:11:\"panel_third\";s:11:\"Panel Third\";s:4:\"gmap\";s:4:\"GMap\";s:14:\"panel_footer_1\";s:14:\"Panel Footer 1\";s:14:\"panel_footer_2\";s:14:\"Panel Footer 2\";s:14:\"panel_footer_3\";s:14:\"Panel Footer 3\";s:14:\"panel_footer_4\";s:14:\"Panel Footer 4\";s:6:\"footer\";s:6:\"Footer\";s:14:\"dashboard_main\";s:16:\"Dashboard (main)\";s:17:\"dashboard_sidebar\";s:19:\"Dashboard (sidebar)\";s:18:\"dashboard_inactive\";s:20:\"Dashboard (inactive)\";}s:8:\"settings\";a:7:{s:19:\"sidebar_first_width\";s:1:\"3\";s:20:\"sidebar_second_width\";s:1:\"3\";s:20:\"panel_footer_1_width\";s:1:\"3\";s:20:\"panel_footer_2_width\";s:1:\"3\";s:20:\"panel_footer_3_width\";s:1:\"3\";s:20:\"panel_footer_4_width\";s:1:\"3\";s:20:\"layout_width_default\";s:4:\"1200\";}s:5:\"skins\";a:3:{s:3:\"red\";s:3:\"Red\";s:6:\"yellow\";s:6:\"Yellow\";s:5:\"green\";s:5:\"Green\";}s:7:\"plugins\";a:1:{s:14:\"advanced_forum\";a:1:{s:6:\"styles\";s:23:\"css/advanced_forum/plus\";}}s:11:\"backgrounds\";a:7:{s:4:\"bg-1\";s:12:\"Background 1\";s:4:\"bg-2\";s:12:\"Background 2\";s:4:\"bg-3\";s:12:\"Background 3\";s:4:\"bg-4\";s:12:\"Background 4\";s:4:\"bg-5\";s:12:\"Background 5\";s:4:\"bg-6\";s:12:\"Background 6\";s:4:\"bg-7\";s:12:\"Background 7\";}s:6:\"layout\";a:1:{s:12:\"layout-boxed\";s:12:\"Boxed Layout\";}s:10:\"screenshot\";s:42:\"sites/all/themes/forum_plus/screenshot.png\";s:3:\"php\";s:5:\"5.2.4\";s:5:\"mtime\";i:1499928385;s:15:\"overlay_regions\";a:5:{i:0;s:14:\"dashboard_main\";i:1;s:17:\"dashboard_sidebar\";i:2;s:18:\"dashboard_inactive\";i:3;s:7:\"content\";i:4;s:4:\"help\";}s:14:\"regions_hidden\";a:2:{i:0;s:8:\"page_top\";i:1;s:11:\"page_bottom\";}s:28:\"overlay_supplemental_regions\";a:1:{i:0;s:11:\"page_bottom\";}}s:6:\"prefix\";s:11:\"phptemplate\";}s:7:\"garland\";O:8:\"stdClass\":10:{s:8:\"filename\";s:27:\"themes/garland/garland.info\";s:4:\"name\";s:7:\"garland\";s:4:\"type\";s:5:\"theme\";s:5:\"owner\";s:45:\"themes/engines/phptemplate/phptemplate.engine\";s:6:\"status\";s:1:\"0\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:2:\"-1\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:19:{s:4:\"name\";s:7:\"Garland\";s:11:\"description\";s:111:\"A multi-column theme which can be configured to modify colors and switch between fixed and fluid width layouts.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:11:\"stylesheets\";a:2:{s:3:\"all\";a:1:{s:9:\"style.css\";s:24:\"themes/garland/style.css\";}s:5:\"print\";a:1:{s:9:\"print.css\";s:24:\"themes/garland/print.css\";}}s:8:\"settings\";a:1:{s:13:\"garland_width\";s:5:\"fluid\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:6:\"engine\";s:11:\"phptemplate\";s:7:\"regions\";a:12:{s:13:\"sidebar_first\";s:12:\"Left sidebar\";s:14:\"sidebar_second\";s:13:\"Right sidebar\";s:7:\"content\";s:7:\"Content\";s:6:\"header\";s:6:\"Header\";s:6:\"footer\";s:6:\"Footer\";s:11:\"highlighted\";s:11:\"Highlighted\";s:4:\"help\";s:4:\"Help\";s:8:\"page_top\";s:8:\"Page top\";s:11:\"page_bottom\";s:11:\"Page bottom\";s:14:\"dashboard_main\";s:16:\"Dashboard (main)\";s:17:\"dashboard_sidebar\";s:19:\"Dashboard (sidebar)\";s:18:\"dashboard_inactive\";s:20:\"Dashboard (inactive)\";}s:8:\"features\";a:9:{i:0;s:4:\"logo\";i:1;s:7:\"favicon\";i:2;s:4:\"name\";i:3;s:6:\"slogan\";i:4;s:17:\"node_user_picture\";i:5;s:20:\"comment_user_picture\";i:6;s:25:\"comment_user_verification\";i:7;s:9:\"main_menu\";i:8;s:14:\"secondary_menu\";}s:10:\"screenshot\";s:29:\"themes/garland/screenshot.png\";s:3:\"php\";s:5:\"5.2.4\";s:7:\"scripts\";a:0:{}s:5:\"mtime\";i:1498069849;s:15:\"overlay_regions\";a:5:{i:0;s:14:\"dashboard_main\";i:1;s:17:\"dashboard_sidebar\";i:2;s:18:\"dashboard_inactive\";i:3;s:7:\"content\";i:4;s:4:\"help\";}s:14:\"regions_hidden\";a:2:{i:0;s:8:\"page_top\";i:1;s:11:\"page_bottom\";}s:28:\"overlay_supplemental_regions\";a:1:{i:0;s:11:\"page_bottom\";}}s:6:\"prefix\";s:11:\"phptemplate\";}s:4:\"plus\";O:8:\"stdClass\":10:{s:8:\"filename\";s:61:\"sites/all/themes/forum_plus/css/advanced_forum/plus/plus.info\";s:4:\"name\";s:4:\"plus\";s:4:\"type\";s:5:\"theme\";s:5:\"owner\";s:45:\"themes/engines/phptemplate/phptemplate.engine\";s:6:\"status\";s:1:\"0\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:2:\"-1\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:18:{s:4:\"name\";s:4:\"Plus\";s:11:\"description\";s:43:\"Based on the Blue Lagoon colors of Garland.\";s:7:\"version\";s:7:\"7.x-2.3\";s:10:\"base style\";s:5:\"naked\";s:4:\"core\";s:3:\"7.x\";s:7:\"project\";s:14:\"advanced_forum\";s:9:\"datestamp\";s:10:\"1373223651\";s:6:\"engine\";s:11:\"phptemplate\";s:7:\"regions\";a:12:{s:13:\"sidebar_first\";s:12:\"Left sidebar\";s:14:\"sidebar_second\";s:13:\"Right sidebar\";s:7:\"content\";s:7:\"Content\";s:6:\"header\";s:6:\"Header\";s:6:\"footer\";s:6:\"Footer\";s:11:\"highlighted\";s:11:\"Highlighted\";s:4:\"help\";s:4:\"Help\";s:8:\"page_top\";s:8:\"Page top\";s:11:\"page_bottom\";s:11:\"Page bottom\";s:14:\"dashboard_main\";s:16:\"Dashboard (main)\";s:17:\"dashboard_sidebar\";s:19:\"Dashboard (sidebar)\";s:18:\"dashboard_inactive\";s:20:\"Dashboard (inactive)\";}s:8:\"features\";a:9:{i:0;s:4:\"logo\";i:1;s:7:\"favicon\";i:2;s:4:\"name\";i:3;s:6:\"slogan\";i:4;s:17:\"node_user_picture\";i:5;s:20:\"comment_user_picture\";i:6;s:25:\"comment_user_verification\";i:7;s:9:\"main_menu\";i:8;s:14:\"secondary_menu\";}s:10:\"screenshot\";s:66:\"sites/all/themes/forum_plus/css/advanced_forum/plus/screenshot.png\";s:3:\"php\";s:5:\"5.2.4\";s:11:\"stylesheets\";a:0:{}s:7:\"scripts\";a:0:{}s:5:\"mtime\";i:1499928385;s:15:\"overlay_regions\";a:5:{i:0;s:14:\"dashboard_main\";i:1;s:17:\"dashboard_sidebar\";i:2;s:18:\"dashboard_inactive\";i:3;s:7:\"content\";i:4;s:4:\"help\";}s:14:\"regions_hidden\";a:2:{i:0;s:8:\"page_top\";i:1;s:11:\"page_bottom\";}s:28:\"overlay_supplemental_regions\";a:1:{i:0;s:11:\"page_bottom\";}}s:6:\"prefix\";s:11:\"phptemplate\";}s:5:\"seven\";O:8:\"stdClass\":10:{s:8:\"filename\";s:23:\"themes/seven/seven.info\";s:4:\"name\";s:5:\"seven\";s:4:\"type\";s:5:\"theme\";s:5:\"owner\";s:45:\"themes/engines/phptemplate/phptemplate.engine\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:2:\"-1\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:19:{s:4:\"name\";s:5:\"Seven\";s:11:\"description\";s:65:\"A simple one-column, tableless, fluid width administration theme.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:11:\"stylesheets\";a:1:{s:6:\"screen\";a:2:{s:9:\"reset.css\";s:22:\"themes/seven/reset.css\";s:9:\"style.css\";s:22:\"themes/seven/style.css\";}}s:8:\"settings\";a:1:{s:20:\"shortcut_module_link\";s:1:\"1\";}s:7:\"regions\";a:8:{s:7:\"content\";s:7:\"Content\";s:4:\"help\";s:4:\"Help\";s:8:\"page_top\";s:8:\"Page top\";s:11:\"page_bottom\";s:11:\"Page bottom\";s:13:\"sidebar_first\";s:13:\"First sidebar\";s:14:\"dashboard_main\";s:16:\"Dashboard (main)\";s:17:\"dashboard_sidebar\";s:19:\"Dashboard (sidebar)\";s:18:\"dashboard_inactive\";s:20:\"Dashboard (inactive)\";}s:14:\"regions_hidden\";a:3:{i:0;s:13:\"sidebar_first\";i:1;s:8:\"page_top\";i:2;s:11:\"page_bottom\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:6:\"engine\";s:11:\"phptemplate\";s:8:\"features\";a:9:{i:0;s:4:\"logo\";i:1;s:7:\"favicon\";i:2;s:4:\"name\";i:3;s:6:\"slogan\";i:4;s:17:\"node_user_picture\";i:5;s:20:\"comment_user_picture\";i:6;s:25:\"comment_user_verification\";i:7;s:9:\"main_menu\";i:8;s:14:\"secondary_menu\";}s:10:\"screenshot\";s:27:\"themes/seven/screenshot.png\";s:3:\"php\";s:5:\"5.2.4\";s:7:\"scripts\";a:0:{}s:5:\"mtime\";i:1498069849;s:15:\"overlay_regions\";a:5:{i:0;s:14:\"dashboard_main\";i:1;s:17:\"dashboard_sidebar\";i:2;s:18:\"dashboard_inactive\";i:3;s:7:\"content\";i:4;s:4:\"help\";}s:28:\"overlay_supplemental_regions\";a:1:{i:0;s:11:\"page_bottom\";}}s:6:\"prefix\";s:11:\"phptemplate\";}s:5:\"stark\";O:8:\"stdClass\":10:{s:8:\"filename\";s:23:\"themes/stark/stark.info\";s:4:\"name\";s:5:\"stark\";s:4:\"type\";s:5:\"theme\";s:5:\"owner\";s:45:\"themes/engines/phptemplate/phptemplate.engine\";s:6:\"status\";s:1:\"0\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:2:\"-1\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:18:{s:4:\"name\";s:5:\"Stark\";s:11:\"description\";s:208:\"This theme demonstrates Drupal\'s default HTML markup and CSS styles. To learn how to build your own theme and override Drupal\'s default code, see the <a href=\"http://drupal.org/theme-guide\">Theming Guide</a>.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:11:\"stylesheets\";a:1:{s:3:\"all\";a:1:{s:10:\"layout.css\";s:23:\"themes/stark/layout.css\";}}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:6:\"engine\";s:11:\"phptemplate\";s:7:\"regions\";a:12:{s:13:\"sidebar_first\";s:12:\"Left sidebar\";s:14:\"sidebar_second\";s:13:\"Right sidebar\";s:7:\"content\";s:7:\"Content\";s:6:\"header\";s:6:\"Header\";s:6:\"footer\";s:6:\"Footer\";s:11:\"highlighted\";s:11:\"Highlighted\";s:4:\"help\";s:4:\"Help\";s:8:\"page_top\";s:8:\"Page top\";s:11:\"page_bottom\";s:11:\"Page bottom\";s:14:\"dashboard_main\";s:16:\"Dashboard (main)\";s:17:\"dashboard_sidebar\";s:19:\"Dashboard (sidebar)\";s:18:\"dashboard_inactive\";s:20:\"Dashboard (inactive)\";}s:8:\"features\";a:9:{i:0;s:4:\"logo\";i:1;s:7:\"favicon\";i:2;s:4:\"name\";i:3;s:6:\"slogan\";i:4;s:17:\"node_user_picture\";i:5;s:20:\"comment_user_picture\";i:6;s:25:\"comment_user_verification\";i:7;s:9:\"main_menu\";i:8;s:14:\"secondary_menu\";}s:10:\"screenshot\";s:27:\"themes/stark/screenshot.png\";s:3:\"php\";s:5:\"5.2.4\";s:7:\"scripts\";a:0:{}s:5:\"mtime\";i:1498069849;s:15:\"overlay_regions\";a:5:{i:0;s:14:\"dashboard_main\";i:1;s:17:\"dashboard_sidebar\";i:2;s:18:\"dashboard_inactive\";i:3;s:7:\"content\";i:4;s:4:\"help\";}s:14:\"regions_hidden\";a:2:{i:0;s:8:\"page_top\";i:1;s:11:\"page_bottom\";}s:28:\"overlay_supplemental_regions\";a:1:{i:0;s:11:\"page_bottom\";}}s:6:\"prefix\";s:11:\"phptemplate\";}s:10:\"we_backend\";O:8:\"stdClass\":10:{s:8:\"filename\";s:43:\"sites/all/themes/we_backend/we_backend.info\";s:4:\"name\";s:10:\"we_backend\";s:4:\"type\";s:5:\"theme\";s:5:\"owner\";s:45:\"themes/engines/phptemplate/phptemplate.engine\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:2:\"-1\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:15:{s:4:\"name\";s:21:\"WeebPal Backend theme\";s:11:\"description\";s:26:\"Backend theme from WeebPal\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:6:\"engine\";s:11:\"phptemplate\";s:11:\"stylesheets\";a:1:{s:3:\"all\";a:1:{s:20:\"assets/css/style.css\";s:48:\"sites/all/themes/we_backend/assets/css/style.css\";}}s:7:\"scripts\";a:1:{s:20:\"assets/js/scripts.js\";s:48:\"sites/all/themes/we_backend/assets/js/scripts.js\";}s:8:\"features\";a:7:{i:0;s:4:\"logo\";i:1;s:4:\"name\";i:2;s:6:\"slogan\";i:3;s:17:\"node_user_picture\";i:4;s:20:\"comment_user_picture\";i:5;s:25:\"comment_user_verification\";i:6;s:7:\"favicon\";}s:7:\"regions\";a:10:{s:6:\"header\";s:6:\"Header\";s:11:\"highlighted\";s:11:\"Highlighted\";s:4:\"help\";s:4:\"Help\";s:7:\"content\";s:7:\"Content\";s:13:\"sidebar_first\";s:13:\"Sidebar first\";s:14:\"sidebar_second\";s:14:\"Sidebar second\";s:6:\"footer\";s:6:\"Footer\";s:14:\"dashboard_main\";s:16:\"Dashboard (main)\";s:17:\"dashboard_sidebar\";s:19:\"Dashboard (sidebar)\";s:18:\"dashboard_inactive\";s:20:\"Dashboard (inactive)\";}s:10:\"screenshot\";s:42:\"sites/all/themes/we_backend/screenshot.png\";s:3:\"php\";s:5:\"5.2.4\";s:5:\"mtime\";i:1499643480;s:15:\"overlay_regions\";a:5:{i:0;s:14:\"dashboard_main\";i:1;s:17:\"dashboard_sidebar\";i:2;s:18:\"dashboard_inactive\";i:3;s:7:\"content\";i:4;s:4:\"help\";}s:14:\"regions_hidden\";a:2:{i:0;s:8:\"page_top\";i:1;s:11:\"page_bottom\";}s:28:\"overlay_supplemental_regions\";a:1:{i:0;s:11:\"page_bottom\";}}s:6:\"prefix\";s:11:\"phptemplate\";}}s:9:\"filepaths\";a:103:{i:0;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:9:\"strongarm\";s:8:\"filepath\";s:44:\"sites/all/modules/strongarm/strongarm.module\";}i:1;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:11:\"remember_me\";s:8:\"filepath\";s:48:\"sites/all/modules/remember_me/remember_me.module\";}i:2;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:5:\"block\";s:8:\"filepath\";s:26:\"modules/block/block.module\";}i:3;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:7:\"webform\";s:8:\"filepath\";s:40:\"sites/all/modules/webform/webform.module\";}i:4;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:11:\"author_pane\";s:8:\"filepath\";s:48:\"sites/all/modules/author_pane/author_pane.module\";}i:5;a:3:{s:4:\"type\";s:5:\"theme\";s:4:\"name\";s:6:\"bartik\";s:8:\"filepath\";s:25:\"themes/bartik/bartik.info\";}i:6;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:11:\"block_class\";s:8:\"filepath\";s:48:\"sites/all/modules/block_class/block_class.module\";}i:7;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:4:\"blog\";s:8:\"filepath\";s:24:\"modules/blog/blog.module\";}i:8;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:4:\"book\";s:8:\"filepath\";s:24:\"modules/book/book.module\";}i:9;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:8:\"calendar\";s:8:\"filepath\";s:42:\"sites/all/modules/calendar/calendar.module\";}i:10;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:6:\"chosen\";s:8:\"filepath\";s:38:\"sites/all/modules/chosen/chosen.module\";}i:11;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:8:\"ckeditor\";s:8:\"filepath\";s:42:\"sites/all/modules/ckeditor/ckeditor.module\";}i:12;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:5:\"color\";s:8:\"filepath\";s:26:\"modules/color/color.module\";}i:13;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:7:\"comment\";s:8:\"filepath\";s:30:\"modules/comment/comment.module\";}i:14;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:7:\"contact\";s:8:\"filepath\";s:30:\"modules/contact/contact.module\";}i:15;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:10:\"contextual\";s:8:\"filepath\";s:36:\"modules/contextual/contextual.module\";}i:16;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:6:\"ctools\";s:8:\"filepath\";s:38:\"sites/all/modules/ctools/ctools.module\";}i:17;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:9:\"dashboard\";s:8:\"filepath\";s:34:\"modules/dashboard/dashboard.module\";}i:18;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:8:\"date_api\";s:8:\"filepath\";s:47:\"sites/all/modules/date/date_api/date_api.module\";}i:19;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:10:\"date_views\";s:8:\"filepath\";s:51:\"sites/all/modules/date/date_views/date_views.module\";}i:20;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:5:\"dblog\";s:8:\"filepath\";s:26:\"modules/dblog/dblog.module\";}i:21;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:6:\"entity\";s:8:\"filepath\";s:38:\"sites/all/modules/entity/entity.module\";}i:22;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:15:\"entityreference\";s:8:\"filepath\";s:56:\"sites/all/modules/entityreference/entityreference.module\";}i:23;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:12:\"entity_token\";s:8:\"filepath\";s:44:\"sites/all/modules/entity/entity_token.module\";}i:24;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:3:\"faq\";s:8:\"filepath\";s:32:\"sites/all/modules/faq/faq.module\";}i:25;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:5:\"field\";s:8:\"filepath\";s:26:\"modules/field/field.module\";}i:26;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:16:\"field_collection\";s:8:\"filepath\";s:58:\"sites/all/modules/field_collection/field_collection.module\";}i:27;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:17:\"field_sql_storage\";s:8:\"filepath\";s:64:\"modules/field/modules/field_sql_storage/field_sql_storage.module\";}i:28;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:8:\"field_ui\";s:8:\"filepath\";s:32:\"modules/field_ui/field_ui.module\";}i:29;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:4:\"file\";s:8:\"filepath\";s:24:\"modules/file/file.module\";}i:30;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:6:\"filter\";s:8:\"filepath\";s:28:\"modules/filter/filter.module\";}i:31;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:8:\"fivestar\";s:8:\"filepath\";s:42:\"sites/all/modules/fivestar/fivestar.module\";}i:32;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:10:\"flexslider\";s:8:\"filepath\";s:46:\"sites/all/modules/flexslider/flexslider.module\";}i:33;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:17:\"flexslider_fields\";s:8:\"filepath\";s:71:\"sites/all/modules/flexslider/flexslider_fields/flexslider_fields.module\";}i:34;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:16:\"flexslider_views\";s:8:\"filepath\";s:69:\"sites/all/modules/flexslider/flexslider_views/flexslider_views.module\";}i:35;a:3:{s:4:\"type\";s:5:\"theme\";s:4:\"name\";s:10:\"forum_plus\";s:8:\"filepath\";s:43:\"sites/all/themes/forum_plus/forum_plus.info\";}i:36;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:4:\"help\";s:8:\"filepath\";s:24:\"modules/help/help.module\";}i:37;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:16:\"i18n_translation\";s:8:\"filepath\";s:63:\"sites/all/modules/i18n/i18n_translation/i18n_translation.module\";}i:38;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:5:\"image\";s:8:\"filepath\";s:26:\"modules/image/image.module\";}i:39;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:13:\"jquery_update\";s:8:\"filepath\";s:52:\"sites/all/modules/jquery_update/jquery_update.module\";}i:40;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:13:\"languageicons\";s:8:\"filepath\";s:52:\"sites/all/modules/languageicons/languageicons.module\";}i:41;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:13:\"lang_dropdown\";s:8:\"filepath\";s:52:\"sites/all/modules/lang_dropdown/lang_dropdown.module\";}i:42;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:21:\"lang_dropdown_hideout\";s:8:\"filepath\";s:82:\"sites/all/modules/lang_dropdown/lang_dropdown_hideout/lang_dropdown_hideout.module\";}i:43;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:9:\"libraries\";s:8:\"filepath\";s:44:\"sites/all/modules/libraries/libraries.module\";}i:44;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:4:\"link\";s:8:\"filepath\";s:34:\"sites/all/modules/link/link.module\";}i:45;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:4:\"list\";s:8:\"filepath\";s:38:\"modules/field/modules/list/list.module\";}i:46;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:6:\"locale\";s:8:\"filepath\";s:28:\"modules/locale/locale.module\";}i:47;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:4:\"menu\";s:8:\"filepath\";s:24:\"modules/menu/menu.module\";}i:48;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:15:\"menu_breadcrumb\";s:8:\"filepath\";s:56:\"sites/all/modules/menu_breadcrumb/menu_breadcrumb.module\";}i:49;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:7:\"message\";s:8:\"filepath\";s:40:\"sites/all/modules/message/message.module\";}i:50;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:15:\"message_example\";s:8:\"filepath\";s:64:\"sites/all/modules/message/message_example/message_example.module\";}i:51;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:11:\"modal_forms\";s:8:\"filepath\";s:48:\"sites/all/modules/modal_forms/modal_forms.module\";}i:52;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:13:\"module_filter\";s:8:\"filepath\";s:52:\"sites/all/modules/module_filter/module_filter.module\";}i:53;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:4:\"node\";s:8:\"filepath\";s:24:\"modules/node/node.module\";}i:54;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:10:\"node_class\";s:8:\"filepath\";s:46:\"sites/all/modules/node_class/node_class.module\";}i:55;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:6:\"number\";s:8:\"filepath\";s:42:\"modules/field/modules/number/number.module\";}i:56;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:7:\"options\";s:8:\"filepath\";s:44:\"modules/field/modules/options/options.module\";}i:57;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:7:\"overlay\";s:8:\"filepath\";s:30:\"modules/overlay/overlay.module\";}i:58;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:4:\"path\";s:8:\"filepath\";s:24:\"modules/path/path.module\";}i:59;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:3:\"php\";s:8:\"filepath\";s:22:\"modules/php/php.module\";}i:60;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:9:\"quicktabs\";s:8:\"filepath\";s:44:\"sites/all/modules/quicktabs/quicktabs.module\";}i:61;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:6:\"search\";s:8:\"filepath\";s:28:\"modules/search/search.module\";}i:62;a:3:{s:4:\"type\";s:5:\"theme\";s:4:\"name\";s:5:\"seven\";s:8:\"filepath\";s:23:\"themes/seven/seven.info\";}i:63;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:9:\"sharethis\";s:8:\"filepath\";s:44:\"sites/all/modules/sharethis/sharethis.module\";}i:64;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:9:\"shortcode\";s:8:\"filepath\";s:44:\"sites/all/modules/shortcode/shortcode.module\";}i:65;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:20:\"shortcode_basic_tags\";s:8:\"filepath\";s:76:\"sites/all/modules/shortcode/shortcode_basic_tags/shortcode_basic_tags.module\";}i:66;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:23:\"shortcode_embed_content\";s:8:\"filepath\";s:82:\"sites/all/modules/shortcode/shortcode_embed_content/shortcode_embed_content.module\";}i:67;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:15:\"shortcode_video\";s:8:\"filepath\";s:66:\"sites/all/modules/shortcode/shortcode_video/shortcode_video.module\";}i:68;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:8:\"shortcut\";s:8:\"filepath\";s:32:\"modules/shortcut/shortcut.module\";}i:69;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:10:\"statistics\";s:8:\"filepath\";s:36:\"modules/statistics/statistics.module\";}i:70;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:6:\"system\";s:8:\"filepath\";s:28:\"modules/system/system.module\";}i:71;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:9:\"tagclouds\";s:8:\"filepath\";s:44:\"sites/all/modules/tagclouds/tagclouds.module\";}i:72;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:8:\"taxonomy\";s:8:\"filepath\";s:32:\"modules/taxonomy/taxonomy.module\";}i:73;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:13:\"taxonomy_menu\";s:8:\"filepath\";s:52:\"sites/all/modules/taxonomy_menu/taxonomy_menu.module\";}i:74;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:4:\"text\";s:8:\"filepath\";s:38:\"modules/field/modules/text/text.module\";}i:75;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:5:\"token\";s:8:\"filepath\";s:36:\"sites/all/modules/token/token.module\";}i:76;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:12:\"token_custom\";s:8:\"filepath\";s:50:\"sites/all/modules/token_custom/token_custom.module\";}i:77;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:6:\"update\";s:8:\"filepath\";s:28:\"modules/update/update.module\";}i:78;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:4:\"user\";s:8:\"filepath\";s:24:\"modules/user/user.module\";}i:79;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:8:\"variable\";s:8:\"filepath\";s:42:\"sites/all/modules/variable/variable.module\";}i:80;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:17:\"video_embed_field\";s:8:\"filepath\";s:60:\"sites/all/modules/video_embed_field/video_embed_field.module\";}i:81;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:15:\"views_fieldsets\";s:8:\"filepath\";s:56:\"sites/all/modules/views_fieldsets/views_fieldsets.module\";}i:82;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:15:\"views_slideshow\";s:8:\"filepath\";s:56:\"sites/all/modules/views_slideshow/views_slideshow.module\";}i:83;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:21:\"views_slideshow_cycle\";s:8:\"filepath\";s:92:\"sites/all/modules/views_slideshow/contrib/views_slideshow_cycle/views_slideshow_cycle.module\";}i:84;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:8:\"views_ui\";s:8:\"filepath\";s:39:\"sites/all/modules/views/views_ui.module\";}i:85;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:9:\"votingapi\";s:8:\"filepath\";s:44:\"sites/all/modules/votingapi/votingapi.module\";}i:86;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:13:\"webform_hints\";s:8:\"filepath\";s:52:\"sites/all/modules/webform_hints/webform_hints.module\";}i:87;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:13:\"wee_shortcode\";s:8:\"filepath\";s:52:\"sites/all/modules/wee_shortcode/wee_shortcode.module\";}i:88;a:3:{s:4:\"type\";s:5:\"theme\";s:4:\"name\";s:10:\"we_backend\";s:8:\"filepath\";s:43:\"sites/all/themes/we_backend/we_backend.info\";}i:89;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:20:\"we_content_migration\";s:8:\"filepath\";s:66:\"sites/all/modules/we_content_migration/we_content_migration.module\";}i:90;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:11:\"field_group\";s:8:\"filepath\";s:48:\"sites/all/modules/field_group/field_group.module\";}i:91;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:5:\"forum\";s:8:\"filepath\";s:26:\"modules/forum/forum.module\";}i:92;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:8:\"pathauto\";s:8:\"filepath\";s:42:\"sites/all/modules/pathauto/pathauto.module\";}i:93;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:13:\"i18n_taxonomy\";s:8:\"filepath\";s:57:\"sites/all/modules/i18n/i18n_taxonomy/i18n_taxonomy.module\";}i:94;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:4:\"i18n\";s:8:\"filepath\";s:34:\"sites/all/modules/i18n/i18n.module\";}i:95;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:11:\"i18n_string\";s:8:\"filepath\";s:53:\"sites/all/modules/i18n/i18n_string/i18n_string.module\";}i:96;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:5:\"views\";s:8:\"filepath\";s:36:\"sites/all/modules/views/views.module\";}i:97;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:14:\"advanced_forum\";s:8:\"filepath\";s:54:\"sites/all/modules/advanced_forum/advanced_forum.module\";}i:98;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:8:\"features\";s:8:\"filepath\";s:42:\"sites/all/modules/features/features.module\";}i:99;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:10:\"admin_menu\";s:8:\"filepath\";s:46:\"sites/all/modules/admin_menu/admin_menu.module\";}i:100;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:10:\"i18n_block\";s:8:\"filepath\";s:51:\"sites/all/modules/i18n/i18n_block/i18n_block.module\";}i:101;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:18:\"admin_menu_toolbar\";s:8:\"filepath\";s:73:\"sites/all/modules/admin_menu/admin_menu_toolbar/admin_menu_toolbar.module\";}i:102;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:8:\"standard\";s:8:\"filepath\";s:34:\"profiles/standard/standard.profile\";}}}',0,1512620340,1);
/*!40000 ALTER TABLE `cache_bootstrap` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `cache_entity_message`
--

DROP TABLE IF EXISTS `cache_entity_message`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `cache_entity_message` (
  `cid` varchar(255) NOT NULL DEFAULT '' COMMENT 'Primary Key: Unique cache ID.',
  `data` longblob COMMENT 'A collection of data to cache.',
  `expire` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry should expire, or 0 for never.',
  `created` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry was created.',
  `serialized` smallint(6) NOT NULL DEFAULT '0' COMMENT 'A flag to indicate whether content is serialized (1) or not (0).',
  PRIMARY KEY (`cid`),
  KEY `expire` (`expire`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Cache table used to store message entity records.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `cache_entity_message`
--

LOCK TABLES `cache_entity_message` WRITE;
/*!40000 ALTER TABLE `cache_entity_message` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `cache_entity_message` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `cache_entity_message_type`
--

DROP TABLE IF EXISTS `cache_entity_message_type`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `cache_entity_message_type` (
  `cid` varchar(255) NOT NULL DEFAULT '' COMMENT 'Primary Key: Unique cache ID.',
  `data` longblob COMMENT 'A collection of data to cache.',
  `expire` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry should expire, or 0 for never.',
  `created` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry was created.',
  `serialized` smallint(6) NOT NULL DEFAULT '0' COMMENT 'A flag to indicate whether content is serialized (1) or not (0).',
  PRIMARY KEY (`cid`),
  KEY `expire` (`expire`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Cache table used to store message_type entity records.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `cache_entity_message_type`
--

LOCK TABLES `cache_entity_message_type` WRITE;
/*!40000 ALTER TABLE `cache_entity_message_type` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `cache_entity_message_type` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `cache_entity_message_type_category`
--

DROP TABLE IF EXISTS `cache_entity_message_type_category`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `cache_entity_message_type_category` (
  `cid` varchar(255) NOT NULL DEFAULT '' COMMENT 'Primary Key: Unique cache ID.',
  `data` longblob COMMENT 'A collection of data to cache.',
  `expire` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry should expire, or 0 for never.',
  `created` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry was created.',
  `serialized` smallint(6) NOT NULL DEFAULT '0' COMMENT 'A flag to indicate whether content is serialized (1) or not (0).',
  PRIMARY KEY (`cid`),
  KEY `expire` (`expire`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Cache table used to store message_type_category entity...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `cache_entity_message_type_category`
--

LOCK TABLES `cache_entity_message_type_category` WRITE;
/*!40000 ALTER TABLE `cache_entity_message_type_category` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `cache_entity_message_type_category` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `cache_features`
--

DROP TABLE IF EXISTS `cache_features`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `cache_features` (
  `cid` varchar(255) NOT NULL DEFAULT '' COMMENT 'Primary Key: Unique cache ID.',
  `data` longblob COMMENT 'A collection of data to cache.',
  `expire` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry should expire, or 0 for never.',
  `created` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry was created.',
  `serialized` smallint(6) NOT NULL DEFAULT '0' COMMENT 'A flag to indicate whether content is serialized (1) or not (0).',
  PRIMARY KEY (`cid`),
  KEY `expire` (`expire`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Generic cache table for caching things not separated out...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `cache_features`
--

LOCK TABLES `cache_features` WRITE;
/*!40000 ALTER TABLE `cache_features` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `cache_features` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `cache_field`
--

DROP TABLE IF EXISTS `cache_field`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `cache_field` (
  `cid` varchar(255) NOT NULL DEFAULT '' COMMENT 'Primary Key: Unique cache ID.',
  `data` longblob COMMENT 'A collection of data to cache.',
  `expire` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry should expire, or 0 for never.',
  `created` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry was created.',
  `serialized` smallint(6) NOT NULL DEFAULT '0' COMMENT 'A flag to indicate whether content is serialized (1) or not (0).',
  PRIMARY KEY (`cid`),
  KEY `expire` (`expire`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Generic cache table for caching things not separated out...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `cache_field`
--

LOCK TABLES `cache_field` WRITE;
/*!40000 ALTER TABLE `cache_field` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `cache_field` VALUES ('field:message_type:1','a:1:{s:12:\"message_text\";a:4:{s:2:\"ar\";a:1:{i:0;a:3:{s:5:\"value\";s:210:\"<p><a href=\"[message:user:url]\">[message:user]</a> have just commented <a href=\"[message:field-node-ref:url]\">[message:field-comment-ref:node]</a></p>\r\n\r\n<p>[message:field-comment-ref:comment-text-teaser]</p>\r\n\";s:6:\"format\";s:9:\"full_html\";s:10:\"safe_value\";s:206:\"<p><a href=\"[message:user:url]\">[message:user]</a> have just commented <a href=\"[message:field-node-ref:url]\">[message:field-comment-ref:node]</a></p>\n<p>[message:field-comment-ref:comment-text-teaser]</p>\n\";}}s:2:\"en\";a:1:{i:0;a:3:{s:5:\"value\";s:207:\"<p><a href=\"[message:user:url]\">[message:user]</a> have just commented <a href=\"[message:field-node-ref:url]\">[message:field-comment-ref:node]</a></p>\n\n<p>[message:field-comment-ref:comment-text-teaser]</p>\n\";s:6:\"format\";s:9:\"full_html\";s:10:\"safe_value\";s:206:\"<p><a href=\"[message:user:url]\">[message:user]</a> have just commented <a href=\"[message:field-node-ref:url]\">[message:field-comment-ref:node]</a></p>\n<p>[message:field-comment-ref:comment-text-teaser]</p>\n\";}}s:2:\"fr\";a:1:{i:0;a:3:{s:5:\"value\";s:194:\"<a href=\"[message:user:url]\">[message:user]</a> viennent commentaires <a href=\"[message:field-node-ref:url]\">[message:field-comment-ref:node]</a> [message:field-comment-ref:comment-text-teaser]\n\";s:6:\"format\";s:9:\"full_html\";s:10:\"safe_value\";s:201:\"<p><a href=\"[message:user:url]\">[message:user]</a> viennent commentaires <a href=\"[message:field-node-ref:url]\">[message:field-comment-ref:node]</a> [message:field-comment-ref:comment-text-teaser]</p>\n\";}}s:3:\"und\";a:2:{i:0;a:3:{s:5:\"value\";s:143:\"<a href=\"[message:user:url]\">@{message:user:name}</a> <a href=\"[message:field-comment-ref:url]\">commented</a> on [message:field-node-ref:title]\";s:6:\"format\";s:9:\"full_html\";s:10:\"safe_value\";s:151:\"<p><a href=\"[message:user:url]\">@{message:user:name}</a> <a href=\"[message:field-comment-ref:url]\">commented</a> on [message:field-node-ref:title]</p>\n\";}i:1;a:3:{s:5:\"value\";s:42:\"[message:field-comment-ref:comment-teaser]\";s:6:\"format\";s:9:\"full_html\";s:10:\"safe_value\";s:50:\"<p>[message:field-comment-ref:comment-teaser]</p>\n\";}}}}',0,1512620348,1),('field:message_type:2','a:1:{s:12:\"message_text\";a:4:{s:2:\"ar\";a:1:{i:0;a:3:{s:5:\"value\";s:141:\"<p><a href=\"[message:user:url]\">[message:user]</a> have just posted <a href=\"[message:field-node-ref:url]\">[message:field-node-ref]</a></p>\r\n\";s:6:\"format\";s:9:\"full_html\";s:10:\"safe_value\";s:140:\"<p><a href=\"[message:user:url]\">[message:user]</a> have just posted <a href=\"[message:field-node-ref:url]\">[message:field-node-ref]</a></p>\n\";}}s:2:\"en\";a:1:{i:0;a:3:{s:5:\"value\";s:140:\"<p><a href=\"[message:user:url]\">[message:user]</a> have just posted <a href=\"[message:field-node-ref:url]\">[message:field-node-ref]</a></p>\n\";s:6:\"format\";s:9:\"full_html\";s:10:\"safe_value\";s:140:\"<p><a href=\"[message:user:url]\">[message:user]</a> have just posted <a href=\"[message:field-node-ref:url]\">[message:field-node-ref]</a></p>\n\";}}s:2:\"fr\";a:1:{i:0;a:3:{s:5:\"value\";s:140:\"<p><a href=\"[message:user:url]\">[message:user]</a> viennent posté <a href=\"[message:field-node-ref:url]\">[message:field-node-ref]</a></p>\r\n\";s:6:\"format\";s:9:\"full_html\";s:10:\"safe_value\";s:139:\"<p><a href=\"[message:user:url]\">[message:user]</a> viennent posté <a href=\"[message:field-node-ref:url]\">[message:field-node-ref]</a></p>\n\";}}s:3:\"und\";a:2:{i:0;a:3:{s:5:\"value\";s:135:\"<a href=\"[message:user:url]\">@{message:user:name}</a> created <a href=\"[message:field-node-ref:url]\">[message:field-node-ref:title]</a>\";s:6:\"format\";s:9:\"full_html\";s:10:\"safe_value\";s:143:\"<p><a href=\"[message:user:url]\">@{message:user:name}</a> created <a href=\"[message:field-node-ref:url]\">[message:field-node-ref:title]</a></p>\n\";}i:1;a:3:{s:5:\"value\";s:36:\"[message:field-node-ref:node-teaser]\";s:6:\"format\";s:9:\"full_html\";s:10:\"safe_value\";s:44:\"<p>[message:field-node-ref:node-teaser]</p>\n\";}}}}',0,1512620348,1),('field:message_type:3','a:1:{s:12:\"message_text\";a:4:{s:2:\"ar\";a:1:{i:0;a:3:{s:5:\"value\";s:74:\"<p><a href=\"[message:user:url]\">[message:user]</a> joined Forum Plus</p>\r\n\";s:6:\"format\";s:9:\"full_html\";s:10:\"safe_value\";s:73:\"<p><a href=\"[message:user:url]\">[message:user]</a> joined Forum Plus</p>\n\";}}s:2:\"en\";a:1:{i:0;a:3:{s:5:\"value\";s:73:\"<p><a href=\"[message:user:url]\">[message:user]</a> joined Forum Plus</p>\n\";s:6:\"format\";s:9:\"full_html\";s:10:\"safe_value\";s:73:\"<p><a href=\"[message:user:url]\">[message:user]</a> joined Forum Plus</p>\n\";}}s:2:\"fr\";a:1:{i:0;a:3:{s:5:\"value\";s:65:\"<a href=\"[message:user:url]\">[message:user]</a> relié Forum Plus\";s:6:\"format\";s:9:\"full_html\";s:10:\"safe_value\";s:73:\"<p><a href=\"[message:user:url]\">[message:user]</a> relié Forum Plus</p>\n\";}}s:3:\"und\";a:1:{i:0;a:3:{s:5:\"value\";s:65:\"<a href=\"[message:user:url]\">@{message:user:name}</a> registered.\";s:6:\"format\";s:9:\"full_html\";s:10:\"safe_value\";s:73:\"<p><a href=\"[message:user:url]\">@{message:user:name}</a> registered.</p>\n\";}}}}',0,1512620348,1),('field:user:1','a:0:{}',0,1512620327,1),('field_groups','a:0:{}',0,1512620348,1),('field_info:bundle:comment:comment_node_article','a:2:{s:9:\"instances\";a:1:{s:12:\"comment_body\";a:13:{s:5:\"label\";s:7:\"Comment\";s:8:\"settings\";a:2:{s:15:\"text_processing\";i:1;s:18:\"user_register_form\";b:0;}s:8:\"required\";b:1;s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";}}s:6:\"widget\";a:4:{s:4:\"type\";s:13:\"text_textarea\";s:8:\"settings\";a:1:{s:4:\"rows\";i:5;}s:6:\"weight\";i:0;s:6:\"module\";s:4:\"text\";}s:11:\"description\";s:0:\"\";s:2:\"id\";s:1:\"3\";s:8:\"field_id\";s:1:\"1\";s:10:\"field_name\";s:12:\"comment_body\";s:11:\"entity_type\";s:7:\"comment\";s:6:\"bundle\";s:20:\"comment_node_article\";s:7:\"deleted\";s:1:\"0\";s:13:\"default_value\";N;}}s:6:\"fields\";a:1:{i:0;a:16:{s:12:\"entity_types\";a:1:{i:0;s:7:\"comment\";}s:12:\"translatable\";s:1:\"0\";s:8:\"settings\";a:0:{}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:23:\"field_data_comment_body\";a:2:{s:5:\"value\";s:18:\"comment_body_value\";s:6:\"format\";s:19:\"comment_body_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:27:\"field_revision_comment_body\";a:2:{s:5:\"value\";s:18:\"comment_body_value\";s:6:\"format\";s:19:\"comment_body_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:1:\"1\";s:10:\"field_name\";s:12:\"comment_body\";s:4:\"type\";s:9:\"text_long\";s:6:\"module\";s:4:\"text\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:2:{s:5:\"value\";a:3:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:3:\"big\";s:8:\"not null\";b:0;}s:6:\"format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:7:\"comment\";a:9:{i:0;s:17:\"comment_node_page\";i:1;s:20:\"comment_node_article\";i:2;s:17:\"comment_node_blog\";i:3;s:17:\"comment_node_book\";i:4;s:18:\"comment_node_forum\";i:5;s:16:\"comment_node_faq\";i:6;s:18:\"comment_node_video\";i:7;s:20:\"comment_node_webform\";i:8;s:21:\"comment_node_products\";}}}}}',0,1512620340,1),('field_info:bundle:comment:comment_node_blog','a:2:{s:9:\"instances\";a:1:{s:12:\"comment_body\";a:13:{s:5:\"label\";s:7:\"Comment\";s:8:\"settings\";a:2:{s:15:\"text_processing\";i:1;s:18:\"user_register_form\";b:0;}s:8:\"required\";b:1;s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";}}s:6:\"widget\";a:4:{s:4:\"type\";s:13:\"text_textarea\";s:8:\"settings\";a:1:{s:4:\"rows\";i:5;}s:6:\"weight\";i:0;s:6:\"module\";s:4:\"text\";}s:11:\"description\";s:0:\"\";s:2:\"id\";s:1:\"7\";s:8:\"field_id\";s:1:\"1\";s:10:\"field_name\";s:12:\"comment_body\";s:11:\"entity_type\";s:7:\"comment\";s:6:\"bundle\";s:17:\"comment_node_blog\";s:7:\"deleted\";s:1:\"0\";s:13:\"default_value\";N;}}s:6:\"fields\";a:1:{i:0;a:16:{s:12:\"entity_types\";a:1:{i:0;s:7:\"comment\";}s:12:\"translatable\";s:1:\"0\";s:8:\"settings\";a:0:{}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:23:\"field_data_comment_body\";a:2:{s:5:\"value\";s:18:\"comment_body_value\";s:6:\"format\";s:19:\"comment_body_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:27:\"field_revision_comment_body\";a:2:{s:5:\"value\";s:18:\"comment_body_value\";s:6:\"format\";s:19:\"comment_body_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:1:\"1\";s:10:\"field_name\";s:12:\"comment_body\";s:4:\"type\";s:9:\"text_long\";s:6:\"module\";s:4:\"text\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:2:{s:5:\"value\";a:3:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:3:\"big\";s:8:\"not null\";b:0;}s:6:\"format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:7:\"comment\";a:9:{i:0;s:17:\"comment_node_page\";i:1;s:20:\"comment_node_article\";i:2;s:17:\"comment_node_blog\";i:3;s:17:\"comment_node_book\";i:4;s:18:\"comment_node_forum\";i:5;s:16:\"comment_node_faq\";i:6;s:18:\"comment_node_video\";i:7;s:20:\"comment_node_webform\";i:8;s:21:\"comment_node_products\";}}}}}',0,1512620340,1),('field_info:bundle:comment:comment_node_book','a:2:{s:9:\"instances\";a:1:{s:12:\"comment_body\";a:13:{s:5:\"label\";s:7:\"Comment\";s:8:\"settings\";a:2:{s:15:\"text_processing\";i:1;s:18:\"user_register_form\";b:0;}s:8:\"required\";b:1;s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";}}s:6:\"widget\";a:4:{s:4:\"type\";s:13:\"text_textarea\";s:8:\"settings\";a:1:{s:4:\"rows\";i:5;}s:6:\"weight\";i:0;s:6:\"module\";s:4:\"text\";}s:11:\"description\";s:0:\"\";s:2:\"id\";s:1:\"9\";s:8:\"field_id\";s:1:\"1\";s:10:\"field_name\";s:12:\"comment_body\";s:11:\"entity_type\";s:7:\"comment\";s:6:\"bundle\";s:17:\"comment_node_book\";s:7:\"deleted\";s:1:\"0\";s:13:\"default_value\";N;}}s:6:\"fields\";a:1:{i:0;a:16:{s:12:\"entity_types\";a:1:{i:0;s:7:\"comment\";}s:12:\"translatable\";s:1:\"0\";s:8:\"settings\";a:0:{}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:23:\"field_data_comment_body\";a:2:{s:5:\"value\";s:18:\"comment_body_value\";s:6:\"format\";s:19:\"comment_body_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:27:\"field_revision_comment_body\";a:2:{s:5:\"value\";s:18:\"comment_body_value\";s:6:\"format\";s:19:\"comment_body_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:1:\"1\";s:10:\"field_name\";s:12:\"comment_body\";s:4:\"type\";s:9:\"text_long\";s:6:\"module\";s:4:\"text\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:2:{s:5:\"value\";a:3:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:3:\"big\";s:8:\"not null\";b:0;}s:6:\"format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:7:\"comment\";a:9:{i:0;s:17:\"comment_node_page\";i:1;s:20:\"comment_node_article\";i:2;s:17:\"comment_node_blog\";i:3;s:17:\"comment_node_book\";i:4;s:18:\"comment_node_forum\";i:5;s:16:\"comment_node_faq\";i:6;s:18:\"comment_node_video\";i:7;s:20:\"comment_node_webform\";i:8;s:21:\"comment_node_products\";}}}}}',0,1512620340,1),('field_info:bundle:comment:comment_node_faq','a:2:{s:9:\"instances\";a:1:{s:12:\"comment_body\";a:13:{s:5:\"label\";s:7:\"Comment\";s:8:\"settings\";a:2:{s:15:\"text_processing\";i:1;s:18:\"user_register_form\";b:0;}s:8:\"required\";b:1;s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";}}s:6:\"widget\";a:4:{s:4:\"type\";s:13:\"text_textarea\";s:8:\"settings\";a:1:{s:4:\"rows\";i:5;}s:6:\"weight\";i:0;s:6:\"module\";s:4:\"text\";}s:11:\"description\";s:0:\"\";s:2:\"id\";s:2:\"28\";s:8:\"field_id\";s:1:\"1\";s:10:\"field_name\";s:12:\"comment_body\";s:11:\"entity_type\";s:7:\"comment\";s:6:\"bundle\";s:16:\"comment_node_faq\";s:7:\"deleted\";s:1:\"0\";s:13:\"default_value\";N;}}s:6:\"fields\";a:1:{i:0;a:16:{s:12:\"entity_types\";a:1:{i:0;s:7:\"comment\";}s:12:\"translatable\";s:1:\"0\";s:8:\"settings\";a:0:{}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:23:\"field_data_comment_body\";a:2:{s:5:\"value\";s:18:\"comment_body_value\";s:6:\"format\";s:19:\"comment_body_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:27:\"field_revision_comment_body\";a:2:{s:5:\"value\";s:18:\"comment_body_value\";s:6:\"format\";s:19:\"comment_body_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:1:\"1\";s:10:\"field_name\";s:12:\"comment_body\";s:4:\"type\";s:9:\"text_long\";s:6:\"module\";s:4:\"text\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:2:{s:5:\"value\";a:3:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:3:\"big\";s:8:\"not null\";b:0;}s:6:\"format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:7:\"comment\";a:9:{i:0;s:17:\"comment_node_page\";i:1;s:20:\"comment_node_article\";i:2;s:17:\"comment_node_blog\";i:3;s:17:\"comment_node_book\";i:4;s:18:\"comment_node_forum\";i:5;s:16:\"comment_node_faq\";i:6;s:18:\"comment_node_video\";i:7;s:20:\"comment_node_webform\";i:8;s:21:\"comment_node_products\";}}}}}',0,1512620340,1),('field_info:bundle:comment:comment_node_forum','a:2:{s:9:\"instances\";a:2:{s:12:\"comment_body\";a:13:{s:5:\"label\";s:7:\"Comment\";s:8:\"settings\";a:2:{s:15:\"text_processing\";i:1;s:18:\"user_register_form\";b:0;}s:8:\"required\";b:1;s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";s:1:\"0\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";}}s:6:\"widget\";a:4:{s:4:\"type\";s:13:\"text_textarea\";s:8:\"settings\";a:1:{s:4:\"rows\";i:5;}s:6:\"weight\";s:1:\"2\";s:6:\"module\";s:4:\"text\";}s:11:\"description\";s:0:\"\";s:2:\"id\";s:2:\"12\";s:8:\"field_id\";s:1:\"1\";s:10:\"field_name\";s:12:\"comment_body\";s:11:\"entity_type\";s:7:\"comment\";s:6:\"bundle\";s:18:\"comment_node_forum\";s:7:\"deleted\";s:1:\"0\";s:13:\"default_value\";N;}s:10:\"field_vote\";a:13:{s:5:\"label\";s:4:\"Vote\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"4\";s:4:\"type\";s:7:\"exposed\";s:6:\"module\";s:8:\"fivestar\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:6:\"widget\";a:1:{s:15:\"fivestar_widget\";s:7:\"default\";}}}s:8:\"settings\";a:6:{s:5:\"stars\";s:1:\"5\";s:11:\"allow_clear\";i:0;s:12:\"allow_revote\";i:0;s:13:\"allow_ownvote\";i:1;s:6:\"target\";s:4:\"none\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:26:\"fivestar_formatter_default\";s:6:\"weight\";s:1:\"2\";s:8:\"settings\";a:4:{s:6:\"widget\";a:1:{s:15:\"fivestar_widget\";s:50:\"sites/all/modules/fivestar/widgets/basic/basic.css\";}s:6:\"expose\";i:1;s:5:\"style\";s:5:\"smart\";s:4:\"text\";s:5:\"smart\";}s:6:\"module\";s:8:\"fivestar\";}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;s:2:\"id\";s:2:\"15\";s:8:\"field_id\";s:1:\"6\";s:10:\"field_name\";s:10:\"field_vote\";s:11:\"entity_type\";s:7:\"comment\";s:6:\"bundle\";s:18:\"comment_node_forum\";s:7:\"deleted\";s:1:\"0\";}}s:6:\"fields\";a:2:{i:0;a:16:{s:12:\"entity_types\";a:1:{i:0;s:7:\"comment\";}s:12:\"translatable\";s:1:\"0\";s:8:\"settings\";a:0:{}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:23:\"field_data_comment_body\";a:2:{s:5:\"value\";s:18:\"comment_body_value\";s:6:\"format\";s:19:\"comment_body_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:27:\"field_revision_comment_body\";a:2:{s:5:\"value\";s:18:\"comment_body_value\";s:6:\"format\";s:19:\"comment_body_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:1:\"1\";s:10:\"field_name\";s:12:\"comment_body\";s:4:\"type\";s:9:\"text_long\";s:6:\"module\";s:4:\"text\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:2:{s:5:\"value\";a:3:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:3:\"big\";s:8:\"not null\";b:0;}s:6:\"format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:7:\"comment\";a:9:{i:0;s:17:\"comment_node_page\";i:1;s:20:\"comment_node_article\";i:2;s:17:\"comment_node_blog\";i:3;s:17:\"comment_node_book\";i:4;s:18:\"comment_node_forum\";i:5;s:16:\"comment_node_faq\";i:6;s:18:\"comment_node_video\";i:7;s:20:\"comment_node_webform\";i:8;s:21:\"comment_node_products\";}}}i:1;a:16:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:4:\"axis\";s:4:\"vote\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:21:\"field_data_field_vote\";a:2:{s:6:\"rating\";s:17:\"field_vote_rating\";s:6:\"target\";s:17:\"field_vote_target\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:25:\"field_revision_field_vote\";a:2:{s:6:\"rating\";s:17:\"field_vote_rating\";s:6:\"target\";s:17:\"field_vote_target\";}}}}}s:12:\"foreign keys\";a:0:{}s:7:\"indexes\";a:0:{}s:2:\"id\";s:1:\"6\";s:10:\"field_name\";s:10:\"field_vote\";s:4:\"type\";s:8:\"fivestar\";s:6:\"module\";s:8:\"fivestar\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:2:{s:6:\"rating\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;s:8:\"sortable\";b:1;}s:6:\"target\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}}s:7:\"bundles\";a:2:{s:4:\"node\";a:2:{i:0;s:5:\"forum\";i:1;s:4:\"blog\";}s:7:\"comment\";a:1:{i:0;s:18:\"comment_node_forum\";}}}}}',0,1512620340,1),('field_info:bundle:comment:comment_node_page','a:2:{s:9:\"instances\";a:1:{s:12:\"comment_body\";a:13:{s:5:\"label\";s:7:\"Comment\";s:8:\"settings\";a:2:{s:15:\"text_processing\";i:1;s:18:\"user_register_form\";b:0;}s:8:\"required\";b:1;s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";}}s:6:\"widget\";a:4:{s:4:\"type\";s:13:\"text_textarea\";s:8:\"settings\";a:1:{s:4:\"rows\";i:5;}s:6:\"weight\";i:0;s:6:\"module\";s:4:\"text\";}s:11:\"description\";s:0:\"\";s:2:\"id\";s:1:\"1\";s:8:\"field_id\";s:1:\"1\";s:10:\"field_name\";s:12:\"comment_body\";s:11:\"entity_type\";s:7:\"comment\";s:6:\"bundle\";s:17:\"comment_node_page\";s:7:\"deleted\";s:1:\"0\";s:13:\"default_value\";N;}}s:6:\"fields\";a:1:{i:0;a:16:{s:12:\"entity_types\";a:1:{i:0;s:7:\"comment\";}s:12:\"translatable\";s:1:\"0\";s:8:\"settings\";a:0:{}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:23:\"field_data_comment_body\";a:2:{s:5:\"value\";s:18:\"comment_body_value\";s:6:\"format\";s:19:\"comment_body_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:27:\"field_revision_comment_body\";a:2:{s:5:\"value\";s:18:\"comment_body_value\";s:6:\"format\";s:19:\"comment_body_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:1:\"1\";s:10:\"field_name\";s:12:\"comment_body\";s:4:\"type\";s:9:\"text_long\";s:6:\"module\";s:4:\"text\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:2:{s:5:\"value\";a:3:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:3:\"big\";s:8:\"not null\";b:0;}s:6:\"format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:7:\"comment\";a:9:{i:0;s:17:\"comment_node_page\";i:1;s:20:\"comment_node_article\";i:2;s:17:\"comment_node_blog\";i:3;s:17:\"comment_node_book\";i:4;s:18:\"comment_node_forum\";i:5;s:16:\"comment_node_faq\";i:6;s:18:\"comment_node_video\";i:7;s:20:\"comment_node_webform\";i:8;s:21:\"comment_node_products\";}}}}}',0,1512620340,1),('field_info:bundle:comment:comment_node_products','a:2:{s:9:\"instances\";a:1:{s:12:\"comment_body\";a:13:{s:5:\"label\";s:7:\"Comment\";s:8:\"settings\";a:2:{s:15:\"text_processing\";i:1;s:18:\"user_register_form\";b:0;}s:8:\"required\";b:1;s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";}}s:6:\"widget\";a:4:{s:4:\"type\";s:13:\"text_textarea\";s:8:\"settings\";a:1:{s:4:\"rows\";i:5;}s:6:\"weight\";i:0;s:6:\"module\";s:4:\"text\";}s:11:\"description\";s:0:\"\";s:2:\"id\";s:2:\"36\";s:8:\"field_id\";s:1:\"1\";s:10:\"field_name\";s:12:\"comment_body\";s:11:\"entity_type\";s:7:\"comment\";s:6:\"bundle\";s:21:\"comment_node_products\";s:7:\"deleted\";s:1:\"0\";s:13:\"default_value\";N;}}s:6:\"fields\";a:1:{i:0;a:16:{s:12:\"entity_types\";a:1:{i:0;s:7:\"comment\";}s:12:\"translatable\";s:1:\"0\";s:8:\"settings\";a:0:{}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:23:\"field_data_comment_body\";a:2:{s:5:\"value\";s:18:\"comment_body_value\";s:6:\"format\";s:19:\"comment_body_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:27:\"field_revision_comment_body\";a:2:{s:5:\"value\";s:18:\"comment_body_value\";s:6:\"format\";s:19:\"comment_body_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:1:\"1\";s:10:\"field_name\";s:12:\"comment_body\";s:4:\"type\";s:9:\"text_long\";s:6:\"module\";s:4:\"text\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:2:{s:5:\"value\";a:3:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:3:\"big\";s:8:\"not null\";b:0;}s:6:\"format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:7:\"comment\";a:9:{i:0;s:17:\"comment_node_page\";i:1;s:20:\"comment_node_article\";i:2;s:17:\"comment_node_blog\";i:3;s:17:\"comment_node_book\";i:4;s:18:\"comment_node_forum\";i:5;s:16:\"comment_node_faq\";i:6;s:18:\"comment_node_video\";i:7;s:20:\"comment_node_webform\";i:8;s:21:\"comment_node_products\";}}}}}',0,1512620340,1),('field_info:bundle:comment:comment_node_video','a:2:{s:9:\"instances\";a:1:{s:12:\"comment_body\";a:13:{s:5:\"label\";s:7:\"Comment\";s:8:\"settings\";a:2:{s:15:\"text_processing\";i:1;s:18:\"user_register_form\";b:0;}s:8:\"required\";b:1;s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";}}s:6:\"widget\";a:4:{s:4:\"type\";s:13:\"text_textarea\";s:8:\"settings\";a:1:{s:4:\"rows\";i:5;}s:6:\"weight\";i:0;s:6:\"module\";s:4:\"text\";}s:11:\"description\";s:0:\"\";s:2:\"id\";s:2:\"30\";s:8:\"field_id\";s:1:\"1\";s:10:\"field_name\";s:12:\"comment_body\";s:11:\"entity_type\";s:7:\"comment\";s:6:\"bundle\";s:18:\"comment_node_video\";s:7:\"deleted\";s:1:\"0\";s:13:\"default_value\";N;}}s:6:\"fields\";a:1:{i:0;a:16:{s:12:\"entity_types\";a:1:{i:0;s:7:\"comment\";}s:12:\"translatable\";s:1:\"0\";s:8:\"settings\";a:0:{}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:23:\"field_data_comment_body\";a:2:{s:5:\"value\";s:18:\"comment_body_value\";s:6:\"format\";s:19:\"comment_body_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:27:\"field_revision_comment_body\";a:2:{s:5:\"value\";s:18:\"comment_body_value\";s:6:\"format\";s:19:\"comment_body_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:1:\"1\";s:10:\"field_name\";s:12:\"comment_body\";s:4:\"type\";s:9:\"text_long\";s:6:\"module\";s:4:\"text\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:2:{s:5:\"value\";a:3:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:3:\"big\";s:8:\"not null\";b:0;}s:6:\"format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:7:\"comment\";a:9:{i:0;s:17:\"comment_node_page\";i:1;s:20:\"comment_node_article\";i:2;s:17:\"comment_node_blog\";i:3;s:17:\"comment_node_book\";i:4;s:18:\"comment_node_forum\";i:5;s:16:\"comment_node_faq\";i:6;s:18:\"comment_node_video\";i:7;s:20:\"comment_node_webform\";i:8;s:21:\"comment_node_products\";}}}}}',0,1512620340,1),('field_info:bundle:comment:comment_node_webform','a:2:{s:9:\"instances\";a:1:{s:12:\"comment_body\";a:13:{s:5:\"label\";s:7:\"Comment\";s:8:\"settings\";a:2:{s:15:\"text_processing\";i:1;s:18:\"user_register_form\";b:0;}s:8:\"required\";b:1;s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";}}s:6:\"widget\";a:4:{s:4:\"type\";s:13:\"text_textarea\";s:8:\"settings\";a:1:{s:4:\"rows\";i:5;}s:6:\"weight\";i:0;s:6:\"module\";s:4:\"text\";}s:11:\"description\";s:0:\"\";s:2:\"id\";s:2:\"34\";s:8:\"field_id\";s:1:\"1\";s:10:\"field_name\";s:12:\"comment_body\";s:11:\"entity_type\";s:7:\"comment\";s:6:\"bundle\";s:20:\"comment_node_webform\";s:7:\"deleted\";s:1:\"0\";s:13:\"default_value\";N;}}s:6:\"fields\";a:1:{i:0;a:16:{s:12:\"entity_types\";a:1:{i:0;s:7:\"comment\";}s:12:\"translatable\";s:1:\"0\";s:8:\"settings\";a:0:{}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:23:\"field_data_comment_body\";a:2:{s:5:\"value\";s:18:\"comment_body_value\";s:6:\"format\";s:19:\"comment_body_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:27:\"field_revision_comment_body\";a:2:{s:5:\"value\";s:18:\"comment_body_value\";s:6:\"format\";s:19:\"comment_body_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:1:\"1\";s:10:\"field_name\";s:12:\"comment_body\";s:4:\"type\";s:9:\"text_long\";s:6:\"module\";s:4:\"text\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:2:{s:5:\"value\";a:3:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:3:\"big\";s:8:\"not null\";b:0;}s:6:\"format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:7:\"comment\";a:9:{i:0;s:17:\"comment_node_page\";i:1;s:20:\"comment_node_article\";i:2;s:17:\"comment_node_blog\";i:3;s:17:\"comment_node_book\";i:4;s:18:\"comment_node_forum\";i:5;s:16:\"comment_node_faq\";i:6;s:18:\"comment_node_video\";i:7;s:20:\"comment_node_webform\";i:8;s:21:\"comment_node_products\";}}}}}',0,1512620340,1),('field_info:bundle:field_collection_item:field_extra_content','a:2:{s:9:\"instances\";a:3:{s:11:\"field_image\";a:12:{s:5:\"label\";s:5:\"Image\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"0\";s:4:\"type\";s:11:\"image_image\";s:6:\"module\";s:5:\"image\";s:6:\"active\";i:1;s:8:\"settings\";a:2:{s:18:\"progress_indicator\";s:8:\"throbber\";s:19:\"preview_image_style\";s:9:\"thumbnail\";}}s:8:\"settings\";a:9:{s:14:\"file_directory\";s:16:\"field/collection\";s:15:\"file_extensions\";s:16:\"png gif jpg jpeg\";s:12:\"max_filesize\";s:0:\"\";s:14:\"max_resolution\";s:0:\"\";s:14:\"min_resolution\";s:0:\"\";s:9:\"alt_field\";i:0;s:11:\"title_field\";i:0;s:13:\"default_image\";i:0;s:18:\"user_register_form\";b:0;}s:7:\"display\";a:3:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:5:\"image\";s:6:\"weight\";s:1:\"0\";s:8:\"settings\";a:2:{s:11:\"image_style\";s:0:\"\";s:10:\"image_link\";s:0:\"\";}s:6:\"module\";s:5:\"image\";}s:4:\"full\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:5:\"image\";s:6:\"weight\";s:1:\"0\";s:8:\"settings\";a:2:{s:11:\"image_style\";s:0:\"\";s:10:\"image_link\";s:0:\"\";}s:6:\"module\";s:5:\"image\";}s:5:\"token\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:5:\"image\";s:6:\"weight\";s:1:\"0\";s:8:\"settings\";a:2:{s:11:\"image_style\";s:0:\"\";s:10:\"image_link\";s:0:\"\";}s:6:\"module\";s:5:\"image\";}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:2:\"id\";s:2:\"44\";s:8:\"field_id\";s:1:\"4\";s:10:\"field_name\";s:11:\"field_image\";s:11:\"entity_type\";s:21:\"field_collection_item\";s:6:\"bundle\";s:19:\"field_extra_content\";s:7:\"deleted\";s:1:\"0\";}s:17:\"field_description\";a:13:{s:5:\"label\";s:11:\"Description\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"2\";s:4:\"type\";s:13:\"text_textarea\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"rows\";s:1:\"5\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:3:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";s:1:\"2\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";}s:4:\"full\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";s:1:\"2\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";}s:5:\"token\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";s:1:\"2\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;s:2:\"id\";s:2:\"45\";s:8:\"field_id\";s:2:\"17\";s:10:\"field_name\";s:17:\"field_description\";s:11:\"entity_type\";s:21:\"field_collection_item\";s:6:\"bundle\";s:19:\"field_extra_content\";s:7:\"deleted\";s:1:\"0\";}s:16:\"field_video_link\";a:13:{s:5:\"label\";s:10:\"Video Link\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"1\";s:4:\"type\";s:23:\"video_embed_field_video\";s:6:\"module\";s:17:\"video_embed_field\";s:6:\"active\";i:0;s:8:\"settings\";a:0:{}}s:8:\"settings\";a:4:{s:17:\"description_field\";i:0;s:18:\"description_length\";s:3:\"128\";s:18:\"user_register_form\";b:0;s:17:\"allowed_providers\";a:2:{i:0;s:7:\"youtube\";i:1;s:5:\"vimeo\";}}s:7:\"display\";a:3:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:17:\"video_embed_field\";s:6:\"weight\";s:1:\"1\";s:8:\"settings\";a:3:{s:11:\"video_style\";s:5:\"large\";s:11:\"description\";i:1;s:20:\"description_position\";s:6:\"bottom\";}s:6:\"module\";s:17:\"video_embed_field\";}s:4:\"full\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:17:\"video_embed_field\";s:6:\"weight\";s:1:\"1\";s:8:\"settings\";a:3:{s:11:\"video_style\";s:5:\"large\";s:11:\"description\";i:1;s:20:\"description_position\";s:6:\"bottom\";}s:6:\"module\";s:17:\"video_embed_field\";}s:5:\"token\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:17:\"video_embed_field\";s:6:\"weight\";s:1:\"1\";s:8:\"settings\";a:3:{s:11:\"video_style\";s:5:\"large\";s:11:\"description\";i:1;s:20:\"description_position\";s:6:\"bottom\";}s:6:\"module\";s:17:\"video_embed_field\";}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;s:2:\"id\";s:2:\"48\";s:8:\"field_id\";s:2:\"13\";s:10:\"field_name\";s:16:\"field_video_link\";s:11:\"entity_type\";s:21:\"field_collection_item\";s:6:\"bundle\";s:19:\"field_extra_content\";s:7:\"deleted\";s:1:\"0\";}}s:6:\"fields\";a:3:{i:0;a:16:{s:7:\"indexes\";a:1:{s:3:\"fid\";a:1:{i:0;s:3:\"fid\";}}s:8:\"settings\";a:2:{s:10:\"uri_scheme\";s:6:\"public\";s:13:\"default_image\";i:0;}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:22:\"field_data_field_image\";a:5:{s:3:\"fid\";s:15:\"field_image_fid\";s:3:\"alt\";s:15:\"field_image_alt\";s:5:\"title\";s:17:\"field_image_title\";s:5:\"width\";s:17:\"field_image_width\";s:6:\"height\";s:18:\"field_image_height\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:26:\"field_revision_field_image\";a:5:{s:3:\"fid\";s:15:\"field_image_fid\";s:3:\"alt\";s:15:\"field_image_alt\";s:5:\"title\";s:17:\"field_image_title\";s:5:\"width\";s:17:\"field_image_width\";s:6:\"height\";s:18:\"field_image_height\";}}}}}s:12:\"entity_types\";a:0:{}s:12:\"translatable\";s:1:\"0\";s:12:\"foreign keys\";a:1:{s:3:\"fid\";a:2:{s:5:\"table\";s:12:\"file_managed\";s:7:\"columns\";a:1:{s:3:\"fid\";s:3:\"fid\";}}}s:2:\"id\";s:1:\"4\";s:10:\"field_name\";s:11:\"field_image\";s:4:\"type\";s:5:\"image\";s:6:\"module\";s:5:\"image\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:5:{s:3:\"fid\";a:4:{s:11:\"description\";s:54:\"The {file_managed}.fid being referenced in this field.\";s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;s:8:\"unsigned\";b:1;}s:3:\"alt\";a:4:{s:11:\"description\";s:56:\"Alternative image text, for the image\'s \'alt\' attribute.\";s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:512;s:8:\"not null\";b:0;}s:5:\"title\";a:4:{s:11:\"description\";s:52:\"Image title text, for the image\'s \'title\' attribute.\";s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:1024;s:8:\"not null\";b:0;}s:5:\"width\";a:3:{s:11:\"description\";s:33:\"The width of the image in pixels.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;}s:6:\"height\";a:3:{s:11:\"description\";s:34:\"The height of the image in pixels.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;}}s:7:\"bundles\";a:2:{s:4:\"node\";a:3:{i:0;s:7:\"article\";i:1;s:4:\"blog\";i:2;s:8:\"products\";}s:21:\"field_collection_item\";a:1:{i:0;s:19:\"field_extra_content\";}}}i:1;a:16:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:0:{}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:28:\"field_data_field_description\";a:2:{s:5:\"value\";s:23:\"field_description_value\";s:6:\"format\";s:24:\"field_description_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:32:\"field_revision_field_description\";a:2:{s:5:\"value\";s:23:\"field_description_value\";s:6:\"format\";s:24:\"field_description_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:2:\"17\";s:10:\"field_name\";s:17:\"field_description\";s:4:\"type\";s:9:\"text_long\";s:6:\"module\";s:4:\"text\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:2:{s:5:\"value\";a:3:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:3:\"big\";s:8:\"not null\";b:0;}s:6:\"format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:21:\"field_collection_item\";a:1:{i:0;s:19:\"field_extra_content\";}}}i:2;a:16:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:0:{}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:27:\"field_data_field_video_link\";a:5:{s:9:\"video_url\";s:26:\"field_video_link_video_url\";s:14:\"thumbnail_path\";s:31:\"field_video_link_thumbnail_path\";s:10:\"video_data\";s:27:\"field_video_link_video_data\";s:10:\"embed_code\";s:27:\"field_video_link_embed_code\";s:11:\"description\";s:28:\"field_video_link_description\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:31:\"field_revision_field_video_link\";a:5:{s:9:\"video_url\";s:26:\"field_video_link_video_url\";s:14:\"thumbnail_path\";s:31:\"field_video_link_thumbnail_path\";s:10:\"video_data\";s:27:\"field_video_link_video_data\";s:10:\"embed_code\";s:27:\"field_video_link_embed_code\";s:11:\"description\";s:28:\"field_video_link_description\";}}}}}s:12:\"foreign keys\";a:0:{}s:7:\"indexes\";a:0:{}s:2:\"id\";s:2:\"13\";s:10:\"field_name\";s:16:\"field_video_link\";s:4:\"type\";s:17:\"video_embed_field\";s:6:\"module\";s:17:\"video_embed_field\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:5:{s:9:\"video_url\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:512;s:7:\"default\";s:0:\"\";}s:14:\"thumbnail_path\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:512;s:7:\"default\";s:0:\"\";}s:10:\"video_data\";a:4:{s:4:\"type\";s:4:\"blob\";s:8:\"not null\";b:0;s:4:\"size\";s:3:\"big\";s:9:\"serialize\";b:1;}s:10:\"embed_code\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:1024;s:7:\"default\";s:0:\"\";}s:11:\"description\";a:2:{s:4:\"type\";s:4:\"text\";s:8:\"not null\";b:0;}}s:7:\"bundles\";a:2:{s:4:\"node\";a:1:{i:0;s:5:\"video\";}s:21:\"field_collection_item\";a:1:{i:0;s:19:\"field_extra_content\";}}}}}',0,1512620340,1),('field_info:bundle:message:example_create_comment','a:2:{s:9:\"instances\";a:3:{s:17:\"field_comment_ref\";a:14:{s:13:\"default_value\";N;s:22:\"default_value_function\";s:0:\"\";s:11:\"description\";s:0:\"\";s:7:\"display\";a:2:{s:7:\"default\";a:4:{s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:4:\"type\";s:6:\"hidden\";s:6:\"weight\";s:1:\"4\";}s:4:\"full\";a:4:{s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:4:\"type\";s:6:\"hidden\";s:6:\"weight\";s:1:\"2\";}}s:5:\"label\";s:17:\"Comment reference\";s:8:\"required\";i:1;s:8:\"settings\";a:2:{s:9:\"behaviors\";a:1:{s:11:\"prepopulate\";a:4:{s:6:\"action\";s:4:\"hide\";s:8:\"fallback\";s:4:\"none\";s:9:\"skip_perm\";s:26:\"access administration menu\";s:6:\"status\";i:0;}}s:18:\"user_register_form\";b:0;}s:6:\"widget\";a:5:{s:6:\"active\";i:1;s:6:\"module\";s:15:\"entityreference\";s:8:\"settings\";a:3:{s:14:\"match_operator\";s:8:\"CONTAINS\";s:4:\"path\";s:0:\"\";s:4:\"size\";s:2:\"60\";}s:4:\"type\";s:28:\"entityreference_autocomplete\";s:6:\"weight\";s:1:\"1\";}s:2:\"id\";s:2:\"17\";s:8:\"field_id\";s:1:\"8\";s:10:\"field_name\";s:17:\"field_comment_ref\";s:11:\"entity_type\";s:7:\"message\";s:6:\"bundle\";s:22:\"example_create_comment\";s:7:\"deleted\";s:1:\"0\";}s:14:\"field_node_ref\";a:14:{s:13:\"default_value\";N;s:22:\"default_value_function\";s:0:\"\";s:11:\"description\";s:0:\"\";s:7:\"display\";a:2:{s:7:\"default\";a:4:{s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:4:\"type\";s:6:\"hidden\";s:6:\"weight\";s:1:\"3\";}s:4:\"full\";a:4:{s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:4:\"type\";s:6:\"hidden\";s:6:\"weight\";s:1:\"3\";}}s:5:\"label\";s:14:\"Node reference\";s:8:\"required\";i:1;s:8:\"settings\";a:2:{s:9:\"behaviors\";a:1:{s:11:\"prepopulate\";a:4:{s:6:\"action\";s:4:\"hide\";s:8:\"fallback\";s:4:\"none\";s:9:\"skip_perm\";s:26:\"access administration menu\";s:6:\"status\";i:0;}}s:18:\"user_register_form\";b:0;}s:6:\"widget\";a:5:{s:6:\"active\";i:1;s:6:\"module\";s:15:\"entityreference\";s:8:\"settings\";a:3:{s:14:\"match_operator\";s:8:\"CONTAINS\";s:4:\"path\";s:0:\"\";s:4:\"size\";s:2:\"60\";}s:4:\"type\";s:28:\"entityreference_autocomplete\";s:6:\"weight\";i:0;}s:2:\"id\";s:2:\"18\";s:8:\"field_id\";s:1:\"9\";s:10:\"field_name\";s:14:\"field_node_ref\";s:11:\"entity_type\";s:7:\"message\";s:6:\"bundle\";s:22:\"example_create_comment\";s:7:\"deleted\";s:1:\"0\";}s:15:\"field_published\";a:13:{s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";i:0;}}s:11:\"description\";s:0:\"\";s:7:\"display\";a:2:{s:7:\"default\";a:4:{s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:4:\"type\";s:6:\"hidden\";s:6:\"weight\";s:1:\"5\";}s:4:\"full\";a:4:{s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:4:\"type\";s:6:\"hidden\";s:6:\"weight\";s:1:\"4\";}}s:5:\"label\";s:9:\"Published\";s:8:\"required\";i:0;s:8:\"settings\";a:1:{s:18:\"user_register_form\";b:0;}s:6:\"widget\";a:5:{s:6:\"active\";i:1;s:6:\"module\";s:7:\"options\";s:8:\"settings\";a:1:{s:13:\"display_label\";i:0;}s:4:\"type\";s:13:\"options_onoff\";s:6:\"weight\";s:1:\"2\";}s:2:\"id\";s:2:\"19\";s:8:\"field_id\";s:2:\"10\";s:10:\"field_name\";s:15:\"field_published\";s:11:\"entity_type\";s:7:\"message\";s:6:\"bundle\";s:22:\"example_create_comment\";s:7:\"deleted\";s:1:\"0\";}}s:6:\"fields\";a:3:{i:0;a:16:{s:12:\"entity_types\";a:0:{}s:12:\"foreign keys\";a:0:{}s:7:\"indexes\";a:1:{s:9:\"target_id\";a:1:{i:0;s:9:\"target_id\";}}s:8:\"settings\";a:4:{s:7:\"handler\";s:4:\"base\";s:16:\"handler_settings\";a:3:{s:9:\"behaviors\";a:1:{s:17:\"views-select-list\";a:1:{s:6:\"status\";i:0;}}s:4:\"sort\";a:4:{s:9:\"direction\";s:3:\"ASC\";s:5:\"field\";s:18:\"comment_body:value\";s:8:\"property\";s:3:\"nid\";s:4:\"type\";s:4:\"none\";}s:14:\"target_bundles\";a:0:{}}s:14:\"handler_submit\";s:14:\"Change handler\";s:11:\"target_type\";s:7:\"comment\";}s:12:\"translatable\";s:1:\"0\";s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:28:\"field_data_field_comment_ref\";a:1:{s:9:\"target_id\";s:27:\"field_comment_ref_target_id\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:32:\"field_revision_field_comment_ref\";a:1:{s:9:\"target_id\";s:27:\"field_comment_ref_target_id\";}}}}}s:2:\"id\";s:1:\"8\";s:10:\"field_name\";s:17:\"field_comment_ref\";s:4:\"type\";s:15:\"entityreference\";s:6:\"module\";s:15:\"entityreference\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:1:{s:9:\"target_id\";a:4:{s:11:\"description\";s:28:\"The id of the target entity.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}}s:7:\"bundles\";a:1:{s:7:\"message\";a:1:{i:0;s:22:\"example_create_comment\";}}}i:1;a:16:{s:12:\"entity_types\";a:0:{}s:12:\"foreign keys\";a:0:{}s:7:\"indexes\";a:1:{s:9:\"target_id\";a:1:{i:0;s:9:\"target_id\";}}s:8:\"settings\";a:5:{s:7:\"handler\";s:4:\"base\";s:16:\"handler_settings\";a:3:{s:9:\"behaviors\";a:1:{s:17:\"views-select-list\";a:1:{s:6:\"status\";i:0;}}s:4:\"sort\";a:4:{s:9:\"direction\";s:3:\"ASC\";s:5:\"field\";s:10:\"body:value\";s:8:\"property\";s:3:\"nid\";s:4:\"type\";s:4:\"none\";}s:14:\"target_bundles\";a:0:{}}s:14:\"handler_submit\";s:14:\"Change handler\";s:14:\"target_bundles\";a:0:{}s:11:\"target_type\";s:4:\"node\";}s:12:\"translatable\";s:1:\"0\";s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:25:\"field_data_field_node_ref\";a:1:{s:9:\"target_id\";s:24:\"field_node_ref_target_id\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:29:\"field_revision_field_node_ref\";a:1:{s:9:\"target_id\";s:24:\"field_node_ref_target_id\";}}}}}s:2:\"id\";s:1:\"9\";s:10:\"field_name\";s:14:\"field_node_ref\";s:4:\"type\";s:15:\"entityreference\";s:6:\"module\";s:15:\"entityreference\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:1:{s:9:\"target_id\";a:4:{s:11:\"description\";s:28:\"The id of the target entity.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}}s:7:\"bundles\";a:1:{s:7:\"message\";a:2:{i:0;s:22:\"example_create_comment\";i:1;s:19:\"example_create_node\";}}}i:2;a:16:{s:12:\"entity_types\";a:0:{}s:12:\"foreign keys\";a:0:{}s:7:\"indexes\";a:1:{s:5:\"value\";a:1:{i:0;s:5:\"value\";}}s:8:\"settings\";a:2:{s:14:\"allowed_values\";a:2:{i:0;s:11:\"Unpublished\";i:1;s:9:\"Published\";}s:23:\"allowed_values_function\";s:0:\"\";}s:12:\"translatable\";s:1:\"0\";s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:26:\"field_data_field_published\";a:1:{s:5:\"value\";s:21:\"field_published_value\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:30:\"field_revision_field_published\";a:1:{s:5:\"value\";s:21:\"field_published_value\";}}}}}s:2:\"id\";s:2:\"10\";s:10:\"field_name\";s:15:\"field_published\";s:4:\"type\";s:12:\"list_boolean\";s:6:\"module\";s:4:\"list\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:7:\"message\";a:3:{i:0;s:22:\"example_create_comment\";i:1;s:19:\"example_create_node\";i:2;s:21:\"example_user_register\";}}}}}',0,1512620340,1),('field_info:bundle:message:example_create_node','a:2:{s:9:\"instances\";a:2:{s:14:\"field_node_ref\";a:14:{s:13:\"default_value\";N;s:22:\"default_value_function\";s:0:\"\";s:11:\"description\";s:0:\"\";s:7:\"display\";a:2:{s:7:\"default\";a:4:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:6:\"hidden\";s:6:\"weight\";s:1:\"2\";s:8:\"settings\";a:0:{}}s:4:\"full\";a:4:{s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:4:\"type\";s:6:\"hidden\";s:6:\"weight\";s:1:\"5\";}}s:5:\"label\";s:14:\"Node reference\";s:8:\"required\";i:1;s:8:\"settings\";a:2:{s:9:\"behaviors\";a:1:{s:11:\"prepopulate\";a:4:{s:6:\"action\";s:4:\"hide\";s:8:\"fallback\";s:4:\"none\";s:9:\"skip_perm\";s:26:\"access administration menu\";s:6:\"status\";i:0;}}s:18:\"user_register_form\";b:0;}s:6:\"widget\";a:5:{s:6:\"active\";i:1;s:6:\"module\";s:15:\"entityreference\";s:8:\"settings\";a:3:{s:14:\"match_operator\";s:8:\"CONTAINS\";s:4:\"path\";s:0:\"\";s:4:\"size\";s:2:\"60\";}s:4:\"type\";s:28:\"entityreference_autocomplete\";s:6:\"weight\";s:1:\"2\";}s:2:\"id\";s:2:\"20\";s:8:\"field_id\";s:1:\"9\";s:10:\"field_name\";s:14:\"field_node_ref\";s:11:\"entity_type\";s:7:\"message\";s:6:\"bundle\";s:19:\"example_create_node\";s:7:\"deleted\";s:1:\"0\";}s:15:\"field_published\";a:13:{s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";i:0;}}s:11:\"description\";s:0:\"\";s:7:\"display\";a:2:{s:7:\"default\";a:4:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:6:\"hidden\";s:6:\"weight\";s:1:\"1\";s:8:\"settings\";a:0:{}}s:4:\"full\";a:4:{s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:4:\"type\";s:6:\"hidden\";s:6:\"weight\";s:1:\"4\";}}s:5:\"label\";s:9:\"Published\";s:8:\"required\";i:0;s:8:\"settings\";a:1:{s:18:\"user_register_form\";b:0;}s:6:\"widget\";a:5:{s:6:\"active\";i:1;s:6:\"module\";s:7:\"options\";s:8:\"settings\";a:1:{s:13:\"display_label\";i:0;}s:4:\"type\";s:13:\"options_onoff\";s:6:\"weight\";s:1:\"3\";}s:2:\"id\";s:2:\"21\";s:8:\"field_id\";s:2:\"10\";s:10:\"field_name\";s:15:\"field_published\";s:11:\"entity_type\";s:7:\"message\";s:6:\"bundle\";s:19:\"example_create_node\";s:7:\"deleted\";s:1:\"0\";}}s:6:\"fields\";a:2:{i:0;a:16:{s:12:\"entity_types\";a:0:{}s:12:\"foreign keys\";a:0:{}s:7:\"indexes\";a:1:{s:9:\"target_id\";a:1:{i:0;s:9:\"target_id\";}}s:8:\"settings\";a:5:{s:7:\"handler\";s:4:\"base\";s:16:\"handler_settings\";a:3:{s:9:\"behaviors\";a:1:{s:17:\"views-select-list\";a:1:{s:6:\"status\";i:0;}}s:4:\"sort\";a:4:{s:9:\"direction\";s:3:\"ASC\";s:5:\"field\";s:10:\"body:value\";s:8:\"property\";s:3:\"nid\";s:4:\"type\";s:4:\"none\";}s:14:\"target_bundles\";a:0:{}}s:14:\"handler_submit\";s:14:\"Change handler\";s:14:\"target_bundles\";a:0:{}s:11:\"target_type\";s:4:\"node\";}s:12:\"translatable\";s:1:\"0\";s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:25:\"field_data_field_node_ref\";a:1:{s:9:\"target_id\";s:24:\"field_node_ref_target_id\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:29:\"field_revision_field_node_ref\";a:1:{s:9:\"target_id\";s:24:\"field_node_ref_target_id\";}}}}}s:2:\"id\";s:1:\"9\";s:10:\"field_name\";s:14:\"field_node_ref\";s:4:\"type\";s:15:\"entityreference\";s:6:\"module\";s:15:\"entityreference\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:1:{s:9:\"target_id\";a:4:{s:11:\"description\";s:28:\"The id of the target entity.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}}s:7:\"bundles\";a:1:{s:7:\"message\";a:2:{i:0;s:22:\"example_create_comment\";i:1;s:19:\"example_create_node\";}}}i:1;a:16:{s:12:\"entity_types\";a:0:{}s:12:\"foreign keys\";a:0:{}s:7:\"indexes\";a:1:{s:5:\"value\";a:1:{i:0;s:5:\"value\";}}s:8:\"settings\";a:2:{s:14:\"allowed_values\";a:2:{i:0;s:11:\"Unpublished\";i:1;s:9:\"Published\";}s:23:\"allowed_values_function\";s:0:\"\";}s:12:\"translatable\";s:1:\"0\";s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:26:\"field_data_field_published\";a:1:{s:5:\"value\";s:21:\"field_published_value\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:30:\"field_revision_field_published\";a:1:{s:5:\"value\";s:21:\"field_published_value\";}}}}}s:2:\"id\";s:2:\"10\";s:10:\"field_name\";s:15:\"field_published\";s:4:\"type\";s:12:\"list_boolean\";s:6:\"module\";s:4:\"list\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:7:\"message\";a:3:{i:0;s:22:\"example_create_comment\";i:1;s:19:\"example_create_node\";i:2;s:21:\"example_user_register\";}}}}}',0,1512620340,1),('field_info:bundle:message:example_user_register','a:2:{s:9:\"instances\";a:1:{s:15:\"field_published\";a:13:{s:13:\"default_value\";N;s:11:\"description\";s:0:\"\";s:7:\"display\";a:2:{s:7:\"default\";a:4:{s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:4:\"type\";s:6:\"hidden\";s:6:\"weight\";s:1:\"1\";}s:4:\"full\";a:4:{s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:4:\"type\";s:6:\"hidden\";s:6:\"weight\";s:1:\"1\";}}s:5:\"label\";s:9:\"Published\";s:8:\"required\";i:0;s:8:\"settings\";a:1:{s:18:\"user_register_form\";b:0;}s:6:\"widget\";a:5:{s:6:\"active\";i:1;s:6:\"module\";s:7:\"options\";s:8:\"settings\";a:0:{}s:4:\"type\";s:15:\"options_buttons\";s:6:\"weight\";s:1:\"2\";}s:2:\"id\";s:2:\"22\";s:8:\"field_id\";s:2:\"10\";s:10:\"field_name\";s:15:\"field_published\";s:11:\"entity_type\";s:7:\"message\";s:6:\"bundle\";s:21:\"example_user_register\";s:7:\"deleted\";s:1:\"0\";}}s:6:\"fields\";a:1:{i:0;a:16:{s:12:\"entity_types\";a:0:{}s:12:\"foreign keys\";a:0:{}s:7:\"indexes\";a:1:{s:5:\"value\";a:1:{i:0;s:5:\"value\";}}s:8:\"settings\";a:2:{s:14:\"allowed_values\";a:2:{i:0;s:11:\"Unpublished\";i:1;s:9:\"Published\";}s:23:\"allowed_values_function\";s:0:\"\";}s:12:\"translatable\";s:1:\"0\";s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:26:\"field_data_field_published\";a:1:{s:5:\"value\";s:21:\"field_published_value\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:30:\"field_revision_field_published\";a:1:{s:5:\"value\";s:21:\"field_published_value\";}}}}}s:2:\"id\";s:2:\"10\";s:10:\"field_name\";s:15:\"field_published\";s:4:\"type\";s:12:\"list_boolean\";s:6:\"module\";s:4:\"list\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:7:\"message\";a:3:{i:0;s:22:\"example_create_comment\";i:1;s:19:\"example_create_node\";i:2;s:21:\"example_user_register\";}}}}}',0,1512620340,1),('field_info:bundle:message_type:message_type','a:2:{s:9:\"instances\";a:1:{s:12:\"message_text\";a:13:{s:5:\"label\";s:12:\"Message text\";s:11:\"description\";s:46:\"This is the text of all messages of this type.\";s:8:\"required\";b:1;s:8:\"settings\";a:2:{s:15:\"text_processing\";i:1;s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:0;}}s:6:\"widget\";a:4:{s:4:\"type\";s:13:\"text_textarea\";s:8:\"settings\";a:1:{s:4:\"rows\";i:5;}s:6:\"weight\";i:0;s:6:\"module\";s:4:\"text\";}s:2:\"id\";s:2:\"16\";s:8:\"field_id\";s:1:\"7\";s:10:\"field_name\";s:12:\"message_text\";s:11:\"entity_type\";s:12:\"message_type\";s:6:\"bundle\";s:12:\"message_type\";s:7:\"deleted\";s:1:\"0\";s:13:\"default_value\";N;}}s:6:\"fields\";a:1:{i:0;a:16:{s:12:\"entity_types\";a:1:{i:0;s:12:\"message_type\";}s:12:\"translatable\";s:1:\"1\";s:8:\"settings\";a:1:{s:12:\"message_text\";b:1;}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:23:\"field_data_message_text\";a:2:{s:5:\"value\";s:18:\"message_text_value\";s:6:\"format\";s:19:\"message_text_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:27:\"field_revision_message_text\";a:2:{s:5:\"value\";s:18:\"message_text_value\";s:6:\"format\";s:19:\"message_text_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:1:\"7\";s:10:\"field_name\";s:12:\"message_text\";s:4:\"type\";s:9:\"text_long\";s:6:\"module\";s:4:\"text\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"1\";s:11:\"cardinality\";s:2:\"-1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:2:{s:5:\"value\";a:3:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:3:\"big\";s:8:\"not null\";b:0;}s:6:\"format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:12:\"message_type\";a:1:{i:0;s:12:\"message_type\";}}}}}',0,1512620340,1),('field_info:bundle:node:article','a:2:{s:9:\"instances\";a:6:{s:4:\"body\";a:13:{s:5:\"label\";s:4:\"Body\";s:6:\"widget\";a:4:{s:4:\"type\";s:26:\"text_textarea_with_summary\";s:8:\"settings\";a:2:{s:4:\"rows\";i:20;s:12:\"summary_rows\";i:5;}s:6:\"weight\";s:1:\"1\";s:6:\"module\";s:4:\"text\";}s:8:\"settings\";a:3:{s:15:\"display_summary\";b:1;s:15:\"text_processing\";i:1;s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";s:1:\"1\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";}s:6:\"teaser\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:23:\"text_summary_or_trimmed\";s:6:\"weight\";s:1:\"1\";s:8:\"settings\";a:1:{s:11:\"trim_length\";i:600;}s:6:\"module\";s:4:\"text\";}}s:8:\"required\";b:0;s:11:\"description\";s:0:\"\";s:2:\"id\";s:1:\"4\";s:8:\"field_id\";s:1:\"2\";s:10:\"field_name\";s:4:\"body\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:7:\"article\";s:7:\"deleted\";s:1:\"0\";s:13:\"default_value\";N;}s:10:\"field_tags\";a:13:{s:5:\"label\";s:4:\"Tags\";s:11:\"description\";s:63:\"Enter a comma-separated list of words to describe your content.\";s:6:\"widget\";a:4:{s:4:\"type\";s:21:\"taxonomy_autocomplete\";s:6:\"weight\";s:1:\"3\";s:8:\"settings\";a:2:{s:4:\"size\";i:60;s:17:\"autocomplete_path\";s:21:\"taxonomy/autocomplete\";}s:6:\"module\";s:8:\"taxonomy\";}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:28:\"taxonomy_term_reference_link\";s:6:\"weight\";s:1:\"3\";s:8:\"settings\";a:0:{}s:6:\"module\";s:8:\"taxonomy\";}s:6:\"teaser\";a:4:{s:5:\"label\";s:6:\"inline\";s:4:\"type\";s:6:\"hidden\";s:6:\"weight\";s:1:\"2\";s:8:\"settings\";a:0:{}}}s:8:\"settings\";a:1:{s:18:\"user_register_form\";b:0;}s:8:\"required\";b:0;s:2:\"id\";s:1:\"5\";s:8:\"field_id\";s:1:\"3\";s:10:\"field_name\";s:10:\"field_tags\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:7:\"article\";s:7:\"deleted\";s:1:\"0\";s:13:\"default_value\";N;}s:11:\"field_image\";a:12:{s:5:\"label\";s:5:\"Image\";s:11:\"description\";s:40:\"Upload an image to go with this article.\";s:8:\"required\";b:0;s:8:\"settings\";a:9:{s:14:\"file_directory\";s:11:\"field/image\";s:15:\"file_extensions\";s:16:\"png gif jpg jpeg\";s:12:\"max_filesize\";s:0:\"\";s:14:\"max_resolution\";s:0:\"\";s:14:\"min_resolution\";s:0:\"\";s:9:\"alt_field\";b:1;s:11:\"title_field\";s:0:\"\";s:13:\"default_image\";i:0;s:18:\"user_register_form\";b:0;}s:6:\"widget\";a:4:{s:4:\"type\";s:11:\"image_image\";s:8:\"settings\";a:2:{s:18:\"progress_indicator\";s:8:\"throbber\";s:19:\"preview_image_style\";s:9:\"thumbnail\";}s:6:\"weight\";s:1:\"2\";s:6:\"module\";s:5:\"image\";}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:5:\"image\";s:6:\"weight\";s:1:\"0\";s:8:\"settings\";a:2:{s:11:\"image_style\";s:0:\"\";s:10:\"image_link\";s:0:\"\";}s:6:\"module\";s:5:\"image\";}s:6:\"teaser\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:5:\"image\";s:6:\"weight\";s:1:\"0\";s:8:\"settings\";a:2:{s:11:\"image_style\";s:5:\"large\";s:10:\"image_link\";s:7:\"content\";}s:6:\"module\";s:5:\"image\";}}s:2:\"id\";s:1:\"6\";s:8:\"field_id\";s:1:\"4\";s:10:\"field_name\";s:11:\"field_image\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:7:\"article\";s:7:\"deleted\";s:1:\"0\";}s:13:\"field_section\";a:13:{s:5:\"label\";s:7:\"Section\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"5\";s:4:\"type\";s:14:\"options_select\";s:6:\"module\";s:7:\"options\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:12:\"apply_chosen\";s:0:\"\";}}s:8:\"settings\";a:1:{s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:4:{s:5:\"label\";s:6:\"inline\";s:4:\"type\";s:6:\"hidden\";s:6:\"weight\";s:1:\"4\";s:8:\"settings\";a:0:{}}s:6:\"teaser\";a:4:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:6:\"hidden\";s:6:\"weight\";s:1:\"4\";s:8:\"settings\";a:0:{}}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;s:2:\"id\";s:2:\"26\";s:8:\"field_id\";s:2:\"11\";s:10:\"field_name\";s:13:\"field_section\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:7:\"article\";s:7:\"deleted\";s:1:\"0\";}s:14:\"field_category\";a:13:{s:5:\"label\";s:8:\"Category\";s:6:\"widget\";a:4:{s:4:\"type\";s:14:\"options_select\";s:6:\"weight\";s:1:\"6\";s:8:\"settings\";a:3:{s:4:\"size\";i:60;s:17:\"autocomplete_path\";s:21:\"taxonomy/autocomplete\";s:12:\"apply_chosen\";s:0:\"\";}s:6:\"module\";s:7:\"options\";}s:8:\"settings\";a:1:{s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:4:{s:5:\"label\";s:6:\"inline\";s:4:\"type\";s:6:\"hidden\";s:6:\"weight\";s:1:\"5\";s:8:\"settings\";a:0:{}}s:6:\"teaser\";a:4:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:6:\"hidden\";s:6:\"weight\";s:1:\"3\";s:8:\"settings\";a:0:{}}}s:8:\"required\";b:0;s:11:\"description\";s:0:\"\";s:2:\"id\";s:2:\"27\";s:8:\"field_id\";s:2:\"12\";s:10:\"field_name\";s:14:\"field_category\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:7:\"article\";s:7:\"deleted\";s:1:\"0\";s:13:\"default_value\";N;}s:19:\"field_extra_content\";a:13:{s:5:\"label\";s:13:\"Extra content\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"8\";s:4:\"type\";s:22:\"field_collection_embed\";s:6:\"module\";s:16:\"field_collection\";s:6:\"active\";i:0;s:8:\"settings\";a:0:{}}s:8:\"settings\";a:1:{s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:21:\"field_collection_view\";s:6:\"weight\";s:1:\"2\";s:8:\"settings\";a:5:{s:4:\"edit\";s:4:\"Edit\";s:6:\"delete\";s:6:\"Delete\";s:3:\"add\";s:3:\"Add\";s:11:\"description\";b:1;s:9:\"view_mode\";s:4:\"full\";}s:6:\"module\";s:16:\"field_collection\";}s:6:\"teaser\";a:4:{s:4:\"type\";s:6:\"hidden\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"weight\";i:0;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;s:2:\"id\";s:2:\"46\";s:8:\"field_id\";s:2:\"16\";s:10:\"field_name\";s:19:\"field_extra_content\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:7:\"article\";s:7:\"deleted\";s:1:\"0\";}}s:6:\"fields\";a:6:{i:0;a:16:{s:12:\"entity_types\";a:1:{i:0;s:4:\"node\";}s:12:\"translatable\";s:1:\"0\";s:8:\"settings\";a:0:{}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:15:\"field_data_body\";a:3:{s:5:\"value\";s:10:\"body_value\";s:7:\"summary\";s:12:\"body_summary\";s:6:\"format\";s:11:\"body_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:19:\"field_revision_body\";a:3:{s:5:\"value\";s:10:\"body_value\";s:7:\"summary\";s:12:\"body_summary\";s:6:\"format\";s:11:\"body_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:1:\"2\";s:10:\"field_name\";s:4:\"body\";s:4:\"type\";s:17:\"text_with_summary\";s:6:\"module\";s:4:\"text\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:3:{s:5:\"value\";a:3:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:3:\"big\";s:8:\"not null\";b:0;}s:7:\"summary\";a:3:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:3:\"big\";s:8:\"not null\";b:0;}s:6:\"format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:9:{i:0;s:4:\"page\";i:1;s:7:\"article\";i:2;s:4:\"blog\";i:3;s:4:\"book\";i:4;s:5:\"forum\";i:5;s:3:\"faq\";i:6;s:5:\"video\";i:7;s:7:\"webform\";i:8;s:8:\"products\";}}}i:1;a:16:{s:8:\"settings\";a:2:{s:14:\"allowed_values\";a:1:{i:0;a:2:{s:10:\"vocabulary\";s:4:\"tags\";s:6:\"parent\";i:0;}}s:21:\"options_list_callback\";s:28:\"i18n_taxonomy_allowed_values\";}s:12:\"entity_types\";a:0:{}s:12:\"translatable\";s:1:\"0\";s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:21:\"field_data_field_tags\";a:1:{s:3:\"tid\";s:14:\"field_tags_tid\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:25:\"field_revision_field_tags\";a:1:{s:3:\"tid\";s:14:\"field_tags_tid\";}}}}}s:12:\"foreign keys\";a:1:{s:3:\"tid\";a:2:{s:5:\"table\";s:18:\"taxonomy_term_data\";s:7:\"columns\";a:1:{s:3:\"tid\";s:3:\"tid\";}}}s:7:\"indexes\";a:1:{s:3:\"tid\";a:1:{i:0;s:3:\"tid\";}}s:2:\"id\";s:1:\"3\";s:10:\"field_name\";s:10:\"field_tags\";s:4:\"type\";s:23:\"taxonomy_term_reference\";s:6:\"module\";s:8:\"taxonomy\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:2:\"-1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:1:{s:3:\"tid\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:3:{i:0;s:7:\"article\";i:1;s:4:\"blog\";i:2;s:5:\"video\";}}}i:2;a:16:{s:7:\"indexes\";a:1:{s:3:\"fid\";a:1:{i:0;s:3:\"fid\";}}s:8:\"settings\";a:2:{s:10:\"uri_scheme\";s:6:\"public\";s:13:\"default_image\";i:0;}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:22:\"field_data_field_image\";a:5:{s:3:\"fid\";s:15:\"field_image_fid\";s:3:\"alt\";s:15:\"field_image_alt\";s:5:\"title\";s:17:\"field_image_title\";s:5:\"width\";s:17:\"field_image_width\";s:6:\"height\";s:18:\"field_image_height\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:26:\"field_revision_field_image\";a:5:{s:3:\"fid\";s:15:\"field_image_fid\";s:3:\"alt\";s:15:\"field_image_alt\";s:5:\"title\";s:17:\"field_image_title\";s:5:\"width\";s:17:\"field_image_width\";s:6:\"height\";s:18:\"field_image_height\";}}}}}s:12:\"entity_types\";a:0:{}s:12:\"translatable\";s:1:\"0\";s:12:\"foreign keys\";a:1:{s:3:\"fid\";a:2:{s:5:\"table\";s:12:\"file_managed\";s:7:\"columns\";a:1:{s:3:\"fid\";s:3:\"fid\";}}}s:2:\"id\";s:1:\"4\";s:10:\"field_name\";s:11:\"field_image\";s:4:\"type\";s:5:\"image\";s:6:\"module\";s:5:\"image\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:5:{s:3:\"fid\";a:4:{s:11:\"description\";s:54:\"The {file_managed}.fid being referenced in this field.\";s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;s:8:\"unsigned\";b:1;}s:3:\"alt\";a:4:{s:11:\"description\";s:56:\"Alternative image text, for the image\'s \'alt\' attribute.\";s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:512;s:8:\"not null\";b:0;}s:5:\"title\";a:4:{s:11:\"description\";s:52:\"Image title text, for the image\'s \'title\' attribute.\";s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:1024;s:8:\"not null\";b:0;}s:5:\"width\";a:3:{s:11:\"description\";s:33:\"The width of the image in pixels.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;}s:6:\"height\";a:3:{s:11:\"description\";s:34:\"The height of the image in pixels.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;}}s:7:\"bundles\";a:2:{s:4:\"node\";a:3:{i:0;s:7:\"article\";i:1;s:4:\"blog\";i:2;s:8:\"products\";}s:21:\"field_collection_item\";a:1:{i:0;s:19:\"field_extra_content\";}}}i:3;a:16:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:2:{s:14:\"allowed_values\";a:1:{i:0;a:2:{s:10:\"vocabulary\";s:8:\"sections\";s:6:\"parent\";s:1:\"0\";}}s:21:\"options_list_callback\";s:28:\"i18n_taxonomy_allowed_values\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:24:\"field_data_field_section\";a:1:{s:3:\"tid\";s:17:\"field_section_tid\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:28:\"field_revision_field_section\";a:1:{s:3:\"tid\";s:17:\"field_section_tid\";}}}}}s:12:\"foreign keys\";a:1:{s:3:\"tid\";a:2:{s:5:\"table\";s:18:\"taxonomy_term_data\";s:7:\"columns\";a:1:{s:3:\"tid\";s:3:\"tid\";}}}s:7:\"indexes\";a:1:{s:3:\"tid\";a:1:{i:0;s:3:\"tid\";}}s:2:\"id\";s:2:\"11\";s:10:\"field_name\";s:13:\"field_section\";s:4:\"type\";s:23:\"taxonomy_term_reference\";s:6:\"module\";s:8:\"taxonomy\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:1:{s:3:\"tid\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{i:0;s:7:\"article\";}}}i:4;a:16:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:2:{s:14:\"allowed_values\";a:1:{i:0;a:2:{s:10:\"vocabulary\";s:10:\"categories\";s:6:\"parent\";s:1:\"0\";}}s:21:\"options_list_callback\";s:28:\"i18n_taxonomy_allowed_values\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:25:\"field_data_field_category\";a:1:{s:3:\"tid\";s:18:\"field_category_tid\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:29:\"field_revision_field_category\";a:1:{s:3:\"tid\";s:18:\"field_category_tid\";}}}}}s:12:\"foreign keys\";a:1:{s:3:\"tid\";a:2:{s:5:\"table\";s:18:\"taxonomy_term_data\";s:7:\"columns\";a:1:{s:3:\"tid\";s:3:\"tid\";}}}s:7:\"indexes\";a:1:{s:3:\"tid\";a:1:{i:0;s:3:\"tid\";}}s:2:\"id\";s:2:\"12\";s:10:\"field_name\";s:14:\"field_category\";s:4:\"type\";s:23:\"taxonomy_term_reference\";s:6:\"module\";s:8:\"taxonomy\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:1:{s:3:\"tid\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{i:0;s:7:\"article\";}}}i:5;a:16:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:2:{s:16:\"hide_blank_items\";i:1;s:4:\"path\";s:0:\"\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:30:\"field_data_field_extra_content\";a:2:{s:5:\"value\";s:25:\"field_extra_content_value\";s:11:\"revision_id\";s:31:\"field_extra_content_revision_id\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:34:\"field_revision_field_extra_content\";a:2:{s:5:\"value\";s:25:\"field_extra_content_value\";s:11:\"revision_id\";s:31:\"field_extra_content_revision_id\";}}}}}s:12:\"foreign keys\";a:0:{}s:7:\"indexes\";a:1:{s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}}s:2:\"id\";s:2:\"16\";s:10:\"field_name\";s:19:\"field_extra_content\";s:4:\"type\";s:16:\"field_collection\";s:6:\"module\";s:16:\"field_collection\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:2:\"-1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:2:{s:5:\"value\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;s:11:\"description\";s:29:\"The field collection item id.\";}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;s:11:\"description\";s:38:\"The field collection item revision id.\";}}s:7:\"bundles\";a:1:{s:4:\"node\";a:3:{i:0;s:4:\"blog\";i:1;s:7:\"article\";i:2;s:5:\"forum\";}}}}}',0,1512620340,1),('field_info:bundle:node:blog','a:2:{s:9:\"instances\";a:5:{s:4:\"body\";a:13:{s:5:\"label\";s:4:\"Body\";s:6:\"widget\";a:4:{s:4:\"type\";s:26:\"text_textarea_with_summary\";s:8:\"settings\";a:2:{s:4:\"rows\";i:20;s:12:\"summary_rows\";i:5;}s:6:\"weight\";s:1:\"1\";s:6:\"module\";s:4:\"text\";}s:8:\"settings\";a:3:{s:15:\"display_summary\";b:1;s:15:\"text_processing\";i:1;s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";s:1:\"1\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";}s:6:\"teaser\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:23:\"text_summary_or_trimmed\";s:6:\"weight\";s:1:\"2\";s:8:\"settings\";a:1:{s:11:\"trim_length\";s:3:\"500\";}s:6:\"module\";s:4:\"text\";}}s:8:\"required\";b:0;s:11:\"description\";s:0:\"\";s:2:\"id\";s:1:\"8\";s:8:\"field_id\";s:1:\"2\";s:10:\"field_name\";s:4:\"body\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:4:\"blog\";s:7:\"deleted\";s:1:\"0\";s:13:\"default_value\";N;}s:11:\"field_image\";a:12:{s:5:\"label\";s:5:\"Image\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"2\";s:4:\"type\";s:11:\"image_image\";s:6:\"module\";s:5:\"image\";s:6:\"active\";i:1;s:8:\"settings\";a:2:{s:18:\"progress_indicator\";s:8:\"throbber\";s:19:\"preview_image_style\";s:9:\"thumbnail\";}}s:8:\"settings\";a:9:{s:14:\"file_directory\";s:10:\"field/blog\";s:15:\"file_extensions\";s:16:\"png gif jpg jpeg\";s:12:\"max_filesize\";s:0:\"\";s:14:\"max_resolution\";s:0:\"\";s:14:\"min_resolution\";s:0:\"\";s:9:\"alt_field\";i:0;s:11:\"title_field\";i:0;s:13:\"default_image\";i:0;s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:5:\"image\";s:6:\"weight\";s:1:\"0\";s:8:\"settings\";a:2:{s:11:\"image_style\";s:5:\"large\";s:10:\"image_link\";s:0:\"\";}s:6:\"module\";s:5:\"image\";}s:6:\"teaser\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:5:\"image\";s:6:\"weight\";s:1:\"0\";s:8:\"settings\";a:2:{s:11:\"image_style\";s:5:\"large\";s:10:\"image_link\";s:7:\"content\";}s:6:\"module\";s:5:\"image\";}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:2:\"id\";s:2:\"23\";s:8:\"field_id\";s:1:\"4\";s:10:\"field_name\";s:11:\"field_image\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:4:\"blog\";s:7:\"deleted\";s:1:\"0\";}s:10:\"field_tags\";a:13:{s:5:\"label\";s:4:\"Tags\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"3\";s:4:\"type\";s:21:\"taxonomy_autocomplete\";s:6:\"module\";s:8:\"taxonomy\";s:6:\"active\";i:0;s:8:\"settings\";a:2:{s:4:\"size\";i:60;s:17:\"autocomplete_path\";s:21:\"taxonomy/autocomplete\";}}s:8:\"settings\";a:1:{s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:28:\"taxonomy_term_reference_link\";s:6:\"weight\";s:1:\"3\";s:8:\"settings\";a:0:{}s:6:\"module\";s:8:\"taxonomy\";}s:6:\"teaser\";a:4:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:6:\"hidden\";s:6:\"weight\";s:1:\"5\";s:8:\"settings\";a:0:{}}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;s:2:\"id\";s:2:\"24\";s:8:\"field_id\";s:1:\"3\";s:10:\"field_name\";s:10:\"field_tags\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:4:\"blog\";s:7:\"deleted\";s:1:\"0\";}s:10:\"field_vote\";a:13:{s:5:\"label\";s:4:\"Vote\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"4\";s:4:\"type\";s:7:\"exposed\";s:6:\"module\";s:8:\"fivestar\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:6:\"widget\";a:1:{s:15:\"fivestar_widget\";s:7:\"default\";}}}s:8:\"settings\";a:6:{s:5:\"stars\";s:1:\"5\";s:11:\"allow_clear\";i:0;s:12:\"allow_revote\";i:0;s:13:\"allow_ownvote\";i:1;s:6:\"target\";s:4:\"none\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:26:\"fivestar_formatter_default\";s:6:\"weight\";s:1:\"4\";s:8:\"settings\";a:4:{s:6:\"widget\";a:1:{s:15:\"fivestar_widget\";s:50:\"sites/all/modules/fivestar/widgets/basic/basic.css\";}s:6:\"expose\";i:1;s:5:\"style\";s:7:\"average\";s:4:\"text\";s:7:\"average\";}s:6:\"module\";s:8:\"fivestar\";}s:6:\"teaser\";a:4:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:6:\"hidden\";s:6:\"weight\";s:1:\"4\";s:8:\"settings\";a:0:{}}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;s:2:\"id\";s:2:\"25\";s:8:\"field_id\";s:1:\"6\";s:10:\"field_name\";s:10:\"field_vote\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:4:\"blog\";s:7:\"deleted\";s:1:\"0\";}s:19:\"field_extra_content\";a:13:{s:5:\"label\";s:13:\"Extra content\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"6\";s:4:\"type\";s:22:\"field_collection_embed\";s:6:\"module\";s:16:\"field_collection\";s:6:\"active\";i:0;s:8:\"settings\";a:0:{}}s:8:\"settings\";a:1:{s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:21:\"field_collection_view\";s:6:\"weight\";s:1:\"2\";s:8:\"settings\";a:5:{s:4:\"edit\";s:4:\"Edit\";s:6:\"delete\";s:6:\"Delete\";s:3:\"add\";s:3:\"Add\";s:11:\"description\";b:1;s:9:\"view_mode\";s:4:\"full\";}s:6:\"module\";s:16:\"field_collection\";}s:6:\"teaser\";a:4:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:6:\"hidden\";s:6:\"weight\";s:1:\"3\";s:8:\"settings\";a:0:{}}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;s:2:\"id\";s:2:\"43\";s:8:\"field_id\";s:2:\"16\";s:10:\"field_name\";s:19:\"field_extra_content\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:4:\"blog\";s:7:\"deleted\";s:1:\"0\";}}s:6:\"fields\";a:5:{i:0;a:16:{s:12:\"entity_types\";a:1:{i:0;s:4:\"node\";}s:12:\"translatable\";s:1:\"0\";s:8:\"settings\";a:0:{}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:15:\"field_data_body\";a:3:{s:5:\"value\";s:10:\"body_value\";s:7:\"summary\";s:12:\"body_summary\";s:6:\"format\";s:11:\"body_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:19:\"field_revision_body\";a:3:{s:5:\"value\";s:10:\"body_value\";s:7:\"summary\";s:12:\"body_summary\";s:6:\"format\";s:11:\"body_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:1:\"2\";s:10:\"field_name\";s:4:\"body\";s:4:\"type\";s:17:\"text_with_summary\";s:6:\"module\";s:4:\"text\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:3:{s:5:\"value\";a:3:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:3:\"big\";s:8:\"not null\";b:0;}s:7:\"summary\";a:3:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:3:\"big\";s:8:\"not null\";b:0;}s:6:\"format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:9:{i:0;s:4:\"page\";i:1;s:7:\"article\";i:2;s:4:\"blog\";i:3;s:4:\"book\";i:4;s:5:\"forum\";i:5;s:3:\"faq\";i:6;s:5:\"video\";i:7;s:7:\"webform\";i:8;s:8:\"products\";}}}i:1;a:16:{s:7:\"indexes\";a:1:{s:3:\"fid\";a:1:{i:0;s:3:\"fid\";}}s:8:\"settings\";a:2:{s:10:\"uri_scheme\";s:6:\"public\";s:13:\"default_image\";i:0;}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:22:\"field_data_field_image\";a:5:{s:3:\"fid\";s:15:\"field_image_fid\";s:3:\"alt\";s:15:\"field_image_alt\";s:5:\"title\";s:17:\"field_image_title\";s:5:\"width\";s:17:\"field_image_width\";s:6:\"height\";s:18:\"field_image_height\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:26:\"field_revision_field_image\";a:5:{s:3:\"fid\";s:15:\"field_image_fid\";s:3:\"alt\";s:15:\"field_image_alt\";s:5:\"title\";s:17:\"field_image_title\";s:5:\"width\";s:17:\"field_image_width\";s:6:\"height\";s:18:\"field_image_height\";}}}}}s:12:\"entity_types\";a:0:{}s:12:\"translatable\";s:1:\"0\";s:12:\"foreign keys\";a:1:{s:3:\"fid\";a:2:{s:5:\"table\";s:12:\"file_managed\";s:7:\"columns\";a:1:{s:3:\"fid\";s:3:\"fid\";}}}s:2:\"id\";s:1:\"4\";s:10:\"field_name\";s:11:\"field_image\";s:4:\"type\";s:5:\"image\";s:6:\"module\";s:5:\"image\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:5:{s:3:\"fid\";a:4:{s:11:\"description\";s:54:\"The {file_managed}.fid being referenced in this field.\";s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;s:8:\"unsigned\";b:1;}s:3:\"alt\";a:4:{s:11:\"description\";s:56:\"Alternative image text, for the image\'s \'alt\' attribute.\";s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:512;s:8:\"not null\";b:0;}s:5:\"title\";a:4:{s:11:\"description\";s:52:\"Image title text, for the image\'s \'title\' attribute.\";s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:1024;s:8:\"not null\";b:0;}s:5:\"width\";a:3:{s:11:\"description\";s:33:\"The width of the image in pixels.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;}s:6:\"height\";a:3:{s:11:\"description\";s:34:\"The height of the image in pixels.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;}}s:7:\"bundles\";a:2:{s:4:\"node\";a:3:{i:0;s:7:\"article\";i:1;s:4:\"blog\";i:2;s:8:\"products\";}s:21:\"field_collection_item\";a:1:{i:0;s:19:\"field_extra_content\";}}}i:2;a:16:{s:8:\"settings\";a:2:{s:14:\"allowed_values\";a:1:{i:0;a:2:{s:10:\"vocabulary\";s:4:\"tags\";s:6:\"parent\";i:0;}}s:21:\"options_list_callback\";s:28:\"i18n_taxonomy_allowed_values\";}s:12:\"entity_types\";a:0:{}s:12:\"translatable\";s:1:\"0\";s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:21:\"field_data_field_tags\";a:1:{s:3:\"tid\";s:14:\"field_tags_tid\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:25:\"field_revision_field_tags\";a:1:{s:3:\"tid\";s:14:\"field_tags_tid\";}}}}}s:12:\"foreign keys\";a:1:{s:3:\"tid\";a:2:{s:5:\"table\";s:18:\"taxonomy_term_data\";s:7:\"columns\";a:1:{s:3:\"tid\";s:3:\"tid\";}}}s:7:\"indexes\";a:1:{s:3:\"tid\";a:1:{i:0;s:3:\"tid\";}}s:2:\"id\";s:1:\"3\";s:10:\"field_name\";s:10:\"field_tags\";s:4:\"type\";s:23:\"taxonomy_term_reference\";s:6:\"module\";s:8:\"taxonomy\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:2:\"-1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:1:{s:3:\"tid\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:3:{i:0;s:7:\"article\";i:1;s:4:\"blog\";i:2;s:5:\"video\";}}}i:3;a:16:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:4:\"axis\";s:4:\"vote\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:21:\"field_data_field_vote\";a:2:{s:6:\"rating\";s:17:\"field_vote_rating\";s:6:\"target\";s:17:\"field_vote_target\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:25:\"field_revision_field_vote\";a:2:{s:6:\"rating\";s:17:\"field_vote_rating\";s:6:\"target\";s:17:\"field_vote_target\";}}}}}s:12:\"foreign keys\";a:0:{}s:7:\"indexes\";a:0:{}s:2:\"id\";s:1:\"6\";s:10:\"field_name\";s:10:\"field_vote\";s:4:\"type\";s:8:\"fivestar\";s:6:\"module\";s:8:\"fivestar\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:2:{s:6:\"rating\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;s:8:\"sortable\";b:1;}s:6:\"target\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}}s:7:\"bundles\";a:2:{s:4:\"node\";a:2:{i:0;s:5:\"forum\";i:1;s:4:\"blog\";}s:7:\"comment\";a:1:{i:0;s:18:\"comment_node_forum\";}}}i:4;a:16:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:2:{s:16:\"hide_blank_items\";i:1;s:4:\"path\";s:0:\"\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:30:\"field_data_field_extra_content\";a:2:{s:5:\"value\";s:25:\"field_extra_content_value\";s:11:\"revision_id\";s:31:\"field_extra_content_revision_id\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:34:\"field_revision_field_extra_content\";a:2:{s:5:\"value\";s:25:\"field_extra_content_value\";s:11:\"revision_id\";s:31:\"field_extra_content_revision_id\";}}}}}s:12:\"foreign keys\";a:0:{}s:7:\"indexes\";a:1:{s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}}s:2:\"id\";s:2:\"16\";s:10:\"field_name\";s:19:\"field_extra_content\";s:4:\"type\";s:16:\"field_collection\";s:6:\"module\";s:16:\"field_collection\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:2:\"-1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:2:{s:5:\"value\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;s:11:\"description\";s:29:\"The field collection item id.\";}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;s:11:\"description\";s:38:\"The field collection item revision id.\";}}s:7:\"bundles\";a:1:{s:4:\"node\";a:3:{i:0;s:4:\"blog\";i:1;s:7:\"article\";i:2;s:5:\"forum\";}}}}}',0,1512620340,1),('field_info:bundle:node:book','a:2:{s:9:\"instances\";a:1:{s:4:\"body\";a:13:{s:5:\"label\";s:4:\"Body\";s:6:\"widget\";a:4:{s:4:\"type\";s:26:\"text_textarea_with_summary\";s:8:\"settings\";a:2:{s:4:\"rows\";i:20;s:12:\"summary_rows\";i:5;}s:6:\"weight\";i:-4;s:6:\"module\";s:4:\"text\";}s:8:\"settings\";a:3:{s:15:\"display_summary\";b:1;s:15:\"text_processing\";i:1;s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:0;}s:6:\"teaser\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:23:\"text_summary_or_trimmed\";s:8:\"settings\";a:1:{s:11:\"trim_length\";i:600;}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:0;}}s:8:\"required\";b:0;s:11:\"description\";s:0:\"\";s:2:\"id\";s:2:\"10\";s:8:\"field_id\";s:1:\"2\";s:10:\"field_name\";s:4:\"body\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:4:\"book\";s:7:\"deleted\";s:1:\"0\";s:13:\"default_value\";N;}}s:6:\"fields\";a:1:{i:0;a:16:{s:12:\"entity_types\";a:1:{i:0;s:4:\"node\";}s:12:\"translatable\";s:1:\"0\";s:8:\"settings\";a:0:{}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:15:\"field_data_body\";a:3:{s:5:\"value\";s:10:\"body_value\";s:7:\"summary\";s:12:\"body_summary\";s:6:\"format\";s:11:\"body_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:19:\"field_revision_body\";a:3:{s:5:\"value\";s:10:\"body_value\";s:7:\"summary\";s:12:\"body_summary\";s:6:\"format\";s:11:\"body_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:1:\"2\";s:10:\"field_name\";s:4:\"body\";s:4:\"type\";s:17:\"text_with_summary\";s:6:\"module\";s:4:\"text\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:3:{s:5:\"value\";a:3:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:3:\"big\";s:8:\"not null\";b:0;}s:7:\"summary\";a:3:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:3:\"big\";s:8:\"not null\";b:0;}s:6:\"format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:9:{i:0;s:4:\"page\";i:1;s:7:\"article\";i:2;s:4:\"blog\";i:3;s:4:\"book\";i:4;s:5:\"forum\";i:5;s:3:\"faq\";i:6;s:5:\"video\";i:7;s:7:\"webform\";i:8;s:8:\"products\";}}}}}',0,1512620340,1),('field_info:bundle:node:faq','a:2:{s:9:\"instances\";a:2:{s:4:\"body\";a:13:{s:5:\"label\";s:4:\"Body\";s:6:\"widget\";a:4:{s:4:\"type\";s:26:\"text_textarea_with_summary\";s:8:\"settings\";a:2:{s:4:\"rows\";i:20;s:12:\"summary_rows\";i:5;}s:6:\"weight\";i:32;s:6:\"module\";s:4:\"text\";}s:8:\"settings\";a:3:{s:15:\"display_summary\";b:1;s:15:\"text_processing\";i:1;s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:1;}s:6:\"teaser\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:23:\"text_summary_or_trimmed\";s:8:\"settings\";a:1:{s:11:\"trim_length\";i:600;}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:1;}}s:8:\"required\";b:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;s:2:\"id\";s:2:\"29\";s:8:\"field_id\";s:1:\"2\";s:10:\"field_name\";s:4:\"body\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:3:\"faq\";s:7:\"deleted\";s:1:\"0\";}s:23:\"field_detailed_question\";a:13:{s:5:\"label\";s:17:\"Detailed question\";s:6:\"widget\";a:5:{s:6:\"weight\";i:31;s:4:\"type\";s:13:\"text_textarea\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"rows\";s:1:\"5\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"1\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";}s:6:\"teaser\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";}}s:8:\"required\";i:0;s:11:\"description\";s:32:\"Enter the detailed question text\";s:13:\"default_value\";N;s:2:\"id\";s:2:\"49\";s:8:\"field_id\";s:2:\"18\";s:10:\"field_name\";s:23:\"field_detailed_question\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:3:\"faq\";s:7:\"deleted\";s:1:\"0\";}}s:6:\"fields\";a:2:{i:0;a:16:{s:12:\"entity_types\";a:1:{i:0;s:4:\"node\";}s:12:\"translatable\";s:1:\"0\";s:8:\"settings\";a:0:{}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:15:\"field_data_body\";a:3:{s:5:\"value\";s:10:\"body_value\";s:7:\"summary\";s:12:\"body_summary\";s:6:\"format\";s:11:\"body_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:19:\"field_revision_body\";a:3:{s:5:\"value\";s:10:\"body_value\";s:7:\"summary\";s:12:\"body_summary\";s:6:\"format\";s:11:\"body_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:1:\"2\";s:10:\"field_name\";s:4:\"body\";s:4:\"type\";s:17:\"text_with_summary\";s:6:\"module\";s:4:\"text\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:3:{s:5:\"value\";a:3:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:3:\"big\";s:8:\"not null\";b:0;}s:7:\"summary\";a:3:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:3:\"big\";s:8:\"not null\";b:0;}s:6:\"format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:9:{i:0;s:4:\"page\";i:1;s:7:\"article\";i:2;s:4:\"blog\";i:3;s:4:\"book\";i:4;s:5:\"forum\";i:5;s:3:\"faq\";i:6;s:5:\"video\";i:7;s:7:\"webform\";i:8;s:8:\"products\";}}}i:1;a:16:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:0:{}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:34:\"field_data_field_detailed_question\";a:2:{s:5:\"value\";s:29:\"field_detailed_question_value\";s:6:\"format\";s:30:\"field_detailed_question_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:38:\"field_revision_field_detailed_question\";a:2:{s:5:\"value\";s:29:\"field_detailed_question_value\";s:6:\"format\";s:30:\"field_detailed_question_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:2:\"18\";s:10:\"field_name\";s:23:\"field_detailed_question\";s:4:\"type\";s:9:\"text_long\";s:6:\"module\";s:4:\"text\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:2:{s:5:\"value\";a:3:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:3:\"big\";s:8:\"not null\";b:0;}s:6:\"format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{i:0;s:3:\"faq\";}}}}}',0,1512620340,1),('field_info:bundle:node:forum','a:2:{s:9:\"instances\";a:4:{s:15:\"taxonomy_forums\";a:13:{s:5:\"label\";s:6:\"Forums\";s:8:\"required\";b:1;s:6:\"widget\";a:4:{s:4:\"type\";s:14:\"options_select\";s:8:\"settings\";a:1:{s:12:\"apply_chosen\";s:0:\"\";}s:6:\"weight\";s:1:\"1\";s:6:\"module\";s:7:\"options\";}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:28:\"taxonomy_term_reference_link\";s:6:\"weight\";s:1:\"0\";s:8:\"settings\";a:0:{}s:6:\"module\";s:8:\"taxonomy\";}s:6:\"teaser\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:28:\"taxonomy_term_reference_link\";s:6:\"weight\";s:2:\"10\";s:8:\"settings\";a:0:{}s:6:\"module\";s:8:\"taxonomy\";}}s:8:\"settings\";a:1:{s:18:\"user_register_form\";b:0;}s:11:\"description\";s:0:\"\";s:2:\"id\";s:2:\"11\";s:8:\"field_id\";s:1:\"5\";s:10:\"field_name\";s:15:\"taxonomy_forums\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:5:\"forum\";s:7:\"deleted\";s:1:\"0\";s:13:\"default_value\";N;}s:4:\"body\";a:13:{s:5:\"label\";s:4:\"Body\";s:6:\"widget\";a:4:{s:4:\"type\";s:26:\"text_textarea_with_summary\";s:8:\"settings\";a:2:{s:4:\"rows\";i:20;s:12:\"summary_rows\";i:5;}s:6:\"weight\";s:1:\"2\";s:6:\"module\";s:4:\"text\";}s:8:\"settings\";a:3:{s:15:\"display_summary\";b:1;s:15:\"text_processing\";i:1;s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";s:1:\"1\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";}s:6:\"teaser\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:23:\"text_summary_or_trimmed\";s:6:\"weight\";s:2:\"11\";s:8:\"settings\";a:1:{s:11:\"trim_length\";i:600;}s:6:\"module\";s:4:\"text\";}}s:8:\"required\";b:0;s:11:\"description\";s:0:\"\";s:2:\"id\";s:2:\"13\";s:8:\"field_id\";s:1:\"2\";s:10:\"field_name\";s:4:\"body\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:5:\"forum\";s:7:\"deleted\";s:1:\"0\";s:13:\"default_value\";N;}s:10:\"field_vote\";a:13:{s:5:\"label\";s:4:\"Vote\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"4\";s:4:\"type\";s:7:\"exposed\";s:6:\"module\";s:8:\"fivestar\";s:6:\"active\";i:1;s:8:\"settings\";a:0:{}}s:8:\"settings\";a:6:{s:5:\"stars\";s:1:\"5\";s:11:\"allow_clear\";i:0;s:12:\"allow_revote\";i:0;s:13:\"allow_ownvote\";i:1;s:6:\"target\";s:4:\"none\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:26:\"fivestar_formatter_default\";s:6:\"weight\";s:1:\"3\";s:8:\"settings\";a:4:{s:6:\"widget\";a:1:{s:15:\"fivestar_widget\";s:50:\"sites/all/modules/fivestar/widgets/basic/basic.css\";}s:6:\"expose\";i:1;s:5:\"style\";s:5:\"smart\";s:4:\"text\";s:4:\"dual\";}s:6:\"module\";s:8:\"fivestar\";}s:6:\"teaser\";a:4:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:6:\"hidden\";s:6:\"weight\";s:1:\"0\";s:8:\"settings\";a:0:{}}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;s:2:\"id\";s:2:\"14\";s:8:\"field_id\";s:1:\"6\";s:10:\"field_name\";s:10:\"field_vote\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:5:\"forum\";s:7:\"deleted\";s:1:\"0\";}s:19:\"field_extra_content\";a:13:{s:5:\"label\";s:13:\"Extra content\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"3\";s:4:\"type\";s:22:\"field_collection_embed\";s:6:\"module\";s:16:\"field_collection\";s:6:\"active\";i:0;s:8:\"settings\";a:0:{}}s:8:\"settings\";a:1:{s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:21:\"field_collection_view\";s:6:\"weight\";s:1:\"2\";s:8:\"settings\";a:5:{s:4:\"edit\";s:4:\"Edit\";s:6:\"delete\";s:6:\"Delete\";s:3:\"add\";s:3:\"Add\";s:11:\"description\";b:1;s:9:\"view_mode\";s:4:\"full\";}s:6:\"module\";s:16:\"field_collection\";}s:6:\"teaser\";a:4:{s:4:\"type\";s:6:\"hidden\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"weight\";i:0;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;s:2:\"id\";s:2:\"47\";s:8:\"field_id\";s:2:\"16\";s:10:\"field_name\";s:19:\"field_extra_content\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:5:\"forum\";s:7:\"deleted\";s:1:\"0\";}}s:6:\"fields\";a:4:{i:0;a:16:{s:8:\"settings\";a:2:{s:14:\"allowed_values\";a:1:{i:0;a:2:{s:10:\"vocabulary\";s:6:\"forums\";s:6:\"parent\";i:0;}}s:21:\"options_list_callback\";s:28:\"i18n_taxonomy_allowed_values\";}s:12:\"entity_types\";a:0:{}s:12:\"translatable\";s:1:\"0\";s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:26:\"field_data_taxonomy_forums\";a:1:{s:3:\"tid\";s:19:\"taxonomy_forums_tid\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:30:\"field_revision_taxonomy_forums\";a:1:{s:3:\"tid\";s:19:\"taxonomy_forums_tid\";}}}}}s:12:\"foreign keys\";a:1:{s:3:\"tid\";a:2:{s:5:\"table\";s:18:\"taxonomy_term_data\";s:7:\"columns\";a:1:{s:3:\"tid\";s:3:\"tid\";}}}s:7:\"indexes\";a:1:{s:3:\"tid\";a:1:{i:0;s:3:\"tid\";}}s:2:\"id\";s:1:\"5\";s:10:\"field_name\";s:15:\"taxonomy_forums\";s:4:\"type\";s:23:\"taxonomy_term_reference\";s:6:\"module\";s:8:\"taxonomy\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:1:{s:3:\"tid\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{i:0;s:5:\"forum\";}}}i:1;a:16:{s:12:\"entity_types\";a:1:{i:0;s:4:\"node\";}s:12:\"translatable\";s:1:\"0\";s:8:\"settings\";a:0:{}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:15:\"field_data_body\";a:3:{s:5:\"value\";s:10:\"body_value\";s:7:\"summary\";s:12:\"body_summary\";s:6:\"format\";s:11:\"body_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:19:\"field_revision_body\";a:3:{s:5:\"value\";s:10:\"body_value\";s:7:\"summary\";s:12:\"body_summary\";s:6:\"format\";s:11:\"body_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:1:\"2\";s:10:\"field_name\";s:4:\"body\";s:4:\"type\";s:17:\"text_with_summary\";s:6:\"module\";s:4:\"text\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:3:{s:5:\"value\";a:3:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:3:\"big\";s:8:\"not null\";b:0;}s:7:\"summary\";a:3:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:3:\"big\";s:8:\"not null\";b:0;}s:6:\"format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:9:{i:0;s:4:\"page\";i:1;s:7:\"article\";i:2;s:4:\"blog\";i:3;s:4:\"book\";i:4;s:5:\"forum\";i:5;s:3:\"faq\";i:6;s:5:\"video\";i:7;s:7:\"webform\";i:8;s:8:\"products\";}}}i:2;a:16:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:4:\"axis\";s:4:\"vote\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:21:\"field_data_field_vote\";a:2:{s:6:\"rating\";s:17:\"field_vote_rating\";s:6:\"target\";s:17:\"field_vote_target\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:25:\"field_revision_field_vote\";a:2:{s:6:\"rating\";s:17:\"field_vote_rating\";s:6:\"target\";s:17:\"field_vote_target\";}}}}}s:12:\"foreign keys\";a:0:{}s:7:\"indexes\";a:0:{}s:2:\"id\";s:1:\"6\";s:10:\"field_name\";s:10:\"field_vote\";s:4:\"type\";s:8:\"fivestar\";s:6:\"module\";s:8:\"fivestar\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:2:{s:6:\"rating\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;s:8:\"sortable\";b:1;}s:6:\"target\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}}s:7:\"bundles\";a:2:{s:4:\"node\";a:2:{i:0;s:5:\"forum\";i:1;s:4:\"blog\";}s:7:\"comment\";a:1:{i:0;s:18:\"comment_node_forum\";}}}i:3;a:16:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:2:{s:16:\"hide_blank_items\";i:1;s:4:\"path\";s:0:\"\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:30:\"field_data_field_extra_content\";a:2:{s:5:\"value\";s:25:\"field_extra_content_value\";s:11:\"revision_id\";s:31:\"field_extra_content_revision_id\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:34:\"field_revision_field_extra_content\";a:2:{s:5:\"value\";s:25:\"field_extra_content_value\";s:11:\"revision_id\";s:31:\"field_extra_content_revision_id\";}}}}}s:12:\"foreign keys\";a:0:{}s:7:\"indexes\";a:1:{s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}}s:2:\"id\";s:2:\"16\";s:10:\"field_name\";s:19:\"field_extra_content\";s:4:\"type\";s:16:\"field_collection\";s:6:\"module\";s:16:\"field_collection\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:2:\"-1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:2:{s:5:\"value\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;s:11:\"description\";s:29:\"The field collection item id.\";}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;s:11:\"description\";s:38:\"The field collection item revision id.\";}}s:7:\"bundles\";a:1:{s:4:\"node\";a:3:{i:0;s:4:\"blog\";i:1;s:7:\"article\";i:2;s:5:\"forum\";}}}}}',0,1512620340,1),('field_info:bundle:node:page','a:2:{s:9:\"instances\";a:1:{s:4:\"body\";a:13:{s:5:\"label\";s:4:\"Body\";s:6:\"widget\";a:4:{s:4:\"type\";s:26:\"text_textarea_with_summary\";s:8:\"settings\";a:2:{s:4:\"rows\";i:20;s:12:\"summary_rows\";i:5;}s:6:\"weight\";i:-4;s:6:\"module\";s:4:\"text\";}s:8:\"settings\";a:3:{s:15:\"display_summary\";b:1;s:15:\"text_processing\";i:1;s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:0;}s:6:\"teaser\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:23:\"text_summary_or_trimmed\";s:8:\"settings\";a:1:{s:11:\"trim_length\";i:600;}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:0;}}s:8:\"required\";b:0;s:11:\"description\";s:0:\"\";s:2:\"id\";s:1:\"2\";s:8:\"field_id\";s:1:\"2\";s:10:\"field_name\";s:4:\"body\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:4:\"page\";s:7:\"deleted\";s:1:\"0\";s:13:\"default_value\";N;}}s:6:\"fields\";a:1:{i:0;a:16:{s:12:\"entity_types\";a:1:{i:0;s:4:\"node\";}s:12:\"translatable\";s:1:\"0\";s:8:\"settings\";a:0:{}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:15:\"field_data_body\";a:3:{s:5:\"value\";s:10:\"body_value\";s:7:\"summary\";s:12:\"body_summary\";s:6:\"format\";s:11:\"body_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:19:\"field_revision_body\";a:3:{s:5:\"value\";s:10:\"body_value\";s:7:\"summary\";s:12:\"body_summary\";s:6:\"format\";s:11:\"body_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:1:\"2\";s:10:\"field_name\";s:4:\"body\";s:4:\"type\";s:17:\"text_with_summary\";s:6:\"module\";s:4:\"text\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:3:{s:5:\"value\";a:3:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:3:\"big\";s:8:\"not null\";b:0;}s:7:\"summary\";a:3:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:3:\"big\";s:8:\"not null\";b:0;}s:6:\"format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:9:{i:0;s:4:\"page\";i:1;s:7:\"article\";i:2;s:4:\"blog\";i:3;s:4:\"book\";i:4;s:5:\"forum\";i:5;s:3:\"faq\";i:6;s:5:\"video\";i:7;s:7:\"webform\";i:8;s:8:\"products\";}}}}}',0,1512620340,1),('field_info:bundle:node:products','a:2:{s:9:\"instances\";a:3:{s:4:\"body\";a:13:{s:5:\"label\";s:4:\"Body\";s:6:\"widget\";a:4:{s:4:\"type\";s:26:\"text_textarea_with_summary\";s:8:\"settings\";a:2:{s:4:\"rows\";i:20;s:12:\"summary_rows\";i:5;}s:6:\"weight\";s:2:\"31\";s:6:\"module\";s:4:\"text\";}s:8:\"settings\";a:3:{s:15:\"display_summary\";b:1;s:15:\"text_processing\";i:1;s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:0;}s:6:\"teaser\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:23:\"text_summary_or_trimmed\";s:8:\"settings\";a:1:{s:11:\"trim_length\";i:600;}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:0;}}s:8:\"required\";b:0;s:11:\"description\";s:0:\"\";s:2:\"id\";s:2:\"37\";s:8:\"field_id\";s:1:\"2\";s:10:\"field_name\";s:4:\"body\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:8:\"products\";s:7:\"deleted\";s:1:\"0\";s:13:\"default_value\";N;}s:11:\"field_image\";a:12:{s:5:\"label\";s:5:\"Image\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"33\";s:4:\"type\";s:11:\"image_image\";s:6:\"module\";s:5:\"image\";s:6:\"active\";i:1;s:8:\"settings\";a:2:{s:18:\"progress_indicator\";s:8:\"throbber\";s:19:\"preview_image_style\";s:9:\"thumbnail\";}}s:8:\"settings\";a:9:{s:14:\"file_directory\";s:13:\"field/product\";s:15:\"file_extensions\";s:16:\"png gif jpg jpeg\";s:12:\"max_filesize\";s:0:\"\";s:14:\"max_resolution\";s:0:\"\";s:14:\"min_resolution\";s:0:\"\";s:9:\"alt_field\";i:0;s:11:\"title_field\";i:0;s:13:\"default_image\";i:0;s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:5:\"image\";s:8:\"settings\";a:2:{s:11:\"image_style\";s:0:\"\";s:10:\"image_link\";s:0:\"\";}s:6:\"module\";s:5:\"image\";s:6:\"weight\";i:1;}s:6:\"teaser\";a:4:{s:4:\"type\";s:6:\"hidden\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"weight\";i:0;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:2:\"id\";s:2:\"38\";s:8:\"field_id\";s:1:\"4\";s:10:\"field_name\";s:11:\"field_image\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:8:\"products\";s:7:\"deleted\";s:1:\"0\";}s:10:\"field_link\";a:13:{s:5:\"label\";s:4:\"Link\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"34\";s:4:\"type\";s:10:\"link_field\";s:6:\"module\";s:4:\"link\";s:6:\"active\";i:0;s:8:\"settings\";a:0:{}}s:8:\"settings\";a:12:{s:12:\"validate_url\";i:1;s:3:\"url\";i:0;s:5:\"title\";s:8:\"optional\";s:11:\"title_value\";s:0:\"\";s:15:\"title_maxlength\";s:3:\"128\";s:13:\"enable_tokens\";i:1;s:7:\"display\";a:1:{s:10:\"url_cutoff\";s:2:\"80\";}s:10:\"attributes\";a:5:{s:6:\"target\";s:7:\"default\";s:3:\"rel\";s:0:\"\";s:5:\"class\";s:0:\"\";s:18:\"configurable_title\";i:0;s:5:\"title\";s:0:\"\";}s:10:\"rel_remove\";s:7:\"default\";s:18:\"user_register_form\";b:0;s:27:\"title_label_use_field_label\";b:0;s:12:\"absolute_url\";i:1;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"link_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"link\";s:6:\"weight\";i:2;}s:6:\"teaser\";a:4:{s:4:\"type\";s:6:\"hidden\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"weight\";i:0;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;s:2:\"id\";s:2:\"39\";s:8:\"field_id\";s:2:\"14\";s:10:\"field_name\";s:10:\"field_link\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:8:\"products\";s:7:\"deleted\";s:1:\"0\";}}s:6:\"fields\";a:3:{i:0;a:16:{s:12:\"entity_types\";a:1:{i:0;s:4:\"node\";}s:12:\"translatable\";s:1:\"0\";s:8:\"settings\";a:0:{}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:15:\"field_data_body\";a:3:{s:5:\"value\";s:10:\"body_value\";s:7:\"summary\";s:12:\"body_summary\";s:6:\"format\";s:11:\"body_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:19:\"field_revision_body\";a:3:{s:5:\"value\";s:10:\"body_value\";s:7:\"summary\";s:12:\"body_summary\";s:6:\"format\";s:11:\"body_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:1:\"2\";s:10:\"field_name\";s:4:\"body\";s:4:\"type\";s:17:\"text_with_summary\";s:6:\"module\";s:4:\"text\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:3:{s:5:\"value\";a:3:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:3:\"big\";s:8:\"not null\";b:0;}s:7:\"summary\";a:3:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:3:\"big\";s:8:\"not null\";b:0;}s:6:\"format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:9:{i:0;s:4:\"page\";i:1;s:7:\"article\";i:2;s:4:\"blog\";i:3;s:4:\"book\";i:4;s:5:\"forum\";i:5;s:3:\"faq\";i:6;s:5:\"video\";i:7;s:7:\"webform\";i:8;s:8:\"products\";}}}i:1;a:16:{s:7:\"indexes\";a:1:{s:3:\"fid\";a:1:{i:0;s:3:\"fid\";}}s:8:\"settings\";a:2:{s:10:\"uri_scheme\";s:6:\"public\";s:13:\"default_image\";i:0;}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:22:\"field_data_field_image\";a:5:{s:3:\"fid\";s:15:\"field_image_fid\";s:3:\"alt\";s:15:\"field_image_alt\";s:5:\"title\";s:17:\"field_image_title\";s:5:\"width\";s:17:\"field_image_width\";s:6:\"height\";s:18:\"field_image_height\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:26:\"field_revision_field_image\";a:5:{s:3:\"fid\";s:15:\"field_image_fid\";s:3:\"alt\";s:15:\"field_image_alt\";s:5:\"title\";s:17:\"field_image_title\";s:5:\"width\";s:17:\"field_image_width\";s:6:\"height\";s:18:\"field_image_height\";}}}}}s:12:\"entity_types\";a:0:{}s:12:\"translatable\";s:1:\"0\";s:12:\"foreign keys\";a:1:{s:3:\"fid\";a:2:{s:5:\"table\";s:12:\"file_managed\";s:7:\"columns\";a:1:{s:3:\"fid\";s:3:\"fid\";}}}s:2:\"id\";s:1:\"4\";s:10:\"field_name\";s:11:\"field_image\";s:4:\"type\";s:5:\"image\";s:6:\"module\";s:5:\"image\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:5:{s:3:\"fid\";a:4:{s:11:\"description\";s:54:\"The {file_managed}.fid being referenced in this field.\";s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;s:8:\"unsigned\";b:1;}s:3:\"alt\";a:4:{s:11:\"description\";s:56:\"Alternative image text, for the image\'s \'alt\' attribute.\";s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:512;s:8:\"not null\";b:0;}s:5:\"title\";a:4:{s:11:\"description\";s:52:\"Image title text, for the image\'s \'title\' attribute.\";s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:1024;s:8:\"not null\";b:0;}s:5:\"width\";a:3:{s:11:\"description\";s:33:\"The width of the image in pixels.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;}s:6:\"height\";a:3:{s:11:\"description\";s:34:\"The height of the image in pixels.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;}}s:7:\"bundles\";a:2:{s:4:\"node\";a:3:{i:0;s:7:\"article\";i:1;s:4:\"blog\";i:2;s:8:\"products\";}s:21:\"field_collection_item\";a:1:{i:0;s:19:\"field_extra_content\";}}}i:2;a:16:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:7:{s:10:\"attributes\";a:3:{s:6:\"target\";s:7:\"default\";s:5:\"class\";s:0:\"\";s:3:\"rel\";s:0:\"\";}s:3:\"url\";i:0;s:5:\"title\";s:8:\"optional\";s:11:\"title_value\";s:0:\"\";s:15:\"title_maxlength\";i:128;s:13:\"enable_tokens\";i:1;s:7:\"display\";a:1:{s:10:\"url_cutoff\";i:80;}}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:21:\"field_data_field_link\";a:3:{s:3:\"url\";s:14:\"field_link_url\";s:5:\"title\";s:16:\"field_link_title\";s:10:\"attributes\";s:21:\"field_link_attributes\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:25:\"field_revision_field_link\";a:3:{s:3:\"url\";s:14:\"field_link_url\";s:5:\"title\";s:16:\"field_link_title\";s:10:\"attributes\";s:21:\"field_link_attributes\";}}}}}s:12:\"foreign keys\";a:0:{}s:7:\"indexes\";a:0:{}s:2:\"id\";s:2:\"14\";s:10:\"field_name\";s:10:\"field_link\";s:4:\"type\";s:10:\"link_field\";s:6:\"module\";s:4:\"link\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:3:{s:3:\"url\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:2048;s:8:\"not null\";b:0;s:8:\"sortable\";b:1;}s:5:\"title\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;s:8:\"sortable\";b:1;}s:10:\"attributes\";a:3:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:6:\"medium\";s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{i:0;s:8:\"products\";}}}}}',0,1512620340,1),('field_info:bundle:node:video','a:2:{s:9:\"instances\";a:3:{s:4:\"body\";a:13:{s:5:\"label\";s:4:\"Body\";s:6:\"widget\";a:4:{s:4:\"type\";s:26:\"text_textarea_with_summary\";s:8:\"settings\";a:2:{s:4:\"rows\";i:20;s:12:\"summary_rows\";i:5;}s:6:\"weight\";s:1:\"2\";s:6:\"module\";s:4:\"text\";}s:8:\"settings\";a:3:{s:15:\"display_summary\";b:1;s:15:\"text_processing\";i:1;s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";s:1:\"1\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";}s:6:\"teaser\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:23:\"text_summary_or_trimmed\";s:6:\"weight\";s:1:\"1\";s:8:\"settings\";a:1:{s:11:\"trim_length\";i:600;}s:6:\"module\";s:4:\"text\";}}s:8:\"required\";b:0;s:11:\"description\";s:0:\"\";s:2:\"id\";s:2:\"31\";s:8:\"field_id\";s:1:\"2\";s:10:\"field_name\";s:4:\"body\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:5:\"video\";s:7:\"deleted\";s:1:\"0\";s:13:\"default_value\";N;}s:10:\"field_tags\";a:13:{s:5:\"label\";s:4:\"Tags\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"4\";s:4:\"type\";s:21:\"taxonomy_autocomplete\";s:6:\"module\";s:8:\"taxonomy\";s:6:\"active\";i:0;s:8:\"settings\";a:2:{s:4:\"size\";i:60;s:17:\"autocomplete_path\";s:21:\"taxonomy/autocomplete\";}}s:8:\"settings\";a:1:{s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"inline\";s:4:\"type\";s:33:\"i18n_taxonomy_term_reference_link\";s:6:\"weight\";s:1:\"2\";s:8:\"settings\";a:0:{}s:6:\"module\";s:13:\"i18n_taxonomy\";}s:6:\"teaser\";a:4:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:6:\"hidden\";s:6:\"weight\";s:1:\"2\";s:8:\"settings\";a:0:{}}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;s:2:\"id\";s:2:\"32\";s:8:\"field_id\";s:1:\"3\";s:10:\"field_name\";s:10:\"field_tags\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:5:\"video\";s:7:\"deleted\";s:1:\"0\";}s:16:\"field_video_link\";a:13:{s:5:\"label\";s:10:\"Video Link\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"3\";s:4:\"type\";s:23:\"video_embed_field_video\";s:6:\"module\";s:17:\"video_embed_field\";s:6:\"active\";i:0;s:8:\"settings\";a:0:{}}s:8:\"settings\";a:4:{s:17:\"description_field\";i:0;s:18:\"description_length\";s:3:\"128\";s:18:\"user_register_form\";b:0;s:17:\"allowed_providers\";a:2:{i:0;s:7:\"youtube\";i:1;s:5:\"vimeo\";}}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:17:\"video_embed_field\";s:6:\"weight\";s:1:\"0\";s:8:\"settings\";a:3:{s:11:\"video_style\";s:5:\"large\";s:11:\"description\";i:1;s:20:\"description_position\";s:6:\"bottom\";}s:6:\"module\";s:17:\"video_embed_field\";}s:6:\"teaser\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:17:\"video_embed_field\";s:6:\"weight\";s:1:\"0\";s:8:\"settings\";a:3:{s:11:\"video_style\";s:5:\"large\";s:11:\"description\";i:1;s:20:\"description_position\";s:6:\"bottom\";}s:6:\"module\";s:17:\"video_embed_field\";}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;s:2:\"id\";s:2:\"33\";s:8:\"field_id\";s:2:\"13\";s:10:\"field_name\";s:16:\"field_video_link\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:5:\"video\";s:7:\"deleted\";s:1:\"0\";}}s:6:\"fields\";a:3:{i:0;a:16:{s:12:\"entity_types\";a:1:{i:0;s:4:\"node\";}s:12:\"translatable\";s:1:\"0\";s:8:\"settings\";a:0:{}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:15:\"field_data_body\";a:3:{s:5:\"value\";s:10:\"body_value\";s:7:\"summary\";s:12:\"body_summary\";s:6:\"format\";s:11:\"body_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:19:\"field_revision_body\";a:3:{s:5:\"value\";s:10:\"body_value\";s:7:\"summary\";s:12:\"body_summary\";s:6:\"format\";s:11:\"body_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:1:\"2\";s:10:\"field_name\";s:4:\"body\";s:4:\"type\";s:17:\"text_with_summary\";s:6:\"module\";s:4:\"text\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:3:{s:5:\"value\";a:3:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:3:\"big\";s:8:\"not null\";b:0;}s:7:\"summary\";a:3:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:3:\"big\";s:8:\"not null\";b:0;}s:6:\"format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:9:{i:0;s:4:\"page\";i:1;s:7:\"article\";i:2;s:4:\"blog\";i:3;s:4:\"book\";i:4;s:5:\"forum\";i:5;s:3:\"faq\";i:6;s:5:\"video\";i:7;s:7:\"webform\";i:8;s:8:\"products\";}}}i:1;a:16:{s:8:\"settings\";a:2:{s:14:\"allowed_values\";a:1:{i:0;a:2:{s:10:\"vocabulary\";s:4:\"tags\";s:6:\"parent\";i:0;}}s:21:\"options_list_callback\";s:28:\"i18n_taxonomy_allowed_values\";}s:12:\"entity_types\";a:0:{}s:12:\"translatable\";s:1:\"0\";s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:21:\"field_data_field_tags\";a:1:{s:3:\"tid\";s:14:\"field_tags_tid\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:25:\"field_revision_field_tags\";a:1:{s:3:\"tid\";s:14:\"field_tags_tid\";}}}}}s:12:\"foreign keys\";a:1:{s:3:\"tid\";a:2:{s:5:\"table\";s:18:\"taxonomy_term_data\";s:7:\"columns\";a:1:{s:3:\"tid\";s:3:\"tid\";}}}s:7:\"indexes\";a:1:{s:3:\"tid\";a:1:{i:0;s:3:\"tid\";}}s:2:\"id\";s:1:\"3\";s:10:\"field_name\";s:10:\"field_tags\";s:4:\"type\";s:23:\"taxonomy_term_reference\";s:6:\"module\";s:8:\"taxonomy\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:2:\"-1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:1:{s:3:\"tid\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:3:{i:0;s:7:\"article\";i:1;s:4:\"blog\";i:2;s:5:\"video\";}}}i:2;a:16:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:0:{}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:27:\"field_data_field_video_link\";a:5:{s:9:\"video_url\";s:26:\"field_video_link_video_url\";s:14:\"thumbnail_path\";s:31:\"field_video_link_thumbnail_path\";s:10:\"video_data\";s:27:\"field_video_link_video_data\";s:10:\"embed_code\";s:27:\"field_video_link_embed_code\";s:11:\"description\";s:28:\"field_video_link_description\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:31:\"field_revision_field_video_link\";a:5:{s:9:\"video_url\";s:26:\"field_video_link_video_url\";s:14:\"thumbnail_path\";s:31:\"field_video_link_thumbnail_path\";s:10:\"video_data\";s:27:\"field_video_link_video_data\";s:10:\"embed_code\";s:27:\"field_video_link_embed_code\";s:11:\"description\";s:28:\"field_video_link_description\";}}}}}s:12:\"foreign keys\";a:0:{}s:7:\"indexes\";a:0:{}s:2:\"id\";s:2:\"13\";s:10:\"field_name\";s:16:\"field_video_link\";s:4:\"type\";s:17:\"video_embed_field\";s:6:\"module\";s:17:\"video_embed_field\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:5:{s:9:\"video_url\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:512;s:7:\"default\";s:0:\"\";}s:14:\"thumbnail_path\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:512;s:7:\"default\";s:0:\"\";}s:10:\"video_data\";a:4:{s:4:\"type\";s:4:\"blob\";s:8:\"not null\";b:0;s:4:\"size\";s:3:\"big\";s:9:\"serialize\";b:1;}s:10:\"embed_code\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:1024;s:7:\"default\";s:0:\"\";}s:11:\"description\";a:2:{s:4:\"type\";s:4:\"text\";s:8:\"not null\";b:0;}}s:7:\"bundles\";a:2:{s:4:\"node\";a:1:{i:0;s:5:\"video\";}s:21:\"field_collection_item\";a:1:{i:0;s:19:\"field_extra_content\";}}}}}',0,1512620340,1),('field_info:bundle:node:webform','a:2:{s:9:\"instances\";a:1:{s:4:\"body\";a:13:{s:5:\"label\";s:4:\"Body\";s:6:\"widget\";a:4:{s:4:\"type\";s:26:\"text_textarea_with_summary\";s:8:\"settings\";a:2:{s:4:\"rows\";i:20;s:12:\"summary_rows\";i:5;}s:6:\"weight\";i:31;s:6:\"module\";s:4:\"text\";}s:8:\"settings\";a:3:{s:15:\"display_summary\";b:1;s:15:\"text_processing\";i:1;s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";s:1:\"1\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";}s:6:\"teaser\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:23:\"text_summary_or_trimmed\";s:8:\"settings\";a:1:{s:11:\"trim_length\";i:600;}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:0;}}s:8:\"required\";b:0;s:11:\"description\";s:0:\"\";s:2:\"id\";s:2:\"35\";s:8:\"field_id\";s:1:\"2\";s:10:\"field_name\";s:4:\"body\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:7:\"webform\";s:7:\"deleted\";s:1:\"0\";s:13:\"default_value\";N;}}s:6:\"fields\";a:1:{i:0;a:16:{s:12:\"entity_types\";a:1:{i:0;s:4:\"node\";}s:12:\"translatable\";s:1:\"0\";s:8:\"settings\";a:0:{}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:15:\"field_data_body\";a:3:{s:5:\"value\";s:10:\"body_value\";s:7:\"summary\";s:12:\"body_summary\";s:6:\"format\";s:11:\"body_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:19:\"field_revision_body\";a:3:{s:5:\"value\";s:10:\"body_value\";s:7:\"summary\";s:12:\"body_summary\";s:6:\"format\";s:11:\"body_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:1:\"2\";s:10:\"field_name\";s:4:\"body\";s:4:\"type\";s:17:\"text_with_summary\";s:6:\"module\";s:4:\"text\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:3:{s:5:\"value\";a:3:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:3:\"big\";s:8:\"not null\";b:0;}s:7:\"summary\";a:3:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:3:\"big\";s:8:\"not null\";b:0;}s:6:\"format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:9:{i:0;s:4:\"page\";i:1;s:7:\"article\";i:2;s:4:\"blog\";i:3;s:4:\"book\";i:4;s:5:\"forum\";i:5;s:3:\"faq\";i:6;s:5:\"video\";i:7;s:7:\"webform\";i:8;s:8:\"products\";}}}}}',0,1512620340,1),('field_info:bundle:taxonomy_term:categories','a:2:{s:9:\"instances\";a:0:{}s:6:\"fields\";a:0:{}}',0,1512620348,1),('field_info:bundle:taxonomy_term:forums','a:2:{s:9:\"instances\";a:0:{}s:6:\"fields\";a:0:{}}',0,1512620348,1),('field_info:bundle:taxonomy_term:sections','a:2:{s:9:\"instances\";a:0:{}s:6:\"fields\";a:0:{}}',0,1512620348,1),('field_info:bundle:taxonomy_term:tags','a:2:{s:9:\"instances\";a:0:{}s:6:\"fields\";a:0:{}}',0,1512620348,1),('field_info:bundle:user:user','a:2:{s:9:\"instances\";a:0:{}s:6:\"fields\";a:0:{}}',0,1512620327,1),('field_info:bundle_extra:user:user','a:2:{s:4:\"form\";a:7:{s:8:\"ckeditor\";a:3:{s:5:\"label\";s:25:\"Rich text editor settings\";s:11:\"description\";s:25:\"Rich text editor settings\";s:6:\"weight\";i:10;}s:7:\"account\";a:3:{s:5:\"label\";s:22:\"User name and password\";s:11:\"description\";s:34:\"User module account form elements.\";s:6:\"weight\";i:-10;}s:8:\"timezone\";a:3:{s:5:\"label\";s:8:\"Timezone\";s:11:\"description\";s:34:\"User module timezone form element.\";s:6:\"weight\";i:6;}s:7:\"picture\";a:3:{s:5:\"label\";s:7:\"Picture\";s:11:\"description\";s:12:\"User picture\";s:6:\"weight\";i:5;}s:15:\"overlay_control\";a:3:{s:5:\"label\";s:22:\"Administrative overlay\";s:11:\"description\";s:22:\"Administrative overlay\";s:6:\"weight\";i:5;}s:7:\"contact\";a:3:{s:5:\"label\";s:7:\"Contact\";s:11:\"description\";s:20:\"Contact user element\";s:6:\"weight\";i:5;}s:6:\"locale\";a:3:{s:5:\"label\";s:17:\"Language settings\";s:11:\"description\";s:39:\"Language settings for the user account.\";s:6:\"weight\";i:5;}}s:7:\"display\";a:1:{s:7:\"summary\";a:3:{s:5:\"label\";s:7:\"History\";s:11:\"description\";s:33:\"User module history view element.\";s:7:\"display\";a:3:{s:7:\"default\";a:2:{s:6:\"weight\";i:5;s:7:\"visible\";b:1;}s:4:\"full\";a:2:{s:6:\"weight\";i:5;s:7:\"visible\";b:1;}s:5:\"token\";a:2:{s:6:\"weight\";i:5;s:7:\"visible\";b:1;}}}}}',0,1512620348,1),('field_info:fields','a:17:{i:1;a:16:{s:12:\"entity_types\";a:1:{i:0;s:7:\"comment\";}s:12:\"translatable\";s:1:\"0\";s:8:\"settings\";a:0:{}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:23:\"field_data_comment_body\";a:2:{s:5:\"value\";s:18:\"comment_body_value\";s:6:\"format\";s:19:\"comment_body_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:27:\"field_revision_comment_body\";a:2:{s:5:\"value\";s:18:\"comment_body_value\";s:6:\"format\";s:19:\"comment_body_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:1:\"1\";s:10:\"field_name\";s:12:\"comment_body\";s:4:\"type\";s:9:\"text_long\";s:6:\"module\";s:4:\"text\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:2:{s:5:\"value\";a:3:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:3:\"big\";s:8:\"not null\";b:0;}s:6:\"format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:7:\"comment\";a:9:{i:0;s:17:\"comment_node_page\";i:1;s:20:\"comment_node_article\";i:2;s:17:\"comment_node_blog\";i:3;s:17:\"comment_node_book\";i:4;s:18:\"comment_node_forum\";i:5;s:16:\"comment_node_faq\";i:6;s:18:\"comment_node_video\";i:7;s:20:\"comment_node_webform\";i:8;s:21:\"comment_node_products\";}}}i:2;a:16:{s:12:\"entity_types\";a:1:{i:0;s:4:\"node\";}s:12:\"translatable\";s:1:\"0\";s:8:\"settings\";a:0:{}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:15:\"field_data_body\";a:3:{s:5:\"value\";s:10:\"body_value\";s:7:\"summary\";s:12:\"body_summary\";s:6:\"format\";s:11:\"body_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:19:\"field_revision_body\";a:3:{s:5:\"value\";s:10:\"body_value\";s:7:\"summary\";s:12:\"body_summary\";s:6:\"format\";s:11:\"body_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:1:\"2\";s:10:\"field_name\";s:4:\"body\";s:4:\"type\";s:17:\"text_with_summary\";s:6:\"module\";s:4:\"text\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:3:{s:5:\"value\";a:3:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:3:\"big\";s:8:\"not null\";b:0;}s:7:\"summary\";a:3:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:3:\"big\";s:8:\"not null\";b:0;}s:6:\"format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:9:{i:0;s:4:\"page\";i:1;s:7:\"article\";i:2;s:4:\"blog\";i:3;s:4:\"book\";i:4;s:5:\"forum\";i:5;s:3:\"faq\";i:6;s:5:\"video\";i:7;s:7:\"webform\";i:8;s:8:\"products\";}}}i:3;a:16:{s:8:\"settings\";a:2:{s:14:\"allowed_values\";a:1:{i:0;a:2:{s:10:\"vocabulary\";s:4:\"tags\";s:6:\"parent\";i:0;}}s:21:\"options_list_callback\";s:28:\"i18n_taxonomy_allowed_values\";}s:12:\"entity_types\";a:0:{}s:12:\"translatable\";s:1:\"0\";s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:21:\"field_data_field_tags\";a:1:{s:3:\"tid\";s:14:\"field_tags_tid\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:25:\"field_revision_field_tags\";a:1:{s:3:\"tid\";s:14:\"field_tags_tid\";}}}}}s:12:\"foreign keys\";a:1:{s:3:\"tid\";a:2:{s:5:\"table\";s:18:\"taxonomy_term_data\";s:7:\"columns\";a:1:{s:3:\"tid\";s:3:\"tid\";}}}s:7:\"indexes\";a:1:{s:3:\"tid\";a:1:{i:0;s:3:\"tid\";}}s:2:\"id\";s:1:\"3\";s:10:\"field_name\";s:10:\"field_tags\";s:4:\"type\";s:23:\"taxonomy_term_reference\";s:6:\"module\";s:8:\"taxonomy\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:2:\"-1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:1:{s:3:\"tid\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:3:{i:0;s:7:\"article\";i:1;s:4:\"blog\";i:2;s:5:\"video\";}}}i:4;a:16:{s:7:\"indexes\";a:1:{s:3:\"fid\";a:1:{i:0;s:3:\"fid\";}}s:8:\"settings\";a:2:{s:10:\"uri_scheme\";s:6:\"public\";s:13:\"default_image\";i:0;}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:22:\"field_data_field_image\";a:5:{s:3:\"fid\";s:15:\"field_image_fid\";s:3:\"alt\";s:15:\"field_image_alt\";s:5:\"title\";s:17:\"field_image_title\";s:5:\"width\";s:17:\"field_image_width\";s:6:\"height\";s:18:\"field_image_height\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:26:\"field_revision_field_image\";a:5:{s:3:\"fid\";s:15:\"field_image_fid\";s:3:\"alt\";s:15:\"field_image_alt\";s:5:\"title\";s:17:\"field_image_title\";s:5:\"width\";s:17:\"field_image_width\";s:6:\"height\";s:18:\"field_image_height\";}}}}}s:12:\"entity_types\";a:0:{}s:12:\"translatable\";s:1:\"0\";s:12:\"foreign keys\";a:1:{s:3:\"fid\";a:2:{s:5:\"table\";s:12:\"file_managed\";s:7:\"columns\";a:1:{s:3:\"fid\";s:3:\"fid\";}}}s:2:\"id\";s:1:\"4\";s:10:\"field_name\";s:11:\"field_image\";s:4:\"type\";s:5:\"image\";s:6:\"module\";s:5:\"image\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:5:{s:3:\"fid\";a:4:{s:11:\"description\";s:54:\"The {file_managed}.fid being referenced in this field.\";s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;s:8:\"unsigned\";b:1;}s:3:\"alt\";a:4:{s:11:\"description\";s:56:\"Alternative image text, for the image\'s \'alt\' attribute.\";s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:512;s:8:\"not null\";b:0;}s:5:\"title\";a:4:{s:11:\"description\";s:52:\"Image title text, for the image\'s \'title\' attribute.\";s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:1024;s:8:\"not null\";b:0;}s:5:\"width\";a:3:{s:11:\"description\";s:33:\"The width of the image in pixels.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;}s:6:\"height\";a:3:{s:11:\"description\";s:34:\"The height of the image in pixels.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;}}s:7:\"bundles\";a:2:{s:4:\"node\";a:3:{i:0;s:7:\"article\";i:1;s:4:\"blog\";i:2;s:8:\"products\";}s:21:\"field_collection_item\";a:1:{i:0;s:19:\"field_extra_content\";}}}i:5;a:16:{s:8:\"settings\";a:2:{s:14:\"allowed_values\";a:1:{i:0;a:2:{s:10:\"vocabulary\";s:6:\"forums\";s:6:\"parent\";i:0;}}s:21:\"options_list_callback\";s:28:\"i18n_taxonomy_allowed_values\";}s:12:\"entity_types\";a:0:{}s:12:\"translatable\";s:1:\"0\";s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:26:\"field_data_taxonomy_forums\";a:1:{s:3:\"tid\";s:19:\"taxonomy_forums_tid\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:30:\"field_revision_taxonomy_forums\";a:1:{s:3:\"tid\";s:19:\"taxonomy_forums_tid\";}}}}}s:12:\"foreign keys\";a:1:{s:3:\"tid\";a:2:{s:5:\"table\";s:18:\"taxonomy_term_data\";s:7:\"columns\";a:1:{s:3:\"tid\";s:3:\"tid\";}}}s:7:\"indexes\";a:1:{s:3:\"tid\";a:1:{i:0;s:3:\"tid\";}}s:2:\"id\";s:1:\"5\";s:10:\"field_name\";s:15:\"taxonomy_forums\";s:4:\"type\";s:23:\"taxonomy_term_reference\";s:6:\"module\";s:8:\"taxonomy\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:1:{s:3:\"tid\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{i:0;s:5:\"forum\";}}}i:6;a:16:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:4:\"axis\";s:4:\"vote\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:21:\"field_data_field_vote\";a:2:{s:6:\"rating\";s:17:\"field_vote_rating\";s:6:\"target\";s:17:\"field_vote_target\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:25:\"field_revision_field_vote\";a:2:{s:6:\"rating\";s:17:\"field_vote_rating\";s:6:\"target\";s:17:\"field_vote_target\";}}}}}s:12:\"foreign keys\";a:0:{}s:7:\"indexes\";a:0:{}s:2:\"id\";s:1:\"6\";s:10:\"field_name\";s:10:\"field_vote\";s:4:\"type\";s:8:\"fivestar\";s:6:\"module\";s:8:\"fivestar\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:2:{s:6:\"rating\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;s:8:\"sortable\";b:1;}s:6:\"target\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}}s:7:\"bundles\";a:2:{s:4:\"node\";a:2:{i:0;s:5:\"forum\";i:1;s:4:\"blog\";}s:7:\"comment\";a:1:{i:0;s:18:\"comment_node_forum\";}}}i:7;a:16:{s:12:\"entity_types\";a:1:{i:0;s:12:\"message_type\";}s:12:\"translatable\";s:1:\"1\";s:8:\"settings\";a:1:{s:12:\"message_text\";b:1;}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:23:\"field_data_message_text\";a:2:{s:5:\"value\";s:18:\"message_text_value\";s:6:\"format\";s:19:\"message_text_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:27:\"field_revision_message_text\";a:2:{s:5:\"value\";s:18:\"message_text_value\";s:6:\"format\";s:19:\"message_text_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:1:\"7\";s:10:\"field_name\";s:12:\"message_text\";s:4:\"type\";s:9:\"text_long\";s:6:\"module\";s:4:\"text\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"1\";s:11:\"cardinality\";s:2:\"-1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:2:{s:5:\"value\";a:3:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:3:\"big\";s:8:\"not null\";b:0;}s:6:\"format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:12:\"message_type\";a:1:{i:0;s:12:\"message_type\";}}}i:8;a:16:{s:12:\"entity_types\";a:0:{}s:12:\"foreign keys\";a:0:{}s:7:\"indexes\";a:1:{s:9:\"target_id\";a:1:{i:0;s:9:\"target_id\";}}s:8:\"settings\";a:4:{s:7:\"handler\";s:4:\"base\";s:16:\"handler_settings\";a:3:{s:9:\"behaviors\";a:1:{s:17:\"views-select-list\";a:1:{s:6:\"status\";i:0;}}s:4:\"sort\";a:4:{s:9:\"direction\";s:3:\"ASC\";s:5:\"field\";s:18:\"comment_body:value\";s:8:\"property\";s:3:\"nid\";s:4:\"type\";s:4:\"none\";}s:14:\"target_bundles\";a:0:{}}s:14:\"handler_submit\";s:14:\"Change handler\";s:11:\"target_type\";s:7:\"comment\";}s:12:\"translatable\";s:1:\"0\";s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:28:\"field_data_field_comment_ref\";a:1:{s:9:\"target_id\";s:27:\"field_comment_ref_target_id\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:32:\"field_revision_field_comment_ref\";a:1:{s:9:\"target_id\";s:27:\"field_comment_ref_target_id\";}}}}}s:2:\"id\";s:1:\"8\";s:10:\"field_name\";s:17:\"field_comment_ref\";s:4:\"type\";s:15:\"entityreference\";s:6:\"module\";s:15:\"entityreference\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:1:{s:9:\"target_id\";a:4:{s:11:\"description\";s:28:\"The id of the target entity.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}}s:7:\"bundles\";a:1:{s:7:\"message\";a:1:{i:0;s:22:\"example_create_comment\";}}}i:9;a:16:{s:12:\"entity_types\";a:0:{}s:12:\"foreign keys\";a:0:{}s:7:\"indexes\";a:1:{s:9:\"target_id\";a:1:{i:0;s:9:\"target_id\";}}s:8:\"settings\";a:5:{s:7:\"handler\";s:4:\"base\";s:16:\"handler_settings\";a:3:{s:9:\"behaviors\";a:1:{s:17:\"views-select-list\";a:1:{s:6:\"status\";i:0;}}s:4:\"sort\";a:4:{s:9:\"direction\";s:3:\"ASC\";s:5:\"field\";s:10:\"body:value\";s:8:\"property\";s:3:\"nid\";s:4:\"type\";s:4:\"none\";}s:14:\"target_bundles\";a:0:{}}s:14:\"handler_submit\";s:14:\"Change handler\";s:14:\"target_bundles\";a:0:{}s:11:\"target_type\";s:4:\"node\";}s:12:\"translatable\";s:1:\"0\";s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:25:\"field_data_field_node_ref\";a:1:{s:9:\"target_id\";s:24:\"field_node_ref_target_id\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:29:\"field_revision_field_node_ref\";a:1:{s:9:\"target_id\";s:24:\"field_node_ref_target_id\";}}}}}s:2:\"id\";s:1:\"9\";s:10:\"field_name\";s:14:\"field_node_ref\";s:4:\"type\";s:15:\"entityreference\";s:6:\"module\";s:15:\"entityreference\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:1:{s:9:\"target_id\";a:4:{s:11:\"description\";s:28:\"The id of the target entity.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}}s:7:\"bundles\";a:1:{s:7:\"message\";a:2:{i:0;s:22:\"example_create_comment\";i:1;s:19:\"example_create_node\";}}}i:10;a:16:{s:12:\"entity_types\";a:0:{}s:12:\"foreign keys\";a:0:{}s:7:\"indexes\";a:1:{s:5:\"value\";a:1:{i:0;s:5:\"value\";}}s:8:\"settings\";a:2:{s:14:\"allowed_values\";a:2:{i:0;s:11:\"Unpublished\";i:1;s:9:\"Published\";}s:23:\"allowed_values_function\";s:0:\"\";}s:12:\"translatable\";s:1:\"0\";s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:26:\"field_data_field_published\";a:1:{s:5:\"value\";s:21:\"field_published_value\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:30:\"field_revision_field_published\";a:1:{s:5:\"value\";s:21:\"field_published_value\";}}}}}s:2:\"id\";s:2:\"10\";s:10:\"field_name\";s:15:\"field_published\";s:4:\"type\";s:12:\"list_boolean\";s:6:\"module\";s:4:\"list\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:1:{s:5:\"value\";a:2:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:7:\"message\";a:3:{i:0;s:22:\"example_create_comment\";i:1;s:19:\"example_create_node\";i:2;s:21:\"example_user_register\";}}}i:11;a:16:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:2:{s:14:\"allowed_values\";a:1:{i:0;a:2:{s:10:\"vocabulary\";s:8:\"sections\";s:6:\"parent\";s:1:\"0\";}}s:21:\"options_list_callback\";s:28:\"i18n_taxonomy_allowed_values\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:24:\"field_data_field_section\";a:1:{s:3:\"tid\";s:17:\"field_section_tid\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:28:\"field_revision_field_section\";a:1:{s:3:\"tid\";s:17:\"field_section_tid\";}}}}}s:12:\"foreign keys\";a:1:{s:3:\"tid\";a:2:{s:5:\"table\";s:18:\"taxonomy_term_data\";s:7:\"columns\";a:1:{s:3:\"tid\";s:3:\"tid\";}}}s:7:\"indexes\";a:1:{s:3:\"tid\";a:1:{i:0;s:3:\"tid\";}}s:2:\"id\";s:2:\"11\";s:10:\"field_name\";s:13:\"field_section\";s:4:\"type\";s:23:\"taxonomy_term_reference\";s:6:\"module\";s:8:\"taxonomy\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:1:{s:3:\"tid\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{i:0;s:7:\"article\";}}}i:12;a:16:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:2:{s:14:\"allowed_values\";a:1:{i:0;a:2:{s:10:\"vocabulary\";s:10:\"categories\";s:6:\"parent\";s:1:\"0\";}}s:21:\"options_list_callback\";s:28:\"i18n_taxonomy_allowed_values\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:25:\"field_data_field_category\";a:1:{s:3:\"tid\";s:18:\"field_category_tid\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:29:\"field_revision_field_category\";a:1:{s:3:\"tid\";s:18:\"field_category_tid\";}}}}}s:12:\"foreign keys\";a:1:{s:3:\"tid\";a:2:{s:5:\"table\";s:18:\"taxonomy_term_data\";s:7:\"columns\";a:1:{s:3:\"tid\";s:3:\"tid\";}}}s:7:\"indexes\";a:1:{s:3:\"tid\";a:1:{i:0;s:3:\"tid\";}}s:2:\"id\";s:2:\"12\";s:10:\"field_name\";s:14:\"field_category\";s:4:\"type\";s:23:\"taxonomy_term_reference\";s:6:\"module\";s:8:\"taxonomy\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:1:{s:3:\"tid\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{i:0;s:7:\"article\";}}}i:13;a:16:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:0:{}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:27:\"field_data_field_video_link\";a:5:{s:9:\"video_url\";s:26:\"field_video_link_video_url\";s:14:\"thumbnail_path\";s:31:\"field_video_link_thumbnail_path\";s:10:\"video_data\";s:27:\"field_video_link_video_data\";s:10:\"embed_code\";s:27:\"field_video_link_embed_code\";s:11:\"description\";s:28:\"field_video_link_description\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:31:\"field_revision_field_video_link\";a:5:{s:9:\"video_url\";s:26:\"field_video_link_video_url\";s:14:\"thumbnail_path\";s:31:\"field_video_link_thumbnail_path\";s:10:\"video_data\";s:27:\"field_video_link_video_data\";s:10:\"embed_code\";s:27:\"field_video_link_embed_code\";s:11:\"description\";s:28:\"field_video_link_description\";}}}}}s:12:\"foreign keys\";a:0:{}s:7:\"indexes\";a:0:{}s:2:\"id\";s:2:\"13\";s:10:\"field_name\";s:16:\"field_video_link\";s:4:\"type\";s:17:\"video_embed_field\";s:6:\"module\";s:17:\"video_embed_field\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:5:{s:9:\"video_url\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:512;s:7:\"default\";s:0:\"\";}s:14:\"thumbnail_path\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:512;s:7:\"default\";s:0:\"\";}s:10:\"video_data\";a:4:{s:4:\"type\";s:4:\"blob\";s:8:\"not null\";b:0;s:4:\"size\";s:3:\"big\";s:9:\"serialize\";b:1;}s:10:\"embed_code\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:1024;s:7:\"default\";s:0:\"\";}s:11:\"description\";a:2:{s:4:\"type\";s:4:\"text\";s:8:\"not null\";b:0;}}s:7:\"bundles\";a:2:{s:4:\"node\";a:1:{i:0;s:5:\"video\";}s:21:\"field_collection_item\";a:1:{i:0;s:19:\"field_extra_content\";}}}i:14;a:16:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:7:{s:10:\"attributes\";a:3:{s:6:\"target\";s:7:\"default\";s:5:\"class\";s:0:\"\";s:3:\"rel\";s:0:\"\";}s:3:\"url\";i:0;s:5:\"title\";s:8:\"optional\";s:11:\"title_value\";s:0:\"\";s:15:\"title_maxlength\";i:128;s:13:\"enable_tokens\";i:1;s:7:\"display\";a:1:{s:10:\"url_cutoff\";i:80;}}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:21:\"field_data_field_link\";a:3:{s:3:\"url\";s:14:\"field_link_url\";s:5:\"title\";s:16:\"field_link_title\";s:10:\"attributes\";s:21:\"field_link_attributes\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:25:\"field_revision_field_link\";a:3:{s:3:\"url\";s:14:\"field_link_url\";s:5:\"title\";s:16:\"field_link_title\";s:10:\"attributes\";s:21:\"field_link_attributes\";}}}}}s:12:\"foreign keys\";a:0:{}s:7:\"indexes\";a:0:{}s:2:\"id\";s:2:\"14\";s:10:\"field_name\";s:10:\"field_link\";s:4:\"type\";s:10:\"link_field\";s:6:\"module\";s:4:\"link\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:3:{s:3:\"url\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:2048;s:8:\"not null\";b:0;s:8:\"sortable\";b:1;}s:5:\"title\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;s:8:\"sortable\";b:1;}s:10:\"attributes\";a:3:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:6:\"medium\";s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{i:0;s:8:\"products\";}}}i:16;a:16:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:2:{s:16:\"hide_blank_items\";i:1;s:4:\"path\";s:0:\"\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:30:\"field_data_field_extra_content\";a:2:{s:5:\"value\";s:25:\"field_extra_content_value\";s:11:\"revision_id\";s:31:\"field_extra_content_revision_id\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:34:\"field_revision_field_extra_content\";a:2:{s:5:\"value\";s:25:\"field_extra_content_value\";s:11:\"revision_id\";s:31:\"field_extra_content_revision_id\";}}}}}s:12:\"foreign keys\";a:0:{}s:7:\"indexes\";a:1:{s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}}s:2:\"id\";s:2:\"16\";s:10:\"field_name\";s:19:\"field_extra_content\";s:4:\"type\";s:16:\"field_collection\";s:6:\"module\";s:16:\"field_collection\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:2:\"-1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:2:{s:5:\"value\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;s:11:\"description\";s:29:\"The field collection item id.\";}s:11:\"revision_id\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;s:11:\"description\";s:38:\"The field collection item revision id.\";}}s:7:\"bundles\";a:1:{s:4:\"node\";a:3:{i:0;s:4:\"blog\";i:1;s:7:\"article\";i:2;s:5:\"forum\";}}}i:17;a:16:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:0:{}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:28:\"field_data_field_description\";a:2:{s:5:\"value\";s:23:\"field_description_value\";s:6:\"format\";s:24:\"field_description_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:32:\"field_revision_field_description\";a:2:{s:5:\"value\";s:23:\"field_description_value\";s:6:\"format\";s:24:\"field_description_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:2:\"17\";s:10:\"field_name\";s:17:\"field_description\";s:4:\"type\";s:9:\"text_long\";s:6:\"module\";s:4:\"text\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:2:{s:5:\"value\";a:3:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:3:\"big\";s:8:\"not null\";b:0;}s:6:\"format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:21:\"field_collection_item\";a:1:{i:0;s:19:\"field_extra_content\";}}}i:18;a:16:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:0:{}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:34:\"field_data_field_detailed_question\";a:2:{s:5:\"value\";s:29:\"field_detailed_question_value\";s:6:\"format\";s:30:\"field_detailed_question_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:38:\"field_revision_field_detailed_question\";a:2:{s:5:\"value\";s:29:\"field_detailed_question_value\";s:6:\"format\";s:30:\"field_detailed_question_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:2:\"18\";s:10:\"field_name\";s:23:\"field_detailed_question\";s:4:\"type\";s:9:\"text_long\";s:6:\"module\";s:4:\"text\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:2:{s:5:\"value\";a:3:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:3:\"big\";s:8:\"not null\";b:0;}s:6:\"format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{i:0;s:3:\"faq\";}}}}',0,1512620340,1),('field_info:field_map','a:17:{s:12:\"comment_body\";a:2:{s:7:\"bundles\";a:1:{s:7:\"comment\";a:9:{i:0;s:17:\"comment_node_page\";i:1;s:20:\"comment_node_article\";i:2;s:17:\"comment_node_blog\";i:3;s:17:\"comment_node_book\";i:4;s:18:\"comment_node_forum\";i:5;s:16:\"comment_node_faq\";i:6;s:18:\"comment_node_video\";i:7;s:20:\"comment_node_webform\";i:8;s:21:\"comment_node_products\";}}s:4:\"type\";s:9:\"text_long\";}s:4:\"body\";a:2:{s:7:\"bundles\";a:1:{s:4:\"node\";a:9:{i:0;s:4:\"page\";i:1;s:7:\"article\";i:2;s:4:\"blog\";i:3;s:4:\"book\";i:4;s:5:\"forum\";i:5;s:3:\"faq\";i:6;s:5:\"video\";i:7;s:7:\"webform\";i:8;s:8:\"products\";}}s:4:\"type\";s:17:\"text_with_summary\";}s:10:\"field_tags\";a:2:{s:7:\"bundles\";a:1:{s:4:\"node\";a:3:{i:0;s:7:\"article\";i:1;s:4:\"blog\";i:2;s:5:\"video\";}}s:4:\"type\";s:23:\"taxonomy_term_reference\";}s:11:\"field_image\";a:2:{s:7:\"bundles\";a:2:{s:4:\"node\";a:3:{i:0;s:7:\"article\";i:1;s:4:\"blog\";i:2;s:8:\"products\";}s:21:\"field_collection_item\";a:1:{i:0;s:19:\"field_extra_content\";}}s:4:\"type\";s:5:\"image\";}s:15:\"taxonomy_forums\";a:2:{s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{i:0;s:5:\"forum\";}}s:4:\"type\";s:23:\"taxonomy_term_reference\";}s:10:\"field_vote\";a:2:{s:7:\"bundles\";a:2:{s:4:\"node\";a:2:{i:0;s:5:\"forum\";i:1;s:4:\"blog\";}s:7:\"comment\";a:1:{i:0;s:18:\"comment_node_forum\";}}s:4:\"type\";s:8:\"fivestar\";}s:12:\"message_text\";a:2:{s:7:\"bundles\";a:1:{s:12:\"message_type\";a:1:{i:0;s:12:\"message_type\";}}s:4:\"type\";s:9:\"text_long\";}s:17:\"field_comment_ref\";a:2:{s:7:\"bundles\";a:1:{s:7:\"message\";a:1:{i:0;s:22:\"example_create_comment\";}}s:4:\"type\";s:15:\"entityreference\";}s:14:\"field_node_ref\";a:2:{s:7:\"bundles\";a:1:{s:7:\"message\";a:2:{i:0;s:22:\"example_create_comment\";i:1;s:19:\"example_create_node\";}}s:4:\"type\";s:15:\"entityreference\";}s:15:\"field_published\";a:2:{s:7:\"bundles\";a:1:{s:7:\"message\";a:3:{i:0;s:22:\"example_create_comment\";i:1;s:19:\"example_create_node\";i:2;s:21:\"example_user_register\";}}s:4:\"type\";s:12:\"list_boolean\";}s:13:\"field_section\";a:2:{s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{i:0;s:7:\"article\";}}s:4:\"type\";s:23:\"taxonomy_term_reference\";}s:14:\"field_category\";a:2:{s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{i:0;s:7:\"article\";}}s:4:\"type\";s:23:\"taxonomy_term_reference\";}s:16:\"field_video_link\";a:2:{s:7:\"bundles\";a:2:{s:4:\"node\";a:1:{i:0;s:5:\"video\";}s:21:\"field_collection_item\";a:1:{i:0;s:19:\"field_extra_content\";}}s:4:\"type\";s:17:\"video_embed_field\";}s:10:\"field_link\";a:2:{s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{i:0;s:8:\"products\";}}s:4:\"type\";s:10:\"link_field\";}s:19:\"field_extra_content\";a:2:{s:7:\"bundles\";a:1:{s:4:\"node\";a:3:{i:0;s:4:\"blog\";i:1;s:7:\"article\";i:2;s:5:\"forum\";}}s:4:\"type\";s:16:\"field_collection\";}s:17:\"field_description\";a:2:{s:7:\"bundles\";a:1:{s:21:\"field_collection_item\";a:1:{i:0;s:19:\"field_extra_content\";}}s:4:\"type\";s:9:\"text_long\";}s:23:\"field_detailed_question\";a:2:{s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{i:0;s:3:\"faq\";}}s:4:\"type\";s:9:\"text_long\";}}',0,1512620340,1),('field_info:instances','a:11:{s:7:\"comment\";a:9:{s:17:\"comment_node_page\";a:1:{s:12:\"comment_body\";a:13:{s:5:\"label\";s:7:\"Comment\";s:8:\"settings\";a:2:{s:15:\"text_processing\";i:1;s:18:\"user_register_form\";b:0;}s:8:\"required\";b:1;s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";}}s:6:\"widget\";a:4:{s:4:\"type\";s:13:\"text_textarea\";s:8:\"settings\";a:1:{s:4:\"rows\";i:5;}s:6:\"weight\";i:0;s:6:\"module\";s:4:\"text\";}s:11:\"description\";s:0:\"\";s:2:\"id\";s:1:\"1\";s:8:\"field_id\";s:1:\"1\";s:10:\"field_name\";s:12:\"comment_body\";s:11:\"entity_type\";s:7:\"comment\";s:6:\"bundle\";s:17:\"comment_node_page\";s:7:\"deleted\";s:1:\"0\";s:13:\"default_value\";N;}}s:20:\"comment_node_article\";a:1:{s:12:\"comment_body\";a:13:{s:5:\"label\";s:7:\"Comment\";s:8:\"settings\";a:2:{s:15:\"text_processing\";i:1;s:18:\"user_register_form\";b:0;}s:8:\"required\";b:1;s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";}}s:6:\"widget\";a:4:{s:4:\"type\";s:13:\"text_textarea\";s:8:\"settings\";a:1:{s:4:\"rows\";i:5;}s:6:\"weight\";i:0;s:6:\"module\";s:4:\"text\";}s:11:\"description\";s:0:\"\";s:2:\"id\";s:1:\"3\";s:8:\"field_id\";s:1:\"1\";s:10:\"field_name\";s:12:\"comment_body\";s:11:\"entity_type\";s:7:\"comment\";s:6:\"bundle\";s:20:\"comment_node_article\";s:7:\"deleted\";s:1:\"0\";s:13:\"default_value\";N;}}s:17:\"comment_node_blog\";a:1:{s:12:\"comment_body\";a:13:{s:5:\"label\";s:7:\"Comment\";s:8:\"settings\";a:2:{s:15:\"text_processing\";i:1;s:18:\"user_register_form\";b:0;}s:8:\"required\";b:1;s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";}}s:6:\"widget\";a:4:{s:4:\"type\";s:13:\"text_textarea\";s:8:\"settings\";a:1:{s:4:\"rows\";i:5;}s:6:\"weight\";i:0;s:6:\"module\";s:4:\"text\";}s:11:\"description\";s:0:\"\";s:2:\"id\";s:1:\"7\";s:8:\"field_id\";s:1:\"1\";s:10:\"field_name\";s:12:\"comment_body\";s:11:\"entity_type\";s:7:\"comment\";s:6:\"bundle\";s:17:\"comment_node_blog\";s:7:\"deleted\";s:1:\"0\";s:13:\"default_value\";N;}}s:17:\"comment_node_book\";a:1:{s:12:\"comment_body\";a:13:{s:5:\"label\";s:7:\"Comment\";s:8:\"settings\";a:2:{s:15:\"text_processing\";i:1;s:18:\"user_register_form\";b:0;}s:8:\"required\";b:1;s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";}}s:6:\"widget\";a:4:{s:4:\"type\";s:13:\"text_textarea\";s:8:\"settings\";a:1:{s:4:\"rows\";i:5;}s:6:\"weight\";i:0;s:6:\"module\";s:4:\"text\";}s:11:\"description\";s:0:\"\";s:2:\"id\";s:1:\"9\";s:8:\"field_id\";s:1:\"1\";s:10:\"field_name\";s:12:\"comment_body\";s:11:\"entity_type\";s:7:\"comment\";s:6:\"bundle\";s:17:\"comment_node_book\";s:7:\"deleted\";s:1:\"0\";s:13:\"default_value\";N;}}s:18:\"comment_node_forum\";a:2:{s:12:\"comment_body\";a:13:{s:5:\"label\";s:7:\"Comment\";s:8:\"settings\";a:2:{s:15:\"text_processing\";i:1;s:18:\"user_register_form\";b:0;}s:8:\"required\";b:1;s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";s:1:\"0\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";}}s:6:\"widget\";a:4:{s:4:\"type\";s:13:\"text_textarea\";s:8:\"settings\";a:1:{s:4:\"rows\";i:5;}s:6:\"weight\";s:1:\"2\";s:6:\"module\";s:4:\"text\";}s:11:\"description\";s:0:\"\";s:2:\"id\";s:2:\"12\";s:8:\"field_id\";s:1:\"1\";s:10:\"field_name\";s:12:\"comment_body\";s:11:\"entity_type\";s:7:\"comment\";s:6:\"bundle\";s:18:\"comment_node_forum\";s:7:\"deleted\";s:1:\"0\";s:13:\"default_value\";N;}s:10:\"field_vote\";a:13:{s:5:\"label\";s:4:\"Vote\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"4\";s:4:\"type\";s:7:\"exposed\";s:6:\"module\";s:8:\"fivestar\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:6:\"widget\";a:1:{s:15:\"fivestar_widget\";s:7:\"default\";}}}s:8:\"settings\";a:6:{s:5:\"stars\";s:1:\"5\";s:11:\"allow_clear\";i:0;s:12:\"allow_revote\";i:0;s:13:\"allow_ownvote\";i:1;s:6:\"target\";s:4:\"none\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:26:\"fivestar_formatter_default\";s:6:\"weight\";s:1:\"2\";s:8:\"settings\";a:4:{s:6:\"widget\";a:1:{s:15:\"fivestar_widget\";s:50:\"sites/all/modules/fivestar/widgets/basic/basic.css\";}s:6:\"expose\";i:1;s:5:\"style\";s:5:\"smart\";s:4:\"text\";s:5:\"smart\";}s:6:\"module\";s:8:\"fivestar\";}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;s:2:\"id\";s:2:\"15\";s:8:\"field_id\";s:1:\"6\";s:10:\"field_name\";s:10:\"field_vote\";s:11:\"entity_type\";s:7:\"comment\";s:6:\"bundle\";s:18:\"comment_node_forum\";s:7:\"deleted\";s:1:\"0\";}}s:16:\"comment_node_faq\";a:1:{s:12:\"comment_body\";a:13:{s:5:\"label\";s:7:\"Comment\";s:8:\"settings\";a:2:{s:15:\"text_processing\";i:1;s:18:\"user_register_form\";b:0;}s:8:\"required\";b:1;s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";}}s:6:\"widget\";a:4:{s:4:\"type\";s:13:\"text_textarea\";s:8:\"settings\";a:1:{s:4:\"rows\";i:5;}s:6:\"weight\";i:0;s:6:\"module\";s:4:\"text\";}s:11:\"description\";s:0:\"\";s:2:\"id\";s:2:\"28\";s:8:\"field_id\";s:1:\"1\";s:10:\"field_name\";s:12:\"comment_body\";s:11:\"entity_type\";s:7:\"comment\";s:6:\"bundle\";s:16:\"comment_node_faq\";s:7:\"deleted\";s:1:\"0\";s:13:\"default_value\";N;}}s:18:\"comment_node_video\";a:1:{s:12:\"comment_body\";a:13:{s:5:\"label\";s:7:\"Comment\";s:8:\"settings\";a:2:{s:15:\"text_processing\";i:1;s:18:\"user_register_form\";b:0;}s:8:\"required\";b:1;s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";}}s:6:\"widget\";a:4:{s:4:\"type\";s:13:\"text_textarea\";s:8:\"settings\";a:1:{s:4:\"rows\";i:5;}s:6:\"weight\";i:0;s:6:\"module\";s:4:\"text\";}s:11:\"description\";s:0:\"\";s:2:\"id\";s:2:\"30\";s:8:\"field_id\";s:1:\"1\";s:10:\"field_name\";s:12:\"comment_body\";s:11:\"entity_type\";s:7:\"comment\";s:6:\"bundle\";s:18:\"comment_node_video\";s:7:\"deleted\";s:1:\"0\";s:13:\"default_value\";N;}}s:20:\"comment_node_webform\";a:1:{s:12:\"comment_body\";a:13:{s:5:\"label\";s:7:\"Comment\";s:8:\"settings\";a:2:{s:15:\"text_processing\";i:1;s:18:\"user_register_form\";b:0;}s:8:\"required\";b:1;s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";}}s:6:\"widget\";a:4:{s:4:\"type\";s:13:\"text_textarea\";s:8:\"settings\";a:1:{s:4:\"rows\";i:5;}s:6:\"weight\";i:0;s:6:\"module\";s:4:\"text\";}s:11:\"description\";s:0:\"\";s:2:\"id\";s:2:\"34\";s:8:\"field_id\";s:1:\"1\";s:10:\"field_name\";s:12:\"comment_body\";s:11:\"entity_type\";s:7:\"comment\";s:6:\"bundle\";s:20:\"comment_node_webform\";s:7:\"deleted\";s:1:\"0\";s:13:\"default_value\";N;}}s:21:\"comment_node_products\";a:1:{s:12:\"comment_body\";a:13:{s:5:\"label\";s:7:\"Comment\";s:8:\"settings\";a:2:{s:15:\"text_processing\";i:1;s:18:\"user_register_form\";b:0;}s:8:\"required\";b:1;s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";}}s:6:\"widget\";a:4:{s:4:\"type\";s:13:\"text_textarea\";s:8:\"settings\";a:1:{s:4:\"rows\";i:5;}s:6:\"weight\";i:0;s:6:\"module\";s:4:\"text\";}s:11:\"description\";s:0:\"\";s:2:\"id\";s:2:\"36\";s:8:\"field_id\";s:1:\"1\";s:10:\"field_name\";s:12:\"comment_body\";s:11:\"entity_type\";s:7:\"comment\";s:6:\"bundle\";s:21:\"comment_node_products\";s:7:\"deleted\";s:1:\"0\";s:13:\"default_value\";N;}}}s:4:\"node\";a:9:{s:4:\"page\";a:1:{s:4:\"body\";a:13:{s:5:\"label\";s:4:\"Body\";s:6:\"widget\";a:4:{s:4:\"type\";s:26:\"text_textarea_with_summary\";s:8:\"settings\";a:2:{s:4:\"rows\";i:20;s:12:\"summary_rows\";i:5;}s:6:\"weight\";i:-4;s:6:\"module\";s:4:\"text\";}s:8:\"settings\";a:3:{s:15:\"display_summary\";b:1;s:15:\"text_processing\";i:1;s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:0;}s:6:\"teaser\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:23:\"text_summary_or_trimmed\";s:8:\"settings\";a:1:{s:11:\"trim_length\";i:600;}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:0;}}s:8:\"required\";b:0;s:11:\"description\";s:0:\"\";s:2:\"id\";s:1:\"2\";s:8:\"field_id\";s:1:\"2\";s:10:\"field_name\";s:4:\"body\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:4:\"page\";s:7:\"deleted\";s:1:\"0\";s:13:\"default_value\";N;}}s:7:\"article\";a:6:{s:4:\"body\";a:13:{s:5:\"label\";s:4:\"Body\";s:6:\"widget\";a:4:{s:4:\"type\";s:26:\"text_textarea_with_summary\";s:8:\"settings\";a:2:{s:4:\"rows\";i:20;s:12:\"summary_rows\";i:5;}s:6:\"weight\";s:1:\"1\";s:6:\"module\";s:4:\"text\";}s:8:\"settings\";a:3:{s:15:\"display_summary\";b:1;s:15:\"text_processing\";i:1;s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";s:1:\"1\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";}s:6:\"teaser\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:23:\"text_summary_or_trimmed\";s:6:\"weight\";s:1:\"1\";s:8:\"settings\";a:1:{s:11:\"trim_length\";i:600;}s:6:\"module\";s:4:\"text\";}}s:8:\"required\";b:0;s:11:\"description\";s:0:\"\";s:2:\"id\";s:1:\"4\";s:8:\"field_id\";s:1:\"2\";s:10:\"field_name\";s:4:\"body\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:7:\"article\";s:7:\"deleted\";s:1:\"0\";s:13:\"default_value\";N;}s:10:\"field_tags\";a:13:{s:5:\"label\";s:4:\"Tags\";s:11:\"description\";s:63:\"Enter a comma-separated list of words to describe your content.\";s:6:\"widget\";a:4:{s:4:\"type\";s:21:\"taxonomy_autocomplete\";s:6:\"weight\";s:1:\"3\";s:8:\"settings\";a:2:{s:4:\"size\";i:60;s:17:\"autocomplete_path\";s:21:\"taxonomy/autocomplete\";}s:6:\"module\";s:8:\"taxonomy\";}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:28:\"taxonomy_term_reference_link\";s:6:\"weight\";s:1:\"3\";s:8:\"settings\";a:0:{}s:6:\"module\";s:8:\"taxonomy\";}s:6:\"teaser\";a:4:{s:5:\"label\";s:6:\"inline\";s:4:\"type\";s:6:\"hidden\";s:6:\"weight\";s:1:\"2\";s:8:\"settings\";a:0:{}}}s:8:\"settings\";a:1:{s:18:\"user_register_form\";b:0;}s:8:\"required\";b:0;s:2:\"id\";s:1:\"5\";s:8:\"field_id\";s:1:\"3\";s:10:\"field_name\";s:10:\"field_tags\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:7:\"article\";s:7:\"deleted\";s:1:\"0\";s:13:\"default_value\";N;}s:11:\"field_image\";a:12:{s:5:\"label\";s:5:\"Image\";s:11:\"description\";s:40:\"Upload an image to go with this article.\";s:8:\"required\";b:0;s:8:\"settings\";a:9:{s:14:\"file_directory\";s:11:\"field/image\";s:15:\"file_extensions\";s:16:\"png gif jpg jpeg\";s:12:\"max_filesize\";s:0:\"\";s:14:\"max_resolution\";s:0:\"\";s:14:\"min_resolution\";s:0:\"\";s:9:\"alt_field\";b:1;s:11:\"title_field\";s:0:\"\";s:13:\"default_image\";i:0;s:18:\"user_register_form\";b:0;}s:6:\"widget\";a:4:{s:4:\"type\";s:11:\"image_image\";s:8:\"settings\";a:2:{s:18:\"progress_indicator\";s:8:\"throbber\";s:19:\"preview_image_style\";s:9:\"thumbnail\";}s:6:\"weight\";s:1:\"2\";s:6:\"module\";s:5:\"image\";}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:5:\"image\";s:6:\"weight\";s:1:\"0\";s:8:\"settings\";a:2:{s:11:\"image_style\";s:0:\"\";s:10:\"image_link\";s:0:\"\";}s:6:\"module\";s:5:\"image\";}s:6:\"teaser\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:5:\"image\";s:6:\"weight\";s:1:\"0\";s:8:\"settings\";a:2:{s:11:\"image_style\";s:5:\"large\";s:10:\"image_link\";s:7:\"content\";}s:6:\"module\";s:5:\"image\";}}s:2:\"id\";s:1:\"6\";s:8:\"field_id\";s:1:\"4\";s:10:\"field_name\";s:11:\"field_image\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:7:\"article\";s:7:\"deleted\";s:1:\"0\";}s:13:\"field_section\";a:13:{s:5:\"label\";s:7:\"Section\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"5\";s:4:\"type\";s:14:\"options_select\";s:6:\"module\";s:7:\"options\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:12:\"apply_chosen\";s:0:\"\";}}s:8:\"settings\";a:1:{s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:4:{s:5:\"label\";s:6:\"inline\";s:4:\"type\";s:6:\"hidden\";s:6:\"weight\";s:1:\"4\";s:8:\"settings\";a:0:{}}s:6:\"teaser\";a:4:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:6:\"hidden\";s:6:\"weight\";s:1:\"4\";s:8:\"settings\";a:0:{}}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;s:2:\"id\";s:2:\"26\";s:8:\"field_id\";s:2:\"11\";s:10:\"field_name\";s:13:\"field_section\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:7:\"article\";s:7:\"deleted\";s:1:\"0\";}s:14:\"field_category\";a:13:{s:5:\"label\";s:8:\"Category\";s:6:\"widget\";a:4:{s:4:\"type\";s:14:\"options_select\";s:6:\"weight\";s:1:\"6\";s:8:\"settings\";a:3:{s:4:\"size\";i:60;s:17:\"autocomplete_path\";s:21:\"taxonomy/autocomplete\";s:12:\"apply_chosen\";s:0:\"\";}s:6:\"module\";s:7:\"options\";}s:8:\"settings\";a:1:{s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:4:{s:5:\"label\";s:6:\"inline\";s:4:\"type\";s:6:\"hidden\";s:6:\"weight\";s:1:\"5\";s:8:\"settings\";a:0:{}}s:6:\"teaser\";a:4:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:6:\"hidden\";s:6:\"weight\";s:1:\"3\";s:8:\"settings\";a:0:{}}}s:8:\"required\";b:0;s:11:\"description\";s:0:\"\";s:2:\"id\";s:2:\"27\";s:8:\"field_id\";s:2:\"12\";s:10:\"field_name\";s:14:\"field_category\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:7:\"article\";s:7:\"deleted\";s:1:\"0\";s:13:\"default_value\";N;}s:19:\"field_extra_content\";a:13:{s:5:\"label\";s:13:\"Extra content\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"8\";s:4:\"type\";s:22:\"field_collection_embed\";s:6:\"module\";s:16:\"field_collection\";s:6:\"active\";i:0;s:8:\"settings\";a:0:{}}s:8:\"settings\";a:1:{s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:21:\"field_collection_view\";s:6:\"weight\";s:1:\"2\";s:8:\"settings\";a:5:{s:4:\"edit\";s:4:\"Edit\";s:6:\"delete\";s:6:\"Delete\";s:3:\"add\";s:3:\"Add\";s:11:\"description\";b:1;s:9:\"view_mode\";s:4:\"full\";}s:6:\"module\";s:16:\"field_collection\";}s:6:\"teaser\";a:4:{s:4:\"type\";s:6:\"hidden\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"weight\";i:0;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;s:2:\"id\";s:2:\"46\";s:8:\"field_id\";s:2:\"16\";s:10:\"field_name\";s:19:\"field_extra_content\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:7:\"article\";s:7:\"deleted\";s:1:\"0\";}}s:4:\"blog\";a:5:{s:4:\"body\";a:13:{s:5:\"label\";s:4:\"Body\";s:6:\"widget\";a:4:{s:4:\"type\";s:26:\"text_textarea_with_summary\";s:8:\"settings\";a:2:{s:4:\"rows\";i:20;s:12:\"summary_rows\";i:5;}s:6:\"weight\";s:1:\"1\";s:6:\"module\";s:4:\"text\";}s:8:\"settings\";a:3:{s:15:\"display_summary\";b:1;s:15:\"text_processing\";i:1;s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";s:1:\"1\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";}s:6:\"teaser\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:23:\"text_summary_or_trimmed\";s:6:\"weight\";s:1:\"2\";s:8:\"settings\";a:1:{s:11:\"trim_length\";s:3:\"500\";}s:6:\"module\";s:4:\"text\";}}s:8:\"required\";b:0;s:11:\"description\";s:0:\"\";s:2:\"id\";s:1:\"8\";s:8:\"field_id\";s:1:\"2\";s:10:\"field_name\";s:4:\"body\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:4:\"blog\";s:7:\"deleted\";s:1:\"0\";s:13:\"default_value\";N;}s:11:\"field_image\";a:12:{s:5:\"label\";s:5:\"Image\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"2\";s:4:\"type\";s:11:\"image_image\";s:6:\"module\";s:5:\"image\";s:6:\"active\";i:1;s:8:\"settings\";a:2:{s:18:\"progress_indicator\";s:8:\"throbber\";s:19:\"preview_image_style\";s:9:\"thumbnail\";}}s:8:\"settings\";a:9:{s:14:\"file_directory\";s:10:\"field/blog\";s:15:\"file_extensions\";s:16:\"png gif jpg jpeg\";s:12:\"max_filesize\";s:0:\"\";s:14:\"max_resolution\";s:0:\"\";s:14:\"min_resolution\";s:0:\"\";s:9:\"alt_field\";i:0;s:11:\"title_field\";i:0;s:13:\"default_image\";i:0;s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:5:\"image\";s:6:\"weight\";s:1:\"0\";s:8:\"settings\";a:2:{s:11:\"image_style\";s:5:\"large\";s:10:\"image_link\";s:0:\"\";}s:6:\"module\";s:5:\"image\";}s:6:\"teaser\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:5:\"image\";s:6:\"weight\";s:1:\"0\";s:8:\"settings\";a:2:{s:11:\"image_style\";s:5:\"large\";s:10:\"image_link\";s:7:\"content\";}s:6:\"module\";s:5:\"image\";}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:2:\"id\";s:2:\"23\";s:8:\"field_id\";s:1:\"4\";s:10:\"field_name\";s:11:\"field_image\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:4:\"blog\";s:7:\"deleted\";s:1:\"0\";}s:10:\"field_tags\";a:13:{s:5:\"label\";s:4:\"Tags\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"3\";s:4:\"type\";s:21:\"taxonomy_autocomplete\";s:6:\"module\";s:8:\"taxonomy\";s:6:\"active\";i:0;s:8:\"settings\";a:2:{s:4:\"size\";i:60;s:17:\"autocomplete_path\";s:21:\"taxonomy/autocomplete\";}}s:8:\"settings\";a:1:{s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:28:\"taxonomy_term_reference_link\";s:6:\"weight\";s:1:\"3\";s:8:\"settings\";a:0:{}s:6:\"module\";s:8:\"taxonomy\";}s:6:\"teaser\";a:4:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:6:\"hidden\";s:6:\"weight\";s:1:\"5\";s:8:\"settings\";a:0:{}}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;s:2:\"id\";s:2:\"24\";s:8:\"field_id\";s:1:\"3\";s:10:\"field_name\";s:10:\"field_tags\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:4:\"blog\";s:7:\"deleted\";s:1:\"0\";}s:10:\"field_vote\";a:13:{s:5:\"label\";s:4:\"Vote\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"4\";s:4:\"type\";s:7:\"exposed\";s:6:\"module\";s:8:\"fivestar\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:6:\"widget\";a:1:{s:15:\"fivestar_widget\";s:7:\"default\";}}}s:8:\"settings\";a:6:{s:5:\"stars\";s:1:\"5\";s:11:\"allow_clear\";i:0;s:12:\"allow_revote\";i:0;s:13:\"allow_ownvote\";i:1;s:6:\"target\";s:4:\"none\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:26:\"fivestar_formatter_default\";s:6:\"weight\";s:1:\"4\";s:8:\"settings\";a:4:{s:6:\"widget\";a:1:{s:15:\"fivestar_widget\";s:50:\"sites/all/modules/fivestar/widgets/basic/basic.css\";}s:6:\"expose\";i:1;s:5:\"style\";s:7:\"average\";s:4:\"text\";s:7:\"average\";}s:6:\"module\";s:8:\"fivestar\";}s:6:\"teaser\";a:4:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:6:\"hidden\";s:6:\"weight\";s:1:\"4\";s:8:\"settings\";a:0:{}}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;s:2:\"id\";s:2:\"25\";s:8:\"field_id\";s:1:\"6\";s:10:\"field_name\";s:10:\"field_vote\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:4:\"blog\";s:7:\"deleted\";s:1:\"0\";}s:19:\"field_extra_content\";a:13:{s:5:\"label\";s:13:\"Extra content\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"6\";s:4:\"type\";s:22:\"field_collection_embed\";s:6:\"module\";s:16:\"field_collection\";s:6:\"active\";i:0;s:8:\"settings\";a:0:{}}s:8:\"settings\";a:1:{s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:21:\"field_collection_view\";s:6:\"weight\";s:1:\"2\";s:8:\"settings\";a:5:{s:4:\"edit\";s:4:\"Edit\";s:6:\"delete\";s:6:\"Delete\";s:3:\"add\";s:3:\"Add\";s:11:\"description\";b:1;s:9:\"view_mode\";s:4:\"full\";}s:6:\"module\";s:16:\"field_collection\";}s:6:\"teaser\";a:4:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:6:\"hidden\";s:6:\"weight\";s:1:\"3\";s:8:\"settings\";a:0:{}}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;s:2:\"id\";s:2:\"43\";s:8:\"field_id\";s:2:\"16\";s:10:\"field_name\";s:19:\"field_extra_content\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:4:\"blog\";s:7:\"deleted\";s:1:\"0\";}}s:4:\"book\";a:1:{s:4:\"body\";a:13:{s:5:\"label\";s:4:\"Body\";s:6:\"widget\";a:4:{s:4:\"type\";s:26:\"text_textarea_with_summary\";s:8:\"settings\";a:2:{s:4:\"rows\";i:20;s:12:\"summary_rows\";i:5;}s:6:\"weight\";i:-4;s:6:\"module\";s:4:\"text\";}s:8:\"settings\";a:3:{s:15:\"display_summary\";b:1;s:15:\"text_processing\";i:1;s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:0;}s:6:\"teaser\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:23:\"text_summary_or_trimmed\";s:8:\"settings\";a:1:{s:11:\"trim_length\";i:600;}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:0;}}s:8:\"required\";b:0;s:11:\"description\";s:0:\"\";s:2:\"id\";s:2:\"10\";s:8:\"field_id\";s:1:\"2\";s:10:\"field_name\";s:4:\"body\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:4:\"book\";s:7:\"deleted\";s:1:\"0\";s:13:\"default_value\";N;}}s:5:\"forum\";a:4:{s:15:\"taxonomy_forums\";a:13:{s:5:\"label\";s:6:\"Forums\";s:8:\"required\";b:1;s:6:\"widget\";a:4:{s:4:\"type\";s:14:\"options_select\";s:8:\"settings\";a:1:{s:12:\"apply_chosen\";s:0:\"\";}s:6:\"weight\";s:1:\"1\";s:6:\"module\";s:7:\"options\";}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:28:\"taxonomy_term_reference_link\";s:6:\"weight\";s:1:\"0\";s:8:\"settings\";a:0:{}s:6:\"module\";s:8:\"taxonomy\";}s:6:\"teaser\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:28:\"taxonomy_term_reference_link\";s:6:\"weight\";s:2:\"10\";s:8:\"settings\";a:0:{}s:6:\"module\";s:8:\"taxonomy\";}}s:8:\"settings\";a:1:{s:18:\"user_register_form\";b:0;}s:11:\"description\";s:0:\"\";s:2:\"id\";s:2:\"11\";s:8:\"field_id\";s:1:\"5\";s:10:\"field_name\";s:15:\"taxonomy_forums\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:5:\"forum\";s:7:\"deleted\";s:1:\"0\";s:13:\"default_value\";N;}s:4:\"body\";a:13:{s:5:\"label\";s:4:\"Body\";s:6:\"widget\";a:4:{s:4:\"type\";s:26:\"text_textarea_with_summary\";s:8:\"settings\";a:2:{s:4:\"rows\";i:20;s:12:\"summary_rows\";i:5;}s:6:\"weight\";s:1:\"2\";s:6:\"module\";s:4:\"text\";}s:8:\"settings\";a:3:{s:15:\"display_summary\";b:1;s:15:\"text_processing\";i:1;s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";s:1:\"1\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";}s:6:\"teaser\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:23:\"text_summary_or_trimmed\";s:6:\"weight\";s:2:\"11\";s:8:\"settings\";a:1:{s:11:\"trim_length\";i:600;}s:6:\"module\";s:4:\"text\";}}s:8:\"required\";b:0;s:11:\"description\";s:0:\"\";s:2:\"id\";s:2:\"13\";s:8:\"field_id\";s:1:\"2\";s:10:\"field_name\";s:4:\"body\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:5:\"forum\";s:7:\"deleted\";s:1:\"0\";s:13:\"default_value\";N;}s:10:\"field_vote\";a:13:{s:5:\"label\";s:4:\"Vote\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"4\";s:4:\"type\";s:7:\"exposed\";s:6:\"module\";s:8:\"fivestar\";s:6:\"active\";i:1;s:8:\"settings\";a:0:{}}s:8:\"settings\";a:6:{s:5:\"stars\";s:1:\"5\";s:11:\"allow_clear\";i:0;s:12:\"allow_revote\";i:0;s:13:\"allow_ownvote\";i:1;s:6:\"target\";s:4:\"none\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:26:\"fivestar_formatter_default\";s:6:\"weight\";s:1:\"3\";s:8:\"settings\";a:4:{s:6:\"widget\";a:1:{s:15:\"fivestar_widget\";s:50:\"sites/all/modules/fivestar/widgets/basic/basic.css\";}s:6:\"expose\";i:1;s:5:\"style\";s:5:\"smart\";s:4:\"text\";s:4:\"dual\";}s:6:\"module\";s:8:\"fivestar\";}s:6:\"teaser\";a:4:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:6:\"hidden\";s:6:\"weight\";s:1:\"0\";s:8:\"settings\";a:0:{}}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;s:2:\"id\";s:2:\"14\";s:8:\"field_id\";s:1:\"6\";s:10:\"field_name\";s:10:\"field_vote\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:5:\"forum\";s:7:\"deleted\";s:1:\"0\";}s:19:\"field_extra_content\";a:13:{s:5:\"label\";s:13:\"Extra content\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"3\";s:4:\"type\";s:22:\"field_collection_embed\";s:6:\"module\";s:16:\"field_collection\";s:6:\"active\";i:0;s:8:\"settings\";a:0:{}}s:8:\"settings\";a:1:{s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:21:\"field_collection_view\";s:6:\"weight\";s:1:\"2\";s:8:\"settings\";a:5:{s:4:\"edit\";s:4:\"Edit\";s:6:\"delete\";s:6:\"Delete\";s:3:\"add\";s:3:\"Add\";s:11:\"description\";b:1;s:9:\"view_mode\";s:4:\"full\";}s:6:\"module\";s:16:\"field_collection\";}s:6:\"teaser\";a:4:{s:4:\"type\";s:6:\"hidden\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"weight\";i:0;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;s:2:\"id\";s:2:\"47\";s:8:\"field_id\";s:2:\"16\";s:10:\"field_name\";s:19:\"field_extra_content\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:5:\"forum\";s:7:\"deleted\";s:1:\"0\";}}s:3:\"faq\";a:2:{s:4:\"body\";a:13:{s:5:\"label\";s:4:\"Body\";s:6:\"widget\";a:4:{s:4:\"type\";s:26:\"text_textarea_with_summary\";s:8:\"settings\";a:2:{s:4:\"rows\";i:20;s:12:\"summary_rows\";i:5;}s:6:\"weight\";i:32;s:6:\"module\";s:4:\"text\";}s:8:\"settings\";a:3:{s:15:\"display_summary\";b:1;s:15:\"text_processing\";i:1;s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:1;}s:6:\"teaser\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:23:\"text_summary_or_trimmed\";s:8:\"settings\";a:1:{s:11:\"trim_length\";i:600;}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:1;}}s:8:\"required\";b:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;s:2:\"id\";s:2:\"29\";s:8:\"field_id\";s:1:\"2\";s:10:\"field_name\";s:4:\"body\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:3:\"faq\";s:7:\"deleted\";s:1:\"0\";}s:23:\"field_detailed_question\";a:13:{s:5:\"label\";s:17:\"Detailed question\";s:6:\"widget\";a:5:{s:6:\"weight\";i:31;s:4:\"type\";s:13:\"text_textarea\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"rows\";s:1:\"5\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"1\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";}s:6:\"teaser\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";}}s:8:\"required\";i:0;s:11:\"description\";s:32:\"Enter the detailed question text\";s:13:\"default_value\";N;s:2:\"id\";s:2:\"49\";s:8:\"field_id\";s:2:\"18\";s:10:\"field_name\";s:23:\"field_detailed_question\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:3:\"faq\";s:7:\"deleted\";s:1:\"0\";}}s:5:\"video\";a:3:{s:4:\"body\";a:13:{s:5:\"label\";s:4:\"Body\";s:6:\"widget\";a:4:{s:4:\"type\";s:26:\"text_textarea_with_summary\";s:8:\"settings\";a:2:{s:4:\"rows\";i:20;s:12:\"summary_rows\";i:5;}s:6:\"weight\";s:1:\"2\";s:6:\"module\";s:4:\"text\";}s:8:\"settings\";a:3:{s:15:\"display_summary\";b:1;s:15:\"text_processing\";i:1;s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";s:1:\"1\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";}s:6:\"teaser\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:23:\"text_summary_or_trimmed\";s:6:\"weight\";s:1:\"1\";s:8:\"settings\";a:1:{s:11:\"trim_length\";i:600;}s:6:\"module\";s:4:\"text\";}}s:8:\"required\";b:0;s:11:\"description\";s:0:\"\";s:2:\"id\";s:2:\"31\";s:8:\"field_id\";s:1:\"2\";s:10:\"field_name\";s:4:\"body\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:5:\"video\";s:7:\"deleted\";s:1:\"0\";s:13:\"default_value\";N;}s:10:\"field_tags\";a:13:{s:5:\"label\";s:4:\"Tags\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"4\";s:4:\"type\";s:21:\"taxonomy_autocomplete\";s:6:\"module\";s:8:\"taxonomy\";s:6:\"active\";i:0;s:8:\"settings\";a:2:{s:4:\"size\";i:60;s:17:\"autocomplete_path\";s:21:\"taxonomy/autocomplete\";}}s:8:\"settings\";a:1:{s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"inline\";s:4:\"type\";s:33:\"i18n_taxonomy_term_reference_link\";s:6:\"weight\";s:1:\"2\";s:8:\"settings\";a:0:{}s:6:\"module\";s:13:\"i18n_taxonomy\";}s:6:\"teaser\";a:4:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:6:\"hidden\";s:6:\"weight\";s:1:\"2\";s:8:\"settings\";a:0:{}}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;s:2:\"id\";s:2:\"32\";s:8:\"field_id\";s:1:\"3\";s:10:\"field_name\";s:10:\"field_tags\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:5:\"video\";s:7:\"deleted\";s:1:\"0\";}s:16:\"field_video_link\";a:13:{s:5:\"label\";s:10:\"Video Link\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"3\";s:4:\"type\";s:23:\"video_embed_field_video\";s:6:\"module\";s:17:\"video_embed_field\";s:6:\"active\";i:0;s:8:\"settings\";a:0:{}}s:8:\"settings\";a:4:{s:17:\"description_field\";i:0;s:18:\"description_length\";s:3:\"128\";s:18:\"user_register_form\";b:0;s:17:\"allowed_providers\";a:2:{i:0;s:7:\"youtube\";i:1;s:5:\"vimeo\";}}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:17:\"video_embed_field\";s:6:\"weight\";s:1:\"0\";s:8:\"settings\";a:3:{s:11:\"video_style\";s:5:\"large\";s:11:\"description\";i:1;s:20:\"description_position\";s:6:\"bottom\";}s:6:\"module\";s:17:\"video_embed_field\";}s:6:\"teaser\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:17:\"video_embed_field\";s:6:\"weight\";s:1:\"0\";s:8:\"settings\";a:3:{s:11:\"video_style\";s:5:\"large\";s:11:\"description\";i:1;s:20:\"description_position\";s:6:\"bottom\";}s:6:\"module\";s:17:\"video_embed_field\";}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;s:2:\"id\";s:2:\"33\";s:8:\"field_id\";s:2:\"13\";s:10:\"field_name\";s:16:\"field_video_link\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:5:\"video\";s:7:\"deleted\";s:1:\"0\";}}s:7:\"webform\";a:1:{s:4:\"body\";a:13:{s:5:\"label\";s:4:\"Body\";s:6:\"widget\";a:4:{s:4:\"type\";s:26:\"text_textarea_with_summary\";s:8:\"settings\";a:2:{s:4:\"rows\";i:20;s:12:\"summary_rows\";i:5;}s:6:\"weight\";i:31;s:6:\"module\";s:4:\"text\";}s:8:\"settings\";a:3:{s:15:\"display_summary\";b:1;s:15:\"text_processing\";i:1;s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";s:1:\"1\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";}s:6:\"teaser\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:23:\"text_summary_or_trimmed\";s:8:\"settings\";a:1:{s:11:\"trim_length\";i:600;}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:0;}}s:8:\"required\";b:0;s:11:\"description\";s:0:\"\";s:2:\"id\";s:2:\"35\";s:8:\"field_id\";s:1:\"2\";s:10:\"field_name\";s:4:\"body\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:7:\"webform\";s:7:\"deleted\";s:1:\"0\";s:13:\"default_value\";N;}}s:8:\"products\";a:3:{s:4:\"body\";a:13:{s:5:\"label\";s:4:\"Body\";s:6:\"widget\";a:4:{s:4:\"type\";s:26:\"text_textarea_with_summary\";s:8:\"settings\";a:2:{s:4:\"rows\";i:20;s:12:\"summary_rows\";i:5;}s:6:\"weight\";s:2:\"31\";s:6:\"module\";s:4:\"text\";}s:8:\"settings\";a:3:{s:15:\"display_summary\";b:1;s:15:\"text_processing\";i:1;s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:0;}s:6:\"teaser\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:23:\"text_summary_or_trimmed\";s:8:\"settings\";a:1:{s:11:\"trim_length\";i:600;}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:0;}}s:8:\"required\";b:0;s:11:\"description\";s:0:\"\";s:2:\"id\";s:2:\"37\";s:8:\"field_id\";s:1:\"2\";s:10:\"field_name\";s:4:\"body\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:8:\"products\";s:7:\"deleted\";s:1:\"0\";s:13:\"default_value\";N;}s:11:\"field_image\";a:12:{s:5:\"label\";s:5:\"Image\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"33\";s:4:\"type\";s:11:\"image_image\";s:6:\"module\";s:5:\"image\";s:6:\"active\";i:1;s:8:\"settings\";a:2:{s:18:\"progress_indicator\";s:8:\"throbber\";s:19:\"preview_image_style\";s:9:\"thumbnail\";}}s:8:\"settings\";a:9:{s:14:\"file_directory\";s:13:\"field/product\";s:15:\"file_extensions\";s:16:\"png gif jpg jpeg\";s:12:\"max_filesize\";s:0:\"\";s:14:\"max_resolution\";s:0:\"\";s:14:\"min_resolution\";s:0:\"\";s:9:\"alt_field\";i:0;s:11:\"title_field\";i:0;s:13:\"default_image\";i:0;s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:5:\"image\";s:8:\"settings\";a:2:{s:11:\"image_style\";s:0:\"\";s:10:\"image_link\";s:0:\"\";}s:6:\"module\";s:5:\"image\";s:6:\"weight\";i:1;}s:6:\"teaser\";a:4:{s:4:\"type\";s:6:\"hidden\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"weight\";i:0;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:2:\"id\";s:2:\"38\";s:8:\"field_id\";s:1:\"4\";s:10:\"field_name\";s:11:\"field_image\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:8:\"products\";s:7:\"deleted\";s:1:\"0\";}s:10:\"field_link\";a:13:{s:5:\"label\";s:4:\"Link\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"34\";s:4:\"type\";s:10:\"link_field\";s:6:\"module\";s:4:\"link\";s:6:\"active\";i:0;s:8:\"settings\";a:0:{}}s:8:\"settings\";a:12:{s:12:\"validate_url\";i:1;s:3:\"url\";i:0;s:5:\"title\";s:8:\"optional\";s:11:\"title_value\";s:0:\"\";s:15:\"title_maxlength\";s:3:\"128\";s:13:\"enable_tokens\";i:1;s:7:\"display\";a:1:{s:10:\"url_cutoff\";s:2:\"80\";}s:10:\"attributes\";a:5:{s:6:\"target\";s:7:\"default\";s:3:\"rel\";s:0:\"\";s:5:\"class\";s:0:\"\";s:18:\"configurable_title\";i:0;s:5:\"title\";s:0:\"\";}s:10:\"rel_remove\";s:7:\"default\";s:18:\"user_register_form\";b:0;s:27:\"title_label_use_field_label\";b:0;s:12:\"absolute_url\";i:1;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"link_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"link\";s:6:\"weight\";i:2;}s:6:\"teaser\";a:4:{s:4:\"type\";s:6:\"hidden\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"weight\";i:0;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;s:2:\"id\";s:2:\"39\";s:8:\"field_id\";s:2:\"14\";s:10:\"field_name\";s:10:\"field_link\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:8:\"products\";s:7:\"deleted\";s:1:\"0\";}}}s:21:\"field_collection_item\";a:1:{s:19:\"field_extra_content\";a:3:{s:11:\"field_image\";a:12:{s:5:\"label\";s:5:\"Image\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"0\";s:4:\"type\";s:11:\"image_image\";s:6:\"module\";s:5:\"image\";s:6:\"active\";i:1;s:8:\"settings\";a:2:{s:18:\"progress_indicator\";s:8:\"throbber\";s:19:\"preview_image_style\";s:9:\"thumbnail\";}}s:8:\"settings\";a:9:{s:14:\"file_directory\";s:16:\"field/collection\";s:15:\"file_extensions\";s:16:\"png gif jpg jpeg\";s:12:\"max_filesize\";s:0:\"\";s:14:\"max_resolution\";s:0:\"\";s:14:\"min_resolution\";s:0:\"\";s:9:\"alt_field\";i:0;s:11:\"title_field\";i:0;s:13:\"default_image\";i:0;s:18:\"user_register_form\";b:0;}s:7:\"display\";a:3:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:5:\"image\";s:6:\"weight\";s:1:\"0\";s:8:\"settings\";a:2:{s:11:\"image_style\";s:0:\"\";s:10:\"image_link\";s:0:\"\";}s:6:\"module\";s:5:\"image\";}s:4:\"full\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:5:\"image\";s:6:\"weight\";s:1:\"0\";s:8:\"settings\";a:2:{s:11:\"image_style\";s:0:\"\";s:10:\"image_link\";s:0:\"\";}s:6:\"module\";s:5:\"image\";}s:5:\"token\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:5:\"image\";s:6:\"weight\";s:1:\"0\";s:8:\"settings\";a:2:{s:11:\"image_style\";s:0:\"\";s:10:\"image_link\";s:0:\"\";}s:6:\"module\";s:5:\"image\";}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:2:\"id\";s:2:\"44\";s:8:\"field_id\";s:1:\"4\";s:10:\"field_name\";s:11:\"field_image\";s:11:\"entity_type\";s:21:\"field_collection_item\";s:6:\"bundle\";s:19:\"field_extra_content\";s:7:\"deleted\";s:1:\"0\";}s:17:\"field_description\";a:13:{s:5:\"label\";s:11:\"Description\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"2\";s:4:\"type\";s:13:\"text_textarea\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"rows\";s:1:\"5\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:3:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";s:1:\"2\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";}s:4:\"full\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";s:1:\"2\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";}s:5:\"token\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";s:1:\"2\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;s:2:\"id\";s:2:\"45\";s:8:\"field_id\";s:2:\"17\";s:10:\"field_name\";s:17:\"field_description\";s:11:\"entity_type\";s:21:\"field_collection_item\";s:6:\"bundle\";s:19:\"field_extra_content\";s:7:\"deleted\";s:1:\"0\";}s:16:\"field_video_link\";a:13:{s:5:\"label\";s:10:\"Video Link\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"1\";s:4:\"type\";s:23:\"video_embed_field_video\";s:6:\"module\";s:17:\"video_embed_field\";s:6:\"active\";i:0;s:8:\"settings\";a:0:{}}s:8:\"settings\";a:4:{s:17:\"description_field\";i:0;s:18:\"description_length\";s:3:\"128\";s:18:\"user_register_form\";b:0;s:17:\"allowed_providers\";a:2:{i:0;s:7:\"youtube\";i:1;s:5:\"vimeo\";}}s:7:\"display\";a:3:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:17:\"video_embed_field\";s:6:\"weight\";s:1:\"1\";s:8:\"settings\";a:3:{s:11:\"video_style\";s:5:\"large\";s:11:\"description\";i:1;s:20:\"description_position\";s:6:\"bottom\";}s:6:\"module\";s:17:\"video_embed_field\";}s:4:\"full\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:17:\"video_embed_field\";s:6:\"weight\";s:1:\"1\";s:8:\"settings\";a:3:{s:11:\"video_style\";s:5:\"large\";s:11:\"description\";i:1;s:20:\"description_position\";s:6:\"bottom\";}s:6:\"module\";s:17:\"video_embed_field\";}s:5:\"token\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:17:\"video_embed_field\";s:6:\"weight\";s:1:\"1\";s:8:\"settings\";a:3:{s:11:\"video_style\";s:5:\"large\";s:11:\"description\";i:1;s:20:\"description_position\";s:6:\"bottom\";}s:6:\"module\";s:17:\"video_embed_field\";}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;s:2:\"id\";s:2:\"48\";s:8:\"field_id\";s:2:\"13\";s:10:\"field_name\";s:16:\"field_video_link\";s:11:\"entity_type\";s:21:\"field_collection_item\";s:6:\"bundle\";s:19:\"field_extra_content\";s:7:\"deleted\";s:1:\"0\";}}}s:12:\"message_type\";a:1:{s:12:\"message_type\";a:1:{s:12:\"message_text\";a:13:{s:5:\"label\";s:12:\"Message text\";s:11:\"description\";s:46:\"This is the text of all messages of this type.\";s:8:\"required\";b:1;s:8:\"settings\";a:2:{s:15:\"text_processing\";i:1;s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:0;}}s:6:\"widget\";a:4:{s:4:\"type\";s:13:\"text_textarea\";s:8:\"settings\";a:1:{s:4:\"rows\";i:5;}s:6:\"weight\";i:0;s:6:\"module\";s:4:\"text\";}s:2:\"id\";s:2:\"16\";s:8:\"field_id\";s:1:\"7\";s:10:\"field_name\";s:12:\"message_text\";s:11:\"entity_type\";s:12:\"message_type\";s:6:\"bundle\";s:12:\"message_type\";s:7:\"deleted\";s:1:\"0\";s:13:\"default_value\";N;}}}s:7:\"message\";a:3:{s:22:\"example_create_comment\";a:3:{s:17:\"field_comment_ref\";a:14:{s:13:\"default_value\";N;s:22:\"default_value_function\";s:0:\"\";s:11:\"description\";s:0:\"\";s:7:\"display\";a:2:{s:7:\"default\";a:4:{s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:4:\"type\";s:6:\"hidden\";s:6:\"weight\";s:1:\"4\";}s:4:\"full\";a:4:{s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:4:\"type\";s:6:\"hidden\";s:6:\"weight\";s:1:\"2\";}}s:5:\"label\";s:17:\"Comment reference\";s:8:\"required\";i:1;s:8:\"settings\";a:2:{s:9:\"behaviors\";a:1:{s:11:\"prepopulate\";a:4:{s:6:\"action\";s:4:\"hide\";s:8:\"fallback\";s:4:\"none\";s:9:\"skip_perm\";s:26:\"access administration menu\";s:6:\"status\";i:0;}}s:18:\"user_register_form\";b:0;}s:6:\"widget\";a:5:{s:6:\"active\";i:1;s:6:\"module\";s:15:\"entityreference\";s:8:\"settings\";a:3:{s:14:\"match_operator\";s:8:\"CONTAINS\";s:4:\"path\";s:0:\"\";s:4:\"size\";s:2:\"60\";}s:4:\"type\";s:28:\"entityreference_autocomplete\";s:6:\"weight\";s:1:\"1\";}s:2:\"id\";s:2:\"17\";s:8:\"field_id\";s:1:\"8\";s:10:\"field_name\";s:17:\"field_comment_ref\";s:11:\"entity_type\";s:7:\"message\";s:6:\"bundle\";s:22:\"example_create_comment\";s:7:\"deleted\";s:1:\"0\";}s:14:\"field_node_ref\";a:14:{s:13:\"default_value\";N;s:22:\"default_value_function\";s:0:\"\";s:11:\"description\";s:0:\"\";s:7:\"display\";a:2:{s:7:\"default\";a:4:{s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:4:\"type\";s:6:\"hidden\";s:6:\"weight\";s:1:\"3\";}s:4:\"full\";a:4:{s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:4:\"type\";s:6:\"hidden\";s:6:\"weight\";s:1:\"3\";}}s:5:\"label\";s:14:\"Node reference\";s:8:\"required\";i:1;s:8:\"settings\";a:2:{s:9:\"behaviors\";a:1:{s:11:\"prepopulate\";a:4:{s:6:\"action\";s:4:\"hide\";s:8:\"fallback\";s:4:\"none\";s:9:\"skip_perm\";s:26:\"access administration menu\";s:6:\"status\";i:0;}}s:18:\"user_register_form\";b:0;}s:6:\"widget\";a:5:{s:6:\"active\";i:1;s:6:\"module\";s:15:\"entityreference\";s:8:\"settings\";a:3:{s:14:\"match_operator\";s:8:\"CONTAINS\";s:4:\"path\";s:0:\"\";s:4:\"size\";s:2:\"60\";}s:4:\"type\";s:28:\"entityreference_autocomplete\";s:6:\"weight\";i:0;}s:2:\"id\";s:2:\"18\";s:8:\"field_id\";s:1:\"9\";s:10:\"field_name\";s:14:\"field_node_ref\";s:11:\"entity_type\";s:7:\"message\";s:6:\"bundle\";s:22:\"example_create_comment\";s:7:\"deleted\";s:1:\"0\";}s:15:\"field_published\";a:13:{s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";i:0;}}s:11:\"description\";s:0:\"\";s:7:\"display\";a:2:{s:7:\"default\";a:4:{s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:4:\"type\";s:6:\"hidden\";s:6:\"weight\";s:1:\"5\";}s:4:\"full\";a:4:{s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:4:\"type\";s:6:\"hidden\";s:6:\"weight\";s:1:\"4\";}}s:5:\"label\";s:9:\"Published\";s:8:\"required\";i:0;s:8:\"settings\";a:1:{s:18:\"user_register_form\";b:0;}s:6:\"widget\";a:5:{s:6:\"active\";i:1;s:6:\"module\";s:7:\"options\";s:8:\"settings\";a:1:{s:13:\"display_label\";i:0;}s:4:\"type\";s:13:\"options_onoff\";s:6:\"weight\";s:1:\"2\";}s:2:\"id\";s:2:\"19\";s:8:\"field_id\";s:2:\"10\";s:10:\"field_name\";s:15:\"field_published\";s:11:\"entity_type\";s:7:\"message\";s:6:\"bundle\";s:22:\"example_create_comment\";s:7:\"deleted\";s:1:\"0\";}}s:19:\"example_create_node\";a:2:{s:14:\"field_node_ref\";a:14:{s:13:\"default_value\";N;s:22:\"default_value_function\";s:0:\"\";s:11:\"description\";s:0:\"\";s:7:\"display\";a:2:{s:7:\"default\";a:4:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:6:\"hidden\";s:6:\"weight\";s:1:\"2\";s:8:\"settings\";a:0:{}}s:4:\"full\";a:4:{s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:4:\"type\";s:6:\"hidden\";s:6:\"weight\";s:1:\"5\";}}s:5:\"label\";s:14:\"Node reference\";s:8:\"required\";i:1;s:8:\"settings\";a:2:{s:9:\"behaviors\";a:1:{s:11:\"prepopulate\";a:4:{s:6:\"action\";s:4:\"hide\";s:8:\"fallback\";s:4:\"none\";s:9:\"skip_perm\";s:26:\"access administration menu\";s:6:\"status\";i:0;}}s:18:\"user_register_form\";b:0;}s:6:\"widget\";a:5:{s:6:\"active\";i:1;s:6:\"module\";s:15:\"entityreference\";s:8:\"settings\";a:3:{s:14:\"match_operator\";s:8:\"CONTAINS\";s:4:\"path\";s:0:\"\";s:4:\"size\";s:2:\"60\";}s:4:\"type\";s:28:\"entityreference_autocomplete\";s:6:\"weight\";s:1:\"2\";}s:2:\"id\";s:2:\"20\";s:8:\"field_id\";s:1:\"9\";s:10:\"field_name\";s:14:\"field_node_ref\";s:11:\"entity_type\";s:7:\"message\";s:6:\"bundle\";s:19:\"example_create_node\";s:7:\"deleted\";s:1:\"0\";}s:15:\"field_published\";a:13:{s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";i:0;}}s:11:\"description\";s:0:\"\";s:7:\"display\";a:2:{s:7:\"default\";a:4:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:6:\"hidden\";s:6:\"weight\";s:1:\"1\";s:8:\"settings\";a:0:{}}s:4:\"full\";a:4:{s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:4:\"type\";s:6:\"hidden\";s:6:\"weight\";s:1:\"4\";}}s:5:\"label\";s:9:\"Published\";s:8:\"required\";i:0;s:8:\"settings\";a:1:{s:18:\"user_register_form\";b:0;}s:6:\"widget\";a:5:{s:6:\"active\";i:1;s:6:\"module\";s:7:\"options\";s:8:\"settings\";a:1:{s:13:\"display_label\";i:0;}s:4:\"type\";s:13:\"options_onoff\";s:6:\"weight\";s:1:\"3\";}s:2:\"id\";s:2:\"21\";s:8:\"field_id\";s:2:\"10\";s:10:\"field_name\";s:15:\"field_published\";s:11:\"entity_type\";s:7:\"message\";s:6:\"bundle\";s:19:\"example_create_node\";s:7:\"deleted\";s:1:\"0\";}}s:21:\"example_user_register\";a:1:{s:15:\"field_published\";a:13:{s:13:\"default_value\";N;s:11:\"description\";s:0:\"\";s:7:\"display\";a:2:{s:7:\"default\";a:4:{s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:4:\"type\";s:6:\"hidden\";s:6:\"weight\";s:1:\"1\";}s:4:\"full\";a:4:{s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:4:\"type\";s:6:\"hidden\";s:6:\"weight\";s:1:\"1\";}}s:5:\"label\";s:9:\"Published\";s:8:\"required\";i:0;s:8:\"settings\";a:1:{s:18:\"user_register_form\";b:0;}s:6:\"widget\";a:5:{s:6:\"active\";i:1;s:6:\"module\";s:7:\"options\";s:8:\"settings\";a:0:{}s:4:\"type\";s:15:\"options_buttons\";s:6:\"weight\";s:1:\"2\";}s:2:\"id\";s:2:\"22\";s:8:\"field_id\";s:2:\"10\";s:10:\"field_name\";s:15:\"field_published\";s:11:\"entity_type\";s:7:\"message\";s:6:\"bundle\";s:21:\"example_user_register\";s:7:\"deleted\";s:1:\"0\";}}}s:16:\"i18n_translation\";a:1:{s:13:\"taxonomy_term\";a:0:{}}s:21:\"message_type_category\";a:1:{s:21:\"message_type_category\";a:0:{}}s:4:\"file\";a:1:{s:4:\"file\";a:0:{}}s:13:\"taxonomy_term\";a:4:{s:4:\"tags\";a:0:{}s:6:\"forums\";a:0:{}s:10:\"categories\";a:0:{}s:8:\"sections\";a:0:{}}s:19:\"taxonomy_vocabulary\";a:1:{s:19:\"taxonomy_vocabulary\";a:0:{}}s:4:\"user\";a:1:{s:4:\"user\";a:0:{}}}',0,1512620340,1),('field_info_types:en','a:4:{s:11:\"field types\";a:18:{s:15:\"entityreference\";a:8:{s:5:\"label\";s:16:\"Entity Reference\";s:11:\"description\";s:36:\"This field reference another entity.\";s:8:\"settings\";a:3:{s:11:\"target_type\";s:4:\"node\";s:7:\"handler\";s:4:\"base\";s:16:\"handler_settings\";a:0:{}}s:17:\"instance_settings\";a:1:{s:18:\"user_register_form\";b:0;}s:14:\"default_widget\";s:28:\"entityreference_autocomplete\";s:17:\"default_formatter\";s:21:\"entityreference_label\";s:18:\"property_callbacks\";a:1:{i:0;s:39:\"entityreference_field_property_callback\";}s:6:\"module\";s:15:\"entityreference\";}s:16:\"field_collection\";a:9:{s:5:\"label\";s:16:\"Field collection\";s:11:\"description\";s:97:\"This field stores references to embedded entities, which itself may contain any number of fields.\";s:17:\"instance_settings\";a:1:{s:18:\"user_register_form\";b:0;}s:14:\"default_widget\";s:23:\"field_collection_hidden\";s:17:\"default_formatter\";s:21:\"field_collection_view\";s:8:\"settings\";a:2:{s:4:\"path\";s:0:\"\";s:16:\"hide_blank_items\";b:1;}s:13:\"property_type\";s:21:\"field_collection_item\";s:18:\"property_callbacks\";a:1:{i:0;s:50:\"field_collection_entity_metadata_property_callback\";}s:6:\"module\";s:16:\"field_collection\";}s:4:\"file\";a:10:{s:5:\"label\";s:4:\"File\";s:11:\"description\";s:55:\"This field stores the ID of a file as an integer value.\";s:8:\"settings\";a:3:{s:13:\"display_field\";i:0;s:15:\"display_default\";i:0;s:10:\"uri_scheme\";s:6:\"public\";}s:17:\"instance_settings\";a:5:{s:15:\"file_extensions\";s:3:\"txt\";s:14:\"file_directory\";s:0:\"\";s:12:\"max_filesize\";s:0:\"\";s:17:\"description_field\";i:0;s:18:\"user_register_form\";b:0;}s:14:\"default_widget\";s:12:\"file_generic\";s:17:\"default_formatter\";s:12:\"file_default\";s:6:\"module\";s:4:\"file\";s:13:\"property_type\";s:15:\"field_item_file\";s:18:\"property_callbacks\";a:1:{i:0;s:35:\"entity_metadata_field_file_callback\";}s:23:\"default_token_formatter\";s:14:\"file_url_plain\";}s:8:\"fivestar\";a:10:{s:5:\"label\";s:15:\"Fivestar Rating\";s:11:\"description\";s:41:\"Store a rating for this piece of content.\";s:14:\"default_widget\";s:7:\"exposed\";s:17:\"default_formatter\";s:26:\"fivestar_formatter_default\";s:8:\"settings\";a:1:{s:4:\"axis\";s:4:\"vote\";}s:17:\"instance_settings\";a:2:{s:5:\"stars\";i:5;s:18:\"user_register_form\";b:0;}s:13:\"property_type\";s:8:\"fivestar\";s:18:\"property_callbacks\";a:1:{i:0;s:31:\"fivestar_property_info_callback\";}s:9:\"microdata\";b:1;s:6:\"module\";s:8:\"fivestar\";}s:5:\"image\";a:10:{s:5:\"label\";s:5:\"Image\";s:11:\"description\";s:62:\"This field stores the ID of an image file as an integer value.\";s:8:\"settings\";a:2:{s:10:\"uri_scheme\";s:6:\"public\";s:13:\"default_image\";i:0;}s:17:\"instance_settings\";a:9:{s:15:\"file_extensions\";s:16:\"png gif jpg jpeg\";s:14:\"file_directory\";s:0:\"\";s:12:\"max_filesize\";s:0:\"\";s:9:\"alt_field\";i:0;s:11:\"title_field\";i:0;s:14:\"max_resolution\";s:0:\"\";s:14:\"min_resolution\";s:0:\"\";s:13:\"default_image\";i:0;s:18:\"user_register_form\";b:0;}s:14:\"default_widget\";s:11:\"image_image\";s:17:\"default_formatter\";s:5:\"image\";s:6:\"module\";s:5:\"image\";s:13:\"property_type\";s:16:\"field_item_image\";s:18:\"property_callbacks\";a:2:{i:0;s:35:\"entity_metadata_field_file_callback\";i:1;s:36:\"entity_metadata_field_image_callback\";}s:23:\"default_token_formatter\";s:14:\"file_url_plain\";}s:10:\"link_field\";a:9:{s:5:\"label\";s:4:\"Link\";s:11:\"description\";s:71:\"Store a title, href, and attributes in the database to assemble a link.\";s:8:\"settings\";a:7:{s:10:\"attributes\";a:3:{s:6:\"target\";s:7:\"default\";s:5:\"class\";s:0:\"\";s:3:\"rel\";s:0:\"\";}s:3:\"url\";i:0;s:5:\"title\";s:8:\"optional\";s:11:\"title_value\";s:0:\"\";s:15:\"title_maxlength\";i:128;s:13:\"enable_tokens\";i:1;s:7:\"display\";a:1:{s:10:\"url_cutoff\";i:80;}}s:17:\"instance_settings\";a:11:{s:10:\"attributes\";a:3:{s:6:\"target\";s:7:\"default\";s:5:\"class\";s:0:\"\";s:3:\"rel\";s:0:\"\";}s:3:\"url\";i:0;s:5:\"title\";s:8:\"optional\";s:11:\"title_value\";s:0:\"\";s:27:\"title_label_use_field_label\";b:0;s:15:\"title_maxlength\";i:128;s:13:\"enable_tokens\";i:1;s:7:\"display\";a:1:{s:10:\"url_cutoff\";i:80;}s:12:\"validate_url\";i:1;s:12:\"absolute_url\";i:1;s:18:\"user_register_form\";b:0;}s:14:\"default_widget\";s:10:\"link_field\";s:17:\"default_formatter\";s:12:\"link_default\";s:13:\"property_type\";s:15:\"field_item_link\";s:18:\"property_callbacks\";a:1:{i:0;s:33:\"link_field_property_info_callback\";}s:6:\"module\";s:4:\"link\";}s:12:\"list_integer\";a:9:{s:5:\"label\";s:14:\"List (integer)\";s:11:\"description\";s:144:\"This field stores integer values from a list of allowed \'value => label\' pairs, i.e. \'Lifetime in days\': 1 => 1 day, 7 => 1 week, 31 => 1 month.\";s:8:\"settings\";a:2:{s:14:\"allowed_values\";a:0:{}s:23:\"allowed_values_function\";s:0:\"\";}s:14:\"default_widget\";s:14:\"options_select\";s:17:\"default_formatter\";s:12:\"list_default\";s:17:\"instance_settings\";a:1:{s:18:\"user_register_form\";b:0;}s:6:\"module\";s:4:\"list\";s:13:\"property_type\";s:7:\"integer\";s:23:\"default_token_formatter\";s:12:\"list_default\";}s:10:\"list_float\";a:9:{s:5:\"label\";s:12:\"List (float)\";s:11:\"description\";s:134:\"This field stores float values from a list of allowed \'value => label\' pairs, i.e. \'Fraction\': 0 => 0, .25 => 1/4, .75 => 3/4, 1 => 1.\";s:8:\"settings\";a:2:{s:14:\"allowed_values\";a:0:{}s:23:\"allowed_values_function\";s:0:\"\";}s:14:\"default_widget\";s:14:\"options_select\";s:17:\"default_formatter\";s:12:\"list_default\";s:17:\"instance_settings\";a:1:{s:18:\"user_register_form\";b:0;}s:6:\"module\";s:4:\"list\";s:13:\"property_type\";s:7:\"decimal\";s:23:\"default_token_formatter\";s:12:\"list_default\";}s:9:\"list_text\";a:9:{s:5:\"label\";s:11:\"List (text)\";s:11:\"description\";s:137:\"This field stores text values from a list of allowed \'value => label\' pairs, i.e. \'US States\': IL => Illinois, IA => Iowa, IN => Indiana.\";s:8:\"settings\";a:2:{s:14:\"allowed_values\";a:0:{}s:23:\"allowed_values_function\";s:0:\"\";}s:14:\"default_widget\";s:14:\"options_select\";s:17:\"default_formatter\";s:12:\"list_default\";s:17:\"instance_settings\";a:1:{s:18:\"user_register_form\";b:0;}s:6:\"module\";s:4:\"list\";s:13:\"property_type\";s:4:\"text\";s:23:\"default_token_formatter\";s:12:\"list_default\";}s:12:\"list_boolean\";a:9:{s:5:\"label\";s:7:\"Boolean\";s:11:\"description\";s:50:\"This field stores simple on/off or yes/no options.\";s:8:\"settings\";a:2:{s:14:\"allowed_values\";a:0:{}s:23:\"allowed_values_function\";s:0:\"\";}s:14:\"default_widget\";s:15:\"options_buttons\";s:17:\"default_formatter\";s:12:\"list_default\";s:17:\"instance_settings\";a:1:{s:18:\"user_register_form\";b:0;}s:6:\"module\";s:4:\"list\";s:13:\"property_type\";s:7:\"boolean\";s:23:\"default_token_formatter\";s:12:\"list_default\";}s:14:\"number_integer\";a:9:{s:5:\"label\";s:7:\"Integer\";s:11:\"description\";s:57:\"This field stores a number in the database as an integer.\";s:17:\"instance_settings\";a:5:{s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:18:\"user_register_form\";b:0;}s:14:\"default_widget\";s:6:\"number\";s:17:\"default_formatter\";s:14:\"number_integer\";s:8:\"settings\";a:0:{}s:6:\"module\";s:6:\"number\";s:13:\"property_type\";s:7:\"integer\";s:23:\"default_token_formatter\";s:18:\"number_unformatted\";}s:14:\"number_decimal\";a:9:{s:5:\"label\";s:7:\"Decimal\";s:11:\"description\";s:69:\"This field stores a number in the database in a fixed decimal format.\";s:8:\"settings\";a:3:{s:9:\"precision\";i:10;s:5:\"scale\";i:2;s:17:\"decimal_separator\";s:1:\".\";}s:17:\"instance_settings\";a:5:{s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:18:\"user_register_form\";b:0;}s:14:\"default_widget\";s:6:\"number\";s:17:\"default_formatter\";s:14:\"number_decimal\";s:6:\"module\";s:6:\"number\";s:13:\"property_type\";s:7:\"decimal\";s:23:\"default_token_formatter\";s:18:\"number_unformatted\";}s:12:\"number_float\";a:9:{s:5:\"label\";s:5:\"Float\";s:11:\"description\";s:70:\"This field stores a number in the database in a floating point format.\";s:8:\"settings\";a:1:{s:17:\"decimal_separator\";s:1:\".\";}s:17:\"instance_settings\";a:5:{s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:18:\"user_register_form\";b:0;}s:14:\"default_widget\";s:6:\"number\";s:17:\"default_formatter\";s:14:\"number_decimal\";s:6:\"module\";s:6:\"number\";s:13:\"property_type\";s:7:\"decimal\";s:23:\"default_token_formatter\";s:18:\"number_unformatted\";}s:23:\"taxonomy_term_reference\";a:12:{s:5:\"label\";s:14:\"Term reference\";s:11:\"description\";s:49:\"This field stores a reference to a taxonomy term.\";s:14:\"default_widget\";s:14:\"options_select\";s:17:\"default_formatter\";s:33:\"i18n_taxonomy_term_reference_link\";s:8:\"settings\";a:1:{s:14:\"allowed_values\";a:1:{i:0;a:2:{s:10:\"vocabulary\";s:0:\"\";s:6:\"parent\";s:1:\"0\";}}}s:17:\"instance_settings\";a:1:{s:18:\"user_register_form\";b:0;}s:6:\"module\";s:8:\"taxonomy\";s:13:\"property_type\";s:13:\"taxonomy_term\";s:18:\"property_callbacks\";a:1:{i:0;s:45:\"entity_metadata_field_term_reference_callback\";}s:23:\"default_token_formatter\";s:29:\"taxonomy_term_reference_plain\";s:21:\"options_list_callback\";s:28:\"i18n_taxonomy_allowed_values\";s:18:\"i18n_sync_callback\";s:39:\"i18n_taxonomy_field_prepare_translation\";}s:4:\"text\";a:10:{s:5:\"label\";s:4:\"Text\";s:11:\"description\";s:47:\"This field stores varchar text in the database.\";s:8:\"settings\";a:1:{s:10:\"max_length\";i:255;}s:17:\"instance_settings\";a:2:{s:15:\"text_processing\";i:0;s:18:\"user_register_form\";b:0;}s:14:\"default_widget\";s:14:\"text_textfield\";s:17:\"default_formatter\";s:12:\"text_default\";s:6:\"module\";s:4:\"text\";s:13:\"property_type\";s:4:\"text\";s:18:\"property_callbacks\";a:1:{i:0;s:44:\"entity_metadata_field_text_property_callback\";}s:23:\"default_token_formatter\";s:12:\"text_default\";}s:9:\"text_long\";a:10:{s:5:\"label\";s:9:\"Long text\";s:11:\"description\";s:44:\"This field stores long text in the database.\";s:17:\"instance_settings\";a:2:{s:15:\"text_processing\";i:0;s:18:\"user_register_form\";b:0;}s:14:\"default_widget\";s:13:\"text_textarea\";s:17:\"default_formatter\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";s:13:\"property_type\";s:4:\"text\";s:18:\"property_callbacks\";a:1:{i:0;s:44:\"entity_metadata_field_text_property_callback\";}s:23:\"default_token_formatter\";s:12:\"text_default\";}s:17:\"text_with_summary\";a:10:{s:5:\"label\";s:21:\"Long text and summary\";s:11:\"description\";s:77:\"This field stores long text in the database along with optional summary text.\";s:17:\"instance_settings\";a:3:{s:15:\"text_processing\";i:1;s:15:\"display_summary\";i:0;s:18:\"user_register_form\";b:0;}s:14:\"default_widget\";s:26:\"text_textarea_with_summary\";s:17:\"default_formatter\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";s:13:\"property_type\";s:22:\"field_item_textsummary\";s:18:\"property_callbacks\";a:1:{i:0;s:44:\"entity_metadata_field_text_property_callback\";}s:23:\"default_token_formatter\";s:12:\"text_default\";}s:17:\"video_embed_field\";a:9:{s:5:\"label\";s:11:\"Video Embed\";s:11:\"description\";s:34:\"Embed videos from youtube or vimeo\";s:8:\"settings\";a:0:{}s:17:\"instance_settings\";a:4:{s:17:\"description_field\";i:0;s:18:\"description_length\";i:128;s:17:\"allowed_providers\";a:2:{i:0;s:7:\"youtube\";i:1;s:5:\"vimeo\";}s:18:\"user_register_form\";b:0;}s:14:\"default_widget\";s:23:\"video_embed_field_video\";s:17:\"default_formatter\";s:17:\"video_embed_field\";s:13:\"property_type\";s:17:\"video_embed_field\";s:18:\"property_callbacks\";a:1:{i:0;s:40:\"video_embed_field_property_info_callback\";}s:6:\"module\";s:17:\"video_embed_field\";}}s:12:\"widget types\";a:19:{s:13:\"options_onoff\";a:5:{s:5:\"label\";s:22:\"Single on/off checkbox\";s:11:\"field types\";a:1:{i:0;s:12:\"list_boolean\";}s:9:\"behaviors\";a:1:{s:15:\"multiple values\";i:4;}s:8:\"settings\";a:1:{s:13:\"display_label\";i:0;}s:6:\"module\";s:7:\"options\";}s:15:\"options_buttons\";a:5:{s:5:\"label\";s:25:\"Check boxes/radio buttons\";s:11:\"field types\";a:6:{i:0;s:15:\"entityreference\";i:1;s:12:\"list_integer\";i:2;s:10:\"list_float\";i:3;s:9:\"list_text\";i:4;s:12:\"list_boolean\";i:5;s:23:\"taxonomy_term_reference\";}s:9:\"behaviors\";a:1:{s:15:\"multiple values\";i:4;}s:8:\"settings\";a:0:{}s:6:\"module\";s:7:\"options\";}s:14:\"options_select\";a:5:{s:5:\"label\";s:11:\"Select list\";s:11:\"field types\";a:5:{i:0;s:15:\"entityreference\";i:1;s:12:\"list_integer\";i:2;s:10:\"list_float\";i:3;s:9:\"list_text\";i:4;s:23:\"taxonomy_term_reference\";}s:9:\"behaviors\";a:1:{s:15:\"multiple values\";i:4;}s:8:\"settings\";a:1:{s:12:\"apply_chosen\";s:0:\"\";}s:6:\"module\";s:7:\"options\";}s:21:\"taxonomy_autocomplete\";a:5:{s:5:\"label\";s:34:\"Autocomplete term widget (tagging)\";s:11:\"field types\";a:1:{i:0;s:23:\"taxonomy_term_reference\";}s:8:\"settings\";a:2:{s:4:\"size\";i:60;s:17:\"autocomplete_path\";s:21:\"taxonomy/autocomplete\";}s:9:\"behaviors\";a:1:{s:15:\"multiple values\";i:4;}s:6:\"module\";s:8:\"taxonomy\";}s:14:\"text_textfield\";a:4:{s:5:\"label\";s:10:\"Text field\";s:11:\"field types\";a:1:{i:0;s:4:\"text\";}s:8:\"settings\";a:1:{s:4:\"size\";i:60;}s:6:\"module\";s:4:\"text\";}s:23:\"video_embed_field_video\";a:6:{s:5:\"label\";s:5:\"Video\";s:11:\"description\";s:28:\"Provides a video embed field\";s:11:\"field types\";a:1:{i:0;s:17:\"video_embed_field\";}s:8:\"settings\";a:0:{}s:9:\"behaviors\";a:2:{s:15:\"multiple values\";i:2;s:13:\"default value\";i:2;}s:6:\"module\";s:17:\"video_embed_field\";}s:26:\"text_textarea_with_summary\";a:4:{s:5:\"label\";s:24:\"Text area with a summary\";s:11:\"field types\";a:1:{i:0;s:17:\"text_with_summary\";}s:8:\"settings\";a:2:{s:4:\"rows\";i:20;s:12:\"summary_rows\";i:5;}s:6:\"module\";s:4:\"text\";}s:13:\"text_textarea\";a:4:{s:5:\"label\";s:25:\"Text area (multiple rows)\";s:11:\"field types\";a:1:{i:0;s:9:\"text_long\";}s:8:\"settings\";a:1:{s:4:\"rows\";i:5;}s:6:\"module\";s:4:\"text\";}s:6:\"number\";a:4:{s:5:\"label\";s:10:\"Text field\";s:11:\"field types\";a:3:{i:0;s:14:\"number_integer\";i:1;s:14:\"number_decimal\";i:2;s:12:\"number_float\";}s:8:\"settings\";a:0:{}s:6:\"module\";s:6:\"number\";}s:10:\"link_field\";a:5:{s:5:\"label\";s:4:\"Link\";s:11:\"field types\";a:1:{i:0;s:10:\"link_field\";}s:15:\"multiple values\";i:2;s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"link\";}s:22:\"field_collection_embed\";a:5:{s:5:\"label\";s:8:\"Embedded\";s:11:\"field types\";a:1:{i:0;s:16:\"field_collection\";}s:9:\"behaviors\";a:2:{s:15:\"multiple values\";i:2;s:13:\"default value\";i:1;}s:8:\"settings\";a:0:{}s:6:\"module\";s:16:\"field_collection\";}s:23:\"field_collection_hidden\";a:5:{s:5:\"label\";s:6:\"Hidden\";s:11:\"field types\";a:1:{i:0;s:16:\"field_collection\";}s:9:\"behaviors\";a:2:{s:15:\"multiple values\";i:4;s:13:\"default value\";i:1;}s:8:\"settings\";a:0:{}s:6:\"module\";s:16:\"field_collection\";}s:33:\"entityreference_autocomplete_tags\";a:6:{s:5:\"label\";s:25:\"Autocomplete (Tags style)\";s:11:\"description\";s:27:\"An autocomplete text field.\";s:11:\"field types\";a:1:{i:0;s:15:\"entityreference\";}s:8:\"settings\";a:3:{s:14:\"match_operator\";s:8:\"CONTAINS\";s:4:\"size\";i:60;s:4:\"path\";s:0:\"\";}s:9:\"behaviors\";a:1:{s:15:\"multiple values\";i:4;}s:6:\"module\";s:15:\"entityreference\";}s:12:\"file_generic\";a:5:{s:5:\"label\";s:4:\"File\";s:11:\"field types\";a:1:{i:0;s:4:\"file\";}s:8:\"settings\";a:1:{s:18:\"progress_indicator\";s:8:\"throbber\";}s:9:\"behaviors\";a:2:{s:15:\"multiple values\";i:4;s:13:\"default value\";i:1;}s:6:\"module\";s:4:\"file\";}s:7:\"exposed\";a:5:{s:5:\"label\";s:27:\"Stars (rated while viewing)\";s:11:\"field types\";a:1:{i:0;s:8:\"fivestar\";}s:9:\"behaviors\";a:1:{s:15:\"multiple values\";i:1;}s:8:\"settings\";a:0:{}s:6:\"module\";s:8:\"fivestar\";}s:11:\"image_image\";a:5:{s:5:\"label\";s:5:\"Image\";s:11:\"field types\";a:1:{i:0;s:5:\"image\";}s:8:\"settings\";a:2:{s:18:\"progress_indicator\";s:8:\"throbber\";s:19:\"preview_image_style\";s:9:\"thumbnail\";}s:9:\"behaviors\";a:2:{s:15:\"multiple values\";i:4;s:13:\"default value\";i:1;}s:6:\"module\";s:5:\"image\";}s:15:\"fivestar_select\";a:5:{s:5:\"label\";s:33:\"Select list (rated while editing)\";s:11:\"field types\";a:1:{i:0;s:8:\"fivestar\";}s:9:\"behaviors\";a:1:{s:15:\"multiple values\";i:1;}s:8:\"settings\";a:0:{}s:6:\"module\";s:8:\"fivestar\";}s:5:\"stars\";a:5:{s:5:\"label\";s:27:\"Stars (rated while editing)\";s:11:\"field types\";a:1:{i:0;s:8:\"fivestar\";}s:9:\"behaviors\";a:1:{s:15:\"multiple values\";i:1;}s:8:\"settings\";a:1:{s:6:\"widget\";a:1:{s:15:\"fivestar_widget\";s:7:\"default\";}}s:6:\"module\";s:8:\"fivestar\";}s:28:\"entityreference_autocomplete\";a:5:{s:5:\"label\";s:12:\"Autocomplete\";s:11:\"description\";s:27:\"An autocomplete text field.\";s:11:\"field types\";a:1:{i:0;s:15:\"entityreference\";}s:8:\"settings\";a:3:{s:14:\"match_operator\";s:8:\"CONTAINS\";s:4:\"size\";i:60;s:4:\"path\";s:0:\"\";}s:6:\"module\";s:15:\"entityreference\";}}s:15:\"formatter types\";a:40:{s:21:\"entityreference_label\";a:5:{s:5:\"label\";s:5:\"Label\";s:11:\"description\";s:45:\"Display the label of the referenced entities.\";s:11:\"field types\";a:1:{i:0;s:15:\"entityreference\";}s:8:\"settings\";a:1:{s:4:\"link\";b:0;}s:6:\"module\";s:15:\"entityreference\";}s:25:\"entityreference_entity_id\";a:5:{s:5:\"label\";s:9:\"Entity id\";s:11:\"description\";s:42:\"Display the id of the referenced entities.\";s:11:\"field types\";a:1:{i:0;s:15:\"entityreference\";}s:8:\"settings\";a:0:{}s:6:\"module\";s:15:\"entityreference\";}s:27:\"entityreference_entity_view\";a:5:{s:5:\"label\";s:15:\"Rendered entity\";s:11:\"description\";s:58:\"Display the referenced entities rendered by entity_view().\";s:11:\"field types\";a:1:{i:0;s:15:\"entityreference\";}s:8:\"settings\";a:2:{s:9:\"view_mode\";s:7:\"default\";s:5:\"links\";b:1;}s:6:\"module\";s:15:\"entityreference\";}s:21:\"field_collection_list\";a:4:{s:5:\"label\";s:31:\"Links to field collection items\";s:11:\"field types\";a:1:{i:0;s:16:\"field_collection\";}s:8:\"settings\";a:4:{s:4:\"edit\";s:4:\"Edit\";s:6:\"delete\";s:6:\"Delete\";s:3:\"add\";s:3:\"Add\";s:11:\"description\";b:1;}s:6:\"module\";s:16:\"field_collection\";}s:21:\"field_collection_view\";a:4:{s:5:\"label\";s:22:\"Field collection items\";s:11:\"field types\";a:1:{i:0;s:16:\"field_collection\";}s:8:\"settings\";a:5:{s:4:\"edit\";s:4:\"Edit\";s:6:\"delete\";s:6:\"Delete\";s:3:\"add\";s:3:\"Add\";s:11:\"description\";b:1;s:9:\"view_mode\";s:4:\"full\";}s:6:\"module\";s:16:\"field_collection\";}s:23:\"field_collection_fields\";a:4:{s:5:\"label\";s:11:\"Fields only\";s:11:\"field types\";a:1:{i:0;s:16:\"field_collection\";}s:8:\"settings\";a:1:{s:9:\"view_mode\";s:4:\"full\";}s:6:\"module\";s:16:\"field_collection\";}s:12:\"file_default\";a:4:{s:5:\"label\";s:12:\"Generic file\";s:11:\"field types\";a:1:{i:0;s:4:\"file\";}s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"file\";}s:10:\"file_table\";a:4:{s:5:\"label\";s:14:\"Table of files\";s:11:\"field types\";a:1:{i:0;s:4:\"file\";}s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"file\";}s:14:\"file_url_plain\";a:4:{s:5:\"label\";s:11:\"URL to file\";s:11:\"field types\";a:1:{i:0;s:4:\"file\";}s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"file\";}s:26:\"fivestar_formatter_default\";a:4:{s:5:\"label\";s:8:\"As Stars\";s:11:\"field types\";a:1:{i:0;s:8:\"fivestar\";}s:8:\"settings\";a:4:{s:6:\"widget\";a:1:{s:15:\"fivestar_widget\";N;}s:5:\"style\";s:7:\"average\";s:4:\"text\";s:7:\"average\";s:6:\"expose\";b:1;}s:6:\"module\";s:8:\"fivestar\";}s:25:\"fivestar_formatter_rating\";a:4:{s:5:\"label\";s:19:\"Rating (i.e. 4.2/5)\";s:11:\"field types\";a:1:{i:0;s:8:\"fivestar\";}s:8:\"settings\";a:0:{}s:6:\"module\";s:8:\"fivestar\";}s:29:\"fivestar_formatter_percentage\";a:4:{s:5:\"label\";s:20:\"Percentage (i.e. 92)\";s:11:\"field types\";a:1:{i:0;s:8:\"fivestar\";}s:8:\"settings\";a:0:{}s:6:\"module\";s:8:\"fivestar\";}s:10:\"flexslider\";a:4:{s:5:\"label\";s:10:\"flexslider\";s:11:\"field types\";a:2:{i:0;s:5:\"image\";i:1;s:5:\"media\";}s:8:\"settings\";a:3:{s:9:\"optionset\";s:7:\"default\";s:11:\"image_style\";s:0:\"\";s:7:\"caption\";b:0;}s:6:\"module\";s:17:\"flexslider_fields\";}s:5:\"image\";a:4:{s:5:\"label\";s:5:\"Image\";s:11:\"field types\";a:1:{i:0;s:5:\"image\";}s:8:\"settings\";a:2:{s:11:\"image_style\";s:0:\"\";s:10:\"image_link\";s:0:\"\";}s:6:\"module\";s:5:\"image\";}s:12:\"link_default\";a:5:{s:5:\"label\";s:24:\"Title, as link (default)\";s:11:\"field types\";a:1:{i:0;s:10:\"link_field\";}s:15:\"multiple values\";i:2;s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"link\";}s:16:\"link_title_plain\";a:5:{s:5:\"label\";s:20:\"Title, as plain text\";s:11:\"field types\";a:1:{i:0;s:10:\"link_field\";}s:15:\"multiple values\";i:2;s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"link\";}s:8:\"link_url\";a:5:{s:5:\"label\";s:12:\"URL, as link\";s:11:\"field types\";a:1:{i:0;s:10:\"link_field\";}s:15:\"multiple values\";i:2;s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"link\";}s:10:\"link_plain\";a:5:{s:5:\"label\";s:18:\"URL, as plain text\";s:11:\"field types\";a:1:{i:0;s:10:\"link_field\";}s:15:\"multiple values\";i:2;s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"link\";}s:13:\"link_absolute\";a:5:{s:5:\"label\";s:13:\"URL, absolute\";s:11:\"field types\";a:1:{i:0;s:10:\"link_field\";}s:15:\"multiple values\";i:2;s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"link\";}s:11:\"link_domain\";a:5:{s:5:\"label\";s:15:\"Domain, as link\";s:11:\"field types\";a:1:{i:0;s:10:\"link_field\";}s:15:\"multiple values\";i:2;s:8:\"settings\";a:1:{s:9:\"strip_www\";b:0;}s:6:\"module\";s:4:\"link\";}s:10:\"link_short\";a:5:{s:5:\"label\";s:32:\"Short, as link with title \"Link\"\";s:11:\"field types\";a:1:{i:0;s:10:\"link_field\";}s:15:\"multiple values\";i:2;s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"link\";}s:10:\"link_label\";a:5:{s:5:\"label\";s:34:\"Label, as link with label as title\";s:11:\"field types\";a:1:{i:0;s:10:\"link_field\";}s:15:\"multiple values\";i:2;s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"link\";}s:13:\"link_separate\";a:5:{s:5:\"label\";s:22:\"Separate title and URL\";s:11:\"field types\";a:1:{i:0;s:10:\"link_field\";}s:15:\"multiple values\";i:2;s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"link\";}s:12:\"list_default\";a:4:{s:5:\"label\";s:7:\"Default\";s:11:\"field types\";a:4:{i:0;s:12:\"list_integer\";i:1;s:10:\"list_float\";i:2;s:9:\"list_text\";i:3;s:12:\"list_boolean\";}s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"list\";}s:8:\"list_key\";a:4:{s:5:\"label\";s:3:\"Key\";s:11:\"field types\";a:4:{i:0;s:12:\"list_integer\";i:1;s:10:\"list_float\";i:2;s:9:\"list_text\";i:3;s:12:\"list_boolean\";}s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"list\";}s:14:\"number_integer\";a:4:{s:5:\"label\";s:7:\"Default\";s:11:\"field types\";a:1:{i:0;s:14:\"number_integer\";}s:8:\"settings\";a:4:{s:18:\"thousand_separator\";s:0:\"\";s:17:\"decimal_separator\";s:1:\".\";s:5:\"scale\";i:0;s:13:\"prefix_suffix\";b:1;}s:6:\"module\";s:6:\"number\";}s:14:\"number_decimal\";a:4:{s:5:\"label\";s:7:\"Default\";s:11:\"field types\";a:2:{i:0;s:14:\"number_decimal\";i:1;s:12:\"number_float\";}s:8:\"settings\";a:4:{s:18:\"thousand_separator\";s:0:\"\";s:17:\"decimal_separator\";s:1:\".\";s:5:\"scale\";i:2;s:13:\"prefix_suffix\";b:1;}s:6:\"module\";s:6:\"number\";}s:18:\"number_unformatted\";a:4:{s:5:\"label\";s:11:\"Unformatted\";s:11:\"field types\";a:3:{i:0;s:14:\"number_integer\";i:1;s:14:\"number_decimal\";i:2;s:12:\"number_float\";}s:8:\"settings\";a:0:{}s:6:\"module\";s:6:\"number\";}s:28:\"taxonomy_term_reference_link\";a:4:{s:5:\"label\";s:4:\"Link\";s:11:\"field types\";a:1:{i:0;s:23:\"taxonomy_term_reference\";}s:8:\"settings\";a:0:{}s:6:\"module\";s:8:\"taxonomy\";}s:29:\"taxonomy_term_reference_plain\";a:4:{s:5:\"label\";s:10:\"Plain text\";s:11:\"field types\";a:1:{i:0;s:23:\"taxonomy_term_reference\";}s:8:\"settings\";a:0:{}s:6:\"module\";s:8:\"taxonomy\";}s:36:\"taxonomy_term_reference_rss_category\";a:4:{s:5:\"label\";s:12:\"RSS category\";s:11:\"field types\";a:1:{i:0;s:23:\"taxonomy_term_reference\";}s:8:\"settings\";a:0:{}s:6:\"module\";s:8:\"taxonomy\";}s:12:\"text_default\";a:4:{s:5:\"label\";s:7:\"Default\";s:11:\"field types\";a:3:{i:0;s:4:\"text\";i:1;s:9:\"text_long\";i:2;s:17:\"text_with_summary\";}s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";}s:10:\"text_plain\";a:4:{s:5:\"label\";s:10:\"Plain text\";s:11:\"field types\";a:3:{i:0;s:4:\"text\";i:1;s:9:\"text_long\";i:2;s:17:\"text_with_summary\";}s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";}s:12:\"text_trimmed\";a:4:{s:5:\"label\";s:7:\"Trimmed\";s:11:\"field types\";a:3:{i:0;s:4:\"text\";i:1;s:9:\"text_long\";i:2;s:17:\"text_with_summary\";}s:8:\"settings\";a:1:{s:11:\"trim_length\";i:600;}s:6:\"module\";s:4:\"text\";}s:23:\"text_summary_or_trimmed\";a:4:{s:5:\"label\";s:18:\"Summary or trimmed\";s:11:\"field types\";a:1:{i:0;s:17:\"text_with_summary\";}s:8:\"settings\";a:1:{s:11:\"trim_length\";i:600;}s:6:\"module\";s:4:\"text\";}s:17:\"video_embed_field\";a:4:{s:5:\"label\";s:12:\"Video Player\";s:11:\"field types\";a:1:{i:0;s:17:\"video_embed_field\";}s:8:\"settings\";a:3:{s:11:\"video_style\";s:6:\"normal\";s:11:\"description\";i:1;s:20:\"description_position\";s:6:\"bottom\";}s:6:\"module\";s:17:\"video_embed_field\";}s:21:\"video_embed_field_url\";a:4:{s:5:\"label\";s:12:\"URL to Video\";s:11:\"field types\";a:1:{i:0;s:17:\"video_embed_field\";}s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"video_embed_field\";}s:27:\"video_embed_field_thumbnail\";a:4:{s:5:\"label\";s:17:\"Thumbnail Preview\";s:11:\"field types\";a:1:{i:0;s:17:\"video_embed_field\";}s:8:\"settings\";a:4:{s:11:\"image_style\";s:0:\"\";s:11:\"description\";i:1;s:20:\"description_position\";s:6:\"bottom\";s:10:\"image_link\";s:4:\"none\";}s:6:\"module\";s:17:\"video_embed_field\";}s:33:\"i18n_taxonomy_term_reference_link\";a:4:{s:5:\"label\";s:16:\"Link (localized)\";s:11:\"field types\";a:1:{i:0;s:23:\"taxonomy_term_reference\";}s:8:\"settings\";a:0:{}s:6:\"module\";s:13:\"i18n_taxonomy\";}s:34:\"i18n_taxonomy_term_reference_plain\";a:4:{s:5:\"label\";s:22:\"Plain text (localized)\";s:11:\"field types\";a:1:{i:0;s:23:\"taxonomy_term_reference\";}s:8:\"settings\";a:0:{}s:6:\"module\";s:13:\"i18n_taxonomy\";}}s:13:\"storage types\";a:1:{s:17:\"field_sql_storage\";a:4:{s:5:\"label\";s:19:\"Default SQL storage\";s:11:\"description\";s:64:\"Stores fields in the local SQL database, using per-field tables.\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";}}}',0,1512620340,1);
/*!40000 ALTER TABLE `cache_field` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `cache_filter`
--

DROP TABLE IF EXISTS `cache_filter`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `cache_filter` (
  `cid` varchar(255) NOT NULL DEFAULT '' COMMENT 'Primary Key: Unique cache ID.',
  `data` longblob COMMENT 'A collection of data to cache.',
  `expire` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry should expire, or 0 for never.',
  `created` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry was created.',
  `serialized` smallint(6) NOT NULL DEFAULT '0' COMMENT 'A flag to indicate whether content is serialized (1) or not (0).',
  PRIMARY KEY (`cid`),
  KEY `expire` (`expire`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Cache table for the Filter module to store already...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `cache_filter`
--

LOCK TABLES `cache_filter` WRITE;
/*!40000 ALTER TABLE `cache_filter` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `cache_filter` VALUES ('filtered_html::25df0a6a9fcbdf2f4e21fb30db04c99215453d676ba6458075c1d2f9199bfe41','<p>We are a web development team with a concentration on open-source Content Management Systems (CMS), especially Drupal.</p>\n<p>We provide web services from small products: <a href=\"http://weebpal.com/drupal-themes\">Drupal themes</a>, modules...</p>\n',0,1512620340,0),('full_html::81ac769835714876d8a7bf3de8dce75e6c0b4ba9af7ae7336a959af7ca4b973d','<address><i class=\"fa fa-phone\"></i> (123) 123-4567<br /><i class=\"fa fa-map-marker\"></i> 7801 NW 15 Street<br />Ste #CO32314 Doral, Florida 33126<br /><i class=\"fa fa-envelope\"></i> <a href=\"mailto:contact@weebpal.com\">contact@weebpal.com</a></address>\n',0,1512620340,0),('full_html::8379ce4db76f854cd72ab5c20d0164f2c2584a419249d4e6d17dd0e81f191251','<p>Powered by <a href=\"http://drupal.org\" target=\"_blank\">Drupal</a>. Designed by <a href=\"http://weebpal.com\" target=\"_blank\">WeebPal Drupal Themes</a>. Copyright © 2014. All Rights Reserved.</p>\n',0,1512620340,0),('full_html::f0becde28d503510720cfa41370b4eccfe85ce92fddb17b7f8ef9b8daba36165','<ul class=\"social-list\"><li><a class=\"fa fa-facebook\" href=\"#\" title=\"Facebook\"><span>Facebook</span></a></li>\n<li><a class=\"fa fa-twitter\" href=\"#\" title=\"Twitter\"><span>Twitter</span></a></li>\n<li><a class=\"fa fa-google-plus\" href=\"#\" title=\"Google+\"><span>Google+</span></a></li>\n<li><a class=\"fa fa-pinterest\" href=\"#\" title=\"Pinterest\"><span>Pinterest</span></a></li>\n<li><a class=\"fa fa-rss\" href=\"#\" title=\"RSS\"><span>RSS</span></a></li>\n</ul>',0,1512620340,0);
/*!40000 ALTER TABLE `cache_filter` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `cache_form`
--

DROP TABLE IF EXISTS `cache_form`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `cache_form` (
  `cid` varchar(255) NOT NULL DEFAULT '' COMMENT 'Primary Key: Unique cache ID.',
  `data` longblob COMMENT 'A collection of data to cache.',
  `expire` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry should expire, or 0 for never.',
  `created` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry was created.',
  `serialized` smallint(6) NOT NULL DEFAULT '0' COMMENT 'A flag to indicate whether content is serialized (1) or not (0).',
  PRIMARY KEY (`cid`),
  KEY `expire` (`expire`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Cache table for the form system to store recently built...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `cache_form`
--

LOCK TABLES `cache_form` WRITE;
/*!40000 ALTER TABLE `cache_form` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `cache_form` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `cache_image`
--

DROP TABLE IF EXISTS `cache_image`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `cache_image` (
  `cid` varchar(255) NOT NULL DEFAULT '' COMMENT 'Primary Key: Unique cache ID.',
  `data` longblob COMMENT 'A collection of data to cache.',
  `expire` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry should expire, or 0 for never.',
  `created` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry was created.',
  `serialized` smallint(6) NOT NULL DEFAULT '0' COMMENT 'A flag to indicate whether content is serialized (1) or not (0).',
  PRIMARY KEY (`cid`),
  KEY `expire` (`expire`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Cache table used to store information about image...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `cache_image`
--

LOCK TABLES `cache_image` WRITE;
/*!40000 ALTER TABLE `cache_image` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `cache_image` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `cache_libraries`
--

DROP TABLE IF EXISTS `cache_libraries`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `cache_libraries` (
  `cid` varchar(255) NOT NULL DEFAULT '' COMMENT 'Primary Key: Unique cache ID.',
  `data` longblob COMMENT 'A collection of data to cache.',
  `expire` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry should expire, or 0 for never.',
  `created` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry was created.',
  `serialized` smallint(6) NOT NULL DEFAULT '0' COMMENT 'A flag to indicate whether content is serialized (1) or not (0).',
  PRIMARY KEY (`cid`),
  KEY `expire` (`expire`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Cache table to store library information.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `cache_libraries`
--

LOCK TABLES `cache_libraries` WRITE;
/*!40000 ALTER TABLE `cache_libraries` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `cache_libraries` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `cache_menu`
--

DROP TABLE IF EXISTS `cache_menu`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `cache_menu` (
  `cid` varchar(255) NOT NULL DEFAULT '' COMMENT 'Primary Key: Unique cache ID.',
  `data` longblob COMMENT 'A collection of data to cache.',
  `expire` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry should expire, or 0 for never.',
  `created` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry was created.',
  `serialized` smallint(6) NOT NULL DEFAULT '0' COMMENT 'A flag to indicate whether content is serialized (1) or not (0).',
  PRIMARY KEY (`cid`),
  KEY `expire` (`expire`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Cache table for the menu system to store router...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `cache_menu`
--

LOCK TABLES `cache_menu` WRITE;
/*!40000 ALTER TABLE `cache_menu` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `cache_menu` VALUES ('admin_menu:1:3QV5Ae0ANwuTwt8MXjAOg_CobIrc5KhTkGsHK1_UoJc:en','<div id=\"admin-menu\" class=\"admin-menu-site-forum-plus-local2-weebpal-com overlay-displace-top\"><div id=\"admin-menu-wrapper\">\n<ul id=\"admin-menu-icon\" class=\"dropdown\"><li class=\"admin-menu-icon admin-menu-toolbar-category expandable\"><a href=\"/en\"><span>Home</span></a>\n<ul class=\"dropdown\"><li><a href=\"/en/admin/index\">Index</a></li><li class=\"expandable\"><a href=\"/en/admin_menu/flush-cache?token=9_tZF0Tob66BPdn-cZnSiH49ZLAeef-8CUFU0dD3j2I\" class=\"admin-menu-destination\">Flush all caches</a>\n<ul class=\"dropdown\"><li><a href=\"/en/admin_menu/flush-cache/admin_menu?token=RRviA0TiEZul30l3xCIZsWurqiWmGpvGEz0y6_4mpz0\" class=\"admin-menu-destination\">Administration menu</a></li><li><a href=\"/en/admin_menu/flush-cache/registry?token=HOb3Z8EsIavHR-TU1PpJRMs-5p4YGd7CYJj_o1Ydhys\" class=\"admin-menu-destination\">Class registry</a></li><li><a href=\"/en/admin_menu/flush-cache/assets?token=8vAcFKLQFGSfU6bnsbPLkK1QfG48L33G4wjm6lpedYQ\" class=\"admin-menu-destination\">CSS and JavaScript</a></li><li><a href=\"/en/admin_menu/flush-cache/menu?token=qXiAn1kQVmKxr7ecvWJUlokR5O6JGJKBuTFsqtGqfVQ\" class=\"admin-menu-destination\">Menu</a></li><li><a href=\"/en/admin_menu/flush-cache/cache?token=p1cHXPGwJjRAh8PIBkrqL4mKITs_OqYw0TEuHqta-9o\" class=\"admin-menu-destination\">Page and else</a></li><li><a href=\"/en/admin_menu/flush-cache/theme?token=YZ7DK1UONvCEG1nU2JSY8bQPEe71m5cnD8wmBEgyNXs\" class=\"admin-menu-destination\">Theme registry</a></li><li><a href=\"/en/token/flush-cache?token=l0cIJkWw08d_geKag3d6Hj4cshu9oYaAVynbjfIGVco\" class=\"admin-menu-destination\">Token registry</a></li><li><a href=\"/en/admin_menu/flush-cache/update?token=Ded7RAQ4A6_glSRlhn9n8qjy1A5F7Zm6x0HmEsDpckc\" class=\"admin-menu-destination\">Update data</a></li></ul></li><li><a href=\"/en/admin/reports/status/run-cron\">Run cron</a></li><li><a href=\"/update.php\">Run updates</a></li><li class=\"expandable\"><a href=\"http://drupal.org\">Drupal.org</a>\n<ul class=\"dropdown\"><li><a href=\"http://drupal.org/project/issues/drupal?version=7.x\">Block issue queue</a></li><li><a href=\"http://drupal.org/project/issues/admin_menu?version=7.x\">Administration menu issue queue</a></li><li><a href=\"http://drupal.org/project/issues/advanced_forum?version=7.x\">Advanced Forum issue queue</a></li><li><a href=\"http://drupal.org/project/issues/author_pane?version=7.x\">Author Pane issue queue</a></li><li><a href=\"http://drupal.org/project/issues/block_class?version=7.x\">Block Class issue queue</a></li><li><a href=\"http://drupal.org/project/issues/calendar?version=7.x\">Calendar issue queue</a></li><li><a href=\"http://drupal.org/project/issues/ctools?version=7.x\">Chaos tools issue queue</a></li><li><a href=\"http://drupal.org/project/issues/chosen?version=7.x\">Chosen issue queue</a></li><li><a href=\"http://drupal.org/project/issues/ckeditor?version=7.x\">CKEditor issue queue</a></li><li><a href=\"http://drupal.org/project/issues/we_content_migration?version=7.x\">Content Migration issue queue</a></li><li><a href=\"http://drupal.org/project/issues/token_custom?version=7.x\">Custom tokens issue queue</a></li><li><a href=\"http://drupal.org/project/issues/date?version=7.x\">Date API issue queue</a></li><li><a href=\"http://drupal.org/project/issues/entity?version=7.x\">Entity API issue queue</a></li><li><a href=\"http://drupal.org/project/issues/entityreference?version=7.x\">Entity Reference issue queue</a></li><li><a href=\"http://drupal.org/project/issues/features?version=7.x\">Features issue queue</a></li><li><a href=\"http://drupal.org/project/issues/field_collection?version=7.x\">Field collection issue queue</a></li><li><a href=\"http://drupal.org/project/issues/field_group?version=7.x\">Field Group issue queue</a></li><li><a href=\"http://drupal.org/project/issues/fivestar?version=7.x\">Fivestar issue queue</a></li><li><a href=\"http://drupal.org/project/issues/flexslider?version=7.x\">FlexSlider issue queue</a></li><li><a href=\"http://drupal.org/project/issues/faq?version=7.x\">Frequently Asked Questions issue queue</a></li><li><a href=\"http://drupal.org/project/issues/jquery_update?version=7.x\">jQuery Update issue queue</a></li><li><a href=\"http://drupal.org/project/issues/languageicons?version=7.x\">Language Icons issue queue</a></li><li><a href=\"http://drupal.org/project/issues/lang_dropdown?version=7.x\">Language Switcher Dropdown issue queue</a></li><li><a href=\"http://drupal.org/project/issues/libraries?version=7.x\">Libraries issue queue</a></li><li><a href=\"http://drupal.org/project/issues/link?version=7.x\">Link issue queue</a></li><li><a href=\"http://drupal.org/project/issues/menu_breadcrumb?version=7.x\">Menu breadcrumb issue queue</a></li><li><a href=\"http://drupal.org/project/issues/message?version=7.x\">Message issue queue</a></li><li><a href=\"http://drupal.org/project/issues/modal_forms?version=7.x\">Modal forms issue queue</a></li><li><a href=\"http://drupal.org/project/issues/module_filter?version=7.x\">Module filter issue queue</a></li><li><a href=\"http://drupal.org/project/issues/node_class?version=7.x\">Node Class issue queue</a></li><li><a href=\"http://drupal.org/project/issues/pathauto?version=7.x\">Pathauto issue queue</a></li><li><a href=\"http://drupal.org/project/issues/quicktabs?version=7.x\">Quicktabs issue queue</a></li><li><a href=\"http://drupal.org/project/issues/remember_me?version=7.x\">Remember me issue queue</a></li><li><a href=\"http://drupal.org/project/issues/sharethis?version=7.x\">ShareThis issue queue</a></li><li><a href=\"http://drupal.org/project/issues/shortcode?version=7.x\">Shortcode issue queue</a></li><li><a href=\"http://drupal.org/project/issues/strongarm?version=7.x\">Strongarm issue queue</a></li><li><a href=\"http://drupal.org/project/issues/tagclouds?version=7.x\">TagClouds issue queue</a></li><li><a href=\"http://drupal.org/project/issues/taxonomy_menu?version=7.x\">Taxonomy menu issue queue</a></li><li><a href=\"http://drupal.org/project/issues/token?version=7.x\">Token issue queue</a></li><li><a href=\"http://drupal.org/project/issues/i18n?version=7.x\">Translation sets issue queue</a></li><li><a href=\"http://drupal.org/project/issues/variable?version=7.x\">Variable issue queue</a></li><li><a href=\"http://drupal.org/project/issues/video_embed_field?version=7.x\">Video Embed Field issue queue</a></li><li><a href=\"http://drupal.org/project/issues/views_fieldsets?version=7.x\">Views fieldsets issue queue</a></li><li><a href=\"http://drupal.org/project/issues/views_slideshow?version=7.x\">Views Slideshow issue queue</a></li><li><a href=\"http://drupal.org/project/issues/views?version=7.x\">Views UI issue queue</a></li><li><a href=\"http://drupal.org/project/issues/votingapi?version=7.x\">Voting API issue queue</a></li><li><a href=\"http://drupal.org/project/issues/webform_hints?version=7.x\">Webform Hints issue queue</a></li><li><a href=\"http://drupal.org/project/issues/webform?version=7.x\">Webform issue queue</a></li></ul></li></ul></li></ul>\n<ul id=\"admin-menu-menu\" class=\"dropdown\"><li class=\"admin-menu-toolbar-category\"><a href=\"/en/admin/dashboard\">Dashboard</a></li><li class=\"admin-menu-toolbar-category expandable\"><a href=\"/en/admin/content\">Content</a>\n<ul class=\"dropdown\"><li class=\"expandable\"><a href=\"/en/node/add\">Add content</a>\n<ul class=\"dropdown\"><li><a href=\"/en/node/add/article\">Article</a></li><li><a href=\"/en/node/add/page\">Basic page</a></li><li><a href=\"/en/node/add/blog\">Blog entry</a></li><li><a href=\"/en/node/add/book\">Book page</a></li><li><a href=\"/en/node/add/faq\">FAQ</a></li><li><a href=\"/en/node/add/forum\">Forum topic</a></li><li><a href=\"/en/node/add/products\">Products</a></li><li><a href=\"/en/node/add/video\">Video</a></li><li><a href=\"/en/node/add/webform\">Webform</a></li></ul></li><li class=\"expandable\"><a href=\"/en/admin/content/book\">Books</a>\n<ul class=\"dropdown\"><li><a href=\"/en/admin/content/book/settings\">Settings</a></li></ul></li><li class=\"expandable\"><a href=\"/en/admin/content/comment\">Comments</a>\n<ul class=\"dropdown\"><li><a href=\"/en/admin/content/comment/approval\">Unapproved comments (0)</a></li></ul></li><li><a href=\"/en/admin/content/message\">Messages</a></li><li><a href=\"/en/admin/content/webform\">Webforms</a></li></ul></li><li class=\"admin-menu-toolbar-category expandable\"><a href=\"/en/admin/structure\">Structure</a>\n<ul class=\"dropdown\"><li class=\"expandable\"><a href=\"/en/admin/structure/block\">Blocks</a>\n<ul class=\"dropdown\"><li><a href=\"/en/admin/structure/block/add\">Add block</a></li><li class=\"expandable\"><a href=\"/en/admin/structure/block/list/bartik\">Bartik</a>\n<ul class=\"dropdown\"><li><a href=\"/en/admin/structure/block/list/bartik/add\">Add block</a></li></ul></li><li class=\"expandable\"><a href=\"/en/admin/structure/block/list/seven\">Seven</a>\n<ul class=\"dropdown\"><li><a href=\"/en/admin/structure/block/list/seven/add\">Add block</a></li></ul></li><li class=\"expandable\"><a href=\"/en/admin/structure/block/list/we_backend\">WeebPal Backend theme</a>\n<ul class=\"dropdown\"><li><a href=\"/en/admin/structure/block/list/we_backend/add\">Add block</a></li></ul></li></ul></li><li class=\"expandable\"><a href=\"/en/admin/structure/contact\">Contact form</a>\n<ul class=\"dropdown\"><li><a href=\"/en/admin/structure/contact/add\">Add category</a></li></ul></li><li class=\"expandable\"><a href=\"/en/admin/structure/types\">Content types</a>\n<ul class=\"dropdown\"><li><a href=\"/en/admin/structure/types/add\">Add content type</a></li><li class=\"expandable\"><a href=\"/en/admin/structure/types/manage/article\">Article</a>\n<ul class=\"dropdown\"><li><a href=\"/en/admin/structure/types/manage/article/delete\">Delete</a></li><li class=\"expandable\"><a href=\"/en/admin/structure/types/manage/article/fields\">Manage fields</a>\n<ul class=\"dropdown\"><li class=\"expandable\"><a href=\"/en/admin/structure/types/manage/article/fields/body\">Body</a>\n<ul class=\"dropdown\"><li><a href=\"/en/admin/structure/types/manage/article/fields/body/field-settings\">Field settings</a></li><li><a href=\"/en/admin/structure/types/manage/article/fields/body/widget-type\">Widget type</a></li><li><a href=\"/en/admin/structure/types/manage/article/fields/body/delete\">Delete</a></li></ul></li><li class=\"expandable\"><a href=\"/en/admin/structure/types/manage/article/fields/field_category\">Category</a>\n<ul class=\"dropdown\"><li><a href=\"/en/admin/structure/types/manage/article/fields/field_category/field-settings\">Field settings</a></li><li><a href=\"/en/admin/structure/types/manage/article/fields/field_category/widget-type\">Widget type</a></li><li><a href=\"/en/admin/structure/types/manage/article/fields/field_category/delete\">Delete</a></li></ul></li><li class=\"expandable\"><a href=\"/en/admin/structure/types/manage/article/fields/field_extra_content\">Extra content</a>\n<ul class=\"dropdown\"><li><a href=\"/en/admin/structure/types/manage/article/fields/field_extra_content/field-settings\">Field settings</a></li><li><a href=\"/en/admin/structure/types/manage/article/fields/field_extra_content/widget-type\">Widget type</a></li><li><a href=\"/en/admin/structure/types/manage/article/fields/field_extra_content/delete\">Delete</a></li></ul></li><li class=\"expandable\"><a href=\"/en/admin/structure/types/manage/article/fields/field_image\">Image</a>\n<ul class=\"dropdown\"><li><a href=\"/en/admin/structure/types/manage/article/fields/field_image/field-settings\">Field settings</a></li><li><a href=\"/en/admin/structure/types/manage/article/fields/field_image/widget-type\">Widget type</a></li><li><a href=\"/en/admin/structure/types/manage/article/fields/field_image/delete\">Delete</a></li></ul></li><li class=\"expandable\"><a href=\"/en/admin/structure/types/manage/article/fields/field_section\">Section</a>\n<ul class=\"dropdown\"><li><a href=\"/en/admin/structure/types/manage/article/fields/field_section/field-settings\">Field settings</a></li><li><a href=\"/en/admin/structure/types/manage/article/fields/field_section/widget-type\">Widget type</a></li><li><a href=\"/en/admin/structure/types/manage/article/fields/field_section/delete\">Delete</a></li></ul></li><li class=\"expandable\"><a href=\"/en/admin/structure/types/manage/article/fields/field_tags\">Tags</a>\n<ul class=\"dropdown\"><li><a href=\"/en/admin/structure/types/manage/article/fields/field_tags/field-settings\">Field settings</a></li><li><a href=\"/en/admin/structure/types/manage/article/fields/field_tags/widget-type\">Widget type</a></li><li><a href=\"/en/admin/structure/types/manage/article/fields/field_tags/delete\">Delete</a></li></ul></li></ul></li><li class=\"expandable\"><a href=\"/en/admin/structure/types/manage/article/display\">Manage display</a>\n<ul class=\"dropdown\"><li><a href=\"/en/admin/structure/types/manage/article/display/teaser\">Teaser</a></li></ul></li></ul></li><li class=\"expandable\"><a href=\"/en/admin/structure/types/manage/page\">Basic page</a>\n<ul class=\"dropdown\"><li><a href=\"/en/admin/structure/types/manage/page/delete\">Delete</a></li><li class=\"expandable\"><a href=\"/en/admin/structure/types/manage/page/fields\">Manage fields</a>\n<ul class=\"dropdown\"><li class=\"expandable\"><a href=\"/en/admin/structure/types/manage/page/fields/body\">Body</a>\n<ul class=\"dropdown\"><li><a href=\"/en/admin/structure/types/manage/page/fields/body/field-settings\">Field settings</a></li><li><a href=\"/en/admin/structure/types/manage/page/fields/body/widget-type\">Widget type</a></li><li><a href=\"/en/admin/structure/types/manage/page/fields/body/delete\">Delete</a></li></ul></li></ul></li><li class=\"expandable\"><a href=\"/en/admin/structure/types/manage/page/display\">Manage display</a>\n<ul class=\"dropdown\"><li><a href=\"/en/admin/structure/types/manage/page/display/teaser\">Teaser</a></li></ul></li></ul></li><li class=\"expandable\"><a href=\"/en/admin/structure/types/manage/blog\">Blog entry</a>\n<ul class=\"dropdown\"><li><a href=\"/en/admin/structure/types/manage/blog/delete\">Delete</a></li><li class=\"expandable\"><a href=\"/en/admin/structure/types/manage/blog/fields\">Manage fields</a>\n<ul class=\"dropdown\"><li class=\"expandable\"><a href=\"/en/admin/structure/types/manage/blog/fields/body\">Body</a>\n<ul class=\"dropdown\"><li><a href=\"/en/admin/structure/types/manage/blog/fields/body/field-settings\">Field settings</a></li><li><a href=\"/en/admin/structure/types/manage/blog/fields/body/widget-type\">Widget type</a></li><li><a href=\"/en/admin/structure/types/manage/blog/fields/body/delete\">Delete</a></li></ul></li><li class=\"expandable\"><a href=\"/en/admin/structure/types/manage/blog/fields/field_extra_content\">Extra content</a>\n<ul class=\"dropdown\"><li><a href=\"/en/admin/structure/types/manage/blog/fields/field_extra_content/field-settings\">Field settings</a></li><li><a href=\"/en/admin/structure/types/manage/blog/fields/field_extra_content/widget-type\">Widget type</a></li><li><a href=\"/en/admin/structure/types/manage/blog/fields/field_extra_content/delete\">Delete</a></li></ul></li><li class=\"expandable\"><a href=\"/en/admin/structure/types/manage/blog/fields/field_image\">Image</a>\n<ul class=\"dropdown\"><li><a href=\"/en/admin/structure/types/manage/blog/fields/field_image/field-settings\">Field settings</a></li><li><a href=\"/en/admin/structure/types/manage/blog/fields/field_image/widget-type\">Widget type</a></li><li><a href=\"/en/admin/structure/types/manage/blog/fields/field_image/delete\">Delete</a></li></ul></li><li class=\"expandable\"><a href=\"/en/admin/structure/types/manage/blog/fields/field_tags\">Tags</a>\n<ul class=\"dropdown\"><li><a href=\"/en/admin/structure/types/manage/blog/fields/field_tags/field-settings\">Field settings</a></li><li><a href=\"/en/admin/structure/types/manage/blog/fields/field_tags/widget-type\">Widget type</a></li><li><a href=\"/en/admin/structure/types/manage/blog/fields/field_tags/delete\">Delete</a></li></ul></li><li class=\"expandable\"><a href=\"/en/admin/structure/types/manage/blog/fields/field_vote\">Vote</a>\n<ul class=\"dropdown\"><li><a href=\"/en/admin/structure/types/manage/blog/fields/field_vote/field-settings\">Field settings</a></li><li><a href=\"/en/admin/structure/types/manage/blog/fields/field_vote/widget-type\">Widget type</a></li><li><a href=\"/en/admin/structure/types/manage/blog/fields/field_vote/delete\">Delete</a></li></ul></li></ul></li><li class=\"expandable\"><a href=\"/en/admin/structure/types/manage/blog/display\">Manage display</a>\n<ul class=\"dropdown\"><li><a href=\"/en/admin/structure/types/manage/blog/display/teaser\">Teaser</a></li></ul></li></ul></li><li class=\"expandable\"><a href=\"/en/admin/structure/types/manage/book\">Book page</a>\n<ul class=\"dropdown\"><li><a href=\"/en/admin/structure/types/manage/book/delete\">Delete</a></li><li class=\"expandable\"><a href=\"/en/admin/structure/types/manage/book/fields\">Manage fields</a>\n<ul class=\"dropdown\"><li class=\"expandable\"><a href=\"/en/admin/structure/types/manage/book/fields/body\">Body</a>\n<ul class=\"dropdown\"><li><a href=\"/en/admin/structure/types/manage/book/fields/body/field-settings\">Field settings</a></li><li><a href=\"/en/admin/structure/types/manage/book/fields/body/widget-type\">Widget type</a></li><li><a href=\"/en/admin/structure/types/manage/book/fields/body/delete\">Delete</a></li></ul></li></ul></li><li class=\"expandable\"><a href=\"/en/admin/structure/types/manage/book/display\">Manage display</a>\n<ul class=\"dropdown\"><li><a href=\"/en/admin/structure/types/manage/book/display/teaser\">Teaser</a></li></ul></li></ul></li><li class=\"expandable\"><a href=\"/en/admin/structure/types/manage/faq\">FAQ</a>\n<ul class=\"dropdown\"><li><a href=\"/en/admin/structure/types/manage/faq/delete\">Delete</a></li><li class=\"expandable\"><a href=\"/en/admin/structure/types/manage/faq/fields\">Manage fields</a>\n<ul class=\"dropdown\"><li class=\"expandable\"><a href=\"/en/admin/structure/types/manage/faq/fields/body\">Body</a>\n<ul class=\"dropdown\"><li><a href=\"/en/admin/structure/types/manage/faq/fields/body/field-settings\">Field settings</a></li><li><a href=\"/en/admin/structure/types/manage/faq/fields/body/widget-type\">Widget type</a></li><li><a href=\"/en/admin/structure/types/manage/faq/fields/body/delete\">Delete</a></li></ul></li><li class=\"expandable\"><a href=\"/en/admin/structure/types/manage/faq/fields/field_detailed_question\">Detailed question</a>\n<ul class=\"dropdown\"><li><a href=\"/en/admin/structure/types/manage/faq/fields/field_detailed_question/field-settings\">Field settings</a></li><li><a href=\"/en/admin/structure/types/manage/faq/fields/field_detailed_question/widget-type\">Widget type</a></li><li><a href=\"/en/admin/structure/types/manage/faq/fields/field_detailed_question/delete\">Delete</a></li></ul></li></ul></li><li class=\"expandable\"><a href=\"/en/admin/structure/types/manage/faq/display\">Manage display</a>\n<ul class=\"dropdown\"><li><a href=\"/en/admin/structure/types/manage/faq/display/teaser\">Teaser</a></li></ul></li></ul></li><li class=\"expandable\"><a href=\"/en/admin/structure/types/manage/forum\">Forum topic</a>\n<ul class=\"dropdown\"><li><a href=\"/en/admin/structure/types/manage/forum/delete\">Delete</a></li><li class=\"expandable\"><a href=\"/en/admin/structure/types/manage/forum/fields\">Manage fields</a>\n<ul class=\"dropdown\"><li class=\"expandable\"><a href=\"/en/admin/structure/types/manage/forum/fields/body\">Body</a>\n<ul class=\"dropdown\"><li><a href=\"/en/admin/structure/types/manage/forum/fields/body/field-settings\">Field settings</a></li><li><a href=\"/en/admin/structure/types/manage/forum/fields/body/widget-type\">Widget type</a></li><li><a href=\"/en/admin/structure/types/manage/forum/fields/body/delete\">Delete</a></li></ul></li><li class=\"expandable\"><a href=\"/en/admin/structure/types/manage/forum/fields/field_extra_content\">Extra content</a>\n<ul class=\"dropdown\"><li><a href=\"/en/admin/structure/types/manage/forum/fields/field_extra_content/field-settings\">Field settings</a></li><li><a href=\"/en/admin/structure/types/manage/forum/fields/field_extra_content/widget-type\">Widget type</a></li><li><a href=\"/en/admin/structure/types/manage/forum/fields/field_extra_content/delete\">Delete</a></li></ul></li><li class=\"expandable\"><a href=\"/en/admin/structure/types/manage/forum/fields/taxonomy_forums\">Forums</a>\n<ul class=\"dropdown\"><li><a href=\"/en/admin/structure/types/manage/forum/fields/taxonomy_forums/field-settings\">Field settings</a></li><li><a href=\"/en/admin/structure/types/manage/forum/fields/taxonomy_forums/widget-type\">Widget type</a></li><li><a href=\"/en/admin/structure/types/manage/forum/fields/taxonomy_forums/delete\">Delete</a></li></ul></li><li class=\"expandable\"><a href=\"/en/admin/structure/types/manage/forum/fields/field_vote\">Vote</a>\n<ul class=\"dropdown\"><li><a href=\"/en/admin/structure/types/manage/forum/fields/field_vote/field-settings\">Field settings</a></li><li><a href=\"/en/admin/structure/types/manage/forum/fields/field_vote/widget-type\">Widget type</a></li><li><a href=\"/en/admin/structure/types/manage/forum/fields/field_vote/delete\">Delete</a></li></ul></li></ul></li><li class=\"expandable\"><a href=\"/en/admin/structure/types/manage/forum/display\">Manage display</a>\n<ul class=\"dropdown\"><li><a href=\"/en/admin/structure/types/manage/forum/display/teaser\">Teaser</a></li></ul></li></ul></li><li class=\"expandable\"><a href=\"/en/admin/structure/types/manage/products\">Products</a>\n<ul class=\"dropdown\"><li><a href=\"/en/admin/structure/types/manage/products/delete\">Delete</a></li><li class=\"expandable\"><a href=\"/en/admin/structure/types/manage/products/fields\">Manage fields</a>\n<ul class=\"dropdown\"><li class=\"expandable\"><a href=\"/en/admin/structure/types/manage/products/fields/body\">Body</a>\n<ul class=\"dropdown\"><li><a href=\"/en/admin/structure/types/manage/products/fields/body/field-settings\">Field settings</a></li><li><a href=\"/en/admin/structure/types/manage/products/fields/body/widget-type\">Widget type</a></li><li><a href=\"/en/admin/structure/types/manage/products/fields/body/delete\">Delete</a></li></ul></li><li class=\"expandable\"><a href=\"/en/admin/structure/types/manage/products/fields/field_image\">Image</a>\n<ul class=\"dropdown\"><li><a href=\"/en/admin/structure/types/manage/products/fields/field_image/field-settings\">Field settings</a></li><li><a href=\"/en/admin/structure/types/manage/products/fields/field_image/widget-type\">Widget type</a></li><li><a href=\"/en/admin/structure/types/manage/products/fields/field_image/delete\">Delete</a></li></ul></li><li class=\"expandable\"><a href=\"/en/admin/structure/types/manage/products/fields/field_link\">Link</a>\n<ul class=\"dropdown\"><li><a href=\"/en/admin/structure/types/manage/products/fields/field_link/field-settings\">Field settings</a></li><li><a href=\"/en/admin/structure/types/manage/products/fields/field_link/widget-type\">Widget type</a></li><li><a href=\"/en/admin/structure/types/manage/products/fields/field_link/delete\">Delete</a></li></ul></li></ul></li><li class=\"expandable\"><a href=\"/en/admin/structure/types/manage/products/display\">Manage display</a>\n<ul class=\"dropdown\"><li><a href=\"/en/admin/structure/types/manage/products/display/teaser\">Teaser</a></li></ul></li></ul></li><li class=\"expandable\"><a href=\"/en/admin/structure/types/manage/video\">Video</a>\n<ul class=\"dropdown\"><li><a href=\"/en/admin/structure/types/manage/video/delete\">Delete</a></li><li class=\"expandable\"><a href=\"/en/admin/structure/types/manage/video/fields\">Manage fields</a>\n<ul class=\"dropdown\"><li class=\"expandable\"><a href=\"/en/admin/structure/types/manage/video/fields/body\">Body</a>\n<ul class=\"dropdown\"><li><a href=\"/en/admin/structure/types/manage/video/fields/body/field-settings\">Field settings</a></li><li><a href=\"/en/admin/structure/types/manage/video/fields/body/widget-type\">Widget type</a></li><li><a href=\"/en/admin/structure/types/manage/video/fields/body/delete\">Delete</a></li></ul></li><li class=\"expandable\"><a href=\"/en/admin/structure/types/manage/video/fields/field_tags\">Tags</a>\n<ul class=\"dropdown\"><li><a href=\"/en/admin/structure/types/manage/video/fields/field_tags/field-settings\">Field settings</a></li><li><a href=\"/en/admin/structure/types/manage/video/fields/field_tags/widget-type\">Widget type</a></li><li><a href=\"/en/admin/structure/types/manage/video/fields/field_tags/delete\">Delete</a></li></ul></li><li class=\"expandable\"><a href=\"/en/admin/structure/types/manage/video/fields/field_video_link\">Video Link</a>\n<ul class=\"dropdown\"><li><a href=\"/en/admin/structure/types/manage/video/fields/field_video_link/field-settings\">Field settings</a></li><li><a href=\"/en/admin/structure/types/manage/video/fields/field_video_link/widget-type\">Widget type</a></li><li><a href=\"/en/admin/structure/types/manage/video/fields/field_video_link/delete\">Delete</a></li></ul></li></ul></li><li class=\"expandable\"><a href=\"/en/admin/structure/types/manage/video/display\">Manage display</a>\n<ul class=\"dropdown\"><li><a href=\"/en/admin/structure/types/manage/video/display/teaser\">Teaser</a></li></ul></li></ul></li><li class=\"expandable\"><a href=\"/en/admin/structure/types/manage/webform\">Webform</a>\n<ul class=\"dropdown\"><li><a href=\"/en/admin/structure/types/manage/webform/delete\">Delete</a></li><li class=\"expandable\"><a href=\"/en/admin/structure/types/manage/webform/fields\">Manage fields</a>\n<ul class=\"dropdown\"><li class=\"expandable\"><a href=\"/en/admin/structure/types/manage/webform/fields/body\">Body</a>\n<ul class=\"dropdown\"><li><a href=\"/en/admin/structure/types/manage/webform/fields/body/field-settings\">Field settings</a></li><li><a href=\"/en/admin/structure/types/manage/webform/fields/body/widget-type\">Widget type</a></li><li><a href=\"/en/admin/structure/types/manage/webform/fields/body/delete\">Delete</a></li></ul></li></ul></li><li class=\"expandable\"><a href=\"/en/admin/structure/types/manage/webform/display\">Manage display</a>\n<ul class=\"dropdown\"><li><a href=\"/en/admin/structure/types/manage/webform/display/teaser\">Teaser</a></li></ul></li></ul></li></ul></li><li class=\"expandable\"><a href=\"/en/admin/structure/token-custom\">Custom tokens</a>\n<ul class=\"dropdown\"><li><a href=\"/en/admin/structure/token-custom/add\">Add token</a></li><li class=\"expandable\"><a href=\"/en/admin/structure/token-custom/type\">Custom token types</a>\n<ul class=\"dropdown\"><li><a href=\"/en/admin/structure/token-custom/type/add\">Add token type</a></li></ul></li></ul></li><li class=\"expandable\"><a href=\"/en/admin/structure/features\">Features</a>\n<ul class=\"dropdown\"><li><a href=\"/en/admin/structure/features/create\">Create feature</a></li><li><a href=\"/en/admin/structure/features/settings\">Settings</a></li></ul></li><li><a href=\"/en/admin/structure/field-collections\">Field collections</a></li><li class=\"expandable\"><a href=\"/en/admin/structure/forum\">Forums</a>\n<ul class=\"dropdown\"><li><a href=\"/en/admin/structure/forum/add/container\">Add container</a></li><li><a href=\"/en/admin/structure/forum/add/forum\">Add forum</a></li><li><a href=\"/en/admin/structure/forum/settings\">Settings</a></li></ul></li><li class=\"expandable\"><a href=\"/en/admin/structure/menu\">Menus</a>\n<ul class=\"dropdown\"><li><a href=\"/en/admin/structure/menu/add\">Add menu</a></li><li class=\"expandable\"><a href=\"/en/admin/structure/menu/manage/menu-categories\">Categories</a>\n<ul class=\"dropdown\"><li><a href=\"/en/admin/structure/menu/manage/menu-categories/add\">Add link</a></li><li><a href=\"/en/admin/structure/menu/manage/menu-categories/delete\">Delete menu</a></li><li><a href=\"/en/admin/structure/menu/manage/menu-categories/edit\">Edit menu</a></li></ul></li><li class=\"expandable\"><a href=\"/en/admin/structure/menu/manage/features\">Features</a>\n<ul class=\"dropdown\"><li><a href=\"/en/admin/structure/menu/manage/features/add\">Add link</a></li><li><a href=\"/en/admin/structure/menu/manage/features/delete\">Delete menu</a></li><li><a href=\"/en/admin/structure/menu/manage/features/edit\">Edit menu</a></li></ul></li><li class=\"expandable\"><a href=\"/en/admin/structure/menu/manage/menu-footer-menu\">Footer menu</a>\n<ul class=\"dropdown\"><li><a href=\"/en/admin/structure/menu/manage/menu-footer-menu/add\">Add link</a></li><li><a href=\"/en/admin/structure/menu/manage/menu-footer-menu/delete\">Delete menu</a></li><li><a href=\"/en/admin/structure/menu/manage/menu-footer-menu/edit\">Edit menu</a></li></ul></li><li class=\"expandable\"><a href=\"/en/admin/structure/menu/manage/menu-links\">Links</a>\n<ul class=\"dropdown\"><li><a href=\"/en/admin/structure/menu/manage/menu-links/add\">Add link</a></li><li><a href=\"/en/admin/structure/menu/manage/menu-links/delete\">Delete menu</a></li><li><a href=\"/en/admin/structure/menu/manage/menu-links/edit\">Edit menu</a></li></ul></li><li class=\"expandable\"><a href=\"/en/admin/structure/menu/manage/main-menu\">Main menu</a>\n<ul class=\"dropdown\"><li><a href=\"/en/admin/structure/menu/manage/main-menu/add\">Add link</a></li><li><a href=\"/en/admin/structure/menu/manage/main-menu/delete\">Delete menu</a></li><li><a href=\"/en/admin/structure/menu/manage/main-menu/edit\">Edit menu</a></li></ul></li><li class=\"expandable\"><a href=\"/en/admin/structure/menu/manage/management\">Management</a>\n<ul class=\"dropdown\"><li><a href=\"/en/admin/structure/menu/manage/management/add\">Add link</a></li><li><a href=\"/en/admin/structure/menu/manage/management/delete\">Delete menu</a></li><li><a href=\"/en/admin/structure/menu/manage/management/edit\">Edit menu</a></li></ul></li><li class=\"expandable\"><a href=\"/en/admin/structure/menu/manage/navigation\">Navigation</a>\n<ul class=\"dropdown\"><li><a href=\"/en/admin/structure/menu/manage/navigation/add\">Add link</a></li><li><a href=\"/en/admin/structure/menu/manage/navigation/delete\">Delete menu</a></li><li><a href=\"/en/admin/structure/menu/manage/navigation/edit\">Edit menu</a></li></ul></li><li class=\"expandable\"><a href=\"/en/admin/structure/menu/manage/menu-sections\">Sections</a>\n<ul class=\"dropdown\"><li><a href=\"/en/admin/structure/menu/manage/menu-sections/add\">Add link</a></li><li><a href=\"/en/admin/structure/menu/manage/menu-sections/delete\">Delete menu</a></li><li><a href=\"/en/admin/structure/menu/manage/menu-sections/edit\">Edit menu</a></li></ul></li><li class=\"expandable\"><a href=\"/en/admin/structure/menu/manage/user-menu\">User menu</a>\n<ul class=\"dropdown\"><li><a href=\"/en/admin/structure/menu/manage/user-menu/add\">Add link</a></li><li><a href=\"/en/admin/structure/menu/manage/user-menu/delete\">Delete menu</a></li><li><a href=\"/en/admin/structure/menu/manage/user-menu/edit\">Edit menu</a></li></ul></li><li><a href=\"/en/admin/structure/menu/settings\">Settings</a></li></ul></li><li class=\"expandable\"><a href=\"/en/admin/structure/messages\">Message types</a>\n<ul class=\"dropdown\"><li><a href=\"/en/admin/structure/messages/add\">Add message type</a></li><li><a href=\"/en/admin/structure/messages/import\">Import message type</a></li></ul></li><li class=\"expandable\"><a href=\"/en/admin/structure/migrate_content\">Migrate Content</a>\n<ul class=\"dropdown\"><li><a href=\"/en/admin/structure/migrate_content/create\">Create</a></li><li><a href=\"/en/admin/structure/migrate_content/import-from-upload\">Import</a></li><li><a href=\"/en/admin/structure/migrate_content/settings\">Settings</a></li></ul></li><li class=\"expandable\"><a href=\"/en/admin/structure/quicktabs\">Quicktabs</a>\n<ul class=\"dropdown\"><li><a href=\"/en/admin/structure/quicktabs/add\">Add Quicktabs Instance</a></li></ul></li><li class=\"expandable\"><a href=\"/en/admin/structure/taxonomy\">Taxonomy</a>\n<ul class=\"dropdown\"><li><a href=\"/en/admin/structure/taxonomy/add\">Add vocabulary</a></li><li class=\"expandable\"><a href=\"/en/admin/structure/taxonomy/categories\">Categories</a>\n<ul class=\"dropdown\"><li><a href=\"/en/admin/structure/taxonomy/categories/add\">Add term</a></li><li><a href=\"/en/admin/structure/taxonomy/categories/edit\">Edit</a></li><li><a href=\"/en/admin/structure/taxonomy/categories/fields\">Manage fields</a></li><li><a href=\"/en/admin/structure/taxonomy/categories/display\">Manage display</a></li><li><a href=\"/en/admin/structure/taxonomy/categories/translate\">Translate</a></li></ul></li><li class=\"expandable\"><a href=\"/en/admin/structure/taxonomy/forums\">Forums</a>\n<ul class=\"dropdown\"><li><a href=\"/en/admin/structure/taxonomy/forums/add\">Add term</a></li><li><a href=\"/en/admin/structure/taxonomy/forums/edit\">Edit</a></li><li><a href=\"/en/admin/structure/taxonomy/forums/fields\">Manage fields</a></li><li><a href=\"/en/admin/structure/taxonomy/forums/display\">Manage display</a></li><li><a href=\"/en/admin/structure/taxonomy/forums/translate\">Translate</a></li></ul></li><li class=\"expandable\"><a href=\"/en/admin/structure/taxonomy/sections\">Sections</a>\n<ul class=\"dropdown\"><li><a href=\"/en/admin/structure/taxonomy/sections/add\">Add term</a></li><li><a href=\"/en/admin/structure/taxonomy/sections/edit\">Edit</a></li><li><a href=\"/en/admin/structure/taxonomy/sections/fields\">Manage fields</a></li><li><a href=\"/en/admin/structure/taxonomy/sections/display\">Manage display</a></li><li><a href=\"/en/admin/structure/taxonomy/sections/translate\">Translate</a></li></ul></li><li class=\"expandable\"><a href=\"/en/admin/structure/taxonomy/tags\">Tags</a>\n<ul class=\"dropdown\"><li><a href=\"/en/admin/structure/taxonomy/tags/add\">Add term</a></li><li><a href=\"/en/admin/structure/taxonomy/tags/edit\">Edit</a></li><li><a href=\"/en/admin/structure/taxonomy/tags/fields\">Manage fields</a></li><li><a href=\"/en/admin/structure/taxonomy/tags/display\">Manage display</a></li><li><a href=\"/en/admin/structure/taxonomy/tags/translate\">Translate</a></li></ul></li></ul></li><li class=\"expandable\"><a href=\"/en/admin/structure/views\">Views</a>\n<ul class=\"dropdown\"><li><a href=\"/en/admin/structure/views/add\">Add new view</a></li><li><a href=\"/en/admin/structure/views/add-template\">Add view from template</a></li><li><a href=\"/en/admin/structure/views/import\">Import</a></li><li><a href=\"/en/admin/structure/views/view/activity_stream\">Activity Stream (Message)</a></li><li><a href=\"/en/admin/structure/views/view/advanced_forum_active_topics\">Advanced Forum active topics (Content)</a></li><li><a href=\"/en/admin/structure/views/view/advanced_forum_new_topics\">Advanced Forum new topics (Content)</a></li><li><a href=\"/en/admin/structure/views/view/advanced_forum_search\">Advanced Forum Search (Content)</a></li><li><a href=\"/en/admin/structure/views/view/advanced_forum_topic_list\">Advanced Forum topic list (Content)</a></li><li><a href=\"/en/admin/structure/views/view/advanced_forum_unanswered_topics\">Advanced Forum unanswered topics (Content)</a></li><li><a href=\"/en/admin/structure/views/view/archive\">Archive (Content)</a></li><li><a href=\"/en/admin/structure/views/view/articles\">Articles (Content)</a></li><li><a href=\"/en/admin/structure/views/view/blogs\">Blogs (Content)</a></li><li><a href=\"/en/admin/structure/views/view/calendar\">Calendar (Content)</a></li><li><a href=\"/en/admin/structure/views/view/comments\">Comments (Comment)</a></li><li><a href=\"/en/admin/structure/views/view/faq\">FAQ (Content)</a></li><li><a href=\"/en/admin/structure/views/view/get_products\">Get Products (Content)</a></li><li><a href=\"/en/admin/structure/views/view/hot_video\">Hot Video (Content)</a></li><li><a href=\"/en/admin/structure/views/view/message\">Message (Message)</a></li><li><a href=\"/en/admin/structure/views/view/message_example\">Message example (Message)</a></li><li><a href=\"/en/admin/structure/views/view/new_forum_posts\">New Forum Posts (Content)</a></li><li><a href=\"/en/admin/structure/views/view/recent_blogs\">Recent Blogs (Content)</a></li><li><a href=\"/en/admin/structure/views/view/recent_topics\">Recent Topics (Content)</a></li><li class=\"expandable\"><a href=\"/en/admin/structure/views/settings\">Settings</a>\n<ul class=\"dropdown\"><li><a href=\"/en/admin/structure/views/settings/advanced\">Advanced</a></li></ul></li><li><a href=\"/en/admin/structure/views/view/webform_analysis\">Webform Analysis (Webform submissions)</a></li><li><a href=\"/en/admin/structure/views/view/webform_results\">Webform Results (Webform submissions)</a></li><li><a href=\"/en/admin/structure/views/view/webform_webforms\">Webforms (Webform nodes)</a></li><li><a href=\"/en/admin/structure/views/view/webform_submissions\">Webform Submissions (Webform submissions)</a></li><li><a href=\"/en/admin/structure/views/view/what_is_news\">What is news (Content)</a></li></ul></li></ul></li><li class=\"admin-menu-toolbar-category expandable\"><a href=\"/en/admin/appearance\">Appearance</a>\n<ul class=\"dropdown\"><li><a href=\"/en/admin/appearance/install\">Install new theme</a></li><li><a href=\"/en/admin/appearance/update\">Update</a></li><li class=\"expandable\"><a href=\"/en/admin/appearance/settings\">Settings</a>\n<ul class=\"dropdown\"><li><a href=\"/en/admin/appearance/settings/bartik\">Bartik</a></li><li><a href=\"/en/admin/appearance/settings/forum_plus\">Forum Plus</a></li><li><a href=\"/en/admin/appearance/settings/seven\">Seven</a></li><li><a href=\"/en/admin/appearance/settings/we_backend\">WeebPal Backend theme</a></li></ul></li></ul></li><li class=\"admin-menu-toolbar-category expandable\"><a href=\"/en/admin/people\">People</a>\n<ul class=\"dropdown\"><li><a href=\"/en/admin/people/create\">Add user</a></li><li class=\"expandable\"><a href=\"/en/admin/people/permissions\">Permissions</a>\n<ul class=\"dropdown\"><li><a href=\"/en/admin/people/permissions/roles\">Roles</a></li></ul></li></ul></li><li class=\"admin-menu-toolbar-category expandable\"><a href=\"/en/admin/modules\">Modules</a>\n<ul class=\"dropdown\"><li><a href=\"/en/admin/modules/install\">Install new module</a></li><li><a href=\"/en/admin/modules/update\">Update</a></li><li><a href=\"/en/admin/modules/uninstall\">Uninstall</a></li></ul></li><li class=\"admin-menu-toolbar-category expandable\"><a href=\"/en/admin/config\">Configuration</a>\n<ul class=\"dropdown\"><li class=\"expandable\"><a href=\"/en/admin/config/administration\">Administration</a>\n<ul class=\"dropdown\"><li><a href=\"/en/admin/config/administration/admin_menu\">Administration menu</a></li></ul></li><li class=\"expandable\"><a href=\"/en/admin/config/content\">Content authoring</a>\n<ul class=\"dropdown\"><li><a href=\"/en/admin/config/content/advanced-forum\">Advanced Forum</a></li><li><a href=\"/en/admin/config/content/ckeditor\">CKEditor</a></li><li><a href=\"/en/admin/config/content/fivestar\">Fivestar</a></li><li class=\"expandable\"><a href=\"/en/admin/config/content/faq\">Frequently Asked Questions</a>\n<ul class=\"dropdown\"><li><a href=\"/en/admin/config/content/faq/questions\">Questions</a></li><li><a href=\"/en/admin/config/content/faq/categories\">Categories</a></li></ul></li><li><a href=\"/en/admin/config/content/tagclouds\">TagClouds configuration</a></li><li class=\"expandable\"><a href=\"/en/admin/config/content/formats\">Text formats</a>\n<ul class=\"dropdown\"><li><a href=\"/en/admin/config/content/formats/add\">Add text format</a></li><li class=\"expandable\"><a href=\"/en/admin/config/content/formats/filtered_html\">Filtered HTML</a>\n<ul class=\"dropdown\"><li><a href=\"/en/admin/config/content/formats/filtered_html/disable\">Disable text format</a></li></ul></li><li class=\"expandable\"><a href=\"/en/admin/config/content/formats/full_html\">Full HTML</a>\n<ul class=\"dropdown\"><li><a href=\"/en/admin/config/content/formats/full_html/disable\">Disable text format</a></li></ul></li><li class=\"expandable\"><a href=\"/en/admin/config/content/formats/php_code\">PHP code</a>\n<ul class=\"dropdown\"><li><a href=\"/en/admin/config/content/formats/php_code/disable\">Disable text format</a></li></ul></li><li><a href=\"/en/admin/config/content/formats/plain_text\">Plain text</a></li></ul></li><li><a href=\"/en/admin/config/content/webform-hints\">Webform Hints settings</a></li><li><a href=\"/en/admin/config/content/webform\">Webform settings</a></li></ul></li><li class=\"expandable\"><a href=\"/en/admin/config/date\">Date API</a>\n<ul class=\"dropdown\"><li><a href=\"/en/admin/config/date/calendar\">Calendar</a></li></ul></li><li class=\"expandable\"><a href=\"/en/admin/config/development\">Development</a>\n<ul class=\"dropdown\"><li><a href=\"/en/admin/config/development/performance\">Performance</a></li><li><a href=\"/en/admin/config/development/logging\">Logging and errors</a></li><li><a href=\"/en/admin/config/development/maintenance\">Maintenance mode</a></li><li><a href=\"/en/admin/config/development/jquery_update\">jQuery update</a></li><li><a href=\"/en/admin/config/development/modal_forms\">Modal forms</a></li><li><a href=\"/en/admin/config/development/strongarm\">Strongarm</a></li></ul></li><li class=\"expandable\"><a href=\"/en/admin/config/media\">Media</a>\n<ul class=\"dropdown\"><li><a href=\"/en/admin/config/media/file-system\">File system</a></li><li class=\"expandable\"><a href=\"/en/admin/config/media/flexslider\">FlexSlider</a>\n<ul class=\"dropdown\"><li><a href=\"/en/admin/config/media/flexslider/add\">Add</a></li><li><a href=\"/en/admin/config/media/flexslider/import\">Import</a></li><li><a href=\"/en/admin/config/media/flexslider/advanced\">Advanced settings</a></li></ul></li><li class=\"expandable\"><a href=\"/en/admin/config/media/image-styles\">Image styles</a>\n<ul class=\"dropdown\"><li><a href=\"/en/admin/config/media/image-styles/add\">Add style</a></li></ul></li><li class=\"expandable\"><a href=\"/en/admin/config/media/vef\">Video Embed Field</a>\n<ul class=\"dropdown\"><li><a href=\"/en/admin/config/media/vef/settings\">Settings</a></li><li class=\"expandable\"><a href=\"/en/admin/config/media/vef/vef_video_styles\">Video Embed Styles</a>\n<ul class=\"dropdown\"><li><a href=\"/en/admin/config/media/vef/vef_video_styles/add\">Add</a></li><li><a href=\"/en/admin/config/media/vef/vef_video_styles/import\">Import</a></li></ul></li></ul></li><li><a href=\"/en/admin/config/media/image-toolkit\">Image toolkit</a></li></ul></li><li class=\"expandable\"><a href=\"/en/admin/config/people\">People</a>\n<ul class=\"dropdown\"><li class=\"expandable\"><a href=\"/en/admin/config/people/accounts\">Account settings</a>\n<ul class=\"dropdown\"><li><a href=\"/en/admin/config/people/accounts/fields\">Manage fields</a></li><li><a href=\"/en/admin/config/people/accounts/display\">Manage display</a></li></ul></li><li><a href=\"/en/admin/config/people/ip-blocking\">IP address blocking</a></li></ul></li><li class=\"expandable\"><a href=\"/en/admin/config/regional\">Regional and language</a>\n<ul class=\"dropdown\"><li><a href=\"/en/admin/config/regional/settings\">Regional settings</a></li><li class=\"expandable\"><a href=\"/en/admin/config/regional/date-time\">Date and time</a>\n<ul class=\"dropdown\"><li class=\"expandable\"><a href=\"/en/admin/config/regional/date-time/formats\">Formats</a>\n<ul class=\"dropdown\"><li><a href=\"/en/admin/config/regional/date-time/formats/add\">Add format</a></li></ul></li><li><a href=\"/en/admin/config/regional/date-time/locale\">Localize</a></li><li><a href=\"/en/admin/config/regional/date-time/date-views\">Date views</a></li></ul></li><li class=\"expandable\"><a href=\"/en/admin/config/regional/language\">Languages</a>\n<ul class=\"dropdown\"><li><a href=\"/en/admin/config/regional/language/add\">Add language</a></li><li><a href=\"/en/admin/config/regional/language/configure\">Detection and selection</a></li><li><a href=\"/en/admin/config/regional/language/icons\">Icons</a></li></ul></li><li class=\"expandable\"><a href=\"/en/admin/config/regional/translate\">Translate interface</a>\n<ul class=\"dropdown\"><li><a href=\"/en/admin/config/regional/translate/translate\">Translate</a></li><li><a href=\"/en/admin/config/regional/translate/import\">Import</a></li><li><a href=\"/en/admin/config/regional/translate/i18n_string\">Strings</a></li><li><a href=\"/en/admin/config/regional/translate/export\">Export</a></li></ul></li><li class=\"expandable\"><a href=\"/en/admin/config/regional/i18n\">Multilingual settings</a>\n<ul class=\"dropdown\"><li><a href=\"/en/admin/config/regional/i18n/strings\">Strings</a></li></ul></li><li><a href=\"/en/admin/config/regional/i18n_translation\">Translation sets</a></li></ul></li><li class=\"expandable\"><a href=\"/en/admin/config/search\">Search and metadata</a>\n<ul class=\"dropdown\"><li><a href=\"/en/admin/config/search/settings\">Search settings</a></li><li class=\"expandable\"><a href=\"/en/admin/config/search/path\">URL aliases</a>\n<ul class=\"dropdown\"><li><a href=\"/en/admin/config/search/path/add\">Add alias</a></li><li><a href=\"/en/admin/config/search/path/patterns\">Patterns</a></li><li><a href=\"/en/admin/config/search/path/settings\">Settings</a></li><li><a href=\"/en/admin/config/search/path/update_bulk\">Bulk update</a></li><li><a href=\"/en/admin/config/search/path/delete_bulk\">Delete aliases</a></li></ul></li><li><a href=\"/en/admin/config/search/votingapi\">Voting API</a></li><li><a href=\"/en/admin/config/search/clean-urls\">Clean URLs</a></li></ul></li><li class=\"expandable\"><a href=\"/en/admin/config/system\">System</a>\n<ul class=\"dropdown\"><li><a href=\"/en/admin/config/system/site-information\">Site information</a></li><li><a href=\"/en/admin/config/system/statistics\">Statistics</a></li><li><a href=\"/en/admin/config/system/actions\">Actions</a></li><li class=\"expandable\"><a href=\"/en/admin/config/system/message\">Message settings</a>\n<ul class=\"dropdown\"><li><a href=\"/en/admin/config/system/message/text-copy\">Copy messages text fields</a></li></ul></li><li><a href=\"/en/admin/config/system/remember_me\">Remember me settings</a></li><li><a href=\"/en/admin/config/system/cron\">Cron</a></li></ul></li><li class=\"expandable\"><a href=\"/en/admin/config/user-interface\">User interface</a>\n<ul class=\"dropdown\"><li><a href=\"/en/admin/config/user-interface/chosen\">Chosen</a></li><li><a href=\"/en/admin/config/user-interface/menu-breadcrumb\">Menu Breadcrumb</a></li><li><a href=\"/en/admin/config/user-interface/modulefilter\">Module filter</a></li><li class=\"expandable\"><a href=\"/en/admin/config/user-interface/shortcut\">Shortcuts</a>\n<ul class=\"dropdown\"><li><a href=\"/en/admin/config/user-interface/shortcut/add-set\">Add shortcut set</a></li></ul></li></ul></li><li class=\"expandable\"><a href=\"/en/admin/config/services\">Web services</a>\n<ul class=\"dropdown\"><li><a href=\"/en/admin/config/services/rss-publishing\">RSS publishing</a></li><li><a href=\"/en/admin/config/services/sharethis\">ShareThis</a></li></ul></li></ul></li><li class=\"admin-menu-toolbar-category expandable\"><a href=\"/en/admin/reports\">Reports</a>\n<ul class=\"dropdown\"><li><a href=\"/en/admin/reports/status\">Status report</a></li><li class=\"expandable\"><a href=\"/en/admin/reports/updates\">Available updates</a>\n<ul class=\"dropdown\"><li><a href=\"/en/admin/reports/updates/install\">Install new module or theme</a></li><li><a href=\"/en/admin/reports/updates/update\">Update</a></li><li><a href=\"/en/admin/reports/updates/settings\">Settings</a></li></ul></li><li><a href=\"/en/admin/reports/dblog\">Recent log messages</a></li><li class=\"expandable\"><a href=\"/en/admin/reports/fields\">Field list</a>\n<ul class=\"dropdown\"><li><a href=\"/en/admin/reports/fields/views-fields\">Used in views</a></li></ul></li><li><a href=\"/en/admin/reports/hits\">Recent hits</a></li><li><a href=\"/en/admin/reports/access-denied\">Top &#039;access denied&#039; errors</a></li><li><a href=\"/en/admin/reports/page-not-found\">Top &#039;page not found&#039; errors</a></li><li><a href=\"/en/admin/reports/referrers\">Top referrers</a></li><li><a href=\"/en/admin/reports/search\">Top search phrases</a></li><li><a href=\"/en/admin/reports/views-plugins\">Views plugins</a></li><li><a href=\"/en/admin/reports/pages\">Top pages</a></li><li><a href=\"/en/admin/reports/visitors\">Top visitors</a></li></ul></li><li class=\"admin-menu-toolbar-category\"><a href=\"/en/admin/help\">Help</a></li></ul>\n<ul id=\"admin-menu-account\" class=\"dropdown\"><li class=\"admin-menu-action\"><a href=\"/en/user/logout\">Log out</a></li><li class=\"admin-menu-action admin-menu-account\"><a href=\"/en/users/admin\" class=\"active\">Hello <strong>admin</strong></a></li></ul></div></div>',0,1512620348,0),('links:main-menu:page:user/1:en:1:0','a:4:{s:9:\"min_depth\";i:1;s:9:\"max_depth\";N;s:8:\"expanded\";a:6:{i:0;i:0;i:310;s:3:\"310\";i:359;s:3:\"359\";i:566;s:3:\"566\";i:621;s:3:\"621\";i:627;s:3:\"627\";}s:12:\"active_trail\";a:1:{i:0;i:0;}}',0,1512620348,1),('links:main-menu:page:user:en:1:0','a:4:{s:9:\"min_depth\";i:1;s:9:\"max_depth\";N;s:8:\"expanded\";a:6:{i:0;i:0;i:310;s:3:\"310\";i:359;s:3:\"359\";i:566;s:3:\"566\";i:621;s:3:\"621\";i:627;s:3:\"627\";}s:12:\"active_trail\";a:1:{i:0;i:0;}}',0,1512620340,1),('links:main-menu:tree-data:en:941c18f39c08375261dcee3fb9811962cd509b520000fa7a35c6b914d7cd53d4','a:2:{s:4:\"tree\";a:10:{i:155;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:9:\"main-menu\";s:4:\"mlid\";s:3:\"155\";s:4:\"plid\";s:1:\"0\";s:9:\"link_path\";s:6:\"search\";s:11:\"router_path\";s:6:\"search\";s:10:\"link_title\";s:6:\"Search\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:3:\"-45\";s:5:\"depth\";s:1:\"1\";s:10:\"customized\";s:1:\"1\";s:2:\"p1\";s:3:\"155\";s:2:\"p2\";s:1:\"0\";s:2:\"p3\";s:1:\"0\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:16:\"search_is_active\";s:16:\"access_arguments\";s:6:\"a:0:{}\";s:13:\"page_callback\";s:11:\"search_view\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:6:\"search\";s:5:\"title\";s:6:\"Search\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:2:\"20\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:218;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:9:\"main-menu\";s:4:\"mlid\";s:3:\"218\";s:4:\"plid\";s:1:\"0\";s:9:\"link_path\";s:7:\"<front>\";s:11:\"router_path\";s:0:\"\";s:10:\"link_title\";s:4:\"Home\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:4:\"menu\";s:6:\"hidden\";s:1:\"1\";s:8:\"external\";s:1:\"1\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:3:\"-50\";s:5:\"depth\";s:1:\"1\";s:10:\"customized\";s:1:\"1\";s:2:\"p1\";s:3:\"218\";s:2:\"p2\";s:1:\"0\";s:2:\"p3\";s:1:\"0\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";N;s:16:\"to_arg_functions\";N;s:15:\"access_callback\";N;s:16:\"access_arguments\";N;s:13:\"page_callback\";N;s:14:\"page_arguments\";N;s:17:\"delivery_callback\";N;s:10:\"tab_parent\";N;s:8:\"tab_root\";N;s:5:\"title\";N;s:14:\"title_callback\";N;s:15:\"title_arguments\";N;s:14:\"theme_callback\";N;s:15:\"theme_arguments\";N;s:4:\"type\";N;s:11:\"description\";N;s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:309;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:9:\"main-menu\";s:4:\"mlid\";s:3:\"309\";s:4:\"plid\";s:1:\"0\";s:9:\"link_path\";s:4:\"book\";s:11:\"router_path\";s:4:\"book\";s:10:\"link_title\";s:5:\"Books\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:3:\"-46\";s:5:\"depth\";s:1:\"1\";s:10:\"customized\";s:1:\"1\";s:2:\"p1\";s:3:\"309\";s:2:\"p2\";s:1:\"0\";s:2:\"p3\";s:1:\"0\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:32:\"a:1:{i:0;s:14:\"access content\";}\";s:13:\"page_callback\";s:11:\"book_render\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:4:\"book\";s:5:\"title\";s:5:\"Books\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:2:\"20\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:310;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:9:\"main-menu\";s:4:\"mlid\";s:3:\"310\";s:4:\"plid\";s:1:\"0\";s:9:\"link_path\";s:5:\"forum\";s:11:\"router_path\";s:5:\"forum\";s:10:\"link_title\";s:6:\"Forums\";s:7:\"options\";s:49:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:0:\"\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"1\";s:8:\"expanded\";s:1:\"1\";s:6:\"weight\";s:3:\"-49\";s:5:\"depth\";s:1:\"1\";s:10:\"customized\";s:1:\"1\";s:2:\"p1\";s:3:\"310\";s:2:\"p2\";s:1:\"0\";s:2:\"p3\";s:1:\"0\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:32:\"a:1:{i:0;s:14:\"access content\";}\";s:13:\"page_callback\";s:19:\"advanced_forum_page\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:5:\"forum\";s:5:\"title\";s:6:\"Forums\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:8:{i:311;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:9:\"main-menu\";s:4:\"mlid\";s:3:\"311\";s:4:\"plid\";s:3:\"310\";s:9:\"link_path\";s:7:\"forum/%\";s:11:\"router_path\";s:7:\"forum/%\";s:10:\"link_title\";s:6:\"Forums\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"2\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:3:\"310\";s:2:\"p2\";s:3:\"311\";s:2:\"p3\";s:1:\"0\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:43:\"a:1:{i:1;s:25:\"advanced_forum_forum_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:32:\"a:1:{i:0;s:14:\"access content\";}\";s:13:\"page_callback\";s:19:\"advanced_forum_page\";s:14:\"page_arguments\";s:14:\"a:1:{i:0;i:1;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:7:\"forum/%\";s:5:\"title\";s:6:\"Forums\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:418;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:9:\"main-menu\";s:4:\"mlid\";s:3:\"418\";s:4:\"plid\";s:3:\"310\";s:9:\"link_path\";s:10:\"forum/view\";s:11:\"router_path\";s:10:\"forum/view\";s:10:\"link_title\";s:11:\"View Forums\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:4:\"-100\";s:5:\"depth\";s:1:\"2\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:3:\"310\";s:2:\"p2\";s:3:\"418\";s:2:\"p3\";s:1:\"0\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:32:\"a:1:{i:0;s:14:\"access content\";}\";s:13:\"page_callback\";s:19:\"advanced_forum_page\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:5:\"forum\";s:8:\"tab_root\";s:5:\"forum\";s:5:\"title\";s:11:\"View Forums\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"140\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:423;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:9:\"main-menu\";s:4:\"mlid\";s:3:\"423\";s:4:\"plid\";s:3:\"310\";s:9:\"link_path\";s:12:\"forum/active\";s:11:\"router_path\";s:12:\"forum/active\";s:10:\"link_title\";s:13:\"Active topics\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"1\";s:5:\"depth\";s:1:\"2\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:3:\"310\";s:2:\"p2\";s:3:\"423\";s:2:\"p3\";s:1:\"0\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:12:\"views_access\";s:16:\"access_arguments\";s:14:\"a:1:{i:0;b:1;}\";s:13:\"page_callback\";s:10:\"views_page\";s:14:\"page_arguments\";s:63:\"a:2:{i:0;s:28:\"advanced_forum_active_topics\";i:1;s:6:\"page_1\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:5:\"forum\";s:8:\"tab_root\";s:5:\"forum\";s:5:\"title\";s:13:\"Active topics\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:424;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:9:\"main-menu\";s:4:\"mlid\";s:3:\"424\";s:4:\"plid\";s:3:\"310\";s:9:\"link_path\";s:9:\"forum/new\";s:11:\"router_path\";s:9:\"forum/new\";s:10:\"link_title\";s:20:\"New & updated topics\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"2\";s:5:\"depth\";s:1:\"2\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:3:\"310\";s:2:\"p2\";s:3:\"424\";s:2:\"p3\";s:1:\"0\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:12:\"views_access\";s:16:\"access_arguments\";s:73:\"a:1:{i:0;a:2:{i:0;s:17:\"views_check_roles\";i:1;a:1:{i:0;a:1:{i:2;i:2;}}}}\";s:13:\"page_callback\";s:10:\"views_page\";s:14:\"page_arguments\";s:60:\"a:2:{i:0;s:25:\"advanced_forum_new_topics\";i:1;s:6:\"page_1\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:5:\"forum\";s:8:\"tab_root\";s:5:\"forum\";s:5:\"title\";s:20:\"New & updated topics\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:425;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:9:\"main-menu\";s:4:\"mlid\";s:3:\"425\";s:4:\"plid\";s:3:\"310\";s:9:\"link_path\";s:16:\"forum/unanswered\";s:11:\"router_path\";s:16:\"forum/unanswered\";s:10:\"link_title\";s:17:\"Unanswered topics\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"1\";s:5:\"depth\";s:1:\"2\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:3:\"310\";s:2:\"p2\";s:3:\"425\";s:2:\"p3\";s:1:\"0\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:12:\"views_access\";s:16:\"access_arguments\";s:14:\"a:1:{i:0;b:1;}\";s:13:\"page_callback\";s:10:\"views_page\";s:14:\"page_arguments\";s:67:\"a:2:{i:0;s:32:\"advanced_forum_unanswered_topics\";i:1;s:6:\"page_1\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:5:\"forum\";s:8:\"tab_root\";s:5:\"forum\";s:5:\"title\";s:17:\"Unanswered topics\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:540;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:9:\"main-menu\";s:4:\"mlid\";s:3:\"540\";s:4:\"plid\";s:3:\"310\";s:9:\"link_path\";s:14:\"node/add/forum\";s:11:\"router_path\";s:14:\"node/add/forum\";s:10:\"link_title\";s:9:\"New posts\";s:7:\"options\";s:49:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:0:\"\";}}\";s:6:\"module\";s:4:\"menu\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:3:\"-50\";s:5:\"depth\";s:1:\"2\";s:10:\"customized\";s:1:\"1\";s:2:\"p1\";s:3:\"310\";s:2:\"p2\";s:3:\"540\";s:2:\"p3\";s:1:\"0\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"node_access\";s:16:\"access_arguments\";s:39:\"a:2:{i:0;s:6:\"create\";i:1;s:5:\"forum\";}\";s:13:\"page_callback\";s:8:\"node_add\";s:14:\"page_arguments\";s:22:\"a:1:{i:0;s:5:\"forum\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:14:\"node/add/forum\";s:5:\"title\";s:11:\"Forum topic\";s:14:\"title_callback\";s:11:\"check_plain\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:69:\"A <em>forum topic</em> starts a new discussion thread within a forum.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:544;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:9:\"main-menu\";s:4:\"mlid\";s:3:\"544\";s:4:\"plid\";s:3:\"310\";s:9:\"link_path\";s:8:\"calendar\";s:11:\"router_path\";s:8:\"calendar\";s:10:\"link_title\";s:8:\"Calendar\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:3:\"-49\";s:5:\"depth\";s:1:\"2\";s:10:\"customized\";s:1:\"1\";s:2:\"p1\";s:3:\"310\";s:2:\"p2\";s:3:\"544\";s:2:\"p3\";s:1:\"0\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:12:\"views_access\";s:16:\"access_arguments\";s:80:\"a:1:{i:0;a:2:{i:0;s:16:\"views_check_perm\";i:1;a:1:{i:0;s:14:\"access content\";}}}\";s:13:\"page_callback\";s:10:\"views_page\";s:14:\"page_arguments\";s:40:\"a:2:{i:0;s:8:\"calendar\";i:1;s:4:\"page\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:8:\"calendar\";s:5:\"title\";s:8:\"Calendar\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:545;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:9:\"main-menu\";s:4:\"mlid\";s:3:\"545\";s:4:\"plid\";s:3:\"310\";s:9:\"link_path\";s:8:\"faq-page\";s:11:\"router_path\";s:8:\"faq-page\";s:10:\"link_title\";s:3:\"FAQ\";s:7:\"options\";s:49:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:0:\"\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:3:\"-48\";s:5:\"depth\";s:1:\"2\";s:10:\"customized\";s:1:\"1\";s:2:\"p1\";s:3:\"310\";s:2:\"p2\";s:3:\"545\";s:2:\"p3\";s:1:\"0\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:31:\"a:1:{i:0;s:13:\"view faq page\";}\";s:13:\"page_callback\";s:8:\"faq_page\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:8:\"faq-page\";s:5:\"title\";s:26:\"Frequently Asked Questions\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:2:\"20\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}}}i:359;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:9:\"main-menu\";s:4:\"mlid\";s:3:\"359\";s:4:\"plid\";s:1:\"0\";s:9:\"link_path\";s:8:\"articles\";s:11:\"router_path\";s:8:\"articles\";s:10:\"link_title\";s:8:\"Articles\";s:7:\"options\";s:49:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:0:\"\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"1\";s:8:\"expanded\";s:1:\"1\";s:6:\"weight\";s:3:\"-48\";s:5:\"depth\";s:1:\"1\";s:10:\"customized\";s:1:\"1\";s:2:\"p1\";s:3:\"359\";s:2:\"p2\";s:1:\"0\";s:2:\"p3\";s:1:\"0\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:12:\"views_access\";s:16:\"access_arguments\";s:80:\"a:1:{i:0;a:2:{i:0;s:16:\"views_check_perm\";i:1;a:1:{i:0;s:14:\"access content\";}}}\";s:13:\"page_callback\";s:10:\"views_page\";s:14:\"page_arguments\";s:40:\"a:2:{i:0;s:8:\"articles\";i:1;s:4:\"page\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:8:\"articles\";s:5:\"title\";s:8:\"Articles\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:8:{i:567;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:9:\"main-menu\";s:4:\"mlid\";s:3:\"567\";s:4:\"plid\";s:3:\"359\";s:9:\"link_path\";s:15:\"articles-teaser\";s:11:\"router_path\";s:15:\"articles-teaser\";s:10:\"link_title\";s:15:\"Articles Teaser\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:3:\"-50\";s:5:\"depth\";s:1:\"2\";s:10:\"customized\";s:1:\"1\";s:2:\"p1\";s:3:\"359\";s:2:\"p2\";s:3:\"567\";s:2:\"p3\";s:1:\"0\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:12:\"views_access\";s:16:\"access_arguments\";s:80:\"a:1:{i:0;a:2:{i:0;s:16:\"views_check_perm\";i:1;a:1:{i:0;s:14:\"access content\";}}}\";s:13:\"page_callback\";s:10:\"views_page\";s:14:\"page_arguments\";s:42:\"a:2:{i:0;s:8:\"articles\";i:1;s:6:\"page_1\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:15:\"articles-teaser\";s:5:\"title\";s:15:\"Articles Teaser\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:569;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:9:\"main-menu\";s:4:\"mlid\";s:3:\"569\";s:4:\"plid\";s:3:\"359\";s:9:\"link_path\";s:10:\"articles-1\";s:11:\"router_path\";s:10:\"articles-1\";s:10:\"link_title\";s:10:\"Articles 1\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:3:\"-50\";s:5:\"depth\";s:1:\"2\";s:10:\"customized\";s:1:\"1\";s:2:\"p1\";s:3:\"359\";s:2:\"p2\";s:3:\"569\";s:2:\"p3\";s:1:\"0\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";N;s:16:\"to_arg_functions\";N;s:15:\"access_callback\";N;s:16:\"access_arguments\";N;s:13:\"page_callback\";N;s:14:\"page_arguments\";N;s:17:\"delivery_callback\";N;s:10:\"tab_parent\";N;s:8:\"tab_root\";N;s:5:\"title\";N;s:14:\"title_callback\";N;s:15:\"title_arguments\";N;s:14:\"theme_callback\";N;s:15:\"theme_arguments\";N;s:4:\"type\";N;s:11:\"description\";N;s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:570;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:9:\"main-menu\";s:4:\"mlid\";s:3:\"570\";s:4:\"plid\";s:3:\"359\";s:9:\"link_path\";s:10:\"articles-2\";s:11:\"router_path\";s:10:\"articles-2\";s:10:\"link_title\";s:10:\"Articles 2\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:3:\"-49\";s:5:\"depth\";s:1:\"2\";s:10:\"customized\";s:1:\"1\";s:2:\"p1\";s:3:\"359\";s:2:\"p2\";s:3:\"570\";s:2:\"p3\";s:1:\"0\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";N;s:16:\"to_arg_functions\";N;s:15:\"access_callback\";N;s:16:\"access_arguments\";N;s:13:\"page_callback\";N;s:14:\"page_arguments\";N;s:17:\"delivery_callback\";N;s:10:\"tab_parent\";N;s:8:\"tab_root\";N;s:5:\"title\";N;s:14:\"title_callback\";N;s:15:\"title_arguments\";N;s:14:\"theme_callback\";N;s:15:\"theme_arguments\";N;s:4:\"type\";N;s:11:\"description\";N;s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:574;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:9:\"main-menu\";s:4:\"mlid\";s:3:\"574\";s:4:\"plid\";s:3:\"359\";s:9:\"link_path\";s:20:\"articles-two-columns\";s:11:\"router_path\";s:20:\"articles-two-columns\";s:10:\"link_title\";s:11:\"Two Columns\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:3:\"-49\";s:5:\"depth\";s:1:\"2\";s:10:\"customized\";s:1:\"1\";s:2:\"p1\";s:3:\"359\";s:2:\"p2\";s:3:\"574\";s:2:\"p3\";s:1:\"0\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";N;s:16:\"to_arg_functions\";N;s:15:\"access_callback\";N;s:16:\"access_arguments\";N;s:13:\"page_callback\";N;s:14:\"page_arguments\";N;s:17:\"delivery_callback\";N;s:10:\"tab_parent\";N;s:8:\"tab_root\";N;s:5:\"title\";N;s:14:\"title_callback\";N;s:15:\"title_arguments\";N;s:14:\"theme_callback\";N;s:15:\"theme_arguments\";N;s:4:\"type\";N;s:11:\"description\";N;s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:575;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:9:\"main-menu\";s:4:\"mlid\";s:3:\"575\";s:4:\"plid\";s:3:\"359\";s:9:\"link_path\";s:22:\"articles-three-columns\";s:11:\"router_path\";s:22:\"articles-three-columns\";s:10:\"link_title\";s:13:\"Three Columns\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:3:\"-48\";s:5:\"depth\";s:1:\"2\";s:10:\"customized\";s:1:\"1\";s:2:\"p1\";s:3:\"359\";s:2:\"p2\";s:3:\"575\";s:2:\"p3\";s:1:\"0\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";N;s:16:\"to_arg_functions\";N;s:15:\"access_callback\";N;s:16:\"access_arguments\";N;s:13:\"page_callback\";N;s:14:\"page_arguments\";N;s:17:\"delivery_callback\";N;s:10:\"tab_parent\";N;s:8:\"tab_root\";N;s:5:\"title\";N;s:14:\"title_callback\";N;s:15:\"title_arguments\";N;s:14:\"theme_callback\";N;s:15:\"theme_arguments\";N;s:4:\"type\";N;s:11:\"description\";N;s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:576;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:9:\"main-menu\";s:4:\"mlid\";s:3:\"576\";s:4:\"plid\";s:3:\"359\";s:9:\"link_path\";s:21:\"articles-four-columns\";s:11:\"router_path\";s:21:\"articles-four-columns\";s:10:\"link_title\";s:12:\"Four Columns\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:3:\"-47\";s:5:\"depth\";s:1:\"2\";s:10:\"customized\";s:1:\"1\";s:2:\"p1\";s:3:\"359\";s:2:\"p2\";s:3:\"576\";s:2:\"p3\";s:1:\"0\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";N;s:16:\"to_arg_functions\";N;s:15:\"access_callback\";N;s:16:\"access_arguments\";N;s:13:\"page_callback\";N;s:14:\"page_arguments\";N;s:17:\"delivery_callback\";N;s:10:\"tab_parent\";N;s:8:\"tab_root\";N;s:5:\"title\";N;s:14:\"title_callback\";N;s:15:\"title_arguments\";N;s:14:\"theme_callback\";N;s:15:\"theme_arguments\";N;s:4:\"type\";N;s:11:\"description\";N;s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:589;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:9:\"main-menu\";s:4:\"mlid\";s:3:\"589\";s:4:\"plid\";s:3:\"359\";s:9:\"link_path\";s:12:\"articles/two\";s:11:\"router_path\";s:12:\"articles/two\";s:10:\"link_title\";s:11:\"Two Columns\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"2\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:3:\"359\";s:2:\"p2\";s:3:\"589\";s:2:\"p3\";s:1:\"0\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:12:\"views_access\";s:16:\"access_arguments\";s:80:\"a:1:{i:0;a:2:{i:0;s:16:\"views_check_perm\";i:1;a:1:{i:0;s:14:\"access content\";}}}\";s:13:\"page_callback\";s:10:\"views_page\";s:14:\"page_arguments\";s:42:\"a:2:{i:0;s:8:\"articles\";i:1;s:6:\"page_2\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:12:\"articles/two\";s:5:\"title\";s:11:\"Two Columns\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:590;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:9:\"main-menu\";s:4:\"mlid\";s:3:\"590\";s:4:\"plid\";s:3:\"359\";s:9:\"link_path\";s:14:\"articles/three\";s:11:\"router_path\";s:14:\"articles/three\";s:10:\"link_title\";s:13:\"Three Columns\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"2\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:3:\"359\";s:2:\"p2\";s:3:\"590\";s:2:\"p3\";s:1:\"0\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:12:\"views_access\";s:16:\"access_arguments\";s:80:\"a:1:{i:0;a:2:{i:0;s:16:\"views_check_perm\";i:1;a:1:{i:0;s:14:\"access content\";}}}\";s:13:\"page_callback\";s:10:\"views_page\";s:14:\"page_arguments\";s:42:\"a:2:{i:0;s:8:\"articles\";i:1;s:6:\"page_3\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:14:\"articles/three\";s:5:\"title\";s:13:\"Three Columns\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}}}i:483;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:9:\"main-menu\";s:4:\"mlid\";s:3:\"483\";s:4:\"plid\";s:1:\"0\";s:9:\"link_path\";s:15:\"activity-stream\";s:11:\"router_path\";s:15:\"activity-stream\";s:10:\"link_title\";s:10:\"What\'s New\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:3:\"-44\";s:5:\"depth\";s:1:\"1\";s:10:\"customized\";s:1:\"1\";s:2:\"p1\";s:3:\"483\";s:2:\"p2\";s:1:\"0\";s:2:\"p3\";s:1:\"0\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:12:\"views_access\";s:16:\"access_arguments\";s:14:\"a:1:{i:0;b:1;}\";s:13:\"page_callback\";s:10:\"views_page\";s:14:\"page_arguments\";s:48:\"a:2:{i:0;s:15:\"activity_stream\";i:1;s:4:\"page\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:15:\"activity-stream\";s:5:\"title\";s:10:\"What\'s New\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:566;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:9:\"main-menu\";s:4:\"mlid\";s:3:\"566\";s:4:\"plid\";s:1:\"0\";s:9:\"link_path\";s:7:\"contact\";s:11:\"router_path\";s:7:\"contact\";s:10:\"link_title\";s:7:\"Contact\";s:7:\"options\";s:49:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:0:\"\";}}\";s:6:\"module\";s:4:\"menu\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"1\";s:8:\"expanded\";s:1:\"1\";s:6:\"weight\";s:3:\"-42\";s:5:\"depth\";s:1:\"1\";s:10:\"customized\";s:1:\"1\";s:2:\"p1\";s:3:\"566\";s:2:\"p2\";s:1:\"0\";s:2:\"p3\";s:1:\"0\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:47:\"a:1:{i:0;s:29:\"access site-wide contact form\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:35:\"a:1:{i:0;s:17:\"contact_site_form\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:7:\"contact\";s:5:\"title\";s:7:\"Contact\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:2:\"20\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:2:{i:618;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:9:\"main-menu\";s:4:\"mlid\";s:3:\"618\";s:4:\"plid\";s:3:\"566\";s:9:\"link_path\";s:7:\"contact\";s:11:\"router_path\";s:7:\"contact\";s:10:\"link_title\";s:10:\"Contact Us\";s:7:\"options\";s:49:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:0:\"\";}}\";s:6:\"module\";s:4:\"menu\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:3:\"-50\";s:5:\"depth\";s:1:\"2\";s:10:\"customized\";s:1:\"1\";s:2:\"p1\";s:3:\"566\";s:2:\"p2\";s:3:\"618\";s:2:\"p3\";s:1:\"0\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:47:\"a:1:{i:0;s:29:\"access site-wide contact form\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:35:\"a:1:{i:0;s:17:\"contact_site_form\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:7:\"contact\";s:5:\"title\";s:7:\"Contact\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:2:\"20\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:620;a:2:{s:4:\"link\";a:43:{s:9:\"menu_name\";s:9:\"main-menu\";s:4:\"mlid\";s:3:\"620\";s:4:\"plid\";s:3:\"566\";s:9:\"link_path\";s:7:\"node/41\";s:11:\"router_path\";s:6:\"node/%\";s:10:\"link_title\";s:12:\"Contact Us 2\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:4:\"menu\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:3:\"-49\";s:5:\"depth\";s:1:\"2\";s:10:\"customized\";s:1:\"1\";s:2:\"p1\";s:3:\"566\";s:2:\"p2\";s:3:\"620\";s:2:\"p3\";s:1:\"0\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:26:\"a:1:{i:1;s:9:\"node_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"node_access\";s:16:\"access_arguments\";s:29:\"a:2:{i:0;s:4:\"view\";i:1;i:1;}\";s:13:\"page_callback\";s:14:\"node_page_view\";s:14:\"page_arguments\";s:14:\"a:1:{i:0;i:1;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:6:\"node/%\";s:5:\"title\";s:0:\"\";s:14:\"title_callback\";s:15:\"node_page_title\";s:15:\"title_arguments\";s:14:\"a:1:{i:0;i:1;}\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;s:6:\"access\";b:0;}s:5:\"below\";a:0:{}}}}i:571;a:2:{s:4:\"link\";a:43:{s:9:\"menu_name\";s:9:\"main-menu\";s:4:\"mlid\";s:3:\"571\";s:4:\"plid\";s:1:\"0\";s:9:\"link_path\";s:7:\"node/33\";s:11:\"router_path\";s:6:\"node/%\";s:10:\"link_title\";s:8:\"404 page\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:4:\"menu\";s:6:\"hidden\";s:1:\"1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:3:\"-41\";s:5:\"depth\";s:1:\"1\";s:10:\"customized\";s:1:\"1\";s:2:\"p1\";s:3:\"571\";s:2:\"p2\";s:1:\"0\";s:2:\"p3\";s:1:\"0\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:26:\"a:1:{i:1;s:9:\"node_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"node_access\";s:16:\"access_arguments\";s:29:\"a:2:{i:0;s:4:\"view\";i:1;i:1;}\";s:13:\"page_callback\";s:14:\"node_page_view\";s:14:\"page_arguments\";s:14:\"a:1:{i:0;i:1;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:6:\"node/%\";s:5:\"title\";s:0:\"\";s:14:\"title_callback\";s:15:\"node_page_title\";s:15:\"title_arguments\";s:14:\"a:1:{i:0;i:1;}\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;s:6:\"access\";b:0;}s:5:\"below\";a:0:{}}i:621;a:2:{s:4:\"link\";a:43:{s:9:\"menu_name\";s:9:\"main-menu\";s:4:\"mlid\";s:3:\"621\";s:4:\"plid\";s:1:\"0\";s:9:\"link_path\";s:7:\"node/42\";s:11:\"router_path\";s:6:\"node/%\";s:10:\"link_title\";s:5:\"Color\";s:7:\"options\";s:49:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:0:\"\";}}\";s:6:\"module\";s:4:\"menu\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"1\";s:8:\"expanded\";s:1:\"1\";s:6:\"weight\";s:3:\"-43\";s:5:\"depth\";s:1:\"1\";s:10:\"customized\";s:1:\"1\";s:2:\"p1\";s:3:\"621\";s:2:\"p2\";s:1:\"0\";s:2:\"p3\";s:1:\"0\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:26:\"a:1:{i:1;s:9:\"node_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"node_access\";s:16:\"access_arguments\";s:29:\"a:2:{i:0;s:4:\"view\";i:1;i:1;}\";s:13:\"page_callback\";s:14:\"node_page_view\";s:14:\"page_arguments\";s:14:\"a:1:{i:0;i:1;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:6:\"node/%\";s:5:\"title\";s:0:\"\";s:14:\"title_callback\";s:15:\"node_page_title\";s:15:\"title_arguments\";s:14:\"a:1:{i:0;i:1;}\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;s:6:\"access\";b:0;}s:5:\"below\";a:4:{i:622;a:2:{s:4:\"link\";a:43:{s:9:\"menu_name\";s:9:\"main-menu\";s:4:\"mlid\";s:3:\"622\";s:4:\"plid\";s:3:\"621\";s:9:\"link_path\";s:7:\"node/43\";s:11:\"router_path\";s:6:\"node/%\";s:10:\"link_title\";s:7:\"Default\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:4:\"menu\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:3:\"-50\";s:5:\"depth\";s:1:\"2\";s:10:\"customized\";s:1:\"1\";s:2:\"p1\";s:3:\"621\";s:2:\"p2\";s:3:\"622\";s:2:\"p3\";s:1:\"0\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:26:\"a:1:{i:1;s:9:\"node_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"node_access\";s:16:\"access_arguments\";s:29:\"a:2:{i:0;s:4:\"view\";i:1;i:1;}\";s:13:\"page_callback\";s:14:\"node_page_view\";s:14:\"page_arguments\";s:14:\"a:1:{i:0;i:1;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:6:\"node/%\";s:5:\"title\";s:0:\"\";s:14:\"title_callback\";s:15:\"node_page_title\";s:15:\"title_arguments\";s:14:\"a:1:{i:0;i:1;}\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;s:6:\"access\";b:0;}s:5:\"below\";a:0:{}}i:623;a:2:{s:4:\"link\";a:43:{s:9:\"menu_name\";s:9:\"main-menu\";s:4:\"mlid\";s:3:\"623\";s:4:\"plid\";s:3:\"621\";s:9:\"link_path\";s:7:\"node/44\";s:11:\"router_path\";s:6:\"node/%\";s:10:\"link_title\";s:3:\"Red\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:4:\"menu\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:3:\"-48\";s:5:\"depth\";s:1:\"2\";s:10:\"customized\";s:1:\"1\";s:2:\"p1\";s:3:\"621\";s:2:\"p2\";s:3:\"623\";s:2:\"p3\";s:1:\"0\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:26:\"a:1:{i:1;s:9:\"node_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"node_access\";s:16:\"access_arguments\";s:29:\"a:2:{i:0;s:4:\"view\";i:1;i:1;}\";s:13:\"page_callback\";s:14:\"node_page_view\";s:14:\"page_arguments\";s:14:\"a:1:{i:0;i:1;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:6:\"node/%\";s:5:\"title\";s:0:\"\";s:14:\"title_callback\";s:15:\"node_page_title\";s:15:\"title_arguments\";s:14:\"a:1:{i:0;i:1;}\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;s:6:\"access\";b:0;}s:5:\"below\";a:0:{}}i:624;a:2:{s:4:\"link\";a:43:{s:9:\"menu_name\";s:9:\"main-menu\";s:4:\"mlid\";s:3:\"624\";s:4:\"plid\";s:3:\"621\";s:9:\"link_path\";s:7:\"node/45\";s:11:\"router_path\";s:6:\"node/%\";s:10:\"link_title\";s:6:\"Yellow\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:4:\"menu\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:3:\"-49\";s:5:\"depth\";s:1:\"2\";s:10:\"customized\";s:1:\"1\";s:2:\"p1\";s:3:\"621\";s:2:\"p2\";s:3:\"624\";s:2:\"p3\";s:1:\"0\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:26:\"a:1:{i:1;s:9:\"node_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"node_access\";s:16:\"access_arguments\";s:29:\"a:2:{i:0;s:4:\"view\";i:1;i:1;}\";s:13:\"page_callback\";s:14:\"node_page_view\";s:14:\"page_arguments\";s:14:\"a:1:{i:0;i:1;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:6:\"node/%\";s:5:\"title\";s:0:\"\";s:14:\"title_callback\";s:15:\"node_page_title\";s:15:\"title_arguments\";s:14:\"a:1:{i:0;i:1;}\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;s:6:\"access\";b:0;}s:5:\"below\";a:0:{}}i:675;a:2:{s:4:\"link\";a:43:{s:9:\"menu_name\";s:9:\"main-menu\";s:4:\"mlid\";s:3:\"675\";s:4:\"plid\";s:3:\"621\";s:9:\"link_path\";s:7:\"node/57\";s:11:\"router_path\";s:6:\"node/%\";s:10:\"link_title\";s:5:\"Green\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:4:\"menu\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"2\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:3:\"621\";s:2:\"p2\";s:3:\"675\";s:2:\"p3\";s:1:\"0\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:26:\"a:1:{i:1;s:9:\"node_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"node_access\";s:16:\"access_arguments\";s:29:\"a:2:{i:0;s:4:\"view\";i:1;i:1;}\";s:13:\"page_callback\";s:14:\"node_page_view\";s:14:\"page_arguments\";s:14:\"a:1:{i:0;i:1;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:6:\"node/%\";s:5:\"title\";s:0:\"\";s:14:\"title_callback\";s:15:\"node_page_title\";s:15:\"title_arguments\";s:14:\"a:1:{i:0;i:1;}\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;s:6:\"access\";b:0;}s:5:\"below\";a:0:{}}}}i:627;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:9:\"main-menu\";s:4:\"mlid\";s:3:\"627\";s:4:\"plid\";s:1:\"0\";s:9:\"link_path\";s:5:\"blogs\";s:11:\"router_path\";s:5:\"blogs\";s:10:\"link_title\";s:5:\"Blogs\";s:7:\"options\";s:49:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:0:\"\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"1\";s:8:\"expanded\";s:1:\"1\";s:6:\"weight\";s:3:\"-47\";s:5:\"depth\";s:1:\"1\";s:10:\"customized\";s:1:\"1\";s:2:\"p1\";s:3:\"627\";s:2:\"p2\";s:1:\"0\";s:2:\"p3\";s:1:\"0\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:12:\"views_access\";s:16:\"access_arguments\";s:80:\"a:1:{i:0;a:2:{i:0;s:16:\"views_check_perm\";i:1;a:1:{i:0;s:14:\"access content\";}}}\";s:13:\"page_callback\";s:10:\"views_page\";s:14:\"page_arguments\";s:39:\"a:2:{i:0;s:5:\"blogs\";i:1;s:6:\"page_1\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:5:\"blogs\";s:5:\"title\";s:5:\"Blogs\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:5:{i:308;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:9:\"main-menu\";s:4:\"mlid\";s:3:\"308\";s:4:\"plid\";s:3:\"627\";s:9:\"link_path\";s:4:\"blog\";s:11:\"router_path\";s:4:\"blog\";s:10:\"link_title\";s:13:\"Blogs Default\";s:7:\"options\";s:49:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:0:\"\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:3:\"-46\";s:5:\"depth\";s:1:\"2\";s:10:\"customized\";s:1:\"1\";s:2:\"p1\";s:3:\"627\";s:2:\"p2\";s:3:\"308\";s:2:\"p3\";s:1:\"0\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:32:\"a:1:{i:0;s:14:\"access content\";}\";s:13:\"page_callback\";s:14:\"blog_page_last\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:4:\"blog\";s:5:\"title\";s:5:\"Blogs\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:2:\"20\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:587;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:9:\"main-menu\";s:4:\"mlid\";s:3:\"587\";s:4:\"plid\";s:3:\"627\";s:9:\"link_path\";s:9:\"blogs/two\";s:11:\"router_path\";s:9:\"blogs/two\";s:10:\"link_title\";s:11:\"Two Columns\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:3:\"-47\";s:5:\"depth\";s:1:\"2\";s:10:\"customized\";s:1:\"1\";s:2:\"p1\";s:3:\"627\";s:2:\"p2\";s:3:\"587\";s:2:\"p3\";s:1:\"0\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:12:\"views_access\";s:16:\"access_arguments\";s:80:\"a:1:{i:0;a:2:{i:0;s:16:\"views_check_perm\";i:1;a:1:{i:0;s:14:\"access content\";}}}\";s:13:\"page_callback\";s:10:\"views_page\";s:14:\"page_arguments\";s:39:\"a:2:{i:0;s:5:\"blogs\";i:1;s:6:\"page_2\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:9:\"blogs/two\";s:5:\"title\";s:11:\"Two Columns\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:588;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:9:\"main-menu\";s:4:\"mlid\";s:3:\"588\";s:4:\"plid\";s:3:\"627\";s:9:\"link_path\";s:11:\"blogs/three\";s:11:\"router_path\";s:11:\"blogs/three\";s:10:\"link_title\";s:13:\"Three Columns\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:3:\"-48\";s:5:\"depth\";s:1:\"2\";s:10:\"customized\";s:1:\"1\";s:2:\"p1\";s:3:\"627\";s:2:\"p2\";s:3:\"588\";s:2:\"p3\";s:1:\"0\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:12:\"views_access\";s:16:\"access_arguments\";s:80:\"a:1:{i:0;a:2:{i:0;s:16:\"views_check_perm\";i:1;a:1:{i:0;s:14:\"access content\";}}}\";s:13:\"page_callback\";s:10:\"views_page\";s:14:\"page_arguments\";s:39:\"a:2:{i:0;s:5:\"blogs\";i:1;s:6:\"page_3\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:11:\"blogs/three\";s:5:\"title\";s:13:\"Three Columns\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:595;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:9:\"main-menu\";s:4:\"mlid\";s:3:\"595\";s:4:\"plid\";s:3:\"627\";s:9:\"link_path\";s:9:\"blogs/mix\";s:11:\"router_path\";s:9:\"blogs/mix\";s:10:\"link_title\";s:9:\"Blogs Mix\";s:7:\"options\";s:49:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:0:\"\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:3:\"-50\";s:5:\"depth\";s:1:\"2\";s:10:\"customized\";s:1:\"1\";s:2:\"p1\";s:3:\"627\";s:2:\"p2\";s:3:\"595\";s:2:\"p3\";s:1:\"0\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:12:\"views_access\";s:16:\"access_arguments\";s:80:\"a:1:{i:0;a:2:{i:0;s:16:\"views_check_perm\";i:1;a:1:{i:0;s:14:\"access content\";}}}\";s:13:\"page_callback\";s:10:\"views_page\";s:14:\"page_arguments\";s:39:\"a:2:{i:0;s:5:\"blogs\";i:1;s:6:\"page_4\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:9:\"blogs/mix\";s:5:\"title\";s:8:\"Blog Mix\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:626;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:9:\"main-menu\";s:4:\"mlid\";s:3:\"626\";s:4:\"plid\";s:3:\"627\";s:9:\"link_path\";s:12:\"blogs/teaser\";s:11:\"router_path\";s:12:\"blogs/teaser\";s:10:\"link_title\";s:12:\"Blogs Teaser\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:3:\"-49\";s:5:\"depth\";s:1:\"2\";s:10:\"customized\";s:1:\"1\";s:2:\"p1\";s:3:\"627\";s:2:\"p2\";s:3:\"626\";s:2:\"p3\";s:1:\"0\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:12:\"views_access\";s:16:\"access_arguments\";s:80:\"a:1:{i:0;a:2:{i:0;s:16:\"views_check_perm\";i:1;a:1:{i:0;s:14:\"access content\";}}}\";s:13:\"page_callback\";s:10:\"views_page\";s:14:\"page_arguments\";s:37:\"a:2:{i:0;s:5:\"blogs\";i:1;s:4:\"page\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:12:\"blogs/teaser\";s:5:\"title\";s:12:\"Blogs Teaser\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}}}}s:10:\"node_links\";a:7:{i:41;a:1:{i:620;R:1084;}i:33;a:1:{i:571;R:1130;}i:42;a:1:{i:621;R:1176;}i:43;a:1:{i:622;R:1222;}i:44;a:1:{i:623;R:1268;}i:45;a:1:{i:624;R:1314;}i:57;a:1:{i:675;R:1360;}}}',0,1512620340,1),('links:management:all:0:en:0','a:2:{s:9:\"min_depth\";i:1;s:9:\"max_depth\";N;}',0,1512620348,1),('links:management:tree-data:en:ec99d3452fef1ede622e66c68ba908b1dad455aa71f5e68648aeec6488b89c88','a:2:{s:4:\"tree\";a:1:{i:1;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:1:\"1\";s:4:\"plid\";s:1:\"0\";s:9:\"link_path\";s:5:\"admin\";s:11:\"router_path\";s:5:\"admin\";s:10:\"link_title\";s:14:\"Administration\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"1\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"9\";s:5:\"depth\";s:1:\"1\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"0\";s:2:\"p3\";s:1:\"0\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:45:\"a:1:{i:0;s:27:\"access administration pages\";}\";s:13:\"page_callback\";s:28:\"system_admin_menu_block_page\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:5:\"admin\";s:5:\"title\";s:14:\"Administration\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:11:{i:7;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:1:\"7\";s:4:\"plid\";s:1:\"1\";s:9:\"link_path\";s:16:\"admin/appearance\";s:11:\"router_path\";s:16:\"admin/appearance\";s:10:\"link_title\";s:10:\"Appearance\";s:7:\"options\";s:83:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:33:\"Select and configure your themes.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:2:\"-6\";s:5:\"depth\";s:1:\"2\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"7\";s:2:\"p3\";s:1:\"0\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:35:\"a:1:{i:0;s:17:\"administer themes\";}\";s:13:\"page_callback\";s:18:\"system_themes_page\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:16:\"admin/appearance\";s:5:\"title\";s:10:\"Appearance\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:33:\"Select and configure your themes.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:4:{i:42;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:2:\"42\";s:4:\"plid\";s:1:\"7\";s:9:\"link_path\";s:21:\"admin/appearance/list\";s:11:\"router_path\";s:21:\"admin/appearance/list\";s:10:\"link_title\";s:4:\"List\";s:7:\"options\";s:81:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:31:\"Select and configure your theme\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:2:\"-1\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"7\";s:2:\"p3\";s:2:\"42\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:35:\"a:1:{i:0;s:17:\"administer themes\";}\";s:13:\"page_callback\";s:18:\"system_themes_page\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:16:\"admin/appearance\";s:8:\"tab_root\";s:16:\"admin/appearance\";s:5:\"title\";s:4:\"List\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"140\";s:11:\"description\";s:31:\"Select and configure your theme\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:52;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:2:\"52\";s:4:\"plid\";s:1:\"7\";s:9:\"link_path\";s:25:\"admin/appearance/settings\";s:11:\"router_path\";s:25:\"admin/appearance/settings\";s:10:\"link_title\";s:8:\"Settings\";s:7:\"options\";s:96:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:46:\"Configure default and theme specific settings.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:2:\"20\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"7\";s:2:\"p3\";s:2:\"52\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:35:\"a:1:{i:0;s:17:\"administer themes\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:39:\"a:1:{i:0;s:21:\"system_theme_settings\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:16:\"admin/appearance\";s:8:\"tab_root\";s:16:\"admin/appearance\";s:5:\"title\";s:8:\"Settings\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:46:\"Configure default and theme specific settings.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:8:{i:68;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:2:\"68\";s:4:\"plid\";s:2:\"52\";s:9:\"link_path\";s:32:\"admin/appearance/settings/bartik\";s:11:\"router_path\";s:32:\"admin/appearance/settings/bartik\";s:10:\"link_title\";s:6:\"Bartik\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"7\";s:2:\"p3\";s:2:\"52\";s:2:\"p4\";s:2:\"68\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:21:\"_system_themes_access\";s:16:\"access_arguments\";s:2741:\"a:1:{i:0;O:8:\"stdClass\":12:{s:8:\"filename\";s:25:\"themes/bartik/bartik.info\";s:4:\"name\";s:6:\"bartik\";s:4:\"type\";s:5:\"theme\";s:5:\"owner\";s:45:\"themes/engines/phptemplate/phptemplate.engine\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:2:\"-1\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:19:{s:4:\"name\";s:6:\"Bartik\";s:11:\"description\";s:48:\"A flexible, recolorable theme with many regions.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:11:\"stylesheets\";a:2:{s:3:\"all\";a:3:{s:14:\"css/layout.css\";s:28:\"themes/bartik/css/layout.css\";s:13:\"css/style.css\";s:27:\"themes/bartik/css/style.css\";s:14:\"css/colors.css\";s:28:\"themes/bartik/css/colors.css\";}s:5:\"print\";a:1:{s:13:\"css/print.css\";s:27:\"themes/bartik/css/print.css\";}}s:7:\"regions\";a:20:{s:6:\"header\";s:6:\"Header\";s:4:\"help\";s:4:\"Help\";s:8:\"page_top\";s:8:\"Page top\";s:11:\"page_bottom\";s:11:\"Page bottom\";s:11:\"highlighted\";s:11:\"Highlighted\";s:8:\"featured\";s:8:\"Featured\";s:7:\"content\";s:7:\"Content\";s:13:\"sidebar_first\";s:13:\"Sidebar first\";s:14:\"sidebar_second\";s:14:\"Sidebar second\";s:14:\"triptych_first\";s:14:\"Triptych first\";s:15:\"triptych_middle\";s:15:\"Triptych middle\";s:13:\"triptych_last\";s:13:\"Triptych last\";s:18:\"footer_firstcolumn\";s:19:\"Footer first column\";s:19:\"footer_secondcolumn\";s:20:\"Footer second column\";s:18:\"footer_thirdcolumn\";s:19:\"Footer third column\";s:19:\"footer_fourthcolumn\";s:20:\"Footer fourth column\";s:6:\"footer\";s:6:\"Footer\";s:14:\"dashboard_main\";s:16:\"Dashboard (main)\";s:17:\"dashboard_sidebar\";s:19:\"Dashboard (sidebar)\";s:18:\"dashboard_inactive\";s:20:\"Dashboard (inactive)\";}s:8:\"settings\";a:1:{s:20:\"shortcut_module_link\";s:1:\"0\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:6:\"engine\";s:11:\"phptemplate\";s:8:\"features\";a:9:{i:0;s:4:\"logo\";i:1;s:7:\"favicon\";i:2;s:4:\"name\";i:3;s:6:\"slogan\";i:4;s:17:\"node_user_picture\";i:5;s:20:\"comment_user_picture\";i:6;s:25:\"comment_user_verification\";i:7;s:9:\"main_menu\";i:8;s:14:\"secondary_menu\";}s:10:\"screenshot\";s:28:\"themes/bartik/screenshot.png\";s:3:\"php\";s:5:\"5.2.4\";s:7:\"scripts\";a:0:{}s:5:\"mtime\";i:1498069849;s:15:\"overlay_regions\";a:5:{i:0;s:14:\"dashboard_main\";i:1;s:17:\"dashboard_sidebar\";i:2;s:18:\"dashboard_inactive\";i:3;s:7:\"content\";i:4;s:4:\"help\";}s:14:\"regions_hidden\";a:2:{i:0;s:8:\"page_top\";i:1;s:11:\"page_bottom\";}s:28:\"overlay_supplemental_regions\";a:1:{i:0;s:11:\"page_bottom\";}}s:6:\"prefix\";s:11:\"phptemplate\";s:11:\"stylesheets\";a:2:{s:3:\"all\";a:3:{s:14:\"css/layout.css\";s:28:\"themes/bartik/css/layout.css\";s:13:\"css/style.css\";s:27:\"themes/bartik/css/style.css\";s:14:\"css/colors.css\";s:28:\"themes/bartik/css/colors.css\";}s:5:\"print\";a:1:{s:13:\"css/print.css\";s:27:\"themes/bartik/css/print.css\";}}s:6:\"engine\";s:11:\"phptemplate\";}}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:56:\"a:2:{i:0;s:21:\"system_theme_settings\";i:1;s:6:\"bartik\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:25:\"admin/appearance/settings\";s:8:\"tab_root\";s:16:\"admin/appearance\";s:5:\"title\";s:6:\"Bartik\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:74;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:2:\"74\";s:4:\"plid\";s:2:\"52\";s:9:\"link_path\";s:33:\"admin/appearance/settings/garland\";s:11:\"router_path\";s:33:\"admin/appearance/settings/garland\";s:10:\"link_title\";s:7:\"Garland\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"7\";s:2:\"p3\";s:2:\"52\";s:2:\"p4\";s:2:\"74\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:21:\"_system_themes_access\";s:16:\"access_arguments\";s:2163:\"a:1:{i:0;O:8:\"stdClass\":12:{s:8:\"filename\";s:27:\"themes/garland/garland.info\";s:4:\"name\";s:7:\"garland\";s:4:\"type\";s:5:\"theme\";s:5:\"owner\";s:45:\"themes/engines/phptemplate/phptemplate.engine\";s:6:\"status\";s:1:\"0\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:2:\"-1\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:19:{s:4:\"name\";s:7:\"Garland\";s:11:\"description\";s:111:\"A multi-column theme which can be configured to modify colors and switch between fixed and fluid width layouts.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:11:\"stylesheets\";a:2:{s:3:\"all\";a:1:{s:9:\"style.css\";s:24:\"themes/garland/style.css\";}s:5:\"print\";a:1:{s:9:\"print.css\";s:24:\"themes/garland/print.css\";}}s:8:\"settings\";a:1:{s:13:\"garland_width\";s:5:\"fluid\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:6:\"engine\";s:11:\"phptemplate\";s:7:\"regions\";a:12:{s:13:\"sidebar_first\";s:12:\"Left sidebar\";s:14:\"sidebar_second\";s:13:\"Right sidebar\";s:7:\"content\";s:7:\"Content\";s:6:\"header\";s:6:\"Header\";s:6:\"footer\";s:6:\"Footer\";s:11:\"highlighted\";s:11:\"Highlighted\";s:4:\"help\";s:4:\"Help\";s:8:\"page_top\";s:8:\"Page top\";s:11:\"page_bottom\";s:11:\"Page bottom\";s:14:\"dashboard_main\";s:16:\"Dashboard (main)\";s:17:\"dashboard_sidebar\";s:19:\"Dashboard (sidebar)\";s:18:\"dashboard_inactive\";s:20:\"Dashboard (inactive)\";}s:8:\"features\";a:9:{i:0;s:4:\"logo\";i:1;s:7:\"favicon\";i:2;s:4:\"name\";i:3;s:6:\"slogan\";i:4;s:17:\"node_user_picture\";i:5;s:20:\"comment_user_picture\";i:6;s:25:\"comment_user_verification\";i:7;s:9:\"main_menu\";i:8;s:14:\"secondary_menu\";}s:10:\"screenshot\";s:29:\"themes/garland/screenshot.png\";s:3:\"php\";s:5:\"5.2.4\";s:7:\"scripts\";a:0:{}s:5:\"mtime\";i:1498069849;s:15:\"overlay_regions\";a:5:{i:0;s:14:\"dashboard_main\";i:1;s:17:\"dashboard_sidebar\";i:2;s:18:\"dashboard_inactive\";i:3;s:7:\"content\";i:4;s:4:\"help\";}s:14:\"regions_hidden\";a:2:{i:0;s:8:\"page_top\";i:1;s:11:\"page_bottom\";}s:28:\"overlay_supplemental_regions\";a:1:{i:0;s:11:\"page_bottom\";}}s:6:\"prefix\";s:11:\"phptemplate\";s:11:\"stylesheets\";a:2:{s:3:\"all\";a:1:{s:9:\"style.css\";s:24:\"themes/garland/style.css\";}s:5:\"print\";a:1:{s:9:\"print.css\";s:24:\"themes/garland/print.css\";}}s:6:\"engine\";s:11:\"phptemplate\";}}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:57:\"a:2:{i:0;s:21:\"system_theme_settings\";i:1;s:7:\"garland\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:25:\"admin/appearance/settings\";s:8:\"tab_root\";s:16:\"admin/appearance\";s:5:\"title\";s:7:\"Garland\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:75;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:2:\"75\";s:4:\"plid\";s:2:\"52\";s:9:\"link_path\";s:32:\"admin/appearance/settings/global\";s:11:\"router_path\";s:32:\"admin/appearance/settings/global\";s:10:\"link_title\";s:15:\"Global settings\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:2:\"-1\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"7\";s:2:\"p3\";s:2:\"52\";s:2:\"p4\";s:2:\"75\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:35:\"a:1:{i:0;s:17:\"administer themes\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:39:\"a:1:{i:0;s:21:\"system_theme_settings\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:25:\"admin/appearance/settings\";s:8:\"tab_root\";s:16:\"admin/appearance\";s:5:\"title\";s:15:\"Global settings\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"140\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:91;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:2:\"91\";s:4:\"plid\";s:2:\"52\";s:9:\"link_path\";s:31:\"admin/appearance/settings/seven\";s:11:\"router_path\";s:31:\"admin/appearance/settings/seven\";s:10:\"link_title\";s:5:\"Seven\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"7\";s:2:\"p3\";s:2:\"52\";s:2:\"p4\";s:2:\"91\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:21:\"_system_themes_access\";s:16:\"access_arguments\";s:1963:\"a:1:{i:0;O:8:\"stdClass\":12:{s:8:\"filename\";s:23:\"themes/seven/seven.info\";s:4:\"name\";s:5:\"seven\";s:4:\"type\";s:5:\"theme\";s:5:\"owner\";s:45:\"themes/engines/phptemplate/phptemplate.engine\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:2:\"-1\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:19:{s:4:\"name\";s:5:\"Seven\";s:11:\"description\";s:65:\"A simple one-column, tableless, fluid width administration theme.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:11:\"stylesheets\";a:1:{s:6:\"screen\";a:2:{s:9:\"reset.css\";s:22:\"themes/seven/reset.css\";s:9:\"style.css\";s:22:\"themes/seven/style.css\";}}s:8:\"settings\";a:1:{s:20:\"shortcut_module_link\";s:1:\"1\";}s:7:\"regions\";a:8:{s:7:\"content\";s:7:\"Content\";s:4:\"help\";s:4:\"Help\";s:8:\"page_top\";s:8:\"Page top\";s:11:\"page_bottom\";s:11:\"Page bottom\";s:13:\"sidebar_first\";s:13:\"First sidebar\";s:14:\"dashboard_main\";s:16:\"Dashboard (main)\";s:17:\"dashboard_sidebar\";s:19:\"Dashboard (sidebar)\";s:18:\"dashboard_inactive\";s:20:\"Dashboard (inactive)\";}s:14:\"regions_hidden\";a:3:{i:0;s:13:\"sidebar_first\";i:1;s:8:\"page_top\";i:2;s:11:\"page_bottom\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:6:\"engine\";s:11:\"phptemplate\";s:8:\"features\";a:9:{i:0;s:4:\"logo\";i:1;s:7:\"favicon\";i:2;s:4:\"name\";i:3;s:6:\"slogan\";i:4;s:17:\"node_user_picture\";i:5;s:20:\"comment_user_picture\";i:6;s:25:\"comment_user_verification\";i:7;s:9:\"main_menu\";i:8;s:14:\"secondary_menu\";}s:10:\"screenshot\";s:27:\"themes/seven/screenshot.png\";s:3:\"php\";s:5:\"5.2.4\";s:7:\"scripts\";a:0:{}s:5:\"mtime\";i:1498069849;s:15:\"overlay_regions\";a:5:{i:0;s:14:\"dashboard_main\";i:1;s:17:\"dashboard_sidebar\";i:2;s:18:\"dashboard_inactive\";i:3;s:7:\"content\";i:4;s:4:\"help\";}s:28:\"overlay_supplemental_regions\";a:1:{i:0;s:11:\"page_bottom\";}}s:6:\"prefix\";s:11:\"phptemplate\";s:11:\"stylesheets\";a:1:{s:6:\"screen\";a:2:{s:9:\"reset.css\";s:22:\"themes/seven/reset.css\";s:9:\"style.css\";s:22:\"themes/seven/style.css\";}}s:6:\"engine\";s:11:\"phptemplate\";}}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:55:\"a:2:{i:0;s:21:\"system_theme_settings\";i:1;s:5:\"seven\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:25:\"admin/appearance/settings\";s:8:\"tab_root\";s:16:\"admin/appearance\";s:5:\"title\";s:5:\"Seven\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:93;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:2:\"93\";s:4:\"plid\";s:2:\"52\";s:9:\"link_path\";s:31:\"admin/appearance/settings/stark\";s:11:\"router_path\";s:31:\"admin/appearance/settings/stark\";s:10:\"link_title\";s:5:\"Stark\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"7\";s:2:\"p3\";s:2:\"52\";s:2:\"p4\";s:2:\"93\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:21:\"_system_themes_access\";s:16:\"access_arguments\";s:2066:\"a:1:{i:0;O:8:\"stdClass\":12:{s:8:\"filename\";s:23:\"themes/stark/stark.info\";s:4:\"name\";s:5:\"stark\";s:4:\"type\";s:5:\"theme\";s:5:\"owner\";s:45:\"themes/engines/phptemplate/phptemplate.engine\";s:6:\"status\";s:1:\"0\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:2:\"-1\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:18:{s:4:\"name\";s:5:\"Stark\";s:11:\"description\";s:208:\"This theme demonstrates Drupal\'s default HTML markup and CSS styles. To learn how to build your own theme and override Drupal\'s default code, see the <a href=\"http://drupal.org/theme-guide\">Theming Guide</a>.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:11:\"stylesheets\";a:1:{s:3:\"all\";a:1:{s:10:\"layout.css\";s:23:\"themes/stark/layout.css\";}}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:6:\"engine\";s:11:\"phptemplate\";s:7:\"regions\";a:12:{s:13:\"sidebar_first\";s:12:\"Left sidebar\";s:14:\"sidebar_second\";s:13:\"Right sidebar\";s:7:\"content\";s:7:\"Content\";s:6:\"header\";s:6:\"Header\";s:6:\"footer\";s:6:\"Footer\";s:11:\"highlighted\";s:11:\"Highlighted\";s:4:\"help\";s:4:\"Help\";s:8:\"page_top\";s:8:\"Page top\";s:11:\"page_bottom\";s:11:\"Page bottom\";s:14:\"dashboard_main\";s:16:\"Dashboard (main)\";s:17:\"dashboard_sidebar\";s:19:\"Dashboard (sidebar)\";s:18:\"dashboard_inactive\";s:20:\"Dashboard (inactive)\";}s:8:\"features\";a:9:{i:0;s:4:\"logo\";i:1;s:7:\"favicon\";i:2;s:4:\"name\";i:3;s:6:\"slogan\";i:4;s:17:\"node_user_picture\";i:5;s:20:\"comment_user_picture\";i:6;s:25:\"comment_user_verification\";i:7;s:9:\"main_menu\";i:8;s:14:\"secondary_menu\";}s:10:\"screenshot\";s:27:\"themes/stark/screenshot.png\";s:3:\"php\";s:5:\"5.2.4\";s:7:\"scripts\";a:0:{}s:5:\"mtime\";i:1498069849;s:15:\"overlay_regions\";a:5:{i:0;s:14:\"dashboard_main\";i:1;s:17:\"dashboard_sidebar\";i:2;s:18:\"dashboard_inactive\";i:3;s:7:\"content\";i:4;s:4:\"help\";}s:14:\"regions_hidden\";a:2:{i:0;s:8:\"page_top\";i:1;s:11:\"page_bottom\";}s:28:\"overlay_supplemental_regions\";a:1:{i:0;s:11:\"page_bottom\";}}s:6:\"prefix\";s:11:\"phptemplate\";s:11:\"stylesheets\";a:1:{s:3:\"all\";a:1:{s:10:\"layout.css\";s:23:\"themes/stark/layout.css\";}}s:6:\"engine\";s:11:\"phptemplate\";}}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:55:\"a:2:{i:0;s:21:\"system_theme_settings\";i:1;s:5:\"stark\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:25:\"admin/appearance/settings\";s:8:\"tab_root\";s:16:\"admin/appearance\";s:5:\"title\";s:5:\"Stark\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:360;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"360\";s:4:\"plid\";s:2:\"52\";s:9:\"link_path\";s:36:\"admin/appearance/settings/forum_plus\";s:11:\"router_path\";s:36:\"admin/appearance/settings/forum_plus\";s:10:\"link_title\";s:10:\"Forum Plus\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"7\";s:2:\"p3\";s:2:\"52\";s:2:\"p4\";s:3:\"360\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:21:\"_system_themes_access\";s:16:\"access_arguments\";s:4909:\"a:1:{i:0;O:8:\"stdClass\":13:{s:8:\"filename\";s:43:\"sites/all/themes/forum_plus/forum_plus.info\";s:4:\"name\";s:10:\"forum_plus\";s:4:\"type\";s:5:\"theme\";s:5:\"owner\";s:45:\"themes/engines/phptemplate/phptemplate.engine\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:2:\"-1\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:20:{s:4:\"name\";s:10:\"Forum Plus\";s:11:\"description\";s:23:\"Theme for the Companies\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:6:\"engine\";s:11:\"phptemplate\";s:11:\"stylesheets\";a:1:{s:3:\"all\";a:3:{s:34:\"vendor/bootstrap/css/bootstrap.css\";s:62:\"sites/all/themes/forum_plus/vendor/bootstrap/css/bootstrap.css\";s:40:\"vendor/bootstrap/css/bootstrap-theme.css\";s:68:\"sites/all/themes/forum_plus/vendor/bootstrap/css/bootstrap-theme.css\";s:14:\"css/styles.css\";s:42:\"sites/all/themes/forum_plus/css/styles.css\";}}s:7:\"scripts\";a:8:{s:32:\"vendor/bootstrap/js/bootstrap.js\";s:60:\"sites/all/themes/forum_plus/vendor/bootstrap/js/bootstrap.js\";s:26:\"js/jquery.smooth-scroll.js\";s:54:\"sites/all/themes/forum_plus/js/jquery.smooth-scroll.js\";s:19:\"js/jquery.cookie.js\";s:47:\"sites/all/themes/forum_plus/js/jquery.cookie.js\";s:24:\"js/jquery.matchHeight.js\";s:52:\"sites/all/themes/forum_plus/js/jquery.matchHeight.js\";s:12:\"js/moment.js\";s:40:\"sites/all/themes/forum_plus/js/moment.js\";s:20:\"js/accordion_menu.js\";s:48:\"sites/all/themes/forum_plus/js/accordion_menu.js\";s:13:\"js/weebpal.js\";s:41:\"sites/all/themes/forum_plus/js/weebpal.js\";s:16:\"js/forum_plus.js\";s:44:\"sites/all/themes/forum_plus/js/forum_plus.js\";}s:8:\"features\";a:7:{i:0;s:4:\"logo\";i:1;s:4:\"name\";i:2;s:6:\"slogan\";i:3;s:17:\"node_user_picture\";i:4;s:20:\"comment_user_picture\";i:5;s:25:\"comment_user_verification\";i:6;s:7:\"favicon\";}s:7:\"regions\";a:25:{s:8:\"headline\";s:8:\"Headline\";s:6:\"header\";s:6:\"Header\";s:9:\"main_menu\";s:9:\"Main Menu\";s:9:\"slideshow\";s:9:\"Slideshow\";s:4:\"help\";s:4:\"Help\";s:8:\"page_top\";s:8:\"Page top\";s:11:\"page_bottom\";s:11:\"Page bottom\";s:11:\"highlighted\";s:11:\"Highlighted\";s:8:\"featured\";s:8:\"Featured\";s:7:\"content\";s:7:\"Content\";s:13:\"sidebar_first\";s:13:\"Sidebar first\";s:14:\"sidebar_second\";s:14:\"Sidebar second\";s:7:\"welcome\";s:7:\"Welcome\";s:11:\"panel_first\";s:11:\"Panel First\";s:12:\"panel_second\";s:12:\"Panel Second\";s:11:\"panel_third\";s:11:\"Panel Third\";s:4:\"gmap\";s:4:\"GMap\";s:14:\"panel_footer_1\";s:14:\"Panel Footer 1\";s:14:\"panel_footer_2\";s:14:\"Panel Footer 2\";s:14:\"panel_footer_3\";s:14:\"Panel Footer 3\";s:14:\"panel_footer_4\";s:14:\"Panel Footer 4\";s:6:\"footer\";s:6:\"Footer\";s:14:\"dashboard_main\";s:16:\"Dashboard (main)\";s:17:\"dashboard_sidebar\";s:19:\"Dashboard (sidebar)\";s:18:\"dashboard_inactive\";s:20:\"Dashboard (inactive)\";}s:8:\"settings\";a:7:{s:19:\"sidebar_first_width\";s:1:\"3\";s:20:\"sidebar_second_width\";s:1:\"3\";s:20:\"panel_footer_1_width\";s:1:\"3\";s:20:\"panel_footer_2_width\";s:1:\"3\";s:20:\"panel_footer_3_width\";s:1:\"3\";s:20:\"panel_footer_4_width\";s:1:\"3\";s:20:\"layout_width_default\";s:4:\"1200\";}s:5:\"skins\";a:3:{s:3:\"red\";s:3:\"Red\";s:6:\"yellow\";s:6:\"Yellow\";s:5:\"green\";s:5:\"Green\";}s:7:\"plugins\";a:1:{s:14:\"advanced_forum\";a:1:{s:6:\"styles\";s:23:\"css/advanced_forum/plus\";}}s:11:\"backgrounds\";a:7:{s:4:\"bg-1\";s:12:\"Background 1\";s:4:\"bg-2\";s:12:\"Background 2\";s:4:\"bg-3\";s:12:\"Background 3\";s:4:\"bg-4\";s:12:\"Background 4\";s:4:\"bg-5\";s:12:\"Background 5\";s:4:\"bg-6\";s:12:\"Background 6\";s:4:\"bg-7\";s:12:\"Background 7\";}s:6:\"layout\";a:1:{s:12:\"layout-boxed\";s:12:\"Boxed Layout\";}s:10:\"screenshot\";s:42:\"sites/all/themes/forum_plus/screenshot.png\";s:3:\"php\";s:5:\"5.2.4\";s:5:\"mtime\";i:1499928385;s:15:\"overlay_regions\";a:5:{i:0;s:14:\"dashboard_main\";i:1;s:17:\"dashboard_sidebar\";i:2;s:18:\"dashboard_inactive\";i:3;s:7:\"content\";i:4;s:4:\"help\";}s:14:\"regions_hidden\";a:2:{i:0;s:8:\"page_top\";i:1;s:11:\"page_bottom\";}s:28:\"overlay_supplemental_regions\";a:1:{i:0;s:11:\"page_bottom\";}}s:6:\"prefix\";s:11:\"phptemplate\";s:11:\"stylesheets\";a:1:{s:3:\"all\";a:3:{s:34:\"vendor/bootstrap/css/bootstrap.css\";s:62:\"sites/all/themes/forum_plus/vendor/bootstrap/css/bootstrap.css\";s:40:\"vendor/bootstrap/css/bootstrap-theme.css\";s:68:\"sites/all/themes/forum_plus/vendor/bootstrap/css/bootstrap-theme.css\";s:14:\"css/styles.css\";s:42:\"sites/all/themes/forum_plus/css/styles.css\";}}s:7:\"scripts\";a:8:{s:32:\"vendor/bootstrap/js/bootstrap.js\";s:60:\"sites/all/themes/forum_plus/vendor/bootstrap/js/bootstrap.js\";s:26:\"js/jquery.smooth-scroll.js\";s:54:\"sites/all/themes/forum_plus/js/jquery.smooth-scroll.js\";s:19:\"js/jquery.cookie.js\";s:47:\"sites/all/themes/forum_plus/js/jquery.cookie.js\";s:24:\"js/jquery.matchHeight.js\";s:52:\"sites/all/themes/forum_plus/js/jquery.matchHeight.js\";s:12:\"js/moment.js\";s:40:\"sites/all/themes/forum_plus/js/moment.js\";s:20:\"js/accordion_menu.js\";s:48:\"sites/all/themes/forum_plus/js/accordion_menu.js\";s:13:\"js/weebpal.js\";s:41:\"sites/all/themes/forum_plus/js/weebpal.js\";s:16:\"js/forum_plus.js\";s:44:\"sites/all/themes/forum_plus/js/forum_plus.js\";}s:6:\"engine\";s:11:\"phptemplate\";}}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:61:\"a:2:{i:0;s:21:\"system_theme_settings\";i:1;s:10:\"forum_plus\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:25:\"admin/appearance/settings\";s:8:\"tab_root\";s:16:\"admin/appearance\";s:5:\"title\";s:10:\"Forum Plus\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:898;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"898\";s:4:\"plid\";s:2:\"52\";s:9:\"link_path\";s:30:\"admin/appearance/settings/plus\";s:11:\"router_path\";s:30:\"admin/appearance/settings/plus\";s:10:\"link_title\";s:4:\"Plus\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"7\";s:2:\"p3\";s:2:\"52\";s:2:\"p4\";s:3:\"898\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:21:\"_system_themes_access\";s:16:\"access_arguments\";s:1837:\"a:1:{i:0;O:8:\"stdClass\":11:{s:8:\"filename\";s:61:\"sites/all/themes/forum_plus/css/advanced_forum/plus/plus.info\";s:4:\"name\";s:4:\"plus\";s:4:\"type\";s:5:\"theme\";s:5:\"owner\";s:45:\"themes/engines/phptemplate/phptemplate.engine\";s:6:\"status\";s:1:\"0\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:2:\"-1\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:18:{s:4:\"name\";s:4:\"Plus\";s:11:\"description\";s:43:\"Based on the Blue Lagoon colors of Garland.\";s:7:\"version\";s:7:\"7.x-2.3\";s:10:\"base style\";s:5:\"naked\";s:4:\"core\";s:3:\"7.x\";s:7:\"project\";s:14:\"advanced_forum\";s:9:\"datestamp\";s:10:\"1373223651\";s:6:\"engine\";s:11:\"phptemplate\";s:7:\"regions\";a:12:{s:13:\"sidebar_first\";s:12:\"Left sidebar\";s:14:\"sidebar_second\";s:13:\"Right sidebar\";s:7:\"content\";s:7:\"Content\";s:6:\"header\";s:6:\"Header\";s:6:\"footer\";s:6:\"Footer\";s:11:\"highlighted\";s:11:\"Highlighted\";s:4:\"help\";s:4:\"Help\";s:8:\"page_top\";s:8:\"Page top\";s:11:\"page_bottom\";s:11:\"Page bottom\";s:14:\"dashboard_main\";s:16:\"Dashboard (main)\";s:17:\"dashboard_sidebar\";s:19:\"Dashboard (sidebar)\";s:18:\"dashboard_inactive\";s:20:\"Dashboard (inactive)\";}s:8:\"features\";a:9:{i:0;s:4:\"logo\";i:1;s:7:\"favicon\";i:2;s:4:\"name\";i:3;s:6:\"slogan\";i:4;s:17:\"node_user_picture\";i:5;s:20:\"comment_user_picture\";i:6;s:25:\"comment_user_verification\";i:7;s:9:\"main_menu\";i:8;s:14:\"secondary_menu\";}s:10:\"screenshot\";s:66:\"sites/all/themes/forum_plus/css/advanced_forum/plus/screenshot.png\";s:3:\"php\";s:5:\"5.2.4\";s:11:\"stylesheets\";a:0:{}s:7:\"scripts\";a:0:{}s:5:\"mtime\";i:1499928385;s:15:\"overlay_regions\";a:5:{i:0;s:14:\"dashboard_main\";i:1;s:17:\"dashboard_sidebar\";i:2;s:18:\"dashboard_inactive\";i:3;s:7:\"content\";i:4;s:4:\"help\";}s:14:\"regions_hidden\";a:2:{i:0;s:8:\"page_top\";i:1;s:11:\"page_bottom\";}s:28:\"overlay_supplemental_regions\";a:1:{i:0;s:11:\"page_bottom\";}}s:6:\"prefix\";s:11:\"phptemplate\";s:6:\"engine\";s:11:\"phptemplate\";}}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:54:\"a:2:{i:0;s:21:\"system_theme_settings\";i:1;s:4:\"plus\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:25:\"admin/appearance/settings\";s:8:\"tab_root\";s:16:\"admin/appearance\";s:5:\"title\";s:4:\"Plus\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:914;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"914\";s:4:\"plid\";s:2:\"52\";s:9:\"link_path\";s:36:\"admin/appearance/settings/we_backend\";s:11:\"router_path\";s:36:\"admin/appearance/settings/we_backend\";s:10:\"link_title\";s:21:\"WeebPal Backend theme\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"7\";s:2:\"p3\";s:2:\"52\";s:2:\"p4\";s:3:\"914\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:21:\"_system_themes_access\";s:16:\"access_arguments\";s:2001:\"a:1:{i:0;O:8:\"stdClass\":13:{s:8:\"filename\";s:43:\"sites/all/themes/we_backend/we_backend.info\";s:4:\"name\";s:10:\"we_backend\";s:4:\"type\";s:5:\"theme\";s:5:\"owner\";s:45:\"themes/engines/phptemplate/phptemplate.engine\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:2:\"-1\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:15:{s:4:\"name\";s:21:\"WeebPal Backend theme\";s:11:\"description\";s:26:\"Backend theme from WeebPal\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:6:\"engine\";s:11:\"phptemplate\";s:11:\"stylesheets\";a:1:{s:3:\"all\";a:1:{s:20:\"assets/css/style.css\";s:48:\"sites/all/themes/we_backend/assets/css/style.css\";}}s:7:\"scripts\";a:1:{s:20:\"assets/js/scripts.js\";s:48:\"sites/all/themes/we_backend/assets/js/scripts.js\";}s:8:\"features\";a:7:{i:0;s:4:\"logo\";i:1;s:4:\"name\";i:2;s:6:\"slogan\";i:3;s:17:\"node_user_picture\";i:4;s:20:\"comment_user_picture\";i:5;s:25:\"comment_user_verification\";i:6;s:7:\"favicon\";}s:7:\"regions\";a:10:{s:6:\"header\";s:6:\"Header\";s:11:\"highlighted\";s:11:\"Highlighted\";s:4:\"help\";s:4:\"Help\";s:7:\"content\";s:7:\"Content\";s:13:\"sidebar_first\";s:13:\"Sidebar first\";s:14:\"sidebar_second\";s:14:\"Sidebar second\";s:6:\"footer\";s:6:\"Footer\";s:14:\"dashboard_main\";s:16:\"Dashboard (main)\";s:17:\"dashboard_sidebar\";s:19:\"Dashboard (sidebar)\";s:18:\"dashboard_inactive\";s:20:\"Dashboard (inactive)\";}s:10:\"screenshot\";s:42:\"sites/all/themes/we_backend/screenshot.png\";s:3:\"php\";s:5:\"5.2.4\";s:5:\"mtime\";i:1499643480;s:15:\"overlay_regions\";a:5:{i:0;s:14:\"dashboard_main\";i:1;s:17:\"dashboard_sidebar\";i:2;s:18:\"dashboard_inactive\";i:3;s:7:\"content\";i:4;s:4:\"help\";}s:14:\"regions_hidden\";a:2:{i:0;s:8:\"page_top\";i:1;s:11:\"page_bottom\";}s:28:\"overlay_supplemental_regions\";a:1:{i:0;s:11:\"page_bottom\";}}s:6:\"prefix\";s:11:\"phptemplate\";s:11:\"stylesheets\";a:1:{s:3:\"all\";a:1:{s:20:\"assets/css/style.css\";s:48:\"sites/all/themes/we_backend/assets/css/style.css\";}}s:7:\"scripts\";a:1:{s:20:\"assets/js/scripts.js\";s:48:\"sites/all/themes/we_backend/assets/js/scripts.js\";}s:6:\"engine\";s:11:\"phptemplate\";}}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:61:\"a:2:{i:0;s:21:\"system_theme_settings\";i:1;s:10:\"we_backend\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:25:\"admin/appearance/settings\";s:8:\"tab_root\";s:16:\"admin/appearance\";s:5:\"title\";s:21:\"WeebPal Backend theme\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}}}i:261;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"261\";s:4:\"plid\";s:1:\"7\";s:9:\"link_path\";s:24:\"admin/appearance/install\";s:11:\"router_path\";s:24:\"admin/appearance/install\";s:10:\"link_title\";s:17:\"Install new theme\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:2:\"25\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"7\";s:2:\"p3\";s:3:\"261\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:21:\"update_manager_access\";s:16:\"access_arguments\";s:6:\"a:0:{}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:61:\"a:2:{i:0;s:27:\"update_manager_install_form\";i:1;s:5:\"theme\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:16:\"admin/appearance\";s:8:\"tab_root\";s:16:\"admin/appearance\";s:5:\"title\";s:17:\"Install new theme\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"388\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:264;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"264\";s:4:\"plid\";s:1:\"7\";s:9:\"link_path\";s:23:\"admin/appearance/update\";s:11:\"router_path\";s:23:\"admin/appearance/update\";s:10:\"link_title\";s:6:\"Update\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:2:\"10\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"7\";s:2:\"p3\";s:3:\"264\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:21:\"update_manager_access\";s:16:\"access_arguments\";s:6:\"a:0:{}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:60:\"a:2:{i:0;s:26:\"update_manager_update_form\";i:1;s:5:\"theme\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:16:\"admin/appearance\";s:8:\"tab_root\";s:16:\"admin/appearance\";s:5:\"title\";s:6:\"Update\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}}}i:8;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:1:\"8\";s:4:\"plid\";s:1:\"1\";s:9:\"link_path\";s:12:\"admin/config\";s:11:\"router_path\";s:12:\"admin/config\";s:10:\"link_title\";s:13:\"Configuration\";s:7:\"options\";s:70:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:20:\"Administer settings.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"1\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"2\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:1:\"0\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:45:\"a:1:{i:0;s:27:\"access administration pages\";}\";s:13:\"page_callback\";s:24:\"system_admin_config_page\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:12:\"admin/config\";s:5:\"title\";s:13:\"Configuration\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:20:\"Administer settings.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:12:{i:33;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:2:\"33\";s:4:\"plid\";s:1:\"8\";s:9:\"link_path\";s:20:\"admin/config/content\";s:11:\"router_path\";s:20:\"admin/config/content\";s:10:\"link_title\";s:17:\"Content authoring\";s:7:\"options\";s:103:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:53:\"Settings related to formatting and authoring content.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"1\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:3:\"-15\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"33\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:45:\"a:1:{i:0;s:27:\"access administration pages\";}\";s:13:\"page_callback\";s:28:\"system_admin_menu_block_page\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:20:\"admin/config/content\";s:5:\"title\";s:17:\"Content authoring\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:53:\"Settings related to formatting and authoring content.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:8:{i:94;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:2:\"94\";s:4:\"plid\";s:2:\"33\";s:9:\"link_path\";s:28:\"admin/config/content/formats\";s:11:\"router_path\";s:28:\"admin/config/content/formats\";s:10:\"link_title\";s:12:\"Text formats\";s:7:\"options\";s:178:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:127:\"Configure how content input by users is filtered, including allowed HTML tags. Also allows enabling of module-provided filters.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"1\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"33\";s:2:\"p4\";s:2:\"94\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:36:\"a:1:{i:0;s:18:\"administer filters\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:39:\"a:1:{i:0;s:21:\"filter_admin_overview\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:28:\"admin/config/content/formats\";s:5:\"title\";s:12:\"Text formats\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:127:\"Configure how content input by users is filtered, including allowed HTML tags. Also allows enabling of module-provided filters.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:3:{i:98;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:2:\"98\";s:4:\"plid\";s:2:\"94\";s:9:\"link_path\";s:30:\"admin/config/content/formats/%\";s:11:\"router_path\";s:30:\"admin/config/content/formats/%\";s:10:\"link_title\";s:0:\"\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"1\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"33\";s:2:\"p4\";s:2:\"94\";s:2:\"p5\";s:2:\"98\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:36:\"a:1:{i:4;s:18:\"filter_format_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:36:\"a:1:{i:0;s:18:\"administer filters\";}\";s:13:\"page_callback\";s:24:\"filter_admin_format_page\";s:14:\"page_arguments\";s:14:\"a:1:{i:0;i:4;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:30:\"admin/config/content/formats/%\";s:5:\"title\";s:0:\"\";s:14:\"title_callback\";s:25:\"filter_admin_format_title\";s:15:\"title_arguments\";s:14:\"a:1:{i:0;i:4;}\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:1:{i:131;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"131\";s:4:\"plid\";s:2:\"98\";s:9:\"link_path\";s:38:\"admin/config/content/formats/%/disable\";s:11:\"router_path\";s:38:\"admin/config/content/formats/%/disable\";s:10:\"link_title\";s:19:\"Disable text format\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"6\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"33\";s:2:\"p4\";s:2:\"94\";s:2:\"p5\";s:2:\"98\";s:2:\"p6\";s:3:\"131\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:36:\"a:1:{i:4;s:18:\"filter_format_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:29:\"_filter_disable_format_access\";s:16:\"access_arguments\";s:14:\"a:1:{i:0;i:4;}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:46:\"a:2:{i:0;s:20:\"filter_admin_disable\";i:1;i:4;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:38:\"admin/config/content/formats/%/disable\";s:5:\"title\";s:19:\"Disable text format\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}}}i:100;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"100\";s:4:\"plid\";s:2:\"94\";s:9:\"link_path\";s:32:\"admin/config/content/formats/add\";s:11:\"router_path\";s:32:\"admin/config/content/formats/add\";s:10:\"link_title\";s:15:\"Add text format\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"1\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"33\";s:2:\"p4\";s:2:\"94\";s:2:\"p5\";s:3:\"100\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:36:\"a:1:{i:0;s:18:\"administer filters\";}\";s:13:\"page_callback\";s:24:\"filter_admin_format_page\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:28:\"admin/config/content/formats\";s:8:\"tab_root\";s:28:\"admin/config/content/formats\";s:5:\"title\";s:15:\"Add text format\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"388\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:107;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"107\";s:4:\"plid\";s:2:\"94\";s:9:\"link_path\";s:33:\"admin/config/content/formats/list\";s:11:\"router_path\";s:33:\"admin/config/content/formats/list\";s:10:\"link_title\";s:4:\"List\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"33\";s:2:\"p4\";s:2:\"94\";s:2:\"p5\";s:3:\"107\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:36:\"a:1:{i:0;s:18:\"administer filters\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:39:\"a:1:{i:0;s:21:\"filter_admin_overview\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:28:\"admin/config/content/formats\";s:8:\"tab_root\";s:28:\"admin/config/content/formats\";s:5:\"title\";s:4:\"List\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"140\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}}}i:417;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"417\";s:4:\"plid\";s:2:\"33\";s:9:\"link_path\";s:30:\"admin/config/content/tagclouds\";s:11:\"router_path\";s:30:\"admin/config/content/tagclouds\";s:10:\"link_title\";s:23:\"TagClouds configuration\";s:7:\"options\";s:139:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:89:\"Configure the tag clouds. Set the order, the number of tags, and the depth of the clouds.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"33\";s:2:\"p4\";s:3:\"417\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:37:\"a:1:{i:0;s:19:\"administer taxonomy\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:36:\"a:1:{i:0;s:18:\"tagclouds_settings\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:30:\"admin/config/content/tagclouds\";s:5:\"title\";s:23:\"TagClouds configuration\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:89:\"Configure the tag clouds. Set the order, the number of tags, and the depth of the clouds.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:419;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"419\";s:4:\"plid\";s:2:\"33\";s:9:\"link_path\";s:35:\"admin/config/content/advanced-forum\";s:11:\"router_path\";s:35:\"admin/config/content/advanced-forum\";s:10:\"link_title\";s:14:\"Advanced Forum\";s:7:\"options\";s:95:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:45:\"Configure Advanced Forum with these settings.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"33\";s:2:\"p4\";s:3:\"419\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:43:\"a:1:{i:0;s:25:\"administer advanced forum\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:46:\"a:1:{i:0;s:28:\"advanced_forum_settings_page\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:35:\"admin/config/content/advanced-forum\";s:5:\"title\";s:14:\"Advanced Forum\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:45:\"Configure Advanced Forum with these settings.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:437;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"437\";s:4:\"plid\";s:2:\"33\";s:9:\"link_path\";s:29:\"admin/config/content/fivestar\";s:11:\"router_path\";s:29:\"admin/config/content/fivestar\";s:10:\"link_title\";s:8:\"Fivestar\";s:7:\"options\";s:103:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:53:\"Configure site-wide widgets used for Fivestar rating.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"33\";s:2:\"p4\";s:3:\"437\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:47:\"a:1:{i:0;s:29:\"administer site configuration\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:35:\"a:1:{i:0;s:17:\"fivestar_settings\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:29:\"admin/config/content/fivestar\";s:5:\"title\";s:8:\"Fivestar\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:53:\"Configure site-wide widgets used for Fivestar rating.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:552;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"552\";s:4:\"plid\";s:2:\"33\";s:9:\"link_path\";s:24:\"admin/config/content/faq\";s:11:\"router_path\";s:24:\"admin/config/content/faq\";s:10:\"link_title\";s:26:\"Frequently Asked Questions\";s:7:\"options\";s:129:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:79:\"Allows the user to configure the layout of questions and answers on a FAQ page.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"33\";s:2:\"p4\";s:3:\"552\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:32:\"a:1:{i:0;s:14:\"administer faq\";}\";s:13:\"page_callback\";s:17:\"faq_settings_page\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:24:\"admin/config/content/faq\";s:5:\"title\";s:26:\"Frequently Asked Questions\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:79:\"Allows the user to configure the layout of questions and answers on a FAQ page.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:3:{i:553;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"553\";s:4:\"plid\";s:3:\"552\";s:9:\"link_path\";s:35:\"admin/config/content/faq/categories\";s:11:\"router_path\";s:35:\"admin/config/content/faq/categories\";s:10:\"link_title\";s:10:\"Categories\";s:7:\"options\";s:146:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:96:\"Allows the user to configure the layout of questions and answers using categories on a FAQ page.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:2:\"-8\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"33\";s:2:\"p4\";s:3:\"552\";s:2:\"p5\";s:3:\"553\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:32:\"a:1:{i:0;s:14:\"administer faq\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:46:\"a:1:{i:0;s:28:\"faq_categories_settings_form\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:24:\"admin/config/content/faq\";s:8:\"tab_root\";s:24:\"admin/config/content/faq\";s:5:\"title\";s:10:\"Categories\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:96:\"Allows the user to configure the layout of questions and answers using categories on a FAQ page.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:554;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"554\";s:4:\"plid\";s:3:\"552\";s:9:\"link_path\";s:32:\"admin/config/content/faq/general\";s:11:\"router_path\";s:32:\"admin/config/content/faq/general\";s:10:\"link_title\";s:7:\"General\";s:7:\"options\";s:128:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:78:\"Allows the user to configure the header and descriptive text for the FAQ page.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:3:\"-10\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"33\";s:2:\"p4\";s:3:\"552\";s:2:\"p5\";s:3:\"554\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:32:\"a:1:{i:0;s:14:\"administer faq\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:43:\"a:1:{i:0;s:25:\"faq_general_settings_form\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:24:\"admin/config/content/faq\";s:8:\"tab_root\";s:24:\"admin/config/content/faq\";s:5:\"title\";s:7:\"General\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"140\";s:11:\"description\";s:78:\"Allows the user to configure the header and descriptive text for the FAQ page.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:555;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"555\";s:4:\"plid\";s:3:\"552\";s:9:\"link_path\";s:34:\"admin/config/content/faq/questions\";s:11:\"router_path\";s:34:\"admin/config/content/faq/questions\";s:10:\"link_title\";s:9:\"Questions\";s:7:\"options\";s:129:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:79:\"Allows the user to configure the layout of questions and answers on a FAQ page.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:2:\"-9\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"33\";s:2:\"p4\";s:3:\"552\";s:2:\"p5\";s:3:\"555\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:32:\"a:1:{i:0;s:14:\"administer faq\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:45:\"a:1:{i:0;s:27:\"faq_questions_settings_form\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:24:\"admin/config/content/faq\";s:8:\"tab_root\";s:24:\"admin/config/content/faq\";s:5:\"title\";s:9:\"Questions\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:79:\"Allows the user to configure the layout of questions and answers on a FAQ page.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}}}i:609;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"609\";s:4:\"plid\";s:2:\"33\";s:9:\"link_path\";s:28:\"admin/config/content/webform\";s:11:\"router_path\";s:28:\"admin/config/content/webform\";s:10:\"link_title\";s:16:\"Webform settings\";s:7:\"options\";s:96:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:46:\"Global configuration of webform functionality.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"33\";s:2:\"p4\";s:3:\"609\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:47:\"a:1:{i:0;s:29:\"administer site configuration\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:40:\"a:1:{i:0;s:22:\"webform_admin_settings\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:28:\"admin/config/content/webform\";s:5:\"title\";s:16:\"Webform settings\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:46:\"Global configuration of webform functionality.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:619;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"619\";s:4:\"plid\";s:2:\"33\";s:9:\"link_path\";s:34:\"admin/config/content/webform-hints\";s:11:\"router_path\";s:34:\"admin/config/content/webform-hints\";s:10:\"link_title\";s:22:\"Webform Hints settings\";s:7:\"options\";s:114:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:64:\"Administer which of your Webforms will receive the hints effect.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"33\";s:2:\"p4\";s:3:\"619\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:51:\"a:1:{i:0;s:33:\"administer Webform Hints settings\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:46:\"a:1:{i:0;s:28:\"webform_hints_admin_settings\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:34:\"admin/config/content/webform-hints\";s:5:\"title\";s:22:\"Webform Hints settings\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:64:\"Administer which of your Webforms will receive the hints effect.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:685;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"685\";s:4:\"plid\";s:2:\"33\";s:9:\"link_path\";s:29:\"admin/config/content/ckeditor\";s:11:\"router_path\";s:29:\"admin/config/content/ckeditor\";s:10:\"link_title\";s:8:\"CKEditor\";s:7:\"options\";s:81:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:31:\"Configure the rich text editor.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"33\";s:2:\"p4\";s:3:\"685\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:37:\"a:1:{i:0;s:19:\"administer ckeditor\";}\";s:13:\"page_callback\";s:19:\"ckeditor_admin_main\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:29:\"admin/config/content/ckeditor\";s:5:\"title\";s:8:\"CKEditor\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:31:\"Configure the rich text editor.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}}}i:37;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:2:\"37\";s:4:\"plid\";s:1:\"8\";s:9:\"link_path\";s:24:\"admin/config/development\";s:11:\"router_path\";s:24:\"admin/config/development\";s:10:\"link_title\";s:11:\"Development\";s:7:\"options\";s:68:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:18:\"Development tools.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"1\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:3:\"-10\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"37\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:45:\"a:1:{i:0;s:27:\"access administration pages\";}\";s:13:\"page_callback\";s:28:\"system_admin_menu_block_page\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:24:\"admin/config/development\";s:5:\"title\";s:11:\"Development\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:18:\"Development tools.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:6:{i:82;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:2:\"82\";s:4:\"plid\";s:2:\"37\";s:9:\"link_path\";s:32:\"admin/config/development/logging\";s:11:\"router_path\";s:32:\"admin/config/development/logging\";s:10:\"link_title\";s:18:\"Logging and errors\";s:7:\"options\";s:205:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:154:\"Settings for logging and alerts modules. Various modules can route Drupal\'s system events to different destinations, such as syslog, database, email, etc.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:3:\"-15\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"37\";s:2:\"p4\";s:2:\"82\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:47:\"a:1:{i:0;s:29:\"administer site configuration\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:41:\"a:1:{i:0;s:23:\"system_logging_settings\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:32:\"admin/config/development/logging\";s:5:\"title\";s:18:\"Logging and errors\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:154:\"Settings for logging and alerts modules. Various modules can route Drupal\'s system events to different destinations, such as syslog, database, email, etc.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:83;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:2:\"83\";s:4:\"plid\";s:2:\"37\";s:9:\"link_path\";s:36:\"admin/config/development/maintenance\";s:11:\"router_path\";s:36:\"admin/config/development/maintenance\";s:10:\"link_title\";s:16:\"Maintenance mode\";s:7:\"options\";s:112:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:62:\"Take the site offline for maintenance or bring it back online.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:3:\"-10\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"37\";s:2:\"p4\";s:2:\"83\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:47:\"a:1:{i:0;s:29:\"administer site configuration\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:46:\"a:1:{i:0;s:28:\"system_site_maintenance_mode\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:36:\"admin/config/development/maintenance\";s:5:\"title\";s:16:\"Maintenance mode\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:62:\"Take the site offline for maintenance or bring it back online.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:84;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:2:\"84\";s:4:\"plid\";s:2:\"37\";s:9:\"link_path\";s:36:\"admin/config/development/performance\";s:11:\"router_path\";s:36:\"admin/config/development/performance\";s:10:\"link_title\";s:11:\"Performance\";s:7:\"options\";s:152:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:101:\"Enable or disable page caching for anonymous users and set CSS and JS bandwidth optimization options.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:3:\"-20\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"37\";s:2:\"p4\";s:2:\"84\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:47:\"a:1:{i:0;s:29:\"administer site configuration\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:45:\"a:1:{i:0;s:27:\"system_performance_settings\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:36:\"admin/config/development/performance\";s:5:\"title\";s:11:\"Performance\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:101:\"Enable or disable page caching for anonymous users and set CSS and JS bandwidth optimization options.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:458;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"458\";s:4:\"plid\";s:2:\"37\";s:9:\"link_path\";s:34:\"admin/config/development/strongarm\";s:11:\"router_path\";s:34:\"admin/config/development/strongarm\";s:10:\"link_title\";s:9:\"Strongarm\";s:7:\"options\";s:109:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:59:\"Manage Drupal variable settings that have been strongarmed.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"37\";s:2:\"p4\";s:3:\"458\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:47:\"a:1:{i:0;s:29:\"administer site configuration\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:38:\"a:1:{i:0;s:20:\"strongarm_admin_form\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:34:\"admin/config/development/strongarm\";s:5:\"title\";s:9:\"Strongarm\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:59:\"Manage Drupal variable settings that have been strongarmed.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:492;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"492\";s:4:\"plid\";s:2:\"37\";s:9:\"link_path\";s:38:\"admin/config/development/jquery_update\";s:11:\"router_path\";s:38:\"admin/config/development/jquery_update\";s:10:\"link_title\";s:13:\"jQuery update\";s:7:\"options\";s:133:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:83:\"Configure settings related to the jQuery upgrade, the library path and compression.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"37\";s:2:\"p4\";s:3:\"492\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:47:\"a:1:{i:0;s:29:\"administer site configuration\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:45:\"a:1:{i:0;s:27:\"jquery_update_settings_form\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:38:\"admin/config/development/jquery_update\";s:5:\"title\";s:13:\"jQuery update\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:83:\"Configure settings related to the jQuery upgrade, the library path and compression.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:564;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"564\";s:4:\"plid\";s:2:\"37\";s:9:\"link_path\";s:36:\"admin/config/development/modal_forms\";s:11:\"router_path\";s:36:\"admin/config/development/modal_forms\";s:10:\"link_title\";s:11:\"Modal forms\";s:7:\"options\";s:78:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:28:\"Adjust Modal forms settings.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"37\";s:2:\"p4\";s:3:\"564\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:47:\"a:1:{i:0;s:29:\"administer site configuration\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:44:\"a:1:{i:0;s:26:\"modal_forms_admin_settings\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:36:\"admin/config/development/modal_forms\";s:5:\"title\";s:11:\"Modal forms\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:28:\"Adjust Modal forms settings.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}}}i:44;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:2:\"44\";s:4:\"plid\";s:1:\"8\";s:9:\"link_path\";s:18:\"admin/config/media\";s:11:\"router_path\";s:18:\"admin/config/media\";s:10:\"link_title\";s:5:\"Media\";s:7:\"options\";s:62:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:12:\"Media tools.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"1\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:3:\"-10\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"44\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:45:\"a:1:{i:0;s:27:\"access administration pages\";}\";s:13:\"page_callback\";s:28:\"system_admin_menu_block_page\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:18:\"admin/config/media\";s:5:\"title\";s:5:\"Media\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:12:\"Media tools.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:5:{i:73;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:2:\"73\";s:4:\"plid\";s:2:\"44\";s:9:\"link_path\";s:30:\"admin/config/media/file-system\";s:11:\"router_path\";s:30:\"admin/config/media/file-system\";s:10:\"link_title\";s:11:\"File system\";s:7:\"options\";s:118:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:68:\"Tell Drupal where to store uploaded files and how they are accessed.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:3:\"-10\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"44\";s:2:\"p4\";s:2:\"73\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:47:\"a:1:{i:0;s:29:\"administer site configuration\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:45:\"a:1:{i:0;s:27:\"system_file_system_settings\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:30:\"admin/config/media/file-system\";s:5:\"title\";s:11:\"File system\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:68:\"Tell Drupal where to store uploaded files and how they are accessed.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:77;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:2:\"77\";s:4:\"plid\";s:2:\"44\";s:9:\"link_path\";s:31:\"admin/config/media/image-styles\";s:11:\"router_path\";s:31:\"admin/config/media/image-styles\";s:10:\"link_title\";s:12:\"Image styles\";s:7:\"options\";s:128:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:78:\"Configure styles that can be used for resizing or adjusting images on display.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"1\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"44\";s:2:\"p4\";s:2:\"77\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:41:\"a:1:{i:0;s:23:\"administer image styles\";}\";s:13:\"page_callback\";s:16:\"image_style_list\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:31:\"admin/config/media/image-styles\";s:5:\"title\";s:12:\"Image styles\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:78:\"Configure styles that can be used for resizing or adjusting images on display.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:5:{i:99;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:2:\"99\";s:4:\"plid\";s:2:\"77\";s:9:\"link_path\";s:35:\"admin/config/media/image-styles/add\";s:11:\"router_path\";s:35:\"admin/config/media/image-styles/add\";s:10:\"link_title\";s:9:\"Add style\";s:7:\"options\";s:72:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:22:\"Add a new image style.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"2\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"44\";s:2:\"p4\";s:2:\"77\";s:2:\"p5\";s:2:\"99\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:41:\"a:1:{i:0;s:23:\"administer image styles\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:38:\"a:1:{i:0;s:20:\"image_style_add_form\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:31:\"admin/config/media/image-styles\";s:8:\"tab_root\";s:31:\"admin/config/media/image-styles\";s:5:\"title\";s:9:\"Add style\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"388\";s:11:\"description\";s:22:\"Add a new image style.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:108;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"108\";s:4:\"plid\";s:2:\"77\";s:9:\"link_path\";s:36:\"admin/config/media/image-styles/list\";s:11:\"router_path\";s:36:\"admin/config/media/image-styles/list\";s:10:\"link_title\";s:4:\"List\";s:7:\"options\";s:92:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:42:\"List the current image styles on the site.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"1\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"44\";s:2:\"p4\";s:2:\"77\";s:2:\"p5\";s:3:\"108\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:41:\"a:1:{i:0;s:23:\"administer image styles\";}\";s:13:\"page_callback\";s:16:\"image_style_list\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:31:\"admin/config/media/image-styles\";s:8:\"tab_root\";s:31:\"admin/config/media/image-styles\";s:5:\"title\";s:4:\"List\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"140\";s:11:\"description\";s:42:\"List the current image styles on the site.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:136;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"136\";s:4:\"plid\";s:2:\"77\";s:9:\"link_path\";s:38:\"admin/config/media/image-styles/edit/%\";s:11:\"router_path\";s:38:\"admin/config/media/image-styles/edit/%\";s:10:\"link_title\";s:10:\"Edit style\";s:7:\"options\";s:75:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:25:\"Configure an image style.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"1\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"44\";s:2:\"p4\";s:2:\"77\";s:2:\"p5\";s:3:\"136\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:34:\"a:1:{i:5;s:16:\"image_style_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:41:\"a:1:{i:0;s:23:\"administer image styles\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:42:\"a:2:{i:0;s:16:\"image_style_form\";i:1;i:5;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:38:\"admin/config/media/image-styles/edit/%\";s:5:\"title\";s:10:\"Edit style\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:25:\"Configure an image style.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:2:{i:148;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"148\";s:4:\"plid\";s:3:\"136\";s:9:\"link_path\";s:44:\"admin/config/media/image-styles/edit/%/add/%\";s:11:\"router_path\";s:44:\"admin/config/media/image-styles/edit/%/add/%\";s:10:\"link_title\";s:16:\"Add image effect\";s:7:\"options\";s:78:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:28:\"Add a new effect to a style.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"6\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"44\";s:2:\"p4\";s:2:\"77\";s:2:\"p5\";s:3:\"136\";s:2:\"p6\";s:3:\"148\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:114:\"a:2:{i:5;a:1:{s:16:\"image_style_load\";a:1:{i:0;i:5;}}i:7;a:1:{s:28:\"image_effect_definition_load\";a:1:{i:0;i:5;}}}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:41:\"a:1:{i:0;s:23:\"administer image styles\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:51:\"a:3:{i:0;s:17:\"image_effect_form\";i:1;i:5;i:2;i:7;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:44:\"admin/config/media/image-styles/edit/%/add/%\";s:5:\"title\";s:16:\"Add image effect\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:28:\"Add a new effect to a style.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:149;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"149\";s:4:\"plid\";s:3:\"136\";s:9:\"link_path\";s:48:\"admin/config/media/image-styles/edit/%/effects/%\";s:11:\"router_path\";s:48:\"admin/config/media/image-styles/edit/%/effects/%\";s:10:\"link_title\";s:17:\"Edit image effect\";s:7:\"options\";s:89:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:39:\"Edit an existing effect within a style.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"1\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"6\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"44\";s:2:\"p4\";s:2:\"77\";s:2:\"p5\";s:3:\"136\";s:2:\"p6\";s:3:\"149\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:127:\"a:2:{i:5;a:1:{s:16:\"image_style_load\";a:2:{i:0;i:5;i:1;s:1:\"3\";}}i:7;a:1:{s:17:\"image_effect_load\";a:2:{i:0;i:5;i:1;s:1:\"3\";}}}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:41:\"a:1:{i:0;s:23:\"administer image styles\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:51:\"a:3:{i:0;s:17:\"image_effect_form\";i:1;i:5;i:2;i:7;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:48:\"admin/config/media/image-styles/edit/%/effects/%\";s:5:\"title\";s:17:\"Edit image effect\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:39:\"Edit an existing effect within a style.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:1:{i:150;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"150\";s:4:\"plid\";s:3:\"149\";s:9:\"link_path\";s:55:\"admin/config/media/image-styles/edit/%/effects/%/delete\";s:11:\"router_path\";s:55:\"admin/config/media/image-styles/edit/%/effects/%/delete\";s:10:\"link_title\";s:19:\"Delete image effect\";s:7:\"options\";s:89:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:39:\"Delete an existing effect from a style.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"7\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"44\";s:2:\"p4\";s:2:\"77\";s:2:\"p5\";s:3:\"136\";s:2:\"p6\";s:3:\"149\";s:2:\"p7\";s:3:\"150\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:127:\"a:2:{i:5;a:1:{s:16:\"image_style_load\";a:2:{i:0;i:5;i:1;s:1:\"3\";}}i:7;a:1:{s:17:\"image_effect_load\";a:2:{i:0;i:5;i:1;s:1:\"3\";}}}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:41:\"a:1:{i:0;s:23:\"administer image styles\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:58:\"a:3:{i:0;s:24:\"image_effect_delete_form\";i:1;i:5;i:2;i:7;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:55:\"admin/config/media/image-styles/edit/%/effects/%/delete\";s:5:\"title\";s:19:\"Delete image effect\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:39:\"Delete an existing effect from a style.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}}}}}i:139;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"139\";s:4:\"plid\";s:2:\"77\";s:9:\"link_path\";s:40:\"admin/config/media/image-styles/delete/%\";s:11:\"router_path\";s:40:\"admin/config/media/image-styles/delete/%\";s:10:\"link_title\";s:12:\"Delete style\";s:7:\"options\";s:72:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:22:\"Delete an image style.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"44\";s:2:\"p4\";s:2:\"77\";s:2:\"p5\";s:3:\"139\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:64:\"a:1:{i:5;a:1:{s:16:\"image_style_load\";a:2:{i:0;N;i:1;s:1:\"1\";}}}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:41:\"a:1:{i:0;s:23:\"administer image styles\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:49:\"a:2:{i:0;s:23:\"image_style_delete_form\";i:1;i:5;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:40:\"admin/config/media/image-styles/delete/%\";s:5:\"title\";s:12:\"Delete style\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:22:\"Delete an image style.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:140;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"140\";s:4:\"plid\";s:2:\"77\";s:9:\"link_path\";s:40:\"admin/config/media/image-styles/revert/%\";s:11:\"router_path\";s:40:\"admin/config/media/image-styles/revert/%\";s:10:\"link_title\";s:12:\"Revert style\";s:7:\"options\";s:72:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:22:\"Revert an image style.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"44\";s:2:\"p4\";s:2:\"77\";s:2:\"p5\";s:3:\"140\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:64:\"a:1:{i:5;a:1:{s:16:\"image_style_load\";a:2:{i:0;N;i:1;s:1:\"2\";}}}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:41:\"a:1:{i:0;s:23:\"administer image styles\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:49:\"a:2:{i:0;s:23:\"image_style_revert_form\";i:1;i:5;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:40:\"admin/config/media/image-styles/revert/%\";s:5:\"title\";s:12:\"Revert style\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:22:\"Revert an image style.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}}}i:78;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:2:\"78\";s:4:\"plid\";s:2:\"44\";s:9:\"link_path\";s:32:\"admin/config/media/image-toolkit\";s:11:\"router_path\";s:32:\"admin/config/media/image-toolkit\";s:10:\"link_title\";s:13:\"Image toolkit\";s:7:\"options\";s:124:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:74:\"Choose which image toolkit to use if you have installed optional toolkits.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:2:\"20\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"44\";s:2:\"p4\";s:2:\"78\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:47:\"a:1:{i:0;s:29:\"administer site configuration\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:47:\"a:1:{i:0;s:29:\"system_image_toolkit_settings\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:32:\"admin/config/media/image-toolkit\";s:5:\"title\";s:13:\"Image toolkit\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:74:\"Choose which image toolkit to use if you have installed optional toolkits.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:631;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"631\";s:4:\"plid\";s:2:\"44\";s:9:\"link_path\";s:29:\"admin/config/media/flexslider\";s:11:\"router_path\";s:29:\"admin/config/media/flexslider\";s:10:\"link_title\";s:10:\"FlexSlider\";s:7:\"options\";s:80:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:30:\"Administer FlexSlider presets.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"44\";s:2:\"p4\";s:3:\"631\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:28:\"ctools_export_ui_task_access\";s:16:\"access_arguments\";s:60:\"a:2:{i:0;s:27:\"flexslider_ctools_export_ui\";i:1;s:4:\"list\";}\";s:13:\"page_callback\";s:30:\"ctools_export_ui_switcher_page\";s:14:\"page_arguments\";s:60:\"a:2:{i:0;s:27:\"flexslider_ctools_export_ui\";i:1;s:4:\"list\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:29:\"admin/config/media/flexslider\";s:5:\"title\";s:10:\"FlexSlider\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:30:\"Administer FlexSlider presets.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:4:{i:632;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"632\";s:4:\"plid\";s:3:\"631\";s:9:\"link_path\";s:33:\"admin/config/media/flexslider/add\";s:11:\"router_path\";s:33:\"admin/config/media/flexslider/add\";s:10:\"link_title\";s:3:\"Add\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"44\";s:2:\"p4\";s:3:\"631\";s:2:\"p5\";s:3:\"632\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:28:\"ctools_export_ui_task_access\";s:16:\"access_arguments\";s:59:\"a:2:{i:0;s:27:\"flexslider_ctools_export_ui\";i:1;s:3:\"add\";}\";s:13:\"page_callback\";s:30:\"ctools_export_ui_switcher_page\";s:14:\"page_arguments\";s:59:\"a:2:{i:0;s:27:\"flexslider_ctools_export_ui\";i:1;s:3:\"add\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:29:\"admin/config/media/flexslider\";s:8:\"tab_root\";s:29:\"admin/config/media/flexslider\";s:5:\"title\";s:3:\"Add\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"388\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:633;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"633\";s:4:\"plid\";s:3:\"631\";s:9:\"link_path\";s:38:\"admin/config/media/flexslider/advanced\";s:11:\"router_path\";s:38:\"admin/config/media/flexslider/advanced\";s:10:\"link_title\";s:17:\"Advanced settings\";s:7:\"options\";s:100:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:50:\"Configure the advanced flexslider module settings.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"2\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"44\";s:2:\"p4\";s:3:\"631\";s:2:\"p5\";s:3:\"633\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:39:\"a:1:{i:0;s:21:\"administer flexslider\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:42:\"a:1:{i:0;s:24:\"flexslider_form_settings\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:29:\"admin/config/media/flexslider\";s:8:\"tab_root\";s:29:\"admin/config/media/flexslider\";s:5:\"title\";s:17:\"Advanced settings\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:50:\"Configure the advanced flexslider module settings.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:634;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"634\";s:4:\"plid\";s:3:\"631\";s:9:\"link_path\";s:36:\"admin/config/media/flexslider/import\";s:11:\"router_path\";s:36:\"admin/config/media/flexslider/import\";s:10:\"link_title\";s:6:\"Import\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"44\";s:2:\"p4\";s:3:\"631\";s:2:\"p5\";s:3:\"634\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:28:\"ctools_export_ui_task_access\";s:16:\"access_arguments\";s:62:\"a:2:{i:0;s:27:\"flexslider_ctools_export_ui\";i:1;s:6:\"import\";}\";s:13:\"page_callback\";s:30:\"ctools_export_ui_switcher_page\";s:14:\"page_arguments\";s:62:\"a:2:{i:0;s:27:\"flexslider_ctools_export_ui\";i:1;s:6:\"import\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:29:\"admin/config/media/flexslider\";s:8:\"tab_root\";s:29:\"admin/config/media/flexslider\";s:5:\"title\";s:6:\"Import\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"388\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:635;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"635\";s:4:\"plid\";s:3:\"631\";s:9:\"link_path\";s:34:\"admin/config/media/flexslider/list\";s:11:\"router_path\";s:34:\"admin/config/media/flexslider/list\";s:10:\"link_title\";s:4:\"List\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:3:\"-10\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"44\";s:2:\"p4\";s:3:\"631\";s:2:\"p5\";s:3:\"635\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:28:\"ctools_export_ui_task_access\";s:16:\"access_arguments\";s:60:\"a:2:{i:0;s:27:\"flexslider_ctools_export_ui\";i:1;s:4:\"list\";}\";s:13:\"page_callback\";s:30:\"ctools_export_ui_switcher_page\";s:14:\"page_arguments\";s:60:\"a:2:{i:0;s:27:\"flexslider_ctools_export_ui\";i:1;s:4:\"list\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:29:\"admin/config/media/flexslider\";s:8:\"tab_root\";s:29:\"admin/config/media/flexslider\";s:5:\"title\";s:4:\"List\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"140\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:2:{i:636;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"636\";s:4:\"plid\";s:3:\"635\";s:9:\"link_path\";s:41:\"admin/config/media/flexslider/list/%/edit\";s:11:\"router_path\";s:41:\"admin/config/media/flexslider/list/%/edit\";s:10:\"link_title\";s:4:\"Edit\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:3:\"-10\";s:5:\"depth\";s:1:\"6\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"44\";s:2:\"p4\";s:3:\"631\";s:2:\"p5\";s:3:\"635\";s:2:\"p6\";s:3:\"636\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:90:\"a:1:{i:5;a:1:{s:21:\"ctools_export_ui_load\";a:1:{i:0;s:27:\"flexslider_ctools_export_ui\";}}}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:28:\"ctools_export_ui_task_access\";s:16:\"access_arguments\";s:68:\"a:3:{i:0;s:27:\"flexslider_ctools_export_ui\";i:1;s:4:\"edit\";i:2;i:5;}\";s:13:\"page_callback\";s:30:\"ctools_export_ui_switcher_page\";s:14:\"page_arguments\";s:68:\"a:3:{i:0;s:27:\"flexslider_ctools_export_ui\";i:1;s:4:\"edit\";i:2;i:5;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:36:\"admin/config/media/flexslider/list/%\";s:8:\"tab_root\";s:36:\"admin/config/media/flexslider/list/%\";s:5:\"title\";s:4:\"Edit\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"140\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:637;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"637\";s:4:\"plid\";s:3:\"635\";s:9:\"link_path\";s:43:\"admin/config/media/flexslider/list/%/export\";s:11:\"router_path\";s:43:\"admin/config/media/flexslider/list/%/export\";s:10:\"link_title\";s:6:\"Export\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"6\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"44\";s:2:\"p4\";s:3:\"631\";s:2:\"p5\";s:3:\"635\";s:2:\"p6\";s:3:\"637\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:90:\"a:1:{i:5;a:1:{s:21:\"ctools_export_ui_load\";a:1:{i:0;s:27:\"flexslider_ctools_export_ui\";}}}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:28:\"ctools_export_ui_task_access\";s:16:\"access_arguments\";s:70:\"a:3:{i:0;s:27:\"flexslider_ctools_export_ui\";i:1;s:6:\"export\";i:2;i:5;}\";s:13:\"page_callback\";s:30:\"ctools_export_ui_switcher_page\";s:14:\"page_arguments\";s:70:\"a:3:{i:0;s:27:\"flexslider_ctools_export_ui\";i:1;s:6:\"export\";i:2;i:5;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:36:\"admin/config/media/flexslider/list/%\";s:8:\"tab_root\";s:36:\"admin/config/media/flexslider/list/%\";s:5:\"title\";s:6:\"Export\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}}}}}i:901;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"901\";s:4:\"plid\";s:2:\"44\";s:9:\"link_path\";s:22:\"admin/config/media/vef\";s:11:\"router_path\";s:22:\"admin/config/media/vef\";s:10:\"link_title\";s:17:\"Video Embed Field\";s:7:\"options\";s:81:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:31:\"Video Embed Field configuration\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"1\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"44\";s:2:\"p4\";s:3:\"901\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:41:\"a:1:{i:0;s:23:\"administer video styles\";}\";s:13:\"page_callback\";s:28:\"system_admin_menu_block_page\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:22:\"admin/config/media/vef\";s:5:\"title\";s:17:\"Video Embed Field\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:31:\"Video Embed Field configuration\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:2:{i:902;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"902\";s:4:\"plid\";s:3:\"901\";s:9:\"link_path\";s:31:\"admin/config/media/vef/settings\";s:11:\"router_path\";s:31:\"admin/config/media/vef/settings\";s:10:\"link_title\";s:8:\"Settings\";s:7:\"options\";s:83:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:33:\"Video Embed Field module settings\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"44\";s:2:\"p4\";s:3:\"901\";s:2:\"p5\";s:3:\"902\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:41:\"a:1:{i:0;s:23:\"administer video styles\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:49:\"a:1:{i:0;s:31:\"video_embed_field_settings_form\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:31:\"admin/config/media/vef/settings\";s:5:\"title\";s:8:\"Settings\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:33:\"Video Embed Field module settings\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:903;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"903\";s:4:\"plid\";s:3:\"901\";s:9:\"link_path\";s:39:\"admin/config/media/vef/vef_video_styles\";s:11:\"router_path\";s:39:\"admin/config/media/vef/vef_video_styles\";s:10:\"link_title\";s:18:\"Video Embed Styles\";s:7:\"options\";s:94:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:44:\"Administer Video Embed Field\'s video styles.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"44\";s:2:\"p4\";s:3:\"901\";s:2:\"p5\";s:3:\"903\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:28:\"ctools_export_ui_task_access\";s:16:\"access_arguments\";s:60:\"a:2:{i:0;s:27:\"video_embed_field_export_ui\";i:1;s:4:\"list\";}\";s:13:\"page_callback\";s:30:\"ctools_export_ui_switcher_page\";s:14:\"page_arguments\";s:60:\"a:2:{i:0;s:27:\"video_embed_field_export_ui\";i:1;s:4:\"list\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:39:\"admin/config/media/vef/vef_video_styles\";s:5:\"title\";s:18:\"Video Embed Styles\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:44:\"Administer Video Embed Field\'s video styles.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:3:{i:904;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"904\";s:4:\"plid\";s:3:\"903\";s:9:\"link_path\";s:43:\"admin/config/media/vef/vef_video_styles/add\";s:11:\"router_path\";s:43:\"admin/config/media/vef/vef_video_styles/add\";s:10:\"link_title\";s:3:\"Add\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"6\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"44\";s:2:\"p4\";s:3:\"901\";s:2:\"p5\";s:3:\"903\";s:2:\"p6\";s:3:\"904\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:28:\"ctools_export_ui_task_access\";s:16:\"access_arguments\";s:59:\"a:2:{i:0;s:27:\"video_embed_field_export_ui\";i:1;s:3:\"add\";}\";s:13:\"page_callback\";s:30:\"ctools_export_ui_switcher_page\";s:14:\"page_arguments\";s:59:\"a:2:{i:0;s:27:\"video_embed_field_export_ui\";i:1;s:3:\"add\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:39:\"admin/config/media/vef/vef_video_styles\";s:8:\"tab_root\";s:39:\"admin/config/media/vef/vef_video_styles\";s:5:\"title\";s:3:\"Add\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"388\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:905;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"905\";s:4:\"plid\";s:3:\"903\";s:9:\"link_path\";s:46:\"admin/config/media/vef/vef_video_styles/import\";s:11:\"router_path\";s:46:\"admin/config/media/vef/vef_video_styles/import\";s:10:\"link_title\";s:6:\"Import\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"6\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"44\";s:2:\"p4\";s:3:\"901\";s:2:\"p5\";s:3:\"903\";s:2:\"p6\";s:3:\"905\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:28:\"ctools_export_ui_task_access\";s:16:\"access_arguments\";s:62:\"a:2:{i:0;s:27:\"video_embed_field_export_ui\";i:1;s:6:\"import\";}\";s:13:\"page_callback\";s:30:\"ctools_export_ui_switcher_page\";s:14:\"page_arguments\";s:62:\"a:2:{i:0;s:27:\"video_embed_field_export_ui\";i:1;s:6:\"import\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:39:\"admin/config/media/vef/vef_video_styles\";s:8:\"tab_root\";s:39:\"admin/config/media/vef/vef_video_styles\";s:5:\"title\";s:6:\"Import\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"388\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:906;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"906\";s:4:\"plid\";s:3:\"903\";s:9:\"link_path\";s:44:\"admin/config/media/vef/vef_video_styles/list\";s:11:\"router_path\";s:44:\"admin/config/media/vef/vef_video_styles/list\";s:10:\"link_title\";s:4:\"List\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:3:\"-10\";s:5:\"depth\";s:1:\"6\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"44\";s:2:\"p4\";s:3:\"901\";s:2:\"p5\";s:3:\"903\";s:2:\"p6\";s:3:\"906\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:28:\"ctools_export_ui_task_access\";s:16:\"access_arguments\";s:60:\"a:2:{i:0;s:27:\"video_embed_field_export_ui\";i:1;s:4:\"list\";}\";s:13:\"page_callback\";s:30:\"ctools_export_ui_switcher_page\";s:14:\"page_arguments\";s:60:\"a:2:{i:0;s:27:\"video_embed_field_export_ui\";i:1;s:4:\"list\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:39:\"admin/config/media/vef/vef_video_styles\";s:8:\"tab_root\";s:39:\"admin/config/media/vef/vef_video_styles\";s:5:\"title\";s:4:\"List\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"140\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:2:{i:907;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"907\";s:4:\"plid\";s:3:\"906\";s:9:\"link_path\";s:51:\"admin/config/media/vef/vef_video_styles/list/%/edit\";s:11:\"router_path\";s:51:\"admin/config/media/vef/vef_video_styles/list/%/edit\";s:10:\"link_title\";s:4:\"Edit\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:3:\"-10\";s:5:\"depth\";s:1:\"7\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"44\";s:2:\"p4\";s:3:\"901\";s:2:\"p5\";s:3:\"903\";s:2:\"p6\";s:3:\"906\";s:2:\"p7\";s:3:\"907\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:90:\"a:1:{i:6;a:1:{s:21:\"ctools_export_ui_load\";a:1:{i:0;s:27:\"video_embed_field_export_ui\";}}}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:28:\"ctools_export_ui_task_access\";s:16:\"access_arguments\";s:68:\"a:3:{i:0;s:27:\"video_embed_field_export_ui\";i:1;s:4:\"edit\";i:2;i:6;}\";s:13:\"page_callback\";s:30:\"ctools_export_ui_switcher_page\";s:14:\"page_arguments\";s:68:\"a:3:{i:0;s:27:\"video_embed_field_export_ui\";i:1;s:4:\"edit\";i:2;i:6;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:46:\"admin/config/media/vef/vef_video_styles/list/%\";s:8:\"tab_root\";s:46:\"admin/config/media/vef/vef_video_styles/list/%\";s:5:\"title\";s:4:\"Edit\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"140\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:908;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"908\";s:4:\"plid\";s:3:\"906\";s:9:\"link_path\";s:53:\"admin/config/media/vef/vef_video_styles/list/%/export\";s:11:\"router_path\";s:53:\"admin/config/media/vef/vef_video_styles/list/%/export\";s:10:\"link_title\";s:6:\"Export\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"7\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"44\";s:2:\"p4\";s:3:\"901\";s:2:\"p5\";s:3:\"903\";s:2:\"p6\";s:3:\"906\";s:2:\"p7\";s:3:\"908\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:90:\"a:1:{i:6;a:1:{s:21:\"ctools_export_ui_load\";a:1:{i:0;s:27:\"video_embed_field_export_ui\";}}}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:28:\"ctools_export_ui_task_access\";s:16:\"access_arguments\";s:70:\"a:3:{i:0;s:27:\"video_embed_field_export_ui\";i:1;s:6:\"export\";i:2;i:6;}\";s:13:\"page_callback\";s:30:\"ctools_export_ui_switcher_page\";s:14:\"page_arguments\";s:70:\"a:3:{i:0;s:27:\"video_embed_field_export_ui\";i:1;s:6:\"export\";i:2;i:6;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:46:\"admin/config/media/vef/vef_video_styles/list/%\";s:8:\"tab_root\";s:46:\"admin/config/media/vef/vef_video_styles/list/%\";s:5:\"title\";s:6:\"Export\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}}}}}}}}}i:46;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:2:\"46\";s:4:\"plid\";s:1:\"8\";s:9:\"link_path\";s:19:\"admin/config/people\";s:11:\"router_path\";s:19:\"admin/config/people\";s:10:\"link_title\";s:6:\"People\";s:7:\"options\";s:74:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:24:\"Configure user accounts.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"1\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:3:\"-20\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"46\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:45:\"a:1:{i:0;s:27:\"access administration pages\";}\";s:13:\"page_callback\";s:28:\"system_admin_menu_block_page\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:19:\"admin/config/people\";s:5:\"title\";s:6:\"People\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:24:\"Configure user accounts.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:2:{i:63;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:2:\"63\";s:4:\"plid\";s:2:\"46\";s:9:\"link_path\";s:28:\"admin/config/people/accounts\";s:11:\"router_path\";s:28:\"admin/config/people/accounts\";s:10:\"link_title\";s:16:\"Account settings\";s:7:\"options\";s:160:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:109:\"Configure default behavior of users, including registration requirements, e-mails, fields, and user pictures.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:3:\"-10\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"46\";s:2:\"p4\";s:2:\"63\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:34:\"a:1:{i:0;s:16:\"administer users\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:37:\"a:1:{i:0;s:19:\"user_admin_settings\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:28:\"admin/config/people/accounts\";s:5:\"title\";s:16:\"Account settings\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:109:\"Configure default behavior of users, including registration requirements, e-mails, fields, and user pictures.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:3:{i:110;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"110\";s:4:\"plid\";s:2:\"63\";s:9:\"link_path\";s:37:\"admin/config/people/accounts/settings\";s:11:\"router_path\";s:37:\"admin/config/people/accounts/settings\";s:10:\"link_title\";s:8:\"Settings\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:3:\"-10\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"46\";s:2:\"p4\";s:2:\"63\";s:2:\"p5\";s:3:\"110\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:34:\"a:1:{i:0;s:16:\"administer users\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:37:\"a:1:{i:0;s:19:\"user_admin_settings\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:28:\"admin/config/people/accounts\";s:8:\"tab_root\";s:28:\"admin/config/people/accounts\";s:5:\"title\";s:8:\"Settings\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"140\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:921;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"921\";s:4:\"plid\";s:2:\"63\";s:9:\"link_path\";s:36:\"admin/config/people/accounts/display\";s:11:\"router_path\";s:36:\"admin/config/people/accounts/display\";s:10:\"link_title\";s:14:\"Manage display\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"2\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"46\";s:2:\"p4\";s:2:\"63\";s:2:\"p5\";s:3:\"921\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:21:\"field_ui_admin_access\";s:16:\"access_arguments\";s:67:\"a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:16:\"administer users\";}}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:96:\"a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:4:\"user\";i:2;s:4:\"user\";i:3;s:7:\"default\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:28:\"admin/config/people/accounts\";s:8:\"tab_root\";s:28:\"admin/config/people/accounts\";s:5:\"title\";s:14:\"Manage display\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:3:{i:927;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"927\";s:4:\"plid\";s:3:\"921\";s:9:\"link_path\";s:44:\"admin/config/people/accounts/display/default\";s:11:\"router_path\";s:44:\"admin/config/people/accounts/display/default\";s:10:\"link_title\";s:7:\"Default\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:3:\"-10\";s:5:\"depth\";s:1:\"6\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"46\";s:2:\"p4\";s:2:\"63\";s:2:\"p5\";s:3:\"921\";s:2:\"p6\";s:3:\"927\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:31:\"_field_ui_view_mode_menu_access\";s:16:\"access_arguments\";s:148:\"a:6:{i:0;s:4:\"user\";i:1;s:4:\"user\";i:2;s:7:\"default\";i:3;s:21:\"field_ui_admin_access\";i:4;s:11:\"user_access\";i:5;a:1:{i:0;s:16:\"administer users\";}}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:96:\"a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:4:\"user\";i:2;s:4:\"user\";i:3;s:7:\"default\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:36:\"admin/config/people/accounts/display\";s:8:\"tab_root\";s:28:\"admin/config/people/accounts\";s:5:\"title\";s:7:\"Default\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"140\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:936;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"936\";s:4:\"plid\";s:3:\"921\";s:9:\"link_path\";s:42:\"admin/config/people/accounts/display/token\";s:11:\"router_path\";s:42:\"admin/config/people/accounts/display/token\";s:10:\"link_title\";s:6:\"Tokens\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"1\";s:5:\"depth\";s:1:\"6\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"46\";s:2:\"p4\";s:2:\"63\";s:2:\"p5\";s:3:\"921\";s:2:\"p6\";s:3:\"936\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:31:\"_field_ui_view_mode_menu_access\";s:16:\"access_arguments\";s:146:\"a:6:{i:0;s:4:\"user\";i:1;s:4:\"user\";i:2;s:5:\"token\";i:3;s:21:\"field_ui_admin_access\";i:4;s:11:\"user_access\";i:5;a:1:{i:0;s:16:\"administer users\";}}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:94:\"a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:4:\"user\";i:2;s:4:\"user\";i:3;s:5:\"token\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:36:\"admin/config/people/accounts/display\";s:8:\"tab_root\";s:28:\"admin/config/people/accounts\";s:5:\"title\";s:6:\"Tokens\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:937;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"937\";s:4:\"plid\";s:3:\"921\";s:9:\"link_path\";s:41:\"admin/config/people/accounts/display/full\";s:11:\"router_path\";s:41:\"admin/config/people/accounts/display/full\";s:10:\"link_title\";s:12:\"User account\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"6\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"46\";s:2:\"p4\";s:2:\"63\";s:2:\"p5\";s:3:\"921\";s:2:\"p6\";s:3:\"937\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:31:\"_field_ui_view_mode_menu_access\";s:16:\"access_arguments\";s:145:\"a:6:{i:0;s:4:\"user\";i:1;s:4:\"user\";i:2;s:4:\"full\";i:3;s:21:\"field_ui_admin_access\";i:4;s:11:\"user_access\";i:5;a:1:{i:0;s:16:\"administer users\";}}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:93:\"a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:4:\"user\";i:2;s:4:\"user\";i:3;s:4:\"full\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:36:\"admin/config/people/accounts/display\";s:8:\"tab_root\";s:28:\"admin/config/people/accounts\";s:5:\"title\";s:12:\"User account\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}}}i:924;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"924\";s:4:\"plid\";s:2:\"63\";s:9:\"link_path\";s:35:\"admin/config/people/accounts/fields\";s:11:\"router_path\";s:35:\"admin/config/people/accounts/fields\";s:10:\"link_title\";s:13:\"Manage fields\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"1\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"1\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"46\";s:2:\"p4\";s:2:\"63\";s:2:\"p5\";s:3:\"924\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:21:\"field_ui_admin_access\";s:16:\"access_arguments\";s:67:\"a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:16:\"administer users\";}}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:76:\"a:3:{i:0;s:28:\"field_ui_field_overview_form\";i:1;s:4:\"user\";i:2;s:4:\"user\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:28:\"admin/config/people/accounts\";s:8:\"tab_root\";s:28:\"admin/config/people/accounts\";s:5:\"title\";s:13:\"Manage fields\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:1:{i:940;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"940\";s:4:\"plid\";s:3:\"924\";s:9:\"link_path\";s:37:\"admin/config/people/accounts/fields/%\";s:11:\"router_path\";s:37:\"admin/config/people/accounts/fields/%\";s:10:\"link_title\";s:0:\"\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"6\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"46\";s:2:\"p4\";s:2:\"63\";s:2:\"p5\";s:3:\"924\";s:2:\"p6\";s:3:\"940\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:105:\"a:1:{i:5;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:4:\"user\";i:1;s:4:\"user\";i:2;s:1:\"0\";i:3;s:4:\"%map\";}}}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:21:\"field_ui_admin_access\";s:16:\"access_arguments\";s:67:\"a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:16:\"administer users\";}}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:50:\"a:2:{i:0;s:24:\"field_ui_field_edit_form\";i:1;i:5;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:37:\"admin/config/people/accounts/fields/%\";s:5:\"title\";s:0:\"\";s:14:\"title_callback\";s:19:\"field_ui_menu_title\";s:15:\"title_arguments\";s:14:\"a:1:{i:0;i:5;}\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:4:{i:962;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"962\";s:4:\"plid\";s:3:\"940\";s:9:\"link_path\";s:44:\"admin/config/people/accounts/fields/%/delete\";s:11:\"router_path\";s:44:\"admin/config/people/accounts/fields/%/delete\";s:10:\"link_title\";s:6:\"Delete\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:2:\"10\";s:5:\"depth\";s:1:\"7\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"46\";s:2:\"p4\";s:2:\"63\";s:2:\"p5\";s:3:\"924\";s:2:\"p6\";s:3:\"940\";s:2:\"p7\";s:3:\"962\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:105:\"a:1:{i:5;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:4:\"user\";i:1;s:4:\"user\";i:2;s:1:\"0\";i:3;s:4:\"%map\";}}}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:21:\"field_ui_admin_access\";s:16:\"access_arguments\";s:67:\"a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:16:\"administer users\";}}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:52:\"a:2:{i:0;s:26:\"field_ui_field_delete_form\";i:1;i:5;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:37:\"admin/config/people/accounts/fields/%\";s:8:\"tab_root\";s:37:\"admin/config/people/accounts/fields/%\";s:5:\"title\";s:6:\"Delete\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:963;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"963\";s:4:\"plid\";s:3:\"940\";s:9:\"link_path\";s:42:\"admin/config/people/accounts/fields/%/edit\";s:11:\"router_path\";s:42:\"admin/config/people/accounts/fields/%/edit\";s:10:\"link_title\";s:4:\"Edit\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"7\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"46\";s:2:\"p4\";s:2:\"63\";s:2:\"p5\";s:3:\"924\";s:2:\"p6\";s:3:\"940\";s:2:\"p7\";s:3:\"963\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:105:\"a:1:{i:5;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:4:\"user\";i:1;s:4:\"user\";i:2;s:1:\"0\";i:3;s:4:\"%map\";}}}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:21:\"field_ui_admin_access\";s:16:\"access_arguments\";s:67:\"a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:16:\"administer users\";}}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:50:\"a:2:{i:0;s:24:\"field_ui_field_edit_form\";i:1;i:5;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:37:\"admin/config/people/accounts/fields/%\";s:8:\"tab_root\";s:37:\"admin/config/people/accounts/fields/%\";s:5:\"title\";s:4:\"Edit\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"140\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:964;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"964\";s:4:\"plid\";s:3:\"940\";s:9:\"link_path\";s:52:\"admin/config/people/accounts/fields/%/field-settings\";s:11:\"router_path\";s:52:\"admin/config/people/accounts/fields/%/field-settings\";s:10:\"link_title\";s:14:\"Field settings\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"7\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"46\";s:2:\"p4\";s:2:\"63\";s:2:\"p5\";s:3:\"924\";s:2:\"p6\";s:3:\"940\";s:2:\"p7\";s:3:\"964\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:105:\"a:1:{i:5;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:4:\"user\";i:1;s:4:\"user\";i:2;s:1:\"0\";i:3;s:4:\"%map\";}}}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:21:\"field_ui_admin_access\";s:16:\"access_arguments\";s:67:\"a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:16:\"administer users\";}}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:54:\"a:2:{i:0;s:28:\"field_ui_field_settings_form\";i:1;i:5;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:37:\"admin/config/people/accounts/fields/%\";s:8:\"tab_root\";s:37:\"admin/config/people/accounts/fields/%\";s:5:\"title\";s:14:\"Field settings\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:965;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"965\";s:4:\"plid\";s:3:\"940\";s:9:\"link_path\";s:49:\"admin/config/people/accounts/fields/%/widget-type\";s:11:\"router_path\";s:49:\"admin/config/people/accounts/fields/%/widget-type\";s:10:\"link_title\";s:11:\"Widget type\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"7\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"46\";s:2:\"p4\";s:2:\"63\";s:2:\"p5\";s:3:\"924\";s:2:\"p6\";s:3:\"940\";s:2:\"p7\";s:3:\"965\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:105:\"a:1:{i:5;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:4:\"user\";i:1;s:4:\"user\";i:2;s:1:\"0\";i:3;s:4:\"%map\";}}}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:21:\"field_ui_admin_access\";s:16:\"access_arguments\";s:67:\"a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:16:\"administer users\";}}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:51:\"a:2:{i:0;s:25:\"field_ui_widget_type_form\";i:1;i:5;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:37:\"admin/config/people/accounts/fields/%\";s:8:\"tab_root\";s:37:\"admin/config/people/accounts/fields/%\";s:5:\"title\";s:11:\"Widget type\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}}}}}}}i:76;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:2:\"76\";s:4:\"plid\";s:2:\"46\";s:9:\"link_path\";s:31:\"admin/config/people/ip-blocking\";s:11:\"router_path\";s:31:\"admin/config/people/ip-blocking\";s:10:\"link_title\";s:19:\"IP address blocking\";s:7:\"options\";s:78:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:28:\"Manage blocked IP addresses.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"1\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:2:\"10\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"46\";s:2:\"p4\";s:2:\"76\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:36:\"a:1:{i:0;s:18:\"block IP addresses\";}\";s:13:\"page_callback\";s:18:\"system_ip_blocking\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:31:\"admin/config/people/ip-blocking\";s:5:\"title\";s:19:\"IP address blocking\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:28:\"Manage blocked IP addresses.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:1:{i:126;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"126\";s:4:\"plid\";s:2:\"76\";s:9:\"link_path\";s:40:\"admin/config/people/ip-blocking/delete/%\";s:11:\"router_path\";s:40:\"admin/config/people/ip-blocking/delete/%\";s:10:\"link_title\";s:17:\"Delete IP address\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"46\";s:2:\"p4\";s:2:\"76\";s:2:\"p5\";s:3:\"126\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:33:\"a:1:{i:5;s:15:\"blocked_ip_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:36:\"a:1:{i:0;s:18:\"block IP addresses\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:51:\"a:2:{i:0;s:25:\"system_ip_blocking_delete\";i:1;i:5;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:40:\"admin/config/people/ip-blocking/delete/%\";s:5:\"title\";s:17:\"Delete IP address\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}}}}}i:49;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:2:\"49\";s:4:\"plid\";s:1:\"8\";s:9:\"link_path\";s:21:\"admin/config/regional\";s:11:\"router_path\";s:21:\"admin/config/regional\";s:10:\"link_title\";s:21:\"Regional and language\";s:7:\"options\";s:98:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:48:\"Regional settings, localization and translation.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"1\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:2:\"-5\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"49\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:45:\"a:1:{i:0;s:27:\"access administration pages\";}\";s:13:\"page_callback\";s:28:\"system_admin_menu_block_page\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:21:\"admin/config/regional\";s:5:\"title\";s:21:\"Regional and language\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:48:\"Regional settings, localization and translation.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:6:{i:71;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:2:\"71\";s:4:\"plid\";s:2:\"49\";s:9:\"link_path\";s:31:\"admin/config/regional/date-time\";s:11:\"router_path\";s:31:\"admin/config/regional/date-time\";s:10:\"link_title\";s:13:\"Date and time\";s:7:\"options\";s:94:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:44:\"Configure display formats for date and time.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:3:\"-15\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"49\";s:2:\"p4\";s:2:\"71\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:47:\"a:1:{i:0;s:29:\"administer site configuration\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:43:\"a:1:{i:0;s:25:\"system_date_time_settings\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:31:\"admin/config/regional/date-time\";s:5:\"title\";s:13:\"Date and time\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:44:\"Configure display formats for date and time.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:4:{i:105;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"105\";s:4:\"plid\";s:2:\"71\";s:9:\"link_path\";s:39:\"admin/config/regional/date-time/formats\";s:11:\"router_path\";s:39:\"admin/config/regional/date-time/formats\";s:10:\"link_title\";s:7:\"Formats\";s:7:\"options\";s:101:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:51:\"Configure display format strings for date and time.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"1\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:2:\"-9\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"49\";s:2:\"p4\";s:2:\"71\";s:2:\"p5\";s:3:\"105\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:47:\"a:1:{i:0;s:29:\"administer site configuration\";}\";s:13:\"page_callback\";s:24:\"system_date_time_formats\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:31:\"admin/config/regional/date-time\";s:8:\"tab_root\";s:31:\"admin/config/regional/date-time\";s:5:\"title\";s:7:\"Formats\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:51:\"Configure display format strings for date and time.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:3:{i:121;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"121\";s:4:\"plid\";s:3:\"105\";s:9:\"link_path\";s:43:\"admin/config/regional/date-time/formats/add\";s:11:\"router_path\";s:43:\"admin/config/regional/date-time/formats/add\";s:10:\"link_title\";s:10:\"Add format\";s:7:\"options\";s:93:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:43:\"Allow users to add additional date formats.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:3:\"-10\";s:5:\"depth\";s:1:\"6\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"49\";s:2:\"p4\";s:2:\"71\";s:2:\"p5\";s:3:\"105\";s:2:\"p6\";s:3:\"121\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:47:\"a:1:{i:0;s:29:\"administer site configuration\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:52:\"a:1:{i:0;s:34:\"system_configure_date_formats_form\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:39:\"admin/config/regional/date-time/formats\";s:8:\"tab_root\";s:31:\"admin/config/regional/date-time\";s:5:\"title\";s:10:\"Add format\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"388\";s:11:\"description\";s:43:\"Allow users to add additional date formats.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:145;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"145\";s:4:\"plid\";s:3:\"105\";s:9:\"link_path\";s:48:\"admin/config/regional/date-time/formats/%/delete\";s:11:\"router_path\";s:48:\"admin/config/regional/date-time/formats/%/delete\";s:10:\"link_title\";s:18:\"Delete date format\";s:7:\"options\";s:97:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:47:\"Allow users to delete a configured date format.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"6\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"49\";s:2:\"p4\";s:2:\"71\";s:2:\"p5\";s:3:\"105\";s:2:\"p6\";s:3:\"145\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:12:\"a:1:{i:5;N;}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:47:\"a:1:{i:0;s:29:\"administer site configuration\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:56:\"a:2:{i:0;s:30:\"system_date_delete_format_form\";i:1;i:5;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:48:\"admin/config/regional/date-time/formats/%/delete\";s:5:\"title\";s:18:\"Delete date format\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:47:\"Allow users to delete a configured date format.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:147;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"147\";s:4:\"plid\";s:3:\"105\";s:9:\"link_path\";s:46:\"admin/config/regional/date-time/formats/%/edit\";s:11:\"router_path\";s:46:\"admin/config/regional/date-time/formats/%/edit\";s:10:\"link_title\";s:16:\"Edit date format\";s:7:\"options\";s:95:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:45:\"Allow users to edit a configured date format.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"6\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"49\";s:2:\"p4\";s:2:\"71\";s:2:\"p5\";s:3:\"105\";s:2:\"p6\";s:3:\"147\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:12:\"a:1:{i:5;N;}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:47:\"a:1:{i:0;s:29:\"administer site configuration\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:60:\"a:2:{i:0;s:34:\"system_configure_date_formats_form\";i:1;i:5;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:46:\"admin/config/regional/date-time/formats/%/edit\";s:5:\"title\";s:16:\"Edit date format\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:45:\"Allow users to edit a configured date format.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}}}i:113;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"113\";s:4:\"plid\";s:2:\"71\";s:9:\"link_path\";s:37:\"admin/config/regional/date-time/types\";s:11:\"router_path\";s:37:\"admin/config/regional/date-time/types\";s:10:\"link_title\";s:5:\"Types\";s:7:\"options\";s:94:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:44:\"Configure display formats for date and time.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"1\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:3:\"-10\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"49\";s:2:\"p4\";s:2:\"71\";s:2:\"p5\";s:3:\"113\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:47:\"a:1:{i:0;s:29:\"administer site configuration\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:43:\"a:1:{i:0;s:25:\"system_date_time_settings\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:31:\"admin/config/regional/date-time\";s:8:\"tab_root\";s:31:\"admin/config/regional/date-time\";s:5:\"title\";s:5:\"Types\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"140\";s:11:\"description\";s:44:\"Configure display formats for date and time.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:2:{i:120;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"120\";s:4:\"plid\";s:3:\"113\";s:9:\"link_path\";s:41:\"admin/config/regional/date-time/types/add\";s:11:\"router_path\";s:41:\"admin/config/regional/date-time/types/add\";s:10:\"link_title\";s:13:\"Add date type\";s:7:\"options\";s:68:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:18:\"Add new date type.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:3:\"-10\";s:5:\"depth\";s:1:\"6\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"49\";s:2:\"p4\";s:2:\"71\";s:2:\"p5\";s:3:\"113\";s:2:\"p6\";s:3:\"120\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:47:\"a:1:{i:0;s:29:\"administer site configuration\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:50:\"a:1:{i:0;s:32:\"system_add_date_format_type_form\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:37:\"admin/config/regional/date-time/types\";s:8:\"tab_root\";s:31:\"admin/config/regional/date-time\";s:5:\"title\";s:13:\"Add date type\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"388\";s:11:\"description\";s:18:\"Add new date type.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:146;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"146\";s:4:\"plid\";s:3:\"113\";s:9:\"link_path\";s:46:\"admin/config/regional/date-time/types/%/delete\";s:11:\"router_path\";s:46:\"admin/config/regional/date-time/types/%/delete\";s:10:\"link_title\";s:16:\"Delete date type\";s:7:\"options\";s:95:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:45:\"Allow users to delete a configured date type.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"6\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"49\";s:2:\"p4\";s:2:\"71\";s:2:\"p5\";s:3:\"113\";s:2:\"p6\";s:3:\"146\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:12:\"a:1:{i:5;N;}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:47:\"a:1:{i:0;s:29:\"administer site configuration\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:61:\"a:2:{i:0;s:35:\"system_delete_date_format_type_form\";i:1;i:5;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:46:\"admin/config/regional/date-time/types/%/delete\";s:5:\"title\";s:16:\"Delete date type\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:45:\"Allow users to delete a configured date type.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}}}i:380;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"380\";s:4:\"plid\";s:2:\"71\";s:9:\"link_path\";s:38:\"admin/config/regional/date-time/locale\";s:11:\"router_path\";s:38:\"admin/config/regional/date-time/locale\";s:10:\"link_title\";s:8:\"Localize\";s:7:\"options\";s:88:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:38:\"Configure date formats for each locale\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"1\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:2:\"-8\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"49\";s:2:\"p4\";s:2:\"71\";s:2:\"p5\";s:3:\"380\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:47:\"a:1:{i:0;s:29:\"administer site configuration\";}\";s:13:\"page_callback\";s:41:\"locale_date_format_language_overview_page\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:31:\"admin/config/regional/date-time\";s:8:\"tab_root\";s:31:\"admin/config/regional/date-time\";s:5:\"title\";s:8:\"Localize\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:38:\"Configure date formats for each locale\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:2:{i:392;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"392\";s:4:\"plid\";s:3:\"380\";s:9:\"link_path\";s:45:\"admin/config/regional/date-time/locale/%/edit\";s:11:\"router_path\";s:45:\"admin/config/regional/date-time/locale/%/edit\";s:10:\"link_title\";s:21:\"Localize date formats\";s:7:\"options\";s:88:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:38:\"Configure date formats for each locale\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"6\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"49\";s:2:\"p4\";s:2:\"71\";s:2:\"p5\";s:3:\"380\";s:2:\"p6\";s:3:\"392\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:12:\"a:1:{i:5;N;}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:47:\"a:1:{i:0;s:29:\"administer site configuration\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:49:\"a:2:{i:0;s:23:\"locale_date_format_form\";i:1;i:5;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:45:\"admin/config/regional/date-time/locale/%/edit\";s:5:\"title\";s:21:\"Localize date formats\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:38:\"Configure date formats for each locale\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:393;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"393\";s:4:\"plid\";s:3:\"380\";s:9:\"link_path\";s:46:\"admin/config/regional/date-time/locale/%/reset\";s:11:\"router_path\";s:46:\"admin/config/regional/date-time/locale/%/reset\";s:10:\"link_title\";s:18:\"Reset date formats\";s:7:\"options\";s:97:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:47:\"Reset localized date formats to global defaults\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"6\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"49\";s:2:\"p4\";s:2:\"71\";s:2:\"p5\";s:3:\"380\";s:2:\"p6\";s:3:\"393\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:12:\"a:1:{i:5;N;}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:47:\"a:1:{i:0;s:29:\"administer site configuration\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:55:\"a:2:{i:0;s:29:\"locale_date_format_reset_form\";i:1;i:5;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:46:\"admin/config/regional/date-time/locale/%/reset\";s:5:\"title\";s:18:\"Reset date formats\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:47:\"Reset localized date formats to global defaults\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}}}i:687;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"687\";s:4:\"plid\";s:2:\"71\";s:9:\"link_path\";s:42:\"admin/config/regional/date-time/date-views\";s:11:\"router_path\";s:42:\"admin/config/regional/date-time/date-views\";s:10:\"link_title\";s:10:\"Date views\";s:7:\"options\";s:84:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:34:\"Configure settings for date views.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"49\";s:2:\"p4\";s:2:\"71\";s:2:\"p5\";s:3:\"687\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:48:\"a:1:{i:0;s:30:\"administer site configuration \";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:37:\"a:1:{i:0;s:19:\"date_views_settings\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:31:\"admin/config/regional/date-time\";s:8:\"tab_root\";s:31:\"admin/config/regional/date-time\";s:5:\"title\";s:10:\"Date views\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:34:\"Configure settings for date views.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}}}i:88;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:2:\"88\";s:4:\"plid\";s:2:\"49\";s:9:\"link_path\";s:30:\"admin/config/regional/settings\";s:11:\"router_path\";s:30:\"admin/config/regional/settings\";s:10:\"link_title\";s:17:\"Regional settings\";s:7:\"options\";s:104:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:54:\"Settings for the site\'s default time zone and country.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:3:\"-20\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"49\";s:2:\"p4\";s:2:\"88\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:47:\"a:1:{i:0;s:29:\"administer site configuration\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:42:\"a:1:{i:0;s:24:\"system_regional_settings\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:30:\"admin/config/regional/settings\";s:5:\"title\";s:17:\"Regional settings\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:54:\"Settings for the site\'s default time zone and country.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:371;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"371\";s:4:\"plid\";s:2:\"49\";s:9:\"link_path\";s:30:\"admin/config/regional/language\";s:11:\"router_path\";s:30:\"admin/config/regional/language\";s:10:\"link_title\";s:9:\"Languages\";s:7:\"options\";s:105:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:55:\"Configure languages for content and the user interface.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"1\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:3:\"-10\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"49\";s:2:\"p4\";s:3:\"371\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:38:\"a:1:{i:0;s:20:\"administer languages\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:48:\"a:1:{i:0;s:30:\"locale_languages_overview_form\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:30:\"admin/config/regional/language\";s:5:\"title\";s:9:\"Languages\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:55:\"Configure languages for content and the user interface.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:6:{i:374;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"374\";s:4:\"plid\";s:3:\"371\";s:9:\"link_path\";s:34:\"admin/config/regional/language/add\";s:11:\"router_path\";s:34:\"admin/config/regional/language/add\";s:10:\"link_title\";s:12:\"Add language\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"5\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"49\";s:2:\"p4\";s:3:\"371\";s:2:\"p5\";s:3:\"374\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:38:\"a:1:{i:0;s:20:\"administer languages\";}\";s:13:\"page_callback\";s:27:\"locale_languages_add_screen\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:30:\"admin/config/regional/language\";s:8:\"tab_root\";s:30:\"admin/config/regional/language\";s:5:\"title\";s:12:\"Add language\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"388\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:375;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"375\";s:4:\"plid\";s:3:\"371\";s:9:\"link_path\";s:40:\"admin/config/regional/language/configure\";s:11:\"router_path\";s:40:\"admin/config/regional/language/configure\";s:10:\"link_title\";s:23:\"Detection and selection\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:2:\"10\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"49\";s:2:\"p4\";s:3:\"371\";s:2:\"p5\";s:3:\"375\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:38:\"a:1:{i:0;s:20:\"administer languages\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:49:\"a:1:{i:0;s:31:\"locale_languages_configure_form\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:30:\"admin/config/regional/language\";s:8:\"tab_root\";s:30:\"admin/config/regional/language\";s:5:\"title\";s:23:\"Detection and selection\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:2:{i:390;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"390\";s:4:\"plid\";s:3:\"375\";s:9:\"link_path\";s:48:\"admin/config/regional/language/configure/session\";s:11:\"router_path\";s:48:\"admin/config/regional/language/configure/session\";s:10:\"link_title\";s:40:\"Session language detection configuration\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"6\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"49\";s:2:\"p4\";s:3:\"371\";s:2:\"p5\";s:3:\"375\";s:2:\"p6\";s:3:\"390\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:38:\"a:1:{i:0;s:20:\"administer languages\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:56:\"a:1:{i:0;s:38:\"locale_language_providers_session_form\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:48:\"admin/config/regional/language/configure/session\";s:5:\"title\";s:40:\"Session language detection configuration\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"4\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:391;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"391\";s:4:\"plid\";s:3:\"375\";s:9:\"link_path\";s:44:\"admin/config/regional/language/configure/url\";s:11:\"router_path\";s:44:\"admin/config/regional/language/configure/url\";s:10:\"link_title\";s:36:\"URL language detection configuration\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"6\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"49\";s:2:\"p4\";s:3:\"371\";s:2:\"p5\";s:3:\"375\";s:2:\"p6\";s:3:\"391\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:38:\"a:1:{i:0;s:20:\"administer languages\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:52:\"a:1:{i:0;s:34:\"locale_language_providers_url_form\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:44:\"admin/config/regional/language/configure/url\";s:5:\"title\";s:36:\"URL language detection configuration\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"4\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}}}i:377;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"377\";s:4:\"plid\";s:3:\"371\";s:9:\"link_path\";s:36:\"admin/config/regional/language/icons\";s:11:\"router_path\";s:36:\"admin/config/regional/language/icons\";s:10:\"link_title\";s:5:\"Icons\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:2:\"10\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"49\";s:2:\"p4\";s:3:\"371\";s:2:\"p5\";s:3:\"377\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:38:\"a:1:{i:0;s:20:\"administer languages\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:46:\"a:1:{i:0;s:28:\"languageicons_admin_settings\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:30:\"admin/config/regional/language\";s:8:\"tab_root\";s:30:\"admin/config/regional/language\";s:5:\"title\";s:5:\"Icons\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:379;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"379\";s:4:\"plid\";s:3:\"371\";s:9:\"link_path\";s:39:\"admin/config/regional/language/overview\";s:11:\"router_path\";s:39:\"admin/config/regional/language/overview\";s:10:\"link_title\";s:4:\"List\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"49\";s:2:\"p4\";s:3:\"371\";s:2:\"p5\";s:3:\"379\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:38:\"a:1:{i:0;s:20:\"administer languages\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:48:\"a:1:{i:0;s:30:\"locale_languages_overview_form\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:30:\"admin/config/regional/language\";s:8:\"tab_root\";s:30:\"admin/config/regional/language\";s:5:\"title\";s:4:\"List\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"140\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:386;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"386\";s:4:\"plid\";s:3:\"371\";s:9:\"link_path\";s:39:\"admin/config/regional/language/delete/%\";s:11:\"router_path\";s:39:\"admin/config/regional/language/delete/%\";s:10:\"link_title\";s:7:\"Confirm\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"49\";s:2:\"p4\";s:3:\"371\";s:2:\"p5\";s:3:\"386\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:12:\"a:1:{i:5;N;}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:38:\"a:1:{i:0;s:20:\"administer languages\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:54:\"a:2:{i:0;s:28:\"locale_languages_delete_form\";i:1;i:5;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:39:\"admin/config/regional/language/delete/%\";s:5:\"title\";s:7:\"Confirm\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:388;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"388\";s:4:\"plid\";s:3:\"371\";s:9:\"link_path\";s:37:\"admin/config/regional/language/edit/%\";s:11:\"router_path\";s:37:\"admin/config/regional/language/edit/%\";s:10:\"link_title\";s:13:\"Edit language\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"49\";s:2:\"p4\";s:3:\"371\";s:2:\"p5\";s:3:\"388\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:12:\"a:1:{i:5;N;}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:38:\"a:1:{i:0;s:20:\"administer languages\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:52:\"a:2:{i:0;s:26:\"locale_languages_edit_form\";i:1;i:5;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:37:\"admin/config/regional/language/edit/%\";s:5:\"title\";s:13:\"Edit language\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}}}i:372;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"372\";s:4:\"plid\";s:2:\"49\";s:9:\"link_path\";s:26:\"admin/config/regional/i18n\";s:11:\"router_path\";s:26:\"admin/config/regional/i18n\";s:10:\"link_title\";s:21:\"Multilingual settings\";s:7:\"options\";s:119:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:69:\"Configure extended options for multilingual content and translations.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:2:\"10\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"49\";s:2:\"p4\";s:3:\"372\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:47:\"a:1:{i:0;s:29:\"administer site configuration\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:53:\"a:2:{i:0;s:20:\"variable_module_form\";i:1;s:4:\"i18n\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:26:\"admin/config/regional/i18n\";s:5:\"title\";s:21:\"Multilingual settings\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:69:\"Configure extended options for multilingual content and translations.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:2:{i:381;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"381\";s:4:\"plid\";s:3:\"372\";s:9:\"link_path\";s:36:\"admin/config/regional/i18n/configure\";s:11:\"router_path\";s:36:\"admin/config/regional/i18n/configure\";s:10:\"link_title\";s:19:\"Multilingual system\";s:7:\"options\";s:119:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:69:\"Configure extended options for multilingual content and translations.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"49\";s:2:\"p4\";s:3:\"372\";s:2:\"p5\";s:3:\"381\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:47:\"a:1:{i:0;s:29:\"administer site configuration\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:53:\"a:2:{i:0;s:20:\"variable_module_form\";i:1;s:4:\"i18n\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:26:\"admin/config/regional/i18n\";s:8:\"tab_root\";s:26:\"admin/config/regional/i18n\";s:5:\"title\";s:19:\"Multilingual system\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"140\";s:11:\"description\";s:69:\"Configure extended options for multilingual content and translations.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:383;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"383\";s:4:\"plid\";s:3:\"372\";s:9:\"link_path\";s:34:\"admin/config/regional/i18n/strings\";s:11:\"router_path\";s:34:\"admin/config/regional/i18n/strings\";s:10:\"link_title\";s:7:\"Strings\";s:7:\"options\";s:83:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:33:\"Options for user defined strings.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:2:\"20\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"49\";s:2:\"p4\";s:3:\"372\";s:2:\"p5\";s:3:\"383\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:47:\"a:1:{i:0;s:29:\"administer site configuration\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:124:\"a:2:{i:0;s:18:\"variable_edit_form\";i:1;a:2:{i:0;s:27:\"i18n_string_allowed_formats\";i:1;s:27:\"i18n_string_source_language\";}}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:26:\"admin/config/regional/i18n\";s:8:\"tab_root\";s:26:\"admin/config/regional/i18n\";s:5:\"title\";s:7:\"Strings\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:33:\"Options for user defined strings.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}}}i:373;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"373\";s:4:\"plid\";s:2:\"49\";s:9:\"link_path\";s:31:\"admin/config/regional/translate\";s:11:\"router_path\";s:31:\"admin/config/regional/translate\";s:10:\"link_title\";s:19:\"Translate interface\";s:7:\"options\";s:109:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:59:\"Translate the built in interface and optionally other text.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"1\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:2:\"-5\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"49\";s:2:\"p4\";s:3:\"373\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:37:\"a:1:{i:0;s:19:\"translate interface\";}\";s:13:\"page_callback\";s:32:\"locale_translate_overview_screen\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:31:\"admin/config/regional/translate\";s:5:\"title\";s:19:\"Translate interface\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:59:\"Translate the built in interface and optionally other text.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:7:{i:376;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"376\";s:4:\"plid\";s:3:\"373\";s:9:\"link_path\";s:38:\"admin/config/regional/translate/export\";s:11:\"router_path\";s:38:\"admin/config/regional/translate/export\";s:10:\"link_title\";s:6:\"Export\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:2:\"30\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"49\";s:2:\"p4\";s:3:\"373\";s:2:\"p5\";s:3:\"376\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:37:\"a:1:{i:0;s:19:\"translate interface\";}\";s:13:\"page_callback\";s:30:\"locale_translate_export_screen\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:31:\"admin/config/regional/translate\";s:8:\"tab_root\";s:31:\"admin/config/regional/translate\";s:5:\"title\";s:6:\"Export\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:378;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"378\";s:4:\"plid\";s:3:\"373\";s:9:\"link_path\";s:38:\"admin/config/regional/translate/import\";s:11:\"router_path\";s:38:\"admin/config/regional/translate/import\";s:10:\"link_title\";s:6:\"Import\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:2:\"20\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"49\";s:2:\"p4\";s:3:\"373\";s:2:\"p5\";s:3:\"378\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:37:\"a:1:{i:0;s:19:\"translate interface\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:46:\"a:1:{i:0;s:28:\"locale_translate_import_form\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:31:\"admin/config/regional/translate\";s:8:\"tab_root\";s:31:\"admin/config/regional/translate\";s:5:\"title\";s:6:\"Import\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:382;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"382\";s:4:\"plid\";s:3:\"373\";s:9:\"link_path\";s:40:\"admin/config/regional/translate/overview\";s:11:\"router_path\";s:40:\"admin/config/regional/translate/overview\";s:10:\"link_title\";s:8:\"Overview\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"49\";s:2:\"p4\";s:3:\"373\";s:2:\"p5\";s:3:\"382\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:37:\"a:1:{i:0;s:19:\"translate interface\";}\";s:13:\"page_callback\";s:32:\"locale_translate_overview_screen\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:31:\"admin/config/regional/translate\";s:8:\"tab_root\";s:31:\"admin/config/regional/translate\";s:5:\"title\";s:8:\"Overview\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"140\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:384;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"384\";s:4:\"plid\";s:3:\"373\";s:9:\"link_path\";s:43:\"admin/config/regional/translate/i18n_string\";s:11:\"router_path\";s:43:\"admin/config/regional/translate/i18n_string\";s:10:\"link_title\";s:7:\"Strings\";s:7:\"options\";s:79:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:29:\"Refresh user defined strings.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:2:\"20\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"49\";s:2:\"p4\";s:3:\"373\";s:2:\"p5\";s:3:\"384\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:37:\"a:1:{i:0;s:19:\"translate interface\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:48:\"a:1:{i:0;s:30:\"i18n_string_admin_refresh_form\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:31:\"admin/config/regional/translate\";s:8:\"tab_root\";s:31:\"admin/config/regional/translate\";s:5:\"title\";s:7:\"Strings\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:29:\"Refresh user defined strings.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:385;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"385\";s:4:\"plid\";s:3:\"373\";s:9:\"link_path\";s:41:\"admin/config/regional/translate/translate\";s:11:\"router_path\";s:41:\"admin/config/regional/translate/translate\";s:10:\"link_title\";s:9:\"Translate\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:2:\"10\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"49\";s:2:\"p4\";s:3:\"373\";s:2:\"p5\";s:3:\"385\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:37:\"a:1:{i:0;s:19:\"translate interface\";}\";s:13:\"page_callback\";s:28:\"locale_translate_seek_screen\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:31:\"admin/config/regional/translate\";s:8:\"tab_root\";s:31:\"admin/config/regional/translate\";s:5:\"title\";s:9:\"Translate\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:387;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"387\";s:4:\"plid\";s:3:\"373\";s:9:\"link_path\";s:40:\"admin/config/regional/translate/delete/%\";s:11:\"router_path\";s:40:\"admin/config/regional/translate/delete/%\";s:10:\"link_title\";s:13:\"Delete string\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"49\";s:2:\"p4\";s:3:\"373\";s:2:\"p5\";s:3:\"387\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:12:\"a:1:{i:5;N;}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:37:\"a:1:{i:0;s:19:\"translate interface\";}\";s:13:\"page_callback\";s:28:\"locale_translate_delete_page\";s:14:\"page_arguments\";s:14:\"a:1:{i:0;i:5;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:40:\"admin/config/regional/translate/delete/%\";s:5:\"title\";s:13:\"Delete string\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:389;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"389\";s:4:\"plid\";s:3:\"373\";s:9:\"link_path\";s:38:\"admin/config/regional/translate/edit/%\";s:11:\"router_path\";s:38:\"admin/config/regional/translate/edit/%\";s:10:\"link_title\";s:11:\"Edit string\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"49\";s:2:\"p4\";s:3:\"373\";s:2:\"p5\";s:3:\"389\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:12:\"a:1:{i:5;N;}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:37:\"a:1:{i:0;s:19:\"translate interface\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:64:\"a:2:{i:0;s:38:\"i18n_string_locale_translate_edit_form\";i:1;i:5;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:38:\"admin/config/regional/translate/edit/%\";s:5:\"title\";s:11:\"Edit string\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}}}i:519;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"519\";s:4:\"plid\";s:2:\"49\";s:9:\"link_path\";s:38:\"admin/config/regional/i18n_translation\";s:11:\"router_path\";s:38:\"admin/config/regional/i18n_translation\";s:10:\"link_title\";s:16:\"Translation sets\";s:7:\"options\";s:76:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:26:\"Translation sets overview.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:2:\"10\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"49\";s:2:\"p4\";s:3:\"519\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:47:\"a:1:{i:0;s:29:\"administer site configuration\";}\";s:13:\"page_callback\";s:31:\"i18n_translation_admin_overview\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:38:\"admin/config/regional/i18n_translation\";s:5:\"title\";s:16:\"Translation sets\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:26:\"Translation sets overview.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:1:{i:521;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"521\";s:4:\"plid\";s:3:\"519\";s:9:\"link_path\";s:48:\"admin/config/regional/i18n_translation/configure\";s:11:\"router_path\";s:48:\"admin/config/regional/i18n_translation/configure\";s:10:\"link_title\";s:16:\"Translation sets\";s:7:\"options\";s:88:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:38:\"Overview of existing translation sets.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"49\";s:2:\"p4\";s:3:\"519\";s:2:\"p5\";s:3:\"521\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:47:\"a:1:{i:0;s:29:\"administer site configuration\";}\";s:13:\"page_callback\";s:31:\"i18n_translation_admin_overview\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:38:\"admin/config/regional/i18n_translation\";s:8:\"tab_root\";s:38:\"admin/config/regional/i18n_translation\";s:5:\"title\";s:16:\"Translation sets\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"140\";s:11:\"description\";s:38:\"Overview of existing translation sets.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}}}}}i:51;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:2:\"51\";s:4:\"plid\";s:1:\"8\";s:9:\"link_path\";s:19:\"admin/config/search\";s:11:\"router_path\";s:19:\"admin/config/search\";s:10:\"link_title\";s:19:\"Search and metadata\";s:7:\"options\";s:86:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:36:\"Local site search, metadata and SEO.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"1\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:3:\"-10\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"51\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:45:\"a:1:{i:0;s:27:\"access administration pages\";}\";s:13:\"page_callback\";s:28:\"system_admin_menu_block_page\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:19:\"admin/config/search\";s:5:\"title\";s:19:\"Search and metadata\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:36:\"Local site search, metadata and SEO.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:4:{i:69;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:2:\"69\";s:4:\"plid\";s:2:\"51\";s:9:\"link_path\";s:30:\"admin/config/search/clean-urls\";s:11:\"router_path\";s:30:\"admin/config/search/clean-urls\";s:10:\"link_title\";s:10:\"Clean URLs\";s:7:\"options\";s:93:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:43:\"Enable or disable clean URLs for your site.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"5\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"51\";s:2:\"p4\";s:2:\"69\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:47:\"a:1:{i:0;s:29:\"administer site configuration\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:43:\"a:1:{i:0;s:25:\"system_clean_url_settings\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:30:\"admin/config/search/clean-urls\";s:5:\"title\";s:10:\"Clean URLs\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:43:\"Enable or disable clean URLs for your site.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:197;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"197\";s:4:\"plid\";s:2:\"51\";s:9:\"link_path\";s:28:\"admin/config/search/settings\";s:11:\"router_path\";s:28:\"admin/config/search/settings\";s:10:\"link_title\";s:15:\"Search settings\";s:7:\"options\";s:117:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:67:\"Configure relevance settings for search and other indexing options.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:3:\"-10\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"51\";s:2:\"p4\";s:3:\"197\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:35:\"a:1:{i:0;s:17:\"administer search\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:39:\"a:1:{i:0;s:21:\"search_admin_settings\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:28:\"admin/config/search/settings\";s:5:\"title\";s:15:\"Search settings\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:67:\"Configure relevance settings for search and other indexing options.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:1:{i:203;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"203\";s:4:\"plid\";s:3:\"197\";s:9:\"link_path\";s:36:\"admin/config/search/settings/reindex\";s:11:\"router_path\";s:36:\"admin/config/search/settings/reindex\";s:10:\"link_title\";s:11:\"Clear index\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"51\";s:2:\"p4\";s:3:\"197\";s:2:\"p5\";s:3:\"203\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:35:\"a:1:{i:0;s:17:\"administer search\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:40:\"a:1:{i:0;s:22:\"search_reindex_confirm\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:36:\"admin/config/search/settings/reindex\";s:5:\"title\";s:11:\"Clear index\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"4\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}}}i:199;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"199\";s:4:\"plid\";s:2:\"51\";s:9:\"link_path\";s:24:\"admin/config/search/path\";s:11:\"router_path\";s:24:\"admin/config/search/path\";s:10:\"link_title\";s:11:\"URL aliases\";s:7:\"options\";s:96:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:46:\"Change your site\'s URL paths by aliasing them.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"1\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:2:\"-5\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"51\";s:2:\"p4\";s:3:\"199\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:40:\"a:1:{i:0;s:22:\"administer url aliases\";}\";s:13:\"page_callback\";s:19:\"path_admin_overview\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:24:\"admin/config/search/path\";s:5:\"title\";s:11:\"URL aliases\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:46:\"Change your site\'s URL paths by aliasing them.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:8:{i:200;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"200\";s:4:\"plid\";s:3:\"199\";s:9:\"link_path\";s:28:\"admin/config/search/path/add\";s:11:\"router_path\";s:28:\"admin/config/search/path/add\";s:10:\"link_title\";s:9:\"Add alias\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"51\";s:2:\"p4\";s:3:\"199\";s:2:\"p5\";s:3:\"200\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:40:\"a:1:{i:0;s:22:\"administer url aliases\";}\";s:13:\"page_callback\";s:15:\"path_admin_edit\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:24:\"admin/config/search/path\";s:8:\"tab_root\";s:24:\"admin/config/search/path\";s:5:\"title\";s:9:\"Add alias\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"388\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:207;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"207\";s:4:\"plid\";s:3:\"199\";s:9:\"link_path\";s:29:\"admin/config/search/path/list\";s:11:\"router_path\";s:29:\"admin/config/search/path/list\";s:10:\"link_title\";s:4:\"List\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:3:\"-10\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"51\";s:2:\"p4\";s:3:\"199\";s:2:\"p5\";s:3:\"207\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:40:\"a:1:{i:0;s:22:\"administer url aliases\";}\";s:13:\"page_callback\";s:19:\"path_admin_overview\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:24:\"admin/config/search/path\";s:8:\"tab_root\";s:24:\"admin/config/search/path\";s:5:\"title\";s:4:\"List\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"140\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:209;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"209\";s:4:\"plid\";s:3:\"199\";s:9:\"link_path\";s:33:\"admin/config/search/path/delete/%\";s:11:\"router_path\";s:33:\"admin/config/search/path/delete/%\";s:10:\"link_title\";s:12:\"Delete alias\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"51\";s:2:\"p4\";s:3:\"199\";s:2:\"p5\";s:3:\"209\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:26:\"a:1:{i:5;s:9:\"path_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:40:\"a:1:{i:0;s:22:\"administer url aliases\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:51:\"a:2:{i:0;s:25:\"path_admin_delete_confirm\";i:1;i:5;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:33:\"admin/config/search/path/delete/%\";s:5:\"title\";s:12:\"Delete alias\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:211;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"211\";s:4:\"plid\";s:3:\"199\";s:9:\"link_path\";s:31:\"admin/config/search/path/edit/%\";s:11:\"router_path\";s:31:\"admin/config/search/path/edit/%\";s:10:\"link_title\";s:10:\"Edit alias\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"51\";s:2:\"p4\";s:3:\"199\";s:2:\"p5\";s:3:\"211\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:26:\"a:1:{i:5;s:9:\"path_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:40:\"a:1:{i:0;s:22:\"administer url aliases\";}\";s:13:\"page_callback\";s:15:\"path_admin_edit\";s:14:\"page_arguments\";s:14:\"a:1:{i:0;i:5;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:31:\"admin/config/search/path/edit/%\";s:5:\"title\";s:10:\"Edit alias\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:504;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"504\";s:4:\"plid\";s:3:\"199\";s:9:\"link_path\";s:36:\"admin/config/search/path/update_bulk\";s:11:\"router_path\";s:36:\"admin/config/search/path/update_bulk\";s:10:\"link_title\";s:11:\"Bulk update\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:2:\"30\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"51\";s:2:\"p4\";s:3:\"199\";s:2:\"p5\";s:3:\"504\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:40:\"a:1:{i:0;s:22:\"administer url aliases\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:43:\"a:1:{i:0;s:25:\"pathauto_bulk_update_form\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:24:\"admin/config/search/path\";s:8:\"tab_root\";s:24:\"admin/config/search/path\";s:5:\"title\";s:11:\"Bulk update\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:505;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"505\";s:4:\"plid\";s:3:\"199\";s:9:\"link_path\";s:36:\"admin/config/search/path/delete_bulk\";s:11:\"router_path\";s:36:\"admin/config/search/path/delete_bulk\";s:10:\"link_title\";s:14:\"Delete aliases\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:2:\"40\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"51\";s:2:\"p4\";s:3:\"199\";s:2:\"p5\";s:3:\"505\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:40:\"a:1:{i:0;s:22:\"administer url aliases\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:39:\"a:1:{i:0;s:21:\"pathauto_admin_delete\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:24:\"admin/config/search/path\";s:8:\"tab_root\";s:24:\"admin/config/search/path\";s:5:\"title\";s:14:\"Delete aliases\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:506;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"506\";s:4:\"plid\";s:3:\"199\";s:9:\"link_path\";s:33:\"admin/config/search/path/patterns\";s:11:\"router_path\";s:33:\"admin/config/search/path/patterns\";s:10:\"link_title\";s:8:\"Patterns\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:2:\"10\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"51\";s:2:\"p4\";s:3:\"199\";s:2:\"p5\";s:3:\"506\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:37:\"a:1:{i:0;s:19:\"administer pathauto\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:40:\"a:1:{i:0;s:22:\"pathauto_patterns_form\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:24:\"admin/config/search/path\";s:8:\"tab_root\";s:24:\"admin/config/search/path\";s:5:\"title\";s:8:\"Patterns\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:507;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"507\";s:4:\"plid\";s:3:\"199\";s:9:\"link_path\";s:33:\"admin/config/search/path/settings\";s:11:\"router_path\";s:33:\"admin/config/search/path/settings\";s:10:\"link_title\";s:8:\"Settings\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:2:\"20\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"51\";s:2:\"p4\";s:3:\"199\";s:2:\"p5\";s:3:\"507\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:37:\"a:1:{i:0;s:19:\"administer pathauto\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:40:\"a:1:{i:0;s:22:\"pathauto_settings_form\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:24:\"admin/config/search/path\";s:8:\"tab_root\";s:24:\"admin/config/search/path\";s:5:\"title\";s:8:\"Settings\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}}}i:438;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"438\";s:4:\"plid\";s:2:\"51\";s:9:\"link_path\";s:29:\"admin/config/search/votingapi\";s:11:\"router_path\";s:29:\"admin/config/search/votingapi\";s:10:\"link_title\";s:10:\"Voting API\";s:7:\"options\";s:115:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:65:\"Configure sitewide settings for user-generated ratings and votes.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"51\";s:2:\"p4\";s:3:\"438\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:39:\"a:1:{i:0;s:21:\"administer voting api\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:41:\"a:1:{i:0;s:23:\"votingapi_settings_form\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:29:\"admin/config/search/votingapi\";s:5:\"title\";s:10:\"Voting API\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:65:\"Configure sitewide settings for user-generated ratings and votes.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}}}i:54;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:2:\"54\";s:4:\"plid\";s:1:\"8\";s:9:\"link_path\";s:19:\"admin/config/system\";s:11:\"router_path\";s:19:\"admin/config/system\";s:10:\"link_title\";s:6:\"System\";s:7:\"options\";s:87:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:37:\"General system related configuration.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"1\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:3:\"-20\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"54\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:45:\"a:1:{i:0;s:27:\"access administration pages\";}\";s:13:\"page_callback\";s:28:\"system_admin_menu_block_page\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:19:\"admin/config/system\";s:5:\"title\";s:6:\"System\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:37:\"General system related configuration.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:6:{i:64;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:2:\"64\";s:4:\"plid\";s:2:\"54\";s:9:\"link_path\";s:27:\"admin/config/system/actions\";s:11:\"router_path\";s:27:\"admin/config/system/actions\";s:10:\"link_title\";s:7:\"Actions\";s:7:\"options\";s:91:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:41:\"Manage the actions defined for your site.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"1\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"54\";s:2:\"p4\";s:2:\"64\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:36:\"a:1:{i:0;s:18:\"administer actions\";}\";s:13:\"page_callback\";s:21:\"system_actions_manage\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:27:\"admin/config/system/actions\";s:5:\"title\";s:7:\"Actions\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:41:\"Manage the actions defined for your site.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:3:{i:102;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"102\";s:4:\"plid\";s:2:\"64\";s:9:\"link_path\";s:37:\"admin/config/system/actions/configure\";s:11:\"router_path\";s:37:\"admin/config/system/actions/configure\";s:10:\"link_title\";s:28:\"Configure an advanced action\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"54\";s:2:\"p4\";s:2:\"64\";s:2:\"p5\";s:3:\"102\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:36:\"a:1:{i:0;s:18:\"administer actions\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:42:\"a:1:{i:0;s:24:\"system_actions_configure\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:37:\"admin/config/system/actions/configure\";s:5:\"title\";s:28:\"Configure an advanced action\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"4\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:109;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"109\";s:4:\"plid\";s:2:\"64\";s:9:\"link_path\";s:34:\"admin/config/system/actions/manage\";s:11:\"router_path\";s:34:\"admin/config/system/actions/manage\";s:10:\"link_title\";s:14:\"Manage actions\";s:7:\"options\";s:91:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:41:\"Manage the actions defined for your site.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:2:\"-2\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"54\";s:2:\"p4\";s:2:\"64\";s:2:\"p5\";s:3:\"109\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:36:\"a:1:{i:0;s:18:\"administer actions\";}\";s:13:\"page_callback\";s:21:\"system_actions_manage\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:27:\"admin/config/system/actions\";s:8:\"tab_root\";s:27:\"admin/config/system/actions\";s:5:\"title\";s:14:\"Manage actions\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"140\";s:11:\"description\";s:41:\"Manage the actions defined for your site.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:127;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"127\";s:4:\"plid\";s:2:\"64\";s:9:\"link_path\";s:36:\"admin/config/system/actions/delete/%\";s:11:\"router_path\";s:36:\"admin/config/system/actions/delete/%\";s:10:\"link_title\";s:13:\"Delete action\";s:7:\"options\";s:67:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:17:\"Delete an action.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"54\";s:2:\"p4\";s:2:\"64\";s:2:\"p5\";s:3:\"127\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:30:\"a:1:{i:5;s:12:\"actions_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:36:\"a:1:{i:0;s:18:\"administer actions\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:52:\"a:2:{i:0;s:26:\"system_actions_delete_form\";i:1;i:5;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:36:\"admin/config/system/actions/delete/%\";s:5:\"title\";s:13:\"Delete action\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:17:\"Delete an action.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}}}i:70;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:2:\"70\";s:4:\"plid\";s:2:\"54\";s:9:\"link_path\";s:24:\"admin/config/system/cron\";s:11:\"router_path\";s:24:\"admin/config/system/cron\";s:10:\"link_title\";s:4:\"Cron\";s:7:\"options\";s:90:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:40:\"Manage automatic site maintenance tasks.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:2:\"20\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"54\";s:2:\"p4\";s:2:\"70\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:47:\"a:1:{i:0;s:29:\"administer site configuration\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:38:\"a:1:{i:0;s:20:\"system_cron_settings\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:24:\"admin/config/system/cron\";s:5:\"title\";s:4:\"Cron\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:40:\"Manage automatic site maintenance tasks.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:92;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:2:\"92\";s:4:\"plid\";s:2:\"54\";s:9:\"link_path\";s:36:\"admin/config/system/site-information\";s:11:\"router_path\";s:36:\"admin/config/system/site-information\";s:10:\"link_title\";s:16:\"Site information\";s:7:\"options\";s:155:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:104:\"Change site name, e-mail address, slogan, default front page, and number of posts per page, error pages.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:3:\"-20\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"54\";s:2:\"p4\";s:2:\"92\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:47:\"a:1:{i:0;s:29:\"administer site configuration\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:50:\"a:1:{i:0;s:32:\"system_site_information_settings\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:36:\"admin/config/system/site-information\";s:5:\"title\";s:16:\"Site information\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:104:\"Change site name, e-mail address, slogan, default front page, and number of posts per page, error pages.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:434;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"434\";s:4:\"plid\";s:2:\"54\";s:9:\"link_path\";s:30:\"admin/config/system/statistics\";s:11:\"router_path\";s:30:\"admin/config/system/statistics\";s:10:\"link_title\";s:10:\"Statistics\";s:7:\"options\";s:118:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:68:\"Control details about what and how your site logs access statistics.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:3:\"-15\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"54\";s:2:\"p4\";s:3:\"434\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:39:\"a:1:{i:0;s:21:\"administer statistics\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:42:\"a:1:{i:0;s:24:\"statistics_settings_form\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:30:\"admin/config/system/statistics\";s:5:\"title\";s:10:\"Statistics\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:68:\"Control details about what and how your site logs access statistics.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:444;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"444\";s:4:\"plid\";s:2:\"54\";s:9:\"link_path\";s:27:\"admin/config/system/message\";s:11:\"router_path\";s:27:\"admin/config/system/message\";s:10:\"link_title\";s:16:\"Message settings\";s:7:\"options\";s:83:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:33:\"Manage message purging upon cron.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"1\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"54\";s:2:\"p4\";s:3:\"444\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:42:\"a:1:{i:0;s:24:\"administer message types\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:45:\"a:1:{i:0;s:27:\"message_user_admin_settings\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:27:\"admin/config/system/message\";s:5:\"title\";s:16:\"Message settings\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:33:\"Manage message purging upon cron.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:1:{i:445;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"445\";s:4:\"plid\";s:3:\"444\";s:9:\"link_path\";s:37:\"admin/config/system/message/text-copy\";s:11:\"router_path\";s:37:\"admin/config/system/message/text-copy\";s:10:\"link_title\";s:25:\"Copy messages text fields\";s:7:\"options\";s:103:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:53:\"Copy messages text fields from one language to others\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"54\";s:2:\"p4\";s:3:\"444\";s:2:\"p5\";s:3:\"445\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:42:\"a:1:{i:0;s:24:\"administer message types\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:41:\"a:1:{i:0;s:23:\"message_admin_text_copy\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:37:\"admin/config/system/message/text-copy\";s:5:\"title\";s:25:\"Copy messages text fields\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:53:\"Copy messages text fields from one language to others\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}}}i:629;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"629\";s:4:\"plid\";s:2:\"54\";s:9:\"link_path\";s:31:\"admin/config/system/remember_me\";s:11:\"router_path\";s:31:\"admin/config/system/remember_me\";s:10:\"link_title\";s:20:\"Remember me settings\";s:7:\"options\";s:114:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:64:\"Configure settings like session time out for remember_me module.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"54\";s:2:\"p4\";s:3:\"629\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:47:\"a:1:{i:0;s:29:\"administer site configuration\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:44:\"a:1:{i:0;s:26:\"remember_me_admin_settings\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:31:\"admin/config/system/remember_me\";s:5:\"title\";s:20:\"Remember me settings\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:64:\"Configure settings like session time out for remember_me module.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}}}i:58;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:2:\"58\";s:4:\"plid\";s:1:\"8\";s:9:\"link_path\";s:27:\"admin/config/user-interface\";s:11:\"router_path\";s:27:\"admin/config/user-interface\";s:10:\"link_title\";s:14:\"User interface\";s:7:\"options\";s:88:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:38:\"Tools that enhance the user interface.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"1\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:3:\"-15\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"58\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:45:\"a:1:{i:0;s:27:\"access administration pages\";}\";s:13:\"page_callback\";s:28:\"system_admin_menu_block_page\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:27:\"admin/config/user-interface\";s:5:\"title\";s:14:\"User interface\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:38:\"Tools that enhance the user interface.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:4:{i:198;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"198\";s:4:\"plid\";s:2:\"58\";s:9:\"link_path\";s:36:\"admin/config/user-interface/shortcut\";s:11:\"router_path\";s:36:\"admin/config/user-interface/shortcut\";s:10:\"link_title\";s:9:\"Shortcuts\";s:7:\"options\";s:79:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:29:\"Add and modify shortcut sets.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"1\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"58\";s:2:\"p4\";s:3:\"198\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:38:\"a:1:{i:0;s:20:\"administer shortcuts\";}\";s:13:\"page_callback\";s:18:\"shortcut_set_admin\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:36:\"admin/config/user-interface/shortcut\";s:5:\"title\";s:9:\"Shortcuts\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:29:\"Add and modify shortcut sets.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:3:{i:201;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"201\";s:4:\"plid\";s:3:\"198\";s:9:\"link_path\";s:44:\"admin/config/user-interface/shortcut/add-set\";s:11:\"router_path\";s:44:\"admin/config/user-interface/shortcut/add-set\";s:10:\"link_title\";s:16:\"Add shortcut set\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"58\";s:2:\"p4\";s:3:\"198\";s:2:\"p5\";s:3:\"201\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:38:\"a:1:{i:0;s:20:\"administer shortcuts\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:39:\"a:1:{i:0;s:21:\"shortcut_set_add_form\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:36:\"admin/config/user-interface/shortcut\";s:8:\"tab_root\";s:36:\"admin/config/user-interface/shortcut\";s:5:\"title\";s:16:\"Add shortcut set\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"388\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:205;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"205\";s:4:\"plid\";s:3:\"198\";s:9:\"link_path\";s:38:\"admin/config/user-interface/shortcut/%\";s:11:\"router_path\";s:38:\"admin/config/user-interface/shortcut/%\";s:10:\"link_title\";s:14:\"Edit shortcuts\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"1\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"58\";s:2:\"p4\";s:3:\"198\";s:2:\"p5\";s:3:\"205\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:35:\"a:1:{i:4;s:17:\"shortcut_set_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:24:\"shortcut_set_edit_access\";s:16:\"access_arguments\";s:14:\"a:1:{i:0;i:4;}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:48:\"a:2:{i:0;s:22:\"shortcut_set_customize\";i:1;i:4;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:38:\"admin/config/user-interface/shortcut/%\";s:5:\"title\";s:14:\"Edit shortcuts\";s:14:\"title_callback\";s:27:\"shortcut_set_title_callback\";s:15:\"title_arguments\";s:14:\"a:1:{i:0;i:4;}\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:4:{i:208;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"208\";s:4:\"plid\";s:3:\"205\";s:9:\"link_path\";s:47:\"admin/config/user-interface/shortcut/%/add-link\";s:11:\"router_path\";s:47:\"admin/config/user-interface/shortcut/%/add-link\";s:10:\"link_title\";s:12:\"Add shortcut\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"6\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"58\";s:2:\"p4\";s:3:\"198\";s:2:\"p5\";s:3:\"205\";s:2:\"p6\";s:3:\"208\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:35:\"a:1:{i:4;s:17:\"shortcut_set_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:24:\"shortcut_set_edit_access\";s:16:\"access_arguments\";s:14:\"a:1:{i:0;i:4;}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:43:\"a:2:{i:0;s:17:\"shortcut_link_add\";i:1;i:4;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:38:\"admin/config/user-interface/shortcut/%\";s:8:\"tab_root\";s:38:\"admin/config/user-interface/shortcut/%\";s:5:\"title\";s:12:\"Add shortcut\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"388\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:210;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"210\";s:4:\"plid\";s:3:\"205\";s:9:\"link_path\";s:45:\"admin/config/user-interface/shortcut/%/delete\";s:11:\"router_path\";s:45:\"admin/config/user-interface/shortcut/%/delete\";s:10:\"link_title\";s:19:\"Delete shortcut set\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"6\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"58\";s:2:\"p4\";s:3:\"198\";s:2:\"p5\";s:3:\"205\";s:2:\"p6\";s:3:\"210\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:35:\"a:1:{i:4;s:17:\"shortcut_set_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:26:\"shortcut_set_delete_access\";s:16:\"access_arguments\";s:14:\"a:1:{i:0;i:4;}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:50:\"a:2:{i:0;s:24:\"shortcut_set_delete_form\";i:1;i:4;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:45:\"admin/config/user-interface/shortcut/%/delete\";s:5:\"title\";s:19:\"Delete shortcut set\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:212;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"212\";s:4:\"plid\";s:3:\"205\";s:9:\"link_path\";s:43:\"admin/config/user-interface/shortcut/%/edit\";s:11:\"router_path\";s:43:\"admin/config/user-interface/shortcut/%/edit\";s:10:\"link_title\";s:13:\"Edit set name\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:2:\"10\";s:5:\"depth\";s:1:\"6\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"58\";s:2:\"p4\";s:3:\"198\";s:2:\"p5\";s:3:\"205\";s:2:\"p6\";s:3:\"212\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:35:\"a:1:{i:4;s:17:\"shortcut_set_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:24:\"shortcut_set_edit_access\";s:16:\"access_arguments\";s:14:\"a:1:{i:0;i:4;}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:48:\"a:2:{i:0;s:22:\"shortcut_set_edit_form\";i:1;i:4;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:38:\"admin/config/user-interface/shortcut/%\";s:8:\"tab_root\";s:38:\"admin/config/user-interface/shortcut/%\";s:5:\"title\";s:13:\"Edit set name\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:214;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"214\";s:4:\"plid\";s:3:\"205\";s:9:\"link_path\";s:44:\"admin/config/user-interface/shortcut/%/links\";s:11:\"router_path\";s:44:\"admin/config/user-interface/shortcut/%/links\";s:10:\"link_title\";s:10:\"List links\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"6\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"58\";s:2:\"p4\";s:3:\"198\";s:2:\"p5\";s:3:\"205\";s:2:\"p6\";s:3:\"214\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:35:\"a:1:{i:4;s:17:\"shortcut_set_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:24:\"shortcut_set_edit_access\";s:16:\"access_arguments\";s:14:\"a:1:{i:0;i:4;}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:48:\"a:2:{i:0;s:22:\"shortcut_set_customize\";i:1;i:4;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:38:\"admin/config/user-interface/shortcut/%\";s:8:\"tab_root\";s:38:\"admin/config/user-interface/shortcut/%\";s:5:\"title\";s:10:\"List links\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"140\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}}}i:213;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"213\";s:4:\"plid\";s:3:\"198\";s:9:\"link_path\";s:43:\"admin/config/user-interface/shortcut/link/%\";s:11:\"router_path\";s:43:\"admin/config/user-interface/shortcut/link/%\";s:10:\"link_title\";s:13:\"Edit shortcut\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"1\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"58\";s:2:\"p4\";s:3:\"198\";s:2:\"p5\";s:3:\"213\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:32:\"a:1:{i:5;s:14:\"menu_link_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:20:\"shortcut_link_access\";s:16:\"access_arguments\";s:14:\"a:1:{i:0;i:5;}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:44:\"a:2:{i:0;s:18:\"shortcut_link_edit\";i:1;i:5;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:43:\"admin/config/user-interface/shortcut/link/%\";s:5:\"title\";s:13:\"Edit shortcut\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:1:{i:215;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"215\";s:4:\"plid\";s:3:\"213\";s:9:\"link_path\";s:50:\"admin/config/user-interface/shortcut/link/%/delete\";s:11:\"router_path\";s:50:\"admin/config/user-interface/shortcut/link/%/delete\";s:10:\"link_title\";s:15:\"Delete shortcut\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"6\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"58\";s:2:\"p4\";s:3:\"198\";s:2:\"p5\";s:3:\"213\";s:2:\"p6\";s:3:\"215\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:32:\"a:1:{i:5;s:14:\"menu_link_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:20:\"shortcut_link_access\";s:16:\"access_arguments\";s:14:\"a:1:{i:0;i:5;}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:46:\"a:2:{i:0;s:20:\"shortcut_link_delete\";i:1;i:5;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:50:\"admin/config/user-interface/shortcut/link/%/delete\";s:5:\"title\";s:15:\"Delete shortcut\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}}}}}i:358;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"358\";s:4:\"plid\";s:2:\"58\";s:9:\"link_path\";s:40:\"admin/config/user-interface/modulefilter\";s:11:\"router_path\";s:40:\"admin/config/user-interface/modulefilter\";s:10:\"link_title\";s:13:\"Module filter\";s:7:\"options\";s:96:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:46:\"Configure how the modules page looks and acts.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"58\";s:2:\"p4\";s:3:\"358\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:42:\"a:1:{i:0;s:24:\"administer module filter\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:40:\"a:1:{i:0;s:22:\"module_filter_settings\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:40:\"admin/config/user-interface/modulefilter\";s:5:\"title\";s:13:\"Module filter\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:46:\"Configure how the modules page looks and acts.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:573;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"573\";s:4:\"plid\";s:2:\"58\";s:9:\"link_path\";s:43:\"admin/config/user-interface/menu-breadcrumb\";s:11:\"router_path\";s:43:\"admin/config/user-interface/menu-breadcrumb\";s:10:\"link_title\";s:15:\"Menu Breadcrumb\";s:7:\"options\";s:76:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:26:\"Configure menu breadcrumb.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"58\";s:2:\"p4\";s:3:\"573\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:47:\"a:1:{i:0;s:29:\"administer site configuration\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:53:\"a:1:{i:0;s:35:\"menu_breadcrumb_admin_settings_form\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:43:\"admin/config/user-interface/menu-breadcrumb\";s:5:\"title\";s:15:\"Menu Breadcrumb\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:26:\"Configure menu breadcrumb.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:690;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"690\";s:4:\"plid\";s:2:\"58\";s:9:\"link_path\";s:34:\"admin/config/user-interface/chosen\";s:11:\"router_path\";s:34:\"admin/config/user-interface/chosen\";s:10:\"link_title\";s:6:\"Chosen\";s:7:\"options\";s:81:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:31:\"Configuration for Chosen plugin\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"58\";s:2:\"p4\";s:3:\"690\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:47:\"a:1:{i:0;s:29:\"administer site configuration\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:39:\"a:1:{i:0;s:21:\"chosen_admin_settings\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:34:\"admin/config/user-interface/chosen\";s:5:\"title\";s:6:\"Chosen\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:31:\"Configuration for Chosen plugin\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}}}i:61;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:2:\"61\";s:4:\"plid\";s:1:\"8\";s:9:\"link_path\";s:21:\"admin/config/services\";s:11:\"router_path\";s:21:\"admin/config/services\";s:10:\"link_title\";s:12:\"Web services\";s:7:\"options\";s:80:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:30:\"Tools related to web services.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"1\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"61\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:45:\"a:1:{i:0;s:27:\"access administration pages\";}\";s:13:\"page_callback\";s:28:\"system_admin_menu_block_page\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:21:\"admin/config/services\";s:5:\"title\";s:12:\"Web services\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:30:\"Tools related to web services.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:2:{i:87;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:2:\"87\";s:4:\"plid\";s:2:\"61\";s:9:\"link_path\";s:36:\"admin/config/services/rss-publishing\";s:11:\"router_path\";s:36:\"admin/config/services/rss-publishing\";s:10:\"link_title\";s:14:\"RSS publishing\";s:7:\"options\";s:165:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:114:\"Configure the site description, the number of items per feed and whether feeds should be titles/teasers/full-text.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"61\";s:2:\"p4\";s:2:\"87\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:47:\"a:1:{i:0;s:29:\"administer site configuration\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:43:\"a:1:{i:0;s:25:\"system_rss_feeds_settings\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:36:\"admin/config/services/rss-publishing\";s:5:\"title\";s:14:\"RSS publishing\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:114:\"Configure the site description, the number of items per feed and whether feeds should be titles/teasers/full-text.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:578;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"578\";s:4:\"plid\";s:2:\"61\";s:9:\"link_path\";s:31:\"admin/config/services/sharethis\";s:11:\"router_path\";s:31:\"admin/config/services/sharethis\";s:10:\"link_title\";s:9:\"ShareThis\";s:7:\"options\";s:141:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:91:\"Choose the widget, button family, and services for using ShareThis to share content online.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"61\";s:2:\"p4\";s:3:\"578\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:38:\"a:1:{i:0;s:20:\"administer sharethis\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:46:\"a:1:{i:0;s:28:\"sharethis_configuration_form\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:31:\"admin/config/services/sharethis\";s:5:\"title\";s:9:\"ShareThis\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:91:\"Choose the widget, button family, and services for using ShareThis to share content online.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}}}i:62;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:2:\"62\";s:4:\"plid\";s:1:\"8\";s:9:\"link_path\";s:21:\"admin/config/workflow\";s:11:\"router_path\";s:21:\"admin/config/workflow\";s:10:\"link_title\";s:8:\"Workflow\";s:7:\"options\";s:93:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:43:\"Content workflow, editorial workflow tools.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"5\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:2:\"62\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:45:\"a:1:{i:0;s:27:\"access administration pages\";}\";s:13:\"page_callback\";s:28:\"system_admin_menu_block_page\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:21:\"admin/config/workflow\";s:5:\"title\";s:8:\"Workflow\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:43:\"Content workflow, editorial workflow tools.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:355;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"355\";s:4:\"plid\";s:1:\"8\";s:9:\"link_path\";s:27:\"admin/config/administration\";s:11:\"router_path\";s:27:\"admin/config/administration\";s:10:\"link_title\";s:14:\"Administration\";s:7:\"options\";s:71:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:21:\"Administration tools.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"1\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:3:\"355\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:45:\"a:1:{i:0;s:27:\"access administration pages\";}\";s:13:\"page_callback\";s:28:\"system_admin_menu_block_page\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:27:\"admin/config/administration\";s:5:\"title\";s:14:\"Administration\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:21:\"Administration tools.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:1:{i:357;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"357\";s:4:\"plid\";s:3:\"355\";s:9:\"link_path\";s:38:\"admin/config/administration/admin_menu\";s:11:\"router_path\";s:38:\"admin/config/administration/admin_menu\";s:10:\"link_title\";s:19:\"Administration menu\";s:7:\"options\";s:86:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:36:\"Adjust administration menu settings.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:3:\"355\";s:2:\"p4\";s:3:\"357\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:47:\"a:1:{i:0;s:29:\"administer site configuration\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:43:\"a:1:{i:0;s:25:\"admin_menu_theme_settings\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:38:\"admin/config/administration/admin_menu\";s:5:\"title\";s:19:\"Administration menu\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:36:\"Adjust administration menu settings.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}}}i:541;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"541\";s:4:\"plid\";s:1:\"8\";s:9:\"link_path\";s:17:\"admin/config/date\";s:11:\"router_path\";s:17:\"admin/config/date\";s:10:\"link_title\";s:8:\"Date API\";s:7:\"options\";s:92:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:42:\"Settings for modules the use the Date API.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"1\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:3:\"-10\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:3:\"541\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:47:\"a:1:{i:0;s:29:\"administer site configuration\";}\";s:13:\"page_callback\";s:28:\"system_admin_menu_block_page\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:17:\"admin/config/date\";s:5:\"title\";s:8:\"Date API\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:42:\"Settings for modules the use the Date API.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:1:{i:543;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"543\";s:4:\"plid\";s:3:\"541\";s:9:\"link_path\";s:26:\"admin/config/date/calendar\";s:11:\"router_path\";s:26:\"admin/config/date/calendar\";s:10:\"link_title\";s:8:\"Calendar\";s:7:\"options\";s:74:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:24:\"Calendar administration.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"8\";s:2:\"p3\";s:3:\"541\";s:2:\"p4\";s:3:\"543\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:47:\"a:1:{i:0;s:29:\"administer site configuration\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:41:\"a:1:{i:0;s:23:\"calendar_admin_settings\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:26:\"admin/config/date/calendar\";s:5:\"title\";s:8:\"Calendar\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:24:\"Calendar administration.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}}}}}i:9;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:1:\"9\";s:4:\"plid\";s:1:\"1\";s:9:\"link_path\";s:13:\"admin/content\";s:11:\"router_path\";s:13:\"admin/content\";s:10:\"link_title\";s:7:\"Content\";s:7:\"options\";s:82:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:32:\"Administer content and comments.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"1\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:3:\"-10\";s:5:\"depth\";s:1:\"2\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"9\";s:2:\"p3\";s:1:\"0\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:41:\"a:1:{i:0;s:23:\"access content overview\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:36:\"a:1:{i:0;s:18:\"node_admin_content\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:13:\"admin/content\";s:5:\"title\";s:7:\"Content\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:32:\"Administer content and comments.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:5:{i:30;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:2:\"30\";s:4:\"plid\";s:1:\"9\";s:9:\"link_path\";s:21:\"admin/content/comment\";s:11:\"router_path\";s:21:\"admin/content/comment\";s:10:\"link_title\";s:8:\"Comments\";s:7:\"options\";s:109:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:59:\"List and edit site comments and the comment approval queue.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"9\";s:2:\"p3\";s:2:\"30\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:37:\"a:1:{i:0;s:19:\"administer comments\";}\";s:13:\"page_callback\";s:13:\"comment_admin\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:13:\"admin/content\";s:8:\"tab_root\";s:13:\"admin/content\";s:5:\"title\";s:8:\"Comments\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"134\";s:11:\"description\";s:59:\"List and edit site comments and the comment approval queue.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:2:{i:86;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:2:\"86\";s:4:\"plid\";s:2:\"30\";s:9:\"link_path\";s:25:\"admin/content/comment/new\";s:11:\"router_path\";s:25:\"admin/content/comment/new\";s:10:\"link_title\";s:18:\"Published comments\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:3:\"-10\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"9\";s:2:\"p3\";s:2:\"30\";s:2:\"p4\";s:2:\"86\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:37:\"a:1:{i:0;s:19:\"administer comments\";}\";s:13:\"page_callback\";s:13:\"comment_admin\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:21:\"admin/content/comment\";s:8:\"tab_root\";s:13:\"admin/content\";s:5:\"title\";s:18:\"Published comments\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"140\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:95;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:2:\"95\";s:4:\"plid\";s:2:\"30\";s:9:\"link_path\";s:30:\"admin/content/comment/approval\";s:11:\"router_path\";s:30:\"admin/content/comment/approval\";s:10:\"link_title\";s:19:\"Unapproved comments\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"9\";s:2:\"p3\";s:2:\"30\";s:2:\"p4\";s:2:\"95\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:37:\"a:1:{i:0;s:19:\"administer comments\";}\";s:13:\"page_callback\";s:13:\"comment_admin\";s:14:\"page_arguments\";s:25:\"a:1:{i:0;s:8:\"approval\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:21:\"admin/content/comment\";s:8:\"tab_root\";s:13:\"admin/content\";s:5:\"title\";s:19:\"Unapproved comments\";s:14:\"title_callback\";s:25:\"comment_count_unpublished\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}}}i:32;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:2:\"32\";s:4:\"plid\";s:1:\"9\";s:9:\"link_path\";s:18:\"admin/content/node\";s:11:\"router_path\";s:18:\"admin/content/node\";s:10:\"link_title\";s:7:\"Content\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:3:\"-10\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"9\";s:2:\"p3\";s:2:\"32\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:41:\"a:1:{i:0;s:23:\"access content overview\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:36:\"a:1:{i:0;s:18:\"node_admin_content\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:13:\"admin/content\";s:8:\"tab_root\";s:13:\"admin/content\";s:5:\"title\";s:7:\"Content\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"140\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:315;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"315\";s:4:\"plid\";s:1:\"9\";s:9:\"link_path\";s:18:\"admin/content/book\";s:11:\"router_path\";s:18:\"admin/content/book\";s:10:\"link_title\";s:5:\"Books\";s:7:\"options\";s:83:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:33:\"Manage your site\'s book outlines.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"9\";s:2:\"p3\";s:3:\"315\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:42:\"a:1:{i:0;s:24:\"administer book outlines\";}\";s:13:\"page_callback\";s:19:\"book_admin_overview\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:13:\"admin/content\";s:8:\"tab_root\";s:13:\"admin/content\";s:5:\"title\";s:5:\"Books\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:33:\"Manage your site\'s book outlines.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:2:{i:329;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"329\";s:4:\"plid\";s:3:\"315\";s:9:\"link_path\";s:23:\"admin/content/book/list\";s:11:\"router_path\";s:23:\"admin/content/book/list\";s:10:\"link_title\";s:4:\"List\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"9\";s:2:\"p3\";s:3:\"315\";s:2:\"p4\";s:3:\"329\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:42:\"a:1:{i:0;s:24:\"administer book outlines\";}\";s:13:\"page_callback\";s:19:\"book_admin_overview\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:18:\"admin/content/book\";s:8:\"tab_root\";s:13:\"admin/content\";s:5:\"title\";s:4:\"List\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"140\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:334;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"334\";s:4:\"plid\";s:3:\"315\";s:9:\"link_path\";s:27:\"admin/content/book/settings\";s:11:\"router_path\";s:27:\"admin/content/book/settings\";s:10:\"link_title\";s:8:\"Settings\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"8\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"9\";s:2:\"p3\";s:3:\"315\";s:2:\"p4\";s:3:\"334\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:47:\"a:1:{i:0;s:29:\"administer site configuration\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:37:\"a:1:{i:0;s:19:\"book_admin_settings\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:18:\"admin/content/book\";s:8:\"tab_root\";s:13:\"admin/content\";s:5:\"title\";s:8:\"Settings\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}}}i:440;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"440\";s:4:\"plid\";s:1:\"9\";s:9:\"link_path\";s:21:\"admin/content/message\";s:11:\"router_path\";s:21:\"admin/content/message\";s:10:\"link_title\";s:8:\"Messages\";s:7:\"options\";s:73:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:23:\"A list of all messages.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"9\";s:2:\"p3\";s:3:\"440\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:12:\"views_access\";s:16:\"access_arguments\";s:90:\"a:1:{i:0;a:2:{i:0;s:16:\"views_check_perm\";i:1;a:1:{i:0;s:24:\"administer message types\";}}}\";s:13:\"page_callback\";s:10:\"views_page\";s:14:\"page_arguments\";s:41:\"a:2:{i:0;s:7:\"message\";i:1;s:6:\"page_1\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:13:\"admin/content\";s:8:\"tab_root\";s:13:\"admin/content\";s:5:\"title\";s:8:\"Messages\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:23:\"A list of all messages.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:599;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"599\";s:4:\"plid\";s:1:\"9\";s:9:\"link_path\";s:21:\"admin/content/webform\";s:11:\"router_path\";s:21:\"admin/content/webform\";s:10:\"link_title\";s:8:\"Webforms\";s:7:\"options\";s:104:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:54:\"View and edit all the available webforms on your site.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:1:\"9\";s:2:\"p3\";s:3:\"599\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:44:\"a:1:{i:0;s:26:\"access all webform results\";}\";s:13:\"page_callback\";s:21:\"webform_admin_content\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:13:\"admin/content\";s:8:\"tab_root\";s:13:\"admin/content\";s:5:\"title\";s:8:\"Webforms\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:54:\"View and edit all the available webforms on your site.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}}}i:11;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:2:\"11\";s:4:\"plid\";s:1:\"1\";s:9:\"link_path\";s:15:\"admin/dashboard\";s:11:\"router_path\";s:15:\"admin/dashboard\";s:10:\"link_title\";s:9:\"Dashboard\";s:7:\"options\";s:84:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:34:\"View and customize your dashboard.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:3:\"-15\";s:5:\"depth\";s:1:\"2\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"11\";s:2:\"p3\";s:1:\"0\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:34:\"a:1:{i:0;s:16:\"access dashboard\";}\";s:13:\"page_callback\";s:15:\"dashboard_admin\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:15:\"admin/dashboard\";s:5:\"title\";s:9:\"Dashboard\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:34:\"View and customize your dashboard.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:2:{i:31;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:2:\"31\";s:4:\"plid\";s:2:\"11\";s:9:\"link_path\";s:25:\"admin/dashboard/configure\";s:11:\"router_path\";s:25:\"admin/dashboard/configure\";s:10:\"link_title\";s:36:\"Configure available dashboard blocks\";s:7:\"options\";s:103:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:53:\"Configure which blocks can be shown on the dashboard.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"11\";s:2:\"p3\";s:2:\"31\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:35:\"a:1:{i:0;s:17:\"administer blocks\";}\";s:13:\"page_callback\";s:22:\"dashboard_admin_blocks\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:25:\"admin/dashboard/configure\";s:5:\"title\";s:36:\"Configure available dashboard blocks\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"4\";s:11:\"description\";s:53:\"Configure which blocks can be shown on the dashboard.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:35;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:2:\"35\";s:4:\"plid\";s:2:\"11\";s:9:\"link_path\";s:25:\"admin/dashboard/customize\";s:11:\"router_path\";s:25:\"admin/dashboard/customize\";s:10:\"link_title\";s:19:\"Customize dashboard\";s:7:\"options\";s:75:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:25:\"Customize your dashboard.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"11\";s:2:\"p3\";s:2:\"35\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:34:\"a:1:{i:0;s:16:\"access dashboard\";}\";s:13:\"page_callback\";s:15:\"dashboard_admin\";s:14:\"page_arguments\";s:14:\"a:1:{i:0;b:1;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:25:\"admin/dashboard/customize\";s:5:\"title\";s:19:\"Customize dashboard\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"4\";s:11:\"description\";s:25:\"Customize your dashboard.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}}}i:12;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:2:\"12\";s:4:\"plid\";s:1:\"1\";s:9:\"link_path\";s:11:\"admin/index\";s:11:\"router_path\";s:11:\"admin/index\";s:10:\"link_title\";s:5:\"Index\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:3:\"-18\";s:5:\"depth\";s:1:\"2\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"12\";s:2:\"p3\";s:1:\"0\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:45:\"a:1:{i:0;s:27:\"access administration pages\";}\";s:13:\"page_callback\";s:18:\"system_admin_index\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:5:\"admin\";s:8:\"tab_root\";s:5:\"admin\";s:5:\"title\";s:5:\"Index\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:15;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:2:\"15\";s:4:\"plid\";s:1:\"1\";s:9:\"link_path\";s:13:\"admin/modules\";s:11:\"router_path\";s:13:\"admin/modules\";s:10:\"link_title\";s:7:\"Modules\";s:7:\"options\";s:76:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:26:\"Extend site functionality.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:2:\"-2\";s:5:\"depth\";s:1:\"2\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"15\";s:2:\"p3\";s:1:\"0\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:36:\"a:1:{i:0;s:18:\"administer modules\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:32:\"a:1:{i:0;s:14:\"system_modules\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:13:\"admin/modules\";s:5:\"title\";s:7:\"Modules\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:26:\"Extend site functionality.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:4:{i:43;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:2:\"43\";s:4:\"plid\";s:2:\"15\";s:9:\"link_path\";s:18:\"admin/modules/list\";s:11:\"router_path\";s:18:\"admin/modules/list\";s:10:\"link_title\";s:4:\"List\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"15\";s:2:\"p3\";s:2:\"43\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:36:\"a:1:{i:0;s:18:\"administer modules\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:32:\"a:1:{i:0;s:14:\"system_modules\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:13:\"admin/modules\";s:8:\"tab_root\";s:13:\"admin/modules\";s:5:\"title\";s:4:\"List\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"140\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:1:{i:79;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:2:\"79\";s:4:\"plid\";s:2:\"43\";s:9:\"link_path\";s:26:\"admin/modules/list/confirm\";s:11:\"router_path\";s:26:\"admin/modules/list/confirm\";s:10:\"link_title\";s:4:\"List\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"15\";s:2:\"p3\";s:2:\"43\";s:2:\"p4\";s:2:\"79\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:36:\"a:1:{i:0;s:18:\"administer modules\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:32:\"a:1:{i:0;s:14:\"system_modules\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:26:\"admin/modules/list/confirm\";s:5:\"title\";s:4:\"List\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"4\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}}}i:57;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:2:\"57\";s:4:\"plid\";s:2:\"15\";s:9:\"link_path\";s:23:\"admin/modules/uninstall\";s:11:\"router_path\";s:23:\"admin/modules/uninstall\";s:10:\"link_title\";s:9:\"Uninstall\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:2:\"20\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"15\";s:2:\"p3\";s:2:\"57\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:36:\"a:1:{i:0;s:18:\"administer modules\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:42:\"a:1:{i:0;s:24:\"system_modules_uninstall\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:13:\"admin/modules\";s:8:\"tab_root\";s:13:\"admin/modules\";s:5:\"title\";s:9:\"Uninstall\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:1:{i:96;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:2:\"96\";s:4:\"plid\";s:2:\"57\";s:9:\"link_path\";s:31:\"admin/modules/uninstall/confirm\";s:11:\"router_path\";s:31:\"admin/modules/uninstall/confirm\";s:10:\"link_title\";s:9:\"Uninstall\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"15\";s:2:\"p3\";s:2:\"57\";s:2:\"p4\";s:2:\"96\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:36:\"a:1:{i:0;s:18:\"administer modules\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:42:\"a:1:{i:0;s:24:\"system_modules_uninstall\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:31:\"admin/modules/uninstall/confirm\";s:5:\"title\";s:9:\"Uninstall\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"4\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}}}i:262;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"262\";s:4:\"plid\";s:2:\"15\";s:9:\"link_path\";s:20:\"admin/modules/update\";s:11:\"router_path\";s:20:\"admin/modules/update\";s:10:\"link_title\";s:6:\"Update\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:2:\"10\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"15\";s:2:\"p3\";s:3:\"262\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:21:\"update_manager_access\";s:16:\"access_arguments\";s:6:\"a:0:{}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:61:\"a:2:{i:0;s:26:\"update_manager_update_form\";i:1;s:6:\"module\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:13:\"admin/modules\";s:8:\"tab_root\";s:13:\"admin/modules\";s:5:\"title\";s:6:\"Update\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:263;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"263\";s:4:\"plid\";s:2:\"15\";s:9:\"link_path\";s:21:\"admin/modules/install\";s:11:\"router_path\";s:21:\"admin/modules/install\";s:10:\"link_title\";s:18:\"Install new module\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:2:\"25\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"15\";s:2:\"p3\";s:3:\"263\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:21:\"update_manager_access\";s:16:\"access_arguments\";s:6:\"a:0:{}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:62:\"a:2:{i:0;s:27:\"update_manager_install_form\";i:1;s:6:\"module\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:13:\"admin/modules\";s:8:\"tab_root\";s:13:\"admin/modules\";s:5:\"title\";s:18:\"Install new module\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"388\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}}}i:17;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:2:\"17\";s:4:\"plid\";s:1:\"1\";s:9:\"link_path\";s:12:\"admin/people\";s:11:\"router_path\";s:12:\"admin/people\";s:10:\"link_title\";s:6:\"People\";s:7:\"options\";s:95:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:45:\"Manage user accounts, roles, and permissions.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:2:\"-4\";s:5:\"depth\";s:1:\"2\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"17\";s:2:\"p3\";s:1:\"0\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:34:\"a:1:{i:0;s:16:\"administer users\";}\";s:13:\"page_callback\";s:10:\"user_admin\";s:14:\"page_arguments\";s:21:\"a:1:{i:0;s:4:\"list\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:12:\"admin/people\";s:5:\"title\";s:6:\"People\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:45:\"Manage user accounts, roles, and permissions.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:3:{i:27;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:2:\"27\";s:4:\"plid\";s:2:\"17\";s:9:\"link_path\";s:19:\"admin/people/create\";s:11:\"router_path\";s:19:\"admin/people/create\";s:10:\"link_title\";s:8:\"Add user\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"17\";s:2:\"p3\";s:2:\"27\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:34:\"a:1:{i:0;s:16:\"administer users\";}\";s:13:\"page_callback\";s:10:\"user_admin\";s:14:\"page_arguments\";s:23:\"a:1:{i:0;s:6:\"create\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:12:\"admin/people\";s:8:\"tab_root\";s:12:\"admin/people\";s:5:\"title\";s:8:\"Add user\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"388\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:41;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:2:\"41\";s:4:\"plid\";s:2:\"17\";s:9:\"link_path\";s:19:\"admin/people/people\";s:11:\"router_path\";s:19:\"admin/people/people\";s:10:\"link_title\";s:4:\"List\";s:7:\"options\";s:100:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:50:\"Find and manage people interacting with your site.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:3:\"-10\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"17\";s:2:\"p3\";s:2:\"41\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:34:\"a:1:{i:0;s:16:\"administer users\";}\";s:13:\"page_callback\";s:10:\"user_admin\";s:14:\"page_arguments\";s:21:\"a:1:{i:0;s:4:\"list\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:12:\"admin/people\";s:8:\"tab_root\";s:12:\"admin/people\";s:5:\"title\";s:4:\"List\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"140\";s:11:\"description\";s:50:\"Find and manage people interacting with your site.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:47;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:2:\"47\";s:4:\"plid\";s:2:\"17\";s:9:\"link_path\";s:24:\"admin/people/permissions\";s:11:\"router_path\";s:24:\"admin/people/permissions\";s:10:\"link_title\";s:11:\"Permissions\";s:7:\"options\";s:114:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:64:\"Determine access to features by selecting permissions for roles.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"17\";s:2:\"p3\";s:2:\"47\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:40:\"a:1:{i:0;s:22:\"administer permissions\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:40:\"a:1:{i:0;s:22:\"user_admin_permissions\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:12:\"admin/people\";s:8:\"tab_root\";s:12:\"admin/people\";s:5:\"title\";s:11:\"Permissions\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:64:\"Determine access to features by selecting permissions for roles.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:2:{i:85;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:2:\"85\";s:4:\"plid\";s:2:\"47\";s:9:\"link_path\";s:29:\"admin/people/permissions/list\";s:11:\"router_path\";s:29:\"admin/people/permissions/list\";s:10:\"link_title\";s:11:\"Permissions\";s:7:\"options\";s:114:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:64:\"Determine access to features by selecting permissions for roles.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:2:\"-8\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"17\";s:2:\"p3\";s:2:\"47\";s:2:\"p4\";s:2:\"85\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:40:\"a:1:{i:0;s:22:\"administer permissions\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:40:\"a:1:{i:0;s:22:\"user_admin_permissions\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:24:\"admin/people/permissions\";s:8:\"tab_root\";s:12:\"admin/people\";s:5:\"title\";s:11:\"Permissions\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"140\";s:11:\"description\";s:64:\"Determine access to features by selecting permissions for roles.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:89;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:2:\"89\";s:4:\"plid\";s:2:\"47\";s:9:\"link_path\";s:30:\"admin/people/permissions/roles\";s:11:\"router_path\";s:30:\"admin/people/permissions/roles\";s:10:\"link_title\";s:5:\"Roles\";s:7:\"options\";s:80:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:30:\"List, edit, or add user roles.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"1\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:2:\"-5\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"17\";s:2:\"p3\";s:2:\"47\";s:2:\"p4\";s:2:\"89\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:40:\"a:1:{i:0;s:22:\"administer permissions\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:34:\"a:1:{i:0;s:16:\"user_admin_roles\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:24:\"admin/people/permissions\";s:8:\"tab_root\";s:12:\"admin/people\";s:5:\"title\";s:5:\"Roles\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:30:\"List, edit, or add user roles.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:2:{i:130;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"130\";s:4:\"plid\";s:2:\"89\";s:9:\"link_path\";s:39:\"admin/people/permissions/roles/delete/%\";s:11:\"router_path\";s:39:\"admin/people/permissions/roles/delete/%\";s:10:\"link_title\";s:11:\"Delete role\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"17\";s:2:\"p3\";s:2:\"47\";s:2:\"p4\";s:2:\"89\";s:2:\"p5\";s:3:\"130\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:32:\"a:1:{i:5;s:14:\"user_role_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:21:\"user_role_edit_access\";s:16:\"access_arguments\";s:14:\"a:1:{i:0;i:5;}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:56:\"a:2:{i:0;s:30:\"user_admin_role_delete_confirm\";i:1;i:5;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:39:\"admin/people/permissions/roles/delete/%\";s:5:\"title\";s:11:\"Delete role\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:135;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"135\";s:4:\"plid\";s:2:\"89\";s:9:\"link_path\";s:37:\"admin/people/permissions/roles/edit/%\";s:11:\"router_path\";s:37:\"admin/people/permissions/roles/edit/%\";s:10:\"link_title\";s:9:\"Edit role\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"17\";s:2:\"p3\";s:2:\"47\";s:2:\"p4\";s:2:\"89\";s:2:\"p5\";s:3:\"135\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:32:\"a:1:{i:5;s:14:\"user_role_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:21:\"user_role_edit_access\";s:16:\"access_arguments\";s:14:\"a:1:{i:0;i:5;}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:41:\"a:2:{i:0;s:15:\"user_admin_role\";i:1;i:5;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:37:\"admin/people/permissions/roles/edit/%\";s:5:\"title\";s:9:\"Edit role\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}}}}}}}i:18;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:2:\"18\";s:4:\"plid\";s:1:\"1\";s:9:\"link_path\";s:13:\"admin/reports\";s:11:\"router_path\";s:13:\"admin/reports\";s:10:\"link_title\";s:7:\"Reports\";s:7:\"options\";s:84:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:34:\"View reports, updates, and errors.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"1\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"5\";s:5:\"depth\";s:1:\"2\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"18\";s:2:\"p3\";s:1:\"0\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:37:\"a:1:{i:0;s:19:\"access site reports\";}\";s:13:\"page_callback\";s:28:\"system_admin_menu_block_page\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:13:\"admin/reports\";s:5:\"title\";s:7:\"Reports\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:34:\"View reports, updates, and errors.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:14:{i:40;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:2:\"40\";s:4:\"plid\";s:2:\"18\";s:9:\"link_path\";s:20:\"admin/reports/fields\";s:11:\"router_path\";s:20:\"admin/reports/fields\";s:10:\"link_title\";s:10:\"Field list\";s:7:\"options\";s:89:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:39:\"Overview of fields on all entity types.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"18\";s:2:\"p3\";s:2:\"40\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:42:\"a:1:{i:0;s:24:\"administer content types\";}\";s:13:\"page_callback\";s:20:\"field_ui_fields_list\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:20:\"admin/reports/fields\";s:5:\"title\";s:10:\"Field list\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:39:\"Overview of fields on all entity types.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:2:{i:332;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"332\";s:4:\"plid\";s:2:\"40\";s:9:\"link_path\";s:25:\"admin/reports/fields/list\";s:11:\"router_path\";s:25:\"admin/reports/fields/list\";s:10:\"link_title\";s:4:\"List\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:3:\"-10\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"18\";s:2:\"p3\";s:2:\"40\";s:2:\"p4\";s:3:\"332\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:42:\"a:1:{i:0;s:24:\"administer content types\";}\";s:13:\"page_callback\";s:20:\"field_ui_fields_list\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:20:\"admin/reports/fields\";s:8:\"tab_root\";s:20:\"admin/reports/fields\";s:5:\"title\";s:4:\"List\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"140\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:336;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"336\";s:4:\"plid\";s:2:\"40\";s:9:\"link_path\";s:33:\"admin/reports/fields/views-fields\";s:11:\"router_path\";s:33:\"admin/reports/fields/views-fields\";s:10:\"link_title\";s:13:\"Used in views\";s:7:\"options\";s:87:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:37:\"Overview of fields used in all views.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"18\";s:2:\"p3\";s:2:\"40\";s:2:\"p4\";s:3:\"336\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:34:\"a:1:{i:0;s:16:\"administer views\";}\";s:13:\"page_callback\";s:19:\"views_ui_field_list\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:20:\"admin/reports/fields\";s:8:\"tab_root\";s:20:\"admin/reports/fields\";s:5:\"title\";s:13:\"Used in views\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:37:\"Overview of fields used in all views.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}}}i:48;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:2:\"48\";s:4:\"plid\";s:2:\"18\";s:9:\"link_path\";s:19:\"admin/reports/dblog\";s:11:\"router_path\";s:19:\"admin/reports/dblog\";s:10:\"link_title\";s:19:\"Recent log messages\";s:7:\"options\";s:93:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:43:\"View events that have recently been logged.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:2:\"-1\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"18\";s:2:\"p3\";s:2:\"48\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:37:\"a:1:{i:0;s:19:\"access site reports\";}\";s:13:\"page_callback\";s:14:\"dblog_overview\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:19:\"admin/reports/dblog\";s:5:\"title\";s:19:\"Recent log messages\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:43:\"View events that have recently been logged.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:53;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:2:\"53\";s:4:\"plid\";s:2:\"18\";s:9:\"link_path\";s:20:\"admin/reports/status\";s:11:\"router_path\";s:20:\"admin/reports/status\";s:10:\"link_title\";s:13:\"Status report\";s:7:\"options\";s:124:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:74:\"Get a status report about your site\'s operation and any detected problems.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:3:\"-60\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"18\";s:2:\"p3\";s:2:\"53\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:47:\"a:1:{i:0;s:29:\"administer site configuration\";}\";s:13:\"page_callback\";s:13:\"system_status\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:20:\"admin/reports/status\";s:5:\"title\";s:13:\"Status report\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:74:\"Get a status report about your site\'s operation and any detected problems.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:55;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:2:\"55\";s:4:\"plid\";s:2:\"18\";s:9:\"link_path\";s:27:\"admin/reports/access-denied\";s:11:\"router_path\";s:27:\"admin/reports/access-denied\";s:10:\"link_title\";s:26:\"Top \'access denied\' errors\";s:7:\"options\";s:85:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:35:\"View \'access denied\' errors (403s).\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"18\";s:2:\"p3\";s:2:\"55\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:37:\"a:1:{i:0;s:19:\"access site reports\";}\";s:13:\"page_callback\";s:9:\"dblog_top\";s:14:\"page_arguments\";s:31:\"a:1:{i:0;s:13:\"access denied\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:27:\"admin/reports/access-denied\";s:5:\"title\";s:26:\"Top \'access denied\' errors\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:35:\"View \'access denied\' errors (403s).\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:56;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:2:\"56\";s:4:\"plid\";s:2:\"18\";s:9:\"link_path\";s:28:\"admin/reports/page-not-found\";s:11:\"router_path\";s:28:\"admin/reports/page-not-found\";s:10:\"link_title\";s:27:\"Top \'page not found\' errors\";s:7:\"options\";s:86:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:36:\"View \'page not found\' errors (404s).\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"18\";s:2:\"p3\";s:2:\"56\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:37:\"a:1:{i:0;s:19:\"access site reports\";}\";s:13:\"page_callback\";s:9:\"dblog_top\";s:14:\"page_arguments\";s:32:\"a:1:{i:0;s:14:\"page not found\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:28:\"admin/reports/page-not-found\";s:5:\"title\";s:27:\"Top \'page not found\' errors\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:36:\"View \'page not found\' errors (404s).\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:72;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:2:\"72\";s:4:\"plid\";s:2:\"18\";s:9:\"link_path\";s:21:\"admin/reports/event/%\";s:11:\"router_path\";s:21:\"admin/reports/event/%\";s:10:\"link_title\";s:7:\"Details\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"18\";s:2:\"p3\";s:2:\"72\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:12:\"a:1:{i:3;N;}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:37:\"a:1:{i:0;s:19:\"access site reports\";}\";s:13:\"page_callback\";s:11:\"dblog_event\";s:14:\"page_arguments\";s:14:\"a:1:{i:0;i:3;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:21:\"admin/reports/event/%\";s:5:\"title\";s:7:\"Details\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:163;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"163\";s:4:\"plid\";s:2:\"18\";s:9:\"link_path\";s:20:\"admin/reports/search\";s:11:\"router_path\";s:20:\"admin/reports/search\";s:10:\"link_title\";s:18:\"Top search phrases\";s:7:\"options\";s:83:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:33:\"View most popular search phrases.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"18\";s:2:\"p3\";s:3:\"163\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:37:\"a:1:{i:0;s:19:\"access site reports\";}\";s:13:\"page_callback\";s:9:\"dblog_top\";s:14:\"page_arguments\";s:23:\"a:1:{i:0;s:6:\"search\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:20:\"admin/reports/search\";s:5:\"title\";s:18:\"Top search phrases\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:33:\"View most popular search phrases.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:260;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"260\";s:4:\"plid\";s:2:\"18\";s:9:\"link_path\";s:21:\"admin/reports/updates\";s:11:\"router_path\";s:21:\"admin/reports/updates\";s:10:\"link_title\";s:17:\"Available updates\";s:7:\"options\";s:132:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:82:\"Get a status report about available updates for your installed modules and themes.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:3:\"-50\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"18\";s:2:\"p3\";s:3:\"260\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:47:\"a:1:{i:0;s:29:\"administer site configuration\";}\";s:13:\"page_callback\";s:27:\"module_filter_update_status\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:21:\"admin/reports/updates\";s:5:\"title\";s:17:\"Available updates\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:82:\"Get a status report about available updates for your installed modules and themes.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:4:{i:266;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"266\";s:4:\"plid\";s:3:\"260\";s:9:\"link_path\";s:29:\"admin/reports/updates/install\";s:11:\"router_path\";s:29:\"admin/reports/updates/install\";s:10:\"link_title\";s:27:\"Install new module or theme\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:2:\"25\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"18\";s:2:\"p3\";s:3:\"260\";s:2:\"p4\";s:3:\"266\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:21:\"update_manager_access\";s:16:\"access_arguments\";s:6:\"a:0:{}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:62:\"a:2:{i:0;s:27:\"update_manager_install_form\";i:1;s:6:\"report\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:21:\"admin/reports/updates\";s:8:\"tab_root\";s:21:\"admin/reports/updates\";s:5:\"title\";s:27:\"Install new module or theme\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"388\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:267;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"267\";s:4:\"plid\";s:3:\"260\";s:9:\"link_path\";s:28:\"admin/reports/updates/update\";s:11:\"router_path\";s:28:\"admin/reports/updates/update\";s:10:\"link_title\";s:6:\"Update\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:2:\"10\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"18\";s:2:\"p3\";s:3:\"260\";s:2:\"p4\";s:3:\"267\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:21:\"update_manager_access\";s:16:\"access_arguments\";s:6:\"a:0:{}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:61:\"a:2:{i:0;s:26:\"update_manager_update_form\";i:1;s:6:\"report\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:21:\"admin/reports/updates\";s:8:\"tab_root\";s:21:\"admin/reports/updates\";s:5:\"title\";s:6:\"Update\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:268;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"268\";s:4:\"plid\";s:3:\"260\";s:9:\"link_path\";s:26:\"admin/reports/updates/list\";s:11:\"router_path\";s:26:\"admin/reports/updates/list\";s:10:\"link_title\";s:4:\"List\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"18\";s:2:\"p3\";s:3:\"260\";s:2:\"p4\";s:3:\"268\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:47:\"a:1:{i:0;s:29:\"administer site configuration\";}\";s:13:\"page_callback\";s:27:\"module_filter_update_status\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:21:\"admin/reports/updates\";s:8:\"tab_root\";s:21:\"admin/reports/updates\";s:5:\"title\";s:4:\"List\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"140\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:269;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"269\";s:4:\"plid\";s:3:\"260\";s:9:\"link_path\";s:30:\"admin/reports/updates/settings\";s:11:\"router_path\";s:30:\"admin/reports/updates/settings\";s:10:\"link_title\";s:8:\"Settings\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:2:\"50\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"18\";s:2:\"p3\";s:3:\"260\";s:2:\"p4\";s:3:\"269\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:47:\"a:1:{i:0;s:29:\"administer site configuration\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:33:\"a:1:{i:0;s:15:\"update_settings\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:21:\"admin/reports/updates\";s:8:\"tab_root\";s:21:\"admin/reports/updates\";s:5:\"title\";s:8:\"Settings\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}}}i:320;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"320\";s:4:\"plid\";s:2:\"18\";s:9:\"link_path\";s:27:\"admin/reports/views-plugins\";s:11:\"router_path\";s:27:\"admin/reports/views-plugins\";s:10:\"link_title\";s:13:\"Views plugins\";s:7:\"options\";s:88:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:38:\"Overview of plugins used in all views.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"18\";s:2:\"p3\";s:3:\"320\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:34:\"a:1:{i:0;s:16:\"administer views\";}\";s:13:\"page_callback\";s:20:\"views_ui_plugin_list\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:27:\"admin/reports/views-plugins\";s:5:\"title\";s:13:\"Views plugins\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:38:\"Overview of plugins used in all views.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:427;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"427\";s:4:\"plid\";s:2:\"18\";s:9:\"link_path\";s:18:\"admin/reports/hits\";s:11:\"router_path\";s:18:\"admin/reports/hits\";s:10:\"link_title\";s:11:\"Recent hits\";s:7:\"options\";s:93:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:43:\"View pages that have recently been visited.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"18\";s:2:\"p3\";s:3:\"427\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:35:\"a:1:{i:0;s:17:\"access statistics\";}\";s:13:\"page_callback\";s:22:\"statistics_recent_hits\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:18:\"admin/reports/hits\";s:5:\"title\";s:11:\"Recent hits\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:43:\"View pages that have recently been visited.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:428;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"428\";s:4:\"plid\";s:2:\"18\";s:9:\"link_path\";s:19:\"admin/reports/pages\";s:11:\"router_path\";s:19:\"admin/reports/pages\";s:10:\"link_title\";s:9:\"Top pages\";s:7:\"options\";s:91:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:41:\"View pages that have been hit frequently.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"1\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"18\";s:2:\"p3\";s:3:\"428\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:35:\"a:1:{i:0;s:17:\"access statistics\";}\";s:13:\"page_callback\";s:20:\"statistics_top_pages\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:19:\"admin/reports/pages\";s:5:\"title\";s:9:\"Top pages\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:41:\"View pages that have been hit frequently.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:429;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"429\";s:4:\"plid\";s:2:\"18\";s:9:\"link_path\";s:23:\"admin/reports/referrers\";s:11:\"router_path\";s:23:\"admin/reports/referrers\";s:10:\"link_title\";s:13:\"Top referrers\";s:7:\"options\";s:69:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:19:\"View top referrers.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"18\";s:2:\"p3\";s:3:\"429\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:35:\"a:1:{i:0;s:17:\"access statistics\";}\";s:13:\"page_callback\";s:24:\"statistics_top_referrers\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:23:\"admin/reports/referrers\";s:5:\"title\";s:13:\"Top referrers\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:19:\"View top referrers.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:430;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"430\";s:4:\"plid\";s:2:\"18\";s:9:\"link_path\";s:22:\"admin/reports/visitors\";s:11:\"router_path\";s:22:\"admin/reports/visitors\";s:10:\"link_title\";s:12:\"Top visitors\";s:7:\"options\";s:84:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:34:\"View visitors that hit many pages.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"2\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"18\";s:2:\"p3\";s:3:\"430\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:35:\"a:1:{i:0;s:17:\"access statistics\";}\";s:13:\"page_callback\";s:23:\"statistics_top_visitors\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:22:\"admin/reports/visitors\";s:5:\"title\";s:12:\"Top visitors\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:34:\"View visitors that hit many pages.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:433;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"433\";s:4:\"plid\";s:2:\"18\";s:9:\"link_path\";s:22:\"admin/reports/access/%\";s:11:\"router_path\";s:22:\"admin/reports/access/%\";s:10:\"link_title\";s:7:\"Details\";s:7:\"options\";s:66:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:16:\"View access log.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"18\";s:2:\"p3\";s:3:\"433\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:12:\"a:1:{i:3;N;}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:35:\"a:1:{i:0;s:17:\"access statistics\";}\";s:13:\"page_callback\";s:21:\"statistics_access_log\";s:14:\"page_arguments\";s:14:\"a:1:{i:0;i:3;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:22:\"admin/reports/access/%\";s:5:\"title\";s:7:\"Details\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:16:\"View access log.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}}}i:20;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:2:\"20\";s:4:\"plid\";s:1:\"1\";s:9:\"link_path\";s:15:\"admin/structure\";s:11:\"router_path\";s:15:\"admin/structure\";s:10:\"link_title\";s:9:\"Structure\";s:7:\"options\";s:95:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:45:\"Administer blocks, content types, menus, etc.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"1\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:2:\"-8\";s:5:\"depth\";s:1:\"2\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:1:\"0\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:45:\"a:1:{i:0;s:27:\"access administration pages\";}\";s:13:\"page_callback\";s:28:\"system_admin_menu_block_page\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:15:\"admin/structure\";s:5:\"title\";s:9:\"Structure\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:45:\"Administer blocks, content types, menus, etc.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:13:{i:28;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:2:\"28\";s:4:\"plid\";s:2:\"20\";s:9:\"link_path\";s:21:\"admin/structure/block\";s:11:\"router_path\";s:21:\"admin/structure/block\";s:10:\"link_title\";s:6:\"Blocks\";s:7:\"options\";s:129:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:79:\"Configure what block content appears in your site\'s sidebars and other regions.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"1\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:2:\"28\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:35:\"a:1:{i:0;s:17:\"administer blocks\";}\";s:13:\"page_callback\";s:19:\"block_admin_display\";s:14:\"page_arguments\";s:28:\"a:1:{i:0;s:10:\"forum_plus\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:21:\"admin/structure/block\";s:5:\"title\";s:6:\"Blocks\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:79:\"Configure what block content appears in your site\'s sidebars and other regions.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:9:{i:65;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:2:\"65\";s:4:\"plid\";s:2:\"28\";s:9:\"link_path\";s:25:\"admin/structure/block/add\";s:11:\"router_path\";s:25:\"admin/structure/block/add\";s:10:\"link_title\";s:9:\"Add block\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:2:\"28\";s:2:\"p4\";s:2:\"65\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:35:\"a:1:{i:0;s:17:\"administer blocks\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:38:\"a:1:{i:0;s:20:\"block_add_block_form\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:21:\"admin/structure/block\";s:8:\"tab_root\";s:21:\"admin/structure/block\";s:5:\"title\";s:9:\"Add block\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"388\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:101;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"101\";s:4:\"plid\";s:2:\"28\";s:9:\"link_path\";s:33:\"admin/structure/block/list/bartik\";s:11:\"router_path\";s:33:\"admin/structure/block/list/bartik\";s:10:\"link_title\";s:6:\"Bartik\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:2:\"28\";s:2:\"p4\";s:3:\"101\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:20:\"_block_themes_access\";s:16:\"access_arguments\";s:2741:\"a:1:{i:0;O:8:\"stdClass\":12:{s:8:\"filename\";s:25:\"themes/bartik/bartik.info\";s:4:\"name\";s:6:\"bartik\";s:4:\"type\";s:5:\"theme\";s:5:\"owner\";s:45:\"themes/engines/phptemplate/phptemplate.engine\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:2:\"-1\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:19:{s:4:\"name\";s:6:\"Bartik\";s:11:\"description\";s:48:\"A flexible, recolorable theme with many regions.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:11:\"stylesheets\";a:2:{s:3:\"all\";a:3:{s:14:\"css/layout.css\";s:28:\"themes/bartik/css/layout.css\";s:13:\"css/style.css\";s:27:\"themes/bartik/css/style.css\";s:14:\"css/colors.css\";s:28:\"themes/bartik/css/colors.css\";}s:5:\"print\";a:1:{s:13:\"css/print.css\";s:27:\"themes/bartik/css/print.css\";}}s:7:\"regions\";a:20:{s:6:\"header\";s:6:\"Header\";s:4:\"help\";s:4:\"Help\";s:8:\"page_top\";s:8:\"Page top\";s:11:\"page_bottom\";s:11:\"Page bottom\";s:11:\"highlighted\";s:11:\"Highlighted\";s:8:\"featured\";s:8:\"Featured\";s:7:\"content\";s:7:\"Content\";s:13:\"sidebar_first\";s:13:\"Sidebar first\";s:14:\"sidebar_second\";s:14:\"Sidebar second\";s:14:\"triptych_first\";s:14:\"Triptych first\";s:15:\"triptych_middle\";s:15:\"Triptych middle\";s:13:\"triptych_last\";s:13:\"Triptych last\";s:18:\"footer_firstcolumn\";s:19:\"Footer first column\";s:19:\"footer_secondcolumn\";s:20:\"Footer second column\";s:18:\"footer_thirdcolumn\";s:19:\"Footer third column\";s:19:\"footer_fourthcolumn\";s:20:\"Footer fourth column\";s:6:\"footer\";s:6:\"Footer\";s:14:\"dashboard_main\";s:16:\"Dashboard (main)\";s:17:\"dashboard_sidebar\";s:19:\"Dashboard (sidebar)\";s:18:\"dashboard_inactive\";s:20:\"Dashboard (inactive)\";}s:8:\"settings\";a:1:{s:20:\"shortcut_module_link\";s:1:\"0\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:6:\"engine\";s:11:\"phptemplate\";s:8:\"features\";a:9:{i:0;s:4:\"logo\";i:1;s:7:\"favicon\";i:2;s:4:\"name\";i:3;s:6:\"slogan\";i:4;s:17:\"node_user_picture\";i:5;s:20:\"comment_user_picture\";i:6;s:25:\"comment_user_verification\";i:7;s:9:\"main_menu\";i:8;s:14:\"secondary_menu\";}s:10:\"screenshot\";s:28:\"themes/bartik/screenshot.png\";s:3:\"php\";s:5:\"5.2.4\";s:7:\"scripts\";a:0:{}s:5:\"mtime\";i:1498069849;s:15:\"overlay_regions\";a:5:{i:0;s:14:\"dashboard_main\";i:1;s:17:\"dashboard_sidebar\";i:2;s:18:\"dashboard_inactive\";i:3;s:7:\"content\";i:4;s:4:\"help\";}s:14:\"regions_hidden\";a:2:{i:0;s:8:\"page_top\";i:1;s:11:\"page_bottom\";}s:28:\"overlay_supplemental_regions\";a:1:{i:0;s:11:\"page_bottom\";}}s:6:\"prefix\";s:11:\"phptemplate\";s:11:\"stylesheets\";a:2:{s:3:\"all\";a:3:{s:14:\"css/layout.css\";s:28:\"themes/bartik/css/layout.css\";s:13:\"css/style.css\";s:27:\"themes/bartik/css/style.css\";s:14:\"css/colors.css\";s:28:\"themes/bartik/css/colors.css\";}s:5:\"print\";a:1:{s:13:\"css/print.css\";s:27:\"themes/bartik/css/print.css\";}}s:6:\"engine\";s:11:\"phptemplate\";}}\";s:13:\"page_callback\";s:19:\"block_admin_display\";s:14:\"page_arguments\";s:23:\"a:1:{i:0;s:6:\"bartik\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:21:\"admin/structure/block\";s:8:\"tab_root\";s:21:\"admin/structure/block\";s:5:\"title\";s:6:\"Bartik\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:1:{i:363;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"363\";s:4:\"plid\";s:3:\"101\";s:9:\"link_path\";s:37:\"admin/structure/block/list/bartik/add\";s:11:\"router_path\";s:37:\"admin/structure/block/list/bartik/add\";s:10:\"link_title\";s:9:\"Add block\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:2:\"28\";s:2:\"p4\";s:3:\"101\";s:2:\"p5\";s:3:\"363\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:35:\"a:1:{i:0;s:17:\"administer blocks\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:38:\"a:1:{i:0;s:20:\"block_add_block_form\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:33:\"admin/structure/block/list/bartik\";s:8:\"tab_root\";s:21:\"admin/structure/block\";s:5:\"title\";s:9:\"Add block\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"388\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}}}i:106;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"106\";s:4:\"plid\";s:2:\"28\";s:9:\"link_path\";s:34:\"admin/structure/block/list/garland\";s:11:\"router_path\";s:34:\"admin/structure/block/list/garland\";s:10:\"link_title\";s:7:\"Garland\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:2:\"28\";s:2:\"p4\";s:3:\"106\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:20:\"_block_themes_access\";s:16:\"access_arguments\";s:2163:\"a:1:{i:0;O:8:\"stdClass\":12:{s:8:\"filename\";s:27:\"themes/garland/garland.info\";s:4:\"name\";s:7:\"garland\";s:4:\"type\";s:5:\"theme\";s:5:\"owner\";s:45:\"themes/engines/phptemplate/phptemplate.engine\";s:6:\"status\";s:1:\"0\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:2:\"-1\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:19:{s:4:\"name\";s:7:\"Garland\";s:11:\"description\";s:111:\"A multi-column theme which can be configured to modify colors and switch between fixed and fluid width layouts.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:11:\"stylesheets\";a:2:{s:3:\"all\";a:1:{s:9:\"style.css\";s:24:\"themes/garland/style.css\";}s:5:\"print\";a:1:{s:9:\"print.css\";s:24:\"themes/garland/print.css\";}}s:8:\"settings\";a:1:{s:13:\"garland_width\";s:5:\"fluid\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:6:\"engine\";s:11:\"phptemplate\";s:7:\"regions\";a:12:{s:13:\"sidebar_first\";s:12:\"Left sidebar\";s:14:\"sidebar_second\";s:13:\"Right sidebar\";s:7:\"content\";s:7:\"Content\";s:6:\"header\";s:6:\"Header\";s:6:\"footer\";s:6:\"Footer\";s:11:\"highlighted\";s:11:\"Highlighted\";s:4:\"help\";s:4:\"Help\";s:8:\"page_top\";s:8:\"Page top\";s:11:\"page_bottom\";s:11:\"Page bottom\";s:14:\"dashboard_main\";s:16:\"Dashboard (main)\";s:17:\"dashboard_sidebar\";s:19:\"Dashboard (sidebar)\";s:18:\"dashboard_inactive\";s:20:\"Dashboard (inactive)\";}s:8:\"features\";a:9:{i:0;s:4:\"logo\";i:1;s:7:\"favicon\";i:2;s:4:\"name\";i:3;s:6:\"slogan\";i:4;s:17:\"node_user_picture\";i:5;s:20:\"comment_user_picture\";i:6;s:25:\"comment_user_verification\";i:7;s:9:\"main_menu\";i:8;s:14:\"secondary_menu\";}s:10:\"screenshot\";s:29:\"themes/garland/screenshot.png\";s:3:\"php\";s:5:\"5.2.4\";s:7:\"scripts\";a:0:{}s:5:\"mtime\";i:1498069849;s:15:\"overlay_regions\";a:5:{i:0;s:14:\"dashboard_main\";i:1;s:17:\"dashboard_sidebar\";i:2;s:18:\"dashboard_inactive\";i:3;s:7:\"content\";i:4;s:4:\"help\";}s:14:\"regions_hidden\";a:2:{i:0;s:8:\"page_top\";i:1;s:11:\"page_bottom\";}s:28:\"overlay_supplemental_regions\";a:1:{i:0;s:11:\"page_bottom\";}}s:6:\"prefix\";s:11:\"phptemplate\";s:11:\"stylesheets\";a:2:{s:3:\"all\";a:1:{s:9:\"style.css\";s:24:\"themes/garland/style.css\";}s:5:\"print\";a:1:{s:9:\"print.css\";s:24:\"themes/garland/print.css\";}}s:6:\"engine\";s:11:\"phptemplate\";}}\";s:13:\"page_callback\";s:19:\"block_admin_display\";s:14:\"page_arguments\";s:24:\"a:1:{i:0;s:7:\"garland\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:21:\"admin/structure/block\";s:8:\"tab_root\";s:21:\"admin/structure/block\";s:5:\"title\";s:7:\"Garland\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:1:{i:117;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"117\";s:4:\"plid\";s:3:\"106\";s:9:\"link_path\";s:38:\"admin/structure/block/list/garland/add\";s:11:\"router_path\";s:38:\"admin/structure/block/list/garland/add\";s:10:\"link_title\";s:9:\"Add block\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:2:\"28\";s:2:\"p4\";s:3:\"106\";s:2:\"p5\";s:3:\"117\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:35:\"a:1:{i:0;s:17:\"administer blocks\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:38:\"a:1:{i:0;s:20:\"block_add_block_form\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:34:\"admin/structure/block/list/garland\";s:8:\"tab_root\";s:21:\"admin/structure/block\";s:5:\"title\";s:9:\"Add block\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"388\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}}}i:111;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"111\";s:4:\"plid\";s:2:\"28\";s:9:\"link_path\";s:32:\"admin/structure/block/list/seven\";s:11:\"router_path\";s:32:\"admin/structure/block/list/seven\";s:10:\"link_title\";s:5:\"Seven\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:2:\"28\";s:2:\"p4\";s:3:\"111\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:20:\"_block_themes_access\";s:16:\"access_arguments\";s:1963:\"a:1:{i:0;O:8:\"stdClass\":12:{s:8:\"filename\";s:23:\"themes/seven/seven.info\";s:4:\"name\";s:5:\"seven\";s:4:\"type\";s:5:\"theme\";s:5:\"owner\";s:45:\"themes/engines/phptemplate/phptemplate.engine\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:2:\"-1\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:19:{s:4:\"name\";s:5:\"Seven\";s:11:\"description\";s:65:\"A simple one-column, tableless, fluid width administration theme.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:11:\"stylesheets\";a:1:{s:6:\"screen\";a:2:{s:9:\"reset.css\";s:22:\"themes/seven/reset.css\";s:9:\"style.css\";s:22:\"themes/seven/style.css\";}}s:8:\"settings\";a:1:{s:20:\"shortcut_module_link\";s:1:\"1\";}s:7:\"regions\";a:8:{s:7:\"content\";s:7:\"Content\";s:4:\"help\";s:4:\"Help\";s:8:\"page_top\";s:8:\"Page top\";s:11:\"page_bottom\";s:11:\"Page bottom\";s:13:\"sidebar_first\";s:13:\"First sidebar\";s:14:\"dashboard_main\";s:16:\"Dashboard (main)\";s:17:\"dashboard_sidebar\";s:19:\"Dashboard (sidebar)\";s:18:\"dashboard_inactive\";s:20:\"Dashboard (inactive)\";}s:14:\"regions_hidden\";a:3:{i:0;s:13:\"sidebar_first\";i:1;s:8:\"page_top\";i:2;s:11:\"page_bottom\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:6:\"engine\";s:11:\"phptemplate\";s:8:\"features\";a:9:{i:0;s:4:\"logo\";i:1;s:7:\"favicon\";i:2;s:4:\"name\";i:3;s:6:\"slogan\";i:4;s:17:\"node_user_picture\";i:5;s:20:\"comment_user_picture\";i:6;s:25:\"comment_user_verification\";i:7;s:9:\"main_menu\";i:8;s:14:\"secondary_menu\";}s:10:\"screenshot\";s:27:\"themes/seven/screenshot.png\";s:3:\"php\";s:5:\"5.2.4\";s:7:\"scripts\";a:0:{}s:5:\"mtime\";i:1498069849;s:15:\"overlay_regions\";a:5:{i:0;s:14:\"dashboard_main\";i:1;s:17:\"dashboard_sidebar\";i:2;s:18:\"dashboard_inactive\";i:3;s:7:\"content\";i:4;s:4:\"help\";}s:28:\"overlay_supplemental_regions\";a:1:{i:0;s:11:\"page_bottom\";}}s:6:\"prefix\";s:11:\"phptemplate\";s:11:\"stylesheets\";a:1:{s:6:\"screen\";a:2:{s:9:\"reset.css\";s:22:\"themes/seven/reset.css\";s:9:\"style.css\";s:22:\"themes/seven/style.css\";}}s:6:\"engine\";s:11:\"phptemplate\";}}\";s:13:\"page_callback\";s:19:\"block_admin_display\";s:14:\"page_arguments\";s:22:\"a:1:{i:0;s:5:\"seven\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:21:\"admin/structure/block\";s:8:\"tab_root\";s:21:\"admin/structure/block\";s:5:\"title\";s:5:\"Seven\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:1:{i:118;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"118\";s:4:\"plid\";s:3:\"111\";s:9:\"link_path\";s:36:\"admin/structure/block/list/seven/add\";s:11:\"router_path\";s:36:\"admin/structure/block/list/seven/add\";s:10:\"link_title\";s:9:\"Add block\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:2:\"28\";s:2:\"p4\";s:3:\"111\";s:2:\"p5\";s:3:\"118\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:35:\"a:1:{i:0;s:17:\"administer blocks\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:38:\"a:1:{i:0;s:20:\"block_add_block_form\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:32:\"admin/structure/block/list/seven\";s:8:\"tab_root\";s:21:\"admin/structure/block\";s:5:\"title\";s:9:\"Add block\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"388\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}}}i:112;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"112\";s:4:\"plid\";s:2:\"28\";s:9:\"link_path\";s:32:\"admin/structure/block/list/stark\";s:11:\"router_path\";s:32:\"admin/structure/block/list/stark\";s:10:\"link_title\";s:5:\"Stark\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:2:\"28\";s:2:\"p4\";s:3:\"112\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:20:\"_block_themes_access\";s:16:\"access_arguments\";s:2066:\"a:1:{i:0;O:8:\"stdClass\":12:{s:8:\"filename\";s:23:\"themes/stark/stark.info\";s:4:\"name\";s:5:\"stark\";s:4:\"type\";s:5:\"theme\";s:5:\"owner\";s:45:\"themes/engines/phptemplate/phptemplate.engine\";s:6:\"status\";s:1:\"0\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:2:\"-1\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:18:{s:4:\"name\";s:5:\"Stark\";s:11:\"description\";s:208:\"This theme demonstrates Drupal\'s default HTML markup and CSS styles. To learn how to build your own theme and override Drupal\'s default code, see the <a href=\"http://drupal.org/theme-guide\">Theming Guide</a>.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:11:\"stylesheets\";a:1:{s:3:\"all\";a:1:{s:10:\"layout.css\";s:23:\"themes/stark/layout.css\";}}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:6:\"engine\";s:11:\"phptemplate\";s:7:\"regions\";a:12:{s:13:\"sidebar_first\";s:12:\"Left sidebar\";s:14:\"sidebar_second\";s:13:\"Right sidebar\";s:7:\"content\";s:7:\"Content\";s:6:\"header\";s:6:\"Header\";s:6:\"footer\";s:6:\"Footer\";s:11:\"highlighted\";s:11:\"Highlighted\";s:4:\"help\";s:4:\"Help\";s:8:\"page_top\";s:8:\"Page top\";s:11:\"page_bottom\";s:11:\"Page bottom\";s:14:\"dashboard_main\";s:16:\"Dashboard (main)\";s:17:\"dashboard_sidebar\";s:19:\"Dashboard (sidebar)\";s:18:\"dashboard_inactive\";s:20:\"Dashboard (inactive)\";}s:8:\"features\";a:9:{i:0;s:4:\"logo\";i:1;s:7:\"favicon\";i:2;s:4:\"name\";i:3;s:6:\"slogan\";i:4;s:17:\"node_user_picture\";i:5;s:20:\"comment_user_picture\";i:6;s:25:\"comment_user_verification\";i:7;s:9:\"main_menu\";i:8;s:14:\"secondary_menu\";}s:10:\"screenshot\";s:27:\"themes/stark/screenshot.png\";s:3:\"php\";s:5:\"5.2.4\";s:7:\"scripts\";a:0:{}s:5:\"mtime\";i:1498069849;s:15:\"overlay_regions\";a:5:{i:0;s:14:\"dashboard_main\";i:1;s:17:\"dashboard_sidebar\";i:2;s:18:\"dashboard_inactive\";i:3;s:7:\"content\";i:4;s:4:\"help\";}s:14:\"regions_hidden\";a:2:{i:0;s:8:\"page_top\";i:1;s:11:\"page_bottom\";}s:28:\"overlay_supplemental_regions\";a:1:{i:0;s:11:\"page_bottom\";}}s:6:\"prefix\";s:11:\"phptemplate\";s:11:\"stylesheets\";a:1:{s:3:\"all\";a:1:{s:10:\"layout.css\";s:23:\"themes/stark/layout.css\";}}s:6:\"engine\";s:11:\"phptemplate\";}}\";s:13:\"page_callback\";s:19:\"block_admin_display\";s:14:\"page_arguments\";s:22:\"a:1:{i:0;s:5:\"stark\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:21:\"admin/structure/block\";s:8:\"tab_root\";s:21:\"admin/structure/block\";s:5:\"title\";s:5:\"Stark\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:1:{i:119;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"119\";s:4:\"plid\";s:3:\"112\";s:9:\"link_path\";s:36:\"admin/structure/block/list/stark/add\";s:11:\"router_path\";s:36:\"admin/structure/block/list/stark/add\";s:10:\"link_title\";s:9:\"Add block\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:2:\"28\";s:2:\"p4\";s:3:\"112\";s:2:\"p5\";s:3:\"119\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:35:\"a:1:{i:0;s:17:\"administer blocks\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:38:\"a:1:{i:0;s:20:\"block_add_block_form\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:32:\"admin/structure/block/list/stark\";s:8:\"tab_root\";s:21:\"admin/structure/block\";s:5:\"title\";s:9:\"Add block\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"388\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}}}i:123;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"123\";s:4:\"plid\";s:2:\"28\";s:9:\"link_path\";s:32:\"admin/structure/block/manage/%/%\";s:11:\"router_path\";s:32:\"admin/structure/block/manage/%/%\";s:10:\"link_title\";s:15:\"Configure block\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:2:\"28\";s:2:\"p4\";s:3:\"123\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:18:\"a:2:{i:4;N;i:5;N;}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:35:\"a:1:{i:0;s:17:\"administer blocks\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:55:\"a:3:{i:0;s:21:\"block_admin_configure\";i:1;i:4;i:2;i:5;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:32:\"admin/structure/block/manage/%/%\";s:5:\"title\";s:15:\"Configure block\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:3:{i:143;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"143\";s:4:\"plid\";s:3:\"123\";s:9:\"link_path\";s:42:\"admin/structure/block/manage/%/%/configure\";s:11:\"router_path\";s:42:\"admin/structure/block/manage/%/%/configure\";s:10:\"link_title\";s:9:\"Configure\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:4:\"-100\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:2:\"28\";s:2:\"p4\";s:3:\"123\";s:2:\"p5\";s:3:\"143\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:18:\"a:2:{i:4;N;i:5;N;}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:35:\"a:1:{i:0;s:17:\"administer blocks\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:55:\"a:3:{i:0;s:21:\"block_admin_configure\";i:1;i:4;i:2;i:5;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:32:\"admin/structure/block/manage/%/%\";s:8:\"tab_root\";s:32:\"admin/structure/block/manage/%/%\";s:5:\"title\";s:9:\"Configure\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"140\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:144;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"144\";s:4:\"plid\";s:3:\"123\";s:9:\"link_path\";s:39:\"admin/structure/block/manage/%/%/delete\";s:11:\"router_path\";s:39:\"admin/structure/block/manage/%/%/delete\";s:10:\"link_title\";s:12:\"Delete block\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:2:\"28\";s:2:\"p4\";s:3:\"123\";s:2:\"p5\";s:3:\"144\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:18:\"a:2:{i:4;N;i:5;N;}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:35:\"a:1:{i:0;s:17:\"administer blocks\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:59:\"a:3:{i:0;s:25:\"block_custom_block_delete\";i:1;i:4;i:2;i:5;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:39:\"admin/structure/block/manage/%/%/delete\";s:5:\"title\";s:12:\"Delete block\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"0\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:394;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"394\";s:4:\"plid\";s:3:\"123\";s:9:\"link_path\";s:42:\"admin/structure/block/manage/%/%/translate\";s:11:\"router_path\";s:42:\"admin/structure/block/manage/%/%/translate\";s:10:\"link_title\";s:9:\"Translate\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:2:\"10\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:2:\"28\";s:2:\"p4\";s:3:\"123\";s:2:\"p5\";s:3:\"394\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:18:\"a:2:{i:4;N;i:5;N;}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:31:\"i18n_block_translate_tab_access\";s:16:\"access_arguments\";s:22:\"a:2:{i:0;i:4;i:1;i:5;}\";s:13:\"page_callback\";s:29:\"i18n_block_translate_tab_page\";s:14:\"page_arguments\";s:22:\"a:2:{i:0;i:4;i:1;i:5;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:32:\"admin/structure/block/manage/%/%\";s:8:\"tab_root\";s:32:\"admin/structure/block/manage/%/%\";s:5:\"title\";s:9:\"Translate\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}}}i:361;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"361\";s:4:\"plid\";s:2:\"28\";s:9:\"link_path\";s:37:\"admin/structure/block/list/forum_plus\";s:11:\"router_path\";s:37:\"admin/structure/block/list/forum_plus\";s:10:\"link_title\";s:10:\"Forum Plus\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:3:\"-10\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:2:\"28\";s:2:\"p4\";s:3:\"361\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:20:\"_block_themes_access\";s:16:\"access_arguments\";s:4909:\"a:1:{i:0;O:8:\"stdClass\":13:{s:8:\"filename\";s:43:\"sites/all/themes/forum_plus/forum_plus.info\";s:4:\"name\";s:10:\"forum_plus\";s:4:\"type\";s:5:\"theme\";s:5:\"owner\";s:45:\"themes/engines/phptemplate/phptemplate.engine\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:2:\"-1\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:20:{s:4:\"name\";s:10:\"Forum Plus\";s:11:\"description\";s:23:\"Theme for the Companies\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:6:\"engine\";s:11:\"phptemplate\";s:11:\"stylesheets\";a:1:{s:3:\"all\";a:3:{s:34:\"vendor/bootstrap/css/bootstrap.css\";s:62:\"sites/all/themes/forum_plus/vendor/bootstrap/css/bootstrap.css\";s:40:\"vendor/bootstrap/css/bootstrap-theme.css\";s:68:\"sites/all/themes/forum_plus/vendor/bootstrap/css/bootstrap-theme.css\";s:14:\"css/styles.css\";s:42:\"sites/all/themes/forum_plus/css/styles.css\";}}s:7:\"scripts\";a:8:{s:32:\"vendor/bootstrap/js/bootstrap.js\";s:60:\"sites/all/themes/forum_plus/vendor/bootstrap/js/bootstrap.js\";s:26:\"js/jquery.smooth-scroll.js\";s:54:\"sites/all/themes/forum_plus/js/jquery.smooth-scroll.js\";s:19:\"js/jquery.cookie.js\";s:47:\"sites/all/themes/forum_plus/js/jquery.cookie.js\";s:24:\"js/jquery.matchHeight.js\";s:52:\"sites/all/themes/forum_plus/js/jquery.matchHeight.js\";s:12:\"js/moment.js\";s:40:\"sites/all/themes/forum_plus/js/moment.js\";s:20:\"js/accordion_menu.js\";s:48:\"sites/all/themes/forum_plus/js/accordion_menu.js\";s:13:\"js/weebpal.js\";s:41:\"sites/all/themes/forum_plus/js/weebpal.js\";s:16:\"js/forum_plus.js\";s:44:\"sites/all/themes/forum_plus/js/forum_plus.js\";}s:8:\"features\";a:7:{i:0;s:4:\"logo\";i:1;s:4:\"name\";i:2;s:6:\"slogan\";i:3;s:17:\"node_user_picture\";i:4;s:20:\"comment_user_picture\";i:5;s:25:\"comment_user_verification\";i:6;s:7:\"favicon\";}s:7:\"regions\";a:25:{s:8:\"headline\";s:8:\"Headline\";s:6:\"header\";s:6:\"Header\";s:9:\"main_menu\";s:9:\"Main Menu\";s:9:\"slideshow\";s:9:\"Slideshow\";s:4:\"help\";s:4:\"Help\";s:8:\"page_top\";s:8:\"Page top\";s:11:\"page_bottom\";s:11:\"Page bottom\";s:11:\"highlighted\";s:11:\"Highlighted\";s:8:\"featured\";s:8:\"Featured\";s:7:\"content\";s:7:\"Content\";s:13:\"sidebar_first\";s:13:\"Sidebar first\";s:14:\"sidebar_second\";s:14:\"Sidebar second\";s:7:\"welcome\";s:7:\"Welcome\";s:11:\"panel_first\";s:11:\"Panel First\";s:12:\"panel_second\";s:12:\"Panel Second\";s:11:\"panel_third\";s:11:\"Panel Third\";s:4:\"gmap\";s:4:\"GMap\";s:14:\"panel_footer_1\";s:14:\"Panel Footer 1\";s:14:\"panel_footer_2\";s:14:\"Panel Footer 2\";s:14:\"panel_footer_3\";s:14:\"Panel Footer 3\";s:14:\"panel_footer_4\";s:14:\"Panel Footer 4\";s:6:\"footer\";s:6:\"Footer\";s:14:\"dashboard_main\";s:16:\"Dashboard (main)\";s:17:\"dashboard_sidebar\";s:19:\"Dashboard (sidebar)\";s:18:\"dashboard_inactive\";s:20:\"Dashboard (inactive)\";}s:8:\"settings\";a:7:{s:19:\"sidebar_first_width\";s:1:\"3\";s:20:\"sidebar_second_width\";s:1:\"3\";s:20:\"panel_footer_1_width\";s:1:\"3\";s:20:\"panel_footer_2_width\";s:1:\"3\";s:20:\"panel_footer_3_width\";s:1:\"3\";s:20:\"panel_footer_4_width\";s:1:\"3\";s:20:\"layout_width_default\";s:4:\"1200\";}s:5:\"skins\";a:3:{s:3:\"red\";s:3:\"Red\";s:6:\"yellow\";s:6:\"Yellow\";s:5:\"green\";s:5:\"Green\";}s:7:\"plugins\";a:1:{s:14:\"advanced_forum\";a:1:{s:6:\"styles\";s:23:\"css/advanced_forum/plus\";}}s:11:\"backgrounds\";a:7:{s:4:\"bg-1\";s:12:\"Background 1\";s:4:\"bg-2\";s:12:\"Background 2\";s:4:\"bg-3\";s:12:\"Background 3\";s:4:\"bg-4\";s:12:\"Background 4\";s:4:\"bg-5\";s:12:\"Background 5\";s:4:\"bg-6\";s:12:\"Background 6\";s:4:\"bg-7\";s:12:\"Background 7\";}s:6:\"layout\";a:1:{s:12:\"layout-boxed\";s:12:\"Boxed Layout\";}s:10:\"screenshot\";s:42:\"sites/all/themes/forum_plus/screenshot.png\";s:3:\"php\";s:5:\"5.2.4\";s:5:\"mtime\";i:1499928385;s:15:\"overlay_regions\";a:5:{i:0;s:14:\"dashboard_main\";i:1;s:17:\"dashboard_sidebar\";i:2;s:18:\"dashboard_inactive\";i:3;s:7:\"content\";i:4;s:4:\"help\";}s:14:\"regions_hidden\";a:2:{i:0;s:8:\"page_top\";i:1;s:11:\"page_bottom\";}s:28:\"overlay_supplemental_regions\";a:1:{i:0;s:11:\"page_bottom\";}}s:6:\"prefix\";s:11:\"phptemplate\";s:11:\"stylesheets\";a:1:{s:3:\"all\";a:3:{s:34:\"vendor/bootstrap/css/bootstrap.css\";s:62:\"sites/all/themes/forum_plus/vendor/bootstrap/css/bootstrap.css\";s:40:\"vendor/bootstrap/css/bootstrap-theme.css\";s:68:\"sites/all/themes/forum_plus/vendor/bootstrap/css/bootstrap-theme.css\";s:14:\"css/styles.css\";s:42:\"sites/all/themes/forum_plus/css/styles.css\";}}s:7:\"scripts\";a:8:{s:32:\"vendor/bootstrap/js/bootstrap.js\";s:60:\"sites/all/themes/forum_plus/vendor/bootstrap/js/bootstrap.js\";s:26:\"js/jquery.smooth-scroll.js\";s:54:\"sites/all/themes/forum_plus/js/jquery.smooth-scroll.js\";s:19:\"js/jquery.cookie.js\";s:47:\"sites/all/themes/forum_plus/js/jquery.cookie.js\";s:24:\"js/jquery.matchHeight.js\";s:52:\"sites/all/themes/forum_plus/js/jquery.matchHeight.js\";s:12:\"js/moment.js\";s:40:\"sites/all/themes/forum_plus/js/moment.js\";s:20:\"js/accordion_menu.js\";s:48:\"sites/all/themes/forum_plus/js/accordion_menu.js\";s:13:\"js/weebpal.js\";s:41:\"sites/all/themes/forum_plus/js/weebpal.js\";s:16:\"js/forum_plus.js\";s:44:\"sites/all/themes/forum_plus/js/forum_plus.js\";}s:6:\"engine\";s:11:\"phptemplate\";}}\";s:13:\"page_callback\";s:19:\"block_admin_display\";s:14:\"page_arguments\";s:28:\"a:1:{i:0;s:10:\"forum_plus\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:21:\"admin/structure/block\";s:8:\"tab_root\";s:21:\"admin/structure/block\";s:5:\"title\";s:10:\"Forum Plus\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"140\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:899;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"899\";s:4:\"plid\";s:2:\"28\";s:9:\"link_path\";s:31:\"admin/structure/block/list/plus\";s:11:\"router_path\";s:31:\"admin/structure/block/list/plus\";s:10:\"link_title\";s:4:\"Plus\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:2:\"28\";s:2:\"p4\";s:3:\"899\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:20:\"_block_themes_access\";s:16:\"access_arguments\";s:1837:\"a:1:{i:0;O:8:\"stdClass\":11:{s:8:\"filename\";s:61:\"sites/all/themes/forum_plus/css/advanced_forum/plus/plus.info\";s:4:\"name\";s:4:\"plus\";s:4:\"type\";s:5:\"theme\";s:5:\"owner\";s:45:\"themes/engines/phptemplate/phptemplate.engine\";s:6:\"status\";s:1:\"0\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:2:\"-1\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:18:{s:4:\"name\";s:4:\"Plus\";s:11:\"description\";s:43:\"Based on the Blue Lagoon colors of Garland.\";s:7:\"version\";s:7:\"7.x-2.3\";s:10:\"base style\";s:5:\"naked\";s:4:\"core\";s:3:\"7.x\";s:7:\"project\";s:14:\"advanced_forum\";s:9:\"datestamp\";s:10:\"1373223651\";s:6:\"engine\";s:11:\"phptemplate\";s:7:\"regions\";a:12:{s:13:\"sidebar_first\";s:12:\"Left sidebar\";s:14:\"sidebar_second\";s:13:\"Right sidebar\";s:7:\"content\";s:7:\"Content\";s:6:\"header\";s:6:\"Header\";s:6:\"footer\";s:6:\"Footer\";s:11:\"highlighted\";s:11:\"Highlighted\";s:4:\"help\";s:4:\"Help\";s:8:\"page_top\";s:8:\"Page top\";s:11:\"page_bottom\";s:11:\"Page bottom\";s:14:\"dashboard_main\";s:16:\"Dashboard (main)\";s:17:\"dashboard_sidebar\";s:19:\"Dashboard (sidebar)\";s:18:\"dashboard_inactive\";s:20:\"Dashboard (inactive)\";}s:8:\"features\";a:9:{i:0;s:4:\"logo\";i:1;s:7:\"favicon\";i:2;s:4:\"name\";i:3;s:6:\"slogan\";i:4;s:17:\"node_user_picture\";i:5;s:20:\"comment_user_picture\";i:6;s:25:\"comment_user_verification\";i:7;s:9:\"main_menu\";i:8;s:14:\"secondary_menu\";}s:10:\"screenshot\";s:66:\"sites/all/themes/forum_plus/css/advanced_forum/plus/screenshot.png\";s:3:\"php\";s:5:\"5.2.4\";s:11:\"stylesheets\";a:0:{}s:7:\"scripts\";a:0:{}s:5:\"mtime\";i:1499928385;s:15:\"overlay_regions\";a:5:{i:0;s:14:\"dashboard_main\";i:1;s:17:\"dashboard_sidebar\";i:2;s:18:\"dashboard_inactive\";i:3;s:7:\"content\";i:4;s:4:\"help\";}s:14:\"regions_hidden\";a:2:{i:0;s:8:\"page_top\";i:1;s:11:\"page_bottom\";}s:28:\"overlay_supplemental_regions\";a:1:{i:0;s:11:\"page_bottom\";}}s:6:\"prefix\";s:11:\"phptemplate\";s:6:\"engine\";s:11:\"phptemplate\";}}\";s:13:\"page_callback\";s:19:\"block_admin_display\";s:14:\"page_arguments\";s:21:\"a:1:{i:0;s:4:\"plus\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:21:\"admin/structure/block\";s:8:\"tab_root\";s:21:\"admin/structure/block\";s:5:\"title\";s:4:\"Plus\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:1:{i:900;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"900\";s:4:\"plid\";s:3:\"899\";s:9:\"link_path\";s:35:\"admin/structure/block/list/plus/add\";s:11:\"router_path\";s:35:\"admin/structure/block/list/plus/add\";s:10:\"link_title\";s:9:\"Add block\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:2:\"28\";s:2:\"p4\";s:3:\"899\";s:2:\"p5\";s:3:\"900\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:35:\"a:1:{i:0;s:17:\"administer blocks\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:38:\"a:1:{i:0;s:20:\"block_add_block_form\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:31:\"admin/structure/block/list/plus\";s:8:\"tab_root\";s:21:\"admin/structure/block\";s:5:\"title\";s:9:\"Add block\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"388\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}}}i:915;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"915\";s:4:\"plid\";s:2:\"28\";s:9:\"link_path\";s:37:\"admin/structure/block/list/we_backend\";s:11:\"router_path\";s:37:\"admin/structure/block/list/we_backend\";s:10:\"link_title\";s:21:\"WeebPal Backend theme\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:2:\"28\";s:2:\"p4\";s:3:\"915\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:20:\"_block_themes_access\";s:16:\"access_arguments\";s:2001:\"a:1:{i:0;O:8:\"stdClass\":13:{s:8:\"filename\";s:43:\"sites/all/themes/we_backend/we_backend.info\";s:4:\"name\";s:10:\"we_backend\";s:4:\"type\";s:5:\"theme\";s:5:\"owner\";s:45:\"themes/engines/phptemplate/phptemplate.engine\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:2:\"-1\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:15:{s:4:\"name\";s:21:\"WeebPal Backend theme\";s:11:\"description\";s:26:\"Backend theme from WeebPal\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:6:\"engine\";s:11:\"phptemplate\";s:11:\"stylesheets\";a:1:{s:3:\"all\";a:1:{s:20:\"assets/css/style.css\";s:48:\"sites/all/themes/we_backend/assets/css/style.css\";}}s:7:\"scripts\";a:1:{s:20:\"assets/js/scripts.js\";s:48:\"sites/all/themes/we_backend/assets/js/scripts.js\";}s:8:\"features\";a:7:{i:0;s:4:\"logo\";i:1;s:4:\"name\";i:2;s:6:\"slogan\";i:3;s:17:\"node_user_picture\";i:4;s:20:\"comment_user_picture\";i:5;s:25:\"comment_user_verification\";i:6;s:7:\"favicon\";}s:7:\"regions\";a:10:{s:6:\"header\";s:6:\"Header\";s:11:\"highlighted\";s:11:\"Highlighted\";s:4:\"help\";s:4:\"Help\";s:7:\"content\";s:7:\"Content\";s:13:\"sidebar_first\";s:13:\"Sidebar first\";s:14:\"sidebar_second\";s:14:\"Sidebar second\";s:6:\"footer\";s:6:\"Footer\";s:14:\"dashboard_main\";s:16:\"Dashboard (main)\";s:17:\"dashboard_sidebar\";s:19:\"Dashboard (sidebar)\";s:18:\"dashboard_inactive\";s:20:\"Dashboard (inactive)\";}s:10:\"screenshot\";s:42:\"sites/all/themes/we_backend/screenshot.png\";s:3:\"php\";s:5:\"5.2.4\";s:5:\"mtime\";i:1499643480;s:15:\"overlay_regions\";a:5:{i:0;s:14:\"dashboard_main\";i:1;s:17:\"dashboard_sidebar\";i:2;s:18:\"dashboard_inactive\";i:3;s:7:\"content\";i:4;s:4:\"help\";}s:14:\"regions_hidden\";a:2:{i:0;s:8:\"page_top\";i:1;s:11:\"page_bottom\";}s:28:\"overlay_supplemental_regions\";a:1:{i:0;s:11:\"page_bottom\";}}s:6:\"prefix\";s:11:\"phptemplate\";s:11:\"stylesheets\";a:1:{s:3:\"all\";a:1:{s:20:\"assets/css/style.css\";s:48:\"sites/all/themes/we_backend/assets/css/style.css\";}}s:7:\"scripts\";a:1:{s:20:\"assets/js/scripts.js\";s:48:\"sites/all/themes/we_backend/assets/js/scripts.js\";}s:6:\"engine\";s:11:\"phptemplate\";}}\";s:13:\"page_callback\";s:19:\"block_admin_display\";s:14:\"page_arguments\";s:28:\"a:1:{i:0;s:10:\"we_backend\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:21:\"admin/structure/block\";s:8:\"tab_root\";s:21:\"admin/structure/block\";s:5:\"title\";s:21:\"WeebPal Backend theme\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:1:{i:916;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"916\";s:4:\"plid\";s:3:\"915\";s:9:\"link_path\";s:41:\"admin/structure/block/list/we_backend/add\";s:11:\"router_path\";s:41:\"admin/structure/block/list/we_backend/add\";s:10:\"link_title\";s:9:\"Add block\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:2:\"28\";s:2:\"p4\";s:3:\"915\";s:2:\"p5\";s:3:\"916\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:35:\"a:1:{i:0;s:17:\"administer blocks\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:38:\"a:1:{i:0;s:20:\"block_add_block_form\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:37:\"admin/structure/block/list/we_backend\";s:8:\"tab_root\";s:21:\"admin/structure/block\";s:5:\"title\";s:9:\"Add block\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"388\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}}}}}i:34;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:2:\"34\";s:4:\"plid\";s:2:\"20\";s:9:\"link_path\";s:21:\"admin/structure/types\";s:11:\"router_path\";s:21:\"admin/structure/types\";s:10:\"link_title\";s:13:\"Content types\";s:7:\"options\";s:142:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:92:\"Manage content types, including default status, front page promotion, comment settings, etc.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"1\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:2:\"34\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:42:\"a:1:{i:0;s:24:\"administer content types\";}\";s:13:\"page_callback\";s:19:\"node_overview_types\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:21:\"admin/structure/types\";s:5:\"title\";s:13:\"Content types\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:92:\"Manage content types, including default status, front page promotion, comment settings, etc.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:3:{i:66;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:2:\"66\";s:4:\"plid\";s:2:\"34\";s:9:\"link_path\";s:25:\"admin/structure/types/add\";s:11:\"router_path\";s:25:\"admin/structure/types/add\";s:10:\"link_title\";s:16:\"Add content type\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:2:\"34\";s:2:\"p4\";s:2:\"66\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:42:\"a:1:{i:0;s:24:\"administer content types\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:32:\"a:1:{i:0;s:14:\"node_type_form\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:21:\"admin/structure/types\";s:8:\"tab_root\";s:21:\"admin/structure/types\";s:5:\"title\";s:16:\"Add content type\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"388\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:80;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:2:\"80\";s:4:\"plid\";s:2:\"34\";s:9:\"link_path\";s:26:\"admin/structure/types/list\";s:11:\"router_path\";s:26:\"admin/structure/types/list\";s:10:\"link_title\";s:4:\"List\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:3:\"-10\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:2:\"34\";s:2:\"p4\";s:2:\"80\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:42:\"a:1:{i:0;s:24:\"administer content types\";}\";s:13:\"page_callback\";s:19:\"node_overview_types\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:21:\"admin/structure/types\";s:8:\"tab_root\";s:21:\"admin/structure/types\";s:5:\"title\";s:4:\"List\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"140\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:104;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"104\";s:4:\"plid\";s:2:\"34\";s:9:\"link_path\";s:30:\"admin/structure/types/manage/%\";s:11:\"router_path\";s:30:\"admin/structure/types/manage/%\";s:10:\"link_title\";s:17:\"Edit content type\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"1\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:2:\"34\";s:2:\"p4\";s:3:\"104\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:32:\"a:1:{i:4;s:14:\"node_type_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:42:\"a:1:{i:0;s:24:\"administer content types\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:40:\"a:2:{i:0;s:14:\"node_type_form\";i:1;i:4;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:30:\"admin/structure/types/manage/%\";s:5:\"title\";s:17:\"Edit content type\";s:14:\"title_callback\";s:20:\"node_type_page_title\";s:15:\"title_arguments\";s:14:\"a:1:{i:0;i:4;}\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:6:{i:125;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"125\";s:4:\"plid\";s:3:\"104\";s:9:\"link_path\";s:37:\"admin/structure/types/manage/%/delete\";s:11:\"router_path\";s:37:\"admin/structure/types/manage/%/delete\";s:10:\"link_title\";s:6:\"Delete\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:2:\"34\";s:2:\"p4\";s:3:\"104\";s:2:\"p5\";s:3:\"125\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:32:\"a:1:{i:4;s:14:\"node_type_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:42:\"a:1:{i:0;s:24:\"administer content types\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:50:\"a:2:{i:0;s:24:\"node_type_delete_confirm\";i:1;i:4;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:37:\"admin/structure/types/manage/%/delete\";s:5:\"title\";s:6:\"Delete\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:132;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"132\";s:4:\"plid\";s:3:\"104\";s:9:\"link_path\";s:35:\"admin/structure/types/manage/%/edit\";s:11:\"router_path\";s:35:\"admin/structure/types/manage/%/edit\";s:10:\"link_title\";s:4:\"Edit\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:2:\"34\";s:2:\"p4\";s:3:\"104\";s:2:\"p5\";s:3:\"132\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:32:\"a:1:{i:4;s:14:\"node_type_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:42:\"a:1:{i:0;s:24:\"administer content types\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:40:\"a:2:{i:0;s:14:\"node_type_form\";i:1;i:4;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:30:\"admin/structure/types/manage/%\";s:8:\"tab_root\";s:30:\"admin/structure/types/manage/%\";s:5:\"title\";s:4:\"Edit\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"140\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:141;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"141\";s:4:\"plid\";s:3:\"104\";s:9:\"link_path\";s:46:\"admin/structure/types/manage/%/comment/display\";s:11:\"router_path\";s:46:\"admin/structure/types/manage/%/comment/display\";s:10:\"link_title\";s:15:\"Comment display\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"4\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:2:\"34\";s:2:\"p4\";s:3:\"104\";s:2:\"p5\";s:3:\"141\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:40:\"a:1:{i:4;s:22:\"comment_node_type_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:21:\"field_ui_admin_access\";s:16:\"access_arguments\";s:75:\"a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:24:\"administer content types\";}}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:92:\"a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:7:\"comment\";i:2;i:4;i:3;s:7:\"default\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:30:\"admin/structure/types/manage/%\";s:8:\"tab_root\";s:30:\"admin/structure/types/manage/%\";s:5:\"title\";s:15:\"Comment display\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:3:{i:966;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"966\";s:4:\"plid\";s:3:\"141\";s:9:\"link_path\";s:54:\"admin/structure/types/manage/%/comment/display/default\";s:11:\"router_path\";s:54:\"admin/structure/types/manage/%/comment/display/default\";s:10:\"link_title\";s:7:\"Default\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:3:\"-10\";s:5:\"depth\";s:1:\"6\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:2:\"34\";s:2:\"p4\";s:3:\"104\";s:2:\"p5\";s:3:\"141\";s:2:\"p6\";s:3:\"966\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:40:\"a:1:{i:4;s:22:\"comment_node_type_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:31:\"_field_ui_view_mode_menu_access\";s:16:\"access_arguments\";s:152:\"a:6:{i:0;s:7:\"comment\";i:1;i:4;i:2;s:7:\"default\";i:3;s:21:\"field_ui_admin_access\";i:4;s:11:\"user_access\";i:5;a:1:{i:0;s:24:\"administer content types\";}}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:92:\"a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:7:\"comment\";i:2;i:4;i:3;s:7:\"default\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:46:\"admin/structure/types/manage/%/comment/display\";s:8:\"tab_root\";s:30:\"admin/structure/types/manage/%\";s:5:\"title\";s:7:\"Default\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"140\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:967;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"967\";s:4:\"plid\";s:3:\"141\";s:9:\"link_path\";s:51:\"admin/structure/types/manage/%/comment/display/full\";s:11:\"router_path\";s:51:\"admin/structure/types/manage/%/comment/display/full\";s:10:\"link_title\";s:12:\"Full comment\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"6\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:2:\"34\";s:2:\"p4\";s:3:\"104\";s:2:\"p5\";s:3:\"141\";s:2:\"p6\";s:3:\"967\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:40:\"a:1:{i:4;s:22:\"comment_node_type_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:31:\"_field_ui_view_mode_menu_access\";s:16:\"access_arguments\";s:149:\"a:6:{i:0;s:7:\"comment\";i:1;i:4;i:2;s:4:\"full\";i:3;s:21:\"field_ui_admin_access\";i:4;s:11:\"user_access\";i:5;a:1:{i:0;s:24:\"administer content types\";}}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:89:\"a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:7:\"comment\";i:2;i:4;i:3;s:4:\"full\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:46:\"admin/structure/types/manage/%/comment/display\";s:8:\"tab_root\";s:30:\"admin/structure/types/manage/%\";s:5:\"title\";s:12:\"Full comment\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:968;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"968\";s:4:\"plid\";s:3:\"141\";s:9:\"link_path\";s:52:\"admin/structure/types/manage/%/comment/display/token\";s:11:\"router_path\";s:52:\"admin/structure/types/manage/%/comment/display/token\";s:10:\"link_title\";s:6:\"Tokens\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"1\";s:5:\"depth\";s:1:\"6\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:2:\"34\";s:2:\"p4\";s:3:\"104\";s:2:\"p5\";s:3:\"141\";s:2:\"p6\";s:3:\"968\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:40:\"a:1:{i:4;s:22:\"comment_node_type_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:31:\"_field_ui_view_mode_menu_access\";s:16:\"access_arguments\";s:150:\"a:6:{i:0;s:7:\"comment\";i:1;i:4;i:2;s:5:\"token\";i:3;s:21:\"field_ui_admin_access\";i:4;s:11:\"user_access\";i:5;a:1:{i:0;s:24:\"administer content types\";}}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:90:\"a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:7:\"comment\";i:2;i:4;i:3;s:5:\"token\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:46:\"admin/structure/types/manage/%/comment/display\";s:8:\"tab_root\";s:30:\"admin/structure/types/manage/%\";s:5:\"title\";s:6:\"Tokens\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}}}i:142;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"142\";s:4:\"plid\";s:3:\"104\";s:9:\"link_path\";s:45:\"admin/structure/types/manage/%/comment/fields\";s:11:\"router_path\";s:45:\"admin/structure/types/manage/%/comment/fields\";s:10:\"link_title\";s:14:\"Comment fields\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"1\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"3\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:2:\"34\";s:2:\"p4\";s:3:\"104\";s:2:\"p5\";s:3:\"142\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:40:\"a:1:{i:4;s:22:\"comment_node_type_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:21:\"field_ui_admin_access\";s:16:\"access_arguments\";s:75:\"a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:24:\"administer content types\";}}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:72:\"a:3:{i:0;s:28:\"field_ui_field_overview_form\";i:1;s:7:\"comment\";i:2;i:4;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:30:\"admin/structure/types/manage/%\";s:8:\"tab_root\";s:30:\"admin/structure/types/manage/%\";s:5:\"title\";s:14:\"Comment fields\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:1:{i:969;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"969\";s:4:\"plid\";s:3:\"142\";s:9:\"link_path\";s:47:\"admin/structure/types/manage/%/comment/fields/%\";s:11:\"router_path\";s:47:\"admin/structure/types/manage/%/comment/fields/%\";s:10:\"link_title\";s:0:\"\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"6\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:2:\"34\";s:2:\"p4\";s:3:\"104\";s:2:\"p5\";s:3:\"142\";s:2:\"p6\";s:3:\"969\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:200:\"a:2:{i:4;a:1:{s:22:\"comment_node_type_load\";a:4:{i:0;s:7:\"comment\";i:1;i:4;i:2;s:1:\"4\";i:3;s:4:\"%map\";}}i:7;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:7:\"comment\";i:1;i:4;i:2;s:1:\"4\";i:3;s:4:\"%map\";}}}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:21:\"field_ui_admin_access\";s:16:\"access_arguments\";s:75:\"a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:24:\"administer content types\";}}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:50:\"a:2:{i:0;s:24:\"field_ui_field_edit_form\";i:1;i:7;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:47:\"admin/structure/types/manage/%/comment/fields/%\";s:5:\"title\";s:0:\"\";s:14:\"title_callback\";s:19:\"field_ui_menu_title\";s:15:\"title_arguments\";s:14:\"a:1:{i:0;i:7;}\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:4:{i:978;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"978\";s:4:\"plid\";s:3:\"969\";s:9:\"link_path\";s:54:\"admin/structure/types/manage/%/comment/fields/%/delete\";s:11:\"router_path\";s:54:\"admin/structure/types/manage/%/comment/fields/%/delete\";s:10:\"link_title\";s:6:\"Delete\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:2:\"10\";s:5:\"depth\";s:1:\"7\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:2:\"34\";s:2:\"p4\";s:3:\"104\";s:2:\"p5\";s:3:\"142\";s:2:\"p6\";s:3:\"969\";s:2:\"p7\";s:3:\"978\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:200:\"a:2:{i:4;a:1:{s:22:\"comment_node_type_load\";a:4:{i:0;s:7:\"comment\";i:1;i:4;i:2;s:1:\"4\";i:3;s:4:\"%map\";}}i:7;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:7:\"comment\";i:1;i:4;i:2;s:1:\"4\";i:3;s:4:\"%map\";}}}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:21:\"field_ui_admin_access\";s:16:\"access_arguments\";s:75:\"a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:24:\"administer content types\";}}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:52:\"a:2:{i:0;s:26:\"field_ui_field_delete_form\";i:1;i:7;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:47:\"admin/structure/types/manage/%/comment/fields/%\";s:8:\"tab_root\";s:47:\"admin/structure/types/manage/%/comment/fields/%\";s:5:\"title\";s:6:\"Delete\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:979;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"979\";s:4:\"plid\";s:3:\"969\";s:9:\"link_path\";s:52:\"admin/structure/types/manage/%/comment/fields/%/edit\";s:11:\"router_path\";s:52:\"admin/structure/types/manage/%/comment/fields/%/edit\";s:10:\"link_title\";s:4:\"Edit\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"7\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:2:\"34\";s:2:\"p4\";s:3:\"104\";s:2:\"p5\";s:3:\"142\";s:2:\"p6\";s:3:\"969\";s:2:\"p7\";s:3:\"979\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:200:\"a:2:{i:4;a:1:{s:22:\"comment_node_type_load\";a:4:{i:0;s:7:\"comment\";i:1;i:4;i:2;s:1:\"4\";i:3;s:4:\"%map\";}}i:7;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:7:\"comment\";i:1;i:4;i:2;s:1:\"4\";i:3;s:4:\"%map\";}}}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:21:\"field_ui_admin_access\";s:16:\"access_arguments\";s:75:\"a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:24:\"administer content types\";}}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:50:\"a:2:{i:0;s:24:\"field_ui_field_edit_form\";i:1;i:7;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:47:\"admin/structure/types/manage/%/comment/fields/%\";s:8:\"tab_root\";s:47:\"admin/structure/types/manage/%/comment/fields/%\";s:5:\"title\";s:4:\"Edit\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"140\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:980;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"980\";s:4:\"plid\";s:3:\"969\";s:9:\"link_path\";s:62:\"admin/structure/types/manage/%/comment/fields/%/field-settings\";s:11:\"router_path\";s:62:\"admin/structure/types/manage/%/comment/fields/%/field-settings\";s:10:\"link_title\";s:14:\"Field settings\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"7\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:2:\"34\";s:2:\"p4\";s:3:\"104\";s:2:\"p5\";s:3:\"142\";s:2:\"p6\";s:3:\"969\";s:2:\"p7\";s:3:\"980\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:200:\"a:2:{i:4;a:1:{s:22:\"comment_node_type_load\";a:4:{i:0;s:7:\"comment\";i:1;i:4;i:2;s:1:\"4\";i:3;s:4:\"%map\";}}i:7;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:7:\"comment\";i:1;i:4;i:2;s:1:\"4\";i:3;s:4:\"%map\";}}}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:21:\"field_ui_admin_access\";s:16:\"access_arguments\";s:75:\"a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:24:\"administer content types\";}}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:54:\"a:2:{i:0;s:28:\"field_ui_field_settings_form\";i:1;i:7;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:47:\"admin/structure/types/manage/%/comment/fields/%\";s:8:\"tab_root\";s:47:\"admin/structure/types/manage/%/comment/fields/%\";s:5:\"title\";s:14:\"Field settings\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:981;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"981\";s:4:\"plid\";s:3:\"969\";s:9:\"link_path\";s:59:\"admin/structure/types/manage/%/comment/fields/%/widget-type\";s:11:\"router_path\";s:59:\"admin/structure/types/manage/%/comment/fields/%/widget-type\";s:10:\"link_title\";s:11:\"Widget type\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"7\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:2:\"34\";s:2:\"p4\";s:3:\"104\";s:2:\"p5\";s:3:\"142\";s:2:\"p6\";s:3:\"969\";s:2:\"p7\";s:3:\"981\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:200:\"a:2:{i:4;a:1:{s:22:\"comment_node_type_load\";a:4:{i:0;s:7:\"comment\";i:1;i:4;i:2;s:1:\"4\";i:3;s:4:\"%map\";}}i:7;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:7:\"comment\";i:1;i:4;i:2;s:1:\"4\";i:3;s:4:\"%map\";}}}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:21:\"field_ui_admin_access\";s:16:\"access_arguments\";s:75:\"a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:24:\"administer content types\";}}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:51:\"a:2:{i:0;s:25:\"field_ui_widget_type_form\";i:1;i:7;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:47:\"admin/structure/types/manage/%/comment/fields/%\";s:8:\"tab_root\";s:47:\"admin/structure/types/manage/%/comment/fields/%\";s:5:\"title\";s:11:\"Widget type\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}}}}}i:930;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"930\";s:4:\"plid\";s:3:\"104\";s:9:\"link_path\";s:38:\"admin/structure/types/manage/%/display\";s:11:\"router_path\";s:38:\"admin/structure/types/manage/%/display\";s:10:\"link_title\";s:14:\"Manage display\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"2\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:2:\"34\";s:2:\"p4\";s:3:\"104\";s:2:\"p5\";s:3:\"930\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:32:\"a:1:{i:4;s:14:\"node_type_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:21:\"field_ui_admin_access\";s:16:\"access_arguments\";s:75:\"a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:24:\"administer content types\";}}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:89:\"a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:4:\"node\";i:2;i:4;i:3;s:7:\"default\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:30:\"admin/structure/types/manage/%\";s:8:\"tab_root\";s:30:\"admin/structure/types/manage/%\";s:5:\"title\";s:14:\"Manage display\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:8:{i:942;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"942\";s:4:\"plid\";s:3:\"930\";s:9:\"link_path\";s:46:\"admin/structure/types/manage/%/display/default\";s:11:\"router_path\";s:46:\"admin/structure/types/manage/%/display/default\";s:10:\"link_title\";s:7:\"Default\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:3:\"-10\";s:5:\"depth\";s:1:\"6\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:2:\"34\";s:2:\"p4\";s:3:\"104\";s:2:\"p5\";s:3:\"930\";s:2:\"p6\";s:3:\"942\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:32:\"a:1:{i:4;s:14:\"node_type_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:31:\"_field_ui_view_mode_menu_access\";s:16:\"access_arguments\";s:149:\"a:6:{i:0;s:4:\"node\";i:1;i:4;i:2;s:7:\"default\";i:3;s:21:\"field_ui_admin_access\";i:4;s:11:\"user_access\";i:5;a:1:{i:0;s:24:\"administer content types\";}}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:89:\"a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:4:\"node\";i:2;i:4;i:3;s:7:\"default\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:38:\"admin/structure/types/manage/%/display\";s:8:\"tab_root\";s:30:\"admin/structure/types/manage/%\";s:5:\"title\";s:7:\"Default\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"140\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:944;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"944\";s:4:\"plid\";s:3:\"930\";s:9:\"link_path\";s:43:\"admin/structure/types/manage/%/display/full\";s:11:\"router_path\";s:43:\"admin/structure/types/manage/%/display/full\";s:10:\"link_title\";s:12:\"Full content\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"6\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:2:\"34\";s:2:\"p4\";s:3:\"104\";s:2:\"p5\";s:3:\"930\";s:2:\"p6\";s:3:\"944\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:32:\"a:1:{i:4;s:14:\"node_type_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:31:\"_field_ui_view_mode_menu_access\";s:16:\"access_arguments\";s:146:\"a:6:{i:0;s:4:\"node\";i:1;i:4;i:2;s:4:\"full\";i:3;s:21:\"field_ui_admin_access\";i:4;s:11:\"user_access\";i:5;a:1:{i:0;s:24:\"administer content types\";}}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:86:\"a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:4:\"node\";i:2;i:4;i:3;s:4:\"full\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:38:\"admin/structure/types/manage/%/display\";s:8:\"tab_root\";s:30:\"admin/structure/types/manage/%\";s:5:\"title\";s:12:\"Full content\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:945;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"945\";s:4:\"plid\";s:3:\"930\";s:9:\"link_path\";s:44:\"admin/structure/types/manage/%/display/print\";s:11:\"router_path\";s:44:\"admin/structure/types/manage/%/display/print\";s:10:\"link_title\";s:5:\"Print\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"5\";s:5:\"depth\";s:1:\"6\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:2:\"34\";s:2:\"p4\";s:3:\"104\";s:2:\"p5\";s:3:\"930\";s:2:\"p6\";s:3:\"945\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:32:\"a:1:{i:4;s:14:\"node_type_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:31:\"_field_ui_view_mode_menu_access\";s:16:\"access_arguments\";s:147:\"a:6:{i:0;s:4:\"node\";i:1;i:4;i:2;s:5:\"print\";i:3;s:21:\"field_ui_admin_access\";i:4;s:11:\"user_access\";i:5;a:1:{i:0;s:24:\"administer content types\";}}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:87:\"a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:4:\"node\";i:2;i:4;i:3;s:5:\"print\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:38:\"admin/structure/types/manage/%/display\";s:8:\"tab_root\";s:30:\"admin/structure/types/manage/%\";s:5:\"title\";s:5:\"Print\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:946;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"946\";s:4:\"plid\";s:3:\"930\";s:9:\"link_path\";s:42:\"admin/structure/types/manage/%/display/rss\";s:11:\"router_path\";s:42:\"admin/structure/types/manage/%/display/rss\";s:10:\"link_title\";s:3:\"RSS\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"2\";s:5:\"depth\";s:1:\"6\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:2:\"34\";s:2:\"p4\";s:3:\"104\";s:2:\"p5\";s:3:\"930\";s:2:\"p6\";s:3:\"946\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:32:\"a:1:{i:4;s:14:\"node_type_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:31:\"_field_ui_view_mode_menu_access\";s:16:\"access_arguments\";s:145:\"a:6:{i:0;s:4:\"node\";i:1;i:4;i:2;s:3:\"rss\";i:3;s:21:\"field_ui_admin_access\";i:4;s:11:\"user_access\";i:5;a:1:{i:0;s:24:\"administer content types\";}}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:85:\"a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:4:\"node\";i:2;i:4;i:3;s:3:\"rss\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:38:\"admin/structure/types/manage/%/display\";s:8:\"tab_root\";s:30:\"admin/structure/types/manage/%\";s:5:\"title\";s:3:\"RSS\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:947;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"947\";s:4:\"plid\";s:3:\"930\";s:9:\"link_path\";s:51:\"admin/structure/types/manage/%/display/search_index\";s:11:\"router_path\";s:51:\"admin/structure/types/manage/%/display/search_index\";s:10:\"link_title\";s:12:\"Search index\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"3\";s:5:\"depth\";s:1:\"6\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:2:\"34\";s:2:\"p4\";s:3:\"104\";s:2:\"p5\";s:3:\"930\";s:2:\"p6\";s:3:\"947\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:32:\"a:1:{i:4;s:14:\"node_type_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:31:\"_field_ui_view_mode_menu_access\";s:16:\"access_arguments\";s:155:\"a:6:{i:0;s:4:\"node\";i:1;i:4;i:2;s:12:\"search_index\";i:3;s:21:\"field_ui_admin_access\";i:4;s:11:\"user_access\";i:5;a:1:{i:0;s:24:\"administer content types\";}}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:95:\"a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:4:\"node\";i:2;i:4;i:3;s:12:\"search_index\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:38:\"admin/structure/types/manage/%/display\";s:8:\"tab_root\";s:30:\"admin/structure/types/manage/%\";s:5:\"title\";s:12:\"Search index\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:948;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"948\";s:4:\"plid\";s:3:\"930\";s:9:\"link_path\";s:52:\"admin/structure/types/manage/%/display/search_result\";s:11:\"router_path\";s:52:\"admin/structure/types/manage/%/display/search_result\";s:10:\"link_title\";s:32:\"Search result highlighting input\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"4\";s:5:\"depth\";s:1:\"6\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:2:\"34\";s:2:\"p4\";s:3:\"104\";s:2:\"p5\";s:3:\"930\";s:2:\"p6\";s:3:\"948\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:32:\"a:1:{i:4;s:14:\"node_type_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:31:\"_field_ui_view_mode_menu_access\";s:16:\"access_arguments\";s:156:\"a:6:{i:0;s:4:\"node\";i:1;i:4;i:2;s:13:\"search_result\";i:3;s:21:\"field_ui_admin_access\";i:4;s:11:\"user_access\";i:5;a:1:{i:0;s:24:\"administer content types\";}}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:96:\"a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:4:\"node\";i:2;i:4;i:3;s:13:\"search_result\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:38:\"admin/structure/types/manage/%/display\";s:8:\"tab_root\";s:30:\"admin/structure/types/manage/%\";s:5:\"title\";s:32:\"Search result highlighting input\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:949;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"949\";s:4:\"plid\";s:3:\"930\";s:9:\"link_path\";s:45:\"admin/structure/types/manage/%/display/teaser\";s:11:\"router_path\";s:45:\"admin/structure/types/manage/%/display/teaser\";s:10:\"link_title\";s:6:\"Teaser\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"1\";s:5:\"depth\";s:1:\"6\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:2:\"34\";s:2:\"p4\";s:3:\"104\";s:2:\"p5\";s:3:\"930\";s:2:\"p6\";s:3:\"949\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:32:\"a:1:{i:4;s:14:\"node_type_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:31:\"_field_ui_view_mode_menu_access\";s:16:\"access_arguments\";s:148:\"a:6:{i:0;s:4:\"node\";i:1;i:4;i:2;s:6:\"teaser\";i:3;s:21:\"field_ui_admin_access\";i:4;s:11:\"user_access\";i:5;a:1:{i:0;s:24:\"administer content types\";}}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:88:\"a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:4:\"node\";i:2;i:4;i:3;s:6:\"teaser\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:38:\"admin/structure/types/manage/%/display\";s:8:\"tab_root\";s:30:\"admin/structure/types/manage/%\";s:5:\"title\";s:6:\"Teaser\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:951;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"951\";s:4:\"plid\";s:3:\"930\";s:9:\"link_path\";s:44:\"admin/structure/types/manage/%/display/token\";s:11:\"router_path\";s:44:\"admin/structure/types/manage/%/display/token\";s:10:\"link_title\";s:6:\"Tokens\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"6\";s:5:\"depth\";s:1:\"6\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:2:\"34\";s:2:\"p4\";s:3:\"104\";s:2:\"p5\";s:3:\"930\";s:2:\"p6\";s:3:\"951\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:32:\"a:1:{i:4;s:14:\"node_type_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:31:\"_field_ui_view_mode_menu_access\";s:16:\"access_arguments\";s:147:\"a:6:{i:0;s:4:\"node\";i:1;i:4;i:2;s:5:\"token\";i:3;s:21:\"field_ui_admin_access\";i:4;s:11:\"user_access\";i:5;a:1:{i:0;s:24:\"administer content types\";}}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:87:\"a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:4:\"node\";i:2;i:4;i:3;s:5:\"token\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:38:\"admin/structure/types/manage/%/display\";s:8:\"tab_root\";s:30:\"admin/structure/types/manage/%\";s:5:\"title\";s:6:\"Tokens\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}}}i:932;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"932\";s:4:\"plid\";s:3:\"104\";s:9:\"link_path\";s:37:\"admin/structure/types/manage/%/fields\";s:11:\"router_path\";s:37:\"admin/structure/types/manage/%/fields\";s:10:\"link_title\";s:13:\"Manage fields\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"1\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"1\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:2:\"34\";s:2:\"p4\";s:3:\"104\";s:2:\"p5\";s:3:\"932\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:32:\"a:1:{i:4;s:14:\"node_type_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:21:\"field_ui_admin_access\";s:16:\"access_arguments\";s:75:\"a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:24:\"administer content types\";}}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:69:\"a:3:{i:0;s:28:\"field_ui_field_overview_form\";i:1;s:4:\"node\";i:2;i:4;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:30:\"admin/structure/types/manage/%\";s:8:\"tab_root\";s:30:\"admin/structure/types/manage/%\";s:5:\"title\";s:13:\"Manage fields\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:1:{i:957;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"957\";s:4:\"plid\";s:3:\"932\";s:9:\"link_path\";s:39:\"admin/structure/types/manage/%/fields/%\";s:11:\"router_path\";s:39:\"admin/structure/types/manage/%/fields/%\";s:10:\"link_title\";s:0:\"\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"6\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:2:\"34\";s:2:\"p4\";s:3:\"104\";s:2:\"p5\";s:3:\"932\";s:2:\"p6\";s:3:\"957\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:186:\"a:2:{i:4;a:1:{s:14:\"node_type_load\";a:4:{i:0;s:4:\"node\";i:1;i:4;i:2;s:1:\"4\";i:3;s:4:\"%map\";}}i:6;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:4:\"node\";i:1;i:4;i:2;s:1:\"4\";i:3;s:4:\"%map\";}}}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:21:\"field_ui_admin_access\";s:16:\"access_arguments\";s:75:\"a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:24:\"administer content types\";}}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:50:\"a:2:{i:0;s:24:\"field_ui_field_edit_form\";i:1;i:6;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:39:\"admin/structure/types/manage/%/fields/%\";s:5:\"title\";s:0:\"\";s:14:\"title_callback\";s:19:\"field_ui_menu_title\";s:15:\"title_arguments\";s:14:\"a:1:{i:0;i:6;}\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:4:{i:971;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"971\";s:4:\"plid\";s:3:\"957\";s:9:\"link_path\";s:46:\"admin/structure/types/manage/%/fields/%/delete\";s:11:\"router_path\";s:46:\"admin/structure/types/manage/%/fields/%/delete\";s:10:\"link_title\";s:6:\"Delete\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:2:\"10\";s:5:\"depth\";s:1:\"7\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:2:\"34\";s:2:\"p4\";s:3:\"104\";s:2:\"p5\";s:3:\"932\";s:2:\"p6\";s:3:\"957\";s:2:\"p7\";s:3:\"971\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:186:\"a:2:{i:4;a:1:{s:14:\"node_type_load\";a:4:{i:0;s:4:\"node\";i:1;i:4;i:2;s:1:\"4\";i:3;s:4:\"%map\";}}i:6;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:4:\"node\";i:1;i:4;i:2;s:1:\"4\";i:3;s:4:\"%map\";}}}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:21:\"field_ui_admin_access\";s:16:\"access_arguments\";s:75:\"a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:24:\"administer content types\";}}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:52:\"a:2:{i:0;s:26:\"field_ui_field_delete_form\";i:1;i:6;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:39:\"admin/structure/types/manage/%/fields/%\";s:8:\"tab_root\";s:39:\"admin/structure/types/manage/%/fields/%\";s:5:\"title\";s:6:\"Delete\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:972;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"972\";s:4:\"plid\";s:3:\"957\";s:9:\"link_path\";s:44:\"admin/structure/types/manage/%/fields/%/edit\";s:11:\"router_path\";s:44:\"admin/structure/types/manage/%/fields/%/edit\";s:10:\"link_title\";s:4:\"Edit\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"7\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:2:\"34\";s:2:\"p4\";s:3:\"104\";s:2:\"p5\";s:3:\"932\";s:2:\"p6\";s:3:\"957\";s:2:\"p7\";s:3:\"972\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:186:\"a:2:{i:4;a:1:{s:14:\"node_type_load\";a:4:{i:0;s:4:\"node\";i:1;i:4;i:2;s:1:\"4\";i:3;s:4:\"%map\";}}i:6;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:4:\"node\";i:1;i:4;i:2;s:1:\"4\";i:3;s:4:\"%map\";}}}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:21:\"field_ui_admin_access\";s:16:\"access_arguments\";s:75:\"a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:24:\"administer content types\";}}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:50:\"a:2:{i:0;s:24:\"field_ui_field_edit_form\";i:1;i:6;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:39:\"admin/structure/types/manage/%/fields/%\";s:8:\"tab_root\";s:39:\"admin/structure/types/manage/%/fields/%\";s:5:\"title\";s:4:\"Edit\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"140\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:976;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"976\";s:4:\"plid\";s:3:\"957\";s:9:\"link_path\";s:54:\"admin/structure/types/manage/%/fields/%/field-settings\";s:11:\"router_path\";s:54:\"admin/structure/types/manage/%/fields/%/field-settings\";s:10:\"link_title\";s:14:\"Field settings\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"7\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:2:\"34\";s:2:\"p4\";s:3:\"104\";s:2:\"p5\";s:3:\"932\";s:2:\"p6\";s:3:\"957\";s:2:\"p7\";s:3:\"976\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:186:\"a:2:{i:4;a:1:{s:14:\"node_type_load\";a:4:{i:0;s:4:\"node\";i:1;i:4;i:2;s:1:\"4\";i:3;s:4:\"%map\";}}i:6;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:4:\"node\";i:1;i:4;i:2;s:1:\"4\";i:3;s:4:\"%map\";}}}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:21:\"field_ui_admin_access\";s:16:\"access_arguments\";s:75:\"a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:24:\"administer content types\";}}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:54:\"a:2:{i:0;s:28:\"field_ui_field_settings_form\";i:1;i:6;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:39:\"admin/structure/types/manage/%/fields/%\";s:8:\"tab_root\";s:39:\"admin/structure/types/manage/%/fields/%\";s:5:\"title\";s:14:\"Field settings\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:977;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"977\";s:4:\"plid\";s:3:\"957\";s:9:\"link_path\";s:51:\"admin/structure/types/manage/%/fields/%/widget-type\";s:11:\"router_path\";s:51:\"admin/structure/types/manage/%/fields/%/widget-type\";s:10:\"link_title\";s:11:\"Widget type\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"7\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:2:\"34\";s:2:\"p4\";s:3:\"104\";s:2:\"p5\";s:3:\"932\";s:2:\"p6\";s:3:\"957\";s:2:\"p7\";s:3:\"977\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:186:\"a:2:{i:4;a:1:{s:14:\"node_type_load\";a:4:{i:0;s:4:\"node\";i:1;i:4;i:2;s:1:\"4\";i:3;s:4:\"%map\";}}i:6;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:4:\"node\";i:1;i:4;i:2;s:1:\"4\";i:3;s:4:\"%map\";}}}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:21:\"field_ui_admin_access\";s:16:\"access_arguments\";s:75:\"a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:24:\"administer content types\";}}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:51:\"a:2:{i:0;s:25:\"field_ui_widget_type_form\";i:1;i:6;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:39:\"admin/structure/types/manage/%/fields/%\";s:8:\"tab_root\";s:39:\"admin/structure/types/manage/%/fields/%\";s:5:\"title\";s:11:\"Widget type\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}}}}}}}}}i:45;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:2:\"45\";s:4:\"plid\";s:2:\"20\";s:9:\"link_path\";s:20:\"admin/structure/menu\";s:11:\"router_path\";s:20:\"admin/structure/menu\";s:10:\"link_title\";s:5:\"Menus\";s:7:\"options\";s:136:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:86:\"Add new menus to your site, edit existing menus, and rename and reorganize menu links.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"1\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:2:\"45\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:33:\"a:1:{i:0;s:15:\"administer menu\";}\";s:13:\"page_callback\";s:18:\"menu_overview_page\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:20:\"admin/structure/menu\";s:5:\"title\";s:5:\"Menus\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:86:\"Add new menus to your site, edit existing menus, and rename and reorganize menu links.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:15:{i:67;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:2:\"67\";s:4:\"plid\";s:2:\"45\";s:9:\"link_path\";s:24:\"admin/structure/menu/add\";s:11:\"router_path\";s:24:\"admin/structure/menu/add\";s:10:\"link_title\";s:8:\"Add menu\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:2:\"45\";s:2:\"p4\";s:2:\"67\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:33:\"a:1:{i:0;s:15:\"administer menu\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:46:\"a:2:{i:0;s:14:\"menu_edit_menu\";i:1;s:3:\"add\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:20:\"admin/structure/menu\";s:8:\"tab_root\";s:20:\"admin/structure/menu\";s:5:\"title\";s:8:\"Add menu\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"388\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:81;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:2:\"81\";s:4:\"plid\";s:2:\"45\";s:9:\"link_path\";s:25:\"admin/structure/menu/list\";s:11:\"router_path\";s:25:\"admin/structure/menu/list\";s:10:\"link_title\";s:10:\"List menus\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:3:\"-10\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:2:\"45\";s:2:\"p4\";s:2:\"81\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:33:\"a:1:{i:0;s:15:\"administer menu\";}\";s:13:\"page_callback\";s:18:\"menu_overview_page\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:20:\"admin/structure/menu\";s:8:\"tab_root\";s:20:\"admin/structure/menu\";s:5:\"title\";s:10:\"List menus\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"140\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:90;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:2:\"90\";s:4:\"plid\";s:2:\"45\";s:9:\"link_path\";s:29:\"admin/structure/menu/settings\";s:11:\"router_path\";s:29:\"admin/structure/menu/settings\";s:10:\"link_title\";s:8:\"Settings\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"5\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:2:\"45\";s:2:\"p4\";s:2:\"90\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:33:\"a:1:{i:0;s:15:\"administer menu\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:32:\"a:1:{i:0;s:14:\"menu_configure\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:20:\"admin/structure/menu\";s:8:\"tab_root\";s:20:\"admin/structure/menu\";s:5:\"title\";s:8:\"Settings\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:103;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"103\";s:4:\"plid\";s:2:\"45\";s:9:\"link_path\";s:29:\"admin/structure/menu/manage/%\";s:11:\"router_path\";s:29:\"admin/structure/menu/manage/%\";s:10:\"link_title\";s:14:\"Customize menu\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"1\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:2:\"45\";s:2:\"p4\";s:3:\"103\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:26:\"a:1:{i:4;s:9:\"menu_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:33:\"a:1:{i:0;s:15:\"administer menu\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:44:\"a:2:{i:0;s:18:\"menu_overview_form\";i:1;i:4;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:29:\"admin/structure/menu/manage/%\";s:5:\"title\";s:14:\"Customize menu\";s:14:\"title_callback\";s:19:\"menu_overview_title\";s:15:\"title_arguments\";s:14:\"a:1:{i:0;i:4;}\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:4:{i:122;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"122\";s:4:\"plid\";s:3:\"103\";s:9:\"link_path\";s:33:\"admin/structure/menu/manage/%/add\";s:11:\"router_path\";s:33:\"admin/structure/menu/manage/%/add\";s:10:\"link_title\";s:8:\"Add link\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:2:\"45\";s:2:\"p4\";s:3:\"103\";s:2:\"p5\";s:3:\"122\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:26:\"a:1:{i:4;s:9:\"menu_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:33:\"a:1:{i:0;s:15:\"administer menu\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:60:\"a:4:{i:0;s:14:\"menu_edit_item\";i:1;s:3:\"add\";i:2;N;i:3;i:4;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:29:\"admin/structure/menu/manage/%\";s:8:\"tab_root\";s:29:\"admin/structure/menu/manage/%\";s:5:\"title\";s:8:\"Add link\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"388\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:128;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"128\";s:4:\"plid\";s:3:\"103\";s:9:\"link_path\";s:36:\"admin/structure/menu/manage/%/delete\";s:11:\"router_path\";s:36:\"admin/structure/menu/manage/%/delete\";s:10:\"link_title\";s:11:\"Delete menu\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:2:\"45\";s:2:\"p4\";s:3:\"103\";s:2:\"p5\";s:3:\"128\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:26:\"a:1:{i:4;s:9:\"menu_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:33:\"a:1:{i:0;s:15:\"administer menu\";}\";s:13:\"page_callback\";s:21:\"menu_delete_menu_page\";s:14:\"page_arguments\";s:14:\"a:1:{i:0;i:4;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:36:\"admin/structure/menu/manage/%/delete\";s:5:\"title\";s:11:\"Delete menu\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:133;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"133\";s:4:\"plid\";s:3:\"103\";s:9:\"link_path\";s:34:\"admin/structure/menu/manage/%/edit\";s:11:\"router_path\";s:34:\"admin/structure/menu/manage/%/edit\";s:10:\"link_title\";s:9:\"Edit menu\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:2:\"45\";s:2:\"p4\";s:3:\"103\";s:2:\"p5\";s:3:\"133\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:26:\"a:1:{i:4;s:9:\"menu_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:33:\"a:1:{i:0;s:15:\"administer menu\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:55:\"a:3:{i:0;s:14:\"menu_edit_menu\";i:1;s:4:\"edit\";i:2;i:4;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:29:\"admin/structure/menu/manage/%\";s:8:\"tab_root\";s:29:\"admin/structure/menu/manage/%\";s:5:\"title\";s:9:\"Edit menu\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:137;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"137\";s:4:\"plid\";s:3:\"103\";s:9:\"link_path\";s:34:\"admin/structure/menu/manage/%/list\";s:11:\"router_path\";s:34:\"admin/structure/menu/manage/%/list\";s:10:\"link_title\";s:10:\"List links\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:3:\"-10\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:2:\"45\";s:2:\"p4\";s:3:\"103\";s:2:\"p5\";s:3:\"137\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:26:\"a:1:{i:4;s:9:\"menu_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:33:\"a:1:{i:0;s:15:\"administer menu\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:44:\"a:2:{i:0;s:18:\"menu_overview_form\";i:1;i:4;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:29:\"admin/structure/menu/manage/%\";s:8:\"tab_root\";s:29:\"admin/structure/menu/manage/%\";s:5:\"title\";s:10:\"List links\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"140\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}}}i:129;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"129\";s:4:\"plid\";s:2:\"45\";s:9:\"link_path\";s:34:\"admin/structure/menu/item/%/delete\";s:11:\"router_path\";s:34:\"admin/structure/menu/item/%/delete\";s:10:\"link_title\";s:16:\"Delete menu link\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:2:\"45\";s:2:\"p4\";s:3:\"129\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:32:\"a:1:{i:4;s:14:\"menu_link_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:33:\"a:1:{i:0;s:15:\"administer menu\";}\";s:13:\"page_callback\";s:21:\"menu_item_delete_page\";s:14:\"page_arguments\";s:14:\"a:1:{i:0;i:4;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:34:\"admin/structure/menu/item/%/delete\";s:5:\"title\";s:16:\"Delete menu link\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:134;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"134\";s:4:\"plid\";s:2:\"45\";s:9:\"link_path\";s:32:\"admin/structure/menu/item/%/edit\";s:11:\"router_path\";s:32:\"admin/structure/menu/item/%/edit\";s:10:\"link_title\";s:14:\"Edit menu link\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:2:\"45\";s:2:\"p4\";s:3:\"134\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:32:\"a:1:{i:4;s:14:\"menu_link_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:33:\"a:1:{i:0;s:15:\"administer menu\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:61:\"a:4:{i:0;s:14:\"menu_edit_item\";i:1;s:4:\"edit\";i:2;i:4;i:3;N;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:32:\"admin/structure/menu/item/%/edit\";s:5:\"title\";s:14:\"Edit menu link\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:138;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"138\";s:4:\"plid\";s:2:\"45\";s:9:\"link_path\";s:33:\"admin/structure/menu/item/%/reset\";s:11:\"router_path\";s:33:\"admin/structure/menu/item/%/reset\";s:10:\"link_title\";s:15:\"Reset menu link\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:2:\"45\";s:2:\"p4\";s:3:\"138\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:32:\"a:1:{i:4;s:14:\"menu_link_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:33:\"a:1:{i:0;s:15:\"administer menu\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:49:\"a:2:{i:0;s:23:\"menu_reset_item_confirm\";i:1;i:4;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:33:\"admin/structure/menu/item/%/reset\";s:5:\"title\";s:15:\"Reset menu link\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:151;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"151\";s:4:\"plid\";s:2:\"45\";s:9:\"link_path\";s:37:\"admin/structure/menu/manage/main-menu\";s:11:\"router_path\";s:29:\"admin/structure/menu/manage/%\";s:10:\"link_title\";s:9:\"Main menu\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:4:\"menu\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:2:\"45\";s:2:\"p4\";s:3:\"151\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:26:\"a:1:{i:4;s:9:\"menu_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:33:\"a:1:{i:0;s:15:\"administer menu\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:44:\"a:2:{i:0;s:18:\"menu_overview_form\";i:1;i:4;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:29:\"admin/structure/menu/manage/%\";s:5:\"title\";s:14:\"Customize menu\";s:14:\"title_callback\";s:19:\"menu_overview_title\";s:15:\"title_arguments\";s:14:\"a:1:{i:0;i:4;}\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:152;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"152\";s:4:\"plid\";s:2:\"45\";s:9:\"link_path\";s:38:\"admin/structure/menu/manage/management\";s:11:\"router_path\";s:29:\"admin/structure/menu/manage/%\";s:10:\"link_title\";s:10:\"Management\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:4:\"menu\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:2:\"45\";s:2:\"p4\";s:3:\"152\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:26:\"a:1:{i:4;s:9:\"menu_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:33:\"a:1:{i:0;s:15:\"administer menu\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:44:\"a:2:{i:0;s:18:\"menu_overview_form\";i:1;i:4;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:29:\"admin/structure/menu/manage/%\";s:5:\"title\";s:14:\"Customize menu\";s:14:\"title_callback\";s:19:\"menu_overview_title\";s:15:\"title_arguments\";s:14:\"a:1:{i:0;i:4;}\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:153;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"153\";s:4:\"plid\";s:2:\"45\";s:9:\"link_path\";s:38:\"admin/structure/menu/manage/navigation\";s:11:\"router_path\";s:29:\"admin/structure/menu/manage/%\";s:10:\"link_title\";s:10:\"Navigation\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:4:\"menu\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:2:\"45\";s:2:\"p4\";s:3:\"153\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:26:\"a:1:{i:4;s:9:\"menu_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:33:\"a:1:{i:0;s:15:\"administer menu\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:44:\"a:2:{i:0;s:18:\"menu_overview_form\";i:1;i:4;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:29:\"admin/structure/menu/manage/%\";s:5:\"title\";s:14:\"Customize menu\";s:14:\"title_callback\";s:19:\"menu_overview_title\";s:15:\"title_arguments\";s:14:\"a:1:{i:0;i:4;}\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:154;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"154\";s:4:\"plid\";s:2:\"45\";s:9:\"link_path\";s:37:\"admin/structure/menu/manage/user-menu\";s:11:\"router_path\";s:29:\"admin/structure/menu/manage/%\";s:10:\"link_title\";s:9:\"User menu\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:4:\"menu\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:2:\"45\";s:2:\"p4\";s:3:\"154\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:26:\"a:1:{i:4;s:9:\"menu_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:33:\"a:1:{i:0;s:15:\"administer menu\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:44:\"a:2:{i:0;s:18:\"menu_overview_form\";i:1;i:4;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:29:\"admin/structure/menu/manage/%\";s:5:\"title\";s:14:\"Customize menu\";s:14:\"title_callback\";s:19:\"menu_overview_title\";s:15:\"title_arguments\";s:14:\"a:1:{i:0;i:4;}\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:395;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"395\";s:4:\"plid\";s:2:\"45\";s:9:\"link_path\";s:38:\"admin/structure/menu/manage/menu-links\";s:11:\"router_path\";s:29:\"admin/structure/menu/manage/%\";s:10:\"link_title\";s:5:\"Links\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:4:\"menu\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:2:\"45\";s:2:\"p4\";s:3:\"395\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:26:\"a:1:{i:4;s:9:\"menu_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:33:\"a:1:{i:0;s:15:\"administer menu\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:44:\"a:2:{i:0;s:18:\"menu_overview_form\";i:1;i:4;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:29:\"admin/structure/menu/manage/%\";s:5:\"title\";s:14:\"Customize menu\";s:14:\"title_callback\";s:19:\"menu_overview_title\";s:15:\"title_arguments\";s:14:\"a:1:{i:0;i:4;}\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:400;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"400\";s:4:\"plid\";s:2:\"45\";s:9:\"link_path\";s:44:\"admin/structure/menu/manage/menu-footer-menu\";s:11:\"router_path\";s:29:\"admin/structure/menu/manage/%\";s:10:\"link_title\";s:11:\"Footer menu\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:4:\"menu\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:2:\"45\";s:2:\"p4\";s:3:\"400\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:26:\"a:1:{i:4;s:9:\"menu_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:33:\"a:1:{i:0;s:15:\"administer menu\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:44:\"a:2:{i:0;s:18:\"menu_overview_form\";i:1;i:4;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:29:\"admin/structure/menu/manage/%\";s:5:\"title\";s:14:\"Customize menu\";s:14:\"title_callback\";s:19:\"menu_overview_title\";s:15:\"title_arguments\";s:14:\"a:1:{i:0;i:4;}\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:525;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"525\";s:4:\"plid\";s:2:\"45\";s:9:\"link_path\";s:41:\"admin/structure/menu/manage/menu-sections\";s:11:\"router_path\";s:29:\"admin/structure/menu/manage/%\";s:10:\"link_title\";s:8:\"Sections\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:4:\"menu\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:2:\"45\";s:2:\"p4\";s:3:\"525\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:26:\"a:1:{i:4;s:9:\"menu_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:33:\"a:1:{i:0;s:15:\"administer menu\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:44:\"a:2:{i:0;s:18:\"menu_overview_form\";i:1;i:4;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:29:\"admin/structure/menu/manage/%\";s:5:\"title\";s:14:\"Customize menu\";s:14:\"title_callback\";s:19:\"menu_overview_title\";s:15:\"title_arguments\";s:14:\"a:1:{i:0;i:4;}\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:526;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"526\";s:4:\"plid\";s:2:\"45\";s:9:\"link_path\";s:43:\"admin/structure/menu/manage/menu-categories\";s:11:\"router_path\";s:29:\"admin/structure/menu/manage/%\";s:10:\"link_title\";s:10:\"Categories\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:4:\"menu\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:2:\"45\";s:2:\"p4\";s:3:\"526\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:26:\"a:1:{i:4;s:9:\"menu_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:33:\"a:1:{i:0;s:15:\"administer menu\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:44:\"a:2:{i:0;s:18:\"menu_overview_form\";i:1;i:4;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:29:\"admin/structure/menu/manage/%\";s:5:\"title\";s:14:\"Customize menu\";s:14:\"title_callback\";s:19:\"menu_overview_title\";s:15:\"title_arguments\";s:14:\"a:1:{i:0;i:4;}\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}}}i:162;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"162\";s:4:\"plid\";s:2:\"20\";s:9:\"link_path\";s:24:\"admin/structure/taxonomy\";s:11:\"router_path\";s:24:\"admin/structure/taxonomy\";s:10:\"link_title\";s:8:\"Taxonomy\";s:7:\"options\";s:117:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:67:\"Manage tagging, categorization, and classification of your content.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"1\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:3:\"162\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:37:\"a:1:{i:0;s:19:\"administer taxonomy\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:48:\"a:1:{i:0;s:30:\"taxonomy_overview_vocabularies\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:24:\"admin/structure/taxonomy\";s:5:\"title\";s:8:\"Taxonomy\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:67:\"Manage tagging, categorization, and classification of your content.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:3:{i:194;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"194\";s:4:\"plid\";s:3:\"162\";s:9:\"link_path\";s:26:\"admin/structure/taxonomy/%\";s:11:\"router_path\";s:26:\"admin/structure/taxonomy/%\";s:10:\"link_title\";s:0:\"\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:3:\"162\";s:2:\"p4\";s:3:\"194\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:55:\"a:1:{i:3;s:37:\"taxonomy_vocabulary_machine_name_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:37:\"a:1:{i:0;s:19:\"administer taxonomy\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:49:\"a:2:{i:0;s:23:\"taxonomy_overview_terms\";i:1;i:3;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:26:\"admin/structure/taxonomy/%\";s:5:\"title\";s:0:\"\";s:14:\"title_callback\";s:12:\"entity_label\";s:15:\"title_arguments\";s:45:\"a:2:{i:0;s:19:\"taxonomy_vocabulary\";i:1;i:3;}\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:6:{i:202;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"202\";s:4:\"plid\";s:3:\"194\";s:9:\"link_path\";s:30:\"admin/structure/taxonomy/%/add\";s:11:\"router_path\";s:30:\"admin/structure/taxonomy/%/add\";s:10:\"link_title\";s:8:\"Add term\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:3:\"162\";s:2:\"p4\";s:3:\"194\";s:2:\"p5\";s:3:\"202\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:55:\"a:1:{i:3;s:37:\"taxonomy_vocabulary_machine_name_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:37:\"a:1:{i:0;s:19:\"administer taxonomy\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:54:\"a:3:{i:0;s:18:\"taxonomy_form_term\";i:1;a:0:{}i:2;i:3;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:26:\"admin/structure/taxonomy/%\";s:8:\"tab_root\";s:26:\"admin/structure/taxonomy/%\";s:5:\"title\";s:8:\"Add term\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"388\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:204;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"204\";s:4:\"plid\";s:3:\"194\";s:9:\"link_path\";s:31:\"admin/structure/taxonomy/%/edit\";s:11:\"router_path\";s:31:\"admin/structure/taxonomy/%/edit\";s:10:\"link_title\";s:4:\"Edit\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:3:\"-10\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:3:\"162\";s:2:\"p4\";s:3:\"194\";s:2:\"p5\";s:3:\"204\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:55:\"a:1:{i:3;s:37:\"taxonomy_vocabulary_machine_name_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:37:\"a:1:{i:0;s:19:\"administer taxonomy\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:50:\"a:2:{i:0;s:24:\"taxonomy_form_vocabulary\";i:1;i:3;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:26:\"admin/structure/taxonomy/%\";s:8:\"tab_root\";s:26:\"admin/structure/taxonomy/%\";s:5:\"title\";s:4:\"Edit\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:206;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"206\";s:4:\"plid\";s:3:\"194\";s:9:\"link_path\";s:31:\"admin/structure/taxonomy/%/list\";s:11:\"router_path\";s:31:\"admin/structure/taxonomy/%/list\";s:10:\"link_title\";s:4:\"List\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:3:\"-20\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:3:\"162\";s:2:\"p4\";s:3:\"194\";s:2:\"p5\";s:3:\"206\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:55:\"a:1:{i:3;s:37:\"taxonomy_vocabulary_machine_name_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:37:\"a:1:{i:0;s:19:\"administer taxonomy\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:49:\"a:2:{i:0;s:23:\"taxonomy_overview_terms\";i:1;i:3;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:26:\"admin/structure/taxonomy/%\";s:8:\"tab_root\";s:26:\"admin/structure/taxonomy/%\";s:5:\"title\";s:4:\"List\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"140\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:2:{i:522;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"522\";s:4:\"plid\";s:3:\"206\";s:9:\"link_path\";s:36:\"admin/structure/taxonomy/%/list/list\";s:11:\"router_path\";s:36:\"admin/structure/taxonomy/%/list/list\";s:10:\"link_title\";s:5:\"Terms\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:3:\"-20\";s:5:\"depth\";s:1:\"6\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:3:\"162\";s:2:\"p4\";s:3:\"194\";s:2:\"p5\";s:3:\"206\";s:2:\"p6\";s:3:\"522\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:55:\"a:1:{i:3;s:37:\"taxonomy_vocabulary_machine_name_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:37:\"a:1:{i:0;s:19:\"administer taxonomy\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:49:\"a:2:{i:0;s:23:\"taxonomy_overview_terms\";i:1;i:3;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:31:\"admin/structure/taxonomy/%/list\";s:8:\"tab_root\";s:26:\"admin/structure/taxonomy/%\";s:5:\"title\";s:5:\"Terms\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"140\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:523;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"523\";s:4:\"plid\";s:3:\"206\";s:9:\"link_path\";s:36:\"admin/structure/taxonomy/%/list/sets\";s:11:\"router_path\";s:36:\"admin/structure/taxonomy/%/list/sets\";s:10:\"link_title\";s:16:\"Translation sets\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"6\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:3:\"162\";s:2:\"p4\";s:3:\"194\";s:2:\"p5\";s:3:\"206\";s:2:\"p6\";s:3:\"523\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:55:\"a:1:{i:3;s:37:\"taxonomy_vocabulary_machine_name_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:52:\"i18n_taxonomy_vocabulary_translation_tab_sets_access\";s:16:\"access_arguments\";s:14:\"a:1:{i:0;i:3;}\";s:13:\"page_callback\";s:39:\"i18n_taxonomy_translation_sets_overview\";s:14:\"page_arguments\";s:14:\"a:1:{i:0;i:3;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:31:\"admin/structure/taxonomy/%/list\";s:8:\"tab_root\";s:26:\"admin/structure/taxonomy/%\";s:5:\"title\";s:16:\"Translation sets\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:1:{i:524;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"524\";s:4:\"plid\";s:3:\"523\";s:9:\"link_path\";s:40:\"admin/structure/taxonomy/%/list/sets/add\";s:11:\"router_path\";s:40:\"admin/structure/taxonomy/%/list/sets/add\";s:10:\"link_title\";s:22:\"Create new translation\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"7\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:3:\"162\";s:2:\"p4\";s:3:\"194\";s:2:\"p5\";s:3:\"206\";s:2:\"p6\";s:3:\"523\";s:2:\"p7\";s:3:\"524\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:55:\"a:1:{i:3;s:37:\"taxonomy_vocabulary_machine_name_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:52:\"i18n_taxonomy_vocabulary_translation_tab_sets_access\";s:16:\"access_arguments\";s:14:\"a:1:{i:0;i:3;}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:61:\"a:2:{i:0;s:35:\"i18n_taxonomy_translation_term_form\";i:1;i:3;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:36:\"admin/structure/taxonomy/%/list/sets\";s:8:\"tab_root\";s:26:\"admin/structure/taxonomy/%\";s:5:\"title\";s:22:\"Create new translation\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"388\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}}}}}i:520;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"520\";s:4:\"plid\";s:3:\"194\";s:9:\"link_path\";s:36:\"admin/structure/taxonomy/%/translate\";s:11:\"router_path\";s:36:\"admin/structure/taxonomy/%/translate\";s:10:\"link_title\";s:9:\"Translate\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:2:\"10\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:3:\"162\";s:2:\"p4\";s:3:\"194\";s:2:\"p5\";s:3:\"520\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:55:\"a:1:{i:3;s:37:\"taxonomy_vocabulary_machine_name_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:28:\"i18n_object_translate_access\";s:16:\"access_arguments\";s:45:\"a:2:{i:0;s:19:\"taxonomy_vocabulary\";i:1;i:3;}\";s:13:\"page_callback\";s:28:\"i18n_page_translate_localize\";s:14:\"page_arguments\";s:45:\"a:2:{i:0;s:19:\"taxonomy_vocabulary\";i:1;i:3;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:26:\"admin/structure/taxonomy/%\";s:8:\"tab_root\";s:26:\"admin/structure/taxonomy/%\";s:5:\"title\";s:9:\"Translate\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:920;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"920\";s:4:\"plid\";s:3:\"194\";s:9:\"link_path\";s:34:\"admin/structure/taxonomy/%/display\";s:11:\"router_path\";s:34:\"admin/structure/taxonomy/%/display\";s:10:\"link_title\";s:14:\"Manage display\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"2\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:3:\"162\";s:2:\"p4\";s:3:\"194\";s:2:\"p5\";s:3:\"920\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:55:\"a:1:{i:3;s:37:\"taxonomy_vocabulary_machine_name_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:21:\"field_ui_admin_access\";s:16:\"access_arguments\";s:70:\"a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:19:\"administer taxonomy\";}}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:99:\"a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:13:\"taxonomy_term\";i:2;i:3;i:3;s:7:\"default\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:26:\"admin/structure/taxonomy/%\";s:8:\"tab_root\";s:26:\"admin/structure/taxonomy/%\";s:5:\"title\";s:14:\"Manage display\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:3:{i:926;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"926\";s:4:\"plid\";s:3:\"920\";s:9:\"link_path\";s:42:\"admin/structure/taxonomy/%/display/default\";s:11:\"router_path\";s:42:\"admin/structure/taxonomy/%/display/default\";s:10:\"link_title\";s:7:\"Default\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:3:\"-10\";s:5:\"depth\";s:1:\"6\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:3:\"162\";s:2:\"p4\";s:3:\"194\";s:2:\"p5\";s:3:\"920\";s:2:\"p6\";s:3:\"926\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:55:\"a:1:{i:3;s:37:\"taxonomy_vocabulary_machine_name_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:31:\"_field_ui_view_mode_menu_access\";s:16:\"access_arguments\";s:154:\"a:6:{i:0;s:13:\"taxonomy_term\";i:1;i:3;i:2;s:7:\"default\";i:3;s:21:\"field_ui_admin_access\";i:4;s:11:\"user_access\";i:5;a:1:{i:0;s:19:\"administer taxonomy\";}}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:99:\"a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:13:\"taxonomy_term\";i:2;i:3;i:3;s:7:\"default\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:34:\"admin/structure/taxonomy/%/display\";s:8:\"tab_root\";s:26:\"admin/structure/taxonomy/%\";s:5:\"title\";s:7:\"Default\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"140\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:933;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"933\";s:4:\"plid\";s:3:\"920\";s:9:\"link_path\";s:39:\"admin/structure/taxonomy/%/display/full\";s:11:\"router_path\";s:39:\"admin/structure/taxonomy/%/display/full\";s:10:\"link_title\";s:18:\"Taxonomy term page\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"6\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:3:\"162\";s:2:\"p4\";s:3:\"194\";s:2:\"p5\";s:3:\"920\";s:2:\"p6\";s:3:\"933\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:55:\"a:1:{i:3;s:37:\"taxonomy_vocabulary_machine_name_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:31:\"_field_ui_view_mode_menu_access\";s:16:\"access_arguments\";s:151:\"a:6:{i:0;s:13:\"taxonomy_term\";i:1;i:3;i:2;s:4:\"full\";i:3;s:21:\"field_ui_admin_access\";i:4;s:11:\"user_access\";i:5;a:1:{i:0;s:19:\"administer taxonomy\";}}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:96:\"a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:13:\"taxonomy_term\";i:2;i:3;i:3;s:4:\"full\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:34:\"admin/structure/taxonomy/%/display\";s:8:\"tab_root\";s:26:\"admin/structure/taxonomy/%\";s:5:\"title\";s:18:\"Taxonomy term page\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:935;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"935\";s:4:\"plid\";s:3:\"920\";s:9:\"link_path\";s:40:\"admin/structure/taxonomy/%/display/token\";s:11:\"router_path\";s:40:\"admin/structure/taxonomy/%/display/token\";s:10:\"link_title\";s:6:\"Tokens\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"1\";s:5:\"depth\";s:1:\"6\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:3:\"162\";s:2:\"p4\";s:3:\"194\";s:2:\"p5\";s:3:\"920\";s:2:\"p6\";s:3:\"935\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:55:\"a:1:{i:3;s:37:\"taxonomy_vocabulary_machine_name_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:31:\"_field_ui_view_mode_menu_access\";s:16:\"access_arguments\";s:152:\"a:6:{i:0;s:13:\"taxonomy_term\";i:1;i:3;i:2;s:5:\"token\";i:3;s:21:\"field_ui_admin_access\";i:4;s:11:\"user_access\";i:5;a:1:{i:0;s:19:\"administer taxonomy\";}}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:97:\"a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:13:\"taxonomy_term\";i:2;i:3;i:3;s:5:\"token\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:34:\"admin/structure/taxonomy/%/display\";s:8:\"tab_root\";s:26:\"admin/structure/taxonomy/%\";s:5:\"title\";s:6:\"Tokens\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}}}i:923;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"923\";s:4:\"plid\";s:3:\"194\";s:9:\"link_path\";s:33:\"admin/structure/taxonomy/%/fields\";s:11:\"router_path\";s:33:\"admin/structure/taxonomy/%/fields\";s:10:\"link_title\";s:13:\"Manage fields\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"1\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"1\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:3:\"162\";s:2:\"p4\";s:3:\"194\";s:2:\"p5\";s:3:\"923\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:55:\"a:1:{i:3;s:37:\"taxonomy_vocabulary_machine_name_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:21:\"field_ui_admin_access\";s:16:\"access_arguments\";s:70:\"a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:19:\"administer taxonomy\";}}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:79:\"a:3:{i:0;s:28:\"field_ui_field_overview_form\";i:1;s:13:\"taxonomy_term\";i:2;i:3;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:26:\"admin/structure/taxonomy/%\";s:8:\"tab_root\";s:26:\"admin/structure/taxonomy/%\";s:5:\"title\";s:13:\"Manage fields\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:1:{i:938;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"938\";s:4:\"plid\";s:3:\"923\";s:9:\"link_path\";s:35:\"admin/structure/taxonomy/%/fields/%\";s:11:\"router_path\";s:35:\"admin/structure/taxonomy/%/fields/%\";s:10:\"link_title\";s:0:\"\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"6\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:3:\"162\";s:2:\"p4\";s:3:\"194\";s:2:\"p5\";s:3:\"923\";s:2:\"p6\";s:3:\"938\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:229:\"a:2:{i:3;a:1:{s:37:\"taxonomy_vocabulary_machine_name_load\";a:4:{i:0;s:13:\"taxonomy_term\";i:1;i:3;i:2;s:1:\"3\";i:3;s:4:\"%map\";}}i:5;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:13:\"taxonomy_term\";i:1;i:3;i:2;s:1:\"3\";i:3;s:4:\"%map\";}}}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:21:\"field_ui_admin_access\";s:16:\"access_arguments\";s:70:\"a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:19:\"administer taxonomy\";}}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:50:\"a:2:{i:0;s:24:\"field_ui_field_edit_form\";i:1;i:5;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:35:\"admin/structure/taxonomy/%/fields/%\";s:5:\"title\";s:0:\"\";s:14:\"title_callback\";s:19:\"field_ui_menu_title\";s:15:\"title_arguments\";s:14:\"a:1:{i:0;i:5;}\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:4:{i:958;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"958\";s:4:\"plid\";s:3:\"938\";s:9:\"link_path\";s:42:\"admin/structure/taxonomy/%/fields/%/delete\";s:11:\"router_path\";s:42:\"admin/structure/taxonomy/%/fields/%/delete\";s:10:\"link_title\";s:6:\"Delete\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:2:\"10\";s:5:\"depth\";s:1:\"7\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:3:\"162\";s:2:\"p4\";s:3:\"194\";s:2:\"p5\";s:3:\"923\";s:2:\"p6\";s:3:\"938\";s:2:\"p7\";s:3:\"958\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:229:\"a:2:{i:3;a:1:{s:37:\"taxonomy_vocabulary_machine_name_load\";a:4:{i:0;s:13:\"taxonomy_term\";i:1;i:3;i:2;s:1:\"3\";i:3;s:4:\"%map\";}}i:5;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:13:\"taxonomy_term\";i:1;i:3;i:2;s:1:\"3\";i:3;s:4:\"%map\";}}}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:21:\"field_ui_admin_access\";s:16:\"access_arguments\";s:70:\"a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:19:\"administer taxonomy\";}}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:52:\"a:2:{i:0;s:26:\"field_ui_field_delete_form\";i:1;i:5;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:35:\"admin/structure/taxonomy/%/fields/%\";s:8:\"tab_root\";s:35:\"admin/structure/taxonomy/%/fields/%\";s:5:\"title\";s:6:\"Delete\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:959;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"959\";s:4:\"plid\";s:3:\"938\";s:9:\"link_path\";s:40:\"admin/structure/taxonomy/%/fields/%/edit\";s:11:\"router_path\";s:40:\"admin/structure/taxonomy/%/fields/%/edit\";s:10:\"link_title\";s:4:\"Edit\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"7\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:3:\"162\";s:2:\"p4\";s:3:\"194\";s:2:\"p5\";s:3:\"923\";s:2:\"p6\";s:3:\"938\";s:2:\"p7\";s:3:\"959\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:229:\"a:2:{i:3;a:1:{s:37:\"taxonomy_vocabulary_machine_name_load\";a:4:{i:0;s:13:\"taxonomy_term\";i:1;i:3;i:2;s:1:\"3\";i:3;s:4:\"%map\";}}i:5;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:13:\"taxonomy_term\";i:1;i:3;i:2;s:1:\"3\";i:3;s:4:\"%map\";}}}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:21:\"field_ui_admin_access\";s:16:\"access_arguments\";s:70:\"a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:19:\"administer taxonomy\";}}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:50:\"a:2:{i:0;s:24:\"field_ui_field_edit_form\";i:1;i:5;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:35:\"admin/structure/taxonomy/%/fields/%\";s:8:\"tab_root\";s:35:\"admin/structure/taxonomy/%/fields/%\";s:5:\"title\";s:4:\"Edit\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"140\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:960;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"960\";s:4:\"plid\";s:3:\"938\";s:9:\"link_path\";s:50:\"admin/structure/taxonomy/%/fields/%/field-settings\";s:11:\"router_path\";s:50:\"admin/structure/taxonomy/%/fields/%/field-settings\";s:10:\"link_title\";s:14:\"Field settings\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"7\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:3:\"162\";s:2:\"p4\";s:3:\"194\";s:2:\"p5\";s:3:\"923\";s:2:\"p6\";s:3:\"938\";s:2:\"p7\";s:3:\"960\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:229:\"a:2:{i:3;a:1:{s:37:\"taxonomy_vocabulary_machine_name_load\";a:4:{i:0;s:13:\"taxonomy_term\";i:1;i:3;i:2;s:1:\"3\";i:3;s:4:\"%map\";}}i:5;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:13:\"taxonomy_term\";i:1;i:3;i:2;s:1:\"3\";i:3;s:4:\"%map\";}}}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:21:\"field_ui_admin_access\";s:16:\"access_arguments\";s:70:\"a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:19:\"administer taxonomy\";}}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:54:\"a:2:{i:0;s:28:\"field_ui_field_settings_form\";i:1;i:5;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:35:\"admin/structure/taxonomy/%/fields/%\";s:8:\"tab_root\";s:35:\"admin/structure/taxonomy/%/fields/%\";s:5:\"title\";s:14:\"Field settings\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:961;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"961\";s:4:\"plid\";s:3:\"938\";s:9:\"link_path\";s:47:\"admin/structure/taxonomy/%/fields/%/widget-type\";s:11:\"router_path\";s:47:\"admin/structure/taxonomy/%/fields/%/widget-type\";s:10:\"link_title\";s:11:\"Widget type\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"7\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:3:\"162\";s:2:\"p4\";s:3:\"194\";s:2:\"p5\";s:3:\"923\";s:2:\"p6\";s:3:\"938\";s:2:\"p7\";s:3:\"961\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:229:\"a:2:{i:3;a:1:{s:37:\"taxonomy_vocabulary_machine_name_load\";a:4:{i:0;s:13:\"taxonomy_term\";i:1;i:3;i:2;s:1:\"3\";i:3;s:4:\"%map\";}}i:5;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:13:\"taxonomy_term\";i:1;i:3;i:2;s:1:\"3\";i:3;s:4:\"%map\";}}}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:21:\"field_ui_admin_access\";s:16:\"access_arguments\";s:70:\"a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:19:\"administer taxonomy\";}}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:51:\"a:2:{i:0;s:25:\"field_ui_widget_type_form\";i:1;i:5;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:35:\"admin/structure/taxonomy/%/fields/%\";s:8:\"tab_root\";s:35:\"admin/structure/taxonomy/%/fields/%\";s:5:\"title\";s:11:\"Widget type\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}}}}}}}i:195;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"195\";s:4:\"plid\";s:3:\"162\";s:9:\"link_path\";s:28:\"admin/structure/taxonomy/add\";s:11:\"router_path\";s:28:\"admin/structure/taxonomy/add\";s:10:\"link_title\";s:14:\"Add vocabulary\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:3:\"162\";s:2:\"p4\";s:3:\"195\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:37:\"a:1:{i:0;s:19:\"administer taxonomy\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:42:\"a:1:{i:0;s:24:\"taxonomy_form_vocabulary\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:24:\"admin/structure/taxonomy\";s:8:\"tab_root\";s:24:\"admin/structure/taxonomy\";s:5:\"title\";s:14:\"Add vocabulary\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"388\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:196;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"196\";s:4:\"plid\";s:3:\"162\";s:9:\"link_path\";s:29:\"admin/structure/taxonomy/list\";s:11:\"router_path\";s:29:\"admin/structure/taxonomy/list\";s:10:\"link_title\";s:4:\"List\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:3:\"-10\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:3:\"162\";s:2:\"p4\";s:3:\"196\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:37:\"a:1:{i:0;s:19:\"administer taxonomy\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:48:\"a:1:{i:0;s:30:\"taxonomy_overview_vocabularies\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:24:\"admin/structure/taxonomy\";s:8:\"tab_root\";s:24:\"admin/structure/taxonomy\";s:5:\"title\";s:4:\"List\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"140\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}}}i:317;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"317\";s:4:\"plid\";s:2:\"20\";s:9:\"link_path\";s:21:\"admin/structure/forum\";s:11:\"router_path\";s:21:\"admin/structure/forum\";s:10:\"link_title\";s:6:\"Forums\";s:7:\"options\";s:83:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:33:\"Control forum hierarchy settings.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"1\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:3:\"317\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:35:\"a:1:{i:0;s:17:\"administer forums\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:32:\"a:1:{i:0;s:14:\"forum_overview\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:21:\"admin/structure/forum\";s:5:\"title\";s:6:\"Forums\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:33:\"Control forum hierarchy settings.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:6:{i:331;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"331\";s:4:\"plid\";s:3:\"317\";s:9:\"link_path\";s:26:\"admin/structure/forum/list\";s:11:\"router_path\";s:26:\"admin/structure/forum/list\";s:10:\"link_title\";s:4:\"List\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:3:\"-10\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:3:\"317\";s:2:\"p4\";s:3:\"331\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:35:\"a:1:{i:0;s:17:\"administer forums\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:32:\"a:1:{i:0;s:14:\"forum_overview\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:21:\"admin/structure/forum\";s:8:\"tab_root\";s:21:\"admin/structure/forum\";s:5:\"title\";s:4:\"List\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"140\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:337;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"337\";s:4:\"plid\";s:3:\"317\";s:9:\"link_path\";s:30:\"admin/structure/forum/settings\";s:11:\"router_path\";s:30:\"admin/structure/forum/settings\";s:10:\"link_title\";s:8:\"Settings\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"5\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:3:\"317\";s:2:\"p4\";s:3:\"337\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:35:\"a:1:{i:0;s:17:\"administer forums\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:38:\"a:1:{i:0;s:20:\"forum_admin_settings\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:21:\"admin/structure/forum\";s:8:\"tab_root\";s:21:\"admin/structure/forum\";s:5:\"title\";s:8:\"Settings\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:341;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"341\";s:4:\"plid\";s:3:\"317\";s:9:\"link_path\";s:35:\"admin/structure/forum/add/container\";s:11:\"router_path\";s:35:\"admin/structure/forum/add/container\";s:10:\"link_title\";s:13:\"Add container\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:3:\"317\";s:2:\"p4\";s:3:\"341\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:35:\"a:1:{i:0;s:17:\"administer forums\";}\";s:13:\"page_callback\";s:15:\"forum_form_main\";s:14:\"page_arguments\";s:26:\"a:1:{i:0;s:9:\"container\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:21:\"admin/structure/forum\";s:8:\"tab_root\";s:21:\"admin/structure/forum\";s:5:\"title\";s:13:\"Add container\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"388\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:342;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"342\";s:4:\"plid\";s:3:\"317\";s:9:\"link_path\";s:31:\"admin/structure/forum/add/forum\";s:11:\"router_path\";s:31:\"admin/structure/forum/add/forum\";s:10:\"link_title\";s:9:\"Add forum\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:3:\"317\";s:2:\"p4\";s:3:\"342\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:35:\"a:1:{i:0;s:17:\"administer forums\";}\";s:13:\"page_callback\";s:15:\"forum_form_main\";s:14:\"page_arguments\";s:22:\"a:1:{i:0;s:5:\"forum\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:21:\"admin/structure/forum\";s:8:\"tab_root\";s:21:\"admin/structure/forum\";s:5:\"title\";s:9:\"Add forum\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"388\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:344;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"344\";s:4:\"plid\";s:3:\"317\";s:9:\"link_path\";s:38:\"admin/structure/forum/edit/container/%\";s:11:\"router_path\";s:38:\"admin/structure/forum/edit/container/%\";s:10:\"link_title\";s:14:\"Edit container\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:3:\"317\";s:2:\"p4\";s:3:\"344\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:36:\"a:1:{i:5;s:18:\"taxonomy_term_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:35:\"a:1:{i:0;s:17:\"administer forums\";}\";s:13:\"page_callback\";s:15:\"forum_form_main\";s:14:\"page_arguments\";s:34:\"a:2:{i:0;s:9:\"container\";i:1;i:5;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:38:\"admin/structure/forum/edit/container/%\";s:5:\"title\";s:14:\"Edit container\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:345;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"345\";s:4:\"plid\";s:3:\"317\";s:9:\"link_path\";s:34:\"admin/structure/forum/edit/forum/%\";s:11:\"router_path\";s:34:\"admin/structure/forum/edit/forum/%\";s:10:\"link_title\";s:10:\"Edit forum\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:3:\"317\";s:2:\"p4\";s:3:\"345\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:36:\"a:1:{i:5;s:18:\"taxonomy_term_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:35:\"a:1:{i:0;s:17:\"administer forums\";}\";s:13:\"page_callback\";s:15:\"forum_form_main\";s:14:\"page_arguments\";s:30:\"a:2:{i:0;s:5:\"forum\";i:1;i:5;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:34:\"admin/structure/forum/edit/forum/%\";s:5:\"title\";s:10:\"Edit forum\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}}}i:319;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"319\";s:4:\"plid\";s:2:\"20\";s:9:\"link_path\";s:21:\"admin/structure/views\";s:11:\"router_path\";s:21:\"admin/structure/views\";s:10:\"link_title\";s:5:\"Views\";s:7:\"options\";s:85:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:35:\"Manage customized lists of content.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"1\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:3:\"319\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:28:\"ctools_export_ui_task_access\";s:16:\"access_arguments\";s:40:\"a:2:{i:0;s:8:\"views_ui\";i:1;s:4:\"list\";}\";s:13:\"page_callback\";s:30:\"ctools_export_ui_switcher_page\";s:14:\"page_arguments\";s:40:\"a:2:{i:0;s:8:\"views_ui\";i:1;s:4:\"list\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:21:\"admin/structure/views\";s:5:\"title\";s:5:\"Views\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:35:\"Manage customized lists of content.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:8:{i:326;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"326\";s:4:\"plid\";s:3:\"319\";s:9:\"link_path\";s:25:\"admin/structure/views/add\";s:11:\"router_path\";s:25:\"admin/structure/views/add\";s:10:\"link_title\";s:12:\"Add new view\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:3:\"319\";s:2:\"p4\";s:3:\"326\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:34:\"a:1:{i:0;s:16:\"administer views\";}\";s:13:\"page_callback\";s:17:\"views_ui_add_page\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:21:\"admin/structure/views\";s:8:\"tab_root\";s:21:\"admin/structure/views\";s:5:\"title\";s:12:\"Add new view\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"388\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:327;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"327\";s:4:\"plid\";s:3:\"319\";s:9:\"link_path\";s:34:\"admin/structure/views/add-template\";s:11:\"router_path\";s:34:\"admin/structure/views/add-template\";s:10:\"link_title\";s:22:\"Add view from template\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:3:\"319\";s:2:\"p4\";s:3:\"327\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:34:\"a:1:{i:0;s:16:\"administer views\";}\";s:13:\"page_callback\";s:26:\"views_ui_add_template_page\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:21:\"admin/structure/views\";s:8:\"tab_root\";s:21:\"admin/structure/views\";s:5:\"title\";s:22:\"Add view from template\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"388\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:328;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"328\";s:4:\"plid\";s:3:\"319\";s:9:\"link_path\";s:28:\"admin/structure/views/import\";s:11:\"router_path\";s:28:\"admin/structure/views/import\";s:10:\"link_title\";s:6:\"Import\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:3:\"319\";s:2:\"p4\";s:3:\"328\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:19:\"views_import_access\";s:16:\"access_arguments\";s:34:\"a:1:{i:0;s:16:\"administer views\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:38:\"a:1:{i:0;s:20:\"views_ui_import_page\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:21:\"admin/structure/views\";s:8:\"tab_root\";s:21:\"admin/structure/views\";s:5:\"title\";s:6:\"Import\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"388\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:330;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"330\";s:4:\"plid\";s:3:\"319\";s:9:\"link_path\";s:26:\"admin/structure/views/list\";s:11:\"router_path\";s:26:\"admin/structure/views/list\";s:10:\"link_title\";s:4:\"List\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:3:\"-10\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:3:\"319\";s:2:\"p4\";s:3:\"330\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:28:\"ctools_export_ui_task_access\";s:16:\"access_arguments\";s:40:\"a:2:{i:0;s:8:\"views_ui\";i:1;s:4:\"list\";}\";s:13:\"page_callback\";s:30:\"ctools_export_ui_switcher_page\";s:14:\"page_arguments\";s:40:\"a:2:{i:0;s:8:\"views_ui\";i:1;s:4:\"list\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:21:\"admin/structure/views\";s:8:\"tab_root\";s:21:\"admin/structure/views\";s:5:\"title\";s:4:\"List\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"140\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:335;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"335\";s:4:\"plid\";s:3:\"319\";s:9:\"link_path\";s:30:\"admin/structure/views/settings\";s:11:\"router_path\";s:30:\"admin/structure/views/settings\";s:10:\"link_title\";s:8:\"Settings\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:3:\"319\";s:2:\"p4\";s:3:\"335\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:34:\"a:1:{i:0;s:16:\"administer views\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:47:\"a:1:{i:0;s:29:\"views_ui_admin_settings_basic\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:21:\"admin/structure/views\";s:8:\"tab_root\";s:21:\"admin/structure/views\";s:5:\"title\";s:8:\"Settings\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:2:{i:338;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"338\";s:4:\"plid\";s:3:\"335\";s:9:\"link_path\";s:39:\"admin/structure/views/settings/advanced\";s:11:\"router_path\";s:39:\"admin/structure/views/settings/advanced\";s:10:\"link_title\";s:8:\"Advanced\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"1\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:3:\"319\";s:2:\"p4\";s:3:\"335\";s:2:\"p5\";s:3:\"338\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:34:\"a:1:{i:0;s:16:\"administer views\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:50:\"a:1:{i:0;s:32:\"views_ui_admin_settings_advanced\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:30:\"admin/structure/views/settings\";s:8:\"tab_root\";s:21:\"admin/structure/views\";s:5:\"title\";s:8:\"Advanced\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:339;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"339\";s:4:\"plid\";s:3:\"335\";s:9:\"link_path\";s:36:\"admin/structure/views/settings/basic\";s:11:\"router_path\";s:36:\"admin/structure/views/settings/basic\";s:10:\"link_title\";s:5:\"Basic\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:3:\"319\";s:2:\"p4\";s:3:\"335\";s:2:\"p5\";s:3:\"339\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:34:\"a:1:{i:0;s:16:\"administer views\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:47:\"a:1:{i:0;s:29:\"views_ui_admin_settings_basic\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:30:\"admin/structure/views/settings\";s:8:\"tab_root\";s:21:\"admin/structure/views\";s:5:\"title\";s:5:\"Basic\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"140\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}}}i:340;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"340\";s:4:\"plid\";s:3:\"319\";s:9:\"link_path\";s:28:\"admin/structure/views/view/%\";s:11:\"router_path\";s:28:\"admin/structure/views/view/%\";s:10:\"link_title\";s:0:\"\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:3:\"319\";s:2:\"p4\";s:3:\"340\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:37:\"a:1:{i:4;s:19:\"views_ui_cache_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:34:\"a:1:{i:0;s:16:\"administer views\";}\";s:13:\"page_callback\";s:18:\"views_ui_edit_page\";s:14:\"page_arguments\";s:14:\"a:1:{i:0;i:4;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:28:\"admin/structure/views/view/%\";s:5:\"title\";s:0:\"\";s:14:\"title_callback\";s:24:\"views_ui_edit_page_title\";s:15:\"title_arguments\";s:14:\"a:1:{i:0;i:4;}\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:7:{i:343;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"343\";s:4:\"plid\";s:3:\"340\";s:9:\"link_path\";s:39:\"admin/structure/views/view/%/break-lock\";s:11:\"router_path\";s:39:\"admin/structure/views/view/%/break-lock\";s:10:\"link_title\";s:10:\"Break lock\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:3:\"319\";s:2:\"p4\";s:3:\"340\";s:2:\"p5\";s:3:\"343\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:37:\"a:1:{i:4;s:19:\"views_ui_cache_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:34:\"a:1:{i:0;s:16:\"administer views\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:53:\"a:2:{i:0;s:27:\"views_ui_break_lock_confirm\";i:1;i:4;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:39:\"admin/structure/views/view/%/break-lock\";s:5:\"title\";s:10:\"Break lock\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"4\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:346;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"346\";s:4:\"plid\";s:3:\"340\";s:9:\"link_path\";s:33:\"admin/structure/views/view/%/edit\";s:11:\"router_path\";s:33:\"admin/structure/views/view/%/edit\";s:10:\"link_title\";s:9:\"Edit view\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:3:\"-10\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:3:\"319\";s:2:\"p4\";s:3:\"340\";s:2:\"p5\";s:3:\"346\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:37:\"a:1:{i:4;s:19:\"views_ui_cache_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:34:\"a:1:{i:0;s:16:\"administer views\";}\";s:13:\"page_callback\";s:18:\"views_ui_edit_page\";s:14:\"page_arguments\";s:14:\"a:1:{i:0;i:4;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:28:\"admin/structure/views/view/%\";s:8:\"tab_root\";s:28:\"admin/structure/views/view/%\";s:5:\"title\";s:9:\"Edit view\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:20:\"ajax_base_page_theme\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"140\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:347;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"347\";s:4:\"plid\";s:3:\"340\";s:9:\"link_path\";s:34:\"admin/structure/views/view/%/clone\";s:11:\"router_path\";s:34:\"admin/structure/views/view/%/clone\";s:10:\"link_title\";s:5:\"Clone\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:3:\"319\";s:2:\"p4\";s:3:\"340\";s:2:\"p5\";s:3:\"347\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:70:\"a:1:{i:4;a:1:{s:21:\"ctools_export_ui_load\";a:1:{i:0;s:8:\"views_ui\";}}}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:28:\"ctools_export_ui_task_access\";s:16:\"access_arguments\";s:49:\"a:3:{i:0;s:8:\"views_ui\";i:1;s:5:\"clone\";i:2;i:4;}\";s:13:\"page_callback\";s:30:\"ctools_export_ui_switcher_page\";s:14:\"page_arguments\";s:49:\"a:3:{i:0;s:8:\"views_ui\";i:1;s:5:\"clone\";i:2;i:4;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:34:\"admin/structure/views/view/%/clone\";s:5:\"title\";s:5:\"Clone\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"4\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:348;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"348\";s:4:\"plid\";s:3:\"340\";s:9:\"link_path\";s:35:\"admin/structure/views/view/%/delete\";s:11:\"router_path\";s:35:\"admin/structure/views/view/%/delete\";s:10:\"link_title\";s:6:\"Delete\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:3:\"319\";s:2:\"p4\";s:3:\"340\";s:2:\"p5\";s:3:\"348\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:70:\"a:1:{i:4;a:1:{s:21:\"ctools_export_ui_load\";a:1:{i:0;s:8:\"views_ui\";}}}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:28:\"ctools_export_ui_task_access\";s:16:\"access_arguments\";s:50:\"a:3:{i:0;s:8:\"views_ui\";i:1;s:6:\"delete\";i:2;i:4;}\";s:13:\"page_callback\";s:30:\"ctools_export_ui_switcher_page\";s:14:\"page_arguments\";s:50:\"a:3:{i:0;s:8:\"views_ui\";i:1;s:6:\"delete\";i:2;i:4;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:35:\"admin/structure/views/view/%/delete\";s:5:\"title\";s:6:\"Delete\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"4\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:349;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"349\";s:4:\"plid\";s:3:\"340\";s:9:\"link_path\";s:35:\"admin/structure/views/view/%/export\";s:11:\"router_path\";s:35:\"admin/structure/views/view/%/export\";s:10:\"link_title\";s:6:\"Export\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:3:\"319\";s:2:\"p4\";s:3:\"340\";s:2:\"p5\";s:3:\"349\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:70:\"a:1:{i:4;a:1:{s:21:\"ctools_export_ui_load\";a:1:{i:0;s:8:\"views_ui\";}}}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:28:\"ctools_export_ui_task_access\";s:16:\"access_arguments\";s:50:\"a:3:{i:0;s:8:\"views_ui\";i:1;s:6:\"export\";i:2;i:4;}\";s:13:\"page_callback\";s:30:\"ctools_export_ui_switcher_page\";s:14:\"page_arguments\";s:50:\"a:3:{i:0;s:8:\"views_ui\";i:1;s:6:\"export\";i:2;i:4;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:35:\"admin/structure/views/view/%/export\";s:5:\"title\";s:6:\"Export\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"4\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:350;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"350\";s:4:\"plid\";s:3:\"340\";s:9:\"link_path\";s:35:\"admin/structure/views/view/%/revert\";s:11:\"router_path\";s:35:\"admin/structure/views/view/%/revert\";s:10:\"link_title\";s:6:\"Revert\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:3:\"319\";s:2:\"p4\";s:3:\"340\";s:2:\"p5\";s:3:\"350\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:70:\"a:1:{i:4;a:1:{s:21:\"ctools_export_ui_load\";a:1:{i:0;s:8:\"views_ui\";}}}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:28:\"ctools_export_ui_task_access\";s:16:\"access_arguments\";s:50:\"a:3:{i:0;s:8:\"views_ui\";i:1;s:6:\"revert\";i:2;i:4;}\";s:13:\"page_callback\";s:30:\"ctools_export_ui_switcher_page\";s:14:\"page_arguments\";s:50:\"a:3:{i:0;s:8:\"views_ui\";i:1;s:6:\"delete\";i:2;i:4;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:35:\"admin/structure/views/view/%/revert\";s:5:\"title\";s:6:\"Revert\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"4\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:351;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"351\";s:4:\"plid\";s:3:\"340\";s:9:\"link_path\";s:38:\"admin/structure/views/view/%/preview/%\";s:11:\"router_path\";s:38:\"admin/structure/views/view/%/preview/%\";s:10:\"link_title\";s:0:\"\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:3:\"319\";s:2:\"p4\";s:3:\"340\";s:2:\"p5\";s:3:\"351\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:43:\"a:2:{i:4;s:19:\"views_ui_cache_load\";i:6;N;}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:34:\"a:1:{i:0;s:16:\"administer views\";}\";s:13:\"page_callback\";s:22:\"views_ui_build_preview\";s:14:\"page_arguments\";s:22:\"a:2:{i:0;i:4;i:1;i:6;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:38:\"admin/structure/views/view/%/preview/%\";s:5:\"title\";s:0:\"\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"4\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}}}i:353;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"353\";s:4:\"plid\";s:3:\"319\";s:9:\"link_path\";s:38:\"admin/structure/views/ajax/preview/%/%\";s:11:\"router_path\";s:38:\"admin/structure/views/ajax/preview/%/%\";s:10:\"link_title\";s:0:\"\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:3:\"319\";s:2:\"p4\";s:3:\"353\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:43:\"a:2:{i:5;s:19:\"views_ui_cache_load\";i:6;N;}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:34:\"a:1:{i:0;s:16:\"administer views\";}\";s:13:\"page_callback\";s:16:\"views_ui_preview\";s:14:\"page_arguments\";s:22:\"a:2:{i:0;i:5;i:1;i:6;}\";s:17:\"delivery_callback\";s:12:\"ajax_deliver\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:38:\"admin/structure/views/ajax/preview/%/%\";s:5:\"title\";s:0:\"\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:354;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"354\";s:4:\"plid\";s:3:\"319\";s:9:\"link_path\";s:38:\"admin/structure/views/nojs/preview/%/%\";s:11:\"router_path\";s:38:\"admin/structure/views/nojs/preview/%/%\";s:10:\"link_title\";s:0:\"\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:3:\"319\";s:2:\"p4\";s:3:\"354\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:43:\"a:2:{i:5;s:19:\"views_ui_cache_load\";i:6;N;}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:34:\"a:1:{i:0;s:16:\"administer views\";}\";s:13:\"page_callback\";s:16:\"views_ui_preview\";s:14:\"page_arguments\";s:22:\"a:2:{i:0;i:5;i:1;i:6;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:38:\"admin/structure/views/nojs/preview/%/%\";s:5:\"title\";s:0:\"\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}}}i:405;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"405\";s:4:\"plid\";s:2:\"20\";s:9:\"link_path\";s:23:\"admin/structure/contact\";s:11:\"router_path\";s:23:\"admin/structure/contact\";s:10:\"link_title\";s:12:\"Contact form\";s:7:\"options\";s:121:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:71:\"Create a system contact form and set up categories for the form to use.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"1\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:3:\"405\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:42:\"a:1:{i:0;s:24:\"administer contact forms\";}\";s:13:\"page_callback\";s:21:\"contact_category_list\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:23:\"admin/structure/contact\";s:5:\"title\";s:12:\"Contact form\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:71:\"Create a system contact form and set up categories for the form to use.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:3:{i:407;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"407\";s:4:\"plid\";s:3:\"405\";s:9:\"link_path\";s:27:\"admin/structure/contact/add\";s:11:\"router_path\";s:27:\"admin/structure/contact/add\";s:10:\"link_title\";s:12:\"Add category\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"1\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:3:\"405\";s:2:\"p4\";s:3:\"407\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:42:\"a:1:{i:0;s:24:\"administer contact forms\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:44:\"a:1:{i:0;s:26:\"contact_category_edit_form\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:23:\"admin/structure/contact\";s:8:\"tab_root\";s:23:\"admin/structure/contact\";s:5:\"title\";s:12:\"Add category\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"388\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:408;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"408\";s:4:\"plid\";s:3:\"405\";s:9:\"link_path\";s:32:\"admin/structure/contact/delete/%\";s:11:\"router_path\";s:32:\"admin/structure/contact/delete/%\";s:10:\"link_title\";s:14:\"Delete contact\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:3:\"405\";s:2:\"p4\";s:3:\"408\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:30:\"a:1:{i:4;s:12:\"contact_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:42:\"a:1:{i:0;s:24:\"administer contact forms\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:54:\"a:2:{i:0;s:28:\"contact_category_delete_form\";i:1;i:4;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:32:\"admin/structure/contact/delete/%\";s:5:\"title\";s:14:\"Delete contact\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:409;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"409\";s:4:\"plid\";s:3:\"405\";s:9:\"link_path\";s:30:\"admin/structure/contact/edit/%\";s:11:\"router_path\";s:30:\"admin/structure/contact/edit/%\";s:10:\"link_title\";s:21:\"Edit contact category\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:3:\"405\";s:2:\"p4\";s:3:\"409\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:30:\"a:1:{i:4;s:12:\"contact_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:42:\"a:1:{i:0;s:24:\"administer contact forms\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:52:\"a:2:{i:0;s:26:\"contact_category_edit_form\";i:1;i:4;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:30:\"admin/structure/contact/edit/%\";s:5:\"title\";s:21:\"Edit contact category\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}}}i:439;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"439\";s:4:\"plid\";s:2:\"20\";s:9:\"link_path\";s:24:\"admin/structure/messages\";s:11:\"router_path\";s:24:\"admin/structure/messages\";s:10:\"link_title\";s:13:\"Message types\";s:7:\"options\";s:71:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:21:\"Manage Message types.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"1\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:3:\"439\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:13:\"entity_access\";s:16:\"access_arguments\";s:45:\"a:2:{i:0;s:4:\"view\";i:1;s:12:\"message_type\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:68:\"a:2:{i:0;s:26:\"message_type_overview_form\";i:1;s:12:\"message_type\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:24:\"admin/structure/messages\";s:5:\"title\";s:13:\"Message types\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:21:\"Manage Message types.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:4:{i:441;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"441\";s:4:\"plid\";s:3:\"439\";s:9:\"link_path\";s:28:\"admin/structure/messages/add\";s:11:\"router_path\";s:28:\"admin/structure/messages/add\";s:10:\"link_title\";s:0:\"\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:3:\"439\";s:2:\"p4\";s:3:\"441\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:13:\"entity_access\";s:16:\"access_arguments\";s:47:\"a:2:{i:0;s:6:\"create\";i:1;s:12:\"message_type\";}\";s:13:\"page_callback\";s:18:\"entity_ui_get_form\";s:14:\"page_arguments\";s:50:\"a:3:{i:0;s:12:\"message_type\";i:1;N;i:2;s:3:\"add\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:24:\"admin/structure/messages\";s:8:\"tab_root\";s:24:\"admin/structure/messages\";s:5:\"title\";s:0:\"\";s:14:\"title_callback\";s:26:\"entity_ui_get_action_title\";s:15:\"title_arguments\";s:44:\"a:2:{i:0;s:3:\"add\";i:1;s:12:\"message_type\";}\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"388\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:442;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"442\";s:4:\"plid\";s:3:\"439\";s:9:\"link_path\";s:31:\"admin/structure/messages/import\";s:11:\"router_path\";s:31:\"admin/structure/messages/import\";s:10:\"link_title\";s:0:\"\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:3:\"439\";s:2:\"p4\";s:3:\"442\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:13:\"entity_access\";s:16:\"access_arguments\";s:47:\"a:2:{i:0;s:6:\"create\";i:1;s:12:\"message_type\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:92:\"a:4:{i:0;s:27:\"message_type_operation_form\";i:1;s:12:\"message_type\";i:2;N;i:3;s:6:\"import\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:24:\"admin/structure/messages\";s:8:\"tab_root\";s:24:\"admin/structure/messages\";s:5:\"title\";s:0:\"\";s:14:\"title_callback\";s:26:\"entity_ui_get_action_title\";s:15:\"title_arguments\";s:47:\"a:2:{i:0;s:6:\"import\";i:1;s:12:\"message_type\";}\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"388\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:443;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"443\";s:4:\"plid\";s:3:\"439\";s:9:\"link_path\";s:29:\"admin/structure/messages/list\";s:11:\"router_path\";s:29:\"admin/structure/messages/list\";s:10:\"link_title\";s:4:\"List\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:3:\"-10\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:3:\"439\";s:2:\"p4\";s:3:\"443\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:13:\"entity_access\";s:16:\"access_arguments\";s:45:\"a:2:{i:0;s:4:\"view\";i:1;s:12:\"message_type\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:68:\"a:2:{i:0;s:26:\"message_type_overview_form\";i:1;s:12:\"message_type\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:24:\"admin/structure/messages\";s:8:\"tab_root\";s:24:\"admin/structure/messages\";s:5:\"title\";s:4:\"List\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"140\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:446;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"446\";s:4:\"plid\";s:3:\"439\";s:9:\"link_path\";s:33:\"admin/structure/messages/manage/%\";s:11:\"router_path\";s:33:\"admin/structure/messages/manage/%\";s:10:\"link_title\";s:4:\"Edit\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"1\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:3:\"439\";s:2:\"p4\";s:3:\"446\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:72:\"a:1:{i:4;a:1:{s:18:\"entity_object_load\";a:1:{i:0;s:12:\"message_type\";}}}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:13:\"entity_access\";s:16:\"access_arguments\";s:55:\"a:3:{i:0;s:6:\"update\";i:1;s:12:\"message_type\";i:2;i:4;}\";s:13:\"page_callback\";s:18:\"entity_ui_get_form\";s:14:\"page_arguments\";s:38:\"a:2:{i:0;s:12:\"message_type\";i:1;i:4;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:33:\"admin/structure/messages/manage/%\";s:5:\"title\";s:4:\"Edit\";s:14:\"title_callback\";s:12:\"entity_label\";s:15:\"title_arguments\";s:38:\"a:2:{i:0;s:12:\"message_type\";i:1;i:4;}\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:5:{i:447;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"447\";s:4:\"plid\";s:3:\"446\";s:9:\"link_path\";s:35:\"admin/structure/messages/manage/%/%\";s:11:\"router_path\";s:35:\"admin/structure/messages/manage/%/%\";s:10:\"link_title\";s:0:\"\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:3:\"439\";s:2:\"p4\";s:3:\"446\";s:2:\"p5\";s:3:\"447\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:78:\"a:2:{i:4;a:1:{s:18:\"entity_object_load\";a:1:{i:0;s:12:\"message_type\";}}i:5;N;}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:13:\"entity_access\";s:16:\"access_arguments\";s:55:\"a:3:{i:0;s:6:\"delete\";i:1;s:12:\"message_type\";i:2;i:4;}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:85:\"a:4:{i:0;s:27:\"message_type_operation_form\";i:1;s:12:\"message_type\";i:2;i:4;i:3;i:5;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:35:\"admin/structure/messages/manage/%/%\";s:5:\"title\";s:0:\"\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:448;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"448\";s:4:\"plid\";s:3:\"446\";s:9:\"link_path\";s:39:\"admin/structure/messages/manage/%/clone\";s:11:\"router_path\";s:39:\"admin/structure/messages/manage/%/clone\";s:10:\"link_title\";s:5:\"Clone\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:3:\"439\";s:2:\"p4\";s:3:\"446\";s:2:\"p5\";s:3:\"448\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:72:\"a:1:{i:4;a:1:{s:18:\"entity_object_load\";a:1:{i:0;s:12:\"message_type\";}}}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:13:\"entity_access\";s:16:\"access_arguments\";s:47:\"a:2:{i:0;s:6:\"create\";i:1;s:12:\"message_type\";}\";s:13:\"page_callback\";s:18:\"entity_ui_get_form\";s:14:\"page_arguments\";s:54:\"a:3:{i:0;s:12:\"message_type\";i:1;i:4;i:2;s:5:\"clone\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:39:\"admin/structure/messages/manage/%/clone\";s:5:\"title\";s:5:\"Clone\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:449;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"449\";s:4:\"plid\";s:3:\"446\";s:9:\"link_path\";s:38:\"admin/structure/messages/manage/%/edit\";s:11:\"router_path\";s:38:\"admin/structure/messages/manage/%/edit\";s:10:\"link_title\";s:4:\"Edit\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:3:\"439\";s:2:\"p4\";s:3:\"446\";s:2:\"p5\";s:3:\"449\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:72:\"a:1:{i:4;a:1:{s:18:\"entity_object_load\";a:1:{i:0;s:12:\"message_type\";}}}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:13:\"entity_access\";s:16:\"access_arguments\";s:55:\"a:3:{i:0;s:6:\"update\";i:1;s:12:\"message_type\";i:2;i:4;}\";s:13:\"page_callback\";s:18:\"entity_ui_get_form\";s:14:\"page_arguments\";s:38:\"a:2:{i:0;s:12:\"message_type\";i:1;i:4;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:33:\"admin/structure/messages/manage/%\";s:8:\"tab_root\";s:33:\"admin/structure/messages/manage/%\";s:5:\"title\";s:4:\"Edit\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"140\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:929;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"929\";s:4:\"plid\";s:3:\"446\";s:9:\"link_path\";s:41:\"admin/structure/messages/manage/%/display\";s:11:\"router_path\";s:41:\"admin/structure/messages/manage/%/display\";s:10:\"link_title\";s:14:\"Manage display\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"2\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:3:\"439\";s:2:\"p4\";s:3:\"446\";s:2:\"p5\";s:3:\"929\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:35:\"a:1:{i:4;s:17:\"message_type_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:21:\"field_ui_admin_access\";s:16:\"access_arguments\";s:75:\"a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:24:\"administer message types\";}}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:92:\"a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:7:\"message\";i:2;i:4;i:3;s:7:\"default\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:33:\"admin/structure/messages/manage/%\";s:8:\"tab_root\";s:33:\"admin/structure/messages/manage/%\";s:5:\"title\";s:14:\"Manage display\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:3:{i:941;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"941\";s:4:\"plid\";s:3:\"929\";s:9:\"link_path\";s:49:\"admin/structure/messages/manage/%/display/default\";s:11:\"router_path\";s:49:\"admin/structure/messages/manage/%/display/default\";s:10:\"link_title\";s:7:\"Default\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:3:\"-10\";s:5:\"depth\";s:1:\"6\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:3:\"439\";s:2:\"p4\";s:3:\"446\";s:2:\"p5\";s:3:\"929\";s:2:\"p6\";s:3:\"941\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:35:\"a:1:{i:4;s:17:\"message_type_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:31:\"_field_ui_view_mode_menu_access\";s:16:\"access_arguments\";s:152:\"a:6:{i:0;s:7:\"message\";i:1;i:4;i:2;s:7:\"default\";i:3;s:21:\"field_ui_admin_access\";i:4;s:11:\"user_access\";i:5;a:1:{i:0;s:24:\"administer message types\";}}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:92:\"a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:7:\"message\";i:2;i:4;i:3;s:7:\"default\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:41:\"admin/structure/messages/manage/%/display\";s:8:\"tab_root\";s:33:\"admin/structure/messages/manage/%\";s:5:\"title\";s:7:\"Default\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"140\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:943;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"943\";s:4:\"plid\";s:3:\"929\";s:9:\"link_path\";s:46:\"admin/structure/messages/manage/%/display/full\";s:11:\"router_path\";s:46:\"admin/structure/messages/manage/%/display/full\";s:10:\"link_title\";s:4:\"Full\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"6\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:3:\"439\";s:2:\"p4\";s:3:\"446\";s:2:\"p5\";s:3:\"929\";s:2:\"p6\";s:3:\"943\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:35:\"a:1:{i:4;s:17:\"message_type_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:31:\"_field_ui_view_mode_menu_access\";s:16:\"access_arguments\";s:149:\"a:6:{i:0;s:7:\"message\";i:1;i:4;i:2;s:4:\"full\";i:3;s:21:\"field_ui_admin_access\";i:4;s:11:\"user_access\";i:5;a:1:{i:0;s:24:\"administer message types\";}}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:89:\"a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:7:\"message\";i:2;i:4;i:3;s:4:\"full\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:41:\"admin/structure/messages/manage/%/display\";s:8:\"tab_root\";s:33:\"admin/structure/messages/manage/%\";s:5:\"title\";s:4:\"Full\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:950;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"950\";s:4:\"plid\";s:3:\"929\";s:9:\"link_path\";s:47:\"admin/structure/messages/manage/%/display/token\";s:11:\"router_path\";s:47:\"admin/structure/messages/manage/%/display/token\";s:10:\"link_title\";s:6:\"Tokens\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"1\";s:5:\"depth\";s:1:\"6\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:3:\"439\";s:2:\"p4\";s:3:\"446\";s:2:\"p5\";s:3:\"929\";s:2:\"p6\";s:3:\"950\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:35:\"a:1:{i:4;s:17:\"message_type_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:31:\"_field_ui_view_mode_menu_access\";s:16:\"access_arguments\";s:150:\"a:6:{i:0;s:7:\"message\";i:1;i:4;i:2;s:5:\"token\";i:3;s:21:\"field_ui_admin_access\";i:4;s:11:\"user_access\";i:5;a:1:{i:0;s:24:\"administer message types\";}}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:90:\"a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:7:\"message\";i:2;i:4;i:3;s:5:\"token\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:41:\"admin/structure/messages/manage/%/display\";s:8:\"tab_root\";s:33:\"admin/structure/messages/manage/%\";s:5:\"title\";s:6:\"Tokens\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}}}i:931;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"931\";s:4:\"plid\";s:3:\"446\";s:9:\"link_path\";s:40:\"admin/structure/messages/manage/%/fields\";s:11:\"router_path\";s:40:\"admin/structure/messages/manage/%/fields\";s:10:\"link_title\";s:13:\"Manage fields\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"1\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"1\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:3:\"439\";s:2:\"p4\";s:3:\"446\";s:2:\"p5\";s:3:\"931\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:35:\"a:1:{i:4;s:17:\"message_type_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:21:\"field_ui_admin_access\";s:16:\"access_arguments\";s:75:\"a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:24:\"administer message types\";}}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:72:\"a:3:{i:0;s:28:\"field_ui_field_overview_form\";i:1;s:7:\"message\";i:2;i:4;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:33:\"admin/structure/messages/manage/%\";s:8:\"tab_root\";s:33:\"admin/structure/messages/manage/%\";s:5:\"title\";s:13:\"Manage fields\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:1:{i:956;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"956\";s:4:\"plid\";s:3:\"931\";s:9:\"link_path\";s:42:\"admin/structure/messages/manage/%/fields/%\";s:11:\"router_path\";s:42:\"admin/structure/messages/manage/%/fields/%\";s:10:\"link_title\";s:0:\"\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"6\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:3:\"439\";s:2:\"p4\";s:3:\"446\";s:2:\"p5\";s:3:\"931\";s:2:\"p6\";s:3:\"956\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:195:\"a:2:{i:4;a:1:{s:17:\"message_type_load\";a:4:{i:0;s:7:\"message\";i:1;i:4;i:2;s:1:\"4\";i:3;s:4:\"%map\";}}i:6;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:7:\"message\";i:1;i:4;i:2;s:1:\"4\";i:3;s:4:\"%map\";}}}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:21:\"field_ui_admin_access\";s:16:\"access_arguments\";s:75:\"a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:24:\"administer message types\";}}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:50:\"a:2:{i:0;s:24:\"field_ui_field_edit_form\";i:1;i:6;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:42:\"admin/structure/messages/manage/%/fields/%\";s:5:\"title\";s:0:\"\";s:14:\"title_callback\";s:19:\"field_ui_menu_title\";s:15:\"title_arguments\";s:14:\"a:1:{i:0;i:6;}\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:4:{i:970;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"970\";s:4:\"plid\";s:3:\"956\";s:9:\"link_path\";s:49:\"admin/structure/messages/manage/%/fields/%/delete\";s:11:\"router_path\";s:49:\"admin/structure/messages/manage/%/fields/%/delete\";s:10:\"link_title\";s:6:\"Delete\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:2:\"10\";s:5:\"depth\";s:1:\"7\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:3:\"439\";s:2:\"p4\";s:3:\"446\";s:2:\"p5\";s:3:\"931\";s:2:\"p6\";s:3:\"956\";s:2:\"p7\";s:3:\"970\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:195:\"a:2:{i:4;a:1:{s:17:\"message_type_load\";a:4:{i:0;s:7:\"message\";i:1;i:4;i:2;s:1:\"4\";i:3;s:4:\"%map\";}}i:6;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:7:\"message\";i:1;i:4;i:2;s:1:\"4\";i:3;s:4:\"%map\";}}}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:21:\"field_ui_admin_access\";s:16:\"access_arguments\";s:75:\"a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:24:\"administer message types\";}}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:52:\"a:2:{i:0;s:26:\"field_ui_field_delete_form\";i:1;i:6;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:42:\"admin/structure/messages/manage/%/fields/%\";s:8:\"tab_root\";s:42:\"admin/structure/messages/manage/%/fields/%\";s:5:\"title\";s:6:\"Delete\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:973;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"973\";s:4:\"plid\";s:3:\"956\";s:9:\"link_path\";s:47:\"admin/structure/messages/manage/%/fields/%/edit\";s:11:\"router_path\";s:47:\"admin/structure/messages/manage/%/fields/%/edit\";s:10:\"link_title\";s:4:\"Edit\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"7\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:3:\"439\";s:2:\"p4\";s:3:\"446\";s:2:\"p5\";s:3:\"931\";s:2:\"p6\";s:3:\"956\";s:2:\"p7\";s:3:\"973\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:195:\"a:2:{i:4;a:1:{s:17:\"message_type_load\";a:4:{i:0;s:7:\"message\";i:1;i:4;i:2;s:1:\"4\";i:3;s:4:\"%map\";}}i:6;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:7:\"message\";i:1;i:4;i:2;s:1:\"4\";i:3;s:4:\"%map\";}}}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:21:\"field_ui_admin_access\";s:16:\"access_arguments\";s:75:\"a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:24:\"administer message types\";}}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:50:\"a:2:{i:0;s:24:\"field_ui_field_edit_form\";i:1;i:6;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:42:\"admin/structure/messages/manage/%/fields/%\";s:8:\"tab_root\";s:42:\"admin/structure/messages/manage/%/fields/%\";s:5:\"title\";s:4:\"Edit\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"140\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:974;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"974\";s:4:\"plid\";s:3:\"956\";s:9:\"link_path\";s:57:\"admin/structure/messages/manage/%/fields/%/field-settings\";s:11:\"router_path\";s:57:\"admin/structure/messages/manage/%/fields/%/field-settings\";s:10:\"link_title\";s:14:\"Field settings\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"7\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:3:\"439\";s:2:\"p4\";s:3:\"446\";s:2:\"p5\";s:3:\"931\";s:2:\"p6\";s:3:\"956\";s:2:\"p7\";s:3:\"974\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:195:\"a:2:{i:4;a:1:{s:17:\"message_type_load\";a:4:{i:0;s:7:\"message\";i:1;i:4;i:2;s:1:\"4\";i:3;s:4:\"%map\";}}i:6;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:7:\"message\";i:1;i:4;i:2;s:1:\"4\";i:3;s:4:\"%map\";}}}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:21:\"field_ui_admin_access\";s:16:\"access_arguments\";s:75:\"a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:24:\"administer message types\";}}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:54:\"a:2:{i:0;s:28:\"field_ui_field_settings_form\";i:1;i:6;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:42:\"admin/structure/messages/manage/%/fields/%\";s:8:\"tab_root\";s:42:\"admin/structure/messages/manage/%/fields/%\";s:5:\"title\";s:14:\"Field settings\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:975;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"975\";s:4:\"plid\";s:3:\"956\";s:9:\"link_path\";s:54:\"admin/structure/messages/manage/%/fields/%/widget-type\";s:11:\"router_path\";s:54:\"admin/structure/messages/manage/%/fields/%/widget-type\";s:10:\"link_title\";s:11:\"Widget type\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"7\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:3:\"439\";s:2:\"p4\";s:3:\"446\";s:2:\"p5\";s:3:\"931\";s:2:\"p6\";s:3:\"956\";s:2:\"p7\";s:3:\"975\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:195:\"a:2:{i:4;a:1:{s:17:\"message_type_load\";a:4:{i:0;s:7:\"message\";i:1;i:4;i:2;s:1:\"4\";i:3;s:4:\"%map\";}}i:6;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:7:\"message\";i:1;i:4;i:2;s:1:\"4\";i:3;s:4:\"%map\";}}}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:21:\"field_ui_admin_access\";s:16:\"access_arguments\";s:75:\"a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:24:\"administer message types\";}}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:51:\"a:2:{i:0;s:25:\"field_ui_widget_type_form\";i:1;i:6;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:42:\"admin/structure/messages/manage/%/fields/%\";s:8:\"tab_root\";s:42:\"admin/structure/messages/manage/%/fields/%\";s:5:\"title\";s:11:\"Widget type\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}}}}}}}}}i:451;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"451\";s:4:\"plid\";s:2:\"20\";s:9:\"link_path\";s:24:\"admin/structure/features\";s:11:\"router_path\";s:24:\"admin/structure/features\";s:10:\"link_title\";s:8:\"Features\";s:7:\"options\";s:66:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:16:\"Manage features.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:3:\"451\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:33:\"a:1:{i:0;s:15:\"manage features\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:37:\"a:1:{i:0;s:19:\"features_admin_form\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:24:\"admin/structure/features\";s:5:\"title\";s:8:\"Features\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:16:\"Manage features.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:5:{i:455;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"455\";s:4:\"plid\";s:3:\"451\";s:9:\"link_path\";s:31:\"admin/structure/features/create\";s:11:\"router_path\";s:31:\"admin/structure/features/create\";s:10:\"link_title\";s:14:\"Create feature\";s:7:\"options\";s:71:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:21:\"Create a new feature.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:2:\"10\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:3:\"451\";s:2:\"p4\";s:3:\"455\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:37:\"a:1:{i:0;s:19:\"administer features\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:38:\"a:1:{i:0;s:20:\"features_export_form\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:24:\"admin/structure/features\";s:8:\"tab_root\";s:24:\"admin/structure/features\";s:5:\"title\";s:14:\"Create feature\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:21:\"Create a new feature.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:456;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"456\";s:4:\"plid\";s:3:\"451\";s:9:\"link_path\";s:31:\"admin/structure/features/manage\";s:11:\"router_path\";s:31:\"admin/structure/features/manage\";s:10:\"link_title\";s:6:\"Manage\";s:7:\"options\";s:78:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:28:\"Enable and disable features.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:3:\"451\";s:2:\"p4\";s:3:\"456\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:33:\"a:1:{i:0;s:15:\"manage features\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:37:\"a:1:{i:0;s:19:\"features_admin_form\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:24:\"admin/structure/features\";s:8:\"tab_root\";s:24:\"admin/structure/features\";s:5:\"title\";s:6:\"Manage\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"140\";s:11:\"description\";s:28:\"Enable and disable features.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:457;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"457\";s:4:\"plid\";s:3:\"451\";s:9:\"link_path\";s:33:\"admin/structure/features/settings\";s:11:\"router_path\";s:33:\"admin/structure/features/settings\";s:10:\"link_title\";s:8:\"Settings\";s:7:\"options\";s:92:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:42:\"Adjust settings for using features module.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:2:\"11\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:3:\"451\";s:2:\"p4\";s:3:\"457\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:37:\"a:1:{i:0;s:19:\"administer features\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:40:\"a:1:{i:0;s:22:\"features_settings_form\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:24:\"admin/structure/features\";s:8:\"tab_root\";s:24:\"admin/structure/features\";s:5:\"title\";s:8:\"Settings\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:42:\"Adjust settings for using features module.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:459;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"459\";s:4:\"plid\";s:3:\"451\";s:9:\"link_path\";s:31:\"admin/structure/features/%/view\";s:11:\"router_path\";s:31:\"admin/structure/features/%/view\";s:10:\"link_title\";s:4:\"View\";s:7:\"options\";s:82:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:32:\"Display components of a feature.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:3:\"-10\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:3:\"451\";s:2:\"p4\";s:3:\"459\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:50:\"a:1:{i:3;a:1:{s:12:\"feature_load\";a:1:{i:0;b:1;}}}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:37:\"a:1:{i:0;s:19:\"administer features\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:51:\"a:2:{i:0;s:25:\"features_admin_components\";i:1;i:3;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:26:\"admin/structure/features/%\";s:8:\"tab_root\";s:26:\"admin/structure/features/%\";s:5:\"title\";s:4:\"View\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"140\";s:11:\"description\";s:32:\"Display components of a feature.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:460;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"460\";s:4:\"plid\";s:3:\"451\";s:9:\"link_path\";s:35:\"admin/structure/features/%/recreate\";s:11:\"router_path\";s:35:\"admin/structure/features/%/recreate\";s:10:\"link_title\";s:8:\"Recreate\";s:7:\"options\";s:79:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:29:\"Recreate an existing feature.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:2:\"11\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:3:\"451\";s:2:\"p4\";s:3:\"460\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:50:\"a:1:{i:3;a:1:{s:12:\"feature_load\";a:1:{i:0;b:1;}}}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:37:\"a:1:{i:0;s:19:\"administer features\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:46:\"a:2:{i:0;s:20:\"features_export_form\";i:1;i:3;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:26:\"admin/structure/features/%\";s:8:\"tab_root\";s:26:\"admin/structure/features/%\";s:5:\"title\";s:8:\"Recreate\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:29:\"Recreate an existing feature.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}}}i:508;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"508\";s:4:\"plid\";s:2:\"20\";s:9:\"link_path\";s:25:\"admin/structure/quicktabs\";s:11:\"router_path\";s:25:\"admin/structure/quicktabs\";s:10:\"link_title\";s:9:\"Quicktabs\";s:7:\"options\";s:82:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:32:\"Create blocks of tabbed content.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"1\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:3:\"508\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:38:\"a:1:{i:0;s:20:\"administer quicktabs\";}\";s:13:\"page_callback\";s:14:\"quicktabs_list\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:25:\"admin/structure/quicktabs\";s:5:\"title\";s:9:\"Quicktabs\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:32:\"Create blocks of tabbed content.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:3:{i:510;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"510\";s:4:\"plid\";s:3:\"508\";s:9:\"link_path\";s:29:\"admin/structure/quicktabs/add\";s:11:\"router_path\";s:29:\"admin/structure/quicktabs/add\";s:10:\"link_title\";s:22:\"Add Quicktabs Instance\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:3:\"508\";s:2:\"p4\";s:3:\"510\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:38:\"a:1:{i:0;s:20:\"administer quicktabs\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:46:\"a:2:{i:0;s:14:\"quicktabs_form\";i:1;s:3:\"add\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:25:\"admin/structure/quicktabs\";s:8:\"tab_root\";s:25:\"admin/structure/quicktabs\";s:5:\"title\";s:22:\"Add Quicktabs Instance\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"388\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:511;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"511\";s:4:\"plid\";s:3:\"508\";s:9:\"link_path\";s:30:\"admin/structure/quicktabs/list\";s:11:\"router_path\";s:30:\"admin/structure/quicktabs/list\";s:10:\"link_title\";s:14:\"List quicktabs\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:3:\"508\";s:2:\"p4\";s:3:\"511\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:38:\"a:1:{i:0;s:20:\"administer quicktabs\";}\";s:13:\"page_callback\";s:14:\"quicktabs_list\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:25:\"admin/structure/quicktabs\";s:8:\"tab_root\";s:25:\"admin/structure/quicktabs\";s:5:\"title\";s:14:\"List quicktabs\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"140\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:512;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"512\";s:4:\"plid\";s:3:\"508\";s:9:\"link_path\";s:34:\"admin/structure/quicktabs/manage/%\";s:11:\"router_path\";s:34:\"admin/structure/quicktabs/manage/%\";s:10:\"link_title\";s:13:\"Edit quicktab\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:3:\"508\";s:2:\"p4\";s:3:\"512\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:32:\"a:1:{i:4;s:14:\"quicktabs_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:38:\"a:1:{i:0;s:20:\"administer quicktabs\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:55:\"a:3:{i:0;s:14:\"quicktabs_form\";i:1;s:4:\"edit\";i:2;i:4;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:34:\"admin/structure/quicktabs/manage/%\";s:5:\"title\";s:13:\"Edit quicktab\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:4:{i:513;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"513\";s:4:\"plid\";s:3:\"512\";s:9:\"link_path\";s:40:\"admin/structure/quicktabs/manage/%/clone\";s:11:\"router_path\";s:40:\"admin/structure/quicktabs/manage/%/clone\";s:10:\"link_title\";s:14:\"Clone quicktab\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:3:\"508\";s:2:\"p4\";s:3:\"512\";s:2:\"p5\";s:3:\"513\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:32:\"a:1:{i:4;s:14:\"quicktabs_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:38:\"a:1:{i:0;s:20:\"administer quicktabs\";}\";s:13:\"page_callback\";s:15:\"quicktabs_clone\";s:14:\"page_arguments\";s:14:\"a:1:{i:0;i:4;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:34:\"admin/structure/quicktabs/manage/%\";s:8:\"tab_root\";s:34:\"admin/structure/quicktabs/manage/%\";s:5:\"title\";s:14:\"Clone quicktab\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:514;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"514\";s:4:\"plid\";s:3:\"512\";s:9:\"link_path\";s:41:\"admin/structure/quicktabs/manage/%/delete\";s:11:\"router_path\";s:41:\"admin/structure/quicktabs/manage/%/delete\";s:10:\"link_title\";s:15:\"Delete quicktab\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:3:\"508\";s:2:\"p4\";s:3:\"512\";s:2:\"p5\";s:3:\"514\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:32:\"a:1:{i:4;s:14:\"quicktabs_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:38:\"a:1:{i:0;s:20:\"administer quicktabs\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:48:\"a:2:{i:0;s:22:\"quicktabs_block_delete\";i:1;i:4;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:34:\"admin/structure/quicktabs/manage/%\";s:8:\"tab_root\";s:34:\"admin/structure/quicktabs/manage/%\";s:5:\"title\";s:15:\"Delete quicktab\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:515;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"515\";s:4:\"plid\";s:3:\"512\";s:9:\"link_path\";s:39:\"admin/structure/quicktabs/manage/%/edit\";s:11:\"router_path\";s:39:\"admin/structure/quicktabs/manage/%/edit\";s:10:\"link_title\";s:13:\"Edit quicktab\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:3:\"508\";s:2:\"p4\";s:3:\"512\";s:2:\"p5\";s:3:\"515\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:32:\"a:1:{i:4;s:14:\"quicktabs_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:38:\"a:1:{i:0;s:20:\"administer quicktabs\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:55:\"a:3:{i:0;s:14:\"quicktabs_form\";i:1;s:4:\"edit\";i:2;i:4;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:34:\"admin/structure/quicktabs/manage/%\";s:8:\"tab_root\";s:34:\"admin/structure/quicktabs/manage/%\";s:5:\"title\";s:13:\"Edit quicktab\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"140\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:516;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"516\";s:4:\"plid\";s:3:\"512\";s:9:\"link_path\";s:41:\"admin/structure/quicktabs/manage/%/export\";s:11:\"router_path\";s:41:\"admin/structure/quicktabs/manage/%/export\";s:10:\"link_title\";s:6:\"Export\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:3:\"508\";s:2:\"p4\";s:3:\"512\";s:2:\"p5\";s:3:\"516\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:32:\"a:1:{i:4;s:14:\"quicktabs_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:38:\"a:1:{i:0;s:20:\"administer quicktabs\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:47:\"a:2:{i:0;s:21:\"quicktabs_export_form\";i:1;i:4;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:34:\"admin/structure/quicktabs/manage/%\";s:8:\"tab_root\";s:34:\"admin/structure/quicktabs/manage/%\";s:5:\"title\";s:6:\"Export\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}}}}}i:639;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"639\";s:4:\"plid\";s:2:\"20\";s:9:\"link_path\";s:33:\"admin/structure/field-collections\";s:11:\"router_path\";s:33:\"admin/structure/field-collections\";s:10:\"link_title\";s:17:\"Field collections\";s:7:\"options\";s:85:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:35:\"Manage fields on field collections.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"1\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:3:\"639\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:46:\"a:1:{i:0;s:28:\"administer field collections\";}\";s:13:\"page_callback\";s:26:\"field_collections_overview\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:33:\"admin/structure/field-collections\";s:5:\"title\";s:17:\"Field collections\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:35:\"Manage fields on field collections.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:1:{i:918;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"918\";s:4:\"plid\";s:3:\"639\";s:9:\"link_path\";s:35:\"admin/structure/field-collections/%\";s:11:\"router_path\";s:35:\"admin/structure/field-collections/%\";s:10:\"link_title\";s:13:\"Manage fields\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"1\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:3:\"639\";s:2:\"p4\";s:3:\"918\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:50:\"a:1:{i:3;s:32:\"field_collection_field_name_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:21:\"field_ui_admin_access\";s:16:\"access_arguments\";s:79:\"a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:28:\"administer field collections\";}}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:87:\"a:3:{i:0;s:28:\"field_ui_field_overview_form\";i:1;s:21:\"field_collection_item\";i:2;i:3;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:35:\"admin/structure/field-collections/%\";s:5:\"title\";s:13:\"Manage fields\";s:14:\"title_callback\";s:33:\"field_collection_admin_page_title\";s:15:\"title_arguments\";s:14:\"a:1:{i:0;i:3;}\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:2:{i:919;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"919\";s:4:\"plid\";s:3:\"918\";s:9:\"link_path\";s:43:\"admin/structure/field-collections/%/display\";s:11:\"router_path\";s:43:\"admin/structure/field-collections/%/display\";s:10:\"link_title\";s:14:\"Manage display\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"2\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:3:\"639\";s:2:\"p4\";s:3:\"918\";s:2:\"p5\";s:3:\"919\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:50:\"a:1:{i:3;s:32:\"field_collection_field_name_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:21:\"field_ui_admin_access\";s:16:\"access_arguments\";s:79:\"a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:28:\"administer field collections\";}}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:107:\"a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:21:\"field_collection_item\";i:2;i:3;i:3;s:7:\"default\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:35:\"admin/structure/field-collections/%\";s:8:\"tab_root\";s:35:\"admin/structure/field-collections/%\";s:5:\"title\";s:14:\"Manage display\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:3:{i:925;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"925\";s:4:\"plid\";s:3:\"919\";s:9:\"link_path\";s:51:\"admin/structure/field-collections/%/display/default\";s:11:\"router_path\";s:51:\"admin/structure/field-collections/%/display/default\";s:10:\"link_title\";s:7:\"Default\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:3:\"-10\";s:5:\"depth\";s:1:\"6\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:3:\"639\";s:2:\"p4\";s:3:\"918\";s:2:\"p5\";s:3:\"919\";s:2:\"p6\";s:3:\"925\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:50:\"a:1:{i:3;s:32:\"field_collection_field_name_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:31:\"_field_ui_view_mode_menu_access\";s:16:\"access_arguments\";s:171:\"a:6:{i:0;s:21:\"field_collection_item\";i:1;i:3;i:2;s:7:\"default\";i:3;s:21:\"field_ui_admin_access\";i:4;s:11:\"user_access\";i:5;a:1:{i:0;s:28:\"administer field collections\";}}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:107:\"a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:21:\"field_collection_item\";i:2;i:3;i:3;s:7:\"default\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:43:\"admin/structure/field-collections/%/display\";s:8:\"tab_root\";s:35:\"admin/structure/field-collections/%\";s:5:\"title\";s:7:\"Default\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"140\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:928;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"928\";s:4:\"plid\";s:3:\"919\";s:9:\"link_path\";s:48:\"admin/structure/field-collections/%/display/full\";s:11:\"router_path\";s:48:\"admin/structure/field-collections/%/display/full\";s:10:\"link_title\";s:12:\"Full content\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"6\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:3:\"639\";s:2:\"p4\";s:3:\"918\";s:2:\"p5\";s:3:\"919\";s:2:\"p6\";s:3:\"928\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:50:\"a:1:{i:3;s:32:\"field_collection_field_name_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:31:\"_field_ui_view_mode_menu_access\";s:16:\"access_arguments\";s:168:\"a:6:{i:0;s:21:\"field_collection_item\";i:1;i:3;i:2;s:4:\"full\";i:3;s:21:\"field_ui_admin_access\";i:4;s:11:\"user_access\";i:5;a:1:{i:0;s:28:\"administer field collections\";}}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:104:\"a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:21:\"field_collection_item\";i:2;i:3;i:3;s:4:\"full\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:43:\"admin/structure/field-collections/%/display\";s:8:\"tab_root\";s:35:\"admin/structure/field-collections/%\";s:5:\"title\";s:12:\"Full content\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:934;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"934\";s:4:\"plid\";s:3:\"919\";s:9:\"link_path\";s:49:\"admin/structure/field-collections/%/display/token\";s:11:\"router_path\";s:49:\"admin/structure/field-collections/%/display/token\";s:10:\"link_title\";s:6:\"Tokens\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"1\";s:5:\"depth\";s:1:\"6\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:3:\"639\";s:2:\"p4\";s:3:\"918\";s:2:\"p5\";s:3:\"919\";s:2:\"p6\";s:3:\"934\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:50:\"a:1:{i:3;s:32:\"field_collection_field_name_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:31:\"_field_ui_view_mode_menu_access\";s:16:\"access_arguments\";s:169:\"a:6:{i:0;s:21:\"field_collection_item\";i:1;i:3;i:2;s:5:\"token\";i:3;s:21:\"field_ui_admin_access\";i:4;s:11:\"user_access\";i:5;a:1:{i:0;s:28:\"administer field collections\";}}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:105:\"a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:21:\"field_collection_item\";i:2;i:3;i:3;s:5:\"token\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:43:\"admin/structure/field-collections/%/display\";s:8:\"tab_root\";s:35:\"admin/structure/field-collections/%\";s:5:\"title\";s:6:\"Tokens\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}}}i:922;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"922\";s:4:\"plid\";s:3:\"918\";s:9:\"link_path\";s:42:\"admin/structure/field-collections/%/fields\";s:11:\"router_path\";s:42:\"admin/structure/field-collections/%/fields\";s:10:\"link_title\";s:13:\"Manage fields\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"1\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"1\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:3:\"639\";s:2:\"p4\";s:3:\"918\";s:2:\"p5\";s:3:\"922\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:50:\"a:1:{i:3;s:32:\"field_collection_field_name_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:21:\"field_ui_admin_access\";s:16:\"access_arguments\";s:79:\"a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:28:\"administer field collections\";}}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:87:\"a:3:{i:0;s:28:\"field_ui_field_overview_form\";i:1;s:21:\"field_collection_item\";i:2;i:3;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:35:\"admin/structure/field-collections/%\";s:8:\"tab_root\";s:35:\"admin/structure/field-collections/%\";s:5:\"title\";s:13:\"Manage fields\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"140\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:1:{i:939;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"939\";s:4:\"plid\";s:3:\"922\";s:9:\"link_path\";s:44:\"admin/structure/field-collections/%/fields/%\";s:11:\"router_path\";s:44:\"admin/structure/field-collections/%/fields/%\";s:10:\"link_title\";s:0:\"\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"6\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:3:\"639\";s:2:\"p4\";s:3:\"918\";s:2:\"p5\";s:3:\"922\";s:2:\"p6\";s:3:\"939\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:240:\"a:2:{i:3;a:1:{s:32:\"field_collection_field_name_load\";a:4:{i:0;s:21:\"field_collection_item\";i:1;i:3;i:2;s:1:\"3\";i:3;s:4:\"%map\";}}i:5;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:21:\"field_collection_item\";i:1;i:3;i:2;s:1:\"3\";i:3;s:4:\"%map\";}}}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:21:\"field_ui_admin_access\";s:16:\"access_arguments\";s:79:\"a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:28:\"administer field collections\";}}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:50:\"a:2:{i:0;s:24:\"field_ui_field_edit_form\";i:1;i:5;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:44:\"admin/structure/field-collections/%/fields/%\";s:5:\"title\";s:0:\"\";s:14:\"title_callback\";s:19:\"field_ui_menu_title\";s:15:\"title_arguments\";s:14:\"a:1:{i:0;i:5;}\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:4:{i:952;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"952\";s:4:\"plid\";s:3:\"939\";s:9:\"link_path\";s:51:\"admin/structure/field-collections/%/fields/%/delete\";s:11:\"router_path\";s:51:\"admin/structure/field-collections/%/fields/%/delete\";s:10:\"link_title\";s:6:\"Delete\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:2:\"10\";s:5:\"depth\";s:1:\"7\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:3:\"639\";s:2:\"p4\";s:3:\"918\";s:2:\"p5\";s:3:\"922\";s:2:\"p6\";s:3:\"939\";s:2:\"p7\";s:3:\"952\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:240:\"a:2:{i:3;a:1:{s:32:\"field_collection_field_name_load\";a:4:{i:0;s:21:\"field_collection_item\";i:1;i:3;i:2;s:1:\"3\";i:3;s:4:\"%map\";}}i:5;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:21:\"field_collection_item\";i:1;i:3;i:2;s:1:\"3\";i:3;s:4:\"%map\";}}}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:21:\"field_ui_admin_access\";s:16:\"access_arguments\";s:79:\"a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:28:\"administer field collections\";}}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:52:\"a:2:{i:0;s:26:\"field_ui_field_delete_form\";i:1;i:5;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:44:\"admin/structure/field-collections/%/fields/%\";s:8:\"tab_root\";s:44:\"admin/structure/field-collections/%/fields/%\";s:5:\"title\";s:6:\"Delete\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:953;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"953\";s:4:\"plid\";s:3:\"939\";s:9:\"link_path\";s:49:\"admin/structure/field-collections/%/fields/%/edit\";s:11:\"router_path\";s:49:\"admin/structure/field-collections/%/fields/%/edit\";s:10:\"link_title\";s:4:\"Edit\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"7\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:3:\"639\";s:2:\"p4\";s:3:\"918\";s:2:\"p5\";s:3:\"922\";s:2:\"p6\";s:3:\"939\";s:2:\"p7\";s:3:\"953\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:240:\"a:2:{i:3;a:1:{s:32:\"field_collection_field_name_load\";a:4:{i:0;s:21:\"field_collection_item\";i:1;i:3;i:2;s:1:\"3\";i:3;s:4:\"%map\";}}i:5;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:21:\"field_collection_item\";i:1;i:3;i:2;s:1:\"3\";i:3;s:4:\"%map\";}}}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:21:\"field_ui_admin_access\";s:16:\"access_arguments\";s:79:\"a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:28:\"administer field collections\";}}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:50:\"a:2:{i:0;s:24:\"field_ui_field_edit_form\";i:1;i:5;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:44:\"admin/structure/field-collections/%/fields/%\";s:8:\"tab_root\";s:44:\"admin/structure/field-collections/%/fields/%\";s:5:\"title\";s:4:\"Edit\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"140\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:954;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"954\";s:4:\"plid\";s:3:\"939\";s:9:\"link_path\";s:59:\"admin/structure/field-collections/%/fields/%/field-settings\";s:11:\"router_path\";s:59:\"admin/structure/field-collections/%/fields/%/field-settings\";s:10:\"link_title\";s:14:\"Field settings\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"7\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:3:\"639\";s:2:\"p4\";s:3:\"918\";s:2:\"p5\";s:3:\"922\";s:2:\"p6\";s:3:\"939\";s:2:\"p7\";s:3:\"954\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:240:\"a:2:{i:3;a:1:{s:32:\"field_collection_field_name_load\";a:4:{i:0;s:21:\"field_collection_item\";i:1;i:3;i:2;s:1:\"3\";i:3;s:4:\"%map\";}}i:5;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:21:\"field_collection_item\";i:1;i:3;i:2;s:1:\"3\";i:3;s:4:\"%map\";}}}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:21:\"field_ui_admin_access\";s:16:\"access_arguments\";s:79:\"a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:28:\"administer field collections\";}}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:54:\"a:2:{i:0;s:28:\"field_ui_field_settings_form\";i:1;i:5;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:44:\"admin/structure/field-collections/%/fields/%\";s:8:\"tab_root\";s:44:\"admin/structure/field-collections/%/fields/%\";s:5:\"title\";s:14:\"Field settings\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:955;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"955\";s:4:\"plid\";s:3:\"939\";s:9:\"link_path\";s:56:\"admin/structure/field-collections/%/fields/%/widget-type\";s:11:\"router_path\";s:56:\"admin/structure/field-collections/%/fields/%/widget-type\";s:10:\"link_title\";s:11:\"Widget type\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"7\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:3:\"639\";s:2:\"p4\";s:3:\"918\";s:2:\"p5\";s:3:\"922\";s:2:\"p6\";s:3:\"939\";s:2:\"p7\";s:3:\"955\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:240:\"a:2:{i:3;a:1:{s:32:\"field_collection_field_name_load\";a:4:{i:0;s:21:\"field_collection_item\";i:1;i:3;i:2;s:1:\"3\";i:3;s:4:\"%map\";}}i:5;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:21:\"field_collection_item\";i:1;i:3;i:2;s:1:\"3\";i:3;s:4:\"%map\";}}}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:21:\"field_ui_admin_access\";s:16:\"access_arguments\";s:79:\"a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:28:\"administer field collections\";}}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:51:\"a:2:{i:0;s:25:\"field_ui_widget_type_form\";i:1;i:5;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:44:\"admin/structure/field-collections/%/fields/%\";s:8:\"tab_root\";s:44:\"admin/structure/field-collections/%/fields/%\";s:5:\"title\";s:11:\"Widget type\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}}}}}}}}}i:676;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"676\";s:4:\"plid\";s:2:\"20\";s:9:\"link_path\";s:28:\"admin/structure/token-custom\";s:11:\"router_path\";s:28:\"admin/structure/token-custom\";s:10:\"link_title\";s:13:\"Custom tokens\";s:7:\"options\";s:77:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:27:\"Administrate custom tokens.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"1\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:3:\"676\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:36:\"a:1:{i:0;s:18:\"list custom tokens\";}\";s:13:\"page_callback\";s:22:\"token_custom_list_page\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:28:\"admin/structure/token-custom\";s:5:\"title\";s:13:\"Custom tokens\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:27:\"Administrate custom tokens.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:4:{i:678;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"678\";s:4:\"plid\";s:3:\"676\";s:9:\"link_path\";s:32:\"admin/structure/token-custom/add\";s:11:\"router_path\";s:32:\"admin/structure/token-custom/add\";s:10:\"link_title\";s:9:\"Add token\";s:7:\"options\";s:70:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:20:\"Create custom tokens\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"1\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:3:\"676\";s:2:\"p4\";s:3:\"678\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:42:\"a:1:{i:0;s:24:\"administer custom tokens\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:54:\"a:2:{i:0;s:22:\"token_custom_edit_form\";i:1;s:3:\"add\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:28:\"admin/structure/token-custom\";s:8:\"tab_root\";s:28:\"admin/structure/token-custom\";s:5:\"title\";s:9:\"Add token\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"388\";s:11:\"description\";s:20:\"Create custom tokens\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:679;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"679\";s:4:\"plid\";s:3:\"676\";s:9:\"link_path\";s:33:\"admin/structure/token-custom/type\";s:11:\"router_path\";s:33:\"admin/structure/token-custom/type\";s:10:\"link_title\";s:18:\"Custom token types\";s:7:\"options\";s:73:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:23:\"View custom token types\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"1\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"2\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:3:\"676\";s:2:\"p4\";s:3:\"679\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:42:\"a:1:{i:0;s:24:\"administer custom tokens\";}\";s:13:\"page_callback\";s:27:\"token_custom_type_list_page\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:28:\"admin/structure/token-custom\";s:8:\"tab_root\";s:28:\"admin/structure/token-custom\";s:5:\"title\";s:18:\"Custom token types\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:23:\"View custom token types\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:2:{i:681;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"681\";s:4:\"plid\";s:3:\"679\";s:9:\"link_path\";s:37:\"admin/structure/token-custom/type/add\";s:11:\"router_path\";s:37:\"admin/structure/token-custom/type/add\";s:10:\"link_title\";s:14:\"Add token type\";s:7:\"options\";s:75:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:25:\"Create custom token types\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"2\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:3:\"676\";s:2:\"p4\";s:3:\"679\";s:2:\"p5\";s:3:\"681\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:42:\"a:1:{i:0;s:24:\"administer custom tokens\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:59:\"a:2:{i:0;s:27:\"token_custom_type_edit_form\";i:1;s:3:\"add\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:33:\"admin/structure/token-custom/type\";s:8:\"tab_root\";s:28:\"admin/structure/token-custom\";s:5:\"title\";s:14:\"Add token type\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"388\";s:11:\"description\";s:25:\"Create custom token types\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:683;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"683\";s:4:\"plid\";s:3:\"679\";s:9:\"link_path\";s:42:\"admin/structure/token-custom/type/%/delete\";s:11:\"router_path\";s:42:\"admin/structure/token-custom/type/%/delete\";s:10:\"link_title\";s:19:\"Delete custom token\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"5\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:3:\"676\";s:2:\"p4\";s:3:\"679\";s:2:\"p5\";s:3:\"683\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:40:\"a:1:{i:4;s:22:\"token_custom_type_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:30:\"token_custom_type_forms_access\";s:16:\"access_arguments\";s:14:\"a:1:{i:0;i:4;}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:63:\"a:2:{i:0;s:37:\"token_custom_type_delete_confirm_form\";i:1;i:4;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:42:\"admin/structure/token-custom/type/%/delete\";s:5:\"title\";s:19:\"Delete custom token\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}}}i:680;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"680\";s:4:\"plid\";s:3:\"676\";s:9:\"link_path\";s:33:\"admin/structure/token-custom/list\";s:11:\"router_path\";s:33:\"admin/structure/token-custom/list\";s:10:\"link_title\";s:13:\"Custom tokens\";s:7:\"options\";s:72:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:22:\"List of custom tokens.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:3:\"676\";s:2:\"p4\";s:3:\"680\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:36:\"a:1:{i:0;s:18:\"list custom tokens\";}\";s:13:\"page_callback\";s:22:\"token_custom_list_page\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:28:\"admin/structure/token-custom\";s:8:\"tab_root\";s:28:\"admin/structure/token-custom\";s:5:\"title\";s:13:\"Custom tokens\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"140\";s:11:\"description\";s:22:\"List of custom tokens.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:682;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"682\";s:4:\"plid\";s:3:\"676\";s:9:\"link_path\";s:37:\"admin/structure/token-custom/%/delete\";s:11:\"router_path\";s:37:\"admin/structure/token-custom/%/delete\";s:10:\"link_title\";s:19:\"Delete custom token\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:3:\"676\";s:2:\"p4\";s:3:\"682\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:35:\"a:1:{i:3;s:17:\"token_custom_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:42:\"a:1:{i:0;s:24:\"administer custom tokens\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:58:\"a:2:{i:0;s:32:\"token_custom_delete_confirm_form\";i:1;i:3;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:37:\"admin/structure/token-custom/%/delete\";s:5:\"title\";s:19:\"Delete custom token\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}}}i:909;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"909\";s:4:\"plid\";s:2:\"20\";s:9:\"link_path\";s:31:\"admin/structure/migrate_content\";s:11:\"router_path\";s:31:\"admin/structure/migrate_content\";s:10:\"link_title\";s:15:\"Migrate Content\";s:7:\"options\";s:73:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:23:\"Manage Migrate Content.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:3:\"909\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:47:\"a:1:{i:0;s:29:\"administer site configuration\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:49:\"a:1:{i:0;s:31:\"we_content_migration_admin_form\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:31:\"admin/structure/migrate_content\";s:5:\"title\";s:15:\"Migrate Content\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:23:\"Manage Migrate Content.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:4:{i:910;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"910\";s:4:\"plid\";s:3:\"909\";s:9:\"link_path\";s:38:\"admin/structure/migrate_content/create\";s:11:\"router_path\";s:38:\"admin/structure/migrate_content/create\";s:10:\"link_title\";s:6:\"Create\";s:7:\"options\";s:73:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:23:\"Migrate Content Create.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:2:\"10\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:3:\"909\";s:2:\"p4\";s:3:\"910\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:47:\"a:1:{i:0;s:29:\"administer site configuration\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:50:\"a:1:{i:0;s:32:\"we_content_migration_export_form\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:31:\"admin/structure/migrate_content\";s:8:\"tab_root\";s:31:\"admin/structure/migrate_content\";s:5:\"title\";s:6:\"Create\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:23:\"Migrate Content Create.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:911;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"911\";s:4:\"plid\";s:3:\"909\";s:9:\"link_path\";s:50:\"admin/structure/migrate_content/import-from-upload\";s:11:\"router_path\";s:50:\"admin/structure/migrate_content/import-from-upload\";s:10:\"link_title\";s:6:\"Import\";s:7:\"options\";s:76:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:26:\"Upload zip file to import.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:2:\"11\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:3:\"909\";s:2:\"p4\";s:3:\"911\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:47:\"a:1:{i:0;s:29:\"administer site configuration\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:62:\"a:1:{i:0;s:44:\"we_content_migration_import_from_upload_form\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:31:\"admin/structure/migrate_content\";s:8:\"tab_root\";s:31:\"admin/structure/migrate_content\";s:5:\"title\";s:6:\"Import\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:26:\"Upload zip file to import.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:912;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"912\";s:4:\"plid\";s:3:\"909\";s:9:\"link_path\";s:38:\"admin/structure/migrate_content/manage\";s:11:\"router_path\";s:38:\"admin/structure/migrate_content/manage\";s:10:\"link_title\";s:6:\"Manage\";s:7:\"options\";s:83:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:33:\"Enable and disable entity bundle.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:3:\"909\";s:2:\"p4\";s:3:\"912\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:47:\"a:1:{i:0;s:29:\"administer site configuration\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:49:\"a:1:{i:0;s:31:\"we_content_migration_admin_form\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:31:\"admin/structure/migrate_content\";s:8:\"tab_root\";s:31:\"admin/structure/migrate_content\";s:5:\"title\";s:6:\"Manage\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"140\";s:11:\"description\";s:33:\"Enable and disable entity bundle.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:913;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"913\";s:4:\"plid\";s:3:\"909\";s:9:\"link_path\";s:40:\"admin/structure/migrate_content/settings\";s:11:\"router_path\";s:40:\"admin/structure/migrate_content/settings\";s:10:\"link_title\";s:8:\"Settings\";s:7:\"options\";s:99:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:49:\"Adjust settings for using migrate content module.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:2:\"11\";s:5:\"depth\";s:1:\"4\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"20\";s:2:\"p3\";s:3:\"909\";s:2:\"p4\";s:3:\"913\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:47:\"a:1:{i:0;s:29:\"administer site configuration\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:52:\"a:1:{i:0;s:34:\"we_content_migration_settings_form\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:31:\"admin/structure/migrate_content\";s:8:\"tab_root\";s:31:\"admin/structure/migrate_content\";s:5:\"title\";s:8:\"Settings\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:49:\"Adjust settings for using migrate content module.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}}}}}i:21;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:2:\"21\";s:4:\"plid\";s:1:\"1\";s:9:\"link_path\";s:11:\"admin/tasks\";s:11:\"router_path\";s:11:\"admin/tasks\";s:10:\"link_title\";s:5:\"Tasks\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:3:\"-20\";s:5:\"depth\";s:1:\"2\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:2:\"21\";s:2:\"p3\";s:1:\"0\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:45:\"a:1:{i:0;s:27:\"access administration pages\";}\";s:13:\"page_callback\";s:28:\"system_admin_menu_block_page\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:5:\"admin\";s:8:\"tab_root\";s:5:\"admin\";s:5:\"title\";s:5:\"Tasks\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"140\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:158;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"158\";s:4:\"plid\";s:1:\"1\";s:9:\"link_path\";s:10:\"admin/help\";s:11:\"router_path\";s:10:\"admin/help\";s:10:\"link_title\";s:4:\"Help\";s:7:\"options\";s:98:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:48:\"Reference for usage, configuration, and modules.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"9\";s:5:\"depth\";s:1:\"2\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:3:\"158\";s:2:\"p3\";s:1:\"0\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:45:\"a:1:{i:0;s:27:\"access administration pages\";}\";s:13:\"page_callback\";s:9:\"help_main\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:10:\"admin/help\";s:5:\"title\";s:4:\"Help\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:48:\"Reference for usage, configuration, and modules.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:61:{i:165;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"165\";s:4:\"plid\";s:3:\"158\";s:9:\"link_path\";s:16:\"admin/help/block\";s:11:\"router_path\";s:16:\"admin/help/block\";s:10:\"link_title\";s:5:\"block\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:3:\"158\";s:2:\"p3\";s:3:\"165\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:45:\"a:1:{i:0;s:27:\"access administration pages\";}\";s:13:\"page_callback\";s:9:\"help_page\";s:14:\"page_arguments\";s:14:\"a:1:{i:0;i:2;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:16:\"admin/help/block\";s:5:\"title\";s:5:\"block\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"4\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:166;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"166\";s:4:\"plid\";s:3:\"158\";s:9:\"link_path\";s:16:\"admin/help/color\";s:11:\"router_path\";s:16:\"admin/help/color\";s:10:\"link_title\";s:5:\"color\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:3:\"158\";s:2:\"p3\";s:3:\"166\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:45:\"a:1:{i:0;s:27:\"access administration pages\";}\";s:13:\"page_callback\";s:9:\"help_page\";s:14:\"page_arguments\";s:14:\"a:1:{i:0;i:2;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:16:\"admin/help/color\";s:5:\"title\";s:5:\"color\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"4\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:167;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"167\";s:4:\"plid\";s:3:\"158\";s:9:\"link_path\";s:18:\"admin/help/comment\";s:11:\"router_path\";s:18:\"admin/help/comment\";s:10:\"link_title\";s:7:\"comment\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:3:\"158\";s:2:\"p3\";s:3:\"167\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:45:\"a:1:{i:0;s:27:\"access administration pages\";}\";s:13:\"page_callback\";s:9:\"help_page\";s:14:\"page_arguments\";s:14:\"a:1:{i:0;i:2;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:18:\"admin/help/comment\";s:5:\"title\";s:7:\"comment\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"4\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:168;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"168\";s:4:\"plid\";s:3:\"158\";s:9:\"link_path\";s:21:\"admin/help/contextual\";s:11:\"router_path\";s:21:\"admin/help/contextual\";s:10:\"link_title\";s:10:\"contextual\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:3:\"158\";s:2:\"p3\";s:3:\"168\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:45:\"a:1:{i:0;s:27:\"access administration pages\";}\";s:13:\"page_callback\";s:9:\"help_page\";s:14:\"page_arguments\";s:14:\"a:1:{i:0;i:2;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:21:\"admin/help/contextual\";s:5:\"title\";s:10:\"contextual\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"4\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:169;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"169\";s:4:\"plid\";s:3:\"158\";s:9:\"link_path\";s:20:\"admin/help/dashboard\";s:11:\"router_path\";s:20:\"admin/help/dashboard\";s:10:\"link_title\";s:9:\"dashboard\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:3:\"158\";s:2:\"p3\";s:3:\"169\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:45:\"a:1:{i:0;s:27:\"access administration pages\";}\";s:13:\"page_callback\";s:9:\"help_page\";s:14:\"page_arguments\";s:14:\"a:1:{i:0;i:2;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:20:\"admin/help/dashboard\";s:5:\"title\";s:9:\"dashboard\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"4\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:170;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"170\";s:4:\"plid\";s:3:\"158\";s:9:\"link_path\";s:16:\"admin/help/dblog\";s:11:\"router_path\";s:16:\"admin/help/dblog\";s:10:\"link_title\";s:5:\"dblog\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:3:\"158\";s:2:\"p3\";s:3:\"170\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:45:\"a:1:{i:0;s:27:\"access administration pages\";}\";s:13:\"page_callback\";s:9:\"help_page\";s:14:\"page_arguments\";s:14:\"a:1:{i:0;i:2;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:16:\"admin/help/dblog\";s:5:\"title\";s:5:\"dblog\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"4\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:171;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"171\";s:4:\"plid\";s:3:\"158\";s:9:\"link_path\";s:16:\"admin/help/field\";s:11:\"router_path\";s:16:\"admin/help/field\";s:10:\"link_title\";s:5:\"field\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:3:\"158\";s:2:\"p3\";s:3:\"171\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:45:\"a:1:{i:0;s:27:\"access administration pages\";}\";s:13:\"page_callback\";s:9:\"help_page\";s:14:\"page_arguments\";s:14:\"a:1:{i:0;i:2;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:16:\"admin/help/field\";s:5:\"title\";s:5:\"field\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"4\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:172;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"172\";s:4:\"plid\";s:3:\"158\";s:9:\"link_path\";s:28:\"admin/help/field_sql_storage\";s:11:\"router_path\";s:28:\"admin/help/field_sql_storage\";s:10:\"link_title\";s:17:\"field_sql_storage\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:3:\"158\";s:2:\"p3\";s:3:\"172\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:45:\"a:1:{i:0;s:27:\"access administration pages\";}\";s:13:\"page_callback\";s:9:\"help_page\";s:14:\"page_arguments\";s:14:\"a:1:{i:0;i:2;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:28:\"admin/help/field_sql_storage\";s:5:\"title\";s:17:\"field_sql_storage\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"4\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:173;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"173\";s:4:\"plid\";s:3:\"158\";s:9:\"link_path\";s:19:\"admin/help/field_ui\";s:11:\"router_path\";s:19:\"admin/help/field_ui\";s:10:\"link_title\";s:8:\"field_ui\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:3:\"158\";s:2:\"p3\";s:3:\"173\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:45:\"a:1:{i:0;s:27:\"access administration pages\";}\";s:13:\"page_callback\";s:9:\"help_page\";s:14:\"page_arguments\";s:14:\"a:1:{i:0;i:2;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:19:\"admin/help/field_ui\";s:5:\"title\";s:8:\"field_ui\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"4\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:174;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"174\";s:4:\"plid\";s:3:\"158\";s:9:\"link_path\";s:15:\"admin/help/file\";s:11:\"router_path\";s:15:\"admin/help/file\";s:10:\"link_title\";s:4:\"file\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:3:\"158\";s:2:\"p3\";s:3:\"174\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:45:\"a:1:{i:0;s:27:\"access administration pages\";}\";s:13:\"page_callback\";s:9:\"help_page\";s:14:\"page_arguments\";s:14:\"a:1:{i:0;i:2;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:15:\"admin/help/file\";s:5:\"title\";s:4:\"file\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"4\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:175;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"175\";s:4:\"plid\";s:3:\"158\";s:9:\"link_path\";s:17:\"admin/help/filter\";s:11:\"router_path\";s:17:\"admin/help/filter\";s:10:\"link_title\";s:6:\"filter\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:3:\"158\";s:2:\"p3\";s:3:\"175\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:45:\"a:1:{i:0;s:27:\"access administration pages\";}\";s:13:\"page_callback\";s:9:\"help_page\";s:14:\"page_arguments\";s:14:\"a:1:{i:0;i:2;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:17:\"admin/help/filter\";s:5:\"title\";s:6:\"filter\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"4\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:176;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"176\";s:4:\"plid\";s:3:\"158\";s:9:\"link_path\";s:15:\"admin/help/help\";s:11:\"router_path\";s:15:\"admin/help/help\";s:10:\"link_title\";s:4:\"help\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:3:\"158\";s:2:\"p3\";s:3:\"176\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:45:\"a:1:{i:0;s:27:\"access administration pages\";}\";s:13:\"page_callback\";s:9:\"help_page\";s:14:\"page_arguments\";s:14:\"a:1:{i:0;i:2;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:15:\"admin/help/help\";s:5:\"title\";s:4:\"help\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"4\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:177;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"177\";s:4:\"plid\";s:3:\"158\";s:9:\"link_path\";s:16:\"admin/help/image\";s:11:\"router_path\";s:16:\"admin/help/image\";s:10:\"link_title\";s:5:\"image\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:3:\"158\";s:2:\"p3\";s:3:\"177\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:45:\"a:1:{i:0;s:27:\"access administration pages\";}\";s:13:\"page_callback\";s:9:\"help_page\";s:14:\"page_arguments\";s:14:\"a:1:{i:0;i:2;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:16:\"admin/help/image\";s:5:\"title\";s:5:\"image\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"4\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:178;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"178\";s:4:\"plid\";s:3:\"158\";s:9:\"link_path\";s:15:\"admin/help/list\";s:11:\"router_path\";s:15:\"admin/help/list\";s:10:\"link_title\";s:4:\"list\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:3:\"158\";s:2:\"p3\";s:3:\"178\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:45:\"a:1:{i:0;s:27:\"access administration pages\";}\";s:13:\"page_callback\";s:9:\"help_page\";s:14:\"page_arguments\";s:14:\"a:1:{i:0;i:2;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:15:\"admin/help/list\";s:5:\"title\";s:4:\"list\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"4\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:179;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"179\";s:4:\"plid\";s:3:\"158\";s:9:\"link_path\";s:15:\"admin/help/menu\";s:11:\"router_path\";s:15:\"admin/help/menu\";s:10:\"link_title\";s:4:\"menu\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:3:\"158\";s:2:\"p3\";s:3:\"179\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:45:\"a:1:{i:0;s:27:\"access administration pages\";}\";s:13:\"page_callback\";s:9:\"help_page\";s:14:\"page_arguments\";s:14:\"a:1:{i:0;i:2;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:15:\"admin/help/menu\";s:5:\"title\";s:4:\"menu\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"4\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:180;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"180\";s:4:\"plid\";s:3:\"158\";s:9:\"link_path\";s:15:\"admin/help/node\";s:11:\"router_path\";s:15:\"admin/help/node\";s:10:\"link_title\";s:4:\"node\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:3:\"158\";s:2:\"p3\";s:3:\"180\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:45:\"a:1:{i:0;s:27:\"access administration pages\";}\";s:13:\"page_callback\";s:9:\"help_page\";s:14:\"page_arguments\";s:14:\"a:1:{i:0;i:2;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:15:\"admin/help/node\";s:5:\"title\";s:4:\"node\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"4\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:181;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"181\";s:4:\"plid\";s:3:\"158\";s:9:\"link_path\";s:17:\"admin/help/number\";s:11:\"router_path\";s:17:\"admin/help/number\";s:10:\"link_title\";s:6:\"number\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:3:\"158\";s:2:\"p3\";s:3:\"181\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:45:\"a:1:{i:0;s:27:\"access administration pages\";}\";s:13:\"page_callback\";s:9:\"help_page\";s:14:\"page_arguments\";s:14:\"a:1:{i:0;i:2;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:17:\"admin/help/number\";s:5:\"title\";s:6:\"number\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"4\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:182;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"182\";s:4:\"plid\";s:3:\"158\";s:9:\"link_path\";s:18:\"admin/help/options\";s:11:\"router_path\";s:18:\"admin/help/options\";s:10:\"link_title\";s:7:\"options\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:3:\"158\";s:2:\"p3\";s:3:\"182\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:45:\"a:1:{i:0;s:27:\"access administration pages\";}\";s:13:\"page_callback\";s:9:\"help_page\";s:14:\"page_arguments\";s:14:\"a:1:{i:0;i:2;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:18:\"admin/help/options\";s:5:\"title\";s:7:\"options\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"4\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:183;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"183\";s:4:\"plid\";s:3:\"158\";s:9:\"link_path\";s:18:\"admin/help/overlay\";s:11:\"router_path\";s:18:\"admin/help/overlay\";s:10:\"link_title\";s:7:\"overlay\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:3:\"158\";s:2:\"p3\";s:3:\"183\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:45:\"a:1:{i:0;s:27:\"access administration pages\";}\";s:13:\"page_callback\";s:9:\"help_page\";s:14:\"page_arguments\";s:14:\"a:1:{i:0;i:2;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:18:\"admin/help/overlay\";s:5:\"title\";s:7:\"overlay\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"4\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:184;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"184\";s:4:\"plid\";s:3:\"158\";s:9:\"link_path\";s:15:\"admin/help/path\";s:11:\"router_path\";s:15:\"admin/help/path\";s:10:\"link_title\";s:4:\"path\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:3:\"158\";s:2:\"p3\";s:3:\"184\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:45:\"a:1:{i:0;s:27:\"access administration pages\";}\";s:13:\"page_callback\";s:9:\"help_page\";s:14:\"page_arguments\";s:14:\"a:1:{i:0;i:2;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:15:\"admin/help/path\";s:5:\"title\";s:4:\"path\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"4\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:186;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"186\";s:4:\"plid\";s:3:\"158\";s:9:\"link_path\";s:17:\"admin/help/search\";s:11:\"router_path\";s:17:\"admin/help/search\";s:10:\"link_title\";s:6:\"search\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:3:\"158\";s:2:\"p3\";s:3:\"186\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:45:\"a:1:{i:0;s:27:\"access administration pages\";}\";s:13:\"page_callback\";s:9:\"help_page\";s:14:\"page_arguments\";s:14:\"a:1:{i:0;i:2;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:17:\"admin/help/search\";s:5:\"title\";s:6:\"search\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"4\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:187;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"187\";s:4:\"plid\";s:3:\"158\";s:9:\"link_path\";s:19:\"admin/help/shortcut\";s:11:\"router_path\";s:19:\"admin/help/shortcut\";s:10:\"link_title\";s:8:\"shortcut\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:3:\"158\";s:2:\"p3\";s:3:\"187\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:45:\"a:1:{i:0;s:27:\"access administration pages\";}\";s:13:\"page_callback\";s:9:\"help_page\";s:14:\"page_arguments\";s:14:\"a:1:{i:0;i:2;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:19:\"admin/help/shortcut\";s:5:\"title\";s:8:\"shortcut\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"4\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:188;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"188\";s:4:\"plid\";s:3:\"158\";s:9:\"link_path\";s:17:\"admin/help/system\";s:11:\"router_path\";s:17:\"admin/help/system\";s:10:\"link_title\";s:6:\"system\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:3:\"158\";s:2:\"p3\";s:3:\"188\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:45:\"a:1:{i:0;s:27:\"access administration pages\";}\";s:13:\"page_callback\";s:9:\"help_page\";s:14:\"page_arguments\";s:14:\"a:1:{i:0;i:2;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:17:\"admin/help/system\";s:5:\"title\";s:6:\"system\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"4\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:189;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"189\";s:4:\"plid\";s:3:\"158\";s:9:\"link_path\";s:19:\"admin/help/taxonomy\";s:11:\"router_path\";s:19:\"admin/help/taxonomy\";s:10:\"link_title\";s:8:\"taxonomy\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:3:\"158\";s:2:\"p3\";s:3:\"189\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:45:\"a:1:{i:0;s:27:\"access administration pages\";}\";s:13:\"page_callback\";s:9:\"help_page\";s:14:\"page_arguments\";s:14:\"a:1:{i:0;i:2;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:19:\"admin/help/taxonomy\";s:5:\"title\";s:8:\"taxonomy\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"4\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:190;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"190\";s:4:\"plid\";s:3:\"158\";s:9:\"link_path\";s:15:\"admin/help/text\";s:11:\"router_path\";s:15:\"admin/help/text\";s:10:\"link_title\";s:4:\"text\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:3:\"158\";s:2:\"p3\";s:3:\"190\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:45:\"a:1:{i:0;s:27:\"access administration pages\";}\";s:13:\"page_callback\";s:9:\"help_page\";s:14:\"page_arguments\";s:14:\"a:1:{i:0;i:2;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:15:\"admin/help/text\";s:5:\"title\";s:4:\"text\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"4\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:191;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"191\";s:4:\"plid\";s:3:\"158\";s:9:\"link_path\";s:15:\"admin/help/user\";s:11:\"router_path\";s:15:\"admin/help/user\";s:10:\"link_title\";s:4:\"user\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:3:\"158\";s:2:\"p3\";s:3:\"191\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:45:\"a:1:{i:0;s:27:\"access administration pages\";}\";s:13:\"page_callback\";s:9:\"help_page\";s:14:\"page_arguments\";s:14:\"a:1:{i:0;i:2;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:15:\"admin/help/user\";s:5:\"title\";s:4:\"user\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"4\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:265;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"265\";s:4:\"plid\";s:3:\"158\";s:9:\"link_path\";s:17:\"admin/help/update\";s:11:\"router_path\";s:17:\"admin/help/update\";s:10:\"link_title\";s:6:\"update\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:3:\"158\";s:2:\"p3\";s:3:\"265\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:45:\"a:1:{i:0;s:27:\"access administration pages\";}\";s:13:\"page_callback\";s:9:\"help_page\";s:14:\"page_arguments\";s:14:\"a:1:{i:0;i:2;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:17:\"admin/help/update\";s:5:\"title\";s:6:\"update\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"4\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:321;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"321\";s:4:\"plid\";s:3:\"158\";s:9:\"link_path\";s:15:\"admin/help/blog\";s:11:\"router_path\";s:15:\"admin/help/blog\";s:10:\"link_title\";s:4:\"blog\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:3:\"158\";s:2:\"p3\";s:3:\"321\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:45:\"a:1:{i:0;s:27:\"access administration pages\";}\";s:13:\"page_callback\";s:9:\"help_page\";s:14:\"page_arguments\";s:14:\"a:1:{i:0;i:2;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:15:\"admin/help/blog\";s:5:\"title\";s:4:\"blog\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"4\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:322;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"322\";s:4:\"plid\";s:3:\"158\";s:9:\"link_path\";s:15:\"admin/help/book\";s:11:\"router_path\";s:15:\"admin/help/book\";s:10:\"link_title\";s:4:\"book\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:3:\"158\";s:2:\"p3\";s:3:\"322\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:45:\"a:1:{i:0;s:27:\"access administration pages\";}\";s:13:\"page_callback\";s:9:\"help_page\";s:14:\"page_arguments\";s:14:\"a:1:{i:0;i:2;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:15:\"admin/help/book\";s:5:\"title\";s:4:\"book\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"4\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:323;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"323\";s:4:\"plid\";s:3:\"158\";s:9:\"link_path\";s:16:\"admin/help/forum\";s:11:\"router_path\";s:16:\"admin/help/forum\";s:10:\"link_title\";s:5:\"forum\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:3:\"158\";s:2:\"p3\";s:3:\"323\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:45:\"a:1:{i:0;s:27:\"access administration pages\";}\";s:13:\"page_callback\";s:9:\"help_page\";s:14:\"page_arguments\";s:14:\"a:1:{i:0;i:2;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:16:\"admin/help/forum\";s:5:\"title\";s:5:\"forum\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"4\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:324;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"324\";s:4:\"plid\";s:3:\"158\";s:9:\"link_path\";s:26:\"admin/help/views_slideshow\";s:11:\"router_path\";s:26:\"admin/help/views_slideshow\";s:10:\"link_title\";s:15:\"views_slideshow\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:3:\"158\";s:2:\"p3\";s:3:\"324\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:45:\"a:1:{i:0;s:27:\"access administration pages\";}\";s:13:\"page_callback\";s:9:\"help_page\";s:14:\"page_arguments\";s:14:\"a:1:{i:0;i:2;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:26:\"admin/help/views_slideshow\";s:5:\"title\";s:15:\"views_slideshow\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"4\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:325;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"325\";s:4:\"plid\";s:3:\"158\";s:9:\"link_path\";s:32:\"admin/help/views_slideshow_cycle\";s:11:\"router_path\";s:32:\"admin/help/views_slideshow_cycle\";s:10:\"link_title\";s:21:\"views_slideshow_cycle\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:3:\"158\";s:2:\"p3\";s:3:\"325\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:45:\"a:1:{i:0;s:27:\"access administration pages\";}\";s:13:\"page_callback\";s:9:\"help_page\";s:14:\"page_arguments\";s:14:\"a:1:{i:0;i:2;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:32:\"admin/help/views_slideshow_cycle\";s:5:\"title\";s:21:\"views_slideshow_cycle\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"4\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:356;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"356\";s:4:\"plid\";s:3:\"158\";s:9:\"link_path\";s:21:\"admin/help/admin_menu\";s:11:\"router_path\";s:21:\"admin/help/admin_menu\";s:10:\"link_title\";s:10:\"admin_menu\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:3:\"158\";s:2:\"p3\";s:3:\"356\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:45:\"a:1:{i:0;s:27:\"access administration pages\";}\";s:13:\"page_callback\";s:9:\"help_page\";s:14:\"page_arguments\";s:14:\"a:1:{i:0;i:2;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:21:\"admin/help/admin_menu\";s:5:\"title\";s:10:\"admin_menu\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"4\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:364;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"364\";s:4:\"plid\";s:3:\"158\";s:9:\"link_path\";s:15:\"admin/help/i18n\";s:11:\"router_path\";s:15:\"admin/help/i18n\";s:10:\"link_title\";s:4:\"i18n\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:3:\"158\";s:2:\"p3\";s:3:\"364\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:45:\"a:1:{i:0;s:27:\"access administration pages\";}\";s:13:\"page_callback\";s:9:\"help_page\";s:14:\"page_arguments\";s:14:\"a:1:{i:0;i:2;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:15:\"admin/help/i18n\";s:5:\"title\";s:4:\"i18n\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"4\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:365;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"365\";s:4:\"plid\";s:3:\"158\";s:9:\"link_path\";s:21:\"admin/help/i18n_block\";s:11:\"router_path\";s:21:\"admin/help/i18n_block\";s:10:\"link_title\";s:10:\"i18n_block\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:3:\"158\";s:2:\"p3\";s:3:\"365\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:45:\"a:1:{i:0;s:27:\"access administration pages\";}\";s:13:\"page_callback\";s:9:\"help_page\";s:14:\"page_arguments\";s:14:\"a:1:{i:0;i:2;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:21:\"admin/help/i18n_block\";s:5:\"title\";s:10:\"i18n_block\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"4\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:366;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"366\";s:4:\"plid\";s:3:\"158\";s:9:\"link_path\";s:22:\"admin/help/i18n_string\";s:11:\"router_path\";s:22:\"admin/help/i18n_string\";s:10:\"link_title\";s:11:\"i18n_string\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:3:\"158\";s:2:\"p3\";s:3:\"366\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:45:\"a:1:{i:0;s:27:\"access administration pages\";}\";s:13:\"page_callback\";s:9:\"help_page\";s:14:\"page_arguments\";s:14:\"a:1:{i:0;i:2;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:22:\"admin/help/i18n_string\";s:5:\"title\";s:11:\"i18n_string\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"4\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:367;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"367\";s:4:\"plid\";s:3:\"158\";s:9:\"link_path\";s:24:\"admin/help/lang_dropdown\";s:11:\"router_path\";s:24:\"admin/help/lang_dropdown\";s:10:\"link_title\";s:13:\"lang_dropdown\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:3:\"158\";s:2:\"p3\";s:3:\"367\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:45:\"a:1:{i:0;s:27:\"access administration pages\";}\";s:13:\"page_callback\";s:9:\"help_page\";s:14:\"page_arguments\";s:14:\"a:1:{i:0;i:2;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:24:\"admin/help/lang_dropdown\";s:5:\"title\";s:13:\"lang_dropdown\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"4\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:368;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"368\";s:4:\"plid\";s:3:\"158\";s:9:\"link_path\";s:32:\"admin/help/lang_dropdown_hideout\";s:11:\"router_path\";s:32:\"admin/help/lang_dropdown_hideout\";s:10:\"link_title\";s:21:\"lang_dropdown_hideout\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:3:\"158\";s:2:\"p3\";s:3:\"368\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:45:\"a:1:{i:0;s:27:\"access administration pages\";}\";s:13:\"page_callback\";s:9:\"help_page\";s:14:\"page_arguments\";s:14:\"a:1:{i:0;i:2;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:32:\"admin/help/lang_dropdown_hideout\";s:5:\"title\";s:21:\"lang_dropdown_hideout\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"4\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:369;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"369\";s:4:\"plid\";s:3:\"158\";s:9:\"link_path\";s:24:\"admin/help/languageicons\";s:11:\"router_path\";s:24:\"admin/help/languageicons\";s:10:\"link_title\";s:13:\"languageicons\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:3:\"158\";s:2:\"p3\";s:3:\"369\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:45:\"a:1:{i:0;s:27:\"access administration pages\";}\";s:13:\"page_callback\";s:9:\"help_page\";s:14:\"page_arguments\";s:14:\"a:1:{i:0;i:2;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:24:\"admin/help/languageicons\";s:5:\"title\";s:13:\"languageicons\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"4\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:370;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"370\";s:4:\"plid\";s:3:\"158\";s:9:\"link_path\";s:17:\"admin/help/locale\";s:11:\"router_path\";s:17:\"admin/help/locale\";s:10:\"link_title\";s:6:\"locale\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:3:\"158\";s:2:\"p3\";s:3:\"370\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:45:\"a:1:{i:0;s:27:\"access administration pages\";}\";s:13:\"page_callback\";s:9:\"help_page\";s:14:\"page_arguments\";s:14:\"a:1:{i:0;i:2;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:17:\"admin/help/locale\";s:5:\"title\";s:6:\"locale\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"4\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:406;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"406\";s:4:\"plid\";s:3:\"158\";s:9:\"link_path\";s:18:\"admin/help/contact\";s:11:\"router_path\";s:18:\"admin/help/contact\";s:10:\"link_title\";s:7:\"contact\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:3:\"158\";s:2:\"p3\";s:3:\"406\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:45:\"a:1:{i:0;s:27:\"access administration pages\";}\";s:13:\"page_callback\";s:9:\"help_page\";s:14:\"page_arguments\";s:14:\"a:1:{i:0;i:2;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:18:\"admin/help/contact\";s:5:\"title\";s:7:\"contact\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"4\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:432;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"432\";s:4:\"plid\";s:3:\"158\";s:9:\"link_path\";s:21:\"admin/help/statistics\";s:11:\"router_path\";s:21:\"admin/help/statistics\";s:10:\"link_title\";s:10:\"statistics\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:3:\"158\";s:2:\"p3\";s:3:\"432\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:45:\"a:1:{i:0;s:27:\"access administration pages\";}\";s:13:\"page_callback\";s:9:\"help_page\";s:14:\"page_arguments\";s:14:\"a:1:{i:0;i:2;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:21:\"admin/help/statistics\";s:5:\"title\";s:10:\"statistics\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"4\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:436;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"436\";s:4:\"plid\";s:3:\"158\";s:9:\"link_path\";s:19:\"admin/help/fivestar\";s:11:\"router_path\";s:19:\"admin/help/fivestar\";s:10:\"link_title\";s:8:\"fivestar\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:3:\"158\";s:2:\"p3\";s:3:\"436\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:45:\"a:1:{i:0;s:27:\"access administration pages\";}\";s:13:\"page_callback\";s:9:\"help_page\";s:14:\"page_arguments\";s:14:\"a:1:{i:0;i:2;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:19:\"admin/help/fivestar\";s:5:\"title\";s:8:\"fivestar\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"4\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:452;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"452\";s:4:\"plid\";s:3:\"158\";s:9:\"link_path\";s:19:\"admin/help/features\";s:11:\"router_path\";s:19:\"admin/help/features\";s:10:\"link_title\";s:8:\"features\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:3:\"158\";s:2:\"p3\";s:3:\"452\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:45:\"a:1:{i:0;s:27:\"access administration pages\";}\";s:13:\"page_callback\";s:9:\"help_page\";s:14:\"page_arguments\";s:14:\"a:1:{i:0;i:2;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:19:\"admin/help/features\";s:5:\"title\";s:8:\"features\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"4\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:453;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"453\";s:4:\"plid\";s:3:\"158\";s:9:\"link_path\";s:20:\"admin/help/strongarm\";s:11:\"router_path\";s:20:\"admin/help/strongarm\";s:10:\"link_title\";s:9:\"strongarm\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:3:\"158\";s:2:\"p3\";s:3:\"453\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:45:\"a:1:{i:0;s:27:\"access administration pages\";}\";s:13:\"page_callback\";s:9:\"help_page\";s:14:\"page_arguments\";s:14:\"a:1:{i:0;i:2;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:20:\"admin/help/strongarm\";s:5:\"title\";s:9:\"strongarm\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"4\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:454;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"454\";s:4:\"plid\";s:3:\"158\";s:9:\"link_path\";s:16:\"admin/help/token\";s:11:\"router_path\";s:16:\"admin/help/token\";s:10:\"link_title\";s:5:\"token\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:3:\"158\";s:2:\"p3\";s:3:\"454\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:45:\"a:1:{i:0;s:27:\"access administration pages\";}\";s:13:\"page_callback\";s:9:\"help_page\";s:14:\"page_arguments\";s:14:\"a:1:{i:0;i:2;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:16:\"admin/help/token\";s:5:\"title\";s:5:\"token\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"4\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:491;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"491\";s:4:\"plid\";s:3:\"158\";s:9:\"link_path\";s:24:\"admin/help/jquery_update\";s:11:\"router_path\";s:24:\"admin/help/jquery_update\";s:10:\"link_title\";s:13:\"jquery_update\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:3:\"158\";s:2:\"p3\";s:3:\"491\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:45:\"a:1:{i:0;s:27:\"access administration pages\";}\";s:13:\"page_callback\";s:9:\"help_page\";s:14:\"page_arguments\";s:14:\"a:1:{i:0;i:2;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:24:\"admin/help/jquery_update\";s:5:\"title\";s:13:\"jquery_update\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"4\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:503;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"503\";s:4:\"plid\";s:3:\"158\";s:9:\"link_path\";s:19:\"admin/help/pathauto\";s:11:\"router_path\";s:19:\"admin/help/pathauto\";s:10:\"link_title\";s:8:\"pathauto\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:3:\"158\";s:2:\"p3\";s:3:\"503\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:45:\"a:1:{i:0;s:27:\"access administration pages\";}\";s:13:\"page_callback\";s:9:\"help_page\";s:14:\"page_arguments\";s:14:\"a:1:{i:0;i:2;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:19:\"admin/help/pathauto\";s:5:\"title\";s:8:\"pathauto\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"4\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:509;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"509\";s:4:\"plid\";s:3:\"158\";s:9:\"link_path\";s:20:\"admin/help/quicktabs\";s:11:\"router_path\";s:20:\"admin/help/quicktabs\";s:10:\"link_title\";s:9:\"quicktabs\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:3:\"158\";s:2:\"p3\";s:3:\"509\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:45:\"a:1:{i:0;s:27:\"access administration pages\";}\";s:13:\"page_callback\";s:9:\"help_page\";s:14:\"page_arguments\";s:14:\"a:1:{i:0;i:2;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:20:\"admin/help/quicktabs\";s:5:\"title\";s:9:\"quicktabs\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"4\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:517;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"517\";s:4:\"plid\";s:3:\"158\";s:9:\"link_path\";s:24:\"admin/help/i18n_taxonomy\";s:11:\"router_path\";s:24:\"admin/help/i18n_taxonomy\";s:10:\"link_title\";s:13:\"i18n_taxonomy\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:3:\"158\";s:2:\"p3\";s:3:\"517\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:45:\"a:1:{i:0;s:27:\"access administration pages\";}\";s:13:\"page_callback\";s:9:\"help_page\";s:14:\"page_arguments\";s:14:\"a:1:{i:0;i:2;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:24:\"admin/help/i18n_taxonomy\";s:5:\"title\";s:13:\"i18n_taxonomy\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"4\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:542;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"542\";s:4:\"plid\";s:3:\"158\";s:9:\"link_path\";s:19:\"admin/help/calendar\";s:11:\"router_path\";s:19:\"admin/help/calendar\";s:10:\"link_title\";s:8:\"calendar\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:3:\"158\";s:2:\"p3\";s:3:\"542\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:45:\"a:1:{i:0;s:27:\"access administration pages\";}\";s:13:\"page_callback\";s:9:\"help_page\";s:14:\"page_arguments\";s:14:\"a:1:{i:0;i:2;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:19:\"admin/help/calendar\";s:5:\"title\";s:8:\"calendar\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"4\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:551;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"551\";s:4:\"plid\";s:3:\"158\";s:9:\"link_path\";s:14:\"admin/help/faq\";s:11:\"router_path\";s:14:\"admin/help/faq\";s:10:\"link_title\";s:3:\"faq\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:3:\"158\";s:2:\"p3\";s:3:\"551\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:45:\"a:1:{i:0;s:27:\"access administration pages\";}\";s:13:\"page_callback\";s:9:\"help_page\";s:14:\"page_arguments\";s:14:\"a:1:{i:0;i:2;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:14:\"admin/help/faq\";s:5:\"title\";s:3:\"faq\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"4\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:565;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"565\";s:4:\"plid\";s:3:\"158\";s:9:\"link_path\";s:14:\"admin/help/php\";s:11:\"router_path\";s:14:\"admin/help/php\";s:10:\"link_title\";s:3:\"php\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:3:\"158\";s:2:\"p3\";s:3:\"565\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:45:\"a:1:{i:0;s:27:\"access administration pages\";}\";s:13:\"page_callback\";s:9:\"help_page\";s:14:\"page_arguments\";s:14:\"a:1:{i:0;i:2;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:14:\"admin/help/php\";s:5:\"title\";s:3:\"php\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"4\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:572;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"572\";s:4:\"plid\";s:3:\"158\";s:9:\"link_path\";s:26:\"admin/help/menu_breadcrumb\";s:11:\"router_path\";s:26:\"admin/help/menu_breadcrumb\";s:10:\"link_title\";s:15:\"menu_breadcrumb\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:3:\"158\";s:2:\"p3\";s:3:\"572\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:45:\"a:1:{i:0;s:27:\"access administration pages\";}\";s:13:\"page_callback\";s:9:\"help_page\";s:14:\"page_arguments\";s:14:\"a:1:{i:0;i:2;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:26:\"admin/help/menu_breadcrumb\";s:5:\"title\";s:15:\"menu_breadcrumb\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"4\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:577;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"577\";s:4:\"plid\";s:3:\"158\";s:9:\"link_path\";s:20:\"admin/help/sharethis\";s:11:\"router_path\";s:20:\"admin/help/sharethis\";s:10:\"link_title\";s:9:\"sharethis\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:3:\"158\";s:2:\"p3\";s:3:\"577\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:45:\"a:1:{i:0;s:27:\"access administration pages\";}\";s:13:\"page_callback\";s:9:\"help_page\";s:14:\"page_arguments\";s:14:\"a:1:{i:0;i:2;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:20:\"admin/help/sharethis\";s:5:\"title\";s:9:\"sharethis\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"4\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:600;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"600\";s:4:\"plid\";s:3:\"158\";s:9:\"link_path\";s:18:\"admin/help/webform\";s:11:\"router_path\";s:18:\"admin/help/webform\";s:10:\"link_title\";s:7:\"webform\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:3:\"158\";s:2:\"p3\";s:3:\"600\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:45:\"a:1:{i:0;s:27:\"access administration pages\";}\";s:13:\"page_callback\";s:9:\"help_page\";s:14:\"page_arguments\";s:14:\"a:1:{i:0;i:2;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:18:\"admin/help/webform\";s:5:\"title\";s:7:\"webform\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"4\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:628;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"628\";s:4:\"plid\";s:3:\"158\";s:9:\"link_path\";s:22:\"admin/help/remember_me\";s:11:\"router_path\";s:22:\"admin/help/remember_me\";s:10:\"link_title\";s:11:\"remember_me\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:3:\"158\";s:2:\"p3\";s:3:\"628\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:45:\"a:1:{i:0;s:27:\"access administration pages\";}\";s:13:\"page_callback\";s:9:\"help_page\";s:14:\"page_arguments\";s:14:\"a:1:{i:0;i:2;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:22:\"admin/help/remember_me\";s:5:\"title\";s:11:\"remember_me\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"4\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:630;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"630\";s:4:\"plid\";s:3:\"158\";s:9:\"link_path\";s:21:\"admin/help/flexslider\";s:11:\"router_path\";s:21:\"admin/help/flexslider\";s:10:\"link_title\";s:10:\"flexslider\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:3:\"158\";s:2:\"p3\";s:3:\"630\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:45:\"a:1:{i:0;s:27:\"access administration pages\";}\";s:13:\"page_callback\";s:9:\"help_page\";s:14:\"page_arguments\";s:14:\"a:1:{i:0;i:2;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:21:\"admin/help/flexslider\";s:5:\"title\";s:10:\"flexslider\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"4\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:640;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"640\";s:4:\"plid\";s:3:\"158\";s:9:\"link_path\";s:27:\"admin/help/field_collection\";s:11:\"router_path\";s:27:\"admin/help/field_collection\";s:10:\"link_title\";s:16:\"field_collection\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:3:\"158\";s:2:\"p3\";s:3:\"640\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:45:\"a:1:{i:0;s:27:\"access administration pages\";}\";s:13:\"page_callback\";s:9:\"help_page\";s:14:\"page_arguments\";s:14:\"a:1:{i:0;i:2;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:27:\"admin/help/field_collection\";s:5:\"title\";s:16:\"field_collection\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"4\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:677;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"677\";s:4:\"plid\";s:3:\"158\";s:9:\"link_path\";s:23:\"admin/help/token_custom\";s:11:\"router_path\";s:23:\"admin/help/token_custom\";s:10:\"link_title\";s:12:\"token_custom\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:3:\"158\";s:2:\"p3\";s:3:\"677\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:45:\"a:1:{i:0;s:27:\"access administration pages\";}\";s:13:\"page_callback\";s:9:\"help_page\";s:14:\"page_arguments\";s:14:\"a:1:{i:0;i:2;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:23:\"admin/help/token_custom\";s:5:\"title\";s:12:\"token_custom\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"4\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:684;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"management\";s:4:\"mlid\";s:3:\"684\";s:4:\"plid\";s:3:\"158\";s:9:\"link_path\";s:19:\"admin/help/ckeditor\";s:11:\"router_path\";s:19:\"admin/help/ckeditor\";s:10:\"link_title\";s:8:\"ckeditor\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"3\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"1\";s:2:\"p2\";s:3:\"158\";s:2:\"p3\";s:3:\"684\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:45:\"a:1:{i:0;s:27:\"access administration pages\";}\";s:13:\"page_callback\";s:9:\"help_page\";s:14:\"page_arguments\";s:14:\"a:1:{i:0;i:2;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:19:\"admin/help/ckeditor\";s:5:\"title\";s:8:\"ckeditor\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"4\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}}}}}}s:10:\"node_links\";a:0:{}}',0,1512620348,1),('links:menu-footer-menu:page:user/1:en:1:0','a:4:{s:9:\"min_depth\";i:1;s:9:\"max_depth\";N;s:8:\"expanded\";a:1:{i:0;i:0;}s:12:\"active_trail\";a:1:{i:0;i:0;}}',0,1512620348,1),('links:menu-footer-menu:page:user:en:1:0','a:4:{s:9:\"min_depth\";i:1;s:9:\"max_depth\";N;s:8:\"expanded\";a:1:{i:0;i:0;}s:12:\"active_trail\";a:1:{i:0;i:0;}}',0,1512620340,1),('links:menu-footer-menu:tree-data:en:9bd1605e2280833450478f9083b7f8714c2fa28f1012455e2744e5af1a13eec5','a:2:{s:4:\"tree\";a:4:{i:401;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:16:\"menu-footer-menu\";s:4:\"mlid\";s:3:\"401\";s:4:\"plid\";s:1:\"0\";s:9:\"link_path\";s:7:\"<front>\";s:11:\"router_path\";s:0:\"\";s:10:\"link_title\";s:10:\"Forum Plus\";s:7:\"options\";s:49:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:0:\"\";}}\";s:6:\"module\";s:4:\"menu\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"1\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:3:\"-50\";s:5:\"depth\";s:1:\"1\";s:10:\"customized\";s:1:\"1\";s:2:\"p1\";s:3:\"401\";s:2:\"p2\";s:1:\"0\";s:2:\"p3\";s:1:\"0\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";N;s:16:\"to_arg_functions\";N;s:15:\"access_callback\";N;s:16:\"access_arguments\";N;s:13:\"page_callback\";N;s:14:\"page_arguments\";N;s:17:\"delivery_callback\";N;s:10:\"tab_parent\";N;s:8:\"tab_root\";N;s:5:\"title\";N;s:14:\"title_callback\";N;s:15:\"title_arguments\";N;s:14:\"theme_callback\";N;s:15:\"theme_arguments\";N;s:4:\"type\";N;s:11:\"description\";N;s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:403;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:16:\"menu-footer-menu\";s:4:\"mlid\";s:3:\"403\";s:4:\"plid\";s:1:\"0\";s:9:\"link_path\";s:7:\"contact\";s:11:\"router_path\";s:7:\"contact\";s:10:\"link_title\";s:7:\"Contact\";s:7:\"options\";s:49:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:0:\"\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:3:\"-47\";s:5:\"depth\";s:1:\"1\";s:10:\"customized\";s:1:\"1\";s:2:\"p1\";s:3:\"403\";s:2:\"p2\";s:1:\"0\";s:2:\"p3\";s:1:\"0\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:47:\"a:1:{i:0;s:29:\"access site-wide contact form\";}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:35:\"a:1:{i:0;s:17:\"contact_site_form\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:7:\"contact\";s:5:\"title\";s:7:\"Contact\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:2:\"20\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:562;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:16:\"menu-footer-menu\";s:4:\"mlid\";s:3:\"562\";s:4:\"plid\";s:1:\"0\";s:9:\"link_path\";s:7:\"archive\";s:11:\"router_path\";s:7:\"archive\";s:10:\"link_title\";s:7:\"Archive\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:3:\"-48\";s:5:\"depth\";s:1:\"1\";s:10:\"customized\";s:1:\"1\";s:2:\"p1\";s:3:\"562\";s:2:\"p2\";s:1:\"0\";s:2:\"p3\";s:1:\"0\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:12:\"views_access\";s:16:\"access_arguments\";s:14:\"a:1:{i:0;b:1;}\";s:13:\"page_callback\";s:10:\"views_page\";s:14:\"page_arguments\";s:39:\"a:2:{i:0;s:7:\"archive\";i:1;s:4:\"page\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:7:\"archive\";s:5:\"title\";s:7:\"Archive\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:563;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:16:\"menu-footer-menu\";s:4:\"mlid\";s:3:\"563\";s:4:\"plid\";s:1:\"0\";s:9:\"link_path\";s:8:\"faq-page\";s:11:\"router_path\";s:8:\"faq-page\";s:10:\"link_title\";s:3:\"FAQ\";s:7:\"options\";s:49:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:0:\"\";}}\";s:6:\"module\";s:4:\"menu\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:3:\"-49\";s:5:\"depth\";s:1:\"1\";s:10:\"customized\";s:1:\"1\";s:2:\"p1\";s:3:\"563\";s:2:\"p2\";s:1:\"0\";s:2:\"p3\";s:1:\"0\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:31:\"a:1:{i:0;s:13:\"view faq page\";}\";s:13:\"page_callback\";s:8:\"faq_page\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:8:\"faq-page\";s:5:\"title\";s:26:\"Frequently Asked Questions\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:2:\"20\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}}s:10:\"node_links\";a:0:{}}',0,1512620340,1),('links:menu-links:page:user/1:en:1:0','a:4:{s:9:\"min_depth\";i:1;s:9:\"max_depth\";N;s:8:\"expanded\";a:1:{i:0;i:0;}s:12:\"active_trail\";a:1:{i:0;i:0;}}',0,1512620348,1),('links:menu-links:page:user:en:1:0','a:4:{s:9:\"min_depth\";i:1;s:9:\"max_depth\";N;s:8:\"expanded\";a:1:{i:0;i:0;}s:12:\"active_trail\";a:1:{i:0;i:0;}}',0,1512620340,1),('links:menu-links:tree-data:en:9bd1605e2280833450478f9083b7f8714c2fa28f1012455e2744e5af1a13eec5','a:2:{s:4:\"tree\";a:4:{i:396;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"menu-links\";s:4:\"mlid\";s:3:\"396\";s:4:\"plid\";s:1:\"0\";s:9:\"link_path\";s:15:\"activity-stream\";s:11:\"router_path\";s:15:\"activity-stream\";s:10:\"link_title\";s:13:\" What’s new\";s:7:\"options\";s:49:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:0:\"\";}}\";s:6:\"module\";s:4:\"menu\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"1\";s:10:\"customized\";s:1:\"1\";s:2:\"p1\";s:3:\"396\";s:2:\"p2\";s:1:\"0\";s:2:\"p3\";s:1:\"0\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:12:\"views_access\";s:16:\"access_arguments\";s:14:\"a:1:{i:0;b:1;}\";s:13:\"page_callback\";s:10:\"views_page\";s:14:\"page_arguments\";s:48:\"a:2:{i:0;s:15:\"activity_stream\";i:1;s:4:\"page\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:15:\"activity-stream\";s:5:\"title\";s:10:\"What\'s New\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:397;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"menu-links\";s:4:\"mlid\";s:3:\"397\";s:4:\"plid\";s:1:\"0\";s:9:\"link_path\";s:8:\"articles\";s:11:\"router_path\";s:8:\"articles\";s:10:\"link_title\";s:9:\" Articles\";s:7:\"options\";s:49:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:0:\"\";}}\";s:6:\"module\";s:4:\"menu\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"1\";s:10:\"customized\";s:1:\"1\";s:2:\"p1\";s:3:\"397\";s:2:\"p2\";s:1:\"0\";s:2:\"p3\";s:1:\"0\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:12:\"views_access\";s:16:\"access_arguments\";s:80:\"a:1:{i:0;a:2:{i:0;s:16:\"views_check_perm\";i:1;a:1:{i:0;s:14:\"access content\";}}}\";s:13:\"page_callback\";s:10:\"views_page\";s:14:\"page_arguments\";s:40:\"a:2:{i:0;s:8:\"articles\";i:1;s:4:\"page\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:8:\"articles\";s:5:\"title\";s:8:\"Articles\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:398;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"menu-links\";s:4:\"mlid\";s:3:\"398\";s:4:\"plid\";s:1:\"0\";s:9:\"link_path\";s:5:\"blogs\";s:11:\"router_path\";s:5:\"blogs\";s:10:\"link_title\";s:5:\"Blogs\";s:7:\"options\";s:49:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:0:\"\";}}\";s:6:\"module\";s:4:\"menu\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"1\";s:10:\"customized\";s:1:\"1\";s:2:\"p1\";s:3:\"398\";s:2:\"p2\";s:1:\"0\";s:2:\"p3\";s:1:\"0\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:12:\"views_access\";s:16:\"access_arguments\";s:80:\"a:1:{i:0;a:2:{i:0;s:16:\"views_check_perm\";i:1;a:1:{i:0;s:14:\"access content\";}}}\";s:13:\"page_callback\";s:10:\"views_page\";s:14:\"page_arguments\";s:39:\"a:2:{i:0;s:5:\"blogs\";i:1;s:6:\"page_1\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:5:\"blogs\";s:5:\"title\";s:5:\"Blogs\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:399;a:2:{s:4:\"link\";a:43:{s:9:\"menu_name\";s:10:\"menu-links\";s:4:\"mlid\";s:3:\"399\";s:4:\"plid\";s:1:\"0\";s:9:\"link_path\";s:6:\"node/2\";s:11:\"router_path\";s:6:\"node/%\";s:10:\"link_title\";s:20:\"Community Guidelines\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:4:\"menu\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"1\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:3:\"399\";s:2:\"p2\";s:1:\"0\";s:2:\"p3\";s:1:\"0\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:26:\"a:1:{i:1;s:9:\"node_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"node_access\";s:16:\"access_arguments\";s:29:\"a:2:{i:0;s:4:\"view\";i:1;i:1;}\";s:13:\"page_callback\";s:14:\"node_page_view\";s:14:\"page_arguments\";s:14:\"a:1:{i:0;i:1;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:6:\"node/%\";s:5:\"title\";s:0:\"\";s:14:\"title_callback\";s:15:\"node_page_title\";s:15:\"title_arguments\";s:14:\"a:1:{i:0;i:1;}\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;s:6:\"access\";b:0;}s:5:\"below\";a:0:{}}}s:10:\"node_links\";a:1:{i:2;a:1:{i:399;R:139;}}}',0,1512620340,1),('links:navigation:page:user/1:en:1:0:trail','a:5:{s:9:\"min_depth\";i:1;s:9:\"max_depth\";N;s:17:\"only_active_trail\";b:1;s:8:\"expanded\";a:2:{i:0;i:0;i:16;s:2:\"16\";}s:12:\"active_trail\";a:2:{i:0;i:0;i:16;s:2:\"16\";}}',0,1512620348,1),('links:navigation:tree-data:en:7495eb1e79a64d19a9c75b78fd39b8b17c02b3073c84e89a5069ca6b9c76749c','a:2:{s:4:\"tree\";a:1:{i:6;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"navigation\";s:4:\"mlid\";s:1:\"6\";s:4:\"plid\";s:1:\"0\";s:9:\"link_path\";s:8:\"node/add\";s:11:\"router_path\";s:8:\"node/add\";s:10:\"link_title\";s:11:\"Add content\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"1\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"1\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"6\";s:2:\"p2\";s:1:\"0\";s:2:\"p3\";s:1:\"0\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:16:\"_node_add_access\";s:16:\"access_arguments\";s:6:\"a:0:{}\";s:13:\"page_callback\";s:13:\"node_add_page\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:8:\"node/add\";s:5:\"title\";s:11:\"Add content\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:9:{i:219;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"navigation\";s:4:\"mlid\";s:3:\"219\";s:4:\"plid\";s:1:\"6\";s:9:\"link_path\";s:16:\"node/add/article\";s:11:\"router_path\";s:16:\"node/add/article\";s:10:\"link_title\";s:7:\"Article\";s:7:\"options\";s:139:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:89:\"Use <em>articles</em> for time-sensitive content like news, press releases or blog posts.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"2\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"6\";s:2:\"p2\";s:3:\"219\";s:2:\"p3\";s:1:\"0\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"node_access\";s:16:\"access_arguments\";s:41:\"a:2:{i:0;s:6:\"create\";i:1;s:7:\"article\";}\";s:13:\"page_callback\";s:8:\"node_add\";s:14:\"page_arguments\";s:24:\"a:1:{i:0;s:7:\"article\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:16:\"node/add/article\";s:5:\"title\";s:7:\"Article\";s:14:\"title_callback\";s:11:\"check_plain\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:89:\"Use <em>articles</em> for time-sensitive content like news, press releases or blog posts.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:220;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"navigation\";s:4:\"mlid\";s:3:\"220\";s:4:\"plid\";s:1:\"6\";s:9:\"link_path\";s:13:\"node/add/page\";s:11:\"router_path\";s:13:\"node/add/page\";s:10:\"link_title\";s:10:\"Basic page\";s:7:\"options\";s:127:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:77:\"Use <em>basic pages</em> for your static content, such as an \'About us\' page.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"2\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"6\";s:2:\"p2\";s:3:\"220\";s:2:\"p3\";s:1:\"0\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"node_access\";s:16:\"access_arguments\";s:38:\"a:2:{i:0;s:6:\"create\";i:1;s:4:\"page\";}\";s:13:\"page_callback\";s:8:\"node_add\";s:14:\"page_arguments\";s:21:\"a:1:{i:0;s:4:\"page\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:13:\"node/add/page\";s:5:\"title\";s:10:\"Basic page\";s:14:\"title_callback\";s:11:\"check_plain\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:77:\"Use <em>basic pages</em> for your static content, such as an \'About us\' page.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:313;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"navigation\";s:4:\"mlid\";s:3:\"313\";s:4:\"plid\";s:1:\"6\";s:9:\"link_path\";s:13:\"node/add/blog\";s:11:\"router_path\";s:13:\"node/add/blog\";s:10:\"link_title\";s:10:\"Blog entry\";s:7:\"options\";s:108:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:58:\"Use for multi-user blogs. Every user gets a personal blog.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"2\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"6\";s:2:\"p2\";s:3:\"313\";s:2:\"p3\";s:1:\"0\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"node_access\";s:16:\"access_arguments\";s:38:\"a:2:{i:0;s:6:\"create\";i:1;s:4:\"blog\";}\";s:13:\"page_callback\";s:8:\"node_add\";s:14:\"page_arguments\";s:21:\"a:1:{i:0;s:4:\"blog\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:13:\"node/add/blog\";s:5:\"title\";s:10:\"Blog entry\";s:14:\"title_callback\";s:11:\"check_plain\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:58:\"Use for multi-user blogs. Every user gets a personal blog.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:314;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"navigation\";s:4:\"mlid\";s:3:\"314\";s:4:\"plid\";s:1:\"6\";s:9:\"link_path\";s:13:\"node/add/book\";s:11:\"router_path\";s:13:\"node/add/book\";s:10:\"link_title\";s:9:\"Book page\";s:7:\"options\";s:137:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:87:\"<em>Books</em> have a built-in hierarchical navigation. Use for handbooks or tutorials.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"2\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"6\";s:2:\"p2\";s:3:\"314\";s:2:\"p3\";s:1:\"0\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"node_access\";s:16:\"access_arguments\";s:38:\"a:2:{i:0;s:6:\"create\";i:1;s:4:\"book\";}\";s:13:\"page_callback\";s:8:\"node_add\";s:14:\"page_arguments\";s:21:\"a:1:{i:0;s:4:\"book\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:13:\"node/add/book\";s:5:\"title\";s:9:\"Book page\";s:14:\"title_callback\";s:11:\"check_plain\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:87:\"<em>Books</em> have a built-in hierarchical navigation. Use for handbooks or tutorials.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:316;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"navigation\";s:4:\"mlid\";s:3:\"316\";s:4:\"plid\";s:1:\"6\";s:9:\"link_path\";s:14:\"node/add/forum\";s:11:\"router_path\";s:14:\"node/add/forum\";s:10:\"link_title\";s:11:\"Forum topic\";s:7:\"options\";s:119:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:69:\"A <em>forum topic</em> starts a new discussion thread within a forum.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"2\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"6\";s:2:\"p2\";s:3:\"316\";s:2:\"p3\";s:1:\"0\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"node_access\";s:16:\"access_arguments\";s:39:\"a:2:{i:0;s:6:\"create\";i:1;s:5:\"forum\";}\";s:13:\"page_callback\";s:8:\"node_add\";s:14:\"page_arguments\";s:22:\"a:1:{i:0;s:5:\"forum\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:14:\"node/add/forum\";s:5:\"title\";s:11:\"Forum topic\";s:14:\"title_callback\";s:11:\"check_plain\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:69:\"A <em>forum topic</em> starts a new discussion thread within a forum.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:550;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"navigation\";s:4:\"mlid\";s:3:\"550\";s:4:\"plid\";s:1:\"6\";s:9:\"link_path\";s:12:\"node/add/faq\";s:11:\"router_path\";s:12:\"node/add/faq\";s:10:\"link_title\";s:3:\"FAQ\";s:7:\"options\";s:93:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:43:\"A frequently asked question and its answer.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"2\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"6\";s:2:\"p2\";s:3:\"550\";s:2:\"p3\";s:1:\"0\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"node_access\";s:16:\"access_arguments\";s:37:\"a:2:{i:0;s:6:\"create\";i:1;s:3:\"faq\";}\";s:13:\"page_callback\";s:8:\"node_add\";s:14:\"page_arguments\";s:20:\"a:1:{i:0;s:3:\"faq\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:12:\"node/add/faq\";s:5:\"title\";s:3:\"FAQ\";s:14:\"title_callback\";s:11:\"check_plain\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:43:\"A frequently asked question and its answer.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:579;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"navigation\";s:4:\"mlid\";s:3:\"579\";s:4:\"plid\";s:1:\"6\";s:9:\"link_path\";s:14:\"node/add/video\";s:11:\"router_path\";s:14:\"node/add/video\";s:10:\"link_title\";s:5:\"Video\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"2\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"6\";s:2:\"p2\";s:3:\"579\";s:2:\"p3\";s:1:\"0\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"node_access\";s:16:\"access_arguments\";s:39:\"a:2:{i:0;s:6:\"create\";i:1;s:5:\"video\";}\";s:13:\"page_callback\";s:8:\"node_add\";s:14:\"page_arguments\";s:22:\"a:1:{i:0;s:5:\"video\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:14:\"node/add/video\";s:5:\"title\";s:5:\"Video\";s:14:\"title_callback\";s:11:\"check_plain\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:597;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"navigation\";s:4:\"mlid\";s:3:\"597\";s:4:\"plid\";s:1:\"6\";s:9:\"link_path\";s:16:\"node/add/webform\";s:11:\"router_path\";s:16:\"node/add/webform\";s:10:\"link_title\";s:7:\"Webform\";s:7:\"options\";s:189:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:138:\"Create a new form or questionnaire accessible to users. Submission results and statistics are recorded and accessible to privileged users.\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"2\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"6\";s:2:\"p2\";s:3:\"597\";s:2:\"p3\";s:1:\"0\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"node_access\";s:16:\"access_arguments\";s:41:\"a:2:{i:0;s:6:\"create\";i:1;s:7:\"webform\";}\";s:13:\"page_callback\";s:8:\"node_add\";s:14:\"page_arguments\";s:24:\"a:1:{i:0;s:7:\"webform\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:16:\"node/add/webform\";s:5:\"title\";s:7:\"Webform\";s:14:\"title_callback\";s:11:\"check_plain\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:138:\"Create a new form or questionnaire accessible to users. Submission results and statistics are recorded and accessible to privileged users.\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:638;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"navigation\";s:4:\"mlid\";s:3:\"638\";s:4:\"plid\";s:1:\"6\";s:9:\"link_path\";s:17:\"node/add/products\";s:11:\"router_path\";s:17:\"node/add/products\";s:10:\"link_title\";s:8:\"Products\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"2\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"6\";s:2:\"p2\";s:3:\"638\";s:2:\"p3\";s:1:\"0\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"node_access\";s:16:\"access_arguments\";s:42:\"a:2:{i:0;s:6:\"create\";i:1;s:8:\"products\";}\";s:13:\"page_callback\";s:8:\"node_add\";s:14:\"page_arguments\";s:25:\"a:1:{i:0;s:8:\"products\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:17:\"node/add/products\";s:5:\"title\";s:8:\"Products\";s:14:\"title_callback\";s:11:\"check_plain\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}}}}s:10:\"node_links\";a:0:{}}',0,1512620348,1),('links:navigation:tree-data:en:97525f6ec7b5b737610cb0ad8411748eb071b0286dbb7e6492ad2be89db42e28','a:2:{s:4:\"tree\";a:11:{i:3;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"navigation\";s:4:\"mlid\";s:1:\"3\";s:4:\"plid\";s:1:\"0\";s:9:\"link_path\";s:9:\"comment/%\";s:11:\"router_path\";s:9:\"comment/%\";s:10:\"link_title\";s:17:\"Comment permalink\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"1\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"1\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"3\";s:2:\"p2\";s:1:\"0\";s:2:\"p3\";s:1:\"0\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:12:\"a:1:{i:1;N;}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:33:\"a:1:{i:0;s:15:\"access comments\";}\";s:13:\"page_callback\";s:17:\"comment_permalink\";s:14:\"page_arguments\";s:14:\"a:1:{i:0;i:1;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:9:\"comment/%\";s:5:\"title\";s:17:\"Comment permalink\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:4;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"navigation\";s:4:\"mlid\";s:1:\"4\";s:4:\"plid\";s:1:\"0\";s:9:\"link_path\";s:11:\"filter/tips\";s:11:\"router_path\";s:11:\"filter/tips\";s:10:\"link_title\";s:12:\"Compose tips\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"1\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"1\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"4\";s:2:\"p2\";s:1:\"0\";s:2:\"p3\";s:1:\"0\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:1:\"1\";s:16:\"access_arguments\";s:6:\"a:0:{}\";s:13:\"page_callback\";s:16:\"filter_tips_long\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:11:\"filter/tips\";s:5:\"title\";s:12:\"Compose tips\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:2:\"20\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:5;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"navigation\";s:4:\"mlid\";s:1:\"5\";s:4:\"plid\";s:1:\"0\";s:9:\"link_path\";s:6:\"node/%\";s:11:\"router_path\";s:6:\"node/%\";s:10:\"link_title\";s:0:\"\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"1\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"5\";s:2:\"p2\";s:1:\"0\";s:2:\"p3\";s:1:\"0\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:26:\"a:1:{i:1;s:9:\"node_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"node_access\";s:16:\"access_arguments\";s:29:\"a:2:{i:0;s:4:\"view\";i:1;i:1;}\";s:13:\"page_callback\";s:14:\"node_page_view\";s:14:\"page_arguments\";s:14:\"a:1:{i:0;i:1;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:6:\"node/%\";s:5:\"title\";s:0:\"\";s:14:\"title_callback\";s:15:\"node_page_title\";s:15:\"title_arguments\";s:14:\"a:1:{i:0;i:1;}\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:6;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"navigation\";s:4:\"mlid\";s:1:\"6\";s:4:\"plid\";s:1:\"0\";s:9:\"link_path\";s:8:\"node/add\";s:11:\"router_path\";s:8:\"node/add\";s:10:\"link_title\";s:11:\"Add content\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"1\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"1\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"6\";s:2:\"p2\";s:1:\"0\";s:2:\"p3\";s:1:\"0\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:16:\"_node_add_access\";s:16:\"access_arguments\";s:6:\"a:0:{}\";s:13:\"page_callback\";s:13:\"node_add_page\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:8:\"node/add\";s:5:\"title\";s:11:\"Add content\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:16;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"navigation\";s:4:\"mlid\";s:2:\"16\";s:4:\"plid\";s:1:\"0\";s:9:\"link_path\";s:6:\"user/%\";s:11:\"router_path\";s:6:\"user/%\";s:10:\"link_title\";s:10:\"My account\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"1\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"1\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:2:\"16\";s:2:\"p2\";s:1:\"0\";s:2:\"p3\";s:1:\"0\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:26:\"a:1:{i:1;s:9:\"user_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:16:\"user_view_access\";s:16:\"access_arguments\";s:14:\"a:1:{i:0;i:1;}\";s:13:\"page_callback\";s:14:\"user_view_page\";s:14:\"page_arguments\";s:14:\"a:1:{i:0;i:1;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:6:\"user/%\";s:5:\"title\";s:10:\"My account\";s:14:\"title_callback\";s:15:\"user_page_title\";s:15:\"title_arguments\";s:14:\"a:1:{i:0;i:1;}\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:1;}s:5:\"below\";a:6:{i:29;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"navigation\";s:4:\"mlid\";s:2:\"29\";s:4:\"plid\";s:2:\"16\";s:9:\"link_path\";s:13:\"user/%/cancel\";s:11:\"router_path\";s:13:\"user/%/cancel\";s:10:\"link_title\";s:14:\"Cancel account\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"1\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"2\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:2:\"16\";s:2:\"p2\";s:2:\"29\";s:2:\"p3\";s:1:\"0\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:26:\"a:1:{i:1;s:9:\"user_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:18:\"user_cancel_access\";s:16:\"access_arguments\";s:14:\"a:1:{i:0;i:1;}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:50:\"a:2:{i:0;s:24:\"user_cancel_confirm_form\";i:1;i:1;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:13:\"user/%/cancel\";s:5:\"title\";s:14:\"Cancel account\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:38;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"navigation\";s:4:\"mlid\";s:2:\"38\";s:4:\"plid\";s:2:\"16\";s:9:\"link_path\";s:11:\"user/%/edit\";s:11:\"router_path\";s:11:\"user/%/edit\";s:10:\"link_title\";s:4:\"Edit\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"2\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:2:\"16\";s:2:\"p2\";s:2:\"38\";s:2:\"p3\";s:1:\"0\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:26:\"a:1:{i:1;s:9:\"user_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:16:\"user_edit_access\";s:16:\"access_arguments\";s:14:\"a:1:{i:0;i:1;}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:43:\"a:2:{i:0;s:17:\"user_profile_form\";i:1;i:1;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:6:\"user/%\";s:8:\"tab_root\";s:6:\"user/%\";s:5:\"title\";s:4:\"Edit\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:60;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"navigation\";s:4:\"mlid\";s:2:\"60\";s:4:\"plid\";s:2:\"16\";s:9:\"link_path\";s:11:\"user/%/view\";s:11:\"router_path\";s:11:\"user/%/view\";s:10:\"link_title\";s:4:\"View\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:3:\"-10\";s:5:\"depth\";s:1:\"2\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:2:\"16\";s:2:\"p2\";s:2:\"60\";s:2:\"p3\";s:1:\"0\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:26:\"a:1:{i:1;s:9:\"user_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:16:\"user_view_access\";s:16:\"access_arguments\";s:14:\"a:1:{i:0;i:1;}\";s:13:\"page_callback\";s:14:\"user_view_page\";s:14:\"page_arguments\";s:14:\"a:1:{i:0;i:1;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:6:\"user/%\";s:8:\"tab_root\";s:6:\"user/%\";s:5:\"title\";s:4:\"View\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"140\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:161;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"navigation\";s:4:\"mlid\";s:3:\"161\";s:4:\"plid\";s:2:\"16\";s:9:\"link_path\";s:16:\"user/%/shortcuts\";s:11:\"router_path\";s:16:\"user/%/shortcuts\";s:10:\"link_title\";s:9:\"Shortcuts\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"2\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:2:\"16\";s:2:\"p2\";s:3:\"161\";s:2:\"p3\";s:1:\"0\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:26:\"a:1:{i:1;s:9:\"user_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:26:\"shortcut_set_switch_access\";s:16:\"access_arguments\";s:14:\"a:1:{i:0;i:1;}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:45:\"a:2:{i:0;s:19:\"shortcut_set_switch\";i:1;i:1;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:6:\"user/%\";s:8:\"tab_root\";s:6:\"user/%\";s:5:\"title\";s:9:\"Shortcuts\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:404;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"navigation\";s:4:\"mlid\";s:3:\"404\";s:4:\"plid\";s:2:\"16\";s:9:\"link_path\";s:14:\"user/%/contact\";s:11:\"router_path\";s:14:\"user/%/contact\";s:10:\"link_title\";s:7:\"Contact\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"2\";s:5:\"depth\";s:1:\"2\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:2:\"16\";s:2:\"p2\";s:3:\"404\";s:2:\"p3\";s:1:\"0\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:26:\"a:1:{i:1;s:9:\"user_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:28:\"_contact_personal_tab_access\";s:16:\"access_arguments\";s:14:\"a:1:{i:0;i:1;}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:47:\"a:2:{i:0;s:21:\"contact_personal_form\";i:1;i:1;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:6:\"user/%\";s:8:\"tab_root\";s:6:\"user/%\";s:5:\"title\";s:7:\"Contact\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:435;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"navigation\";s:4:\"mlid\";s:3:\"435\";s:4:\"plid\";s:2:\"16\";s:9:\"link_path\";s:23:\"user/%/track/navigation\";s:11:\"router_path\";s:23:\"user/%/track/navigation\";s:10:\"link_title\";s:17:\"Track page visits\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"2\";s:5:\"depth\";s:1:\"2\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:2:\"16\";s:2:\"p2\";s:3:\"435\";s:2:\"p3\";s:1:\"0\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:26:\"a:1:{i:1;s:9:\"user_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:35:\"a:1:{i:0;s:17:\"access statistics\";}\";s:13:\"page_callback\";s:23:\"statistics_user_tracker\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:6:\"user/%\";s:8:\"tab_root\";s:6:\"user/%\";s:5:\"title\";s:17:\"Track page visits\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}}}i:22;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"navigation\";s:4:\"mlid\";s:2:\"22\";s:4:\"plid\";s:1:\"0\";s:9:\"link_path\";s:15:\"comment/reply/%\";s:11:\"router_path\";s:15:\"comment/reply/%\";s:10:\"link_title\";s:15:\"Add new comment\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"1\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:2:\"22\";s:2:\"p2\";s:1:\"0\";s:2:\"p3\";s:1:\"0\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:26:\"a:1:{i:2;s:9:\"node_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"node_access\";s:16:\"access_arguments\";s:29:\"a:2:{i:0;s:4:\"view\";i:1;i:2;}\";s:13:\"page_callback\";s:13:\"comment_reply\";s:14:\"page_arguments\";s:14:\"a:1:{i:0;i:2;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:15:\"comment/reply/%\";s:5:\"title\";s:15:\"Add new comment\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:159;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"navigation\";s:4:\"mlid\";s:3:\"159\";s:4:\"plid\";s:1:\"0\";s:9:\"link_path\";s:15:\"taxonomy/term/%\";s:11:\"router_path\";s:15:\"taxonomy/term/%\";s:10:\"link_title\";s:13:\"Taxonomy term\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"1\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:3:\"159\";s:2:\"p2\";s:1:\"0\";s:2:\"p3\";s:1:\"0\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:36:\"a:1:{i:2;s:18:\"taxonomy_term_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:32:\"a:1:{i:0;s:14:\"access content\";}\";s:13:\"page_callback\";s:23:\"i18n_taxonomy_term_page\";s:14:\"page_arguments\";s:14:\"a:1:{i:0;i:2;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:15:\"taxonomy/term/%\";s:5:\"title\";s:13:\"Taxonomy term\";s:14:\"title_callback\";s:23:\"i18n_taxonomy_term_name\";s:15:\"title_arguments\";s:14:\"a:1:{i:0;i:2;}\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:415;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"navigation\";s:4:\"mlid\";s:3:\"415\";s:4:\"plid\";s:1:\"0\";s:9:\"link_path\";s:9:\"tagclouds\";s:11:\"router_path\";s:9:\"tagclouds\";s:10:\"link_title\";s:4:\"Tags\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"1\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:3:\"415\";s:2:\"p2\";s:1:\"0\";s:2:\"p3\";s:1:\"0\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:32:\"a:1:{i:0;s:14:\"access content\";}\";s:13:\"page_callback\";s:20:\"tagclouds_page_chunk\";s:14:\"page_arguments\";s:12:\"a:1:{i:0;N;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:9:\"tagclouds\";s:5:\"title\";s:4:\"Tags\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:2:\"20\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:450;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"navigation\";s:4:\"mlid\";s:3:\"450\";s:4:\"plid\";s:1:\"0\";s:9:\"link_path\";s:15:\"message-example\";s:11:\"router_path\";s:15:\"message-example\";s:10:\"link_title\";s:15:\"Message example\";s:7:\"options\";s:85:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:35:\"Typical UAS (User activity stream).\";}}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"1\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:3:\"450\";s:2:\"p2\";s:1:\"0\";s:2:\"p3\";s:1:\"0\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:12:\"views_access\";s:16:\"access_arguments\";s:14:\"a:1:{i:0;b:1;}\";s:13:\"page_callback\";s:10:\"views_page\";s:14:\"page_arguments\";s:48:\"a:2:{i:0;s:15:\"message_example\";i:1;s:4:\"page\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:15:\"message-example\";s:5:\"title\";s:15:\"Message example\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:35:\"Typical UAS (User activity stream).\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:658;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"navigation\";s:4:\"mlid\";s:3:\"658\";s:4:\"plid\";s:1:\"0\";s:9:\"link_path\";s:38:\"field-collection/field-extra-content/%\";s:11:\"router_path\";s:38:\"field-collection/field-extra-content/%\";s:10:\"link_title\";s:0:\"\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"1\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"1\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:3:\"658\";s:2:\"p2\";s:1:\"0\";s:2:\"p3\";s:1:\"0\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:44:\"a:1:{i:2;s:26:\"field_collection_item_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:28:\"field_collection_item_access\";s:16:\"access_arguments\";s:29:\"a:2:{i:0;s:4:\"view\";i:1;i:2;}\";s:13:\"page_callback\";s:31:\"field_collection_item_page_view\";s:14:\"page_arguments\";s:14:\"a:1:{i:0;i:2;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:38:\"field-collection/field-extra-content/%\";s:5:\"title\";s:0:\"\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:663;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:10:\"navigation\";s:4:\"mlid\";s:3:\"663\";s:4:\"plid\";s:1:\"0\";s:9:\"link_path\";s:44:\"field-collection/field-extra-content/add/%/%\";s:11:\"router_path\";s:44:\"field-collection/field-extra-content/add/%/%\";s:10:\"link_title\";s:0:\"\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"1\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:3:\"663\";s:2:\"p2\";s:1:\"0\";s:2:\"p3\";s:1:\"0\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:18:\"a:2:{i:3;N;i:4;N;}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:1:\"1\";s:16:\"access_arguments\";s:6:\"a:0:{}\";s:13:\"page_callback\";s:25:\"field_collection_item_add\";s:14:\"page_arguments\";s:53:\"a:3:{i:0;s:19:\"field_extra_content\";i:1;i:3;i:2;i:4;}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:44:\"field-collection/field-extra-content/add/%/%\";s:5:\"title\";s:0:\"\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}}s:10:\"node_links\";a:0:{}}',0,1512620348,1),('links:user-menu:page:user/1:en:1:0','a:4:{s:9:\"min_depth\";i:1;s:9:\"max_depth\";N;s:8:\"expanded\";a:1:{i:0;i:0;}s:12:\"active_trail\";a:1:{i:0;i:0;}}',0,1512620348,1),('links:user-menu:page:user:en:1:0','a:4:{s:9:\"min_depth\";i:1;s:9:\"max_depth\";N;s:8:\"expanded\";a:2:{i:0;i:0;i:2;s:1:\"2\";}s:12:\"active_trail\";a:2:{i:0;i:0;i:2;s:1:\"2\";}}',0,1512620340,1),('links:user-menu:page:user:en:1:0:trail','a:5:{s:9:\"min_depth\";i:1;s:9:\"max_depth\";N;s:17:\"only_active_trail\";b:1;s:8:\"expanded\";a:2:{i:0;i:0;i:2;s:1:\"2\";}s:12:\"active_trail\";a:2:{i:0;i:0;i:2;s:1:\"2\";}}',0,1512620340,1),('links:user-menu:tree-data:en:748dd6d28b004aaae1c5adb20e9fb30e8a0a55bb2291fd8e1ed7199ff4266657','a:2:{s:4:\"tree\";a:3:{i:2;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:9:\"user-menu\";s:4:\"mlid\";s:1:\"2\";s:4:\"plid\";s:1:\"0\";s:9:\"link_path\";s:4:\"user\";s:11:\"router_path\";s:4:\"user\";s:10:\"link_title\";s:12:\"User account\";s:7:\"options\";s:22:\"a:1:{s:5:\"alter\";b:1;}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:3:\"-10\";s:5:\"depth\";s:1:\"1\";s:10:\"customized\";s:1:\"1\";s:2:\"p1\";s:1:\"2\";s:2:\"p2\";s:1:\"0\";s:2:\"p3\";s:1:\"0\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:1:\"1\";s:16:\"access_arguments\";s:6:\"a:0:{}\";s:13:\"page_callback\";s:9:\"user_page\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:4:\"user\";s:5:\"title\";s:12:\"User account\";s:14:\"title_callback\";s:15:\"user_menu_title\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:1;}s:5:\"below\";a:3:{i:10;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:9:\"user-menu\";s:4:\"mlid\";s:2:\"10\";s:4:\"plid\";s:1:\"2\";s:9:\"link_path\";s:13:\"user/register\";s:11:\"router_path\";s:13:\"user/register\";s:10:\"link_title\";s:18:\"Create new account\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"2\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"2\";s:2:\"p2\";s:2:\"10\";s:2:\"p3\";s:1:\"0\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:20:\"user_register_access\";s:16:\"access_arguments\";s:6:\"a:0:{}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:36:\"a:1:{i:0;s:18:\"user_register_form\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:4:\"user\";s:8:\"tab_root\";s:4:\"user\";s:5:\"title\";s:18:\"Create new account\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:13;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:9:\"user-menu\";s:4:\"mlid\";s:2:\"13\";s:4:\"plid\";s:1:\"2\";s:9:\"link_path\";s:10:\"user/login\";s:11:\"router_path\";s:10:\"user/login\";s:10:\"link_title\";s:6:\"Log in\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"2\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"2\";s:2:\"p2\";s:2:\"13\";s:2:\"p3\";s:1:\"0\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:17:\"user_is_anonymous\";s:16:\"access_arguments\";s:6:\"a:0:{}\";s:13:\"page_callback\";s:9:\"user_page\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:4:\"user\";s:8:\"tab_root\";s:4:\"user\";s:5:\"title\";s:6:\"Log in\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"140\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:19;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:9:\"user-menu\";s:4:\"mlid\";s:2:\"19\";s:4:\"plid\";s:1:\"2\";s:9:\"link_path\";s:13:\"user/password\";s:11:\"router_path\";s:13:\"user/password\";s:10:\"link_title\";s:20:\"Request new password\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"2\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"2\";s:2:\"p2\";s:2:\"19\";s:2:\"p3\";s:1:\"0\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:1:\"1\";s:16:\"access_arguments\";s:6:\"a:0:{}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:26:\"a:1:{i:0;s:9:\"user_pass\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:4:\"user\";s:8:\"tab_root\";s:4:\"user\";s:5:\"title\";s:20:\"Request new password\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}}}i:14;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:9:\"user-menu\";s:4:\"mlid\";s:2:\"14\";s:4:\"plid\";s:1:\"0\";s:9:\"link_path\";s:11:\"user/logout\";s:11:\"router_path\";s:11:\"user/logout\";s:10:\"link_title\";s:7:\"Log out\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:2:\"10\";s:5:\"depth\";s:1:\"1\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:2:\"14\";s:2:\"p2\";s:1:\"0\";s:2:\"p3\";s:1:\"0\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:17:\"user_is_logged_in\";s:16:\"access_arguments\";s:6:\"a:0:{}\";s:13:\"page_callback\";s:11:\"user_logout\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:11:\"user/logout\";s:5:\"title\";s:7:\"Log out\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:426;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:9:\"user-menu\";s:4:\"mlid\";s:3:\"426\";s:4:\"plid\";s:1:\"0\";s:9:\"link_path\";s:10:\"user/login\";s:11:\"router_path\";s:10:\"user/login\";s:10:\"link_title\";s:5:\"Login\";s:7:\"options\";s:49:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:0:\"\";}}\";s:6:\"module\";s:4:\"menu\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"1\";s:10:\"customized\";s:1:\"1\";s:2:\"p1\";s:3:\"426\";s:2:\"p2\";s:1:\"0\";s:2:\"p3\";s:1:\"0\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:17:\"user_is_anonymous\";s:16:\"access_arguments\";s:6:\"a:0:{}\";s:13:\"page_callback\";s:9:\"user_page\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:4:\"user\";s:8:\"tab_root\";s:4:\"user\";s:5:\"title\";s:6:\"Log in\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"140\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}}s:10:\"node_links\";a:0:{}}',0,1512620340,1),('links:user-menu:tree-data:en:8363ec2e0ccba44290caa33c11240d14f009ab1ad8b56c71409b28e6a86e86be','a:2:{s:4:\"tree\";a:3:{i:2;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:9:\"user-menu\";s:4:\"mlid\";s:1:\"2\";s:4:\"plid\";s:1:\"0\";s:9:\"link_path\";s:4:\"user\";s:11:\"router_path\";s:4:\"user\";s:10:\"link_title\";s:12:\"User account\";s:7:\"options\";s:22:\"a:1:{s:5:\"alter\";b:1;}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:3:\"-10\";s:5:\"depth\";s:1:\"1\";s:10:\"customized\";s:1:\"1\";s:2:\"p1\";s:1:\"2\";s:2:\"p2\";s:1:\"0\";s:2:\"p3\";s:1:\"0\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:1:\"1\";s:16:\"access_arguments\";s:6:\"a:0:{}\";s:13:\"page_callback\";s:9:\"user_page\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:4:\"user\";s:5:\"title\";s:12:\"User account\";s:14:\"title_callback\";s:15:\"user_menu_title\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:1;}s:5:\"below\";a:3:{i:10;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:9:\"user-menu\";s:4:\"mlid\";s:2:\"10\";s:4:\"plid\";s:1:\"2\";s:9:\"link_path\";s:13:\"user/register\";s:11:\"router_path\";s:13:\"user/register\";s:10:\"link_title\";s:18:\"Create new account\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"2\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"2\";s:2:\"p2\";s:2:\"10\";s:2:\"p3\";s:1:\"0\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:20:\"user_register_access\";s:16:\"access_arguments\";s:6:\"a:0:{}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:36:\"a:1:{i:0;s:18:\"user_register_form\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:4:\"user\";s:8:\"tab_root\";s:4:\"user\";s:5:\"title\";s:18:\"Create new account\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:13;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:9:\"user-menu\";s:4:\"mlid\";s:2:\"13\";s:4:\"plid\";s:1:\"2\";s:9:\"link_path\";s:10:\"user/login\";s:11:\"router_path\";s:10:\"user/login\";s:10:\"link_title\";s:6:\"Log in\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"2\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"2\";s:2:\"p2\";s:2:\"13\";s:2:\"p3\";s:1:\"0\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:17:\"user_is_anonymous\";s:16:\"access_arguments\";s:6:\"a:0:{}\";s:13:\"page_callback\";s:9:\"user_page\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:4:\"user\";s:8:\"tab_root\";s:4:\"user\";s:5:\"title\";s:6:\"Log in\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"140\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:19;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:9:\"user-menu\";s:4:\"mlid\";s:2:\"19\";s:4:\"plid\";s:1:\"2\";s:9:\"link_path\";s:13:\"user/password\";s:11:\"router_path\";s:13:\"user/password\";s:10:\"link_title\";s:20:\"Request new password\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:2:\"-1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"2\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:1:\"2\";s:2:\"p2\";s:2:\"19\";s:2:\"p3\";s:1:\"0\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:1:\"1\";s:16:\"access_arguments\";s:6:\"a:0:{}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:26:\"a:1:{i:0;s:9:\"user_pass\";}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:4:\"user\";s:8:\"tab_root\";s:4:\"user\";s:5:\"title\";s:20:\"Request new password\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}}}i:14;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:9:\"user-menu\";s:4:\"mlid\";s:2:\"14\";s:4:\"plid\";s:1:\"0\";s:9:\"link_path\";s:11:\"user/logout\";s:11:\"router_path\";s:11:\"user/logout\";s:10:\"link_title\";s:7:\"Log out\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:2:\"10\";s:5:\"depth\";s:1:\"1\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:2:\"14\";s:2:\"p2\";s:1:\"0\";s:2:\"p3\";s:1:\"0\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:17:\"user_is_logged_in\";s:16:\"access_arguments\";s:6:\"a:0:{}\";s:13:\"page_callback\";s:11:\"user_logout\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:11:\"user/logout\";s:5:\"title\";s:7:\"Log out\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:426;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:9:\"user-menu\";s:4:\"mlid\";s:3:\"426\";s:4:\"plid\";s:1:\"0\";s:9:\"link_path\";s:10:\"user/login\";s:11:\"router_path\";s:10:\"user/login\";s:10:\"link_title\";s:5:\"Login\";s:7:\"options\";s:49:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:0:\"\";}}\";s:6:\"module\";s:4:\"menu\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"1\";s:10:\"customized\";s:1:\"1\";s:2:\"p1\";s:3:\"426\";s:2:\"p2\";s:1:\"0\";s:2:\"p3\";s:1:\"0\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:17:\"user_is_anonymous\";s:16:\"access_arguments\";s:6:\"a:0:{}\";s:13:\"page_callback\";s:9:\"user_page\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:4:\"user\";s:8:\"tab_root\";s:4:\"user\";s:5:\"title\";s:6:\"Log in\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"140\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}}s:10:\"node_links\";a:0:{}}',0,1512620340,1),('links:user-menu:tree-data:en:9bd1605e2280833450478f9083b7f8714c2fa28f1012455e2744e5af1a13eec5','a:2:{s:4:\"tree\";a:3:{i:2;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:9:\"user-menu\";s:4:\"mlid\";s:1:\"2\";s:4:\"plid\";s:1:\"0\";s:9:\"link_path\";s:4:\"user\";s:11:\"router_path\";s:4:\"user\";s:10:\"link_title\";s:12:\"User account\";s:7:\"options\";s:22:\"a:1:{s:5:\"alter\";b:1;}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"1\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:3:\"-10\";s:5:\"depth\";s:1:\"1\";s:10:\"customized\";s:1:\"1\";s:2:\"p1\";s:1:\"2\";s:2:\"p2\";s:1:\"0\";s:2:\"p3\";s:1:\"0\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:1:\"1\";s:16:\"access_arguments\";s:6:\"a:0:{}\";s:13:\"page_callback\";s:9:\"user_page\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:4:\"user\";s:5:\"title\";s:12:\"User account\";s:14:\"title_callback\";s:15:\"user_menu_title\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:14;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:9:\"user-menu\";s:4:\"mlid\";s:2:\"14\";s:4:\"plid\";s:1:\"0\";s:9:\"link_path\";s:11:\"user/logout\";s:11:\"router_path\";s:11:\"user/logout\";s:10:\"link_title\";s:7:\"Log out\";s:7:\"options\";s:6:\"a:0:{}\";s:6:\"module\";s:6:\"system\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:2:\"10\";s:5:\"depth\";s:1:\"1\";s:10:\"customized\";s:1:\"0\";s:2:\"p1\";s:2:\"14\";s:2:\"p2\";s:1:\"0\";s:2:\"p3\";s:1:\"0\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:17:\"user_is_logged_in\";s:16:\"access_arguments\";s:6:\"a:0:{}\";s:13:\"page_callback\";s:11:\"user_logout\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:11:\"user/logout\";s:5:\"title\";s:7:\"Log out\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}i:426;a:2:{s:4:\"link\";a:42:{s:9:\"menu_name\";s:9:\"user-menu\";s:4:\"mlid\";s:3:\"426\";s:4:\"plid\";s:1:\"0\";s:9:\"link_path\";s:10:\"user/login\";s:11:\"router_path\";s:10:\"user/login\";s:10:\"link_title\";s:5:\"Login\";s:7:\"options\";s:49:\"a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:0:\"\";}}\";s:6:\"module\";s:4:\"menu\";s:6:\"hidden\";s:1:\"0\";s:8:\"external\";s:1:\"0\";s:12:\"has_children\";s:1:\"0\";s:8:\"expanded\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:5:\"depth\";s:1:\"1\";s:10:\"customized\";s:1:\"1\";s:2:\"p1\";s:3:\"426\";s:2:\"p2\";s:1:\"0\";s:2:\"p3\";s:1:\"0\";s:2:\"p4\";s:1:\"0\";s:2:\"p5\";s:1:\"0\";s:2:\"p6\";s:1:\"0\";s:2:\"p7\";s:1:\"0\";s:2:\"p8\";s:1:\"0\";s:2:\"p9\";s:1:\"0\";s:7:\"updated\";s:1:\"0\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:17:\"user_is_anonymous\";s:16:\"access_arguments\";s:6:\"a:0:{}\";s:13:\"page_callback\";s:9:\"user_page\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:10:\"tab_parent\";s:4:\"user\";s:8:\"tab_root\";s:4:\"user\";s:5:\"title\";s:6:\"Log in\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"140\";s:11:\"description\";s:0:\"\";s:15:\"in_active_trail\";b:0;}s:5:\"below\";a:0:{}}}s:10:\"node_links\";a:0:{}}',0,1512620348,1),('local_tasks:user','a:4:{i:0;a:23:{s:4:\"path\";s:4:\"user\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:1:\"1\";s:16:\"access_arguments\";s:6:\"a:0:{}\";s:13:\"page_callback\";s:9:\"user_page\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:3:\"fit\";s:1:\"1\";s:12:\"number_parts\";s:1:\"1\";s:7:\"context\";s:1:\"0\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:4:\"user\";s:5:\"title\";s:12:\"User account\";s:14:\"title_callback\";s:15:\"user_menu_title\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:0:\"\";s:8:\"position\";s:0:\"\";s:6:\"weight\";s:3:\"-10\";s:12:\"include_file\";s:27:\"modules/user/user.pages.inc\";}i:1;a:23:{s:4:\"path\";s:13:\"user/register\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:20:\"user_register_access\";s:16:\"access_arguments\";s:6:\"a:0:{}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:36:\"a:1:{i:0;s:18:\"user_register_form\";}\";s:17:\"delivery_callback\";s:0:\"\";s:3:\"fit\";s:1:\"3\";s:12:\"number_parts\";s:1:\"2\";s:7:\"context\";s:1:\"1\";s:10:\"tab_parent\";s:4:\"user\";s:8:\"tab_root\";s:4:\"user\";s:5:\"title\";s:18:\"Create new account\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:8:\"position\";s:0:\"\";s:6:\"weight\";s:1:\"0\";s:12:\"include_file\";s:0:\"\";}i:2;a:23:{s:4:\"path\";s:10:\"user/login\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:17:\"user_is_anonymous\";s:16:\"access_arguments\";s:6:\"a:0:{}\";s:13:\"page_callback\";s:9:\"user_page\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:3:\"fit\";s:1:\"3\";s:12:\"number_parts\";s:1:\"2\";s:7:\"context\";s:1:\"1\";s:10:\"tab_parent\";s:4:\"user\";s:8:\"tab_root\";s:4:\"user\";s:5:\"title\";s:6:\"Log in\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"140\";s:11:\"description\";s:0:\"\";s:8:\"position\";s:0:\"\";s:6:\"weight\";s:1:\"0\";s:12:\"include_file\";s:27:\"modules/user/user.pages.inc\";}i:3;a:23:{s:4:\"path\";s:13:\"user/password\";s:14:\"load_functions\";s:0:\"\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:1:\"1\";s:16:\"access_arguments\";s:6:\"a:0:{}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:26:\"a:1:{i:0;s:9:\"user_pass\";}\";s:17:\"delivery_callback\";s:0:\"\";s:3:\"fit\";s:1:\"3\";s:12:\"number_parts\";s:1:\"2\";s:7:\"context\";s:1:\"1\";s:10:\"tab_parent\";s:4:\"user\";s:8:\"tab_root\";s:4:\"user\";s:5:\"title\";s:20:\"Request new password\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:8:\"position\";s:0:\"\";s:6:\"weight\";s:1:\"0\";s:12:\"include_file\";s:27:\"modules/user/user.pages.inc\";}}',0,1512620340,1),('local_tasks:user/%','a:7:{i:0;a:23:{s:4:\"path\";s:11:\"user/%/view\";s:14:\"load_functions\";s:26:\"a:1:{i:1;s:9:\"user_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:16:\"user_view_access\";s:16:\"access_arguments\";s:14:\"a:1:{i:0;i:1;}\";s:13:\"page_callback\";s:14:\"user_view_page\";s:14:\"page_arguments\";s:14:\"a:1:{i:0;i:1;}\";s:17:\"delivery_callback\";s:0:\"\";s:3:\"fit\";s:1:\"5\";s:12:\"number_parts\";s:1:\"3\";s:7:\"context\";s:1:\"1\";s:10:\"tab_parent\";s:6:\"user/%\";s:8:\"tab_root\";s:6:\"user/%\";s:5:\"title\";s:4:\"View\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"140\";s:11:\"description\";s:0:\"\";s:8:\"position\";s:0:\"\";s:6:\"weight\";s:3:\"-10\";s:12:\"include_file\";s:0:\"\";}i:1;a:23:{s:4:\"path\";s:19:\"user/%/edit/account\";s:14:\"load_functions\";s:80:\"a:1:{i:1;a:1:{s:18:\"user_category_load\";a:2:{i:0;s:4:\"%map\";i:1;s:6:\"%index\";}}}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:16:\"user_edit_access\";s:16:\"access_arguments\";s:14:\"a:1:{i:0;i:1;}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:43:\"a:2:{i:0;s:17:\"user_profile_form\";i:1;i:1;}\";s:17:\"delivery_callback\";s:0:\"\";s:3:\"fit\";s:2:\"11\";s:12:\"number_parts\";s:1:\"4\";s:7:\"context\";s:1:\"1\";s:10:\"tab_parent\";s:11:\"user/%/edit\";s:8:\"tab_root\";s:6:\"user/%\";s:5:\"title\";s:7:\"Account\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"140\";s:11:\"description\";s:0:\"\";s:8:\"position\";s:0:\"\";s:6:\"weight\";s:1:\"0\";s:12:\"include_file\";s:27:\"modules/user/user.pages.inc\";}i:2;a:23:{s:4:\"path\";s:11:\"user/%/edit\";s:14:\"load_functions\";s:26:\"a:1:{i:1;s:9:\"user_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:16:\"user_edit_access\";s:16:\"access_arguments\";s:14:\"a:1:{i:0;i:1;}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:43:\"a:2:{i:0;s:17:\"user_profile_form\";i:1;i:1;}\";s:17:\"delivery_callback\";s:0:\"\";s:3:\"fit\";s:1:\"5\";s:12:\"number_parts\";s:1:\"3\";s:7:\"context\";s:1:\"1\";s:10:\"tab_parent\";s:6:\"user/%\";s:8:\"tab_root\";s:6:\"user/%\";s:5:\"title\";s:4:\"Edit\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:8:\"position\";s:0:\"\";s:6:\"weight\";s:1:\"0\";s:12:\"include_file\";s:27:\"modules/user/user.pages.inc\";}i:3;a:23:{s:4:\"path\";s:6:\"user/%\";s:14:\"load_functions\";s:26:\"a:1:{i:1;s:9:\"user_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:16:\"user_view_access\";s:16:\"access_arguments\";s:14:\"a:1:{i:0;i:1;}\";s:13:\"page_callback\";s:14:\"user_view_page\";s:14:\"page_arguments\";s:14:\"a:1:{i:0;i:1;}\";s:17:\"delivery_callback\";s:0:\"\";s:3:\"fit\";s:1:\"2\";s:12:\"number_parts\";s:1:\"2\";s:7:\"context\";s:1:\"0\";s:10:\"tab_parent\";s:0:\"\";s:8:\"tab_root\";s:6:\"user/%\";s:5:\"title\";s:10:\"My account\";s:14:\"title_callback\";s:15:\"user_page_title\";s:15:\"title_arguments\";s:14:\"a:1:{i:0;i:1;}\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:1:\"6\";s:11:\"description\";s:0:\"\";s:8:\"position\";s:0:\"\";s:6:\"weight\";s:1:\"0\";s:12:\"include_file\";s:0:\"\";}i:4;a:23:{s:4:\"path\";s:16:\"user/%/shortcuts\";s:14:\"load_functions\";s:26:\"a:1:{i:1;s:9:\"user_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:26:\"shortcut_set_switch_access\";s:16:\"access_arguments\";s:14:\"a:1:{i:0;i:1;}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:45:\"a:2:{i:0;s:19:\"shortcut_set_switch\";i:1;i:1;}\";s:17:\"delivery_callback\";s:0:\"\";s:3:\"fit\";s:1:\"5\";s:12:\"number_parts\";s:1:\"3\";s:7:\"context\";s:1:\"1\";s:10:\"tab_parent\";s:6:\"user/%\";s:8:\"tab_root\";s:6:\"user/%\";s:5:\"title\";s:9:\"Shortcuts\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:8:\"position\";s:0:\"\";s:6:\"weight\";s:1:\"0\";s:12:\"include_file\";s:35:\"modules/shortcut/shortcut.admin.inc\";}i:5;a:23:{s:4:\"path\";s:14:\"user/%/contact\";s:14:\"load_functions\";s:26:\"a:1:{i:1;s:9:\"user_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:28:\"_contact_personal_tab_access\";s:16:\"access_arguments\";s:14:\"a:1:{i:0;i:1;}\";s:13:\"page_callback\";s:15:\"drupal_get_form\";s:14:\"page_arguments\";s:47:\"a:2:{i:0;s:21:\"contact_personal_form\";i:1;i:1;}\";s:17:\"delivery_callback\";s:0:\"\";s:3:\"fit\";s:1:\"5\";s:12:\"number_parts\";s:1:\"3\";s:7:\"context\";s:1:\"1\";s:10:\"tab_parent\";s:6:\"user/%\";s:8:\"tab_root\";s:6:\"user/%\";s:5:\"title\";s:7:\"Contact\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:8:\"position\";s:0:\"\";s:6:\"weight\";s:1:\"2\";s:12:\"include_file\";s:33:\"modules/contact/contact.pages.inc\";}i:6;a:23:{s:4:\"path\";s:23:\"user/%/track/navigation\";s:14:\"load_functions\";s:26:\"a:1:{i:1;s:9:\"user_load\";}\";s:16:\"to_arg_functions\";s:0:\"\";s:15:\"access_callback\";s:11:\"user_access\";s:16:\"access_arguments\";s:35:\"a:1:{i:0;s:17:\"access statistics\";}\";s:13:\"page_callback\";s:23:\"statistics_user_tracker\";s:14:\"page_arguments\";s:6:\"a:0:{}\";s:17:\"delivery_callback\";s:0:\"\";s:3:\"fit\";s:2:\"11\";s:12:\"number_parts\";s:1:\"4\";s:7:\"context\";s:1:\"1\";s:10:\"tab_parent\";s:6:\"user/%\";s:8:\"tab_root\";s:6:\"user/%\";s:5:\"title\";s:17:\"Track page visits\";s:14:\"title_callback\";s:1:\"t\";s:15:\"title_arguments\";s:0:\"\";s:14:\"theme_callback\";s:0:\"\";s:15:\"theme_arguments\";s:6:\"a:0:{}\";s:4:\"type\";s:3:\"132\";s:11:\"description\";s:0:\"\";s:8:\"position\";s:0:\"\";s:6:\"weight\";s:1:\"2\";s:12:\"include_file\";s:39:\"modules/statistics/statistics.pages.inc\";}}',0,1512620348,1),('menu_custom','a:9:{s:8:\"features\";a:3:{s:9:\"menu_name\";s:8:\"features\";s:5:\"title\";s:8:\"Features\";s:11:\"description\";s:36:\"Menu items for any enabled features.\";}s:9:\"main-menu\";a:3:{s:9:\"menu_name\";s:9:\"main-menu\";s:5:\"title\";s:9:\"Main menu\";s:11:\"description\";s:115:\"The <em>Main</em> menu is used on many sites to show the major sections of the site, often in a top navigation bar.\";}s:10:\"management\";a:3:{s:9:\"menu_name\";s:10:\"management\";s:5:\"title\";s:10:\"Management\";s:11:\"description\";s:69:\"The <em>Management</em> menu contains links for administrative tasks.\";}s:15:\"menu-categories\";a:3:{s:9:\"menu_name\";s:15:\"menu-categories\";s:5:\"title\";s:10:\"Categories\";s:11:\"description\";s:0:\"\";}s:16:\"menu-footer-menu\";a:3:{s:9:\"menu_name\";s:16:\"menu-footer-menu\";s:5:\"title\";s:11:\"Footer menu\";s:11:\"description\";s:0:\"\";}s:10:\"menu-links\";a:3:{s:9:\"menu_name\";s:10:\"menu-links\";s:5:\"title\";s:5:\"Links\";s:11:\"description\";s:0:\"\";}s:13:\"menu-sections\";a:3:{s:9:\"menu_name\";s:13:\"menu-sections\";s:5:\"title\";s:8:\"Sections\";s:11:\"description\";s:0:\"\";}s:10:\"navigation\";a:3:{s:9:\"menu_name\";s:10:\"navigation\";s:5:\"title\";s:10:\"Navigation\";s:11:\"description\";s:150:\"The <em>Navigation</em> menu contains links intended for site visitors. Links are added to the <em>Navigation</em> menu automatically by some modules.\";}s:9:\"user-menu\";a:3:{s:9:\"menu_name\";s:9:\"user-menu\";s:5:\"title\";s:9:\"User menu\";s:11:\"description\";s:99:\"The <em>User</em> menu contains links related to the user\'s account, as well as the \'Log out\' link.\";}}',0,1512620328,1);
/*!40000 ALTER TABLE `cache_menu` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `cache_page`
--

DROP TABLE IF EXISTS `cache_page`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `cache_page` (
  `cid` varchar(255) NOT NULL DEFAULT '' COMMENT 'Primary Key: Unique cache ID.',
  `data` longblob COMMENT 'A collection of data to cache.',
  `expire` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry should expire, or 0 for never.',
  `created` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry was created.',
  `serialized` smallint(6) NOT NULL DEFAULT '0' COMMENT 'A flag to indicate whether content is serialized (1) or not (0).',
  PRIMARY KEY (`cid`),
  KEY `expire` (`expire`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Cache table used to store compressed pages for anonymous...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `cache_page`
--

LOCK TABLES `cache_page` WRITE;
/*!40000 ALTER TABLE `cache_page` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `cache_page` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `cache_path`
--

DROP TABLE IF EXISTS `cache_path`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `cache_path` (
  `cid` varchar(255) NOT NULL DEFAULT '' COMMENT 'Primary Key: Unique cache ID.',
  `data` longblob COMMENT 'A collection of data to cache.',
  `expire` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry should expire, or 0 for never.',
  `created` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry was created.',
  `serialized` smallint(6) NOT NULL DEFAULT '0' COMMENT 'A flag to indicate whether content is serialized (1) or not (0).',
  PRIMARY KEY (`cid`),
  KEY `expire` (`expire`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Cache table for path alias lookup.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `cache_path`
--

LOCK TABLES `cache_path` WRITE;
/*!40000 ALTER TABLE `cache_path` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `cache_path` VALUES ('user','a:17:{i:0;s:4:\"user\";i:1;s:5:\"node/\";i:2;s:7:\"node/56\";i:3;s:7:\"node/22\";i:4;s:6:\"node/2\";i:5;s:10:\"user/login\";i:6;s:5:\"forum\";i:7;s:4:\"blog\";i:8;s:7:\"node/43\";i:9;s:7:\"node/45\";i:10;s:7:\"node/44\";i:11;s:7:\"node/57\";i:12;s:7:\"node/42\";i:13;s:7:\"node/41\";i:14;s:13:\"user/register\";i:15;s:13:\"user/password\";i:16;s:7:\"node/33\";}',1512706740,1512620340,1),('user/1','a:21:{i:0;s:6:\"user/1\";i:1;s:6:\"blog/1\";i:2;s:6:\"user/6\";i:3;s:7:\"node/56\";i:4;s:7:\"node/22\";i:5;s:11:\"user/logout\";i:6;s:6:\"node/2\";i:7;s:14:\"node/add/forum\";i:8;s:5:\"forum\";i:9;s:4:\"blog\";i:10;s:7:\"node/43\";i:11;s:7:\"node/45\";i:12;s:7:\"node/44\";i:13;s:7:\"node/57\";i:14;s:7:\"node/42\";i:15;s:7:\"node/41\";i:16;s:11:\"user/1/edit\";i:17;s:16:\"user/1/shortcuts\";i:18;s:14:\"user/1/contact\";i:19;s:23:\"user/1/track/navigation\";i:20;s:7:\"node/33\";}',1512706748,1512620348,1);
/*!40000 ALTER TABLE `cache_path` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `cache_token`
--

DROP TABLE IF EXISTS `cache_token`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `cache_token` (
  `cid` varchar(255) NOT NULL DEFAULT '' COMMENT 'Primary Key: Unique cache ID.',
  `data` longblob COMMENT 'A collection of data to cache.',
  `expire` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry should expire, or 0 for never.',
  `created` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry was created.',
  `serialized` smallint(6) NOT NULL DEFAULT '0' COMMENT 'A flag to indicate whether content is serialized (1) or not (0).',
  PRIMARY KEY (`cid`),
  KEY `expire` (`expire`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Cache table for token information.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `cache_token`
--

LOCK TABLES `cache_token` WRITE;
/*!40000 ALTER TABLE `cache_token` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `cache_token` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `cache_update`
--

DROP TABLE IF EXISTS `cache_update`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `cache_update` (
  `cid` varchar(255) NOT NULL DEFAULT '' COMMENT 'Primary Key: Unique cache ID.',
  `data` longblob COMMENT 'A collection of data to cache.',
  `expire` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry should expire, or 0 for never.',
  `created` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry was created.',
  `serialized` smallint(6) NOT NULL DEFAULT '0' COMMENT 'A flag to indicate whether content is serialized (1) or not (0).',
  PRIMARY KEY (`cid`),
  KEY `expire` (`expire`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Cache table for the Update module to store information...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `cache_update`
--

LOCK TABLES `cache_update` WRITE;
/*!40000 ALTER TABLE `cache_update` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `cache_update` VALUES ('available_releases::admin_menu','a:11:{s:5:\"title\";s:19:\"Administration menu\";s:10:\"short_name\";s:10:\"admin_menu\";s:4:\"type\";s:14:\"project_module\";s:11:\"api_version\";s:3:\"7.x\";s:17:\"recommended_major\";s:1:\"3\";s:16:\"supported_majors\";s:1:\"3\";s:13:\"default_major\";s:1:\"3\";s:14:\"project_status\";s:9:\"published\";s:4:\"link\";s:41:\"https://www.drupal.org/project/admin_menu\";s:5:\"terms\";s:0:\"\";s:8:\"releases\";a:6:{s:11:\"7.x-3.0-rc5\";a:15:{s:4:\"name\";s:22:\"admin_menu 7.x-3.0-rc5\";s:7:\"version\";s:11:\"7.x-3.0-rc5\";s:3:\"tag\";s:11:\"7.x-3.0-rc5\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc5\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/admin_menu/releases/7.x-3.0-rc5\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/admin_menu-7.x-3.0-rc5.tar.gz\";s:4:\"date\";s:10:\"1419029280\";s:6:\"mdhash\";s:32:\"4f1a0c14001c880bd7eb170318b91303\";s:8:\"filesize\";s:5:\"53401\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:54:\"Project has not opted into security advisory coverage!\";}s:11:\"7.x-3.0-rc4\";a:15:{s:4:\"name\";s:22:\"admin_menu 7.x-3.0-rc4\";s:7:\"version\";s:11:\"7.x-3.0-rc4\";s:3:\"tag\";s:11:\"7.x-3.0-rc4\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/admin_menu/releases/7.x-3.0-rc4\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/admin_menu-7.x-3.0-rc4.tar.gz\";s:4:\"date\";s:10:\"1359651687\";s:6:\"mdhash\";s:32:\"3d8359538878723720fca6ddb2f82c7a\";s:8:\"filesize\";s:5:\"55064\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:54:\"Project has not opted into security advisory coverage!\";}s:11:\"7.x-3.0-rc3\";a:15:{s:4:\"name\";s:22:\"admin_menu 7.x-3.0-rc3\";s:7:\"version\";s:11:\"7.x-3.0-rc3\";s:3:\"tag\";s:11:\"7.x-3.0-rc3\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/admin_menu/releases/7.x-3.0-rc3\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/admin_menu-7.x-3.0-rc3.tar.gz\";s:4:\"date\";s:10:\"1337292349\";s:6:\"mdhash\";s:32:\"86b659c35823d541354179eccbfdc2d4\";s:8:\"filesize\";s:5:\"50950\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:54:\"Project has not opted into security advisory coverage!\";}s:11:\"7.x-3.0-rc2\";a:15:{s:4:\"name\";s:22:\"admin_menu 7.x-3.0-rc2\";s:7:\"version\";s:11:\"7.x-3.0-rc2\";s:3:\"tag\";s:11:\"7.x-3.0-rc2\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/admin_menu/releases/7.x-3.0-rc2\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/admin_menu-7.x-3.0-rc2.tar.gz\";s:4:\"date\";s:10:\"1335198071\";s:6:\"mdhash\";s:32:\"47761c79c351697f295d933b85441328\";s:8:\"filesize\";s:5:\"49988\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:54:\"Project has not opted into security advisory coverage!\";}s:11:\"7.x-3.0-rc1\";a:15:{s:4:\"name\";s:22:\"admin_menu 7.x-3.0-rc1\";s:7:\"version\";s:11:\"7.x-3.0-rc1\";s:3:\"tag\";s:11:\"7.x-3.0-rc1\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/admin_menu/releases/7.x-3.0-rc1\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/admin_menu-7.x-3.0-rc1.tar.gz\";s:4:\"date\";s:10:\"1294378871\";s:6:\"mdhash\";s:32:\"9d0cfb26adda4da7bd309bdf5be305a0\";s:8:\"filesize\";s:5:\"70961\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:54:\"Project has not opted into security advisory coverage!\";s:5:\"terms\";a:0:{}}s:11:\"7.x-3.x-dev\";a:14:{s:4:\"name\";s:22:\"admin_menu 7.x-3.x-dev\";s:7:\"version\";s:11:\"7.x-3.x-dev\";s:3:\"tag\";s:7:\"7.x-3.x\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/admin_menu/releases/7.x-3.x-dev\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/admin_menu-7.x-3.x-dev.tar.gz\";s:4:\"date\";s:10:\"1426875181\";s:6:\"mdhash\";s:32:\"6d2cdd2a5be2531a7e735847ce329102\";s:8:\"filesize\";s:5:\"53496\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:54:\"Project has not opted into security advisory coverage!\";s:5:\"terms\";a:0:{}}}}',1512706735,1512620327,1),('available_releases::advanced_forum','a:11:{s:5:\"title\";s:14:\"Advanced Forum\";s:10:\"short_name\";s:14:\"advanced_forum\";s:4:\"type\";s:14:\"project_module\";s:11:\"api_version\";s:3:\"7.x\";s:17:\"recommended_major\";s:1:\"2\";s:16:\"supported_majors\";s:1:\"2\";s:13:\"default_major\";s:1:\"2\";s:14:\"project_status\";s:9:\"published\";s:4:\"link\";s:45:\"https://www.drupal.org/project/advanced_forum\";s:5:\"terms\";s:0:\"\";s:8:\"releases\";a:17:{s:11:\"7.x-2.7-rc0\";a:15:{s:4:\"name\";s:26:\"advanced_forum 7.x-2.7-rc0\";s:7:\"version\";s:11:\"7.x-2.7-rc0\";s:3:\"tag\";s:11:\"7.x-2.7-rc0\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"7\";s:13:\"version_extra\";s:3:\"rc0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:66:\"https://www.drupal.org/project/advanced_forum/releases/7.x-2.7-rc0\";s:13:\"download_link\";s:71:\"https://ftp.drupal.org/files/projects/advanced_forum-7.x-2.7-rc0.tar.gz\";s:4:\"date\";s:10:\"1461748139\";s:6:\"mdhash\";s:32:\"c12fe91bd8ea4f7647a67cfec67f1cd6\";s:8:\"filesize\";s:6:\"168359\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:7:\"7.x-2.6\";a:14:{s:4:\"name\";s:22:\"advanced_forum 7.x-2.6\";s:7:\"version\";s:7:\"7.x-2.6\";s:3:\"tag\";s:7:\"7.x-2.6\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"6\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/advanced_forum/releases/7.x-2.6\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/advanced_forum-7.x-2.6.tar.gz\";s:4:\"date\";s:10:\"1445848439\";s:6:\"mdhash\";s:32:\"974ec37282b4ebca2db1d0789130acfb\";s:8:\"filesize\";s:6:\"168301\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:11:\"7.x-2.6-rc1\";a:15:{s:4:\"name\";s:26:\"advanced_forum 7.x-2.6-rc1\";s:7:\"version\";s:11:\"7.x-2.6-rc1\";s:3:\"tag\";s:11:\"7.x-2.6-rc1\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"6\";s:13:\"version_extra\";s:3:\"rc1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:66:\"https://www.drupal.org/project/advanced_forum/releases/7.x-2.6-rc1\";s:13:\"download_link\";s:71:\"https://ftp.drupal.org/files/projects/advanced_forum-7.x-2.6-rc1.tar.gz\";s:4:\"date\";s:10:\"1438699439\";s:6:\"mdhash\";s:32:\"9adc16e94f6fdd607dd9ed5fcd0f4a0a\";s:8:\"filesize\";s:6:\"167924\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:7:\"7.x-2.5\";a:14:{s:4:\"name\";s:22:\"advanced_forum 7.x-2.5\";s:7:\"version\";s:7:\"7.x-2.5\";s:3:\"tag\";s:7:\"7.x-2.5\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"5\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/advanced_forum/releases/7.x-2.5\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/advanced_forum-7.x-2.5.tar.gz\";s:4:\"date\";s:10:\"1423590781\";s:6:\"mdhash\";s:32:\"cd9046bb578ba2e71a8fee99025ce676\";s:8:\"filesize\";s:6:\"167690\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:11:\"7.x-2.5-rc1\";a:15:{s:4:\"name\";s:26:\"advanced_forum 7.x-2.5-rc1\";s:7:\"version\";s:11:\"7.x-2.5-rc1\";s:3:\"tag\";s:11:\"7.x-2.5-rc1\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"5\";s:13:\"version_extra\";s:3:\"rc1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:66:\"https://www.drupal.org/project/advanced_forum/releases/7.x-2.5-rc1\";s:13:\"download_link\";s:71:\"https://ftp.drupal.org/files/projects/advanced_forum-7.x-2.5-rc1.tar.gz\";s:4:\"date\";s:10:\"1415529480\";s:6:\"mdhash\";s:32:\"5381361da07206991de2a4df41c9b027\";s:8:\"filesize\";s:6:\"166831\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:7:\"7.x-2.4\";a:14:{s:4:\"name\";s:22:\"advanced_forum 7.x-2.4\";s:7:\"version\";s:7:\"7.x-2.4\";s:3:\"tag\";s:7:\"7.x-2.4\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/advanced_forum/releases/7.x-2.4\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/advanced_forum-7.x-2.4.tar.gz\";s:4:\"date\";s:10:\"1403371727\";s:6:\"mdhash\";s:32:\"05eb4587f6c3635addaef343281612fb\";s:8:\"filesize\";s:6:\"166588\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-2.3\";a:14:{s:4:\"name\";s:22:\"advanced_forum 7.x-2.3\";s:7:\"version\";s:7:\"7.x-2.3\";s:3:\"tag\";s:7:\"7.x-2.3\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/advanced_forum/releases/7.x-2.3\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/advanced_forum-7.x-2.3.tar.gz\";s:4:\"date\";s:10:\"1373223652\";s:6:\"mdhash\";s:32:\"e909174e228c901c03fd359a7afb1959\";s:8:\"filesize\";s:6:\"163700\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-2.2\";a:14:{s:4:\"name\";s:22:\"advanced_forum 7.x-2.2\";s:7:\"version\";s:7:\"7.x-2.2\";s:3:\"tag\";s:7:\"7.x-2.2\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/advanced_forum/releases/7.x-2.2\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/advanced_forum-7.x-2.2.tar.gz\";s:4:\"date\";s:10:\"1372959654\";s:6:\"mdhash\";s:32:\"91df020d2b193b3633e080cfb0911d90\";s:8:\"filesize\";s:6:\"163748\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-2.1\";a:14:{s:4:\"name\";s:22:\"advanced_forum 7.x-2.1\";s:7:\"version\";s:7:\"7.x-2.1\";s:3:\"tag\";s:7:\"7.x-2.1\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/advanced_forum/releases/7.x-2.1\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/advanced_forum-7.x-2.1.tar.gz\";s:4:\"date\";s:10:\"1361268675\";s:6:\"mdhash\";s:32:\"ae9e08f9d0b0e59474a91bf4625b134d\";s:8:\"filesize\";s:6:\"162794\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";s:5:\"terms\";a:0:{}}s:7:\"7.x-2.0\";a:14:{s:4:\"name\";s:22:\"advanced_forum 7.x-2.0\";s:7:\"version\";s:7:\"7.x-2.0\";s:3:\"tag\";s:7:\"7.x-2.0\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/advanced_forum/releases/7.x-2.0\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/advanced_forum-7.x-2.0.tar.gz\";s:4:\"date\";s:10:\"1332167738\";s:6:\"mdhash\";s:32:\"e295756ee2dead0d714bd41494e6eb78\";s:8:\"filesize\";s:6:\"160660\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";s:5:\"terms\";a:0:{}}s:11:\"7.x-2.0-rc1\";a:15:{s:4:\"name\";s:26:\"advanced_forum 7.x-2.0-rc1\";s:7:\"version\";s:11:\"7.x-2.0-rc1\";s:3:\"tag\";s:11:\"7.x-2.0-rc1\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:66:\"https://www.drupal.org/project/advanced_forum/releases/7.x-2.0-rc1\";s:13:\"download_link\";s:71:\"https://ftp.drupal.org/files/projects/advanced_forum-7.x-2.0-rc1.tar.gz\";s:4:\"date\";s:10:\"1323079837\";s:6:\"mdhash\";s:32:\"cb064e117f08b863ce3af00525da7503\";s:8:\"filesize\";s:6:\"160207\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}s:13:\"7.x-2.0-beta2\";a:15:{s:4:\"name\";s:28:\"advanced_forum 7.x-2.0-beta2\";s:7:\"version\";s:13:\"7.x-2.0-beta2\";s:3:\"tag\";s:13:\"7.x-2.0-beta2\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:68:\"https://www.drupal.org/project/advanced_forum/releases/7.x-2.0-beta2\";s:13:\"download_link\";s:73:\"https://ftp.drupal.org/files/projects/advanced_forum-7.x-2.0-beta2.tar.gz\";s:4:\"date\";s:10:\"1320510629\";s:6:\"mdhash\";s:32:\"d2bd5286db247cd9c4af68bf55a5449d\";s:8:\"filesize\";s:6:\"160337\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}s:13:\"7.x-2.0-beta1\";a:15:{s:4:\"name\";s:28:\"advanced_forum 7.x-2.0-beta1\";s:7:\"version\";s:13:\"7.x-2.0-beta1\";s:3:\"tag\";s:13:\"7.x-2.0-beta1\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:68:\"https://www.drupal.org/project/advanced_forum/releases/7.x-2.0-beta1\";s:13:\"download_link\";s:73:\"https://ftp.drupal.org/files/projects/advanced_forum-7.x-2.0-beta1.tar.gz\";s:4:\"date\";s:10:\"1314868016\";s:6:\"mdhash\";s:32:\"23f3ad653b882c7ff0214fc2a1b96ce8\";s:8:\"filesize\";s:6:\"159068\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:14:\"7.x-2.0-alpha3\";a:15:{s:4:\"name\";s:29:\"advanced_forum 7.x-2.0-alpha3\";s:7:\"version\";s:14:\"7.x-2.0-alpha3\";s:3:\"tag\";s:14:\"7.x-2.0-alpha3\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:69:\"https://www.drupal.org/project/advanced_forum/releases/7.x-2.0-alpha3\";s:13:\"download_link\";s:74:\"https://ftp.drupal.org/files/projects/advanced_forum-7.x-2.0-alpha3.tar.gz\";s:4:\"date\";s:10:\"1312537915\";s:6:\"mdhash\";s:32:\"6634233d62005ec0d4ea843303aad5b4\";s:8:\"filesize\";s:6:\"159003\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}s:14:\"7.x-2.0-alpha2\";a:15:{s:4:\"name\";s:29:\"advanced_forum 7.x-2.0-alpha2\";s:7:\"version\";s:14:\"7.x-2.0-alpha2\";s:3:\"tag\";s:14:\"7.x-2.0-alpha2\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:69:\"https://www.drupal.org/project/advanced_forum/releases/7.x-2.0-alpha2\";s:13:\"download_link\";s:74:\"https://ftp.drupal.org/files/projects/advanced_forum-7.x-2.0-alpha2.tar.gz\";s:4:\"date\";s:10:\"1309511215\";s:6:\"mdhash\";s:32:\"c66ad769c1fd5b7fb2eb35a83e3891ab\";s:8:\"filesize\";s:6:\"158647\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:14:\"7.x-2.0-alpha1\";a:15:{s:4:\"name\";s:29:\"advanced_forum 7.x-2.0-alpha1\";s:7:\"version\";s:14:\"7.x-2.0-alpha1\";s:3:\"tag\";s:14:\"7.x-2.0-alpha1\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:69:\"https://www.drupal.org/project/advanced_forum/releases/7.x-2.0-alpha1\";s:13:\"download_link\";s:74:\"https://ftp.drupal.org/files/projects/advanced_forum-7.x-2.0-alpha1.tar.gz\";s:4:\"date\";s:10:\"1301932868\";s:6:\"mdhash\";s:32:\"a4f48493cfa5582694de162610e06f28\";s:8:\"filesize\";s:6:\"162539\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}s:11:\"7.x-2.x-dev\";a:14:{s:4:\"name\";s:26:\"advanced_forum 7.x-2.x-dev\";s:7:\"version\";s:11:\"7.x-2.x-dev\";s:3:\"tag\";s:7:\"7.x-2.x\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:66:\"https://www.drupal.org/project/advanced_forum/releases/7.x-2.x-dev\";s:13:\"download_link\";s:71:\"https://ftp.drupal.org/files/projects/advanced_forum-7.x-2.x-dev.tar.gz\";s:4:\"date\";s:10:\"1465425539\";s:6:\"mdhash\";s:32:\"0d91ee07174134fc8a818ddacf36df69\";s:8:\"filesize\";s:6:\"168388\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}}}',1512706735,1512620327,1),('available_releases::author_pane','a:11:{s:5:\"title\";s:11:\"Author Pane\";s:10:\"short_name\";s:11:\"author_pane\";s:4:\"type\";s:14:\"project_module\";s:11:\"api_version\";s:3:\"7.x\";s:17:\"recommended_major\";s:1:\"2\";s:16:\"supported_majors\";s:1:\"2\";s:13:\"default_major\";s:1:\"2\";s:14:\"project_status\";s:9:\"published\";s:4:\"link\";s:42:\"https://www.drupal.org/project/author_pane\";s:5:\"terms\";s:0:\"\";s:8:\"releases\";a:6:{s:7:\"7.x-2.0\";a:14:{s:4:\"name\";s:19:\"author_pane 7.x-2.0\";s:7:\"version\";s:7:\"7.x-2.0\";s:3:\"tag\";s:7:\"7.x-2.0\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:59:\"https://www.drupal.org/project/author_pane/releases/7.x-2.0\";s:13:\"download_link\";s:64:\"https://ftp.drupal.org/files/projects/author_pane-7.x-2.0.tar.gz\";s:4:\"date\";s:10:\"1392987812\";s:6:\"mdhash\";s:32:\"cae7423f34203462b1c308f662b5be77\";s:8:\"filesize\";s:5:\"28291\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:13:\"7.x-2.0-beta1\";a:15:{s:4:\"name\";s:25:\"author_pane 7.x-2.0-beta1\";s:7:\"version\";s:13:\"7.x-2.0-beta1\";s:3:\"tag\";s:13:\"7.x-2.0-beta1\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:65:\"https://www.drupal.org/project/author_pane/releases/7.x-2.0-beta1\";s:13:\"download_link\";s:70:\"https://ftp.drupal.org/files/projects/author_pane-7.x-2.0-beta1.tar.gz\";s:4:\"date\";s:10:\"1336847751\";s:6:\"mdhash\";s:32:\"68ff717050bac20c44fcfeccc8db980d\";s:8:\"filesize\";s:5:\"28389\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:14:\"7.x-2.0-alpha3\";a:15:{s:4:\"name\";s:26:\"author_pane 7.x-2.0-alpha3\";s:7:\"version\";s:14:\"7.x-2.0-alpha3\";s:3:\"tag\";s:14:\"7.x-2.0-alpha3\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:66:\"https://www.drupal.org/project/author_pane/releases/7.x-2.0-alpha3\";s:13:\"download_link\";s:71:\"https://ftp.drupal.org/files/projects/author_pane-7.x-2.0-alpha3.tar.gz\";s:4:\"date\";s:10:\"1330523737\";s:6:\"mdhash\";s:32:\"bfc0c044fdc4a31be19867dee2fb8e9d\";s:8:\"filesize\";s:5:\"27827\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:14:\"7.x-2.0-alpha2\";a:15:{s:4:\"name\";s:26:\"author_pane 7.x-2.0-alpha2\";s:7:\"version\";s:14:\"7.x-2.0-alpha2\";s:3:\"tag\";s:14:\"7.x-2.0-alpha2\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:66:\"https://www.drupal.org/project/author_pane/releases/7.x-2.0-alpha2\";s:13:\"download_link\";s:71:\"https://ftp.drupal.org/files/projects/author_pane-7.x-2.0-alpha2.tar.gz\";s:4:\"date\";s:10:\"1325266837\";s:6:\"mdhash\";s:32:\"e3ee6277c9ff4fc0d2cb721c42eb23bb\";s:8:\"filesize\";s:5:\"27969\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:14:\"7.x-2.0-alpha1\";a:15:{s:4:\"name\";s:26:\"author_pane 7.x-2.0-alpha1\";s:7:\"version\";s:14:\"7.x-2.0-alpha1\";s:3:\"tag\";s:14:\"7.x-2.0-alpha1\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:66:\"https://www.drupal.org/project/author_pane/releases/7.x-2.0-alpha1\";s:13:\"download_link\";s:71:\"https://ftp.drupal.org/files/projects/author_pane-7.x-2.0-alpha1.tar.gz\";s:4:\"date\";s:10:\"1316897801\";s:6:\"mdhash\";s:32:\"3b8f899f9a0288a0910d78059b7578f7\";s:8:\"filesize\";s:5:\"27709\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}s:11:\"7.x-2.x-dev\";a:14:{s:4:\"name\";s:23:\"author_pane 7.x-2.x-dev\";s:7:\"version\";s:11:\"7.x-2.x-dev\";s:3:\"tag\";s:7:\"7.x-2.x\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:63:\"https://www.drupal.org/project/author_pane/releases/7.x-2.x-dev\";s:13:\"download_link\";s:68:\"https://ftp.drupal.org/files/projects/author_pane-7.x-2.x-dev.tar.gz\";s:4:\"date\";s:10:\"1393335805\";s:6:\"mdhash\";s:32:\"155580579552ee8ce83ad8009710fdc9\";s:8:\"filesize\";s:5:\"28270\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}}}',1512706736,1512620327,1),('available_releases::block_class','a:11:{s:5:\"title\";s:11:\"Block Class\";s:10:\"short_name\";s:11:\"block_class\";s:4:\"type\";s:14:\"project_module\";s:11:\"api_version\";s:3:\"7.x\";s:17:\"recommended_major\";s:1:\"2\";s:16:\"supported_majors\";s:1:\"2\";s:13:\"default_major\";s:1:\"2\";s:14:\"project_status\";s:9:\"published\";s:4:\"link\";s:42:\"https://www.drupal.org/project/block_class\";s:5:\"terms\";s:0:\"\";s:8:\"releases\";a:11:{s:7:\"7.x-2.3\";a:14:{s:4:\"name\";s:19:\"block_class 7.x-2.3\";s:7:\"version\";s:7:\"7.x-2.3\";s:3:\"tag\";s:7:\"7.x-2.3\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:59:\"https://www.drupal.org/project/block_class/releases/7.x-2.3\";s:13:\"download_link\";s:64:\"https://ftp.drupal.org/files/projects/block_class-7.x-2.3.tar.gz\";s:4:\"date\";s:10:\"1450415939\";s:6:\"mdhash\";s:32:\"286b7673faa2a067a9e96ee748331db9\";s:8:\"filesize\";s:5:\"12696\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-2.2\";a:14:{s:4:\"name\";s:19:\"block_class 7.x-2.2\";s:7:\"version\";s:7:\"7.x-2.2\";s:3:\"tag\";s:7:\"7.x-2.2\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:59:\"https://www.drupal.org/project/block_class/releases/7.x-2.2\";s:13:\"download_link\";s:64:\"https://ftp.drupal.org/files/projects/block_class-7.x-2.2.tar.gz\";s:4:\"date\";s:10:\"1450293839\";s:6:\"mdhash\";s:32:\"9e382ab421c420b01c393be94b401ad9\";s:8:\"filesize\";s:5:\"12684\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:15:\"Security update\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-2.1\";a:14:{s:4:\"name\";s:19:\"block_class 7.x-2.1\";s:7:\"version\";s:7:\"7.x-2.1\";s:3:\"tag\";s:7:\"7.x-2.1\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:59:\"https://www.drupal.org/project/block_class/releases/7.x-2.1\";s:13:\"download_link\";s:64:\"https://ftp.drupal.org/files/projects/block_class-7.x-2.1.tar.gz\";s:4:\"date\";s:10:\"1377197769\";s:6:\"mdhash\";s:32:\"cb57d269d45aabd8978c0a88b05b9eb3\";s:8:\"filesize\";s:5:\"11499\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-2.0\";a:14:{s:4:\"name\";s:19:\"block_class 7.x-2.0\";s:7:\"version\";s:7:\"7.x-2.0\";s:3:\"tag\";s:7:\"7.x-2.0\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:59:\"https://www.drupal.org/project/block_class/releases/7.x-2.0\";s:13:\"download_link\";s:64:\"https://ftp.drupal.org/files/projects/block_class-7.x-2.0.tar.gz\";s:4:\"date\";s:10:\"1362669357\";s:6:\"mdhash\";s:32:\"4c3afdc9b94f12d4a2fa6ab8eac2bae8\";s:8:\"filesize\";s:4:\"9421\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-1.3\";a:14:{s:4:\"name\";s:19:\"block_class 7.x-1.3\";s:7:\"version\";s:7:\"7.x-1.3\";s:3:\"tag\";s:7:\"7.x-1.3\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:59:\"https://www.drupal.org/project/block_class/releases/7.x-1.3\";s:13:\"download_link\";s:64:\"https://ftp.drupal.org/files/projects/block_class-7.x-1.3.tar.gz\";s:4:\"date\";s:10:\"1377198970\";s:6:\"mdhash\";s:32:\"393dbfad8a142c2ff7d348f30521a63f\";s:8:\"filesize\";s:5:\"11913\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-1.2\";a:14:{s:4:\"name\";s:19:\"block_class 7.x-1.2\";s:7:\"version\";s:7:\"7.x-1.2\";s:3:\"tag\";s:7:\"7.x-1.2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:59:\"https://www.drupal.org/project/block_class/releases/7.x-1.2\";s:13:\"download_link\";s:64:\"https://ftp.drupal.org/files/projects/block_class-7.x-1.2.tar.gz\";s:4:\"date\";s:10:\"1349301967\";s:6:\"mdhash\";s:32:\"30eff4c1392274a53680412e5784330b\";s:8:\"filesize\";s:4:\"8874\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:13:\"7.x-1.2-beta1\";a:15:{s:4:\"name\";s:25:\"block_class 7.x-1.2-beta1\";s:7:\"version\";s:13:\"7.x-1.2-beta1\";s:3:\"tag\";s:13:\"7.x-1.2-beta1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"2\";s:13:\"version_extra\";s:5:\"beta1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:65:\"https://www.drupal.org/project/block_class/releases/7.x-1.2-beta1\";s:13:\"download_link\";s:70:\"https://ftp.drupal.org/files/projects/block_class-7.x-1.2-beta1.tar.gz\";s:4:\"date\";s:10:\"1333059942\";s:6:\"mdhash\";s:32:\"d83eb9270022e9a3d6dc53ad102017d3\";s:8:\"filesize\";s:4:\"8873\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:7:\"7.x-1.1\";a:14:{s:4:\"name\";s:19:\"block_class 7.x-1.1\";s:7:\"version\";s:7:\"7.x-1.1\";s:3:\"tag\";s:7:\"7.x-1.1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:59:\"https://www.drupal.org/project/block_class/releases/7.x-1.1\";s:13:\"download_link\";s:64:\"https://ftp.drupal.org/files/projects/block_class-7.x-1.1.tar.gz\";s:4:\"date\";s:10:\"1331079937\";s:6:\"mdhash\";s:32:\"b466c130b0fc352d7bd2d434f294e6d6\";s:8:\"filesize\";s:4:\"8694\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:15:\"Security update\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-1.0\";a:14:{s:4:\"name\";s:19:\"block_class 7.x-1.0\";s:7:\"version\";s:7:\"7.x-1.0\";s:3:\"tag\";s:7:\"7.x-1.0\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:59:\"https://www.drupal.org/project/block_class/releases/7.x-1.0\";s:13:\"download_link\";s:64:\"https://ftp.drupal.org/files/projects/block_class-7.x-1.0.tar.gz\";s:4:\"date\";s:10:\"1318630894\";s:6:\"mdhash\";s:32:\"7659a7e3cfb4be20692a64b467a40310\";s:8:\"filesize\";s:4:\"8703\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:11:\"7.x-2.x-dev\";a:14:{s:4:\"name\";s:23:\"block_class 7.x-2.x-dev\";s:7:\"version\";s:11:\"7.x-2.x-dev\";s:3:\"tag\";s:7:\"7.x-2.x\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:63:\"https://www.drupal.org/project/block_class/releases/7.x-2.x-dev\";s:13:\"download_link\";s:68:\"https://ftp.drupal.org/files/projects/block_class-7.x-2.x-dev.tar.gz\";s:4:\"date\";s:10:\"1496362442\";s:6:\"mdhash\";s:32:\"8df84f57a2cf05072280b47904c3dfe4\";s:8:\"filesize\";s:5:\"13550\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:12:\"New features\";}}s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";}s:11:\"7.x-1.x-dev\";a:14:{s:4:\"name\";s:23:\"block_class 7.x-1.x-dev\";s:7:\"version\";s:11:\"7.x-1.x-dev\";s:3:\"tag\";s:7:\"7.x-1.x\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:63:\"https://www.drupal.org/project/block_class/releases/7.x-1.x-dev\";s:13:\"download_link\";s:68:\"https://ftp.drupal.org/files/projects/block_class-7.x-1.x-dev.tar.gz\";s:4:\"date\";s:10:\"1380556302\";s:6:\"mdhash\";s:32:\"7419a6f4c1a002401da79a0f3291dd75\";s:8:\"filesize\";s:5:\"11922\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";}}}',1512706737,1512620327,1),('available_releases::calendar','a:11:{s:5:\"title\";s:8:\"Calendar\";s:10:\"short_name\";s:8:\"calendar\";s:4:\"type\";s:14:\"project_module\";s:11:\"api_version\";s:3:\"7.x\";s:17:\"recommended_major\";s:1:\"3\";s:16:\"supported_majors\";s:1:\"3\";s:13:\"default_major\";s:1:\"3\";s:14:\"project_status\";s:9:\"published\";s:4:\"link\";s:39:\"https://www.drupal.org/project/calendar\";s:5:\"terms\";s:0:\"\";s:8:\"releases\";a:16:{s:7:\"7.x-3.5\";a:14:{s:4:\"name\";s:16:\"calendar 7.x-3.5\";s:7:\"version\";s:7:\"7.x-3.5\";s:3:\"tag\";s:7:\"7.x-3.5\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"5\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/calendar/releases/7.x-3.5\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/calendar-7.x-3.5.tar.gz\";s:4:\"date\";s:10:\"1413299929\";s:6:\"mdhash\";s:32:\"722be21d595e6dec4c3946119121167b\";s:8:\"filesize\";s:5:\"60999\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-3.4\";a:14:{s:4:\"name\";s:16:\"calendar 7.x-3.4\";s:7:\"version\";s:7:\"7.x-3.4\";s:3:\"tag\";s:7:\"7.x-3.4\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/calendar/releases/7.x-3.4\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/calendar-7.x-3.4.tar.gz\";s:4:\"date\";s:10:\"1337429753\";s:6:\"mdhash\";s:32:\"0b2fcc3c9e1c00707a0bddbdcf2923e8\";s:8:\"filesize\";s:5:\"62201\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-3.3\";a:14:{s:4:\"name\";s:16:\"calendar 7.x-3.3\";s:7:\"version\";s:7:\"7.x-3.3\";s:3:\"tag\";s:7:\"7.x-3.3\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/calendar/releases/7.x-3.3\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/calendar-7.x-3.3.tar.gz\";s:4:\"date\";s:10:\"1335767761\";s:6:\"mdhash\";s:32:\"f2fba081a0cbd6b3e8068f615a1a9beb\";s:8:\"filesize\";s:5:\"71806\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-3.2\";a:14:{s:4:\"name\";s:16:\"calendar 7.x-3.2\";s:7:\"version\";s:7:\"7.x-3.2\";s:3:\"tag\";s:7:\"7.x-3.2\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/calendar/releases/7.x-3.2\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/calendar-7.x-3.2.tar.gz\";s:4:\"date\";s:10:\"1334931973\";s:6:\"mdhash\";s:32:\"9b7b791c5cb6af39776ef8ab19eb1716\";s:8:\"filesize\";s:5:\"70561\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-3.1\";a:14:{s:4:\"name\";s:16:\"calendar 7.x-3.1\";s:7:\"version\";s:7:\"7.x-3.1\";s:3:\"tag\";s:7:\"7.x-3.1\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/calendar/releases/7.x-3.1\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/calendar-7.x-3.1.tar.gz\";s:4:\"date\";s:10:\"1334828793\";s:6:\"mdhash\";s:32:\"2b4295be2d9b00096b7af9891b46dbae\";s:8:\"filesize\";s:5:\"70424\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-3.0\";a:14:{s:4:\"name\";s:16:\"calendar 7.x-3.0\";s:7:\"version\";s:7:\"7.x-3.0\";s:3:\"tag\";s:7:\"7.x-3.0\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/calendar/releases/7.x-3.0\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/calendar-7.x-3.0.tar.gz\";s:4:\"date\";s:10:\"1330089637\";s:6:\"mdhash\";s:32:\"e30aa07996a54f18bb3182b8ef6979d1\";s:8:\"filesize\";s:5:\"70729\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:11:\"7.x-3.0-rc1\";a:15:{s:4:\"name\";s:20:\"calendar 7.x-3.0-rc1\";s:7:\"version\";s:11:\"7.x-3.0-rc1\";s:3:\"tag\";s:11:\"7.x-3.0-rc1\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:60:\"https://www.drupal.org/project/calendar/releases/7.x-3.0-rc1\";s:13:\"download_link\";s:65:\"https://ftp.drupal.org/files/projects/calendar-7.x-3.0-rc1.tar.gz\";s:4:\"date\";s:10:\"1329217537\";s:6:\"mdhash\";s:32:\"eb12c8832d608609615c1a86e6f451a4\";s:8:\"filesize\";s:5:\"68640\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:14:\"7.x-3.0-alpha2\";a:15:{s:4:\"name\";s:23:\"calendar 7.x-3.0-alpha2\";s:7:\"version\";s:14:\"7.x-3.0-alpha2\";s:3:\"tag\";s:14:\"7.x-3.0-alpha2\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:63:\"https://www.drupal.org/project/calendar/releases/7.x-3.0-alpha2\";s:13:\"download_link\";s:68:\"https://ftp.drupal.org/files/projects/calendar-7.x-3.0-alpha2.tar.gz\";s:4:\"date\";s:10:\"1325346037\";s:6:\"mdhash\";s:32:\"2a29207408c6b098dd47d465efec5583\";s:8:\"filesize\";s:5:\"57906\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:14:\"7.x-3.0-alpha1\";a:15:{s:4:\"name\";s:23:\"calendar 7.x-3.0-alpha1\";s:7:\"version\";s:14:\"7.x-3.0-alpha1\";s:3:\"tag\";s:14:\"7.x-3.0-alpha1\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:63:\"https://www.drupal.org/project/calendar/releases/7.x-3.0-alpha1\";s:13:\"download_link\";s:68:\"https://ftp.drupal.org/files/projects/calendar-7.x-3.0-alpha1.tar.gz\";s:4:\"date\";s:10:\"1312195614\";s:6:\"mdhash\";s:32:\"ee5fbac9b1338089e393770ff990e477\";s:8:\"filesize\";s:5:\"53410\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:14:\"7.x-2.0-alpha1\";a:15:{s:4:\"name\";s:23:\"calendar 7.x-2.0-alpha1\";s:7:\"version\";s:14:\"7.x-2.0-alpha1\";s:3:\"tag\";s:14:\"7.x-2.0-alpha1\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:63:\"https://www.drupal.org/project/calendar/releases/7.x-2.0-alpha1\";s:13:\"download_link\";s:68:\"https://ftp.drupal.org/files/projects/calendar-7.x-2.0-alpha1.tar.gz\";s:4:\"date\";s:10:\"1303818714\";s:6:\"mdhash\";s:32:\"8a0bdc71be1b6bf709180d4fab619193\";s:8:\"filesize\";s:6:\"480286\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:14:\"7.x-1.0-alpha3\";a:15:{s:4:\"name\";s:23:\"calendar 7.x-1.0-alpha3\";s:7:\"version\";s:14:\"7.x-1.0-alpha3\";s:3:\"tag\";s:14:\"7.x-1.0-alpha3\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:63:\"https://www.drupal.org/project/calendar/releases/7.x-1.0-alpha3\";s:13:\"download_link\";s:68:\"https://ftp.drupal.org/files/projects/calendar-7.x-1.0-alpha3.tar.gz\";s:4:\"date\";s:10:\"1295532254\";s:6:\"mdhash\";s:32:\"ac79d9a4e80287dd26ea9d6bbcab0dd3\";s:8:\"filesize\";s:6:\"504346\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:14:\"7.x-1.0-alpha2\";a:15:{s:4:\"name\";s:23:\"calendar 7.x-1.0-alpha2\";s:7:\"version\";s:14:\"7.x-1.0-alpha2\";s:3:\"tag\";s:14:\"7.x-1.0-alpha2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:63:\"https://www.drupal.org/project/calendar/releases/7.x-1.0-alpha2\";s:13:\"download_link\";s:68:\"https://ftp.drupal.org/files/projects/calendar-7.x-1.0-alpha2.tar.gz\";s:4:\"date\";s:10:\"1295529401\";s:6:\"mdhash\";s:32:\"890bfc46988ce6a017cd6542980fb591\";s:8:\"filesize\";s:6:\"504195\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:14:\"7.x-1.0-alpha1\";a:15:{s:4:\"name\";s:23:\"calendar 7.x-1.0-alpha1\";s:7:\"version\";s:14:\"7.x-1.0-alpha1\";s:3:\"tag\";s:14:\"7.x-1.0-alpha1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:63:\"https://www.drupal.org/project/calendar/releases/7.x-1.0-alpha1\";s:13:\"download_link\";s:68:\"https://ftp.drupal.org/files/projects/calendar-7.x-1.0-alpha1.tar.gz\";s:4:\"date\";s:10:\"1295353336\";s:6:\"mdhash\";s:32:\"e3be0aa9d48e0c1a703d0b7921b80d28\";s:8:\"filesize\";s:6:\"504061\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}s:11:\"7.x-3.x-dev\";a:14:{s:4:\"name\";s:20:\"calendar 7.x-3.x-dev\";s:7:\"version\";s:11:\"7.x-3.x-dev\";s:3:\"tag\";s:7:\"7.x-3.x\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:60:\"https://www.drupal.org/project/calendar/releases/7.x-3.x-dev\";s:13:\"download_link\";s:65:\"https://ftp.drupal.org/files/projects/calendar-7.x-3.x-dev.tar.gz\";s:4:\"date\";s:10:\"1512036185\";s:6:\"mdhash\";s:32:\"4dadf5685658043f7a02c3e0b134dd81\";s:8:\"filesize\";s:5:\"61150\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:12:\"New features\";}}s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";}s:11:\"7.x-2.x-dev\";a:14:{s:4:\"name\";s:20:\"calendar 7.x-2.x-dev\";s:7:\"version\";s:11:\"7.x-2.x-dev\";s:3:\"tag\";s:7:\"7.x-2.x\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:60:\"https://www.drupal.org/project/calendar/releases/7.x-2.x-dev\";s:13:\"download_link\";s:65:\"https://ftp.drupal.org/files/projects/calendar-7.x-2.x-dev.tar.gz\";s:4:\"date\";s:10:\"1380557357\";s:6:\"mdhash\";s:32:\"3991e66ca29b290f9da4fea07f7ffd6e\";s:8:\"filesize\";s:6:\"481376\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";}s:11:\"7.x-1.x-dev\";a:14:{s:4:\"name\";s:20:\"calendar 7.x-1.x-dev\";s:7:\"version\";s:11:\"7.x-1.x-dev\";s:3:\"tag\";s:7:\"7.x-1.x\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:60:\"https://www.drupal.org/project/calendar/releases/7.x-1.x-dev\";s:13:\"download_link\";s:65:\"https://ftp.drupal.org/files/projects/calendar-7.x-1.x-dev.tar.gz\";s:4:\"date\";s:10:\"1479998880\";s:6:\"mdhash\";s:32:\"fd132f379cb55c308fe2f0c76e21ec0a\";s:8:\"filesize\";s:6:\"481943\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}}}',1512706737,1512620327,1),('available_releases::chosen','a:11:{s:5:\"title\";s:6:\"Chosen\";s:10:\"short_name\";s:6:\"chosen\";s:4:\"type\";s:14:\"project_module\";s:11:\"api_version\";s:3:\"7.x\";s:17:\"recommended_major\";s:1:\"2\";s:16:\"supported_majors\";s:1:\"2\";s:13:\"default_major\";s:1:\"2\";s:14:\"project_status\";s:9:\"published\";s:4:\"link\";s:37:\"https://www.drupal.org/project/chosen\";s:5:\"terms\";s:0:\"\";s:8:\"releases\";a:13:{s:7:\"7.x-2.1\";a:14:{s:4:\"name\";s:14:\"chosen 7.x-2.1\";s:7:\"version\";s:7:\"7.x-2.1\";s:3:\"tag\";s:7:\"7.x-2.1\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:54:\"https://www.drupal.org/project/chosen/releases/7.x-2.1\";s:13:\"download_link\";s:59:\"https://ftp.drupal.org/files/projects/chosen-7.x-2.1.tar.gz\";s:4:\"date\";s:10:\"1490260383\";s:6:\"mdhash\";s:32:\"ca17f21e5ce6e1697d369301704e70ab\";s:8:\"filesize\";s:5:\"15428\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-2.0\";a:14:{s:4:\"name\";s:14:\"chosen 7.x-2.0\";s:7:\"version\";s:7:\"7.x-2.0\";s:3:\"tag\";s:7:\"7.x-2.0\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:54:\"https://www.drupal.org/project/chosen/releases/7.x-2.0\";s:13:\"download_link\";s:59:\"https://ftp.drupal.org/files/projects/chosen-7.x-2.0.tar.gz\";s:4:\"date\";s:10:\"1476640739\";s:6:\"mdhash\";s:32:\"c0bb1b0a37db807c57cb533a4dbbc17a\";s:8:\"filesize\";s:5:\"15287\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:13:\"7.x-2.0-beta5\";a:15:{s:4:\"name\";s:20:\"chosen 7.x-2.0-beta5\";s:7:\"version\";s:13:\"7.x-2.0-beta5\";s:3:\"tag\";s:13:\"7.x-2.0-beta5\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta5\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:60:\"https://www.drupal.org/project/chosen/releases/7.x-2.0-beta5\";s:13:\"download_link\";s:65:\"https://ftp.drupal.org/files/projects/chosen-7.x-2.0-beta5.tar.gz\";s:4:\"date\";s:10:\"1459939441\";s:6:\"mdhash\";s:32:\"fae42114eaeada4198deeedc35d960bb\";s:8:\"filesize\";s:5:\"14915\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"7.x-2.0-beta4\";a:15:{s:4:\"name\";s:20:\"chosen 7.x-2.0-beta4\";s:7:\"version\";s:13:\"7.x-2.0-beta4\";s:3:\"tag\";s:13:\"7.x-2.0-beta4\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:60:\"https://www.drupal.org/project/chosen/releases/7.x-2.0-beta4\";s:13:\"download_link\";s:65:\"https://ftp.drupal.org/files/projects/chosen-7.x-2.0-beta4.tar.gz\";s:4:\"date\";s:10:\"1394256505\";s:6:\"mdhash\";s:32:\"08b424ba6640ef1ab8f1adff81e90ac6\";s:8:\"filesize\";s:5:\"14294\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"7.x-2.0-beta2\";a:15:{s:4:\"name\";s:20:\"chosen 7.x-2.0-beta2\";s:7:\"version\";s:13:\"7.x-2.0-beta2\";s:3:\"tag\";s:13:\"7.x-2.0-beta2\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:60:\"https://www.drupal.org/project/chosen/releases/7.x-2.0-beta2\";s:13:\"download_link\";s:65:\"https://ftp.drupal.org/files/projects/chosen-7.x-2.0-beta2.tar.gz\";s:4:\"date\";s:10:\"1394153305\";s:6:\"mdhash\";s:32:\"dd5a2bd9a4d75a5c1726c1735f432568\";s:8:\"filesize\";s:5:\"13476\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"7.x-2.0-beta1\";a:15:{s:4:\"name\";s:20:\"chosen 7.x-2.0-beta1\";s:7:\"version\";s:13:\"7.x-2.0-beta1\";s:3:\"tag\";s:13:\"7.x-2.0-beta1\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:60:\"https://www.drupal.org/project/chosen/releases/7.x-2.0-beta1\";s:13:\"download_link\";s:65:\"https://ftp.drupal.org/files/projects/chosen-7.x-2.0-beta1.tar.gz\";s:4:\"date\";s:10:\"1394120905\";s:6:\"mdhash\";s:32:\"1f481e331b6de881d624a9c162fe11a7\";s:8:\"filesize\";s:5:\"13390\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:14:\"7.x-2.0-alpha4\";a:15:{s:4:\"name\";s:21:\"chosen 7.x-2.0-alpha4\";s:7:\"version\";s:14:\"7.x-2.0-alpha4\";s:3:\"tag\";s:14:\"7.x-2.0-alpha4\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/chosen/releases/7.x-2.0-alpha4\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/chosen-7.x-2.0-alpha4.tar.gz\";s:4:\"date\";s:10:\"1379598967\";s:6:\"mdhash\";s:32:\"dbeff0756d01bc335137a4c83455b44f\";s:8:\"filesize\";s:5:\"13421\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:14:\"7.x-2.0-alpha3\";a:15:{s:4:\"name\";s:21:\"chosen 7.x-2.0-alpha3\";s:7:\"version\";s:14:\"7.x-2.0-alpha3\";s:3:\"tag\";s:14:\"7.x-2.0-alpha3\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/chosen/releases/7.x-2.0-alpha3\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/chosen-7.x-2.0-alpha3.tar.gz\";s:4:\"date\";s:10:\"1378478168\";s:6:\"mdhash\";s:32:\"0b927bd495e679dd256d403e1521b54d\";s:8:\"filesize\";s:5:\"13419\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:14:\"7.x-2.0-alpha2\";a:15:{s:4:\"name\";s:21:\"chosen 7.x-2.0-alpha2\";s:7:\"version\";s:14:\"7.x-2.0-alpha2\";s:3:\"tag\";s:14:\"7.x-2.0-alpha2\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/chosen/releases/7.x-2.0-alpha2\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/chosen-7.x-2.0-alpha2.tar.gz\";s:4:\"date\";s:10:\"1368039911\";s:6:\"mdhash\";s:32:\"9d5dba3e27e93ea920fe5dd4e94fd5d0\";s:8:\"filesize\";s:5:\"10255\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:14:\"7.x-2.0-alpha1\";a:15:{s:4:\"name\";s:21:\"chosen 7.x-2.0-alpha1\";s:7:\"version\";s:14:\"7.x-2.0-alpha1\";s:3:\"tag\";s:14:\"7.x-2.0-alpha1\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/chosen/releases/7.x-2.0-alpha1\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/chosen-7.x-2.0-alpha1.tar.gz\";s:4:\"date\";s:10:\"1358504112\";s:6:\"mdhash\";s:32:\"420ac109b8761bf769c97c69154ff352\";s:8:\"filesize\";s:5:\"10308\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}s:7:\"7.x-1.0\";a:14:{s:4:\"name\";s:14:\"chosen 7.x-1.0\";s:7:\"version\";s:7:\"7.x-1.0\";s:3:\"tag\";s:7:\"7.x-1.0\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:54:\"https://www.drupal.org/project/chosen/releases/7.x-1.0\";s:13:\"download_link\";s:59:\"https://ftp.drupal.org/files/projects/chosen-7.x-1.0.tar.gz\";s:4:\"date\";s:10:\"1311684414\";s:6:\"mdhash\";s:32:\"3fbb7ba2bb7e2a8f684df0a7548cb743\";s:8:\"filesize\";s:4:\"7530\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:11:\"7.x-2.x-dev\";a:14:{s:4:\"name\";s:18:\"chosen 7.x-2.x-dev\";s:7:\"version\";s:11:\"7.x-2.x-dev\";s:3:\"tag\";s:7:\"7.x-2.x\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:58:\"https://www.drupal.org/project/chosen/releases/7.x-2.x-dev\";s:13:\"download_link\";s:63:\"https://ftp.drupal.org/files/projects/chosen-7.x-2.x-dev.tar.gz\";s:4:\"date\";s:10:\"1490607783\";s:6:\"mdhash\";s:32:\"a723666c04945af49f39ec3d6338ce43\";s:8:\"filesize\";s:5:\"16124\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";}s:11:\"7.x-1.x-dev\";a:14:{s:4:\"name\";s:18:\"chosen 7.x-1.x-dev\";s:7:\"version\";s:11:\"7.x-1.x-dev\";s:3:\"tag\";s:7:\"7.x-1.x\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:58:\"https://www.drupal.org/project/chosen/releases/7.x-1.x-dev\";s:13:\"download_link\";s:63:\"https://ftp.drupal.org/files/projects/chosen-7.x-1.x-dev.tar.gz\";s:4:\"date\";s:10:\"1380558355\";s:6:\"mdhash\";s:32:\"413920c0279bc44e65a19ed3cbc62eaa\";s:8:\"filesize\";s:4:\"9895\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:12:\"New features\";}}s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";}}}',1512706737,1512620327,1),('available_releases::ckeditor','a:11:{s:5:\"title\";s:30:\"CKEditor - WYSIWYG HTML editor\";s:10:\"short_name\";s:8:\"ckeditor\";s:4:\"type\";s:14:\"project_module\";s:11:\"api_version\";s:3:\"7.x\";s:17:\"recommended_major\";s:1:\"1\";s:16:\"supported_majors\";s:1:\"1\";s:13:\"default_major\";s:1:\"1\";s:14:\"project_status\";s:9:\"published\";s:4:\"link\";s:39:\"https://www.drupal.org/project/ckeditor\";s:5:\"terms\";s:0:\"\";s:8:\"releases\";a:21:{s:8:\"7.x-1.18\";a:14:{s:4:\"name\";s:17:\"ckeditor 7.x-1.18\";s:7:\"version\";s:8:\"7.x-1.18\";s:3:\"tag\";s:8:\"7.x-1.18\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:2:\"18\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:57:\"https://www.drupal.org/project/ckeditor/releases/7.x-1.18\";s:13:\"download_link\";s:62:\"https://ftp.drupal.org/files/projects/ckeditor-7.x-1.18.tar.gz\";s:4:\"date\";s:10:\"1498506242\";s:6:\"mdhash\";s:32:\"c85049f6a351e6e72b8890f01325eed2\";s:8:\"filesize\";s:6:\"198098\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";s:5:\"terms\";a:0:{}}s:8:\"7.x-1.17\";a:14:{s:4:\"name\";s:17:\"ckeditor 7.x-1.17\";s:7:\"version\";s:8:\"7.x-1.17\";s:3:\"tag\";s:8:\"7.x-1.17\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:2:\"17\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:57:\"https://www.drupal.org/project/ckeditor/releases/7.x-1.17\";s:13:\"download_link\";s:62:\"https://ftp.drupal.org/files/projects/ckeditor-7.x-1.17.tar.gz\";s:4:\"date\";s:10:\"1450969739\";s:6:\"mdhash\";s:32:\"af5cf266be662fb632034192658f451d\";s:8:\"filesize\";s:6:\"198195\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:8:\"7.x-1.16\";a:14:{s:4:\"name\";s:17:\"ckeditor 7.x-1.16\";s:7:\"version\";s:8:\"7.x-1.16\";s:3:\"tag\";s:8:\"7.x-1.16\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:2:\"16\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:57:\"https://www.drupal.org/project/ckeditor/releases/7.x-1.16\";s:13:\"download_link\";s:62:\"https://ftp.drupal.org/files/projects/ckeditor-7.x-1.16.tar.gz\";s:4:\"date\";s:10:\"1413311928\";s:6:\"mdhash\";s:32:\"b906e538201c88213415cecd6177b3c5\";s:8:\"filesize\";s:6:\"201743\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:15:\"Security update\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:8:\"7.x-1.15\";a:14:{s:4:\"name\";s:17:\"ckeditor 7.x-1.15\";s:7:\"version\";s:8:\"7.x-1.15\";s:3:\"tag\";s:8:\"7.x-1.15\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:2:\"15\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:57:\"https://www.drupal.org/project/ckeditor/releases/7.x-1.15\";s:13:\"download_link\";s:62:\"https://ftp.drupal.org/files/projects/ckeditor-7.x-1.15.tar.gz\";s:4:\"date\";s:10:\"1405436628\";s:6:\"mdhash\";s:32:\"7bedcb818fd336144f0b3ac7d056ef85\";s:8:\"filesize\";s:6:\"201891\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:8:\"7.x-1.14\";a:14:{s:4:\"name\";s:17:\"ckeditor 7.x-1.14\";s:7:\"version\";s:8:\"7.x-1.14\";s:3:\"tag\";s:8:\"7.x-1.14\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:2:\"14\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:57:\"https://www.drupal.org/project/ckeditor/releases/7.x-1.14\";s:13:\"download_link\";s:62:\"https://ftp.drupal.org/files/projects/ckeditor-7.x-1.14.tar.gz\";s:4:\"date\";s:10:\"1399546427\";s:6:\"mdhash\";s:32:\"146cc7306386b994fe281781f795c6dc\";s:8:\"filesize\";s:6:\"202031\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:8:\"7.x-1.13\";a:14:{s:4:\"name\";s:17:\"ckeditor 7.x-1.13\";s:7:\"version\";s:8:\"7.x-1.13\";s:3:\"tag\";s:8:\"7.x-1.13\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:2:\"13\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:57:\"https://www.drupal.org/project/ckeditor/releases/7.x-1.13\";s:13:\"download_link\";s:62:\"https://ftp.drupal.org/files/projects/ckeditor-7.x-1.13.tar.gz\";s:4:\"date\";s:10:\"1365759619\";s:6:\"mdhash\";s:32:\"e35e43b86694fcb04ea5c590834e9659\";s:8:\"filesize\";s:6:\"242724\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:8:\"7.x-1.12\";a:14:{s:4:\"name\";s:17:\"ckeditor 7.x-1.12\";s:7:\"version\";s:8:\"7.x-1.12\";s:3:\"tag\";s:8:\"7.x-1.12\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:2:\"12\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:57:\"https://www.drupal.org/project/ckeditor/releases/7.x-1.12\";s:13:\"download_link\";s:62:\"https://ftp.drupal.org/files/projects/ckeditor-7.x-1.12.tar.gz\";s:4:\"date\";s:10:\"1356180966\";s:6:\"mdhash\";s:32:\"95abc65d68a1bbfe8b87c3a3fa9ff427\";s:8:\"filesize\";s:6:\"241718\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:8:\"7.x-1.11\";a:14:{s:4:\"name\";s:17:\"ckeditor 7.x-1.11\";s:7:\"version\";s:8:\"7.x-1.11\";s:3:\"tag\";s:8:\"7.x-1.11\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:2:\"11\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:57:\"https://www.drupal.org/project/ckeditor/releases/7.x-1.11\";s:13:\"download_link\";s:62:\"https://ftp.drupal.org/files/projects/ckeditor-7.x-1.11.tar.gz\";s:4:\"date\";s:10:\"1355320857\";s:6:\"mdhash\";s:32:\"cff447953001b81497c64cd1a4fb9c48\";s:8:\"filesize\";s:6:\"241212\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:8:\"7.x-1.10\";a:14:{s:4:\"name\";s:17:\"ckeditor 7.x-1.10\";s:7:\"version\";s:8:\"7.x-1.10\";s:3:\"tag\";s:8:\"7.x-1.10\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:2:\"10\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:57:\"https://www.drupal.org/project/ckeditor/releases/7.x-1.10\";s:13:\"download_link\";s:62:\"https://ftp.drupal.org/files/projects/ckeditor-7.x-1.10.tar.gz\";s:4:\"date\";s:10:\"1355320262\";s:6:\"mdhash\";s:32:\"065fb6dd5309318abcf5249552bdb68a\";s:8:\"filesize\";s:6:\"297619\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-1.9\";a:14:{s:4:\"name\";s:16:\"ckeditor 7.x-1.9\";s:7:\"version\";s:7:\"7.x-1.9\";s:3:\"tag\";s:7:\"7.x-1.9\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"9\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/ckeditor/releases/7.x-1.9\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/ckeditor-7.x-1.9.tar.gz\";s:4:\"date\";s:10:\"1334745697\";s:6:\"mdhash\";s:32:\"9ff722478310ae812d07028fa24998dd\";s:8:\"filesize\";s:6:\"176069\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-1.8\";a:14:{s:4:\"name\";s:16:\"ckeditor 7.x-1.8\";s:7:\"version\";s:7:\"7.x-1.8\";s:3:\"tag\";s:7:\"7.x-1.8\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"8\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/ckeditor/releases/7.x-1.8\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/ckeditor-7.x-1.8.tar.gz\";s:4:\"date\";s:10:\"1331818250\";s:6:\"mdhash\";s:32:\"ddf710374b698660dcf5bc8e7a954566\";s:8:\"filesize\";s:6:\"172815\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-1.7\";a:14:{s:4:\"name\";s:16:\"ckeditor 7.x-1.7\";s:7:\"version\";s:7:\"7.x-1.7\";s:3:\"tag\";s:7:\"7.x-1.7\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"7\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/ckeditor/releases/7.x-1.7\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/ckeditor-7.x-1.7.tar.gz\";s:4:\"date\";s:10:\"1331747145\";s:6:\"mdhash\";s:32:\"cb2be6da12cb3fde798bbeb3f1a24707\";s:8:\"filesize\";s:6:\"172799\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:15:\"Security update\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-1.6\";a:14:{s:4:\"name\";s:16:\"ckeditor 7.x-1.6\";s:7:\"version\";s:7:\"7.x-1.6\";s:3:\"tag\";s:7:\"7.x-1.6\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"6\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/ckeditor/releases/7.x-1.6\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/ckeditor-7.x-1.6.tar.gz\";s:4:\"date\";s:10:\"1320880530\";s:6:\"mdhash\";s:32:\"e1f9df6492e157d12284f94dae5b9992\";s:8:\"filesize\";s:6:\"210606\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-1.5\";a:14:{s:4:\"name\";s:16:\"ckeditor 7.x-1.5\";s:7:\"version\";s:7:\"7.x-1.5\";s:3:\"tag\";s:7:\"7.x-1.5\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"5\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/ckeditor/releases/7.x-1.5\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/ckeditor-7.x-1.5.tar.gz\";s:4:\"date\";s:10:\"1320829232\";s:6:\"mdhash\";s:32:\"b04cc3539c6a53f6765aae48b1957644\";s:8:\"filesize\";s:6:\"268084\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:15:\"Security update\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-1.4\";a:14:{s:4:\"name\";s:16:\"ckeditor 7.x-1.4\";s:7:\"version\";s:7:\"7.x-1.4\";s:3:\"tag\";s:7:\"7.x-1.4\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/ckeditor/releases/7.x-1.4\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/ckeditor-7.x-1.4.tar.gz\";s:4:\"date\";s:10:\"1319630130\";s:6:\"mdhash\";s:32:\"d66cba130acc3ff05da2ef6fa30480f9\";s:8:\"filesize\";s:6:\"210061\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-1.3\";a:14:{s:4:\"name\";s:16:\"ckeditor 7.x-1.3\";s:7:\"version\";s:7:\"7.x-1.3\";s:3:\"tag\";s:7:\"7.x-1.3\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/ckeditor/releases/7.x-1.3\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/ckeditor-7.x-1.3.tar.gz\";s:4:\"date\";s:10:\"1314622318\";s:6:\"mdhash\";s:32:\"d94f7cfc922f2020039526bb329936a2\";s:8:\"filesize\";s:5:\"73228\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-1.2\";a:14:{s:4:\"name\";s:16:\"ckeditor 7.x-1.2\";s:7:\"version\";s:7:\"7.x-1.2\";s:3:\"tag\";s:7:\"7.x-1.2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/ckeditor/releases/7.x-1.2\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/ckeditor-7.x-1.2.tar.gz\";s:4:\"date\";s:10:\"1306745815\";s:6:\"mdhash\";s:32:\"7df22e6f6d4666895d00d01134f5960a\";s:8:\"filesize\";s:5:\"93621\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-1.1\";a:14:{s:4:\"name\";s:16:\"ckeditor 7.x-1.1\";s:7:\"version\";s:7:\"7.x-1.1\";s:3:\"tag\";s:7:\"7.x-1.1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/ckeditor/releases/7.x-1.1\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/ckeditor-7.x-1.1.tar.gz\";s:4:\"date\";s:10:\"1299757267\";s:6:\"mdhash\";s:32:\"b118af2ecd2936efc87bec95dacfbafe\";s:8:\"filesize\";s:5:\"87885\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-1.0\";a:14:{s:4:\"name\";s:16:\"ckeditor 7.x-1.0\";s:7:\"version\";s:7:\"7.x-1.0\";s:3:\"tag\";s:7:\"7.x-1.0\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/ckeditor/releases/7.x-1.0\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/ckeditor-7.x-1.0.tar.gz\";s:4:\"date\";s:10:\"1294949192\";s:6:\"mdhash\";s:32:\"f00a0235a70a052226f2db0d6a7c579c\";s:8:\"filesize\";s:6:\"142482\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:11:\"7.x-1.0-rc1\";a:15:{s:4:\"name\";s:20:\"ckeditor 7.x-1.0-rc1\";s:7:\"version\";s:11:\"7.x-1.0-rc1\";s:3:\"tag\";s:11:\"7.x-1.0-rc1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:60:\"https://www.drupal.org/project/ckeditor/releases/7.x-1.0-rc1\";s:13:\"download_link\";s:65:\"https://ftp.drupal.org/files/projects/ckeditor-7.x-1.0-rc1.tar.gz\";s:4:\"date\";s:10:\"1292444466\";s:6:\"mdhash\";s:32:\"942b796a636baec84229135cf03c6353\";s:8:\"filesize\";s:6:\"141641\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:12:\"New features\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:11:\"7.x-1.x-dev\";a:14:{s:4:\"name\";s:20:\"ckeditor 7.x-1.x-dev\";s:7:\"version\";s:11:\"7.x-1.x-dev\";s:3:\"tag\";s:7:\"7.x-1.x\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:60:\"https://www.drupal.org/project/ckeditor/releases/7.x-1.x-dev\";s:13:\"download_link\";s:65:\"https://ftp.drupal.org/files/projects/ckeditor-7.x-1.x-dev.tar.gz\";s:4:\"date\";s:10:\"1498863242\";s:6:\"mdhash\";s:32:\"ff0ca102a1cfd4aa870779d2a388ef56\";s:8:\"filesize\";s:6:\"198104\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";}}}',1512706737,1512620327,1),('available_releases::ctools','a:11:{s:5:\"title\";s:25:\"Chaos tool suite (ctools)\";s:10:\"short_name\";s:6:\"ctools\";s:4:\"type\";s:14:\"project_module\";s:11:\"api_version\";s:3:\"7.x\";s:17:\"recommended_major\";s:1:\"1\";s:16:\"supported_majors\";s:1:\"1\";s:13:\"default_major\";s:1:\"1\";s:14:\"project_status\";s:9:\"published\";s:4:\"link\";s:37:\"https://www.drupal.org/project/ctools\";s:5:\"terms\";s:0:\"\";s:8:\"releases\";a:22:{s:8:\"7.x-1.12\";a:14:{s:4:\"name\";s:15:\"ctools 7.x-1.12\";s:7:\"version\";s:8:\"7.x-1.12\";s:3:\"tag\";s:8:\"7.x-1.12\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:2:\"12\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:55:\"https://www.drupal.org/project/ctools/releases/7.x-1.12\";s:13:\"download_link\";s:60:\"https://ftp.drupal.org/files/projects/ctools-7.x-1.12.tar.gz\";s:4:\"date\";s:10:\"1479787142\";s:6:\"mdhash\";s:32:\"daae0be22830e34c4d952f91557ae5a5\";s:8:\"filesize\";s:6:\"433707\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:8:\"7.x-1.11\";a:14:{s:4:\"name\";s:15:\"ctools 7.x-1.11\";s:7:\"version\";s:8:\"7.x-1.11\";s:3:\"tag\";s:8:\"7.x-1.11\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:2:\"11\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:55:\"https://www.drupal.org/project/ctools/releases/7.x-1.11\";s:13:\"download_link\";s:60:\"https://ftp.drupal.org/files/projects/ctools-7.x-1.11.tar.gz\";s:4:\"date\";s:10:\"1476581639\";s:6:\"mdhash\";s:32:\"271d08d18f3c05f51aba1ad77d42f96c\";s:8:\"filesize\";s:6:\"432144\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:8:\"7.x-1.10\";a:14:{s:4:\"name\";s:15:\"ctools 7.x-1.10\";s:7:\"version\";s:8:\"7.x-1.10\";s:3:\"tag\";s:8:\"7.x-1.10\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:2:\"10\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:55:\"https://www.drupal.org/project/ctools/releases/7.x-1.10\";s:13:\"download_link\";s:60:\"https://ftp.drupal.org/files/projects/ctools-7.x-1.10.tar.gz\";s:4:\"date\";s:10:\"1471454080\";s:6:\"mdhash\";s:32:\"38bb47304f6dcd0bcd6b02ed6ee235fc\";s:8:\"filesize\";s:6:\"430198\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-1.9\";a:14:{s:4:\"name\";s:14:\"ctools 7.x-1.9\";s:7:\"version\";s:7:\"7.x-1.9\";s:3:\"tag\";s:7:\"7.x-1.9\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"9\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:54:\"https://www.drupal.org/project/ctools/releases/7.x-1.9\";s:13:\"download_link\";s:59:\"https://ftp.drupal.org/files/projects/ctools-7.x-1.9.tar.gz\";s:4:\"date\";s:10:\"1440019139\";s:6:\"mdhash\";s:32:\"bd7b5dac915e8fa3da909379807ef824\";s:8:\"filesize\";s:6:\"429330\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-1.8\";a:14:{s:4:\"name\";s:14:\"ctools 7.x-1.8\";s:7:\"version\";s:7:\"7.x-1.8\";s:3:\"tag\";s:7:\"7.x-1.8\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"8\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:54:\"https://www.drupal.org/project/ctools/releases/7.x-1.8\";s:13:\"download_link\";s:59:\"https://ftp.drupal.org/files/projects/ctools-7.x-1.8.tar.gz\";s:4:\"date\";s:10:\"1440015839\";s:6:\"mdhash\";s:32:\"629f8bc414026864fe4a235b62586e0c\";s:8:\"filesize\";s:6:\"428252\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:15:\"Security update\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-1.7\";a:14:{s:4:\"name\";s:14:\"ctools 7.x-1.7\";s:7:\"version\";s:7:\"7.x-1.7\";s:3:\"tag\";s:7:\"7.x-1.7\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"7\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:54:\"https://www.drupal.org/project/ctools/releases/7.x-1.7\";s:13:\"download_link\";s:59:\"https://ftp.drupal.org/files/projects/ctools-7.x-1.7.tar.gz\";s:4:\"date\";s:10:\"1426695781\";s:6:\"mdhash\";s:32:\"81ab507b12875b02b88a0492d1173b99\";s:8:\"filesize\";s:6:\"426463\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:15:\"Security update\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-1.6\";a:14:{s:4:\"name\";s:14:\"ctools 7.x-1.6\";s:7:\"version\";s:7:\"7.x-1.6\";s:3:\"tag\";s:7:\"7.x-1.6\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"6\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:54:\"https://www.drupal.org/project/ctools/releases/7.x-1.6\";s:13:\"download_link\";s:59:\"https://ftp.drupal.org/files/projects/ctools-7.x-1.6.tar.gz\";s:4:\"date\";s:10:\"1422471481\";s:6:\"mdhash\";s:32:\"e8999d5bd1748ee3dcd4fdc33a24c615\";s:8:\"filesize\";s:6:\"424622\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:11:\"7.x-1.6-rc1\";a:15:{s:4:\"name\";s:18:\"ctools 7.x-1.6-rc1\";s:7:\"version\";s:11:\"7.x-1.6-rc1\";s:3:\"tag\";s:11:\"7.x-1.6-rc1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"6\";s:13:\"version_extra\";s:3:\"rc1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:58:\"https://www.drupal.org/project/ctools/releases/7.x-1.6-rc1\";s:13:\"download_link\";s:63:\"https://ftp.drupal.org/files/projects/ctools-7.x-1.6-rc1.tar.gz\";s:4:\"date\";s:10:\"1418961480\";s:6:\"mdhash\";s:32:\"f3dc80ff7f3e29c73870f26a6ad02ff7\";s:8:\"filesize\";s:6:\"422180\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:7:\"7.x-1.5\";a:14:{s:4:\"name\";s:14:\"ctools 7.x-1.5\";s:7:\"version\";s:7:\"7.x-1.5\";s:3:\"tag\";s:7:\"7.x-1.5\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"5\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:54:\"https://www.drupal.org/project/ctools/releases/7.x-1.5\";s:13:\"download_link\";s:59:\"https://ftp.drupal.org/files/projects/ctools-7.x-1.5.tar.gz\";s:4:\"date\";s:10:\"1416423482\";s:6:\"mdhash\";s:32:\"0e90d8baaae78d3c37fe73dbe0d98dac\";s:8:\"filesize\";s:6:\"417508\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-1.4\";a:14:{s:4:\"name\";s:14:\"ctools 7.x-1.4\";s:7:\"version\";s:7:\"7.x-1.4\";s:3:\"tag\";s:7:\"7.x-1.4\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:54:\"https://www.drupal.org/project/ctools/releases/7.x-1.4\";s:13:\"download_link\";s:59:\"https://ftp.drupal.org/files/projects/ctools-7.x-1.4.tar.gz\";s:4:\"date\";s:10:\"1392220719\";s:6:\"mdhash\";s:32:\"df1ce5aeb6a9a5c383d944a2a7494f18\";s:8:\"filesize\";s:6:\"415678\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:3:{i:0;s:15:\"Security update\";i:1;s:9:\"Bug fixes\";i:2;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-1.3\";a:14:{s:4:\"name\";s:14:\"ctools 7.x-1.3\";s:7:\"version\";s:7:\"7.x-1.3\";s:3:\"tag\";s:7:\"7.x-1.3\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:54:\"https://www.drupal.org/project/ctools/releases/7.x-1.3\";s:13:\"download_link\";s:59:\"https://ftp.drupal.org/files/projects/ctools-7.x-1.3.tar.gz\";s:4:\"date\";s:10:\"1365013512\";s:6:\"mdhash\";s:32:\"b27a7230f63a7a81db8cc480ab2dba63\";s:8:\"filesize\";s:6:\"413477\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:15:\"Security update\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-1.2\";a:14:{s:4:\"name\";s:14:\"ctools 7.x-1.2\";s:7:\"version\";s:7:\"7.x-1.2\";s:3:\"tag\";s:7:\"7.x-1.2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:54:\"https://www.drupal.org/project/ctools/releases/7.x-1.2\";s:13:\"download_link\";s:59:\"https://ftp.drupal.org/files/projects/ctools-7.x-1.2.tar.gz\";s:4:\"date\";s:10:\"1345319204\";s:6:\"mdhash\";s:32:\"62fa855ee8aced1e355b09ac6cd54e99\";s:8:\"filesize\";s:6:\"407345\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-1.1\";a:14:{s:4:\"name\";s:14:\"ctools 7.x-1.1\";s:7:\"version\";s:7:\"7.x-1.1\";s:3:\"tag\";s:7:\"7.x-1.1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:54:\"https://www.drupal.org/project/ctools/releases/7.x-1.1\";s:13:\"download_link\";s:59:\"https://ftp.drupal.org/files/projects/ctools-7.x-1.1.tar.gz\";s:4:\"date\";s:10:\"1344463011\";s:6:\"mdhash\";s:32:\"c36cbb2fd7a6eb8b3245c13972380bd7\";s:8:\"filesize\";s:6:\"405567\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:15:\"Security update\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-1.0\";a:14:{s:4:\"name\";s:14:\"ctools 7.x-1.0\";s:7:\"version\";s:7:\"7.x-1.0\";s:3:\"tag\";s:7:\"7.x-1.0\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:54:\"https://www.drupal.org/project/ctools/releases/7.x-1.0\";s:13:\"download_link\";s:59:\"https://ftp.drupal.org/files/projects/ctools-7.x-1.0.tar.gz\";s:4:\"date\";s:10:\"1332962446\";s:6:\"mdhash\";s:32:\"642eca364e64b0074e5ad49f86627ac5\";s:8:\"filesize\";s:6:\"402254\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:15:\"Security update\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:11:\"7.x-1.0-rc2\";a:15:{s:4:\"name\";s:18:\"ctools 7.x-1.0-rc2\";s:7:\"version\";s:11:\"7.x-1.0-rc2\";s:3:\"tag\";s:11:\"7.x-1.0-rc2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:58:\"https://www.drupal.org/project/ctools/releases/7.x-1.0-rc2\";s:13:\"download_link\";s:63:\"https://ftp.drupal.org/files/projects/ctools-7.x-1.0-rc2.tar.gz\";s:4:\"date\";s:10:\"1332017742\";s:6:\"mdhash\";s:32:\"791167a47cea014fad9018c93376aa88\";s:8:\"filesize\";s:6:\"396440\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:11:\"7.x-1.0-rc1\";a:15:{s:4:\"name\";s:18:\"ctools 7.x-1.0-rc1\";s:7:\"version\";s:11:\"7.x-1.0-rc1\";s:3:\"tag\";s:11:\"7.x-1.0-rc1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:58:\"https://www.drupal.org/project/ctools/releases/7.x-1.0-rc1\";s:13:\"download_link\";s:63:\"https://ftp.drupal.org/files/projects/ctools-7.x-1.0-rc1.tar.gz\";s:4:\"date\";s:10:\"1311894415\";s:6:\"mdhash\";s:32:\"39bcea671210505409e3148c8eaefc0e\";s:8:\"filesize\";s:6:\"381078\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:13:\"7.x-1.0-beta1\";a:15:{s:4:\"name\";s:20:\"ctools 7.x-1.0-beta1\";s:7:\"version\";s:13:\"7.x-1.0-beta1\";s:3:\"tag\";s:13:\"7.x-1.0-beta1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:60:\"https://www.drupal.org/project/ctools/releases/7.x-1.0-beta1\";s:13:\"download_link\";s:65:\"https://ftp.drupal.org/files/projects/ctools-7.x-1.0-beta1.tar.gz\";s:4:\"date\";s:10:\"1306885315\";s:6:\"mdhash\";s:32:\"96d8154bfab611eb59cbd3774aa94793\";s:8:\"filesize\";s:6:\"378287\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:14:\"7.x-1.0-alpha4\";a:15:{s:4:\"name\";s:21:\"ctools 7.x-1.0-alpha4\";s:7:\"version\";s:14:\"7.x-1.0-alpha4\";s:3:\"tag\";s:14:\"7.x-1.0-alpha4\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/ctools/releases/7.x-1.0-alpha4\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/ctools-7.x-1.0-alpha4.tar.gz\";s:4:\"date\";s:10:\"1301099792\";s:6:\"mdhash\";s:32:\"774f6654c149f192b11b136a06be5544\";s:8:\"filesize\";s:6:\"370763\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:14:\"7.x-1.0-alpha3\";a:15:{s:4:\"name\";s:21:\"ctools 7.x-1.0-alpha3\";s:7:\"version\";s:14:\"7.x-1.0-alpha3\";s:3:\"tag\";s:14:\"7.x-1.0-alpha3\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/ctools/releases/7.x-1.0-alpha3\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/ctools-7.x-1.0-alpha3.tar.gz\";s:4:\"date\";s:10:\"1300395967\";s:6:\"mdhash\";s:32:\"1909846a7bd5775c99331c6564ffefa8\";s:8:\"filesize\";s:6:\"370238\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:14:\"7.x-1.0-alpha2\";a:15:{s:4:\"name\";s:21:\"ctools 7.x-1.0-alpha2\";s:7:\"version\";s:14:\"7.x-1.0-alpha2\";s:3:\"tag\";s:14:\"7.x-1.0-alpha2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/ctools/releases/7.x-1.0-alpha2\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/ctools-7.x-1.0-alpha2.tar.gz\";s:4:\"date\";s:10:\"1294276865\";s:6:\"mdhash\";s:32:\"30e0f5cb27949d2cd67b80bb36701d3e\";s:8:\"filesize\";s:6:\"521068\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:14:\"7.x-1.0-alpha1\";a:15:{s:4:\"name\";s:21:\"ctools 7.x-1.0-alpha1\";s:7:\"version\";s:14:\"7.x-1.0-alpha1\";s:3:\"tag\";s:14:\"7.x-1.0-alpha1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/ctools/releases/7.x-1.0-alpha1\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/ctools-7.x-1.0-alpha1.tar.gz\";s:4:\"date\";s:10:\"1286838960\";s:6:\"mdhash\";s:32:\"500a55a33f90b2bab865753a0d8c5439\";s:8:\"filesize\";s:6:\"510384\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}s:11:\"7.x-1.x-dev\";a:14:{s:4:\"name\";s:18:\"ctools 7.x-1.x-dev\";s:7:\"version\";s:11:\"7.x-1.x-dev\";s:3:\"tag\";s:7:\"7.x-1.x\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:58:\"https://www.drupal.org/project/ctools/releases/7.x-1.x-dev\";s:13:\"download_link\";s:63:\"https://ftp.drupal.org/files/projects/ctools-7.x-1.x-dev.tar.gz\";s:4:\"date\";s:10:\"1503512045\";s:6:\"mdhash\";s:32:\"38d159499be2a534436ff7ef7305d3cc\";s:8:\"filesize\";s:6:\"446584\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}}}',1512706738,1512620327,1),('available_releases::date','a:11:{s:5:\"title\";s:4:\"Date\";s:10:\"short_name\";s:4:\"date\";s:4:\"type\";s:14:\"project_module\";s:11:\"api_version\";s:3:\"7.x\";s:17:\"recommended_major\";s:1:\"2\";s:16:\"supported_majors\";s:1:\"2\";s:13:\"default_major\";s:1:\"2\";s:14:\"project_status\";s:9:\"published\";s:4:\"link\";s:35:\"https://www.drupal.org/project/date\";s:5:\"terms\";s:0:\"\";s:8:\"releases\";a:31:{s:8:\"7.x-2.10\";a:14:{s:4:\"name\";s:13:\"date 7.x-2.10\";s:7:\"version\";s:8:\"7.x-2.10\";s:3:\"tag\";s:8:\"7.x-2.10\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:2:\"10\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:53:\"https://www.drupal.org/project/date/releases/7.x-2.10\";s:13:\"download_link\";s:58:\"https://ftp.drupal.org/files/projects/date-7.x-2.10.tar.gz\";s:4:\"date\";s:10:\"1491562083\";s:6:\"mdhash\";s:32:\"2574ab984de79b65f93dbeb48a4e2036\";s:8:\"filesize\";s:6:\"226466\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:12:\"7.x-2.10-rc2\";a:15:{s:4:\"name\";s:17:\"date 7.x-2.10-rc2\";s:7:\"version\";s:12:\"7.x-2.10-rc2\";s:3:\"tag\";s:12:\"7.x-2.10-rc2\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:2:\"10\";s:13:\"version_extra\";s:3:\"rc2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:57:\"https://www.drupal.org/project/date/releases/7.x-2.10-rc2\";s:13:\"download_link\";s:62:\"https://ftp.drupal.org/files/projects/date-7.x-2.10-rc2.tar.gz\";s:4:\"date\";s:10:\"1490783284\";s:6:\"mdhash\";s:32:\"2e59072e74cf1e180b5f159cea91639c\";s:8:\"filesize\";s:6:\"226485\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:12:\"7.x-2.10-rc1\";a:15:{s:4:\"name\";s:17:\"date 7.x-2.10-rc1\";s:7:\"version\";s:12:\"7.x-2.10-rc1\";s:3:\"tag\";s:12:\"7.x-2.10-rc1\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:2:\"10\";s:13:\"version_extra\";s:3:\"rc1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:57:\"https://www.drupal.org/project/date/releases/7.x-2.10-rc1\";s:13:\"download_link\";s:62:\"https://ftp.drupal.org/files/projects/date-7.x-2.10-rc1.tar.gz\";s:4:\"date\";s:10:\"1461749740\";s:6:\"mdhash\";s:32:\"59079319cdaa7f96843c66a674bd6f96\";s:8:\"filesize\";s:6:\"226185\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:14:\"7.x-2.10-beta1\";a:15:{s:4:\"name\";s:19:\"date 7.x-2.10-beta1\";s:7:\"version\";s:14:\"7.x-2.10-beta1\";s:3:\"tag\";s:14:\"7.x-2.10-beta1\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:2:\"10\";s:13:\"version_extra\";s:5:\"beta1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:59:\"https://www.drupal.org/project/date/releases/7.x-2.10-beta1\";s:13:\"download_link\";s:64:\"https://ftp.drupal.org/files/projects/date-7.x-2.10-beta1.tar.gz\";s:4:\"date\";s:10:\"1452253139\";s:6:\"mdhash\";s:32:\"b6c7abde2995afb8a014cb590ac131ac\";s:8:\"filesize\";s:6:\"224719\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:7:\"7.x-2.9\";a:14:{s:4:\"name\";s:12:\"date 7.x-2.9\";s:7:\"version\";s:7:\"7.x-2.9\";s:3:\"tag\";s:7:\"7.x-2.9\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"9\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/date/releases/7.x-2.9\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/date-7.x-2.9.tar.gz\";s:4:\"date\";s:10:\"1441727339\";s:6:\"mdhash\";s:32:\"5d76a5e020d3926aa3c516e426678700\";s:8:\"filesize\";s:6:\"224512\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:11:\"7.x-2.9-rc1\";a:15:{s:4:\"name\";s:16:\"date 7.x-2.9-rc1\";s:7:\"version\";s:11:\"7.x-2.9-rc1\";s:3:\"tag\";s:11:\"7.x-2.9-rc1\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"9\";s:13:\"version_extra\";s:3:\"rc1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/date/releases/7.x-2.9-rc1\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/date-7.x-2.9-rc1.tar.gz\";s:4:\"date\";s:10:\"1427454181\";s:6:\"mdhash\";s:32:\"5cc051772c39d76bb0a2bfd8a5f7c775\";s:8:\"filesize\";s:6:\"224454\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:13:\"7.x-2.9-beta2\";a:15:{s:4:\"name\";s:18:\"date 7.x-2.9-beta2\";s:7:\"version\";s:13:\"7.x-2.9-beta2\";s:3:\"tag\";s:13:\"7.x-2.9-beta2\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"9\";s:13:\"version_extra\";s:5:\"beta2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:58:\"https://www.drupal.org/project/date/releases/7.x-2.9-beta2\";s:13:\"download_link\";s:63:\"https://ftp.drupal.org/files/projects/date-7.x-2.9-beta2.tar.gz\";s:4:\"date\";s:10:\"1417718873\";s:6:\"mdhash\";s:32:\"e81616832e6ef58be039640a4fe35390\";s:8:\"filesize\";s:6:\"223732\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"7.x-2.9-beta1\";a:15:{s:4:\"name\";s:18:\"date 7.x-2.9-beta1\";s:7:\"version\";s:13:\"7.x-2.9-beta1\";s:3:\"tag\";s:13:\"7.x-2.9-beta1\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"9\";s:13:\"version_extra\";s:5:\"beta1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:58:\"https://www.drupal.org/project/date/releases/7.x-2.9-beta1\";s:13:\"download_link\";s:63:\"https://ftp.drupal.org/files/projects/date-7.x-2.9-beta1.tar.gz\";s:4:\"date\";s:10:\"1415483880\";s:6:\"mdhash\";s:32:\"e03390f28efe81e7e56180651f4bb76a\";s:8:\"filesize\";s:6:\"222344\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:14:\"7.x-2.9-alpha2\";a:15:{s:4:\"name\";s:19:\"date 7.x-2.9-alpha2\";s:7:\"version\";s:14:\"7.x-2.9-alpha2\";s:3:\"tag\";s:14:\"7.x-2.9-alpha2\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"9\";s:13:\"version_extra\";s:6:\"alpha2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:59:\"https://www.drupal.org/project/date/releases/7.x-2.9-alpha2\";s:13:\"download_link\";s:64:\"https://ftp.drupal.org/files/projects/date-7.x-2.9-alpha2.tar.gz\";s:4:\"date\";s:10:\"1411597754\";s:6:\"mdhash\";s:32:\"2f71a9bc1dc8a13c1607ca2dc74a87b7\";s:8:\"filesize\";s:6:\"218373\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:14:\"7.x-2.9-alpha1\";a:15:{s:4:\"name\";s:19:\"date 7.x-2.9-alpha1\";s:7:\"version\";s:14:\"7.x-2.9-alpha1\";s:3:\"tag\";s:14:\"7.x-2.9-alpha1\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"9\";s:13:\"version_extra\";s:6:\"alpha1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:59:\"https://www.drupal.org/project/date/releases/7.x-2.9-alpha1\";s:13:\"download_link\";s:64:\"https://ftp.drupal.org/files/projects/date-7.x-2.9-alpha1.tar.gz\";s:4:\"date\";s:10:\"1406829527\";s:6:\"mdhash\";s:32:\"3e6a694c86989c61d9cd5cf4cf582bc5\";s:8:\"filesize\";s:6:\"218628\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:7:\"7.x-2.8\";a:14:{s:4:\"name\";s:12:\"date 7.x-2.8\";s:7:\"version\";s:7:\"7.x-2.8\";s:3:\"tag\";s:7:\"7.x-2.8\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"8\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/date/releases/7.x-2.8\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/date-7.x-2.8.tar.gz\";s:4:\"date\";s:10:\"1406653427\";s:6:\"mdhash\";s:32:\"e0d07255a60e3a7716db5902767e08d1\";s:8:\"filesize\";s:6:\"218587\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:15:\"Security update\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:13:\"7.x-2.8-beta2\";a:15:{s:4:\"name\";s:18:\"date 7.x-2.8-beta2\";s:7:\"version\";s:13:\"7.x-2.8-beta2\";s:3:\"tag\";s:13:\"7.x-2.8-beta2\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"8\";s:13:\"version_extra\";s:5:\"beta2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:58:\"https://www.drupal.org/project/date/releases/7.x-2.8-beta2\";s:13:\"download_link\";s:63:\"https://ftp.drupal.org/files/projects/date-7.x-2.8-beta2.tar.gz\";s:4:\"date\";s:10:\"1406317428\";s:6:\"mdhash\";s:32:\"3ba190c30aa3833500af8505c9951121\";s:8:\"filesize\";s:6:\"217910\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"7.x-2.8-beta1\";a:15:{s:4:\"name\";s:18:\"date 7.x-2.8-beta1\";s:7:\"version\";s:13:\"7.x-2.8-beta1\";s:3:\"tag\";s:13:\"7.x-2.8-beta1\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"8\";s:13:\"version_extra\";s:5:\"beta1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:58:\"https://www.drupal.org/project/date/releases/7.x-2.8-beta1\";s:13:\"download_link\";s:63:\"https://ftp.drupal.org/files/projects/date-7.x-2.8-beta1.tar.gz\";s:4:\"date\";s:10:\"1403366927\";s:6:\"mdhash\";s:32:\"cf89ddee77f567db0157124e1651246d\";s:8:\"filesize\";s:6:\"217411\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:7:\"7.x-2.7\";a:14:{s:4:\"name\";s:12:\"date 7.x-2.7\";s:7:\"version\";s:7:\"7.x-2.7\";s:3:\"tag\";s:7:\"7.x-2.7\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"7\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/date/releases/7.x-2.7\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/date-7.x-2.7.tar.gz\";s:4:\"date\";s:10:\"1387659204\";s:6:\"mdhash\";s:32:\"24e11f82623a442305c30cb6887d77f9\";s:8:\"filesize\";s:6:\"216320\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-2.6\";a:14:{s:4:\"name\";s:12:\"date 7.x-2.6\";s:7:\"version\";s:7:\"7.x-2.6\";s:3:\"tag\";s:7:\"7.x-2.6\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"6\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/date/releases/7.x-2.6\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/date-7.x-2.6.tar.gz\";s:4:\"date\";s:10:\"1344850024\";s:6:\"mdhash\";s:32:\"cc22fe50289aea79b3b9b240baba0111\";s:8:\"filesize\";s:6:\"213301\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-2.5\";a:14:{s:4:\"name\";s:12:\"date 7.x-2.5\";s:7:\"version\";s:7:\"7.x-2.5\";s:3:\"tag\";s:7:\"7.x-2.5\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"5\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/date/releases/7.x-2.5\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/date-7.x-2.5.tar.gz\";s:4:\"date\";s:10:\"1334835098\";s:6:\"mdhash\";s:32:\"56fa435f5c8831655ddf3f4fffe2b97a\";s:8:\"filesize\";s:6:\"211078\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-2.4\";a:14:{s:4:\"name\";s:12:\"date 7.x-2.4\";s:7:\"version\";s:7:\"7.x-2.4\";s:3:\"tag\";s:7:\"7.x-2.4\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/date/releases/7.x-2.4\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/date-7.x-2.4.tar.gz\";s:4:\"date\";s:10:\"1334828498\";s:6:\"mdhash\";s:32:\"2c152c82d8cc55e090cba40a46742465\";s:8:\"filesize\";s:6:\"210999\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-2.3\";a:14:{s:4:\"name\";s:12:\"date 7.x-2.3\";s:7:\"version\";s:7:\"7.x-2.3\";s:3:\"tag\";s:7:\"7.x-2.3\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/date/releases/7.x-2.3\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/date-7.x-2.3.tar.gz\";s:4:\"date\";s:10:\"1333273246\";s:6:\"mdhash\";s:32:\"3290ee3891157384b606633dda02fe19\";s:8:\"filesize\";s:6:\"210464\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-2.2\";a:14:{s:4:\"name\";s:12:\"date 7.x-2.2\";s:7:\"version\";s:7:\"7.x-2.2\";s:3:\"tag\";s:7:\"7.x-2.2\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/date/releases/7.x-2.2\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/date-7.x-2.2.tar.gz\";s:4:\"date\";s:10:\"1330089942\";s:6:\"mdhash\";s:32:\"652323d741226212057e8f58906c7d6a\";s:8:\"filesize\";s:6:\"207223\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-2.1\";a:14:{s:4:\"name\";s:12:\"date 7.x-2.1\";s:7:\"version\";s:7:\"7.x-2.1\";s:3:\"tag\";s:7:\"7.x-2.1\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/date/releases/7.x-2.1\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/date-7.x-2.1.tar.gz\";s:4:\"date\";s:10:\"1329214840\";s:6:\"mdhash\";s:32:\"08eab951b7096b1edcc1cdff52b3c9cc\";s:8:\"filesize\";s:6:\"208349\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:11:\"7.x-2.0-rc2\";a:15:{s:4:\"name\";s:16:\"date 7.x-2.0-rc2\";s:7:\"version\";s:11:\"7.x-2.0-rc2\";s:3:\"tag\";s:11:\"7.x-2.0-rc2\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/date/releases/7.x-2.0-rc2\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/date-7.x-2.0-rc2.tar.gz\";s:4:\"date\";s:10:\"1328104249\";s:6:\"mdhash\";s:32:\"60e5d591d567e823141650db8290394b\";s:8:\"filesize\";s:6:\"208479\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:11:\"7.x-2.0-rc1\";a:15:{s:4:\"name\";s:16:\"date 7.x-2.0-rc1\";s:7:\"version\";s:11:\"7.x-2.0-rc1\";s:3:\"tag\";s:11:\"7.x-2.0-rc1\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/date/releases/7.x-2.0-rc1\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/date-7.x-2.0-rc1.tar.gz\";s:4:\"date\";s:10:\"1324415138\";s:6:\"mdhash\";s:32:\"553e622be1be5c28b59c088f8b890872\";s:8:\"filesize\";s:6:\"203112\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:14:\"7.x-2.0-alpha5\";a:15:{s:4:\"name\";s:19:\"date 7.x-2.0-alpha5\";s:7:\"version\";s:14:\"7.x-2.0-alpha5\";s:3:\"tag\";s:14:\"7.x-2.0-alpha5\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha5\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:59:\"https://www.drupal.org/project/date/releases/7.x-2.0-alpha5\";s:13:\"download_link\";s:64:\"https://ftp.drupal.org/files/projects/date-7.x-2.0-alpha5.tar.gz\";s:4:\"date\";s:10:\"1322563238\";s:6:\"mdhash\";s:32:\"02cf9eff83b7203b70c311daca9c0e8c\";s:8:\"filesize\";s:6:\"204364\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:14:\"7.x-2.0-alpha4\";a:15:{s:4:\"name\";s:19:\"date 7.x-2.0-alpha4\";s:7:\"version\";s:14:\"7.x-2.0-alpha4\";s:3:\"tag\";s:14:\"7.x-2.0-alpha4\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:59:\"https://www.drupal.org/project/date/releases/7.x-2.0-alpha4\";s:13:\"download_link\";s:64:\"https://ftp.drupal.org/files/projects/date-7.x-2.0-alpha4.tar.gz\";s:4:\"date\";s:10:\"1314097619\";s:6:\"mdhash\";s:32:\"832ce7f175146004c9976b9191d37f45\";s:8:\"filesize\";s:6:\"195013\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:14:\"7.x-2.0-alpha3\";a:15:{s:4:\"name\";s:19:\"date 7.x-2.0-alpha3\";s:7:\"version\";s:14:\"7.x-2.0-alpha3\";s:3:\"tag\";s:14:\"7.x-2.0-alpha3\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:59:\"https://www.drupal.org/project/date/releases/7.x-2.0-alpha3\";s:13:\"download_link\";s:64:\"https://ftp.drupal.org/files/projects/date-7.x-2.0-alpha3.tar.gz\";s:4:\"date\";s:10:\"1303821715\";s:6:\"mdhash\";s:32:\"d7de2d8ece4098fe8ac9ce6e5eb30270\";s:8:\"filesize\";s:6:\"169553\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:14:\"7.x-2.0-alpha2\";a:15:{s:4:\"name\";s:19:\"date 7.x-2.0-alpha2\";s:7:\"version\";s:14:\"7.x-2.0-alpha2\";s:3:\"tag\";s:14:\"7.x-2.0-alpha2\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:59:\"https://www.drupal.org/project/date/releases/7.x-2.0-alpha2\";s:13:\"download_link\";s:64:\"https://ftp.drupal.org/files/projects/date-7.x-2.0-alpha2.tar.gz\";s:4:\"date\";s:10:\"1303818715\";s:6:\"mdhash\";s:32:\"2a2c10cb87eed66b0174283f9fc607c4\";s:8:\"filesize\";s:6:\"169563\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:14:\"7.x-2.0-alpha1\";a:15:{s:4:\"name\";s:19:\"date 7.x-2.0-alpha1\";s:7:\"version\";s:14:\"7.x-2.0-alpha1\";s:3:\"tag\";s:14:\"7.x-2.0-alpha1\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:59:\"https://www.drupal.org/project/date/releases/7.x-2.0-alpha1\";s:13:\"download_link\";s:64:\"https://ftp.drupal.org/files/projects/date-7.x-2.0-alpha1.tar.gz\";s:4:\"date\";s:10:\"1299682267\";s:6:\"mdhash\";s:32:\"c5ab4e67bb59da279c0da9b10ed9725e\";s:8:\"filesize\";s:6:\"166837\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:14:\"7.x-1.0-alpha2\";a:15:{s:4:\"name\";s:19:\"date 7.x-1.0-alpha2\";s:7:\"version\";s:14:\"7.x-1.0-alpha2\";s:3:\"tag\";s:14:\"7.x-1.0-alpha2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:59:\"https://www.drupal.org/project/date/releases/7.x-1.0-alpha2\";s:13:\"download_link\";s:64:\"https://ftp.drupal.org/files/projects/date-7.x-1.0-alpha2.tar.gz\";s:4:\"date\";s:10:\"1295529407\";s:6:\"mdhash\";s:32:\"0ed3d8939eeb72e7a3bcb537ed4d21ff\";s:8:\"filesize\";s:6:\"268480\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:14:\"7.x-1.0-alpha1\";a:15:{s:4:\"name\";s:19:\"date 7.x-1.0-alpha1\";s:7:\"version\";s:14:\"7.x-1.0-alpha1\";s:3:\"tag\";s:14:\"7.x-1.0-alpha1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:59:\"https://www.drupal.org/project/date/releases/7.x-1.0-alpha1\";s:13:\"download_link\";s:64:\"https://ftp.drupal.org/files/projects/date-7.x-1.0-alpha1.tar.gz\";s:4:\"date\";s:10:\"1295353339\";s:6:\"mdhash\";s:32:\"6534800ffd881bab8721172100039111\";s:8:\"filesize\";s:6:\"268378\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}s:11:\"7.x-2.x-dev\";a:14:{s:4:\"name\";s:16:\"date 7.x-2.x-dev\";s:7:\"version\";s:11:\"7.x-2.x-dev\";s:3:\"tag\";s:7:\"7.x-2.x\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/date/releases/7.x-2.x-dev\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/date-7.x-2.x-dev.tar.gz\";s:4:\"date\";s:10:\"1490712482\";s:6:\"mdhash\";s:32:\"d1b92438376c95b25e429036c4dd3ef9\";s:8:\"filesize\";s:6:\"226507\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:12:\"New features\";}}s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";}s:11:\"7.x-1.x-dev\";a:14:{s:4:\"name\";s:16:\"date-7.x-1.x-dev\";s:7:\"version\";s:11:\"7.x-1.x-dev\";s:3:\"tag\";s:7:\"7.x-1.x\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/date/releases/7.x-1.x-dev\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/date-7.x-1.x-dev.tar.gz\";s:4:\"date\";s:10:\"1490710682\";s:6:\"mdhash\";s:32:\"fac06f792a558a00f0bc1b49b43469fd\";s:8:\"filesize\";s:6:\"166214\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}}}',1512706738,1512620327,1),('available_releases::drupal','a:11:{s:5:\"title\";s:11:\"Drupal core\";s:10:\"short_name\";s:6:\"drupal\";s:4:\"type\";s:12:\"project_core\";s:11:\"api_version\";s:3:\"7.x\";s:17:\"recommended_major\";s:1:\"7\";s:16:\"supported_majors\";s:1:\"7\";s:13:\"default_major\";s:1:\"7\";s:14:\"project_status\";s:9:\"published\";s:4:\"link\";s:37:\"https://www.drupal.org/project/drupal\";s:5:\"terms\";s:0:\"\";s:8:\"releases\";a:67:{s:4:\"7.56\";a:14:{s:4:\"name\";s:11:\"drupal 7.56\";s:7:\"version\";s:4:\"7.56\";s:3:\"tag\";s:4:\"7.56\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:2:\"56\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:51:\"https://www.drupal.org/project/drupal/releases/7.56\";s:13:\"download_link\";s:56:\"https://ftp.drupal.org/files/projects/drupal-7.56.tar.gz\";s:4:\"date\";s:10:\"1498069782\";s:6:\"mdhash\";s:32:\"5d198f40f0f1cbf9cdf1bf3de842e534\";s:8:\"filesize\";s:7:\"3277833\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:15:\"Security update\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:4:\"7.55\";a:14:{s:4:\"name\";s:11:\"drupal 7.55\";s:7:\"version\";s:4:\"7.55\";s:3:\"tag\";s:4:\"7.55\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:2:\"55\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:51:\"https://www.drupal.org/project/drupal/releases/7.55\";s:13:\"download_link\";s:56:\"https://ftp.drupal.org/files/projects/drupal-7.55.tar.gz\";s:4:\"date\";s:10:\"1496873942\";s:6:\"mdhash\";s:32:\"ad97f8c86cee7be9d6ab13724b55fa1c\";s:8:\"filesize\";s:7:\"3277355\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:4:\"7.54\";a:14:{s:4:\"name\";s:11:\"drupal 7.54\";s:7:\"version\";s:4:\"7.54\";s:3:\"tag\";s:4:\"7.54\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:2:\"54\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:51:\"https://www.drupal.org/project/drupal/releases/7.54\";s:13:\"download_link\";s:56:\"https://ftp.drupal.org/files/projects/drupal-7.54.tar.gz\";s:4:\"date\";s:10:\"1485986883\";s:6:\"mdhash\";s:32:\"3068cbe488075ae166e23ea6cd29cf0f\";s:8:\"filesize\";s:7:\"3275864\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:4:\"7.53\";a:14:{s:4:\"name\";s:11:\"drupal 7.53\";s:7:\"version\";s:4:\"7.53\";s:3:\"tag\";s:4:\"7.53\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:2:\"53\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:51:\"https://www.drupal.org/project/drupal/releases/7.53\";s:13:\"download_link\";s:56:\"https://ftp.drupal.org/files/projects/drupal-7.53.tar.gz\";s:4:\"date\";s:10:\"1481152384\";s:6:\"mdhash\";s:32:\"4230279ecca4f0cde652a219e10327e7\";s:8:\"filesize\";s:7:\"3273245\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:4:\"7.52\";a:14:{s:4:\"name\";s:11:\"drupal 7.52\";s:7:\"version\";s:4:\"7.52\";s:3:\"tag\";s:4:\"7.52\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:2:\"52\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:51:\"https://www.drupal.org/project/drupal/releases/7.52\";s:13:\"download_link\";s:56:\"https://ftp.drupal.org/files/projects/drupal-7.52.tar.gz\";s:4:\"date\";s:10:\"1479322810\";s:6:\"mdhash\";s:32:\"4963e68ca12918d3a3eae56054214191\";s:8:\"filesize\";s:7:\"3289714\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:15:\"Security update\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:4:\"7.51\";a:14:{s:4:\"name\";s:11:\"drupal 7.51\";s:7:\"version\";s:4:\"7.51\";s:3:\"tag\";s:4:\"7.51\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:2:\"51\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:51:\"https://www.drupal.org/project/drupal/releases/7.51\";s:13:\"download_link\";s:56:\"https://ftp.drupal.org/files/projects/drupal-7.51.tar.gz\";s:4:\"date\";s:10:\"1475693339\";s:6:\"mdhash\";s:32:\"49f82c1cac8e4bd4941ca160fcbee93d\";s:8:\"filesize\";s:7:\"3288987\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:4:\"7.50\";a:14:{s:4:\"name\";s:11:\"drupal 7.50\";s:7:\"version\";s:4:\"7.50\";s:3:\"tag\";s:4:\"7.50\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:2:\"50\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:51:\"https://www.drupal.org/project/drupal/releases/7.50\";s:13:\"download_link\";s:56:\"https://ftp.drupal.org/files/projects/drupal-7.50.tar.gz\";s:4:\"date\";s:10:\"1467918239\";s:6:\"mdhash\";s:32:\"f23905b0248d76f0fc8316692cd64753\";s:8:\"filesize\";s:7:\"3286826\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:4:\"7.44\";a:14:{s:4:\"name\";s:11:\"drupal 7.44\";s:7:\"version\";s:4:\"7.44\";s:3:\"tag\";s:4:\"7.44\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:2:\"44\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:51:\"https://www.drupal.org/project/drupal/releases/7.44\";s:13:\"download_link\";s:56:\"https://ftp.drupal.org/files/projects/drupal-7.44.tar.gz\";s:4:\"date\";s:10:\"1466021480\";s:6:\"mdhash\";s:32:\"965ab5fe5457625ec8c18e5c1c455008\";s:8:\"filesize\";s:7:\"3265819\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:15:\"Security update\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:4:\"7.43\";a:14:{s:4:\"name\";s:11:\"drupal 7.43\";s:7:\"version\";s:4:\"7.43\";s:3:\"tag\";s:4:\"7.43\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:2:\"43\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:51:\"https://www.drupal.org/project/drupal/releases/7.43\";s:13:\"download_link\";s:56:\"https://ftp.drupal.org/files/projects/drupal-7.43.tar.gz\";s:4:\"date\";s:10:\"1456341749\";s:6:\"mdhash\";s:32:\"c6fb49bc88a6408a985afddac76b9f8b\";s:8:\"filesize\";s:7:\"3265824\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:15:\"Security update\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:4:\"7.42\";a:14:{s:4:\"name\";s:11:\"drupal 7.42\";s:7:\"version\";s:4:\"7.42\";s:3:\"tag\";s:4:\"7.42\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:2:\"42\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:51:\"https://www.drupal.org/project/drupal/releases/7.42\";s:13:\"download_link\";s:56:\"https://ftp.drupal.org/files/projects/drupal-7.42.tar.gz\";s:4:\"date\";s:10:\"1454516939\";s:6:\"mdhash\";s:32:\"9a96f67474e209dd48750ba6fccc77db\";s:8:\"filesize\";s:7:\"3264065\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:4:\"7.41\";a:14:{s:4:\"name\";s:11:\"drupal 7.41\";s:7:\"version\";s:4:\"7.41\";s:3:\"tag\";s:4:\"7.41\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:2:\"41\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:51:\"https://www.drupal.org/project/drupal/releases/7.41\";s:13:\"download_link\";s:56:\"https://ftp.drupal.org/files/projects/drupal-7.41.tar.gz\";s:4:\"date\";s:10:\"1445457239\";s:6:\"mdhash\";s:32:\"7636e75e8be213455b4ac7911ce5801f\";s:8:\"filesize\";s:7:\"3257325\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:15:\"Security update\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:4:\"7.40\";a:14:{s:4:\"name\";s:11:\"drupal 7.40\";s:7:\"version\";s:4:\"7.40\";s:3:\"tag\";s:4:\"7.40\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:2:\"40\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:51:\"https://www.drupal.org/project/drupal/releases/7.40\";s:13:\"download_link\";s:56:\"https://ftp.drupal.org/files/projects/drupal-7.40.tar.gz\";s:4:\"date\";s:10:\"1444865639\";s:6:\"mdhash\";s:32:\"d4509f13c23999a76e61ec4d5ccfaf26\";s:8:\"filesize\";s:7:\"3257401\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:4:\"7.39\";a:14:{s:4:\"name\";s:11:\"drupal 7.39\";s:7:\"version\";s:4:\"7.39\";s:3:\"tag\";s:4:\"7.39\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:2:\"39\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:51:\"https://www.drupal.org/project/drupal/releases/7.39\";s:13:\"download_link\";s:56:\"https://ftp.drupal.org/files/projects/drupal-7.39.tar.gz\";s:4:\"date\";s:10:\"1440019139\";s:6:\"mdhash\";s:32:\"6f42a7e9c7a1c2c4c9c2f20c81b8e79a\";s:8:\"filesize\";s:7:\"3249343\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:15:\"Security update\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:4:\"7.38\";a:14:{s:4:\"name\";s:11:\"drupal 7.38\";s:7:\"version\";s:4:\"7.38\";s:3:\"tag\";s:4:\"7.38\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:2:\"38\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:51:\"https://www.drupal.org/project/drupal/releases/7.38\";s:13:\"download_link\";s:56:\"https://ftp.drupal.org/files/projects/drupal-7.38.tar.gz\";s:4:\"date\";s:10:\"1434566280\";s:6:\"mdhash\";s:32:\"c18298c1a5aed32ddbdac605fdef7fce\";s:8:\"filesize\";s:7:\"3247864\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:15:\"Security update\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:4:\"7.37\";a:14:{s:4:\"name\";s:11:\"drupal 7.37\";s:7:\"version\";s:4:\"7.37\";s:3:\"tag\";s:4:\"7.37\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:2:\"37\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:51:\"https://www.drupal.org/project/drupal/releases/7.37\";s:13:\"download_link\";s:56:\"https://ftp.drupal.org/files/projects/drupal-7.37.tar.gz\";s:4:\"date\";s:10:\"1430972281\";s:6:\"mdhash\";s:32:\"3a70696c87b786365f2c6c3aeb895d8a\";s:8:\"filesize\";s:7:\"3244291\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:4:\"7.36\";a:14:{s:4:\"name\";s:11:\"drupal 7.36\";s:7:\"version\";s:4:\"7.36\";s:3:\"tag\";s:4:\"7.36\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:2:\"36\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:51:\"https://www.drupal.org/project/drupal/releases/7.36\";s:13:\"download_link\";s:56:\"https://ftp.drupal.org/files/projects/drupal-7.36.tar.gz\";s:4:\"date\";s:10:\"1427943181\";s:6:\"mdhash\";s:32:\"98e1f62c11a5dc5f9481935eefc814c5\";s:8:\"filesize\";s:7:\"3244905\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:4:\"7.35\";a:14:{s:4:\"name\";s:11:\"drupal 7.35\";s:7:\"version\";s:4:\"7.35\";s:3:\"tag\";s:4:\"7.35\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:2:\"35\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:51:\"https://www.drupal.org/project/drupal/releases/7.35\";s:13:\"download_link\";s:56:\"https://ftp.drupal.org/files/projects/drupal-7.35.tar.gz\";s:4:\"date\";s:10:\"1426706281\";s:6:\"mdhash\";s:32:\"fecc55bd0bd476bc35d9ebf68452942d\";s:8:\"filesize\";s:7:\"3234349\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:15:\"Security update\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:4:\"7.34\";a:14:{s:4:\"name\";s:11:\"drupal 7.34\";s:7:\"version\";s:4:\"7.34\";s:3:\"tag\";s:4:\"7.34\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:2:\"34\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:51:\"https://www.drupal.org/project/drupal/releases/7.34\";s:13:\"download_link\";s:56:\"https://ftp.drupal.org/files/projects/drupal-7.34.tar.gz\";s:4:\"date\";s:10:\"1416429264\";s:6:\"mdhash\";s:32:\"bb4d212e1eb1d7375e41613fbefa04f2\";s:8:\"filesize\";s:7:\"3229858\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:15:\"Security update\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:4:\"7.33\";a:14:{s:4:\"name\";s:11:\"drupal 7.33\";s:7:\"version\";s:4:\"7.33\";s:3:\"tag\";s:4:\"7.33\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:2:\"33\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:51:\"https://www.drupal.org/project/drupal/releases/7.33\";s:13:\"download_link\";s:56:\"https://ftp.drupal.org/files/projects/drupal-7.33.tar.gz\";s:4:\"date\";s:10:\"1415374080\";s:6:\"mdhash\";s:32:\"187b076a5753960d5d5cb12d30d93e73\";s:8:\"filesize\";s:7:\"3229397\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:4:\"7.32\";a:14:{s:4:\"name\";s:11:\"drupal 7.32\";s:7:\"version\";s:4:\"7.32\";s:3:\"tag\";s:4:\"7.32\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:2:\"32\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:51:\"https://www.drupal.org/project/drupal/releases/7.32\";s:13:\"download_link\";s:56:\"https://ftp.drupal.org/files/projects/drupal-7.32.tar.gz\";s:4:\"date\";s:10:\"1413387329\";s:6:\"mdhash\";s:32:\"d5d121a6ce974f2d20604a7e10e1987a\";s:8:\"filesize\";s:7:\"3215563\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:15:\"Security update\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:4:\"7.31\";a:14:{s:4:\"name\";s:11:\"drupal 7.31\";s:7:\"version\";s:4:\"7.31\";s:3:\"tag\";s:4:\"7.31\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:2:\"31\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:51:\"https://www.drupal.org/project/drupal/releases/7.31\";s:13:\"download_link\";s:56:\"https://ftp.drupal.org/files/projects/drupal-7.31.tar.gz\";s:4:\"date\";s:10:\"1407346427\";s:6:\"mdhash\";s:32:\"de256f202930d3ef5ccc6aebc550adaf\";s:8:\"filesize\";s:7:\"3216766\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:15:\"Security update\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:4:\"7.30\";a:14:{s:4:\"name\";s:11:\"drupal 7.30\";s:7:\"version\";s:4:\"7.30\";s:3:\"tag\";s:4:\"7.30\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:2:\"30\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:51:\"https://www.drupal.org/project/drupal/releases/7.30\";s:13:\"download_link\";s:56:\"https://ftp.drupal.org/files/projects/drupal-7.30.tar.gz\";s:4:\"date\";s:10:\"1406239728\";s:6:\"mdhash\";s:32:\"ef7bce65ca6395f1e6bc44c15fdbc3cb\";s:8:\"filesize\";s:7:\"3215744\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:4:\"7.29\";a:14:{s:4:\"name\";s:11:\"drupal 7.29\";s:7:\"version\";s:4:\"7.29\";s:3:\"tag\";s:4:\"7.29\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:2:\"29\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:51:\"https://www.drupal.org/project/drupal/releases/7.29\";s:13:\"download_link\";s:56:\"https://ftp.drupal.org/files/projects/drupal-7.29.tar.gz\";s:4:\"date\";s:10:\"1405543128\";s:6:\"mdhash\";s:32:\"6ffdfb0ee08fadfb531c7fed1d2c5633\";s:8:\"filesize\";s:7:\"3213499\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:15:\"Security update\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:4:\"7.28\";a:14:{s:4:\"name\";s:11:\"drupal 7.28\";s:7:\"version\";s:4:\"7.28\";s:3:\"tag\";s:4:\"7.28\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:2:\"28\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:51:\"https://www.drupal.org/project/drupal/releases/7.28\";s:13:\"download_link\";s:56:\"https://ftp.drupal.org/files/projects/drupal-7.28.tar.gz\";s:4:\"date\";s:10:\"1399522729\";s:6:\"mdhash\";s:32:\"6255884d7e15c654fc8856805b271551\";s:8:\"filesize\";s:7:\"3212823\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:4:\"7.27\";a:14:{s:4:\"name\";s:11:\"drupal 7.27\";s:7:\"version\";s:4:\"7.27\";s:3:\"tag\";s:4:\"7.27\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:2:\"27\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:51:\"https://www.drupal.org/project/drupal/releases/7.27\";s:13:\"download_link\";s:56:\"https://ftp.drupal.org/files/projects/drupal-7.27.tar.gz\";s:4:\"date\";s:10:\"1397686464\";s:6:\"mdhash\";s:32:\"e9b05562f1a7f8bbcb5922cd3a0d55cb\";s:8:\"filesize\";s:7:\"3207398\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:15:\"Security update\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:4:\"7.26\";a:14:{s:4:\"name\";s:11:\"drupal 7.26\";s:7:\"version\";s:4:\"7.26\";s:3:\"tag\";s:4:\"7.26\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:2:\"26\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:51:\"https://www.drupal.org/project/drupal/releases/7.26\";s:13:\"download_link\";s:56:\"https://ftp.drupal.org/files/projects/drupal-7.26.tar.gz\";s:4:\"date\";s:10:\"1389815904\";s:6:\"mdhash\";s:32:\"740bd57f524b8ac18a203b663ca1329d\";s:8:\"filesize\";s:7:\"3204587\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:15:\"Security update\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:4:\"7.25\";a:14:{s:4:\"name\";s:11:\"drupal 7.25\";s:7:\"version\";s:4:\"7.25\";s:3:\"tag\";s:4:\"7.25\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:2:\"25\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:51:\"https://www.drupal.org/project/drupal/releases/7.25\";s:13:\"download_link\";s:56:\"https://ftp.drupal.org/files/projects/drupal-7.25.tar.gz\";s:4:\"date\";s:10:\"1388709505\";s:6:\"mdhash\";s:32:\"25906158083d89aa86534df1c683b4ea\";s:8:\"filesize\";s:7:\"3203256\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:4:\"7.24\";a:14:{s:4:\"name\";s:11:\"drupal 7.24\";s:7:\"version\";s:4:\"7.24\";s:3:\"tag\";s:4:\"7.24\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:2:\"24\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:51:\"https://www.drupal.org/project/drupal/releases/7.24\";s:13:\"download_link\";s:56:\"https://ftp.drupal.org/files/projects/drupal-7.24.tar.gz\";s:4:\"date\";s:10:\"1384982905\";s:6:\"mdhash\";s:32:\"c1ddb37155e4b6160f6508636c06f2a7\";s:8:\"filesize\";s:7:\"3195735\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:15:\"Security update\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:4:\"7.23\";a:14:{s:4:\"name\";s:11:\"drupal 7.23\";s:7:\"version\";s:4:\"7.23\";s:3:\"tag\";s:4:\"7.23\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:2:\"23\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:51:\"https://www.drupal.org/project/drupal/releases/7.23\";s:13:\"download_link\";s:56:\"https://ftp.drupal.org/files/projects/drupal-7.23.tar.gz\";s:4:\"date\";s:10:\"1375928239\";s:6:\"mdhash\";s:32:\"0beca6fec15b8cf8c35a6fdda6675342\";s:8:\"filesize\";s:7:\"3191695\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:4:\"7.22\";a:14:{s:4:\"name\";s:11:\"drupal 7.22\";s:7:\"version\";s:4:\"7.22\";s:3:\"tag\";s:4:\"7.22\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:2:\"22\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:51:\"https://www.drupal.org/project/drupal/releases/7.22\";s:13:\"download_link\";s:56:\"https://ftp.drupal.org/files/projects/drupal-7.22.tar.gz\";s:4:\"date\";s:10:\"1365027013\";s:6:\"mdhash\";s:32:\"068d7a77958fce6bb002659aa7ccaeb7\";s:8:\"filesize\";s:7:\"3183014\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:4:\"7.21\";a:14:{s:4:\"name\";s:11:\"drupal 7.21\";s:7:\"version\";s:4:\"7.21\";s:3:\"tag\";s:4:\"7.21\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:2:\"21\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:48:\"https://www.drupal.org/drupal-7.21-release-notes\";s:13:\"download_link\";s:56:\"https://ftp.drupal.org/files/projects/drupal-7.21.tar.gz\";s:4:\"date\";s:10:\"1362616997\";s:6:\"mdhash\";s:32:\"eff054cd53be39ff719f77c81dce1aac\";s:8:\"filesize\";s:7:\"3163798\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:4:\"7.20\";a:14:{s:4:\"name\";s:11:\"drupal 7.20\";s:7:\"version\";s:4:\"7.20\";s:3:\"tag\";s:4:\"7.20\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:2:\"20\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:48:\"https://www.drupal.org/drupal-7.20-release-notes\";s:13:\"download_link\";s:56:\"https://ftp.drupal.org/files/projects/drupal-7.20.tar.gz\";s:4:\"date\";s:10:\"1361393684\";s:6:\"mdhash\";s:32:\"ee576d63f1fd8a1f1c072a56978da0c5\";s:8:\"filesize\";s:7:\"3163257\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:15:\"Security update\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:4:\"7.19\";a:14:{s:4:\"name\";s:11:\"drupal 7.19\";s:7:\"version\";s:4:\"7.19\";s:3:\"tag\";s:4:\"7.19\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:2:\"19\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:48:\"https://www.drupal.org/drupal-7.19-release-notes\";s:13:\"download_link\";s:56:\"https://ftp.drupal.org/files/projects/drupal-7.19.tar.gz\";s:4:\"date\";s:10:\"1358374871\";s:6:\"mdhash\";s:32:\"c1dd3960f1555df208c80ef612e0c53a\";s:8:\"filesize\";s:7:\"3163130\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:15:\"Security update\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:4:\"7.18\";a:14:{s:4:\"name\";s:11:\"drupal 7.18\";s:7:\"version\";s:4:\"7.18\";s:3:\"tag\";s:4:\"7.18\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:2:\"18\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:48:\"https://www.drupal.org/drupal-7.18-release-notes\";s:13:\"download_link\";s:56:\"https://ftp.drupal.org/files/projects/drupal-7.18.tar.gz\";s:4:\"date\";s:10:\"1355944004\";s:6:\"mdhash\";s:32:\"5c048f60a53acd7cb3c2b6d5fe42f082\";s:8:\"filesize\";s:7:\"3162333\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:15:\"Security update\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:4:\"7.17\";a:14:{s:4:\"name\";s:11:\"drupal 7.17\";s:7:\"version\";s:4:\"7.17\";s:3:\"tag\";s:4:\"7.17\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:2:\"17\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:48:\"https://www.drupal.org/drupal-7.17-release-notes\";s:13:\"download_link\";s:56:\"https://ftp.drupal.org/files/projects/drupal-7.17.tar.gz\";s:4:\"date\";s:10:\"1352325358\";s:6:\"mdhash\";s:32:\"439e8ca7e6a33bb879a4624d8f01bed0\";s:8:\"filesize\";s:7:\"3162429\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:4:\"7.16\";a:14:{s:4:\"name\";s:11:\"drupal 7.16\";s:7:\"version\";s:4:\"7.16\";s:3:\"tag\";s:4:\"7.16\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:2:\"16\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:51:\"https://www.drupal.org/project/drupal/releases/7.16\";s:13:\"download_link\";s:56:\"https://ftp.drupal.org/files/projects/drupal-7.16.tar.gz\";s:4:\"date\";s:10:\"1350508568\";s:6:\"mdhash\";s:32:\"352497b2df94b5308e31cb8da020b631\";s:8:\"filesize\";s:7:\"3142889\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:15:\"Security update\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:4:\"7.15\";a:14:{s:4:\"name\";s:11:\"drupal 7.15\";s:7:\"version\";s:4:\"7.15\";s:3:\"tag\";s:4:\"7.15\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:2:\"15\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:51:\"https://www.drupal.org/project/drupal/releases/7.15\";s:13:\"download_link\";s:56:\"https://ftp.drupal.org/files/projects/drupal-7.15.tar.gz\";s:4:\"date\";s:10:\"1343839327\";s:6:\"mdhash\";s:32:\"f42c9baccd74e1d035d61ff537ae21b4\";s:8:\"filesize\";s:7:\"3142219\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:4:\"7.14\";a:14:{s:4:\"name\";s:11:\"drupal 7.14\";s:7:\"version\";s:4:\"7.14\";s:3:\"tag\";s:4:\"7.14\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:2:\"14\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:51:\"https://www.drupal.org/project/drupal/releases/7.14\";s:13:\"download_link\";s:56:\"https://ftp.drupal.org/files/projects/drupal-7.14.tar.gz\";s:4:\"date\";s:10:\"1335997556\";s:6:\"mdhash\";s:32:\"af7abd95c03ecad4e1567ed94a438334\";s:8:\"filesize\";s:7:\"3128473\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:4:\"7.13\";a:14:{s:4:\"name\";s:11:\"drupal 7.13\";s:7:\"version\";s:4:\"7.13\";s:3:\"tag\";s:4:\"7.13\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:2:\"13\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:51:\"https://www.drupal.org/project/drupal/releases/7.13\";s:13:\"download_link\";s:56:\"https://ftp.drupal.org/files/projects/drupal-7.13.tar.gz\";s:4:\"date\";s:10:\"1335997261\";s:6:\"mdhash\";s:32:\"80587b66375c7fc539414a20a2c6f2de\";s:8:\"filesize\";s:7:\"3088448\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:15:\"Security update\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:4:\"7.12\";a:14:{s:4:\"name\";s:11:\"drupal 7.12\";s:7:\"version\";s:4:\"7.12\";s:3:\"tag\";s:4:\"7.12\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:2:\"12\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:51:\"https://www.drupal.org/project/drupal/releases/7.12\";s:13:\"download_link\";s:56:\"https://ftp.drupal.org/files/projects/drupal-7.12.tar.gz\";s:4:\"date\";s:10:\"1328134561\";s:6:\"mdhash\";s:32:\"db2284beb97241c9bdca9c638cd8a4f1\";s:8:\"filesize\";s:7:\"3088472\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:4:\"7.11\";a:14:{s:4:\"name\";s:11:\"drupal 7.11\";s:7:\"version\";s:4:\"7.11\";s:3:\"tag\";s:4:\"7.11\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:2:\"11\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:51:\"https://www.drupal.org/project/drupal/releases/7.11\";s:13:\"download_link\";s:56:\"https://ftp.drupal.org/files/projects/drupal-7.11.tar.gz\";s:4:\"date\";s:10:\"1328134275\";s:6:\"mdhash\";s:32:\"e9857e1749762367d7631d74cc6564a7\";s:8:\"filesize\";s:7:\"2789336\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:15:\"Security update\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:4:\"7.10\";a:14:{s:4:\"name\";s:11:\"drupal 7.10\";s:7:\"version\";s:4:\"7.10\";s:3:\"tag\";s:4:\"7.10\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:2:\"10\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:51:\"https://www.drupal.org/project/drupal/releases/7.10\";s:13:\"download_link\";s:56:\"https://ftp.drupal.org/files/projects/drupal-7.10.tar.gz\";s:4:\"date\";s:10:\"1323125439\";s:6:\"mdhash\";s:32:\"1caafb849bc756e62dd874b90b95ab31\";s:8:\"filesize\";s:7:\"3067653\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:3:\"7.9\";a:14:{s:4:\"name\";s:10:\"drupal 7.9\";s:7:\"version\";s:3:\"7.9\";s:3:\"tag\";s:3:\"7.9\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:1:\"9\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:50:\"https://www.drupal.org/project/drupal/releases/7.9\";s:13:\"download_link\";s:55:\"https://ftp.drupal.org/files/projects/drupal-7.9.tar.gz\";s:4:\"date\";s:10:\"1319660731\";s:6:\"mdhash\";s:32:\"7f45f109c413ca69ebb6e3140ed47225\";s:8:\"filesize\";s:7:\"2788086\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:3:\"7.8\";a:14:{s:4:\"name\";s:10:\"drupal 7.8\";s:7:\"version\";s:3:\"7.8\";s:3:\"tag\";s:3:\"7.8\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:1:\"8\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:50:\"https://www.drupal.org/project/drupal/releases/7.8\";s:13:\"download_link\";s:55:\"https://ftp.drupal.org/files/projects/drupal-7.8.tar.gz\";s:4:\"date\";s:10:\"1314817617\";s:6:\"mdhash\";s:32:\"e0226b56e8d5c57c6b126e8ed5866b1f\";s:8:\"filesize\";s:7:\"2766967\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:3:\"7.7\";a:14:{s:4:\"name\";s:10:\"drupal 7.7\";s:7:\"version\";s:3:\"7.7\";s:3:\"tag\";s:3:\"7.7\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:1:\"7\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:50:\"https://www.drupal.org/project/drupal/releases/7.7\";s:13:\"download_link\";s:55:\"https://ftp.drupal.org/files/projects/drupal-7.7.tar.gz\";s:4:\"date\";s:10:\"1311813880\";s:6:\"mdhash\";s:32:\"2eeb63fd1ef6b23b0a9f5f6b8aef8850\";s:8:\"filesize\";s:7:\"2754113\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:3:\"7.6\";a:14:{s:4:\"name\";s:10:\"drupal 7.6\";s:7:\"version\";s:3:\"7.6\";s:3:\"tag\";s:3:\"7.6\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:1:\"6\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:50:\"https://www.drupal.org/project/drupal/releases/7.6\";s:13:\"download_link\";s:55:\"https://ftp.drupal.org/files/projects/drupal-7.6.tar.gz\";s:4:\"date\";s:10:\"1311798716\";s:6:\"mdhash\";s:32:\"e88e63c4da9e5e170f089d050c88c827\";s:8:\"filesize\";s:7:\"2753784\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:3:\"7.5\";a:14:{s:4:\"name\";s:10:\"drupal 7.5\";s:7:\"version\";s:3:\"7.5\";s:3:\"tag\";s:3:\"7.5\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:1:\"5\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:50:\"https://www.drupal.org/project/drupal/releases/7.5\";s:13:\"download_link\";s:55:\"https://ftp.drupal.org/files/projects/drupal-7.5.tar.gz\";s:4:\"date\";s:10:\"1311798416\";s:6:\"mdhash\";s:32:\"36d65b7a97c58226c64a6abdf481de45\";s:8:\"filesize\";s:7:\"2744690\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:15:\"Security update\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:3:\"7.4\";a:14:{s:4:\"name\";s:10:\"drupal 7.4\";s:7:\"version\";s:3:\"7.4\";s:3:\"tag\";s:3:\"7.4\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:1:\"4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:50:\"https://www.drupal.org/project/drupal/releases/7.4\";s:13:\"download_link\";s:55:\"https://ftp.drupal.org/files/projects/drupal-7.4.tar.gz\";s:4:\"date\";s:10:\"1309397516\";s:6:\"mdhash\";s:32:\"84704de078e9f5432c9bb5c6ecd841d4\";s:8:\"filesize\";s:7:\"2744808\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:3:\"7.3\";a:14:{s:4:\"name\";s:10:\"drupal 7.3\";s:7:\"version\";s:3:\"7.3\";s:3:\"tag\";s:3:\"7.3\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:1:\"3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:50:\"https://www.drupal.org/project/drupal/releases/7.3\";s:13:\"download_link\";s:55:\"https://ftp.drupal.org/files/projects/drupal-7.3.tar.gz\";s:4:\"date\";s:10:\"1309397216\";s:6:\"mdhash\";s:32:\"c290775724bc309647d84d03ddb88e2e\";s:8:\"filesize\";s:7:\"2735461\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:15:\"Security update\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:3:\"7.2\";a:14:{s:4:\"name\";s:10:\"drupal 7.2\";s:7:\"version\";s:3:\"7.2\";s:3:\"tag\";s:3:\"7.2\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:1:\"2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:50:\"https://www.drupal.org/project/drupal/releases/7.2\";s:13:\"download_link\";s:55:\"https://ftp.drupal.org/files/projects/drupal-7.2.tar.gz\";s:4:\"date\";s:10:\"1306357017\";s:6:\"mdhash\";s:32:\"cf88c87e3694ebd15b62ba6f6a69124f\";s:8:\"filesize\";s:7:\"2731345\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:3:\"7.1\";a:14:{s:4:\"name\";s:10:\"drupal 7.1\";s:7:\"version\";s:3:\"7.1\";s:3:\"tag\";s:3:\"7.1\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:1:\"1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:50:\"https://www.drupal.org/project/drupal/releases/7.1\";s:13:\"download_link\";s:55:\"https://ftp.drupal.org/files/projects/drupal-7.1.tar.gz\";s:4:\"date\";s:10:\"1306354916\";s:6:\"mdhash\";s:32:\"27eb45cb894a76f3a9ae6715584a10cc\";s:8:\"filesize\";s:7:\"2713977\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:15:\"Security update\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:3:\"7.0\";a:14:{s:4:\"name\";s:10:\"drupal 7.0\";s:7:\"version\";s:3:\"7.0\";s:3:\"tag\";s:3:\"7.0\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:50:\"https://www.drupal.org/project/drupal/releases/7.0\";s:13:\"download_link\";s:55:\"https://ftp.drupal.org/files/projects/drupal-7.0.tar.gz\";s:4:\"date\";s:10:\"1294208759\";s:6:\"mdhash\";s:32:\"e96c0a5e47c5d7706897384069dfb920\";s:8:\"filesize\";s:7:\"2728271\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.0-rc4\";a:15:{s:4:\"name\";s:14:\"drupal 7.0-rc4\";s:7:\"version\";s:7:\"7.0-rc4\";s:3:\"tag\";s:8:\"7.0-rc-4\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:54:\"https://www.drupal.org/project/drupal/releases/7.0-rc4\";s:13:\"download_link\";s:59:\"https://ftp.drupal.org/files/projects/drupal-7.0-rc4.tar.gz\";s:4:\"date\";s:10:\"1293684084\";s:6:\"mdhash\";s:32:\"104c08e609c64bb1e45b55a7ad1ad857\";s:8:\"filesize\";s:7:\"2717666\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:7:\"7.0-rc3\";a:15:{s:4:\"name\";s:14:\"drupal 7.0-rc3\";s:7:\"version\";s:7:\"7.0-rc3\";s:3:\"tag\";s:8:\"7.0-rc-3\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:54:\"https://www.drupal.org/project/drupal/releases/7.0-rc3\";s:13:\"download_link\";s:59:\"https://ftp.drupal.org/files/projects/drupal-7.0-rc3.tar.gz\";s:4:\"date\";s:10:\"1293099424\";s:6:\"mdhash\";s:32:\"be9a3f190e2648fa03dcb2bf3d8be199\";s:8:\"filesize\";s:7:\"2719115\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:15:\"Security update\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:7:\"7.0-rc2\";a:15:{s:4:\"name\";s:14:\"drupal 7.0-rc2\";s:7:\"version\";s:7:\"7.0-rc2\";s:3:\"tag\";s:8:\"7.0-rc-2\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:54:\"https://www.drupal.org/project/drupal/releases/7.0-rc2\";s:13:\"download_link\";s:59:\"https://ftp.drupal.org/files/projects/drupal-7.0-rc2.tar.gz\";s:4:\"date\";s:10:\"1292101847\";s:6:\"mdhash\";s:32:\"f31982c73f1707ddccb2927325bc9cb9\";s:8:\"filesize\";s:7:\"2705734\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:15:\"Security update\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:7:\"7.0-rc1\";a:15:{s:4:\"name\";s:14:\"drupal 7.0-rc1\";s:7:\"version\";s:7:\"7.0-rc1\";s:3:\"tag\";s:8:\"7.0-rc-1\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:54:\"https://www.drupal.org/project/drupal/releases/7.0-rc1\";s:13:\"download_link\";s:59:\"https://ftp.drupal.org/files/projects/drupal-7.0-rc1.tar.gz\";s:4:\"date\";s:10:\"1291190142\";s:6:\"mdhash\";s:32:\"b554e79cf60c02d4dec592151c4b58ee\";s:8:\"filesize\";s:7:\"2694689\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:3:{i:0;s:15:\"Security update\";i:1;s:12:\"New features\";i:2;s:9:\"Bug fixes\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:9:\"7.0-beta3\";a:15:{s:4:\"name\";s:16:\"drupal 7.0-beta3\";s:7:\"version\";s:9:\"7.0-beta3\";s:3:\"tag\";s:9:\"7.0-beta3\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/drupal/releases/7.0-beta3\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/drupal-7.0-beta3.tar.gz\";s:4:\"date\";s:10:\"1289694735\";s:6:\"mdhash\";s:32:\"c942f010a2535586c4578cd7b107c652\";s:8:\"filesize\";s:7:\"2660883\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:3:{i:0;s:15:\"Security update\";i:1;s:12:\"New features\";i:2;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:9:\"7.0-beta2\";a:15:{s:4:\"name\";s:16:\"drupal 7.0-beta2\";s:7:\"version\";s:9:\"7.0-beta2\";s:3:\"tag\";s:9:\"7.0-beta2\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/drupal/releases/7.0-beta2\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/drupal-7.0-beta2.tar.gz\";s:4:\"date\";s:10:\"1287812133\";s:6:\"mdhash\";s:32:\"c2de0bdb657b77af8c8369a355cab8ce\";s:8:\"filesize\";s:7:\"2638949\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:9:\"7.0-beta1\";a:15:{s:4:\"name\";s:16:\"drupal 7.0-beta1\";s:7:\"version\";s:9:\"7.0-beta1\";s:3:\"tag\";s:9:\"7.0-beta1\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/drupal/releases/7.0-beta1\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/drupal-7.0-beta1.tar.gz\";s:4:\"date\";s:10:\"1286422866\";s:6:\"mdhash\";s:32:\"490ce0d95eacc15f2918becd60f6821c\";s:8:\"filesize\";s:7:\"2622225\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:15:\"Security update\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:10:\"7.0-alpha7\";a:15:{s:4:\"name\";s:17:\"drupal 7.0-alpha7\";s:7:\"version\";s:10:\"7.0-alpha7\";s:3:\"tag\";s:10:\"7.0-alpha7\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha7\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:57:\"https://www.drupal.org/project/drupal/releases/7.0-alpha7\";s:13:\"download_link\";s:62:\"https://ftp.drupal.org/files/projects/drupal-7.0-alpha7.tar.gz\";s:4:\"date\";s:10:\"1284599764\";s:6:\"mdhash\";s:32:\"15183fcf862be97f7e96991e6e56fe2e\";s:8:\"filesize\";s:7:\"2586833\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:15:\"Security update\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:10:\"7.0-alpha6\";a:15:{s:4:\"name\";s:17:\"drupal 7.0-alpha6\";s:7:\"version\";s:10:\"7.0-alpha6\";s:3:\"tag\";s:10:\"7.0-alpha6\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha6\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:57:\"https://www.drupal.org/project/drupal/releases/7.0-alpha6\";s:13:\"download_link\";s:62:\"https://ftp.drupal.org/files/projects/drupal-7.0-alpha6.tar.gz\";s:4:\"date\";s:10:\"1278634809\";s:6:\"mdhash\";s:32:\"eb64647263affc36f76d1e7ffb751d32\";s:8:\"filesize\";s:7:\"2458211\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:3:{i:0;s:15:\"Security update\";i:1;s:12:\"New features\";i:2;s:9:\"Bug fixes\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:10:\"7.0-alpha5\";a:15:{s:4:\"name\";s:17:\"drupal 7.0-alpha5\";s:7:\"version\";s:10:\"7.0-alpha5\";s:3:\"tag\";s:10:\"7.0-alpha5\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha5\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:57:\"https://www.drupal.org/project/drupal/releases/7.0-alpha5\";s:13:\"download_link\";s:62:\"https://ftp.drupal.org/files/projects/drupal-7.0-alpha5.tar.gz\";s:4:\"date\";s:10:\"1274628613\";s:6:\"mdhash\";s:32:\"de9c1d51f0ce730f7356bd0a160e8ce1\";s:8:\"filesize\";s:7:\"2424226\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:15:\"Security update\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:10:\"7.0-alpha4\";a:15:{s:4:\"name\";s:17:\"drupal 7.0-alpha4\";s:7:\"version\";s:10:\"7.0-alpha4\";s:3:\"tag\";s:10:\"7.0-alpha4\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:57:\"https://www.drupal.org/project/drupal/releases/7.0-alpha4\";s:13:\"download_link\";s:62:\"https://ftp.drupal.org/files/projects/drupal-7.0-alpha4.tar.gz\";s:4:\"date\";s:10:\"1272318014\";s:6:\"mdhash\";s:32:\"c8f371a388bc65b2211d7d29856fb993\";s:8:\"filesize\";s:7:\"2403384\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:15:\"Security update\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:10:\"7.0-alpha3\";a:15:{s:4:\"name\";s:17:\"drupal 7.0-alpha3\";s:7:\"version\";s:10:\"7.0-alpha3\";s:3:\"tag\";s:10:\"7.0-alpha3\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:57:\"https://www.drupal.org/project/drupal/releases/7.0-alpha3\";s:13:\"download_link\";s:62:\"https://ftp.drupal.org/files/projects/drupal-7.0-alpha3.tar.gz\";s:4:\"date\";s:10:\"1269192317\";s:6:\"mdhash\";s:32:\"9efc083f09d6b523d655bc90a6869945\";s:8:\"filesize\";s:7:\"2357934\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:3:{i:0;s:15:\"Security update\";i:1;s:12:\"New features\";i:2;s:9:\"Bug fixes\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:10:\"7.0-alpha2\";a:15:{s:4:\"name\";s:17:\"drupal 7.0-alpha2\";s:7:\"version\";s:10:\"7.0-alpha2\";s:3:\"tag\";s:10:\"7.0-alpha2\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:57:\"https://www.drupal.org/project/drupal/releases/7.0-alpha2\";s:13:\"download_link\";s:62:\"https://ftp.drupal.org/files/projects/drupal-7.0-alpha2.tar.gz\";s:4:\"date\";s:10:\"1266777910\";s:6:\"mdhash\";s:32:\"cfbfdd2249638a266054f2532348065d\";s:8:\"filesize\";s:7:\"2314834\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:10:\"7.0-alpha1\";a:15:{s:4:\"name\";s:17:\"drupal 7.0-alpha1\";s:7:\"version\";s:10:\"7.0-alpha1\";s:3:\"tag\";s:10:\"7.0-alpha1\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:57:\"https://www.drupal.org/project/drupal/releases/7.0-alpha1\";s:13:\"download_link\";s:62:\"https://ftp.drupal.org/files/projects/drupal-7.0-alpha1.tar.gz\";s:4:\"date\";s:10:\"1263566711\";s:6:\"mdhash\";s:32:\"508109c6cf0ead868e02d8c3db2a4d1f\";s:8:\"filesize\";s:7:\"2283220\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:12:\"New features\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:7:\"7.x-dev\";a:14:{s:4:\"name\";s:14:\"drupal 7.x-dev\";s:7:\"version\";s:7:\"7.x-dev\";s:3:\"tag\";s:3:\"7.x\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:54:\"https://www.drupal.org/project/drupal/releases/7.x-dev\";s:13:\"download_link\";s:59:\"https://ftp.drupal.org/files/projects/drupal-7.x-dev.tar.gz\";s:4:\"date\";s:10:\"1512077285\";s:6:\"mdhash\";s:32:\"6334b3280cdf2585a7da88178b66521f\";s:8:\"filesize\";s:7:\"3279047\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";}}}',1512706736,1512620327,1),('available_releases::entity','a:11:{s:5:\"title\";s:10:\"Entity API\";s:10:\"short_name\";s:6:\"entity\";s:4:\"type\";s:14:\"project_module\";s:11:\"api_version\";s:3:\"7.x\";s:17:\"recommended_major\";s:1:\"1\";s:16:\"supported_majors\";s:1:\"1\";s:13:\"default_major\";s:1:\"1\";s:14:\"project_status\";s:9:\"published\";s:4:\"link\";s:37:\"https://www.drupal.org/project/entity\";s:5:\"terms\";s:0:\"\";s:8:\"releases\";a:30:{s:7:\"7.x-1.8\";a:14:{s:4:\"name\";s:14:\"entity 7.x-1.8\";s:7:\"version\";s:7:\"7.x-1.8\";s:3:\"tag\";s:7:\"7.x-1.8\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"8\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:54:\"https://www.drupal.org/project/entity/releases/7.x-1.8\";s:13:\"download_link\";s:59:\"https://ftp.drupal.org/files/projects/entity-7.x-1.8.tar.gz\";s:4:\"date\";s:10:\"1474545839\";s:6:\"mdhash\";s:32:\"3926d48c86387c3d1d5777538903a752\";s:8:\"filesize\";s:6:\"123957\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-1.7\";a:14:{s:4:\"name\";s:14:\"entity 7.x-1.7\";s:7:\"version\";s:7:\"7.x-1.7\";s:3:\"tag\";s:7:\"7.x-1.7\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"7\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:54:\"https://www.drupal.org/project/entity/releases/7.x-1.7\";s:13:\"download_link\";s:59:\"https://ftp.drupal.org/files/projects/entity-7.x-1.7.tar.gz\";s:4:\"date\";s:10:\"1458222242\";s:6:\"mdhash\";s:32:\"f4787da0230869cc7420b6cea78212e5\";s:8:\"filesize\";s:6:\"121426\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-1.6\";a:14:{s:4:\"name\";s:14:\"entity 7.x-1.6\";s:7:\"version\";s:7:\"7.x-1.6\";s:3:\"tag\";s:7:\"7.x-1.6\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"6\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:54:\"https://www.drupal.org/project/entity/releases/7.x-1.6\";s:13:\"download_link\";s:59:\"https://ftp.drupal.org/files/projects/entity-7.x-1.6.tar.gz\";s:4:\"date\";s:10:\"1424876581\";s:6:\"mdhash\";s:32:\"a778a5c82eaddac50e40a3dd0a3ebac6\";s:8:\"filesize\";s:6:\"120850\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:15:\"Security update\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-1.5\";a:14:{s:4:\"name\";s:14:\"entity 7.x-1.5\";s:7:\"version\";s:7:\"7.x-1.5\";s:3:\"tag\";s:7:\"7.x-1.5\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"5\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:54:\"https://www.drupal.org/project/entity/releases/7.x-1.5\";s:13:\"download_link\";s:59:\"https://ftp.drupal.org/files/projects/entity-7.x-1.5.tar.gz\";s:4:\"date\";s:10:\"1396975451\";s:6:\"mdhash\";s:32:\"04b90c27b2f1627d0a218006291afa9f\";s:8:\"filesize\";s:6:\"121011\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-1.4\";a:14:{s:4:\"name\";s:14:\"entity 7.x-1.4\";s:7:\"version\";s:7:\"7.x-1.4\";s:3:\"tag\";s:7:\"7.x-1.4\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:54:\"https://www.drupal.org/project/entity/releases/7.x-1.4\";s:13:\"download_link\";s:59:\"https://ftp.drupal.org/files/projects/entity-7.x-1.4.tar.gz\";s:4:\"date\";s:10:\"1395335056\";s:6:\"mdhash\";s:32:\"d026208f7b433b9b2dd5fdc705396d0e\";s:8:\"filesize\";s:6:\"120371\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-1.3\";a:14:{s:4:\"name\";s:14:\"entity 7.x-1.3\";s:7:\"version\";s:7:\"7.x-1.3\";s:3:\"tag\";s:7:\"7.x-1.3\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:54:\"https://www.drupal.org/project/entity/releases/7.x-1.3\";s:13:\"download_link\";s:59:\"https://ftp.drupal.org/files/projects/entity-7.x-1.3.tar.gz\";s:4:\"date\";s:10:\"1389210804\";s:6:\"mdhash\";s:32:\"92bb78da6928049c0d9bdea76629416b\";s:8:\"filesize\";s:6:\"119279\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:15:\"Security update\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-1.2\";a:14:{s:4:\"name\";s:14:\"entity 7.x-1.2\";s:7:\"version\";s:7:\"7.x-1.2\";s:3:\"tag\";s:7:\"7.x-1.2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:54:\"https://www.drupal.org/project/entity/releases/7.x-1.2\";s:13:\"download_link\";s:59:\"https://ftp.drupal.org/files/projects/entity-7.x-1.2.tar.gz\";s:4:\"date\";s:10:\"1376493705\";s:6:\"mdhash\";s:32:\"c87e0ce3708a26a3045c36b8ad15f61c\";s:8:\"filesize\";s:6:\"115225\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:15:\"Security update\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-1.1\";a:14:{s:4:\"name\";s:14:\"entity 7.x-1.1\";s:7:\"version\";s:7:\"7.x-1.1\";s:3:\"tag\";s:7:\"7.x-1.1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:54:\"https://www.drupal.org/project/entity/releases/7.x-1.1\";s:13:\"download_link\";s:59:\"https://ftp.drupal.org/files/projects/entity-7.x-1.1.tar.gz\";s:4:\"date\";s:10:\"1367338217\";s:6:\"mdhash\";s:32:\"1f23d1bee48287f1c53f8d3f1391187a\";s:8:\"filesize\";s:6:\"110514\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-1.0\";a:14:{s:4:\"name\";s:14:\"entity 7.x-1.0\";s:7:\"version\";s:7:\"7.x-1.0\";s:3:\"tag\";s:7:\"7.x-1.0\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:54:\"https://www.drupal.org/project/entity/releases/7.x-1.0\";s:13:\"download_link\";s:59:\"https://ftp.drupal.org/files/projects/entity-7.x-1.0.tar.gz\";s:4:\"date\";s:10:\"1356471145\";s:6:\"mdhash\";s:32:\"f072eda34e284561bb55cfae0dbe30db\";s:8:\"filesize\";s:6:\"110082\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:11:\"7.x-1.0-rc3\";a:15:{s:4:\"name\";s:18:\"entity 7.x-1.0-rc3\";s:7:\"version\";s:11:\"7.x-1.0-rc3\";s:3:\"tag\";s:11:\"7.x-1.0-rc3\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:58:\"https://www.drupal.org/project/entity/releases/7.x-1.0-rc3\";s:13:\"download_link\";s:63:\"https://ftp.drupal.org/files/projects/entity-7.x-1.0-rc3.tar.gz\";s:4:\"date\";s:10:\"1337981155\";s:6:\"mdhash\";s:32:\"267c552757d1fa8bbe17c624a7ec4c3f\";s:8:\"filesize\";s:6:\"106628\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:11:\"7.x-1.0-rc2\";a:15:{s:4:\"name\";s:18:\"entity 7.x-1.0-rc2\";s:7:\"version\";s:11:\"7.x-1.0-rc2\";s:3:\"tag\";s:11:\"7.x-1.0-rc2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:58:\"https://www.drupal.org/project/entity/releases/7.x-1.0-rc2\";s:13:\"download_link\";s:63:\"https://ftp.drupal.org/files/projects/entity-7.x-1.0-rc2.tar.gz\";s:4:\"date\";s:10:\"1335099086\";s:6:\"mdhash\";s:32:\"587d7b6a088a195722fe7d11b1c9c8fa\";s:8:\"filesize\";s:6:\"105993\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:11:\"7.x-1.0-rc1\";a:15:{s:4:\"name\";s:18:\"entity 7.x-1.0-rc1\";s:7:\"version\";s:11:\"7.x-1.0-rc1\";s:3:\"tag\";s:11:\"7.x-1.0-rc1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:58:\"https://www.drupal.org/project/entity/releases/7.x-1.0-rc1\";s:13:\"download_link\";s:63:\"https://ftp.drupal.org/files/projects/entity-7.x-1.0-rc1.tar.gz\";s:4:\"date\";s:10:\"1320914735\";s:6:\"mdhash\";s:32:\"daa6dff009d00756f86b80b31af32c77\";s:8:\"filesize\";s:5:\"95227\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:14:\"7.x-1.0-beta11\";a:15:{s:4:\"name\";s:21:\"entity 7.x-1.0-beta11\";s:7:\"version\";s:14:\"7.x-1.0-beta11\";s:3:\"tag\";s:14:\"7.x-1.0-beta11\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"beta11\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/entity/releases/7.x-1.0-beta11\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/entity-7.x-1.0-beta11.tar.gz\";s:4:\"date\";s:10:\"1319558131\";s:6:\"mdhash\";s:32:\"0d98c2c361e5936593b8365614fa04e3\";s:8:\"filesize\";s:5:\"83206\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:14:\"7.x-1.0-beta10\";a:15:{s:4:\"name\";s:21:\"entity 7.x-1.0-beta10\";s:7:\"version\";s:14:\"7.x-1.0-beta10\";s:3:\"tag\";s:14:\"7.x-1.0-beta10\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"beta10\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/entity/releases/7.x-1.0-beta10\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/entity-7.x-1.0-beta10.tar.gz\";s:4:\"date\";s:10:\"1310486817\";s:6:\"mdhash\";s:32:\"016f48d7ecee0da62ae1a8f6cf26a656\";s:8:\"filesize\";s:5:\"77197\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"7.x-1.0-beta9\";a:15:{s:4:\"name\";s:20:\"entity 7.x-1.0-beta9\";s:7:\"version\";s:13:\"7.x-1.0-beta9\";s:3:\"tag\";s:13:\"7.x-1.0-beta9\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta9\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:60:\"https://www.drupal.org/project/entity/releases/7.x-1.0-beta9\";s:13:\"download_link\";s:65:\"https://ftp.drupal.org/files/projects/entity-7.x-1.0-beta9.tar.gz\";s:4:\"date\";s:10:\"1308239815\";s:6:\"mdhash\";s:32:\"a965dc47b0b8afc2f75b69be31e767d0\";s:8:\"filesize\";s:5:\"75840\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"7.x-1.0-beta8\";a:15:{s:4:\"name\";s:20:\"entity 7.x-1.0-beta8\";s:7:\"version\";s:13:\"7.x-1.0-beta8\";s:3:\"tag\";s:13:\"7.x-1.0-beta8\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta8\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:60:\"https://www.drupal.org/project/entity/releases/7.x-1.0-beta8\";s:13:\"download_link\";s:65:\"https://ftp.drupal.org/files/projects/entity-7.x-1.0-beta8.tar.gz\";s:4:\"date\";s:10:\"1300731067\";s:6:\"mdhash\";s:32:\"317ec15a5f9d90e7613b52f20a7e9a82\";s:8:\"filesize\";s:5:\"71258\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"7.x-1.0-beta7\";a:15:{s:4:\"name\";s:20:\"entity 7.x-1.0-beta7\";s:7:\"version\";s:13:\"7.x-1.0-beta7\";s:3:\"tag\";s:13:\"7.x-1.0-beta7\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta7\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:60:\"https://www.drupal.org/project/entity/releases/7.x-1.0-beta7\";s:13:\"download_link\";s:65:\"https://ftp.drupal.org/files/projects/entity-7.x-1.0-beta7.tar.gz\";s:4:\"date\";s:10:\"1298285230\";s:6:\"mdhash\";s:32:\"9598452892a90a3b098d3152334aeb85\";s:8:\"filesize\";s:5:\"72722\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"7.x-1.0-beta6\";a:15:{s:4:\"name\";s:20:\"entity 7.x-1.0-beta6\";s:7:\"version\";s:13:\"7.x-1.0-beta6\";s:3:\"tag\";s:13:\"7.x-1.0-beta6\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta6\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:60:\"https://www.drupal.org/project/entity/releases/7.x-1.0-beta6\";s:13:\"download_link\";s:65:\"https://ftp.drupal.org/files/projects/entity-7.x-1.0-beta6.tar.gz\";s:4:\"date\";s:10:\"1294170388\";s:6:\"mdhash\";s:32:\"64588b70e6773d146e0bf4267a90a270\";s:8:\"filesize\";s:5:\"68465\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}s:13:\"7.x-1.0-beta5\";a:15:{s:4:\"name\";s:20:\"entity 7.x-1.0-beta5\";s:7:\"version\";s:13:\"7.x-1.0-beta5\";s:3:\"tag\";s:13:\"7.x-1.0-beta5\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta5\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:60:\"https://www.drupal.org/project/entity/releases/7.x-1.0-beta5\";s:13:\"download_link\";s:65:\"https://ftp.drupal.org/files/projects/entity-7.x-1.0-beta5.tar.gz\";s:4:\"date\";s:10:\"1293135097\";s:6:\"mdhash\";s:32:\"53325d82ab40c0dc325ccb59d0bca3e6\";s:8:\"filesize\";s:5:\"65300\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"7.x-1.0-beta4\";a:15:{s:4:\"name\";s:20:\"entity 7.x-1.0-beta4\";s:7:\"version\";s:13:\"7.x-1.0-beta4\";s:3:\"tag\";s:13:\"7.x-1.0-beta4\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:60:\"https://www.drupal.org/project/entity/releases/7.x-1.0-beta4\";s:13:\"download_link\";s:65:\"https://ftp.drupal.org/files/projects/entity-7.x-1.0-beta4.tar.gz\";s:4:\"date\";s:10:\"1292941950\";s:6:\"mdhash\";s:32:\"93210f6c3b3b19258f217a64e6bd56a8\";s:8:\"filesize\";s:5:\"65305\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"7.x-1.0-beta3\";a:15:{s:4:\"name\";s:20:\"entity 7.x-1.0-beta3\";s:7:\"version\";s:13:\"7.x-1.0-beta3\";s:3:\"tag\";s:13:\"7.x-1.0-beta3\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:60:\"https://www.drupal.org/project/entity/releases/7.x-1.0-beta3\";s:13:\"download_link\";s:65:\"https://ftp.drupal.org/files/projects/entity-7.x-1.0-beta3.tar.gz\";s:4:\"date\";s:10:\"1291297866\";s:6:\"mdhash\";s:32:\"cb05413449da98da415d40e3520f0f6d\";s:8:\"filesize\";s:5:\"61957\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"7.x-1.0-beta2\";a:15:{s:4:\"name\";s:20:\"entity 7.x-1.0-beta2\";s:7:\"version\";s:13:\"7.x-1.0-beta2\";s:3:\"tag\";s:13:\"7.x-1.0-beta2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:60:\"https://www.drupal.org/project/entity/releases/7.x-1.0-beta2\";s:13:\"download_link\";s:65:\"https://ftp.drupal.org/files/projects/entity-7.x-1.0-beta2.tar.gz\";s:4:\"date\";s:10:\"1290197444\";s:6:\"mdhash\";s:32:\"a1646f5c1933772feb76e2dd31d6324b\";s:8:\"filesize\";s:5:\"60670\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"7.x-1.0-beta1\";a:15:{s:4:\"name\";s:20:\"entity 7.x-1.0-beta1\";s:7:\"version\";s:13:\"7.x-1.0-beta1\";s:3:\"tag\";s:13:\"7.x-1.0-beta1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:60:\"https://www.drupal.org/project/entity/releases/7.x-1.0-beta1\";s:13:\"download_link\";s:65:\"https://ftp.drupal.org/files/projects/entity-7.x-1.0-beta1.tar.gz\";s:4:\"date\";s:10:\"1286786762\";s:6:\"mdhash\";s:32:\"2e53243fdf0fae60217dd7916d982e47\";s:8:\"filesize\";s:5:\"54660\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:14:\"7.x-1.0-alpha6\";a:15:{s:4:\"name\";s:21:\"entity 7.x-1.0-alpha6\";s:7:\"version\";s:14:\"7.x-1.0-alpha6\";s:3:\"tag\";s:14:\"7.x-1.0-alpha6\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha6\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/entity/releases/7.x-1.0-alpha6\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/entity-7.x-1.0-alpha6.tar.gz\";s:4:\"date\";s:10:\"1280228111\";s:6:\"mdhash\";s:32:\"5d88abea4508ea3561332f466746ab3d\";s:8:\"filesize\";s:5:\"47315\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:14:\"7.x-1.0-alpha5\";a:15:{s:4:\"name\";s:21:\"entity 7.x-1.0-alpha5\";s:7:\"version\";s:14:\"7.x-1.0-alpha5\";s:3:\"tag\";s:14:\"7.x-1.0-alpha5\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha5\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/entity/releases/7.x-1.0-alpha5\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/entity-7.x-1.0-alpha5.tar.gz\";s:4:\"date\";s:10:\"1273607706\";s:6:\"mdhash\";s:32:\"13348a08070605b3742d4fad7856d76a\";s:8:\"filesize\";s:5:\"45331\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}s:14:\"7.x-1.0-alpha4\";a:15:{s:4:\"name\";s:21:\"entity 7.x-1.0-alpha4\";s:7:\"version\";s:14:\"7.x-1.0-alpha4\";s:3:\"tag\";s:14:\"7.x-1.0-alpha4\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/entity/releases/7.x-1.0-alpha4\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/entity-7.x-1.0-alpha4.tar.gz\";s:4:\"date\";s:10:\"1268336409\";s:6:\"mdhash\";s:32:\"0e093c0ded92b23a4e628a7953a198dc\";s:8:\"filesize\";s:5:\"41614\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}s:14:\"7.x-1.0-alpha3\";a:15:{s:4:\"name\";s:21:\"entity 7.x-1.0-alpha3\";s:7:\"version\";s:14:\"7.x-1.0-alpha3\";s:3:\"tag\";s:14:\"7.x-1.0-alpha3\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/entity/releases/7.x-1.0-alpha3\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/entity-7.x-1.0-alpha3.tar.gz\";s:4:\"date\";s:10:\"1266851413\";s:6:\"mdhash\";s:32:\"d347ca5528b9ed9d132b492cb4b7b2af\";s:8:\"filesize\";s:5:\"40746\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:14:\"7.x-1.0-alpha2\";a:15:{s:4:\"name\";s:21:\"entity 7.x-1.0-alpha2\";s:7:\"version\";s:14:\"7.x-1.0-alpha2\";s:3:\"tag\";s:14:\"7.x-1.0-alpha2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/entity/releases/7.x-1.0-alpha2\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/entity-7.x-1.0-alpha2.tar.gz\";s:4:\"date\";s:10:\"1263231309\";s:6:\"mdhash\";s:32:\"be9a91bd68b59480bdca9e8a6d6ad932\";s:8:\"filesize\";s:5:\"31954\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:14:\"7.x-1.0-alpha1\";a:15:{s:4:\"name\";s:21:\"entity 7.x-1.0-alpha1\";s:7:\"version\";s:14:\"7.x-1.0-alpha1\";s:3:\"tag\";s:14:\"7.x-1.0-alpha1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/entity/releases/7.x-1.0-alpha1\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/entity-7.x-1.0-alpha1.tar.gz\";s:4:\"date\";s:10:\"1260807922\";s:6:\"mdhash\";s:32:\"858c5a1b255f5316737dbbd3b562d825\";s:8:\"filesize\";s:5:\"29154\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}s:11:\"7.x-1.x-dev\";a:14:{s:4:\"name\";s:18:\"entity 7.x-1.x-dev\";s:7:\"version\";s:11:\"7.x-1.x-dev\";s:3:\"tag\";s:7:\"7.x-1.x\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:58:\"https://www.drupal.org/project/entity/releases/7.x-1.x-dev\";s:13:\"download_link\";s:63:\"https://ftp.drupal.org/files/projects/entity-7.x-1.x-dev.tar.gz\";s:4:\"date\";s:10:\"1489006983\";s:6:\"mdhash\";s:32:\"896905b4ea1cfc180d6f03bc5ab44378\";s:8:\"filesize\";s:6:\"124235\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}}}',1512706738,1512620327,1),('available_releases::entityreference','a:11:{s:5:\"title\";s:16:\"Entity reference\";s:10:\"short_name\";s:15:\"entityreference\";s:4:\"type\";s:14:\"project_module\";s:11:\"api_version\";s:3:\"7.x\";s:17:\"recommended_major\";s:1:\"1\";s:16:\"supported_majors\";s:1:\"1\";s:13:\"default_major\";s:1:\"1\";s:14:\"project_status\";s:9:\"published\";s:4:\"link\";s:46:\"https://www.drupal.org/project/entityreference\";s:5:\"terms\";s:0:\"\";s:8:\"releases\";a:19:{s:7:\"7.x-1.5\";a:14:{s:4:\"name\";s:23:\"entityreference 7.x-1.5\";s:7:\"version\";s:7:\"7.x-1.5\";s:3:\"tag\";s:7:\"7.x-1.5\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"5\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:63:\"https://www.drupal.org/project/entityreference/releases/7.x-1.5\";s:13:\"download_link\";s:68:\"https://ftp.drupal.org/files/projects/entityreference-7.x-1.5.tar.gz\";s:4:\"date\";s:10:\"1502895843\";s:6:\"mdhash\";s:32:\"56f6198ead378b93eb978444c3cdd948\";s:8:\"filesize\";s:5:\"43330\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:15:\"Security update\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-1.4\";a:14:{s:4:\"name\";s:23:\"entityreference 7.x-1.4\";s:7:\"version\";s:7:\"7.x-1.4\";s:3:\"tag\";s:7:\"7.x-1.4\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:63:\"https://www.drupal.org/project/entityreference/releases/7.x-1.4\";s:13:\"download_link\";s:68:\"https://ftp.drupal.org/files/projects/entityreference-7.x-1.4.tar.gz\";s:4:\"date\";s:10:\"1495557183\";s:6:\"mdhash\";s:32:\"ce8bde18b2b0269f218a1e2dc17579ee\";s:8:\"filesize\";s:5:\"43230\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-1.3\";a:14:{s:4:\"name\";s:23:\"entityreference 7.x-1.3\";s:7:\"version\";s:7:\"7.x-1.3\";s:3:\"tag\";s:7:\"7.x-1.3\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:63:\"https://www.drupal.org/project/entityreference/releases/7.x-1.3\";s:13:\"download_link\";s:68:\"https://ftp.drupal.org/files/projects/entityreference-7.x-1.3.tar.gz\";s:4:\"date\";s:10:\"1494450485\";s:6:\"mdhash\";s:32:\"e800309d10d254bd8e80770beb17f4f3\";s:8:\"filesize\";s:5:\"43171\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-1.2\";a:14:{s:4:\"name\";s:23:\"entityreference 7.x-1.2\";s:7:\"version\";s:7:\"7.x-1.2\";s:3:\"tag\";s:7:\"7.x-1.2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:63:\"https://www.drupal.org/project/entityreference/releases/7.x-1.2\";s:13:\"download_link\";s:68:\"https://ftp.drupal.org/files/projects/entityreference-7.x-1.2.tar.gz\";s:4:\"date\";s:10:\"1474306739\";s:6:\"mdhash\";s:32:\"ef8f161721709dedcd1babc18b033006\";s:8:\"filesize\";s:5:\"40840\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-1.1\";a:14:{s:4:\"name\";s:23:\"entityreference 7.x-1.1\";s:7:\"version\";s:7:\"7.x-1.1\";s:3:\"tag\";s:7:\"7.x-1.1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:63:\"https://www.drupal.org/project/entityreference/releases/7.x-1.1\";s:13:\"download_link\";s:68:\"https://ftp.drupal.org/files/projects/entityreference-7.x-1.1.tar.gz\";s:4:\"date\";s:10:\"1384973004\";s:6:\"mdhash\";s:32:\"604843bda17acbd927f71f8cf8a74a48\";s:8:\"filesize\";s:5:\"40371\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:15:\"Security update\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-1.0\";a:14:{s:4:\"name\";s:23:\"entityreference 7.x-1.0\";s:7:\"version\";s:7:\"7.x-1.0\";s:3:\"tag\";s:7:\"7.x-1.0\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:63:\"https://www.drupal.org/project/entityreference/releases/7.x-1.0\";s:13:\"download_link\";s:68:\"https://ftp.drupal.org/files/projects/entityreference-7.x-1.0.tar.gz\";s:4:\"date\";s:10:\"1353230808\";s:6:\"mdhash\";s:32:\"81f458c4b41b61f405af905d2fd8a5ec\";s:8:\"filesize\";s:5:\"36787\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:11:\"7.x-1.0-rc5\";a:15:{s:4:\"name\";s:27:\"entityreference 7.x-1.0-rc5\";s:7:\"version\";s:11:\"7.x-1.0-rc5\";s:3:\"tag\";s:11:\"7.x-1.0-rc5\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc5\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:67:\"https://www.drupal.org/project/entityreference/releases/7.x-1.0-rc5\";s:13:\"download_link\";s:72:\"https://ftp.drupal.org/files/projects/entityreference-7.x-1.0-rc5.tar.gz\";s:4:\"date\";s:10:\"1348565045\";s:6:\"mdhash\";s:32:\"648a462e0bc442533debbd0b1b98e665\";s:8:\"filesize\";s:5:\"32328\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}s:11:\"7.x-1.0-rc4\";a:15:{s:4:\"name\";s:27:\"entityreference 7.x-1.0-rc4\";s:7:\"version\";s:11:\"7.x-1.0-rc4\";s:3:\"tag\";s:11:\"7.x-1.0-rc4\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:67:\"https://www.drupal.org/project/entityreference/releases/7.x-1.0-rc4\";s:13:\"download_link\";s:72:\"https://ftp.drupal.org/files/projects/entityreference-7.x-1.0-rc4.tar.gz\";s:4:\"date\";s:10:\"1348486666\";s:6:\"mdhash\";s:32:\"b1bdad67159df7cfa1edbc71ca1f15be\";s:8:\"filesize\";s:5:\"31223\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}s:11:\"7.x-1.0-rc3\";a:15:{s:4:\"name\";s:27:\"entityreference 7.x-1.0-rc3\";s:7:\"version\";s:11:\"7.x-1.0-rc3\";s:3:\"tag\";s:11:\"7.x-1.0-rc3\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:67:\"https://www.drupal.org/project/entityreference/releases/7.x-1.0-rc3\";s:13:\"download_link\";s:72:\"https://ftp.drupal.org/files/projects/entityreference-7.x-1.0-rc3.tar.gz\";s:4:\"date\";s:10:\"1338411956\";s:6:\"mdhash\";s:32:\"6f07ffafd42ec5fa9b76d398831c9956\";s:8:\"filesize\";s:5:\"30501\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}s:11:\"7.x-1.0-rc2\";a:15:{s:4:\"name\";s:27:\"entityreference 7.x-1.0-rc2\";s:7:\"version\";s:11:\"7.x-1.0-rc2\";s:3:\"tag\";s:11:\"7.x-1.0-rc2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:67:\"https://www.drupal.org/project/entityreference/releases/7.x-1.0-rc2\";s:13:\"download_link\";s:72:\"https://ftp.drupal.org/files/projects/entityreference-7.x-1.0-rc2.tar.gz\";s:4:\"date\";s:10:\"1338371757\";s:6:\"mdhash\";s:32:\"35336e7b27b1755db8464d786167081b\";s:8:\"filesize\";s:5:\"30494\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}s:11:\"7.x-1.0-rc1\";a:15:{s:4:\"name\";s:27:\"entityreference 7.x-1.0-rc1\";s:7:\"version\";s:11:\"7.x-1.0-rc1\";s:3:\"tag\";s:11:\"7.x-1.0-rc1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:67:\"https://www.drupal.org/project/entityreference/releases/7.x-1.0-rc1\";s:13:\"download_link\";s:72:\"https://ftp.drupal.org/files/projects/entityreference-7.x-1.0-rc1.tar.gz\";s:4:\"date\";s:10:\"1332279946\";s:6:\"mdhash\";s:32:\"83f006ab5235890efc2b3986f8dcdfe3\";s:8:\"filesize\";s:5:\"24495\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}s:13:\"7.x-1.0-beta5\";a:15:{s:4:\"name\";s:29:\"entityreference 7.x-1.0-beta5\";s:7:\"version\";s:13:\"7.x-1.0-beta5\";s:3:\"tag\";s:13:\"7.x-1.0-beta5\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta5\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:69:\"https://www.drupal.org/project/entityreference/releases/7.x-1.0-beta5\";s:13:\"download_link\";s:74:\"https://ftp.drupal.org/files/projects/entityreference-7.x-1.0-beta5.tar.gz\";s:4:\"date\";s:10:\"1330297849\";s:6:\"mdhash\";s:32:\"1508867497f54a68acb9f92ca4cddcfe\";s:8:\"filesize\";s:5:\"24228\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}s:13:\"7.x-1.0-beta4\";a:15:{s:4:\"name\";s:29:\"entityreference 7.x-1.0-beta4\";s:7:\"version\";s:13:\"7.x-1.0-beta4\";s:3:\"tag\";s:13:\"7.x-1.0-beta4\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:69:\"https://www.drupal.org/project/entityreference/releases/7.x-1.0-beta4\";s:13:\"download_link\";s:74:\"https://ftp.drupal.org/files/projects/entityreference-7.x-1.0-beta4.tar.gz\";s:4:\"date\";s:10:\"1329149138\";s:6:\"mdhash\";s:32:\"7d5566cd6425d2dca4d0597984726eb8\";s:8:\"filesize\";s:5:\"24005\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}s:13:\"7.x-1.0-beta3\";a:15:{s:4:\"name\";s:29:\"entityreference 7.x-1.0-beta3\";s:7:\"version\";s:13:\"7.x-1.0-beta3\";s:3:\"tag\";s:13:\"7.x-1.0-beta3\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:69:\"https://www.drupal.org/project/entityreference/releases/7.x-1.0-beta3\";s:13:\"download_link\";s:74:\"https://ftp.drupal.org/files/projects/entityreference-7.x-1.0-beta3.tar.gz\";s:4:\"date\";s:10:\"1324748139\";s:6:\"mdhash\";s:32:\"397fa7a810501fbb22390c8fb8ac10ef\";s:8:\"filesize\";s:5:\"19799\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:15:\"Security update\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"7.x-1.0-beta2\";a:15:{s:4:\"name\";s:29:\"entityreference 7.x-1.0-beta2\";s:7:\"version\";s:13:\"7.x-1.0-beta2\";s:3:\"tag\";s:13:\"7.x-1.0-beta2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:69:\"https://www.drupal.org/project/entityreference/releases/7.x-1.0-beta2\";s:13:\"download_link\";s:74:\"https://ftp.drupal.org/files/projects/entityreference-7.x-1.0-beta2.tar.gz\";s:4:\"date\";s:10:\"1322214940\";s:6:\"mdhash\";s:32:\"41b5dd4ed7115763e5b30c41a9a07c3d\";s:8:\"filesize\";s:5:\"19792\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}s:13:\"7.x-1.0-beta1\";a:15:{s:4:\"name\";s:29:\"entityreference 7.x-1.0-beta1\";s:7:\"version\";s:13:\"7.x-1.0-beta1\";s:3:\"tag\";s:13:\"7.x-1.0-beta1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:69:\"https://www.drupal.org/project/entityreference/releases/7.x-1.0-beta1\";s:13:\"download_link\";s:74:\"https://ftp.drupal.org/files/projects/entityreference-7.x-1.0-beta1.tar.gz\";s:4:\"date\";s:10:\"1316702804\";s:6:\"mdhash\";s:32:\"a056dc3e075e9b0783cb1addaad5086e\";s:8:\"filesize\";s:5:\"18948\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}s:14:\"7.x-1.0-alpha2\";a:15:{s:4:\"name\";s:30:\"entityreference 7.x-1.0-alpha2\";s:7:\"version\";s:14:\"7.x-1.0-alpha2\";s:3:\"tag\";s:14:\"7.x-1.0-alpha2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:70:\"https://www.drupal.org/project/entityreference/releases/7.x-1.0-alpha2\";s:13:\"download_link\";s:75:\"https://ftp.drupal.org/files/projects/entityreference-7.x-1.0-alpha2.tar.gz\";s:4:\"date\";s:10:\"1316171203\";s:6:\"mdhash\";s:32:\"0f5a3e9f3f998ed12d7c6bf1fd864274\";s:8:\"filesize\";s:5:\"17761\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}s:14:\"7.x-1.0-alpha1\";a:15:{s:4:\"name\";s:30:\"entityreference 7.x-1.0-alpha1\";s:7:\"version\";s:14:\"7.x-1.0-alpha1\";s:3:\"tag\";s:14:\"7.x-1.0-alpha1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:70:\"https://www.drupal.org/project/entityreference/releases/7.x-1.0-alpha1\";s:13:\"download_link\";s:75:\"https://ftp.drupal.org/files/projects/entityreference-7.x-1.0-alpha1.tar.gz\";s:4:\"date\";s:10:\"1313085717\";s:6:\"mdhash\";s:32:\"d17373159f2c745be04bf3ea2df7632d\";s:8:\"filesize\";s:5:\"10847\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}s:11:\"7.x-1.x-dev\";a:14:{s:4:\"name\";s:27:\"entityreference 7.x-1.x-dev\";s:7:\"version\";s:11:\"7.x-1.x-dev\";s:3:\"tag\";s:7:\"7.x-1.x\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:67:\"https://www.drupal.org/project/entityreference/releases/7.x-1.x-dev\";s:13:\"download_link\";s:72:\"https://ftp.drupal.org/files/projects/entityreference-7.x-1.x-dev.tar.gz\";s:4:\"date\";s:10:\"1502895843\";s:6:\"mdhash\";s:32:\"63de6fe0a49144e0dbe13e7c488927be\";s:8:\"filesize\";s:5:\"43346\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}}}',1512706738,1512620327,1),('available_releases::faq','a:11:{s:5:\"title\";s:26:\"Frequently Asked Questions\";s:10:\"short_name\";s:3:\"faq\";s:4:\"type\";s:14:\"project_module\";s:11:\"api_version\";s:3:\"7.x\";s:17:\"recommended_major\";s:1:\"1\";s:16:\"supported_majors\";s:3:\"1,2\";s:13:\"default_major\";s:1:\"1\";s:14:\"project_status\";s:9:\"published\";s:4:\"link\";s:34:\"https://www.drupal.org/project/faq\";s:5:\"terms\";s:0:\"\";s:8:\"releases\";a:9:{s:14:\"7.x-2.0-alpha2\";a:15:{s:4:\"name\";s:18:\"faq 7.x-2.0-alpha2\";s:7:\"version\";s:14:\"7.x-2.0-alpha2\";s:3:\"tag\";s:14:\"7.x-2.0-alpha2\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:58:\"https://www.drupal.org/project/faq/releases/7.x-2.0-alpha2\";s:13:\"download_link\";s:63:\"https://ftp.drupal.org/files/projects/faq-7.x-2.0-alpha2.tar.gz\";s:4:\"date\";s:10:\"1410364432\";s:6:\"mdhash\";s:32:\"d5939a9b175274cd1df691ecf7435d3c\";s:8:\"filesize\";s:5:\"40831\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:14:\"7.x-2.0-alpha1\";a:15:{s:4:\"name\";s:18:\"faq 7.x-2.0-alpha1\";s:7:\"version\";s:14:\"7.x-2.0-alpha1\";s:3:\"tag\";s:14:\"7.x-2.0-alpha1\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:58:\"https://www.drupal.org/project/faq/releases/7.x-2.0-alpha1\";s:13:\"download_link\";s:63:\"https://ftp.drupal.org/files/projects/faq-7.x-2.0-alpha1.tar.gz\";s:4:\"date\";s:10:\"1407241427\";s:6:\"mdhash\";s:32:\"8c1454ed84dff1da53514a842729284e\";s:8:\"filesize\";s:5:\"41319\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:7:\"7.x-1.1\";a:14:{s:4:\"name\";s:11:\"faq 7.x-1.1\";s:7:\"version\";s:7:\"7.x-1.1\";s:3:\"tag\";s:7:\"7.x-1.1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:51:\"https://www.drupal.org/project/faq/releases/7.x-1.1\";s:13:\"download_link\";s:56:\"https://ftp.drupal.org/files/projects/faq-7.x-1.1.tar.gz\";s:4:\"date\";s:10:\"1441726439\";s:6:\"mdhash\";s:32:\"abd5f2f55925c9e25c52a79d9c682d39\";s:8:\"filesize\";s:5:\"42295\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-1.0\";a:14:{s:4:\"name\";s:11:\"faq 7.x-1.0\";s:7:\"version\";s:7:\"7.x-1.0\";s:3:\"tag\";s:7:\"7.x-1.0\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:51:\"https://www.drupal.org/project/faq/releases/7.x-1.0\";s:13:\"download_link\";s:56:\"https://ftp.drupal.org/files/projects/faq-7.x-1.0.tar.gz\";s:4:\"date\";s:10:\"1427455681\";s:6:\"mdhash\";s:32:\"c8c9e541dbea89d3076552500e799a02\";s:8:\"filesize\";s:5:\"41952\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:11:\"7.x-1.0-rc3\";a:15:{s:4:\"name\";s:15:\"faq 7.x-1.0-rc3\";s:7:\"version\";s:11:\"7.x-1.0-rc3\";s:3:\"tag\";s:11:\"7.x-1.0-rc3\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:55:\"https://www.drupal.org/project/faq/releases/7.x-1.0-rc3\";s:13:\"download_link\";s:60:\"https://ftp.drupal.org/files/projects/faq-7.x-1.0-rc3.tar.gz\";s:4:\"date\";s:10:\"1415528880\";s:6:\"mdhash\";s:32:\"b9570546f908c7e634f1b2215ed2f7d9\";s:8:\"filesize\";s:5:\"41881\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:11:\"7.x-1.0-rc2\";a:15:{s:4:\"name\";s:15:\"faq 7.x-1.0-rc2\";s:7:\"version\";s:11:\"7.x-1.0-rc2\";s:3:\"tag\";s:11:\"7.x-1.0-rc2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:55:\"https://www.drupal.org/project/faq/releases/7.x-1.0-rc2\";s:13:\"download_link\";s:60:\"https://ftp.drupal.org/files/projects/faq-7.x-1.0-rc2.tar.gz\";s:4:\"date\";s:10:\"1329952549\";s:6:\"mdhash\";s:32:\"c10c293f05e28fefe48a8bd232334d48\";s:8:\"filesize\";s:5:\"38898\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:15:\"Security update\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:11:\"7.x-1.0-rc1\";a:15:{s:4:\"name\";s:15:\"faq 7.x-1.0-rc1\";s:7:\"version\";s:11:\"7.x-1.0-rc1\";s:3:\"tag\";s:11:\"7.x-1.0-rc1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:55:\"https://www.drupal.org/project/faq/releases/7.x-1.0-rc1\";s:13:\"download_link\";s:60:\"https://ftp.drupal.org/files/projects/faq-7.x-1.0-rc1.tar.gz\";s:4:\"date\";s:10:\"1314568918\";s:6:\"mdhash\";s:32:\"b9864a18d1a36cd448c48871dea33aad\";s:8:\"filesize\";s:5:\"36305\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:11:\"7.x-2.x-dev\";a:14:{s:4:\"name\";s:15:\"faq 7.x-2.x-dev\";s:7:\"version\";s:11:\"7.x-2.x-dev\";s:3:\"tag\";s:7:\"7.x-2.x\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:55:\"https://www.drupal.org/project/faq/releases/7.x-2.x-dev\";s:13:\"download_link\";s:60:\"https://ftp.drupal.org/files/projects/faq-7.x-2.x-dev.tar.gz\";s:4:\"date\";s:10:\"1415528580\";s:6:\"mdhash\";s:32:\"dd7e308d35b01c27a909db2413f9180c\";s:8:\"filesize\";s:5:\"40693\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:12:\"New features\";}}s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";}s:11:\"7.x-1.x-dev\";a:14:{s:4:\"name\";s:15:\"faq 7.x-1.x-dev\";s:7:\"version\";s:11:\"7.x-1.x-dev\";s:3:\"tag\";s:7:\"7.x-1.x\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:55:\"https://www.drupal.org/project/faq/releases/7.x-1.x-dev\";s:13:\"download_link\";s:60:\"https://ftp.drupal.org/files/projects/faq-7.x-1.x-dev.tar.gz\";s:4:\"date\";s:10:\"1441726439\";s:6:\"mdhash\";s:32:\"f8108cfc7b58e612c434a5f41f45a440\";s:8:\"filesize\";s:5:\"42298\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}}}',1512706738,1512620327,1),('available_releases::features','a:11:{s:5:\"title\";s:8:\"Features\";s:10:\"short_name\";s:8:\"features\";s:4:\"type\";s:14:\"project_module\";s:11:\"api_version\";s:3:\"7.x\";s:17:\"recommended_major\";s:1:\"2\";s:16:\"supported_majors\";s:1:\"2\";s:13:\"default_major\";s:1:\"2\";s:14:\"project_status\";s:9:\"published\";s:4:\"link\";s:39:\"https://www.drupal.org/project/features\";s:5:\"terms\";s:0:\"\";s:8:\"releases\";a:35:{s:8:\"7.x-2.10\";a:14:{s:4:\"name\";s:17:\"features 7.x-2.10\";s:7:\"version\";s:8:\"7.x-2.10\";s:3:\"tag\";s:8:\"7.x-2.10\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:2:\"10\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:57:\"https://www.drupal.org/project/features/releases/7.x-2.10\";s:13:\"download_link\";s:62:\"https://ftp.drupal.org/files/projects/features-7.x-2.10.tar.gz\";s:4:\"date\";s:10:\"1461011639\";s:6:\"mdhash\";s:32:\"5641e5545020932570aed464fbaebf6a\";s:8:\"filesize\";s:5:\"97102\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-2.9\";a:14:{s:4:\"name\";s:16:\"features 7.x-2.9\";s:7:\"version\";s:7:\"7.x-2.9\";s:3:\"tag\";s:7:\"7.x-2.9\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"9\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/features/releases/7.x-2.9\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/features-7.x-2.9.tar.gz\";s:4:\"date\";s:10:\"1460560739\";s:6:\"mdhash\";s:32:\"27fbaf1a31c83f0d18fbe114c2f3fc8a\";s:8:\"filesize\";s:5:\"97030\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:15:\"Security update\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-2.8\";a:14:{s:4:\"name\";s:16:\"features 7.x-2.8\";s:7:\"version\";s:7:\"7.x-2.8\";s:3:\"tag\";s:7:\"7.x-2.8\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"8\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/features/releases/7.x-2.8\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/features-7.x-2.8.tar.gz\";s:4:\"date\";s:10:\"1458744539\";s:6:\"mdhash\";s:32:\"ad38d9cf2588bdd7821fc662217d6763\";s:8:\"filesize\";s:5:\"96932\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-2.7\";a:14:{s:4:\"name\";s:16:\"features 7.x-2.7\";s:7:\"version\";s:7:\"7.x-2.7\";s:3:\"tag\";s:7:\"7.x-2.7\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"7\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/features/releases/7.x-2.7\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/features-7.x-2.7.tar.gz\";s:4:\"date\";s:10:\"1444829339\";s:6:\"mdhash\";s:32:\"dcfcc0cede1d281c23346662029015a5\";s:8:\"filesize\";s:5:\"97292\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";s:5:\"terms\";a:0:{}}s:7:\"7.x-2.6\";a:14:{s:4:\"name\";s:16:\"features 7.x-2.6\";s:7:\"version\";s:7:\"7.x-2.6\";s:3:\"tag\";s:7:\"7.x-2.6\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"6\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/features/releases/7.x-2.6\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/features-7.x-2.6.tar.gz\";s:4:\"date\";s:10:\"1435165980\";s:6:\"mdhash\";s:32:\"3a41eba4ca26f0d3a0e00e97dd8722ba\";s:8:\"filesize\";s:5:\"96581\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:11:\"7.x-2.6-rc1\";a:15:{s:4:\"name\";s:20:\"features 7.x-2.6-rc1\";s:7:\"version\";s:11:\"7.x-2.6-rc1\";s:3:\"tag\";s:11:\"7.x-2.6-rc1\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"6\";s:13:\"version_extra\";s:3:\"rc1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:60:\"https://www.drupal.org/project/features/releases/7.x-2.6-rc1\";s:13:\"download_link\";s:65:\"https://ftp.drupal.org/files/projects/features-7.x-2.6-rc1.tar.gz\";s:4:\"date\";s:10:\"1433533080\";s:6:\"mdhash\";s:32:\"ac68a860da89bd8a54f0cb5b7a2668ce\";s:8:\"filesize\";s:5:\"96592\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:7:\"7.x-2.5\";a:14:{s:4:\"name\";s:16:\"features 7.x-2.5\";s:7:\"version\";s:7:\"7.x-2.5\";s:3:\"tag\";s:7:\"7.x-2.5\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"5\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/features/releases/7.x-2.5\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/features-7.x-2.5.tar.gz\";s:4:\"date\";s:10:\"1428943813\";s:6:\"mdhash\";s:32:\"c6fea06d61fe6f4c9d1943a5fcb99f61\";s:8:\"filesize\";s:5:\"92795\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-2.4\";a:14:{s:4:\"name\";s:16:\"features 7.x-2.4\";s:7:\"version\";s:7:\"7.x-2.4\";s:3:\"tag\";s:7:\"7.x-2.4\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/features/releases/7.x-2.4\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/features-7.x-2.4.tar.gz\";s:4:\"date\";s:10:\"1425500581\";s:6:\"mdhash\";s:32:\"af6f0fd6117b5c0ff15ef7c1923d116f\";s:8:\"filesize\";s:5:\"92229\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-2.3\";a:14:{s:4:\"name\";s:16:\"features 7.x-2.3\";s:7:\"version\";s:7:\"7.x-2.3\";s:3:\"tag\";s:7:\"7.x-2.3\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/features/releases/7.x-2.3\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/features-7.x-2.3.tar.gz\";s:4:\"date\";s:10:\"1420492080\";s:6:\"mdhash\";s:32:\"562c8c81a512e45d5fb04b4ee33858bf\";s:8:\"filesize\";s:5:\"92013\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-2.2\";a:14:{s:4:\"name\";s:16:\"features 7.x-2.2\";s:7:\"version\";s:7:\"7.x-2.2\";s:3:\"tag\";s:7:\"7.x-2.2\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/features/releases/7.x-2.2\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/features-7.x-2.2.tar.gz\";s:4:\"date\";s:10:\"1407338927\";s:6:\"mdhash\";s:32:\"1eaa764a12b7ad846ab3ffa70512c567\";s:8:\"filesize\";s:5:\"92041\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-2.1\";a:14:{s:4:\"name\";s:16:\"features 7.x-2.1\";s:7:\"version\";s:7:\"7.x-2.1\";s:3:\"tag\";s:7:\"7.x-2.1\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/features/releases/7.x-2.1\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/features-7.x-2.1.tar.gz\";s:4:\"date\";s:10:\"1406655227\";s:6:\"mdhash\";s:32:\"4e95d6671dbdaa0e8c8bd1ce9cf04ead\";s:8:\"filesize\";s:5:\"92052\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";s:5:\"terms\";a:0:{}}s:7:\"7.x-2.0\";a:14:{s:4:\"name\";s:16:\"features 7.x-2.0\";s:7:\"version\";s:7:\"7.x-2.0\";s:3:\"tag\";s:7:\"7.x-2.0\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/features/releases/7.x-2.0\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/features-7.x-2.0.tar.gz\";s:4:\"date\";s:10:\"1382018758\";s:6:\"mdhash\";s:32:\"2ce7c8cb75d3fc57da069721f6a9a052\";s:8:\"filesize\";s:5:\"90313\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";s:5:\"terms\";a:0:{}}s:11:\"7.x-2.0-rc5\";a:15:{s:4:\"name\";s:20:\"features 7.x-2.0-rc5\";s:7:\"version\";s:11:\"7.x-2.0-rc5\";s:3:\"tag\";s:11:\"7.x-2.0-rc5\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc5\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:60:\"https://www.drupal.org/project/features/releases/7.x-2.0-rc5\";s:13:\"download_link\";s:65:\"https://ftp.drupal.org/files/projects/features-7.x-2.0-rc5.tar.gz\";s:4:\"date\";s:10:\"1381157303\";s:6:\"mdhash\";s:32:\"faf76e87122ff5140a7a8300c96e8389\";s:8:\"filesize\";s:5:\"90231\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:11:\"7.x-2.0-rc4\";a:15:{s:4:\"name\";s:20:\"features 7.x-2.0-rc4\";s:7:\"version\";s:11:\"7.x-2.0-rc4\";s:3:\"tag\";s:11:\"7.x-2.0-rc4\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:60:\"https://www.drupal.org/project/features/releases/7.x-2.0-rc4\";s:13:\"download_link\";s:65:\"https://ftp.drupal.org/files/projects/features-7.x-2.0-rc4.tar.gz\";s:4:\"date\";s:10:\"1380815748\";s:6:\"mdhash\";s:32:\"71aa54041d07e2b773efb692c2d13476\";s:8:\"filesize\";s:5:\"90706\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:11:\"7.x-2.0-rc3\";a:15:{s:4:\"name\";s:20:\"features 7.x-2.0-rc3\";s:7:\"version\";s:11:\"7.x-2.0-rc3\";s:3:\"tag\";s:11:\"7.x-2.0-rc3\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:60:\"https://www.drupal.org/project/features/releases/7.x-2.0-rc3\";s:13:\"download_link\";s:65:\"https://ftp.drupal.org/files/projects/features-7.x-2.0-rc3.tar.gz\";s:4:\"date\";s:10:\"1377548845\";s:6:\"mdhash\";s:32:\"d92bf152081ba92b2c352b0164198e17\";s:8:\"filesize\";s:5:\"88117\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:11:\"7.x-2.0-rc2\";a:15:{s:4:\"name\";s:20:\"features 7.x-2.0-rc2\";s:7:\"version\";s:11:\"7.x-2.0-rc2\";s:3:\"tag\";s:11:\"7.x-2.0-rc2\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:60:\"https://www.drupal.org/project/features/releases/7.x-2.0-rc2\";s:13:\"download_link\";s:65:\"https://ftp.drupal.org/files/projects/features-7.x-2.0-rc2.tar.gz\";s:4:\"date\";s:10:\"1375464067\";s:6:\"mdhash\";s:32:\"63db49c3d8285277b787afa237e96454\";s:8:\"filesize\";s:5:\"87769\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:11:\"7.x-2.0-rc1\";a:15:{s:4:\"name\";s:20:\"features 7.x-2.0-rc1\";s:7:\"version\";s:11:\"7.x-2.0-rc1\";s:3:\"tag\";s:11:\"7.x-2.0-rc1\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:60:\"https://www.drupal.org/project/features/releases/7.x-2.0-rc1\";s:13:\"download_link\";s:65:\"https://ftp.drupal.org/files/projects/features-7.x-2.0-rc1.tar.gz\";s:4:\"date\";s:10:\"1369094412\";s:6:\"mdhash\";s:32:\"303cd7d10ec0a84e500fd1693d2d3fd0\";s:8:\"filesize\";s:5:\"85917\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:13:\"7.x-2.0-beta2\";a:15:{s:4:\"name\";s:22:\"features 7.x-2.0-beta2\";s:7:\"version\";s:13:\"7.x-2.0-beta2\";s:3:\"tag\";s:13:\"7.x-2.0-beta2\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/features/releases/7.x-2.0-beta2\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/features-7.x-2.0-beta2.tar.gz\";s:4:\"date\";s:10:\"1364589018\";s:6:\"mdhash\";s:32:\"d889b7006668c261294e58a31b40c53e\";s:8:\"filesize\";s:5:\"85069\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"7.x-2.0-beta1\";a:15:{s:4:\"name\";s:22:\"features 7.x-2.0-beta1\";s:7:\"version\";s:13:\"7.x-2.0-beta1\";s:3:\"tag\";s:13:\"7.x-2.0-beta1\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/features/releases/7.x-2.0-beta1\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/features-7.x-2.0-beta1.tar.gz\";s:4:\"date\";s:10:\"1352395006\";s:6:\"mdhash\";s:32:\"654e54d22922d4cdbdf1b78be19c5cda\";s:8:\"filesize\";s:5:\"83547\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:14:\"7.x-2.0-alpha2\";a:15:{s:4:\"name\";s:23:\"features 7.x-2.0-alpha2\";s:7:\"version\";s:14:\"7.x-2.0-alpha2\";s:3:\"tag\";s:14:\"7.x-2.0-alpha2\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:63:\"https://www.drupal.org/project/features/releases/7.x-2.0-alpha2\";s:13:\"download_link\";s:68:\"https://ftp.drupal.org/files/projects/features-7.x-2.0-alpha2.tar.gz\";s:4:\"date\";s:10:\"1351907522\";s:6:\"mdhash\";s:32:\"f588de7611e09d4460a6cd92bf133200\";s:8:\"filesize\";s:5:\"83533\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:7:\"7.x-1.0\";a:14:{s:4:\"name\";s:16:\"features 7.x-1.0\";s:7:\"version\";s:7:\"7.x-1.0\";s:3:\"tag\";s:7:\"7.x-1.0\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/features/releases/7.x-1.0\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/features-7.x-1.0.tar.gz\";s:4:\"date\";s:10:\"1343240292\";s:6:\"mdhash\";s:32:\"00984913badb19fee69d3ee0ac27eee8\";s:8:\"filesize\";s:5:\"72114\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:11:\"7.x-1.0-rc3\";a:15:{s:4:\"name\";s:20:\"features 7.x-1.0-rc3\";s:7:\"version\";s:11:\"7.x-1.0-rc3\";s:3:\"tag\";s:11:\"7.x-1.0-rc3\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:60:\"https://www.drupal.org/project/features/releases/7.x-1.0-rc3\";s:13:\"download_link\";s:65:\"https://ftp.drupal.org/files/projects/features-7.x-1.0-rc3.tar.gz\";s:4:\"date\";s:10:\"1339680981\";s:6:\"mdhash\";s:32:\"bb8ac718377cd098474e37f202181b03\";s:8:\"filesize\";s:5:\"71806\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:11:\"7.x-1.0-rc2\";a:15:{s:4:\"name\";s:20:\"features 7.x-1.0-rc2\";s:7:\"version\";s:11:\"7.x-1.0-rc2\";s:3:\"tag\";s:11:\"7.x-1.0-rc2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:60:\"https://www.drupal.org/project/features/releases/7.x-1.0-rc2\";s:13:\"download_link\";s:65:\"https://ftp.drupal.org/files/projects/features-7.x-1.0-rc2.tar.gz\";s:4:\"date\";s:10:\"1334345807\";s:6:\"mdhash\";s:32:\"0b559938e0aa604729eb2b2fb4840f1b\";s:8:\"filesize\";s:5:\"69926\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:11:\"7.x-1.0-rc1\";a:15:{s:4:\"name\";s:20:\"features 7.x-1.0-rc1\";s:7:\"version\";s:11:\"7.x-1.0-rc1\";s:3:\"tag\";s:11:\"7.x-1.0-rc1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:60:\"https://www.drupal.org/project/features/releases/7.x-1.0-rc1\";s:13:\"download_link\";s:65:\"https://ftp.drupal.org/files/projects/features-7.x-1.0-rc1.tar.gz\";s:4:\"date\";s:10:\"1332022247\";s:6:\"mdhash\";s:32:\"a4f24fe0f0ac5e099b18c667253fa8bc\";s:8:\"filesize\";s:5:\"68737\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:13:\"7.x-1.0-beta6\";a:15:{s:4:\"name\";s:22:\"features 7.x-1.0-beta6\";s:7:\"version\";s:13:\"7.x-1.0-beta6\";s:3:\"tag\";s:13:\"7.x-1.0-beta6\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta6\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/features/releases/7.x-1.0-beta6\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/features-7.x-1.0-beta6.tar.gz\";s:4:\"date\";s:10:\"1325627143\";s:6:\"mdhash\";s:32:\"d65f3131ad8d397bd5437fe4ab7dba0a\";s:8:\"filesize\";s:5:\"68900\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"7.x-1.0-beta5\";a:15:{s:4:\"name\";s:22:\"features 7.x-1.0-beta5\";s:7:\"version\";s:13:\"7.x-1.0-beta5\";s:3:\"tag\";s:13:\"7.x-1.0-beta5\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta5\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/features/releases/7.x-1.0-beta5\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/features-7.x-1.0-beta5.tar.gz\";s:4:\"date\";s:10:\"1324573544\";s:6:\"mdhash\";s:32:\"10053380081d77c6e1cc107ea17bd81e\";s:8:\"filesize\";s:5:\"68894\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"7.x-1.0-beta4\";a:15:{s:4:\"name\";s:22:\"features 7.x-1.0-beta4\";s:7:\"version\";s:13:\"7.x-1.0-beta4\";s:3:\"tag\";s:13:\"7.x-1.0-beta4\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/features/releases/7.x-1.0-beta4\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/features-7.x-1.0-beta4.tar.gz\";s:4:\"date\";s:10:\"1316565919\";s:6:\"mdhash\";s:32:\"fbce2ff07b59723d6688ceeac97a967a\";s:8:\"filesize\";s:5:\"67007\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"7.x-1.0-beta3\";a:15:{s:4:\"name\";s:22:\"features 7.x-1.0-beta3\";s:7:\"version\";s:13:\"7.x-1.0-beta3\";s:3:\"tag\";s:13:\"7.x-1.0-beta3\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/features/releases/7.x-1.0-beta3\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/features-7.x-1.0-beta3.tar.gz\";s:4:\"date\";s:10:\"1308598915\";s:6:\"mdhash\";s:32:\"20db76b147faf56cc2c1c413cf187db3\";s:8:\"filesize\";s:5:\"63951\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"7.x-1.0-beta2\";a:15:{s:4:\"name\";s:22:\"features 7.x-1.0-beta2\";s:7:\"version\";s:13:\"7.x-1.0-beta2\";s:3:\"tag\";s:13:\"7.x-1.0-beta2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/features/releases/7.x-1.0-beta2\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/features-7.x-1.0-beta2.tar.gz\";s:4:\"date\";s:10:\"1302049346\";s:6:\"mdhash\";s:32:\"333424ca64d3278cb51319b842e218b2\";s:8:\"filesize\";s:5:\"63505\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"7.x-1.0-beta1\";a:15:{s:4:\"name\";s:22:\"features 7.x-1.0-beta1\";s:7:\"version\";s:13:\"7.x-1.0-beta1\";s:3:\"tag\";s:13:\"7.x-1.0-beta1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/features/releases/7.x-1.0-beta1\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/features-7.x-1.0-beta1.tar.gz\";s:4:\"date\";s:10:\"1298073121\";s:6:\"mdhash\";s:32:\"a5a58e87c3e18dd77ae0e2fb512531d1\";s:8:\"filesize\";s:5:\"68372\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:14:\"7.x-1.0-alpha3\";a:15:{s:4:\"name\";s:23:\"features 7.x-1.0-alpha3\";s:7:\"version\";s:14:\"7.x-1.0-alpha3\";s:3:\"tag\";s:14:\"7.x-1.0-alpha3\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:63:\"https://www.drupal.org/project/features/releases/7.x-1.0-alpha3\";s:13:\"download_link\";s:68:\"https://ftp.drupal.org/files/projects/features-7.x-1.0-alpha3.tar.gz\";s:4:\"date\";s:10:\"1285791063\";s:6:\"mdhash\";s:32:\"09651bc4edb61969d1caa23c76c2df00\";s:8:\"filesize\";s:5:\"67846\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:14:\"7.x-1.0-alpha2\";a:15:{s:4:\"name\";s:23:\"features 7.x-1.0-alpha2\";s:7:\"version\";s:14:\"7.x-1.0-alpha2\";s:3:\"tag\";s:14:\"7.x-1.0-alpha2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:63:\"https://www.drupal.org/project/features/releases/7.x-1.0-alpha2\";s:13:\"download_link\";s:68:\"https://ftp.drupal.org/files/projects/features-7.x-1.0-alpha2.tar.gz\";s:4:\"date\";s:10:\"1285602662\";s:6:\"mdhash\";s:32:\"b7bcfb6b3a7ac54cac600153642c7aab\";s:8:\"filesize\";s:5:\"67869\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:14:\"7.x-1.0-alpha1\";a:15:{s:4:\"name\";s:23:\"features 7.x-1.0-alpha1\";s:7:\"version\";s:14:\"7.x-1.0-alpha1\";s:3:\"tag\";s:14:\"7.x-1.0-alpha1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:63:\"https://www.drupal.org/project/features/releases/7.x-1.0-alpha1\";s:13:\"download_link\";s:68:\"https://ftp.drupal.org/files/projects/features-7.x-1.0-alpha1.tar.gz\";s:4:\"date\";s:10:\"1284158807\";s:6:\"mdhash\";s:32:\"829c91a7111886b3f53278fd44346ec7\";s:8:\"filesize\";s:5:\"67845\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}s:11:\"7.x-2.x-dev\";a:14:{s:4:\"name\";s:20:\"features 7.x-2.x-dev\";s:7:\"version\";s:11:\"7.x-2.x-dev\";s:3:\"tag\";s:7:\"7.x-2.x\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:60:\"https://www.drupal.org/project/features/releases/7.x-2.x-dev\";s:13:\"download_link\";s:65:\"https://ftp.drupal.org/files/projects/features-7.x-2.x-dev.tar.gz\";s:4:\"date\";s:10:\"1473863339\";s:6:\"mdhash\";s:32:\"5ac1876694e412976d22f572294de436\";s:8:\"filesize\";s:5:\"97121\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}s:11:\"7.x-1.x-dev\";a:14:{s:4:\"name\";s:20:\"features 7.x-1.x-dev\";s:7:\"version\";s:11:\"7.x-1.x-dev\";s:3:\"tag\";s:7:\"7.x-1.x\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:60:\"https://www.drupal.org/project/features/releases/7.x-1.x-dev\";s:13:\"download_link\";s:65:\"https://ftp.drupal.org/files/projects/features-7.x-1.x-dev.tar.gz\";s:4:\"date\";s:10:\"1380578130\";s:6:\"mdhash\";s:32:\"baaa489bb72393a5168683c4c27f29dc\";s:8:\"filesize\";s:5:\"73847\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}}}',1512706739,1512620327,1),('available_releases::field_collection','a:11:{s:5:\"title\";s:16:\"Field collection\";s:10:\"short_name\";s:16:\"field_collection\";s:4:\"type\";s:14:\"project_module\";s:11:\"api_version\";s:3:\"7.x\";s:17:\"recommended_major\";s:1:\"1\";s:16:\"supported_majors\";s:1:\"1\";s:13:\"default_major\";s:1:\"1\";s:14:\"project_status\";s:9:\"published\";s:4:\"link\";s:47:\"https://www.drupal.org/project/field_collection\";s:5:\"terms\";s:0:\"\";s:8:\"releases\";a:12:{s:14:\"7.x-1.0-beta12\";a:15:{s:4:\"name\";s:31:\"field_collection 7.x-1.0-beta12\";s:7:\"version\";s:14:\"7.x-1.0-beta12\";s:3:\"tag\";s:14:\"7.x-1.0-beta12\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"beta12\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:71:\"https://www.drupal.org/project/field_collection/releases/7.x-1.0-beta12\";s:13:\"download_link\";s:76:\"https://ftp.drupal.org/files/projects/field_collection-7.x-1.0-beta12.tar.gz\";s:4:\"date\";s:10:\"1479402842\";s:6:\"mdhash\";s:32:\"e966ba0c2ad40b9b044ae8bdf993f5ed\";s:8:\"filesize\";s:5:\"51018\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:54:\"Project has not opted into security advisory coverage!\";}s:14:\"7.x-1.0-beta11\";a:15:{s:4:\"name\";s:31:\"field_collection 7.x-1.0-beta11\";s:7:\"version\";s:14:\"7.x-1.0-beta11\";s:3:\"tag\";s:14:\"7.x-1.0-beta11\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"beta11\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:71:\"https://www.drupal.org/project/field_collection/releases/7.x-1.0-beta11\";s:13:\"download_link\";s:76:\"https://ftp.drupal.org/files/projects/field_collection-7.x-1.0-beta11.tar.gz\";s:4:\"date\";s:10:\"1454338739\";s:6:\"mdhash\";s:32:\"0f51a97383cd50f72a2ecd950cce5e1a\";s:8:\"filesize\";s:5:\"40461\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:54:\"Project has not opted into security advisory coverage!\";}s:14:\"7.x-1.0-beta10\";a:15:{s:4:\"name\";s:31:\"field_collection 7.x-1.0-beta10\";s:7:\"version\";s:14:\"7.x-1.0-beta10\";s:3:\"tag\";s:14:\"7.x-1.0-beta10\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"beta10\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:71:\"https://www.drupal.org/project/field_collection/releases/7.x-1.0-beta10\";s:13:\"download_link\";s:76:\"https://ftp.drupal.org/files/projects/field_collection-7.x-1.0-beta10.tar.gz\";s:4:\"date\";s:10:\"1445529539\";s:6:\"mdhash\";s:32:\"bb00b6d371b096732071ad7999223c5a\";s:8:\"filesize\";s:5:\"40443\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:54:\"Project has not opted into security advisory coverage!\";s:5:\"terms\";a:0:{}}s:13:\"7.x-1.0-beta9\";a:15:{s:4:\"name\";s:30:\"field_collection 7.x-1.0-beta9\";s:7:\"version\";s:13:\"7.x-1.0-beta9\";s:3:\"tag\";s:13:\"7.x-1.0-beta9\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta9\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:70:\"https://www.drupal.org/project/field_collection/releases/7.x-1.0-beta9\";s:13:\"download_link\";s:75:\"https://ftp.drupal.org/files/projects/field_collection-7.x-1.0-beta9.tar.gz\";s:4:\"date\";s:10:\"1445282939\";s:6:\"mdhash\";s:32:\"99910b78ea9fdda42a746089b579152c\";s:8:\"filesize\";s:5:\"40406\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:54:\"Project has not opted into security advisory coverage!\";s:5:\"terms\";a:0:{}}s:13:\"7.x-1.0-beta8\";a:15:{s:4:\"name\";s:30:\"field_collection 7.x-1.0-beta8\";s:7:\"version\";s:13:\"7.x-1.0-beta8\";s:3:\"tag\";s:13:\"7.x-1.0-beta8\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta8\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:70:\"https://www.drupal.org/project/field_collection/releases/7.x-1.0-beta8\";s:13:\"download_link\";s:75:\"https://ftp.drupal.org/files/projects/field_collection-7.x-1.0-beta8.tar.gz\";s:4:\"date\";s:10:\"1415122380\";s:6:\"mdhash\";s:32:\"50e687acf3779b987bacde5ad047fb46\";s:8:\"filesize\";s:5:\"38360\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:54:\"Project has not opted into security advisory coverage!\";}s:13:\"7.x-1.0-beta7\";a:15:{s:4:\"name\";s:30:\"field_collection 7.x-1.0-beta7\";s:7:\"version\";s:13:\"7.x-1.0-beta7\";s:3:\"tag\";s:13:\"7.x-1.0-beta7\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta7\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:70:\"https://www.drupal.org/project/field_collection/releases/7.x-1.0-beta7\";s:13:\"download_link\";s:75:\"https://ftp.drupal.org/files/projects/field_collection-7.x-1.0-beta7.tar.gz\";s:4:\"date\";s:10:\"1394731105\";s:6:\"mdhash\";s:32:\"8678d50f7248d4830a615f451c623201\";s:8:\"filesize\";s:5:\"36080\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:54:\"Project has not opted into security advisory coverage!\";}s:13:\"7.x-1.0-beta5\";a:15:{s:4:\"name\";s:30:\"field_collection 7.x-1.0-beta5\";s:7:\"version\";s:13:\"7.x-1.0-beta5\";s:3:\"tag\";s:13:\"7.x-1.0-beta5\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta5\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:70:\"https://www.drupal.org/project/field_collection/releases/7.x-1.0-beta5\";s:13:\"download_link\";s:75:\"https://ftp.drupal.org/files/projects/field_collection-7.x-1.0-beta5.tar.gz\";s:4:\"date\";s:10:\"1356475964\";s:6:\"mdhash\";s:32:\"e881931a5e0fea9ff844385c80743a54\";s:8:\"filesize\";s:5:\"33162\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:54:\"Project has not opted into security advisory coverage!\";}s:13:\"7.x-1.0-beta4\";a:15:{s:4:\"name\";s:30:\"field_collection 7.x-1.0-beta4\";s:7:\"version\";s:13:\"7.x-1.0-beta4\";s:3:\"tag\";s:13:\"7.x-1.0-beta4\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:70:\"https://www.drupal.org/project/field_collection/releases/7.x-1.0-beta4\";s:13:\"download_link\";s:75:\"https://ftp.drupal.org/files/projects/field_collection-7.x-1.0-beta4.tar.gz\";s:4:\"date\";s:10:\"1333382446\";s:6:\"mdhash\";s:32:\"591e8d3bcc5f0af52710680529308d8e\";s:8:\"filesize\";s:5:\"26573\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:54:\"Project has not opted into security advisory coverage!\";s:5:\"terms\";a:0:{}}s:13:\"7.x-1.0-beta3\";a:15:{s:4:\"name\";s:30:\"field_collection 7.x-1.0-beta3\";s:7:\"version\";s:13:\"7.x-1.0-beta3\";s:3:\"tag\";s:13:\"7.x-1.0-beta3\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:70:\"https://www.drupal.org/project/field_collection/releases/7.x-1.0-beta3\";s:13:\"download_link\";s:75:\"https://ftp.drupal.org/files/projects/field_collection-7.x-1.0-beta3.tar.gz\";s:4:\"date\";s:10:\"1327376442\";s:6:\"mdhash\";s:32:\"ef0e3a56c77e50a59f0ae965d70b58b3\";s:8:\"filesize\";s:5:\"25613\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:54:\"Project has not opted into security advisory coverage!\";}s:13:\"7.x-1.0-beta2\";a:15:{s:4:\"name\";s:30:\"field_collection 7.x-1.0-beta2\";s:7:\"version\";s:13:\"7.x-1.0-beta2\";s:3:\"tag\";s:13:\"7.x-1.0-beta2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:70:\"https://www.drupal.org/project/field_collection/releases/7.x-1.0-beta2\";s:13:\"download_link\";s:75:\"https://ftp.drupal.org/files/projects/field_collection-7.x-1.0-beta2.tar.gz\";s:4:\"date\";s:10:\"1313670125\";s:6:\"mdhash\";s:32:\"b4ee245a67c07332b3b2fa2d83ba7e1a\";s:8:\"filesize\";s:5:\"21012\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:54:\"Project has not opted into security advisory coverage!\";}s:13:\"7.x-1.0-beta1\";a:15:{s:4:\"name\";s:30:\"field_collection 7.x-1.0-beta1\";s:7:\"version\";s:13:\"7.x-1.0-beta1\";s:3:\"tag\";s:13:\"7.x-1.0-beta1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:70:\"https://www.drupal.org/project/field_collection/releases/7.x-1.0-beta1\";s:13:\"download_link\";s:75:\"https://ftp.drupal.org/files/projects/field_collection-7.x-1.0-beta1.tar.gz\";s:4:\"date\";s:10:\"1296573488\";s:6:\"mdhash\";s:32:\"7c644203e32cc8c6d2d1bd5400b5c361\";s:8:\"filesize\";s:5:\"17272\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:54:\"Project has not opted into security advisory coverage!\";s:5:\"terms\";a:0:{}}s:11:\"7.x-1.x-dev\";a:14:{s:4:\"name\";s:28:\"field_collection 7.x-1.x-dev\";s:7:\"version\";s:11:\"7.x-1.x-dev\";s:3:\"tag\";s:7:\"7.x-1.x\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:68:\"https://www.drupal.org/project/field_collection/releases/7.x-1.x-dev\";s:13:\"download_link\";s:73:\"https://ftp.drupal.org/files/projects/field_collection-7.x-1.x-dev.tar.gz\";s:4:\"date\";s:10:\"1481300583\";s:6:\"mdhash\";s:32:\"cedb190a2c89f6280843a7672094e0bc\";s:8:\"filesize\";s:5:\"51053\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:54:\"Project has not opted into security advisory coverage!\";s:5:\"terms\";a:0:{}}}}',1512706729,1512620327,1),('available_releases::field_group','a:11:{s:5:\"title\";s:11:\"Field Group\";s:10:\"short_name\";s:11:\"field_group\";s:4:\"type\";s:14:\"project_module\";s:11:\"api_version\";s:3:\"7.x\";s:17:\"recommended_major\";s:1:\"1\";s:16:\"supported_majors\";s:1:\"1\";s:13:\"default_major\";s:1:\"1\";s:14:\"project_status\";s:9:\"published\";s:4:\"link\";s:42:\"https://www.drupal.org/project/field_group\";s:5:\"terms\";s:0:\"\";s:8:\"releases\";a:11:{s:7:\"7.x-1.6\";a:14:{s:4:\"name\";s:19:\"field_group 7.x-1.6\";s:7:\"version\";s:7:\"7.x-1.6\";s:3:\"tag\";s:7:\"7.x-1.6\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"6\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:59:\"https://www.drupal.org/project/field_group/releases/7.x-1.6\";s:13:\"download_link\";s:64:\"https://ftp.drupal.org/files/projects/field_group-7.x-1.6.tar.gz\";s:4:\"date\";s:10:\"1509751984\";s:6:\"mdhash\";s:32:\"14a100269b1ddfe88c32442c8da53d1d\";s:8:\"filesize\";s:5:\"52556\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-1.5\";a:14:{s:4:\"name\";s:19:\"field_group 7.x-1.5\";s:7:\"version\";s:7:\"7.x-1.5\";s:3:\"tag\";s:7:\"7.x-1.5\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"5\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:59:\"https://www.drupal.org/project/field_group/releases/7.x-1.5\";s:13:\"download_link\";s:64:\"https://ftp.drupal.org/files/projects/field_group-7.x-1.5.tar.gz\";s:4:\"date\";s:10:\"1452033539\";s:6:\"mdhash\";s:32:\"8d91e0f3cc8106deefe038d5fc07d3e6\";s:8:\"filesize\";s:5:\"51465\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:15:\"Security update\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-1.4\";a:14:{s:4:\"name\";s:19:\"field_group 7.x-1.4\";s:7:\"version\";s:7:\"7.x-1.4\";s:3:\"tag\";s:7:\"7.x-1.4\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:59:\"https://www.drupal.org/project/field_group/releases/7.x-1.4\";s:13:\"download_link\";s:64:\"https://ftp.drupal.org/files/projects/field_group-7.x-1.4.tar.gz\";s:4:\"date\";s:10:\"1401918527\";s:6:\"mdhash\";s:32:\"fa268e0c23b2af31ed560aa03a986cf1\";s:8:\"filesize\";s:5:\"51303\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-1.3\";a:14:{s:4:\"name\";s:19:\"field_group 7.x-1.3\";s:7:\"version\";s:7:\"7.x-1.3\";s:3:\"tag\";s:7:\"7.x-1.3\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:59:\"https://www.drupal.org/project/field_group/releases/7.x-1.3\";s:13:\"download_link\";s:64:\"https://ftp.drupal.org/files/projects/field_group-7.x-1.3.tar.gz\";s:4:\"date\";s:10:\"1380124361\";s:6:\"mdhash\";s:32:\"6ea6a2b8a15c9c68d981f5b0ae6f881c\";s:8:\"filesize\";s:5:\"50593\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-1.2\";a:14:{s:4:\"name\";s:19:\"field_group 7.x-1.2\";s:7:\"version\";s:7:\"7.x-1.2\";s:3:\"tag\";s:7:\"7.x-1.2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:59:\"https://www.drupal.org/project/field_group/releases/7.x-1.2\";s:13:\"download_link\";s:64:\"https://ftp.drupal.org/files/projects/field_group-7.x-1.2.tar.gz\";s:4:\"date\";s:10:\"1377806210\";s:6:\"mdhash\";s:32:\"ea1b1af0b09f7578cffc261c8c5203df\";s:8:\"filesize\";s:5:\"49436\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-1.1\";a:14:{s:4:\"name\";s:19:\"field_group 7.x-1.1\";s:7:\"version\";s:7:\"7.x-1.1\";s:3:\"tag\";s:7:\"7.x-1.1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:59:\"https://www.drupal.org/project/field_group/releases/7.x-1.1\";s:13:\"download_link\";s:64:\"https://ftp.drupal.org/files/projects/field_group-7.x-1.1.tar.gz\";s:4:\"date\";s:10:\"1319051133\";s:6:\"mdhash\";s:32:\"4f02e7b10aff66e3bcdae002d6b80ec6\";s:8:\"filesize\";s:5:\"43065\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-1.0\";a:14:{s:4:\"name\";s:19:\"field_group 7.x-1.0\";s:7:\"version\";s:7:\"7.x-1.0\";s:3:\"tag\";s:7:\"7.x-1.0\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:59:\"https://www.drupal.org/project/field_group/releases/7.x-1.0\";s:13:\"download_link\";s:64:\"https://ftp.drupal.org/files/projects/field_group-7.x-1.0.tar.gz\";s:4:\"date\";s:10:\"1306266416\";s:6:\"mdhash\";s:32:\"5f549fbc7cbfa575a11a9d705a3df597\";s:8:\"filesize\";s:5:\"33471\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:11:\"7.x-1.0-rc2\";a:15:{s:4:\"name\";s:23:\"field_group 7.x-1.0-rc2\";s:7:\"version\";s:11:\"7.x-1.0-rc2\";s:3:\"tag\";s:11:\"7.x-1.0-rc2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:63:\"https://www.drupal.org/project/field_group/releases/7.x-1.0-rc2\";s:13:\"download_link\";s:68:\"https://ftp.drupal.org/files/projects/field_group-7.x-1.0-rc2.tar.gz\";s:4:\"date\";s:10:\"1300283167\";s:6:\"mdhash\";s:32:\"959768b52b8d4c04be0e8f8e93f4af1b\";s:8:\"filesize\";s:5:\"32537\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:11:\"7.x-1.0-rc1\";a:15:{s:4:\"name\";s:23:\"field_group 7.x-1.0-rc1\";s:7:\"version\";s:11:\"7.x-1.0-rc1\";s:3:\"tag\";s:11:\"7.x-1.0-rc1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:63:\"https://www.drupal.org/project/field_group/releases/7.x-1.0-rc1\";s:13:\"download_link\";s:68:\"https://ftp.drupal.org/files/projects/field_group-7.x-1.0-rc1.tar.gz\";s:4:\"date\";s:10:\"1295392936\";s:6:\"mdhash\";s:32:\"aaa22e6444d2377e9673e5cfd6f21095\";s:8:\"filesize\";s:5:\"30414\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:11:\"7.x-2.x-dev\";a:14:{s:4:\"name\";s:23:\"field_group 7.x-2.x-dev\";s:7:\"version\";s:11:\"7.x-2.x-dev\";s:3:\"tag\";s:7:\"7.x-2.x\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:63:\"https://www.drupal.org/project/field_group/releases/7.x-2.x-dev\";s:13:\"download_link\";s:68:\"https://ftp.drupal.org/files/projects/field_group-7.x-2.x-dev.tar.gz\";s:4:\"date\";s:10:\"1380578862\";s:6:\"mdhash\";s:32:\"3ff6c75931a1668be98876378b7c2ebf\";s:8:\"filesize\";s:5:\"41104\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:12:\"New features\";}}s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";}s:11:\"7.x-1.x-dev\";a:14:{s:4:\"name\";s:23:\"field_group 7.x-1.x-dev\";s:7:\"version\";s:11:\"7.x-1.x-dev\";s:3:\"tag\";s:7:\"7.x-1.x\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:63:\"https://www.drupal.org/project/field_group/releases/7.x-1.x-dev\";s:13:\"download_link\";s:68:\"https://ftp.drupal.org/files/projects/field_group-7.x-1.x-dev.tar.gz\";s:4:\"date\";s:10:\"1509751984\";s:6:\"mdhash\";s:32:\"511fd177b8bb37b9c8011162ea3d8017\";s:8:\"filesize\";s:5:\"52572\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}}}',1512706729,1512620327,1),('available_releases::fivestar','a:11:{s:5:\"title\";s:8:\"Fivestar\";s:10:\"short_name\";s:8:\"fivestar\";s:4:\"type\";s:14:\"project_module\";s:11:\"api_version\";s:3:\"7.x\";s:17:\"recommended_major\";s:1:\"2\";s:16:\"supported_majors\";s:1:\"2\";s:13:\"default_major\";s:1:\"2\";s:14:\"project_status\";s:9:\"published\";s:4:\"link\";s:39:\"https://www.drupal.org/project/fivestar\";s:5:\"terms\";s:0:\"\";s:8:\"releases\";a:10:{s:7:\"7.x-2.2\";a:14:{s:4:\"name\";s:16:\"fivestar 7.x-2.2\";s:7:\"version\";s:7:\"7.x-2.2\";s:3:\"tag\";s:7:\"7.x-2.2\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/fivestar/releases/7.x-2.2\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/fivestar-7.x-2.2.tar.gz\";s:4:\"date\";s:10:\"1461406441\";s:6:\"mdhash\";s:32:\"ed5cb540db0944a47d7f09657b39d7e4\";s:8:\"filesize\";s:6:\"226248\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-2.1\";a:14:{s:4:\"name\";s:16:\"fivestar 7.x-2.1\";s:7:\"version\";s:7:\"7.x-2.1\";s:3:\"tag\";s:7:\"7.x-2.1\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/fivestar/releases/7.x-2.1\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/fivestar-7.x-2.1.tar.gz\";s:4:\"date\";s:10:\"1395087832\";s:6:\"mdhash\";s:32:\"ab74125c5ff622a55d3c029ad91c82ff\";s:8:\"filesize\";s:6:\"226676\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:11:\"7.x-2.0-rc3\";a:15:{s:4:\"name\";s:20:\"fivestar 7.x-2.0-rc3\";s:7:\"version\";s:11:\"7.x-2.0-rc3\";s:3:\"tag\";s:11:\"7.x-2.0-rc3\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:60:\"https://www.drupal.org/project/fivestar/releases/7.x-2.0-rc3\";s:13:\"download_link\";s:65:\"https://ftp.drupal.org/files/projects/fivestar-7.x-2.0-rc3.tar.gz\";s:4:\"date\";s:10:\"1394544996\";s:6:\"mdhash\";s:32:\"7ba894cefa67ccd33d87bfb715f9a0f1\";s:8:\"filesize\";s:6:\"226676\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:11:\"7.x-2.0-rc2\";a:15:{s:4:\"name\";s:20:\"fivestar 7.x-2.0-rc2\";s:7:\"version\";s:11:\"7.x-2.0-rc2\";s:3:\"tag\";s:11:\"7.x-2.0-rc2\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:60:\"https://www.drupal.org/project/fivestar/releases/7.x-2.0-rc2\";s:13:\"download_link\";s:65:\"https://ftp.drupal.org/files/projects/fivestar-7.x-2.0-rc2.tar.gz\";s:4:\"date\";s:10:\"1394386705\";s:6:\"mdhash\";s:32:\"ddaac2b3a4c178300ede150b9325e440\";s:8:\"filesize\";s:6:\"227037\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:11:\"7.x-2.0-rc1\";a:15:{s:4:\"name\";s:20:\"fivestar 7.x-2.0-rc1\";s:7:\"version\";s:11:\"7.x-2.0-rc1\";s:3:\"tag\";s:11:\"7.x-2.0-rc1\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:60:\"https://www.drupal.org/project/fivestar/releases/7.x-2.0-rc1\";s:13:\"download_link\";s:65:\"https://ftp.drupal.org/files/projects/fivestar-7.x-2.0-rc1.tar.gz\";s:4:\"date\";s:10:\"1393790305\";s:6:\"mdhash\";s:32:\"82689969e410ebf763a7e4a39b6b7631\";s:8:\"filesize\";s:6:\"226649\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:13:\"7.x-2.0-beta1\";a:15:{s:4:\"name\";s:22:\"fivestar 7.x-2.0-beta1\";s:7:\"version\";s:13:\"7.x-2.0-beta1\";s:3:\"tag\";s:13:\"7.x-2.0-beta1\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/fivestar/releases/7.x-2.0-beta1\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/fivestar-7.x-2.0-beta1.tar.gz\";s:4:\"date\";s:10:\"1392552805\";s:6:\"mdhash\";s:32:\"3ba9ebc0430d4f95564418b584b4c763\";s:8:\"filesize\";s:6:\"225330\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:14:\"7.x-2.0-alpha3\";a:15:{s:4:\"name\";s:23:\"fivestar 7.x-2.0-alpha3\";s:7:\"version\";s:14:\"7.x-2.0-alpha3\";s:3:\"tag\";s:14:\"7.x-2.0-alpha3\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:63:\"https://www.drupal.org/project/fivestar/releases/7.x-2.0-alpha3\";s:13:\"download_link\";s:68:\"https://ftp.drupal.org/files/projects/fivestar-7.x-2.0-alpha3.tar.gz\";s:4:\"date\";s:10:\"1391276005\";s:6:\"mdhash\";s:32:\"1571a761135705581c3f1f33a3bcb293\";s:8:\"filesize\";s:6:\"223936\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:14:\"7.x-2.0-alpha2\";a:15:{s:4:\"name\";s:23:\"fivestar 7.x-2.0-alpha2\";s:7:\"version\";s:14:\"7.x-2.0-alpha2\";s:3:\"tag\";s:14:\"7.x-2.0-alpha2\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:63:\"https://www.drupal.org/project/fivestar/releases/7.x-2.0-alpha2\";s:13:\"download_link\";s:68:\"https://ftp.drupal.org/files/projects/fivestar-7.x-2.0-alpha2.tar.gz\";s:4:\"date\";s:10:\"1332954347\";s:6:\"mdhash\";s:32:\"acebd71efc5234dacbf256d98b68c346\";s:8:\"filesize\";s:6:\"221015\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:14:\"7.x-2.0-alpha1\";a:15:{s:4:\"name\";s:23:\"fivestar 7.x-2.0-alpha1\";s:7:\"version\";s:14:\"7.x-2.0-alpha1\";s:3:\"tag\";s:14:\"7.x-2.0-alpha1\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:63:\"https://www.drupal.org/project/fivestar/releases/7.x-2.0-alpha1\";s:13:\"download_link\";s:68:\"https://ftp.drupal.org/files/projects/fivestar-7.x-2.0-alpha1.tar.gz\";s:4:\"date\";s:10:\"1316447804\";s:6:\"mdhash\";s:32:\"e4fddd9e83b1b5ec8c8f7032f52e53e2\";s:8:\"filesize\";s:6:\"193249\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:11:\"7.x-2.x-dev\";a:14:{s:4:\"name\";s:20:\"fivestar 7.x-2.x-dev\";s:7:\"version\";s:11:\"7.x-2.x-dev\";s:3:\"tag\";s:7:\"7.x-2.x\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:60:\"https://www.drupal.org/project/fivestar/releases/7.x-2.x-dev\";s:13:\"download_link\";s:65:\"https://ftp.drupal.org/files/projects/fivestar-7.x-2.x-dev.tar.gz\";s:4:\"date\";s:10:\"1498452248\";s:6:\"mdhash\";s:32:\"f492061ef8f990fad91471ff53c4ae57\";s:8:\"filesize\";s:6:\"228459\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";}}}',1512706730,1512620327,1),('available_releases::flexslider','a:11:{s:5:\"title\";s:11:\"Flex Slider\";s:10:\"short_name\";s:10:\"flexslider\";s:4:\"type\";s:14:\"project_module\";s:11:\"api_version\";s:3:\"7.x\";s:17:\"recommended_major\";s:1:\"2\";s:16:\"supported_majors\";s:3:\"1,2\";s:13:\"default_major\";s:1:\"1\";s:14:\"project_status\";s:9:\"published\";s:4:\"link\";s:41:\"https://www.drupal.org/project/flexslider\";s:5:\"terms\";s:0:\"\";s:8:\"releases\";a:12:{s:11:\"7.x-2.0-rc2\";a:15:{s:4:\"name\";s:22:\"flexslider 7.x-2.0-rc2\";s:7:\"version\";s:11:\"7.x-2.0-rc2\";s:3:\"tag\";s:11:\"7.x-2.0-rc2\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/flexslider/releases/7.x-2.0-rc2\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/flexslider-7.x-2.0-rc2.tar.gz\";s:4:\"date\";s:10:\"1487028483\";s:6:\"mdhash\";s:32:\"6bbfff91fc66bef36e8ef42323a33a59\";s:8:\"filesize\";s:7:\"3976547\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:54:\"Project has not opted into security advisory coverage!\";}s:11:\"7.x-2.0-rc1\";a:15:{s:4:\"name\";s:22:\"flexslider 7.x-2.0-rc1\";s:7:\"version\";s:11:\"7.x-2.0-rc1\";s:3:\"tag\";s:11:\"7.x-2.0-rc1\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/flexslider/releases/7.x-2.0-rc1\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/flexslider-7.x-2.0-rc1.tar.gz\";s:4:\"date\";s:10:\"1438285139\";s:6:\"mdhash\";s:32:\"c637c53352d34961d6413c8ac04ebf87\";s:8:\"filesize\";s:7:\"3977507\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:54:\"Project has not opted into security advisory coverage!\";}s:14:\"7.x-2.0-alpha3\";a:15:{s:4:\"name\";s:25:\"flexslider 7.x-2.0-alpha3\";s:7:\"version\";s:14:\"7.x-2.0-alpha3\";s:3:\"tag\";s:14:\"7.x-2.0-alpha3\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:65:\"https://www.drupal.org/project/flexslider/releases/7.x-2.0-alpha3\";s:13:\"download_link\";s:70:\"https://ftp.drupal.org/files/projects/flexslider-7.x-2.0-alpha3.tar.gz\";s:4:\"date\";s:10:\"1378663044\";s:6:\"mdhash\";s:32:\"a8b4f9b9740ab9d41a9043b1ea7361aa\";s:8:\"filesize\";s:7:\"3977501\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:54:\"Project has not opted into security advisory coverage!\";}s:14:\"7.x-2.0-alpha2\";a:15:{s:4:\"name\";s:25:\"flexslider 7.x-2.0-alpha2\";s:7:\"version\";s:14:\"7.x-2.0-alpha2\";s:3:\"tag\";s:14:\"7.x-2.0-alpha2\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:65:\"https://www.drupal.org/project/flexslider/releases/7.x-2.0-alpha2\";s:13:\"download_link\";s:70:\"https://ftp.drupal.org/files/projects/flexslider-7.x-2.0-alpha2.tar.gz\";s:4:\"date\";s:10:\"1376925141\";s:6:\"mdhash\";s:32:\"8f92257ca4e8baf7a6743a4bcf8738da\";s:8:\"filesize\";s:7:\"3975729\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:54:\"Project has not opted into security advisory coverage!\";}s:14:\"7.x-2.0-alpha1\";a:15:{s:4:\"name\";s:25:\"flexslider 7.x-2.0-alpha1\";s:7:\"version\";s:14:\"7.x-2.0-alpha1\";s:3:\"tag\";s:14:\"7.x-2.0-alpha1\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:65:\"https://www.drupal.org/project/flexslider/releases/7.x-2.0-alpha1\";s:13:\"download_link\";s:70:\"https://ftp.drupal.org/files/projects/flexslider-7.x-2.0-alpha1.tar.gz\";s:4:\"date\";s:10:\"1362783811\";s:6:\"mdhash\";s:32:\"cb88bc862e89af0980839962c4f90a78\";s:8:\"filesize\";s:7:\"8366543\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:54:\"Project has not opted into security advisory coverage!\";}s:11:\"7.x-1.0-rc3\";a:15:{s:4:\"name\";s:22:\"flexslider 7.x-1.0-rc3\";s:7:\"version\";s:11:\"7.x-1.0-rc3\";s:3:\"tag\";s:11:\"7.x-1.0-rc3\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/flexslider/releases/7.x-1.0-rc3\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/flexslider-7.x-1.0-rc3.tar.gz\";s:4:\"date\";s:10:\"1337289957\";s:6:\"mdhash\";s:32:\"e10d32bcb407d080319d1c85e93cb3f5\";s:8:\"filesize\";s:5:\"26069\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:54:\"Project has not opted into security advisory coverage!\";}s:11:\"7.x-1.0-rc2\";a:15:{s:4:\"name\";s:22:\"flexslider 7.x-1.0-rc2\";s:7:\"version\";s:11:\"7.x-1.0-rc2\";s:3:\"tag\";s:11:\"7.x-1.0-rc2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/flexslider/releases/7.x-1.0-rc2\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/flexslider-7.x-1.0-rc2.tar.gz\";s:4:\"date\";s:10:\"1333369556\";s:6:\"mdhash\";s:32:\"e5b228317528e962c633a508a56fcab7\";s:8:\"filesize\";s:5:\"25910\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:54:\"Project has not opted into security advisory coverage!\";}s:11:\"7.x-1.0-rc1\";a:15:{s:4:\"name\";s:22:\"flexslider 7.x-1.0-rc1\";s:7:\"version\";s:11:\"7.x-1.0-rc1\";s:3:\"tag\";s:11:\"7.x-1.0-rc1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/flexslider/releases/7.x-1.0-rc1\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/flexslider-7.x-1.0-rc1.tar.gz\";s:4:\"date\";s:10:\"1333216546\";s:6:\"mdhash\";s:32:\"cdf482ecf2684c4d63f51242ec815a7c\";s:8:\"filesize\";s:5:\"25930\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:54:\"Project has not opted into security advisory coverage!\";}s:13:\"7.x-1.0-beta2\";a:15:{s:4:\"name\";s:24:\"flexslider 7.x-1.0-beta2\";s:7:\"version\";s:13:\"7.x-1.0-beta2\";s:3:\"tag\";s:13:\"7.x-1.0-beta2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:64:\"https://www.drupal.org/project/flexslider/releases/7.x-1.0-beta2\";s:13:\"download_link\";s:69:\"https://ftp.drupal.org/files/projects/flexslider-7.x-1.0-beta2.tar.gz\";s:4:\"date\";s:10:\"1332764150\";s:6:\"mdhash\";s:32:\"4fe1003a1fcfb8d088cc6e402c2bc5bb\";s:8:\"filesize\";s:5:\"26001\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:54:\"Project has not opted into security advisory coverage!\";}s:13:\"7.x-1.0-beta1\";a:15:{s:4:\"name\";s:24:\"flexslider 7.x-1.0-beta1\";s:7:\"version\";s:13:\"7.x-1.0-beta1\";s:3:\"tag\";s:13:\"7.x-1.0-beta1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:64:\"https://www.drupal.org/project/flexslider/releases/7.x-1.0-beta1\";s:13:\"download_link\";s:69:\"https://ftp.drupal.org/files/projects/flexslider-7.x-1.0-beta1.tar.gz\";s:4:\"date\";s:10:\"1332702357\";s:6:\"mdhash\";s:32:\"058b01b76f42dcf9c075036036c4b62d\";s:8:\"filesize\";s:5:\"25855\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:54:\"Project has not opted into security advisory coverage!\";}s:11:\"7.x-2.x-dev\";a:14:{s:4:\"name\";s:22:\"flexslider 7.x-2.x-dev\";s:7:\"version\";s:11:\"7.x-2.x-dev\";s:3:\"tag\";s:7:\"7.x-2.x\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/flexslider/releases/7.x-2.x-dev\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/flexslider-7.x-2.x-dev.tar.gz\";s:4:\"date\";s:10:\"1487024583\";s:6:\"mdhash\";s:32:\"191e55868a7a3a0c9f2f6024b93ae83f\";s:8:\"filesize\";s:7:\"3976557\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:54:\"Project has not opted into security advisory coverage!\";s:5:\"terms\";a:0:{}}s:11:\"7.x-1.x-dev\";a:14:{s:4:\"name\";s:22:\"flexslider 7.x-1.x-dev\";s:7:\"version\";s:11:\"7.x-1.x-dev\";s:3:\"tag\";s:7:\"7.x-1.x\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/flexslider/releases/7.x-1.x-dev\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/flexslider-7.x-1.x-dev.tar.gz\";s:4:\"date\";s:10:\"1446839939\";s:6:\"mdhash\";s:32:\"ed882b54ea61dc7ad370c2f3ea890e6b\";s:8:\"filesize\";s:5:\"26679\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:54:\"Project has not opted into security advisory coverage!\";s:5:\"terms\";a:0:{}}}}',1512706730,1512620327,1),('available_releases::i18n','a:11:{s:5:\"title\";s:20:\"Internationalization\";s:10:\"short_name\";s:4:\"i18n\";s:4:\"type\";s:14:\"project_module\";s:11:\"api_version\";s:3:\"7.x\";s:17:\"recommended_major\";s:1:\"1\";s:16:\"supported_majors\";s:1:\"1\";s:13:\"default_major\";s:1:\"1\";s:14:\"project_status\";s:9:\"published\";s:4:\"link\";s:35:\"https://www.drupal.org/project/i18n\";s:5:\"terms\";s:0:\"\";s:8:\"releases\";a:37:{s:8:\"7.x-1.22\";a:14:{s:4:\"name\";s:13:\"i18n 7.x-1.22\";s:7:\"version\";s:8:\"7.x-1.22\";s:3:\"tag\";s:8:\"7.x-1.22\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:2:\"22\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:53:\"https://www.drupal.org/project/i18n/releases/7.x-1.22\";s:13:\"download_link\";s:58:\"https://ftp.drupal.org/files/projects/i18n-7.x-1.22.tar.gz\";s:4:\"date\";s:10:\"1511689985\";s:6:\"mdhash\";s:32:\"7c3abc1bb63a67acc75b77c020c739ea\";s:8:\"filesize\";s:6:\"159112\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:8:\"7.x-1.20\";a:14:{s:4:\"name\";s:13:\"i18n 7.x-1.20\";s:7:\"version\";s:8:\"7.x-1.20\";s:3:\"tag\";s:8:\"7.x-1.20\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:2:\"20\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:53:\"https://www.drupal.org/project/i18n/releases/7.x-1.20\";s:13:\"download_link\";s:58:\"https://ftp.drupal.org/files/projects/i18n-7.x-1.20.tar.gz\";s:4:\"date\";s:10:\"1511587385\";s:6:\"mdhash\";s:32:\"3d66579d2d9be345ff1c88f3d9808b82\";s:8:\"filesize\";s:6:\"159100\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:8:\"7.x-1.19\";a:14:{s:4:\"name\";s:13:\"i18n 7.x-1.19\";s:7:\"version\";s:8:\"7.x-1.19\";s:3:\"tag\";s:8:\"7.x-1.19\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:2:\"19\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:53:\"https://www.drupal.org/project/i18n/releases/7.x-1.19\";s:13:\"download_link\";s:58:\"https://ftp.drupal.org/files/projects/i18n-7.x-1.19.tar.gz\";s:4:\"date\";s:10:\"1511586484\";s:6:\"mdhash\";s:32:\"e4c0c7dd8a7725280470f6fc101a64e7\";s:8:\"filesize\";s:6:\"159082\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:8:\"7.x-1.18\";a:14:{s:4:\"name\";s:13:\"i18n 7.x-1.18\";s:7:\"version\";s:8:\"7.x-1.18\";s:3:\"tag\";s:8:\"7.x-1.18\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:2:\"18\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:53:\"https://www.drupal.org/project/i18n/releases/7.x-1.18\";s:13:\"download_link\";s:58:\"https://ftp.drupal.org/files/projects/i18n-7.x-1.18.tar.gz\";s:4:\"date\";s:10:\"1497704042\";s:6:\"mdhash\";s:32:\"e497647e0f4f8e53bfcfc3ff7cd3b5d7\";s:8:\"filesize\";s:6:\"158805\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:8:\"7.x-1.17\";a:14:{s:4:\"name\";s:13:\"i18n 7.x-1.17\";s:7:\"version\";s:8:\"7.x-1.17\";s:3:\"tag\";s:8:\"7.x-1.17\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:2:\"17\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:53:\"https://www.drupal.org/project/i18n/releases/7.x-1.17\";s:13:\"download_link\";s:58:\"https://ftp.drupal.org/files/projects/i18n-7.x-1.17.tar.gz\";s:4:\"date\";s:10:\"1492537742\";s:6:\"mdhash\";s:32:\"82b1b4a5734383ebfa3e19dbafd12cd7\";s:8:\"filesize\";s:6:\"158762\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:8:\"7.x-1.16\";a:14:{s:4:\"name\";s:13:\"i18n 7.x-1.16\";s:7:\"version\";s:8:\"7.x-1.16\";s:3:\"tag\";s:8:\"7.x-1.16\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:2:\"16\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:53:\"https://www.drupal.org/project/i18n/releases/7.x-1.16\";s:13:\"download_link\";s:58:\"https://ftp.drupal.org/files/projects/i18n-7.x-1.16.tar.gz\";s:4:\"date\";s:10:\"1492535643\";s:6:\"mdhash\";s:32:\"b322c08e58b0116332617faa8d38cba7\";s:8:\"filesize\";s:6:\"158373\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:8:\"7.x-1.15\";a:14:{s:4:\"name\";s:13:\"i18n 7.x-1.15\";s:7:\"version\";s:8:\"7.x-1.15\";s:3:\"tag\";s:8:\"7.x-1.15\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:2:\"15\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:53:\"https://www.drupal.org/project/i18n/releases/7.x-1.15\";s:13:\"download_link\";s:58:\"https://ftp.drupal.org/files/projects/i18n-7.x-1.15.tar.gz\";s:4:\"date\";s:10:\"1485834788\";s:6:\"mdhash\";s:32:\"43ad0d8abda83139ab231add02e746a3\";s:8:\"filesize\";s:6:\"157783\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:8:\"7.x-1.14\";a:14:{s:4:\"name\";s:13:\"i18n 7.x-1.14\";s:7:\"version\";s:8:\"7.x-1.14\";s:3:\"tag\";s:8:\"7.x-1.14\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:2:\"14\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:53:\"https://www.drupal.org/project/i18n/releases/7.x-1.14\";s:13:\"download_link\";s:58:\"https://ftp.drupal.org/files/projects/i18n-7.x-1.14.tar.gz\";s:4:\"date\";s:10:\"1477154940\";s:6:\"mdhash\";s:32:\"51a67e9543afc1b901e7b34f41ed46f5\";s:8:\"filesize\";s:6:\"147525\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:8:\"7.x-1.13\";a:14:{s:4:\"name\";s:13:\"i18n 7.x-1.13\";s:7:\"version\";s:8:\"7.x-1.13\";s:3:\"tag\";s:8:\"7.x-1.13\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:2:\"13\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:53:\"https://www.drupal.org/project/i18n/releases/7.x-1.13\";s:13:\"download_link\";s:58:\"https://ftp.drupal.org/files/projects/i18n-7.x-1.13.tar.gz\";s:4:\"date\";s:10:\"1430999882\";s:6:\"mdhash\";s:32:\"9ba72bcc87f3eed9bef6f2eb38ae474d\";s:8:\"filesize\";s:6:\"146305\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:8:\"7.x-1.12\";a:14:{s:4:\"name\";s:13:\"i18n 7.x-1.12\";s:7:\"version\";s:8:\"7.x-1.12\";s:3:\"tag\";s:8:\"7.x-1.12\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:2:\"12\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:53:\"https://www.drupal.org/project/i18n/releases/7.x-1.12\";s:13:\"download_link\";s:58:\"https://ftp.drupal.org/files/projects/i18n-7.x-1.12.tar.gz\";s:4:\"date\";s:10:\"1422286980\";s:6:\"mdhash\";s:32:\"c1d7460ef3b7ee18b0e7788d98ba91be\";s:8:\"filesize\";s:6:\"145997\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:8:\"7.x-1.11\";a:14:{s:4:\"name\";s:13:\"i18n 7.x-1.11\";s:7:\"version\";s:8:\"7.x-1.11\";s:3:\"tag\";s:8:\"7.x-1.11\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:2:\"11\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:53:\"https://www.drupal.org/project/i18n/releases/7.x-1.11\";s:13:\"download_link\";s:58:\"https://ftp.drupal.org/files/projects/i18n-7.x-1.11.tar.gz\";s:4:\"date\";s:10:\"1397666962\";s:6:\"mdhash\";s:32:\"b7949e640740e34be4be15a22281c5cf\";s:8:\"filesize\";s:6:\"144606\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:15:\"Security update\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:8:\"7.x-1.10\";a:14:{s:4:\"name\";s:13:\"i18n 7.x-1.10\";s:7:\"version\";s:8:\"7.x-1.10\";s:3:\"tag\";s:8:\"7.x-1.10\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:2:\"10\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:53:\"https://www.drupal.org/project/i18n/releases/7.x-1.10\";s:13:\"download_link\";s:58:\"https://ftp.drupal.org/files/projects/i18n-7.x-1.10.tar.gz\";s:4:\"date\";s:10:\"1377069697\";s:6:\"mdhash\";s:32:\"8ade3f3fc2e740ee3c5eae949e48eedf\";s:8:\"filesize\";s:6:\"142894\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-1.9\";a:14:{s:4:\"name\";s:12:\"i18n 7.x-1.9\";s:7:\"version\";s:7:\"7.x-1.9\";s:3:\"tag\";s:7:\"7.x-1.9\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"9\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/i18n/releases/7.x-1.9\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/i18n-7.x-1.9.tar.gz\";s:4:\"date\";s:10:\"1373385355\";s:6:\"mdhash\";s:32:\"eb3b820b05203f790cc4e42ba109ce06\";s:8:\"filesize\";s:6:\"142609\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-1.8\";a:14:{s:4:\"name\";s:12:\"i18n 7.x-1.8\";s:7:\"version\";s:7:\"7.x-1.8\";s:3:\"tag\";s:7:\"7.x-1.8\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"8\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/i18n/releases/7.x-1.8\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/i18n-7.x-1.8.tar.gz\";s:4:\"date\";s:10:\"1358075002\";s:6:\"mdhash\";s:32:\"6b2d3d4df7ebe6bc6392699c4c95b5b4\";s:8:\"filesize\";s:6:\"140957\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-1.7\";a:14:{s:4:\"name\";s:12:\"i18n 7.x-1.7\";s:7:\"version\";s:7:\"7.x-1.7\";s:3:\"tag\";s:7:\"7.x-1.7\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"7\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/i18n/releases/7.x-1.7\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/i18n-7.x-1.7.tar.gz\";s:4:\"date\";s:10:\"1341236501\";s:6:\"mdhash\";s:32:\"14a8e0cc7596ed9744b2e2d62f67d6f2\";s:8:\"filesize\";s:6:\"138498\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";s:5:\"terms\";a:0:{}}s:7:\"7.x-1.6\";a:14:{s:4:\"name\";s:12:\"i18n 7.x-1.6\";s:7:\"version\";s:7:\"7.x-1.6\";s:3:\"tag\";s:7:\"7.x-1.6\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"6\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/i18n/releases/7.x-1.6\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/i18n-7.x-1.6.tar.gz\";s:4:\"date\";s:10:\"1340225780\";s:6:\"mdhash\";s:32:\"0eeb8b2d91ecc9ce1e1d6df6614f5350\";s:8:\"filesize\";s:6:\"138494\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-1.5\";a:14:{s:4:\"name\";s:12:\"i18n 7.x-1.5\";s:7:\"version\";s:7:\"7.x-1.5\";s:3:\"tag\";s:7:\"7.x-1.5\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"5\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/i18n/releases/7.x-1.5\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/i18n-7.x-1.5.tar.gz\";s:4:\"date\";s:10:\"1335000084\";s:6:\"mdhash\";s:32:\"754960703013ecbfe8d9fdb06f16df58\";s:8:\"filesize\";s:6:\"138516\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-1.4\";a:14:{s:4:\"name\";s:12:\"i18n 7.x-1.4\";s:7:\"version\";s:7:\"7.x-1.4\";s:3:\"tag\";s:7:\"7.x-1.4\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/i18n/releases/7.x-1.4\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/i18n-7.x-1.4.tar.gz\";s:4:\"date\";s:10:\"1328469343\";s:6:\"mdhash\";s:32:\"11b5c3a01c65cb434a2398685923b5f2\";s:8:\"filesize\";s:6:\"134767\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-1.3\";a:14:{s:4:\"name\";s:12:\"i18n 7.x-1.3\";s:7:\"version\";s:7:\"7.x-1.3\";s:3:\"tag\";s:7:\"7.x-1.3\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/i18n/releases/7.x-1.3\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/i18n-7.x-1.3.tar.gz\";s:4:\"date\";s:10:\"1326276941\";s:6:\"mdhash\";s:32:\"c1a688a15bc7183d7c2d0a1260822911\";s:8:\"filesize\";s:6:\"133142\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-1.2\";a:14:{s:4:\"name\";s:12:\"i18n 7.x-1.2\";s:7:\"version\";s:7:\"7.x-1.2\";s:3:\"tag\";s:7:\"7.x-1.2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/i18n/releases/7.x-1.2\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/i18n-7.x-1.2.tar.gz\";s:4:\"date\";s:10:\"1322474442\";s:6:\"mdhash\";s:32:\"b25c24e442bae244ffaf028a9f085343\";s:8:\"filesize\";s:6:\"129943\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-1.1\";a:14:{s:4:\"name\";s:12:\"i18n 7.x-1.1\";s:7:\"version\";s:7:\"7.x-1.1\";s:3:\"tag\";s:7:\"7.x-1.1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/i18n/releases/7.x-1.1\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/i18n-7.x-1.1.tar.gz\";s:4:\"date\";s:10:\"1318100203\";s:6:\"mdhash\";s:32:\"45c6464b8128732dd3cbf93d949b46c3\";s:8:\"filesize\";s:6:\"129532\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-1.0\";a:14:{s:4:\"name\";s:12:\"i18n 7.x-1.0\";s:7:\"version\";s:7:\"7.x-1.0\";s:3:\"tag\";s:7:\"7.x-1.0\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/i18n/releases/7.x-1.0\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/i18n-7.x-1.0.tar.gz\";s:4:\"date\";s:10:\"1313936520\";s:6:\"mdhash\";s:32:\"ddc6efedc7e412c13adba4bd3444dd7f\";s:8:\"filesize\";s:6:\"126819\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";s:5:\"terms\";a:0:{}}s:11:\"7.x-1.0-rc3\";a:15:{s:4:\"name\";s:16:\"i18n 7.x-1.0-rc3\";s:7:\"version\";s:11:\"7.x-1.0-rc3\";s:3:\"tag\";s:11:\"7.x-1.0-rc3\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/i18n/releases/7.x-1.0-rc3\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/i18n-7.x-1.0-rc3.tar.gz\";s:4:\"date\";s:10:\"1312832516\";s:6:\"mdhash\";s:32:\"f506797c2f66c1d3621adcabd6689fb5\";s:8:\"filesize\";s:6:\"126457\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:11:\"7.x-1.0-rc2\";a:15:{s:4:\"name\";s:16:\"i18n 7.x-1.0-rc2\";s:7:\"version\";s:11:\"7.x-1.0-rc2\";s:3:\"tag\";s:11:\"7.x-1.0-rc2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/i18n/releases/7.x-1.0-rc2\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/i18n-7.x-1.0-rc2.tar.gz\";s:4:\"date\";s:10:\"1311532319\";s:6:\"mdhash\";s:32:\"732737b342324de2ed2c5e1b9e77c24c\";s:8:\"filesize\";s:6:\"125375\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:11:\"7.x-1.0-rc1\";a:15:{s:4:\"name\";s:16:\"i18n 7.x-1.0-rc1\";s:7:\"version\";s:11:\"7.x-1.0-rc1\";s:3:\"tag\";s:11:\"7.x-1.0-rc1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/i18n/releases/7.x-1.0-rc1\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/i18n-7.x-1.0-rc1.tar.gz\";s:4:\"date\";s:10:\"1310466117\";s:6:\"mdhash\";s:32:\"85ccc65b6e54338fa849591cfa2a6740\";s:8:\"filesize\";s:6:\"124377\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:13:\"7.x-1.0-beta8\";a:15:{s:4:\"name\";s:18:\"i18n 7.x-1.0-beta8\";s:7:\"version\";s:13:\"7.x-1.0-beta8\";s:3:\"tag\";s:13:\"7.x-1.0-beta8\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta8\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:58:\"https://www.drupal.org/project/i18n/releases/7.x-1.0-beta8\";s:13:\"download_link\";s:63:\"https://ftp.drupal.org/files/projects/i18n-7.x-1.0-beta8.tar.gz\";s:4:\"date\";s:10:\"1309858916\";s:6:\"mdhash\";s:32:\"8b891fef746bd5adc216ce158e04e072\";s:8:\"filesize\";s:6:\"122698\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"7.x-1.0-beta7\";a:15:{s:4:\"name\";s:18:\"i18n 7.x-1.0-beta7\";s:7:\"version\";s:13:\"7.x-1.0-beta7\";s:3:\"tag\";s:13:\"7.x-1.0-beta7\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta7\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:58:\"https://www.drupal.org/project/i18n/releases/7.x-1.0-beta7\";s:13:\"download_link\";s:63:\"https://ftp.drupal.org/files/projects/i18n-7.x-1.0-beta7.tar.gz\";s:4:\"date\";s:10:\"1307806316\";s:6:\"mdhash\";s:32:\"89027827dafff6d87818c5206774dd65\";s:8:\"filesize\";s:6:\"118216\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"7.x-1.0-beta6\";a:15:{s:4:\"name\";s:18:\"i18n 7.x-1.0-beta6\";s:7:\"version\";s:13:\"7.x-1.0-beta6\";s:3:\"tag\";s:13:\"7.x-1.0-beta6\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta6\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:58:\"https://www.drupal.org/project/i18n/releases/7.x-1.0-beta6\";s:13:\"download_link\";s:63:\"https://ftp.drupal.org/files/projects/i18n-7.x-1.0-beta6.tar.gz\";s:4:\"date\";s:10:\"1306227416\";s:6:\"mdhash\";s:32:\"2180948e651d4d528853e2a732401149\";s:8:\"filesize\";s:6:\"112115\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"7.x-1.0-beta5\";a:15:{s:4:\"name\";s:18:\"i18n 7.x-1.0-beta5\";s:7:\"version\";s:13:\"7.x-1.0-beta5\";s:3:\"tag\";s:13:\"7.x-1.0-beta5\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta5\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:58:\"https://www.drupal.org/project/i18n/releases/7.x-1.0-beta5\";s:13:\"download_link\";s:63:\"https://ftp.drupal.org/files/projects/i18n-7.x-1.0-beta5.tar.gz\";s:4:\"date\";s:10:\"1304158615\";s:6:\"mdhash\";s:32:\"8bcbe4378b330c4d8b6ad521ab10d055\";s:8:\"filesize\";s:5:\"93396\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"7.x-1.0-beta4\";a:15:{s:4:\"name\";s:18:\"i18n 7.x-1.0-beta4\";s:7:\"version\";s:13:\"7.x-1.0-beta4\";s:3:\"tag\";s:13:\"7.x-1.0-beta4\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:58:\"https://www.drupal.org/project/i18n/releases/7.x-1.0-beta4\";s:13:\"download_link\";s:63:\"https://ftp.drupal.org/files/projects/i18n-7.x-1.0-beta4.tar.gz\";s:4:\"date\";s:10:\"1301683568\";s:6:\"mdhash\";s:32:\"4649fcd7e3be0a36cb3c3a499d528600\";s:8:\"filesize\";s:5:\"93145\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"7.x-1.0-beta3\";a:15:{s:4:\"name\";s:18:\"i18n 7.x-1.0-beta3\";s:7:\"version\";s:13:\"7.x-1.0-beta3\";s:3:\"tag\";s:13:\"7.x-1.0-beta3\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:58:\"https://www.drupal.org/project/i18n/releases/7.x-1.0-beta3\";s:13:\"download_link\";s:63:\"https://ftp.drupal.org/files/projects/i18n-7.x-1.0-beta3.tar.gz\";s:4:\"date\";s:10:\"1300145467\";s:6:\"mdhash\";s:32:\"af324f4684f56fdfc9728a5755a4ef67\";s:8:\"filesize\";s:5:\"97481\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"7.x-1.0-beta2\";a:15:{s:4:\"name\";s:18:\"i18n 7.x-1.0-beta2\";s:7:\"version\";s:13:\"7.x-1.0-beta2\";s:3:\"tag\";s:13:\"7.x-1.0-beta2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:58:\"https://www.drupal.org/project/i18n/releases/7.x-1.0-beta2\";s:13:\"download_link\";s:63:\"https://ftp.drupal.org/files/projects/i18n-7.x-1.0-beta2.tar.gz\";s:4:\"date\";s:10:\"1298892072\";s:6:\"mdhash\";s:32:\"108d90910b6aae8f5cf17433838ae26d\";s:8:\"filesize\";s:5:\"97012\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"7.x-1.0-beta1\";a:15:{s:4:\"name\";s:18:\"i18n 7.x-1.0-beta1\";s:7:\"version\";s:13:\"7.x-1.0-beta1\";s:3:\"tag\";s:13:\"7.x-1.0-beta1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:58:\"https://www.drupal.org/project/i18n/releases/7.x-1.0-beta1\";s:13:\"download_link\";s:63:\"https://ftp.drupal.org/files/projects/i18n-7.x-1.0-beta1.tar.gz\";s:4:\"date\";s:10:\"1298539000\";s:6:\"mdhash\";s:32:\"2c4d61513eeb7aa1c3a1c6710a6cfe36\";s:8:\"filesize\";s:5:\"97944\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:14:\"7.x-1.0-alpha3\";a:15:{s:4:\"name\";s:19:\"i18n 7.x-1.0-alpha3\";s:7:\"version\";s:14:\"7.x-1.0-alpha3\";s:3:\"tag\";s:14:\"7.x-1.0-alpha3\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:59:\"https://www.drupal.org/project/i18n/releases/7.x-1.0-alpha3\";s:13:\"download_link\";s:64:\"https://ftp.drupal.org/files/projects/i18n-7.x-1.0-alpha3.tar.gz\";s:4:\"date\";s:10:\"1298138679\";s:6:\"mdhash\";s:32:\"574a1cb4e3a607ef1f56775b2741e32a\";s:8:\"filesize\";s:5:\"91045\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:14:\"7.x-1.0-alpha2\";a:15:{s:4:\"name\";s:19:\"i18n 7.x-1.0-alpha2\";s:7:\"version\";s:14:\"7.x-1.0-alpha2\";s:3:\"tag\";s:14:\"7.x-1.0-alpha2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:59:\"https://www.drupal.org/project/i18n/releases/7.x-1.0-alpha2\";s:13:\"download_link\";s:64:\"https://ftp.drupal.org/files/projects/i18n-7.x-1.0-alpha2.tar.gz\";s:4:\"date\";s:10:\"1297683731\";s:6:\"mdhash\";s:32:\"ecc35a3641cc80c278c5f3899867b65f\";s:8:\"filesize\";s:5:\"85227\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}s:14:\"7.x-1.0-alpha1\";a:15:{s:4:\"name\";s:19:\"i18n 7.x-1.0-alpha1\";s:7:\"version\";s:14:\"7.x-1.0-alpha1\";s:3:\"tag\";s:14:\"7.x-1.0-alpha1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:59:\"https://www.drupal.org/project/i18n/releases/7.x-1.0-alpha1\";s:13:\"download_link\";s:64:\"https://ftp.drupal.org/files/projects/i18n-7.x-1.0-alpha1.tar.gz\";s:4:\"date\";s:10:\"1294773669\";s:6:\"mdhash\";s:32:\"d4a69a4cdc9dce950fe8f785203888fc\";s:8:\"filesize\";s:5:\"80850\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}s:11:\"7.x-1.x-dev\";a:14:{s:4:\"name\";s:16:\"i18n 7.x-1.x-dev\";s:7:\"version\";s:11:\"7.x-1.x-dev\";s:3:\"tag\";s:7:\"7.x-1.x\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/i18n/releases/7.x-1.x-dev\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/i18n-7.x-1.x-dev.tar.gz\";s:4:\"date\";s:10:\"1511690885\";s:6:\"mdhash\";s:32:\"a09f550e0e059dcbd396acd2df34dea0\";s:8:\"filesize\";s:6:\"159262\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}}}',1512706730,1512620327,1),('available_releases::jquery_update','a:11:{s:5:\"title\";s:13:\"jQuery Update\";s:10:\"short_name\";s:13:\"jquery_update\";s:4:\"type\";s:14:\"project_module\";s:11:\"api_version\";s:3:\"7.x\";s:17:\"recommended_major\";s:1:\"2\";s:16:\"supported_majors\";s:3:\"2,3\";s:13:\"default_major\";s:1:\"2\";s:14:\"project_status\";s:9:\"published\";s:4:\"link\";s:44:\"https://www.drupal.org/project/jquery_update\";s:5:\"terms\";s:0:\"\";s:8:\"releases\";a:18:{s:14:\"7.x-3.0-alpha5\";a:15:{s:4:\"name\";s:28:\"jquery_update 7.x-3.0-alpha5\";s:7:\"version\";s:14:\"7.x-3.0-alpha5\";s:3:\"tag\";s:14:\"7.x-3.0-alpha5\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha5\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:68:\"https://www.drupal.org/project/jquery_update/releases/7.x-3.0-alpha5\";s:13:\"download_link\";s:73:\"https://ftp.drupal.org/files/projects/jquery_update-7.x-3.0-alpha5.tar.gz\";s:4:\"date\";s:10:\"1490805183\";s:6:\"mdhash\";s:32:\"48baebd87003519ade8c65dc5598bbe5\";s:8:\"filesize\";s:7:\"1980268\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:14:\"7.x-3.0-alpha4\";a:15:{s:4:\"name\";s:28:\"jquery_update 7.x-3.0-alpha4\";s:7:\"version\";s:14:\"7.x-3.0-alpha4\";s:3:\"tag\";s:14:\"7.x-3.0-alpha4\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:68:\"https://www.drupal.org/project/jquery_update/releases/7.x-3.0-alpha4\";s:13:\"download_link\";s:73:\"https://ftp.drupal.org/files/projects/jquery_update-7.x-3.0-alpha4.tar.gz\";s:4:\"date\";s:10:\"1489024086\";s:6:\"mdhash\";s:32:\"b9cadf50cf17638df514aad3c188c776\";s:8:\"filesize\";s:7:\"1978968\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:14:\"7.x-3.0-alpha3\";a:15:{s:4:\"name\";s:28:\"jquery_update 7.x-3.0-alpha3\";s:7:\"version\";s:14:\"7.x-3.0-alpha3\";s:3:\"tag\";s:14:\"7.x-3.0-alpha3\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:68:\"https://www.drupal.org/project/jquery_update/releases/7.x-3.0-alpha3\";s:13:\"download_link\";s:73:\"https://ftp.drupal.org/files/projects/jquery_update-7.x-3.0-alpha3.tar.gz\";s:4:\"date\";s:10:\"1445382239\";s:6:\"mdhash\";s:32:\"599739c36c8095b1a268d82a8d5820ac\";s:8:\"filesize\";s:7:\"1463630\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:14:\"7.x-3.0-alpha2\";a:15:{s:4:\"name\";s:28:\"jquery_update 7.x-3.0-alpha2\";s:7:\"version\";s:14:\"7.x-3.0-alpha2\";s:3:\"tag\";s:14:\"7.x-3.0-alpha2\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:68:\"https://www.drupal.org/project/jquery_update/releases/7.x-3.0-alpha2\";s:13:\"download_link\";s:73:\"https://ftp.drupal.org/files/projects/jquery_update-7.x-3.0-alpha2.tar.gz\";s:4:\"date\";s:10:\"1432926481\";s:6:\"mdhash\";s:32:\"99d161a138a599ee9ebd30434479e1ca\";s:8:\"filesize\";s:7:\"1542292\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:14:\"7.x-3.0-alpha1\";a:15:{s:4:\"name\";s:28:\"jquery_update 7.x-3.0-alpha1\";s:7:\"version\";s:14:\"7.x-3.0-alpha1\";s:3:\"tag\";s:14:\"7.x-3.0-alpha1\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:68:\"https://www.drupal.org/project/jquery_update/releases/7.x-3.0-alpha1\";s:13:\"download_link\";s:73:\"https://ftp.drupal.org/files/projects/jquery_update-7.x-3.0-alpha1.tar.gz\";s:4:\"date\";s:10:\"1431975181\";s:6:\"mdhash\";s:32:\"500a98ed3bec0c943994c43913422332\";s:8:\"filesize\";s:7:\"1541898\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:12:\"New features\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:7:\"7.x-2.7\";a:14:{s:4:\"name\";s:21:\"jquery_update 7.x-2.7\";s:7:\"version\";s:7:\"7.x-2.7\";s:3:\"tag\";s:7:\"7.x-2.7\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"7\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/jquery_update/releases/7.x-2.7\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/jquery_update-7.x-2.7.tar.gz\";s:4:\"date\";s:10:\"1445379839\";s:6:\"mdhash\";s:32:\"85eaf02362c384979bc475df30ae7a3e\";s:8:\"filesize\";s:7:\"1135987\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:15:\"Security update\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-2.6\";a:14:{s:4:\"name\";s:21:\"jquery_update 7.x-2.6\";s:7:\"version\";s:7:\"7.x-2.6\";s:3:\"tag\";s:7:\"7.x-2.6\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"6\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/jquery_update/releases/7.x-2.6\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/jquery_update-7.x-2.6.tar.gz\";s:4:\"date\";s:10:\"1434549780\";s:6:\"mdhash\";s:32:\"88b81a8defbfdf9a4674f876685543f1\";s:8:\"filesize\";s:7:\"1203578\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:15:\"Security update\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-2.5\";a:14:{s:4:\"name\";s:21:\"jquery_update 7.x-2.5\";s:7:\"version\";s:7:\"7.x-2.5\";s:3:\"tag\";s:7:\"7.x-2.5\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"5\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/jquery_update/releases/7.x-2.5\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/jquery_update-7.x-2.5.tar.gz\";s:4:\"date\";s:10:\"1422221880\";s:6:\"mdhash\";s:32:\"47f430531b0a2a821c791325b2d89388\";s:8:\"filesize\";s:7:\"1201320\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-2.4\";a:14:{s:4:\"name\";s:21:\"jquery_update 7.x-2.4\";s:7:\"version\";s:7:\"7.x-2.4\";s:3:\"tag\";s:7:\"7.x-2.4\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/jquery_update/releases/7.x-2.4\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/jquery_update-7.x-2.4.tar.gz\";s:4:\"date\";s:10:\"1396482245\";s:6:\"mdhash\";s:32:\"9cc4f8b964202f1d6f005a43a08060c6\";s:8:\"filesize\";s:7:\"1199709\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-2.3\";a:14:{s:4:\"name\";s:21:\"jquery_update 7.x-2.3\";s:7:\"version\";s:7:\"7.x-2.3\";s:3:\"tag\";s:7:\"7.x-2.3\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/jquery_update/releases/7.x-2.3\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/jquery_update-7.x-2.3.tar.gz\";s:4:\"date\";s:10:\"1360375905\";s:6:\"mdhash\";s:32:\"2d5a1e594a027fa849ed250f5dfef7c5\";s:8:\"filesize\";s:6:\"709788\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:14:\"7.x-2.3-alpha1\";a:15:{s:4:\"name\";s:28:\"jquery_update 7.x-2.3-alpha1\";s:7:\"version\";s:14:\"7.x-2.3-alpha1\";s:3:\"tag\";s:14:\"7.x-2.3-alpha1\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"3\";s:13:\"version_extra\";s:6:\"alpha1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:68:\"https://www.drupal.org/project/jquery_update/releases/7.x-2.3-alpha1\";s:13:\"download_link\";s:73:\"https://ftp.drupal.org/files/projects/jquery_update-7.x-2.3-alpha1.tar.gz\";s:4:\"date\";s:10:\"1348790474\";s:6:\"mdhash\";s:32:\"2fe04a30f74e47c0b1a4ce24023a39fa\";s:8:\"filesize\";s:6:\"709779\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}s:7:\"7.x-2.2\";a:14:{s:4:\"name\";s:21:\"jquery_update 7.x-2.2\";s:7:\"version\";s:7:\"7.x-2.2\";s:3:\"tag\";s:7:\"7.x-2.2\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/jquery_update/releases/7.x-2.2\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/jquery_update-7.x-2.2.tar.gz\";s:4:\"date\";s:10:\"1301920269\";s:6:\"mdhash\";s:32:\"944e097382c08d9a3ba5028ac700162b\";s:8:\"filesize\";s:6:\"482023\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-2.1\";a:14:{s:4:\"name\";s:21:\"jquery_update 7.x-2.1\";s:7:\"version\";s:7:\"7.x-2.1\";s:3:\"tag\";s:7:\"7.x-2.1\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/jquery_update/releases/7.x-2.1\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/jquery_update-7.x-2.1.tar.gz\";s:4:\"date\";s:10:\"1300647067\";s:6:\"mdhash\";s:32:\"6b6f9064e23aaede7ce9f04ded255a57\";s:8:\"filesize\";s:6:\"479984\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-2.0\";a:14:{s:4:\"name\";s:21:\"jquery_update 7.x-2.0\";s:7:\"version\";s:7:\"7.x-2.0\";s:3:\"tag\";s:7:\"7.x-2.0\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/jquery_update/releases/7.x-2.0\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/jquery_update-7.x-2.0.tar.gz\";s:4:\"date\";s:10:\"1297454705\";s:6:\"mdhash\";s:32:\"de6d8095e0bdd4e231922974df3f8fc7\";s:8:\"filesize\";s:6:\"476204\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-1.0\";a:14:{s:4:\"name\";s:21:\"jquery_update 7.x-1.0\";s:7:\"version\";s:7:\"7.x-1.0\";s:3:\"tag\";s:7:\"7.x-1.0\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/jquery_update/releases/7.x-1.0\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/jquery_update-7.x-1.0.tar.gz\";s:4:\"date\";s:10:\"1297453316\";s:6:\"mdhash\";s:32:\"4fa3749b8e477b76341d72a5516344d8\";s:8:\"filesize\";s:6:\"476208\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";s:5:\"terms\";a:0:{}}s:11:\"7.x-3.x-dev\";a:14:{s:4:\"name\";s:25:\"jquery_update 7.x-3.x-dev\";s:7:\"version\";s:11:\"7.x-3.x-dev\";s:3:\"tag\";s:7:\"7.x-3.x\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:65:\"https://www.drupal.org/project/jquery_update/releases/7.x-3.x-dev\";s:13:\"download_link\";s:70:\"https://ftp.drupal.org/files/projects/jquery_update-7.x-3.x-dev.tar.gz\";s:4:\"date\";s:10:\"1490804883\";s:6:\"mdhash\";s:32:\"5786d8734547bdd37d012b365aaa44d9\";s:8:\"filesize\";s:7:\"1980264\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";}s:11:\"7.x-2.x-dev\";a:14:{s:4:\"name\";s:25:\"jquery_update 7.x-2.x-dev\";s:7:\"version\";s:11:\"7.x-2.x-dev\";s:3:\"tag\";s:7:\"7.x-2.x\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:65:\"https://www.drupal.org/project/jquery_update/releases/7.x-2.x-dev\";s:13:\"download_link\";s:70:\"https://ftp.drupal.org/files/projects/jquery_update-7.x-2.x-dev.tar.gz\";s:4:\"date\";s:10:\"1445379839\";s:6:\"mdhash\";s:32:\"b4c28c594a6ecf50ccb9cd9689e778c9\";s:8:\"filesize\";s:7:\"1135988\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}s:11:\"7.x-1.x-dev\";a:14:{s:4:\"name\";s:25:\"jquery_update 7.x-1.x-dev\";s:7:\"version\";s:11:\"7.x-1.x-dev\";s:3:\"tag\";s:7:\"7.x-1.x\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:65:\"https://www.drupal.org/project/jquery_update/releases/7.x-1.x-dev\";s:13:\"download_link\";s:70:\"https://ftp.drupal.org/files/projects/jquery_update-7.x-1.x-dev.tar.gz\";s:4:\"date\";s:10:\"1380584081\";s:6:\"mdhash\";s:32:\"9d1b43a6e55ea389f03cd338ab9c5f35\";s:8:\"filesize\";s:6:\"472169\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}}}',1512706730,1512620327,1),('available_releases::languageicons','a:11:{s:5:\"title\";s:14:\"Language Icons\";s:10:\"short_name\";s:13:\"languageicons\";s:4:\"type\";s:14:\"project_module\";s:11:\"api_version\";s:3:\"7.x\";s:17:\"recommended_major\";s:1:\"1\";s:16:\"supported_majors\";s:1:\"1\";s:13:\"default_major\";s:1:\"1\";s:14:\"project_status\";s:9:\"published\";s:4:\"link\";s:44:\"https://www.drupal.org/project/languageicons\";s:5:\"terms\";s:0:\"\";s:8:\"releases\";a:6:{s:7:\"7.x-1.1\";a:14:{s:4:\"name\";s:21:\"languageicons 7.x-1.1\";s:7:\"version\";s:7:\"7.x-1.1\";s:3:\"tag\";s:7:\"7.x-1.1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/languageicons/releases/7.x-1.1\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/languageicons-7.x-1.1.tar.gz\";s:4:\"date\";s:10:\"1399825727\";s:6:\"mdhash\";s:32:\"5097ac19d351655794d0cda9a596120f\";s:8:\"filesize\";s:5:\"23863\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-1.0\";a:14:{s:4:\"name\";s:21:\"languageicons 7.x-1.0\";s:7:\"version\";s:7:\"7.x-1.0\";s:3:\"tag\";s:7:\"7.x-1.0\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/languageicons/releases/7.x-1.0\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/languageicons-7.x-1.0.tar.gz\";s:4:\"date\";s:10:\"1331734546\";s:6:\"mdhash\";s:32:\"e0c36d4b6ede591030a0c3f8995d012b\";s:8:\"filesize\";s:5:\"19798\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:3:{i:0;s:15:\"Security update\";i:1;s:12:\"New features\";i:2;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:11:\"7.x-1.0-rc1\";a:15:{s:4:\"name\";s:25:\"languageicons 7.x-1.0-rc1\";s:7:\"version\";s:11:\"7.x-1.0-rc1\";s:3:\"tag\";s:11:\"7.x-1.0-rc1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:65:\"https://www.drupal.org/project/languageicons/releases/7.x-1.0-rc1\";s:13:\"download_link\";s:70:\"https://ftp.drupal.org/files/projects/languageicons-7.x-1.0-rc1.tar.gz\";s:4:\"date\";s:10:\"1331050546\";s:6:\"mdhash\";s:32:\"ecb85db62091b697f155c267079f7f12\";s:8:\"filesize\";s:5:\"19098\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:13:\"7.x-1.0-beta1\";a:15:{s:4:\"name\";s:27:\"languageicons 7.x-1.0-beta1\";s:7:\"version\";s:13:\"7.x-1.0-beta1\";s:3:\"tag\";s:13:\"7.x-1.0-beta1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:67:\"https://www.drupal.org/project/languageicons/releases/7.x-1.0-beta1\";s:13:\"download_link\";s:72:\"https://ftp.drupal.org/files/projects/languageicons-7.x-1.0-beta1.tar.gz\";s:4:\"date\";s:10:\"1299020768\";s:6:\"mdhash\";s:32:\"26504905177c19143c20ef3c557aefbf\";s:8:\"filesize\";s:5:\"17383\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:14:\"7.x-1.0-alpha1\";a:15:{s:4:\"name\";s:28:\"languageicons 7.x-1.0-alpha1\";s:7:\"version\";s:14:\"7.x-1.0-alpha1\";s:3:\"tag\";s:14:\"7.x-1.0-alpha1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:68:\"https://www.drupal.org/project/languageicons/releases/7.x-1.0-alpha1\";s:13:\"download_link\";s:73:\"https://ftp.drupal.org/files/projects/languageicons-7.x-1.0-alpha1.tar.gz\";s:4:\"date\";s:10:\"1293053777\";s:6:\"mdhash\";s:32:\"486747d27d711aacabb4266f3b9c8bb3\";s:8:\"filesize\";s:5:\"16917\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}s:11:\"7.x-1.x-dev\";a:14:{s:4:\"name\";s:25:\"languageicons 7.x-1.x-dev\";s:7:\"version\";s:11:\"7.x-1.x-dev\";s:3:\"tag\";s:7:\"7.x-1.x\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:65:\"https://www.drupal.org/project/languageicons/releases/7.x-1.x-dev\";s:13:\"download_link\";s:70:\"https://ftp.drupal.org/files/projects/languageicons-7.x-1.x-dev.tar.gz\";s:4:\"date\";s:10:\"1479365940\";s:6:\"mdhash\";s:32:\"774fc155b5fb4a2216641b205a4f678c\";s:8:\"filesize\";s:5:\"24052\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}}}',1512706730,1512620327,1),('available_releases::lang_dropdown','a:11:{s:5:\"title\";s:26:\"Language Switcher Dropdown\";s:10:\"short_name\";s:13:\"lang_dropdown\";s:4:\"type\";s:14:\"project_module\";s:11:\"api_version\";s:3:\"7.x\";s:17:\"recommended_major\";s:1:\"2\";s:16:\"supported_majors\";s:1:\"2\";s:13:\"default_major\";s:1:\"2\";s:14:\"project_status\";s:9:\"published\";s:4:\"link\";s:44:\"https://www.drupal.org/project/lang_dropdown\";s:5:\"terms\";s:0:\"\";s:8:\"releases\";a:14:{s:7:\"7.x-2.5\";a:14:{s:4:\"name\";s:21:\"lang_dropdown 7.x-2.5\";s:7:\"version\";s:7:\"7.x-2.5\";s:3:\"tag\";s:7:\"7.x-2.5\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"5\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/lang_dropdown/releases/7.x-2.5\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/lang_dropdown-7.x-2.5.tar.gz\";s:4:\"date\";s:10:\"1387127904\";s:6:\"mdhash\";s:32:\"691113055535b8b1d4225d7eecb5a667\";s:8:\"filesize\";s:5:\"24486\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-2.4\";a:14:{s:4:\"name\";s:21:\"lang_dropdown 7.x-2.4\";s:7:\"version\";s:7:\"7.x-2.4\";s:3:\"tag\";s:7:\"7.x-2.4\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/lang_dropdown/releases/7.x-2.4\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/lang_dropdown-7.x-2.4.tar.gz\";s:4:\"date\";s:10:\"1387053506\";s:6:\"mdhash\";s:32:\"5086718573d269e5c3f7ec31d375a8fc\";s:8:\"filesize\";s:5:\"24491\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-2.3\";a:14:{s:4:\"name\";s:21:\"lang_dropdown 7.x-2.3\";s:7:\"version\";s:7:\"7.x-2.3\";s:3:\"tag\";s:7:\"7.x-2.3\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/lang_dropdown/releases/7.x-2.3\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/lang_dropdown-7.x-2.3.tar.gz\";s:4:\"date\";s:10:\"1386939805\";s:6:\"mdhash\";s:32:\"61488887584b97423fc9f17b555a09b2\";s:8:\"filesize\";s:5:\"24560\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-2.2\";a:14:{s:4:\"name\";s:21:\"lang_dropdown 7.x-2.2\";s:7:\"version\";s:7:\"7.x-2.2\";s:3:\"tag\";s:7:\"7.x-2.2\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/lang_dropdown/releases/7.x-2.2\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/lang_dropdown-7.x-2.2.tar.gz\";s:4:\"date\";s:10:\"1386935606\";s:6:\"mdhash\";s:32:\"b2001e68fd391a9f9a65ead8997bf85c\";s:8:\"filesize\";s:5:\"24561\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-2.1\";a:14:{s:4:\"name\";s:21:\"lang_dropdown 7.x-2.1\";s:7:\"version\";s:7:\"7.x-2.1\";s:3:\"tag\";s:7:\"7.x-2.1\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/lang_dropdown/releases/7.x-2.1\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/lang_dropdown-7.x-2.1.tar.gz\";s:4:\"date\";s:10:\"1385824104\";s:6:\"mdhash\";s:32:\"ca4167da91456e080bd25cebaa57a7f2\";s:8:\"filesize\";s:5:\"20421\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-2.0\";a:14:{s:4:\"name\";s:21:\"lang_dropdown 7.x-2.0\";s:7:\"version\";s:7:\"7.x-2.0\";s:3:\"tag\";s:7:\"7.x-2.0\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/lang_dropdown/releases/7.x-2.0\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/lang_dropdown-7.x-2.0.tar.gz\";s:4:\"date\";s:10:\"1385775804\";s:6:\"mdhash\";s:32:\"e0b9726ce3da409de8302b1b61f11a51\";s:8:\"filesize\";s:5:\"20303\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-1.5\";a:14:{s:4:\"name\";s:21:\"lang_dropdown 7.x-1.5\";s:7:\"version\";s:7:\"7.x-1.5\";s:3:\"tag\";s:7:\"7.x-1.5\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"5\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/lang_dropdown/releases/7.x-1.5\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/lang_dropdown-7.x-1.5.tar.gz\";s:4:\"date\";s:10:\"1339444196\";s:6:\"mdhash\";s:32:\"e778e70a4d942b5a636110002720d39c\";s:8:\"filesize\";s:5:\"20505\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-1.4\";a:14:{s:4:\"name\";s:21:\"lang_dropdown 7.x-1.4\";s:7:\"version\";s:7:\"7.x-1.4\";s:3:\"tag\";s:7:\"7.x-1.4\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/lang_dropdown/releases/7.x-1.4\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/lang_dropdown-7.x-1.4.tar.gz\";s:4:\"date\";s:10:\"1338659779\";s:6:\"mdhash\";s:32:\"690fd221945873ce372d7e8c45afca13\";s:8:\"filesize\";s:5:\"20395\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:15:\"Security update\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-1.3\";a:14:{s:4:\"name\";s:21:\"lang_dropdown 7.x-1.3\";s:7:\"version\";s:7:\"7.x-1.3\";s:3:\"tag\";s:7:\"7.x-1.3\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/lang_dropdown/releases/7.x-1.3\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/lang_dropdown-7.x-1.3.tar.gz\";s:4:\"date\";s:10:\"1336479655\";s:6:\"mdhash\";s:32:\"5184341672b2f94f809a8b81486b1092\";s:8:\"filesize\";s:5:\"20327\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-1.2\";a:14:{s:4:\"name\";s:21:\"lang_dropdown 7.x-1.2\";s:7:\"version\";s:7:\"7.x-1.2\";s:3:\"tag\";s:7:\"7.x-1.2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/lang_dropdown/releases/7.x-1.2\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/lang_dropdown-7.x-1.2.tar.gz\";s:4:\"date\";s:10:\"1329527439\";s:6:\"mdhash\";s:32:\"4ec6013d54ffade26e31ba56305650b1\";s:8:\"filesize\";s:5:\"19747\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-1.1\";a:14:{s:4:\"name\";s:21:\"lang_dropdown 7.x-1.1\";s:7:\"version\";s:7:\"7.x-1.1\";s:3:\"tag\";s:7:\"7.x-1.1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/lang_dropdown/releases/7.x-1.1\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/lang_dropdown-7.x-1.1.tar.gz\";s:4:\"date\";s:10:\"1328836848\";s:6:\"mdhash\";s:32:\"aa27606b17882a091f517fa426104920\";s:8:\"filesize\";s:5:\"19568\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-1.0\";a:14:{s:4:\"name\";s:21:\"lang_dropdown 7.x-1.0\";s:7:\"version\";s:7:\"7.x-1.0\";s:3:\"tag\";s:7:\"7.x-1.0\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/lang_dropdown/releases/7.x-1.0\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/lang_dropdown-7.x-1.0.tar.gz\";s:4:\"date\";s:10:\"1317906409\";s:6:\"mdhash\";s:32:\"44c63436cbdaec02507b3935b758b1ad\";s:8:\"filesize\";s:5:\"18507\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:11:\"7.x-2.x-dev\";a:14:{s:4:\"name\";s:25:\"lang_dropdown 7.x-2.x-dev\";s:7:\"version\";s:11:\"7.x-2.x-dev\";s:3:\"tag\";s:7:\"7.x-2.x\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:65:\"https://www.drupal.org/project/lang_dropdown/releases/7.x-2.x-dev\";s:13:\"download_link\";s:70:\"https://ftp.drupal.org/files/projects/lang_dropdown-7.x-2.x-dev.tar.gz\";s:4:\"date\";s:10:\"1505965745\";s:6:\"mdhash\";s:32:\"e93455d41bb214de43a076d4d09fb0c0\";s:8:\"filesize\";s:5:\"24902\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";}s:11:\"7.x-1.x-dev\";a:14:{s:4:\"name\";s:25:\"lang_dropdown 7.x-1.x-dev\";s:7:\"version\";s:11:\"7.x-1.x-dev\";s:3:\"tag\";s:7:\"7.x-1.x\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:65:\"https://www.drupal.org/project/lang_dropdown/releases/7.x-1.x-dev\";s:13:\"download_link\";s:70:\"https://ftp.drupal.org/files/projects/lang_dropdown-7.x-1.x-dev.tar.gz\";s:4:\"date\";s:10:\"1385690304\";s:6:\"mdhash\";s:32:\"448ebc64f1593d55c35935c88a533fc2\";s:8:\"filesize\";s:6:\"302313\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:12:\"New features\";}}s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";}}}',1512706730,1512620327,1),('available_releases::libraries','a:11:{s:5:\"title\";s:13:\"Libraries API\";s:10:\"short_name\";s:9:\"libraries\";s:4:\"type\";s:14:\"project_module\";s:11:\"api_version\";s:3:\"7.x\";s:17:\"recommended_major\";s:1:\"2\";s:16:\"supported_majors\";s:5:\"1,2,3\";s:13:\"default_major\";s:1:\"1\";s:14:\"project_status\";s:9:\"published\";s:4:\"link\";s:40:\"https://www.drupal.org/project/libraries\";s:5:\"terms\";s:0:\"\";s:8:\"releases\";a:10:{s:7:\"7.x-2.3\";a:14:{s:4:\"name\";s:17:\"libraries 7.x-2.3\";s:7:\"version\";s:7:\"7.x-2.3\";s:3:\"tag\";s:7:\"7.x-2.3\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:57:\"https://www.drupal.org/project/libraries/releases/7.x-2.3\";s:13:\"download_link\";s:62:\"https://ftp.drupal.org/files/projects/libraries-7.x-2.3.tar.gz\";s:4:\"date\";s:10:\"1463077439\";s:6:\"mdhash\";s:32:\"294d3e4096c513321159b908cfd7c2be\";s:8:\"filesize\";s:5:\"41863\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-2.2\";a:14:{s:4:\"name\";s:17:\"libraries 7.x-2.2\";s:7:\"version\";s:7:\"7.x-2.2\";s:3:\"tag\";s:7:\"7.x-2.2\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:57:\"https://www.drupal.org/project/libraries/releases/7.x-2.2\";s:13:\"download_link\";s:62:\"https://ftp.drupal.org/files/projects/libraries-7.x-2.2.tar.gz\";s:4:\"date\";s:10:\"1391965705\";s:6:\"mdhash\";s:32:\"629663be1ddbbc79531ab98d7d3761dc\";s:8:\"filesize\";s:5:\"33326\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-2.1\";a:14:{s:4:\"name\";s:17:\"libraries 7.x-2.1\";s:7:\"version\";s:7:\"7.x-2.1\";s:3:\"tag\";s:7:\"7.x-2.1\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:57:\"https://www.drupal.org/project/libraries/releases/7.x-2.1\";s:13:\"download_link\";s:62:\"https://ftp.drupal.org/files/projects/libraries-7.x-2.1.tar.gz\";s:4:\"date\";s:10:\"1362848412\";s:6:\"mdhash\";s:32:\"e240bf43e3a4dd2d595bf24ac34d46bd\";s:8:\"filesize\";s:5:\"30501\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-2.0\";a:14:{s:4:\"name\";s:17:\"libraries 7.x-2.0\";s:7:\"version\";s:7:\"7.x-2.0\";s:3:\"tag\";s:7:\"7.x-2.0\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:57:\"https://www.drupal.org/project/libraries/releases/7.x-2.0\";s:13:\"download_link\";s:62:\"https://ftp.drupal.org/files/projects/libraries-7.x-2.0.tar.gz\";s:4:\"date\";s:10:\"1343561873\";s:6:\"mdhash\";s:32:\"bb4707fe9c9c67401c9baa514fbab948\";s:8:\"filesize\";s:5:\"30229\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:14:\"7.x-2.0-alpha2\";a:15:{s:4:\"name\";s:24:\"libraries 7.x-2.0-alpha2\";s:7:\"version\";s:14:\"7.x-2.0-alpha2\";s:3:\"tag\";s:14:\"7.x-2.0-alpha2\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:64:\"https://www.drupal.org/project/libraries/releases/7.x-2.0-alpha2\";s:13:\"download_link\";s:69:\"https://ftp.drupal.org/files/projects/libraries-7.x-2.0-alpha2.tar.gz\";s:4:\"date\";s:10:\"1323950504\";s:6:\"mdhash\";s:32:\"150a5e24e7f1e849e054ba06921a0311\";s:8:\"filesize\";s:5:\"29501\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:14:\"7.x-2.0-alpha1\";a:15:{s:4:\"name\";s:24:\"libraries 7.x-2.0-alpha1\";s:7:\"version\";s:14:\"7.x-2.0-alpha1\";s:3:\"tag\";s:14:\"7.x-2.0-alpha1\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:64:\"https://www.drupal.org/project/libraries/releases/7.x-2.0-alpha1\";s:13:\"download_link\";s:69:\"https://ftp.drupal.org/files/projects/libraries-7.x-2.0-alpha1.tar.gz\";s:4:\"date\";s:10:\"1317479207\";s:6:\"mdhash\";s:32:\"8e3529be946d9ad0a4b387756cb91a5d\";s:8:\"filesize\";s:5:\"28459\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:12:\"New features\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:7:\"7.x-1.0\";a:14:{s:4:\"name\";s:17:\"libraries 7.x-1.0\";s:7:\"version\";s:7:\"7.x-1.0\";s:3:\"tag\";s:7:\"7.x-1.0\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:57:\"https://www.drupal.org/project/libraries/releases/7.x-1.0\";s:13:\"download_link\";s:62:\"https://ftp.drupal.org/files/projects/libraries-7.x-1.0.tar.gz\";s:4:\"date\";s:10:\"1296096156\";s:6:\"mdhash\";s:32:\"e395a4229adb94f48de0764654e83967\";s:8:\"filesize\";s:4:\"7921\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";s:5:\"terms\";a:0:{}}s:11:\"7.x-3.x-dev\";a:14:{s:4:\"name\";s:21:\"libraries 7.x-3.x-dev\";s:7:\"version\";s:11:\"7.x-3.x-dev\";s:3:\"tag\";s:7:\"7.x-3.x\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/libraries/releases/7.x-3.x-dev\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/libraries-7.x-3.x-dev.tar.gz\";s:4:\"date\";s:10:\"1413167628\";s:6:\"mdhash\";s:32:\"7263f590a91de04704820f2b218956f9\";s:8:\"filesize\";s:5:\"33184\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:12:\"New features\";}}s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";}s:11:\"7.x-2.x-dev\";a:14:{s:4:\"name\";s:21:\"libraries 7.x-2.x-dev\";s:7:\"version\";s:11:\"7.x-2.x-dev\";s:3:\"tag\";s:7:\"7.x-2.x\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/libraries/releases/7.x-2.x-dev\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/libraries-7.x-2.x-dev.tar.gz\";s:4:\"date\";s:10:\"1479046140\";s:6:\"mdhash\";s:32:\"3664fa9b54800164c107a0fbc2e52865\";s:8:\"filesize\";s:5:\"44459\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}s:11:\"7.x-1.x-dev\";a:14:{s:4:\"name\";s:21:\"libraries 7.x-1.x-dev\";s:7:\"version\";s:11:\"7.x-1.x-dev\";s:3:\"tag\";s:7:\"7.x-1.x\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/libraries/releases/7.x-1.x-dev\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/libraries-7.x-1.x-dev.tar.gz\";s:4:\"date\";s:10:\"1406512127\";s:6:\"mdhash\";s:32:\"84247d751f028c55371865aef18fbd11\";s:8:\"filesize\";s:4:\"9041\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}}}',1512706731,1512620327,1),('available_releases::link','a:11:{s:5:\"title\";s:4:\"Link\";s:10:\"short_name\";s:4:\"link\";s:4:\"type\";s:14:\"project_module\";s:11:\"api_version\";s:3:\"7.x\";s:17:\"recommended_major\";s:1:\"1\";s:16:\"supported_majors\";s:1:\"1\";s:13:\"default_major\";s:1:\"1\";s:14:\"project_status\";s:9:\"published\";s:4:\"link\";s:35:\"https://www.drupal.org/project/link\";s:5:\"terms\";s:0:\"\";s:8:\"releases\";a:12:{s:13:\"7.x-1.5-beta2\";a:15:{s:4:\"name\";s:18:\"link 7.x-1.5-beta2\";s:7:\"version\";s:13:\"7.x-1.5-beta2\";s:3:\"tag\";s:13:\"7.x-1.5-beta2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"5\";s:13:\"version_extra\";s:5:\"beta2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:58:\"https://www.drupal.org/project/link/releases/7.x-1.5-beta2\";s:13:\"download_link\";s:63:\"https://ftp.drupal.org/files/projects/link-7.x-1.5-beta2.tar.gz\";s:4:\"date\";s:10:\"1500985442\";s:6:\"mdhash\";s:32:\"7ffe7148234f8c237a4893abd82c8e0e\";s:8:\"filesize\";s:5:\"38156\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"7.x-1.5-beta1\";a:15:{s:4:\"name\";s:18:\"link 7.x-1.5-beta1\";s:7:\"version\";s:13:\"7.x-1.5-beta1\";s:3:\"tag\";s:13:\"7.x-1.5-beta1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"5\";s:13:\"version_extra\";s:5:\"beta1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:58:\"https://www.drupal.org/project/link/releases/7.x-1.5-beta1\";s:13:\"download_link\";s:63:\"https://ftp.drupal.org/files/projects/link-7.x-1.5-beta1.tar.gz\";s:4:\"date\";s:10:\"1499171942\";s:6:\"mdhash\";s:32:\"0589fb97c7b74f82e429a34677eb1fb8\";s:8:\"filesize\";s:5:\"37592\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:7:\"7.x-1.4\";a:14:{s:4:\"name\";s:12:\"link 7.x-1.4\";s:7:\"version\";s:7:\"7.x-1.4\";s:3:\"tag\";s:7:\"7.x-1.4\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/link/releases/7.x-1.4\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/link-7.x-1.4.tar.gz\";s:4:\"date\";s:10:\"1452830639\";s:6:\"mdhash\";s:32:\"10cb0a7bb75aaa6cd709c88fd7f79e9f\";s:8:\"filesize\";s:5:\"36913\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-1.3\";a:14:{s:4:\"name\";s:12:\"link 7.x-1.3\";s:7:\"version\";s:7:\"7.x-1.3\";s:3:\"tag\";s:7:\"7.x-1.3\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/link/releases/7.x-1.3\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/link-7.x-1.3.tar.gz\";s:4:\"date\";s:10:\"1413924828\";s:6:\"mdhash\";s:32:\"cc9ccec6ca028f73cf60f8cab09e5a4d\";s:8:\"filesize\";s:5:\"33988\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-1.2\";a:14:{s:4:\"name\";s:12:\"link 7.x-1.2\";s:7:\"version\";s:7:\"7.x-1.2\";s:3:\"tag\";s:7:\"7.x-1.2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/link/releases/7.x-1.2\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/link-7.x-1.2.tar.gz\";s:4:\"date\";s:10:\"1385335704\";s:6:\"mdhash\";s:32:\"100c0b2416d455908a818f0a547e9938\";s:8:\"filesize\";s:5:\"33858\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-1.1\";a:14:{s:4:\"name\";s:12:\"link 7.x-1.1\";s:7:\"version\";s:7:\"7.x-1.1\";s:3:\"tag\";s:7:\"7.x-1.1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/link/releases/7.x-1.1\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/link-7.x-1.1.tar.gz\";s:4:\"date\";s:10:\"1360444360\";s:6:\"mdhash\";s:32:\"416691004d5a09681869dcd93188238b\";s:8:\"filesize\";s:5:\"33160\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-1.0\";a:14:{s:4:\"name\";s:12:\"link 7.x-1.0\";s:7:\"version\";s:7:\"7.x-1.0\";s:3:\"tag\";s:7:\"7.x-1.0\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/link/releases/7.x-1.0\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/link-7.x-1.0.tar.gz\";s:4:\"date\";s:10:\"1319392535\";s:6:\"mdhash\";s:32:\"0b237d7b329c0454f437f5687d607743\";s:8:\"filesize\";s:5:\"31440\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:13:\"7.x-1.0-beta1\";a:15:{s:4:\"name\";s:18:\"link 7.x-1.0-beta1\";s:7:\"version\";s:13:\"7.x-1.0-beta1\";s:3:\"tag\";s:13:\"7.x-1.0-beta1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:58:\"https://www.drupal.org/project/link/releases/7.x-1.0-beta1\";s:13:\"download_link\";s:63:\"https://ftp.drupal.org/files/projects/link-7.x-1.0-beta1.tar.gz\";s:4:\"date\";s:10:\"1317011508\";s:6:\"mdhash\";s:32:\"05802cd5a599cbf0b205a084016779a8\";s:8:\"filesize\";s:5:\"30289\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:14:\"7.x-1.0-alpha3\";a:15:{s:4:\"name\";s:19:\"link 7.x-1.0-alpha3\";s:7:\"version\";s:14:\"7.x-1.0-alpha3\";s:3:\"tag\";s:14:\"7.x-1.0-alpha3\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:59:\"https://www.drupal.org/project/link/releases/7.x-1.0-alpha3\";s:13:\"download_link\";s:64:\"https://ftp.drupal.org/files/projects/link-7.x-1.0-alpha3.tar.gz\";s:4:\"date\";s:10:\"1297061216\";s:6:\"mdhash\";s:32:\"372ddf2818f9ae6754274b4a8b6b640b\";s:8:\"filesize\";s:5:\"27724\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:14:\"7.x-1.0-alpha2\";a:15:{s:4:\"name\";s:19:\"link 7.x-1.0-alpha2\";s:7:\"version\";s:14:\"7.x-1.0-alpha2\";s:3:\"tag\";s:14:\"7.x-1.0-alpha2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:7:\"alpha-2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:59:\"https://www.drupal.org/project/link/releases/7.x-1.0-alpha2\";s:13:\"download_link\";s:64:\"https://ftp.drupal.org/files/projects/link-7.x-1.0-alpha2.tar.gz\";s:4:\"date\";s:10:\"1295189003\";s:6:\"mdhash\";s:32:\"c74d7846f210f1bf4a8f14cc8a2d4dbd\";s:8:\"filesize\";s:5:\"20558\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:62:\"Alpha- releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}s:14:\"7.x-1.0-alpha1\";a:15:{s:4:\"name\";s:19:\"link 7.x-1.0-alpha1\";s:7:\"version\";s:14:\"7.x-1.0-alpha1\";s:3:\"tag\";s:14:\"7.x-1.0-alpha1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:59:\"https://www.drupal.org/project/link/releases/7.x-1.0-alpha1\";s:13:\"download_link\";s:64:\"https://ftp.drupal.org/files/projects/link-7.x-1.0-alpha1.tar.gz\";s:4:\"date\";s:10:\"1291518680\";s:6:\"mdhash\";s:32:\"e9299a741ec5b8ac631f3ba701df7c14\";s:8:\"filesize\";s:5:\"20843\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:12:\"New features\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:11:\"7.x-1.x-dev\";a:14:{s:4:\"name\";s:16:\"link 7.x-1.x-dev\";s:7:\"version\";s:11:\"7.x-1.x-dev\";s:3:\"tag\";s:7:\"7.x-1.x\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/link/releases/7.x-1.x-dev\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/link-7.x-1.x-dev.tar.gz\";s:4:\"date\";s:10:\"1506613144\";s:6:\"mdhash\";s:32:\"71db813feb016fddb7706119fc7954f0\";s:8:\"filesize\";s:5:\"38945\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}}}',1512706731,1512620327,1),('available_releases::menu_breadcrumb','a:11:{s:5:\"title\";s:15:\"Menu Breadcrumb\";s:10:\"short_name\";s:15:\"menu_breadcrumb\";s:4:\"type\";s:14:\"project_module\";s:11:\"api_version\";s:3:\"7.x\";s:17:\"recommended_major\";s:1:\"1\";s:16:\"supported_majors\";s:1:\"1\";s:13:\"default_major\";s:1:\"1\";s:14:\"project_status\";s:9:\"published\";s:4:\"link\";s:46:\"https://www.drupal.org/project/menu_breadcrumb\";s:5:\"terms\";s:0:\"\";s:8:\"releases\";a:5:{s:7:\"7.x-1.6\";a:14:{s:4:\"name\";s:23:\"menu_breadcrumb 7.x-1.6\";s:7:\"version\";s:7:\"7.x-1.6\";s:3:\"tag\";s:7:\"7.x-1.6\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"6\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:63:\"https://www.drupal.org/project/menu_breadcrumb/releases/7.x-1.6\";s:13:\"download_link\";s:68:\"https://ftp.drupal.org/files/projects/menu_breadcrumb-7.x-1.6.tar.gz\";s:4:\"date\";s:10:\"1425993987\";s:6:\"mdhash\";s:32:\"30291c87761f042b7599865d80df6f62\";s:8:\"filesize\";s:5:\"15154\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-1.5\";a:14:{s:4:\"name\";s:23:\"menu_breadcrumb 7.x-1.5\";s:7:\"version\";s:7:\"7.x-1.5\";s:3:\"tag\";s:7:\"7.x-1.5\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"5\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:63:\"https://www.drupal.org/project/menu_breadcrumb/releases/7.x-1.5\";s:13:\"download_link\";s:68:\"https://ftp.drupal.org/files/projects/menu_breadcrumb-7.x-1.5.tar.gz\";s:4:\"date\";s:10:\"1381202821\";s:6:\"mdhash\";s:32:\"a39b1abd3b655dcd3e25bceaae6dc844\";s:8:\"filesize\";s:5:\"14006\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-1.4\";a:14:{s:4:\"name\";s:23:\"menu_breadcrumb 7.x-1.4\";s:7:\"version\";s:7:\"7.x-1.4\";s:3:\"tag\";s:7:\"7.x-1.4\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:63:\"https://www.drupal.org/project/menu_breadcrumb/releases/7.x-1.4\";s:13:\"download_link\";s:68:\"https://ftp.drupal.org/files/projects/menu_breadcrumb-7.x-1.4.tar.gz\";s:4:\"date\";s:10:\"1374442868\";s:6:\"mdhash\";s:32:\"7bc222b8b0d0eab296852addb6b5b0c1\";s:8:\"filesize\";s:5:\"13957\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-1.3\";a:14:{s:4:\"name\";s:23:\"menu_breadcrumb 7.x-1.3\";s:7:\"version\";s:7:\"7.x-1.3\";s:3:\"tag\";s:7:\"7.x-1.3\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:63:\"https://www.drupal.org/project/menu_breadcrumb/releases/7.x-1.3\";s:13:\"download_link\";s:68:\"https://ftp.drupal.org/files/projects/menu_breadcrumb-7.x-1.3.tar.gz\";s:4:\"date\";s:10:\"1312055519\";s:6:\"mdhash\";s:32:\"3993ada6458db730ed1c94225d2c4d73\";s:8:\"filesize\";s:5:\"12884\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:11:\"7.x-1.x-dev\";a:14:{s:4:\"name\";s:27:\"menu_breadcrumb 7.x-1.x-dev\";s:7:\"version\";s:11:\"7.x-1.x-dev\";s:3:\"tag\";s:7:\"7.x-1.x\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:67:\"https://www.drupal.org/project/menu_breadcrumb/releases/7.x-1.x-dev\";s:13:\"download_link\";s:72:\"https://ftp.drupal.org/files/projects/menu_breadcrumb-7.x-1.x-dev.tar.gz\";s:4:\"date\";s:10:\"1465478639\";s:6:\"mdhash\";s:32:\"42bd1026f9f2cc07695cb1b2ded0536c\";s:8:\"filesize\";s:5:\"15161\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:12:\"New features\";}}s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";}}}',1512706731,1512620327,1),('available_releases::message','a:11:{s:5:\"title\";s:7:\"Message\";s:10:\"short_name\";s:7:\"message\";s:4:\"type\";s:14:\"project_module\";s:11:\"api_version\";s:3:\"7.x\";s:17:\"recommended_major\";s:1:\"1\";s:16:\"supported_majors\";s:1:\"1\";s:13:\"default_major\";s:1:\"1\";s:14:\"project_status\";s:9:\"published\";s:4:\"link\";s:38:\"https://www.drupal.org/project/message\";s:5:\"terms\";s:0:\"\";s:8:\"releases\";a:14:{s:8:\"7.x-1.12\";a:14:{s:4:\"name\";s:16:\"message 7.x-1.12\";s:7:\"version\";s:8:\"7.x-1.12\";s:3:\"tag\";s:8:\"7.x-1.12\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:2:\"12\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/message/releases/7.x-1.12\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/message-7.x-1.12.tar.gz\";s:4:\"date\";s:10:\"1468304039\";s:6:\"mdhash\";s:32:\"bd4c7df7848fea70f00afbcfe76a205d\";s:8:\"filesize\";s:5:\"51254\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:8:\"7.x-1.11\";a:14:{s:4:\"name\";s:16:\"message 7.x-1.11\";s:7:\"version\";s:8:\"7.x-1.11\";s:3:\"tag\";s:8:\"7.x-1.11\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:2:\"11\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/message/releases/7.x-1.11\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/message-7.x-1.11.tar.gz\";s:4:\"date\";s:10:\"1450768739\";s:6:\"mdhash\";s:32:\"3a75a8a11f9531b178b79b89e597f4ee\";s:8:\"filesize\";s:5:\"48234\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:8:\"7.x-1.10\";a:14:{s:4:\"name\";s:16:\"message 7.x-1.10\";s:7:\"version\";s:8:\"7.x-1.10\";s:3:\"tag\";s:8:\"7.x-1.10\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:2:\"10\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/message/releases/7.x-1.10\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/message-7.x-1.10.tar.gz\";s:4:\"date\";s:10:\"1429477681\";s:6:\"mdhash\";s:32:\"264cb52ec60f97e1b1c6e033ffd56fe9\";s:8:\"filesize\";s:5:\"48255\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-1.9\";a:14:{s:4:\"name\";s:15:\"message 7.x-1.9\";s:7:\"version\";s:7:\"7.x-1.9\";s:3:\"tag\";s:7:\"7.x-1.9\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"9\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:55:\"https://www.drupal.org/project/message/releases/7.x-1.9\";s:13:\"download_link\";s:60:\"https://ftp.drupal.org/files/projects/message-7.x-1.9.tar.gz\";s:4:\"date\";s:10:\"1374541036\";s:6:\"mdhash\";s:32:\"574a29b445f95f8b384fe43a8824294b\";s:8:\"filesize\";s:5:\"45898\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-1.8\";a:14:{s:4:\"name\";s:15:\"message 7.x-1.8\";s:7:\"version\";s:7:\"7.x-1.8\";s:3:\"tag\";s:7:\"7.x-1.8\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"8\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:55:\"https://www.drupal.org/project/message/releases/7.x-1.8\";s:13:\"download_link\";s:60:\"https://ftp.drupal.org/files/projects/message-7.x-1.8.tar.gz\";s:4:\"date\";s:10:\"1366630873\";s:6:\"mdhash\";s:32:\"d46128d324af8a3477ea162eae0537d9\";s:8:\"filesize\";s:5:\"45686\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-1.7\";a:14:{s:4:\"name\";s:15:\"message 7.x-1.7\";s:7:\"version\";s:7:\"7.x-1.7\";s:3:\"tag\";s:7:\"7.x-1.7\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"7\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:55:\"https://www.drupal.org/project/message/releases/7.x-1.7\";s:13:\"download_link\";s:60:\"https://ftp.drupal.org/files/projects/message-7.x-1.7.tar.gz\";s:4:\"date\";s:10:\"1355398352\";s:6:\"mdhash\";s:32:\"7f8cc660445008c3bd016176c54c0dc0\";s:8:\"filesize\";s:5:\"44272\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-1.6\";a:14:{s:4:\"name\";s:15:\"message 7.x-1.6\";s:7:\"version\";s:7:\"7.x-1.6\";s:3:\"tag\";s:7:\"7.x-1.6\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"6\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:55:\"https://www.drupal.org/project/message/releases/7.x-1.6\";s:13:\"download_link\";s:60:\"https://ftp.drupal.org/files/projects/message-7.x-1.6.tar.gz\";s:4:\"date\";s:10:\"1352270207\";s:6:\"mdhash\";s:32:\"faac88f17be5ce9df336b4ec099b5560\";s:8:\"filesize\";s:5:\"43926\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-1.5\";a:14:{s:4:\"name\";s:15:\"message 7.x-1.5\";s:7:\"version\";s:7:\"7.x-1.5\";s:3:\"tag\";s:7:\"7.x-1.5\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"5\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:55:\"https://www.drupal.org/project/message/releases/7.x-1.5\";s:13:\"download_link\";s:60:\"https://ftp.drupal.org/files/projects/message-7.x-1.5.tar.gz\";s:4:\"date\";s:10:\"1344628929\";s:6:\"mdhash\";s:32:\"6b5f5e92d7cf041e2350ec80df0cf504\";s:8:\"filesize\";s:5:\"42358\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-1.4\";a:14:{s:4:\"name\";s:15:\"message 7.x-1.4\";s:7:\"version\";s:7:\"7.x-1.4\";s:3:\"tag\";s:7:\"7.x-1.4\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:55:\"https://www.drupal.org/project/message/releases/7.x-1.4\";s:13:\"download_link\";s:60:\"https://ftp.drupal.org/files/projects/message-7.x-1.4.tar.gz\";s:4:\"date\";s:10:\"1339963279\";s:6:\"mdhash\";s:32:\"052eeface60e26a82dfe9e2cc66cdcae\";s:8:\"filesize\";s:5:\"40499\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-1.3\";a:14:{s:4:\"name\";s:15:\"message 7.x-1.3\";s:7:\"version\";s:7:\"7.x-1.3\";s:3:\"tag\";s:7:\"7.x-1.3\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:55:\"https://www.drupal.org/project/message/releases/7.x-1.3\";s:13:\"download_link\";s:60:\"https://ftp.drupal.org/files/projects/message-7.x-1.3.tar.gz\";s:4:\"date\";s:10:\"1334765499\";s:6:\"mdhash\";s:32:\"51f77903393605cf30208a4576585422\";s:8:\"filesize\";s:5:\"38453\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-1.2\";a:14:{s:4:\"name\";s:15:\"message 7.x-1.2\";s:7:\"version\";s:7:\"7.x-1.2\";s:3:\"tag\";s:7:\"7.x-1.2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:55:\"https://www.drupal.org/project/message/releases/7.x-1.2\";s:13:\"download_link\";s:60:\"https://ftp.drupal.org/files/projects/message-7.x-1.2.tar.gz\";s:4:\"date\";s:10:\"1331068847\";s:6:\"mdhash\";s:32:\"177c90c56a2993de66f83d0dc76bd203\";s:8:\"filesize\";s:5:\"26537\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-1.1\";a:14:{s:4:\"name\";s:15:\"message 7.x-1.1\";s:7:\"version\";s:7:\"7.x-1.1\";s:3:\"tag\";s:7:\"7.x-1.1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:55:\"https://www.drupal.org/project/message/releases/7.x-1.1\";s:13:\"download_link\";s:60:\"https://ftp.drupal.org/files/projects/message-7.x-1.1.tar.gz\";s:4:\"date\";s:10:\"1320867935\";s:6:\"mdhash\";s:32:\"bb7a79517dc768ce338d38b4f9834c77\";s:8:\"filesize\";s:5:\"20964\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-1.0\";a:14:{s:4:\"name\";s:15:\"message 7.x-1.0\";s:7:\"version\";s:7:\"7.x-1.0\";s:3:\"tag\";s:7:\"7.x-1.0\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:55:\"https://www.drupal.org/project/message/releases/7.x-1.0\";s:13:\"download_link\";s:60:\"https://ftp.drupal.org/files/projects/message-7.x-1.0.tar.gz\";s:4:\"date\";s:10:\"1294241763\";s:6:\"mdhash\";s:32:\"4f3bb765c0a8ce23d0bf28992dc52bc0\";s:8:\"filesize\";s:5:\"14472\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";s:5:\"terms\";a:0:{}}s:11:\"7.x-1.x-dev\";a:14:{s:4:\"name\";s:19:\"message 7.x-1.x-dev\";s:7:\"version\";s:11:\"7.x-1.x-dev\";s:3:\"tag\";s:7:\"7.x-1.x\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:59:\"https://www.drupal.org/project/message/releases/7.x-1.x-dev\";s:13:\"download_link\";s:64:\"https://ftp.drupal.org/files/projects/message-7.x-1.x-dev.tar.gz\";s:4:\"date\";s:10:\"1466589239\";s:6:\"mdhash\";s:32:\"472b101663af0966a2bd00e02f5898c2\";s:8:\"filesize\";s:5:\"51264\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}}}',1512706731,1512620327,1),('available_releases::modal_forms','a:11:{s:5:\"title\";s:25:\"Modal forms (with ctools)\";s:10:\"short_name\";s:11:\"modal_forms\";s:4:\"type\";s:14:\"project_module\";s:11:\"api_version\";s:3:\"7.x\";s:17:\"recommended_major\";s:1:\"1\";s:16:\"supported_majors\";s:1:\"1\";s:13:\"default_major\";s:1:\"1\";s:14:\"project_status\";s:9:\"published\";s:4:\"link\";s:42:\"https://www.drupal.org/project/modal_forms\";s:5:\"terms\";s:0:\"\";s:8:\"releases\";a:4:{s:7:\"7.x-1.2\";a:14:{s:4:\"name\";s:19:\"modal_forms 7.x-1.2\";s:7:\"version\";s:7:\"7.x-1.2\";s:3:\"tag\";s:7:\"7.x-1.2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:59:\"https://www.drupal.org/project/modal_forms/releases/7.x-1.2\";s:13:\"download_link\";s:64:\"https://ftp.drupal.org/files/projects/modal_forms-7.x-1.2.tar.gz\";s:4:\"date\";s:10:\"1353326875\";s:6:\"mdhash\";s:32:\"ad1e71dd8a361254f1383eec009b89de\";s:8:\"filesize\";s:5:\"29937\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-1.1\";a:14:{s:4:\"name\";s:19:\"modal_forms 7.x-1.1\";s:7:\"version\";s:7:\"7.x-1.1\";s:3:\"tag\";s:7:\"7.x-1.1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:59:\"https://www.drupal.org/project/modal_forms/releases/7.x-1.1\";s:13:\"download_link\";s:64:\"https://ftp.drupal.org/files/projects/modal_forms-7.x-1.1.tar.gz\";s:4:\"date\";s:10:\"1351606627\";s:6:\"mdhash\";s:32:\"4c5ecab1b272fce9135cba636a0348a6\";s:8:\"filesize\";s:5:\"29045\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-1.0\";a:14:{s:4:\"name\";s:19:\"modal_forms 7.x-1.0\";s:7:\"version\";s:7:\"7.x-1.0\";s:3:\"tag\";s:7:\"7.x-1.0\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:59:\"https://www.drupal.org/project/modal_forms/releases/7.x-1.0\";s:13:\"download_link\";s:64:\"https://ftp.drupal.org/files/projects/modal_forms-7.x-1.0.tar.gz\";s:4:\"date\";s:10:\"1317720425\";s:6:\"mdhash\";s:32:\"cc77384455ddac0978e8c16c90af9859\";s:8:\"filesize\";s:5:\"26651\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";s:5:\"terms\";a:0:{}}s:11:\"7.x-1.x-dev\";a:14:{s:4:\"name\";s:23:\"modal_forms 7.x-1.x-dev\";s:7:\"version\";s:11:\"7.x-1.x-dev\";s:3:\"tag\";s:7:\"7.x-1.x\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:63:\"https://www.drupal.org/project/modal_forms/releases/7.x-1.x-dev\";s:13:\"download_link\";s:68:\"https://ftp.drupal.org/files/projects/modal_forms-7.x-1.x-dev.tar.gz\";s:4:\"date\";s:10:\"1423212181\";s:6:\"mdhash\";s:32:\"8028fc6e050a72427346180af638a372\";s:8:\"filesize\";s:5:\"32226\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}}}',1512706731,1512620327,1),('available_releases::module_filter','a:11:{s:5:\"title\";s:13:\"Module Filter\";s:10:\"short_name\";s:13:\"module_filter\";s:4:\"type\";s:14:\"project_module\";s:11:\"api_version\";s:3:\"7.x\";s:17:\"recommended_major\";s:1:\"2\";s:16:\"supported_majors\";s:1:\"2\";s:13:\"default_major\";s:1:\"2\";s:14:\"project_status\";s:9:\"published\";s:4:\"link\";s:44:\"https://www.drupal.org/project/module_filter\";s:5:\"terms\";s:0:\"\";s:8:\"releases\";a:15:{s:7:\"7.x-2.1\";a:14:{s:4:\"name\";s:21:\"module_filter 7.x-2.1\";s:7:\"version\";s:7:\"7.x-2.1\";s:3:\"tag\";s:7:\"7.x-2.1\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/module_filter/releases/7.x-2.1\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/module_filter-7.x-2.1.tar.gz\";s:4:\"date\";s:10:\"1497029343\";s:6:\"mdhash\";s:32:\"66a4998f63f2cefe77c18713054a42cc\";s:8:\"filesize\";s:5:\"29757\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-2.0\";a:14:{s:4:\"name\";s:21:\"module_filter 7.x-2.0\";s:7:\"version\";s:7:\"7.x-2.0\";s:3:\"tag\";s:7:\"7.x-2.0\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/module_filter/releases/7.x-2.0\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/module_filter-7.x-2.0.tar.gz\";s:4:\"date\";s:10:\"1424631181\";s:6:\"mdhash\";s:32:\"3e2ebdd2f2ec028252e1cf2a547d7d7e\";s:8:\"filesize\";s:5:\"29130\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";s:5:\"terms\";a:0:{}}s:14:\"7.x-2.0-alpha2\";a:15:{s:4:\"name\";s:28:\"module_filter 7.x-2.0-alpha2\";s:7:\"version\";s:14:\"7.x-2.0-alpha2\";s:3:\"tag\";s:14:\"7.x-2.0-alpha2\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:68:\"https://www.drupal.org/project/module_filter/releases/7.x-2.0-alpha2\";s:13:\"download_link\";s:73:\"https://ftp.drupal.org/files/projects/module_filter-7.x-2.0-alpha2.tar.gz\";s:4:\"date\";s:10:\"1386356904\";s:6:\"mdhash\";s:32:\"342e0e3963e64c39f86061a10bbdaf2e\";s:8:\"filesize\";s:5:\"27898\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:14:\"7.x-2.0-alpha1\";a:15:{s:4:\"name\";s:28:\"module_filter 7.x-2.0-alpha1\";s:7:\"version\";s:14:\"7.x-2.0-alpha1\";s:3:\"tag\";s:14:\"7.x-2.0-alpha1\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:68:\"https://www.drupal.org/project/module_filter/releases/7.x-2.0-alpha1\";s:13:\"download_link\";s:73:\"https://ftp.drupal.org/files/projects/module_filter-7.x-2.0-alpha1.tar.gz\";s:4:\"date\";s:10:\"1384832005\";s:6:\"mdhash\";s:32:\"3bfb306828c12830c0ee3678f675f124\";s:8:\"filesize\";s:5:\"27962\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:7:\"7.x-1.8\";a:14:{s:4:\"name\";s:21:\"module_filter 7.x-1.8\";s:7:\"version\";s:7:\"7.x-1.8\";s:3:\"tag\";s:7:\"7.x-1.8\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"8\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/module_filter/releases/7.x-1.8\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/module_filter-7.x-1.8.tar.gz\";s:4:\"date\";s:10:\"1375995221\";s:6:\"mdhash\";s:32:\"53a1b995dee29e1ab202fa1547dc1266\";s:8:\"filesize\";s:5:\"14605\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-1.7\";a:14:{s:4:\"name\";s:21:\"module_filter 7.x-1.7\";s:7:\"version\";s:7:\"7.x-1.7\";s:3:\"tag\";s:7:\"7.x-1.7\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"7\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/module_filter/releases/7.x-1.7\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/module_filter-7.x-1.7.tar.gz\";s:4:\"date\";s:10:\"1341518501\";s:6:\"mdhash\";s:32:\"f10e62aa5346d5cd82854d66c359f199\";s:8:\"filesize\";s:5:\"14646\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-1.6\";a:14:{s:4:\"name\";s:21:\"module_filter 7.x-1.6\";s:7:\"version\";s:7:\"7.x-1.6\";s:3:\"tag\";s:7:\"7.x-1.6\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"6\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/module_filter/releases/7.x-1.6\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/module_filter-7.x-1.6.tar.gz\";s:4:\"date\";s:10:\"1316105205\";s:6:\"mdhash\";s:32:\"77ca515021372066e2b19906adddb94e\";s:8:\"filesize\";s:5:\"13177\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-1.5\";a:14:{s:4:\"name\";s:21:\"module_filter 7.x-1.5\";s:7:\"version\";s:7:\"7.x-1.5\";s:3:\"tag\";s:7:\"7.x-1.5\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"5\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/module_filter/releases/7.x-1.5\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/module_filter-7.x-1.5.tar.gz\";s:4:\"date\";s:10:\"1313598120\";s:6:\"mdhash\";s:32:\"f3a6a44ec3e35e91870f8391a9f04ff5\";s:8:\"filesize\";s:5:\"13039\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-1.4\";a:14:{s:4:\"name\";s:21:\"module_filter 7.x-1.4\";s:7:\"version\";s:7:\"7.x-1.4\";s:3:\"tag\";s:7:\"7.x-1.4\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/module_filter/releases/7.x-1.4\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/module_filter-7.x-1.4.tar.gz\";s:4:\"date\";s:10:\"1299525068\";s:6:\"mdhash\";s:32:\"90d9ec10df0b9ee07707f87b96711bca\";s:8:\"filesize\";s:5:\"11570\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-1.3\";a:14:{s:4:\"name\";s:21:\"module_filter 7.x-1.3\";s:7:\"version\";s:7:\"7.x-1.3\";s:3:\"tag\";s:7:\"7.x-1.3\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/module_filter/releases/7.x-1.3\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/module_filter-7.x-1.3.tar.gz\";s:4:\"date\";s:10:\"1299519370\";s:6:\"mdhash\";s:32:\"8a075e4932db8cd4e35371ac276bcb4b\";s:8:\"filesize\";s:5:\"11555\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";s:5:\"terms\";a:0:{}}s:7:\"7.x-1.2\";a:14:{s:4:\"name\";s:21:\"module_filter 7.x-1.2\";s:7:\"version\";s:7:\"7.x-1.2\";s:3:\"tag\";s:7:\"7.x-1.2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/module_filter/releases/7.x-1.2\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/module_filter-7.x-1.2.tar.gz\";s:4:\"date\";s:10:\"1299516669\";s:6:\"mdhash\";s:32:\"afbb784aeb4029294e5877654385cc8c\";s:8:\"filesize\";s:5:\"11446\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-1.1\";a:14:{s:4:\"name\";s:21:\"module_filter 7.x-1.1\";s:7:\"version\";s:7:\"7.x-1.1\";s:3:\"tag\";s:7:\"7.x-1.1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/module_filter/releases/7.x-1.1\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/module_filter-7.x-1.1.tar.gz\";s:4:\"date\";s:10:\"1299515169\";s:6:\"mdhash\";s:32:\"45546c1f5bc473389ffc36f0e38a2bc1\";s:8:\"filesize\";s:5:\"13033\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-1.0\";a:14:{s:4:\"name\";s:21:\"module_filter 7.x-1.0\";s:7:\"version\";s:7:\"7.x-1.0\";s:3:\"tag\";s:7:\"7.x-1.0\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/module_filter/releases/7.x-1.0\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/module_filter-7.x-1.0.tar.gz\";s:4:\"date\";s:10:\"1294104365\";s:6:\"mdhash\";s:32:\"a482aef54751a8fd947bafc2d5ef1ecd\";s:8:\"filesize\";s:5:\"11523\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:11:\"7.x-2.x-dev\";a:14:{s:4:\"name\";s:25:\"module_filter 7.x-2.x-dev\";s:7:\"version\";s:11:\"7.x-2.x-dev\";s:3:\"tag\";s:7:\"7.x-2.x\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:65:\"https://www.drupal.org/project/module_filter/releases/7.x-2.x-dev\";s:13:\"download_link\";s:70:\"https://ftp.drupal.org/files/projects/module_filter-7.x-2.x-dev.tar.gz\";s:4:\"date\";s:10:\"1497029343\";s:6:\"mdhash\";s:32:\"bf63bf30b9a6eecb11e527cc12a87312\";s:8:\"filesize\";s:5:\"29762\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:12:\"New features\";}}s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";}s:11:\"7.x-1.x-dev\";a:14:{s:4:\"name\";s:25:\"module_filter 7.x-1.x-dev\";s:7:\"version\";s:11:\"7.x-1.x-dev\";s:3:\"tag\";s:7:\"7.x-1.x\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:65:\"https://www.drupal.org/project/module_filter/releases/7.x-1.x-dev\";s:13:\"download_link\";s:70:\"https://ftp.drupal.org/files/projects/module_filter-7.x-1.x-dev.tar.gz\";s:4:\"date\";s:10:\"1406917428\";s:6:\"mdhash\";s:32:\"62b7a0ab716b2798d9e60462314d95c5\";s:8:\"filesize\";s:5:\"14743\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}}}',1512706732,1512620327,1),('available_releases::node_class','a:11:{s:5:\"title\";s:10:\"Node Class\";s:10:\"short_name\";s:10:\"node_class\";s:4:\"type\";s:14:\"project_module\";s:11:\"api_version\";s:3:\"7.x\";s:17:\"recommended_major\";s:1:\"1\";s:16:\"supported_majors\";s:1:\"1\";s:13:\"default_major\";s:1:\"1\";s:14:\"project_status\";s:9:\"published\";s:4:\"link\";s:41:\"https://www.drupal.org/project/node_class\";s:5:\"terms\";s:0:\"\";s:8:\"releases\";a:3:{s:7:\"7.x-1.3\";a:14:{s:4:\"name\";s:18:\"node_class 7.x-1.3\";s:7:\"version\";s:7:\"7.x-1.3\";s:3:\"tag\";s:7:\"7.x-1.3\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:58:\"https://www.drupal.org/project/node_class/releases/7.x-1.3\";s:13:\"download_link\";s:63:\"https://ftp.drupal.org/files/projects/node_class-7.x-1.3.tar.gz\";s:4:\"date\";s:10:\"1388997805\";s:6:\"mdhash\";s:32:\"76bc0de128d7108d7131c710798c79a8\";s:8:\"filesize\";s:4:\"8698\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-1.1\";a:14:{s:4:\"name\";s:18:\"node_class 7.x-1.1\";s:7:\"version\";s:7:\"7.x-1.1\";s:3:\"tag\";s:7:\"7.x-1.1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:58:\"https://www.drupal.org/project/node_class/releases/7.x-1.1\";s:13:\"download_link\";s:63:\"https://ftp.drupal.org/files/projects/node_class-7.x-1.1.tar.gz\";s:4:\"date\";s:10:\"1353409388\";s:6:\"mdhash\";s:32:\"7132a7c92d76ee2f6d674d96076f40a3\";s:8:\"filesize\";s:4:\"8733\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";s:5:\"terms\";a:0:{}}s:7:\"7.x-1.0\";a:14:{s:4:\"name\";s:18:\"node_class 7.x-1.0\";s:7:\"version\";s:7:\"7.x-1.0\";s:3:\"tag\";s:7:\"7.x-1.0\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:58:\"https://www.drupal.org/project/node_class/releases/7.x-1.0\";s:13:\"download_link\";s:63:\"https://ftp.drupal.org/files/projects/node_class-7.x-1.0.tar.gz\";s:4:\"date\";s:10:\"1327735847\";s:6:\"mdhash\";s:32:\"63906a6d1f0d1dec47561258a8fe4795\";s:8:\"filesize\";s:4:\"8625\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}}}',1512706732,1512620327,1),('available_releases::pathauto','a:11:{s:5:\"title\";s:8:\"Pathauto\";s:10:\"short_name\";s:8:\"pathauto\";s:4:\"type\";s:14:\"project_module\";s:11:\"api_version\";s:3:\"7.x\";s:17:\"recommended_major\";s:1:\"1\";s:16:\"supported_majors\";s:1:\"1\";s:13:\"default_major\";s:1:\"1\";s:14:\"project_status\";s:9:\"published\";s:4:\"link\";s:39:\"https://www.drupal.org/project/pathauto\";s:5:\"terms\";s:0:\"\";s:8:\"releases\";a:10:{s:7:\"7.x-1.3\";a:14:{s:4:\"name\";s:16:\"pathauto 7.x-1.3\";s:7:\"version\";s:7:\"7.x-1.3\";s:3:\"tag\";s:7:\"7.x-1.3\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/pathauto/releases/7.x-1.3\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/pathauto-7.x-1.3.tar.gz\";s:4:\"date\";s:10:\"1444232639\";s:6:\"mdhash\";s:32:\"ff984b2837230a221d53fad5462c0b61\";s:8:\"filesize\";s:5:\"42319\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-1.2\";a:14:{s:4:\"name\";s:16:\"pathauto 7.x-1.2\";s:7:\"version\";s:7:\"7.x-1.2\";s:3:\"tag\";s:7:\"7.x-1.2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/pathauto/releases/7.x-1.2\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/pathauto-7.x-1.2.tar.gz\";s:4:\"date\";s:10:\"1344525185\";s:6:\"mdhash\";s:32:\"abdb73c49803aefe3c87774a92c42b87\";s:8:\"filesize\";s:5:\"38900\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-1.1\";a:14:{s:4:\"name\";s:16:\"pathauto 7.x-1.1\";s:7:\"version\";s:7:\"7.x-1.1\";s:3:\"tag\";s:7:\"7.x-1.1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/pathauto/releases/7.x-1.1\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/pathauto-7.x-1.1.tar.gz\";s:4:\"date\";s:10:\"1336950382\";s:6:\"mdhash\";s:32:\"ee42c248db62f384871cb526d72005f2\";s:8:\"filesize\";s:5:\"38652\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-1.0\";a:14:{s:4:\"name\";s:16:\"pathauto 7.x-1.0\";s:7:\"version\";s:7:\"7.x-1.0\";s:3:\"tag\";s:7:\"7.x-1.0\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/pathauto/releases/7.x-1.0\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/pathauto-7.x-1.0.tar.gz\";s:4:\"date\";s:10:\"1320072936\";s:6:\"mdhash\";s:32:\"6edd617da0cfa31ddde247933d670ef4\";s:8:\"filesize\";s:5:\"37196\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:11:\"7.x-1.0-rc2\";a:15:{s:4:\"name\";s:20:\"pathauto 7.x-1.0-rc2\";s:7:\"version\";s:11:\"7.x-1.0-rc2\";s:3:\"tag\";s:11:\"7.x-1.0-rc2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:60:\"https://www.drupal.org/project/pathauto/releases/7.x-1.0-rc2\";s:13:\"download_link\";s:65:\"https://ftp.drupal.org/files/projects/pathauto-7.x-1.0-rc2.tar.gz\";s:4:\"date\";s:10:\"1308241021\";s:6:\"mdhash\";s:32:\"376c28fa39f3b383ad5134c5a1360be7\";s:8:\"filesize\";s:5:\"35681\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:11:\"7.x-1.0-rc1\";a:15:{s:4:\"name\";s:20:\"pathauto 7.x-1.0-rc1\";s:7:\"version\";s:11:\"7.x-1.0-rc1\";s:3:\"tag\";s:11:\"7.x-1.0-rc1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:60:\"https://www.drupal.org/project/pathauto/releases/7.x-1.0-rc1\";s:13:\"download_link\";s:65:\"https://ftp.drupal.org/files/projects/pathauto-7.x-1.0-rc1.tar.gz\";s:4:\"date\";s:10:\"1308121619\";s:6:\"mdhash\";s:32:\"a53a56cffaaa67c8775c085d542f162c\";s:8:\"filesize\";s:5:\"35350\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:13:\"7.x-1.0-beta1\";a:15:{s:4:\"name\";s:22:\"pathauto 7.x-1.0-beta1\";s:7:\"version\";s:13:\"7.x-1.0-beta1\";s:3:\"tag\";s:13:\"7.x-1.0-beta1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/pathauto/releases/7.x-1.0-beta1\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/pathauto-7.x-1.0-beta1.tar.gz\";s:4:\"date\";s:10:\"1294891602\";s:6:\"mdhash\";s:32:\"37c8eaa37d69d60303e702c271f99f9e\";s:8:\"filesize\";s:5:\"56885\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}s:14:\"7.x-1.0-alpha2\";a:15:{s:4:\"name\";s:23:\"pathauto 7.x-1.0-alpha2\";s:7:\"version\";s:14:\"7.x-1.0-alpha2\";s:3:\"tag\";s:14:\"7.x-1.0-alpha2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:63:\"https://www.drupal.org/project/pathauto/releases/7.x-1.0-alpha2\";s:13:\"download_link\";s:68:\"https://ftp.drupal.org/files/projects/pathauto-7.x-1.0-alpha2.tar.gz\";s:4:\"date\";s:10:\"1281556294\";s:6:\"mdhash\";s:32:\"5f4aecc1b5d6a6e4365fafcc7f0efe15\";s:8:\"filesize\";s:6:\"122301\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:3:{i:0;s:15:\"Security update\";i:1;s:12:\"New features\";i:2;s:9:\"Bug fixes\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:14:\"7.x-1.0-alpha1\";a:15:{s:4:\"name\";s:23:\"pathauto 7.x-1.0-alpha1\";s:7:\"version\";s:14:\"7.x-1.0-alpha1\";s:3:\"tag\";s:14:\"7.x-1.0-alpha1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:63:\"https://www.drupal.org/project/pathauto/releases/7.x-1.0-alpha1\";s:13:\"download_link\";s:68:\"https://ftp.drupal.org/files/projects/pathauto-7.x-1.0-alpha1.tar.gz\";s:4:\"date\";s:10:\"1267300506\";s:6:\"mdhash\";s:32:\"ec86f7a12f9b4daa02967a3d7ccedef6\";s:8:\"filesize\";s:6:\"121249\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}s:11:\"7.x-1.x-dev\";a:14:{s:4:\"name\";s:20:\"pathauto 7.x-1.x-dev\";s:7:\"version\";s:11:\"7.x-1.x-dev\";s:3:\"tag\";s:7:\"7.x-1.x\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:60:\"https://www.drupal.org/project/pathauto/releases/7.x-1.x-dev\";s:13:\"download_link\";s:65:\"https://ftp.drupal.org/files/projects/pathauto-7.x-1.x-dev.tar.gz\";s:4:\"date\";s:10:\"1472576639\";s:6:\"mdhash\";s:32:\"a597c609ed9d356b6ad4faa978b12aa7\";s:8:\"filesize\";s:5:\"42278\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";}}}',1512706732,1512620327,1),('available_releases::quicktabs','a:11:{s:5:\"title\";s:10:\"Quick Tabs\";s:10:\"short_name\";s:9:\"quicktabs\";s:4:\"type\";s:14:\"project_module\";s:11:\"api_version\";s:3:\"7.x\";s:17:\"recommended_major\";s:1:\"3\";s:16:\"supported_majors\";s:1:\"3\";s:13:\"default_major\";s:1:\"3\";s:14:\"project_status\";s:9:\"published\";s:4:\"link\";s:40:\"https://www.drupal.org/project/quicktabs\";s:5:\"terms\";s:0:\"\";s:8:\"releases\";a:18:{s:7:\"7.x-3.8\";a:14:{s:4:\"name\";s:17:\"quicktabs 7.x-3.8\";s:7:\"version\";s:7:\"7.x-3.8\";s:3:\"tag\";s:7:\"7.x-3.8\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"8\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:57:\"https://www.drupal.org/project/quicktabs/releases/7.x-3.8\";s:13:\"download_link\";s:62:\"https://ftp.drupal.org/files/projects/quicktabs-7.x-3.8.tar.gz\";s:4:\"date\";s:10:\"1497619442\";s:6:\"mdhash\";s:32:\"63da431afe05b274f0e8a87a8bb2febf\";s:8:\"filesize\";s:5:\"75912\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-3.7\";a:14:{s:4:\"name\";s:17:\"quicktabs 7.x-3.7\";s:7:\"version\";s:7:\"7.x-3.7\";s:3:\"tag\";s:7:\"7.x-3.7\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"7\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:57:\"https://www.drupal.org/project/quicktabs/releases/7.x-3.7\";s:13:\"download_link\";s:62:\"https://ftp.drupal.org/files/projects/quicktabs-7.x-3.7.tar.gz\";s:4:\"date\";s:10:\"1497616742\";s:6:\"mdhash\";s:32:\"32aff4d6407e4d0d564211cfdeaee291\";s:8:\"filesize\";s:5:\"75918\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-3.6\";a:14:{s:4:\"name\";s:17:\"quicktabs 7.x-3.6\";s:7:\"version\";s:7:\"7.x-3.6\";s:3:\"tag\";s:7:\"7.x-3.6\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"6\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:57:\"https://www.drupal.org/project/quicktabs/releases/7.x-3.6\";s:13:\"download_link\";s:62:\"https://ftp.drupal.org/files/projects/quicktabs-7.x-3.6.tar.gz\";s:4:\"date\";s:10:\"1380731930\";s:6:\"mdhash\";s:32:\"b5303635e54ba0677822bf3cd15169d3\";s:8:\"filesize\";s:5:\"75170\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:3:{i:0;s:15:\"Security update\";i:1;s:12:\"New features\";i:2;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-3.5\";a:14:{s:4:\"name\";s:17:\"quicktabs 7.x-3.5\";s:7:\"version\";s:7:\"7.x-3.5\";s:3:\"tag\";s:7:\"7.x-3.5\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"5\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:57:\"https://www.drupal.org/project/quicktabs/releases/7.x-3.5\";s:13:\"download_link\";s:62:\"https://ftp.drupal.org/files/projects/quicktabs-7.x-3.5.tar.gz\";s:4:\"date\";s:10:\"1379371264\";s:6:\"mdhash\";s:32:\"e858cf2dac05ba4e75be5cb34420eeec\";s:8:\"filesize\";s:5:\"74756\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-3.4\";a:14:{s:4:\"name\";s:17:\"quicktabs 7.x-3.4\";s:7:\"version\";s:7:\"7.x-3.4\";s:3:\"tag\";s:7:\"7.x-3.4\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:57:\"https://www.drupal.org/project/quicktabs/releases/7.x-3.4\";s:13:\"download_link\";s:62:\"https://ftp.drupal.org/files/projects/quicktabs-7.x-3.4.tar.gz\";s:4:\"date\";s:10:\"1332980461\";s:6:\"mdhash\";s:32:\"e83ce594c509577a44305ae2df6aa0f9\";s:8:\"filesize\";s:5:\"74329\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-3.3\";a:14:{s:4:\"name\";s:17:\"quicktabs 7.x-3.3\";s:7:\"version\";s:7:\"7.x-3.3\";s:3:\"tag\";s:7:\"7.x-3.3\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:57:\"https://www.drupal.org/project/quicktabs/releases/7.x-3.3\";s:13:\"download_link\";s:62:\"https://ftp.drupal.org/files/projects/quicktabs-7.x-3.3.tar.gz\";s:4:\"date\";s:10:\"1326919545\";s:6:\"mdhash\";s:32:\"fbb89f0a5312265335f4e4dcece951fe\";s:8:\"filesize\";s:5:\"74693\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:15:\"Security update\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-3.2\";a:14:{s:4:\"name\";s:17:\"quicktabs 7.x-3.2\";s:7:\"version\";s:7:\"7.x-3.2\";s:3:\"tag\";s:7:\"7.x-3.2\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:57:\"https://www.drupal.org/project/quicktabs/releases/7.x-3.2\";s:13:\"download_link\";s:62:\"https://ftp.drupal.org/files/projects/quicktabs-7.x-3.2.tar.gz\";s:4:\"date\";s:10:\"1322002246\";s:6:\"mdhash\";s:32:\"dd699e185849623700473fc0c55251fd\";s:8:\"filesize\";s:5:\"75019\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-3.1\";a:14:{s:4:\"name\";s:17:\"quicktabs 7.x-3.1\";s:7:\"version\";s:7:\"7.x-3.1\";s:3:\"tag\";s:7:\"7.x-3.1\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:57:\"https://www.drupal.org/project/quicktabs/releases/7.x-3.1\";s:13:\"download_link\";s:62:\"https://ftp.drupal.org/files/projects/quicktabs-7.x-3.1.tar.gz\";s:4:\"date\";s:10:\"1321421443\";s:6:\"mdhash\";s:32:\"67e283dd6981dcfa10644d7288636f6c\";s:8:\"filesize\";s:5:\"74986\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-3.0\";a:14:{s:4:\"name\";s:17:\"quicktabs 7.x-3.0\";s:7:\"version\";s:7:\"7.x-3.0\";s:3:\"tag\";s:7:\"7.x-3.0\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:57:\"https://www.drupal.org/project/quicktabs/releases/7.x-3.0\";s:13:\"download_link\";s:62:\"https://ftp.drupal.org/files/projects/quicktabs-7.x-3.0.tar.gz\";s:4:\"date\";s:10:\"1312172228\";s:6:\"mdhash\";s:32:\"4c72ff22d7eaa9b3e5bd22acfe5c286e\";s:8:\"filesize\";s:5:\"71391\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:13:\"7.x-3.0-beta3\";a:15:{s:4:\"name\";s:23:\"quicktabs 7.x-3.0-beta3\";s:7:\"version\";s:13:\"7.x-3.0-beta3\";s:3:\"tag\";s:13:\"7.x-3.0-beta3\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:63:\"https://www.drupal.org/project/quicktabs/releases/7.x-3.0-beta3\";s:13:\"download_link\";s:68:\"https://ftp.drupal.org/files/projects/quicktabs-7.x-3.0-beta3.tar.gz\";s:4:\"date\";s:10:\"1311958019\";s:6:\"mdhash\";s:32:\"f25f6d00a21f083db6b73726517282e0\";s:8:\"filesize\";s:5:\"70957\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"7.x-3.0-beta2\";a:15:{s:4:\"name\";s:23:\"quicktabs 7.x-3.0-beta2\";s:7:\"version\";s:13:\"7.x-3.0-beta2\";s:3:\"tag\";s:13:\"7.x-3.0-beta2\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:63:\"https://www.drupal.org/project/quicktabs/releases/7.x-3.0-beta2\";s:13:\"download_link\";s:68:\"https://ftp.drupal.org/files/projects/quicktabs-7.x-3.0-beta2.tar.gz\";s:4:\"date\";s:10:\"1311491011\";s:6:\"mdhash\";s:32:\"fe549974c22f34eedd34255c7188bf4e\";s:8:\"filesize\";s:5:\"70854\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"7.x-3.0-beta1\";a:15:{s:4:\"name\";s:23:\"quicktabs 7.x-3.0-beta1\";s:7:\"version\";s:13:\"7.x-3.0-beta1\";s:3:\"tag\";s:13:\"7.x-3.0-beta1\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:63:\"https://www.drupal.org/project/quicktabs/releases/7.x-3.0-beta1\";s:13:\"download_link\";s:68:\"https://ftp.drupal.org/files/projects/quicktabs-7.x-3.0-beta1.tar.gz\";s:4:\"date\";s:10:\"1309974420\";s:6:\"mdhash\";s:32:\"b7568736c672a0f58f780543621755ca\";s:8:\"filesize\";s:5:\"70850\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:14:\"7.x-3.0-alpha2\";a:15:{s:4:\"name\";s:24:\"quicktabs 7.x-3.0-alpha2\";s:7:\"version\";s:14:\"7.x-3.0-alpha2\";s:3:\"tag\";s:14:\"7.x-3.0-alpha2\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:64:\"https://www.drupal.org/project/quicktabs/releases/7.x-3.0-alpha2\";s:13:\"download_link\";s:69:\"https://ftp.drupal.org/files/projects/quicktabs-7.x-3.0-alpha2.tar.gz\";s:4:\"date\";s:10:\"1308089219\";s:6:\"mdhash\";s:32:\"5b4fa99ea7b0cf1382ac51fdcad1ad4c\";s:8:\"filesize\";s:5:\"69431\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:14:\"7.x-3.0-alpha1\";a:15:{s:4:\"name\";s:24:\"quicktabs 7.x-3.0-alpha1\";s:7:\"version\";s:14:\"7.x-3.0-alpha1\";s:3:\"tag\";s:14:\"7.x-3.0-alpha1\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:64:\"https://www.drupal.org/project/quicktabs/releases/7.x-3.0-alpha1\";s:13:\"download_link\";s:69:\"https://ftp.drupal.org/files/projects/quicktabs-7.x-3.0-alpha1.tar.gz\";s:4:\"date\";s:10:\"1308027419\";s:6:\"mdhash\";s:32:\"9f86f3615e5a54e038fd9e5a54f98388\";s:8:\"filesize\";s:5:\"69236\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:12:\"New features\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:7:\"7.x-2.0\";a:14:{s:4:\"name\";s:17:\"quicktabs 7.x-2.0\";s:7:\"version\";s:7:\"7.x-2.0\";s:3:\"tag\";s:7:\"7.x-2.0\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:57:\"https://www.drupal.org/project/quicktabs/releases/7.x-2.0\";s:13:\"download_link\";s:62:\"https://ftp.drupal.org/files/projects/quicktabs-7.x-2.0.tar.gz\";s:4:\"date\";s:10:\"1312172227\";s:6:\"mdhash\";s:32:\"40ad6420da071e758c04f5df81693ef5\";s:8:\"filesize\";s:5:\"59833\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:13:\"7.x-2.0-beta1\";a:15:{s:4:\"name\";s:23:\"quicktabs 7.x-2.0-beta1\";s:7:\"version\";s:13:\"7.x-2.0-beta1\";s:3:\"tag\";s:13:\"7.x-2.0-beta1\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:63:\"https://www.drupal.org/project/quicktabs/releases/7.x-2.0-beta1\";s:13:\"download_link\";s:68:\"https://ftp.drupal.org/files/projects/quicktabs-7.x-2.0-beta1.tar.gz\";s:4:\"date\";s:10:\"1301378169\";s:6:\"mdhash\";s:32:\"abd93c7fc0a33eeacd769a3d87bf9534\";s:8:\"filesize\";s:5:\"59501\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}s:11:\"7.x-3.x-dev\";a:14:{s:4:\"name\";s:21:\"quicktabs 7.x-3.x-dev\";s:7:\"version\";s:11:\"7.x-3.x-dev\";s:3:\"tag\";s:7:\"7.x-3.x\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/quicktabs/releases/7.x-3.x-dev\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/quicktabs-7.x-3.x-dev.tar.gz\";s:4:\"date\";s:10:\"1498214642\";s:6:\"mdhash\";s:32:\"dcfb62b3bd04a3027007a194a78bbb79\";s:8:\"filesize\";s:5:\"76036\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:12:\"New features\";}}s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";}s:11:\"7.x-2.x-dev\";a:14:{s:4:\"name\";s:21:\"quicktabs 7.x-2.x-dev\";s:7:\"version\";s:11:\"7.x-2.x-dev\";s:3:\"tag\";s:7:\"7.x-2.x\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/quicktabs/releases/7.x-2.x-dev\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/quicktabs-7.x-2.x-dev.tar.gz\";s:4:\"date\";s:10:\"1380624610\";s:6:\"mdhash\";s:32:\"38b7a23c5a2201c1e9d4b9eace929654\";s:8:\"filesize\";s:5:\"61020\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}}}',1512706732,1512620327,1),('available_releases::remember_me','a:11:{s:5:\"title\";s:11:\"Remember me\";s:10:\"short_name\";s:11:\"remember_me\";s:4:\"type\";s:14:\"project_module\";s:11:\"api_version\";s:3:\"7.x\";s:17:\"recommended_major\";s:1:\"1\";s:16:\"supported_majors\";s:1:\"1\";s:13:\"default_major\";s:1:\"1\";s:14:\"project_status\";s:9:\"published\";s:4:\"link\";s:42:\"https://www.drupal.org/project/remember_me\";s:5:\"terms\";s:0:\"\";s:8:\"releases\";a:6:{s:7:\"7.x-1.1\";a:14:{s:4:\"name\";s:19:\"remember_me 7.x-1.1\";s:7:\"version\";s:7:\"7.x-1.1\";s:3:\"tag\";s:7:\"7.x-1.1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:59:\"https://www.drupal.org/project/remember_me/releases/7.x-1.1\";s:13:\"download_link\";s:64:\"https://ftp.drupal.org/files/projects/remember_me-7.x-1.1.tar.gz\";s:4:\"date\";s:10:\"1492928943\";s:6:\"mdhash\";s:32:\"6219d5ec3c6da162f180c4f5f5519137\";s:8:\"filesize\";s:5:\"10053\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:15:\"Security update\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-1.0\";a:14:{s:4:\"name\";s:19:\"remember_me 7.x-1.0\";s:7:\"version\";s:7:\"7.x-1.0\";s:3:\"tag\";s:7:\"7.x-1.0\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:59:\"https://www.drupal.org/project/remember_me/releases/7.x-1.0\";s:13:\"download_link\";s:64:\"https://ftp.drupal.org/files/projects/remember_me-7.x-1.0.tar.gz\";s:4:\"date\";s:10:\"1333644074\";s:6:\"mdhash\";s:32:\"0eb3c49756ef02103022ae96dbb940fc\";s:8:\"filesize\";s:5:\"10131\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:11:\"7.x-1.0-rc3\";a:15:{s:4:\"name\";s:23:\"remember_me 7.x-1.0-rc3\";s:7:\"version\";s:11:\"7.x-1.0-rc3\";s:3:\"tag\";s:11:\"7.x-1.0-rc3\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:63:\"https://www.drupal.org/project/remember_me/releases/7.x-1.0-rc3\";s:13:\"download_link\";s:68:\"https://ftp.drupal.org/files/projects/remember_me-7.x-1.0-rc3.tar.gz\";s:4:\"date\";s:10:\"1329521439\";s:6:\"mdhash\";s:32:\"e61d111a8693c34456b1a39a4a76a0b9\";s:8:\"filesize\";s:5:\"10132\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:11:\"7.x-1.0-rc2\";a:15:{s:4:\"name\";s:23:\"remember_me 7.x-1.0-rc2\";s:7:\"version\";s:11:\"7.x-1.0-rc2\";s:3:\"tag\";s:11:\"7.x-1.0-rc2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:63:\"https://www.drupal.org/project/remember_me/releases/7.x-1.0-rc2\";s:13:\"download_link\";s:68:\"https://ftp.drupal.org/files/projects/remember_me-7.x-1.0-rc2.tar.gz\";s:4:\"date\";s:10:\"1329485444\";s:6:\"mdhash\";s:32:\"1c06470314c61db1caedb29384e2c789\";s:8:\"filesize\";s:5:\"10194\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:11:\"7.x-1.0-rc1\";a:15:{s:4:\"name\";s:23:\"remember_me 7.x-1.0-rc1\";s:7:\"version\";s:11:\"7.x-1.0-rc1\";s:3:\"tag\";s:11:\"7.x-1.0-rc1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:63:\"https://www.drupal.org/project/remember_me/releases/7.x-1.0-rc1\";s:13:\"download_link\";s:68:\"https://ftp.drupal.org/files/projects/remember_me-7.x-1.0-rc1.tar.gz\";s:4:\"date\";s:10:\"1327554345\";s:6:\"mdhash\";s:32:\"279e6d2169084b39fcffcd9927773883\";s:8:\"filesize\";s:5:\"10339\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:11:\"7.x-1.x-dev\";a:14:{s:4:\"name\";s:23:\"remember_me 7.x-1.x-dev\";s:7:\"version\";s:11:\"7.x-1.x-dev\";s:3:\"tag\";s:7:\"7.x-1.x\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:63:\"https://www.drupal.org/project/remember_me/releases/7.x-1.x-dev\";s:13:\"download_link\";s:68:\"https://ftp.drupal.org/files/projects/remember_me-7.x-1.x-dev.tar.gz\";s:4:\"date\";s:10:\"1494577385\";s:6:\"mdhash\";s:32:\"e0dc6aa9cf38fad85e9285a46457290d\";s:8:\"filesize\";s:5:\"10040\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}}}',1512706732,1512620327,1),('available_releases::sharethis','a:11:{s:5:\"title\";s:9:\"ShareThis\";s:10:\"short_name\";s:9:\"sharethis\";s:4:\"type\";s:14:\"project_module\";s:11:\"api_version\";s:3:\"7.x\";s:17:\"recommended_major\";s:1:\"2\";s:16:\"supported_majors\";s:1:\"2\";s:13:\"default_major\";s:1:\"2\";s:14:\"project_status\";s:9:\"published\";s:4:\"link\";s:40:\"https://www.drupal.org/project/sharethis\";s:5:\"terms\";s:0:\"\";s:8:\"releases\";a:18:{s:8:\"7.x-2.13\";a:14:{s:4:\"name\";s:18:\"sharethis 7.x-2.13\";s:7:\"version\";s:8:\"7.x-2.13\";s:3:\"tag\";s:8:\"7.x-2.13\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:2:\"13\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:58:\"https://www.drupal.org/project/sharethis/releases/7.x-2.13\";s:13:\"download_link\";s:63:\"https://ftp.drupal.org/files/projects/sharethis-7.x-2.13.tar.gz\";s:4:\"date\";s:10:\"1468581839\";s:6:\"mdhash\";s:32:\"f3f446bf449c62592963af24d0e947c8\";s:8:\"filesize\";s:6:\"104699\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:8:\"7.x-2.12\";a:14:{s:4:\"name\";s:18:\"sharethis 7.x-2.12\";s:7:\"version\";s:8:\"7.x-2.12\";s:3:\"tag\";s:8:\"7.x-2.12\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:2:\"12\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:58:\"https://www.drupal.org/project/sharethis/releases/7.x-2.12\";s:13:\"download_link\";s:63:\"https://ftp.drupal.org/files/projects/sharethis-7.x-2.12.tar.gz\";s:4:\"date\";s:10:\"1435896243\";s:6:\"mdhash\";s:32:\"271241bed99c04a997585639421163bd\";s:8:\"filesize\";s:6:\"213053\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:8:\"7.x-2.11\";a:14:{s:4:\"name\";s:18:\"sharethis 7.x-2.11\";s:7:\"version\";s:8:\"7.x-2.11\";s:3:\"tag\";s:8:\"7.x-2.11\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:2:\"11\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:58:\"https://www.drupal.org/project/sharethis/releases/7.x-2.11\";s:13:\"download_link\";s:63:\"https://ftp.drupal.org/files/projects/sharethis-7.x-2.11.tar.gz\";s:4:\"date\";s:10:\"1435141080\";s:6:\"mdhash\";s:32:\"d0b2aa1a9ddca61eb87f32d472ffc2df\";s:8:\"filesize\";s:6:\"212917\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:8:\"7.x-2.10\";a:14:{s:4:\"name\";s:18:\"sharethis 7.x-2.10\";s:7:\"version\";s:8:\"7.x-2.10\";s:3:\"tag\";s:8:\"7.x-2.10\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:2:\"10\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:58:\"https://www.drupal.org/project/sharethis/releases/7.x-2.10\";s:13:\"download_link\";s:63:\"https://ftp.drupal.org/files/projects/sharethis-7.x-2.10.tar.gz\";s:4:\"date\";s:10:\"1422441781\";s:6:\"mdhash\";s:32:\"03583f04d6a98b8879a71b529ae2c4b2\";s:8:\"filesize\";s:6:\"213013\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-2.9\";a:14:{s:4:\"name\";s:17:\"sharethis 7.x-2.9\";s:7:\"version\";s:7:\"7.x-2.9\";s:3:\"tag\";s:7:\"7.x-2.9\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"9\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:57:\"https://www.drupal.org/project/sharethis/releases/7.x-2.9\";s:13:\"download_link\";s:62:\"https://ftp.drupal.org/files/projects/sharethis-7.x-2.9.tar.gz\";s:4:\"date\";s:10:\"1406878136\";s:6:\"mdhash\";s:32:\"bc9592c60974a262224b1132e043d3bb\";s:8:\"filesize\";s:6:\"231394\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-2.8\";a:14:{s:4:\"name\";s:17:\"sharethis 7.x-2.8\";s:7:\"version\";s:7:\"7.x-2.8\";s:3:\"tag\";s:7:\"7.x-2.8\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"8\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:57:\"https://www.drupal.org/project/sharethis/releases/7.x-2.8\";s:13:\"download_link\";s:62:\"https://ftp.drupal.org/files/projects/sharethis-7.x-2.8.tar.gz\";s:4:\"date\";s:10:\"1402042727\";s:6:\"mdhash\";s:32:\"0b7e41166e70a4c39a44976a788dc049\";s:8:\"filesize\";s:6:\"215617\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-2.6\";a:14:{s:4:\"name\";s:17:\"sharethis 7.x-2.6\";s:7:\"version\";s:7:\"7.x-2.6\";s:3:\"tag\";s:7:\"7.x-2.6\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"6\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:57:\"https://www.drupal.org/project/sharethis/releases/7.x-2.6\";s:13:\"download_link\";s:62:\"https://ftp.drupal.org/files/projects/sharethis-7.x-2.6.tar.gz\";s:4:\"date\";s:10:\"1397215753\";s:6:\"mdhash\";s:32:\"f5b19bd07c8d7a6fd007a5b00d2f6579\";s:8:\"filesize\";s:6:\"207036\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:14:\"7.x-2.6-alpha1\";a:15:{s:4:\"name\";s:24:\"sharethis 7.x-2.6-alpha1\";s:7:\"version\";s:14:\"7.x-2.6-alpha1\";s:3:\"tag\";s:14:\"7.x-2.6-alpha1\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"6\";s:13:\"version_extra\";s:6:\"alpha1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:64:\"https://www.drupal.org/project/sharethis/releases/7.x-2.6-alpha1\";s:13:\"download_link\";s:69:\"https://ftp.drupal.org/files/projects/sharethis-7.x-2.6-alpha1.tar.gz\";s:4:\"date\";s:10:\"1352821394\";s:6:\"mdhash\";s:32:\"fe9ef42be3d987bfdb49a387771311bf\";s:8:\"filesize\";s:6:\"209885\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:7:\"7.x-2.5\";a:14:{s:4:\"name\";s:17:\"sharethis 7.x-2.5\";s:7:\"version\";s:7:\"7.x-2.5\";s:3:\"tag\";s:7:\"7.x-2.5\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"5\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:57:\"https://www.drupal.org/project/sharethis/releases/7.x-2.5\";s:13:\"download_link\";s:62:\"https://ftp.drupal.org/files/projects/sharethis-7.x-2.5.tar.gz\";s:4:\"date\";s:10:\"1349883717\";s:6:\"mdhash\";s:32:\"93cca418501ea64712a64fb6188d96f0\";s:8:\"filesize\";s:6:\"209675\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:15:\"Security update\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-2.4\";a:14:{s:4:\"name\";s:17:\"sharethis 7.x-2.4\";s:7:\"version\";s:7:\"7.x-2.4\";s:3:\"tag\";s:7:\"7.x-2.4\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:57:\"https://www.drupal.org/project/sharethis/releases/7.x-2.4\";s:13:\"download_link\";s:62:\"https://ftp.drupal.org/files/projects/sharethis-7.x-2.4.tar.gz\";s:4:\"date\";s:10:\"1334781723\";s:6:\"mdhash\";s:32:\"73de56620358ef4a0101a9f9e4eb2f7e\";s:8:\"filesize\";s:6:\"209110\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-2.3\";a:14:{s:4:\"name\";s:17:\"sharethis 7.x-2.3\";s:7:\"version\";s:7:\"7.x-2.3\";s:3:\"tag\";s:7:\"7.x-2.3\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:57:\"https://www.drupal.org/project/sharethis/releases/7.x-2.3\";s:13:\"download_link\";s:62:\"https://ftp.drupal.org/files/projects/sharethis-7.x-2.3.tar.gz\";s:4:\"date\";s:10:\"1332868247\";s:6:\"mdhash\";s:32:\"4e21af8f17509be7d8e054b3afeefbd1\";s:8:\"filesize\";s:6:\"208832\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:3:{i:0;s:15:\"Security update\";i:1;s:12:\"New features\";i:2;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-2.2\";a:14:{s:4:\"name\";s:17:\"sharethis 7.x-2.2\";s:7:\"version\";s:7:\"7.x-2.2\";s:3:\"tag\";s:7:\"7.x-2.2\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:57:\"https://www.drupal.org/project/sharethis/releases/7.x-2.2\";s:13:\"download_link\";s:62:\"https://ftp.drupal.org/files/projects/sharethis-7.x-2.2.tar.gz\";s:4:\"date\";s:10:\"1317251208\";s:6:\"mdhash\";s:32:\"10f75d998555fd6652dc5d563c409e76\";s:8:\"filesize\";s:6:\"207566\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-2.1\";a:14:{s:4:\"name\";s:17:\"sharethis 7.x-2.1\";s:7:\"version\";s:7:\"7.x-2.1\";s:3:\"tag\";s:7:\"7.x-2.1\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:57:\"https://www.drupal.org/project/sharethis/releases/7.x-2.1\";s:13:\"download_link\";s:62:\"https://ftp.drupal.org/files/projects/sharethis-7.x-2.1.tar.gz\";s:4:\"date\";s:10:\"1316724707\";s:6:\"mdhash\";s:32:\"e6722e600d5d31ae65b5c74f03f3a4e0\";s:8:\"filesize\";s:6:\"207558\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-2.0\";a:14:{s:4:\"name\";s:17:\"sharethis 7.x-2.0\";s:7:\"version\";s:7:\"7.x-2.0\";s:3:\"tag\";s:7:\"7.x-2.0\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:57:\"https://www.drupal.org/project/sharethis/releases/7.x-2.0\";s:13:\"download_link\";s:62:\"https://ftp.drupal.org/files/projects/sharethis-7.x-2.0.tar.gz\";s:4:\"date\";s:10:\"1316650599\";s:6:\"mdhash\";s:32:\"3c9b76e4ed786e385918ab79c53b0bad\";s:8:\"filesize\";s:6:\"207436\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-1.1\";a:14:{s:4:\"name\";s:17:\"sharethis 7.x-1.1\";s:7:\"version\";s:7:\"7.x-1.1\";s:3:\"tag\";s:7:\"7.x-1.1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:57:\"https://www.drupal.org/project/sharethis/releases/7.x-1.1\";s:13:\"download_link\";s:62:\"https://ftp.drupal.org/files/projects/sharethis-7.x-1.1.tar.gz\";s:4:\"date\";s:10:\"1308855119\";s:6:\"mdhash\";s:32:\"df53da5631266505fef7b61b98ff0230\";s:8:\"filesize\";s:6:\"205563\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-1.0\";a:14:{s:4:\"name\";s:17:\"sharethis 7.x-1.0\";s:7:\"version\";s:7:\"7.x-1.0\";s:3:\"tag\";s:7:\"7.x-1.0\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:57:\"https://www.drupal.org/project/sharethis/releases/7.x-1.0\";s:13:\"download_link\";s:62:\"https://ftp.drupal.org/files/projects/sharethis-7.x-1.0.tar.gz\";s:4:\"date\";s:10:\"1307461619\";s:6:\"mdhash\";s:32:\"daf3f54b938a0a5de1c2c63c233a2f72\";s:8:\"filesize\";s:6:\"205564\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:11:\"7.x-2.x-dev\";a:14:{s:4:\"name\";s:21:\"sharethis 7.x-2.x-dev\";s:7:\"version\";s:11:\"7.x-2.x-dev\";s:3:\"tag\";s:7:\"7.x-2.x\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/sharethis/releases/7.x-2.x-dev\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/sharethis-7.x-2.x-dev.tar.gz\";s:4:\"date\";s:10:\"1510999985\";s:6:\"mdhash\";s:32:\"554daed67dc25a02672bfabb9f082344\";s:8:\"filesize\";s:6:\"104906\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}s:11:\"7.x-1.x-dev\";a:14:{s:4:\"name\";s:21:\"sharethis 7.x-1.x-dev\";s:7:\"version\";s:11:\"7.x-1.x-dev\";s:3:\"tag\";s:7:\"7.x-1.x\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/sharethis/releases/7.x-1.x-dev\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/sharethis-7.x-1.x-dev.tar.gz\";s:4:\"date\";s:10:\"1380627608\";s:6:\"mdhash\";s:32:\"b890d391c214948357d22adc2aedaa98\";s:8:\"filesize\";s:6:\"207567\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}}}',1512706732,1512620327,1),('available_releases::shortcode','a:11:{s:5:\"title\";s:9:\"Shortcode\";s:10:\"short_name\";s:9:\"shortcode\";s:4:\"type\";s:14:\"project_module\";s:11:\"api_version\";s:3:\"7.x\";s:17:\"recommended_major\";s:1:\"2\";s:16:\"supported_majors\";s:1:\"2\";s:13:\"default_major\";s:1:\"2\";s:14:\"project_status\";s:9:\"published\";s:4:\"link\";s:40:\"https://www.drupal.org/project/shortcode\";s:5:\"terms\";s:0:\"\";s:8:\"releases\";a:12:{s:8:\"7.x-2.25\";a:14:{s:4:\"name\";s:18:\"shortcode 7.x-2.25\";s:7:\"version\";s:8:\"7.x-2.25\";s:3:\"tag\";s:8:\"7.x-2.25\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:2:\"25\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:58:\"https://www.drupal.org/project/shortcode/releases/7.x-2.25\";s:13:\"download_link\";s:63:\"https://ftp.drupal.org/files/projects/shortcode-7.x-2.25.tar.gz\";s:4:\"date\";s:10:\"1512417784\";s:6:\"mdhash\";s:32:\"08e5d7df166849ae50bf9cc27ecf9898\";s:8:\"filesize\";s:5:\"19313\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:8:\"7.x-2.24\";a:14:{s:4:\"name\";s:18:\"shortcode 7.x-2.24\";s:7:\"version\";s:8:\"7.x-2.24\";s:3:\"tag\";s:8:\"7.x-2.24\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:2:\"24\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:58:\"https://www.drupal.org/project/shortcode/releases/7.x-2.24\";s:13:\"download_link\";s:63:\"https://ftp.drupal.org/files/projects/shortcode-7.x-2.24.tar.gz\";s:4:\"date\";s:10:\"1510127586\";s:6:\"mdhash\";s:32:\"98162630bf970653449f4018319e56e5\";s:8:\"filesize\";s:5:\"19284\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:8:\"7.x-2.23\";a:14:{s:4:\"name\";s:18:\"shortcode 7.x-2.23\";s:7:\"version\";s:8:\"7.x-2.23\";s:3:\"tag\";s:8:\"7.x-2.23\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:2:\"23\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:58:\"https://www.drupal.org/project/shortcode/releases/7.x-2.23\";s:13:\"download_link\";s:63:\"https://ftp.drupal.org/files/projects/shortcode-7.x-2.23.tar.gz\";s:4:\"date\";s:10:\"1508523544\";s:6:\"mdhash\";s:32:\"fe26ae91d20157fa078f9d5f4925a650\";s:8:\"filesize\";s:5:\"19248\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:8:\"7.x-2.22\";a:14:{s:4:\"name\";s:18:\"shortcode 7.x-2.22\";s:7:\"version\";s:8:\"7.x-2.22\";s:3:\"tag\";s:8:\"7.x-2.22\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:2:\"22\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:58:\"https://www.drupal.org/project/shortcode/releases/7.x-2.22\";s:13:\"download_link\";s:63:\"https://ftp.drupal.org/files/projects/shortcode-7.x-2.22.tar.gz\";s:4:\"date\";s:10:\"1431600781\";s:6:\"mdhash\";s:32:\"efc26c432621621a2da07be817f30ebd\";s:8:\"filesize\";s:5:\"19181\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:8:\"7.x-2.21\";a:14:{s:4:\"name\";s:18:\"shortcode 7.x-2.21\";s:7:\"version\";s:8:\"7.x-2.21\";s:3:\"tag\";s:8:\"7.x-2.21\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:2:\"21\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:58:\"https://www.drupal.org/project/shortcode/releases/7.x-2.21\";s:13:\"download_link\";s:63:\"https://ftp.drupal.org/files/projects/shortcode-7.x-2.21.tar.gz\";s:4:\"date\";s:10:\"1429272781\";s:6:\"mdhash\";s:32:\"534752a42169e1330f60b096613e38de\";s:8:\"filesize\";s:5:\"19171\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";s:5:\"terms\";a:0:{}}s:7:\"7.x-2.2\";a:14:{s:4:\"name\";s:17:\"shortcode 7.x-2.2\";s:7:\"version\";s:7:\"7.x-2.2\";s:3:\"tag\";s:7:\"7.x-2.2\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:57:\"https://www.drupal.org/project/shortcode/releases/7.x-2.2\";s:13:\"download_link\";s:62:\"https://ftp.drupal.org/files/projects/shortcode-7.x-2.2.tar.gz\";s:4:\"date\";s:10:\"1423035781\";s:6:\"mdhash\";s:32:\"ac65e4f1b3418cd6cf7a1837c5c85947\";s:8:\"filesize\";s:5:\"19807\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-2.1\";a:14:{s:4:\"name\";s:17:\"shortcode 7.x-2.1\";s:7:\"version\";s:7:\"7.x-2.1\";s:3:\"tag\";s:7:\"7.x-2.1\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:57:\"https://www.drupal.org/project/shortcode/releases/7.x-2.1\";s:13:\"download_link\";s:62:\"https://ftp.drupal.org/files/projects/shortcode-7.x-2.1.tar.gz\";s:4:\"date\";s:10:\"1397163252\";s:6:\"mdhash\";s:32:\"697f3fcbef96e370864a021b8d04b991\";s:8:\"filesize\";s:5:\"19123\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-2.0\";a:14:{s:4:\"name\";s:17:\"shortcode 7.x-2.0\";s:7:\"version\";s:7:\"7.x-2.0\";s:3:\"tag\";s:7:\"7.x-2.0\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:57:\"https://www.drupal.org/project/shortcode/releases/7.x-2.0\";s:13:\"download_link\";s:62:\"https://ftp.drupal.org/files/projects/shortcode-7.x-2.0.tar.gz\";s:4:\"date\";s:10:\"1376997109\";s:6:\"mdhash\";s:32:\"70c4dd4ae7758dc51c71dfdda64d1a12\";s:8:\"filesize\";s:5:\"22811\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:14:\"7.x-2.0-alpha5\";a:15:{s:4:\"name\";s:24:\"shortcode 7.x-2.0-alpha5\";s:7:\"version\";s:14:\"7.x-2.0-alpha5\";s:3:\"tag\";s:14:\"7.x-2.0-alpha5\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha5\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:64:\"https://www.drupal.org/project/shortcode/releases/7.x-2.0-alpha5\";s:13:\"download_link\";s:69:\"https://ftp.drupal.org/files/projects/shortcode-7.x-2.0-alpha5.tar.gz\";s:4:\"date\";s:10:\"1350027720\";s:6:\"mdhash\";s:32:\"78e847960c279c3a182132923955f69c\";s:8:\"filesize\";s:5:\"22590\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:14:\"7.x-2.0-alpha4\";a:15:{s:4:\"name\";s:24:\"shortcode 7.x-2.0-alpha4\";s:7:\"version\";s:14:\"7.x-2.0-alpha4\";s:3:\"tag\";s:14:\"7.x-2.0-alpha4\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:64:\"https://www.drupal.org/project/shortcode/releases/7.x-2.0-alpha4\";s:13:\"download_link\";s:69:\"https://ftp.drupal.org/files/projects/shortcode-7.x-2.0-alpha4.tar.gz\";s:4:\"date\";s:10:\"1350027122\";s:6:\"mdhash\";s:32:\"f0cf54480cd49757f0f07fd31931c976\";s:8:\"filesize\";s:5:\"22244\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:14:\"7.x-2.0-alpha1\";a:15:{s:4:\"name\";s:24:\"shortcode 7.x-2.0-alpha1\";s:7:\"version\";s:14:\"7.x-2.0-alpha1\";s:3:\"tag\";s:14:\"7.x-2.0-alpha1\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:64:\"https://www.drupal.org/project/shortcode/releases/7.x-2.0-alpha1\";s:13:\"download_link\";s:69:\"https://ftp.drupal.org/files/projects/shortcode-7.x-2.0-alpha1.tar.gz\";s:4:\"date\";s:10:\"1331420143\";s:6:\"mdhash\";s:32:\"75bb9d5b77a68bce5a64bc7a6353cd58\";s:8:\"filesize\";s:5:\"20245\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:11:\"7.x-2.x-dev\";a:14:{s:4:\"name\";s:21:\"shortcode 7.x-2.x-dev\";s:7:\"version\";s:11:\"7.x-2.x-dev\";s:3:\"tag\";s:7:\"7.x-2.x\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/shortcode/releases/7.x-2.x-dev\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/shortcode-7.x-2.x-dev.tar.gz\";s:4:\"date\";s:10:\"1512417485\";s:6:\"mdhash\";s:32:\"2fce6e3fcb8b2c60ef0db61062170e16\";s:8:\"filesize\";s:5:\"19317\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:12:\"New features\";}}s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";}}}',1512706733,1512620327,1),('available_releases::strongarm','a:11:{s:5:\"title\";s:9:\"Strongarm\";s:10:\"short_name\";s:9:\"strongarm\";s:4:\"type\";s:14:\"project_module\";s:11:\"api_version\";s:3:\"7.x\";s:17:\"recommended_major\";s:1:\"2\";s:16:\"supported_majors\";s:1:\"2\";s:13:\"default_major\";s:1:\"2\";s:14:\"project_status\";s:9:\"published\";s:4:\"link\";s:40:\"https://www.drupal.org/project/strongarm\";s:5:\"terms\";s:0:\"\";s:8:\"releases\";a:8:{s:7:\"7.x-2.0\";a:14:{s:4:\"name\";s:17:\"strongarm 7.x-2.0\";s:7:\"version\";s:7:\"7.x-2.0\";s:3:\"tag\";s:7:\"7.x-2.0\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:57:\"https://www.drupal.org/project/strongarm/releases/7.x-2.0\";s:13:\"download_link\";s:62:\"https://ftp.drupal.org/files/projects/strongarm-7.x-2.0.tar.gz\";s:4:\"date\";s:10:\"1339604214\";s:6:\"mdhash\";s:32:\"76f0757b173e612937b0e6ce0b9bca70\";s:8:\"filesize\";s:5:\"12284\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:11:\"7.x-2.0-rc1\";a:15:{s:4:\"name\";s:21:\"strongarm 7.x-2.0-rc1\";s:7:\"version\";s:11:\"7.x-2.0-rc1\";s:3:\"tag\";s:11:\"7.x-2.0-rc1\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/strongarm/releases/7.x-2.0-rc1\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/strongarm-7.x-2.0-rc1.tar.gz\";s:4:\"date\";s:10:\"1332787846\";s:6:\"mdhash\";s:32:\"1ee67266881e9d2d7617dd48cf4c5e36\";s:8:\"filesize\";s:5:\"12280\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}s:13:\"7.x-2.0-beta5\";a:15:{s:4:\"name\";s:23:\"strongarm 7.x-2.0-beta5\";s:7:\"version\";s:13:\"7.x-2.0-beta5\";s:3:\"tag\";s:13:\"7.x-2.0-beta5\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta5\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:63:\"https://www.drupal.org/project/strongarm/releases/7.x-2.0-beta5\";s:13:\"download_link\";s:68:\"https://ftp.drupal.org/files/projects/strongarm-7.x-2.0-beta5.tar.gz\";s:4:\"date\";s:10:\"1324046743\";s:6:\"mdhash\";s:32:\"b1e005f4ba1a08c8e78c041eabc5dcdf\";s:8:\"filesize\";s:5:\"12278\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"7.x-2.0-beta4\";a:15:{s:4:\"name\";s:23:\"strongarm 7.x-2.0-beta4\";s:7:\"version\";s:13:\"7.x-2.0-beta4\";s:3:\"tag\";s:13:\"7.x-2.0-beta4\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:63:\"https://www.drupal.org/project/strongarm/releases/7.x-2.0-beta4\";s:13:\"download_link\";s:68:\"https://ftp.drupal.org/files/projects/strongarm-7.x-2.0-beta4.tar.gz\";s:4:\"date\";s:10:\"1319128535\";s:6:\"mdhash\";s:32:\"dd2b5489eff881c8ac5600a985d82dbb\";s:8:\"filesize\";s:5:\"12246\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"7.x-2.0-beta3\";a:15:{s:4:\"name\";s:23:\"strongarm 7.x-2.0-beta3\";s:7:\"version\";s:13:\"7.x-2.0-beta3\";s:3:\"tag\";s:13:\"7.x-2.0-beta3\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:63:\"https://www.drupal.org/project/strongarm/releases/7.x-2.0-beta3\";s:13:\"download_link\";s:68:\"https://ftp.drupal.org/files/projects/strongarm-7.x-2.0-beta3.tar.gz\";s:4:\"date\";s:10:\"1316558107\";s:6:\"mdhash\";s:32:\"1dfe9c89660a9fb31c36949e9d387e36\";s:8:\"filesize\";s:5:\"12249\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"7.x-2.0-beta2\";a:15:{s:4:\"name\";s:23:\"strongarm 7.x-2.0-beta2\";s:7:\"version\";s:13:\"7.x-2.0-beta2\";s:3:\"tag\";s:13:\"7.x-2.0-beta2\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:63:\"https://www.drupal.org/project/strongarm/releases/7.x-2.0-beta2\";s:13:\"download_link\";s:68:\"https://ftp.drupal.org/files/projects/strongarm-7.x-2.0-beta2.tar.gz\";s:4:\"date\";s:10:\"1285599361\";s:6:\"mdhash\";s:32:\"5bb7adb1f90ba6107fd793f0c5f2bfab\";s:8:\"filesize\";s:5:\"12588\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"7.x-2.0-beta1\";a:15:{s:4:\"name\";s:23:\"strongarm 7.x-2.0-beta1\";s:7:\"version\";s:13:\"7.x-2.0-beta1\";s:3:\"tag\";s:13:\"7.x-2.0-beta1\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:63:\"https://www.drupal.org/project/strongarm/releases/7.x-2.0-beta1\";s:13:\"download_link\";s:68:\"https://ftp.drupal.org/files/projects/strongarm-7.x-2.0-beta1.tar.gz\";s:4:\"date\";s:10:\"1284074210\";s:6:\"mdhash\";s:32:\"05634757865f7944d924d4630957cff6\";s:8:\"filesize\";s:5:\"12558\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}s:11:\"7.x-2.x-dev\";a:14:{s:4:\"name\";s:21:\"strongarm 7.x-2.x-dev\";s:7:\"version\";s:11:\"7.x-2.x-dev\";s:3:\"tag\";s:7:\"7.x-2.x\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/strongarm/releases/7.x-2.x-dev\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/strongarm-7.x-2.x-dev.tar.gz\";s:4:\"date\";s:10:\"1380638118\";s:6:\"mdhash\";s:32:\"11b392102dae9e36786f9b96895a9577\";s:8:\"filesize\";s:5:\"12329\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}}}',1512706733,1512620327,1),('available_releases::tagclouds','a:11:{s:5:\"title\";s:8:\"TagCloud\";s:10:\"short_name\";s:9:\"tagclouds\";s:4:\"type\";s:14:\"project_module\";s:11:\"api_version\";s:3:\"7.x\";s:17:\"recommended_major\";s:1:\"1\";s:16:\"supported_majors\";s:1:\"1\";s:13:\"default_major\";s:1:\"1\";s:14:\"project_status\";s:9:\"published\";s:4:\"link\";s:40:\"https://www.drupal.org/project/tagclouds\";s:5:\"terms\";s:0:\"\";s:8:\"releases\";a:12:{s:8:\"7.x-1.11\";a:14:{s:4:\"name\";s:18:\"tagclouds 7.x-1.11\";s:7:\"version\";s:8:\"7.x-1.11\";s:3:\"tag\";s:8:\"7.x-1.11\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:2:\"11\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:58:\"https://www.drupal.org/project/tagclouds/releases/7.x-1.11\";s:13:\"download_link\";s:63:\"https://ftp.drupal.org/files/projects/tagclouds-7.x-1.11.tar.gz\";s:4:\"date\";s:10:\"1452956639\";s:6:\"mdhash\";s:32:\"8fb0190b0c34735329d9e7808f507873\";s:8:\"filesize\";s:5:\"13778\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:8:\"7.x-1.10\";a:14:{s:4:\"name\";s:18:\"tagclouds 7.x-1.10\";s:7:\"version\";s:8:\"7.x-1.10\";s:3:\"tag\";s:8:\"7.x-1.10\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:2:\"10\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:58:\"https://www.drupal.org/project/tagclouds/releases/7.x-1.10\";s:13:\"download_link\";s:63:\"https://ftp.drupal.org/files/projects/tagclouds-7.x-1.10.tar.gz\";s:4:\"date\";s:10:\"1404152328\";s:6:\"mdhash\";s:32:\"c61b66f969714f149fe33a02fa503a8b\";s:8:\"filesize\";s:5:\"13675\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-1.9\";a:14:{s:4:\"name\";s:17:\"tagclouds 7.x-1.9\";s:7:\"version\";s:7:\"7.x-1.9\";s:3:\"tag\";s:7:\"7.x-1.9\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"9\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:57:\"https://www.drupal.org/project/tagclouds/releases/7.x-1.9\";s:13:\"download_link\";s:62:\"https://ftp.drupal.org/files/projects/tagclouds-7.x-1.9.tar.gz\";s:4:\"date\";s:10:\"1360479605\";s:6:\"mdhash\";s:32:\"97f6f1e4519294b2c42af23125f557cf\";s:8:\"filesize\";s:5:\"12310\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-1.8\";a:14:{s:4:\"name\";s:17:\"tagclouds 7.x-1.8\";s:7:\"version\";s:7:\"7.x-1.8\";s:3:\"tag\";s:7:\"7.x-1.8\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"8\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:57:\"https://www.drupal.org/project/tagclouds/releases/7.x-1.8\";s:13:\"download_link\";s:62:\"https://ftp.drupal.org/files/projects/tagclouds-7.x-1.8.tar.gz\";s:4:\"date\";s:10:\"1360479602\";s:6:\"mdhash\";s:32:\"5b77828dc2a46c141844ea327aac830a\";s:8:\"filesize\";s:5:\"12319\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";s:5:\"terms\";a:0:{}}s:7:\"7.x-1.7\";a:14:{s:4:\"name\";s:17:\"tagclouds 7.x-1.7\";s:7:\"version\";s:7:\"7.x-1.7\";s:3:\"tag\";s:7:\"7.x-1.7\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"7\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:57:\"https://www.drupal.org/project/tagclouds/releases/7.x-1.7\";s:13:\"download_link\";s:62:\"https://ftp.drupal.org/files/projects/tagclouds-7.x-1.7.tar.gz\";s:4:\"date\";s:10:\"1352088449\";s:6:\"mdhash\";s:32:\"d8e41e65fd196cf6c4e92f9bcf0d457d\";s:8:\"filesize\";s:5:\"12322\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-1.6\";a:14:{s:4:\"name\";s:17:\"tagclouds 7.x-1.6\";s:7:\"version\";s:7:\"7.x-1.6\";s:3:\"tag\";s:7:\"7.x-1.6\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"6\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:57:\"https://www.drupal.org/project/tagclouds/releases/7.x-1.6\";s:13:\"download_link\";s:62:\"https://ftp.drupal.org/files/projects/tagclouds-7.x-1.6.tar.gz\";s:4:\"date\";s:10:\"1345993367\";s:6:\"mdhash\";s:32:\"1a2023554e2bbe374d2b3869ae0bc308\";s:8:\"filesize\";s:5:\"11966\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-1.5\";a:14:{s:4:\"name\";s:17:\"tagclouds 7.x-1.5\";s:7:\"version\";s:7:\"7.x-1.5\";s:3:\"tag\";s:7:\"7.x-1.5\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"5\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:57:\"https://www.drupal.org/project/tagclouds/releases/7.x-1.5\";s:13:\"download_link\";s:62:\"https://ftp.drupal.org/files/projects/tagclouds-7.x-1.5.tar.gz\";s:4:\"date\";s:10:\"1343936897\";s:6:\"mdhash\";s:32:\"30224eadab577270b2ed57ee27e689e6\";s:8:\"filesize\";s:5:\"12006\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";s:5:\"terms\";a:0:{}}s:7:\"7.x-1.4\";a:14:{s:4:\"name\";s:17:\"tagclouds 7.x-1.4\";s:7:\"version\";s:7:\"7.x-1.4\";s:3:\"tag\";s:7:\"7.x-1.4\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:57:\"https://www.drupal.org/project/tagclouds/releases/7.x-1.4\";s:13:\"download_link\";s:62:\"https://ftp.drupal.org/files/projects/tagclouds-7.x-1.4.tar.gz\";s:4:\"date\";s:10:\"1333904769\";s:6:\"mdhash\";s:32:\"c961e59c6d9f07769d5e5488e5f415f5\";s:8:\"filesize\";s:5:\"11820\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-1.3\";a:14:{s:4:\"name\";s:17:\"tagclouds 7.x-1.3\";s:7:\"version\";s:7:\"7.x-1.3\";s:3:\"tag\";s:7:\"7.x-1.3\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:57:\"https://www.drupal.org/project/tagclouds/releases/7.x-1.3\";s:13:\"download_link\";s:62:\"https://ftp.drupal.org/files/projects/tagclouds-7.x-1.3.tar.gz\";s:4:\"date\";s:10:\"1331844643\";s:6:\"mdhash\";s:32:\"cf88cba4196b172c6fe6d24ae29378df\";s:8:\"filesize\";s:5:\"11756\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";s:5:\"terms\";a:0:{}}s:7:\"7.x-1.1\";a:14:{s:4:\"name\";s:17:\"tagclouds 7.x-1.1\";s:7:\"version\";s:7:\"7.x-1.1\";s:3:\"tag\";s:7:\"7.x-1.1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:57:\"https://www.drupal.org/project/tagclouds/releases/7.x-1.1\";s:13:\"download_link\";s:62:\"https://ftp.drupal.org/files/projects/tagclouds-7.x-1.1.tar.gz\";s:4:\"date\";s:10:\"1325266844\";s:6:\"mdhash\";s:32:\"4e98f22f58879134ed407d2cda87374e\";s:8:\"filesize\";s:5:\"11575\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-1.0\";a:14:{s:4:\"name\";s:17:\"tagclouds 7.x-1.0\";s:7:\"version\";s:7:\"7.x-1.0\";s:3:\"tag\";s:7:\"7.x-1.0\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:57:\"https://www.drupal.org/project/tagclouds/releases/7.x-1.0\";s:13:\"download_link\";s:62:\"https://ftp.drupal.org/files/projects/tagclouds-7.x-1.0.tar.gz\";s:4:\"date\";s:10:\"1319252736\";s:6:\"mdhash\";s:32:\"04a7356eb1ce5ffe91968a988672ff7a\";s:8:\"filesize\";s:5:\"11581\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";s:5:\"terms\";a:0:{}}s:11:\"7.x-1.x-dev\";a:14:{s:4:\"name\";s:21:\"tagclouds 7.x-1.x-dev\";s:7:\"version\";s:11:\"7.x-1.x-dev\";s:3:\"tag\";s:7:\"7.x-1.x\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/tagclouds/releases/7.x-1.x-dev\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/tagclouds-7.x-1.x-dev.tar.gz\";s:4:\"date\";s:10:\"1467295142\";s:6:\"mdhash\";s:32:\"16d34071d093edaa53226900450f9cea\";s:8:\"filesize\";s:5:\"13571\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:12:\"New features\";}}s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";}}}',1512706733,1512620327,1),('available_releases::taxonomy_menu','a:11:{s:5:\"title\";s:13:\"Taxonomy menu\";s:10:\"short_name\";s:13:\"taxonomy_menu\";s:4:\"type\";s:14:\"project_module\";s:11:\"api_version\";s:3:\"7.x\";s:17:\"recommended_major\";s:1:\"1\";s:16:\"supported_majors\";s:3:\"1,2\";s:13:\"default_major\";s:1:\"1\";s:14:\"project_status\";s:9:\"published\";s:4:\"link\";s:44:\"https://www.drupal.org/project/taxonomy_menu\";s:5:\"terms\";s:0:\"\";s:8:\"releases\";a:10:{s:14:\"7.x-2.0-alpha2\";a:15:{s:4:\"name\";s:28:\"taxonomy_menu 7.x-2.0-alpha2\";s:7:\"version\";s:14:\"7.x-2.0-alpha2\";s:3:\"tag\";s:14:\"7.x-2.0-alpha2\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:68:\"https://www.drupal.org/project/taxonomy_menu/releases/7.x-2.0-alpha2\";s:13:\"download_link\";s:73:\"https://ftp.drupal.org/files/projects/taxonomy_menu-7.x-2.0-alpha2.tar.gz\";s:4:\"date\";s:10:\"1359084813\";s:6:\"mdhash\";s:32:\"464f8dfd87a4a29958005eab55064b9a\";s:8:\"filesize\";s:5:\"31176\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:14:\"7.x-2.0-alpha1\";a:15:{s:4:\"name\";s:28:\"taxonomy_menu 7.x-2.0-alpha1\";s:7:\"version\";s:14:\"7.x-2.0-alpha1\";s:3:\"tag\";s:14:\"7.x-2.0-alpha1\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:68:\"https://www.drupal.org/project/taxonomy_menu/releases/7.x-2.0-alpha1\";s:13:\"download_link\";s:73:\"https://ftp.drupal.org/files/projects/taxonomy_menu-7.x-2.0-alpha1.tar.gz\";s:4:\"date\";s:10:\"1354041231\";s:6:\"mdhash\";s:32:\"adc321e1143241024a467aa5d80ca871\";s:8:\"filesize\";s:5:\"27625\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:7:\"7.x-1.5\";a:14:{s:4:\"name\";s:21:\"taxonomy_menu 7.x-1.5\";s:7:\"version\";s:7:\"7.x-1.5\";s:3:\"tag\";s:7:\"7.x-1.5\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"5\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/taxonomy_menu/releases/7.x-1.5\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/taxonomy_menu-7.x-1.5.tar.gz\";s:4:\"date\";s:10:\"1396359246\";s:6:\"mdhash\";s:32:\"f2aa072ca8e5ffad1082db99917e7226\";s:8:\"filesize\";s:5:\"25478\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-1.4\";a:14:{s:4:\"name\";s:21:\"taxonomy_menu 7.x-1.4\";s:7:\"version\";s:7:\"7.x-1.4\";s:3:\"tag\";s:7:\"7.x-1.4\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/taxonomy_menu/releases/7.x-1.4\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/taxonomy_menu-7.x-1.4.tar.gz\";s:4:\"date\";s:10:\"1346896425\";s:6:\"mdhash\";s:32:\"590c259749920262b9c9698673d0e7ba\";s:8:\"filesize\";s:5:\"25466\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-1.3\";a:14:{s:4:\"name\";s:21:\"taxonomy_menu 7.x-1.3\";s:7:\"version\";s:7:\"7.x-1.3\";s:3:\"tag\";s:7:\"7.x-1.3\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/taxonomy_menu/releases/7.x-1.3\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/taxonomy_menu-7.x-1.3.tar.gz\";s:4:\"date\";s:10:\"1343504281\";s:6:\"mdhash\";s:32:\"2529b7c858b34f4bc3ab0f36c383edcf\";s:8:\"filesize\";s:5:\"25755\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-1.2\";a:14:{s:4:\"name\";s:21:\"taxonomy_menu 7.x-1.2\";s:7:\"version\";s:7:\"7.x-1.2\";s:3:\"tag\";s:7:\"7.x-1.2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/taxonomy_menu/releases/7.x-1.2\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/taxonomy_menu-7.x-1.2.tar.gz\";s:4:\"date\";s:10:\"1311037620\";s:6:\"mdhash\";s:32:\"7c8dd9c6135179139b304d4c53e19910\";s:8:\"filesize\";s:5:\"21792\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-1.1\";a:14:{s:4:\"name\";s:21:\"taxonomy_menu 7.x-1.1\";s:7:\"version\";s:7:\"7.x-1.1\";s:3:\"tag\";s:7:\"7.x-1.1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/taxonomy_menu/releases/7.x-1.1\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/taxonomy_menu-7.x-1.1.tar.gz\";s:4:\"date\";s:10:\"1295050660\";s:6:\"mdhash\";s:32:\"bad372aab7f881a7d9084976b5e294fc\";s:8:\"filesize\";s:5:\"20775\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-1.0\";a:14:{s:4:\"name\";s:21:\"taxonomy_menu 7.x-1.0\";s:7:\"version\";s:7:\"7.x-1.0\";s:3:\"tag\";s:7:\"7.x-1.0\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/taxonomy_menu/releases/7.x-1.0\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/taxonomy_menu-7.x-1.0.tar.gz\";s:4:\"date\";s:10:\"1294199467\";s:6:\"mdhash\";s:32:\"adb67fe63b51058cd5e5297ae7cd25c9\";s:8:\"filesize\";s:5:\"20806\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";s:5:\"terms\";a:0:{}}s:11:\"7.x-2.x-dev\";a:14:{s:4:\"name\";s:25:\"taxonomy_menu 7.x-2.x-dev\";s:7:\"version\";s:11:\"7.x-2.x-dev\";s:3:\"tag\";s:7:\"7.x-2.x\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:65:\"https://www.drupal.org/project/taxonomy_menu/releases/7.x-2.x-dev\";s:13:\"download_link\";s:70:\"https://ftp.drupal.org/files/projects/taxonomy_menu-7.x-2.x-dev.tar.gz\";s:4:\"date\";s:10:\"1479919812\";s:6:\"mdhash\";s:32:\"a6e6b286b63221464f64c260a888810e\";s:8:\"filesize\";s:5:\"32419\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}s:11:\"7.x-1.x-dev\";a:14:{s:4:\"name\";s:25:\"taxonomy_menu 7.x-1.x-dev\";s:7:\"version\";s:11:\"7.x-1.x-dev\";s:3:\"tag\";s:7:\"7.x-1.x\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:65:\"https://www.drupal.org/project/taxonomy_menu/releases/7.x-1.x-dev\";s:13:\"download_link\";s:70:\"https://ftp.drupal.org/files/projects/taxonomy_menu-7.x-1.x-dev.tar.gz\";s:4:\"date\";s:10:\"1479919140\";s:6:\"mdhash\";s:32:\"00bf9a45a91243002244ccd573ee4130\";s:8:\"filesize\";s:5:\"25970\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}}}',1512706733,1512620327,1),('available_releases::token','a:11:{s:5:\"title\";s:5:\"Token\";s:10:\"short_name\";s:5:\"token\";s:4:\"type\";s:14:\"project_module\";s:11:\"api_version\";s:3:\"7.x\";s:17:\"recommended_major\";s:1:\"1\";s:16:\"supported_majors\";s:1:\"1\";s:13:\"default_major\";s:1:\"1\";s:14:\"project_status\";s:9:\"published\";s:4:\"link\";s:36:\"https://www.drupal.org/project/token\";s:5:\"terms\";s:0:\"\";s:8:\"releases\";a:20:{s:7:\"7.x-1.7\";a:14:{s:4:\"name\";s:13:\"token 7.x-1.7\";s:7:\"version\";s:7:\"7.x-1.7\";s:3:\"tag\";s:7:\"7.x-1.7\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"7\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:53:\"https://www.drupal.org/project/token/releases/7.x-1.7\";s:13:\"download_link\";s:58:\"https://ftp.drupal.org/files/projects/token-7.x-1.7.tar.gz\";s:4:\"date\";s:10:\"1485316084\";s:6:\"mdhash\";s:32:\"cf117195d2815e4292e522c04f4055d0\";s:8:\"filesize\";s:5:\"44016\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-1.6\";a:14:{s:4:\"name\";s:13:\"token 7.x-1.6\";s:7:\"version\";s:7:\"7.x-1.6\";s:3:\"tag\";s:7:\"7.x-1.6\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"6\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:53:\"https://www.drupal.org/project/token/releases/7.x-1.6\";s:13:\"download_link\";s:58:\"https://ftp.drupal.org/files/projects/token-7.x-1.6.tar.gz\";s:4:\"date\";s:10:\"1425149059\";s:6:\"mdhash\";s:32:\"9b59f3ce5f25aab883a1ae7631bf5581\";s:8:\"filesize\";s:5:\"44396\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-1.5\";a:14:{s:4:\"name\";s:13:\"token 7.x-1.5\";s:7:\"version\";s:7:\"7.x-1.5\";s:3:\"tag\";s:7:\"7.x-1.5\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"5\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:53:\"https://www.drupal.org/project/token/releases/7.x-1.5\";s:13:\"download_link\";s:58:\"https://ftp.drupal.org/files/projects/token-7.x-1.5.tar.gz\";s:4:\"date\";s:10:\"1361665026\";s:6:\"mdhash\";s:32:\"93e5a19e8b244022cc38e58663db8001\";s:8:\"filesize\";s:5:\"44012\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-1.4\";a:14:{s:4:\"name\";s:13:\"token 7.x-1.4\";s:7:\"version\";s:7:\"7.x-1.4\";s:3:\"tag\";s:7:\"7.x-1.4\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:53:\"https://www.drupal.org/project/token/releases/7.x-1.4\";s:13:\"download_link\";s:58:\"https://ftp.drupal.org/files/projects/token-7.x-1.4.tar.gz\";s:4:\"date\";s:10:\"1348497279\";s:6:\"mdhash\";s:32:\"e65a894f14518751ca1da445a767965c\";s:8:\"filesize\";s:5:\"43675\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-1.3\";a:14:{s:4:\"name\";s:13:\"token 7.x-1.3\";s:7:\"version\";s:7:\"7.x-1.3\";s:3:\"tag\";s:7:\"7.x-1.3\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:53:\"https://www.drupal.org/project/token/releases/7.x-1.3\";s:13:\"download_link\";s:58:\"https://ftp.drupal.org/files/projects/token-7.x-1.3.tar.gz\";s:4:\"date\";s:10:\"1347466790\";s:6:\"mdhash\";s:32:\"efe130120435cf38d33e6ae005ad0956\";s:8:\"filesize\";s:5:\"43666\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:15:\"Security update\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-1.2\";a:14:{s:4:\"name\";s:13:\"token 7.x-1.2\";s:7:\"version\";s:7:\"7.x-1.2\";s:3:\"tag\";s:7:\"7.x-1.2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:53:\"https://www.drupal.org/project/token/releases/7.x-1.2\";s:13:\"download_link\";s:58:\"https://ftp.drupal.org/files/projects/token-7.x-1.2.tar.gz\";s:4:\"date\";s:10:\"1344634643\";s:6:\"mdhash\";s:32:\"0cb93d8a597acd5f99acdc7cb42b6332\";s:8:\"filesize\";s:5:\"43170\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-1.1\";a:14:{s:4:\"name\";s:13:\"token 7.x-1.1\";s:7:\"version\";s:7:\"7.x-1.1\";s:3:\"tag\";s:7:\"7.x-1.1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:53:\"https://www.drupal.org/project/token/releases/7.x-1.1\";s:13:\"download_link\";s:58:\"https://ftp.drupal.org/files/projects/token-7.x-1.1.tar.gz\";s:4:\"date\";s:10:\"1337115392\";s:6:\"mdhash\";s:32:\"8d4c96128ab3ef9f4e76fbdb73900e35\";s:8:\"filesize\";s:5:\"42496\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-1.0\";a:14:{s:4:\"name\";s:13:\"token 7.x-1.0\";s:7:\"version\";s:7:\"7.x-1.0\";s:3:\"tag\";s:7:\"7.x-1.0\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:53:\"https://www.drupal.org/project/token/releases/7.x-1.0\";s:13:\"download_link\";s:58:\"https://ftp.drupal.org/files/projects/token-7.x-1.0.tar.gz\";s:4:\"date\";s:10:\"1333672577\";s:6:\"mdhash\";s:32:\"21709598974906287ea5bd68f2b94815\";s:8:\"filesize\";s:5:\"42264\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:11:\"7.x-1.0-rc1\";a:15:{s:4:\"name\";s:17:\"token 7.x-1.0-rc1\";s:7:\"version\";s:11:\"7.x-1.0-rc1\";s:3:\"tag\";s:11:\"7.x-1.0-rc1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:57:\"https://www.drupal.org/project/token/releases/7.x-1.0-rc1\";s:13:\"download_link\";s:62:\"https://ftp.drupal.org/files/projects/token-7.x-1.0-rc1.tar.gz\";s:4:\"date\";s:10:\"1328022364\";s:6:\"mdhash\";s:32:\"b63435f4a943cb013aa34339f5ce8bb0\";s:8:\"filesize\";s:5:\"41089\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:13:\"7.x-1.0-beta7\";a:15:{s:4:\"name\";s:19:\"token 7.x-1.0-beta7\";s:7:\"version\";s:13:\"7.x-1.0-beta7\";s:3:\"tag\";s:13:\"7.x-1.0-beta7\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta7\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:59:\"https://www.drupal.org/project/token/releases/7.x-1.0-beta7\";s:13:\"download_link\";s:64:\"https://ftp.drupal.org/files/projects/token-7.x-1.0-beta7.tar.gz\";s:4:\"date\";s:10:\"1319825735\";s:6:\"mdhash\";s:32:\"9d5644d212720e8c9db7fcbcf4559468\";s:8:\"filesize\";s:5:\"40531\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"7.x-1.0-beta6\";a:15:{s:4:\"name\";s:19:\"token 7.x-1.0-beta6\";s:7:\"version\";s:13:\"7.x-1.0-beta6\";s:3:\"tag\";s:13:\"7.x-1.0-beta6\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta6\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:59:\"https://www.drupal.org/project/token/releases/7.x-1.0-beta6\";s:13:\"download_link\";s:64:\"https://ftp.drupal.org/files/projects/token-7.x-1.0-beta6.tar.gz\";s:4:\"date\";s:10:\"1317397307\";s:6:\"mdhash\";s:32:\"797c619140cdcc00004ce5e64b25eb02\";s:8:\"filesize\";s:5:\"40155\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"7.x-1.0-beta5\";a:15:{s:4:\"name\";s:19:\"token 7.x-1.0-beta5\";s:7:\"version\";s:13:\"7.x-1.0-beta5\";s:3:\"tag\";s:13:\"7.x-1.0-beta5\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta5\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:59:\"https://www.drupal.org/project/token/releases/7.x-1.0-beta5\";s:13:\"download_link\";s:64:\"https://ftp.drupal.org/files/projects/token-7.x-1.0-beta5.tar.gz\";s:4:\"date\";s:10:\"1314804722\";s:6:\"mdhash\";s:32:\"42b75e49ecfe3945cf3971b20d64e21f\";s:8:\"filesize\";s:5:\"38428\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"7.x-1.0-beta4\";a:15:{s:4:\"name\";s:19:\"token 7.x-1.0-beta4\";s:7:\"version\";s:13:\"7.x-1.0-beta4\";s:3:\"tag\";s:13:\"7.x-1.0-beta4\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:59:\"https://www.drupal.org/project/token/releases/7.x-1.0-beta4\";s:13:\"download_link\";s:64:\"https://ftp.drupal.org/files/projects/token-7.x-1.0-beta4.tar.gz\";s:4:\"date\";s:10:\"1313614619\";s:6:\"mdhash\";s:32:\"00aea5ce506db5a5308e4881cc16a650\";s:8:\"filesize\";s:5:\"36328\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"7.x-1.0-beta3\";a:15:{s:4:\"name\";s:19:\"token 7.x-1.0-beta3\";s:7:\"version\";s:13:\"7.x-1.0-beta3\";s:3:\"tag\";s:13:\"7.x-1.0-beta3\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:59:\"https://www.drupal.org/project/token/releases/7.x-1.0-beta3\";s:13:\"download_link\";s:64:\"https://ftp.drupal.org/files/projects/token-7.x-1.0-beta3.tar.gz\";s:4:\"date\";s:10:\"1311709319\";s:6:\"mdhash\";s:32:\"236041ef8c6249adae04f0af98e8aa8b\";s:8:\"filesize\";s:5:\"34573\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}s:13:\"7.x-1.0-beta2\";a:15:{s:4:\"name\";s:19:\"token 7.x-1.0-beta2\";s:7:\"version\";s:13:\"7.x-1.0-beta2\";s:3:\"tag\";s:13:\"7.x-1.0-beta2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:59:\"https://www.drupal.org/project/token/releases/7.x-1.0-beta2\";s:13:\"download_link\";s:64:\"https://ftp.drupal.org/files/projects/token-7.x-1.0-beta2.tar.gz\";s:4:\"date\";s:10:\"1305833216\";s:6:\"mdhash\";s:32:\"33678788042e89887c17f072f22b360e\";s:8:\"filesize\";s:5:\"32677\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"7.x-1.0-beta1\";a:15:{s:4:\"name\";s:19:\"token 7.x-1.0-beta1\";s:7:\"version\";s:13:\"7.x-1.0-beta1\";s:3:\"tag\";s:13:\"7.x-1.0-beta1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:59:\"https://www.drupal.org/project/token/releases/7.x-1.0-beta1\";s:13:\"download_link\";s:64:\"https://ftp.drupal.org/files/projects/token-7.x-1.0-beta1.tar.gz\";s:4:\"date\";s:10:\"1294805791\";s:6:\"mdhash\";s:32:\"0c597a7a17a7a27a725cf076bbae25e4\";s:8:\"filesize\";s:5:\"31159\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:14:\"7.x-1.0-alpha3\";a:15:{s:4:\"name\";s:20:\"token 7.x-1.0-alpha3\";s:7:\"version\";s:14:\"7.x-1.0-alpha3\";s:3:\"tag\";s:14:\"7.x-1.0-alpha3\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:60:\"https://www.drupal.org/project/token/releases/7.x-1.0-alpha3\";s:13:\"download_link\";s:65:\"https://ftp.drupal.org/files/projects/token-7.x-1.0-alpha3.tar.gz\";s:4:\"date\";s:10:\"1286469965\";s:6:\"mdhash\";s:32:\"16096ce5c4a1f7e0b70c31026d88238a\";s:8:\"filesize\";s:5:\"23473\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:14:\"7.x-1.0-alpha2\";a:15:{s:4:\"name\";s:20:\"token 7.x-1.0-alpha2\";s:7:\"version\";s:14:\"7.x-1.0-alpha2\";s:3:\"tag\";s:14:\"7.x-1.0-alpha2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:60:\"https://www.drupal.org/project/token/releases/7.x-1.0-alpha2\";s:13:\"download_link\";s:65:\"https://ftp.drupal.org/files/projects/token-7.x-1.0-alpha2.tar.gz\";s:4:\"date\";s:10:\"1281549992\";s:6:\"mdhash\";s:32:\"788bb2827e595fa41387afbe116f462d\";s:8:\"filesize\";s:5:\"21523\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:14:\"7.x-1.0-alpha1\";a:15:{s:4:\"name\";s:20:\"token 7.x-1.0-alpha1\";s:7:\"version\";s:14:\"7.x-1.0-alpha1\";s:3:\"tag\";s:14:\"7.x-1.0-alpha1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:60:\"https://www.drupal.org/project/token/releases/7.x-1.0-alpha1\";s:13:\"download_link\";s:65:\"https://ftp.drupal.org/files/projects/token-7.x-1.0-alpha1.tar.gz\";s:4:\"date\";s:10:\"1271567107\";s:6:\"mdhash\";s:32:\"622a57e2ef607da3010c9e94d76af3fc\";s:8:\"filesize\";s:5:\"17032\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}s:11:\"7.x-1.x-dev\";a:14:{s:4:\"name\";s:17:\"token 7.x-1.x-dev\";s:7:\"version\";s:11:\"7.x-1.x-dev\";s:3:\"tag\";s:7:\"7.x-1.x\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:57:\"https://www.drupal.org/project/token/releases/7.x-1.x-dev\";s:13:\"download_link\";s:62:\"https://ftp.drupal.org/files/projects/token-7.x-1.x-dev.tar.gz\";s:4:\"date\";s:10:\"1493330042\";s:6:\"mdhash\";s:32:\"89e063c41031d1001ae19ca34d00ccdb\";s:8:\"filesize\";s:5:\"44024\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}}}',1512706733,1512620327,1),('available_releases::token_custom','a:11:{s:5:\"title\";s:13:\"Custom Tokens\";s:10:\"short_name\";s:12:\"token_custom\";s:4:\"type\";s:14:\"project_module\";s:11:\"api_version\";s:3:\"7.x\";s:17:\"recommended_major\";s:1:\"2\";s:16:\"supported_majors\";s:3:\"1,2\";s:13:\"default_major\";s:1:\"1\";s:14:\"project_status\";s:9:\"published\";s:4:\"link\";s:43:\"https://www.drupal.org/project/token_custom\";s:5:\"terms\";s:0:\"\";s:8:\"releases\";a:8:{s:13:\"7.x-2.0-beta3\";a:15:{s:4:\"name\";s:26:\"token_custom 7.x-2.0-beta3\";s:7:\"version\";s:13:\"7.x-2.0-beta3\";s:3:\"tag\";s:13:\"7.x-2.0-beta3\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:66:\"https://www.drupal.org/project/token_custom/releases/7.x-2.0-beta3\";s:13:\"download_link\";s:71:\"https://ftp.drupal.org/files/projects/token_custom-7.x-2.0-beta3.tar.gz\";s:4:\"date\";s:10:\"1348426268\";s:6:\"mdhash\";s:32:\"b927d3dc1272920003ac3f4ac7cdb3d7\";s:8:\"filesize\";s:5:\"14649\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"7.x-2.0-beta2\";a:15:{s:4:\"name\";s:26:\"token_custom 7.x-2.0-beta2\";s:7:\"version\";s:13:\"7.x-2.0-beta2\";s:3:\"tag\";s:13:\"7.x-2.0-beta2\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:66:\"https://www.drupal.org/project/token_custom/releases/7.x-2.0-beta2\";s:13:\"download_link\";s:71:\"https://ftp.drupal.org/files/projects/token_custom-7.x-2.0-beta2.tar.gz\";s:4:\"date\";s:10:\"1339253235\";s:6:\"mdhash\";s:32:\"db5875ffd069a45a4321429187e8e696\";s:8:\"filesize\";s:5:\"14632\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"7.x-2.0-beta1\";a:15:{s:4:\"name\";s:26:\"token_custom 7.x-2.0-beta1\";s:7:\"version\";s:13:\"7.x-2.0-beta1\";s:3:\"tag\";s:13:\"7.x-2.0-beta1\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:66:\"https://www.drupal.org/project/token_custom/releases/7.x-2.0-beta1\";s:13:\"download_link\";s:71:\"https://ftp.drupal.org/files/projects/token_custom-7.x-2.0-beta1.tar.gz\";s:4:\"date\";s:10:\"1336397783\";s:6:\"mdhash\";s:32:\"e6a2c401d6e3cb0103a49746d60a5105\";s:8:\"filesize\";s:5:\"14073\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:7:\"7.x-1.1\";a:14:{s:4:\"name\";s:20:\"token_custom 7.x-1.1\";s:7:\"version\";s:7:\"7.x-1.1\";s:3:\"tag\";s:7:\"7.x-1.1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:60:\"https://www.drupal.org/project/token_custom/releases/7.x-1.1\";s:13:\"download_link\";s:65:\"https://ftp.drupal.org/files/projects/token_custom-7.x-1.1.tar.gz\";s:4:\"date\";s:10:\"1324149043\";s:6:\"mdhash\";s:32:\"e5c2bbdfc3e40e3e2c2de1c64566c20a\";s:8:\"filesize\";s:5:\"12038\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-1.0\";a:14:{s:4:\"name\";s:20:\"token_custom 7.x-1.0\";s:7:\"version\";s:7:\"7.x-1.0\";s:3:\"tag\";s:7:\"7.x-1.0\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:60:\"https://www.drupal.org/project/token_custom/releases/7.x-1.0\";s:13:\"download_link\";s:65:\"https://ftp.drupal.org/files/projects/token_custom-7.x-1.0.tar.gz\";s:4:\"date\";s:10:\"1321700745\";s:6:\"mdhash\";s:32:\"ebc1f1685443bd52b81ed36e8ab67625\";s:8:\"filesize\";s:5:\"12042\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";s:5:\"terms\";a:0:{}}s:13:\"7.x-1.0-beta2\";a:15:{s:4:\"name\";s:26:\"token_custom 7.x-1.0-beta2\";s:7:\"version\";s:13:\"7.x-1.0-beta2\";s:3:\"tag\";s:13:\"7.x-1.0-beta2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:66:\"https://www.drupal.org/project/token_custom/releases/7.x-1.0-beta2\";s:13:\"download_link\";s:71:\"https://ftp.drupal.org/files/projects/token_custom-7.x-1.0-beta2.tar.gz\";s:4:\"date\";s:10:\"1319568935\";s:6:\"mdhash\";s:32:\"d2481e5387987f1449b53fac60c17166\";s:8:\"filesize\";s:5:\"12013\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:12:\"New features\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:11:\"7.x-2.x-dev\";a:14:{s:4:\"name\";s:24:\"token_custom 7.x-2.x-dev\";s:7:\"version\";s:11:\"7.x-2.x-dev\";s:3:\"tag\";s:7:\"7.x-2.x\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:64:\"https://www.drupal.org/project/token_custom/releases/7.x-2.x-dev\";s:13:\"download_link\";s:69:\"https://ftp.drupal.org/files/projects/token_custom-7.x-2.x-dev.tar.gz\";s:4:\"date\";s:10:\"1469179739\";s:6:\"mdhash\";s:32:\"5ee923c5cbf096f56b697cca0a05c204\";s:8:\"filesize\";s:5:\"14620\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:12:\"New features\";}}s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";}s:11:\"7.x-1.x-dev\";a:14:{s:4:\"name\";s:24:\"token_custom 7.x-1.x-dev\";s:7:\"version\";s:11:\"7.x-1.x-dev\";s:3:\"tag\";s:7:\"7.x-1.x\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:64:\"https://www.drupal.org/project/token_custom/releases/7.x-1.x-dev\";s:13:\"download_link\";s:69:\"https://ftp.drupal.org/files/projects/token_custom-7.x-1.x-dev.tar.gz\";s:4:\"date\";s:10:\"1382147405\";s:6:\"mdhash\";s:32:\"f87c83b3d85e108e4edb6e41bcaca532\";s:8:\"filesize\";s:5:\"12166\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";}}}',1512706733,1512620327,1),('available_releases::variable','a:11:{s:5:\"title\";s:8:\"Variable\";s:10:\"short_name\";s:8:\"variable\";s:4:\"type\";s:14:\"project_module\";s:11:\"api_version\";s:3:\"7.x\";s:17:\"recommended_major\";s:1:\"2\";s:16:\"supported_majors\";s:1:\"2\";s:13:\"default_major\";s:1:\"2\";s:14:\"project_status\";s:9:\"published\";s:4:\"link\";s:39:\"https://www.drupal.org/project/variable\";s:5:\"terms\";s:0:\"\";s:8:\"releases\";a:21:{s:7:\"7.x-2.5\";a:14:{s:4:\"name\";s:16:\"variable 7.x-2.5\";s:7:\"version\";s:7:\"7.x-2.5\";s:3:\"tag\";s:7:\"7.x-2.5\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"5\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/variable/releases/7.x-2.5\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/variable-7.x-2.5.tar.gz\";s:4:\"date\";s:10:\"1398250127\";s:6:\"mdhash\";s:32:\"19ef79edd10ef87e471775cf34a27386\";s:8:\"filesize\";s:5:\"53993\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-2.4\";a:14:{s:4:\"name\";s:16:\"variable 7.x-2.4\";s:7:\"version\";s:7:\"7.x-2.4\";s:3:\"tag\";s:7:\"7.x-2.4\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/variable/releases/7.x-2.4\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/variable-7.x-2.4.tar.gz\";s:4:\"date\";s:10:\"1390310305\";s:6:\"mdhash\";s:32:\"593343d361833c14f6bf8da3cc93332c\";s:8:\"filesize\";s:5:\"53722\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-2.3\";a:14:{s:4:\"name\";s:16:\"variable 7.x-2.3\";s:7:\"version\";s:7:\"7.x-2.3\";s:3:\"tag\";s:7:\"7.x-2.3\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/variable/releases/7.x-2.3\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/variable-7.x-2.3.tar.gz\";s:4:\"date\";s:10:\"1376034994\";s:6:\"mdhash\";s:32:\"4a053c4479a0a540225dc040e822b6ac\";s:8:\"filesize\";s:5:\"53717\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-2.2\";a:14:{s:4:\"name\";s:16:\"variable 7.x-2.2\";s:7:\"version\";s:7:\"7.x-2.2\";s:3:\"tag\";s:7:\"7.x-2.2\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/variable/releases/7.x-2.2\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/variable-7.x-2.2.tar.gz\";s:4:\"date\";s:10:\"1358075138\";s:6:\"mdhash\";s:32:\"07d1633a9df95a66374c70eb9b539ef1\";s:8:\"filesize\";s:5:\"53545\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-2.1\";a:14:{s:4:\"name\";s:16:\"variable 7.x-2.1\";s:7:\"version\";s:7:\"7.x-2.1\";s:3:\"tag\";s:7:\"7.x-2.1\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/variable/releases/7.x-2.1\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/variable-7.x-2.1.tar.gz\";s:4:\"date\";s:10:\"1341236242\";s:6:\"mdhash\";s:32:\"ec6e03acf71fdb65471dcf3f71439a2b\";s:8:\"filesize\";s:5:\"52510\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-2.0\";a:14:{s:4:\"name\";s:16:\"variable 7.x-2.0\";s:7:\"version\";s:7:\"7.x-2.0\";s:3:\"tag\";s:7:\"7.x-2.0\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/variable/releases/7.x-2.0\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/variable-7.x-2.0.tar.gz\";s:4:\"date\";s:10:\"1340224919\";s:6:\"mdhash\";s:32:\"8360a99fe685553a71ebb8f2b2de9537\";s:8:\"filesize\";s:5:\"52286\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:13:\"7.x-2.0-beta1\";a:15:{s:4:\"name\";s:22:\"variable 7.x-2.0-beta1\";s:7:\"version\";s:13:\"7.x-2.0-beta1\";s:3:\"tag\";s:13:\"7.x-2.0-beta1\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/variable/releases/7.x-2.0-beta1\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/variable-7.x-2.0-beta1.tar.gz\";s:4:\"date\";s:10:\"1338039697\";s:6:\"mdhash\";s:32:\"f06bde35794978e2114b064b8fe6a26a\";s:8:\"filesize\";s:5:\"50599\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:14:\"7.x-2.0-alpha1\";a:15:{s:4:\"name\";s:23:\"variable 7.x-2.0-alpha1\";s:7:\"version\";s:14:\"7.x-2.0-alpha1\";s:3:\"tag\";s:14:\"7.x-2.0-alpha1\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:63:\"https://www.drupal.org/project/variable/releases/7.x-2.0-alpha1\";s:13:\"download_link\";s:68:\"https://ftp.drupal.org/files/projects/variable-7.x-2.0-alpha1.tar.gz\";s:4:\"date\";s:10:\"1337602905\";s:6:\"mdhash\";s:32:\"a969eb4605ed8d1b46d5a7f615894d97\";s:8:\"filesize\";s:5:\"49073\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:7:\"7.x-1.2\";a:14:{s:4:\"name\";s:16:\"variable 7.x-1.2\";s:7:\"version\";s:7:\"7.x-1.2\";s:3:\"tag\";s:7:\"7.x-1.2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/variable/releases/7.x-1.2\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/variable-7.x-1.2.tar.gz\";s:4:\"date\";s:10:\"1334999498\";s:6:\"mdhash\";s:32:\"d22b461760eb97e010a29ab443d26582\";s:8:\"filesize\";s:5:\"39619\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-1.1\";a:14:{s:4:\"name\";s:16:\"variable 7.x-1.1\";s:7:\"version\";s:7:\"7.x-1.1\";s:3:\"tag\";s:7:\"7.x-1.1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/variable/releases/7.x-1.1\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/variable-7.x-1.1.tar.gz\";s:4:\"date\";s:10:\"1313088721\";s:6:\"mdhash\";s:32:\"e25c594c052b1973402c90ed896b40aa\";s:8:\"filesize\";s:5:\"30548\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-1.0\";a:14:{s:4:\"name\";s:16:\"variable 7.x-1.0\";s:7:\"version\";s:7:\"7.x-1.0\";s:3:\"tag\";s:7:\"7.x-1.0\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/variable/releases/7.x-1.0\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/variable-7.x-1.0.tar.gz\";s:4:\"date\";s:10:\"1304158917\";s:6:\"mdhash\";s:32:\"715a7eb15fb721ce32f243a0cbe014a2\";s:8:\"filesize\";s:5:\"29109\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:13:\"7.x-1.0-beta3\";a:15:{s:4:\"name\";s:22:\"variable 7.x-1.0-beta3\";s:7:\"version\";s:13:\"7.x-1.0-beta3\";s:3:\"tag\";s:13:\"7.x-1.0-beta3\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/variable/releases/7.x-1.0-beta3\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/variable-7.x-1.0-beta3.tar.gz\";s:4:\"date\";s:10:\"1303033317\";s:6:\"mdhash\";s:32:\"b7b99e2a5fee44e3ba2bc9162826576c\";s:8:\"filesize\";s:5:\"29116\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"7.x-1.0-beta2\";a:15:{s:4:\"name\";s:22:\"variable 7.x-1.0-beta2\";s:7:\"version\";s:13:\"7.x-1.0-beta2\";s:3:\"tag\";s:13:\"7.x-1.0-beta2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/variable/releases/7.x-1.0-beta2\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/variable-7.x-1.0-beta2.tar.gz\";s:4:\"date\";s:10:\"1298891771\";s:6:\"mdhash\";s:32:\"91d7116b5ef8b9a0b32d47c913e93a9c\";s:8:\"filesize\";s:5:\"28339\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"7.x-1.0-beta1\";a:15:{s:4:\"name\";s:22:\"variable 7.x-1.0-beta1\";s:7:\"version\";s:13:\"7.x-1.0-beta1\";s:3:\"tag\";s:13:\"7.x-1.0-beta1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/variable/releases/7.x-1.0-beta1\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/variable-7.x-1.0-beta1.tar.gz\";s:4:\"date\";s:10:\"1298575040\";s:6:\"mdhash\";s:32:\"316aa9de8723f9e42d235340d5e81cd8\";s:8:\"filesize\";s:5:\"27140\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:14:\"7.x-1.0-alpha5\";a:15:{s:4:\"name\";s:23:\"variable 7.x-1.0-alpha5\";s:7:\"version\";s:14:\"7.x-1.0-alpha5\";s:3:\"tag\";s:14:\"7.x-1.0-alpha5\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha5\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:63:\"https://www.drupal.org/project/variable/releases/7.x-1.0-alpha5\";s:13:\"download_link\";s:68:\"https://ftp.drupal.org/files/projects/variable-7.x-1.0-alpha5.tar.gz\";s:4:\"date\";s:10:\"1298138218\";s:6:\"mdhash\";s:32:\"562eb1e1bc3ed33f3bf7d3cf3af5713c\";s:8:\"filesize\";s:5:\"25613\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:14:\"7.x-1.0-alpha4\";a:15:{s:4:\"name\";s:23:\"variable 7.x-1.0-alpha4\";s:7:\"version\";s:14:\"7.x-1.0-alpha4\";s:3:\"tag\";s:14:\"7.x-1.0-alpha4\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:63:\"https://www.drupal.org/project/variable/releases/7.x-1.0-alpha4\";s:13:\"download_link\";s:68:\"https://ftp.drupal.org/files/projects/variable-7.x-1.0-alpha4.tar.gz\";s:4:\"date\";s:10:\"1297961280\";s:6:\"mdhash\";s:32:\"d9057a4880e128bf379a261985cee7b9\";s:8:\"filesize\";s:5:\"25316\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:14:\"7.x-1.0-alpha3\";a:15:{s:4:\"name\";s:23:\"variable 7.x-1.0-alpha3\";s:7:\"version\";s:14:\"7.x-1.0-alpha3\";s:3:\"tag\";s:14:\"7.x-1.0-alpha3\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:63:\"https://www.drupal.org/project/variable/releases/7.x-1.0-alpha3\";s:13:\"download_link\";s:68:\"https://ftp.drupal.org/files/projects/variable-7.x-1.0-alpha3.tar.gz\";s:4:\"date\";s:10:\"1297683744\";s:6:\"mdhash\";s:32:\"d5e5cc33ed8d0c29409fa945d3107c4e\";s:8:\"filesize\";s:5:\"23820\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}s:14:\"7.x-1.0-alpha2\";a:15:{s:4:\"name\";s:23:\"variable 7.x-1.0-alpha2\";s:7:\"version\";s:14:\"7.x-1.0-alpha2\";s:3:\"tag\";s:14:\"7.x-1.0-alpha2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:63:\"https://www.drupal.org/project/variable/releases/7.x-1.0-alpha2\";s:13:\"download_link\";s:68:\"https://ftp.drupal.org/files/projects/variable-7.x-1.0-alpha2.tar.gz\";s:4:\"date\";s:10:\"1295708628\";s:6:\"mdhash\";s:32:\"5d8f8134368f319788c6b2f86d812171\";s:8:\"filesize\";s:5:\"23271\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:12:\"New features\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:14:\"7.x-1.0-alpha1\";a:15:{s:4:\"name\";s:23:\"variable 7.x-1.0-alpha1\";s:7:\"version\";s:14:\"7.x-1.0-alpha1\";s:3:\"tag\";s:14:\"7.x-1.0-alpha1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:63:\"https://www.drupal.org/project/variable/releases/7.x-1.0-alpha1\";s:13:\"download_link\";s:68:\"https://ftp.drupal.org/files/projects/variable-7.x-1.0-alpha1.tar.gz\";s:4:\"date\";s:10:\"1295460731\";s:6:\"mdhash\";s:32:\"e42b293024da523516f8e92e26ede356\";s:8:\"filesize\";s:5:\"19401\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:12:\"New features\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:11:\"7.x-2.x-dev\";a:14:{s:4:\"name\";s:20:\"variable 7.x-2.x-dev\";s:7:\"version\";s:11:\"7.x-2.x-dev\";s:3:\"tag\";s:7:\"7.x-2.x\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:60:\"https://www.drupal.org/project/variable/releases/7.x-2.x-dev\";s:13:\"download_link\";s:65:\"https://ftp.drupal.org/files/projects/variable-7.x-2.x-dev.tar.gz\";s:4:\"date\";s:10:\"1397240053\";s:6:\"mdhash\";s:32:\"9e8a3fec31297fdc79a71dbba82e5472\";s:8:\"filesize\";s:5:\"53993\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:12:\"New features\";}}s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";}s:11:\"7.x-1.x-dev\";a:14:{s:4:\"name\";s:20:\"variable 7.x-1.x-dev\";s:7:\"version\";s:11:\"7.x-1.x-dev\";s:3:\"tag\";s:7:\"7.x-1.x\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:60:\"https://www.drupal.org/project/variable/releases/7.x-1.x-dev\";s:13:\"download_link\";s:65:\"https://ftp.drupal.org/files/projects/variable-7.x-1.x-dev.tar.gz\";s:4:\"date\";s:10:\"1382151333\";s:6:\"mdhash\";s:32:\"5251f764b10e313bcb36b83eaaafd77b\";s:8:\"filesize\";s:5:\"48137\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}}}',1512706734,1512620327,1),('available_releases::video_embed_field','a:11:{s:5:\"title\";s:17:\"Video Embed Field\";s:10:\"short_name\";s:17:\"video_embed_field\";s:4:\"type\";s:14:\"project_module\";s:11:\"api_version\";s:3:\"7.x\";s:17:\"recommended_major\";s:1:\"2\";s:16:\"supported_majors\";s:1:\"2\";s:13:\"default_major\";s:1:\"2\";s:14:\"project_status\";s:9:\"published\";s:4:\"link\";s:48:\"https://www.drupal.org/project/video_embed_field\";s:5:\"terms\";s:0:\"\";s:8:\"releases\";a:22:{s:14:\"7.x-2.0-beta11\";a:15:{s:4:\"name\";s:32:\"video_embed_field 7.x-2.0-beta11\";s:7:\"version\";s:14:\"7.x-2.0-beta11\";s:3:\"tag\";s:14:\"7.x-2.0-beta11\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"beta11\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:72:\"https://www.drupal.org/project/video_embed_field/releases/7.x-2.0-beta11\";s:13:\"download_link\";s:77:\"https://ftp.drupal.org/files/projects/video_embed_field-7.x-2.0-beta11.tar.gz\";s:4:\"date\";s:10:\"1441639439\";s:6:\"mdhash\";s:32:\"43d7d6f6a9ec796b1eb1c68c66d82c49\";s:8:\"filesize\";s:6:\"182549\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:14:\"7.x-2.0-beta10\";a:15:{s:4:\"name\";s:32:\"video_embed_field 7.x-2.0-beta10\";s:7:\"version\";s:14:\"7.x-2.0-beta10\";s:3:\"tag\";s:14:\"7.x-2.0-beta10\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"beta10\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:72:\"https://www.drupal.org/project/video_embed_field/releases/7.x-2.0-beta10\";s:13:\"download_link\";s:77:\"https://ftp.drupal.org/files/projects/video_embed_field-7.x-2.0-beta10.tar.gz\";s:4:\"date\";s:10:\"1434007080\";s:6:\"mdhash\";s:32:\"2c8ea305f1dc5261329325c311495670\";s:8:\"filesize\";s:6:\"182048\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"7.x-2.0-beta9\";a:15:{s:4:\"name\";s:31:\"video_embed_field 7.x-2.0-beta9\";s:7:\"version\";s:13:\"7.x-2.0-beta9\";s:3:\"tag\";s:13:\"7.x-2.0-beta9\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta9\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:71:\"https://www.drupal.org/project/video_embed_field/releases/7.x-2.0-beta9\";s:13:\"download_link\";s:76:\"https://ftp.drupal.org/files/projects/video_embed_field-7.x-2.0-beta9.tar.gz\";s:4:\"date\";s:10:\"1433921580\";s:6:\"mdhash\";s:32:\"76d0f3ef894180e67effc51709883127\";s:8:\"filesize\";s:6:\"182071\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:3:{i:0;s:15:\"Security update\";i:1;s:9:\"Bug fixes\";i:2;s:12:\"New features\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"7.x-2.0-beta8\";a:15:{s:4:\"name\";s:31:\"video_embed_field 7.x-2.0-beta8\";s:7:\"version\";s:13:\"7.x-2.0-beta8\";s:3:\"tag\";s:13:\"7.x-2.0-beta8\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta8\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:71:\"https://www.drupal.org/project/video_embed_field/releases/7.x-2.0-beta8\";s:13:\"download_link\";s:76:\"https://ftp.drupal.org/files/projects/video_embed_field-7.x-2.0-beta8.tar.gz\";s:4:\"date\";s:10:\"1408177428\";s:6:\"mdhash\";s:32:\"371899516ce6d6045d6497b05e7a1bb4\";s:8:\"filesize\";s:6:\"181618\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"7.x-2.0-beta7\";a:15:{s:4:\"name\";s:31:\"video_embed_field 7.x-2.0-beta7\";s:7:\"version\";s:13:\"7.x-2.0-beta7\";s:3:\"tag\";s:13:\"7.x-2.0-beta7\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta7\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:71:\"https://www.drupal.org/project/video_embed_field/releases/7.x-2.0-beta7\";s:13:\"download_link\";s:76:\"https://ftp.drupal.org/files/projects/video_embed_field-7.x-2.0-beta7.tar.gz\";s:4:\"date\";s:10:\"1391588905\";s:6:\"mdhash\";s:32:\"14ed578b5e8731222175b4d4fd065739\";s:8:\"filesize\";s:5:\"26836\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"7.x-2.0-beta6\";a:15:{s:4:\"name\";s:31:\"video_embed_field 7.x-2.0-beta6\";s:7:\"version\";s:13:\"7.x-2.0-beta6\";s:3:\"tag\";s:13:\"7.x-2.0-beta6\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta6\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:71:\"https://www.drupal.org/project/video_embed_field/releases/7.x-2.0-beta6\";s:13:\"download_link\";s:76:\"https://ftp.drupal.org/files/projects/video_embed_field-7.x-2.0-beta6.tar.gz\";s:4:\"date\";s:10:\"1391540905\";s:6:\"mdhash\";s:32:\"081ffe322a5ea1b69730c32fab636c63\";s:8:\"filesize\";s:5:\"26839\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"7.x-2.0-beta5\";a:15:{s:4:\"name\";s:31:\"video_embed_field 7.x-2.0-beta5\";s:7:\"version\";s:13:\"7.x-2.0-beta5\";s:3:\"tag\";s:13:\"7.x-2.0-beta5\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta5\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:71:\"https://www.drupal.org/project/video_embed_field/releases/7.x-2.0-beta5\";s:13:\"download_link\";s:76:\"https://ftp.drupal.org/files/projects/video_embed_field-7.x-2.0-beta5.tar.gz\";s:4:\"date\";s:10:\"1340317020\";s:6:\"mdhash\";s:32:\"115e9be89fbd84deaf5ce57359e88d6e\";s:8:\"filesize\";s:5:\"22696\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"7.x-2.0-beta4\";a:15:{s:4:\"name\";s:31:\"video_embed_field 7.x-2.0-beta4\";s:7:\"version\";s:13:\"7.x-2.0-beta4\";s:3:\"tag\";s:13:\"7.x-2.0-beta4\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:71:\"https://www.drupal.org/project/video_embed_field/releases/7.x-2.0-beta4\";s:13:\"download_link\";s:76:\"https://ftp.drupal.org/files/projects/video_embed_field-7.x-2.0-beta4.tar.gz\";s:4:\"date\";s:10:\"1329771346\";s:6:\"mdhash\";s:32:\"4e811f8a08a4131e4d8d4825b08643ce\";s:8:\"filesize\";s:5:\"18372\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"7.x-2.0-beta3\";a:15:{s:4:\"name\";s:31:\"video_embed_field 7.x-2.0-beta3\";s:7:\"version\";s:13:\"7.x-2.0-beta3\";s:3:\"tag\";s:13:\"7.x-2.0-beta3\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:71:\"https://www.drupal.org/project/video_embed_field/releases/7.x-2.0-beta3\";s:13:\"download_link\";s:76:\"https://ftp.drupal.org/files/projects/video_embed_field-7.x-2.0-beta3.tar.gz\";s:4:\"date\";s:10:\"1329762349\";s:6:\"mdhash\";s:32:\"8e43c11f195c87771a1278b8d2509724\";s:8:\"filesize\";s:5:\"18380\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"7.x-2.0-beta2\";a:15:{s:4:\"name\";s:31:\"video_embed_field 7.x-2.0-beta2\";s:7:\"version\";s:13:\"7.x-2.0-beta2\";s:3:\"tag\";s:13:\"7.x-2.0-beta2\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:71:\"https://www.drupal.org/project/video_embed_field/releases/7.x-2.0-beta2\";s:13:\"download_link\";s:76:\"https://ftp.drupal.org/files/projects/video_embed_field-7.x-2.0-beta2.tar.gz\";s:4:\"date\";s:10:\"1329756951\";s:6:\"mdhash\";s:32:\"0026cd26baf54b1a42755adf341c7db1\";s:8:\"filesize\";s:5:\"18423\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"7.x-2.0-beta1\";a:15:{s:4:\"name\";s:31:\"video_embed_field 7.x-2.0-beta1\";s:7:\"version\";s:13:\"7.x-2.0-beta1\";s:3:\"tag\";s:13:\"7.x-2.0-beta1\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:71:\"https://www.drupal.org/project/video_embed_field/releases/7.x-2.0-beta1\";s:13:\"download_link\";s:76:\"https://ftp.drupal.org/files/projects/video_embed_field-7.x-2.0-beta1.tar.gz\";s:4:\"date\";s:10:\"1329752449\";s:6:\"mdhash\";s:32:\"749c003386a9688eb926627051e7ac5c\";s:8:\"filesize\";s:5:\"18334\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:14:\"7.x-2.0-alpha3\";a:15:{s:4:\"name\";s:32:\"video_embed_field 7.x-2.0-alpha3\";s:7:\"version\";s:14:\"7.x-2.0-alpha3\";s:3:\"tag\";s:14:\"7.x-2.0-alpha3\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:72:\"https://www.drupal.org/project/video_embed_field/releases/7.x-2.0-alpha3\";s:13:\"download_link\";s:77:\"https://ftp.drupal.org/files/projects/video_embed_field-7.x-2.0-alpha3.tar.gz\";s:4:\"date\";s:10:\"1323788745\";s:6:\"mdhash\";s:32:\"c67e292e91bdea37495d66f1e59b1603\";s:8:\"filesize\";s:5:\"16346\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:14:\"7.x-2.0-alpha2\";a:15:{s:4:\"name\";s:32:\"video_embed_field 7.x-2.0-alpha2\";s:7:\"version\";s:14:\"7.x-2.0-alpha2\";s:3:\"tag\";s:14:\"7.x-2.0-alpha2\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:72:\"https://www.drupal.org/project/video_embed_field/releases/7.x-2.0-alpha2\";s:13:\"download_link\";s:77:\"https://ftp.drupal.org/files/projects/video_embed_field-7.x-2.0-alpha2.tar.gz\";s:4:\"date\";s:10:\"1321918249\";s:6:\"mdhash\";s:32:\"ed202d988168c150ca68f9e88aa2a142\";s:8:\"filesize\";s:5:\"16334\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}s:14:\"7.x-2.0-alpha1\";a:15:{s:4:\"name\";s:32:\"video_embed_field 7.x-2.0-alpha1\";s:7:\"version\";s:14:\"7.x-2.0-alpha1\";s:3:\"tag\";s:14:\"7.x-2.0-alpha1\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:72:\"https://www.drupal.org/project/video_embed_field/releases/7.x-2.0-alpha1\";s:13:\"download_link\";s:77:\"https://ftp.drupal.org/files/projects/video_embed_field-7.x-2.0-alpha1.tar.gz\";s:4:\"date\";s:10:\"1321889149\";s:6:\"mdhash\";s:32:\"4ebb65718de086e9207eaf0bc887c355\";s:8:\"filesize\";s:5:\"16375\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}s:13:\"7.x-1.0-beta1\";a:15:{s:4:\"name\";s:31:\"video_embed_field 7.x-1.0-beta1\";s:7:\"version\";s:13:\"7.x-1.0-beta1\";s:3:\"tag\";s:13:\"7.x-1.0-beta1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:71:\"https://www.drupal.org/project/video_embed_field/releases/7.x-1.0-beta1\";s:13:\"download_link\";s:76:\"https://ftp.drupal.org/files/projects/video_embed_field-7.x-1.0-beta1.tar.gz\";s:4:\"date\";s:10:\"1321887645\";s:6:\"mdhash\";s:32:\"3b11bba44ff9a39cb681e853e0f7d226\";s:8:\"filesize\";s:5:\"13658\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:14:\"7.x-1.0-alpha5\";a:15:{s:4:\"name\";s:32:\"video_embed_field 7.x-1.0-alpha5\";s:7:\"version\";s:14:\"7.x-1.0-alpha5\";s:3:\"tag\";s:14:\"7.x-1.0-alpha5\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha5\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:72:\"https://www.drupal.org/project/video_embed_field/releases/7.x-1.0-alpha5\";s:13:\"download_link\";s:77:\"https://ftp.drupal.org/files/projects/video_embed_field-7.x-1.0-alpha5.tar.gz\";s:4:\"date\";s:10:\"1318712200\";s:6:\"mdhash\";s:32:\"71f34f22428d72587adcdb612a4b732d\";s:8:\"filesize\";s:5:\"13113\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:14:\"7.x-1.0-alpha4\";a:15:{s:4:\"name\";s:32:\"video_embed_field 7.x-1.0-alpha4\";s:7:\"version\";s:14:\"7.x-1.0-alpha4\";s:3:\"tag\";s:14:\"7.x-1.0-alpha4\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:72:\"https://www.drupal.org/project/video_embed_field/releases/7.x-1.0-alpha4\";s:13:\"download_link\";s:77:\"https://ftp.drupal.org/files/projects/video_embed_field-7.x-1.0-alpha4.tar.gz\";s:4:\"date\";s:10:\"1315489621\";s:6:\"mdhash\";s:32:\"bc03fbce84328f6cb1c61ff5df6c3785\";s:8:\"filesize\";s:5:\"10784\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:14:\"7.x-1.0-alpha3\";a:15:{s:4:\"name\";s:32:\"video_embed_field 7.x-1.0-alpha3\";s:7:\"version\";s:14:\"7.x-1.0-alpha3\";s:3:\"tag\";s:14:\"7.x-1.0-alpha3\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:72:\"https://www.drupal.org/project/video_embed_field/releases/7.x-1.0-alpha3\";s:13:\"download_link\";s:77:\"https://ftp.drupal.org/files/projects/video_embed_field-7.x-1.0-alpha3.tar.gz\";s:4:\"date\";s:10:\"1315327921\";s:6:\"mdhash\";s:32:\"5546f88133bdaee9b2d34e44ce0b0772\";s:8:\"filesize\";s:5:\"10831\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}s:14:\"7.x-1.0-alpha2\";a:15:{s:4:\"name\";s:32:\"video_embed_field 7.x-1.0-alpha2\";s:7:\"version\";s:14:\"7.x-1.0-alpha2\";s:3:\"tag\";s:14:\"7.x-1.0-alpha2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:72:\"https://www.drupal.org/project/video_embed_field/releases/7.x-1.0-alpha2\";s:13:\"download_link\";s:77:\"https://ftp.drupal.org/files/projects/video_embed_field-7.x-1.0-alpha2.tar.gz\";s:4:\"date\";s:10:\"1313427721\";s:6:\"mdhash\";s:32:\"5f83b5461a688478468d6a7f822c124d\";s:8:\"filesize\";s:5:\"10052\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:14:\"7.x-1.0-alpha1\";a:15:{s:4:\"name\";s:32:\"video_embed_field 7.x-1.0-alpha1\";s:7:\"version\";s:14:\"7.x-1.0-alpha1\";s:3:\"tag\";s:14:\"7.x-1.0-alpha1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:72:\"https://www.drupal.org/project/video_embed_field/releases/7.x-1.0-alpha1\";s:13:\"download_link\";s:77:\"https://ftp.drupal.org/files/projects/video_embed_field-7.x-1.0-alpha1.tar.gz\";s:4:\"date\";s:10:\"1312900321\";s:6:\"mdhash\";s:32:\"1193c2663a0195ae52cd744a6ff78135\";s:8:\"filesize\";s:4:\"9392\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:12:\"New features\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:11:\"7.x-2.x-dev\";a:14:{s:4:\"name\";s:29:\"video_embed_field 7.x-2.x-dev\";s:7:\"version\";s:11:\"7.x-2.x-dev\";s:3:\"tag\";s:7:\"7.x-2.x\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:69:\"https://www.drupal.org/project/video_embed_field/releases/7.x-2.x-dev\";s:13:\"download_link\";s:74:\"https://ftp.drupal.org/files/projects/video_embed_field-7.x-2.x-dev.tar.gz\";s:4:\"date\";s:10:\"1441744739\";s:6:\"mdhash\";s:32:\"818abb413092148c730e56ff158c3f54\";s:8:\"filesize\";s:6:\"182557\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}s:11:\"7.x-1.x-dev\";a:14:{s:4:\"name\";s:29:\"video_embed_field 7.x-1.x-dev\";s:7:\"version\";s:11:\"7.x-1.x-dev\";s:3:\"tag\";s:7:\"7.x-1.x\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:69:\"https://www.drupal.org/project/video_embed_field/releases/7.x-1.x-dev\";s:13:\"download_link\";s:74:\"https://ftp.drupal.org/files/projects/video_embed_field-7.x-1.x-dev.tar.gz\";s:4:\"date\";s:10:\"1382151940\";s:6:\"mdhash\";s:32:\"792a314aee142fc354f379d494dab2a0\";s:8:\"filesize\";s:5:\"13662\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}}}',1512706734,1512620327,1),('available_releases::views','a:11:{s:5:\"title\";s:5:\"Views\";s:10:\"short_name\";s:5:\"views\";s:4:\"type\";s:14:\"project_module\";s:11:\"api_version\";s:3:\"7.x\";s:17:\"recommended_major\";s:1:\"3\";s:16:\"supported_majors\";s:1:\"3\";s:13:\"default_major\";s:1:\"3\";s:14:\"project_status\";s:9:\"published\";s:4:\"link\";s:36:\"https://www.drupal.org/project/views\";s:5:\"terms\";s:0:\"\";s:8:\"releases\";a:26:{s:8:\"7.x-3.18\";a:14:{s:4:\"name\";s:14:\"views 7.x-3.18\";s:7:\"version\";s:8:\"7.x-3.18\";s:3:\"tag\";s:8:\"7.x-3.18\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:2:\"18\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:54:\"https://www.drupal.org/project/views/releases/7.x-3.18\";s:13:\"download_link\";s:59:\"https://ftp.drupal.org/files/projects/views-7.x-3.18.tar.gz\";s:4:\"date\";s:10:\"1503494944\";s:6:\"mdhash\";s:32:\"937ad4ebd559fd3f57896f4702f6f3c4\";s:8:\"filesize\";s:7:\"1646788\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:8:\"7.x-3.17\";a:14:{s:4:\"name\";s:14:\"views 7.x-3.17\";s:7:\"version\";s:8:\"7.x-3.17\";s:3:\"tag\";s:8:\"7.x-3.17\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:2:\"17\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:54:\"https://www.drupal.org/project/views/releases/7.x-3.17\";s:13:\"download_link\";s:59:\"https://ftp.drupal.org/files/projects/views-7.x-3.17.tar.gz\";s:4:\"date\";s:10:\"1502903343\";s:6:\"mdhash\";s:32:\"ff6d025dedb555672ccf01f5e234df4f\";s:8:\"filesize\";s:7:\"1644296\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:15:\"Security update\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:8:\"7.x-3.16\";a:14:{s:4:\"name\";s:14:\"views 7.x-3.16\";s:7:\"version\";s:8:\"7.x-3.16\";s:3:\"tag\";s:8:\"7.x-3.16\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:2:\"16\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:54:\"https://www.drupal.org/project/views/releases/7.x-3.16\";s:13:\"download_link\";s:59:\"https://ftp.drupal.org/files/projects/views-7.x-3.16.tar.gz\";s:4:\"date\";s:10:\"1491158584\";s:6:\"mdhash\";s:32:\"d840cb148809da844b93d73b16b453f9\";s:8:\"filesize\";s:7:\"1643030\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:12:\"7.x-3.16-rc1\";a:15:{s:4:\"name\";s:18:\"views 7.x-3.16-rc1\";s:7:\"version\";s:12:\"7.x-3.16-rc1\";s:3:\"tag\";s:12:\"7.x-3.16-rc1\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:2:\"16\";s:13:\"version_extra\";s:3:\"rc1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:58:\"https://www.drupal.org/project/views/releases/7.x-3.16-rc1\";s:13:\"download_link\";s:63:\"https://ftp.drupal.org/files/projects/views-7.x-3.16-rc1.tar.gz\";s:4:\"date\";s:10:\"1489763584\";s:6:\"mdhash\";s:32:\"cba59381dbf64ac9d9d76fa549b4c7c1\";s:8:\"filesize\";s:7:\"1642814\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:8:\"7.x-3.15\";a:14:{s:4:\"name\";s:14:\"views 7.x-3.15\";s:7:\"version\";s:8:\"7.x-3.15\";s:3:\"tag\";s:8:\"7.x-3.15\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:2:\"15\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:54:\"https://www.drupal.org/project/views/releases/7.x-3.15\";s:13:\"download_link\";s:59:\"https://ftp.drupal.org/files/projects/views-7.x-3.15.tar.gz\";s:4:\"date\";s:10:\"1487784184\";s:6:\"mdhash\";s:32:\"473cb5384456d55af988feabc1af12ed\";s:8:\"filesize\";s:7:\"1642425\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:15:\"Security update\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:8:\"7.x-3.14\";a:14:{s:4:\"name\";s:14:\"views 7.x-3.14\";s:7:\"version\";s:8:\"7.x-3.14\";s:3:\"tag\";s:8:\"7.x-3.14\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:2:\"14\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:54:\"https://www.drupal.org/project/views/releases/7.x-3.14\";s:13:\"download_link\";s:59:\"https://ftp.drupal.org/files/projects/views-7.x-3.14.tar.gz\";s:4:\"date\";s:10:\"1466019539\";s:6:\"mdhash\";s:32:\"168bb684c8f34297be94b03c797841e5\";s:8:\"filesize\";s:7:\"1656594\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:15:\"Security update\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:8:\"7.x-3.13\";a:14:{s:4:\"name\";s:14:\"views 7.x-3.13\";s:7:\"version\";s:8:\"7.x-3.13\";s:3:\"tag\";s:8:\"7.x-3.13\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:2:\"13\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:54:\"https://www.drupal.org/project/views/releases/7.x-3.13\";s:13:\"download_link\";s:59:\"https://ftp.drupal.org/files/projects/views-7.x-3.13.tar.gz\";s:4:\"date\";s:10:\"1446804839\";s:6:\"mdhash\";s:32:\"50d3b231f689f8c4ff15d79ea3c261d9\";s:8:\"filesize\";s:7:\"1650157\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:8:\"7.x-3.12\";a:14:{s:4:\"name\";s:14:\"views 7.x-3.12\";s:7:\"version\";s:8:\"7.x-3.12\";s:3:\"tag\";s:8:\"7.x-3.12\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:2:\"12\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:54:\"https://www.drupal.org/project/views/releases/7.x-3.12\";s:13:\"download_link\";s:59:\"https://ftp.drupal.org/files/projects/views-7.x-3.12.tar.gz\";s:4:\"date\";s:10:\"1446653339\";s:6:\"mdhash\";s:32:\"a50033bb090730176d9263ddae7f32b2\";s:8:\"filesize\";s:7:\"1650130\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:8:\"7.x-3.11\";a:14:{s:4:\"name\";s:14:\"views 7.x-3.11\";s:7:\"version\";s:8:\"7.x-3.11\";s:3:\"tag\";s:8:\"7.x-3.11\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:2:\"11\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:54:\"https://www.drupal.org/project/views/releases/7.x-3.11\";s:13:\"download_link\";s:59:\"https://ftp.drupal.org/files/projects/views-7.x-3.11.tar.gz\";s:4:\"date\";s:10:\"1430320981\";s:6:\"mdhash\";s:32:\"00d722e1d8ed57e912c8bd586cf2edbe\";s:8:\"filesize\";s:7:\"1649389\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:15:\"Security update\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:8:\"7.x-3.10\";a:14:{s:4:\"name\";s:14:\"views 7.x-3.10\";s:7:\"version\";s:8:\"7.x-3.10\";s:3:\"tag\";s:8:\"7.x-3.10\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:2:\"10\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:54:\"https://www.drupal.org/project/views/releases/7.x-3.10\";s:13:\"download_link\";s:59:\"https://ftp.drupal.org/files/projects/views-7.x-3.10.tar.gz\";s:4:\"date\";s:10:\"1423648081\";s:6:\"mdhash\";s:32:\"c9806ffd69448bc505a67e790f97da58\";s:8:\"filesize\";s:7:\"1648314\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:15:\"Security update\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-3.8\";a:14:{s:4:\"name\";s:13:\"views 7.x-3.8\";s:7:\"version\";s:7:\"7.x-3.8\";s:3:\"tag\";s:7:\"7.x-3.8\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"8\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:53:\"https://www.drupal.org/project/views/releases/7.x-3.8\";s:13:\"download_link\";s:58:\"https://ftp.drupal.org/files/projects/views-7.x-3.8.tar.gz\";s:4:\"date\";s:10:\"1400618927\";s:6:\"mdhash\";s:32:\"0fbe71c455f5d34c7193797563b63b3f\";s:8:\"filesize\";s:7:\"1646817\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:3:{i:0;s:15:\"Security update\";i:1;s:9:\"Bug fixes\";i:2;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-3.7\";a:14:{s:4:\"name\";s:13:\"views 7.x-3.7\";s:7:\"version\";s:7:\"7.x-3.7\";s:3:\"tag\";s:7:\"7.x-3.7\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"7\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:53:\"https://www.drupal.org/project/views/releases/7.x-3.7\";s:13:\"download_link\";s:58:\"https://ftp.drupal.org/files/projects/views-7.x-3.7.tar.gz\";s:4:\"date\";s:10:\"1365499237\";s:6:\"mdhash\";s:32:\"3f36f0d13f3b724d719f6729cbc110ba\";s:8:\"filesize\";s:7:\"1639539\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-3.6\";a:14:{s:4:\"name\";s:13:\"views 7.x-3.6\";s:7:\"version\";s:7:\"7.x-3.6\";s:3:\"tag\";s:7:\"7.x-3.6\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"6\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:53:\"https://www.drupal.org/project/views/releases/7.x-3.6\";s:13:\"download_link\";s:58:\"https://ftp.drupal.org/files/projects/views-7.x-3.6.tar.gz\";s:4:\"date\";s:10:\"1363810217\";s:6:\"mdhash\";s:32:\"1531a1ece3970332db1559b854f5dcc9\";s:8:\"filesize\";s:7:\"1639219\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:15:\"Security update\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-3.5\";a:14:{s:4:\"name\";s:13:\"views 7.x-3.5\";s:7:\"version\";s:7:\"7.x-3.5\";s:3:\"tag\";s:7:\"7.x-3.5\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"5\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:53:\"https://www.drupal.org/project/views/releases/7.x-3.5\";s:13:\"download_link\";s:58:\"https://ftp.drupal.org/files/projects/views-7.x-3.5.tar.gz\";s:4:\"date\";s:10:\"1345829395\";s:6:\"mdhash\";s:32:\"fba70998d4ebcca5116ef5ee90117738\";s:8:\"filesize\";s:7:\"1632919\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-3.4\";a:14:{s:4:\"name\";s:13:\"views 7.x-3.4\";s:7:\"version\";s:7:\"7.x-3.4\";s:3:\"tag\";s:7:\"7.x-3.4\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:53:\"https://www.drupal.org/project/views/releases/7.x-3.4\";s:13:\"download_link\";s:58:\"https://ftp.drupal.org/files/projects/views-7.x-3.4.tar.gz\";s:4:\"date\";s:10:\"1345559303\";s:6:\"mdhash\";s:32:\"72bd0f35ac467aed74e533c10a76c93f\";s:8:\"filesize\";s:7:\"1632803\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-3.3\";a:14:{s:4:\"name\";s:13:\"views 7.x-3.3\";s:7:\"version\";s:7:\"7.x-3.3\";s:3:\"tag\";s:7:\"7.x-3.3\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:53:\"https://www.drupal.org/project/views/releases/7.x-3.3\";s:13:\"download_link\";s:58:\"https://ftp.drupal.org/files/projects/views-7.x-3.3.tar.gz\";s:4:\"date\";s:10:\"1329946249\";s:6:\"mdhash\";s:32:\"70f24086dc7acfa7fc23c6148c7f8e00\";s:8:\"filesize\";s:7:\"1583249\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-3.2\";a:14:{s:4:\"name\";s:13:\"views 7.x-3.2\";s:7:\"version\";s:7:\"7.x-3.2\";s:3:\"tag\";s:7:\"7.x-3.2\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:53:\"https://www.drupal.org/project/views/releases/7.x-3.2\";s:13:\"download_link\";s:58:\"https://ftp.drupal.org/files/projects/views-7.x-3.2.tar.gz\";s:4:\"date\";s:10:\"1329778551\";s:6:\"mdhash\";s:32:\"c350603991445ca69b30eddf3befe887\";s:8:\"filesize\";s:7:\"1582617\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-3.1\";a:14:{s:4:\"name\";s:13:\"views 7.x-3.1\";s:7:\"version\";s:7:\"7.x-3.1\";s:3:\"tag\";s:7:\"7.x-3.1\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:53:\"https://www.drupal.org/project/views/releases/7.x-3.1\";s:13:\"download_link\";s:58:\"https://ftp.drupal.org/files/projects/views-7.x-3.1.tar.gz\";s:4:\"date\";s:10:\"1326750948\";s:6:\"mdhash\";s:32:\"e158435dc66d1d89a0df587c39ef1a23\";s:8:\"filesize\";s:7:\"1575585\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-3.0\";a:14:{s:4:\"name\";s:13:\"views 7.x-3.0\";s:7:\"version\";s:7:\"7.x-3.0\";s:3:\"tag\";s:7:\"7.x-3.0\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:53:\"https://www.drupal.org/project/views/releases/7.x-3.0\";s:13:\"download_link\";s:58:\"https://ftp.drupal.org/files/projects/views-7.x-3.0.tar.gz\";s:4:\"date\";s:10:\"1324170451\";s:6:\"mdhash\";s:32:\"1be8cbd6fd3f37bfd1493693dfa95d8d\";s:8:\"filesize\";s:7:\"1461460\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:11:\"7.x-3.0-rc3\";a:15:{s:4:\"name\";s:17:\"views 7.x-3.0-rc3\";s:7:\"version\";s:11:\"7.x-3.0-rc3\";s:3:\"tag\";s:11:\"7.x-3.0-rc3\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:57:\"https://www.drupal.org/project/views/releases/7.x-3.0-rc3\";s:13:\"download_link\";s:62:\"https://ftp.drupal.org/files/projects/views-7.x-3.0-rc3.tar.gz\";s:4:\"date\";s:10:\"1321467945\";s:6:\"mdhash\";s:32:\"b3e58f4195308e37621155d3c843e53f\";s:8:\"filesize\";s:7:\"1456218\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:15:\"Security update\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:11:\"7.x-3.0-rc1\";a:15:{s:4:\"name\";s:17:\"views 7.x-3.0-rc1\";s:7:\"version\";s:11:\"7.x-3.0-rc1\";s:3:\"tag\";s:11:\"7.x-3.0-rc1\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:57:\"https://www.drupal.org/project/views/releases/7.x-3.0-rc1\";s:13:\"download_link\";s:62:\"https://ftp.drupal.org/files/projects/views-7.x-3.0-rc1.tar.gz\";s:4:\"date\";s:10:\"1308341221\";s:6:\"mdhash\";s:32:\"e158db78ae2f8cc615edb910a09384b0\";s:8:\"filesize\";s:7:\"1481151\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:13:\"7.x-3.0-beta3\";a:15:{s:4:\"name\";s:19:\"views 7.x-3.0-beta3\";s:7:\"version\";s:13:\"7.x-3.0-beta3\";s:3:\"tag\";s:13:\"7.x-3.0-beta3\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:59:\"https://www.drupal.org/project/views/releases/7.x-3.0-beta3\";s:13:\"download_link\";s:64:\"https://ftp.drupal.org/files/projects/views-7.x-3.0-beta3.tar.gz\";s:4:\"date\";s:10:\"1301301971\";s:6:\"mdhash\";s:32:\"114c76f201523ef3e50b9a1d431b0364\";s:8:\"filesize\";s:7:\"1469580\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"7.x-3.0-beta2\";a:15:{s:4:\"name\";s:19:\"views 7.x-3.0-beta2\";s:7:\"version\";s:13:\"7.x-3.0-beta2\";s:3:\"tag\";s:13:\"7.x-3.0-beta2\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:59:\"https://www.drupal.org/project/views/releases/7.x-3.0-beta2\";s:13:\"download_link\";s:64:\"https://ftp.drupal.org/files/projects/views-7.x-3.0-beta2.tar.gz\";s:4:\"date\";s:10:\"1301158871\";s:6:\"mdhash\";s:32:\"c39fab1e76e55b15291fecf2c10386c2\";s:8:\"filesize\";s:7:\"1469243\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"7.x-3.0-beta1\";a:15:{s:4:\"name\";s:19:\"views 7.x-3.0-beta1\";s:7:\"version\";s:13:\"7.x-3.0-beta1\";s:3:\"tag\";s:13:\"7.x-3.0-beta1\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:59:\"https://www.drupal.org/project/views/releases/7.x-3.0-beta1\";s:13:\"download_link\";s:64:\"https://ftp.drupal.org/files/projects/views-7.x-3.0-beta1.tar.gz\";s:4:\"date\";s:10:\"1301099796\";s:6:\"mdhash\";s:32:\"6ee4495cbdf0a8d19bd214f57bef0bf4\";s:8:\"filesize\";s:7:\"1468892\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:14:\"7.x-3.0-alpha1\";a:15:{s:4:\"name\";s:20:\"views 7.x-3.0-alpha1\";s:7:\"version\";s:14:\"7.x-3.0-alpha1\";s:3:\"tag\";s:14:\"7.x-3.0-alpha1\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:60:\"https://www.drupal.org/project/views/releases/7.x-3.0-alpha1\";s:13:\"download_link\";s:65:\"https://ftp.drupal.org/files/projects/views-7.x-3.0-alpha1.tar.gz\";s:4:\"date\";s:10:\"1294276882\";s:6:\"mdhash\";s:32:\"8635e5b0c03fed4516abae25489a5a5c\";s:8:\"filesize\";s:7:\"1561161\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:11:\"7.x-3.x-dev\";a:14:{s:4:\"name\";s:17:\"views 7.x-3.x-dev\";s:7:\"version\";s:11:\"7.x-3.x-dev\";s:3:\"tag\";s:7:\"7.x-3.x\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:57:\"https://www.drupal.org/project/views/releases/7.x-3.x-dev\";s:13:\"download_link\";s:62:\"https://ftp.drupal.org/files/projects/views-7.x-3.x-dev.tar.gz\";s:4:\"date\";s:10:\"1512487686\";s:6:\"mdhash\";s:32:\"68845818cc38541ebe30d3b19f324390\";s:8:\"filesize\";s:7:\"1648736\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}}}',1512706734,1512620327,1),('available_releases::views_fieldsets','a:11:{s:5:\"title\";s:15:\"Views fieldsets\";s:10:\"short_name\";s:15:\"views_fieldsets\";s:4:\"type\";s:14:\"project_module\";s:11:\"api_version\";s:3:\"7.x\";s:17:\"recommended_major\";s:1:\"2\";s:16:\"supported_majors\";s:1:\"2\";s:13:\"default_major\";s:1:\"2\";s:14:\"project_status\";s:9:\"published\";s:4:\"link\";s:46:\"https://www.drupal.org/project/views_fieldsets\";s:5:\"terms\";s:0:\"\";s:8:\"releases\";a:9:{s:7:\"7.x-2.1\";a:14:{s:4:\"name\";s:23:\"views_fieldsets 7.x-2.1\";s:7:\"version\";s:7:\"7.x-2.1\";s:3:\"tag\";s:7:\"7.x-2.1\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:63:\"https://www.drupal.org/project/views_fieldsets/releases/7.x-2.1\";s:13:\"download_link\";s:68:\"https://ftp.drupal.org/files/projects/views_fieldsets-7.x-2.1.tar.gz\";s:4:\"date\";s:10:\"1452361172\";s:6:\"mdhash\";s:32:\"c5865105b071c412aca65878eed1d8fe\";s:8:\"filesize\";s:5:\"14729\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-2.0\";a:14:{s:4:\"name\";s:23:\"views_fieldsets 7.x-2.0\";s:7:\"version\";s:7:\"7.x-2.0\";s:3:\"tag\";s:7:\"7.x-2.0\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:63:\"https://www.drupal.org/project/views_fieldsets/releases/7.x-2.0\";s:13:\"download_link\";s:68:\"https://ftp.drupal.org/files/projects/views_fieldsets-7.x-2.0.tar.gz\";s:4:\"date\";s:10:\"1436550539\";s:6:\"mdhash\";s:32:\"6a70727be4617284f768216fa8a00c87\";s:8:\"filesize\";s:5:\"14397\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-1.3\";a:14:{s:4:\"name\";s:23:\"views_fieldsets 7.x-1.3\";s:7:\"version\";s:7:\"7.x-1.3\";s:3:\"tag\";s:7:\"7.x-1.3\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:63:\"https://www.drupal.org/project/views_fieldsets/releases/7.x-1.3\";s:13:\"download_link\";s:68:\"https://ftp.drupal.org/files/projects/views_fieldsets-7.x-1.3.tar.gz\";s:4:\"date\";s:10:\"1425515881\";s:6:\"mdhash\";s:32:\"bb105a56ed43d3ead73e98e52ee48ca4\";s:8:\"filesize\";s:5:\"13371\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-1.2\";a:14:{s:4:\"name\";s:23:\"views_fieldsets 7.x-1.2\";s:7:\"version\";s:7:\"7.x-1.2\";s:3:\"tag\";s:7:\"7.x-1.2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:63:\"https://www.drupal.org/project/views_fieldsets/releases/7.x-1.2\";s:13:\"download_link\";s:68:\"https://ftp.drupal.org/files/projects/views_fieldsets-7.x-1.2.tar.gz\";s:4:\"date\";s:10:\"1392335005\";s:6:\"mdhash\";s:32:\"70259475223e1f57b610084fac78fc01\";s:8:\"filesize\";s:5:\"13111\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-1.1\";a:14:{s:4:\"name\";s:23:\"views_fieldsets 7.x-1.1\";s:7:\"version\";s:7:\"7.x-1.1\";s:3:\"tag\";s:7:\"7.x-1.1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:63:\"https://www.drupal.org/project/views_fieldsets/releases/7.x-1.1\";s:13:\"download_link\";s:68:\"https://ftp.drupal.org/files/projects/views_fieldsets-7.x-1.1.tar.gz\";s:4:\"date\";s:10:\"1360701659\";s:6:\"mdhash\";s:32:\"ebe6376710d9fa20b9cd655ab8428138\";s:8:\"filesize\";s:5:\"13035\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-1.0\";a:14:{s:4:\"name\";s:23:\"views_fieldsets 7.x-1.0\";s:7:\"version\";s:7:\"7.x-1.0\";s:3:\"tag\";s:7:\"7.x-1.0\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:63:\"https://www.drupal.org/project/views_fieldsets/releases/7.x-1.0\";s:13:\"download_link\";s:68:\"https://ftp.drupal.org/files/projects/views_fieldsets-7.x-1.0.tar.gz\";s:4:\"date\";s:10:\"1357769111\";s:6:\"mdhash\";s:32:\"d99b0cda11f62cf33dc7eb7f485f2154\";s:8:\"filesize\";s:5:\"12875\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:14:\"7.x-1.0-alpha1\";a:15:{s:4:\"name\";s:30:\"views_fieldsets 7.x-1.0-alpha1\";s:7:\"version\";s:14:\"7.x-1.0-alpha1\";s:3:\"tag\";s:14:\"7.x-1.0-alpha1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:70:\"https://www.drupal.org/project/views_fieldsets/releases/7.x-1.0-alpha1\";s:13:\"download_link\";s:75:\"https://ftp.drupal.org/files/projects/views_fieldsets-7.x-1.0-alpha1.tar.gz\";s:4:\"date\";s:10:\"1342189984\";s:6:\"mdhash\";s:32:\"43e62b2acdb8d4a542527c0919c47ce6\";s:8:\"filesize\";s:5:\"12805\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}s:11:\"7.x-2.x-dev\";a:14:{s:4:\"name\";s:27:\"views_fieldsets 7.x-2.x-dev\";s:7:\"version\";s:11:\"7.x-2.x-dev\";s:3:\"tag\";s:7:\"7.x-2.x\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:67:\"https://www.drupal.org/project/views_fieldsets/releases/7.x-2.x-dev\";s:13:\"download_link\";s:72:\"https://ftp.drupal.org/files/projects/views_fieldsets-7.x-2.x-dev.tar.gz\";s:4:\"date\";s:10:\"1478952539\";s:6:\"mdhash\";s:32:\"d88549432db8f2d2013b0b407cd2eb35\";s:8:\"filesize\";s:5:\"15153\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:12:\"New features\";}}s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";}s:11:\"7.x-1.x-dev\";a:14:{s:4:\"name\";s:27:\"views_fieldsets 7.x-1.x-dev\";s:7:\"version\";s:11:\"7.x-1.x-dev\";s:3:\"tag\";s:7:\"7.x-1.x\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:67:\"https://www.drupal.org/project/views_fieldsets/releases/7.x-1.x-dev\";s:13:\"download_link\";s:72:\"https://ftp.drupal.org/files/projects/views_fieldsets-7.x-1.x-dev.tar.gz\";s:4:\"date\";s:10:\"1429815481\";s:6:\"mdhash\";s:32:\"8785f8504272b1a9dfcaf90ea6accdee\";s:8:\"filesize\";s:5:\"13386\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}}}',1512706734,1512620327,1),('available_releases::views_slideshow','a:11:{s:5:\"title\";s:15:\"Views Slideshow\";s:10:\"short_name\";s:15:\"views_slideshow\";s:4:\"type\";s:14:\"project_module\";s:11:\"api_version\";s:3:\"7.x\";s:17:\"recommended_major\";s:1:\"3\";s:16:\"supported_majors\";s:1:\"3\";s:13:\"default_major\";s:1:\"3\";s:14:\"project_status\";s:9:\"published\";s:4:\"link\";s:46:\"https://www.drupal.org/project/views_slideshow\";s:5:\"terms\";s:0:\"\";s:8:\"releases\";a:12:{s:7:\"7.x-3.9\";a:14:{s:4:\"name\";s:23:\"views_slideshow 7.x-3.9\";s:7:\"version\";s:7:\"7.x-3.9\";s:3:\"tag\";s:7:\"7.x-3.9\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"9\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:63:\"https://www.drupal.org/project/views_slideshow/releases/7.x-3.9\";s:13:\"download_link\";s:68:\"https://ftp.drupal.org/files/projects/views_slideshow-7.x-3.9.tar.gz\";s:4:\"date\";s:10:\"1496893142\";s:6:\"mdhash\";s:32:\"fc1edcb8ee04923d93cdaa36ca848563\";s:8:\"filesize\";s:5:\"42352\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-3.8\";a:14:{s:4:\"name\";s:23:\"views_slideshow 7.x-3.8\";s:7:\"version\";s:7:\"7.x-3.8\";s:3:\"tag\";s:7:\"7.x-3.8\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"8\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:63:\"https://www.drupal.org/project/views_slideshow/releases/7.x-3.8\";s:13:\"download_link\";s:68:\"https://ftp.drupal.org/files/projects/views_slideshow-7.x-3.8.tar.gz\";s:4:\"date\";s:10:\"1488825783\";s:6:\"mdhash\";s:32:\"ad0e1665ad39b234df35954f96be4d78\";s:8:\"filesize\";s:5:\"42099\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-3.7\";a:14:{s:4:\"name\";s:23:\"views_slideshow 7.x-3.7\";s:7:\"version\";s:7:\"7.x-3.7\";s:3:\"tag\";s:7:\"7.x-3.7\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"7\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:63:\"https://www.drupal.org/project/views_slideshow/releases/7.x-3.7\";s:13:\"download_link\";s:68:\"https://ftp.drupal.org/files/projects/views_slideshow-7.x-3.7.tar.gz\";s:4:\"date\";s:10:\"1488323883\";s:6:\"mdhash\";s:32:\"3c9f89add1c975c6820f155a855d109d\";s:8:\"filesize\";s:5:\"41306\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-3.6\";a:14:{s:4:\"name\";s:23:\"views_slideshow 7.x-3.6\";s:7:\"version\";s:7:\"7.x-3.6\";s:3:\"tag\";s:7:\"7.x-3.6\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"6\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:63:\"https://www.drupal.org/project/views_slideshow/releases/7.x-3.6\";s:13:\"download_link\";s:68:\"https://ftp.drupal.org/files/projects/views_slideshow-7.x-3.6.tar.gz\";s:4:\"date\";s:10:\"1487211484\";s:6:\"mdhash\";s:32:\"cb17433b7585c42c64c4ce4cbaaa186d\";s:8:\"filesize\";s:5:\"40102\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-3.5\";a:14:{s:4:\"name\";s:23:\"views_slideshow 7.x-3.5\";s:7:\"version\";s:7:\"7.x-3.5\";s:3:\"tag\";s:7:\"7.x-3.5\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"5\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:63:\"https://www.drupal.org/project/views_slideshow/releases/7.x-3.5\";s:13:\"download_link\";s:68:\"https://ftp.drupal.org/files/projects/views_slideshow-7.x-3.5.tar.gz\";s:4:\"date\";s:10:\"1484857383\";s:6:\"mdhash\";s:32:\"3123e0b522aadb07b7e791eea34c27de\";s:8:\"filesize\";s:5:\"38808\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-3.4\";a:14:{s:4:\"name\";s:23:\"views_slideshow 7.x-3.4\";s:7:\"version\";s:7:\"7.x-3.4\";s:3:\"tag\";s:7:\"7.x-3.4\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:63:\"https://www.drupal.org/project/views_slideshow/releases/7.x-3.4\";s:13:\"download_link\";s:68:\"https://ftp.drupal.org/files/projects/views_slideshow-7.x-3.4.tar.gz\";s:4:\"date\";s:10:\"1483641842\";s:6:\"mdhash\";s:32:\"c793ed088af5d093df616fee77b86b41\";s:8:\"filesize\";s:5:\"38045\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-3.3\";a:14:{s:4:\"name\";s:23:\"views_slideshow 7.x-3.3\";s:7:\"version\";s:7:\"7.x-3.3\";s:3:\"tag\";s:7:\"7.x-3.3\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:63:\"https://www.drupal.org/project/views_slideshow/releases/7.x-3.3\";s:13:\"download_link\";s:68:\"https://ftp.drupal.org/files/projects/views_slideshow-7.x-3.3.tar.gz\";s:4:\"date\";s:10:\"1483562342\";s:6:\"mdhash\";s:32:\"8642510e04bb94fa5e61033b6ed6645c\";s:8:\"filesize\";s:5:\"37849\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-3.2\";a:14:{s:4:\"name\";s:23:\"views_slideshow 7.x-3.2\";s:7:\"version\";s:7:\"7.x-3.2\";s:3:\"tag\";s:7:\"7.x-3.2\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:63:\"https://www.drupal.org/project/views_slideshow/releases/7.x-3.2\";s:13:\"download_link\";s:68:\"https://ftp.drupal.org/files/projects/views_slideshow-7.x-3.2.tar.gz\";s:4:\"date\";s:10:\"1482784083\";s:6:\"mdhash\";s:32:\"81adf86198a6a0dc61aa43c961726dbe\";s:8:\"filesize\";s:5:\"37459\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-3.1\";a:14:{s:4:\"name\";s:23:\"views_slideshow 7.x-3.1\";s:7:\"version\";s:7:\"7.x-3.1\";s:3:\"tag\";s:7:\"7.x-3.1\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:63:\"https://www.drupal.org/project/views_slideshow/releases/7.x-3.1\";s:13:\"download_link\";s:68:\"https://ftp.drupal.org/files/projects/views_slideshow-7.x-3.1.tar.gz\";s:4:\"date\";s:10:\"1382584827\";s:6:\"mdhash\";s:32:\"a807ec5d346350d1f21b84be38480faf\";s:8:\"filesize\";s:5:\"35949\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-3.0\";a:14:{s:4:\"name\";s:23:\"views_slideshow 7.x-3.0\";s:7:\"version\";s:7:\"7.x-3.0\";s:3:\"tag\";s:7:\"7.x-3.0\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:63:\"https://www.drupal.org/project/views_slideshow/releases/7.x-3.0\";s:13:\"download_link\";s:68:\"https://ftp.drupal.org/files/projects/views_slideshow-7.x-3.0.tar.gz\";s:4:\"date\";s:10:\"1319589616\";s:6:\"mdhash\";s:32:\"6bf9363dacee1b55b97c0294b70b5507\";s:8:\"filesize\";s:5:\"33692\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:14:\"7.x-3.0-alpha1\";a:15:{s:4:\"name\";s:30:\"views_slideshow 7.x-3.0-alpha1\";s:7:\"version\";s:14:\"7.x-3.0-alpha1\";s:3:\"tag\";s:14:\"7.x-3.0-alpha1\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:70:\"https://www.drupal.org/project/views_slideshow/releases/7.x-3.0-alpha1\";s:13:\"download_link\";s:75:\"https://ftp.drupal.org/files/projects/views_slideshow-7.x-3.0-alpha1.tar.gz\";s:4:\"date\";s:10:\"1299893769\";s:6:\"mdhash\";s:32:\"a6b97871bde1ee41b63b60d0953b2e8b\";s:8:\"filesize\";s:5:\"29502\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:11:\"7.x-3.x-dev\";a:14:{s:4:\"name\";s:27:\"views_slideshow 7.x-3.x-dev\";s:7:\"version\";s:11:\"7.x-3.x-dev\";s:3:\"tag\";s:7:\"7.x-3.x\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:67:\"https://www.drupal.org/project/views_slideshow/releases/7.x-3.x-dev\";s:13:\"download_link\";s:72:\"https://ftp.drupal.org/files/projects/views_slideshow-7.x-3.x-dev.tar.gz\";s:4:\"date\";s:10:\"1510976285\";s:6:\"mdhash\";s:32:\"fd06837eb70fbd98239f19fca30a0ccd\";s:8:\"filesize\";s:5:\"42349\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}}}',1512706734,1512620327,1),('available_releases::votingapi','a:11:{s:5:\"title\";s:10:\"Voting API\";s:10:\"short_name\";s:9:\"votingapi\";s:4:\"type\";s:14:\"project_module\";s:11:\"api_version\";s:3:\"7.x\";s:17:\"recommended_major\";s:1:\"2\";s:16:\"supported_majors\";s:3:\"2,3\";s:13:\"default_major\";s:1:\"2\";s:14:\"project_status\";s:9:\"published\";s:4:\"link\";s:40:\"https://www.drupal.org/project/votingapi\";s:5:\"terms\";s:0:\"\";s:8:\"releases\";a:12:{s:8:\"7.x-2.12\";a:14:{s:4:\"name\";s:18:\"votingapi 7.x-2.12\";s:7:\"version\";s:8:\"7.x-2.12\";s:3:\"tag\";s:8:\"7.x-2.12\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:2:\"12\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:58:\"https://www.drupal.org/project/votingapi/releases/7.x-2.12\";s:13:\"download_link\";s:63:\"https://ftp.drupal.org/files/projects/votingapi-7.x-2.12.tar.gz\";s:4:\"date\";s:10:\"1407995928\";s:6:\"mdhash\";s:32:\"af36516e151719c7b7e9d4edb51bf045\";s:8:\"filesize\";s:5:\"31602\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:8:\"7.x-2.11\";a:14:{s:4:\"name\";s:18:\"votingapi 7.x-2.11\";s:7:\"version\";s:8:\"7.x-2.11\";s:3:\"tag\";s:8:\"7.x-2.11\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:2:\"11\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:58:\"https://www.drupal.org/project/votingapi/releases/7.x-2.11\";s:13:\"download_link\";s:63:\"https://ftp.drupal.org/files/projects/votingapi-7.x-2.11.tar.gz\";s:4:\"date\";s:10:\"1363989617\";s:6:\"mdhash\";s:32:\"bbc90109102e156bfea046d15bc59122\";s:8:\"filesize\";s:5:\"31741\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:8:\"7.x-2.10\";a:14:{s:4:\"name\";s:18:\"votingapi 7.x-2.10\";s:7:\"version\";s:8:\"7.x-2.10\";s:3:\"tag\";s:8:\"7.x-2.10\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:2:\"10\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:58:\"https://www.drupal.org/project/votingapi/releases/7.x-2.10\";s:13:\"download_link\";s:63:\"https://ftp.drupal.org/files/projects/votingapi-7.x-2.10.tar.gz\";s:4:\"date\";s:10:\"1352273826\";s:6:\"mdhash\";s:32:\"fc832cc2661fc2cdccd2929a7bcfc2b8\";s:8:\"filesize\";s:5:\"31598\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-2.9\";a:14:{s:4:\"name\";s:17:\"votingapi 7.x-2.9\";s:7:\"version\";s:7:\"7.x-2.9\";s:3:\"tag\";s:7:\"7.x-2.9\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"9\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:57:\"https://www.drupal.org/project/votingapi/releases/7.x-2.9\";s:13:\"download_link\";s:62:\"https://ftp.drupal.org/files/projects/votingapi-7.x-2.9.tar.gz\";s:4:\"date\";s:10:\"1350410215\";s:6:\"mdhash\";s:32:\"59ec628378ad6f893f405c697954a359\";s:8:\"filesize\";s:5:\"31586\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-2.8\";a:14:{s:4:\"name\";s:17:\"votingapi 7.x-2.8\";s:7:\"version\";s:7:\"7.x-2.8\";s:3:\"tag\";s:7:\"7.x-2.8\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"8\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:57:\"https://www.drupal.org/project/votingapi/releases/7.x-2.8\";s:13:\"download_link\";s:62:\"https://ftp.drupal.org/files/projects/votingapi-7.x-2.8.tar.gz\";s:4:\"date\";s:10:\"1349852523\";s:6:\"mdhash\";s:32:\"e359d448f856e3241d6f0004b6fe6284\";s:8:\"filesize\";s:5:\"31581\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-2.7\";a:14:{s:4:\"name\";s:17:\"votingapi 7.x-2.7\";s:7:\"version\";s:7:\"7.x-2.7\";s:3:\"tag\";s:7:\"7.x-2.7\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"7\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:57:\"https://www.drupal.org/project/votingapi/releases/7.x-2.7\";s:13:\"download_link\";s:62:\"https://ftp.drupal.org/files/projects/votingapi-7.x-2.7.tar.gz\";s:4:\"date\";s:10:\"1349714817\";s:6:\"mdhash\";s:32:\"603845b42d53e7e98bdeaab933dc0690\";s:8:\"filesize\";s:5:\"32495\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-2.6\";a:14:{s:4:\"name\";s:17:\"votingapi 7.x-2.6\";s:7:\"version\";s:7:\"7.x-2.6\";s:3:\"tag\";s:7:\"7.x-2.6\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"6\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:57:\"https://www.drupal.org/project/votingapi/releases/7.x-2.6\";s:13:\"download_link\";s:62:\"https://ftp.drupal.org/files/projects/votingapi-7.x-2.6.tar.gz\";s:4:\"date\";s:10:\"1330372849\";s:6:\"mdhash\";s:32:\"2af6027dca1b9952a97c497b9e6cea19\";s:8:\"filesize\";s:5:\"31868\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-2.5\";a:14:{s:4:\"name\";s:17:\"votingapi 7.x-2.5\";s:7:\"version\";s:7:\"7.x-2.5\";s:3:\"tag\";s:7:\"7.x-2.5\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"5\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:57:\"https://www.drupal.org/project/votingapi/releases/7.x-2.5\";s:13:\"download_link\";s:62:\"https://ftp.drupal.org/files/projects/votingapi-7.x-2.5.tar.gz\";s:4:\"date\";s:10:\"1330092651\";s:6:\"mdhash\";s:32:\"384f9c0f670c01f144a072790ed18407\";s:8:\"filesize\";s:5:\"31815\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-2.4\";a:14:{s:4:\"name\";s:17:\"votingapi 7.x-2.4\";s:7:\"version\";s:7:\"7.x-2.4\";s:3:\"tag\";s:7:\"7.x-2.4\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:57:\"https://www.drupal.org/project/votingapi/releases/7.x-2.4\";s:13:\"download_link\";s:62:\"https://ftp.drupal.org/files/projects/votingapi-7.x-2.4.tar.gz\";s:4:\"date\";s:10:\"1294852010\";s:6:\"mdhash\";s:32:\"e7f7b774ef1f35cbd6a1c87fbec49288\";s:8:\"filesize\";s:5:\"34714\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:13:\"7.x-2.4-beta1\";a:15:{s:4:\"name\";s:23:\"votingapi 7.x-2.4-beta1\";s:7:\"version\";s:13:\"7.x-2.4-beta1\";s:3:\"tag\";s:13:\"7.x-2.4-beta1\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"4\";s:13:\"version_extra\";s:5:\"beta1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:63:\"https://www.drupal.org/project/votingapi/releases/7.x-2.4-beta1\";s:13:\"download_link\";s:68:\"https://ftp.drupal.org/files/projects/votingapi-7.x-2.4-beta1.tar.gz\";s:4:\"date\";s:10:\"1286662869\";s:6:\"mdhash\";s:32:\"352fdf184bbc2e8bfd191daf01708e08\";s:8:\"filesize\";s:5:\"36351\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:11:\"7.x-3.x-dev\";a:14:{s:4:\"name\";s:21:\"votingapi 7.x-3.x-dev\";s:7:\"version\";s:11:\"7.x-3.x-dev\";s:3:\"tag\";s:7:\"7.x-3.x\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/votingapi/releases/7.x-3.x-dev\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/votingapi-7.x-3.x-dev.tar.gz\";s:4:\"date\";s:10:\"1382165520\";s:6:\"mdhash\";s:32:\"0d207fb268c4d4be32f810e3d4f19198\";s:8:\"filesize\";s:5:\"30566\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:12:\"New features\";}}s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";}s:11:\"7.x-2.x-dev\";a:14:{s:4:\"name\";s:21:\"votingapi 7.x-2.x-dev\";s:7:\"version\";s:11:\"7.x-2.x-dev\";s:3:\"tag\";s:7:\"7.x-2.x\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/votingapi/releases/7.x-2.x-dev\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/votingapi-7.x-2.x-dev.tar.gz\";s:4:\"date\";s:10:\"1407995729\";s:6:\"mdhash\";s:32:\"a60302f2f1fb4bf2b5ae86085c65bdc1\";s:8:\"filesize\";s:5:\"31605\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}}}',1512706734,1512620327,1),('available_releases::webform','a:11:{s:5:\"title\";s:7:\"Webform\";s:10:\"short_name\";s:7:\"webform\";s:4:\"type\";s:14:\"project_module\";s:11:\"api_version\";s:3:\"7.x\";s:17:\"recommended_major\";s:1:\"4\";s:16:\"supported_majors\";s:3:\"3,4\";s:13:\"default_major\";s:1:\"3\";s:14:\"project_status\";s:9:\"published\";s:4:\"link\";s:38:\"https://www.drupal.org/project/webform\";s:5:\"terms\";s:0:\"\";s:8:\"releases\";a:72:{s:8:\"7.x-4.16\";a:14:{s:4:\"name\";s:16:\"webform 7.x-4.16\";s:7:\"version\";s:8:\"7.x-4.16\";s:3:\"tag\";s:8:\"7.x-4.16\";s:13:\"version_major\";s:1:\"4\";s:13:\"version_patch\";s:2:\"16\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/webform/releases/7.x-4.16\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/webform-7.x-4.16.tar.gz\";s:4:\"date\";s:10:\"1507320544\";s:6:\"mdhash\";s:32:\"d4d168b87b1ca12fb0d56126ac6aeb66\";s:8:\"filesize\";s:6:\"247838\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:12:\"7.x-4.16-rc1\";a:15:{s:4:\"name\";s:20:\"webform 7.x-4.16-rc1\";s:7:\"version\";s:12:\"7.x-4.16-rc1\";s:3:\"tag\";s:12:\"7.x-4.16-rc1\";s:13:\"version_major\";s:1:\"4\";s:13:\"version_patch\";s:2:\"16\";s:13:\"version_extra\";s:3:\"rc1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:60:\"https://www.drupal.org/project/webform/releases/7.x-4.16-rc1\";s:13:\"download_link\";s:65:\"https://ftp.drupal.org/files/projects/webform-7.x-4.16-rc1.tar.gz\";s:4:\"date\";s:10:\"1505495644\";s:6:\"mdhash\";s:32:\"0c45832337e5240efac9eac1ef56e3a4\";s:8:\"filesize\";s:6:\"247808\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:8:\"7.x-4.15\";a:14:{s:4:\"name\";s:16:\"webform 7.x-4.15\";s:7:\"version\";s:8:\"7.x-4.15\";s:3:\"tag\";s:8:\"7.x-4.15\";s:13:\"version_major\";s:1:\"4\";s:13:\"version_patch\";s:2:\"15\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/webform/releases/7.x-4.15\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/webform-7.x-4.15.tar.gz\";s:4:\"date\";s:10:\"1492107243\";s:6:\"mdhash\";s:32:\"12556ecbae9cb7bf39d768d2bbd29694\";s:8:\"filesize\";s:6:\"247725\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:12:\"7.x-4.15-rc1\";a:15:{s:4:\"name\";s:20:\"webform 7.x-4.15-rc1\";s:7:\"version\";s:12:\"7.x-4.15-rc1\";s:3:\"tag\";s:12:\"7.x-4.15-rc1\";s:13:\"version_major\";s:1:\"4\";s:13:\"version_patch\";s:2:\"15\";s:13:\"version_extra\";s:3:\"rc1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:60:\"https://www.drupal.org/project/webform/releases/7.x-4.15-rc1\";s:13:\"download_link\";s:65:\"https://ftp.drupal.org/files/projects/webform-7.x-4.15-rc1.tar.gz\";s:4:\"date\";s:10:\"1490884682\";s:6:\"mdhash\";s:32:\"4a0871210035b354cdaf24a7af9a072c\";s:8:\"filesize\";s:6:\"247731\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:8:\"7.x-4.14\";a:14:{s:4:\"name\";s:16:\"webform 7.x-4.14\";s:7:\"version\";s:8:\"7.x-4.14\";s:3:\"tag\";s:8:\"7.x-4.14\";s:13:\"version_major\";s:1:\"4\";s:13:\"version_patch\";s:2:\"14\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/webform/releases/7.x-4.14\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/webform-7.x-4.14.tar.gz\";s:4:\"date\";s:10:\"1472386739\";s:6:\"mdhash\";s:32:\"9d28b1cbc3d380074b6926181543e445\";s:8:\"filesize\";s:6:\"244516\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:8:\"7.x-4.13\";a:14:{s:4:\"name\";s:16:\"webform 7.x-4.13\";s:7:\"version\";s:8:\"7.x-4.13\";s:3:\"tag\";s:8:\"7.x-4.13\";s:13:\"version_major\";s:1:\"4\";s:13:\"version_patch\";s:2:\"13\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/webform/releases/7.x-4.13\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/webform-7.x-4.13.tar.gz\";s:4:\"date\";s:10:\"1469140439\";s:6:\"mdhash\";s:32:\"dae91401fb44079b6370451bb72652eb\";s:8:\"filesize\";s:6:\"243560\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:8:\"7.x-4.12\";a:14:{s:4:\"name\";s:16:\"webform 7.x-4.12\";s:7:\"version\";s:8:\"7.x-4.12\";s:3:\"tag\";s:8:\"7.x-4.12\";s:13:\"version_major\";s:1:\"4\";s:13:\"version_patch\";s:2:\"12\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/webform/releases/7.x-4.12\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/webform-7.x-4.12.tar.gz\";s:4:\"date\";s:10:\"1445622240\";s:6:\"mdhash\";s:32:\"5eed02c0782f36b042c205f4229a076c\";s:8:\"filesize\";s:6:\"240545\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:8:\"7.x-4.11\";a:14:{s:4:\"name\";s:16:\"webform 7.x-4.11\";s:7:\"version\";s:8:\"7.x-4.11\";s:3:\"tag\";s:8:\"7.x-4.11\";s:13:\"version_major\";s:1:\"4\";s:13:\"version_patch\";s:2:\"11\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/webform/releases/7.x-4.11\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/webform-7.x-4.11.tar.gz\";s:4:\"date\";s:10:\"1442953139\";s:6:\"mdhash\";s:32:\"319613b667722186ff0b22f0f0cf2f95\";s:8:\"filesize\";s:6:\"235259\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:8:\"7.x-4.10\";a:14:{s:4:\"name\";s:16:\"webform 7.x-4.10\";s:7:\"version\";s:8:\"7.x-4.10\";s:3:\"tag\";s:8:\"7.x-4.10\";s:13:\"version_major\";s:1:\"4\";s:13:\"version_patch\";s:2:\"10\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/webform/releases/7.x-4.10\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/webform-7.x-4.10.tar.gz\";s:4:\"date\";s:10:\"1437076439\";s:6:\"mdhash\";s:32:\"a8947025d47f177154511c7406a8534e\";s:8:\"filesize\";s:6:\"234255\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-4.9\";a:14:{s:4:\"name\";s:15:\"webform 7.x-4.9\";s:7:\"version\";s:7:\"7.x-4.9\";s:3:\"tag\";s:7:\"7.x-4.9\";s:13:\"version_major\";s:1:\"4\";s:13:\"version_patch\";s:1:\"9\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:55:\"https://www.drupal.org/project/webform/releases/7.x-4.9\";s:13:\"download_link\";s:60:\"https://ftp.drupal.org/files/projects/webform-7.x-4.9.tar.gz\";s:4:\"date\";s:10:\"1432669981\";s:6:\"mdhash\";s:32:\"7a4771c9fb06bad7d0e7b51048d36e57\";s:8:\"filesize\";s:6:\"231377\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-4.8\";a:14:{s:4:\"name\";s:15:\"webform 7.x-4.8\";s:7:\"version\";s:7:\"7.x-4.8\";s:3:\"tag\";s:7:\"7.x-4.8\";s:13:\"version_major\";s:1:\"4\";s:13:\"version_patch\";s:1:\"8\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:55:\"https://www.drupal.org/project/webform/releases/7.x-4.8\";s:13:\"download_link\";s:60:\"https://ftp.drupal.org/files/projects/webform-7.x-4.8.tar.gz\";s:4:\"date\";s:10:\"1430334481\";s:6:\"mdhash\";s:32:\"dbd68b085357a4802c55edb03188e22c\";s:8:\"filesize\";s:6:\"230957\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-4.7\";a:14:{s:4:\"name\";s:15:\"webform 7.x-4.7\";s:7:\"version\";s:7:\"7.x-4.7\";s:3:\"tag\";s:7:\"7.x-4.7\";s:13:\"version_major\";s:1:\"4\";s:13:\"version_patch\";s:1:\"7\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:55:\"https://www.drupal.org/project/webform/releases/7.x-4.7\";s:13:\"download_link\";s:60:\"https://ftp.drupal.org/files/projects/webform-7.x-4.7.tar.gz\";s:4:\"date\";s:10:\"1427387581\";s:6:\"mdhash\";s:32:\"708325315325143ecf872803bb8fc97e\";s:8:\"filesize\";s:6:\"212482\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-4.6\";a:14:{s:4:\"name\";s:15:\"webform 7.x-4.6\";s:7:\"version\";s:7:\"7.x-4.6\";s:3:\"tag\";s:7:\"7.x-4.6\";s:13:\"version_major\";s:1:\"4\";s:13:\"version_patch\";s:1:\"6\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:55:\"https://www.drupal.org/project/webform/releases/7.x-4.6\";s:13:\"download_link\";s:60:\"https://ftp.drupal.org/files/projects/webform-7.x-4.6.tar.gz\";s:4:\"date\";s:10:\"1427029681\";s:6:\"mdhash\";s:32:\"4c434af84de80e9886d9a0014bbde4dc\";s:8:\"filesize\";s:6:\"212172\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-4.5\";a:14:{s:4:\"name\";s:15:\"webform 7.x-4.5\";s:7:\"version\";s:7:\"7.x-4.5\";s:3:\"tag\";s:7:\"7.x-4.5\";s:13:\"version_major\";s:1:\"4\";s:13:\"version_patch\";s:1:\"5\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:55:\"https://www.drupal.org/project/webform/releases/7.x-4.5\";s:13:\"download_link\";s:60:\"https://ftp.drupal.org/files/projects/webform-7.x-4.5.tar.gz\";s:4:\"date\";s:10:\"1426611015\";s:6:\"mdhash\";s:32:\"8b864d7fd7de0abcc11f213bc28dcc6b\";s:8:\"filesize\";s:6:\"208218\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:15:\"Security update\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-4.4\";a:14:{s:4:\"name\";s:15:\"webform 7.x-4.4\";s:7:\"version\";s:7:\"7.x-4.4\";s:3:\"tag\";s:7:\"7.x-4.4\";s:13:\"version_major\";s:1:\"4\";s:13:\"version_patch\";s:1:\"4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:55:\"https://www.drupal.org/project/webform/releases/7.x-4.4\";s:13:\"download_link\";s:60:\"https://ftp.drupal.org/files/projects/webform-7.x-4.4.tar.gz\";s:4:\"date\";s:10:\"1425406981\";s:6:\"mdhash\";s:32:\"7933b2eaa6bfd7648b490c6c1e34f56c\";s:8:\"filesize\";s:6:\"207645\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:3:{i:0;s:15:\"Security update\";i:1;s:9:\"Bug fixes\";i:2;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-4.3\";a:14:{s:4:\"name\";s:15:\"webform 7.x-4.3\";s:7:\"version\";s:7:\"7.x-4.3\";s:3:\"tag\";s:7:\"7.x-4.3\";s:13:\"version_major\";s:1:\"4\";s:13:\"version_patch\";s:1:\"3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:55:\"https://www.drupal.org/project/webform/releases/7.x-4.3\";s:13:\"download_link\";s:60:\"https://ftp.drupal.org/files/projects/webform-7.x-4.3.tar.gz\";s:4:\"date\";s:10:\"1424096281\";s:6:\"mdhash\";s:32:\"5ed6d060b3cd57ba6a0dc6aac19d31be\";s:8:\"filesize\";s:6:\"204589\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-4.2\";a:14:{s:4:\"name\";s:15:\"webform 7.x-4.2\";s:7:\"version\";s:7:\"7.x-4.2\";s:3:\"tag\";s:7:\"7.x-4.2\";s:13:\"version_major\";s:1:\"4\";s:13:\"version_patch\";s:1:\"2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:55:\"https://www.drupal.org/project/webform/releases/7.x-4.2\";s:13:\"download_link\";s:60:\"https://ftp.drupal.org/files/projects/webform-7.x-4.2.tar.gz\";s:4:\"date\";s:10:\"1416925848\";s:6:\"mdhash\";s:32:\"a48a33c79d3831b748342b1836617a74\";s:8:\"filesize\";s:6:\"202048\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-4.1\";a:14:{s:4:\"name\";s:15:\"webform 7.x-4.1\";s:7:\"version\";s:7:\"7.x-4.1\";s:3:\"tag\";s:7:\"7.x-4.1\";s:13:\"version_major\";s:1:\"4\";s:13:\"version_patch\";s:1:\"1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:55:\"https://www.drupal.org/project/webform/releases/7.x-4.1\";s:13:\"download_link\";s:60:\"https://ftp.drupal.org/files/projects/webform-7.x-4.1.tar.gz\";s:4:\"date\";s:10:\"1412681928\";s:6:\"mdhash\";s:32:\"e33d9a244c41c7b1bc6df8af00e08b7a\";s:8:\"filesize\";s:6:\"193676\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-4.0\";a:14:{s:4:\"name\";s:15:\"webform 7.x-4.0\";s:7:\"version\";s:7:\"7.x-4.0\";s:3:\"tag\";s:7:\"7.x-4.0\";s:13:\"version_major\";s:1:\"4\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:55:\"https://www.drupal.org/project/webform/releases/7.x-4.0\";s:13:\"download_link\";s:60:\"https://ftp.drupal.org/files/projects/webform-7.x-4.0.tar.gz\";s:4:\"date\";s:10:\"1409365728\";s:6:\"mdhash\";s:32:\"20c266a95b99abd24bd5dd3facba61a8\";s:8:\"filesize\";s:6:\"193699\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:11:\"7.x-4.0-rc6\";a:15:{s:4:\"name\";s:19:\"webform 7.x-4.0-rc6\";s:7:\"version\";s:11:\"7.x-4.0-rc6\";s:3:\"tag\";s:11:\"7.x-4.0-rc6\";s:13:\"version_major\";s:1:\"4\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc6\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:59:\"https://www.drupal.org/project/webform/releases/7.x-4.0-rc6\";s:13:\"download_link\";s:64:\"https://ftp.drupal.org/files/projects/webform-7.x-4.0-rc6.tar.gz\";s:4:\"date\";s:10:\"1408408128\";s:6:\"mdhash\";s:32:\"d6c9af053bb448d13db9ed4bda7373bf\";s:8:\"filesize\";s:6:\"192838\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:11:\"7.x-4.0-rc5\";a:15:{s:4:\"name\";s:19:\"webform 7.x-4.0-rc5\";s:7:\"version\";s:11:\"7.x-4.0-rc5\";s:3:\"tag\";s:11:\"7.x-4.0-rc5\";s:13:\"version_major\";s:1:\"4\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc5\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:59:\"https://www.drupal.org/project/webform/releases/7.x-4.0-rc5\";s:13:\"download_link\";s:64:\"https://ftp.drupal.org/files/projects/webform-7.x-4.0-rc5.tar.gz\";s:4:\"date\";s:10:\"1406922827\";s:6:\"mdhash\";s:32:\"376fdf4bac5d797aba46ef7c6e984dad\";s:8:\"filesize\";s:6:\"192690\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:11:\"7.x-4.0-rc4\";a:15:{s:4:\"name\";s:19:\"webform 7.x-4.0-rc4\";s:7:\"version\";s:11:\"7.x-4.0-rc4\";s:3:\"tag\";s:11:\"7.x-4.0-rc4\";s:13:\"version_major\";s:1:\"4\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:59:\"https://www.drupal.org/project/webform/releases/7.x-4.0-rc4\";s:13:\"download_link\";s:64:\"https://ftp.drupal.org/files/projects/webform-7.x-4.0-rc4.tar.gz\";s:4:\"date\";s:10:\"1403835228\";s:6:\"mdhash\";s:32:\"a7433fae49177e403a2f9ea391dbff40\";s:8:\"filesize\";s:6:\"190874\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:11:\"7.x-4.0-rc3\";a:15:{s:4:\"name\";s:19:\"webform 7.x-4.0-rc3\";s:7:\"version\";s:11:\"7.x-4.0-rc3\";s:3:\"tag\";s:11:\"7.x-4.0-rc3\";s:13:\"version_major\";s:1:\"4\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:59:\"https://www.drupal.org/project/webform/releases/7.x-4.0-rc3\";s:13:\"download_link\";s:64:\"https://ftp.drupal.org/files/projects/webform-7.x-4.0-rc3.tar.gz\";s:4:\"date\";s:10:\"1398161327\";s:6:\"mdhash\";s:32:\"dc88f99bb75f0ccb278c43ff288ee20d\";s:8:\"filesize\";s:6:\"189321\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:11:\"7.x-4.0-rc2\";a:15:{s:4:\"name\";s:19:\"webform 7.x-4.0-rc2\";s:7:\"version\";s:11:\"7.x-4.0-rc2\";s:3:\"tag\";s:11:\"7.x-4.0-rc2\";s:13:\"version_major\";s:1:\"4\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:59:\"https://www.drupal.org/project/webform/releases/7.x-4.0-rc2\";s:13:\"download_link\";s:64:\"https://ftp.drupal.org/files/projects/webform-7.x-4.0-rc2.tar.gz\";s:4:\"date\";s:10:\"1398128627\";s:6:\"mdhash\";s:32:\"83463fc7c1c09db64491821d6ec70245\";s:8:\"filesize\";s:6:\"189359\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:11:\"7.x-4.0-rc1\";a:15:{s:4:\"name\";s:19:\"webform 7.x-4.0-rc1\";s:7:\"version\";s:11:\"7.x-4.0-rc1\";s:3:\"tag\";s:11:\"7.x-4.0-rc1\";s:13:\"version_major\";s:1:\"4\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:59:\"https://www.drupal.org/project/webform/releases/7.x-4.0-rc1\";s:13:\"download_link\";s:64:\"https://ftp.drupal.org/files/projects/webform-7.x-4.0-rc1.tar.gz\";s:4:\"date\";s:10:\"1397285353\";s:6:\"mdhash\";s:32:\"f531bd82a3e8a218e8ba6b9418a272fe\";s:8:\"filesize\";s:6:\"188567\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:13:\"7.x-4.0-beta3\";a:15:{s:4:\"name\";s:21:\"webform 7.x-4.0-beta3\";s:7:\"version\";s:13:\"7.x-4.0-beta3\";s:3:\"tag\";s:13:\"7.x-4.0-beta3\";s:13:\"version_major\";s:1:\"4\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/webform/releases/7.x-4.0-beta3\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/webform-7.x-4.0-beta3.tar.gz\";s:4:\"date\";s:10:\"1392366205\";s:6:\"mdhash\";s:32:\"ed5a9f251b148852a8604d3a27d312d0\";s:8:\"filesize\";s:6:\"183926\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"7.x-4.0-beta2\";a:15:{s:4:\"name\";s:21:\"webform 7.x-4.0-beta2\";s:7:\"version\";s:13:\"7.x-4.0-beta2\";s:3:\"tag\";s:13:\"7.x-4.0-beta2\";s:13:\"version_major\";s:1:\"4\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/webform/releases/7.x-4.0-beta2\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/webform-7.x-4.0-beta2.tar.gz\";s:4:\"date\";s:10:\"1392182008\";s:6:\"mdhash\";s:32:\"8aed2f45bc2c66d21b197fe0e25ee268\";s:8:\"filesize\";s:6:\"182803\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:3:{i:0;s:15:\"Security update\";i:1;s:9:\"Bug fixes\";i:2;s:12:\"New features\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"7.x-4.0-beta1\";a:15:{s:4:\"name\";s:21:\"webform 7.x-4.0-beta1\";s:7:\"version\";s:13:\"7.x-4.0-beta1\";s:3:\"tag\";s:13:\"7.x-4.0-beta1\";s:13:\"version_major\";s:1:\"4\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/webform/releases/7.x-4.0-beta1\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/webform-7.x-4.0-beta1.tar.gz\";s:4:\"date\";s:10:\"1379945522\";s:6:\"mdhash\";s:32:\"ad8186178f170001d34c20afa0cc794c\";s:8:\"filesize\";s:6:\"178805\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}s:15:\"7.x-4.0-alpha10\";a:15:{s:4:\"name\";s:23:\"webform 7.x-4.0-alpha10\";s:7:\"version\";s:15:\"7.x-4.0-alpha10\";s:3:\"tag\";s:15:\"7.x-4.0-alpha10\";s:13:\"version_major\";s:1:\"4\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:7:\"alpha10\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:63:\"https://www.drupal.org/project/webform/releases/7.x-4.0-alpha10\";s:13:\"download_link\";s:68:\"https://ftp.drupal.org/files/projects/webform-7.x-4.0-alpha10.tar.gz\";s:4:\"date\";s:10:\"1376030931\";s:6:\"mdhash\";s:32:\"0dbf55ba01a9fa44eca22a25da43cf88\";s:8:\"filesize\";s:6:\"175015\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:14:\"7.x-4.0-alpha9\";a:15:{s:4:\"name\";s:22:\"webform 7.x-4.0-alpha9\";s:7:\"version\";s:14:\"7.x-4.0-alpha9\";s:3:\"tag\";s:14:\"7.x-4.0-alpha9\";s:13:\"version_major\";s:1:\"4\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha9\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/webform/releases/7.x-4.0-alpha9\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/webform-7.x-4.0-alpha9.tar.gz\";s:4:\"date\";s:10:\"1373869569\";s:6:\"mdhash\";s:32:\"2119eb8d79bb27e70f34bb5ed8d28d5f\";s:8:\"filesize\";s:6:\"165143\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:14:\"7.x-4.0-alpha8\";a:15:{s:4:\"name\";s:22:\"webform 7.x-4.0-alpha8\";s:7:\"version\";s:14:\"7.x-4.0-alpha8\";s:3:\"tag\";s:14:\"7.x-4.0-alpha8\";s:13:\"version_major\";s:1:\"4\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha8\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/webform/releases/7.x-4.0-alpha8\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/webform-7.x-4.0-alpha8.tar.gz\";s:4:\"date\";s:10:\"1371660352\";s:6:\"mdhash\";s:32:\"f137cf2c0835affeb5c9da810507a67c\";s:8:\"filesize\";s:6:\"160206\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:14:\"7.x-4.0-alpha7\";a:15:{s:4:\"name\";s:22:\"webform 7.x-4.0-alpha7\";s:7:\"version\";s:14:\"7.x-4.0-alpha7\";s:3:\"tag\";s:14:\"7.x-4.0-alpha7\";s:13:\"version_major\";s:1:\"4\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha7\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/webform/releases/7.x-4.0-alpha7\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/webform-7.x-4.0-alpha7.tar.gz\";s:4:\"date\";s:10:\"1371629090\";s:6:\"mdhash\";s:32:\"1639e10d3bcdccddbeed2947a93fa127\";s:8:\"filesize\";s:6:\"160211\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:14:\"7.x-4.0-alpha6\";a:15:{s:4:\"name\";s:22:\"webform 7.x-4.0-alpha6\";s:7:\"version\";s:14:\"7.x-4.0-alpha6\";s:3:\"tag\";s:14:\"7.x-4.0-alpha6\";s:13:\"version_major\";s:1:\"4\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha6\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/webform/releases/7.x-4.0-alpha6\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/webform-7.x-4.0-alpha6.tar.gz\";s:4:\"date\";s:10:\"1347692127\";s:6:\"mdhash\";s:32:\"75227a94b7db0ef7a500af2c2ebb7ab9\";s:8:\"filesize\";s:6:\"155734\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:14:\"7.x-4.0-alpha5\";a:15:{s:4:\"name\";s:22:\"webform 7.x-4.0-alpha5\";s:7:\"version\";s:14:\"7.x-4.0-alpha5\";s:3:\"tag\";s:14:\"7.x-4.0-alpha5\";s:13:\"version_major\";s:1:\"4\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha5\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/webform/releases/7.x-4.0-alpha5\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/webform-7.x-4.0-alpha5.tar.gz\";s:4:\"date\";s:10:\"1347551761\";s:6:\"mdhash\";s:32:\"5d02f0e052f7c49ffba4539b8bb4aef9\";s:8:\"filesize\";s:6:\"152419\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:14:\"7.x-4.0-alpha4\";a:15:{s:4:\"name\";s:22:\"webform 7.x-4.0-alpha4\";s:7:\"version\";s:14:\"7.x-4.0-alpha4\";s:3:\"tag\";s:14:\"7.x-4.0-alpha4\";s:13:\"version_major\";s:1:\"4\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/webform/releases/7.x-4.0-alpha4\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/webform-7.x-4.0-alpha4.tar.gz\";s:4:\"date\";s:10:\"1343527082\";s:6:\"mdhash\";s:32:\"e33d957ef4bc8f00f00d3a60aa21ac6c\";s:8:\"filesize\";s:6:\"152205\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:14:\"7.x-4.0-alpha3\";a:15:{s:4:\"name\";s:22:\"webform 7.x-4.0-alpha3\";s:7:\"version\";s:14:\"7.x-4.0-alpha3\";s:3:\"tag\";s:14:\"7.x-4.0-alpha3\";s:13:\"version_major\";s:1:\"4\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/webform/releases/7.x-4.0-alpha3\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/webform-7.x-4.0-alpha3.tar.gz\";s:4:\"date\";s:10:\"1339117034\";s:6:\"mdhash\";s:32:\"39f02ba0cee0a419a38254075f966c6a\";s:8:\"filesize\";s:6:\"151352\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:14:\"7.x-4.0-alpha2\";a:15:{s:4:\"name\";s:22:\"webform 7.x-4.0-alpha2\";s:7:\"version\";s:14:\"7.x-4.0-alpha2\";s:3:\"tag\";s:14:\"7.x-4.0-alpha2\";s:13:\"version_major\";s:1:\"4\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/webform/releases/7.x-4.0-alpha2\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/webform-7.x-4.0-alpha2.tar.gz\";s:4:\"date\";s:10:\"1338609133\";s:6:\"mdhash\";s:32:\"7fb52e64f354fb6875da48469a0d55af\";s:8:\"filesize\";s:6:\"150956\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:12:\"New features\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:14:\"7.x-4.0-alpha1\";a:15:{s:4:\"name\";s:22:\"webform 7.x-4.0-alpha1\";s:7:\"version\";s:14:\"7.x-4.0-alpha1\";s:3:\"tag\";s:14:\"7.x-4.0-alpha1\";s:13:\"version_major\";s:1:\"4\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/webform/releases/7.x-4.0-alpha1\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/webform-7.x-4.0-alpha1.tar.gz\";s:4:\"date\";s:10:\"1337451095\";s:6:\"mdhash\";s:32:\"512260ef02e1ce57ef43ec90683c1e78\";s:8:\"filesize\";s:6:\"135199\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:12:\"New features\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:8:\"7.x-3.27\";a:14:{s:4:\"name\";s:16:\"webform 7.x-3.27\";s:7:\"version\";s:8:\"7.x-3.27\";s:3:\"tag\";s:8:\"7.x-3.27\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:2:\"27\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/webform/releases/7.x-3.27\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/webform-7.x-3.27.tar.gz\";s:4:\"date\";s:10:\"1486665483\";s:6:\"mdhash\";s:32:\"17c1e11d7826c9a3554d4b6a93594c9f\";s:8:\"filesize\";s:6:\"139957\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:12:\"7.x-3.27-rc1\";a:15:{s:4:\"name\";s:20:\"webform 7.x-3.27-rc1\";s:7:\"version\";s:12:\"7.x-3.27-rc1\";s:3:\"tag\";s:12:\"7.x-3.27-rc1\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:2:\"27\";s:13:\"version_extra\";s:3:\"rc1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:60:\"https://www.drupal.org/project/webform/releases/7.x-3.27-rc1\";s:13:\"download_link\";s:65:\"https://ftp.drupal.org/files/projects/webform-7.x-3.27-rc1.tar.gz\";s:4:\"date\";s:10:\"1485444182\";s:6:\"mdhash\";s:32:\"786145dda5a2e5f4520c2197c3ea69b1\";s:8:\"filesize\";s:6:\"139957\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:8:\"7.x-3.26\";a:14:{s:4:\"name\";s:16:\"webform 7.x-3.26\";s:7:\"version\";s:8:\"7.x-3.26\";s:3:\"tag\";s:8:\"7.x-3.26\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:2:\"26\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/webform/releases/7.x-3.26\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/webform-7.x-3.26.tar.gz\";s:4:\"date\";s:10:\"1480529583\";s:6:\"mdhash\";s:32:\"065cedb9c220daccccb22f907bb3d744\";s:8:\"filesize\";s:6:\"139944\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:12:\"7.x-3.26-rc1\";a:15:{s:4:\"name\";s:20:\"webform 7.x-3.26-rc1\";s:7:\"version\";s:12:\"7.x-3.26-rc1\";s:3:\"tag\";s:12:\"7.x-3.26-rc1\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:2:\"26\";s:13:\"version_extra\";s:3:\"rc1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:60:\"https://www.drupal.org/project/webform/releases/7.x-3.26-rc1\";s:13:\"download_link\";s:65:\"https://ftp.drupal.org/files/projects/webform-7.x-3.26-rc1.tar.gz\";s:4:\"date\";s:10:\"1479312239\";s:6:\"mdhash\";s:32:\"8de44a808ec179c299df85736196b446\";s:8:\"filesize\";s:6:\"137812\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:8:\"7.x-3.25\";a:14:{s:4:\"name\";s:16:\"webform 7.x-3.25\";s:7:\"version\";s:8:\"7.x-3.25\";s:3:\"tag\";s:8:\"7.x-3.25\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:2:\"25\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/webform/releases/7.x-3.25\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/webform-7.x-3.25.tar.gz\";s:4:\"date\";s:10:\"1476870839\";s:6:\"mdhash\";s:32:\"8b039236e6e7d71ec72e0894205dae5e\";s:8:\"filesize\";s:6:\"137744\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:15:\"Security update\";i:1;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:8:\"7.x-3.24\";a:14:{s:4:\"name\";s:16:\"webform 7.x-3.24\";s:7:\"version\";s:8:\"7.x-3.24\";s:3:\"tag\";s:8:\"7.x-3.24\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:2:\"24\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/webform/releases/7.x-3.24\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/webform-7.x-3.24.tar.gz\";s:4:\"date\";s:10:\"1427956545\";s:6:\"mdhash\";s:32:\"4cc3efd543655c6af4356ff2f88d7ac3\";s:8:\"filesize\";s:6:\"137672\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:8:\"7.x-3.23\";a:14:{s:4:\"name\";s:16:\"webform 7.x-3.23\";s:7:\"version\";s:8:\"7.x-3.23\";s:3:\"tag\";s:8:\"7.x-3.23\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:2:\"23\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/webform/releases/7.x-3.23\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/webform-7.x-3.23.tar.gz\";s:4:\"date\";s:10:\"1426611015\";s:6:\"mdhash\";s:32:\"6a507412ba68d7b371fb13f18c739149\";s:8:\"filesize\";s:6:\"137624\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:15:\"Security update\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:8:\"7.x-3.22\";a:14:{s:4:\"name\";s:16:\"webform 7.x-3.22\";s:7:\"version\";s:8:\"7.x-3.22\";s:3:\"tag\";s:8:\"7.x-3.22\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:2:\"22\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/webform/releases/7.x-3.22\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/webform-7.x-3.22.tar.gz\";s:4:\"date\";s:10:\"1425406681\";s:6:\"mdhash\";s:32:\"af8e64222a07a850b5d9d1798a1d1bb2\";s:8:\"filesize\";s:6:\"136634\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:15:\"Security update\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:8:\"7.x-3.21\";a:14:{s:4:\"name\";s:16:\"webform 7.x-3.21\";s:7:\"version\";s:8:\"7.x-3.21\";s:3:\"tag\";s:8:\"7.x-3.21\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:2:\"21\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/webform/releases/7.x-3.21\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/webform-7.x-3.21.tar.gz\";s:4:\"date\";s:10:\"1412681928\";s:6:\"mdhash\";s:32:\"0a5579986a6d8698eca05ef4cd4f0ee3\";s:8:\"filesize\";s:6:\"136660\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:8:\"7.x-3.20\";a:14:{s:4:\"name\";s:16:\"webform 7.x-3.20\";s:7:\"version\";s:8:\"7.x-3.20\";s:3:\"tag\";s:8:\"7.x-3.20\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:2:\"20\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/webform/releases/7.x-3.20\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/webform-7.x-3.20.tar.gz\";s:4:\"date\";s:10:\"1392182304\";s:6:\"mdhash\";s:32:\"5011725f4998fbdff66ad31bc539c473\";s:8:\"filesize\";s:6:\"136668\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:15:\"Security update\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:8:\"7.x-3.19\";a:14:{s:4:\"name\";s:16:\"webform 7.x-3.19\";s:7:\"version\";s:8:\"7.x-3.19\";s:3:\"tag\";s:8:\"7.x-3.19\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:2:\"19\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/webform/releases/7.x-3.19\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/webform-7.x-3.19.tar.gz\";s:4:\"date\";s:10:\"1369860079\";s:6:\"mdhash\";s:32:\"75a7796e7571b8eb8107f4a0171f2a64\";s:8:\"filesize\";s:6:\"135557\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:8:\"7.x-3.18\";a:14:{s:4:\"name\";s:16:\"webform 7.x-3.18\";s:7:\"version\";s:8:\"7.x-3.18\";s:3:\"tag\";s:8:\"7.x-3.18\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:2:\"18\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/webform/releases/7.x-3.18\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/webform-7.x-3.18.tar.gz\";s:4:\"date\";s:10:\"1336890411\";s:6:\"mdhash\";s:32:\"0c831e201bfc065207e0ddfeb8169e68\";s:8:\"filesize\";s:6:\"134663\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:8:\"7.x-3.17\";a:14:{s:4:\"name\";s:16:\"webform 7.x-3.17\";s:7:\"version\";s:8:\"7.x-3.17\";s:3:\"tag\";s:8:\"7.x-3.17\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:2:\"17\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/webform/releases/7.x-3.17\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/webform-7.x-3.17.tar.gz\";s:4:\"date\";s:10:\"1331149848\";s:6:\"mdhash\";s:32:\"99164a28431b75a3ee58727698c159ba\";s:8:\"filesize\";s:6:\"132843\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:15:\"Security update\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:8:\"7.x-3.16\";a:14:{s:4:\"name\";s:16:\"webform 7.x-3.16\";s:7:\"version\";s:8:\"7.x-3.16\";s:3:\"tag\";s:8:\"7.x-3.16\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:2:\"16\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/webform/releases/7.x-3.16\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/webform-7.x-3.16.tar.gz\";s:4:\"date\";s:10:\"1330334150\";s:6:\"mdhash\";s:32:\"c0b428e7931efb4416e7b1057f37e02f\";s:8:\"filesize\";s:6:\"131554\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:8:\"7.x-3.15\";a:14:{s:4:\"name\";s:16:\"webform 7.x-3.15\";s:7:\"version\";s:8:\"7.x-3.15\";s:3:\"tag\";s:8:\"7.x-3.15\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:2:\"15\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/webform/releases/7.x-3.15\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/webform-7.x-3.15.tar.gz\";s:4:\"date\";s:10:\"1323326755\";s:6:\"mdhash\";s:32:\"6631cf2e3cfbab71e8e48dc31c0b5f04\";s:8:\"filesize\";s:6:\"123969\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:8:\"7.x-3.13\";a:14:{s:4:\"name\";s:16:\"webform 7.x-3.13\";s:7:\"version\";s:8:\"7.x-3.13\";s:3:\"tag\";s:8:\"7.x-3.13\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:2:\"13\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/webform/releases/7.x-3.13\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/webform-7.x-3.13.tar.gz\";s:4:\"date\";s:10:\"1314806221\";s:6:\"mdhash\";s:32:\"3608e957d4685680c755870b2264d444\";s:8:\"filesize\";s:6:\"121276\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:8:\"7.x-3.12\";a:14:{s:4:\"name\";s:16:\"webform 7.x-3.12\";s:7:\"version\";s:8:\"7.x-3.12\";s:3:\"tag\";s:8:\"7.x-3.12\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:2:\"12\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/webform/releases/7.x-3.12\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/webform-7.x-3.12.tar.gz\";s:4:\"date\";s:10:\"1313561826\";s:6:\"mdhash\";s:32:\"9094d0cc5d3d1e746767cd6b03474be8\";s:8:\"filesize\";s:6:\"119057\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:8:\"7.x-3.11\";a:14:{s:4:\"name\";s:16:\"webform 7.x-3.11\";s:7:\"version\";s:8:\"7.x-3.11\";s:3:\"tag\";s:8:\"7.x-3.11\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:2:\"11\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/webform/releases/7.x-3.11\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/webform-7.x-3.11.tar.gz\";s:4:\"date\";s:10:\"1305758218\";s:6:\"mdhash\";s:32:\"ab63b21e78594d9012c688d6f9242c1a\";s:8:\"filesize\";s:6:\"117272\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:8:\"7.x-3.10\";a:14:{s:4:\"name\";s:16:\"webform 7.x-3.10\";s:7:\"version\";s:8:\"7.x-3.10\";s:3:\"tag\";s:8:\"7.x-3.10\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:2:\"10\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/webform/releases/7.x-3.10\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/webform-7.x-3.10.tar.gz\";s:4:\"date\";s:10:\"1305756717\";s:6:\"mdhash\";s:32:\"a463377335ec4ea95512dabd400ac6c6\";s:8:\"filesize\";s:6:\"115439\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:15:\"Security update\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-3.9\";a:14:{s:4:\"name\";s:15:\"webform 7.x-3.9\";s:7:\"version\";s:7:\"7.x-3.9\";s:3:\"tag\";s:7:\"7.x-3.9\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"9\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:55:\"https://www.drupal.org/project/webform/releases/7.x-3.9\";s:13:\"download_link\";s:60:\"https://ftp.drupal.org/files/projects/webform-7.x-3.9.tar.gz\";s:4:\"date\";s:10:\"1299399369\";s:6:\"mdhash\";s:32:\"4622ef7902efbbdf2c76ea1a70095350\";s:8:\"filesize\";s:6:\"115250\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-3.8\";a:14:{s:4:\"name\";s:15:\"webform 7.x-3.8\";s:7:\"version\";s:7:\"7.x-3.8\";s:3:\"tag\";s:7:\"7.x-3.8\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"8\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:55:\"https://www.drupal.org/project/webform/releases/7.x-3.8\";s:13:\"download_link\";s:60:\"https://ftp.drupal.org/files/projects/webform-7.x-3.8.tar.gz\";s:4:\"date\";s:10:\"1298677273\";s:6:\"mdhash\";s:32:\"a55a253b21abae132f519943a6dfb1e2\";s:8:\"filesize\";s:6:\"115237\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-3.7\";a:14:{s:4:\"name\";s:15:\"webform 7.x-3.7\";s:7:\"version\";s:7:\"7.x-3.7\";s:3:\"tag\";s:7:\"7.x-3.7\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"7\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:55:\"https://www.drupal.org/project/webform/releases/7.x-3.7\";s:13:\"download_link\";s:60:\"https://ftp.drupal.org/files/projects/webform-7.x-3.7.tar.gz\";s:4:\"date\";s:10:\"1298534230\";s:6:\"mdhash\";s:32:\"0531afc17545bf2df8ff36fd770c9522\";s:8:\"filesize\";s:6:\"332813\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-3.6\";a:14:{s:4:\"name\";s:15:\"webform 7.x-3.6\";s:7:\"version\";s:7:\"7.x-3.6\";s:3:\"tag\";s:7:\"7.x-3.6\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"6\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:55:\"https://www.drupal.org/project/webform/releases/7.x-3.6\";s:13:\"download_link\";s:60:\"https://ftp.drupal.org/files/projects/webform-7.x-3.6.tar.gz\";s:4:\"date\";s:10:\"1294819898\";s:6:\"mdhash\";s:32:\"5b5d011f368ccc3458acb816bd322368\";s:8:\"filesize\";s:6:\"342890\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:13:\"7.x-3.4-beta1\";a:15:{s:4:\"name\";s:21:\"webform 7.x-3.4-beta1\";s:7:\"version\";s:13:\"7.x-3.4-beta1\";s:3:\"tag\";s:13:\"7.x-3.4-beta1\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"4\";s:13:\"version_extra\";s:5:\"beta1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/webform/releases/7.x-3.4-beta1\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/webform-7.x-3.4-beta1.tar.gz\";s:4:\"date\";s:10:\"1287598575\";s:6:\"mdhash\";s:32:\"2a39a8641a3da45835309830600c78dd\";s:8:\"filesize\";s:6:\"342322\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"7.x-3.3-beta1\";a:15:{s:4:\"name\";s:21:\"webform 7.x-3.3-beta1\";s:7:\"version\";s:13:\"7.x-3.3-beta1\";s:3:\"tag\";s:13:\"7.x-3.3-beta1\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"3\";s:13:\"version_extra\";s:5:\"beta1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/webform/releases/7.x-3.3-beta1\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/webform-7.x-3.3-beta1.tar.gz\";s:4:\"date\";s:10:\"1287390088\";s:6:\"mdhash\";s:32:\"05abb33a143713e3dec72dc9b832b488\";s:8:\"filesize\";s:6:\"342034\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"7.x-3.0-beta8\";a:15:{s:4:\"name\";s:21:\"webform 7.x-3.0-beta8\";s:7:\"version\";s:13:\"7.x-3.0-beta8\";s:3:\"tag\";s:13:\"7.x-3.0-beta8\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta8\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/webform/releases/7.x-3.0-beta8\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/webform-7.x-3.0-beta8.tar.gz\";s:4:\"date\";s:10:\"1282828912\";s:6:\"mdhash\";s:32:\"da4804382f6f3ba985982bb4ef0f1821\";s:8:\"filesize\";s:6:\"336720\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"7.x-3.0-beta7\";a:15:{s:4:\"name\";s:21:\"webform 7.x-3.0-beta7\";s:7:\"version\";s:13:\"7.x-3.0-beta7\";s:3:\"tag\";s:13:\"7.x-3.0-beta7\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta7\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/webform/releases/7.x-3.0-beta7\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/webform-7.x-3.0-beta7.tar.gz\";s:4:\"date\";s:10:\"1281825694\";s:6:\"mdhash\";s:32:\"e6daf245f2f70b7e101864f3c086235c\";s:8:\"filesize\";s:6:\"336332\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"7.x-3.0-beta6\";a:15:{s:4:\"name\";s:21:\"webform 7.x-3.0-beta6\";s:7:\"version\";s:13:\"7.x-3.0-beta6\";s:3:\"tag\";s:13:\"7.x-3.0-beta6\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta6\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/webform/releases/7.x-3.0-beta6\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/webform-7.x-3.0-beta6.tar.gz\";s:4:\"date\";s:10:\"1277097010\";s:6:\"mdhash\";s:32:\"b2e32326c4d009b9af6efb190f3623cd\";s:8:\"filesize\";s:6:\"336300\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"7.x-3.0-beta5\";a:15:{s:4:\"name\";s:21:\"webform 7.x-3.0-beta5\";s:7:\"version\";s:13:\"7.x-3.0-beta5\";s:3:\"tag\";s:13:\"7.x-3.0-beta5\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta5\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/webform/releases/7.x-3.0-beta5\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/webform-7.x-3.0-beta5.tar.gz\";s:4:\"date\";s:10:\"1271177414\";s:6:\"mdhash\";s:32:\"8e2e4e4b5c3e7f3b05f5af0454417f8a\";s:8:\"filesize\";s:6:\"334969\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"7.x-3.0-beta4\";a:15:{s:4:\"name\";s:21:\"webform 7.x-3.0-beta4\";s:7:\"version\";s:13:\"7.x-3.0-beta4\";s:3:\"tag\";s:13:\"7.x-3.0-beta4\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/webform/releases/7.x-3.0-beta4\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/webform-7.x-3.0-beta4.tar.gz\";s:4:\"date\";s:10:\"1270268112\";s:6:\"mdhash\";s:32:\"58886079d44ff03a11e8fc7c79e457e1\";s:8:\"filesize\";s:6:\"333147\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"7.x-3.0-beta3\";a:15:{s:4:\"name\";s:21:\"webform 7.x-3.0-beta3\";s:7:\"version\";s:13:\"7.x-3.0-beta3\";s:3:\"tag\";s:13:\"7.x-3.0-beta3\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/webform/releases/7.x-3.0-beta3\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/webform-7.x-3.0-beta3.tar.gz\";s:4:\"date\";s:10:\"1270265414\";s:6:\"mdhash\";s:32:\"285cce90e04b2bce7fe62f7e08ec152b\";s:8:\"filesize\";s:6:\"333092\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:13:\"7.x-3.0-beta2\";a:15:{s:4:\"name\";s:21:\"webform 7.x-3.0-beta2\";s:7:\"version\";s:13:\"7.x-3.0-beta2\";s:3:\"tag\";s:13:\"7.x-3.0-beta2\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/webform/releases/7.x-3.0-beta2\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/webform-7.x-3.0-beta2.tar.gz\";s:4:\"date\";s:10:\"1268446210\";s:6:\"mdhash\";s:32:\"6152ba9b80f69e4098c5fc14457e1a2e\";s:8:\"filesize\";s:6:\"327887\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}s:11:\"7.x-4.x-dev\";a:14:{s:4:\"name\";s:19:\"webform 7.x-4.x-dev\";s:7:\"version\";s:11:\"7.x-4.x-dev\";s:3:\"tag\";s:7:\"7.x-4.x\";s:13:\"version_major\";s:1:\"4\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:59:\"https://www.drupal.org/project/webform/releases/7.x-4.x-dev\";s:13:\"download_link\";s:64:\"https://ftp.drupal.org/files/projects/webform-7.x-4.x-dev.tar.gz\";s:4:\"date\";s:10:\"1509137885\";s:6:\"mdhash\";s:32:\"66a100d3aa75669db1131c2c162055ab\";s:8:\"filesize\";s:6:\"248016\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}s:11:\"7.x-3.x-dev\";a:14:{s:4:\"name\";s:19:\"webform 7.x-3.x-dev\";s:7:\"version\";s:11:\"7.x-3.x-dev\";s:3:\"tag\";s:7:\"7.x-3.x\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:59:\"https://www.drupal.org/project/webform/releases/7.x-3.x-dev\";s:13:\"download_link\";s:64:\"https://ftp.drupal.org/files/projects/webform-7.x-3.x-dev.tar.gz\";s:4:\"date\";s:10:\"1484233084\";s:6:\"mdhash\";s:32:\"d66aae2c19d435b79adf3ba7d093f435\";s:8:\"filesize\";s:6:\"139954\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";s:5:\"terms\";a:0:{}}}}',1512706735,1512620327,1),('available_releases::webform_hints','a:11:{s:5:\"title\";s:13:\"Webform Hints\";s:10:\"short_name\";s:13:\"webform_hints\";s:4:\"type\";s:14:\"project_module\";s:11:\"api_version\";s:3:\"7.x\";s:17:\"recommended_major\";s:1:\"1\";s:16:\"supported_majors\";s:1:\"1\";s:13:\"default_major\";s:1:\"1\";s:14:\"project_status\";s:9:\"published\";s:4:\"link\";s:44:\"https://www.drupal.org/project/webform_hints\";s:5:\"terms\";s:0:\"\";s:8:\"releases\";a:7:{s:7:\"7.x-1.5\";a:14:{s:4:\"name\";s:21:\"webform_hints 7.x-1.5\";s:7:\"version\";s:7:\"7.x-1.5\";s:3:\"tag\";s:7:\"7.x-1.5\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"5\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/webform_hints/releases/7.x-1.5\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/webform_hints-7.x-1.5.tar.gz\";s:4:\"date\";s:10:\"1407952127\";s:6:\"mdhash\";s:32:\"50454c993e5a7886ef493de842870981\";s:8:\"filesize\";s:5:\"12341\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-1.4\";a:14:{s:4:\"name\";s:21:\"webform_hints 7.x-1.4\";s:7:\"version\";s:7:\"7.x-1.4\";s:3:\"tag\";s:7:\"7.x-1.4\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/webform_hints/releases/7.x-1.4\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/webform_hints-7.x-1.4.tar.gz\";s:4:\"date\";s:10:\"1399566227\";s:6:\"mdhash\";s:32:\"a498ad568405383f4478f9d7d1d9978c\";s:8:\"filesize\";s:5:\"10967\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-1.3\";a:14:{s:4:\"name\";s:21:\"webform_hints 7.x-1.3\";s:7:\"version\";s:7:\"7.x-1.3\";s:3:\"tag\";s:7:\"7.x-1.3\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/webform_hints/releases/7.x-1.3\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/webform_hints-7.x-1.3.tar.gz\";s:4:\"date\";s:10:\"1382467266\";s:6:\"mdhash\";s:32:\"cf3a9f1e88a9a6c8c3bdb92c5e8a9d57\";s:8:\"filesize\";s:5:\"10925\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-1.2\";a:14:{s:4:\"name\";s:21:\"webform_hints 7.x-1.2\";s:7:\"version\";s:7:\"7.x-1.2\";s:3:\"tag\";s:7:\"7.x-1.2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/webform_hints/releases/7.x-1.2\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/webform_hints-7.x-1.2.tar.gz\";s:4:\"date\";s:10:\"1380644652\";s:6:\"mdhash\";s:32:\"55941bcaeae0298b4df888cbddae844d\";s:8:\"filesize\";s:5:\"10900\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-1.1\";a:14:{s:4:\"name\";s:21:\"webform_hints 7.x-1.1\";s:7:\"version\";s:7:\"7.x-1.1\";s:3:\"tag\";s:7:\"7.x-1.1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/webform_hints/releases/7.x-1.1\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/webform_hints-7.x-1.1.tar.gz\";s:4:\"date\";s:10:\"1378318638\";s:6:\"mdhash\";s:32:\"edd54fe09644582da243f042b758e571\";s:8:\"filesize\";s:5:\"10801\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}s:7:\"7.x-1.0\";a:14:{s:4:\"name\";s:21:\"webform_hints 7.x-1.0\";s:7:\"version\";s:7:\"7.x-1.0\";s:3:\"tag\";s:7:\"7.x-1.0\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/webform_hints/releases/7.x-1.0\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/webform_hints-7.x-1.0.tar.gz\";s:4:\"date\";s:10:\"1373641868\";s:6:\"mdhash\";s:32:\"485c5b162a13de03a52d4029d8af851e\";s:8:\"filesize\";s:5:\"10728\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";s:5:\"terms\";a:0:{}}s:11:\"7.x-1.x-dev\";a:14:{s:4:\"name\";s:25:\"webform_hints 7.x-1.x-dev\";s:7:\"version\";s:11:\"7.x-1.x-dev\";s:3:\"tag\";s:7:\"7.x-1.x\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:65:\"https://www.drupal.org/project/webform_hints/releases/7.x-1.x-dev\";s:13:\"download_link\";s:70:\"https://ftp.drupal.org/files/projects/webform_hints-7.x-1.x-dev.tar.gz\";s:4:\"date\";s:10:\"1407951527\";s:6:\"mdhash\";s:32:\"195bcecb6592f880505162e5d4a8f998\";s:8:\"filesize\";s:5:\"12349\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:59:\"Dev releases are not covered by Drupal security advisories.\";}}}',1512706735,1512620327,1),('available_releases::we_content_migration','a:10:{s:5:\"title\";s:24:\"Drupal Content Migration\";s:10:\"short_name\";s:20:\"we_content_migration\";s:4:\"type\";s:14:\"project_module\";s:11:\"api_version\";s:3:\"7.x\";s:16:\"supported_majors\";s:1:\"1\";s:13:\"default_major\";s:1:\"1\";s:14:\"project_status\";s:9:\"published\";s:4:\"link\";s:51:\"https://www.drupal.org/project/we_content_migration\";s:5:\"terms\";s:0:\"\";s:8:\"releases\";a:1:{s:11:\"7.x-1.x-dev\";a:14:{s:4:\"name\";s:32:\"we_content_migration 7.x-1.x-dev\";s:7:\"version\";s:11:\"7.x-1.x-dev\";s:3:\"tag\";s:7:\"7.x-1.x\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:72:\"https://www.drupal.org/project/we_content_migration/releases/7.x-1.x-dev\";s:13:\"download_link\";s:77:\"https://ftp.drupal.org/files/projects/we_content_migration-7.x-1.x-dev.tar.gz\";s:4:\"date\";s:10:\"1499677742\";s:6:\"mdhash\";s:32:\"5e6c20f89dc504dbc3bdfe48009e62a1\";s:8:\"filesize\";s:5:\"49548\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:12:\"New features\";}}s:8:\"security\";s:54:\"Project has not opted into security advisory coverage!\";}}}',1512706734,1512620327,1),('fetch_failures','a:0:{}',1512620639,1512620327,1),('update_project_data','a:48:{s:10:\"admin_menu\";a:17:{s:4:\"name\";s:10:\"admin_menu\";s:4:\"info\";a:6:{s:4:\"name\";s:19:\"Administration menu\";s:7:\"package\";s:14:\"Administration\";s:7:\"version\";s:11:\"7.x-3.0-rc5\";s:7:\"project\";s:10:\"admin_menu\";s:9:\"datestamp\";s:10:\"1419029284\";s:16:\"_info_file_ctime\";i:1499928385;}s:9:\"datestamp\";s:10:\"1419029284\";s:8:\"includes\";a:2:{s:10:\"admin_menu\";s:19:\"Administration menu\";s:18:\"admin_menu_toolbar\";s:33:\"Administration menu Toolbar style\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}s:16:\"existing_version\";s:11:\"7.x-3.0-rc5\";s:14:\"existing_major\";s:1:\"3\";s:12:\"install_type\";s:8:\"official\";s:5:\"title\";s:19:\"Administration menu\";s:4:\"link\";s:41:\"https://www.drupal.org/project/admin_menu\";s:14:\"latest_version\";s:11:\"7.x-3.0-rc5\";s:8:\"releases\";a:1:{s:11:\"7.x-3.0-rc5\";a:15:{s:4:\"name\";s:22:\"admin_menu 7.x-3.0-rc5\";s:7:\"version\";s:11:\"7.x-3.0-rc5\";s:3:\"tag\";s:11:\"7.x-3.0-rc5\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc5\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/admin_menu/releases/7.x-3.0-rc5\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/admin_menu-7.x-3.0-rc5.tar.gz\";s:4:\"date\";s:10:\"1419029280\";s:6:\"mdhash\";s:32:\"4f1a0c14001c880bd7eb170318b91303\";s:8:\"filesize\";s:5:\"53401\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:54:\"Project has not opted into security advisory coverage!\";}}s:11:\"recommended\";s:11:\"7.x-3.0-rc5\";s:6:\"status\";i:5;}s:14:\"advanced_forum\";a:17:{s:4:\"name\";s:14:\"advanced_forum\";s:4:\"info\";a:6:{s:4:\"name\";s:14:\"Advanced Forum\";s:7:\"package\";s:14:\"Advanced Forum\";s:7:\"version\";s:7:\"7.x-2.5\";s:7:\"project\";s:14:\"advanced_forum\";s:9:\"datestamp\";s:10:\"1423590792\";s:16:\"_info_file_ctime\";i:1499928385;}s:9:\"datestamp\";s:10:\"1423590792\";s:8:\"includes\";a:1:{s:14:\"advanced_forum\";s:14:\"Advanced Forum\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}s:16:\"existing_version\";s:7:\"7.x-2.5\";s:14:\"existing_major\";s:1:\"2\";s:12:\"install_type\";s:8:\"official\";s:5:\"title\";s:14:\"Advanced Forum\";s:4:\"link\";s:45:\"https://www.drupal.org/project/advanced_forum\";s:14:\"latest_version\";s:11:\"7.x-2.7-rc0\";s:8:\"releases\";a:2:{s:11:\"7.x-2.7-rc0\";a:15:{s:4:\"name\";s:26:\"advanced_forum 7.x-2.7-rc0\";s:7:\"version\";s:11:\"7.x-2.7-rc0\";s:3:\"tag\";s:11:\"7.x-2.7-rc0\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"7\";s:13:\"version_extra\";s:3:\"rc0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:66:\"https://www.drupal.org/project/advanced_forum/releases/7.x-2.7-rc0\";s:13:\"download_link\";s:71:\"https://ftp.drupal.org/files/projects/advanced_forum-7.x-2.7-rc0.tar.gz\";s:4:\"date\";s:10:\"1461748139\";s:6:\"mdhash\";s:32:\"c12fe91bd8ea4f7647a67cfec67f1cd6\";s:8:\"filesize\";s:6:\"168359\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:58:\"RC releases are not covered by Drupal security advisories.\";}s:7:\"7.x-2.6\";a:14:{s:4:\"name\";s:22:\"advanced_forum 7.x-2.6\";s:7:\"version\";s:7:\"7.x-2.6\";s:3:\"tag\";s:7:\"7.x-2.6\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"6\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/advanced_forum/releases/7.x-2.6\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/advanced_forum-7.x-2.6.tar.gz\";s:4:\"date\";s:10:\"1445848439\";s:6:\"mdhash\";s:32:\"974ec37282b4ebca2db1d0789130acfb\";s:8:\"filesize\";s:6:\"168301\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}}s:11:\"recommended\";s:7:\"7.x-2.6\";s:6:\"status\";i:4;}s:11:\"author_pane\";a:17:{s:4:\"name\";s:11:\"author_pane\";s:4:\"info\";a:6:{s:4:\"name\";s:11:\"Author Pane\";s:7:\"version\";s:7:\"7.x-2.0\";s:7:\"project\";s:11:\"author_pane\";s:9:\"datestamp\";s:10:\"1392987849\";s:7:\"package\";s:5:\"Other\";s:16:\"_info_file_ctime\";i:1499928385;}s:9:\"datestamp\";s:10:\"1392987849\";s:8:\"includes\";a:1:{s:11:\"author_pane\";s:11:\"Author Pane\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}s:16:\"existing_version\";s:7:\"7.x-2.0\";s:14:\"existing_major\";s:1:\"2\";s:12:\"install_type\";s:8:\"official\";s:5:\"title\";s:11:\"Author Pane\";s:4:\"link\";s:42:\"https://www.drupal.org/project/author_pane\";s:14:\"latest_version\";s:7:\"7.x-2.0\";s:8:\"releases\";a:1:{s:7:\"7.x-2.0\";a:14:{s:4:\"name\";s:19:\"author_pane 7.x-2.0\";s:7:\"version\";s:7:\"7.x-2.0\";s:3:\"tag\";s:7:\"7.x-2.0\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:59:\"https://www.drupal.org/project/author_pane/releases/7.x-2.0\";s:13:\"download_link\";s:64:\"https://ftp.drupal.org/files/projects/author_pane-7.x-2.0.tar.gz\";s:4:\"date\";s:10:\"1392987812\";s:6:\"mdhash\";s:32:\"cae7423f34203462b1c308f662b5be77\";s:8:\"filesize\";s:5:\"28291\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}}s:11:\"recommended\";s:7:\"7.x-2.0\";s:6:\"status\";i:5;}s:6:\"drupal\";a:17:{s:4:\"name\";s:6:\"drupal\";s:4:\"info\";a:6:{s:4:\"name\";s:5:\"Block\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:16:\"_info_file_ctime\";i:1500259381;}s:9:\"datestamp\";s:10:\"1498069849\";s:8:\"includes\";a:36:{s:5:\"block\";s:5:\"Block\";s:4:\"blog\";s:4:\"Blog\";s:4:\"book\";s:4:\"Book\";s:5:\"color\";s:5:\"Color\";s:7:\"comment\";s:7:\"Comment\";s:7:\"contact\";s:7:\"Contact\";s:10:\"contextual\";s:16:\"Contextual links\";s:9:\"dashboard\";s:9:\"Dashboard\";s:5:\"dblog\";s:16:\"Database logging\";s:5:\"field\";s:5:\"Field\";s:17:\"field_sql_storage\";s:17:\"Field SQL storage\";s:8:\"field_ui\";s:8:\"Field UI\";s:4:\"file\";s:4:\"File\";s:6:\"filter\";s:6:\"Filter\";s:5:\"forum\";s:5:\"Forum\";s:4:\"help\";s:4:\"Help\";s:5:\"image\";s:5:\"Image\";s:4:\"list\";s:4:\"List\";s:6:\"locale\";s:6:\"Locale\";s:4:\"menu\";s:4:\"Menu\";s:4:\"node\";s:4:\"Node\";s:6:\"number\";s:6:\"Number\";s:7:\"options\";s:7:\"Options\";s:7:\"overlay\";s:7:\"Overlay\";s:4:\"path\";s:4:\"Path\";s:3:\"php\";s:10:\"PHP filter\";s:6:\"search\";s:6:\"Search\";s:8:\"shortcut\";s:8:\"Shortcut\";s:10:\"statistics\";s:10:\"Statistics\";s:6:\"system\";s:6:\"System\";s:8:\"taxonomy\";s:8:\"Taxonomy\";s:4:\"text\";s:4:\"Text\";s:6:\"update\";s:14:\"Update manager\";s:4:\"user\";s:4:\"User\";s:6:\"bartik\";s:6:\"Bartik\";s:5:\"seven\";s:5:\"Seven\";}s:12:\"project_type\";s:4:\"core\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}s:16:\"existing_version\";s:4:\"7.56\";s:14:\"existing_major\";s:1:\"7\";s:12:\"install_type\";s:8:\"official\";s:5:\"title\";s:11:\"Drupal core\";s:4:\"link\";s:37:\"https://www.drupal.org/project/drupal\";s:14:\"latest_version\";s:4:\"7.56\";s:8:\"releases\";a:1:{s:4:\"7.56\";a:14:{s:4:\"name\";s:11:\"drupal 7.56\";s:7:\"version\";s:4:\"7.56\";s:3:\"tag\";s:4:\"7.56\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:2:\"56\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:51:\"https://www.drupal.org/project/drupal/releases/7.56\";s:13:\"download_link\";s:56:\"https://ftp.drupal.org/files/projects/drupal-7.56.tar.gz\";s:4:\"date\";s:10:\"1498069782\";s:6:\"mdhash\";s:32:\"5d198f40f0f1cbf9cdf1bf3de842e534\";s:8:\"filesize\";s:7:\"3277833\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:15:\"Security update\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}}s:11:\"recommended\";s:4:\"7.56\";s:6:\"status\";i:5;}s:11:\"block_class\";a:17:{s:4:\"name\";s:11:\"block_class\";s:4:\"info\";a:6:{s:4:\"name\";s:11:\"Block Class\";s:7:\"version\";s:7:\"7.x-2.3\";s:7:\"project\";s:11:\"block_class\";s:9:\"datestamp\";s:10:\"1450415951\";s:7:\"package\";s:5:\"Other\";s:16:\"_info_file_ctime\";i:1500261080;}s:9:\"datestamp\";s:10:\"1450415951\";s:8:\"includes\";a:1:{s:11:\"block_class\";s:11:\"Block Class\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}s:16:\"existing_version\";s:7:\"7.x-2.3\";s:14:\"existing_major\";s:1:\"2\";s:12:\"install_type\";s:8:\"official\";s:5:\"title\";s:11:\"Block Class\";s:4:\"link\";s:42:\"https://www.drupal.org/project/block_class\";s:14:\"latest_version\";s:7:\"7.x-2.3\";s:8:\"releases\";a:1:{s:7:\"7.x-2.3\";a:14:{s:4:\"name\";s:19:\"block_class 7.x-2.3\";s:7:\"version\";s:7:\"7.x-2.3\";s:3:\"tag\";s:7:\"7.x-2.3\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:59:\"https://www.drupal.org/project/block_class/releases/7.x-2.3\";s:13:\"download_link\";s:64:\"https://ftp.drupal.org/files/projects/block_class-7.x-2.3.tar.gz\";s:4:\"date\";s:10:\"1450415939\";s:6:\"mdhash\";s:32:\"286b7673faa2a067a9e96ee748331db9\";s:8:\"filesize\";s:5:\"12696\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}}s:11:\"recommended\";s:7:\"7.x-2.3\";s:6:\"status\";i:5;}s:8:\"calendar\";a:17:{s:4:\"name\";s:8:\"calendar\";s:4:\"info\";a:6:{s:4:\"name\";s:8:\"Calendar\";s:7:\"package\";s:9:\"Date/Time\";s:7:\"version\";s:7:\"7.x-3.5\";s:7:\"project\";s:8:\"calendar\";s:9:\"datestamp\";s:10:\"1413299943\";s:16:\"_info_file_ctime\";i:1499928385;}s:9:\"datestamp\";s:10:\"1413299943\";s:8:\"includes\";a:1:{s:8:\"calendar\";s:8:\"Calendar\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}s:16:\"existing_version\";s:7:\"7.x-3.5\";s:14:\"existing_major\";s:1:\"3\";s:12:\"install_type\";s:8:\"official\";s:5:\"title\";s:8:\"Calendar\";s:4:\"link\";s:39:\"https://www.drupal.org/project/calendar\";s:14:\"latest_version\";s:7:\"7.x-3.5\";s:8:\"releases\";a:1:{s:7:\"7.x-3.5\";a:14:{s:4:\"name\";s:16:\"calendar 7.x-3.5\";s:7:\"version\";s:7:\"7.x-3.5\";s:3:\"tag\";s:7:\"7.x-3.5\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"5\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/calendar/releases/7.x-3.5\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/calendar-7.x-3.5.tar.gz\";s:4:\"date\";s:10:\"1413299929\";s:6:\"mdhash\";s:32:\"722be21d595e6dec4c3946119121167b\";s:8:\"filesize\";s:5:\"60999\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}}s:11:\"recommended\";s:7:\"7.x-3.5\";s:6:\"status\";i:5;}s:6:\"chosen\";a:17:{s:4:\"name\";s:6:\"chosen\";s:4:\"info\";a:6:{s:4:\"name\";s:6:\"Chosen\";s:7:\"package\";s:14:\"User interface\";s:7:\"version\";s:13:\"7.x-2.0-beta4\";s:7:\"project\";s:6:\"chosen\";s:9:\"datestamp\";s:10:\"1394256505\";s:16:\"_info_file_ctime\";i:1499928385;}s:9:\"datestamp\";s:10:\"1394256505\";s:8:\"includes\";a:1:{s:6:\"chosen\";s:6:\"Chosen\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}s:16:\"existing_version\";s:13:\"7.x-2.0-beta4\";s:14:\"existing_major\";s:1:\"2\";s:12:\"install_type\";s:8:\"official\";s:5:\"title\";s:6:\"Chosen\";s:4:\"link\";s:37:\"https://www.drupal.org/project/chosen\";s:14:\"latest_version\";s:7:\"7.x-2.1\";s:8:\"releases\";a:1:{s:7:\"7.x-2.1\";a:14:{s:4:\"name\";s:14:\"chosen 7.x-2.1\";s:7:\"version\";s:7:\"7.x-2.1\";s:3:\"tag\";s:7:\"7.x-2.1\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:54:\"https://www.drupal.org/project/chosen/releases/7.x-2.1\";s:13:\"download_link\";s:59:\"https://ftp.drupal.org/files/projects/chosen-7.x-2.1.tar.gz\";s:4:\"date\";s:10:\"1490260383\";s:6:\"mdhash\";s:32:\"ca17f21e5ce6e1697d369301704e70ab\";s:8:\"filesize\";s:5:\"15428\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}}s:11:\"recommended\";s:7:\"7.x-2.1\";s:6:\"status\";i:4;}s:8:\"ckeditor\";a:17:{s:4:\"name\";s:8:\"ckeditor\";s:4:\"info\";a:6:{s:4:\"name\";s:8:\"CKEditor\";s:7:\"package\";s:14:\"User interface\";s:7:\"version\";s:8:\"7.x-1.16\";s:7:\"project\";s:8:\"ckeditor\";s:9:\"datestamp\";s:10:\"1413311935\";s:16:\"_info_file_ctime\";i:1499928385;}s:9:\"datestamp\";s:10:\"1413311935\";s:8:\"includes\";a:1:{s:8:\"ckeditor\";s:8:\"CKEditor\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}s:16:\"existing_version\";s:8:\"7.x-1.16\";s:14:\"existing_major\";s:1:\"1\";s:12:\"install_type\";s:8:\"official\";s:5:\"title\";s:30:\"CKEditor - WYSIWYG HTML editor\";s:4:\"link\";s:39:\"https://www.drupal.org/project/ckeditor\";s:14:\"latest_version\";s:8:\"7.x-1.18\";s:8:\"releases\";a:1:{s:8:\"7.x-1.18\";a:14:{s:4:\"name\";s:17:\"ckeditor 7.x-1.18\";s:7:\"version\";s:8:\"7.x-1.18\";s:3:\"tag\";s:8:\"7.x-1.18\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:2:\"18\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:57:\"https://www.drupal.org/project/ckeditor/releases/7.x-1.18\";s:13:\"download_link\";s:62:\"https://ftp.drupal.org/files/projects/ckeditor-7.x-1.18.tar.gz\";s:4:\"date\";s:10:\"1498506242\";s:6:\"mdhash\";s:32:\"c85049f6a351e6e72b8890f01325eed2\";s:8:\"filesize\";s:6:\"198098\";s:5:\"files\";s:0:\"\";s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";s:5:\"terms\";a:0:{}}}s:11:\"recommended\";s:8:\"7.x-1.18\";s:6:\"status\";i:4;}s:6:\"ctools\";a:17:{s:4:\"name\";s:6:\"ctools\";s:4:\"info\";a:6:{s:4:\"name\";s:11:\"Chaos tools\";s:7:\"package\";s:16:\"Chaos tool suite\";s:7:\"version\";s:7:\"7.x-1.9\";s:7:\"project\";s:6:\"ctools\";s:9:\"datestamp\";s:10:\"1440020680\";s:16:\"_info_file_ctime\";i:1499928385;}s:9:\"datestamp\";s:10:\"1440020680\";s:8:\"includes\";a:1:{s:6:\"ctools\";s:11:\"Chaos tools\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}s:16:\"existing_version\";s:7:\"7.x-1.9\";s:14:\"existing_major\";s:1:\"1\";s:12:\"install_type\";s:8:\"official\";s:5:\"title\";s:25:\"Chaos tool suite (ctools)\";s:4:\"link\";s:37:\"https://www.drupal.org/project/ctools\";s:14:\"latest_version\";s:8:\"7.x-1.12\";s:8:\"releases\";a:1:{s:8:\"7.x-1.12\";a:14:{s:4:\"name\";s:15:\"ctools 7.x-1.12\";s:7:\"version\";s:8:\"7.x-1.12\";s:3:\"tag\";s:8:\"7.x-1.12\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:2:\"12\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:55:\"https://www.drupal.org/project/ctools/releases/7.x-1.12\";s:13:\"download_link\";s:60:\"https://ftp.drupal.org/files/projects/ctools-7.x-1.12.tar.gz\";s:4:\"date\";s:10:\"1479787142\";s:6:\"mdhash\";s:32:\"daae0be22830e34c4d952f91557ae5a5\";s:8:\"filesize\";s:6:\"433707\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}}s:11:\"recommended\";s:8:\"7.x-1.12\";s:6:\"status\";i:4;}s:4:\"date\";a:17:{s:4:\"name\";s:4:\"date\";s:4:\"info\";a:6:{s:4:\"name\";s:8:\"Date API\";s:7:\"package\";s:9:\"Date/Time\";s:7:\"version\";s:7:\"7.x-2.8\";s:7:\"project\";s:4:\"date\";s:9:\"datestamp\";s:10:\"1406653438\";s:16:\"_info_file_ctime\";i:1499928385;}s:9:\"datestamp\";s:10:\"1406653438\";s:8:\"includes\";a:2:{s:8:\"date_api\";s:8:\"Date API\";s:10:\"date_views\";s:10:\"Date Views\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}s:16:\"existing_version\";s:7:\"7.x-2.8\";s:14:\"existing_major\";s:1:\"2\";s:12:\"install_type\";s:8:\"official\";s:5:\"title\";s:4:\"Date\";s:4:\"link\";s:35:\"https://www.drupal.org/project/date\";s:14:\"latest_version\";s:8:\"7.x-2.10\";s:8:\"releases\";a:1:{s:8:\"7.x-2.10\";a:14:{s:4:\"name\";s:13:\"date 7.x-2.10\";s:7:\"version\";s:8:\"7.x-2.10\";s:3:\"tag\";s:8:\"7.x-2.10\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:2:\"10\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:53:\"https://www.drupal.org/project/date/releases/7.x-2.10\";s:13:\"download_link\";s:58:\"https://ftp.drupal.org/files/projects/date-7.x-2.10.tar.gz\";s:4:\"date\";s:10:\"1491562083\";s:6:\"mdhash\";s:32:\"2574ab984de79b65f93dbeb48a4e2036\";s:8:\"filesize\";s:6:\"226466\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}}s:11:\"recommended\";s:8:\"7.x-2.10\";s:6:\"status\";i:4;}s:6:\"entity\";a:17:{s:4:\"name\";s:6:\"entity\";s:4:\"info\";a:6:{s:4:\"name\";s:10:\"Entity API\";s:7:\"version\";s:7:\"7.x-1.6\";s:7:\"project\";s:6:\"entity\";s:9:\"datestamp\";s:10:\"1424876582\";s:7:\"package\";s:5:\"Other\";s:16:\"_info_file_ctime\";i:1499928385;}s:9:\"datestamp\";s:10:\"1424876582\";s:8:\"includes\";a:2:{s:6:\"entity\";s:10:\"Entity API\";s:12:\"entity_token\";s:13:\"Entity tokens\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}s:16:\"existing_version\";s:7:\"7.x-1.6\";s:14:\"existing_major\";s:1:\"1\";s:12:\"install_type\";s:8:\"official\";s:5:\"title\";s:10:\"Entity API\";s:4:\"link\";s:37:\"https://www.drupal.org/project/entity\";s:14:\"latest_version\";s:7:\"7.x-1.8\";s:8:\"releases\";a:1:{s:7:\"7.x-1.8\";a:14:{s:4:\"name\";s:14:\"entity 7.x-1.8\";s:7:\"version\";s:7:\"7.x-1.8\";s:3:\"tag\";s:7:\"7.x-1.8\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"8\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:54:\"https://www.drupal.org/project/entity/releases/7.x-1.8\";s:13:\"download_link\";s:59:\"https://ftp.drupal.org/files/projects/entity-7.x-1.8.tar.gz\";s:4:\"date\";s:10:\"1474545839\";s:6:\"mdhash\";s:32:\"3926d48c86387c3d1d5777538903a752\";s:8:\"filesize\";s:6:\"123957\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}}s:11:\"recommended\";s:7:\"7.x-1.8\";s:6:\"status\";i:4;}s:15:\"entityreference\";a:18:{s:4:\"name\";s:15:\"entityreference\";s:4:\"info\";a:6:{s:4:\"name\";s:16:\"Entity Reference\";s:7:\"package\";s:6:\"Fields\";s:7:\"version\";s:7:\"7.x-1.1\";s:7:\"project\";s:15:\"entityreference\";s:9:\"datestamp\";s:10:\"1384973110\";s:16:\"_info_file_ctime\";i:1499928385;}s:9:\"datestamp\";s:10:\"1384973110\";s:8:\"includes\";a:1:{s:15:\"entityreference\";s:16:\"Entity Reference\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}s:16:\"existing_version\";s:7:\"7.x-1.1\";s:14:\"existing_major\";s:1:\"1\";s:12:\"install_type\";s:8:\"official\";s:5:\"title\";s:16:\"Entity reference\";s:4:\"link\";s:46:\"https://www.drupal.org/project/entityreference\";s:14:\"latest_version\";s:7:\"7.x-1.5\";s:8:\"releases\";a:1:{s:7:\"7.x-1.5\";a:14:{s:4:\"name\";s:23:\"entityreference 7.x-1.5\";s:7:\"version\";s:7:\"7.x-1.5\";s:3:\"tag\";s:7:\"7.x-1.5\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"5\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:63:\"https://www.drupal.org/project/entityreference/releases/7.x-1.5\";s:13:\"download_link\";s:68:\"https://ftp.drupal.org/files/projects/entityreference-7.x-1.5.tar.gz\";s:4:\"date\";s:10:\"1502895843\";s:6:\"mdhash\";s:32:\"56f6198ead378b93eb978444c3cdd948\";s:8:\"filesize\";s:5:\"43330\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:15:\"Security update\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}}s:11:\"recommended\";s:7:\"7.x-1.5\";s:16:\"security updates\";a:1:{i:0;a:14:{s:4:\"name\";s:23:\"entityreference 7.x-1.5\";s:7:\"version\";s:7:\"7.x-1.5\";s:3:\"tag\";s:7:\"7.x-1.5\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"5\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:63:\"https://www.drupal.org/project/entityreference/releases/7.x-1.5\";s:13:\"download_link\";s:68:\"https://ftp.drupal.org/files/projects/entityreference-7.x-1.5.tar.gz\";s:4:\"date\";s:10:\"1502895843\";s:6:\"mdhash\";s:32:\"56f6198ead378b93eb978444c3cdd948\";s:8:\"filesize\";s:5:\"43330\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:15:\"Security update\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}}s:6:\"status\";i:1;}s:3:\"faq\";a:18:{s:4:\"name\";s:3:\"faq\";s:4:\"info\";a:6:{s:4:\"name\";s:26:\"Frequently Asked Questions\";s:7:\"version\";s:11:\"7.x-1.0-rc3\";s:7:\"project\";s:3:\"faq\";s:9:\"datestamp\";s:10:\"1415528891\";s:7:\"package\";s:5:\"Other\";s:16:\"_info_file_ctime\";i:1499928385;}s:9:\"datestamp\";s:10:\"1415528891\";s:8:\"includes\";a:1:{s:3:\"faq\";s:26:\"Frequently Asked Questions\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}s:16:\"existing_version\";s:11:\"7.x-1.0-rc3\";s:14:\"existing_major\";s:1:\"1\";s:12:\"install_type\";s:8:\"official\";s:5:\"title\";s:26:\"Frequently Asked Questions\";s:4:\"link\";s:34:\"https://www.drupal.org/project/faq\";s:4:\"also\";a:1:{i:2;s:14:\"7.x-2.0-alpha2\";}s:8:\"releases\";a:2:{s:14:\"7.x-2.0-alpha2\";a:15:{s:4:\"name\";s:18:\"faq 7.x-2.0-alpha2\";s:7:\"version\";s:14:\"7.x-2.0-alpha2\";s:3:\"tag\";s:14:\"7.x-2.0-alpha2\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:58:\"https://www.drupal.org/project/faq/releases/7.x-2.0-alpha2\";s:13:\"download_link\";s:63:\"https://ftp.drupal.org/files/projects/faq-7.x-2.0-alpha2.tar.gz\";s:4:\"date\";s:10:\"1410364432\";s:6:\"mdhash\";s:32:\"d5939a9b175274cd1df691ecf7435d3c\";s:8:\"filesize\";s:5:\"40831\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:7:\"7.x-1.1\";a:14:{s:4:\"name\";s:11:\"faq 7.x-1.1\";s:7:\"version\";s:7:\"7.x-1.1\";s:3:\"tag\";s:7:\"7.x-1.1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:51:\"https://www.drupal.org/project/faq/releases/7.x-1.1\";s:13:\"download_link\";s:56:\"https://ftp.drupal.org/files/projects/faq-7.x-1.1.tar.gz\";s:4:\"date\";s:10:\"1441726439\";s:6:\"mdhash\";s:32:\"abd5f2f55925c9e25c52a79d9c682d39\";s:8:\"filesize\";s:5:\"42295\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}}s:14:\"latest_version\";s:7:\"7.x-1.1\";s:11:\"recommended\";s:7:\"7.x-1.1\";s:6:\"status\";i:4;}s:8:\"features\";a:17:{s:4:\"name\";s:8:\"features\";s:4:\"info\";a:6:{s:4:\"name\";s:8:\"Features\";s:7:\"package\";s:8:\"Features\";s:7:\"version\";s:8:\"7.x-2.10\";s:7:\"project\";s:8:\"features\";s:9:\"datestamp\";s:10:\"1461011641\";s:16:\"_info_file_ctime\";i:1500260145;}s:9:\"datestamp\";s:10:\"1461011641\";s:8:\"includes\";a:1:{s:8:\"features\";s:8:\"Features\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}s:16:\"existing_version\";s:8:\"7.x-2.10\";s:14:\"existing_major\";s:1:\"2\";s:12:\"install_type\";s:8:\"official\";s:5:\"title\";s:8:\"Features\";s:4:\"link\";s:39:\"https://www.drupal.org/project/features\";s:14:\"latest_version\";s:8:\"7.x-2.10\";s:8:\"releases\";a:1:{s:8:\"7.x-2.10\";a:14:{s:4:\"name\";s:17:\"features 7.x-2.10\";s:7:\"version\";s:8:\"7.x-2.10\";s:3:\"tag\";s:8:\"7.x-2.10\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:2:\"10\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:57:\"https://www.drupal.org/project/features/releases/7.x-2.10\";s:13:\"download_link\";s:62:\"https://ftp.drupal.org/files/projects/features-7.x-2.10.tar.gz\";s:4:\"date\";s:10:\"1461011639\";s:6:\"mdhash\";s:32:\"5641e5545020932570aed464fbaebf6a\";s:8:\"filesize\";s:5:\"97102\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}}s:11:\"recommended\";s:8:\"7.x-2.10\";s:6:\"status\";i:5;}s:16:\"field_collection\";a:17:{s:4:\"name\";s:16:\"field_collection\";s:4:\"info\";a:6:{s:4:\"name\";s:16:\"Field collection\";s:7:\"package\";s:6:\"Fields\";s:7:\"version\";s:13:\"7.x-1.0-beta8\";s:7:\"project\";s:16:\"field_collection\";s:9:\"datestamp\";s:10:\"1415122384\";s:16:\"_info_file_ctime\";i:1499928385;}s:9:\"datestamp\";s:10:\"1415122384\";s:8:\"includes\";a:1:{s:16:\"field_collection\";s:16:\"Field collection\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}s:16:\"existing_version\";s:13:\"7.x-1.0-beta8\";s:14:\"existing_major\";s:1:\"1\";s:12:\"install_type\";s:8:\"official\";s:5:\"title\";s:16:\"Field collection\";s:4:\"link\";s:47:\"https://www.drupal.org/project/field_collection\";s:14:\"latest_version\";s:14:\"7.x-1.0-beta12\";s:8:\"releases\";a:1:{s:14:\"7.x-1.0-beta12\";a:15:{s:4:\"name\";s:31:\"field_collection 7.x-1.0-beta12\";s:7:\"version\";s:14:\"7.x-1.0-beta12\";s:3:\"tag\";s:14:\"7.x-1.0-beta12\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"beta12\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:71:\"https://www.drupal.org/project/field_collection/releases/7.x-1.0-beta12\";s:13:\"download_link\";s:76:\"https://ftp.drupal.org/files/projects/field_collection-7.x-1.0-beta12.tar.gz\";s:4:\"date\";s:10:\"1479402842\";s:6:\"mdhash\";s:32:\"e966ba0c2ad40b9b044ae8bdf993f5ed\";s:8:\"filesize\";s:5:\"51018\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:54:\"Project has not opted into security advisory coverage!\";}}s:11:\"recommended\";s:14:\"7.x-1.0-beta12\";s:6:\"status\";i:4;}s:11:\"field_group\";a:17:{s:4:\"name\";s:11:\"field_group\";s:4:\"info\";a:6:{s:4:\"name\";s:11:\"Field Group\";s:7:\"package\";s:6:\"Fields\";s:7:\"version\";s:7:\"7.x-1.5\";s:7:\"project\";s:11:\"field_group\";s:9:\"datestamp\";s:10:\"1452033709\";s:16:\"_info_file_ctime\";i:1500259485;}s:9:\"datestamp\";s:10:\"1452033709\";s:8:\"includes\";a:1:{s:11:\"field_group\";s:11:\"Field Group\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}s:16:\"existing_version\";s:7:\"7.x-1.5\";s:14:\"existing_major\";s:1:\"1\";s:12:\"install_type\";s:8:\"official\";s:5:\"title\";s:11:\"Field Group\";s:4:\"link\";s:42:\"https://www.drupal.org/project/field_group\";s:14:\"latest_version\";s:7:\"7.x-1.6\";s:8:\"releases\";a:1:{s:7:\"7.x-1.6\";a:14:{s:4:\"name\";s:19:\"field_group 7.x-1.6\";s:7:\"version\";s:7:\"7.x-1.6\";s:3:\"tag\";s:7:\"7.x-1.6\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"6\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:59:\"https://www.drupal.org/project/field_group/releases/7.x-1.6\";s:13:\"download_link\";s:64:\"https://ftp.drupal.org/files/projects/field_group-7.x-1.6.tar.gz\";s:4:\"date\";s:10:\"1509751984\";s:6:\"mdhash\";s:32:\"14a100269b1ddfe88c32442c8da53d1d\";s:8:\"filesize\";s:5:\"52556\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}}s:11:\"recommended\";s:7:\"7.x-1.6\";s:6:\"status\";i:4;}s:8:\"fivestar\";a:17:{s:4:\"name\";s:8:\"fivestar\";s:4:\"info\";a:6:{s:4:\"name\";s:8:\"Fivestar\";s:7:\"package\";s:6:\"Voting\";s:7:\"version\";s:7:\"7.x-2.1\";s:7:\"project\";s:8:\"fivestar\";s:9:\"datestamp\";s:10:\"1395087839\";s:16:\"_info_file_ctime\";i:1499928385;}s:9:\"datestamp\";s:10:\"1395087839\";s:8:\"includes\";a:1:{s:8:\"fivestar\";s:8:\"Fivestar\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}s:16:\"existing_version\";s:7:\"7.x-2.1\";s:14:\"existing_major\";s:1:\"2\";s:12:\"install_type\";s:8:\"official\";s:5:\"title\";s:8:\"Fivestar\";s:4:\"link\";s:39:\"https://www.drupal.org/project/fivestar\";s:14:\"latest_version\";s:7:\"7.x-2.2\";s:8:\"releases\";a:1:{s:7:\"7.x-2.2\";a:14:{s:4:\"name\";s:16:\"fivestar 7.x-2.2\";s:7:\"version\";s:7:\"7.x-2.2\";s:3:\"tag\";s:7:\"7.x-2.2\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/fivestar/releases/7.x-2.2\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/fivestar-7.x-2.2.tar.gz\";s:4:\"date\";s:10:\"1461406441\";s:6:\"mdhash\";s:32:\"ed5cb540db0944a47d7f09657b39d7e4\";s:8:\"filesize\";s:6:\"226248\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}}s:11:\"recommended\";s:7:\"7.x-2.2\";s:6:\"status\";i:4;}s:10:\"flexslider\";a:17:{s:4:\"name\";s:10:\"flexslider\";s:4:\"info\";a:6:{s:4:\"name\";s:10:\"FlexSlider\";s:7:\"package\";s:10:\"FlexSlider\";s:7:\"version\";s:14:\"7.x-2.0-alpha3\";s:7:\"project\";s:10:\"flexslider\";s:9:\"datestamp\";s:10:\"1378663043\";s:16:\"_info_file_ctime\";i:1499928385;}s:9:\"datestamp\";s:10:\"1378663043\";s:8:\"includes\";a:3:{s:10:\"flexslider\";s:10:\"FlexSlider\";s:17:\"flexslider_fields\";s:17:\"FlexSlider Fields\";s:16:\"flexslider_views\";s:22:\"FlexSlider Views Style\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}s:16:\"existing_version\";s:14:\"7.x-2.0-alpha3\";s:14:\"existing_major\";s:1:\"2\";s:12:\"install_type\";s:8:\"official\";s:5:\"title\";s:11:\"Flex Slider\";s:4:\"link\";s:41:\"https://www.drupal.org/project/flexslider\";s:14:\"latest_version\";s:11:\"7.x-2.0-rc2\";s:8:\"releases\";a:1:{s:11:\"7.x-2.0-rc2\";a:15:{s:4:\"name\";s:22:\"flexslider 7.x-2.0-rc2\";s:7:\"version\";s:11:\"7.x-2.0-rc2\";s:3:\"tag\";s:11:\"7.x-2.0-rc2\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:62:\"https://www.drupal.org/project/flexslider/releases/7.x-2.0-rc2\";s:13:\"download_link\";s:67:\"https://ftp.drupal.org/files/projects/flexslider-7.x-2.0-rc2.tar.gz\";s:4:\"date\";s:10:\"1487028483\";s:6:\"mdhash\";s:32:\"6bbfff91fc66bef36e8ef42323a33a59\";s:8:\"filesize\";s:7:\"3976547\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:54:\"Project has not opted into security advisory coverage!\";}}s:11:\"recommended\";s:11:\"7.x-2.0-rc2\";s:6:\"status\";i:4;}s:4:\"i18n\";a:17:{s:4:\"name\";s:4:\"i18n\";s:4:\"info\";a:6:{s:4:\"name\";s:20:\"Internationalization\";s:7:\"package\";s:35:\"Multilingual - Internationalization\";s:7:\"version\";s:8:\"7.x-1.13\";s:7:\"project\";s:4:\"i18n\";s:9:\"datestamp\";s:10:\"1430999922\";s:16:\"_info_file_ctime\";i:1499928385;}s:9:\"datestamp\";s:10:\"1430999922\";s:8:\"includes\";a:5:{s:4:\"i18n\";s:20:\"Internationalization\";s:10:\"i18n_block\";s:15:\"Block languages\";s:11:\"i18n_string\";s:18:\"String translation\";s:13:\"i18n_taxonomy\";s:20:\"Taxonomy translation\";s:16:\"i18n_translation\";s:16:\"Translation sets\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}s:16:\"existing_version\";s:8:\"7.x-1.13\";s:14:\"existing_major\";s:1:\"1\";s:12:\"install_type\";s:8:\"official\";s:5:\"title\";s:20:\"Internationalization\";s:4:\"link\";s:35:\"https://www.drupal.org/project/i18n\";s:14:\"latest_version\";s:8:\"7.x-1.22\";s:8:\"releases\";a:1:{s:8:\"7.x-1.22\";a:14:{s:4:\"name\";s:13:\"i18n 7.x-1.22\";s:7:\"version\";s:8:\"7.x-1.22\";s:3:\"tag\";s:8:\"7.x-1.22\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:2:\"22\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:53:\"https://www.drupal.org/project/i18n/releases/7.x-1.22\";s:13:\"download_link\";s:58:\"https://ftp.drupal.org/files/projects/i18n-7.x-1.22.tar.gz\";s:4:\"date\";s:10:\"1511689985\";s:6:\"mdhash\";s:32:\"7c3abc1bb63a67acc75b77c020c739ea\";s:8:\"filesize\";s:6:\"159112\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}}s:11:\"recommended\";s:8:\"7.x-1.22\";s:6:\"status\";i:4;}s:13:\"jquery_update\";a:18:{s:4:\"name\";s:13:\"jquery_update\";s:4:\"info\";a:6:{s:4:\"name\";s:13:\"jQuery Update\";s:7:\"package\";s:14:\"User interface\";s:7:\"version\";s:7:\"7.x-2.7\";s:7:\"project\";s:13:\"jquery_update\";s:9:\"datestamp\";s:10:\"1445379855\";s:16:\"_info_file_ctime\";i:1500261015;}s:9:\"datestamp\";s:10:\"1445379855\";s:8:\"includes\";a:1:{s:13:\"jquery_update\";s:13:\"jQuery Update\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}s:16:\"existing_version\";s:7:\"7.x-2.7\";s:14:\"existing_major\";s:1:\"2\";s:12:\"install_type\";s:8:\"official\";s:5:\"title\";s:13:\"jQuery Update\";s:4:\"link\";s:44:\"https://www.drupal.org/project/jquery_update\";s:4:\"also\";a:1:{i:3;s:14:\"7.x-3.0-alpha5\";}s:8:\"releases\";a:2:{s:14:\"7.x-3.0-alpha5\";a:15:{s:4:\"name\";s:28:\"jquery_update 7.x-3.0-alpha5\";s:7:\"version\";s:14:\"7.x-3.0-alpha5\";s:3:\"tag\";s:14:\"7.x-3.0-alpha5\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha5\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:68:\"https://www.drupal.org/project/jquery_update/releases/7.x-3.0-alpha5\";s:13:\"download_link\";s:73:\"https://ftp.drupal.org/files/projects/jquery_update-7.x-3.0-alpha5.tar.gz\";s:4:\"date\";s:10:\"1490805183\";s:6:\"mdhash\";s:32:\"48baebd87003519ade8c65dc5598bbe5\";s:8:\"filesize\";s:7:\"1980268\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:7:\"7.x-2.7\";a:14:{s:4:\"name\";s:21:\"jquery_update 7.x-2.7\";s:7:\"version\";s:7:\"7.x-2.7\";s:3:\"tag\";s:7:\"7.x-2.7\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"7\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/jquery_update/releases/7.x-2.7\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/jquery_update-7.x-2.7.tar.gz\";s:4:\"date\";s:10:\"1445379839\";s:6:\"mdhash\";s:32:\"85eaf02362c384979bc475df30ae7a3e\";s:8:\"filesize\";s:7:\"1135987\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:15:\"Security update\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}}s:14:\"latest_version\";s:7:\"7.x-2.7\";s:11:\"recommended\";s:7:\"7.x-2.7\";s:6:\"status\";i:5;}s:13:\"lang_dropdown\";a:17:{s:4:\"name\";s:13:\"lang_dropdown\";s:4:\"info\";a:6:{s:4:\"name\";s:26:\"Language Switcher Dropdown\";s:7:\"package\";s:12:\"Multilingual\";s:7:\"version\";s:7:\"7.x-2.5\";s:7:\"project\";s:13:\"lang_dropdown\";s:9:\"datestamp\";s:10:\"1387127905\";s:16:\"_info_file_ctime\";i:1499928385;}s:9:\"datestamp\";s:10:\"1387127905\";s:8:\"includes\";a:2:{s:13:\"lang_dropdown\";s:26:\"Language Switcher Dropdown\";s:21:\"lang_dropdown_hideout\";s:34:\"Language Switcher Dropdown Hideout\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}s:16:\"existing_version\";s:7:\"7.x-2.5\";s:14:\"existing_major\";s:1:\"2\";s:12:\"install_type\";s:8:\"official\";s:5:\"title\";s:26:\"Language Switcher Dropdown\";s:4:\"link\";s:44:\"https://www.drupal.org/project/lang_dropdown\";s:14:\"latest_version\";s:7:\"7.x-2.5\";s:8:\"releases\";a:1:{s:7:\"7.x-2.5\";a:14:{s:4:\"name\";s:21:\"lang_dropdown 7.x-2.5\";s:7:\"version\";s:7:\"7.x-2.5\";s:3:\"tag\";s:7:\"7.x-2.5\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"5\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/lang_dropdown/releases/7.x-2.5\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/lang_dropdown-7.x-2.5.tar.gz\";s:4:\"date\";s:10:\"1387127904\";s:6:\"mdhash\";s:32:\"691113055535b8b1d4225d7eecb5a667\";s:8:\"filesize\";s:5:\"24486\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}}s:11:\"recommended\";s:7:\"7.x-2.5\";s:6:\"status\";i:5;}s:13:\"languageicons\";a:17:{s:4:\"name\";s:13:\"languageicons\";s:4:\"info\";a:6:{s:4:\"name\";s:14:\"Language Icons\";s:7:\"package\";s:12:\"Multilingual\";s:7:\"version\";s:7:\"7.x-1.1\";s:7:\"project\";s:13:\"languageicons\";s:9:\"datestamp\";s:10:\"1399825730\";s:16:\"_info_file_ctime\";i:1499928385;}s:9:\"datestamp\";s:10:\"1399825730\";s:8:\"includes\";a:1:{s:13:\"languageicons\";s:14:\"Language Icons\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}s:16:\"existing_version\";s:7:\"7.x-1.1\";s:14:\"existing_major\";s:1:\"1\";s:12:\"install_type\";s:8:\"official\";s:5:\"title\";s:14:\"Language Icons\";s:4:\"link\";s:44:\"https://www.drupal.org/project/languageicons\";s:14:\"latest_version\";s:7:\"7.x-1.1\";s:8:\"releases\";a:1:{s:7:\"7.x-1.1\";a:14:{s:4:\"name\";s:21:\"languageicons 7.x-1.1\";s:7:\"version\";s:7:\"7.x-1.1\";s:3:\"tag\";s:7:\"7.x-1.1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/languageicons/releases/7.x-1.1\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/languageicons-7.x-1.1.tar.gz\";s:4:\"date\";s:10:\"1399825727\";s:6:\"mdhash\";s:32:\"5097ac19d351655794d0cda9a596120f\";s:8:\"filesize\";s:5:\"23863\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}}s:11:\"recommended\";s:7:\"7.x-1.1\";s:6:\"status\";i:5;}s:9:\"libraries\";a:17:{s:4:\"name\";s:9:\"libraries\";s:4:\"info\";a:6:{s:4:\"name\";s:9:\"Libraries\";s:7:\"version\";s:7:\"7.x-2.2\";s:7:\"project\";s:9:\"libraries\";s:9:\"datestamp\";s:10:\"1391965716\";s:7:\"package\";s:5:\"Other\";s:16:\"_info_file_ctime\";i:1499928385;}s:9:\"datestamp\";s:10:\"1391965716\";s:8:\"includes\";a:1:{s:9:\"libraries\";s:9:\"Libraries\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}s:16:\"existing_version\";s:7:\"7.x-2.2\";s:14:\"existing_major\";s:1:\"2\";s:12:\"install_type\";s:8:\"official\";s:5:\"title\";s:13:\"Libraries API\";s:4:\"link\";s:40:\"https://www.drupal.org/project/libraries\";s:14:\"latest_version\";s:7:\"7.x-2.3\";s:8:\"releases\";a:1:{s:7:\"7.x-2.3\";a:14:{s:4:\"name\";s:17:\"libraries 7.x-2.3\";s:7:\"version\";s:7:\"7.x-2.3\";s:3:\"tag\";s:7:\"7.x-2.3\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:57:\"https://www.drupal.org/project/libraries/releases/7.x-2.3\";s:13:\"download_link\";s:62:\"https://ftp.drupal.org/files/projects/libraries-7.x-2.3.tar.gz\";s:4:\"date\";s:10:\"1463077439\";s:6:\"mdhash\";s:32:\"294d3e4096c513321159b908cfd7c2be\";s:8:\"filesize\";s:5:\"41863\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}}s:11:\"recommended\";s:7:\"7.x-2.3\";s:6:\"status\";i:4;}s:4:\"link\";a:17:{s:4:\"name\";s:4:\"link\";s:4:\"info\";a:6:{s:4:\"name\";s:4:\"Link\";s:7:\"package\";s:6:\"Fields\";s:7:\"version\";s:7:\"7.x-1.3\";s:7:\"project\";s:4:\"link\";s:9:\"datestamp\";s:10:\"1413924830\";s:16:\"_info_file_ctime\";i:1499928385;}s:9:\"datestamp\";s:10:\"1413924830\";s:8:\"includes\";a:1:{s:4:\"link\";s:4:\"Link\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}s:16:\"existing_version\";s:7:\"7.x-1.3\";s:14:\"existing_major\";s:1:\"1\";s:12:\"install_type\";s:8:\"official\";s:5:\"title\";s:4:\"Link\";s:4:\"link\";s:35:\"https://www.drupal.org/project/link\";s:14:\"latest_version\";s:13:\"7.x-1.5-beta2\";s:8:\"releases\";a:2:{s:13:\"7.x-1.5-beta2\";a:15:{s:4:\"name\";s:18:\"link 7.x-1.5-beta2\";s:7:\"version\";s:13:\"7.x-1.5-beta2\";s:3:\"tag\";s:13:\"7.x-1.5-beta2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"5\";s:13:\"version_extra\";s:5:\"beta2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:58:\"https://www.drupal.org/project/link/releases/7.x-1.5-beta2\";s:13:\"download_link\";s:63:\"https://ftp.drupal.org/files/projects/link-7.x-1.5-beta2.tar.gz\";s:4:\"date\";s:10:\"1500985442\";s:6:\"mdhash\";s:32:\"7ffe7148234f8c237a4893abd82c8e0e\";s:8:\"filesize\";s:5:\"38156\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}s:7:\"7.x-1.4\";a:14:{s:4:\"name\";s:12:\"link 7.x-1.4\";s:7:\"version\";s:7:\"7.x-1.4\";s:3:\"tag\";s:7:\"7.x-1.4\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:52:\"https://www.drupal.org/project/link/releases/7.x-1.4\";s:13:\"download_link\";s:57:\"https://ftp.drupal.org/files/projects/link-7.x-1.4.tar.gz\";s:4:\"date\";s:10:\"1452830639\";s:6:\"mdhash\";s:32:\"10cb0a7bb75aaa6cd709c88fd7f79e9f\";s:8:\"filesize\";s:5:\"36913\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}}s:11:\"recommended\";s:7:\"7.x-1.4\";s:6:\"status\";i:4;}s:15:\"menu_breadcrumb\";a:17:{s:4:\"name\";s:15:\"menu_breadcrumb\";s:4:\"info\";a:6:{s:4:\"name\";s:15:\"Menu breadcrumb\";s:7:\"version\";s:7:\"7.x-1.6\";s:7:\"project\";s:15:\"menu_breadcrumb\";s:9:\"datestamp\";s:10:\"1425993992\";s:7:\"package\";s:5:\"Other\";s:16:\"_info_file_ctime\";i:1499928385;}s:9:\"datestamp\";s:10:\"1425993992\";s:8:\"includes\";a:1:{s:15:\"menu_breadcrumb\";s:15:\"Menu breadcrumb\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}s:16:\"existing_version\";s:7:\"7.x-1.6\";s:14:\"existing_major\";s:1:\"1\";s:12:\"install_type\";s:8:\"official\";s:5:\"title\";s:15:\"Menu Breadcrumb\";s:4:\"link\";s:46:\"https://www.drupal.org/project/menu_breadcrumb\";s:14:\"latest_version\";s:7:\"7.x-1.6\";s:8:\"releases\";a:1:{s:7:\"7.x-1.6\";a:14:{s:4:\"name\";s:23:\"menu_breadcrumb 7.x-1.6\";s:7:\"version\";s:7:\"7.x-1.6\";s:3:\"tag\";s:7:\"7.x-1.6\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"6\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:63:\"https://www.drupal.org/project/menu_breadcrumb/releases/7.x-1.6\";s:13:\"download_link\";s:68:\"https://ftp.drupal.org/files/projects/menu_breadcrumb-7.x-1.6.tar.gz\";s:4:\"date\";s:10:\"1425993987\";s:6:\"mdhash\";s:32:\"30291c87761f042b7599865d80df6f62\";s:8:\"filesize\";s:5:\"15154\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}}s:11:\"recommended\";s:7:\"7.x-1.6\";s:6:\"status\";i:5;}s:7:\"message\";a:17:{s:4:\"name\";s:7:\"message\";s:4:\"info\";a:6:{s:4:\"name\";s:7:\"Message\";s:7:\"package\";s:7:\"Message\";s:7:\"version\";s:7:\"7.x-1.9\";s:7:\"project\";s:7:\"message\";s:9:\"datestamp\";s:10:\"1374541036\";s:16:\"_info_file_ctime\";i:1499928385;}s:9:\"datestamp\";s:10:\"1374541036\";s:8:\"includes\";a:2:{s:7:\"message\";s:7:\"Message\";s:15:\"message_example\";s:15:\"Message example\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}s:16:\"existing_version\";s:7:\"7.x-1.9\";s:14:\"existing_major\";s:1:\"1\";s:12:\"install_type\";s:8:\"official\";s:5:\"title\";s:7:\"Message\";s:4:\"link\";s:38:\"https://www.drupal.org/project/message\";s:14:\"latest_version\";s:8:\"7.x-1.12\";s:8:\"releases\";a:1:{s:8:\"7.x-1.12\";a:14:{s:4:\"name\";s:16:\"message 7.x-1.12\";s:7:\"version\";s:8:\"7.x-1.12\";s:3:\"tag\";s:8:\"7.x-1.12\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:2:\"12\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/message/releases/7.x-1.12\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/message-7.x-1.12.tar.gz\";s:4:\"date\";s:10:\"1468304039\";s:6:\"mdhash\";s:32:\"bd4c7df7848fea70f00afbcfe76a205d\";s:8:\"filesize\";s:5:\"51254\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}}s:11:\"recommended\";s:8:\"7.x-1.12\";s:6:\"status\";i:4;}s:11:\"modal_forms\";a:17:{s:4:\"name\";s:11:\"modal_forms\";s:4:\"info\";a:6:{s:4:\"name\";s:11:\"Modal forms\";s:7:\"version\";s:7:\"7.x-1.2\";s:7:\"project\";s:11:\"modal_forms\";s:9:\"datestamp\";s:10:\"1353326875\";s:7:\"package\";s:5:\"Other\";s:16:\"_info_file_ctime\";i:1499928385;}s:9:\"datestamp\";s:10:\"1353326875\";s:8:\"includes\";a:1:{s:11:\"modal_forms\";s:11:\"Modal forms\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}s:16:\"existing_version\";s:7:\"7.x-1.2\";s:14:\"existing_major\";s:1:\"1\";s:12:\"install_type\";s:8:\"official\";s:5:\"title\";s:25:\"Modal forms (with ctools)\";s:4:\"link\";s:42:\"https://www.drupal.org/project/modal_forms\";s:14:\"latest_version\";s:7:\"7.x-1.2\";s:8:\"releases\";a:1:{s:7:\"7.x-1.2\";a:14:{s:4:\"name\";s:19:\"modal_forms 7.x-1.2\";s:7:\"version\";s:7:\"7.x-1.2\";s:3:\"tag\";s:7:\"7.x-1.2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:59:\"https://www.drupal.org/project/modal_forms/releases/7.x-1.2\";s:13:\"download_link\";s:64:\"https://ftp.drupal.org/files/projects/modal_forms-7.x-1.2.tar.gz\";s:4:\"date\";s:10:\"1353326875\";s:6:\"mdhash\";s:32:\"ad1e71dd8a361254f1383eec009b89de\";s:8:\"filesize\";s:5:\"29937\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}}s:11:\"recommended\";s:7:\"7.x-1.2\";s:6:\"status\";i:5;}s:13:\"module_filter\";a:17:{s:4:\"name\";s:13:\"module_filter\";s:4:\"info\";a:6:{s:4:\"name\";s:13:\"Module filter\";s:7:\"package\";s:14:\"Administration\";s:7:\"version\";s:7:\"7.x-2.0\";s:7:\"project\";s:13:\"module_filter\";s:9:\"datestamp\";s:10:\"1424631189\";s:16:\"_info_file_ctime\";i:1499928385;}s:9:\"datestamp\";s:10:\"1424631189\";s:8:\"includes\";a:1:{s:13:\"module_filter\";s:13:\"Module filter\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}s:16:\"existing_version\";s:7:\"7.x-2.0\";s:14:\"existing_major\";s:1:\"2\";s:12:\"install_type\";s:8:\"official\";s:5:\"title\";s:13:\"Module Filter\";s:4:\"link\";s:44:\"https://www.drupal.org/project/module_filter\";s:14:\"latest_version\";s:7:\"7.x-2.1\";s:8:\"releases\";a:1:{s:7:\"7.x-2.1\";a:14:{s:4:\"name\";s:21:\"module_filter 7.x-2.1\";s:7:\"version\";s:7:\"7.x-2.1\";s:3:\"tag\";s:7:\"7.x-2.1\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/module_filter/releases/7.x-2.1\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/module_filter-7.x-2.1.tar.gz\";s:4:\"date\";s:10:\"1497029343\";s:6:\"mdhash\";s:32:\"66a4998f63f2cefe77c18713054a42cc\";s:8:\"filesize\";s:5:\"29757\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}}s:11:\"recommended\";s:7:\"7.x-2.1\";s:6:\"status\";i:4;}s:10:\"node_class\";a:17:{s:4:\"name\";s:10:\"node_class\";s:4:\"info\";a:6:{s:4:\"name\";s:10:\"Node Class\";s:7:\"version\";s:7:\"7.x-1.3\";s:7:\"project\";s:10:\"node_class\";s:9:\"datestamp\";s:10:\"1388997876\";s:7:\"package\";s:5:\"Other\";s:16:\"_info_file_ctime\";i:1499928385;}s:9:\"datestamp\";s:10:\"1388997876\";s:8:\"includes\";a:1:{s:10:\"node_class\";s:10:\"Node Class\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}s:16:\"existing_version\";s:7:\"7.x-1.3\";s:14:\"existing_major\";s:1:\"1\";s:12:\"install_type\";s:8:\"official\";s:5:\"title\";s:10:\"Node Class\";s:4:\"link\";s:41:\"https://www.drupal.org/project/node_class\";s:14:\"latest_version\";s:7:\"7.x-1.3\";s:8:\"releases\";a:1:{s:7:\"7.x-1.3\";a:14:{s:4:\"name\";s:18:\"node_class 7.x-1.3\";s:7:\"version\";s:7:\"7.x-1.3\";s:3:\"tag\";s:7:\"7.x-1.3\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:58:\"https://www.drupal.org/project/node_class/releases/7.x-1.3\";s:13:\"download_link\";s:63:\"https://ftp.drupal.org/files/projects/node_class-7.x-1.3.tar.gz\";s:4:\"date\";s:10:\"1388997805\";s:6:\"mdhash\";s:32:\"76bc0de128d7108d7131c710798c79a8\";s:8:\"filesize\";s:4:\"8698\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}}s:11:\"recommended\";s:7:\"7.x-1.3\";s:6:\"status\";i:5;}s:8:\"pathauto\";a:17:{s:4:\"name\";s:8:\"pathauto\";s:4:\"info\";a:6:{s:4:\"name\";s:8:\"Pathauto\";s:7:\"version\";s:7:\"7.x-1.2\";s:7:\"project\";s:8:\"pathauto\";s:9:\"datestamp\";s:10:\"1344525185\";s:7:\"package\";s:5:\"Other\";s:16:\"_info_file_ctime\";i:1499928385;}s:9:\"datestamp\";s:10:\"1344525185\";s:8:\"includes\";a:1:{s:8:\"pathauto\";s:8:\"Pathauto\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}s:16:\"existing_version\";s:7:\"7.x-1.2\";s:14:\"existing_major\";s:1:\"1\";s:12:\"install_type\";s:8:\"official\";s:5:\"title\";s:8:\"Pathauto\";s:4:\"link\";s:39:\"https://www.drupal.org/project/pathauto\";s:14:\"latest_version\";s:7:\"7.x-1.3\";s:8:\"releases\";a:1:{s:7:\"7.x-1.3\";a:14:{s:4:\"name\";s:16:\"pathauto 7.x-1.3\";s:7:\"version\";s:7:\"7.x-1.3\";s:3:\"tag\";s:7:\"7.x-1.3\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/pathauto/releases/7.x-1.3\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/pathauto-7.x-1.3.tar.gz\";s:4:\"date\";s:10:\"1444232639\";s:6:\"mdhash\";s:32:\"ff984b2837230a221d53fad5462c0b61\";s:8:\"filesize\";s:5:\"42319\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}}s:11:\"recommended\";s:7:\"7.x-1.3\";s:6:\"status\";i:4;}s:9:\"quicktabs\";a:17:{s:4:\"name\";s:9:\"quicktabs\";s:4:\"info\";a:6:{s:4:\"name\";s:9:\"Quicktabs\";s:7:\"version\";s:7:\"7.x-3.6\";s:7:\"project\";s:9:\"quicktabs\";s:9:\"datestamp\";s:10:\"1380731929\";s:7:\"package\";s:5:\"Other\";s:16:\"_info_file_ctime\";i:1499928385;}s:9:\"datestamp\";s:10:\"1380731929\";s:8:\"includes\";a:1:{s:9:\"quicktabs\";s:9:\"Quicktabs\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}s:16:\"existing_version\";s:7:\"7.x-3.6\";s:14:\"existing_major\";s:1:\"3\";s:12:\"install_type\";s:8:\"official\";s:5:\"title\";s:10:\"Quick Tabs\";s:4:\"link\";s:40:\"https://www.drupal.org/project/quicktabs\";s:14:\"latest_version\";s:7:\"7.x-3.8\";s:8:\"releases\";a:1:{s:7:\"7.x-3.8\";a:14:{s:4:\"name\";s:17:\"quicktabs 7.x-3.8\";s:7:\"version\";s:7:\"7.x-3.8\";s:3:\"tag\";s:7:\"7.x-3.8\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"8\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:57:\"https://www.drupal.org/project/quicktabs/releases/7.x-3.8\";s:13:\"download_link\";s:62:\"https://ftp.drupal.org/files/projects/quicktabs-7.x-3.8.tar.gz\";s:4:\"date\";s:10:\"1497619442\";s:6:\"mdhash\";s:32:\"63da431afe05b274f0e8a87a8bb2febf\";s:8:\"filesize\";s:5:\"75912\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}}s:11:\"recommended\";s:7:\"7.x-3.8\";s:6:\"status\";i:4;}s:11:\"remember_me\";a:17:{s:4:\"name\";s:11:\"remember_me\";s:4:\"info\";a:6:{s:4:\"name\";s:11:\"Remember me\";s:7:\"version\";s:7:\"7.x-1.1\";s:7:\"project\";s:11:\"remember_me\";s:9:\"datestamp\";s:10:\"1492928945\";s:7:\"package\";s:5:\"Other\";s:16:\"_info_file_ctime\";i:1500259564;}s:9:\"datestamp\";s:10:\"1492928945\";s:8:\"includes\";a:1:{s:11:\"remember_me\";s:11:\"Remember me\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}s:16:\"existing_version\";s:7:\"7.x-1.1\";s:14:\"existing_major\";s:1:\"1\";s:12:\"install_type\";s:8:\"official\";s:5:\"title\";s:11:\"Remember me\";s:4:\"link\";s:42:\"https://www.drupal.org/project/remember_me\";s:14:\"latest_version\";s:7:\"7.x-1.1\";s:8:\"releases\";a:1:{s:7:\"7.x-1.1\";a:14:{s:4:\"name\";s:19:\"remember_me 7.x-1.1\";s:7:\"version\";s:7:\"7.x-1.1\";s:3:\"tag\";s:7:\"7.x-1.1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:59:\"https://www.drupal.org/project/remember_me/releases/7.x-1.1\";s:13:\"download_link\";s:64:\"https://ftp.drupal.org/files/projects/remember_me-7.x-1.1.tar.gz\";s:4:\"date\";s:10:\"1492928943\";s:6:\"mdhash\";s:32:\"6219d5ec3c6da162f180c4f5f5519137\";s:8:\"filesize\";s:5:\"10053\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:15:\"Security update\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}}s:11:\"recommended\";s:7:\"7.x-1.1\";s:6:\"status\";i:5;}s:9:\"sharethis\";a:17:{s:4:\"name\";s:9:\"sharethis\";s:4:\"info\";a:6:{s:4:\"name\";s:9:\"ShareThis\";s:7:\"package\";s:7:\"Sharing\";s:7:\"version\";s:8:\"7.x-2.10\";s:7:\"project\";s:9:\"sharethis\";s:9:\"datestamp\";s:10:\"1422441977\";s:16:\"_info_file_ctime\";i:1499928385;}s:9:\"datestamp\";s:10:\"1422441977\";s:8:\"includes\";a:1:{s:9:\"sharethis\";s:9:\"ShareThis\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}s:16:\"existing_version\";s:8:\"7.x-2.10\";s:14:\"existing_major\";s:1:\"2\";s:12:\"install_type\";s:8:\"official\";s:5:\"title\";s:9:\"ShareThis\";s:4:\"link\";s:40:\"https://www.drupal.org/project/sharethis\";s:14:\"latest_version\";s:8:\"7.x-2.13\";s:8:\"releases\";a:1:{s:8:\"7.x-2.13\";a:14:{s:4:\"name\";s:18:\"sharethis 7.x-2.13\";s:7:\"version\";s:8:\"7.x-2.13\";s:3:\"tag\";s:8:\"7.x-2.13\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:2:\"13\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:58:\"https://www.drupal.org/project/sharethis/releases/7.x-2.13\";s:13:\"download_link\";s:63:\"https://ftp.drupal.org/files/projects/sharethis-7.x-2.13.tar.gz\";s:4:\"date\";s:10:\"1468581839\";s:6:\"mdhash\";s:32:\"f3f446bf449c62592963af24d0e947c8\";s:8:\"filesize\";s:6:\"104699\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}}s:11:\"recommended\";s:8:\"7.x-2.13\";s:6:\"status\";i:4;}s:9:\"shortcode\";a:17:{s:4:\"name\";s:9:\"shortcode\";s:4:\"info\";a:6:{s:4:\"name\";s:9:\"Shortcode\";s:7:\"package\";s:9:\"Shortcode\";s:7:\"version\";s:7:\"7.x-2.2\";s:7:\"project\";s:9:\"shortcode\";s:9:\"datestamp\";s:10:\"1423035812\";s:16:\"_info_file_ctime\";i:1499928385;}s:9:\"datestamp\";s:10:\"1423035812\";s:8:\"includes\";a:4:{s:9:\"shortcode\";s:9:\"Shortcode\";s:20:\"shortcode_basic_tags\";s:20:\"Shortcode Basic Tags\";s:23:\"shortcode_embed_content\";s:27:\"Shortcode Embed Content Tag\";s:15:\"shortcode_video\";s:21:\"Shortcode Video Macro\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}s:16:\"existing_version\";s:7:\"7.x-2.2\";s:14:\"existing_major\";s:1:\"2\";s:12:\"install_type\";s:8:\"official\";s:5:\"title\";s:9:\"Shortcode\";s:4:\"link\";s:40:\"https://www.drupal.org/project/shortcode\";s:14:\"latest_version\";s:8:\"7.x-2.25\";s:8:\"releases\";a:1:{s:8:\"7.x-2.25\";a:14:{s:4:\"name\";s:18:\"shortcode 7.x-2.25\";s:7:\"version\";s:8:\"7.x-2.25\";s:3:\"tag\";s:8:\"7.x-2.25\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:2:\"25\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:58:\"https://www.drupal.org/project/shortcode/releases/7.x-2.25\";s:13:\"download_link\";s:63:\"https://ftp.drupal.org/files/projects/shortcode-7.x-2.25.tar.gz\";s:4:\"date\";s:10:\"1512417784\";s:6:\"mdhash\";s:32:\"08e5d7df166849ae50bf9cc27ecf9898\";s:8:\"filesize\";s:5:\"19313\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}}s:11:\"recommended\";s:8:\"7.x-2.25\";s:6:\"status\";i:4;}s:9:\"strongarm\";a:17:{s:4:\"name\";s:9:\"strongarm\";s:4:\"info\";a:6:{s:4:\"name\";s:9:\"Strongarm\";s:7:\"version\";s:7:\"7.x-2.0\";s:7:\"project\";s:9:\"strongarm\";s:9:\"datestamp\";s:10:\"1339604214\";s:7:\"package\";s:5:\"Other\";s:16:\"_info_file_ctime\";i:1499928385;}s:9:\"datestamp\";s:10:\"1339604214\";s:8:\"includes\";a:1:{s:9:\"strongarm\";s:9:\"Strongarm\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}s:16:\"existing_version\";s:7:\"7.x-2.0\";s:14:\"existing_major\";s:1:\"2\";s:12:\"install_type\";s:8:\"official\";s:5:\"title\";s:9:\"Strongarm\";s:4:\"link\";s:40:\"https://www.drupal.org/project/strongarm\";s:14:\"latest_version\";s:7:\"7.x-2.0\";s:8:\"releases\";a:1:{s:7:\"7.x-2.0\";a:14:{s:4:\"name\";s:17:\"strongarm 7.x-2.0\";s:7:\"version\";s:7:\"7.x-2.0\";s:3:\"tag\";s:7:\"7.x-2.0\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:57:\"https://www.drupal.org/project/strongarm/releases/7.x-2.0\";s:13:\"download_link\";s:62:\"https://ftp.drupal.org/files/projects/strongarm-7.x-2.0.tar.gz\";s:4:\"date\";s:10:\"1339604214\";s:6:\"mdhash\";s:32:\"76f0757b173e612937b0e6ce0b9bca70\";s:8:\"filesize\";s:5:\"12284\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}}s:11:\"recommended\";s:7:\"7.x-2.0\";s:6:\"status\";i:5;}s:9:\"tagclouds\";a:17:{s:4:\"name\";s:9:\"tagclouds\";s:4:\"info\";a:6:{s:4:\"name\";s:9:\"TagClouds\";s:7:\"package\";s:8:\"Taxonomy\";s:7:\"version\";s:8:\"7.x-1.10\";s:7:\"project\";s:9:\"tagclouds\";s:9:\"datestamp\";s:10:\"1404152332\";s:16:\"_info_file_ctime\";i:1499928385;}s:9:\"datestamp\";s:10:\"1404152332\";s:8:\"includes\";a:1:{s:9:\"tagclouds\";s:9:\"TagClouds\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}s:16:\"existing_version\";s:8:\"7.x-1.10\";s:14:\"existing_major\";s:1:\"1\";s:12:\"install_type\";s:8:\"official\";s:5:\"title\";s:8:\"TagCloud\";s:4:\"link\";s:40:\"https://www.drupal.org/project/tagclouds\";s:14:\"latest_version\";s:8:\"7.x-1.11\";s:8:\"releases\";a:1:{s:8:\"7.x-1.11\";a:14:{s:4:\"name\";s:18:\"tagclouds 7.x-1.11\";s:7:\"version\";s:8:\"7.x-1.11\";s:3:\"tag\";s:8:\"7.x-1.11\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:2:\"11\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:58:\"https://www.drupal.org/project/tagclouds/releases/7.x-1.11\";s:13:\"download_link\";s:63:\"https://ftp.drupal.org/files/projects/tagclouds-7.x-1.11.tar.gz\";s:4:\"date\";s:10:\"1452956639\";s:6:\"mdhash\";s:32:\"8fb0190b0c34735329d9e7808f507873\";s:8:\"filesize\";s:5:\"13778\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}}s:11:\"recommended\";s:8:\"7.x-1.11\";s:6:\"status\";i:4;}s:13:\"taxonomy_menu\";a:18:{s:4:\"name\";s:13:\"taxonomy_menu\";s:4:\"info\";a:6:{s:4:\"name\";s:13:\"Taxonomy menu\";s:7:\"package\";s:13:\"Taxonomy menu\";s:7:\"version\";s:7:\"7.x-1.5\";s:7:\"project\";s:13:\"taxonomy_menu\";s:9:\"datestamp\";s:10:\"1396359247\";s:16:\"_info_file_ctime\";i:1499928385;}s:9:\"datestamp\";s:10:\"1396359247\";s:8:\"includes\";a:1:{s:13:\"taxonomy_menu\";s:13:\"Taxonomy menu\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}s:16:\"existing_version\";s:7:\"7.x-1.5\";s:14:\"existing_major\";s:1:\"1\";s:12:\"install_type\";s:8:\"official\";s:5:\"title\";s:13:\"Taxonomy menu\";s:4:\"link\";s:44:\"https://www.drupal.org/project/taxonomy_menu\";s:4:\"also\";a:1:{i:2;s:14:\"7.x-2.0-alpha2\";}s:8:\"releases\";a:2:{s:14:\"7.x-2.0-alpha2\";a:15:{s:4:\"name\";s:28:\"taxonomy_menu 7.x-2.0-alpha2\";s:7:\"version\";s:14:\"7.x-2.0-alpha2\";s:3:\"tag\";s:14:\"7.x-2.0-alpha2\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:68:\"https://www.drupal.org/project/taxonomy_menu/releases/7.x-2.0-alpha2\";s:13:\"download_link\";s:73:\"https://ftp.drupal.org/files/projects/taxonomy_menu-7.x-2.0-alpha2.tar.gz\";s:4:\"date\";s:10:\"1359084813\";s:6:\"mdhash\";s:32:\"464f8dfd87a4a29958005eab55064b9a\";s:8:\"filesize\";s:5:\"31176\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}s:8:\"security\";s:61:\"Alpha releases are not covered by Drupal security advisories.\";}s:7:\"7.x-1.5\";a:14:{s:4:\"name\";s:21:\"taxonomy_menu 7.x-1.5\";s:7:\"version\";s:7:\"7.x-1.5\";s:3:\"tag\";s:7:\"7.x-1.5\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"5\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/taxonomy_menu/releases/7.x-1.5\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/taxonomy_menu-7.x-1.5.tar.gz\";s:4:\"date\";s:10:\"1396359246\";s:6:\"mdhash\";s:32:\"f2aa072ca8e5ffad1082db99917e7226\";s:8:\"filesize\";s:5:\"25478\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}}s:14:\"latest_version\";s:7:\"7.x-1.5\";s:11:\"recommended\";s:7:\"7.x-1.5\";s:6:\"status\";i:5;}s:5:\"token\";a:17:{s:4:\"name\";s:5:\"token\";s:4:\"info\";a:6:{s:4:\"name\";s:5:\"Token\";s:7:\"version\";s:7:\"7.x-1.6\";s:7:\"project\";s:5:\"token\";s:9:\"datestamp\";s:10:\"1425149060\";s:7:\"package\";s:5:\"Other\";s:16:\"_info_file_ctime\";i:1499928385;}s:9:\"datestamp\";s:10:\"1425149060\";s:8:\"includes\";a:1:{s:5:\"token\";s:5:\"Token\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}s:16:\"existing_version\";s:7:\"7.x-1.6\";s:14:\"existing_major\";s:1:\"1\";s:12:\"install_type\";s:8:\"official\";s:5:\"title\";s:5:\"Token\";s:4:\"link\";s:36:\"https://www.drupal.org/project/token\";s:14:\"latest_version\";s:7:\"7.x-1.7\";s:8:\"releases\";a:1:{s:7:\"7.x-1.7\";a:14:{s:4:\"name\";s:13:\"token 7.x-1.7\";s:7:\"version\";s:7:\"7.x-1.7\";s:3:\"tag\";s:7:\"7.x-1.7\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"7\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:53:\"https://www.drupal.org/project/token/releases/7.x-1.7\";s:13:\"download_link\";s:58:\"https://ftp.drupal.org/files/projects/token-7.x-1.7.tar.gz\";s:4:\"date\";s:10:\"1485316084\";s:6:\"mdhash\";s:32:\"cf117195d2815e4292e522c04f4055d0\";s:8:\"filesize\";s:5:\"44016\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}}s:11:\"recommended\";s:7:\"7.x-1.7\";s:6:\"status\";i:4;}s:12:\"token_custom\";a:17:{s:4:\"name\";s:12:\"token_custom\";s:4:\"info\";a:6:{s:4:\"name\";s:13:\"Custom tokens\";s:7:\"version\";s:13:\"7.x-2.0-beta3\";s:7:\"project\";s:12:\"token_custom\";s:9:\"datestamp\";s:10:\"1348426268\";s:7:\"package\";s:5:\"Other\";s:16:\"_info_file_ctime\";i:1499928385;}s:9:\"datestamp\";s:10:\"1348426268\";s:8:\"includes\";a:1:{s:12:\"token_custom\";s:13:\"Custom tokens\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}s:16:\"existing_version\";s:13:\"7.x-2.0-beta3\";s:14:\"existing_major\";s:1:\"2\";s:12:\"install_type\";s:8:\"official\";s:5:\"title\";s:13:\"Custom Tokens\";s:4:\"link\";s:43:\"https://www.drupal.org/project/token_custom\";s:14:\"latest_version\";s:13:\"7.x-2.0-beta3\";s:8:\"releases\";a:1:{s:13:\"7.x-2.0-beta3\";a:15:{s:4:\"name\";s:26:\"token_custom 7.x-2.0-beta3\";s:7:\"version\";s:13:\"7.x-2.0-beta3\";s:3:\"tag\";s:13:\"7.x-2.0-beta3\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:66:\"https://www.drupal.org/project/token_custom/releases/7.x-2.0-beta3\";s:13:\"download_link\";s:71:\"https://ftp.drupal.org/files/projects/token_custom-7.x-2.0-beta3.tar.gz\";s:4:\"date\";s:10:\"1348426268\";s:6:\"mdhash\";s:32:\"b927d3dc1272920003ac3f4ac7cdb3d7\";s:8:\"filesize\";s:5:\"14649\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}}s:11:\"recommended\";s:13:\"7.x-2.0-beta3\";s:6:\"status\";i:5;}s:8:\"variable\";a:17:{s:4:\"name\";s:8:\"variable\";s:4:\"info\";a:6:{s:4:\"name\";s:8:\"Variable\";s:7:\"package\";s:8:\"Variable\";s:7:\"version\";s:7:\"7.x-2.5\";s:7:\"project\";s:8:\"variable\";s:9:\"datestamp\";s:10:\"1398250128\";s:16:\"_info_file_ctime\";i:1499928385;}s:9:\"datestamp\";s:10:\"1398250128\";s:8:\"includes\";a:1:{s:8:\"variable\";s:8:\"Variable\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}s:16:\"existing_version\";s:7:\"7.x-2.5\";s:14:\"existing_major\";s:1:\"2\";s:12:\"install_type\";s:8:\"official\";s:5:\"title\";s:8:\"Variable\";s:4:\"link\";s:39:\"https://www.drupal.org/project/variable\";s:14:\"latest_version\";s:7:\"7.x-2.5\";s:8:\"releases\";a:1:{s:7:\"7.x-2.5\";a:14:{s:4:\"name\";s:16:\"variable 7.x-2.5\";s:7:\"version\";s:7:\"7.x-2.5\";s:3:\"tag\";s:7:\"7.x-2.5\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"5\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/variable/releases/7.x-2.5\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/variable-7.x-2.5.tar.gz\";s:4:\"date\";s:10:\"1398250127\";s:6:\"mdhash\";s:32:\"19ef79edd10ef87e471775cf34a27386\";s:8:\"filesize\";s:5:\"53993\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}}s:11:\"recommended\";s:7:\"7.x-2.5\";s:6:\"status\";i:5;}s:17:\"video_embed_field\";a:17:{s:4:\"name\";s:17:\"video_embed_field\";s:4:\"info\";a:6:{s:4:\"name\";s:17:\"Video Embed Field\";s:7:\"package\";s:5:\"Media\";s:7:\"version\";s:14:\"7.x-2.0-beta11\";s:7:\"project\";s:17:\"video_embed_field\";s:9:\"datestamp\";s:10:\"1441639440\";s:16:\"_info_file_ctime\";i:1499928385;}s:9:\"datestamp\";s:10:\"1441639440\";s:8:\"includes\";a:1:{s:17:\"video_embed_field\";s:17:\"Video Embed Field\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}s:16:\"existing_version\";s:14:\"7.x-2.0-beta11\";s:14:\"existing_major\";s:1:\"2\";s:12:\"install_type\";s:8:\"official\";s:5:\"title\";s:17:\"Video Embed Field\";s:4:\"link\";s:48:\"https://www.drupal.org/project/video_embed_field\";s:14:\"latest_version\";s:14:\"7.x-2.0-beta11\";s:8:\"releases\";a:1:{s:14:\"7.x-2.0-beta11\";a:15:{s:4:\"name\";s:32:\"video_embed_field 7.x-2.0-beta11\";s:7:\"version\";s:14:\"7.x-2.0-beta11\";s:3:\"tag\";s:14:\"7.x-2.0-beta11\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"beta11\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:72:\"https://www.drupal.org/project/video_embed_field/releases/7.x-2.0-beta11\";s:13:\"download_link\";s:77:\"https://ftp.drupal.org/files/projects/video_embed_field-7.x-2.0-beta11.tar.gz\";s:4:\"date\";s:10:\"1441639439\";s:6:\"mdhash\";s:32:\"43d7d6f6a9ec796b1eb1c68c66d82c49\";s:8:\"filesize\";s:6:\"182549\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:60:\"Beta releases are not covered by Drupal security advisories.\";}}s:11:\"recommended\";s:14:\"7.x-2.0-beta11\";s:6:\"status\";i:5;}s:5:\"views\";a:18:{s:4:\"name\";s:5:\"views\";s:4:\"info\";a:6:{s:4:\"name\";s:5:\"Views\";s:7:\"package\";s:5:\"Views\";s:7:\"version\";s:8:\"7.x-3.16\";s:7:\"project\";s:5:\"views\";s:9:\"datestamp\";s:10:\"1491158591\";s:16:\"_info_file_ctime\";i:1500259761;}s:9:\"datestamp\";s:10:\"1491158591\";s:8:\"includes\";a:2:{s:5:\"views\";s:5:\"Views\";s:8:\"views_ui\";s:8:\"Views UI\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}s:16:\"existing_version\";s:8:\"7.x-3.16\";s:14:\"existing_major\";s:1:\"3\";s:12:\"install_type\";s:8:\"official\";s:5:\"title\";s:5:\"Views\";s:4:\"link\";s:36:\"https://www.drupal.org/project/views\";s:14:\"latest_version\";s:8:\"7.x-3.18\";s:8:\"releases\";a:1:{s:8:\"7.x-3.18\";a:14:{s:4:\"name\";s:14:\"views 7.x-3.18\";s:7:\"version\";s:8:\"7.x-3.18\";s:3:\"tag\";s:8:\"7.x-3.18\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:2:\"18\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:54:\"https://www.drupal.org/project/views/releases/7.x-3.18\";s:13:\"download_link\";s:59:\"https://ftp.drupal.org/files/projects/views-7.x-3.18.tar.gz\";s:4:\"date\";s:10:\"1503494944\";s:6:\"mdhash\";s:32:\"937ad4ebd559fd3f57896f4702f6f3c4\";s:8:\"filesize\";s:7:\"1646788\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}}s:11:\"recommended\";s:8:\"7.x-3.18\";s:16:\"security updates\";a:1:{i:0;a:14:{s:4:\"name\";s:14:\"views 7.x-3.17\";s:7:\"version\";s:8:\"7.x-3.17\";s:3:\"tag\";s:8:\"7.x-3.17\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:2:\"17\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:54:\"https://www.drupal.org/project/views/releases/7.x-3.17\";s:13:\"download_link\";s:59:\"https://ftp.drupal.org/files/projects/views-7.x-3.17.tar.gz\";s:4:\"date\";s:10:\"1502903343\";s:6:\"mdhash\";s:32:\"ff6d025dedb555672ccf01f5e234df4f\";s:8:\"filesize\";s:7:\"1644296\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:15:\"Security update\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}}s:6:\"status\";i:1;}s:15:\"views_fieldsets\";a:17:{s:4:\"name\";s:15:\"views_fieldsets\";s:4:\"info\";a:6:{s:4:\"name\";s:15:\"Views fieldsets\";s:7:\"package\";s:5:\"Views\";s:7:\"version\";s:7:\"7.x-1.3\";s:7:\"project\";s:15:\"views_fieldsets\";s:9:\"datestamp\";s:10:\"1425515886\";s:16:\"_info_file_ctime\";i:1499928385;}s:9:\"datestamp\";s:10:\"1425515886\";s:8:\"includes\";a:1:{s:15:\"views_fieldsets\";s:15:\"Views fieldsets\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}s:16:\"existing_version\";s:7:\"7.x-1.3\";s:14:\"existing_major\";s:1:\"1\";s:12:\"install_type\";s:8:\"official\";s:5:\"title\";s:15:\"Views fieldsets\";s:4:\"link\";s:46:\"https://www.drupal.org/project/views_fieldsets\";s:6:\"status\";i:3;s:14:\"latest_version\";s:7:\"7.x-2.1\";s:8:\"releases\";a:1:{s:7:\"7.x-2.1\";a:14:{s:4:\"name\";s:23:\"views_fieldsets 7.x-2.1\";s:7:\"version\";s:7:\"7.x-2.1\";s:3:\"tag\";s:7:\"7.x-2.1\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:63:\"https://www.drupal.org/project/views_fieldsets/releases/7.x-2.1\";s:13:\"download_link\";s:68:\"https://ftp.drupal.org/files/projects/views_fieldsets-7.x-2.1.tar.gz\";s:4:\"date\";s:10:\"1452361172\";s:6:\"mdhash\";s:32:\"c5865105b071c412aca65878eed1d8fe\";s:8:\"filesize\";s:5:\"14729\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}}s:11:\"recommended\";s:7:\"7.x-2.1\";}s:15:\"views_slideshow\";a:17:{s:4:\"name\";s:15:\"views_slideshow\";s:4:\"info\";a:6:{s:4:\"name\";s:15:\"Views Slideshow\";s:7:\"package\";s:5:\"Views\";s:7:\"version\";s:7:\"7.x-3.1\";s:7:\"project\";s:15:\"views_slideshow\";s:9:\"datestamp\";s:10:\"1382584826\";s:16:\"_info_file_ctime\";i:1499928385;}s:9:\"datestamp\";s:10:\"1382584826\";s:8:\"includes\";a:2:{s:15:\"views_slideshow\";s:15:\"Views Slideshow\";s:21:\"views_slideshow_cycle\";s:22:\"Views Slideshow: Cycle\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}s:16:\"existing_version\";s:7:\"7.x-3.1\";s:14:\"existing_major\";s:1:\"3\";s:12:\"install_type\";s:8:\"official\";s:5:\"title\";s:15:\"Views Slideshow\";s:4:\"link\";s:46:\"https://www.drupal.org/project/views_slideshow\";s:14:\"latest_version\";s:7:\"7.x-3.9\";s:8:\"releases\";a:1:{s:7:\"7.x-3.9\";a:14:{s:4:\"name\";s:23:\"views_slideshow 7.x-3.9\";s:7:\"version\";s:7:\"7.x-3.9\";s:3:\"tag\";s:7:\"7.x-3.9\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"9\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:63:\"https://www.drupal.org/project/views_slideshow/releases/7.x-3.9\";s:13:\"download_link\";s:68:\"https://ftp.drupal.org/files/projects/views_slideshow-7.x-3.9.tar.gz\";s:4:\"date\";s:10:\"1496893142\";s:6:\"mdhash\";s:32:\"fc1edcb8ee04923d93cdaa36ca848563\";s:8:\"filesize\";s:5:\"42352\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}}s:11:\"recommended\";s:7:\"7.x-3.9\";s:6:\"status\";i:4;}s:9:\"votingapi\";a:17:{s:4:\"name\";s:9:\"votingapi\";s:4:\"info\";a:6:{s:4:\"name\";s:10:\"Voting API\";s:7:\"package\";s:6:\"Voting\";s:7:\"version\";s:8:\"7.x-2.12\";s:7:\"project\";s:9:\"votingapi\";s:9:\"datestamp\";s:10:\"1407995929\";s:16:\"_info_file_ctime\";i:1499928385;}s:9:\"datestamp\";s:10:\"1407995929\";s:8:\"includes\";a:1:{s:9:\"votingapi\";s:10:\"Voting API\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}s:16:\"existing_version\";s:8:\"7.x-2.12\";s:14:\"existing_major\";s:1:\"2\";s:12:\"install_type\";s:8:\"official\";s:5:\"title\";s:10:\"Voting API\";s:4:\"link\";s:40:\"https://www.drupal.org/project/votingapi\";s:14:\"latest_version\";s:8:\"7.x-2.12\";s:8:\"releases\";a:1:{s:8:\"7.x-2.12\";a:14:{s:4:\"name\";s:18:\"votingapi 7.x-2.12\";s:7:\"version\";s:8:\"7.x-2.12\";s:3:\"tag\";s:8:\"7.x-2.12\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:2:\"12\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:58:\"https://www.drupal.org/project/votingapi/releases/7.x-2.12\";s:13:\"download_link\";s:63:\"https://ftp.drupal.org/files/projects/votingapi-7.x-2.12.tar.gz\";s:4:\"date\";s:10:\"1407995928\";s:6:\"mdhash\";s:32:\"af36516e151719c7b7e9d4edb51bf045\";s:8:\"filesize\";s:5:\"31602\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}}s:11:\"recommended\";s:8:\"7.x-2.12\";s:6:\"status\";i:5;}s:20:\"we_content_migration\";a:19:{s:4:\"name\";s:20:\"we_content_migration\";s:4:\"info\";a:6:{s:4:\"name\";s:17:\"Content Migration\";s:7:\"package\";s:17:\"Content Migration\";s:7:\"version\";s:11:\"7.x-1.x-dev\";s:7:\"project\";s:20:\"we_content_migration\";s:9:\"datestamp\";s:10:\"1499677744\";s:16:\"_info_file_ctime\";i:1499928623;}s:9:\"datestamp\";s:10:\"1499677744\";s:8:\"includes\";a:1:{s:20:\"we_content_migration\";s:17:\"Content Migration\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}s:16:\"existing_version\";s:11:\"7.x-1.x-dev\";s:14:\"existing_major\";s:1:\"1\";s:12:\"install_type\";s:3:\"dev\";s:5:\"title\";s:24:\"Drupal Content Migration\";s:4:\"link\";s:51:\"https://www.drupal.org/project/we_content_migration\";s:14:\"latest_version\";s:11:\"7.x-1.x-dev\";s:8:\"releases\";a:1:{s:11:\"7.x-1.x-dev\";a:14:{s:4:\"name\";s:32:\"we_content_migration 7.x-1.x-dev\";s:7:\"version\";s:11:\"7.x-1.x-dev\";s:3:\"tag\";s:7:\"7.x-1.x\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:72:\"https://www.drupal.org/project/we_content_migration/releases/7.x-1.x-dev\";s:13:\"download_link\";s:77:\"https://ftp.drupal.org/files/projects/we_content_migration-7.x-1.x-dev.tar.gz\";s:4:\"date\";s:10:\"1499677742\";s:6:\"mdhash\";s:32:\"5e6c20f89dc504dbc3bdfe48009e62a1\";s:8:\"filesize\";s:5:\"49548\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:12:\"New features\";}}s:8:\"security\";s:54:\"Project has not opted into security advisory coverage!\";}}s:11:\"dev_version\";s:11:\"7.x-1.x-dev\";s:11:\"recommended\";s:11:\"7.x-1.x-dev\";s:10:\"latest_dev\";s:11:\"7.x-1.x-dev\";s:6:\"status\";i:5;}s:7:\"webform\";a:17:{s:4:\"name\";s:7:\"webform\";s:4:\"info\";a:6:{s:4:\"name\";s:7:\"Webform\";s:7:\"package\";s:7:\"Webform\";s:7:\"version\";s:8:\"7.x-4.15\";s:7:\"project\";s:7:\"webform\";s:9:\"datestamp\";s:10:\"1492107249\";s:16:\"_info_file_ctime\";i:1500259935;}s:9:\"datestamp\";s:10:\"1492107249\";s:8:\"includes\";a:1:{s:7:\"webform\";s:7:\"Webform\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}s:16:\"existing_version\";s:8:\"7.x-4.15\";s:14:\"existing_major\";s:1:\"4\";s:12:\"install_type\";s:8:\"official\";s:5:\"title\";s:7:\"Webform\";s:4:\"link\";s:38:\"https://www.drupal.org/project/webform\";s:14:\"latest_version\";s:8:\"7.x-4.16\";s:8:\"releases\";a:1:{s:8:\"7.x-4.16\";a:14:{s:4:\"name\";s:16:\"webform 7.x-4.16\";s:7:\"version\";s:8:\"7.x-4.16\";s:3:\"tag\";s:8:\"7.x-4.16\";s:13:\"version_major\";s:1:\"4\";s:13:\"version_patch\";s:2:\"16\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:56:\"https://www.drupal.org/project/webform/releases/7.x-4.16\";s:13:\"download_link\";s:61:\"https://ftp.drupal.org/files/projects/webform-7.x-4.16.tar.gz\";s:4:\"date\";s:10:\"1507320544\";s:6:\"mdhash\";s:32:\"d4d168b87b1ca12fb0d56126ac6aeb66\";s:8:\"filesize\";s:6:\"247838\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}}s:11:\"recommended\";s:8:\"7.x-4.16\";s:6:\"status\";i:4;}s:13:\"webform_hints\";a:17:{s:4:\"name\";s:13:\"webform_hints\";s:4:\"info\";a:6:{s:4:\"name\";s:13:\"Webform Hints\";s:7:\"package\";s:7:\"Webform\";s:7:\"version\";s:7:\"7.x-1.5\";s:7:\"project\";s:13:\"webform_hints\";s:9:\"datestamp\";s:10:\"1407952128\";s:16:\"_info_file_ctime\";i:1499928385;}s:9:\"datestamp\";s:10:\"1407952128\";s:8:\"includes\";a:1:{s:13:\"webform_hints\";s:13:\"Webform Hints\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}s:16:\"existing_version\";s:7:\"7.x-1.5\";s:14:\"existing_major\";s:1:\"1\";s:12:\"install_type\";s:8:\"official\";s:5:\"title\";s:13:\"Webform Hints\";s:4:\"link\";s:44:\"https://www.drupal.org/project/webform_hints\";s:14:\"latest_version\";s:7:\"7.x-1.5\";s:8:\"releases\";a:1:{s:7:\"7.x-1.5\";a:14:{s:4:\"name\";s:21:\"webform_hints 7.x-1.5\";s:7:\"version\";s:7:\"7.x-1.5\";s:3:\"tag\";s:7:\"7.x-1.5\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"5\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:61:\"https://www.drupal.org/project/webform_hints/releases/7.x-1.5\";s:13:\"download_link\";s:66:\"https://ftp.drupal.org/files/projects/webform_hints-7.x-1.5.tar.gz\";s:4:\"date\";s:10:\"1407952127\";s:6:\"mdhash\";s:32:\"50454c993e5a7886ef493de842870981\";s:8:\"filesize\";s:5:\"12341\";s:5:\"files\";s:0:\"\";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:12:\"New features\";}}s:8:\"security\";s:44:\"Covered by Drupal\'s security advisory policy\";}}s:11:\"recommended\";s:7:\"7.x-1.5\";s:6:\"status\";i:5;}}',1512623927,1512620327,1),('update_project_projects','a:48:{s:10:\"admin_menu\";a:8:{s:4:\"name\";s:10:\"admin_menu\";s:4:\"info\";a:6:{s:4:\"name\";s:19:\"Administration menu\";s:7:\"package\";s:14:\"Administration\";s:7:\"version\";s:11:\"7.x-3.0-rc5\";s:7:\"project\";s:10:\"admin_menu\";s:9:\"datestamp\";s:10:\"1419029284\";s:16:\"_info_file_ctime\";i:1499928385;}s:9:\"datestamp\";s:10:\"1419029284\";s:8:\"includes\";a:2:{s:10:\"admin_menu\";s:19:\"Administration menu\";s:18:\"admin_menu_toolbar\";s:33:\"Administration menu Toolbar style\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}}s:14:\"advanced_forum\";a:8:{s:4:\"name\";s:14:\"advanced_forum\";s:4:\"info\";a:6:{s:4:\"name\";s:14:\"Advanced Forum\";s:7:\"package\";s:14:\"Advanced Forum\";s:7:\"version\";s:7:\"7.x-2.5\";s:7:\"project\";s:14:\"advanced_forum\";s:9:\"datestamp\";s:10:\"1423590792\";s:16:\"_info_file_ctime\";i:1499928385;}s:9:\"datestamp\";s:10:\"1423590792\";s:8:\"includes\";a:1:{s:14:\"advanced_forum\";s:14:\"Advanced Forum\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}}s:11:\"author_pane\";a:8:{s:4:\"name\";s:11:\"author_pane\";s:4:\"info\";a:6:{s:4:\"name\";s:11:\"Author Pane\";s:7:\"version\";s:7:\"7.x-2.0\";s:7:\"project\";s:11:\"author_pane\";s:9:\"datestamp\";s:10:\"1392987849\";s:7:\"package\";s:5:\"Other\";s:16:\"_info_file_ctime\";i:1499928385;}s:9:\"datestamp\";s:10:\"1392987849\";s:8:\"includes\";a:1:{s:11:\"author_pane\";s:11:\"Author Pane\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}}s:6:\"drupal\";a:8:{s:4:\"name\";s:6:\"drupal\";s:4:\"info\";a:6:{s:4:\"name\";s:5:\"Block\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:16:\"_info_file_ctime\";i:1500259381;}s:9:\"datestamp\";s:10:\"1498069849\";s:8:\"includes\";a:36:{s:5:\"block\";s:5:\"Block\";s:4:\"blog\";s:4:\"Blog\";s:4:\"book\";s:4:\"Book\";s:5:\"color\";s:5:\"Color\";s:7:\"comment\";s:7:\"Comment\";s:7:\"contact\";s:7:\"Contact\";s:10:\"contextual\";s:16:\"Contextual links\";s:9:\"dashboard\";s:9:\"Dashboard\";s:5:\"dblog\";s:16:\"Database logging\";s:5:\"field\";s:5:\"Field\";s:17:\"field_sql_storage\";s:17:\"Field SQL storage\";s:8:\"field_ui\";s:8:\"Field UI\";s:4:\"file\";s:4:\"File\";s:6:\"filter\";s:6:\"Filter\";s:5:\"forum\";s:5:\"Forum\";s:4:\"help\";s:4:\"Help\";s:5:\"image\";s:5:\"Image\";s:4:\"list\";s:4:\"List\";s:6:\"locale\";s:6:\"Locale\";s:4:\"menu\";s:4:\"Menu\";s:4:\"node\";s:4:\"Node\";s:6:\"number\";s:6:\"Number\";s:7:\"options\";s:7:\"Options\";s:7:\"overlay\";s:7:\"Overlay\";s:4:\"path\";s:4:\"Path\";s:3:\"php\";s:10:\"PHP filter\";s:6:\"search\";s:6:\"Search\";s:8:\"shortcut\";s:8:\"Shortcut\";s:10:\"statistics\";s:10:\"Statistics\";s:6:\"system\";s:6:\"System\";s:8:\"taxonomy\";s:8:\"Taxonomy\";s:4:\"text\";s:4:\"Text\";s:6:\"update\";s:14:\"Update manager\";s:4:\"user\";s:4:\"User\";s:6:\"bartik\";s:6:\"Bartik\";s:5:\"seven\";s:5:\"Seven\";}s:12:\"project_type\";s:4:\"core\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}}s:11:\"block_class\";a:8:{s:4:\"name\";s:11:\"block_class\";s:4:\"info\";a:6:{s:4:\"name\";s:11:\"Block Class\";s:7:\"version\";s:7:\"7.x-2.3\";s:7:\"project\";s:11:\"block_class\";s:9:\"datestamp\";s:10:\"1450415951\";s:7:\"package\";s:5:\"Other\";s:16:\"_info_file_ctime\";i:1500261080;}s:9:\"datestamp\";s:10:\"1450415951\";s:8:\"includes\";a:1:{s:11:\"block_class\";s:11:\"Block Class\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}}s:8:\"calendar\";a:8:{s:4:\"name\";s:8:\"calendar\";s:4:\"info\";a:6:{s:4:\"name\";s:8:\"Calendar\";s:7:\"package\";s:9:\"Date/Time\";s:7:\"version\";s:7:\"7.x-3.5\";s:7:\"project\";s:8:\"calendar\";s:9:\"datestamp\";s:10:\"1413299943\";s:16:\"_info_file_ctime\";i:1499928385;}s:9:\"datestamp\";s:10:\"1413299943\";s:8:\"includes\";a:1:{s:8:\"calendar\";s:8:\"Calendar\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}}s:6:\"chosen\";a:8:{s:4:\"name\";s:6:\"chosen\";s:4:\"info\";a:6:{s:4:\"name\";s:6:\"Chosen\";s:7:\"package\";s:14:\"User interface\";s:7:\"version\";s:13:\"7.x-2.0-beta4\";s:7:\"project\";s:6:\"chosen\";s:9:\"datestamp\";s:10:\"1394256505\";s:16:\"_info_file_ctime\";i:1499928385;}s:9:\"datestamp\";s:10:\"1394256505\";s:8:\"includes\";a:1:{s:6:\"chosen\";s:6:\"Chosen\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}}s:8:\"ckeditor\";a:8:{s:4:\"name\";s:8:\"ckeditor\";s:4:\"info\";a:6:{s:4:\"name\";s:8:\"CKEditor\";s:7:\"package\";s:14:\"User interface\";s:7:\"version\";s:8:\"7.x-1.16\";s:7:\"project\";s:8:\"ckeditor\";s:9:\"datestamp\";s:10:\"1413311935\";s:16:\"_info_file_ctime\";i:1499928385;}s:9:\"datestamp\";s:10:\"1413311935\";s:8:\"includes\";a:1:{s:8:\"ckeditor\";s:8:\"CKEditor\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}}s:6:\"ctools\";a:8:{s:4:\"name\";s:6:\"ctools\";s:4:\"info\";a:6:{s:4:\"name\";s:11:\"Chaos tools\";s:7:\"package\";s:16:\"Chaos tool suite\";s:7:\"version\";s:7:\"7.x-1.9\";s:7:\"project\";s:6:\"ctools\";s:9:\"datestamp\";s:10:\"1440020680\";s:16:\"_info_file_ctime\";i:1499928385;}s:9:\"datestamp\";s:10:\"1440020680\";s:8:\"includes\";a:1:{s:6:\"ctools\";s:11:\"Chaos tools\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}}s:4:\"date\";a:8:{s:4:\"name\";s:4:\"date\";s:4:\"info\";a:6:{s:4:\"name\";s:8:\"Date API\";s:7:\"package\";s:9:\"Date/Time\";s:7:\"version\";s:7:\"7.x-2.8\";s:7:\"project\";s:4:\"date\";s:9:\"datestamp\";s:10:\"1406653438\";s:16:\"_info_file_ctime\";i:1499928385;}s:9:\"datestamp\";s:10:\"1406653438\";s:8:\"includes\";a:2:{s:8:\"date_api\";s:8:\"Date API\";s:10:\"date_views\";s:10:\"Date Views\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}}s:6:\"entity\";a:8:{s:4:\"name\";s:6:\"entity\";s:4:\"info\";a:6:{s:4:\"name\";s:10:\"Entity API\";s:7:\"version\";s:7:\"7.x-1.6\";s:7:\"project\";s:6:\"entity\";s:9:\"datestamp\";s:10:\"1424876582\";s:7:\"package\";s:5:\"Other\";s:16:\"_info_file_ctime\";i:1499928385;}s:9:\"datestamp\";s:10:\"1424876582\";s:8:\"includes\";a:2:{s:6:\"entity\";s:10:\"Entity API\";s:12:\"entity_token\";s:13:\"Entity tokens\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}}s:15:\"entityreference\";a:8:{s:4:\"name\";s:15:\"entityreference\";s:4:\"info\";a:6:{s:4:\"name\";s:16:\"Entity Reference\";s:7:\"package\";s:6:\"Fields\";s:7:\"version\";s:7:\"7.x-1.1\";s:7:\"project\";s:15:\"entityreference\";s:9:\"datestamp\";s:10:\"1384973110\";s:16:\"_info_file_ctime\";i:1499928385;}s:9:\"datestamp\";s:10:\"1384973110\";s:8:\"includes\";a:1:{s:15:\"entityreference\";s:16:\"Entity Reference\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}}s:3:\"faq\";a:8:{s:4:\"name\";s:3:\"faq\";s:4:\"info\";a:6:{s:4:\"name\";s:26:\"Frequently Asked Questions\";s:7:\"version\";s:11:\"7.x-1.0-rc3\";s:7:\"project\";s:3:\"faq\";s:9:\"datestamp\";s:10:\"1415528891\";s:7:\"package\";s:5:\"Other\";s:16:\"_info_file_ctime\";i:1499928385;}s:9:\"datestamp\";s:10:\"1415528891\";s:8:\"includes\";a:1:{s:3:\"faq\";s:26:\"Frequently Asked Questions\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}}s:8:\"features\";a:8:{s:4:\"name\";s:8:\"features\";s:4:\"info\";a:6:{s:4:\"name\";s:8:\"Features\";s:7:\"package\";s:8:\"Features\";s:7:\"version\";s:8:\"7.x-2.10\";s:7:\"project\";s:8:\"features\";s:9:\"datestamp\";s:10:\"1461011641\";s:16:\"_info_file_ctime\";i:1500260145;}s:9:\"datestamp\";s:10:\"1461011641\";s:8:\"includes\";a:1:{s:8:\"features\";s:8:\"Features\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}}s:16:\"field_collection\";a:8:{s:4:\"name\";s:16:\"field_collection\";s:4:\"info\";a:6:{s:4:\"name\";s:16:\"Field collection\";s:7:\"package\";s:6:\"Fields\";s:7:\"version\";s:13:\"7.x-1.0-beta8\";s:7:\"project\";s:16:\"field_collection\";s:9:\"datestamp\";s:10:\"1415122384\";s:16:\"_info_file_ctime\";i:1499928385;}s:9:\"datestamp\";s:10:\"1415122384\";s:8:\"includes\";a:1:{s:16:\"field_collection\";s:16:\"Field collection\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}}s:11:\"field_group\";a:8:{s:4:\"name\";s:11:\"field_group\";s:4:\"info\";a:6:{s:4:\"name\";s:11:\"Field Group\";s:7:\"package\";s:6:\"Fields\";s:7:\"version\";s:7:\"7.x-1.5\";s:7:\"project\";s:11:\"field_group\";s:9:\"datestamp\";s:10:\"1452033709\";s:16:\"_info_file_ctime\";i:1500259485;}s:9:\"datestamp\";s:10:\"1452033709\";s:8:\"includes\";a:1:{s:11:\"field_group\";s:11:\"Field Group\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}}s:8:\"fivestar\";a:8:{s:4:\"name\";s:8:\"fivestar\";s:4:\"info\";a:6:{s:4:\"name\";s:8:\"Fivestar\";s:7:\"package\";s:6:\"Voting\";s:7:\"version\";s:7:\"7.x-2.1\";s:7:\"project\";s:8:\"fivestar\";s:9:\"datestamp\";s:10:\"1395087839\";s:16:\"_info_file_ctime\";i:1499928385;}s:9:\"datestamp\";s:10:\"1395087839\";s:8:\"includes\";a:1:{s:8:\"fivestar\";s:8:\"Fivestar\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}}s:10:\"flexslider\";a:8:{s:4:\"name\";s:10:\"flexslider\";s:4:\"info\";a:6:{s:4:\"name\";s:10:\"FlexSlider\";s:7:\"package\";s:10:\"FlexSlider\";s:7:\"version\";s:14:\"7.x-2.0-alpha3\";s:7:\"project\";s:10:\"flexslider\";s:9:\"datestamp\";s:10:\"1378663043\";s:16:\"_info_file_ctime\";i:1499928385;}s:9:\"datestamp\";s:10:\"1378663043\";s:8:\"includes\";a:3:{s:10:\"flexslider\";s:10:\"FlexSlider\";s:17:\"flexslider_fields\";s:17:\"FlexSlider Fields\";s:16:\"flexslider_views\";s:22:\"FlexSlider Views Style\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}}s:4:\"i18n\";a:8:{s:4:\"name\";s:4:\"i18n\";s:4:\"info\";a:6:{s:4:\"name\";s:20:\"Internationalization\";s:7:\"package\";s:35:\"Multilingual - Internationalization\";s:7:\"version\";s:8:\"7.x-1.13\";s:7:\"project\";s:4:\"i18n\";s:9:\"datestamp\";s:10:\"1430999922\";s:16:\"_info_file_ctime\";i:1499928385;}s:9:\"datestamp\";s:10:\"1430999922\";s:8:\"includes\";a:5:{s:4:\"i18n\";s:20:\"Internationalization\";s:10:\"i18n_block\";s:15:\"Block languages\";s:11:\"i18n_string\";s:18:\"String translation\";s:13:\"i18n_taxonomy\";s:20:\"Taxonomy translation\";s:16:\"i18n_translation\";s:16:\"Translation sets\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}}s:13:\"jquery_update\";a:8:{s:4:\"name\";s:13:\"jquery_update\";s:4:\"info\";a:6:{s:4:\"name\";s:13:\"jQuery Update\";s:7:\"package\";s:14:\"User interface\";s:7:\"version\";s:7:\"7.x-2.7\";s:7:\"project\";s:13:\"jquery_update\";s:9:\"datestamp\";s:10:\"1445379855\";s:16:\"_info_file_ctime\";i:1500261015;}s:9:\"datestamp\";s:10:\"1445379855\";s:8:\"includes\";a:1:{s:13:\"jquery_update\";s:13:\"jQuery Update\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}}s:13:\"lang_dropdown\";a:8:{s:4:\"name\";s:13:\"lang_dropdown\";s:4:\"info\";a:6:{s:4:\"name\";s:26:\"Language Switcher Dropdown\";s:7:\"package\";s:12:\"Multilingual\";s:7:\"version\";s:7:\"7.x-2.5\";s:7:\"project\";s:13:\"lang_dropdown\";s:9:\"datestamp\";s:10:\"1387127905\";s:16:\"_info_file_ctime\";i:1499928385;}s:9:\"datestamp\";s:10:\"1387127905\";s:8:\"includes\";a:2:{s:13:\"lang_dropdown\";s:26:\"Language Switcher Dropdown\";s:21:\"lang_dropdown_hideout\";s:34:\"Language Switcher Dropdown Hideout\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}}s:13:\"languageicons\";a:8:{s:4:\"name\";s:13:\"languageicons\";s:4:\"info\";a:6:{s:4:\"name\";s:14:\"Language Icons\";s:7:\"package\";s:12:\"Multilingual\";s:7:\"version\";s:7:\"7.x-1.1\";s:7:\"project\";s:13:\"languageicons\";s:9:\"datestamp\";s:10:\"1399825730\";s:16:\"_info_file_ctime\";i:1499928385;}s:9:\"datestamp\";s:10:\"1399825730\";s:8:\"includes\";a:1:{s:13:\"languageicons\";s:14:\"Language Icons\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}}s:9:\"libraries\";a:8:{s:4:\"name\";s:9:\"libraries\";s:4:\"info\";a:6:{s:4:\"name\";s:9:\"Libraries\";s:7:\"version\";s:7:\"7.x-2.2\";s:7:\"project\";s:9:\"libraries\";s:9:\"datestamp\";s:10:\"1391965716\";s:7:\"package\";s:5:\"Other\";s:16:\"_info_file_ctime\";i:1499928385;}s:9:\"datestamp\";s:10:\"1391965716\";s:8:\"includes\";a:1:{s:9:\"libraries\";s:9:\"Libraries\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}}s:4:\"link\";a:8:{s:4:\"name\";s:4:\"link\";s:4:\"info\";a:6:{s:4:\"name\";s:4:\"Link\";s:7:\"package\";s:6:\"Fields\";s:7:\"version\";s:7:\"7.x-1.3\";s:7:\"project\";s:4:\"link\";s:9:\"datestamp\";s:10:\"1413924830\";s:16:\"_info_file_ctime\";i:1499928385;}s:9:\"datestamp\";s:10:\"1413924830\";s:8:\"includes\";a:1:{s:4:\"link\";s:4:\"Link\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}}s:15:\"menu_breadcrumb\";a:8:{s:4:\"name\";s:15:\"menu_breadcrumb\";s:4:\"info\";a:6:{s:4:\"name\";s:15:\"Menu breadcrumb\";s:7:\"version\";s:7:\"7.x-1.6\";s:7:\"project\";s:15:\"menu_breadcrumb\";s:9:\"datestamp\";s:10:\"1425993992\";s:7:\"package\";s:5:\"Other\";s:16:\"_info_file_ctime\";i:1499928385;}s:9:\"datestamp\";s:10:\"1425993992\";s:8:\"includes\";a:1:{s:15:\"menu_breadcrumb\";s:15:\"Menu breadcrumb\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}}s:7:\"message\";a:8:{s:4:\"name\";s:7:\"message\";s:4:\"info\";a:6:{s:4:\"name\";s:7:\"Message\";s:7:\"package\";s:7:\"Message\";s:7:\"version\";s:7:\"7.x-1.9\";s:7:\"project\";s:7:\"message\";s:9:\"datestamp\";s:10:\"1374541036\";s:16:\"_info_file_ctime\";i:1499928385;}s:9:\"datestamp\";s:10:\"1374541036\";s:8:\"includes\";a:2:{s:7:\"message\";s:7:\"Message\";s:15:\"message_example\";s:15:\"Message example\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}}s:11:\"modal_forms\";a:8:{s:4:\"name\";s:11:\"modal_forms\";s:4:\"info\";a:6:{s:4:\"name\";s:11:\"Modal forms\";s:7:\"version\";s:7:\"7.x-1.2\";s:7:\"project\";s:11:\"modal_forms\";s:9:\"datestamp\";s:10:\"1353326875\";s:7:\"package\";s:5:\"Other\";s:16:\"_info_file_ctime\";i:1499928385;}s:9:\"datestamp\";s:10:\"1353326875\";s:8:\"includes\";a:1:{s:11:\"modal_forms\";s:11:\"Modal forms\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}}s:13:\"module_filter\";a:8:{s:4:\"name\";s:13:\"module_filter\";s:4:\"info\";a:6:{s:4:\"name\";s:13:\"Module filter\";s:7:\"package\";s:14:\"Administration\";s:7:\"version\";s:7:\"7.x-2.0\";s:7:\"project\";s:13:\"module_filter\";s:9:\"datestamp\";s:10:\"1424631189\";s:16:\"_info_file_ctime\";i:1499928385;}s:9:\"datestamp\";s:10:\"1424631189\";s:8:\"includes\";a:1:{s:13:\"module_filter\";s:13:\"Module filter\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}}s:10:\"node_class\";a:8:{s:4:\"name\";s:10:\"node_class\";s:4:\"info\";a:6:{s:4:\"name\";s:10:\"Node Class\";s:7:\"version\";s:7:\"7.x-1.3\";s:7:\"project\";s:10:\"node_class\";s:9:\"datestamp\";s:10:\"1388997876\";s:7:\"package\";s:5:\"Other\";s:16:\"_info_file_ctime\";i:1499928385;}s:9:\"datestamp\";s:10:\"1388997876\";s:8:\"includes\";a:1:{s:10:\"node_class\";s:10:\"Node Class\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}}s:8:\"pathauto\";a:8:{s:4:\"name\";s:8:\"pathauto\";s:4:\"info\";a:6:{s:4:\"name\";s:8:\"Pathauto\";s:7:\"version\";s:7:\"7.x-1.2\";s:7:\"project\";s:8:\"pathauto\";s:9:\"datestamp\";s:10:\"1344525185\";s:7:\"package\";s:5:\"Other\";s:16:\"_info_file_ctime\";i:1499928385;}s:9:\"datestamp\";s:10:\"1344525185\";s:8:\"includes\";a:1:{s:8:\"pathauto\";s:8:\"Pathauto\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}}s:9:\"quicktabs\";a:8:{s:4:\"name\";s:9:\"quicktabs\";s:4:\"info\";a:6:{s:4:\"name\";s:9:\"Quicktabs\";s:7:\"version\";s:7:\"7.x-3.6\";s:7:\"project\";s:9:\"quicktabs\";s:9:\"datestamp\";s:10:\"1380731929\";s:7:\"package\";s:5:\"Other\";s:16:\"_info_file_ctime\";i:1499928385;}s:9:\"datestamp\";s:10:\"1380731929\";s:8:\"includes\";a:1:{s:9:\"quicktabs\";s:9:\"Quicktabs\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}}s:11:\"remember_me\";a:8:{s:4:\"name\";s:11:\"remember_me\";s:4:\"info\";a:6:{s:4:\"name\";s:11:\"Remember me\";s:7:\"version\";s:7:\"7.x-1.1\";s:7:\"project\";s:11:\"remember_me\";s:9:\"datestamp\";s:10:\"1492928945\";s:7:\"package\";s:5:\"Other\";s:16:\"_info_file_ctime\";i:1500259564;}s:9:\"datestamp\";s:10:\"1492928945\";s:8:\"includes\";a:1:{s:11:\"remember_me\";s:11:\"Remember me\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}}s:9:\"sharethis\";a:8:{s:4:\"name\";s:9:\"sharethis\";s:4:\"info\";a:6:{s:4:\"name\";s:9:\"ShareThis\";s:7:\"package\";s:7:\"Sharing\";s:7:\"version\";s:8:\"7.x-2.10\";s:7:\"project\";s:9:\"sharethis\";s:9:\"datestamp\";s:10:\"1422441977\";s:16:\"_info_file_ctime\";i:1499928385;}s:9:\"datestamp\";s:10:\"1422441977\";s:8:\"includes\";a:1:{s:9:\"sharethis\";s:9:\"ShareThis\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}}s:9:\"shortcode\";a:8:{s:4:\"name\";s:9:\"shortcode\";s:4:\"info\";a:6:{s:4:\"name\";s:9:\"Shortcode\";s:7:\"package\";s:9:\"Shortcode\";s:7:\"version\";s:7:\"7.x-2.2\";s:7:\"project\";s:9:\"shortcode\";s:9:\"datestamp\";s:10:\"1423035812\";s:16:\"_info_file_ctime\";i:1499928385;}s:9:\"datestamp\";s:10:\"1423035812\";s:8:\"includes\";a:4:{s:9:\"shortcode\";s:9:\"Shortcode\";s:20:\"shortcode_basic_tags\";s:20:\"Shortcode Basic Tags\";s:23:\"shortcode_embed_content\";s:27:\"Shortcode Embed Content Tag\";s:15:\"shortcode_video\";s:21:\"Shortcode Video Macro\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}}s:9:\"strongarm\";a:8:{s:4:\"name\";s:9:\"strongarm\";s:4:\"info\";a:6:{s:4:\"name\";s:9:\"Strongarm\";s:7:\"version\";s:7:\"7.x-2.0\";s:7:\"project\";s:9:\"strongarm\";s:9:\"datestamp\";s:10:\"1339604214\";s:7:\"package\";s:5:\"Other\";s:16:\"_info_file_ctime\";i:1499928385;}s:9:\"datestamp\";s:10:\"1339604214\";s:8:\"includes\";a:1:{s:9:\"strongarm\";s:9:\"Strongarm\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}}s:9:\"tagclouds\";a:8:{s:4:\"name\";s:9:\"tagclouds\";s:4:\"info\";a:6:{s:4:\"name\";s:9:\"TagClouds\";s:7:\"package\";s:8:\"Taxonomy\";s:7:\"version\";s:8:\"7.x-1.10\";s:7:\"project\";s:9:\"tagclouds\";s:9:\"datestamp\";s:10:\"1404152332\";s:16:\"_info_file_ctime\";i:1499928385;}s:9:\"datestamp\";s:10:\"1404152332\";s:8:\"includes\";a:1:{s:9:\"tagclouds\";s:9:\"TagClouds\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}}s:13:\"taxonomy_menu\";a:8:{s:4:\"name\";s:13:\"taxonomy_menu\";s:4:\"info\";a:6:{s:4:\"name\";s:13:\"Taxonomy menu\";s:7:\"package\";s:13:\"Taxonomy menu\";s:7:\"version\";s:7:\"7.x-1.5\";s:7:\"project\";s:13:\"taxonomy_menu\";s:9:\"datestamp\";s:10:\"1396359247\";s:16:\"_info_file_ctime\";i:1499928385;}s:9:\"datestamp\";s:10:\"1396359247\";s:8:\"includes\";a:1:{s:13:\"taxonomy_menu\";s:13:\"Taxonomy menu\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}}s:5:\"token\";a:8:{s:4:\"name\";s:5:\"token\";s:4:\"info\";a:6:{s:4:\"name\";s:5:\"Token\";s:7:\"version\";s:7:\"7.x-1.6\";s:7:\"project\";s:5:\"token\";s:9:\"datestamp\";s:10:\"1425149060\";s:7:\"package\";s:5:\"Other\";s:16:\"_info_file_ctime\";i:1499928385;}s:9:\"datestamp\";s:10:\"1425149060\";s:8:\"includes\";a:1:{s:5:\"token\";s:5:\"Token\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}}s:12:\"token_custom\";a:8:{s:4:\"name\";s:12:\"token_custom\";s:4:\"info\";a:6:{s:4:\"name\";s:13:\"Custom tokens\";s:7:\"version\";s:13:\"7.x-2.0-beta3\";s:7:\"project\";s:12:\"token_custom\";s:9:\"datestamp\";s:10:\"1348426268\";s:7:\"package\";s:5:\"Other\";s:16:\"_info_file_ctime\";i:1499928385;}s:9:\"datestamp\";s:10:\"1348426268\";s:8:\"includes\";a:1:{s:12:\"token_custom\";s:13:\"Custom tokens\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}}s:8:\"variable\";a:8:{s:4:\"name\";s:8:\"variable\";s:4:\"info\";a:6:{s:4:\"name\";s:8:\"Variable\";s:7:\"package\";s:8:\"Variable\";s:7:\"version\";s:7:\"7.x-2.5\";s:7:\"project\";s:8:\"variable\";s:9:\"datestamp\";s:10:\"1398250128\";s:16:\"_info_file_ctime\";i:1499928385;}s:9:\"datestamp\";s:10:\"1398250128\";s:8:\"includes\";a:1:{s:8:\"variable\";s:8:\"Variable\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}}s:17:\"video_embed_field\";a:8:{s:4:\"name\";s:17:\"video_embed_field\";s:4:\"info\";a:6:{s:4:\"name\";s:17:\"Video Embed Field\";s:7:\"package\";s:5:\"Media\";s:7:\"version\";s:14:\"7.x-2.0-beta11\";s:7:\"project\";s:17:\"video_embed_field\";s:9:\"datestamp\";s:10:\"1441639440\";s:16:\"_info_file_ctime\";i:1499928385;}s:9:\"datestamp\";s:10:\"1441639440\";s:8:\"includes\";a:1:{s:17:\"video_embed_field\";s:17:\"Video Embed Field\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}}s:5:\"views\";a:8:{s:4:\"name\";s:5:\"views\";s:4:\"info\";a:6:{s:4:\"name\";s:5:\"Views\";s:7:\"package\";s:5:\"Views\";s:7:\"version\";s:8:\"7.x-3.16\";s:7:\"project\";s:5:\"views\";s:9:\"datestamp\";s:10:\"1491158591\";s:16:\"_info_file_ctime\";i:1500259761;}s:9:\"datestamp\";s:10:\"1491158591\";s:8:\"includes\";a:2:{s:5:\"views\";s:5:\"Views\";s:8:\"views_ui\";s:8:\"Views UI\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}}s:15:\"views_fieldsets\";a:8:{s:4:\"name\";s:15:\"views_fieldsets\";s:4:\"info\";a:6:{s:4:\"name\";s:15:\"Views fieldsets\";s:7:\"package\";s:5:\"Views\";s:7:\"version\";s:7:\"7.x-1.3\";s:7:\"project\";s:15:\"views_fieldsets\";s:9:\"datestamp\";s:10:\"1425515886\";s:16:\"_info_file_ctime\";i:1499928385;}s:9:\"datestamp\";s:10:\"1425515886\";s:8:\"includes\";a:1:{s:15:\"views_fieldsets\";s:15:\"Views fieldsets\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}}s:15:\"views_slideshow\";a:8:{s:4:\"name\";s:15:\"views_slideshow\";s:4:\"info\";a:6:{s:4:\"name\";s:15:\"Views Slideshow\";s:7:\"package\";s:5:\"Views\";s:7:\"version\";s:7:\"7.x-3.1\";s:7:\"project\";s:15:\"views_slideshow\";s:9:\"datestamp\";s:10:\"1382584826\";s:16:\"_info_file_ctime\";i:1499928385;}s:9:\"datestamp\";s:10:\"1382584826\";s:8:\"includes\";a:2:{s:15:\"views_slideshow\";s:15:\"Views Slideshow\";s:21:\"views_slideshow_cycle\";s:22:\"Views Slideshow: Cycle\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}}s:9:\"votingapi\";a:8:{s:4:\"name\";s:9:\"votingapi\";s:4:\"info\";a:6:{s:4:\"name\";s:10:\"Voting API\";s:7:\"package\";s:6:\"Voting\";s:7:\"version\";s:8:\"7.x-2.12\";s:7:\"project\";s:9:\"votingapi\";s:9:\"datestamp\";s:10:\"1407995929\";s:16:\"_info_file_ctime\";i:1499928385;}s:9:\"datestamp\";s:10:\"1407995929\";s:8:\"includes\";a:1:{s:9:\"votingapi\";s:10:\"Voting API\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}}s:20:\"we_content_migration\";a:8:{s:4:\"name\";s:20:\"we_content_migration\";s:4:\"info\";a:6:{s:4:\"name\";s:17:\"Content Migration\";s:7:\"package\";s:17:\"Content Migration\";s:7:\"version\";s:11:\"7.x-1.x-dev\";s:7:\"project\";s:20:\"we_content_migration\";s:9:\"datestamp\";s:10:\"1499677744\";s:16:\"_info_file_ctime\";i:1499928623;}s:9:\"datestamp\";s:10:\"1499677744\";s:8:\"includes\";a:1:{s:20:\"we_content_migration\";s:17:\"Content Migration\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}}s:7:\"webform\";a:8:{s:4:\"name\";s:7:\"webform\";s:4:\"info\";a:6:{s:4:\"name\";s:7:\"Webform\";s:7:\"package\";s:7:\"Webform\";s:7:\"version\";s:8:\"7.x-4.15\";s:7:\"project\";s:7:\"webform\";s:9:\"datestamp\";s:10:\"1492107249\";s:16:\"_info_file_ctime\";i:1500259935;}s:9:\"datestamp\";s:10:\"1492107249\";s:8:\"includes\";a:1:{s:7:\"webform\";s:7:\"Webform\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}}s:13:\"webform_hints\";a:8:{s:4:\"name\";s:13:\"webform_hints\";s:4:\"info\";a:6:{s:4:\"name\";s:13:\"Webform Hints\";s:7:\"package\";s:7:\"Webform\";s:7:\"version\";s:7:\"7.x-1.5\";s:7:\"project\";s:13:\"webform_hints\";s:9:\"datestamp\";s:10:\"1407952128\";s:16:\"_info_file_ctime\";i:1499928385;}s:9:\"datestamp\";s:10:\"1407952128\";s:8:\"includes\";a:1:{s:13:\"webform_hints\";s:13:\"Webform Hints\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}}}',1512623927,1512620327,1);
/*!40000 ALTER TABLE `cache_update` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `cache_variable`
--

DROP TABLE IF EXISTS `cache_variable`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `cache_variable` (
  `cid` varchar(255) NOT NULL DEFAULT '' COMMENT 'Primary Key: Unique cache ID.',
  `data` longblob COMMENT 'A collection of data to cache.',
  `expire` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry should expire, or 0 for never.',
  `created` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry was created.',
  `serialized` smallint(6) NOT NULL DEFAULT '0' COMMENT 'A flag to indicate whether content is serialized (1) or not (0).',
  PRIMARY KEY (`cid`),
  KEY `expire` (`expire`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Cache table for variables.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `cache_variable`
--

LOCK TABLES `cache_variable` WRITE;
/*!40000 ALTER TABLE `cache_variable` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `cache_variable` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `cache_views`
--

DROP TABLE IF EXISTS `cache_views`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `cache_views` (
  `cid` varchar(255) NOT NULL DEFAULT '' COMMENT 'Primary Key: Unique cache ID.',
  `data` longblob COMMENT 'A collection of data to cache.',
  `expire` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry should expire, or 0 for never.',
  `created` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry was created.',
  `serialized` smallint(6) NOT NULL DEFAULT '0' COMMENT 'A flag to indicate whether content is serialized (1) or not (0).',
  PRIMARY KEY (`cid`),
  KEY `expire` (`expire`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Generic cache table for caching things not separated out...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `cache_views`
--

LOCK TABLES `cache_views` WRITE;
/*!40000 ALTER TABLE `cache_views` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `cache_views` VALUES ('ctools_export:views_view:advanced_forum_active_topics','O:4:\"view\":49:{s:8:\"db_table\";s:10:\"views_view\";s:10:\"base_table\";s:4:\"node\";s:10:\"base_field\";s:3:\"nid\";s:4:\"name\";s:28:\"advanced_forum_active_topics\";s:3:\"vid\";s:0:\"\";s:11:\"description\";s:38:\"Shows the active topics in all forums.\";s:3:\"tag\";s:14:\"Advanced Forum\";s:10:\"human_name\";s:28:\"Advanced Forum active topics\";s:4:\"core\";i:7;s:11:\"api_version\";s:3:\"3.0\";s:8:\"disabled\";b:0;s:5:\"built\";b:0;s:8:\"executed\";b:0;s:7:\"editing\";b:0;s:4:\"args\";a:0:{}s:10:\"build_info\";a:0:{}s:8:\"use_ajax\";b:0;s:6:\"result\";a:0:{}s:12:\"current_page\";N;s:14:\"items_per_page\";N;s:6:\"offset\";N;s:10:\"total_rows\";N;s:17:\"attachment_before\";s:0:\"\";s:16:\"attachment_after\";s:0:\"\";s:12:\"exposed_data\";a:0:{}s:13:\"exposed_input\";a:0:{}s:17:\"exposed_raw_input\";a:0:{}s:8:\"old_view\";a:0:{}s:12:\"parent_views\";a:0:{}s:13:\"is_attachment\";N;s:15:\"current_display\";N;s:5:\"query\";N;s:15:\"display_handler\";N;s:7:\"display\";a:3:{s:7:\"default\";O:13:\"views_display\":8:{s:7:\"handler\";O:28:\"views_plugin_display_default\":9:{s:4:\"view\";r:1;s:8:\"handlers\";a:0:{}s:8:\"extender\";a:0:{}s:7:\"display\";R:36;s:11:\"plugin_type\";s:7:\"display\";s:11:\"plugin_name\";s:7:\"default\";s:7:\"options\";a:38:{s:5:\"title\";s:0:\"\";s:7:\"enabled\";b:1;s:15:\"display_comment\";s:0:\"\";s:9:\"css_class\";s:0:\"\";s:19:\"display_description\";s:0:\"\";s:8:\"use_ajax\";b:0;s:23:\"hide_attachment_summary\";b:0;s:16:\"hide_admin_links\";b:0;s:14:\"items_per_page\";i:10;s:6:\"offset\";i:0;s:9:\"use_pager\";b:0;s:8:\"use_more\";b:0;s:15:\"use_more_always\";b:0;s:13:\"use_more_text\";s:4:\"more\";s:12:\"link_display\";s:0:\"\";s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:0;s:14:\"field_language\";s:22:\"***CURRENT_LANGUAGE***\";s:27:\"field_language_add_to_query\";i:1;s:6:\"access\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"cache\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:0:{}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"full\";s:7:\"options\";a:0:{}}s:12:\"style_plugin\";s:7:\"default\";s:13:\"style_options\";a:0:{}s:10:\"row_plugin\";s:6:\"fields\";s:11:\"row_options\";a:0:{}s:13:\"exposed_block\";b:0;s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:0:{}s:13:\"relationships\";a:0:{}s:6:\"fields\";a:0:{}s:5:\"sorts\";a:0:{}s:9:\"arguments\";a:0:{}s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}s:7:\"filters\";a:0:{}}s:10:\"definition\";a:20:{s:5:\"title\";s:6:\"Master\";s:4:\"help\";s:31:\"Default settings for this view.\";s:7:\"handler\";s:28:\"views_plugin_display_default\";s:5:\"theme\";s:10:\"views_view\";s:5:\"no ui\";b:1;s:9:\"no remove\";b:1;s:2:\"js\";a:6:{i:0;s:12:\"misc/form.js\";i:1;s:16:\"misc/collapse.js\";i:2;s:16:\"misc/textarea.js\";i:3;s:17:\"misc/tabledrag.js\";i:4;s:20:\"misc/autocomplete.js\";i:5;s:40:\"sites/all/modules/ctools/js/dependent.js\";}s:8:\"use ajax\";b:1;s:9:\"use pager\";b:1;s:8:\"use more\";b:1;s:18:\"accept attachments\";b:1;s:10:\"help topic\";s:15:\"display-default\";s:6:\"module\";s:5:\"views\";s:10:\"theme path\";s:29:\"sites/all/modules/views/theme\";s:10:\"theme file\";s:9:\"theme.inc\";s:4:\"path\";s:31:\"sites/all/modules/views/plugins\";s:4:\"file\";s:32:\"views_plugin_display_default.inc\";s:6:\"parent\";s:6:\"parent\";s:4:\"name\";s:7:\"default\";s:16:\"contextual links\";a:1:{s:8:\"views_ui\";a:2:{s:11:\"parent path\";s:26:\"admin/structure/views/view\";s:19:\"argument properties\";a:1:{i:0;s:4:\"name\";}}}}s:9:\"is_plugin\";b:1;}s:15:\"display_options\";a:12:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:2:{s:8:\"distinct\";b:1;s:13:\"query_comment\";b:0;}}s:5:\"title\";s:19:\"Active forum topics\";s:6:\"access\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"cache\";a:1:{s:4:\"type\";s:4:\"none\";}s:12:\"exposed_form\";a:1:{s:4:\"type\";s:5:\"basic\";}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"full\";s:7:\"options\";a:1:{s:14:\"items_per_page\";i:20;}}s:12:\"style_plugin\";s:16:\"forum_topic_list\";s:13:\"style_options\";a:7:{s:7:\"columns\";a:16:{s:3:\"nid\";s:3:\"nid\";s:6:\"teaser\";s:6:\"teaser\";s:10:\"topic_icon\";s:10:\"topic_icon\";s:5:\"title\";s:5:\"title\";s:4:\"name\";s:4:\"name\";s:9:\"timestamp\";s:5:\"title\";s:11:\"topic_pager\";s:5:\"title\";s:6:\"name_1\";s:5:\"title\";s:7:\"created\";s:5:\"title\";s:13:\"comment_count\";s:13:\"comment_count\";s:12:\"new_comments\";s:13:\"comment_count\";s:10:\"totalcount\";s:10:\"totalcount\";s:17:\"last_comment_name\";s:12:\"last_updated\";s:12:\"last_updated\";s:12:\"last_updated\";s:6:\"sticky\";s:6:\"sticky\";s:7:\"comment\";s:7:\"comment\";}s:7:\"default\";s:12:\"last_updated\";s:4:\"info\";a:16:{s:3:\"nid\";a:2:{s:8:\"sortable\";i:0;s:9:\"separator\";s:0:\"\";}s:10:\"topic_icon\";a:1:{s:9:\"separator\";s:0:\"\";}s:5:\"title\";a:2:{s:8:\"sortable\";i:1;s:9:\"separator\";s:1:\" \";}s:4:\"name\";a:2:{s:8:\"sortable\";i:1;s:9:\"separator\";s:0:\"\";}s:9:\"timestamp\";a:1:{s:9:\"separator\";s:0:\"\";}s:11:\"topic_pager\";a:1:{s:9:\"separator\";s:0:\"\";}s:6:\"name_1\";a:2:{s:8:\"sortable\";i:0;s:9:\"separator\";s:0:\"\";}s:7:\"created\";a:2:{s:8:\"sortable\";i:0;s:9:\"separator\";s:0:\"\";}s:13:\"comment_count\";a:2:{s:8:\"sortable\";i:1;s:9:\"separator\";s:6:\"<br />\";}s:12:\"new_comments\";a:1:{s:9:\"separator\";s:0:\"\";}s:10:\"totalcount\";a:2:{s:8:\"sortable\";i:1;s:9:\"separator\";s:0:\"\";}s:17:\"last_comment_name\";a:2:{s:8:\"sortable\";i:1;s:9:\"separator\";s:6:\"<br />\";}s:12:\"last_updated\";a:2:{s:8:\"sortable\";i:1;s:9:\"separator\";s:6:\"<br />\";}s:6:\"sticky\";a:2:{s:8:\"sortable\";i:0;s:9:\"separator\";s:0:\"\";}s:6:\"teaser\";a:1:{s:9:\"separator\";s:0:\"\";}s:7:\"comment\";a:2:{s:8:\"sortable\";i:0;s:9:\"separator\";s:0:\"\";}}s:8:\"override\";i:0;s:6:\"sticky\";i:1;s:5:\"order\";s:4:\"desc\";s:3:\"tid\";s:26:\"filter.term_node_tid_depth\";}s:5:\"empty\";a:1:{s:4:\"text\";a:5:{s:2:\"id\";s:4:\"area\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:4:\"area\";s:5:\"empty\";b:0;s:7:\"content\";s:17:\"No active topics.\";}}s:13:\"relationships\";a:2:{s:13:\"term_node_tid\";a:3:{s:2:\"id\";s:13:\"term_node_tid\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:13:\"term_node_tid\";}s:3:\"uid\";a:3:{s:2:\"id\";s:3:\"uid\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:3:\"uid\";}}s:6:\"fields\";a:16:{s:3:\"nid\";a:8:{s:2:\"id\";s:3:\"nid\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:3:\"nid\";s:7:\"exclude\";b:1;s:5:\"alter\";a:7:{s:10:\"alter_text\";i:0;s:9:\"make_link\";i:0;s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:4:\"html\";i:0;}s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:12:\"link_to_node\";i:0;}s:6:\"teaser\";a:9:{s:2:\"id\";s:6:\"teaser\";s:5:\"table\";s:15:\"field_data_body\";s:5:\"field\";s:4:\"body\";s:5:\"label\";s:6:\"Teaser\";s:7:\"exclude\";b:1;s:5:\"alter\";a:8:{s:10:\"alter_text\";i:0;s:9:\"make_link\";i:0;s:10:\"max_length\";s:3:\"200\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:10:\"strip_tags\";i:1;s:4:\"trim\";i:0;s:4:\"html\";i:0;}s:10:\"hide_empty\";i:0;s:4:\"type\";s:23:\"text_summary_or_trimmed\";s:8:\"settings\";a:1:{s:11:\"trim_length\";s:3:\"200\";}}s:10:\"topic_icon\";a:6:{s:2:\"id\";s:10:\"topic_icon\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:10:\"topic_icon\";s:5:\"label\";s:0:\"\";s:5:\"alter\";a:7:{s:10:\"alter_text\";i:0;s:9:\"make_link\";i:0;s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:4:\"html\";i:0;}s:19:\"hot_topic_threshold\";s:2:\"15\";}s:5:\"title\";a:8:{s:2:\"id\";s:5:\"title\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:5:\"title\";s:5:\"label\";s:5:\"Topic\";s:5:\"alter\";a:11:{s:10:\"alter_text\";i:0;s:4:\"text\";s:47:\"<span class=\"forum-topic-title\">[title]</span> \";s:9:\"make_link\";i:1;s:4:\"path\";s:10:\"node/[nid]\";s:3:\"alt\";s:8:\"[teaser]\";s:10:\"link_class\";s:11:\"topic-title\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:4:\"html\";i:0;}s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:12:\"link_to_node\";i:0;}s:9:\"timestamp\";a:8:{s:2:\"id\";s:9:\"timestamp\";s:5:\"table\";s:7:\"history\";s:5:\"field\";s:9:\"timestamp\";s:5:\"alter\";a:8:{s:10:\"alter_text\";i:1;s:4:\"text\";s:12:\"[timestamp] \";s:9:\"make_link\";i:0;s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:4:\"html\";i:0;}s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:12:\"link_to_node\";i:0;s:8:\"comments\";i:1;}s:11:\"topic_pager\";a:5:{s:2:\"id\";s:11:\"topic_pager\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:11:\"topic_pager\";s:5:\"alter\";a:7:{s:10:\"alter_text\";i:0;s:9:\"make_link\";i:0;s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:4:\"html\";i:0;}s:17:\"total_pages_shown\";s:1:\"3\";}s:6:\"name_1\";a:9:{s:2:\"id\";s:6:\"name_1\";s:5:\"table\";s:5:\"users\";s:5:\"field\";s:4:\"name\";s:12:\"relationship\";s:3:\"uid\";s:5:\"alter\";a:8:{s:10:\"alter_text\";i:1;s:4:\"text\";s:19:\"<br /> by [name_1] \";s:9:\"make_link\";i:0;s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:4:\"html\";i:0;}s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:12:\"link_to_user\";i:1;s:19:\"overwrite_anonymous\";i:0;}s:7:\"created\";a:6:{s:2:\"id\";s:7:\"created\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:7:\"created\";s:5:\"alter\";a:8:{s:10:\"alter_text\";i:1;s:4:\"text\";s:12:\"on [created]\";s:9:\"make_link\";i:0;s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:4:\"html\";i:0;}s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;}s:13:\"comment_count\";a:12:{s:2:\"id\";s:13:\"comment_count\";s:5:\"table\";s:23:\"node_comment_statistics\";s:5:\"field\";s:13:\"comment_count\";s:5:\"label\";s:7:\"Replies\";s:5:\"alter\";a:12:{s:10:\"alter_text\";i:0;s:9:\"make_link\";i:0;s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:15:\"trim_whitespace\";i:0;s:5:\"nl2br\";i:0;s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:4:\"html\";i:0;}s:19:\"element_label_colon\";i:1;s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:1:\"0\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:0;s:13:\"format_plural\";i:0;}s:12:\"new_comments\";a:9:{s:2:\"id\";s:12:\"new_comments\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:12:\"new_comments\";s:5:\"alter\";a:7:{s:10:\"alter_text\";i:0;s:9:\"make_link\";i:0;s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:4:\"html\";i:0;}s:10:\"hide_empty\";i:1;s:10:\"empty_zero\";i:0;s:6:\"prefix\";s:5:\"View \";s:6:\"suffix\";s:4:\" new\";s:15:\"link_to_comment\";i:1;}s:10:\"totalcount\";a:8:{s:2:\"id\";s:10:\"totalcount\";s:5:\"table\";s:12:\"node_counter\";s:5:\"field\";s:10:\"totalcount\";s:5:\"label\";s:5:\"Views\";s:5:\"alter\";a:7:{s:10:\"alter_text\";i:0;s:9:\"make_link\";i:0;s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:4:\"html\";i:0;}s:5:\"empty\";s:1:\"0\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:1;}s:17:\"last_comment_name\";a:6:{s:2:\"id\";s:17:\"last_comment_name\";s:5:\"table\";s:23:\"node_comment_statistics\";s:5:\"field\";s:17:\"last_comment_name\";s:5:\"alter\";a:8:{s:10:\"alter_text\";i:1;s:4:\"text\";s:22:\"by [last_comment_name]\";s:9:\"make_link\";i:0;s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:4:\"html\";i:0;}s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;}s:12:\"last_updated\";a:7:{s:2:\"id\";s:12:\"last_updated\";s:5:\"table\";s:23:\"node_comment_statistics\";s:5:\"field\";s:12:\"last_updated\";s:5:\"label\";s:9:\"Last post\";s:5:\"alter\";a:7:{s:10:\"alter_text\";i:0;s:9:\"make_link\";i:0;s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:4:\"html\";i:0;}s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;}s:6:\"sticky\";a:6:{s:2:\"id\";s:6:\"sticky\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:6:\"sticky\";s:7:\"exclude\";b:1;s:5:\"alter\";a:7:{s:10:\"alter_text\";i:0;s:9:\"make_link\";i:0;s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:4:\"html\";i:0;}s:3:\"not\";i:0;}s:7:\"comment\";a:5:{s:2:\"id\";s:7:\"comment\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:7:\"comment\";s:7:\"exclude\";b:1;s:5:\"alter\";a:7:{s:10:\"alter_text\";i:0;s:9:\"make_link\";i:0;s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:4:\"html\";i:0;}}s:4:\"name\";a:9:{s:2:\"id\";s:4:\"name\";s:5:\"table\";s:18:\"taxonomy_term_data\";s:5:\"field\";s:4:\"name\";s:12:\"relationship\";s:13:\"term_node_tid\";s:5:\"label\";s:5:\"Forum\";s:5:\"alter\";a:7:{s:10:\"alter_text\";i:0;s:9:\"make_link\";i:0;s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:4:\"html\";i:0;}s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"link_to_taxonomy\";i:1;}}s:7:\"filters\";a:3:{s:6:\"status\";a:5:{s:2:\"id\";s:6:\"status\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:6:\"status\";s:5:\"value\";s:1:\"1\";s:6:\"expose\";a:1:{s:8:\"operator\";b:0;}}s:3:\"vid\";a:6:{s:2:\"id\";s:3:\"vid\";s:5:\"table\";s:18:\"taxonomy_term_data\";s:5:\"field\";s:3:\"vid\";s:12:\"relationship\";s:13:\"term_node_tid\";s:5:\"value\";a:1:{i:2;s:1:\"2\";}s:6:\"expose\";a:1:{s:8:\"operator\";b:0;}}s:19:\"term_node_tid_depth\";a:11:{s:2:\"id\";s:19:\"term_node_tid_depth\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:19:\"term_node_tid_depth\";s:7:\"exposed\";b:1;s:6:\"expose\";a:6:{s:11:\"operator_id\";s:22:\"term_node_tid_depth_op\";s:5:\"label\";s:22:\"Show active topics in:\";s:8:\"operator\";s:22:\"term_node_tid_depth_op\";s:10:\"identifier\";s:5:\"forum\";s:8:\"remember\";i:1;s:6:\"reduce\";i:0;}s:17:\"reduce_duplicates\";i:0;s:4:\"type\";s:6:\"select\";s:10:\"vocabulary\";s:6:\"forums\";s:9:\"hierarchy\";i:1;s:13:\"error_message\";i:1;s:5:\"depth\";s:1:\"2\";}}}s:8:\"db_table\";s:13:\"views_display\";s:3:\"vid\";i:0;s:2:\"id\";s:7:\"default\";s:13:\"display_title\";s:8:\"Defaults\";s:14:\"display_plugin\";s:7:\"default\";s:8:\"position\";i:0;}s:6:\"page_1\";O:13:\"views_display\":8:{s:7:\"handler\";O:25:\"views_plugin_display_page\":10:{s:4:\"view\";r:1;s:8:\"handlers\";a:0:{}s:8:\"extender\";a:0:{}s:7:\"display\";R:532;s:11:\"plugin_type\";s:7:\"display\";s:11:\"plugin_name\";s:4:\"page\";s:7:\"options\";a:42:{s:8:\"defaults\";a:32:{s:6:\"access\";b:1;s:5:\"cache\";b:1;s:5:\"query\";b:1;s:5:\"title\";b:1;s:9:\"css_class\";b:1;s:19:\"display_description\";b:0;s:8:\"use_ajax\";b:1;s:23:\"hide_attachment_summary\";b:1;s:16:\"hide_admin_links\";b:1;s:5:\"pager\";b:1;s:13:\"pager_options\";b:1;s:8:\"use_more\";b:1;s:15:\"use_more_always\";b:1;s:13:\"use_more_text\";b:1;s:12:\"exposed_form\";b:1;s:20:\"exposed_form_options\";b:1;s:12:\"link_display\";b:1;s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:1;s:12:\"style_plugin\";b:1;s:13:\"style_options\";b:1;s:10:\"row_plugin\";b:1;s:11:\"row_options\";b:1;s:6:\"header\";b:1;s:6:\"footer\";b:1;s:5:\"empty\";b:1;s:13:\"relationships\";b:1;s:6:\"fields\";b:1;s:5:\"sorts\";b:1;s:9:\"arguments\";b:1;s:7:\"filters\";b:1;s:13:\"filter_groups\";b:1;}s:5:\"title\";s:0:\"\";s:7:\"enabled\";b:1;s:15:\"display_comment\";s:0:\"\";s:9:\"css_class\";s:0:\"\";s:19:\"display_description\";s:0:\"\";s:8:\"use_ajax\";b:0;s:23:\"hide_attachment_summary\";b:0;s:16:\"hide_admin_links\";b:0;s:14:\"items_per_page\";i:10;s:6:\"offset\";i:0;s:9:\"use_pager\";b:0;s:8:\"use_more\";b:0;s:15:\"use_more_always\";b:0;s:13:\"use_more_text\";s:4:\"more\";s:12:\"link_display\";s:0:\"\";s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:0;s:14:\"field_language\";s:22:\"***CURRENT_LANGUAGE***\";s:27:\"field_language_add_to_query\";i:1;s:6:\"access\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"cache\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:0:{}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"full\";s:7:\"options\";a:0:{}}s:12:\"style_plugin\";s:7:\"default\";s:13:\"style_options\";a:0:{}s:10:\"row_plugin\";s:6:\"fields\";s:11:\"row_options\";a:0:{}s:13:\"exposed_block\";b:0;s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:0:{}s:13:\"relationships\";a:0:{}s:6:\"fields\";a:0:{}s:5:\"sorts\";a:0:{}s:9:\"arguments\";a:0:{}s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}s:7:\"filters\";a:0:{}s:4:\"path\";s:0:\"\";s:4:\"menu\";a:7:{s:4:\"type\";s:4:\"none\";s:5:\"title\";s:0:\"\";s:11:\"description\";s:0:\"\";s:6:\"weight\";i:0;s:4:\"name\";s:10:\"navigation\";s:7:\"context\";s:0:\"\";s:19:\"context_only_inline\";b:0;}s:11:\"tab_options\";a:5:{s:4:\"type\";s:4:\"none\";s:5:\"title\";s:0:\"\";s:11:\"description\";s:0:\"\";s:6:\"weight\";i:0;s:4:\"name\";s:10:\"navigation\";}}s:10:\"definition\";a:20:{s:5:\"title\";s:4:\"Page\";s:4:\"help\";s:54:\"Display the view as a page, with a URL and menu links.\";s:7:\"handler\";s:25:\"views_plugin_display_page\";s:5:\"theme\";s:10:\"views_view\";s:14:\"uses hook menu\";b:1;s:26:\"contextual links locations\";a:1:{i:0;s:4:\"page\";}s:8:\"use ajax\";b:1;s:9:\"use pager\";b:1;s:8:\"use more\";b:1;s:18:\"accept attachments\";b:1;s:5:\"admin\";s:4:\"Page\";s:10:\"help topic\";s:12:\"display-page\";s:6:\"module\";s:5:\"views\";s:10:\"theme path\";s:29:\"sites/all/modules/views/theme\";s:10:\"theme file\";s:9:\"theme.inc\";s:4:\"path\";s:31:\"sites/all/modules/views/plugins\";s:4:\"file\";s:29:\"views_plugin_display_page.inc\";s:6:\"parent\";s:6:\"parent\";s:4:\"name\";s:4:\"page\";s:16:\"contextual links\";a:1:{s:8:\"views_ui\";a:2:{s:11:\"parent path\";s:26:\"admin/structure/views/view\";s:19:\"argument properties\";a:1:{i:0;s:4:\"name\";}}}}s:9:\"is_plugin\";b:1;s:15:\"default_display\";R:37;}s:15:\"display_options\";a:4:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:4:\"path\";s:12:\"forum/active\";s:4:\"menu\";a:3:{s:4:\"type\";s:3:\"tab\";s:5:\"title\";s:13:\"Active topics\";s:6:\"weight\";s:1:\"1\";}s:11:\"tab_options\";a:1:{s:6:\"weight\";s:1:\"0\";}}s:8:\"db_table\";s:13:\"views_display\";s:3:\"vid\";i:0;s:2:\"id\";s:6:\"page_1\";s:13:\"display_title\";s:4:\"Page\";s:14:\"display_plugin\";s:4:\"page\";s:8:\"position\";i:0;}s:6:\"feed_1\";O:13:\"views_display\":8:{s:7:\"handler\";O:25:\"views_plugin_display_feed\":10:{s:4:\"view\";r:1;s:8:\"handlers\";a:0:{}s:8:\"extender\";a:0:{}s:7:\"display\";R:681;s:11:\"plugin_type\";s:7:\"display\";s:11:\"plugin_name\";s:4:\"feed\";s:7:\"options\";a:44:{s:8:\"defaults\";a:35:{s:6:\"access\";b:1;s:5:\"cache\";b:1;s:5:\"query\";b:1;s:5:\"title\";b:1;s:9:\"css_class\";b:1;s:19:\"display_description\";b:0;s:8:\"use_ajax\";b:1;s:23:\"hide_attachment_summary\";b:1;s:16:\"hide_admin_links\";b:1;s:5:\"pager\";b:0;s:13:\"pager_options\";b:1;s:8:\"use_more\";b:1;s:15:\"use_more_always\";b:1;s:13:\"use_more_text\";b:1;s:12:\"exposed_form\";b:1;s:20:\"exposed_form_options\";b:1;s:12:\"link_display\";b:1;s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:1;s:12:\"style_plugin\";b:0;s:13:\"style_options\";b:0;s:10:\"row_plugin\";b:0;s:11:\"row_options\";b:0;s:6:\"header\";b:1;s:6:\"footer\";b:1;s:5:\"empty\";b:1;s:13:\"relationships\";b:1;s:6:\"fields\";b:1;s:5:\"sorts\";b:1;s:9:\"arguments\";b:1;s:7:\"filters\";b:1;s:13:\"filter_groups\";b:1;s:9:\"use_pager\";b:0;s:14:\"items_per_page\";b:0;s:6:\"offset\";b:0;}s:5:\"title\";s:0:\"\";s:7:\"enabled\";b:1;s:15:\"display_comment\";s:0:\"\";s:9:\"css_class\";s:0:\"\";s:19:\"display_description\";s:0:\"\";s:8:\"use_ajax\";b:0;s:23:\"hide_attachment_summary\";b:0;s:16:\"hide_admin_links\";b:0;s:14:\"items_per_page\";i:10;s:6:\"offset\";i:0;s:9:\"use_pager\";b:0;s:8:\"use_more\";b:0;s:15:\"use_more_always\";b:0;s:13:\"use_more_text\";s:4:\"more\";s:12:\"link_display\";s:0:\"\";s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:0;s:14:\"field_language\";s:22:\"***CURRENT_LANGUAGE***\";s:27:\"field_language_add_to_query\";i:1;s:6:\"access\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"cache\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:0:{}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"some\";s:7:\"options\";a:0:{}}s:12:\"style_plugin\";s:3:\"rss\";s:13:\"style_options\";a:1:{s:11:\"description\";s:0:\"\";}s:10:\"row_plugin\";s:8:\"node_rss\";s:11:\"row_options\";a:0:{}s:13:\"exposed_block\";b:0;s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:0:{}s:13:\"relationships\";a:0:{}s:6:\"fields\";a:0:{}s:5:\"sorts\";a:0:{}s:9:\"arguments\";a:0:{}s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}s:7:\"filters\";a:0:{}s:4:\"path\";s:0:\"\";s:4:\"menu\";a:7:{s:4:\"type\";s:4:\"none\";s:5:\"title\";s:0:\"\";s:11:\"description\";s:0:\"\";s:6:\"weight\";i:0;s:4:\"name\";s:10:\"navigation\";s:7:\"context\";s:0:\"\";s:19:\"context_only_inline\";b:0;}s:11:\"tab_options\";a:5:{s:4:\"type\";s:4:\"none\";s:5:\"title\";s:0:\"\";s:11:\"description\";s:0:\"\";s:6:\"weight\";i:0;s:4:\"name\";s:10:\"navigation\";}s:8:\"displays\";a:0:{}s:14:\"sitename_title\";b:0;}s:10:\"definition\";a:17:{s:5:\"title\";s:4:\"Feed\";s:4:\"help\";s:48:\"Display the view as a feed, such as an RSS feed.\";s:7:\"handler\";s:25:\"views_plugin_display_feed\";s:14:\"uses hook menu\";b:1;s:8:\"use ajax\";b:0;s:9:\"use pager\";b:0;s:18:\"accept attachments\";b:0;s:5:\"admin\";s:4:\"Feed\";s:10:\"help topic\";s:12:\"display-feed\";s:6:\"module\";s:5:\"views\";s:10:\"theme path\";s:29:\"sites/all/modules/views/theme\";s:10:\"theme file\";s:9:\"theme.inc\";s:4:\"path\";s:31:\"sites/all/modules/views/plugins\";s:4:\"file\";s:29:\"views_plugin_display_feed.inc\";s:6:\"parent\";s:6:\"parent\";s:4:\"name\";s:4:\"feed\";s:16:\"contextual links\";a:1:{s:8:\"views_ui\";a:2:{s:11:\"parent path\";s:26:\"admin/structure/views/view\";s:19:\"argument properties\";a:1:{i:0;s:4:\"name\";}}}}s:9:\"is_plugin\";b:1;s:15:\"default_display\";R:37;}s:15:\"display_options\";a:8:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:8:\"defaults\";a:1:{s:12:\"link_display\";b:0;}s:12:\"link_display\";s:6:\"feed_1\";s:5:\"pager\";a:1:{s:4:\"type\";s:4:\"some\";}s:12:\"style_plugin\";s:3:\"rss\";s:10:\"row_plugin\";s:8:\"node_rss\";s:4:\"path\";s:17:\"forum/active/feed\";s:8:\"displays\";a:2:{s:6:\"page_1\";s:6:\"page_1\";s:7:\"default\";i:0;}}s:8:\"db_table\";s:13:\"views_display\";s:3:\"vid\";i:0;s:2:\"id\";s:6:\"feed_1\";s:13:\"display_title\";s:4:\"Feed\";s:14:\"display_plugin\";s:4:\"feed\";s:8:\"position\";i:0;}}s:12:\"style_plugin\";N;s:13:\"style_options\";N;s:9:\"row_index\";N;s:12:\"override_url\";N;s:13:\"override_path\";N;s:13:\"base_database\";N;s:5:\"field\";N;s:8:\"argument\";N;s:4:\"sort\";N;s:6:\"filter\";N;s:12:\"relationship\";N;s:6:\"header\";N;s:6:\"footer\";N;s:5:\"empty\";N;s:13:\"export_module\";s:14:\"advanced_forum\";}',0,1512620340,1),('ctools_export:views_view:advanced_forum_new_topics','O:4:\"view\":49:{s:8:\"db_table\";s:10:\"views_view\";s:10:\"base_table\";s:4:\"node\";s:10:\"base_field\";s:3:\"nid\";s:4:\"name\";s:25:\"advanced_forum_new_topics\";s:3:\"vid\";s:0:\"\";s:11:\"description\";s:63:\"Shows the new or update topics in a given forum (or all forums)\";s:3:\"tag\";s:14:\"Advanced Forum\";s:10:\"human_name\";s:25:\"Advanced Forum new topics\";s:4:\"core\";i:7;s:11:\"api_version\";s:3:\"3.0\";s:8:\"disabled\";b:0;s:5:\"built\";b:0;s:8:\"executed\";b:0;s:7:\"editing\";b:0;s:4:\"args\";a:0:{}s:10:\"build_info\";a:0:{}s:8:\"use_ajax\";b:0;s:6:\"result\";a:0:{}s:12:\"current_page\";N;s:14:\"items_per_page\";N;s:6:\"offset\";N;s:10:\"total_rows\";N;s:17:\"attachment_before\";s:0:\"\";s:16:\"attachment_after\";s:0:\"\";s:12:\"exposed_data\";a:0:{}s:13:\"exposed_input\";a:0:{}s:17:\"exposed_raw_input\";a:0:{}s:8:\"old_view\";a:0:{}s:12:\"parent_views\";a:0:{}s:13:\"is_attachment\";N;s:15:\"current_display\";N;s:5:\"query\";N;s:15:\"display_handler\";N;s:7:\"display\";a:2:{s:7:\"default\";O:13:\"views_display\":8:{s:7:\"handler\";O:28:\"views_plugin_display_default\":9:{s:4:\"view\";r:1;s:8:\"handlers\";a:0:{}s:8:\"extender\";a:0:{}s:7:\"display\";R:36;s:11:\"plugin_type\";s:7:\"display\";s:11:\"plugin_name\";s:7:\"default\";s:7:\"options\";a:38:{s:5:\"title\";s:0:\"\";s:7:\"enabled\";b:1;s:15:\"display_comment\";s:0:\"\";s:9:\"css_class\";s:0:\"\";s:19:\"display_description\";s:0:\"\";s:8:\"use_ajax\";b:0;s:23:\"hide_attachment_summary\";b:0;s:16:\"hide_admin_links\";b:0;s:14:\"items_per_page\";i:10;s:6:\"offset\";i:0;s:9:\"use_pager\";b:0;s:8:\"use_more\";b:0;s:15:\"use_more_always\";b:0;s:13:\"use_more_text\";s:4:\"more\";s:12:\"link_display\";s:0:\"\";s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:0;s:14:\"field_language\";s:22:\"***CURRENT_LANGUAGE***\";s:27:\"field_language_add_to_query\";i:1;s:6:\"access\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"cache\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:0:{}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"full\";s:7:\"options\";a:0:{}}s:12:\"style_plugin\";s:7:\"default\";s:13:\"style_options\";a:0:{}s:10:\"row_plugin\";s:6:\"fields\";s:11:\"row_options\";a:0:{}s:13:\"exposed_block\";b:0;s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:0:{}s:13:\"relationships\";a:0:{}s:6:\"fields\";a:0:{}s:5:\"sorts\";a:0:{}s:9:\"arguments\";a:0:{}s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}s:7:\"filters\";a:0:{}}s:10:\"definition\";a:20:{s:5:\"title\";s:6:\"Master\";s:4:\"help\";s:31:\"Default settings for this view.\";s:7:\"handler\";s:28:\"views_plugin_display_default\";s:5:\"theme\";s:10:\"views_view\";s:5:\"no ui\";b:1;s:9:\"no remove\";b:1;s:2:\"js\";a:6:{i:0;s:12:\"misc/form.js\";i:1;s:16:\"misc/collapse.js\";i:2;s:16:\"misc/textarea.js\";i:3;s:17:\"misc/tabledrag.js\";i:4;s:20:\"misc/autocomplete.js\";i:5;s:40:\"sites/all/modules/ctools/js/dependent.js\";}s:8:\"use ajax\";b:1;s:9:\"use pager\";b:1;s:8:\"use more\";b:1;s:18:\"accept attachments\";b:1;s:10:\"help topic\";s:15:\"display-default\";s:6:\"module\";s:5:\"views\";s:10:\"theme path\";s:29:\"sites/all/modules/views/theme\";s:10:\"theme file\";s:9:\"theme.inc\";s:4:\"path\";s:31:\"sites/all/modules/views/plugins\";s:4:\"file\";s:32:\"views_plugin_display_default.inc\";s:6:\"parent\";s:6:\"parent\";s:4:\"name\";s:7:\"default\";s:16:\"contextual links\";a:1:{s:8:\"views_ui\";a:2:{s:11:\"parent path\";s:26:\"admin/structure/views/view\";s:19:\"argument properties\";a:1:{i:0;s:4:\"name\";}}}}s:9:\"is_plugin\";b:1;}s:15:\"display_options\";a:13:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:2:{s:8:\"distinct\";b:1;s:13:\"query_comment\";b:0;}}s:5:\"title\";s:33:\"Topics with new and updated posts\";s:6:\"access\";a:2:{s:4:\"type\";s:4:\"role\";s:4:\"role\";a:1:{i:2;i:2;}}s:5:\"cache\";a:1:{s:4:\"type\";s:4:\"none\";}s:12:\"exposed_form\";a:1:{s:4:\"type\";s:5:\"basic\";}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"full\";s:7:\"options\";a:1:{s:14:\"items_per_page\";i:20;}}s:12:\"style_plugin\";s:16:\"forum_topic_list\";s:13:\"style_options\";a:7:{s:7:\"columns\";a:14:{s:10:\"topic_icon\";s:10:\"topic_icon\";s:5:\"title\";s:5:\"title\";s:9:\"timestamp\";s:5:\"title\";s:11:\"topic_pager\";s:5:\"title\";s:6:\"name_1\";s:5:\"title\";s:7:\"created\";s:5:\"title\";s:13:\"comment_count\";s:13:\"comment_count\";s:12:\"new_comments\";s:13:\"comment_count\";s:10:\"totalcount\";s:10:\"totalcount\";s:17:\"last_comment_name\";s:12:\"last_updated\";s:12:\"last_updated\";s:12:\"last_updated\";s:6:\"sticky\";s:6:\"sticky\";s:6:\"teaser\";s:6:\"teaser\";s:7:\"comment\";s:7:\"comment\";}s:7:\"default\";s:12:\"last_updated\";s:4:\"info\";a:15:{s:10:\"topic_icon\";a:1:{s:9:\"separator\";s:0:\"\";}s:5:\"title\";a:2:{s:8:\"sortable\";i:1;s:9:\"separator\";s:1:\" \";}s:4:\"name\";a:2:{s:8:\"sortable\";i:1;s:9:\"separator\";s:0:\"\";}s:9:\"timestamp\";a:1:{s:9:\"separator\";s:0:\"\";}s:11:\"topic_pager\";a:1:{s:9:\"separator\";s:0:\"\";}s:6:\"name_1\";a:2:{s:8:\"sortable\";i:0;s:9:\"separator\";s:0:\"\";}s:7:\"created\";a:2:{s:8:\"sortable\";i:0;s:9:\"separator\";s:0:\"\";}s:13:\"comment_count\";a:2:{s:8:\"sortable\";i:1;s:9:\"separator\";s:6:\"<br />\";}s:12:\"new_comments\";a:1:{s:9:\"separator\";s:0:\"\";}s:10:\"totalcount\";a:2:{s:8:\"sortable\";i:1;s:9:\"separator\";s:0:\"\";}s:17:\"last_comment_name\";a:2:{s:8:\"sortable\";i:1;s:9:\"separator\";s:6:\"<br />\";}s:12:\"last_updated\";a:2:{s:8:\"sortable\";i:1;s:9:\"separator\";s:6:\"<br />\";}s:6:\"sticky\";a:2:{s:8:\"sortable\";i:0;s:9:\"separator\";s:0:\"\";}s:6:\"teaser\";a:1:{s:9:\"separator\";s:0:\"\";}s:7:\"comment\";a:2:{s:8:\"sortable\";i:0;s:9:\"separator\";s:0:\"\";}}s:8:\"override\";i:0;s:6:\"sticky\";i:1;s:5:\"order\";s:4:\"desc\";s:3:\"tid\";s:26:\"filter.term_node_tid_depth\";}s:5:\"empty\";a:1:{s:4:\"text\";a:5:{s:2:\"id\";s:4:\"area\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:4:\"area\";s:5:\"empty\";b:0;s:7:\"content\";s:24:\"No new or updated posts.\";}}s:13:\"relationships\";a:2:{s:13:\"term_node_tid\";a:3:{s:2:\"id\";s:13:\"term_node_tid\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:13:\"term_node_tid\";}s:3:\"uid\";a:3:{s:2:\"id\";s:3:\"uid\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:3:\"uid\";}}s:6:\"fields\";a:15:{s:6:\"teaser\";a:9:{s:2:\"id\";s:6:\"teaser\";s:5:\"table\";s:15:\"field_data_body\";s:5:\"field\";s:4:\"body\";s:5:\"label\";s:6:\"Teaser\";s:7:\"exclude\";b:1;s:5:\"alter\";a:8:{s:10:\"alter_text\";i:0;s:9:\"make_link\";i:0;s:10:\"max_length\";s:3:\"200\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:10:\"strip_tags\";i:1;s:4:\"trim\";i:0;s:4:\"html\";i:0;}s:10:\"hide_empty\";i:0;s:4:\"type\";s:23:\"text_summary_or_trimmed\";s:8:\"settings\";a:1:{s:11:\"trim_length\";s:3:\"200\";}}s:10:\"topic_icon\";a:6:{s:2:\"id\";s:10:\"topic_icon\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:10:\"topic_icon\";s:5:\"label\";s:0:\"\";s:5:\"alter\";a:7:{s:10:\"alter_text\";i:0;s:9:\"make_link\";i:0;s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:4:\"html\";i:0;}s:19:\"hot_topic_threshold\";s:2:\"15\";}s:5:\"title\";a:8:{s:2:\"id\";s:5:\"title\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:5:\"title\";s:5:\"label\";s:21:\"Topic / Topic starter\";s:5:\"alter\";a:10:{s:10:\"alter_text\";i:1;s:4:\"text\";s:47:\"<span class=\"forum-topic-title\">[title]</span> \";s:9:\"make_link\";i:1;s:4:\"path\";s:10:\"node/[nid]\";s:3:\"alt\";s:8:\"[teaser]\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:4:\"html\";i:0;}s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:12:\"link_to_node\";i:1;}s:9:\"timestamp\";a:10:{s:2:\"id\";s:9:\"timestamp\";s:5:\"table\";s:7:\"history\";s:5:\"field\";s:9:\"timestamp\";s:7:\"ui_name\";s:15:\"Has new content\";s:5:\"alter\";a:9:{s:10:\"alter_text\";i:1;s:4:\"text\";s:12:\"[timestamp] \";s:9:\"make_link\";i:0;s:8:\"absolute\";i:0;s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:4:\"html\";i:0;}s:19:\"element_label_colon\";i:1;s:23:\"element_default_classes\";i:1;s:10:\"hide_empty\";i:0;s:12:\"link_to_node\";i:0;s:8:\"comments\";i:1;}s:11:\"topic_pager\";a:5:{s:2:\"id\";s:11:\"topic_pager\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:11:\"topic_pager\";s:5:\"alter\";a:7:{s:10:\"alter_text\";i:0;s:9:\"make_link\";i:0;s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:4:\"html\";i:0;}s:17:\"total_pages_shown\";s:1:\"3\";}s:6:\"name_1\";a:9:{s:2:\"id\";s:6:\"name_1\";s:5:\"table\";s:5:\"users\";s:5:\"field\";s:4:\"name\";s:12:\"relationship\";s:3:\"uid\";s:5:\"alter\";a:8:{s:10:\"alter_text\";i:1;s:4:\"text\";s:19:\"<br /> by [name_1] \";s:9:\"make_link\";i:0;s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:4:\"html\";i:0;}s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:12:\"link_to_user\";i:1;s:19:\"overwrite_anonymous\";i:0;}s:7:\"created\";a:6:{s:2:\"id\";s:7:\"created\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:7:\"created\";s:5:\"alter\";a:8:{s:10:\"alter_text\";i:1;s:4:\"text\";s:12:\"on [created]\";s:9:\"make_link\";i:0;s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:4:\"html\";i:0;}s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;}s:13:\"comment_count\";a:8:{s:2:\"id\";s:13:\"comment_count\";s:5:\"table\";s:23:\"node_comment_statistics\";s:5:\"field\";s:13:\"comment_count\";s:5:\"label\";s:7:\"Replies\";s:5:\"alter\";a:7:{s:10:\"alter_text\";i:0;s:9:\"make_link\";i:0;s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:4:\"html\";i:0;}s:5:\"empty\";s:1:\"0\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:1;}s:12:\"new_comments\";a:9:{s:2:\"id\";s:12:\"new_comments\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:12:\"new_comments\";s:5:\"alter\";a:7:{s:10:\"alter_text\";i:0;s:9:\"make_link\";i:0;s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:4:\"html\";i:0;}s:10:\"hide_empty\";i:1;s:10:\"empty_zero\";i:0;s:6:\"prefix\";s:6:\" View \";s:6:\"suffix\";s:4:\" new\";s:15:\"link_to_comment\";i:1;}s:10:\"totalcount\";a:8:{s:2:\"id\";s:10:\"totalcount\";s:5:\"table\";s:12:\"node_counter\";s:5:\"field\";s:10:\"totalcount\";s:5:\"label\";s:5:\"Views\";s:5:\"alter\";a:7:{s:10:\"alter_text\";i:0;s:9:\"make_link\";i:0;s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:4:\"html\";i:0;}s:5:\"empty\";s:1:\"0\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:1;}s:17:\"last_comment_name\";a:6:{s:2:\"id\";s:17:\"last_comment_name\";s:5:\"table\";s:23:\"node_comment_statistics\";s:5:\"field\";s:17:\"last_comment_name\";s:5:\"alter\";a:8:{s:10:\"alter_text\";i:1;s:4:\"text\";s:22:\"by [last_comment_name]\";s:9:\"make_link\";i:0;s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:4:\"html\";i:0;}s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;}s:12:\"last_updated\";a:7:{s:2:\"id\";s:12:\"last_updated\";s:5:\"table\";s:23:\"node_comment_statistics\";s:5:\"field\";s:12:\"last_updated\";s:5:\"label\";s:11:\"Last update\";s:5:\"alter\";a:7:{s:10:\"alter_text\";i:0;s:9:\"make_link\";i:0;s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:4:\"html\";i:0;}s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;}s:4:\"name\";a:7:{s:2:\"id\";s:4:\"name\";s:5:\"table\";s:18:\"taxonomy_term_data\";s:5:\"field\";s:4:\"name\";s:12:\"relationship\";s:13:\"term_node_tid\";s:5:\"label\";s:5:\"Forum\";s:5:\"alter\";a:7:{s:10:\"alter_text\";i:0;s:9:\"make_link\";i:0;s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:4:\"html\";i:0;}s:16:\"link_to_taxonomy\";i:1;}s:6:\"sticky\";a:6:{s:2:\"id\";s:6:\"sticky\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:6:\"sticky\";s:7:\"exclude\";b:1;s:5:\"alter\";a:7:{s:10:\"alter_text\";i:0;s:9:\"make_link\";i:0;s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:4:\"html\";i:0;}s:3:\"not\";i:0;}s:7:\"comment\";a:5:{s:2:\"id\";s:7:\"comment\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:7:\"comment\";s:7:\"exclude\";b:1;s:5:\"alter\";a:7:{s:10:\"alter_text\";i:0;s:9:\"make_link\";i:0;s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:4:\"html\";i:0;}}}s:5:\"sorts\";a:2:{s:6:\"sticky\";a:4:{s:2:\"id\";s:6:\"sticky\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:6:\"sticky\";s:5:\"order\";s:4:\"DESC\";}s:12:\"last_updated\";a:4:{s:2:\"id\";s:12:\"last_updated\";s:5:\"table\";s:23:\"node_comment_statistics\";s:5:\"field\";s:12:\"last_updated\";s:5:\"order\";s:4:\"DESC\";}}s:7:\"filters\";a:4:{s:6:\"status\";a:5:{s:2:\"id\";s:6:\"status\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:6:\"status\";s:5:\"value\";s:1:\"1\";s:6:\"expose\";a:1:{s:8:\"operator\";b:0;}}s:9:\"timestamp\";a:4:{s:2:\"id\";s:9:\"timestamp\";s:5:\"table\";s:7:\"history\";s:5:\"field\";s:9:\"timestamp\";s:6:\"expose\";a:1:{s:8:\"operator\";b:0;}}s:3:\"vid\";a:6:{s:2:\"id\";s:3:\"vid\";s:5:\"table\";s:18:\"taxonomy_term_data\";s:5:\"field\";s:3:\"vid\";s:12:\"relationship\";s:13:\"term_node_tid\";s:5:\"value\";a:1:{i:2;s:1:\"2\";}s:6:\"expose\";a:1:{s:8:\"operator\";b:0;}}s:19:\"term_node_tid_depth\";a:11:{s:2:\"id\";s:19:\"term_node_tid_depth\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:19:\"term_node_tid_depth\";s:7:\"exposed\";b:1;s:6:\"expose\";a:6:{s:11:\"operator_id\";s:22:\"term_node_tid_depth_op\";s:5:\"label\";s:29:\"Show new & updated topics in:\";s:8:\"operator\";s:22:\"term_node_tid_depth_op\";s:10:\"identifier\";s:5:\"forum\";s:8:\"remember\";i:1;s:6:\"reduce\";i:0;}s:17:\"reduce_duplicates\";i:0;s:4:\"type\";s:6:\"select\";s:10:\"vocabulary\";s:6:\"forums\";s:9:\"hierarchy\";i:1;s:13:\"error_message\";i:1;s:5:\"depth\";s:1:\"2\";}}}s:8:\"db_table\";s:13:\"views_display\";s:3:\"vid\";i:0;s:2:\"id\";s:7:\"default\";s:13:\"display_title\";s:8:\"Defaults\";s:14:\"display_plugin\";s:7:\"default\";s:8:\"position\";i:0;}s:6:\"page_1\";O:13:\"views_display\":8:{s:7:\"handler\";O:25:\"views_plugin_display_page\":10:{s:4:\"view\";r:1;s:8:\"handlers\";a:0:{}s:8:\"extender\";a:0:{}s:7:\"display\";R:521;s:11:\"plugin_type\";s:7:\"display\";s:11:\"plugin_name\";s:4:\"page\";s:7:\"options\";a:42:{s:8:\"defaults\";a:32:{s:6:\"access\";b:1;s:5:\"cache\";b:1;s:5:\"query\";b:1;s:5:\"title\";b:1;s:9:\"css_class\";b:1;s:19:\"display_description\";b:0;s:8:\"use_ajax\";b:1;s:23:\"hide_attachment_summary\";b:1;s:16:\"hide_admin_links\";b:1;s:5:\"pager\";b:1;s:13:\"pager_options\";b:1;s:8:\"use_more\";b:1;s:15:\"use_more_always\";b:1;s:13:\"use_more_text\";b:1;s:12:\"exposed_form\";b:1;s:20:\"exposed_form_options\";b:1;s:12:\"link_display\";b:1;s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:1;s:12:\"style_plugin\";b:1;s:13:\"style_options\";b:1;s:10:\"row_plugin\";b:1;s:11:\"row_options\";b:1;s:6:\"header\";b:1;s:6:\"footer\";b:1;s:5:\"empty\";b:1;s:13:\"relationships\";b:1;s:6:\"fields\";b:1;s:5:\"sorts\";b:1;s:9:\"arguments\";b:1;s:7:\"filters\";b:1;s:13:\"filter_groups\";b:1;}s:5:\"title\";s:0:\"\";s:7:\"enabled\";b:1;s:15:\"display_comment\";s:0:\"\";s:9:\"css_class\";s:0:\"\";s:19:\"display_description\";s:0:\"\";s:8:\"use_ajax\";b:0;s:23:\"hide_attachment_summary\";b:0;s:16:\"hide_admin_links\";b:0;s:14:\"items_per_page\";i:10;s:6:\"offset\";i:0;s:9:\"use_pager\";b:0;s:8:\"use_more\";b:0;s:15:\"use_more_always\";b:0;s:13:\"use_more_text\";s:4:\"more\";s:12:\"link_display\";s:0:\"\";s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:0;s:14:\"field_language\";s:22:\"***CURRENT_LANGUAGE***\";s:27:\"field_language_add_to_query\";i:1;s:6:\"access\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"cache\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:0:{}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"full\";s:7:\"options\";a:0:{}}s:12:\"style_plugin\";s:7:\"default\";s:13:\"style_options\";a:0:{}s:10:\"row_plugin\";s:6:\"fields\";s:11:\"row_options\";a:0:{}s:13:\"exposed_block\";b:0;s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:0:{}s:13:\"relationships\";a:0:{}s:6:\"fields\";a:0:{}s:5:\"sorts\";a:0:{}s:9:\"arguments\";a:0:{}s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}s:7:\"filters\";a:0:{}s:4:\"path\";s:0:\"\";s:4:\"menu\";a:7:{s:4:\"type\";s:4:\"none\";s:5:\"title\";s:0:\"\";s:11:\"description\";s:0:\"\";s:6:\"weight\";i:0;s:4:\"name\";s:10:\"navigation\";s:7:\"context\";s:0:\"\";s:19:\"context_only_inline\";b:0;}s:11:\"tab_options\";a:5:{s:4:\"type\";s:4:\"none\";s:5:\"title\";s:0:\"\";s:11:\"description\";s:0:\"\";s:6:\"weight\";i:0;s:4:\"name\";s:10:\"navigation\";}}s:10:\"definition\";a:20:{s:5:\"title\";s:4:\"Page\";s:4:\"help\";s:54:\"Display the view as a page, with a URL and menu links.\";s:7:\"handler\";s:25:\"views_plugin_display_page\";s:5:\"theme\";s:10:\"views_view\";s:14:\"uses hook menu\";b:1;s:26:\"contextual links locations\";a:1:{i:0;s:4:\"page\";}s:8:\"use ajax\";b:1;s:9:\"use pager\";b:1;s:8:\"use more\";b:1;s:18:\"accept attachments\";b:1;s:5:\"admin\";s:4:\"Page\";s:10:\"help topic\";s:12:\"display-page\";s:6:\"module\";s:5:\"views\";s:10:\"theme path\";s:29:\"sites/all/modules/views/theme\";s:10:\"theme file\";s:9:\"theme.inc\";s:4:\"path\";s:31:\"sites/all/modules/views/plugins\";s:4:\"file\";s:29:\"views_plugin_display_page.inc\";s:6:\"parent\";s:6:\"parent\";s:4:\"name\";s:4:\"page\";s:16:\"contextual links\";a:1:{s:8:\"views_ui\";a:2:{s:11:\"parent path\";s:26:\"admin/structure/views/view\";s:19:\"argument properties\";a:1:{i:0;s:4:\"name\";}}}}s:9:\"is_plugin\";b:1;s:15:\"default_display\";R:37;}s:15:\"display_options\";a:3:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:4:\"path\";s:9:\"forum/new\";s:4:\"menu\";a:3:{s:4:\"type\";s:3:\"tab\";s:5:\"title\";s:20:\"New & updated topics\";s:6:\"weight\";s:1:\"2\";}}s:8:\"db_table\";s:13:\"views_display\";s:3:\"vid\";i:0;s:2:\"id\";s:6:\"page_1\";s:13:\"display_title\";s:4:\"Page\";s:14:\"display_plugin\";s:4:\"page\";s:8:\"position\";i:0;}}s:12:\"style_plugin\";N;s:13:\"style_options\";N;s:9:\"row_index\";N;s:12:\"override_url\";N;s:13:\"override_path\";N;s:13:\"base_database\";N;s:5:\"field\";N;s:8:\"argument\";N;s:4:\"sort\";N;s:6:\"filter\";N;s:12:\"relationship\";N;s:6:\"header\";N;s:6:\"footer\";N;s:5:\"empty\";N;s:13:\"export_module\";s:14:\"advanced_forum\";}',0,1512620340,1),('ctools_export:views_view:advanced_forum_search','O:4:\"view\":49:{s:8:\"db_table\";s:10:\"views_view\";s:10:\"base_table\";s:4:\"node\";s:10:\"base_field\";s:3:\"nid\";s:4:\"name\";s:21:\"advanced_forum_search\";s:3:\"vid\";s:0:\"\";s:11:\"description\";s:0:\"\";s:3:\"tag\";s:7:\"default\";s:10:\"human_name\";s:21:\"Advanced Forum Search\";s:4:\"core\";i:7;s:11:\"api_version\";s:3:\"3.0\";s:8:\"disabled\";b:0;s:5:\"built\";b:0;s:8:\"executed\";b:0;s:7:\"editing\";b:0;s:4:\"args\";a:0:{}s:10:\"build_info\";a:0:{}s:8:\"use_ajax\";b:0;s:6:\"result\";a:0:{}s:12:\"current_page\";N;s:14:\"items_per_page\";N;s:6:\"offset\";N;s:10:\"total_rows\";N;s:17:\"attachment_before\";s:0:\"\";s:16:\"attachment_after\";s:0:\"\";s:12:\"exposed_data\";a:0:{}s:13:\"exposed_input\";a:0:{}s:17:\"exposed_raw_input\";a:0:{}s:8:\"old_view\";a:0:{}s:12:\"parent_views\";a:0:{}s:13:\"is_attachment\";N;s:15:\"current_display\";N;s:5:\"query\";N;s:15:\"display_handler\";N;s:7:\"display\";a:2:{s:7:\"default\";O:13:\"views_display\":8:{s:7:\"handler\";O:28:\"views_plugin_display_default\":9:{s:4:\"view\";r:1;s:8:\"handlers\";a:0:{}s:8:\"extender\";a:0:{}s:7:\"display\";R:36;s:11:\"plugin_type\";s:7:\"display\";s:11:\"plugin_name\";s:7:\"default\";s:7:\"options\";a:38:{s:5:\"title\";s:0:\"\";s:7:\"enabled\";b:1;s:15:\"display_comment\";s:0:\"\";s:9:\"css_class\";s:0:\"\";s:19:\"display_description\";s:0:\"\";s:8:\"use_ajax\";b:0;s:23:\"hide_attachment_summary\";b:0;s:16:\"hide_admin_links\";b:0;s:14:\"items_per_page\";i:10;s:6:\"offset\";i:0;s:9:\"use_pager\";b:0;s:8:\"use_more\";b:0;s:15:\"use_more_always\";b:0;s:13:\"use_more_text\";s:4:\"more\";s:12:\"link_display\";s:0:\"\";s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:0;s:14:\"field_language\";s:22:\"***CURRENT_LANGUAGE***\";s:27:\"field_language_add_to_query\";i:1;s:6:\"access\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"cache\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:0:{}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"full\";s:7:\"options\";a:0:{}}s:12:\"style_plugin\";s:7:\"default\";s:13:\"style_options\";a:0:{}s:10:\"row_plugin\";s:6:\"fields\";s:11:\"row_options\";a:0:{}s:13:\"exposed_block\";b:0;s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:0:{}s:13:\"relationships\";a:0:{}s:6:\"fields\";a:0:{}s:5:\"sorts\";a:0:{}s:9:\"arguments\";a:0:{}s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}s:7:\"filters\";a:0:{}}s:10:\"definition\";a:20:{s:5:\"title\";s:6:\"Master\";s:4:\"help\";s:31:\"Default settings for this view.\";s:7:\"handler\";s:28:\"views_plugin_display_default\";s:5:\"theme\";s:10:\"views_view\";s:5:\"no ui\";b:1;s:9:\"no remove\";b:1;s:2:\"js\";a:6:{i:0;s:12:\"misc/form.js\";i:1;s:16:\"misc/collapse.js\";i:2;s:16:\"misc/textarea.js\";i:3;s:17:\"misc/tabledrag.js\";i:4;s:20:\"misc/autocomplete.js\";i:5;s:40:\"sites/all/modules/ctools/js/dependent.js\";}s:8:\"use ajax\";b:1;s:9:\"use pager\";b:1;s:8:\"use more\";b:1;s:18:\"accept attachments\";b:1;s:10:\"help topic\";s:15:\"display-default\";s:6:\"module\";s:5:\"views\";s:10:\"theme path\";s:29:\"sites/all/modules/views/theme\";s:10:\"theme file\";s:9:\"theme.inc\";s:4:\"path\";s:31:\"sites/all/modules/views/plugins\";s:4:\"file\";s:32:\"views_plugin_display_default.inc\";s:6:\"parent\";s:6:\"parent\";s:4:\"name\";s:7:\"default\";s:16:\"contextual links\";a:1:{s:8:\"views_ui\";a:2:{s:11:\"parent path\";s:26:\"admin/structure/views/view\";s:19:\"argument properties\";a:1:{i:0;s:4:\"name\";}}}}s:9:\"is_plugin\";b:1;}s:15:\"display_options\";a:12:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:5:\"title\";s:21:\"Advanced Forum Search\";s:15:\"use_more_always\";b:0;s:6:\"access\";a:1:{s:4:\"type\";s:4:\"perm\";}s:5:\"cache\";a:1:{s:4:\"type\";s:4:\"none\";}s:12:\"exposed_form\";a:1:{s:4:\"type\";s:5:\"basic\";}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"full\";s:7:\"options\";a:1:{s:14:\"items_per_page\";s:2:\"25\";}}s:12:\"style_plugin\";s:7:\"default\";s:10:\"row_plugin\";s:6:\"fields\";s:6:\"fields\";a:2:{s:5:\"title\";a:5:{s:2:\"id\";s:5:\"title\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:5:\"title\";s:5:\"label\";s:0:\"\";s:5:\"alter\";a:2:{s:13:\"word_boundary\";b:0;s:8:\"ellipsis\";b:0;}}s:4:\"body\";a:7:{s:2:\"id\";s:4:\"body\";s:5:\"table\";s:15:\"field_data_body\";s:5:\"field\";s:4:\"body\";s:5:\"label\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:4:\"type\";s:23:\"text_summary_or_trimmed\";s:8:\"settings\";a:1:{s:11:\"trim_length\";s:3:\"600\";}}}s:5:\"sorts\";a:1:{s:7:\"created\";a:4:{s:2:\"id\";s:7:\"created\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:7:\"created\";s:5:\"order\";s:4:\"DESC\";}}s:7:\"filters\";a:4:{s:6:\"status\";a:6:{s:2:\"id\";s:6:\"status\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:6:\"status\";s:5:\"value\";i:1;s:5:\"group\";i:1;s:6:\"expose\";a:1:{s:8:\"operator\";b:0;}}s:4:\"keys\";a:5:{s:2:\"id\";s:4:\"keys\";s:5:\"table\";s:12:\"search_index\";s:5:\"field\";s:4:\"keys\";s:7:\"exposed\";b:1;s:6:\"expose\";a:5:{s:11:\"operator_id\";s:7:\"keys_op\";s:5:\"label\";s:12:\"Search Terms\";s:8:\"operator\";s:7:\"keys_op\";s:10:\"identifier\";s:4:\"keys\";s:14:\"remember_roles\";a:3:{i:2;s:1:\"2\";i:1;i:0;i:3;i:0;}}}s:19:\"term_node_tid_depth\";a:9:{s:2:\"id\";s:19:\"term_node_tid_depth\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:19:\"term_node_tid_depth\";s:7:\"exposed\";b:1;s:6:\"expose\";a:5:{s:11:\"operator_id\";s:22:\"term_node_tid_depth_op\";s:5:\"label\";s:31:\"Has taxonomy terms (with depth)\";s:8:\"operator\";s:22:\"term_node_tid_depth_op\";s:10:\"identifier\";s:19:\"term_node_tid_depth\";s:14:\"remember_roles\";a:3:{i:2;s:1:\"2\";i:1;i:0;i:3;i:0;}}s:4:\"type\";s:6:\"select\";s:10:\"vocabulary\";s:6:\"forums\";s:9:\"hierarchy\";i:1;s:5:\"depth\";s:1:\"0\";}s:4:\"type\";a:4:{s:2:\"id\";s:4:\"type\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:4:\"type\";s:5:\"value\";a:1:{s:5:\"forum\";s:5:\"forum\";}}}}s:8:\"db_table\";s:13:\"views_display\";s:3:\"vid\";i:0;s:2:\"id\";s:7:\"default\";s:13:\"display_title\";s:6:\"Master\";s:14:\"display_plugin\";s:7:\"default\";s:8:\"position\";i:0;}s:4:\"page\";O:13:\"views_display\":8:{s:7:\"handler\";O:25:\"views_plugin_display_page\":10:{s:4:\"view\";r:1;s:8:\"handlers\";a:0:{}s:8:\"extender\";a:0:{}s:7:\"display\";R:220;s:11:\"plugin_type\";s:7:\"display\";s:11:\"plugin_name\";s:4:\"page\";s:7:\"options\";a:42:{s:8:\"defaults\";a:32:{s:6:\"access\";b:1;s:5:\"cache\";b:1;s:5:\"query\";b:1;s:5:\"title\";b:1;s:9:\"css_class\";b:1;s:19:\"display_description\";b:0;s:8:\"use_ajax\";b:1;s:23:\"hide_attachment_summary\";b:1;s:16:\"hide_admin_links\";b:1;s:5:\"pager\";b:1;s:13:\"pager_options\";b:1;s:8:\"use_more\";b:1;s:15:\"use_more_always\";b:1;s:13:\"use_more_text\";b:1;s:12:\"exposed_form\";b:1;s:20:\"exposed_form_options\";b:1;s:12:\"link_display\";b:1;s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:1;s:12:\"style_plugin\";b:1;s:13:\"style_options\";b:1;s:10:\"row_plugin\";b:1;s:11:\"row_options\";b:1;s:6:\"header\";b:1;s:6:\"footer\";b:1;s:5:\"empty\";b:1;s:13:\"relationships\";b:1;s:6:\"fields\";b:1;s:5:\"sorts\";b:1;s:9:\"arguments\";b:1;s:7:\"filters\";b:1;s:13:\"filter_groups\";b:1;}s:5:\"title\";s:0:\"\";s:7:\"enabled\";b:1;s:15:\"display_comment\";s:0:\"\";s:9:\"css_class\";s:0:\"\";s:19:\"display_description\";s:0:\"\";s:8:\"use_ajax\";b:0;s:23:\"hide_attachment_summary\";b:0;s:16:\"hide_admin_links\";b:0;s:14:\"items_per_page\";i:10;s:6:\"offset\";i:0;s:9:\"use_pager\";b:0;s:8:\"use_more\";b:0;s:15:\"use_more_always\";b:0;s:13:\"use_more_text\";s:4:\"more\";s:12:\"link_display\";s:0:\"\";s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:0;s:14:\"field_language\";s:22:\"***CURRENT_LANGUAGE***\";s:27:\"field_language_add_to_query\";i:1;s:6:\"access\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"cache\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:0:{}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"full\";s:7:\"options\";a:0:{}}s:12:\"style_plugin\";s:7:\"default\";s:13:\"style_options\";a:0:{}s:10:\"row_plugin\";s:6:\"fields\";s:11:\"row_options\";a:0:{}s:13:\"exposed_block\";b:0;s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:0:{}s:13:\"relationships\";a:0:{}s:6:\"fields\";a:0:{}s:5:\"sorts\";a:0:{}s:9:\"arguments\";a:0:{}s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}s:7:\"filters\";a:0:{}s:4:\"path\";s:0:\"\";s:4:\"menu\";a:7:{s:4:\"type\";s:4:\"none\";s:5:\"title\";s:0:\"\";s:11:\"description\";s:0:\"\";s:6:\"weight\";i:0;s:4:\"name\";s:10:\"navigation\";s:7:\"context\";s:0:\"\";s:19:\"context_only_inline\";b:0;}s:11:\"tab_options\";a:5:{s:4:\"type\";s:4:\"none\";s:5:\"title\";s:0:\"\";s:11:\"description\";s:0:\"\";s:6:\"weight\";i:0;s:4:\"name\";s:10:\"navigation\";}}s:10:\"definition\";a:20:{s:5:\"title\";s:4:\"Page\";s:4:\"help\";s:54:\"Display the view as a page, with a URL and menu links.\";s:7:\"handler\";s:25:\"views_plugin_display_page\";s:5:\"theme\";s:10:\"views_view\";s:14:\"uses hook menu\";b:1;s:26:\"contextual links locations\";a:1:{i:0;s:4:\"page\";}s:8:\"use ajax\";b:1;s:9:\"use pager\";b:1;s:8:\"use more\";b:1;s:18:\"accept attachments\";b:1;s:5:\"admin\";s:4:\"Page\";s:10:\"help topic\";s:12:\"display-page\";s:6:\"module\";s:5:\"views\";s:10:\"theme path\";s:29:\"sites/all/modules/views/theme\";s:10:\"theme file\";s:9:\"theme.inc\";s:4:\"path\";s:31:\"sites/all/modules/views/plugins\";s:4:\"file\";s:29:\"views_plugin_display_page.inc\";s:6:\"parent\";s:6:\"parent\";s:4:\"name\";s:4:\"page\";s:16:\"contextual links\";a:1:{s:8:\"views_ui\";a:2:{s:11:\"parent path\";s:26:\"admin/structure/views/view\";s:19:\"argument properties\";a:1:{i:0;s:4:\"name\";}}}}s:9:\"is_plugin\";b:1;s:15:\"default_display\";R:37;}s:15:\"display_options\";a:2:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:4:\"path\";s:12:\"forum/search\";}s:8:\"db_table\";s:13:\"views_display\";s:3:\"vid\";i:0;s:2:\"id\";s:4:\"page\";s:13:\"display_title\";s:4:\"Page\";s:14:\"display_plugin\";s:4:\"page\";s:8:\"position\";i:0;}}s:12:\"style_plugin\";N;s:13:\"style_options\";N;s:9:\"row_index\";N;s:12:\"override_url\";N;s:13:\"override_path\";N;s:13:\"base_database\";N;s:5:\"field\";N;s:8:\"argument\";N;s:4:\"sort\";N;s:6:\"filter\";N;s:12:\"relationship\";N;s:6:\"header\";N;s:6:\"footer\";N;s:5:\"empty\";N;s:13:\"export_module\";s:14:\"advanced_forum\";}',0,1512620340,1),('ctools_export:views_view:advanced_forum_topic_list','O:4:\"view\":49:{s:8:\"db_table\";s:10:\"views_view\";s:10:\"base_table\";s:4:\"node\";s:10:\"base_field\";s:3:\"nid\";s:4:\"name\";s:25:\"advanced_forum_topic_list\";s:3:\"vid\";s:0:\"\";s:11:\"description\";s:33:\"Shows the topics in a given forum\";s:3:\"tag\";s:14:\"Advanced Forum\";s:10:\"human_name\";s:25:\"Advanced Forum topic list\";s:4:\"core\";i:7;s:11:\"api_version\";s:3:\"3.0\";s:8:\"disabled\";b:0;s:5:\"built\";b:0;s:8:\"executed\";b:0;s:7:\"editing\";b:0;s:4:\"args\";a:0:{}s:10:\"build_info\";a:0:{}s:8:\"use_ajax\";b:0;s:6:\"result\";a:0:{}s:12:\"current_page\";N;s:14:\"items_per_page\";N;s:6:\"offset\";N;s:10:\"total_rows\";N;s:17:\"attachment_before\";s:0:\"\";s:16:\"attachment_after\";s:0:\"\";s:12:\"exposed_data\";a:0:{}s:13:\"exposed_input\";a:0:{}s:17:\"exposed_raw_input\";a:0:{}s:8:\"old_view\";a:0:{}s:12:\"parent_views\";a:0:{}s:13:\"is_attachment\";N;s:15:\"current_display\";N;s:5:\"query\";N;s:15:\"display_handler\";N;s:7:\"display\";a:1:{s:7:\"default\";O:13:\"views_display\":8:{s:7:\"handler\";O:28:\"views_plugin_display_default\":9:{s:4:\"view\";r:1;s:8:\"handlers\";a:0:{}s:8:\"extender\";a:0:{}s:7:\"display\";R:36;s:11:\"plugin_type\";s:7:\"display\";s:11:\"plugin_name\";s:7:\"default\";s:7:\"options\";a:38:{s:5:\"title\";s:0:\"\";s:7:\"enabled\";b:1;s:15:\"display_comment\";s:0:\"\";s:9:\"css_class\";s:0:\"\";s:19:\"display_description\";s:0:\"\";s:8:\"use_ajax\";b:0;s:23:\"hide_attachment_summary\";b:0;s:16:\"hide_admin_links\";b:0;s:14:\"items_per_page\";i:10;s:6:\"offset\";i:0;s:9:\"use_pager\";b:0;s:8:\"use_more\";b:0;s:15:\"use_more_always\";b:0;s:13:\"use_more_text\";s:4:\"more\";s:12:\"link_display\";s:0:\"\";s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:0;s:14:\"field_language\";s:22:\"***CURRENT_LANGUAGE***\";s:27:\"field_language_add_to_query\";i:1;s:6:\"access\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"cache\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:0:{}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"full\";s:7:\"options\";a:0:{}}s:12:\"style_plugin\";s:7:\"default\";s:13:\"style_options\";a:0:{}s:10:\"row_plugin\";s:6:\"fields\";s:11:\"row_options\";a:0:{}s:13:\"exposed_block\";b:0;s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:0:{}s:13:\"relationships\";a:0:{}s:6:\"fields\";a:0:{}s:5:\"sorts\";a:0:{}s:9:\"arguments\";a:0:{}s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}s:7:\"filters\";a:0:{}}s:10:\"definition\";a:20:{s:5:\"title\";s:6:\"Master\";s:4:\"help\";s:31:\"Default settings for this view.\";s:7:\"handler\";s:28:\"views_plugin_display_default\";s:5:\"theme\";s:10:\"views_view\";s:5:\"no ui\";b:1;s:9:\"no remove\";b:1;s:2:\"js\";a:6:{i:0;s:12:\"misc/form.js\";i:1;s:16:\"misc/collapse.js\";i:2;s:16:\"misc/textarea.js\";i:3;s:17:\"misc/tabledrag.js\";i:4;s:20:\"misc/autocomplete.js\";i:5;s:40:\"sites/all/modules/ctools/js/dependent.js\";}s:8:\"use ajax\";b:1;s:9:\"use pager\";b:1;s:8:\"use more\";b:1;s:18:\"accept attachments\";b:1;s:10:\"help topic\";s:15:\"display-default\";s:6:\"module\";s:5:\"views\";s:10:\"theme path\";s:29:\"sites/all/modules/views/theme\";s:10:\"theme file\";s:9:\"theme.inc\";s:4:\"path\";s:31:\"sites/all/modules/views/plugins\";s:4:\"file\";s:32:\"views_plugin_display_default.inc\";s:6:\"parent\";s:6:\"parent\";s:4:\"name\";s:7:\"default\";s:16:\"contextual links\";a:1:{s:8:\"views_ui\";a:2:{s:11:\"parent path\";s:26:\"admin/structure/views/view\";s:19:\"argument properties\";a:1:{i:0;s:4:\"name\";}}}}s:9:\"is_plugin\";b:1;}s:15:\"display_options\";a:14:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:1:{s:13:\"query_comment\";b:0;}}s:5:\"title\";s:10:\"Forum Name\";s:6:\"access\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"cache\";a:1:{s:4:\"type\";s:4:\"none\";}s:12:\"exposed_form\";a:1:{s:4:\"type\";s:5:\"basic\";}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"full\";s:7:\"options\";a:1:{s:14:\"items_per_page\";i:20;}}s:12:\"style_plugin\";s:16:\"forum_topic_list\";s:13:\"style_options\";a:8:{s:7:\"columns\";a:15:{s:3:\"nid\";s:3:\"nid\";s:6:\"teaser\";s:6:\"teaser\";s:10:\"topic_icon\";s:10:\"topic_icon\";s:5:\"title\";s:5:\"title\";s:9:\"timestamp\";s:5:\"title\";s:11:\"topic_pager\";s:5:\"title\";s:6:\"name_1\";s:5:\"title\";s:7:\"created\";s:5:\"title\";s:13:\"comment_count\";s:13:\"comment_count\";s:12:\"new_comments\";s:13:\"comment_count\";s:10:\"totalcount\";s:10:\"totalcount\";s:17:\"last_comment_name\";s:12:\"last_updated\";s:12:\"last_updated\";s:12:\"last_updated\";s:6:\"sticky\";s:6:\"sticky\";s:7:\"comment\";s:7:\"comment\";}s:7:\"default\";s:12:\"last_updated\";s:4:\"info\";a:15:{s:3:\"nid\";a:4:{s:8:\"sortable\";i:0;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";}s:6:\"teaser\";a:4:{s:8:\"sortable\";i:0;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";}s:10:\"topic_icon\";a:2:{s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";}s:5:\"title\";a:4:{s:8:\"sortable\";i:1;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:1:\" \";}s:9:\"timestamp\";a:2:{s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";}s:11:\"topic_pager\";a:2:{s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";}s:6:\"name_1\";a:4:{s:8:\"sortable\";i:0;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";}s:7:\"created\";a:4:{s:8:\"sortable\";i:0;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";}s:13:\"comment_count\";a:4:{s:8:\"sortable\";i:1;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:6:\"<br />\";}s:12:\"new_comments\";a:2:{s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";}s:10:\"totalcount\";a:4:{s:8:\"sortable\";i:1;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";}s:17:\"last_comment_name\";a:4:{s:8:\"sortable\";i:1;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:6:\"<br />\";}s:12:\"last_updated\";a:4:{s:8:\"sortable\";i:1;s:18:\"default_sort_order\";s:4:\"desc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:6:\"<br />\";}s:6:\"sticky\";a:4:{s:8:\"sortable\";i:0;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";}s:7:\"comment\";a:4:{s:8:\"sortable\";i:0;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";}}s:8:\"override\";i:0;s:6:\"sticky\";i:1;s:5:\"order\";s:4:\"desc\";s:11:\"empty_table\";i:0;s:3:\"tid\";s:12:\"argument.tid\";}s:5:\"empty\";a:1:{s:4:\"text\";a:6:{s:2:\"id\";s:4:\"text\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:4:\"area\";s:5:\"empty\";b:0;s:7:\"content\";s:23:\"No posts in this forum.\";s:6:\"format\";s:13:\"filtered_html\";}}s:13:\"relationships\";a:1:{s:3:\"uid\";a:3:{s:2:\"id\";s:3:\"uid\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:3:\"uid\";}}s:6:\"fields\";a:15:{s:3:\"nid\";a:6:{s:2:\"id\";s:3:\"nid\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:3:\"nid\";s:7:\"exclude\";b:1;s:5:\"alter\";a:6:{s:10:\"alter_text\";i:0;s:9:\"make_link\";i:0;s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:4:\"trim\";i:0;s:4:\"html\";i:0;}s:12:\"link_to_node\";i:0;}s:6:\"teaser\";a:9:{s:2:\"id\";s:6:\"teaser\";s:5:\"table\";s:15:\"field_data_body\";s:5:\"field\";s:4:\"body\";s:5:\"label\";s:6:\"Teaser\";s:7:\"exclude\";b:1;s:5:\"alter\";a:8:{s:10:\"alter_text\";i:0;s:9:\"make_link\";i:0;s:10:\"max_length\";s:3:\"200\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:10:\"strip_tags\";i:1;s:4:\"trim\";i:0;s:4:\"html\";i:0;}s:10:\"hide_empty\";i:0;s:4:\"type\";s:23:\"text_summary_or_trimmed\";s:8:\"settings\";a:1:{s:11:\"trim_length\";s:3:\"200\";}}s:10:\"topic_icon\";a:6:{s:2:\"id\";s:10:\"topic_icon\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:10:\"topic_icon\";s:5:\"label\";s:0:\"\";s:5:\"alter\";a:7:{s:10:\"alter_text\";i:0;s:9:\"make_link\";i:0;s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:4:\"html\";i:0;}s:19:\"hot_topic_threshold\";s:2:\"15\";}s:5:\"title\";a:8:{s:2:\"id\";s:5:\"title\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:5:\"title\";s:5:\"label\";s:21:\"Topic / Topic starter\";s:5:\"alter\";a:10:{s:10:\"alter_text\";i:1;s:4:\"text\";s:47:\"<span class=\"forum-topic-title\">[title]</span> \";s:9:\"make_link\";i:1;s:4:\"path\";s:10:\"node/[nid]\";s:3:\"alt\";s:8:\"[teaser]\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:4:\"html\";i:0;}s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:12:\"link_to_node\";i:0;}s:9:\"timestamp\";a:10:{s:2:\"id\";s:9:\"timestamp\";s:5:\"table\";s:7:\"history\";s:5:\"field\";s:9:\"timestamp\";s:7:\"ui_name\";s:15:\"Has new content\";s:5:\"alter\";a:9:{s:10:\"alter_text\";i:1;s:4:\"text\";s:12:\"[timestamp] \";s:9:\"make_link\";i:0;s:8:\"absolute\";i:0;s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:4:\"html\";i:0;}s:19:\"element_label_colon\";i:1;s:23:\"element_default_classes\";i:1;s:10:\"hide_empty\";i:0;s:12:\"link_to_node\";i:0;s:8:\"comments\";i:1;}s:11:\"topic_pager\";a:5:{s:2:\"id\";s:11:\"topic_pager\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:11:\"topic_pager\";s:5:\"alter\";a:7:{s:10:\"alter_text\";i:0;s:9:\"make_link\";i:0;s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:4:\"html\";i:0;}s:17:\"total_pages_shown\";s:1:\"3\";}s:6:\"name_1\";a:9:{s:2:\"id\";s:6:\"name_1\";s:5:\"table\";s:5:\"users\";s:5:\"field\";s:4:\"name\";s:12:\"relationship\";s:3:\"uid\";s:5:\"alter\";a:8:{s:10:\"alter_text\";i:1;s:4:\"text\";s:18:\"<br /> by [name_1]\";s:9:\"make_link\";i:0;s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:4:\"html\";i:0;}s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:12:\"link_to_user\";i:1;s:19:\"overwrite_anonymous\";i:0;}s:7:\"created\";a:6:{s:2:\"id\";s:7:\"created\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:7:\"created\";s:5:\"alter\";a:8:{s:10:\"alter_text\";i:1;s:4:\"text\";s:12:\"» [created]\";s:9:\"make_link\";i:0;s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:4:\"html\";i:0;}s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;}s:12:\"new_comments\";a:14:{s:2:\"id\";s:12:\"new_comments\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:12:\"new_comments\";s:7:\"exclude\";b:1;s:5:\"alter\";a:12:{s:10:\"alter_text\";i:0;s:9:\"make_link\";i:0;s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:15:\"trim_whitespace\";i:0;s:5:\"nl2br\";i:0;s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:4:\"html\";i:0;}s:19:\"element_label_colon\";i:1;s:23:\"element_default_classes\";i:1;s:10:\"hide_empty\";i:1;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:0;s:13:\"format_plural\";i:0;s:6:\"prefix\";s:5:\"View \";s:6:\"suffix\";s:4:\" new\";s:15:\"link_to_comment\";i:1;}s:13:\"comment_count\";a:12:{s:2:\"id\";s:13:\"comment_count\";s:5:\"table\";s:23:\"node_comment_statistics\";s:5:\"field\";s:13:\"comment_count\";s:5:\"label\";s:7:\"Replies\";s:5:\"alter\";a:13:{s:10:\"alter_text\";i:1;s:4:\"text\";s:36:\"[comment_count]<br />[new_comments] \";s:9:\"make_link\";i:0;s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:15:\"trim_whitespace\";i:0;s:5:\"nl2br\";i:0;s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:4:\"html\";i:0;}s:19:\"element_label_colon\";i:1;s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:1:\"0\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:1;s:16:\"hide_alter_empty\";i:0;s:13:\"format_plural\";i:0;}s:10:\"totalcount\";a:8:{s:2:\"id\";s:10:\"totalcount\";s:5:\"table\";s:12:\"node_counter\";s:5:\"field\";s:10:\"totalcount\";s:5:\"label\";s:5:\"Views\";s:5:\"alter\";a:7:{s:10:\"alter_text\";i:0;s:9:\"make_link\";i:0;s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:4:\"html\";i:0;}s:5:\"empty\";s:1:\"0\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:1;}s:17:\"last_comment_name\";a:6:{s:2:\"id\";s:17:\"last_comment_name\";s:5:\"table\";s:23:\"node_comment_statistics\";s:5:\"field\";s:17:\"last_comment_name\";s:5:\"alter\";a:8:{s:10:\"alter_text\";i:1;s:4:\"text\";s:22:\"by [last_comment_name]\";s:9:\"make_link\";i:0;s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:4:\"html\";i:0;}s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;}s:12:\"last_updated\";a:7:{s:2:\"id\";s:12:\"last_updated\";s:5:\"table\";s:23:\"node_comment_statistics\";s:5:\"field\";s:12:\"last_updated\";s:5:\"label\";s:9:\"Last post\";s:5:\"alter\";a:7:{s:10:\"alter_text\";i:0;s:9:\"make_link\";i:0;s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:4:\"html\";i:0;}s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;}s:6:\"sticky\";a:6:{s:2:\"id\";s:6:\"sticky\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:6:\"sticky\";s:7:\"exclude\";b:1;s:5:\"alter\";a:7:{s:10:\"alter_text\";i:0;s:9:\"make_link\";i:0;s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:4:\"html\";i:0;}s:3:\"not\";i:0;}s:7:\"comment\";a:5:{s:2:\"id\";s:7:\"comment\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:7:\"comment\";s:7:\"exclude\";b:1;s:5:\"alter\";a:7:{s:10:\"alter_text\";i:0;s:9:\"make_link\";i:0;s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:4:\"html\";i:0;}}}s:5:\"sorts\";a:1:{s:6:\"sticky\";a:4:{s:2:\"id\";s:6:\"sticky\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:6:\"sticky\";s:5:\"order\";s:4:\"DESC\";}}s:9:\"arguments\";a:1:{s:3:\"tid\";a:10:{s:2:\"id\";s:3:\"tid\";s:5:\"table\";s:14:\"taxonomy_index\";s:5:\"field\";s:3:\"tid\";s:21:\"default_argument_type\";s:5:\"fixed\";s:7:\"summary\";a:1:{s:6:\"format\";s:15:\"default_summary\";}s:12:\"break_phrase\";i:0;s:9:\"add_table\";i:0;s:13:\"require_value\";i:0;s:17:\"reduce_duplicates\";i:0;s:14:\"set_breadcrumb\";i:0;}}s:7:\"filters\";a:1:{s:6:\"status\";a:5:{s:2:\"id\";s:6:\"status\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:6:\"status\";s:5:\"value\";s:1:\"1\";s:6:\"expose\";a:1:{s:8:\"operator\";b:0;}}}}s:8:\"db_table\";s:13:\"views_display\";s:3:\"vid\";i:0;s:2:\"id\";s:7:\"default\";s:13:\"display_title\";s:8:\"Defaults\";s:14:\"display_plugin\";s:7:\"default\";s:8:\"position\";i:0;}}s:12:\"style_plugin\";N;s:13:\"style_options\";N;s:9:\"row_index\";N;s:12:\"override_url\";N;s:13:\"override_path\";N;s:13:\"base_database\";N;s:5:\"field\";N;s:8:\"argument\";N;s:4:\"sort\";N;s:6:\"filter\";N;s:12:\"relationship\";N;s:6:\"header\";N;s:6:\"footer\";N;s:5:\"empty\";N;s:13:\"export_module\";s:14:\"advanced_forum\";}',0,1512620340,1),('ctools_export:views_view:advanced_forum_unanswered_topics','O:4:\"view\":49:{s:8:\"db_table\";s:10:\"views_view\";s:10:\"base_table\";s:4:\"node\";s:10:\"base_field\";s:3:\"nid\";s:4:\"name\";s:32:\"advanced_forum_unanswered_topics\";s:3:\"vid\";s:0:\"\";s:11:\"description\";s:40:\"Shows unanswered topics in a given forum\";s:3:\"tag\";s:14:\"Advanced Forum\";s:10:\"human_name\";s:32:\"Advanced Forum unanswered topics\";s:4:\"core\";i:7;s:11:\"api_version\";s:3:\"3.0\";s:8:\"disabled\";b:0;s:5:\"built\";b:0;s:8:\"executed\";b:0;s:7:\"editing\";b:0;s:4:\"args\";a:0:{}s:10:\"build_info\";a:0:{}s:8:\"use_ajax\";b:0;s:6:\"result\";a:0:{}s:12:\"current_page\";N;s:14:\"items_per_page\";N;s:6:\"offset\";N;s:10:\"total_rows\";N;s:17:\"attachment_before\";s:0:\"\";s:16:\"attachment_after\";s:0:\"\";s:12:\"exposed_data\";a:0:{}s:13:\"exposed_input\";a:0:{}s:17:\"exposed_raw_input\";a:0:{}s:8:\"old_view\";a:0:{}s:12:\"parent_views\";a:0:{}s:13:\"is_attachment\";N;s:15:\"current_display\";N;s:5:\"query\";N;s:15:\"display_handler\";N;s:7:\"display\";a:3:{s:7:\"default\";O:13:\"views_display\":8:{s:7:\"handler\";O:28:\"views_plugin_display_default\":9:{s:4:\"view\";r:1;s:8:\"handlers\";a:0:{}s:8:\"extender\";a:0:{}s:7:\"display\";R:36;s:11:\"plugin_type\";s:7:\"display\";s:11:\"plugin_name\";s:7:\"default\";s:7:\"options\";a:38:{s:5:\"title\";s:0:\"\";s:7:\"enabled\";b:1;s:15:\"display_comment\";s:0:\"\";s:9:\"css_class\";s:0:\"\";s:19:\"display_description\";s:0:\"\";s:8:\"use_ajax\";b:0;s:23:\"hide_attachment_summary\";b:0;s:16:\"hide_admin_links\";b:0;s:14:\"items_per_page\";i:10;s:6:\"offset\";i:0;s:9:\"use_pager\";b:0;s:8:\"use_more\";b:0;s:15:\"use_more_always\";b:0;s:13:\"use_more_text\";s:4:\"more\";s:12:\"link_display\";s:0:\"\";s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:0;s:14:\"field_language\";s:22:\"***CURRENT_LANGUAGE***\";s:27:\"field_language_add_to_query\";i:1;s:6:\"access\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"cache\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:0:{}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"full\";s:7:\"options\";a:0:{}}s:12:\"style_plugin\";s:7:\"default\";s:13:\"style_options\";a:0:{}s:10:\"row_plugin\";s:6:\"fields\";s:11:\"row_options\";a:0:{}s:13:\"exposed_block\";b:0;s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:0:{}s:13:\"relationships\";a:0:{}s:6:\"fields\";a:0:{}s:5:\"sorts\";a:0:{}s:9:\"arguments\";a:0:{}s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}s:7:\"filters\";a:0:{}}s:10:\"definition\";a:20:{s:5:\"title\";s:6:\"Master\";s:4:\"help\";s:31:\"Default settings for this view.\";s:7:\"handler\";s:28:\"views_plugin_display_default\";s:5:\"theme\";s:10:\"views_view\";s:5:\"no ui\";b:1;s:9:\"no remove\";b:1;s:2:\"js\";a:6:{i:0;s:12:\"misc/form.js\";i:1;s:16:\"misc/collapse.js\";i:2;s:16:\"misc/textarea.js\";i:3;s:17:\"misc/tabledrag.js\";i:4;s:20:\"misc/autocomplete.js\";i:5;s:40:\"sites/all/modules/ctools/js/dependent.js\";}s:8:\"use ajax\";b:1;s:9:\"use pager\";b:1;s:8:\"use more\";b:1;s:18:\"accept attachments\";b:1;s:10:\"help topic\";s:15:\"display-default\";s:6:\"module\";s:5:\"views\";s:10:\"theme path\";s:29:\"sites/all/modules/views/theme\";s:10:\"theme file\";s:9:\"theme.inc\";s:4:\"path\";s:31:\"sites/all/modules/views/plugins\";s:4:\"file\";s:32:\"views_plugin_display_default.inc\";s:6:\"parent\";s:6:\"parent\";s:4:\"name\";s:7:\"default\";s:16:\"contextual links\";a:1:{s:8:\"views_ui\";a:2:{s:11:\"parent path\";s:26:\"admin/structure/views/view\";s:19:\"argument properties\";a:1:{i:0;s:4:\"name\";}}}}s:9:\"is_plugin\";b:1;}s:15:\"display_options\";a:13:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:2:{s:8:\"distinct\";b:1;s:13:\"query_comment\";b:0;}}s:5:\"title\";s:23:\"Unanswered forum topics\";s:6:\"access\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"cache\";a:1:{s:4:\"type\";s:4:\"none\";}s:12:\"exposed_form\";a:1:{s:4:\"type\";s:5:\"basic\";}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"full\";s:7:\"options\";a:1:{s:14:\"items_per_page\";i:20;}}s:12:\"style_plugin\";s:16:\"forum_topic_list\";s:13:\"style_options\";a:8:{s:7:\"columns\";a:15:{s:3:\"nid\";s:3:\"nid\";s:6:\"teaser\";s:6:\"teaser\";s:10:\"topic_icon\";s:10:\"topic_icon\";s:5:\"title\";s:5:\"title\";s:9:\"timestamp\";s:5:\"title\";s:11:\"topic_pager\";s:5:\"title\";s:6:\"name_1\";s:5:\"title\";s:7:\"created\";s:5:\"title\";s:12:\"new_comments\";s:12:\"new_comments\";s:10:\"totalcount\";s:10:\"totalcount\";s:17:\"last_comment_name\";s:12:\"last_updated\";s:12:\"last_updated\";s:12:\"last_updated\";s:6:\"sticky\";s:6:\"sticky\";s:7:\"comment\";s:7:\"comment\";s:4:\"name\";s:4:\"name\";}s:7:\"default\";s:12:\"last_updated\";s:4:\"info\";a:15:{s:3:\"nid\";a:4:{s:8:\"sortable\";i:0;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";}s:6:\"teaser\";a:4:{s:8:\"sortable\";i:0;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";}s:10:\"topic_icon\";a:2:{s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";}s:5:\"title\";a:4:{s:8:\"sortable\";i:1;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:1:\" \";}s:9:\"timestamp\";a:2:{s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";}s:11:\"topic_pager\";a:2:{s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";}s:6:\"name_1\";a:4:{s:8:\"sortable\";i:0;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";}s:7:\"created\";a:4:{s:8:\"sortable\";i:0;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";}s:12:\"new_comments\";a:2:{s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";}s:10:\"totalcount\";a:4:{s:8:\"sortable\";i:1;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";}s:17:\"last_comment_name\";a:4:{s:8:\"sortable\";i:1;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:6:\"<br />\";}s:12:\"last_updated\";a:4:{s:8:\"sortable\";i:1;s:18:\"default_sort_order\";s:4:\"desc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:6:\"<br />\";}s:6:\"sticky\";a:4:{s:8:\"sortable\";i:0;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";}s:7:\"comment\";a:4:{s:8:\"sortable\";i:0;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";}s:4:\"name\";a:4:{s:8:\"sortable\";i:1;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";}}s:8:\"override\";i:0;s:6:\"sticky\";i:1;s:5:\"order\";s:4:\"desc\";s:11:\"empty_table\";i:0;s:3:\"tid\";s:26:\"filter.term_node_tid_depth\";}s:5:\"empty\";a:1:{s:4:\"text\";a:5:{s:2:\"id\";s:4:\"area\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:4:\"area\";s:5:\"empty\";b:0;s:7:\"content\";s:21:\"No unanswered topics.\";}}s:13:\"relationships\";a:2:{s:13:\"term_node_tid\";a:3:{s:2:\"id\";s:13:\"term_node_tid\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:13:\"term_node_tid\";}s:3:\"uid\";a:3:{s:2:\"id\";s:3:\"uid\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:3:\"uid\";}}s:6:\"fields\";a:13:{s:3:\"nid\";a:8:{s:2:\"id\";s:3:\"nid\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:3:\"nid\";s:7:\"exclude\";b:1;s:5:\"alter\";a:7:{s:10:\"alter_text\";i:0;s:9:\"make_link\";i:0;s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:4:\"html\";i:0;}s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:12:\"link_to_node\";i:0;}s:6:\"teaser\";a:9:{s:2:\"id\";s:6:\"teaser\";s:5:\"table\";s:15:\"field_data_body\";s:5:\"field\";s:4:\"body\";s:5:\"label\";s:6:\"Teaser\";s:7:\"exclude\";b:1;s:5:\"alter\";a:8:{s:10:\"alter_text\";i:0;s:9:\"make_link\";i:0;s:10:\"max_length\";s:3:\"200\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:10:\"strip_tags\";i:1;s:4:\"trim\";i:0;s:4:\"html\";i:0;}s:10:\"hide_empty\";i:0;s:4:\"type\";s:23:\"text_summary_or_trimmed\";s:8:\"settings\";a:1:{s:11:\"trim_length\";s:3:\"200\";}}s:10:\"topic_icon\";a:6:{s:2:\"id\";s:10:\"topic_icon\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:10:\"topic_icon\";s:5:\"label\";s:0:\"\";s:5:\"alter\";a:7:{s:10:\"alter_text\";i:0;s:9:\"make_link\";i:0;s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:4:\"html\";i:0;}s:19:\"hot_topic_threshold\";s:2:\"15\";}s:5:\"title\";a:8:{s:2:\"id\";s:5:\"title\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:5:\"title\";s:5:\"label\";s:5:\"Topic\";s:5:\"alter\";a:11:{s:10:\"alter_text\";i:0;s:4:\"text\";s:47:\"<span class=\"forum-topic-title\">[title]</span> \";s:9:\"make_link\";i:1;s:4:\"path\";s:10:\"node/[nid]\";s:3:\"alt\";s:8:\"[teaser]\";s:10:\"link_class\";s:11:\"topic-title\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:4:\"html\";i:0;}s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:12:\"link_to_node\";i:0;}s:9:\"timestamp\";a:8:{s:2:\"id\";s:9:\"timestamp\";s:5:\"table\";s:7:\"history\";s:5:\"field\";s:9:\"timestamp\";s:5:\"alter\";a:8:{s:10:\"alter_text\";i:1;s:4:\"text\";s:12:\"[timestamp] \";s:9:\"make_link\";i:0;s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:4:\"html\";i:0;}s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:12:\"link_to_node\";i:0;s:8:\"comments\";i:1;}s:11:\"topic_pager\";a:5:{s:2:\"id\";s:11:\"topic_pager\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:11:\"topic_pager\";s:5:\"alter\";a:7:{s:10:\"alter_text\";i:0;s:9:\"make_link\";i:0;s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:4:\"html\";i:0;}s:17:\"total_pages_shown\";s:1:\"3\";}s:6:\"name_1\";a:9:{s:2:\"id\";s:6:\"name_1\";s:5:\"table\";s:5:\"users\";s:5:\"field\";s:4:\"name\";s:12:\"relationship\";s:3:\"uid\";s:5:\"alter\";a:8:{s:10:\"alter_text\";i:1;s:4:\"text\";s:19:\"<br /> by [name_1] \";s:9:\"make_link\";i:0;s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:4:\"html\";i:0;}s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:12:\"link_to_user\";i:1;s:19:\"overwrite_anonymous\";i:0;}s:7:\"created\";a:6:{s:2:\"id\";s:7:\"created\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:7:\"created\";s:5:\"alter\";a:8:{s:10:\"alter_text\";i:1;s:4:\"text\";s:12:\"on [created]\";s:9:\"make_link\";i:0;s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:4:\"html\";i:0;}s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;}s:10:\"totalcount\";a:8:{s:2:\"id\";s:10:\"totalcount\";s:5:\"table\";s:12:\"node_counter\";s:5:\"field\";s:10:\"totalcount\";s:5:\"label\";s:5:\"Views\";s:5:\"alter\";a:7:{s:10:\"alter_text\";i:0;s:9:\"make_link\";i:0;s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:4:\"html\";i:0;}s:5:\"empty\";s:1:\"0\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:1;}s:6:\"sticky\";a:6:{s:2:\"id\";s:6:\"sticky\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:6:\"sticky\";s:7:\"exclude\";b:1;s:5:\"alter\";a:7:{s:10:\"alter_text\";i:0;s:9:\"make_link\";i:0;s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:4:\"html\";i:0;}s:3:\"not\";i:0;}s:7:\"comment\";a:5:{s:2:\"id\";s:7:\"comment\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:7:\"comment\";s:7:\"exclude\";b:1;s:5:\"alter\";a:7:{s:10:\"alter_text\";i:0;s:9:\"make_link\";i:0;s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:4:\"html\";i:0;}}s:4:\"name\";a:9:{s:2:\"id\";s:4:\"name\";s:5:\"table\";s:18:\"taxonomy_term_data\";s:5:\"field\";s:4:\"name\";s:12:\"relationship\";s:13:\"term_node_tid\";s:5:\"label\";s:5:\"Forum\";s:5:\"alter\";a:7:{s:10:\"alter_text\";i:0;s:9:\"make_link\";i:0;s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:4:\"html\";i:0;}s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"link_to_taxonomy\";i:1;}s:13:\"comment_count\";a:11:{s:2:\"id\";s:13:\"comment_count\";s:5:\"table\";s:23:\"node_comment_statistics\";s:5:\"field\";s:13:\"comment_count\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:1;s:5:\"alter\";a:11:{s:10:\"alter_text\";i:0;s:9:\"make_link\";i:0;s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:5:\"nl2br\";i:0;s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:4:\"html\";i:0;}s:19:\"element_label_colon\";b:0;s:23:\"element_default_classes\";i:1;s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:1;s:13:\"format_plural\";i:0;}}s:5:\"sorts\";a:1:{s:7:\"created\";a:4:{s:2:\"id\";s:7:\"created\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:7:\"created\";s:5:\"order\";s:4:\"DESC\";}}s:7:\"filters\";a:4:{s:6:\"status\";a:5:{s:2:\"id\";s:6:\"status\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:6:\"status\";s:5:\"value\";s:1:\"1\";s:6:\"expose\";a:1:{s:8:\"operator\";b:0;}}s:3:\"vid\";a:6:{s:2:\"id\";s:3:\"vid\";s:5:\"table\";s:18:\"taxonomy_term_data\";s:5:\"field\";s:3:\"vid\";s:12:\"relationship\";s:13:\"term_node_tid\";s:5:\"value\";a:1:{i:2;s:1:\"2\";}s:6:\"expose\";a:1:{s:8:\"operator\";b:0;}}s:19:\"term_node_tid_depth\";a:10:{s:2:\"id\";s:19:\"term_node_tid_depth\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:19:\"term_node_tid_depth\";s:7:\"exposed\";b:1;s:6:\"expose\";a:7:{s:11:\"operator_id\";s:22:\"term_node_tid_depth_op\";s:5:\"label\";s:26:\"Show unanswered topics in:\";s:12:\"use_operator\";b:0;s:8:\"operator\";s:22:\"term_node_tid_depth_op\";s:10:\"identifier\";s:5:\"forum\";s:8:\"remember\";i:1;s:6:\"reduce\";i:0;}s:17:\"reduce_duplicates\";i:0;s:4:\"type\";s:6:\"select\";s:10:\"vocabulary\";s:6:\"forums\";s:9:\"hierarchy\";i:1;s:5:\"depth\";s:1:\"2\";}s:13:\"comment_count\";a:5:{s:2:\"id\";s:13:\"comment_count\";s:5:\"table\";s:23:\"node_comment_statistics\";s:5:\"field\";s:13:\"comment_count\";s:5:\"value\";a:1:{s:5:\"value\";s:1:\"0\";}s:6:\"expose\";a:5:{s:11:\"operator_id\";s:16:\"comment_count_op\";s:5:\"label\";s:13:\"Comment count\";s:8:\"operator\";s:16:\"comment_count_op\";s:10:\"identifier\";s:13:\"comment_count\";s:8:\"multiple\";b:0;}}}}s:8:\"db_table\";s:13:\"views_display\";s:3:\"vid\";i:0;s:2:\"id\";s:7:\"default\";s:13:\"display_title\";s:8:\"Defaults\";s:14:\"display_plugin\";s:7:\"default\";s:8:\"position\";i:0;}s:6:\"page_1\";O:13:\"views_display\":8:{s:7:\"handler\";O:25:\"views_plugin_display_page\":10:{s:4:\"view\";r:1;s:8:\"handlers\";a:0:{}s:8:\"extender\";a:0:{}s:7:\"display\";R:525;s:11:\"plugin_type\";s:7:\"display\";s:11:\"plugin_name\";s:4:\"page\";s:7:\"options\";a:42:{s:8:\"defaults\";a:32:{s:6:\"access\";b:1;s:5:\"cache\";b:1;s:5:\"query\";b:1;s:5:\"title\";b:1;s:9:\"css_class\";b:1;s:19:\"display_description\";b:0;s:8:\"use_ajax\";b:1;s:23:\"hide_attachment_summary\";b:1;s:16:\"hide_admin_links\";b:1;s:5:\"pager\";b:1;s:13:\"pager_options\";b:1;s:8:\"use_more\";b:1;s:15:\"use_more_always\";b:1;s:13:\"use_more_text\";b:1;s:12:\"exposed_form\";b:1;s:20:\"exposed_form_options\";b:1;s:12:\"link_display\";b:1;s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:1;s:12:\"style_plugin\";b:1;s:13:\"style_options\";b:1;s:10:\"row_plugin\";b:1;s:11:\"row_options\";b:1;s:6:\"header\";b:1;s:6:\"footer\";b:1;s:5:\"empty\";b:1;s:13:\"relationships\";b:1;s:6:\"fields\";b:1;s:5:\"sorts\";b:1;s:9:\"arguments\";b:1;s:7:\"filters\";b:1;s:13:\"filter_groups\";b:1;}s:5:\"title\";s:0:\"\";s:7:\"enabled\";b:1;s:15:\"display_comment\";s:0:\"\";s:9:\"css_class\";s:0:\"\";s:19:\"display_description\";s:0:\"\";s:8:\"use_ajax\";b:0;s:23:\"hide_attachment_summary\";b:0;s:16:\"hide_admin_links\";b:0;s:14:\"items_per_page\";i:10;s:6:\"offset\";i:0;s:9:\"use_pager\";b:0;s:8:\"use_more\";b:0;s:15:\"use_more_always\";b:0;s:13:\"use_more_text\";s:4:\"more\";s:12:\"link_display\";s:0:\"\";s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:0;s:14:\"field_language\";s:22:\"***CURRENT_LANGUAGE***\";s:27:\"field_language_add_to_query\";i:1;s:6:\"access\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"cache\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:0:{}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"full\";s:7:\"options\";a:0:{}}s:12:\"style_plugin\";s:7:\"default\";s:13:\"style_options\";a:0:{}s:10:\"row_plugin\";s:6:\"fields\";s:11:\"row_options\";a:0:{}s:13:\"exposed_block\";b:0;s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:0:{}s:13:\"relationships\";a:0:{}s:6:\"fields\";a:0:{}s:5:\"sorts\";a:0:{}s:9:\"arguments\";a:0:{}s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}s:7:\"filters\";a:0:{}s:4:\"path\";s:0:\"\";s:4:\"menu\";a:7:{s:4:\"type\";s:4:\"none\";s:5:\"title\";s:0:\"\";s:11:\"description\";s:0:\"\";s:6:\"weight\";i:0;s:4:\"name\";s:10:\"navigation\";s:7:\"context\";s:0:\"\";s:19:\"context_only_inline\";b:0;}s:11:\"tab_options\";a:5:{s:4:\"type\";s:4:\"none\";s:5:\"title\";s:0:\"\";s:11:\"description\";s:0:\"\";s:6:\"weight\";i:0;s:4:\"name\";s:10:\"navigation\";}}s:10:\"definition\";a:20:{s:5:\"title\";s:4:\"Page\";s:4:\"help\";s:54:\"Display the view as a page, with a URL and menu links.\";s:7:\"handler\";s:25:\"views_plugin_display_page\";s:5:\"theme\";s:10:\"views_view\";s:14:\"uses hook menu\";b:1;s:26:\"contextual links locations\";a:1:{i:0;s:4:\"page\";}s:8:\"use ajax\";b:1;s:9:\"use pager\";b:1;s:8:\"use more\";b:1;s:18:\"accept attachments\";b:1;s:5:\"admin\";s:4:\"Page\";s:10:\"help topic\";s:12:\"display-page\";s:6:\"module\";s:5:\"views\";s:10:\"theme path\";s:29:\"sites/all/modules/views/theme\";s:10:\"theme file\";s:9:\"theme.inc\";s:4:\"path\";s:31:\"sites/all/modules/views/plugins\";s:4:\"file\";s:29:\"views_plugin_display_page.inc\";s:6:\"parent\";s:6:\"parent\";s:4:\"name\";s:4:\"page\";s:16:\"contextual links\";a:1:{s:8:\"views_ui\";a:2:{s:11:\"parent path\";s:26:\"admin/structure/views/view\";s:19:\"argument properties\";a:1:{i:0;s:4:\"name\";}}}}s:9:\"is_plugin\";b:1;s:15:\"default_display\";R:37;}s:15:\"display_options\";a:4:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:4:\"path\";s:16:\"forum/unanswered\";s:4:\"menu\";a:3:{s:4:\"type\";s:3:\"tab\";s:5:\"title\";s:17:\"Unanswered topics\";s:6:\"weight\";s:1:\"1\";}s:11:\"tab_options\";a:1:{s:6:\"weight\";s:1:\"0\";}}s:8:\"db_table\";s:13:\"views_display\";s:3:\"vid\";i:0;s:2:\"id\";s:6:\"page_1\";s:13:\"display_title\";s:4:\"Page\";s:14:\"display_plugin\";s:4:\"page\";s:8:\"position\";i:0;}s:6:\"feed_1\";O:13:\"views_display\":8:{s:7:\"handler\";O:25:\"views_plugin_display_feed\":10:{s:4:\"view\";r:1;s:8:\"handlers\";a:0:{}s:8:\"extender\";a:0:{}s:7:\"display\";R:674;s:11:\"plugin_type\";s:7:\"display\";s:11:\"plugin_name\";s:4:\"feed\";s:7:\"options\";a:44:{s:8:\"defaults\";a:35:{s:6:\"access\";b:1;s:5:\"cache\";b:1;s:5:\"query\";b:1;s:5:\"title\";b:1;s:9:\"css_class\";b:1;s:19:\"display_description\";b:0;s:8:\"use_ajax\";b:1;s:23:\"hide_attachment_summary\";b:1;s:16:\"hide_admin_links\";b:1;s:5:\"pager\";b:0;s:13:\"pager_options\";b:1;s:8:\"use_more\";b:1;s:15:\"use_more_always\";b:1;s:13:\"use_more_text\";b:1;s:12:\"exposed_form\";b:1;s:20:\"exposed_form_options\";b:1;s:12:\"link_display\";b:1;s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:1;s:12:\"style_plugin\";b:0;s:13:\"style_options\";b:0;s:10:\"row_plugin\";b:0;s:11:\"row_options\";b:0;s:6:\"header\";b:1;s:6:\"footer\";b:1;s:5:\"empty\";b:1;s:13:\"relationships\";b:1;s:6:\"fields\";b:1;s:5:\"sorts\";b:1;s:9:\"arguments\";b:1;s:7:\"filters\";b:1;s:13:\"filter_groups\";b:1;s:9:\"use_pager\";b:0;s:14:\"items_per_page\";b:0;s:6:\"offset\";b:0;}s:5:\"title\";s:0:\"\";s:7:\"enabled\";b:1;s:15:\"display_comment\";s:0:\"\";s:9:\"css_class\";s:0:\"\";s:19:\"display_description\";s:0:\"\";s:8:\"use_ajax\";b:0;s:23:\"hide_attachment_summary\";b:0;s:16:\"hide_admin_links\";b:0;s:14:\"items_per_page\";i:10;s:6:\"offset\";i:0;s:9:\"use_pager\";b:0;s:8:\"use_more\";b:0;s:15:\"use_more_always\";b:0;s:13:\"use_more_text\";s:4:\"more\";s:12:\"link_display\";s:0:\"\";s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:0;s:14:\"field_language\";s:22:\"***CURRENT_LANGUAGE***\";s:27:\"field_language_add_to_query\";i:1;s:6:\"access\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"cache\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:0:{}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"some\";s:7:\"options\";a:0:{}}s:12:\"style_plugin\";s:3:\"rss\";s:13:\"style_options\";a:1:{s:11:\"description\";s:0:\"\";}s:10:\"row_plugin\";s:8:\"node_rss\";s:11:\"row_options\";a:0:{}s:13:\"exposed_block\";b:0;s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:0:{}s:13:\"relationships\";a:0:{}s:6:\"fields\";a:0:{}s:5:\"sorts\";a:0:{}s:9:\"arguments\";a:0:{}s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}s:7:\"filters\";a:0:{}s:4:\"path\";s:0:\"\";s:4:\"menu\";a:7:{s:4:\"type\";s:4:\"none\";s:5:\"title\";s:0:\"\";s:11:\"description\";s:0:\"\";s:6:\"weight\";i:0;s:4:\"name\";s:10:\"navigation\";s:7:\"context\";s:0:\"\";s:19:\"context_only_inline\";b:0;}s:11:\"tab_options\";a:5:{s:4:\"type\";s:4:\"none\";s:5:\"title\";s:0:\"\";s:11:\"description\";s:0:\"\";s:6:\"weight\";i:0;s:4:\"name\";s:10:\"navigation\";}s:8:\"displays\";a:0:{}s:14:\"sitename_title\";b:0;}s:10:\"definition\";a:17:{s:5:\"title\";s:4:\"Feed\";s:4:\"help\";s:48:\"Display the view as a feed, such as an RSS feed.\";s:7:\"handler\";s:25:\"views_plugin_display_feed\";s:14:\"uses hook menu\";b:1;s:8:\"use ajax\";b:0;s:9:\"use pager\";b:0;s:18:\"accept attachments\";b:0;s:5:\"admin\";s:4:\"Feed\";s:10:\"help topic\";s:12:\"display-feed\";s:6:\"module\";s:5:\"views\";s:10:\"theme path\";s:29:\"sites/all/modules/views/theme\";s:10:\"theme file\";s:9:\"theme.inc\";s:4:\"path\";s:31:\"sites/all/modules/views/plugins\";s:4:\"file\";s:29:\"views_plugin_display_feed.inc\";s:6:\"parent\";s:6:\"parent\";s:4:\"name\";s:4:\"feed\";s:16:\"contextual links\";a:1:{s:8:\"views_ui\";a:2:{s:11:\"parent path\";s:26:\"admin/structure/views/view\";s:19:\"argument properties\";a:1:{i:0;s:4:\"name\";}}}}s:9:\"is_plugin\";b:1;s:15:\"default_display\";R:37;}s:15:\"display_options\";a:8:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:8:\"defaults\";a:1:{s:12:\"link_display\";b:0;}s:12:\"link_display\";s:6:\"feed_1\";s:5:\"pager\";a:1:{s:4:\"type\";s:4:\"some\";}s:12:\"style_plugin\";s:3:\"rss\";s:10:\"row_plugin\";s:8:\"node_rss\";s:4:\"path\";s:21:\"forum/unanswered/feed\";s:8:\"displays\";a:2:{s:6:\"page_1\";s:6:\"page_1\";s:7:\"default\";i:0;}}s:8:\"db_table\";s:13:\"views_display\";s:3:\"vid\";i:0;s:2:\"id\";s:6:\"feed_1\";s:13:\"display_title\";s:4:\"Feed\";s:14:\"display_plugin\";s:4:\"feed\";s:8:\"position\";i:0;}}s:12:\"style_plugin\";N;s:13:\"style_options\";N;s:9:\"row_index\";N;s:12:\"override_url\";N;s:13:\"override_path\";N;s:13:\"base_database\";N;s:5:\"field\";N;s:8:\"argument\";N;s:4:\"sort\";N;s:6:\"filter\";N;s:12:\"relationship\";N;s:6:\"header\";N;s:6:\"footer\";N;s:5:\"empty\";N;s:13:\"export_module\";s:14:\"advanced_forum\";}',0,1512620340,1),('ctools_export:views_view:archive','O:4:\"view\":49:{s:8:\"db_table\";s:10:\"views_view\";s:10:\"base_table\";s:4:\"node\";s:10:\"base_field\";s:3:\"nid\";s:4:\"name\";s:7:\"archive\";s:3:\"vid\";s:0:\"\";s:11:\"description\";s:61:\"Display a list of months that link to content for that month.\";s:3:\"tag\";s:7:\"default\";s:10:\"human_name\";s:7:\"Archive\";s:4:\"core\";i:0;s:11:\"api_version\";s:3:\"3.0\";s:8:\"disabled\";b:1;s:5:\"built\";b:0;s:8:\"executed\";b:0;s:7:\"editing\";b:0;s:4:\"args\";a:0:{}s:10:\"build_info\";a:0:{}s:8:\"use_ajax\";b:0;s:6:\"result\";a:0:{}s:12:\"current_page\";N;s:14:\"items_per_page\";N;s:6:\"offset\";N;s:10:\"total_rows\";N;s:17:\"attachment_before\";s:0:\"\";s:16:\"attachment_after\";s:0:\"\";s:12:\"exposed_data\";a:0:{}s:13:\"exposed_input\";a:0:{}s:17:\"exposed_raw_input\";a:0:{}s:8:\"old_view\";a:0:{}s:12:\"parent_views\";a:0:{}s:13:\"is_attachment\";N;s:15:\"current_display\";N;s:5:\"query\";N;s:15:\"display_handler\";N;s:7:\"display\";a:3:{s:7:\"default\";O:13:\"views_display\":8:{s:7:\"handler\";O:28:\"views_plugin_display_default\":9:{s:4:\"view\";r:1;s:8:\"handlers\";a:0:{}s:8:\"extender\";a:0:{}s:7:\"display\";R:36;s:11:\"plugin_type\";s:7:\"display\";s:11:\"plugin_name\";s:7:\"default\";s:7:\"options\";a:38:{s:5:\"title\";s:0:\"\";s:7:\"enabled\";b:1;s:15:\"display_comment\";s:0:\"\";s:9:\"css_class\";s:0:\"\";s:19:\"display_description\";s:0:\"\";s:8:\"use_ajax\";b:0;s:23:\"hide_attachment_summary\";b:0;s:16:\"hide_admin_links\";b:0;s:14:\"items_per_page\";i:10;s:6:\"offset\";i:0;s:9:\"use_pager\";b:0;s:8:\"use_more\";b:0;s:15:\"use_more_always\";b:0;s:13:\"use_more_text\";s:4:\"more\";s:12:\"link_display\";s:0:\"\";s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:0;s:14:\"field_language\";s:22:\"***CURRENT_LANGUAGE***\";s:27:\"field_language_add_to_query\";i:1;s:6:\"access\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"cache\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:0:{}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"full\";s:7:\"options\";a:0:{}}s:12:\"style_plugin\";s:7:\"default\";s:13:\"style_options\";a:0:{}s:10:\"row_plugin\";s:6:\"fields\";s:11:\"row_options\";a:0:{}s:13:\"exposed_block\";b:0;s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:0:{}s:13:\"relationships\";a:0:{}s:6:\"fields\";a:0:{}s:5:\"sorts\";a:0:{}s:9:\"arguments\";a:0:{}s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}s:7:\"filters\";a:0:{}}s:10:\"definition\";a:20:{s:5:\"title\";s:6:\"Master\";s:4:\"help\";s:31:\"Default settings for this view.\";s:7:\"handler\";s:28:\"views_plugin_display_default\";s:5:\"theme\";s:10:\"views_view\";s:5:\"no ui\";b:1;s:9:\"no remove\";b:1;s:2:\"js\";a:6:{i:0;s:12:\"misc/form.js\";i:1;s:16:\"misc/collapse.js\";i:2;s:16:\"misc/textarea.js\";i:3;s:17:\"misc/tabledrag.js\";i:4;s:20:\"misc/autocomplete.js\";i:5;s:40:\"sites/all/modules/ctools/js/dependent.js\";}s:8:\"use ajax\";b:1;s:9:\"use pager\";b:1;s:8:\"use more\";b:1;s:18:\"accept attachments\";b:1;s:10:\"help topic\";s:15:\"display-default\";s:6:\"module\";s:5:\"views\";s:10:\"theme path\";s:29:\"sites/all/modules/views/theme\";s:10:\"theme file\";s:9:\"theme.inc\";s:4:\"path\";s:31:\"sites/all/modules/views/plugins\";s:4:\"file\";s:32:\"views_plugin_display_default.inc\";s:6:\"parent\";s:6:\"parent\";s:4:\"name\";s:7:\"default\";s:16:\"contextual links\";a:1:{s:8:\"views_ui\";a:2:{s:11:\"parent path\";s:26:\"admin/structure/views/view\";s:19:\"argument properties\";a:1:{i:0;s:4:\"name\";}}}}s:9:\"is_plugin\";b:1;}s:15:\"display_options\";a:11:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:1:{s:13:\"query_comment\";b:0;}}s:5:\"title\";s:15:\"Monthly archive\";s:6:\"access\";a:2:{s:4:\"type\";s:4:\"perm\";s:4:\"perm\";s:14:\"access content\";}s:5:\"cache\";a:1:{s:4:\"type\";s:4:\"none\";}s:12:\"exposed_form\";a:1:{s:4:\"type\";s:5:\"basic\";}s:5:\"pager\";a:1:{s:4:\"type\";s:4:\"full\";}s:12:\"style_plugin\";s:7:\"default\";s:10:\"row_plugin\";s:4:\"node\";s:5:\"sorts\";a:1:{s:7:\"created\";a:4:{s:2:\"id\";s:7:\"created\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:7:\"created\";s:5:\"order\";s:4:\"DESC\";}}s:9:\"arguments\";a:1:{s:18:\"created_year_month\";a:11:{s:2:\"id\";s:18:\"created_year_month\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:18:\"created_year_month\";s:14:\"default_action\";s:7:\"summary\";s:9:\"exception\";a:1:{s:12:\"title_enable\";i:1;}s:12:\"title_enable\";i:1;s:5:\"title\";s:2:\"%1\";s:21:\"default_argument_type\";s:5:\"fixed\";s:7:\"summary\";a:2:{s:10:\"sort_order\";s:4:\"desc\";s:6:\"format\";s:15:\"default_summary\";}s:15:\"summary_options\";a:2:{s:8:\"override\";b:1;s:14:\"items_per_page\";s:2:\"30\";}s:18:\"specify_validation\";i:1;}}s:7:\"filters\";a:1:{s:6:\"status\";a:6:{s:2:\"id\";s:6:\"status\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:6:\"status\";s:5:\"value\";i:1;s:5:\"group\";i:0;s:6:\"expose\";a:1:{s:8:\"operator\";b:0;}}}}s:8:\"db_table\";s:13:\"views_display\";s:3:\"vid\";i:0;s:2:\"id\";s:7:\"default\";s:13:\"display_title\";s:6:\"Master\";s:14:\"display_plugin\";s:7:\"default\";s:8:\"position\";i:0;}s:4:\"page\";O:13:\"views_display\":8:{s:7:\"handler\";O:25:\"views_plugin_display_page\":10:{s:4:\"view\";r:1;s:8:\"handlers\";a:0:{}s:8:\"extender\";a:0:{}s:7:\"display\";R:181;s:11:\"plugin_type\";s:7:\"display\";s:11:\"plugin_name\";s:4:\"page\";s:7:\"options\";a:42:{s:8:\"defaults\";a:32:{s:6:\"access\";b:1;s:5:\"cache\";b:1;s:5:\"query\";b:1;s:5:\"title\";b:1;s:9:\"css_class\";b:1;s:19:\"display_description\";b:0;s:8:\"use_ajax\";b:1;s:23:\"hide_attachment_summary\";b:1;s:16:\"hide_admin_links\";b:1;s:5:\"pager\";b:1;s:13:\"pager_options\";b:1;s:8:\"use_more\";b:1;s:15:\"use_more_always\";b:1;s:13:\"use_more_text\";b:1;s:12:\"exposed_form\";b:1;s:20:\"exposed_form_options\";b:1;s:12:\"link_display\";b:1;s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:1;s:12:\"style_plugin\";b:1;s:13:\"style_options\";b:1;s:10:\"row_plugin\";b:1;s:11:\"row_options\";b:1;s:6:\"header\";b:1;s:6:\"footer\";b:1;s:5:\"empty\";b:1;s:13:\"relationships\";b:1;s:6:\"fields\";b:1;s:5:\"sorts\";b:1;s:9:\"arguments\";b:1;s:7:\"filters\";b:1;s:13:\"filter_groups\";b:1;}s:5:\"title\";s:0:\"\";s:7:\"enabled\";b:1;s:15:\"display_comment\";s:0:\"\";s:9:\"css_class\";s:0:\"\";s:19:\"display_description\";s:0:\"\";s:8:\"use_ajax\";b:0;s:23:\"hide_attachment_summary\";b:0;s:16:\"hide_admin_links\";b:0;s:14:\"items_per_page\";i:10;s:6:\"offset\";i:0;s:9:\"use_pager\";b:0;s:8:\"use_more\";b:0;s:15:\"use_more_always\";b:0;s:13:\"use_more_text\";s:4:\"more\";s:12:\"link_display\";s:0:\"\";s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:0;s:14:\"field_language\";s:22:\"***CURRENT_LANGUAGE***\";s:27:\"field_language_add_to_query\";i:1;s:6:\"access\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"cache\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:0:{}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"full\";s:7:\"options\";a:0:{}}s:12:\"style_plugin\";s:7:\"default\";s:13:\"style_options\";a:0:{}s:10:\"row_plugin\";s:6:\"fields\";s:11:\"row_options\";a:0:{}s:13:\"exposed_block\";b:0;s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:0:{}s:13:\"relationships\";a:0:{}s:6:\"fields\";a:0:{}s:5:\"sorts\";a:0:{}s:9:\"arguments\";a:0:{}s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}s:7:\"filters\";a:0:{}s:4:\"path\";s:0:\"\";s:4:\"menu\";a:7:{s:4:\"type\";s:4:\"none\";s:5:\"title\";s:0:\"\";s:11:\"description\";s:0:\"\";s:6:\"weight\";i:0;s:4:\"name\";s:10:\"navigation\";s:7:\"context\";s:0:\"\";s:19:\"context_only_inline\";b:0;}s:11:\"tab_options\";a:5:{s:4:\"type\";s:4:\"none\";s:5:\"title\";s:0:\"\";s:11:\"description\";s:0:\"\";s:6:\"weight\";i:0;s:4:\"name\";s:10:\"navigation\";}}s:10:\"definition\";a:20:{s:5:\"title\";s:4:\"Page\";s:4:\"help\";s:54:\"Display the view as a page, with a URL and menu links.\";s:7:\"handler\";s:25:\"views_plugin_display_page\";s:5:\"theme\";s:10:\"views_view\";s:14:\"uses hook menu\";b:1;s:26:\"contextual links locations\";a:1:{i:0;s:4:\"page\";}s:8:\"use ajax\";b:1;s:9:\"use pager\";b:1;s:8:\"use more\";b:1;s:18:\"accept attachments\";b:1;s:5:\"admin\";s:4:\"Page\";s:10:\"help topic\";s:12:\"display-page\";s:6:\"module\";s:5:\"views\";s:10:\"theme path\";s:29:\"sites/all/modules/views/theme\";s:10:\"theme file\";s:9:\"theme.inc\";s:4:\"path\";s:31:\"sites/all/modules/views/plugins\";s:4:\"file\";s:29:\"views_plugin_display_page.inc\";s:6:\"parent\";s:6:\"parent\";s:4:\"name\";s:4:\"page\";s:16:\"contextual links\";a:1:{s:8:\"views_ui\";a:2:{s:11:\"parent path\";s:26:\"admin/structure/views/view\";s:19:\"argument properties\";a:1:{i:0;s:4:\"name\";}}}}s:9:\"is_plugin\";b:1;s:15:\"default_display\";R:37;}s:15:\"display_options\";a:2:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:4:\"path\";s:7:\"archive\";}s:8:\"db_table\";s:13:\"views_display\";s:3:\"vid\";i:0;s:2:\"id\";s:4:\"page\";s:13:\"display_title\";s:4:\"Page\";s:14:\"display_plugin\";s:4:\"page\";s:8:\"position\";i:0;}s:5:\"block\";O:13:\"views_display\":8:{s:7:\"handler\";O:26:\"views_plugin_display_block\":10:{s:4:\"view\";r:1;s:8:\"handlers\";a:0:{}s:8:\"extender\";a:0:{}s:7:\"display\";R:324;s:11:\"plugin_type\";s:7:\"display\";s:11:\"plugin_name\";s:5:\"block\";s:7:\"options\";a:41:{s:8:\"defaults\";a:32:{s:6:\"access\";b:1;s:5:\"cache\";b:1;s:5:\"query\";b:1;s:5:\"title\";b:1;s:9:\"css_class\";b:1;s:19:\"display_description\";b:0;s:8:\"use_ajax\";b:1;s:23:\"hide_attachment_summary\";b:1;s:16:\"hide_admin_links\";b:1;s:5:\"pager\";b:1;s:13:\"pager_options\";b:1;s:8:\"use_more\";b:1;s:15:\"use_more_always\";b:1;s:13:\"use_more_text\";b:1;s:12:\"exposed_form\";b:1;s:20:\"exposed_form_options\";b:1;s:12:\"link_display\";b:1;s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:1;s:12:\"style_plugin\";b:1;s:13:\"style_options\";b:1;s:10:\"row_plugin\";b:1;s:11:\"row_options\";b:1;s:6:\"header\";b:1;s:6:\"footer\";b:1;s:5:\"empty\";b:1;s:13:\"relationships\";b:1;s:6:\"fields\";b:1;s:5:\"sorts\";b:1;s:9:\"arguments\";b:1;s:7:\"filters\";b:1;s:13:\"filter_groups\";b:1;}s:5:\"title\";s:0:\"\";s:7:\"enabled\";b:1;s:15:\"display_comment\";s:0:\"\";s:9:\"css_class\";s:0:\"\";s:19:\"display_description\";s:0:\"\";s:8:\"use_ajax\";b:0;s:23:\"hide_attachment_summary\";b:0;s:16:\"hide_admin_links\";b:0;s:14:\"items_per_page\";i:10;s:6:\"offset\";i:0;s:9:\"use_pager\";b:0;s:8:\"use_more\";b:0;s:15:\"use_more_always\";b:0;s:13:\"use_more_text\";s:4:\"more\";s:12:\"link_display\";s:0:\"\";s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:0;s:14:\"field_language\";s:22:\"***CURRENT_LANGUAGE***\";s:27:\"field_language_add_to_query\";i:1;s:6:\"access\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"cache\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:0:{}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"full\";s:7:\"options\";a:0:{}}s:12:\"style_plugin\";s:7:\"default\";s:13:\"style_options\";a:0:{}s:10:\"row_plugin\";s:6:\"fields\";s:11:\"row_options\";a:0:{}s:13:\"exposed_block\";b:0;s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:0:{}s:13:\"relationships\";a:0:{}s:6:\"fields\";a:0:{}s:5:\"sorts\";a:0:{}s:9:\"arguments\";a:0:{}s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}s:7:\"filters\";a:0:{}s:17:\"block_description\";s:0:\"\";s:13:\"block_caching\";i:-1;}s:10:\"definition\";a:20:{s:5:\"title\";s:5:\"Block\";s:4:\"help\";s:28:\"Display the view as a block.\";s:7:\"handler\";s:26:\"views_plugin_display_block\";s:5:\"theme\";s:10:\"views_view\";s:15:\"uses hook block\";b:1;s:26:\"contextual links locations\";a:1:{i:0;s:5:\"block\";}s:8:\"use ajax\";b:1;s:9:\"use pager\";b:1;s:8:\"use more\";b:1;s:18:\"accept attachments\";b:1;s:5:\"admin\";s:5:\"Block\";s:10:\"help topic\";s:13:\"display-block\";s:6:\"module\";s:5:\"views\";s:10:\"theme path\";s:29:\"sites/all/modules/views/theme\";s:10:\"theme file\";s:9:\"theme.inc\";s:4:\"path\";s:31:\"sites/all/modules/views/plugins\";s:4:\"file\";s:30:\"views_plugin_display_block.inc\";s:6:\"parent\";s:6:\"parent\";s:4:\"name\";s:5:\"block\";s:16:\"contextual links\";a:1:{s:8:\"views_ui\";a:2:{s:11:\"parent path\";s:26:\"admin/structure/views/view\";s:19:\"argument properties\";a:1:{i:0;s:4:\"name\";}}}}s:9:\"is_plugin\";b:1;s:15:\"default_display\";R:37;}s:15:\"display_options\";a:3:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:8:\"defaults\";a:1:{s:9:\"arguments\";b:0;}s:9:\"arguments\";a:1:{s:18:\"created_year_month\";a:11:{s:2:\"id\";s:18:\"created_year_month\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:18:\"created_year_month\";s:14:\"default_action\";s:7:\"summary\";s:9:\"exception\";a:1:{s:12:\"title_enable\";i:1;}s:12:\"title_enable\";i:1;s:5:\"title\";s:2:\"%1\";s:21:\"default_argument_type\";s:5:\"fixed\";s:7:\"summary\";a:1:{s:6:\"format\";s:15:\"default_summary\";}s:15:\"summary_options\";a:1:{s:14:\"items_per_page\";s:2:\"30\";}s:18:\"specify_validation\";i:1;}}}s:8:\"db_table\";s:13:\"views_display\";s:3:\"vid\";i:0;s:2:\"id\";s:5:\"block\";s:13:\"display_title\";s:5:\"Block\";s:14:\"display_plugin\";s:5:\"block\";s:8:\"position\";i:0;}}s:12:\"style_plugin\";N;s:13:\"style_options\";N;s:9:\"row_index\";N;s:12:\"override_url\";N;s:13:\"override_path\";N;s:13:\"base_database\";N;s:5:\"field\";N;s:8:\"argument\";N;s:4:\"sort\";N;s:6:\"filter\";N;s:12:\"relationship\";N;s:6:\"header\";N;s:6:\"footer\";N;s:5:\"empty\";N;s:13:\"export_module\";s:4:\"node\";}',0,1512620340,1),('ctools_export:views_view:backlinks','O:4:\"view\":49:{s:8:\"db_table\";s:10:\"views_view\";s:10:\"base_table\";s:4:\"node\";s:10:\"base_field\";s:3:\"nid\";s:4:\"name\";s:9:\"backlinks\";s:3:\"vid\";s:0:\"\";s:11:\"description\";s:81:\"Displays a list of nodes that link to the node, using the search backlinks table.\";s:3:\"tag\";s:7:\"default\";s:10:\"human_name\";s:9:\"Backlinks\";s:4:\"core\";i:0;s:11:\"api_version\";s:3:\"3.0\";s:8:\"disabled\";b:1;s:5:\"built\";b:0;s:8:\"executed\";b:0;s:7:\"editing\";b:0;s:4:\"args\";a:0:{}s:10:\"build_info\";a:0:{}s:8:\"use_ajax\";b:0;s:6:\"result\";a:0:{}s:12:\"current_page\";N;s:14:\"items_per_page\";N;s:6:\"offset\";N;s:10:\"total_rows\";N;s:17:\"attachment_before\";s:0:\"\";s:16:\"attachment_after\";s:0:\"\";s:12:\"exposed_data\";a:0:{}s:13:\"exposed_input\";a:0:{}s:17:\"exposed_raw_input\";a:0:{}s:8:\"old_view\";a:0:{}s:12:\"parent_views\";a:0:{}s:13:\"is_attachment\";N;s:15:\"current_display\";N;s:5:\"query\";N;s:15:\"display_handler\";N;s:7:\"display\";a:3:{s:7:\"default\";O:13:\"views_display\":8:{s:7:\"handler\";O:28:\"views_plugin_display_default\":9:{s:4:\"view\";r:1;s:8:\"handlers\";a:0:{}s:8:\"extender\";a:0:{}s:7:\"display\";R:36;s:11:\"plugin_type\";s:7:\"display\";s:11:\"plugin_name\";s:7:\"default\";s:7:\"options\";a:38:{s:5:\"title\";s:0:\"\";s:7:\"enabled\";b:1;s:15:\"display_comment\";s:0:\"\";s:9:\"css_class\";s:0:\"\";s:19:\"display_description\";s:0:\"\";s:8:\"use_ajax\";b:0;s:23:\"hide_attachment_summary\";b:0;s:16:\"hide_admin_links\";b:0;s:14:\"items_per_page\";i:10;s:6:\"offset\";i:0;s:9:\"use_pager\";b:0;s:8:\"use_more\";b:0;s:15:\"use_more_always\";b:0;s:13:\"use_more_text\";s:4:\"more\";s:12:\"link_display\";s:0:\"\";s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:0;s:14:\"field_language\";s:22:\"***CURRENT_LANGUAGE***\";s:27:\"field_language_add_to_query\";i:1;s:6:\"access\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"cache\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:0:{}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"full\";s:7:\"options\";a:0:{}}s:12:\"style_plugin\";s:7:\"default\";s:13:\"style_options\";a:0:{}s:10:\"row_plugin\";s:6:\"fields\";s:11:\"row_options\";a:0:{}s:13:\"exposed_block\";b:0;s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:0:{}s:13:\"relationships\";a:0:{}s:6:\"fields\";a:0:{}s:5:\"sorts\";a:0:{}s:9:\"arguments\";a:0:{}s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}s:7:\"filters\";a:0:{}}s:10:\"definition\";a:20:{s:5:\"title\";s:6:\"Master\";s:4:\"help\";s:31:\"Default settings for this view.\";s:7:\"handler\";s:28:\"views_plugin_display_default\";s:5:\"theme\";s:10:\"views_view\";s:5:\"no ui\";b:1;s:9:\"no remove\";b:1;s:2:\"js\";a:6:{i:0;s:12:\"misc/form.js\";i:1;s:16:\"misc/collapse.js\";i:2;s:16:\"misc/textarea.js\";i:3;s:17:\"misc/tabledrag.js\";i:4;s:20:\"misc/autocomplete.js\";i:5;s:40:\"sites/all/modules/ctools/js/dependent.js\";}s:8:\"use ajax\";b:1;s:9:\"use pager\";b:1;s:8:\"use more\";b:1;s:18:\"accept attachments\";b:1;s:10:\"help topic\";s:15:\"display-default\";s:6:\"module\";s:5:\"views\";s:10:\"theme path\";s:29:\"sites/all/modules/views/theme\";s:10:\"theme file\";s:9:\"theme.inc\";s:4:\"path\";s:31:\"sites/all/modules/views/plugins\";s:4:\"file\";s:32:\"views_plugin_display_default.inc\";s:6:\"parent\";s:6:\"parent\";s:4:\"name\";s:7:\"default\";s:16:\"contextual links\";a:1:{s:8:\"views_ui\";a:2:{s:11:\"parent path\";s:26:\"admin/structure/views/view\";s:19:\"argument properties\";a:1:{i:0;s:4:\"name\";}}}}s:9:\"is_plugin\";b:1;}s:15:\"display_options\";a:12:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:1:{s:13:\"query_comment\";b:0;}}s:6:\"access\";a:2:{s:4:\"type\";s:4:\"perm\";s:4:\"perm\";s:14:\"access content\";}s:5:\"cache\";a:1:{s:4:\"type\";s:4:\"none\";}s:12:\"exposed_form\";a:1:{s:4:\"type\";s:5:\"basic\";}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"full\";s:7:\"options\";a:1:{s:14:\"items_per_page\";i:30;}}s:12:\"style_plugin\";s:4:\"list\";s:13:\"style_options\";a:1:{s:4:\"type\";s:2:\"ol\";}s:10:\"row_plugin\";s:6:\"fields\";s:5:\"empty\";a:1:{s:4:\"text\";a:6:{s:2:\"id\";s:4:\"area\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:4:\"area\";s:5:\"empty\";b:0;s:7:\"content\";s:19:\"No backlinks found.\";s:6:\"format\";s:1:\"1\";}}s:6:\"fields\";a:1:{s:5:\"title\";a:5:{s:2:\"id\";s:5:\"title\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:5:\"title\";s:5:\"label\";s:0:\"\";s:12:\"link_to_node\";i:1;}}s:9:\"arguments\";a:1:{s:3:\"nid\";a:10:{s:2:\"id\";s:3:\"nid\";s:5:\"table\";s:20:\"search_node_links_to\";s:5:\"field\";s:3:\"nid\";s:14:\"default_action\";s:9:\"not found\";s:12:\"title_enable\";i:1;s:5:\"title\";s:21:\"Pages that link to %1\";s:21:\"default_argument_type\";s:5:\"fixed\";s:7:\"summary\";a:1:{s:6:\"format\";s:15:\"default_summary\";}s:18:\"specify_validation\";i:1;s:8:\"validate\";a:1:{s:4:\"type\";s:4:\"node\";}}}s:7:\"filters\";a:1:{s:6:\"status\";a:6:{s:2:\"id\";s:6:\"status\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:6:\"status\";s:5:\"value\";i:1;s:5:\"group\";i:0;s:6:\"expose\";a:1:{s:8:\"operator\";b:0;}}}}s:8:\"db_table\";s:13:\"views_display\";s:3:\"vid\";i:0;s:2:\"id\";s:7:\"default\";s:13:\"display_title\";s:6:\"Master\";s:14:\"display_plugin\";s:7:\"default\";s:8:\"position\";i:0;}s:4:\"page\";O:13:\"views_display\":8:{s:7:\"handler\";O:25:\"views_plugin_display_page\":10:{s:4:\"view\";r:1;s:8:\"handlers\";a:0:{}s:8:\"extender\";a:0:{}s:7:\"display\";R:189;s:11:\"plugin_type\";s:7:\"display\";s:11:\"plugin_name\";s:4:\"page\";s:7:\"options\";a:42:{s:8:\"defaults\";a:32:{s:6:\"access\";b:1;s:5:\"cache\";b:1;s:5:\"query\";b:1;s:5:\"title\";b:1;s:9:\"css_class\";b:1;s:19:\"display_description\";b:0;s:8:\"use_ajax\";b:1;s:23:\"hide_attachment_summary\";b:1;s:16:\"hide_admin_links\";b:1;s:5:\"pager\";b:1;s:13:\"pager_options\";b:1;s:8:\"use_more\";b:1;s:15:\"use_more_always\";b:1;s:13:\"use_more_text\";b:1;s:12:\"exposed_form\";b:1;s:20:\"exposed_form_options\";b:1;s:12:\"link_display\";b:1;s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:1;s:12:\"style_plugin\";b:1;s:13:\"style_options\";b:1;s:10:\"row_plugin\";b:1;s:11:\"row_options\";b:1;s:6:\"header\";b:1;s:6:\"footer\";b:1;s:5:\"empty\";b:1;s:13:\"relationships\";b:1;s:6:\"fields\";b:1;s:5:\"sorts\";b:1;s:9:\"arguments\";b:1;s:7:\"filters\";b:1;s:13:\"filter_groups\";b:1;}s:5:\"title\";s:0:\"\";s:7:\"enabled\";b:1;s:15:\"display_comment\";s:0:\"\";s:9:\"css_class\";s:0:\"\";s:19:\"display_description\";s:0:\"\";s:8:\"use_ajax\";b:0;s:23:\"hide_attachment_summary\";b:0;s:16:\"hide_admin_links\";b:0;s:14:\"items_per_page\";i:10;s:6:\"offset\";i:0;s:9:\"use_pager\";b:0;s:8:\"use_more\";b:0;s:15:\"use_more_always\";b:0;s:13:\"use_more_text\";s:4:\"more\";s:12:\"link_display\";s:0:\"\";s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:0;s:14:\"field_language\";s:22:\"***CURRENT_LANGUAGE***\";s:27:\"field_language_add_to_query\";i:1;s:6:\"access\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"cache\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:0:{}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"full\";s:7:\"options\";a:0:{}}s:12:\"style_plugin\";s:7:\"default\";s:13:\"style_options\";a:0:{}s:10:\"row_plugin\";s:6:\"fields\";s:11:\"row_options\";a:0:{}s:13:\"exposed_block\";b:0;s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:0:{}s:13:\"relationships\";a:0:{}s:6:\"fields\";a:0:{}s:5:\"sorts\";a:0:{}s:9:\"arguments\";a:0:{}s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}s:7:\"filters\";a:0:{}s:4:\"path\";s:0:\"\";s:4:\"menu\";a:7:{s:4:\"type\";s:4:\"none\";s:5:\"title\";s:0:\"\";s:11:\"description\";s:0:\"\";s:6:\"weight\";i:0;s:4:\"name\";s:10:\"navigation\";s:7:\"context\";s:0:\"\";s:19:\"context_only_inline\";b:0;}s:11:\"tab_options\";a:5:{s:4:\"type\";s:4:\"none\";s:5:\"title\";s:0:\"\";s:11:\"description\";s:0:\"\";s:6:\"weight\";i:0;s:4:\"name\";s:10:\"navigation\";}}s:10:\"definition\";a:20:{s:5:\"title\";s:4:\"Page\";s:4:\"help\";s:54:\"Display the view as a page, with a URL and menu links.\";s:7:\"handler\";s:25:\"views_plugin_display_page\";s:5:\"theme\";s:10:\"views_view\";s:14:\"uses hook menu\";b:1;s:26:\"contextual links locations\";a:1:{i:0;s:4:\"page\";}s:8:\"use ajax\";b:1;s:9:\"use pager\";b:1;s:8:\"use more\";b:1;s:18:\"accept attachments\";b:1;s:5:\"admin\";s:4:\"Page\";s:10:\"help topic\";s:12:\"display-page\";s:6:\"module\";s:5:\"views\";s:10:\"theme path\";s:29:\"sites/all/modules/views/theme\";s:10:\"theme file\";s:9:\"theme.inc\";s:4:\"path\";s:31:\"sites/all/modules/views/plugins\";s:4:\"file\";s:29:\"views_plugin_display_page.inc\";s:6:\"parent\";s:6:\"parent\";s:4:\"name\";s:4:\"page\";s:16:\"contextual links\";a:1:{s:8:\"views_ui\";a:2:{s:11:\"parent path\";s:26:\"admin/structure/views/view\";s:19:\"argument properties\";a:1:{i:0;s:4:\"name\";}}}}s:9:\"is_plugin\";b:1;s:15:\"default_display\";R:37;}s:15:\"display_options\";a:3:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:4:\"path\";s:16:\"node/%/backlinks\";s:4:\"menu\";a:3:{s:4:\"type\";s:3:\"tab\";s:5:\"title\";s:15:\"What links here\";s:6:\"weight\";s:1:\"0\";}}s:8:\"db_table\";s:13:\"views_display\";s:3:\"vid\";i:0;s:2:\"id\";s:4:\"page\";s:13:\"display_title\";s:4:\"Page\";s:14:\"display_plugin\";s:4:\"page\";s:8:\"position\";i:0;}s:5:\"block\";O:13:\"views_display\":8:{s:7:\"handler\";O:26:\"views_plugin_display_block\":10:{s:4:\"view\";r:1;s:8:\"handlers\";a:0:{}s:8:\"extender\";a:0:{}s:7:\"display\";R:336;s:11:\"plugin_type\";s:7:\"display\";s:11:\"plugin_name\";s:5:\"block\";s:7:\"options\";a:41:{s:8:\"defaults\";a:32:{s:6:\"access\";b:1;s:5:\"cache\";b:1;s:5:\"query\";b:1;s:5:\"title\";b:1;s:9:\"css_class\";b:1;s:19:\"display_description\";b:0;s:8:\"use_ajax\";b:1;s:23:\"hide_attachment_summary\";b:1;s:16:\"hide_admin_links\";b:1;s:5:\"pager\";b:1;s:13:\"pager_options\";b:1;s:8:\"use_more\";b:1;s:15:\"use_more_always\";b:1;s:13:\"use_more_text\";b:1;s:12:\"exposed_form\";b:1;s:20:\"exposed_form_options\";b:1;s:12:\"link_display\";b:1;s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:1;s:12:\"style_plugin\";b:1;s:13:\"style_options\";b:1;s:10:\"row_plugin\";b:1;s:11:\"row_options\";b:1;s:6:\"header\";b:1;s:6:\"footer\";b:1;s:5:\"empty\";b:1;s:13:\"relationships\";b:1;s:6:\"fields\";b:1;s:5:\"sorts\";b:1;s:9:\"arguments\";b:1;s:7:\"filters\";b:1;s:13:\"filter_groups\";b:1;}s:5:\"title\";s:0:\"\";s:7:\"enabled\";b:1;s:15:\"display_comment\";s:0:\"\";s:9:\"css_class\";s:0:\"\";s:19:\"display_description\";s:0:\"\";s:8:\"use_ajax\";b:0;s:23:\"hide_attachment_summary\";b:0;s:16:\"hide_admin_links\";b:0;s:14:\"items_per_page\";i:10;s:6:\"offset\";i:0;s:9:\"use_pager\";b:0;s:8:\"use_more\";b:0;s:15:\"use_more_always\";b:0;s:13:\"use_more_text\";s:4:\"more\";s:12:\"link_display\";s:0:\"\";s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:0;s:14:\"field_language\";s:22:\"***CURRENT_LANGUAGE***\";s:27:\"field_language_add_to_query\";i:1;s:6:\"access\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"cache\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:0:{}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"full\";s:7:\"options\";a:0:{}}s:12:\"style_plugin\";s:7:\"default\";s:13:\"style_options\";a:0:{}s:10:\"row_plugin\";s:6:\"fields\";s:11:\"row_options\";a:0:{}s:13:\"exposed_block\";b:0;s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:0:{}s:13:\"relationships\";a:0:{}s:6:\"fields\";a:0:{}s:5:\"sorts\";a:0:{}s:9:\"arguments\";a:0:{}s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}s:7:\"filters\";a:0:{}s:17:\"block_description\";s:0:\"\";s:13:\"block_caching\";i:-1;}s:10:\"definition\";a:20:{s:5:\"title\";s:5:\"Block\";s:4:\"help\";s:28:\"Display the view as a block.\";s:7:\"handler\";s:26:\"views_plugin_display_block\";s:5:\"theme\";s:10:\"views_view\";s:15:\"uses hook block\";b:1;s:26:\"contextual links locations\";a:1:{i:0;s:5:\"block\";}s:8:\"use ajax\";b:1;s:9:\"use pager\";b:1;s:8:\"use more\";b:1;s:18:\"accept attachments\";b:1;s:5:\"admin\";s:5:\"Block\";s:10:\"help topic\";s:13:\"display-block\";s:6:\"module\";s:5:\"views\";s:10:\"theme path\";s:29:\"sites/all/modules/views/theme\";s:10:\"theme file\";s:9:\"theme.inc\";s:4:\"path\";s:31:\"sites/all/modules/views/plugins\";s:4:\"file\";s:30:\"views_plugin_display_block.inc\";s:6:\"parent\";s:6:\"parent\";s:4:\"name\";s:5:\"block\";s:16:\"contextual links\";a:1:{s:8:\"views_ui\";a:2:{s:11:\"parent path\";s:26:\"admin/structure/views/view\";s:19:\"argument properties\";a:1:{i:0;s:4:\"name\";}}}}s:9:\"is_plugin\";b:1;s:15:\"default_display\";R:37;}s:15:\"display_options\";a:6:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:8:\"defaults\";a:6:{s:8:\"use_more\";b:0;s:12:\"style_plugin\";b:0;s:13:\"style_options\";b:0;s:10:\"row_plugin\";b:0;s:11:\"row_options\";b:0;s:9:\"arguments\";b:0;}s:8:\"use_more\";b:1;s:12:\"style_plugin\";s:4:\"list\";s:10:\"row_plugin\";s:6:\"fields\";s:9:\"arguments\";a:1:{s:3:\"nid\";a:10:{s:2:\"id\";s:3:\"nid\";s:5:\"table\";s:20:\"search_node_links_to\";s:5:\"field\";s:3:\"nid\";s:14:\"default_action\";s:7:\"default\";s:12:\"title_enable\";i:1;s:5:\"title\";s:15:\"What links here\";s:21:\"default_argument_type\";s:4:\"node\";s:7:\"summary\";a:1:{s:6:\"format\";s:15:\"default_summary\";}s:18:\"specify_validation\";i:1;s:8:\"validate\";a:1:{s:4:\"type\";s:4:\"node\";}}}}s:8:\"db_table\";s:13:\"views_display\";s:3:\"vid\";i:0;s:2:\"id\";s:5:\"block\";s:13:\"display_title\";s:15:\"What links here\";s:14:\"display_plugin\";s:5:\"block\";s:8:\"position\";i:0;}}s:12:\"style_plugin\";N;s:13:\"style_options\";N;s:9:\"row_index\";N;s:12:\"override_url\";N;s:13:\"override_path\";N;s:13:\"base_database\";N;s:5:\"field\";N;s:8:\"argument\";N;s:4:\"sort\";N;s:6:\"filter\";N;s:12:\"relationship\";N;s:6:\"header\";N;s:6:\"footer\";N;s:5:\"empty\";N;s:13:\"export_module\";s:6:\"search\";}',0,1512620340,1),('ctools_export:views_view:comments_recent','O:4:\"view\":50:{s:8:\"db_table\";s:10:\"views_view\";s:10:\"base_table\";s:7:\"comment\";s:10:\"base_field\";s:3:\"nid\";s:4:\"name\";s:15:\"comments_recent\";s:3:\"vid\";s:0:\"\";s:11:\"description\";s:162:\"Contains a block and a page to list recent comments; the block will automatically link to the page, which displays the comment body as well as a link to the node.\";s:3:\"tag\";s:7:\"default\";s:10:\"human_name\";s:15:\"Recent comments\";s:4:\"core\";i:0;s:11:\"api_version\";s:3:\"3.0\";s:8:\"disabled\";b:1;s:5:\"built\";b:0;s:8:\"executed\";b:0;s:7:\"editing\";b:0;s:4:\"args\";a:0:{}s:10:\"build_info\";a:0:{}s:8:\"use_ajax\";b:0;s:6:\"result\";a:0:{}s:12:\"current_page\";N;s:14:\"items_per_page\";N;s:6:\"offset\";N;s:10:\"total_rows\";N;s:17:\"attachment_before\";s:0:\"\";s:16:\"attachment_after\";s:0:\"\";s:12:\"exposed_data\";a:0:{}s:13:\"exposed_input\";a:0:{}s:17:\"exposed_raw_input\";a:0:{}s:8:\"old_view\";a:0:{}s:12:\"parent_views\";a:0:{}s:13:\"is_attachment\";N;s:15:\"current_display\";N;s:5:\"query\";N;s:15:\"display_handler\";N;s:7:\"display\";a:3:{s:7:\"default\";O:13:\"views_display\":8:{s:7:\"handler\";O:28:\"views_plugin_display_default\":9:{s:4:\"view\";r:1;s:8:\"handlers\";a:0:{}s:8:\"extender\";a:0:{}s:7:\"display\";R:36;s:11:\"plugin_type\";s:7:\"display\";s:11:\"plugin_name\";s:7:\"default\";s:7:\"options\";a:38:{s:5:\"title\";s:0:\"\";s:7:\"enabled\";b:1;s:15:\"display_comment\";s:0:\"\";s:9:\"css_class\";s:0:\"\";s:19:\"display_description\";s:0:\"\";s:8:\"use_ajax\";b:0;s:23:\"hide_attachment_summary\";b:0;s:16:\"hide_admin_links\";b:0;s:14:\"items_per_page\";i:10;s:6:\"offset\";i:0;s:9:\"use_pager\";b:0;s:8:\"use_more\";b:0;s:15:\"use_more_always\";b:0;s:13:\"use_more_text\";s:4:\"more\";s:12:\"link_display\";s:0:\"\";s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:0;s:14:\"field_language\";s:22:\"***CURRENT_LANGUAGE***\";s:27:\"field_language_add_to_query\";i:1;s:6:\"access\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"cache\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:0:{}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"full\";s:7:\"options\";a:0:{}}s:12:\"style_plugin\";s:7:\"default\";s:13:\"style_options\";a:0:{}s:10:\"row_plugin\";s:6:\"fields\";s:11:\"row_options\";a:0:{}s:13:\"exposed_block\";b:0;s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:0:{}s:13:\"relationships\";a:0:{}s:6:\"fields\";a:0:{}s:5:\"sorts\";a:0:{}s:9:\"arguments\";a:0:{}s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}s:7:\"filters\";a:0:{}}s:10:\"definition\";a:20:{s:5:\"title\";s:6:\"Master\";s:4:\"help\";s:31:\"Default settings for this view.\";s:7:\"handler\";s:28:\"views_plugin_display_default\";s:5:\"theme\";s:10:\"views_view\";s:5:\"no ui\";b:1;s:9:\"no remove\";b:1;s:2:\"js\";a:6:{i:0;s:12:\"misc/form.js\";i:1;s:16:\"misc/collapse.js\";i:2;s:16:\"misc/textarea.js\";i:3;s:17:\"misc/tabledrag.js\";i:4;s:20:\"misc/autocomplete.js\";i:5;s:40:\"sites/all/modules/ctools/js/dependent.js\";}s:8:\"use ajax\";b:1;s:9:\"use pager\";b:1;s:8:\"use more\";b:1;s:18:\"accept attachments\";b:1;s:10:\"help topic\";s:15:\"display-default\";s:6:\"module\";s:5:\"views\";s:10:\"theme path\";s:29:\"sites/all/modules/views/theme\";s:10:\"theme file\";s:9:\"theme.inc\";s:4:\"path\";s:31:\"sites/all/modules/views/plugins\";s:4:\"file\";s:32:\"views_plugin_display_default.inc\";s:6:\"parent\";s:6:\"parent\";s:4:\"name\";s:7:\"default\";s:16:\"contextual links\";a:1:{s:8:\"views_ui\";a:2:{s:11:\"parent path\";s:26:\"admin/structure/views/view\";s:19:\"argument properties\";a:1:{i:0;s:4:\"name\";}}}}s:9:\"is_plugin\";b:1;}s:15:\"display_options\";a:13:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:1:{s:13:\"query_comment\";b:0;}}s:5:\"title\";s:15:\"Recent comments\";s:8:\"use_more\";b:1;s:6:\"access\";a:2:{s:4:\"type\";s:4:\"perm\";s:4:\"perm\";s:15:\"access comments\";}s:5:\"cache\";a:1:{s:4:\"type\";s:4:\"none\";}s:12:\"exposed_form\";a:1:{s:4:\"type\";s:5:\"basic\";}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"some\";s:7:\"options\";a:1:{s:14:\"items_per_page\";i:5;}}s:12:\"style_plugin\";s:4:\"list\";s:10:\"row_plugin\";s:6:\"fields\";s:13:\"relationships\";a:1:{s:3:\"nid\";a:3:{s:2:\"id\";s:3:\"nid\";s:5:\"table\";s:7:\"comment\";s:5:\"field\";s:3:\"nid\";}}s:6:\"fields\";a:2:{s:7:\"subject\";a:5:{s:2:\"id\";s:7:\"subject\";s:5:\"table\";s:7:\"comment\";s:5:\"field\";s:7:\"subject\";s:5:\"label\";s:0:\"\";s:15:\"link_to_comment\";i:1;}s:9:\"timestamp\";a:5:{s:2:\"id\";s:9:\"timestamp\";s:5:\"table\";s:7:\"comment\";s:5:\"field\";s:7:\"changed\";s:5:\"label\";s:0:\"\";s:11:\"date_format\";s:8:\"time ago\";}}s:5:\"sorts\";a:1:{s:9:\"timestamp\";a:4:{s:2:\"id\";s:9:\"timestamp\";s:5:\"table\";s:7:\"comment\";s:5:\"field\";s:7:\"changed\";s:5:\"order\";s:4:\"DESC\";}}s:7:\"filters\";a:1:{s:12:\"status_extra\";a:5:{s:2:\"id\";s:12:\"status_extra\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:12:\"status_extra\";s:12:\"relationship\";s:3:\"nid\";s:5:\"group\";i:0;}}}s:8:\"db_table\";s:13:\"views_display\";s:3:\"vid\";i:0;s:2:\"id\";s:7:\"default\";s:13:\"display_title\";s:6:\"Master\";s:14:\"display_plugin\";s:7:\"default\";s:8:\"position\";i:0;}s:4:\"page\";O:13:\"views_display\":8:{s:7:\"handler\";O:25:\"views_plugin_display_page\":10:{s:4:\"view\";r:1;s:8:\"handlers\";a:0:{}s:8:\"extender\";a:0:{}s:7:\"display\";R:182;s:11:\"plugin_type\";s:7:\"display\";s:11:\"plugin_name\";s:4:\"page\";s:7:\"options\";a:42:{s:8:\"defaults\";a:32:{s:6:\"access\";b:1;s:5:\"cache\";b:1;s:5:\"query\";b:1;s:5:\"title\";b:1;s:9:\"css_class\";b:1;s:19:\"display_description\";b:0;s:8:\"use_ajax\";b:1;s:23:\"hide_attachment_summary\";b:1;s:16:\"hide_admin_links\";b:1;s:5:\"pager\";b:1;s:13:\"pager_options\";b:1;s:8:\"use_more\";b:1;s:15:\"use_more_always\";b:1;s:13:\"use_more_text\";b:1;s:12:\"exposed_form\";b:1;s:20:\"exposed_form_options\";b:1;s:12:\"link_display\";b:1;s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:1;s:12:\"style_plugin\";b:1;s:13:\"style_options\";b:1;s:10:\"row_plugin\";b:1;s:11:\"row_options\";b:1;s:6:\"header\";b:1;s:6:\"footer\";b:1;s:5:\"empty\";b:1;s:13:\"relationships\";b:1;s:6:\"fields\";b:1;s:5:\"sorts\";b:1;s:9:\"arguments\";b:1;s:7:\"filters\";b:1;s:13:\"filter_groups\";b:1;}s:5:\"title\";s:0:\"\";s:7:\"enabled\";b:1;s:15:\"display_comment\";s:0:\"\";s:9:\"css_class\";s:0:\"\";s:19:\"display_description\";s:0:\"\";s:8:\"use_ajax\";b:0;s:23:\"hide_attachment_summary\";b:0;s:16:\"hide_admin_links\";b:0;s:14:\"items_per_page\";i:10;s:6:\"offset\";i:0;s:9:\"use_pager\";b:0;s:8:\"use_more\";b:0;s:15:\"use_more_always\";b:0;s:13:\"use_more_text\";s:4:\"more\";s:12:\"link_display\";s:0:\"\";s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:0;s:14:\"field_language\";s:22:\"***CURRENT_LANGUAGE***\";s:27:\"field_language_add_to_query\";i:1;s:6:\"access\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"cache\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:0:{}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"full\";s:7:\"options\";a:0:{}}s:12:\"style_plugin\";s:7:\"default\";s:13:\"style_options\";a:0:{}s:10:\"row_plugin\";s:6:\"fields\";s:11:\"row_options\";a:0:{}s:13:\"exposed_block\";b:0;s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:0:{}s:13:\"relationships\";a:0:{}s:6:\"fields\";a:0:{}s:5:\"sorts\";a:0:{}s:9:\"arguments\";a:0:{}s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}s:7:\"filters\";a:0:{}s:4:\"path\";s:0:\"\";s:4:\"menu\";a:7:{s:4:\"type\";s:4:\"none\";s:5:\"title\";s:0:\"\";s:11:\"description\";s:0:\"\";s:6:\"weight\";i:0;s:4:\"name\";s:10:\"navigation\";s:7:\"context\";s:0:\"\";s:19:\"context_only_inline\";b:0;}s:11:\"tab_options\";a:5:{s:4:\"type\";s:4:\"none\";s:5:\"title\";s:0:\"\";s:11:\"description\";s:0:\"\";s:6:\"weight\";i:0;s:4:\"name\";s:10:\"navigation\";}}s:10:\"definition\";a:20:{s:5:\"title\";s:4:\"Page\";s:4:\"help\";s:54:\"Display the view as a page, with a URL and menu links.\";s:7:\"handler\";s:25:\"views_plugin_display_page\";s:5:\"theme\";s:10:\"views_view\";s:14:\"uses hook menu\";b:1;s:26:\"contextual links locations\";a:1:{i:0;s:4:\"page\";}s:8:\"use ajax\";b:1;s:9:\"use pager\";b:1;s:8:\"use more\";b:1;s:18:\"accept attachments\";b:1;s:5:\"admin\";s:4:\"Page\";s:10:\"help topic\";s:12:\"display-page\";s:6:\"module\";s:5:\"views\";s:10:\"theme path\";s:29:\"sites/all/modules/views/theme\";s:10:\"theme file\";s:9:\"theme.inc\";s:4:\"path\";s:31:\"sites/all/modules/views/plugins\";s:4:\"file\";s:29:\"views_plugin_display_page.inc\";s:6:\"parent\";s:6:\"parent\";s:4:\"name\";s:4:\"page\";s:16:\"contextual links\";a:1:{s:8:\"views_ui\";a:2:{s:11:\"parent path\";s:26:\"admin/structure/views/view\";s:19:\"argument properties\";a:1:{i:0;s:4:\"name\";}}}}s:9:\"is_plugin\";b:1;s:15:\"default_display\";R:37;}s:15:\"display_options\";a:7:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:8:\"defaults\";a:5:{s:12:\"style_plugin\";b:0;s:13:\"style_options\";b:0;s:10:\"row_plugin\";b:0;s:11:\"row_options\";b:0;s:6:\"fields\";b:0;}s:12:\"style_plugin\";s:4:\"list\";s:10:\"row_plugin\";s:6:\"fields\";s:11:\"row_options\";a:2:{s:6:\"inline\";a:2:{s:5:\"title\";s:5:\"title\";s:9:\"timestamp\";s:9:\"timestamp\";}s:9:\"separator\";s:6:\"&nbsp;\";}s:6:\"fields\";a:4:{s:5:\"title\";a:6:{s:2:\"id\";s:5:\"title\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:5:\"title\";s:12:\"relationship\";s:3:\"nid\";s:5:\"label\";s:8:\"Reply to\";s:12:\"link_to_node\";i:1;}s:9:\"timestamp\";a:5:{s:2:\"id\";s:9:\"timestamp\";s:5:\"table\";s:7:\"comment\";s:5:\"field\";s:7:\"changed\";s:5:\"label\";s:0:\"\";s:11:\"date_format\";s:8:\"time ago\";}s:7:\"subject\";a:5:{s:2:\"id\";s:7:\"subject\";s:5:\"table\";s:7:\"comment\";s:5:\"field\";s:7:\"subject\";s:5:\"label\";s:0:\"\";s:15:\"link_to_comment\";i:1;}s:7:\"comment\";a:4:{s:2:\"id\";s:7:\"comment\";s:5:\"table\";s:23:\"field_data_comment_body\";s:5:\"field\";s:12:\"comment_body\";s:5:\"label\";s:0:\"\";}}s:4:\"path\";s:15:\"comments/recent\";}s:8:\"db_table\";s:13:\"views_display\";s:3:\"vid\";i:0;s:2:\"id\";s:4:\"page\";s:13:\"display_title\";s:4:\"Page\";s:14:\"display_plugin\";s:4:\"page\";s:8:\"position\";i:0;}s:5:\"block\";O:13:\"views_display\":8:{s:7:\"handler\";O:26:\"views_plugin_display_block\":10:{s:4:\"view\";r:1;s:8:\"handlers\";a:0:{}s:8:\"extender\";a:0:{}s:7:\"display\";R:363;s:11:\"plugin_type\";s:7:\"display\";s:11:\"plugin_name\";s:5:\"block\";s:7:\"options\";a:41:{s:8:\"defaults\";a:32:{s:6:\"access\";b:1;s:5:\"cache\";b:1;s:5:\"query\";b:1;s:5:\"title\";b:1;s:9:\"css_class\";b:1;s:19:\"display_description\";b:0;s:8:\"use_ajax\";b:1;s:23:\"hide_attachment_summary\";b:1;s:16:\"hide_admin_links\";b:1;s:5:\"pager\";b:1;s:13:\"pager_options\";b:1;s:8:\"use_more\";b:1;s:15:\"use_more_always\";b:1;s:13:\"use_more_text\";b:1;s:12:\"exposed_form\";b:1;s:20:\"exposed_form_options\";b:1;s:12:\"link_display\";b:1;s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:1;s:12:\"style_plugin\";b:1;s:13:\"style_options\";b:1;s:10:\"row_plugin\";b:1;s:11:\"row_options\";b:1;s:6:\"header\";b:1;s:6:\"footer\";b:1;s:5:\"empty\";b:1;s:13:\"relationships\";b:1;s:6:\"fields\";b:1;s:5:\"sorts\";b:1;s:9:\"arguments\";b:1;s:7:\"filters\";b:1;s:13:\"filter_groups\";b:1;}s:5:\"title\";s:0:\"\";s:7:\"enabled\";b:1;s:15:\"display_comment\";s:0:\"\";s:9:\"css_class\";s:0:\"\";s:19:\"display_description\";s:0:\"\";s:8:\"use_ajax\";b:0;s:23:\"hide_attachment_summary\";b:0;s:16:\"hide_admin_links\";b:0;s:14:\"items_per_page\";i:10;s:6:\"offset\";i:0;s:9:\"use_pager\";b:0;s:8:\"use_more\";b:0;s:15:\"use_more_always\";b:0;s:13:\"use_more_text\";s:4:\"more\";s:12:\"link_display\";s:0:\"\";s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:0;s:14:\"field_language\";s:22:\"***CURRENT_LANGUAGE***\";s:27:\"field_language_add_to_query\";i:1;s:6:\"access\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"cache\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:0:{}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"full\";s:7:\"options\";a:0:{}}s:12:\"style_plugin\";s:7:\"default\";s:13:\"style_options\";a:0:{}s:10:\"row_plugin\";s:6:\"fields\";s:11:\"row_options\";a:0:{}s:13:\"exposed_block\";b:0;s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:0:{}s:13:\"relationships\";a:0:{}s:6:\"fields\";a:0:{}s:5:\"sorts\";a:0:{}s:9:\"arguments\";a:0:{}s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}s:7:\"filters\";a:0:{}s:17:\"block_description\";s:0:\"\";s:13:\"block_caching\";i:-1;}s:10:\"definition\";a:20:{s:5:\"title\";s:5:\"Block\";s:4:\"help\";s:28:\"Display the view as a block.\";s:7:\"handler\";s:26:\"views_plugin_display_block\";s:5:\"theme\";s:10:\"views_view\";s:15:\"uses hook block\";b:1;s:26:\"contextual links locations\";a:1:{i:0;s:5:\"block\";}s:8:\"use ajax\";b:1;s:9:\"use pager\";b:1;s:8:\"use more\";b:1;s:18:\"accept attachments\";b:1;s:5:\"admin\";s:5:\"Block\";s:10:\"help topic\";s:13:\"display-block\";s:6:\"module\";s:5:\"views\";s:10:\"theme path\";s:29:\"sites/all/modules/views/theme\";s:10:\"theme file\";s:9:\"theme.inc\";s:4:\"path\";s:31:\"sites/all/modules/views/plugins\";s:4:\"file\";s:30:\"views_plugin_display_block.inc\";s:6:\"parent\";s:6:\"parent\";s:4:\"name\";s:5:\"block\";s:16:\"contextual links\";a:1:{s:8:\"views_ui\";a:2:{s:11:\"parent path\";s:26:\"admin/structure/views/view\";s:19:\"argument properties\";a:1:{i:0;s:4:\"name\";}}}}s:9:\"is_plugin\";b:1;s:15:\"default_display\";R:37;}s:15:\"display_options\";a:1:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}}s:8:\"db_table\";s:13:\"views_display\";s:3:\"vid\";i:0;s:2:\"id\";s:5:\"block\";s:13:\"display_title\";s:5:\"Block\";s:14:\"display_plugin\";s:5:\"block\";s:8:\"position\";i:0;}}s:12:\"style_plugin\";N;s:13:\"style_options\";N;s:9:\"row_index\";N;s:12:\"override_url\";N;s:13:\"override_path\";N;s:13:\"base_database\";N;s:5:\"field\";N;s:8:\"argument\";N;s:4:\"sort\";N;s:6:\"filter\";N;s:12:\"relationship\";N;s:6:\"header\";N;s:6:\"footer\";N;s:5:\"empty\";N;s:19:\"localization_plugin\";O:30:\"views_plugin_localization_core\":9:{s:14:\"export_strings\";a:0:{}s:9:\"translate\";b:1;s:4:\"view\";r:1;s:7:\"display\";N;s:11:\"plugin_type\";s:12:\"localization\";s:11:\"plugin_name\";s:4:\"core\";s:7:\"options\";a:0:{}s:10:\"definition\";a:11:{s:5:\"title\";s:4:\"Core\";s:4:\"help\";s:283:\"Use Drupal core t() function. Not recommended, as it doesn\'t support updates to existing strings. If you need to translate Views labels into other languages, consider installing the <a href=\"http://drupal.org/project/i18n\">Internationalization</a> package\'s Views translation module.\";s:7:\"handler\";s:30:\"views_plugin_localization_core\";s:10:\"help topic\";s:17:\"localization-core\";s:6:\"module\";s:5:\"views\";s:10:\"theme path\";s:29:\"sites/all/modules/views/theme\";s:10:\"theme file\";s:9:\"theme.inc\";s:4:\"path\";s:31:\"sites/all/modules/views/plugins\";s:4:\"file\";s:34:\"views_plugin_localization_core.inc\";s:6:\"parent\";s:6:\"parent\";s:4:\"name\";s:4:\"core\";}s:9:\"is_plugin\";b:1;}s:13:\"export_module\";s:7:\"comment\";}',0,1512620340,1),('ctools_export:views_view:faq','O:4:\"view\":50:{s:8:\"db_table\";s:10:\"views_view\";s:10:\"base_table\";s:4:\"node\";s:10:\"base_field\";s:3:\"nid\";s:4:\"name\";s:3:\"faq\";s:3:\"vid\";s:0:\"\";s:11:\"description\";s:12:\"FAQ listings\";s:3:\"tag\";s:7:\"default\";s:10:\"human_name\";s:3:\"FAQ\";s:4:\"core\";i:7;s:11:\"api_version\";s:3:\"3.0\";s:8:\"disabled\";b:0;s:5:\"built\";b:0;s:8:\"executed\";b:0;s:7:\"editing\";b:0;s:4:\"args\";a:0:{}s:10:\"build_info\";a:0:{}s:8:\"use_ajax\";b:0;s:6:\"result\";a:0:{}s:12:\"current_page\";N;s:14:\"items_per_page\";N;s:6:\"offset\";N;s:10:\"total_rows\";N;s:17:\"attachment_before\";s:0:\"\";s:16:\"attachment_after\";s:0:\"\";s:12:\"exposed_data\";a:0:{}s:13:\"exposed_input\";a:0:{}s:17:\"exposed_raw_input\";a:0:{}s:8:\"old_view\";a:0:{}s:12:\"parent_views\";a:0:{}s:13:\"is_attachment\";N;s:15:\"current_display\";N;s:5:\"query\";N;s:15:\"display_handler\";N;s:7:\"display\";a:8:{s:7:\"default\";O:13:\"views_display\":8:{s:7:\"handler\";O:28:\"views_plugin_display_default\":9:{s:4:\"view\";r:1;s:8:\"handlers\";a:0:{}s:8:\"extender\";a:0:{}s:7:\"display\";R:36;s:11:\"plugin_type\";s:7:\"display\";s:11:\"plugin_name\";s:7:\"default\";s:7:\"options\";a:38:{s:5:\"title\";s:0:\"\";s:7:\"enabled\";b:1;s:15:\"display_comment\";s:0:\"\";s:9:\"css_class\";s:0:\"\";s:19:\"display_description\";s:0:\"\";s:8:\"use_ajax\";b:0;s:23:\"hide_attachment_summary\";b:0;s:16:\"hide_admin_links\";b:0;s:14:\"items_per_page\";i:10;s:6:\"offset\";i:0;s:9:\"use_pager\";b:0;s:8:\"use_more\";b:0;s:15:\"use_more_always\";b:0;s:13:\"use_more_text\";s:4:\"more\";s:12:\"link_display\";s:0:\"\";s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:0;s:14:\"field_language\";s:22:\"***CURRENT_LANGUAGE***\";s:27:\"field_language_add_to_query\";i:1;s:6:\"access\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"cache\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:0:{}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"full\";s:7:\"options\";a:0:{}}s:12:\"style_plugin\";s:7:\"default\";s:13:\"style_options\";a:0:{}s:10:\"row_plugin\";s:6:\"fields\";s:11:\"row_options\";a:0:{}s:13:\"exposed_block\";b:0;s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:0:{}s:13:\"relationships\";a:0:{}s:6:\"fields\";a:0:{}s:5:\"sorts\";a:0:{}s:9:\"arguments\";a:0:{}s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}s:7:\"filters\";a:0:{}}s:10:\"definition\";a:20:{s:5:\"title\";s:6:\"Master\";s:4:\"help\";s:31:\"Default settings for this view.\";s:7:\"handler\";s:28:\"views_plugin_display_default\";s:5:\"theme\";s:10:\"views_view\";s:5:\"no ui\";b:1;s:9:\"no remove\";b:1;s:2:\"js\";a:6:{i:0;s:12:\"misc/form.js\";i:1;s:16:\"misc/collapse.js\";i:2;s:16:\"misc/textarea.js\";i:3;s:17:\"misc/tabledrag.js\";i:4;s:20:\"misc/autocomplete.js\";i:5;s:40:\"sites/all/modules/ctools/js/dependent.js\";}s:8:\"use ajax\";b:1;s:9:\"use pager\";b:1;s:8:\"use more\";b:1;s:18:\"accept attachments\";b:1;s:10:\"help topic\";s:15:\"display-default\";s:6:\"module\";s:5:\"views\";s:10:\"theme path\";s:29:\"sites/all/modules/views/theme\";s:10:\"theme file\";s:9:\"theme.inc\";s:4:\"path\";s:31:\"sites/all/modules/views/plugins\";s:4:\"file\";s:32:\"views_plugin_display_default.inc\";s:6:\"parent\";s:6:\"parent\";s:4:\"name\";s:7:\"default\";s:16:\"contextual links\";a:1:{s:8:\"views_ui\";a:2:{s:11:\"parent path\";s:26:\"admin/structure/views/view\";s:19:\"argument properties\";a:1:{i:0;s:4:\"name\";}}}}s:9:\"is_plugin\";b:1;}s:15:\"display_options\";a:14:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:1:{s:13:\"query_comment\";b:0;}}s:5:\"title\";s:3:\"FAQ\";s:8:\"use_more\";b:1;s:15:\"use_more_always\";b:1;s:13:\"use_more_text\";s:13:\"View all FAQs\";s:6:\"access\";a:1:{s:4:\"type\";s:4:\"perm\";}s:5:\"cache\";a:1:{s:4:\"type\";s:4:\"none\";}s:12:\"exposed_form\";a:1:{s:4:\"type\";s:5:\"basic\";}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"full\";s:7:\"options\";a:1:{s:14:\"items_per_page\";s:2:\"10\";}}s:12:\"style_plugin\";s:7:\"default\";s:10:\"row_plugin\";s:4:\"node\";s:6:\"fields\";a:1:{s:5:\"title\";a:8:{s:2:\"id\";s:5:\"title\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:5:\"title\";s:5:\"label\";s:0:\"\";s:5:\"alter\";a:8:{s:10:\"alter_text\";i:0;s:9:\"make_link\";i:0;s:8:\"absolute\";i:0;s:13:\"word_boundary\";i:0;s:8:\"ellipsis\";i:0;s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:4:\"html\";i:0;}s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:12:\"link_to_node\";i:1;}}s:5:\"sorts\";a:2:{s:6:\"sticky\";a:4:{s:2:\"id\";s:6:\"sticky\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:6:\"sticky\";s:5:\"order\";s:4:\"DESC\";}s:7:\"created\";a:4:{s:2:\"id\";s:7:\"created\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:7:\"created\";s:5:\"order\";s:4:\"DESC\";}}s:7:\"filters\";a:3:{s:6:\"status\";a:6:{s:2:\"id\";s:6:\"status\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:6:\"status\";s:5:\"value\";i:1;s:5:\"group\";i:0;s:6:\"expose\";a:1:{s:8:\"operator\";b:0;}}s:4:\"type\";a:4:{s:2:\"id\";s:4:\"type\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:4:\"type\";s:5:\"value\";a:1:{s:3:\"faq\";s:3:\"faq\";}}s:8:\"language\";a:4:{s:2:\"id\";s:8:\"language\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:8:\"language\";s:5:\"value\";a:2:{s:22:\"***CURRENT_LANGUAGE***\";s:22:\"***CURRENT_LANGUAGE***\";s:3:\"und\";s:3:\"und\";}}}}s:8:\"db_table\";s:13:\"views_display\";s:3:\"vid\";i:0;s:2:\"id\";s:7:\"default\";s:13:\"display_title\";s:6:\"Master\";s:14:\"display_plugin\";s:7:\"default\";s:8:\"position\";i:0;}s:10:\"faq_recent\";O:13:\"views_display\":8:{s:7:\"handler\";O:26:\"views_plugin_display_block\":10:{s:4:\"view\";r:1;s:8:\"handlers\";a:0:{}s:8:\"extender\";a:0:{}s:7:\"display\";R:203;s:11:\"plugin_type\";s:7:\"display\";s:11:\"plugin_name\";s:5:\"block\";s:7:\"options\";a:41:{s:8:\"defaults\";a:32:{s:6:\"access\";b:1;s:5:\"cache\";b:1;s:5:\"query\";b:1;s:5:\"title\";b:1;s:9:\"css_class\";b:1;s:19:\"display_description\";b:0;s:8:\"use_ajax\";b:1;s:23:\"hide_attachment_summary\";b:1;s:16:\"hide_admin_links\";b:1;s:5:\"pager\";b:1;s:13:\"pager_options\";b:1;s:8:\"use_more\";b:1;s:15:\"use_more_always\";b:1;s:13:\"use_more_text\";b:1;s:12:\"exposed_form\";b:1;s:20:\"exposed_form_options\";b:1;s:12:\"link_display\";b:1;s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:1;s:12:\"style_plugin\";b:1;s:13:\"style_options\";b:1;s:10:\"row_plugin\";b:1;s:11:\"row_options\";b:1;s:6:\"header\";b:1;s:6:\"footer\";b:1;s:5:\"empty\";b:1;s:13:\"relationships\";b:1;s:6:\"fields\";b:1;s:5:\"sorts\";b:1;s:9:\"arguments\";b:1;s:7:\"filters\";b:1;s:13:\"filter_groups\";b:1;}s:5:\"title\";s:0:\"\";s:7:\"enabled\";b:1;s:15:\"display_comment\";s:0:\"\";s:9:\"css_class\";s:0:\"\";s:19:\"display_description\";s:0:\"\";s:8:\"use_ajax\";b:0;s:23:\"hide_attachment_summary\";b:0;s:16:\"hide_admin_links\";b:0;s:14:\"items_per_page\";i:10;s:6:\"offset\";i:0;s:9:\"use_pager\";b:0;s:8:\"use_more\";b:0;s:15:\"use_more_always\";b:0;s:13:\"use_more_text\";s:4:\"more\";s:12:\"link_display\";s:0:\"\";s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:0;s:14:\"field_language\";s:22:\"***CURRENT_LANGUAGE***\";s:27:\"field_language_add_to_query\";i:1;s:6:\"access\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"cache\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:0:{}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"full\";s:7:\"options\";a:0:{}}s:12:\"style_plugin\";s:7:\"default\";s:13:\"style_options\";a:0:{}s:10:\"row_plugin\";s:6:\"fields\";s:11:\"row_options\";a:0:{}s:13:\"exposed_block\";b:0;s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:0:{}s:13:\"relationships\";a:0:{}s:6:\"fields\";a:0:{}s:5:\"sorts\";a:0:{}s:9:\"arguments\";a:0:{}s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}s:7:\"filters\";a:0:{}s:17:\"block_description\";s:0:\"\";s:13:\"block_caching\";i:-1;}s:10:\"definition\";a:20:{s:5:\"title\";s:5:\"Block\";s:4:\"help\";s:28:\"Display the view as a block.\";s:7:\"handler\";s:26:\"views_plugin_display_block\";s:5:\"theme\";s:10:\"views_view\";s:15:\"uses hook block\";b:1;s:26:\"contextual links locations\";a:1:{i:0;s:5:\"block\";}s:8:\"use ajax\";b:1;s:9:\"use pager\";b:1;s:8:\"use more\";b:1;s:18:\"accept attachments\";b:1;s:5:\"admin\";s:5:\"Block\";s:10:\"help topic\";s:13:\"display-block\";s:6:\"module\";s:5:\"views\";s:10:\"theme path\";s:29:\"sites/all/modules/views/theme\";s:10:\"theme file\";s:9:\"theme.inc\";s:4:\"path\";s:31:\"sites/all/modules/views/plugins\";s:4:\"file\";s:30:\"views_plugin_display_block.inc\";s:6:\"parent\";s:6:\"parent\";s:4:\"name\";s:5:\"block\";s:16:\"contextual links\";a:1:{s:8:\"views_ui\";a:2:{s:11:\"parent path\";s:26:\"admin/structure/views/view\";s:19:\"argument properties\";a:1:{i:0;s:4:\"name\";}}}}s:9:\"is_plugin\";b:1;s:15:\"default_display\";R:37;}s:15:\"display_options\";a:11:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:8:\"defaults\";a:7:{s:5:\"title\";b:0;s:8:\"use_more\";b:0;s:5:\"pager\";b:0;s:12:\"style_plugin\";b:0;s:13:\"style_options\";b:0;s:10:\"row_plugin\";b:0;s:11:\"row_options\";b:0;}s:5:\"title\";s:11:\"Recent FAQs\";s:8:\"use_more\";b:1;s:15:\"use_more_always\";b:1;s:13:\"use_more_text\";s:13:\"View all FAQs\";s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"some\";s:7:\"options\";a:2:{s:14:\"items_per_page\";s:1:\"5\";s:6:\"offset\";s:1:\"0\";}}s:12:\"style_plugin\";s:4:\"list\";s:13:\"style_options\";a:1:{s:8:\"grouping\";s:0:\"\";}s:10:\"row_plugin\";s:6:\"fields\";s:17:\"block_description\";s:11:\"Recent FAQs\";}s:8:\"db_table\";s:13:\"views_display\";s:3:\"vid\";i:0;s:2:\"id\";s:10:\"faq_recent\";s:13:\"display_title\";s:19:\"Block - Recent FAQs\";s:14:\"display_plugin\";s:5:\"block\";s:8:\"position\";i:0;}s:10:\"faq_random\";O:13:\"views_display\":8:{s:7:\"handler\";O:26:\"views_plugin_display_block\":10:{s:4:\"view\";r:1;s:8:\"handlers\";a:0:{}s:8:\"extender\";a:0:{}s:7:\"display\";R:354;s:11:\"plugin_type\";s:7:\"display\";s:11:\"plugin_name\";s:5:\"block\";s:7:\"options\";a:41:{s:8:\"defaults\";a:32:{s:6:\"access\";b:1;s:5:\"cache\";b:1;s:5:\"query\";b:1;s:5:\"title\";b:1;s:9:\"css_class\";b:1;s:19:\"display_description\";b:0;s:8:\"use_ajax\";b:1;s:23:\"hide_attachment_summary\";b:1;s:16:\"hide_admin_links\";b:1;s:5:\"pager\";b:1;s:13:\"pager_options\";b:1;s:8:\"use_more\";b:1;s:15:\"use_more_always\";b:1;s:13:\"use_more_text\";b:1;s:12:\"exposed_form\";b:1;s:20:\"exposed_form_options\";b:1;s:12:\"link_display\";b:1;s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:1;s:12:\"style_plugin\";b:1;s:13:\"style_options\";b:1;s:10:\"row_plugin\";b:1;s:11:\"row_options\";b:1;s:6:\"header\";b:1;s:6:\"footer\";b:1;s:5:\"empty\";b:1;s:13:\"relationships\";b:1;s:6:\"fields\";b:1;s:5:\"sorts\";b:1;s:9:\"arguments\";b:1;s:7:\"filters\";b:1;s:13:\"filter_groups\";b:1;}s:5:\"title\";s:0:\"\";s:7:\"enabled\";b:1;s:15:\"display_comment\";s:0:\"\";s:9:\"css_class\";s:0:\"\";s:19:\"display_description\";s:0:\"\";s:8:\"use_ajax\";b:0;s:23:\"hide_attachment_summary\";b:0;s:16:\"hide_admin_links\";b:0;s:14:\"items_per_page\";i:10;s:6:\"offset\";i:0;s:9:\"use_pager\";b:0;s:8:\"use_more\";b:0;s:15:\"use_more_always\";b:0;s:13:\"use_more_text\";s:4:\"more\";s:12:\"link_display\";s:0:\"\";s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:0;s:14:\"field_language\";s:22:\"***CURRENT_LANGUAGE***\";s:27:\"field_language_add_to_query\";i:1;s:6:\"access\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"cache\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:0:{}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"full\";s:7:\"options\";a:0:{}}s:12:\"style_plugin\";s:7:\"default\";s:13:\"style_options\";a:0:{}s:10:\"row_plugin\";s:6:\"fields\";s:11:\"row_options\";a:0:{}s:13:\"exposed_block\";b:0;s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:0:{}s:13:\"relationships\";a:0:{}s:6:\"fields\";a:0:{}s:5:\"sorts\";a:0:{}s:9:\"arguments\";a:0:{}s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}s:7:\"filters\";a:0:{}s:17:\"block_description\";s:0:\"\";s:13:\"block_caching\";i:-1;}s:10:\"definition\";a:20:{s:5:\"title\";s:5:\"Block\";s:4:\"help\";s:28:\"Display the view as a block.\";s:7:\"handler\";s:26:\"views_plugin_display_block\";s:5:\"theme\";s:10:\"views_view\";s:15:\"uses hook block\";b:1;s:26:\"contextual links locations\";a:1:{i:0;s:5:\"block\";}s:8:\"use ajax\";b:1;s:9:\"use pager\";b:1;s:8:\"use more\";b:1;s:18:\"accept attachments\";b:1;s:5:\"admin\";s:5:\"Block\";s:10:\"help topic\";s:13:\"display-block\";s:6:\"module\";s:5:\"views\";s:10:\"theme path\";s:29:\"sites/all/modules/views/theme\";s:10:\"theme file\";s:9:\"theme.inc\";s:4:\"path\";s:31:\"sites/all/modules/views/plugins\";s:4:\"file\";s:30:\"views_plugin_display_block.inc\";s:6:\"parent\";s:6:\"parent\";s:4:\"name\";s:5:\"block\";s:16:\"contextual links\";a:1:{s:8:\"views_ui\";a:2:{s:11:\"parent path\";s:26:\"admin/structure/views/view\";s:19:\"argument properties\";a:1:{i:0;s:4:\"name\";}}}}s:9:\"is_plugin\";b:1;s:15:\"default_display\";R:37;}s:15:\"display_options\";a:12:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:8:\"defaults\";a:8:{s:5:\"title\";b:0;s:8:\"use_more\";b:0;s:5:\"pager\";b:0;s:12:\"style_plugin\";b:0;s:13:\"style_options\";b:0;s:10:\"row_plugin\";b:0;s:11:\"row_options\";b:0;s:5:\"sorts\";b:0;}s:5:\"title\";s:11:\"Random FAQs\";s:8:\"use_more\";b:1;s:15:\"use_more_always\";b:1;s:13:\"use_more_text\";s:13:\"View all FAQs\";s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"some\";s:7:\"options\";a:2:{s:14:\"items_per_page\";s:1:\"5\";s:6:\"offset\";s:1:\"0\";}}s:12:\"style_plugin\";s:4:\"list\";s:10:\"row_plugin\";s:6:\"fields\";s:11:\"row_options\";a:2:{s:10:\"hide_empty\";i:0;s:22:\"default_field_elements\";i:1;}s:5:\"sorts\";a:1:{s:6:\"random\";a:3:{s:2:\"id\";s:6:\"random\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:6:\"random\";}}s:17:\"block_description\";s:11:\"Random FAQs\";}s:8:\"db_table\";s:13:\"views_display\";s:3:\"vid\";i:0;s:2:\"id\";s:10:\"faq_random\";s:13:\"display_title\";s:19:\"Block - Random FAQs\";s:14:\"display_plugin\";s:5:\"block\";s:8:\"position\";i:0;}s:4:\"page\";O:13:\"views_display\":8:{s:7:\"handler\";O:25:\"views_plugin_display_page\":10:{s:4:\"view\";r:1;s:8:\"handlers\";a:0:{}s:8:\"extender\";a:0:{}s:7:\"display\";R:512;s:11:\"plugin_type\";s:7:\"display\";s:11:\"plugin_name\";s:4:\"page\";s:7:\"options\";a:42:{s:8:\"defaults\";a:32:{s:6:\"access\";b:1;s:5:\"cache\";b:1;s:5:\"query\";b:1;s:5:\"title\";b:1;s:9:\"css_class\";b:1;s:19:\"display_description\";b:0;s:8:\"use_ajax\";b:1;s:23:\"hide_attachment_summary\";b:1;s:16:\"hide_admin_links\";b:1;s:5:\"pager\";b:1;s:13:\"pager_options\";b:1;s:8:\"use_more\";b:1;s:15:\"use_more_always\";b:1;s:13:\"use_more_text\";b:1;s:12:\"exposed_form\";b:1;s:20:\"exposed_form_options\";b:1;s:12:\"link_display\";b:1;s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:1;s:12:\"style_plugin\";b:1;s:13:\"style_options\";b:1;s:10:\"row_plugin\";b:1;s:11:\"row_options\";b:1;s:6:\"header\";b:1;s:6:\"footer\";b:1;s:5:\"empty\";b:1;s:13:\"relationships\";b:1;s:6:\"fields\";b:1;s:5:\"sorts\";b:1;s:9:\"arguments\";b:1;s:7:\"filters\";b:1;s:13:\"filter_groups\";b:1;}s:5:\"title\";s:0:\"\";s:7:\"enabled\";b:1;s:15:\"display_comment\";s:0:\"\";s:9:\"css_class\";s:0:\"\";s:19:\"display_description\";s:0:\"\";s:8:\"use_ajax\";b:0;s:23:\"hide_attachment_summary\";b:0;s:16:\"hide_admin_links\";b:0;s:14:\"items_per_page\";i:10;s:6:\"offset\";i:0;s:9:\"use_pager\";b:0;s:8:\"use_more\";b:0;s:15:\"use_more_always\";b:0;s:13:\"use_more_text\";s:4:\"more\";s:12:\"link_display\";s:0:\"\";s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:0;s:14:\"field_language\";s:22:\"***CURRENT_LANGUAGE***\";s:27:\"field_language_add_to_query\";i:1;s:6:\"access\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"cache\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:0:{}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"full\";s:7:\"options\";a:0:{}}s:12:\"style_plugin\";s:7:\"default\";s:13:\"style_options\";a:0:{}s:10:\"row_plugin\";s:6:\"fields\";s:11:\"row_options\";a:0:{}s:13:\"exposed_block\";b:0;s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:0:{}s:13:\"relationships\";a:0:{}s:6:\"fields\";a:0:{}s:5:\"sorts\";a:0:{}s:9:\"arguments\";a:0:{}s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}s:7:\"filters\";a:0:{}s:4:\"path\";s:0:\"\";s:4:\"menu\";a:7:{s:4:\"type\";s:4:\"none\";s:5:\"title\";s:0:\"\";s:11:\"description\";s:0:\"\";s:6:\"weight\";i:0;s:4:\"name\";s:10:\"navigation\";s:7:\"context\";s:0:\"\";s:19:\"context_only_inline\";b:0;}s:11:\"tab_options\";a:5:{s:4:\"type\";s:4:\"none\";s:5:\"title\";s:0:\"\";s:11:\"description\";s:0:\"\";s:6:\"weight\";i:0;s:4:\"name\";s:10:\"navigation\";}}s:10:\"definition\";a:20:{s:5:\"title\";s:4:\"Page\";s:4:\"help\";s:54:\"Display the view as a page, with a URL and menu links.\";s:7:\"handler\";s:25:\"views_plugin_display_page\";s:5:\"theme\";s:10:\"views_view\";s:14:\"uses hook menu\";b:1;s:26:\"contextual links locations\";a:1:{i:0;s:4:\"page\";}s:8:\"use ajax\";b:1;s:9:\"use pager\";b:1;s:8:\"use more\";b:1;s:18:\"accept attachments\";b:1;s:5:\"admin\";s:4:\"Page\";s:10:\"help topic\";s:12:\"display-page\";s:6:\"module\";s:5:\"views\";s:10:\"theme path\";s:29:\"sites/all/modules/views/theme\";s:10:\"theme file\";s:9:\"theme.inc\";s:4:\"path\";s:31:\"sites/all/modules/views/plugins\";s:4:\"file\";s:29:\"views_plugin_display_page.inc\";s:6:\"parent\";s:6:\"parent\";s:4:\"name\";s:4:\"page\";s:16:\"contextual links\";a:1:{s:8:\"views_ui\";a:2:{s:11:\"parent path\";s:26:\"admin/structure/views/view\";s:19:\"argument properties\";a:1:{i:0;s:4:\"name\";}}}}s:9:\"is_plugin\";b:1;s:15:\"default_display\";R:37;}s:15:\"display_options\";a:3:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:7:\"enabled\";b:0;s:4:\"path\";s:20:\"faq-questions-inline\";}s:8:\"db_table\";s:13:\"views_display\";s:3:\"vid\";i:0;s:2:\"id\";s:4:\"page\";s:13:\"display_title\";s:23:\"Page - Questions Inline\";s:14:\"display_plugin\";s:4:\"page\";s:8:\"position\";i:0;}s:6:\"page_1\";O:13:\"views_display\":8:{s:7:\"handler\";O:25:\"views_plugin_display_page\":10:{s:4:\"view\";r:1;s:8:\"handlers\";a:0:{}s:8:\"extender\";a:0:{}s:7:\"display\";R:656;s:11:\"plugin_type\";s:7:\"display\";s:11:\"plugin_name\";s:4:\"page\";s:7:\"options\";a:42:{s:8:\"defaults\";a:32:{s:6:\"access\";b:1;s:5:\"cache\";b:1;s:5:\"query\";b:1;s:5:\"title\";b:1;s:9:\"css_class\";b:1;s:19:\"display_description\";b:0;s:8:\"use_ajax\";b:1;s:23:\"hide_attachment_summary\";b:1;s:16:\"hide_admin_links\";b:1;s:5:\"pager\";b:1;s:13:\"pager_options\";b:1;s:8:\"use_more\";b:1;s:15:\"use_more_always\";b:1;s:13:\"use_more_text\";b:1;s:12:\"exposed_form\";b:1;s:20:\"exposed_form_options\";b:1;s:12:\"link_display\";b:1;s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:1;s:12:\"style_plugin\";b:1;s:13:\"style_options\";b:1;s:10:\"row_plugin\";b:1;s:11:\"row_options\";b:1;s:6:\"header\";b:1;s:6:\"footer\";b:1;s:5:\"empty\";b:1;s:13:\"relationships\";b:1;s:6:\"fields\";b:1;s:5:\"sorts\";b:1;s:9:\"arguments\";b:1;s:7:\"filters\";b:1;s:13:\"filter_groups\";b:1;}s:5:\"title\";s:0:\"\";s:7:\"enabled\";b:1;s:15:\"display_comment\";s:0:\"\";s:9:\"css_class\";s:0:\"\";s:19:\"display_description\";s:0:\"\";s:8:\"use_ajax\";b:0;s:23:\"hide_attachment_summary\";b:0;s:16:\"hide_admin_links\";b:0;s:14:\"items_per_page\";i:10;s:6:\"offset\";i:0;s:9:\"use_pager\";b:0;s:8:\"use_more\";b:0;s:15:\"use_more_always\";b:0;s:13:\"use_more_text\";s:4:\"more\";s:12:\"link_display\";s:0:\"\";s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:0;s:14:\"field_language\";s:22:\"***CURRENT_LANGUAGE***\";s:27:\"field_language_add_to_query\";i:1;s:6:\"access\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"cache\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:0:{}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"full\";s:7:\"options\";a:0:{}}s:12:\"style_plugin\";s:7:\"default\";s:13:\"style_options\";a:0:{}s:10:\"row_plugin\";s:6:\"fields\";s:11:\"row_options\";a:0:{}s:13:\"exposed_block\";b:0;s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:0:{}s:13:\"relationships\";a:0:{}s:6:\"fields\";a:0:{}s:5:\"sorts\";a:0:{}s:9:\"arguments\";a:0:{}s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}s:7:\"filters\";a:0:{}s:4:\"path\";s:0:\"\";s:4:\"menu\";a:7:{s:4:\"type\";s:4:\"none\";s:5:\"title\";s:0:\"\";s:11:\"description\";s:0:\"\";s:6:\"weight\";i:0;s:4:\"name\";s:10:\"navigation\";s:7:\"context\";s:0:\"\";s:19:\"context_only_inline\";b:0;}s:11:\"tab_options\";a:5:{s:4:\"type\";s:4:\"none\";s:5:\"title\";s:0:\"\";s:11:\"description\";s:0:\"\";s:6:\"weight\";i:0;s:4:\"name\";s:10:\"navigation\";}}s:10:\"definition\";a:20:{s:5:\"title\";s:4:\"Page\";s:4:\"help\";s:54:\"Display the view as a page, with a URL and menu links.\";s:7:\"handler\";s:25:\"views_plugin_display_page\";s:5:\"theme\";s:10:\"views_view\";s:14:\"uses hook menu\";b:1;s:26:\"contextual links locations\";a:1:{i:0;s:4:\"page\";}s:8:\"use ajax\";b:1;s:9:\"use pager\";b:1;s:8:\"use more\";b:1;s:18:\"accept attachments\";b:1;s:5:\"admin\";s:4:\"Page\";s:10:\"help topic\";s:12:\"display-page\";s:6:\"module\";s:5:\"views\";s:10:\"theme path\";s:29:\"sites/all/modules/views/theme\";s:10:\"theme file\";s:9:\"theme.inc\";s:4:\"path\";s:31:\"sites/all/modules/views/plugins\";s:4:\"file\";s:29:\"views_plugin_display_page.inc\";s:6:\"parent\";s:6:\"parent\";s:4:\"name\";s:4:\"page\";s:16:\"contextual links\";a:1:{s:8:\"views_ui\";a:2:{s:11:\"parent path\";s:26:\"admin/structure/views/view\";s:19:\"argument properties\";a:1:{i:0;s:4:\"name\";}}}}s:9:\"is_plugin\";b:1;s:15:\"default_display\";R:37;}s:15:\"display_options\";a:9:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:7:\"enabled\";b:0;s:8:\"defaults\";a:6:{s:5:\"pager\";b:0;s:12:\"style_plugin\";b:0;s:13:\"style_options\";b:0;s:10:\"row_plugin\";b:0;s:11:\"row_options\";b:0;s:6:\"fields\";b:0;}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"none\";s:7:\"options\";a:1:{s:6:\"offset\";s:1:\"0\";}}s:12:\"style_plugin\";s:7:\"default\";s:10:\"row_plugin\";s:6:\"fields\";s:11:\"row_options\";a:2:{s:10:\"hide_empty\";i:0;s:22:\"default_field_elements\";i:1;}s:6:\"fields\";a:3:{s:3:\"nid\";a:12:{s:2:\"id\";s:3:\"nid\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:3:\"nid\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:1;s:5:\"alter\";a:12:{s:10:\"alter_text\";i:0;s:9:\"make_link\";i:0;s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:15:\"trim_whitespace\";i:0;s:5:\"nl2br\";i:0;s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:4:\"html\";i:0;}s:19:\"element_label_colon\";b:0;s:23:\"element_default_classes\";i:1;s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:0;s:12:\"link_to_node\";i:0;}s:5:\"title\";a:11:{s:2:\"id\";s:5:\"title\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:5:\"title\";s:5:\"label\";s:0:\"\";s:5:\"alter\";a:13:{s:10:\"alter_text\";i:1;s:4:\"text\";s:35:\"<h3><a id=\"n[nid]\">[title]</a></h3>\";s:9:\"make_link\";i:0;s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:15:\"trim_whitespace\";i:0;s:5:\"nl2br\";i:0;s:13:\"word_boundary\";i:0;s:8:\"ellipsis\";i:0;s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:4:\"html\";i:0;}s:19:\"element_label_colon\";b:0;s:23:\"element_default_classes\";i:1;s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:0;s:12:\"link_to_node\";i:0;}s:4:\"body\";a:11:{s:2:\"id\";s:4:\"body\";s:5:\"table\";s:15:\"field_data_body\";s:5:\"field\";s:4:\"body\";s:5:\"label\";s:0:\"\";s:5:\"alter\";a:12:{s:10:\"alter_text\";i:0;s:9:\"make_link\";i:0;s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:15:\"trim_whitespace\";i:0;s:5:\"nl2br\";i:0;s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:4:\"html\";i:0;}s:19:\"element_label_colon\";b:0;s:23:\"element_default_classes\";i:1;s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:0;s:17:\"field_api_classes\";i:0;}}s:4:\"path\";s:17:\"faq-questions-top\";}s:8:\"db_table\";s:13:\"views_display\";s:3:\"vid\";i:0;s:2:\"id\";s:6:\"page_1\";s:13:\"display_title\";s:20:\"Page - Questions Top\";s:14:\"display_plugin\";s:4:\"page\";s:8:\"position\";i:0;}s:12:\"attachment_1\";O:13:\"views_display\":8:{s:7:\"handler\";O:31:\"views_plugin_display_attachment\":10:{s:4:\"view\";r:1;s:8:\"handlers\";a:0:{}s:8:\"extender\";a:0:{}s:7:\"display\";R:891;s:11:\"plugin_type\";s:7:\"display\";s:11:\"plugin_name\";s:10:\"attachment\";s:7:\"options\";a:45:{s:8:\"defaults\";a:35:{s:6:\"access\";b:1;s:5:\"cache\";b:1;s:5:\"query\";b:1;s:5:\"title\";b:1;s:9:\"css_class\";b:1;s:19:\"display_description\";b:0;s:8:\"use_ajax\";b:1;s:23:\"hide_attachment_summary\";b:1;s:16:\"hide_admin_links\";b:1;s:5:\"pager\";b:0;s:13:\"pager_options\";b:1;s:8:\"use_more\";b:1;s:15:\"use_more_always\";b:1;s:13:\"use_more_text\";b:1;s:12:\"exposed_form\";b:1;s:20:\"exposed_form_options\";b:1;s:12:\"link_display\";b:1;s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:1;s:12:\"style_plugin\";b:1;s:13:\"style_options\";b:1;s:10:\"row_plugin\";b:1;s:11:\"row_options\";b:1;s:6:\"header\";b:1;s:6:\"footer\";b:1;s:5:\"empty\";b:1;s:13:\"relationships\";b:1;s:6:\"fields\";b:1;s:5:\"sorts\";b:1;s:9:\"arguments\";b:1;s:7:\"filters\";b:1;s:13:\"filter_groups\";b:1;s:9:\"use_pager\";b:0;s:14:\"items_per_page\";b:0;s:6:\"offset\";b:0;}s:5:\"title\";s:0:\"\";s:7:\"enabled\";b:1;s:15:\"display_comment\";s:0:\"\";s:9:\"css_class\";s:0:\"\";s:19:\"display_description\";s:0:\"\";s:8:\"use_ajax\";b:0;s:23:\"hide_attachment_summary\";b:0;s:16:\"hide_admin_links\";b:0;s:14:\"items_per_page\";i:10;s:6:\"offset\";i:0;s:9:\"use_pager\";b:0;s:8:\"use_more\";b:0;s:15:\"use_more_always\";b:0;s:13:\"use_more_text\";s:4:\"more\";s:12:\"link_display\";s:0:\"\";s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:0;s:14:\"field_language\";s:22:\"***CURRENT_LANGUAGE***\";s:27:\"field_language_add_to_query\";i:1;s:6:\"access\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"cache\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:0:{}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"some\";s:7:\"options\";a:0:{}}s:12:\"style_plugin\";s:7:\"default\";s:13:\"style_options\";a:0:{}s:10:\"row_plugin\";s:6:\"fields\";s:11:\"row_options\";a:0:{}s:13:\"exposed_block\";b:0;s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:0:{}s:13:\"relationships\";a:0:{}s:6:\"fields\";a:0:{}s:5:\"sorts\";a:0:{}s:9:\"arguments\";a:0:{}s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}s:7:\"filters\";a:0:{}s:8:\"displays\";a:0:{}s:19:\"attachment_position\";s:6:\"before\";s:17:\"inherit_arguments\";b:1;s:23:\"inherit_exposed_filters\";b:0;s:13:\"inherit_pager\";b:0;s:12:\"render_pager\";b:0;}s:10:\"definition\";a:18:{s:5:\"title\";s:10:\"Attachment\";s:4:\"help\";s:79:\"Attachments added to other displays to achieve multiple views in the same view.\";s:7:\"handler\";s:31:\"views_plugin_display_attachment\";s:5:\"theme\";s:10:\"views_view\";s:26:\"contextual links locations\";a:0:{}s:8:\"use ajax\";b:1;s:9:\"use pager\";b:0;s:8:\"use more\";b:1;s:18:\"accept attachments\";b:0;s:10:\"help topic\";s:18:\"display-attachment\";s:6:\"module\";s:5:\"views\";s:10:\"theme path\";s:29:\"sites/all/modules/views/theme\";s:10:\"theme file\";s:9:\"theme.inc\";s:4:\"path\";s:31:\"sites/all/modules/views/plugins\";s:4:\"file\";s:35:\"views_plugin_display_attachment.inc\";s:6:\"parent\";s:6:\"parent\";s:4:\"name\";s:10:\"attachment\";s:16:\"contextual links\";a:1:{s:8:\"views_ui\";a:2:{s:11:\"parent path\";s:26:\"admin/structure/views/view\";s:19:\"argument properties\";a:1:{i:0;s:4:\"name\";}}}}s:9:\"is_plugin\";b:1;s:15:\"default_display\";R:37;}s:15:\"display_options\";a:13:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:7:\"enabled\";b:0;s:8:\"defaults\";a:7:{s:8:\"use_more\";b:0;s:12:\"link_display\";b:0;s:12:\"style_plugin\";b:0;s:13:\"style_options\";b:0;s:10:\"row_plugin\";b:0;s:11:\"row_options\";b:0;s:6:\"fields\";b:0;}s:15:\"use_more_always\";b:1;s:13:\"use_more_text\";s:13:\"View all FAQs\";s:12:\"link_display\";s:6:\"page_1\";s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"none\";s:7:\"options\";a:1:{s:6:\"offset\";s:1:\"0\";}}s:12:\"style_plugin\";s:4:\"list\";s:10:\"row_plugin\";s:6:\"fields\";s:11:\"row_options\";a:2:{s:10:\"hide_empty\";i:0;s:22:\"default_field_elements\";i:1;}s:6:\"fields\";a:2:{s:3:\"nid\";a:12:{s:2:\"id\";s:3:\"nid\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:3:\"nid\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:1;s:5:\"alter\";a:12:{s:10:\"alter_text\";i:0;s:9:\"make_link\";i:0;s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:15:\"trim_whitespace\";i:0;s:5:\"nl2br\";i:0;s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:4:\"html\";i:0;}s:19:\"element_label_colon\";b:0;s:23:\"element_default_classes\";i:1;s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:0;s:12:\"link_to_node\";i:0;}s:5:\"title\";a:11:{s:2:\"id\";s:5:\"title\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:5:\"title\";s:5:\"label\";s:0:\"\";s:5:\"alter\";a:13:{s:10:\"alter_text\";i:0;s:9:\"make_link\";i:1;s:4:\"path\";s:24:\"faq-questions-top#n[nid]\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:15:\"trim_whitespace\";i:0;s:5:\"nl2br\";i:0;s:13:\"word_boundary\";i:0;s:8:\"ellipsis\";i:0;s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:4:\"html\";i:0;}s:19:\"element_label_colon\";b:0;s:23:\"element_default_classes\";i:1;s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:0;s:12:\"link_to_node\";i:0;}}s:8:\"displays\";a:5:{s:6:\"page_1\";s:6:\"page_1\";s:7:\"default\";i:0;s:4:\"page\";i:0;s:5:\"block\";i:0;s:7:\"block_1\";i:0;}s:23:\"inherit_exposed_filters\";i:1;}s:8:\"db_table\";s:13:\"views_display\";s:3:\"vid\";i:0;s:2:\"id\";s:12:\"attachment_1\";s:13:\"display_title\";s:26:\"Attachment - Questions Top\";s:14:\"display_plugin\";s:10:\"attachment\";s:8:\"position\";i:0;}s:6:\"page_2\";O:13:\"views_display\":8:{s:7:\"handler\";O:25:\"views_plugin_display_page\":10:{s:4:\"view\";r:1;s:8:\"handlers\";a:0:{}s:8:\"extender\";a:0:{}s:7:\"display\";R:1103;s:11:\"plugin_type\";s:7:\"display\";s:11:\"plugin_name\";s:4:\"page\";s:7:\"options\";a:42:{s:8:\"defaults\";a:32:{s:6:\"access\";b:1;s:5:\"cache\";b:1;s:5:\"query\";b:1;s:5:\"title\";b:1;s:9:\"css_class\";b:1;s:19:\"display_description\";b:0;s:8:\"use_ajax\";b:1;s:23:\"hide_attachment_summary\";b:1;s:16:\"hide_admin_links\";b:1;s:5:\"pager\";b:1;s:13:\"pager_options\";b:1;s:8:\"use_more\";b:1;s:15:\"use_more_always\";b:1;s:13:\"use_more_text\";b:1;s:12:\"exposed_form\";b:1;s:20:\"exposed_form_options\";b:1;s:12:\"link_display\";b:1;s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:1;s:12:\"style_plugin\";b:1;s:13:\"style_options\";b:1;s:10:\"row_plugin\";b:1;s:11:\"row_options\";b:1;s:6:\"header\";b:1;s:6:\"footer\";b:1;s:5:\"empty\";b:1;s:13:\"relationships\";b:1;s:6:\"fields\";b:1;s:5:\"sorts\";b:1;s:9:\"arguments\";b:1;s:7:\"filters\";b:1;s:13:\"filter_groups\";b:1;}s:5:\"title\";s:0:\"\";s:7:\"enabled\";b:1;s:15:\"display_comment\";s:0:\"\";s:9:\"css_class\";s:0:\"\";s:19:\"display_description\";s:0:\"\";s:8:\"use_ajax\";b:0;s:23:\"hide_attachment_summary\";b:0;s:16:\"hide_admin_links\";b:0;s:14:\"items_per_page\";i:10;s:6:\"offset\";i:0;s:9:\"use_pager\";b:0;s:8:\"use_more\";b:0;s:15:\"use_more_always\";b:0;s:13:\"use_more_text\";s:4:\"more\";s:12:\"link_display\";s:0:\"\";s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:0;s:14:\"field_language\";s:22:\"***CURRENT_LANGUAGE***\";s:27:\"field_language_add_to_query\";i:1;s:6:\"access\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"cache\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:0:{}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"full\";s:7:\"options\";a:0:{}}s:12:\"style_plugin\";s:7:\"default\";s:13:\"style_options\";a:0:{}s:10:\"row_plugin\";s:6:\"fields\";s:11:\"row_options\";a:0:{}s:13:\"exposed_block\";b:0;s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:0:{}s:13:\"relationships\";a:0:{}s:6:\"fields\";a:0:{}s:5:\"sorts\";a:0:{}s:9:\"arguments\";a:0:{}s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}s:7:\"filters\";a:0:{}s:4:\"path\";s:0:\"\";s:4:\"menu\";a:7:{s:4:\"type\";s:4:\"none\";s:5:\"title\";s:0:\"\";s:11:\"description\";s:0:\"\";s:6:\"weight\";i:0;s:4:\"name\";s:10:\"navigation\";s:7:\"context\";s:0:\"\";s:19:\"context_only_inline\";b:0;}s:11:\"tab_options\";a:5:{s:4:\"type\";s:4:\"none\";s:5:\"title\";s:0:\"\";s:11:\"description\";s:0:\"\";s:6:\"weight\";i:0;s:4:\"name\";s:10:\"navigation\";}}s:10:\"definition\";a:20:{s:5:\"title\";s:4:\"Page\";s:4:\"help\";s:54:\"Display the view as a page, with a URL and menu links.\";s:7:\"handler\";s:25:\"views_plugin_display_page\";s:5:\"theme\";s:10:\"views_view\";s:14:\"uses hook menu\";b:1;s:26:\"contextual links locations\";a:1:{i:0;s:4:\"page\";}s:8:\"use ajax\";b:1;s:9:\"use pager\";b:1;s:8:\"use more\";b:1;s:18:\"accept attachments\";b:1;s:5:\"admin\";s:4:\"Page\";s:10:\"help topic\";s:12:\"display-page\";s:6:\"module\";s:5:\"views\";s:10:\"theme path\";s:29:\"sites/all/modules/views/theme\";s:10:\"theme file\";s:9:\"theme.inc\";s:4:\"path\";s:31:\"sites/all/modules/views/plugins\";s:4:\"file\";s:29:\"views_plugin_display_page.inc\";s:6:\"parent\";s:6:\"parent\";s:4:\"name\";s:4:\"page\";s:16:\"contextual links\";a:1:{s:8:\"views_ui\";a:2:{s:11:\"parent path\";s:26:\"admin/structure/views/view\";s:19:\"argument properties\";a:1:{i:0;s:4:\"name\";}}}}s:9:\"is_plugin\";b:1;s:15:\"default_display\";R:37;}s:15:\"display_options\";a:8:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:7:\"enabled\";b:0;s:8:\"defaults\";a:5:{s:12:\"style_plugin\";b:0;s:13:\"style_options\";b:0;s:10:\"row_plugin\";b:0;s:11:\"row_options\";b:0;s:6:\"fields\";b:0;}s:12:\"style_plugin\";s:4:\"list\";s:10:\"row_plugin\";s:6:\"fields\";s:11:\"row_options\";a:2:{s:10:\"hide_empty\";i:0;s:22:\"default_field_elements\";i:1;}s:6:\"fields\";a:1:{s:5:\"title\";a:8:{s:2:\"id\";s:5:\"title\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:5:\"title\";s:5:\"label\";s:0:\"\";s:5:\"alter\";a:8:{s:10:\"alter_text\";i:0;s:9:\"make_link\";i:0;s:8:\"absolute\";i:0;s:13:\"word_boundary\";i:0;s:8:\"ellipsis\";i:0;s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:4:\"html\";i:0;}s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:12:\"link_to_node\";i:1;}}s:4:\"path\";s:12:\"faq-new-page\";}s:8:\"db_table\";s:13:\"views_display\";s:3:\"vid\";i:0;s:2:\"id\";s:6:\"page_2\";s:13:\"display_title\";s:15:\"Page - New Page\";s:14:\"display_plugin\";s:4:\"page\";s:8:\"position\";i:0;}s:6:\"page_3\";O:13:\"views_display\":8:{s:7:\"handler\";O:25:\"views_plugin_display_page\":10:{s:4:\"view\";r:1;s:8:\"handlers\";a:0:{}s:8:\"extender\";a:0:{}s:7:\"display\";R:1276;s:11:\"plugin_type\";s:7:\"display\";s:11:\"plugin_name\";s:4:\"page\";s:7:\"options\";a:42:{s:8:\"defaults\";a:32:{s:6:\"access\";b:1;s:5:\"cache\";b:1;s:5:\"query\";b:1;s:5:\"title\";b:1;s:9:\"css_class\";b:1;s:19:\"display_description\";b:0;s:8:\"use_ajax\";b:1;s:23:\"hide_attachment_summary\";b:1;s:16:\"hide_admin_links\";b:1;s:5:\"pager\";b:1;s:13:\"pager_options\";b:1;s:8:\"use_more\";b:1;s:15:\"use_more_always\";b:1;s:13:\"use_more_text\";b:1;s:12:\"exposed_form\";b:1;s:20:\"exposed_form_options\";b:1;s:12:\"link_display\";b:1;s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:1;s:12:\"style_plugin\";b:1;s:13:\"style_options\";b:1;s:10:\"row_plugin\";b:1;s:11:\"row_options\";b:1;s:6:\"header\";b:1;s:6:\"footer\";b:1;s:5:\"empty\";b:1;s:13:\"relationships\";b:1;s:6:\"fields\";b:1;s:5:\"sorts\";b:1;s:9:\"arguments\";b:1;s:7:\"filters\";b:1;s:13:\"filter_groups\";b:1;}s:5:\"title\";s:0:\"\";s:7:\"enabled\";b:1;s:15:\"display_comment\";s:0:\"\";s:9:\"css_class\";s:0:\"\";s:19:\"display_description\";s:0:\"\";s:8:\"use_ajax\";b:0;s:23:\"hide_attachment_summary\";b:0;s:16:\"hide_admin_links\";b:0;s:14:\"items_per_page\";i:10;s:6:\"offset\";i:0;s:9:\"use_pager\";b:0;s:8:\"use_more\";b:0;s:15:\"use_more_always\";b:0;s:13:\"use_more_text\";s:4:\"more\";s:12:\"link_display\";s:0:\"\";s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:0;s:14:\"field_language\";s:22:\"***CURRENT_LANGUAGE***\";s:27:\"field_language_add_to_query\";i:1;s:6:\"access\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"cache\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:0:{}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"full\";s:7:\"options\";a:0:{}}s:12:\"style_plugin\";s:7:\"default\";s:13:\"style_options\";a:0:{}s:10:\"row_plugin\";s:6:\"fields\";s:11:\"row_options\";a:0:{}s:13:\"exposed_block\";b:0;s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:0:{}s:13:\"relationships\";a:0:{}s:6:\"fields\";a:0:{}s:5:\"sorts\";a:0:{}s:9:\"arguments\";a:0:{}s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}s:7:\"filters\";a:0:{}s:4:\"path\";s:0:\"\";s:4:\"menu\";a:7:{s:4:\"type\";s:4:\"none\";s:5:\"title\";s:0:\"\";s:11:\"description\";s:0:\"\";s:6:\"weight\";i:0;s:4:\"name\";s:10:\"navigation\";s:7:\"context\";s:0:\"\";s:19:\"context_only_inline\";b:0;}s:11:\"tab_options\";a:5:{s:4:\"type\";s:4:\"none\";s:5:\"title\";s:0:\"\";s:11:\"description\";s:0:\"\";s:6:\"weight\";i:0;s:4:\"name\";s:10:\"navigation\";}}s:10:\"definition\";a:20:{s:5:\"title\";s:4:\"Page\";s:4:\"help\";s:54:\"Display the view as a page, with a URL and menu links.\";s:7:\"handler\";s:25:\"views_plugin_display_page\";s:5:\"theme\";s:10:\"views_view\";s:14:\"uses hook menu\";b:1;s:26:\"contextual links locations\";a:1:{i:0;s:4:\"page\";}s:8:\"use ajax\";b:1;s:9:\"use pager\";b:1;s:8:\"use more\";b:1;s:18:\"accept attachments\";b:1;s:5:\"admin\";s:4:\"Page\";s:10:\"help topic\";s:12:\"display-page\";s:6:\"module\";s:5:\"views\";s:10:\"theme path\";s:29:\"sites/all/modules/views/theme\";s:10:\"theme file\";s:9:\"theme.inc\";s:4:\"path\";s:31:\"sites/all/modules/views/plugins\";s:4:\"file\";s:29:\"views_plugin_display_page.inc\";s:6:\"parent\";s:6:\"parent\";s:4:\"name\";s:4:\"page\";s:16:\"contextual links\";a:1:{s:8:\"views_ui\";a:2:{s:11:\"parent path\";s:26:\"admin/structure/views/view\";s:19:\"argument properties\";a:1:{i:0;s:4:\"name\";}}}}s:9:\"is_plugin\";b:1;s:15:\"default_display\";R:37;}s:15:\"display_options\";a:9:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:7:\"enabled\";b:0;s:8:\"defaults\";a:5:{s:12:\"style_plugin\";b:0;s:13:\"style_options\";b:0;s:10:\"row_plugin\";b:0;s:11:\"row_options\";b:0;s:6:\"fields\";b:0;}s:12:\"style_plugin\";s:4:\"list\";s:13:\"style_options\";a:1:{s:8:\"grouping\";s:14:\"field_category\";}s:10:\"row_plugin\";s:6:\"fields\";s:11:\"row_options\";a:2:{s:10:\"hide_empty\";i:0;s:22:\"default_field_elements\";i:1;}s:6:\"fields\";a:2:{s:5:\"title\";a:8:{s:2:\"id\";s:5:\"title\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:5:\"title\";s:5:\"label\";s:0:\"\";s:5:\"alter\";a:8:{s:10:\"alter_text\";i:0;s:9:\"make_link\";i:0;s:8:\"absolute\";i:0;s:13:\"word_boundary\";i:0;s:8:\"ellipsis\";i:0;s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:4:\"html\";i:0;}s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:12:\"link_to_node\";i:1;}s:14:\"field_category\";a:13:{s:2:\"id\";s:14:\"field_category\";s:5:\"table\";s:25:\"field_data_field_category\";s:5:\"field\";s:14:\"field_category\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:1;s:5:\"alter\";a:12:{s:10:\"alter_text\";i:0;s:9:\"make_link\";i:0;s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:15:\"trim_whitespace\";i:0;s:5:\"nl2br\";i:0;s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:4:\"html\";i:0;}s:19:\"element_label_colon\";b:0;s:23:\"element_default_classes\";i:1;s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:0;s:4:\"type\";s:29:\"taxonomy_term_reference_plain\";s:17:\"field_api_classes\";i:0;}}s:4:\"path\";s:30:\"faq-categories-inline-new-page\";}s:8:\"db_table\";s:13:\"views_display\";s:3:\"vid\";i:0;s:2:\"id\";s:6:\"page_3\";s:13:\"display_title\";s:35:\"Page - Categories Inline - New Page\";s:14:\"display_plugin\";s:4:\"page\";s:8:\"position\";i:0;}}s:12:\"style_plugin\";N;s:13:\"style_options\";N;s:9:\"row_index\";N;s:12:\"override_url\";N;s:13:\"override_path\";N;s:13:\"base_database\";N;s:5:\"field\";N;s:8:\"argument\";N;s:4:\"sort\";N;s:6:\"filter\";N;s:12:\"relationship\";N;s:6:\"header\";N;s:6:\"footer\";N;s:5:\"empty\";N;s:19:\"localization_plugin\";O:30:\"views_plugin_localization_core\":9:{s:14:\"export_strings\";a:0:{}s:9:\"translate\";b:1;s:4:\"view\";r:1;s:7:\"display\";N;s:11:\"plugin_type\";s:12:\"localization\";s:11:\"plugin_name\";s:4:\"core\";s:7:\"options\";a:0:{}s:10:\"definition\";a:11:{s:5:\"title\";s:4:\"Core\";s:4:\"help\";s:283:\"Use Drupal core t() function. Not recommended, as it doesn\'t support updates to existing strings. If you need to translate Views labels into other languages, consider installing the <a href=\"http://drupal.org/project/i18n\">Internationalization</a> package\'s Views translation module.\";s:7:\"handler\";s:30:\"views_plugin_localization_core\";s:10:\"help topic\";s:17:\"localization-core\";s:6:\"module\";s:5:\"views\";s:10:\"theme path\";s:29:\"sites/all/modules/views/theme\";s:10:\"theme file\";s:9:\"theme.inc\";s:4:\"path\";s:31:\"sites/all/modules/views/plugins\";s:4:\"file\";s:34:\"views_plugin_localization_core.inc\";s:6:\"parent\";s:6:\"parent\";s:4:\"name\";s:4:\"core\";}s:9:\"is_plugin\";b:1;}s:13:\"export_module\";s:3:\"faq\";}',0,1512620340,1),('ctools_export:views_view:frontpage','O:4:\"view\":50:{s:8:\"db_table\";s:10:\"views_view\";s:10:\"base_table\";s:4:\"node\";s:10:\"base_field\";s:3:\"nid\";s:4:\"name\";s:9:\"frontpage\";s:3:\"vid\";s:0:\"\";s:11:\"description\";s:119:\"Emulates the default Drupal front page; you may set the default home page path to this view to make it your front page.\";s:3:\"tag\";s:7:\"default\";s:10:\"human_name\";s:10:\"Front page\";s:4:\"core\";i:0;s:11:\"api_version\";s:3:\"3.0\";s:8:\"disabled\";b:1;s:5:\"built\";b:0;s:8:\"executed\";b:0;s:7:\"editing\";b:0;s:4:\"args\";a:0:{}s:10:\"build_info\";a:0:{}s:8:\"use_ajax\";b:0;s:6:\"result\";a:0:{}s:12:\"current_page\";N;s:14:\"items_per_page\";N;s:6:\"offset\";N;s:10:\"total_rows\";N;s:17:\"attachment_before\";s:0:\"\";s:16:\"attachment_after\";s:0:\"\";s:12:\"exposed_data\";a:0:{}s:13:\"exposed_input\";a:0:{}s:17:\"exposed_raw_input\";a:0:{}s:8:\"old_view\";a:0:{}s:12:\"parent_views\";a:0:{}s:13:\"is_attachment\";N;s:15:\"current_display\";N;s:5:\"query\";N;s:15:\"display_handler\";N;s:7:\"display\";a:3:{s:7:\"default\";O:13:\"views_display\":8:{s:7:\"handler\";O:28:\"views_plugin_display_default\":9:{s:4:\"view\";r:1;s:8:\"handlers\";a:0:{}s:8:\"extender\";a:0:{}s:7:\"display\";R:36;s:11:\"plugin_type\";s:7:\"display\";s:11:\"plugin_name\";s:7:\"default\";s:7:\"options\";a:38:{s:5:\"title\";s:0:\"\";s:7:\"enabled\";b:1;s:15:\"display_comment\";s:0:\"\";s:9:\"css_class\";s:0:\"\";s:19:\"display_description\";s:0:\"\";s:8:\"use_ajax\";b:0;s:23:\"hide_attachment_summary\";b:0;s:16:\"hide_admin_links\";b:0;s:14:\"items_per_page\";i:10;s:6:\"offset\";i:0;s:9:\"use_pager\";b:0;s:8:\"use_more\";b:0;s:15:\"use_more_always\";b:0;s:13:\"use_more_text\";s:4:\"more\";s:12:\"link_display\";s:0:\"\";s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:0;s:14:\"field_language\";s:22:\"***CURRENT_LANGUAGE***\";s:27:\"field_language_add_to_query\";i:1;s:6:\"access\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"cache\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:0:{}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"full\";s:7:\"options\";a:0:{}}s:12:\"style_plugin\";s:7:\"default\";s:13:\"style_options\";a:0:{}s:10:\"row_plugin\";s:6:\"fields\";s:11:\"row_options\";a:0:{}s:13:\"exposed_block\";b:0;s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:0:{}s:13:\"relationships\";a:0:{}s:6:\"fields\";a:0:{}s:5:\"sorts\";a:0:{}s:9:\"arguments\";a:0:{}s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}s:7:\"filters\";a:0:{}}s:10:\"definition\";a:20:{s:5:\"title\";s:6:\"Master\";s:4:\"help\";s:31:\"Default settings for this view.\";s:7:\"handler\";s:28:\"views_plugin_display_default\";s:5:\"theme\";s:10:\"views_view\";s:5:\"no ui\";b:1;s:9:\"no remove\";b:1;s:2:\"js\";a:6:{i:0;s:12:\"misc/form.js\";i:1;s:16:\"misc/collapse.js\";i:2;s:16:\"misc/textarea.js\";i:3;s:17:\"misc/tabledrag.js\";i:4;s:20:\"misc/autocomplete.js\";i:5;s:40:\"sites/all/modules/ctools/js/dependent.js\";}s:8:\"use ajax\";b:1;s:9:\"use pager\";b:1;s:8:\"use more\";b:1;s:18:\"accept attachments\";b:1;s:10:\"help topic\";s:15:\"display-default\";s:6:\"module\";s:5:\"views\";s:10:\"theme path\";s:29:\"sites/all/modules/views/theme\";s:10:\"theme file\";s:9:\"theme.inc\";s:4:\"path\";s:31:\"sites/all/modules/views/plugins\";s:4:\"file\";s:32:\"views_plugin_display_default.inc\";s:6:\"parent\";s:6:\"parent\";s:4:\"name\";s:7:\"default\";s:16:\"contextual links\";a:1:{s:8:\"views_ui\";a:2:{s:11:\"parent path\";s:26:\"admin/structure/views/view\";s:19:\"argument properties\";a:1:{i:0;s:4:\"name\";}}}}s:9:\"is_plugin\";b:1;}s:15:\"display_options\";a:10:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:1:{s:13:\"query_comment\";b:0;}}s:6:\"access\";a:2:{s:4:\"type\";s:4:\"perm\";s:4:\"perm\";s:14:\"access content\";}s:5:\"cache\";a:1:{s:4:\"type\";s:4:\"none\";}s:12:\"exposed_form\";a:1:{s:4:\"type\";s:5:\"basic\";}s:5:\"pager\";a:1:{s:4:\"type\";s:4:\"full\";}s:12:\"style_plugin\";s:7:\"default\";s:10:\"row_plugin\";s:4:\"node\";s:11:\"row_options\";a:1:{s:5:\"links\";i:1;}s:5:\"sorts\";a:2:{s:6:\"sticky\";a:4:{s:2:\"id\";s:6:\"sticky\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:6:\"sticky\";s:5:\"order\";s:4:\"DESC\";}s:7:\"created\";a:4:{s:2:\"id\";s:7:\"created\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:7:\"created\";s:5:\"order\";s:4:\"DESC\";}}s:7:\"filters\";a:2:{s:7:\"promote\";a:6:{s:2:\"id\";s:7:\"promote\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:7:\"promote\";s:5:\"value\";s:1:\"1\";s:5:\"group\";i:0;s:6:\"expose\";a:1:{s:8:\"operator\";b:0;}}s:6:\"status\";a:6:{s:2:\"id\";s:6:\"status\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:6:\"status\";s:5:\"value\";s:1:\"1\";s:5:\"group\";i:0;s:6:\"expose\";a:1:{s:8:\"operator\";b:0;}}}}s:8:\"db_table\";s:13:\"views_display\";s:3:\"vid\";i:0;s:2:\"id\";s:7:\"default\";s:13:\"display_title\";s:6:\"Master\";s:14:\"display_plugin\";s:7:\"default\";s:8:\"position\";i:0;}s:4:\"page\";O:13:\"views_display\":8:{s:7:\"handler\";O:25:\"views_plugin_display_page\":10:{s:4:\"view\";r:1;s:8:\"handlers\";a:0:{}s:8:\"extender\";a:0:{}s:7:\"display\";R:177;s:11:\"plugin_type\";s:7:\"display\";s:11:\"plugin_name\";s:4:\"page\";s:7:\"options\";a:42:{s:8:\"defaults\";a:32:{s:6:\"access\";b:1;s:5:\"cache\";b:1;s:5:\"query\";b:1;s:5:\"title\";b:1;s:9:\"css_class\";b:1;s:19:\"display_description\";b:0;s:8:\"use_ajax\";b:1;s:23:\"hide_attachment_summary\";b:1;s:16:\"hide_admin_links\";b:1;s:5:\"pager\";b:1;s:13:\"pager_options\";b:1;s:8:\"use_more\";b:1;s:15:\"use_more_always\";b:1;s:13:\"use_more_text\";b:1;s:12:\"exposed_form\";b:1;s:20:\"exposed_form_options\";b:1;s:12:\"link_display\";b:1;s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:1;s:12:\"style_plugin\";b:1;s:13:\"style_options\";b:1;s:10:\"row_plugin\";b:1;s:11:\"row_options\";b:1;s:6:\"header\";b:1;s:6:\"footer\";b:1;s:5:\"empty\";b:1;s:13:\"relationships\";b:1;s:6:\"fields\";b:1;s:5:\"sorts\";b:1;s:9:\"arguments\";b:1;s:7:\"filters\";b:1;s:13:\"filter_groups\";b:1;}s:5:\"title\";s:0:\"\";s:7:\"enabled\";b:1;s:15:\"display_comment\";s:0:\"\";s:9:\"css_class\";s:0:\"\";s:19:\"display_description\";s:0:\"\";s:8:\"use_ajax\";b:0;s:23:\"hide_attachment_summary\";b:0;s:16:\"hide_admin_links\";b:0;s:14:\"items_per_page\";i:10;s:6:\"offset\";i:0;s:9:\"use_pager\";b:0;s:8:\"use_more\";b:0;s:15:\"use_more_always\";b:0;s:13:\"use_more_text\";s:4:\"more\";s:12:\"link_display\";s:0:\"\";s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:0;s:14:\"field_language\";s:22:\"***CURRENT_LANGUAGE***\";s:27:\"field_language_add_to_query\";i:1;s:6:\"access\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"cache\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:0:{}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"full\";s:7:\"options\";a:0:{}}s:12:\"style_plugin\";s:7:\"default\";s:13:\"style_options\";a:0:{}s:10:\"row_plugin\";s:6:\"fields\";s:11:\"row_options\";a:0:{}s:13:\"exposed_block\";b:0;s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:0:{}s:13:\"relationships\";a:0:{}s:6:\"fields\";a:0:{}s:5:\"sorts\";a:0:{}s:9:\"arguments\";a:0:{}s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}s:7:\"filters\";a:0:{}s:4:\"path\";s:0:\"\";s:4:\"menu\";a:7:{s:4:\"type\";s:4:\"none\";s:5:\"title\";s:0:\"\";s:11:\"description\";s:0:\"\";s:6:\"weight\";i:0;s:4:\"name\";s:10:\"navigation\";s:7:\"context\";s:0:\"\";s:19:\"context_only_inline\";b:0;}s:11:\"tab_options\";a:5:{s:4:\"type\";s:4:\"none\";s:5:\"title\";s:0:\"\";s:11:\"description\";s:0:\"\";s:6:\"weight\";i:0;s:4:\"name\";s:10:\"navigation\";}}s:10:\"definition\";a:20:{s:5:\"title\";s:4:\"Page\";s:4:\"help\";s:54:\"Display the view as a page, with a URL and menu links.\";s:7:\"handler\";s:25:\"views_plugin_display_page\";s:5:\"theme\";s:10:\"views_view\";s:14:\"uses hook menu\";b:1;s:26:\"contextual links locations\";a:1:{i:0;s:4:\"page\";}s:8:\"use ajax\";b:1;s:9:\"use pager\";b:1;s:8:\"use more\";b:1;s:18:\"accept attachments\";b:1;s:5:\"admin\";s:4:\"Page\";s:10:\"help topic\";s:12:\"display-page\";s:6:\"module\";s:5:\"views\";s:10:\"theme path\";s:29:\"sites/all/modules/views/theme\";s:10:\"theme file\";s:9:\"theme.inc\";s:4:\"path\";s:31:\"sites/all/modules/views/plugins\";s:4:\"file\";s:29:\"views_plugin_display_page.inc\";s:6:\"parent\";s:6:\"parent\";s:4:\"name\";s:4:\"page\";s:16:\"contextual links\";a:1:{s:8:\"views_ui\";a:2:{s:11:\"parent path\";s:26:\"admin/structure/views/view\";s:19:\"argument properties\";a:1:{i:0;s:4:\"name\";}}}}s:9:\"is_plugin\";b:1;s:15:\"default_display\";R:37;}s:15:\"display_options\";a:2:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:4:\"path\";s:9:\"frontpage\";}s:8:\"db_table\";s:13:\"views_display\";s:3:\"vid\";i:0;s:2:\"id\";s:4:\"page\";s:13:\"display_title\";s:4:\"Page\";s:14:\"display_plugin\";s:4:\"page\";s:8:\"position\";i:0;}s:4:\"feed\";O:13:\"views_display\":8:{s:7:\"handler\";O:25:\"views_plugin_display_feed\":10:{s:4:\"view\";r:1;s:8:\"handlers\";a:0:{}s:8:\"extender\";a:0:{}s:7:\"display\";R:320;s:11:\"plugin_type\";s:7:\"display\";s:11:\"plugin_name\";s:4:\"feed\";s:7:\"options\";a:44:{s:8:\"defaults\";a:35:{s:6:\"access\";b:1;s:5:\"cache\";b:1;s:5:\"query\";b:1;s:5:\"title\";b:1;s:9:\"css_class\";b:1;s:19:\"display_description\";b:0;s:8:\"use_ajax\";b:1;s:23:\"hide_attachment_summary\";b:1;s:16:\"hide_admin_links\";b:1;s:5:\"pager\";b:0;s:13:\"pager_options\";b:1;s:8:\"use_more\";b:1;s:15:\"use_more_always\";b:1;s:13:\"use_more_text\";b:1;s:12:\"exposed_form\";b:1;s:20:\"exposed_form_options\";b:1;s:12:\"link_display\";b:1;s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:1;s:12:\"style_plugin\";b:0;s:13:\"style_options\";b:0;s:10:\"row_plugin\";b:0;s:11:\"row_options\";b:0;s:6:\"header\";b:1;s:6:\"footer\";b:1;s:5:\"empty\";b:1;s:13:\"relationships\";b:1;s:6:\"fields\";b:1;s:5:\"sorts\";b:1;s:9:\"arguments\";b:1;s:7:\"filters\";b:1;s:13:\"filter_groups\";b:1;s:9:\"use_pager\";b:0;s:14:\"items_per_page\";b:0;s:6:\"offset\";b:0;}s:5:\"title\";s:0:\"\";s:7:\"enabled\";b:1;s:15:\"display_comment\";s:0:\"\";s:9:\"css_class\";s:0:\"\";s:19:\"display_description\";s:0:\"\";s:8:\"use_ajax\";b:0;s:23:\"hide_attachment_summary\";b:0;s:16:\"hide_admin_links\";b:0;s:14:\"items_per_page\";i:10;s:6:\"offset\";i:0;s:9:\"use_pager\";b:0;s:8:\"use_more\";b:0;s:15:\"use_more_always\";b:0;s:13:\"use_more_text\";s:4:\"more\";s:12:\"link_display\";s:0:\"\";s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:0;s:14:\"field_language\";s:22:\"***CURRENT_LANGUAGE***\";s:27:\"field_language_add_to_query\";i:1;s:6:\"access\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"cache\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:0:{}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"some\";s:7:\"options\";a:0:{}}s:12:\"style_plugin\";s:3:\"rss\";s:13:\"style_options\";a:1:{s:11:\"description\";s:0:\"\";}s:10:\"row_plugin\";s:8:\"node_rss\";s:11:\"row_options\";a:0:{}s:13:\"exposed_block\";b:0;s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:0:{}s:13:\"relationships\";a:0:{}s:6:\"fields\";a:0:{}s:5:\"sorts\";a:0:{}s:9:\"arguments\";a:0:{}s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}s:7:\"filters\";a:0:{}s:4:\"path\";s:0:\"\";s:4:\"menu\";a:7:{s:4:\"type\";s:4:\"none\";s:5:\"title\";s:0:\"\";s:11:\"description\";s:0:\"\";s:6:\"weight\";i:0;s:4:\"name\";s:10:\"navigation\";s:7:\"context\";s:0:\"\";s:19:\"context_only_inline\";b:0;}s:11:\"tab_options\";a:5:{s:4:\"type\";s:4:\"none\";s:5:\"title\";s:0:\"\";s:11:\"description\";s:0:\"\";s:6:\"weight\";i:0;s:4:\"name\";s:10:\"navigation\";}s:8:\"displays\";a:0:{}s:14:\"sitename_title\";b:0;}s:10:\"definition\";a:17:{s:5:\"title\";s:4:\"Feed\";s:4:\"help\";s:48:\"Display the view as a feed, such as an RSS feed.\";s:7:\"handler\";s:25:\"views_plugin_display_feed\";s:14:\"uses hook menu\";b:1;s:8:\"use ajax\";b:0;s:9:\"use pager\";b:0;s:18:\"accept attachments\";b:0;s:5:\"admin\";s:4:\"Feed\";s:10:\"help topic\";s:12:\"display-feed\";s:6:\"module\";s:5:\"views\";s:10:\"theme path\";s:29:\"sites/all/modules/views/theme\";s:10:\"theme file\";s:9:\"theme.inc\";s:4:\"path\";s:31:\"sites/all/modules/views/plugins\";s:4:\"file\";s:29:\"views_plugin_display_feed.inc\";s:6:\"parent\";s:6:\"parent\";s:4:\"name\";s:4:\"feed\";s:16:\"contextual links\";a:1:{s:8:\"views_ui\";a:2:{s:11:\"parent path\";s:26:\"admin/structure/views/view\";s:19:\"argument properties\";a:1:{i:0;s:4:\"name\";}}}}s:9:\"is_plugin\";b:1;s:15:\"default_display\";R:37;}s:15:\"display_options\";a:9:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:8:\"defaults\";a:1:{s:5:\"title\";b:0;}s:5:\"title\";s:15:\"Front page feed\";s:5:\"pager\";a:1:{s:4:\"type\";s:4:\"some\";}s:12:\"style_plugin\";s:3:\"rss\";s:10:\"row_plugin\";s:8:\"node_rss\";s:4:\"path\";s:7:\"rss.xml\";s:8:\"displays\";a:2:{s:7:\"default\";s:7:\"default\";s:4:\"page\";s:4:\"page\";}s:14:\"sitename_title\";s:1:\"1\";}s:8:\"db_table\";s:13:\"views_display\";s:3:\"vid\";i:0;s:2:\"id\";s:4:\"feed\";s:13:\"display_title\";s:4:\"Feed\";s:14:\"display_plugin\";s:4:\"feed\";s:8:\"position\";i:0;}}s:12:\"style_plugin\";N;s:13:\"style_options\";N;s:9:\"row_index\";N;s:12:\"override_url\";N;s:13:\"override_path\";N;s:13:\"base_database\";N;s:5:\"field\";N;s:8:\"argument\";N;s:4:\"sort\";N;s:6:\"filter\";N;s:12:\"relationship\";N;s:6:\"header\";N;s:6:\"footer\";N;s:5:\"empty\";N;s:19:\"localization_plugin\";O:30:\"views_plugin_localization_core\":9:{s:14:\"export_strings\";a:0:{}s:9:\"translate\";b:1;s:4:\"view\";r:1;s:7:\"display\";N;s:11:\"plugin_type\";s:12:\"localization\";s:11:\"plugin_name\";s:4:\"core\";s:7:\"options\";a:0:{}s:10:\"definition\";a:11:{s:5:\"title\";s:4:\"Core\";s:4:\"help\";s:283:\"Use Drupal core t() function. Not recommended, as it doesn\'t support updates to existing strings. If you need to translate Views labels into other languages, consider installing the <a href=\"http://drupal.org/project/i18n\">Internationalization</a> package\'s Views translation module.\";s:7:\"handler\";s:30:\"views_plugin_localization_core\";s:10:\"help topic\";s:17:\"localization-core\";s:6:\"module\";s:5:\"views\";s:10:\"theme path\";s:29:\"sites/all/modules/views/theme\";s:10:\"theme file\";s:9:\"theme.inc\";s:4:\"path\";s:31:\"sites/all/modules/views/plugins\";s:4:\"file\";s:34:\"views_plugin_localization_core.inc\";s:6:\"parent\";s:6:\"parent\";s:4:\"name\";s:4:\"core\";}s:9:\"is_plugin\";b:1;}s:13:\"export_module\";s:4:\"node\";}',0,1512620340,1),('ctools_export:views_view:glossary','O:4:\"view\":49:{s:8:\"db_table\";s:10:\"views_view\";s:10:\"base_table\";s:4:\"node\";s:10:\"base_field\";s:3:\"nid\";s:4:\"name\";s:8:\"glossary\";s:3:\"vid\";s:0:\"\";s:11:\"description\";s:33:\"A list of all content, by letter.\";s:3:\"tag\";s:7:\"default\";s:10:\"human_name\";s:8:\"Glossary\";s:4:\"core\";i:0;s:11:\"api_version\";s:3:\"3.0\";s:8:\"disabled\";b:1;s:5:\"built\";b:0;s:8:\"executed\";b:0;s:7:\"editing\";b:0;s:4:\"args\";a:0:{}s:10:\"build_info\";a:0:{}s:8:\"use_ajax\";b:0;s:6:\"result\";a:0:{}s:12:\"current_page\";N;s:14:\"items_per_page\";N;s:6:\"offset\";N;s:10:\"total_rows\";N;s:17:\"attachment_before\";s:0:\"\";s:16:\"attachment_after\";s:0:\"\";s:12:\"exposed_data\";a:0:{}s:13:\"exposed_input\";a:0:{}s:17:\"exposed_raw_input\";a:0:{}s:8:\"old_view\";a:0:{}s:12:\"parent_views\";a:0:{}s:13:\"is_attachment\";N;s:15:\"current_display\";N;s:5:\"query\";N;s:15:\"display_handler\";N;s:7:\"display\";a:3:{s:7:\"default\";O:13:\"views_display\":8:{s:7:\"handler\";O:28:\"views_plugin_display_default\":9:{s:4:\"view\";r:1;s:8:\"handlers\";a:0:{}s:8:\"extender\";a:0:{}s:7:\"display\";R:36;s:11:\"plugin_type\";s:7:\"display\";s:11:\"plugin_name\";s:7:\"default\";s:7:\"options\";a:38:{s:5:\"title\";s:0:\"\";s:7:\"enabled\";b:1;s:15:\"display_comment\";s:0:\"\";s:9:\"css_class\";s:0:\"\";s:19:\"display_description\";s:0:\"\";s:8:\"use_ajax\";b:0;s:23:\"hide_attachment_summary\";b:0;s:16:\"hide_admin_links\";b:0;s:14:\"items_per_page\";i:10;s:6:\"offset\";i:0;s:9:\"use_pager\";b:0;s:8:\"use_more\";b:0;s:15:\"use_more_always\";b:0;s:13:\"use_more_text\";s:4:\"more\";s:12:\"link_display\";s:0:\"\";s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:0;s:14:\"field_language\";s:22:\"***CURRENT_LANGUAGE***\";s:27:\"field_language_add_to_query\";i:1;s:6:\"access\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"cache\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:0:{}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"full\";s:7:\"options\";a:0:{}}s:12:\"style_plugin\";s:7:\"default\";s:13:\"style_options\";a:0:{}s:10:\"row_plugin\";s:6:\"fields\";s:11:\"row_options\";a:0:{}s:13:\"exposed_block\";b:0;s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:0:{}s:13:\"relationships\";a:0:{}s:6:\"fields\";a:0:{}s:5:\"sorts\";a:0:{}s:9:\"arguments\";a:0:{}s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}s:7:\"filters\";a:0:{}}s:10:\"definition\";a:20:{s:5:\"title\";s:6:\"Master\";s:4:\"help\";s:31:\"Default settings for this view.\";s:7:\"handler\";s:28:\"views_plugin_display_default\";s:5:\"theme\";s:10:\"views_view\";s:5:\"no ui\";b:1;s:9:\"no remove\";b:1;s:2:\"js\";a:6:{i:0;s:12:\"misc/form.js\";i:1;s:16:\"misc/collapse.js\";i:2;s:16:\"misc/textarea.js\";i:3;s:17:\"misc/tabledrag.js\";i:4;s:20:\"misc/autocomplete.js\";i:5;s:40:\"sites/all/modules/ctools/js/dependent.js\";}s:8:\"use ajax\";b:1;s:9:\"use pager\";b:1;s:8:\"use more\";b:1;s:18:\"accept attachments\";b:1;s:10:\"help topic\";s:15:\"display-default\";s:6:\"module\";s:5:\"views\";s:10:\"theme path\";s:29:\"sites/all/modules/views/theme\";s:10:\"theme file\";s:9:\"theme.inc\";s:4:\"path\";s:31:\"sites/all/modules/views/plugins\";s:4:\"file\";s:32:\"views_plugin_display_default.inc\";s:6:\"parent\";s:6:\"parent\";s:4:\"name\";s:7:\"default\";s:16:\"contextual links\";a:1:{s:8:\"views_ui\";a:2:{s:11:\"parent path\";s:26:\"admin/structure/views/view\";s:19:\"argument properties\";a:1:{i:0;s:4:\"name\";}}}}s:9:\"is_plugin\";b:1;}s:15:\"display_options\";a:10:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:1:{s:13:\"query_comment\";b:0;}}s:8:\"use_ajax\";b:1;s:6:\"access\";a:2:{s:4:\"type\";s:4:\"perm\";s:4:\"perm\";s:14:\"access content\";}s:5:\"cache\";a:1:{s:4:\"type\";s:4:\"none\";}s:12:\"exposed_form\";a:1:{s:4:\"type\";s:5:\"basic\";}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"full\";s:7:\"options\";a:1:{s:14:\"items_per_page\";i:36;}}s:12:\"style_plugin\";s:5:\"table\";s:13:\"style_options\";a:5:{s:7:\"columns\";a:3:{s:5:\"title\";s:5:\"title\";s:4:\"name\";s:4:\"name\";s:7:\"changed\";s:7:\"changed\";}s:7:\"default\";s:5:\"title\";s:4:\"info\";a:3:{s:5:\"title\";a:2:{s:8:\"sortable\";i:1;s:9:\"separator\";s:0:\"\";}s:4:\"name\";a:2:{s:8:\"sortable\";i:1;s:9:\"separator\";s:0:\"\";}s:7:\"changed\";a:2:{s:8:\"sortable\";i:1;s:9:\"separator\";s:0:\"\";}}s:8:\"override\";i:1;s:6:\"sticky\";i:0;}s:6:\"fields\";a:3:{s:5:\"title\";a:4:{s:2:\"id\";s:5:\"title\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:5:\"title\";s:12:\"link_to_node\";i:1;}s:4:\"name\";a:5:{s:2:\"id\";s:4:\"name\";s:5:\"table\";s:5:\"users\";s:5:\"field\";s:4:\"name\";s:5:\"label\";s:6:\"Author\";s:12:\"link_to_user\";i:1;}s:7:\"changed\";a:5:{s:2:\"id\";s:7:\"changed\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:7:\"changed\";s:5:\"label\";s:11:\"Last update\";s:11:\"date_format\";s:5:\"large\";}}s:9:\"arguments\";a:1:{s:5:\"title\";a:14:{s:2:\"id\";s:5:\"title\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:5:\"title\";s:14:\"default_action\";s:7:\"default\";s:9:\"exception\";a:1:{s:12:\"title_enable\";i:1;}s:21:\"default_argument_type\";s:5:\"fixed\";s:24:\"default_argument_options\";a:1:{s:8:\"argument\";s:1:\"a\";}s:7:\"summary\";a:1:{s:6:\"format\";s:15:\"default_summary\";}s:18:\"specify_validation\";i:1;s:8:\"glossary\";i:1;s:5:\"limit\";s:1:\"1\";s:4:\"case\";s:5:\"upper\";s:9:\"path_case\";s:5:\"lower\";s:14:\"transform_dash\";i:0;}}}s:8:\"db_table\";s:13:\"views_display\";s:3:\"vid\";i:0;s:2:\"id\";s:7:\"default\";s:13:\"display_title\";s:6:\"Master\";s:14:\"display_plugin\";s:7:\"default\";s:8:\"position\";i:0;}s:4:\"page\";O:13:\"views_display\":8:{s:7:\"handler\";O:25:\"views_plugin_display_page\":10:{s:4:\"view\";r:1;s:8:\"handlers\";a:0:{}s:8:\"extender\";a:0:{}s:7:\"display\";R:204;s:11:\"plugin_type\";s:7:\"display\";s:11:\"plugin_name\";s:4:\"page\";s:7:\"options\";a:42:{s:8:\"defaults\";a:32:{s:6:\"access\";b:1;s:5:\"cache\";b:1;s:5:\"query\";b:1;s:5:\"title\";b:1;s:9:\"css_class\";b:1;s:19:\"display_description\";b:0;s:8:\"use_ajax\";b:1;s:23:\"hide_attachment_summary\";b:1;s:16:\"hide_admin_links\";b:1;s:5:\"pager\";b:1;s:13:\"pager_options\";b:1;s:8:\"use_more\";b:1;s:15:\"use_more_always\";b:1;s:13:\"use_more_text\";b:1;s:12:\"exposed_form\";b:1;s:20:\"exposed_form_options\";b:1;s:12:\"link_display\";b:1;s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:1;s:12:\"style_plugin\";b:1;s:13:\"style_options\";b:1;s:10:\"row_plugin\";b:1;s:11:\"row_options\";b:1;s:6:\"header\";b:1;s:6:\"footer\";b:1;s:5:\"empty\";b:1;s:13:\"relationships\";b:1;s:6:\"fields\";b:1;s:5:\"sorts\";b:1;s:9:\"arguments\";b:1;s:7:\"filters\";b:1;s:13:\"filter_groups\";b:1;}s:5:\"title\";s:0:\"\";s:7:\"enabled\";b:1;s:15:\"display_comment\";s:0:\"\";s:9:\"css_class\";s:0:\"\";s:19:\"display_description\";s:0:\"\";s:8:\"use_ajax\";b:0;s:23:\"hide_attachment_summary\";b:0;s:16:\"hide_admin_links\";b:0;s:14:\"items_per_page\";i:10;s:6:\"offset\";i:0;s:9:\"use_pager\";b:0;s:8:\"use_more\";b:0;s:15:\"use_more_always\";b:0;s:13:\"use_more_text\";s:4:\"more\";s:12:\"link_display\";s:0:\"\";s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:0;s:14:\"field_language\";s:22:\"***CURRENT_LANGUAGE***\";s:27:\"field_language_add_to_query\";i:1;s:6:\"access\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"cache\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:0:{}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"full\";s:7:\"options\";a:0:{}}s:12:\"style_plugin\";s:7:\"default\";s:13:\"style_options\";a:0:{}s:10:\"row_plugin\";s:6:\"fields\";s:11:\"row_options\";a:0:{}s:13:\"exposed_block\";b:0;s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:0:{}s:13:\"relationships\";a:0:{}s:6:\"fields\";a:0:{}s:5:\"sorts\";a:0:{}s:9:\"arguments\";a:0:{}s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}s:7:\"filters\";a:0:{}s:4:\"path\";s:0:\"\";s:4:\"menu\";a:7:{s:4:\"type\";s:4:\"none\";s:5:\"title\";s:0:\"\";s:11:\"description\";s:0:\"\";s:6:\"weight\";i:0;s:4:\"name\";s:10:\"navigation\";s:7:\"context\";s:0:\"\";s:19:\"context_only_inline\";b:0;}s:11:\"tab_options\";a:5:{s:4:\"type\";s:4:\"none\";s:5:\"title\";s:0:\"\";s:11:\"description\";s:0:\"\";s:6:\"weight\";i:0;s:4:\"name\";s:10:\"navigation\";}}s:10:\"definition\";a:20:{s:5:\"title\";s:4:\"Page\";s:4:\"help\";s:54:\"Display the view as a page, with a URL and menu links.\";s:7:\"handler\";s:25:\"views_plugin_display_page\";s:5:\"theme\";s:10:\"views_view\";s:14:\"uses hook menu\";b:1;s:26:\"contextual links locations\";a:1:{i:0;s:4:\"page\";}s:8:\"use ajax\";b:1;s:9:\"use pager\";b:1;s:8:\"use more\";b:1;s:18:\"accept attachments\";b:1;s:5:\"admin\";s:4:\"Page\";s:10:\"help topic\";s:12:\"display-page\";s:6:\"module\";s:5:\"views\";s:10:\"theme path\";s:29:\"sites/all/modules/views/theme\";s:10:\"theme file\";s:9:\"theme.inc\";s:4:\"path\";s:31:\"sites/all/modules/views/plugins\";s:4:\"file\";s:29:\"views_plugin_display_page.inc\";s:6:\"parent\";s:6:\"parent\";s:4:\"name\";s:4:\"page\";s:16:\"contextual links\";a:1:{s:8:\"views_ui\";a:2:{s:11:\"parent path\";s:26:\"admin/structure/views/view\";s:19:\"argument properties\";a:1:{i:0;s:4:\"name\";}}}}s:9:\"is_plugin\";b:1;s:15:\"default_display\";R:37;}s:15:\"display_options\";a:3:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:4:\"path\";s:8:\"glossary\";s:4:\"menu\";a:3:{s:4:\"type\";s:6:\"normal\";s:5:\"title\";s:8:\"Glossary\";s:6:\"weight\";s:1:\"0\";}}s:8:\"db_table\";s:13:\"views_display\";s:3:\"vid\";i:0;s:2:\"id\";s:4:\"page\";s:13:\"display_title\";s:4:\"Page\";s:14:\"display_plugin\";s:4:\"page\";s:8:\"position\";i:0;}s:10:\"attachment\";O:13:\"views_display\":8:{s:7:\"handler\";O:31:\"views_plugin_display_attachment\":10:{s:4:\"view\";r:1;s:8:\"handlers\";a:0:{}s:8:\"extender\";a:0:{}s:7:\"display\";R:351;s:11:\"plugin_type\";s:7:\"display\";s:11:\"plugin_name\";s:10:\"attachment\";s:7:\"options\";a:45:{s:8:\"defaults\";a:35:{s:6:\"access\";b:1;s:5:\"cache\";b:1;s:5:\"query\";b:1;s:5:\"title\";b:1;s:9:\"css_class\";b:1;s:19:\"display_description\";b:0;s:8:\"use_ajax\";b:1;s:23:\"hide_attachment_summary\";b:1;s:16:\"hide_admin_links\";b:1;s:5:\"pager\";b:0;s:13:\"pager_options\";b:1;s:8:\"use_more\";b:1;s:15:\"use_more_always\";b:1;s:13:\"use_more_text\";b:1;s:12:\"exposed_form\";b:1;s:20:\"exposed_form_options\";b:1;s:12:\"link_display\";b:1;s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:1;s:12:\"style_plugin\";b:1;s:13:\"style_options\";b:1;s:10:\"row_plugin\";b:1;s:11:\"row_options\";b:1;s:6:\"header\";b:1;s:6:\"footer\";b:1;s:5:\"empty\";b:1;s:13:\"relationships\";b:1;s:6:\"fields\";b:1;s:5:\"sorts\";b:1;s:9:\"arguments\";b:1;s:7:\"filters\";b:1;s:13:\"filter_groups\";b:1;s:9:\"use_pager\";b:0;s:14:\"items_per_page\";b:0;s:6:\"offset\";b:0;}s:5:\"title\";s:0:\"\";s:7:\"enabled\";b:1;s:15:\"display_comment\";s:0:\"\";s:9:\"css_class\";s:0:\"\";s:19:\"display_description\";s:0:\"\";s:8:\"use_ajax\";b:0;s:23:\"hide_attachment_summary\";b:0;s:16:\"hide_admin_links\";b:0;s:14:\"items_per_page\";i:10;s:6:\"offset\";i:0;s:9:\"use_pager\";b:0;s:8:\"use_more\";b:0;s:15:\"use_more_always\";b:0;s:13:\"use_more_text\";s:4:\"more\";s:12:\"link_display\";s:0:\"\";s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:0;s:14:\"field_language\";s:22:\"***CURRENT_LANGUAGE***\";s:27:\"field_language_add_to_query\";i:1;s:6:\"access\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"cache\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:0:{}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"some\";s:7:\"options\";a:0:{}}s:12:\"style_plugin\";s:7:\"default\";s:13:\"style_options\";a:0:{}s:10:\"row_plugin\";s:6:\"fields\";s:11:\"row_options\";a:0:{}s:13:\"exposed_block\";b:0;s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:0:{}s:13:\"relationships\";a:0:{}s:6:\"fields\";a:0:{}s:5:\"sorts\";a:0:{}s:9:\"arguments\";a:0:{}s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}s:7:\"filters\";a:0:{}s:8:\"displays\";a:0:{}s:19:\"attachment_position\";s:6:\"before\";s:17:\"inherit_arguments\";b:1;s:23:\"inherit_exposed_filters\";b:0;s:13:\"inherit_pager\";b:0;s:12:\"render_pager\";b:0;}s:10:\"definition\";a:18:{s:5:\"title\";s:10:\"Attachment\";s:4:\"help\";s:79:\"Attachments added to other displays to achieve multiple views in the same view.\";s:7:\"handler\";s:31:\"views_plugin_display_attachment\";s:5:\"theme\";s:10:\"views_view\";s:26:\"contextual links locations\";a:0:{}s:8:\"use ajax\";b:1;s:9:\"use pager\";b:0;s:8:\"use more\";b:1;s:18:\"accept attachments\";b:0;s:10:\"help topic\";s:18:\"display-attachment\";s:6:\"module\";s:5:\"views\";s:10:\"theme path\";s:29:\"sites/all/modules/views/theme\";s:10:\"theme file\";s:9:\"theme.inc\";s:4:\"path\";s:31:\"sites/all/modules/views/plugins\";s:4:\"file\";s:35:\"views_plugin_display_attachment.inc\";s:6:\"parent\";s:6:\"parent\";s:4:\"name\";s:10:\"attachment\";s:16:\"contextual links\";a:1:{s:8:\"views_ui\";a:2:{s:11:\"parent path\";s:26:\"admin/structure/views/view\";s:19:\"argument properties\";a:1:{i:0;s:4:\"name\";}}}}s:9:\"is_plugin\";b:1;s:15:\"default_display\";R:37;}s:15:\"display_options\";a:6:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"none\";s:7:\"options\";a:1:{s:6:\"offset\";s:1:\"0\";}}s:8:\"defaults\";a:1:{s:9:\"arguments\";b:0;}s:9:\"arguments\";a:1:{s:5:\"title\";a:15:{s:2:\"id\";s:5:\"title\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:5:\"title\";s:14:\"default_action\";s:7:\"summary\";s:9:\"exception\";a:1:{s:12:\"title_enable\";i:1;}s:21:\"default_argument_type\";s:5:\"fixed\";s:24:\"default_argument_options\";a:1:{s:8:\"argument\";s:1:\"a\";}s:7:\"summary\";a:1:{s:6:\"format\";s:19:\"unformatted_summary\";}s:15:\"summary_options\";a:3:{s:14:\"items_per_page\";s:2:\"25\";s:6:\"inline\";i:1;s:9:\"separator\";s:3:\" | \";}s:18:\"specify_validation\";i:1;s:8:\"glossary\";i:1;s:5:\"limit\";s:1:\"1\";s:4:\"case\";s:5:\"upper\";s:9:\"path_case\";s:5:\"lower\";s:14:\"transform_dash\";i:0;}}s:8:\"displays\";a:2:{s:7:\"default\";s:7:\"default\";s:4:\"page\";s:4:\"page\";}s:17:\"inherit_arguments\";i:0;}s:8:\"db_table\";s:13:\"views_display\";s:3:\"vid\";i:0;s:2:\"id\";s:10:\"attachment\";s:13:\"display_title\";s:10:\"Attachment\";s:14:\"display_plugin\";s:10:\"attachment\";s:8:\"position\";i:0;}}s:12:\"style_plugin\";N;s:13:\"style_options\";N;s:9:\"row_index\";N;s:12:\"override_url\";N;s:13:\"override_path\";N;s:13:\"base_database\";N;s:5:\"field\";N;s:8:\"argument\";N;s:4:\"sort\";N;s:6:\"filter\";N;s:12:\"relationship\";N;s:6:\"header\";N;s:6:\"footer\";N;s:5:\"empty\";N;s:13:\"export_module\";s:4:\"node\";}',0,1512620340,1),('ctools_export:views_view:message','O:4:\"view\":49:{s:8:\"db_table\";s:10:\"views_view\";s:10:\"base_table\";s:7:\"message\";s:10:\"base_field\";s:3:\"nid\";s:4:\"name\";s:7:\"message\";s:3:\"vid\";s:0:\"\";s:11:\"description\";s:27:\"Show all existing messages.\";s:3:\"tag\";s:7:\"Message\";s:10:\"human_name\";s:7:\"Message\";s:4:\"core\";i:7;s:11:\"api_version\";s:3:\"3.0\";s:8:\"disabled\";b:0;s:5:\"built\";b:0;s:8:\"executed\";b:0;s:7:\"editing\";b:0;s:4:\"args\";a:0:{}s:10:\"build_info\";a:0:{}s:8:\"use_ajax\";b:0;s:6:\"result\";a:0:{}s:12:\"current_page\";N;s:14:\"items_per_page\";N;s:6:\"offset\";N;s:10:\"total_rows\";N;s:17:\"attachment_before\";s:0:\"\";s:16:\"attachment_after\";s:0:\"\";s:12:\"exposed_data\";a:0:{}s:13:\"exposed_input\";a:0:{}s:17:\"exposed_raw_input\";a:0:{}s:8:\"old_view\";a:0:{}s:12:\"parent_views\";a:0:{}s:13:\"is_attachment\";N;s:15:\"current_display\";N;s:5:\"query\";N;s:15:\"display_handler\";N;s:7:\"display\";a:2:{s:7:\"default\";O:13:\"views_display\":8:{s:7:\"handler\";O:28:\"views_plugin_display_default\":9:{s:4:\"view\";r:1;s:8:\"handlers\";a:0:{}s:8:\"extender\";a:0:{}s:7:\"display\";R:36;s:11:\"plugin_type\";s:7:\"display\";s:11:\"plugin_name\";s:7:\"default\";s:7:\"options\";a:38:{s:5:\"title\";s:0:\"\";s:7:\"enabled\";b:1;s:15:\"display_comment\";s:0:\"\";s:9:\"css_class\";s:0:\"\";s:19:\"display_description\";s:0:\"\";s:8:\"use_ajax\";b:0;s:23:\"hide_attachment_summary\";b:0;s:16:\"hide_admin_links\";b:0;s:14:\"items_per_page\";i:10;s:6:\"offset\";i:0;s:9:\"use_pager\";b:0;s:8:\"use_more\";b:0;s:15:\"use_more_always\";b:0;s:13:\"use_more_text\";s:4:\"more\";s:12:\"link_display\";s:0:\"\";s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:0;s:14:\"field_language\";s:22:\"***CURRENT_LANGUAGE***\";s:27:\"field_language_add_to_query\";i:1;s:6:\"access\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"cache\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:0:{}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"full\";s:7:\"options\";a:0:{}}s:12:\"style_plugin\";s:7:\"default\";s:13:\"style_options\";a:0:{}s:10:\"row_plugin\";s:6:\"fields\";s:11:\"row_options\";a:0:{}s:13:\"exposed_block\";b:0;s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:0:{}s:13:\"relationships\";a:0:{}s:6:\"fields\";a:0:{}s:5:\"sorts\";a:0:{}s:9:\"arguments\";a:0:{}s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}s:7:\"filters\";a:0:{}}s:10:\"definition\";a:20:{s:5:\"title\";s:6:\"Master\";s:4:\"help\";s:31:\"Default settings for this view.\";s:7:\"handler\";s:28:\"views_plugin_display_default\";s:5:\"theme\";s:10:\"views_view\";s:5:\"no ui\";b:1;s:9:\"no remove\";b:1;s:2:\"js\";a:6:{i:0;s:12:\"misc/form.js\";i:1;s:16:\"misc/collapse.js\";i:2;s:16:\"misc/textarea.js\";i:3;s:17:\"misc/tabledrag.js\";i:4;s:20:\"misc/autocomplete.js\";i:5;s:40:\"sites/all/modules/ctools/js/dependent.js\";}s:8:\"use ajax\";b:1;s:9:\"use pager\";b:1;s:8:\"use more\";b:1;s:18:\"accept attachments\";b:1;s:10:\"help topic\";s:15:\"display-default\";s:6:\"module\";s:5:\"views\";s:10:\"theme path\";s:29:\"sites/all/modules/views/theme\";s:10:\"theme file\";s:9:\"theme.inc\";s:4:\"path\";s:31:\"sites/all/modules/views/plugins\";s:4:\"file\";s:32:\"views_plugin_display_default.inc\";s:6:\"parent\";s:6:\"parent\";s:4:\"name\";s:7:\"default\";s:16:\"contextual links\";a:1:{s:8:\"views_ui\";a:2:{s:11:\"parent path\";s:26:\"admin/structure/views/view\";s:19:\"argument properties\";a:1:{i:0;s:4:\"name\";}}}}s:9:\"is_plugin\";b:1;}s:15:\"display_options\";a:12:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:1:{s:13:\"query_comment\";b:0;}}s:6:\"access\";a:2:{s:4:\"type\";s:4:\"perm\";s:4:\"perm\";s:24:\"administer message types\";}s:5:\"cache\";a:1:{s:4:\"type\";s:4:\"none\";}s:12:\"exposed_form\";a:1:{s:4:\"type\";s:5:\"basic\";}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"full\";s:7:\"options\";a:4:{s:14:\"items_per_page\";s:2:\"30\";s:6:\"offset\";s:1:\"0\";s:2:\"id\";s:1:\"0\";s:6:\"expose\";a:1:{s:26:\"items_per_page_options_all\";i:0;}}}s:12:\"style_plugin\";s:5:\"table\";s:13:\"style_options\";a:6:{s:7:\"columns\";a:3:{s:9:\"timestamp\";s:9:\"timestamp\";s:14:\"message_render\";s:14:\"message_render\";s:4:\"name\";s:4:\"name\";}s:7:\"default\";s:2:\"-1\";s:4:\"info\";a:3:{s:9:\"timestamp\";a:4:{s:8:\"sortable\";i:1;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";}s:14:\"message_render\";a:2:{s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";}s:4:\"name\";a:4:{s:8:\"sortable\";i:1;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";}}s:8:\"override\";i:1;s:6:\"sticky\";i:1;s:11:\"empty_table\";i:0;}s:5:\"empty\";a:1:{s:4:\"area\";a:7:{s:2:\"id\";s:4:\"area\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:4:\"area\";s:5:\"empty\";b:0;s:7:\"content\";s:24:\"No messages created yet.\";s:6:\"format\";s:13:\"filtered_html\";s:8:\"tokenize\";i:0;}}s:13:\"relationships\";a:1:{s:4:\"user\";a:4:{s:2:\"id\";s:4:\"user\";s:5:\"table\";s:7:\"message\";s:5:\"field\";s:4:\"user\";s:8:\"required\";i:0;}}s:6:\"fields\";a:3:{s:9:\"timestamp\";a:9:{s:2:\"id\";s:9:\"timestamp\";s:5:\"table\";s:7:\"message\";s:5:\"field\";s:9:\"timestamp\";s:5:\"alter\";a:12:{s:10:\"alter_text\";i:0;s:9:\"make_link\";i:0;s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:15:\"trim_whitespace\";i:0;s:5:\"nl2br\";i:0;s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:4:\"html\";i:0;}s:19:\"element_label_colon\";i:1;s:23:\"element_default_classes\";i:1;s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:11:\"date_format\";s:5:\"short\";}s:14:\"message_render\";a:10:{s:2:\"id\";s:14:\"message_render\";s:5:\"table\";s:7:\"message\";s:5:\"field\";s:14:\"message_render\";s:5:\"label\";s:4:\"Text\";s:5:\"alter\";a:12:{s:10:\"alter_text\";i:0;s:9:\"make_link\";i:0;s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:15:\"trim_whitespace\";i:0;s:5:\"nl2br\";i:0;s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:4:\"html\";i:0;}s:19:\"element_label_colon\";i:0;s:23:\"element_default_classes\";i:1;s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:0;}s:4:\"name\";a:12:{s:2:\"id\";s:4:\"name\";s:5:\"table\";s:5:\"users\";s:5:\"field\";s:4:\"name\";s:12:\"relationship\";s:4:\"user\";s:5:\"label\";s:4:\"User\";s:5:\"alter\";a:12:{s:10:\"alter_text\";i:0;s:9:\"make_link\";i:0;s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:15:\"trim_whitespace\";i:0;s:5:\"nl2br\";i:0;s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:4:\"html\";i:0;}s:19:\"element_label_colon\";i:1;s:23:\"element_default_classes\";i:1;s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:12:\"link_to_user\";i:1;s:19:\"overwrite_anonymous\";i:0;}}s:5:\"sorts\";a:1:{s:9:\"timestamp\";a:4:{s:2:\"id\";s:9:\"timestamp\";s:5:\"table\";s:7:\"message\";s:5:\"field\";s:9:\"timestamp\";s:5:\"order\";s:4:\"DESC\";}}s:7:\"filters\";a:1:{s:4:\"type\";a:5:{s:2:\"id\";s:4:\"type\";s:5:\"table\";s:7:\"message\";s:5:\"field\";s:4:\"type\";s:7:\"exposed\";b:1;s:6:\"expose\";a:5:{s:11:\"operator_id\";s:7:\"type_op\";s:5:\"label\";s:12:\"Message type\";s:8:\"operator\";s:7:\"type_op\";s:10:\"identifier\";s:4:\"type\";s:6:\"reduce\";i:0;}}}}s:8:\"db_table\";s:13:\"views_display\";s:3:\"vid\";i:0;s:2:\"id\";s:7:\"default\";s:13:\"display_title\";s:8:\"Defaults\";s:14:\"display_plugin\";s:7:\"default\";s:8:\"position\";i:0;}s:6:\"page_1\";O:13:\"views_display\":8:{s:7:\"handler\";O:25:\"views_plugin_display_page\":10:{s:4:\"view\";r:1;s:8:\"handlers\";a:0:{}s:8:\"extender\";a:0:{}s:7:\"display\";R:279;s:11:\"plugin_type\";s:7:\"display\";s:11:\"plugin_name\";s:4:\"page\";s:7:\"options\";a:42:{s:8:\"defaults\";a:32:{s:6:\"access\";b:1;s:5:\"cache\";b:1;s:5:\"query\";b:1;s:5:\"title\";b:1;s:9:\"css_class\";b:1;s:19:\"display_description\";b:0;s:8:\"use_ajax\";b:1;s:23:\"hide_attachment_summary\";b:1;s:16:\"hide_admin_links\";b:1;s:5:\"pager\";b:1;s:13:\"pager_options\";b:1;s:8:\"use_more\";b:1;s:15:\"use_more_always\";b:1;s:13:\"use_more_text\";b:1;s:12:\"exposed_form\";b:1;s:20:\"exposed_form_options\";b:1;s:12:\"link_display\";b:1;s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:1;s:12:\"style_plugin\";b:1;s:13:\"style_options\";b:1;s:10:\"row_plugin\";b:1;s:11:\"row_options\";b:1;s:6:\"header\";b:1;s:6:\"footer\";b:1;s:5:\"empty\";b:1;s:13:\"relationships\";b:1;s:6:\"fields\";b:1;s:5:\"sorts\";b:1;s:9:\"arguments\";b:1;s:7:\"filters\";b:1;s:13:\"filter_groups\";b:1;}s:5:\"title\";s:0:\"\";s:7:\"enabled\";b:1;s:15:\"display_comment\";s:0:\"\";s:9:\"css_class\";s:0:\"\";s:19:\"display_description\";s:0:\"\";s:8:\"use_ajax\";b:0;s:23:\"hide_attachment_summary\";b:0;s:16:\"hide_admin_links\";b:0;s:14:\"items_per_page\";i:10;s:6:\"offset\";i:0;s:9:\"use_pager\";b:0;s:8:\"use_more\";b:0;s:15:\"use_more_always\";b:0;s:13:\"use_more_text\";s:4:\"more\";s:12:\"link_display\";s:0:\"\";s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:0;s:14:\"field_language\";s:22:\"***CURRENT_LANGUAGE***\";s:27:\"field_language_add_to_query\";i:1;s:6:\"access\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"cache\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:0:{}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"full\";s:7:\"options\";a:0:{}}s:12:\"style_plugin\";s:7:\"default\";s:13:\"style_options\";a:0:{}s:10:\"row_plugin\";s:6:\"fields\";s:11:\"row_options\";a:0:{}s:13:\"exposed_block\";b:0;s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:0:{}s:13:\"relationships\";a:0:{}s:6:\"fields\";a:0:{}s:5:\"sorts\";a:0:{}s:9:\"arguments\";a:0:{}s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}s:7:\"filters\";a:0:{}s:4:\"path\";s:0:\"\";s:4:\"menu\";a:7:{s:4:\"type\";s:4:\"none\";s:5:\"title\";s:0:\"\";s:11:\"description\";s:0:\"\";s:6:\"weight\";i:0;s:4:\"name\";s:10:\"navigation\";s:7:\"context\";s:0:\"\";s:19:\"context_only_inline\";b:0;}s:11:\"tab_options\";a:5:{s:4:\"type\";s:4:\"none\";s:5:\"title\";s:0:\"\";s:11:\"description\";s:0:\"\";s:6:\"weight\";i:0;s:4:\"name\";s:10:\"navigation\";}}s:10:\"definition\";a:20:{s:5:\"title\";s:4:\"Page\";s:4:\"help\";s:54:\"Display the view as a page, with a URL and menu links.\";s:7:\"handler\";s:25:\"views_plugin_display_page\";s:5:\"theme\";s:10:\"views_view\";s:14:\"uses hook menu\";b:1;s:26:\"contextual links locations\";a:1:{i:0;s:4:\"page\";}s:8:\"use ajax\";b:1;s:9:\"use pager\";b:1;s:8:\"use more\";b:1;s:18:\"accept attachments\";b:1;s:5:\"admin\";s:4:\"Page\";s:10:\"help topic\";s:12:\"display-page\";s:6:\"module\";s:5:\"views\";s:10:\"theme path\";s:29:\"sites/all/modules/views/theme\";s:10:\"theme file\";s:9:\"theme.inc\";s:4:\"path\";s:31:\"sites/all/modules/views/plugins\";s:4:\"file\";s:29:\"views_plugin_display_page.inc\";s:6:\"parent\";s:6:\"parent\";s:4:\"name\";s:4:\"page\";s:16:\"contextual links\";a:1:{s:8:\"views_ui\";a:2:{s:11:\"parent path\";s:26:\"admin/structure/views/view\";s:19:\"argument properties\";a:1:{i:0;s:4:\"name\";}}}}s:9:\"is_plugin\";b:1;s:15:\"default_display\";R:37;}s:15:\"display_options\";a:3:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:4:\"path\";s:21:\"admin/content/message\";s:4:\"menu\";a:5:{s:4:\"type\";s:3:\"tab\";s:5:\"title\";s:8:\"Messages\";s:11:\"description\";s:23:\"A list of all messages.\";s:6:\"weight\";s:1:\"0\";s:4:\"name\";s:10:\"management\";}}s:8:\"db_table\";s:13:\"views_display\";s:3:\"vid\";i:0;s:2:\"id\";s:6:\"page_1\";s:13:\"display_title\";s:4:\"Page\";s:14:\"display_plugin\";s:4:\"page\";s:8:\"position\";i:0;}}s:12:\"style_plugin\";N;s:13:\"style_options\";N;s:9:\"row_index\";N;s:12:\"override_url\";N;s:13:\"override_path\";N;s:13:\"base_database\";N;s:5:\"field\";N;s:8:\"argument\";N;s:4:\"sort\";N;s:6:\"filter\";N;s:12:\"relationship\";N;s:6:\"header\";N;s:6:\"footer\";N;s:5:\"empty\";N;s:13:\"export_module\";s:7:\"message\";}',0,1512620340,1),('ctools_export:views_view:message_example','O:4:\"view\":49:{s:8:\"db_table\";s:10:\"views_view\";s:10:\"base_table\";s:7:\"message\";s:10:\"base_field\";s:3:\"nid\";s:4:\"name\";s:15:\"message_example\";s:3:\"vid\";s:0:\"\";s:11:\"description\";s:0:\"\";s:3:\"tag\";s:7:\"default\";s:10:\"human_name\";s:15:\"Message example\";s:4:\"core\";i:7;s:11:\"api_version\";s:3:\"3.0\";s:8:\"disabled\";b:0;s:5:\"built\";b:0;s:8:\"executed\";b:0;s:7:\"editing\";b:0;s:4:\"args\";a:0:{}s:10:\"build_info\";a:0:{}s:8:\"use_ajax\";b:0;s:6:\"result\";a:0:{}s:12:\"current_page\";N;s:14:\"items_per_page\";N;s:6:\"offset\";N;s:10:\"total_rows\";N;s:17:\"attachment_before\";s:0:\"\";s:16:\"attachment_after\";s:0:\"\";s:12:\"exposed_data\";a:0:{}s:13:\"exposed_input\";a:0:{}s:17:\"exposed_raw_input\";a:0:{}s:8:\"old_view\";a:0:{}s:12:\"parent_views\";a:0:{}s:13:\"is_attachment\";N;s:15:\"current_display\";N;s:5:\"query\";N;s:15:\"display_handler\";N;s:7:\"display\";a:2:{s:7:\"default\";O:13:\"views_display\":8:{s:7:\"handler\";O:28:\"views_plugin_display_default\":9:{s:4:\"view\";r:1;s:8:\"handlers\";a:0:{}s:8:\"extender\";a:0:{}s:7:\"display\";R:36;s:11:\"plugin_type\";s:7:\"display\";s:11:\"plugin_name\";s:7:\"default\";s:7:\"options\";a:38:{s:5:\"title\";s:0:\"\";s:7:\"enabled\";b:1;s:15:\"display_comment\";s:0:\"\";s:9:\"css_class\";s:0:\"\";s:19:\"display_description\";s:0:\"\";s:8:\"use_ajax\";b:0;s:23:\"hide_attachment_summary\";b:0;s:16:\"hide_admin_links\";b:0;s:14:\"items_per_page\";i:10;s:6:\"offset\";i:0;s:9:\"use_pager\";b:0;s:8:\"use_more\";b:0;s:15:\"use_more_always\";b:0;s:13:\"use_more_text\";s:4:\"more\";s:12:\"link_display\";s:0:\"\";s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:0;s:14:\"field_language\";s:22:\"***CURRENT_LANGUAGE***\";s:27:\"field_language_add_to_query\";i:1;s:6:\"access\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"cache\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:0:{}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"full\";s:7:\"options\";a:0:{}}s:12:\"style_plugin\";s:7:\"default\";s:13:\"style_options\";a:0:{}s:10:\"row_plugin\";s:6:\"fields\";s:11:\"row_options\";a:0:{}s:13:\"exposed_block\";b:0;s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:0:{}s:13:\"relationships\";a:0:{}s:6:\"fields\";a:0:{}s:5:\"sorts\";a:0:{}s:9:\"arguments\";a:0:{}s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}s:7:\"filters\";a:0:{}}s:10:\"definition\";a:20:{s:5:\"title\";s:6:\"Master\";s:4:\"help\";s:31:\"Default settings for this view.\";s:7:\"handler\";s:28:\"views_plugin_display_default\";s:5:\"theme\";s:10:\"views_view\";s:5:\"no ui\";b:1;s:9:\"no remove\";b:1;s:2:\"js\";a:6:{i:0;s:12:\"misc/form.js\";i:1;s:16:\"misc/collapse.js\";i:2;s:16:\"misc/textarea.js\";i:3;s:17:\"misc/tabledrag.js\";i:4;s:20:\"misc/autocomplete.js\";i:5;s:40:\"sites/all/modules/ctools/js/dependent.js\";}s:8:\"use ajax\";b:1;s:9:\"use pager\";b:1;s:8:\"use more\";b:1;s:18:\"accept attachments\";b:1;s:10:\"help topic\";s:15:\"display-default\";s:6:\"module\";s:5:\"views\";s:10:\"theme path\";s:29:\"sites/all/modules/views/theme\";s:10:\"theme file\";s:9:\"theme.inc\";s:4:\"path\";s:31:\"sites/all/modules/views/plugins\";s:4:\"file\";s:32:\"views_plugin_display_default.inc\";s:6:\"parent\";s:6:\"parent\";s:4:\"name\";s:7:\"default\";s:16:\"contextual links\";a:1:{s:8:\"views_ui\";a:2:{s:11:\"parent path\";s:26:\"admin/structure/views/view\";s:19:\"argument properties\";a:1:{i:0;s:4:\"name\";}}}}s:9:\"is_plugin\";b:1;}s:15:\"display_options\";a:15:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:1:{s:13:\"query_comment\";b:0;}}s:5:\"title\";s:15:\"Message example\";s:9:\"css_class\";s:15:\"message-example\";s:15:\"use_more_always\";b:0;s:6:\"access\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"cache\";a:1:{s:4:\"type\";s:4:\"none\";}s:12:\"exposed_form\";a:1:{s:4:\"type\";s:5:\"basic\";}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"full\";s:7:\"options\";a:1:{s:14:\"items_per_page\";s:2:\"25\";}}s:12:\"style_plugin\";s:4:\"list\";s:10:\"row_plugin\";s:6:\"entity\";s:6:\"header\";a:1:{s:4:\"area\";a:6:{s:2:\"id\";s:4:\"area\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:4:\"area\";s:5:\"label\";s:26:\"UAS (User activity stream)\";s:7:\"content\";s:87:\"Bellow is an example of a typical UAS (User activity stream), using the Message module.\";s:6:\"format\";s:13:\"filtered_html\";}}s:5:\"empty\";a:1:{s:4:\"area\";a:6:{s:2:\"id\";s:4:\"area\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:4:\"area\";s:5:\"label\";s:23:\"No messages created yet\";s:7:\"content\";s:201:\"You should create some activity (manually or with Drush + Devel generate module):\n\n1) Register new users (<code>drush genu 10</code>)\n2) Create new content and comments (<code>drush genc 10 5</code>)\n\n\";s:6:\"format\";s:13:\"filtered_html\";}}s:6:\"fields\";a:3:{s:14:\"message_render\";a:8:{s:2:\"id\";s:14:\"message_render\";s:5:\"table\";s:7:\"message\";s:5:\"field\";s:14:\"message_render\";s:7:\"ui_name\";s:26:\"User picture - (Partial 0)\";s:5:\"label\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:8:\"partials\";i:1;s:14:\"partials_delta\";s:1:\"0\";}s:16:\"message_render_1\";a:8:{s:2:\"id\";s:16:\"message_render_1\";s:5:\"table\";s:7:\"message\";s:5:\"field\";s:14:\"message_render\";s:7:\"ui_name\";s:28:\"Operation info - (Partial 1)\";s:5:\"label\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:8:\"partials\";i:1;s:14:\"partials_delta\";s:1:\"1\";}s:16:\"message_render_2\";a:8:{s:2:\"id\";s:16:\"message_render_2\";s:5:\"table\";s:7:\"message\";s:5:\"field\";s:14:\"message_render\";s:7:\"ui_name\";s:20:\"Teaser - (Partial 2)\";s:5:\"label\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:8:\"partials\";i:1;s:14:\"partials_delta\";s:1:\"2\";}}s:5:\"sorts\";a:1:{s:9:\"timestamp\";a:4:{s:2:\"id\";s:9:\"timestamp\";s:5:\"table\";s:7:\"message\";s:5:\"field\";s:9:\"timestamp\";s:5:\"order\";s:4:\"DESC\";}}s:7:\"filters\";a:1:{s:21:\"field_published_value\";a:4:{s:2:\"id\";s:21:\"field_published_value\";s:5:\"table\";s:26:\"field_data_field_published\";s:5:\"field\";s:21:\"field_published_value\";s:5:\"value\";a:1:{i:1;s:1:\"1\";}}}}s:8:\"db_table\";s:13:\"views_display\";s:3:\"vid\";i:0;s:2:\"id\";s:7:\"default\";s:13:\"display_title\";s:6:\"Master\";s:14:\"display_plugin\";s:7:\"default\";s:8:\"position\";i:0;}s:4:\"page\";O:13:\"views_display\":8:{s:7:\"handler\";O:25:\"views_plugin_display_page\":10:{s:4:\"view\";r:1;s:8:\"handlers\";a:0:{}s:8:\"extender\";a:0:{}s:7:\"display\";R:208;s:11:\"plugin_type\";s:7:\"display\";s:11:\"plugin_name\";s:4:\"page\";s:7:\"options\";a:42:{s:8:\"defaults\";a:32:{s:6:\"access\";b:1;s:5:\"cache\";b:1;s:5:\"query\";b:1;s:5:\"title\";b:1;s:9:\"css_class\";b:1;s:19:\"display_description\";b:0;s:8:\"use_ajax\";b:1;s:23:\"hide_attachment_summary\";b:1;s:16:\"hide_admin_links\";b:1;s:5:\"pager\";b:1;s:13:\"pager_options\";b:1;s:8:\"use_more\";b:1;s:15:\"use_more_always\";b:1;s:13:\"use_more_text\";b:1;s:12:\"exposed_form\";b:1;s:20:\"exposed_form_options\";b:1;s:12:\"link_display\";b:1;s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:1;s:12:\"style_plugin\";b:1;s:13:\"style_options\";b:1;s:10:\"row_plugin\";b:1;s:11:\"row_options\";b:1;s:6:\"header\";b:1;s:6:\"footer\";b:1;s:5:\"empty\";b:1;s:13:\"relationships\";b:1;s:6:\"fields\";b:1;s:5:\"sorts\";b:1;s:9:\"arguments\";b:1;s:7:\"filters\";b:1;s:13:\"filter_groups\";b:1;}s:5:\"title\";s:0:\"\";s:7:\"enabled\";b:1;s:15:\"display_comment\";s:0:\"\";s:9:\"css_class\";s:0:\"\";s:19:\"display_description\";s:0:\"\";s:8:\"use_ajax\";b:0;s:23:\"hide_attachment_summary\";b:0;s:16:\"hide_admin_links\";b:0;s:14:\"items_per_page\";i:10;s:6:\"offset\";i:0;s:9:\"use_pager\";b:0;s:8:\"use_more\";b:0;s:15:\"use_more_always\";b:0;s:13:\"use_more_text\";s:4:\"more\";s:12:\"link_display\";s:0:\"\";s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:0;s:14:\"field_language\";s:22:\"***CURRENT_LANGUAGE***\";s:27:\"field_language_add_to_query\";i:1;s:6:\"access\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"cache\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:0:{}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"full\";s:7:\"options\";a:0:{}}s:12:\"style_plugin\";s:7:\"default\";s:13:\"style_options\";a:0:{}s:10:\"row_plugin\";s:6:\"fields\";s:11:\"row_options\";a:0:{}s:13:\"exposed_block\";b:0;s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:0:{}s:13:\"relationships\";a:0:{}s:6:\"fields\";a:0:{}s:5:\"sorts\";a:0:{}s:9:\"arguments\";a:0:{}s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}s:7:\"filters\";a:0:{}s:4:\"path\";s:0:\"\";s:4:\"menu\";a:7:{s:4:\"type\";s:4:\"none\";s:5:\"title\";s:0:\"\";s:11:\"description\";s:0:\"\";s:6:\"weight\";i:0;s:4:\"name\";s:10:\"navigation\";s:7:\"context\";s:0:\"\";s:19:\"context_only_inline\";b:0;}s:11:\"tab_options\";a:5:{s:4:\"type\";s:4:\"none\";s:5:\"title\";s:0:\"\";s:11:\"description\";s:0:\"\";s:6:\"weight\";i:0;s:4:\"name\";s:10:\"navigation\";}}s:10:\"definition\";a:20:{s:5:\"title\";s:4:\"Page\";s:4:\"help\";s:54:\"Display the view as a page, with a URL and menu links.\";s:7:\"handler\";s:25:\"views_plugin_display_page\";s:5:\"theme\";s:10:\"views_view\";s:14:\"uses hook menu\";b:1;s:26:\"contextual links locations\";a:1:{i:0;s:4:\"page\";}s:8:\"use ajax\";b:1;s:9:\"use pager\";b:1;s:8:\"use more\";b:1;s:18:\"accept attachments\";b:1;s:5:\"admin\";s:4:\"Page\";s:10:\"help topic\";s:12:\"display-page\";s:6:\"module\";s:5:\"views\";s:10:\"theme path\";s:29:\"sites/all/modules/views/theme\";s:10:\"theme file\";s:9:\"theme.inc\";s:4:\"path\";s:31:\"sites/all/modules/views/plugins\";s:4:\"file\";s:29:\"views_plugin_display_page.inc\";s:6:\"parent\";s:6:\"parent\";s:4:\"name\";s:4:\"page\";s:16:\"contextual links\";a:1:{s:8:\"views_ui\";a:2:{s:11:\"parent path\";s:26:\"admin/structure/views/view\";s:19:\"argument properties\";a:1:{i:0;s:4:\"name\";}}}}s:9:\"is_plugin\";b:1;s:15:\"default_display\";R:37;}s:15:\"display_options\";a:4:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:8:\"defaults\";a:1:{s:16:\"hide_admin_links\";b:0;}s:4:\"path\";s:15:\"message-example\";s:4:\"menu\";a:5:{s:4:\"type\";s:6:\"normal\";s:5:\"title\";s:15:\"Message example\";s:11:\"description\";s:35:\"Typical UAS (User activity stream).\";s:6:\"weight\";s:1:\"0\";s:7:\"context\";i:0;}}s:8:\"db_table\";s:13:\"views_display\";s:3:\"vid\";i:0;s:2:\"id\";s:4:\"page\";s:13:\"display_title\";s:4:\"Page\";s:14:\"display_plugin\";s:4:\"page\";s:8:\"position\";i:0;}}s:12:\"style_plugin\";N;s:13:\"style_options\";N;s:9:\"row_index\";N;s:12:\"override_url\";N;s:13:\"override_path\";N;s:13:\"base_database\";N;s:5:\"field\";N;s:8:\"argument\";N;s:4:\"sort\";N;s:6:\"filter\";N;s:12:\"relationship\";N;s:6:\"header\";N;s:6:\"footer\";N;s:5:\"empty\";N;s:13:\"export_module\";s:15:\"message_example\";}',0,1512620340,1),('ctools_export:views_view:popular','O:4:\"view\":49:{s:8:\"db_table\";s:10:\"views_view\";s:10:\"base_table\";s:4:\"node\";s:10:\"base_field\";s:3:\"nid\";s:4:\"name\";s:7:\"popular\";s:3:\"vid\";s:0:\"\";s:11:\"description\";s:132:\"Shows the most-viewed nodes on the site. This requires the statistics to be enabled at administer >> reports >> access log settings.\";s:3:\"tag\";s:7:\"default\";s:10:\"human_name\";s:15:\"Popular content\";s:4:\"core\";i:0;s:11:\"api_version\";s:3:\"3.0\";s:8:\"disabled\";b:1;s:5:\"built\";b:0;s:8:\"executed\";b:0;s:7:\"editing\";b:0;s:4:\"args\";a:0:{}s:10:\"build_info\";a:0:{}s:8:\"use_ajax\";b:0;s:6:\"result\";a:0:{}s:12:\"current_page\";N;s:14:\"items_per_page\";N;s:6:\"offset\";N;s:10:\"total_rows\";N;s:17:\"attachment_before\";s:0:\"\";s:16:\"attachment_after\";s:0:\"\";s:12:\"exposed_data\";a:0:{}s:13:\"exposed_input\";a:0:{}s:17:\"exposed_raw_input\";a:0:{}s:8:\"old_view\";a:0:{}s:12:\"parent_views\";a:0:{}s:13:\"is_attachment\";N;s:15:\"current_display\";N;s:5:\"query\";N;s:15:\"display_handler\";N;s:7:\"display\";a:5:{s:7:\"default\";O:13:\"views_display\":8:{s:7:\"handler\";O:28:\"views_plugin_display_default\":9:{s:4:\"view\";r:1;s:8:\"handlers\";a:0:{}s:8:\"extender\";a:0:{}s:7:\"display\";R:36;s:11:\"plugin_type\";s:7:\"display\";s:11:\"plugin_name\";s:7:\"default\";s:7:\"options\";a:38:{s:5:\"title\";s:0:\"\";s:7:\"enabled\";b:1;s:15:\"display_comment\";s:0:\"\";s:9:\"css_class\";s:0:\"\";s:19:\"display_description\";s:0:\"\";s:8:\"use_ajax\";b:0;s:23:\"hide_attachment_summary\";b:0;s:16:\"hide_admin_links\";b:0;s:14:\"items_per_page\";i:10;s:6:\"offset\";i:0;s:9:\"use_pager\";b:0;s:8:\"use_more\";b:0;s:15:\"use_more_always\";b:0;s:13:\"use_more_text\";s:4:\"more\";s:12:\"link_display\";s:0:\"\";s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:0;s:14:\"field_language\";s:22:\"***CURRENT_LANGUAGE***\";s:27:\"field_language_add_to_query\";i:1;s:6:\"access\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"cache\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:0:{}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"full\";s:7:\"options\";a:0:{}}s:12:\"style_plugin\";s:7:\"default\";s:13:\"style_options\";a:0:{}s:10:\"row_plugin\";s:6:\"fields\";s:11:\"row_options\";a:0:{}s:13:\"exposed_block\";b:0;s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:0:{}s:13:\"relationships\";a:0:{}s:6:\"fields\";a:0:{}s:5:\"sorts\";a:0:{}s:9:\"arguments\";a:0:{}s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}s:7:\"filters\";a:0:{}}s:10:\"definition\";a:20:{s:5:\"title\";s:6:\"Master\";s:4:\"help\";s:31:\"Default settings for this view.\";s:7:\"handler\";s:28:\"views_plugin_display_default\";s:5:\"theme\";s:10:\"views_view\";s:5:\"no ui\";b:1;s:9:\"no remove\";b:1;s:2:\"js\";a:6:{i:0;s:12:\"misc/form.js\";i:1;s:16:\"misc/collapse.js\";i:2;s:16:\"misc/textarea.js\";i:3;s:17:\"misc/tabledrag.js\";i:4;s:20:\"misc/autocomplete.js\";i:5;s:40:\"sites/all/modules/ctools/js/dependent.js\";}s:8:\"use ajax\";b:1;s:9:\"use pager\";b:1;s:8:\"use more\";b:1;s:18:\"accept attachments\";b:1;s:10:\"help topic\";s:15:\"display-default\";s:6:\"module\";s:5:\"views\";s:10:\"theme path\";s:29:\"sites/all/modules/views/theme\";s:10:\"theme file\";s:9:\"theme.inc\";s:4:\"path\";s:31:\"sites/all/modules/views/plugins\";s:4:\"file\";s:32:\"views_plugin_display_default.inc\";s:6:\"parent\";s:6:\"parent\";s:4:\"name\";s:7:\"default\";s:16:\"contextual links\";a:1:{s:8:\"views_ui\";a:2:{s:11:\"parent path\";s:26:\"admin/structure/views/view\";s:19:\"argument properties\";a:1:{i:0;s:4:\"name\";}}}}s:9:\"is_plugin\";b:1;}s:15:\"display_options\";a:12:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:1:{s:13:\"query_comment\";b:0;}}s:5:\"title\";s:15:\"Popular content\";s:8:\"use_more\";b:1;s:6:\"access\";a:2:{s:4:\"type\";s:4:\"perm\";s:4:\"perm\";s:14:\"access content\";}s:5:\"cache\";a:1:{s:4:\"type\";s:4:\"none\";}s:12:\"exposed_form\";a:1:{s:4:\"type\";s:5:\"basic\";}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"full\";s:7:\"options\";a:1:{s:14:\"items_per_page\";s:2:\"25\";}}s:12:\"style_plugin\";s:5:\"table\";s:13:\"style_options\";a:5:{s:7:\"columns\";a:5:{s:4:\"type\";s:4:\"type\";s:5:\"title\";s:5:\"title\";s:4:\"name\";s:4:\"name\";s:9:\"timestamp\";s:5:\"title\";s:10:\"totalcount\";s:10:\"totalcount\";}s:7:\"default\";s:2:\"-1\";s:4:\"info\";a:5:{s:4:\"type\";a:2:{s:8:\"sortable\";i:0;s:9:\"separator\";s:0:\"\";}s:5:\"title\";a:2:{s:8:\"sortable\";i:0;s:9:\"separator\";s:0:\"\";}s:4:\"name\";a:2:{s:8:\"sortable\";i:0;s:9:\"separator\";s:0:\"\";}s:9:\"timestamp\";a:1:{s:9:\"separator\";s:0:\"\";}s:10:\"totalcount\";a:2:{s:8:\"sortable\";i:0;s:9:\"separator\";s:0:\"\";}}s:8:\"override\";i:0;s:5:\"order\";s:4:\"desc\";}s:6:\"fields\";a:4:{s:4:\"type\";a:3:{s:2:\"id\";s:4:\"type\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:4:\"type\";}s:5:\"title\";a:3:{s:2:\"id\";s:5:\"title\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:5:\"title\";}s:4:\"name\";a:4:{s:2:\"id\";s:4:\"name\";s:5:\"table\";s:5:\"users\";s:5:\"field\";s:4:\"name\";s:5:\"label\";s:6:\"Author\";}s:9:\"timestamp\";a:6:{s:2:\"id\";s:9:\"timestamp\";s:5:\"table\";s:7:\"history\";s:5:\"field\";s:9:\"timestamp\";s:5:\"label\";s:0:\"\";s:12:\"link_to_node\";i:0;s:8:\"comments\";i:1;}}s:5:\"sorts\";a:1:{s:10:\"totalcount\";a:4:{s:2:\"id\";s:10:\"totalcount\";s:5:\"table\";s:12:\"node_counter\";s:5:\"field\";s:10:\"totalcount\";s:5:\"order\";s:4:\"DESC\";}}s:7:\"filters\";a:2:{s:6:\"status\";a:6:{s:2:\"id\";s:6:\"status\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:6:\"status\";s:5:\"value\";s:1:\"1\";s:5:\"group\";i:0;s:6:\"expose\";a:1:{s:8:\"operator\";b:0;}}s:10:\"totalcount\";a:7:{s:2:\"id\";s:10:\"totalcount\";s:5:\"table\";s:12:\"node_counter\";s:5:\"field\";s:10:\"totalcount\";s:8:\"operator\";s:1:\">\";s:5:\"value\";a:1:{s:5:\"value\";s:1:\"0\";}s:5:\"group\";i:0;s:6:\"expose\";a:1:{s:8:\"operator\";b:0;}}}}s:8:\"db_table\";s:13:\"views_display\";s:3:\"vid\";i:0;s:2:\"id\";s:7:\"default\";s:13:\"display_title\";s:6:\"Master\";s:14:\"display_plugin\";s:7:\"default\";s:8:\"position\";i:0;}s:4:\"page\";O:13:\"views_display\":8:{s:7:\"handler\";O:25:\"views_plugin_display_page\":10:{s:4:\"view\";r:1;s:8:\"handlers\";a:0:{}s:8:\"extender\";a:0:{}s:7:\"display\";R:221;s:11:\"plugin_type\";s:7:\"display\";s:11:\"plugin_name\";s:4:\"page\";s:7:\"options\";a:42:{s:8:\"defaults\";a:32:{s:6:\"access\";b:1;s:5:\"cache\";b:1;s:5:\"query\";b:1;s:5:\"title\";b:1;s:9:\"css_class\";b:1;s:19:\"display_description\";b:0;s:8:\"use_ajax\";b:1;s:23:\"hide_attachment_summary\";b:1;s:16:\"hide_admin_links\";b:1;s:5:\"pager\";b:1;s:13:\"pager_options\";b:1;s:8:\"use_more\";b:1;s:15:\"use_more_always\";b:1;s:13:\"use_more_text\";b:1;s:12:\"exposed_form\";b:1;s:20:\"exposed_form_options\";b:1;s:12:\"link_display\";b:1;s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:1;s:12:\"style_plugin\";b:1;s:13:\"style_options\";b:1;s:10:\"row_plugin\";b:1;s:11:\"row_options\";b:1;s:6:\"header\";b:1;s:6:\"footer\";b:1;s:5:\"empty\";b:1;s:13:\"relationships\";b:1;s:6:\"fields\";b:1;s:5:\"sorts\";b:1;s:9:\"arguments\";b:1;s:7:\"filters\";b:1;s:13:\"filter_groups\";b:1;}s:5:\"title\";s:0:\"\";s:7:\"enabled\";b:1;s:15:\"display_comment\";s:0:\"\";s:9:\"css_class\";s:0:\"\";s:19:\"display_description\";s:0:\"\";s:8:\"use_ajax\";b:0;s:23:\"hide_attachment_summary\";b:0;s:16:\"hide_admin_links\";b:0;s:14:\"items_per_page\";i:10;s:6:\"offset\";i:0;s:9:\"use_pager\";b:0;s:8:\"use_more\";b:0;s:15:\"use_more_always\";b:0;s:13:\"use_more_text\";s:4:\"more\";s:12:\"link_display\";s:0:\"\";s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:0;s:14:\"field_language\";s:22:\"***CURRENT_LANGUAGE***\";s:27:\"field_language_add_to_query\";i:1;s:6:\"access\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"cache\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:0:{}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"full\";s:7:\"options\";a:0:{}}s:12:\"style_plugin\";s:7:\"default\";s:13:\"style_options\";a:0:{}s:10:\"row_plugin\";s:6:\"fields\";s:11:\"row_options\";a:0:{}s:13:\"exposed_block\";b:0;s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:0:{}s:13:\"relationships\";a:0:{}s:6:\"fields\";a:0:{}s:5:\"sorts\";a:0:{}s:9:\"arguments\";a:0:{}s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}s:7:\"filters\";a:0:{}s:4:\"path\";s:0:\"\";s:4:\"menu\";a:7:{s:4:\"type\";s:4:\"none\";s:5:\"title\";s:0:\"\";s:11:\"description\";s:0:\"\";s:6:\"weight\";i:0;s:4:\"name\";s:10:\"navigation\";s:7:\"context\";s:0:\"\";s:19:\"context_only_inline\";b:0;}s:11:\"tab_options\";a:5:{s:4:\"type\";s:4:\"none\";s:5:\"title\";s:0:\"\";s:11:\"description\";s:0:\"\";s:6:\"weight\";i:0;s:4:\"name\";s:10:\"navigation\";}}s:10:\"definition\";a:20:{s:5:\"title\";s:4:\"Page\";s:4:\"help\";s:54:\"Display the view as a page, with a URL and menu links.\";s:7:\"handler\";s:25:\"views_plugin_display_page\";s:5:\"theme\";s:10:\"views_view\";s:14:\"uses hook menu\";b:1;s:26:\"contextual links locations\";a:1:{i:0;s:4:\"page\";}s:8:\"use ajax\";b:1;s:9:\"use pager\";b:1;s:8:\"use more\";b:1;s:18:\"accept attachments\";b:1;s:5:\"admin\";s:4:\"Page\";s:10:\"help topic\";s:12:\"display-page\";s:6:\"module\";s:5:\"views\";s:10:\"theme path\";s:29:\"sites/all/modules/views/theme\";s:10:\"theme file\";s:9:\"theme.inc\";s:4:\"path\";s:31:\"sites/all/modules/views/plugins\";s:4:\"file\";s:29:\"views_plugin_display_page.inc\";s:6:\"parent\";s:6:\"parent\";s:4:\"name\";s:4:\"page\";s:16:\"contextual links\";a:1:{s:8:\"views_ui\";a:2:{s:11:\"parent path\";s:26:\"admin/structure/views/view\";s:19:\"argument properties\";a:1:{i:0;s:4:\"name\";}}}}s:9:\"is_plugin\";b:1;s:15:\"default_display\";R:37;}s:15:\"display_options\";a:4:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:4:\"path\";s:11:\"popular/all\";s:4:\"menu\";a:3:{s:4:\"type\";s:11:\"default tab\";s:5:\"title\";s:15:\"Popular content\";s:6:\"weight\";s:2:\"-1\";}s:11:\"tab_options\";a:3:{s:4:\"type\";s:6:\"normal\";s:5:\"title\";s:15:\"Popular content\";s:6:\"weight\";s:0:\"\";}}s:8:\"db_table\";s:13:\"views_display\";s:3:\"vid\";i:0;s:2:\"id\";s:4:\"page\";s:13:\"display_title\";s:14:\"Popular (page)\";s:14:\"display_plugin\";s:4:\"page\";s:8:\"position\";i:0;}s:6:\"page_1\";O:13:\"views_display\":8:{s:7:\"handler\";O:25:\"views_plugin_display_page\":10:{s:4:\"view\";r:1;s:8:\"handlers\";a:0:{}s:8:\"extender\";a:0:{}s:7:\"display\";R:372;s:11:\"plugin_type\";s:7:\"display\";s:11:\"plugin_name\";s:4:\"page\";s:7:\"options\";a:42:{s:8:\"defaults\";a:32:{s:6:\"access\";b:1;s:5:\"cache\";b:1;s:5:\"query\";b:1;s:5:\"title\";b:1;s:9:\"css_class\";b:1;s:19:\"display_description\";b:0;s:8:\"use_ajax\";b:1;s:23:\"hide_attachment_summary\";b:1;s:16:\"hide_admin_links\";b:1;s:5:\"pager\";b:1;s:13:\"pager_options\";b:1;s:8:\"use_more\";b:1;s:15:\"use_more_always\";b:1;s:13:\"use_more_text\";b:1;s:12:\"exposed_form\";b:1;s:20:\"exposed_form_options\";b:1;s:12:\"link_display\";b:1;s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:1;s:12:\"style_plugin\";b:1;s:13:\"style_options\";b:1;s:10:\"row_plugin\";b:1;s:11:\"row_options\";b:1;s:6:\"header\";b:1;s:6:\"footer\";b:1;s:5:\"empty\";b:1;s:13:\"relationships\";b:1;s:6:\"fields\";b:1;s:5:\"sorts\";b:1;s:9:\"arguments\";b:1;s:7:\"filters\";b:1;s:13:\"filter_groups\";b:1;}s:5:\"title\";s:0:\"\";s:7:\"enabled\";b:1;s:15:\"display_comment\";s:0:\"\";s:9:\"css_class\";s:0:\"\";s:19:\"display_description\";s:0:\"\";s:8:\"use_ajax\";b:0;s:23:\"hide_attachment_summary\";b:0;s:16:\"hide_admin_links\";b:0;s:14:\"items_per_page\";i:10;s:6:\"offset\";i:0;s:9:\"use_pager\";b:0;s:8:\"use_more\";b:0;s:15:\"use_more_always\";b:0;s:13:\"use_more_text\";s:4:\"more\";s:12:\"link_display\";s:0:\"\";s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:0;s:14:\"field_language\";s:22:\"***CURRENT_LANGUAGE***\";s:27:\"field_language_add_to_query\";i:1;s:6:\"access\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"cache\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:0:{}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"full\";s:7:\"options\";a:0:{}}s:12:\"style_plugin\";s:7:\"default\";s:13:\"style_options\";a:0:{}s:10:\"row_plugin\";s:6:\"fields\";s:11:\"row_options\";a:0:{}s:13:\"exposed_block\";b:0;s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:0:{}s:13:\"relationships\";a:0:{}s:6:\"fields\";a:0:{}s:5:\"sorts\";a:0:{}s:9:\"arguments\";a:0:{}s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}s:7:\"filters\";a:0:{}s:4:\"path\";s:0:\"\";s:4:\"menu\";a:7:{s:4:\"type\";s:4:\"none\";s:5:\"title\";s:0:\"\";s:11:\"description\";s:0:\"\";s:6:\"weight\";i:0;s:4:\"name\";s:10:\"navigation\";s:7:\"context\";s:0:\"\";s:19:\"context_only_inline\";b:0;}s:11:\"tab_options\";a:5:{s:4:\"type\";s:4:\"none\";s:5:\"title\";s:0:\"\";s:11:\"description\";s:0:\"\";s:6:\"weight\";i:0;s:4:\"name\";s:10:\"navigation\";}}s:10:\"definition\";a:20:{s:5:\"title\";s:4:\"Page\";s:4:\"help\";s:54:\"Display the view as a page, with a URL and menu links.\";s:7:\"handler\";s:25:\"views_plugin_display_page\";s:5:\"theme\";s:10:\"views_view\";s:14:\"uses hook menu\";b:1;s:26:\"contextual links locations\";a:1:{i:0;s:4:\"page\";}s:8:\"use ajax\";b:1;s:9:\"use pager\";b:1;s:8:\"use more\";b:1;s:18:\"accept attachments\";b:1;s:5:\"admin\";s:4:\"Page\";s:10:\"help topic\";s:12:\"display-page\";s:6:\"module\";s:5:\"views\";s:10:\"theme path\";s:29:\"sites/all/modules/views/theme\";s:10:\"theme file\";s:9:\"theme.inc\";s:4:\"path\";s:31:\"sites/all/modules/views/plugins\";s:4:\"file\";s:29:\"views_plugin_display_page.inc\";s:6:\"parent\";s:6:\"parent\";s:4:\"name\";s:4:\"page\";s:16:\"contextual links\";a:1:{s:8:\"views_ui\";a:2:{s:11:\"parent path\";s:26:\"admin/structure/views/view\";s:19:\"argument properties\";a:1:{i:0;s:4:\"name\";}}}}s:9:\"is_plugin\";b:1;s:15:\"default_display\";R:37;}s:15:\"display_options\";a:7:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:8:\"defaults\";a:2:{s:6:\"fields\";b:0;s:5:\"sorts\";b:0;}s:6:\"fields\";a:5:{s:4:\"type\";a:3:{s:2:\"id\";s:4:\"type\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:4:\"type\";}s:5:\"title\";a:3:{s:2:\"id\";s:5:\"title\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:5:\"title\";}s:4:\"name\";a:4:{s:2:\"id\";s:4:\"name\";s:5:\"table\";s:5:\"users\";s:5:\"field\";s:4:\"name\";s:5:\"label\";s:6:\"Author\";}s:9:\"timestamp\";a:6:{s:2:\"id\";s:9:\"timestamp\";s:5:\"table\";s:7:\"history\";s:5:\"field\";s:9:\"timestamp\";s:5:\"label\";s:0:\"\";s:12:\"link_to_node\";i:0;s:8:\"comments\";i:1;}s:8:\"daycount\";a:3:{s:2:\"id\";s:8:\"daycount\";s:5:\"table\";s:12:\"node_counter\";s:5:\"field\";s:8:\"daycount\";}}s:5:\"sorts\";a:1:{s:8:\"daycount\";a:4:{s:2:\"id\";s:8:\"daycount\";s:5:\"table\";s:12:\"node_counter\";s:5:\"field\";s:8:\"daycount\";s:5:\"order\";s:4:\"DESC\";}}s:4:\"path\";s:13:\"popular/today\";s:4:\"menu\";a:3:{s:4:\"type\";s:3:\"tab\";s:5:\"title\";s:23:\"Today\'s popular content\";s:6:\"weight\";s:1:\"0\";}s:11:\"tab_options\";a:3:{s:4:\"type\";s:6:\"normal\";s:5:\"title\";s:15:\"Popular content\";s:6:\"weight\";s:1:\"0\";}}s:8:\"db_table\";s:13:\"views_display\";s:3:\"vid\";i:0;s:2:\"id\";s:6:\"page_1\";s:13:\"display_title\";s:12:\"Today (page)\";s:14:\"display_plugin\";s:4:\"page\";s:8:\"position\";i:0;}s:5:\"block\";O:13:\"views_display\":8:{s:7:\"handler\";O:26:\"views_plugin_display_block\":10:{s:4:\"view\";r:1;s:8:\"handlers\";a:0:{}s:8:\"extender\";a:0:{}s:7:\"display\";R:557;s:11:\"plugin_type\";s:7:\"display\";s:11:\"plugin_name\";s:5:\"block\";s:7:\"options\";a:41:{s:8:\"defaults\";a:32:{s:6:\"access\";b:1;s:5:\"cache\";b:1;s:5:\"query\";b:1;s:5:\"title\";b:1;s:9:\"css_class\";b:1;s:19:\"display_description\";b:0;s:8:\"use_ajax\";b:1;s:23:\"hide_attachment_summary\";b:1;s:16:\"hide_admin_links\";b:1;s:5:\"pager\";b:1;s:13:\"pager_options\";b:1;s:8:\"use_more\";b:1;s:15:\"use_more_always\";b:1;s:13:\"use_more_text\";b:1;s:12:\"exposed_form\";b:1;s:20:\"exposed_form_options\";b:1;s:12:\"link_display\";b:1;s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:1;s:12:\"style_plugin\";b:1;s:13:\"style_options\";b:1;s:10:\"row_plugin\";b:1;s:11:\"row_options\";b:1;s:6:\"header\";b:1;s:6:\"footer\";b:1;s:5:\"empty\";b:1;s:13:\"relationships\";b:1;s:6:\"fields\";b:1;s:5:\"sorts\";b:1;s:9:\"arguments\";b:1;s:7:\"filters\";b:1;s:13:\"filter_groups\";b:1;}s:5:\"title\";s:0:\"\";s:7:\"enabled\";b:1;s:15:\"display_comment\";s:0:\"\";s:9:\"css_class\";s:0:\"\";s:19:\"display_description\";s:0:\"\";s:8:\"use_ajax\";b:0;s:23:\"hide_attachment_summary\";b:0;s:16:\"hide_admin_links\";b:0;s:14:\"items_per_page\";i:10;s:6:\"offset\";i:0;s:9:\"use_pager\";b:0;s:8:\"use_more\";b:0;s:15:\"use_more_always\";b:0;s:13:\"use_more_text\";s:4:\"more\";s:12:\"link_display\";s:0:\"\";s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:0;s:14:\"field_language\";s:22:\"***CURRENT_LANGUAGE***\";s:27:\"field_language_add_to_query\";i:1;s:6:\"access\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"cache\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:0:{}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"full\";s:7:\"options\";a:0:{}}s:12:\"style_plugin\";s:7:\"default\";s:13:\"style_options\";a:0:{}s:10:\"row_plugin\";s:6:\"fields\";s:11:\"row_options\";a:0:{}s:13:\"exposed_block\";b:0;s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:0:{}s:13:\"relationships\";a:0:{}s:6:\"fields\";a:0:{}s:5:\"sorts\";a:0:{}s:9:\"arguments\";a:0:{}s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}s:7:\"filters\";a:0:{}s:17:\"block_description\";s:0:\"\";s:13:\"block_caching\";i:-1;}s:10:\"definition\";a:20:{s:5:\"title\";s:5:\"Block\";s:4:\"help\";s:28:\"Display the view as a block.\";s:7:\"handler\";s:26:\"views_plugin_display_block\";s:5:\"theme\";s:10:\"views_view\";s:15:\"uses hook block\";b:1;s:26:\"contextual links locations\";a:1:{i:0;s:5:\"block\";}s:8:\"use ajax\";b:1;s:9:\"use pager\";b:1;s:8:\"use more\";b:1;s:18:\"accept attachments\";b:1;s:5:\"admin\";s:5:\"Block\";s:10:\"help topic\";s:13:\"display-block\";s:6:\"module\";s:5:\"views\";s:10:\"theme path\";s:29:\"sites/all/modules/views/theme\";s:10:\"theme file\";s:9:\"theme.inc\";s:4:\"path\";s:31:\"sites/all/modules/views/plugins\";s:4:\"file\";s:30:\"views_plugin_display_block.inc\";s:6:\"parent\";s:6:\"parent\";s:4:\"name\";s:5:\"block\";s:16:\"contextual links\";a:1:{s:8:\"views_ui\";a:2:{s:11:\"parent path\";s:26:\"admin/structure/views/view\";s:19:\"argument properties\";a:1:{i:0;s:4:\"name\";}}}}s:9:\"is_plugin\";b:1;s:15:\"default_display\";R:37;}s:15:\"display_options\";a:6:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:8:\"defaults\";a:5:{s:12:\"style_plugin\";b:0;s:13:\"style_options\";b:0;s:10:\"row_plugin\";b:0;s:11:\"row_options\";b:0;s:6:\"fields\";b:0;}s:12:\"style_plugin\";s:4:\"list\";s:10:\"row_plugin\";s:6:\"fields\";s:11:\"row_options\";a:1:{s:6:\"inline\";a:2:{s:5:\"title\";s:5:\"title\";s:10:\"totalcount\";s:10:\"totalcount\";}}s:6:\"fields\";a:2:{s:5:\"title\";a:5:{s:2:\"id\";s:5:\"title\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:5:\"title\";s:5:\"label\";s:0:\"\";s:12:\"link_to_node\";i:1;}s:10:\"totalcount\";a:6:{s:2:\"id\";s:10:\"totalcount\";s:5:\"table\";s:12:\"node_counter\";s:5:\"field\";s:10:\"totalcount\";s:5:\"label\";s:0:\"\";s:6:\"prefix\";s:2:\" (\";s:6:\"suffix\";s:1:\")\";}}}s:8:\"db_table\";s:13:\"views_display\";s:3:\"vid\";i:0;s:2:\"id\";s:5:\"block\";s:13:\"display_title\";s:15:\"Popular (block)\";s:14:\"display_plugin\";s:5:\"block\";s:8:\"position\";i:0;}s:7:\"block_1\";O:13:\"views_display\":8:{s:7:\"handler\";O:26:\"views_plugin_display_block\":10:{s:4:\"view\";r:1;s:8:\"handlers\";a:0:{}s:8:\"extender\";a:0:{}s:7:\"display\";R:712;s:11:\"plugin_type\";s:7:\"display\";s:11:\"plugin_name\";s:5:\"block\";s:7:\"options\";a:41:{s:8:\"defaults\";a:32:{s:6:\"access\";b:1;s:5:\"cache\";b:1;s:5:\"query\";b:1;s:5:\"title\";b:1;s:9:\"css_class\";b:1;s:19:\"display_description\";b:0;s:8:\"use_ajax\";b:1;s:23:\"hide_attachment_summary\";b:1;s:16:\"hide_admin_links\";b:1;s:5:\"pager\";b:1;s:13:\"pager_options\";b:1;s:8:\"use_more\";b:1;s:15:\"use_more_always\";b:1;s:13:\"use_more_text\";b:1;s:12:\"exposed_form\";b:1;s:20:\"exposed_form_options\";b:1;s:12:\"link_display\";b:1;s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:1;s:12:\"style_plugin\";b:1;s:13:\"style_options\";b:1;s:10:\"row_plugin\";b:1;s:11:\"row_options\";b:1;s:6:\"header\";b:1;s:6:\"footer\";b:1;s:5:\"empty\";b:1;s:13:\"relationships\";b:1;s:6:\"fields\";b:1;s:5:\"sorts\";b:1;s:9:\"arguments\";b:1;s:7:\"filters\";b:1;s:13:\"filter_groups\";b:1;}s:5:\"title\";s:0:\"\";s:7:\"enabled\";b:1;s:15:\"display_comment\";s:0:\"\";s:9:\"css_class\";s:0:\"\";s:19:\"display_description\";s:0:\"\";s:8:\"use_ajax\";b:0;s:23:\"hide_attachment_summary\";b:0;s:16:\"hide_admin_links\";b:0;s:14:\"items_per_page\";i:10;s:6:\"offset\";i:0;s:9:\"use_pager\";b:0;s:8:\"use_more\";b:0;s:15:\"use_more_always\";b:0;s:13:\"use_more_text\";s:4:\"more\";s:12:\"link_display\";s:0:\"\";s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:0;s:14:\"field_language\";s:22:\"***CURRENT_LANGUAGE***\";s:27:\"field_language_add_to_query\";i:1;s:6:\"access\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"cache\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:0:{}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"full\";s:7:\"options\";a:0:{}}s:12:\"style_plugin\";s:7:\"default\";s:13:\"style_options\";a:0:{}s:10:\"row_plugin\";s:6:\"fields\";s:11:\"row_options\";a:0:{}s:13:\"exposed_block\";b:0;s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:0:{}s:13:\"relationships\";a:0:{}s:6:\"fields\";a:0:{}s:5:\"sorts\";a:0:{}s:9:\"arguments\";a:0:{}s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}s:7:\"filters\";a:0:{}s:17:\"block_description\";s:0:\"\";s:13:\"block_caching\";i:-1;}s:10:\"definition\";a:20:{s:5:\"title\";s:5:\"Block\";s:4:\"help\";s:28:\"Display the view as a block.\";s:7:\"handler\";s:26:\"views_plugin_display_block\";s:5:\"theme\";s:10:\"views_view\";s:15:\"uses hook block\";b:1;s:26:\"contextual links locations\";a:1:{i:0;s:5:\"block\";}s:8:\"use ajax\";b:1;s:9:\"use pager\";b:1;s:8:\"use more\";b:1;s:18:\"accept attachments\";b:1;s:5:\"admin\";s:5:\"Block\";s:10:\"help topic\";s:13:\"display-block\";s:6:\"module\";s:5:\"views\";s:10:\"theme path\";s:29:\"sites/all/modules/views/theme\";s:10:\"theme file\";s:9:\"theme.inc\";s:4:\"path\";s:31:\"sites/all/modules/views/plugins\";s:4:\"file\";s:30:\"views_plugin_display_block.inc\";s:6:\"parent\";s:6:\"parent\";s:4:\"name\";s:5:\"block\";s:16:\"contextual links\";a:1:{s:8:\"views_ui\";a:2:{s:11:\"parent path\";s:26:\"admin/structure/views/view\";s:19:\"argument properties\";a:1:{i:0;s:4:\"name\";}}}}s:9:\"is_plugin\";b:1;s:15:\"default_display\";R:37;}s:15:\"display_options\";a:9:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:8:\"defaults\";a:8:{s:5:\"title\";b:0;s:12:\"link_display\";b:0;s:12:\"style_plugin\";b:0;s:13:\"style_options\";b:0;s:10:\"row_plugin\";b:0;s:11:\"row_options\";b:0;s:6:\"fields\";b:0;s:5:\"sorts\";b:0;}s:5:\"title\";s:23:\"Today\'s popular content\";s:12:\"link_display\";s:6:\"page_1\";s:12:\"style_plugin\";s:4:\"list\";s:10:\"row_plugin\";s:6:\"fields\";s:11:\"row_options\";a:1:{s:6:\"inline\";a:2:{s:5:\"title\";s:5:\"title\";s:8:\"daycount\";s:8:\"daycount\";}}s:6:\"fields\";a:2:{s:5:\"title\";a:5:{s:2:\"id\";s:5:\"title\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:5:\"title\";s:5:\"label\";s:0:\"\";s:12:\"link_to_node\";i:1;}s:8:\"daycount\";a:6:{s:2:\"id\";s:8:\"daycount\";s:5:\"table\";s:12:\"node_counter\";s:5:\"field\";s:8:\"daycount\";s:5:\"label\";s:0:\"\";s:6:\"prefix\";s:2:\" (\";s:6:\"suffix\";s:1:\")\";}}s:5:\"sorts\";a:1:{s:8:\"daycount\";a:4:{s:2:\"id\";s:8:\"daycount\";s:5:\"table\";s:12:\"node_counter\";s:5:\"field\";s:8:\"daycount\";s:5:\"order\";s:4:\"DESC\";}}}s:8:\"db_table\";s:13:\"views_display\";s:3:\"vid\";i:0;s:2:\"id\";s:7:\"block_1\";s:13:\"display_title\";s:13:\"Today (block)\";s:14:\"display_plugin\";s:5:\"block\";s:8:\"position\";i:0;}}s:12:\"style_plugin\";N;s:13:\"style_options\";N;s:9:\"row_index\";N;s:12:\"override_url\";N;s:13:\"override_path\";N;s:13:\"base_database\";N;s:5:\"field\";N;s:8:\"argument\";N;s:4:\"sort\";N;s:6:\"filter\";N;s:12:\"relationship\";N;s:6:\"header\";N;s:6:\"footer\";N;s:5:\"empty\";N;s:13:\"export_module\";s:10:\"statistics\";}',0,1512620340,1),('ctools_export:views_view:taxonomy_term','O:4:\"view\":49:{s:8:\"db_table\";s:10:\"views_view\";s:10:\"base_table\";s:4:\"node\";s:10:\"base_field\";s:3:\"nid\";s:4:\"name\";s:13:\"taxonomy_term\";s:3:\"vid\";s:0:\"\";s:11:\"description\";s:58:\"A view to emulate Drupal core\'s handling of taxonomy/term.\";s:3:\"tag\";s:7:\"default\";s:10:\"human_name\";s:13:\"Taxonomy term\";s:4:\"core\";i:7;s:11:\"api_version\";s:3:\"3.0\";s:8:\"disabled\";b:1;s:5:\"built\";b:0;s:8:\"executed\";b:0;s:7:\"editing\";b:0;s:4:\"args\";a:0:{}s:10:\"build_info\";a:0:{}s:8:\"use_ajax\";b:0;s:6:\"result\";a:0:{}s:12:\"current_page\";N;s:14:\"items_per_page\";N;s:6:\"offset\";N;s:10:\"total_rows\";N;s:17:\"attachment_before\";s:0:\"\";s:16:\"attachment_after\";s:0:\"\";s:12:\"exposed_data\";a:0:{}s:13:\"exposed_input\";a:0:{}s:17:\"exposed_raw_input\";a:0:{}s:8:\"old_view\";a:0:{}s:12:\"parent_views\";a:0:{}s:13:\"is_attachment\";N;s:15:\"current_display\";N;s:5:\"query\";N;s:15:\"display_handler\";N;s:7:\"display\";a:3:{s:7:\"default\";O:13:\"views_display\":8:{s:7:\"handler\";O:28:\"views_plugin_display_default\":9:{s:4:\"view\";r:1;s:8:\"handlers\";a:0:{}s:8:\"extender\";a:0:{}s:7:\"display\";R:36;s:11:\"plugin_type\";s:7:\"display\";s:11:\"plugin_name\";s:7:\"default\";s:7:\"options\";a:38:{s:5:\"title\";s:0:\"\";s:7:\"enabled\";b:1;s:15:\"display_comment\";s:0:\"\";s:9:\"css_class\";s:0:\"\";s:19:\"display_description\";s:0:\"\";s:8:\"use_ajax\";b:0;s:23:\"hide_attachment_summary\";b:0;s:16:\"hide_admin_links\";b:0;s:14:\"items_per_page\";i:10;s:6:\"offset\";i:0;s:9:\"use_pager\";b:0;s:8:\"use_more\";b:0;s:15:\"use_more_always\";b:0;s:13:\"use_more_text\";s:4:\"more\";s:12:\"link_display\";s:0:\"\";s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:0;s:14:\"field_language\";s:22:\"***CURRENT_LANGUAGE***\";s:27:\"field_language_add_to_query\";i:1;s:6:\"access\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"cache\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:0:{}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"full\";s:7:\"options\";a:0:{}}s:12:\"style_plugin\";s:7:\"default\";s:13:\"style_options\";a:0:{}s:10:\"row_plugin\";s:6:\"fields\";s:11:\"row_options\";a:0:{}s:13:\"exposed_block\";b:0;s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:0:{}s:13:\"relationships\";a:0:{}s:6:\"fields\";a:0:{}s:5:\"sorts\";a:0:{}s:9:\"arguments\";a:0:{}s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}s:7:\"filters\";a:0:{}}s:10:\"definition\";a:20:{s:5:\"title\";s:6:\"Master\";s:4:\"help\";s:31:\"Default settings for this view.\";s:7:\"handler\";s:28:\"views_plugin_display_default\";s:5:\"theme\";s:10:\"views_view\";s:5:\"no ui\";b:1;s:9:\"no remove\";b:1;s:2:\"js\";a:6:{i:0;s:12:\"misc/form.js\";i:1;s:16:\"misc/collapse.js\";i:2;s:16:\"misc/textarea.js\";i:3;s:17:\"misc/tabledrag.js\";i:4;s:20:\"misc/autocomplete.js\";i:5;s:40:\"sites/all/modules/ctools/js/dependent.js\";}s:8:\"use ajax\";b:1;s:9:\"use pager\";b:1;s:8:\"use more\";b:1;s:18:\"accept attachments\";b:1;s:10:\"help topic\";s:15:\"display-default\";s:6:\"module\";s:5:\"views\";s:10:\"theme path\";s:29:\"sites/all/modules/views/theme\";s:10:\"theme file\";s:9:\"theme.inc\";s:4:\"path\";s:31:\"sites/all/modules/views/plugins\";s:4:\"file\";s:32:\"views_plugin_display_default.inc\";s:6:\"parent\";s:6:\"parent\";s:4:\"name\";s:7:\"default\";s:16:\"contextual links\";a:1:{s:8:\"views_ui\";a:2:{s:11:\"parent path\";s:26:\"admin/structure/views/view\";s:19:\"argument properties\";a:1:{i:0;s:4:\"name\";}}}}s:9:\"is_plugin\";b:1;}s:15:\"display_options\";a:10:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:1:{s:13:\"query_comment\";b:0;}}s:6:\"access\";a:2:{s:4:\"type\";s:4:\"perm\";s:4:\"perm\";s:14:\"access content\";}s:5:\"cache\";a:1:{s:4:\"type\";s:4:\"none\";}s:12:\"exposed_form\";a:1:{s:4:\"type\";s:5:\"basic\";}s:5:\"pager\";a:1:{s:4:\"type\";s:4:\"full\";}s:12:\"style_plugin\";s:7:\"default\";s:10:\"row_plugin\";s:4:\"node\";s:5:\"sorts\";a:2:{s:6:\"sticky\";a:4:{s:2:\"id\";s:6:\"sticky\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:6:\"sticky\";s:5:\"order\";s:4:\"DESC\";}s:7:\"created\";a:4:{s:2:\"id\";s:7:\"created\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:7:\"created\";s:5:\"order\";s:4:\"DESC\";}}s:9:\"arguments\";a:2:{s:19:\"term_node_tid_depth\";a:13:{s:2:\"id\";s:19:\"term_node_tid_depth\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:19:\"term_node_tid_depth\";s:14:\"default_action\";s:9:\"not found\";s:9:\"exception\";a:1:{s:12:\"title_enable\";i:1;}s:12:\"title_enable\";i:1;s:5:\"title\";s:2:\"%1\";s:21:\"default_argument_type\";s:5:\"fixed\";s:7:\"summary\";a:1:{s:6:\"format\";s:15:\"default_summary\";}s:18:\"specify_validation\";i:1;s:8:\"validate\";a:1:{s:4:\"type\";s:13:\"taxonomy_term\";}s:5:\"depth\";s:1:\"0\";s:12:\"break_phrase\";i:1;}s:28:\"term_node_tid_depth_modifier\";a:7:{s:2:\"id\";s:28:\"term_node_tid_depth_modifier\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:28:\"term_node_tid_depth_modifier\";s:9:\"exception\";a:1:{s:12:\"title_enable\";i:1;}s:21:\"default_argument_type\";s:5:\"fixed\";s:7:\"summary\";a:1:{s:6:\"format\";s:15:\"default_summary\";}s:18:\"specify_validation\";i:1;}}s:7:\"filters\";a:1:{s:12:\"status_extra\";a:5:{s:2:\"id\";s:12:\"status_extra\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:12:\"status_extra\";s:5:\"group\";i:0;s:6:\"expose\";a:1:{s:8:\"operator\";b:0;}}}}s:8:\"db_table\";s:13:\"views_display\";s:3:\"vid\";i:0;s:2:\"id\";s:7:\"default\";s:13:\"display_title\";s:6:\"Master\";s:14:\"display_plugin\";s:7:\"default\";s:8:\"position\";i:0;}s:4:\"page\";O:13:\"views_display\":8:{s:7:\"handler\";O:25:\"views_plugin_display_page\":10:{s:4:\"view\";r:1;s:8:\"handlers\";a:0:{}s:8:\"extender\";a:0:{}s:7:\"display\";R:194;s:11:\"plugin_type\";s:7:\"display\";s:11:\"plugin_name\";s:4:\"page\";s:7:\"options\";a:42:{s:8:\"defaults\";a:32:{s:6:\"access\";b:1;s:5:\"cache\";b:1;s:5:\"query\";b:1;s:5:\"title\";b:1;s:9:\"css_class\";b:1;s:19:\"display_description\";b:0;s:8:\"use_ajax\";b:1;s:23:\"hide_attachment_summary\";b:1;s:16:\"hide_admin_links\";b:1;s:5:\"pager\";b:1;s:13:\"pager_options\";b:1;s:8:\"use_more\";b:1;s:15:\"use_more_always\";b:1;s:13:\"use_more_text\";b:1;s:12:\"exposed_form\";b:1;s:20:\"exposed_form_options\";b:1;s:12:\"link_display\";b:1;s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:1;s:12:\"style_plugin\";b:1;s:13:\"style_options\";b:1;s:10:\"row_plugin\";b:1;s:11:\"row_options\";b:1;s:6:\"header\";b:1;s:6:\"footer\";b:1;s:5:\"empty\";b:1;s:13:\"relationships\";b:1;s:6:\"fields\";b:1;s:5:\"sorts\";b:1;s:9:\"arguments\";b:1;s:7:\"filters\";b:1;s:13:\"filter_groups\";b:1;}s:5:\"title\";s:0:\"\";s:7:\"enabled\";b:1;s:15:\"display_comment\";s:0:\"\";s:9:\"css_class\";s:0:\"\";s:19:\"display_description\";s:0:\"\";s:8:\"use_ajax\";b:0;s:23:\"hide_attachment_summary\";b:0;s:16:\"hide_admin_links\";b:0;s:14:\"items_per_page\";i:10;s:6:\"offset\";i:0;s:9:\"use_pager\";b:0;s:8:\"use_more\";b:0;s:15:\"use_more_always\";b:0;s:13:\"use_more_text\";s:4:\"more\";s:12:\"link_display\";s:0:\"\";s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:0;s:14:\"field_language\";s:22:\"***CURRENT_LANGUAGE***\";s:27:\"field_language_add_to_query\";i:1;s:6:\"access\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"cache\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:0:{}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"full\";s:7:\"options\";a:0:{}}s:12:\"style_plugin\";s:7:\"default\";s:13:\"style_options\";a:0:{}s:10:\"row_plugin\";s:6:\"fields\";s:11:\"row_options\";a:0:{}s:13:\"exposed_block\";b:0;s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:0:{}s:13:\"relationships\";a:0:{}s:6:\"fields\";a:0:{}s:5:\"sorts\";a:0:{}s:9:\"arguments\";a:0:{}s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}s:7:\"filters\";a:0:{}s:4:\"path\";s:0:\"\";s:4:\"menu\";a:7:{s:4:\"type\";s:4:\"none\";s:5:\"title\";s:0:\"\";s:11:\"description\";s:0:\"\";s:6:\"weight\";i:0;s:4:\"name\";s:10:\"navigation\";s:7:\"context\";s:0:\"\";s:19:\"context_only_inline\";b:0;}s:11:\"tab_options\";a:5:{s:4:\"type\";s:4:\"none\";s:5:\"title\";s:0:\"\";s:11:\"description\";s:0:\"\";s:6:\"weight\";i:0;s:4:\"name\";s:10:\"navigation\";}}s:10:\"definition\";a:20:{s:5:\"title\";s:4:\"Page\";s:4:\"help\";s:54:\"Display the view as a page, with a URL and menu links.\";s:7:\"handler\";s:25:\"views_plugin_display_page\";s:5:\"theme\";s:10:\"views_view\";s:14:\"uses hook menu\";b:1;s:26:\"contextual links locations\";a:1:{i:0;s:4:\"page\";}s:8:\"use ajax\";b:1;s:9:\"use pager\";b:1;s:8:\"use more\";b:1;s:18:\"accept attachments\";b:1;s:5:\"admin\";s:4:\"Page\";s:10:\"help topic\";s:12:\"display-page\";s:6:\"module\";s:5:\"views\";s:10:\"theme path\";s:29:\"sites/all/modules/views/theme\";s:10:\"theme file\";s:9:\"theme.inc\";s:4:\"path\";s:31:\"sites/all/modules/views/plugins\";s:4:\"file\";s:29:\"views_plugin_display_page.inc\";s:6:\"parent\";s:6:\"parent\";s:4:\"name\";s:4:\"page\";s:16:\"contextual links\";a:1:{s:8:\"views_ui\";a:2:{s:11:\"parent path\";s:26:\"admin/structure/views/view\";s:19:\"argument properties\";a:1:{i:0;s:4:\"name\";}}}}s:9:\"is_plugin\";b:1;s:15:\"default_display\";R:37;}s:15:\"display_options\";a:2:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:4:\"path\";s:15:\"taxonomy/term/%\";}s:8:\"db_table\";s:13:\"views_display\";s:3:\"vid\";i:0;s:2:\"id\";s:4:\"page\";s:13:\"display_title\";s:4:\"Page\";s:14:\"display_plugin\";s:4:\"page\";s:8:\"position\";i:0;}s:4:\"feed\";O:13:\"views_display\":8:{s:7:\"handler\";O:25:\"views_plugin_display_feed\":10:{s:4:\"view\";r:1;s:8:\"handlers\";a:0:{}s:8:\"extender\";a:0:{}s:7:\"display\";R:337;s:11:\"plugin_type\";s:7:\"display\";s:11:\"plugin_name\";s:4:\"feed\";s:7:\"options\";a:44:{s:8:\"defaults\";a:35:{s:6:\"access\";b:1;s:5:\"cache\";b:1;s:5:\"query\";b:1;s:5:\"title\";b:1;s:9:\"css_class\";b:1;s:19:\"display_description\";b:0;s:8:\"use_ajax\";b:1;s:23:\"hide_attachment_summary\";b:1;s:16:\"hide_admin_links\";b:1;s:5:\"pager\";b:0;s:13:\"pager_options\";b:1;s:8:\"use_more\";b:1;s:15:\"use_more_always\";b:1;s:13:\"use_more_text\";b:1;s:12:\"exposed_form\";b:1;s:20:\"exposed_form_options\";b:1;s:12:\"link_display\";b:1;s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:1;s:12:\"style_plugin\";b:0;s:13:\"style_options\";b:0;s:10:\"row_plugin\";b:0;s:11:\"row_options\";b:0;s:6:\"header\";b:1;s:6:\"footer\";b:1;s:5:\"empty\";b:1;s:13:\"relationships\";b:1;s:6:\"fields\";b:1;s:5:\"sorts\";b:1;s:9:\"arguments\";b:1;s:7:\"filters\";b:1;s:13:\"filter_groups\";b:1;s:9:\"use_pager\";b:0;s:14:\"items_per_page\";b:0;s:6:\"offset\";b:0;}s:5:\"title\";s:0:\"\";s:7:\"enabled\";b:1;s:15:\"display_comment\";s:0:\"\";s:9:\"css_class\";s:0:\"\";s:19:\"display_description\";s:0:\"\";s:8:\"use_ajax\";b:0;s:23:\"hide_attachment_summary\";b:0;s:16:\"hide_admin_links\";b:0;s:14:\"items_per_page\";i:10;s:6:\"offset\";i:0;s:9:\"use_pager\";b:0;s:8:\"use_more\";b:0;s:15:\"use_more_always\";b:0;s:13:\"use_more_text\";s:4:\"more\";s:12:\"link_display\";s:0:\"\";s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:0;s:14:\"field_language\";s:22:\"***CURRENT_LANGUAGE***\";s:27:\"field_language_add_to_query\";i:1;s:6:\"access\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"cache\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:0:{}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"some\";s:7:\"options\";a:0:{}}s:12:\"style_plugin\";s:3:\"rss\";s:13:\"style_options\";a:1:{s:11:\"description\";s:0:\"\";}s:10:\"row_plugin\";s:8:\"node_rss\";s:11:\"row_options\";a:0:{}s:13:\"exposed_block\";b:0;s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:0:{}s:13:\"relationships\";a:0:{}s:6:\"fields\";a:0:{}s:5:\"sorts\";a:0:{}s:9:\"arguments\";a:0:{}s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}s:7:\"filters\";a:0:{}s:4:\"path\";s:0:\"\";s:4:\"menu\";a:7:{s:4:\"type\";s:4:\"none\";s:5:\"title\";s:0:\"\";s:11:\"description\";s:0:\"\";s:6:\"weight\";i:0;s:4:\"name\";s:10:\"navigation\";s:7:\"context\";s:0:\"\";s:19:\"context_only_inline\";b:0;}s:11:\"tab_options\";a:5:{s:4:\"type\";s:4:\"none\";s:5:\"title\";s:0:\"\";s:11:\"description\";s:0:\"\";s:6:\"weight\";i:0;s:4:\"name\";s:10:\"navigation\";}s:8:\"displays\";a:0:{}s:14:\"sitename_title\";b:0;}s:10:\"definition\";a:17:{s:5:\"title\";s:4:\"Feed\";s:4:\"help\";s:48:\"Display the view as a feed, such as an RSS feed.\";s:7:\"handler\";s:25:\"views_plugin_display_feed\";s:14:\"uses hook menu\";b:1;s:8:\"use ajax\";b:0;s:9:\"use pager\";b:0;s:18:\"accept attachments\";b:0;s:5:\"admin\";s:4:\"Feed\";s:10:\"help topic\";s:12:\"display-feed\";s:6:\"module\";s:5:\"views\";s:10:\"theme path\";s:29:\"sites/all/modules/views/theme\";s:10:\"theme file\";s:9:\"theme.inc\";s:4:\"path\";s:31:\"sites/all/modules/views/plugins\";s:4:\"file\";s:29:\"views_plugin_display_feed.inc\";s:6:\"parent\";s:6:\"parent\";s:4:\"name\";s:4:\"feed\";s:16:\"contextual links\";a:1:{s:8:\"views_ui\";a:2:{s:11:\"parent path\";s:26:\"admin/structure/views/view\";s:19:\"argument properties\";a:1:{i:0;s:4:\"name\";}}}}s:9:\"is_plugin\";b:1;s:15:\"default_display\";R:37;}s:15:\"display_options\";a:6:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"full\";s:7:\"options\";a:1:{s:14:\"items_per_page\";i:15;}}s:12:\"style_plugin\";s:3:\"rss\";s:10:\"row_plugin\";s:8:\"node_rss\";s:4:\"path\";s:22:\"taxonomy/term/%/%/feed\";s:8:\"displays\";a:2:{s:4:\"page\";s:4:\"page\";s:7:\"default\";i:0;}}s:8:\"db_table\";s:13:\"views_display\";s:3:\"vid\";i:0;s:2:\"id\";s:4:\"feed\";s:13:\"display_title\";s:4:\"Feed\";s:14:\"display_plugin\";s:4:\"feed\";s:8:\"position\";i:0;}}s:12:\"style_plugin\";N;s:13:\"style_options\";N;s:9:\"row_index\";N;s:12:\"override_url\";N;s:13:\"override_path\";N;s:13:\"base_database\";N;s:5:\"field\";N;s:8:\"argument\";N;s:4:\"sort\";N;s:6:\"filter\";N;s:12:\"relationship\";N;s:6:\"header\";N;s:6:\"footer\";N;s:5:\"empty\";N;s:13:\"export_module\";s:8:\"taxonomy\";}',0,1512620340,1),('ctools_export:views_view:top_content','O:4:\"view\":52:{s:8:\"db_table\";s:10:\"views_view\";s:10:\"base_table\";s:4:\"node\";s:10:\"base_field\";s:3:\"nid\";s:4:\"name\";s:11:\"top_content\";s:3:\"vid\";s:0:\"\";s:11:\"description\";s:17:\"Top rated content\";s:3:\"tag\";s:9:\"votingapi\";s:10:\"human_name\";s:0:\"\";s:4:\"core\";i:0;s:11:\"api_version\";i:2;s:8:\"disabled\";b:1;s:5:\"built\";b:0;s:8:\"executed\";b:0;s:7:\"editing\";b:0;s:4:\"args\";a:0:{}s:10:\"build_info\";a:0:{}s:8:\"use_ajax\";b:0;s:6:\"result\";a:0:{}s:12:\"current_page\";N;s:14:\"items_per_page\";N;s:6:\"offset\";N;s:10:\"total_rows\";N;s:17:\"attachment_before\";s:0:\"\";s:16:\"attachment_after\";s:0:\"\";s:12:\"exposed_data\";a:0:{}s:13:\"exposed_input\";a:0:{}s:17:\"exposed_raw_input\";a:0:{}s:8:\"old_view\";a:0:{}s:12:\"parent_views\";a:0:{}s:13:\"is_attachment\";N;s:15:\"current_display\";N;s:5:\"query\";N;s:15:\"display_handler\";N;s:7:\"display\";a:4:{s:7:\"default\";O:13:\"views_display\":8:{s:7:\"handler\";O:28:\"views_plugin_display_default\":9:{s:4:\"view\";r:1;s:8:\"handlers\";a:0:{}s:8:\"extender\";a:0:{}s:7:\"display\";R:36;s:11:\"plugin_type\";s:7:\"display\";s:11:\"plugin_name\";s:7:\"default\";s:7:\"options\";a:40:{s:5:\"title\";s:17:\"Top rated content\";s:7:\"enabled\";b:1;s:15:\"display_comment\";s:0:\"\";s:9:\"css_class\";s:0:\"\";s:19:\"display_description\";s:0:\"\";s:8:\"use_ajax\";b:0;s:23:\"hide_attachment_summary\";b:0;s:16:\"hide_admin_links\";b:0;s:14:\"items_per_page\";N;s:6:\"offset\";N;s:9:\"use_pager\";s:1:\"1\";s:8:\"use_more\";b:0;s:15:\"use_more_always\";b:0;s:13:\"use_more_text\";s:4:\"more\";s:12:\"link_display\";s:0:\"\";s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:0;s:14:\"field_language\";s:22:\"***CURRENT_LANGUAGE***\";s:27:\"field_language_add_to_query\";i:1;s:6:\"access\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"cache\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:0:{}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"some\";s:7:\"options\";a:2:{s:6:\"offset\";i:0;s:14:\"items_per_page\";i:10;}}s:12:\"style_plugin\";s:5:\"table\";s:13:\"style_options\";a:7:{s:8:\"grouping\";s:0:\"\";s:8:\"override\";i:1;s:6:\"sticky\";i:1;s:5:\"order\";s:4:\"desc\";s:7:\"columns\";a:3:{s:4:\"name\";s:4:\"name\";s:5:\"title\";s:5:\"title\";s:7:\"created\";s:7:\"created\";}s:4:\"info\";a:3:{s:4:\"name\";a:2:{s:8:\"sortable\";i:1;s:9:\"separator\";s:0:\"\";}s:5:\"title\";a:2:{s:8:\"sortable\";i:1;s:9:\"separator\";s:0:\"\";}s:7:\"created\";a:2:{s:8:\"sortable\";i:1;s:9:\"separator\";s:0:\"\";}}s:7:\"default\";s:5:\"title\";}s:10:\"row_plugin\";s:6:\"fields\";s:11:\"row_options\";a:0:{}s:13:\"exposed_block\";b:0;s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:0:{}s:13:\"relationships\";a:0:{}s:6:\"fields\";a:3:{s:4:\"name\";a:7:{s:5:\"label\";s:6:\"Author\";s:12:\"link_to_user\";i:1;s:7:\"exclude\";i:0;s:2:\"id\";s:4:\"name\";s:5:\"table\";s:5:\"users\";s:5:\"field\";s:4:\"name\";s:12:\"relationship\";s:4:\"none\";}s:5:\"title\";a:7:{s:5:\"label\";s:5:\"Title\";s:12:\"link_to_node\";i:1;s:7:\"exclude\";i:0;s:2:\"id\";s:5:\"title\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:5:\"title\";s:12:\"relationship\";s:4:\"none\";}s:7:\"created\";a:8:{s:5:\"label\";s:6:\"Posted\";s:11:\"date_format\";s:8:\"time ago\";s:18:\"custom_date_format\";s:1:\"1\";s:7:\"exclude\";i:0;s:2:\"id\";s:7:\"created\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:7:\"created\";s:12:\"relationship\";s:4:\"none\";}}s:5:\"sorts\";a:0:{}s:9:\"arguments\";a:0:{}s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}s:7:\"filters\";a:1:{s:6:\"status\";a:9:{s:8:\"operator\";s:1:\"=\";s:5:\"value\";i:1;s:5:\"group\";s:1:\"0\";s:7:\"exposed\";b:0;s:6:\"expose\";a:2:{s:8:\"operator\";b:0;s:5:\"label\";s:0:\"\";}s:2:\"id\";s:6:\"status\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:6:\"status\";s:12:\"relationship\";s:4:\"none\";}}s:8:\"defaults\";a:10:{s:6:\"fields\";b:0;s:7:\"filters\";b:0;s:13:\"filter_groups\";b:0;s:6:\"access\";b:0;s:14:\"access_options\";b:0;s:5:\"title\";b:0;s:12:\"style_plugin\";b:0;s:13:\"style_options\";b:0;s:10:\"row_plugin\";b:0;s:11:\"row_options\";b:0;}s:14:\"access_options\";N;}s:10:\"definition\";a:20:{s:5:\"title\";s:6:\"Master\";s:4:\"help\";s:31:\"Default settings for this view.\";s:7:\"handler\";s:28:\"views_plugin_display_default\";s:5:\"theme\";s:10:\"views_view\";s:5:\"no ui\";b:1;s:9:\"no remove\";b:1;s:2:\"js\";a:6:{i:0;s:12:\"misc/form.js\";i:1;s:16:\"misc/collapse.js\";i:2;s:16:\"misc/textarea.js\";i:3;s:17:\"misc/tabledrag.js\";i:4;s:20:\"misc/autocomplete.js\";i:5;s:40:\"sites/all/modules/ctools/js/dependent.js\";}s:8:\"use ajax\";b:1;s:9:\"use pager\";b:1;s:8:\"use more\";b:1;s:18:\"accept attachments\";b:1;s:10:\"help topic\";s:15:\"display-default\";s:6:\"module\";s:5:\"views\";s:10:\"theme path\";s:29:\"sites/all/modules/views/theme\";s:10:\"theme file\";s:9:\"theme.inc\";s:4:\"path\";s:31:\"sites/all/modules/views/plugins\";s:4:\"file\";s:32:\"views_plugin_display_default.inc\";s:6:\"parent\";s:6:\"parent\";s:4:\"name\";s:7:\"default\";s:16:\"contextual links\";a:1:{s:8:\"views_ui\";a:2:{s:11:\"parent path\";s:26:\"admin/structure/views/view\";s:19:\"argument properties\";a:1:{i:0;s:4:\"name\";}}}}s:9:\"is_plugin\";b:1;}s:15:\"display_options\";a:16:{s:14:\"items_per_page\";N;s:6:\"offset\";N;s:9:\"use_pager\";s:1:\"1\";s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"some\";s:7:\"options\";a:2:{s:6:\"offset\";i:0;s:14:\"items_per_page\";i:10;}}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:6:\"fields\";a:3:{s:4:\"name\";a:7:{s:5:\"label\";s:6:\"Author\";s:12:\"link_to_user\";i:1;s:7:\"exclude\";i:0;s:2:\"id\";s:4:\"name\";s:5:\"table\";s:5:\"users\";s:5:\"field\";s:4:\"name\";s:12:\"relationship\";s:4:\"none\";}s:5:\"title\";a:7:{s:5:\"label\";s:5:\"Title\";s:12:\"link_to_node\";i:1;s:7:\"exclude\";i:0;s:2:\"id\";s:5:\"title\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:5:\"title\";s:12:\"relationship\";s:4:\"none\";}s:7:\"created\";a:8:{s:5:\"label\";s:6:\"Posted\";s:11:\"date_format\";s:8:\"time ago\";s:18:\"custom_date_format\";s:1:\"1\";s:7:\"exclude\";i:0;s:2:\"id\";s:7:\"created\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:7:\"created\";s:12:\"relationship\";s:4:\"none\";}}s:8:\"defaults\";a:10:{s:6:\"fields\";b:0;s:7:\"filters\";b:0;s:13:\"filter_groups\";b:0;s:6:\"access\";b:0;s:14:\"access_options\";b:0;s:5:\"title\";b:0;s:12:\"style_plugin\";b:0;s:13:\"style_options\";b:0;s:10:\"row_plugin\";b:0;s:11:\"row_options\";b:0;}s:7:\"filters\";a:1:{s:6:\"status\";a:9:{s:8:\"operator\";s:1:\"=\";s:5:\"value\";i:1;s:5:\"group\";s:1:\"0\";s:7:\"exposed\";b:0;s:6:\"expose\";a:2:{s:8:\"operator\";b:0;s:5:\"label\";s:0:\"\";}s:2:\"id\";s:6:\"status\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:6:\"status\";s:12:\"relationship\";s:4:\"none\";}}s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}s:6:\"access\";a:1:{s:4:\"type\";s:4:\"none\";}s:14:\"access_options\";N;s:5:\"title\";s:17:\"Top rated content\";s:12:\"style_plugin\";s:5:\"table\";s:13:\"style_options\";a:7:{s:8:\"grouping\";s:0:\"\";s:8:\"override\";i:1;s:6:\"sticky\";i:1;s:5:\"order\";s:4:\"desc\";s:7:\"columns\";a:3:{s:4:\"name\";s:4:\"name\";s:5:\"title\";s:5:\"title\";s:7:\"created\";s:7:\"created\";}s:4:\"info\";a:3:{s:4:\"name\";a:2:{s:8:\"sortable\";i:1;s:9:\"separator\";s:0:\"\";}s:5:\"title\";a:2:{s:8:\"sortable\";i:1;s:9:\"separator\";s:0:\"\";}s:7:\"created\";a:2:{s:8:\"sortable\";i:1;s:9:\"separator\";s:0:\"\";}}s:7:\"default\";s:5:\"title\";}s:10:\"row_plugin\";s:6:\"fields\";s:11:\"row_options\";a:0:{}}s:8:\"db_table\";s:13:\"views_display\";s:3:\"vid\";i:0;s:2:\"id\";s:7:\"default\";s:13:\"display_title\";s:8:\"Defaults\";s:14:\"display_plugin\";s:7:\"default\";s:8:\"position\";i:0;}s:6:\"page_1\";O:13:\"views_display\":8:{s:7:\"handler\";O:25:\"views_plugin_display_page\":10:{s:4:\"view\";r:1;s:8:\"handlers\";a:0:{}s:8:\"extender\";a:0:{}s:7:\"display\";R:294;s:11:\"plugin_type\";s:7:\"display\";s:11:\"plugin_name\";s:4:\"page\";s:7:\"options\";a:44:{s:8:\"defaults\";a:32:{s:6:\"access\";b:1;s:5:\"cache\";b:1;s:5:\"query\";b:1;s:5:\"title\";b:1;s:9:\"css_class\";b:1;s:19:\"display_description\";b:0;s:8:\"use_ajax\";b:1;s:23:\"hide_attachment_summary\";b:1;s:16:\"hide_admin_links\";b:1;s:5:\"pager\";b:1;s:13:\"pager_options\";b:1;s:8:\"use_more\";b:1;s:15:\"use_more_always\";b:1;s:13:\"use_more_text\";b:1;s:12:\"exposed_form\";b:1;s:20:\"exposed_form_options\";b:1;s:12:\"link_display\";b:1;s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:1;s:12:\"style_plugin\";b:0;s:13:\"style_options\";b:0;s:10:\"row_plugin\";b:0;s:11:\"row_options\";b:0;s:6:\"header\";b:0;s:6:\"footer\";b:1;s:5:\"empty\";b:1;s:13:\"relationships\";b:0;s:6:\"fields\";b:0;s:5:\"sorts\";b:0;s:9:\"arguments\";b:1;s:7:\"filters\";b:1;s:13:\"filter_groups\";b:1;}s:5:\"title\";s:0:\"\";s:7:\"enabled\";b:1;s:15:\"display_comment\";s:0:\"\";s:9:\"css_class\";s:0:\"\";s:19:\"display_description\";s:0:\"\";s:8:\"use_ajax\";b:0;s:23:\"hide_attachment_summary\";b:0;s:16:\"hide_admin_links\";b:0;s:14:\"items_per_page\";N;s:6:\"offset\";N;s:9:\"use_pager\";N;s:8:\"use_more\";b:0;s:15:\"use_more_always\";b:0;s:13:\"use_more_text\";s:4:\"more\";s:12:\"link_display\";s:0:\"\";s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:0;s:14:\"field_language\";s:22:\"***CURRENT_LANGUAGE***\";s:27:\"field_language_add_to_query\";i:1;s:6:\"access\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"cache\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:0:{}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"some\";s:7:\"options\";a:2:{s:6:\"offset\";i:0;s:14:\"items_per_page\";i:10;}}s:12:\"style_plugin\";s:5:\"table\";s:13:\"style_options\";a:7:{s:8:\"grouping\";s:0:\"\";s:8:\"override\";i:1;s:6:\"sticky\";i:1;s:5:\"order\";s:4:\"desc\";s:7:\"columns\";a:4:{s:4:\"name\";s:4:\"name\";s:5:\"title\";s:5:\"title\";s:7:\"created\";s:7:\"created\";s:5:\"value\";s:5:\"value\";}s:4:\"info\";a:4:{s:4:\"name\";a:2:{s:8:\"sortable\";i:1;s:9:\"separator\";s:0:\"\";}s:5:\"title\";a:2:{s:8:\"sortable\";i:1;s:9:\"separator\";s:0:\"\";}s:7:\"created\";a:2:{s:8:\"sortable\";i:1;s:9:\"separator\";s:0:\"\";}s:5:\"value\";a:2:{s:8:\"sortable\";i:1;s:9:\"separator\";s:0:\"\";}}s:7:\"default\";s:5:\"value\";}s:10:\"row_plugin\";s:6:\"fields\";s:11:\"row_options\";a:0:{}s:13:\"exposed_block\";b:0;s:6:\"header\";s:172:\"This page is a demonstration of VotingAPI\'s integration with the Views module. It\'s set up to display nodes sorted by percentage ratings, the style used by Fivestar module.\";s:6:\"footer\";a:0:{}s:5:\"empty\";a:0:{}s:13:\"relationships\";a:1:{s:15:\"votingapi_cache\";a:8:{s:5:\"label\";s:14:\"Voting results\";s:8:\"required\";i:0;s:9:\"votingapi\";a:3:{s:10:\"value_type\";s:7:\"percent\";s:3:\"tag\";s:4:\"vote\";s:8:\"function\";s:7:\"average\";}s:2:\"id\";s:15:\"votingapi_cache\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:15:\"votingapi_cache\";s:8:\"override\";a:1:{s:6:\"button\";s:11:\"Use default\";}s:12:\"relationship\";s:4:\"none\";}}s:6:\"fields\";a:4:{s:4:\"name\";a:7:{s:5:\"label\";s:6:\"Author\";s:12:\"link_to_user\";i:1;s:7:\"exclude\";i:0;s:2:\"id\";s:4:\"name\";s:5:\"table\";s:5:\"users\";s:5:\"field\";s:4:\"name\";s:12:\"relationship\";s:4:\"none\";}s:5:\"title\";a:7:{s:5:\"label\";s:5:\"Title\";s:12:\"link_to_node\";i:1;s:7:\"exclude\";i:0;s:2:\"id\";s:5:\"title\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:5:\"title\";s:12:\"relationship\";s:4:\"none\";}s:7:\"created\";a:8:{s:5:\"label\";s:6:\"Posted\";s:11:\"date_format\";s:8:\"time ago\";s:18:\"custom_date_format\";s:1:\"1\";s:7:\"exclude\";i:0;s:2:\"id\";s:7:\"created\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:7:\"created\";s:12:\"relationship\";s:4:\"none\";}s:5:\"value\";a:14:{s:5:\"label\";s:6:\"Rating\";s:13:\"set_precision\";b:0;s:9:\"precision\";i:0;s:7:\"decimal\";s:1:\".\";s:9:\"separator\";s:1:\",\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:10:\"appearance\";s:36:\"fivestar_views_value_display_handler\";s:7:\"exclude\";i:0;s:2:\"id\";s:5:\"value\";s:5:\"table\";s:15:\"votingapi_cache\";s:5:\"field\";s:5:\"value\";s:8:\"override\";a:1:{s:6:\"button\";s:11:\"Use default\";}s:12:\"relationship\";s:15:\"votingapi_cache\";}}s:5:\"sorts\";a:1:{s:5:\"value\";a:6:{s:5:\"order\";s:4:\"DESC\";s:2:\"id\";s:5:\"value\";s:5:\"table\";s:15:\"votingapi_cache\";s:5:\"field\";s:5:\"value\";s:12:\"relationship\";s:15:\"votingapi_cache\";s:8:\"override\";a:1:{s:6:\"button\";s:11:\"Use default\";}}}s:9:\"arguments\";a:0:{}s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}s:7:\"filters\";a:0:{}s:4:\"path\";s:17:\"top-rated-percent\";s:4:\"menu\";a:4:{s:4:\"type\";s:6:\"normal\";s:5:\"title\";s:22:\"Top content (Fivestar)\";s:6:\"weight\";s:1:\"0\";s:4:\"name\";s:10:\"navigation\";}s:11:\"tab_options\";a:3:{s:4:\"type\";s:4:\"none\";s:5:\"title\";s:0:\"\";s:6:\"weight\";i:0;}s:13:\"header_format\";s:1:\"1\";s:12:\"header_empty\";i:0;}s:10:\"definition\";a:20:{s:5:\"title\";s:4:\"Page\";s:4:\"help\";s:54:\"Display the view as a page, with a URL and menu links.\";s:7:\"handler\";s:25:\"views_plugin_display_page\";s:5:\"theme\";s:10:\"views_view\";s:14:\"uses hook menu\";b:1;s:26:\"contextual links locations\";a:1:{i:0;s:4:\"page\";}s:8:\"use ajax\";b:1;s:9:\"use pager\";b:1;s:8:\"use more\";b:1;s:18:\"accept attachments\";b:1;s:5:\"admin\";s:4:\"Page\";s:10:\"help topic\";s:12:\"display-page\";s:6:\"module\";s:5:\"views\";s:10:\"theme path\";s:29:\"sites/all/modules/views/theme\";s:10:\"theme file\";s:9:\"theme.inc\";s:4:\"path\";s:31:\"sites/all/modules/views/plugins\";s:4:\"file\";s:29:\"views_plugin_display_page.inc\";s:6:\"parent\";s:6:\"parent\";s:4:\"name\";s:4:\"page\";s:16:\"contextual links\";a:1:{s:8:\"views_ui\";a:2:{s:11:\"parent path\";s:26:\"admin/structure/views/view\";s:19:\"argument properties\";a:1:{i:0;s:4:\"name\";}}}}s:9:\"is_plugin\";b:1;s:15:\"default_display\";R:37;}s:15:\"display_options\";a:19:{s:14:\"items_per_page\";N;s:6:\"offset\";N;s:9:\"use_pager\";N;s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"some\";s:7:\"options\";a:2:{s:6:\"offset\";i:0;s:14:\"items_per_page\";i:10;}}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:13:\"relationships\";a:1:{s:15:\"votingapi_cache\";a:8:{s:5:\"label\";s:14:\"Voting results\";s:8:\"required\";i:0;s:9:\"votingapi\";a:3:{s:10:\"value_type\";s:7:\"percent\";s:3:\"tag\";s:4:\"vote\";s:8:\"function\";s:7:\"average\";}s:2:\"id\";s:15:\"votingapi_cache\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:15:\"votingapi_cache\";s:8:\"override\";a:1:{s:6:\"button\";s:11:\"Use default\";}s:12:\"relationship\";s:4:\"none\";}}s:8:\"defaults\";a:8:{s:13:\"relationships\";b:0;s:6:\"fields\";b:0;s:5:\"sorts\";b:0;s:6:\"header\";b:0;s:12:\"style_plugin\";b:0;s:13:\"style_options\";b:0;s:10:\"row_plugin\";b:0;s:11:\"row_options\";b:0;}s:6:\"fields\";a:4:{s:4:\"name\";a:7:{s:5:\"label\";s:6:\"Author\";s:12:\"link_to_user\";i:1;s:7:\"exclude\";i:0;s:2:\"id\";s:4:\"name\";s:5:\"table\";s:5:\"users\";s:5:\"field\";s:4:\"name\";s:12:\"relationship\";s:4:\"none\";}s:5:\"title\";a:7:{s:5:\"label\";s:5:\"Title\";s:12:\"link_to_node\";i:1;s:7:\"exclude\";i:0;s:2:\"id\";s:5:\"title\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:5:\"title\";s:12:\"relationship\";s:4:\"none\";}s:7:\"created\";a:8:{s:5:\"label\";s:6:\"Posted\";s:11:\"date_format\";s:8:\"time ago\";s:18:\"custom_date_format\";s:1:\"1\";s:7:\"exclude\";i:0;s:2:\"id\";s:7:\"created\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:7:\"created\";s:12:\"relationship\";s:4:\"none\";}s:5:\"value\";a:14:{s:5:\"label\";s:6:\"Rating\";s:13:\"set_precision\";b:0;s:9:\"precision\";i:0;s:7:\"decimal\";s:1:\".\";s:9:\"separator\";s:1:\",\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:10:\"appearance\";s:36:\"fivestar_views_value_display_handler\";s:7:\"exclude\";i:0;s:2:\"id\";s:5:\"value\";s:5:\"table\";s:15:\"votingapi_cache\";s:5:\"field\";s:5:\"value\";s:8:\"override\";a:1:{s:6:\"button\";s:11:\"Use default\";}s:12:\"relationship\";s:15:\"votingapi_cache\";}}s:5:\"sorts\";a:1:{s:5:\"value\";a:6:{s:5:\"order\";s:4:\"DESC\";s:2:\"id\";s:5:\"value\";s:5:\"table\";s:15:\"votingapi_cache\";s:5:\"field\";s:5:\"value\";s:12:\"relationship\";s:15:\"votingapi_cache\";s:8:\"override\";a:1:{s:6:\"button\";s:11:\"Use default\";}}}s:6:\"header\";s:172:\"This page is a demonstration of VotingAPI\'s integration with the Views module. It\'s set up to display nodes sorted by percentage ratings, the style used by Fivestar module.\";s:13:\"header_format\";s:1:\"1\";s:12:\"header_empty\";i:0;s:12:\"style_plugin\";s:5:\"table\";s:13:\"style_options\";a:7:{s:8:\"grouping\";s:0:\"\";s:8:\"override\";i:1;s:6:\"sticky\";i:1;s:5:\"order\";s:4:\"desc\";s:7:\"columns\";a:4:{s:4:\"name\";s:4:\"name\";s:5:\"title\";s:5:\"title\";s:7:\"created\";s:7:\"created\";s:5:\"value\";s:5:\"value\";}s:4:\"info\";a:4:{s:4:\"name\";a:2:{s:8:\"sortable\";i:1;s:9:\"separator\";s:0:\"\";}s:5:\"title\";a:2:{s:8:\"sortable\";i:1;s:9:\"separator\";s:0:\"\";}s:7:\"created\";a:2:{s:8:\"sortable\";i:1;s:9:\"separator\";s:0:\"\";}s:5:\"value\";a:2:{s:8:\"sortable\";i:1;s:9:\"separator\";s:0:\"\";}}s:7:\"default\";s:5:\"value\";}s:10:\"row_plugin\";s:6:\"fields\";s:11:\"row_options\";a:0:{}s:4:\"path\";s:17:\"top-rated-percent\";s:4:\"menu\";a:4:{s:4:\"type\";s:6:\"normal\";s:5:\"title\";s:22:\"Top content (Fivestar)\";s:6:\"weight\";s:1:\"0\";s:4:\"name\";s:10:\"navigation\";}s:11:\"tab_options\";a:3:{s:4:\"type\";s:4:\"none\";s:5:\"title\";s:0:\"\";s:6:\"weight\";i:0;}}s:8:\"db_table\";s:13:\"views_display\";s:3:\"vid\";i:0;s:2:\"id\";s:6:\"page_1\";s:13:\"display_title\";s:8:\"Fivestar\";s:14:\"display_plugin\";s:4:\"page\";s:8:\"position\";i:0;}s:6:\"page_2\";O:13:\"views_display\":8:{s:7:\"handler\";O:25:\"views_plugin_display_page\":10:{s:4:\"view\";r:1;s:8:\"handlers\";a:0:{}s:8:\"extender\";a:0:{}s:7:\"display\";R:642;s:11:\"plugin_type\";s:7:\"display\";s:11:\"plugin_name\";s:4:\"page\";s:7:\"options\";a:44:{s:8:\"defaults\";a:32:{s:6:\"access\";b:1;s:5:\"cache\";b:1;s:5:\"query\";b:1;s:5:\"title\";b:1;s:9:\"css_class\";b:1;s:19:\"display_description\";b:0;s:8:\"use_ajax\";b:1;s:23:\"hide_attachment_summary\";b:1;s:16:\"hide_admin_links\";b:1;s:5:\"pager\";b:1;s:13:\"pager_options\";b:1;s:8:\"use_more\";b:1;s:15:\"use_more_always\";b:1;s:13:\"use_more_text\";b:1;s:12:\"exposed_form\";b:1;s:20:\"exposed_form_options\";b:1;s:12:\"link_display\";b:1;s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:1;s:12:\"style_plugin\";b:0;s:13:\"style_options\";b:0;s:10:\"row_plugin\";b:0;s:11:\"row_options\";b:0;s:6:\"header\";b:0;s:6:\"footer\";b:1;s:5:\"empty\";b:1;s:13:\"relationships\";b:0;s:6:\"fields\";b:0;s:5:\"sorts\";b:0;s:9:\"arguments\";b:1;s:7:\"filters\";b:1;s:13:\"filter_groups\";b:1;}s:5:\"title\";s:0:\"\";s:7:\"enabled\";b:1;s:15:\"display_comment\";s:0:\"\";s:9:\"css_class\";s:0:\"\";s:19:\"display_description\";s:0:\"\";s:8:\"use_ajax\";b:0;s:23:\"hide_attachment_summary\";b:0;s:16:\"hide_admin_links\";b:0;s:14:\"items_per_page\";N;s:6:\"offset\";N;s:9:\"use_pager\";N;s:8:\"use_more\";b:0;s:15:\"use_more_always\";b:0;s:13:\"use_more_text\";s:4:\"more\";s:12:\"link_display\";s:0:\"\";s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:0;s:14:\"field_language\";s:22:\"***CURRENT_LANGUAGE***\";s:27:\"field_language_add_to_query\";i:1;s:6:\"access\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"cache\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:0:{}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"some\";s:7:\"options\";a:2:{s:6:\"offset\";i:0;s:14:\"items_per_page\";i:10;}}s:12:\"style_plugin\";s:5:\"table\";s:13:\"style_options\";a:7:{s:8:\"grouping\";s:0:\"\";s:8:\"override\";i:1;s:6:\"sticky\";i:1;s:5:\"order\";s:4:\"desc\";s:7:\"columns\";a:4:{s:4:\"name\";s:4:\"name\";s:5:\"title\";s:5:\"title\";s:7:\"created\";s:7:\"created\";s:5:\"value\";s:5:\"value\";}s:4:\"info\";a:4:{s:4:\"name\";a:2:{s:8:\"sortable\";i:1;s:9:\"separator\";s:0:\"\";}s:5:\"title\";a:2:{s:8:\"sortable\";i:1;s:9:\"separator\";s:0:\"\";}s:7:\"created\";a:2:{s:8:\"sortable\";i:1;s:9:\"separator\";s:0:\"\";}s:5:\"value\";a:2:{s:8:\"sortable\";i:1;s:9:\"separator\";s:0:\"\";}}s:7:\"default\";s:5:\"value\";}s:10:\"row_plugin\";s:6:\"fields\";s:11:\"row_options\";a:0:{}s:13:\"exposed_block\";b:0;s:6:\"header\";s:184:\"This page is a demonstration of VotingAPI\'s integration with the Views module. It\'s set up to display nodes sorted by point ratings, the style used by the Plus1 and VoteUpDown modules.\";s:6:\"footer\";a:0:{}s:5:\"empty\";a:0:{}s:13:\"relationships\";a:1:{s:15:\"votingapi_cache\";a:8:{s:5:\"label\";s:14:\"Voting results\";s:8:\"required\";i:0;s:9:\"votingapi\";a:3:{s:10:\"value_type\";s:6:\"points\";s:3:\"tag\";s:4:\"vote\";s:8:\"function\";s:3:\"sum\";}s:2:\"id\";s:15:\"votingapi_cache\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:15:\"votingapi_cache\";s:8:\"override\";a:1:{s:6:\"button\";s:11:\"Use default\";}s:12:\"relationship\";s:4:\"none\";}}s:6:\"fields\";a:4:{s:4:\"name\";a:7:{s:5:\"label\";s:6:\"Author\";s:12:\"link_to_user\";i:1;s:7:\"exclude\";i:0;s:2:\"id\";s:4:\"name\";s:5:\"table\";s:5:\"users\";s:5:\"field\";s:4:\"name\";s:12:\"relationship\";s:4:\"none\";}s:5:\"title\";a:7:{s:5:\"label\";s:5:\"Title\";s:12:\"link_to_node\";i:1;s:7:\"exclude\";i:0;s:2:\"id\";s:5:\"title\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:5:\"title\";s:12:\"relationship\";s:4:\"none\";}s:7:\"created\";a:8:{s:5:\"label\";s:6:\"Posted\";s:11:\"date_format\";s:8:\"time ago\";s:18:\"custom_date_format\";s:1:\"1\";s:7:\"exclude\";i:0;s:2:\"id\";s:7:\"created\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:7:\"created\";s:12:\"relationship\";s:4:\"none\";}s:5:\"value\";a:14:{s:5:\"label\";s:6:\"Rating\";s:13:\"set_precision\";b:0;s:9:\"precision\";i:0;s:7:\"decimal\";s:1:\".\";s:9:\"separator\";s:1:\",\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:7:\" points\";s:10:\"appearance\";s:0:\"\";s:7:\"exclude\";i:0;s:2:\"id\";s:5:\"value\";s:5:\"table\";s:15:\"votingapi_cache\";s:5:\"field\";s:5:\"value\";s:8:\"override\";a:1:{s:6:\"button\";s:11:\"Use default\";}s:12:\"relationship\";s:15:\"votingapi_cache\";}}s:5:\"sorts\";a:1:{s:5:\"value\";a:6:{s:5:\"order\";s:4:\"DESC\";s:2:\"id\";s:5:\"value\";s:5:\"table\";s:15:\"votingapi_cache\";s:5:\"field\";s:5:\"value\";s:8:\"override\";a:1:{s:6:\"button\";s:11:\"Use default\";}s:12:\"relationship\";s:15:\"votingapi_cache\";}}s:9:\"arguments\";a:0:{}s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}s:7:\"filters\";a:0:{}s:4:\"path\";s:16:\"top-rated-points\";s:4:\"menu\";a:4:{s:4:\"type\";s:6:\"normal\";s:5:\"title\";s:19:\"Top content (Plus1)\";s:6:\"weight\";s:1:\"0\";s:4:\"name\";s:10:\"navigation\";}s:11:\"tab_options\";a:3:{s:4:\"type\";s:4:\"none\";s:5:\"title\";s:0:\"\";s:6:\"weight\";i:0;}s:13:\"header_format\";s:1:\"1\";s:12:\"header_empty\";i:0;}s:10:\"definition\";a:20:{s:5:\"title\";s:4:\"Page\";s:4:\"help\";s:54:\"Display the view as a page, with a URL and menu links.\";s:7:\"handler\";s:25:\"views_plugin_display_page\";s:5:\"theme\";s:10:\"views_view\";s:14:\"uses hook menu\";b:1;s:26:\"contextual links locations\";a:1:{i:0;s:4:\"page\";}s:8:\"use ajax\";b:1;s:9:\"use pager\";b:1;s:8:\"use more\";b:1;s:18:\"accept attachments\";b:1;s:5:\"admin\";s:4:\"Page\";s:10:\"help topic\";s:12:\"display-page\";s:6:\"module\";s:5:\"views\";s:10:\"theme path\";s:29:\"sites/all/modules/views/theme\";s:10:\"theme file\";s:9:\"theme.inc\";s:4:\"path\";s:31:\"sites/all/modules/views/plugins\";s:4:\"file\";s:29:\"views_plugin_display_page.inc\";s:6:\"parent\";s:6:\"parent\";s:4:\"name\";s:4:\"page\";s:16:\"contextual links\";a:1:{s:8:\"views_ui\";a:2:{s:11:\"parent path\";s:26:\"admin/structure/views/view\";s:19:\"argument properties\";a:1:{i:0;s:4:\"name\";}}}}s:9:\"is_plugin\";b:1;s:15:\"default_display\";R:37;}s:15:\"display_options\";a:19:{s:14:\"items_per_page\";N;s:6:\"offset\";N;s:9:\"use_pager\";N;s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"some\";s:7:\"options\";a:2:{s:6:\"offset\";i:0;s:14:\"items_per_page\";i:10;}}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:13:\"relationships\";a:1:{s:15:\"votingapi_cache\";a:8:{s:5:\"label\";s:14:\"Voting results\";s:8:\"required\";i:0;s:9:\"votingapi\";a:3:{s:10:\"value_type\";s:6:\"points\";s:3:\"tag\";s:4:\"vote\";s:8:\"function\";s:3:\"sum\";}s:2:\"id\";s:15:\"votingapi_cache\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:15:\"votingapi_cache\";s:8:\"override\";a:1:{s:6:\"button\";s:11:\"Use default\";}s:12:\"relationship\";s:4:\"none\";}}s:8:\"defaults\";a:8:{s:13:\"relationships\";b:0;s:6:\"fields\";b:0;s:5:\"sorts\";b:0;s:6:\"header\";b:0;s:12:\"style_plugin\";b:0;s:13:\"style_options\";b:0;s:10:\"row_plugin\";b:0;s:11:\"row_options\";b:0;}s:6:\"fields\";a:4:{s:4:\"name\";a:7:{s:5:\"label\";s:6:\"Author\";s:12:\"link_to_user\";i:1;s:7:\"exclude\";i:0;s:2:\"id\";s:4:\"name\";s:5:\"table\";s:5:\"users\";s:5:\"field\";s:4:\"name\";s:12:\"relationship\";s:4:\"none\";}s:5:\"title\";a:7:{s:5:\"label\";s:5:\"Title\";s:12:\"link_to_node\";i:1;s:7:\"exclude\";i:0;s:2:\"id\";s:5:\"title\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:5:\"title\";s:12:\"relationship\";s:4:\"none\";}s:7:\"created\";a:8:{s:5:\"label\";s:6:\"Posted\";s:11:\"date_format\";s:8:\"time ago\";s:18:\"custom_date_format\";s:1:\"1\";s:7:\"exclude\";i:0;s:2:\"id\";s:7:\"created\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:7:\"created\";s:12:\"relationship\";s:4:\"none\";}s:5:\"value\";a:14:{s:5:\"label\";s:6:\"Rating\";s:13:\"set_precision\";b:0;s:9:\"precision\";i:0;s:7:\"decimal\";s:1:\".\";s:9:\"separator\";s:1:\",\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:7:\" points\";s:10:\"appearance\";s:0:\"\";s:7:\"exclude\";i:0;s:2:\"id\";s:5:\"value\";s:5:\"table\";s:15:\"votingapi_cache\";s:5:\"field\";s:5:\"value\";s:8:\"override\";a:1:{s:6:\"button\";s:11:\"Use default\";}s:12:\"relationship\";s:15:\"votingapi_cache\";}}s:5:\"sorts\";a:1:{s:5:\"value\";a:6:{s:5:\"order\";s:4:\"DESC\";s:2:\"id\";s:5:\"value\";s:5:\"table\";s:15:\"votingapi_cache\";s:5:\"field\";s:5:\"value\";s:8:\"override\";a:1:{s:6:\"button\";s:11:\"Use default\";}s:12:\"relationship\";s:15:\"votingapi_cache\";}}s:6:\"header\";s:184:\"This page is a demonstration of VotingAPI\'s integration with the Views module. It\'s set up to display nodes sorted by point ratings, the style used by the Plus1 and VoteUpDown modules.\";s:13:\"header_format\";s:1:\"1\";s:12:\"header_empty\";i:0;s:12:\"style_plugin\";s:5:\"table\";s:13:\"style_options\";a:7:{s:8:\"grouping\";s:0:\"\";s:8:\"override\";i:1;s:6:\"sticky\";i:1;s:5:\"order\";s:4:\"desc\";s:7:\"columns\";a:4:{s:4:\"name\";s:4:\"name\";s:5:\"title\";s:5:\"title\";s:7:\"created\";s:7:\"created\";s:5:\"value\";s:5:\"value\";}s:4:\"info\";a:4:{s:4:\"name\";a:2:{s:8:\"sortable\";i:1;s:9:\"separator\";s:0:\"\";}s:5:\"title\";a:2:{s:8:\"sortable\";i:1;s:9:\"separator\";s:0:\"\";}s:7:\"created\";a:2:{s:8:\"sortable\";i:1;s:9:\"separator\";s:0:\"\";}s:5:\"value\";a:2:{s:8:\"sortable\";i:1;s:9:\"separator\";s:0:\"\";}}s:7:\"default\";s:5:\"value\";}s:10:\"row_plugin\";s:6:\"fields\";s:11:\"row_options\";a:0:{}s:4:\"path\";s:16:\"top-rated-points\";s:4:\"menu\";a:4:{s:4:\"type\";s:6:\"normal\";s:5:\"title\";s:19:\"Top content (Plus1)\";s:6:\"weight\";s:1:\"0\";s:4:\"name\";s:10:\"navigation\";}s:11:\"tab_options\";a:3:{s:4:\"type\";s:4:\"none\";s:5:\"title\";s:0:\"\";s:6:\"weight\";i:0;}}s:8:\"db_table\";s:13:\"views_display\";s:3:\"vid\";i:0;s:2:\"id\";s:6:\"page_2\";s:13:\"display_title\";s:5:\"Plus1\";s:14:\"display_plugin\";s:4:\"page\";s:8:\"position\";i:0;}s:6:\"page_3\";O:13:\"views_display\":8:{s:7:\"handler\";O:25:\"views_plugin_display_page\":10:{s:4:\"view\";r:1;s:8:\"handlers\";a:0:{}s:8:\"extender\";a:0:{}s:7:\"display\";R:990;s:11:\"plugin_type\";s:7:\"display\";s:11:\"plugin_name\";s:4:\"page\";s:7:\"options\";a:42:{s:8:\"defaults\";a:32:{s:6:\"access\";b:1;s:5:\"cache\";b:1;s:5:\"query\";b:1;s:5:\"title\";b:0;s:9:\"css_class\";b:1;s:19:\"display_description\";b:0;s:8:\"use_ajax\";b:1;s:23:\"hide_attachment_summary\";b:1;s:16:\"hide_admin_links\";b:1;s:5:\"pager\";b:1;s:13:\"pager_options\";b:1;s:8:\"use_more\";b:1;s:15:\"use_more_always\";b:1;s:13:\"use_more_text\";b:1;s:12:\"exposed_form\";b:1;s:20:\"exposed_form_options\";b:1;s:12:\"link_display\";b:1;s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:1;s:12:\"style_plugin\";b:0;s:13:\"style_options\";b:0;s:10:\"row_plugin\";b:0;s:11:\"row_options\";b:0;s:6:\"header\";b:1;s:6:\"footer\";b:1;s:5:\"empty\";b:1;s:13:\"relationships\";b:0;s:6:\"fields\";b:0;s:5:\"sorts\";b:0;s:9:\"arguments\";b:0;s:7:\"filters\";b:0;s:13:\"filter_groups\";b:0;}s:5:\"title\";s:10:\"Your votes\";s:7:\"enabled\";b:1;s:15:\"display_comment\";s:0:\"\";s:9:\"css_class\";s:0:\"\";s:19:\"display_description\";s:0:\"\";s:8:\"use_ajax\";b:0;s:23:\"hide_attachment_summary\";b:0;s:16:\"hide_admin_links\";b:0;s:14:\"items_per_page\";N;s:6:\"offset\";N;s:9:\"use_pager\";N;s:8:\"use_more\";b:0;s:15:\"use_more_always\";b:0;s:13:\"use_more_text\";s:4:\"more\";s:12:\"link_display\";s:0:\"\";s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:0;s:14:\"field_language\";s:22:\"***CURRENT_LANGUAGE***\";s:27:\"field_language_add_to_query\";i:1;s:6:\"access\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"cache\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:0:{}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"some\";s:7:\"options\";a:2:{s:6:\"offset\";i:0;s:14:\"items_per_page\";i:10;}}s:12:\"style_plugin\";s:5:\"table\";s:13:\"style_options\";a:7:{s:8:\"grouping\";s:0:\"\";s:8:\"override\";i:1;s:6:\"sticky\";i:1;s:5:\"order\";s:4:\"desc\";s:7:\"columns\";a:4:{s:5:\"title\";s:5:\"title\";s:10:\"value_type\";s:10:\"value_type\";s:5:\"value\";s:5:\"value\";s:9:\"timestamp\";s:9:\"timestamp\";}s:4:\"info\";a:4:{s:5:\"title\";a:2:{s:8:\"sortable\";i:1;s:9:\"separator\";s:0:\"\";}s:10:\"value_type\";a:2:{s:8:\"sortable\";i:1;s:9:\"separator\";s:0:\"\";}s:5:\"value\";a:2:{s:8:\"sortable\";i:1;s:9:\"separator\";s:0:\"\";}s:9:\"timestamp\";a:2:{s:8:\"sortable\";i:1;s:9:\"separator\";s:0:\"\";}}s:7:\"default\";s:9:\"timestamp\";}s:10:\"row_plugin\";s:6:\"fields\";s:11:\"row_options\";a:0:{}s:13:\"exposed_block\";b:0;s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:0:{}s:13:\"relationships\";a:1:{s:14:\"votingapi_vote\";a:9:{s:5:\"label\";s:16:\"Individual votes\";s:8:\"required\";i:1;s:9:\"votingapi\";a:2:{s:10:\"value_type\";s:0:\"\";s:3:\"tag\";s:0:\"\";}s:12:\"current_user\";i:0;s:2:\"id\";s:14:\"votingapi_vote\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:14:\"votingapi_vote\";s:8:\"override\";a:1:{s:6:\"button\";s:11:\"Use default\";}s:12:\"relationship\";s:4:\"none\";}}s:6:\"fields\";a:4:{s:5:\"title\";a:7:{s:5:\"label\";s:5:\"Title\";s:12:\"link_to_node\";i:1;s:7:\"exclude\";i:0;s:2:\"id\";s:5:\"title\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:5:\"title\";s:12:\"relationship\";s:4:\"none\";}s:10:\"value_type\";a:7:{s:5:\"label\";s:9:\"Vote type\";s:7:\"exclude\";i:0;s:2:\"id\";s:10:\"value_type\";s:5:\"table\";s:14:\"votingapi_vote\";s:5:\"field\";s:10:\"value_type\";s:8:\"override\";a:1:{s:6:\"button\";s:8:\"Override\";}s:12:\"relationship\";s:14:\"votingapi_vote\";}s:5:\"value\";a:14:{s:5:\"label\";s:5:\"Value\";s:13:\"set_precision\";b:0;s:9:\"precision\";i:0;s:7:\"decimal\";s:1:\".\";s:9:\"separator\";s:1:\",\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:10:\"appearance\";s:0:\"\";s:7:\"exclude\";i:0;s:2:\"id\";s:5:\"value\";s:5:\"table\";s:14:\"votingapi_vote\";s:5:\"field\";s:5:\"value\";s:8:\"override\";a:1:{s:6:\"button\";s:8:\"Override\";}s:12:\"relationship\";s:14:\"votingapi_vote\";}s:9:\"timestamp\";a:9:{s:5:\"label\";s:9:\"Timestamp\";s:11:\"date_format\";s:8:\"time ago\";s:18:\"custom_date_format\";s:1:\"1\";s:7:\"exclude\";i:0;s:2:\"id\";s:9:\"timestamp\";s:5:\"table\";s:14:\"votingapi_vote\";s:5:\"field\";s:9:\"timestamp\";s:8:\"override\";a:1:{s:6:\"button\";s:11:\"Use default\";}s:12:\"relationship\";s:14:\"votingapi_vote\";}}s:5:\"sorts\";a:1:{s:9:\"timestamp\";a:6:{s:5:\"order\";s:4:\"DESC\";s:2:\"id\";s:9:\"timestamp\";s:5:\"table\";s:14:\"votingapi_vote\";s:5:\"field\";s:9:\"timestamp\";s:8:\"override\";a:1:{s:6:\"button\";s:11:\"Use default\";}s:12:\"relationship\";s:14:\"votingapi_vote\";}}s:9:\"arguments\";a:1:{s:3:\"uid\";a:27:{s:14:\"default_action\";s:7:\"default\";s:12:\"style_plugin\";s:15:\"default_summary\";s:13:\"style_options\";a:0:{}s:8:\"wildcard\";s:3:\"all\";s:21:\"wildcard_substitution\";s:8:\"Everyone\";s:5:\"title\";s:10:\"%1\'s votes\";s:21:\"default_argument_type\";s:12:\"current_user\";s:16:\"default_argument\";s:0:\"\";s:13:\"validate_type\";s:4:\"none\";s:13:\"validate_fail\";s:9:\"not found\";s:12:\"break_phrase\";i:0;s:3:\"not\";i:0;s:2:\"id\";s:3:\"uid\";s:5:\"table\";s:14:\"votingapi_vote\";s:5:\"field\";s:3:\"uid\";s:12:\"relationship\";s:14:\"votingapi_vote\";s:8:\"override\";a:1:{s:6:\"button\";s:11:\"Use default\";}s:26:\"default_options_div_prefix\";s:0:\"\";s:21:\"default_argument_user\";i:0;s:22:\"default_argument_fixed\";s:0:\"\";s:20:\"default_argument_php\";s:0:\"\";s:27:\"validate_argument_node_type\";a:2:{s:4:\"page\";i:0;s:5:\"story\";i:0;}s:29:\"validate_argument_node_access\";i:0;s:26:\"validate_argument_nid_type\";s:3:\"nid\";s:28:\"validate_argument_vocabulary\";a:0:{}s:22:\"validate_argument_type\";s:3:\"tid\";s:21:\"validate_argument_php\";s:0:\"\";}}s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}s:7:\"filters\";a:2:{s:6:\"status\";a:9:{s:8:\"operator\";s:1:\"=\";s:5:\"value\";i:1;s:5:\"group\";s:1:\"0\";s:7:\"exposed\";b:0;s:6:\"expose\";a:2:{s:8:\"operator\";b:0;s:5:\"label\";s:0:\"\";}s:2:\"id\";s:6:\"status\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:6:\"status\";s:12:\"relationship\";s:4:\"none\";}s:5:\"value\";a:10:{s:8:\"operator\";s:9:\"not empty\";s:5:\"value\";a:3:{s:5:\"value\";s:0:\"\";s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";}s:5:\"group\";s:1:\"0\";s:7:\"exposed\";b:0;s:6:\"expose\";a:2:{s:8:\"operator\";b:0;s:5:\"label\";s:0:\"\";}s:2:\"id\";s:5:\"value\";s:5:\"table\";s:14:\"votingapi_vote\";s:5:\"field\";s:5:\"value\";s:8:\"override\";a:1:{s:6:\"button\";s:11:\"Use default\";}s:12:\"relationship\";s:14:\"votingapi_vote\";}}s:4:\"path\";s:10:\"your-votes\";s:4:\"menu\";a:4:{s:4:\"type\";s:6:\"normal\";s:5:\"title\";s:10:\"Your votes\";s:6:\"weight\";s:1:\"0\";s:4:\"name\";s:10:\"navigation\";}s:11:\"tab_options\";a:3:{s:4:\"type\";s:4:\"none\";s:5:\"title\";s:0:\"\";s:6:\"weight\";i:0;}}s:10:\"definition\";a:20:{s:5:\"title\";s:4:\"Page\";s:4:\"help\";s:54:\"Display the view as a page, with a URL and menu links.\";s:7:\"handler\";s:25:\"views_plugin_display_page\";s:5:\"theme\";s:10:\"views_view\";s:14:\"uses hook menu\";b:1;s:26:\"contextual links locations\";a:1:{i:0;s:4:\"page\";}s:8:\"use ajax\";b:1;s:9:\"use pager\";b:1;s:8:\"use more\";b:1;s:18:\"accept attachments\";b:1;s:5:\"admin\";s:4:\"Page\";s:10:\"help topic\";s:12:\"display-page\";s:6:\"module\";s:5:\"views\";s:10:\"theme path\";s:29:\"sites/all/modules/views/theme\";s:10:\"theme file\";s:9:\"theme.inc\";s:4:\"path\";s:31:\"sites/all/modules/views/plugins\";s:4:\"file\";s:29:\"views_plugin_display_page.inc\";s:6:\"parent\";s:6:\"parent\";s:4:\"name\";s:4:\"page\";s:16:\"contextual links\";a:1:{s:8:\"views_ui\";a:2:{s:11:\"parent path\";s:26:\"admin/structure/views/view\";s:19:\"argument properties\";a:1:{i:0;s:4:\"name\";}}}}s:9:\"is_plugin\";b:1;s:15:\"default_display\";R:37;}s:15:\"display_options\";a:20:{s:14:\"items_per_page\";N;s:6:\"offset\";N;s:9:\"use_pager\";N;s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"some\";s:7:\"options\";a:2:{s:6:\"offset\";i:0;s:14:\"items_per_page\";i:10;}}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:13:\"relationships\";a:1:{s:14:\"votingapi_vote\";a:9:{s:5:\"label\";s:16:\"Individual votes\";s:8:\"required\";i:1;s:9:\"votingapi\";a:2:{s:10:\"value_type\";s:0:\"\";s:3:\"tag\";s:0:\"\";}s:12:\"current_user\";i:0;s:2:\"id\";s:14:\"votingapi_vote\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:14:\"votingapi_vote\";s:8:\"override\";a:1:{s:6:\"button\";s:11:\"Use default\";}s:12:\"relationship\";s:4:\"none\";}}s:8:\"defaults\";a:11:{s:13:\"relationships\";b:0;s:6:\"fields\";b:0;s:5:\"sorts\";b:0;s:9:\"arguments\";b:0;s:7:\"filters\";b:0;s:13:\"filter_groups\";b:0;s:5:\"title\";b:0;s:12:\"style_plugin\";b:0;s:13:\"style_options\";b:0;s:10:\"row_plugin\";b:0;s:11:\"row_options\";b:0;}s:6:\"fields\";a:4:{s:5:\"title\";a:7:{s:5:\"label\";s:5:\"Title\";s:12:\"link_to_node\";i:1;s:7:\"exclude\";i:0;s:2:\"id\";s:5:\"title\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:5:\"title\";s:12:\"relationship\";s:4:\"none\";}s:10:\"value_type\";a:7:{s:5:\"label\";s:9:\"Vote type\";s:7:\"exclude\";i:0;s:2:\"id\";s:10:\"value_type\";s:5:\"table\";s:14:\"votingapi_vote\";s:5:\"field\";s:10:\"value_type\";s:8:\"override\";a:1:{s:6:\"button\";s:8:\"Override\";}s:12:\"relationship\";s:14:\"votingapi_vote\";}s:5:\"value\";a:14:{s:5:\"label\";s:5:\"Value\";s:13:\"set_precision\";b:0;s:9:\"precision\";i:0;s:7:\"decimal\";s:1:\".\";s:9:\"separator\";s:1:\",\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:10:\"appearance\";s:0:\"\";s:7:\"exclude\";i:0;s:2:\"id\";s:5:\"value\";s:5:\"table\";s:14:\"votingapi_vote\";s:5:\"field\";s:5:\"value\";s:8:\"override\";a:1:{s:6:\"button\";s:8:\"Override\";}s:12:\"relationship\";s:14:\"votingapi_vote\";}s:9:\"timestamp\";a:9:{s:5:\"label\";s:9:\"Timestamp\";s:11:\"date_format\";s:8:\"time ago\";s:18:\"custom_date_format\";s:1:\"1\";s:7:\"exclude\";i:0;s:2:\"id\";s:9:\"timestamp\";s:5:\"table\";s:14:\"votingapi_vote\";s:5:\"field\";s:9:\"timestamp\";s:8:\"override\";a:1:{s:6:\"button\";s:11:\"Use default\";}s:12:\"relationship\";s:14:\"votingapi_vote\";}}s:5:\"sorts\";a:1:{s:9:\"timestamp\";a:6:{s:5:\"order\";s:4:\"DESC\";s:2:\"id\";s:9:\"timestamp\";s:5:\"table\";s:14:\"votingapi_vote\";s:5:\"field\";s:9:\"timestamp\";s:8:\"override\";a:1:{s:6:\"button\";s:11:\"Use default\";}s:12:\"relationship\";s:14:\"votingapi_vote\";}}s:9:\"arguments\";a:1:{s:3:\"uid\";a:27:{s:14:\"default_action\";s:7:\"default\";s:12:\"style_plugin\";s:15:\"default_summary\";s:13:\"style_options\";a:0:{}s:8:\"wildcard\";s:3:\"all\";s:21:\"wildcard_substitution\";s:8:\"Everyone\";s:5:\"title\";s:10:\"%1\'s votes\";s:21:\"default_argument_type\";s:12:\"current_user\";s:16:\"default_argument\";s:0:\"\";s:13:\"validate_type\";s:4:\"none\";s:13:\"validate_fail\";s:9:\"not found\";s:12:\"break_phrase\";i:0;s:3:\"not\";i:0;s:2:\"id\";s:3:\"uid\";s:5:\"table\";s:14:\"votingapi_vote\";s:5:\"field\";s:3:\"uid\";s:12:\"relationship\";s:14:\"votingapi_vote\";s:8:\"override\";a:1:{s:6:\"button\";s:11:\"Use default\";}s:26:\"default_options_div_prefix\";s:0:\"\";s:21:\"default_argument_user\";i:0;s:22:\"default_argument_fixed\";s:0:\"\";s:20:\"default_argument_php\";s:0:\"\";s:27:\"validate_argument_node_type\";a:2:{s:4:\"page\";i:0;s:5:\"story\";i:0;}s:29:\"validate_argument_node_access\";i:0;s:26:\"validate_argument_nid_type\";s:3:\"nid\";s:28:\"validate_argument_vocabulary\";a:0:{}s:22:\"validate_argument_type\";s:3:\"tid\";s:21:\"validate_argument_php\";s:0:\"\";}}s:7:\"filters\";a:2:{s:6:\"status\";a:9:{s:8:\"operator\";s:1:\"=\";s:5:\"value\";i:1;s:5:\"group\";s:1:\"0\";s:7:\"exposed\";b:0;s:6:\"expose\";a:2:{s:8:\"operator\";b:0;s:5:\"label\";s:0:\"\";}s:2:\"id\";s:6:\"status\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:6:\"status\";s:12:\"relationship\";s:4:\"none\";}s:5:\"value\";a:10:{s:8:\"operator\";s:9:\"not empty\";s:5:\"value\";a:3:{s:5:\"value\";s:0:\"\";s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";}s:5:\"group\";s:1:\"0\";s:7:\"exposed\";b:0;s:6:\"expose\";a:2:{s:8:\"operator\";b:0;s:5:\"label\";s:0:\"\";}s:2:\"id\";s:5:\"value\";s:5:\"table\";s:14:\"votingapi_vote\";s:5:\"field\";s:5:\"value\";s:8:\"override\";a:1:{s:6:\"button\";s:11:\"Use default\";}s:12:\"relationship\";s:14:\"votingapi_vote\";}}s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}s:5:\"title\";s:10:\"Your votes\";s:12:\"style_plugin\";s:5:\"table\";s:13:\"style_options\";a:7:{s:8:\"grouping\";s:0:\"\";s:8:\"override\";i:1;s:6:\"sticky\";i:1;s:5:\"order\";s:4:\"desc\";s:7:\"columns\";a:4:{s:5:\"title\";s:5:\"title\";s:10:\"value_type\";s:10:\"value_type\";s:5:\"value\";s:5:\"value\";s:9:\"timestamp\";s:9:\"timestamp\";}s:4:\"info\";a:4:{s:5:\"title\";a:2:{s:8:\"sortable\";i:1;s:9:\"separator\";s:0:\"\";}s:10:\"value_type\";a:2:{s:8:\"sortable\";i:1;s:9:\"separator\";s:0:\"\";}s:5:\"value\";a:2:{s:8:\"sortable\";i:1;s:9:\"separator\";s:0:\"\";}s:9:\"timestamp\";a:2:{s:8:\"sortable\";i:1;s:9:\"separator\";s:0:\"\";}}s:7:\"default\";s:9:\"timestamp\";}s:10:\"row_plugin\";s:6:\"fields\";s:11:\"row_options\";a:0:{}s:4:\"path\";s:10:\"your-votes\";s:4:\"menu\";a:4:{s:4:\"type\";s:6:\"normal\";s:5:\"title\";s:10:\"Your votes\";s:6:\"weight\";s:1:\"0\";s:4:\"name\";s:10:\"navigation\";}s:11:\"tab_options\";a:3:{s:4:\"type\";s:4:\"none\";s:5:\"title\";s:0:\"\";s:6:\"weight\";i:0;}}s:8:\"db_table\";s:13:\"views_display\";s:3:\"vid\";i:0;s:2:\"id\";s:6:\"page_3\";s:13:\"display_title\";s:12:\"Current user\";s:14:\"display_plugin\";s:4:\"page\";s:8:\"position\";i:0;}}s:12:\"style_plugin\";N;s:13:\"style_options\";N;s:9:\"row_index\";N;s:12:\"override_url\";N;s:13:\"override_path\";N;s:13:\"base_database\";N;s:5:\"field\";N;s:8:\"argument\";N;s:4:\"sort\";N;s:6:\"filter\";N;s:12:\"relationship\";N;s:6:\"header\";N;s:6:\"footer\";N;s:5:\"empty\";N;s:8:\"view_php\";s:0:\"\";s:12:\"is_cacheable\";b:0;s:7:\"changed\";b:1;s:13:\"export_module\";s:9:\"votingapi\";}',0,1512620340,1),('ctools_export:views_view:tracker','O:4:\"view\":49:{s:8:\"db_table\";s:10:\"views_view\";s:10:\"base_table\";s:4:\"node\";s:10:\"base_field\";s:3:\"nid\";s:4:\"name\";s:7:\"tracker\";s:3:\"vid\";s:0:\"\";s:11:\"description\";s:33:\"Shows all new activity on system.\";s:3:\"tag\";s:7:\"default\";s:10:\"human_name\";s:7:\"Tracker\";s:4:\"core\";i:0;s:11:\"api_version\";s:3:\"3.0\";s:8:\"disabled\";b:1;s:5:\"built\";b:0;s:8:\"executed\";b:0;s:7:\"editing\";b:0;s:4:\"args\";a:0:{}s:10:\"build_info\";a:0:{}s:8:\"use_ajax\";b:0;s:6:\"result\";a:0:{}s:12:\"current_page\";N;s:14:\"items_per_page\";N;s:6:\"offset\";N;s:10:\"total_rows\";N;s:17:\"attachment_before\";s:0:\"\";s:16:\"attachment_after\";s:0:\"\";s:12:\"exposed_data\";a:0:{}s:13:\"exposed_input\";a:0:{}s:17:\"exposed_raw_input\";a:0:{}s:8:\"old_view\";a:0:{}s:12:\"parent_views\";a:0:{}s:13:\"is_attachment\";N;s:15:\"current_display\";N;s:5:\"query\";N;s:15:\"display_handler\";N;s:7:\"display\";a:2:{s:7:\"default\";O:13:\"views_display\":8:{s:7:\"handler\";O:28:\"views_plugin_display_default\":9:{s:4:\"view\";r:1;s:8:\"handlers\";a:0:{}s:8:\"extender\";a:0:{}s:7:\"display\";R:36;s:11:\"plugin_type\";s:7:\"display\";s:11:\"plugin_name\";s:7:\"default\";s:7:\"options\";a:38:{s:5:\"title\";s:0:\"\";s:7:\"enabled\";b:1;s:15:\"display_comment\";s:0:\"\";s:9:\"css_class\";s:0:\"\";s:19:\"display_description\";s:0:\"\";s:8:\"use_ajax\";b:0;s:23:\"hide_attachment_summary\";b:0;s:16:\"hide_admin_links\";b:0;s:14:\"items_per_page\";i:10;s:6:\"offset\";i:0;s:9:\"use_pager\";b:0;s:8:\"use_more\";b:0;s:15:\"use_more_always\";b:0;s:13:\"use_more_text\";s:4:\"more\";s:12:\"link_display\";s:0:\"\";s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:0;s:14:\"field_language\";s:22:\"***CURRENT_LANGUAGE***\";s:27:\"field_language_add_to_query\";i:1;s:6:\"access\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"cache\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:0:{}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"full\";s:7:\"options\";a:0:{}}s:12:\"style_plugin\";s:7:\"default\";s:13:\"style_options\";a:0:{}s:10:\"row_plugin\";s:6:\"fields\";s:11:\"row_options\";a:0:{}s:13:\"exposed_block\";b:0;s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:0:{}s:13:\"relationships\";a:0:{}s:6:\"fields\";a:0:{}s:5:\"sorts\";a:0:{}s:9:\"arguments\";a:0:{}s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}s:7:\"filters\";a:0:{}}s:10:\"definition\";a:20:{s:5:\"title\";s:6:\"Master\";s:4:\"help\";s:31:\"Default settings for this view.\";s:7:\"handler\";s:28:\"views_plugin_display_default\";s:5:\"theme\";s:10:\"views_view\";s:5:\"no ui\";b:1;s:9:\"no remove\";b:1;s:2:\"js\";a:6:{i:0;s:12:\"misc/form.js\";i:1;s:16:\"misc/collapse.js\";i:2;s:16:\"misc/textarea.js\";i:3;s:17:\"misc/tabledrag.js\";i:4;s:20:\"misc/autocomplete.js\";i:5;s:40:\"sites/all/modules/ctools/js/dependent.js\";}s:8:\"use ajax\";b:1;s:9:\"use pager\";b:1;s:8:\"use more\";b:1;s:18:\"accept attachments\";b:1;s:10:\"help topic\";s:15:\"display-default\";s:6:\"module\";s:5:\"views\";s:10:\"theme path\";s:29:\"sites/all/modules/views/theme\";s:10:\"theme file\";s:9:\"theme.inc\";s:4:\"path\";s:31:\"sites/all/modules/views/plugins\";s:4:\"file\";s:32:\"views_plugin_display_default.inc\";s:6:\"parent\";s:6:\"parent\";s:4:\"name\";s:7:\"default\";s:16:\"contextual links\";a:1:{s:8:\"views_ui\";a:2:{s:11:\"parent path\";s:26:\"admin/structure/views/view\";s:19:\"argument properties\";a:1:{i:0;s:4:\"name\";}}}}s:9:\"is_plugin\";b:1;}s:15:\"display_options\";a:13:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:1:{s:13:\"query_comment\";b:0;}}s:5:\"title\";s:12:\"Recent posts\";s:6:\"access\";a:2:{s:4:\"type\";s:4:\"perm\";s:4:\"perm\";s:14:\"access content\";}s:5:\"cache\";a:1:{s:4:\"type\";s:4:\"none\";}s:12:\"exposed_form\";a:1:{s:4:\"type\";s:5:\"basic\";}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"full\";s:7:\"options\";a:1:{s:14:\"items_per_page\";s:2:\"25\";}}s:12:\"style_plugin\";s:5:\"table\";s:13:\"style_options\";a:5:{s:7:\"columns\";a:7:{s:4:\"type\";s:4:\"type\";s:5:\"title\";s:5:\"title\";s:4:\"name\";s:4:\"name\";s:13:\"comment_count\";s:13:\"comment_count\";s:22:\"last_comment_timestamp\";s:22:\"last_comment_timestamp\";s:9:\"timestamp\";s:5:\"title\";s:12:\"new_comments\";s:13:\"comment_count\";}s:7:\"default\";s:22:\"last_comment_timestamp\";s:4:\"info\";a:7:{s:4:\"type\";a:2:{s:8:\"sortable\";i:1;s:9:\"separator\";s:0:\"\";}s:5:\"title\";a:2:{s:8:\"sortable\";i:1;s:9:\"separator\";s:6:\"&nbsp;\";}s:4:\"name\";a:2:{s:8:\"sortable\";i:1;s:9:\"separator\";s:0:\"\";}s:13:\"comment_count\";a:2:{s:8:\"sortable\";i:1;s:9:\"separator\";s:6:\"<br />\";}s:22:\"last_comment_timestamp\";a:2:{s:8:\"sortable\";i:1;s:9:\"separator\";s:6:\"&nbsp;\";}s:9:\"timestamp\";a:1:{s:9:\"separator\";s:0:\"\";}s:12:\"new_comments\";a:1:{s:9:\"separator\";s:0:\"\";}}s:8:\"override\";i:1;s:5:\"order\";s:4:\"desc\";}s:13:\"relationships\";a:1:{s:3:\"uid\";a:3:{s:2:\"id\";s:3:\"uid\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:3:\"uid\";}}s:6:\"fields\";a:7:{s:4:\"type\";a:3:{s:2:\"id\";s:4:\"type\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:4:\"type\";}s:5:\"title\";a:3:{s:2:\"id\";s:5:\"title\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:5:\"title\";}s:4:\"name\";a:5:{s:2:\"id\";s:4:\"name\";s:5:\"table\";s:5:\"users\";s:5:\"field\";s:4:\"name\";s:12:\"relationship\";s:3:\"uid\";s:5:\"label\";s:6:\"Author\";}s:13:\"comment_count\";a:4:{s:2:\"id\";s:13:\"comment_count\";s:5:\"table\";s:23:\"node_comment_statistics\";s:5:\"field\";s:13:\"comment_count\";s:5:\"label\";s:7:\"Replies\";}s:22:\"last_comment_timestamp\";a:4:{s:2:\"id\";s:22:\"last_comment_timestamp\";s:5:\"table\";s:23:\"node_comment_statistics\";s:5:\"field\";s:22:\"last_comment_timestamp\";s:5:\"label\";s:9:\"Last Post\";}s:9:\"timestamp\";a:6:{s:2:\"id\";s:9:\"timestamp\";s:5:\"table\";s:7:\"history\";s:5:\"field\";s:9:\"timestamp\";s:5:\"label\";s:0:\"\";s:12:\"link_to_node\";i:0;s:8:\"comments\";i:1;}s:12:\"new_comments\";a:7:{s:2:\"id\";s:12:\"new_comments\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:12:\"new_comments\";s:5:\"label\";s:0:\"\";s:10:\"hide_empty\";b:1;s:6:\"suffix\";s:4:\" new\";s:15:\"link_to_comment\";i:1;}}s:5:\"sorts\";a:1:{s:22:\"last_comment_timestamp\";a:3:{s:2:\"id\";s:22:\"last_comment_timestamp\";s:5:\"table\";s:23:\"node_comment_statistics\";s:5:\"field\";s:22:\"last_comment_timestamp\";}}s:9:\"arguments\";a:1:{s:9:\"uid_touch\";a:9:{s:2:\"id\";s:9:\"uid_touch\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:9:\"uid_touch\";s:9:\"exception\";a:1:{s:12:\"title_enable\";i:1;}s:12:\"title_enable\";i:1;s:5:\"title\";s:19:\"Recent posts for %1\";s:21:\"default_argument_type\";s:5:\"fixed\";s:7:\"summary\";a:1:{s:6:\"format\";s:15:\"default_summary\";}s:18:\"specify_validation\";i:1;}}s:7:\"filters\";a:1:{s:6:\"status\";a:6:{s:2:\"id\";s:6:\"status\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:6:\"status\";s:5:\"value\";s:1:\"1\";s:5:\"group\";i:0;s:6:\"expose\";a:1:{s:8:\"operator\";b:0;}}}}s:8:\"db_table\";s:13:\"views_display\";s:3:\"vid\";i:0;s:2:\"id\";s:7:\"default\";s:13:\"display_title\";s:6:\"Master\";s:14:\"display_plugin\";s:7:\"default\";s:8:\"position\";i:0;}s:4:\"page\";O:13:\"views_display\":8:{s:7:\"handler\";O:25:\"views_plugin_display_page\":10:{s:4:\"view\";r:1;s:8:\"handlers\";a:0:{}s:8:\"extender\";a:0:{}s:7:\"display\";R:253;s:11:\"plugin_type\";s:7:\"display\";s:11:\"plugin_name\";s:4:\"page\";s:7:\"options\";a:42:{s:8:\"defaults\";a:32:{s:6:\"access\";b:1;s:5:\"cache\";b:1;s:5:\"query\";b:1;s:5:\"title\";b:1;s:9:\"css_class\";b:1;s:19:\"display_description\";b:0;s:8:\"use_ajax\";b:1;s:23:\"hide_attachment_summary\";b:1;s:16:\"hide_admin_links\";b:1;s:5:\"pager\";b:1;s:13:\"pager_options\";b:1;s:8:\"use_more\";b:1;s:15:\"use_more_always\";b:1;s:13:\"use_more_text\";b:1;s:12:\"exposed_form\";b:1;s:20:\"exposed_form_options\";b:1;s:12:\"link_display\";b:1;s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:1;s:12:\"style_plugin\";b:1;s:13:\"style_options\";b:1;s:10:\"row_plugin\";b:1;s:11:\"row_options\";b:1;s:6:\"header\";b:1;s:6:\"footer\";b:1;s:5:\"empty\";b:1;s:13:\"relationships\";b:1;s:6:\"fields\";b:1;s:5:\"sorts\";b:1;s:9:\"arguments\";b:1;s:7:\"filters\";b:1;s:13:\"filter_groups\";b:1;}s:5:\"title\";s:0:\"\";s:7:\"enabled\";b:1;s:15:\"display_comment\";s:0:\"\";s:9:\"css_class\";s:0:\"\";s:19:\"display_description\";s:0:\"\";s:8:\"use_ajax\";b:0;s:23:\"hide_attachment_summary\";b:0;s:16:\"hide_admin_links\";b:0;s:14:\"items_per_page\";i:10;s:6:\"offset\";i:0;s:9:\"use_pager\";b:0;s:8:\"use_more\";b:0;s:15:\"use_more_always\";b:0;s:13:\"use_more_text\";s:4:\"more\";s:12:\"link_display\";s:0:\"\";s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:0;s:14:\"field_language\";s:22:\"***CURRENT_LANGUAGE***\";s:27:\"field_language_add_to_query\";i:1;s:6:\"access\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"cache\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:0:{}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"full\";s:7:\"options\";a:0:{}}s:12:\"style_plugin\";s:7:\"default\";s:13:\"style_options\";a:0:{}s:10:\"row_plugin\";s:6:\"fields\";s:11:\"row_options\";a:0:{}s:13:\"exposed_block\";b:0;s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:0:{}s:13:\"relationships\";a:0:{}s:6:\"fields\";a:0:{}s:5:\"sorts\";a:0:{}s:9:\"arguments\";a:0:{}s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}s:7:\"filters\";a:0:{}s:4:\"path\";s:0:\"\";s:4:\"menu\";a:7:{s:4:\"type\";s:4:\"none\";s:5:\"title\";s:0:\"\";s:11:\"description\";s:0:\"\";s:6:\"weight\";i:0;s:4:\"name\";s:10:\"navigation\";s:7:\"context\";s:0:\"\";s:19:\"context_only_inline\";b:0;}s:11:\"tab_options\";a:5:{s:4:\"type\";s:4:\"none\";s:5:\"title\";s:0:\"\";s:11:\"description\";s:0:\"\";s:6:\"weight\";i:0;s:4:\"name\";s:10:\"navigation\";}}s:10:\"definition\";a:20:{s:5:\"title\";s:4:\"Page\";s:4:\"help\";s:54:\"Display the view as a page, with a URL and menu links.\";s:7:\"handler\";s:25:\"views_plugin_display_page\";s:5:\"theme\";s:10:\"views_view\";s:14:\"uses hook menu\";b:1;s:26:\"contextual links locations\";a:1:{i:0;s:4:\"page\";}s:8:\"use ajax\";b:1;s:9:\"use pager\";b:1;s:8:\"use more\";b:1;s:18:\"accept attachments\";b:1;s:5:\"admin\";s:4:\"Page\";s:10:\"help topic\";s:12:\"display-page\";s:6:\"module\";s:5:\"views\";s:10:\"theme path\";s:29:\"sites/all/modules/views/theme\";s:10:\"theme file\";s:9:\"theme.inc\";s:4:\"path\";s:31:\"sites/all/modules/views/plugins\";s:4:\"file\";s:29:\"views_plugin_display_page.inc\";s:6:\"parent\";s:6:\"parent\";s:4:\"name\";s:4:\"page\";s:16:\"contextual links\";a:1:{s:8:\"views_ui\";a:2:{s:11:\"parent path\";s:26:\"admin/structure/views/view\";s:19:\"argument properties\";a:1:{i:0;s:4:\"name\";}}}}s:9:\"is_plugin\";b:1;s:15:\"default_display\";R:37;}s:15:\"display_options\";a:3:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:4:\"path\";s:7:\"tracker\";s:4:\"menu\";a:2:{s:4:\"type\";s:6:\"normal\";s:5:\"title\";s:12:\"Recent posts\";}}s:8:\"db_table\";s:13:\"views_display\";s:3:\"vid\";i:0;s:2:\"id\";s:4:\"page\";s:13:\"display_title\";s:4:\"Page\";s:14:\"display_plugin\";s:4:\"page\";s:8:\"position\";i:0;}}s:12:\"style_plugin\";N;s:13:\"style_options\";N;s:9:\"row_index\";N;s:12:\"override_url\";N;s:13:\"override_path\";N;s:13:\"base_database\";N;s:5:\"field\";N;s:8:\"argument\";N;s:4:\"sort\";N;s:6:\"filter\";N;s:12:\"relationship\";N;s:6:\"header\";N;s:6:\"footer\";N;s:5:\"empty\";N;s:13:\"export_module\";s:7:\"comment\";}',0,1512620340,1),('ctools_export:views_view:webform_analysis','O:4:\"view\":50:{s:8:\"db_table\";s:10:\"views_view\";s:10:\"base_table\";s:19:\"webform_submissions\";s:10:\"base_field\";s:3:\"nid\";s:4:\"name\";s:16:\"webform_analysis\";s:3:\"vid\";s:0:\"\";s:11:\"description\";s:114:\"Limit submissions for the webform node\'s analysis. Query must have sid as a field. Don\'t duplicate sids in result.\";s:3:\"tag\";s:7:\"webform\";s:10:\"human_name\";s:16:\"Webform Analysis\";s:4:\"core\";i:7;s:11:\"api_version\";s:3:\"3.0\";s:8:\"disabled\";b:0;s:5:\"built\";b:0;s:8:\"executed\";b:0;s:7:\"editing\";b:0;s:4:\"args\";a:0:{}s:10:\"build_info\";a:0:{}s:8:\"use_ajax\";b:0;s:6:\"result\";a:0:{}s:12:\"current_page\";N;s:14:\"items_per_page\";N;s:6:\"offset\";N;s:10:\"total_rows\";N;s:17:\"attachment_before\";s:0:\"\";s:16:\"attachment_after\";s:0:\"\";s:12:\"exposed_data\";a:0:{}s:13:\"exposed_input\";a:0:{}s:17:\"exposed_raw_input\";a:0:{}s:8:\"old_view\";a:0:{}s:12:\"parent_views\";a:0:{}s:13:\"is_attachment\";N;s:15:\"current_display\";N;s:5:\"query\";N;s:15:\"display_handler\";N;s:7:\"display\";a:1:{s:7:\"default\";O:13:\"views_display\":8:{s:7:\"handler\";O:28:\"views_plugin_display_default\":9:{s:4:\"view\";r:1;s:8:\"handlers\";a:0:{}s:8:\"extender\";a:0:{}s:7:\"display\";R:36;s:11:\"plugin_type\";s:7:\"display\";s:11:\"plugin_name\";s:7:\"default\";s:7:\"options\";a:38:{s:5:\"title\";s:0:\"\";s:7:\"enabled\";b:1;s:15:\"display_comment\";s:0:\"\";s:9:\"css_class\";s:0:\"\";s:19:\"display_description\";s:0:\"\";s:8:\"use_ajax\";b:0;s:23:\"hide_attachment_summary\";b:0;s:16:\"hide_admin_links\";b:0;s:14:\"items_per_page\";i:10;s:6:\"offset\";i:0;s:9:\"use_pager\";b:0;s:8:\"use_more\";b:0;s:15:\"use_more_always\";b:0;s:13:\"use_more_text\";s:4:\"more\";s:12:\"link_display\";s:0:\"\";s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:0;s:14:\"field_language\";s:22:\"***CURRENT_LANGUAGE***\";s:27:\"field_language_add_to_query\";i:1;s:6:\"access\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"cache\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:0:{}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"full\";s:7:\"options\";a:0:{}}s:12:\"style_plugin\";s:7:\"default\";s:13:\"style_options\";a:0:{}s:10:\"row_plugin\";s:6:\"fields\";s:11:\"row_options\";a:0:{}s:13:\"exposed_block\";b:0;s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:0:{}s:13:\"relationships\";a:0:{}s:6:\"fields\";a:0:{}s:5:\"sorts\";a:0:{}s:9:\"arguments\";a:0:{}s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}s:7:\"filters\";a:0:{}}s:10:\"definition\";a:20:{s:5:\"title\";s:6:\"Master\";s:4:\"help\";s:31:\"Default settings for this view.\";s:7:\"handler\";s:28:\"views_plugin_display_default\";s:5:\"theme\";s:10:\"views_view\";s:5:\"no ui\";b:1;s:9:\"no remove\";b:1;s:2:\"js\";a:6:{i:0;s:12:\"misc/form.js\";i:1;s:16:\"misc/collapse.js\";i:2;s:16:\"misc/textarea.js\";i:3;s:17:\"misc/tabledrag.js\";i:4;s:20:\"misc/autocomplete.js\";i:5;s:40:\"sites/all/modules/ctools/js/dependent.js\";}s:8:\"use ajax\";b:1;s:9:\"use pager\";b:1;s:8:\"use more\";b:1;s:18:\"accept attachments\";b:1;s:10:\"help topic\";s:15:\"display-default\";s:6:\"module\";s:5:\"views\";s:10:\"theme path\";s:29:\"sites/all/modules/views/theme\";s:10:\"theme file\";s:9:\"theme.inc\";s:4:\"path\";s:31:\"sites/all/modules/views/plugins\";s:4:\"file\";s:32:\"views_plugin_display_default.inc\";s:6:\"parent\";s:6:\"parent\";s:4:\"name\";s:7:\"default\";s:16:\"contextual links\";a:1:{s:8:\"views_ui\";a:2:{s:11:\"parent path\";s:26:\"admin/structure/views/view\";s:19:\"argument properties\";a:1:{i:0;s:4:\"name\";}}}}s:9:\"is_plugin\";b:1;}s:15:\"display_options\";a:10:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:1:{s:8:\"distinct\";b:1;}}s:15:\"use_more_always\";b:0;s:6:\"access\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"cache\";a:1:{s:4:\"type\";s:4:\"none\";}s:12:\"exposed_form\";a:1:{s:4:\"type\";s:5:\"basic\";}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"none\";s:7:\"options\";a:1:{s:6:\"offset\";s:1:\"0\";}}s:12:\"style_plugin\";s:7:\"default\";s:10:\"row_plugin\";s:6:\"fields\";s:6:\"fields\";a:1:{s:3:\"sid\";a:3:{s:2:\"id\";s:3:\"sid\";s:5:\"table\";s:19:\"webform_submissions\";s:5:\"field\";s:3:\"sid\";}}s:9:\"arguments\";a:1:{s:3:\"nid\";a:7:{s:2:\"id\";s:3:\"nid\";s:5:\"table\";s:19:\"webform_submissions\";s:5:\"field\";s:3:\"nid\";s:14:\"default_action\";s:5:\"empty\";s:21:\"default_argument_type\";s:5:\"fixed\";s:7:\"summary\";a:2:{s:17:\"number_of_records\";s:1:\"0\";s:6:\"format\";s:15:\"default_summary\";}s:15:\"summary_options\";a:1:{s:14:\"items_per_page\";s:2:\"25\";}}}}s:8:\"db_table\";s:13:\"views_display\";s:3:\"vid\";i:0;s:2:\"id\";s:7:\"default\";s:13:\"display_title\";s:6:\"Master\";s:14:\"display_plugin\";s:7:\"default\";s:8:\"position\";i:0;}}s:12:\"style_plugin\";N;s:13:\"style_options\";N;s:9:\"row_index\";N;s:12:\"override_url\";N;s:13:\"override_path\";N;s:13:\"base_database\";N;s:5:\"field\";N;s:8:\"argument\";N;s:4:\"sort\";N;s:6:\"filter\";N;s:12:\"relationship\";N;s:6:\"header\";N;s:6:\"footer\";N;s:5:\"empty\";N;s:19:\"localization_plugin\";O:30:\"views_plugin_localization_core\":9:{s:14:\"export_strings\";a:0:{}s:9:\"translate\";b:1;s:4:\"view\";r:1;s:7:\"display\";N;s:11:\"plugin_type\";s:12:\"localization\";s:11:\"plugin_name\";s:4:\"core\";s:7:\"options\";a:0:{}s:10:\"definition\";a:11:{s:5:\"title\";s:4:\"Core\";s:4:\"help\";s:283:\"Use Drupal core t() function. Not recommended, as it doesn\'t support updates to existing strings. If you need to translate Views labels into other languages, consider installing the <a href=\"http://drupal.org/project/i18n\">Internationalization</a> package\'s Views translation module.\";s:7:\"handler\";s:30:\"views_plugin_localization_core\";s:10:\"help topic\";s:17:\"localization-core\";s:6:\"module\";s:5:\"views\";s:10:\"theme path\";s:29:\"sites/all/modules/views/theme\";s:10:\"theme file\";s:9:\"theme.inc\";s:4:\"path\";s:31:\"sites/all/modules/views/plugins\";s:4:\"file\";s:34:\"views_plugin_localization_core.inc\";s:6:\"parent\";s:6:\"parent\";s:4:\"name\";s:4:\"core\";}s:9:\"is_plugin\";b:1;}s:13:\"export_module\";s:7:\"webform\";}',0,1512620340,1),('ctools_export:views_view:webform_results','O:4:\"view\":49:{s:8:\"db_table\";s:10:\"views_view\";s:10:\"base_table\";s:19:\"webform_submissions\";s:10:\"base_field\";s:3:\"nid\";s:4:\"name\";s:15:\"webform_results\";s:3:\"vid\";s:0:\"\";s:11:\"description\";s:0:\"\";s:3:\"tag\";s:7:\"webform\";s:10:\"human_name\";s:15:\"Webform Results\";s:4:\"core\";i:7;s:11:\"api_version\";s:3:\"3.0\";s:8:\"disabled\";b:0;s:5:\"built\";b:0;s:8:\"executed\";b:0;s:7:\"editing\";b:0;s:4:\"args\";a:0:{}s:10:\"build_info\";a:0:{}s:8:\"use_ajax\";b:0;s:6:\"result\";a:0:{}s:12:\"current_page\";N;s:14:\"items_per_page\";N;s:6:\"offset\";N;s:10:\"total_rows\";N;s:17:\"attachment_before\";s:0:\"\";s:16:\"attachment_after\";s:0:\"\";s:12:\"exposed_data\";a:0:{}s:13:\"exposed_input\";a:0:{}s:17:\"exposed_raw_input\";a:0:{}s:8:\"old_view\";a:0:{}s:12:\"parent_views\";a:0:{}s:13:\"is_attachment\";N;s:15:\"current_display\";N;s:5:\"query\";N;s:15:\"display_handler\";N;s:7:\"display\";a:1:{s:7:\"default\";O:13:\"views_display\":8:{s:7:\"handler\";O:28:\"views_plugin_display_default\":9:{s:4:\"view\";r:1;s:8:\"handlers\";a:0:{}s:8:\"extender\";a:0:{}s:7:\"display\";R:36;s:11:\"plugin_type\";s:7:\"display\";s:11:\"plugin_name\";s:7:\"default\";s:7:\"options\";a:38:{s:5:\"title\";s:0:\"\";s:7:\"enabled\";b:1;s:15:\"display_comment\";s:0:\"\";s:9:\"css_class\";s:0:\"\";s:19:\"display_description\";s:0:\"\";s:8:\"use_ajax\";b:0;s:23:\"hide_attachment_summary\";b:0;s:16:\"hide_admin_links\";b:0;s:14:\"items_per_page\";i:10;s:6:\"offset\";i:0;s:9:\"use_pager\";b:0;s:8:\"use_more\";b:0;s:15:\"use_more_always\";b:0;s:13:\"use_more_text\";s:4:\"more\";s:12:\"link_display\";s:0:\"\";s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:0;s:14:\"field_language\";s:22:\"***CURRENT_LANGUAGE***\";s:27:\"field_language_add_to_query\";i:1;s:6:\"access\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"cache\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:0:{}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"full\";s:7:\"options\";a:0:{}}s:12:\"style_plugin\";s:7:\"default\";s:13:\"style_options\";a:0:{}s:10:\"row_plugin\";s:6:\"fields\";s:11:\"row_options\";a:0:{}s:13:\"exposed_block\";b:0;s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:0:{}s:13:\"relationships\";a:0:{}s:6:\"fields\";a:0:{}s:5:\"sorts\";a:0:{}s:9:\"arguments\";a:0:{}s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}s:7:\"filters\";a:0:{}}s:10:\"definition\";a:20:{s:5:\"title\";s:6:\"Master\";s:4:\"help\";s:31:\"Default settings for this view.\";s:7:\"handler\";s:28:\"views_plugin_display_default\";s:5:\"theme\";s:10:\"views_view\";s:5:\"no ui\";b:1;s:9:\"no remove\";b:1;s:2:\"js\";a:6:{i:0;s:12:\"misc/form.js\";i:1;s:16:\"misc/collapse.js\";i:2;s:16:\"misc/textarea.js\";i:3;s:17:\"misc/tabledrag.js\";i:4;s:20:\"misc/autocomplete.js\";i:5;s:40:\"sites/all/modules/ctools/js/dependent.js\";}s:8:\"use ajax\";b:1;s:9:\"use pager\";b:1;s:8:\"use more\";b:1;s:18:\"accept attachments\";b:1;s:10:\"help topic\";s:15:\"display-default\";s:6:\"module\";s:5:\"views\";s:10:\"theme path\";s:29:\"sites/all/modules/views/theme\";s:10:\"theme file\";s:9:\"theme.inc\";s:4:\"path\";s:31:\"sites/all/modules/views/plugins\";s:4:\"file\";s:32:\"views_plugin_display_default.inc\";s:6:\"parent\";s:6:\"parent\";s:4:\"name\";s:7:\"default\";s:16:\"contextual links\";a:1:{s:8:\"views_ui\";a:2:{s:11:\"parent path\";s:26:\"admin/structure/views/view\";s:19:\"argument properties\";a:1:{i:0;s:4:\"name\";}}}}s:9:\"is_plugin\";b:1;}s:15:\"display_options\";a:13:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:15:\"use_more_always\";b:0;s:6:\"access\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"cache\";a:1:{s:4:\"type\";s:4:\"none\";}s:12:\"exposed_form\";a:1:{s:4:\"type\";s:5:\"basic\";}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"full\";s:7:\"options\";a:5:{s:14:\"items_per_page\";s:2:\"50\";s:6:\"offset\";s:1:\"0\";s:2:\"id\";s:1:\"0\";s:8:\"quantity\";s:1:\"9\";s:6:\"expose\";a:3:{s:22:\"items_per_page_options\";s:27:\"10, 50, 100, 200, 500, 1000\";s:26:\"items_per_page_options_all\";b:1;s:32:\"items_per_page_options_all_label\";s:3:\"All\";}}}s:12:\"style_plugin\";s:5:\"table\";s:13:\"style_options\";a:5:{s:7:\"columns\";a:4:{s:15:\"view_submission\";s:15:\"view_submission\";s:9:\"submitted\";s:9:\"submitted\";s:4:\"name\";s:4:\"name\";s:11:\"remote_addr\";s:11:\"remote_addr\";}s:7:\"default\";s:15:\"view_submission\";s:4:\"info\";a:5:{s:15:\"view_submission\";a:5:{s:8:\"sortable\";i:1;s:18:\"default_sort_order\";s:4:\"desc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";i:0;}s:9:\"submitted\";a:5:{s:8:\"sortable\";i:1;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";i:0;}s:4:\"name\";a:5:{s:8:\"sortable\";i:1;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";i:0;}s:11:\"remote_addr\";a:5:{s:8:\"sortable\";i:1;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";i:0;}s:18:\"webform_all_fields\";a:5:{s:8:\"sortable\";i:1;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";i:0;}}s:6:\"sticky\";b:1;s:11:\"empty_table\";b:1;}s:6:\"header\";a:1:{s:14:\"webform_result\";a:4:{s:2:\"id\";s:14:\"webform_result\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:14:\"webform_result\";s:7:\"content\";s:105:\"<div class=\"webform-results-per-page\">Showing @start - @end of @total. &nbsp; @items_per_page_links</div>\";}}s:5:\"empty\";a:1:{s:16:\"area_text_custom\";a:6:{s:2:\"id\";s:16:\"area_text_custom\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:16:\"area_text_custom\";s:5:\"empty\";b:1;s:7:\"content\";s:81:\"There are no submissions for this form. <a href=\"/en/node/!1\">View this form</a>.\";s:8:\"tokenize\";b:1;}}s:13:\"relationships\";a:1:{s:3:\"uid\";a:3:{s:2:\"id\";s:3:\"uid\";s:5:\"table\";s:19:\"webform_submissions\";s:5:\"field\";s:3:\"uid\";}}s:6:\"fields\";a:5:{s:15:\"view_submission\";a:7:{s:2:\"id\";s:15:\"view_submission\";s:5:\"table\";s:19:\"webform_submissions\";s:5:\"field\";s:15:\"view_submission\";s:5:\"label\";s:1:\"#\";s:19:\"element_label_colon\";b:0;s:4:\"text\";s:8:\"[serial]\";s:12:\"access_check\";i:0;}s:9:\"submitted\";a:5:{s:2:\"id\";s:9:\"submitted\";s:5:\"table\";s:19:\"webform_submissions\";s:5:\"field\";s:9:\"submitted\";s:11:\"date_format\";s:5:\"short\";s:18:\"second_date_format\";s:4:\"long\";}s:4:\"name\";a:6:{s:2:\"id\";s:4:\"name\";s:5:\"table\";s:5:\"users\";s:5:\"field\";s:4:\"name\";s:12:\"relationship\";s:3:\"uid\";s:5:\"label\";s:4:\"User\";s:19:\"element_label_colon\";b:0;}s:11:\"remote_addr\";a:4:{s:2:\"id\";s:11:\"remote_addr\";s:5:\"table\";s:19:\"webform_submissions\";s:5:\"field\";s:11:\"remote_addr\";s:5:\"label\";s:10:\"IP address\";}s:18:\"webform_all_fields\";a:7:{s:2:\"id\";s:18:\"webform_all_fields\";s:5:\"table\";s:19:\"webform_submissions\";s:5:\"field\";s:18:\"webform_all_fields\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";b:1;s:5:\"alter\";a:1:{s:5:\"nl2br\";b:1;}s:6:\"format\";s:4:\"text\";}}s:9:\"arguments\";a:1:{s:3:\"nid\";a:9:{s:2:\"id\";s:3:\"nid\";s:5:\"table\";s:19:\"webform_submissions\";s:5:\"field\";s:3:\"nid\";s:14:\"default_action\";s:9:\"not found\";s:21:\"default_argument_type\";s:5:\"fixed\";s:7:\"summary\";a:2:{s:17:\"number_of_records\";s:1:\"0\";s:6:\"format\";s:15:\"default_summary\";}s:15:\"summary_options\";a:1:{s:14:\"items_per_page\";s:2:\"25\";}s:18:\"specify_validation\";b:1;s:8:\"validate\";a:1:{s:4:\"type\";s:4:\"node\";}}}}s:8:\"db_table\";s:13:\"views_display\";s:3:\"vid\";i:0;s:2:\"id\";s:7:\"default\";s:13:\"display_title\";s:6:\"Master\";s:14:\"display_plugin\";s:7:\"default\";s:8:\"position\";i:0;}}s:12:\"style_plugin\";N;s:13:\"style_options\";N;s:9:\"row_index\";N;s:12:\"override_url\";N;s:13:\"override_path\";N;s:13:\"base_database\";N;s:5:\"field\";N;s:8:\"argument\";N;s:4:\"sort\";N;s:6:\"filter\";N;s:12:\"relationship\";N;s:6:\"header\";N;s:6:\"footer\";N;s:5:\"empty\";N;s:13:\"export_module\";s:7:\"webform\";}',0,1512620340,1),('ctools_export:views_view:webform_submissions','O:4:\"view\":49:{s:8:\"db_table\";s:10:\"views_view\";s:10:\"base_table\";s:19:\"webform_submissions\";s:10:\"base_field\";s:3:\"nid\";s:4:\"name\";s:19:\"webform_submissions\";s:3:\"vid\";s:0:\"\";s:11:\"description\";s:0:\"\";s:3:\"tag\";s:7:\"webform\";s:10:\"human_name\";s:19:\"Webform Submissions\";s:4:\"core\";i:7;s:11:\"api_version\";s:3:\"3.0\";s:8:\"disabled\";b:0;s:5:\"built\";b:0;s:8:\"executed\";b:0;s:7:\"editing\";b:0;s:4:\"args\";a:0:{}s:10:\"build_info\";a:0:{}s:8:\"use_ajax\";b:0;s:6:\"result\";a:0:{}s:12:\"current_page\";N;s:14:\"items_per_page\";N;s:6:\"offset\";N;s:10:\"total_rows\";N;s:17:\"attachment_before\";s:0:\"\";s:16:\"attachment_after\";s:0:\"\";s:12:\"exposed_data\";a:0:{}s:13:\"exposed_input\";a:0:{}s:17:\"exposed_raw_input\";a:0:{}s:8:\"old_view\";a:0:{}s:12:\"parent_views\";a:0:{}s:13:\"is_attachment\";N;s:15:\"current_display\";N;s:5:\"query\";N;s:15:\"display_handler\";N;s:7:\"display\";a:1:{s:7:\"default\";O:13:\"views_display\":8:{s:7:\"handler\";O:28:\"views_plugin_display_default\":9:{s:4:\"view\";r:1;s:8:\"handlers\";a:0:{}s:8:\"extender\";a:0:{}s:7:\"display\";R:36;s:11:\"plugin_type\";s:7:\"display\";s:11:\"plugin_name\";s:7:\"default\";s:7:\"options\";a:38:{s:5:\"title\";s:0:\"\";s:7:\"enabled\";b:1;s:15:\"display_comment\";s:0:\"\";s:9:\"css_class\";s:0:\"\";s:19:\"display_description\";s:0:\"\";s:8:\"use_ajax\";b:0;s:23:\"hide_attachment_summary\";b:0;s:16:\"hide_admin_links\";b:0;s:14:\"items_per_page\";i:10;s:6:\"offset\";i:0;s:9:\"use_pager\";b:0;s:8:\"use_more\";b:0;s:15:\"use_more_always\";b:0;s:13:\"use_more_text\";s:4:\"more\";s:12:\"link_display\";s:0:\"\";s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:0;s:14:\"field_language\";s:22:\"***CURRENT_LANGUAGE***\";s:27:\"field_language_add_to_query\";i:1;s:6:\"access\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"cache\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:0:{}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"full\";s:7:\"options\";a:0:{}}s:12:\"style_plugin\";s:7:\"default\";s:13:\"style_options\";a:0:{}s:10:\"row_plugin\";s:6:\"fields\";s:11:\"row_options\";a:0:{}s:13:\"exposed_block\";b:0;s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:0:{}s:13:\"relationships\";a:0:{}s:6:\"fields\";a:0:{}s:5:\"sorts\";a:0:{}s:9:\"arguments\";a:0:{}s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}s:7:\"filters\";a:0:{}}s:10:\"definition\";a:20:{s:5:\"title\";s:6:\"Master\";s:4:\"help\";s:31:\"Default settings for this view.\";s:7:\"handler\";s:28:\"views_plugin_display_default\";s:5:\"theme\";s:10:\"views_view\";s:5:\"no ui\";b:1;s:9:\"no remove\";b:1;s:2:\"js\";a:6:{i:0;s:12:\"misc/form.js\";i:1;s:16:\"misc/collapse.js\";i:2;s:16:\"misc/textarea.js\";i:3;s:17:\"misc/tabledrag.js\";i:4;s:20:\"misc/autocomplete.js\";i:5;s:40:\"sites/all/modules/ctools/js/dependent.js\";}s:8:\"use ajax\";b:1;s:9:\"use pager\";b:1;s:8:\"use more\";b:1;s:18:\"accept attachments\";b:1;s:10:\"help topic\";s:15:\"display-default\";s:6:\"module\";s:5:\"views\";s:10:\"theme path\";s:29:\"sites/all/modules/views/theme\";s:10:\"theme file\";s:9:\"theme.inc\";s:4:\"path\";s:31:\"sites/all/modules/views/plugins\";s:4:\"file\";s:32:\"views_plugin_display_default.inc\";s:6:\"parent\";s:6:\"parent\";s:4:\"name\";s:7:\"default\";s:16:\"contextual links\";a:1:{s:8:\"views_ui\";a:2:{s:11:\"parent path\";s:26:\"admin/structure/views/view\";s:19:\"argument properties\";a:1:{i:0;s:4:\"name\";}}}}s:9:\"is_plugin\";b:1;}s:15:\"display_options\";a:13:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:15:\"use_more_always\";b:0;s:6:\"access\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"cache\";a:1:{s:4:\"type\";s:4:\"none\";}s:12:\"exposed_form\";a:1:{s:4:\"type\";s:5:\"basic\";}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"full\";s:7:\"options\";a:5:{s:14:\"items_per_page\";s:2:\"50\";s:6:\"offset\";s:1:\"0\";s:2:\"id\";s:1:\"0\";s:8:\"quantity\";s:1:\"9\";s:6:\"expose\";a:3:{s:22:\"items_per_page_options\";s:27:\"10, 50, 100, 200, 500, 1000\";s:26:\"items_per_page_options_all\";b:1;s:32:\"items_per_page_options_all_label\";s:3:\"All\";}}}s:12:\"style_plugin\";s:5:\"table\";s:13:\"style_options\";a:5:{s:7:\"columns\";a:7:{s:15:\"view_submission\";s:15:\"view_submission\";s:9:\"submitted\";s:9:\"submitted\";s:4:\"name\";s:4:\"name\";s:11:\"remote_addr\";s:11:\"remote_addr\";s:17:\"view_submission_1\";s:17:\"view_submission_1\";s:15:\"edit_submission\";s:17:\"view_submission_1\";s:17:\"delete_submission\";s:17:\"view_submission_1\";}s:7:\"default\";s:15:\"view_submission\";s:4:\"info\";a:7:{s:15:\"view_submission\";a:5:{s:8:\"sortable\";i:1;s:18:\"default_sort_order\";s:4:\"desc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";i:0;}s:9:\"submitted\";a:5:{s:8:\"sortable\";i:1;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";i:0;}s:4:\"name\";a:5:{s:8:\"sortable\";i:1;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";i:0;}s:11:\"remote_addr\";a:5:{s:8:\"sortable\";i:1;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";i:0;}s:17:\"view_submission_1\";a:5:{s:8:\"sortable\";i:0;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:8:\" &nbsp; \";s:12:\"empty_column\";i:0;}s:15:\"edit_submission\";a:5:{s:8:\"sortable\";i:0;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";i:0;}s:17:\"delete_submission\";a:5:{s:8:\"sortable\";i:0;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";i:0;}}s:6:\"sticky\";b:1;s:11:\"empty_table\";b:1;}s:6:\"header\";a:1:{s:14:\"webform_result\";a:4:{s:2:\"id\";s:14:\"webform_result\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:14:\"webform_result\";s:7:\"content\";s:105:\"<div class=\"webform-results-per-page\">Showing @start - @end of @total. &nbsp; @items_per_page_links</div>\";}}s:5:\"empty\";a:1:{s:16:\"area_text_custom\";a:6:{s:2:\"id\";s:16:\"area_text_custom\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:16:\"area_text_custom\";s:5:\"empty\";b:1;s:7:\"content\";s:81:\"There are no submissions for this form. <a href=\"/en/node/!1\">View this form</a>.\";s:8:\"tokenize\";b:1;}}s:13:\"relationships\";a:1:{s:3:\"uid\";a:3:{s:2:\"id\";s:3:\"uid\";s:5:\"table\";s:19:\"webform_submissions\";s:5:\"field\";s:3:\"uid\";}}s:6:\"fields\";a:7:{s:15:\"view_submission\";a:7:{s:2:\"id\";s:15:\"view_submission\";s:5:\"table\";s:19:\"webform_submissions\";s:5:\"field\";s:15:\"view_submission\";s:5:\"label\";s:1:\"#\";s:19:\"element_label_colon\";b:0;s:4:\"text\";s:8:\"[serial]\";s:12:\"access_check\";i:0;}s:9:\"submitted\";a:5:{s:2:\"id\";s:9:\"submitted\";s:5:\"table\";s:19:\"webform_submissions\";s:5:\"field\";s:9:\"submitted\";s:11:\"date_format\";s:5:\"short\";s:18:\"second_date_format\";s:4:\"long\";}s:4:\"name\";a:6:{s:2:\"id\";s:4:\"name\";s:5:\"table\";s:5:\"users\";s:5:\"field\";s:4:\"name\";s:12:\"relationship\";s:3:\"uid\";s:5:\"label\";s:4:\"User\";s:19:\"element_label_colon\";b:0;}s:11:\"remote_addr\";a:4:{s:2:\"id\";s:11:\"remote_addr\";s:5:\"table\";s:19:\"webform_submissions\";s:5:\"field\";s:11:\"remote_addr\";s:5:\"label\";s:10:\"IP address\";}s:17:\"view_submission_1\";a:6:{s:2:\"id\";s:17:\"view_submission_1\";s:5:\"table\";s:19:\"webform_submissions\";s:5:\"field\";s:15:\"view_submission\";s:5:\"label\";s:10:\"Operations\";s:19:\"element_label_colon\";b:0;s:12:\"access_check\";i:0;}s:15:\"edit_submission\";a:6:{s:2:\"id\";s:15:\"edit_submission\";s:5:\"table\";s:19:\"webform_submissions\";s:5:\"field\";s:15:\"edit_submission\";s:5:\"label\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:12:\"access_check\";i:1;}s:17:\"delete_submission\";a:6:{s:2:\"id\";s:17:\"delete_submission\";s:5:\"table\";s:19:\"webform_submissions\";s:5:\"field\";s:17:\"delete_submission\";s:5:\"label\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:12:\"access_check\";i:1;}}s:9:\"arguments\";a:2:{s:3:\"nid\";a:9:{s:2:\"id\";s:3:\"nid\";s:5:\"table\";s:19:\"webform_submissions\";s:5:\"field\";s:3:\"nid\";s:14:\"default_action\";s:9:\"not found\";s:21:\"default_argument_type\";s:5:\"fixed\";s:7:\"summary\";a:2:{s:17:\"number_of_records\";s:1:\"0\";s:6:\"format\";s:15:\"default_summary\";}s:15:\"summary_options\";a:1:{s:14:\"items_per_page\";s:2:\"25\";}s:18:\"specify_validation\";b:1;s:8:\"validate\";a:1:{s:4:\"type\";s:4:\"node\";}}s:3:\"uid\";a:6:{s:2:\"id\";s:3:\"uid\";s:5:\"table\";s:19:\"webform_submissions\";s:5:\"field\";s:3:\"uid\";s:21:\"default_argument_type\";s:5:\"fixed\";s:7:\"summary\";a:2:{s:17:\"number_of_records\";s:1:\"0\";s:6:\"format\";s:15:\"default_summary\";}s:15:\"summary_options\";a:1:{s:14:\"items_per_page\";s:2:\"25\";}}}}s:8:\"db_table\";s:13:\"views_display\";s:3:\"vid\";i:0;s:2:\"id\";s:7:\"default\";s:13:\"display_title\";s:6:\"Master\";s:14:\"display_plugin\";s:7:\"default\";s:8:\"position\";i:0;}}s:12:\"style_plugin\";N;s:13:\"style_options\";N;s:9:\"row_index\";N;s:12:\"override_url\";N;s:13:\"override_path\";N;s:13:\"base_database\";N;s:5:\"field\";N;s:8:\"argument\";N;s:4:\"sort\";N;s:6:\"filter\";N;s:12:\"relationship\";N;s:6:\"header\";N;s:6:\"footer\";N;s:5:\"empty\";N;s:13:\"export_module\";s:7:\"webform\";}',0,1512620340,1),('ctools_export:views_view:webform_webforms','O:4:\"view\":49:{s:8:\"db_table\";s:10:\"views_view\";s:10:\"base_table\";s:7:\"webform\";s:10:\"base_field\";s:3:\"nid\";s:4:\"name\";s:16:\"webform_webforms\";s:3:\"vid\";s:0:\"\";s:11:\"description\";s:39:\"An administrative list of webform nodes\";s:3:\"tag\";s:7:\"webform\";s:10:\"human_name\";s:8:\"Webforms\";s:4:\"core\";i:7;s:11:\"api_version\";s:3:\"3.0\";s:8:\"disabled\";b:0;s:5:\"built\";b:0;s:8:\"executed\";b:0;s:7:\"editing\";b:0;s:4:\"args\";a:0:{}s:10:\"build_info\";a:0:{}s:8:\"use_ajax\";b:0;s:6:\"result\";a:0:{}s:12:\"current_page\";N;s:14:\"items_per_page\";N;s:6:\"offset\";N;s:10:\"total_rows\";N;s:17:\"attachment_before\";s:0:\"\";s:16:\"attachment_after\";s:0:\"\";s:12:\"exposed_data\";a:0:{}s:13:\"exposed_input\";a:0:{}s:17:\"exposed_raw_input\";a:0:{}s:8:\"old_view\";a:0:{}s:12:\"parent_views\";a:0:{}s:13:\"is_attachment\";N;s:15:\"current_display\";N;s:5:\"query\";N;s:15:\"display_handler\";N;s:7:\"display\";a:1:{s:7:\"default\";O:13:\"views_display\":8:{s:7:\"handler\";O:28:\"views_plugin_display_default\":9:{s:4:\"view\";r:1;s:8:\"handlers\";a:0:{}s:8:\"extender\";a:0:{}s:7:\"display\";R:36;s:11:\"plugin_type\";s:7:\"display\";s:11:\"plugin_name\";s:7:\"default\";s:7:\"options\";a:38:{s:5:\"title\";s:0:\"\";s:7:\"enabled\";b:1;s:15:\"display_comment\";s:0:\"\";s:9:\"css_class\";s:0:\"\";s:19:\"display_description\";s:0:\"\";s:8:\"use_ajax\";b:0;s:23:\"hide_attachment_summary\";b:0;s:16:\"hide_admin_links\";b:0;s:14:\"items_per_page\";i:10;s:6:\"offset\";i:0;s:9:\"use_pager\";b:0;s:8:\"use_more\";b:0;s:15:\"use_more_always\";b:0;s:13:\"use_more_text\";s:4:\"more\";s:12:\"link_display\";s:0:\"\";s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:0;s:14:\"field_language\";s:22:\"***CURRENT_LANGUAGE***\";s:27:\"field_language_add_to_query\";i:1;s:6:\"access\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"cache\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:0:{}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"full\";s:7:\"options\";a:0:{}}s:12:\"style_plugin\";s:7:\"default\";s:13:\"style_options\";a:0:{}s:10:\"row_plugin\";s:6:\"fields\";s:11:\"row_options\";a:0:{}s:13:\"exposed_block\";b:0;s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:0:{}s:13:\"relationships\";a:0:{}s:6:\"fields\";a:0:{}s:5:\"sorts\";a:0:{}s:9:\"arguments\";a:0:{}s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}s:7:\"filters\";a:0:{}}s:10:\"definition\";a:20:{s:5:\"title\";s:6:\"Master\";s:4:\"help\";s:31:\"Default settings for this view.\";s:7:\"handler\";s:28:\"views_plugin_display_default\";s:5:\"theme\";s:10:\"views_view\";s:5:\"no ui\";b:1;s:9:\"no remove\";b:1;s:2:\"js\";a:6:{i:0;s:12:\"misc/form.js\";i:1;s:16:\"misc/collapse.js\";i:2;s:16:\"misc/textarea.js\";i:3;s:17:\"misc/tabledrag.js\";i:4;s:20:\"misc/autocomplete.js\";i:5;s:40:\"sites/all/modules/ctools/js/dependent.js\";}s:8:\"use ajax\";b:1;s:9:\"use pager\";b:1;s:8:\"use more\";b:1;s:18:\"accept attachments\";b:1;s:10:\"help topic\";s:15:\"display-default\";s:6:\"module\";s:5:\"views\";s:10:\"theme path\";s:29:\"sites/all/modules/views/theme\";s:10:\"theme file\";s:9:\"theme.inc\";s:4:\"path\";s:31:\"sites/all/modules/views/plugins\";s:4:\"file\";s:32:\"views_plugin_display_default.inc\";s:6:\"parent\";s:6:\"parent\";s:4:\"name\";s:7:\"default\";s:16:\"contextual links\";a:1:{s:8:\"views_ui\";a:2:{s:11:\"parent path\";s:26:\"admin/structure/views/view\";s:19:\"argument properties\";a:1:{i:0;s:4:\"name\";}}}}s:9:\"is_plugin\";b:1;}s:15:\"display_options\";a:10:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:15:\"use_more_always\";b:0;s:6:\"access\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"cache\";a:1:{s:4:\"type\";s:4:\"none\";}s:12:\"exposed_form\";a:1:{s:4:\"type\";s:5:\"basic\";}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"full\";s:7:\"options\";a:4:{s:14:\"items_per_page\";s:2:\"25\";s:6:\"offset\";s:1:\"0\";s:2:\"id\";s:1:\"0\";s:8:\"quantity\";s:1:\"9\";}}s:12:\"style_plugin\";s:5:\"table\";s:13:\"style_options\";a:3:{s:7:\"columns\";a:10:{s:5:\"title\";s:5:\"title\";s:7:\"created\";s:7:\"created\";s:6:\"status\";s:6:\"status\";s:15:\"webform_results\";s:15:\"webform_results\";s:17:\"webform_results_2\";s:15:\"webform_results\";s:17:\"webform_results_3\";s:15:\"webform_results\";s:17:\"webform_results_4\";s:15:\"webform_results\";s:9:\"edit_node\";s:9:\"edit_node\";s:12:\"webform_edit\";s:9:\"edit_node\";s:17:\"webform_results_1\";s:9:\"edit_node\";}s:7:\"default\";s:7:\"created\";s:4:\"info\";a:10:{s:5:\"title\";a:5:{s:8:\"sortable\";i:1;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";i:0;}s:7:\"created\";a:5:{s:8:\"sortable\";i:1;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";i:0;}s:6:\"status\";a:5:{s:8:\"sortable\";i:1;s:18:\"default_sort_order\";s:3:\"asc\";s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";i:0;}s:15:\"webform_results\";a:3:{s:5:\"align\";s:0:\"\";s:9:\"separator\";s:8:\" &nbsp; \";s:12:\"empty_column\";i:0;}s:17:\"webform_results_2\";a:3:{s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";i:0;}s:17:\"webform_results_3\";a:3:{s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";i:0;}s:17:\"webform_results_4\";a:3:{s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";i:0;}s:9:\"edit_node\";a:3:{s:5:\"align\";s:0:\"\";s:9:\"separator\";s:8:\" &nbsp; \";s:12:\"empty_column\";i:0;}s:12:\"webform_edit\";a:3:{s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";i:0;}s:17:\"webform_results_1\";a:3:{s:5:\"align\";s:0:\"\";s:9:\"separator\";s:0:\"\";s:12:\"empty_column\";i:0;}}}s:13:\"relationships\";a:1:{s:3:\"nid\";a:4:{s:2:\"id\";s:3:\"nid\";s:5:\"table\";s:7:\"webform\";s:5:\"field\";s:3:\"nid\";s:8:\"required\";b:1;}}s:6:\"fields\";a:10:{s:5:\"title\";a:4:{s:2:\"id\";s:5:\"title\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:5:\"title\";s:12:\"relationship\";s:3:\"nid\";}s:7:\"created\";a:7:{s:2:\"id\";s:7:\"created\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:7:\"created\";s:12:\"relationship\";s:3:\"nid\";s:5:\"label\";s:7:\"Created\";s:11:\"date_format\";s:5:\"short\";s:18:\"second_date_format\";s:4:\"long\";}s:6:\"status\";a:3:{s:2:\"id\";s:6:\"status\";s:5:\"table\";s:7:\"webform\";s:5:\"field\";s:6:\"status\";}s:15:\"webform_results\";a:7:{s:2:\"id\";s:15:\"webform_results\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:15:\"webform_results\";s:12:\"relationship\";s:3:\"nid\";s:5:\"label\";s:4:\"View\";s:19:\"element_label_colon\";b:0;s:4:\"text\";s:11:\"Submissions\";}s:17:\"webform_results_2\";a:8:{s:2:\"id\";s:17:\"webform_results_2\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:15:\"webform_results\";s:12:\"relationship\";s:3:\"nid\";s:5:\"label\";s:8:\"Analysis\";s:19:\"element_label_colon\";b:0;s:4:\"text\";s:8:\"Analysis\";s:7:\"subpath\";s:8:\"analysis\";}s:17:\"webform_results_3\";a:8:{s:2:\"id\";s:17:\"webform_results_3\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:15:\"webform_results\";s:12:\"relationship\";s:3:\"nid\";s:5:\"label\";s:5:\"Table\";s:19:\"element_label_colon\";b:0;s:4:\"text\";s:5:\"Table\";s:7:\"subpath\";s:5:\"table\";}s:17:\"webform_results_4\";a:8:{s:2:\"id\";s:17:\"webform_results_4\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:15:\"webform_results\";s:12:\"relationship\";s:3:\"nid\";s:5:\"label\";s:8:\"Download\";s:19:\"element_label_colon\";b:0;s:4:\"text\";s:8:\"Download\";s:7:\"subpath\";s:8:\"download\";}s:9:\"edit_node\";a:7:{s:2:\"id\";s:9:\"edit_node\";s:5:\"table\";s:17:\"views_entity_node\";s:5:\"field\";s:9:\"edit_node\";s:12:\"relationship\";s:3:\"nid\";s:5:\"label\";s:10:\"Operations\";s:5:\"alter\";a:2:{s:10:\"alter_text\";b:1;s:4:\"text\";s:4:\"Edit\";}s:19:\"element_label_colon\";b:0;}s:12:\"webform_edit\";a:8:{s:2:\"id\";s:12:\"webform_edit\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:12:\"webform_edit\";s:12:\"relationship\";s:3:\"nid\";s:5:\"label\";s:10:\"Components\";s:19:\"element_label_colon\";b:0;s:4:\"text\";s:10:\"Components\";s:7:\"subpath\";s:10:\"components\";}s:17:\"webform_results_1\";a:7:{s:2:\"id\";s:17:\"webform_results_1\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:15:\"webform_results\";s:12:\"relationship\";s:3:\"nid\";s:5:\"label\";s:5:\"Clear\";s:4:\"text\";s:5:\"Clear\";s:7:\"subpath\";s:5:\"clear\";}}}s:8:\"db_table\";s:13:\"views_display\";s:3:\"vid\";i:0;s:2:\"id\";s:7:\"default\";s:13:\"display_title\";s:6:\"Master\";s:14:\"display_plugin\";s:7:\"default\";s:8:\"position\";i:0;}}s:12:\"style_plugin\";N;s:13:\"style_options\";N;s:9:\"row_index\";N;s:12:\"override_url\";N;s:13:\"override_path\";N;s:13:\"base_database\";N;s:5:\"field\";N;s:8:\"argument\";N;s:4:\"sort\";N;s:6:\"filter\";N;s:12:\"relationship\";N;s:6:\"header\";N;s:6:\"footer\";N;s:5:\"empty\";N;s:13:\"export_module\";s:7:\"webform\";}',0,1512620340,1),('ctools_export_index:views_view','a:21:{i:0;s:16:\"webform_analysis\";i:1;s:15:\"webform_results\";i:2;s:19:\"webform_submissions\";i:3;s:16:\"webform_webforms\";i:4;s:15:\"comments_recent\";i:5;s:7:\"tracker\";i:6;s:3:\"faq\";i:7;s:7:\"message\";i:8;s:15:\"message_example\";i:9;s:7:\"archive\";i:10;s:9:\"frontpage\";i:11;s:8:\"glossary\";i:12;s:9:\"backlinks\";i:13;s:7:\"popular\";i:14;s:13:\"taxonomy_term\";i:15;s:11:\"top_content\";i:16;s:25:\"advanced_forum_topic_list\";i:17;s:32:\"advanced_forum_unanswered_topics\";i:18;s:28:\"advanced_forum_active_topics\";i:19;s:21:\"advanced_forum_search\";i:20;s:25:\"advanced_forum_new_topics\";}',0,1512620340,1),('entity_base_tables:en','a:11:{i:0;s:7:\"comment\";i:1;s:21:\"field_collection_item\";i:2;s:30:\"field_collection_item_revision\";i:3;s:21:\"message_type_category\";i:4;s:12:\"message_type\";i:5;s:7:\"message\";i:6;s:4:\"node\";i:7;s:13:\"node_revision\";i:8;s:12:\"file_managed\";i:9;s:18:\"taxonomy_term_data\";i:10;s:5:\"users\";}',0,1512620340,1),('unpack_options:2858069a4892781716e15d27b5cbdb53:en','a:41:{s:8:\"defaults\";a:32:{s:6:\"access\";b:1;s:5:\"cache\";b:1;s:5:\"query\";b:1;s:5:\"title\";b:1;s:9:\"css_class\";b:1;s:19:\"display_description\";b:0;s:8:\"use_ajax\";b:1;s:23:\"hide_attachment_summary\";b:1;s:16:\"hide_admin_links\";b:1;s:5:\"pager\";b:1;s:13:\"pager_options\";b:1;s:8:\"use_more\";b:1;s:15:\"use_more_always\";b:1;s:13:\"use_more_text\";b:1;s:12:\"exposed_form\";b:1;s:20:\"exposed_form_options\";b:1;s:12:\"link_display\";b:1;s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:1;s:12:\"style_plugin\";b:1;s:13:\"style_options\";b:1;s:10:\"row_plugin\";b:1;s:11:\"row_options\";b:1;s:6:\"header\";b:1;s:6:\"footer\";b:1;s:5:\"empty\";b:1;s:13:\"relationships\";b:1;s:6:\"fields\";b:1;s:5:\"sorts\";b:1;s:9:\"arguments\";b:1;s:7:\"filters\";b:1;s:13:\"filter_groups\";b:1;}s:5:\"title\";s:0:\"\";s:7:\"enabled\";b:1;s:15:\"display_comment\";s:0:\"\";s:9:\"css_class\";s:0:\"\";s:19:\"display_description\";s:0:\"\";s:8:\"use_ajax\";b:0;s:23:\"hide_attachment_summary\";b:0;s:16:\"hide_admin_links\";b:0;s:14:\"items_per_page\";i:10;s:6:\"offset\";i:0;s:9:\"use_pager\";b:0;s:8:\"use_more\";b:0;s:15:\"use_more_always\";b:0;s:13:\"use_more_text\";s:4:\"more\";s:12:\"link_display\";s:0:\"\";s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:0;s:14:\"field_language\";s:22:\"***CURRENT_LANGUAGE***\";s:27:\"field_language_add_to_query\";i:1;s:6:\"access\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"cache\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:0:{}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"full\";s:7:\"options\";a:0:{}}s:12:\"style_plugin\";s:7:\"default\";s:13:\"style_options\";a:0:{}s:10:\"row_plugin\";s:6:\"fields\";s:11:\"row_options\";a:0:{}s:13:\"exposed_block\";b:0;s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:0:{}s:13:\"relationships\";a:0:{}s:6:\"fields\";a:0:{}s:5:\"sorts\";a:0:{}s:9:\"arguments\";a:0:{}s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}s:7:\"filters\";a:0:{}s:17:\"block_description\";s:0:\"\";s:13:\"block_caching\";i:-1;}',0,1512620340,1),('unpack_options:2d740aaffb9ba9cb6a211d34b252fb1c:en','a:42:{s:8:\"defaults\";a:32:{s:6:\"access\";b:1;s:5:\"cache\";b:1;s:5:\"query\";b:1;s:5:\"title\";b:1;s:9:\"css_class\";b:1;s:19:\"display_description\";b:0;s:8:\"use_ajax\";b:1;s:23:\"hide_attachment_summary\";b:1;s:16:\"hide_admin_links\";b:1;s:5:\"pager\";b:1;s:13:\"pager_options\";b:1;s:8:\"use_more\";b:1;s:15:\"use_more_always\";b:1;s:13:\"use_more_text\";b:1;s:12:\"exposed_form\";b:1;s:20:\"exposed_form_options\";b:1;s:12:\"link_display\";b:1;s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:1;s:12:\"style_plugin\";b:1;s:13:\"style_options\";b:1;s:10:\"row_plugin\";b:1;s:11:\"row_options\";b:1;s:6:\"header\";b:1;s:6:\"footer\";b:1;s:5:\"empty\";b:1;s:13:\"relationships\";b:1;s:6:\"fields\";b:1;s:5:\"sorts\";b:1;s:9:\"arguments\";b:1;s:7:\"filters\";b:1;s:13:\"filter_groups\";b:1;}s:5:\"title\";s:0:\"\";s:7:\"enabled\";b:1;s:15:\"display_comment\";s:0:\"\";s:9:\"css_class\";s:0:\"\";s:19:\"display_description\";s:0:\"\";s:8:\"use_ajax\";b:0;s:23:\"hide_attachment_summary\";b:0;s:16:\"hide_admin_links\";b:0;s:14:\"items_per_page\";i:10;s:6:\"offset\";i:0;s:9:\"use_pager\";b:0;s:8:\"use_more\";b:0;s:15:\"use_more_always\";b:0;s:13:\"use_more_text\";s:4:\"more\";s:12:\"link_display\";s:0:\"\";s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:0;s:14:\"field_language\";s:22:\"***CURRENT_LANGUAGE***\";s:27:\"field_language_add_to_query\";i:1;s:6:\"access\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"cache\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:0:{}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"full\";s:7:\"options\";a:0:{}}s:12:\"style_plugin\";s:7:\"default\";s:13:\"style_options\";a:0:{}s:10:\"row_plugin\";s:6:\"fields\";s:11:\"row_options\";a:0:{}s:13:\"exposed_block\";b:0;s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:0:{}s:13:\"relationships\";a:0:{}s:6:\"fields\";a:0:{}s:5:\"sorts\";a:0:{}s:9:\"arguments\";a:0:{}s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}s:7:\"filters\";a:0:{}s:4:\"path\";s:0:\"\";s:4:\"menu\";a:7:{s:4:\"type\";s:4:\"none\";s:5:\"title\";s:0:\"\";s:11:\"description\";s:0:\"\";s:6:\"weight\";i:0;s:4:\"name\";s:10:\"navigation\";s:7:\"context\";s:0:\"\";s:19:\"context_only_inline\";b:0;}s:11:\"tab_options\";a:5:{s:4:\"type\";s:4:\"none\";s:5:\"title\";s:0:\"\";s:11:\"description\";s:0:\"\";s:6:\"weight\";i:0;s:4:\"name\";s:10:\"navigation\";}}',0,1512620340,1),('unpack_options:4aa787798c4722c2275a115084231559:en','a:45:{s:8:\"defaults\";a:35:{s:6:\"access\";b:1;s:5:\"cache\";b:1;s:5:\"query\";b:1;s:5:\"title\";b:1;s:9:\"css_class\";b:1;s:19:\"display_description\";b:0;s:8:\"use_ajax\";b:1;s:23:\"hide_attachment_summary\";b:1;s:16:\"hide_admin_links\";b:1;s:5:\"pager\";b:0;s:13:\"pager_options\";b:1;s:8:\"use_more\";b:1;s:15:\"use_more_always\";b:1;s:13:\"use_more_text\";b:1;s:12:\"exposed_form\";b:1;s:20:\"exposed_form_options\";b:1;s:12:\"link_display\";b:1;s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:1;s:12:\"style_plugin\";b:1;s:13:\"style_options\";b:1;s:10:\"row_plugin\";b:1;s:11:\"row_options\";b:1;s:6:\"header\";b:1;s:6:\"footer\";b:1;s:5:\"empty\";b:1;s:13:\"relationships\";b:1;s:6:\"fields\";b:1;s:5:\"sorts\";b:1;s:9:\"arguments\";b:1;s:7:\"filters\";b:1;s:13:\"filter_groups\";b:1;s:9:\"use_pager\";b:0;s:14:\"items_per_page\";b:0;s:6:\"offset\";b:0;}s:5:\"title\";s:0:\"\";s:7:\"enabled\";b:1;s:15:\"display_comment\";s:0:\"\";s:9:\"css_class\";s:0:\"\";s:19:\"display_description\";s:0:\"\";s:8:\"use_ajax\";b:0;s:23:\"hide_attachment_summary\";b:0;s:16:\"hide_admin_links\";b:0;s:14:\"items_per_page\";i:10;s:6:\"offset\";i:0;s:9:\"use_pager\";b:0;s:8:\"use_more\";b:0;s:15:\"use_more_always\";b:0;s:13:\"use_more_text\";s:4:\"more\";s:12:\"link_display\";s:0:\"\";s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:0;s:14:\"field_language\";s:22:\"***CURRENT_LANGUAGE***\";s:27:\"field_language_add_to_query\";i:1;s:6:\"access\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"cache\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:0:{}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"some\";s:7:\"options\";a:0:{}}s:12:\"style_plugin\";s:7:\"default\";s:13:\"style_options\";a:0:{}s:10:\"row_plugin\";s:6:\"fields\";s:11:\"row_options\";a:0:{}s:13:\"exposed_block\";b:0;s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:0:{}s:13:\"relationships\";a:0:{}s:6:\"fields\";a:0:{}s:5:\"sorts\";a:0:{}s:9:\"arguments\";a:0:{}s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}s:7:\"filters\";a:0:{}s:8:\"displays\";a:0:{}s:19:\"attachment_position\";s:6:\"before\";s:17:\"inherit_arguments\";b:1;s:23:\"inherit_exposed_filters\";b:0;s:13:\"inherit_pager\";b:0;s:12:\"render_pager\";b:0;}',0,1512620340,1),('unpack_options:5b456cf505ffee2080ca33191eb7e273:en','a:44:{s:8:\"defaults\";a:35:{s:6:\"access\";b:1;s:5:\"cache\";b:1;s:5:\"query\";b:1;s:5:\"title\";b:1;s:9:\"css_class\";b:1;s:19:\"display_description\";b:0;s:8:\"use_ajax\";b:1;s:23:\"hide_attachment_summary\";b:1;s:16:\"hide_admin_links\";b:1;s:5:\"pager\";b:0;s:13:\"pager_options\";b:1;s:8:\"use_more\";b:1;s:15:\"use_more_always\";b:1;s:13:\"use_more_text\";b:1;s:12:\"exposed_form\";b:1;s:20:\"exposed_form_options\";b:1;s:12:\"link_display\";b:1;s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:1;s:12:\"style_plugin\";b:0;s:13:\"style_options\";b:0;s:10:\"row_plugin\";b:0;s:11:\"row_options\";b:0;s:6:\"header\";b:1;s:6:\"footer\";b:1;s:5:\"empty\";b:1;s:13:\"relationships\";b:1;s:6:\"fields\";b:1;s:5:\"sorts\";b:1;s:9:\"arguments\";b:1;s:7:\"filters\";b:1;s:13:\"filter_groups\";b:1;s:9:\"use_pager\";b:0;s:14:\"items_per_page\";b:0;s:6:\"offset\";b:0;}s:5:\"title\";s:0:\"\";s:7:\"enabled\";b:1;s:15:\"display_comment\";s:0:\"\";s:9:\"css_class\";s:0:\"\";s:19:\"display_description\";s:0:\"\";s:8:\"use_ajax\";b:0;s:23:\"hide_attachment_summary\";b:0;s:16:\"hide_admin_links\";b:0;s:14:\"items_per_page\";i:10;s:6:\"offset\";i:0;s:9:\"use_pager\";b:0;s:8:\"use_more\";b:0;s:15:\"use_more_always\";b:0;s:13:\"use_more_text\";s:4:\"more\";s:12:\"link_display\";s:0:\"\";s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:0;s:14:\"field_language\";s:22:\"***CURRENT_LANGUAGE***\";s:27:\"field_language_add_to_query\";i:1;s:6:\"access\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"cache\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:0:{}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"some\";s:7:\"options\";a:0:{}}s:12:\"style_plugin\";s:3:\"rss\";s:13:\"style_options\";a:1:{s:11:\"description\";s:0:\"\";}s:10:\"row_plugin\";s:0:\"\";s:11:\"row_options\";a:0:{}s:13:\"exposed_block\";b:0;s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:0:{}s:13:\"relationships\";a:0:{}s:6:\"fields\";a:0:{}s:5:\"sorts\";a:0:{}s:9:\"arguments\";a:0:{}s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}s:7:\"filters\";a:0:{}s:4:\"path\";s:0:\"\";s:4:\"menu\";a:7:{s:4:\"type\";s:4:\"none\";s:5:\"title\";s:0:\"\";s:11:\"description\";s:0:\"\";s:6:\"weight\";i:0;s:4:\"name\";s:10:\"navigation\";s:7:\"context\";s:0:\"\";s:19:\"context_only_inline\";b:0;}s:11:\"tab_options\";a:5:{s:4:\"type\";s:4:\"none\";s:5:\"title\";s:0:\"\";s:11:\"description\";s:0:\"\";s:6:\"weight\";i:0;s:4:\"name\";s:10:\"navigation\";}s:8:\"displays\";a:0:{}s:14:\"sitename_title\";b:0;}',0,1512620340,1),('unpack_options:d712695f37af1bb20d684a7164f486dd:en','a:42:{s:8:\"defaults\";a:32:{s:6:\"access\";b:1;s:5:\"cache\";b:1;s:5:\"query\";b:1;s:5:\"title\";b:1;s:9:\"css_class\";b:1;s:19:\"display_description\";b:0;s:8:\"use_ajax\";b:1;s:23:\"hide_attachment_summary\";b:1;s:16:\"hide_admin_links\";b:1;s:5:\"pager\";b:1;s:13:\"pager_options\";b:1;s:8:\"use_more\";b:1;s:15:\"use_more_always\";b:1;s:13:\"use_more_text\";b:1;s:12:\"exposed_form\";b:1;s:20:\"exposed_form_options\";b:1;s:12:\"link_display\";b:1;s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:1;s:12:\"style_plugin\";b:1;s:13:\"style_options\";b:1;s:10:\"row_plugin\";b:1;s:11:\"row_options\";b:1;s:6:\"header\";b:1;s:6:\"footer\";b:1;s:5:\"empty\";b:1;s:13:\"relationships\";b:1;s:6:\"fields\";b:1;s:5:\"sorts\";b:1;s:9:\"arguments\";b:1;s:7:\"filters\";b:1;s:13:\"filter_groups\";b:1;}s:5:\"title\";s:0:\"\";s:7:\"enabled\";b:1;s:15:\"display_comment\";s:0:\"\";s:9:\"css_class\";s:0:\"\";s:19:\"display_description\";s:0:\"\";s:8:\"use_ajax\";b:0;s:23:\"hide_attachment_summary\";b:0;s:16:\"hide_admin_links\";b:0;s:14:\"items_per_page\";i:10;s:6:\"offset\";i:0;s:9:\"use_pager\";b:0;s:8:\"use_more\";b:0;s:15:\"use_more_always\";b:0;s:13:\"use_more_text\";s:4:\"more\";s:12:\"link_display\";s:0:\"\";s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:0;s:14:\"field_language\";s:22:\"***CURRENT_LANGUAGE***\";s:27:\"field_language_add_to_query\";i:1;s:6:\"access\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"cache\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:0:{}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"full\";s:7:\"options\";a:0:{}}s:12:\"style_plugin\";s:7:\"default\";s:13:\"style_options\";a:0:{}s:10:\"row_plugin\";s:6:\"fields\";s:11:\"row_options\";a:0:{}s:13:\"exposed_block\";b:0;s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:0:{}s:13:\"relationships\";a:0:{}s:6:\"fields\";a:0:{}s:5:\"sorts\";a:0:{}s:9:\"arguments\";a:0:{}s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}s:7:\"filters\";a:0:{}s:17:\"block_description\";s:0:\"\";s:13:\"block_caching\";i:-1;s:5:\"field\";a:1:{s:5:\"title\";a:1:{s:12:\"link_to_node\";i:1;}}}',0,1512620340,1),('unpack_options:e25ba9e50cc13d7b33248d068aa95e63:en','a:38:{s:5:\"title\";s:0:\"\";s:7:\"enabled\";b:1;s:15:\"display_comment\";s:0:\"\";s:9:\"css_class\";s:0:\"\";s:19:\"display_description\";s:0:\"\";s:8:\"use_ajax\";b:0;s:23:\"hide_attachment_summary\";b:0;s:16:\"hide_admin_links\";b:0;s:14:\"items_per_page\";i:10;s:6:\"offset\";i:0;s:9:\"use_pager\";b:0;s:8:\"use_more\";b:0;s:15:\"use_more_always\";b:0;s:13:\"use_more_text\";s:4:\"more\";s:12:\"link_display\";s:0:\"\";s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:0;s:14:\"field_language\";s:22:\"***CURRENT_LANGUAGE***\";s:27:\"field_language_add_to_query\";i:1;s:6:\"access\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"cache\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:0:{}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"full\";s:7:\"options\";a:0:{}}s:12:\"style_plugin\";s:7:\"default\";s:13:\"style_options\";a:0:{}s:10:\"row_plugin\";s:6:\"fields\";s:11:\"row_options\";a:0:{}s:13:\"exposed_block\";b:0;s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:0:{}s:13:\"relationships\";a:0:{}s:6:\"fields\";a:0:{}s:5:\"sorts\";a:0:{}s:9:\"arguments\";a:0:{}s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}s:7:\"filters\";a:0:{}}',0,1512620340,1),('unpack_options:e7666cab7a330f2c87165bcb893b196e:en','a:38:{s:5:\"title\";s:13:\"Recent Topics\";s:7:\"enabled\";b:1;s:15:\"display_comment\";s:0:\"\";s:9:\"css_class\";s:23:\"forum-panel-footer-view\";s:19:\"display_description\";s:0:\"\";s:8:\"use_ajax\";b:0;s:23:\"hide_attachment_summary\";b:0;s:16:\"hide_admin_links\";b:0;s:14:\"items_per_page\";i:10;s:6:\"offset\";i:0;s:9:\"use_pager\";b:0;s:8:\"use_more\";b:0;s:15:\"use_more_always\";b:0;s:13:\"use_more_text\";s:4:\"more\";s:12:\"link_display\";s:0:\"\";s:8:\"link_url\";s:0:\"\";s:8:\"group_by\";b:0;s:14:\"field_language\";s:22:\"***CURRENT_LANGUAGE***\";s:27:\"field_language_add_to_query\";i:1;s:6:\"access\";a:1:{s:4:\"type\";s:4:\"perm\";}s:5:\"cache\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:12:\"exposed_form\";a:2:{s:4:\"type\";s:5:\"basic\";s:7:\"options\";a:0:{}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"some\";s:7:\"options\";a:1:{s:14:\"items_per_page\";s:1:\"2\";}}s:12:\"style_plugin\";s:7:\"default\";s:13:\"style_options\";a:0:{}s:10:\"row_plugin\";s:6:\"fields\";s:11:\"row_options\";a:0:{}s:13:\"exposed_block\";b:0;s:6:\"header\";a:0:{}s:6:\"footer\";a:0:{}s:5:\"empty\";a:0:{}s:13:\"relationships\";a:1:{s:3:\"uid\";a:8:{s:2:\"id\";s:3:\"uid\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:3:\"uid\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:6:\"author\";s:8:\"required\";i:0;}}s:6:\"fields\";a:4:{s:7:\"picture\";a:23:{s:2:\"id\";s:7:\"picture\";s:5:\"table\";s:5:\"users\";s:5:\"field\";s:7:\"picture\";s:12:\"relationship\";s:3:\"uid\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:21:\"link_photo_to_profile\";i:1;s:11:\"image_style\";s:9:\"thumbnail\";}s:5:\"title\";a:22:{s:2:\"id\";s:5:\"title\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:5:\"title\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:2:\"20\";s:13:\"word_boundary\";i:0;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:1;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:1;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:12:\"link_to_node\";i:1;}s:4:\"name\";a:25:{s:2:\"id\";s:4:\"name\";s:5:\"table\";s:5:\"users\";s:5:\"field\";s:4:\"name\";s:12:\"relationship\";s:3:\"uid\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:1;s:4:\"text\";s:9:\"By [name]\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:12:\"link_to_user\";i:1;s:19:\"overwrite_anonymous\";i:0;s:14:\"anonymous_text\";s:0:\"\";s:15:\"format_username\";i:1;}s:7:\"created\";a:26:{s:2:\"id\";s:7:\"created\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:7:\"created\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:39:\"<i class=\"fa fa-clock-o\"></i> [created]\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:11:\"date_format\";s:6:\"custom\";s:18:\"custom_date_format\";s:13:\"D M d, Y h:ma\";s:25:\"second_date_format_custom\";s:0:\"\";s:18:\"second_date_format\";s:4:\"long\";s:8:\"timezone\";s:0:\"\";}}s:5:\"sorts\";a:1:{s:7:\"created\";a:4:{s:2:\"id\";s:7:\"created\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:7:\"created\";s:5:\"order\";s:4:\"DESC\";}}s:9:\"arguments\";a:0:{}s:13:\"filter_groups\";a:2:{s:8:\"operator\";s:3:\"AND\";s:6:\"groups\";a:1:{i:1;s:3:\"AND\";}}s:7:\"filters\";a:3:{s:6:\"status\";a:6:{s:5:\"value\";i:1;s:5:\"table\";s:4:\"node\";s:5:\"field\";s:6:\"status\";s:2:\"id\";s:6:\"status\";s:6:\"expose\";a:1:{s:8:\"operator\";b:0;}s:5:\"group\";i:1;}s:4:\"type\";a:4:{s:2:\"id\";s:4:\"type\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:4:\"type\";s:5:\"value\";a:1:{s:5:\"forum\";s:5:\"forum\";}}s:7:\"picture\";a:13:{s:2:\"id\";s:7:\"picture\";s:5:\"table\";s:5:\"users\";s:5:\"field\";s:7:\"picture\";s:12:\"relationship\";s:3:\"uid\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:8:\"operator\";s:1:\"=\";s:5:\"value\";s:1:\"1\";s:5:\"group\";s:1:\"1\";s:7:\"exposed\";b:0;s:6:\"expose\";a:11:{s:11:\"operator_id\";b:0;s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:14:\"operator_label\";s:0:\"\";s:8:\"operator\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:1:{i:2;i:2;}}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";i:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}}}}',0,1512620340,1),('views_data:en','a:107:{s:7:\"webform\";a:3:{s:5:\"table\";a:3:{s:5:\"group\";s:7:\"Webform\";s:4:\"base\";a:3:{s:5:\"field\";s:3:\"nid\";s:5:\"title\";s:13:\"Webform nodes\";s:4:\"help\";s:26:\"Nodes which have webforms.\";}s:4:\"join\";a:1:{s:4:\"node\";a:3:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:3:\"nid\";s:4:\"type\";s:5:\"INNER\";}}}s:3:\"nid\";a:6:{s:5:\"title\";s:4:\"Node\";s:4:\"help\";s:33:\"The node this webform is part of.\";s:12:\"relationship\";a:4:{s:4:\"base\";s:4:\"node\";s:5:\"field\";s:3:\"nid\";s:7:\"handler\";s:26:\"views_handler_relationship\";s:5:\"label\";s:16:\"Node for webform\";}s:6:\"filter\";a:1:{s:7:\"handler\";s:28:\"views_handler_filter_numeric\";}s:4:\"sort\";a:1:{s:7:\"handler\";s:18:\"views_handler_sort\";}s:8:\"argument\";a:4:{s:7:\"handler\";s:31:\"views_handler_argument_node_nid\";s:10:\"name field\";s:5:\"title\";s:7:\"numeric\";b:1;s:13:\"validate type\";s:3:\"nid\";}}s:6:\"status\";a:5:{s:5:\"title\";s:6:\"Status\";s:4:\"help\";s:39:\"The open or closed status of a webform.\";s:5:\"field\";a:2:{s:7:\"handler\";s:36:\"webform_handler_field_webform_status\";s:14:\"click sortable\";b:1;}s:6:\"filter\";a:3:{s:5:\"label\";s:6:\"Status\";s:7:\"handler\";s:37:\"webform_handler_filter_webform_status\";s:4:\"type\";s:11:\"open-closed\";}s:4:\"sort\";a:1:{s:7:\"handler\";s:18:\"views_handler_sort\";}}}s:19:\"webform_submissions\";a:18:{s:5:\"table\";a:2:{s:5:\"group\";s:19:\"Webform submissions\";s:4:\"base\";a:3:{s:5:\"field\";s:3:\"sid\";s:5:\"title\";s:19:\"Webform submissions\";s:4:\"help\";s:41:\"Submissions generated from Webform forms.\";}}s:6:\"serial\";a:6:{s:5:\"title\";s:13:\"Serial number\";s:4:\"help\";s:36:\"The serial number of the submission.\";s:5:\"field\";a:2:{s:7:\"handler\";s:27:\"views_handler_field_numeric\";s:14:\"click sortable\";b:1;}s:6:\"filter\";a:2:{s:5:\"title\";s:13:\"Serial number\";s:7:\"handler\";s:28:\"views_handler_filter_numeric\";}s:4:\"sort\";a:1:{s:7:\"handler\";s:18:\"views_handler_sort\";}s:8:\"argument\";a:1:{s:7:\"handler\";s:30:\"views_handler_argument_numeric\";}}s:3:\"sid\";a:6:{s:5:\"title\";s:3:\"Sid\";s:4:\"help\";s:36:\"The submission ID of the submission.\";s:5:\"field\";a:2:{s:7:\"handler\";s:27:\"views_handler_field_numeric\";s:14:\"click sortable\";b:1;}s:6:\"filter\";a:2:{s:5:\"title\";s:3:\"Sid\";s:7:\"handler\";s:28:\"views_handler_filter_numeric\";}s:4:\"sort\";a:1:{s:7:\"handler\";s:18:\"views_handler_sort\";}s:8:\"argument\";a:1:{s:7:\"handler\";s:30:\"views_handler_argument_numeric\";}}s:5:\"value\";a:5:{s:5:\"title\";s:5:\"Value\";s:4:\"help\";s:48:\"The value of a component as submitted by a user.\";s:10:\"real field\";s:3:\"sid\";s:5:\"group\";s:23:\"Webform submission data\";s:5:\"field\";a:3:{s:7:\"handler\";s:37:\"webform_handler_field_submission_data\";s:14:\"webform_expand\";b:0;s:14:\"click sortable\";b:1;}}s:18:\"webform_all_fields\";a:5:{s:5:\"title\";s:10:\"All values\";s:4:\"help\";s:43:\"Displays all values as submitted by a user.\";s:10:\"real field\";s:3:\"sid\";s:5:\"group\";s:23:\"Webform submission data\";s:5:\"field\";a:3:{s:7:\"handler\";s:37:\"webform_handler_field_submission_data\";s:14:\"webform_expand\";b:1;s:14:\"click sortable\";b:1;}}s:3:\"nid\";a:6:{s:5:\"title\";s:4:\"Node\";s:4:\"help\";s:52:\"The webform node this submission was generated from.\";s:12:\"relationship\";a:4:{s:4:\"base\";s:4:\"node\";s:5:\"field\";s:3:\"nid\";s:7:\"handler\";s:26:\"views_handler_relationship\";s:5:\"label\";s:12:\"Webform Node\";}s:6:\"filter\";a:1:{s:7:\"handler\";s:28:\"views_handler_filter_numeric\";}s:4:\"sort\";a:1:{s:7:\"handler\";s:18:\"views_handler_sort\";}s:8:\"argument\";a:4:{s:7:\"handler\";s:31:\"views_handler_argument_node_nid\";s:10:\"name field\";s:5:\"title\";s:7:\"numeric\";b:1;s:13:\"validate type\";s:3:\"nid\";}}s:3:\"uid\";a:7:{s:5:\"title\";s:4:\"User\";s:4:\"help\";s:41:\"The user who sent the webform submission.\";s:12:\"relationship\";a:4:{s:4:\"base\";s:5:\"users\";s:5:\"field\";s:3:\"uid\";s:7:\"handler\";s:26:\"views_handler_relationship\";s:5:\"label\";s:23:\"Webform Submission User\";}s:6:\"filter\";a:1:{s:7:\"handler\";s:30:\"views_handler_filter_user_name\";}s:4:\"sort\";a:1:{s:7:\"handler\";s:18:\"views_handler_sort\";}s:8:\"argument\";a:1:{s:7:\"handler\";s:30:\"views_handler_argument_numeric\";}s:5:\"field\";a:1:{s:7:\"handler\";s:24:\"views_handler_field_user\";}}s:8:\"is_draft\";a:5:{s:5:\"title\";s:5:\"Draft\";s:4:\"help\";s:41:\"Whether or not the submission is a draft.\";s:5:\"field\";a:2:{s:7:\"handler\";s:30:\"webform_handler_field_is_draft\";s:14:\"click sortable\";b:1;}s:6:\"filter\";a:1:{s:7:\"handler\";s:31:\"webform_handler_filter_is_draft\";}s:4:\"sort\";a:1:{s:7:\"handler\";s:18:\"views_handler_sort\";}}s:9:\"submitted\";a:6:{s:5:\"title\";s:9:\"Submitted\";s:4:\"help\";s:62:\"Timestamp when the form was first saved as draft or submitted.\";s:5:\"field\";a:3:{s:7:\"handler\";s:24:\"views_handler_field_date\";s:14:\"click sortable\";b:1;s:7:\"is date\";b:1;}s:6:\"filter\";a:3:{s:5:\"title\";s:9:\"Submitted\";s:7:\"handler\";s:25:\"views_handler_filter_date\";s:7:\"is date\";b:1;}s:4:\"sort\";a:2:{s:7:\"handler\";s:23:\"views_handler_sort_date\";s:7:\"is date\";b:1;}s:8:\"argument\";a:2:{s:7:\"handler\";s:27:\"views_handler_argument_date\";s:7:\"is date\";b:1;}}s:9:\"completed\";a:6:{s:5:\"title\";s:9:\"Completed\";s:4:\"help\";s:62:\"Timestamp when the form was submitted as complete (not draft).\";s:5:\"field\";a:3:{s:7:\"handler\";s:24:\"views_handler_field_date\";s:14:\"click sortable\";b:1;s:7:\"is date\";b:1;}s:6:\"filter\";a:3:{s:5:\"title\";s:9:\"Completed\";s:7:\"handler\";s:25:\"views_handler_filter_date\";s:7:\"is date\";b:1;}s:4:\"sort\";a:2:{s:7:\"handler\";s:23:\"views_handler_sort_date\";s:7:\"is date\";b:1;}s:8:\"argument\";a:2:{s:7:\"handler\";s:27:\"views_handler_argument_date\";s:7:\"is date\";b:1;}}s:8:\"modified\";a:6:{s:5:\"title\";s:8:\"Modified\";s:4:\"help\";s:59:\"Timestamp when the form was last saved (complete or draft).\";s:5:\"field\";a:3:{s:7:\"handler\";s:24:\"views_handler_field_date\";s:14:\"click sortable\";b:1;s:7:\"is date\";b:1;}s:6:\"filter\";a:3:{s:5:\"title\";s:8:\"Modified\";s:7:\"handler\";s:25:\"views_handler_filter_date\";s:7:\"is date\";b:1;}s:4:\"sort\";a:2:{s:7:\"handler\";s:23:\"views_handler_sort_date\";s:7:\"is date\";b:1;}s:8:\"argument\";a:2:{s:7:\"handler\";s:27:\"views_handler_argument_date\";s:7:\"is date\";b:1;}}s:11:\"remote_addr\";a:5:{s:5:\"title\";s:14:\"Remote address\";s:4:\"help\";s:65:\"The remote IP address of the user that submitted this submission.\";s:5:\"field\";a:2:{s:7:\"handler\";s:19:\"views_handler_field\";s:14:\"click sortable\";b:1;}s:6:\"filter\";a:2:{s:5:\"title\";s:14:\"Remote address\";s:7:\"handler\";s:27:\"views_handler_filter_string\";}s:4:\"sort\";a:1:{s:7:\"handler\";s:18:\"views_handler_sort\";}}s:15:\"view_submission\";a:5:{s:5:\"title\";s:9:\"View link\";s:4:\"help\";s:45:\"Provide a simple link to view the submission.\";s:10:\"real field\";s:6:\"serial\";s:5:\"field\";a:4:{s:7:\"handler\";s:37:\"webform_handler_field_submission_link\";s:14:\"click sortable\";b:1;s:10:\"real field\";s:6:\"serial\";s:9:\"link_type\";s:4:\"view\";}s:4:\"sort\";a:1:{s:7:\"handler\";s:18:\"views_handler_sort\";}}s:15:\"edit_submission\";a:5:{s:5:\"title\";s:9:\"Edit link\";s:4:\"help\";s:45:\"Provide a simple link to edit the submission.\";s:10:\"real field\";s:6:\"serial\";s:5:\"field\";a:3:{s:7:\"handler\";s:37:\"webform_handler_field_submission_link\";s:14:\"click sortable\";b:1;s:9:\"link_type\";s:4:\"edit\";}s:4:\"sort\";a:1:{s:7:\"handler\";s:18:\"views_handler_sort\";}}s:17:\"delete_submission\";a:5:{s:5:\"title\";s:11:\"Delete link\";s:4:\"help\";s:47:\"Provide a simple link to delete the submission.\";s:10:\"real field\";s:6:\"serial\";s:5:\"field\";a:3:{s:7:\"handler\";s:37:\"webform_handler_field_submission_link\";s:14:\"click sortable\";b:1;s:9:\"link_type\";s:6:\"delete\";}s:4:\"sort\";a:1:{s:7:\"handler\";s:18:\"views_handler_sort\";}}s:4:\"data\";a:4:{s:5:\"title\";s:4:\"Data\";s:4:\"help\";s:36:\"Relates to a webform submission data\";s:10:\"real field\";s:3:\"sid\";s:12:\"relationship\";a:4:{s:7:\"handler\";s:44:\"webform_handler_relationship_submission_data\";s:4:\"base\";s:22:\"webform_submitted_data\";s:10:\"base field\";s:3:\"sid\";s:5:\"label\";s:15:\"Submission Data\";}}s:13:\"date_argument\";a:4:{s:5:\"group\";s:4:\"Date\";s:5:\"title\";s:26:\"Date (webform_submissions)\";s:4:\"help\";s:180:\"Filter any Views webform_submissions date field by a date argument, using any common ISO date/period format (i.e. YYYY, YYYY-MM, YYYY-MM-DD, YYYY-W99, YYYY-MM-DD--P3M, P90D, etc). \";s:8:\"argument\";a:3:{s:7:\"handler\";s:27:\"date_views_argument_handler\";s:16:\"empty field name\";s:7:\"Undated\";s:7:\"is date\";b:1;}}s:11:\"date_filter\";a:4:{s:5:\"group\";s:4:\"Date\";s:5:\"title\";s:26:\"Date (webform_submissions)\";s:4:\"help\";s:48:\"Filter any Views webform_submissions date field.\";s:6:\"filter\";a:3:{s:7:\"handler\";s:25:\"date_views_filter_handler\";s:16:\"empty field name\";s:7:\"Undated\";s:7:\"is date\";b:1;}}}s:22:\"webform_submitted_data\";a:4:{s:5:\"table\";a:1:{s:5:\"group\";s:23:\"Webform submission data\";}s:4:\"data\";a:8:{s:5:\"table\";s:22:\"webform_submitted_data\";s:5:\"title\";s:10:\"Data field\";s:4:\"help\";s:48:\"The value of a component as submitted by a user.\";s:10:\"real field\";s:4:\"data\";s:5:\"field\";a:4:{s:5:\"title\";s:11:\"Value (raw)\";s:4:\"help\";s:103:\"The raw value from the database as submitted by a user. Use only when needing to sort on a field value.\";s:7:\"handler\";s:19:\"views_handler_field\";s:14:\"click sortable\";b:1;}s:8:\"argument\";a:1:{s:7:\"handler\";s:29:\"views_handler_argument_string\";}s:6:\"filter\";a:1:{s:7:\"handler\";s:38:\"webform_handler_filter_submission_data\";}s:4:\"sort\";a:1:{s:7:\"handler\";s:18:\"views_handler_sort\";}}s:12:\"data_numeric\";a:8:{s:5:\"table\";s:22:\"webform_submitted_data\";s:5:\"title\";s:20:\"Data field (numeric)\";s:4:\"help\";s:56:\"The numeric value of a component as submitted by a user.\";s:10:\"real field\";s:4:\"data\";s:5:\"field\";a:5:{s:5:\"title\";s:19:\"Numeric value (raw)\";s:4:\"help\";s:122:\"The raw value from the database, cast to a number, as submitted by a user. Use only when needing to sort on a field value.\";s:7:\"handler\";s:34:\"webform_handler_field_numeric_data\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;}s:8:\"argument\";a:1:{s:7:\"handler\";s:30:\"views_handler_argument_numeric\";}s:6:\"filter\";a:1:{s:7:\"handler\";s:35:\"webform_handler_filter_numeric_data\";}s:4:\"sort\";a:1:{s:7:\"handler\";s:33:\"webform_handler_sort_numeric_data\";}}s:2:\"no\";a:7:{s:5:\"title\";s:11:\"Value delta\";s:4:\"help\";s:86:\"The delta value of the submitted data in a multi value component (such as checkboxes).\";s:10:\"real field\";s:2:\"no\";s:8:\"argument\";a:1:{s:7:\"handler\";s:30:\"views_handler_argument_numeric\";}s:5:\"field\";a:1:{s:7:\"handler\";s:27:\"views_handler_field_numeric\";}s:6:\"filter\";a:1:{s:7:\"handler\";s:28:\"views_handler_filter_numeric\";}s:4:\"sort\";a:1:{s:7:\"handler\";s:18:\"views_handler_sort\";}}}s:4:\"book\";a:2:{s:5:\"table\";a:2:{s:5:\"group\";s:4:\"Book\";s:4:\"join\";a:1:{s:4:\"node\";a:2:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:3:\"nid\";}}}s:3:\"bid\";a:3:{s:5:\"title\";s:14:\"Top level book\";s:4:\"help\";s:24:\"The book the node is in.\";s:12:\"relationship\";a:3:{s:4:\"base\";s:4:\"node\";s:7:\"handler\";s:26:\"views_handler_relationship\";s:5:\"label\";s:4:\"Book\";}}}s:15:\"book_menu_links\";a:4:{s:5:\"table\";a:2:{s:5:\"group\";s:4:\"Book\";s:4:\"join\";a:1:{s:4:\"node\";a:4:{s:5:\"table\";s:10:\"menu_links\";s:10:\"left_table\";s:4:\"book\";s:10:\"left_field\";s:4:\"mlid\";s:5:\"field\";s:4:\"mlid\";}}}s:6:\"weight\";a:4:{s:5:\"title\";s:6:\"Weight\";s:4:\"help\";s:28:\"The weight of the book page.\";s:5:\"field\";a:2:{s:7:\"handler\";s:27:\"views_handler_field_numeric\";s:14:\"click sortable\";b:1;}s:4:\"sort\";a:1:{s:7:\"handler\";s:18:\"views_handler_sort\";}}s:5:\"depth\";a:6:{s:5:\"title\";s:5:\"Depth\";s:4:\"help\";s:79:\"The depth of the book page in the hierarchy; top level books have a depth of 1.\";s:5:\"field\";a:2:{s:7:\"handler\";s:27:\"views_handler_field_numeric\";s:14:\"click sortable\";b:1;}s:4:\"sort\";a:1:{s:7:\"handler\";s:18:\"views_handler_sort\";}s:6:\"filter\";a:1:{s:7:\"handler\";s:28:\"views_handler_filter_numeric\";}s:8:\"argument\";a:1:{s:7:\"handler\";s:22:\"views_handler_argument\";}}s:1:\"p\";a:3:{s:5:\"title\";s:9:\"Hierarchy\";s:4:\"help\";s:41:\"The order of pages in the book hierarchy.\";s:4:\"sort\";a:1:{s:7:\"handler\";s:33:\"views_handler_sort_menu_hierarchy\";}}}s:11:\"book_parent\";a:2:{s:5:\"table\";a:2:{s:5:\"group\";s:4:\"Book\";s:4:\"join\";a:1:{s:4:\"node\";a:4:{s:5:\"table\";s:4:\"book\";s:10:\"left_table\";s:15:\"book_menu_links\";s:10:\"left_field\";s:4:\"plid\";s:5:\"field\";s:4:\"mlid\";}}}s:3:\"nid\";a:3:{s:5:\"title\";s:6:\"Parent\";s:4:\"help\";s:21:\"The parent book node.\";s:12:\"relationship\";a:4:{s:4:\"base\";s:4:\"node\";s:10:\"base field\";s:3:\"nid\";s:7:\"handler\";s:26:\"views_handler_relationship\";s:5:\"label\";s:11:\"Book parent\";}}}s:8:\"comments\";a:8:{s:8:\"moved to\";s:7:\"comment\";s:9:\"timestamp\";a:1:{s:8:\"moved to\";a:2:{i:0;s:7:\"comment\";i:1;s:7:\"changed\";}}s:18:\"timestamp_fulldate\";a:1:{s:8:\"moved to\";a:2:{i:0;s:7:\"comment\";i:1;s:16:\"changed_fulldata\";}}s:20:\"timestamp_year_month\";a:1:{s:8:\"moved to\";a:2:{i:0;s:7:\"comment\";i:1;s:18:\"changed_year_month\";}}s:14:\"timestamp_year\";a:1:{s:8:\"moved to\";a:2:{i:0;s:7:\"comment\";i:1;s:12:\"changed_year\";}}s:15:\"timestamp_month\";a:1:{s:8:\"moved to\";a:2:{i:0;s:7:\"comment\";i:1;s:13:\"changed_month\";}}s:13:\"timestamp_day\";a:1:{s:8:\"moved to\";a:2:{i:0;s:7:\"comment\";i:1;s:11:\"changed_day\";}}s:14:\"timestamp_week\";a:1:{s:8:\"moved to\";a:2:{i:0;s:7:\"comment\";i:1;s:12:\"changed_week\";}}}s:7:\"comment\";a:38:{s:7:\"comment\";a:2:{s:8:\"moved to\";a:2:{i:0;s:23:\"field_data_comment_body\";i:1;s:12:\"comment_body\";}s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:23:\"field_data_comment_body\";i:1;s:12:\"comment_body\";}}}s:5:\"table\";a:4:{s:5:\"group\";s:7:\"Comment\";s:4:\"base\";a:4:{s:5:\"field\";s:3:\"cid\";s:5:\"title\";s:7:\"Comment\";s:4:\"help\";s:39:\"Comments are responses to node content.\";s:16:\"access query tag\";s:14:\"comment_access\";}s:11:\"entity type\";s:7:\"comment\";s:20:\"default_relationship\";a:1:{s:4:\"node\";a:2:{s:5:\"table\";s:4:\"node\";s:5:\"field\";s:3:\"cid\";}}}s:7:\"subject\";a:6:{s:5:\"title\";s:5:\"Title\";s:4:\"help\";s:25:\"The title of the comment.\";s:5:\"field\";a:2:{s:7:\"handler\";s:27:\"views_handler_field_comment\";s:14:\"click sortable\";b:1;}s:6:\"filter\";a:1:{s:7:\"handler\";s:27:\"views_handler_filter_string\";}s:4:\"sort\";a:1:{s:7:\"handler\";s:18:\"views_handler_sort\";}s:8:\"argument\";a:1:{s:7:\"handler\";s:29:\"views_handler_argument_string\";}}s:3:\"cid\";a:6:{s:5:\"title\";s:2:\"ID\";s:4:\"help\";s:27:\"The comment ID of the field\";s:5:\"field\";a:2:{s:7:\"handler\";s:27:\"views_handler_field_comment\";s:14:\"click sortable\";b:1;}s:6:\"filter\";a:1:{s:7:\"handler\";s:28:\"views_handler_filter_numeric\";}s:4:\"sort\";a:1:{s:7:\"handler\";s:18:\"views_handler_sort\";}s:8:\"argument\";a:1:{s:7:\"handler\";s:30:\"views_handler_argument_numeric\";}}s:4:\"name\";a:6:{s:5:\"title\";s:6:\"Author\";s:4:\"help\";s:85:\"The name of the comment\'s author. Can be rendered as a link to the author\'s homepage.\";s:5:\"field\";a:2:{s:7:\"handler\";s:36:\"views_handler_field_comment_username\";s:14:\"click sortable\";b:1;}s:6:\"filter\";a:1:{s:7:\"handler\";s:27:\"views_handler_filter_string\";}s:4:\"sort\";a:1:{s:7:\"handler\";s:18:\"views_handler_sort\";}s:8:\"argument\";a:1:{s:7:\"handler\";s:29:\"views_handler_argument_string\";}}s:8:\"homepage\";a:6:{s:5:\"title\";s:16:\"Author\'s website\";s:4:\"help\";s:121:\"The website address of the comment\'s author. Can be rendered as a link. Will be empty if the author is a registered user.\";s:5:\"field\";a:2:{s:7:\"handler\";s:23:\"views_handler_field_url\";s:14:\"click sortable\";b:1;}s:6:\"filter\";a:1:{s:7:\"handler\";s:27:\"views_handler_filter_string\";}s:4:\"sort\";a:1:{s:7:\"handler\";s:18:\"views_handler_sort\";}s:8:\"argument\";a:1:{s:7:\"handler\";s:29:\"views_handler_argument_string\";}}s:8:\"hostname\";a:6:{s:5:\"title\";s:8:\"Hostname\";s:4:\"help\";s:41:\"Hostname of user that posted the comment.\";s:5:\"field\";a:2:{s:7:\"handler\";s:19:\"views_handler_field\";s:14:\"click sortable\";b:1;}s:6:\"filter\";a:1:{s:7:\"handler\";s:27:\"views_handler_filter_string\";}s:4:\"sort\";a:1:{s:7:\"handler\";s:18:\"views_handler_sort\";}s:8:\"argument\";a:1:{s:7:\"handler\";s:29:\"views_handler_argument_string\";}}s:4:\"mail\";a:6:{s:5:\"title\";s:4:\"Mail\";s:4:\"help\";s:88:\"Email of user that posted the comment. Will be empty if the author is a registered user.\";s:5:\"field\";a:2:{s:7:\"handler\";s:19:\"views_handler_field\";s:14:\"click sortable\";b:1;}s:6:\"filter\";a:1:{s:7:\"handler\";s:27:\"views_handler_filter_string\";}s:4:\"sort\";a:1:{s:7:\"handler\";s:18:\"views_handler_sort\";}s:8:\"argument\";a:1:{s:7:\"handler\";s:29:\"views_handler_argument_string\";}}s:7:\"created\";a:5:{s:5:\"title\";s:9:\"Post date\";s:4:\"help\";s:46:\"Date and time of when the comment was created.\";s:5:\"field\";a:3:{s:7:\"handler\";s:24:\"views_handler_field_date\";s:14:\"click sortable\";b:1;s:7:\"is date\";b:1;}s:4:\"sort\";a:2:{s:7:\"handler\";s:23:\"views_handler_sort_date\";s:7:\"is date\";b:1;}s:6:\"filter\";a:2:{s:7:\"handler\";s:25:\"views_handler_filter_date\";s:7:\"is date\";b:1;}}s:16:\"created_fulldata\";a:3:{s:5:\"title\";s:12:\"Created date\";s:4:\"help\";s:29:\"Date in the form of CCYYMMDD.\";s:8:\"argument\";a:2:{s:5:\"field\";s:7:\"created\";s:7:\"handler\";s:44:\"views_handler_argument_node_created_fulldate\";}}s:18:\"created_year_month\";a:3:{s:5:\"title\";s:20:\"Created year + month\";s:4:\"help\";s:27:\"Date in the form of YYYYMM.\";s:8:\"argument\";a:2:{s:5:\"field\";s:7:\"created\";s:7:\"handler\";s:46:\"views_handler_argument_node_created_year_month\";}}s:12:\"created_year\";a:3:{s:5:\"title\";s:12:\"Created year\";s:4:\"help\";s:25:\"Date in the form of YYYY.\";s:8:\"argument\";a:2:{s:5:\"field\";s:7:\"created\";s:7:\"handler\";s:40:\"views_handler_argument_node_created_year\";}}s:13:\"created_month\";a:3:{s:5:\"title\";s:13:\"Created month\";s:4:\"help\";s:33:\"Date in the form of MM (01 - 12).\";s:8:\"argument\";a:2:{s:5:\"field\";s:7:\"created\";s:7:\"handler\";s:41:\"views_handler_argument_node_created_month\";}}s:11:\"created_day\";a:3:{s:5:\"title\";s:11:\"Created day\";s:4:\"help\";s:33:\"Date in the form of DD (01 - 31).\";s:8:\"argument\";a:2:{s:5:\"field\";s:7:\"created\";s:7:\"handler\";s:39:\"views_handler_argument_node_created_day\";}}s:12:\"created_week\";a:3:{s:5:\"title\";s:12:\"Created week\";s:4:\"help\";s:33:\"Date in the form of WW (01 - 53).\";s:8:\"argument\";a:2:{s:5:\"field\";s:7:\"created\";s:7:\"handler\";s:40:\"views_handler_argument_node_created_week\";}}s:8:\"language\";a:6:{s:5:\"title\";s:8:\"Language\";s:4:\"help\";s:31:\"The language the comment is in.\";s:5:\"field\";a:2:{s:7:\"handler\";s:35:\"views_handler_field_locale_language\";s:14:\"click sortable\";b:1;}s:6:\"filter\";a:1:{s:7:\"handler\";s:36:\"views_handler_filter_locale_language\";}s:8:\"argument\";a:1:{s:7:\"handler\";s:38:\"views_handler_argument_locale_language\";}s:4:\"sort\";a:1:{s:7:\"handler\";s:18:\"views_handler_sort\";}}s:7:\"changed\";a:5:{s:5:\"title\";s:12:\"Updated date\";s:4:\"help\";s:51:\"Date and time of when the comment was last updated.\";s:5:\"field\";a:3:{s:7:\"handler\";s:24:\"views_handler_field_date\";s:14:\"click sortable\";b:1;s:7:\"is date\";b:1;}s:4:\"sort\";a:2:{s:7:\"handler\";s:23:\"views_handler_sort_date\";s:7:\"is date\";b:1;}s:6:\"filter\";a:2:{s:7:\"handler\";s:25:\"views_handler_filter_date\";s:7:\"is date\";b:1;}}s:16:\"changed_fulldata\";a:3:{s:5:\"title\";s:12:\"Changed date\";s:4:\"help\";s:29:\"Date in the form of CCYYMMDD.\";s:8:\"argument\";a:2:{s:5:\"field\";s:7:\"changed\";s:7:\"handler\";s:44:\"views_handler_argument_node_created_fulldate\";}}s:18:\"changed_year_month\";a:3:{s:5:\"title\";s:20:\"Changed year + month\";s:4:\"help\";s:27:\"Date in the form of YYYYMM.\";s:8:\"argument\";a:2:{s:5:\"field\";s:7:\"changed\";s:7:\"handler\";s:46:\"views_handler_argument_node_created_year_month\";}}s:12:\"changed_year\";a:3:{s:5:\"title\";s:12:\"Changed year\";s:4:\"help\";s:25:\"Date in the form of YYYY.\";s:8:\"argument\";a:2:{s:5:\"field\";s:7:\"changed\";s:7:\"handler\";s:40:\"views_handler_argument_node_created_year\";}}s:13:\"changed_month\";a:3:{s:5:\"title\";s:13:\"Changed month\";s:4:\"help\";s:33:\"Date in the form of MM (01 - 12).\";s:8:\"argument\";a:2:{s:5:\"field\";s:7:\"changed\";s:7:\"handler\";s:41:\"views_handler_argument_node_created_month\";}}s:11:\"changed_day\";a:3:{s:5:\"title\";s:11:\"Changed day\";s:4:\"help\";s:33:\"Date in the form of DD (01 - 31).\";s:8:\"argument\";a:2:{s:5:\"field\";s:7:\"changed\";s:7:\"handler\";s:39:\"views_handler_argument_node_created_day\";}}s:12:\"changed_week\";a:3:{s:5:\"title\";s:12:\"Changed week\";s:4:\"help\";s:33:\"Date in the form of WW (01 - 53).\";s:8:\"argument\";a:2:{s:5:\"field\";s:7:\"changed\";s:7:\"handler\";s:40:\"views_handler_argument_node_created_week\";}}s:6:\"status\";a:5:{s:5:\"title\";s:8:\"Approved\";s:4:\"help\";s:67:\"Whether the comment is approved (or still in the moderation queue).\";s:5:\"field\";a:3:{s:7:\"handler\";s:27:\"views_handler_field_boolean\";s:14:\"click sortable\";b:1;s:14:\"output formats\";a:1:{s:21:\"approved-not-approved\";a:2:{i:0;s:8:\"Approved\";i:1;s:12:\"Not Approved\";}}}s:6:\"filter\";a:3:{s:7:\"handler\";s:37:\"views_handler_filter_boolean_operator\";s:5:\"label\";s:16:\"Approved comment\";s:4:\"type\";s:6:\"yes-no\";}s:4:\"sort\";a:1:{s:7:\"handler\";s:18:\"views_handler_sort\";}}s:12:\"view_comment\";a:1:{s:5:\"field\";a:3:{s:5:\"title\";s:9:\"View link\";s:4:\"help\";s:42:\"Provide a simple link to view the comment.\";s:7:\"handler\";s:32:\"views_handler_field_comment_link\";}}s:12:\"edit_comment\";a:1:{s:5:\"field\";a:3:{s:5:\"title\";s:9:\"Edit link\";s:4:\"help\";s:42:\"Provide a simple link to edit the comment.\";s:7:\"handler\";s:37:\"views_handler_field_comment_link_edit\";}}s:14:\"delete_comment\";a:1:{s:5:\"field\";a:3:{s:5:\"title\";s:11:\"Delete link\";s:4:\"help\";s:44:\"Provide a simple link to delete the comment.\";s:7:\"handler\";s:39:\"views_handler_field_comment_link_delete\";}}s:15:\"approve_comment\";a:1:{s:5:\"field\";a:3:{s:5:\"title\";s:12:\"Approve link\";s:4:\"help\";s:45:\"Provide a simple link to approve the comment.\";s:7:\"handler\";s:40:\"views_handler_field_comment_link_approve\";}}s:15:\"replyto_comment\";a:1:{s:5:\"field\";a:3:{s:5:\"title\";s:13:\"Reply-to link\";s:4:\"help\";s:46:\"Provide a simple link to reply to the comment.\";s:7:\"handler\";s:38:\"views_handler_field_comment_link_reply\";}}s:6:\"thread\";a:2:{s:5:\"field\";a:3:{s:5:\"title\";s:5:\"Depth\";s:4:\"help\";s:51:\"Display the depth of the comment if it is threaded.\";s:7:\"handler\";s:33:\"views_handler_field_comment_depth\";}s:4:\"sort\";a:3:{s:5:\"title\";s:6:\"Thread\";s:4:\"help\";s:86:\"Sort by the threaded order. This will keep child comments together with their parents.\";s:7:\"handler\";s:33:\"views_handler_sort_comment_thread\";}}s:3:\"nid\";a:6:{s:5:\"title\";s:3:\"Nid\";s:4:\"help\";s:47:\"The node ID to which the comment is a reply to.\";s:12:\"relationship\";a:6:{s:5:\"title\";s:7:\"Content\";s:4:\"help\";s:47:\"The content to which the comment is a reply to.\";s:4:\"base\";s:4:\"node\";s:10:\"base field\";s:3:\"nid\";s:7:\"handler\";s:26:\"views_handler_relationship\";s:5:\"label\";s:7:\"Content\";}s:6:\"filter\";a:1:{s:7:\"handler\";s:28:\"views_handler_filter_numeric\";}s:8:\"argument\";a:1:{s:7:\"handler\";s:30:\"views_handler_argument_numeric\";}s:5:\"field\";a:1:{s:7:\"handler\";s:27:\"views_handler_field_numeric\";}}s:3:\"uid\";a:6:{s:5:\"title\";s:10:\"Author uid\";s:4:\"help\";s:73:\"If you need more fields than the uid add the comment: author relationship\";s:12:\"relationship\";a:6:{s:5:\"title\";s:6:\"Author\";s:4:\"help\";s:36:\"The User ID of the comment\'s author.\";s:4:\"base\";s:5:\"users\";s:10:\"base field\";s:3:\"uid\";s:7:\"handler\";s:26:\"views_handler_relationship\";s:5:\"label\";s:6:\"author\";}s:6:\"filter\";a:1:{s:7:\"handler\";s:28:\"views_handler_filter_numeric\";}s:8:\"argument\";a:1:{s:7:\"handler\";s:30:\"views_handler_argument_numeric\";}s:5:\"field\";a:1:{s:7:\"handler\";s:24:\"views_handler_field_user\";}}s:3:\"pid\";a:4:{s:5:\"title\";s:10:\"Parent CID\";s:4:\"help\";s:37:\"The Comment ID of the parent comment.\";s:5:\"field\";a:1:{s:7:\"handler\";s:19:\"views_handler_field\";}s:12:\"relationship\";a:6:{s:5:\"title\";s:14:\"Parent comment\";s:4:\"help\";s:19:\"The parent comment.\";s:4:\"base\";s:7:\"comment\";s:10:\"base field\";s:3:\"cid\";s:7:\"handler\";s:26:\"views_handler_relationship\";s:5:\"label\";s:14:\"Parent comment\";}}s:13:\"date_argument\";a:4:{s:5:\"group\";s:4:\"Date\";s:5:\"title\";s:14:\"Date (comment)\";s:4:\"help\";s:168:\"Filter any Views comment date field by a date argument, using any common ISO date/period format (i.e. YYYY, YYYY-MM, YYYY-MM-DD, YYYY-W99, YYYY-MM-DD--P3M, P90D, etc). \";s:8:\"argument\";a:3:{s:7:\"handler\";s:27:\"date_views_argument_handler\";s:16:\"empty field name\";s:7:\"Undated\";s:7:\"is date\";b:1;}}s:11:\"date_filter\";a:4:{s:5:\"group\";s:4:\"Date\";s:5:\"title\";s:14:\"Date (comment)\";s:4:\"help\";s:36:\"Filter any Views comment date field.\";s:6:\"filter\";a:3:{s:7:\"handler\";s:25:\"date_views_filter_handler\";s:16:\"empty field name\";s:7:\"Undated\";s:7:\"is date\";b:1;}}s:33:\"reverse_field_comment_ref_message\";a:1:{s:12:\"relationship\";a:11:{s:7:\"handler\";s:41:\"views_handler_relationship_entity_reverse\";s:10:\"field_name\";s:17:\"field_comment_ref\";s:11:\"field table\";s:28:\"field_data_field_comment_ref\";s:11:\"field field\";s:27:\"field_comment_ref_target_id\";s:4:\"base\";s:7:\"message\";s:10:\"base field\";s:3:\"mid\";s:5:\"label\";s:50:\"Message referencing Comment from field_comment_ref\";s:5:\"group\";s:16:\"Entity Reference\";s:5:\"title\";s:18:\"Referencing entity\";s:4:\"help\";s:80:\"A bridge to the Message entity that is referencing Comment via field_comment_ref\";s:10:\"join_extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:7:\"message\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}s:14:\"votingapi_vote\";a:1:{s:12:\"relationship\";a:7:{s:5:\"title\";s:5:\"Votes\";s:4:\"help\";s:31:\"Votes cast by users on Comment.\";s:4:\"base\";s:14:\"votingapi_vote\";s:5:\"field\";s:9:\"entity_id\";s:18:\"relationship field\";s:3:\"cid\";s:7:\"handler\";s:36:\"votingapi_views_handler_relationship\";s:5:\"extra\";a:1:{i:0;a:3:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:7:\"comment\";s:7:\"numeric\";b:0;}}}}s:15:\"votingapi_cache\";a:1:{s:12:\"relationship\";a:7:{s:5:\"title\";s:12:\"Vote results\";s:4:\"help\";s:43:\"Aggregate results of votes cast on Comment.\";s:4:\"base\";s:15:\"votingapi_cache\";s:5:\"field\";s:9:\"entity_id\";s:18:\"relationship field\";s:3:\"cid\";s:7:\"handler\";s:36:\"votingapi_views_handler_relationship\";s:5:\"extra\";a:1:{i:0;a:3:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:7:\"comment\";s:7:\"numeric\";b:0;}}}}}s:23:\"node_comment_statistics\";a:7:{s:5:\"table\";a:2:{s:5:\"group\";s:7:\"Content\";s:4:\"join\";a:1:{s:4:\"node\";a:3:{s:4:\"type\";s:5:\"INNER\";s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:3:\"nid\";}}}s:22:\"last_comment_timestamp\";a:5:{s:5:\"title\";s:17:\"Last comment time\";s:4:\"help\";s:50:\"Date and time of when the last comment was posted.\";s:5:\"field\";a:2:{s:7:\"handler\";s:42:\"views_handler_field_last_comment_timestamp\";s:14:\"click sortable\";b:1;}s:4:\"sort\";a:2:{s:7:\"handler\";s:23:\"views_handler_sort_date\";s:7:\"is date\";b:1;}s:6:\"filter\";a:2:{s:7:\"handler\";s:25:\"views_handler_filter_date\";s:7:\"is date\";b:1;}}s:17:\"last_comment_name\";a:4:{s:5:\"title\";s:19:\"Last comment author\";s:4:\"help\";s:50:\"The name of the author of the last posted comment.\";s:5:\"field\";a:3:{s:7:\"handler\";s:41:\"views_handler_field_ncs_last_comment_name\";s:14:\"click sortable\";b:1;s:11:\"no group by\";b:1;}s:4:\"sort\";a:2:{s:7:\"handler\";s:40:\"views_handler_sort_ncs_last_comment_name\";s:11:\"no group by\";b:1;}}s:13:\"comment_count\";a:6:{s:5:\"title\";s:13:\"Comment count\";s:4:\"help\";s:34:\"The number of comments a node has.\";s:5:\"field\";a:2:{s:7:\"handler\";s:27:\"views_handler_field_numeric\";s:14:\"click sortable\";b:1;}s:6:\"filter\";a:1:{s:7:\"handler\";s:28:\"views_handler_filter_numeric\";}s:4:\"sort\";a:1:{s:7:\"handler\";s:18:\"views_handler_sort\";}s:8:\"argument\";a:1:{s:7:\"handler\";s:22:\"views_handler_argument\";}}s:12:\"last_updated\";a:5:{s:5:\"title\";s:22:\"Updated/commented date\";s:4:\"help\";s:60:\"The most recent of last comment posted or node updated time.\";s:5:\"field\";a:3:{s:7:\"handler\";s:36:\"views_handler_field_ncs_last_updated\";s:14:\"click sortable\";b:1;s:11:\"no group by\";b:1;}s:4:\"sort\";a:2:{s:7:\"handler\";s:35:\"views_handler_sort_ncs_last_updated\";s:11:\"no group by\";b:1;}s:6:\"filter\";a:1:{s:7:\"handler\";s:37:\"views_handler_filter_ncs_last_updated\";}}s:3:\"cid\";a:3:{s:5:\"title\";s:16:\"Last comment CID\";s:4:\"help\";s:34:\"Display the last comment of a node\";s:12:\"relationship\";a:7:{s:5:\"title\";s:12:\"Last Comment\";s:4:\"help\";s:27:\"The last comment of a node.\";s:5:\"group\";s:7:\"Comment\";s:4:\"base\";s:7:\"comment\";s:10:\"base field\";s:3:\"cid\";s:7:\"handler\";s:26:\"views_handler_relationship\";s:5:\"label\";s:12:\"Last Comment\";}}s:16:\"last_comment_uid\";a:6:{s:5:\"title\";s:16:\"Last comment uid\";s:4:\"help\";s:56:\"The User ID of the author of the last comment of a node.\";s:12:\"relationship\";a:5:{s:5:\"title\";s:19:\"Last comment author\";s:4:\"base\";s:5:\"users\";s:10:\"base field\";s:3:\"uid\";s:7:\"handler\";s:26:\"views_handler_relationship\";s:5:\"label\";s:19:\"Last comment author\";}s:6:\"filter\";a:1:{s:7:\"handler\";s:28:\"views_handler_filter_numeric\";}s:8:\"argument\";a:1:{s:7:\"handler\";s:30:\"views_handler_argument_numeric\";}s:5:\"field\";a:1:{s:7:\"handler\";s:27:\"views_handler_field_numeric\";}}}s:21:\"field_collection_item\";a:10:{s:13:\"date_argument\";a:4:{s:5:\"group\";s:4:\"Date\";s:5:\"title\";s:28:\"Date (field_collection_item)\";s:4:\"help\";s:182:\"Filter any Views field_collection_item date field by a date argument, using any common ISO date/period format (i.e. YYYY, YYYY-MM, YYYY-MM-DD, YYYY-W99, YYYY-MM-DD--P3M, P90D, etc). \";s:8:\"argument\";a:3:{s:7:\"handler\";s:27:\"date_views_argument_handler\";s:16:\"empty field name\";s:7:\"Undated\";s:7:\"is date\";b:1;}}s:11:\"date_filter\";a:4:{s:5:\"group\";s:4:\"Date\";s:5:\"title\";s:28:\"Date (field_collection_item)\";s:4:\"help\";s:50:\"Filter any Views field_collection_item date field.\";s:6:\"filter\";a:3:{s:7:\"handler\";s:25:\"date_views_filter_handler\";s:16:\"empty field name\";s:7:\"Undated\";s:7:\"is date\";b:1;}}s:5:\"table\";a:4:{s:5:\"group\";s:21:\"Field collection item\";s:11:\"entity type\";s:21:\"field_collection_item\";s:4:\"base\";a:4:{s:5:\"field\";s:7:\"item_id\";s:16:\"access query tag\";s:28:\"field_collection_item_access\";s:5:\"title\";s:21:\"Field collection item\";s:4:\"help\";s:0:\"\";}s:20:\"default_relationship\";a:1:{s:30:\"field_collection_item_revision\";a:2:{s:5:\"table\";s:30:\"field_collection_item_revision\";s:5:\"field\";s:11:\"revision_id\";}}}s:7:\"item_id\";a:6:{s:5:\"title\";s:24:\"Field collection item ID\";s:4:\"help\";s:43:\"The unique ID of the field collection item.\";s:5:\"field\";a:4:{s:10:\"real field\";s:7:\"item_id\";s:7:\"handler\";s:27:\"views_handler_field_numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:2:{s:10:\"real field\";s:7:\"item_id\";s:7:\"handler\";s:18:\"views_handler_sort\";}s:6:\"filter\";a:2:{s:10:\"real field\";s:7:\"item_id\";s:7:\"handler\";s:28:\"views_handler_filter_numeric\";}s:8:\"argument\";a:2:{s:10:\"real field\";s:7:\"item_id\";s:7:\"handler\";s:30:\"views_handler_argument_numeric\";}}s:11:\"revision_id\";a:6:{s:5:\"title\";s:11:\"Revision_id\";s:4:\"help\";s:45:\"Field collection item \"revision_id\" property.\";s:5:\"field\";a:4:{s:10:\"real field\";s:11:\"revision_id\";s:7:\"handler\";s:27:\"views_handler_field_numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:2:{s:10:\"real field\";s:11:\"revision_id\";s:7:\"handler\";s:18:\"views_handler_sort\";}s:6:\"filter\";a:2:{s:10:\"real field\";s:11:\"revision_id\";s:7:\"handler\";s:28:\"views_handler_filter_numeric\";}s:8:\"argument\";a:2:{s:10:\"real field\";s:11:\"revision_id\";s:7:\"handler\";s:30:\"views_handler_argument_numeric\";}}s:10:\"field_name\";a:6:{s:5:\"title\";s:10:\"Field name\";s:4:\"help\";s:77:\"The machine-readable name of the field collection field containing this item.\";s:5:\"field\";a:5:{s:10:\"real field\";s:10:\"field_name\";s:7:\"handler\";s:32:\"views_handler_field_machine_name\";s:14:\"click sortable\";b:1;s:16:\"options callback\";a:2:{i:0;s:28:\"EntityDefaultViewsController\";i:1;s:19:\"optionsListCallback\";}s:17:\"options arguments\";a:3:{i:0;s:21:\"field_collection_item\";i:1;s:10:\"field_name\";i:2;s:4:\"view\";}}s:4:\"sort\";a:2:{s:10:\"real field\";s:10:\"field_name\";s:7:\"handler\";s:18:\"views_handler_sort\";}s:6:\"filter\";a:4:{s:10:\"real field\";s:10:\"field_name\";s:7:\"handler\";s:32:\"views_handler_filter_in_operator\";s:16:\"options callback\";a:2:{i:0;s:28:\"EntityDefaultViewsController\";i:1;s:19:\"optionsListCallback\";}s:17:\"options arguments\";a:3:{i:0;s:21:\"field_collection_item\";i:1;s:10:\"field_name\";i:2;s:4:\"view\";}}s:8:\"argument\";a:2:{s:10:\"real field\";s:10:\"field_name\";s:7:\"handler\";s:29:\"views_handler_argument_string\";}}s:8:\"archived\";a:6:{s:5:\"title\";s:8:\"Archived\";s:4:\"help\";s:42:\"Field collection item \"archived\" property.\";s:5:\"field\";a:4:{s:10:\"real field\";s:8:\"archived\";s:7:\"handler\";s:27:\"views_handler_field_numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:2:{s:10:\"real field\";s:8:\"archived\";s:7:\"handler\";s:18:\"views_handler_sort\";}s:6:\"filter\";a:2:{s:10:\"real field\";s:8:\"archived\";s:7:\"handler\";s:28:\"views_handler_filter_numeric\";}s:8:\"argument\";a:2:{s:10:\"real field\";s:8:\"archived\";s:7:\"handler\";s:30:\"views_handler_argument_numeric\";}}s:24:\"field_extra_content_node\";a:1:{s:12:\"relationship\";a:9:{s:5:\"title\";s:51:\"Entity with the Extra content (field_extra_content)\";s:4:\"help\";s:40:\"Relate each Content using Extra content.\";s:7:\"handler\";s:41:\"views_handler_relationship_entity_reverse\";s:10:\"field_name\";s:19:\"field_extra_content\";s:11:\"field table\";s:30:\"field_data_field_extra_content\";s:11:\"field field\";s:25:\"field_extra_content_value\";s:4:\"base\";s:4:\"node\";s:10:\"base field\";s:3:\"nid\";s:5:\"label\";s:19:\"field_extra_content\";}}s:14:\"votingapi_vote\";a:1:{s:12:\"relationship\";a:7:{s:5:\"title\";s:5:\"Votes\";s:4:\"help\";s:45:\"Votes cast by users on Field collection item.\";s:4:\"base\";s:14:\"votingapi_vote\";s:5:\"field\";s:9:\"entity_id\";s:18:\"relationship field\";s:7:\"item_id\";s:7:\"handler\";s:36:\"votingapi_views_handler_relationship\";s:5:\"extra\";a:1:{i:0;a:3:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:21:\"field_collection_item\";s:7:\"numeric\";b:0;}}}}s:15:\"votingapi_cache\";a:1:{s:12:\"relationship\";a:7:{s:5:\"title\";s:12:\"Vote results\";s:4:\"help\";s:57:\"Aggregate results of votes cast on Field collection item.\";s:4:\"base\";s:15:\"votingapi_cache\";s:5:\"field\";s:9:\"entity_id\";s:18:\"relationship field\";s:7:\"item_id\";s:7:\"handler\";s:36:\"votingapi_views_handler_relationship\";s:5:\"extra\";a:1:{i:0;a:3:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:21:\"field_collection_item\";s:7:\"numeric\";b:0;}}}}}s:30:\"field_collection_item_revision\";a:5:{s:13:\"date_argument\";a:4:{s:5:\"group\";s:4:\"Date\";s:5:\"title\";s:37:\"Date (field_collection_item_revision)\";s:4:\"help\";s:191:\"Filter any Views field_collection_item_revision date field by a date argument, using any common ISO date/period format (i.e. YYYY, YYYY-MM, YYYY-MM-DD, YYYY-W99, YYYY-MM-DD--P3M, P90D, etc). \";s:8:\"argument\";a:3:{s:7:\"handler\";s:27:\"date_views_argument_handler\";s:16:\"empty field name\";s:7:\"Undated\";s:7:\"is date\";b:1;}}s:11:\"date_filter\";a:4:{s:5:\"group\";s:4:\"Date\";s:5:\"title\";s:37:\"Date (field_collection_item_revision)\";s:4:\"help\";s:59:\"Filter any Views field_collection_item_revision date field.\";s:6:\"filter\";a:3:{s:7:\"handler\";s:25:\"date_views_filter_handler\";s:16:\"empty field name\";s:7:\"Undated\";s:7:\"is date\";b:1;}}s:5:\"table\";a:5:{s:5:\"group\";s:31:\"Field collection item Revisions\";s:11:\"entity type\";s:21:\"field_collection_item\";s:4:\"base\";a:4:{s:5:\"field\";s:11:\"revision_id\";s:16:\"access query tag\";s:28:\"field_collection_item_access\";s:5:\"title\";s:31:\"Field collection item Revisions\";s:4:\"help\";s:9:\"Revisions\";}s:4:\"join\";a:1:{s:21:\"field_collection_item\";a:2:{s:10:\"left_field\";s:11:\"revision_id\";s:5:\"field\";s:11:\"revision_id\";}}s:20:\"default_relationship\";a:1:{s:21:\"field_collection_item\";a:2:{s:5:\"table\";s:21:\"field_collection_item\";s:5:\"field\";s:7:\"item_id\";}}}s:7:\"item_id\";a:6:{s:5:\"title\";s:24:\"Field collection item ID\";s:4:\"help\";s:43:\"The unique ID of the field collection item.\";s:5:\"field\";a:4:{s:10:\"real field\";s:7:\"item_id\";s:7:\"handler\";s:27:\"views_handler_field_numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:2:{s:10:\"real field\";s:7:\"item_id\";s:7:\"handler\";s:18:\"views_handler_sort\";}s:6:\"filter\";a:2:{s:10:\"real field\";s:7:\"item_id\";s:7:\"handler\";s:28:\"views_handler_filter_numeric\";}s:8:\"argument\";a:2:{s:10:\"real field\";s:7:\"item_id\";s:7:\"handler\";s:30:\"views_handler_argument_numeric\";}}s:11:\"revision_id\";a:6:{s:5:\"title\";s:11:\"Revision_id\";s:4:\"help\";s:45:\"Field collection item \"revision_id\" property.\";s:5:\"field\";a:4:{s:10:\"real field\";s:11:\"revision_id\";s:7:\"handler\";s:27:\"views_handler_field_numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:2:{s:10:\"real field\";s:11:\"revision_id\";s:7:\"handler\";s:18:\"views_handler_sort\";}s:6:\"filter\";a:2:{s:10:\"real field\";s:11:\"revision_id\";s:7:\"handler\";s:28:\"views_handler_filter_numeric\";}s:8:\"argument\";a:2:{s:10:\"real field\";s:11:\"revision_id\";s:7:\"handler\";s:30:\"views_handler_argument_numeric\";}}}s:20:\"i18n_translation_set\";a:4:{s:13:\"date_argument\";a:4:{s:5:\"group\";s:4:\"Date\";s:5:\"title\";s:27:\"Date (i18n_translation_set)\";s:4:\"help\";s:181:\"Filter any Views i18n_translation_set date field by a date argument, using any common ISO date/period format (i.e. YYYY, YYYY-MM, YYYY-MM-DD, YYYY-W99, YYYY-MM-DD--P3M, P90D, etc). \";s:8:\"argument\";a:3:{s:7:\"handler\";s:27:\"date_views_argument_handler\";s:16:\"empty field name\";s:7:\"Undated\";s:7:\"is date\";b:1;}}s:11:\"date_filter\";a:4:{s:5:\"group\";s:4:\"Date\";s:5:\"title\";s:27:\"Date (i18n_translation_set)\";s:4:\"help\";s:49:\"Filter any Views i18n_translation_set date field.\";s:6:\"filter\";a:3:{s:7:\"handler\";s:25:\"date_views_filter_handler\";s:16:\"empty field name\";s:7:\"Undated\";s:7:\"is date\";b:1;}}s:14:\"votingapi_vote\";a:1:{s:12:\"relationship\";a:7:{s:5:\"title\";s:5:\"Votes\";s:4:\"help\";s:39:\"Votes cast by users on Translation set.\";s:4:\"base\";s:14:\"votingapi_vote\";s:5:\"field\";s:9:\"entity_id\";s:18:\"relationship field\";s:4:\"tsid\";s:7:\"handler\";s:36:\"votingapi_views_handler_relationship\";s:5:\"extra\";a:1:{i:0;a:3:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:16:\"i18n_translation\";s:7:\"numeric\";b:0;}}}}s:15:\"votingapi_cache\";a:1:{s:12:\"relationship\";a:7:{s:5:\"title\";s:12:\"Vote results\";s:4:\"help\";s:51:\"Aggregate results of votes cast on Translation set.\";s:4:\"base\";s:15:\"votingapi_cache\";s:5:\"field\";s:9:\"entity_id\";s:18:\"relationship field\";s:4:\"tsid\";s:7:\"handler\";s:36:\"votingapi_views_handler_relationship\";s:5:\"extra\";a:1:{i:0;a:3:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:16:\"i18n_translation\";s:7:\"numeric\";b:0;}}}}}s:21:\"message_type_category\";a:11:{s:13:\"date_argument\";a:4:{s:5:\"group\";s:4:\"Date\";s:5:\"title\";s:28:\"Date (message_type_category)\";s:4:\"help\";s:182:\"Filter any Views message_type_category date field by a date argument, using any common ISO date/period format (i.e. YYYY, YYYY-MM, YYYY-MM-DD, YYYY-W99, YYYY-MM-DD--P3M, P90D, etc). \";s:8:\"argument\";a:3:{s:7:\"handler\";s:27:\"date_views_argument_handler\";s:16:\"empty field name\";s:7:\"Undated\";s:7:\"is date\";b:1;}}s:11:\"date_filter\";a:4:{s:5:\"group\";s:4:\"Date\";s:5:\"title\";s:28:\"Date (message_type_category)\";s:4:\"help\";s:50:\"Filter any Views message_type_category date field.\";s:6:\"filter\";a:3:{s:7:\"handler\";s:25:\"date_views_filter_handler\";s:16:\"empty field name\";s:7:\"Undated\";s:7:\"is date\";b:1;}}s:5:\"table\";a:3:{s:5:\"group\";s:21:\"Message type category\";s:11:\"entity type\";s:21:\"message_type_category\";s:4:\"base\";a:4:{s:5:\"field\";s:2:\"id\";s:16:\"access query tag\";s:28:\"message_type_category_access\";s:5:\"title\";s:21:\"Message type category\";s:4:\"help\";s:0:\"\";}}s:2:\"id\";a:6:{s:5:\"title\";s:42:\"Internal, numeric message type category ID\";s:4:\"help\";s:62:\"The ID used to identify this message type category internally.\";s:5:\"field\";a:4:{s:10:\"real field\";s:2:\"id\";s:7:\"handler\";s:27:\"views_handler_field_numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:2:{s:10:\"real field\";s:2:\"id\";s:7:\"handler\";s:18:\"views_handler_sort\";}s:6:\"filter\";a:2:{s:10:\"real field\";s:2:\"id\";s:7:\"handler\";s:28:\"views_handler_filter_numeric\";}s:8:\"argument\";a:2:{s:10:\"real field\";s:2:\"id\";s:7:\"handler\";s:30:\"views_handler_argument_numeric\";}}s:8:\"category\";a:6:{s:5:\"title\";s:21:\"Machine-readable name\";s:4:\"help\";s:65:\"The machine-readable name identifying this message type category.\";s:5:\"field\";a:3:{s:10:\"real field\";s:8:\"category\";s:7:\"handler\";s:19:\"views_handler_field\";s:14:\"click sortable\";b:1;}s:4:\"sort\";a:2:{s:10:\"real field\";s:8:\"category\";s:7:\"handler\";s:18:\"views_handler_sort\";}s:6:\"filter\";a:2:{s:10:\"real field\";s:8:\"category\";s:7:\"handler\";s:27:\"views_handler_filter_string\";}s:8:\"argument\";a:2:{s:10:\"real field\";s:8:\"category\";s:7:\"handler\";s:29:\"views_handler_argument_string\";}}s:11:\"description\";a:6:{s:5:\"title\";s:5:\"Label\";s:4:\"help\";s:25:\"The human readable label.\";s:5:\"field\";a:3:{s:10:\"real field\";s:11:\"description\";s:7:\"handler\";s:19:\"views_handler_field\";s:14:\"click sortable\";b:1;}s:4:\"sort\";a:2:{s:10:\"real field\";s:11:\"description\";s:7:\"handler\";s:18:\"views_handler_sort\";}s:6:\"filter\";a:2:{s:10:\"real field\";s:11:\"description\";s:7:\"handler\";s:27:\"views_handler_filter_string\";}s:8:\"argument\";a:2:{s:10:\"real field\";s:11:\"description\";s:7:\"handler\";s:29:\"views_handler_argument_string\";}}s:8:\"language\";a:6:{s:5:\"title\";s:8:\"Language\";s:4:\"help\";s:42:\"Message type category \"language\" property.\";s:5:\"field\";a:3:{s:10:\"real field\";s:8:\"language\";s:7:\"handler\";s:19:\"views_handler_field\";s:14:\"click sortable\";b:1;}s:4:\"sort\";a:2:{s:10:\"real field\";s:8:\"language\";s:7:\"handler\";s:18:\"views_handler_sort\";}s:6:\"filter\";a:2:{s:10:\"real field\";s:8:\"language\";s:7:\"handler\";s:27:\"views_handler_filter_string\";}s:8:\"argument\";a:2:{s:10:\"real field\";s:8:\"language\";s:7:\"handler\";s:29:\"views_handler_argument_string\";}}s:6:\"status\";a:6:{s:5:\"title\";s:6:\"Status\";s:4:\"help\";s:40:\"Message type category \"status\" property.\";s:5:\"field\";a:4:{s:10:\"real field\";s:6:\"status\";s:7:\"handler\";s:27:\"views_handler_field_numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:2:{s:10:\"real field\";s:6:\"status\";s:7:\"handler\";s:18:\"views_handler_sort\";}s:6:\"filter\";a:2:{s:10:\"real field\";s:6:\"status\";s:7:\"handler\";s:28:\"views_handler_filter_numeric\";}s:8:\"argument\";a:2:{s:10:\"real field\";s:6:\"status\";s:7:\"handler\";s:30:\"views_handler_argument_numeric\";}}s:6:\"module\";a:6:{s:5:\"title\";s:6:\"Module\";s:4:\"help\";s:40:\"Message type category \"module\" property.\";s:5:\"field\";a:3:{s:10:\"real field\";s:6:\"module\";s:7:\"handler\";s:19:\"views_handler_field\";s:14:\"click sortable\";b:1;}s:4:\"sort\";a:2:{s:10:\"real field\";s:6:\"module\";s:7:\"handler\";s:18:\"views_handler_sort\";}s:6:\"filter\";a:2:{s:10:\"real field\";s:6:\"module\";s:7:\"handler\";s:27:\"views_handler_filter_string\";}s:8:\"argument\";a:2:{s:10:\"real field\";s:6:\"module\";s:7:\"handler\";s:29:\"views_handler_argument_string\";}}s:14:\"votingapi_vote\";a:1:{s:12:\"relationship\";a:7:{s:5:\"title\";s:5:\"Votes\";s:4:\"help\";s:45:\"Votes cast by users on Message type category.\";s:4:\"base\";s:14:\"votingapi_vote\";s:5:\"field\";s:9:\"entity_id\";s:18:\"relationship field\";s:2:\"id\";s:7:\"handler\";s:36:\"votingapi_views_handler_relationship\";s:5:\"extra\";a:1:{i:0;a:3:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:21:\"message_type_category\";s:7:\"numeric\";b:0;}}}}s:15:\"votingapi_cache\";a:1:{s:12:\"relationship\";a:7:{s:5:\"title\";s:12:\"Vote results\";s:4:\"help\";s:57:\"Aggregate results of votes cast on Message type category.\";s:4:\"base\";s:15:\"votingapi_cache\";s:5:\"field\";s:9:\"entity_id\";s:18:\"relationship field\";s:2:\"id\";s:7:\"handler\";s:36:\"votingapi_views_handler_relationship\";s:5:\"extra\";a:1:{i:0;a:3:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:21:\"message_type_category\";s:7:\"numeric\";b:0;}}}}}s:12:\"message_type\";a:13:{s:13:\"date_argument\";a:4:{s:5:\"group\";s:4:\"Date\";s:5:\"title\";s:19:\"Date (message_type)\";s:4:\"help\";s:173:\"Filter any Views message_type date field by a date argument, using any common ISO date/period format (i.e. YYYY, YYYY-MM, YYYY-MM-DD, YYYY-W99, YYYY-MM-DD--P3M, P90D, etc). \";s:8:\"argument\";a:3:{s:7:\"handler\";s:27:\"date_views_argument_handler\";s:16:\"empty field name\";s:7:\"Undated\";s:7:\"is date\";b:1;}}s:11:\"date_filter\";a:4:{s:5:\"group\";s:4:\"Date\";s:5:\"title\";s:19:\"Date (message_type)\";s:4:\"help\";s:41:\"Filter any Views message_type date field.\";s:6:\"filter\";a:3:{s:7:\"handler\";s:25:\"date_views_filter_handler\";s:16:\"empty field name\";s:7:\"Undated\";s:7:\"is date\";b:1;}}s:5:\"table\";a:3:{s:5:\"group\";s:12:\"Message type\";s:11:\"entity type\";s:12:\"message_type\";s:4:\"base\";a:4:{s:5:\"field\";s:2:\"id\";s:16:\"access query tag\";s:19:\"message_type_access\";s:5:\"title\";s:12:\"Message type\";s:4:\"help\";s:0:\"\";}}s:2:\"id\";a:6:{s:5:\"title\";s:33:\"Internal, numeric message type ID\";s:4:\"help\";s:53:\"The ID used to identify this message type internally.\";s:5:\"field\";a:4:{s:10:\"real field\";s:2:\"id\";s:7:\"handler\";s:27:\"views_handler_field_numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:2:{s:10:\"real field\";s:2:\"id\";s:7:\"handler\";s:18:\"views_handler_sort\";}s:6:\"filter\";a:2:{s:10:\"real field\";s:2:\"id\";s:7:\"handler\";s:28:\"views_handler_filter_numeric\";}s:8:\"argument\";a:2:{s:10:\"real field\";s:2:\"id\";s:7:\"handler\";s:30:\"views_handler_argument_numeric\";}}s:4:\"name\";a:6:{s:5:\"title\";s:21:\"Machine-readable name\";s:4:\"help\";s:56:\"The machine-readable name identifying this message type.\";s:5:\"field\";a:3:{s:10:\"real field\";s:4:\"name\";s:7:\"handler\";s:19:\"views_handler_field\";s:14:\"click sortable\";b:1;}s:4:\"sort\";a:2:{s:10:\"real field\";s:4:\"name\";s:7:\"handler\";s:18:\"views_handler_sort\";}s:6:\"filter\";a:2:{s:10:\"real field\";s:4:\"name\";s:7:\"handler\";s:27:\"views_handler_filter_string\";}s:8:\"argument\";a:2:{s:10:\"real field\";s:4:\"name\";s:7:\"handler\";s:29:\"views_handler_argument_string\";}}s:8:\"category\";a:6:{s:5:\"title\";s:8:\"Category\";s:4:\"help\";s:33:\"Message type \"category\" property.\";s:5:\"field\";a:5:{s:10:\"real field\";s:8:\"category\";s:7:\"handler\";s:32:\"views_handler_field_machine_name\";s:14:\"click sortable\";b:1;s:16:\"options callback\";a:2:{i:0;s:28:\"EntityDefaultViewsController\";i:1;s:19:\"optionsListCallback\";}s:17:\"options arguments\";a:3:{i:0;s:12:\"message_type\";i:1;s:8:\"category\";i:2;s:4:\"view\";}}s:4:\"sort\";a:2:{s:10:\"real field\";s:8:\"category\";s:7:\"handler\";s:18:\"views_handler_sort\";}s:6:\"filter\";a:4:{s:10:\"real field\";s:8:\"category\";s:7:\"handler\";s:32:\"views_handler_filter_in_operator\";s:16:\"options callback\";a:2:{i:0;s:28:\"EntityDefaultViewsController\";i:1;s:19:\"optionsListCallback\";}s:17:\"options arguments\";a:3:{i:0;s:12:\"message_type\";i:1;s:8:\"category\";i:2;s:4:\"view\";}}s:8:\"argument\";a:2:{s:10:\"real field\";s:8:\"category\";s:7:\"handler\";s:29:\"views_handler_argument_string\";}}s:11:\"description\";a:6:{s:5:\"title\";s:5:\"Label\";s:4:\"help\";s:25:\"The human readable label.\";s:5:\"field\";a:3:{s:10:\"real field\";s:11:\"description\";s:7:\"handler\";s:19:\"views_handler_field\";s:14:\"click sortable\";b:1;}s:4:\"sort\";a:2:{s:10:\"real field\";s:11:\"description\";s:7:\"handler\";s:18:\"views_handler_sort\";}s:6:\"filter\";a:2:{s:10:\"real field\";s:11:\"description\";s:7:\"handler\";s:27:\"views_handler_filter_string\";}s:8:\"argument\";a:2:{s:10:\"real field\";s:11:\"description\";s:7:\"handler\";s:29:\"views_handler_argument_string\";}}s:8:\"language\";a:6:{s:5:\"title\";s:8:\"Language\";s:4:\"help\";s:33:\"Message type \"language\" property.\";s:5:\"field\";a:3:{s:10:\"real field\";s:8:\"language\";s:7:\"handler\";s:19:\"views_handler_field\";s:14:\"click sortable\";b:1;}s:4:\"sort\";a:2:{s:10:\"real field\";s:8:\"language\";s:7:\"handler\";s:18:\"views_handler_sort\";}s:6:\"filter\";a:2:{s:10:\"real field\";s:8:\"language\";s:7:\"handler\";s:27:\"views_handler_filter_string\";}s:8:\"argument\";a:2:{s:10:\"real field\";s:8:\"language\";s:7:\"handler\";s:29:\"views_handler_argument_string\";}}s:6:\"status\";a:6:{s:5:\"title\";s:6:\"Status\";s:4:\"help\";s:31:\"Message type \"status\" property.\";s:5:\"field\";a:4:{s:10:\"real field\";s:6:\"status\";s:7:\"handler\";s:27:\"views_handler_field_numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:2:{s:10:\"real field\";s:6:\"status\";s:7:\"handler\";s:18:\"views_handler_sort\";}s:6:\"filter\";a:2:{s:10:\"real field\";s:6:\"status\";s:7:\"handler\";s:28:\"views_handler_filter_numeric\";}s:8:\"argument\";a:2:{s:10:\"real field\";s:6:\"status\";s:7:\"handler\";s:30:\"views_handler_argument_numeric\";}}s:6:\"module\";a:6:{s:5:\"title\";s:6:\"Module\";s:4:\"help\";s:31:\"Message type \"module\" property.\";s:5:\"field\";a:3:{s:10:\"real field\";s:6:\"module\";s:7:\"handler\";s:19:\"views_handler_field\";s:14:\"click sortable\";b:1;}s:4:\"sort\";a:2:{s:10:\"real field\";s:6:\"module\";s:7:\"handler\";s:18:\"views_handler_sort\";}s:6:\"filter\";a:2:{s:10:\"real field\";s:6:\"module\";s:7:\"handler\";s:27:\"views_handler_filter_string\";}s:8:\"argument\";a:2:{s:10:\"real field\";s:6:\"module\";s:7:\"handler\";s:29:\"views_handler_argument_string\";}}s:7:\"message\";a:3:{s:5:\"title\";s:7:\"Message\";s:4:\"help\";s:42:\"Associated message via the message\'s type.\";s:12:\"relationship\";a:5:{s:5:\"label\";s:7:\"Message\";s:7:\"handler\";s:26:\"views_handler_relationship\";s:4:\"base\";s:7:\"message\";s:10:\"base field\";s:4:\"type\";s:18:\"relationship field\";s:4:\"name\";}}s:14:\"votingapi_vote\";a:1:{s:12:\"relationship\";a:7:{s:5:\"title\";s:5:\"Votes\";s:4:\"help\";s:36:\"Votes cast by users on Message type.\";s:4:\"base\";s:14:\"votingapi_vote\";s:5:\"field\";s:9:\"entity_id\";s:18:\"relationship field\";s:2:\"id\";s:7:\"handler\";s:36:\"votingapi_views_handler_relationship\";s:5:\"extra\";a:1:{i:0;a:3:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:12:\"message_type\";s:7:\"numeric\";b:0;}}}}s:15:\"votingapi_cache\";a:1:{s:12:\"relationship\";a:7:{s:5:\"title\";s:12:\"Vote results\";s:4:\"help\";s:48:\"Aggregate results of votes cast on Message type.\";s:4:\"base\";s:15:\"votingapi_cache\";s:5:\"field\";s:9:\"entity_id\";s:18:\"relationship field\";s:2:\"id\";s:7:\"handler\";s:36:\"votingapi_views_handler_relationship\";s:5:\"extra\";a:1:{i:0;a:3:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:12:\"message_type\";s:7:\"numeric\";b:0;}}}}}s:7:\"message\";a:12:{s:13:\"date_argument\";a:4:{s:5:\"group\";s:4:\"Date\";s:5:\"title\";s:14:\"Date (message)\";s:4:\"help\";s:168:\"Filter any Views message date field by a date argument, using any common ISO date/period format (i.e. YYYY, YYYY-MM, YYYY-MM-DD, YYYY-W99, YYYY-MM-DD--P3M, P90D, etc). \";s:8:\"argument\";a:3:{s:7:\"handler\";s:27:\"date_views_argument_handler\";s:16:\"empty field name\";s:7:\"Undated\";s:7:\"is date\";b:1;}}s:11:\"date_filter\";a:4:{s:5:\"group\";s:4:\"Date\";s:5:\"title\";s:14:\"Date (message)\";s:4:\"help\";s:36:\"Filter any Views message date field.\";s:6:\"filter\";a:3:{s:7:\"handler\";s:25:\"date_views_filter_handler\";s:16:\"empty field name\";s:7:\"Undated\";s:7:\"is date\";b:1;}}s:5:\"table\";a:3:{s:5:\"group\";s:7:\"Message\";s:11:\"entity type\";s:7:\"message\";s:4:\"base\";a:4:{s:5:\"field\";s:3:\"mid\";s:16:\"access query tag\";s:14:\"message_access\";s:5:\"title\";s:7:\"Message\";s:4:\"help\";s:0:\"\";}}s:3:\"mid\";a:6:{s:5:\"title\";s:10:\"Message ID\";s:4:\"help\";s:29:\"The unique ID of the message.\";s:5:\"field\";a:4:{s:10:\"real field\";s:3:\"mid\";s:7:\"handler\";s:27:\"views_handler_field_numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:2:{s:10:\"real field\";s:3:\"mid\";s:7:\"handler\";s:18:\"views_handler_sort\";}s:6:\"filter\";a:2:{s:10:\"real field\";s:3:\"mid\";s:7:\"handler\";s:28:\"views_handler_filter_numeric\";}s:8:\"argument\";a:2:{s:10:\"real field\";s:3:\"mid\";s:7:\"handler\";s:30:\"views_handler_argument_numeric\";}}s:4:\"type\";a:7:{s:12:\"relationship\";a:5:{s:5:\"label\";s:12:\"Message type\";s:7:\"handler\";s:43:\"entity_views_handler_relationship_by_bundle\";s:4:\"base\";s:12:\"message_type\";s:10:\"base field\";s:4:\"name\";s:18:\"relationship field\";s:4:\"type\";}s:5:\"title\";s:4:\"Type\";s:4:\"help\";s:17:\"The message type.\";s:5:\"field\";a:5:{s:10:\"real field\";s:4:\"type\";s:7:\"handler\";s:32:\"views_handler_field_machine_name\";s:14:\"click sortable\";b:1;s:16:\"options callback\";a:2:{i:0;s:28:\"EntityDefaultViewsController\";i:1;s:19:\"optionsListCallback\";}s:17:\"options arguments\";a:3:{i:0;s:7:\"message\";i:1;s:4:\"type\";i:2;s:4:\"view\";}}s:4:\"sort\";a:2:{s:10:\"real field\";s:4:\"type\";s:7:\"handler\";s:18:\"views_handler_sort\";}s:6:\"filter\";a:4:{s:10:\"real field\";s:4:\"type\";s:7:\"handler\";s:35:\"message_handler_filter_message_type\";s:16:\"options callback\";a:2:{i:0;s:28:\"EntityDefaultViewsController\";i:1;s:19:\"optionsListCallback\";}s:17:\"options arguments\";a:3:{i:0;s:7:\"message\";i:1;s:4:\"type\";i:2;s:4:\"view\";}}s:8:\"argument\";a:2:{s:10:\"real field\";s:4:\"type\";s:7:\"handler\";s:29:\"views_handler_argument_string\";}}s:9:\"timestamp\";a:6:{s:5:\"title\";s:9:\"Timestamp\";s:4:\"help\";s:37:\"The time the message has been logged.\";s:5:\"field\";a:4:{s:10:\"real field\";s:9:\"timestamp\";s:7:\"handler\";s:24:\"views_handler_field_date\";s:14:\"click sortable\";b:1;s:7:\"is date\";b:1;}s:4:\"sort\";a:3:{s:10:\"real field\";s:9:\"timestamp\";s:7:\"handler\";s:23:\"views_handler_sort_date\";s:7:\"is date\";b:1;}s:6:\"filter\";a:3:{s:10:\"real field\";s:9:\"timestamp\";s:7:\"handler\";s:25:\"views_handler_filter_date\";s:7:\"is date\";b:1;}s:8:\"argument\";a:3:{s:10:\"real field\";s:9:\"timestamp\";s:7:\"handler\";s:27:\"views_handler_argument_date\";s:7:\"is date\";b:1;}}s:8:\"language\";a:6:{s:5:\"title\";s:8:\"Language\";s:4:\"help\";s:28:\"Message \"language\" property.\";s:5:\"field\";a:3:{s:10:\"real field\";s:8:\"language\";s:7:\"handler\";s:19:\"views_handler_field\";s:14:\"click sortable\";b:1;}s:4:\"sort\";a:2:{s:10:\"real field\";s:8:\"language\";s:7:\"handler\";s:18:\"views_handler_sort\";}s:6:\"filter\";a:2:{s:10:\"real field\";s:8:\"language\";s:7:\"handler\";s:27:\"views_handler_filter_string\";}s:8:\"argument\";a:2:{s:10:\"real field\";s:8:\"language\";s:7:\"handler\";s:29:\"views_handler_argument_string\";}}s:4:\"user\";a:7:{s:12:\"relationship\";a:5:{s:5:\"label\";s:4:\"User\";s:7:\"handler\";s:26:\"views_handler_relationship\";s:4:\"base\";s:5:\"users\";s:10:\"base field\";s:3:\"uid\";s:18:\"relationship field\";s:3:\"uid\";}s:5:\"title\";s:8:\"User uid\";s:4:\"help\";s:38:\"The user for which to log the message.\";s:5:\"field\";a:4:{s:10:\"real field\";s:3:\"uid\";s:7:\"handler\";s:27:\"views_handler_field_numeric\";s:14:\"click sortable\";b:1;s:5:\"float\";b:0;}s:4:\"sort\";a:2:{s:10:\"real field\";s:3:\"uid\";s:7:\"handler\";s:18:\"views_handler_sort\";}s:6:\"filter\";a:2:{s:10:\"real field\";s:3:\"uid\";s:7:\"handler\";s:28:\"views_handler_filter_numeric\";}s:8:\"argument\";a:2:{s:10:\"real field\";s:3:\"uid\";s:7:\"handler\";s:30:\"views_handler_argument_numeric\";}}s:14:\"message_render\";a:1:{s:5:\"field\";a:4:{s:5:\"title\";s:25:\"Render message (Get text)\";s:10:\"real field\";s:3:\"mid\";s:4:\"help\";s:63:\"Show the message by replacing any tokens with their real value.\";s:7:\"handler\";s:36:\"message_handler_field_message_render\";}}s:13:\"type_category\";a:3:{s:5:\"title\";s:16:\"Message category\";s:4:\"help\";s:41:\"Filter messages by message type category.\";s:6:\"filter\";a:2:{s:7:\"handler\";s:44:\"message_handler_filter_message_type_category\";s:10:\"real field\";s:4:\"type\";}}s:14:\"votingapi_vote\";a:1:{s:12:\"relationship\";a:7:{s:5:\"title\";s:5:\"Votes\";s:4:\"help\";s:31:\"Votes cast by users on Message.\";s:4:\"base\";s:14:\"votingapi_vote\";s:5:\"field\";s:9:\"entity_id\";s:18:\"relationship field\";s:3:\"mid\";s:7:\"handler\";s:36:\"votingapi_views_handler_relationship\";s:5:\"extra\";a:1:{i:0;a:3:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:7:\"message\";s:7:\"numeric\";b:0;}}}}s:15:\"votingapi_cache\";a:1:{s:12:\"relationship\";a:7:{s:5:\"title\";s:12:\"Vote results\";s:4:\"help\";s:43:\"Aggregate results of votes cast on Message.\";s:4:\"base\";s:15:\"votingapi_cache\";s:5:\"field\";s:9:\"entity_id\";s:18:\"relationship field\";s:3:\"mid\";s:7:\"handler\";s:36:\"votingapi_views_handler_relationship\";s:5:\"extra\";a:1:{i:0;a:3:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:7:\"message\";s:7:\"numeric\";b:0;}}}}}s:4:\"node\";a:53:{s:13:\"date_argument\";a:4:{s:5:\"group\";s:4:\"Date\";s:5:\"title\";s:11:\"Date (node)\";s:4:\"help\";s:165:\"Filter any Views node date field by a date argument, using any common ISO date/period format (i.e. YYYY, YYYY-MM, YYYY-MM-DD, YYYY-W99, YYYY-MM-DD--P3M, P90D, etc). \";s:8:\"argument\";a:3:{s:7:\"handler\";s:27:\"date_views_argument_handler\";s:16:\"empty field name\";s:7:\"Undated\";s:7:\"is date\";b:1;}}s:11:\"date_filter\";a:4:{s:5:\"group\";s:4:\"Date\";s:5:\"title\";s:11:\"Date (node)\";s:4:\"help\";s:33:\"Filter any Views node date field.\";s:6:\"filter\";a:3:{s:7:\"handler\";s:25:\"date_views_filter_handler\";s:16:\"empty field name\";s:7:\"Undated\";s:7:\"is date\";b:1;}}s:5:\"table\";a:5:{s:5:\"group\";s:7:\"Content\";s:4:\"base\";a:5:{s:5:\"field\";s:3:\"nid\";s:5:\"title\";s:7:\"Content\";s:6:\"weight\";i:-10;s:16:\"access query tag\";s:11:\"node_access\";s:8:\"defaults\";a:1:{s:5:\"field\";s:5:\"title\";}}s:11:\"entity type\";s:4:\"node\";s:20:\"default_relationship\";a:1:{s:13:\"node_revision\";a:2:{s:5:\"table\";s:13:\"node_revision\";s:5:\"field\";s:3:\"vid\";}}s:4:\"join\";a:1:{s:19:\"webform_submissions\";a:3:{s:5:\"field\";s:3:\"nid\";s:10:\"left_field\";s:3:\"nid\";s:10:\"left_table\";s:19:\"webform_submissions\";}}}s:3:\"nid\";a:6:{s:5:\"title\";s:3:\"Nid\";s:4:\"help\";s:12:\"The node ID.\";s:5:\"field\";a:2:{s:7:\"handler\";s:24:\"views_handler_field_node\";s:14:\"click sortable\";b:1;}s:8:\"argument\";a:4:{s:7:\"handler\";s:31:\"views_handler_argument_node_nid\";s:10:\"name field\";s:5:\"title\";s:7:\"numeric\";b:1;s:13:\"validate type\";s:3:\"nid\";}s:6:\"filter\";a:1:{s:7:\"handler\";s:28:\"views_handler_filter_numeric\";}s:4:\"sort\";a:1:{s:7:\"handler\";s:18:\"views_handler_sort\";}}s:5:\"title\";a:6:{s:5:\"title\";s:5:\"Title\";s:4:\"help\";s:18:\"The content title.\";s:5:\"field\";a:5:{s:5:\"field\";s:5:\"title\";s:5:\"group\";s:7:\"Content\";s:7:\"handler\";s:24:\"views_handler_field_node\";s:14:\"click sortable\";b:1;s:20:\"link_to_node default\";b:1;}s:4:\"sort\";a:1:{s:7:\"handler\";s:18:\"views_handler_sort\";}s:6:\"filter\";a:1:{s:7:\"handler\";s:27:\"views_handler_filter_string\";}s:8:\"argument\";a:1:{s:7:\"handler\";s:29:\"views_handler_argument_string\";}}s:7:\"created\";a:5:{s:5:\"title\";s:9:\"Post date\";s:4:\"help\";s:32:\"The date the content was posted.\";s:5:\"field\";a:3:{s:7:\"handler\";s:24:\"views_handler_field_date\";s:14:\"click sortable\";b:1;s:7:\"is date\";b:1;}s:4:\"sort\";a:2:{s:7:\"handler\";s:23:\"views_handler_sort_date\";s:7:\"is date\";b:1;}s:6:\"filter\";a:2:{s:7:\"handler\";s:25:\"views_handler_filter_date\";s:7:\"is date\";b:1;}}s:7:\"changed\";a:5:{s:5:\"title\";s:12:\"Updated date\";s:4:\"help\";s:38:\"The date the content was last updated.\";s:5:\"field\";a:3:{s:7:\"handler\";s:24:\"views_handler_field_date\";s:14:\"click sortable\";b:1;s:7:\"is date\";b:1;}s:4:\"sort\";a:2:{s:7:\"handler\";s:23:\"views_handler_sort_date\";s:7:\"is date\";b:1;}s:6:\"filter\";a:2:{s:7:\"handler\";s:25:\"views_handler_filter_date\";s:7:\"is date\";b:1;}}s:4:\"type\";a:6:{s:5:\"title\";s:4:\"Type\";s:4:\"help\";s:73:\"The content type (for example, \"blog entry\", \"forum post\", \"story\", etc).\";s:5:\"field\";a:2:{s:7:\"handler\";s:29:\"views_handler_field_node_type\";s:14:\"click sortable\";b:1;}s:4:\"sort\";a:1:{s:7:\"handler\";s:18:\"views_handler_sort\";}s:6:\"filter\";a:1:{s:7:\"handler\";s:30:\"views_handler_filter_node_type\";}s:8:\"argument\";a:1:{s:7:\"handler\";s:32:\"views_handler_argument_node_type\";}}s:6:\"status\";a:5:{s:5:\"title\";s:9:\"Published\";s:4:\"help\";s:40:\"Whether or not the content is published.\";s:5:\"field\";a:3:{s:7:\"handler\";s:27:\"views_handler_field_boolean\";s:14:\"click sortable\";b:1;s:14:\"output formats\";a:1:{s:22:\"published-notpublished\";a:2:{i:0;s:9:\"Published\";i:1;s:13:\"Not published\";}}}s:6:\"filter\";a:4:{s:7:\"handler\";s:37:\"views_handler_filter_boolean_operator\";s:5:\"label\";s:9:\"Published\";s:4:\"type\";s:6:\"yes-no\";s:9:\"use equal\";b:1;}s:4:\"sort\";a:1:{s:7:\"handler\";s:18:\"views_handler_sort\";}}s:12:\"status_extra\";a:3:{s:5:\"title\";s:18:\"Published or admin\";s:4:\"help\";s:67:\"Filters out unpublished content if the current user cannot view it.\";s:6:\"filter\";a:3:{s:5:\"field\";s:6:\"status\";s:7:\"handler\";s:32:\"views_handler_filter_node_status\";s:5:\"label\";s:18:\"Published or admin\";}}s:7:\"promote\";a:5:{s:5:\"title\";s:22:\"Promoted to front page\";s:4:\"help\";s:57:\"Whether or not the content is promoted to the front page.\";s:5:\"field\";a:3:{s:7:\"handler\";s:27:\"views_handler_field_boolean\";s:14:\"click sortable\";b:1;s:14:\"output formats\";a:1:{s:20:\"promoted-notpromoted\";a:2:{i:0;s:8:\"Promoted\";i:1;s:12:\"Not promoted\";}}}s:6:\"filter\";a:3:{s:7:\"handler\";s:37:\"views_handler_filter_boolean_operator\";s:5:\"label\";s:22:\"Promoted to front page\";s:4:\"type\";s:6:\"yes-no\";}s:4:\"sort\";a:1:{s:7:\"handler\";s:18:\"views_handler_sort\";}}s:6:\"sticky\";a:5:{s:5:\"title\";s:6:\"Sticky\";s:4:\"help\";s:37:\"Whether or not the content is sticky.\";s:5:\"field\";a:3:{s:7:\"handler\";s:27:\"views_handler_field_boolean\";s:14:\"click sortable\";b:1;s:14:\"output formats\";a:1:{s:6:\"sticky\";a:2:{i:0;s:6:\"Sticky\";i:1;s:10:\"Not sticky\";}}}s:6:\"filter\";a:3:{s:7:\"handler\";s:37:\"views_handler_filter_boolean_operator\";s:5:\"label\";s:6:\"Sticky\";s:4:\"type\";s:6:\"yes-no\";}s:4:\"sort\";a:2:{s:7:\"handler\";s:18:\"views_handler_sort\";s:4:\"help\";s:91:\"Whether or not the content is sticky. To list sticky content first, set this to descending.\";}}s:9:\"view_node\";a:1:{s:8:\"moved to\";a:2:{i:0;s:17:\"views_entity_node\";i:1;s:9:\"view_node\";}}s:9:\"edit_node\";a:1:{s:8:\"moved to\";a:2:{i:0;s:17:\"views_entity_node\";i:1;s:9:\"edit_node\";}}s:11:\"delete_node\";a:1:{s:8:\"moved to\";a:2:{i:0;s:17:\"views_entity_node\";i:1;s:11:\"delete_node\";}}s:4:\"path\";a:1:{s:5:\"field\";a:3:{s:5:\"title\";s:4:\"Path\";s:4:\"help\";s:33:\"The aliased path to this content.\";s:7:\"handler\";s:29:\"views_handler_field_node_path\";}}s:16:\"created_fulldate\";a:3:{s:5:\"title\";s:12:\"Created date\";s:4:\"help\";s:29:\"Date in the form of CCYYMMDD.\";s:8:\"argument\";a:2:{s:5:\"field\";s:7:\"created\";s:7:\"handler\";s:44:\"views_handler_argument_node_created_fulldate\";}}s:18:\"created_year_month\";a:3:{s:5:\"title\";s:20:\"Created year + month\";s:4:\"help\";s:27:\"Date in the form of YYYYMM.\";s:8:\"argument\";a:2:{s:5:\"field\";s:7:\"created\";s:7:\"handler\";s:46:\"views_handler_argument_node_created_year_month\";}}s:12:\"created_year\";a:3:{s:5:\"title\";s:12:\"Created year\";s:4:\"help\";s:25:\"Date in the form of YYYY.\";s:8:\"argument\";a:2:{s:5:\"field\";s:7:\"created\";s:7:\"handler\";s:40:\"views_handler_argument_node_created_year\";}}s:13:\"created_month\";a:3:{s:5:\"title\";s:13:\"Created month\";s:4:\"help\";s:33:\"Date in the form of MM (01 - 12).\";s:8:\"argument\";a:2:{s:5:\"field\";s:7:\"created\";s:7:\"handler\";s:41:\"views_handler_argument_node_created_month\";}}s:11:\"created_day\";a:3:{s:5:\"title\";s:11:\"Created day\";s:4:\"help\";s:33:\"Date in the form of DD (01 - 31).\";s:8:\"argument\";a:2:{s:5:\"field\";s:7:\"created\";s:7:\"handler\";s:39:\"views_handler_argument_node_created_day\";}}s:12:\"created_week\";a:3:{s:5:\"title\";s:12:\"Created week\";s:4:\"help\";s:33:\"Date in the form of WW (01 - 53).\";s:8:\"argument\";a:2:{s:5:\"field\";s:7:\"created\";s:7:\"handler\";s:40:\"views_handler_argument_node_created_week\";}}s:16:\"changed_fulldate\";a:3:{s:5:\"title\";s:12:\"Updated date\";s:4:\"help\";s:29:\"Date in the form of CCYYMMDD.\";s:8:\"argument\";a:2:{s:5:\"field\";s:7:\"changed\";s:7:\"handler\";s:44:\"views_handler_argument_node_created_fulldate\";}}s:18:\"changed_year_month\";a:3:{s:5:\"title\";s:20:\"Updated year + month\";s:4:\"help\";s:27:\"Date in the form of YYYYMM.\";s:8:\"argument\";a:2:{s:5:\"field\";s:7:\"changed\";s:7:\"handler\";s:46:\"views_handler_argument_node_created_year_month\";}}s:12:\"changed_year\";a:3:{s:5:\"title\";s:12:\"Updated year\";s:4:\"help\";s:25:\"Date in the form of YYYY.\";s:8:\"argument\";a:2:{s:5:\"field\";s:7:\"changed\";s:7:\"handler\";s:40:\"views_handler_argument_node_created_year\";}}s:13:\"changed_month\";a:3:{s:5:\"title\";s:13:\"Updated month\";s:4:\"help\";s:33:\"Date in the form of MM (01 - 12).\";s:8:\"argument\";a:2:{s:5:\"field\";s:7:\"changed\";s:7:\"handler\";s:41:\"views_handler_argument_node_created_month\";}}s:11:\"changed_day\";a:3:{s:5:\"title\";s:11:\"Updated day\";s:4:\"help\";s:33:\"Date in the form of DD (01 - 31).\";s:8:\"argument\";a:2:{s:5:\"field\";s:7:\"changed\";s:7:\"handler\";s:39:\"views_handler_argument_node_created_day\";}}s:12:\"changed_week\";a:3:{s:5:\"title\";s:12:\"Updated week\";s:4:\"help\";s:33:\"Date in the form of WW (01 - 53).\";s:8:\"argument\";a:2:{s:5:\"field\";s:7:\"changed\";s:7:\"handler\";s:40:\"views_handler_argument_node_created_week\";}}s:3:\"uid\";a:6:{s:5:\"title\";s:10:\"Author uid\";s:4:\"help\";s:105:\"The user authoring the content. If you need more fields than the uid add the content: author relationship\";s:12:\"relationship\";a:6:{s:5:\"title\";s:6:\"Author\";s:4:\"help\";s:42:\"Relate content to the user who created it.\";s:7:\"handler\";s:26:\"views_handler_relationship\";s:4:\"base\";s:5:\"users\";s:5:\"field\";s:3:\"uid\";s:5:\"label\";s:6:\"author\";}s:6:\"filter\";a:1:{s:7:\"handler\";s:30:\"views_handler_filter_user_name\";}s:8:\"argument\";a:1:{s:7:\"handler\";s:30:\"views_handler_argument_numeric\";}s:5:\"field\";a:1:{s:7:\"handler\";s:24:\"views_handler_field_user\";}}s:12:\"uid_revision\";a:5:{s:5:\"title\";s:19:\"User has a revision\";s:4:\"help\";s:45:\"All nodes where a certain user has a revision\";s:10:\"real field\";s:3:\"nid\";s:6:\"filter\";a:1:{s:7:\"handler\";s:38:\"views_handler_filter_node_uid_revision\";}s:8:\"argument\";a:1:{s:7:\"handler\";s:40:\"views_handler_argument_node_uid_revision\";}}s:13:\"version_count\";a:5:{s:5:\"title\";s:13:\"Version Count\";s:4:\"help\";s:56:\"The total count of versions/revisions of a certain node.\";s:5:\"field\";a:3:{s:7:\"handler\";s:38:\"views_handler_field_node_version_count\";s:5:\"field\";s:3:\"nid\";s:14:\"click sortable\";b:1;}s:6:\"filter\";a:2:{s:7:\"handler\";s:39:\"views_handler_filter_node_version_count\";s:11:\"allow empty\";b:0;}s:4:\"sort\";a:1:{s:7:\"handler\";s:37:\"views_handler_sort_node_version_count\";}}s:9:\"sharethis\";a:3:{s:5:\"title\";s:14:\"ShareThis Link\";s:4:\"help\";s:39:\"Link provided by the ShareThis service.\";s:5:\"field\";a:2:{s:7:\"handler\";s:28:\"sharethis_handler_field_link\";s:14:\"click sortable\";b:0;}}s:18:\"webform_submission\";a:4:{s:5:\"title\";s:18:\"Webform submission\";s:4:\"help\";s:46:\"Webform submissions of the given Webform node.\";s:10:\"real field\";s:3:\"nid\";s:12:\"relationship\";a:4:{s:4:\"base\";s:19:\"webform_submissions\";s:10:\"base field\";s:3:\"nid\";s:7:\"handler\";s:26:\"views_handler_relationship\";s:5:\"label\";s:18:\"Webform Submission\";}}s:29:\"webform_submission_count_node\";a:2:{s:5:\"group\";s:7:\"Webform\";s:5:\"field\";a:4:{s:5:\"title\";s:24:\"Webform submission count\";s:4:\"help\";s:47:\"The number of webform submissions on this node.\";s:7:\"handler\";s:38:\"webform_handler_field_submission_count\";s:10:\"count_type\";s:4:\"node\";}}s:12:\"webform_edit\";a:2:{s:5:\"group\";s:7:\"Webform\";s:5:\"field\";a:3:{s:5:\"title\";s:17:\"Webform edit link\";s:4:\"help\";s:71:\"Provide a simple link to edit the webform components and configuration.\";s:7:\"handler\";s:36:\"webform_handler_field_node_link_edit\";}}s:15:\"webform_results\";a:2:{s:5:\"group\";s:7:\"Webform\";s:5:\"field\";a:3:{s:5:\"title\";s:20:\"Webform results link\";s:4:\"help\";s:55:\"Provide a simple link to view the results of a webform.\";s:7:\"handler\";s:39:\"webform_handler_field_node_link_results\";}}s:17:\"webform_form_body\";a:2:{s:5:\"group\";s:7:\"Webform\";s:5:\"field\";a:3:{s:5:\"title\";s:17:\"Webform form body\";s:4:\"help\";s:44:\"The Webform form body display for this node.\";s:7:\"handler\";s:31:\"webform_handler_field_form_body\";}}s:12:\"new_comments\";a:3:{s:5:\"title\";s:12:\"New comments\";s:4:\"help\";s:39:\"The number of new comments on the node.\";s:5:\"field\";a:2:{s:7:\"handler\";s:37:\"views_handler_field_node_new_comments\";s:11:\"no group by\";b:1;}}s:13:\"comments_link\";a:1:{s:5:\"field\";a:3:{s:5:\"title\";s:16:\"Add comment link\";s:4:\"help\";s:133:\"Display the standard add comment link used on regular nodes, which will only display if the viewing user has access to add a comment.\";s:7:\"handler\";s:37:\"views_handler_field_comment_node_link\";}}s:7:\"comment\";a:5:{s:5:\"title\";s:14:\"Comment status\";s:4:\"help\";s:53:\"Whether comments are enabled or disabled on the node.\";s:5:\"field\";a:2:{s:7:\"handler\";s:32:\"views_handler_field_node_comment\";s:14:\"click sortable\";b:1;}s:4:\"sort\";a:1:{s:7:\"handler\";s:18:\"views_handler_sort\";}s:6:\"filter\";a:1:{s:7:\"handler\";s:33:\"views_handler_filter_node_comment\";}}s:9:\"uid_touch\";a:4:{s:5:\"title\";s:24:\"User posted or commented\";s:4:\"help\";s:70:\"Display nodes only if a user posted the node or commented on the node.\";s:8:\"argument\";a:5:{s:5:\"field\";s:3:\"uid\";s:10:\"name table\";s:5:\"users\";s:10:\"name field\";s:4:\"name\";s:7:\"handler\";s:39:\"views_handler_argument_comment_user_uid\";s:11:\"no group by\";b:1;}s:6:\"filter\";a:4:{s:5:\"field\";s:3:\"uid\";s:10:\"name table\";s:5:\"users\";s:10:\"name field\";s:4:\"name\";s:7:\"handler\";s:37:\"views_handler_filter_comment_user_uid\";}}s:3:\"cid\";a:3:{s:5:\"title\";s:20:\"Comments of the node\";s:4:\"help\";s:151:\"Relate all comments on the node. This will create 1 duplicate record for every comment. Usually if you need this it is better to create a comment view.\";s:12:\"relationship\";a:6:{s:5:\"group\";s:7:\"Comment\";s:5:\"label\";s:8:\"Comments\";s:4:\"base\";s:7:\"comment\";s:10:\"base field\";s:3:\"nid\";s:18:\"relationship field\";s:3:\"nid\";s:7:\"handler\";s:26:\"views_handler_relationship\";}}s:30:\"reverse_field_node_ref_message\";a:1:{s:12:\"relationship\";a:11:{s:7:\"handler\";s:41:\"views_handler_relationship_entity_reverse\";s:10:\"field_name\";s:14:\"field_node_ref\";s:11:\"field table\";s:25:\"field_data_field_node_ref\";s:11:\"field field\";s:24:\"field_node_ref_target_id\";s:4:\"base\";s:7:\"message\";s:10:\"base field\";s:3:\"mid\";s:5:\"label\";s:47:\"Message referencing Content from field_node_ref\";s:5:\"group\";s:16:\"Entity Reference\";s:5:\"title\";s:18:\"Referencing entity\";s:4:\"help\";s:77:\"A bridge to the Message entity that is referencing Content via field_node_ref\";s:10:\"join_extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:7:\"message\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}s:8:\"language\";a:6:{s:5:\"title\";s:8:\"Language\";s:4:\"help\";s:31:\"The language the content is in.\";s:5:\"field\";a:2:{s:7:\"handler\";s:33:\"views_handler_field_node_language\";s:14:\"click sortable\";b:1;}s:6:\"filter\";a:1:{s:7:\"handler\";s:34:\"views_handler_filter_node_language\";}s:8:\"argument\";a:1:{s:7:\"handler\";s:36:\"views_handler_argument_node_language\";}s:4:\"sort\";a:1:{s:7:\"handler\";s:18:\"views_handler_sort\";}}s:17:\"specific_language\";a:3:{s:5:\"title\";s:17:\"Specific language\";s:4:\"help\";s:51:\"Sort by a specific language that the content is in.\";s:4:\"sort\";a:1:{s:7:\"handler\";s:32:\"views_handler_sort_node_language\";}}s:13:\"term_node_tid\";a:4:{s:5:\"title\";s:22:\"Taxonomy terms on node\";s:4:\"help\";s:161:\"Relate nodes to taxonomy terms, specifiying which vocabulary or vocabularies to use. This relationship will cause duplicated records if there are multiple terms.\";s:12:\"relationship\";a:3:{s:7:\"handler\";s:41:\"views_handler_relationship_node_term_data\";s:5:\"label\";s:4:\"term\";s:4:\"base\";s:18:\"taxonomy_term_data\";}s:5:\"field\";a:4:{s:5:\"title\";s:18:\"All taxonomy terms\";s:4:\"help\";s:78:\"Display all taxonomy terms associated with a node from specified vocabularies.\";s:7:\"handler\";s:33:\"views_handler_field_term_node_tid\";s:11:\"no group by\";b:1;}}s:19:\"term_node_tid_depth\";a:4:{s:4:\"help\";s:175:\"Display content if it has the selected taxonomy terms, or children of the selected terms. Due to additional complexity, this has fewer options than the versions without depth.\";s:10:\"real field\";s:3:\"nid\";s:8:\"argument\";a:3:{s:5:\"title\";s:33:\"Has taxonomy term ID (with depth)\";s:7:\"handler\";s:42:\"views_handler_argument_term_node_tid_depth\";s:21:\"accept depth modifier\";b:1;}s:6:\"filter\";a:2:{s:5:\"title\";s:31:\"Has taxonomy terms (with depth)\";s:7:\"handler\";s:40:\"views_handler_filter_term_node_tid_depth\";}}s:24:\"term_node_tid_depth_join\";a:4:{s:4:\"help\";s:175:\"Display content if it has the selected taxonomy terms, or children of the selected terms. Due to additional complexity, this has fewer options than the versions without depth.\";s:10:\"real field\";s:3:\"nid\";s:8:\"argument\";a:3:{s:5:\"title\";s:45:\"Has taxonomy term ID with depth (using joins)\";s:7:\"handler\";s:47:\"views_handler_argument_term_node_tid_depth_join\";s:21:\"accept depth modifier\";b:1;}s:6:\"filter\";a:2:{s:5:\"title\";s:43:\"Has taxonomy terms with depth (using joins)\";s:7:\"handler\";s:45:\"views_handler_filter_term_node_tid_depth_join\";}}s:28:\"term_node_tid_depth_modifier\";a:3:{s:5:\"title\";s:35:\"Has taxonomy term ID depth modifier\";s:4:\"help\";s:111:\"Allows the \"depth\" for Taxonomy: Term ID (with depth) to be modified via an additional contextual filter value.\";s:8:\"argument\";a:1:{s:7:\"handler\";s:51:\"views_handler_argument_term_node_tid_depth_modifier\";}}s:14:\"votingapi_vote\";a:1:{s:12:\"relationship\";a:7:{s:5:\"title\";s:5:\"Votes\";s:4:\"help\";s:28:\"Votes cast by users on Node.\";s:4:\"base\";s:14:\"votingapi_vote\";s:5:\"field\";s:9:\"entity_id\";s:18:\"relationship field\";s:3:\"nid\";s:7:\"handler\";s:36:\"votingapi_views_handler_relationship\";s:5:\"extra\";a:1:{i:0;a:3:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";s:7:\"numeric\";b:0;}}}}s:15:\"votingapi_cache\";a:1:{s:12:\"relationship\";a:7:{s:5:\"title\";s:12:\"Vote results\";s:4:\"help\";s:40:\"Aggregate results of votes cast on Node.\";s:4:\"base\";s:15:\"votingapi_cache\";s:5:\"field\";s:9:\"entity_id\";s:18:\"relationship field\";s:3:\"nid\";s:7:\"handler\";s:36:\"votingapi_views_handler_relationship\";s:5:\"extra\";a:1:{i:0;a:3:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";s:7:\"numeric\";b:0;}}}}s:10:\"topic_icon\";a:3:{s:5:\"title\";s:10:\"Topic Icon\";s:4:\"help\";s:52:\"Icon that shows new posts, hot, sticky, locked, etc.\";s:5:\"field\";a:1:{s:7:\"handler\";s:44:\"advanced_forum_handler_field_node_topic_icon\";}}s:11:\"topic_pager\";a:3:{s:5:\"title\";s:11:\"Topic Pager\";s:4:\"help\";s:34:\"Small pager for individual topics.\";s:5:\"field\";a:1:{s:7:\"handler\";s:45:\"advanced_forum_handler_field_node_topic_pager\";}}}s:13:\"node_revision\";a:12:{s:13:\"date_argument\";a:4:{s:5:\"group\";s:4:\"Date\";s:5:\"title\";s:20:\"Date (node_revision)\";s:4:\"help\";s:174:\"Filter any Views node_revision date field by a date argument, using any common ISO date/period format (i.e. YYYY, YYYY-MM, YYYY-MM-DD, YYYY-W99, YYYY-MM-DD--P3M, P90D, etc). \";s:8:\"argument\";a:3:{s:7:\"handler\";s:27:\"date_views_argument_handler\";s:16:\"empty field name\";s:7:\"Undated\";s:7:\"is date\";b:1;}}s:11:\"date_filter\";a:4:{s:5:\"group\";s:4:\"Date\";s:5:\"title\";s:20:\"Date (node_revision)\";s:4:\"help\";s:42:\"Filter any Views node_revision date field.\";s:6:\"filter\";a:3:{s:7:\"handler\";s:25:\"date_views_filter_handler\";s:16:\"empty field name\";s:7:\"Undated\";s:7:\"is date\";b:1;}}s:5:\"table\";a:6:{s:11:\"entity type\";s:4:\"node\";s:8:\"revision\";b:1;s:5:\"group\";s:16:\"Content revision\";s:4:\"base\";a:4:{s:5:\"field\";s:3:\"vid\";s:5:\"title\";s:16:\"Content revision\";s:4:\"help\";s:52:\"Content revision is a history of changes to content.\";s:8:\"defaults\";a:1:{s:5:\"field\";s:5:\"title\";}}s:4:\"join\";a:1:{s:4:\"node\";a:2:{s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:3:\"vid\";}}s:20:\"default_relationship\";a:1:{s:4:\"node\";a:2:{s:5:\"table\";s:4:\"node\";s:5:\"field\";s:3:\"nid\";}}}s:3:\"uid\";a:3:{s:5:\"title\";s:4:\"User\";s:4:\"help\";s:63:\"Relate a content revision to the user who created the revision.\";s:12:\"relationship\";a:4:{s:7:\"handler\";s:26:\"views_handler_relationship\";s:4:\"base\";s:5:\"users\";s:10:\"base field\";s:3:\"uid\";s:5:\"label\";s:13:\"revision user\";}}s:3:\"nid\";a:7:{s:5:\"title\";s:3:\"Nid\";s:4:\"help\";s:41:\"The revision NID of the content revision.\";s:5:\"field\";a:1:{s:14:\"click sortable\";b:1;}s:8:\"argument\";a:3:{s:7:\"handler\";s:31:\"views_handler_argument_node_nid\";s:14:\"click sortable\";b:1;s:7:\"numeric\";b:1;}s:6:\"filter\";a:1:{s:7:\"handler\";s:28:\"views_handler_filter_numeric\";}s:4:\"sort\";a:1:{s:7:\"handler\";s:18:\"views_handler_sort\";}s:12:\"relationship\";a:5:{s:7:\"handler\";s:26:\"views_handler_relationship\";s:4:\"base\";s:4:\"node\";s:10:\"base field\";s:3:\"nid\";s:5:\"title\";s:7:\"Content\";s:5:\"label\";s:47:\"Get the actual content from a content revision.\";}}s:3:\"vid\";a:7:{s:5:\"title\";s:3:\"Vid\";s:4:\"help\";s:40:\"The revision ID of the content revision.\";s:5:\"field\";a:1:{s:14:\"click sortable\";b:1;}s:8:\"argument\";a:3:{s:7:\"handler\";s:31:\"views_handler_argument_node_vid\";s:14:\"click sortable\";b:1;s:7:\"numeric\";b:1;}s:6:\"filter\";a:1:{s:7:\"handler\";s:28:\"views_handler_filter_numeric\";}s:4:\"sort\";a:1:{s:7:\"handler\";s:18:\"views_handler_sort\";}s:12:\"relationship\";a:5:{s:7:\"handler\";s:26:\"views_handler_relationship\";s:4:\"base\";s:4:\"node\";s:10:\"base field\";s:3:\"vid\";s:5:\"title\";s:7:\"Content\";s:5:\"label\";s:47:\"Get the actual content from a content revision.\";}}s:5:\"title\";a:6:{s:5:\"title\";s:5:\"Title\";s:4:\"help\";s:18:\"The content title.\";s:5:\"field\";a:3:{s:5:\"field\";s:5:\"title\";s:7:\"handler\";s:33:\"views_handler_field_node_revision\";s:14:\"click sortable\";b:1;}s:4:\"sort\";a:1:{s:7:\"handler\";s:18:\"views_handler_sort\";}s:6:\"filter\";a:1:{s:7:\"handler\";s:27:\"views_handler_filter_string\";}s:8:\"argument\";a:1:{s:7:\"handler\";s:29:\"views_handler_argument_string\";}}s:3:\"log\";a:4:{s:5:\"title\";s:11:\"Log message\";s:4:\"help\";s:54:\"The log message entered when the revision was created.\";s:5:\"field\";a:1:{s:7:\"handler\";s:23:\"views_handler_field_xss\";}s:6:\"filter\";a:1:{s:7:\"handler\";s:27:\"views_handler_filter_string\";}}s:9:\"timestamp\";a:5:{s:5:\"title\";s:12:\"Updated date\";s:4:\"help\";s:35:\"The date the node was last updated.\";s:5:\"field\";a:3:{s:7:\"handler\";s:24:\"views_handler_field_date\";s:14:\"click sortable\";b:1;s:7:\"is date\";b:1;}s:4:\"sort\";a:2:{s:7:\"handler\";s:23:\"views_handler_sort_date\";s:7:\"is date\";b:1;}s:6:\"filter\";a:2:{s:7:\"handler\";s:25:\"views_handler_filter_date\";s:7:\"is date\";b:1;}}s:16:\"link_to_revision\";a:1:{s:5:\"field\";a:3:{s:5:\"title\";s:4:\"Link\";s:4:\"help\";s:38:\"Provide a simple link to the revision.\";s:7:\"handler\";s:38:\"views_handler_field_node_revision_link\";}}s:15:\"revert_revision\";a:1:{s:5:\"field\";a:3:{s:5:\"title\";s:11:\"Revert link\";s:4:\"help\";s:48:\"Provide a simple link to revert to the revision.\";s:7:\"handler\";s:45:\"views_handler_field_node_revision_link_revert\";}}s:15:\"delete_revision\";a:1:{s:5:\"field\";a:3:{s:5:\"title\";s:11:\"Delete link\";s:4:\"help\";s:53:\"Provide a simple link to delete the content revision.\";s:7:\"handler\";s:45:\"views_handler_field_node_revision_link_delete\";}}}s:12:\"file_managed\";a:16:{s:13:\"date_argument\";a:4:{s:5:\"group\";s:4:\"Date\";s:5:\"title\";s:19:\"Date (file_managed)\";s:4:\"help\";s:173:\"Filter any Views file_managed date field by a date argument, using any common ISO date/period format (i.e. YYYY, YYYY-MM, YYYY-MM-DD, YYYY-W99, YYYY-MM-DD--P3M, P90D, etc). \";s:8:\"argument\";a:3:{s:7:\"handler\";s:27:\"date_views_argument_handler\";s:16:\"empty field name\";s:7:\"Undated\";s:7:\"is date\";b:1;}}s:11:\"date_filter\";a:4:{s:5:\"group\";s:4:\"Date\";s:5:\"title\";s:19:\"Date (file_managed)\";s:4:\"help\";s:41:\"Filter any Views file_managed date field.\";s:6:\"filter\";a:3:{s:7:\"handler\";s:25:\"date_views_filter_handler\";s:16:\"empty field name\";s:7:\"Undated\";s:7:\"is date\";b:1;}}s:5:\"table\";a:3:{s:5:\"group\";s:4:\"File\";s:4:\"base\";a:4:{s:5:\"field\";s:3:\"fid\";s:5:\"title\";s:4:\"File\";s:4:\"help\";s:47:\"Files maintained by Drupal and various modules.\";s:8:\"defaults\";a:1:{s:5:\"field\";s:8:\"filename\";}}s:11:\"entity type\";s:4:\"file\";}s:3:\"fid\";a:6:{s:5:\"title\";s:7:\"File ID\";s:4:\"help\";s:19:\"The ID of the file.\";s:5:\"field\";a:2:{s:7:\"handler\";s:24:\"views_handler_field_file\";s:14:\"click sortable\";b:1;}s:8:\"argument\";a:3:{s:7:\"handler\";s:31:\"views_handler_argument_file_fid\";s:10:\"name field\";s:8:\"filename\";s:7:\"numeric\";b:1;}s:6:\"filter\";a:1:{s:7:\"handler\";s:28:\"views_handler_filter_numeric\";}s:4:\"sort\";a:1:{s:7:\"handler\";s:18:\"views_handler_sort\";}}s:8:\"filename\";a:6:{s:5:\"title\";s:4:\"Name\";s:4:\"help\";s:21:\"The name of the file.\";s:5:\"field\";a:2:{s:7:\"handler\";s:24:\"views_handler_field_file\";s:14:\"click sortable\";b:1;}s:4:\"sort\";a:1:{s:7:\"handler\";s:18:\"views_handler_sort\";}s:6:\"filter\";a:1:{s:7:\"handler\";s:27:\"views_handler_filter_string\";}s:8:\"argument\";a:1:{s:7:\"handler\";s:29:\"views_handler_argument_string\";}}s:3:\"uri\";a:6:{s:5:\"title\";s:4:\"Path\";s:4:\"help\";s:21:\"The path of the file.\";s:5:\"field\";a:2:{s:7:\"handler\";s:28:\"views_handler_field_file_uri\";s:14:\"click sortable\";b:1;}s:4:\"sort\";a:1:{s:7:\"handler\";s:18:\"views_handler_sort\";}s:6:\"filter\";a:1:{s:7:\"handler\";s:27:\"views_handler_filter_string\";}s:8:\"argument\";a:1:{s:7:\"handler\";s:29:\"views_handler_argument_string\";}}s:8:\"filemime\";a:6:{s:5:\"title\";s:9:\"Mime type\";s:4:\"help\";s:26:\"The mime type of the file.\";s:5:\"field\";a:2:{s:7:\"handler\";s:33:\"views_handler_field_file_filemime\";s:14:\"click sortable\";b:1;}s:4:\"sort\";a:1:{s:7:\"handler\";s:18:\"views_handler_sort\";}s:6:\"filter\";a:1:{s:7:\"handler\";s:27:\"views_handler_filter_string\";}s:8:\"argument\";a:1:{s:7:\"handler\";s:29:\"views_handler_argument_string\";}}s:9:\"extension\";a:4:{s:5:\"title\";s:9:\"Extension\";s:4:\"help\";s:26:\"The extension of the file.\";s:10:\"real field\";s:8:\"filename\";s:5:\"field\";a:2:{s:7:\"handler\";s:34:\"views_handler_field_file_extension\";s:14:\"click sortable\";b:0;}}s:8:\"filesize\";a:5:{s:5:\"title\";s:4:\"Size\";s:4:\"help\";s:21:\"The size of the file.\";s:5:\"field\";a:2:{s:7:\"handler\";s:29:\"views_handler_field_file_size\";s:14:\"click sortable\";b:1;}s:4:\"sort\";a:1:{s:7:\"handler\";s:18:\"views_handler_sort\";}s:6:\"filter\";a:1:{s:7:\"handler\";s:28:\"views_handler_filter_numeric\";}}s:6:\"status\";a:5:{s:5:\"title\";s:6:\"Status\";s:4:\"help\";s:23:\"The status of the file.\";s:5:\"field\";a:2:{s:7:\"handler\";s:31:\"views_handler_field_file_status\";s:14:\"click sortable\";b:1;}s:4:\"sort\";a:1:{s:7:\"handler\";s:18:\"views_handler_sort\";}s:6:\"filter\";a:1:{s:7:\"handler\";s:32:\"views_handler_filter_file_status\";}}s:9:\"timestamp\";a:5:{s:5:\"title\";s:11:\"Upload date\";s:4:\"help\";s:31:\"The date the file was uploaded.\";s:5:\"field\";a:3:{s:7:\"handler\";s:24:\"views_handler_field_date\";s:14:\"click sortable\";b:1;s:7:\"is date\";b:1;}s:4:\"sort\";a:2:{s:7:\"handler\";s:23:\"views_handler_sort_date\";s:7:\"is date\";b:1;}s:6:\"filter\";a:2:{s:7:\"handler\";s:25:\"views_handler_filter_date\";s:7:\"is date\";b:1;}}s:3:\"uid\";a:3:{s:5:\"title\";s:17:\"User who uploaded\";s:4:\"help\";s:32:\"The user that uploaded the file.\";s:12:\"relationship\";a:4:{s:5:\"title\";s:17:\"User who uploaded\";s:5:\"label\";s:17:\"User who uploaded\";s:4:\"base\";s:5:\"users\";s:10:\"base field\";s:3:\"uid\";}}s:24:\"reverse_field_image_node\";a:1:{s:12:\"relationship\";a:10:{s:5:\"title\";s:19:\"Content using Image\";s:4:\"help\";s:50:\"Relate each Content with a Image set to the image.\";s:7:\"handler\";s:41:\"views_handler_relationship_entity_reverse\";s:10:\"field_name\";s:11:\"field_image\";s:11:\"field table\";s:22:\"field_data_field_image\";s:11:\"field field\";s:15:\"field_image_fid\";s:4:\"base\";s:4:\"node\";s:10:\"base field\";s:3:\"nid\";s:5:\"label\";s:11:\"field_image\";s:10:\"join_extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}s:41:\"reverse_field_image_field_collection_item\";a:1:{s:12:\"relationship\";a:10:{s:5:\"title\";s:33:\"Field collection item using Image\";s:4:\"help\";s:64:\"Relate each Field collection item with a Image set to the image.\";s:7:\"handler\";s:41:\"views_handler_relationship_entity_reverse\";s:10:\"field_name\";s:11:\"field_image\";s:11:\"field table\";s:22:\"field_data_field_image\";s:11:\"field field\";s:15:\"field_image_fid\";s:4:\"base\";s:21:\"field_collection_item\";s:10:\"base field\";s:7:\"item_id\";s:5:\"label\";s:11:\"field_image\";s:10:\"join_extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:21:\"field_collection_item\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}s:14:\"votingapi_vote\";a:1:{s:12:\"relationship\";a:7:{s:5:\"title\";s:5:\"Votes\";s:4:\"help\";s:28:\"Votes cast by users on File.\";s:4:\"base\";s:14:\"votingapi_vote\";s:5:\"field\";s:9:\"entity_id\";s:18:\"relationship field\";s:3:\"fid\";s:7:\"handler\";s:36:\"votingapi_views_handler_relationship\";s:5:\"extra\";a:1:{i:0;a:3:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"file\";s:7:\"numeric\";b:0;}}}}s:15:\"votingapi_cache\";a:1:{s:12:\"relationship\";a:7:{s:5:\"title\";s:12:\"Vote results\";s:4:\"help\";s:40:\"Aggregate results of votes cast on File.\";s:4:\"base\";s:15:\"votingapi_cache\";s:5:\"field\";s:9:\"entity_id\";s:18:\"relationship field\";s:3:\"fid\";s:7:\"handler\";s:36:\"votingapi_views_handler_relationship\";s:5:\"extra\";a:1:{i:0;a:3:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"file\";s:7:\"numeric\";b:0;}}}}}s:18:\"taxonomy_term_data\";a:17:{s:13:\"date_argument\";a:4:{s:5:\"group\";s:4:\"Date\";s:5:\"title\";s:25:\"Date (taxonomy_term_data)\";s:4:\"help\";s:179:\"Filter any Views taxonomy_term_data date field by a date argument, using any common ISO date/period format (i.e. YYYY, YYYY-MM, YYYY-MM-DD, YYYY-W99, YYYY-MM-DD--P3M, P90D, etc). \";s:8:\"argument\";a:3:{s:7:\"handler\";s:27:\"date_views_argument_handler\";s:16:\"empty field name\";s:7:\"Undated\";s:7:\"is date\";b:1;}}s:11:\"date_filter\";a:4:{s:5:\"group\";s:4:\"Date\";s:5:\"title\";s:25:\"Date (taxonomy_term_data)\";s:4:\"help\";s:47:\"Filter any Views taxonomy_term_data date field.\";s:6:\"filter\";a:3:{s:7:\"handler\";s:25:\"date_views_filter_handler\";s:16:\"empty field name\";s:7:\"Undated\";s:7:\"is date\";b:1;}}s:5:\"table\";a:5:{s:5:\"group\";s:13:\"Taxonomy term\";s:4:\"base\";a:4:{s:5:\"field\";s:3:\"tid\";s:5:\"title\";s:4:\"Term\";s:4:\"help\";s:37:\"Taxonomy terms are attached to nodes.\";s:16:\"access query tag\";s:20:\"taxonomy_term_access\";}s:11:\"entity type\";s:13:\"taxonomy_term\";s:4:\"join\";a:2:{s:19:\"taxonomy_vocabulary\";a:2:{s:5:\"field\";s:3:\"vid\";s:10:\"left_field\";s:3:\"vid\";}s:14:\"taxonomy_index\";a:2:{s:5:\"field\";s:3:\"tid\";s:10:\"left_field\";s:3:\"tid\";}}s:20:\"default_relationship\";a:1:{s:4:\"node\";a:2:{s:5:\"table\";s:4:\"node\";s:5:\"field\";s:13:\"term_node_tid\";}}}s:3:\"tid\";a:6:{s:5:\"title\";s:7:\"Term ID\";s:4:\"help\";s:27:\"The tid of a taxonomy term.\";s:5:\"field\";a:2:{s:7:\"handler\";s:27:\"views_handler_field_numeric\";s:14:\"click sortable\";b:1;}s:4:\"sort\";a:1:{s:7:\"handler\";s:18:\"views_handler_sort\";}s:8:\"argument\";a:3:{s:7:\"handler\";s:31:\"views_handler_argument_taxonomy\";s:10:\"name field\";s:4:\"name\";s:12:\"zero is null\";b:1;}s:6:\"filter\";a:5:{s:5:\"title\";s:4:\"Term\";s:4:\"help\";s:56:\"Taxonomy term chosen from autocomplete or select widget.\";s:7:\"handler\";s:34:\"views_handler_filter_term_node_tid\";s:15:\"hierarchy table\";s:23:\"taxonomy_term_hierarchy\";s:7:\"numeric\";b:1;}}s:7:\"tid_raw\";a:4:{s:5:\"title\";s:7:\"Term ID\";s:4:\"help\";s:27:\"The tid of a taxonomy term.\";s:10:\"real field\";s:3:\"tid\";s:6:\"filter\";a:2:{s:7:\"handler\";s:28:\"views_handler_filter_numeric\";s:11:\"allow empty\";b:1;}}s:18:\"tid_representative\";a:1:{s:12:\"relationship\";a:10:{s:5:\"title\";s:19:\"Representative node\";s:5:\"label\";s:19:\"Representative node\";s:4:\"help\";s:89:\"Obtains a single representative node for each term, according to a chosen sort criterion.\";s:7:\"handler\";s:40:\"views_handler_relationship_groupwise_max\";s:18:\"relationship field\";s:3:\"tid\";s:11:\"outer field\";s:22:\"taxonomy_term_data.tid\";s:14:\"argument table\";s:18:\"taxonomy_term_data\";s:14:\"argument field\";s:3:\"tid\";s:4:\"base\";s:4:\"node\";s:5:\"field\";s:3:\"nid\";}}s:4:\"name\";a:6:{s:5:\"title\";s:4:\"Name\";s:4:\"help\";s:23:\"The taxonomy term name.\";s:5:\"field\";a:2:{s:7:\"handler\";s:28:\"views_handler_field_taxonomy\";s:14:\"click sortable\";b:1;}s:4:\"sort\";a:1:{s:7:\"handler\";s:18:\"views_handler_sort\";}s:6:\"filter\";a:2:{s:7:\"handler\";s:27:\"views_handler_filter_string\";s:4:\"help\";s:19:\"Taxonomy term name.\";}s:8:\"argument\";a:4:{s:7:\"handler\";s:29:\"views_handler_argument_string\";s:4:\"help\";s:19:\"Taxonomy term name.\";s:11:\"many to one\";b:1;s:16:\"empty field name\";s:13:\"Uncategorized\";}}s:6:\"weight\";a:6:{s:5:\"title\";s:6:\"Weight\";s:4:\"help\";s:21:\"The term weight field\";s:5:\"field\";a:2:{s:7:\"handler\";s:27:\"views_handler_field_numeric\";s:14:\"click sortable\";b:1;}s:4:\"sort\";a:1:{s:7:\"handler\";s:18:\"views_handler_sort\";}s:6:\"filter\";a:1:{s:7:\"handler\";s:28:\"views_handler_filter_numeric\";}s:8:\"argument\";a:1:{s:7:\"handler\";s:30:\"views_handler_argument_numeric\";}}s:11:\"description\";a:4:{s:5:\"title\";s:16:\"Term description\";s:4:\"help\";s:48:\"The description associated with a taxonomy term.\";s:5:\"field\";a:2:{s:7:\"handler\";s:26:\"views_handler_field_markup\";s:6:\"format\";a:1:{s:5:\"field\";s:6:\"format\";}}s:6:\"filter\";a:1:{s:7:\"handler\";s:27:\"views_handler_filter_string\";}}s:3:\"vid\";a:3:{s:5:\"title\";s:10:\"Vocabulary\";s:4:\"help\";s:66:\"Filter the results of \"Taxonomy: Term\" to a particular vocabulary.\";s:6:\"filter\";a:1:{s:7:\"handler\";s:35:\"views_handler_filter_vocabulary_vid\";}}s:9:\"edit_term\";a:1:{s:5:\"field\";a:3:{s:5:\"title\";s:14:\"Term edit link\";s:4:\"help\";s:39:\"Provide a simple link to edit the term.\";s:7:\"handler\";s:34:\"views_handler_field_term_link_edit\";}}s:23:\"reverse_field_tags_node\";a:1:{s:12:\"relationship\";a:10:{s:5:\"title\";s:18:\"Content using Tags\";s:4:\"help\";s:48:\"Relate each Content with a Tags set to the term.\";s:7:\"handler\";s:41:\"views_handler_relationship_entity_reverse\";s:10:\"field_name\";s:10:\"field_tags\";s:11:\"field table\";s:21:\"field_data_field_tags\";s:11:\"field field\";s:14:\"field_tags_tid\";s:4:\"base\";s:4:\"node\";s:10:\"base field\";s:3:\"nid\";s:5:\"label\";s:10:\"field_tags\";s:10:\"join_extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}s:28:\"reverse_taxonomy_forums_node\";a:1:{s:12:\"relationship\";a:10:{s:5:\"title\";s:20:\"Content using Forums\";s:4:\"help\";s:50:\"Relate each Content with a Forums set to the term.\";s:7:\"handler\";s:41:\"views_handler_relationship_entity_reverse\";s:10:\"field_name\";s:15:\"taxonomy_forums\";s:11:\"field table\";s:26:\"field_data_taxonomy_forums\";s:11:\"field field\";s:19:\"taxonomy_forums_tid\";s:4:\"base\";s:4:\"node\";s:10:\"base field\";s:3:\"nid\";s:5:\"label\";s:15:\"taxonomy_forums\";s:10:\"join_extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}s:26:\"reverse_field_section_node\";a:1:{s:12:\"relationship\";a:10:{s:5:\"title\";s:21:\"Content using Section\";s:4:\"help\";s:51:\"Relate each Content with a Section set to the term.\";s:7:\"handler\";s:41:\"views_handler_relationship_entity_reverse\";s:10:\"field_name\";s:13:\"field_section\";s:11:\"field table\";s:24:\"field_data_field_section\";s:11:\"field field\";s:17:\"field_section_tid\";s:4:\"base\";s:4:\"node\";s:10:\"base field\";s:3:\"nid\";s:5:\"label\";s:13:\"field_section\";s:10:\"join_extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}s:27:\"reverse_field_category_node\";a:1:{s:12:\"relationship\";a:10:{s:5:\"title\";s:22:\"Content using Category\";s:4:\"help\";s:52:\"Relate each Content with a Category set to the term.\";s:7:\"handler\";s:41:\"views_handler_relationship_entity_reverse\";s:10:\"field_name\";s:14:\"field_category\";s:11:\"field table\";s:25:\"field_data_field_category\";s:11:\"field field\";s:18:\"field_category_tid\";s:4:\"base\";s:4:\"node\";s:10:\"base field\";s:3:\"nid\";s:5:\"label\";s:14:\"field_category\";s:10:\"join_extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}s:14:\"votingapi_vote\";a:1:{s:12:\"relationship\";a:7:{s:5:\"title\";s:5:\"Votes\";s:4:\"help\";s:37:\"Votes cast by users on Taxonomy term.\";s:4:\"base\";s:14:\"votingapi_vote\";s:5:\"field\";s:9:\"entity_id\";s:18:\"relationship field\";s:3:\"tid\";s:7:\"handler\";s:36:\"votingapi_views_handler_relationship\";s:5:\"extra\";a:1:{i:0;a:3:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:13:\"taxonomy_term\";s:7:\"numeric\";b:0;}}}}s:15:\"votingapi_cache\";a:1:{s:12:\"relationship\";a:7:{s:5:\"title\";s:12:\"Vote results\";s:4:\"help\";s:49:\"Aggregate results of votes cast on Taxonomy term.\";s:4:\"base\";s:15:\"votingapi_cache\";s:5:\"field\";s:9:\"entity_id\";s:18:\"relationship field\";s:3:\"tid\";s:7:\"handler\";s:36:\"votingapi_views_handler_relationship\";s:5:\"extra\";a:1:{i:0;a:3:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:13:\"taxonomy_term\";s:7:\"numeric\";b:0;}}}}}s:19:\"taxonomy_vocabulary\";a:10:{s:13:\"date_argument\";a:4:{s:5:\"group\";s:4:\"Date\";s:5:\"title\";s:26:\"Date (taxonomy_vocabulary)\";s:4:\"help\";s:180:\"Filter any Views taxonomy_vocabulary date field by a date argument, using any common ISO date/period format (i.e. YYYY, YYYY-MM, YYYY-MM-DD, YYYY-W99, YYYY-MM-DD--P3M, P90D, etc). \";s:8:\"argument\";a:3:{s:7:\"handler\";s:27:\"date_views_argument_handler\";s:16:\"empty field name\";s:7:\"Undated\";s:7:\"is date\";b:1;}}s:11:\"date_filter\";a:4:{s:5:\"group\";s:4:\"Date\";s:5:\"title\";s:26:\"Date (taxonomy_vocabulary)\";s:4:\"help\";s:48:\"Filter any Views taxonomy_vocabulary date field.\";s:6:\"filter\";a:3:{s:7:\"handler\";s:25:\"date_views_filter_handler\";s:16:\"empty field name\";s:7:\"Undated\";s:7:\"is date\";b:1;}}s:5:\"table\";a:3:{s:5:\"group\";s:19:\"Taxonomy vocabulary\";s:4:\"join\";a:1:{s:18:\"taxonomy_term_data\";a:2:{s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:3:\"vid\";}}s:20:\"default_relationship\";a:1:{s:4:\"node\";a:2:{s:5:\"table\";s:4:\"node\";s:5:\"field\";s:13:\"term_node_tid\";}}}s:4:\"name\";a:3:{s:5:\"title\";s:4:\"Name\";s:5:\"field\";a:3:{s:4:\"help\";s:160:\"Name of the vocabulary a term is a member of. This will be the vocabulary that whichever term the \"Taxonomy: Term\" field is; and can similarly cause duplicates.\";s:7:\"handler\";s:19:\"views_handler_field\";s:14:\"click sortable\";b:1;}s:4:\"sort\";a:2:{s:7:\"handler\";s:18:\"views_handler_sort\";s:4:\"help\";s:28:\"The taxonomy vocabulary name\";}}s:12:\"machine_name\";a:4:{s:5:\"title\";s:12:\"Machine name\";s:5:\"field\";a:3:{s:4:\"help\";s:168:\"Machine-Name of the vocabulary a term is a member of. This will be the vocabulary that whichever term the \"Taxonomy: Term\" field is; and can similarly cause duplicates.\";s:7:\"handler\";s:19:\"views_handler_field\";s:14:\"click sortable\";b:1;}s:6:\"filter\";a:2:{s:4:\"help\";s:66:\"Filter the results of \"Taxonomy: Term\" to a particular vocabulary.\";s:7:\"handler\";s:44:\"views_handler_filter_vocabulary_machine_name\";}s:8:\"argument\";a:2:{s:4:\"help\";s:66:\"Filter the results of \"Taxonomy: Term\" to a particular vocabulary.\";s:7:\"handler\";s:46:\"views_handler_argument_vocabulary_machine_name\";}}s:3:\"vid\";a:5:{s:5:\"title\";s:13:\"Vocabulary ID\";s:4:\"help\";s:26:\"The taxonomy vocabulary ID\";s:5:\"field\";a:2:{s:7:\"handler\";s:27:\"views_handler_field_numeric\";s:14:\"click sortable\";b:1;}s:8:\"argument\";a:2:{s:7:\"handler\";s:37:\"views_handler_argument_vocabulary_vid\";s:10:\"name field\";s:4:\"name\";}s:4:\"sort\";a:1:{s:7:\"handler\";s:18:\"views_handler_sort\";}}s:11:\"description\";a:3:{s:5:\"title\";s:11:\"Description\";s:4:\"help\";s:35:\"The taxonomy vocabulary description\";s:5:\"field\";a:1:{s:7:\"handler\";s:19:\"views_handler_field\";}}s:6:\"weight\";a:6:{s:5:\"title\";s:6:\"Weight\";s:4:\"help\";s:30:\"The taxonomy vocabulary weight\";s:5:\"field\";a:2:{s:7:\"handler\";s:27:\"views_handler_field_numeric\";s:14:\"click sortable\";b:1;}s:8:\"argument\";a:2:{s:7:\"handler\";s:30:\"views_handler_argument_numeric\";s:10:\"name field\";s:6:\"weight\";}s:4:\"sort\";a:1:{s:7:\"handler\";s:18:\"views_handler_sort\";}s:6:\"filter\";a:1:{s:7:\"handler\";s:28:\"views_handler_filter_numeric\";}}s:14:\"votingapi_vote\";a:1:{s:12:\"relationship\";a:7:{s:5:\"title\";s:5:\"Votes\";s:4:\"help\";s:43:\"Votes cast by users on Taxonomy vocabulary.\";s:4:\"base\";s:14:\"votingapi_vote\";s:5:\"field\";s:9:\"entity_id\";s:18:\"relationship field\";s:3:\"vid\";s:7:\"handler\";s:36:\"votingapi_views_handler_relationship\";s:5:\"extra\";a:1:{i:0;a:3:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:19:\"taxonomy_vocabulary\";s:7:\"numeric\";b:0;}}}}s:15:\"votingapi_cache\";a:1:{s:12:\"relationship\";a:7:{s:5:\"title\";s:12:\"Vote results\";s:4:\"help\";s:55:\"Aggregate results of votes cast on Taxonomy vocabulary.\";s:4:\"base\";s:15:\"votingapi_cache\";s:5:\"field\";s:9:\"entity_id\";s:18:\"relationship field\";s:3:\"vid\";s:7:\"handler\";s:36:\"votingapi_views_handler_relationship\";s:5:\"extra\";a:1:{i:0;a:3:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:19:\"taxonomy_vocabulary\";s:7:\"numeric\";b:0;}}}}}s:5:\"users\";a:34:{s:13:\"date_argument\";a:4:{s:5:\"group\";s:4:\"Date\";s:5:\"title\";s:12:\"Date (users)\";s:4:\"help\";s:166:\"Filter any Views users date field by a date argument, using any common ISO date/period format (i.e. YYYY, YYYY-MM, YYYY-MM-DD, YYYY-W99, YYYY-MM-DD--P3M, P90D, etc). \";s:8:\"argument\";a:3:{s:7:\"handler\";s:27:\"date_views_argument_handler\";s:16:\"empty field name\";s:7:\"Undated\";s:7:\"is date\";b:1;}}s:11:\"date_filter\";a:4:{s:5:\"group\";s:4:\"Date\";s:5:\"title\";s:12:\"Date (users)\";s:4:\"help\";s:34:\"Filter any Views users date field.\";s:6:\"filter\";a:3:{s:7:\"handler\";s:25:\"date_views_filter_handler\";s:16:\"empty field name\";s:7:\"Undated\";s:7:\"is date\";b:1;}}s:7:\"message\";a:3:{s:5:\"title\";s:7:\"Message\";s:4:\"help\";s:42:\"Associated message via the message\'s user.\";s:12:\"relationship\";a:5:{s:5:\"label\";s:7:\"Message\";s:7:\"handler\";s:43:\"entity_views_handler_relationship_by_bundle\";s:4:\"base\";s:7:\"message\";s:10:\"base field\";s:3:\"uid\";s:18:\"relationship field\";s:3:\"uid\";}}s:5:\"table\";a:4:{s:5:\"group\";s:4:\"User\";s:4:\"base\";a:4:{s:5:\"field\";s:3:\"uid\";s:5:\"title\";s:4:\"User\";s:4:\"help\";s:45:\"Users who have created accounts on your site.\";s:16:\"access query tag\";s:11:\"user_access\";}s:11:\"entity type\";s:4:\"user\";s:20:\"default_relationship\";a:3:{s:4:\"node\";a:2:{s:5:\"table\";s:4:\"node\";s:5:\"field\";s:3:\"uid\";}s:13:\"node_revision\";a:2:{s:5:\"table\";s:13:\"node_revision\";s:5:\"field\";s:3:\"uid\";}s:4:\"file\";a:2:{s:5:\"table\";s:4:\"file\";s:5:\"field\";s:3:\"uid\";}}}s:3:\"uid\";a:7:{s:5:\"title\";s:3:\"Uid\";s:4:\"help\";s:11:\"The user ID\";s:5:\"field\";a:2:{s:7:\"handler\";s:24:\"views_handler_field_user\";s:14:\"click sortable\";b:1;}s:8:\"argument\";a:2:{s:7:\"handler\";s:31:\"views_handler_argument_user_uid\";s:10:\"name field\";s:4:\"name\";}s:6:\"filter\";a:2:{s:5:\"title\";s:4:\"Name\";s:7:\"handler\";s:30:\"views_handler_filter_user_name\";}s:4:\"sort\";a:1:{s:7:\"handler\";s:18:\"views_handler_sort\";}s:12:\"relationship\";a:7:{s:5:\"title\";s:16:\"Content authored\";s:4:\"help\";s:126:\"Relate content to the user who created it. This relationship will create one record for each content item created by the user.\";s:7:\"handler\";s:26:\"views_handler_relationship\";s:4:\"base\";s:4:\"node\";s:10:\"base field\";s:3:\"uid\";s:5:\"field\";s:3:\"uid\";s:5:\"label\";s:5:\"nodes\";}}s:7:\"uid_raw\";a:3:{s:4:\"help\";s:24:\"The raw numeric user ID.\";s:10:\"real field\";s:3:\"uid\";s:6:\"filter\";a:2:{s:5:\"title\";s:11:\"The user ID\";s:7:\"handler\";s:28:\"views_handler_filter_numeric\";}}s:18:\"uid_representative\";a:1:{s:12:\"relationship\";a:10:{s:5:\"title\";s:19:\"Representative node\";s:5:\"label\";s:19:\"Representative node\";s:4:\"help\";s:89:\"Obtains a single representative node for each user, according to a chosen sort criterion.\";s:7:\"handler\";s:40:\"views_handler_relationship_groupwise_max\";s:18:\"relationship field\";s:3:\"uid\";s:11:\"outer field\";s:9:\"users.uid\";s:14:\"argument table\";s:5:\"users\";s:14:\"argument field\";s:3:\"uid\";s:4:\"base\";s:4:\"node\";s:5:\"field\";s:3:\"nid\";}}s:11:\"uid_current\";a:4:{s:10:\"real field\";s:3:\"uid\";s:5:\"title\";s:7:\"Current\";s:4:\"help\";s:48:\"Filter the view to the currently logged in user.\";s:6:\"filter\";a:2:{s:7:\"handler\";s:33:\"views_handler_filter_user_current\";s:4:\"type\";s:6:\"yes-no\";}}s:4:\"name\";a:6:{s:5:\"title\";s:4:\"Name\";s:4:\"help\";s:24:\"The user or author name.\";s:5:\"field\";a:2:{s:7:\"handler\";s:29:\"views_handler_field_user_name\";s:14:\"click sortable\";b:1;}s:4:\"sort\";a:1:{s:7:\"handler\";s:18:\"views_handler_sort\";}s:8:\"argument\";a:1:{s:7:\"handler\";s:29:\"views_handler_argument_string\";}s:6:\"filter\";a:3:{s:7:\"handler\";s:27:\"views_handler_filter_string\";s:5:\"title\";s:10:\"Name (raw)\";s:4:\"help\";s:130:\"The user or author name. This filter does not check if the user exists and allows partial matching. Does not utilize autocomplete.\";}}s:4:\"mail\";a:6:{s:5:\"title\";s:6:\"E-mail\";s:4:\"help\";s:104:\"Email address for a given user. This field is normally not shown to users, so be cautious when using it.\";s:5:\"field\";a:2:{s:7:\"handler\";s:29:\"views_handler_field_user_mail\";s:14:\"click sortable\";b:1;}s:4:\"sort\";a:1:{s:7:\"handler\";s:18:\"views_handler_sort\";}s:6:\"filter\";a:1:{s:7:\"handler\";s:27:\"views_handler_filter_string\";}s:8:\"argument\";a:1:{s:7:\"handler\";s:29:\"views_handler_argument_string\";}}s:8:\"language\";a:6:{s:5:\"title\";s:8:\"Language\";s:4:\"help\";s:20:\"Language of the user\";s:5:\"field\";a:2:{s:7:\"handler\";s:33:\"views_handler_field_user_language\";s:14:\"click sortable\";b:1;}s:4:\"sort\";a:1:{s:7:\"handler\";s:18:\"views_handler_sort\";}s:6:\"filter\";a:1:{s:7:\"handler\";s:34:\"views_handler_filter_node_language\";}s:8:\"argument\";a:1:{s:7:\"handler\";s:36:\"views_handler_argument_node_language\";}}s:11:\"picture_fid\";a:1:{s:8:\"moved to\";a:2:{i:0;s:5:\"users\";i:1;s:7:\"picture\";}}s:7:\"picture\";a:5:{s:5:\"title\";s:7:\"Picture\";s:4:\"help\";s:31:\"The user\'s picture, if allowed.\";s:5:\"field\";a:2:{s:7:\"handler\";s:32:\"views_handler_field_user_picture\";s:14:\"click sortable\";b:1;}s:4:\"sort\";a:1:{s:7:\"handler\";s:18:\"views_handler_sort\";}s:6:\"filter\";a:3:{s:7:\"handler\";s:37:\"views_handler_filter_boolean_operator\";s:5:\"label\";s:10:\"Has Avatar\";s:4:\"type\";s:6:\"yes-no\";}}s:9:\"view_user\";a:1:{s:5:\"field\";a:3:{s:5:\"title\";s:4:\"Link\";s:4:\"help\";s:34:\"Provide a simple link to the user.\";s:7:\"handler\";s:29:\"views_handler_field_user_link\";}}s:7:\"created\";a:5:{s:5:\"title\";s:12:\"Created date\";s:4:\"help\";s:30:\"The date the user was created.\";s:5:\"field\";a:3:{s:7:\"handler\";s:24:\"views_handler_field_date\";s:14:\"click sortable\";b:1;s:7:\"is date\";b:1;}s:4:\"sort\";a:2:{s:7:\"handler\";s:23:\"views_handler_sort_date\";s:7:\"is date\";b:1;}s:6:\"filter\";a:2:{s:7:\"handler\";s:25:\"views_handler_filter_date\";s:7:\"is date\";b:1;}}s:16:\"created_fulldate\";a:3:{s:5:\"title\";s:12:\"Created date\";s:4:\"help\";s:29:\"Date in the form of CCYYMMDD.\";s:8:\"argument\";a:2:{s:5:\"field\";s:7:\"created\";s:7:\"handler\";s:44:\"views_handler_argument_node_created_fulldate\";}}s:18:\"created_year_month\";a:3:{s:5:\"title\";s:20:\"Created year + month\";s:4:\"help\";s:27:\"Date in the form of YYYYMM.\";s:8:\"argument\";a:2:{s:5:\"field\";s:7:\"created\";s:7:\"handler\";s:46:\"views_handler_argument_node_created_year_month\";}}s:14:\"timestamp_year\";a:1:{s:8:\"moved to\";a:2:{i:0;s:5:\"users\";i:1;s:12:\"created_year\";}}s:12:\"created_year\";a:3:{s:5:\"title\";s:12:\"Created year\";s:4:\"help\";s:25:\"Date in the form of YYYY.\";s:8:\"argument\";a:2:{s:5:\"field\";s:7:\"created\";s:7:\"handler\";s:40:\"views_handler_argument_node_created_year\";}}s:13:\"created_month\";a:3:{s:5:\"title\";s:13:\"Created month\";s:4:\"help\";s:33:\"Date in the form of MM (01 - 12).\";s:8:\"argument\";a:2:{s:5:\"field\";s:7:\"created\";s:7:\"handler\";s:41:\"views_handler_argument_node_created_month\";}}s:11:\"created_day\";a:3:{s:5:\"title\";s:11:\"Created day\";s:4:\"help\";s:33:\"Date in the form of DD (01 - 31).\";s:8:\"argument\";a:2:{s:5:\"field\";s:7:\"created\";s:7:\"handler\";s:39:\"views_handler_argument_node_created_day\";}}s:12:\"created_week\";a:3:{s:5:\"title\";s:12:\"Created week\";s:4:\"help\";s:33:\"Date in the form of WW (01 - 53).\";s:8:\"argument\";a:2:{s:5:\"field\";s:7:\"created\";s:7:\"handler\";s:40:\"views_handler_argument_node_created_week\";}}s:6:\"access\";a:5:{s:5:\"title\";s:11:\"Last access\";s:4:\"help\";s:28:\"The user\'s last access date.\";s:5:\"field\";a:3:{s:7:\"handler\";s:24:\"views_handler_field_date\";s:14:\"click sortable\";b:1;s:7:\"is date\";b:1;}s:4:\"sort\";a:2:{s:7:\"handler\";s:23:\"views_handler_sort_date\";s:7:\"is date\";b:1;}s:6:\"filter\";a:2:{s:7:\"handler\";s:25:\"views_handler_filter_date\";s:7:\"is date\";b:1;}}s:5:\"login\";a:5:{s:5:\"title\";s:10:\"Last login\";s:4:\"help\";s:27:\"The user\'s last login date.\";s:5:\"field\";a:3:{s:7:\"handler\";s:24:\"views_handler_field_date\";s:14:\"click sortable\";b:1;s:7:\"is date\";b:1;}s:4:\"sort\";a:2:{s:7:\"handler\";s:23:\"views_handler_sort_date\";s:7:\"is date\";b:1;}s:6:\"filter\";a:2:{s:7:\"handler\";s:25:\"views_handler_filter_date\";s:7:\"is date\";b:1;}}s:6:\"status\";a:5:{s:5:\"title\";s:6:\"Active\";s:4:\"help\";s:36:\"Whether a user is active or blocked.\";s:5:\"field\";a:3:{s:7:\"handler\";s:27:\"views_handler_field_boolean\";s:14:\"click sortable\";b:1;s:14:\"output formats\";a:1:{s:14:\"active-blocked\";a:2:{i:0;s:6:\"Active\";i:1;s:7:\"Blocked\";}}}s:6:\"filter\";a:3:{s:7:\"handler\";s:37:\"views_handler_filter_boolean_operator\";s:5:\"label\";s:6:\"Active\";s:4:\"type\";s:6:\"yes-no\";}s:4:\"sort\";a:1:{s:7:\"handler\";s:18:\"views_handler_sort\";}}s:9:\"signature\";a:4:{s:5:\"title\";s:9:\"Signature\";s:4:\"help\";s:21:\"The user\'s signature.\";s:5:\"field\";a:2:{s:7:\"handler\";s:26:\"views_handler_field_markup\";s:6:\"format\";s:10:\"plain_text\";}s:6:\"filter\";a:1:{s:7:\"handler\";s:27:\"views_handler_filter_string\";}}s:9:\"edit_node\";a:1:{s:5:\"field\";a:3:{s:5:\"title\";s:9:\"Edit link\";s:4:\"help\";s:39:\"Provide a simple link to edit the user.\";s:7:\"handler\";s:34:\"views_handler_field_user_link_edit\";}}s:11:\"cancel_node\";a:1:{s:5:\"field\";a:3:{s:5:\"title\";s:11:\"Cancel link\";s:4:\"help\";s:41:\"Provide a simple link to cancel the user.\";s:7:\"handler\";s:36:\"views_handler_field_user_link_cancel\";}}s:4:\"data\";a:3:{s:5:\"title\";s:4:\"Data\";s:4:\"help\";s:35:\"Provide serialized data of the user\";s:5:\"field\";a:1:{s:7:\"handler\";s:30:\"views_handler_field_serialized\";}}s:18:\"webform_submission\";a:4:{s:5:\"title\";s:18:\"Webform submission\";s:4:\"help\";s:38:\"Webform submissions of the given user.\";s:10:\"real field\";s:3:\"uid\";s:12:\"relationship\";a:4:{s:4:\"base\";s:19:\"webform_submissions\";s:10:\"base field\";s:3:\"uid\";s:7:\"handler\";s:26:\"views_handler_relationship\";s:5:\"label\";s:18:\"Webform Submission\";}}s:29:\"webform_submission_count_user\";a:1:{s:5:\"field\";a:4:{s:5:\"title\";s:24:\"Webform submission count\";s:4:\"help\";s:48:\"The number of webform submissions for this user.\";s:7:\"handler\";s:38:\"webform_handler_field_submission_count\";s:10:\"count_type\";s:5:\"users\";}}s:7:\"contact\";a:1:{s:5:\"field\";a:3:{s:5:\"title\";s:20:\"Link to contact page\";s:4:\"help\";s:47:\"Provide a simple link to the user contact page.\";s:7:\"handler\";s:32:\"views_handler_field_contact_link\";}}s:14:\"votingapi_vote\";a:1:{s:12:\"relationship\";a:7:{s:5:\"title\";s:5:\"Votes\";s:4:\"help\";s:28:\"Votes cast by users on User.\";s:4:\"base\";s:14:\"votingapi_vote\";s:5:\"field\";s:9:\"entity_id\";s:18:\"relationship field\";s:3:\"uid\";s:7:\"handler\";s:36:\"votingapi_views_handler_relationship\";s:5:\"extra\";a:1:{i:0;a:3:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"user\";s:7:\"numeric\";b:0;}}}}s:15:\"votingapi_cache\";a:1:{s:12:\"relationship\";a:7:{s:5:\"title\";s:12:\"Vote results\";s:4:\"help\";s:40:\"Aggregate results of votes cast on User.\";s:4:\"base\";s:15:\"votingapi_cache\";s:5:\"field\";s:9:\"entity_id\";s:18:\"relationship field\";s:3:\"uid\";s:7:\"handler\";s:36:\"votingapi_views_handler_relationship\";s:5:\"extra\";a:1:{i:0;a:3:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"user\";s:7:\"numeric\";b:0;}}}}}s:14:\"entity_comment\";a:21:{s:5:\"table\";a:2:{s:5:\"group\";s:7:\"Comment\";s:11:\"entity type\";s:7:\"comment\";}s:3:\"cid\";a:3:{s:5:\"title\";s:10:\"Comment ID\";s:4:\"help\";s:29:\"The unique ID of the comment.\";s:5:\"field\";a:2:{s:7:\"handler\";s:34:\"entity_views_handler_field_numeric\";s:4:\"type\";s:7:\"integer\";}}s:8:\"hostname\";a:3:{s:5:\"title\";s:10:\"IP Address\";s:4:\"help\";s:59:\"The IP address of the computer the comment was posted from.\";s:5:\"field\";a:2:{s:7:\"handler\";s:31:\"entity_views_handler_field_text\";s:4:\"type\";s:4:\"text\";}}s:4:\"name\";a:3:{s:5:\"title\";s:4:\"Name\";s:4:\"help\";s:36:\"The name left by the comment author.\";s:5:\"field\";a:2:{s:7:\"handler\";s:31:\"entity_views_handler_field_text\";s:4:\"type\";s:4:\"text\";}}s:4:\"mail\";a:3:{s:5:\"title\";s:13:\"Email address\";s:4:\"help\";s:45:\"The email address left by the comment author.\";s:5:\"field\";a:2:{s:7:\"handler\";s:31:\"entity_views_handler_field_text\";s:4:\"type\";s:4:\"text\";}}s:8:\"homepage\";a:3:{s:5:\"title\";s:9:\"Home page\";s:4:\"help\";s:45:\"The home page URL left by the comment author.\";s:5:\"field\";a:2:{s:7:\"handler\";s:31:\"entity_views_handler_field_text\";s:4:\"type\";s:4:\"text\";}}s:7:\"subject\";a:3:{s:5:\"title\";s:7:\"Subject\";s:4:\"help\";s:27:\"The subject of the comment.\";s:5:\"field\";a:2:{s:7:\"handler\";s:31:\"entity_views_handler_field_text\";s:4:\"type\";s:4:\"text\";}}s:3:\"url\";a:3:{s:5:\"title\";s:3:\"URL\";s:4:\"help\";s:23:\"The URL of the comment.\";s:5:\"field\";a:2:{s:7:\"handler\";s:30:\"entity_views_handler_field_uri\";s:4:\"type\";s:3:\"uri\";}}s:8:\"edit_url\";a:3:{s:5:\"title\";s:8:\"Edit URL\";s:4:\"help\";s:35:\"The URL of the comment\'s edit page.\";s:5:\"field\";a:2:{s:7:\"handler\";s:30:\"entity_views_handler_field_uri\";s:4:\"type\";s:3:\"uri\";}}s:7:\"created\";a:3:{s:5:\"title\";s:12:\"Date created\";s:4:\"help\";s:32:\"The date the comment was posted.\";s:5:\"field\";a:2:{s:7:\"handler\";s:31:\"entity_views_handler_field_date\";s:4:\"type\";s:4:\"date\";}}s:6:\"parent\";a:4:{s:5:\"title\";s:6:\"Parent\";s:4:\"help\";s:53:\"The comment\'s parent, if comment threading is active.\";s:5:\"field\";a:2:{s:7:\"handler\";s:33:\"entity_views_handler_field_entity\";s:4:\"type\";s:7:\"comment\";}s:12:\"relationship\";a:5:{s:7:\"handler\";s:33:\"entity_views_handler_relationship\";s:4:\"base\";s:14:\"entity_comment\";s:10:\"base field\";s:3:\"cid\";s:18:\"relationship field\";s:6:\"parent\";s:5:\"label\";s:6:\"Parent\";}}s:4:\"node\";a:4:{s:5:\"title\";s:4:\"Node\";s:4:\"help\";s:35:\"The node the comment was posted to.\";s:5:\"field\";a:2:{s:7:\"handler\";s:33:\"entity_views_handler_field_entity\";s:4:\"type\";s:4:\"node\";}s:12:\"relationship\";a:5:{s:7:\"handler\";s:33:\"entity_views_handler_relationship\";s:4:\"base\";s:11:\"entity_node\";s:10:\"base field\";s:3:\"nid\";s:18:\"relationship field\";s:4:\"node\";s:5:\"label\";s:4:\"Node\";}}s:6:\"author\";a:4:{s:5:\"title\";s:6:\"Author\";s:4:\"help\";s:26:\"The author of the comment.\";s:5:\"field\";a:2:{s:7:\"handler\";s:33:\"entity_views_handler_field_entity\";s:4:\"type\";s:4:\"user\";}s:12:\"relationship\";a:5:{s:7:\"handler\";s:33:\"entity_views_handler_relationship\";s:4:\"base\";s:11:\"entity_user\";s:10:\"base field\";s:3:\"uid\";s:18:\"relationship field\";s:6:\"author\";s:5:\"label\";s:6:\"Author\";}}s:6:\"status\";a:3:{s:5:\"title\";s:6:\"Status\";s:4:\"help\";s:48:\"Whether the comment is published or unpublished.\";s:5:\"field\";a:3:{s:7:\"handler\";s:34:\"entity_views_handler_field_options\";s:4:\"type\";s:7:\"integer\";s:16:\"options callback\";a:2:{s:8:\"function\";s:35:\"entity_metadata_status_options_list\";s:4:\"info\";a:8:{s:5:\"label\";s:6:\"Status\";s:11:\"description\";s:48:\"Whether the comment is published or unpublished.\";s:15:\"setter callback\";s:28:\"entity_property_verbatim_set\";s:4:\"type\";s:7:\"integer\";s:12:\"options list\";s:35:\"entity_metadata_status_options_list\";s:15:\"access callback\";s:41:\"entity_metadata_comment_properties_access\";s:12:\"schema field\";s:6:\"status\";s:15:\"getter callback\";s:28:\"entity_property_verbatim_get\";}}}}s:12:\"comment_body\";a:3:{s:5:\"title\";s:18:\"The main body text\";s:4:\"help\";s:26:\"(No information available)\";s:5:\"field\";a:6:{s:7:\"handler\";s:32:\"entity_views_handler_field_field\";s:4:\"type\";s:14:\"text_formatted\";s:10:\"field_name\";s:12:\"comment_body\";s:13:\"entity_tables\";a:0:{}s:11:\"entity type\";s:7:\"comment\";s:11:\"is revision\";b:0;}}s:18:\"comment_body_value\";a:4:{s:5:\"title\";s:26:\"The main body text » Text\";s:4:\"help\";s:26:\"(No information available)\";s:5:\"field\";a:2:{s:7:\"handler\";s:31:\"entity_views_handler_field_text\";s:4:\"type\";s:4:\"text\";}s:10:\"real field\";s:18:\"comment_body:value\";}s:19:\"comment_body_format\";a:4:{s:5:\"title\";s:33:\"The main body text » Text format\";s:4:\"help\";s:26:\"(No information available)\";s:5:\"field\";a:3:{s:7:\"handler\";s:34:\"entity_views_handler_field_options\";s:4:\"type\";s:5:\"token\";s:16:\"options callback\";a:2:{s:8:\"function\";s:34:\"entity_metadata_field_text_formats\";s:4:\"info\";a:6:{s:4:\"type\";s:5:\"token\";s:5:\"label\";s:11:\"Text format\";s:12:\"options list\";s:34:\"entity_metadata_field_text_formats\";s:15:\"getter callback\";s:28:\"entity_property_verbatim_get\";s:15:\"setter callback\";s:28:\"entity_property_verbatim_set\";s:18:\"setter permissions\";s:18:\"administer filters\";}}}s:10:\"real field\";s:19:\"comment_body:format\";}s:10:\"field_vote\";a:3:{s:5:\"title\";s:4:\"Vote\";s:4:\"help\";s:19:\"Field \"field_vote\".\";s:5:\"field\";a:6:{s:7:\"handler\";s:32:\"entity_views_handler_field_field\";s:4:\"type\";s:8:\"fivestar\";s:10:\"field_name\";s:10:\"field_vote\";s:13:\"entity_tables\";a:0:{}s:11:\"entity type\";s:7:\"comment\";s:11:\"is revision\";b:0;}}s:25:\"field_vote_average_rating\";a:4:{s:5:\"title\";s:22:\"Vote » Average Rating\";s:4:\"help\";s:26:\"(No information available)\";s:5:\"field\";a:2:{s:7:\"handler\";s:31:\"entity_views_handler_field_text\";s:4:\"type\";s:4:\"text\";}s:10:\"real field\";s:25:\"field_vote:average_rating\";}s:22:\"field_vote_user_rating\";a:4:{s:5:\"title\";s:21:\"Vote » User\'s Rating\";s:4:\"help\";s:26:\"(No information available)\";s:5:\"field\";a:2:{s:7:\"handler\";s:31:\"entity_views_handler_field_text\";s:4:\"type\";s:4:\"text\";}s:10:\"real field\";s:22:\"field_vote:user_rating\";}s:23:\"field_vote_rating_count\";a:4:{s:5:\"title\";s:20:\"Vote » Rating count\";s:4:\"help\";s:26:\"(No information available)\";s:5:\"field\";a:2:{s:7:\"handler\";s:31:\"entity_views_handler_field_text\";s:4:\"type\";s:4:\"text\";}s:10:\"real field\";s:23:\"field_vote:rating_count\";}}s:20:\"views_entity_comment\";a:2:{s:15:\"rendered_entity\";a:3:{s:5:\"title\";s:16:\"Rendered Comment\";s:4:\"help\";s:67:\"The Comment of the current relationship rendered using a view mode.\";s:5:\"field\";a:3:{s:7:\"handler\";s:33:\"entity_views_handler_field_entity\";s:4:\"type\";s:7:\"comment\";s:10:\"real field\";s:13:\"entity object\";}}s:5:\"table\";a:3:{s:4:\"join\";a:3:{s:7:\"comment\";a:1:{s:10:\"left_table\";s:7:\"comment\";}s:14:\"entity_comment\";a:1:{s:10:\"left_table\";s:14:\"entity_comment\";}s:20:\"views_entity_comment\";a:1:{s:10:\"left_table\";s:20:\"views_entity_comment\";}}s:11:\"entity type\";s:7:\"comment\";s:5:\"group\";s:7:\"Comment\";}}s:28:\"entity_field_collection_item\";a:13:{s:5:\"table\";a:2:{s:5:\"group\";s:21:\"Field collection item\";s:11:\"entity type\";s:21:\"field_collection_item\";}s:7:\"item_id\";a:3:{s:5:\"title\";s:24:\"Field collection item ID\";s:4:\"help\";s:43:\"The unique ID of the field collection item.\";s:5:\"field\";a:2:{s:7:\"handler\";s:34:\"entity_views_handler_field_numeric\";s:4:\"type\";s:7:\"integer\";}}s:11:\"revision_id\";a:3:{s:5:\"title\";s:11:\"Revision_id\";s:4:\"help\";s:45:\"Field collection item \"revision_id\" property.\";s:5:\"field\";a:2:{s:7:\"handler\";s:34:\"entity_views_handler_field_numeric\";s:4:\"type\";s:7:\"integer\";}}s:10:\"field_name\";a:3:{s:5:\"title\";s:10:\"Field name\";s:4:\"help\";s:77:\"The machine-readable name of the field collection field containing this item.\";s:5:\"field\";a:3:{s:7:\"handler\";s:34:\"entity_views_handler_field_options\";s:4:\"type\";s:5:\"token\";s:16:\"options callback\";a:2:{s:8:\"function\";a:2:{i:0;s:37:\"FieldCollectionItemMetadataController\";i:1;s:17:\"bundleOptionsList\";}s:4:\"info\";a:7:{s:4:\"type\";s:5:\"token\";s:5:\"label\";s:10:\"Field name\";s:12:\"schema field\";s:10:\"field_name\";s:11:\"description\";s:77:\"The machine-readable name of the field collection field containing this item.\";s:12:\"options list\";a:2:{i:0;s:37:\"FieldCollectionItemMetadataController\";i:1;s:17:\"bundleOptionsList\";}s:8:\"required\";b:1;s:15:\"getter callback\";s:28:\"entity_property_verbatim_get\";}}}}s:8:\"archived\";a:3:{s:5:\"title\";s:8:\"Archived\";s:4:\"help\";s:42:\"Field collection item \"archived\" property.\";s:5:\"field\";a:2:{s:7:\"handler\";s:34:\"entity_views_handler_field_numeric\";s:4:\"type\";s:7:\"integer\";}}s:11:\"host_entity\";a:3:{s:5:\"title\";s:11:\"Host entity\";s:4:\"help\";s:49:\"The entity containing the field collection field.\";s:5:\"field\";a:2:{s:7:\"handler\";s:33:\"entity_views_handler_field_entity\";s:4:\"type\";s:6:\"entity\";}}s:11:\"field_image\";a:3:{s:5:\"title\";s:5:\"Image\";s:4:\"help\";s:20:\"Field \"field_image\".\";s:5:\"field\";a:6:{s:7:\"handler\";s:32:\"entity_views_handler_field_field\";s:4:\"type\";s:16:\"field_item_image\";s:10:\"field_name\";s:11:\"field_image\";s:13:\"entity_tables\";a:0:{}s:11:\"entity type\";s:21:\"field_collection_item\";s:11:\"is revision\";b:0;}}s:16:\"field_image_file\";a:5:{s:5:\"title\";s:24:\"Image » The image file.\";s:4:\"help\";s:26:\"(No information available)\";s:5:\"field\";a:2:{s:7:\"handler\";s:33:\"entity_views_handler_field_entity\";s:4:\"type\";s:4:\"file\";}s:10:\"real field\";s:16:\"field_image:file\";s:12:\"relationship\";a:5:{s:7:\"handler\";s:33:\"entity_views_handler_relationship\";s:4:\"base\";s:11:\"entity_file\";s:10:\"base field\";s:3:\"fid\";s:18:\"relationship field\";s:16:\"field_image:file\";s:5:\"label\";s:24:\"Image » The image file.\";}}s:16:\"field_video_link\";a:3:{s:5:\"title\";s:10:\"Video Link\";s:4:\"help\";s:25:\"Field \"field_video_link\".\";s:5:\"field\";a:6:{s:7:\"handler\";s:32:\"entity_views_handler_field_field\";s:4:\"type\";s:17:\"video_embed_field\";s:10:\"field_name\";s:16:\"field_video_link\";s:13:\"entity_tables\";a:0:{}s:11:\"entity type\";s:21:\"field_collection_item\";s:11:\"is revision\";b:0;}}s:26:\"field_video_link_video_url\";a:4:{s:5:\"title\";s:23:\"Video Link » Video URL\";s:4:\"help\";s:59:\"Video URL of field <em class=\"placeholder\">Video embed</em>\";s:5:\"field\";a:2:{s:7:\"handler\";s:30:\"entity_views_handler_field_uri\";s:4:\"type\";s:3:\"uri\";}s:10:\"real field\";s:26:\"field_video_link:video_url\";}s:31:\"field_video_link_thumbnail_path\";a:4:{s:5:\"title\";s:28:\"Video Link » Thumbnail path\";s:4:\"help\";s:64:\"Thumbnail path of field <em class=\"placeholder\">Video embed</em>\";s:5:\"field\";a:2:{s:7:\"handler\";s:30:\"entity_views_handler_field_uri\";s:4:\"type\";s:3:\"uri\";}s:10:\"real field\";s:31:\"field_video_link:thumbnail_path\";}s:28:\"field_video_link_description\";a:4:{s:5:\"title\";s:25:\"Video Link » Description\";s:4:\"help\";s:61:\"Description of field <em class=\"placeholder\">Video embed</em>\";s:5:\"field\";a:2:{s:7:\"handler\";s:31:\"entity_views_handler_field_text\";s:4:\"type\";s:4:\"text\";}s:10:\"real field\";s:28:\"field_video_link:description\";}s:17:\"field_description\";a:3:{s:5:\"title\";s:11:\"Description\";s:4:\"help\";s:26:\"Field \"field_description\".\";s:5:\"field\";a:6:{s:7:\"handler\";s:32:\"entity_views_handler_field_field\";s:4:\"type\";s:4:\"text\";s:10:\"field_name\";s:17:\"field_description\";s:13:\"entity_tables\";a:0:{}s:11:\"entity type\";s:21:\"field_collection_item\";s:11:\"is revision\";b:0;}}}s:34:\"views_entity_field_collection_item\";a:3:{s:3:\"url\";a:3:{s:5:\"title\";s:3:\"URL\";s:4:\"help\";s:22:\"The URL of the entity.\";s:5:\"field\";a:2:{s:7:\"handler\";s:30:\"entity_views_handler_field_uri\";s:4:\"type\";s:3:\"uri\";}}s:15:\"rendered_entity\";a:3:{s:5:\"title\";s:30:\"Rendered Field collection item\";s:4:\"help\";s:81:\"The Field collection item of the current relationship rendered using a view mode.\";s:5:\"field\";a:3:{s:7:\"handler\";s:33:\"entity_views_handler_field_entity\";s:4:\"type\";s:21:\"field_collection_item\";s:10:\"real field\";s:13:\"entity object\";}}s:5:\"table\";a:3:{s:4:\"join\";a:4:{s:21:\"field_collection_item\";a:1:{s:10:\"left_table\";s:21:\"field_collection_item\";}s:30:\"field_collection_item_revision\";a:1:{s:10:\"left_table\";s:30:\"field_collection_item_revision\";}s:28:\"entity_field_collection_item\";a:1:{s:10:\"left_table\";s:28:\"entity_field_collection_item\";}s:34:\"views_entity_field_collection_item\";a:1:{s:10:\"left_table\";s:34:\"views_entity_field_collection_item\";}}s:11:\"entity type\";s:21:\"field_collection_item\";s:5:\"group\";s:21:\"Field collection item\";}}s:23:\"entity_i18n_translation\";a:1:{s:5:\"table\";a:2:{s:5:\"group\";s:15:\"Translation set\";s:11:\"entity type\";s:16:\"i18n_translation\";}}s:29:\"views_entity_i18n_translation\";a:1:{s:5:\"table\";a:3:{s:4:\"join\";a:2:{s:23:\"entity_i18n_translation\";a:1:{s:10:\"left_table\";s:23:\"entity_i18n_translation\";}s:29:\"views_entity_i18n_translation\";a:1:{s:10:\"left_table\";s:29:\"views_entity_i18n_translation\";}}s:11:\"entity type\";s:16:\"i18n_translation\";s:5:\"group\";s:15:\"Translation set\";}}s:28:\"entity_message_type_category\";a:7:{s:5:\"table\";a:2:{s:5:\"group\";s:21:\"Message type category\";s:11:\"entity type\";s:21:\"message_type_category\";}s:2:\"id\";a:3:{s:5:\"title\";s:42:\"Internal, numeric message type category ID\";s:4:\"help\";s:62:\"The ID used to identify this message type category internally.\";s:5:\"field\";a:2:{s:7:\"handler\";s:34:\"entity_views_handler_field_numeric\";s:4:\"type\";s:7:\"integer\";}}s:8:\"category\";a:3:{s:5:\"title\";s:21:\"Machine-readable name\";s:4:\"help\";s:65:\"The machine-readable name identifying this message type category.\";s:5:\"field\";a:2:{s:7:\"handler\";s:31:\"entity_views_handler_field_text\";s:4:\"type\";s:5:\"token\";}}s:11:\"description\";a:3:{s:5:\"title\";s:5:\"Label\";s:4:\"help\";s:25:\"The human readable label.\";s:5:\"field\";a:2:{s:7:\"handler\";s:31:\"entity_views_handler_field_text\";s:4:\"type\";s:4:\"text\";}}s:8:\"language\";a:3:{s:5:\"title\";s:8:\"Language\";s:4:\"help\";s:42:\"Message type category \"language\" property.\";s:5:\"field\";a:2:{s:7:\"handler\";s:31:\"entity_views_handler_field_text\";s:4:\"type\";s:4:\"text\";}}s:6:\"status\";a:3:{s:5:\"title\";s:6:\"Status\";s:4:\"help\";s:40:\"Message type category \"status\" property.\";s:5:\"field\";a:2:{s:7:\"handler\";s:34:\"entity_views_handler_field_numeric\";s:4:\"type\";s:7:\"integer\";}}s:6:\"module\";a:3:{s:5:\"title\";s:6:\"Module\";s:4:\"help\";s:40:\"Message type category \"module\" property.\";s:5:\"field\";a:2:{s:7:\"handler\";s:31:\"entity_views_handler_field_text\";s:4:\"type\";s:4:\"text\";}}}s:34:\"views_entity_message_type_category\";a:2:{s:15:\"rendered_entity\";a:3:{s:5:\"title\";s:30:\"Rendered Message type category\";s:4:\"help\";s:81:\"The Message type category of the current relationship rendered using a view mode.\";s:5:\"field\";a:3:{s:7:\"handler\";s:33:\"entity_views_handler_field_entity\";s:4:\"type\";s:21:\"message_type_category\";s:10:\"real field\";s:13:\"entity object\";}}s:5:\"table\";a:3:{s:4:\"join\";a:3:{s:21:\"message_type_category\";a:1:{s:10:\"left_table\";s:21:\"message_type_category\";}s:28:\"entity_message_type_category\";a:1:{s:10:\"left_table\";s:28:\"entity_message_type_category\";}s:34:\"views_entity_message_type_category\";a:1:{s:10:\"left_table\";s:34:\"views_entity_message_type_category\";}}s:11:\"entity type\";s:21:\"message_type_category\";s:5:\"group\";s:21:\"Message type category\";}}s:19:\"entity_message_type\";a:14:{s:5:\"table\";a:2:{s:5:\"group\";s:12:\"Message type\";s:11:\"entity type\";s:12:\"message_type\";}s:2:\"id\";a:3:{s:5:\"title\";s:33:\"Internal, numeric message type ID\";s:4:\"help\";s:53:\"The ID used to identify this message type internally.\";s:5:\"field\";a:2:{s:7:\"handler\";s:34:\"entity_views_handler_field_numeric\";s:4:\"type\";s:7:\"integer\";}}s:4:\"name\";a:3:{s:5:\"title\";s:21:\"Machine-readable name\";s:4:\"help\";s:56:\"The machine-readable name identifying this message type.\";s:5:\"field\";a:2:{s:7:\"handler\";s:31:\"entity_views_handler_field_text\";s:4:\"type\";s:5:\"token\";}}s:8:\"category\";a:3:{s:5:\"title\";s:8:\"Category\";s:4:\"help\";s:33:\"Message type \"category\" property.\";s:5:\"field\";a:3:{s:7:\"handler\";s:34:\"entity_views_handler_field_options\";s:4:\"type\";s:5:\"token\";s:16:\"options callback\";a:2:{s:8:\"function\";a:2:{i:0;s:31:\"EntityDefaultMetadataController\";i:1;s:17:\"bundleOptionsList\";}s:4:\"info\";a:6:{s:4:\"type\";s:5:\"token\";s:5:\"label\";s:8:\"Category\";s:12:\"schema field\";s:8:\"category\";s:11:\"description\";s:33:\"Message type \"category\" property.\";s:12:\"options list\";a:2:{i:0;s:31:\"EntityDefaultMetadataController\";i:1;s:17:\"bundleOptionsList\";}s:15:\"getter callback\";s:28:\"entity_property_verbatim_get\";}}}}s:11:\"description\";a:3:{s:5:\"title\";s:5:\"Label\";s:4:\"help\";s:25:\"The human readable label.\";s:5:\"field\";a:2:{s:7:\"handler\";s:31:\"entity_views_handler_field_text\";s:4:\"type\";s:4:\"text\";}}s:13:\"argument_keys\";a:3:{s:5:\"title\";s:13:\"Argument_keys\";s:4:\"help\";s:38:\"Message type \"argument_keys\" property.\";s:5:\"field\";a:2:{s:7:\"handler\";s:31:\"entity_views_handler_field_text\";s:4:\"type\";s:4:\"text\";}}s:8:\"language\";a:3:{s:5:\"title\";s:8:\"Language\";s:4:\"help\";s:33:\"Message type \"language\" property.\";s:5:\"field\";a:2:{s:7:\"handler\";s:31:\"entity_views_handler_field_text\";s:4:\"type\";s:4:\"text\";}}s:6:\"status\";a:3:{s:5:\"title\";s:6:\"Status\";s:4:\"help\";s:31:\"Message type \"status\" property.\";s:5:\"field\";a:2:{s:7:\"handler\";s:34:\"entity_views_handler_field_numeric\";s:4:\"type\";s:7:\"integer\";}}s:6:\"module\";a:3:{s:5:\"title\";s:6:\"Module\";s:4:\"help\";s:31:\"Message type \"module\" property.\";s:5:\"field\";a:2:{s:7:\"handler\";s:31:\"entity_views_handler_field_text\";s:4:\"type\";s:4:\"text\";}}s:9:\"arguments\";a:3:{s:5:\"title\";s:9:\"Arguments\";s:4:\"help\";s:34:\"Message type \"arguments\" property.\";s:5:\"field\";a:2:{s:7:\"handler\";s:31:\"entity_views_handler_field_text\";s:4:\"type\";s:4:\"text\";}}s:4:\"data\";a:3:{s:5:\"title\";s:4:\"Data\";s:4:\"help\";s:29:\"Message type \"data\" property.\";s:5:\"field\";a:2:{s:7:\"handler\";s:31:\"entity_views_handler_field_text\";s:4:\"type\";s:4:\"text\";}}s:12:\"message_text\";a:3:{s:5:\"title\";s:12:\"Message text\";s:4:\"help\";s:21:\"Field \"message_text\".\";s:5:\"field\";a:6:{s:7:\"handler\";s:32:\"entity_views_handler_field_field\";s:4:\"type\";s:20:\"list<text_formatted>\";s:10:\"field_name\";s:12:\"message_text\";s:13:\"entity_tables\";a:0:{}s:11:\"entity type\";s:12:\"message_type\";s:11:\"is revision\";b:0;}}s:18:\"message_text_value\";a:4:{s:5:\"title\";s:20:\"Message text » Text\";s:4:\"help\";s:26:\"(No information available)\";s:5:\"field\";a:2:{s:7:\"handler\";s:31:\"entity_views_handler_field_text\";s:4:\"type\";s:4:\"text\";}s:10:\"real field\";s:18:\"message_text:value\";}s:19:\"message_text_format\";a:4:{s:5:\"title\";s:27:\"Message text » Text format\";s:4:\"help\";s:26:\"(No information available)\";s:5:\"field\";a:3:{s:7:\"handler\";s:34:\"entity_views_handler_field_options\";s:4:\"type\";s:5:\"token\";s:16:\"options callback\";a:2:{s:8:\"function\";s:34:\"entity_metadata_field_text_formats\";s:4:\"info\";a:6:{s:4:\"type\";s:5:\"token\";s:5:\"label\";s:11:\"Text format\";s:12:\"options list\";s:34:\"entity_metadata_field_text_formats\";s:15:\"getter callback\";s:28:\"entity_property_verbatim_get\";s:15:\"setter callback\";s:28:\"entity_property_verbatim_set\";s:18:\"setter permissions\";s:18:\"administer filters\";}}}s:10:\"real field\";s:19:\"message_text:format\";}}s:25:\"views_entity_message_type\";a:2:{s:15:\"rendered_entity\";a:3:{s:5:\"title\";s:21:\"Rendered Message type\";s:4:\"help\";s:72:\"The Message type of the current relationship rendered using a view mode.\";s:5:\"field\";a:3:{s:7:\"handler\";s:33:\"entity_views_handler_field_entity\";s:4:\"type\";s:12:\"message_type\";s:10:\"real field\";s:13:\"entity object\";}}s:5:\"table\";a:3:{s:4:\"join\";a:3:{s:12:\"message_type\";a:1:{s:10:\"left_table\";s:12:\"message_type\";}s:19:\"entity_message_type\";a:1:{s:10:\"left_table\";s:19:\"entity_message_type\";}s:25:\"views_entity_message_type\";a:1:{s:10:\"left_table\";s:25:\"views_entity_message_type\";}}s:11:\"entity type\";s:12:\"message_type\";s:5:\"group\";s:12:\"Message type\";}}s:14:\"entity_message\";a:11:{s:5:\"table\";a:2:{s:5:\"group\";s:7:\"Message\";s:11:\"entity type\";s:7:\"message\";}s:3:\"mid\";a:3:{s:5:\"title\";s:10:\"Message ID\";s:4:\"help\";s:29:\"The unique ID of the message.\";s:5:\"field\";a:2:{s:7:\"handler\";s:34:\"entity_views_handler_field_numeric\";s:4:\"type\";s:7:\"integer\";}}s:4:\"type\";a:4:{s:5:\"title\";s:4:\"Type\";s:4:\"help\";s:17:\"The message type.\";s:5:\"field\";a:2:{s:7:\"handler\";s:33:\"entity_views_handler_field_entity\";s:4:\"type\";s:12:\"message_type\";}s:12:\"relationship\";a:5:{s:7:\"handler\";s:33:\"entity_views_handler_relationship\";s:4:\"base\";s:19:\"entity_message_type\";s:10:\"base field\";s:2:\"id\";s:18:\"relationship field\";s:4:\"type\";s:5:\"label\";s:4:\"Type\";}}s:9:\"timestamp\";a:3:{s:5:\"title\";s:9:\"Timestamp\";s:4:\"help\";s:37:\"The time the message has been logged.\";s:5:\"field\";a:2:{s:7:\"handler\";s:31:\"entity_views_handler_field_date\";s:4:\"type\";s:4:\"date\";}}s:8:\"language\";a:3:{s:5:\"title\";s:8:\"Language\";s:4:\"help\";s:28:\"Message \"language\" property.\";s:5:\"field\";a:2:{s:7:\"handler\";s:31:\"entity_views_handler_field_text\";s:4:\"type\";s:4:\"text\";}}s:4:\"user\";a:4:{s:5:\"title\";s:4:\"User\";s:4:\"help\";s:38:\"The user for which to log the message.\";s:5:\"field\";a:2:{s:7:\"handler\";s:33:\"entity_views_handler_field_entity\";s:4:\"type\";s:4:\"user\";}s:12:\"relationship\";a:5:{s:7:\"handler\";s:33:\"entity_views_handler_relationship\";s:4:\"base\";s:11:\"entity_user\";s:10:\"base field\";s:3:\"uid\";s:18:\"relationship field\";s:4:\"user\";s:5:\"label\";s:4:\"User\";}}s:4:\"text\";a:3:{s:5:\"title\";s:16:\"The message text\";s:4:\"help\";s:56:\"The message text with all replacement arguments applied.\";s:5:\"field\";a:2:{s:7:\"handler\";s:31:\"entity_views_handler_field_text\";s:4:\"type\";s:4:\"text\";}}s:16:\"arguments_teaser\";a:4:{s:5:\"title\";s:37:\"Message arguments » Argument !teaser\";s:4:\"help\";s:33:\"The replacement value for !teaser\";s:5:\"field\";a:2:{s:7:\"handler\";s:31:\"entity_views_handler_field_text\";s:4:\"type\";s:4:\"text\";}s:10:\"real field\";s:16:\"arguments:teaser\";}s:17:\"field_comment_ref\";a:4:{s:5:\"title\";s:17:\"Comment reference\";s:4:\"help\";s:26:\"Field \"field_comment_ref\".\";s:5:\"field\";a:2:{s:7:\"handler\";s:33:\"entity_views_handler_field_entity\";s:4:\"type\";s:7:\"comment\";}s:12:\"relationship\";a:5:{s:7:\"handler\";s:33:\"entity_views_handler_relationship\";s:4:\"base\";s:14:\"entity_comment\";s:10:\"base field\";s:3:\"cid\";s:18:\"relationship field\";s:17:\"field_comment_ref\";s:5:\"label\";s:17:\"Comment reference\";}}s:14:\"field_node_ref\";a:4:{s:5:\"title\";s:14:\"Node reference\";s:4:\"help\";s:23:\"Field \"field_node_ref\".\";s:5:\"field\";a:2:{s:7:\"handler\";s:33:\"entity_views_handler_field_entity\";s:4:\"type\";s:4:\"node\";}s:12:\"relationship\";a:5:{s:7:\"handler\";s:33:\"entity_views_handler_relationship\";s:4:\"base\";s:11:\"entity_node\";s:10:\"base field\";s:3:\"nid\";s:18:\"relationship field\";s:14:\"field_node_ref\";s:5:\"label\";s:14:\"Node reference\";}}s:15:\"field_published\";a:3:{s:5:\"title\";s:9:\"Published\";s:4:\"help\";s:24:\"Field \"field_published\".\";s:5:\"field\";a:6:{s:7:\"handler\";s:32:\"entity_views_handler_field_field\";s:4:\"type\";s:7:\"boolean\";s:10:\"field_name\";s:15:\"field_published\";s:13:\"entity_tables\";a:0:{}s:11:\"entity type\";s:7:\"message\";s:11:\"is revision\";b:0;}}}s:20:\"views_entity_message\";a:2:{s:15:\"rendered_entity\";a:3:{s:5:\"title\";s:16:\"Rendered Message\";s:4:\"help\";s:67:\"The Message of the current relationship rendered using a view mode.\";s:5:\"field\";a:3:{s:7:\"handler\";s:33:\"entity_views_handler_field_entity\";s:4:\"type\";s:7:\"message\";s:10:\"real field\";s:13:\"entity object\";}}s:5:\"table\";a:3:{s:4:\"join\";a:3:{s:7:\"message\";a:1:{s:10:\"left_table\";s:7:\"message\";}s:14:\"entity_message\";a:1:{s:10:\"left_table\";s:14:\"entity_message\";}s:20:\"views_entity_message\";a:1:{s:10:\"left_table\";s:20:\"views_entity_message\";}}s:11:\"entity type\";s:7:\"message\";s:5:\"group\";s:7:\"Message\";}}s:11:\"entity_node\";a:53:{s:5:\"table\";a:2:{s:5:\"group\";s:4:\"Node\";s:11:\"entity type\";s:4:\"node\";}s:3:\"nid\";a:3:{s:5:\"title\";s:7:\"Node ID\";s:4:\"help\";s:26:\"The unique ID of the node.\";s:5:\"field\";a:2:{s:7:\"handler\";s:34:\"entity_views_handler_field_numeric\";s:4:\"type\";s:7:\"integer\";}}s:3:\"vid\";a:3:{s:5:\"title\";s:11:\"Revision ID\";s:4:\"help\";s:37:\"The unique ID of the node\'s revision.\";s:5:\"field\";a:2:{s:7:\"handler\";s:34:\"entity_views_handler_field_numeric\";s:4:\"type\";s:7:\"integer\";}}s:6:\"is_new\";a:3:{s:5:\"title\";s:6:\"Is new\";s:4:\"help\";s:58:\"Whether the node is new and not saved to the database yet.\";s:5:\"field\";a:2:{s:7:\"handler\";s:34:\"entity_views_handler_field_boolean\";s:4:\"type\";s:7:\"boolean\";}}s:4:\"type\";a:3:{s:5:\"title\";s:12:\"Content type\";s:4:\"help\";s:21:\"The type of the node.\";s:5:\"field\";a:3:{s:7:\"handler\";s:34:\"entity_views_handler_field_options\";s:4:\"type\";s:5:\"token\";s:16:\"options callback\";a:2:{s:8:\"function\";s:19:\"node_type_get_names\";s:4:\"info\";a:9:{s:5:\"label\";s:12:\"Content type\";s:4:\"type\";s:5:\"token\";s:11:\"description\";s:21:\"The type of the node.\";s:15:\"setter callback\";s:28:\"entity_property_verbatim_set\";s:17:\"setter permission\";s:16:\"administer nodes\";s:12:\"options list\";s:19:\"node_type_get_names\";s:8:\"required\";b:1;s:12:\"schema field\";s:4:\"type\";s:15:\"getter callback\";s:28:\"entity_property_verbatim_get\";}}}}s:5:\"title\";a:3:{s:5:\"title\";s:5:\"Title\";s:4:\"help\";s:22:\"The title of the node.\";s:5:\"field\";a:2:{s:7:\"handler\";s:31:\"entity_views_handler_field_text\";s:4:\"type\";s:4:\"text\";}}s:8:\"language\";a:3:{s:5:\"title\";s:8:\"Language\";s:4:\"help\";s:36:\"The language the node is written in.\";s:5:\"field\";a:3:{s:7:\"handler\";s:34:\"entity_views_handler_field_options\";s:4:\"type\";s:5:\"token\";s:16:\"options callback\";a:2:{s:8:\"function\";s:29:\"entity_metadata_language_list\";s:4:\"info\";a:8:{s:5:\"label\";s:8:\"Language\";s:4:\"type\";s:5:\"token\";s:11:\"description\";s:36:\"The language the node is written in.\";s:15:\"setter callback\";s:28:\"entity_property_verbatim_set\";s:12:\"options list\";s:29:\"entity_metadata_language_list\";s:12:\"schema field\";s:8:\"language\";s:17:\"setter permission\";s:16:\"administer nodes\";s:15:\"getter callback\";s:28:\"entity_property_verbatim_get\";}}}}s:3:\"url\";a:3:{s:5:\"title\";s:3:\"URL\";s:4:\"help\";s:20:\"The URL of the node.\";s:5:\"field\";a:2:{s:7:\"handler\";s:30:\"entity_views_handler_field_uri\";s:4:\"type\";s:3:\"uri\";}}s:8:\"edit_url\";a:3:{s:5:\"title\";s:8:\"Edit URL\";s:4:\"help\";s:32:\"The URL of the node\'s edit page.\";s:5:\"field\";a:2:{s:7:\"handler\";s:30:\"entity_views_handler_field_uri\";s:4:\"type\";s:3:\"uri\";}}s:6:\"status\";a:3:{s:5:\"title\";s:6:\"Status\";s:4:\"help\";s:45:\"Whether the node is published or unpublished.\";s:5:\"field\";a:3:{s:7:\"handler\";s:34:\"entity_views_handler_field_options\";s:4:\"type\";s:7:\"integer\";s:16:\"options callback\";a:2:{s:8:\"function\";s:35:\"entity_metadata_status_options_list\";s:4:\"info\";a:8:{s:5:\"label\";s:6:\"Status\";s:11:\"description\";s:45:\"Whether the node is published or unpublished.\";s:4:\"type\";s:7:\"integer\";s:12:\"options list\";s:35:\"entity_metadata_status_options_list\";s:15:\"setter callback\";s:28:\"entity_property_verbatim_set\";s:17:\"setter permission\";s:16:\"administer nodes\";s:12:\"schema field\";s:6:\"status\";s:15:\"getter callback\";s:28:\"entity_property_verbatim_get\";}}}}s:7:\"promote\";a:3:{s:5:\"title\";s:21:\"Promoted to frontpage\";s:4:\"help\";s:46:\"Whether the node is promoted to the frontpage.\";s:5:\"field\";a:2:{s:7:\"handler\";s:34:\"entity_views_handler_field_boolean\";s:4:\"type\";s:7:\"boolean\";}}s:6:\"sticky\";a:3:{s:5:\"title\";s:15:\"Sticky in lists\";s:4:\"help\";s:70:\"Whether the node is displayed at the top of lists in which it appears.\";s:5:\"field\";a:2:{s:7:\"handler\";s:34:\"entity_views_handler_field_boolean\";s:4:\"type\";s:7:\"boolean\";}}s:7:\"created\";a:3:{s:5:\"title\";s:12:\"Date created\";s:4:\"help\";s:29:\"The date the node was posted.\";s:5:\"field\";a:2:{s:7:\"handler\";s:31:\"entity_views_handler_field_date\";s:4:\"type\";s:4:\"date\";}}s:7:\"changed\";a:3:{s:5:\"title\";s:12:\"Date changed\";s:4:\"help\";s:44:\"The date the node was most recently updated.\";s:5:\"field\";a:2:{s:7:\"handler\";s:31:\"entity_views_handler_field_date\";s:4:\"type\";s:4:\"date\";}}s:6:\"author\";a:4:{s:5:\"title\";s:6:\"Author\";s:4:\"help\";s:23:\"The author of the node.\";s:5:\"field\";a:2:{s:7:\"handler\";s:33:\"entity_views_handler_field_entity\";s:4:\"type\";s:4:\"user\";}s:12:\"relationship\";a:5:{s:7:\"handler\";s:33:\"entity_views_handler_relationship\";s:4:\"base\";s:11:\"entity_user\";s:10:\"base field\";s:3:\"uid\";s:18:\"relationship field\";s:6:\"author\";s:5:\"label\";s:6:\"Author\";}}s:6:\"source\";a:4:{s:5:\"title\";s:23:\"Translation source node\";s:4:\"help\";s:58:\"The original-language version of this node, if one exists.\";s:5:\"field\";a:2:{s:7:\"handler\";s:33:\"entity_views_handler_field_entity\";s:4:\"type\";s:4:\"node\";}s:12:\"relationship\";a:5:{s:7:\"handler\";s:33:\"entity_views_handler_relationship\";s:4:\"base\";s:11:\"entity_node\";s:10:\"base field\";s:3:\"nid\";s:18:\"relationship field\";s:6:\"source\";s:5:\"label\";s:23:\"Translation source node\";}}s:3:\"log\";a:3:{s:5:\"title\";s:20:\"Revision log message\";s:4:\"help\";s:93:\"In case a new revision is to be saved, the log entry explaining the changes for this version.\";s:5:\"field\";a:2:{s:7:\"handler\";s:31:\"entity_views_handler_field_text\";s:4:\"type\";s:4:\"text\";}}s:8:\"revision\";a:3:{s:5:\"title\";s:16:\"Creates revision\";s:4:\"help\";s:48:\"Whether saving this node creates a new revision.\";s:5:\"field\";a:2:{s:7:\"handler\";s:34:\"entity_views_handler_field_boolean\";s:4:\"type\";s:7:\"boolean\";}}s:4:\"book\";a:4:{s:5:\"title\";s:4:\"Book\";s:4:\"help\";s:60:\"If part of a book, the book to which this book page belongs.\";s:5:\"field\";a:2:{s:7:\"handler\";s:33:\"entity_views_handler_field_entity\";s:4:\"type\";s:4:\"node\";}s:12:\"relationship\";a:5:{s:7:\"handler\";s:33:\"entity_views_handler_relationship\";s:4:\"base\";s:11:\"entity_node\";s:10:\"base field\";s:3:\"nid\";s:18:\"relationship field\";s:4:\"book\";s:5:\"label\";s:4:\"Book\";}}s:14:\"book_ancestors\";a:4:{s:5:\"title\";s:14:\"Book ancestors\";s:4:\"help\";s:74:\"If part of a book, a list of all book pages upwards in the book hierarchy.\";s:5:\"field\";a:2:{s:7:\"handler\";s:33:\"entity_views_handler_field_entity\";s:4:\"type\";s:10:\"list<node>\";}s:12:\"relationship\";a:6:{s:7:\"handler\";s:33:\"entity_views_handler_relationship\";s:4:\"base\";s:11:\"entity_node\";s:10:\"base field\";s:3:\"nid\";s:18:\"relationship field\";s:14:\"book_ancestors\";s:5:\"label\";s:14:\"Book ancestors\";s:8:\"multiple\";b:1;}}s:7:\"comment\";a:3:{s:5:\"title\";s:16:\"Comments allowed\";s:4:\"help\";s:97:\"Whether comments are allowed on this node: 0 = no, 1 = closed (read only), 2 = open (read/write).\";s:5:\"field\";a:2:{s:7:\"handler\";s:34:\"entity_views_handler_field_numeric\";s:4:\"type\";s:7:\"integer\";}}s:8:\"comments\";a:4:{s:5:\"title\";s:8:\"Comments\";s:4:\"help\";s:18:\"The node comments.\";s:5:\"field\";a:2:{s:7:\"handler\";s:33:\"entity_views_handler_field_entity\";s:4:\"type\";s:13:\"list<comment>\";}s:12:\"relationship\";a:6:{s:7:\"handler\";s:33:\"entity_views_handler_relationship\";s:4:\"base\";s:14:\"entity_comment\";s:10:\"base field\";s:3:\"cid\";s:18:\"relationship field\";s:8:\"comments\";s:5:\"label\";s:8:\"Comments\";s:8:\"multiple\";b:1;}}s:13:\"comment_count\";a:3:{s:5:\"title\";s:13:\"Comment count\";s:4:\"help\";s:40:\"The number of comments posted on a node.\";s:5:\"field\";a:2:{s:7:\"handler\";s:34:\"entity_views_handler_field_numeric\";s:4:\"type\";s:7:\"integer\";}}s:17:\"comment_count_new\";a:3:{s:5:\"title\";s:17:\"New comment count\";s:4:\"help\";s:72:\"The number of comments posted on a node since the reader last viewed it.\";s:5:\"field\";a:2:{s:7:\"handler\";s:34:\"entity_views_handler_field_numeric\";s:4:\"type\";s:7:\"integer\";}}s:4:\"body\";a:3:{s:5:\"title\";s:18:\"The main body text\";s:4:\"help\";s:26:\"(No information available)\";s:5:\"field\";a:6:{s:7:\"handler\";s:32:\"entity_views_handler_field_field\";s:4:\"type\";s:14:\"text_formatted\";s:10:\"field_name\";s:4:\"body\";s:13:\"entity_tables\";a:0:{}s:11:\"entity type\";s:4:\"node\";s:11:\"is revision\";b:0;}}s:10:\"body_value\";a:4:{s:5:\"title\";s:26:\"The main body text » Text\";s:4:\"help\";s:26:\"(No information available)\";s:5:\"field\";a:2:{s:7:\"handler\";s:31:\"entity_views_handler_field_text\";s:4:\"type\";s:4:\"text\";}s:10:\"real field\";s:10:\"body:value\";}s:12:\"body_summary\";a:4:{s:5:\"title\";s:29:\"The main body text » Summary\";s:4:\"help\";s:26:\"(No information available)\";s:5:\"field\";a:2:{s:7:\"handler\";s:31:\"entity_views_handler_field_text\";s:4:\"type\";s:4:\"text\";}s:10:\"real field\";s:12:\"body:summary\";}s:11:\"body_format\";a:4:{s:5:\"title\";s:33:\"The main body text » Text format\";s:4:\"help\";s:26:\"(No information available)\";s:5:\"field\";a:3:{s:7:\"handler\";s:34:\"entity_views_handler_field_options\";s:4:\"type\";s:5:\"token\";s:16:\"options callback\";a:2:{s:8:\"function\";s:34:\"entity_metadata_field_text_formats\";s:4:\"info\";a:6:{s:4:\"type\";s:5:\"token\";s:5:\"label\";s:11:\"Text format\";s:12:\"options list\";s:34:\"entity_metadata_field_text_formats\";s:15:\"getter callback\";s:28:\"entity_property_verbatim_get\";s:15:\"setter callback\";s:28:\"entity_property_verbatim_set\";s:18:\"setter permissions\";s:18:\"administer filters\";}}}s:10:\"real field\";s:11:\"body:format\";}s:5:\"views\";a:3:{s:5:\"title\";s:15:\"Number of views\";s:4:\"help\";s:46:\"The number of visitors who have read the node.\";s:5:\"field\";a:2:{s:7:\"handler\";s:34:\"entity_views_handler_field_numeric\";s:4:\"type\";s:7:\"integer\";}}s:9:\"day_views\";a:3:{s:5:\"title\";s:11:\"Views today\";s:4:\"help\";s:52:\"The number of visitors who have read the node today.\";s:5:\"field\";a:2:{s:7:\"handler\";s:34:\"entity_views_handler_field_numeric\";s:4:\"type\";s:7:\"integer\";}}s:9:\"last_view\";a:3:{s:5:\"title\";s:9:\"Last view\";s:4:\"help\";s:47:\"The date on which a visitor last read the node.\";s:5:\"field\";a:2:{s:7:\"handler\";s:31:\"entity_views_handler_field_date\";s:4:\"type\";s:4:\"date\";}}s:10:\"field_tags\";a:4:{s:5:\"title\";s:4:\"Tags\";s:4:\"help\";s:19:\"Field \"field_tags\".\";s:5:\"field\";a:2:{s:7:\"handler\";s:33:\"entity_views_handler_field_entity\";s:4:\"type\";s:19:\"list<taxonomy_term>\";}s:12:\"relationship\";a:6:{s:7:\"handler\";s:33:\"entity_views_handler_relationship\";s:4:\"base\";s:20:\"entity_taxonomy_term\";s:10:\"base field\";s:3:\"tid\";s:18:\"relationship field\";s:10:\"field_tags\";s:5:\"label\";s:4:\"Tags\";s:8:\"multiple\";b:1;}}s:11:\"field_image\";a:3:{s:5:\"title\";s:5:\"Image\";s:4:\"help\";s:20:\"Field \"field_image\".\";s:5:\"field\";a:6:{s:7:\"handler\";s:32:\"entity_views_handler_field_field\";s:4:\"type\";s:16:\"field_item_image\";s:10:\"field_name\";s:11:\"field_image\";s:13:\"entity_tables\";a:0:{}s:11:\"entity type\";s:4:\"node\";s:11:\"is revision\";b:0;}}s:16:\"field_image_file\";a:5:{s:5:\"title\";s:24:\"Image » The image file.\";s:4:\"help\";s:26:\"(No information available)\";s:5:\"field\";a:2:{s:7:\"handler\";s:33:\"entity_views_handler_field_entity\";s:4:\"type\";s:4:\"file\";}s:10:\"real field\";s:16:\"field_image:file\";s:12:\"relationship\";a:5:{s:7:\"handler\";s:33:\"entity_views_handler_relationship\";s:4:\"base\";s:11:\"entity_file\";s:10:\"base field\";s:3:\"fid\";s:18:\"relationship field\";s:16:\"field_image:file\";s:5:\"label\";s:24:\"Image » The image file.\";}}s:15:\"field_image_alt\";a:4:{s:5:\"title\";s:33:\"Image » The \"Alt\" attribute text\";s:4:\"help\";s:26:\"(No information available)\";s:5:\"field\";a:2:{s:7:\"handler\";s:31:\"entity_views_handler_field_text\";s:4:\"type\";s:4:\"text\";}s:10:\"real field\";s:15:\"field_image:alt\";}s:13:\"field_section\";a:4:{s:5:\"title\";s:7:\"Section\";s:4:\"help\";s:22:\"Field \"field_section\".\";s:5:\"field\";a:2:{s:7:\"handler\";s:33:\"entity_views_handler_field_entity\";s:4:\"type\";s:13:\"taxonomy_term\";}s:12:\"relationship\";a:5:{s:7:\"handler\";s:33:\"entity_views_handler_relationship\";s:4:\"base\";s:20:\"entity_taxonomy_term\";s:10:\"base field\";s:3:\"tid\";s:18:\"relationship field\";s:13:\"field_section\";s:5:\"label\";s:7:\"Section\";}}s:14:\"field_category\";a:4:{s:5:\"title\";s:8:\"Category\";s:4:\"help\";s:23:\"Field \"field_category\".\";s:5:\"field\";a:2:{s:7:\"handler\";s:33:\"entity_views_handler_field_entity\";s:4:\"type\";s:13:\"taxonomy_term\";}s:12:\"relationship\";a:5:{s:7:\"handler\";s:33:\"entity_views_handler_relationship\";s:4:\"base\";s:20:\"entity_taxonomy_term\";s:10:\"base field\";s:3:\"tid\";s:18:\"relationship field\";s:14:\"field_category\";s:5:\"label\";s:8:\"Category\";}}s:19:\"field_extra_content\";a:4:{s:5:\"title\";s:13:\"Extra content\";s:4:\"help\";s:28:\"Field \"field_extra_content\".\";s:5:\"field\";a:2:{s:7:\"handler\";s:33:\"entity_views_handler_field_entity\";s:4:\"type\";s:27:\"list<field_collection_item>\";}s:12:\"relationship\";a:6:{s:7:\"handler\";s:33:\"entity_views_handler_relationship\";s:4:\"base\";s:28:\"entity_field_collection_item\";s:10:\"base field\";s:7:\"item_id\";s:18:\"relationship field\";s:19:\"field_extra_content\";s:5:\"label\";s:13:\"Extra content\";s:8:\"multiple\";b:1;}}s:10:\"field_vote\";a:3:{s:5:\"title\";s:4:\"Vote\";s:4:\"help\";s:19:\"Field \"field_vote\".\";s:5:\"field\";a:6:{s:7:\"handler\";s:32:\"entity_views_handler_field_field\";s:4:\"type\";s:8:\"fivestar\";s:10:\"field_name\";s:10:\"field_vote\";s:13:\"entity_tables\";a:0:{}s:11:\"entity type\";s:4:\"node\";s:11:\"is revision\";b:0;}}s:25:\"field_vote_average_rating\";a:4:{s:5:\"title\";s:22:\"Vote » Average Rating\";s:4:\"help\";s:26:\"(No information available)\";s:5:\"field\";a:2:{s:7:\"handler\";s:31:\"entity_views_handler_field_text\";s:4:\"type\";s:4:\"text\";}s:10:\"real field\";s:25:\"field_vote:average_rating\";}s:22:\"field_vote_user_rating\";a:4:{s:5:\"title\";s:21:\"Vote » User\'s Rating\";s:4:\"help\";s:26:\"(No information available)\";s:5:\"field\";a:2:{s:7:\"handler\";s:31:\"entity_views_handler_field_text\";s:4:\"type\";s:4:\"text\";}s:10:\"real field\";s:22:\"field_vote:user_rating\";}s:23:\"field_vote_rating_count\";a:4:{s:5:\"title\";s:20:\"Vote » Rating count\";s:4:\"help\";s:26:\"(No information available)\";s:5:\"field\";a:2:{s:7:\"handler\";s:31:\"entity_views_handler_field_text\";s:4:\"type\";s:4:\"text\";}s:10:\"real field\";s:23:\"field_vote:rating_count\";}s:15:\"taxonomy_forums\";a:4:{s:5:\"title\";s:6:\"Forums\";s:4:\"help\";s:24:\"Field \"taxonomy_forums\".\";s:5:\"field\";a:2:{s:7:\"handler\";s:33:\"entity_views_handler_field_entity\";s:4:\"type\";s:13:\"taxonomy_term\";}s:12:\"relationship\";a:5:{s:7:\"handler\";s:33:\"entity_views_handler_relationship\";s:4:\"base\";s:20:\"entity_taxonomy_term\";s:10:\"base field\";s:3:\"tid\";s:18:\"relationship field\";s:15:\"taxonomy_forums\";s:5:\"label\";s:6:\"Forums\";}}s:23:\"field_detailed_question\";a:3:{s:5:\"title\";s:17:\"Detailed question\";s:4:\"help\";s:32:\"Field \"field_detailed_question\".\";s:5:\"field\";a:6:{s:7:\"handler\";s:32:\"entity_views_handler_field_field\";s:4:\"type\";s:14:\"text_formatted\";s:10:\"field_name\";s:23:\"field_detailed_question\";s:13:\"entity_tables\";a:0:{}s:11:\"entity type\";s:4:\"node\";s:11:\"is revision\";b:0;}}s:29:\"field_detailed_question_value\";a:4:{s:5:\"title\";s:25:\"Detailed question » Text\";s:4:\"help\";s:26:\"(No information available)\";s:5:\"field\";a:2:{s:7:\"handler\";s:31:\"entity_views_handler_field_text\";s:4:\"type\";s:4:\"text\";}s:10:\"real field\";s:29:\"field_detailed_question:value\";}s:30:\"field_detailed_question_format\";a:4:{s:5:\"title\";s:32:\"Detailed question » Text format\";s:4:\"help\";s:26:\"(No information available)\";s:5:\"field\";a:3:{s:7:\"handler\";s:34:\"entity_views_handler_field_options\";s:4:\"type\";s:5:\"token\";s:16:\"options callback\";a:2:{s:8:\"function\";s:34:\"entity_metadata_field_text_formats\";s:4:\"info\";a:6:{s:4:\"type\";s:5:\"token\";s:5:\"label\";s:11:\"Text format\";s:12:\"options list\";s:34:\"entity_metadata_field_text_formats\";s:15:\"getter callback\";s:28:\"entity_property_verbatim_get\";s:15:\"setter callback\";s:28:\"entity_property_verbatim_set\";s:18:\"setter permissions\";s:18:\"administer filters\";}}}s:10:\"real field\";s:30:\"field_detailed_question:format\";}s:16:\"field_video_link\";a:3:{s:5:\"title\";s:10:\"Video Link\";s:4:\"help\";s:25:\"Field \"field_video_link\".\";s:5:\"field\";a:6:{s:7:\"handler\";s:32:\"entity_views_handler_field_field\";s:4:\"type\";s:17:\"video_embed_field\";s:10:\"field_name\";s:16:\"field_video_link\";s:13:\"entity_tables\";a:0:{}s:11:\"entity type\";s:4:\"node\";s:11:\"is revision\";b:0;}}s:26:\"field_video_link_video_url\";a:4:{s:5:\"title\";s:23:\"Video Link » Video URL\";s:4:\"help\";s:59:\"Video URL of field <em class=\"placeholder\">Video embed</em>\";s:5:\"field\";a:2:{s:7:\"handler\";s:30:\"entity_views_handler_field_uri\";s:4:\"type\";s:3:\"uri\";}s:10:\"real field\";s:26:\"field_video_link:video_url\";}s:31:\"field_video_link_thumbnail_path\";a:4:{s:5:\"title\";s:28:\"Video Link » Thumbnail path\";s:4:\"help\";s:64:\"Thumbnail path of field <em class=\"placeholder\">Video embed</em>\";s:5:\"field\";a:2:{s:7:\"handler\";s:30:\"entity_views_handler_field_uri\";s:4:\"type\";s:3:\"uri\";}s:10:\"real field\";s:31:\"field_video_link:thumbnail_path\";}s:28:\"field_video_link_description\";a:4:{s:5:\"title\";s:25:\"Video Link » Description\";s:4:\"help\";s:61:\"Description of field <em class=\"placeholder\">Video embed</em>\";s:5:\"field\";a:2:{s:7:\"handler\";s:31:\"entity_views_handler_field_text\";s:4:\"type\";s:4:\"text\";}s:10:\"real field\";s:28:\"field_video_link:description\";}s:10:\"field_link\";a:3:{s:5:\"title\";s:4:\"Link\";s:4:\"help\";s:19:\"Field \"field_link\".\";s:5:\"field\";a:6:{s:7:\"handler\";s:32:\"entity_views_handler_field_field\";s:4:\"type\";s:15:\"field_item_link\";s:10:\"field_name\";s:10:\"field_link\";s:13:\"entity_tables\";a:0:{}s:11:\"entity type\";s:4:\"node\";s:11:\"is revision\";b:0;}}s:16:\"field_link_title\";a:4:{s:5:\"title\";s:30:\"Link » The title of the link.\";s:4:\"help\";s:26:\"(No information available)\";s:5:\"field\";a:2:{s:7:\"handler\";s:31:\"entity_views_handler_field_text\";s:4:\"type\";s:4:\"text\";}s:10:\"real field\";s:16:\"field_link:title\";}s:14:\"field_link_url\";a:4:{s:5:\"title\";s:28:\"Link » The URL of the link.\";s:4:\"help\";s:26:\"(No information available)\";s:5:\"field\";a:2:{s:7:\"handler\";s:30:\"entity_views_handler_field_uri\";s:4:\"type\";s:3:\"uri\";}s:10:\"real field\";s:14:\"field_link:url\";}}s:17:\"views_entity_node\";a:5:{s:15:\"rendered_entity\";a:3:{s:5:\"title\";s:13:\"Rendered Node\";s:4:\"help\";s:64:\"The Node of the current relationship rendered using a view mode.\";s:5:\"field\";a:3:{s:7:\"handler\";s:33:\"entity_views_handler_field_entity\";s:4:\"type\";s:4:\"node\";s:10:\"real field\";s:13:\"entity object\";}}s:5:\"table\";a:3:{s:5:\"group\";s:7:\"Content\";s:4:\"join\";a:4:{s:4:\"node\";a:1:{s:10:\"left_table\";s:4:\"node\";}s:13:\"node_revision\";a:1:{s:10:\"left_table\";s:13:\"node_revision\";}s:11:\"entity_node\";a:1:{s:10:\"left_table\";s:11:\"entity_node\";}s:17:\"views_entity_node\";a:1:{s:10:\"left_table\";s:17:\"views_entity_node\";}}s:11:\"entity type\";s:4:\"node\";}s:9:\"view_node\";a:1:{s:5:\"field\";a:3:{s:5:\"title\";s:4:\"Link\";s:4:\"help\";s:37:\"Provide a simple link to the content.\";s:7:\"handler\";s:29:\"views_handler_field_node_link\";}}s:9:\"edit_node\";a:1:{s:5:\"field\";a:3:{s:5:\"title\";s:9:\"Edit link\";s:4:\"help\";s:42:\"Provide a simple link to edit the content.\";s:7:\"handler\";s:34:\"views_handler_field_node_link_edit\";}}s:11:\"delete_node\";a:1:{s:5:\"field\";a:3:{s:5:\"title\";s:11:\"Delete link\";s:4:\"help\";s:44:\"Provide a simple link to delete the content.\";s:7:\"handler\";s:36:\"views_handler_field_node_link_delete\";}}}s:11:\"entity_file\";a:8:{s:5:\"table\";a:2:{s:5:\"group\";s:4:\"File\";s:11:\"entity type\";s:4:\"file\";}s:3:\"fid\";a:3:{s:5:\"title\";s:7:\"File ID\";s:4:\"help\";s:35:\"The unique ID of the uploaded file.\";s:5:\"field\";a:2:{s:7:\"handler\";s:34:\"entity_views_handler_field_numeric\";s:4:\"type\";s:7:\"integer\";}}s:4:\"name\";a:3:{s:5:\"title\";s:9:\"File name\";s:4:\"help\";s:29:\"The name of the file on disk.\";s:5:\"field\";a:2:{s:7:\"handler\";s:31:\"entity_views_handler_field_text\";s:4:\"type\";s:4:\"text\";}}s:4:\"mime\";a:3:{s:5:\"title\";s:9:\"MIME type\";s:4:\"help\";s:26:\"The MIME type of the file.\";s:5:\"field\";a:2:{s:7:\"handler\";s:31:\"entity_views_handler_field_text\";s:4:\"type\";s:4:\"text\";}}s:4:\"size\";a:3:{s:5:\"title\";s:9:\"File size\";s:4:\"help\";s:35:\"The size of the file, in kilobytes.\";s:5:\"field\";a:2:{s:7:\"handler\";s:34:\"entity_views_handler_field_numeric\";s:4:\"type\";s:7:\"integer\";}}s:3:\"url\";a:3:{s:5:\"title\";s:3:\"URL\";s:4:\"help\";s:36:\"The web-accessible URL for the file.\";s:5:\"field\";a:2:{s:7:\"handler\";s:31:\"entity_views_handler_field_text\";s:4:\"type\";s:4:\"text\";}}s:9:\"timestamp\";a:3:{s:5:\"title\";s:9:\"Timestamp\";s:4:\"help\";s:44:\"The date the file was most recently changed.\";s:5:\"field\";a:2:{s:7:\"handler\";s:31:\"entity_views_handler_field_date\";s:4:\"type\";s:4:\"date\";}}s:5:\"owner\";a:4:{s:5:\"title\";s:5:\"Owner\";s:4:\"help\";s:42:\"The user who originally uploaded the file.\";s:5:\"field\";a:2:{s:7:\"handler\";s:33:\"entity_views_handler_field_entity\";s:4:\"type\";s:4:\"user\";}s:12:\"relationship\";a:5:{s:7:\"handler\";s:33:\"entity_views_handler_relationship\";s:4:\"base\";s:11:\"entity_user\";s:10:\"base field\";s:3:\"uid\";s:18:\"relationship field\";s:5:\"owner\";s:5:\"label\";s:5:\"Owner\";}}}s:17:\"views_entity_file\";a:1:{s:5:\"table\";a:3:{s:4:\"join\";a:3:{s:12:\"file_managed\";a:1:{s:10:\"left_table\";s:12:\"file_managed\";}s:11:\"entity_file\";a:1:{s:10:\"left_table\";s:11:\"entity_file\";}s:17:\"views_entity_file\";a:1:{s:10:\"left_table\";s:17:\"views_entity_file\";}}s:11:\"entity type\";s:4:\"file\";s:5:\"group\";s:4:\"File\";}}s:20:\"entity_taxonomy_term\";a:10:{s:5:\"table\";a:2:{s:5:\"group\";s:13:\"Taxonomy term\";s:11:\"entity type\";s:13:\"taxonomy_term\";}s:3:\"tid\";a:3:{s:5:\"title\";s:7:\"Term ID\";s:4:\"help\";s:35:\"The unique ID of the taxonomy term.\";s:5:\"field\";a:2:{s:7:\"handler\";s:34:\"entity_views_handler_field_numeric\";s:4:\"type\";s:7:\"integer\";}}s:4:\"name\";a:3:{s:5:\"title\";s:4:\"Name\";s:4:\"help\";s:30:\"The name of the taxonomy term.\";s:5:\"field\";a:2:{s:7:\"handler\";s:31:\"entity_views_handler_field_text\";s:4:\"type\";s:4:\"text\";}}s:11:\"description\";a:3:{s:5:\"title\";s:11:\"Description\";s:4:\"help\";s:46:\"The optional description of the taxonomy term.\";s:5:\"field\";a:2:{s:7:\"handler\";s:31:\"entity_views_handler_field_text\";s:4:\"type\";s:4:\"text\";}}s:6:\"weight\";a:3:{s:5:\"title\";s:6:\"Weight\";s:4:\"help\";s:72:\"The weight of the term, which is used for ordering terms during display.\";s:5:\"field\";a:2:{s:7:\"handler\";s:34:\"entity_views_handler_field_numeric\";s:4:\"type\";s:7:\"integer\";}}s:10:\"node_count\";a:3:{s:5:\"title\";s:10:\"Node count\";s:4:\"help\";s:50:\"The number of nodes tagged with the taxonomy term.\";s:5:\"field\";a:2:{s:7:\"handler\";s:34:\"entity_views_handler_field_numeric\";s:4:\"type\";s:7:\"integer\";}}s:3:\"url\";a:3:{s:5:\"title\";s:3:\"URL\";s:4:\"help\";s:29:\"The URL of the taxonomy term.\";s:5:\"field\";a:2:{s:7:\"handler\";s:30:\"entity_views_handler_field_uri\";s:4:\"type\";s:3:\"uri\";}}s:10:\"vocabulary\";a:4:{s:5:\"title\";s:10:\"Vocabulary\";s:4:\"help\";s:44:\"The vocabulary the taxonomy term belongs to.\";s:5:\"field\";a:2:{s:7:\"handler\";s:33:\"entity_views_handler_field_entity\";s:4:\"type\";s:19:\"taxonomy_vocabulary\";}s:12:\"relationship\";a:5:{s:7:\"handler\";s:33:\"entity_views_handler_relationship\";s:4:\"base\";s:26:\"entity_taxonomy_vocabulary\";s:10:\"base field\";s:3:\"vid\";s:18:\"relationship field\";s:10:\"vocabulary\";s:5:\"label\";s:10:\"Vocabulary\";}}s:6:\"parent\";a:4:{s:5:\"title\";s:12:\"Parent terms\";s:4:\"help\";s:38:\"The parent terms of the taxonomy term.\";s:5:\"field\";a:2:{s:7:\"handler\";s:33:\"entity_views_handler_field_entity\";s:4:\"type\";s:19:\"list<taxonomy_term>\";}s:12:\"relationship\";a:6:{s:7:\"handler\";s:33:\"entity_views_handler_relationship\";s:4:\"base\";s:20:\"entity_taxonomy_term\";s:10:\"base field\";s:3:\"tid\";s:18:\"relationship field\";s:6:\"parent\";s:5:\"label\";s:12:\"Parent terms\";s:8:\"multiple\";b:1;}}s:11:\"parents_all\";a:4:{s:5:\"title\";s:16:\"All parent terms\";s:4:\"help\";s:65:\"Ancestors of the term, i.e. parent of all above hierarchy levels.\";s:5:\"field\";a:2:{s:7:\"handler\";s:33:\"entity_views_handler_field_entity\";s:4:\"type\";s:19:\"list<taxonomy_term>\";}s:12:\"relationship\";a:6:{s:7:\"handler\";s:33:\"entity_views_handler_relationship\";s:4:\"base\";s:20:\"entity_taxonomy_term\";s:10:\"base field\";s:3:\"tid\";s:18:\"relationship field\";s:11:\"parents_all\";s:5:\"label\";s:16:\"All parent terms\";s:8:\"multiple\";b:1;}}}s:26:\"views_entity_taxonomy_term\";a:2:{s:15:\"rendered_entity\";a:3:{s:5:\"title\";s:22:\"Rendered Taxonomy term\";s:4:\"help\";s:73:\"The Taxonomy term of the current relationship rendered using a view mode.\";s:5:\"field\";a:3:{s:7:\"handler\";s:33:\"entity_views_handler_field_entity\";s:4:\"type\";s:13:\"taxonomy_term\";s:10:\"real field\";s:13:\"entity object\";}}s:5:\"table\";a:3:{s:4:\"join\";a:3:{s:18:\"taxonomy_term_data\";a:1:{s:10:\"left_table\";s:18:\"taxonomy_term_data\";}s:20:\"entity_taxonomy_term\";a:1:{s:10:\"left_table\";s:20:\"entity_taxonomy_term\";}s:26:\"views_entity_taxonomy_term\";a:1:{s:10:\"left_table\";s:26:\"views_entity_taxonomy_term\";}}s:11:\"entity type\";s:13:\"taxonomy_term\";s:5:\"group\";s:13:\"Taxonomy term\";}}s:26:\"entity_taxonomy_vocabulary\";a:6:{s:5:\"table\";a:2:{s:5:\"group\";s:19:\"Taxonomy vocabulary\";s:11:\"entity type\";s:19:\"taxonomy_vocabulary\";}s:3:\"vid\";a:3:{s:5:\"title\";s:13:\"Vocabulary ID\";s:4:\"help\";s:41:\"The unique ID of the taxonomy vocabulary.\";s:5:\"field\";a:2:{s:7:\"handler\";s:34:\"entity_views_handler_field_numeric\";s:4:\"type\";s:7:\"integer\";}}s:4:\"name\";a:3:{s:5:\"title\";s:4:\"Name\";s:4:\"help\";s:36:\"The name of the taxonomy vocabulary.\";s:5:\"field\";a:2:{s:7:\"handler\";s:31:\"entity_views_handler_field_text\";s:4:\"type\";s:4:\"text\";}}s:12:\"machine_name\";a:3:{s:5:\"title\";s:12:\"Machine name\";s:4:\"help\";s:44:\"The machine name of the taxonomy vocabulary.\";s:5:\"field\";a:2:{s:7:\"handler\";s:31:\"entity_views_handler_field_text\";s:4:\"type\";s:5:\"token\";}}s:11:\"description\";a:3:{s:5:\"title\";s:11:\"Description\";s:4:\"help\";s:52:\"The optional description of the taxonomy vocabulary.\";s:5:\"field\";a:2:{s:7:\"handler\";s:31:\"entity_views_handler_field_text\";s:4:\"type\";s:4:\"text\";}}s:10:\"term_count\";a:3:{s:5:\"title\";s:10:\"Term count\";s:4:\"help\";s:57:\"The number of terms belonging to the taxonomy vocabulary.\";s:5:\"field\";a:2:{s:7:\"handler\";s:34:\"entity_views_handler_field_numeric\";s:4:\"type\";s:7:\"integer\";}}}s:32:\"views_entity_taxonomy_vocabulary\";a:1:{s:5:\"table\";a:3:{s:4:\"join\";a:2:{s:26:\"entity_taxonomy_vocabulary\";a:1:{s:10:\"left_table\";s:26:\"entity_taxonomy_vocabulary\";}s:32:\"views_entity_taxonomy_vocabulary\";a:1:{s:10:\"left_table\";s:32:\"views_entity_taxonomy_vocabulary\";}}s:11:\"entity type\";s:19:\"taxonomy_vocabulary\";s:5:\"group\";s:19:\"Taxonomy vocabulary\";}}s:11:\"entity_user\";a:13:{s:5:\"table\";a:2:{s:5:\"group\";s:4:\"User\";s:11:\"entity type\";s:4:\"user\";}s:3:\"uid\";a:3:{s:5:\"title\";s:7:\"User ID\";s:4:\"help\";s:34:\"The unique ID of the user account.\";s:5:\"field\";a:2:{s:7:\"handler\";s:34:\"entity_views_handler_field_numeric\";s:4:\"type\";s:7:\"integer\";}}s:4:\"name\";a:3:{s:5:\"title\";s:4:\"Name\";s:4:\"help\";s:35:\"The login name of the user account.\";s:5:\"field\";a:2:{s:7:\"handler\";s:31:\"entity_views_handler_field_text\";s:4:\"type\";s:4:\"text\";}}s:4:\"mail\";a:3:{s:5:\"title\";s:5:\"Email\";s:4:\"help\";s:38:\"The email address of the user account.\";s:5:\"field\";a:2:{s:7:\"handler\";s:31:\"entity_views_handler_field_text\";s:4:\"type\";s:4:\"text\";}}s:3:\"url\";a:3:{s:5:\"title\";s:3:\"URL\";s:4:\"help\";s:36:\"The URL of the account profile page.\";s:5:\"field\";a:2:{s:7:\"handler\";s:30:\"entity_views_handler_field_uri\";s:4:\"type\";s:3:\"uri\";}}s:8:\"edit_url\";a:3:{s:5:\"title\";s:8:\"Edit URL\";s:4:\"help\";s:33:\"The url of the account edit page.\";s:5:\"field\";a:2:{s:7:\"handler\";s:30:\"entity_views_handler_field_uri\";s:4:\"type\";s:3:\"uri\";}}s:11:\"last_access\";a:3:{s:5:\"title\";s:11:\"Last access\";s:4:\"help\";s:41:\"The date the user last accessed the site.\";s:5:\"field\";a:2:{s:7:\"handler\";s:31:\"entity_views_handler_field_date\";s:4:\"type\";s:4:\"date\";}}s:10:\"last_login\";a:3:{s:5:\"title\";s:10:\"Last login\";s:4:\"help\";s:45:\"The date the user last logged in to the site.\";s:5:\"field\";a:2:{s:7:\"handler\";s:31:\"entity_views_handler_field_date\";s:4:\"type\";s:4:\"date\";}}s:7:\"created\";a:3:{s:5:\"title\";s:7:\"Created\";s:4:\"help\";s:38:\"The date the user account was created.\";s:5:\"field\";a:2:{s:7:\"handler\";s:31:\"entity_views_handler_field_date\";s:4:\"type\";s:4:\"date\";}}s:5:\"roles\";a:3:{s:5:\"title\";s:10:\"User roles\";s:4:\"help\";s:22:\"The roles of the user.\";s:5:\"field\";a:3:{s:7:\"handler\";s:34:\"entity_views_handler_field_options\";s:4:\"type\";s:13:\"list<integer>\";s:16:\"options callback\";a:2:{s:8:\"function\";s:26:\"entity_metadata_user_roles\";s:4:\"info\";a:7:{s:5:\"label\";s:10:\"User roles\";s:11:\"description\";s:22:\"The roles of the user.\";s:4:\"type\";s:13:\"list<integer>\";s:15:\"getter callback\";s:35:\"entity_metadata_user_get_properties\";s:15:\"setter callback\";s:35:\"entity_metadata_user_set_properties\";s:12:\"options list\";s:26:\"entity_metadata_user_roles\";s:15:\"access callback\";s:38:\"entity_metadata_user_properties_access\";}}}}s:6:\"status\";a:3:{s:5:\"title\";s:6:\"Status\";s:4:\"help\";s:38:\"Whether the user is active or blocked.\";s:5:\"field\";a:3:{s:7:\"handler\";s:34:\"entity_views_handler_field_options\";s:4:\"type\";s:7:\"integer\";s:16:\"options callback\";a:2:{s:8:\"function\";s:40:\"entity_metadata_user_status_options_list\";s:4:\"info\";a:8:{s:5:\"label\";s:6:\"Status\";s:11:\"description\";s:38:\"Whether the user is active or blocked.\";s:15:\"setter callback\";s:28:\"entity_property_verbatim_set\";s:4:\"type\";s:7:\"integer\";s:12:\"options list\";s:40:\"entity_metadata_user_status_options_list\";s:15:\"access callback\";s:38:\"entity_metadata_user_properties_access\";s:12:\"schema field\";s:6:\"status\";s:15:\"getter callback\";s:28:\"entity_property_verbatim_get\";}}}}s:5:\"theme\";a:3:{s:5:\"title\";s:13:\"Default theme\";s:4:\"help\";s:25:\"The user\'s default theme.\";s:5:\"field\";a:2:{s:7:\"handler\";s:31:\"entity_views_handler_field_text\";s:4:\"type\";s:4:\"text\";}}s:8:\"language\";a:3:{s:5:\"title\";s:8:\"Language\";s:4:\"help\";s:90:\"This account\'s default language for e-mails, and preferred language for site presentation.\";s:5:\"field\";a:3:{s:7:\"handler\";s:34:\"entity_views_handler_field_options\";s:4:\"type\";s:5:\"token\";s:16:\"options callback\";a:2:{s:8:\"function\";s:29:\"entity_metadata_language_list\";s:4:\"info\";a:8:{s:5:\"label\";s:8:\"Language\";s:11:\"description\";s:90:\"This account\'s default language for e-mails, and preferred language for site presentation.\";s:4:\"type\";s:5:\"token\";s:15:\"getter callback\";s:40:\"entity_metadata_locale_get_user_language\";s:15:\"setter callback\";s:28:\"entity_property_verbatim_set\";s:12:\"options list\";s:29:\"entity_metadata_language_list\";s:12:\"schema field\";s:8:\"language\";s:17:\"setter permission\";s:16:\"administer users\";}}}}}s:17:\"views_entity_user\";a:2:{s:15:\"rendered_entity\";a:3:{s:5:\"title\";s:13:\"Rendered User\";s:4:\"help\";s:64:\"The User of the current relationship rendered using a view mode.\";s:5:\"field\";a:3:{s:7:\"handler\";s:33:\"entity_views_handler_field_entity\";s:4:\"type\";s:4:\"user\";s:10:\"real field\";s:13:\"entity object\";}}s:5:\"table\";a:3:{s:4:\"join\";a:3:{s:5:\"users\";a:1:{s:10:\"left_table\";s:5:\"users\";}s:11:\"entity_user\";a:1:{s:10:\"left_table\";s:11:\"entity_user\";}s:17:\"views_entity_user\";a:1:{s:10:\"left_table\";s:17:\"views_entity_user\";}}s:11:\"entity type\";s:4:\"user\";s:5:\"group\";s:4:\"User\";}}s:14:\"entity__global\";a:2:{s:5:\"table\";a:2:{s:5:\"group\";s:6:\"Entity\";s:4:\"join\";a:1:{s:7:\"#global\";a:0:{}}}s:6:\"entity\";a:3:{s:5:\"title\";s:15:\"Rendered entity\";s:4:\"help\";s:32:\"Displays a single chosen entity.\";s:4:\"area\";a:1:{s:7:\"handler\";s:32:\"entity_views_handler_area_entity\";}}}s:13:\"faq_questions\";a:3:{s:5:\"table\";a:2:{s:5:\"group\";s:3:\"FAQ\";s:4:\"join\";a:1:{s:4:\"node\";a:2:{s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:3:\"vid\";}}}s:8:\"question\";a:5:{s:5:\"title\";s:18:\"FAQ short question\";s:4:\"help\";s:38:\"The short question text for FAQ nodes.\";s:5:\"field\";a:2:{s:7:\"handler\";s:19:\"views_handler_field\";s:14:\"click sortable\";b:1;}s:4:\"sort\";a:1:{s:7:\"handler\";s:18:\"views_handler_sort\";}s:6:\"filter\";a:1:{s:7:\"handler\";s:27:\"views_handler_filter_string\";}}s:17:\"detailed_question\";a:5:{s:5:\"title\";s:21:\"FAQ detailed question\";s:4:\"help\";s:37:\"The long question text for FAQ nodes.\";s:5:\"field\";a:2:{s:7:\"handler\";s:19:\"views_handler_field\";s:14:\"click sortable\";b:1;}s:4:\"sort\";a:1:{s:7:\"handler\";s:18:\"views_handler_sort\";}s:6:\"filter\";a:1:{s:7:\"handler\";s:27:\"views_handler_filter_string\";}}}s:11:\"faq_weights\";a:4:{s:5:\"table\";a:2:{s:5:\"group\";s:3:\"FAQ\";s:4:\"join\";a:2:{s:4:\"node\";a:2:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:3:\"nid\";}s:18:\"taxonomy_term_data\";a:2:{s:10:\"left_field\";s:3:\"tid\";s:5:\"field\";s:3:\"tid\";}}}s:6:\"weight\";a:5:{s:5:\"title\";s:10:\"FAQ weight\";s:4:\"help\";s:27:\"The weight of the FAQ node.\";s:5:\"field\";a:2:{s:7:\"handler\";s:27:\"views_handler_field_numeric\";s:14:\"click sortable\";b:1;}s:4:\"sort\";a:1:{s:7:\"handler\";s:18:\"views_handler_sort\";}s:6:\"filter\";a:1:{s:7:\"handler\";s:28:\"views_handler_filter_numeric\";}}s:3:\"tid\";a:5:{s:5:\"title\";s:16:\"FAQ category tid\";s:4:\"help\";s:24:\"The tid of the FAQ node.\";s:5:\"field\";a:3:{s:7:\"handler\";s:27:\"views_handler_field_numeric\";s:14:\"click sortable\";b:1;s:12:\"zero is null\";b:0;}s:6:\"filter\";a:7:{s:5:\"title\";s:3:\"Tid\";s:7:\"handler\";s:28:\"views_handler_filter_numeric\";s:15:\"hierarchy table\";s:23:\"taxonomy_term_hierarchy\";s:7:\"numeric\";b:1;s:9:\"skip base\";s:18:\"taxonomy_term_data\";s:11:\"allow empty\";b:1;s:12:\"zero is null\";b:0;}s:12:\"relationship\";a:5:{s:7:\"handler\";s:26:\"views_handler_relationship\";s:5:\"label\";s:8:\"category\";s:4:\"base\";s:14:\"taxonomy_index\";s:10:\"base field\";s:3:\"tid\";s:9:\"skip base\";s:18:\"taxonomy_term_data\";}}s:8:\"category\";a:6:{s:5:\"title\";s:12:\"FAQ category\";s:4:\"help\";s:25:\"The term of the FAQ node.\";s:10:\"real field\";s:3:\"tid\";s:5:\"field\";a:3:{s:7:\"handler\";s:33:\"views_handler_field_term_node_tid\";s:14:\"click sortable\";b:1;s:12:\"zero is null\";b:1;}s:8:\"argument\";a:7:{s:7:\"handler\";s:36:\"views_handler_argument_term_node_tid\";s:10:\"name table\";s:18:\"taxonomy_term_data\";s:10:\"name field\";s:4:\"name\";s:16:\"empty field name\";s:13:\"Uncategorized\";s:7:\"numeric\";b:1;s:9:\"skip base\";s:18:\"taxonomy_term_data\";s:12:\"zero is null\";b:1;}s:6:\"filter\";a:7:{s:5:\"title\";s:4:\"Term\";s:7:\"handler\";s:34:\"views_handler_filter_term_node_tid\";s:15:\"hierarchy table\";s:23:\"taxonomy_term_hierarchy\";s:7:\"numeric\";b:1;s:9:\"skip base\";s:18:\"taxonomy_term_data\";s:11:\"allow empty\";b:1;s:12:\"zero is null\";b:0;}}}s:34:\"field_data_field_detailed_question\";a:5:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:4:\"node\";a:3:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:9:\"entity_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:34:\"field_data_field_detailed_question\";i:1;s:23:\"field_detailed_question\";}}}s:23:\"field_detailed_question\";a:5:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:17:\"Detailed question\";s:11:\"title short\";s:17:\"Detailed question\";s:4:\"help\";s:21:\"Appears in: node:faq.\";s:5:\"field\";a:9:{s:5:\"table\";s:34:\"field_data_field_detailed_question\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:23:\"field_detailed_question\";s:10:\"real field\";s:29:\"field_detailed_question_value\";s:17:\"additional fields\";a:5:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:29:\"field_detailed_question_value\";i:4;s:30:\"field_detailed_question_format\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;}}s:29:\"field_detailed_question_value\";a:6:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:43:\"Detailed question (field_detailed_question)\";s:11:\"title short\";s:17:\"Detailed question\";s:4:\"help\";s:21:\"Appears in: node:faq.\";s:8:\"argument\";a:6:{s:5:\"field\";s:29:\"field_detailed_question_value\";s:5:\"table\";s:34:\"field_data_field_detailed_question\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:29:\"field_detailed_question_value\";i:1;s:30:\"field_detailed_question_format\";}s:10:\"field_name\";s:23:\"field_detailed_question\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:29:\"field_detailed_question_value\";s:5:\"table\";s:34:\"field_data_field_detailed_question\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:29:\"field_detailed_question_value\";i:1;s:30:\"field_detailed_question_format\";}s:10:\"field_name\";s:23:\"field_detailed_question\";s:11:\"allow empty\";b:1;}}s:30:\"field_detailed_question_format\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:50:\"Detailed question (field_detailed_question:format)\";s:11:\"title short\";s:24:\"Detailed question:format\";s:4:\"help\";s:21:\"Appears in: node:faq.\";s:8:\"argument\";a:6:{s:5:\"field\";s:30:\"field_detailed_question_format\";s:5:\"table\";s:34:\"field_data_field_detailed_question\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:29:\"field_detailed_question_value\";i:1;s:30:\"field_detailed_question_format\";}s:10:\"field_name\";s:23:\"field_detailed_question\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:30:\"field_detailed_question_format\";s:5:\"table\";s:34:\"field_data_field_detailed_question\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:29:\"field_detailed_question_value\";i:1;s:30:\"field_detailed_question_format\";}s:10:\"field_name\";s:23:\"field_detailed_question\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:30:\"field_detailed_question_format\";s:5:\"table\";s:34:\"field_data_field_detailed_question\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:29:\"field_detailed_question_value\";i:1;s:30:\"field_detailed_question_format\";}s:10:\"field_name\";s:23:\"field_detailed_question\";}}}s:38:\"field_revision_field_detailed_question\";a:5:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:13:\"node_revision\";a:3:{s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:11:\"revision_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:38:\"field_revision_field_detailed_question\";i:1;s:35:\"field_detailed_question-revision_id\";}}}s:35:\"field_detailed_question-revision_id\";a:5:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:17:\"Detailed question\";s:11:\"title short\";s:17:\"Detailed question\";s:4:\"help\";s:21:\"Appears in: node:faq.\";s:5:\"field\";a:9:{s:5:\"table\";s:38:\"field_revision_field_detailed_question\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:23:\"field_detailed_question\";s:10:\"real field\";s:41:\"field_detailed_question-revision_id_value\";s:17:\"additional fields\";a:5:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:29:\"field_detailed_question_value\";i:4;s:30:\"field_detailed_question_format\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:29:\"field_detailed_question_value\";a:6:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:43:\"Detailed question (field_detailed_question)\";s:11:\"title short\";s:17:\"Detailed question\";s:4:\"help\";s:21:\"Appears in: node:faq.\";s:8:\"argument\";a:6:{s:5:\"field\";s:29:\"field_detailed_question_value\";s:5:\"table\";s:38:\"field_revision_field_detailed_question\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:29:\"field_detailed_question_value\";i:1;s:30:\"field_detailed_question_format\";}s:10:\"field_name\";s:23:\"field_detailed_question\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:29:\"field_detailed_question_value\";s:5:\"table\";s:38:\"field_revision_field_detailed_question\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:29:\"field_detailed_question_value\";i:1;s:30:\"field_detailed_question_format\";}s:10:\"field_name\";s:23:\"field_detailed_question\";s:11:\"allow empty\";b:1;}}s:30:\"field_detailed_question_format\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:50:\"Detailed question (field_detailed_question:format)\";s:11:\"title short\";s:24:\"Detailed question:format\";s:4:\"help\";s:21:\"Appears in: node:faq.\";s:8:\"argument\";a:6:{s:5:\"field\";s:30:\"field_detailed_question_format\";s:5:\"table\";s:38:\"field_revision_field_detailed_question\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:29:\"field_detailed_question_value\";i:1;s:30:\"field_detailed_question_format\";}s:10:\"field_name\";s:23:\"field_detailed_question\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:30:\"field_detailed_question_format\";s:5:\"table\";s:38:\"field_revision_field_detailed_question\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:29:\"field_detailed_question_value\";i:1;s:30:\"field_detailed_question_format\";}s:10:\"field_name\";s:23:\"field_detailed_question\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:30:\"field_detailed_question_format\";s:5:\"table\";s:38:\"field_revision_field_detailed_question\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:29:\"field_detailed_question_value\";i:1;s:30:\"field_detailed_question_format\";}s:10:\"field_name\";s:23:\"field_detailed_question\";}}}s:28:\"field_data_field_description\";a:5:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:21:\"field_collection_item\";a:3:{s:10:\"left_field\";s:7:\"item_id\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:21:\"field_collection_item\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:9:\"entity_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:28:\"field_data_field_description\";i:1;s:17:\"field_description\";}}}s:17:\"field_description\";a:5:{s:5:\"group\";s:21:\"Field collection item\";s:5:\"title\";s:11:\"Description\";s:11:\"title short\";s:11:\"Description\";s:4:\"help\";s:54:\"Appears in: field_collection_item:field_extra_content.\";s:5:\"field\";a:9:{s:5:\"table\";s:28:\"field_data_field_description\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:17:\"field_description\";s:10:\"real field\";s:23:\"field_description_value\";s:17:\"additional fields\";a:5:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:23:\"field_description_value\";i:4;s:24:\"field_description_format\";}s:13:\"entity_tables\";a:2:{s:21:\"field_collection_item\";s:21:\"field_collection_item\";s:30:\"field_collection_item_revision\";s:21:\"field_collection_item\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;}}s:23:\"field_description_value\";a:6:{s:5:\"group\";s:21:\"Field collection item\";s:5:\"title\";s:31:\"Description (field_description)\";s:11:\"title short\";s:11:\"Description\";s:4:\"help\";s:54:\"Appears in: field_collection_item:field_extra_content.\";s:8:\"argument\";a:6:{s:5:\"field\";s:23:\"field_description_value\";s:5:\"table\";s:28:\"field_data_field_description\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:23:\"field_description_value\";i:1;s:24:\"field_description_format\";}s:10:\"field_name\";s:17:\"field_description\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:23:\"field_description_value\";s:5:\"table\";s:28:\"field_data_field_description\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:23:\"field_description_value\";i:1;s:24:\"field_description_format\";}s:10:\"field_name\";s:17:\"field_description\";s:11:\"allow empty\";b:1;}}s:24:\"field_description_format\";a:7:{s:5:\"group\";s:21:\"Field collection item\";s:5:\"title\";s:38:\"Description (field_description:format)\";s:11:\"title short\";s:18:\"Description:format\";s:4:\"help\";s:54:\"Appears in: field_collection_item:field_extra_content.\";s:8:\"argument\";a:6:{s:5:\"field\";s:24:\"field_description_format\";s:5:\"table\";s:28:\"field_data_field_description\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:23:\"field_description_value\";i:1;s:24:\"field_description_format\";}s:10:\"field_name\";s:17:\"field_description\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:24:\"field_description_format\";s:5:\"table\";s:28:\"field_data_field_description\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:23:\"field_description_value\";i:1;s:24:\"field_description_format\";}s:10:\"field_name\";s:17:\"field_description\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:24:\"field_description_format\";s:5:\"table\";s:28:\"field_data_field_description\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:23:\"field_description_value\";i:1;s:24:\"field_description_format\";}s:10:\"field_name\";s:17:\"field_description\";}}}s:32:\"field_revision_field_description\";a:5:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:30:\"field_collection_item_revision\";a:3:{s:10:\"left_field\";s:11:\"revision_id\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:21:\"field_collection_item\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:11:\"revision_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:32:\"field_revision_field_description\";i:1;s:29:\"field_description-revision_id\";}}}s:29:\"field_description-revision_id\";a:5:{s:5:\"group\";s:39:\"Field collection item (historical data)\";s:5:\"title\";s:11:\"Description\";s:11:\"title short\";s:11:\"Description\";s:4:\"help\";s:54:\"Appears in: field_collection_item:field_extra_content.\";s:5:\"field\";a:9:{s:5:\"table\";s:32:\"field_revision_field_description\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:17:\"field_description\";s:10:\"real field\";s:35:\"field_description-revision_id_value\";s:17:\"additional fields\";a:5:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:23:\"field_description_value\";i:4;s:24:\"field_description_format\";}s:13:\"entity_tables\";a:2:{s:21:\"field_collection_item\";s:21:\"field_collection_item\";s:30:\"field_collection_item_revision\";s:21:\"field_collection_item\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:23:\"field_description_value\";a:6:{s:5:\"group\";s:39:\"Field collection item (historical data)\";s:5:\"title\";s:31:\"Description (field_description)\";s:11:\"title short\";s:11:\"Description\";s:4:\"help\";s:54:\"Appears in: field_collection_item:field_extra_content.\";s:8:\"argument\";a:6:{s:5:\"field\";s:23:\"field_description_value\";s:5:\"table\";s:32:\"field_revision_field_description\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:23:\"field_description_value\";i:1;s:24:\"field_description_format\";}s:10:\"field_name\";s:17:\"field_description\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:23:\"field_description_value\";s:5:\"table\";s:32:\"field_revision_field_description\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:23:\"field_description_value\";i:1;s:24:\"field_description_format\";}s:10:\"field_name\";s:17:\"field_description\";s:11:\"allow empty\";b:1;}}s:24:\"field_description_format\";a:7:{s:5:\"group\";s:39:\"Field collection item (historical data)\";s:5:\"title\";s:38:\"Description (field_description:format)\";s:11:\"title short\";s:18:\"Description:format\";s:4:\"help\";s:54:\"Appears in: field_collection_item:field_extra_content.\";s:8:\"argument\";a:6:{s:5:\"field\";s:24:\"field_description_format\";s:5:\"table\";s:32:\"field_revision_field_description\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:23:\"field_description_value\";i:1;s:24:\"field_description_format\";}s:10:\"field_name\";s:17:\"field_description\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:24:\"field_description_format\";s:5:\"table\";s:32:\"field_revision_field_description\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:23:\"field_description_value\";i:1;s:24:\"field_description_format\";}s:10:\"field_name\";s:17:\"field_description\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:24:\"field_description_format\";s:5:\"table\";s:32:\"field_revision_field_description\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:23:\"field_description_value\";i:1;s:24:\"field_description_format\";}s:10:\"field_name\";s:17:\"field_description\";}}}s:30:\"field_data_field_extra_content\";a:6:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:4:\"node\";a:3:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:9:\"entity_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:30:\"field_data_field_extra_content\";i:1;s:19:\"field_extra_content\";}}}s:19:\"field_extra_content\";a:5:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:13:\"Extra content\";s:11:\"title short\";s:13:\"Extra content\";s:4:\"help\";s:48:\"Appears in: node:blog, node:article, node:forum.\";s:5:\"field\";a:9:{s:5:\"table\";s:30:\"field_data_field_extra_content\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:19:\"field_extra_content\";s:10:\"real field\";s:25:\"field_extra_content_value\";s:17:\"additional fields\";a:5:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:25:\"field_extra_content_value\";i:4;s:31:\"field_extra_content_revision_id\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;}}s:25:\"field_extra_content_value\";a:8:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:35:\"Extra content (field_extra_content)\";s:11:\"title short\";s:13:\"Extra content\";s:4:\"help\";s:48:\"Appears in: node:blog, node:article, node:forum.\";s:8:\"argument\";a:6:{s:5:\"field\";s:25:\"field_extra_content_value\";s:5:\"table\";s:30:\"field_data_field_extra_content\";s:7:\"handler\";s:30:\"views_handler_argument_numeric\";s:17:\"additional fields\";a:2:{i:0;s:25:\"field_extra_content_value\";i:1;s:31:\"field_extra_content_revision_id\";}s:10:\"field_name\";s:19:\"field_extra_content\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:25:\"field_extra_content_value\";s:5:\"table\";s:30:\"field_data_field_extra_content\";s:7:\"handler\";s:28:\"views_handler_filter_numeric\";s:17:\"additional fields\";a:2:{i:0;s:25:\"field_extra_content_value\";i:1;s:31:\"field_extra_content_revision_id\";}s:10:\"field_name\";s:19:\"field_extra_content\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:25:\"field_extra_content_value\";s:5:\"table\";s:30:\"field_data_field_extra_content\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:25:\"field_extra_content_value\";i:1;s:31:\"field_extra_content_revision_id\";}s:10:\"field_name\";s:19:\"field_extra_content\";}s:12:\"relationship\";a:5:{s:7:\"handler\";s:37:\"field_collection_handler_relationship\";s:4:\"base\";s:21:\"field_collection_item\";s:10:\"base field\";s:7:\"item_id\";s:5:\"label\";s:46:\"field collection item from field_extra_content\";s:10:\"field_name\";s:19:\"field_extra_content\";}}s:5:\"delta\";a:8:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:41:\"Extra content (field_extra_content:delta)\";s:11:\"title short\";s:19:\"Extra content:delta\";s:4:\"help\";s:56:\"Delta - Appears in: node:blog, node:article, node:forum.\";s:5:\"field\";a:1:{s:7:\"handler\";s:27:\"views_handler_field_numeric\";}s:8:\"argument\";a:6:{s:5:\"field\";s:5:\"delta\";s:5:\"table\";s:30:\"field_data_field_extra_content\";s:7:\"handler\";s:30:\"views_handler_argument_numeric\";s:17:\"additional fields\";a:2:{i:0;s:25:\"field_extra_content_value\";i:1;s:31:\"field_extra_content_revision_id\";}s:16:\"empty field name\";s:12:\"- No value -\";s:10:\"field_name\";s:19:\"field_extra_content\";}s:6:\"filter\";a:6:{s:5:\"field\";s:5:\"delta\";s:5:\"table\";s:30:\"field_data_field_extra_content\";s:7:\"handler\";s:28:\"views_handler_filter_numeric\";s:17:\"additional fields\";a:2:{i:0;s:25:\"field_extra_content_value\";i:1;s:31:\"field_extra_content_revision_id\";}s:10:\"field_name\";s:19:\"field_extra_content\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:5:\"delta\";s:5:\"table\";s:30:\"field_data_field_extra_content\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:25:\"field_extra_content_value\";i:1;s:31:\"field_extra_content_revision_id\";}s:10:\"field_name\";s:19:\"field_extra_content\";}}s:31:\"field_extra_content_revision_id\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:47:\"Extra content (field_extra_content:revision_id)\";s:11:\"title short\";s:25:\"Extra content:revision_id\";s:4:\"help\";s:48:\"Appears in: node:blog, node:article, node:forum.\";s:8:\"argument\";a:6:{s:5:\"field\";s:31:\"field_extra_content_revision_id\";s:5:\"table\";s:30:\"field_data_field_extra_content\";s:7:\"handler\";s:30:\"views_handler_argument_numeric\";s:17:\"additional fields\";a:2:{i:0;s:25:\"field_extra_content_value\";i:1;s:31:\"field_extra_content_revision_id\";}s:10:\"field_name\";s:19:\"field_extra_content\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:31:\"field_extra_content_revision_id\";s:5:\"table\";s:30:\"field_data_field_extra_content\";s:7:\"handler\";s:28:\"views_handler_filter_numeric\";s:17:\"additional fields\";a:2:{i:0;s:25:\"field_extra_content_value\";i:1;s:31:\"field_extra_content_revision_id\";}s:10:\"field_name\";s:19:\"field_extra_content\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:31:\"field_extra_content_revision_id\";s:5:\"table\";s:30:\"field_data_field_extra_content\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:25:\"field_extra_content_value\";i:1;s:31:\"field_extra_content_revision_id\";}s:10:\"field_name\";s:19:\"field_extra_content\";}}}s:34:\"field_revision_field_extra_content\";a:6:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:13:\"node_revision\";a:3:{s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:11:\"revision_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:34:\"field_revision_field_extra_content\";i:1;s:31:\"field_extra_content-revision_id\";}}}s:31:\"field_extra_content-revision_id\";a:5:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:13:\"Extra content\";s:11:\"title short\";s:13:\"Extra content\";s:4:\"help\";s:48:\"Appears in: node:blog, node:article, node:forum.\";s:5:\"field\";a:9:{s:5:\"table\";s:34:\"field_revision_field_extra_content\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:19:\"field_extra_content\";s:10:\"real field\";s:37:\"field_extra_content-revision_id_value\";s:17:\"additional fields\";a:5:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:25:\"field_extra_content_value\";i:4;s:31:\"field_extra_content_revision_id\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:25:\"field_extra_content_value\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:35:\"Extra content (field_extra_content)\";s:11:\"title short\";s:13:\"Extra content\";s:4:\"help\";s:48:\"Appears in: node:blog, node:article, node:forum.\";s:8:\"argument\";a:6:{s:5:\"field\";s:25:\"field_extra_content_value\";s:5:\"table\";s:34:\"field_revision_field_extra_content\";s:7:\"handler\";s:30:\"views_handler_argument_numeric\";s:17:\"additional fields\";a:2:{i:0;s:25:\"field_extra_content_value\";i:1;s:31:\"field_extra_content_revision_id\";}s:10:\"field_name\";s:19:\"field_extra_content\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:25:\"field_extra_content_value\";s:5:\"table\";s:34:\"field_revision_field_extra_content\";s:7:\"handler\";s:28:\"views_handler_filter_numeric\";s:17:\"additional fields\";a:2:{i:0;s:25:\"field_extra_content_value\";i:1;s:31:\"field_extra_content_revision_id\";}s:10:\"field_name\";s:19:\"field_extra_content\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:25:\"field_extra_content_value\";s:5:\"table\";s:34:\"field_revision_field_extra_content\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:25:\"field_extra_content_value\";i:1;s:31:\"field_extra_content_revision_id\";}s:10:\"field_name\";s:19:\"field_extra_content\";}}s:5:\"delta\";a:8:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:41:\"Extra content (field_extra_content:delta)\";s:11:\"title short\";s:19:\"Extra content:delta\";s:4:\"help\";s:56:\"Delta - Appears in: node:blog, node:article, node:forum.\";s:5:\"field\";a:1:{s:7:\"handler\";s:27:\"views_handler_field_numeric\";}s:8:\"argument\";a:6:{s:5:\"field\";s:5:\"delta\";s:5:\"table\";s:34:\"field_revision_field_extra_content\";s:7:\"handler\";s:30:\"views_handler_argument_numeric\";s:17:\"additional fields\";a:2:{i:0;s:25:\"field_extra_content_value\";i:1;s:31:\"field_extra_content_revision_id\";}s:16:\"empty field name\";s:12:\"- No value -\";s:10:\"field_name\";s:19:\"field_extra_content\";}s:6:\"filter\";a:6:{s:5:\"field\";s:5:\"delta\";s:5:\"table\";s:34:\"field_revision_field_extra_content\";s:7:\"handler\";s:28:\"views_handler_filter_numeric\";s:17:\"additional fields\";a:2:{i:0;s:25:\"field_extra_content_value\";i:1;s:31:\"field_extra_content_revision_id\";}s:10:\"field_name\";s:19:\"field_extra_content\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:5:\"delta\";s:5:\"table\";s:34:\"field_revision_field_extra_content\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:25:\"field_extra_content_value\";i:1;s:31:\"field_extra_content_revision_id\";}s:10:\"field_name\";s:19:\"field_extra_content\";}}s:31:\"field_extra_content_revision_id\";a:8:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:47:\"Extra content (field_extra_content:revision_id)\";s:11:\"title short\";s:25:\"Extra content:revision_id\";s:4:\"help\";s:48:\"Appears in: node:blog, node:article, node:forum.\";s:8:\"argument\";a:6:{s:5:\"field\";s:31:\"field_extra_content_revision_id\";s:5:\"table\";s:34:\"field_revision_field_extra_content\";s:7:\"handler\";s:30:\"views_handler_argument_numeric\";s:17:\"additional fields\";a:2:{i:0;s:25:\"field_extra_content_value\";i:1;s:31:\"field_extra_content_revision_id\";}s:10:\"field_name\";s:19:\"field_extra_content\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:31:\"field_extra_content_revision_id\";s:5:\"table\";s:34:\"field_revision_field_extra_content\";s:7:\"handler\";s:28:\"views_handler_filter_numeric\";s:17:\"additional fields\";a:2:{i:0;s:25:\"field_extra_content_value\";i:1;s:31:\"field_extra_content_revision_id\";}s:10:\"field_name\";s:19:\"field_extra_content\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:31:\"field_extra_content_revision_id\";s:5:\"table\";s:34:\"field_revision_field_extra_content\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:25:\"field_extra_content_value\";i:1;s:31:\"field_extra_content_revision_id\";}s:10:\"field_name\";s:19:\"field_extra_content\";}s:12:\"relationship\";a:5:{s:7:\"handler\";s:37:\"field_collection_handler_relationship\";s:4:\"base\";s:30:\"field_collection_item_revision\";s:10:\"base field\";s:11:\"revision_id\";s:5:\"label\";s:55:\"field collection item revision from field_extra_content\";s:10:\"field_name\";s:19:\"field_extra_content\";}}}s:21:\"field_data_field_link\";a:6:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:4:\"node\";a:3:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:9:\"entity_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:21:\"field_data_field_link\";i:1;s:10:\"field_link\";}}}s:10:\"field_link\";a:5:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:4:\"Link\";s:11:\"title short\";s:4:\"Link\";s:4:\"help\";s:26:\"Appears in: node:products.\";s:5:\"field\";a:9:{s:5:\"table\";s:21:\"field_data_field_link\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:10:\"field_link\";s:10:\"real field\";s:14:\"field_link_url\";s:17:\"additional fields\";a:6:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:14:\"field_link_url\";i:4;s:16:\"field_link_title\";i:5;s:21:\"field_link_attributes\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;}}s:14:\"field_link_url\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:21:\"Link (field_link:url)\";s:11:\"title short\";s:8:\"Link:url\";s:4:\"help\";s:26:\"Appears in: node:products.\";s:8:\"argument\";a:6:{s:5:\"field\";s:14:\"field_link_url\";s:5:\"table\";s:21:\"field_data_field_link\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:3:{i:0;s:14:\"field_link_url\";i:1;s:16:\"field_link_title\";i:2;s:21:\"field_link_attributes\";}s:10:\"field_name\";s:10:\"field_link\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:14:\"field_link_url\";s:5:\"table\";s:21:\"field_data_field_link\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:3:{i:0;s:14:\"field_link_url\";i:1;s:16:\"field_link_title\";i:2;s:21:\"field_link_attributes\";}s:10:\"field_name\";s:10:\"field_link\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:14:\"field_link_url\";s:5:\"table\";s:21:\"field_data_field_link\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:3:{i:0;s:14:\"field_link_url\";i:1;s:16:\"field_link_title\";i:2;s:21:\"field_link_attributes\";}s:10:\"field_name\";s:10:\"field_link\";}}s:16:\"field_link_title\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:23:\"Link (field_link:title)\";s:11:\"title short\";s:10:\"Link:title\";s:4:\"help\";s:26:\"Appears in: node:products.\";s:8:\"argument\";a:6:{s:5:\"field\";s:16:\"field_link_title\";s:5:\"table\";s:21:\"field_data_field_link\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:3:{i:0;s:14:\"field_link_url\";i:1;s:16:\"field_link_title\";i:2;s:21:\"field_link_attributes\";}s:10:\"field_name\";s:10:\"field_link\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:16:\"field_link_title\";s:5:\"table\";s:21:\"field_data_field_link\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:3:{i:0;s:14:\"field_link_url\";i:1;s:16:\"field_link_title\";i:2;s:21:\"field_link_attributes\";}s:10:\"field_name\";s:10:\"field_link\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:16:\"field_link_title\";s:5:\"table\";s:21:\"field_data_field_link\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:3:{i:0;s:14:\"field_link_url\";i:1;s:16:\"field_link_title\";i:2;s:21:\"field_link_attributes\";}s:10:\"field_name\";s:10:\"field_link\";}}s:21:\"field_link_attributes\";a:6:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:28:\"Link (field_link:attributes)\";s:11:\"title short\";s:15:\"Link:attributes\";s:4:\"help\";s:26:\"Appears in: node:products.\";s:8:\"argument\";a:6:{s:5:\"field\";s:21:\"field_link_attributes\";s:5:\"table\";s:21:\"field_data_field_link\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:3:{i:0;s:14:\"field_link_url\";i:1;s:16:\"field_link_title\";i:2;s:21:\"field_link_attributes\";}s:10:\"field_name\";s:10:\"field_link\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:21:\"field_link_attributes\";s:5:\"table\";s:21:\"field_data_field_link\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:3:{i:0;s:14:\"field_link_url\";i:1;s:16:\"field_link_title\";i:2;s:21:\"field_link_attributes\";}s:10:\"field_name\";s:10:\"field_link\";s:11:\"allow empty\";b:1;}}}s:25:\"field_revision_field_link\";a:6:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:13:\"node_revision\";a:3:{s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:11:\"revision_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:25:\"field_revision_field_link\";i:1;s:22:\"field_link-revision_id\";}}}s:22:\"field_link-revision_id\";a:5:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:4:\"Link\";s:11:\"title short\";s:4:\"Link\";s:4:\"help\";s:26:\"Appears in: node:products.\";s:5:\"field\";a:9:{s:5:\"table\";s:25:\"field_revision_field_link\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:10:\"field_link\";s:10:\"real field\";s:26:\"field_link-revision_id_url\";s:17:\"additional fields\";a:6:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:14:\"field_link_url\";i:4;s:16:\"field_link_title\";i:5;s:21:\"field_link_attributes\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:14:\"field_link_url\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:21:\"Link (field_link:url)\";s:11:\"title short\";s:8:\"Link:url\";s:4:\"help\";s:26:\"Appears in: node:products.\";s:8:\"argument\";a:6:{s:5:\"field\";s:14:\"field_link_url\";s:5:\"table\";s:25:\"field_revision_field_link\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:3:{i:0;s:14:\"field_link_url\";i:1;s:16:\"field_link_title\";i:2;s:21:\"field_link_attributes\";}s:10:\"field_name\";s:10:\"field_link\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:14:\"field_link_url\";s:5:\"table\";s:25:\"field_revision_field_link\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:3:{i:0;s:14:\"field_link_url\";i:1;s:16:\"field_link_title\";i:2;s:21:\"field_link_attributes\";}s:10:\"field_name\";s:10:\"field_link\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:14:\"field_link_url\";s:5:\"table\";s:25:\"field_revision_field_link\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:3:{i:0;s:14:\"field_link_url\";i:1;s:16:\"field_link_title\";i:2;s:21:\"field_link_attributes\";}s:10:\"field_name\";s:10:\"field_link\";}}s:16:\"field_link_title\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:23:\"Link (field_link:title)\";s:11:\"title short\";s:10:\"Link:title\";s:4:\"help\";s:26:\"Appears in: node:products.\";s:8:\"argument\";a:6:{s:5:\"field\";s:16:\"field_link_title\";s:5:\"table\";s:25:\"field_revision_field_link\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:3:{i:0;s:14:\"field_link_url\";i:1;s:16:\"field_link_title\";i:2;s:21:\"field_link_attributes\";}s:10:\"field_name\";s:10:\"field_link\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:16:\"field_link_title\";s:5:\"table\";s:25:\"field_revision_field_link\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:3:{i:0;s:14:\"field_link_url\";i:1;s:16:\"field_link_title\";i:2;s:21:\"field_link_attributes\";}s:10:\"field_name\";s:10:\"field_link\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:16:\"field_link_title\";s:5:\"table\";s:25:\"field_revision_field_link\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:3:{i:0;s:14:\"field_link_url\";i:1;s:16:\"field_link_title\";i:2;s:21:\"field_link_attributes\";}s:10:\"field_name\";s:10:\"field_link\";}}s:21:\"field_link_attributes\";a:6:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:28:\"Link (field_link:attributes)\";s:11:\"title short\";s:15:\"Link:attributes\";s:4:\"help\";s:26:\"Appears in: node:products.\";s:8:\"argument\";a:6:{s:5:\"field\";s:21:\"field_link_attributes\";s:5:\"table\";s:25:\"field_revision_field_link\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:3:{i:0;s:14:\"field_link_url\";i:1;s:16:\"field_link_title\";i:2;s:21:\"field_link_attributes\";}s:10:\"field_name\";s:10:\"field_link\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:21:\"field_link_attributes\";s:5:\"table\";s:25:\"field_revision_field_link\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:3:{i:0;s:14:\"field_link_url\";i:1;s:16:\"field_link_title\";i:2;s:21:\"field_link_attributes\";}s:10:\"field_name\";s:10:\"field_link\";s:11:\"allow empty\";b:1;}}}s:27:\"field_data_field_video_link\";a:8:{s:5:\"table\";a:1:{s:4:\"join\";a:2:{s:4:\"node\";a:3:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}s:21:\"field_collection_item\";a:3:{s:10:\"left_field\";s:7:\"item_id\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:21:\"field_collection_item\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:9:\"entity_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:27:\"field_data_field_video_link\";i:1;s:16:\"field_video_link\";}}}s:16:\"field_video_link\";a:6:{s:5:\"group\";s:5:\"Field\";s:5:\"title\";s:10:\"Video Link\";s:11:\"title short\";s:10:\"Video Link\";s:4:\"help\";s:137:\"Appears in: node:video, field_collection_item:field_extra_content. Also known as: Content: Video Link, Field collection item: Video Link.\";s:7:\"aliases\";a:2:{i:0;a:4:{s:4:\"base\";s:4:\"node\";s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:10:\"Video Link\";s:4:\"help\";s:38:\"This is an alias of Field: Video Link.\";}i:1;a:4:{s:4:\"base\";s:21:\"field_collection_item\";s:5:\"group\";s:21:\"Field collection item\";s:5:\"title\";s:10:\"Video Link\";s:4:\"help\";s:38:\"This is an alias of Field: Video Link.\";}}s:5:\"field\";a:9:{s:5:\"table\";s:27:\"field_data_field_video_link\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:16:\"field_video_link\";s:10:\"real field\";s:26:\"field_video_link_video_url\";s:17:\"additional fields\";a:8:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:26:\"field_video_link_video_url\";i:4;s:31:\"field_video_link_thumbnail_path\";i:5;s:27:\"field_video_link_video_data\";i:6;s:27:\"field_video_link_embed_code\";i:7;s:28:\"field_video_link_description\";}s:13:\"entity_tables\";a:4:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";s:21:\"field_collection_item\";s:21:\"field_collection_item\";s:30:\"field_collection_item_revision\";s:21:\"field_collection_item\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;}}s:26:\"field_video_link_video_url\";a:9:{s:5:\"group\";s:5:\"Field\";s:5:\"title\";s:22:\"Video Link - Video URL\";s:11:\"title short\";s:22:\"Video Link - Video URL\";s:4:\"help\";s:195:\"Appears in: node:video, field_collection_item:field_extra_content. Also known as: Content: Video Link (field_video_link:video_url), Field collection item: Video Link (field_video_link:video_url).\";s:7:\"aliases\";a:2:{i:0;a:3:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:39:\"Video Link (field_video_link:video_url)\";s:4:\"help\";s:67:\"This is an alias of Field: Video Link (field_video_link:video_url).\";}i:1;a:3:{s:5:\"group\";s:21:\"Field collection item\";s:5:\"title\";s:39:\"Video Link (field_video_link:video_url)\";s:4:\"help\";s:67:\"This is an alias of Field: Video Link (field_video_link:video_url).\";}}s:8:\"argument\";a:6:{s:5:\"field\";s:26:\"field_video_link_video_url\";s:5:\"table\";s:27:\"field_data_field_video_link\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:5:{i:0;s:26:\"field_video_link_video_url\";i:1;s:31:\"field_video_link_thumbnail_path\";i:2;s:27:\"field_video_link_video_data\";i:3;s:27:\"field_video_link_embed_code\";i:4;s:28:\"field_video_link_description\";}s:10:\"field_name\";s:16:\"field_video_link\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:26:\"field_video_link_video_url\";s:5:\"table\";s:27:\"field_data_field_video_link\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:5:{i:0;s:26:\"field_video_link_video_url\";i:1;s:31:\"field_video_link_thumbnail_path\";i:2;s:27:\"field_video_link_video_data\";i:3;s:27:\"field_video_link_embed_code\";i:4;s:28:\"field_video_link_description\";}s:10:\"field_name\";s:16:\"field_video_link\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:26:\"field_video_link_video_url\";s:5:\"table\";s:27:\"field_data_field_video_link\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:5:{i:0;s:26:\"field_video_link_video_url\";i:1;s:31:\"field_video_link_thumbnail_path\";i:2;s:27:\"field_video_link_video_data\";i:3;s:27:\"field_video_link_embed_code\";i:4;s:28:\"field_video_link_description\";}s:10:\"field_name\";s:16:\"field_video_link\";}s:5:\"field\";a:8:{s:5:\"table\";s:27:\"field_data_field_video_link\";s:7:\"handler\";s:19:\"views_handler_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:16:\"field_video_link\";s:10:\"real field\";s:26:\"field_video_link_video_url\";s:13:\"entity_tables\";a:4:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";s:21:\"field_collection_item\";s:21:\"field_collection_item\";s:30:\"field_collection_item_revision\";s:21:\"field_collection_item\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;}}s:31:\"field_video_link_thumbnail_path\";a:9:{s:5:\"group\";s:5:\"Field\";s:5:\"title\";s:27:\"Video Link - Thumbnail path\";s:11:\"title short\";s:27:\"Video Link - Thumbnail path\";s:4:\"help\";s:205:\"Appears in: node:video, field_collection_item:field_extra_content. Also known as: Content: Video Link (field_video_link:thumbnail_path), Field collection item: Video Link (field_video_link:thumbnail_path).\";s:7:\"aliases\";a:2:{i:0;a:3:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:44:\"Video Link (field_video_link:thumbnail_path)\";s:4:\"help\";s:72:\"This is an alias of Field: Video Link (field_video_link:thumbnail_path).\";}i:1;a:3:{s:5:\"group\";s:21:\"Field collection item\";s:5:\"title\";s:44:\"Video Link (field_video_link:thumbnail_path)\";s:4:\"help\";s:72:\"This is an alias of Field: Video Link (field_video_link:thumbnail_path).\";}}s:8:\"argument\";a:6:{s:5:\"field\";s:31:\"field_video_link_thumbnail_path\";s:5:\"table\";s:27:\"field_data_field_video_link\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:5:{i:0;s:26:\"field_video_link_video_url\";i:1;s:31:\"field_video_link_thumbnail_path\";i:2;s:27:\"field_video_link_video_data\";i:3;s:27:\"field_video_link_embed_code\";i:4;s:28:\"field_video_link_description\";}s:10:\"field_name\";s:16:\"field_video_link\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:31:\"field_video_link_thumbnail_path\";s:5:\"table\";s:27:\"field_data_field_video_link\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:5:{i:0;s:26:\"field_video_link_video_url\";i:1;s:31:\"field_video_link_thumbnail_path\";i:2;s:27:\"field_video_link_video_data\";i:3;s:27:\"field_video_link_embed_code\";i:4;s:28:\"field_video_link_description\";}s:10:\"field_name\";s:16:\"field_video_link\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:31:\"field_video_link_thumbnail_path\";s:5:\"table\";s:27:\"field_data_field_video_link\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:5:{i:0;s:26:\"field_video_link_video_url\";i:1;s:31:\"field_video_link_thumbnail_path\";i:2;s:27:\"field_video_link_video_data\";i:3;s:27:\"field_video_link_embed_code\";i:4;s:28:\"field_video_link_description\";}s:10:\"field_name\";s:16:\"field_video_link\";}s:5:\"field\";a:8:{s:5:\"table\";s:27:\"field_data_field_video_link\";s:7:\"handler\";s:52:\"views_embed_field_views_handler_field_thumbnail_path\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:16:\"field_video_link\";s:10:\"real field\";s:31:\"field_video_link_thumbnail_path\";s:13:\"entity_tables\";a:4:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";s:21:\"field_collection_item\";s:21:\"field_collection_item\";s:30:\"field_collection_item_revision\";s:21:\"field_collection_item\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;}}s:27:\"field_video_link_video_data\";a:7:{s:5:\"group\";s:5:\"Field\";s:5:\"title\";s:40:\"Video Link (field_video_link:video_data)\";s:11:\"title short\";s:21:\"Video Link:video_data\";s:4:\"help\";s:197:\"Appears in: node:video, field_collection_item:field_extra_content. Also known as: Content: Video Link (field_video_link:video_data), Field collection item: Video Link (field_video_link:video_data).\";s:7:\"aliases\";a:2:{i:0;a:3:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:40:\"Video Link (field_video_link:video_data)\";s:4:\"help\";s:68:\"This is an alias of Field: Video Link (field_video_link:video_data).\";}i:1;a:3:{s:5:\"group\";s:21:\"Field collection item\";s:5:\"title\";s:40:\"Video Link (field_video_link:video_data)\";s:4:\"help\";s:68:\"This is an alias of Field: Video Link (field_video_link:video_data).\";}}s:8:\"argument\";a:6:{s:5:\"field\";s:27:\"field_video_link_video_data\";s:5:\"table\";s:27:\"field_data_field_video_link\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:5:{i:0;s:26:\"field_video_link_video_url\";i:1;s:31:\"field_video_link_thumbnail_path\";i:2;s:27:\"field_video_link_video_data\";i:3;s:27:\"field_video_link_embed_code\";i:4;s:28:\"field_video_link_description\";}s:10:\"field_name\";s:16:\"field_video_link\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:27:\"field_video_link_video_data\";s:5:\"table\";s:27:\"field_data_field_video_link\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:5:{i:0;s:26:\"field_video_link_video_url\";i:1;s:31:\"field_video_link_thumbnail_path\";i:2;s:27:\"field_video_link_video_data\";i:3;s:27:\"field_video_link_embed_code\";i:4;s:28:\"field_video_link_description\";}s:10:\"field_name\";s:16:\"field_video_link\";s:11:\"allow empty\";b:1;}}s:27:\"field_video_link_embed_code\";a:8:{s:5:\"group\";s:5:\"Field\";s:5:\"title\";s:40:\"Video Link (field_video_link:embed_code)\";s:11:\"title short\";s:21:\"Video Link:embed_code\";s:4:\"help\";s:197:\"Appears in: node:video, field_collection_item:field_extra_content. Also known as: Content: Video Link (field_video_link:embed_code), Field collection item: Video Link (field_video_link:embed_code).\";s:7:\"aliases\";a:2:{i:0;a:3:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:40:\"Video Link (field_video_link:embed_code)\";s:4:\"help\";s:68:\"This is an alias of Field: Video Link (field_video_link:embed_code).\";}i:1;a:3:{s:5:\"group\";s:21:\"Field collection item\";s:5:\"title\";s:40:\"Video Link (field_video_link:embed_code)\";s:4:\"help\";s:68:\"This is an alias of Field: Video Link (field_video_link:embed_code).\";}}s:8:\"argument\";a:6:{s:5:\"field\";s:27:\"field_video_link_embed_code\";s:5:\"table\";s:27:\"field_data_field_video_link\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:5:{i:0;s:26:\"field_video_link_video_url\";i:1;s:31:\"field_video_link_thumbnail_path\";i:2;s:27:\"field_video_link_video_data\";i:3;s:27:\"field_video_link_embed_code\";i:4;s:28:\"field_video_link_description\";}s:10:\"field_name\";s:16:\"field_video_link\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:27:\"field_video_link_embed_code\";s:5:\"table\";s:27:\"field_data_field_video_link\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:5:{i:0;s:26:\"field_video_link_video_url\";i:1;s:31:\"field_video_link_thumbnail_path\";i:2;s:27:\"field_video_link_video_data\";i:3;s:27:\"field_video_link_embed_code\";i:4;s:28:\"field_video_link_description\";}s:10:\"field_name\";s:16:\"field_video_link\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:27:\"field_video_link_embed_code\";s:5:\"table\";s:27:\"field_data_field_video_link\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:5:{i:0;s:26:\"field_video_link_video_url\";i:1;s:31:\"field_video_link_thumbnail_path\";i:2;s:27:\"field_video_link_video_data\";i:3;s:27:\"field_video_link_embed_code\";i:4;s:28:\"field_video_link_description\";}s:10:\"field_name\";s:16:\"field_video_link\";}}s:28:\"field_video_link_description\";a:8:{s:5:\"group\";s:5:\"Field\";s:5:\"title\";s:24:\"Video Link - Description\";s:11:\"title short\";s:24:\"Video Link - Description\";s:4:\"help\";s:199:\"Appears in: node:video, field_collection_item:field_extra_content. Also known as: Content: Video Link (field_video_link:description), Field collection item: Video Link (field_video_link:description).\";s:7:\"aliases\";a:2:{i:0;a:3:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:41:\"Video Link (field_video_link:description)\";s:4:\"help\";s:69:\"This is an alias of Field: Video Link (field_video_link:description).\";}i:1;a:3:{s:5:\"group\";s:21:\"Field collection item\";s:5:\"title\";s:41:\"Video Link (field_video_link:description)\";s:4:\"help\";s:69:\"This is an alias of Field: Video Link (field_video_link:description).\";}}s:8:\"argument\";a:6:{s:5:\"field\";s:28:\"field_video_link_description\";s:5:\"table\";s:27:\"field_data_field_video_link\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:5:{i:0;s:26:\"field_video_link_video_url\";i:1;s:31:\"field_video_link_thumbnail_path\";i:2;s:27:\"field_video_link_video_data\";i:3;s:27:\"field_video_link_embed_code\";i:4;s:28:\"field_video_link_description\";}s:10:\"field_name\";s:16:\"field_video_link\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:28:\"field_video_link_description\";s:5:\"table\";s:27:\"field_data_field_video_link\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:5:{i:0;s:26:\"field_video_link_video_url\";i:1;s:31:\"field_video_link_thumbnail_path\";i:2;s:27:\"field_video_link_video_data\";i:3;s:27:\"field_video_link_embed_code\";i:4;s:28:\"field_video_link_description\";}s:10:\"field_name\";s:16:\"field_video_link\";s:11:\"allow empty\";b:1;}s:5:\"field\";a:8:{s:5:\"table\";s:27:\"field_data_field_video_link\";s:7:\"handler\";s:19:\"views_handler_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:16:\"field_video_link\";s:10:\"real field\";s:28:\"field_video_link_description\";s:13:\"entity_tables\";a:4:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";s:21:\"field_collection_item\";s:21:\"field_collection_item\";s:30:\"field_collection_item_revision\";s:21:\"field_collection_item\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;}}}s:31:\"field_revision_field_video_link\";a:8:{s:5:\"table\";a:1:{s:4:\"join\";a:2:{s:13:\"node_revision\";a:3:{s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}s:30:\"field_collection_item_revision\";a:3:{s:10:\"left_field\";s:11:\"revision_id\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:21:\"field_collection_item\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:11:\"revision_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:31:\"field_revision_field_video_link\";i:1;s:28:\"field_video_link-revision_id\";}}}s:28:\"field_video_link-revision_id\";a:5:{s:5:\"group\";s:23:\"Field (historical data)\";s:5:\"title\";s:10:\"Video Link\";s:11:\"title short\";s:10:\"Video Link\";s:4:\"help\";s:66:\"Appears in: node:video, field_collection_item:field_extra_content.\";s:5:\"field\";a:9:{s:5:\"table\";s:31:\"field_revision_field_video_link\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:16:\"field_video_link\";s:10:\"real field\";s:38:\"field_video_link-revision_id_video_url\";s:17:\"additional fields\";a:8:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:26:\"field_video_link_video_url\";i:4;s:31:\"field_video_link_thumbnail_path\";i:5;s:27:\"field_video_link_video_data\";i:6;s:27:\"field_video_link_embed_code\";i:7;s:28:\"field_video_link_description\";}s:13:\"entity_tables\";a:4:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";s:21:\"field_collection_item\";s:21:\"field_collection_item\";s:30:\"field_collection_item_revision\";s:21:\"field_collection_item\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:26:\"field_video_link_video_url\";a:8:{s:5:\"group\";s:23:\"Field (historical data)\";s:5:\"title\";s:39:\"Video Link (field_video_link:video_url)\";s:11:\"title short\";s:20:\"Video Link:video_url\";s:4:\"help\";s:195:\"Appears in: node:video, field_collection_item:field_extra_content. Also known as: Content: Video Link (field_video_link:video_url), Field collection item: Video Link (field_video_link:video_url).\";s:7:\"aliases\";a:2:{i:0;a:3:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:39:\"Video Link (field_video_link:video_url)\";s:4:\"help\";s:67:\"This is an alias of Field: Video Link (field_video_link:video_url).\";}i:1;a:3:{s:5:\"group\";s:21:\"Field collection item\";s:5:\"title\";s:39:\"Video Link (field_video_link:video_url)\";s:4:\"help\";s:67:\"This is an alias of Field: Video Link (field_video_link:video_url).\";}}s:8:\"argument\";a:6:{s:5:\"field\";s:26:\"field_video_link_video_url\";s:5:\"table\";s:31:\"field_revision_field_video_link\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:5:{i:0;s:26:\"field_video_link_video_url\";i:1;s:31:\"field_video_link_thumbnail_path\";i:2;s:27:\"field_video_link_video_data\";i:3;s:27:\"field_video_link_embed_code\";i:4;s:28:\"field_video_link_description\";}s:10:\"field_name\";s:16:\"field_video_link\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:26:\"field_video_link_video_url\";s:5:\"table\";s:31:\"field_revision_field_video_link\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:5:{i:0;s:26:\"field_video_link_video_url\";i:1;s:31:\"field_video_link_thumbnail_path\";i:2;s:27:\"field_video_link_video_data\";i:3;s:27:\"field_video_link_embed_code\";i:4;s:28:\"field_video_link_description\";}s:10:\"field_name\";s:16:\"field_video_link\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:26:\"field_video_link_video_url\";s:5:\"table\";s:31:\"field_revision_field_video_link\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:5:{i:0;s:26:\"field_video_link_video_url\";i:1;s:31:\"field_video_link_thumbnail_path\";i:2;s:27:\"field_video_link_video_data\";i:3;s:27:\"field_video_link_embed_code\";i:4;s:28:\"field_video_link_description\";}s:10:\"field_name\";s:16:\"field_video_link\";}}s:31:\"field_video_link_thumbnail_path\";a:8:{s:5:\"group\";s:23:\"Field (historical data)\";s:5:\"title\";s:44:\"Video Link (field_video_link:thumbnail_path)\";s:11:\"title short\";s:25:\"Video Link:thumbnail_path\";s:4:\"help\";s:205:\"Appears in: node:video, field_collection_item:field_extra_content. Also known as: Content: Video Link (field_video_link:thumbnail_path), Field collection item: Video Link (field_video_link:thumbnail_path).\";s:7:\"aliases\";a:2:{i:0;a:3:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:44:\"Video Link (field_video_link:thumbnail_path)\";s:4:\"help\";s:72:\"This is an alias of Field: Video Link (field_video_link:thumbnail_path).\";}i:1;a:3:{s:5:\"group\";s:21:\"Field collection item\";s:5:\"title\";s:44:\"Video Link (field_video_link:thumbnail_path)\";s:4:\"help\";s:72:\"This is an alias of Field: Video Link (field_video_link:thumbnail_path).\";}}s:8:\"argument\";a:6:{s:5:\"field\";s:31:\"field_video_link_thumbnail_path\";s:5:\"table\";s:31:\"field_revision_field_video_link\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:5:{i:0;s:26:\"field_video_link_video_url\";i:1;s:31:\"field_video_link_thumbnail_path\";i:2;s:27:\"field_video_link_video_data\";i:3;s:27:\"field_video_link_embed_code\";i:4;s:28:\"field_video_link_description\";}s:10:\"field_name\";s:16:\"field_video_link\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:31:\"field_video_link_thumbnail_path\";s:5:\"table\";s:31:\"field_revision_field_video_link\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:5:{i:0;s:26:\"field_video_link_video_url\";i:1;s:31:\"field_video_link_thumbnail_path\";i:2;s:27:\"field_video_link_video_data\";i:3;s:27:\"field_video_link_embed_code\";i:4;s:28:\"field_video_link_description\";}s:10:\"field_name\";s:16:\"field_video_link\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:31:\"field_video_link_thumbnail_path\";s:5:\"table\";s:31:\"field_revision_field_video_link\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:5:{i:0;s:26:\"field_video_link_video_url\";i:1;s:31:\"field_video_link_thumbnail_path\";i:2;s:27:\"field_video_link_video_data\";i:3;s:27:\"field_video_link_embed_code\";i:4;s:28:\"field_video_link_description\";}s:10:\"field_name\";s:16:\"field_video_link\";}}s:27:\"field_video_link_video_data\";a:7:{s:5:\"group\";s:23:\"Field (historical data)\";s:5:\"title\";s:40:\"Video Link (field_video_link:video_data)\";s:11:\"title short\";s:21:\"Video Link:video_data\";s:4:\"help\";s:197:\"Appears in: node:video, field_collection_item:field_extra_content. Also known as: Content: Video Link (field_video_link:video_data), Field collection item: Video Link (field_video_link:video_data).\";s:7:\"aliases\";a:2:{i:0;a:3:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:40:\"Video Link (field_video_link:video_data)\";s:4:\"help\";s:68:\"This is an alias of Field: Video Link (field_video_link:video_data).\";}i:1;a:3:{s:5:\"group\";s:21:\"Field collection item\";s:5:\"title\";s:40:\"Video Link (field_video_link:video_data)\";s:4:\"help\";s:68:\"This is an alias of Field: Video Link (field_video_link:video_data).\";}}s:8:\"argument\";a:6:{s:5:\"field\";s:27:\"field_video_link_video_data\";s:5:\"table\";s:31:\"field_revision_field_video_link\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:5:{i:0;s:26:\"field_video_link_video_url\";i:1;s:31:\"field_video_link_thumbnail_path\";i:2;s:27:\"field_video_link_video_data\";i:3;s:27:\"field_video_link_embed_code\";i:4;s:28:\"field_video_link_description\";}s:10:\"field_name\";s:16:\"field_video_link\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:27:\"field_video_link_video_data\";s:5:\"table\";s:31:\"field_revision_field_video_link\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:5:{i:0;s:26:\"field_video_link_video_url\";i:1;s:31:\"field_video_link_thumbnail_path\";i:2;s:27:\"field_video_link_video_data\";i:3;s:27:\"field_video_link_embed_code\";i:4;s:28:\"field_video_link_description\";}s:10:\"field_name\";s:16:\"field_video_link\";s:11:\"allow empty\";b:1;}}s:27:\"field_video_link_embed_code\";a:8:{s:5:\"group\";s:23:\"Field (historical data)\";s:5:\"title\";s:40:\"Video Link (field_video_link:embed_code)\";s:11:\"title short\";s:21:\"Video Link:embed_code\";s:4:\"help\";s:197:\"Appears in: node:video, field_collection_item:field_extra_content. Also known as: Content: Video Link (field_video_link:embed_code), Field collection item: Video Link (field_video_link:embed_code).\";s:7:\"aliases\";a:2:{i:0;a:3:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:40:\"Video Link (field_video_link:embed_code)\";s:4:\"help\";s:68:\"This is an alias of Field: Video Link (field_video_link:embed_code).\";}i:1;a:3:{s:5:\"group\";s:21:\"Field collection item\";s:5:\"title\";s:40:\"Video Link (field_video_link:embed_code)\";s:4:\"help\";s:68:\"This is an alias of Field: Video Link (field_video_link:embed_code).\";}}s:8:\"argument\";a:6:{s:5:\"field\";s:27:\"field_video_link_embed_code\";s:5:\"table\";s:31:\"field_revision_field_video_link\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:5:{i:0;s:26:\"field_video_link_video_url\";i:1;s:31:\"field_video_link_thumbnail_path\";i:2;s:27:\"field_video_link_video_data\";i:3;s:27:\"field_video_link_embed_code\";i:4;s:28:\"field_video_link_description\";}s:10:\"field_name\";s:16:\"field_video_link\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:27:\"field_video_link_embed_code\";s:5:\"table\";s:31:\"field_revision_field_video_link\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:5:{i:0;s:26:\"field_video_link_video_url\";i:1;s:31:\"field_video_link_thumbnail_path\";i:2;s:27:\"field_video_link_video_data\";i:3;s:27:\"field_video_link_embed_code\";i:4;s:28:\"field_video_link_description\";}s:10:\"field_name\";s:16:\"field_video_link\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:27:\"field_video_link_embed_code\";s:5:\"table\";s:31:\"field_revision_field_video_link\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:5:{i:0;s:26:\"field_video_link_video_url\";i:1;s:31:\"field_video_link_thumbnail_path\";i:2;s:27:\"field_video_link_video_data\";i:3;s:27:\"field_video_link_embed_code\";i:4;s:28:\"field_video_link_description\";}s:10:\"field_name\";s:16:\"field_video_link\";}}s:28:\"field_video_link_description\";a:7:{s:5:\"group\";s:23:\"Field (historical data)\";s:5:\"title\";s:41:\"Video Link (field_video_link:description)\";s:11:\"title short\";s:22:\"Video Link:description\";s:4:\"help\";s:199:\"Appears in: node:video, field_collection_item:field_extra_content. Also known as: Content: Video Link (field_video_link:description), Field collection item: Video Link (field_video_link:description).\";s:7:\"aliases\";a:2:{i:0;a:3:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:41:\"Video Link (field_video_link:description)\";s:4:\"help\";s:69:\"This is an alias of Field: Video Link (field_video_link:description).\";}i:1;a:3:{s:5:\"group\";s:21:\"Field collection item\";s:5:\"title\";s:41:\"Video Link (field_video_link:description)\";s:4:\"help\";s:69:\"This is an alias of Field: Video Link (field_video_link:description).\";}}s:8:\"argument\";a:6:{s:5:\"field\";s:28:\"field_video_link_description\";s:5:\"table\";s:31:\"field_revision_field_video_link\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:5:{i:0;s:26:\"field_video_link_video_url\";i:1;s:31:\"field_video_link_thumbnail_path\";i:2;s:27:\"field_video_link_video_data\";i:3;s:27:\"field_video_link_embed_code\";i:4;s:28:\"field_video_link_description\";}s:10:\"field_name\";s:16:\"field_video_link\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:28:\"field_video_link_description\";s:5:\"table\";s:31:\"field_revision_field_video_link\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:5:{i:0;s:26:\"field_video_link_video_url\";i:1;s:31:\"field_video_link_thumbnail_path\";i:2;s:27:\"field_video_link_video_data\";i:3;s:27:\"field_video_link_embed_code\";i:4;s:28:\"field_video_link_description\";}s:10:\"field_name\";s:16:\"field_video_link\";s:11:\"allow empty\";b:1;}}}s:25:\"field_data_field_category\";a:4:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:4:\"node\";a:3:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:9:\"entity_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:25:\"field_data_field_category\";i:1;s:14:\"field_category\";}}}s:14:\"field_category\";a:5:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:8:\"Category\";s:11:\"title short\";s:8:\"Category\";s:4:\"help\";s:25:\"Appears in: node:article.\";s:5:\"field\";a:9:{s:5:\"table\";s:25:\"field_data_field_category\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:14:\"field_category\";s:10:\"real field\";s:18:\"field_category_tid\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:18:\"field_category_tid\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;}}s:18:\"field_category_tid\";a:8:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:25:\"Category (field_category)\";s:11:\"title short\";s:8:\"Category\";s:4:\"help\";s:25:\"Appears in: node:article.\";s:8:\"argument\";a:6:{s:5:\"field\";s:18:\"field_category_tid\";s:5:\"table\";s:25:\"field_data_field_category\";s:7:\"handler\";s:30:\"views_handler_argument_numeric\";s:17:\"additional fields\";a:1:{i:0;s:18:\"field_category_tid\";}s:10:\"field_name\";s:14:\"field_category\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:7:{s:5:\"field\";s:18:\"field_category_tid\";s:5:\"table\";s:25:\"field_data_field_category\";s:7:\"handler\";s:34:\"views_handler_filter_term_node_tid\";s:17:\"additional fields\";a:1:{i:0;s:18:\"field_category_tid\";}s:10:\"field_name\";s:14:\"field_category\";s:11:\"allow empty\";b:1;s:10:\"vocabulary\";s:10:\"categories\";}s:4:\"sort\";a:5:{s:5:\"field\";s:18:\"field_category_tid\";s:5:\"table\";s:25:\"field_data_field_category\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:1:{i:0;s:18:\"field_category_tid\";}s:10:\"field_name\";s:14:\"field_category\";}s:12:\"relationship\";a:4:{s:7:\"handler\";s:26:\"views_handler_relationship\";s:4:\"base\";s:18:\"taxonomy_term_data\";s:10:\"base field\";s:3:\"tid\";s:5:\"label\";s:24:\"term from field_category\";}}}s:29:\"field_revision_field_category\";a:4:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:13:\"node_revision\";a:3:{s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:11:\"revision_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:29:\"field_revision_field_category\";i:1;s:26:\"field_category-revision_id\";}}}s:26:\"field_category-revision_id\";a:5:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:8:\"Category\";s:11:\"title short\";s:8:\"Category\";s:4:\"help\";s:25:\"Appears in: node:article.\";s:5:\"field\";a:9:{s:5:\"table\";s:29:\"field_revision_field_category\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:14:\"field_category\";s:10:\"real field\";s:30:\"field_category-revision_id_tid\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:18:\"field_category_tid\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:18:\"field_category_tid\";a:8:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:25:\"Category (field_category)\";s:11:\"title short\";s:8:\"Category\";s:4:\"help\";s:25:\"Appears in: node:article.\";s:8:\"argument\";a:6:{s:5:\"field\";s:18:\"field_category_tid\";s:5:\"table\";s:29:\"field_revision_field_category\";s:7:\"handler\";s:30:\"views_handler_argument_numeric\";s:17:\"additional fields\";a:1:{i:0;s:18:\"field_category_tid\";}s:10:\"field_name\";s:14:\"field_category\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:7:{s:5:\"field\";s:18:\"field_category_tid\";s:5:\"table\";s:29:\"field_revision_field_category\";s:7:\"handler\";s:34:\"views_handler_filter_term_node_tid\";s:17:\"additional fields\";a:1:{i:0;s:18:\"field_category_tid\";}s:10:\"field_name\";s:14:\"field_category\";s:11:\"allow empty\";b:1;s:10:\"vocabulary\";s:10:\"categories\";}s:4:\"sort\";a:5:{s:5:\"field\";s:18:\"field_category_tid\";s:5:\"table\";s:29:\"field_revision_field_category\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:1:{i:0;s:18:\"field_category_tid\";}s:10:\"field_name\";s:14:\"field_category\";}s:12:\"relationship\";a:4:{s:7:\"handler\";s:26:\"views_handler_relationship\";s:4:\"base\";s:18:\"taxonomy_term_data\";s:10:\"base field\";s:3:\"tid\";s:5:\"label\";s:24:\"term from field_category\";}}}s:24:\"field_data_field_section\";a:4:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:4:\"node\";a:3:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:9:\"entity_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:24:\"field_data_field_section\";i:1;s:13:\"field_section\";}}}s:13:\"field_section\";a:5:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:7:\"Section\";s:11:\"title short\";s:7:\"Section\";s:4:\"help\";s:25:\"Appears in: node:article.\";s:5:\"field\";a:9:{s:5:\"table\";s:24:\"field_data_field_section\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:13:\"field_section\";s:10:\"real field\";s:17:\"field_section_tid\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:17:\"field_section_tid\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;}}s:17:\"field_section_tid\";a:8:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:23:\"Section (field_section)\";s:11:\"title short\";s:7:\"Section\";s:4:\"help\";s:25:\"Appears in: node:article.\";s:8:\"argument\";a:6:{s:5:\"field\";s:17:\"field_section_tid\";s:5:\"table\";s:24:\"field_data_field_section\";s:7:\"handler\";s:30:\"views_handler_argument_numeric\";s:17:\"additional fields\";a:1:{i:0;s:17:\"field_section_tid\";}s:10:\"field_name\";s:13:\"field_section\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:7:{s:5:\"field\";s:17:\"field_section_tid\";s:5:\"table\";s:24:\"field_data_field_section\";s:7:\"handler\";s:34:\"views_handler_filter_term_node_tid\";s:17:\"additional fields\";a:1:{i:0;s:17:\"field_section_tid\";}s:10:\"field_name\";s:13:\"field_section\";s:11:\"allow empty\";b:1;s:10:\"vocabulary\";s:8:\"sections\";}s:4:\"sort\";a:5:{s:5:\"field\";s:17:\"field_section_tid\";s:5:\"table\";s:24:\"field_data_field_section\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:1:{i:0;s:17:\"field_section_tid\";}s:10:\"field_name\";s:13:\"field_section\";}s:12:\"relationship\";a:4:{s:7:\"handler\";s:26:\"views_handler_relationship\";s:4:\"base\";s:18:\"taxonomy_term_data\";s:10:\"base field\";s:3:\"tid\";s:5:\"label\";s:23:\"term from field_section\";}}}s:28:\"field_revision_field_section\";a:4:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:13:\"node_revision\";a:3:{s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:11:\"revision_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:28:\"field_revision_field_section\";i:1;s:25:\"field_section-revision_id\";}}}s:25:\"field_section-revision_id\";a:5:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:7:\"Section\";s:11:\"title short\";s:7:\"Section\";s:4:\"help\";s:25:\"Appears in: node:article.\";s:5:\"field\";a:9:{s:5:\"table\";s:28:\"field_revision_field_section\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:13:\"field_section\";s:10:\"real field\";s:29:\"field_section-revision_id_tid\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:17:\"field_section_tid\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:17:\"field_section_tid\";a:8:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:23:\"Section (field_section)\";s:11:\"title short\";s:7:\"Section\";s:4:\"help\";s:25:\"Appears in: node:article.\";s:8:\"argument\";a:6:{s:5:\"field\";s:17:\"field_section_tid\";s:5:\"table\";s:28:\"field_revision_field_section\";s:7:\"handler\";s:30:\"views_handler_argument_numeric\";s:17:\"additional fields\";a:1:{i:0;s:17:\"field_section_tid\";}s:10:\"field_name\";s:13:\"field_section\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:7:{s:5:\"field\";s:17:\"field_section_tid\";s:5:\"table\";s:28:\"field_revision_field_section\";s:7:\"handler\";s:34:\"views_handler_filter_term_node_tid\";s:17:\"additional fields\";a:1:{i:0;s:17:\"field_section_tid\";}s:10:\"field_name\";s:13:\"field_section\";s:11:\"allow empty\";b:1;s:10:\"vocabulary\";s:8:\"sections\";}s:4:\"sort\";a:5:{s:5:\"field\";s:17:\"field_section_tid\";s:5:\"table\";s:28:\"field_revision_field_section\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:1:{i:0;s:17:\"field_section_tid\";}s:10:\"field_name\";s:13:\"field_section\";}s:12:\"relationship\";a:4:{s:7:\"handler\";s:26:\"views_handler_relationship\";s:4:\"base\";s:18:\"taxonomy_term_data\";s:10:\"base field\";s:3:\"tid\";s:5:\"label\";s:23:\"term from field_section\";}}}s:26:\"field_data_field_published\";a:4:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:7:\"message\";a:3:{s:10:\"left_field\";s:3:\"mid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:7:\"message\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:9:\"entity_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:26:\"field_data_field_published\";i:1;s:15:\"field_published\";}}}s:15:\"field_published\";a:5:{s:5:\"group\";s:7:\"Message\";s:5:\"title\";s:9:\"Published\";s:11:\"title short\";s:9:\"Published\";s:4:\"help\";s:103:\"Appears in: message:example_create_comment, message:example_create_node, message:example_user_register.\";s:5:\"field\";a:9:{s:5:\"table\";s:26:\"field_data_field_published\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:15:\"field_published\";s:10:\"real field\";s:21:\"field_published_value\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:21:\"field_published_value\";}s:13:\"entity_tables\";a:1:{s:7:\"message\";s:7:\"message\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;}}s:21:\"field_published_value\";a:7:{s:5:\"group\";s:7:\"Message\";s:5:\"title\";s:27:\"Published (field_published)\";s:11:\"title short\";s:9:\"Published\";s:4:\"help\";s:103:\"Appears in: message:example_create_comment, message:example_create_node, message:example_user_register.\";s:8:\"argument\";a:6:{s:5:\"field\";s:21:\"field_published_value\";s:5:\"table\";s:26:\"field_data_field_published\";s:7:\"handler\";s:33:\"views_handler_argument_field_list\";s:17:\"additional fields\";a:1:{i:0;s:21:\"field_published_value\";}s:10:\"field_name\";s:15:\"field_published\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:21:\"field_published_value\";s:5:\"table\";s:26:\"field_data_field_published\";s:7:\"handler\";s:39:\"views_handler_filter_field_list_boolean\";s:17:\"additional fields\";a:1:{i:0;s:21:\"field_published_value\";}s:10:\"field_name\";s:15:\"field_published\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:21:\"field_published_value\";s:5:\"table\";s:26:\"field_data_field_published\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:1:{i:0;s:21:\"field_published_value\";}s:10:\"field_name\";s:15:\"field_published\";}}}s:25:\"field_data_field_node_ref\";a:4:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:7:\"message\";a:3:{s:10:\"left_field\";s:3:\"mid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:7:\"message\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:9:\"entity_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:25:\"field_data_field_node_ref\";i:1;s:14:\"field_node_ref\";}}}s:14:\"field_node_ref\";a:5:{s:5:\"group\";s:7:\"Message\";s:5:\"title\";s:14:\"Node reference\";s:11:\"title short\";s:14:\"Node reference\";s:4:\"help\";s:72:\"Appears in: message:example_create_comment, message:example_create_node.\";s:5:\"field\";a:9:{s:5:\"table\";s:25:\"field_data_field_node_ref\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:14:\"field_node_ref\";s:10:\"real field\";s:24:\"field_node_ref_target_id\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:24:\"field_node_ref_target_id\";}s:13:\"entity_tables\";a:1:{s:7:\"message\";s:7:\"message\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;}}s:24:\"field_node_ref_target_id\";a:8:{s:5:\"group\";s:7:\"Message\";s:5:\"title\";s:31:\"Node reference (field_node_ref)\";s:11:\"title short\";s:14:\"Node reference\";s:4:\"help\";s:72:\"Appears in: message:example_create_comment, message:example_create_node.\";s:8:\"argument\";a:6:{s:5:\"field\";s:24:\"field_node_ref_target_id\";s:5:\"table\";s:25:\"field_data_field_node_ref\";s:7:\"handler\";s:30:\"views_handler_argument_numeric\";s:17:\"additional fields\";a:1:{i:0;s:24:\"field_node_ref_target_id\";}s:10:\"field_name\";s:14:\"field_node_ref\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:24:\"field_node_ref_target_id\";s:5:\"table\";s:25:\"field_data_field_node_ref\";s:7:\"handler\";s:28:\"views_handler_filter_numeric\";s:17:\"additional fields\";a:1:{i:0;s:24:\"field_node_ref_target_id\";}s:10:\"field_name\";s:14:\"field_node_ref\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:24:\"field_node_ref_target_id\";s:5:\"table\";s:25:\"field_data_field_node_ref\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:1:{i:0;s:24:\"field_node_ref_target_id\";}s:10:\"field_name\";s:14:\"field_node_ref\";}s:12:\"relationship\";a:7:{s:7:\"handler\";s:26:\"views_handler_relationship\";s:4:\"base\";s:4:\"node\";s:10:\"base field\";s:3:\"nid\";s:5:\"label\";s:45:\"Content entity referenced from field_node_ref\";s:5:\"group\";s:16:\"Entity Reference\";s:5:\"title\";s:17:\"Referenced Entity\";s:4:\"help\";s:68:\"A bridge to the Content entity that is referenced via field_node_ref\";}}}s:28:\"field_data_field_comment_ref\";a:4:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:7:\"message\";a:3:{s:10:\"left_field\";s:3:\"mid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:7:\"message\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:9:\"entity_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:28:\"field_data_field_comment_ref\";i:1;s:17:\"field_comment_ref\";}}}s:17:\"field_comment_ref\";a:5:{s:5:\"group\";s:7:\"Message\";s:5:\"title\";s:17:\"Comment reference\";s:11:\"title short\";s:17:\"Comment reference\";s:4:\"help\";s:43:\"Appears in: message:example_create_comment.\";s:5:\"field\";a:9:{s:5:\"table\";s:28:\"field_data_field_comment_ref\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:17:\"field_comment_ref\";s:10:\"real field\";s:27:\"field_comment_ref_target_id\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:27:\"field_comment_ref_target_id\";}s:13:\"entity_tables\";a:1:{s:7:\"message\";s:7:\"message\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;}}s:27:\"field_comment_ref_target_id\";a:8:{s:5:\"group\";s:7:\"Message\";s:5:\"title\";s:37:\"Comment reference (field_comment_ref)\";s:11:\"title short\";s:17:\"Comment reference\";s:4:\"help\";s:43:\"Appears in: message:example_create_comment.\";s:8:\"argument\";a:6:{s:5:\"field\";s:27:\"field_comment_ref_target_id\";s:5:\"table\";s:28:\"field_data_field_comment_ref\";s:7:\"handler\";s:30:\"views_handler_argument_numeric\";s:17:\"additional fields\";a:1:{i:0;s:27:\"field_comment_ref_target_id\";}s:10:\"field_name\";s:17:\"field_comment_ref\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:27:\"field_comment_ref_target_id\";s:5:\"table\";s:28:\"field_data_field_comment_ref\";s:7:\"handler\";s:28:\"views_handler_filter_numeric\";s:17:\"additional fields\";a:1:{i:0;s:27:\"field_comment_ref_target_id\";}s:10:\"field_name\";s:17:\"field_comment_ref\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:27:\"field_comment_ref_target_id\";s:5:\"table\";s:28:\"field_data_field_comment_ref\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:1:{i:0;s:27:\"field_comment_ref_target_id\";}s:10:\"field_name\";s:17:\"field_comment_ref\";}s:12:\"relationship\";a:7:{s:7:\"handler\";s:26:\"views_handler_relationship\";s:4:\"base\";s:7:\"comment\";s:10:\"base field\";s:3:\"cid\";s:5:\"label\";s:48:\"Comment entity referenced from field_comment_ref\";s:5:\"group\";s:16:\"Entity Reference\";s:5:\"title\";s:17:\"Referenced Entity\";s:4:\"help\";s:71:\"A bridge to the Comment entity that is referenced via field_comment_ref\";}}}s:23:\"field_data_message_text\";a:7:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:12:\"message_type\";a:3:{s:10:\"left_field\";s:2:\"id\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:12:\"message_type\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:9:\"entity_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:23:\"field_data_message_text\";i:1;s:12:\"message_text\";}}}s:12:\"message_text\";a:5:{s:5:\"group\";s:12:\"Message type\";s:5:\"title\";s:12:\"Message text\";s:11:\"title short\";s:12:\"Message text\";s:4:\"help\";s:38:\"Appears in: message_type:message_type.\";s:5:\"field\";a:9:{s:5:\"table\";s:23:\"field_data_message_text\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:12:\"message_text\";s:10:\"real field\";s:18:\"message_text_value\";s:17:\"additional fields\";a:5:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:18:\"message_text_value\";i:4;s:19:\"message_text_format\";}s:13:\"entity_tables\";a:1:{s:12:\"message_type\";s:12:\"message_type\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;}}s:18:\"message_text_value\";a:6:{s:5:\"group\";s:12:\"Message type\";s:5:\"title\";s:27:\"Message text (message_text)\";s:11:\"title short\";s:12:\"Message text\";s:4:\"help\";s:38:\"Appears in: message_type:message_type.\";s:8:\"argument\";a:6:{s:5:\"field\";s:18:\"message_text_value\";s:5:\"table\";s:23:\"field_data_message_text\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:18:\"message_text_value\";i:1;s:19:\"message_text_format\";}s:10:\"field_name\";s:12:\"message_text\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:18:\"message_text_value\";s:5:\"table\";s:23:\"field_data_message_text\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:18:\"message_text_value\";i:1;s:19:\"message_text_format\";}s:10:\"field_name\";s:12:\"message_text\";s:11:\"allow empty\";b:1;}}s:5:\"delta\";a:8:{s:5:\"group\";s:12:\"Message type\";s:5:\"title\";s:33:\"Message text (message_text:delta)\";s:11:\"title short\";s:18:\"Message text:delta\";s:4:\"help\";s:46:\"Delta - Appears in: message_type:message_type.\";s:5:\"field\";a:1:{s:7:\"handler\";s:27:\"views_handler_field_numeric\";}s:8:\"argument\";a:6:{s:5:\"field\";s:5:\"delta\";s:5:\"table\";s:23:\"field_data_message_text\";s:7:\"handler\";s:30:\"views_handler_argument_numeric\";s:17:\"additional fields\";a:2:{i:0;s:18:\"message_text_value\";i:1;s:19:\"message_text_format\";}s:16:\"empty field name\";s:12:\"- No value -\";s:10:\"field_name\";s:12:\"message_text\";}s:6:\"filter\";a:6:{s:5:\"field\";s:5:\"delta\";s:5:\"table\";s:23:\"field_data_message_text\";s:7:\"handler\";s:28:\"views_handler_filter_numeric\";s:17:\"additional fields\";a:2:{i:0;s:18:\"message_text_value\";i:1;s:19:\"message_text_format\";}s:10:\"field_name\";s:12:\"message_text\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:5:\"delta\";s:5:\"table\";s:23:\"field_data_message_text\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:18:\"message_text_value\";i:1;s:19:\"message_text_format\";}s:10:\"field_name\";s:12:\"message_text\";}}s:8:\"language\";a:8:{s:5:\"group\";s:12:\"Message type\";s:5:\"title\";s:36:\"Message text (message_text:language)\";s:11:\"title short\";s:21:\"Message text:language\";s:4:\"help\";s:49:\"Language - Appears in: message_type:message_type.\";s:5:\"field\";a:1:{s:7:\"handler\";s:35:\"views_handler_field_locale_language\";}s:8:\"argument\";a:6:{s:5:\"field\";s:8:\"language\";s:5:\"table\";s:23:\"field_data_message_text\";s:7:\"handler\";s:38:\"views_handler_argument_locale_language\";s:17:\"additional fields\";a:2:{i:0;s:18:\"message_text_value\";i:1;s:19:\"message_text_format\";}s:16:\"empty field name\";s:10:\"<No value>\";s:10:\"field_name\";s:12:\"message_text\";}s:6:\"filter\";a:6:{s:5:\"field\";s:8:\"language\";s:5:\"table\";s:23:\"field_data_message_text\";s:7:\"handler\";s:36:\"views_handler_filter_locale_language\";s:17:\"additional fields\";a:2:{i:0;s:18:\"message_text_value\";i:1;s:19:\"message_text_format\";}s:10:\"field_name\";s:12:\"message_text\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:8:\"language\";s:5:\"table\";s:23:\"field_data_message_text\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:18:\"message_text_value\";i:1;s:19:\"message_text_format\";}s:10:\"field_name\";s:12:\"message_text\";}}s:19:\"message_text_format\";a:7:{s:5:\"group\";s:12:\"Message type\";s:5:\"title\";s:34:\"Message text (message_text:format)\";s:11:\"title short\";s:19:\"Message text:format\";s:4:\"help\";s:38:\"Appears in: message_type:message_type.\";s:8:\"argument\";a:6:{s:5:\"field\";s:19:\"message_text_format\";s:5:\"table\";s:23:\"field_data_message_text\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:18:\"message_text_value\";i:1;s:19:\"message_text_format\";}s:10:\"field_name\";s:12:\"message_text\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:19:\"message_text_format\";s:5:\"table\";s:23:\"field_data_message_text\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:18:\"message_text_value\";i:1;s:19:\"message_text_format\";}s:10:\"field_name\";s:12:\"message_text\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:19:\"message_text_format\";s:5:\"table\";s:23:\"field_data_message_text\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:18:\"message_text_value\";i:1;s:19:\"message_text_format\";}s:10:\"field_name\";s:12:\"message_text\";}}}s:21:\"field_data_field_vote\";a:5:{s:5:\"table\";a:1:{s:4:\"join\";a:2:{s:4:\"node\";a:3:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}s:7:\"comment\";a:3:{s:10:\"left_field\";s:3:\"cid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:7:\"comment\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:9:\"entity_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:21:\"field_data_field_vote\";i:1;s:10:\"field_vote\";}}}s:10:\"field_vote\";a:6:{s:5:\"group\";s:5:\"Field\";s:5:\"title\";s:4:\"Vote\";s:11:\"title short\";s:4:\"Vote\";s:4:\"help\";s:107:\"Appears in: node:forum, node:blog, comment:comment_node_forum. Also known as: Comment: Vote, Content: Vote.\";s:7:\"aliases\";a:2:{i:0;a:4:{s:4:\"base\";s:7:\"comment\";s:5:\"group\";s:7:\"Comment\";s:5:\"title\";s:4:\"Vote\";s:4:\"help\";s:32:\"This is an alias of Field: Vote.\";}i:1;a:4:{s:4:\"base\";s:4:\"node\";s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:4:\"Vote\";s:4:\"help\";s:32:\"This is an alias of Field: Vote.\";}}s:5:\"field\";a:9:{s:5:\"table\";s:21:\"field_data_field_vote\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:10:\"field_vote\";s:10:\"real field\";s:17:\"field_vote_rating\";s:17:\"additional fields\";a:5:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:17:\"field_vote_rating\";i:4;s:17:\"field_vote_target\";}s:13:\"entity_tables\";a:3:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";s:7:\"comment\";s:7:\"comment\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;}}s:17:\"field_vote_rating\";a:8:{s:5:\"group\";s:5:\"Field\";s:5:\"title\";s:24:\"Vote (field_vote:rating)\";s:11:\"title short\";s:11:\"Vote:rating\";s:4:\"help\";s:147:\"Appears in: node:forum, node:blog, comment:comment_node_forum. Also known as: Comment: Vote (field_vote:rating), Content: Vote (field_vote:rating).\";s:7:\"aliases\";a:2:{i:0;a:3:{s:5:\"group\";s:7:\"Comment\";s:5:\"title\";s:24:\"Vote (field_vote:rating)\";s:4:\"help\";s:52:\"This is an alias of Field: Vote (field_vote:rating).\";}i:1;a:3:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:24:\"Vote (field_vote:rating)\";s:4:\"help\";s:52:\"This is an alias of Field: Vote (field_vote:rating).\";}}s:8:\"argument\";a:6:{s:5:\"field\";s:17:\"field_vote_rating\";s:5:\"table\";s:21:\"field_data_field_vote\";s:7:\"handler\";s:30:\"views_handler_argument_numeric\";s:17:\"additional fields\";a:2:{i:0;s:17:\"field_vote_rating\";i:1;s:17:\"field_vote_target\";}s:10:\"field_name\";s:10:\"field_vote\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:17:\"field_vote_rating\";s:5:\"table\";s:21:\"field_data_field_vote\";s:7:\"handler\";s:28:\"views_handler_filter_numeric\";s:17:\"additional fields\";a:2:{i:0;s:17:\"field_vote_rating\";i:1;s:17:\"field_vote_target\";}s:10:\"field_name\";s:10:\"field_vote\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:17:\"field_vote_rating\";s:5:\"table\";s:21:\"field_data_field_vote\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:17:\"field_vote_rating\";i:1;s:17:\"field_vote_target\";}s:10:\"field_name\";s:10:\"field_vote\";}}s:17:\"field_vote_target\";a:8:{s:5:\"group\";s:5:\"Field\";s:5:\"title\";s:24:\"Vote (field_vote:target)\";s:11:\"title short\";s:11:\"Vote:target\";s:4:\"help\";s:147:\"Appears in: node:forum, node:blog, comment:comment_node_forum. Also known as: Comment: Vote (field_vote:target), Content: Vote (field_vote:target).\";s:7:\"aliases\";a:2:{i:0;a:3:{s:5:\"group\";s:7:\"Comment\";s:5:\"title\";s:24:\"Vote (field_vote:target)\";s:4:\"help\";s:52:\"This is an alias of Field: Vote (field_vote:target).\";}i:1;a:3:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:24:\"Vote (field_vote:target)\";s:4:\"help\";s:52:\"This is an alias of Field: Vote (field_vote:target).\";}}s:8:\"argument\";a:6:{s:5:\"field\";s:17:\"field_vote_target\";s:5:\"table\";s:21:\"field_data_field_vote\";s:7:\"handler\";s:30:\"views_handler_argument_numeric\";s:17:\"additional fields\";a:2:{i:0;s:17:\"field_vote_rating\";i:1;s:17:\"field_vote_target\";}s:10:\"field_name\";s:10:\"field_vote\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:17:\"field_vote_target\";s:5:\"table\";s:21:\"field_data_field_vote\";s:7:\"handler\";s:28:\"views_handler_filter_numeric\";s:17:\"additional fields\";a:2:{i:0;s:17:\"field_vote_rating\";i:1;s:17:\"field_vote_target\";}s:10:\"field_name\";s:10:\"field_vote\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:17:\"field_vote_target\";s:5:\"table\";s:21:\"field_data_field_vote\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:17:\"field_vote_rating\";i:1;s:17:\"field_vote_target\";}s:10:\"field_name\";s:10:\"field_vote\";}}}s:25:\"field_revision_field_vote\";a:5:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:13:\"node_revision\";a:3:{s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:11:\"revision_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:25:\"field_revision_field_vote\";i:1;s:22:\"field_vote-revision_id\";}}}s:22:\"field_vote-revision_id\";a:5:{s:5:\"group\";s:23:\"Field (historical data)\";s:5:\"title\";s:4:\"Vote\";s:11:\"title short\";s:4:\"Vote\";s:4:\"help\";s:62:\"Appears in: node:forum, node:blog, comment:comment_node_forum.\";s:5:\"field\";a:9:{s:5:\"table\";s:25:\"field_revision_field_vote\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:10:\"field_vote\";s:10:\"real field\";s:29:\"field_vote-revision_id_rating\";s:17:\"additional fields\";a:5:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:17:\"field_vote_rating\";i:4;s:17:\"field_vote_target\";}s:13:\"entity_tables\";a:3:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";s:7:\"comment\";s:7:\"comment\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:17:\"field_vote_rating\";a:8:{s:5:\"group\";s:23:\"Field (historical data)\";s:5:\"title\";s:24:\"Vote (field_vote:rating)\";s:11:\"title short\";s:11:\"Vote:rating\";s:4:\"help\";s:147:\"Appears in: node:forum, node:blog, comment:comment_node_forum. Also known as: Comment: Vote (field_vote:rating), Content: Vote (field_vote:rating).\";s:7:\"aliases\";a:2:{i:0;a:3:{s:5:\"group\";s:7:\"Comment\";s:5:\"title\";s:24:\"Vote (field_vote:rating)\";s:4:\"help\";s:52:\"This is an alias of Field: Vote (field_vote:rating).\";}i:1;a:3:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:24:\"Vote (field_vote:rating)\";s:4:\"help\";s:52:\"This is an alias of Field: Vote (field_vote:rating).\";}}s:8:\"argument\";a:6:{s:5:\"field\";s:17:\"field_vote_rating\";s:5:\"table\";s:25:\"field_revision_field_vote\";s:7:\"handler\";s:30:\"views_handler_argument_numeric\";s:17:\"additional fields\";a:2:{i:0;s:17:\"field_vote_rating\";i:1;s:17:\"field_vote_target\";}s:10:\"field_name\";s:10:\"field_vote\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:17:\"field_vote_rating\";s:5:\"table\";s:25:\"field_revision_field_vote\";s:7:\"handler\";s:28:\"views_handler_filter_numeric\";s:17:\"additional fields\";a:2:{i:0;s:17:\"field_vote_rating\";i:1;s:17:\"field_vote_target\";}s:10:\"field_name\";s:10:\"field_vote\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:17:\"field_vote_rating\";s:5:\"table\";s:25:\"field_revision_field_vote\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:17:\"field_vote_rating\";i:1;s:17:\"field_vote_target\";}s:10:\"field_name\";s:10:\"field_vote\";}}s:17:\"field_vote_target\";a:8:{s:5:\"group\";s:23:\"Field (historical data)\";s:5:\"title\";s:24:\"Vote (field_vote:target)\";s:11:\"title short\";s:11:\"Vote:target\";s:4:\"help\";s:147:\"Appears in: node:forum, node:blog, comment:comment_node_forum. Also known as: Comment: Vote (field_vote:target), Content: Vote (field_vote:target).\";s:7:\"aliases\";a:2:{i:0;a:3:{s:5:\"group\";s:7:\"Comment\";s:5:\"title\";s:24:\"Vote (field_vote:target)\";s:4:\"help\";s:52:\"This is an alias of Field: Vote (field_vote:target).\";}i:1;a:3:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:24:\"Vote (field_vote:target)\";s:4:\"help\";s:52:\"This is an alias of Field: Vote (field_vote:target).\";}}s:8:\"argument\";a:6:{s:5:\"field\";s:17:\"field_vote_target\";s:5:\"table\";s:25:\"field_revision_field_vote\";s:7:\"handler\";s:30:\"views_handler_argument_numeric\";s:17:\"additional fields\";a:2:{i:0;s:17:\"field_vote_rating\";i:1;s:17:\"field_vote_target\";}s:10:\"field_name\";s:10:\"field_vote\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:17:\"field_vote_target\";s:5:\"table\";s:25:\"field_revision_field_vote\";s:7:\"handler\";s:28:\"views_handler_filter_numeric\";s:17:\"additional fields\";a:2:{i:0;s:17:\"field_vote_rating\";i:1;s:17:\"field_vote_target\";}s:10:\"field_name\";s:10:\"field_vote\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:17:\"field_vote_target\";s:5:\"table\";s:25:\"field_revision_field_vote\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:17:\"field_vote_rating\";i:1;s:17:\"field_vote_target\";}s:10:\"field_name\";s:10:\"field_vote\";}}}s:26:\"field_data_taxonomy_forums\";a:4:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:4:\"node\";a:3:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:9:\"entity_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:26:\"field_data_taxonomy_forums\";i:1;s:15:\"taxonomy_forums\";}}}s:15:\"taxonomy_forums\";a:5:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:6:\"Forums\";s:11:\"title short\";s:6:\"Forums\";s:4:\"help\";s:23:\"Appears in: node:forum.\";s:5:\"field\";a:9:{s:5:\"table\";s:26:\"field_data_taxonomy_forums\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:15:\"taxonomy_forums\";s:10:\"real field\";s:19:\"taxonomy_forums_tid\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:19:\"taxonomy_forums_tid\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;}}s:19:\"taxonomy_forums_tid\";a:8:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:24:\"Forums (taxonomy_forums)\";s:11:\"title short\";s:6:\"Forums\";s:4:\"help\";s:23:\"Appears in: node:forum.\";s:8:\"argument\";a:6:{s:5:\"field\";s:19:\"taxonomy_forums_tid\";s:5:\"table\";s:26:\"field_data_taxonomy_forums\";s:7:\"handler\";s:30:\"views_handler_argument_numeric\";s:17:\"additional fields\";a:1:{i:0;s:19:\"taxonomy_forums_tid\";}s:10:\"field_name\";s:15:\"taxonomy_forums\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:7:{s:5:\"field\";s:19:\"taxonomy_forums_tid\";s:5:\"table\";s:26:\"field_data_taxonomy_forums\";s:7:\"handler\";s:34:\"views_handler_filter_term_node_tid\";s:17:\"additional fields\";a:1:{i:0;s:19:\"taxonomy_forums_tid\";}s:10:\"field_name\";s:15:\"taxonomy_forums\";s:11:\"allow empty\";b:1;s:10:\"vocabulary\";s:6:\"forums\";}s:4:\"sort\";a:5:{s:5:\"field\";s:19:\"taxonomy_forums_tid\";s:5:\"table\";s:26:\"field_data_taxonomy_forums\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:1:{i:0;s:19:\"taxonomy_forums_tid\";}s:10:\"field_name\";s:15:\"taxonomy_forums\";}s:12:\"relationship\";a:4:{s:7:\"handler\";s:26:\"views_handler_relationship\";s:4:\"base\";s:18:\"taxonomy_term_data\";s:10:\"base field\";s:3:\"tid\";s:5:\"label\";s:25:\"term from taxonomy_forums\";}}}s:30:\"field_revision_taxonomy_forums\";a:4:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:13:\"node_revision\";a:3:{s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:11:\"revision_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:30:\"field_revision_taxonomy_forums\";i:1;s:27:\"taxonomy_forums-revision_id\";}}}s:27:\"taxonomy_forums-revision_id\";a:5:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:6:\"Forums\";s:11:\"title short\";s:6:\"Forums\";s:4:\"help\";s:23:\"Appears in: node:forum.\";s:5:\"field\";a:9:{s:5:\"table\";s:30:\"field_revision_taxonomy_forums\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:15:\"taxonomy_forums\";s:10:\"real field\";s:31:\"taxonomy_forums-revision_id_tid\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:19:\"taxonomy_forums_tid\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:19:\"taxonomy_forums_tid\";a:8:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:24:\"Forums (taxonomy_forums)\";s:11:\"title short\";s:6:\"Forums\";s:4:\"help\";s:23:\"Appears in: node:forum.\";s:8:\"argument\";a:6:{s:5:\"field\";s:19:\"taxonomy_forums_tid\";s:5:\"table\";s:30:\"field_revision_taxonomy_forums\";s:7:\"handler\";s:30:\"views_handler_argument_numeric\";s:17:\"additional fields\";a:1:{i:0;s:19:\"taxonomy_forums_tid\";}s:10:\"field_name\";s:15:\"taxonomy_forums\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:7:{s:5:\"field\";s:19:\"taxonomy_forums_tid\";s:5:\"table\";s:30:\"field_revision_taxonomy_forums\";s:7:\"handler\";s:34:\"views_handler_filter_term_node_tid\";s:17:\"additional fields\";a:1:{i:0;s:19:\"taxonomy_forums_tid\";}s:10:\"field_name\";s:15:\"taxonomy_forums\";s:11:\"allow empty\";b:1;s:10:\"vocabulary\";s:6:\"forums\";}s:4:\"sort\";a:5:{s:5:\"field\";s:19:\"taxonomy_forums_tid\";s:5:\"table\";s:30:\"field_revision_taxonomy_forums\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:1:{i:0;s:19:\"taxonomy_forums_tid\";}s:10:\"field_name\";s:15:\"taxonomy_forums\";}s:12:\"relationship\";a:4:{s:7:\"handler\";s:26:\"views_handler_relationship\";s:4:\"base\";s:18:\"taxonomy_term_data\";s:10:\"base field\";s:3:\"tid\";s:5:\"label\";s:25:\"term from taxonomy_forums\";}}}s:22:\"field_data_field_image\";a:8:{s:5:\"table\";a:1:{s:4:\"join\";a:2:{s:4:\"node\";a:3:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}s:21:\"field_collection_item\";a:3:{s:10:\"left_field\";s:7:\"item_id\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:21:\"field_collection_item\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:9:\"entity_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:22:\"field_data_field_image\";i:1;s:11:\"field_image\";}}}s:11:\"field_image\";a:6:{s:5:\"group\";s:5:\"Field\";s:5:\"title\";s:5:\"Image\";s:11:\"title short\";s:5:\"Image\";s:4:\"help\";s:155:\"Appears in: node:article, node:blog, node:products, field_collection_item:field_extra_content. Also known as: Content: Image, Field collection item: Image.\";s:7:\"aliases\";a:2:{i:0;a:4:{s:4:\"base\";s:4:\"node\";s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:5:\"Image\";s:4:\"help\";s:33:\"This is an alias of Field: Image.\";}i:1;a:4:{s:4:\"base\";s:21:\"field_collection_item\";s:5:\"group\";s:21:\"Field collection item\";s:5:\"title\";s:5:\"Image\";s:4:\"help\";s:33:\"This is an alias of Field: Image.\";}}s:5:\"field\";a:9:{s:5:\"table\";s:22:\"field_data_field_image\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:11:\"field_image\";s:10:\"real field\";s:15:\"field_image_fid\";s:17:\"additional fields\";a:8:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:15:\"field_image_fid\";i:4;s:15:\"field_image_alt\";i:5;s:17:\"field_image_title\";i:6;s:17:\"field_image_width\";i:7;s:18:\"field_image_height\";}s:13:\"entity_tables\";a:4:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";s:21:\"field_collection_item\";s:21:\"field_collection_item\";s:30:\"field_collection_item_revision\";s:21:\"field_collection_item\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;}}s:15:\"field_image_fid\";a:9:{s:5:\"group\";s:5:\"Field\";s:5:\"title\";s:23:\"Image (field_image:fid)\";s:11:\"title short\";s:9:\"Image:fid\";s:4:\"help\";s:191:\"Appears in: node:article, node:blog, node:products, field_collection_item:field_extra_content. Also known as: Content: Image (field_image:fid), Field collection item: Image (field_image:fid).\";s:7:\"aliases\";a:2:{i:0;a:3:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:23:\"Image (field_image:fid)\";s:4:\"help\";s:51:\"This is an alias of Field: Image (field_image:fid).\";}i:1;a:3:{s:5:\"group\";s:21:\"Field collection item\";s:5:\"title\";s:23:\"Image (field_image:fid)\";s:4:\"help\";s:51:\"This is an alias of Field: Image (field_image:fid).\";}}s:8:\"argument\";a:6:{s:5:\"field\";s:15:\"field_image_fid\";s:5:\"table\";s:22:\"field_data_field_image\";s:7:\"handler\";s:30:\"views_handler_argument_numeric\";s:17:\"additional fields\";a:5:{i:0;s:15:\"field_image_fid\";i:1;s:15:\"field_image_alt\";i:2;s:17:\"field_image_title\";i:3;s:17:\"field_image_width\";i:4;s:18:\"field_image_height\";}s:10:\"field_name\";s:11:\"field_image\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:15:\"field_image_fid\";s:5:\"table\";s:22:\"field_data_field_image\";s:7:\"handler\";s:28:\"views_handler_filter_numeric\";s:17:\"additional fields\";a:5:{i:0;s:15:\"field_image_fid\";i:1;s:15:\"field_image_alt\";i:2;s:17:\"field_image_title\";i:3;s:17:\"field_image_width\";i:4;s:18:\"field_image_height\";}s:10:\"field_name\";s:11:\"field_image\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:15:\"field_image_fid\";s:5:\"table\";s:22:\"field_data_field_image\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:5:{i:0;s:15:\"field_image_fid\";i:1;s:15:\"field_image_alt\";i:2;s:17:\"field_image_title\";i:3;s:17:\"field_image_width\";i:4;s:18:\"field_image_height\";}s:10:\"field_name\";s:11:\"field_image\";}s:12:\"relationship\";a:4:{s:7:\"handler\";s:26:\"views_handler_relationship\";s:4:\"base\";s:12:\"file_managed\";s:10:\"base field\";s:3:\"fid\";s:5:\"label\";s:22:\"image from field_image\";}}s:15:\"field_image_alt\";a:8:{s:5:\"group\";s:5:\"Field\";s:5:\"title\";s:23:\"Image (field_image:alt)\";s:11:\"title short\";s:9:\"Image:alt\";s:4:\"help\";s:191:\"Appears in: node:article, node:blog, node:products, field_collection_item:field_extra_content. Also known as: Content: Image (field_image:alt), Field collection item: Image (field_image:alt).\";s:7:\"aliases\";a:2:{i:0;a:3:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:23:\"Image (field_image:alt)\";s:4:\"help\";s:51:\"This is an alias of Field: Image (field_image:alt).\";}i:1;a:3:{s:5:\"group\";s:21:\"Field collection item\";s:5:\"title\";s:23:\"Image (field_image:alt)\";s:4:\"help\";s:51:\"This is an alias of Field: Image (field_image:alt).\";}}s:8:\"argument\";a:6:{s:5:\"field\";s:15:\"field_image_alt\";s:5:\"table\";s:22:\"field_data_field_image\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:5:{i:0;s:15:\"field_image_fid\";i:1;s:15:\"field_image_alt\";i:2;s:17:\"field_image_title\";i:3;s:17:\"field_image_width\";i:4;s:18:\"field_image_height\";}s:10:\"field_name\";s:11:\"field_image\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:15:\"field_image_alt\";s:5:\"table\";s:22:\"field_data_field_image\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:5:{i:0;s:15:\"field_image_fid\";i:1;s:15:\"field_image_alt\";i:2;s:17:\"field_image_title\";i:3;s:17:\"field_image_width\";i:4;s:18:\"field_image_height\";}s:10:\"field_name\";s:11:\"field_image\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:15:\"field_image_alt\";s:5:\"table\";s:22:\"field_data_field_image\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:5:{i:0;s:15:\"field_image_fid\";i:1;s:15:\"field_image_alt\";i:2;s:17:\"field_image_title\";i:3;s:17:\"field_image_width\";i:4;s:18:\"field_image_height\";}s:10:\"field_name\";s:11:\"field_image\";}}s:17:\"field_image_title\";a:8:{s:5:\"group\";s:5:\"Field\";s:5:\"title\";s:25:\"Image (field_image:title)\";s:11:\"title short\";s:11:\"Image:title\";s:4:\"help\";s:195:\"Appears in: node:article, node:blog, node:products, field_collection_item:field_extra_content. Also known as: Content: Image (field_image:title), Field collection item: Image (field_image:title).\";s:7:\"aliases\";a:2:{i:0;a:3:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:25:\"Image (field_image:title)\";s:4:\"help\";s:53:\"This is an alias of Field: Image (field_image:title).\";}i:1;a:3:{s:5:\"group\";s:21:\"Field collection item\";s:5:\"title\";s:25:\"Image (field_image:title)\";s:4:\"help\";s:53:\"This is an alias of Field: Image (field_image:title).\";}}s:8:\"argument\";a:6:{s:5:\"field\";s:17:\"field_image_title\";s:5:\"table\";s:22:\"field_data_field_image\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:5:{i:0;s:15:\"field_image_fid\";i:1;s:15:\"field_image_alt\";i:2;s:17:\"field_image_title\";i:3;s:17:\"field_image_width\";i:4;s:18:\"field_image_height\";}s:10:\"field_name\";s:11:\"field_image\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:17:\"field_image_title\";s:5:\"table\";s:22:\"field_data_field_image\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:5:{i:0;s:15:\"field_image_fid\";i:1;s:15:\"field_image_alt\";i:2;s:17:\"field_image_title\";i:3;s:17:\"field_image_width\";i:4;s:18:\"field_image_height\";}s:10:\"field_name\";s:11:\"field_image\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:17:\"field_image_title\";s:5:\"table\";s:22:\"field_data_field_image\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:5:{i:0;s:15:\"field_image_fid\";i:1;s:15:\"field_image_alt\";i:2;s:17:\"field_image_title\";i:3;s:17:\"field_image_width\";i:4;s:18:\"field_image_height\";}s:10:\"field_name\";s:11:\"field_image\";}}s:17:\"field_image_width\";a:8:{s:5:\"group\";s:5:\"Field\";s:5:\"title\";s:25:\"Image (field_image:width)\";s:11:\"title short\";s:11:\"Image:width\";s:4:\"help\";s:195:\"Appears in: node:article, node:blog, node:products, field_collection_item:field_extra_content. Also known as: Content: Image (field_image:width), Field collection item: Image (field_image:width).\";s:7:\"aliases\";a:2:{i:0;a:3:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:25:\"Image (field_image:width)\";s:4:\"help\";s:53:\"This is an alias of Field: Image (field_image:width).\";}i:1;a:3:{s:5:\"group\";s:21:\"Field collection item\";s:5:\"title\";s:25:\"Image (field_image:width)\";s:4:\"help\";s:53:\"This is an alias of Field: Image (field_image:width).\";}}s:8:\"argument\";a:6:{s:5:\"field\";s:17:\"field_image_width\";s:5:\"table\";s:22:\"field_data_field_image\";s:7:\"handler\";s:30:\"views_handler_argument_numeric\";s:17:\"additional fields\";a:5:{i:0;s:15:\"field_image_fid\";i:1;s:15:\"field_image_alt\";i:2;s:17:\"field_image_title\";i:3;s:17:\"field_image_width\";i:4;s:18:\"field_image_height\";}s:10:\"field_name\";s:11:\"field_image\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:17:\"field_image_width\";s:5:\"table\";s:22:\"field_data_field_image\";s:7:\"handler\";s:28:\"views_handler_filter_numeric\";s:17:\"additional fields\";a:5:{i:0;s:15:\"field_image_fid\";i:1;s:15:\"field_image_alt\";i:2;s:17:\"field_image_title\";i:3;s:17:\"field_image_width\";i:4;s:18:\"field_image_height\";}s:10:\"field_name\";s:11:\"field_image\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:17:\"field_image_width\";s:5:\"table\";s:22:\"field_data_field_image\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:5:{i:0;s:15:\"field_image_fid\";i:1;s:15:\"field_image_alt\";i:2;s:17:\"field_image_title\";i:3;s:17:\"field_image_width\";i:4;s:18:\"field_image_height\";}s:10:\"field_name\";s:11:\"field_image\";}}s:18:\"field_image_height\";a:8:{s:5:\"group\";s:5:\"Field\";s:5:\"title\";s:26:\"Image (field_image:height)\";s:11:\"title short\";s:12:\"Image:height\";s:4:\"help\";s:197:\"Appears in: node:article, node:blog, node:products, field_collection_item:field_extra_content. Also known as: Content: Image (field_image:height), Field collection item: Image (field_image:height).\";s:7:\"aliases\";a:2:{i:0;a:3:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:26:\"Image (field_image:height)\";s:4:\"help\";s:54:\"This is an alias of Field: Image (field_image:height).\";}i:1;a:3:{s:5:\"group\";s:21:\"Field collection item\";s:5:\"title\";s:26:\"Image (field_image:height)\";s:4:\"help\";s:54:\"This is an alias of Field: Image (field_image:height).\";}}s:8:\"argument\";a:6:{s:5:\"field\";s:18:\"field_image_height\";s:5:\"table\";s:22:\"field_data_field_image\";s:7:\"handler\";s:30:\"views_handler_argument_numeric\";s:17:\"additional fields\";a:5:{i:0;s:15:\"field_image_fid\";i:1;s:15:\"field_image_alt\";i:2;s:17:\"field_image_title\";i:3;s:17:\"field_image_width\";i:4;s:18:\"field_image_height\";}s:10:\"field_name\";s:11:\"field_image\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:18:\"field_image_height\";s:5:\"table\";s:22:\"field_data_field_image\";s:7:\"handler\";s:28:\"views_handler_filter_numeric\";s:17:\"additional fields\";a:5:{i:0;s:15:\"field_image_fid\";i:1;s:15:\"field_image_alt\";i:2;s:17:\"field_image_title\";i:3;s:17:\"field_image_width\";i:4;s:18:\"field_image_height\";}s:10:\"field_name\";s:11:\"field_image\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:18:\"field_image_height\";s:5:\"table\";s:22:\"field_data_field_image\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:5:{i:0;s:15:\"field_image_fid\";i:1;s:15:\"field_image_alt\";i:2;s:17:\"field_image_title\";i:3;s:17:\"field_image_width\";i:4;s:18:\"field_image_height\";}s:10:\"field_name\";s:11:\"field_image\";}}}s:26:\"field_revision_field_image\";a:8:{s:5:\"table\";a:1:{s:4:\"join\";a:2:{s:13:\"node_revision\";a:3:{s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}s:30:\"field_collection_item_revision\";a:3:{s:10:\"left_field\";s:11:\"revision_id\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:21:\"field_collection_item\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:11:\"revision_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:26:\"field_revision_field_image\";i:1;s:23:\"field_image-revision_id\";}}}s:23:\"field_image-revision_id\";a:5:{s:5:\"group\";s:23:\"Field (historical data)\";s:5:\"title\";s:5:\"Image\";s:11:\"title short\";s:5:\"Image\";s:4:\"help\";s:94:\"Appears in: node:article, node:blog, node:products, field_collection_item:field_extra_content.\";s:5:\"field\";a:9:{s:5:\"table\";s:26:\"field_revision_field_image\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:11:\"field_image\";s:10:\"real field\";s:27:\"field_image-revision_id_fid\";s:17:\"additional fields\";a:8:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:15:\"field_image_fid\";i:4;s:15:\"field_image_alt\";i:5;s:17:\"field_image_title\";i:6;s:17:\"field_image_width\";i:7;s:18:\"field_image_height\";}s:13:\"entity_tables\";a:4:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";s:21:\"field_collection_item\";s:21:\"field_collection_item\";s:30:\"field_collection_item_revision\";s:21:\"field_collection_item\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:15:\"field_image_fid\";a:9:{s:5:\"group\";s:23:\"Field (historical data)\";s:5:\"title\";s:23:\"Image (field_image:fid)\";s:11:\"title short\";s:9:\"Image:fid\";s:4:\"help\";s:191:\"Appears in: node:article, node:blog, node:products, field_collection_item:field_extra_content. Also known as: Content: Image (field_image:fid), Field collection item: Image (field_image:fid).\";s:7:\"aliases\";a:2:{i:0;a:3:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:23:\"Image (field_image:fid)\";s:4:\"help\";s:51:\"This is an alias of Field: Image (field_image:fid).\";}i:1;a:3:{s:5:\"group\";s:21:\"Field collection item\";s:5:\"title\";s:23:\"Image (field_image:fid)\";s:4:\"help\";s:51:\"This is an alias of Field: Image (field_image:fid).\";}}s:8:\"argument\";a:6:{s:5:\"field\";s:15:\"field_image_fid\";s:5:\"table\";s:26:\"field_revision_field_image\";s:7:\"handler\";s:30:\"views_handler_argument_numeric\";s:17:\"additional fields\";a:5:{i:0;s:15:\"field_image_fid\";i:1;s:15:\"field_image_alt\";i:2;s:17:\"field_image_title\";i:3;s:17:\"field_image_width\";i:4;s:18:\"field_image_height\";}s:10:\"field_name\";s:11:\"field_image\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:15:\"field_image_fid\";s:5:\"table\";s:26:\"field_revision_field_image\";s:7:\"handler\";s:28:\"views_handler_filter_numeric\";s:17:\"additional fields\";a:5:{i:0;s:15:\"field_image_fid\";i:1;s:15:\"field_image_alt\";i:2;s:17:\"field_image_title\";i:3;s:17:\"field_image_width\";i:4;s:18:\"field_image_height\";}s:10:\"field_name\";s:11:\"field_image\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:15:\"field_image_fid\";s:5:\"table\";s:26:\"field_revision_field_image\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:5:{i:0;s:15:\"field_image_fid\";i:1;s:15:\"field_image_alt\";i:2;s:17:\"field_image_title\";i:3;s:17:\"field_image_width\";i:4;s:18:\"field_image_height\";}s:10:\"field_name\";s:11:\"field_image\";}s:12:\"relationship\";a:4:{s:7:\"handler\";s:26:\"views_handler_relationship\";s:4:\"base\";s:12:\"file_managed\";s:10:\"base field\";s:3:\"fid\";s:5:\"label\";s:22:\"image from field_image\";}}s:15:\"field_image_alt\";a:8:{s:5:\"group\";s:23:\"Field (historical data)\";s:5:\"title\";s:23:\"Image (field_image:alt)\";s:11:\"title short\";s:9:\"Image:alt\";s:4:\"help\";s:191:\"Appears in: node:article, node:blog, node:products, field_collection_item:field_extra_content. Also known as: Content: Image (field_image:alt), Field collection item: Image (field_image:alt).\";s:7:\"aliases\";a:2:{i:0;a:3:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:23:\"Image (field_image:alt)\";s:4:\"help\";s:51:\"This is an alias of Field: Image (field_image:alt).\";}i:1;a:3:{s:5:\"group\";s:21:\"Field collection item\";s:5:\"title\";s:23:\"Image (field_image:alt)\";s:4:\"help\";s:51:\"This is an alias of Field: Image (field_image:alt).\";}}s:8:\"argument\";a:6:{s:5:\"field\";s:15:\"field_image_alt\";s:5:\"table\";s:26:\"field_revision_field_image\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:5:{i:0;s:15:\"field_image_fid\";i:1;s:15:\"field_image_alt\";i:2;s:17:\"field_image_title\";i:3;s:17:\"field_image_width\";i:4;s:18:\"field_image_height\";}s:10:\"field_name\";s:11:\"field_image\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:15:\"field_image_alt\";s:5:\"table\";s:26:\"field_revision_field_image\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:5:{i:0;s:15:\"field_image_fid\";i:1;s:15:\"field_image_alt\";i:2;s:17:\"field_image_title\";i:3;s:17:\"field_image_width\";i:4;s:18:\"field_image_height\";}s:10:\"field_name\";s:11:\"field_image\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:15:\"field_image_alt\";s:5:\"table\";s:26:\"field_revision_field_image\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:5:{i:0;s:15:\"field_image_fid\";i:1;s:15:\"field_image_alt\";i:2;s:17:\"field_image_title\";i:3;s:17:\"field_image_width\";i:4;s:18:\"field_image_height\";}s:10:\"field_name\";s:11:\"field_image\";}}s:17:\"field_image_title\";a:8:{s:5:\"group\";s:23:\"Field (historical data)\";s:5:\"title\";s:25:\"Image (field_image:title)\";s:11:\"title short\";s:11:\"Image:title\";s:4:\"help\";s:195:\"Appears in: node:article, node:blog, node:products, field_collection_item:field_extra_content. Also known as: Content: Image (field_image:title), Field collection item: Image (field_image:title).\";s:7:\"aliases\";a:2:{i:0;a:3:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:25:\"Image (field_image:title)\";s:4:\"help\";s:53:\"This is an alias of Field: Image (field_image:title).\";}i:1;a:3:{s:5:\"group\";s:21:\"Field collection item\";s:5:\"title\";s:25:\"Image (field_image:title)\";s:4:\"help\";s:53:\"This is an alias of Field: Image (field_image:title).\";}}s:8:\"argument\";a:6:{s:5:\"field\";s:17:\"field_image_title\";s:5:\"table\";s:26:\"field_revision_field_image\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:5:{i:0;s:15:\"field_image_fid\";i:1;s:15:\"field_image_alt\";i:2;s:17:\"field_image_title\";i:3;s:17:\"field_image_width\";i:4;s:18:\"field_image_height\";}s:10:\"field_name\";s:11:\"field_image\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:17:\"field_image_title\";s:5:\"table\";s:26:\"field_revision_field_image\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:5:{i:0;s:15:\"field_image_fid\";i:1;s:15:\"field_image_alt\";i:2;s:17:\"field_image_title\";i:3;s:17:\"field_image_width\";i:4;s:18:\"field_image_height\";}s:10:\"field_name\";s:11:\"field_image\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:17:\"field_image_title\";s:5:\"table\";s:26:\"field_revision_field_image\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:5:{i:0;s:15:\"field_image_fid\";i:1;s:15:\"field_image_alt\";i:2;s:17:\"field_image_title\";i:3;s:17:\"field_image_width\";i:4;s:18:\"field_image_height\";}s:10:\"field_name\";s:11:\"field_image\";}}s:17:\"field_image_width\";a:8:{s:5:\"group\";s:23:\"Field (historical data)\";s:5:\"title\";s:25:\"Image (field_image:width)\";s:11:\"title short\";s:11:\"Image:width\";s:4:\"help\";s:195:\"Appears in: node:article, node:blog, node:products, field_collection_item:field_extra_content. Also known as: Content: Image (field_image:width), Field collection item: Image (field_image:width).\";s:7:\"aliases\";a:2:{i:0;a:3:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:25:\"Image (field_image:width)\";s:4:\"help\";s:53:\"This is an alias of Field: Image (field_image:width).\";}i:1;a:3:{s:5:\"group\";s:21:\"Field collection item\";s:5:\"title\";s:25:\"Image (field_image:width)\";s:4:\"help\";s:53:\"This is an alias of Field: Image (field_image:width).\";}}s:8:\"argument\";a:6:{s:5:\"field\";s:17:\"field_image_width\";s:5:\"table\";s:26:\"field_revision_field_image\";s:7:\"handler\";s:30:\"views_handler_argument_numeric\";s:17:\"additional fields\";a:5:{i:0;s:15:\"field_image_fid\";i:1;s:15:\"field_image_alt\";i:2;s:17:\"field_image_title\";i:3;s:17:\"field_image_width\";i:4;s:18:\"field_image_height\";}s:10:\"field_name\";s:11:\"field_image\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:17:\"field_image_width\";s:5:\"table\";s:26:\"field_revision_field_image\";s:7:\"handler\";s:28:\"views_handler_filter_numeric\";s:17:\"additional fields\";a:5:{i:0;s:15:\"field_image_fid\";i:1;s:15:\"field_image_alt\";i:2;s:17:\"field_image_title\";i:3;s:17:\"field_image_width\";i:4;s:18:\"field_image_height\";}s:10:\"field_name\";s:11:\"field_image\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:17:\"field_image_width\";s:5:\"table\";s:26:\"field_revision_field_image\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:5:{i:0;s:15:\"field_image_fid\";i:1;s:15:\"field_image_alt\";i:2;s:17:\"field_image_title\";i:3;s:17:\"field_image_width\";i:4;s:18:\"field_image_height\";}s:10:\"field_name\";s:11:\"field_image\";}}s:18:\"field_image_height\";a:8:{s:5:\"group\";s:23:\"Field (historical data)\";s:5:\"title\";s:26:\"Image (field_image:height)\";s:11:\"title short\";s:12:\"Image:height\";s:4:\"help\";s:197:\"Appears in: node:article, node:blog, node:products, field_collection_item:field_extra_content. Also known as: Content: Image (field_image:height), Field collection item: Image (field_image:height).\";s:7:\"aliases\";a:2:{i:0;a:3:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:26:\"Image (field_image:height)\";s:4:\"help\";s:54:\"This is an alias of Field: Image (field_image:height).\";}i:1;a:3:{s:5:\"group\";s:21:\"Field collection item\";s:5:\"title\";s:26:\"Image (field_image:height)\";s:4:\"help\";s:54:\"This is an alias of Field: Image (field_image:height).\";}}s:8:\"argument\";a:6:{s:5:\"field\";s:18:\"field_image_height\";s:5:\"table\";s:26:\"field_revision_field_image\";s:7:\"handler\";s:30:\"views_handler_argument_numeric\";s:17:\"additional fields\";a:5:{i:0;s:15:\"field_image_fid\";i:1;s:15:\"field_image_alt\";i:2;s:17:\"field_image_title\";i:3;s:17:\"field_image_width\";i:4;s:18:\"field_image_height\";}s:10:\"field_name\";s:11:\"field_image\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:18:\"field_image_height\";s:5:\"table\";s:26:\"field_revision_field_image\";s:7:\"handler\";s:28:\"views_handler_filter_numeric\";s:17:\"additional fields\";a:5:{i:0;s:15:\"field_image_fid\";i:1;s:15:\"field_image_alt\";i:2;s:17:\"field_image_title\";i:3;s:17:\"field_image_width\";i:4;s:18:\"field_image_height\";}s:10:\"field_name\";s:11:\"field_image\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:18:\"field_image_height\";s:5:\"table\";s:26:\"field_revision_field_image\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:5:{i:0;s:15:\"field_image_fid\";i:1;s:15:\"field_image_alt\";i:2;s:17:\"field_image_title\";i:3;s:17:\"field_image_width\";i:4;s:18:\"field_image_height\";}s:10:\"field_name\";s:11:\"field_image\";}}}s:21:\"field_data_field_tags\";a:5:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:4:\"node\";a:3:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:9:\"entity_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:21:\"field_data_field_tags\";i:1;s:10:\"field_tags\";}}}s:10:\"field_tags\";a:5:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:4:\"Tags\";s:11:\"title short\";s:4:\"Tags\";s:4:\"help\";s:48:\"Appears in: node:article, node:blog, node:video.\";s:5:\"field\";a:9:{s:5:\"table\";s:21:\"field_data_field_tags\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:10:\"field_tags\";s:10:\"real field\";s:14:\"field_tags_tid\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:14:\"field_tags_tid\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;}}s:14:\"field_tags_tid\";a:8:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:17:\"Tags (field_tags)\";s:11:\"title short\";s:4:\"Tags\";s:4:\"help\";s:48:\"Appears in: node:article, node:blog, node:video.\";s:8:\"argument\";a:6:{s:5:\"field\";s:14:\"field_tags_tid\";s:5:\"table\";s:21:\"field_data_field_tags\";s:7:\"handler\";s:30:\"views_handler_argument_numeric\";s:17:\"additional fields\";a:1:{i:0;s:14:\"field_tags_tid\";}s:10:\"field_name\";s:10:\"field_tags\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:7:{s:5:\"field\";s:14:\"field_tags_tid\";s:5:\"table\";s:21:\"field_data_field_tags\";s:7:\"handler\";s:34:\"views_handler_filter_term_node_tid\";s:17:\"additional fields\";a:1:{i:0;s:14:\"field_tags_tid\";}s:10:\"field_name\";s:10:\"field_tags\";s:11:\"allow empty\";b:1;s:10:\"vocabulary\";s:4:\"tags\";}s:4:\"sort\";a:5:{s:5:\"field\";s:14:\"field_tags_tid\";s:5:\"table\";s:21:\"field_data_field_tags\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:1:{i:0;s:14:\"field_tags_tid\";}s:10:\"field_name\";s:10:\"field_tags\";}s:12:\"relationship\";a:4:{s:7:\"handler\";s:26:\"views_handler_relationship\";s:4:\"base\";s:18:\"taxonomy_term_data\";s:10:\"base field\";s:3:\"tid\";s:5:\"label\";s:20:\"term from field_tags\";}}s:5:\"delta\";a:8:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:23:\"Tags (field_tags:delta)\";s:11:\"title short\";s:10:\"Tags:delta\";s:4:\"help\";s:56:\"Delta - Appears in: node:article, node:blog, node:video.\";s:5:\"field\";a:1:{s:7:\"handler\";s:27:\"views_handler_field_numeric\";}s:8:\"argument\";a:6:{s:5:\"field\";s:5:\"delta\";s:5:\"table\";s:21:\"field_data_field_tags\";s:7:\"handler\";s:30:\"views_handler_argument_numeric\";s:17:\"additional fields\";a:1:{i:0;s:14:\"field_tags_tid\";}s:16:\"empty field name\";s:12:\"- No value -\";s:10:\"field_name\";s:10:\"field_tags\";}s:6:\"filter\";a:6:{s:5:\"field\";s:5:\"delta\";s:5:\"table\";s:21:\"field_data_field_tags\";s:7:\"handler\";s:28:\"views_handler_filter_numeric\";s:17:\"additional fields\";a:1:{i:0;s:14:\"field_tags_tid\";}s:10:\"field_name\";s:10:\"field_tags\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:5:\"delta\";s:5:\"table\";s:21:\"field_data_field_tags\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:1:{i:0;s:14:\"field_tags_tid\";}s:10:\"field_name\";s:10:\"field_tags\";}}}s:25:\"field_revision_field_tags\";a:5:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:13:\"node_revision\";a:3:{s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:11:\"revision_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:25:\"field_revision_field_tags\";i:1;s:22:\"field_tags-revision_id\";}}}s:22:\"field_tags-revision_id\";a:5:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:4:\"Tags\";s:11:\"title short\";s:4:\"Tags\";s:4:\"help\";s:48:\"Appears in: node:article, node:blog, node:video.\";s:5:\"field\";a:9:{s:5:\"table\";s:25:\"field_revision_field_tags\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:10:\"field_tags\";s:10:\"real field\";s:26:\"field_tags-revision_id_tid\";s:17:\"additional fields\";a:4:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:14:\"field_tags_tid\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:14:\"field_tags_tid\";a:8:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:17:\"Tags (field_tags)\";s:11:\"title short\";s:4:\"Tags\";s:4:\"help\";s:48:\"Appears in: node:article, node:blog, node:video.\";s:8:\"argument\";a:6:{s:5:\"field\";s:14:\"field_tags_tid\";s:5:\"table\";s:25:\"field_revision_field_tags\";s:7:\"handler\";s:30:\"views_handler_argument_numeric\";s:17:\"additional fields\";a:1:{i:0;s:14:\"field_tags_tid\";}s:10:\"field_name\";s:10:\"field_tags\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:7:{s:5:\"field\";s:14:\"field_tags_tid\";s:5:\"table\";s:25:\"field_revision_field_tags\";s:7:\"handler\";s:34:\"views_handler_filter_term_node_tid\";s:17:\"additional fields\";a:1:{i:0;s:14:\"field_tags_tid\";}s:10:\"field_name\";s:10:\"field_tags\";s:11:\"allow empty\";b:1;s:10:\"vocabulary\";s:4:\"tags\";}s:4:\"sort\";a:5:{s:5:\"field\";s:14:\"field_tags_tid\";s:5:\"table\";s:25:\"field_revision_field_tags\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:1:{i:0;s:14:\"field_tags_tid\";}s:10:\"field_name\";s:10:\"field_tags\";}s:12:\"relationship\";a:4:{s:7:\"handler\";s:26:\"views_handler_relationship\";s:4:\"base\";s:18:\"taxonomy_term_data\";s:10:\"base field\";s:3:\"tid\";s:5:\"label\";s:20:\"term from field_tags\";}}s:5:\"delta\";a:8:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:23:\"Tags (field_tags:delta)\";s:11:\"title short\";s:10:\"Tags:delta\";s:4:\"help\";s:56:\"Delta - Appears in: node:article, node:blog, node:video.\";s:5:\"field\";a:1:{s:7:\"handler\";s:27:\"views_handler_field_numeric\";}s:8:\"argument\";a:6:{s:5:\"field\";s:5:\"delta\";s:5:\"table\";s:25:\"field_revision_field_tags\";s:7:\"handler\";s:30:\"views_handler_argument_numeric\";s:17:\"additional fields\";a:1:{i:0;s:14:\"field_tags_tid\";}s:16:\"empty field name\";s:12:\"- No value -\";s:10:\"field_name\";s:10:\"field_tags\";}s:6:\"filter\";a:6:{s:5:\"field\";s:5:\"delta\";s:5:\"table\";s:25:\"field_revision_field_tags\";s:7:\"handler\";s:28:\"views_handler_filter_numeric\";s:17:\"additional fields\";a:1:{i:0;s:14:\"field_tags_tid\";}s:10:\"field_name\";s:10:\"field_tags\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:5:\"delta\";s:5:\"table\";s:25:\"field_revision_field_tags\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:1:{i:0;s:14:\"field_tags_tid\";}s:10:\"field_name\";s:10:\"field_tags\";}}}s:15:\"field_data_body\";a:6:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:4:\"node\";a:3:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:9:\"entity_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:15:\"field_data_body\";i:1;s:4:\"body\";}}}s:4:\"body\";a:5:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:4:\"Body\";s:11:\"title short\";s:4:\"Body\";s:4:\"help\";s:121:\"Appears in: node:page, node:article, node:blog, node:book, node:forum, node:faq, node:video, node:webform, node:products.\";s:5:\"field\";a:9:{s:5:\"table\";s:15:\"field_data_body\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:4:\"body\";s:10:\"real field\";s:10:\"body_value\";s:17:\"additional fields\";a:6:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:10:\"body_value\";i:4;s:12:\"body_summary\";i:5;s:11:\"body_format\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;}}s:10:\"body_value\";a:6:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:11:\"Body (body)\";s:11:\"title short\";s:4:\"Body\";s:4:\"help\";s:121:\"Appears in: node:page, node:article, node:blog, node:book, node:forum, node:faq, node:video, node:webform, node:products.\";s:8:\"argument\";a:6:{s:5:\"field\";s:10:\"body_value\";s:5:\"table\";s:15:\"field_data_body\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:3:{i:0;s:10:\"body_value\";i:1;s:12:\"body_summary\";i:2;s:11:\"body_format\";}s:10:\"field_name\";s:4:\"body\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:10:\"body_value\";s:5:\"table\";s:15:\"field_data_body\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:3:{i:0;s:10:\"body_value\";i:1;s:12:\"body_summary\";i:2;s:11:\"body_format\";}s:10:\"field_name\";s:4:\"body\";s:11:\"allow empty\";b:1;}}s:12:\"body_summary\";a:6:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:19:\"Body (body:summary)\";s:11:\"title short\";s:12:\"Body:summary\";s:4:\"help\";s:121:\"Appears in: node:page, node:article, node:blog, node:book, node:forum, node:faq, node:video, node:webform, node:products.\";s:8:\"argument\";a:6:{s:5:\"field\";s:12:\"body_summary\";s:5:\"table\";s:15:\"field_data_body\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:3:{i:0;s:10:\"body_value\";i:1;s:12:\"body_summary\";i:2;s:11:\"body_format\";}s:10:\"field_name\";s:4:\"body\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:12:\"body_summary\";s:5:\"table\";s:15:\"field_data_body\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:3:{i:0;s:10:\"body_value\";i:1;s:12:\"body_summary\";i:2;s:11:\"body_format\";}s:10:\"field_name\";s:4:\"body\";s:11:\"allow empty\";b:1;}}s:11:\"body_format\";a:7:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:18:\"Body (body:format)\";s:11:\"title short\";s:11:\"Body:format\";s:4:\"help\";s:121:\"Appears in: node:page, node:article, node:blog, node:book, node:forum, node:faq, node:video, node:webform, node:products.\";s:8:\"argument\";a:6:{s:5:\"field\";s:11:\"body_format\";s:5:\"table\";s:15:\"field_data_body\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:3:{i:0;s:10:\"body_value\";i:1;s:12:\"body_summary\";i:2;s:11:\"body_format\";}s:10:\"field_name\";s:4:\"body\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:11:\"body_format\";s:5:\"table\";s:15:\"field_data_body\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:3:{i:0;s:10:\"body_value\";i:1;s:12:\"body_summary\";i:2;s:11:\"body_format\";}s:10:\"field_name\";s:4:\"body\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:11:\"body_format\";s:5:\"table\";s:15:\"field_data_body\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:3:{i:0;s:10:\"body_value\";i:1;s:12:\"body_summary\";i:2;s:11:\"body_format\";}s:10:\"field_name\";s:4:\"body\";}}}s:19:\"field_revision_body\";a:6:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:13:\"node_revision\";a:3:{s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:11:\"revision_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:11:\"revision_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:19:\"field_revision_body\";i:1;s:16:\"body-revision_id\";}}}s:16:\"body-revision_id\";a:5:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:4:\"Body\";s:11:\"title short\";s:4:\"Body\";s:4:\"help\";s:121:\"Appears in: node:page, node:article, node:blog, node:book, node:forum, node:faq, node:video, node:webform, node:products.\";s:5:\"field\";a:9:{s:5:\"table\";s:19:\"field_revision_body\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:4:\"body\";s:10:\"real field\";s:22:\"body-revision_id_value\";s:17:\"additional fields\";a:6:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:10:\"body_value\";i:4;s:12:\"body_summary\";i:5;s:11:\"body_format\";}s:13:\"entity_tables\";a:2:{s:4:\"node\";s:4:\"node\";s:13:\"node_revision\";s:4:\"node\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:1;}}s:10:\"body_value\";a:6:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:11:\"Body (body)\";s:11:\"title short\";s:4:\"Body\";s:4:\"help\";s:121:\"Appears in: node:page, node:article, node:blog, node:book, node:forum, node:faq, node:video, node:webform, node:products.\";s:8:\"argument\";a:6:{s:5:\"field\";s:10:\"body_value\";s:5:\"table\";s:19:\"field_revision_body\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:3:{i:0;s:10:\"body_value\";i:1;s:12:\"body_summary\";i:2;s:11:\"body_format\";}s:10:\"field_name\";s:4:\"body\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:10:\"body_value\";s:5:\"table\";s:19:\"field_revision_body\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:3:{i:0;s:10:\"body_value\";i:1;s:12:\"body_summary\";i:2;s:11:\"body_format\";}s:10:\"field_name\";s:4:\"body\";s:11:\"allow empty\";b:1;}}s:12:\"body_summary\";a:6:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:19:\"Body (body:summary)\";s:11:\"title short\";s:12:\"Body:summary\";s:4:\"help\";s:121:\"Appears in: node:page, node:article, node:blog, node:book, node:forum, node:faq, node:video, node:webform, node:products.\";s:8:\"argument\";a:6:{s:5:\"field\";s:12:\"body_summary\";s:5:\"table\";s:19:\"field_revision_body\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:3:{i:0;s:10:\"body_value\";i:1;s:12:\"body_summary\";i:2;s:11:\"body_format\";}s:10:\"field_name\";s:4:\"body\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:12:\"body_summary\";s:5:\"table\";s:19:\"field_revision_body\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:3:{i:0;s:10:\"body_value\";i:1;s:12:\"body_summary\";i:2;s:11:\"body_format\";}s:10:\"field_name\";s:4:\"body\";s:11:\"allow empty\";b:1;}}s:11:\"body_format\";a:7:{s:5:\"group\";s:25:\"Content (historical data)\";s:5:\"title\";s:18:\"Body (body:format)\";s:11:\"title short\";s:11:\"Body:format\";s:4:\"help\";s:121:\"Appears in: node:page, node:article, node:blog, node:book, node:forum, node:faq, node:video, node:webform, node:products.\";s:8:\"argument\";a:6:{s:5:\"field\";s:11:\"body_format\";s:5:\"table\";s:19:\"field_revision_body\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:3:{i:0;s:10:\"body_value\";i:1;s:12:\"body_summary\";i:2;s:11:\"body_format\";}s:10:\"field_name\";s:4:\"body\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:11:\"body_format\";s:5:\"table\";s:19:\"field_revision_body\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:3:{i:0;s:10:\"body_value\";i:1;s:12:\"body_summary\";i:2;s:11:\"body_format\";}s:10:\"field_name\";s:4:\"body\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:11:\"body_format\";s:5:\"table\";s:19:\"field_revision_body\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:3:{i:0;s:10:\"body_value\";i:1;s:12:\"body_summary\";i:2;s:11:\"body_format\";}s:10:\"field_name\";s:4:\"body\";}}}s:23:\"field_data_comment_body\";a:5:{s:5:\"table\";a:1:{s:4:\"join\";a:1:{s:7:\"comment\";a:3:{s:10:\"left_field\";s:3:\"cid\";s:5:\"field\";s:9:\"entity_id\";s:5:\"extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:7:\"comment\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}}s:9:\"entity_id\";a:1:{s:5:\"field\";a:1:{s:8:\"moved to\";a:2:{i:0;s:23:\"field_data_comment_body\";i:1;s:12:\"comment_body\";}}}s:12:\"comment_body\";a:5:{s:5:\"group\";s:7:\"Comment\";s:5:\"title\";s:7:\"Comment\";s:11:\"title short\";s:7:\"Comment\";s:4:\"help\";s:265:\"Appears in: comment:comment_node_page, comment:comment_node_article, comment:comment_node_blog, comment:comment_node_book, comment:comment_node_forum, comment:comment_node_faq, comment:comment_node_video, comment:comment_node_webform, comment:comment_node_products.\";s:5:\"field\";a:9:{s:5:\"table\";s:23:\"field_data_comment_body\";s:7:\"handler\";s:25:\"views_handler_field_field\";s:14:\"click sortable\";b:1;s:10:\"field_name\";s:12:\"comment_body\";s:10:\"real field\";s:18:\"comment_body_value\";s:17:\"additional fields\";a:5:{i:0;s:5:\"delta\";i:1;s:8:\"language\";i:2;s:6:\"bundle\";i:3;s:18:\"comment_body_value\";i:4;s:19:\"comment_body_format\";}s:13:\"entity_tables\";a:1:{s:7:\"comment\";s:7:\"comment\";}s:12:\"element type\";s:3:\"div\";s:11:\"is revision\";b:0;}}s:18:\"comment_body_value\";a:6:{s:5:\"group\";s:7:\"Comment\";s:5:\"title\";s:22:\"Comment (comment_body)\";s:11:\"title short\";s:7:\"Comment\";s:4:\"help\";s:265:\"Appears in: comment:comment_node_page, comment:comment_node_article, comment:comment_node_blog, comment:comment_node_book, comment:comment_node_forum, comment:comment_node_faq, comment:comment_node_video, comment:comment_node_webform, comment:comment_node_products.\";s:8:\"argument\";a:6:{s:5:\"field\";s:18:\"comment_body_value\";s:5:\"table\";s:23:\"field_data_comment_body\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:18:\"comment_body_value\";i:1;s:19:\"comment_body_format\";}s:10:\"field_name\";s:12:\"comment_body\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:18:\"comment_body_value\";s:5:\"table\";s:23:\"field_data_comment_body\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:18:\"comment_body_value\";i:1;s:19:\"comment_body_format\";}s:10:\"field_name\";s:12:\"comment_body\";s:11:\"allow empty\";b:1;}}s:19:\"comment_body_format\";a:7:{s:5:\"group\";s:7:\"Comment\";s:5:\"title\";s:29:\"Comment (comment_body:format)\";s:11:\"title short\";s:14:\"Comment:format\";s:4:\"help\";s:265:\"Appears in: comment:comment_node_page, comment:comment_node_article, comment:comment_node_blog, comment:comment_node_book, comment:comment_node_forum, comment:comment_node_faq, comment:comment_node_video, comment:comment_node_webform, comment:comment_node_products.\";s:8:\"argument\";a:6:{s:5:\"field\";s:19:\"comment_body_format\";s:5:\"table\";s:23:\"field_data_comment_body\";s:7:\"handler\";s:29:\"views_handler_argument_string\";s:17:\"additional fields\";a:2:{i:0;s:18:\"comment_body_value\";i:1;s:19:\"comment_body_format\";}s:10:\"field_name\";s:12:\"comment_body\";s:16:\"empty field name\";s:12:\"- No value -\";}s:6:\"filter\";a:6:{s:5:\"field\";s:19:\"comment_body_format\";s:5:\"table\";s:23:\"field_data_comment_body\";s:7:\"handler\";s:27:\"views_handler_filter_string\";s:17:\"additional fields\";a:2:{i:0;s:18:\"comment_body_value\";i:1;s:19:\"comment_body_format\";}s:10:\"field_name\";s:12:\"comment_body\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:5:{s:5:\"field\";s:19:\"comment_body_format\";s:5:\"table\";s:23:\"field_data_comment_body\";s:7:\"handler\";s:18:\"views_handler_sort\";s:17:\"additional fields\";a:2:{i:0;s:18:\"comment_body_value\";i:1;s:19:\"comment_body_format\";}s:10:\"field_name\";s:12:\"comment_body\";}}}s:14:\"filter_formats\";a:1:{s:8:\"moved to\";s:13:\"filter_format\";}s:13:\"filter_format\";a:1:{s:5:\"table\";a:1:{s:4:\"join\";a:2:{s:13:\"node_revision\";a:2:{s:10:\"left_field\";s:6:\"format\";s:5:\"field\";s:6:\"format\";}s:4:\"node\";a:3:{s:10:\"left_table\";s:13:\"node_revision\";s:10:\"left_field\";s:6:\"format\";s:5:\"field\";s:6:\"format\";}}}}s:14:\"locales_source\";a:7:{s:5:\"table\";a:2:{s:5:\"group\";s:13:\"Locale source\";s:4:\"base\";a:3:{s:5:\"field\";s:3:\"lid\";s:5:\"title\";s:13:\"Locale source\";s:4:\"help\";s:73:\"A source string for translation, in English or the default site language.\";}}s:3:\"lid\";a:6:{s:5:\"title\";s:3:\"LID\";s:4:\"help\";s:28:\"The ID of the source string.\";s:5:\"field\";a:2:{s:7:\"handler\";s:19:\"views_handler_field\";s:14:\"click sortable\";b:1;}s:8:\"argument\";a:3:{s:7:\"handler\";s:30:\"views_handler_argument_numeric\";s:7:\"numeric\";b:1;s:13:\"validate type\";s:3:\"lid\";}s:6:\"filter\";a:1:{s:7:\"handler\";s:28:\"views_handler_filter_numeric\";}s:4:\"sort\";a:1:{s:7:\"handler\";s:18:\"views_handler_sort\";}}s:8:\"location\";a:7:{s:5:\"group\";s:13:\"Locale source\";s:5:\"title\";s:8:\"Location\";s:4:\"help\";s:55:\"A description of the location or context of the string.\";s:5:\"field\";a:2:{s:7:\"handler\";s:19:\"views_handler_field\";s:14:\"click sortable\";b:1;}s:4:\"sort\";a:1:{s:7:\"handler\";s:18:\"views_handler_sort\";}s:6:\"filter\";a:1:{s:7:\"handler\";s:27:\"views_handler_filter_string\";}s:8:\"argument\";a:1:{s:7:\"handler\";s:29:\"views_handler_argument_string\";}}s:9:\"textgroup\";a:6:{s:5:\"group\";s:13:\"Locale source\";s:5:\"title\";s:5:\"Group\";s:4:\"help\";s:32:\"The group the translation is in.\";s:5:\"field\";a:2:{s:7:\"handler\";s:32:\"views_handler_field_locale_group\";s:14:\"click sortable\";b:1;}s:6:\"filter\";a:1:{s:7:\"handler\";s:33:\"views_handler_filter_locale_group\";}s:8:\"argument\";a:1:{s:7:\"handler\";s:35:\"views_handler_argument_locale_group\";}}s:6:\"source\";a:5:{s:5:\"group\";s:13:\"Locale source\";s:5:\"title\";s:6:\"Source\";s:4:\"help\";s:25:\"The full original string.\";s:5:\"field\";a:1:{s:7:\"handler\";s:19:\"views_handler_field\";}s:6:\"filter\";a:1:{s:7:\"handler\";s:27:\"views_handler_filter_string\";}}s:7:\"version\";a:6:{s:5:\"group\";s:13:\"Locale source\";s:5:\"title\";s:7:\"Version\";s:4:\"help\";s:51:\"The version of Drupal core that this string is for.\";s:5:\"field\";a:2:{s:7:\"handler\";s:19:\"views_handler_field\";s:14:\"click sortable\";b:1;}s:6:\"filter\";a:1:{s:7:\"handler\";s:35:\"views_handler_filter_locale_version\";}s:8:\"argument\";a:1:{s:7:\"handler\";s:29:\"views_handler_argument_string\";}}s:8:\"edit_lid\";a:2:{s:5:\"group\";s:13:\"Locale source\";s:5:\"field\";a:3:{s:5:\"title\";s:9:\"Edit link\";s:4:\"help\";s:47:\"Provide a simple link to edit the translations.\";s:7:\"handler\";s:36:\"views_handler_field_locale_link_edit\";}}}s:14:\"locales_target\";a:5:{s:5:\"table\";a:2:{s:5:\"group\";s:13:\"Locale target\";s:4:\"join\";a:1:{s:14:\"locales_source\";a:2:{s:10:\"left_field\";s:3:\"lid\";s:5:\"field\";s:3:\"lid\";}}}s:11:\"translation\";a:5:{s:5:\"group\";s:13:\"Locale target\";s:5:\"title\";s:11:\"Translation\";s:4:\"help\";s:28:\"The full translation string.\";s:5:\"field\";a:1:{s:7:\"handler\";s:19:\"views_handler_field\";}s:6:\"filter\";a:1:{s:7:\"handler\";s:27:\"views_handler_filter_string\";}}s:8:\"language\";a:6:{s:5:\"group\";s:13:\"Locale target\";s:5:\"title\";s:8:\"Language\";s:4:\"help\";s:36:\"The language this translation is in.\";s:5:\"field\";a:2:{s:7:\"handler\";s:35:\"views_handler_field_locale_language\";s:14:\"click sortable\";b:1;}s:6:\"filter\";a:1:{s:7:\"handler\";s:36:\"views_handler_filter_locale_language\";}s:8:\"argument\";a:1:{s:7:\"handler\";s:38:\"views_handler_argument_locale_language\";}}s:4:\"plid\";a:4:{s:5:\"group\";s:13:\"Locale target\";s:5:\"title\";s:12:\"Singular LID\";s:4:\"help\";s:33:\"The ID of the parent translation.\";s:5:\"field\";a:1:{s:7:\"handler\";s:19:\"views_handler_field\";}}s:6:\"plural\";a:6:{s:5:\"group\";s:13:\"Locale target\";s:5:\"title\";s:6:\"Plural\";s:4:\"help\";s:41:\"Whether or not the translation is plural.\";s:5:\"field\";a:2:{s:7:\"handler\";s:27:\"views_handler_field_boolean\";s:14:\"click sortable\";b:1;}s:6:\"filter\";a:3:{s:7:\"handler\";s:37:\"views_handler_filter_boolean_operator\";s:5:\"label\";s:6:\"Plural\";s:4:\"type\";s:6:\"yes-no\";}s:4:\"sort\";a:1:{s:7:\"handler\";s:18:\"views_handler_sort\";}}}s:14:\"node_revisions\";a:2:{s:8:\"moved to\";s:13:\"node_revision\";s:4:\"body\";a:1:{s:8:\"moved to\";a:2:{i:0;s:19:\"field_revision_data\";i:1;s:16:\"body-revision_id\";}}}s:11:\"node_access\";a:2:{s:5:\"table\";a:2:{s:5:\"group\";s:14:\"Content access\";s:4:\"join\";a:1:{s:4:\"node\";a:2:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:3:\"nid\";}}}s:3:\"nid\";a:3:{s:5:\"title\";s:6:\"Access\";s:4:\"help\";s:17:\"Filter by access.\";s:6:\"filter\";a:2:{s:7:\"handler\";s:32:\"views_handler_filter_node_access\";s:4:\"help\";s:107:\"Filter for content by view access. <strong>Not necessary if you are using node as your base table.</strong>\";}}}s:12:\"history_user\";a:1:{s:8:\"moved to\";s:7:\"history\";}s:7:\"history\";a:2:{s:5:\"table\";a:2:{s:5:\"group\";s:7:\"Content\";s:4:\"join\";a:1:{s:4:\"node\";a:4:{s:5:\"table\";s:7:\"history\";s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:3:\"nid\";s:5:\"extra\";a:1:{i:0;a:3:{s:5:\"field\";s:3:\"uid\";s:5:\"value\";s:18:\"***CURRENT_USER***\";s:7:\"numeric\";b:1;}}}}}s:9:\"timestamp\";a:3:{s:5:\"title\";s:15:\"Has new content\";s:5:\"field\";a:2:{s:7:\"handler\";s:42:\"views_handler_field_history_user_timestamp\";s:4:\"help\";s:47:\"Show a marker if the content is new or updated.\";}s:6:\"filter\";a:2:{s:4:\"help\";s:41:\"Show only content that is new or updated.\";s:7:\"handler\";s:43:\"views_handler_filter_history_user_timestamp\";}}}s:12:\"search_index\";a:3:{s:5:\"table\";a:2:{s:5:\"group\";s:6:\"Search\";s:4:\"join\";a:1:{s:4:\"node\";a:2:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:3:\"sid\";}}}s:5:\"score\";a:4:{s:5:\"title\";s:5:\"Score\";s:4:\"help\";s:93:\"The score of the search item. This will not be used if the search filter is not also present.\";s:5:\"field\";a:4:{s:7:\"handler\";s:32:\"views_handler_field_search_score\";s:14:\"click sortable\";b:1;s:5:\"float\";b:1;s:11:\"no group by\";b:1;}s:4:\"sort\";a:2:{s:7:\"handler\";s:31:\"views_handler_sort_search_score\";s:11:\"no group by\";b:1;}}s:4:\"keys\";a:4:{s:5:\"title\";s:12:\"Search Terms\";s:4:\"help\";s:24:\"The terms to search for.\";s:6:\"filter\";a:2:{s:7:\"handler\";s:27:\"views_handler_filter_search\";s:11:\"no group by\";b:1;}s:8:\"argument\";a:2:{s:7:\"handler\";s:29:\"views_handler_argument_search\";s:11:\"no group by\";b:1;}}}s:12:\"search_total\";a:1:{s:5:\"table\";a:1:{s:4:\"join\";a:2:{s:4:\"node\";a:3:{s:10:\"left_table\";s:12:\"search_index\";s:10:\"left_field\";s:4:\"word\";s:5:\"field\";s:4:\"word\";}s:5:\"users\";a:3:{s:10:\"left_table\";s:12:\"search_index\";s:10:\"left_field\";s:4:\"word\";s:5:\"field\";s:4:\"word\";}}}}s:14:\"search_dataset\";a:1:{s:5:\"table\";a:1:{s:4:\"join\";a:2:{s:4:\"node\";a:5:{s:10:\"left_table\";s:12:\"search_index\";s:10:\"left_field\";s:3:\"sid\";s:5:\"field\";s:3:\"sid\";s:5:\"extra\";s:39:\"search_index.type = search_dataset.type\";s:4:\"type\";s:5:\"INNER\";}s:5:\"users\";a:5:{s:10:\"left_table\";s:12:\"search_index\";s:10:\"left_field\";s:3:\"sid\";s:5:\"field\";s:3:\"sid\";s:5:\"extra\";s:39:\"search_index.type = search_dataset.type\";s:4:\"type\";s:5:\"INNER\";}}}}s:22:\"search_node_links_from\";a:2:{s:5:\"table\";a:2:{s:5:\"group\";s:6:\"Search\";s:4:\"join\";a:1:{s:4:\"node\";a:1:{s:9:\"arguments\";a:6:{i:0;s:17:\"search_node_links\";i:1;s:4:\"node\";i:2;s:3:\"nid\";i:3;s:3:\"nid\";i:4;N;i:5;s:5:\"INNER\";}}}}s:3:\"sid\";a:4:{s:5:\"title\";s:10:\"Links from\";s:4:\"help\";s:42:\"Other nodes that are linked from the node.\";s:8:\"argument\";a:1:{s:7:\"handler\";s:31:\"views_handler_argument_node_nid\";}s:6:\"filter\";a:1:{s:7:\"handler\";s:29:\"views_handler_filter_equality\";}}}s:20:\"search_node_links_to\";a:2:{s:5:\"table\";a:2:{s:5:\"group\";s:6:\"Search\";s:4:\"join\";a:1:{s:4:\"node\";a:1:{s:9:\"arguments\";a:6:{i:0;s:17:\"search_node_links\";i:1;s:4:\"node\";i:2;s:3:\"nid\";i:3;s:3:\"sid\";i:4;N;i:5;s:5:\"INNER\";}}}}s:3:\"nid\";a:4:{s:5:\"title\";s:8:\"Links to\";s:4:\"help\";s:34:\"Other nodes that link to the node.\";s:8:\"argument\";a:1:{s:7:\"handler\";s:31:\"views_handler_argument_node_nid\";}s:6:\"filter\";a:1:{s:7:\"handler\";s:29:\"views_handler_filter_equality\";}}}s:12:\"node_counter\";a:4:{s:5:\"table\";a:2:{s:5:\"group\";s:18:\"Content statistics\";s:4:\"join\";a:1:{s:4:\"node\";a:2:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:3:\"nid\";}}}s:10:\"totalcount\";a:5:{s:5:\"title\";s:11:\"Total views\";s:4:\"help\";s:51:\"The total number of times the node has been viewed.\";s:5:\"field\";a:2:{s:7:\"handler\";s:38:\"views_handler_field_statistics_numeric\";s:14:\"click sortable\";b:1;}s:6:\"filter\";a:1:{s:7:\"handler\";s:28:\"views_handler_filter_numeric\";}s:4:\"sort\";a:1:{s:7:\"handler\";s:18:\"views_handler_sort\";}}s:8:\"daycount\";a:5:{s:5:\"title\";s:11:\"Views today\";s:4:\"help\";s:57:\"The total number of times the node has been viewed today.\";s:5:\"field\";a:2:{s:7:\"handler\";s:38:\"views_handler_field_statistics_numeric\";s:14:\"click sortable\";b:1;}s:6:\"filter\";a:1:{s:7:\"handler\";s:28:\"views_handler_filter_numeric\";}s:4:\"sort\";a:1:{s:7:\"handler\";s:18:\"views_handler_sort\";}}s:9:\"timestamp\";a:5:{s:5:\"title\";s:16:\"Most recent view\";s:4:\"help\";s:46:\"The most recent time the node has been viewed.\";s:5:\"field\";a:2:{s:7:\"handler\";s:42:\"views_handler_field_node_counter_timestamp\";s:14:\"click sortable\";b:1;}s:6:\"filter\";a:2:{s:7:\"handler\";s:25:\"views_handler_filter_date\";s:7:\"is date\";b:1;}s:4:\"sort\";a:1:{s:7:\"handler\";s:18:\"views_handler_sort\";}}}s:9:\"accesslog\";a:10:{s:5:\"table\";a:3:{s:5:\"group\";s:10:\"Access log\";s:4:\"base\";a:4:{s:5:\"field\";s:3:\"aid\";s:5:\"title\";s:10:\"Access log\";s:4:\"help\";s:31:\"Stores site access information.\";s:6:\"weight\";i:10;}s:4:\"join\";a:1:{s:5:\"users\";a:2:{s:5:\"field\";s:3:\"uid\";s:10:\"left_field\";s:3:\"uid\";}}}s:3:\"aid\";a:6:{s:5:\"title\";s:3:\"Aid\";s:4:\"help\";s:23:\"Unique access event ID.\";s:5:\"field\";a:2:{s:7:\"handler\";s:27:\"views_handler_field_numeric\";s:14:\"click sortable\";b:1;}s:8:\"argument\";a:3:{s:7:\"handler\";s:30:\"views_handler_argument_numeric\";s:10:\"name field\";s:3:\"wid\";s:7:\"numeric\";b:1;}s:6:\"filter\";a:1:{s:7:\"handler\";s:28:\"views_handler_filter_numeric\";}s:4:\"sort\";a:1:{s:7:\"handler\";s:18:\"views_handler_sort\";}}s:3:\"sid\";a:6:{s:5:\"title\";s:10:\"Session ID\";s:4:\"help\";s:45:\"Browser session ID of user that visited page.\";s:5:\"field\";a:2:{s:7:\"handler\";s:19:\"views_handler_field\";s:14:\"click sortable\";b:1;}s:6:\"filter\";a:1:{s:7:\"handler\";s:27:\"views_handler_filter_string\";}s:8:\"argument\";a:1:{s:7:\"handler\";s:29:\"views_handler_argument_string\";}s:4:\"sort\";a:1:{s:7:\"handler\";s:18:\"views_handler_sort\";}}s:5:\"title\";a:6:{s:5:\"title\";s:10:\"Page title\";s:4:\"help\";s:22:\"Title of page visited.\";s:5:\"field\";a:2:{s:7:\"handler\";s:34:\"views_handler_field_accesslog_path\";s:14:\"click sortable\";b:1;}s:6:\"filter\";a:1:{s:7:\"handler\";s:27:\"views_handler_filter_string\";}s:4:\"sort\";a:1:{s:7:\"handler\";s:18:\"views_handler_sort\";}s:8:\"argument\";a:1:{s:7:\"handler\";s:29:\"views_handler_argument_string\";}}s:4:\"path\";a:5:{s:5:\"title\";s:4:\"Path\";s:4:\"help\";s:56:\"Internal path to page visited (relative to Drupal root.)\";s:5:\"field\";a:2:{s:7:\"handler\";s:34:\"views_handler_field_accesslog_path\";s:14:\"click sortable\";b:1;}s:6:\"filter\";a:1:{s:7:\"handler\";s:27:\"views_handler_filter_string\";}s:4:\"sort\";a:1:{s:7:\"handler\";s:18:\"views_handler_sort\";}}s:3:\"url\";a:5:{s:5:\"title\";s:8:\"Referrer\";s:4:\"help\";s:13:\"Referrer URI.\";s:5:\"field\";a:2:{s:7:\"handler\";s:23:\"views_handler_field_url\";s:14:\"click sortable\";b:1;}s:6:\"filter\";a:1:{s:7:\"handler\";s:27:\"views_handler_filter_string\";}s:4:\"sort\";a:1:{s:7:\"handler\";s:18:\"views_handler_sort\";}}s:8:\"hostname\";a:6:{s:5:\"title\";s:8:\"Hostname\";s:4:\"help\";s:39:\"Hostname of user that visited the page.\";s:5:\"field\";a:2:{s:7:\"handler\";s:19:\"views_handler_field\";s:14:\"click sortable\";b:1;}s:6:\"filter\";a:1:{s:7:\"handler\";s:27:\"views_handler_filter_string\";}s:4:\"sort\";a:1:{s:7:\"handler\";s:18:\"views_handler_sort\";}s:8:\"argument\";a:1:{s:7:\"handler\";s:29:\"views_handler_argument_string\";}}s:3:\"uid\";a:3:{s:5:\"title\";s:4:\"User\";s:4:\"help\";s:30:\"The user who visited the site.\";s:12:\"relationship\";a:3:{s:7:\"handler\";s:26:\"views_handler_relationship\";s:4:\"base\";s:5:\"users\";s:10:\"base field\";s:3:\"uid\";}}s:5:\"timer\";a:5:{s:5:\"title\";s:5:\"Timer\";s:4:\"help\";s:48:\"Time in milliseconds that the page took to load.\";s:5:\"field\";a:2:{s:7:\"handler\";s:27:\"views_handler_field_numeric\";s:14:\"click sortable\";b:1;}s:6:\"filter\";a:1:{s:7:\"handler\";s:28:\"views_handler_filter_numeric\";}s:4:\"sort\";a:1:{s:7:\"handler\";s:18:\"views_handler_sort\";}}s:9:\"timestamp\";a:5:{s:5:\"title\";s:9:\"Timestamp\";s:4:\"help\";s:39:\"Timestamp of when the page was visited.\";s:5:\"field\";a:3:{s:7:\"handler\";s:24:\"views_handler_field_date\";s:14:\"click sortable\";b:1;s:7:\"is date\";b:1;}s:4:\"sort\";a:1:{s:7:\"handler\";s:18:\"views_handler_sort\";}s:6:\"filter\";a:2:{s:7:\"handler\";s:25:\"views_handler_filter_date\";s:7:\"is date\";b:1;}}}s:5:\"files\";a:1:{s:8:\"moved to\";s:12:\"file_managed\";}s:10:\"file_usage\";a:15:{s:5:\"table\";a:2:{s:5:\"group\";s:10:\"File Usage\";s:4:\"join\";a:6:{s:12:\"file_managed\";a:2:{s:5:\"field\";s:3:\"fid\";s:10:\"left_field\";s:3:\"fid\";}s:4:\"node\";a:3:{s:5:\"field\";s:2:\"id\";s:10:\"left_field\";s:3:\"nid\";s:5:\"extra\";a:1:{i:0;a:2:{s:5:\"field\";s:4:\"type\";s:5:\"value\";s:4:\"node\";}}}s:5:\"users\";a:3:{s:5:\"field\";s:2:\"id\";s:10:\"left_field\";s:3:\"uid\";s:5:\"extra\";a:1:{i:0;a:2:{s:5:\"field\";s:4:\"type\";s:5:\"value\";s:4:\"user\";}}}s:7:\"comment\";a:3:{s:5:\"field\";s:2:\"id\";s:10:\"left_field\";s:3:\"cid\";s:5:\"extra\";a:1:{i:0;a:2:{s:5:\"field\";s:4:\"type\";s:5:\"value\";s:7:\"comment\";}}}s:18:\"taxonomy_term_data\";a:3:{s:5:\"field\";s:2:\"id\";s:10:\"left_field\";s:3:\"tid\";s:5:\"extra\";a:1:{i:0;a:2:{s:5:\"field\";s:4:\"type\";s:5:\"value\";s:13:\"taxonomy_term\";}}}s:19:\"taxonomy_vocabulary\";a:3:{s:5:\"field\";s:2:\"id\";s:10:\"left_field\";s:3:\"vid\";s:5:\"extra\";a:1:{i:0;a:2:{s:5:\"field\";s:4:\"type\";s:5:\"value\";s:19:\"taxonomy_vocabulary\";}}}}}s:12:\"file_to_node\";a:5:{s:5:\"title\";s:7:\"Content\";s:4:\"help\";s:98:\"Content that is associated with this file, usually because this file is in a field on the content.\";s:9:\"skip base\";a:6:{i:0;s:4:\"node\";i:1;s:13:\"node_revision\";i:2;s:5:\"users\";i:3;s:7:\"comment\";i:4;s:18:\"taxonomy_term_data\";i:5;s:19:\"taxonomy_vocabulary\";}s:10:\"real field\";s:2:\"id\";s:12:\"relationship\";a:6:{s:5:\"title\";s:7:\"Content\";s:5:\"label\";s:7:\"Content\";s:4:\"base\";s:4:\"node\";s:10:\"base field\";s:3:\"nid\";s:18:\"relationship field\";s:2:\"id\";s:5:\"extra\";a:1:{i:0;a:4:{s:5:\"table\";s:10:\"file_usage\";s:5:\"field\";s:4:\"type\";s:8:\"operator\";s:1:\"=\";s:5:\"value\";s:4:\"node\";}}}}s:12:\"node_to_file\";a:5:{s:5:\"title\";s:4:\"File\";s:4:\"help\";s:87:\"A file that is associated with this node, usually because it is in a field on the node.\";s:9:\"skip base\";a:5:{i:0;s:12:\"file_managed\";i:1;s:5:\"users\";i:2;s:7:\"comment\";i:3;s:18:\"taxonomy_term_data\";i:4;s:19:\"taxonomy_vocabulary\";}s:10:\"real field\";s:3:\"fid\";s:12:\"relationship\";a:5:{s:5:\"title\";s:4:\"File\";s:5:\"label\";s:4:\"File\";s:4:\"base\";s:12:\"file_managed\";s:10:\"base field\";s:3:\"fid\";s:18:\"relationship field\";s:3:\"fid\";}}s:12:\"file_to_user\";a:5:{s:5:\"title\";s:4:\"User\";s:4:\"help\";s:94:\"A user that is associated with this file, usually because this file is in a field on the user.\";s:9:\"skip base\";a:6:{i:0;s:4:\"node\";i:1;s:13:\"node_revision\";i:2;s:5:\"users\";i:3;s:7:\"comment\";i:4;s:18:\"taxonomy_term_data\";i:5;s:19:\"taxonomy_vocabulary\";}s:10:\"real field\";s:2:\"id\";s:12:\"relationship\";a:6:{s:5:\"title\";s:4:\"User\";s:5:\"label\";s:4:\"User\";s:4:\"base\";s:5:\"users\";s:10:\"base field\";s:3:\"uid\";s:18:\"relationship field\";s:2:\"id\";s:5:\"extra\";a:1:{i:0;a:4:{s:5:\"table\";s:10:\"file_usage\";s:5:\"field\";s:4:\"type\";s:8:\"operator\";s:1:\"=\";s:5:\"value\";s:4:\"user\";}}}}s:12:\"user_to_file\";a:5:{s:5:\"title\";s:4:\"File\";s:4:\"help\";s:87:\"A file that is associated with this user, usually because it is in a field on the user.\";s:9:\"skip base\";a:6:{i:0;s:12:\"file_managed\";i:1;s:4:\"node\";i:2;s:13:\"node_revision\";i:3;s:7:\"comment\";i:4;s:18:\"taxonomy_term_data\";i:5;s:19:\"taxonomy_vocabulary\";}s:10:\"real field\";s:3:\"fid\";s:12:\"relationship\";a:5:{s:5:\"title\";s:4:\"File\";s:5:\"label\";s:4:\"File\";s:4:\"base\";s:12:\"file_managed\";s:10:\"base field\";s:3:\"fid\";s:18:\"relationship field\";s:3:\"fid\";}}s:15:\"file_to_comment\";a:5:{s:5:\"title\";s:7:\"Comment\";s:4:\"help\";s:100:\"A comment that is associated with this file, usually because this file is in a field on the comment.\";s:9:\"skip base\";a:6:{i:0;s:4:\"node\";i:1;s:13:\"node_revision\";i:2;s:5:\"users\";i:3;s:7:\"comment\";i:4;s:18:\"taxonomy_term_data\";i:5;s:19:\"taxonomy_vocabulary\";}s:10:\"real field\";s:2:\"id\";s:12:\"relationship\";a:6:{s:5:\"title\";s:7:\"Comment\";s:5:\"label\";s:7:\"Comment\";s:4:\"base\";s:7:\"comment\";s:10:\"base field\";s:3:\"cid\";s:18:\"relationship field\";s:2:\"id\";s:5:\"extra\";a:1:{i:0;a:4:{s:5:\"table\";s:10:\"file_usage\";s:5:\"field\";s:4:\"type\";s:8:\"operator\";s:1:\"=\";s:5:\"value\";s:7:\"comment\";}}}}s:15:\"comment_to_file\";a:5:{s:5:\"title\";s:4:\"File\";s:4:\"help\";s:93:\"A file that is associated with this comment, usually because it is in a field on the comment.\";s:9:\"skip base\";a:6:{i:0;s:12:\"file_managed\";i:1;s:4:\"node\";i:2;s:13:\"node_revision\";i:3;s:5:\"users\";i:4;s:18:\"taxonomy_term_data\";i:5;s:19:\"taxonomy_vocabulary\";}s:10:\"real field\";s:3:\"fid\";s:12:\"relationship\";a:5:{s:5:\"title\";s:4:\"File\";s:5:\"label\";s:4:\"File\";s:4:\"base\";s:12:\"file_managed\";s:10:\"base field\";s:3:\"fid\";s:18:\"relationship field\";s:3:\"fid\";}}s:21:\"file_to_taxonomy_term\";a:5:{s:5:\"title\";s:13:\"Taxonomy Term\";s:4:\"help\";s:112:\"A taxonomy term that is associated with this file, usually because this file is in a field on the taxonomy term.\";s:9:\"skip base\";a:6:{i:0;s:4:\"node\";i:1;s:13:\"node_revision\";i:2;s:5:\"users\";i:3;s:7:\"comment\";i:4;s:18:\"taxonomy_term_data\";i:5;s:19:\"taxonomy_vocabulary\";}s:10:\"real field\";s:2:\"id\";s:12:\"relationship\";a:6:{s:5:\"title\";s:13:\"Taxonomy Term\";s:5:\"label\";s:13:\"Taxonomy Term\";s:4:\"base\";s:18:\"taxonomy_term_data\";s:10:\"base field\";s:3:\"tid\";s:18:\"relationship field\";s:2:\"id\";s:5:\"extra\";a:1:{i:0;a:4:{s:5:\"table\";s:10:\"file_usage\";s:5:\"field\";s:4:\"type\";s:8:\"operator\";s:1:\"=\";s:5:\"value\";s:13:\"taxonomy_term\";}}}}s:21:\"taxonomy_term_to_file\";a:5:{s:5:\"title\";s:4:\"File\";s:4:\"help\";s:105:\"A file that is associated with this taxonomy term, usually because it is in a field on the taxonomy term.\";s:9:\"skip base\";a:6:{i:0;s:12:\"file_managed\";i:1;s:4:\"node\";i:2;s:13:\"node_revision\";i:3;s:5:\"users\";i:4;s:7:\"comment\";i:5;s:19:\"taxonomy_vocabulary\";}s:10:\"real field\";s:3:\"fid\";s:12:\"relationship\";a:5:{s:5:\"title\";s:4:\"File\";s:5:\"label\";s:4:\"File\";s:4:\"base\";s:12:\"file_managed\";s:10:\"base field\";s:3:\"fid\";s:18:\"relationship field\";s:3:\"fid\";}}s:27:\"file_to_taxonomy_vocabulary\";a:5:{s:5:\"title\";s:19:\"Taxonomy Vocabulary\";s:4:\"help\";s:124:\"A taxonomy vocabulary that is associated with this file, usually because this file is in a field on the taxonomy vocabulary.\";s:9:\"skip base\";a:6:{i:0;s:4:\"node\";i:1;s:13:\"node_revision\";i:2;s:5:\"users\";i:3;s:7:\"comment\";i:4;s:18:\"taxonomy_term_data\";i:5;s:19:\"taxonomy_vocabulary\";}s:10:\"real field\";s:2:\"id\";s:12:\"relationship\";a:6:{s:5:\"title\";s:19:\"Taxonomy Vocabulary\";s:5:\"label\";s:19:\"Taxonomy Vocabulary\";s:4:\"base\";s:19:\"taxonomy_vocabulary\";s:10:\"base field\";s:3:\"vid\";s:18:\"relationship field\";s:2:\"id\";s:5:\"extra\";a:1:{i:0;a:4:{s:5:\"table\";s:10:\"file_usage\";s:5:\"field\";s:4:\"type\";s:8:\"operator\";s:1:\"=\";s:5:\"value\";s:19:\"taxonomy_vocabulary\";}}}}s:27:\"taxonomy_vocabulary_to_file\";a:5:{s:5:\"title\";s:4:\"File\";s:4:\"help\";s:117:\"A file that is associated with this taxonomy vocabulary, usually because it is in a field on the taxonomy vocabulary.\";s:9:\"skip base\";a:6:{i:0;s:12:\"file_managed\";i:1;s:4:\"node\";i:2;s:13:\"node_revision\";i:3;s:5:\"users\";i:4;s:7:\"comment\";i:5;s:18:\"taxonomy_term_data\";}s:10:\"real field\";s:3:\"fid\";s:12:\"relationship\";a:5:{s:5:\"title\";s:4:\"File\";s:5:\"label\";s:4:\"File\";s:4:\"base\";s:12:\"file_managed\";s:10:\"base field\";s:3:\"fid\";s:18:\"relationship field\";s:3:\"fid\";}}s:6:\"module\";a:6:{s:5:\"title\";s:6:\"Module\";s:4:\"help\";s:43:\"The module managing this file relationship.\";s:5:\"field\";a:2:{s:7:\"handler\";s:19:\"views_handler_field\";s:14:\"click sortable\";b:1;}s:6:\"filter\";a:1:{s:7:\"handler\";s:27:\"views_handler_filter_string\";}s:8:\"argument\";a:1:{s:7:\"handler\";s:29:\"views_handler_argument_string\";}s:4:\"sort\";a:1:{s:7:\"handler\";s:18:\"views_handler_sort\";}}s:4:\"type\";a:6:{s:5:\"title\";s:11:\"Entity type\";s:4:\"help\";s:47:\"The type of entity that is related to the file.\";s:5:\"field\";a:2:{s:7:\"handler\";s:19:\"views_handler_field\";s:14:\"click sortable\";b:1;}s:6:\"filter\";a:1:{s:7:\"handler\";s:27:\"views_handler_filter_string\";}s:8:\"argument\";a:1:{s:7:\"handler\";s:29:\"views_handler_argument_string\";}s:4:\"sort\";a:1:{s:7:\"handler\";s:18:\"views_handler_sort\";}}s:2:\"id\";a:6:{s:5:\"title\";s:9:\"Entity ID\";s:4:\"help\";s:49:\"The ID of the entity that is related to the file.\";s:5:\"field\";a:2:{s:7:\"handler\";s:27:\"views_handler_field_numeric\";s:14:\"click sortable\";b:1;}s:8:\"argument\";a:1:{s:7:\"handler\";s:30:\"views_handler_argument_numeric\";}s:6:\"filter\";a:1:{s:7:\"handler\";s:28:\"views_handler_filter_numeric\";}s:4:\"sort\";a:1:{s:7:\"handler\";s:18:\"views_handler_sort\";}}s:5:\"count\";a:5:{s:5:\"title\";s:9:\"Use count\";s:4:\"help\";s:52:\"The number of times the file is used by this entity.\";s:5:\"field\";a:2:{s:7:\"handler\";s:27:\"views_handler_field_numeric\";s:14:\"click sortable\";b:1;}s:6:\"filter\";a:1:{s:7:\"handler\";s:28:\"views_handler_filter_numeric\";}s:4:\"sort\";a:1:{s:7:\"handler\";s:18:\"views_handler_sort\";}}}s:6:\"system\";a:6:{s:5:\"table\";a:2:{s:5:\"group\";s:6:\"System\";s:4:\"base\";a:3:{s:5:\"field\";s:8:\"filename\";s:5:\"title\";s:25:\"Module/Theme/Theme engine\";s:4:\"help\";s:46:\"Modules/Themes/Theme engines in your codebase.\";}}s:8:\"filename\";a:6:{s:5:\"title\";s:34:\"Module/Theme/Theme engine filename\";s:4:\"help\";s:103:\"The path of the primary file for this item, relative to the Drupal root; e.g. modules/node/node.module.\";s:5:\"field\";a:2:{s:7:\"handler\";s:19:\"views_handler_field\";s:14:\"click sortable\";b:1;}s:8:\"argument\";a:2:{s:7:\"handler\";s:29:\"views_handler_argument_string\";s:10:\"name field\";s:8:\"filename\";}s:6:\"filter\";a:1:{s:7:\"handler\";s:27:\"views_handler_filter_string\";}s:4:\"sort\";a:1:{s:7:\"handler\";s:18:\"views_handler_sort\";}}s:4:\"name\";a:6:{s:5:\"title\";s:30:\"Module/Theme/Theme engine name\";s:4:\"help\";s:32:\"The name of the item; e.g. node.\";s:5:\"field\";a:2:{s:7:\"handler\";s:19:\"views_handler_field\";s:14:\"click sortable\";b:1;}s:8:\"argument\";a:2:{s:7:\"handler\";s:29:\"views_handler_argument_string\";s:10:\"name field\";s:4:\"name\";}s:6:\"filter\";a:1:{s:7:\"handler\";s:27:\"views_handler_filter_string\";}s:4:\"sort\";a:1:{s:7:\"handler\";s:18:\"views_handler_sort\";}}s:4:\"type\";a:6:{s:5:\"title\";s:4:\"Type\";s:4:\"help\";s:60:\"The type of the item, either module, theme, or theme_engine.\";s:5:\"field\";a:2:{s:7:\"handler\";s:19:\"views_handler_field\";s:14:\"click sortable\";b:1;}s:8:\"argument\";a:2:{s:7:\"handler\";s:29:\"views_handler_argument_string\";s:10:\"name field\";s:4:\"type\";}s:6:\"filter\";a:1:{s:7:\"handler\";s:32:\"views_handler_filter_system_type\";}s:4:\"sort\";a:1:{s:7:\"handler\";s:18:\"views_handler_sort\";}}s:6:\"status\";a:6:{s:5:\"title\";s:6:\"Status\";s:4:\"help\";s:55:\"Boolean indicating whether or not this item is enabled.\";s:5:\"field\";a:2:{s:7:\"handler\";s:27:\"views_handler_field_boolean\";s:14:\"click sortable\";b:1;}s:8:\"argument\";a:2:{s:7:\"handler\";s:30:\"views_handler_argument_numeric\";s:10:\"name field\";s:6:\"status\";}s:6:\"filter\";a:1:{s:7:\"handler\";s:37:\"views_handler_filter_boolean_operator\";}s:4:\"sort\";a:1:{s:7:\"handler\";s:18:\"views_handler_sort\";}}s:14:\"schema_version\";a:6:{s:5:\"title\";s:14:\"Schema version\";s:4:\"help\";s:238:\"The module\'s database schema version number. -1 if the module is not installed (its tables do not exist); 0 or the largest N of the module\'s hook_update_N() function that has either been run or existed when the module was first installed.\";s:5:\"field\";a:2:{s:7:\"handler\";s:27:\"views_handler_field_numeric\";s:14:\"click sortable\";b:1;}s:8:\"argument\";a:2:{s:7:\"handler\";s:30:\"views_handler_argument_numeric\";s:10:\"name field\";s:14:\"schema_version\";}s:6:\"filter\";a:1:{s:7:\"handler\";s:28:\"views_handler_filter_numeric\";}s:4:\"sort\";a:1:{s:7:\"handler\";s:18:\"views_handler_sort\";}}}s:10:\"vocabulary\";a:1:{s:8:\"moved to\";s:19:\"taxonomy_vocabulary\";}s:9:\"term_data\";a:1:{s:8:\"moved to\";s:18:\"taxonomy_term_data\";}s:9:\"term_node\";a:1:{s:8:\"moved to\";s:14:\"taxonomy_index\";}s:14:\"taxonomy_index\";a:3:{s:5:\"table\";a:2:{s:5:\"group\";s:13:\"Taxonomy term\";s:4:\"join\";a:3:{s:18:\"taxonomy_term_data\";a:2:{s:10:\"left_field\";s:3:\"tid\";s:5:\"field\";s:3:\"tid\";}s:4:\"node\";a:2:{s:10:\"left_field\";s:3:\"nid\";s:5:\"field\";s:3:\"nid\";}s:23:\"taxonomy_term_hierarchy\";a:2:{s:10:\"left_field\";s:3:\"tid\";s:5:\"field\";s:3:\"tid\";}}}s:3:\"nid\";a:3:{s:5:\"title\";s:17:\"Content with term\";s:4:\"help\";s:38:\"Relate all content tagged with a term.\";s:12:\"relationship\";a:5:{s:7:\"handler\";s:26:\"views_handler_relationship\";s:4:\"base\";s:4:\"node\";s:10:\"base field\";s:3:\"nid\";s:5:\"label\";s:4:\"node\";s:9:\"skip base\";s:4:\"node\";}}s:3:\"tid\";a:5:{s:5:\"group\";s:7:\"Content\";s:5:\"title\";s:20:\"Has taxonomy term ID\";s:4:\"help\";s:54:\"Display content if it has the selected taxonomy terms.\";s:8:\"argument\";a:6:{s:7:\"handler\";s:36:\"views_handler_argument_term_node_tid\";s:10:\"name table\";s:18:\"taxonomy_term_data\";s:10:\"name field\";s:4:\"name\";s:16:\"empty field name\";s:13:\"Uncategorized\";s:7:\"numeric\";b:1;s:9:\"skip base\";s:18:\"taxonomy_term_data\";}s:6:\"filter\";a:6:{s:5:\"title\";s:17:\"Has taxonomy term\";s:7:\"handler\";s:34:\"views_handler_filter_term_node_tid\";s:15:\"hierarchy table\";s:23:\"taxonomy_term_hierarchy\";s:7:\"numeric\";b:1;s:9:\"skip base\";s:18:\"taxonomy_term_data\";s:11:\"allow empty\";b:1;}}}s:23:\"taxonomy_term_hierarchy\";a:2:{s:5:\"table\";a:3:{s:5:\"group\";s:13:\"Taxonomy term\";s:4:\"join\";a:2:{s:23:\"taxonomy_term_hierarchy\";a:2:{s:10:\"left_field\";s:3:\"tid\";s:5:\"field\";s:6:\"parent\";}s:18:\"taxonomy_term_data\";a:2:{s:10:\"left_field\";s:3:\"tid\";s:5:\"field\";s:3:\"tid\";}}s:20:\"default_relationship\";a:1:{s:4:\"node\";a:2:{s:5:\"table\";s:4:\"node\";s:5:\"field\";s:13:\"term_node_tid\";}}}s:6:\"parent\";a:5:{s:5:\"title\";s:11:\"Parent term\";s:4:\"help\";s:123:\"The parent term of the term. This can produce duplicate entries if you are using a vocabulary that allows multiple parents.\";s:12:\"relationship\";a:3:{s:4:\"base\";s:18:\"taxonomy_term_data\";s:5:\"field\";s:6:\"parent\";s:5:\"label\";s:6:\"Parent\";}s:6:\"filter\";a:2:{s:4:\"help\";s:57:\"Filter the results of \"Taxonomy: Term\" by the parent pid.\";s:7:\"handler\";s:28:\"views_handler_filter_numeric\";}s:8:\"argument\";a:2:{s:4:\"help\";s:28:\"The parent term of the term.\";s:7:\"handler\";s:31:\"views_handler_argument_taxonomy\";}}}s:14:\"term_hierarchy\";a:1:{s:8:\"moved to\";s:23:\"taxonomy_term_hierarchy\";}s:11:\"users_roles\";a:2:{s:5:\"table\";a:3:{s:5:\"group\";s:4:\"User\";s:4:\"join\";a:1:{s:5:\"users\";a:2:{s:10:\"left_field\";s:3:\"uid\";s:5:\"field\";s:3:\"uid\";}}s:20:\"default_relationship\";a:2:{s:4:\"node\";a:2:{s:5:\"table\";s:4:\"node\";s:5:\"field\";s:3:\"uid\";}s:13:\"node_revision\";a:2:{s:5:\"table\";s:13:\"node_revision\";s:5:\"field\";s:3:\"uid\";}}}s:3:\"rid\";a:5:{s:5:\"title\";s:5:\"Roles\";s:4:\"help\";s:29:\"Roles that a user belongs to.\";s:5:\"field\";a:2:{s:7:\"handler\";s:30:\"views_handler_field_user_roles\";s:11:\"no group by\";b:1;}s:6:\"filter\";a:3:{s:7:\"handler\";s:31:\"views_handler_filter_user_roles\";s:7:\"numeric\";b:1;s:11:\"allow empty\";b:1;}s:8:\"argument\";a:6:{s:7:\"handler\";s:38:\"views_handler_argument_users_roles_rid\";s:10:\"name table\";s:4:\"role\";s:10:\"name field\";s:4:\"name\";s:16:\"empty field name\";s:7:\"No role\";s:12:\"zero is null\";b:1;s:7:\"numeric\";b:1;}}}s:4:\"role\";a:1:{s:5:\"table\";a:2:{s:4:\"join\";a:2:{s:5:\"users\";a:3:{s:10:\"left_table\";s:11:\"users_roles\";s:10:\"left_field\";s:3:\"rid\";s:5:\"field\";s:3:\"rid\";}s:11:\"users_roles\";a:2:{s:10:\"left_field\";s:3:\"rid\";s:5:\"field\";s:3:\"rid\";}}s:20:\"default_relationship\";a:2:{s:4:\"node\";a:2:{s:5:\"table\";s:4:\"node\";s:5:\"field\";s:3:\"uid\";}s:13:\"node_revision\";a:2:{s:5:\"table\";s:13:\"node_revision\";s:5:\"field\";s:3:\"uid\";}}}}s:15:\"role_permission\";a:2:{s:5:\"table\";a:2:{s:5:\"group\";s:4:\"User\";s:4:\"join\";a:1:{s:5:\"users\";a:3:{s:10:\"left_table\";s:11:\"users_roles\";s:10:\"left_field\";s:3:\"rid\";s:5:\"field\";s:3:\"rid\";}}}s:10:\"permission\";a:4:{s:5:\"title\";s:10:\"Permission\";s:4:\"help\";s:21:\"The user permissions.\";s:5:\"field\";a:2:{s:7:\"handler\";s:36:\"views_handler_field_user_permissions\";s:11:\"no group by\";b:1;}s:6:\"filter\";a:1:{s:7:\"handler\";s:37:\"views_handler_filter_user_permissions\";}}}s:7:\"authmap\";a:4:{s:5:\"table\";a:3:{s:5:\"group\";s:4:\"User\";s:4:\"join\";a:1:{s:5:\"users\";a:2:{s:10:\"left_field\";s:3:\"uid\";s:5:\"field\";s:3:\"uid\";}}s:20:\"default_relationship\";a:2:{s:4:\"node\";a:2:{s:5:\"table\";s:4:\"node\";s:5:\"field\";s:3:\"uid\";}s:13:\"node_revision\";a:2:{s:5:\"table\";s:13:\"node_revision\";s:5:\"field\";s:3:\"uid\";}}}s:3:\"aid\";a:5:{s:5:\"title\";s:10:\"Authmap ID\";s:4:\"help\";s:15:\"The Authmap ID.\";s:5:\"field\";a:1:{s:7:\"handler\";s:27:\"views_handler_field_numeric\";}s:6:\"filter\";a:2:{s:7:\"handler\";s:28:\"views_handler_filter_numeric\";s:7:\"numeric\";b:1;}s:8:\"argument\";a:2:{s:7:\"handler\";s:30:\"views_handler_argument_numeric\";s:7:\"numeric\";b:1;}}s:8:\"authname\";a:5:{s:5:\"title\";s:19:\"Authentication name\";s:4:\"help\";s:31:\"The unique authentication name.\";s:5:\"field\";a:1:{s:7:\"handler\";s:19:\"views_handler_field\";}s:6:\"filter\";a:1:{s:7:\"handler\";s:27:\"views_handler_filter_string\";}s:8:\"argument\";a:1:{s:7:\"handler\";s:29:\"views_handler_argument_string\";}}s:6:\"module\";a:5:{s:5:\"title\";s:21:\"Authentication module\";s:4:\"help\";s:57:\"The name of the module managing the authentication entry.\";s:5:\"field\";a:1:{s:7:\"handler\";s:19:\"views_handler_field\";}s:6:\"filter\";a:1:{s:7:\"handler\";s:27:\"views_handler_filter_string\";}s:8:\"argument\";a:1:{s:7:\"handler\";s:29:\"views_handler_argument_string\";}}}s:5:\"views\";a:17:{s:8:\"fieldset\";a:3:{s:5:\"title\";s:8:\"Fieldset\";s:4:\"help\";s:53:\"Adds a fieldset to put fields and other fieldsets in.\";s:5:\"field\";a:1:{s:7:\"handler\";s:38:\"views_fieldsets_fieldset_field_handler\";}}s:5:\"table\";a:2:{s:5:\"group\";s:6:\"Global\";s:4:\"join\";a:1:{s:7:\"#global\";a:0:{}}}s:6:\"random\";a:3:{s:5:\"title\";s:6:\"Random\";s:4:\"help\";s:28:\"Randomize the display order.\";s:4:\"sort\";a:1:{s:7:\"handler\";s:25:\"views_handler_sort_random\";}}s:4:\"null\";a:3:{s:5:\"title\";s:4:\"Null\";s:4:\"help\";s:213:\"Allow a contextual filter value to be ignored. The query will not be altered by this contextual filter value. Can be used when contextual filter values come from the URL, and a part of the URL needs to be ignored.\";s:8:\"argument\";a:1:{s:7:\"handler\";s:27:\"views_handler_argument_null\";}}s:7:\"nothing\";a:3:{s:5:\"title\";s:11:\"Custom text\";s:4:\"help\";s:28:\"Provide custom text or link.\";s:5:\"field\";a:1:{s:7:\"handler\";s:26:\"views_handler_field_custom\";}}s:7:\"counter\";a:3:{s:5:\"title\";s:19:\"View result counter\";s:4:\"help\";s:47:\"Displays the actual position of the view result\";s:5:\"field\";a:1:{s:7:\"handler\";s:27:\"views_handler_field_counter\";}}s:4:\"area\";a:3:{s:5:\"title\";s:9:\"Text area\";s:4:\"help\";s:33:\"Provide markup text for the area.\";s:4:\"area\";a:1:{s:7:\"handler\";s:23:\"views_handler_area_text\";}}s:16:\"area_text_custom\";a:3:{s:5:\"title\";s:15:\"Unfiltered text\";s:4:\"help\";s:82:\"Add unrestricted, custom text or markup. This is similar to the custom text field.\";s:4:\"area\";a:1:{s:7:\"handler\";s:30:\"views_handler_area_text_custom\";}}s:4:\"view\";a:3:{s:5:\"title\";s:9:\"View area\";s:4:\"help\";s:29:\"Insert a view inside an area.\";s:4:\"area\";a:1:{s:7:\"handler\";s:23:\"views_handler_area_view\";}}s:6:\"result\";a:3:{s:5:\"title\";s:14:\"Result summary\";s:4:\"help\";s:53:\"Shows result summary, for example the items per page.\";s:4:\"area\";a:1:{s:7:\"handler\";s:25:\"views_handler_area_result\";}}s:8:\"messages\";a:3:{s:5:\"title\";s:8:\"Messages\";s:4:\"help\";s:30:\"Displays messages in the area.\";s:4:\"area\";a:1:{s:7:\"handler\";s:27:\"views_handler_area_messages\";}}s:16:\"contextual_links\";a:3:{s:5:\"title\";s:16:\"Contextual Links\";s:4:\"help\";s:42:\"Display fields in a contextual links menu.\";s:5:\"field\";a:1:{s:7:\"handler\";s:36:\"views_handler_field_contextual_links\";}}s:15:\"ctools_dropdown\";a:3:{s:5:\"title\";s:14:\"Dropdown links\";s:4:\"help\";s:67:\"Displays fields in a dropdown list, like on the views listing page.\";s:5:\"field\";a:1:{s:7:\"handler\";s:35:\"views_handler_field_ctools_dropdown\";}}s:7:\"combine\";a:3:{s:5:\"title\";s:21:\"Combine fields filter\";s:4:\"help\";s:52:\"Combine multiple fields together and search by them.\";s:6:\"filter\";a:1:{s:7:\"handler\";s:28:\"views_handler_filter_combine\";}}s:10:\"expression\";a:3:{s:5:\"title\";s:15:\"Math expression\";s:4:\"help\";s:52:\"Evaluates a mathematical expression and displays it.\";s:5:\"field\";a:2:{s:7:\"handler\";s:24:\"views_handler_field_math\";s:5:\"float\";b:1;}}s:14:\"fields_compare\";a:3:{s:5:\"title\";s:17:\"Fields comparison\";s:4:\"help\";s:42:\"Compare database fields against eachother.\";s:6:\"filter\";a:2:{s:4:\"help\";s:55:\"Use fields comparison to filter the result of the view.\";s:7:\"handler\";s:35:\"views_handler_filter_fields_compare\";}}s:14:\"webform_result\";a:3:{s:5:\"title\";s:64:\"Result summary with an additional token to change the items/page\";s:4:\"help\";s:94:\"Shows result summary, for example the items per page, plus links to change the items per page.\";s:4:\"area\";a:1:{s:7:\"handler\";s:33:\"webform_handler_area_result_pager\";}}}s:14:\"votingapi_vote\";a:8:{s:5:\"table\";a:1:{s:5:\"group\";s:5:\"Votes\";}s:5:\"value\";a:5:{s:5:\"title\";s:5:\"Value\";s:4:\"help\";s:37:\"The value of an individual cast vote.\";s:5:\"field\";a:2:{s:7:\"handler\";s:35:\"votingapi_views_handler_field_value\";s:14:\"click sortable\";b:1;}s:6:\"filter\";a:2:{s:7:\"handler\";s:28:\"views_handler_filter_numeric\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:1:{s:7:\"handler\";s:37:\"votingapi_views_handler_sort_nullable\";}}s:10:\"value_type\";a:5:{s:5:\"title\";s:10:\"Value type\";s:4:\"help\";s:60:\"The nature of the vote being cast (points, percentage, etc).\";s:5:\"field\";a:2:{s:7:\"handler\";s:19:\"views_handler_field\";s:14:\"click sortable\";b:1;}s:6:\"filter\";a:1:{s:7:\"handler\";s:27:\"views_handler_filter_string\";}s:4:\"sort\";a:1:{s:7:\"handler\";s:18:\"views_handler_sort\";}}s:3:\"tag\";a:5:{s:5:\"title\";s:3:\"Tag\";s:4:\"help\";s:46:\"An optional tag to group multi-criteria votes.\";s:5:\"field\";a:2:{s:7:\"handler\";s:19:\"views_handler_field\";s:14:\"click sortable\";b:1;}s:6:\"filter\";a:1:{s:7:\"handler\";s:27:\"views_handler_filter_string\";}s:4:\"sort\";a:1:{s:7:\"handler\";s:18:\"views_handler_sort\";}}s:3:\"uid\";a:7:{s:5:\"title\";s:4:\"User\";s:4:\"help\";s:27:\"The user who cast the vote.\";s:5:\"field\";a:2:{s:7:\"handler\";s:24:\"views_handler_field_user\";s:14:\"click sortable\";b:1;}s:6:\"filter\";a:1:{s:7:\"handler\";s:30:\"views_handler_filter_user_name\";}s:4:\"sort\";a:1:{s:7:\"handler\";s:18:\"views_handler_sort\";}s:8:\"argument\";a:1:{s:7:\"handler\";s:31:\"views_handler_argument_user_uid\";}s:12:\"relationship\";a:4:{s:7:\"handler\";s:26:\"views_handler_relationship\";s:4:\"base\";s:5:\"users\";s:5:\"field\";s:3:\"uid\";s:5:\"label\";s:16:\"Individual voter\";}}s:11:\"current_uid\";a:4:{s:5:\"title\";s:12:\"Current user\";s:4:\"help\";s:49:\"Restrict votes to those cast by the current user.\";s:10:\"real field\";s:3:\"uid\";s:6:\"filter\";a:1:{s:7:\"handler\";s:33:\"views_handler_filter_user_current\";}}s:11:\"vote_source\";a:5:{s:5:\"title\";s:10:\"IP Address\";s:4:\"help\";s:45:\"The IP address of the user who cast the vote.\";s:5:\"field\";a:2:{s:7:\"handler\";s:19:\"views_handler_field\";s:14:\"click sortable\";b:1;}s:6:\"filter\";a:1:{s:7:\"handler\";s:27:\"views_handler_filter_string\";}s:4:\"sort\";a:1:{s:7:\"handler\";s:18:\"views_handler_sort\";}}s:9:\"timestamp\";a:5:{s:5:\"title\";s:9:\"Timestamp\";s:4:\"help\";s:27:\"The time the vote was cast.\";s:5:\"field\";a:3:{s:7:\"handler\";s:24:\"views_handler_field_date\";s:14:\"click sortable\";b:1;s:7:\"is date\";b:1;}s:6:\"filter\";a:2:{s:7:\"handler\";s:25:\"views_handler_filter_date\";s:7:\"is date\";b:1;}s:4:\"sort\";a:1:{s:7:\"handler\";s:18:\"views_handler_sort\";}}}s:15:\"votingapi_cache\";a:6:{s:5:\"table\";a:1:{s:5:\"group\";s:12:\"Vote results\";}s:5:\"value\";a:5:{s:5:\"title\";s:5:\"Value\";s:4:\"help\";s:37:\"The value of an individual cast vote.\";s:5:\"field\";a:2:{s:7:\"handler\";s:35:\"votingapi_views_handler_field_value\";s:14:\"click sortable\";b:1;}s:6:\"filter\";a:2:{s:7:\"handler\";s:28:\"views_handler_filter_numeric\";s:11:\"allow empty\";b:1;}s:4:\"sort\";a:1:{s:7:\"handler\";s:37:\"votingapi_views_handler_sort_nullable\";}}s:10:\"value_type\";a:5:{s:5:\"title\";s:10:\"Value type\";s:4:\"help\";s:64:\"The nature of the results in question (points, percentage, etc).\";s:5:\"field\";a:2:{s:7:\"handler\";s:19:\"views_handler_field\";s:14:\"click sortable\";b:1;}s:6:\"filter\";a:1:{s:7:\"handler\";s:27:\"views_handler_filter_string\";}s:4:\"sort\";a:1:{s:7:\"handler\";s:18:\"views_handler_sort\";}}s:3:\"tag\";a:5:{s:5:\"title\";s:3:\"Tag\";s:4:\"help\";s:48:\"An optional tag to group multi-criteria results.\";s:5:\"field\";a:2:{s:7:\"handler\";s:19:\"views_handler_field\";s:14:\"click sortable\";b:1;}s:6:\"filter\";a:1:{s:7:\"handler\";s:27:\"views_handler_filter_string\";}s:4:\"sort\";a:1:{s:7:\"handler\";s:18:\"views_handler_sort\";}}s:8:\"function\";a:5:{s:5:\"title\";s:8:\"Function\";s:4:\"help\";s:52:\"The aggregate function used to calculate the result.\";s:5:\"field\";a:2:{s:7:\"handler\";s:19:\"views_handler_field\";s:14:\"click sortable\";b:1;}s:6:\"filter\";a:1:{s:7:\"handler\";s:27:\"views_handler_filter_string\";}s:4:\"sort\";a:1:{s:7:\"handler\";s:18:\"views_handler_sort\";}}s:9:\"timestamp\";a:5:{s:5:\"title\";s:9:\"Timestamp\";s:4:\"help\";s:37:\"The time the results were calculated.\";s:5:\"field\";a:3:{s:7:\"handler\";s:24:\"views_handler_field_date\";s:14:\"click sortable\";b:1;s:7:\"is date\";b:1;}s:6:\"filter\";a:2:{s:7:\"handler\";s:25:\"views_handler_filter_date\";s:7:\"is date\";b:1;}s:4:\"sort\";a:1:{s:7:\"handler\";s:18:\"views_handler_sort\";}}}s:5:\"forum\";a:1:{s:5:\"table\";a:1:{s:4:\"join\";a:2:{s:14:\"node_revisions\";a:2:{s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:3:\"vid\";}s:4:\"node\";a:2:{s:10:\"left_field\";s:3:\"vid\";s:5:\"field\";s:3:\"vid\";}}}}}',0,1512620340,1),('views_data:node:en','a:53:{s:13:\"date_argument\";a:4:{s:5:\"group\";s:4:\"Date\";s:5:\"title\";s:11:\"Date (node)\";s:4:\"help\";s:165:\"Filter any Views node date field by a date argument, using any common ISO date/period format (i.e. YYYY, YYYY-MM, YYYY-MM-DD, YYYY-W99, YYYY-MM-DD--P3M, P90D, etc). \";s:8:\"argument\";a:3:{s:7:\"handler\";s:27:\"date_views_argument_handler\";s:16:\"empty field name\";s:7:\"Undated\";s:7:\"is date\";b:1;}}s:11:\"date_filter\";a:4:{s:5:\"group\";s:4:\"Date\";s:5:\"title\";s:11:\"Date (node)\";s:4:\"help\";s:33:\"Filter any Views node date field.\";s:6:\"filter\";a:3:{s:7:\"handler\";s:25:\"date_views_filter_handler\";s:16:\"empty field name\";s:7:\"Undated\";s:7:\"is date\";b:1;}}s:5:\"table\";a:5:{s:5:\"group\";s:7:\"Content\";s:4:\"base\";a:5:{s:5:\"field\";s:3:\"nid\";s:5:\"title\";s:7:\"Content\";s:6:\"weight\";i:-10;s:16:\"access query tag\";s:11:\"node_access\";s:8:\"defaults\";a:1:{s:5:\"field\";s:5:\"title\";}}s:11:\"entity type\";s:4:\"node\";s:20:\"default_relationship\";a:1:{s:13:\"node_revision\";a:2:{s:5:\"table\";s:13:\"node_revision\";s:5:\"field\";s:3:\"vid\";}}s:4:\"join\";a:1:{s:19:\"webform_submissions\";a:3:{s:5:\"field\";s:3:\"nid\";s:10:\"left_field\";s:3:\"nid\";s:10:\"left_table\";s:19:\"webform_submissions\";}}}s:3:\"nid\";a:6:{s:5:\"title\";s:3:\"Nid\";s:4:\"help\";s:12:\"The node ID.\";s:5:\"field\";a:2:{s:7:\"handler\";s:24:\"views_handler_field_node\";s:14:\"click sortable\";b:1;}s:8:\"argument\";a:4:{s:7:\"handler\";s:31:\"views_handler_argument_node_nid\";s:10:\"name field\";s:5:\"title\";s:7:\"numeric\";b:1;s:13:\"validate type\";s:3:\"nid\";}s:6:\"filter\";a:1:{s:7:\"handler\";s:28:\"views_handler_filter_numeric\";}s:4:\"sort\";a:1:{s:7:\"handler\";s:18:\"views_handler_sort\";}}s:5:\"title\";a:6:{s:5:\"title\";s:5:\"Title\";s:4:\"help\";s:18:\"The content title.\";s:5:\"field\";a:5:{s:5:\"field\";s:5:\"title\";s:5:\"group\";s:7:\"Content\";s:7:\"handler\";s:24:\"views_handler_field_node\";s:14:\"click sortable\";b:1;s:20:\"link_to_node default\";b:1;}s:4:\"sort\";a:1:{s:7:\"handler\";s:18:\"views_handler_sort\";}s:6:\"filter\";a:1:{s:7:\"handler\";s:27:\"views_handler_filter_string\";}s:8:\"argument\";a:1:{s:7:\"handler\";s:29:\"views_handler_argument_string\";}}s:7:\"created\";a:5:{s:5:\"title\";s:9:\"Post date\";s:4:\"help\";s:32:\"The date the content was posted.\";s:5:\"field\";a:3:{s:7:\"handler\";s:24:\"views_handler_field_date\";s:14:\"click sortable\";b:1;s:7:\"is date\";b:1;}s:4:\"sort\";a:2:{s:7:\"handler\";s:23:\"views_handler_sort_date\";s:7:\"is date\";b:1;}s:6:\"filter\";a:2:{s:7:\"handler\";s:25:\"views_handler_filter_date\";s:7:\"is date\";b:1;}}s:7:\"changed\";a:5:{s:5:\"title\";s:12:\"Updated date\";s:4:\"help\";s:38:\"The date the content was last updated.\";s:5:\"field\";a:3:{s:7:\"handler\";s:24:\"views_handler_field_date\";s:14:\"click sortable\";b:1;s:7:\"is date\";b:1;}s:4:\"sort\";a:2:{s:7:\"handler\";s:23:\"views_handler_sort_date\";s:7:\"is date\";b:1;}s:6:\"filter\";a:2:{s:7:\"handler\";s:25:\"views_handler_filter_date\";s:7:\"is date\";b:1;}}s:4:\"type\";a:6:{s:5:\"title\";s:4:\"Type\";s:4:\"help\";s:73:\"The content type (for example, \"blog entry\", \"forum post\", \"story\", etc).\";s:5:\"field\";a:2:{s:7:\"handler\";s:29:\"views_handler_field_node_type\";s:14:\"click sortable\";b:1;}s:4:\"sort\";a:1:{s:7:\"handler\";s:18:\"views_handler_sort\";}s:6:\"filter\";a:1:{s:7:\"handler\";s:30:\"views_handler_filter_node_type\";}s:8:\"argument\";a:1:{s:7:\"handler\";s:32:\"views_handler_argument_node_type\";}}s:6:\"status\";a:5:{s:5:\"title\";s:9:\"Published\";s:4:\"help\";s:40:\"Whether or not the content is published.\";s:5:\"field\";a:3:{s:7:\"handler\";s:27:\"views_handler_field_boolean\";s:14:\"click sortable\";b:1;s:14:\"output formats\";a:1:{s:22:\"published-notpublished\";a:2:{i:0;s:9:\"Published\";i:1;s:13:\"Not published\";}}}s:6:\"filter\";a:4:{s:7:\"handler\";s:37:\"views_handler_filter_boolean_operator\";s:5:\"label\";s:9:\"Published\";s:4:\"type\";s:6:\"yes-no\";s:9:\"use equal\";b:1;}s:4:\"sort\";a:1:{s:7:\"handler\";s:18:\"views_handler_sort\";}}s:12:\"status_extra\";a:3:{s:5:\"title\";s:18:\"Published or admin\";s:4:\"help\";s:67:\"Filters out unpublished content if the current user cannot view it.\";s:6:\"filter\";a:3:{s:5:\"field\";s:6:\"status\";s:7:\"handler\";s:32:\"views_handler_filter_node_status\";s:5:\"label\";s:18:\"Published or admin\";}}s:7:\"promote\";a:5:{s:5:\"title\";s:22:\"Promoted to front page\";s:4:\"help\";s:57:\"Whether or not the content is promoted to the front page.\";s:5:\"field\";a:3:{s:7:\"handler\";s:27:\"views_handler_field_boolean\";s:14:\"click sortable\";b:1;s:14:\"output formats\";a:1:{s:20:\"promoted-notpromoted\";a:2:{i:0;s:8:\"Promoted\";i:1;s:12:\"Not promoted\";}}}s:6:\"filter\";a:3:{s:7:\"handler\";s:37:\"views_handler_filter_boolean_operator\";s:5:\"label\";s:22:\"Promoted to front page\";s:4:\"type\";s:6:\"yes-no\";}s:4:\"sort\";a:1:{s:7:\"handler\";s:18:\"views_handler_sort\";}}s:6:\"sticky\";a:5:{s:5:\"title\";s:6:\"Sticky\";s:4:\"help\";s:37:\"Whether or not the content is sticky.\";s:5:\"field\";a:3:{s:7:\"handler\";s:27:\"views_handler_field_boolean\";s:14:\"click sortable\";b:1;s:14:\"output formats\";a:1:{s:6:\"sticky\";a:2:{i:0;s:6:\"Sticky\";i:1;s:10:\"Not sticky\";}}}s:6:\"filter\";a:3:{s:7:\"handler\";s:37:\"views_handler_filter_boolean_operator\";s:5:\"label\";s:6:\"Sticky\";s:4:\"type\";s:6:\"yes-no\";}s:4:\"sort\";a:2:{s:7:\"handler\";s:18:\"views_handler_sort\";s:4:\"help\";s:91:\"Whether or not the content is sticky. To list sticky content first, set this to descending.\";}}s:9:\"view_node\";a:1:{s:8:\"moved to\";a:2:{i:0;s:17:\"views_entity_node\";i:1;s:9:\"view_node\";}}s:9:\"edit_node\";a:1:{s:8:\"moved to\";a:2:{i:0;s:17:\"views_entity_node\";i:1;s:9:\"edit_node\";}}s:11:\"delete_node\";a:1:{s:8:\"moved to\";a:2:{i:0;s:17:\"views_entity_node\";i:1;s:11:\"delete_node\";}}s:4:\"path\";a:1:{s:5:\"field\";a:3:{s:5:\"title\";s:4:\"Path\";s:4:\"help\";s:33:\"The aliased path to this content.\";s:7:\"handler\";s:29:\"views_handler_field_node_path\";}}s:16:\"created_fulldate\";a:3:{s:5:\"title\";s:12:\"Created date\";s:4:\"help\";s:29:\"Date in the form of CCYYMMDD.\";s:8:\"argument\";a:2:{s:5:\"field\";s:7:\"created\";s:7:\"handler\";s:44:\"views_handler_argument_node_created_fulldate\";}}s:18:\"created_year_month\";a:3:{s:5:\"title\";s:20:\"Created year + month\";s:4:\"help\";s:27:\"Date in the form of YYYYMM.\";s:8:\"argument\";a:2:{s:5:\"field\";s:7:\"created\";s:7:\"handler\";s:46:\"views_handler_argument_node_created_year_month\";}}s:12:\"created_year\";a:3:{s:5:\"title\";s:12:\"Created year\";s:4:\"help\";s:25:\"Date in the form of YYYY.\";s:8:\"argument\";a:2:{s:5:\"field\";s:7:\"created\";s:7:\"handler\";s:40:\"views_handler_argument_node_created_year\";}}s:13:\"created_month\";a:3:{s:5:\"title\";s:13:\"Created month\";s:4:\"help\";s:33:\"Date in the form of MM (01 - 12).\";s:8:\"argument\";a:2:{s:5:\"field\";s:7:\"created\";s:7:\"handler\";s:41:\"views_handler_argument_node_created_month\";}}s:11:\"created_day\";a:3:{s:5:\"title\";s:11:\"Created day\";s:4:\"help\";s:33:\"Date in the form of DD (01 - 31).\";s:8:\"argument\";a:2:{s:5:\"field\";s:7:\"created\";s:7:\"handler\";s:39:\"views_handler_argument_node_created_day\";}}s:12:\"created_week\";a:3:{s:5:\"title\";s:12:\"Created week\";s:4:\"help\";s:33:\"Date in the form of WW (01 - 53).\";s:8:\"argument\";a:2:{s:5:\"field\";s:7:\"created\";s:7:\"handler\";s:40:\"views_handler_argument_node_created_week\";}}s:16:\"changed_fulldate\";a:3:{s:5:\"title\";s:12:\"Updated date\";s:4:\"help\";s:29:\"Date in the form of CCYYMMDD.\";s:8:\"argument\";a:2:{s:5:\"field\";s:7:\"changed\";s:7:\"handler\";s:44:\"views_handler_argument_node_created_fulldate\";}}s:18:\"changed_year_month\";a:3:{s:5:\"title\";s:20:\"Updated year + month\";s:4:\"help\";s:27:\"Date in the form of YYYYMM.\";s:8:\"argument\";a:2:{s:5:\"field\";s:7:\"changed\";s:7:\"handler\";s:46:\"views_handler_argument_node_created_year_month\";}}s:12:\"changed_year\";a:3:{s:5:\"title\";s:12:\"Updated year\";s:4:\"help\";s:25:\"Date in the form of YYYY.\";s:8:\"argument\";a:2:{s:5:\"field\";s:7:\"changed\";s:7:\"handler\";s:40:\"views_handler_argument_node_created_year\";}}s:13:\"changed_month\";a:3:{s:5:\"title\";s:13:\"Updated month\";s:4:\"help\";s:33:\"Date in the form of MM (01 - 12).\";s:8:\"argument\";a:2:{s:5:\"field\";s:7:\"changed\";s:7:\"handler\";s:41:\"views_handler_argument_node_created_month\";}}s:11:\"changed_day\";a:3:{s:5:\"title\";s:11:\"Updated day\";s:4:\"help\";s:33:\"Date in the form of DD (01 - 31).\";s:8:\"argument\";a:2:{s:5:\"field\";s:7:\"changed\";s:7:\"handler\";s:39:\"views_handler_argument_node_created_day\";}}s:12:\"changed_week\";a:3:{s:5:\"title\";s:12:\"Updated week\";s:4:\"help\";s:33:\"Date in the form of WW (01 - 53).\";s:8:\"argument\";a:2:{s:5:\"field\";s:7:\"changed\";s:7:\"handler\";s:40:\"views_handler_argument_node_created_week\";}}s:3:\"uid\";a:6:{s:5:\"title\";s:10:\"Author uid\";s:4:\"help\";s:105:\"The user authoring the content. If you need more fields than the uid add the content: author relationship\";s:12:\"relationship\";a:6:{s:5:\"title\";s:6:\"Author\";s:4:\"help\";s:42:\"Relate content to the user who created it.\";s:7:\"handler\";s:26:\"views_handler_relationship\";s:4:\"base\";s:5:\"users\";s:5:\"field\";s:3:\"uid\";s:5:\"label\";s:6:\"author\";}s:6:\"filter\";a:1:{s:7:\"handler\";s:30:\"views_handler_filter_user_name\";}s:8:\"argument\";a:1:{s:7:\"handler\";s:30:\"views_handler_argument_numeric\";}s:5:\"field\";a:1:{s:7:\"handler\";s:24:\"views_handler_field_user\";}}s:12:\"uid_revision\";a:5:{s:5:\"title\";s:19:\"User has a revision\";s:4:\"help\";s:45:\"All nodes where a certain user has a revision\";s:10:\"real field\";s:3:\"nid\";s:6:\"filter\";a:1:{s:7:\"handler\";s:38:\"views_handler_filter_node_uid_revision\";}s:8:\"argument\";a:1:{s:7:\"handler\";s:40:\"views_handler_argument_node_uid_revision\";}}s:13:\"version_count\";a:5:{s:5:\"title\";s:13:\"Version Count\";s:4:\"help\";s:56:\"The total count of versions/revisions of a certain node.\";s:5:\"field\";a:3:{s:7:\"handler\";s:38:\"views_handler_field_node_version_count\";s:5:\"field\";s:3:\"nid\";s:14:\"click sortable\";b:1;}s:6:\"filter\";a:2:{s:7:\"handler\";s:39:\"views_handler_filter_node_version_count\";s:11:\"allow empty\";b:0;}s:4:\"sort\";a:1:{s:7:\"handler\";s:37:\"views_handler_sort_node_version_count\";}}s:9:\"sharethis\";a:3:{s:5:\"title\";s:14:\"ShareThis Link\";s:4:\"help\";s:39:\"Link provided by the ShareThis service.\";s:5:\"field\";a:2:{s:7:\"handler\";s:28:\"sharethis_handler_field_link\";s:14:\"click sortable\";b:0;}}s:18:\"webform_submission\";a:4:{s:5:\"title\";s:18:\"Webform submission\";s:4:\"help\";s:46:\"Webform submissions of the given Webform node.\";s:10:\"real field\";s:3:\"nid\";s:12:\"relationship\";a:4:{s:4:\"base\";s:19:\"webform_submissions\";s:10:\"base field\";s:3:\"nid\";s:7:\"handler\";s:26:\"views_handler_relationship\";s:5:\"label\";s:18:\"Webform Submission\";}}s:29:\"webform_submission_count_node\";a:2:{s:5:\"group\";s:7:\"Webform\";s:5:\"field\";a:4:{s:5:\"title\";s:24:\"Webform submission count\";s:4:\"help\";s:47:\"The number of webform submissions on this node.\";s:7:\"handler\";s:38:\"webform_handler_field_submission_count\";s:10:\"count_type\";s:4:\"node\";}}s:12:\"webform_edit\";a:2:{s:5:\"group\";s:7:\"Webform\";s:5:\"field\";a:3:{s:5:\"title\";s:17:\"Webform edit link\";s:4:\"help\";s:71:\"Provide a simple link to edit the webform components and configuration.\";s:7:\"handler\";s:36:\"webform_handler_field_node_link_edit\";}}s:15:\"webform_results\";a:2:{s:5:\"group\";s:7:\"Webform\";s:5:\"field\";a:3:{s:5:\"title\";s:20:\"Webform results link\";s:4:\"help\";s:55:\"Provide a simple link to view the results of a webform.\";s:7:\"handler\";s:39:\"webform_handler_field_node_link_results\";}}s:17:\"webform_form_body\";a:2:{s:5:\"group\";s:7:\"Webform\";s:5:\"field\";a:3:{s:5:\"title\";s:17:\"Webform form body\";s:4:\"help\";s:44:\"The Webform form body display for this node.\";s:7:\"handler\";s:31:\"webform_handler_field_form_body\";}}s:12:\"new_comments\";a:3:{s:5:\"title\";s:12:\"New comments\";s:4:\"help\";s:39:\"The number of new comments on the node.\";s:5:\"field\";a:2:{s:7:\"handler\";s:37:\"views_handler_field_node_new_comments\";s:11:\"no group by\";b:1;}}s:13:\"comments_link\";a:1:{s:5:\"field\";a:3:{s:5:\"title\";s:16:\"Add comment link\";s:4:\"help\";s:133:\"Display the standard add comment link used on regular nodes, which will only display if the viewing user has access to add a comment.\";s:7:\"handler\";s:37:\"views_handler_field_comment_node_link\";}}s:7:\"comment\";a:5:{s:5:\"title\";s:14:\"Comment status\";s:4:\"help\";s:53:\"Whether comments are enabled or disabled on the node.\";s:5:\"field\";a:2:{s:7:\"handler\";s:32:\"views_handler_field_node_comment\";s:14:\"click sortable\";b:1;}s:4:\"sort\";a:1:{s:7:\"handler\";s:18:\"views_handler_sort\";}s:6:\"filter\";a:1:{s:7:\"handler\";s:33:\"views_handler_filter_node_comment\";}}s:9:\"uid_touch\";a:4:{s:5:\"title\";s:24:\"User posted or commented\";s:4:\"help\";s:70:\"Display nodes only if a user posted the node or commented on the node.\";s:8:\"argument\";a:5:{s:5:\"field\";s:3:\"uid\";s:10:\"name table\";s:5:\"users\";s:10:\"name field\";s:4:\"name\";s:7:\"handler\";s:39:\"views_handler_argument_comment_user_uid\";s:11:\"no group by\";b:1;}s:6:\"filter\";a:4:{s:5:\"field\";s:3:\"uid\";s:10:\"name table\";s:5:\"users\";s:10:\"name field\";s:4:\"name\";s:7:\"handler\";s:37:\"views_handler_filter_comment_user_uid\";}}s:3:\"cid\";a:3:{s:5:\"title\";s:20:\"Comments of the node\";s:4:\"help\";s:151:\"Relate all comments on the node. This will create 1 duplicate record for every comment. Usually if you need this it is better to create a comment view.\";s:12:\"relationship\";a:6:{s:5:\"group\";s:7:\"Comment\";s:5:\"label\";s:8:\"Comments\";s:4:\"base\";s:7:\"comment\";s:10:\"base field\";s:3:\"nid\";s:18:\"relationship field\";s:3:\"nid\";s:7:\"handler\";s:26:\"views_handler_relationship\";}}s:30:\"reverse_field_node_ref_message\";a:1:{s:12:\"relationship\";a:11:{s:7:\"handler\";s:41:\"views_handler_relationship_entity_reverse\";s:10:\"field_name\";s:14:\"field_node_ref\";s:11:\"field table\";s:25:\"field_data_field_node_ref\";s:11:\"field field\";s:24:\"field_node_ref_target_id\";s:4:\"base\";s:7:\"message\";s:10:\"base field\";s:3:\"mid\";s:5:\"label\";s:47:\"Message referencing Content from field_node_ref\";s:5:\"group\";s:16:\"Entity Reference\";s:5:\"title\";s:18:\"Referencing entity\";s:4:\"help\";s:77:\"A bridge to the Message entity that is referencing Content via field_node_ref\";s:10:\"join_extra\";a:2:{i:0;a:2:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:7:\"message\";}i:1;a:3:{s:5:\"field\";s:7:\"deleted\";s:5:\"value\";i:0;s:7:\"numeric\";b:1;}}}}s:8:\"language\";a:6:{s:5:\"title\";s:8:\"Language\";s:4:\"help\";s:31:\"The language the content is in.\";s:5:\"field\";a:2:{s:7:\"handler\";s:33:\"views_handler_field_node_language\";s:14:\"click sortable\";b:1;}s:6:\"filter\";a:1:{s:7:\"handler\";s:34:\"views_handler_filter_node_language\";}s:8:\"argument\";a:1:{s:7:\"handler\";s:36:\"views_handler_argument_node_language\";}s:4:\"sort\";a:1:{s:7:\"handler\";s:18:\"views_handler_sort\";}}s:17:\"specific_language\";a:3:{s:5:\"title\";s:17:\"Specific language\";s:4:\"help\";s:51:\"Sort by a specific language that the content is in.\";s:4:\"sort\";a:1:{s:7:\"handler\";s:32:\"views_handler_sort_node_language\";}}s:13:\"term_node_tid\";a:4:{s:5:\"title\";s:22:\"Taxonomy terms on node\";s:4:\"help\";s:161:\"Relate nodes to taxonomy terms, specifiying which vocabulary or vocabularies to use. This relationship will cause duplicated records if there are multiple terms.\";s:12:\"relationship\";a:3:{s:7:\"handler\";s:41:\"views_handler_relationship_node_term_data\";s:5:\"label\";s:4:\"term\";s:4:\"base\";s:18:\"taxonomy_term_data\";}s:5:\"field\";a:4:{s:5:\"title\";s:18:\"All taxonomy terms\";s:4:\"help\";s:78:\"Display all taxonomy terms associated with a node from specified vocabularies.\";s:7:\"handler\";s:33:\"views_handler_field_term_node_tid\";s:11:\"no group by\";b:1;}}s:19:\"term_node_tid_depth\";a:4:{s:4:\"help\";s:175:\"Display content if it has the selected taxonomy terms, or children of the selected terms. Due to additional complexity, this has fewer options than the versions without depth.\";s:10:\"real field\";s:3:\"nid\";s:8:\"argument\";a:3:{s:5:\"title\";s:33:\"Has taxonomy term ID (with depth)\";s:7:\"handler\";s:42:\"views_handler_argument_term_node_tid_depth\";s:21:\"accept depth modifier\";b:1;}s:6:\"filter\";a:2:{s:5:\"title\";s:31:\"Has taxonomy terms (with depth)\";s:7:\"handler\";s:40:\"views_handler_filter_term_node_tid_depth\";}}s:24:\"term_node_tid_depth_join\";a:4:{s:4:\"help\";s:175:\"Display content if it has the selected taxonomy terms, or children of the selected terms. Due to additional complexity, this has fewer options than the versions without depth.\";s:10:\"real field\";s:3:\"nid\";s:8:\"argument\";a:3:{s:5:\"title\";s:45:\"Has taxonomy term ID with depth (using joins)\";s:7:\"handler\";s:47:\"views_handler_argument_term_node_tid_depth_join\";s:21:\"accept depth modifier\";b:1;}s:6:\"filter\";a:2:{s:5:\"title\";s:43:\"Has taxonomy terms with depth (using joins)\";s:7:\"handler\";s:45:\"views_handler_filter_term_node_tid_depth_join\";}}s:28:\"term_node_tid_depth_modifier\";a:3:{s:5:\"title\";s:35:\"Has taxonomy term ID depth modifier\";s:4:\"help\";s:111:\"Allows the \"depth\" for Taxonomy: Term ID (with depth) to be modified via an additional contextual filter value.\";s:8:\"argument\";a:1:{s:7:\"handler\";s:51:\"views_handler_argument_term_node_tid_depth_modifier\";}}s:14:\"votingapi_vote\";a:1:{s:12:\"relationship\";a:7:{s:5:\"title\";s:5:\"Votes\";s:4:\"help\";s:28:\"Votes cast by users on Node.\";s:4:\"base\";s:14:\"votingapi_vote\";s:5:\"field\";s:9:\"entity_id\";s:18:\"relationship field\";s:3:\"nid\";s:7:\"handler\";s:36:\"votingapi_views_handler_relationship\";s:5:\"extra\";a:1:{i:0;a:3:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";s:7:\"numeric\";b:0;}}}}s:15:\"votingapi_cache\";a:1:{s:12:\"relationship\";a:7:{s:5:\"title\";s:12:\"Vote results\";s:4:\"help\";s:40:\"Aggregate results of votes cast on Node.\";s:4:\"base\";s:15:\"votingapi_cache\";s:5:\"field\";s:9:\"entity_id\";s:18:\"relationship field\";s:3:\"nid\";s:7:\"handler\";s:36:\"votingapi_views_handler_relationship\";s:5:\"extra\";a:1:{i:0;a:3:{s:5:\"field\";s:11:\"entity_type\";s:5:\"value\";s:4:\"node\";s:7:\"numeric\";b:0;}}}}s:10:\"topic_icon\";a:3:{s:5:\"title\";s:10:\"Topic Icon\";s:4:\"help\";s:52:\"Icon that shows new posts, hot, sticky, locked, etc.\";s:5:\"field\";a:1:{s:7:\"handler\";s:44:\"advanced_forum_handler_field_node_topic_icon\";}}s:11:\"topic_pager\";a:3:{s:5:\"title\";s:11:\"Topic Pager\";s:4:\"help\";s:34:\"Small pager for individual topics.\";s:5:\"field\";a:1:{s:7:\"handler\";s:45:\"advanced_forum_handler_field_node_topic_pager\";}}}',0,1512620348,1);
/*!40000 ALTER TABLE `cache_views` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `cache_views_data`
--

DROP TABLE IF EXISTS `cache_views_data`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `cache_views_data` (
  `cid` varchar(255) NOT NULL DEFAULT '' COMMENT 'Primary Key: Unique cache ID.',
  `data` longblob COMMENT 'A collection of data to cache.',
  `expire` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry should expire, or 0 for never.',
  `created` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry was created.',
  `serialized` smallint(6) NOT NULL DEFAULT '1' COMMENT 'A flag to indicate whether content is serialized (1) or not (0).',
  PRIMARY KEY (`cid`),
  KEY `expire` (`expire`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Cache table for views to store pre-rendered queries,...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `cache_views_data`
--

LOCK TABLES `cache_views_data` WRITE;
/*!40000 ALTER TABLE `cache_views_data` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `cache_views_data` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `ckeditor_input_format`
--

DROP TABLE IF EXISTS `ckeditor_input_format`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `ckeditor_input_format` (
  `name` varchar(128) NOT NULL DEFAULT '' COMMENT 'Name of the CKEditor role',
  `format` varchar(128) NOT NULL DEFAULT '' COMMENT 'Drupal filter format ID',
  PRIMARY KEY (`name`,`format`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Stores CKEditor input format assignments';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ckeditor_input_format`
--

LOCK TABLES `ckeditor_input_format` WRITE;
/*!40000 ALTER TABLE `ckeditor_input_format` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `ckeditor_input_format` VALUES ('Advanced','filtered_html'),('Full','full_html');
/*!40000 ALTER TABLE `ckeditor_input_format` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `ckeditor_settings`
--

DROP TABLE IF EXISTS `ckeditor_settings`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `ckeditor_settings` (
  `name` varchar(128) NOT NULL DEFAULT '' COMMENT 'Name of the CKEditor profile',
  `settings` text COMMENT 'Profile settings',
  PRIMARY KEY (`name`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Stores CKEditor profile settings';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ckeditor_settings`
--

LOCK TABLES `ckeditor_settings` WRITE;
/*!40000 ALTER TABLE `ckeditor_settings` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `ckeditor_settings` VALUES ('Advanced','a:27:{s:11:\"filebrowser\";s:4:\"none\";s:11:\"quickupload\";s:1:\"f\";s:2:\"ss\";s:1:\"2\";s:7:\"filters\";a:1:{s:11:\"filter_html\";i:1;}s:7:\"default\";s:1:\"t\";s:11:\"show_toggle\";s:1:\"t\";s:5:\"popup\";s:1:\"f\";s:7:\"toolbar\";s:596:\"\n[\n    [\'Source\'],\n    [\'Cut\',\'Copy\',\'Paste\',\'PasteText\',\'PasteFromWord\',\'-\',\'SpellChecker\', \'Scayt\'],\n    [\'Undo\',\'Redo\',\'Find\',\'Replace\',\'-\',\'SelectAll\'],\n    [\'Image\',\'Media\',\'Flash\',\'Table\',\'HorizontalRule\',\'Smiley\',\'SpecialChar\'],\n    [\'Maximize\', \'ShowBlocks\'],\n    \'/\',\n    [\'Format\'],\n    [\'Bold\',\'Italic\',\'Underline\',\'Strike\',\'-\',\'Subscript\',\'Superscript\',\'-\',\'RemoveFormat\'],\n    [\'NumberedList\',\'BulletedList\',\'-\',\'Outdent\',\'Indent\',\'Blockquote\'],\n    [\'JustifyLeft\',\'JustifyCenter\',\'JustifyRight\',\'JustifyBlock\',\'-\',\'BidiLtr\',\'BidiRtl\'],\n    [\'Link\',\'Unlink\',\'Anchor\',\'Linkit\']\n]\n    \";s:6:\"expand\";s:1:\"t\";s:5:\"width\";s:4:\"100%\";s:4:\"lang\";s:2:\"en\";s:9:\"auto_lang\";s:1:\"t\";s:18:\"language_direction\";s:7:\"default\";s:10:\"enter_mode\";s:1:\"p\";s:16:\"shift_enter_mode\";s:2:\"br\";s:11:\"font_format\";s:35:\"p;div;pre;address;h1;h2;h3;h4;h5;h6\";s:13:\"format_source\";s:1:\"t\";s:13:\"format_output\";s:1:\"t\";s:17:\"custom_formatting\";s:1:\"f\";s:10:\"formatting\";a:1:{s:25:\"custom_formatting_options\";a:4:{s:6:\"indent\";s:6:\"indent\";s:15:\"breakBeforeOpen\";s:15:\"breakBeforeOpen\";s:14:\"breakAfterOpen\";s:14:\"breakAfterOpen\";s:15:\"breakAfterClose\";s:15:\"breakAfterClose\";}}s:8:\"css_mode\";s:4:\"none\";s:8:\"css_path\";s:0:\"\";s:11:\"user_choose\";s:1:\"f\";s:20:\"ckeditor_load_method\";s:11:\"ckeditor.js\";s:22:\"ckeditor_load_time_out\";i:0;s:17:\"scayt_autoStartup\";s:1:\"f\";s:13:\"html_entities\";s:1:\"f\";}'),('CKEditor Global Profile','a:1:{s:13:\"ckeditor_path\";s:33:\"//cdn.ckeditor.com/4.4.3/full-all\";}'),('Full','a:33:{s:2:\"ss\";s:1:\"2\";s:7:\"toolbar\";s:708:\"[\n    [\'Source\'],\n    [\'Cut\',\'Copy\',\'Paste\',\'PasteText\',\'PasteFromWord\',\'-\',\'SpellChecker\', \'Scayt\'],\n    [\'Undo\',\'Redo\',\'Find\',\'Replace\',\'-\',\'SelectAll\'],\n    [\'Image\',\'Media\',\'Flash\',\'Table\',\'HorizontalRule\',\'Smiley\',\'SpecialChar\',\'Iframe\'],\n    \'/\',\n    [\'Bold\',\'Italic\',\'Underline\',\'Strike\',\'-\',\'Subscript\',\'Superscript\',\'-\',\'RemoveFormat\'],\n    [\'NumberedList\',\'BulletedList\',\'-\',\'Outdent\',\'Indent\',\'Blockquote\',\'CreateDiv\'],\n    [\'JustifyLeft\',\'JustifyCenter\',\'JustifyRight\',\'JustifyBlock\',\'-\',\'BidiLtr\',\'BidiRtl\',\'-\',\'Language\'],\n    [\'Link\',\'Unlink\',\'Anchor\',\'Linkit\'],\n    [\'DrupalBreak\'],\n    \'/\',\n    [\'Format\',\'Font\',\'FontSize\'],\n    [\'TextColor\',\'BGColor\'],\n    [\'Maximize\', \'ShowBlocks\']\n]\n    \";s:6:\"expand\";s:1:\"t\";s:7:\"default\";s:1:\"t\";s:11:\"show_toggle\";s:1:\"t\";s:7:\"uicolor\";s:7:\"default\";s:12:\"uicolor_user\";s:7:\"default\";s:5:\"width\";s:4:\"100%\";s:4:\"lang\";s:2:\"en\";s:9:\"auto_lang\";s:1:\"t\";s:18:\"language_direction\";s:7:\"default\";s:15:\"allowed_content\";s:1:\"t\";s:19:\"extraAllowedContent\";s:0:\"\";s:10:\"enter_mode\";s:1:\"p\";s:16:\"shift_enter_mode\";s:2:\"br\";s:11:\"font_format\";s:35:\"p;div;pre;address;h1;h2;h3;h4;h5;h6\";s:17:\"custom_formatting\";s:1:\"f\";s:10:\"formatting\";a:1:{s:25:\"custom_formatting_options\";a:6:{s:6:\"indent\";s:6:\"indent\";s:15:\"breakBeforeOpen\";s:15:\"breakBeforeOpen\";s:14:\"breakAfterOpen\";s:14:\"breakAfterOpen\";s:15:\"breakAfterClose\";s:15:\"breakAfterClose\";s:16:\"breakBeforeClose\";i:0;s:10:\"pre_indent\";i:0;}}s:8:\"css_mode\";s:4:\"none\";s:8:\"css_path\";s:0:\"\";s:9:\"css_style\";s:5:\"theme\";s:11:\"styles_path\";s:0:\"\";s:11:\"filebrowser\";s:4:\"none\";s:17:\"filebrowser_image\";s:0:\"\";s:17:\"filebrowser_flash\";s:0:\"\";s:13:\"UserFilesPath\";s:5:\"%b%f/\";s:21:\"UserFilesAbsolutePath\";s:7:\"%d%b%f/\";s:21:\"forcePasteAsPlainText\";s:1:\"f\";s:13:\"html_entities\";s:1:\"f\";s:17:\"scayt_autoStartup\";s:1:\"f\";s:15:\"theme_config_js\";s:1:\"f\";s:7:\"js_conf\";s:29:\"config.allowedContent = true;\";s:11:\"loadPlugins\";a:2:{s:12:\"drupalbreaks\";a:5:{s:4:\"name\";s:12:\"drupalbreaks\";s:4:\"desc\";s:51:\"Plugin for inserting Drupal teaser and page breaks.\";s:4:\"path\";s:25:\"%plugin_dir%drupalbreaks/\";s:7:\"buttons\";a:1:{s:11:\"DrupalBreak\";a:2:{s:5:\"label\";s:11:\"DrupalBreak\";s:4:\"icon\";s:22:\"images/drupalbreak.png\";}}s:7:\"default\";s:1:\"t\";}s:11:\"tableresize\";a:5:{s:4:\"name\";s:11:\"tableresize\";s:4:\"desc\";s:105:\"Table Resize plugin. See <a href=\"http://ckeditor.com/addon/tableresize\">addon page</a> for more details.\";s:4:\"path\";s:54:\"//cdn.ckeditor.com/4.4.3/full-all/plugins/tableresize/\";s:7:\"buttons\";b:0;s:7:\"default\";s:1:\"t\";}}}');
/*!40000 ALTER TABLE `ckeditor_settings` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `comment`
--

DROP TABLE IF EXISTS `comment`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `comment` (
  `cid` int(11) NOT NULL AUTO_INCREMENT COMMENT 'Primary Key: Unique comment ID.',
  `pid` int(11) NOT NULL DEFAULT '0' COMMENT 'The comment.cid to which this comment is a reply. If set to 0, this comment is not a reply to an existing comment.',
  `nid` int(11) NOT NULL DEFAULT '0' COMMENT 'The node.nid to which this comment is a reply.',
  `uid` int(11) NOT NULL DEFAULT '0' COMMENT 'The users.uid who authored the comment. If set to 0, this comment was created by an anonymous user.',
  `subject` varchar(64) NOT NULL DEFAULT '' COMMENT 'The comment title.',
  `hostname` varchar(128) NOT NULL DEFAULT '' COMMENT 'The author’s host name.',
  `created` int(11) NOT NULL DEFAULT '0' COMMENT 'The time that the comment was created, as a Unix timestamp.',
  `changed` int(11) NOT NULL DEFAULT '0' COMMENT 'The time that the comment was last edited, as a Unix timestamp.',
  `status` tinyint(3) unsigned NOT NULL DEFAULT '1' COMMENT 'The published status of a comment. (0 = Not Published, 1 = Published)',
  `thread` varchar(255) NOT NULL COMMENT 'The vancode representation of the comment’s place in a thread.',
  `name` varchar(60) DEFAULT NULL COMMENT 'The comment author’s name. Uses users.name if the user is logged in, otherwise uses the value typed into the comment form.',
  `mail` varchar(64) DEFAULT NULL COMMENT 'The comment author’s e-mail address from the comment form, if user is anonymous, and the ’Anonymous users may/must leave their contact information’ setting is turned on.',
  `homepage` varchar(255) DEFAULT NULL COMMENT 'The comment author’s home page address from the comment form, if user is anonymous, and the ’Anonymous users may/must leave their contact information’ setting is turned on.',
  `language` varchar(12) NOT NULL DEFAULT '' COMMENT 'The languages.language of this comment.',
  PRIMARY KEY (`cid`),
  KEY `comment_status_pid` (`pid`,`status`),
  KEY `comment_num_new` (`nid`,`status`,`created`,`cid`,`thread`),
  KEY `comment_uid` (`uid`),
  KEY `comment_nid_language` (`nid`,`language`),
  KEY `comment_created` (`created`)
) ENGINE=InnoDB AUTO_INCREMENT=54 DEFAULT CHARSET=utf8 COMMENT='Stores comments and associated data.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `comment`
--

LOCK TABLES `comment` WRITE;
/*!40000 ALTER TABLE `comment` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `comment` VALUES (1,0,1,1,'Even if D8 goes gold tomorrow','127.0.0.1',1404031697,1404031697,1,'01/','admin','','','und'),(2,0,11,1,'Praesent metus tellus,','::1',1404869654,1404869654,1,'01/','admin','','','und'),(3,0,11,2,'Curabitur a felis in nunc','::1',1404869686,1404869686,1,'02/','Peter','','','und'),(4,0,9,2,'Curabitur a felis in nunc','::1',1404869706,1404869705,1,'01/','Peter','','','und'),(5,0,7,2,'Curabitur a felis in nunc','::1',1404869718,1404869717,1,'01/','Peter','','','und'),(6,0,9,1,'Curabitur a felis in nunc','::1',1404869733,1404869733,1,'02/','admin','','','und'),(7,0,12,1,'Nam quam nunc, blandit vel,','::1',1405042786,1405042786,1,'01/','admin','','','und'),(8,0,15,2,'Donec sodales sagittis magna.','::1',1405266476,1405266475,1,'01/','Peter','','','und'),(9,0,15,6,'Phasellus leo dolor, tempus','::1',1405267046,1405267046,1,'02/','Mical','','','und'),(10,0,16,1,'Drupal 7.28 released','::1',1405267525,1405267524,1,'01/','admin','','','und'),(11,0,31,2,'Vivamus id interdum odio.','::1',1407764992,1407764992,1,'01/','Peter','','','und'),(12,0,31,1,'Phasellus nec sem in justo','::1',1407765206,1407765206,1,'02/','admin','','','und'),(13,12,31,2,'Vestibulum rutrum, mi nec','::1',1407765241,1407765241,1,'02.00/','Peter','','','und'),(14,0,30,2,'Vestibulum rutrum, mi nec','::1',1407765279,1407765278,1,'01/','Peter','','','und'),(15,0,5,2,'Fusce porttitor nunc ac ante','::1',1407806449,1407806449,1,'01/','Peter','','','und'),(16,0,5,1,'Phasellus magna. Nullam','::1',1407806469,1407806469,1,'02/','admin','','','und'),(17,0,10,1,'Phasellus volutpat, metus','::1',1407806513,1407806513,1,'01/','admin','','','und'),(18,0,53,2,'Morbi mollis tellus ac sapien','::1',1408185053,1408185052,1,'01/','Peter','','','und'),(19,0,53,1,'Suspendisse non nisl sit amet','::1',1408185153,1408185153,1,'02/','admin','','','und'),(20,0,53,2,'Suspendisse non nisl sit amet','::1',1408185174,1408185174,1,'03/','Peter','','','und'),(21,0,53,1,'Suspendisse non nisl sit amet','::1',1408185182,1408185182,1,'04/','admin','','','und'),(22,0,53,6,'Aenean id mollis justo.','::1',1408185237,1408185237,1,'05/','Mical','','','und'),(23,0,53,2,'Phasellus et mauris sit amet','::1',1408185262,1408185262,1,'06/','Peter','','','und'),(24,0,53,6,'Donec hendrerit, tortor ut','::1',1408185277,1408185276,1,'07/','Mical','','','und'),(25,0,53,6,'Pellentesque vel augue sit','::1',1408185292,1408185292,1,'08/','Mical','','','und'),(26,0,53,1,'Phasellus volutpat, metus','::1',1408185317,1408185317,1,'09/','admin','','','und'),(27,0,53,6,'Duis feugiat libero felis, ut','::1',1408185337,1408185337,1,'0a/','Mical','','','und'),(28,0,53,2,'Phasellus volutpat, metus','::1',1408185360,1408185359,1,'0b/','Peter','','','und'),(29,0,53,7,'Morbi ac felis. Quisque id mi','::1',1408185924,1408185924,1,'0c/','jack','','','und'),(30,0,7,7,'Morbi mattis ullamcorper','::1',1408267227,1408267227,1,'02/','jack','','','und'),(31,0,7,1,'Aenean leo ligula, porttitor','::1',1408267238,1408267238,1,'03/','admin','','','und'),(32,0,7,1,'Vivamus elementum semper nisi','::1',1408267244,1408267244,1,'04/','admin','','','und'),(33,30,7,1,'Vivamus elementum semper nisi','::1',1408267299,1408267298,1,'02.00/','admin','','','und'),(34,0,7,6,'Aliquam eu faucibus orci, a','::1',1408267409,1408267409,1,'05/','Mical','','','und'),(35,32,7,6,'Vestibulum mattis metus non','::1',1408267427,1408267426,1,'04.00/','Mical','','','und'),(36,0,7,6,'Nulla adipiscing quam eros,','::1',1408267436,1408267436,1,'06/','Mical','','','und'),(37,0,7,6,'Pellentesque placerat','::1',1408267441,1408267441,1,'07/','Mical','','','und'),(38,0,7,1,'Phasellus viverra nulla ut','::1',1408267499,1408267499,1,'08/','admin','','','und'),(39,0,7,1,'Vestibulum purus quam,','::1',1408267506,1408267506,1,'09/','admin','','','und'),(40,39,7,6,'Morbi neque arcu, malesuada','::1',1408267535,1408267535,1,'09.00/','Mical','','','und'),(41,0,8,1,'Fusce neque. Ut a nisl id','::1',1408267667,1408267666,1,'01/','admin','','','und'),(42,0,8,1,'Nullam nulla eros, ultricies','::1',1408267673,1408267673,1,'02/','admin','','','und'),(43,41,8,7,'Quisque libero metus,','::1',1408267696,1408267695,1,'01.00/','jack','','','und'),(44,43,8,1,'Cras varius. Curabitur','::1',1408267711,1408267710,1,'01.00.00/','admin','','','und'),(45,4,9,1,'In hac habitasse platea','::1',1408267835,1408267835,1,'01.00/','admin','','','und'),(46,0,55,1,'Quisque libero metus,','::1',1408269496,1408269496,1,'01/','admin','','','und'),(47,0,55,6,'Nunc lobortis egestas justo,','::1',1408269582,1408269582,1,'02/','Mical','','','und'),(48,0,54,6,'Sed sit amet ullamcorper','::1',1408269965,1408269965,1,'01/','Mical','','','und'),(49,0,56,1,'Suspendisse potenti. Integer','::1',1408270155,1408270154,1,'01/','admin','','','und'),(50,0,37,1,'Curabitur ullamcorper','::1',1408377529,1408377529,1,'01/','admin','','','und'),(51,0,47,1,'In hac habitasse platea','::1',1408382574,1408382574,1,'01/','admin','','','und'),(52,0,3,6,'Phasellus a tellus erat.','::1',1408382644,1408382643,1,'01/','Mical','','','und'),(53,0,1,1,'Donec venenatis vulputate','::1',1408589899,1408589898,1,'02/','admin','','','und');
/*!40000 ALTER TABLE `comment` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `contact`
--

DROP TABLE IF EXISTS `contact`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `contact` (
  `cid` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Primary Key: Unique category ID.',
  `category` varchar(255) NOT NULL DEFAULT '' COMMENT 'Category name.',
  `recipients` longtext NOT NULL COMMENT 'Comma-separated list of recipient e-mail addresses.',
  `reply` longtext NOT NULL COMMENT 'Text of the auto-reply message.',
  `weight` int(11) NOT NULL DEFAULT '0' COMMENT 'The category’s weight.',
  `selected` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'Flag to indicate whether or not category is selected by default. (1 = Yes, 0 = No)',
  PRIMARY KEY (`cid`),
  UNIQUE KEY `category` (`category`),
  KEY `list` (`weight`,`category`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=utf8 COMMENT='Contact form category settings.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `contact`
--

LOCK TABLES `contact` WRITE;
/*!40000 ALTER TABLE `contact` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `contact` VALUES (1,'Website feedback','admin@forum-plus.com','',0,1);
/*!40000 ALTER TABLE `contact` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `ctools_css_cache`
--

DROP TABLE IF EXISTS `ctools_css_cache`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `ctools_css_cache` (
  `cid` varchar(128) NOT NULL COMMENT 'The CSS ID this cache object belongs to.',
  `filename` varchar(255) DEFAULT NULL COMMENT 'The filename this CSS is stored in.',
  `css` longtext COMMENT 'CSS being stored.',
  `filter` tinyint(4) DEFAULT NULL COMMENT 'Whether or not this CSS needs to be filtered.',
  PRIMARY KEY (`cid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='A special cache used to store CSS that must be non-volatile.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ctools_css_cache`
--

LOCK TABLES `ctools_css_cache` WRITE;
/*!40000 ALTER TABLE `ctools_css_cache` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `ctools_css_cache` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `ctools_object_cache`
--

DROP TABLE IF EXISTS `ctools_object_cache`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `ctools_object_cache` (
  `sid` varchar(64) NOT NULL COMMENT 'The session ID this cache object belongs to.',
  `name` varchar(128) NOT NULL COMMENT 'The name of the object this cache is attached to.',
  `obj` varchar(128) NOT NULL COMMENT 'The type of the object this cache is attached to; this essentially represents the owner so that several sub-systems can use this cache.',
  `updated` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The time this cache was created or updated.',
  `data` longblob COMMENT 'Serialized data being stored.',
  PRIMARY KEY (`sid`,`obj`,`name`),
  KEY `updated` (`updated`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='A special cache used to store objects that are being...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ctools_object_cache`
--

LOCK TABLES `ctools_object_cache` WRITE;
/*!40000 ALTER TABLE `ctools_object_cache` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `ctools_object_cache` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `date_format_locale`
--

DROP TABLE IF EXISTS `date_format_locale`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `date_format_locale` (
  `format` varchar(100) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL COMMENT 'The date format string.',
  `type` varchar(64) NOT NULL COMMENT 'The date format type, e.g. medium.',
  `language` varchar(12) NOT NULL COMMENT 'A languages.language for this format to be used with.',
  PRIMARY KEY (`type`,`language`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Stores configured date formats for each locale.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `date_format_locale`
--

LOCK TABLES `date_format_locale` WRITE;
/*!40000 ALTER TABLE `date_format_locale` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `date_format_locale` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `date_format_type`
--

DROP TABLE IF EXISTS `date_format_type`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `date_format_type` (
  `type` varchar(64) NOT NULL COMMENT 'The date format type, e.g. medium.',
  `title` varchar(255) NOT NULL COMMENT 'The human readable name of the format type.',
  `locked` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'Whether or not this is a system provided format.',
  PRIMARY KEY (`type`),
  KEY `title` (`title`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Stores configured date format types.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `date_format_type`
--

LOCK TABLES `date_format_type` WRITE;
/*!40000 ALTER TABLE `date_format_type` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `date_format_type` VALUES ('long','Long',1),('medium','Medium',1),('short','Short',1);
/*!40000 ALTER TABLE `date_format_type` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `date_formats`
--

DROP TABLE IF EXISTS `date_formats`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `date_formats` (
  `dfid` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'The date format identifier.',
  `format` varchar(100) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL COMMENT 'The date format string.',
  `type` varchar(64) NOT NULL COMMENT 'The date format type, e.g. medium.',
  `locked` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'Whether or not this format can be modified.',
  PRIMARY KEY (`dfid`),
  UNIQUE KEY `formats` (`format`,`type`)
) ENGINE=InnoDB AUTO_INCREMENT=36 DEFAULT CHARSET=utf8 COMMENT='Stores configured date formats.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `date_formats`
--

LOCK TABLES `date_formats` WRITE;
/*!40000 ALTER TABLE `date_formats` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `date_formats` VALUES (1,'Y-m-d H:i','short',1),(2,'m/d/Y - H:i','short',1),(3,'d/m/Y - H:i','short',1),(4,'Y/m/d - H:i','short',1),(5,'d.m.Y - H:i','short',1),(6,'m/d/Y - g:ia','short',1),(7,'d/m/Y - g:ia','short',1),(8,'Y/m/d - g:ia','short',1),(9,'M j Y - H:i','short',1),(10,'j M Y - H:i','short',1),(11,'Y M j - H:i','short',1),(12,'M j Y - g:ia','short',1),(13,'j M Y - g:ia','short',1),(14,'Y M j - g:ia','short',1),(15,'D, Y-m-d H:i','medium',1),(16,'D, m/d/Y - H:i','medium',1),(17,'D, d/m/Y - H:i','medium',1),(18,'D, Y/m/d - H:i','medium',1),(19,'F j, Y - H:i','medium',1),(20,'j F, Y - H:i','medium',1),(21,'Y, F j - H:i','medium',1),(22,'D, m/d/Y - g:ia','medium',1),(23,'D, d/m/Y - g:ia','medium',1),(24,'D, Y/m/d - g:ia','medium',1),(25,'F j, Y - g:ia','medium',1),(26,'j F Y - g:ia','medium',1),(27,'Y, F j - g:ia','medium',1),(28,'j. F Y - G:i','medium',1),(29,'l, F j, Y - H:i','long',1),(30,'l, j F, Y - H:i','long',1),(31,'l, Y,  F j - H:i','long',1),(32,'l, F j, Y - g:ia','long',1),(33,'l, j F Y - g:ia','long',1),(34,'l, Y,  F j - g:ia','long',1),(35,'l, j. F Y - G:i','long',1);
/*!40000 ALTER TABLE `date_formats` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `faq_questions`
--

DROP TABLE IF EXISTS `faq_questions`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `faq_questions` (
  `nid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The primary identifier for a node.',
  `vid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The primary identifier for a node revision.',
  `question` text NOT NULL COMMENT 'The faq short question text.',
  `detailed_question` text COMMENT 'The faq long question text.',
  PRIMARY KEY (`nid`,`vid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='A table containing the long question text of each faq...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `faq_questions`
--

LOCK TABLES `faq_questions` WRITE;
/*!40000 ALTER TABLE `faq_questions` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `faq_questions` VALUES (13,13,'Praesent nec nisl a purus',''),(14,14,'Praesent congue erat at massa',''),(58,58,'Donec vitae sapien ut',''),(59,59,'Fusce pulvinar interdum lectus sed tempor',''),(60,60,'Lorem ipsum dolor sit amet, consectetuer adipiscing elit',''),(61,61,'Aenean posuere, tortor sed cursus feugiat, nunc augue blandit nunc,',''),(62,62,'Pellentesque egestas neque sit amet',''),(63,63,'Suspendisse enim turpis, dictum sed, iaculis a, condimentum nec, nisi.',''),(64,64,'Morbi mollis tellus ac sapien',''),(65,65,'Proin faucibus arcu quis ante',''),(66,66,'Curabitur non elit faucibus, malesuada elit at, pellentesque tellus',''),(67,67,'Phasellus enim eros, dapibus non pulvinar vel, condimentum quis felis','');
/*!40000 ALTER TABLE `faq_questions` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `faq_weights`
--

DROP TABLE IF EXISTS `faq_weights`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `faq_weights` (
  `tid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The primary identifier for a term or category.  This will be 0 for non-categorized nodes.',
  `nid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The primary identifier for a node.',
  `weight` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A number representing the weight of a node.  Nodes with lower weight values will appear above those with higher weight values.',
  PRIMARY KEY (`nid`,`tid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='A table containing the weight of each faq node by category.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `faq_weights`
--

LOCK TABLES `faq_weights` WRITE;
/*!40000 ALTER TABLE `faq_weights` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `faq_weights` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `field_collection_item`
--

DROP TABLE IF EXISTS `field_collection_item`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_collection_item` (
  `item_id` int(11) NOT NULL AUTO_INCREMENT COMMENT 'Primary Key: Unique field collection item ID.',
  `revision_id` int(11) NOT NULL COMMENT 'Default revision ID.',
  `field_name` varchar(32) NOT NULL COMMENT 'The name of the field on the host entity embedding this entity.',
  `archived` int(11) NOT NULL DEFAULT '0' COMMENT 'Boolean indicating whether the field collection item is archived.',
  PRIMARY KEY (`item_id`)
) ENGINE=InnoDB AUTO_INCREMENT=29 DEFAULT CHARSET=utf8 COMMENT='Stores information about field collection items.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_collection_item`
--

LOCK TABLES `field_collection_item` WRITE;
/*!40000 ALTER TABLE `field_collection_item` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `field_collection_item` VALUES (1,1,'field_content',0),(9,9,'field_extra_content',0),(10,10,'field_extra_content',0),(11,11,'field_extra_content',0),(12,12,'field_extra_content',0),(13,13,'field_extra_content',0),(14,14,'field_extra_content',0),(15,15,'field_extra_content',0),(16,16,'field_extra_content',0),(17,17,'field_extra_content',0),(18,18,'field_extra_content',0),(19,19,'field_extra_content',0),(20,20,'field_extra_content',0),(21,21,'field_extra_content',0),(24,24,'field_extra_content',0),(26,26,'field_extra_content',0),(27,27,'field_extra_content',0),(28,28,'field_extra_content',0);
/*!40000 ALTER TABLE `field_collection_item` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `field_collection_item_revision`
--

DROP TABLE IF EXISTS `field_collection_item_revision`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_collection_item_revision` (
  `revision_id` int(11) NOT NULL AUTO_INCREMENT COMMENT 'Primary Key: Unique revision ID.',
  `item_id` int(11) NOT NULL COMMENT 'Field collection item ID.',
  PRIMARY KEY (`revision_id`),
  KEY `item_id` (`item_id`)
) ENGINE=InnoDB AUTO_INCREMENT=29 DEFAULT CHARSET=utf8 COMMENT='Stores revision information about field collection items.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_collection_item_revision`
--

LOCK TABLES `field_collection_item_revision` WRITE;
/*!40000 ALTER TABLE `field_collection_item_revision` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `field_collection_item_revision` VALUES (1,1),(9,9),(10,10),(11,11),(12,12),(13,13),(14,14),(15,15),(16,16),(17,17),(18,18),(19,19),(20,20),(21,21),(24,24),(26,26),(27,27),(28,28);
/*!40000 ALTER TABLE `field_collection_item_revision` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `field_config`
--

DROP TABLE IF EXISTS `field_config`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_config` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT 'The primary identifier for a field',
  `field_name` varchar(32) NOT NULL COMMENT 'The name of this field. Non-deleted field names are unique, but multiple deleted fields can have the same name.',
  `type` varchar(128) NOT NULL COMMENT 'The type of this field.',
  `module` varchar(128) NOT NULL DEFAULT '' COMMENT 'The module that implements the field type.',
  `active` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'Boolean indicating whether the module that implements the field type is enabled.',
  `storage_type` varchar(128) NOT NULL COMMENT 'The storage backend for the field.',
  `storage_module` varchar(128) NOT NULL DEFAULT '' COMMENT 'The module that implements the storage backend.',
  `storage_active` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'Boolean indicating whether the module that implements the storage backend is enabled.',
  `locked` tinyint(4) NOT NULL DEFAULT '0' COMMENT '@TODO',
  `data` longblob NOT NULL COMMENT 'Serialized data containing the field properties that do not warrant a dedicated column.',
  `cardinality` tinyint(4) NOT NULL DEFAULT '0',
  `translatable` tinyint(4) NOT NULL DEFAULT '0',
  `deleted` tinyint(4) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `field_name` (`field_name`),
  KEY `active` (`active`),
  KEY `storage_active` (`storage_active`),
  KEY `deleted` (`deleted`),
  KEY `module` (`module`),
  KEY `storage_module` (`storage_module`),
  KEY `type` (`type`),
  KEY `storage_type` (`storage_type`)
) ENGINE=InnoDB AUTO_INCREMENT=19 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_config`
--

LOCK TABLES `field_config` WRITE;
/*!40000 ALTER TABLE `field_config` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `field_config` VALUES (1,'comment_body','text_long','text',1,'field_sql_storage','field_sql_storage',1,0,'a:6:{s:12:\"entity_types\";a:1:{i:0;s:7:\"comment\";}s:12:\"translatable\";b:0;s:8:\"settings\";a:0:{}s:7:\"storage\";a:4:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";i:1;}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}}',1,0,0),(2,'body','text_with_summary','text',1,'field_sql_storage','field_sql_storage',1,0,'a:6:{s:12:\"entity_types\";a:1:{i:0;s:4:\"node\";}s:12:\"translatable\";b:0;s:8:\"settings\";a:0:{}s:7:\"storage\";a:4:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";i:1;}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}}',1,0,0),(3,'field_tags','taxonomy_term_reference','taxonomy',1,'field_sql_storage','field_sql_storage',1,0,'a:7:{s:8:\"settings\";a:2:{s:14:\"allowed_values\";a:1:{i:0;a:2:{s:10:\"vocabulary\";s:4:\"tags\";s:6:\"parent\";i:0;}}s:21:\"options_list_callback\";s:28:\"i18n_taxonomy_allowed_values\";}s:12:\"entity_types\";a:0:{}s:12:\"translatable\";s:1:\"0\";s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:21:\"field_data_field_tags\";a:1:{s:3:\"tid\";s:14:\"field_tags_tid\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:25:\"field_revision_field_tags\";a:1:{s:3:\"tid\";s:14:\"field_tags_tid\";}}}}}s:12:\"foreign keys\";a:1:{s:3:\"tid\";a:2:{s:5:\"table\";s:18:\"taxonomy_term_data\";s:7:\"columns\";a:1:{s:3:\"tid\";s:3:\"tid\";}}}s:7:\"indexes\";a:1:{s:3:\"tid\";a:1:{i:0;s:3:\"tid\";}}s:2:\"id\";s:1:\"3\";}',-1,0,0),(4,'field_image','image','image',1,'field_sql_storage','field_sql_storage',1,0,'a:7:{s:7:\"indexes\";a:1:{s:3:\"fid\";a:1:{i:0;s:3:\"fid\";}}s:8:\"settings\";a:2:{s:10:\"uri_scheme\";s:6:\"public\";s:13:\"default_image\";i:0;}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:22:\"field_data_field_image\";a:5:{s:3:\"fid\";s:15:\"field_image_fid\";s:3:\"alt\";s:15:\"field_image_alt\";s:5:\"title\";s:17:\"field_image_title\";s:5:\"width\";s:17:\"field_image_width\";s:6:\"height\";s:18:\"field_image_height\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:26:\"field_revision_field_image\";a:5:{s:3:\"fid\";s:15:\"field_image_fid\";s:3:\"alt\";s:15:\"field_image_alt\";s:5:\"title\";s:17:\"field_image_title\";s:5:\"width\";s:17:\"field_image_width\";s:6:\"height\";s:18:\"field_image_height\";}}}}}s:12:\"entity_types\";a:0:{}s:12:\"translatable\";s:1:\"0\";s:12:\"foreign keys\";a:1:{s:3:\"fid\";a:2:{s:5:\"table\";s:12:\"file_managed\";s:7:\"columns\";a:1:{s:3:\"fid\";s:3:\"fid\";}}}s:2:\"id\";s:1:\"4\";}',1,0,0),(5,'taxonomy_forums','taxonomy_term_reference','taxonomy',1,'field_sql_storage','field_sql_storage',1,0,'a:7:{s:8:\"settings\";a:2:{s:14:\"allowed_values\";a:1:{i:0;a:2:{s:10:\"vocabulary\";s:6:\"forums\";s:6:\"parent\";i:0;}}s:21:\"options_list_callback\";s:28:\"i18n_taxonomy_allowed_values\";}s:12:\"entity_types\";a:0:{}s:12:\"translatable\";s:1:\"0\";s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:26:\"field_data_taxonomy_forums\";a:1:{s:3:\"tid\";s:19:\"taxonomy_forums_tid\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:30:\"field_revision_taxonomy_forums\";a:1:{s:3:\"tid\";s:19:\"taxonomy_forums_tid\";}}}}}s:12:\"foreign keys\";a:1:{s:3:\"tid\";a:2:{s:5:\"table\";s:18:\"taxonomy_term_data\";s:7:\"columns\";a:1:{s:3:\"tid\";s:3:\"tid\";}}}s:7:\"indexes\";a:1:{s:3:\"tid\";a:1:{i:0;s:3:\"tid\";}}s:2:\"id\";s:1:\"5\";}',1,0,0),(6,'field_vote','fivestar','fivestar',1,'field_sql_storage','field_sql_storage',1,0,'a:7:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:4:\"axis\";s:4:\"vote\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:21:\"field_data_field_vote\";a:2:{s:6:\"rating\";s:17:\"field_vote_rating\";s:6:\"target\";s:17:\"field_vote_target\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:25:\"field_revision_field_vote\";a:2:{s:6:\"rating\";s:17:\"field_vote_rating\";s:6:\"target\";s:17:\"field_vote_target\";}}}}}s:12:\"foreign keys\";a:0:{}s:7:\"indexes\";a:0:{}s:2:\"id\";s:1:\"6\";}',1,0,0),(7,'message_text','text_long','text',1,'field_sql_storage','field_sql_storage',1,1,'a:6:{s:12:\"entity_types\";a:1:{i:0;s:12:\"message_type\";}s:12:\"translatable\";b:1;s:8:\"settings\";a:1:{s:12:\"message_text\";b:1;}s:7:\"storage\";a:4:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";i:1;}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}}',-1,1,0),(8,'field_comment_ref','entityreference','entityreference',1,'field_sql_storage','field_sql_storage',1,0,'a:6:{s:12:\"entity_types\";a:0:{}s:12:\"foreign keys\";a:0:{}s:7:\"indexes\";a:1:{s:9:\"target_id\";a:1:{i:0;s:9:\"target_id\";}}s:8:\"settings\";a:4:{s:7:\"handler\";s:4:\"base\";s:16:\"handler_settings\";a:3:{s:9:\"behaviors\";a:1:{s:17:\"views-select-list\";a:1:{s:6:\"status\";i:0;}}s:4:\"sort\";a:4:{s:9:\"direction\";s:3:\"ASC\";s:5:\"field\";s:18:\"comment_body:value\";s:8:\"property\";s:3:\"nid\";s:4:\"type\";s:4:\"none\";}s:14:\"target_bundles\";a:0:{}}s:14:\"handler_submit\";s:14:\"Change handler\";s:11:\"target_type\";s:7:\"comment\";}s:12:\"translatable\";s:1:\"0\";s:7:\"storage\";a:4:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";i:1;}}',1,0,0),(9,'field_node_ref','entityreference','entityreference',1,'field_sql_storage','field_sql_storage',1,0,'a:6:{s:12:\"entity_types\";a:0:{}s:12:\"foreign keys\";a:0:{}s:7:\"indexes\";a:1:{s:9:\"target_id\";a:1:{i:0;s:9:\"target_id\";}}s:8:\"settings\";a:5:{s:7:\"handler\";s:4:\"base\";s:16:\"handler_settings\";a:3:{s:9:\"behaviors\";a:1:{s:17:\"views-select-list\";a:1:{s:6:\"status\";i:0;}}s:4:\"sort\";a:4:{s:9:\"direction\";s:3:\"ASC\";s:5:\"field\";s:10:\"body:value\";s:8:\"property\";s:3:\"nid\";s:4:\"type\";s:4:\"none\";}s:14:\"target_bundles\";a:0:{}}s:14:\"handler_submit\";s:14:\"Change handler\";s:14:\"target_bundles\";a:0:{}s:11:\"target_type\";s:4:\"node\";}s:12:\"translatable\";s:1:\"0\";s:7:\"storage\";a:4:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";i:1;}}',1,0,0),(10,'field_published','list_boolean','list',1,'field_sql_storage','field_sql_storage',1,0,'a:6:{s:12:\"entity_types\";a:0:{}s:12:\"foreign keys\";a:0:{}s:7:\"indexes\";a:1:{s:5:\"value\";a:1:{i:0;s:5:\"value\";}}s:8:\"settings\";a:2:{s:14:\"allowed_values\";a:2:{i:0;s:11:\"Unpublished\";i:1;s:9:\"Published\";}s:23:\"allowed_values_function\";s:0:\"\";}s:12:\"translatable\";s:1:\"0\";s:7:\"storage\";a:4:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";i:1;}}',1,0,0),(11,'field_section','taxonomy_term_reference','taxonomy',1,'field_sql_storage','field_sql_storage',1,0,'a:7:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:14:\"allowed_values\";a:1:{i:0;a:2:{s:10:\"vocabulary\";s:8:\"sections\";s:6:\"parent\";s:1:\"0\";}}}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:24:\"field_data_field_section\";a:1:{s:3:\"tid\";s:17:\"field_section_tid\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:28:\"field_revision_field_section\";a:1:{s:3:\"tid\";s:17:\"field_section_tid\";}}}}}s:12:\"foreign keys\";a:1:{s:3:\"tid\";a:2:{s:5:\"table\";s:18:\"taxonomy_term_data\";s:7:\"columns\";a:1:{s:3:\"tid\";s:3:\"tid\";}}}s:7:\"indexes\";a:1:{s:3:\"tid\";a:1:{i:0;s:3:\"tid\";}}s:2:\"id\";s:2:\"11\";}',1,0,0),(12,'field_category','taxonomy_term_reference','taxonomy',1,'field_sql_storage','field_sql_storage',1,0,'a:7:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:14:\"allowed_values\";a:1:{i:0;a:2:{s:10:\"vocabulary\";s:10:\"categories\";s:6:\"parent\";s:1:\"0\";}}}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:25:\"field_data_field_category\";a:1:{s:3:\"tid\";s:18:\"field_category_tid\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:29:\"field_revision_field_category\";a:1:{s:3:\"tid\";s:18:\"field_category_tid\";}}}}}s:12:\"foreign keys\";a:1:{s:3:\"tid\";a:2:{s:5:\"table\";s:18:\"taxonomy_term_data\";s:7:\"columns\";a:1:{s:3:\"tid\";s:3:\"tid\";}}}s:7:\"indexes\";a:1:{s:3:\"tid\";a:1:{i:0;s:3:\"tid\";}}s:2:\"id\";s:2:\"12\";}',1,0,0),(13,'field_video_link','video_embed_field','video_embed_field',1,'field_sql_storage','field_sql_storage',1,0,'a:7:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:0:{}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:27:\"field_data_field_video_link\";a:5:{s:9:\"video_url\";s:26:\"field_video_link_video_url\";s:14:\"thumbnail_path\";s:31:\"field_video_link_thumbnail_path\";s:10:\"video_data\";s:27:\"field_video_link_video_data\";s:10:\"embed_code\";s:27:\"field_video_link_embed_code\";s:11:\"description\";s:28:\"field_video_link_description\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:31:\"field_revision_field_video_link\";a:5:{s:9:\"video_url\";s:26:\"field_video_link_video_url\";s:14:\"thumbnail_path\";s:31:\"field_video_link_thumbnail_path\";s:10:\"video_data\";s:27:\"field_video_link_video_data\";s:10:\"embed_code\";s:27:\"field_video_link_embed_code\";s:11:\"description\";s:28:\"field_video_link_description\";}}}}}s:12:\"foreign keys\";a:0:{}s:7:\"indexes\";a:0:{}s:2:\"id\";s:2:\"13\";}',1,0,0),(14,'field_link','link_field','link',1,'field_sql_storage','field_sql_storage',1,0,'a:7:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:7:{s:10:\"attributes\";a:3:{s:6:\"target\";s:7:\"default\";s:5:\"class\";s:0:\"\";s:3:\"rel\";s:0:\"\";}s:3:\"url\";i:0;s:5:\"title\";s:8:\"optional\";s:11:\"title_value\";s:0:\"\";s:15:\"title_maxlength\";i:128;s:13:\"enable_tokens\";i:1;s:7:\"display\";a:1:{s:10:\"url_cutoff\";i:80;}}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:21:\"field_data_field_link\";a:3:{s:3:\"url\";s:14:\"field_link_url\";s:5:\"title\";s:16:\"field_link_title\";s:10:\"attributes\";s:21:\"field_link_attributes\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:25:\"field_revision_field_link\";a:3:{s:3:\"url\";s:14:\"field_link_url\";s:5:\"title\";s:16:\"field_link_title\";s:10:\"attributes\";s:21:\"field_link_attributes\";}}}}}s:12:\"foreign keys\";a:0:{}s:7:\"indexes\";a:0:{}s:2:\"id\";s:2:\"14\";}',1,0,0),(16,'field_extra_content','field_collection','field_collection',1,'field_sql_storage','field_sql_storage',1,0,'a:7:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:2:{s:16:\"hide_blank_items\";i:1;s:4:\"path\";s:0:\"\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:30:\"field_data_field_extra_content\";a:2:{s:5:\"value\";s:25:\"field_extra_content_value\";s:11:\"revision_id\";s:31:\"field_extra_content_revision_id\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:34:\"field_revision_field_extra_content\";a:2:{s:5:\"value\";s:25:\"field_extra_content_value\";s:11:\"revision_id\";s:31:\"field_extra_content_revision_id\";}}}}}s:12:\"foreign keys\";a:0:{}s:7:\"indexes\";a:1:{s:11:\"revision_id\";a:1:{i:0;s:11:\"revision_id\";}}s:2:\"id\";s:2:\"16\";}',-1,0,0),(17,'field_description','text_long','text',1,'field_sql_storage','field_sql_storage',1,0,'a:7:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:0:{}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:28:\"field_data_field_description\";a:2:{s:5:\"value\";s:23:\"field_description_value\";s:6:\"format\";s:24:\"field_description_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:32:\"field_revision_field_description\";a:2:{s:5:\"value\";s:23:\"field_description_value\";s:6:\"format\";s:24:\"field_description_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:2:\"17\";}',1,0,0),(18,'field_detailed_question','text_long','text',1,'field_sql_storage','field_sql_storage',1,0,'a:6:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:0:{}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";i:1;s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:34:\"field_data_field_detailed_question\";a:2:{s:5:\"value\";s:29:\"field_detailed_question_value\";s:6:\"format\";s:30:\"field_detailed_question_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:38:\"field_revision_field_detailed_question\";a:2:{s:5:\"value\";s:29:\"field_detailed_question_value\";s:6:\"format\";s:30:\"field_detailed_question_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}}',1,0,0);
/*!40000 ALTER TABLE `field_config` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `field_config_instance`
--

DROP TABLE IF EXISTS `field_config_instance`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_config_instance` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT 'The primary identifier for a field instance',
  `field_id` int(11) NOT NULL COMMENT 'The identifier of the field attached by this instance',
  `field_name` varchar(32) NOT NULL DEFAULT '',
  `entity_type` varchar(32) NOT NULL DEFAULT '',
  `bundle` varchar(128) NOT NULL DEFAULT '',
  `data` longblob NOT NULL,
  `deleted` tinyint(4) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `field_name_bundle` (`field_name`,`entity_type`,`bundle`),
  KEY `deleted` (`deleted`)
) ENGINE=InnoDB AUTO_INCREMENT=50 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_config_instance`
--

LOCK TABLES `field_config_instance` WRITE;
/*!40000 ALTER TABLE `field_config_instance` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `field_config_instance` VALUES (1,1,'comment_body','comment','comment_node_page','a:6:{s:5:\"label\";s:7:\"Comment\";s:8:\"settings\";a:2:{s:15:\"text_processing\";i:1;s:18:\"user_register_form\";b:0;}s:8:\"required\";b:1;s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";}}s:6:\"widget\";a:4:{s:4:\"type\";s:13:\"text_textarea\";s:8:\"settings\";a:1:{s:4:\"rows\";i:5;}s:6:\"weight\";i:0;s:6:\"module\";s:4:\"text\";}s:11:\"description\";s:0:\"\";}',0),(2,2,'body','node','page','a:6:{s:5:\"label\";s:4:\"Body\";s:6:\"widget\";a:4:{s:4:\"type\";s:26:\"text_textarea_with_summary\";s:8:\"settings\";a:2:{s:4:\"rows\";i:20;s:12:\"summary_rows\";i:5;}s:6:\"weight\";i:-4;s:6:\"module\";s:4:\"text\";}s:8:\"settings\";a:3:{s:15:\"display_summary\";b:1;s:15:\"text_processing\";i:1;s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:0;}s:6:\"teaser\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:23:\"text_summary_or_trimmed\";s:8:\"settings\";a:1:{s:11:\"trim_length\";i:600;}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:0;}}s:8:\"required\";b:0;s:11:\"description\";s:0:\"\";}',0),(3,1,'comment_body','comment','comment_node_article','a:6:{s:5:\"label\";s:7:\"Comment\";s:8:\"settings\";a:2:{s:15:\"text_processing\";i:1;s:18:\"user_register_form\";b:0;}s:8:\"required\";b:1;s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";}}s:6:\"widget\";a:4:{s:4:\"type\";s:13:\"text_textarea\";s:8:\"settings\";a:1:{s:4:\"rows\";i:5;}s:6:\"weight\";i:0;s:6:\"module\";s:4:\"text\";}s:11:\"description\";s:0:\"\";}',0),(4,2,'body','node','article','a:6:{s:5:\"label\";s:4:\"Body\";s:6:\"widget\";a:4:{s:4:\"type\";s:26:\"text_textarea_with_summary\";s:8:\"settings\";a:2:{s:4:\"rows\";i:20;s:12:\"summary_rows\";i:5;}s:6:\"weight\";s:1:\"1\";s:6:\"module\";s:4:\"text\";}s:8:\"settings\";a:3:{s:15:\"display_summary\";b:1;s:15:\"text_processing\";i:1;s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";s:1:\"1\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";}s:6:\"teaser\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:23:\"text_summary_or_trimmed\";s:6:\"weight\";s:1:\"1\";s:8:\"settings\";a:1:{s:11:\"trim_length\";i:600;}s:6:\"module\";s:4:\"text\";}}s:8:\"required\";b:0;s:11:\"description\";s:0:\"\";}',0),(5,3,'field_tags','node','article','a:6:{s:5:\"label\";s:4:\"Tags\";s:11:\"description\";s:63:\"Enter a comma-separated list of words to describe your content.\";s:6:\"widget\";a:4:{s:4:\"type\";s:21:\"taxonomy_autocomplete\";s:6:\"weight\";s:1:\"3\";s:8:\"settings\";a:2:{s:4:\"size\";i:60;s:17:\"autocomplete_path\";s:21:\"taxonomy/autocomplete\";}s:6:\"module\";s:8:\"taxonomy\";}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:28:\"taxonomy_term_reference_link\";s:6:\"weight\";s:1:\"3\";s:8:\"settings\";a:0:{}s:6:\"module\";s:8:\"taxonomy\";}s:6:\"teaser\";a:4:{s:5:\"label\";s:6:\"inline\";s:4:\"type\";s:6:\"hidden\";s:6:\"weight\";s:1:\"2\";s:8:\"settings\";a:0:{}}}s:8:\"settings\";a:1:{s:18:\"user_register_form\";b:0;}s:8:\"required\";b:0;}',0),(6,4,'field_image','node','article','a:6:{s:5:\"label\";s:5:\"Image\";s:11:\"description\";s:40:\"Upload an image to go with this article.\";s:8:\"required\";b:0;s:8:\"settings\";a:9:{s:14:\"file_directory\";s:11:\"field/image\";s:15:\"file_extensions\";s:16:\"png gif jpg jpeg\";s:12:\"max_filesize\";s:0:\"\";s:14:\"max_resolution\";s:0:\"\";s:14:\"min_resolution\";s:0:\"\";s:9:\"alt_field\";b:1;s:11:\"title_field\";s:0:\"\";s:13:\"default_image\";i:0;s:18:\"user_register_form\";b:0;}s:6:\"widget\";a:4:{s:4:\"type\";s:11:\"image_image\";s:8:\"settings\";a:2:{s:18:\"progress_indicator\";s:8:\"throbber\";s:19:\"preview_image_style\";s:9:\"thumbnail\";}s:6:\"weight\";s:1:\"2\";s:6:\"module\";s:5:\"image\";}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:5:\"image\";s:6:\"weight\";s:1:\"0\";s:8:\"settings\";a:2:{s:11:\"image_style\";s:0:\"\";s:10:\"image_link\";s:0:\"\";}s:6:\"module\";s:5:\"image\";}s:6:\"teaser\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:5:\"image\";s:6:\"weight\";s:1:\"0\";s:8:\"settings\";a:2:{s:11:\"image_style\";s:5:\"large\";s:10:\"image_link\";s:7:\"content\";}s:6:\"module\";s:5:\"image\";}}}',0),(7,1,'comment_body','comment','comment_node_blog','a:6:{s:5:\"label\";s:7:\"Comment\";s:8:\"settings\";a:2:{s:15:\"text_processing\";i:1;s:18:\"user_register_form\";b:0;}s:8:\"required\";b:1;s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";}}s:6:\"widget\";a:4:{s:4:\"type\";s:13:\"text_textarea\";s:8:\"settings\";a:1:{s:4:\"rows\";i:5;}s:6:\"weight\";i:0;s:6:\"module\";s:4:\"text\";}s:11:\"description\";s:0:\"\";}',0),(8,2,'body','node','blog','a:6:{s:5:\"label\";s:4:\"Body\";s:6:\"widget\";a:4:{s:4:\"type\";s:26:\"text_textarea_with_summary\";s:8:\"settings\";a:2:{s:4:\"rows\";i:20;s:12:\"summary_rows\";i:5;}s:6:\"weight\";s:1:\"1\";s:6:\"module\";s:4:\"text\";}s:8:\"settings\";a:3:{s:15:\"display_summary\";b:1;s:15:\"text_processing\";i:1;s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";s:1:\"1\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";}s:6:\"teaser\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:23:\"text_summary_or_trimmed\";s:6:\"weight\";s:1:\"2\";s:8:\"settings\";a:1:{s:11:\"trim_length\";s:3:\"500\";}s:6:\"module\";s:4:\"text\";}}s:8:\"required\";b:0;s:11:\"description\";s:0:\"\";}',0),(9,1,'comment_body','comment','comment_node_book','a:6:{s:5:\"label\";s:7:\"Comment\";s:8:\"settings\";a:2:{s:15:\"text_processing\";i:1;s:18:\"user_register_form\";b:0;}s:8:\"required\";b:1;s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";}}s:6:\"widget\";a:4:{s:4:\"type\";s:13:\"text_textarea\";s:8:\"settings\";a:1:{s:4:\"rows\";i:5;}s:6:\"weight\";i:0;s:6:\"module\";s:4:\"text\";}s:11:\"description\";s:0:\"\";}',0),(10,2,'body','node','book','a:6:{s:5:\"label\";s:4:\"Body\";s:6:\"widget\";a:4:{s:4:\"type\";s:26:\"text_textarea_with_summary\";s:8:\"settings\";a:2:{s:4:\"rows\";i:20;s:12:\"summary_rows\";i:5;}s:6:\"weight\";i:-4;s:6:\"module\";s:4:\"text\";}s:8:\"settings\";a:3:{s:15:\"display_summary\";b:1;s:15:\"text_processing\";i:1;s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:0;}s:6:\"teaser\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:23:\"text_summary_or_trimmed\";s:8:\"settings\";a:1:{s:11:\"trim_length\";i:600;}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:0;}}s:8:\"required\";b:0;s:11:\"description\";s:0:\"\";}',0),(11,5,'taxonomy_forums','node','forum','a:6:{s:5:\"label\";s:6:\"Forums\";s:8:\"required\";b:1;s:6:\"widget\";a:4:{s:4:\"type\";s:14:\"options_select\";s:8:\"settings\";a:0:{}s:6:\"weight\";s:1:\"1\";s:6:\"module\";s:7:\"options\";}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:28:\"taxonomy_term_reference_link\";s:6:\"weight\";s:1:\"0\";s:8:\"settings\";a:0:{}s:6:\"module\";s:8:\"taxonomy\";}s:6:\"teaser\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:28:\"taxonomy_term_reference_link\";s:6:\"weight\";s:2:\"10\";s:8:\"settings\";a:0:{}s:6:\"module\";s:8:\"taxonomy\";}}s:8:\"settings\";a:1:{s:18:\"user_register_form\";b:0;}s:11:\"description\";s:0:\"\";}',0),(12,1,'comment_body','comment','comment_node_forum','a:6:{s:5:\"label\";s:7:\"Comment\";s:8:\"settings\";a:2:{s:15:\"text_processing\";i:1;s:18:\"user_register_form\";b:0;}s:8:\"required\";b:1;s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";s:1:\"0\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";}}s:6:\"widget\";a:4:{s:4:\"type\";s:13:\"text_textarea\";s:8:\"settings\";a:1:{s:4:\"rows\";i:5;}s:6:\"weight\";s:1:\"2\";s:6:\"module\";s:4:\"text\";}s:11:\"description\";s:0:\"\";}',0),(13,2,'body','node','forum','a:6:{s:5:\"label\";s:4:\"Body\";s:6:\"widget\";a:4:{s:4:\"type\";s:26:\"text_textarea_with_summary\";s:8:\"settings\";a:2:{s:4:\"rows\";i:20;s:12:\"summary_rows\";i:5;}s:6:\"weight\";s:1:\"2\";s:6:\"module\";s:4:\"text\";}s:8:\"settings\";a:3:{s:15:\"display_summary\";b:1;s:15:\"text_processing\";i:1;s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";s:1:\"1\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";}s:6:\"teaser\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:23:\"text_summary_or_trimmed\";s:6:\"weight\";s:2:\"11\";s:8:\"settings\";a:1:{s:11:\"trim_length\";i:600;}s:6:\"module\";s:4:\"text\";}}s:8:\"required\";b:0;s:11:\"description\";s:0:\"\";}',0),(14,6,'field_vote','node','forum','a:7:{s:5:\"label\";s:4:\"Vote\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"4\";s:4:\"type\";s:7:\"exposed\";s:6:\"module\";s:8:\"fivestar\";s:6:\"active\";i:1;s:8:\"settings\";a:0:{}}s:8:\"settings\";a:6:{s:5:\"stars\";s:1:\"5\";s:11:\"allow_clear\";i:0;s:12:\"allow_revote\";i:0;s:13:\"allow_ownvote\";i:1;s:6:\"target\";s:4:\"none\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:26:\"fivestar_formatter_default\";s:6:\"weight\";s:1:\"3\";s:8:\"settings\";a:4:{s:6:\"widget\";a:1:{s:15:\"fivestar_widget\";s:50:\"sites/all/modules/fivestar/widgets/basic/basic.css\";}s:6:\"expose\";i:1;s:5:\"style\";s:5:\"smart\";s:4:\"text\";s:4:\"dual\";}s:6:\"module\";s:8:\"fivestar\";}s:6:\"teaser\";a:4:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:6:\"hidden\";s:6:\"weight\";s:1:\"0\";s:8:\"settings\";a:0:{}}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;}',0),(15,6,'field_vote','comment','comment_node_forum','a:7:{s:5:\"label\";s:4:\"Vote\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"4\";s:4:\"type\";s:7:\"exposed\";s:6:\"module\";s:8:\"fivestar\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:6:\"widget\";a:1:{s:15:\"fivestar_widget\";s:7:\"default\";}}}s:8:\"settings\";a:6:{s:5:\"stars\";s:1:\"5\";s:11:\"allow_clear\";i:0;s:12:\"allow_revote\";i:0;s:13:\"allow_ownvote\";i:1;s:6:\"target\";s:4:\"none\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:26:\"fivestar_formatter_default\";s:6:\"weight\";s:1:\"2\";s:8:\"settings\";a:4:{s:6:\"widget\";a:1:{s:15:\"fivestar_widget\";s:50:\"sites/all/modules/fivestar/widgets/basic/basic.css\";}s:6:\"expose\";i:1;s:5:\"style\";s:5:\"smart\";s:4:\"text\";s:5:\"smart\";}s:6:\"module\";s:8:\"fivestar\";}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;}',0),(16,7,'message_text','message_type','message_type','a:6:{s:5:\"label\";s:12:\"Message text\";s:11:\"description\";s:46:\"This is the text of all messages of this type.\";s:8:\"required\";b:1;s:8:\"settings\";a:2:{s:15:\"text_processing\";i:1;s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:0;}}s:6:\"widget\";a:4:{s:4:\"type\";s:13:\"text_textarea\";s:8:\"settings\";a:1:{s:4:\"rows\";i:5;}s:6:\"weight\";i:0;s:6:\"module\";s:4:\"text\";}}',0),(17,8,'field_comment_ref','message','example_create_comment','a:8:{s:13:\"default_value\";N;s:22:\"default_value_function\";s:0:\"\";s:11:\"description\";s:0:\"\";s:7:\"display\";a:2:{s:7:\"default\";a:4:{s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:4:\"type\";s:6:\"hidden\";s:6:\"weight\";s:1:\"4\";}s:4:\"full\";a:4:{s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:4:\"type\";s:6:\"hidden\";s:6:\"weight\";s:1:\"2\";}}s:5:\"label\";s:17:\"Comment reference\";s:8:\"required\";i:1;s:8:\"settings\";a:2:{s:9:\"behaviors\";a:1:{s:11:\"prepopulate\";a:4:{s:6:\"action\";s:4:\"hide\";s:8:\"fallback\";s:4:\"none\";s:9:\"skip_perm\";s:26:\"access administration menu\";s:6:\"status\";i:0;}}s:18:\"user_register_form\";b:0;}s:6:\"widget\";a:5:{s:6:\"active\";i:1;s:6:\"module\";s:15:\"entityreference\";s:8:\"settings\";a:3:{s:14:\"match_operator\";s:8:\"CONTAINS\";s:4:\"path\";s:0:\"\";s:4:\"size\";s:2:\"60\";}s:4:\"type\";s:28:\"entityreference_autocomplete\";s:6:\"weight\";s:1:\"1\";}}',0),(18,9,'field_node_ref','message','example_create_comment','a:8:{s:13:\"default_value\";N;s:22:\"default_value_function\";s:0:\"\";s:11:\"description\";s:0:\"\";s:7:\"display\";a:2:{s:7:\"default\";a:4:{s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:4:\"type\";s:6:\"hidden\";s:6:\"weight\";s:1:\"3\";}s:4:\"full\";a:4:{s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:4:\"type\";s:6:\"hidden\";s:6:\"weight\";s:1:\"3\";}}s:5:\"label\";s:14:\"Node reference\";s:8:\"required\";i:1;s:8:\"settings\";a:2:{s:9:\"behaviors\";a:1:{s:11:\"prepopulate\";a:4:{s:6:\"action\";s:4:\"hide\";s:8:\"fallback\";s:4:\"none\";s:9:\"skip_perm\";s:26:\"access administration menu\";s:6:\"status\";i:0;}}s:18:\"user_register_form\";b:0;}s:6:\"widget\";a:5:{s:6:\"active\";i:1;s:6:\"module\";s:15:\"entityreference\";s:8:\"settings\";a:3:{s:14:\"match_operator\";s:8:\"CONTAINS\";s:4:\"path\";s:0:\"\";s:4:\"size\";s:2:\"60\";}s:4:\"type\";s:28:\"entityreference_autocomplete\";s:6:\"weight\";i:0;}}',0),(19,10,'field_published','message','example_create_comment','a:7:{s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";i:0;}}s:11:\"description\";s:0:\"\";s:7:\"display\";a:2:{s:7:\"default\";a:4:{s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:4:\"type\";s:6:\"hidden\";s:6:\"weight\";s:1:\"5\";}s:4:\"full\";a:4:{s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:4:\"type\";s:6:\"hidden\";s:6:\"weight\";s:1:\"4\";}}s:5:\"label\";s:9:\"Published\";s:8:\"required\";i:0;s:8:\"settings\";a:1:{s:18:\"user_register_form\";b:0;}s:6:\"widget\";a:5:{s:6:\"active\";i:1;s:6:\"module\";s:7:\"options\";s:8:\"settings\";a:1:{s:13:\"display_label\";i:0;}s:4:\"type\";s:13:\"options_onoff\";s:6:\"weight\";s:1:\"2\";}}',0),(20,9,'field_node_ref','message','example_create_node','a:8:{s:13:\"default_value\";N;s:22:\"default_value_function\";s:0:\"\";s:11:\"description\";s:0:\"\";s:7:\"display\";a:2:{s:7:\"default\";a:4:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:6:\"hidden\";s:6:\"weight\";s:1:\"2\";s:8:\"settings\";a:0:{}}s:4:\"full\";a:4:{s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:4:\"type\";s:6:\"hidden\";s:6:\"weight\";s:1:\"5\";}}s:5:\"label\";s:14:\"Node reference\";s:8:\"required\";i:1;s:8:\"settings\";a:2:{s:9:\"behaviors\";a:1:{s:11:\"prepopulate\";a:4:{s:6:\"action\";s:4:\"hide\";s:8:\"fallback\";s:4:\"none\";s:9:\"skip_perm\";s:26:\"access administration menu\";s:6:\"status\";i:0;}}s:18:\"user_register_form\";b:0;}s:6:\"widget\";a:5:{s:6:\"active\";i:1;s:6:\"module\";s:15:\"entityreference\";s:8:\"settings\";a:3:{s:14:\"match_operator\";s:8:\"CONTAINS\";s:4:\"path\";s:0:\"\";s:4:\"size\";s:2:\"60\";}s:4:\"type\";s:28:\"entityreference_autocomplete\";s:6:\"weight\";s:1:\"2\";}}',0),(21,10,'field_published','message','example_create_node','a:7:{s:13:\"default_value\";a:1:{i:0;a:1:{s:5:\"value\";i:0;}}s:11:\"description\";s:0:\"\";s:7:\"display\";a:2:{s:7:\"default\";a:4:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:6:\"hidden\";s:6:\"weight\";s:1:\"1\";s:8:\"settings\";a:0:{}}s:4:\"full\";a:4:{s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:4:\"type\";s:6:\"hidden\";s:6:\"weight\";s:1:\"4\";}}s:5:\"label\";s:9:\"Published\";s:8:\"required\";i:0;s:8:\"settings\";a:1:{s:18:\"user_register_form\";b:0;}s:6:\"widget\";a:5:{s:6:\"active\";i:1;s:6:\"module\";s:7:\"options\";s:8:\"settings\";a:1:{s:13:\"display_label\";i:0;}s:4:\"type\";s:13:\"options_onoff\";s:6:\"weight\";s:1:\"3\";}}',0),(22,10,'field_published','message','example_user_register','a:7:{s:13:\"default_value\";N;s:11:\"description\";s:0:\"\";s:7:\"display\";a:2:{s:7:\"default\";a:4:{s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:4:\"type\";s:6:\"hidden\";s:6:\"weight\";s:1:\"1\";}s:4:\"full\";a:4:{s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:4:\"type\";s:6:\"hidden\";s:6:\"weight\";s:1:\"1\";}}s:5:\"label\";s:9:\"Published\";s:8:\"required\";i:0;s:8:\"settings\";a:1:{s:18:\"user_register_form\";b:0;}s:6:\"widget\";a:5:{s:6:\"active\";i:1;s:6:\"module\";s:7:\"options\";s:8:\"settings\";a:0:{}s:4:\"type\";s:15:\"options_buttons\";s:6:\"weight\";s:1:\"2\";}}',0),(23,4,'field_image','node','blog','a:6:{s:5:\"label\";s:5:\"Image\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"2\";s:4:\"type\";s:11:\"image_image\";s:6:\"module\";s:5:\"image\";s:6:\"active\";i:1;s:8:\"settings\";a:2:{s:18:\"progress_indicator\";s:8:\"throbber\";s:19:\"preview_image_style\";s:9:\"thumbnail\";}}s:8:\"settings\";a:9:{s:14:\"file_directory\";s:10:\"field/blog\";s:15:\"file_extensions\";s:16:\"png gif jpg jpeg\";s:12:\"max_filesize\";s:0:\"\";s:14:\"max_resolution\";s:0:\"\";s:14:\"min_resolution\";s:0:\"\";s:9:\"alt_field\";i:0;s:11:\"title_field\";i:0;s:13:\"default_image\";i:0;s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:5:\"image\";s:6:\"weight\";s:1:\"0\";s:8:\"settings\";a:2:{s:11:\"image_style\";s:5:\"large\";s:10:\"image_link\";s:0:\"\";}s:6:\"module\";s:5:\"image\";}s:6:\"teaser\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:5:\"image\";s:6:\"weight\";s:1:\"0\";s:8:\"settings\";a:2:{s:11:\"image_style\";s:5:\"large\";s:10:\"image_link\";s:7:\"content\";}s:6:\"module\";s:5:\"image\";}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";}',0),(24,3,'field_tags','node','blog','a:7:{s:5:\"label\";s:4:\"Tags\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"3\";s:4:\"type\";s:21:\"taxonomy_autocomplete\";s:6:\"module\";s:8:\"taxonomy\";s:6:\"active\";i:0;s:8:\"settings\";a:2:{s:4:\"size\";i:60;s:17:\"autocomplete_path\";s:21:\"taxonomy/autocomplete\";}}s:8:\"settings\";a:1:{s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:28:\"taxonomy_term_reference_link\";s:6:\"weight\";s:1:\"3\";s:8:\"settings\";a:0:{}s:6:\"module\";s:8:\"taxonomy\";}s:6:\"teaser\";a:4:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:6:\"hidden\";s:6:\"weight\";s:1:\"5\";s:8:\"settings\";a:0:{}}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;}',0),(25,6,'field_vote','node','blog','a:7:{s:5:\"label\";s:4:\"Vote\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"4\";s:4:\"type\";s:7:\"exposed\";s:6:\"module\";s:8:\"fivestar\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:6:\"widget\";a:1:{s:15:\"fivestar_widget\";s:7:\"default\";}}}s:8:\"settings\";a:6:{s:5:\"stars\";s:1:\"5\";s:11:\"allow_clear\";i:0;s:12:\"allow_revote\";i:0;s:13:\"allow_ownvote\";i:1;s:6:\"target\";s:4:\"none\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:26:\"fivestar_formatter_default\";s:6:\"weight\";s:1:\"4\";s:8:\"settings\";a:4:{s:6:\"widget\";a:1:{s:15:\"fivestar_widget\";s:50:\"sites/all/modules/fivestar/widgets/basic/basic.css\";}s:6:\"expose\";i:1;s:5:\"style\";s:7:\"average\";s:4:\"text\";s:7:\"average\";}s:6:\"module\";s:8:\"fivestar\";}s:6:\"teaser\";a:4:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:6:\"hidden\";s:6:\"weight\";s:1:\"4\";s:8:\"settings\";a:0:{}}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;}',0),(26,11,'field_section','node','article','a:7:{s:5:\"label\";s:7:\"Section\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"5\";s:4:\"type\";s:14:\"options_select\";s:6:\"module\";s:7:\"options\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:12:\"apply_chosen\";s:0:\"\";}}s:8:\"settings\";a:1:{s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:4:{s:5:\"label\";s:6:\"inline\";s:4:\"type\";s:6:\"hidden\";s:6:\"weight\";s:1:\"4\";s:8:\"settings\";a:0:{}}s:6:\"teaser\";a:4:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:6:\"hidden\";s:6:\"weight\";s:1:\"4\";s:8:\"settings\";a:0:{}}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;}',0),(27,12,'field_category','node','article','a:6:{s:5:\"label\";s:8:\"Category\";s:6:\"widget\";a:4:{s:4:\"type\";s:14:\"options_select\";s:6:\"weight\";s:1:\"6\";s:8:\"settings\";a:3:{s:4:\"size\";i:60;s:17:\"autocomplete_path\";s:21:\"taxonomy/autocomplete\";s:12:\"apply_chosen\";s:0:\"\";}s:6:\"module\";s:7:\"options\";}s:8:\"settings\";a:1:{s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:4:{s:5:\"label\";s:6:\"inline\";s:4:\"type\";s:6:\"hidden\";s:6:\"weight\";s:1:\"5\";s:8:\"settings\";a:0:{}}s:6:\"teaser\";a:4:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:6:\"hidden\";s:6:\"weight\";s:1:\"3\";s:8:\"settings\";a:0:{}}}s:8:\"required\";b:0;s:11:\"description\";s:0:\"\";}',0),(28,1,'comment_body','comment','comment_node_faq','a:6:{s:5:\"label\";s:7:\"Comment\";s:8:\"settings\";a:2:{s:15:\"text_processing\";i:1;s:18:\"user_register_form\";b:0;}s:8:\"required\";b:1;s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";}}s:6:\"widget\";a:4:{s:4:\"type\";s:13:\"text_textarea\";s:8:\"settings\";a:1:{s:4:\"rows\";i:5;}s:6:\"weight\";i:0;s:6:\"module\";s:4:\"text\";}s:11:\"description\";s:0:\"\";}',0),(29,2,'body','node','faq','a:7:{s:5:\"label\";s:4:\"Body\";s:6:\"widget\";a:4:{s:4:\"type\";s:26:\"text_textarea_with_summary\";s:8:\"settings\";a:2:{s:4:\"rows\";i:20;s:12:\"summary_rows\";i:5;}s:6:\"weight\";i:32;s:6:\"module\";s:4:\"text\";}s:8:\"settings\";a:3:{s:15:\"display_summary\";b:1;s:15:\"text_processing\";i:1;s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:1;}s:6:\"teaser\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:23:\"text_summary_or_trimmed\";s:8:\"settings\";a:1:{s:11:\"trim_length\";i:600;}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:1;}}s:8:\"required\";b:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;}',0),(30,1,'comment_body','comment','comment_node_video','a:6:{s:5:\"label\";s:7:\"Comment\";s:8:\"settings\";a:2:{s:15:\"text_processing\";i:1;s:18:\"user_register_form\";b:0;}s:8:\"required\";b:1;s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";}}s:6:\"widget\";a:4:{s:4:\"type\";s:13:\"text_textarea\";s:8:\"settings\";a:1:{s:4:\"rows\";i:5;}s:6:\"weight\";i:0;s:6:\"module\";s:4:\"text\";}s:11:\"description\";s:0:\"\";}',0),(31,2,'body','node','video','a:6:{s:5:\"label\";s:4:\"Body\";s:6:\"widget\";a:4:{s:4:\"type\";s:26:\"text_textarea_with_summary\";s:8:\"settings\";a:2:{s:4:\"rows\";i:20;s:12:\"summary_rows\";i:5;}s:6:\"weight\";s:1:\"2\";s:6:\"module\";s:4:\"text\";}s:8:\"settings\";a:3:{s:15:\"display_summary\";b:1;s:15:\"text_processing\";i:1;s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";s:1:\"1\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";}s:6:\"teaser\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:23:\"text_summary_or_trimmed\";s:6:\"weight\";s:1:\"1\";s:8:\"settings\";a:1:{s:11:\"trim_length\";i:600;}s:6:\"module\";s:4:\"text\";}}s:8:\"required\";b:0;s:11:\"description\";s:0:\"\";}',0),(32,3,'field_tags','node','video','a:7:{s:5:\"label\";s:4:\"Tags\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"4\";s:4:\"type\";s:21:\"taxonomy_autocomplete\";s:6:\"module\";s:8:\"taxonomy\";s:6:\"active\";i:0;s:8:\"settings\";a:2:{s:4:\"size\";i:60;s:17:\"autocomplete_path\";s:21:\"taxonomy/autocomplete\";}}s:8:\"settings\";a:1:{s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"inline\";s:4:\"type\";s:33:\"i18n_taxonomy_term_reference_link\";s:6:\"weight\";s:1:\"2\";s:8:\"settings\";a:0:{}s:6:\"module\";s:13:\"i18n_taxonomy\";}s:6:\"teaser\";a:4:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:6:\"hidden\";s:6:\"weight\";s:1:\"2\";s:8:\"settings\";a:0:{}}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;}',0),(33,13,'field_video_link','node','video','a:7:{s:5:\"label\";s:10:\"Video Link\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"3\";s:4:\"type\";s:23:\"video_embed_field_video\";s:6:\"module\";s:17:\"video_embed_field\";s:6:\"active\";i:0;s:8:\"settings\";a:0:{}}s:8:\"settings\";a:4:{s:17:\"description_field\";i:0;s:18:\"description_length\";s:3:\"128\";s:18:\"user_register_form\";b:0;s:17:\"allowed_providers\";a:2:{i:0;s:7:\"youtube\";i:1;s:5:\"vimeo\";}}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:17:\"video_embed_field\";s:6:\"weight\";s:1:\"0\";s:8:\"settings\";a:3:{s:11:\"video_style\";s:5:\"large\";s:11:\"description\";i:1;s:20:\"description_position\";s:6:\"bottom\";}s:6:\"module\";s:17:\"video_embed_field\";}s:6:\"teaser\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:17:\"video_embed_field\";s:6:\"weight\";s:1:\"0\";s:8:\"settings\";a:3:{s:11:\"video_style\";s:5:\"large\";s:11:\"description\";i:1;s:20:\"description_position\";s:6:\"bottom\";}s:6:\"module\";s:17:\"video_embed_field\";}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;}',0),(34,1,'comment_body','comment','comment_node_webform','a:6:{s:5:\"label\";s:7:\"Comment\";s:8:\"settings\";a:2:{s:15:\"text_processing\";i:1;s:18:\"user_register_form\";b:0;}s:8:\"required\";b:1;s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";}}s:6:\"widget\";a:4:{s:4:\"type\";s:13:\"text_textarea\";s:8:\"settings\";a:1:{s:4:\"rows\";i:5;}s:6:\"weight\";i:0;s:6:\"module\";s:4:\"text\";}s:11:\"description\";s:0:\"\";}',0),(35,2,'body','node','webform','a:6:{s:5:\"label\";s:4:\"Body\";s:6:\"widget\";a:4:{s:4:\"type\";s:26:\"text_textarea_with_summary\";s:8:\"settings\";a:2:{s:4:\"rows\";i:20;s:12:\"summary_rows\";i:5;}s:6:\"weight\";i:31;s:6:\"module\";s:4:\"text\";}s:8:\"settings\";a:3:{s:15:\"display_summary\";b:1;s:15:\"text_processing\";i:1;s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";s:1:\"1\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";}s:6:\"teaser\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:23:\"text_summary_or_trimmed\";s:8:\"settings\";a:1:{s:11:\"trim_length\";i:600;}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:0;}}s:8:\"required\";b:0;s:11:\"description\";s:0:\"\";}',0),(36,1,'comment_body','comment','comment_node_products','a:6:{s:5:\"label\";s:7:\"Comment\";s:8:\"settings\";a:2:{s:15:\"text_processing\";i:1;s:18:\"user_register_form\";b:0;}s:8:\"required\";b:1;s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";}}s:6:\"widget\";a:4:{s:4:\"type\";s:13:\"text_textarea\";s:8:\"settings\";a:1:{s:4:\"rows\";i:5;}s:6:\"weight\";i:0;s:6:\"module\";s:4:\"text\";}s:11:\"description\";s:0:\"\";}',0),(37,2,'body','node','products','a:6:{s:5:\"label\";s:4:\"Body\";s:6:\"widget\";a:4:{s:4:\"type\";s:26:\"text_textarea_with_summary\";s:8:\"settings\";a:2:{s:4:\"rows\";i:20;s:12:\"summary_rows\";i:5;}s:6:\"weight\";s:2:\"31\";s:6:\"module\";s:4:\"text\";}s:8:\"settings\";a:3:{s:15:\"display_summary\";b:1;s:15:\"text_processing\";i:1;s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:0;}s:6:\"teaser\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:23:\"text_summary_or_trimmed\";s:8:\"settings\";a:1:{s:11:\"trim_length\";i:600;}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:0;}}s:8:\"required\";b:0;s:11:\"description\";s:0:\"\";}',0),(38,4,'field_image','node','products','a:6:{s:5:\"label\";s:5:\"Image\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"33\";s:4:\"type\";s:11:\"image_image\";s:6:\"module\";s:5:\"image\";s:6:\"active\";i:1;s:8:\"settings\";a:2:{s:18:\"progress_indicator\";s:8:\"throbber\";s:19:\"preview_image_style\";s:9:\"thumbnail\";}}s:8:\"settings\";a:9:{s:14:\"file_directory\";s:13:\"field/product\";s:15:\"file_extensions\";s:16:\"png gif jpg jpeg\";s:12:\"max_filesize\";s:0:\"\";s:14:\"max_resolution\";s:0:\"\";s:14:\"min_resolution\";s:0:\"\";s:9:\"alt_field\";i:0;s:11:\"title_field\";i:0;s:13:\"default_image\";i:0;s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:5:\"image\";s:8:\"settings\";a:2:{s:11:\"image_style\";s:0:\"\";s:10:\"image_link\";s:0:\"\";}s:6:\"module\";s:5:\"image\";s:6:\"weight\";i:1;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";}',0),(39,14,'field_link','node','products','a:7:{s:5:\"label\";s:4:\"Link\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"34\";s:4:\"type\";s:10:\"link_field\";s:6:\"module\";s:4:\"link\";s:6:\"active\";i:0;s:8:\"settings\";a:0:{}}s:8:\"settings\";a:10:{s:12:\"validate_url\";i:1;s:3:\"url\";i:0;s:5:\"title\";s:8:\"optional\";s:11:\"title_value\";s:0:\"\";s:15:\"title_maxlength\";s:3:\"128\";s:13:\"enable_tokens\";i:1;s:7:\"display\";a:1:{s:10:\"url_cutoff\";s:2:\"80\";}s:10:\"attributes\";a:5:{s:6:\"target\";s:7:\"default\";s:3:\"rel\";s:0:\"\";s:5:\"class\";s:0:\"\";s:18:\"configurable_title\";i:0;s:5:\"title\";s:0:\"\";}s:10:\"rel_remove\";s:7:\"default\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"link_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"link\";s:6:\"weight\";i:2;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;}',0),(43,16,'field_extra_content','node','blog','a:7:{s:5:\"label\";s:13:\"Extra content\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"6\";s:4:\"type\";s:22:\"field_collection_embed\";s:6:\"module\";s:16:\"field_collection\";s:6:\"active\";i:0;s:8:\"settings\";a:0:{}}s:8:\"settings\";a:1:{s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:21:\"field_collection_view\";s:6:\"weight\";s:1:\"2\";s:8:\"settings\";a:5:{s:4:\"edit\";s:4:\"Edit\";s:6:\"delete\";s:6:\"Delete\";s:3:\"add\";s:3:\"Add\";s:11:\"description\";b:1;s:9:\"view_mode\";s:4:\"full\";}s:6:\"module\";s:16:\"field_collection\";}s:6:\"teaser\";a:4:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:6:\"hidden\";s:6:\"weight\";s:1:\"3\";s:8:\"settings\";a:0:{}}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;}',0),(44,4,'field_image','field_collection_item','field_extra_content','a:6:{s:5:\"label\";s:5:\"Image\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"0\";s:4:\"type\";s:11:\"image_image\";s:6:\"module\";s:5:\"image\";s:6:\"active\";i:1;s:8:\"settings\";a:2:{s:18:\"progress_indicator\";s:8:\"throbber\";s:19:\"preview_image_style\";s:9:\"thumbnail\";}}s:8:\"settings\";a:9:{s:14:\"file_directory\";s:16:\"field/collection\";s:15:\"file_extensions\";s:16:\"png gif jpg jpeg\";s:12:\"max_filesize\";s:0:\"\";s:14:\"max_resolution\";s:0:\"\";s:14:\"min_resolution\";s:0:\"\";s:9:\"alt_field\";i:0;s:11:\"title_field\";i:0;s:13:\"default_image\";i:0;s:18:\"user_register_form\";b:0;}s:7:\"display\";a:3:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:5:\"image\";s:6:\"weight\";s:1:\"0\";s:8:\"settings\";a:2:{s:11:\"image_style\";s:0:\"\";s:10:\"image_link\";s:0:\"\";}s:6:\"module\";s:5:\"image\";}s:4:\"full\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:5:\"image\";s:6:\"weight\";s:1:\"0\";s:8:\"settings\";a:2:{s:11:\"image_style\";s:0:\"\";s:10:\"image_link\";s:0:\"\";}s:6:\"module\";s:5:\"image\";}s:5:\"token\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:5:\"image\";s:6:\"weight\";s:1:\"0\";s:8:\"settings\";a:2:{s:11:\"image_style\";s:0:\"\";s:10:\"image_link\";s:0:\"\";}s:6:\"module\";s:5:\"image\";}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";}',0),(45,17,'field_description','field_collection_item','field_extra_content','a:7:{s:5:\"label\";s:11:\"Description\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"2\";s:4:\"type\";s:13:\"text_textarea\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"rows\";s:1:\"5\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:3:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";s:1:\"2\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";}s:4:\"full\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";s:1:\"2\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";}s:5:\"token\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";s:1:\"2\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;}',0),(46,16,'field_extra_content','node','article','a:7:{s:5:\"label\";s:13:\"Extra content\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"8\";s:4:\"type\";s:22:\"field_collection_embed\";s:6:\"module\";s:16:\"field_collection\";s:6:\"active\";i:0;s:8:\"settings\";a:0:{}}s:8:\"settings\";a:1:{s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:21:\"field_collection_view\";s:6:\"weight\";s:1:\"2\";s:8:\"settings\";a:5:{s:4:\"edit\";s:4:\"Edit\";s:6:\"delete\";s:6:\"Delete\";s:3:\"add\";s:3:\"Add\";s:11:\"description\";b:1;s:9:\"view_mode\";s:4:\"full\";}s:6:\"module\";s:16:\"field_collection\";}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;}',0),(47,16,'field_extra_content','node','forum','a:7:{s:5:\"label\";s:13:\"Extra content\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"3\";s:4:\"type\";s:22:\"field_collection_embed\";s:6:\"module\";s:16:\"field_collection\";s:6:\"active\";i:0;s:8:\"settings\";a:0:{}}s:8:\"settings\";a:1:{s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:21:\"field_collection_view\";s:6:\"weight\";s:1:\"2\";s:8:\"settings\";a:5:{s:4:\"edit\";s:4:\"Edit\";s:6:\"delete\";s:6:\"Delete\";s:3:\"add\";s:3:\"Add\";s:11:\"description\";b:1;s:9:\"view_mode\";s:4:\"full\";}s:6:\"module\";s:16:\"field_collection\";}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;}',0),(48,13,'field_video_link','field_collection_item','field_extra_content','a:7:{s:5:\"label\";s:10:\"Video Link\";s:6:\"widget\";a:5:{s:6:\"weight\";s:1:\"1\";s:4:\"type\";s:23:\"video_embed_field_video\";s:6:\"module\";s:17:\"video_embed_field\";s:6:\"active\";i:0;s:8:\"settings\";a:0:{}}s:8:\"settings\";a:4:{s:17:\"description_field\";i:0;s:18:\"description_length\";s:3:\"128\";s:18:\"user_register_form\";b:0;s:17:\"allowed_providers\";a:2:{i:0;s:7:\"youtube\";i:1;s:5:\"vimeo\";}}s:7:\"display\";a:3:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:17:\"video_embed_field\";s:6:\"weight\";s:1:\"1\";s:8:\"settings\";a:3:{s:11:\"video_style\";s:5:\"large\";s:11:\"description\";i:1;s:20:\"description_position\";s:6:\"bottom\";}s:6:\"module\";s:17:\"video_embed_field\";}s:4:\"full\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:17:\"video_embed_field\";s:6:\"weight\";s:1:\"1\";s:8:\"settings\";a:3:{s:11:\"video_style\";s:5:\"large\";s:11:\"description\";i:1;s:20:\"description_position\";s:6:\"bottom\";}s:6:\"module\";s:17:\"video_embed_field\";}s:5:\"token\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:17:\"video_embed_field\";s:6:\"weight\";s:1:\"1\";s:8:\"settings\";a:3:{s:11:\"video_style\";s:5:\"large\";s:11:\"description\";i:1;s:20:\"description_position\";s:6:\"bottom\";}s:6:\"module\";s:17:\"video_embed_field\";}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;}',0),(49,18,'field_detailed_question','node','faq','a:7:{s:5:\"label\";s:17:\"Detailed question\";s:6:\"widget\";a:5:{s:6:\"weight\";i:31;s:4:\"type\";s:13:\"text_textarea\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"rows\";s:1:\"5\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"1\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";}s:6:\"teaser\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";}}s:8:\"required\";i:0;s:11:\"description\";s:32:\"Enter the detailed question text\";s:13:\"default_value\";N;}',0);
/*!40000 ALTER TABLE `field_config_instance` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `field_data_body`
--

DROP TABLE IF EXISTS `field_data_body`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_body` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `body_value` longtext,
  `body_summary` longtext,
  `body_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `body_format` (`body_format`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Data storage for field 2 (body)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_body`
--

LOCK TABLES `field_data_body` WRITE;
/*!40000 ALTER TABLE `field_data_body` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `field_data_body` VALUES ('node','forum',0,1,1,'und',0,'I\'m not a Drupal developer but a pro Drupal site builder. I can read PHP and able to tweak and even write some code. I was thinking about learning the development but came across this idea that in D8 we have symphony and some other big changes. Now the question is that shall I start learning D8 dev or I should start with D7 dev?','','filtered_html'),('node','page',0,2,2,'und',0,'\r\n\r\nAt vero eos et accusam et justo duo dolores et ea rebum. Stet clita kasd gubergren, no sea takimata sanctus est Lorem ipsum dolor sit amet. Stet clita kasd gubergren, no sea takimata sanctus est Lorem ipsum dolor sit amet. Stet clita kasd gubergren, no sea takimata sanctus est Lorem ipsum dolor sit amet. Excepteur sint obcaecat cupiditat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum.\r\n\r\nUt wisi enim ad minim veniam, quis nostrud exerci tation ullamcorper suscipit lobortis nisl ut aliquip ex ea commodo consequat. Lorem ipsum dolor sit amet, consectetur adipisici elit, sed eiusmod tempor incidunt ut labore et dolore magna aliqua. Duis autem vel eum iriure dolor in hendrerit in vulputate velit esse molestie consequat, vel illum dolore eu feugiat nulla facilisis at vero eros et accumsan et iusto odio dignissim qui blandit praesent luptatum zzril delenit augue duis dolore te feugait nulla facilisi. Stet clita kasd gubergren, no sea takimata sanctus est Lorem ipsum dolor sit amet. Lorem ipsum dolor sit amet, consetetur sadipscing elitr, sed diam nonumy eirmod tempor invidunt ut labore et dolore magna aliquyam erat, sed diam voluptua.\r\n\r\nLorem ipsum dolor sit amet, consectetuer adipiscing elit, sed diam nonummy nibh euismod tincidunt ut laoreet dolore magna aliquam erat volutpat. Lorem ipsum dolor sit amet. Stet clita kasd gubergren, no sea takimata sanctus est Lorem ipsum dolor sit amet. Stet clita kasd gubergren, no sea takimata sanctus est Lorem ipsum dolor sit amet. Stet clita kasd gubergren, no sea takimata sanctus est Lorem ipsum dolor sit amet.\r\n\r\nStet clita kasd gubergren, no sea takimata sanctus est Lorem ipsum dolor sit amet. At vero eos et accusam et justo duo dolores et ea rebum. Duis autem vel eum iriure dolor in hendrerit in vulputate velit esse molestie consequat, vel illum dolore eu feugiat nulla facilisis. At vero eos et accusam et justo duo dolores et ea rebum. Lorem ipsum dolor sit amet, consectetuer adipiscing elit, sed diam nonummy nibh euismod tincidunt ut laoreet dolore magna aliquam erat volutpat.\r\n\r\nDuis autem vel eum iriure dolor in hendrerit in vulputate velit esse molestie consequat, vel illum dolore eu feugiat nulla facilisis.. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquid ex ea commodi consequat. Lorem ipsum dolor sit amet. Ut wisi enim ad minim veniam, quis nostrud exerci tation ullamcorper suscipit lobortis nisl ut aliquip ex ea commodo consequat.\r\n','','filtered_html'),('node','forum',0,3,3,'und',0,'<p>Excepteur sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum. Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium, totam rem aperiam, eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo.</p>\r\n<p>Nulla facilisi. Cras convallis vel lectus sed convallis. Duis nec accumsan diam. Vestibulum blandit tempus nulla. Suspendisse consectetur cursus elit, et scelerisque ligula hendrerit id. Maecenas ultrices porta nunc, quis consectetur risus. Morbi non metus eget nibh vulputate tincidunt. Nullam dui quam, suscipit a ligula a, posuere sagittis magna. Pellentesque vitae dolor et nunc lobortis vestibulum. Suspendisse potenti. Pellentesque cursus purus vitae libero hendrerit congue. Aenean erat elit, aliquet at mi quis, sollicitudin sollicitudin libero.</p>\r\n<blockquote>\r\n<p>Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium, totam rem aperiam, eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo.</p>\r\n</blockquote>\r\n<h1>h1. Heading 1</h1>\r\n<p>Sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum. Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium, totam rem aperiam, eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo.</p>\r\n<ul>\r\n<li>Nemo enim ipsam voluptatem quia voluptas sit aspernatur aut odit aut fugit</li>\r\n<li>Sed ut perspiciatis unde omnis iste natus error </li>\r\n<li>Qui dolorem ipsum quia dolor sit amet, consectetur, adipisci velit</li>\r\n</ul>\r\n<h2>h2. Heading 2</h2>\r\n<p>Sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum. Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium, totam rem aperiam, eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo.</p>\r\n<h3>h3. Heading 3</h3>\r\n<p>Sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum. Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium, totam rem aperiam, eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo.</p>','','filtered_html'),('node','article',0,4,4,'und',0,'<p>Praesent ut ligula non mi varius sagittis. Curabitur nisi. Phasellus leo dolor, tempus non, auctor et, hendrerit quis, nisi. Curabitur at lacus ac velit ornare lobortis. Fusce fermentum. Nunc sed turpis.</p>\r\n\r\n<p>Praesent ut ligula non mi varius sagittis. Curabitur nisi. Phasellus leo dolor, tempus non, auctor et, hendrerit quis, nisi. Curabitur at lacus ac velit ornare lobortis. Proin convallis pretium lacus, et rhoncus ipsum mollis eget.</p>\r\n\r\n<p>Proin convallis pretium lacus, et rhoncus ipsum mollis eget. Mauris pulvinar leo non magna blandit, sed viverra neque euismod. Vestibulum bibendum pretium nibh consequat tincidunt. Suspendisse consequat tortor nisi, eget dictum orci vulputate vel. Morbi ultrices condimentum lacus, semper venenatis leo ultrices sit amet. Ut et tincidunt purus, non venenatis nibh. Etiam congue quam metus, feugiat fringilla nunc congue nec. Donec ut condimentum justo. Nam ut leo et nisl consequat commodo.</p>\r\n\r\n<blockquote>\r\n<p>Donec lobortis nisi vel erat posuere porttitor. Interdum et malesuada fames ac ante ipsum primis in faucibus. Curabitur venenatis massa sit amet mi mollis sollicitudin. Duis ut purus tincidunt, lobortis tortor a, porttitor erat. Quisque suscipit mi eu euismod egestas. Cras quis porta augue. Morbi porttitor cursus eros. Fusce aliquam vel lorem ut dignissim. Fusce commodo nisl et arcu aliquam, nec accumsan purus dictum. In commodo eleifend justo, eu sagittis libero laoreet in.</p>\r\n<footer>Someone famous in <cite title=\"Source Title\">Source Title</cite></footer>\r\n</blockquote>\r\n\r\n<h1>h1. Heading 1</h1>\r\n<p>Sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum. Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium, totam rem aperiam, eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo.</p>\r\n<ul>\r\n<li>Nemo enim ipsam voluptatem quia voluptas sit aspernatur aut odit aut fugit</li>\r\n<li>Sed ut perspiciatis unde omnis iste natus error </li>\r\n<li>Qui dolorem ipsum quia dolor sit amet, consectetur, adipisci velit</li>\r\n</ul>\r\n<h2>h2. Heading 2</h2>\r\n<p>Sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum. Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium, totam rem aperiam, eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo.</p>\r\n<h3>h3. Heading 3</h3>\r\n<p>Sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum. Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium, totam rem aperiam, eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo.</p>','','filtered_html'),('node','article',0,5,5,'und',0,'<p>Praesent ut ligula non mi varius sagittis. Curabitur nisi. Phasellus leo dolor, tempus non, auctor et, hendrerit quis, nisi. Curabitur at lacus ac velit ornare lobortis. Fusce fermentum. Nunc sed turpis.</p>\r\n\r\n<p>Praesent ut ligula non mi varius sagittis. Curabitur nisi. Phasellus leo dolor, tempus non, auctor et, hendrerit quis, nisi. Curabitur at lacus ac velit ornare lobortis. Proin convallis pretium lacus, et rhoncus ipsum mollis eget.</p>\r\n\r\n<p>Proin convallis pretium lacus, et rhoncus ipsum mollis eget. Mauris pulvinar leo non magna blandit, sed viverra neque euismod. Vestibulum bibendum pretium nibh consequat tincidunt. Suspendisse consequat tortor nisi, eget dictum orci vulputate vel. Morbi ultrices condimentum lacus, semper venenatis leo ultrices sit amet. Ut et tincidunt purus, non venenatis nibh. Etiam congue quam metus, feugiat fringilla nunc congue nec. Donec ut condimentum justo. Nam ut leo et nisl consequat commodo.</p>\r\n\r\n<blockquote>\r\n<p>Donec lobortis nisi vel erat posuere porttitor. Interdum et malesuada fames ac ante ipsum primis in faucibus. Curabitur venenatis massa sit amet mi mollis sollicitudin. Duis ut purus tincidunt, lobortis tortor a, porttitor erat. Quisque suscipit mi eu euismod egestas. Cras quis porta augue. Morbi porttitor cursus eros. Fusce aliquam vel lorem ut dignissim. Fusce commodo nisl et arcu aliquam, nec accumsan purus dictum. In commodo eleifend justo, eu sagittis libero laoreet in.</p>\r\n<footer>Someone famous in <cite title=\"Source Title\">Source Title</cite></footer>\r\n</blockquote>\r\n\r\n<h1>h1. Heading 1</h1>\r\n<p>Sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum. Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium, totam rem aperiam, eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo.</p>\r\n<ul>\r\n<li>Nemo enim ipsam voluptatem quia voluptas sit aspernatur aut odit aut fugit</li>\r\n<li>Sed ut perspiciatis unde omnis iste natus error </li>\r\n<li>Qui dolorem ipsum quia dolor sit amet, consectetur, adipisci velit</li>\r\n</ul>\r\n<h2>h2. Heading 2</h2>\r\n<p>Sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum. Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium, totam rem aperiam, eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo.</p>\r\n<h3>h3. Heading 3</h3>\r\n<p>Sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum. Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium, totam rem aperiam, eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo.</p>','','filtered_html'),('node','article',0,6,6,'und',0,'<p>Praesent ut ligula non mi varius sagittis. Curabitur nisi. Phasellus leo dolor, tempus non, auctor et, hendrerit quis, nisi. Curabitur at lacus ac velit ornare lobortis. Fusce fermentum. Nunc sed turpis.</p>\r\n\r\n<p>Praesent ut ligula non mi varius sagittis. Curabitur nisi. Phasellus leo dolor, tempus non, auctor et, hendrerit quis, nisi. Curabitur at lacus ac velit ornare lobortis. Proin convallis pretium lacus, et rhoncus ipsum mollis eget.</p>\r\n\r\n<p>Proin convallis pretium lacus, et rhoncus ipsum mollis eget. Mauris pulvinar leo non magna blandit, sed viverra neque euismod. Vestibulum bibendum pretium nibh consequat tincidunt. Suspendisse consequat tortor nisi, eget dictum orci vulputate vel. Morbi ultrices condimentum lacus, semper venenatis leo ultrices sit amet. Ut et tincidunt purus, non venenatis nibh. Etiam congue quam metus, feugiat fringilla nunc congue nec. Donec ut condimentum justo. Nam ut leo et nisl consequat commodo.</p>\r\n\r\n<blockquote>\r\n<p>Donec lobortis nisi vel erat posuere porttitor. Interdum et malesuada fames ac ante ipsum primis in faucibus. Curabitur venenatis massa sit amet mi mollis sollicitudin. Duis ut purus tincidunt, lobortis tortor a, porttitor erat. Quisque suscipit mi eu euismod egestas. Cras quis porta augue. Morbi porttitor cursus eros. Fusce aliquam vel lorem ut dignissim. Fusce commodo nisl et arcu aliquam, nec accumsan purus dictum. In commodo eleifend justo, eu sagittis libero laoreet in.</p>\r\n<footer>Someone famous in <cite title=\"Source Title\">Source Title</cite></footer>\r\n</blockquote>\r\n\r\n<h1>h1. Heading 1</h1>\r\n<p>Sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum. Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium, totam rem aperiam, eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo.</p>\r\n<ul>\r\n<li>Nemo enim ipsam voluptatem quia voluptas sit aspernatur aut odit aut fugit</li>\r\n<li>Sed ut perspiciatis unde omnis iste natus error </li>\r\n<li>Qui dolorem ipsum quia dolor sit amet, consectetur, adipisci velit</li>\r\n</ul>\r\n<h2>h2. Heading 2</h2>\r\n<p>Sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum. Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium, totam rem aperiam, eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo.</p>\r\n<h3>h3. Heading 3</h3>\r\n<p>Sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum. Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium, totam rem aperiam, eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo.</p>','','filtered_html'),('node','blog',0,7,7,'und',0,'<p>Excepteur sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum. Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium, totam rem aperiam, eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo.</p>\r\n<p>Nulla facilisi. Cras convallis vel lectus sed convallis. Duis nec accumsan diam. Vestibulum blandit tempus nulla. Suspendisse consectetur cursus elit, et scelerisque ligula hendrerit id. Maecenas ultrices porta nunc, quis consectetur risus. Morbi non metus eget nibh vulputate tincidunt. Nullam dui quam, suscipit a ligula a, posuere sagittis magna. Pellentesque vitae dolor et nunc lobortis vestibulum. Suspendisse potenti. Pellentesque cursus purus vitae libero hendrerit congue. Aenean erat elit, aliquet at mi quis, sollicitudin sollicitudin libero.</p>\r\n<blockquote>\r\n<p>Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium, totam rem aperiam, eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo.</p>\r\n</blockquote>\r\n<h1>h1. Heading 1</h1>\r\n<p>Sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum. Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium, totam rem aperiam, eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo.</p>\r\n<ul>\r\n<li>Nemo enim ipsam voluptatem quia voluptas sit aspernatur aut odit aut fugit</li>\r\n<li>Sed ut perspiciatis unde omnis iste natus error </li>\r\n<li>Qui dolorem ipsum quia dolor sit amet, consectetur, adipisci velit</li>\r\n</ul>\r\n<h2>h2. Heading 2</h2>\r\n<p>Sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum. Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium, totam rem aperiam, eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo.</p>\r\n<h3>h3. Heading 3</h3>\r\n<p>Sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum. Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium, totam rem aperiam, eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo.</p>','','full_html'),('node','blog',0,8,8,'und',0,'<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Pellentesque eget dolor sit amet lorem vulputate aliquet. Praesent eu dignissim turpis. Duis volutpat gravida tincidunt. Vivamus sodales ligula in accumsan accumsan. Nunc adipiscing posuere ultricies. Class aptent taciti sociosqu ad litora torquent per conubia nostra, per inceptos himenaeos. Praesent vehicula justo id nunc facilisis volutpat porttitor id eros.</p>\r\n\r\n<p>Ut aliquet sodales purus, in pretium risus consequat id. Proin convallis pretium lacus, et rhoncus ipsum mollis eget. Mauris pulvinar leo non magna blandit, sed viverra neque euismod. Vestibulum bibendum pretium nibh consequat tincidunt. Suspendisse consequat tortor nisi, eget dictum orci vulputate vel. Morbi ultrices condimentum lacus, semper venenatis leo ultrices sit amet. Ut et tincidunt purus, non venenatis nibh. Etiam congue quam metus, feugiat fringilla nunc congue nec. Donec ut condimentum justo. Nam ut leo et nisl consequat commodo. Nullam tempus rutrum massa, eu ullamcorper turpis dapibus at. Vestibulum feugiat ligula eu nibh vehicula varius.</p>\r\n\r\n<blockquote class=\"blockquote-reverse\">\r\n<p>Donec lobortis nisi vel erat posuere porttitor. Interdum et malesuada fames ac ante ipsum primis in faucibus. Curabitur venenatis massa sit amet mi mollis sollicitudin. Duis ut purus tincidunt, lobortis tortor a, porttitor erat. Quisque suscipit mi eu euismod egestas. Cras quis porta augue. Morbi porttitor cursus eros. Fusce aliquam vel lorem ut dignissim. Fusce commodo nisl et arcu aliquam, nec accumsan purus dictum. In commodo eleifend justo, eu sagittis libero laoreet in.</p>\r\n<footer>Someone famous in <cite title=\"Source Title\">Source Title</cite></footer>\r\n</blockquote>\r\n\r\n<p>Aliquam elementum turpis eget felis eleifend, id sodales dui ultrices. Fusce rhoncus, libero sed consectetur commodo, arcu nisl malesuada sem, commodo facilisis risus diam eu sapien. Aenean iaculis, urna id ultrices lacinia, lacus lectus commodo neque, vel tincidunt lectus quam ac tellus. Sed interdum mattis neque, nec rhoncus lorem laoreet ornare. Vestibulum dignissim, libero non convallis pulvinar, leo lectus dignissim risus, ac consequat metus purus sed nisi. Aliquam erat volutpat. Vivamus elementum feugiat orci. Nam vitae elementum risus, porta luctus tortor. Proin luctus tristique massa. Phasellus volutpat id leo sed facilisis. Vestibulum accumsan libero eu arcu malesuada luctus.</p>\r\n\r\n<h2>h2. Heading 2</h2>\r\n<p>Sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum. Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium, totam rem aperiam, eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo.</p>\r\n<h3>h3. Heading 3</h3>\r\n<p>Sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum. Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium, totam rem aperiam, eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo.</p>','','full_html'),('node','blog',0,9,9,'und',0,'<p>Excepteur sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum. Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium, totam rem aperiam, eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo.</p>\r\n<p>Nulla facilisi. Cras convallis vel lectus sed convallis. Duis nec accumsan diam. Vestibulum blandit tempus nulla. Suspendisse consectetur cursus elit, et scelerisque ligula hendrerit id. Maecenas ultrices porta nunc, quis consectetur risus. Morbi non metus eget nibh vulputate tincidunt. Nullam dui quam, suscipit a ligula a, posuere sagittis magna. Pellentesque vitae dolor et nunc lobortis vestibulum. Suspendisse potenti. Pellentesque cursus purus vitae libero hendrerit congue. Aenean erat elit, aliquet at mi quis, sollicitudin sollicitudin libero.</p>\r\n<blockquote>\r\n<p>Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium, totam rem aperiam, eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo.</p>\r\n</blockquote>\r\n<h1>h1. Heading 1</h1>\r\n<p>Sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum. Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium, totam rem aperiam, eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo.</p>\r\n<ul>\r\n<li>Nemo enim ipsam voluptatem quia voluptas sit aspernatur aut odit aut fugit</li>\r\n<li>Sed ut perspiciatis unde omnis iste natus error </li>\r\n<li>Qui dolorem ipsum quia dolor sit amet, consectetur, adipisci velit</li>\r\n</ul>\r\n<h2>h2. Heading 2</h2>\r\n<p>Sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum. Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium, totam rem aperiam, eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo.</p>\r\n<h3>h3. Heading 3</h3>\r\n<p>Sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum. Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium, totam rem aperiam, eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo.</p>','','full_html'),('node','blog',0,10,10,'und',0,'Praesent ac massa at ligula laoreet iaculis. Etiam imperdiet imperdiet orci. Pellentesque libero tortor, tincidunt et, tincidunt eget, semper nec, quam. Phasellus magna. Phasellus gravida semper nisi. Donec interdum, metus et hendrerit aliquet, dolor diam sagittis ligula, eget egestas libero turpis vel mi. Etiam vitae tortor. Suspendisse feugiat. Nulla consequat massa quis enim. Pellentesque egestas, neque sit amet convallis pulvinar, justo nulla eleifend augue, ac auctor orci leo non est. Donec pede justo, fringilla vel, aliquet nec, vulputate eget, arcu. Aenean viverra rhoncus pede. Sed consequat, leo eget bibendum sodales, augue velit cursus nunc, quis gravida magna mi a libero. Praesent egestas tristique nibh. Sed aliquam ultrices mauris.\r\n\r\nSed libero. Cras non dolor. Proin faucibus arcu quis ante. Donec interdum, metus et hendrerit aliquet, dolor diam sagittis ligula, eget egestas libero turpis vel mi. Donec pede justo, fringilla vel, aliquet nec, vulputate eget, arcu. Proin viverra, ligula sit amet ultrices semper, ligula arcu tristique sapien, a accumsan nisi mauris ac eros. Morbi nec metus. Proin pretium, leo ac pellentesque mollis, felis nunc ultrices eros, sed gravida augue augue mollis justo. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus. Maecenas egestas arcu quis ligula mattis placerat.','','filtered_html'),('node','blog',0,11,11,'und',0,'Donec mi odio, faucibus at, scelerisque quis, convallis in, nisi. Cras id dui. Phasellus volutpat, metus eget egestas mollis, lacus lacus blandit dui, id egestas quam mauris ut lacus. Integer ante arcu, accumsan a, consectetuer eget, posuere ut, mauris. Maecenas vestibulum mollis diam. Nam quam nunc, blandit vel, luctus pulvinar, hendrerit id, lorem. In ut quam vitae odio lacinia tincidunt. Donec vitae sapien ut libero venenatis faucibus. Class aptent taciti sociosqu ad litora torquent per conubia nostra, per inceptos hymenaeos. Etiam ultricies nisi vel augue. Praesent adipiscing. Proin faucibus arcu quis ante. Etiam ultricies nisi vel augue. Fusce pharetra convallis urna. Vestibulum eu odio.\r\n\r\nNunc nulla. Maecenas vestibulum mollis diam. Vestibulum dapibus nunc ac augue. Nulla consequat massa quis enim. Donec vitae orci sed dolor rutrum auctor. Maecenas vestibulum mollis diam. Nam at tortor in tellus interdum sagittis. Aenean tellus metus, bibendum sed, posuere ac, mattis non, nunc. Fusce vulputate eleifend sapien. Nullam tincidunt adipiscing enim.\r\n\r\nDonec mi odio, faucibus at, scelerisque quis, convallis in, nisi. Cras id dui. Phasellus volutpat, metus eget egestas mollis, lacus lacus blandit dui, id egestas quam mauris ut lacus. Integer ante arcu, accumsan a, consectetuer eget, posuere ut, mauris. Maecenas vestibulum mollis diam. Nam quam nunc, blandit vel, luctus pulvinar, hendrerit id, lorem. In ut quam vitae odio lacinia tincidunt. Donec vitae sapien ut libero venenatis faucibus. Class aptent taciti sociosqu ad litora torquent per conubia nostra, per inceptos hymenaeos. Etiam ultricies nisi vel augue. Praesent adipiscing. Proin faucibus arcu quis ante. Etiam ultricies nisi vel augue. Fusce pharetra convallis urna. Vestibulum eu odio.\r\n\r\nNunc nulla. Maecenas vestibulum mollis diam. Vestibulum dapibus nunc ac augue. Nulla consequat massa quis enim. Donec vitae orci sed dolor rutrum auctor. Maecenas vestibulum mollis diam. Nam at tortor in tellus interdum sagittis. Aenean tellus metus, bibendum sed, posuere ac, mattis non, nunc. Fusce vulputate eleifend sapien. Nullam tincidunt adipiscing enim.','','filtered_html'),('node','article',0,12,12,'und',0,'<p>Praesent ut ligula non mi varius sagittis. Curabitur nisi. Phasellus leo dolor, tempus non, auctor et, hendrerit quis, nisi. Curabitur at lacus ac velit ornare lobortis. Fusce fermentum. Nunc sed turpis.</p>\r\n\r\n<p>Praesent ut ligula non mi varius sagittis. Curabitur nisi. Phasellus leo dolor, tempus non, auctor et, hendrerit quis, nisi. Curabitur at lacus ac velit ornare lobortis. Proin convallis pretium lacus, et rhoncus ipsum mollis eget.</p>\r\n\r\n<p>Proin convallis pretium lacus, et rhoncus ipsum mollis eget. Mauris pulvinar leo non magna blandit, sed viverra neque euismod. Vestibulum bibendum pretium nibh consequat tincidunt. Suspendisse consequat tortor nisi, eget dictum orci vulputate vel. Morbi ultrices condimentum lacus, semper venenatis leo ultrices sit amet. Ut et tincidunt purus, non venenatis nibh. Etiam congue quam metus, feugiat fringilla nunc congue nec. Donec ut condimentum justo. Nam ut leo et nisl consequat commodo.</p>\r\n\r\n<blockquote>\r\n<p>Donec lobortis nisi vel erat posuere porttitor. Interdum et malesuada fames ac ante ipsum primis in faucibus. Curabitur venenatis massa sit amet mi mollis sollicitudin. Duis ut purus tincidunt, lobortis tortor a, porttitor erat. Quisque suscipit mi eu euismod egestas. Cras quis porta augue. Morbi porttitor cursus eros. Fusce aliquam vel lorem ut dignissim. Fusce commodo nisl et arcu aliquam, nec accumsan purus dictum. In commodo eleifend justo, eu sagittis libero laoreet in.</p>\r\n<footer>Someone famous in <cite title=\"Source Title\">Source Title</cite></footer>\r\n</blockquote>\r\n\r\n<h1>h1. Heading 1</h1>\r\n<p>Sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum. Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium, totam rem aperiam, eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo.</p>\r\n<ul>\r\n<li>Nemo enim ipsam voluptatem quia voluptas sit aspernatur aut odit aut fugit</li>\r\n<li>Sed ut perspiciatis unde omnis iste natus error </li>\r\n<li>Qui dolorem ipsum quia dolor sit amet, consectetur, adipisci velit</li>\r\n</ul>\r\n<h2>h2. Heading 2</h2>\r\n<p>Sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum. Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium, totam rem aperiam, eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo.</p>\r\n<h3>h3. Heading 3</h3>\r\n<p>Sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum. Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium, totam rem aperiam, eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo.</p>','','filtered_html'),('node','faq',0,13,13,'und',0,'Ut tincidunt tincidunt erat. Praesent ac massa at ligula laoreet iaculis. Donec pede justo, fringilla vel, aliquet nec, vulputate eget, arcu. Nunc nec neque. Ut varius tincidunt libero. Phasellus volutpat, metus eget egestas mollis, lacus lacus blandit dui, id egestas quam mauris ut lacus. Praesent ut ligula non mi varius sagittis. Quisque rutrum. Maecenas tempus, tellus eget condimentum rhoncus, sem quam semper libero, sit amet adipiscing sem neque sed ipsum. Proin faucibus arcu quis ante. Nunc nonummy metus. Praesent metus tellus, elementum eu, semper a, adipiscing nec, purus.. Morbi nec metus. Cras sagittis. Suspendisse nisl elit, rhoncus eget, elementum ac, condimentum eget, diam. Morbi nec metus. Suspendisse faucibus, nunc et pellentesque egestas, lacus ante convallis tellus, vitae iaculis lacus elit id tortor. Sed augue ipsum, egestas nec, vestibulum et, malesuada adipiscing, dui. Proin sapien ipsum, porta a, auctor quis, euismod ut, mi. Curabitur at lacus ac velit ornare lobortis. Etiam iaculis nunc ac metus. Proin sapien ipsum, porta a, auctor quis, euismod ut, mi. Sed hendrerit. Sed consequat, leo eget bibendum sodales, augue velit cursus nunc, quis gravida magna mi a libero.','','filtered_html'),('node','faq',0,14,14,'und',0,'Duis vel nibh at velit scelerisque suscipit. Nulla consequat massa quis enim. Etiam sit amet orci eget eros faucibus tincidunt. Class aptent taciti sociosqu ad litora torquent per conubia nostra, per inceptos hymenaeos. Etiam feugiat lorem non metus. Nunc egestas, augue at pellentesque laoreet, felis eros vehicula leo, at malesuada velit leo quis pede. Ut tincidunt tincidunt erat. Mauris sollicitudin fermentum libero. Morbi ac felis. Nam adipiscing. Etiam ultricies nisi vel augue. Phasellus tempus. Maecenas vestibulum mollis diam. Fusce egestas elit eget lorem. Vestibulum purus quam, scelerisque ut, mollis sed, nonummy id, metus. Nullam dictum felis eu pede mollis pretium. Suspendisse enim turpis, dictum sed, iaculis a, condimentum nec, nisi. Phasellus dolor. Nullam dictum felis eu pede mollis pretium. Nulla neque dolor, sagittis eget, iaculis quis, molestie non, velit. Vestibulum rutrum, mi nec elementum vehicula, eros quam gravida nisl, id fringilla neque ante vel mi.. Nullam quis ante. Suspendisse pulvinar, augue ac venenatis condimentum, sem libero volutpat nibh, nec pellentesque velit pede quis nunc. Pellentesque posuere.','','filtered_html'),('node','forum',0,15,15,'und',0,'We offer 4 main services: community contribution, premium themes, web design & development and web maintenance & support. Find more details about us on our homepage: and our About page','','filtered_html'),('node','forum',0,16,16,'und',0,'Drupal 6 extended support announcement\r\n\r\nOn February 13, 2008, Drupal 6 was released. The policy of the community is to support only the current and previous stable versions. (When Drupal 6 was released, Drupal 4.7.x was marked unsupported. When Drupal 7 came out, Drupal 5.x was marked unsupported.) This policy was created to prevent core and module maintainers from having to maintain more than 2 active major versions of Drupal.\r\n\r\nWith the coming Drupal 8 release, this policy has been questioned. We want to ensure that sites that wish to move from Drupal 6 to Drupal 8 have a supported window within which to do so. The Drupal core team, key module maintainers, and representatives of the Drupal security team met at Drupalcon Austin to discuss this as an in-person follow up to the previous discussion at https://drupal.org/node/2136029.\r\n\r\nDrupal 6 core and modules will transition to unsupported status three months after Drupal 8 is released. \"Unsupported status\" means the community will not be providing support or patches in the same way we do now. Continuing to support Drupal 6 would be difficult for many reasons, including a lack of automated test coverage, the requirement for rigorous manual release testing, the slow-down it introduces in the release of security fixes for the vast majority of Drupal users (on version 7+), and the general shift of volunteers in the community moving their attention onto Drupal 8 development.\r\n\r\nThis gives Drupal 6 users a few options:\r\n\r\n1) Upgrade to Drupal 7 any time between now and 3 months after Drupal 8.0.0 is released. Drupal 7 releases undergo almost 40,000 automated tests, and Drupal 7 will be fully supported at least until Drupal 9 comes out. Given the past history, the release of Drupal 9 is likely to be around 2018.\r\n\r\n2) Upgrade to Drupal 8 after it is released, but before Drupal 6 is not supported anymore. Fortunately, Migrate support for Drupal 6 to Drupal 8 is already in core, and there is Migrate UI, a contributed module. While not all contributed modules will be ready at the time Drupal 8 is released, Drupal 8\'s migration path handles most of the critical site data via its CCK to Entities/Fields in Core migrations.\r\n\r\n3) Find an organization that will provide extended support for Drupal 6. The Drupal Security Team will provide a method for companies and/or individuals to work together in the private security issue queue to continue developing updates, and will provide a reasonable amount of time for companies to provide patches to Drupal 6 security issues that also affect Drupal 7 or Drupal 8. The security team will coordinate access to issues for companies wishing to provide extended support for Drupal 6. However, the team will not explicitly review or test the patches (some team members may do this on their own). All code created by these vendors, would be released to the community.\r\n\r\nOrganizations and individuals interested in providing this level of support for their customers\r\nAND who have the technical knowledge to maintain a Drupal core release should go to the security team Drupal 6 long term support page.\r\n\r\nBoth the Security Team and Drupal core leadership feel that a 3-month window after Drupal 8\'s release before eclipsing community support for Drupal 6 is a workable compromise between leaving Drupal 6 sites on an unsupported version the second Drupal 8 comes out, and acknowledging that our community\'s volunteer resources are limited and have shifted focus. We hope that organizations that rely on Drupal 6 will step up to help maintain it after community support winds down, and/or help their clients update to D8.','','filtered_html'),('node','forum',0,17,17,'und',0,'<p>Excepteur sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum. Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium, totam rem aperiam, eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo.</p>\r\n\r\n<p>Nulla facilisi. Cras convallis vel lectus sed convallis. Duis nec accumsan diam. Vestibulum blandit tempus nulla. Suspendisse consectetur cursus elit, et scelerisque ligula hendrerit id. Maecenas ultrices porta nunc, quis consectetur risus. Morbi non metus eget nibh vulputate tincidunt. Nullam dui quam, suscipit a ligula a, posuere sagittis magna. Pellentesque vitae dolor et nunc lobortis vestibulum. Suspendisse potenti. Pellentesque cursus purus vitae libero hendrerit congue. Aenean erat elit, aliquet at mi quis, sollicitudin sollicitudin libero.</p>\r\n\r\n<blockquote>\r\n<p>Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium, totam rem aperiam, eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo.</p>\r\n</blockquote>\r\n\r\n<h1>h1. Heading 1</h1>\r\n\r\n<p>Sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum. Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium, totam rem aperiam, eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo.</p>\r\n\r\n<ul>\r\n	<li>Nemo enim ipsam voluptatem quia voluptas sit aspernatur aut odit aut fugit</li>\r\n	<li>Sed ut perspiciatis unde omnis iste natus error</li>\r\n	<li>Qui dolorem ipsum quia dolor sit amet, consectetur, adipisci velit</li>\r\n</ul>\r\n\r\n<h2>h2. Heading 2</h2>\r\n\r\n<p>Sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum. Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium, totam rem aperiam, eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo.</p>\r\n\r\n<h3>h3. Heading 3</h3>\r\n\r\n<p>Sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum. Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium, totam rem aperiam, eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo.</p>\r\n','','filtered_html'),('node','forum',0,18,18,'und',0,'The Hosting section is managed by the Drupal Association. Learn how to get listed on the hosting page or other advertising opportunities on Advertising on Drupal.org page on the Drupal Association website.\r\n\r\nHosting companies may also be listed in the Services section of the Marketplace. Learn how to get listed in the Services section of the Marketplace on the Marketplace guidelines.','','filtered_html'),('node','forum',0,19,19,'und',0,'<div class=\"field field-name-body field-type-text-with-summary field-label-hidden\"><div class=\"field-items\"><div class=\"field-item even\"><h3>ATTENTION</h3>\r\n<p><strong>This page does not yet reflect new changes to Drush that apparently make Composer a prerequisite to Drush installation in the newer branches. I don\'t have time to explore this right now. If you have the knowledge, please update this page to reflect that, then remove this message. In the meantime, users of this page can still install older versions of Drush using this method.</strong></p>\r\n<p><strong>Some instructions on installing Composer can be found in the <a href=\"#comment-8798219\" rel=\"nofollow\">comments</a></strong>.</p>\r\n<ol><li>If you don\'t already have shell access, request access to SSH for your shared hosting account (e.g. for Hostmonster or Green Geeks: open a new support ticket with Tech Support (<strong>UPDATE:</strong> Shell access can now be enabled from cPanel for some hostmonster hosting accounts). For other Hosting services you may need to upgrade to use SSH.)</li>\r\n<li><a name=\"2\" rel=\"nofollow\" id=\"2\"></a>Once you have received SSH access to your site, open a new Terminal and login to your site by typing the following <code>ssh username@yourdomain.com</code> or any additional user login string provided by your Hosting service</li>\r\n<li>Enter your password when prompted</li>\r\n<li>By default, you should be in your home directory (~). If you are not in your home directory, navigate yourself there by using the <code>cd ~</code> (cd = change directory command). The <code>\'~\'</code> is an alias for your home directory. On Hostmonster--and nearly every other Linux shared hosting situation--your website directory is located at <strong>~/public_html</strong>, or more specifically <strong>/www/htdocs/username</strong>.</li>\r\n<li>Confirm you are in your home directory by typing the bash shell command <code>ls</code>, which will list the files and folders in the current directory. On Hostmonster, you should see <code>public_html/</code>, <code>public_ftp</code>, and a bunch of other files. Make special note of a file named <code>.bashrc</code>, as we will be editing it later.</li>\r\n<li>Download Drush by typing <code>wget https://github.com/drush-ops/drush/archive/6.x.zip</code> (At the time of this edit, the Drush 6 branch is the recommended version and is no longer available for download on drupal.org). Extract the .zip file by typing in <code>unzip 6.x</code> and remove zip file by typing <code>rm 6.x.zip.</code><br>\r\n*Tip: type <code>clear</code> and hit enter. This will clear your screen, and give you a little more breathing room. Do this as much as you want to throughout this process<br><strong>**Important:</strong> If your host\'s configuration does not allow for the <code>wget</code> command, you may alternately download the zip file of the recommended branch (currently <a href=\"https://github.com/drush-ops/drush/tree/6.x\">https://github.com/drush-ops/drush/tree/6.x</a>) and manually upload and extract via the host\'s cPanel File Manager, or an ftp program of your choice.</li>\r\n<li>Type <code>ls</code> again, to list your directory. You should now see <code>drush/</code> in the directory (if the directory is drush-6.x, rename to drush with <a href=\"http://unixhelp.ed.ac.uk/tasks/mv2.html\" title=\"mv command help\" rel=\"nofollow\"><code>mv</code> command</a>).</li>\r\n<li>Type <code>chmod u+x drush</code> to set the correct permissions on the drush command.<br>\r\n*Tip: Type <code>ls -la</code> to see the permissions and owners on the items in the directory.</li>\r\n<li>Next, in order to use Drush across our installation&amp;emdash;in all of our sub-folders&amp;emdash;we need to add a line to our <code>.bashrc</code> file. While still in your home directory, type the following: <code>nano .bashrc</code>. This will open up <code>.bashrc</code> in a text editor named <code>nano</code>.<br>\r\n*note:  For GoDaddy accounts there is no nano application  (for new cPanel accounts nano is available). Use VIM instead. So type <code>vim .bashrc</code> to edit the file. A good VIM cheatsheet is: <a href=\"http://www.fprintf.net/vimCheatSheet.html\" rel=\"nofollow\">http://www.fprintf.net/vimCheatSheet.html</a>]<br>\r\nLocate <code># User specific aliases and functions</code>. Underneath that, add the following: <code>alias drush=\"~/drush/drush\"</code>. Save the file by typing <code>ctrl+X</code> (Exit) and type <code>y</code> to accept your changes.</li>\r\n<li>Type <code>source ~/.bashrc</code> to refresh the alias list and allow the new drush commands to work.</li>\r\n<li>Confirm that Drush is working by typing <code>drush</code> at the command prompt and hitting <code>enter</code>. You should see a list of drush commands. If you do, then <code>success!</code></li>\r\n<li>If the previous step doesn\'t work, type <code>exit</code> to end your SSH session, then log back in (See <a href=\"#2\" rel=\"nofollow\">step 2</a>) to restart your session. This refreshes <code>.bashrc</code> and allows the new drush commands to work. Some hosting providers such as <strong>GoDaddy</strong> (legacy accounts) use <strong>php-cgi</strong> in the command line instead of <strong>php-cli</strong>. The former is not compatible with Drush and if this is your case you have to locate <strong>php-cli</strong> and then add the following lines to your ~/.bashrc or ~/.bash-profile file:<br><div class=\"codeblock\"><code>export COLUMNS<br>alias drush=\'/usr/local/php5/bin/php ~/drush/drush.php\'<br>alias php=\'/usr/local/php5/bin/php\'</code></div>\r\n</li>\r\n<li>You have now added drush hot sauce to your shared host. Awesome!</li>\r\n</ol><p>Once again, this should work on <em>any</em> shared hosting Linux platforms that allow shell access. On Hostmonster or Green Geeks, you have to specifically ask them to turn it on. If you do not have a <code>.bashrc</code> file in your home directory, try making it by typing <code>touch .bashrc</code>. You can also try using a file named .profile, .bash_aliases or .bash_profile, depending on your server\'s setup.</p>\r\n<h4>SSH config</h4>\r\n<p>Since you\'ll be using the ssh login prompt a lot, you might consider creating a local alias for your login credentials. Follow this link for <a href=\"http://nerderati.com/2011/03/simplify-your-life-with-an-ssh-config-file/\" rel=\"nofollow\">detailed instructions</a>. Note that in a Drush site-alias configuration you would use the host name configured in this file as <code>remote-host</code> and no <code>remote-user</code>.</p>\r\n<h3>Editorial Comments</h3>\r\n<p>For all those who didn\'t really understand the instructions and are just trying to follow it as it is written, here\'s a bit of advice: <em>only</em> use Drush if you start to understand it, even a little bit. Shell commands and Drush commands are very powerful and not recommended for learning on production sites or sites with a live server deadline, because you can mess things up very quickly. Your Shared Hosting support won\'t be happy if you create code loops through failure. </p>\r\n<p><strong>Another bit of advice: If you are not a full-time developer, you should always use the stable non-beta releases of Drush, and should never use the additional -y command to avoid the security question \"are you sure you want ... ? y/n.</strong></p>\r\n<p>To put it another way: Read the instructions twice, understand what the commands mean and what they do, don\'t rely solely on copy/paste. In the long run, you will save your self time--which is the whole point of Drush in the first place.</p>\r\n<p>Let\'s take the <em>alias</em> command as an example; you can exchange the <em>.bashrc alias</em> line with something else like  <em><strong><code>alias ddd=\'~/drush/drush\'</code></strong> </em>  instead of <em><strong><code>alias drush=\'~/drush/drush\'</code></strong></em>. This actually changes the way you use the Drush command later. Your commands will start with <em>ddd [your command]</em> then, instead of <em>drush [your command]</em>. And you can also add other aliases of course, like: <em> <strong><code>alias dddl=\'~drush/drush en\'</code></strong> </em>, which simplifies thee often-used Drush \'en\' command from <em><strong><code>drush dl</code></strong></em> to <em> <strong><code>dddl</code></strong></em>. In short, it is well worth your time (and safer) to go ahead and <em>learn</em> how to properly use Bash commands, if you plan on using Drush.</p>\r\n<p>The <a href=\"http://www.drush.ws\" title=\"Drush\" rel=\"nofollow\">Drush Documentation</a> is a great place to start. It will teach you about Drush commands, and how to use them.</p>\r\n</div></div></div>','','filtered_html'),('node','forum',0,20,20,'und',0,'<div class=\"field field-name-body field-type-text-with-summary field-label-hidden\"><div class=\"field-items\"><div class=\"field-item even\"><p>Note: this page should not be edited without first discussing the changes in a <a href=\"/node/add/project-issue/drupal\">Drupal Core issue</a> as the requirements for each version of Drupal are decided upon by the Drupal Core developers.</p>\r\n<p>To install and run Drupal your web server must meet certain minimum requirements. Most web hosting companies meet these requirements. However, a few stand out by also actively supporting the Drupal community. If you need hosting, consider selecting one of <a href=\"http://drupal.org/hosting\">these web hosts</a>.</p>\r\n<h2>Disk space</h2>\r\n<p>A minimum installation requires 15 Megabytes. 60 MB is needed for a website with many contributed modules and themes installed. Keep in mind you need much more for the database, files uploaded by the users, media, backups and other files.</p>\r\n<h2>Web server</h2>\r\n<p>Apache, Nginx, or Microsoft IIS<br><a href=\"/requirements/webserver\">More details about web server requirements.</a></p>\r\n<h2>Database</h2>\r\n<p>Drupal 6: MySQL 4.1 or higher, PostgreSQL 7.1,<br>\r\nDrupal 7: MySQL 5.0.15 or higher with PDO, PostgreSQL 8.3 or higher with PDO, SQLite 3.3.7 or higher<br>\r\nDrupal 8: MySQL 5.0.15/MariaDB/Percona/equivalent or higher with PDO and an InnoDB-compatible primary storage engine, PostgreSQL 8.3 or higher with PDO, SQLite 3.3.7 or higher </p>\r\n<p><a href=\"/project/sqlsrv\">Microsoft SQL Server</a> and <a href=\"/project/oracle\">Oracle</a> are supported by additional modules.<br><a href=\"/requirements/database\">More details about database requirements.</a></p>\r\n<h2>PHP</h2>\r\n<p>Drupal 6: PHP 5.2.x only. Warning: support for PHP 4.x has been dropped. PHP 5.3 and later may produce errors or unexpected behaviour.<br>\r\nDrupal 7: PHP 5.2.5 or higher (5.3 recommended).<br>\r\nDrupal 8: PHP 5.4 or higher.<br><a href=\"/requirements/php\">More details about PHP requirements,</a> including <a href=\"https://www.drupal.org/requirements/php#memory\">PHP memory</a>.</p>\r\n<p>See also the <a href=\"http://drupal.org/node/627252\">Site Performance section</a> of the Administration Guide and the <a href=\"/node/34022\">webhosting troubleshooting FAQ</a>.</p>\r\n</div></div></div>','','filtered_html'),('node','forum',0,21,21,'und',0,'<div class=\"field-item even\"><p>Drupal works on any <a href=\"http://en.wikipedia.org/wiki/Webserver\" rel=\"nofollow\">web server</a> with PHP support.</p>\r\n<h3>Apache (Recommended)</h3>\r\n<p><a href=\"http://httpd.apache.org/\" rel=\"nofollow\">Apache</a> is the most commonly used web server for Drupal. Drupal will work on Apache 2.x hosted on UNIX/Linux, OS X, or Windows. </p>\r\n<p>The majority of Drupal development and deployment is done on Apache, so there is more community experience and testing performed on Apache than on other web servers. Drupal 7 and 6 will likely work on Apache 1.3.</p>\r\n<p>You can use the Apache \'mod_rewrite\' extension to <a href=\"/getting-started/clean-urls\" rel=\"nofollow\">allow for clean URLs</a>.</p>\r\n<p>The Apache Virtualhost configuration must contain the directive <code>AllowOverride All</code> to allow Drupal\'s .htaccess file to be used.</p>\r\n<h3>Nginx</h3>\r\n<p><a href=\"http://www.nginx.com/\" rel=\"nofollow\">Nginx</a> is a commonly used web server that focuses on high concurrency, performance and low memory usage.</p>\r\n<p>Drupal will work on Nginx legacy versions (0.7.x, 0.8.x, 1.0.x, 1.2.x), stable 1.4.x versions, and mainline 1.5.x versions hosted on UNIX/Linux, OS X, or Windows. Nginx is a popular alternative to Apache, so there is also significant community experience and testing performed on Nginx.</p>\r\n<p>For information on enabling clean URLs, see <a href=\"/node/976392\" rel=\"nofollow\">Clean URLs with NGINX</a>.</p>\r\n<h3>Hiawatha</h3>\r\n<p><a href=\"https://www.hiawatha-webserver.org/\" rel=\"nofollow\">Hiawatha</a> is a web server with a strong focus on security. It also aims at being easy to use and being lightweight. Research performed by independent researchers proves that Hiawatha offers a performance comparable to other web servers under <a href=\"http://www.saltwaterc.ro/wp-download/documents/PHP_web_serving_study.pdf\" rel=\"nofollow\">normal conditions</a>, but much better <a href=\"https://www.hiawatha-webserver.org/weblog/64\" rel=\"nofollow\">while under attack</a>.</p>\r\n<p>Hiawatha is fully compatible with Drupal. For information about the required URL rewriting rules to use Drupal with Hiawatha, read <a href=\"/node/2275833\" rel=\"nofollow\">Clean URLs with Hiawatha</a>.</p>\r\n<h3>Microsoft IIS</h3>\r\n<p><a href=\"http://www.microsoft.com/iis\" rel=\"nofollow\">Microsoft IIS</a> is a web server and set of feature extension modules for use with Microsoft Windows.</p>\r\n<p>Drupal core will work with IIS 5, IIS 6, or IIS 7 if PHP is configured correctly.</p>\r\n<p>To achieve clean URLs you may need to use a third party product. For IIS 7 you can use the Microsoft URL Rewrite Module or a third party solution.</p>\r\n<p>On IIS 7 Drupal requires <a href=\"http://technet.microsoft.com/en-us/windowsserver/dd262148.aspx\" rel=\"nofollow\">Windows 2008 Server SP2</a> or later for fastCGI  support.</p>\r\n</div>','','filtered_html'),('node','forum',0,22,22,'und',0,'<div class=\"field-item even\"><p><strong>Recommended: </strong><a href=\"http://www.mysql.com/\" rel=\"nofollow\">MySQL</a> (or an equivalent such as <a href=\"http://mariadb.org/\" rel=\"nofollow\">MariaDB</a> or <a href=\"http://www.percona.com/software/percona-server\" rel=\"nofollow\">Percona Server</a>)</p>\r\n<h3>MySQL</h3>\r\n<ul><li>Drupal 6 supports MySQL 4.1 or higher, but MySQL 5.0.15 or higher is recommended</li>\r\n<li>Drupal 7 supports MySQL 5.0.15 or higher (or MySQL 5.1.30 or higher), and requires the PDO database extension for PHP (see <a href=\"/requirements/pdo\" rel=\"nofollow\">What is PDO?</a>).</li>\r\n<li>Drupal 8 supports MySQL 5.0.15 or higher (or MySQL 5.1.30 or higher) with InnoDB as the primary storage engine, and requires the PDO database extension.</li>\r\n</ul><p>There are several drop-in replacements for MySQL. Drupal has been extensively tested with <a href=\"http://mariadb.org/\" rel=\"nofollow\">MariaDB</a>, and version 5.1.44 (or greater) is recommended. It is also likely that other drop-in replacements such as <a href=\"http://www.percona.com/software/percona-server\" rel=\"nofollow\">Percona Server</a> will work well with Drupal, but they may not have specifically undergone testing.</p>\r\n<p><strong>Notes</strong>\r\n</p>\r\n<ul><li>Drupal makes use of some features not available on some inexpensive hosting plans so please check that your host allows database accounts with the following rights:<br>\r\nSELECT, INSERT, UPDATE, DELETE, CREATE, DROP, INDEX, ALTER.<br>\r\nThese rights are sufficient to run Drupal 6 and 7</li>\r\n<li>Some contributed modules, and also Drupal core 5.x (but not Drupal core 6.x), additionally require the following rights:<br>\r\nCREATE TEMPORARY TABLES, LOCK TABLES.</li>\r\n<li>It may be necessary to set the system variable max_allowed_packet to at least 16M. Some inexpensive hosting plans set this value too low (the MySQL default is only 1M). In that case, you may need to choose a better hosting plan. A value of 1M may be sufficient for Drupal 5.</li>\r\n<li>Drupal 7 and earlier support MyISAM and InnoDB table types. Drupal 8 no longer supports MyISAM as the primary storage engine, so InnoDB table types are recommended. NDB tables (MySQL Cluster) are not supported.</li>\r\n<li>Note that if your web hosting account is set up with a graphic control panel such as Plesk or CPanel, it is very likely that you do not need to worry about installing a driver for MySQL -- it is probably already installed on your server. You might wish to simply create your database and proceed with installing Drupal, and then refer back to Drupal documentation for specific troubleshooting help if you run into problems.</li>\r\n</ul><h3>PostgreSQL</h3>\r\n<p>Note: Some contributed modules are not as abstracted from MySQL-specific code as everyone would like. If you are familiar with PostgreSQL please file issues with those contributed modules as you find them.</p>\r\n<ul><li>Drupal 6 supports PostgreSQL 7.1 or higher</li>\r\n<li>Drupal 7 supports PostgreSQL 8.3 or higher</li>\r\n</ul><h3>SQLite</h3>\r\n<p>SQLite 3.3.7 or higher  - Drupal 7 only.</p>\r\n<p>Note: Some contributed modules are not as abstracted from MySQL-specific code as everyone would like. If you are familiar with SQLite please file issues with those contributed modules as you find them.</p>\r\n<h3>Other database servers</h3>\r\n<p><a href=\"http://drupal.org/project/sqlsrv\" rel=\"nofollow\">Microsoft SQL Server</a>, <a href=\"http://drupal.org/project/oracle\" rel=\"nofollow\">Oracle</a>, and <a href=\"https://drupal.org/project/mongodb\" rel=\"nofollow\">MongoDB</a> are supported by additional modules.</p>\r\n<p>Please see discussions in the <a href=\"http://groups.drupal.org/enterprise\" rel=\"nofollow\">Enterprise Group</a> if you are interested in working on database support.</p>\r\n</div>','','filtered_html'),('node','page',0,23,23,'und',0,'<div class=\"shortcode-section\">\r\n<h1 class=\"page-header\">Quote</h1>\r\n<h3>Example</h3>\r\n[quote class=\"my-quote\"]This is my quote[/quote]\r\n<h3>Shortcode</h3>\r\n<pre><code>&#91;quote class=&quot;my-quote&quot;]This is my quote&#91;/quote]</code></pre>\r\n</div>\r\n\r\n<div class=\"shortcode-section\">\r\n<h1 class=\"page-header\">Image</h1>\r\n<h3>Example</h3>\r\n[img src=\"sites/all/themes/forum_plus/logo.png\" class=\"my-image\" alt=\"logo image\" /]\r\n<h3>Shortcode</h3>\r\n<pre><code>&#91;img src=\"sites/all/themes/forum_plus/logo.png\" class=\"my-image\" alt=\"logo image\" /]</code></pre>\r\n</div>\r\n\r\n<div class=\"shortcode-section\">\r\n<h1 class=\"page-header\">Highlight</h1>\r\n<h3>Example</h3>\r\n[highlight class=\"my-highlight\"]This is highlight text[/highlight]\r\n<h3>Shortcode</h3>\r\n<pre><code>&#91;highlight class=\"my-highlight\"]This is highlight text&#91;/highlight]</code></pre>\r\n</div>\r\n\r\n<div class=\"shortcode-section\">\r\n<h1 class=\"page-header\">Button</h1>\r\n<h3>Example</h3>\r\n[button path=\"#\" class=\"my-button\"]This is my button[/button]\r\n<h3>Shortcode</h3>\r\n<pre><code>&#91;button path=\"#\" class=\"my-button\"]This is my button&#91;/button]</code></pre>\r\n</div>\r\n\r\n<div class=\"shortcode-section\">\r\n<h1 class=\"page-header\">Dropcap</h1>\r\n<h3>Example</h3>\r\n[dropcap class=\"my-dropcap\"]This is dropcap[/dropcap]\r\n<h3>Shortcode</h3>\r\n<pre><code>&#91;dropcap class=\"my-dropcap\"]This is dropcap&#91;/dropcap]</code></pre>\r\n</div>\r\n\r\n<div class=\"shortcode-section\">\r\n<h1 class=\"page-header\">Item</h1>\r\n<h3>Example</h3>\r\n[item class=\"my-item\" type=\"span\"]This is an item[/item]\r\n<h3>Shortcode</h3>\r\n<pre><code>&#91;item class=\"my-item\" type=\"span\"]This is an item&#91;/item]</code></pre>\r\n</div>\r\n','','full_html'),('node','page',0,24,24,'und',0,'<div class=\"shortcode-section\">\r\n<h1 class=\"page-header\">Quote</h1>\r\n<h3>Example</h3>\r\n[tooltip class=\"my-tooltip\" placement=\"left\" title=\"left\"]This is my left quote[/tooltip]\r\n[tooltip class=\"my-tooltip\" placement=\"top\" title=\"top\"]This is my top quote[/tooltip]\r\n[tooltip class=\"my-tooltip\" placement=\"right\" title=\"right\"]This is my right quote[/tooltip]\r\n[tooltip class=\"my-tooltip\" placement=\"bottom\" title=\"bottom\"]This is my bottom quote[/tooltip]\r\n<h3>Shortcode</h3>\r\n<pre><code>&#91;tooltip class=\"my-tooltip\" placement=\"left\" title=\"left\"]This is my quote&#91;/tooltip]</code></pre>\r\n</div>','','full_html'),('node','page',0,25,25,'und',0,'<div class=\"shortcode-section\">\r\n<h1 class=\"page-header\">Video</h1>\r\n<h3>Example</h3>\r\n[video]http://www.youtube.com/watch?v=Q-GLuydiMe4[/video]\r\n<h3>Shortcode</h3>\r\n<pre><code>&#91;video]https://www.youtube.com/watch?v=Q-GLuydiMe4&#91;/video]</code></pre>\r\n</div>','','full_html'),('node','page',0,26,26,'und',0,'<div class=\"shortcode-section\">\r\n<h1 class=\"page-header\">Video</h1>\r\n<h3>Example</h3>\r\n[collapse]\r\n[accordion title=\"Accordion Item #1\"]\r\nPraesent vestibulum dapibus nibh. Phasellus viverra nulla ut metus varius laoreet. Pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas. Suspendisse feugiat. Nunc nulla.\r\nPraesent egestas neque eu enim. Phasellus leo dolor, tempus non, auctor et, hendrerit quis, nisi. Fusce neque. In hac habitasse platea dictumst. In hac habitasse platea dictumst.\r\n[/accordion]\r\n[accordion title=\"Accordion Item #2\"]\r\nQuisque id odio. Nunc interdum lacus sit amet orci. Nulla sit amet est. Curabitur ligula sapien, tincidunt non, euismod vitae, posuere imperdiet, leo. Maecenas ullamcorper, dui et placerat feugiat, eros pede varius nisi, condimentum viverra felis nunc et lorem.\r\n[/accordion]\r\n[/collapse]\r\n\r\n<h3>Shortcode</h3>\r\n<pre><code>\r\n&#91;collapse]\r\n&#91;accordion title=\"Accordion Item #1\"]\r\nPraesent vestibulum dapibus nibh. Phasellus viverra nulla ut metus varius laoreet. Pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas. Suspendisse feugiat. Nunc nulla.\r\nPraesent egestas neque eu enim. Phasellus leo dolor, tempus non, auctor et, hendrerit quis, nisi. Fusce neque. In hac habitasse platea dictumst. In hac habitasse platea dictumst.\r\n&#91;/accordion]\r\n&#91;accordion title=\"Accordion Item #2\"]\r\nQuisque id odio. Nunc interdum lacus sit amet orci. Nulla sit amet est. Curabitur ligula sapien, tincidunt non, euismod vitae, posuere imperdiet, leo. Maecenas ullamcorper, dui et placerat feugiat, eros pede varius nisi, condimentum viverra felis nunc et lorem.\r\n&#91;/accordion]\r\n&#91;/collapse]\r\n</code></pre>\r\n</div>','','full_html'),('node','article',0,27,27,'und',0,'<p>Praesent ut ligula non mi varius sagittis. Curabitur nisi. Phasellus leo dolor, tempus non, auctor et, hendrerit quis, nisi. Curabitur at lacus ac velit ornare lobortis. Fusce fermentum. Nunc sed turpis.</p>\r\n\r\n<p>Praesent ut ligula non mi varius sagittis. Curabitur nisi. Phasellus leo dolor, tempus non, auctor et, hendrerit quis, nisi. Curabitur at lacus ac velit ornare lobortis. Proin convallis pretium lacus, et rhoncus ipsum mollis eget.</p>\r\n\r\n<p>Proin convallis pretium lacus, et rhoncus ipsum mollis eget. Mauris pulvinar leo non magna blandit, sed viverra neque euismod. Vestibulum bibendum pretium nibh consequat tincidunt. Suspendisse consequat tortor nisi, eget dictum orci vulputate vel. Morbi ultrices condimentum lacus, semper venenatis leo ultrices sit amet. Ut et tincidunt purus, non venenatis nibh. Etiam congue quam metus, feugiat fringilla nunc congue nec. Donec ut condimentum justo. Nam ut leo et nisl consequat commodo.</p>\r\n\r\n<blockquote>\r\n<p>Donec lobortis nisi vel erat posuere porttitor. Interdum et malesuada fames ac ante ipsum primis in faucibus. Curabitur venenatis massa sit amet mi mollis sollicitudin. Duis ut purus tincidunt, lobortis tortor a, porttitor erat. Quisque suscipit mi eu euismod egestas. Cras quis porta augue. Morbi porttitor cursus eros. Fusce aliquam vel lorem ut dignissim. Fusce commodo nisl et arcu aliquam, nec accumsan purus dictum. In commodo eleifend justo, eu sagittis libero laoreet in.</p>\r\n<footer>Someone famous in <cite title=\"Source Title\">Source Title</cite></footer>\r\n</blockquote>\r\n\r\n<h1>h1. Heading 1</h1>\r\n<p>Sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum. Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium, totam rem aperiam, eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo.</p>\r\n<ul>\r\n<li>Nemo enim ipsam voluptatem quia voluptas sit aspernatur aut odit aut fugit</li>\r\n<li>Sed ut perspiciatis unde omnis iste natus error </li>\r\n<li>Qui dolorem ipsum quia dolor sit amet, consectetur, adipisci velit</li>\r\n</ul>\r\n<h2>h2. Heading 2</h2>\r\n<p>Sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum. Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium, totam rem aperiam, eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo.</p>\r\n<h3>h3. Heading 3</h3>\r\n<p>Sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum. Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium, totam rem aperiam, eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo.</p>','','filtered_html'),('node','article',0,28,28,'und',0,'<p>Praesent ut ligula non mi varius sagittis. Curabitur nisi. Phasellus leo dolor, tempus non, auctor et, hendrerit quis, nisi. Curabitur at lacus ac velit ornare lobortis. Fusce fermentum. Nunc sed turpis.</p>\r\n\r\n<p>Praesent ut ligula non mi varius sagittis. Curabitur nisi. Phasellus leo dolor, tempus non, auctor et, hendrerit quis, nisi. Curabitur at lacus ac velit ornare lobortis. Proin convallis pretium lacus, et rhoncus ipsum mollis eget.</p>\r\n\r\n<p>Proin convallis pretium lacus, et rhoncus ipsum mollis eget. Mauris pulvinar leo non magna blandit, sed viverra neque euismod. Vestibulum bibendum pretium nibh consequat tincidunt. Suspendisse consequat tortor nisi, eget dictum orci vulputate vel. Morbi ultrices condimentum lacus, semper venenatis leo ultrices sit amet. Ut et tincidunt purus, non venenatis nibh. Etiam congue quam metus, feugiat fringilla nunc congue nec. Donec ut condimentum justo. Nam ut leo et nisl consequat commodo.</p>\r\n\r\n<blockquote>\r\n<p>Donec lobortis nisi vel erat posuere porttitor. Interdum et malesuada fames ac ante ipsum primis in faucibus. Curabitur venenatis massa sit amet mi mollis sollicitudin. Duis ut purus tincidunt, lobortis tortor a, porttitor erat. Quisque suscipit mi eu euismod egestas. Cras quis porta augue. Morbi porttitor cursus eros. Fusce aliquam vel lorem ut dignissim. Fusce commodo nisl et arcu aliquam, nec accumsan purus dictum. In commodo eleifend justo, eu sagittis libero laoreet in.</p>\r\n<footer>Someone famous in <cite title=\"Source Title\">Source Title</cite></footer>\r\n</blockquote>\r\n\r\n<h1>h1. Heading 1</h1>\r\n<p>Sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum. Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium, totam rem aperiam, eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo.</p>\r\n<ul>\r\n<li>Nemo enim ipsam voluptatem quia voluptas sit aspernatur aut odit aut fugit</li>\r\n<li>Sed ut perspiciatis unde omnis iste natus error </li>\r\n<li>Qui dolorem ipsum quia dolor sit amet, consectetur, adipisci velit</li>\r\n</ul>\r\n<h2>h2. Heading 2</h2>\r\n<p>Sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum. Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium, totam rem aperiam, eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo.</p>\r\n<h3>h3. Heading 3</h3>\r\n<p>Sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum. Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium, totam rem aperiam, eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo.</p>','','filtered_html'),('node','article',0,29,29,'und',0,'<p>Praesent ut ligula non mi varius sagittis. Curabitur nisi. Phasellus leo dolor, tempus non, auctor et, hendrerit quis, nisi. Curabitur at lacus ac velit ornare lobortis. Fusce fermentum. Nunc sed turpis.</p>\r\n\r\n<p>Praesent ut ligula non mi varius sagittis. Curabitur nisi. Phasellus leo dolor, tempus non, auctor et, hendrerit quis, nisi. Curabitur at lacus ac velit ornare lobortis. Proin convallis pretium lacus, et rhoncus ipsum mollis eget.</p>\r\n\r\n<p>Proin convallis pretium lacus, et rhoncus ipsum mollis eget. Mauris pulvinar leo non magna blandit, sed viverra neque euismod. Vestibulum bibendum pretium nibh consequat tincidunt. Suspendisse consequat tortor nisi, eget dictum orci vulputate vel. Morbi ultrices condimentum lacus, semper venenatis leo ultrices sit amet. Ut et tincidunt purus, non venenatis nibh. Etiam congue quam metus, feugiat fringilla nunc congue nec. Donec ut condimentum justo. Nam ut leo et nisl consequat commodo.</p>\r\n\r\n<blockquote>\r\n<p>Donec lobortis nisi vel erat posuere porttitor. Interdum et malesuada fames ac ante ipsum primis in faucibus. Curabitur venenatis massa sit amet mi mollis sollicitudin. Duis ut purus tincidunt, lobortis tortor a, porttitor erat. Quisque suscipit mi eu euismod egestas. Cras quis porta augue. Morbi porttitor cursus eros. Fusce aliquam vel lorem ut dignissim. Fusce commodo nisl et arcu aliquam, nec accumsan purus dictum. In commodo eleifend justo, eu sagittis libero laoreet in.</p>\r\n<footer>Someone famous in <cite title=\"Source Title\">Source Title</cite></footer>\r\n</blockquote>\r\n<h1>h1. Heading 1</h1>\r\n<p>Sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum. Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium, totam rem aperiam, eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo.</p>\r\n<ul>\r\n<li>Nemo enim ipsam voluptatem quia voluptas sit aspernatur aut odit aut fugit</li>\r\n<li>Sed ut perspiciatis unde omnis iste natus error </li>\r\n<li>Qui dolorem ipsum quia dolor sit amet, consectetur, adipisci velit</li>\r\n</ul>\r\n<h2>h2. Heading 2</h2>\r\n<p>Sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum. Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium, totam rem aperiam, eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo.</p>\r\n<h3>h3. Heading 3</h3>\r\n<p>Sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum. Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium, totam rem aperiam, eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo.</p>','','filtered_html'),('node','article',0,30,30,'und',0,'<p>Praesent ut ligula non mi varius sagittis. Curabitur nisi. Phasellus leo dolor, tempus non, auctor et, hendrerit quis, nisi. Curabitur at lacus ac velit ornare lobortis. Fusce fermentum. Nunc sed turpis.</p>\r\n\r\n<p>Praesent ut ligula non mi varius sagittis. Curabitur nisi. Phasellus leo dolor, tempus non, auctor et, hendrerit quis, nisi. Curabitur at lacus ac velit ornare lobortis. Proin convallis pretium lacus, et rhoncus ipsum mollis eget.</p>\r\n\r\n<p>Proin convallis pretium lacus, et rhoncus ipsum mollis eget. Mauris pulvinar leo non magna blandit, sed viverra neque euismod. Vestibulum bibendum pretium nibh consequat tincidunt. Suspendisse consequat tortor nisi, eget dictum orci vulputate vel. Morbi ultrices condimentum lacus, semper venenatis leo ultrices sit amet. Ut et tincidunt purus, non venenatis nibh. Etiam congue quam metus, feugiat fringilla nunc congue nec. Donec ut condimentum justo. Nam ut leo et nisl consequat commodo.</p>\r\n\r\n<blockquote>\r\n<p>Donec lobortis nisi vel erat posuere porttitor. Interdum et malesuada fames ac ante ipsum primis in faucibus. Curabitur venenatis massa sit amet mi mollis sollicitudin. Duis ut purus tincidunt, lobortis tortor a, porttitor erat. Quisque suscipit mi eu euismod egestas. Cras quis porta augue. Morbi porttitor cursus eros. Fusce aliquam vel lorem ut dignissim. Fusce commodo nisl et arcu aliquam, nec accumsan purus dictum. In commodo eleifend justo, eu sagittis libero laoreet in.</p>\r\n<footer>Someone famous in <cite title=\"Source Title\">Source Title</cite></footer>\r\n</blockquote>\r\n\r\n<h1>h1. Heading 1</h1>\r\n<p>Sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum. Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium, totam rem aperiam, eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo.</p>\r\n<ul>\r\n<li>Nemo enim ipsam voluptatem quia voluptas sit aspernatur aut odit aut fugit</li>\r\n<li>Sed ut perspiciatis unde omnis iste natus error </li>\r\n<li>Qui dolorem ipsum quia dolor sit amet, consectetur, adipisci velit</li>\r\n</ul>\r\n<h2>h2. Heading 2</h2>\r\n<p>Sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum. Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium, totam rem aperiam, eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo.</p>\r\n<h3>h3. Heading 3</h3>\r\n<p>Sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum. Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium, totam rem aperiam, eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo.</p>','','filtered_html'),('node','article',0,31,31,'und',0,'<p>Praesent ut ligula non mi varius sagittis. Curabitur nisi. Phasellus leo dolor, tempus non, auctor et, hendrerit quis, nisi. Curabitur at lacus ac velit ornare lobortis. Fusce fermentum. Nunc sed turpis.</p>\r\n\r\n<p>Praesent ut ligula non mi varius sagittis. Curabitur nisi. Phasellus leo dolor, tempus non, auctor et, hendrerit quis, nisi. Curabitur at lacus ac velit ornare lobortis. Proin convallis pretium lacus, et rhoncus ipsum mollis eget.</p>\r\n\r\n<p>Proin convallis pretium lacus, et rhoncus ipsum mollis eget. Mauris pulvinar leo non magna blandit, sed viverra neque euismod. Vestibulum bibendum pretium nibh consequat tincidunt. Suspendisse consequat tortor nisi, eget dictum orci vulputate vel. Morbi ultrices condimentum lacus, semper venenatis leo ultrices sit amet. Ut et tincidunt purus, non venenatis nibh. Etiam congue quam metus, feugiat fringilla nunc congue nec. Donec ut condimentum justo. Nam ut leo et nisl consequat commodo.</p>\r\n\r\n<blockquote>\r\n<p>Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium, totam rem aperiam, eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo.</p>\r\n</blockquote>\r\n<h1>h1. Heading 1</h1>\r\n<p>Sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum. Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium, totam rem aperiam, eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo.</p>\r\n<ul>\r\n<li>Nemo enim ipsam voluptatem quia voluptas sit aspernatur aut odit aut fugit</li>\r\n<li>Sed ut perspiciatis unde omnis iste natus error </li>\r\n<li>Qui dolorem ipsum quia dolor sit amet, consectetur, adipisci velit</li>\r\n</ul>\r\n<h2>h2. Heading 2</h2>\r\n<p>Sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum. Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium, totam rem aperiam, eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo.</p>\r\n<h3>h3. Heading 3</h3>\r\n<p>Sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum. Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium, totam rem aperiam, eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo.</p>','','full_html'),('node','page',0,33,33,'und',0,'Phasellus facilisis feugiat convallis? Suspendisse vestibulum ante ut sagittis viverra. Mauris tincidunt id neque ac malesuada. Aliquam cursus pharetra suscipit. Fusce non arcu eros. Nulla pretium dictum felis; vitae feugiat dui congue nec? Phasellus eu enim id leo sodales lacinia eu ultrices odio. Proin placerat ut ligula vel ornare. Proin purus lacus, hendrerit sed rutrum a, condimentum mattis lorem? Aliquam aliquam, elit id suscipit molestie, neque est viverra arcu, nec vulputate nibh tortor et quam. Nam dictum, nisi in consequat ultricies; lacus dui fringilla sem, ac luctus mi odio ullamcorper massa! Integer id neque mauris. Sed dignissim eget purus vitae ullamcorper.\r\n\r\nDonec faucibus malesuada odio et commodo. Nulla sed adipiscing sem, id feugiat diam. Curabitur dapibus ut mauris at consectetur. Praesent ut tempus nisl, commodo hendrerit dui. Proin venenatis sit amet nisl id feugiat. Sed imperdiet luctus felis. Nunc at neque turpis? Sed ac neque dolor? Mauris sollicitudin erat nisi, quis venenatis augue lobortis et. Nulla consectetur urna a dui sagittis, et sagittis lorem malesuada. Suspendisse potenti. Praesent felis justo, ultricies vestibulum mauris et, tempor ultricies metus.\r\n','','filtered_html'),('node','video',0,34,34,'und',0,'Lorem ipsum dolor sit amet, consectetur adipiscing elit. Pellentesque eget dolor sit amet lorem vulputate aliquet. Praesent eu dignissim turpis. Duis volutpat gravida tincidunt. Vivamus sodales ligula in accumsan accumsan. Nunc adipiscing posuere ultricies. Class aptent taciti sociosqu ad litora torquent per conubia nostra, per inceptos himenaeos. Praesent vehicula justo id nunc facilisis volutpat porttitor id eros.\r\n\r\nUt aliquet sodales purus, in pretium risus consequat id. Proin convallis pretium lacus, et rhoncus ipsum mollis eget. Mauris pulvinar leo non magna blandit, sed viverra neque euismod. Vestibulum bibendum pretium nibh consequat tincidunt. Suspendisse consequat tortor nisi, eget dictum orci vulputate vel. Morbi ultrices condimentum lacus, semper venenatis leo ultrices sit amet. Ut et tincidunt purus, non venenatis nibh. Etiam congue quam metus, feugiat fringilla nunc congue nec. Donec ut condimentum justo. Nam ut leo et nisl consequat commodo. Nullam tempus rutrum massa, eu ullamcorper turpis dapibus at. Vestibulum feugiat ligula eu nibh vehicula varius.\r\n\r\n<blockquote>\r\n<p>Donec lobortis nisi vel erat posuere porttitor. Interdum et malesuada fames ac ante ipsum primis in faucibus. Curabitur venenatis massa sit amet mi mollis sollicitudin. Duis ut purus tincidunt, lobortis tortor a, porttitor erat. Quisque suscipit mi eu euismod egestas. Cras quis porta augue. Morbi porttitor cursus eros. Fusce aliquam vel lorem ut dignissim. Fusce commodo nisl et arcu aliquam, nec accumsan purus dictum. In commodo eleifend justo, eu sagittis libero laoreet in.</p>\r\n<footer>Someone famous in <cite title=\"Source Title\">Source Title</cite></footer>\r\n</blockquote>\r\n\r\nAliquam elementum turpis eget felis eleifend, id sodales dui ultrices. Fusce rhoncus, libero sed consectetur commodo, arcu nisl malesuada sem, commodo facilisis risus diam eu sapien. Aenean iaculis, urna id ultrices lacinia, lacus lectus commodo neque, vel tincidunt lectus quam ac tellus. Sed interdum mattis neque, nec rhoncus lorem laoreet ornare. Vestibulum dignissim, libero non convallis pulvinar, leo lectus dignissim risus, ac consequat metus purus sed nisi. Aliquam erat volutpat. Vivamus elementum feugiat orci. Nam vitae elementum risus, porta luctus tortor. Proin luctus tristique massa. Phasellus volutpat id leo sed facilisis. Vestibulum accumsan libero eu arcu malesuada luctus.\r\n\r\nNulla porta mi quis nisi pellentesque vehicula. Cras enim mi, venenatis quis odio in, dapibus venenatis mauris. Integer et faucibus justo. Sed mauris odio, sodales ut elit scelerisque, volutpat pellentesque felis. Nullam justo lacus, tempus a leo id, scelerisque hendrerit arcu. Nulla et nulla sit amet justo pulvinar cursus. Pellentesque fermentum mollis leo, ac iaculis lacus mattis id. Suspendisse ornare vitae nisl at volutpat. Aliquam nisi lacus, adipiscing at neque ac, volutpat interdum nisl. Ut bibendum elit quam, a pharetra augue laoreet eget. Vestibulum bibendum dui ultrices, cursus nisi eu, commodo lorem. Suspendisse placerat risus eu magna congue malesuada. Nam sed cursus tellus, vitae vehicula est. Donec ut massa elit. Interdum et malesuada fames ac ante ipsum primis in faucibus.','','filtered_html'),('node','video',0,35,35,'und',0,'Praesent sit amet enim tempus, lobortis eros adipiscing, consequat nisl. Nam eget euismod justo. Aenean non elit eleifend, feugiat augue vitae, sagittis nibh. Vivamus a ante dolor. Integer pharetra euismod est, vitae volutpat enim viverra a? Vivamus velit augue, facilisis vel tortor eu, dignissim suscipit urna. Maecenas pellentesque facilisis sapien non hendrerit? Aliquam sodales turpis dui, sit amet blandit nunc fringilla eget. Fusce congue massa eu elit molestie tempor id vitae justo. Maecenas rhoncus egestas felis, a ornare magna laoreet vel? Sed id tincidunt enim. Aenean vulputate ut felis et consectetur.\r\n\r\nNullam quis viverra augue, ut imperdiet orci. Morbi in vulputate dui, eget tempus mi. Nunc ac convallis justo, adipiscing sodales erat. Nullam venenatis bibendum condimentum. Aliquam egestas eget mauris sollicitudin egestas. Curabitur ullamcorper massa est, ut faucibus tellus aliquet quis? Proin eu porta augue. Aenean eu ligula elementum arcu sagittis iaculis. Aliquam dapibus pulvinar faucibus. Cras vel orci suscipit, consequat metus gravida, convallis eros.\r\n\r\nPellentesque congue tellus non felis sollicitudin bibendum. Maecenas risus risus, accumsan eu lectus a, congue massa nunc.\r\n','','filtered_html'),('node','video',0,36,36,'und',0,'Donec posuere vulputate arcu. Phasellus consectetuer vestibulum elit. Nam commodo suscipit quam. Fusce pharetra convallis urna. Donec sodales sagittis magna. Vestibulum turpis sem, aliquet eget, lobortis pellentesque, rutrum eu, nisl. Sed magna purus, fermentum eu, tincidunt eu, varius ut, felis. Vivamus laoreet. In ut quam vitae odio lacinia tincidunt. Sed aliquam ultrices mauris. Sed mollis, eros et ultrices tempus, mauris ipsum aliquam libero, non adipiscing dolor urna a orci. Fusce risus nisl, viverra et, tempor et, pretium in, sapien. Duis vel nibh at velit scelerisque suscipit. Nullam vel sem. In hac habitasse platea dictumst.\r\n\r\nCras dapibus. Duis arcu tortor, suscipit eget, imperdiet nec, imperdiet iaculis, ipsum. Proin faucibus arcu quis ante. Maecenas vestibulum mollis diam. Praesent blandit laoreet nibh. Donec quam felis, ultricies nec, pellentesque eu, pretium quis, sem. Phasellus leo dolor, tempus non, auctor et, hendrerit quis, nisi. Vivamus aliquet elit ac nisl. Fusce a quam. Suspendisse potenti.','','filtered_html'),('node','video',0,37,37,'und',0,'Aenean ut eros et nisl sagittis vestibulum. Suspendisse potenti. Proin viverra, ligula sit amet ultrices semper, ligula arcu tristique sapien, a accumsan nisi mauris ac eros. Cras sagittis. Vivamus consectetuer hendrerit lacus. Pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas. Vivamus quis mi. Etiam sit amet orci eget eros faucibus tincidunt. Phasellus nec sem in justo pellentesque facilisis. Fusce egestas elit eget lorem. Nullam sagittis. Nullam dictum felis eu pede mollis pretium. Ut leo. Quisque malesuada placerat nisl. Donec vitae orci sed dolor rutrum auctor.\r\n\r\nUt varius tincidunt libero. In ut quam vitae odio lacinia tincidunt. Sed hendrerit. Nam eget dui. Aenean viverra rhoncus pede.Aenean imperdiet. Cras sagittis. Pellentesque libero tortor, tincidunt et, tincidunt eget, semper nec, quam. Fusce a quam. Sed consequat, leo eget bibendum sodales, augue velit cursus nunc, quis gravida magna mi a libero. Maecenas egestas arcu quis ligula mattis placerat. In auctor lobortis lacus. Mauris sollicitudin fermentum libero. Etiam feugiat lorem non metus. Vestibulum dapibus nunc ac augue.\r\n\r\nMaecenas malesuada. Vestibulum rutrum, mi nec elementum vehicula, eros quam gravida nisl, id fringilla neque ante vel mi. Vestibulum rutrum, mi nec elementum vehicula, eros quam gravida nisl, id fringilla neque ante vel mi. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Sed aliquam, nisi quis porttitor congue, elit erat euismod orci, ac placerat dolor lectus quis orci. Maecenas tempus, tellus eget condimentum rhoncus, sem quam semper libero, sit amet adipiscing sem neque sed ipsum.\r\n\r\nPraesent nonummy mi in odio. Praesent nonummy mi in odio. Quisque libero metus, condimentum nec, tempor a, commodo mollis, magna. Vivamus euismod mauris. Donec pede justo, fringilla vel, aliquet nec, vulputate eget, arcu. Phasellus dolor. Phasellus magna. Nulla porta dolor. Etiam imperdiet imperdiet orci. Nunc egestas, augue at pellentesque laoreet, felis eros vehicula leo, at malesuada velit leo quis pede.','','filtered_html'),('node','video',0,38,38,'und',0,'Lorem ipsum dolor sit amet, consectetur adipiscing elit. Pellentesque eget dolor sit amet lorem vulputate aliquet. Praesent eu dignissim turpis. Duis volutpat gravida tincidunt. Vivamus sodales ligula in accumsan accumsan. Nunc adipiscing posuere ultricies. Class aptent taciti sociosqu ad litora torquent per conubia nostra, per inceptos himenaeos. Praesent vehicula justo id nunc facilisis volutpat porttitor id eros.\r\n\r\nUt aliquet sodales purus, in pretium risus consequat id. Proin convallis pretium lacus, et rhoncus ipsum mollis eget. Mauris pulvinar leo non magna blandit, sed viverra neque euismod. Vestibulum bibendum pretium nibh consequat tincidunt. Suspendisse consequat tortor nisi, eget dictum orci vulputate vel. Morbi ultrices condimentum lacus, semper venenatis leo ultrices sit amet. Ut et tincidunt purus, non venenatis nibh. Etiam congue quam metus, feugiat fringilla nunc congue nec. Donec ut condimentum justo. Nam ut leo et nisl consequat commodo. Nullam tempus rutrum massa, eu ullamcorper turpis dapibus at. Vestibulum feugiat ligula eu nibh vehicula varius.\r\n\r\n<blockquote>\r\n<p>Donec lobortis nisi vel erat posuere porttitor. Interdum et malesuada fames ac ante ipsum primis in faucibus. Curabitur venenatis massa sit amet mi mollis sollicitudin. Duis ut purus tincidunt, lobortis tortor a, porttitor erat. Quisque suscipit mi eu euismod egestas. Cras quis porta augue. Morbi porttitor cursus eros. Fusce aliquam vel lorem ut dignissim. Fusce commodo nisl et arcu aliquam, nec accumsan purus dictum. In commodo eleifend justo, eu sagittis libero laoreet in.</p>\r\n<footer>Someone famous in <cite title=\"Source Title\">Source Title</cite></footer>\r\n</blockquote>\r\n\r\nAliquam elementum turpis eget felis eleifend, id sodales dui ultrices. Fusce rhoncus, libero sed consectetur commodo, arcu nisl malesuada sem, commodo facilisis risus diam eu sapien. Aenean iaculis, urna id ultrices lacinia, lacus lectus commodo neque, vel tincidunt lectus quam ac tellus. Sed interdum mattis neque, nec rhoncus lorem laoreet ornare. Vestibulum dignissim, libero non convallis pulvinar, leo lectus dignissim risus, ac consequat metus purus sed nisi. Aliquam erat volutpat. Vivamus elementum feugiat orci. Nam vitae elementum risus, porta luctus tortor. Proin luctus tristique massa. Phasellus volutpat id leo sed facilisis. Vestibulum accumsan libero eu arcu malesuada luctus.\r\n\r\nNulla porta mi quis nisi pellentesque vehicula. Cras enim mi, venenatis quis odio in, dapibus venenatis mauris. Integer et faucibus justo. Sed mauris odio, sodales ut elit scelerisque, volutpat pellentesque felis. Nullam justo lacus, tempus a leo id, scelerisque hendrerit arcu. Nulla et nulla sit amet justo pulvinar cursus. Pellentesque fermentum mollis leo, ac iaculis lacus mattis id. Suspendisse ornare vitae nisl at volutpat. Aliquam nisi lacus, adipiscing at neque ac, volutpat interdum nisl. Ut bibendum elit quam, a pharetra augue laoreet eget. Vestibulum bibendum dui ultrices, cursus nisi eu, commodo lorem. Suspendisse placerat risus eu magna congue malesuada. Nam sed cursus tellus, vitae vehicula est. Donec ut massa elit. Interdum et malesuada fames ac ante ipsum primis in faucibus.','','filtered_html'),('node','page',0,39,39,'und',0,'Aliquam convallis neque a massa molestie, vitae imperdiet enim feugiat! Nulla bibendum odio eu lobortis faucibus. Pellentesque consectetur orci diam, quis suscipit ligula lobortis eu. Quisque vel bibendum lacus, quis dictum tellus. Nulla eu justo viverra, hendrerit elit vitae, tristique quam. Proin ut aliquam dui. Fusce vestibulum, eros hendrerit tincidunt aliquet, dui odio consectetur leo, vitae tincidunt lacus leo et lorem! Praesent euismod erat eget urna fringilla, tempus faucibus sem egestas. Quisque quis consequat nunc.\r\n\r\nUt ultrices cursus eleifend. Curabitur pharetra, felis et auctor vehicula, velit arcu convallis purus; non tempor augue libero in quam. Donec congue viverra auctor? Nullam aliquam rhoncus rutrum. Donec id arcu ligula. Nam id lorem placerat, eleifend tortor quis, pellentesque nibh. Curabitur tempus purus vel eleifend euismod. Quisque eu diam nunc! Morbi sed imperdiet nisl, vitae sagittis est. Mauris euismod sodales lacinia. Donec euismod enim vel accumsan pretium. Duis at rutrum nunc.\r\n\r\nLorem ipsum dolor sit amet, consectetuer adipiscing elit, sed diam nonummy nibh euismod tincidunt ut laoreet dolore magna aliquam erat volutpat. Nam liber tempor cum soluta nobis eleifend option congue nihil imperdiet doming id quod mazim placerat facer possim assum. At vero eos et accusam et justo duo dolores et ea rebum. Stet clita kasd gubergren, no sea takimata sanctus est Lorem ipsum dolor sit amet. Stet clita kasd gubergren, no sea takimata sanctus est Lorem ipsum dolor sit amet.\r\n\r\nLorem ipsum dolor sit amet, consetetur sadipscing elitr, sed diam nonumy eirmod tempor invidunt ut labore et dolore magna aliquyam erat. Lorem ipsum dolor sit amet, consetetur sadipscing elitr, sed diam nonumy eirmod tempor invidunt ut labore et dolore magna aliquyam erat, sed diam voluptua. At vero eos et accusam et justo duo dolores et ea rebum. At vero eos et accusam et justo duo dolores et ea rebum. Ut wisi enim ad minim veniam, quis nostrud exerci tation ullamcorper suscipit lobortis nisl ut aliquip ex ea commodo consequat.\r\n\r\nStet clita kasd gubergren, no sea takimata sanctus est Lorem ipsum dolor sit amet. Excepteur sint obcaecat cupiditat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum. Stet clita kasd gubergren, no sea takimata sanctus est Lorem ipsum dolor sit amet. Ut wisi enim ad minim veniam, quis nostrud exerci tation ullamcorper suscipit lobortis nisl ut aliquip ex ea commodo consequat. Duis autem vel eum iriure dolor in hendrerit in vulputate velit esse molestie consequat, vel illum dolore eu feugiat nulla facilisis at vero eros et accumsan et iusto odio dignissim qui blandit praesent luptatum zzril delenit augue duis dolore te feugait nulla facilisi.\r\n\r\nAt vero eos et accusam et justo duo dolores et ea rebum. Stet clita kasd gubergren, no sea takimata sanctus est Lorem ipsum dolor sit amet. Stet clita kasd gubergren, no sea takimata sanctus est Lorem ipsum dolor sit amet. Quis aute iure reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur. At vero eos et accusam et justo duo dolores et ea rebum.\r\n\r\nDuis autem vel eum iriure dolor in hendrerit in vulputate velit esse molestie consequat, vel illum dolore eu feugiat nulla facilisis. Duis autem vel eum iriure dolor in hendrerit in vulputate velit esse molestie consequat, vel illum dolore eu feugiat nulla facilisis at vero eros et accumsan et iusto odio dignissim qui blandit praesent luptatum zzril delenit augue duis dolore te feugait nulla facilisi. Quis aute iure reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur. Ut wisi enim ad minim veniam, quis nostrud exerci tation ullamcorper suscipit lobortis nisl ut aliquip ex ea commodo consequat..\r\n\r\nLorem ipsum dolor sit amet, consetetur sadipscing elitr, At accusam aliquyam diam diam dolore dolores duo eirmod eos erat, et nonumy sed tempor et et invidunt justo labore Stet clita ea et gubergren, kasd magna no rebum. Duis autem vel eum iriure dolor in hendrerit in vulputate velit esse molestie consequat, vel illum dolore eu feugiat nulla facilisis. At vero eos et accusam et justo duo dolores et ea rebum. At vero eos et accusam et justo duo dolores et ea rebum. Excepteur sint obcaecat cupiditat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum.\r\n\r\n Nam liber tempor cum soluta nobis eleifend option congue nihil imperdiet doming id quod mazim placerat facer possim assum. Ut wisi enim ad minim veniam, quis nostrud exerci tation ullamcorper suscipit lobortis nisl ut aliquip ex ea commodo consequat. Ut wisi enim ad minim veniam, quis nostrud exerci tation ullamcorper suscipit lobortis nisl ut aliquip ex ea commodo consequat. Consetetur sadipscing elitr, sed diam nonumy eirmod tempor invidunt ut labore et dolore magna aliquyam erat, sed diam voluptua.\r\n\r\nLorem ipsum dolor sit amet, consetetur sadipscing elitr, sed diam nonumy eirmod tempor invidunt ut labore et dolore magna aliquyam erat. Stet clita kasd gubergren, no sea takimata sanctus est Lorem ipsum dolor sit amet. Excepteur sint obcaecat cupiditat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum. Lorem ipsum dolor sit amet. Quis aute iure reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.\r\n','','filtered_html'),('node','webform',0,40,40,'und',0,'<div class=\"contact-content clearfix\">\r\n<p>Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur. Excepteur sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum. Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium, totam rem aperiam, eaque ipsa quae ab illo inventore veritatis et quasi architecto .</p>\r\n\r\n<address>\r\n<i class=\"fa fa-map-marker\"></i> Alexander Street. Vancouver, BC<br> V6A 1E1 Canada<br><i class=\"fa fa-phone\"></i> 012.345.6789<br><i class=\"fa fa-print\"></i> 012.345.6789<br><i class=\"fa fa-envelope\"></i> support@weebpal.com</address>\r\n</div>','','full_html'),('node','webform',0,41,41,'und',0,'<div class=\"contact-content clearfix\">\r\n<p>Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur. Excepteur sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum. Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium, totam rem aperiam, eaque ipsa quae ab illo inventore veritatis et quasi architecto .</p>\r\n\r\n<address>\r\n<i class=\"fa fa-map-marker\"></i> Alexander Street. Vancouver, BC<br> V6A 1E1 Canada<br><i class=\"fa fa-phone\"></i> 012.345.6789<br><i class=\"fa fa-print\"></i> 012.345.6789<br><i class=\"fa fa-envelope\"></i> support@weebpal.com</address>\r\n</div>','','full_html'),('node','page',0,42,42,'und',0,'orem ipsum dolor sit amet, consectetur adipiscing elit. Suspendisse quis ante pharetra, porta odio non, mattis urna. Aliquam mattis bibendum lacinia. Mauris adipiscing tincidunt turpis at sodales. Aenean in feugiat urna. Praesent at dictum diam, vitae cursus velit. Donec mauris nisi, aliquam ac lectus id, luctus imperdiet lacus. Cras tellus purus, eleifend eu gravida vitae, aliquam a nunc. Suspendisse dictum dui in dapibus consequat. Proin non hendrerit orci. Sed eget velit turpis. Pellentesque nec tempor elit. Proin sit amet ullamcorper est, nec vestibulum velit. Etiam rhoncus, lectus a lacinia lobortis, nisl risus accumsan ante, sed interdum ante lectus sit amet nunc. Vivamus molestie dolor at dolor sagittis, eu consequat orci tristique.\r\n\r\nNunc gravida adipiscing magna sit amet pulvinar. Aenean nec scelerisque nisl, nec ultrices justo. Phasellus a mollis leo, at hendrerit tellus. In mollis enim et euismod mattis. Nunc aliquet sit amet sapien quis ornare. Nunc rutrum, eros in dignissim adipiscing, nibh nibh faucibus elit, ac faucibus sem enim sit amet eros. Nulla at lectus vel enim posuere sodales quis pellentesque eros. Quisque rhoncus nisi sit amet neque fermentum tempus. Morbi fermentum massa dolor, at adipiscing lectus porta sed. Curabitur fringilla metus a scelerisque blandit. Donec sit amet nisi id lectus pharetra tincidunt a a augue. Quisque posuere ante non odio consectetur rhoncus. Nulla at arcu ultricies nunc placerat posuere eu vitae lacus. Aenean hendrerit auctor justo sed gravida.\r\n\r\nMorbi nunc est, vestibulum ac est nec, fringilla bibendum arcu. Etiam id tortor vel ligula dictum adipiscing mollis nec dolor. Vivamus sed eros a lacus accumsan bibendum vitae eget ante. Sed aliquam interdum ipsum in bibendum. Nunc faucibus, tellus et vestibulum imperdiet, ligula velit tincidunt mi, vel porttitor nibh felis non risus. Phasellus id turpis vitae libero consequat pretium nec sodales erat. Donec luctus arcu eget nulla luctus tempus pretium non odio. Sed tempus nec elit quis facilisis. In pretium posuere magna sit amet vehicula. Etiam dapibus sem nec metus laoreet, quis imperdiet libero condimentum. Aliquam fermentum velit eget leo convallis ullamcorper. Fusce ac consectetur elit, id convallis augue.\r\n\r\nPraesent gravida aliquet ante, vitae suscipit dui fringilla id. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis gravida id erat nec vulputate. Duis rutrum, est id cursus suscipit, dui arcu ornare eros, vel consequat urna sapien sed libero. Quisque quis diam ac nisl ultrices blandit. Quisque cursus feugiat sollicitudin. Nam vitae risus et metus ornare consequat quis nec diam. Vestibulum laoreet sem quis dolor congue cursus. In aliquam risus semper lacus cursus dictum. Nunc condimentum lectus sed tellus bibendum, sed eleifend mi consectetur. Fusce cursus pretium ante, eget euismod sem imperdiet nec. Mauris vitae ipsum libero.\r\n\r\nDonec eros neque, imperdiet quis magna a, facilisis venenatis velit. Sed eu velit et erat vehicula convallis. Curabitur vestibulum ut purus sed ultrices. Suspendisse laoreet in risus vitae pulvinar. Sed ac metus diam. Sed posuere justo quis est mattis, sit amet gravida purus feugiat. Duis sit amet semper diam. Suspendisse nulla libero, auctor eu lectus id, congue suscipit nisi.','','filtered_html'),('node','page',0,43,43,'und',0,'orem ipsum dolor sit amet, consectetur adipiscing elit. Suspendisse quis ante pharetra, porta odio non, mattis urna. Aliquam mattis bibendum lacinia. Mauris adipiscing tincidunt turpis at sodales. Aenean in feugiat urna. Praesent at dictum diam, vitae cursus velit. Donec mauris nisi, aliquam ac lectus id, luctus imperdiet lacus. Cras tellus purus, eleifend eu gravida vitae, aliquam a nunc. Suspendisse dictum dui in dapibus consequat. Proin non hendrerit orci. Sed eget velit turpis. Pellentesque nec tempor elit. Proin sit amet ullamcorper est, nec vestibulum velit. Etiam rhoncus, lectus a lacinia lobortis, nisl risus accumsan ante, sed interdum ante lectus sit amet nunc. Vivamus molestie dolor at dolor sagittis, eu consequat orci tristique.\r\n\r\nNunc gravida adipiscing magna sit amet pulvinar. Aenean nec scelerisque nisl, nec ultrices justo. Phasellus a mollis leo, at hendrerit tellus. In mollis enim et euismod mattis. Nunc aliquet sit amet sapien quis ornare. Nunc rutrum, eros in dignissim adipiscing, nibh nibh faucibus elit, ac faucibus sem enim sit amet eros. Nulla at lectus vel enim posuere sodales quis pellentesque eros. Quisque rhoncus nisi sit amet neque fermentum tempus. Morbi fermentum massa dolor, at adipiscing lectus porta sed. Curabitur fringilla metus a scelerisque blandit. Donec sit amet nisi id lectus pharetra tincidunt a a augue. Quisque posuere ante non odio consectetur rhoncus. Nulla at arcu ultricies nunc placerat posuere eu vitae lacus. Aenean hendrerit auctor justo sed gravida.\r\n\r\nMorbi nunc est, vestibulum ac est nec, fringilla bibendum arcu. Etiam id tortor vel ligula dictum adipiscing mollis nec dolor. Vivamus sed eros a lacus accumsan bibendum vitae eget ante. Sed aliquam interdum ipsum in bibendum. Nunc faucibus, tellus et vestibulum imperdiet, ligula velit tincidunt mi, vel porttitor nibh felis non risus. Phasellus id turpis vitae libero consequat pretium nec sodales erat. Donec luctus arcu eget nulla luctus tempus pretium non odio. Sed tempus nec elit quis facilisis. In pretium posuere magna sit amet vehicula. Etiam dapibus sem nec metus laoreet, quis imperdiet libero condimentum. Aliquam fermentum velit eget leo convallis ullamcorper. Fusce ac consectetur elit, id convallis augue.\r\n\r\nPraesent gravida aliquet ante, vitae suscipit dui fringilla id. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis gravida id erat nec vulputate. Duis rutrum, est id cursus suscipit, dui arcu ornare eros, vel consequat urna sapien sed libero. Quisque quis diam ac nisl ultrices blandit. Quisque cursus feugiat sollicitudin. Nam vitae risus et metus ornare consequat quis nec diam. Vestibulum laoreet sem quis dolor congue cursus. In aliquam risus semper lacus cursus dictum. Nunc condimentum lectus sed tellus bibendum, sed eleifend mi consectetur. Fusce cursus pretium ante, eget euismod sem imperdiet nec. Mauris vitae ipsum libero.\r\n\r\nDonec eros neque, imperdiet quis magna a, facilisis venenatis velit. Sed eu velit et erat vehicula convallis. Curabitur vestibulum ut purus sed ultrices. Suspendisse laoreet in risus vitae pulvinar. Sed ac metus diam. Sed posuere justo quis est mattis, sit amet gravida purus feugiat. Duis sit amet semper diam. Suspendisse nulla libero, auctor eu lectus id, congue suscipit nisi.','','filtered_html'),('node','page',0,44,44,'und',0,'orem ipsum dolor sit amet, consectetur adipiscing elit. Suspendisse quis ante pharetra, porta odio non, mattis urna. Aliquam mattis bibendum lacinia. Mauris adipiscing tincidunt turpis at sodales. Aenean in feugiat urna. Praesent at dictum diam, vitae cursus velit. Donec mauris nisi, aliquam ac lectus id, luctus imperdiet lacus. Cras tellus purus, eleifend eu gravida vitae, aliquam a nunc. Suspendisse dictum dui in dapibus consequat. Proin non hendrerit orci. Sed eget velit turpis. Pellentesque nec tempor elit. Proin sit amet ullamcorper est, nec vestibulum velit. Etiam rhoncus, lectus a lacinia lobortis, nisl risus accumsan ante, sed interdum ante lectus sit amet nunc. Vivamus molestie dolor at dolor sagittis, eu consequat orci tristique.\r\n\r\nNunc gravida adipiscing magna sit amet pulvinar. Aenean nec scelerisque nisl, nec ultrices justo. Phasellus a mollis leo, at hendrerit tellus. In mollis enim et euismod mattis. Nunc aliquet sit amet sapien quis ornare. Nunc rutrum, eros in dignissim adipiscing, nibh nibh faucibus elit, ac faucibus sem enim sit amet eros. Nulla at lectus vel enim posuere sodales quis pellentesque eros. Quisque rhoncus nisi sit amet neque fermentum tempus. Morbi fermentum massa dolor, at adipiscing lectus porta sed. Curabitur fringilla metus a scelerisque blandit. Donec sit amet nisi id lectus pharetra tincidunt a a augue. Quisque posuere ante non odio consectetur rhoncus. Nulla at arcu ultricies nunc placerat posuere eu vitae lacus. Aenean hendrerit auctor justo sed gravida.\r\n\r\nMorbi nunc est, vestibulum ac est nec, fringilla bibendum arcu. Etiam id tortor vel ligula dictum adipiscing mollis nec dolor. Vivamus sed eros a lacus accumsan bibendum vitae eget ante. Sed aliquam interdum ipsum in bibendum. Nunc faucibus, tellus et vestibulum imperdiet, ligula velit tincidunt mi, vel porttitor nibh felis non risus. Phasellus id turpis vitae libero consequat pretium nec sodales erat. Donec luctus arcu eget nulla luctus tempus pretium non odio. Sed tempus nec elit quis facilisis. In pretium posuere magna sit amet vehicula. Etiam dapibus sem nec metus laoreet, quis imperdiet libero condimentum. Aliquam fermentum velit eget leo convallis ullamcorper. Fusce ac consectetur elit, id convallis augue.\r\n\r\nPraesent gravida aliquet ante, vitae suscipit dui fringilla id. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis gravida id erat nec vulputate. Duis rutrum, est id cursus suscipit, dui arcu ornare eros, vel consequat urna sapien sed libero. Quisque quis diam ac nisl ultrices blandit. Quisque cursus feugiat sollicitudin. Nam vitae risus et metus ornare consequat quis nec diam. Vestibulum laoreet sem quis dolor congue cursus. In aliquam risus semper lacus cursus dictum. Nunc condimentum lectus sed tellus bibendum, sed eleifend mi consectetur. Fusce cursus pretium ante, eget euismod sem imperdiet nec. Mauris vitae ipsum libero.\r\n\r\nDonec eros neque, imperdiet quis magna a, facilisis venenatis velit. Sed eu velit et erat vehicula convallis. Curabitur vestibulum ut purus sed ultrices. Suspendisse laoreet in risus vitae pulvinar. Sed ac metus diam. Sed posuere justo quis est mattis, sit amet gravida purus feugiat. Duis sit amet semper diam. Suspendisse nulla libero, auctor eu lectus id, congue suscipit nisi.','','filtered_html'),('node','page',0,45,45,'und',0,'<p>orem ipsum dolor sit amet, consectetur adipiscing elit. Suspendisse quis ante pharetra, porta odio non, mattis urna. Aliquam mattis bibendum lacinia. Mauris adipiscing tincidunt turpis at sodales. Aenean in feugiat urna. Praesent at dictum diam, vitae cursus velit. Donec mauris nisi, aliquam ac lectus id, luctus imperdiet lacus. Cras tellus purus, eleifend eu gravida vitae, aliquam a nunc. Suspendisse dictum dui in dapibus consequat. Proin non hendrerit orci. Sed eget velit turpis. Pellentesque nec tempor elit. Proin sit amet ullamcorper est, nec vestibulum velit. Etiam rhoncus, lectus a lacinia lobortis, nisl risus accumsan ante, sed interdum ante lectus sit amet nunc. Vivamus molestie dolor at dolor sagittis, eu consequat orci tristique. Nunc gravida adipiscing magna sit amet pulvinar. Aenean nec scelerisque nisl, nec ultrices justo. Phasellus a mollis leo, at hendrerit tellus. In mollis enim et euismod mattis. Nunc aliquet sit amet sapien quis ornare. Nunc rutrum, eros in dignissim adipiscing, nibh nibh faucibus elit, ac faucibus sem enim sit amet eros. Nulla at lectus vel enim posuere sodales quis pellentesque eros. Quisque rhoncus nisi sit amet neque fermentum tempus. Morbi fermentum massa dolor, at adipiscing lectus porta sed. Curabitur fringilla metus a scelerisque blandit. Donec sit amet nisi id lectus pharetra tincidunt a a augue. Quisque posuere ante non odio consectetur rhoncus. Nulla at arcu ultricies nunc placerat posuere eu vitae lacus. Aenean hendrerit auctor justo sed gravida. Morbi nunc est, vestibulum ac est nec, fringilla bibendum arcu. Etiam id tortor vel ligula dictum adipiscing mollis nec dolor. Vivamus sed eros a lacus accumsan bibendum vitae eget ante. Sed aliquam interdum ipsum in bibendum. Nunc faucibus, tellus et vestibulum imperdiet, ligula velit tincidunt mi, vel porttitor nibh felis non risus. Phasellus id turpis vitae libero consequat pretium nec sodales erat. Donec luctus arcu eget nulla luctus tempus pretium non odio. Sed tempus nec elit quis facilisis. In pretium posuere magna sit amet vehicula. Etiam dapibus sem nec metus laoreet, quis imperdiet libero condimentum. Aliquam fermentum velit eget leo convallis ullamcorper. Fusce ac consectetur elit, id convallis augue. Praesent gravida aliquet ante, vitae suscipit dui fringilla id. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis gravida id erat nec vulputate. Duis rutrum, est id cursus suscipit, dui arcu ornare eros, vel consequat urna sapien sed libero. Quisque quis diam ac nisl ultrices blandit. Quisque cursus feugiat sollicitudin. Nam vitae risus et metus ornare consequat quis nec diam. Vestibulum laoreet sem quis dolor congue cursus. In aliquam risus semper lacus cursus dictum. Nunc condimentum lectus sed tellus bibendum, sed eleifend mi consectetur. Fusce cursus pretium ante, eget euismod sem imperdiet nec. Mauris vitae ipsum libero. Donec eros neque, imperdiet quis magna a, facilisis venenatis velit. Sed eu velit et erat vehicula convallis. Curabitur vestibulum ut purus sed ultrices. Suspendisse laoreet in risus vitae pulvinar. Sed ac metus diam. Sed posuere justo quis est mattis, sit amet gravida purus feugiat. Duis sit amet semper diam. Suspendisse nulla libero, auctor eu lectus id, congue suscipit nisi.</p>\r\n','','filtered_html'),('node','page',0,46,46,'und',0,'orem ipsum dolor sit amet, consectetur adipiscing elit. Suspendisse quis ante pharetra, porta odio non, mattis urna. Aliquam mattis bibendum lacinia. Mauris adipiscing tincidunt turpis at sodales. Aenean in feugiat urna. Praesent at dictum diam, vitae cursus velit. Donec mauris nisi, aliquam ac lectus id, luctus imperdiet lacus. Cras tellus purus, eleifend eu gravida vitae, aliquam a nunc. Suspendisse dictum dui in dapibus consequat. Proin non hendrerit orci. Sed eget velit turpis. Pellentesque nec tempor elit. Proin sit amet ullamcorper est, nec vestibulum velit. Etiam rhoncus, lectus a lacinia lobortis, nisl risus accumsan ante, sed interdum ante lectus sit amet nunc. Vivamus molestie dolor at dolor sagittis, eu consequat orci tristique.\r\n\r\nNunc gravida adipiscing magna sit amet pulvinar. Aenean nec scelerisque nisl, nec ultrices justo. Phasellus a mollis leo, at hendrerit tellus. In mollis enim et euismod mattis. Nunc aliquet sit amet sapien quis ornare. Nunc rutrum, eros in dignissim adipiscing, nibh nibh faucibus elit, ac faucibus sem enim sit amet eros. Nulla at lectus vel enim posuere sodales quis pellentesque eros. Quisque rhoncus nisi sit amet neque fermentum tempus. Morbi fermentum massa dolor, at adipiscing lectus porta sed. Curabitur fringilla metus a scelerisque blandit. Donec sit amet nisi id lectus pharetra tincidunt a a augue. Quisque posuere ante non odio consectetur rhoncus. Nulla at arcu ultricies nunc placerat posuere eu vitae lacus. Aenean hendrerit auctor justo sed gravida.\r\n\r\nMorbi nunc est, vestibulum ac est nec, fringilla bibendum arcu. Etiam id tortor vel ligula dictum adipiscing mollis nec dolor. Vivamus sed eros a lacus accumsan bibendum vitae eget ante. Sed aliquam interdum ipsum in bibendum. Nunc faucibus, tellus et vestibulum imperdiet, ligula velit tincidunt mi, vel porttitor nibh felis non risus. Phasellus id turpis vitae libero consequat pretium nec sodales erat. Donec luctus arcu eget nulla luctus tempus pretium non odio. Sed tempus nec elit quis facilisis. In pretium posuere magna sit amet vehicula. Etiam dapibus sem nec metus laoreet, quis imperdiet libero condimentum. Aliquam fermentum velit eget leo convallis ullamcorper. Fusce ac consectetur elit, id convallis augue.\r\n\r\nPraesent gravida aliquet ante, vitae suscipit dui fringilla id. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis gravida id erat nec vulputate. Duis rutrum, est id cursus suscipit, dui arcu ornare eros, vel consequat urna sapien sed libero. Quisque quis diam ac nisl ultrices blandit. Quisque cursus feugiat sollicitudin. Nam vitae risus et metus ornare consequat quis nec diam. Vestibulum laoreet sem quis dolor congue cursus. In aliquam risus semper lacus cursus dictum. Nunc condimentum lectus sed tellus bibendum, sed eleifend mi consectetur. Fusce cursus pretium ante, eget euismod sem imperdiet nec. Mauris vitae ipsum libero.\r\n\r\nDonec eros neque, imperdiet quis magna a, facilisis venenatis velit. Sed eu velit et erat vehicula convallis. Curabitur vestibulum ut purus sed ultrices. Suspendisse laoreet in risus vitae pulvinar. Sed ac metus diam. Sed posuere justo quis est mattis, sit amet gravida purus feugiat. Duis sit amet semper diam. Suspendisse nulla libero, auctor eu lectus id, congue suscipit nisi.','','filtered_html'),('node','forum',0,47,47,'und',0,'<p>Excepteur sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum. Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium, totam rem aperiam, eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo.</p>\r\n<p>Nulla facilisi. Cras convallis vel lectus sed convallis. Duis nec accumsan diam. Vestibulum blandit tempus nulla. Suspendisse consectetur cursus elit, et scelerisque ligula hendrerit id. Maecenas ultrices porta nunc, quis consectetur risus. Morbi non metus eget nibh vulputate tincidunt. Nullam dui quam, suscipit a ligula a, posuere sagittis magna. Pellentesque vitae dolor et nunc lobortis vestibulum. Suspendisse potenti. Pellentesque cursus purus vitae libero hendrerit congue. Aenean erat elit, aliquet at mi quis, sollicitudin sollicitudin libero.</p>\r\n<blockquote>\r\n<p>Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium, totam rem aperiam, eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo.</p>\r\n</blockquote>\r\n<h1>h1. Heading 1</h1>\r\n<p>Sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum. Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium, totam rem aperiam, eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo.</p>\r\n<ul>\r\n<li>Nemo enim ipsam voluptatem quia voluptas sit aspernatur aut odit aut fugit</li>\r\n<li>Sed ut perspiciatis unde omnis iste natus error </li>\r\n<li>Qui dolorem ipsum quia dolor sit amet, consectetur, adipisci velit</li>\r\n</ul>\r\n<h2>h2. Heading 2</h2>\r\n<p>Sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum. Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium, totam rem aperiam, eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo.</p>\r\n<h3>h3. Heading 3</h3>\r\n<p>Sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum. Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium, totam rem aperiam, eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo.</p>','','filtered_html'),('node','products',0,48,48,'und',0,'Nullam accumsan lorem in dui. Maecenas tempus, tellus eget condimentum rhoncus, sem quam semper libero, sit amet adipiscing sem neque sed ipsum. Duis arcu tortor, suscipit eget, imperdiet nec, imperdiet iaculis, ipsum. Pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas. Curabitur nisi.\r\n\r\nFusce commodo aliquam arcu. Suspendisse potenti. Cras risus ipsum, faucibus ut, ullamcorper id, varius ac, leo. Sed libero. Vestibulum rutrum, mi nec elementum vehicula, eros quam gravida nisl, id fringilla neque ante vel mi.\r\n\r\nDonec interdum, metus et hendrerit aliquet, dolor diam sagittis ligula, eget egestas libero turpis vel mi. Praesent nonummy mi in odio. Cras ultricies mi eu turpis hendrerit fringilla. Aliquam eu nunc. Suspendisse potenti.\r\n\r\nNam ipsum risus, rutrum vitae, vestibulum eu, molestie vel, lacus. Praesent adipiscing. Phasellus a est. Nam pretium turpis et arcu. Nam eget dui.\r\n\r\nEtiam vitae tortor. Proin pretium, leo ac pellentesque mollis, felis nunc ultrices eros, sed gravida augue augue mollis justo. In consectetuer turpis ut velit. Vivamus aliquet elit ac nisl. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Sed aliquam, nisi quis porttitor congue, elit erat euismod orci, ac placerat dolor lectus quis orci.','','filtered_html'),('node','products',0,49,49,'und',0,'Vestibulum ullamcorper mauris at ligula. Nullam cursus lacinia erat. Fusce ac felis sit amet ligula pharetra condimentum. Sed magna purus, fermentum eu, tincidunt eu, varius ut, felis. Cras dapibus.\r\n\r\nAenean commodo ligula eget dolor. Nam pretium turpis et arcu. In auctor lobortis lacus. Fusce fermentum. Phasellus ullamcorper ipsum rutrum nunc.\r\n\r\nNam at tortor in tellus interdum sagittis. Pellentesque dapibus hendrerit tortor. In turpis. Nunc nonummy metus. Aliquam lorem ante, dapibus in, viverra quis, feugiat a, tellus.\r\n\r\nProin magna. Nunc nec neque. Praesent ac sem eget est egestas volutpat. Praesent vestibulum dapibus nibh. Fusce neque.\r\n\r\nVestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Sed aliquam, nisi quis porttitor congue, elit erat euismod orci, ac placerat dolor lectus quis orci. Nulla porta dolor. Suspendisse pulvinar, augue ac venenatis condimentum, sem libero volutpat nibh, nec pellentesque velit pede quis nunc. Praesent venenatis metus at tortor pulvinar varius. Ut id nisl quis enim dignissim sagittis.','','filtered_html'),('node','products',0,50,50,'und',0,'Praesent adipiscing. Vivamus elementum semper nisi. Aenean imperdiet. Aliquam lobortis. Pellentesque libero tortor, tincidunt et, tincidunt eget, semper nec, quam.\r\n\r\nDonec posuere vulputate arcu. Donec venenatis vulputate lorem. Proin faucibus arcu quis ante. Phasellus ullamcorper ipsum rutrum nunc. Quisque libero metus, condimentum nec, tempor a, commodo mollis, magna.\r\n\r\nVestibulum fringilla pede sit amet augue. Fusce vulputate eleifend sapien. Ut non enim eleifend felis pretium feugiat. Nullam dictum felis eu pede mollis pretium. Fusce a quam.\r\n\r\nVestibulum turpis sem, aliquet eget, lobortis pellentesque, rutrum eu, nisl. Curabitur vestibulum aliquam leo. Pellentesque dapibus hendrerit tortor. Vestibulum facilisis, purus nec pulvinar iaculis, ligula mi congue nunc, vitae euismod ligula urna in dolor. Curabitur at lacus ac velit ornare lobortis.\r\n\r\nCras risus ipsum, faucibus ut, ullamcorper id, varius ac, leo. Suspendisse nisl elit, rhoncus eget, elementum ac, condimentum eget, diam. Nullam tincidunt adipiscing enim. Integer tincidunt. Aliquam erat volutpat.','','filtered_html'),('node','products',0,51,51,'und',0,'Aenean posuere, tortor sed cursus feugiat, nunc augue blandit nunc, eu sollicitudin urna dolor sagittis lacus. Sed hendrerit. Fusce risus nisl, viverra et, tempor et, pretium in, sapien. Etiam iaculis nunc ac metus. Praesent vestibulum dapibus nibh.\r\n\r\nUt id nisl quis enim dignissim sagittis. Vivamus quis mi. Donec posuere vulputate arcu. Mauris turpis nunc, blandit et, volutpat molestie, porta ut, ligula. Donec interdum, metus et hendrerit aliquet, dolor diam sagittis ligula, eget egestas libero turpis vel mi.\r\n\r\nPhasellus nec sem in justo pellentesque facilisis. Aenean viverra rhoncus pede. Praesent turpis. Nunc nonummy metus. Nullam accumsan lorem in dui.\r\n\r\nEtiam ut purus mattis mauris sodales aliquam. Nam eget dui. Nullam cursus lacinia erat. Vestibulum eu odio. Curabitur nisi.\r\n\r\nQuisque id odio. Suspendisse nisl elit, rhoncus eget, elementum ac, condimentum eget, diam. Mauris turpis nunc, blandit et, volutpat molestie, porta ut, ligula. Sed magna purus, fermentum eu, tincidunt eu, varius ut, felis. Nullam tincidunt adipiscing enim.','','filtered_html'),('node','products',0,52,52,'und',0,'Phasellus gravida semper nisi. Aenean viverra rhoncus pede. Curabitur at lacus ac velit ornare lobortis. Nam eget dui. Etiam sit amet orci eget eros faucibus tincidunt.\r\n\r\nAliquam eu nunc. Fusce ac felis sit amet ligula pharetra condimentum. In ac felis quis tortor malesuada pretium. Praesent vestibulum dapibus nibh. Vestibulum rutrum, mi nec elementum vehicula, eros quam gravida nisl, id fringilla neque ante vel mi.\r\n\r\nPhasellus magna. Donec interdum, metus et hendrerit aliquet, dolor diam sagittis ligula, eget egestas libero turpis vel mi. Nam quam nunc, blandit vel, luctus pulvinar, hendrerit id, lorem. Cras ultricies mi eu turpis hendrerit fringilla. Nunc sed turpis.\r\n\r\nAenean vulputate eleifend tellus. Curabitur a felis in nunc fringilla tristique. Ut non enim eleifend felis pretium feugiat. Nunc interdum lacus sit amet orci. Ut id nisl quis enim dignissim sagittis.\r\n\r\nSed in libero ut nibh placerat accumsan. Etiam iaculis nunc ac metus. Curabitur blandit mollis lacus. Morbi mollis tellus ac sapien. Nam at tortor in tellus interdum sagittis.','','filtered_html'),('node','forum',0,53,53,'und',0,'Donec venenatis vulputate lorem. Maecenas vestibulum mollis diam. Fusce commodo aliquam arcu. Donec elit libero, sodales nec, volutpat a, suscipit non, turpis. Phasellus nec sem in justo pellentesque facilisis. Etiam ut purus mattis mauris sodales aliquam. Pellentesque posuere. Maecenas tempus, tellus eget condimentum rhoncus, sem quam semper libero, sit amet adipiscing sem neque sed ipsum. Pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas. Vivamus elementum semper nisi.\r\n\r\n1. Get All The Facts\r\nProin faucibus arcu quis ante. Nam commodo suscipit quam. Donec id justo. Aenean posuere, tortor sed cursus feugiat, nunc augue blandit nunc, eu sollicitudin urna dolor sagittis lacus. Fusce pharetra convallis urna. Ut a nisl id ante tempus hendrerit.. Phasellus volutpat, metus eget egestas mollis, lacus lacus blandit dui, id egestas quam mauris ut lacus. Proin pretium, leo ac pellentesque mollis, felis nunc ultrices eros, sed gravida augue augue mollis justo. Phasellus a est.\r\n\r\n2. Track The Details\r\n\r\nCurabitur at lacus ac velit ornare lobortis. Ut non enim eleifend felis pretium feugiat. Morbi vestibulum volutpat enim. Nulla facilisi. Morbi nec metus. Cras dapibus. Fusce risus nisl, viverra et, tempor et, pretium in, sapien. In ac felis quis tortor malesuada pretium. Donec elit libero, sodales nec, volutpat a, suscipit non, turpis. Suspendisse potenti. Duis lobortis massa imperdiet quam. Suspendisse nisl elit, rhoncus eget, elementum ac, condimentum eget, diam. Praesent nec nisl a purus blandit viverra. Nam commodo suscipit quam. Phasellus dolor.\r\n\r\n(cont)','','filtered_html'),('node','forum',0,54,54,'und',0,'<p>Excepteur sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum. Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium, totam rem aperiam, eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo.</p>\r\n<p>Nulla facilisi. Cras convallis vel lectus sed convallis. Duis nec accumsan diam. Vestibulum blandit tempus nulla. Suspendisse consectetur cursus elit, et scelerisque ligula hendrerit id. Maecenas ultrices porta nunc, quis consectetur risus. Morbi non metus eget nibh vulputate tincidunt. Nullam dui quam, suscipit a ligula a, posuere sagittis magna. Pellentesque vitae dolor et nunc lobortis vestibulum. Suspendisse potenti. Pellentesque cursus purus vitae libero hendrerit congue. Aenean erat elit, aliquet at mi quis, sollicitudin sollicitudin libero.</p>\r\n<blockquote>\r\n<p>Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium, totam rem aperiam, eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo.</p>\r\n</blockquote>\r\n<h1>h1. Heading 1</h1>\r\n<p>Sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum. Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium, totam rem aperiam, eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo.</p>\r\n<ul>\r\n<li>Nemo enim ipsam voluptatem quia voluptas sit aspernatur aut odit aut fugit</li>\r\n<li>Sed ut perspiciatis unde omnis iste natus error </li>\r\n<li>Qui dolorem ipsum quia dolor sit amet, consectetur, adipisci velit</li>\r\n</ul>\r\n<h2>h2. Heading 2</h2>\r\n<p>Sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum. Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium, totam rem aperiam, eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo.</p>\r\n<h3>h3. Heading 3</h3>\r\n<p>Sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum. Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium, totam rem aperiam, eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo.</p>','','full_html'),('node','forum',0,55,55,'und',0,'<p>Excepteur sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum. Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium, totam rem aperiam, eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo.</p>\r\n<p>Nulla facilisi. Cras convallis vel lectus sed convallis. Duis nec accumsan diam. Vestibulum blandit tempus nulla. Suspendisse consectetur cursus elit, et scelerisque ligula hendrerit id. Maecenas ultrices porta nunc, quis consectetur risus. Morbi non metus eget nibh vulputate tincidunt. Nullam dui quam, suscipit a ligula a, posuere sagittis magna. Pellentesque vitae dolor et nunc lobortis vestibulum. Suspendisse potenti. Pellentesque cursus purus vitae libero hendrerit congue. Aenean erat elit, aliquet at mi quis, sollicitudin sollicitudin libero.</p>\r\n<blockquote>\r\n<p>Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium, totam rem aperiam, eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo.</p>\r\n</blockquote>\r\n<h1>h1. Heading 1</h1>\r\n<p>Sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum. Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium, totam rem aperiam, eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo.</p>\r\n<ul>\r\n<li>Nemo enim ipsam voluptatem quia voluptas sit aspernatur aut odit aut fugit</li>\r\n<li>Sed ut perspiciatis unde omnis iste natus error </li>\r\n<li>Qui dolorem ipsum quia dolor sit amet, consectetur, adipisci velit</li>\r\n</ul>\r\n<h2>h2. Heading 2</h2>\r\n<p>Sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum. Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium, totam rem aperiam, eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo.</p>\r\n<h3>h3. Heading 3</h3>\r\n<p>Sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum. Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium, totam rem aperiam, eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo.</p>','','full_html'),('node','forum',0,56,56,'und',0,'<p>Excepteur sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum. Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium, totam rem aperiam, eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo.</p>\r\n\r\n<p>Nulla facilisi. Cras convallis vel lectus sed convallis. Duis nec accumsan diam. Vestibulum blandit tempus nulla. Suspendisse consectetur cursus elit, et scelerisque ligula hendrerit id. Maecenas ultrices porta nunc, quis consectetur risus. Morbi non metus eget nibh vulputate tincidunt. Nullam dui quam, suscipit a ligula a, posuere sagittis magna. Pellentesque vitae dolor et nunc lobortis vestibulum. Suspendisse potenti. Pellentesque cursus purus vitae libero hendrerit congue. Aenean erat elit, aliquet at mi quis, sollicitudin sollicitudin libero.</p>\r\n\r\n<blockquote>\r\n<p>Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium, totam rem aperiam, eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo.</p>\r\n</blockquote>\r\n\r\n<h1>h1. Heading 1</h1>\r\n\r\n<p>Sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum. Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium, totam rem aperiam, eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo.</p>\r\n\r\n<ul>\r\n	<li>Nemo enim ipsam voluptatem quia voluptas sit aspernatur aut odit aut fugit</li>\r\n	<li>Sed ut perspiciatis unde omnis iste natus error</li>\r\n	<li>Qui dolorem ipsum quia dolor sit amet, consectetur, adipisci velit</li>\r\n</ul>\r\n\r\n<h2>h2. Heading 2</h2>\r\n\r\n<p>Sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum. Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium, totam rem aperiam, eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo.</p>\r\n\r\n<h3>h3. Heading 3</h3>\r\n\r\n<p>Sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum. Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium, totam rem aperiam, eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo.</p>\r\n','','filtered_html'),('node','page',0,57,57,'und',0,'Lorem ipsum dolor sit amet, consectetur adipiscing elit. Suspendisse quis ante pharetra, porta odio non, mattis urna. Aliquam mattis bibendum lacinia. Mauris adipiscing tincidunt turpis at sodales. Aenean in feugiat urna. Praesent at dictum diam, vitae cursus velit. Donec mauris nisi, aliquam ac lectus id, luctus imperdiet lacus. Cras tellus purus, eleifend eu gravida vitae, aliquam a nunc. Suspendisse dictum dui in dapibus consequat. Proin non hendrerit orci. Sed eget velit turpis. Pellentesque nec tempor elit. Proin sit amet ullamcorper est, nec vestibulum velit. Etiam rhoncus, lectus a lacinia lobortis, nisl risus accumsan ante, sed interdum ante lectus sit amet nunc. Vivamus molestie dolor at dolor sagittis, eu consequat orci tristique.\r\n\r\nNunc gravida adipiscing magna sit amet pulvinar. Aenean nec scelerisque nisl, nec ultrices justo. Phasellus a mollis leo, at hendrerit tellus. In mollis enim et euismod mattis. Nunc aliquet sit amet sapien quis ornare. Nunc rutrum, eros in dignissim adipiscing, nibh nibh faucibus elit, ac faucibus sem enim sit amet eros. Nulla at lectus vel enim posuere sodales quis pellentesque eros. Quisque rhoncus nisi sit amet neque fermentum tempus. Morbi fermentum massa dolor, at adipiscing lectus porta sed. Curabitur fringilla metus a scelerisque blandit. Donec sit amet nisi id lectus pharetra tincidunt a a augue. Quisque posuere ante non odio consectetur rhoncus. Nulla at arcu ultricies nunc placerat posuere eu vitae lacus. Aenean hendrerit auctor justo sed gravida.\r\n\r\nMorbi nunc est, vestibulum ac est nec, fringilla bibendum arcu. Etiam id tortor vel ligula dictum adipiscing mollis nec dolor. Vivamus sed eros a lacus accumsan bibendum vitae eget ante. Sed aliquam interdum ipsum in bibendum. Nunc faucibus, tellus et vestibulum imperdiet, ligula velit tincidunt mi, vel porttitor nibh felis non risus. Phasellus id turpis vitae libero consequat pretium nec sodales erat. Donec luctus arcu eget nulla luctus tempus pretium non odio. Sed tempus nec elit quis facilisis. In pretium posuere magna sit amet vehicula. Etiam dapibus sem nec metus laoreet, quis imperdiet libero condimentum. Aliquam fermentum velit eget leo convallis ullamcorper. Fusce ac consectetur elit, id convallis augue.\r\n\r\nPraesent gravida aliquet ante, vitae suscipit dui fringilla id. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis gravida id erat nec vulputate. Duis rutrum, est id cursus suscipit, dui arcu ornare eros, vel consequat urna sapien sed libero. Quisque quis diam ac nisl ultrices blandit. Quisque cursus feugiat sollicitudin. Nam vitae risus et metus ornare consequat quis nec diam. Vestibulum laoreet sem quis dolor congue cursus. In aliquam risus semper lacus cursus dictum. Nunc condimentum lectus sed tellus bibendum, sed eleifend mi consectetur. Fusce cursus pretium ante, eget euismod sem imperdiet nec. Mauris vitae ipsum libero.\r\n\r\nDonec eros neque, imperdiet quis magna a, facilisis venenatis velit. Sed eu velit et erat vehicula convallis. Curabitur vestibulum ut purus sed ultrices. Suspendisse laoreet in risus vitae pulvinar. Sed ac metus diam. Sed posuere justo quis est mattis, sit amet gravida purus feugiat. Duis sit amet semper diam. Suspendisse nulla libero, auctor eu lectus id, congue suscipit nisi.\r\n','','filtered_html'),('node','faq',0,58,58,'und',0,'Pellentesque dapibus hendrerit tortor. Nullam quis ante. Donec sodales sagittis magna. Etiam iaculis nunc ac metus. Vestibulum dapibus nunc ac augue.\r\n\r\nDonec vitae sapien ut libero venenatis faucibus. Maecenas tempus, tellus eget condimentum rhoncus, sem quam semper libero, sit amet adipiscing sem neque sed ipsum. Quisque rutrum. Phasellus viverra nulla ut metus varius laoreet. Pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas.\r\n\r\nNam commodo suscipit quam. Pellentesque commodo eros a enim. Nam eget dui. Curabitur ligula sapien, tincidunt non, euismod vitae, posuere imperdiet, leo. Phasellus gravida semper nisi.\r\n\r\nMaecenas tempus, tellus eget condimentum rhoncus, sem quam semper libero, sit amet adipiscing sem neque sed ipsum. Phasellus blandit leo ut odio. Quisque ut nisi. Etiam sit amet orci eget eros faucibus tincidunt. Integer ante arcu, accumsan a, consectetuer eget, posuere ut, mauris.\r\n\r\nAenean tellus metus, bibendum sed, posuere ac, mattis non, nunc. Nullam quis ante. Phasellus leo dolor, tempus non, auctor et, hendrerit quis, nisi. Pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas. Phasellus dolor.','','filtered_html'),('node','faq',0,59,59,'und',0,'Fusce fermentum. Nulla neque dolor, sagittis eget, iaculis quis, molestie non, velit. Phasellus blandit leo ut odio. Nullam cursus lacinia erat. Vestibulum volutpat pretium libero.\r\n\r\nNam adipiscing. Curabitur a felis in nunc fringilla tristique. Etiam imperdiet imperdiet orci. Pellentesque ut neque. Vestibulum eu odio.\r\n\r\nDonec vitae orci sed dolor rutrum auctor. Proin magna. Morbi vestibulum volutpat enim. Nullam cursus lacinia erat. Donec interdum, metus et hendrerit aliquet, dolor diam sagittis ligula, eget egestas libero turpis vel mi.\r\n\r\nNullam cursus lacinia erat. In consectetuer turpis ut velit. Sed fringilla mauris sit amet nibh. Curabitur nisi. In hac habitasse platea dictumst.\r\n\r\nSed a libero. Aenean viverra rhoncus pede. Fusce fermentum. Praesent egestas neque eu enim. Etiam ut purus mattis mauris sodales aliquam.','','filtered_html'),('node','faq',0,60,60,'und',0,'Phasellus accumsan cursus velit. Duis vel nibh at velit scelerisque suscipit. Lorem ipsum dolor sit amet, consectetuer adipiscing elit. Pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas. Morbi ac felis.\r\n\r\nFusce commodo aliquam arcu. Etiam feugiat lorem non metus. Pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas. Sed libero. Praesent ac sem eget est egestas volutpat.\r\n\r\nNunc nonummy metus. Suspendisse eu ligula. Vestibulum purus quam, scelerisque ut, mollis sed, nonummy id, metus. Proin magna. Sed magna purus, fermentum eu, tincidunt eu, varius ut, felis.\r\n\r\nEtiam rhoncus. Vivamus aliquet elit ac nisl. Suspendisse potenti. Aliquam lorem ante, dapibus in, viverra quis, feugiat a, tellus. Maecenas nec odio et ante tincidunt tempus.\r\n\r\nIn auctor lobortis lacus. Morbi nec metus. Etiam imperdiet imperdiet orci. Aenean massa. Nunc egestas, augue at pellentesque laoreet, felis eros vehicula leo, at malesuada velit leo quis pede.','','filtered_html'),('node','faq',0,61,61,'und',0,'Aenean posuere, tortor sed cursus feugiat, nunc augue blandit nunc, eu sollicitudin urna dolor sagittis lacus. Praesent egestas tristique nibh. Vestibulum rutrum, mi nec elementum vehicula, eros quam gravida nisl, id fringilla neque ante vel mi. Phasellus consectetuer vestibulum elit. Aenean tellus metus, bibendum sed, posuere ac, mattis non, nunc.\r\n\r\nIn ac felis quis tortor malesuada pretium. Etiam iaculis nunc ac metus. Donec vitae sapien ut libero venenatis faucibus. Pellentesque egestas, neque sit amet convallis pulvinar, justo nulla eleifend augue, ac auctor orci leo non est. Aliquam lorem ante, dapibus in, viverra quis, feugiat a, tellus.\r\n\r\nNullam quis ante. Pellentesque auctor neque nec urna. Vivamus aliquet elit ac nisl. Maecenas ullamcorper, dui et placerat feugiat, eros pede varius nisi, condimentum viverra felis nunc et lorem. Duis vel nibh at velit scelerisque suscipit.\r\n\r\nIn consectetuer turpis ut velit. Nam at tortor in tellus interdum sagittis. Pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas. Pellentesque dapibus hendrerit tortor. Aenean commodo ligula eget dolor.\r\n\r\nPraesent nonummy mi in odio. Cras varius. Suspendisse feugiat. Aenean leo ligula, porttitor eu, consequat vitae, eleifend ac, enim. Mauris sollicitudin fermentum libero.','','filtered_html'),('node','faq',0,62,62,'und',0,'Vivamus elementum semper nisi. Fusce pharetra convallis urna. Vivamus quis mi. Curabitur blandit mollis lacus. Vestibulum facilisis, purus nec pulvinar iaculis, ligula mi congue nunc, vitae euismod ligula urna in dolor.\r\n\r\nUt id nisl quis enim dignissim sagittis. Pellentesque egestas, neque sit amet convallis pulvinar, justo nulla eleifend augue, ac auctor orci leo non est. Cras non dolor. Quisque libero metus, condimentum nec, tempor a, commodo mollis, magna. Vivamus quis mi.\r\n\r\nVestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Fusce id purus. Vestibulum eu odio. Nam commodo suscipit quam. Morbi mollis tellus ac sapien. Curabitur nisi.\r\n\r\nSed aliquam ultrices mauris. Etiam rhoncus. Donec interdum, metus et hendrerit aliquet, dolor diam sagittis ligula, eget egestas libero turpis vel mi. Phasellus accumsan cursus velit. Donec orci lectus, aliquam ut, faucibus non, euismod id, nulla.\r\n\r\nNullam dictum felis eu pede mollis pretium. Curabitur at lacus ac velit ornare lobortis. Sed aliquam ultrices mauris. Nullam nulla eros, ultricies sit amet, nonummy id, imperdiet feugiat, pede. Vestibulum volutpat pretium libero.','','filtered_html'),('node','faq',0,63,63,'und',0,'Sed libero. Aenean ut eros et nisl sagittis vestibulum. Donec vitae sapien ut libero venenatis faucibus. Etiam vitae tortor. Nam eget dui.\r\n\r\nPraesent nec nisl a purus blandit viverra. In turpis. Suspendisse enim turpis, dictum sed, iaculis a, condimentum nec, nisi. Vestibulum eu odio. Phasellus gravida semper nisi.\r\n\r\nVestibulum turpis sem, aliquet eget, lobortis pellentesque, rutrum eu, nisl. Praesent venenatis metus at tortor pulvinar varius. Etiam iaculis nunc ac metus. Praesent nonummy mi in odio. Pellentesque posuere.\r\n\r\nProin viverra, ligula sit amet ultrices semper, ligula arcu tristique sapien, a accumsan nisi mauris ac eros. Fusce ac felis sit amet ligula pharetra condimentum. Nam eget dui. Phasellus magna. Sed augue ipsum, egestas nec, vestibulum et, malesuada adipiscing, dui.\r\n\r\nNullam vel sem. Cras risus ipsum, faucibus ut, ullamcorper id, varius ac, leo. Vivamus quis mi. Vestibulum eu odio. Suspendisse nisl elit, rhoncus eget, elementum ac, condimentum eget, diam.','','filtered_html'),('node','faq',0,64,64,'und',0,'Mauris sollicitudin fermentum libero. Praesent venenatis metus at tortor pulvinar varius. Curabitur ligula sapien, tincidunt non, euismod vitae, posuere imperdiet, leo. Nam at tortor in tellus interdum sagittis. Maecenas malesuada.\r\n\r\nFusce ac felis sit amet ligula pharetra condimentum. Praesent nec nisl a purus blandit viverra. In dui magna, posuere eget, vestibulum et, tempor auctor, justo. Nam adipiscing. Nam adipiscing.\r\n\r\nVivamus euismod mauris. Nulla porta dolor. Fusce a quam. Donec sodales sagittis magna. Cras id dui.\r\n\r\nCras varius. Sed in libero ut nibh placerat accumsan. Donec mollis hendrerit risus. Ut varius tincidunt libero. Quisque ut nisi.\r\n\r\nPhasellus gravida semper nisi. Sed magna purus, fermentum eu, tincidunt eu, varius ut, felis. Curabitur vestibulum aliquam leo. Donec mollis hendrerit risus. In enim justo, rhoncus ut, imperdiet a, venenatis vitae, justo.','','filtered_html'),('node','faq',0,65,65,'und',0,'Fusce risus nisl, viverra et, tempor et, pretium in, sapien. Phasellus ullamcorper ipsum rutrum nunc. Cras risus ipsum, faucibus ut, ullamcorper id, varius ac, leo. Fusce risus nisl, viverra et, tempor et, pretium in, sapien. Donec venenatis vulputate lorem.\r\n\r\nCum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus. Sed aliquam ultrices mauris. Proin magna. Phasellus leo dolor, tempus non, auctor et, hendrerit quis, nisi. Sed lectus.\r\n\r\nSed aliquam ultrices mauris. Suspendisse non nisl sit amet velit hendrerit rutrum. Fusce fermentum odio nec arcu. Phasellus tempus. Etiam rhoncus.\r\n\r\nMaecenas egestas arcu quis ligula mattis placerat. Sed libero. Aenean posuere, tortor sed cursus feugiat, nunc augue blandit nunc, eu sollicitudin urna dolor sagittis lacus. Nullam vel sem. In dui magna, posuere eget, vestibulum et, tempor auctor, justo.\r\n\r\nNullam accumsan lorem in dui. Aliquam lobortis. Aenean viverra rhoncus pede. Sed magna purus, fermentum eu, tincidunt eu, varius ut, felis. In consectetuer turpis ut velit.','','filtered_html'),('node','faq',0,66,66,'und',0,'Curabitur non elit faucibus, malesuada elit at, pellentesque tellus. Curabitur pretium dui id quam posuere molestie. Nulla eget malesuada sem, non elementum enim. In id porttitor libero. Proin sodales urna in vehicula fermentum. Pellentesque scelerisque condimentum augue, sit amet suscipit nisi auctor a. Cras rutrum ex dui, ac interdum ex faucibus eu. Cras ac congue nisi, pretium malesuada risus? Nulla nec dui turpis. Curabitur lectus nisi, dapibus et arcu id, feugiat mollis sapien. Suspendisse non massa nec tellus lobortis lacinia at id mauris. Sed fermentum ac neque eget auctor. In hac habitasse platea dictumst. Etiam sit amet lobortis neque, et tincidunt nisi.\r\n\r\nMaecenas nec porta odio. Aenean a pellentesque nulla; nec scelerisque ipsum. Morbi tempus eros nisi, ut semper metus tincidunt vel. Nullam porta nibh eros, id rhoncus velit rutrum et. Sed diam dui; vulputate ac lobortis quis, vestibulum et magna. Donec tristique elementum est, quis rhoncus est pretium eu. Cras nec eleifend dolor, nec tristique odio. Fusce sem metus, ornare nec varius quis, eleifend non libero.\r\n\r\nCum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus. Proin sit amet semper posuere.\r\n','','filtered_html'),('node','faq',0,67,67,'und',0,'In vel felis fringilla dolor sagittis pulvinar? Duis ac sapien libero. Sed elementum nunc sit amet ante aliquam, vitae malesuada odio commodo. Sed rutrum est non ullamcorper finibus. Pellentesque id aliquam dui. Morbi nisl dui, pulvinar non risus id, tristique accumsan nisl. Quisque euismod vitae lectus dictum lacinia. Duis sagittis mauris a rhoncus fringilla? Donec pellentesque accumsan mattis?\r\n\r\nPhasellus enim eros, dapibus non pulvinar vel, condimentum quis felis? Donec sem dui, hendrerit vel dapibus id, tristique ac sem? Cras semper nec velit at scelerisque. Aenean vel porttitor libero. Proin viverra pretium nisi nec consectetur. Sed non turpis ut odio consectetur pharetra id quis lacus. Nunc at auctor lectus, ut rhoncus enim. Integer venenatis molestie nibh, id viverra mauris malesuada a. Nam quis interdum turpis, eget convallis nisl. Maecenas cursus mattis quam vel pharetra. Nunc pretium, massa ut interdum pharetra; magna est facilisis ipsum, nec imperdiet metus libero sed nibh.\r\n\r\nAliquam sed urna suscipit, feugiat dolor nec, convallis arcu. Vivamus sed diam id nisl lobortis feugiat sit amet efficitur eros. Integer eu neque metus. Donec egestas, sem ut gravida vulputate, leo metus.\r\n','','filtered_html'),('node','forum',0,68,68,'und',0,'<p>Drupal 6 extended support announcement</p>\r\n\r\n<p>On February 13, 2008, Drupal 6 was released. The policy of the community is to support only the current and previous stable versions. (When Drupal 6 was released, Drupal 4.7.x was marked unsupported. When Drupal 7 came out, Drupal 5.x was marked unsupported.) This policy was created to prevent core and module maintainers from having to maintain more than 2 active major versions of Drupal.</p>\r\n\r\n<p>With the coming Drupal 8 release, this policy has been questioned. We want to ensure that sites that wish to move from Drupal 6 to Drupal 8 have a supported window within which to do so. The Drupal core team, key module maintainers, and representatives of the Drupal security team met at Drupalcon Austin to discuss this as an in-person follow up to the previous discussion at <a href=\"https://drupal.org/node/2136029\">https://drupal.org/node/2136029</a>.</p>\r\n\r\n<p>Drupal 6 core and modules will transition to unsupported status three months after Drupal 8 is released. \"Unsupported status\" means the community will not be providing support or patches in the same way we do now. Continuing to support Drupal 6 would be difficult for many reasons, including a lack of automated test coverage, the requirement for rigorous manual release testing, the slow-down it introduces in the release of security fixes for the vast majority of Drupal users (on version 7+), and the general shift of volunteers in the community moving their attention onto Drupal 8 development.</p>\r\n\r\n<p>This gives Drupal 6 users a few options:</p>\r\n\r\n<p>1) Upgrade to Drupal 7 any time between now and 3 months after Drupal 8.0.0 is released. Drupal 7 releases undergo almost 40,000 automated tests, and Drupal 7 will be fully supported at least until Drupal 9 comes out. Given the past history, the release of Drupal 9 is likely to be around 2018.</p>\r\n\r\n<p>2) Upgrade to Drupal 8 after it is released, but before Drupal 6 is not supported anymore. Fortunately, Migrate support for Drupal 6 to Drupal 8 is already in core, and there is Migrate UI, a contributed module. While not all contributed modules will be ready at the time Drupal 8 is released, Drupal 8\'s migration path handles most of the critical site data via its CCK to Entities/Fields in Core migrations.</p>\r\n\r\n<p>3) Find an organization that will provide extended support for Drupal 6. The Drupal Security Team will provide a method for companies and/or individuals to work together in the private security issue queue to continue developing updates, and will provide a reasonable amount of time for companies to provide patches to Drupal 6 security issues that also affect Drupal 7 or Drupal 8. The security team will coordinate access to issues for companies wishing to provide extended support for Drupal 6. However, the team will not explicitly review or test the patches (some team members may do this on their own). All code created by these vendors, would be released to the community.</p>\r\n\r\n<p>Organizations and individuals interested in providing this level of support for their customers<br />\r\nAND who have the technical knowledge to maintain a Drupal core release should go to the security team Drupal 6 long term support page.</p>\r\n\r\n<p>Both the Security Team and Drupal core leadership feel that a 3-month window after Drupal 8\'s release before eclipsing community support for Drupal 6 is a workable compromise between leaving Drupal 6 sites on an unsupported version the second Drupal 8 comes out, and acknowledging that our community\'s volunteer resources are limited and have shifted focus. We hope that organizations that rely on Drupal 6 will step up to help maintain it after community support winds down, and/or help their clients update to D8.</p>\r\n','','full_html'),('node','forum',0,69,69,'und',0,'<div>I\'m not a Drupal developer but a pro Drupal site builder. I can read PHP and able to tweak and even write some code. I was thinking about learning the development but came across this idea that in D8 we have symphony and some other big changes. Now the question is that shall I start learning D8 dev or I should start with D7 dev? - See more at: http://demo.weebpal.com/forum-plus/en/node/1#sthash.p70HJJcO.dpuf</div>\r\n','','filtered_html');
/*!40000 ALTER TABLE `field_data_body` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `field_data_comment_body`
--

DROP TABLE IF EXISTS `field_data_comment_body`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_comment_body` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `comment_body_value` longtext,
  `comment_body_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `comment_body_format` (`comment_body_format`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Data storage for field 1 (comment_body)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_comment_body`
--

LOCK TABLES `field_data_comment_body` WRITE;
/*!40000 ALTER TABLE `field_data_comment_body` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `field_data_comment_body` VALUES ('comment','comment_node_forum',0,1,1,'und',0,'Even if D8 goes gold tomorrow, D7 will be the choice for substantial production sites for a while until a crit mass of modules port and the inevitable bugs shake out. And the need to maintain existing D7 sites will be a desired skill for years to come.','filtered_html'),('comment','comment_node_blog',0,2,2,'und',0,'Praesent metus tellus, elementum eu, semper a, adipiscing nec, purus. Phasellus nec sem in justo pellentesque facilisis. In enim justo, rhoncus ut, imperdiet a, venenatis vitae, justo. Quisque malesuada placerat nisl. Nunc sed turpis.','filtered_html'),('comment','comment_node_blog',0,3,3,'und',0,'Curabitur a felis in nunc fringilla tristique. Nullam tincidunt adipiscing enim. Phasellus tempus. Proin viverra, ligula sit amet ultrices semper, ligula arcu tristique sapien, a accumsan nisi mauris ac eros. Nulla sit amet est.','filtered_html'),('comment','comment_node_blog',0,4,4,'und',0,'Curabitur a felis in nunc fringilla tristique. Nullam tincidunt adipiscing enim. Phasellus tempus. Proin viverra, ligula sit amet ultrices semper, ligula arcu tristique sapien, a accumsan nisi mauris ac eros. Nulla sit amet est.','filtered_html'),('comment','comment_node_blog',0,5,5,'und',0,'Curabitur a felis in nunc fringilla tristique. Nullam tincidunt adipiscing enim. Phasellus tempus. Proin viverra, ligula sit amet ultrices semper, ligula arcu tristique sapien, a accumsan nisi mauris ac eros. Nulla sit amet est.','filtered_html'),('comment','comment_node_blog',0,6,6,'und',0,'Curabitur a felis in nunc fringilla tristique. Nullam tincidunt adipiscing enim. Phasellus tempus. Proin viverra, ligula sit amet ultrices semper, ligula arcu tristique sapien, a accumsan nisi mauris ac eros. Nulla sit amet est.','filtered_html'),('comment','comment_node_article',0,7,7,'und',0,'Nam quam nunc, blandit vel, luctus pulvinar, hendrerit id, lorem. Vivamus laoreet. Phasellus magna. In ac felis quis tortor malesuada pretium. Ut tincidunt tincidunt erat.','filtered_html'),('comment','comment_node_forum',0,8,8,'und',0,'Donec sodales sagittis magna. Praesent ut ligula non mi varius sagittis. Donec venenatis vulputate lorem. Suspendisse eu ligula. Pellentesque posuere. Etiam iaculis nunc ac metus. Fusce a quam. Suspendisse eu ligula. Praesent porttitor, nulla vitae posuere iaculis, arcu nisl dignissim dolor, a pretium mi sem ut ipsum. Phasellus nec sem in justo pellentesque facilisis.\r\n\r\nAliquam lobortis. Nullam dictum felis eu pede mollis pretium. Phasellus consectetuer vestibulum elit. Sed augue ipsum, egestas nec, vestibulum et, malesuada adipiscing, dui. Duis arcu tortor, suscipit eget, imperdiet nec, imperdiet iaculis, ipsum. Curabitur a felis in nunc fringilla tristique. Fusce vulputate eleifend sapien. Quisque ut nisi. Vivamus consectetuer hendrerit lacus. In ut quam vitae odio lacinia tincidunt.\r\n\r\nMorbi mollis tellus ac sapien. Suspendisse nisl elit, rhoncus eget, elementum ac, condimentum eget, diam. In consectetuer turpis ut velit. Mauris turpis nunc, blandit et, volutpat molestie, porta ut, ligula. Ut id nisl quis enim dignissim sagittis.','filtered_html'),('comment','comment_node_forum',0,9,9,'und',0,'Phasellus leo dolor, tempus non, auctor et, hendrerit quis, nisi. Nullam tincidunt adipiscing enim. Phasellus gravida semper nisi. Nulla facilisi. Ut leo.\r\n\r\nFusce a quam. Vestibulum turpis sem, aliquet eget, lobortis pellentesque, rutrum eu, nisl. Fusce risus nisl, viverra et, tempor et, pretium in, sapien. Donec elit libero, sodales nec, volutpat a, suscipit non, turpis. In turpis.\r\n\r\nIn hac habitasse platea dictumst. Vivamus in erat ut urna cursus vestibulum. Nullam accumsan lorem in dui. Donec id justo. Aliquam lorem ante, dapibus in, viverra quis, feugiat a, tellus.\r\n\r\nAenean commodo ligula eget dolor. Quisque malesuada placerat nisl. Vivamus euismod mauris. Vestibulum ullamcorper mauris at ligula. Donec vitae sapien ut libero venenatis faucibus.\r\n\r\nMaecenas malesuada. Nam eget dui. Nam ipsum risus, rutrum vitae, vestibulum eu, molestie vel, lacus. Pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas. Nullam accumsan lorem in dui.','filtered_html'),('comment','comment_node_forum',0,10,10,'und',0,'Drupal 7.28, a maintenance release with numerous bug fixes (no security fixes) is now available for download. See the Drupal 7.28 release notes for a full listing.\r\n\r\nDownload Drupal 7.28\r\nUpgrading your existing Drupal 7 sites is recommended. There are no major new features in this release. For more information about the Drupal 7.x release series, consult the Drupal 7.0 release announcement.\r\n\r\nSecurity information\r\nWe have a security announcement mailing list and a history of all security advisories, as well as an RSS feed with the most recent security advisories. We strongly advise Drupal administrators to sign up for the list.\r\n\r\nDrupal 7 includes the built-in Update Manager module, which informs you about important updates to your modules and themes.\r\n\r\nThere are no security fixes in this release of Drupal core.\r\n\r\nBug reports\r\nDrupal 7.x is being maintained, so given enough bug fixes (not just bug reports), more maintenance releases will be made available, according to our monthly release cycle.\r\n\r\nChangelog\r\nDrupal 7.28 contains bug fixes and small API/feature improvements only. The full list of changes between the 7.27 and 7.28 releases can be found by reading the 7.28 release notes. A complete list of all bug fixes in the stable 7.x branch can be found in the git commit log.\r\n\r\nUpdate notes\r\nSee the 7.28 release notes for details on important changes in this release.\r\n\r\nKnown issues\r\nChanges made to the Update Manager module in this release may lead to performance slowdowns in certain cases (including on rare page loads for site visitors, if the site is using the automated cron feature). See the release notes for more information.','filtered_html'),('comment','comment_node_article',0,11,11,'und',0,'Vivamus id interdum odio. Vivamus eu lectus eros. Aliquam vel nisi sagittis lectus pretium egestas. Integer nisi ligula, pulvinar vitae arcu vitae, cursus mattis massa. Vestibulum tempor metus feugiat condimentum iaculis. Mauris ornare nec neque eget rhoncus. Etiam nisi enim; blandit non porta amet.\r\n','filtered_html'),('comment','comment_node_article',0,12,12,'und',0,'Phasellus nec sem in justo pellentesque facilisis. Donec interdum, metus et hendrerit aliquet, dolor diam sagittis ligula, eget egestas libero turpis vel mi. Praesent ut ligula non mi varius sagittis. Fusce vel dui. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Sed aliquam, nisi quis porttitor congue, elit erat euismod orci, ac placerat dolor lectus quis orci.','filtered_html'),('comment','comment_node_article',0,13,13,'und',0,'Vestibulum rutrum, mi nec elementum vehicula, eros quam gravida nisl, id fringilla neque ante vel mi. Vestibulum fringilla pede sit amet augue. Sed a libero. Fusce convallis metus id felis luctus adipiscing. Donec pede justo, fringilla vel, aliquet nec, vulputate eget, arcu.','filtered_html'),('comment','comment_node_article',0,14,14,'und',0,'Vestibulum rutrum, mi nec elementum vehicula, eros quam gravida nisl, id fringilla neque ante vel mi. Vestibulum fringilla pede sit amet augue. Sed a libero. Fusce convallis metus id felis luctus adipiscing. Donec pede justo, fringilla vel, aliquet nec, vulputate eget, arcu.','filtered_html'),('comment','comment_node_article',0,15,15,'und',0,'Fusce porttitor nunc ac ante pretium, sed fermentum turpis malesuada. Aliquam tempor mollis metus, at congue nulla tincidunt at. Nunc nulla quam, congue quis fringilla ut, porta id ipsum. Nullam quis mattis odio? Nunc condimentum at diam a malesuada. Nulla facilisi. Suspendisse vitae gravida nullam.\r\n','filtered_html'),('comment','comment_node_article',0,16,16,'und',0,'Phasellus magna. Nullam cursus lacinia erat. Maecenas ullamcorper, dui et placerat feugiat, eros pede varius nisi, condimentum viverra felis nunc et lorem. Nullam accumsan lorem in dui. Donec vitae orci sed dolor rutrum auctor.','filtered_html'),('comment','comment_node_blog',0,17,17,'und',0,'<blockquote>Phasellus volutpat, metus eget egestas mollis, lacus lacus blandit dui, id egestas quam mauris ut lacus. Class aptent taciti sociosqu ad litora torquent per conubia nostra, per inceptos hymenaeos. Etiam rhoncus. Nunc egestas, augue at pellentesque laoreet, felis eros vehicula leo, at malesuada velit leo quis pede. Nullam nulla eros, ultricies sit amet, nonummy id, imperdiet feugiat, pede.</blockquote>\r\n\r\nFusce fermentum. Suspendisse faucibus, nunc et pellentesque egestas, lacus ante convallis tellus, vitae iaculis lacus elit id tortor. Pellentesque libero tortor, tincidunt et, tincidunt eget, semper nec, quam. Praesent ac sem eget est egestas volutpat. Duis vel nibh at velit scelerisque suscipit.','filtered_html'),('comment','comment_node_forum',0,18,18,'und',0,'Morbi mollis tellus ac sapien. Nam adipiscing. Nullam nulla eros, ultricies sit amet, nonummy id, imperdiet feugiat, pede. Phasellus viverra nulla ut metus varius laoreet. Praesent adipiscing.\r\n\r\nNam eget dui. Phasellus a est. Etiam iaculis nunc ac metus. Phasellus a est. Nulla neque dolor, sagittis eget, iaculis quis, molestie non, velit.\r\n\r\nMauris turpis nunc, blandit et, volutpat molestie, porta ut, ligula. Vivamus euismod mauris. Fusce ac felis sit amet ligula pharetra condimentum. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus. Sed hendrerit.','filtered_html'),('comment','comment_node_forum',0,19,19,'und',0,'Suspendisse non nisl sit amet velit hendrerit rutrum. Maecenas vestibulum mollis diam. Integer ante arcu, accumsan a, consectetuer eget, posuere ut, mauris. Nunc nonummy metus. Ut id nisl quis enim dignissim sagittis.\r\n\r\nAliquam lobortis. Mauris sollicitudin fermentum libero. Fusce fermentum odio nec arcu. Vestibulum purus quam, scelerisque ut, mollis sed, nonummy id, metus. Suspendisse potenti.\r\n\r\nVestibulum fringilla pede sit amet augue. Phasellus ullamcorper ipsum rutrum nunc. Cras varius. Curabitur nisi. Nullam sagittis.','filtered_html'),('comment','comment_node_forum',0,20,20,'und',0,'Suspendisse non nisl sit amet velit hendrerit rutrum. Maecenas vestibulum mollis diam. Integer ante arcu, accumsan a, consectetuer eget, posuere ut, mauris. Nunc nonummy metus. Ut id nisl quis enim dignissim sagittis.\r\n\r\nAliquam lobortis. Mauris sollicitudin fermentum libero. Fusce fermentum odio nec arcu. Vestibulum purus quam, scelerisque ut, mollis sed, nonummy id, metus. Suspendisse potenti.\r\n\r\nVestibulum fringilla pede sit amet augue. Phasellus ullamcorper ipsum rutrum nunc. Cras varius. Curabitur nisi. Nullam sagittis.','filtered_html'),('comment','comment_node_forum',0,21,21,'und',0,'Suspendisse non nisl sit amet velit hendrerit rutrum. Maecenas vestibulum mollis diam. Integer ante arcu, accumsan a, consectetuer eget, posuere ut, mauris. Nunc nonummy metus. Ut id nisl quis enim dignissim sagittis.\r\n\r\nAliquam lobortis. Mauris sollicitudin fermentum libero. Fusce fermentum odio nec arcu. Vestibulum purus quam, scelerisque ut, mollis sed, nonummy id, metus. Suspendisse potenti.\r\n\r\nVestibulum fringilla pede sit amet augue. Phasellus ullamcorper ipsum rutrum nunc. Cras varius. Curabitur nisi. Nullam sagittis.','filtered_html'),('comment','comment_node_forum',0,22,22,'und',0,'Aenean id mollis justo. Praesent nunc arcu, fringilla eu odio vel, rutrum feugiat dolor. Praesent quis nibh id est scelerisque interdum non vitae turpis. Fusce pretium urna vel lacus commodo mattis? Ut sit amet sapien cursus, imperdiet nibh et, molestie turpis. Vestibulum sed odio at elit cras amet.\r\n','filtered_html'),('comment','comment_node_forum',0,23,23,'und',0,'Phasellus et mauris sit amet metus interdum feugiat in sit amet ipsum. Nulla dignissim adipiscing dictum. Donec in nunc vel metus fringilla posuere id pellentesque nibh! Fusce ullamcorper posuere ipsum, sit amet gravida elit porttitor non! Fusce vehicula orci quis scelerisque congue. Morbi volutpat.\r\n','filtered_html'),('comment','comment_node_forum',0,24,24,'und',0,'Donec hendrerit, tortor ut iaculis imperdiet, leo nisi lacinia sapien, et aliquam dolor ipsum quis quam? Aenean semper dapibus elit, molestie imperdiet quam. Duis dignissim placerat quam, non euismod elit consectetur a. In ut arcu dignissim, ultrices lorem id, varius ligula. Nulla volutpat volutpat.\r\n','filtered_html'),('comment','comment_node_forum',0,25,25,'und',0,'Pellentesque vel augue sit amet ante euismod accumsan non a sapien. Maecenas molestie; velit sed auctor porta, augue purus accumsan lectus; id faucibus leo est id dui. Class aptent taciti sociosqu ad litora torquent per conubia nostra, per inceptos himenaeos. Suspendisse sodales tellus sed volutpat.\r\n','filtered_html'),('comment','comment_node_forum',0,26,26,'und',0,'Phasellus volutpat, metus eget egestas mollis, lacus lacus blandit dui, id egestas quam mauris ut lacus. Etiam sit amet orci eget eros faucibus tincidunt. Suspendisse non nisl sit amet velit hendrerit rutrum. Donec quam felis, ultricies nec, pellentesque eu, pretium quis, sem. Etiam imperdiet imperdiet orci.\r\n\r\nCras dapibus. Donec venenatis vulputate lorem. Praesent turpis. Etiam ut purus mattis mauris sodales aliquam. Etiam ultricies nisi vel augue.\r\n\r\nCras ultricies mi eu turpis hendrerit fringilla. Nullam nulla eros, ultricies sit amet, nonummy id, imperdiet feugiat, pede. Nullam vel sem. Maecenas malesuada. Sed fringilla mauris sit amet nibh.\r\n\r\nCurabitur turpis. Maecenas nec odio et ante tincidunt tempus. In ut quam vitae odio lacinia tincidunt. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Sed aliquam, nisi quis porttitor congue, elit erat euismod orci, ac placerat dolor lectus quis orci. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Fusce id purus.\r\n\r\nPraesent ut ligula non mi varius sagittis. Morbi vestibulum volutpat enim. Fusce egestas elit eget lorem. Vivamus quis mi. Sed lectus.','filtered_html'),('comment','comment_node_forum',0,27,27,'und',0,'Duis feugiat libero felis, ut cursus enim ullamcorper quis. Phasellus sem sem, imperdiet quis est id, porttitor elementum quam. Sed at elementum eros, quis pellentesque enim. Aliquam bibendum erat vel urna molestie, et blandit nibh consequat? Sed eu auctor dolor. Cras eu odio ut leo vestibulum amet.\r\n','filtered_html'),('comment','comment_node_forum',0,28,28,'und',0,'Phasellus volutpat, metus eget egestas mollis, lacus lacus blandit dui, id egestas quam mauris ut lacus. Etiam sit amet orci eget eros faucibus tincidunt. Suspendisse non nisl sit amet velit hendrerit rutrum. Donec quam felis, ultricies nec, pellentesque eu, pretium quis, sem. Etiam imperdiet imperdiet orci.\r\n\r\nCras dapibus. Donec venenatis vulputate lorem. Praesent turpis. Etiam ut purus mattis mauris sodales aliquam. Etiam ultricies nisi vel augue.\r\n\r\nCras ultricies mi eu turpis hendrerit fringilla. Nullam nulla eros, ultricies sit amet, nonummy id, imperdiet feugiat, pede. Nullam vel sem. Maecenas malesuada. Sed fringilla mauris sit amet nibh.\r\n\r\nCurabitur turpis. Maecenas nec odio et ante tincidunt tempus. In ut quam vitae odio lacinia tincidunt. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Sed aliquam, nisi quis porttitor congue, elit erat euismod orci, ac placerat dolor lectus quis orci. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Fusce id purus.\r\n\r\nPraesent ut ligula non mi varius sagittis. Morbi vestibulum volutpat enim. Fusce egestas elit eget lorem. Vivamus quis mi. Sed lectus.','filtered_html'),('comment','comment_node_forum',0,29,29,'und',0,'Morbi ac felis. Quisque id mi. Quisque libero metus, condimentum nec, tempor a, commodo mollis, magna. Donec vitae orci sed dolor rutrum auctor. Curabitur nisi.\r\n\r\nFusce fermentum odio nec arcu. Phasellus magna. Maecenas ullamcorper, dui et placerat feugiat, eros pede varius nisi, condimentum viverra felis nunc et lorem. Nam at tortor in tellus interdum sagittis. Nullam sagittis.\r\n\r\nInteger tincidunt. Aliquam lobortis. In ut quam vitae odio lacinia tincidunt. Vestibulum volutpat pretium libero. Nam commodo suscipit quam.','filtered_html'),('comment','comment_node_blog',0,30,30,'und',0,'Morbi mattis ullamcorper velit. Ut non enim eleifend felis pretium feugiat. Donec quam felis, ultricies nec, pellentesque eu, pretium quis, sem. Maecenas nec odio et ante tincidunt tempus. Lorem ipsum dolor sit amet, consectetuer adipiscing elit.\r\n\r\nPraesent congue erat at massa. Nam ipsum risus, rutrum vitae, vestibulum eu, molestie vel, lacus. Cras id dui. Fusce convallis metus id felis luctus adipiscing. Pellentesque commodo eros a enim.','filtered_html'),('comment','comment_node_blog',0,31,31,'und',0,'Aenean leo ligula, porttitor eu, consequat vitae, eleifend ac, enim. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Fusce id purus. Sed libero. Phasellus blandit leo ut odio. Fusce vel dui.\r\n\r\nNunc sed turpis. Phasellus viverra nulla ut metus varius laoreet. Praesent ut ligula non mi varius sagittis. Nulla consequat massa quis enim. Suspendisse pulvinar, augue ac venenatis condimentum, sem libero volutpat nibh, nec pellentesque velit pede quis nunc.','filtered_html'),('comment','comment_node_blog',0,32,32,'und',0,' Vivamus elementum semper nisi. Nunc egestas, augue at pellentesque laoreet, felis eros vehicula leo, at malesuada velit leo quis pede. Proin sapien ipsum, porta a, auctor quis, euismod ut, mi. Suspendisse eu ligula.','filtered_html'),('comment','comment_node_blog',0,33,33,'und',0,' Vivamus elementum semper nisi. Nunc egestas, augue at pellentesque laoreet, felis eros vehicula leo, at malesuada velit leo quis pede. Proin sapien ipsum, porta a, auctor quis, euismod ut, mi. Suspendisse eu ligula.','filtered_html'),('comment','comment_node_blog',0,34,34,'und',0,'Aliquam eu faucibus orci, a hendrerit elit. Sed metus augue; euismod tristique risus condimentum, elementum faucibus enim. Praesent interdum lorem ante, ut aliquam metus accumsan non? Integer egestas quis arcu sed ornare. Maecenas vitae velit vel ipsum fringilla iaculis sed dapibus odio. Fusce amet.\r\n','filtered_html'),('comment','comment_node_blog',0,35,35,'und',0,'Vestibulum mattis metus non nunc venenatis feugiat. Pellentesque quis scelerisque dolor. Fusce posuere iaculis dictum. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus. Interdum et malesuada fames ac ante ipsum primis in faucibus. Donec sed eros fringilla; nullam.\r\n','filtered_html'),('comment','comment_node_blog',0,36,36,'und',0,'Nulla adipiscing quam eros, eleifend gravida mi ornare eget. Proin id nunc dui. Duis eleifend mi non tellus porta, vitae semper eros pulvinar. Suspendisse adipiscing orci eu porta pretium. Donec at est sed tortor placerat tempor nec pulvinar nisl. Proin at arcu vitae sem vestibulum pharetra sed sed.\r\n','filtered_html'),('comment','comment_node_blog',0,37,37,'und',0,'Pellentesque placerat elementum felis nec interdum. Etiam a felis vel urna egestas molestie. Class aptent taciti sociosqu ad litora torquent per conubia nostra, per inceptos himenaeos. Aliquam pulvinar eleifend ipsum et imperdiet. Curabitur quis libero malesuada, tincidunt mauris ut aenean suscipit.\r\n','filtered_html'),('comment','comment_node_blog',0,38,38,'und',0,'Phasellus viverra nulla ut metus varius laoreet. Suspendisse potenti. Nam adipiscing. Donec posuere vulputate arcu. Sed magna purus, fermentum eu, tincidunt eu, varius ut, felis.','filtered_html'),('comment','comment_node_blog',0,39,39,'und',0,'Vestibulum purus quam, scelerisque ut, mollis sed, nonummy id, metus. Suspendisse non nisl sit amet velit hendrerit rutrum. Vestibulum dapibus nunc ac augue. Praesent adipiscing. Sed mollis, eros et ultrices tempus, mauris ipsum aliquam libero, non adipiscing dolor urna a orci.','filtered_html'),('comment','comment_node_blog',0,40,40,'und',0,'Morbi neque arcu, malesuada tempor elit et; porttitor gravida tellus? Duis mattis sit amet est sed laoreet. Nunc venenatis felis nunc, non sagittis nunc ultricies et. Maecenas semper sed ante non viverra. Aenean a aliquam urna. Etiam faucibus commodo eleifend. Aliquam ornare dapibus nulla cras amet.\r\n','filtered_html'),('comment','comment_node_blog',0,41,41,'und',0,'Fusce neque. Ut a nisl id ante tempus hendrerit. Donec interdum, metus et hendrerit aliquet, dolor diam sagittis ligula, eget egestas libero turpis vel mi. Nullam dictum felis eu pede mollis pretium. Etiam sollicitudin, ipsum eu pulvinar rutrum, tellus ipsum laoreet sapien, quis venenatis ante odio sit amet eros.','filtered_html'),('comment','comment_node_blog',0,42,42,'und',0,'Nullam nulla eros, ultricies sit amet, nonummy id, imperdiet feugiat, pede. Vestibulum fringilla pede sit amet augue. Nam adipiscing. Aenean ut eros et nisl sagittis vestibulum. Curabitur ullamcorper ultricies nisi.','filtered_html'),('comment','comment_node_blog',0,43,43,'und',0,'Quisque libero metus, condimentum nec, tempor a, commodo mollis, magna. Aenean imperdiet. Lorem ipsum dolor sit amet, consectetuer adipiscing elit. Mauris sollicitudin fermentum libero. Maecenas tempus, tellus eget condimentum rhoncus, sem quam semper libero, sit amet adipiscing sem neque sed ipsum.','filtered_html'),('comment','comment_node_blog',0,44,44,'und',0,'Cras varius. Curabitur suscipit suscipit tellus. Sed libero. Nunc nulla. Nulla facilisi.','filtered_html'),('comment','comment_node_blog',0,45,45,'und',0,'In hac habitasse platea dictumst. Vivamus euismod mauris. Vestibulum fringilla pede sit amet augue. Aenean commodo ligula eget dolor. Mauris sollicitudin fermentum libero.','filtered_html'),('comment','comment_node_forum',0,46,46,'und',0,'Quisque libero metus, condimentum nec, tempor a, commodo mollis, magna. Nulla sit amet est. Donec quam felis, ultricies nec, pellentesque eu, pretium quis, sem. Aenean posuere, tortor sed cursus feugiat, nunc augue blandit nunc, eu sollicitudin urna dolor sagittis lacus. Curabitur blandit mollis lacus.\r\n\r\nPraesent vestibulum dapibus nibh. Nunc nonummy metus. Aliquam lobortis. Cras non dolor. Etiam feugiat lorem non metus.','filtered_html'),('comment','comment_node_forum',0,47,47,'und',0,'Nunc lobortis egestas justo, id aliquet dolor blandit ut. Donec vitae tortor enim. Nulla dictum; urna quis fermentum vulputate, leo ipsum porta dui, eu gravida erat ligula eget eros! In vel aliquam libero, ac tempus urna. Fusce quis leo iaculis, iaculis magna ut, eleifend nulla. Morbi commodo metus.\r\n','filtered_html'),('comment','comment_node_forum',0,48,48,'und',0,'Sed sit amet ullamcorper mauris. Duis pulvinar at nisl vel auctor. Etiam hendrerit non nibh at adipiscing. Aliquam semper eros ut tortor ullamcorper blandit. Cras mollis auctor orci eu vestibulum. Aenean vitae volutpat nisi. Class aptent taciti sociosqu ad litora torquent per conubia nostra posuere.\r\n','filtered_html'),('comment','comment_node_forum',0,49,49,'und',0,'Suspendisse potenti. Integer tincidunt. Ut a nisl id ante tempus hendrerit. Suspendisse pulvinar, augue ac venenatis condimentum, sem libero volutpat nibh, nec pellentesque velit pede quis nunc. Vivamus in erat ut urna cursus vestibulum.','filtered_html'),('comment','comment_node_video',0,50,50,'und',0,'Curabitur ullamcorper ultricies nisi. Nullam tincidunt adipiscing enim. Etiam iaculis nunc ac metus. Curabitur at lacus ac velit ornare lobortis. Pellentesque commodo eros a enim.','filtered_html'),('comment','comment_node_forum',0,51,51,'und',0,'In hac habitasse platea dictumst. Morbi vestibulum volutpat enim. Fusce commodo aliquam arcu. Quisque libero metus, condimentum nec, tempor a, commodo mollis, magna. Maecenas vestibulum mollis diam.','filtered_html'),('comment','comment_node_forum',0,52,52,'und',0,'Phasellus a tellus erat. Curabitur ut euismod sem. Proin eu neque a ligula bibendum porta! Fusce faucibus neque id egestas tristique. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Morbi dignissim dictum lectus in tristique. Suspendisse luctus vehicula metus.\r\n','filtered_html'),('comment','comment_node_forum',0,53,53,'und',0,'Donec venenatis vulputate lorem. Donec orci lectus, aliquam ut, faucibus non, euismod id, nulla. Cras dapibus. Phasellus nec sem in justo pellentesque facilisis. Mauris sollicitudin fermentum libero.','filtered_html');
/*!40000 ALTER TABLE `field_data_comment_body` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `field_data_field_category`
--

DROP TABLE IF EXISTS `field_data_field_category`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_category` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_category_tid` int(10) unsigned DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_category_tid` (`field_category_tid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Data storage for field 12 (field_category)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_category`
--

LOCK TABLES `field_data_field_category` WRITE;
/*!40000 ALTER TABLE `field_data_field_category` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `field_data_field_category` VALUES ('node','article',0,4,4,'und',0,25),('node','article',0,5,5,'und',0,26),('node','article',0,6,6,'und',0,22),('node','article',0,12,12,'und',0,23),('node','article',0,27,27,'und',0,23),('node','article',0,28,28,'und',0,22),('node','article',0,29,29,'und',0,24),('node','article',0,30,30,'und',0,25),('node','article',0,31,31,'und',0,21);
/*!40000 ALTER TABLE `field_data_field_category` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `field_data_field_comment_ref`
--

DROP TABLE IF EXISTS `field_data_field_comment_ref`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_comment_ref` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_comment_ref_target_id` int(10) unsigned NOT NULL COMMENT 'The id of the target entity.',
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_comment_ref_target_id` (`field_comment_ref_target_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Data storage for field 8 (field_comment_ref)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_comment_ref`
--

LOCK TABLES `field_data_field_comment_ref` WRITE;
/*!40000 ALTER TABLE `field_data_field_comment_ref` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `field_data_field_comment_ref` VALUES ('message','example_create_comment',0,9,9,'und',0,2),('message','example_create_comment',0,10,10,'und',0,3),('message','example_create_comment',0,11,11,'und',0,4),('message','example_create_comment',0,12,12,'und',0,5),('message','example_create_comment',0,13,13,'und',0,6),('message','example_create_comment',0,15,15,'und',0,7),('message','example_create_comment',0,19,19,'und',0,8),('message','example_create_comment',0,21,21,'und',0,9),('message','example_create_comment',0,23,23,'und',0,10),('message','example_create_comment',0,54,54,'und',0,11),('message','example_create_comment',0,55,55,'und',0,12),('message','example_create_comment',0,56,56,'und',0,13),('message','example_create_comment',0,57,57,'und',0,14),('message','example_create_comment',0,59,59,'und',0,15),('message','example_create_comment',0,60,60,'und',0,16),('message','example_create_comment',0,61,61,'und',0,17),('message','example_create_comment',0,68,68,'und',0,18),('message','example_create_comment',0,69,69,'und',0,19),('message','example_create_comment',0,70,70,'und',0,20),('message','example_create_comment',0,71,71,'und',0,21),('message','example_create_comment',0,72,72,'und',0,22),('message','example_create_comment',0,73,73,'und',0,23),('message','example_create_comment',0,74,74,'und',0,24),('message','example_create_comment',0,75,75,'und',0,25),('message','example_create_comment',0,76,76,'und',0,26),('message','example_create_comment',0,77,77,'und',0,27),('message','example_create_comment',0,78,78,'und',0,28),('message','example_create_comment',0,80,80,'und',0,29),('message','example_create_comment',0,81,81,'und',0,30),('message','example_create_comment',0,82,82,'und',0,31),('message','example_create_comment',0,83,83,'und',0,32),('message','example_create_comment',0,84,84,'und',0,33),('message','example_create_comment',0,85,85,'und',0,34),('message','example_create_comment',0,86,86,'und',0,35),('message','example_create_comment',0,87,87,'und',0,36),('message','example_create_comment',0,88,88,'und',0,37),('message','example_create_comment',0,89,89,'und',0,38),('message','example_create_comment',0,90,90,'und',0,39),('message','example_create_comment',0,91,91,'und',0,40),('message','example_create_comment',0,92,92,'und',0,41),('message','example_create_comment',0,93,93,'und',0,42),('message','example_create_comment',0,94,94,'und',0,43),('message','example_create_comment',0,95,95,'und',0,44),('message','example_create_comment',0,96,96,'und',0,45),('message','example_create_comment',0,99,99,'und',0,46),('message','example_create_comment',0,100,100,'und',0,47),('message','example_create_comment',0,101,101,'und',0,48),('message','example_create_comment',0,103,103,'und',0,49),('message','example_create_comment',0,105,105,'und',0,50),('message','example_create_comment',0,106,106,'und',0,51),('message','example_create_comment',0,107,107,'und',0,52),('message','example_create_comment',0,108,108,'und',0,53);
/*!40000 ALTER TABLE `field_data_field_comment_ref` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `field_data_field_description`
--

DROP TABLE IF EXISTS `field_data_field_description`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_description` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_description_value` longtext,
  `field_description_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_description_format` (`field_description_format`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Data storage for field 17 (field_description)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_description`
--

LOCK TABLES `field_data_field_description` WRITE;
/*!40000 ALTER TABLE `field_data_field_description` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `field_data_field_description` VALUES ('field_collection_item','field_extra_content',0,9,9,'und',0,'Aliquam eu nunc. Vestibulum purus quam, scelerisque ut, mollis sed, nonummy id, metus. Vestibulum dapibus nunc ac augue. Maecenas tempus, tellus eget condimentum rhoncus, sem quam semper libero, sit amet adipiscing sem neque sed ipsum. Fusce vel dui. Vivamus consectetuer hendrerit lacus. Suspendisse faucibus, nunc et pellentesque egestas, lacus ante convallis tellus, vitae iaculis lacus elit id tortor. Vestibulum suscipit nulla quis orci. Fusce neque. Quisque rutrum.',NULL),('field_collection_item','field_extra_content',0,10,10,'und',0,'Aliquam eu nunc. Vestibulum purus quam, scelerisque ut, mollis sed, nonummy id, metus. Vestibulum dapibus nunc ac augue. Maecenas tempus, tellus eget condimentum rhoncus, sem quam semper libero, sit amet adipiscing sem neque sed ipsum. Fusce vel dui. Vivamus consectetuer hendrerit lacus. Suspendisse faucibus, nunc et pellentesque egestas, lacus ante convallis tellus, vitae iaculis lacus elit id tortor. Vestibulum suscipit nulla quis orci. Fusce neque. Quisque rutrum.',NULL),('field_collection_item','field_extra_content',0,11,11,'und',0,'Aliquam eu nunc. Vestibulum purus quam, scelerisque ut, mollis sed, nonummy id, metus. Vestibulum dapibus nunc ac augue. Maecenas tempus, tellus eget condimentum rhoncus, sem quam semper libero, sit amet adipiscing sem neque sed ipsum. Fusce vel dui. Vivamus consectetuer hendrerit lacus. Suspendisse faucibus, nunc et pellentesque egestas, lacus ante convallis tellus, vitae iaculis lacus elit id tortor. Vestibulum suscipit nulla quis orci. Fusce neque. Quisque rutrum.',NULL),('field_collection_item','field_extra_content',0,12,12,'und',0,'Aliquam eu nunc. Vestibulum purus quam, scelerisque ut, mollis sed, nonummy id, metus. Vestibulum dapibus nunc ac augue. Maecenas tempus, tellus eget condimentum rhoncus, sem quam semper libero, sit amet adipiscing sem neque sed ipsum. Fusce vel dui. Vivamus consectetuer hendrerit lacus. Suspendisse faucibus, nunc et pellentesque egestas, lacus ante convallis tellus, vitae iaculis lacus elit id tortor. Vestibulum suscipit nulla quis orci. Fusce neque. Quisque rutrum.',NULL),('field_collection_item','field_extra_content',0,13,13,'und',0,'Sed magna purus, fermentum eu, tincidunt eu, varius ut, felis. Pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas. Vivamus aliquet elit ac nisl. Ut varius tincidunt libero. Nulla sit amet est. Proin faucibus arcu quis ante. Praesent metus tellus, elementum eu, semper a, adipiscing nec, purus. Proin viverra, ligula sit amet ultrices semper, ligula arcu tristique sapien, a accumsan nisi mauris ac eros. Mauris turpis nunc, blandit et, volutpat molestie, porta ut, ligula. Phasellus accumsan cursus velit.',NULL),('field_collection_item','field_extra_content',0,14,14,'und',0,'Aenean viverra rhoncus pede. In dui magna, posuere eget, vestibulum et, tempor auctor, justo. Nullam dictum felis eu pede mollis pretium. Vestibulum turpis sem, aliquet eget, lobortis pellentesque, rutrum eu, nisl. Vivamus laoreet.',NULL),('field_collection_item','field_extra_content',0,15,15,'und',0,'Praesent congue erat at massa. Aenean vulputate eleifend tellus. Vestibulum suscipit nulla quis orci. Praesent nec nisl a purus blandit viverra. Nam quam nunc, blandit vel, luctus pulvinar, hendrerit id, lorem.',NULL),('field_collection_item','field_extra_content',0,16,16,'und',0,'Phasellus gravida semper nisi. Praesent congue erat at massa. Nullam vel sem. Nullam vel sem. Vivamus consectetuer hendrerit lacus.',NULL),('field_collection_item','field_extra_content',0,17,17,'und',0,'Maecenas tempus, tellus eget condimentum rhoncus, sem quam semper libero, sit amet adipiscing sem neque sed ipsum. Vivamus laoreet. Cras sagittis. Pellentesque auctor neque nec urna. Nullam quis ante.',NULL),('field_collection_item','field_extra_content',0,18,18,'und',0,'In turpis. In hac habitasse platea dictumst. Vivamus quis mi. Sed consequat, leo eget bibendum sodales, augue velit cursus nunc, quis gravida magna mi a libero. Quisque malesuada placerat nisl.',NULL),('field_collection_item','field_extra_content',0,19,19,'und',0,'Quisque rutrum. Sed consequat, leo eget bibendum sodales, augue velit cursus nunc, quis gravida magna mi a libero. Suspendisse pulvinar, augue ac venenatis condimentum, sem libero volutpat nibh, nec pellentesque velit pede quis nunc. Curabitur suscipit suscipit tellus. Nulla neque dolor, sagittis eget, iaculis quis, molestie non, velit.',NULL),('field_collection_item','field_extra_content',0,26,26,'und',0,'Ut varius tincidunt libero. Sed lectus. Fusce vel dui. Aenean commodo ligula eget dolor. Fusce vulputate eleifend sapien.',NULL),('field_collection_item','field_extra_content',0,27,27,'und',0,'Nam ipsum risus, rutrum vitae, vestibulum eu, molestie vel, lacus. Fusce egestas elit eget lorem. Duis leo. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Fusce id purus. Donec id justo. Quisque id odio. Nunc interdum lacus sit amet orci. Vestibulum dapibus nunc ac augue. Etiam iaculis nunc ac metus. Nunc nonummy metus.',NULL),('field_collection_item','field_extra_content',0,28,28,'und',0,'Vestibulum fringilla pede sit amet augue. Suspendisse enim turpis, dictum sed, iaculis a, condimentum nec, nisi. Mauris sollicitudin fermentum libero. Praesent ac sem eget est egestas volutpat. In enim justo, rhoncus ut, imperdiet a, venenatis vitae, justo. Aliquam erat volutpat. Sed fringilla mauris sit amet nibh. Suspendisse enim turpis, dictum sed, iaculis a, condimentum nec, nisi. Morbi ac felis. Phasellus nec sem in justo pellentesque facilisis.',NULL);
/*!40000 ALTER TABLE `field_data_field_description` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `field_data_field_detailed_question`
--

DROP TABLE IF EXISTS `field_data_field_detailed_question`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_detailed_question` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_detailed_question_value` longtext,
  `field_detailed_question_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_detailed_question_format` (`field_detailed_question_format`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Data storage for field 18 (field_detailed_question)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_detailed_question`
--

LOCK TABLES `field_data_field_detailed_question` WRITE;
/*!40000 ALTER TABLE `field_data_field_detailed_question` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `field_data_field_detailed_question` VALUES ('node','faq',0,13,13,'und',0,'','filtered_html'),('node','faq',0,14,14,'und',0,'','filtered_html'),('node','faq',0,58,58,'und',0,'','filtered_html'),('node','faq',0,59,59,'und',0,'','filtered_html'),('node','faq',0,60,60,'und',0,'','filtered_html'),('node','faq',0,61,61,'und',0,'','filtered_html'),('node','faq',0,62,62,'und',0,'','filtered_html'),('node','faq',0,63,63,'und',0,'','filtered_html'),('node','faq',0,64,64,'und',0,'','filtered_html'),('node','faq',0,65,65,'und',0,'','filtered_html'),('node','faq',0,66,66,'und',0,'','filtered_html'),('node','faq',0,67,67,'und',0,'','filtered_html');
/*!40000 ALTER TABLE `field_data_field_detailed_question` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `field_data_field_extra_content`
--

DROP TABLE IF EXISTS `field_data_field_extra_content`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_extra_content` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_extra_content_value` int(11) DEFAULT NULL COMMENT 'The field collection item id.',
  `field_extra_content_revision_id` int(11) DEFAULT NULL COMMENT 'The field collection item revision id.',
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_extra_content_revision_id` (`field_extra_content_revision_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Data storage for field 16 (field_extra_content)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_extra_content`
--

LOCK TABLES `field_data_field_extra_content` WRITE;
/*!40000 ALTER TABLE `field_data_field_extra_content` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `field_data_field_extra_content` VALUES ('node','blog',0,7,7,'und',0,9,9),('node','blog',0,7,7,'und',1,10,10),('node','blog',0,7,7,'und',2,11,11),('node','blog',0,8,8,'und',0,12,12),('node','blog',0,8,8,'und',1,13,13),('node','blog',0,9,9,'und',0,14,14),('node','blog',0,9,9,'und',1,15,15),('node','article',0,28,28,'und',0,27,27),('node','article',0,29,29,'und',0,26,26),('node','article',0,31,31,'und',0,16,16),('node','article',0,31,31,'und',1,17,17),('node','forum',0,47,47,'und',0,28,28),('node','forum',0,54,54,'und',0,18,18),('node','forum',0,55,55,'und',0,19,19),('node','forum',0,55,55,'und',1,20,20),('node','forum',0,55,55,'und',2,21,21),('node','forum',0,56,56,'und',0,24,24);
/*!40000 ALTER TABLE `field_data_field_extra_content` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `field_data_field_image`
--

DROP TABLE IF EXISTS `field_data_field_image`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_image` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_image_fid` int(10) unsigned DEFAULT NULL COMMENT 'The file_managed.fid being referenced in this field.',
  `field_image_alt` varchar(512) DEFAULT NULL COMMENT 'Alternative image text, for the image’s ’alt’ attribute.',
  `field_image_title` varchar(1024) DEFAULT NULL COMMENT 'Image title text, for the image’s ’title’ attribute.',
  `field_image_width` int(10) unsigned DEFAULT NULL COMMENT 'The width of the image in pixels.',
  `field_image_height` int(10) unsigned DEFAULT NULL COMMENT 'The height of the image in pixels.',
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_image_fid` (`field_image_fid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Data storage for field 4 (field_image)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_image`
--

LOCK TABLES `field_data_field_image` WRITE;
/*!40000 ALTER TABLE `field_data_field_image` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `field_data_field_image` VALUES ('field_collection_item','field_extra_content',0,9,9,'und',0,120,'','',1170,580),('field_collection_item','field_extra_content',0,10,10,'und',0,121,'','',1170,580),('field_collection_item','field_extra_content',0,11,11,'und',0,122,'','',1170,580),('field_collection_item','field_extra_content',0,12,12,'und',0,123,'','',1170,580),('field_collection_item','field_extra_content',0,13,13,'und',0,124,'','',1170,580),('field_collection_item','field_extra_content',0,14,14,'und',0,125,'','',1170,780),('field_collection_item','field_extra_content',0,15,15,'und',0,126,'','',1170,780),('field_collection_item','field_extra_content',0,16,16,'und',0,127,'','',1170,780),('field_collection_item','field_extra_content',0,17,17,'und',0,128,'','',1170,780),('field_collection_item','field_extra_content',0,18,18,'und',0,129,'','',1170,760),('field_collection_item','field_extra_content',0,19,19,'und',0,130,'','',1170,760),('field_collection_item','field_extra_content',0,21,21,'und',0,132,'','',1170,780),('field_collection_item','field_extra_content',0,26,26,'und',0,140,'','',1170,780),('field_collection_item','field_extra_content',0,27,27,'und',0,142,'','',1170,780),('field_collection_item','field_extra_content',0,28,28,'und',0,149,'','',1170,780),('node','article',0,4,4,'und',0,147,'','',1170,780),('node','article',0,5,5,'und',0,148,'','',1170,780),('node','article',0,6,6,'und',0,145,'','',1170,760),('node','blog',0,7,7,'und',0,99,'','',1170,780),('node','blog',0,8,8,'und',0,100,'','',1170,760),('node','blog',0,9,9,'und',0,101,'','',1170,780),('node','blog',0,10,10,'und',0,103,'','',1170,780),('node','blog',0,11,11,'und',0,102,'','',1170,780),('node','article',0,12,12,'und',0,144,'','',1170,760),('node','article',0,27,27,'und',0,143,'','',1170,760),('node','article',0,28,28,'und',0,141,'','',1170,780),('node','article',0,29,29,'und',0,139,'','',1170,780),('node','article',0,30,30,'und',0,138,'','',1170,780),('node','article',0,31,31,'und',0,137,'','',1170,780),('node','products',0,48,48,'und',0,156,'','',960,460),('node','products',0,49,49,'und',0,157,'','',960,460),('node','products',0,50,50,'und',0,158,'','',960,460),('node','products',0,51,51,'und',0,159,'','',960,460),('node','products',0,52,52,'und',0,160,'','',960,460);
/*!40000 ALTER TABLE `field_data_field_image` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `field_data_field_link`
--

DROP TABLE IF EXISTS `field_data_field_link`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_link` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_link_url` varchar(2048) DEFAULT NULL,
  `field_link_title` varchar(255) DEFAULT NULL,
  `field_link_attributes` mediumtext,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Data storage for field 14 (field_link)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_link`
--

LOCK TABLES `field_data_field_link` WRITE;
/*!40000 ALTER TABLE `field_data_field_link` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `field_data_field_link` VALUES ('node','products',0,48,48,'und',0,'http://weebpal.com/drupal-themes','Read More','a:0:{}'),('node','products',0,49,49,'und',0,'http://weebpal.com/drupal-themes','Read More','a:0:{}'),('node','products',0,50,50,'und',0,'http://weebpal.com/drupal-themes','Read More','a:0:{}'),('node','products',0,51,51,'und',0,'http://weebpal.com/drupal-themes','Read More','a:0:{}'),('node','products',0,52,52,'und',0,'http://weebpal.com/drupal-themes','Read More','a:0:{}');
/*!40000 ALTER TABLE `field_data_field_link` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `field_data_field_node_ref`
--

DROP TABLE IF EXISTS `field_data_field_node_ref`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_node_ref` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_node_ref_target_id` int(10) unsigned NOT NULL COMMENT 'The id of the target entity.',
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_node_ref_target_id` (`field_node_ref_target_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Data storage for field 9 (field_node_ref)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_node_ref`
--

LOCK TABLES `field_data_field_node_ref` WRITE;
/*!40000 ALTER TABLE `field_data_field_node_ref` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `field_data_field_node_ref` VALUES ('message','example_create_node',0,2,2,'und',0,5),('message','example_create_node',0,3,3,'und',0,6),('message','example_create_node',0,4,4,'und',0,7),('message','example_create_node',0,5,5,'und',0,8),('message','example_create_node',0,6,6,'und',0,9),('message','example_create_node',0,7,7,'und',0,10),('message','example_create_node',0,8,8,'und',0,11),('message','example_create_comment',0,9,9,'und',0,11),('message','example_create_comment',0,10,10,'und',0,11),('message','example_create_comment',0,11,11,'und',0,9),('message','example_create_comment',0,12,12,'und',0,7),('message','example_create_comment',0,13,13,'und',0,9),('message','example_create_node',0,14,14,'und',0,12),('message','example_create_comment',0,15,15,'und',0,12),('message','example_create_node',0,16,16,'und',0,13),('message','example_create_node',0,17,17,'und',0,14),('message','example_create_node',0,18,18,'und',0,15),('message','example_create_comment',0,19,19,'und',0,15),('message','example_create_comment',0,21,21,'und',0,15),('message','example_create_node',0,22,22,'und',0,16),('message','example_create_comment',0,23,23,'und',0,16),('message','example_create_node',0,24,24,'und',0,17),('message','example_create_node',0,25,25,'und',0,18),('message','example_create_node',0,26,26,'und',0,19),('message','example_create_node',0,27,27,'und',0,20),('message','example_create_node',0,28,28,'und',0,21),('message','example_create_node',0,29,29,'und',0,22),('message','example_create_node',0,30,30,'und',0,23),('message','example_create_node',0,31,31,'und',0,24),('message','example_create_node',0,32,32,'und',0,25),('message','example_create_node',0,33,33,'und',0,26),('message','example_create_node',0,34,34,'und',0,27),('message','example_create_node',0,35,35,'und',0,28),('message','example_create_node',0,36,36,'und',0,29),('message','example_create_node',0,37,37,'und',0,30),('message','example_create_node',0,38,38,'und',0,31),('message','example_create_node',0,40,40,'und',0,33),('message','example_create_node',0,41,41,'und',0,34),('message','example_create_node',0,42,42,'und',0,35),('message','example_create_node',0,43,43,'und',0,36),('message','example_create_node',0,44,44,'und',0,37),('message','example_create_node',0,45,45,'und',0,38),('message','example_create_node',0,46,46,'und',0,39),('message','example_create_node',0,47,47,'und',0,40),('message','example_create_node',0,48,48,'und',0,41),('message','example_create_node',0,49,49,'und',0,42),('message','example_create_node',0,50,50,'und',0,43),('message','example_create_node',0,51,51,'und',0,44),('message','example_create_node',0,52,52,'und',0,45),('message','example_create_node',0,53,53,'und',0,46),('message','example_create_comment',0,54,54,'und',0,31),('message','example_create_comment',0,55,55,'und',0,31),('message','example_create_comment',0,56,56,'und',0,31),('message','example_create_comment',0,57,57,'und',0,30),('message','example_create_node',0,58,58,'und',0,47),('message','example_create_comment',0,59,59,'und',0,5),('message','example_create_comment',0,60,60,'und',0,5),('message','example_create_comment',0,61,61,'und',0,10),('message','example_create_node',0,62,62,'und',0,48),('message','example_create_node',0,63,63,'und',0,49),('message','example_create_node',0,64,64,'und',0,50),('message','example_create_node',0,65,65,'und',0,51),('message','example_create_node',0,66,66,'und',0,52),('message','example_create_node',0,67,67,'und',0,53),('message','example_create_comment',0,68,68,'und',0,53),('message','example_create_comment',0,69,69,'und',0,53),('message','example_create_comment',0,70,70,'und',0,53),('message','example_create_comment',0,71,71,'und',0,53),('message','example_create_comment',0,72,72,'und',0,53),('message','example_create_comment',0,73,73,'und',0,53),('message','example_create_comment',0,74,74,'und',0,53),('message','example_create_comment',0,75,75,'und',0,53),('message','example_create_comment',0,76,76,'und',0,53),('message','example_create_comment',0,77,77,'und',0,53),('message','example_create_comment',0,78,78,'und',0,53),('message','example_create_comment',0,80,80,'und',0,53),('message','example_create_comment',0,81,81,'und',0,7),('message','example_create_comment',0,82,82,'und',0,7),('message','example_create_comment',0,83,83,'und',0,7),('message','example_create_comment',0,84,84,'und',0,7),('message','example_create_comment',0,85,85,'und',0,7),('message','example_create_comment',0,86,86,'und',0,7),('message','example_create_comment',0,87,87,'und',0,7),('message','example_create_comment',0,88,88,'und',0,7),('message','example_create_comment',0,89,89,'und',0,7),('message','example_create_comment',0,90,90,'und',0,7),('message','example_create_comment',0,91,91,'und',0,7),('message','example_create_comment',0,92,92,'und',0,8),('message','example_create_comment',0,93,93,'und',0,8),('message','example_create_comment',0,94,94,'und',0,8),('message','example_create_comment',0,95,95,'und',0,8),('message','example_create_comment',0,96,96,'und',0,9),('message','example_create_node',0,97,97,'und',0,54),('message','example_create_node',0,98,98,'und',0,55),('message','example_create_comment',0,99,99,'und',0,55),('message','example_create_comment',0,100,100,'und',0,55),('message','example_create_comment',0,101,101,'und',0,54),('message','example_create_node',0,102,102,'und',0,56),('message','example_create_comment',0,103,103,'und',0,56),('message','example_create_node',0,104,104,'und',0,57),('message','example_create_comment',0,105,105,'und',0,37),('message','example_create_comment',0,106,106,'und',0,47),('message','example_create_comment',0,107,107,'und',0,3),('message','example_create_comment',0,108,108,'und',0,1),('message','example_create_node',0,109,109,'und',0,58),('message','example_create_node',0,110,110,'und',0,59),('message','example_create_node',0,111,111,'und',0,60),('message','example_create_node',0,112,112,'und',0,61),('message','example_create_node',0,113,113,'und',0,62),('message','example_create_node',0,114,114,'und',0,63),('message','example_create_node',0,115,115,'und',0,64),('message','example_create_node',0,116,116,'und',0,65),('message','example_create_node',0,117,117,'und',0,66),('message','example_create_node',0,118,118,'und',0,67),('message','example_create_node',0,119,119,'und',0,68),('message','example_create_node',0,120,120,'und',0,69);
/*!40000 ALTER TABLE `field_data_field_node_ref` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `field_data_field_published`
--

DROP TABLE IF EXISTS `field_data_field_published`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_published` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_published_value` int(11) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_published_value` (`field_published_value`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Data storage for field 10 (field_published)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_published`
--

LOCK TABLES `field_data_field_published` WRITE;
/*!40000 ALTER TABLE `field_data_field_published` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `field_data_field_published` VALUES ('message','example_user_register',0,1,1,'und',0,0),('message','example_create_node',0,2,2,'und',0,1),('message','example_create_node',0,3,3,'und',0,1),('message','example_create_node',0,4,4,'und',0,1),('message','example_create_node',0,5,5,'und',0,1),('message','example_create_node',0,6,6,'und',0,1),('message','example_create_node',0,7,7,'und',0,1),('message','example_create_node',0,8,8,'und',0,1),('message','example_create_comment',0,9,9,'und',0,1),('message','example_create_comment',0,10,10,'und',0,1),('message','example_create_comment',0,11,11,'und',0,1),('message','example_create_comment',0,12,12,'und',0,1),('message','example_create_comment',0,13,13,'und',0,1),('message','example_create_node',0,14,14,'und',0,1),('message','example_create_comment',0,15,15,'und',0,1),('message','example_create_node',0,16,16,'und',0,1),('message','example_create_node',0,17,17,'und',0,1),('message','example_create_node',0,18,18,'und',0,1),('message','example_create_comment',0,19,19,'und',0,1),('message','example_user_register',0,20,20,'und',0,1),('message','example_create_comment',0,21,21,'und',0,1),('message','example_create_node',0,22,22,'und',0,1),('message','example_create_comment',0,23,23,'und',0,1),('message','example_create_node',0,24,24,'und',0,1),('message','example_create_node',0,25,25,'und',0,1),('message','example_create_node',0,26,26,'und',0,1),('message','example_create_node',0,27,27,'und',0,1),('message','example_create_node',0,28,28,'und',0,1),('message','example_create_node',0,29,29,'und',0,1),('message','example_create_node',0,30,30,'und',0,1),('message','example_create_node',0,31,31,'und',0,1),('message','example_create_node',0,32,32,'und',0,1),('message','example_create_node',0,33,33,'und',0,1),('message','example_create_node',0,34,34,'und',0,1),('message','example_create_node',0,35,35,'und',0,1),('message','example_create_node',0,36,36,'und',0,1),('message','example_create_node',0,37,37,'und',0,1),('message','example_create_node',0,38,38,'und',0,1),('message','example_create_node',0,40,40,'und',0,1),('message','example_create_node',0,41,41,'und',0,1),('message','example_create_node',0,42,42,'und',0,1),('message','example_create_node',0,43,43,'und',0,1),('message','example_create_node',0,44,44,'und',0,1),('message','example_create_node',0,45,45,'und',0,1),('message','example_create_node',0,46,46,'und',0,1),('message','example_create_node',0,47,47,'und',0,1),('message','example_create_node',0,48,48,'und',0,1),('message','example_create_node',0,49,49,'und',0,1),('message','example_create_node',0,50,50,'und',0,1),('message','example_create_node',0,51,51,'und',0,1),('message','example_create_node',0,52,52,'und',0,1),('message','example_create_node',0,53,53,'und',0,1),('message','example_create_comment',0,54,54,'und',0,1),('message','example_create_comment',0,55,55,'und',0,1),('message','example_create_comment',0,56,56,'und',0,1),('message','example_create_comment',0,57,57,'und',0,1),('message','example_create_node',0,58,58,'und',0,1),('message','example_create_comment',0,59,59,'und',0,1),('message','example_create_comment',0,60,60,'und',0,1),('message','example_create_comment',0,61,61,'und',0,1),('message','example_create_node',0,62,62,'und',0,1),('message','example_create_node',0,63,63,'und',0,1),('message','example_create_node',0,64,64,'und',0,1),('message','example_create_node',0,65,65,'und',0,1),('message','example_create_node',0,66,66,'und',0,1),('message','example_create_node',0,67,67,'und',0,1),('message','example_create_comment',0,68,68,'und',0,1),('message','example_create_comment',0,69,69,'und',0,1),('message','example_create_comment',0,70,70,'und',0,1),('message','example_create_comment',0,71,71,'und',0,1),('message','example_create_comment',0,72,72,'und',0,1),('message','example_create_comment',0,73,73,'und',0,1),('message','example_create_comment',0,74,74,'und',0,1),('message','example_create_comment',0,75,75,'und',0,1),('message','example_create_comment',0,76,76,'und',0,1),('message','example_create_comment',0,77,77,'und',0,1),('message','example_create_comment',0,78,78,'und',0,1),('message','example_user_register',0,79,79,'und',0,1),('message','example_create_comment',0,80,80,'und',0,1),('message','example_create_comment',0,81,81,'und',0,1),('message','example_create_comment',0,82,82,'und',0,1),('message','example_create_comment',0,83,83,'und',0,1),('message','example_create_comment',0,84,84,'und',0,1),('message','example_create_comment',0,85,85,'und',0,1),('message','example_create_comment',0,86,86,'und',0,1),('message','example_create_comment',0,87,87,'und',0,1),('message','example_create_comment',0,88,88,'und',0,1),('message','example_create_comment',0,89,89,'und',0,1),('message','example_create_comment',0,90,90,'und',0,1),('message','example_create_comment',0,91,91,'und',0,1),('message','example_create_comment',0,92,92,'und',0,1),('message','example_create_comment',0,93,93,'und',0,1),('message','example_create_comment',0,94,94,'und',0,1),('message','example_create_comment',0,95,95,'und',0,1),('message','example_create_comment',0,96,96,'und',0,1),('message','example_create_node',0,97,97,'und',0,1),('message','example_create_node',0,98,98,'und',0,1),('message','example_create_comment',0,99,99,'und',0,1),('message','example_create_comment',0,100,100,'und',0,1),('message','example_create_comment',0,101,101,'und',0,1),('message','example_create_node',0,102,102,'und',0,1),('message','example_create_comment',0,103,103,'und',0,1),('message','example_create_node',0,104,104,'und',0,1),('message','example_create_comment',0,105,105,'und',0,1),('message','example_create_comment',0,106,106,'und',0,1),('message','example_create_comment',0,107,107,'und',0,1),('message','example_create_comment',0,108,108,'und',0,1),('message','example_create_node',0,109,109,'und',0,1),('message','example_create_node',0,110,110,'und',0,1),('message','example_create_node',0,111,111,'und',0,1),('message','example_create_node',0,112,112,'und',0,1),('message','example_create_node',0,113,113,'und',0,1),('message','example_create_node',0,114,114,'und',0,1),('message','example_create_node',0,115,115,'und',0,1),('message','example_create_node',0,116,116,'und',0,1),('message','example_create_node',0,117,117,'und',0,1),('message','example_create_node',0,118,118,'und',0,1),('message','example_create_node',0,119,119,'und',0,1),('message','example_create_node',0,120,120,'und',0,1);
/*!40000 ALTER TABLE `field_data_field_published` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `field_data_field_section`
--

DROP TABLE IF EXISTS `field_data_field_section`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_section` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_section_tid` int(10) unsigned DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_section_tid` (`field_section_tid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Data storage for field 11 (field_section)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_section`
--

LOCK TABLES `field_data_field_section` WRITE;
/*!40000 ALTER TABLE `field_data_field_section` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `field_data_field_section` VALUES ('node','article',0,4,4,'und',0,29),('node','article',0,5,5,'und',0,28),('node','article',0,6,6,'und',0,30),('node','article',0,12,12,'und',0,27),('node','article',0,27,27,'und',0,30),('node','article',0,28,28,'und',0,28),('node','article',0,29,29,'und',0,29),('node','article',0,30,30,'und',0,30),('node','article',0,31,31,'und',0,32);
/*!40000 ALTER TABLE `field_data_field_section` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `field_data_field_tags`
--

DROP TABLE IF EXISTS `field_data_field_tags`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_tags` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_tags_tid` int(10) unsigned DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_tags_tid` (`field_tags_tid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Data storage for field 3 (field_tags)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_tags`
--

LOCK TABLES `field_data_field_tags` WRITE;
/*!40000 ALTER TABLE `field_data_field_tags` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `field_data_field_tags` VALUES ('node','article',0,4,4,'und',0,40),('node','article',0,4,4,'und',1,55),('node','article',0,4,4,'und',2,54),('node','article',0,5,5,'und',0,54),('node','article',0,5,5,'und',1,43),('node','article',0,5,5,'und',2,53),('node','article',0,6,6,'und',0,12),('node','article',0,6,6,'und',1,14),('node','blog',0,7,7,'und',0,47),('node','blog',0,8,8,'und',0,48),('node','blog',0,8,8,'und',1,49),('node','blog',0,9,9,'und',0,50),('node','blog',0,10,10,'und',0,16),('node','blog',0,11,11,'und',0,15),('node','blog',0,11,11,'und',1,17),('node','article',0,12,12,'und',0,18),('node','article',0,12,12,'und',1,19),('node','article',0,27,27,'und',0,51),('node','article',0,27,27,'und',1,52),('node','article',0,28,28,'und',0,42),('node','article',0,29,29,'und',0,33),('node','article',0,29,29,'und',1,34),('node','article',0,29,29,'und',2,46),('node','article',0,30,30,'und',0,34),('node','article',0,30,30,'und',1,35),('node','article',0,30,30,'und',2,45),('node','article',0,31,31,'und',0,36),('node','article',0,31,31,'und',1,42),('node','video',0,34,34,'und',0,37),('node','video',0,35,35,'und',0,37),('node','video',0,36,36,'und',0,37),('node','video',0,36,36,'und',1,38),('node','video',0,37,37,'und',0,37),('node','video',0,37,37,'und',1,39),('node','video',0,38,38,'und',0,37);
/*!40000 ALTER TABLE `field_data_field_tags` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `field_data_field_video_link`
--

DROP TABLE IF EXISTS `field_data_field_video_link`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_video_link` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_video_link_video_url` varchar(512) DEFAULT '',
  `field_video_link_thumbnail_path` varchar(512) DEFAULT '',
  `field_video_link_video_data` longblob,
  `field_video_link_embed_code` varchar(1024) DEFAULT '',
  `field_video_link_description` text,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Data storage for field 13 (field_video_link)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_video_link`
--

LOCK TABLES `field_data_field_video_link` WRITE;
/*!40000 ALTER TABLE `field_data_field_video_link` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `field_data_field_video_link` VALUES ('field_collection_item','field_extra_content',0,20,20,'und',0,'https://www.youtube.com/watch?v=lshNdiTvNMI','public://video_embed_field_thumbnails/youtube/lshNdiTvNMI.jpg','a:24:{s:9:\"xmlns$app\";s:26:\"http://www.w3.org/2007/app\";s:5:\"xmlns\";s:27:\"http://www.w3.org/2005/Atom\";s:11:\"xmlns$media\";s:29:\"http://search.yahoo.com/mrss/\";s:8:\"xmlns$gd\";s:32:\"http://schemas.google.com/g/2005\";s:8:\"xmlns$yt\";s:37:\"http://gdata.youtube.com/schemas/2007\";s:7:\"gd$etag\";s:28:\"W/\"DUADQ347eCp7I2A9XRZbEUg.\"\";s:2:\"id\";s:38:\"tag:youtube.com,2008:video:lshNdiTvNMI\";s:9:\"published\";s:24:\"2013-08-14T14:39:32.000Z\";s:7:\"updated\";s:24:\"2014-08-16T02:56:12.000Z\";s:11:\"app$control\";a:1:{s:8:\"yt$state\";s:41:\"Syndication of this video was restricted.\";}s:8:\"category\";a:2:{i:0;a:2:{s:6:\"scheme\";s:37:\"http://schemas.google.com/g/2005#kind\";s:4:\"term\";s:43:\"http://gdata.youtube.com/schemas/2007#video\";}i:1;a:3:{s:6:\"scheme\";s:52:\"http://gdata.youtube.com/schemas/2007/categories.cat\";s:4:\"term\";s:6:\"Travel\";s:5:\"label\";s:15:\"Travel & Events\";}}s:5:\"title\";s:25:\"Brasil Travel Video Guide\";s:7:\"content\";a:2:{s:4:\"type\";s:29:\"application/x-shockwave-flash\";s:3:\"src\";s:73:\"http://www.youtube.com/v/lshNdiTvNMI?version=3&f=videos&app=youtube_gdata\";}s:4:\"link\";a:4:{i:0;a:3:{s:3:\"rel\";s:9:\"alternate\";s:4:\"type\";s:9:\"text/html\";s:4:\"href\";s:64:\"http://www.youtube.com/watch?v=lshNdiTvNMI&feature=youtube_gdata\";}i:1;a:3:{s:3:\"rel\";s:51:\"http://gdata.youtube.com/schemas/2007#video.related\";s:4:\"type\";s:20:\"application/atom+xml\";s:4:\"href\";s:65:\"http://gdata.youtube.com/feeds/api/videos/lshNdiTvNMI/related?v=2\";}i:2;a:3:{s:3:\"rel\";s:46:\"http://gdata.youtube.com/schemas/2007#uploader\";s:4:\"type\";s:20:\"application/atom+xml\";s:4:\"href\";s:67:\"http://gdata.youtube.com/feeds/api/users/3o_gaqvLoPSRVMc2GmkDrg?v=2\";}i:3;a:3:{s:3:\"rel\";s:4:\"self\";s:4:\"type\";s:20:\"application/atom+xml\";s:4:\"href\";s:57:\"http://gdata.youtube.com/feeds/api/videos/lshNdiTvNMI?v=2\";}}s:6:\"author\";a:1:{i:0;a:3:{s:4:\"name\";s:13:\"Expoza Travel\";s:3:\"uri\";s:53:\"http://gdata.youtube.com/feeds/api/users/ExpozaTravel\";s:9:\"yt$userId\";s:22:\"3o_gaqvLoPSRVMc2GmkDrg\";}}s:16:\"yt$accessControl\";a:8:{i:0;a:2:{s:6:\"action\";s:7:\"comment\";s:10:\"permission\";s:7:\"allowed\";}i:1;a:2:{s:6:\"action\";s:11:\"commentVote\";s:10:\"permission\";s:7:\"allowed\";}i:2;a:2:{s:6:\"action\";s:12:\"videoRespond\";s:10:\"permission\";s:9:\"moderated\";}i:3;a:2:{s:6:\"action\";s:4:\"rate\";s:10:\"permission\";s:7:\"allowed\";}i:4;a:2:{s:6:\"action\";s:5:\"embed\";s:10:\"permission\";s:7:\"allowed\";}i:5;a:2:{s:6:\"action\";s:4:\"list\";s:10:\"permission\";s:7:\"allowed\";}i:6;a:2:{s:6:\"action\";s:8:\"autoPlay\";s:10:\"permission\";s:7:\"allowed\";}i:7;a:2:{s:6:\"action\";s:9:\"syndicate\";s:10:\"permission\";s:7:\"allowed\";}}s:11:\"gd$comments\";a:1:{s:11:\"gd$feedLink\";a:3:{s:3:\"rel\";s:46:\"http://gdata.youtube.com/schemas/2007#comments\";s:4:\"href\";s:66:\"http://gdata.youtube.com/feeds/api/videos/lshNdiTvNMI/comments?v=2\";s:9:\"countHint\";i:24;}}s:5:\"yt$hd\";a:0:{}s:11:\"media$group\";a:14:{s:14:\"media$category\";a:1:{i:0;s:6:\"Travel\";}s:13:\"media$content\";a:1:{i:0;a:7:{s:3:\"url\";s:73:\"http://www.youtube.com/v/lshNdiTvNMI?version=3&f=videos&app=youtube_gdata\";s:4:\"type\";s:29:\"application/x-shockwave-flash\";s:6:\"medium\";s:5:\"video\";s:9:\"isDefault\";s:4:\"true\";s:10:\"expression\";s:4:\"full\";s:8:\"duration\";i:3095;s:9:\"yt$format\";i:5;}}s:12:\"media$credit\";a:1:{i:0;s:12:\"expozatravel\";}s:17:\"media$description\";s:160:\"Travel video about destination Brasil.\nBrazil is synonymous with sunshine, samba and exotic nature, a dream destination full of both adventure and constant fun!\";s:14:\"media$keywords\";a:0:{}s:13:\"media$license\";s:7:\"youtube\";s:12:\"media$player\";a:1:{s:3:\"url\";s:71:\"http://www.youtube.com/watch?v=lshNdiTvNMI&feature=youtube_gdata_player\";}s:15:\"media$thumbnail\";a:7:{i:0;a:5:{s:3:\"url\";s:45:\"http://i.ytimg.com/vi/lshNdiTvNMI/default.jpg\";s:6:\"height\";i:90;s:5:\"width\";i:120;s:4:\"time\";s:12:\"00:25:47.500\";s:7:\"yt$name\";s:7:\"default\";}i:1;a:4:{s:3:\"url\";s:47:\"http://i.ytimg.com/vi/lshNdiTvNMI/mqdefault.jpg\";s:6:\"height\";i:180;s:5:\"width\";i:320;s:7:\"yt$name\";s:9:\"mqdefault\";}i:2;a:4:{s:3:\"url\";s:47:\"http://i.ytimg.com/vi/lshNdiTvNMI/hqdefault.jpg\";s:6:\"height\";i:360;s:5:\"width\";i:480;s:7:\"yt$name\";s:9:\"hqdefault\";}i:3;a:4:{s:3:\"url\";s:47:\"http://i.ytimg.com/vi/lshNdiTvNMI/sddefault.jpg\";s:6:\"height\";i:480;s:5:\"width\";i:640;s:7:\"yt$name\";s:9:\"sddefault\";}i:4;a:5:{s:3:\"url\";s:39:\"http://i.ytimg.com/vi/lshNdiTvNMI/1.jpg\";s:6:\"height\";i:90;s:5:\"width\";i:120;s:4:\"time\";s:12:\"00:12:53.750\";s:7:\"yt$name\";s:5:\"start\";}i:5;a:5:{s:3:\"url\";s:39:\"http://i.ytimg.com/vi/lshNdiTvNMI/2.jpg\";s:6:\"height\";i:90;s:5:\"width\";i:120;s:4:\"time\";s:12:\"00:25:47.500\";s:7:\"yt$name\";s:6:\"middle\";}i:6;a:5:{s:3:\"url\";s:39:\"http://i.ytimg.com/vi/lshNdiTvNMI/3.jpg\";s:6:\"height\";i:90;s:5:\"width\";i:120;s:4:\"time\";s:12:\"00:38:41.250\";s:7:\"yt$name\";s:3:\"end\";}}s:11:\"media$title\";s:25:\"Brasil Travel Video Guide\";s:14:\"yt$aspectRatio\";s:10:\"widescreen\";s:11:\"yt$duration\";a:1:{s:7:\"seconds\";s:4:\"3095\";}s:11:\"yt$uploaded\";s:24:\"2013-08-14T14:39:32.000Z\";s:13:\"yt$uploaderId\";s:24:\"UC3o_gaqvLoPSRVMc2GmkDrg\";s:10:\"yt$videoid\";s:11:\"lshNdiTvNMI\";}s:9:\"gd$rating\";a:5:{s:7:\"average\";d:4.7866669999999996;s:3:\"max\";i:5;s:3:\"min\";i:1;s:9:\"numRaters\";i:150;s:3:\"rel\";s:40:\"http://schemas.google.com/g/2005#overall\";}s:13:\"yt$statistics\";a:2:{s:13:\"favoriteCount\";s:1:\"0\";s:9:\"viewCount\";s:5:\"44850\";}s:9:\"yt$rating\";a:2:{s:11:\"numDislikes\";s:1:\"8\";s:8:\"numLikes\";s:3:\"142\";}s:5:\"terms\";a:1:{i:0;s:6:\"Travel\";}s:7:\"handler\";s:7:\"youtube\";}',NULL,NULL),('field_collection_item','field_extra_content',0,24,24,'und',0,'https://www.youtube.com/watch?v=-cUWFLBZU5I','public://video_embed_field_thumbnails/youtube/-cUWFLBZU5I.jpg','a:1:{s:7:\"handler\";s:7:\"youtube\";}',NULL,NULL),('node','video',0,34,34,'und',0,'http://vimeo.com/60280914','public://video_embed_field_thumbnails/vimeo/60280914.jpg','a:25:{s:2:\"id\";i:60280914;s:5:\"title\";s:30:\"Margaret - Thank You Very Much\";s:11:\"description\";s:44:\"https://www.facebook.com/MARGARETMUSICONLINE\";s:3:\"url\";s:25:\"http://vimeo.com/60280914\";s:11:\"upload_date\";s:19:\"2013-02-22 15:10:00\";s:10:\"mobile_url\";s:27:\"http://vimeo.com/m/60280914\";s:15:\"thumbnail_small\";s:48:\"http://i.vimeocdn.com/video/418803220_100x75.jpg\";s:16:\"thumbnail_medium\";s:49:\"http://i.vimeocdn.com/video/418803220_200x150.jpg\";s:15:\"thumbnail_large\";s:45:\"http://i.vimeocdn.com/video/418803220_640.jpg\";s:7:\"user_id\";i:9235811;s:9:\"user_name\";s:15:\"Extensive Music\";s:8:\"user_url\";s:28:\"http://vimeo.com/user9235811\";s:19:\"user_portrait_small\";s:134:\"http://www.gravatar.com/avatar/ac263e084a6d75f8b9d4362890f06497?d=http%3A%2F%2Fi.vimeocdn.com%2Fportrait%2Fdefault-gray_30x30.png&s=30\";s:20:\"user_portrait_medium\";s:134:\"http://www.gravatar.com/avatar/ac263e084a6d75f8b9d4362890f06497?d=http%3A%2F%2Fi.vimeocdn.com%2Fportrait%2Fdefault-gray_75x75.png&s=75\";s:19:\"user_portrait_large\";s:137:\"http://www.gravatar.com/avatar/ac263e084a6d75f8b9d4362890f06497?d=http%3A%2F%2Fi.vimeocdn.com%2Fportrait%2Fdefault-gray_100x100.png&s=100\";s:18:\"user_portrait_huge\";s:137:\"http://www.gravatar.com/avatar/ac263e084a6d75f8b9d4362890f06497?d=http%3A%2F%2Fi.vimeocdn.com%2Fportrait%2Fdefault-gray_300x300.png&s=300\";s:21:\"stats_number_of_likes\";i:609;s:21:\"stats_number_of_plays\";i:1111457;s:24:\"stats_number_of_comments\";i:32;s:8:\"duration\";i:207;s:5:\"width\";i:1280;s:6:\"height\";i:720;s:4:\"tags\";s:53:\"margaret, thank you very much, thank, you, very, much\";s:13:\"embed_privacy\";s:8:\"anywhere\";s:7:\"handler\";s:5:\"vimeo\";}',NULL,NULL),('node','video',0,35,35,'und',0,'https://www.youtube.com/watch?v=FOIjvHjK0Rw','public://video_embed_field_thumbnails/youtube/FOIjvHjK0Rw.jpg','a:22:{s:5:\"xmlns\";s:27:\"http://www.w3.org/2005/Atom\";s:11:\"xmlns$media\";s:29:\"http://search.yahoo.com/mrss/\";s:8:\"xmlns$gd\";s:32:\"http://schemas.google.com/g/2005\";s:8:\"xmlns$yt\";s:37:\"http://gdata.youtube.com/schemas/2007\";s:7:\"gd$etag\";s:28:\"W/\"D08DRn47eCp7I2A9XRZUGE0.\"\";s:2:\"id\";s:38:\"tag:youtube.com,2008:video:FOIjvHjK0Rw\";s:9:\"published\";s:24:\"2013-03-01T05:40:13.000Z\";s:7:\"updated\";s:24:\"2014-08-12T01:11:17.000Z\";s:8:\"category\";a:2:{i:0;a:2:{s:6:\"scheme\";s:37:\"http://schemas.google.com/g/2005#kind\";s:4:\"term\";s:43:\"http://gdata.youtube.com/schemas/2007#video\";}i:1;a:3:{s:6:\"scheme\";s:52:\"http://gdata.youtube.com/schemas/2007/categories.cat\";s:4:\"term\";s:5:\"Music\";s:5:\"label\";s:5:\"Music\";}}s:5:\"title\";s:93:\"Beautiful Light Music - easy smooth inspirational - long playlist by relaxdaily: Ocean Breeze\";s:7:\"content\";a:2:{s:4:\"type\";s:29:\"application/x-shockwave-flash\";s:3:\"src\";s:73:\"http://www.youtube.com/v/FOIjvHjK0Rw?version=3&f=videos&app=youtube_gdata\";}s:4:\"link\";a:5:{i:0;a:3:{s:3:\"rel\";s:9:\"alternate\";s:4:\"type\";s:9:\"text/html\";s:4:\"href\";s:64:\"http://www.youtube.com/watch?v=FOIjvHjK0Rw&feature=youtube_gdata\";}i:1;a:3:{s:3:\"rel\";s:51:\"http://gdata.youtube.com/schemas/2007#video.related\";s:4:\"type\";s:20:\"application/atom+xml\";s:4:\"href\";s:65:\"http://gdata.youtube.com/feeds/api/videos/FOIjvHjK0Rw/related?v=2\";}i:2;a:3:{s:3:\"rel\";s:44:\"http://gdata.youtube.com/schemas/2007#mobile\";s:4:\"type\";s:9:\"text/html\";s:4:\"href\";s:42:\"http://m.youtube.com/details?v=FOIjvHjK0Rw\";}i:3;a:3:{s:3:\"rel\";s:46:\"http://gdata.youtube.com/schemas/2007#uploader\";s:4:\"type\";s:20:\"application/atom+xml\";s:4:\"href\";s:67:\"http://gdata.youtube.com/feeds/api/users/c9EzBNAtdnNiDrMw5CAxUw?v=2\";}i:4;a:3:{s:3:\"rel\";s:4:\"self\";s:4:\"type\";s:20:\"application/atom+xml\";s:4:\"href\";s:57:\"http://gdata.youtube.com/feeds/api/videos/FOIjvHjK0Rw?v=2\";}}s:6:\"author\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"relaxdaily\";s:3:\"uri\";s:51:\"http://gdata.youtube.com/feeds/api/users/relaxdaily\";s:9:\"yt$userId\";s:22:\"c9EzBNAtdnNiDrMw5CAxUw\";}}s:16:\"yt$accessControl\";a:8:{i:0;a:2:{s:6:\"action\";s:7:\"comment\";s:10:\"permission\";s:7:\"allowed\";}i:1;a:2:{s:6:\"action\";s:11:\"commentVote\";s:10:\"permission\";s:7:\"allowed\";}i:2;a:2:{s:6:\"action\";s:12:\"videoRespond\";s:10:\"permission\";s:9:\"moderated\";}i:3;a:2:{s:6:\"action\";s:4:\"rate\";s:10:\"permission\";s:7:\"allowed\";}i:4;a:2:{s:6:\"action\";s:5:\"embed\";s:10:\"permission\";s:7:\"allowed\";}i:5;a:2:{s:6:\"action\";s:4:\"list\";s:10:\"permission\";s:7:\"allowed\";}i:6;a:2:{s:6:\"action\";s:8:\"autoPlay\";s:10:\"permission\";s:7:\"allowed\";}i:7;a:2:{s:6:\"action\";s:9:\"syndicate\";s:10:\"permission\";s:7:\"allowed\";}}s:11:\"gd$comments\";a:1:{s:11:\"gd$feedLink\";a:3:{s:3:\"rel\";s:46:\"http://gdata.youtube.com/schemas/2007#comments\";s:4:\"href\";s:66:\"http://gdata.youtube.com/feeds/api/videos/FOIjvHjK0Rw/comments?v=2\";s:9:\"countHint\";i:5007;}}s:5:\"yt$hd\";a:0:{}s:11:\"media$group\";a:14:{s:14:\"media$category\";a:1:{i:0;s:5:\"Music\";}s:13:\"media$content\";a:3:{i:0;a:7:{s:3:\"url\";s:73:\"http://www.youtube.com/v/FOIjvHjK0Rw?version=3&f=videos&app=youtube_gdata\";s:4:\"type\";s:29:\"application/x-shockwave-flash\";s:6:\"medium\";s:5:\"video\";s:9:\"isDefault\";s:4:\"true\";s:10:\"expression\";s:4:\"full\";s:8:\"duration\";i:7894;s:9:\"yt$format\";i:5;}i:1;a:6:{s:3:\"url\";s:102:\"rtsp://r7---sn-p5qlsu7z.c.youtube.com/CiILENy73wIaGQkc0cp4vCPiFBMYDSANFEgGUgZ2aWRlb3MM/0/0/0/video.3gp\";s:4:\"type\";s:10:\"video/3gpp\";s:6:\"medium\";s:5:\"video\";s:10:\"expression\";s:4:\"full\";s:8:\"duration\";i:7894;s:9:\"yt$format\";i:1;}i:2;a:6:{s:3:\"url\";s:102:\"rtsp://r7---sn-p5qlsu7z.c.youtube.com/CiILENy73wIaGQkc0cp4vCPiFBMYESARFEgGUgZ2aWRlb3MM/0/0/0/video.3gp\";s:4:\"type\";s:10:\"video/3gpp\";s:6:\"medium\";s:5:\"video\";s:10:\"expression\";s:4:\"full\";s:8:\"duration\";i:7894;s:9:\"yt$format\";i:6;}}s:12:\"media$credit\";a:1:{i:0;s:10:\"relaxdaily\";}s:17:\"media$description\";s:1575:\"Listen to a 2h long playlist with relaxdaily music. Beautiful, light instrumental music with an easy, smooth and inspirational attitude. You can download my music at http://relaxdaily.net. Or simply enjoy this full length version here on YouTube ;)\nA music mix I made up from my own releases from the last 1,5 years. Think of it as another 2h relax radio playlist. For more music, mixes and playlists join me at my website or my YouTube channel. \n- Michael (relaxdaily musician)\n\nRelaxdaily\'s background music instrumentals: beautiful, light, inspirational music that can be used as a soundtrack for multiple activities. Depending on your interest you might use my music in your relax radio playlist, as yoga music, as music while you\'re studying, doing homework, working (mentally, creatively), reading, writing, while thinking or reflecting, dreaming, reviewing, making future plans. Some use it as \"sleep music\" (I personally think there\'s better sleep music out there, but it seems to work ;) Some even listen to it in their minecraft music playlist. Call it chillout, smooth, ambient, New Age, instrumental, or background music -- this is not as much about a genre as it is about a feeling. A way of life. With the relaxdaily project, I try to take a little heat from our (generally) too busy lives. I try to deliver a soundtrack for you, when you feel the need for some positive, calming, inspirational tunes.\n\nThe simple (repetitive) video shows some grass waving in the wind at the pacific coast in California, just a few miles south of San Fran.\n\n© 2013, relaxdaily\";s:14:\"media$keywords\";a:0:{}s:13:\"media$license\";s:7:\"youtube\";s:12:\"media$player\";a:1:{s:3:\"url\";s:71:\"http://www.youtube.com/watch?v=FOIjvHjK0Rw&feature=youtube_gdata_player\";}s:15:\"media$thumbnail\";a:7:{i:0;a:5:{s:3:\"url\";s:45:\"http://i.ytimg.com/vi/FOIjvHjK0Rw/default.jpg\";s:6:\"height\";i:90;s:5:\"width\";i:120;s:4:\"time\";s:8:\"01:05:47\";s:7:\"yt$name\";s:7:\"default\";}i:1;a:4:{s:3:\"url\";s:47:\"http://i.ytimg.com/vi/FOIjvHjK0Rw/mqdefault.jpg\";s:6:\"height\";i:180;s:5:\"width\";i:320;s:7:\"yt$name\";s:9:\"mqdefault\";}i:2;a:4:{s:3:\"url\";s:47:\"http://i.ytimg.com/vi/FOIjvHjK0Rw/hqdefault.jpg\";s:6:\"height\";i:360;s:5:\"width\";i:480;s:7:\"yt$name\";s:9:\"hqdefault\";}i:3;a:4:{s:3:\"url\";s:47:\"http://i.ytimg.com/vi/FOIjvHjK0Rw/sddefault.jpg\";s:6:\"height\";i:480;s:5:\"width\";i:640;s:7:\"yt$name\";s:9:\"sddefault\";}i:4;a:5:{s:3:\"url\";s:39:\"http://i.ytimg.com/vi/FOIjvHjK0Rw/1.jpg\";s:6:\"height\";i:90;s:5:\"width\";i:120;s:4:\"time\";s:12:\"00:32:53.500\";s:7:\"yt$name\";s:5:\"start\";}i:5;a:5:{s:3:\"url\";s:39:\"http://i.ytimg.com/vi/FOIjvHjK0Rw/2.jpg\";s:6:\"height\";i:90;s:5:\"width\";i:120;s:4:\"time\";s:8:\"01:05:47\";s:7:\"yt$name\";s:6:\"middle\";}i:6;a:5:{s:3:\"url\";s:39:\"http://i.ytimg.com/vi/FOIjvHjK0Rw/3.jpg\";s:6:\"height\";i:90;s:5:\"width\";i:120;s:4:\"time\";s:12:\"01:38:40.500\";s:7:\"yt$name\";s:3:\"end\";}}s:11:\"media$title\";s:93:\"Beautiful Light Music - easy smooth inspirational - long playlist by relaxdaily: Ocean Breeze\";s:14:\"yt$aspectRatio\";s:10:\"widescreen\";s:11:\"yt$duration\";a:1:{s:7:\"seconds\";s:4:\"7894\";}s:11:\"yt$uploaded\";s:24:\"2013-03-01T05:40:13.000Z\";s:13:\"yt$uploaderId\";s:24:\"UCc9EzBNAtdnNiDrMw5CAxUw\";s:10:\"yt$videoid\";s:11:\"FOIjvHjK0Rw\";}s:9:\"gd$rating\";a:5:{s:7:\"average\";d:4.8578634000000003;s:3:\"max\";i:5;s:3:\"min\";i:1;s:9:\"numRaters\";i:46181;s:3:\"rel\";s:40:\"http://schemas.google.com/g/2005#overall\";}s:13:\"yt$statistics\";a:2:{s:13:\"favoriteCount\";s:1:\"0\";s:9:\"viewCount\";s:8:\"10394683\";}s:9:\"yt$rating\";a:2:{s:11:\"numDislikes\";s:4:\"1641\";s:8:\"numLikes\";s:5:\"44540\";}s:5:\"terms\";a:1:{i:0;s:5:\"Music\";}s:7:\"handler\";s:7:\"youtube\";}',NULL,NULL),('node','video',0,36,36,'und',0,'https://www.youtube.com/watch?v=0VqTwnAuHws','public://video_embed_field_thumbnails/youtube/0VqTwnAuHws.jpg','a:26:{s:9:\"xmlns$app\";s:26:\"http://www.w3.org/2007/app\";s:5:\"xmlns\";s:27:\"http://www.w3.org/2005/Atom\";s:11:\"xmlns$media\";s:29:\"http://search.yahoo.com/mrss/\";s:8:\"xmlns$gd\";s:32:\"http://schemas.google.com/g/2005\";s:8:\"xmlns$yt\";s:37:\"http://gdata.youtube.com/schemas/2007\";s:7:\"gd$etag\";s:28:\"W/\"D04HRH47eCp7I2A9XRZUGE0.\"\";s:2:\"id\";s:38:\"tag:youtube.com,2008:video:0VqTwnAuHws\";s:9:\"published\";s:24:\"2012-07-18T19:54:47.000Z\";s:7:\"updated\";s:24:\"2014-08-12T01:12:15.000Z\";s:11:\"app$control\";a:1:{s:8:\"yt$state\";s:41:\"Syndication of this video was restricted.\";}s:8:\"category\";a:2:{i:0;a:2:{s:6:\"scheme\";s:37:\"http://schemas.google.com/g/2005#kind\";s:4:\"term\";s:43:\"http://gdata.youtube.com/schemas/2007#video\";}i:1;a:3:{s:6:\"scheme\";s:52:\"http://gdata.youtube.com/schemas/2007/categories.cat\";s:4:\"term\";s:5:\"Music\";s:5:\"label\";s:5:\"Music\";}}s:5:\"title\";s:79:\"One Direction - What Makes You Beautiful (5 Piano Guys, 1 piano) - ThePianoGuys\";s:7:\"content\";a:2:{s:4:\"type\";s:29:\"application/x-shockwave-flash\";s:3:\"src\";s:73:\"http://www.youtube.com/v/0VqTwnAuHws?version=3&f=videos&app=youtube_gdata\";}s:4:\"link\";a:4:{i:0;a:3:{s:3:\"rel\";s:9:\"alternate\";s:4:\"type\";s:9:\"text/html\";s:4:\"href\";s:64:\"http://www.youtube.com/watch?v=0VqTwnAuHws&feature=youtube_gdata\";}i:1;a:3:{s:3:\"rel\";s:51:\"http://gdata.youtube.com/schemas/2007#video.related\";s:4:\"type\";s:20:\"application/atom+xml\";s:4:\"href\";s:65:\"http://gdata.youtube.com/feeds/api/videos/0VqTwnAuHws/related?v=2\";}i:2;a:3:{s:3:\"rel\";s:46:\"http://gdata.youtube.com/schemas/2007#uploader\";s:4:\"type\";s:20:\"application/atom+xml\";s:4:\"href\";s:67:\"http://gdata.youtube.com/feeds/api/users/mKurapML4BF9Bjtj4RbvXw?v=2\";}i:3;a:3:{s:3:\"rel\";s:4:\"self\";s:4:\"type\";s:20:\"application/atom+xml\";s:4:\"href\";s:57:\"http://gdata.youtube.com/feeds/api/videos/0VqTwnAuHws?v=2\";}}s:6:\"author\";a:1:{i:0;a:3:{s:4:\"name\";s:12:\"ThePianoGuys\";s:3:\"uri\";s:53:\"http://gdata.youtube.com/feeds/api/users/ThePianoGuys\";s:9:\"yt$userId\";s:22:\"mKurapML4BF9Bjtj4RbvXw\";}}s:16:\"yt$accessControl\";a:8:{i:0;a:2:{s:6:\"action\";s:7:\"comment\";s:10:\"permission\";s:7:\"allowed\";}i:1;a:2:{s:6:\"action\";s:11:\"commentVote\";s:10:\"permission\";s:7:\"allowed\";}i:2;a:2:{s:6:\"action\";s:12:\"videoRespond\";s:10:\"permission\";s:9:\"moderated\";}i:3;a:2:{s:6:\"action\";s:4:\"rate\";s:10:\"permission\";s:7:\"allowed\";}i:4;a:2:{s:6:\"action\";s:5:\"embed\";s:10:\"permission\";s:7:\"allowed\";}i:5;a:2:{s:6:\"action\";s:4:\"list\";s:10:\"permission\";s:7:\"allowed\";}i:6;a:2:{s:6:\"action\";s:8:\"autoPlay\";s:10:\"permission\";s:7:\"allowed\";}i:7;a:2:{s:6:\"action\";s:9:\"syndicate\";s:10:\"permission\";s:6:\"denied\";}}s:11:\"gd$comments\";a:1:{s:11:\"gd$feedLink\";a:3:{s:3:\"rel\";s:46:\"http://gdata.youtube.com/schemas/2007#comments\";s:4:\"href\";s:66:\"http://gdata.youtube.com/feeds/api/videos/0VqTwnAuHws/comments?v=2\";s:9:\"countHint\";i:54006;}}s:5:\"yt$hd\";a:0:{}s:11:\"media$group\";a:14:{s:14:\"media$category\";a:1:{i:0;s:5:\"Music\";}s:13:\"media$content\";a:1:{i:0;a:7:{s:3:\"url\";s:73:\"http://www.youtube.com/v/0VqTwnAuHws?version=3&f=videos&app=youtube_gdata\";s:4:\"type\";s:29:\"application/x-shockwave-flash\";s:6:\"medium\";s:5:\"video\";s:9:\"isDefault\";s:4:\"true\";s:10:\"expression\";s:4:\"full\";s:8:\"duration\";i:201;s:9:\"yt$format\";i:5;}}s:12:\"media$credit\";a:1:{i:0;s:12:\"thepianoguys\";}s:17:\"media$description\";s:4303:\"We\'re on Tour! http://smarturl.it/tpgtour\nBuy Sheet Music: http://smarturl.it/Sheet_Music\nNew Album here: http://smarturl.it/NewAlbum\nBuy song here: http://smarturl.it/WMYB\n________________________\n\nSubscribe to our main channel: http://smarturl.it/TPGsubscribe1\nSubscribe to our BTS channel: http://smarturl.it/TPGsubscribe2\nFollow us on Facebook: http://www.facebook.com/PianoGuys\nFollow us on Twitter: http://www.twitter.com/PianoGuys\n________________________\n\nGet PianoGuys T-Shirts, Wristbands, Sheetmusic here: http://thepianoguys.com\n\n**ALL THE SOUNDS YOU HEAR WERE CREATED BY THE PIANO AND ONE CELLO BOW** (WITH SOME VOCALS AT THE END)\n\nSTORY BEHIND THE SONG\nThe idea: A couple months ago the 5 of us were gathered round a piano prepping for a video shoot scheduled for that day. We were brainstorming ideas when one of us (can\'t remember who!) got off task and starting flicking a piano string. Since all of us are poster children for ADHD, it wasn\'t long before ALL of us had joined in -- banging out a beat, plucking a string, or hitting keys. The brainstorming meeting had been sabotaged beyond repair, but another music video idea was born!\n\nThe song: We went through several song possibilities before landing on \"What Makes You Beautiful\" by One Direction. We like this song because its catchy and the music, lyrics, and video passed our \"sesame street\" test (meaning family friendly). We thought about the ramifications of taking on a teenybopper boy band tune as five middle-aged married guys who are desperately holding on to their hairlines. One of us even has a son older than the guys in One Direction (we won\'t say who) :-) BUT you know us -- we love a good challenge! This one was so fun to write that the \"challenge\" part of it never was felt. We just acted like kids playing a piano and it totally worked! :-) After we figured out the main \"techniques\" of playing the piano unconventionally we loved experimenting with swapping out chords and throwing the structure of the song around until it clicked.\n\nThe location: Where to film? Fitting in video shoots between touring, writing, recording, editing, and spending time with family has always been a challenge. Let\'s be honest, even getting all 5 of us in the same place at the same time has been a challenge! We had a big sold-out show at the Sandy, Utah Amphitheater. We all determined to be at the show and film the video right on stage sometime between sound check and the performance. Sounds like a good idea right? Well...because of a lot of factors, including weather (we had a huge storm sweep in and knock everything down on stage during sound check) the only time we had to film was between the hours of 2AM - 7AM the morning of the concert. In the video at 2:30 you can see the morning light start breaking -- we literally played into the sunrise! :-) \n\nMany thanks to the awesome guys at Annex Recording and Giles Reaves (engineer) for letting us record at their studio. Check them out at http://www.annexrecording.com \n\nThanks to Sandy Amphitheater http://www.sandyarts.com/sandy-amphitheater/home.html for letting us film this video on their stage. They were so great to work with and we\'ve performed so many times there the staff are all old friends (especially you, Mearle!)\n\nAnd thanks to Cole Adams, the lighting genius - who hung out all night allowing us to pull an all-nighter to film this.\n\nCREDITS\n\"What Makes You Beautiful\" written by Rami Yacoubm Carl Falk, and Savan Kotecha\nPublished by KOBALT MUSIC PUB AMERICA OBO RAMI PRODUCTIONS, AIR CHRYSALIS SCANDINAVIA AB, EMI APRIL MUSIC INC OBO MR KANANI SONGS, EMI APRIL MUSIC INC \nArrangement written and produced by Al van der Beek, Jon Schmidt, Steven Sharp Nelson, and Giles Reaves\nPerformed by ThePianoGuys: Paul Anderson (videographer/video producer), Tel Stewart (videographer/editor), Al van der Beek (music producer), Jon Schmidt (pianist), Steven Sharp Nelson (cellist)\nVocals: Al van der Beek, Steven Sharp Nelson, Jon Schmidt\nPiano recorded by Giles Reaves at Annex Recording Studios\nAdditional Piano and vocals recorded by Al van der Beek at TPG Studios\nMixed and Mastered by Al van der Beek at TPG Studios\nVideo filmed on the stage of Sandy Amphitheatre in Sandy, Utah USA\nLighting by Cole Adams\nVideo produced by Paul Anderson and Tel Stewart\";s:14:\"media$keywords\";a:0:{}s:13:\"media$license\";s:7:\"youtube\";s:12:\"media$player\";a:1:{s:3:\"url\";s:71:\"http://www.youtube.com/watch?v=0VqTwnAuHws&feature=youtube_gdata_player\";}s:15:\"media$thumbnail\";a:7:{i:0;a:5:{s:3:\"url\";s:45:\"http://i.ytimg.com/vi/0VqTwnAuHws/default.jpg\";s:6:\"height\";i:90;s:5:\"width\";i:120;s:4:\"time\";s:12:\"00:01:40.500\";s:7:\"yt$name\";s:7:\"default\";}i:1;a:4:{s:3:\"url\";s:47:\"http://i.ytimg.com/vi/0VqTwnAuHws/mqdefault.jpg\";s:6:\"height\";i:180;s:5:\"width\";i:320;s:7:\"yt$name\";s:9:\"mqdefault\";}i:2;a:4:{s:3:\"url\";s:47:\"http://i.ytimg.com/vi/0VqTwnAuHws/hqdefault.jpg\";s:6:\"height\";i:360;s:5:\"width\";i:480;s:7:\"yt$name\";s:9:\"hqdefault\";}i:3;a:4:{s:3:\"url\";s:47:\"http://i.ytimg.com/vi/0VqTwnAuHws/sddefault.jpg\";s:6:\"height\";i:480;s:5:\"width\";i:640;s:7:\"yt$name\";s:9:\"sddefault\";}i:4;a:5:{s:3:\"url\";s:39:\"http://i.ytimg.com/vi/0VqTwnAuHws/1.jpg\";s:6:\"height\";i:90;s:5:\"width\";i:120;s:4:\"time\";s:12:\"00:00:50.250\";s:7:\"yt$name\";s:5:\"start\";}i:5;a:5:{s:3:\"url\";s:39:\"http://i.ytimg.com/vi/0VqTwnAuHws/2.jpg\";s:6:\"height\";i:90;s:5:\"width\";i:120;s:4:\"time\";s:12:\"00:01:40.500\";s:7:\"yt$name\";s:6:\"middle\";}i:6;a:5:{s:3:\"url\";s:39:\"http://i.ytimg.com/vi/0VqTwnAuHws/3.jpg\";s:6:\"height\";i:90;s:5:\"width\";i:120;s:4:\"time\";s:12:\"00:02:30.750\";s:7:\"yt$name\";s:3:\"end\";}}s:11:\"media$title\";s:79:\"One Direction - What Makes You Beautiful (5 Piano Guys, 1 piano) - ThePianoGuys\";s:14:\"yt$aspectRatio\";s:10:\"widescreen\";s:11:\"yt$duration\";a:1:{s:7:\"seconds\";s:3:\"201\";}s:11:\"yt$uploaded\";s:24:\"2012-07-18T19:54:47.000Z\";s:13:\"yt$uploaderId\";s:24:\"UCmKurapML4BF9Bjtj4RbvXw\";s:10:\"yt$videoid\";s:11:\"0VqTwnAuHws\";}s:9:\"gd$rating\";a:5:{s:7:\"average\";d:4.9567829999999997;s:3:\"max\";i:5;s:3:\"min\";i:1;s:9:\"numRaters\";i:444639;s:3:\"rel\";s:40:\"http://schemas.google.com/g/2005#overall\";}s:11:\"yt$recorded\";s:10:\"2012-07-18\";s:13:\"yt$statistics\";a:2:{s:13:\"favoriteCount\";s:1:\"0\";s:9:\"viewCount\";s:8:\"34107215\";}s:9:\"yt$threed\";a:1:{s:6:\"source\";s:9:\"converted\";}s:9:\"yt$rating\";a:2:{s:11:\"numDislikes\";s:4:\"4804\";s:8:\"numLikes\";s:6:\"439835\";}s:5:\"terms\";a:1:{i:0;s:5:\"Music\";}s:7:\"handler\";s:7:\"youtube\";}',NULL,NULL),('node','video',0,37,37,'und',0,'http://vimeo.com/channels/staffpicks/100552392','public://video_embed_field_thumbnails/vimeo/100552392.jpg','a:25:{s:2:\"id\";i:100552392;s:5:\"title\";s:27:\"The San Juans. Proven Here.\";s:11:\"description\";s:1294:\"In late fall, we traveled to the high elevations of the San Juan mountains to explore the vast range and to test out our prototype suspension platform. Our trip took us to the southwest part of Colorado because the San Juan\'s contain some of the most rugged terrain in Colorado and offer a loose network of trails — some fully developed, others just old mining paths filtering down the mountainside. <br />\r\n<br />\r\nFall in the Rockies is always epic, but the weather is variable. We encountered freezing temps and snow, but were rewarded with fresh loam and peak colors. In the end, after the trails were explored, weather was endured, flat tires were fixed, and a few beers were drunk, we found out what works and what doesn’t. Excursions like this are part of the feedback loop necessary to fully develop our suspension designs. SB5 Carbon  & The San Juan’s. Proven Here.<br />\r\n<br />\r\nThe Trip: http://www.pinkbike.com/news/proven-here-sb5-carbon-amp-the-san-jaun-mountains.html<br />\r\nThe Bike / SB5 Carbon: www.yeticycles.com/#/bikes/sb5c<br />\r\n<br />\r\nCinematography By: Craig Grant <br />\r\nDirected and Edited By: Craig Grant <br />\r\nOriginal Music: Ajay Bhattacharyya<br />\r\nSound Design: Keith White<br />\r\n<br />\r\nRider: Joey Schusler<br />\r\n<br />\r\n#YetiCycles #ProvenHere\";s:3:\"url\";s:26:\"http://vimeo.com/100552392\";s:11:\"upload_date\";s:19:\"2014-07-11 19:07:35\";s:10:\"mobile_url\";s:28:\"http://vimeo.com/m/100552392\";s:15:\"thumbnail_small\";s:48:\"http://i.vimeocdn.com/video/482418517_100x75.jpg\";s:16:\"thumbnail_medium\";s:49:\"http://i.vimeocdn.com/video/482418517_200x150.jpg\";s:15:\"thumbnail_large\";s:45:\"http://i.vimeocdn.com/video/482418517_640.jpg\";s:7:\"user_id\";i:7019981;s:9:\"user_name\";s:11:\"Yeti Cycles\";s:8:\"user_url\";s:27:\"http://vimeo.com/yeticycles\";s:19:\"user_portrait_small\";s:48:\"http://i.vimeocdn.com/portrait/5329586_30x30.jpg\";s:20:\"user_portrait_medium\";s:48:\"http://i.vimeocdn.com/portrait/5329586_75x75.jpg\";s:19:\"user_portrait_large\";s:50:\"http://i.vimeocdn.com/portrait/5329586_100x100.jpg\";s:18:\"user_portrait_huge\";s:50:\"http://i.vimeocdn.com/portrait/5329586_300x300.jpg\";s:21:\"stats_number_of_likes\";i:1783;s:21:\"stats_number_of_plays\";i:154446;s:24:\"stats_number_of_comments\";i:42;s:8:\"duration\";i:330;s:5:\"width\";i:1920;s:6:\"height\";i:960;s:4:\"tags\";s:76:\"Yeti Cycles, San Juan Mountains, SB5 Carbon, Colorado, Fall, Mountain Biking\";s:13:\"embed_privacy\";s:8:\"anywhere\";s:7:\"handler\";s:5:\"vimeo\";}',NULL,NULL),('node','video',0,38,38,'und',0,'http://vimeo.com/27066862','public://video_embed_field_thumbnails/vimeo/27066862.jpg','a:25:{s:2:\"id\";i:27066862;s:5:\"title\";s:16:\"Stop Motion [HD]\";s:11:\"description\";s:389:\"An Improv Stop Motion Short.  Let Us Know What You Think!!<br />\n<br />\nfilmed & edited by:<br />\nBrandon Sloan<br />\n<br />\nCome Visit & Join Dancing Shoes Productions here:<br />\nhttp://www.facebook.com/pages/Dancing-Shoes-Productions/119577134786827<br />\n<br />\nCanon 550D<br />\nCanon 16-35mm f2.8L lens<br />\n<br />\nStarring:<br />\nLogan Clenney<br />\nJake McOwan<br />\nTrey Petterson\";s:3:\"url\";s:25:\"http://vimeo.com/27066862\";s:11:\"upload_date\";s:19:\"2011-07-29 16:14:10\";s:10:\"mobile_url\";s:27:\"http://vimeo.com/m/27066862\";s:15:\"thumbnail_small\";s:48:\"http://i.vimeocdn.com/video/179365812_100x75.jpg\";s:16:\"thumbnail_medium\";s:49:\"http://i.vimeocdn.com/video/179365812_200x150.jpg\";s:15:\"thumbnail_large\";s:45:\"http://i.vimeocdn.com/video/179365812_640.jpg\";s:7:\"user_id\";i:2636706;s:9:\"user_name\";s:13:\"Brandon Sloan\";s:8:\"user_url\";s:29:\"http://vimeo.com/brandonsloan\";s:19:\"user_portrait_small\";s:48:\"http://i.vimeocdn.com/portrait/3157839_30x30.jpg\";s:20:\"user_portrait_medium\";s:48:\"http://i.vimeocdn.com/portrait/3157839_75x75.jpg\";s:19:\"user_portrait_large\";s:50:\"http://i.vimeocdn.com/portrait/3157839_100x100.jpg\";s:18:\"user_portrait_huge\";s:50:\"http://i.vimeocdn.com/portrait/3157839_300x300.jpg\";s:21:\"stats_number_of_likes\";i:266;s:21:\"stats_number_of_plays\";i:24831;s:24:\"stats_number_of_comments\";i:48;s:8:\"duration\";i:61;s:5:\"width\";i:1280;s:6:\"height\";i:720;s:4:\"tags\";s:72:\"stop motion, canon 550D, t2i, dslr, 60d, canon eos, 5d iii, 5d, animator\";s:13:\"embed_privacy\";s:8:\"anywhere\";s:7:\"handler\";s:5:\"vimeo\";}',NULL,NULL);
/*!40000 ALTER TABLE `field_data_field_video_link` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `field_data_field_vote`
--

DROP TABLE IF EXISTS `field_data_field_vote`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_vote` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_vote_rating` int(10) unsigned DEFAULT NULL,
  `field_vote_target` int(10) unsigned DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Data storage for field 6 (field_vote)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_vote`
--

LOCK TABLES `field_data_field_vote` WRITE;
/*!40000 ALTER TABLE `field_data_field_vote` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `field_data_field_vote` VALUES ('comment','comment_node_forum',0,1,1,'und',0,80,NULL),('comment','comment_node_forum',0,8,8,'und',0,80,NULL),('comment','comment_node_forum',0,9,9,'und',0,80,NULL),('comment','comment_node_forum',0,10,10,'und',0,80,NULL),('node','forum',0,1,1,'und',0,100,NULL),('node','blog',0,7,7,'und',0,40,NULL),('node','blog',0,8,8,'und',0,100,NULL),('node','blog',0,9,9,'und',0,80,NULL),('node','blog',0,10,10,'und',0,60,NULL),('node','blog',0,11,11,'und',0,80,NULL),('node','forum',0,15,15,'und',0,100,NULL),('node','forum',0,16,16,'und',0,100,NULL),('node','forum',0,17,17,'und',0,80,NULL),('node','forum',0,55,55,'und',0,100,NULL);
/*!40000 ALTER TABLE `field_data_field_vote` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `field_data_message_text`
--

DROP TABLE IF EXISTS `field_data_message_text`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_message_text` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `message_text_value` longtext,
  `message_text_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `message_text_format` (`message_text_format`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Data storage for field 7 (message_text)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_message_text`
--

LOCK TABLES `field_data_message_text` WRITE;
/*!40000 ALTER TABLE `field_data_message_text` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `field_data_message_text` VALUES ('message_type','message_type',0,1,1,'ar',0,'<p><a href=\"[message:user:url]\">[message:user]</a> have just commented <a href=\"[message:field-node-ref:url]\">[message:field-comment-ref:node]</a></p>\r\n\r\n<p>[message:field-comment-ref:comment-text-teaser]</p>\r\n','full_html'),('message_type','message_type',0,1,1,'en',0,'<p><a href=\"[message:user:url]\">[message:user]</a> have just commented <a href=\"[message:field-node-ref:url]\">[message:field-comment-ref:node]</a></p>\n\n<p>[message:field-comment-ref:comment-text-teaser]</p>\n','full_html'),('message_type','message_type',0,1,1,'fr',0,'<a href=\"[message:user:url]\">[message:user]</a> viennent commentaires <a href=\"[message:field-node-ref:url]\">[message:field-comment-ref:node]</a> [message:field-comment-ref:comment-text-teaser]\n','full_html'),('message_type','message_type',0,1,1,'und',0,'<a href=\"[message:user:url]\">@{message:user:name}</a> <a href=\"[message:field-comment-ref:url]\">commented</a> on [message:field-node-ref:title]','full_html'),('message_type','message_type',0,1,1,'und',1,'[message:field-comment-ref:comment-teaser]','full_html'),('message_type','message_type',0,2,2,'ar',0,'<p><a href=\"[message:user:url]\">[message:user]</a> have just posted <a href=\"[message:field-node-ref:url]\">[message:field-node-ref]</a></p>\r\n','full_html'),('message_type','message_type',0,2,2,'en',0,'<p><a href=\"[message:user:url]\">[message:user]</a> have just posted <a href=\"[message:field-node-ref:url]\">[message:field-node-ref]</a></p>\n','full_html'),('message_type','message_type',0,2,2,'fr',0,'<p><a href=\"[message:user:url]\">[message:user]</a> viennent posté <a href=\"[message:field-node-ref:url]\">[message:field-node-ref]</a></p>\r\n','full_html'),('message_type','message_type',0,2,2,'und',0,'<a href=\"[message:user:url]\">@{message:user:name}</a> created <a href=\"[message:field-node-ref:url]\">[message:field-node-ref:title]</a>','full_html'),('message_type','message_type',0,2,2,'und',1,'[message:field-node-ref:node-teaser]','full_html'),('message_type','message_type',0,3,3,'ar',0,'<p><a href=\"[message:user:url]\">[message:user]</a> joined Forum Plus</p>\r\n','full_html'),('message_type','message_type',0,3,3,'en',0,'<p><a href=\"[message:user:url]\">[message:user]</a> joined Forum Plus</p>\n','full_html'),('message_type','message_type',0,3,3,'fr',0,'<a href=\"[message:user:url]\">[message:user]</a> relié Forum Plus','full_html'),('message_type','message_type',0,3,3,'und',0,'<a href=\"[message:user:url]\">@{message:user:name}</a> registered.','full_html');
/*!40000 ALTER TABLE `field_data_message_text` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `field_data_taxonomy_forums`
--

DROP TABLE IF EXISTS `field_data_taxonomy_forums`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_taxonomy_forums` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `taxonomy_forums_tid` int(10) unsigned DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `taxonomy_forums_tid` (`taxonomy_forums_tid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Data storage for field 5 (taxonomy_forums)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_taxonomy_forums`
--

LOCK TABLES `field_data_taxonomy_forums` WRITE;
/*!40000 ALTER TABLE `field_data_taxonomy_forums` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `field_data_taxonomy_forums` VALUES ('node','forum',0,1,1,'und',0,6),('node','forum',0,3,3,'und',0,5),('node','forum',0,15,15,'und',0,6),('node','forum',0,16,16,'und',0,6),('node','forum',0,17,17,'und',0,10),('node','forum',0,18,18,'und',0,9),('node','forum',0,19,19,'und',0,8),('node','forum',0,20,20,'und',0,3),('node','forum',0,21,21,'und',0,3),('node','forum',0,22,22,'und',0,3),('node','forum',0,47,47,'und',0,5),('node','forum',0,53,53,'und',0,6),('node','forum',0,54,54,'und',0,6),('node','forum',0,55,55,'und',0,6),('node','forum',0,56,56,'und',0,11),('node','forum',0,68,68,'und',0,1),('node','forum',0,69,69,'und',0,1);
/*!40000 ALTER TABLE `field_data_taxonomy_forums` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `field_group`
--

DROP TABLE IF EXISTS `field_group`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_group` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT 'The primary identifier for a group',
  `identifier` varchar(255) NOT NULL DEFAULT '' COMMENT 'The unique string identifier for a group.',
  `group_name` varchar(32) NOT NULL DEFAULT '' COMMENT 'The name of this group.',
  `entity_type` varchar(32) NOT NULL DEFAULT '',
  `bundle` varchar(128) NOT NULL DEFAULT '',
  `mode` varchar(128) NOT NULL DEFAULT '',
  `parent_name` varchar(32) NOT NULL DEFAULT '' COMMENT 'The parent name for a group',
  `data` longblob NOT NULL COMMENT 'Serialized data containing the group properties that do not warrant a dedicated column.',
  PRIMARY KEY (`id`),
  UNIQUE KEY `identifier` (`identifier`),
  KEY `group_name` (`group_name`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Table that contains field group entries and settings.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_group`
--

LOCK TABLES `field_group` WRITE;
/*!40000 ALTER TABLE `field_group` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `field_group` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `field_revision_body`
--

DROP TABLE IF EXISTS `field_revision_body`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_body` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `body_value` longtext,
  `body_summary` longtext,
  `body_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `body_format` (`body_format`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 2 (body)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_body`
--

LOCK TABLES `field_revision_body` WRITE;
/*!40000 ALTER TABLE `field_revision_body` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `field_revision_body` VALUES ('node','forum',0,1,1,'und',0,'I\'m not a Drupal developer but a pro Drupal site builder. I can read PHP and able to tweak and even write some code. I was thinking about learning the development but came across this idea that in D8 we have symphony and some other big changes. Now the question is that shall I start learning D8 dev or I should start with D7 dev?','','filtered_html'),('node','page',0,2,2,'und',0,'\r\n\r\nAt vero eos et accusam et justo duo dolores et ea rebum. Stet clita kasd gubergren, no sea takimata sanctus est Lorem ipsum dolor sit amet. Stet clita kasd gubergren, no sea takimata sanctus est Lorem ipsum dolor sit amet. Stet clita kasd gubergren, no sea takimata sanctus est Lorem ipsum dolor sit amet. Excepteur sint obcaecat cupiditat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum.\r\n\r\nUt wisi enim ad minim veniam, quis nostrud exerci tation ullamcorper suscipit lobortis nisl ut aliquip ex ea commodo consequat. Lorem ipsum dolor sit amet, consectetur adipisici elit, sed eiusmod tempor incidunt ut labore et dolore magna aliqua. Duis autem vel eum iriure dolor in hendrerit in vulputate velit esse molestie consequat, vel illum dolore eu feugiat nulla facilisis at vero eros et accumsan et iusto odio dignissim qui blandit praesent luptatum zzril delenit augue duis dolore te feugait nulla facilisi. Stet clita kasd gubergren, no sea takimata sanctus est Lorem ipsum dolor sit amet. Lorem ipsum dolor sit amet, consetetur sadipscing elitr, sed diam nonumy eirmod tempor invidunt ut labore et dolore magna aliquyam erat, sed diam voluptua.\r\n\r\nLorem ipsum dolor sit amet, consectetuer adipiscing elit, sed diam nonummy nibh euismod tincidunt ut laoreet dolore magna aliquam erat volutpat. Lorem ipsum dolor sit amet. Stet clita kasd gubergren, no sea takimata sanctus est Lorem ipsum dolor sit amet. Stet clita kasd gubergren, no sea takimata sanctus est Lorem ipsum dolor sit amet. Stet clita kasd gubergren, no sea takimata sanctus est Lorem ipsum dolor sit amet.\r\n\r\nStet clita kasd gubergren, no sea takimata sanctus est Lorem ipsum dolor sit amet. At vero eos et accusam et justo duo dolores et ea rebum. Duis autem vel eum iriure dolor in hendrerit in vulputate velit esse molestie consequat, vel illum dolore eu feugiat nulla facilisis. At vero eos et accusam et justo duo dolores et ea rebum. Lorem ipsum dolor sit amet, consectetuer adipiscing elit, sed diam nonummy nibh euismod tincidunt ut laoreet dolore magna aliquam erat volutpat.\r\n\r\nDuis autem vel eum iriure dolor in hendrerit in vulputate velit esse molestie consequat, vel illum dolore eu feugiat nulla facilisis.. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquid ex ea commodi consequat. Lorem ipsum dolor sit amet. Ut wisi enim ad minim veniam, quis nostrud exerci tation ullamcorper suscipit lobortis nisl ut aliquip ex ea commodo consequat.\r\n','','filtered_html'),('node','forum',0,3,3,'und',0,'<p>Excepteur sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum. Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium, totam rem aperiam, eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo.</p>\r\n<p>Nulla facilisi. Cras convallis vel lectus sed convallis. Duis nec accumsan diam. Vestibulum blandit tempus nulla. Suspendisse consectetur cursus elit, et scelerisque ligula hendrerit id. Maecenas ultrices porta nunc, quis consectetur risus. Morbi non metus eget nibh vulputate tincidunt. Nullam dui quam, suscipit a ligula a, posuere sagittis magna. Pellentesque vitae dolor et nunc lobortis vestibulum. Suspendisse potenti. Pellentesque cursus purus vitae libero hendrerit congue. Aenean erat elit, aliquet at mi quis, sollicitudin sollicitudin libero.</p>\r\n<blockquote>\r\n<p>Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium, totam rem aperiam, eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo.</p>\r\n</blockquote>\r\n<h1>h1. Heading 1</h1>\r\n<p>Sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum. Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium, totam rem aperiam, eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo.</p>\r\n<ul>\r\n<li>Nemo enim ipsam voluptatem quia voluptas sit aspernatur aut odit aut fugit</li>\r\n<li>Sed ut perspiciatis unde omnis iste natus error </li>\r\n<li>Qui dolorem ipsum quia dolor sit amet, consectetur, adipisci velit</li>\r\n</ul>\r\n<h2>h2. Heading 2</h2>\r\n<p>Sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum. Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium, totam rem aperiam, eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo.</p>\r\n<h3>h3. Heading 3</h3>\r\n<p>Sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum. Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium, totam rem aperiam, eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo.</p>','','filtered_html'),('node','article',0,4,4,'und',0,'<p>Praesent ut ligula non mi varius sagittis. Curabitur nisi. Phasellus leo dolor, tempus non, auctor et, hendrerit quis, nisi. Curabitur at lacus ac velit ornare lobortis. Fusce fermentum. Nunc sed turpis.</p>\r\n\r\n<p>Praesent ut ligula non mi varius sagittis. Curabitur nisi. Phasellus leo dolor, tempus non, auctor et, hendrerit quis, nisi. Curabitur at lacus ac velit ornare lobortis. Proin convallis pretium lacus, et rhoncus ipsum mollis eget.</p>\r\n\r\n<p>Proin convallis pretium lacus, et rhoncus ipsum mollis eget. Mauris pulvinar leo non magna blandit, sed viverra neque euismod. Vestibulum bibendum pretium nibh consequat tincidunt. Suspendisse consequat tortor nisi, eget dictum orci vulputate vel. Morbi ultrices condimentum lacus, semper venenatis leo ultrices sit amet. Ut et tincidunt purus, non venenatis nibh. Etiam congue quam metus, feugiat fringilla nunc congue nec. Donec ut condimentum justo. Nam ut leo et nisl consequat commodo.</p>\r\n\r\n<blockquote>\r\n<p>Donec lobortis nisi vel erat posuere porttitor. Interdum et malesuada fames ac ante ipsum primis in faucibus. Curabitur venenatis massa sit amet mi mollis sollicitudin. Duis ut purus tincidunt, lobortis tortor a, porttitor erat. Quisque suscipit mi eu euismod egestas. Cras quis porta augue. Morbi porttitor cursus eros. Fusce aliquam vel lorem ut dignissim. Fusce commodo nisl et arcu aliquam, nec accumsan purus dictum. In commodo eleifend justo, eu sagittis libero laoreet in.</p>\r\n<footer>Someone famous in <cite title=\"Source Title\">Source Title</cite></footer>\r\n</blockquote>\r\n\r\n<h1>h1. Heading 1</h1>\r\n<p>Sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum. Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium, totam rem aperiam, eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo.</p>\r\n<ul>\r\n<li>Nemo enim ipsam voluptatem quia voluptas sit aspernatur aut odit aut fugit</li>\r\n<li>Sed ut perspiciatis unde omnis iste natus error </li>\r\n<li>Qui dolorem ipsum quia dolor sit amet, consectetur, adipisci velit</li>\r\n</ul>\r\n<h2>h2. Heading 2</h2>\r\n<p>Sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum. Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium, totam rem aperiam, eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo.</p>\r\n<h3>h3. Heading 3</h3>\r\n<p>Sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum. Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium, totam rem aperiam, eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo.</p>','','filtered_html'),('node','article',0,5,5,'und',0,'<p>Praesent ut ligula non mi varius sagittis. Curabitur nisi. Phasellus leo dolor, tempus non, auctor et, hendrerit quis, nisi. Curabitur at lacus ac velit ornare lobortis. Fusce fermentum. Nunc sed turpis.</p>\r\n\r\n<p>Praesent ut ligula non mi varius sagittis. Curabitur nisi. Phasellus leo dolor, tempus non, auctor et, hendrerit quis, nisi. Curabitur at lacus ac velit ornare lobortis. Proin convallis pretium lacus, et rhoncus ipsum mollis eget.</p>\r\n\r\n<p>Proin convallis pretium lacus, et rhoncus ipsum mollis eget. Mauris pulvinar leo non magna blandit, sed viverra neque euismod. Vestibulum bibendum pretium nibh consequat tincidunt. Suspendisse consequat tortor nisi, eget dictum orci vulputate vel. Morbi ultrices condimentum lacus, semper venenatis leo ultrices sit amet. Ut et tincidunt purus, non venenatis nibh. Etiam congue quam metus, feugiat fringilla nunc congue nec. Donec ut condimentum justo. Nam ut leo et nisl consequat commodo.</p>\r\n\r\n<blockquote>\r\n<p>Donec lobortis nisi vel erat posuere porttitor. Interdum et malesuada fames ac ante ipsum primis in faucibus. Curabitur venenatis massa sit amet mi mollis sollicitudin. Duis ut purus tincidunt, lobortis tortor a, porttitor erat. Quisque suscipit mi eu euismod egestas. Cras quis porta augue. Morbi porttitor cursus eros. Fusce aliquam vel lorem ut dignissim. Fusce commodo nisl et arcu aliquam, nec accumsan purus dictum. In commodo eleifend justo, eu sagittis libero laoreet in.</p>\r\n<footer>Someone famous in <cite title=\"Source Title\">Source Title</cite></footer>\r\n</blockquote>\r\n\r\n<h1>h1. Heading 1</h1>\r\n<p>Sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum. Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium, totam rem aperiam, eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo.</p>\r\n<ul>\r\n<li>Nemo enim ipsam voluptatem quia voluptas sit aspernatur aut odit aut fugit</li>\r\n<li>Sed ut perspiciatis unde omnis iste natus error </li>\r\n<li>Qui dolorem ipsum quia dolor sit amet, consectetur, adipisci velit</li>\r\n</ul>\r\n<h2>h2. Heading 2</h2>\r\n<p>Sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum. Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium, totam rem aperiam, eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo.</p>\r\n<h3>h3. Heading 3</h3>\r\n<p>Sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum. Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium, totam rem aperiam, eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo.</p>','','filtered_html'),('node','article',0,6,6,'und',0,'<p>Praesent ut ligula non mi varius sagittis. Curabitur nisi. Phasellus leo dolor, tempus non, auctor et, hendrerit quis, nisi. Curabitur at lacus ac velit ornare lobortis. Fusce fermentum. Nunc sed turpis.</p>\r\n\r\n<p>Praesent ut ligula non mi varius sagittis. Curabitur nisi. Phasellus leo dolor, tempus non, auctor et, hendrerit quis, nisi. Curabitur at lacus ac velit ornare lobortis. Proin convallis pretium lacus, et rhoncus ipsum mollis eget.</p>\r\n\r\n<p>Proin convallis pretium lacus, et rhoncus ipsum mollis eget. Mauris pulvinar leo non magna blandit, sed viverra neque euismod. Vestibulum bibendum pretium nibh consequat tincidunt. Suspendisse consequat tortor nisi, eget dictum orci vulputate vel. Morbi ultrices condimentum lacus, semper venenatis leo ultrices sit amet. Ut et tincidunt purus, non venenatis nibh. Etiam congue quam metus, feugiat fringilla nunc congue nec. Donec ut condimentum justo. Nam ut leo et nisl consequat commodo.</p>\r\n\r\n<blockquote>\r\n<p>Donec lobortis nisi vel erat posuere porttitor. Interdum et malesuada fames ac ante ipsum primis in faucibus. Curabitur venenatis massa sit amet mi mollis sollicitudin. Duis ut purus tincidunt, lobortis tortor a, porttitor erat. Quisque suscipit mi eu euismod egestas. Cras quis porta augue. Morbi porttitor cursus eros. Fusce aliquam vel lorem ut dignissim. Fusce commodo nisl et arcu aliquam, nec accumsan purus dictum. In commodo eleifend justo, eu sagittis libero laoreet in.</p>\r\n<footer>Someone famous in <cite title=\"Source Title\">Source Title</cite></footer>\r\n</blockquote>\r\n\r\n<h1>h1. Heading 1</h1>\r\n<p>Sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum. Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium, totam rem aperiam, eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo.</p>\r\n<ul>\r\n<li>Nemo enim ipsam voluptatem quia voluptas sit aspernatur aut odit aut fugit</li>\r\n<li>Sed ut perspiciatis unde omnis iste natus error </li>\r\n<li>Qui dolorem ipsum quia dolor sit amet, consectetur, adipisci velit</li>\r\n</ul>\r\n<h2>h2. Heading 2</h2>\r\n<p>Sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum. Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium, totam rem aperiam, eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo.</p>\r\n<h3>h3. Heading 3</h3>\r\n<p>Sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum. Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium, totam rem aperiam, eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo.</p>','','filtered_html'),('node','blog',0,7,7,'und',0,'<p>Excepteur sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum. Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium, totam rem aperiam, eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo.</p>\r\n<p>Nulla facilisi. Cras convallis vel lectus sed convallis. Duis nec accumsan diam. Vestibulum blandit tempus nulla. Suspendisse consectetur cursus elit, et scelerisque ligula hendrerit id. Maecenas ultrices porta nunc, quis consectetur risus. Morbi non metus eget nibh vulputate tincidunt. Nullam dui quam, suscipit a ligula a, posuere sagittis magna. Pellentesque vitae dolor et nunc lobortis vestibulum. Suspendisse potenti. Pellentesque cursus purus vitae libero hendrerit congue. Aenean erat elit, aliquet at mi quis, sollicitudin sollicitudin libero.</p>\r\n<blockquote>\r\n<p>Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium, totam rem aperiam, eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo.</p>\r\n</blockquote>\r\n<h1>h1. Heading 1</h1>\r\n<p>Sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum. Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium, totam rem aperiam, eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo.</p>\r\n<ul>\r\n<li>Nemo enim ipsam voluptatem quia voluptas sit aspernatur aut odit aut fugit</li>\r\n<li>Sed ut perspiciatis unde omnis iste natus error </li>\r\n<li>Qui dolorem ipsum quia dolor sit amet, consectetur, adipisci velit</li>\r\n</ul>\r\n<h2>h2. Heading 2</h2>\r\n<p>Sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum. Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium, totam rem aperiam, eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo.</p>\r\n<h3>h3. Heading 3</h3>\r\n<p>Sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum. Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium, totam rem aperiam, eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo.</p>','','full_html'),('node','blog',0,8,8,'und',0,'<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Pellentesque eget dolor sit amet lorem vulputate aliquet. Praesent eu dignissim turpis. Duis volutpat gravida tincidunt. Vivamus sodales ligula in accumsan accumsan. Nunc adipiscing posuere ultricies. Class aptent taciti sociosqu ad litora torquent per conubia nostra, per inceptos himenaeos. Praesent vehicula justo id nunc facilisis volutpat porttitor id eros.</p>\r\n\r\n<p>Ut aliquet sodales purus, in pretium risus consequat id. Proin convallis pretium lacus, et rhoncus ipsum mollis eget. Mauris pulvinar leo non magna blandit, sed viverra neque euismod. Vestibulum bibendum pretium nibh consequat tincidunt. Suspendisse consequat tortor nisi, eget dictum orci vulputate vel. Morbi ultrices condimentum lacus, semper venenatis leo ultrices sit amet. Ut et tincidunt purus, non venenatis nibh. Etiam congue quam metus, feugiat fringilla nunc congue nec. Donec ut condimentum justo. Nam ut leo et nisl consequat commodo. Nullam tempus rutrum massa, eu ullamcorper turpis dapibus at. Vestibulum feugiat ligula eu nibh vehicula varius.</p>\r\n\r\n<blockquote class=\"blockquote-reverse\">\r\n<p>Donec lobortis nisi vel erat posuere porttitor. Interdum et malesuada fames ac ante ipsum primis in faucibus. Curabitur venenatis massa sit amet mi mollis sollicitudin. Duis ut purus tincidunt, lobortis tortor a, porttitor erat. Quisque suscipit mi eu euismod egestas. Cras quis porta augue. Morbi porttitor cursus eros. Fusce aliquam vel lorem ut dignissim. Fusce commodo nisl et arcu aliquam, nec accumsan purus dictum. In commodo eleifend justo, eu sagittis libero laoreet in.</p>\r\n<footer>Someone famous in <cite title=\"Source Title\">Source Title</cite></footer>\r\n</blockquote>\r\n\r\n<p>Aliquam elementum turpis eget felis eleifend, id sodales dui ultrices. Fusce rhoncus, libero sed consectetur commodo, arcu nisl malesuada sem, commodo facilisis risus diam eu sapien. Aenean iaculis, urna id ultrices lacinia, lacus lectus commodo neque, vel tincidunt lectus quam ac tellus. Sed interdum mattis neque, nec rhoncus lorem laoreet ornare. Vestibulum dignissim, libero non convallis pulvinar, leo lectus dignissim risus, ac consequat metus purus sed nisi. Aliquam erat volutpat. Vivamus elementum feugiat orci. Nam vitae elementum risus, porta luctus tortor. Proin luctus tristique massa. Phasellus volutpat id leo sed facilisis. Vestibulum accumsan libero eu arcu malesuada luctus.</p>\r\n\r\n<h2>h2. Heading 2</h2>\r\n<p>Sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum. Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium, totam rem aperiam, eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo.</p>\r\n<h3>h3. Heading 3</h3>\r\n<p>Sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum. Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium, totam rem aperiam, eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo.</p>','','full_html'),('node','blog',0,9,9,'und',0,'<p>Excepteur sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum. Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium, totam rem aperiam, eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo.</p>\r\n<p>Nulla facilisi. Cras convallis vel lectus sed convallis. Duis nec accumsan diam. Vestibulum blandit tempus nulla. Suspendisse consectetur cursus elit, et scelerisque ligula hendrerit id. Maecenas ultrices porta nunc, quis consectetur risus. Morbi non metus eget nibh vulputate tincidunt. Nullam dui quam, suscipit a ligula a, posuere sagittis magna. Pellentesque vitae dolor et nunc lobortis vestibulum. Suspendisse potenti. Pellentesque cursus purus vitae libero hendrerit congue. Aenean erat elit, aliquet at mi quis, sollicitudin sollicitudin libero.</p>\r\n<blockquote>\r\n<p>Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium, totam rem aperiam, eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo.</p>\r\n</blockquote>\r\n<h1>h1. Heading 1</h1>\r\n<p>Sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum. Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium, totam rem aperiam, eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo.</p>\r\n<ul>\r\n<li>Nemo enim ipsam voluptatem quia voluptas sit aspernatur aut odit aut fugit</li>\r\n<li>Sed ut perspiciatis unde omnis iste natus error </li>\r\n<li>Qui dolorem ipsum quia dolor sit amet, consectetur, adipisci velit</li>\r\n</ul>\r\n<h2>h2. Heading 2</h2>\r\n<p>Sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum. Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium, totam rem aperiam, eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo.</p>\r\n<h3>h3. Heading 3</h3>\r\n<p>Sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum. Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium, totam rem aperiam, eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo.</p>','','full_html'),('node','blog',0,10,10,'und',0,'Praesent ac massa at ligula laoreet iaculis. Etiam imperdiet imperdiet orci. Pellentesque libero tortor, tincidunt et, tincidunt eget, semper nec, quam. Phasellus magna. Phasellus gravida semper nisi. Donec interdum, metus et hendrerit aliquet, dolor diam sagittis ligula, eget egestas libero turpis vel mi. Etiam vitae tortor. Suspendisse feugiat. Nulla consequat massa quis enim. Pellentesque egestas, neque sit amet convallis pulvinar, justo nulla eleifend augue, ac auctor orci leo non est. Donec pede justo, fringilla vel, aliquet nec, vulputate eget, arcu. Aenean viverra rhoncus pede. Sed consequat, leo eget bibendum sodales, augue velit cursus nunc, quis gravida magna mi a libero. Praesent egestas tristique nibh. Sed aliquam ultrices mauris.\r\n\r\nSed libero. Cras non dolor. Proin faucibus arcu quis ante. Donec interdum, metus et hendrerit aliquet, dolor diam sagittis ligula, eget egestas libero turpis vel mi. Donec pede justo, fringilla vel, aliquet nec, vulputate eget, arcu. Proin viverra, ligula sit amet ultrices semper, ligula arcu tristique sapien, a accumsan nisi mauris ac eros. Morbi nec metus. Proin pretium, leo ac pellentesque mollis, felis nunc ultrices eros, sed gravida augue augue mollis justo. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus. Maecenas egestas arcu quis ligula mattis placerat.','','filtered_html'),('node','blog',0,11,11,'und',0,'Donec mi odio, faucibus at, scelerisque quis, convallis in, nisi. Cras id dui. Phasellus volutpat, metus eget egestas mollis, lacus lacus blandit dui, id egestas quam mauris ut lacus. Integer ante arcu, accumsan a, consectetuer eget, posuere ut, mauris. Maecenas vestibulum mollis diam. Nam quam nunc, blandit vel, luctus pulvinar, hendrerit id, lorem. In ut quam vitae odio lacinia tincidunt. Donec vitae sapien ut libero venenatis faucibus. Class aptent taciti sociosqu ad litora torquent per conubia nostra, per inceptos hymenaeos. Etiam ultricies nisi vel augue. Praesent adipiscing. Proin faucibus arcu quis ante. Etiam ultricies nisi vel augue. Fusce pharetra convallis urna. Vestibulum eu odio.\r\n\r\nNunc nulla. Maecenas vestibulum mollis diam. Vestibulum dapibus nunc ac augue. Nulla consequat massa quis enim. Donec vitae orci sed dolor rutrum auctor. Maecenas vestibulum mollis diam. Nam at tortor in tellus interdum sagittis. Aenean tellus metus, bibendum sed, posuere ac, mattis non, nunc. Fusce vulputate eleifend sapien. Nullam tincidunt adipiscing enim.\r\n\r\nDonec mi odio, faucibus at, scelerisque quis, convallis in, nisi. Cras id dui. Phasellus volutpat, metus eget egestas mollis, lacus lacus blandit dui, id egestas quam mauris ut lacus. Integer ante arcu, accumsan a, consectetuer eget, posuere ut, mauris. Maecenas vestibulum mollis diam. Nam quam nunc, blandit vel, luctus pulvinar, hendrerit id, lorem. In ut quam vitae odio lacinia tincidunt. Donec vitae sapien ut libero venenatis faucibus. Class aptent taciti sociosqu ad litora torquent per conubia nostra, per inceptos hymenaeos. Etiam ultricies nisi vel augue. Praesent adipiscing. Proin faucibus arcu quis ante. Etiam ultricies nisi vel augue. Fusce pharetra convallis urna. Vestibulum eu odio.\r\n\r\nNunc nulla. Maecenas vestibulum mollis diam. Vestibulum dapibus nunc ac augue. Nulla consequat massa quis enim. Donec vitae orci sed dolor rutrum auctor. Maecenas vestibulum mollis diam. Nam at tortor in tellus interdum sagittis. Aenean tellus metus, bibendum sed, posuere ac, mattis non, nunc. Fusce vulputate eleifend sapien. Nullam tincidunt adipiscing enim.','','filtered_html'),('node','article',0,12,12,'und',0,'<p>Praesent ut ligula non mi varius sagittis. Curabitur nisi. Phasellus leo dolor, tempus non, auctor et, hendrerit quis, nisi. Curabitur at lacus ac velit ornare lobortis. Fusce fermentum. Nunc sed turpis.</p>\r\n\r\n<p>Praesent ut ligula non mi varius sagittis. Curabitur nisi. Phasellus leo dolor, tempus non, auctor et, hendrerit quis, nisi. Curabitur at lacus ac velit ornare lobortis. Proin convallis pretium lacus, et rhoncus ipsum mollis eget.</p>\r\n\r\n<p>Proin convallis pretium lacus, et rhoncus ipsum mollis eget. Mauris pulvinar leo non magna blandit, sed viverra neque euismod. Vestibulum bibendum pretium nibh consequat tincidunt. Suspendisse consequat tortor nisi, eget dictum orci vulputate vel. Morbi ultrices condimentum lacus, semper venenatis leo ultrices sit amet. Ut et tincidunt purus, non venenatis nibh. Etiam congue quam metus, feugiat fringilla nunc congue nec. Donec ut condimentum justo. Nam ut leo et nisl consequat commodo.</p>\r\n\r\n<blockquote>\r\n<p>Donec lobortis nisi vel erat posuere porttitor. Interdum et malesuada fames ac ante ipsum primis in faucibus. Curabitur venenatis massa sit amet mi mollis sollicitudin. Duis ut purus tincidunt, lobortis tortor a, porttitor erat. Quisque suscipit mi eu euismod egestas. Cras quis porta augue. Morbi porttitor cursus eros. Fusce aliquam vel lorem ut dignissim. Fusce commodo nisl et arcu aliquam, nec accumsan purus dictum. In commodo eleifend justo, eu sagittis libero laoreet in.</p>\r\n<footer>Someone famous in <cite title=\"Source Title\">Source Title</cite></footer>\r\n</blockquote>\r\n\r\n<h1>h1. Heading 1</h1>\r\n<p>Sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum. Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium, totam rem aperiam, eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo.</p>\r\n<ul>\r\n<li>Nemo enim ipsam voluptatem quia voluptas sit aspernatur aut odit aut fugit</li>\r\n<li>Sed ut perspiciatis unde omnis iste natus error </li>\r\n<li>Qui dolorem ipsum quia dolor sit amet, consectetur, adipisci velit</li>\r\n</ul>\r\n<h2>h2. Heading 2</h2>\r\n<p>Sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum. Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium, totam rem aperiam, eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo.</p>\r\n<h3>h3. Heading 3</h3>\r\n<p>Sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum. Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium, totam rem aperiam, eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo.</p>','','filtered_html'),('node','faq',0,13,13,'und',0,'Ut tincidunt tincidunt erat. Praesent ac massa at ligula laoreet iaculis. Donec pede justo, fringilla vel, aliquet nec, vulputate eget, arcu. Nunc nec neque. Ut varius tincidunt libero. Phasellus volutpat, metus eget egestas mollis, lacus lacus blandit dui, id egestas quam mauris ut lacus. Praesent ut ligula non mi varius sagittis. Quisque rutrum. Maecenas tempus, tellus eget condimentum rhoncus, sem quam semper libero, sit amet adipiscing sem neque sed ipsum. Proin faucibus arcu quis ante. Nunc nonummy metus. Praesent metus tellus, elementum eu, semper a, adipiscing nec, purus.. Morbi nec metus. Cras sagittis. Suspendisse nisl elit, rhoncus eget, elementum ac, condimentum eget, diam. Morbi nec metus. Suspendisse faucibus, nunc et pellentesque egestas, lacus ante convallis tellus, vitae iaculis lacus elit id tortor. Sed augue ipsum, egestas nec, vestibulum et, malesuada adipiscing, dui. Proin sapien ipsum, porta a, auctor quis, euismod ut, mi. Curabitur at lacus ac velit ornare lobortis. Etiam iaculis nunc ac metus. Proin sapien ipsum, porta a, auctor quis, euismod ut, mi. Sed hendrerit. Sed consequat, leo eget bibendum sodales, augue velit cursus nunc, quis gravida magna mi a libero.','','filtered_html'),('node','faq',0,14,14,'und',0,'Duis vel nibh at velit scelerisque suscipit. Nulla consequat massa quis enim. Etiam sit amet orci eget eros faucibus tincidunt. Class aptent taciti sociosqu ad litora torquent per conubia nostra, per inceptos hymenaeos. Etiam feugiat lorem non metus. Nunc egestas, augue at pellentesque laoreet, felis eros vehicula leo, at malesuada velit leo quis pede. Ut tincidunt tincidunt erat. Mauris sollicitudin fermentum libero. Morbi ac felis. Nam adipiscing. Etiam ultricies nisi vel augue. Phasellus tempus. Maecenas vestibulum mollis diam. Fusce egestas elit eget lorem. Vestibulum purus quam, scelerisque ut, mollis sed, nonummy id, metus. Nullam dictum felis eu pede mollis pretium. Suspendisse enim turpis, dictum sed, iaculis a, condimentum nec, nisi. Phasellus dolor. Nullam dictum felis eu pede mollis pretium. Nulla neque dolor, sagittis eget, iaculis quis, molestie non, velit. Vestibulum rutrum, mi nec elementum vehicula, eros quam gravida nisl, id fringilla neque ante vel mi.. Nullam quis ante. Suspendisse pulvinar, augue ac venenatis condimentum, sem libero volutpat nibh, nec pellentesque velit pede quis nunc. Pellentesque posuere.','','filtered_html'),('node','forum',0,15,15,'und',0,'We offer 4 main services: community contribution, premium themes, web design & development and web maintenance & support. Find more details about us on our homepage: and our About page','','filtered_html'),('node','forum',0,16,16,'und',0,'Drupal 6 extended support announcement\r\n\r\nOn February 13, 2008, Drupal 6 was released. The policy of the community is to support only the current and previous stable versions. (When Drupal 6 was released, Drupal 4.7.x was marked unsupported. When Drupal 7 came out, Drupal 5.x was marked unsupported.) This policy was created to prevent core and module maintainers from having to maintain more than 2 active major versions of Drupal.\r\n\r\nWith the coming Drupal 8 release, this policy has been questioned. We want to ensure that sites that wish to move from Drupal 6 to Drupal 8 have a supported window within which to do so. The Drupal core team, key module maintainers, and representatives of the Drupal security team met at Drupalcon Austin to discuss this as an in-person follow up to the previous discussion at https://drupal.org/node/2136029.\r\n\r\nDrupal 6 core and modules will transition to unsupported status three months after Drupal 8 is released. \"Unsupported status\" means the community will not be providing support or patches in the same way we do now. Continuing to support Drupal 6 would be difficult for many reasons, including a lack of automated test coverage, the requirement for rigorous manual release testing, the slow-down it introduces in the release of security fixes for the vast majority of Drupal users (on version 7+), and the general shift of volunteers in the community moving their attention onto Drupal 8 development.\r\n\r\nThis gives Drupal 6 users a few options:\r\n\r\n1) Upgrade to Drupal 7 any time between now and 3 months after Drupal 8.0.0 is released. Drupal 7 releases undergo almost 40,000 automated tests, and Drupal 7 will be fully supported at least until Drupal 9 comes out. Given the past history, the release of Drupal 9 is likely to be around 2018.\r\n\r\n2) Upgrade to Drupal 8 after it is released, but before Drupal 6 is not supported anymore. Fortunately, Migrate support for Drupal 6 to Drupal 8 is already in core, and there is Migrate UI, a contributed module. While not all contributed modules will be ready at the time Drupal 8 is released, Drupal 8\'s migration path handles most of the critical site data via its CCK to Entities/Fields in Core migrations.\r\n\r\n3) Find an organization that will provide extended support for Drupal 6. The Drupal Security Team will provide a method for companies and/or individuals to work together in the private security issue queue to continue developing updates, and will provide a reasonable amount of time for companies to provide patches to Drupal 6 security issues that also affect Drupal 7 or Drupal 8. The security team will coordinate access to issues for companies wishing to provide extended support for Drupal 6. However, the team will not explicitly review or test the patches (some team members may do this on their own). All code created by these vendors, would be released to the community.\r\n\r\nOrganizations and individuals interested in providing this level of support for their customers\r\nAND who have the technical knowledge to maintain a Drupal core release should go to the security team Drupal 6 long term support page.\r\n\r\nBoth the Security Team and Drupal core leadership feel that a 3-month window after Drupal 8\'s release before eclipsing community support for Drupal 6 is a workable compromise between leaving Drupal 6 sites on an unsupported version the second Drupal 8 comes out, and acknowledging that our community\'s volunteer resources are limited and have shifted focus. We hope that organizations that rely on Drupal 6 will step up to help maintain it after community support winds down, and/or help their clients update to D8.','','filtered_html'),('node','forum',0,17,17,'und',0,'<p>Excepteur sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum. Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium, totam rem aperiam, eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo.</p>\r\n\r\n<p>Nulla facilisi. Cras convallis vel lectus sed convallis. Duis nec accumsan diam. Vestibulum blandit tempus nulla. Suspendisse consectetur cursus elit, et scelerisque ligula hendrerit id. Maecenas ultrices porta nunc, quis consectetur risus. Morbi non metus eget nibh vulputate tincidunt. Nullam dui quam, suscipit a ligula a, posuere sagittis magna. Pellentesque vitae dolor et nunc lobortis vestibulum. Suspendisse potenti. Pellentesque cursus purus vitae libero hendrerit congue. Aenean erat elit, aliquet at mi quis, sollicitudin sollicitudin libero.</p>\r\n\r\n<blockquote>\r\n<p>Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium, totam rem aperiam, eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo.</p>\r\n</blockquote>\r\n\r\n<h1>h1. Heading 1</h1>\r\n\r\n<p>Sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum. Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium, totam rem aperiam, eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo.</p>\r\n\r\n<ul>\r\n	<li>Nemo enim ipsam voluptatem quia voluptas sit aspernatur aut odit aut fugit</li>\r\n	<li>Sed ut perspiciatis unde omnis iste natus error</li>\r\n	<li>Qui dolorem ipsum quia dolor sit amet, consectetur, adipisci velit</li>\r\n</ul>\r\n\r\n<h2>h2. Heading 2</h2>\r\n\r\n<p>Sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum. Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium, totam rem aperiam, eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo.</p>\r\n\r\n<h3>h3. Heading 3</h3>\r\n\r\n<p>Sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum. Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium, totam rem aperiam, eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo.</p>\r\n','','filtered_html'),('node','forum',0,18,18,'und',0,'The Hosting section is managed by the Drupal Association. Learn how to get listed on the hosting page or other advertising opportunities on Advertising on Drupal.org page on the Drupal Association website.\r\n\r\nHosting companies may also be listed in the Services section of the Marketplace. Learn how to get listed in the Services section of the Marketplace on the Marketplace guidelines.','','filtered_html'),('node','forum',0,19,19,'und',0,'<div class=\"field field-name-body field-type-text-with-summary field-label-hidden\"><div class=\"field-items\"><div class=\"field-item even\"><h3>ATTENTION</h3>\r\n<p><strong>This page does not yet reflect new changes to Drush that apparently make Composer a prerequisite to Drush installation in the newer branches. I don\'t have time to explore this right now. If you have the knowledge, please update this page to reflect that, then remove this message. In the meantime, users of this page can still install older versions of Drush using this method.</strong></p>\r\n<p><strong>Some instructions on installing Composer can be found in the <a href=\"#comment-8798219\" rel=\"nofollow\">comments</a></strong>.</p>\r\n<ol><li>If you don\'t already have shell access, request access to SSH for your shared hosting account (e.g. for Hostmonster or Green Geeks: open a new support ticket with Tech Support (<strong>UPDATE:</strong> Shell access can now be enabled from cPanel for some hostmonster hosting accounts). For other Hosting services you may need to upgrade to use SSH.)</li>\r\n<li><a name=\"2\" rel=\"nofollow\" id=\"2\"></a>Once you have received SSH access to your site, open a new Terminal and login to your site by typing the following <code>ssh username@yourdomain.com</code> or any additional user login string provided by your Hosting service</li>\r\n<li>Enter your password when prompted</li>\r\n<li>By default, you should be in your home directory (~). If you are not in your home directory, navigate yourself there by using the <code>cd ~</code> (cd = change directory command). The <code>\'~\'</code> is an alias for your home directory. On Hostmonster--and nearly every other Linux shared hosting situation--your website directory is located at <strong>~/public_html</strong>, or more specifically <strong>/www/htdocs/username</strong>.</li>\r\n<li>Confirm you are in your home directory by typing the bash shell command <code>ls</code>, which will list the files and folders in the current directory. On Hostmonster, you should see <code>public_html/</code>, <code>public_ftp</code>, and a bunch of other files. Make special note of a file named <code>.bashrc</code>, as we will be editing it later.</li>\r\n<li>Download Drush by typing <code>wget https://github.com/drush-ops/drush/archive/6.x.zip</code> (At the time of this edit, the Drush 6 branch is the recommended version and is no longer available for download on drupal.org). Extract the .zip file by typing in <code>unzip 6.x</code> and remove zip file by typing <code>rm 6.x.zip.</code><br>\r\n*Tip: type <code>clear</code> and hit enter. This will clear your screen, and give you a little more breathing room. Do this as much as you want to throughout this process<br><strong>**Important:</strong> If your host\'s configuration does not allow for the <code>wget</code> command, you may alternately download the zip file of the recommended branch (currently <a href=\"https://github.com/drush-ops/drush/tree/6.x\">https://github.com/drush-ops/drush/tree/6.x</a>) and manually upload and extract via the host\'s cPanel File Manager, or an ftp program of your choice.</li>\r\n<li>Type <code>ls</code> again, to list your directory. You should now see <code>drush/</code> in the directory (if the directory is drush-6.x, rename to drush with <a href=\"http://unixhelp.ed.ac.uk/tasks/mv2.html\" title=\"mv command help\" rel=\"nofollow\"><code>mv</code> command</a>).</li>\r\n<li>Type <code>chmod u+x drush</code> to set the correct permissions on the drush command.<br>\r\n*Tip: Type <code>ls -la</code> to see the permissions and owners on the items in the directory.</li>\r\n<li>Next, in order to use Drush across our installation&amp;emdash;in all of our sub-folders&amp;emdash;we need to add a line to our <code>.bashrc</code> file. While still in your home directory, type the following: <code>nano .bashrc</code>. This will open up <code>.bashrc</code> in a text editor named <code>nano</code>.<br>\r\n*note:  For GoDaddy accounts there is no nano application  (for new cPanel accounts nano is available). Use VIM instead. So type <code>vim .bashrc</code> to edit the file. A good VIM cheatsheet is: <a href=\"http://www.fprintf.net/vimCheatSheet.html\" rel=\"nofollow\">http://www.fprintf.net/vimCheatSheet.html</a>]<br>\r\nLocate <code># User specific aliases and functions</code>. Underneath that, add the following: <code>alias drush=\"~/drush/drush\"</code>. Save the file by typing <code>ctrl+X</code> (Exit) and type <code>y</code> to accept your changes.</li>\r\n<li>Type <code>source ~/.bashrc</code> to refresh the alias list and allow the new drush commands to work.</li>\r\n<li>Confirm that Drush is working by typing <code>drush</code> at the command prompt and hitting <code>enter</code>. You should see a list of drush commands. If you do, then <code>success!</code></li>\r\n<li>If the previous step doesn\'t work, type <code>exit</code> to end your SSH session, then log back in (See <a href=\"#2\" rel=\"nofollow\">step 2</a>) to restart your session. This refreshes <code>.bashrc</code> and allows the new drush commands to work. Some hosting providers such as <strong>GoDaddy</strong> (legacy accounts) use <strong>php-cgi</strong> in the command line instead of <strong>php-cli</strong>. The former is not compatible with Drush and if this is your case you have to locate <strong>php-cli</strong> and then add the following lines to your ~/.bashrc or ~/.bash-profile file:<br><div class=\"codeblock\"><code>export COLUMNS<br>alias drush=\'/usr/local/php5/bin/php ~/drush/drush.php\'<br>alias php=\'/usr/local/php5/bin/php\'</code></div>\r\n</li>\r\n<li>You have now added drush hot sauce to your shared host. Awesome!</li>\r\n</ol><p>Once again, this should work on <em>any</em> shared hosting Linux platforms that allow shell access. On Hostmonster or Green Geeks, you have to specifically ask them to turn it on. If you do not have a <code>.bashrc</code> file in your home directory, try making it by typing <code>touch .bashrc</code>. You can also try using a file named .profile, .bash_aliases or .bash_profile, depending on your server\'s setup.</p>\r\n<h4>SSH config</h4>\r\n<p>Since you\'ll be using the ssh login prompt a lot, you might consider creating a local alias for your login credentials. Follow this link for <a href=\"http://nerderati.com/2011/03/simplify-your-life-with-an-ssh-config-file/\" rel=\"nofollow\">detailed instructions</a>. Note that in a Drush site-alias configuration you would use the host name configured in this file as <code>remote-host</code> and no <code>remote-user</code>.</p>\r\n<h3>Editorial Comments</h3>\r\n<p>For all those who didn\'t really understand the instructions and are just trying to follow it as it is written, here\'s a bit of advice: <em>only</em> use Drush if you start to understand it, even a little bit. Shell commands and Drush commands are very powerful and not recommended for learning on production sites or sites with a live server deadline, because you can mess things up very quickly. Your Shared Hosting support won\'t be happy if you create code loops through failure. </p>\r\n<p><strong>Another bit of advice: If you are not a full-time developer, you should always use the stable non-beta releases of Drush, and should never use the additional -y command to avoid the security question \"are you sure you want ... ? y/n.</strong></p>\r\n<p>To put it another way: Read the instructions twice, understand what the commands mean and what they do, don\'t rely solely on copy/paste. In the long run, you will save your self time--which is the whole point of Drush in the first place.</p>\r\n<p>Let\'s take the <em>alias</em> command as an example; you can exchange the <em>.bashrc alias</em> line with something else like  <em><strong><code>alias ddd=\'~/drush/drush\'</code></strong> </em>  instead of <em><strong><code>alias drush=\'~/drush/drush\'</code></strong></em>. This actually changes the way you use the Drush command later. Your commands will start with <em>ddd [your command]</em> then, instead of <em>drush [your command]</em>. And you can also add other aliases of course, like: <em> <strong><code>alias dddl=\'~drush/drush en\'</code></strong> </em>, which simplifies thee often-used Drush \'en\' command from <em><strong><code>drush dl</code></strong></em> to <em> <strong><code>dddl</code></strong></em>. In short, it is well worth your time (and safer) to go ahead and <em>learn</em> how to properly use Bash commands, if you plan on using Drush.</p>\r\n<p>The <a href=\"http://www.drush.ws\" title=\"Drush\" rel=\"nofollow\">Drush Documentation</a> is a great place to start. It will teach you about Drush commands, and how to use them.</p>\r\n</div></div></div>','','filtered_html'),('node','forum',0,20,20,'und',0,'<div class=\"field field-name-body field-type-text-with-summary field-label-hidden\"><div class=\"field-items\"><div class=\"field-item even\"><p>Note: this page should not be edited without first discussing the changes in a <a href=\"/node/add/project-issue/drupal\">Drupal Core issue</a> as the requirements for each version of Drupal are decided upon by the Drupal Core developers.</p>\r\n<p>To install and run Drupal your web server must meet certain minimum requirements. Most web hosting companies meet these requirements. However, a few stand out by also actively supporting the Drupal community. If you need hosting, consider selecting one of <a href=\"http://drupal.org/hosting\">these web hosts</a>.</p>\r\n<h2>Disk space</h2>\r\n<p>A minimum installation requires 15 Megabytes. 60 MB is needed for a website with many contributed modules and themes installed. Keep in mind you need much more for the database, files uploaded by the users, media, backups and other files.</p>\r\n<h2>Web server</h2>\r\n<p>Apache, Nginx, or Microsoft IIS<br><a href=\"/requirements/webserver\">More details about web server requirements.</a></p>\r\n<h2>Database</h2>\r\n<p>Drupal 6: MySQL 4.1 or higher, PostgreSQL 7.1,<br>\r\nDrupal 7: MySQL 5.0.15 or higher with PDO, PostgreSQL 8.3 or higher with PDO, SQLite 3.3.7 or higher<br>\r\nDrupal 8: MySQL 5.0.15/MariaDB/Percona/equivalent or higher with PDO and an InnoDB-compatible primary storage engine, PostgreSQL 8.3 or higher with PDO, SQLite 3.3.7 or higher </p>\r\n<p><a href=\"/project/sqlsrv\">Microsoft SQL Server</a> and <a href=\"/project/oracle\">Oracle</a> are supported by additional modules.<br><a href=\"/requirements/database\">More details about database requirements.</a></p>\r\n<h2>PHP</h2>\r\n<p>Drupal 6: PHP 5.2.x only. Warning: support for PHP 4.x has been dropped. PHP 5.3 and later may produce errors or unexpected behaviour.<br>\r\nDrupal 7: PHP 5.2.5 or higher (5.3 recommended).<br>\r\nDrupal 8: PHP 5.4 or higher.<br><a href=\"/requirements/php\">More details about PHP requirements,</a> including <a href=\"https://www.drupal.org/requirements/php#memory\">PHP memory</a>.</p>\r\n<p>See also the <a href=\"http://drupal.org/node/627252\">Site Performance section</a> of the Administration Guide and the <a href=\"/node/34022\">webhosting troubleshooting FAQ</a>.</p>\r\n</div></div></div>','','filtered_html'),('node','forum',0,21,21,'und',0,'<div class=\"field-item even\"><p>Drupal works on any <a href=\"http://en.wikipedia.org/wiki/Webserver\" rel=\"nofollow\">web server</a> with PHP support.</p>\r\n<h3>Apache (Recommended)</h3>\r\n<p><a href=\"http://httpd.apache.org/\" rel=\"nofollow\">Apache</a> is the most commonly used web server for Drupal. Drupal will work on Apache 2.x hosted on UNIX/Linux, OS X, or Windows. </p>\r\n<p>The majority of Drupal development and deployment is done on Apache, so there is more community experience and testing performed on Apache than on other web servers. Drupal 7 and 6 will likely work on Apache 1.3.</p>\r\n<p>You can use the Apache \'mod_rewrite\' extension to <a href=\"/getting-started/clean-urls\" rel=\"nofollow\">allow for clean URLs</a>.</p>\r\n<p>The Apache Virtualhost configuration must contain the directive <code>AllowOverride All</code> to allow Drupal\'s .htaccess file to be used.</p>\r\n<h3>Nginx</h3>\r\n<p><a href=\"http://www.nginx.com/\" rel=\"nofollow\">Nginx</a> is a commonly used web server that focuses on high concurrency, performance and low memory usage.</p>\r\n<p>Drupal will work on Nginx legacy versions (0.7.x, 0.8.x, 1.0.x, 1.2.x), stable 1.4.x versions, and mainline 1.5.x versions hosted on UNIX/Linux, OS X, or Windows. Nginx is a popular alternative to Apache, so there is also significant community experience and testing performed on Nginx.</p>\r\n<p>For information on enabling clean URLs, see <a href=\"/node/976392\" rel=\"nofollow\">Clean URLs with NGINX</a>.</p>\r\n<h3>Hiawatha</h3>\r\n<p><a href=\"https://www.hiawatha-webserver.org/\" rel=\"nofollow\">Hiawatha</a> is a web server with a strong focus on security. It also aims at being easy to use and being lightweight. Research performed by independent researchers proves that Hiawatha offers a performance comparable to other web servers under <a href=\"http://www.saltwaterc.ro/wp-download/documents/PHP_web_serving_study.pdf\" rel=\"nofollow\">normal conditions</a>, but much better <a href=\"https://www.hiawatha-webserver.org/weblog/64\" rel=\"nofollow\">while under attack</a>.</p>\r\n<p>Hiawatha is fully compatible with Drupal. For information about the required URL rewriting rules to use Drupal with Hiawatha, read <a href=\"/node/2275833\" rel=\"nofollow\">Clean URLs with Hiawatha</a>.</p>\r\n<h3>Microsoft IIS</h3>\r\n<p><a href=\"http://www.microsoft.com/iis\" rel=\"nofollow\">Microsoft IIS</a> is a web server and set of feature extension modules for use with Microsoft Windows.</p>\r\n<p>Drupal core will work with IIS 5, IIS 6, or IIS 7 if PHP is configured correctly.</p>\r\n<p>To achieve clean URLs you may need to use a third party product. For IIS 7 you can use the Microsoft URL Rewrite Module or a third party solution.</p>\r\n<p>On IIS 7 Drupal requires <a href=\"http://technet.microsoft.com/en-us/windowsserver/dd262148.aspx\" rel=\"nofollow\">Windows 2008 Server SP2</a> or later for fastCGI  support.</p>\r\n</div>','','filtered_html'),('node','forum',0,22,22,'und',0,'<div class=\"field-item even\"><p><strong>Recommended: </strong><a href=\"http://www.mysql.com/\" rel=\"nofollow\">MySQL</a> (or an equivalent such as <a href=\"http://mariadb.org/\" rel=\"nofollow\">MariaDB</a> or <a href=\"http://www.percona.com/software/percona-server\" rel=\"nofollow\">Percona Server</a>)</p>\r\n<h3>MySQL</h3>\r\n<ul><li>Drupal 6 supports MySQL 4.1 or higher, but MySQL 5.0.15 or higher is recommended</li>\r\n<li>Drupal 7 supports MySQL 5.0.15 or higher (or MySQL 5.1.30 or higher), and requires the PDO database extension for PHP (see <a href=\"/requirements/pdo\" rel=\"nofollow\">What is PDO?</a>).</li>\r\n<li>Drupal 8 supports MySQL 5.0.15 or higher (or MySQL 5.1.30 or higher) with InnoDB as the primary storage engine, and requires the PDO database extension.</li>\r\n</ul><p>There are several drop-in replacements for MySQL. Drupal has been extensively tested with <a href=\"http://mariadb.org/\" rel=\"nofollow\">MariaDB</a>, and version 5.1.44 (or greater) is recommended. It is also likely that other drop-in replacements such as <a href=\"http://www.percona.com/software/percona-server\" rel=\"nofollow\">Percona Server</a> will work well with Drupal, but they may not have specifically undergone testing.</p>\r\n<p><strong>Notes</strong>\r\n</p>\r\n<ul><li>Drupal makes use of some features not available on some inexpensive hosting plans so please check that your host allows database accounts with the following rights:<br>\r\nSELECT, INSERT, UPDATE, DELETE, CREATE, DROP, INDEX, ALTER.<br>\r\nThese rights are sufficient to run Drupal 6 and 7</li>\r\n<li>Some contributed modules, and also Drupal core 5.x (but not Drupal core 6.x), additionally require the following rights:<br>\r\nCREATE TEMPORARY TABLES, LOCK TABLES.</li>\r\n<li>It may be necessary to set the system variable max_allowed_packet to at least 16M. Some inexpensive hosting plans set this value too low (the MySQL default is only 1M). In that case, you may need to choose a better hosting plan. A value of 1M may be sufficient for Drupal 5.</li>\r\n<li>Drupal 7 and earlier support MyISAM and InnoDB table types. Drupal 8 no longer supports MyISAM as the primary storage engine, so InnoDB table types are recommended. NDB tables (MySQL Cluster) are not supported.</li>\r\n<li>Note that if your web hosting account is set up with a graphic control panel such as Plesk or CPanel, it is very likely that you do not need to worry about installing a driver for MySQL -- it is probably already installed on your server. You might wish to simply create your database and proceed with installing Drupal, and then refer back to Drupal documentation for specific troubleshooting help if you run into problems.</li>\r\n</ul><h3>PostgreSQL</h3>\r\n<p>Note: Some contributed modules are not as abstracted from MySQL-specific code as everyone would like. If you are familiar with PostgreSQL please file issues with those contributed modules as you find them.</p>\r\n<ul><li>Drupal 6 supports PostgreSQL 7.1 or higher</li>\r\n<li>Drupal 7 supports PostgreSQL 8.3 or higher</li>\r\n</ul><h3>SQLite</h3>\r\n<p>SQLite 3.3.7 or higher  - Drupal 7 only.</p>\r\n<p>Note: Some contributed modules are not as abstracted from MySQL-specific code as everyone would like. If you are familiar with SQLite please file issues with those contributed modules as you find them.</p>\r\n<h3>Other database servers</h3>\r\n<p><a href=\"http://drupal.org/project/sqlsrv\" rel=\"nofollow\">Microsoft SQL Server</a>, <a href=\"http://drupal.org/project/oracle\" rel=\"nofollow\">Oracle</a>, and <a href=\"https://drupal.org/project/mongodb\" rel=\"nofollow\">MongoDB</a> are supported by additional modules.</p>\r\n<p>Please see discussions in the <a href=\"http://groups.drupal.org/enterprise\" rel=\"nofollow\">Enterprise Group</a> if you are interested in working on database support.</p>\r\n</div>','','filtered_html'),('node','page',0,23,23,'und',0,'<div class=\"shortcode-section\">\r\n<h1 class=\"page-header\">Quote</h1>\r\n<h3>Example</h3>\r\n[quote class=\"my-quote\"]This is my quote[/quote]\r\n<h3>Shortcode</h3>\r\n<pre><code>&#91;quote class=&quot;my-quote&quot;]This is my quote&#91;/quote]</code></pre>\r\n</div>\r\n\r\n<div class=\"shortcode-section\">\r\n<h1 class=\"page-header\">Image</h1>\r\n<h3>Example</h3>\r\n[img src=\"sites/all/themes/forum_plus/logo.png\" class=\"my-image\" alt=\"logo image\" /]\r\n<h3>Shortcode</h3>\r\n<pre><code>&#91;img src=\"sites/all/themes/forum_plus/logo.png\" class=\"my-image\" alt=\"logo image\" /]</code></pre>\r\n</div>\r\n\r\n<div class=\"shortcode-section\">\r\n<h1 class=\"page-header\">Highlight</h1>\r\n<h3>Example</h3>\r\n[highlight class=\"my-highlight\"]This is highlight text[/highlight]\r\n<h3>Shortcode</h3>\r\n<pre><code>&#91;highlight class=\"my-highlight\"]This is highlight text&#91;/highlight]</code></pre>\r\n</div>\r\n\r\n<div class=\"shortcode-section\">\r\n<h1 class=\"page-header\">Button</h1>\r\n<h3>Example</h3>\r\n[button path=\"#\" class=\"my-button\"]This is my button[/button]\r\n<h3>Shortcode</h3>\r\n<pre><code>&#91;button path=\"#\" class=\"my-button\"]This is my button&#91;/button]</code></pre>\r\n</div>\r\n\r\n<div class=\"shortcode-section\">\r\n<h1 class=\"page-header\">Dropcap</h1>\r\n<h3>Example</h3>\r\n[dropcap class=\"my-dropcap\"]This is dropcap[/dropcap]\r\n<h3>Shortcode</h3>\r\n<pre><code>&#91;dropcap class=\"my-dropcap\"]This is dropcap&#91;/dropcap]</code></pre>\r\n</div>\r\n\r\n<div class=\"shortcode-section\">\r\n<h1 class=\"page-header\">Item</h1>\r\n<h3>Example</h3>\r\n[item class=\"my-item\" type=\"span\"]This is an item[/item]\r\n<h3>Shortcode</h3>\r\n<pre><code>&#91;item class=\"my-item\" type=\"span\"]This is an item&#91;/item]</code></pre>\r\n</div>\r\n','','full_html'),('node','page',0,24,24,'und',0,'<div class=\"shortcode-section\">\r\n<h1 class=\"page-header\">Quote</h1>\r\n<h3>Example</h3>\r\n[tooltip class=\"my-tooltip\" placement=\"left\" title=\"left\"]This is my left quote[/tooltip]\r\n[tooltip class=\"my-tooltip\" placement=\"top\" title=\"top\"]This is my top quote[/tooltip]\r\n[tooltip class=\"my-tooltip\" placement=\"right\" title=\"right\"]This is my right quote[/tooltip]\r\n[tooltip class=\"my-tooltip\" placement=\"bottom\" title=\"bottom\"]This is my bottom quote[/tooltip]\r\n<h3>Shortcode</h3>\r\n<pre><code>&#91;tooltip class=\"my-tooltip\" placement=\"left\" title=\"left\"]This is my quote&#91;/tooltip]</code></pre>\r\n</div>','','full_html'),('node','page',0,25,25,'und',0,'<div class=\"shortcode-section\">\r\n<h1 class=\"page-header\">Video</h1>\r\n<h3>Example</h3>\r\n[video]http://www.youtube.com/watch?v=Q-GLuydiMe4[/video]\r\n<h3>Shortcode</h3>\r\n<pre><code>&#91;video]https://www.youtube.com/watch?v=Q-GLuydiMe4&#91;/video]</code></pre>\r\n</div>','','full_html'),('node','page',0,26,26,'und',0,'<div class=\"shortcode-section\">\r\n<h1 class=\"page-header\">Video</h1>\r\n<h3>Example</h3>\r\n[collapse]\r\n[accordion title=\"Accordion Item #1\"]\r\nPraesent vestibulum dapibus nibh. Phasellus viverra nulla ut metus varius laoreet. Pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas. Suspendisse feugiat. Nunc nulla.\r\nPraesent egestas neque eu enim. Phasellus leo dolor, tempus non, auctor et, hendrerit quis, nisi. Fusce neque. In hac habitasse platea dictumst. In hac habitasse platea dictumst.\r\n[/accordion]\r\n[accordion title=\"Accordion Item #2\"]\r\nQuisque id odio. Nunc interdum lacus sit amet orci. Nulla sit amet est. Curabitur ligula sapien, tincidunt non, euismod vitae, posuere imperdiet, leo. Maecenas ullamcorper, dui et placerat feugiat, eros pede varius nisi, condimentum viverra felis nunc et lorem.\r\n[/accordion]\r\n[/collapse]\r\n\r\n<h3>Shortcode</h3>\r\n<pre><code>\r\n&#91;collapse]\r\n&#91;accordion title=\"Accordion Item #1\"]\r\nPraesent vestibulum dapibus nibh. Phasellus viverra nulla ut metus varius laoreet. Pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas. Suspendisse feugiat. Nunc nulla.\r\nPraesent egestas neque eu enim. Phasellus leo dolor, tempus non, auctor et, hendrerit quis, nisi. Fusce neque. In hac habitasse platea dictumst. In hac habitasse platea dictumst.\r\n&#91;/accordion]\r\n&#91;accordion title=\"Accordion Item #2\"]\r\nQuisque id odio. Nunc interdum lacus sit amet orci. Nulla sit amet est. Curabitur ligula sapien, tincidunt non, euismod vitae, posuere imperdiet, leo. Maecenas ullamcorper, dui et placerat feugiat, eros pede varius nisi, condimentum viverra felis nunc et lorem.\r\n&#91;/accordion]\r\n&#91;/collapse]\r\n</code></pre>\r\n</div>','','full_html'),('node','article',0,27,27,'und',0,'<p>Praesent ut ligula non mi varius sagittis. Curabitur nisi. Phasellus leo dolor, tempus non, auctor et, hendrerit quis, nisi. Curabitur at lacus ac velit ornare lobortis. Fusce fermentum. Nunc sed turpis.</p>\r\n\r\n<p>Praesent ut ligula non mi varius sagittis. Curabitur nisi. Phasellus leo dolor, tempus non, auctor et, hendrerit quis, nisi. Curabitur at lacus ac velit ornare lobortis. Proin convallis pretium lacus, et rhoncus ipsum mollis eget.</p>\r\n\r\n<p>Proin convallis pretium lacus, et rhoncus ipsum mollis eget. Mauris pulvinar leo non magna blandit, sed viverra neque euismod. Vestibulum bibendum pretium nibh consequat tincidunt. Suspendisse consequat tortor nisi, eget dictum orci vulputate vel. Morbi ultrices condimentum lacus, semper venenatis leo ultrices sit amet. Ut et tincidunt purus, non venenatis nibh. Etiam congue quam metus, feugiat fringilla nunc congue nec. Donec ut condimentum justo. Nam ut leo et nisl consequat commodo.</p>\r\n\r\n<blockquote>\r\n<p>Donec lobortis nisi vel erat posuere porttitor. Interdum et malesuada fames ac ante ipsum primis in faucibus. Curabitur venenatis massa sit amet mi mollis sollicitudin. Duis ut purus tincidunt, lobortis tortor a, porttitor erat. Quisque suscipit mi eu euismod egestas. Cras quis porta augue. Morbi porttitor cursus eros. Fusce aliquam vel lorem ut dignissim. Fusce commodo nisl et arcu aliquam, nec accumsan purus dictum. In commodo eleifend justo, eu sagittis libero laoreet in.</p>\r\n<footer>Someone famous in <cite title=\"Source Title\">Source Title</cite></footer>\r\n</blockquote>\r\n\r\n<h1>h1. Heading 1</h1>\r\n<p>Sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum. Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium, totam rem aperiam, eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo.</p>\r\n<ul>\r\n<li>Nemo enim ipsam voluptatem quia voluptas sit aspernatur aut odit aut fugit</li>\r\n<li>Sed ut perspiciatis unde omnis iste natus error </li>\r\n<li>Qui dolorem ipsum quia dolor sit amet, consectetur, adipisci velit</li>\r\n</ul>\r\n<h2>h2. Heading 2</h2>\r\n<p>Sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum. Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium, totam rem aperiam, eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo.</p>\r\n<h3>h3. Heading 3</h3>\r\n<p>Sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum. Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium, totam rem aperiam, eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo.</p>','','filtered_html'),('node','article',0,28,28,'und',0,'<p>Praesent ut ligula non mi varius sagittis. Curabitur nisi. Phasellus leo dolor, tempus non, auctor et, hendrerit quis, nisi. Curabitur at lacus ac velit ornare lobortis. Fusce fermentum. Nunc sed turpis.</p>\r\n\r\n<p>Praesent ut ligula non mi varius sagittis. Curabitur nisi. Phasellus leo dolor, tempus non, auctor et, hendrerit quis, nisi. Curabitur at lacus ac velit ornare lobortis. Proin convallis pretium lacus, et rhoncus ipsum mollis eget.</p>\r\n\r\n<p>Proin convallis pretium lacus, et rhoncus ipsum mollis eget. Mauris pulvinar leo non magna blandit, sed viverra neque euismod. Vestibulum bibendum pretium nibh consequat tincidunt. Suspendisse consequat tortor nisi, eget dictum orci vulputate vel. Morbi ultrices condimentum lacus, semper venenatis leo ultrices sit amet. Ut et tincidunt purus, non venenatis nibh. Etiam congue quam metus, feugiat fringilla nunc congue nec. Donec ut condimentum justo. Nam ut leo et nisl consequat commodo.</p>\r\n\r\n<blockquote>\r\n<p>Donec lobortis nisi vel erat posuere porttitor. Interdum et malesuada fames ac ante ipsum primis in faucibus. Curabitur venenatis massa sit amet mi mollis sollicitudin. Duis ut purus tincidunt, lobortis tortor a, porttitor erat. Quisque suscipit mi eu euismod egestas. Cras quis porta augue. Morbi porttitor cursus eros. Fusce aliquam vel lorem ut dignissim. Fusce commodo nisl et arcu aliquam, nec accumsan purus dictum. In commodo eleifend justo, eu sagittis libero laoreet in.</p>\r\n<footer>Someone famous in <cite title=\"Source Title\">Source Title</cite></footer>\r\n</blockquote>\r\n\r\n<h1>h1. Heading 1</h1>\r\n<p>Sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum. Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium, totam rem aperiam, eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo.</p>\r\n<ul>\r\n<li>Nemo enim ipsam voluptatem quia voluptas sit aspernatur aut odit aut fugit</li>\r\n<li>Sed ut perspiciatis unde omnis iste natus error </li>\r\n<li>Qui dolorem ipsum quia dolor sit amet, consectetur, adipisci velit</li>\r\n</ul>\r\n<h2>h2. Heading 2</h2>\r\n<p>Sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum. Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium, totam rem aperiam, eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo.</p>\r\n<h3>h3. Heading 3</h3>\r\n<p>Sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum. Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium, totam rem aperiam, eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo.</p>','','filtered_html'),('node','article',0,29,29,'und',0,'<p>Praesent ut ligula non mi varius sagittis. Curabitur nisi. Phasellus leo dolor, tempus non, auctor et, hendrerit quis, nisi. Curabitur at lacus ac velit ornare lobortis. Fusce fermentum. Nunc sed turpis.</p>\r\n\r\n<p>Praesent ut ligula non mi varius sagittis. Curabitur nisi. Phasellus leo dolor, tempus non, auctor et, hendrerit quis, nisi. Curabitur at lacus ac velit ornare lobortis. Proin convallis pretium lacus, et rhoncus ipsum mollis eget.</p>\r\n\r\n<p>Proin convallis pretium lacus, et rhoncus ipsum mollis eget. Mauris pulvinar leo non magna blandit, sed viverra neque euismod. Vestibulum bibendum pretium nibh consequat tincidunt. Suspendisse consequat tortor nisi, eget dictum orci vulputate vel. Morbi ultrices condimentum lacus, semper venenatis leo ultrices sit amet. Ut et tincidunt purus, non venenatis nibh. Etiam congue quam metus, feugiat fringilla nunc congue nec. Donec ut condimentum justo. Nam ut leo et nisl consequat commodo.</p>\r\n\r\n<blockquote>\r\n<p>Donec lobortis nisi vel erat posuere porttitor. Interdum et malesuada fames ac ante ipsum primis in faucibus. Curabitur venenatis massa sit amet mi mollis sollicitudin. Duis ut purus tincidunt, lobortis tortor a, porttitor erat. Quisque suscipit mi eu euismod egestas. Cras quis porta augue. Morbi porttitor cursus eros. Fusce aliquam vel lorem ut dignissim. Fusce commodo nisl et arcu aliquam, nec accumsan purus dictum. In commodo eleifend justo, eu sagittis libero laoreet in.</p>\r\n<footer>Someone famous in <cite title=\"Source Title\">Source Title</cite></footer>\r\n</blockquote>\r\n<h1>h1. Heading 1</h1>\r\n<p>Sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum. Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium, totam rem aperiam, eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo.</p>\r\n<ul>\r\n<li>Nemo enim ipsam voluptatem quia voluptas sit aspernatur aut odit aut fugit</li>\r\n<li>Sed ut perspiciatis unde omnis iste natus error </li>\r\n<li>Qui dolorem ipsum quia dolor sit amet, consectetur, adipisci velit</li>\r\n</ul>\r\n<h2>h2. Heading 2</h2>\r\n<p>Sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum. Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium, totam rem aperiam, eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo.</p>\r\n<h3>h3. Heading 3</h3>\r\n<p>Sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum. Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium, totam rem aperiam, eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo.</p>','','filtered_html'),('node','article',0,30,30,'und',0,'<p>Praesent ut ligula non mi varius sagittis. Curabitur nisi. Phasellus leo dolor, tempus non, auctor et, hendrerit quis, nisi. Curabitur at lacus ac velit ornare lobortis. Fusce fermentum. Nunc sed turpis.</p>\r\n\r\n<p>Praesent ut ligula non mi varius sagittis. Curabitur nisi. Phasellus leo dolor, tempus non, auctor et, hendrerit quis, nisi. Curabitur at lacus ac velit ornare lobortis. Proin convallis pretium lacus, et rhoncus ipsum mollis eget.</p>\r\n\r\n<p>Proin convallis pretium lacus, et rhoncus ipsum mollis eget. Mauris pulvinar leo non magna blandit, sed viverra neque euismod. Vestibulum bibendum pretium nibh consequat tincidunt. Suspendisse consequat tortor nisi, eget dictum orci vulputate vel. Morbi ultrices condimentum lacus, semper venenatis leo ultrices sit amet. Ut et tincidunt purus, non venenatis nibh. Etiam congue quam metus, feugiat fringilla nunc congue nec. Donec ut condimentum justo. Nam ut leo et nisl consequat commodo.</p>\r\n\r\n<blockquote>\r\n<p>Donec lobortis nisi vel erat posuere porttitor. Interdum et malesuada fames ac ante ipsum primis in faucibus. Curabitur venenatis massa sit amet mi mollis sollicitudin. Duis ut purus tincidunt, lobortis tortor a, porttitor erat. Quisque suscipit mi eu euismod egestas. Cras quis porta augue. Morbi porttitor cursus eros. Fusce aliquam vel lorem ut dignissim. Fusce commodo nisl et arcu aliquam, nec accumsan purus dictum. In commodo eleifend justo, eu sagittis libero laoreet in.</p>\r\n<footer>Someone famous in <cite title=\"Source Title\">Source Title</cite></footer>\r\n</blockquote>\r\n\r\n<h1>h1. Heading 1</h1>\r\n<p>Sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum. Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium, totam rem aperiam, eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo.</p>\r\n<ul>\r\n<li>Nemo enim ipsam voluptatem quia voluptas sit aspernatur aut odit aut fugit</li>\r\n<li>Sed ut perspiciatis unde omnis iste natus error </li>\r\n<li>Qui dolorem ipsum quia dolor sit amet, consectetur, adipisci velit</li>\r\n</ul>\r\n<h2>h2. Heading 2</h2>\r\n<p>Sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum. Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium, totam rem aperiam, eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo.</p>\r\n<h3>h3. Heading 3</h3>\r\n<p>Sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum. Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium, totam rem aperiam, eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo.</p>','','filtered_html'),('node','article',0,31,31,'und',0,'<p>Praesent ut ligula non mi varius sagittis. Curabitur nisi. Phasellus leo dolor, tempus non, auctor et, hendrerit quis, nisi. Curabitur at lacus ac velit ornare lobortis. Fusce fermentum. Nunc sed turpis.</p>\r\n\r\n<p>Praesent ut ligula non mi varius sagittis. Curabitur nisi. Phasellus leo dolor, tempus non, auctor et, hendrerit quis, nisi. Curabitur at lacus ac velit ornare lobortis. Proin convallis pretium lacus, et rhoncus ipsum mollis eget.</p>\r\n\r\n<p>Proin convallis pretium lacus, et rhoncus ipsum mollis eget. Mauris pulvinar leo non magna blandit, sed viverra neque euismod. Vestibulum bibendum pretium nibh consequat tincidunt. Suspendisse consequat tortor nisi, eget dictum orci vulputate vel. Morbi ultrices condimentum lacus, semper venenatis leo ultrices sit amet. Ut et tincidunt purus, non venenatis nibh. Etiam congue quam metus, feugiat fringilla nunc congue nec. Donec ut condimentum justo. Nam ut leo et nisl consequat commodo.</p>\r\n\r\n<blockquote>\r\n<p>Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium, totam rem aperiam, eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo.</p>\r\n</blockquote>\r\n<h1>h1. Heading 1</h1>\r\n<p>Sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum. Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium, totam rem aperiam, eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo.</p>\r\n<ul>\r\n<li>Nemo enim ipsam voluptatem quia voluptas sit aspernatur aut odit aut fugit</li>\r\n<li>Sed ut perspiciatis unde omnis iste natus error </li>\r\n<li>Qui dolorem ipsum quia dolor sit amet, consectetur, adipisci velit</li>\r\n</ul>\r\n<h2>h2. Heading 2</h2>\r\n<p>Sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum. Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium, totam rem aperiam, eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo.</p>\r\n<h3>h3. Heading 3</h3>\r\n<p>Sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum. Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium, totam rem aperiam, eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo.</p>','','full_html'),('node','page',0,33,33,'und',0,'Phasellus facilisis feugiat convallis? Suspendisse vestibulum ante ut sagittis viverra. Mauris tincidunt id neque ac malesuada. Aliquam cursus pharetra suscipit. Fusce non arcu eros. Nulla pretium dictum felis; vitae feugiat dui congue nec? Phasellus eu enim id leo sodales lacinia eu ultrices odio. Proin placerat ut ligula vel ornare. Proin purus lacus, hendrerit sed rutrum a, condimentum mattis lorem? Aliquam aliquam, elit id suscipit molestie, neque est viverra arcu, nec vulputate nibh tortor et quam. Nam dictum, nisi in consequat ultricies; lacus dui fringilla sem, ac luctus mi odio ullamcorper massa! Integer id neque mauris. Sed dignissim eget purus vitae ullamcorper.\r\n\r\nDonec faucibus malesuada odio et commodo. Nulla sed adipiscing sem, id feugiat diam. Curabitur dapibus ut mauris at consectetur. Praesent ut tempus nisl, commodo hendrerit dui. Proin venenatis sit amet nisl id feugiat. Sed imperdiet luctus felis. Nunc at neque turpis? Sed ac neque dolor? Mauris sollicitudin erat nisi, quis venenatis augue lobortis et. Nulla consectetur urna a dui sagittis, et sagittis lorem malesuada. Suspendisse potenti. Praesent felis justo, ultricies vestibulum mauris et, tempor ultricies metus.\r\n','','filtered_html'),('node','video',0,34,34,'und',0,'Lorem ipsum dolor sit amet, consectetur adipiscing elit. Pellentesque eget dolor sit amet lorem vulputate aliquet. Praesent eu dignissim turpis. Duis volutpat gravida tincidunt. Vivamus sodales ligula in accumsan accumsan. Nunc adipiscing posuere ultricies. Class aptent taciti sociosqu ad litora torquent per conubia nostra, per inceptos himenaeos. Praesent vehicula justo id nunc facilisis volutpat porttitor id eros.\r\n\r\nUt aliquet sodales purus, in pretium risus consequat id. Proin convallis pretium lacus, et rhoncus ipsum mollis eget. Mauris pulvinar leo non magna blandit, sed viverra neque euismod. Vestibulum bibendum pretium nibh consequat tincidunt. Suspendisse consequat tortor nisi, eget dictum orci vulputate vel. Morbi ultrices condimentum lacus, semper venenatis leo ultrices sit amet. Ut et tincidunt purus, non venenatis nibh. Etiam congue quam metus, feugiat fringilla nunc congue nec. Donec ut condimentum justo. Nam ut leo et nisl consequat commodo. Nullam tempus rutrum massa, eu ullamcorper turpis dapibus at. Vestibulum feugiat ligula eu nibh vehicula varius.\r\n\r\n<blockquote>\r\n<p>Donec lobortis nisi vel erat posuere porttitor. Interdum et malesuada fames ac ante ipsum primis in faucibus. Curabitur venenatis massa sit amet mi mollis sollicitudin. Duis ut purus tincidunt, lobortis tortor a, porttitor erat. Quisque suscipit mi eu euismod egestas. Cras quis porta augue. Morbi porttitor cursus eros. Fusce aliquam vel lorem ut dignissim. Fusce commodo nisl et arcu aliquam, nec accumsan purus dictum. In commodo eleifend justo, eu sagittis libero laoreet in.</p>\r\n<footer>Someone famous in <cite title=\"Source Title\">Source Title</cite></footer>\r\n</blockquote>\r\n\r\nAliquam elementum turpis eget felis eleifend, id sodales dui ultrices. Fusce rhoncus, libero sed consectetur commodo, arcu nisl malesuada sem, commodo facilisis risus diam eu sapien. Aenean iaculis, urna id ultrices lacinia, lacus lectus commodo neque, vel tincidunt lectus quam ac tellus. Sed interdum mattis neque, nec rhoncus lorem laoreet ornare. Vestibulum dignissim, libero non convallis pulvinar, leo lectus dignissim risus, ac consequat metus purus sed nisi. Aliquam erat volutpat. Vivamus elementum feugiat orci. Nam vitae elementum risus, porta luctus tortor. Proin luctus tristique massa. Phasellus volutpat id leo sed facilisis. Vestibulum accumsan libero eu arcu malesuada luctus.\r\n\r\nNulla porta mi quis nisi pellentesque vehicula. Cras enim mi, venenatis quis odio in, dapibus venenatis mauris. Integer et faucibus justo. Sed mauris odio, sodales ut elit scelerisque, volutpat pellentesque felis. Nullam justo lacus, tempus a leo id, scelerisque hendrerit arcu. Nulla et nulla sit amet justo pulvinar cursus. Pellentesque fermentum mollis leo, ac iaculis lacus mattis id. Suspendisse ornare vitae nisl at volutpat. Aliquam nisi lacus, adipiscing at neque ac, volutpat interdum nisl. Ut bibendum elit quam, a pharetra augue laoreet eget. Vestibulum bibendum dui ultrices, cursus nisi eu, commodo lorem. Suspendisse placerat risus eu magna congue malesuada. Nam sed cursus tellus, vitae vehicula est. Donec ut massa elit. Interdum et malesuada fames ac ante ipsum primis in faucibus.','','filtered_html'),('node','video',0,35,35,'und',0,'Praesent sit amet enim tempus, lobortis eros adipiscing, consequat nisl. Nam eget euismod justo. Aenean non elit eleifend, feugiat augue vitae, sagittis nibh. Vivamus a ante dolor. Integer pharetra euismod est, vitae volutpat enim viverra a? Vivamus velit augue, facilisis vel tortor eu, dignissim suscipit urna. Maecenas pellentesque facilisis sapien non hendrerit? Aliquam sodales turpis dui, sit amet blandit nunc fringilla eget. Fusce congue massa eu elit molestie tempor id vitae justo. Maecenas rhoncus egestas felis, a ornare magna laoreet vel? Sed id tincidunt enim. Aenean vulputate ut felis et consectetur.\r\n\r\nNullam quis viverra augue, ut imperdiet orci. Morbi in vulputate dui, eget tempus mi. Nunc ac convallis justo, adipiscing sodales erat. Nullam venenatis bibendum condimentum. Aliquam egestas eget mauris sollicitudin egestas. Curabitur ullamcorper massa est, ut faucibus tellus aliquet quis? Proin eu porta augue. Aenean eu ligula elementum arcu sagittis iaculis. Aliquam dapibus pulvinar faucibus. Cras vel orci suscipit, consequat metus gravida, convallis eros.\r\n\r\nPellentesque congue tellus non felis sollicitudin bibendum. Maecenas risus risus, accumsan eu lectus a, congue massa nunc.\r\n','','filtered_html'),('node','video',0,36,36,'und',0,'Donec posuere vulputate arcu. Phasellus consectetuer vestibulum elit. Nam commodo suscipit quam. Fusce pharetra convallis urna. Donec sodales sagittis magna. Vestibulum turpis sem, aliquet eget, lobortis pellentesque, rutrum eu, nisl. Sed magna purus, fermentum eu, tincidunt eu, varius ut, felis. Vivamus laoreet. In ut quam vitae odio lacinia tincidunt. Sed aliquam ultrices mauris. Sed mollis, eros et ultrices tempus, mauris ipsum aliquam libero, non adipiscing dolor urna a orci. Fusce risus nisl, viverra et, tempor et, pretium in, sapien. Duis vel nibh at velit scelerisque suscipit. Nullam vel sem. In hac habitasse platea dictumst.\r\n\r\nCras dapibus. Duis arcu tortor, suscipit eget, imperdiet nec, imperdiet iaculis, ipsum. Proin faucibus arcu quis ante. Maecenas vestibulum mollis diam. Praesent blandit laoreet nibh. Donec quam felis, ultricies nec, pellentesque eu, pretium quis, sem. Phasellus leo dolor, tempus non, auctor et, hendrerit quis, nisi. Vivamus aliquet elit ac nisl. Fusce a quam. Suspendisse potenti.','','filtered_html'),('node','video',0,37,37,'und',0,'Aenean ut eros et nisl sagittis vestibulum. Suspendisse potenti. Proin viverra, ligula sit amet ultrices semper, ligula arcu tristique sapien, a accumsan nisi mauris ac eros. Cras sagittis. Vivamus consectetuer hendrerit lacus. Pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas. Vivamus quis mi. Etiam sit amet orci eget eros faucibus tincidunt. Phasellus nec sem in justo pellentesque facilisis. Fusce egestas elit eget lorem. Nullam sagittis. Nullam dictum felis eu pede mollis pretium. Ut leo. Quisque malesuada placerat nisl. Donec vitae orci sed dolor rutrum auctor.\r\n\r\nUt varius tincidunt libero. In ut quam vitae odio lacinia tincidunt. Sed hendrerit. Nam eget dui. Aenean viverra rhoncus pede.Aenean imperdiet. Cras sagittis. Pellentesque libero tortor, tincidunt et, tincidunt eget, semper nec, quam. Fusce a quam. Sed consequat, leo eget bibendum sodales, augue velit cursus nunc, quis gravida magna mi a libero. Maecenas egestas arcu quis ligula mattis placerat. In auctor lobortis lacus. Mauris sollicitudin fermentum libero. Etiam feugiat lorem non metus. Vestibulum dapibus nunc ac augue.\r\n\r\nMaecenas malesuada. Vestibulum rutrum, mi nec elementum vehicula, eros quam gravida nisl, id fringilla neque ante vel mi. Vestibulum rutrum, mi nec elementum vehicula, eros quam gravida nisl, id fringilla neque ante vel mi. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Sed aliquam, nisi quis porttitor congue, elit erat euismod orci, ac placerat dolor lectus quis orci. Maecenas tempus, tellus eget condimentum rhoncus, sem quam semper libero, sit amet adipiscing sem neque sed ipsum.\r\n\r\nPraesent nonummy mi in odio. Praesent nonummy mi in odio. Quisque libero metus, condimentum nec, tempor a, commodo mollis, magna. Vivamus euismod mauris. Donec pede justo, fringilla vel, aliquet nec, vulputate eget, arcu. Phasellus dolor. Phasellus magna. Nulla porta dolor. Etiam imperdiet imperdiet orci. Nunc egestas, augue at pellentesque laoreet, felis eros vehicula leo, at malesuada velit leo quis pede.','','filtered_html'),('node','video',0,38,38,'und',0,'Lorem ipsum dolor sit amet, consectetur adipiscing elit. Pellentesque eget dolor sit amet lorem vulputate aliquet. Praesent eu dignissim turpis. Duis volutpat gravida tincidunt. Vivamus sodales ligula in accumsan accumsan. Nunc adipiscing posuere ultricies. Class aptent taciti sociosqu ad litora torquent per conubia nostra, per inceptos himenaeos. Praesent vehicula justo id nunc facilisis volutpat porttitor id eros.\r\n\r\nUt aliquet sodales purus, in pretium risus consequat id. Proin convallis pretium lacus, et rhoncus ipsum mollis eget. Mauris pulvinar leo non magna blandit, sed viverra neque euismod. Vestibulum bibendum pretium nibh consequat tincidunt. Suspendisse consequat tortor nisi, eget dictum orci vulputate vel. Morbi ultrices condimentum lacus, semper venenatis leo ultrices sit amet. Ut et tincidunt purus, non venenatis nibh. Etiam congue quam metus, feugiat fringilla nunc congue nec. Donec ut condimentum justo. Nam ut leo et nisl consequat commodo. Nullam tempus rutrum massa, eu ullamcorper turpis dapibus at. Vestibulum feugiat ligula eu nibh vehicula varius.\r\n\r\n<blockquote>\r\n<p>Donec lobortis nisi vel erat posuere porttitor. Interdum et malesuada fames ac ante ipsum primis in faucibus. Curabitur venenatis massa sit amet mi mollis sollicitudin. Duis ut purus tincidunt, lobortis tortor a, porttitor erat. Quisque suscipit mi eu euismod egestas. Cras quis porta augue. Morbi porttitor cursus eros. Fusce aliquam vel lorem ut dignissim. Fusce commodo nisl et arcu aliquam, nec accumsan purus dictum. In commodo eleifend justo, eu sagittis libero laoreet in.</p>\r\n<footer>Someone famous in <cite title=\"Source Title\">Source Title</cite></footer>\r\n</blockquote>\r\n\r\nAliquam elementum turpis eget felis eleifend, id sodales dui ultrices. Fusce rhoncus, libero sed consectetur commodo, arcu nisl malesuada sem, commodo facilisis risus diam eu sapien. Aenean iaculis, urna id ultrices lacinia, lacus lectus commodo neque, vel tincidunt lectus quam ac tellus. Sed interdum mattis neque, nec rhoncus lorem laoreet ornare. Vestibulum dignissim, libero non convallis pulvinar, leo lectus dignissim risus, ac consequat metus purus sed nisi. Aliquam erat volutpat. Vivamus elementum feugiat orci. Nam vitae elementum risus, porta luctus tortor. Proin luctus tristique massa. Phasellus volutpat id leo sed facilisis. Vestibulum accumsan libero eu arcu malesuada luctus.\r\n\r\nNulla porta mi quis nisi pellentesque vehicula. Cras enim mi, venenatis quis odio in, dapibus venenatis mauris. Integer et faucibus justo. Sed mauris odio, sodales ut elit scelerisque, volutpat pellentesque felis. Nullam justo lacus, tempus a leo id, scelerisque hendrerit arcu. Nulla et nulla sit amet justo pulvinar cursus. Pellentesque fermentum mollis leo, ac iaculis lacus mattis id. Suspendisse ornare vitae nisl at volutpat. Aliquam nisi lacus, adipiscing at neque ac, volutpat interdum nisl. Ut bibendum elit quam, a pharetra augue laoreet eget. Vestibulum bibendum dui ultrices, cursus nisi eu, commodo lorem. Suspendisse placerat risus eu magna congue malesuada. Nam sed cursus tellus, vitae vehicula est. Donec ut massa elit. Interdum et malesuada fames ac ante ipsum primis in faucibus.','','filtered_html'),('node','page',0,39,39,'und',0,'Aliquam convallis neque a massa molestie, vitae imperdiet enim feugiat! Nulla bibendum odio eu lobortis faucibus. Pellentesque consectetur orci diam, quis suscipit ligula lobortis eu. Quisque vel bibendum lacus, quis dictum tellus. Nulla eu justo viverra, hendrerit elit vitae, tristique quam. Proin ut aliquam dui. Fusce vestibulum, eros hendrerit tincidunt aliquet, dui odio consectetur leo, vitae tincidunt lacus leo et lorem! Praesent euismod erat eget urna fringilla, tempus faucibus sem egestas. Quisque quis consequat nunc.\r\n\r\nUt ultrices cursus eleifend. Curabitur pharetra, felis et auctor vehicula, velit arcu convallis purus; non tempor augue libero in quam. Donec congue viverra auctor? Nullam aliquam rhoncus rutrum. Donec id arcu ligula. Nam id lorem placerat, eleifend tortor quis, pellentesque nibh. Curabitur tempus purus vel eleifend euismod. Quisque eu diam nunc! Morbi sed imperdiet nisl, vitae sagittis est. Mauris euismod sodales lacinia. Donec euismod enim vel accumsan pretium. Duis at rutrum nunc.\r\n\r\nLorem ipsum dolor sit amet, consectetuer adipiscing elit, sed diam nonummy nibh euismod tincidunt ut laoreet dolore magna aliquam erat volutpat. Nam liber tempor cum soluta nobis eleifend option congue nihil imperdiet doming id quod mazim placerat facer possim assum. At vero eos et accusam et justo duo dolores et ea rebum. Stet clita kasd gubergren, no sea takimata sanctus est Lorem ipsum dolor sit amet. Stet clita kasd gubergren, no sea takimata sanctus est Lorem ipsum dolor sit amet.\r\n\r\nLorem ipsum dolor sit amet, consetetur sadipscing elitr, sed diam nonumy eirmod tempor invidunt ut labore et dolore magna aliquyam erat. Lorem ipsum dolor sit amet, consetetur sadipscing elitr, sed diam nonumy eirmod tempor invidunt ut labore et dolore magna aliquyam erat, sed diam voluptua. At vero eos et accusam et justo duo dolores et ea rebum. At vero eos et accusam et justo duo dolores et ea rebum. Ut wisi enim ad minim veniam, quis nostrud exerci tation ullamcorper suscipit lobortis nisl ut aliquip ex ea commodo consequat.\r\n\r\nStet clita kasd gubergren, no sea takimata sanctus est Lorem ipsum dolor sit amet. Excepteur sint obcaecat cupiditat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum. Stet clita kasd gubergren, no sea takimata sanctus est Lorem ipsum dolor sit amet. Ut wisi enim ad minim veniam, quis nostrud exerci tation ullamcorper suscipit lobortis nisl ut aliquip ex ea commodo consequat. Duis autem vel eum iriure dolor in hendrerit in vulputate velit esse molestie consequat, vel illum dolore eu feugiat nulla facilisis at vero eros et accumsan et iusto odio dignissim qui blandit praesent luptatum zzril delenit augue duis dolore te feugait nulla facilisi.\r\n\r\nAt vero eos et accusam et justo duo dolores et ea rebum. Stet clita kasd gubergren, no sea takimata sanctus est Lorem ipsum dolor sit amet. Stet clita kasd gubergren, no sea takimata sanctus est Lorem ipsum dolor sit amet. Quis aute iure reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur. At vero eos et accusam et justo duo dolores et ea rebum.\r\n\r\nDuis autem vel eum iriure dolor in hendrerit in vulputate velit esse molestie consequat, vel illum dolore eu feugiat nulla facilisis. Duis autem vel eum iriure dolor in hendrerit in vulputate velit esse molestie consequat, vel illum dolore eu feugiat nulla facilisis at vero eros et accumsan et iusto odio dignissim qui blandit praesent luptatum zzril delenit augue duis dolore te feugait nulla facilisi. Quis aute iure reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur. Ut wisi enim ad minim veniam, quis nostrud exerci tation ullamcorper suscipit lobortis nisl ut aliquip ex ea commodo consequat..\r\n\r\nLorem ipsum dolor sit amet, consetetur sadipscing elitr, At accusam aliquyam diam diam dolore dolores duo eirmod eos erat, et nonumy sed tempor et et invidunt justo labore Stet clita ea et gubergren, kasd magna no rebum. Duis autem vel eum iriure dolor in hendrerit in vulputate velit esse molestie consequat, vel illum dolore eu feugiat nulla facilisis. At vero eos et accusam et justo duo dolores et ea rebum. At vero eos et accusam et justo duo dolores et ea rebum. Excepteur sint obcaecat cupiditat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum.\r\n\r\n Nam liber tempor cum soluta nobis eleifend option congue nihil imperdiet doming id quod mazim placerat facer possim assum. Ut wisi enim ad minim veniam, quis nostrud exerci tation ullamcorper suscipit lobortis nisl ut aliquip ex ea commodo consequat. Ut wisi enim ad minim veniam, quis nostrud exerci tation ullamcorper suscipit lobortis nisl ut aliquip ex ea commodo consequat. Consetetur sadipscing elitr, sed diam nonumy eirmod tempor invidunt ut labore et dolore magna aliquyam erat, sed diam voluptua.\r\n\r\nLorem ipsum dolor sit amet, consetetur sadipscing elitr, sed diam nonumy eirmod tempor invidunt ut labore et dolore magna aliquyam erat. Stet clita kasd gubergren, no sea takimata sanctus est Lorem ipsum dolor sit amet. Excepteur sint obcaecat cupiditat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum. Lorem ipsum dolor sit amet. Quis aute iure reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.\r\n','','filtered_html'),('node','webform',0,40,40,'und',0,'<div class=\"contact-content clearfix\">\r\n<p>Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur. Excepteur sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum. Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium, totam rem aperiam, eaque ipsa quae ab illo inventore veritatis et quasi architecto .</p>\r\n\r\n<address>\r\n<i class=\"fa fa-map-marker\"></i> Alexander Street. Vancouver, BC<br> V6A 1E1 Canada<br><i class=\"fa fa-phone\"></i> 012.345.6789<br><i class=\"fa fa-print\"></i> 012.345.6789<br><i class=\"fa fa-envelope\"></i> support@weebpal.com</address>\r\n</div>','','full_html'),('node','webform',0,41,41,'und',0,'<div class=\"contact-content clearfix\">\r\n<p>Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur. Excepteur sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum. Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium, totam rem aperiam, eaque ipsa quae ab illo inventore veritatis et quasi architecto .</p>\r\n\r\n<address>\r\n<i class=\"fa fa-map-marker\"></i> Alexander Street. Vancouver, BC<br> V6A 1E1 Canada<br><i class=\"fa fa-phone\"></i> 012.345.6789<br><i class=\"fa fa-print\"></i> 012.345.6789<br><i class=\"fa fa-envelope\"></i> support@weebpal.com</address>\r\n</div>','','full_html'),('node','page',0,42,42,'und',0,'orem ipsum dolor sit amet, consectetur adipiscing elit. Suspendisse quis ante pharetra, porta odio non, mattis urna. Aliquam mattis bibendum lacinia. Mauris adipiscing tincidunt turpis at sodales. Aenean in feugiat urna. Praesent at dictum diam, vitae cursus velit. Donec mauris nisi, aliquam ac lectus id, luctus imperdiet lacus. Cras tellus purus, eleifend eu gravida vitae, aliquam a nunc. Suspendisse dictum dui in dapibus consequat. Proin non hendrerit orci. Sed eget velit turpis. Pellentesque nec tempor elit. Proin sit amet ullamcorper est, nec vestibulum velit. Etiam rhoncus, lectus a lacinia lobortis, nisl risus accumsan ante, sed interdum ante lectus sit amet nunc. Vivamus molestie dolor at dolor sagittis, eu consequat orci tristique.\r\n\r\nNunc gravida adipiscing magna sit amet pulvinar. Aenean nec scelerisque nisl, nec ultrices justo. Phasellus a mollis leo, at hendrerit tellus. In mollis enim et euismod mattis. Nunc aliquet sit amet sapien quis ornare. Nunc rutrum, eros in dignissim adipiscing, nibh nibh faucibus elit, ac faucibus sem enim sit amet eros. Nulla at lectus vel enim posuere sodales quis pellentesque eros. Quisque rhoncus nisi sit amet neque fermentum tempus. Morbi fermentum massa dolor, at adipiscing lectus porta sed. Curabitur fringilla metus a scelerisque blandit. Donec sit amet nisi id lectus pharetra tincidunt a a augue. Quisque posuere ante non odio consectetur rhoncus. Nulla at arcu ultricies nunc placerat posuere eu vitae lacus. Aenean hendrerit auctor justo sed gravida.\r\n\r\nMorbi nunc est, vestibulum ac est nec, fringilla bibendum arcu. Etiam id tortor vel ligula dictum adipiscing mollis nec dolor. Vivamus sed eros a lacus accumsan bibendum vitae eget ante. Sed aliquam interdum ipsum in bibendum. Nunc faucibus, tellus et vestibulum imperdiet, ligula velit tincidunt mi, vel porttitor nibh felis non risus. Phasellus id turpis vitae libero consequat pretium nec sodales erat. Donec luctus arcu eget nulla luctus tempus pretium non odio. Sed tempus nec elit quis facilisis. In pretium posuere magna sit amet vehicula. Etiam dapibus sem nec metus laoreet, quis imperdiet libero condimentum. Aliquam fermentum velit eget leo convallis ullamcorper. Fusce ac consectetur elit, id convallis augue.\r\n\r\nPraesent gravida aliquet ante, vitae suscipit dui fringilla id. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis gravida id erat nec vulputate. Duis rutrum, est id cursus suscipit, dui arcu ornare eros, vel consequat urna sapien sed libero. Quisque quis diam ac nisl ultrices blandit. Quisque cursus feugiat sollicitudin. Nam vitae risus et metus ornare consequat quis nec diam. Vestibulum laoreet sem quis dolor congue cursus. In aliquam risus semper lacus cursus dictum. Nunc condimentum lectus sed tellus bibendum, sed eleifend mi consectetur. Fusce cursus pretium ante, eget euismod sem imperdiet nec. Mauris vitae ipsum libero.\r\n\r\nDonec eros neque, imperdiet quis magna a, facilisis venenatis velit. Sed eu velit et erat vehicula convallis. Curabitur vestibulum ut purus sed ultrices. Suspendisse laoreet in risus vitae pulvinar. Sed ac metus diam. Sed posuere justo quis est mattis, sit amet gravida purus feugiat. Duis sit amet semper diam. Suspendisse nulla libero, auctor eu lectus id, congue suscipit nisi.','','filtered_html'),('node','page',0,43,43,'und',0,'orem ipsum dolor sit amet, consectetur adipiscing elit. Suspendisse quis ante pharetra, porta odio non, mattis urna. Aliquam mattis bibendum lacinia. Mauris adipiscing tincidunt turpis at sodales. Aenean in feugiat urna. Praesent at dictum diam, vitae cursus velit. Donec mauris nisi, aliquam ac lectus id, luctus imperdiet lacus. Cras tellus purus, eleifend eu gravida vitae, aliquam a nunc. Suspendisse dictum dui in dapibus consequat. Proin non hendrerit orci. Sed eget velit turpis. Pellentesque nec tempor elit. Proin sit amet ullamcorper est, nec vestibulum velit. Etiam rhoncus, lectus a lacinia lobortis, nisl risus accumsan ante, sed interdum ante lectus sit amet nunc. Vivamus molestie dolor at dolor sagittis, eu consequat orci tristique.\r\n\r\nNunc gravida adipiscing magna sit amet pulvinar. Aenean nec scelerisque nisl, nec ultrices justo. Phasellus a mollis leo, at hendrerit tellus. In mollis enim et euismod mattis. Nunc aliquet sit amet sapien quis ornare. Nunc rutrum, eros in dignissim adipiscing, nibh nibh faucibus elit, ac faucibus sem enim sit amet eros. Nulla at lectus vel enim posuere sodales quis pellentesque eros. Quisque rhoncus nisi sit amet neque fermentum tempus. Morbi fermentum massa dolor, at adipiscing lectus porta sed. Curabitur fringilla metus a scelerisque blandit. Donec sit amet nisi id lectus pharetra tincidunt a a augue. Quisque posuere ante non odio consectetur rhoncus. Nulla at arcu ultricies nunc placerat posuere eu vitae lacus. Aenean hendrerit auctor justo sed gravida.\r\n\r\nMorbi nunc est, vestibulum ac est nec, fringilla bibendum arcu. Etiam id tortor vel ligula dictum adipiscing mollis nec dolor. Vivamus sed eros a lacus accumsan bibendum vitae eget ante. Sed aliquam interdum ipsum in bibendum. Nunc faucibus, tellus et vestibulum imperdiet, ligula velit tincidunt mi, vel porttitor nibh felis non risus. Phasellus id turpis vitae libero consequat pretium nec sodales erat. Donec luctus arcu eget nulla luctus tempus pretium non odio. Sed tempus nec elit quis facilisis. In pretium posuere magna sit amet vehicula. Etiam dapibus sem nec metus laoreet, quis imperdiet libero condimentum. Aliquam fermentum velit eget leo convallis ullamcorper. Fusce ac consectetur elit, id convallis augue.\r\n\r\nPraesent gravida aliquet ante, vitae suscipit dui fringilla id. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis gravida id erat nec vulputate. Duis rutrum, est id cursus suscipit, dui arcu ornare eros, vel consequat urna sapien sed libero. Quisque quis diam ac nisl ultrices blandit. Quisque cursus feugiat sollicitudin. Nam vitae risus et metus ornare consequat quis nec diam. Vestibulum laoreet sem quis dolor congue cursus. In aliquam risus semper lacus cursus dictum. Nunc condimentum lectus sed tellus bibendum, sed eleifend mi consectetur. Fusce cursus pretium ante, eget euismod sem imperdiet nec. Mauris vitae ipsum libero.\r\n\r\nDonec eros neque, imperdiet quis magna a, facilisis venenatis velit. Sed eu velit et erat vehicula convallis. Curabitur vestibulum ut purus sed ultrices. Suspendisse laoreet in risus vitae pulvinar. Sed ac metus diam. Sed posuere justo quis est mattis, sit amet gravida purus feugiat. Duis sit amet semper diam. Suspendisse nulla libero, auctor eu lectus id, congue suscipit nisi.','','filtered_html'),('node','page',0,44,44,'und',0,'orem ipsum dolor sit amet, consectetur adipiscing elit. Suspendisse quis ante pharetra, porta odio non, mattis urna. Aliquam mattis bibendum lacinia. Mauris adipiscing tincidunt turpis at sodales. Aenean in feugiat urna. Praesent at dictum diam, vitae cursus velit. Donec mauris nisi, aliquam ac lectus id, luctus imperdiet lacus. Cras tellus purus, eleifend eu gravida vitae, aliquam a nunc. Suspendisse dictum dui in dapibus consequat. Proin non hendrerit orci. Sed eget velit turpis. Pellentesque nec tempor elit. Proin sit amet ullamcorper est, nec vestibulum velit. Etiam rhoncus, lectus a lacinia lobortis, nisl risus accumsan ante, sed interdum ante lectus sit amet nunc. Vivamus molestie dolor at dolor sagittis, eu consequat orci tristique.\r\n\r\nNunc gravida adipiscing magna sit amet pulvinar. Aenean nec scelerisque nisl, nec ultrices justo. Phasellus a mollis leo, at hendrerit tellus. In mollis enim et euismod mattis. Nunc aliquet sit amet sapien quis ornare. Nunc rutrum, eros in dignissim adipiscing, nibh nibh faucibus elit, ac faucibus sem enim sit amet eros. Nulla at lectus vel enim posuere sodales quis pellentesque eros. Quisque rhoncus nisi sit amet neque fermentum tempus. Morbi fermentum massa dolor, at adipiscing lectus porta sed. Curabitur fringilla metus a scelerisque blandit. Donec sit amet nisi id lectus pharetra tincidunt a a augue. Quisque posuere ante non odio consectetur rhoncus. Nulla at arcu ultricies nunc placerat posuere eu vitae lacus. Aenean hendrerit auctor justo sed gravida.\r\n\r\nMorbi nunc est, vestibulum ac est nec, fringilla bibendum arcu. Etiam id tortor vel ligula dictum adipiscing mollis nec dolor. Vivamus sed eros a lacus accumsan bibendum vitae eget ante. Sed aliquam interdum ipsum in bibendum. Nunc faucibus, tellus et vestibulum imperdiet, ligula velit tincidunt mi, vel porttitor nibh felis non risus. Phasellus id turpis vitae libero consequat pretium nec sodales erat. Donec luctus arcu eget nulla luctus tempus pretium non odio. Sed tempus nec elit quis facilisis. In pretium posuere magna sit amet vehicula. Etiam dapibus sem nec metus laoreet, quis imperdiet libero condimentum. Aliquam fermentum velit eget leo convallis ullamcorper. Fusce ac consectetur elit, id convallis augue.\r\n\r\nPraesent gravida aliquet ante, vitae suscipit dui fringilla id. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis gravida id erat nec vulputate. Duis rutrum, est id cursus suscipit, dui arcu ornare eros, vel consequat urna sapien sed libero. Quisque quis diam ac nisl ultrices blandit. Quisque cursus feugiat sollicitudin. Nam vitae risus et metus ornare consequat quis nec diam. Vestibulum laoreet sem quis dolor congue cursus. In aliquam risus semper lacus cursus dictum. Nunc condimentum lectus sed tellus bibendum, sed eleifend mi consectetur. Fusce cursus pretium ante, eget euismod sem imperdiet nec. Mauris vitae ipsum libero.\r\n\r\nDonec eros neque, imperdiet quis magna a, facilisis venenatis velit. Sed eu velit et erat vehicula convallis. Curabitur vestibulum ut purus sed ultrices. Suspendisse laoreet in risus vitae pulvinar. Sed ac metus diam. Sed posuere justo quis est mattis, sit amet gravida purus feugiat. Duis sit amet semper diam. Suspendisse nulla libero, auctor eu lectus id, congue suscipit nisi.','','filtered_html'),('node','page',0,45,45,'und',0,'<p>orem ipsum dolor sit amet, consectetur adipiscing elit. Suspendisse quis ante pharetra, porta odio non, mattis urna. Aliquam mattis bibendum lacinia. Mauris adipiscing tincidunt turpis at sodales. Aenean in feugiat urna. Praesent at dictum diam, vitae cursus velit. Donec mauris nisi, aliquam ac lectus id, luctus imperdiet lacus. Cras tellus purus, eleifend eu gravida vitae, aliquam a nunc. Suspendisse dictum dui in dapibus consequat. Proin non hendrerit orci. Sed eget velit turpis. Pellentesque nec tempor elit. Proin sit amet ullamcorper est, nec vestibulum velit. Etiam rhoncus, lectus a lacinia lobortis, nisl risus accumsan ante, sed interdum ante lectus sit amet nunc. Vivamus molestie dolor at dolor sagittis, eu consequat orci tristique. Nunc gravida adipiscing magna sit amet pulvinar. Aenean nec scelerisque nisl, nec ultrices justo. Phasellus a mollis leo, at hendrerit tellus. In mollis enim et euismod mattis. Nunc aliquet sit amet sapien quis ornare. Nunc rutrum, eros in dignissim adipiscing, nibh nibh faucibus elit, ac faucibus sem enim sit amet eros. Nulla at lectus vel enim posuere sodales quis pellentesque eros. Quisque rhoncus nisi sit amet neque fermentum tempus. Morbi fermentum massa dolor, at adipiscing lectus porta sed. Curabitur fringilla metus a scelerisque blandit. Donec sit amet nisi id lectus pharetra tincidunt a a augue. Quisque posuere ante non odio consectetur rhoncus. Nulla at arcu ultricies nunc placerat posuere eu vitae lacus. Aenean hendrerit auctor justo sed gravida. Morbi nunc est, vestibulum ac est nec, fringilla bibendum arcu. Etiam id tortor vel ligula dictum adipiscing mollis nec dolor. Vivamus sed eros a lacus accumsan bibendum vitae eget ante. Sed aliquam interdum ipsum in bibendum. Nunc faucibus, tellus et vestibulum imperdiet, ligula velit tincidunt mi, vel porttitor nibh felis non risus. Phasellus id turpis vitae libero consequat pretium nec sodales erat. Donec luctus arcu eget nulla luctus tempus pretium non odio. Sed tempus nec elit quis facilisis. In pretium posuere magna sit amet vehicula. Etiam dapibus sem nec metus laoreet, quis imperdiet libero condimentum. Aliquam fermentum velit eget leo convallis ullamcorper. Fusce ac consectetur elit, id convallis augue. Praesent gravida aliquet ante, vitae suscipit dui fringilla id. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis gravida id erat nec vulputate. Duis rutrum, est id cursus suscipit, dui arcu ornare eros, vel consequat urna sapien sed libero. Quisque quis diam ac nisl ultrices blandit. Quisque cursus feugiat sollicitudin. Nam vitae risus et metus ornare consequat quis nec diam. Vestibulum laoreet sem quis dolor congue cursus. In aliquam risus semper lacus cursus dictum. Nunc condimentum lectus sed tellus bibendum, sed eleifend mi consectetur. Fusce cursus pretium ante, eget euismod sem imperdiet nec. Mauris vitae ipsum libero. Donec eros neque, imperdiet quis magna a, facilisis venenatis velit. Sed eu velit et erat vehicula convallis. Curabitur vestibulum ut purus sed ultrices. Suspendisse laoreet in risus vitae pulvinar. Sed ac metus diam. Sed posuere justo quis est mattis, sit amet gravida purus feugiat. Duis sit amet semper diam. Suspendisse nulla libero, auctor eu lectus id, congue suscipit nisi.</p>\r\n','','filtered_html'),('node','page',0,46,46,'und',0,'orem ipsum dolor sit amet, consectetur adipiscing elit. Suspendisse quis ante pharetra, porta odio non, mattis urna. Aliquam mattis bibendum lacinia. Mauris adipiscing tincidunt turpis at sodales. Aenean in feugiat urna. Praesent at dictum diam, vitae cursus velit. Donec mauris nisi, aliquam ac lectus id, luctus imperdiet lacus. Cras tellus purus, eleifend eu gravida vitae, aliquam a nunc. Suspendisse dictum dui in dapibus consequat. Proin non hendrerit orci. Sed eget velit turpis. Pellentesque nec tempor elit. Proin sit amet ullamcorper est, nec vestibulum velit. Etiam rhoncus, lectus a lacinia lobortis, nisl risus accumsan ante, sed interdum ante lectus sit amet nunc. Vivamus molestie dolor at dolor sagittis, eu consequat orci tristique.\r\n\r\nNunc gravida adipiscing magna sit amet pulvinar. Aenean nec scelerisque nisl, nec ultrices justo. Phasellus a mollis leo, at hendrerit tellus. In mollis enim et euismod mattis. Nunc aliquet sit amet sapien quis ornare. Nunc rutrum, eros in dignissim adipiscing, nibh nibh faucibus elit, ac faucibus sem enim sit amet eros. Nulla at lectus vel enim posuere sodales quis pellentesque eros. Quisque rhoncus nisi sit amet neque fermentum tempus. Morbi fermentum massa dolor, at adipiscing lectus porta sed. Curabitur fringilla metus a scelerisque blandit. Donec sit amet nisi id lectus pharetra tincidunt a a augue. Quisque posuere ante non odio consectetur rhoncus. Nulla at arcu ultricies nunc placerat posuere eu vitae lacus. Aenean hendrerit auctor justo sed gravida.\r\n\r\nMorbi nunc est, vestibulum ac est nec, fringilla bibendum arcu. Etiam id tortor vel ligula dictum adipiscing mollis nec dolor. Vivamus sed eros a lacus accumsan bibendum vitae eget ante. Sed aliquam interdum ipsum in bibendum. Nunc faucibus, tellus et vestibulum imperdiet, ligula velit tincidunt mi, vel porttitor nibh felis non risus. Phasellus id turpis vitae libero consequat pretium nec sodales erat. Donec luctus arcu eget nulla luctus tempus pretium non odio. Sed tempus nec elit quis facilisis. In pretium posuere magna sit amet vehicula. Etiam dapibus sem nec metus laoreet, quis imperdiet libero condimentum. Aliquam fermentum velit eget leo convallis ullamcorper. Fusce ac consectetur elit, id convallis augue.\r\n\r\nPraesent gravida aliquet ante, vitae suscipit dui fringilla id. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis gravida id erat nec vulputate. Duis rutrum, est id cursus suscipit, dui arcu ornare eros, vel consequat urna sapien sed libero. Quisque quis diam ac nisl ultrices blandit. Quisque cursus feugiat sollicitudin. Nam vitae risus et metus ornare consequat quis nec diam. Vestibulum laoreet sem quis dolor congue cursus. In aliquam risus semper lacus cursus dictum. Nunc condimentum lectus sed tellus bibendum, sed eleifend mi consectetur. Fusce cursus pretium ante, eget euismod sem imperdiet nec. Mauris vitae ipsum libero.\r\n\r\nDonec eros neque, imperdiet quis magna a, facilisis venenatis velit. Sed eu velit et erat vehicula convallis. Curabitur vestibulum ut purus sed ultrices. Suspendisse laoreet in risus vitae pulvinar. Sed ac metus diam. Sed posuere justo quis est mattis, sit amet gravida purus feugiat. Duis sit amet semper diam. Suspendisse nulla libero, auctor eu lectus id, congue suscipit nisi.','','filtered_html'),('node','forum',0,47,47,'und',0,'<p>Excepteur sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum. Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium, totam rem aperiam, eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo.</p>\r\n<p>Nulla facilisi. Cras convallis vel lectus sed convallis. Duis nec accumsan diam. Vestibulum blandit tempus nulla. Suspendisse consectetur cursus elit, et scelerisque ligula hendrerit id. Maecenas ultrices porta nunc, quis consectetur risus. Morbi non metus eget nibh vulputate tincidunt. Nullam dui quam, suscipit a ligula a, posuere sagittis magna. Pellentesque vitae dolor et nunc lobortis vestibulum. Suspendisse potenti. Pellentesque cursus purus vitae libero hendrerit congue. Aenean erat elit, aliquet at mi quis, sollicitudin sollicitudin libero.</p>\r\n<blockquote>\r\n<p>Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium, totam rem aperiam, eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo.</p>\r\n</blockquote>\r\n<h1>h1. Heading 1</h1>\r\n<p>Sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum. Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium, totam rem aperiam, eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo.</p>\r\n<ul>\r\n<li>Nemo enim ipsam voluptatem quia voluptas sit aspernatur aut odit aut fugit</li>\r\n<li>Sed ut perspiciatis unde omnis iste natus error </li>\r\n<li>Qui dolorem ipsum quia dolor sit amet, consectetur, adipisci velit</li>\r\n</ul>\r\n<h2>h2. Heading 2</h2>\r\n<p>Sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum. Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium, totam rem aperiam, eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo.</p>\r\n<h3>h3. Heading 3</h3>\r\n<p>Sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum. Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium, totam rem aperiam, eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo.</p>','','filtered_html'),('node','products',0,48,48,'und',0,'Nullam accumsan lorem in dui. Maecenas tempus, tellus eget condimentum rhoncus, sem quam semper libero, sit amet adipiscing sem neque sed ipsum. Duis arcu tortor, suscipit eget, imperdiet nec, imperdiet iaculis, ipsum. Pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas. Curabitur nisi.\r\n\r\nFusce commodo aliquam arcu. Suspendisse potenti. Cras risus ipsum, faucibus ut, ullamcorper id, varius ac, leo. Sed libero. Vestibulum rutrum, mi nec elementum vehicula, eros quam gravida nisl, id fringilla neque ante vel mi.\r\n\r\nDonec interdum, metus et hendrerit aliquet, dolor diam sagittis ligula, eget egestas libero turpis vel mi. Praesent nonummy mi in odio. Cras ultricies mi eu turpis hendrerit fringilla. Aliquam eu nunc. Suspendisse potenti.\r\n\r\nNam ipsum risus, rutrum vitae, vestibulum eu, molestie vel, lacus. Praesent adipiscing. Phasellus a est. Nam pretium turpis et arcu. Nam eget dui.\r\n\r\nEtiam vitae tortor. Proin pretium, leo ac pellentesque mollis, felis nunc ultrices eros, sed gravida augue augue mollis justo. In consectetuer turpis ut velit. Vivamus aliquet elit ac nisl. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Sed aliquam, nisi quis porttitor congue, elit erat euismod orci, ac placerat dolor lectus quis orci.','','filtered_html'),('node','products',0,49,49,'und',0,'Vestibulum ullamcorper mauris at ligula. Nullam cursus lacinia erat. Fusce ac felis sit amet ligula pharetra condimentum. Sed magna purus, fermentum eu, tincidunt eu, varius ut, felis. Cras dapibus.\r\n\r\nAenean commodo ligula eget dolor. Nam pretium turpis et arcu. In auctor lobortis lacus. Fusce fermentum. Phasellus ullamcorper ipsum rutrum nunc.\r\n\r\nNam at tortor in tellus interdum sagittis. Pellentesque dapibus hendrerit tortor. In turpis. Nunc nonummy metus. Aliquam lorem ante, dapibus in, viverra quis, feugiat a, tellus.\r\n\r\nProin magna. Nunc nec neque. Praesent ac sem eget est egestas volutpat. Praesent vestibulum dapibus nibh. Fusce neque.\r\n\r\nVestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Sed aliquam, nisi quis porttitor congue, elit erat euismod orci, ac placerat dolor lectus quis orci. Nulla porta dolor. Suspendisse pulvinar, augue ac venenatis condimentum, sem libero volutpat nibh, nec pellentesque velit pede quis nunc. Praesent venenatis metus at tortor pulvinar varius. Ut id nisl quis enim dignissim sagittis.','','filtered_html'),('node','products',0,50,50,'und',0,'Praesent adipiscing. Vivamus elementum semper nisi. Aenean imperdiet. Aliquam lobortis. Pellentesque libero tortor, tincidunt et, tincidunt eget, semper nec, quam.\r\n\r\nDonec posuere vulputate arcu. Donec venenatis vulputate lorem. Proin faucibus arcu quis ante. Phasellus ullamcorper ipsum rutrum nunc. Quisque libero metus, condimentum nec, tempor a, commodo mollis, magna.\r\n\r\nVestibulum fringilla pede sit amet augue. Fusce vulputate eleifend sapien. Ut non enim eleifend felis pretium feugiat. Nullam dictum felis eu pede mollis pretium. Fusce a quam.\r\n\r\nVestibulum turpis sem, aliquet eget, lobortis pellentesque, rutrum eu, nisl. Curabitur vestibulum aliquam leo. Pellentesque dapibus hendrerit tortor. Vestibulum facilisis, purus nec pulvinar iaculis, ligula mi congue nunc, vitae euismod ligula urna in dolor. Curabitur at lacus ac velit ornare lobortis.\r\n\r\nCras risus ipsum, faucibus ut, ullamcorper id, varius ac, leo. Suspendisse nisl elit, rhoncus eget, elementum ac, condimentum eget, diam. Nullam tincidunt adipiscing enim. Integer tincidunt. Aliquam erat volutpat.','','filtered_html'),('node','products',0,51,51,'und',0,'Aenean posuere, tortor sed cursus feugiat, nunc augue blandit nunc, eu sollicitudin urna dolor sagittis lacus. Sed hendrerit. Fusce risus nisl, viverra et, tempor et, pretium in, sapien. Etiam iaculis nunc ac metus. Praesent vestibulum dapibus nibh.\r\n\r\nUt id nisl quis enim dignissim sagittis. Vivamus quis mi. Donec posuere vulputate arcu. Mauris turpis nunc, blandit et, volutpat molestie, porta ut, ligula. Donec interdum, metus et hendrerit aliquet, dolor diam sagittis ligula, eget egestas libero turpis vel mi.\r\n\r\nPhasellus nec sem in justo pellentesque facilisis. Aenean viverra rhoncus pede. Praesent turpis. Nunc nonummy metus. Nullam accumsan lorem in dui.\r\n\r\nEtiam ut purus mattis mauris sodales aliquam. Nam eget dui. Nullam cursus lacinia erat. Vestibulum eu odio. Curabitur nisi.\r\n\r\nQuisque id odio. Suspendisse nisl elit, rhoncus eget, elementum ac, condimentum eget, diam. Mauris turpis nunc, blandit et, volutpat molestie, porta ut, ligula. Sed magna purus, fermentum eu, tincidunt eu, varius ut, felis. Nullam tincidunt adipiscing enim.','','filtered_html'),('node','products',0,52,52,'und',0,'Phasellus gravida semper nisi. Aenean viverra rhoncus pede. Curabitur at lacus ac velit ornare lobortis. Nam eget dui. Etiam sit amet orci eget eros faucibus tincidunt.\r\n\r\nAliquam eu nunc. Fusce ac felis sit amet ligula pharetra condimentum. In ac felis quis tortor malesuada pretium. Praesent vestibulum dapibus nibh. Vestibulum rutrum, mi nec elementum vehicula, eros quam gravida nisl, id fringilla neque ante vel mi.\r\n\r\nPhasellus magna. Donec interdum, metus et hendrerit aliquet, dolor diam sagittis ligula, eget egestas libero turpis vel mi. Nam quam nunc, blandit vel, luctus pulvinar, hendrerit id, lorem. Cras ultricies mi eu turpis hendrerit fringilla. Nunc sed turpis.\r\n\r\nAenean vulputate eleifend tellus. Curabitur a felis in nunc fringilla tristique. Ut non enim eleifend felis pretium feugiat. Nunc interdum lacus sit amet orci. Ut id nisl quis enim dignissim sagittis.\r\n\r\nSed in libero ut nibh placerat accumsan. Etiam iaculis nunc ac metus. Curabitur blandit mollis lacus. Morbi mollis tellus ac sapien. Nam at tortor in tellus interdum sagittis.','','filtered_html'),('node','forum',0,53,53,'und',0,'Donec venenatis vulputate lorem. Maecenas vestibulum mollis diam. Fusce commodo aliquam arcu. Donec elit libero, sodales nec, volutpat a, suscipit non, turpis. Phasellus nec sem in justo pellentesque facilisis. Etiam ut purus mattis mauris sodales aliquam. Pellentesque posuere. Maecenas tempus, tellus eget condimentum rhoncus, sem quam semper libero, sit amet adipiscing sem neque sed ipsum. Pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas. Vivamus elementum semper nisi.\r\n\r\n1. Get All The Facts\r\nProin faucibus arcu quis ante. Nam commodo suscipit quam. Donec id justo. Aenean posuere, tortor sed cursus feugiat, nunc augue blandit nunc, eu sollicitudin urna dolor sagittis lacus. Fusce pharetra convallis urna. Ut a nisl id ante tempus hendrerit.. Phasellus volutpat, metus eget egestas mollis, lacus lacus blandit dui, id egestas quam mauris ut lacus. Proin pretium, leo ac pellentesque mollis, felis nunc ultrices eros, sed gravida augue augue mollis justo. Phasellus a est.\r\n\r\n2. Track The Details\r\n\r\nCurabitur at lacus ac velit ornare lobortis. Ut non enim eleifend felis pretium feugiat. Morbi vestibulum volutpat enim. Nulla facilisi. Morbi nec metus. Cras dapibus. Fusce risus nisl, viverra et, tempor et, pretium in, sapien. In ac felis quis tortor malesuada pretium. Donec elit libero, sodales nec, volutpat a, suscipit non, turpis. Suspendisse potenti. Duis lobortis massa imperdiet quam. Suspendisse nisl elit, rhoncus eget, elementum ac, condimentum eget, diam. Praesent nec nisl a purus blandit viverra. Nam commodo suscipit quam. Phasellus dolor.\r\n\r\n(cont)','','filtered_html'),('node','forum',0,54,54,'und',0,'<p>Excepteur sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum. Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium, totam rem aperiam, eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo.</p>\r\n<p>Nulla facilisi. Cras convallis vel lectus sed convallis. Duis nec accumsan diam. Vestibulum blandit tempus nulla. Suspendisse consectetur cursus elit, et scelerisque ligula hendrerit id. Maecenas ultrices porta nunc, quis consectetur risus. Morbi non metus eget nibh vulputate tincidunt. Nullam dui quam, suscipit a ligula a, posuere sagittis magna. Pellentesque vitae dolor et nunc lobortis vestibulum. Suspendisse potenti. Pellentesque cursus purus vitae libero hendrerit congue. Aenean erat elit, aliquet at mi quis, sollicitudin sollicitudin libero.</p>\r\n<blockquote>\r\n<p>Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium, totam rem aperiam, eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo.</p>\r\n</blockquote>\r\n<h1>h1. Heading 1</h1>\r\n<p>Sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum. Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium, totam rem aperiam, eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo.</p>\r\n<ul>\r\n<li>Nemo enim ipsam voluptatem quia voluptas sit aspernatur aut odit aut fugit</li>\r\n<li>Sed ut perspiciatis unde omnis iste natus error </li>\r\n<li>Qui dolorem ipsum quia dolor sit amet, consectetur, adipisci velit</li>\r\n</ul>\r\n<h2>h2. Heading 2</h2>\r\n<p>Sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum. Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium, totam rem aperiam, eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo.</p>\r\n<h3>h3. Heading 3</h3>\r\n<p>Sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum. Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium, totam rem aperiam, eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo.</p>','','full_html'),('node','forum',0,55,55,'und',0,'<p>Excepteur sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum. Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium, totam rem aperiam, eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo.</p>\r\n<p>Nulla facilisi. Cras convallis vel lectus sed convallis. Duis nec accumsan diam. Vestibulum blandit tempus nulla. Suspendisse consectetur cursus elit, et scelerisque ligula hendrerit id. Maecenas ultrices porta nunc, quis consectetur risus. Morbi non metus eget nibh vulputate tincidunt. Nullam dui quam, suscipit a ligula a, posuere sagittis magna. Pellentesque vitae dolor et nunc lobortis vestibulum. Suspendisse potenti. Pellentesque cursus purus vitae libero hendrerit congue. Aenean erat elit, aliquet at mi quis, sollicitudin sollicitudin libero.</p>\r\n<blockquote>\r\n<p>Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium, totam rem aperiam, eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo.</p>\r\n</blockquote>\r\n<h1>h1. Heading 1</h1>\r\n<p>Sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum. Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium, totam rem aperiam, eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo.</p>\r\n<ul>\r\n<li>Nemo enim ipsam voluptatem quia voluptas sit aspernatur aut odit aut fugit</li>\r\n<li>Sed ut perspiciatis unde omnis iste natus error </li>\r\n<li>Qui dolorem ipsum quia dolor sit amet, consectetur, adipisci velit</li>\r\n</ul>\r\n<h2>h2. Heading 2</h2>\r\n<p>Sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum. Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium, totam rem aperiam, eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo.</p>\r\n<h3>h3. Heading 3</h3>\r\n<p>Sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum. Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium, totam rem aperiam, eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo.</p>','','full_html'),('node','forum',0,56,56,'und',0,'<p>Excepteur sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum. Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium, totam rem aperiam, eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo.</p>\r\n\r\n<p>Nulla facilisi. Cras convallis vel lectus sed convallis. Duis nec accumsan diam. Vestibulum blandit tempus nulla. Suspendisse consectetur cursus elit, et scelerisque ligula hendrerit id. Maecenas ultrices porta nunc, quis consectetur risus. Morbi non metus eget nibh vulputate tincidunt. Nullam dui quam, suscipit a ligula a, posuere sagittis magna. Pellentesque vitae dolor et nunc lobortis vestibulum. Suspendisse potenti. Pellentesque cursus purus vitae libero hendrerit congue. Aenean erat elit, aliquet at mi quis, sollicitudin sollicitudin libero.</p>\r\n\r\n<blockquote>\r\n<p>Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium, totam rem aperiam, eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo.</p>\r\n</blockquote>\r\n\r\n<h1>h1. Heading 1</h1>\r\n\r\n<p>Sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum. Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium, totam rem aperiam, eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo.</p>\r\n\r\n<ul>\r\n	<li>Nemo enim ipsam voluptatem quia voluptas sit aspernatur aut odit aut fugit</li>\r\n	<li>Sed ut perspiciatis unde omnis iste natus error</li>\r\n	<li>Qui dolorem ipsum quia dolor sit amet, consectetur, adipisci velit</li>\r\n</ul>\r\n\r\n<h2>h2. Heading 2</h2>\r\n\r\n<p>Sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum. Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium, totam rem aperiam, eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo.</p>\r\n\r\n<h3>h3. Heading 3</h3>\r\n\r\n<p>Sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum. Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium, totam rem aperiam, eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo.</p>\r\n','','filtered_html'),('node','page',0,57,57,'und',0,'Lorem ipsum dolor sit amet, consectetur adipiscing elit. Suspendisse quis ante pharetra, porta odio non, mattis urna. Aliquam mattis bibendum lacinia. Mauris adipiscing tincidunt turpis at sodales. Aenean in feugiat urna. Praesent at dictum diam, vitae cursus velit. Donec mauris nisi, aliquam ac lectus id, luctus imperdiet lacus. Cras tellus purus, eleifend eu gravida vitae, aliquam a nunc. Suspendisse dictum dui in dapibus consequat. Proin non hendrerit orci. Sed eget velit turpis. Pellentesque nec tempor elit. Proin sit amet ullamcorper est, nec vestibulum velit. Etiam rhoncus, lectus a lacinia lobortis, nisl risus accumsan ante, sed interdum ante lectus sit amet nunc. Vivamus molestie dolor at dolor sagittis, eu consequat orci tristique.\r\n\r\nNunc gravida adipiscing magna sit amet pulvinar. Aenean nec scelerisque nisl, nec ultrices justo. Phasellus a mollis leo, at hendrerit tellus. In mollis enim et euismod mattis. Nunc aliquet sit amet sapien quis ornare. Nunc rutrum, eros in dignissim adipiscing, nibh nibh faucibus elit, ac faucibus sem enim sit amet eros. Nulla at lectus vel enim posuere sodales quis pellentesque eros. Quisque rhoncus nisi sit amet neque fermentum tempus. Morbi fermentum massa dolor, at adipiscing lectus porta sed. Curabitur fringilla metus a scelerisque blandit. Donec sit amet nisi id lectus pharetra tincidunt a a augue. Quisque posuere ante non odio consectetur rhoncus. Nulla at arcu ultricies nunc placerat posuere eu vitae lacus. Aenean hendrerit auctor justo sed gravida.\r\n\r\nMorbi nunc est, vestibulum ac est nec, fringilla bibendum arcu. Etiam id tortor vel ligula dictum adipiscing mollis nec dolor. Vivamus sed eros a lacus accumsan bibendum vitae eget ante. Sed aliquam interdum ipsum in bibendum. Nunc faucibus, tellus et vestibulum imperdiet, ligula velit tincidunt mi, vel porttitor nibh felis non risus. Phasellus id turpis vitae libero consequat pretium nec sodales erat. Donec luctus arcu eget nulla luctus tempus pretium non odio. Sed tempus nec elit quis facilisis. In pretium posuere magna sit amet vehicula. Etiam dapibus sem nec metus laoreet, quis imperdiet libero condimentum. Aliquam fermentum velit eget leo convallis ullamcorper. Fusce ac consectetur elit, id convallis augue.\r\n\r\nPraesent gravida aliquet ante, vitae suscipit dui fringilla id. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis gravida id erat nec vulputate. Duis rutrum, est id cursus suscipit, dui arcu ornare eros, vel consequat urna sapien sed libero. Quisque quis diam ac nisl ultrices blandit. Quisque cursus feugiat sollicitudin. Nam vitae risus et metus ornare consequat quis nec diam. Vestibulum laoreet sem quis dolor congue cursus. In aliquam risus semper lacus cursus dictum. Nunc condimentum lectus sed tellus bibendum, sed eleifend mi consectetur. Fusce cursus pretium ante, eget euismod sem imperdiet nec. Mauris vitae ipsum libero.\r\n\r\nDonec eros neque, imperdiet quis magna a, facilisis venenatis velit. Sed eu velit et erat vehicula convallis. Curabitur vestibulum ut purus sed ultrices. Suspendisse laoreet in risus vitae pulvinar. Sed ac metus diam. Sed posuere justo quis est mattis, sit amet gravida purus feugiat. Duis sit amet semper diam. Suspendisse nulla libero, auctor eu lectus id, congue suscipit nisi.\r\n','','filtered_html'),('node','faq',0,58,58,'und',0,'Pellentesque dapibus hendrerit tortor. Nullam quis ante. Donec sodales sagittis magna. Etiam iaculis nunc ac metus. Vestibulum dapibus nunc ac augue.\r\n\r\nDonec vitae sapien ut libero venenatis faucibus. Maecenas tempus, tellus eget condimentum rhoncus, sem quam semper libero, sit amet adipiscing sem neque sed ipsum. Quisque rutrum. Phasellus viverra nulla ut metus varius laoreet. Pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas.\r\n\r\nNam commodo suscipit quam. Pellentesque commodo eros a enim. Nam eget dui. Curabitur ligula sapien, tincidunt non, euismod vitae, posuere imperdiet, leo. Phasellus gravida semper nisi.\r\n\r\nMaecenas tempus, tellus eget condimentum rhoncus, sem quam semper libero, sit amet adipiscing sem neque sed ipsum. Phasellus blandit leo ut odio. Quisque ut nisi. Etiam sit amet orci eget eros faucibus tincidunt. Integer ante arcu, accumsan a, consectetuer eget, posuere ut, mauris.\r\n\r\nAenean tellus metus, bibendum sed, posuere ac, mattis non, nunc. Nullam quis ante. Phasellus leo dolor, tempus non, auctor et, hendrerit quis, nisi. Pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas. Phasellus dolor.','','filtered_html'),('node','faq',0,59,59,'und',0,'Fusce fermentum. Nulla neque dolor, sagittis eget, iaculis quis, molestie non, velit. Phasellus blandit leo ut odio. Nullam cursus lacinia erat. Vestibulum volutpat pretium libero.\r\n\r\nNam adipiscing. Curabitur a felis in nunc fringilla tristique. Etiam imperdiet imperdiet orci. Pellentesque ut neque. Vestibulum eu odio.\r\n\r\nDonec vitae orci sed dolor rutrum auctor. Proin magna. Morbi vestibulum volutpat enim. Nullam cursus lacinia erat. Donec interdum, metus et hendrerit aliquet, dolor diam sagittis ligula, eget egestas libero turpis vel mi.\r\n\r\nNullam cursus lacinia erat. In consectetuer turpis ut velit. Sed fringilla mauris sit amet nibh. Curabitur nisi. In hac habitasse platea dictumst.\r\n\r\nSed a libero. Aenean viverra rhoncus pede. Fusce fermentum. Praesent egestas neque eu enim. Etiam ut purus mattis mauris sodales aliquam.','','filtered_html'),('node','faq',0,60,60,'und',0,'Phasellus accumsan cursus velit. Duis vel nibh at velit scelerisque suscipit. Lorem ipsum dolor sit amet, consectetuer adipiscing elit. Pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas. Morbi ac felis.\r\n\r\nFusce commodo aliquam arcu. Etiam feugiat lorem non metus. Pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas. Sed libero. Praesent ac sem eget est egestas volutpat.\r\n\r\nNunc nonummy metus. Suspendisse eu ligula. Vestibulum purus quam, scelerisque ut, mollis sed, nonummy id, metus. Proin magna. Sed magna purus, fermentum eu, tincidunt eu, varius ut, felis.\r\n\r\nEtiam rhoncus. Vivamus aliquet elit ac nisl. Suspendisse potenti. Aliquam lorem ante, dapibus in, viverra quis, feugiat a, tellus. Maecenas nec odio et ante tincidunt tempus.\r\n\r\nIn auctor lobortis lacus. Morbi nec metus. Etiam imperdiet imperdiet orci. Aenean massa. Nunc egestas, augue at pellentesque laoreet, felis eros vehicula leo, at malesuada velit leo quis pede.','','filtered_html'),('node','faq',0,61,61,'und',0,'Aenean posuere, tortor sed cursus feugiat, nunc augue blandit nunc, eu sollicitudin urna dolor sagittis lacus. Praesent egestas tristique nibh. Vestibulum rutrum, mi nec elementum vehicula, eros quam gravida nisl, id fringilla neque ante vel mi. Phasellus consectetuer vestibulum elit. Aenean tellus metus, bibendum sed, posuere ac, mattis non, nunc.\r\n\r\nIn ac felis quis tortor malesuada pretium. Etiam iaculis nunc ac metus. Donec vitae sapien ut libero venenatis faucibus. Pellentesque egestas, neque sit amet convallis pulvinar, justo nulla eleifend augue, ac auctor orci leo non est. Aliquam lorem ante, dapibus in, viverra quis, feugiat a, tellus.\r\n\r\nNullam quis ante. Pellentesque auctor neque nec urna. Vivamus aliquet elit ac nisl. Maecenas ullamcorper, dui et placerat feugiat, eros pede varius nisi, condimentum viverra felis nunc et lorem. Duis vel nibh at velit scelerisque suscipit.\r\n\r\nIn consectetuer turpis ut velit. Nam at tortor in tellus interdum sagittis. Pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas. Pellentesque dapibus hendrerit tortor. Aenean commodo ligula eget dolor.\r\n\r\nPraesent nonummy mi in odio. Cras varius. Suspendisse feugiat. Aenean leo ligula, porttitor eu, consequat vitae, eleifend ac, enim. Mauris sollicitudin fermentum libero.','','filtered_html'),('node','faq',0,62,62,'und',0,'Vivamus elementum semper nisi. Fusce pharetra convallis urna. Vivamus quis mi. Curabitur blandit mollis lacus. Vestibulum facilisis, purus nec pulvinar iaculis, ligula mi congue nunc, vitae euismod ligula urna in dolor.\r\n\r\nUt id nisl quis enim dignissim sagittis. Pellentesque egestas, neque sit amet convallis pulvinar, justo nulla eleifend augue, ac auctor orci leo non est. Cras non dolor. Quisque libero metus, condimentum nec, tempor a, commodo mollis, magna. Vivamus quis mi.\r\n\r\nVestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Fusce id purus. Vestibulum eu odio. Nam commodo suscipit quam. Morbi mollis tellus ac sapien. Curabitur nisi.\r\n\r\nSed aliquam ultrices mauris. Etiam rhoncus. Donec interdum, metus et hendrerit aliquet, dolor diam sagittis ligula, eget egestas libero turpis vel mi. Phasellus accumsan cursus velit. Donec orci lectus, aliquam ut, faucibus non, euismod id, nulla.\r\n\r\nNullam dictum felis eu pede mollis pretium. Curabitur at lacus ac velit ornare lobortis. Sed aliquam ultrices mauris. Nullam nulla eros, ultricies sit amet, nonummy id, imperdiet feugiat, pede. Vestibulum volutpat pretium libero.','','filtered_html'),('node','faq',0,63,63,'und',0,'Sed libero. Aenean ut eros et nisl sagittis vestibulum. Donec vitae sapien ut libero venenatis faucibus. Etiam vitae tortor. Nam eget dui.\r\n\r\nPraesent nec nisl a purus blandit viverra. In turpis. Suspendisse enim turpis, dictum sed, iaculis a, condimentum nec, nisi. Vestibulum eu odio. Phasellus gravida semper nisi.\r\n\r\nVestibulum turpis sem, aliquet eget, lobortis pellentesque, rutrum eu, nisl. Praesent venenatis metus at tortor pulvinar varius. Etiam iaculis nunc ac metus. Praesent nonummy mi in odio. Pellentesque posuere.\r\n\r\nProin viverra, ligula sit amet ultrices semper, ligula arcu tristique sapien, a accumsan nisi mauris ac eros. Fusce ac felis sit amet ligula pharetra condimentum. Nam eget dui. Phasellus magna. Sed augue ipsum, egestas nec, vestibulum et, malesuada adipiscing, dui.\r\n\r\nNullam vel sem. Cras risus ipsum, faucibus ut, ullamcorper id, varius ac, leo. Vivamus quis mi. Vestibulum eu odio. Suspendisse nisl elit, rhoncus eget, elementum ac, condimentum eget, diam.','','filtered_html'),('node','faq',0,64,64,'und',0,'Mauris sollicitudin fermentum libero. Praesent venenatis metus at tortor pulvinar varius. Curabitur ligula sapien, tincidunt non, euismod vitae, posuere imperdiet, leo. Nam at tortor in tellus interdum sagittis. Maecenas malesuada.\r\n\r\nFusce ac felis sit amet ligula pharetra condimentum. Praesent nec nisl a purus blandit viverra. In dui magna, posuere eget, vestibulum et, tempor auctor, justo. Nam adipiscing. Nam adipiscing.\r\n\r\nVivamus euismod mauris. Nulla porta dolor. Fusce a quam. Donec sodales sagittis magna. Cras id dui.\r\n\r\nCras varius. Sed in libero ut nibh placerat accumsan. Donec mollis hendrerit risus. Ut varius tincidunt libero. Quisque ut nisi.\r\n\r\nPhasellus gravida semper nisi. Sed magna purus, fermentum eu, tincidunt eu, varius ut, felis. Curabitur vestibulum aliquam leo. Donec mollis hendrerit risus. In enim justo, rhoncus ut, imperdiet a, venenatis vitae, justo.','','filtered_html'),('node','faq',0,65,65,'und',0,'Fusce risus nisl, viverra et, tempor et, pretium in, sapien. Phasellus ullamcorper ipsum rutrum nunc. Cras risus ipsum, faucibus ut, ullamcorper id, varius ac, leo. Fusce risus nisl, viverra et, tempor et, pretium in, sapien. Donec venenatis vulputate lorem.\r\n\r\nCum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus. Sed aliquam ultrices mauris. Proin magna. Phasellus leo dolor, tempus non, auctor et, hendrerit quis, nisi. Sed lectus.\r\n\r\nSed aliquam ultrices mauris. Suspendisse non nisl sit amet velit hendrerit rutrum. Fusce fermentum odio nec arcu. Phasellus tempus. Etiam rhoncus.\r\n\r\nMaecenas egestas arcu quis ligula mattis placerat. Sed libero. Aenean posuere, tortor sed cursus feugiat, nunc augue blandit nunc, eu sollicitudin urna dolor sagittis lacus. Nullam vel sem. In dui magna, posuere eget, vestibulum et, tempor auctor, justo.\r\n\r\nNullam accumsan lorem in dui. Aliquam lobortis. Aenean viverra rhoncus pede. Sed magna purus, fermentum eu, tincidunt eu, varius ut, felis. In consectetuer turpis ut velit.','','filtered_html'),('node','faq',0,66,66,'und',0,'Curabitur non elit faucibus, malesuada elit at, pellentesque tellus. Curabitur pretium dui id quam posuere molestie. Nulla eget malesuada sem, non elementum enim. In id porttitor libero. Proin sodales urna in vehicula fermentum. Pellentesque scelerisque condimentum augue, sit amet suscipit nisi auctor a. Cras rutrum ex dui, ac interdum ex faucibus eu. Cras ac congue nisi, pretium malesuada risus? Nulla nec dui turpis. Curabitur lectus nisi, dapibus et arcu id, feugiat mollis sapien. Suspendisse non massa nec tellus lobortis lacinia at id mauris. Sed fermentum ac neque eget auctor. In hac habitasse platea dictumst. Etiam sit amet lobortis neque, et tincidunt nisi.\r\n\r\nMaecenas nec porta odio. Aenean a pellentesque nulla; nec scelerisque ipsum. Morbi tempus eros nisi, ut semper metus tincidunt vel. Nullam porta nibh eros, id rhoncus velit rutrum et. Sed diam dui; vulputate ac lobortis quis, vestibulum et magna. Donec tristique elementum est, quis rhoncus est pretium eu. Cras nec eleifend dolor, nec tristique odio. Fusce sem metus, ornare nec varius quis, eleifend non libero.\r\n\r\nCum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus. Proin sit amet semper posuere.\r\n','','filtered_html'),('node','faq',0,67,67,'und',0,'In vel felis fringilla dolor sagittis pulvinar? Duis ac sapien libero. Sed elementum nunc sit amet ante aliquam, vitae malesuada odio commodo. Sed rutrum est non ullamcorper finibus. Pellentesque id aliquam dui. Morbi nisl dui, pulvinar non risus id, tristique accumsan nisl. Quisque euismod vitae lectus dictum lacinia. Duis sagittis mauris a rhoncus fringilla? Donec pellentesque accumsan mattis?\r\n\r\nPhasellus enim eros, dapibus non pulvinar vel, condimentum quis felis? Donec sem dui, hendrerit vel dapibus id, tristique ac sem? Cras semper nec velit at scelerisque. Aenean vel porttitor libero. Proin viverra pretium nisi nec consectetur. Sed non turpis ut odio consectetur pharetra id quis lacus. Nunc at auctor lectus, ut rhoncus enim. Integer venenatis molestie nibh, id viverra mauris malesuada a. Nam quis interdum turpis, eget convallis nisl. Maecenas cursus mattis quam vel pharetra. Nunc pretium, massa ut interdum pharetra; magna est facilisis ipsum, nec imperdiet metus libero sed nibh.\r\n\r\nAliquam sed urna suscipit, feugiat dolor nec, convallis arcu. Vivamus sed diam id nisl lobortis feugiat sit amet efficitur eros. Integer eu neque metus. Donec egestas, sem ut gravida vulputate, leo metus.\r\n','','filtered_html'),('node','forum',0,68,68,'und',0,'<p>Drupal 6 extended support announcement</p>\r\n\r\n<p>On February 13, 2008, Drupal 6 was released. The policy of the community is to support only the current and previous stable versions. (When Drupal 6 was released, Drupal 4.7.x was marked unsupported. When Drupal 7 came out, Drupal 5.x was marked unsupported.) This policy was created to prevent core and module maintainers from having to maintain more than 2 active major versions of Drupal.</p>\r\n\r\n<p>With the coming Drupal 8 release, this policy has been questioned. We want to ensure that sites that wish to move from Drupal 6 to Drupal 8 have a supported window within which to do so. The Drupal core team, key module maintainers, and representatives of the Drupal security team met at Drupalcon Austin to discuss this as an in-person follow up to the previous discussion at <a href=\"https://drupal.org/node/2136029\">https://drupal.org/node/2136029</a>.</p>\r\n\r\n<p>Drupal 6 core and modules will transition to unsupported status three months after Drupal 8 is released. \"Unsupported status\" means the community will not be providing support or patches in the same way we do now. Continuing to support Drupal 6 would be difficult for many reasons, including a lack of automated test coverage, the requirement for rigorous manual release testing, the slow-down it introduces in the release of security fixes for the vast majority of Drupal users (on version 7+), and the general shift of volunteers in the community moving their attention onto Drupal 8 development.</p>\r\n\r\n<p>This gives Drupal 6 users a few options:</p>\r\n\r\n<p>1) Upgrade to Drupal 7 any time between now and 3 months after Drupal 8.0.0 is released. Drupal 7 releases undergo almost 40,000 automated tests, and Drupal 7 will be fully supported at least until Drupal 9 comes out. Given the past history, the release of Drupal 9 is likely to be around 2018.</p>\r\n\r\n<p>2) Upgrade to Drupal 8 after it is released, but before Drupal 6 is not supported anymore. Fortunately, Migrate support for Drupal 6 to Drupal 8 is already in core, and there is Migrate UI, a contributed module. While not all contributed modules will be ready at the time Drupal 8 is released, Drupal 8\'s migration path handles most of the critical site data via its CCK to Entities/Fields in Core migrations.</p>\r\n\r\n<p>3) Find an organization that will provide extended support for Drupal 6. The Drupal Security Team will provide a method for companies and/or individuals to work together in the private security issue queue to continue developing updates, and will provide a reasonable amount of time for companies to provide patches to Drupal 6 security issues that also affect Drupal 7 or Drupal 8. The security team will coordinate access to issues for companies wishing to provide extended support for Drupal 6. However, the team will not explicitly review or test the patches (some team members may do this on their own). All code created by these vendors, would be released to the community.</p>\r\n\r\n<p>Organizations and individuals interested in providing this level of support for their customers<br />\r\nAND who have the technical knowledge to maintain a Drupal core release should go to the security team Drupal 6 long term support page.</p>\r\n\r\n<p>Both the Security Team and Drupal core leadership feel that a 3-month window after Drupal 8\'s release before eclipsing community support for Drupal 6 is a workable compromise between leaving Drupal 6 sites on an unsupported version the second Drupal 8 comes out, and acknowledging that our community\'s volunteer resources are limited and have shifted focus. We hope that organizations that rely on Drupal 6 will step up to help maintain it after community support winds down, and/or help their clients update to D8.</p>\r\n','','full_html'),('node','forum',0,69,69,'und',0,'<div>I\'m not a Drupal developer but a pro Drupal site builder. I can read PHP and able to tweak and even write some code. I was thinking about learning the development but came across this idea that in D8 we have symphony and some other big changes. Now the question is that shall I start learning D8 dev or I should start with D7 dev? - See more at: http://demo.weebpal.com/forum-plus/en/node/1#sthash.p70HJJcO.dpuf</div>\r\n','','filtered_html');
/*!40000 ALTER TABLE `field_revision_body` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `field_revision_comment_body`
--

DROP TABLE IF EXISTS `field_revision_comment_body`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_comment_body` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `comment_body_value` longtext,
  `comment_body_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `comment_body_format` (`comment_body_format`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 1 (comment_body)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_comment_body`
--

LOCK TABLES `field_revision_comment_body` WRITE;
/*!40000 ALTER TABLE `field_revision_comment_body` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `field_revision_comment_body` VALUES ('comment','comment_node_forum',0,1,1,'und',0,'Even if D8 goes gold tomorrow, D7 will be the choice for substantial production sites for a while until a crit mass of modules port and the inevitable bugs shake out. And the need to maintain existing D7 sites will be a desired skill for years to come.','filtered_html'),('comment','comment_node_blog',0,2,2,'und',0,'Praesent metus tellus, elementum eu, semper a, adipiscing nec, purus. Phasellus nec sem in justo pellentesque facilisis. In enim justo, rhoncus ut, imperdiet a, venenatis vitae, justo. Quisque malesuada placerat nisl. Nunc sed turpis.','filtered_html'),('comment','comment_node_blog',0,3,3,'und',0,'Curabitur a felis in nunc fringilla tristique. Nullam tincidunt adipiscing enim. Phasellus tempus. Proin viverra, ligula sit amet ultrices semper, ligula arcu tristique sapien, a accumsan nisi mauris ac eros. Nulla sit amet est.','filtered_html'),('comment','comment_node_blog',0,4,4,'und',0,'Curabitur a felis in nunc fringilla tristique. Nullam tincidunt adipiscing enim. Phasellus tempus. Proin viverra, ligula sit amet ultrices semper, ligula arcu tristique sapien, a accumsan nisi mauris ac eros. Nulla sit amet est.','filtered_html'),('comment','comment_node_blog',0,5,5,'und',0,'Curabitur a felis in nunc fringilla tristique. Nullam tincidunt adipiscing enim. Phasellus tempus. Proin viverra, ligula sit amet ultrices semper, ligula arcu tristique sapien, a accumsan nisi mauris ac eros. Nulla sit amet est.','filtered_html'),('comment','comment_node_blog',0,6,6,'und',0,'Curabitur a felis in nunc fringilla tristique. Nullam tincidunt adipiscing enim. Phasellus tempus. Proin viverra, ligula sit amet ultrices semper, ligula arcu tristique sapien, a accumsan nisi mauris ac eros. Nulla sit amet est.','filtered_html'),('comment','comment_node_article',0,7,7,'und',0,'Nam quam nunc, blandit vel, luctus pulvinar, hendrerit id, lorem. Vivamus laoreet. Phasellus magna. In ac felis quis tortor malesuada pretium. Ut tincidunt tincidunt erat.','filtered_html'),('comment','comment_node_forum',0,8,8,'und',0,'Donec sodales sagittis magna. Praesent ut ligula non mi varius sagittis. Donec venenatis vulputate lorem. Suspendisse eu ligula. Pellentesque posuere. Etiam iaculis nunc ac metus. Fusce a quam. Suspendisse eu ligula. Praesent porttitor, nulla vitae posuere iaculis, arcu nisl dignissim dolor, a pretium mi sem ut ipsum. Phasellus nec sem in justo pellentesque facilisis.\r\n\r\nAliquam lobortis. Nullam dictum felis eu pede mollis pretium. Phasellus consectetuer vestibulum elit. Sed augue ipsum, egestas nec, vestibulum et, malesuada adipiscing, dui. Duis arcu tortor, suscipit eget, imperdiet nec, imperdiet iaculis, ipsum. Curabitur a felis in nunc fringilla tristique. Fusce vulputate eleifend sapien. Quisque ut nisi. Vivamus consectetuer hendrerit lacus. In ut quam vitae odio lacinia tincidunt.\r\n\r\nMorbi mollis tellus ac sapien. Suspendisse nisl elit, rhoncus eget, elementum ac, condimentum eget, diam. In consectetuer turpis ut velit. Mauris turpis nunc, blandit et, volutpat molestie, porta ut, ligula. Ut id nisl quis enim dignissim sagittis.','filtered_html'),('comment','comment_node_forum',0,9,9,'und',0,'Phasellus leo dolor, tempus non, auctor et, hendrerit quis, nisi. Nullam tincidunt adipiscing enim. Phasellus gravida semper nisi. Nulla facilisi. Ut leo.\r\n\r\nFusce a quam. Vestibulum turpis sem, aliquet eget, lobortis pellentesque, rutrum eu, nisl. Fusce risus nisl, viverra et, tempor et, pretium in, sapien. Donec elit libero, sodales nec, volutpat a, suscipit non, turpis. In turpis.\r\n\r\nIn hac habitasse platea dictumst. Vivamus in erat ut urna cursus vestibulum. Nullam accumsan lorem in dui. Donec id justo. Aliquam lorem ante, dapibus in, viverra quis, feugiat a, tellus.\r\n\r\nAenean commodo ligula eget dolor. Quisque malesuada placerat nisl. Vivamus euismod mauris. Vestibulum ullamcorper mauris at ligula. Donec vitae sapien ut libero venenatis faucibus.\r\n\r\nMaecenas malesuada. Nam eget dui. Nam ipsum risus, rutrum vitae, vestibulum eu, molestie vel, lacus. Pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas. Nullam accumsan lorem in dui.','filtered_html'),('comment','comment_node_forum',0,10,10,'und',0,'Drupal 7.28, a maintenance release with numerous bug fixes (no security fixes) is now available for download. See the Drupal 7.28 release notes for a full listing.\r\n\r\nDownload Drupal 7.28\r\nUpgrading your existing Drupal 7 sites is recommended. There are no major new features in this release. For more information about the Drupal 7.x release series, consult the Drupal 7.0 release announcement.\r\n\r\nSecurity information\r\nWe have a security announcement mailing list and a history of all security advisories, as well as an RSS feed with the most recent security advisories. We strongly advise Drupal administrators to sign up for the list.\r\n\r\nDrupal 7 includes the built-in Update Manager module, which informs you about important updates to your modules and themes.\r\n\r\nThere are no security fixes in this release of Drupal core.\r\n\r\nBug reports\r\nDrupal 7.x is being maintained, so given enough bug fixes (not just bug reports), more maintenance releases will be made available, according to our monthly release cycle.\r\n\r\nChangelog\r\nDrupal 7.28 contains bug fixes and small API/feature improvements only. The full list of changes between the 7.27 and 7.28 releases can be found by reading the 7.28 release notes. A complete list of all bug fixes in the stable 7.x branch can be found in the git commit log.\r\n\r\nUpdate notes\r\nSee the 7.28 release notes for details on important changes in this release.\r\n\r\nKnown issues\r\nChanges made to the Update Manager module in this release may lead to performance slowdowns in certain cases (including on rare page loads for site visitors, if the site is using the automated cron feature). See the release notes for more information.','filtered_html'),('comment','comment_node_article',0,11,11,'und',0,'Vivamus id interdum odio. Vivamus eu lectus eros. Aliquam vel nisi sagittis lectus pretium egestas. Integer nisi ligula, pulvinar vitae arcu vitae, cursus mattis massa. Vestibulum tempor metus feugiat condimentum iaculis. Mauris ornare nec neque eget rhoncus. Etiam nisi enim; blandit non porta amet.\r\n','filtered_html'),('comment','comment_node_article',0,12,12,'und',0,'Phasellus nec sem in justo pellentesque facilisis. Donec interdum, metus et hendrerit aliquet, dolor diam sagittis ligula, eget egestas libero turpis vel mi. Praesent ut ligula non mi varius sagittis. Fusce vel dui. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Sed aliquam, nisi quis porttitor congue, elit erat euismod orci, ac placerat dolor lectus quis orci.','filtered_html'),('comment','comment_node_article',0,13,13,'und',0,'Vestibulum rutrum, mi nec elementum vehicula, eros quam gravida nisl, id fringilla neque ante vel mi. Vestibulum fringilla pede sit amet augue. Sed a libero. Fusce convallis metus id felis luctus adipiscing. Donec pede justo, fringilla vel, aliquet nec, vulputate eget, arcu.','filtered_html'),('comment','comment_node_article',0,14,14,'und',0,'Vestibulum rutrum, mi nec elementum vehicula, eros quam gravida nisl, id fringilla neque ante vel mi. Vestibulum fringilla pede sit amet augue. Sed a libero. Fusce convallis metus id felis luctus adipiscing. Donec pede justo, fringilla vel, aliquet nec, vulputate eget, arcu.','filtered_html'),('comment','comment_node_article',0,15,15,'und',0,'Fusce porttitor nunc ac ante pretium, sed fermentum turpis malesuada. Aliquam tempor mollis metus, at congue nulla tincidunt at. Nunc nulla quam, congue quis fringilla ut, porta id ipsum. Nullam quis mattis odio? Nunc condimentum at diam a malesuada. Nulla facilisi. Suspendisse vitae gravida nullam.\r\n','filtered_html'),('comment','comment_node_article',0,16,16,'und',0,'Phasellus magna. Nullam cursus lacinia erat. Maecenas ullamcorper, dui et placerat feugiat, eros pede varius nisi, condimentum viverra felis nunc et lorem. Nullam accumsan lorem in dui. Donec vitae orci sed dolor rutrum auctor.','filtered_html'),('comment','comment_node_blog',0,17,17,'und',0,'<blockquote>Phasellus volutpat, metus eget egestas mollis, lacus lacus blandit dui, id egestas quam mauris ut lacus. Class aptent taciti sociosqu ad litora torquent per conubia nostra, per inceptos hymenaeos. Etiam rhoncus. Nunc egestas, augue at pellentesque laoreet, felis eros vehicula leo, at malesuada velit leo quis pede. Nullam nulla eros, ultricies sit amet, nonummy id, imperdiet feugiat, pede.</blockquote>\r\n\r\nFusce fermentum. Suspendisse faucibus, nunc et pellentesque egestas, lacus ante convallis tellus, vitae iaculis lacus elit id tortor. Pellentesque libero tortor, tincidunt et, tincidunt eget, semper nec, quam. Praesent ac sem eget est egestas volutpat. Duis vel nibh at velit scelerisque suscipit.','filtered_html'),('comment','comment_node_forum',0,18,18,'und',0,'Morbi mollis tellus ac sapien. Nam adipiscing. Nullam nulla eros, ultricies sit amet, nonummy id, imperdiet feugiat, pede. Phasellus viverra nulla ut metus varius laoreet. Praesent adipiscing.\r\n\r\nNam eget dui. Phasellus a est. Etiam iaculis nunc ac metus. Phasellus a est. Nulla neque dolor, sagittis eget, iaculis quis, molestie non, velit.\r\n\r\nMauris turpis nunc, blandit et, volutpat molestie, porta ut, ligula. Vivamus euismod mauris. Fusce ac felis sit amet ligula pharetra condimentum. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus. Sed hendrerit.','filtered_html'),('comment','comment_node_forum',0,19,19,'und',0,'Suspendisse non nisl sit amet velit hendrerit rutrum. Maecenas vestibulum mollis diam. Integer ante arcu, accumsan a, consectetuer eget, posuere ut, mauris. Nunc nonummy metus. Ut id nisl quis enim dignissim sagittis.\r\n\r\nAliquam lobortis. Mauris sollicitudin fermentum libero. Fusce fermentum odio nec arcu. Vestibulum purus quam, scelerisque ut, mollis sed, nonummy id, metus. Suspendisse potenti.\r\n\r\nVestibulum fringilla pede sit amet augue. Phasellus ullamcorper ipsum rutrum nunc. Cras varius. Curabitur nisi. Nullam sagittis.','filtered_html'),('comment','comment_node_forum',0,20,20,'und',0,'Suspendisse non nisl sit amet velit hendrerit rutrum. Maecenas vestibulum mollis diam. Integer ante arcu, accumsan a, consectetuer eget, posuere ut, mauris. Nunc nonummy metus. Ut id nisl quis enim dignissim sagittis.\r\n\r\nAliquam lobortis. Mauris sollicitudin fermentum libero. Fusce fermentum odio nec arcu. Vestibulum purus quam, scelerisque ut, mollis sed, nonummy id, metus. Suspendisse potenti.\r\n\r\nVestibulum fringilla pede sit amet augue. Phasellus ullamcorper ipsum rutrum nunc. Cras varius. Curabitur nisi. Nullam sagittis.','filtered_html'),('comment','comment_node_forum',0,21,21,'und',0,'Suspendisse non nisl sit amet velit hendrerit rutrum. Maecenas vestibulum mollis diam. Integer ante arcu, accumsan a, consectetuer eget, posuere ut, mauris. Nunc nonummy metus. Ut id nisl quis enim dignissim sagittis.\r\n\r\nAliquam lobortis. Mauris sollicitudin fermentum libero. Fusce fermentum odio nec arcu. Vestibulum purus quam, scelerisque ut, mollis sed, nonummy id, metus. Suspendisse potenti.\r\n\r\nVestibulum fringilla pede sit amet augue. Phasellus ullamcorper ipsum rutrum nunc. Cras varius. Curabitur nisi. Nullam sagittis.','filtered_html'),('comment','comment_node_forum',0,22,22,'und',0,'Aenean id mollis justo. Praesent nunc arcu, fringilla eu odio vel, rutrum feugiat dolor. Praesent quis nibh id est scelerisque interdum non vitae turpis. Fusce pretium urna vel lacus commodo mattis? Ut sit amet sapien cursus, imperdiet nibh et, molestie turpis. Vestibulum sed odio at elit cras amet.\r\n','filtered_html'),('comment','comment_node_forum',0,23,23,'und',0,'Phasellus et mauris sit amet metus interdum feugiat in sit amet ipsum. Nulla dignissim adipiscing dictum. Donec in nunc vel metus fringilla posuere id pellentesque nibh! Fusce ullamcorper posuere ipsum, sit amet gravida elit porttitor non! Fusce vehicula orci quis scelerisque congue. Morbi volutpat.\r\n','filtered_html'),('comment','comment_node_forum',0,24,24,'und',0,'Donec hendrerit, tortor ut iaculis imperdiet, leo nisi lacinia sapien, et aliquam dolor ipsum quis quam? Aenean semper dapibus elit, molestie imperdiet quam. Duis dignissim placerat quam, non euismod elit consectetur a. In ut arcu dignissim, ultrices lorem id, varius ligula. Nulla volutpat volutpat.\r\n','filtered_html'),('comment','comment_node_forum',0,25,25,'und',0,'Pellentesque vel augue sit amet ante euismod accumsan non a sapien. Maecenas molestie; velit sed auctor porta, augue purus accumsan lectus; id faucibus leo est id dui. Class aptent taciti sociosqu ad litora torquent per conubia nostra, per inceptos himenaeos. Suspendisse sodales tellus sed volutpat.\r\n','filtered_html'),('comment','comment_node_forum',0,26,26,'und',0,'Phasellus volutpat, metus eget egestas mollis, lacus lacus blandit dui, id egestas quam mauris ut lacus. Etiam sit amet orci eget eros faucibus tincidunt. Suspendisse non nisl sit amet velit hendrerit rutrum. Donec quam felis, ultricies nec, pellentesque eu, pretium quis, sem. Etiam imperdiet imperdiet orci.\r\n\r\nCras dapibus. Donec venenatis vulputate lorem. Praesent turpis. Etiam ut purus mattis mauris sodales aliquam. Etiam ultricies nisi vel augue.\r\n\r\nCras ultricies mi eu turpis hendrerit fringilla. Nullam nulla eros, ultricies sit amet, nonummy id, imperdiet feugiat, pede. Nullam vel sem. Maecenas malesuada. Sed fringilla mauris sit amet nibh.\r\n\r\nCurabitur turpis. Maecenas nec odio et ante tincidunt tempus. In ut quam vitae odio lacinia tincidunt. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Sed aliquam, nisi quis porttitor congue, elit erat euismod orci, ac placerat dolor lectus quis orci. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Fusce id purus.\r\n\r\nPraesent ut ligula non mi varius sagittis. Morbi vestibulum volutpat enim. Fusce egestas elit eget lorem. Vivamus quis mi. Sed lectus.','filtered_html'),('comment','comment_node_forum',0,27,27,'und',0,'Duis feugiat libero felis, ut cursus enim ullamcorper quis. Phasellus sem sem, imperdiet quis est id, porttitor elementum quam. Sed at elementum eros, quis pellentesque enim. Aliquam bibendum erat vel urna molestie, et blandit nibh consequat? Sed eu auctor dolor. Cras eu odio ut leo vestibulum amet.\r\n','filtered_html'),('comment','comment_node_forum',0,28,28,'und',0,'Phasellus volutpat, metus eget egestas mollis, lacus lacus blandit dui, id egestas quam mauris ut lacus. Etiam sit amet orci eget eros faucibus tincidunt. Suspendisse non nisl sit amet velit hendrerit rutrum. Donec quam felis, ultricies nec, pellentesque eu, pretium quis, sem. Etiam imperdiet imperdiet orci.\r\n\r\nCras dapibus. Donec venenatis vulputate lorem. Praesent turpis. Etiam ut purus mattis mauris sodales aliquam. Etiam ultricies nisi vel augue.\r\n\r\nCras ultricies mi eu turpis hendrerit fringilla. Nullam nulla eros, ultricies sit amet, nonummy id, imperdiet feugiat, pede. Nullam vel sem. Maecenas malesuada. Sed fringilla mauris sit amet nibh.\r\n\r\nCurabitur turpis. Maecenas nec odio et ante tincidunt tempus. In ut quam vitae odio lacinia tincidunt. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Sed aliquam, nisi quis porttitor congue, elit erat euismod orci, ac placerat dolor lectus quis orci. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Fusce id purus.\r\n\r\nPraesent ut ligula non mi varius sagittis. Morbi vestibulum volutpat enim. Fusce egestas elit eget lorem. Vivamus quis mi. Sed lectus.','filtered_html'),('comment','comment_node_forum',0,29,29,'und',0,'Morbi ac felis. Quisque id mi. Quisque libero metus, condimentum nec, tempor a, commodo mollis, magna. Donec vitae orci sed dolor rutrum auctor. Curabitur nisi.\r\n\r\nFusce fermentum odio nec arcu. Phasellus magna. Maecenas ullamcorper, dui et placerat feugiat, eros pede varius nisi, condimentum viverra felis nunc et lorem. Nam at tortor in tellus interdum sagittis. Nullam sagittis.\r\n\r\nInteger tincidunt. Aliquam lobortis. In ut quam vitae odio lacinia tincidunt. Vestibulum volutpat pretium libero. Nam commodo suscipit quam.','filtered_html'),('comment','comment_node_blog',0,30,30,'und',0,'Morbi mattis ullamcorper velit. Ut non enim eleifend felis pretium feugiat. Donec quam felis, ultricies nec, pellentesque eu, pretium quis, sem. Maecenas nec odio et ante tincidunt tempus. Lorem ipsum dolor sit amet, consectetuer adipiscing elit.\r\n\r\nPraesent congue erat at massa. Nam ipsum risus, rutrum vitae, vestibulum eu, molestie vel, lacus. Cras id dui. Fusce convallis metus id felis luctus adipiscing. Pellentesque commodo eros a enim.','filtered_html'),('comment','comment_node_blog',0,31,31,'und',0,'Aenean leo ligula, porttitor eu, consequat vitae, eleifend ac, enim. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Fusce id purus. Sed libero. Phasellus blandit leo ut odio. Fusce vel dui.\r\n\r\nNunc sed turpis. Phasellus viverra nulla ut metus varius laoreet. Praesent ut ligula non mi varius sagittis. Nulla consequat massa quis enim. Suspendisse pulvinar, augue ac venenatis condimentum, sem libero volutpat nibh, nec pellentesque velit pede quis nunc.','filtered_html'),('comment','comment_node_blog',0,32,32,'und',0,' Vivamus elementum semper nisi. Nunc egestas, augue at pellentesque laoreet, felis eros vehicula leo, at malesuada velit leo quis pede. Proin sapien ipsum, porta a, auctor quis, euismod ut, mi. Suspendisse eu ligula.','filtered_html'),('comment','comment_node_blog',0,33,33,'und',0,' Vivamus elementum semper nisi. Nunc egestas, augue at pellentesque laoreet, felis eros vehicula leo, at malesuada velit leo quis pede. Proin sapien ipsum, porta a, auctor quis, euismod ut, mi. Suspendisse eu ligula.','filtered_html'),('comment','comment_node_blog',0,34,34,'und',0,'Aliquam eu faucibus orci, a hendrerit elit. Sed metus augue; euismod tristique risus condimentum, elementum faucibus enim. Praesent interdum lorem ante, ut aliquam metus accumsan non? Integer egestas quis arcu sed ornare. Maecenas vitae velit vel ipsum fringilla iaculis sed dapibus odio. Fusce amet.\r\n','filtered_html'),('comment','comment_node_blog',0,35,35,'und',0,'Vestibulum mattis metus non nunc venenatis feugiat. Pellentesque quis scelerisque dolor. Fusce posuere iaculis dictum. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus. Interdum et malesuada fames ac ante ipsum primis in faucibus. Donec sed eros fringilla; nullam.\r\n','filtered_html'),('comment','comment_node_blog',0,36,36,'und',0,'Nulla adipiscing quam eros, eleifend gravida mi ornare eget. Proin id nunc dui. Duis eleifend mi non tellus porta, vitae semper eros pulvinar. Suspendisse adipiscing orci eu porta pretium. Donec at est sed tortor placerat tempor nec pulvinar nisl. Proin at arcu vitae sem vestibulum pharetra sed sed.\r\n','filtered_html'),('comment','comment_node_blog',0,37,37,'und',0,'Pellentesque placerat elementum felis nec interdum. Etiam a felis vel urna egestas molestie. Class aptent taciti sociosqu ad litora torquent per conubia nostra, per inceptos himenaeos. Aliquam pulvinar eleifend ipsum et imperdiet. Curabitur quis libero malesuada, tincidunt mauris ut aenean suscipit.\r\n','filtered_html'),('comment','comment_node_blog',0,38,38,'und',0,'Phasellus viverra nulla ut metus varius laoreet. Suspendisse potenti. Nam adipiscing. Donec posuere vulputate arcu. Sed magna purus, fermentum eu, tincidunt eu, varius ut, felis.','filtered_html'),('comment','comment_node_blog',0,39,39,'und',0,'Vestibulum purus quam, scelerisque ut, mollis sed, nonummy id, metus. Suspendisse non nisl sit amet velit hendrerit rutrum. Vestibulum dapibus nunc ac augue. Praesent adipiscing. Sed mollis, eros et ultrices tempus, mauris ipsum aliquam libero, non adipiscing dolor urna a orci.','filtered_html'),('comment','comment_node_blog',0,40,40,'und',0,'Morbi neque arcu, malesuada tempor elit et; porttitor gravida tellus? Duis mattis sit amet est sed laoreet. Nunc venenatis felis nunc, non sagittis nunc ultricies et. Maecenas semper sed ante non viverra. Aenean a aliquam urna. Etiam faucibus commodo eleifend. Aliquam ornare dapibus nulla cras amet.\r\n','filtered_html'),('comment','comment_node_blog',0,41,41,'und',0,'Fusce neque. Ut a nisl id ante tempus hendrerit. Donec interdum, metus et hendrerit aliquet, dolor diam sagittis ligula, eget egestas libero turpis vel mi. Nullam dictum felis eu pede mollis pretium. Etiam sollicitudin, ipsum eu pulvinar rutrum, tellus ipsum laoreet sapien, quis venenatis ante odio sit amet eros.','filtered_html'),('comment','comment_node_blog',0,42,42,'und',0,'Nullam nulla eros, ultricies sit amet, nonummy id, imperdiet feugiat, pede. Vestibulum fringilla pede sit amet augue. Nam adipiscing. Aenean ut eros et nisl sagittis vestibulum. Curabitur ullamcorper ultricies nisi.','filtered_html'),('comment','comment_node_blog',0,43,43,'und',0,'Quisque libero metus, condimentum nec, tempor a, commodo mollis, magna. Aenean imperdiet. Lorem ipsum dolor sit amet, consectetuer adipiscing elit. Mauris sollicitudin fermentum libero. Maecenas tempus, tellus eget condimentum rhoncus, sem quam semper libero, sit amet adipiscing sem neque sed ipsum.','filtered_html'),('comment','comment_node_blog',0,44,44,'und',0,'Cras varius. Curabitur suscipit suscipit tellus. Sed libero. Nunc nulla. Nulla facilisi.','filtered_html'),('comment','comment_node_blog',0,45,45,'und',0,'In hac habitasse platea dictumst. Vivamus euismod mauris. Vestibulum fringilla pede sit amet augue. Aenean commodo ligula eget dolor. Mauris sollicitudin fermentum libero.','filtered_html'),('comment','comment_node_forum',0,46,46,'und',0,'Quisque libero metus, condimentum nec, tempor a, commodo mollis, magna. Nulla sit amet est. Donec quam felis, ultricies nec, pellentesque eu, pretium quis, sem. Aenean posuere, tortor sed cursus feugiat, nunc augue blandit nunc, eu sollicitudin urna dolor sagittis lacus. Curabitur blandit mollis lacus.\r\n\r\nPraesent vestibulum dapibus nibh. Nunc nonummy metus. Aliquam lobortis. Cras non dolor. Etiam feugiat lorem non metus.','filtered_html'),('comment','comment_node_forum',0,47,47,'und',0,'Nunc lobortis egestas justo, id aliquet dolor blandit ut. Donec vitae tortor enim. Nulla dictum; urna quis fermentum vulputate, leo ipsum porta dui, eu gravida erat ligula eget eros! In vel aliquam libero, ac tempus urna. Fusce quis leo iaculis, iaculis magna ut, eleifend nulla. Morbi commodo metus.\r\n','filtered_html'),('comment','comment_node_forum',0,48,48,'und',0,'Sed sit amet ullamcorper mauris. Duis pulvinar at nisl vel auctor. Etiam hendrerit non nibh at adipiscing. Aliquam semper eros ut tortor ullamcorper blandit. Cras mollis auctor orci eu vestibulum. Aenean vitae volutpat nisi. Class aptent taciti sociosqu ad litora torquent per conubia nostra posuere.\r\n','filtered_html'),('comment','comment_node_forum',0,49,49,'und',0,'Suspendisse potenti. Integer tincidunt. Ut a nisl id ante tempus hendrerit. Suspendisse pulvinar, augue ac venenatis condimentum, sem libero volutpat nibh, nec pellentesque velit pede quis nunc. Vivamus in erat ut urna cursus vestibulum.','filtered_html'),('comment','comment_node_video',0,50,50,'und',0,'Curabitur ullamcorper ultricies nisi. Nullam tincidunt adipiscing enim. Etiam iaculis nunc ac metus. Curabitur at lacus ac velit ornare lobortis. Pellentesque commodo eros a enim.','filtered_html'),('comment','comment_node_forum',0,51,51,'und',0,'In hac habitasse platea dictumst. Morbi vestibulum volutpat enim. Fusce commodo aliquam arcu. Quisque libero metus, condimentum nec, tempor a, commodo mollis, magna. Maecenas vestibulum mollis diam.','filtered_html'),('comment','comment_node_forum',0,52,52,'und',0,'Phasellus a tellus erat. Curabitur ut euismod sem. Proin eu neque a ligula bibendum porta! Fusce faucibus neque id egestas tristique. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Morbi dignissim dictum lectus in tristique. Suspendisse luctus vehicula metus.\r\n','filtered_html'),('comment','comment_node_forum',0,53,53,'und',0,'Donec venenatis vulputate lorem. Donec orci lectus, aliquam ut, faucibus non, euismod id, nulla. Cras dapibus. Phasellus nec sem in justo pellentesque facilisis. Mauris sollicitudin fermentum libero.','filtered_html');
/*!40000 ALTER TABLE `field_revision_comment_body` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `field_revision_field_category`
--

DROP TABLE IF EXISTS `field_revision_field_category`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_category` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_category_tid` int(10) unsigned DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_category_tid` (`field_category_tid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 12 (field_category)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_category`
--

LOCK TABLES `field_revision_field_category` WRITE;
/*!40000 ALTER TABLE `field_revision_field_category` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `field_revision_field_category` VALUES ('node','article',0,4,4,'und',0,25),('node','article',0,5,5,'und',0,26),('node','article',0,6,6,'und',0,22),('node','article',0,12,12,'und',0,23),('node','article',0,27,27,'und',0,23),('node','article',0,28,28,'und',0,22),('node','article',0,29,29,'und',0,24),('node','article',0,30,30,'und',0,25),('node','article',0,31,31,'und',0,21);
/*!40000 ALTER TABLE `field_revision_field_category` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `field_revision_field_comment_ref`
--

DROP TABLE IF EXISTS `field_revision_field_comment_ref`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_comment_ref` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_comment_ref_target_id` int(10) unsigned NOT NULL COMMENT 'The id of the target entity.',
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_comment_ref_target_id` (`field_comment_ref_target_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 8 (field_comment_ref)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_comment_ref`
--

LOCK TABLES `field_revision_field_comment_ref` WRITE;
/*!40000 ALTER TABLE `field_revision_field_comment_ref` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `field_revision_field_comment_ref` VALUES ('message','example_create_comment',0,9,9,'und',0,2),('message','example_create_comment',0,10,10,'und',0,3),('message','example_create_comment',0,11,11,'und',0,4),('message','example_create_comment',0,12,12,'und',0,5),('message','example_create_comment',0,13,13,'und',0,6),('message','example_create_comment',0,15,15,'und',0,7),('message','example_create_comment',0,19,19,'und',0,8),('message','example_create_comment',0,21,21,'und',0,9),('message','example_create_comment',0,23,23,'und',0,10),('message','example_create_comment',0,54,54,'und',0,11),('message','example_create_comment',0,55,55,'und',0,12),('message','example_create_comment',0,56,56,'und',0,13),('message','example_create_comment',0,57,57,'und',0,14),('message','example_create_comment',0,59,59,'und',0,15),('message','example_create_comment',0,60,60,'und',0,16),('message','example_create_comment',0,61,61,'und',0,17),('message','example_create_comment',0,68,68,'und',0,18),('message','example_create_comment',0,69,69,'und',0,19),('message','example_create_comment',0,70,70,'und',0,20),('message','example_create_comment',0,71,71,'und',0,21),('message','example_create_comment',0,72,72,'und',0,22),('message','example_create_comment',0,73,73,'und',0,23),('message','example_create_comment',0,74,74,'und',0,24),('message','example_create_comment',0,75,75,'und',0,25),('message','example_create_comment',0,76,76,'und',0,26),('message','example_create_comment',0,77,77,'und',0,27),('message','example_create_comment',0,78,78,'und',0,28),('message','example_create_comment',0,80,80,'und',0,29),('message','example_create_comment',0,81,81,'und',0,30),('message','example_create_comment',0,82,82,'und',0,31),('message','example_create_comment',0,83,83,'und',0,32),('message','example_create_comment',0,84,84,'und',0,33),('message','example_create_comment',0,85,85,'und',0,34),('message','example_create_comment',0,86,86,'und',0,35),('message','example_create_comment',0,87,87,'und',0,36),('message','example_create_comment',0,88,88,'und',0,37),('message','example_create_comment',0,89,89,'und',0,38),('message','example_create_comment',0,90,90,'und',0,39),('message','example_create_comment',0,91,91,'und',0,40),('message','example_create_comment',0,92,92,'und',0,41),('message','example_create_comment',0,93,93,'und',0,42),('message','example_create_comment',0,94,94,'und',0,43),('message','example_create_comment',0,95,95,'und',0,44),('message','example_create_comment',0,96,96,'und',0,45),('message','example_create_comment',0,99,99,'und',0,46),('message','example_create_comment',0,100,100,'und',0,47),('message','example_create_comment',0,101,101,'und',0,48),('message','example_create_comment',0,103,103,'und',0,49),('message','example_create_comment',0,105,105,'und',0,50),('message','example_create_comment',0,106,106,'und',0,51),('message','example_create_comment',0,107,107,'und',0,52),('message','example_create_comment',0,108,108,'und',0,53);
/*!40000 ALTER TABLE `field_revision_field_comment_ref` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `field_revision_field_description`
--

DROP TABLE IF EXISTS `field_revision_field_description`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_description` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_description_value` longtext,
  `field_description_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_description_format` (`field_description_format`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 17 (field_description)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_description`
--

LOCK TABLES `field_revision_field_description` WRITE;
/*!40000 ALTER TABLE `field_revision_field_description` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `field_revision_field_description` VALUES ('field_collection_item','field_extra_content',0,9,9,'und',0,'Aliquam eu nunc. Vestibulum purus quam, scelerisque ut, mollis sed, nonummy id, metus. Vestibulum dapibus nunc ac augue. Maecenas tempus, tellus eget condimentum rhoncus, sem quam semper libero, sit amet adipiscing sem neque sed ipsum. Fusce vel dui. Vivamus consectetuer hendrerit lacus. Suspendisse faucibus, nunc et pellentesque egestas, lacus ante convallis tellus, vitae iaculis lacus elit id tortor. Vestibulum suscipit nulla quis orci. Fusce neque. Quisque rutrum.',NULL),('field_collection_item','field_extra_content',0,10,10,'und',0,'Aliquam eu nunc. Vestibulum purus quam, scelerisque ut, mollis sed, nonummy id, metus. Vestibulum dapibus nunc ac augue. Maecenas tempus, tellus eget condimentum rhoncus, sem quam semper libero, sit amet adipiscing sem neque sed ipsum. Fusce vel dui. Vivamus consectetuer hendrerit lacus. Suspendisse faucibus, nunc et pellentesque egestas, lacus ante convallis tellus, vitae iaculis lacus elit id tortor. Vestibulum suscipit nulla quis orci. Fusce neque. Quisque rutrum.',NULL),('field_collection_item','field_extra_content',0,11,11,'und',0,'Aliquam eu nunc. Vestibulum purus quam, scelerisque ut, mollis sed, nonummy id, metus. Vestibulum dapibus nunc ac augue. Maecenas tempus, tellus eget condimentum rhoncus, sem quam semper libero, sit amet adipiscing sem neque sed ipsum. Fusce vel dui. Vivamus consectetuer hendrerit lacus. Suspendisse faucibus, nunc et pellentesque egestas, lacus ante convallis tellus, vitae iaculis lacus elit id tortor. Vestibulum suscipit nulla quis orci. Fusce neque. Quisque rutrum.',NULL),('field_collection_item','field_extra_content',0,12,12,'und',0,'Aliquam eu nunc. Vestibulum purus quam, scelerisque ut, mollis sed, nonummy id, metus. Vestibulum dapibus nunc ac augue. Maecenas tempus, tellus eget condimentum rhoncus, sem quam semper libero, sit amet adipiscing sem neque sed ipsum. Fusce vel dui. Vivamus consectetuer hendrerit lacus. Suspendisse faucibus, nunc et pellentesque egestas, lacus ante convallis tellus, vitae iaculis lacus elit id tortor. Vestibulum suscipit nulla quis orci. Fusce neque. Quisque rutrum.',NULL),('field_collection_item','field_extra_content',0,13,13,'und',0,'Sed magna purus, fermentum eu, tincidunt eu, varius ut, felis. Pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas. Vivamus aliquet elit ac nisl. Ut varius tincidunt libero. Nulla sit amet est. Proin faucibus arcu quis ante. Praesent metus tellus, elementum eu, semper a, adipiscing nec, purus. Proin viverra, ligula sit amet ultrices semper, ligula arcu tristique sapien, a accumsan nisi mauris ac eros. Mauris turpis nunc, blandit et, volutpat molestie, porta ut, ligula. Phasellus accumsan cursus velit.',NULL),('field_collection_item','field_extra_content',0,14,14,'und',0,'Aenean viverra rhoncus pede. In dui magna, posuere eget, vestibulum et, tempor auctor, justo. Nullam dictum felis eu pede mollis pretium. Vestibulum turpis sem, aliquet eget, lobortis pellentesque, rutrum eu, nisl. Vivamus laoreet.',NULL),('field_collection_item','field_extra_content',0,15,15,'und',0,'Praesent congue erat at massa. Aenean vulputate eleifend tellus. Vestibulum suscipit nulla quis orci. Praesent nec nisl a purus blandit viverra. Nam quam nunc, blandit vel, luctus pulvinar, hendrerit id, lorem.',NULL),('field_collection_item','field_extra_content',0,16,16,'und',0,'Phasellus gravida semper nisi. Praesent congue erat at massa. Nullam vel sem. Nullam vel sem. Vivamus consectetuer hendrerit lacus.',NULL),('field_collection_item','field_extra_content',0,17,17,'und',0,'Maecenas tempus, tellus eget condimentum rhoncus, sem quam semper libero, sit amet adipiscing sem neque sed ipsum. Vivamus laoreet. Cras sagittis. Pellentesque auctor neque nec urna. Nullam quis ante.',NULL),('field_collection_item','field_extra_content',0,18,18,'und',0,'In turpis. In hac habitasse platea dictumst. Vivamus quis mi. Sed consequat, leo eget bibendum sodales, augue velit cursus nunc, quis gravida magna mi a libero. Quisque malesuada placerat nisl.',NULL),('field_collection_item','field_extra_content',0,19,19,'und',0,'Quisque rutrum. Sed consequat, leo eget bibendum sodales, augue velit cursus nunc, quis gravida magna mi a libero. Suspendisse pulvinar, augue ac venenatis condimentum, sem libero volutpat nibh, nec pellentesque velit pede quis nunc. Curabitur suscipit suscipit tellus. Nulla neque dolor, sagittis eget, iaculis quis, molestie non, velit.',NULL),('field_collection_item','field_extra_content',0,26,26,'und',0,'Ut varius tincidunt libero. Sed lectus. Fusce vel dui. Aenean commodo ligula eget dolor. Fusce vulputate eleifend sapien.',NULL),('field_collection_item','field_extra_content',0,27,27,'und',0,'Nam ipsum risus, rutrum vitae, vestibulum eu, molestie vel, lacus. Fusce egestas elit eget lorem. Duis leo. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Fusce id purus. Donec id justo. Quisque id odio. Nunc interdum lacus sit amet orci. Vestibulum dapibus nunc ac augue. Etiam iaculis nunc ac metus. Nunc nonummy metus.',NULL),('field_collection_item','field_extra_content',0,28,28,'und',0,'Vestibulum fringilla pede sit amet augue. Suspendisse enim turpis, dictum sed, iaculis a, condimentum nec, nisi. Mauris sollicitudin fermentum libero. Praesent ac sem eget est egestas volutpat. In enim justo, rhoncus ut, imperdiet a, venenatis vitae, justo. Aliquam erat volutpat. Sed fringilla mauris sit amet nibh. Suspendisse enim turpis, dictum sed, iaculis a, condimentum nec, nisi. Morbi ac felis. Phasellus nec sem in justo pellentesque facilisis.',NULL);
/*!40000 ALTER TABLE `field_revision_field_description` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `field_revision_field_detailed_question`
--

DROP TABLE IF EXISTS `field_revision_field_detailed_question`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_detailed_question` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_detailed_question_value` longtext,
  `field_detailed_question_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_detailed_question_format` (`field_detailed_question_format`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 18 (field_detailed...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_detailed_question`
--

LOCK TABLES `field_revision_field_detailed_question` WRITE;
/*!40000 ALTER TABLE `field_revision_field_detailed_question` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `field_revision_field_detailed_question` VALUES ('node','faq',0,13,13,'und',0,'','filtered_html'),('node','faq',0,14,14,'und',0,'','filtered_html'),('node','faq',0,58,58,'und',0,'','filtered_html'),('node','faq',0,59,59,'und',0,'','filtered_html'),('node','faq',0,60,60,'und',0,'','filtered_html'),('node','faq',0,61,61,'und',0,'','filtered_html'),('node','faq',0,62,62,'und',0,'','filtered_html'),('node','faq',0,63,63,'und',0,'','filtered_html'),('node','faq',0,64,64,'und',0,'','filtered_html'),('node','faq',0,65,65,'und',0,'','filtered_html'),('node','faq',0,66,66,'und',0,'','filtered_html'),('node','faq',0,67,67,'und',0,'','filtered_html');
/*!40000 ALTER TABLE `field_revision_field_detailed_question` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `field_revision_field_extra_content`
--

DROP TABLE IF EXISTS `field_revision_field_extra_content`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_extra_content` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_extra_content_value` int(11) DEFAULT NULL COMMENT 'The field collection item id.',
  `field_extra_content_revision_id` int(11) DEFAULT NULL COMMENT 'The field collection item revision id.',
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_extra_content_revision_id` (`field_extra_content_revision_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 16 (field_extra_content)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_extra_content`
--

LOCK TABLES `field_revision_field_extra_content` WRITE;
/*!40000 ALTER TABLE `field_revision_field_extra_content` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `field_revision_field_extra_content` VALUES ('node','blog',0,7,7,'und',0,9,9),('node','blog',0,7,7,'und',1,10,10),('node','blog',0,7,7,'und',2,11,11),('node','blog',0,8,8,'und',0,12,12),('node','blog',0,8,8,'und',1,13,13),('node','blog',0,9,9,'und',0,14,14),('node','blog',0,9,9,'und',1,15,15),('node','article',0,28,28,'und',0,27,27),('node','article',0,29,29,'und',0,26,26),('node','article',0,31,31,'und',0,16,16),('node','article',0,31,31,'und',1,17,17),('node','forum',0,47,47,'und',0,28,28),('node','forum',0,54,54,'und',0,18,18),('node','forum',0,55,55,'und',0,19,19),('node','forum',0,55,55,'und',1,20,20),('node','forum',0,55,55,'und',2,21,21),('node','forum',0,56,56,'und',0,24,24);
/*!40000 ALTER TABLE `field_revision_field_extra_content` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `field_revision_field_image`
--

DROP TABLE IF EXISTS `field_revision_field_image`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_image` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_image_fid` int(10) unsigned DEFAULT NULL COMMENT 'The file_managed.fid being referenced in this field.',
  `field_image_alt` varchar(512) DEFAULT NULL COMMENT 'Alternative image text, for the image’s ’alt’ attribute.',
  `field_image_title` varchar(1024) DEFAULT NULL COMMENT 'Image title text, for the image’s ’title’ attribute.',
  `field_image_width` int(10) unsigned DEFAULT NULL COMMENT 'The width of the image in pixels.',
  `field_image_height` int(10) unsigned DEFAULT NULL COMMENT 'The height of the image in pixels.',
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_image_fid` (`field_image_fid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 4 (field_image)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_image`
--

LOCK TABLES `field_revision_field_image` WRITE;
/*!40000 ALTER TABLE `field_revision_field_image` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `field_revision_field_image` VALUES ('field_collection_item','field_extra_content',0,9,9,'und',0,120,'','',1170,580),('field_collection_item','field_extra_content',0,10,10,'und',0,121,'','',1170,580),('field_collection_item','field_extra_content',0,11,11,'und',0,122,'','',1170,580),('field_collection_item','field_extra_content',0,12,12,'und',0,123,'','',1170,580),('field_collection_item','field_extra_content',0,13,13,'und',0,124,'','',1170,580),('field_collection_item','field_extra_content',0,14,14,'und',0,125,'','',1170,780),('field_collection_item','field_extra_content',0,15,15,'und',0,126,'','',1170,780),('field_collection_item','field_extra_content',0,16,16,'und',0,127,'','',1170,780),('field_collection_item','field_extra_content',0,17,17,'und',0,128,'','',1170,780),('field_collection_item','field_extra_content',0,18,18,'und',0,129,'','',1170,760),('field_collection_item','field_extra_content',0,19,19,'und',0,130,'','',1170,760),('field_collection_item','field_extra_content',0,21,21,'und',0,132,'','',1170,780),('field_collection_item','field_extra_content',0,26,26,'und',0,140,'','',1170,780),('field_collection_item','field_extra_content',0,27,27,'und',0,142,'','',1170,780),('field_collection_item','field_extra_content',0,28,28,'und',0,149,'','',1170,780),('node','article',0,4,4,'und',0,147,'','',1170,780),('node','article',0,5,5,'und',0,148,'','',1170,780),('node','article',0,6,6,'und',0,145,'','',1170,760),('node','blog',0,7,7,'und',0,99,'','',1170,780),('node','blog',0,8,8,'und',0,100,'','',1170,760),('node','blog',0,9,9,'und',0,101,'','',1170,780),('node','blog',0,10,10,'und',0,103,'','',1170,780),('node','blog',0,11,11,'und',0,102,'','',1170,780),('node','article',0,12,12,'und',0,144,'','',1170,760),('node','article',0,27,27,'und',0,143,'','',1170,760),('node','article',0,28,28,'und',0,141,'','',1170,780),('node','article',0,29,29,'und',0,139,'','',1170,780),('node','article',0,30,30,'und',0,138,'','',1170,780),('node','article',0,31,31,'und',0,137,'','',1170,780),('node','products',0,48,48,'und',0,156,'','',960,460),('node','products',0,49,49,'und',0,157,'','',960,460),('node','products',0,50,50,'und',0,158,'','',960,460),('node','products',0,51,51,'und',0,159,'','',960,460),('node','products',0,52,52,'und',0,160,'','',960,460);
/*!40000 ALTER TABLE `field_revision_field_image` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `field_revision_field_link`
--

DROP TABLE IF EXISTS `field_revision_field_link`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_link` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_link_url` varchar(2048) DEFAULT NULL,
  `field_link_title` varchar(255) DEFAULT NULL,
  `field_link_attributes` mediumtext,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 14 (field_link)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_link`
--

LOCK TABLES `field_revision_field_link` WRITE;
/*!40000 ALTER TABLE `field_revision_field_link` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `field_revision_field_link` VALUES ('node','products',0,48,48,'und',0,'http://weebpal.com/drupal-themes','Read More','a:0:{}'),('node','products',0,49,49,'und',0,'http://weebpal.com/drupal-themes','Read More','a:0:{}'),('node','products',0,50,50,'und',0,'http://weebpal.com/drupal-themes','Read More','a:0:{}'),('node','products',0,51,51,'und',0,'http://weebpal.com/drupal-themes','Read More','a:0:{}'),('node','products',0,52,52,'und',0,'http://weebpal.com/drupal-themes','Read More','a:0:{}');
/*!40000 ALTER TABLE `field_revision_field_link` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `field_revision_field_node_ref`
--

DROP TABLE IF EXISTS `field_revision_field_node_ref`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_node_ref` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_node_ref_target_id` int(10) unsigned NOT NULL COMMENT 'The id of the target entity.',
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_node_ref_target_id` (`field_node_ref_target_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 9 (field_node_ref)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_node_ref`
--

LOCK TABLES `field_revision_field_node_ref` WRITE;
/*!40000 ALTER TABLE `field_revision_field_node_ref` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `field_revision_field_node_ref` VALUES ('message','example_create_node',0,2,2,'und',0,5),('message','example_create_node',0,3,3,'und',0,6),('message','example_create_node',0,4,4,'und',0,7),('message','example_create_node',0,5,5,'und',0,8),('message','example_create_node',0,6,6,'und',0,9),('message','example_create_node',0,7,7,'und',0,10),('message','example_create_node',0,8,8,'und',0,11),('message','example_create_comment',0,9,9,'und',0,11),('message','example_create_comment',0,10,10,'und',0,11),('message','example_create_comment',0,11,11,'und',0,9),('message','example_create_comment',0,12,12,'und',0,7),('message','example_create_comment',0,13,13,'und',0,9),('message','example_create_node',0,14,14,'und',0,12),('message','example_create_comment',0,15,15,'und',0,12),('message','example_create_node',0,16,16,'und',0,13),('message','example_create_node',0,17,17,'und',0,14),('message','example_create_node',0,18,18,'und',0,15),('message','example_create_comment',0,19,19,'und',0,15),('message','example_create_comment',0,21,21,'und',0,15),('message','example_create_node',0,22,22,'und',0,16),('message','example_create_comment',0,23,23,'und',0,16),('message','example_create_node',0,24,24,'und',0,17),('message','example_create_node',0,25,25,'und',0,18),('message','example_create_node',0,26,26,'und',0,19),('message','example_create_node',0,27,27,'und',0,20),('message','example_create_node',0,28,28,'und',0,21),('message','example_create_node',0,29,29,'und',0,22),('message','example_create_node',0,30,30,'und',0,23),('message','example_create_node',0,31,31,'und',0,24),('message','example_create_node',0,32,32,'und',0,25),('message','example_create_node',0,33,33,'und',0,26),('message','example_create_node',0,34,34,'und',0,27),('message','example_create_node',0,35,35,'und',0,28),('message','example_create_node',0,36,36,'und',0,29),('message','example_create_node',0,37,37,'und',0,30),('message','example_create_node',0,38,38,'und',0,31),('message','example_create_node',0,40,40,'und',0,33),('message','example_create_node',0,41,41,'und',0,34),('message','example_create_node',0,42,42,'und',0,35),('message','example_create_node',0,43,43,'und',0,36),('message','example_create_node',0,44,44,'und',0,37),('message','example_create_node',0,45,45,'und',0,38),('message','example_create_node',0,46,46,'und',0,39),('message','example_create_node',0,47,47,'und',0,40),('message','example_create_node',0,48,48,'und',0,41),('message','example_create_node',0,49,49,'und',0,42),('message','example_create_node',0,50,50,'und',0,43),('message','example_create_node',0,51,51,'und',0,44),('message','example_create_node',0,52,52,'und',0,45),('message','example_create_node',0,53,53,'und',0,46),('message','example_create_comment',0,54,54,'und',0,31),('message','example_create_comment',0,55,55,'und',0,31),('message','example_create_comment',0,56,56,'und',0,31),('message','example_create_comment',0,57,57,'und',0,30),('message','example_create_node',0,58,58,'und',0,47),('message','example_create_comment',0,59,59,'und',0,5),('message','example_create_comment',0,60,60,'und',0,5),('message','example_create_comment',0,61,61,'und',0,10),('message','example_create_node',0,62,62,'und',0,48),('message','example_create_node',0,63,63,'und',0,49),('message','example_create_node',0,64,64,'und',0,50),('message','example_create_node',0,65,65,'und',0,51),('message','example_create_node',0,66,66,'und',0,52),('message','example_create_node',0,67,67,'und',0,53),('message','example_create_comment',0,68,68,'und',0,53),('message','example_create_comment',0,69,69,'und',0,53),('message','example_create_comment',0,70,70,'und',0,53),('message','example_create_comment',0,71,71,'und',0,53),('message','example_create_comment',0,72,72,'und',0,53),('message','example_create_comment',0,73,73,'und',0,53),('message','example_create_comment',0,74,74,'und',0,53),('message','example_create_comment',0,75,75,'und',0,53),('message','example_create_comment',0,76,76,'und',0,53),('message','example_create_comment',0,77,77,'und',0,53),('message','example_create_comment',0,78,78,'und',0,53),('message','example_create_comment',0,80,80,'und',0,53),('message','example_create_comment',0,81,81,'und',0,7),('message','example_create_comment',0,82,82,'und',0,7),('message','example_create_comment',0,83,83,'und',0,7),('message','example_create_comment',0,84,84,'und',0,7),('message','example_create_comment',0,85,85,'und',0,7),('message','example_create_comment',0,86,86,'und',0,7),('message','example_create_comment',0,87,87,'und',0,7),('message','example_create_comment',0,88,88,'und',0,7),('message','example_create_comment',0,89,89,'und',0,7),('message','example_create_comment',0,90,90,'und',0,7),('message','example_create_comment',0,91,91,'und',0,7),('message','example_create_comment',0,92,92,'und',0,8),('message','example_create_comment',0,93,93,'und',0,8),('message','example_create_comment',0,94,94,'und',0,8),('message','example_create_comment',0,95,95,'und',0,8),('message','example_create_comment',0,96,96,'und',0,9),('message','example_create_node',0,97,97,'und',0,54),('message','example_create_node',0,98,98,'und',0,55),('message','example_create_comment',0,99,99,'und',0,55),('message','example_create_comment',0,100,100,'und',0,55),('message','example_create_comment',0,101,101,'und',0,54),('message','example_create_node',0,102,102,'und',0,56),('message','example_create_comment',0,103,103,'und',0,56),('message','example_create_node',0,104,104,'und',0,57),('message','example_create_comment',0,105,105,'und',0,37),('message','example_create_comment',0,106,106,'und',0,47),('message','example_create_comment',0,107,107,'und',0,3),('message','example_create_comment',0,108,108,'und',0,1),('message','example_create_node',0,109,109,'und',0,58),('message','example_create_node',0,110,110,'und',0,59),('message','example_create_node',0,111,111,'und',0,60),('message','example_create_node',0,112,112,'und',0,61),('message','example_create_node',0,113,113,'und',0,62),('message','example_create_node',0,114,114,'und',0,63),('message','example_create_node',0,115,115,'und',0,64),('message','example_create_node',0,116,116,'und',0,65),('message','example_create_node',0,117,117,'und',0,66),('message','example_create_node',0,118,118,'und',0,67),('message','example_create_node',0,119,119,'und',0,68),('message','example_create_node',0,120,120,'und',0,69);
/*!40000 ALTER TABLE `field_revision_field_node_ref` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `field_revision_field_published`
--

DROP TABLE IF EXISTS `field_revision_field_published`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_published` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_published_value` int(11) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_published_value` (`field_published_value`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 10 (field_published)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_published`
--

LOCK TABLES `field_revision_field_published` WRITE;
/*!40000 ALTER TABLE `field_revision_field_published` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `field_revision_field_published` VALUES ('message','example_user_register',0,1,1,'und',0,0),('message','example_create_node',0,2,2,'und',0,1),('message','example_create_node',0,3,3,'und',0,1),('message','example_create_node',0,4,4,'und',0,1),('message','example_create_node',0,5,5,'und',0,1),('message','example_create_node',0,6,6,'und',0,1),('message','example_create_node',0,7,7,'und',0,1),('message','example_create_node',0,8,8,'und',0,1),('message','example_create_comment',0,9,9,'und',0,1),('message','example_create_comment',0,10,10,'und',0,1),('message','example_create_comment',0,11,11,'und',0,1),('message','example_create_comment',0,12,12,'und',0,1),('message','example_create_comment',0,13,13,'und',0,1),('message','example_create_node',0,14,14,'und',0,1),('message','example_create_comment',0,15,15,'und',0,1),('message','example_create_node',0,16,16,'und',0,1),('message','example_create_node',0,17,17,'und',0,1),('message','example_create_node',0,18,18,'und',0,1),('message','example_create_comment',0,19,19,'und',0,1),('message','example_user_register',0,20,20,'und',0,1),('message','example_create_comment',0,21,21,'und',0,1),('message','example_create_node',0,22,22,'und',0,1),('message','example_create_comment',0,23,23,'und',0,1),('message','example_create_node',0,24,24,'und',0,1),('message','example_create_node',0,25,25,'und',0,1),('message','example_create_node',0,26,26,'und',0,1),('message','example_create_node',0,27,27,'und',0,1),('message','example_create_node',0,28,28,'und',0,1),('message','example_create_node',0,29,29,'und',0,1),('message','example_create_node',0,30,30,'und',0,1),('message','example_create_node',0,31,31,'und',0,1),('message','example_create_node',0,32,32,'und',0,1),('message','example_create_node',0,33,33,'und',0,1),('message','example_create_node',0,34,34,'und',0,1),('message','example_create_node',0,35,35,'und',0,1),('message','example_create_node',0,36,36,'und',0,1),('message','example_create_node',0,37,37,'und',0,1),('message','example_create_node',0,38,38,'und',0,1),('message','example_create_node',0,40,40,'und',0,1),('message','example_create_node',0,41,41,'und',0,1),('message','example_create_node',0,42,42,'und',0,1),('message','example_create_node',0,43,43,'und',0,1),('message','example_create_node',0,44,44,'und',0,1),('message','example_create_node',0,45,45,'und',0,1),('message','example_create_node',0,46,46,'und',0,1),('message','example_create_node',0,47,47,'und',0,1),('message','example_create_node',0,48,48,'und',0,1),('message','example_create_node',0,49,49,'und',0,1),('message','example_create_node',0,50,50,'und',0,1),('message','example_create_node',0,51,51,'und',0,1),('message','example_create_node',0,52,52,'und',0,1),('message','example_create_node',0,53,53,'und',0,1),('message','example_create_comment',0,54,54,'und',0,1),('message','example_create_comment',0,55,55,'und',0,1),('message','example_create_comment',0,56,56,'und',0,1),('message','example_create_comment',0,57,57,'und',0,1),('message','example_create_node',0,58,58,'und',0,1),('message','example_create_comment',0,59,59,'und',0,1),('message','example_create_comment',0,60,60,'und',0,1),('message','example_create_comment',0,61,61,'und',0,1),('message','example_create_node',0,62,62,'und',0,1),('message','example_create_node',0,63,63,'und',0,1),('message','example_create_node',0,64,64,'und',0,1),('message','example_create_node',0,65,65,'und',0,1),('message','example_create_node',0,66,66,'und',0,1),('message','example_create_node',0,67,67,'und',0,1),('message','example_create_comment',0,68,68,'und',0,1),('message','example_create_comment',0,69,69,'und',0,1),('message','example_create_comment',0,70,70,'und',0,1),('message','example_create_comment',0,71,71,'und',0,1),('message','example_create_comment',0,72,72,'und',0,1),('message','example_create_comment',0,73,73,'und',0,1),('message','example_create_comment',0,74,74,'und',0,1),('message','example_create_comment',0,75,75,'und',0,1),('message','example_create_comment',0,76,76,'und',0,1),('message','example_create_comment',0,77,77,'und',0,1),('message','example_create_comment',0,78,78,'und',0,1),('message','example_user_register',0,79,79,'und',0,1),('message','example_create_comment',0,80,80,'und',0,1),('message','example_create_comment',0,81,81,'und',0,1),('message','example_create_comment',0,82,82,'und',0,1),('message','example_create_comment',0,83,83,'und',0,1),('message','example_create_comment',0,84,84,'und',0,1),('message','example_create_comment',0,85,85,'und',0,1),('message','example_create_comment',0,86,86,'und',0,1),('message','example_create_comment',0,87,87,'und',0,1),('message','example_create_comment',0,88,88,'und',0,1),('message','example_create_comment',0,89,89,'und',0,1),('message','example_create_comment',0,90,90,'und',0,1),('message','example_create_comment',0,91,91,'und',0,1),('message','example_create_comment',0,92,92,'und',0,1),('message','example_create_comment',0,93,93,'und',0,1),('message','example_create_comment',0,94,94,'und',0,1),('message','example_create_comment',0,95,95,'und',0,1),('message','example_create_comment',0,96,96,'und',0,1),('message','example_create_node',0,97,97,'und',0,1),('message','example_create_node',0,98,98,'und',0,1),('message','example_create_comment',0,99,99,'und',0,1),('message','example_create_comment',0,100,100,'und',0,1),('message','example_create_comment',0,101,101,'und',0,1),('message','example_create_node',0,102,102,'und',0,1),('message','example_create_comment',0,103,103,'und',0,1),('message','example_create_node',0,104,104,'und',0,1),('message','example_create_comment',0,105,105,'und',0,1),('message','example_create_comment',0,106,106,'und',0,1),('message','example_create_comment',0,107,107,'und',0,1),('message','example_create_comment',0,108,108,'und',0,1),('message','example_create_node',0,109,109,'und',0,1),('message','example_create_node',0,110,110,'und',0,1),('message','example_create_node',0,111,111,'und',0,1),('message','example_create_node',0,112,112,'und',0,1),('message','example_create_node',0,113,113,'und',0,1),('message','example_create_node',0,114,114,'und',0,1),('message','example_create_node',0,115,115,'und',0,1),('message','example_create_node',0,116,116,'und',0,1),('message','example_create_node',0,117,117,'und',0,1),('message','example_create_node',0,118,118,'und',0,1),('message','example_create_node',0,119,119,'und',0,1),('message','example_create_node',0,120,120,'und',0,1);
/*!40000 ALTER TABLE `field_revision_field_published` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `field_revision_field_section`
--

DROP TABLE IF EXISTS `field_revision_field_section`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_section` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_section_tid` int(10) unsigned DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_section_tid` (`field_section_tid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 11 (field_section)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_section`
--

LOCK TABLES `field_revision_field_section` WRITE;
/*!40000 ALTER TABLE `field_revision_field_section` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `field_revision_field_section` VALUES ('node','article',0,4,4,'und',0,29),('node','article',0,5,5,'und',0,28),('node','article',0,6,6,'und',0,30),('node','article',0,12,12,'und',0,27),('node','article',0,27,27,'und',0,30),('node','article',0,28,28,'und',0,28),('node','article',0,29,29,'und',0,29),('node','article',0,30,30,'und',0,30),('node','article',0,31,31,'und',0,32);
/*!40000 ALTER TABLE `field_revision_field_section` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `field_revision_field_tags`
--

DROP TABLE IF EXISTS `field_revision_field_tags`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_tags` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_tags_tid` int(10) unsigned DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_tags_tid` (`field_tags_tid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 3 (field_tags)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_tags`
--

LOCK TABLES `field_revision_field_tags` WRITE;
/*!40000 ALTER TABLE `field_revision_field_tags` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `field_revision_field_tags` VALUES ('node','article',0,4,4,'und',0,40),('node','article',0,4,4,'und',1,55),('node','article',0,4,4,'und',2,54),('node','article',0,5,5,'und',0,54),('node','article',0,5,5,'und',1,43),('node','article',0,5,5,'und',2,53),('node','article',0,6,6,'und',0,12),('node','article',0,6,6,'und',1,14),('node','blog',0,7,7,'und',0,47),('node','blog',0,8,8,'und',0,48),('node','blog',0,8,8,'und',1,49),('node','blog',0,9,9,'und',0,50),('node','blog',0,10,10,'und',0,16),('node','blog',0,11,11,'und',0,15),('node','blog',0,11,11,'und',1,17),('node','article',0,12,12,'und',0,18),('node','article',0,12,12,'und',1,19),('node','article',0,27,27,'und',0,51),('node','article',0,27,27,'und',1,52),('node','article',0,28,28,'und',0,42),('node','article',0,29,29,'und',0,33),('node','article',0,29,29,'und',1,34),('node','article',0,29,29,'und',2,46),('node','article',0,30,30,'und',0,34),('node','article',0,30,30,'und',1,35),('node','article',0,30,30,'und',2,45),('node','article',0,31,31,'und',0,36),('node','article',0,31,31,'und',1,42),('node','video',0,34,34,'und',0,37),('node','video',0,35,35,'und',0,37),('node','video',0,36,36,'und',0,37),('node','video',0,36,36,'und',1,38),('node','video',0,37,37,'und',0,37),('node','video',0,37,37,'und',1,39),('node','video',0,38,38,'und',0,37);
/*!40000 ALTER TABLE `field_revision_field_tags` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `field_revision_field_video_link`
--

DROP TABLE IF EXISTS `field_revision_field_video_link`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_video_link` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_video_link_video_url` varchar(512) DEFAULT '',
  `field_video_link_thumbnail_path` varchar(512) DEFAULT '',
  `field_video_link_video_data` longblob,
  `field_video_link_embed_code` varchar(1024) DEFAULT '',
  `field_video_link_description` text,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 13 (field_video_link)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_video_link`
--

LOCK TABLES `field_revision_field_video_link` WRITE;
/*!40000 ALTER TABLE `field_revision_field_video_link` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `field_revision_field_video_link` VALUES ('field_collection_item','field_extra_content',0,20,20,'und',0,'https://www.youtube.com/watch?v=lshNdiTvNMI','public://video_embed_field_thumbnails/youtube/lshNdiTvNMI.jpg','a:24:{s:9:\"xmlns$app\";s:26:\"http://www.w3.org/2007/app\";s:5:\"xmlns\";s:27:\"http://www.w3.org/2005/Atom\";s:11:\"xmlns$media\";s:29:\"http://search.yahoo.com/mrss/\";s:8:\"xmlns$gd\";s:32:\"http://schemas.google.com/g/2005\";s:8:\"xmlns$yt\";s:37:\"http://gdata.youtube.com/schemas/2007\";s:7:\"gd$etag\";s:28:\"W/\"DUADQ347eCp7I2A9XRZbEUg.\"\";s:2:\"id\";s:38:\"tag:youtube.com,2008:video:lshNdiTvNMI\";s:9:\"published\";s:24:\"2013-08-14T14:39:32.000Z\";s:7:\"updated\";s:24:\"2014-08-16T02:56:12.000Z\";s:11:\"app$control\";a:1:{s:8:\"yt$state\";s:41:\"Syndication of this video was restricted.\";}s:8:\"category\";a:2:{i:0;a:2:{s:6:\"scheme\";s:37:\"http://schemas.google.com/g/2005#kind\";s:4:\"term\";s:43:\"http://gdata.youtube.com/schemas/2007#video\";}i:1;a:3:{s:6:\"scheme\";s:52:\"http://gdata.youtube.com/schemas/2007/categories.cat\";s:4:\"term\";s:6:\"Travel\";s:5:\"label\";s:15:\"Travel & Events\";}}s:5:\"title\";s:25:\"Brasil Travel Video Guide\";s:7:\"content\";a:2:{s:4:\"type\";s:29:\"application/x-shockwave-flash\";s:3:\"src\";s:73:\"http://www.youtube.com/v/lshNdiTvNMI?version=3&f=videos&app=youtube_gdata\";}s:4:\"link\";a:4:{i:0;a:3:{s:3:\"rel\";s:9:\"alternate\";s:4:\"type\";s:9:\"text/html\";s:4:\"href\";s:64:\"http://www.youtube.com/watch?v=lshNdiTvNMI&feature=youtube_gdata\";}i:1;a:3:{s:3:\"rel\";s:51:\"http://gdata.youtube.com/schemas/2007#video.related\";s:4:\"type\";s:20:\"application/atom+xml\";s:4:\"href\";s:65:\"http://gdata.youtube.com/feeds/api/videos/lshNdiTvNMI/related?v=2\";}i:2;a:3:{s:3:\"rel\";s:46:\"http://gdata.youtube.com/schemas/2007#uploader\";s:4:\"type\";s:20:\"application/atom+xml\";s:4:\"href\";s:67:\"http://gdata.youtube.com/feeds/api/users/3o_gaqvLoPSRVMc2GmkDrg?v=2\";}i:3;a:3:{s:3:\"rel\";s:4:\"self\";s:4:\"type\";s:20:\"application/atom+xml\";s:4:\"href\";s:57:\"http://gdata.youtube.com/feeds/api/videos/lshNdiTvNMI?v=2\";}}s:6:\"author\";a:1:{i:0;a:3:{s:4:\"name\";s:13:\"Expoza Travel\";s:3:\"uri\";s:53:\"http://gdata.youtube.com/feeds/api/users/ExpozaTravel\";s:9:\"yt$userId\";s:22:\"3o_gaqvLoPSRVMc2GmkDrg\";}}s:16:\"yt$accessControl\";a:8:{i:0;a:2:{s:6:\"action\";s:7:\"comment\";s:10:\"permission\";s:7:\"allowed\";}i:1;a:2:{s:6:\"action\";s:11:\"commentVote\";s:10:\"permission\";s:7:\"allowed\";}i:2;a:2:{s:6:\"action\";s:12:\"videoRespond\";s:10:\"permission\";s:9:\"moderated\";}i:3;a:2:{s:6:\"action\";s:4:\"rate\";s:10:\"permission\";s:7:\"allowed\";}i:4;a:2:{s:6:\"action\";s:5:\"embed\";s:10:\"permission\";s:7:\"allowed\";}i:5;a:2:{s:6:\"action\";s:4:\"list\";s:10:\"permission\";s:7:\"allowed\";}i:6;a:2:{s:6:\"action\";s:8:\"autoPlay\";s:10:\"permission\";s:7:\"allowed\";}i:7;a:2:{s:6:\"action\";s:9:\"syndicate\";s:10:\"permission\";s:7:\"allowed\";}}s:11:\"gd$comments\";a:1:{s:11:\"gd$feedLink\";a:3:{s:3:\"rel\";s:46:\"http://gdata.youtube.com/schemas/2007#comments\";s:4:\"href\";s:66:\"http://gdata.youtube.com/feeds/api/videos/lshNdiTvNMI/comments?v=2\";s:9:\"countHint\";i:24;}}s:5:\"yt$hd\";a:0:{}s:11:\"media$group\";a:14:{s:14:\"media$category\";a:1:{i:0;s:6:\"Travel\";}s:13:\"media$content\";a:1:{i:0;a:7:{s:3:\"url\";s:73:\"http://www.youtube.com/v/lshNdiTvNMI?version=3&f=videos&app=youtube_gdata\";s:4:\"type\";s:29:\"application/x-shockwave-flash\";s:6:\"medium\";s:5:\"video\";s:9:\"isDefault\";s:4:\"true\";s:10:\"expression\";s:4:\"full\";s:8:\"duration\";i:3095;s:9:\"yt$format\";i:5;}}s:12:\"media$credit\";a:1:{i:0;s:12:\"expozatravel\";}s:17:\"media$description\";s:160:\"Travel video about destination Brasil.\nBrazil is synonymous with sunshine, samba and exotic nature, a dream destination full of both adventure and constant fun!\";s:14:\"media$keywords\";a:0:{}s:13:\"media$license\";s:7:\"youtube\";s:12:\"media$player\";a:1:{s:3:\"url\";s:71:\"http://www.youtube.com/watch?v=lshNdiTvNMI&feature=youtube_gdata_player\";}s:15:\"media$thumbnail\";a:7:{i:0;a:5:{s:3:\"url\";s:45:\"http://i.ytimg.com/vi/lshNdiTvNMI/default.jpg\";s:6:\"height\";i:90;s:5:\"width\";i:120;s:4:\"time\";s:12:\"00:25:47.500\";s:7:\"yt$name\";s:7:\"default\";}i:1;a:4:{s:3:\"url\";s:47:\"http://i.ytimg.com/vi/lshNdiTvNMI/mqdefault.jpg\";s:6:\"height\";i:180;s:5:\"width\";i:320;s:7:\"yt$name\";s:9:\"mqdefault\";}i:2;a:4:{s:3:\"url\";s:47:\"http://i.ytimg.com/vi/lshNdiTvNMI/hqdefault.jpg\";s:6:\"height\";i:360;s:5:\"width\";i:480;s:7:\"yt$name\";s:9:\"hqdefault\";}i:3;a:4:{s:3:\"url\";s:47:\"http://i.ytimg.com/vi/lshNdiTvNMI/sddefault.jpg\";s:6:\"height\";i:480;s:5:\"width\";i:640;s:7:\"yt$name\";s:9:\"sddefault\";}i:4;a:5:{s:3:\"url\";s:39:\"http://i.ytimg.com/vi/lshNdiTvNMI/1.jpg\";s:6:\"height\";i:90;s:5:\"width\";i:120;s:4:\"time\";s:12:\"00:12:53.750\";s:7:\"yt$name\";s:5:\"start\";}i:5;a:5:{s:3:\"url\";s:39:\"http://i.ytimg.com/vi/lshNdiTvNMI/2.jpg\";s:6:\"height\";i:90;s:5:\"width\";i:120;s:4:\"time\";s:12:\"00:25:47.500\";s:7:\"yt$name\";s:6:\"middle\";}i:6;a:5:{s:3:\"url\";s:39:\"http://i.ytimg.com/vi/lshNdiTvNMI/3.jpg\";s:6:\"height\";i:90;s:5:\"width\";i:120;s:4:\"time\";s:12:\"00:38:41.250\";s:7:\"yt$name\";s:3:\"end\";}}s:11:\"media$title\";s:25:\"Brasil Travel Video Guide\";s:14:\"yt$aspectRatio\";s:10:\"widescreen\";s:11:\"yt$duration\";a:1:{s:7:\"seconds\";s:4:\"3095\";}s:11:\"yt$uploaded\";s:24:\"2013-08-14T14:39:32.000Z\";s:13:\"yt$uploaderId\";s:24:\"UC3o_gaqvLoPSRVMc2GmkDrg\";s:10:\"yt$videoid\";s:11:\"lshNdiTvNMI\";}s:9:\"gd$rating\";a:5:{s:7:\"average\";d:4.7866669999999996;s:3:\"max\";i:5;s:3:\"min\";i:1;s:9:\"numRaters\";i:150;s:3:\"rel\";s:40:\"http://schemas.google.com/g/2005#overall\";}s:13:\"yt$statistics\";a:2:{s:13:\"favoriteCount\";s:1:\"0\";s:9:\"viewCount\";s:5:\"44850\";}s:9:\"yt$rating\";a:2:{s:11:\"numDislikes\";s:1:\"8\";s:8:\"numLikes\";s:3:\"142\";}s:5:\"terms\";a:1:{i:0;s:6:\"Travel\";}s:7:\"handler\";s:7:\"youtube\";}',NULL,NULL),('field_collection_item','field_extra_content',0,24,24,'und',0,'https://www.youtube.com/watch?v=-cUWFLBZU5I','public://video_embed_field_thumbnails/youtube/-cUWFLBZU5I.jpg','a:1:{s:7:\"handler\";s:7:\"youtube\";}',NULL,NULL),('node','video',0,34,34,'und',0,'http://vimeo.com/60280914','public://video_embed_field_thumbnails/vimeo/60280914.jpg','a:25:{s:2:\"id\";i:60280914;s:5:\"title\";s:30:\"Margaret - Thank You Very Much\";s:11:\"description\";s:44:\"https://www.facebook.com/MARGARETMUSICONLINE\";s:3:\"url\";s:25:\"http://vimeo.com/60280914\";s:11:\"upload_date\";s:19:\"2013-02-22 15:10:00\";s:10:\"mobile_url\";s:27:\"http://vimeo.com/m/60280914\";s:15:\"thumbnail_small\";s:48:\"http://i.vimeocdn.com/video/418803220_100x75.jpg\";s:16:\"thumbnail_medium\";s:49:\"http://i.vimeocdn.com/video/418803220_200x150.jpg\";s:15:\"thumbnail_large\";s:45:\"http://i.vimeocdn.com/video/418803220_640.jpg\";s:7:\"user_id\";i:9235811;s:9:\"user_name\";s:15:\"Extensive Music\";s:8:\"user_url\";s:28:\"http://vimeo.com/user9235811\";s:19:\"user_portrait_small\";s:134:\"http://www.gravatar.com/avatar/ac263e084a6d75f8b9d4362890f06497?d=http%3A%2F%2Fi.vimeocdn.com%2Fportrait%2Fdefault-gray_30x30.png&s=30\";s:20:\"user_portrait_medium\";s:134:\"http://www.gravatar.com/avatar/ac263e084a6d75f8b9d4362890f06497?d=http%3A%2F%2Fi.vimeocdn.com%2Fportrait%2Fdefault-gray_75x75.png&s=75\";s:19:\"user_portrait_large\";s:137:\"http://www.gravatar.com/avatar/ac263e084a6d75f8b9d4362890f06497?d=http%3A%2F%2Fi.vimeocdn.com%2Fportrait%2Fdefault-gray_100x100.png&s=100\";s:18:\"user_portrait_huge\";s:137:\"http://www.gravatar.com/avatar/ac263e084a6d75f8b9d4362890f06497?d=http%3A%2F%2Fi.vimeocdn.com%2Fportrait%2Fdefault-gray_300x300.png&s=300\";s:21:\"stats_number_of_likes\";i:609;s:21:\"stats_number_of_plays\";i:1111457;s:24:\"stats_number_of_comments\";i:32;s:8:\"duration\";i:207;s:5:\"width\";i:1280;s:6:\"height\";i:720;s:4:\"tags\";s:53:\"margaret, thank you very much, thank, you, very, much\";s:13:\"embed_privacy\";s:8:\"anywhere\";s:7:\"handler\";s:5:\"vimeo\";}',NULL,NULL),('node','video',0,35,35,'und',0,'https://www.youtube.com/watch?v=FOIjvHjK0Rw','public://video_embed_field_thumbnails/youtube/FOIjvHjK0Rw.jpg','a:22:{s:5:\"xmlns\";s:27:\"http://www.w3.org/2005/Atom\";s:11:\"xmlns$media\";s:29:\"http://search.yahoo.com/mrss/\";s:8:\"xmlns$gd\";s:32:\"http://schemas.google.com/g/2005\";s:8:\"xmlns$yt\";s:37:\"http://gdata.youtube.com/schemas/2007\";s:7:\"gd$etag\";s:28:\"W/\"D08DRn47eCp7I2A9XRZUGE0.\"\";s:2:\"id\";s:38:\"tag:youtube.com,2008:video:FOIjvHjK0Rw\";s:9:\"published\";s:24:\"2013-03-01T05:40:13.000Z\";s:7:\"updated\";s:24:\"2014-08-12T01:11:17.000Z\";s:8:\"category\";a:2:{i:0;a:2:{s:6:\"scheme\";s:37:\"http://schemas.google.com/g/2005#kind\";s:4:\"term\";s:43:\"http://gdata.youtube.com/schemas/2007#video\";}i:1;a:3:{s:6:\"scheme\";s:52:\"http://gdata.youtube.com/schemas/2007/categories.cat\";s:4:\"term\";s:5:\"Music\";s:5:\"label\";s:5:\"Music\";}}s:5:\"title\";s:93:\"Beautiful Light Music - easy smooth inspirational - long playlist by relaxdaily: Ocean Breeze\";s:7:\"content\";a:2:{s:4:\"type\";s:29:\"application/x-shockwave-flash\";s:3:\"src\";s:73:\"http://www.youtube.com/v/FOIjvHjK0Rw?version=3&f=videos&app=youtube_gdata\";}s:4:\"link\";a:5:{i:0;a:3:{s:3:\"rel\";s:9:\"alternate\";s:4:\"type\";s:9:\"text/html\";s:4:\"href\";s:64:\"http://www.youtube.com/watch?v=FOIjvHjK0Rw&feature=youtube_gdata\";}i:1;a:3:{s:3:\"rel\";s:51:\"http://gdata.youtube.com/schemas/2007#video.related\";s:4:\"type\";s:20:\"application/atom+xml\";s:4:\"href\";s:65:\"http://gdata.youtube.com/feeds/api/videos/FOIjvHjK0Rw/related?v=2\";}i:2;a:3:{s:3:\"rel\";s:44:\"http://gdata.youtube.com/schemas/2007#mobile\";s:4:\"type\";s:9:\"text/html\";s:4:\"href\";s:42:\"http://m.youtube.com/details?v=FOIjvHjK0Rw\";}i:3;a:3:{s:3:\"rel\";s:46:\"http://gdata.youtube.com/schemas/2007#uploader\";s:4:\"type\";s:20:\"application/atom+xml\";s:4:\"href\";s:67:\"http://gdata.youtube.com/feeds/api/users/c9EzBNAtdnNiDrMw5CAxUw?v=2\";}i:4;a:3:{s:3:\"rel\";s:4:\"self\";s:4:\"type\";s:20:\"application/atom+xml\";s:4:\"href\";s:57:\"http://gdata.youtube.com/feeds/api/videos/FOIjvHjK0Rw?v=2\";}}s:6:\"author\";a:1:{i:0;a:3:{s:4:\"name\";s:10:\"relaxdaily\";s:3:\"uri\";s:51:\"http://gdata.youtube.com/feeds/api/users/relaxdaily\";s:9:\"yt$userId\";s:22:\"c9EzBNAtdnNiDrMw5CAxUw\";}}s:16:\"yt$accessControl\";a:8:{i:0;a:2:{s:6:\"action\";s:7:\"comment\";s:10:\"permission\";s:7:\"allowed\";}i:1;a:2:{s:6:\"action\";s:11:\"commentVote\";s:10:\"permission\";s:7:\"allowed\";}i:2;a:2:{s:6:\"action\";s:12:\"videoRespond\";s:10:\"permission\";s:9:\"moderated\";}i:3;a:2:{s:6:\"action\";s:4:\"rate\";s:10:\"permission\";s:7:\"allowed\";}i:4;a:2:{s:6:\"action\";s:5:\"embed\";s:10:\"permission\";s:7:\"allowed\";}i:5;a:2:{s:6:\"action\";s:4:\"list\";s:10:\"permission\";s:7:\"allowed\";}i:6;a:2:{s:6:\"action\";s:8:\"autoPlay\";s:10:\"permission\";s:7:\"allowed\";}i:7;a:2:{s:6:\"action\";s:9:\"syndicate\";s:10:\"permission\";s:7:\"allowed\";}}s:11:\"gd$comments\";a:1:{s:11:\"gd$feedLink\";a:3:{s:3:\"rel\";s:46:\"http://gdata.youtube.com/schemas/2007#comments\";s:4:\"href\";s:66:\"http://gdata.youtube.com/feeds/api/videos/FOIjvHjK0Rw/comments?v=2\";s:9:\"countHint\";i:5007;}}s:5:\"yt$hd\";a:0:{}s:11:\"media$group\";a:14:{s:14:\"media$category\";a:1:{i:0;s:5:\"Music\";}s:13:\"media$content\";a:3:{i:0;a:7:{s:3:\"url\";s:73:\"http://www.youtube.com/v/FOIjvHjK0Rw?version=3&f=videos&app=youtube_gdata\";s:4:\"type\";s:29:\"application/x-shockwave-flash\";s:6:\"medium\";s:5:\"video\";s:9:\"isDefault\";s:4:\"true\";s:10:\"expression\";s:4:\"full\";s:8:\"duration\";i:7894;s:9:\"yt$format\";i:5;}i:1;a:6:{s:3:\"url\";s:102:\"rtsp://r7---sn-p5qlsu7z.c.youtube.com/CiILENy73wIaGQkc0cp4vCPiFBMYDSANFEgGUgZ2aWRlb3MM/0/0/0/video.3gp\";s:4:\"type\";s:10:\"video/3gpp\";s:6:\"medium\";s:5:\"video\";s:10:\"expression\";s:4:\"full\";s:8:\"duration\";i:7894;s:9:\"yt$format\";i:1;}i:2;a:6:{s:3:\"url\";s:102:\"rtsp://r7---sn-p5qlsu7z.c.youtube.com/CiILENy73wIaGQkc0cp4vCPiFBMYESARFEgGUgZ2aWRlb3MM/0/0/0/video.3gp\";s:4:\"type\";s:10:\"video/3gpp\";s:6:\"medium\";s:5:\"video\";s:10:\"expression\";s:4:\"full\";s:8:\"duration\";i:7894;s:9:\"yt$format\";i:6;}}s:12:\"media$credit\";a:1:{i:0;s:10:\"relaxdaily\";}s:17:\"media$description\";s:1575:\"Listen to a 2h long playlist with relaxdaily music. Beautiful, light instrumental music with an easy, smooth and inspirational attitude. You can download my music at http://relaxdaily.net. Or simply enjoy this full length version here on YouTube ;)\nA music mix I made up from my own releases from the last 1,5 years. Think of it as another 2h relax radio playlist. For more music, mixes and playlists join me at my website or my YouTube channel. \n- Michael (relaxdaily musician)\n\nRelaxdaily\'s background music instrumentals: beautiful, light, inspirational music that can be used as a soundtrack for multiple activities. Depending on your interest you might use my music in your relax radio playlist, as yoga music, as music while you\'re studying, doing homework, working (mentally, creatively), reading, writing, while thinking or reflecting, dreaming, reviewing, making future plans. Some use it as \"sleep music\" (I personally think there\'s better sleep music out there, but it seems to work ;) Some even listen to it in their minecraft music playlist. Call it chillout, smooth, ambient, New Age, instrumental, or background music -- this is not as much about a genre as it is about a feeling. A way of life. With the relaxdaily project, I try to take a little heat from our (generally) too busy lives. I try to deliver a soundtrack for you, when you feel the need for some positive, calming, inspirational tunes.\n\nThe simple (repetitive) video shows some grass waving in the wind at the pacific coast in California, just a few miles south of San Fran.\n\n© 2013, relaxdaily\";s:14:\"media$keywords\";a:0:{}s:13:\"media$license\";s:7:\"youtube\";s:12:\"media$player\";a:1:{s:3:\"url\";s:71:\"http://www.youtube.com/watch?v=FOIjvHjK0Rw&feature=youtube_gdata_player\";}s:15:\"media$thumbnail\";a:7:{i:0;a:5:{s:3:\"url\";s:45:\"http://i.ytimg.com/vi/FOIjvHjK0Rw/default.jpg\";s:6:\"height\";i:90;s:5:\"width\";i:120;s:4:\"time\";s:8:\"01:05:47\";s:7:\"yt$name\";s:7:\"default\";}i:1;a:4:{s:3:\"url\";s:47:\"http://i.ytimg.com/vi/FOIjvHjK0Rw/mqdefault.jpg\";s:6:\"height\";i:180;s:5:\"width\";i:320;s:7:\"yt$name\";s:9:\"mqdefault\";}i:2;a:4:{s:3:\"url\";s:47:\"http://i.ytimg.com/vi/FOIjvHjK0Rw/hqdefault.jpg\";s:6:\"height\";i:360;s:5:\"width\";i:480;s:7:\"yt$name\";s:9:\"hqdefault\";}i:3;a:4:{s:3:\"url\";s:47:\"http://i.ytimg.com/vi/FOIjvHjK0Rw/sddefault.jpg\";s:6:\"height\";i:480;s:5:\"width\";i:640;s:7:\"yt$name\";s:9:\"sddefault\";}i:4;a:5:{s:3:\"url\";s:39:\"http://i.ytimg.com/vi/FOIjvHjK0Rw/1.jpg\";s:6:\"height\";i:90;s:5:\"width\";i:120;s:4:\"time\";s:12:\"00:32:53.500\";s:7:\"yt$name\";s:5:\"start\";}i:5;a:5:{s:3:\"url\";s:39:\"http://i.ytimg.com/vi/FOIjvHjK0Rw/2.jpg\";s:6:\"height\";i:90;s:5:\"width\";i:120;s:4:\"time\";s:8:\"01:05:47\";s:7:\"yt$name\";s:6:\"middle\";}i:6;a:5:{s:3:\"url\";s:39:\"http://i.ytimg.com/vi/FOIjvHjK0Rw/3.jpg\";s:6:\"height\";i:90;s:5:\"width\";i:120;s:4:\"time\";s:12:\"01:38:40.500\";s:7:\"yt$name\";s:3:\"end\";}}s:11:\"media$title\";s:93:\"Beautiful Light Music - easy smooth inspirational - long playlist by relaxdaily: Ocean Breeze\";s:14:\"yt$aspectRatio\";s:10:\"widescreen\";s:11:\"yt$duration\";a:1:{s:7:\"seconds\";s:4:\"7894\";}s:11:\"yt$uploaded\";s:24:\"2013-03-01T05:40:13.000Z\";s:13:\"yt$uploaderId\";s:24:\"UCc9EzBNAtdnNiDrMw5CAxUw\";s:10:\"yt$videoid\";s:11:\"FOIjvHjK0Rw\";}s:9:\"gd$rating\";a:5:{s:7:\"average\";d:4.8578634000000003;s:3:\"max\";i:5;s:3:\"min\";i:1;s:9:\"numRaters\";i:46181;s:3:\"rel\";s:40:\"http://schemas.google.com/g/2005#overall\";}s:13:\"yt$statistics\";a:2:{s:13:\"favoriteCount\";s:1:\"0\";s:9:\"viewCount\";s:8:\"10394683\";}s:9:\"yt$rating\";a:2:{s:11:\"numDislikes\";s:4:\"1641\";s:8:\"numLikes\";s:5:\"44540\";}s:5:\"terms\";a:1:{i:0;s:5:\"Music\";}s:7:\"handler\";s:7:\"youtube\";}',NULL,NULL),('node','video',0,36,36,'und',0,'https://www.youtube.com/watch?v=0VqTwnAuHws','public://video_embed_field_thumbnails/youtube/0VqTwnAuHws.jpg','a:26:{s:9:\"xmlns$app\";s:26:\"http://www.w3.org/2007/app\";s:5:\"xmlns\";s:27:\"http://www.w3.org/2005/Atom\";s:11:\"xmlns$media\";s:29:\"http://search.yahoo.com/mrss/\";s:8:\"xmlns$gd\";s:32:\"http://schemas.google.com/g/2005\";s:8:\"xmlns$yt\";s:37:\"http://gdata.youtube.com/schemas/2007\";s:7:\"gd$etag\";s:28:\"W/\"D04HRH47eCp7I2A9XRZUGE0.\"\";s:2:\"id\";s:38:\"tag:youtube.com,2008:video:0VqTwnAuHws\";s:9:\"published\";s:24:\"2012-07-18T19:54:47.000Z\";s:7:\"updated\";s:24:\"2014-08-12T01:12:15.000Z\";s:11:\"app$control\";a:1:{s:8:\"yt$state\";s:41:\"Syndication of this video was restricted.\";}s:8:\"category\";a:2:{i:0;a:2:{s:6:\"scheme\";s:37:\"http://schemas.google.com/g/2005#kind\";s:4:\"term\";s:43:\"http://gdata.youtube.com/schemas/2007#video\";}i:1;a:3:{s:6:\"scheme\";s:52:\"http://gdata.youtube.com/schemas/2007/categories.cat\";s:4:\"term\";s:5:\"Music\";s:5:\"label\";s:5:\"Music\";}}s:5:\"title\";s:79:\"One Direction - What Makes You Beautiful (5 Piano Guys, 1 piano) - ThePianoGuys\";s:7:\"content\";a:2:{s:4:\"type\";s:29:\"application/x-shockwave-flash\";s:3:\"src\";s:73:\"http://www.youtube.com/v/0VqTwnAuHws?version=3&f=videos&app=youtube_gdata\";}s:4:\"link\";a:4:{i:0;a:3:{s:3:\"rel\";s:9:\"alternate\";s:4:\"type\";s:9:\"text/html\";s:4:\"href\";s:64:\"http://www.youtube.com/watch?v=0VqTwnAuHws&feature=youtube_gdata\";}i:1;a:3:{s:3:\"rel\";s:51:\"http://gdata.youtube.com/schemas/2007#video.related\";s:4:\"type\";s:20:\"application/atom+xml\";s:4:\"href\";s:65:\"http://gdata.youtube.com/feeds/api/videos/0VqTwnAuHws/related?v=2\";}i:2;a:3:{s:3:\"rel\";s:46:\"http://gdata.youtube.com/schemas/2007#uploader\";s:4:\"type\";s:20:\"application/atom+xml\";s:4:\"href\";s:67:\"http://gdata.youtube.com/feeds/api/users/mKurapML4BF9Bjtj4RbvXw?v=2\";}i:3;a:3:{s:3:\"rel\";s:4:\"self\";s:4:\"type\";s:20:\"application/atom+xml\";s:4:\"href\";s:57:\"http://gdata.youtube.com/feeds/api/videos/0VqTwnAuHws?v=2\";}}s:6:\"author\";a:1:{i:0;a:3:{s:4:\"name\";s:12:\"ThePianoGuys\";s:3:\"uri\";s:53:\"http://gdata.youtube.com/feeds/api/users/ThePianoGuys\";s:9:\"yt$userId\";s:22:\"mKurapML4BF9Bjtj4RbvXw\";}}s:16:\"yt$accessControl\";a:8:{i:0;a:2:{s:6:\"action\";s:7:\"comment\";s:10:\"permission\";s:7:\"allowed\";}i:1;a:2:{s:6:\"action\";s:11:\"commentVote\";s:10:\"permission\";s:7:\"allowed\";}i:2;a:2:{s:6:\"action\";s:12:\"videoRespond\";s:10:\"permission\";s:9:\"moderated\";}i:3;a:2:{s:6:\"action\";s:4:\"rate\";s:10:\"permission\";s:7:\"allowed\";}i:4;a:2:{s:6:\"action\";s:5:\"embed\";s:10:\"permission\";s:7:\"allowed\";}i:5;a:2:{s:6:\"action\";s:4:\"list\";s:10:\"permission\";s:7:\"allowed\";}i:6;a:2:{s:6:\"action\";s:8:\"autoPlay\";s:10:\"permission\";s:7:\"allowed\";}i:7;a:2:{s:6:\"action\";s:9:\"syndicate\";s:10:\"permission\";s:6:\"denied\";}}s:11:\"gd$comments\";a:1:{s:11:\"gd$feedLink\";a:3:{s:3:\"rel\";s:46:\"http://gdata.youtube.com/schemas/2007#comments\";s:4:\"href\";s:66:\"http://gdata.youtube.com/feeds/api/videos/0VqTwnAuHws/comments?v=2\";s:9:\"countHint\";i:54006;}}s:5:\"yt$hd\";a:0:{}s:11:\"media$group\";a:14:{s:14:\"media$category\";a:1:{i:0;s:5:\"Music\";}s:13:\"media$content\";a:1:{i:0;a:7:{s:3:\"url\";s:73:\"http://www.youtube.com/v/0VqTwnAuHws?version=3&f=videos&app=youtube_gdata\";s:4:\"type\";s:29:\"application/x-shockwave-flash\";s:6:\"medium\";s:5:\"video\";s:9:\"isDefault\";s:4:\"true\";s:10:\"expression\";s:4:\"full\";s:8:\"duration\";i:201;s:9:\"yt$format\";i:5;}}s:12:\"media$credit\";a:1:{i:0;s:12:\"thepianoguys\";}s:17:\"media$description\";s:4303:\"We\'re on Tour! http://smarturl.it/tpgtour\nBuy Sheet Music: http://smarturl.it/Sheet_Music\nNew Album here: http://smarturl.it/NewAlbum\nBuy song here: http://smarturl.it/WMYB\n________________________\n\nSubscribe to our main channel: http://smarturl.it/TPGsubscribe1\nSubscribe to our BTS channel: http://smarturl.it/TPGsubscribe2\nFollow us on Facebook: http://www.facebook.com/PianoGuys\nFollow us on Twitter: http://www.twitter.com/PianoGuys\n________________________\n\nGet PianoGuys T-Shirts, Wristbands, Sheetmusic here: http://thepianoguys.com\n\n**ALL THE SOUNDS YOU HEAR WERE CREATED BY THE PIANO AND ONE CELLO BOW** (WITH SOME VOCALS AT THE END)\n\nSTORY BEHIND THE SONG\nThe idea: A couple months ago the 5 of us were gathered round a piano prepping for a video shoot scheduled for that day. We were brainstorming ideas when one of us (can\'t remember who!) got off task and starting flicking a piano string. Since all of us are poster children for ADHD, it wasn\'t long before ALL of us had joined in -- banging out a beat, plucking a string, or hitting keys. The brainstorming meeting had been sabotaged beyond repair, but another music video idea was born!\n\nThe song: We went through several song possibilities before landing on \"What Makes You Beautiful\" by One Direction. We like this song because its catchy and the music, lyrics, and video passed our \"sesame street\" test (meaning family friendly). We thought about the ramifications of taking on a teenybopper boy band tune as five middle-aged married guys who are desperately holding on to their hairlines. One of us even has a son older than the guys in One Direction (we won\'t say who) :-) BUT you know us -- we love a good challenge! This one was so fun to write that the \"challenge\" part of it never was felt. We just acted like kids playing a piano and it totally worked! :-) After we figured out the main \"techniques\" of playing the piano unconventionally we loved experimenting with swapping out chords and throwing the structure of the song around until it clicked.\n\nThe location: Where to film? Fitting in video shoots between touring, writing, recording, editing, and spending time with family has always been a challenge. Let\'s be honest, even getting all 5 of us in the same place at the same time has been a challenge! We had a big sold-out show at the Sandy, Utah Amphitheater. We all determined to be at the show and film the video right on stage sometime between sound check and the performance. Sounds like a good idea right? Well...because of a lot of factors, including weather (we had a huge storm sweep in and knock everything down on stage during sound check) the only time we had to film was between the hours of 2AM - 7AM the morning of the concert. In the video at 2:30 you can see the morning light start breaking -- we literally played into the sunrise! :-) \n\nMany thanks to the awesome guys at Annex Recording and Giles Reaves (engineer) for letting us record at their studio. Check them out at http://www.annexrecording.com \n\nThanks to Sandy Amphitheater http://www.sandyarts.com/sandy-amphitheater/home.html for letting us film this video on their stage. They were so great to work with and we\'ve performed so many times there the staff are all old friends (especially you, Mearle!)\n\nAnd thanks to Cole Adams, the lighting genius - who hung out all night allowing us to pull an all-nighter to film this.\n\nCREDITS\n\"What Makes You Beautiful\" written by Rami Yacoubm Carl Falk, and Savan Kotecha\nPublished by KOBALT MUSIC PUB AMERICA OBO RAMI PRODUCTIONS, AIR CHRYSALIS SCANDINAVIA AB, EMI APRIL MUSIC INC OBO MR KANANI SONGS, EMI APRIL MUSIC INC \nArrangement written and produced by Al van der Beek, Jon Schmidt, Steven Sharp Nelson, and Giles Reaves\nPerformed by ThePianoGuys: Paul Anderson (videographer/video producer), Tel Stewart (videographer/editor), Al van der Beek (music producer), Jon Schmidt (pianist), Steven Sharp Nelson (cellist)\nVocals: Al van der Beek, Steven Sharp Nelson, Jon Schmidt\nPiano recorded by Giles Reaves at Annex Recording Studios\nAdditional Piano and vocals recorded by Al van der Beek at TPG Studios\nMixed and Mastered by Al van der Beek at TPG Studios\nVideo filmed on the stage of Sandy Amphitheatre in Sandy, Utah USA\nLighting by Cole Adams\nVideo produced by Paul Anderson and Tel Stewart\";s:14:\"media$keywords\";a:0:{}s:13:\"media$license\";s:7:\"youtube\";s:12:\"media$player\";a:1:{s:3:\"url\";s:71:\"http://www.youtube.com/watch?v=0VqTwnAuHws&feature=youtube_gdata_player\";}s:15:\"media$thumbnail\";a:7:{i:0;a:5:{s:3:\"url\";s:45:\"http://i.ytimg.com/vi/0VqTwnAuHws/default.jpg\";s:6:\"height\";i:90;s:5:\"width\";i:120;s:4:\"time\";s:12:\"00:01:40.500\";s:7:\"yt$name\";s:7:\"default\";}i:1;a:4:{s:3:\"url\";s:47:\"http://i.ytimg.com/vi/0VqTwnAuHws/mqdefault.jpg\";s:6:\"height\";i:180;s:5:\"width\";i:320;s:7:\"yt$name\";s:9:\"mqdefault\";}i:2;a:4:{s:3:\"url\";s:47:\"http://i.ytimg.com/vi/0VqTwnAuHws/hqdefault.jpg\";s:6:\"height\";i:360;s:5:\"width\";i:480;s:7:\"yt$name\";s:9:\"hqdefault\";}i:3;a:4:{s:3:\"url\";s:47:\"http://i.ytimg.com/vi/0VqTwnAuHws/sddefault.jpg\";s:6:\"height\";i:480;s:5:\"width\";i:640;s:7:\"yt$name\";s:9:\"sddefault\";}i:4;a:5:{s:3:\"url\";s:39:\"http://i.ytimg.com/vi/0VqTwnAuHws/1.jpg\";s:6:\"height\";i:90;s:5:\"width\";i:120;s:4:\"time\";s:12:\"00:00:50.250\";s:7:\"yt$name\";s:5:\"start\";}i:5;a:5:{s:3:\"url\";s:39:\"http://i.ytimg.com/vi/0VqTwnAuHws/2.jpg\";s:6:\"height\";i:90;s:5:\"width\";i:120;s:4:\"time\";s:12:\"00:01:40.500\";s:7:\"yt$name\";s:6:\"middle\";}i:6;a:5:{s:3:\"url\";s:39:\"http://i.ytimg.com/vi/0VqTwnAuHws/3.jpg\";s:6:\"height\";i:90;s:5:\"width\";i:120;s:4:\"time\";s:12:\"00:02:30.750\";s:7:\"yt$name\";s:3:\"end\";}}s:11:\"media$title\";s:79:\"One Direction - What Makes You Beautiful (5 Piano Guys, 1 piano) - ThePianoGuys\";s:14:\"yt$aspectRatio\";s:10:\"widescreen\";s:11:\"yt$duration\";a:1:{s:7:\"seconds\";s:3:\"201\";}s:11:\"yt$uploaded\";s:24:\"2012-07-18T19:54:47.000Z\";s:13:\"yt$uploaderId\";s:24:\"UCmKurapML4BF9Bjtj4RbvXw\";s:10:\"yt$videoid\";s:11:\"0VqTwnAuHws\";}s:9:\"gd$rating\";a:5:{s:7:\"average\";d:4.9567829999999997;s:3:\"max\";i:5;s:3:\"min\";i:1;s:9:\"numRaters\";i:444639;s:3:\"rel\";s:40:\"http://schemas.google.com/g/2005#overall\";}s:11:\"yt$recorded\";s:10:\"2012-07-18\";s:13:\"yt$statistics\";a:2:{s:13:\"favoriteCount\";s:1:\"0\";s:9:\"viewCount\";s:8:\"34107215\";}s:9:\"yt$threed\";a:1:{s:6:\"source\";s:9:\"converted\";}s:9:\"yt$rating\";a:2:{s:11:\"numDislikes\";s:4:\"4804\";s:8:\"numLikes\";s:6:\"439835\";}s:5:\"terms\";a:1:{i:0;s:5:\"Music\";}s:7:\"handler\";s:7:\"youtube\";}',NULL,NULL),('node','video',0,37,37,'und',0,'http://vimeo.com/channels/staffpicks/100552392','public://video_embed_field_thumbnails/vimeo/100552392.jpg','a:25:{s:2:\"id\";i:100552392;s:5:\"title\";s:27:\"The San Juans. Proven Here.\";s:11:\"description\";s:1294:\"In late fall, we traveled to the high elevations of the San Juan mountains to explore the vast range and to test out our prototype suspension platform. Our trip took us to the southwest part of Colorado because the San Juan\'s contain some of the most rugged terrain in Colorado and offer a loose network of trails — some fully developed, others just old mining paths filtering down the mountainside. <br />\r\n<br />\r\nFall in the Rockies is always epic, but the weather is variable. We encountered freezing temps and snow, but were rewarded with fresh loam and peak colors. In the end, after the trails were explored, weather was endured, flat tires were fixed, and a few beers were drunk, we found out what works and what doesn’t. Excursions like this are part of the feedback loop necessary to fully develop our suspension designs. SB5 Carbon  & The San Juan’s. Proven Here.<br />\r\n<br />\r\nThe Trip: http://www.pinkbike.com/news/proven-here-sb5-carbon-amp-the-san-jaun-mountains.html<br />\r\nThe Bike / SB5 Carbon: www.yeticycles.com/#/bikes/sb5c<br />\r\n<br />\r\nCinematography By: Craig Grant <br />\r\nDirected and Edited By: Craig Grant <br />\r\nOriginal Music: Ajay Bhattacharyya<br />\r\nSound Design: Keith White<br />\r\n<br />\r\nRider: Joey Schusler<br />\r\n<br />\r\n#YetiCycles #ProvenHere\";s:3:\"url\";s:26:\"http://vimeo.com/100552392\";s:11:\"upload_date\";s:19:\"2014-07-11 19:07:35\";s:10:\"mobile_url\";s:28:\"http://vimeo.com/m/100552392\";s:15:\"thumbnail_small\";s:48:\"http://i.vimeocdn.com/video/482418517_100x75.jpg\";s:16:\"thumbnail_medium\";s:49:\"http://i.vimeocdn.com/video/482418517_200x150.jpg\";s:15:\"thumbnail_large\";s:45:\"http://i.vimeocdn.com/video/482418517_640.jpg\";s:7:\"user_id\";i:7019981;s:9:\"user_name\";s:11:\"Yeti Cycles\";s:8:\"user_url\";s:27:\"http://vimeo.com/yeticycles\";s:19:\"user_portrait_small\";s:48:\"http://i.vimeocdn.com/portrait/5329586_30x30.jpg\";s:20:\"user_portrait_medium\";s:48:\"http://i.vimeocdn.com/portrait/5329586_75x75.jpg\";s:19:\"user_portrait_large\";s:50:\"http://i.vimeocdn.com/portrait/5329586_100x100.jpg\";s:18:\"user_portrait_huge\";s:50:\"http://i.vimeocdn.com/portrait/5329586_300x300.jpg\";s:21:\"stats_number_of_likes\";i:1783;s:21:\"stats_number_of_plays\";i:154446;s:24:\"stats_number_of_comments\";i:42;s:8:\"duration\";i:330;s:5:\"width\";i:1920;s:6:\"height\";i:960;s:4:\"tags\";s:76:\"Yeti Cycles, San Juan Mountains, SB5 Carbon, Colorado, Fall, Mountain Biking\";s:13:\"embed_privacy\";s:8:\"anywhere\";s:7:\"handler\";s:5:\"vimeo\";}',NULL,NULL),('node','video',0,38,38,'und',0,'http://vimeo.com/27066862','public://video_embed_field_thumbnails/vimeo/27066862.jpg','a:25:{s:2:\"id\";i:27066862;s:5:\"title\";s:16:\"Stop Motion [HD]\";s:11:\"description\";s:389:\"An Improv Stop Motion Short.  Let Us Know What You Think!!<br />\n<br />\nfilmed & edited by:<br />\nBrandon Sloan<br />\n<br />\nCome Visit & Join Dancing Shoes Productions here:<br />\nhttp://www.facebook.com/pages/Dancing-Shoes-Productions/119577134786827<br />\n<br />\nCanon 550D<br />\nCanon 16-35mm f2.8L lens<br />\n<br />\nStarring:<br />\nLogan Clenney<br />\nJake McOwan<br />\nTrey Petterson\";s:3:\"url\";s:25:\"http://vimeo.com/27066862\";s:11:\"upload_date\";s:19:\"2011-07-29 16:14:10\";s:10:\"mobile_url\";s:27:\"http://vimeo.com/m/27066862\";s:15:\"thumbnail_small\";s:48:\"http://i.vimeocdn.com/video/179365812_100x75.jpg\";s:16:\"thumbnail_medium\";s:49:\"http://i.vimeocdn.com/video/179365812_200x150.jpg\";s:15:\"thumbnail_large\";s:45:\"http://i.vimeocdn.com/video/179365812_640.jpg\";s:7:\"user_id\";i:2636706;s:9:\"user_name\";s:13:\"Brandon Sloan\";s:8:\"user_url\";s:29:\"http://vimeo.com/brandonsloan\";s:19:\"user_portrait_small\";s:48:\"http://i.vimeocdn.com/portrait/3157839_30x30.jpg\";s:20:\"user_portrait_medium\";s:48:\"http://i.vimeocdn.com/portrait/3157839_75x75.jpg\";s:19:\"user_portrait_large\";s:50:\"http://i.vimeocdn.com/portrait/3157839_100x100.jpg\";s:18:\"user_portrait_huge\";s:50:\"http://i.vimeocdn.com/portrait/3157839_300x300.jpg\";s:21:\"stats_number_of_likes\";i:266;s:21:\"stats_number_of_plays\";i:24831;s:24:\"stats_number_of_comments\";i:48;s:8:\"duration\";i:61;s:5:\"width\";i:1280;s:6:\"height\";i:720;s:4:\"tags\";s:72:\"stop motion, canon 550D, t2i, dslr, 60d, canon eos, 5d iii, 5d, animator\";s:13:\"embed_privacy\";s:8:\"anywhere\";s:7:\"handler\";s:5:\"vimeo\";}',NULL,NULL);
/*!40000 ALTER TABLE `field_revision_field_video_link` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `field_revision_field_vote`
--

DROP TABLE IF EXISTS `field_revision_field_vote`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_vote` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_vote_rating` int(10) unsigned DEFAULT NULL,
  `field_vote_target` int(10) unsigned DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 6 (field_vote)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_vote`
--

LOCK TABLES `field_revision_field_vote` WRITE;
/*!40000 ALTER TABLE `field_revision_field_vote` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `field_revision_field_vote` VALUES ('comment','comment_node_forum',0,1,1,'und',0,80,NULL),('comment','comment_node_forum',0,8,8,'und',0,80,NULL),('comment','comment_node_forum',0,9,9,'und',0,80,NULL),('comment','comment_node_forum',0,10,10,'und',0,80,NULL),('node','forum',0,1,1,'und',0,100,NULL),('node','blog',0,7,7,'und',0,40,NULL),('node','blog',0,8,8,'und',0,100,NULL),('node','blog',0,9,9,'und',0,80,NULL),('node','blog',0,10,10,'und',0,60,NULL),('node','blog',0,11,11,'und',0,80,NULL),('node','forum',0,15,15,'und',0,100,NULL),('node','forum',0,16,16,'und',0,100,NULL),('node','forum',0,17,17,'und',0,80,NULL),('node','forum',0,55,55,'und',0,100,NULL);
/*!40000 ALTER TABLE `field_revision_field_vote` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `field_revision_message_text`
--

DROP TABLE IF EXISTS `field_revision_message_text`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_message_text` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `message_text_value` longtext,
  `message_text_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `message_text_format` (`message_text_format`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 7 (message_text)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_message_text`
--

LOCK TABLES `field_revision_message_text` WRITE;
/*!40000 ALTER TABLE `field_revision_message_text` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `field_revision_message_text` VALUES ('message_type','message_type',0,1,1,'ar',0,'<p><a href=\"[message:user:url]\">[message:user]</a> have just commented <a href=\"[message:field-node-ref:url]\">[message:field-comment-ref:node]</a></p>\r\n\r\n<p>[message:field-comment-ref:comment-text-teaser]</p>\r\n','full_html'),('message_type','message_type',0,1,1,'en',0,'<p><a href=\"[message:user:url]\">[message:user]</a> have just commented <a href=\"[message:field-node-ref:url]\">[message:field-comment-ref:node]</a></p>\n\n<p>[message:field-comment-ref:comment-text-teaser]</p>\n','full_html'),('message_type','message_type',0,1,1,'fr',0,'<a href=\"[message:user:url]\">[message:user]</a> viennent commentaires <a href=\"[message:field-node-ref:url]\">[message:field-comment-ref:node]</a> [message:field-comment-ref:comment-text-teaser]\n','full_html'),('message_type','message_type',0,1,1,'und',0,'<a href=\"[message:user:url]\">@{message:user:name}</a> <a href=\"[message:field-comment-ref:url]\">commented</a> on [message:field-node-ref:title]','full_html'),('message_type','message_type',0,1,1,'und',1,'[message:field-comment-ref:comment-teaser]','full_html'),('message_type','message_type',0,2,2,'ar',0,'<p><a href=\"[message:user:url]\">[message:user]</a> have just posted <a href=\"[message:field-node-ref:url]\">[message:field-node-ref]</a></p>\r\n','full_html'),('message_type','message_type',0,2,2,'en',0,'<p><a href=\"[message:user:url]\">[message:user]</a> have just posted <a href=\"[message:field-node-ref:url]\">[message:field-node-ref]</a></p>\n','full_html'),('message_type','message_type',0,2,2,'fr',0,'<p><a href=\"[message:user:url]\">[message:user]</a> viennent posté <a href=\"[message:field-node-ref:url]\">[message:field-node-ref]</a></p>\r\n','full_html'),('message_type','message_type',0,2,2,'und',0,'<a href=\"[message:user:url]\">@{message:user:name}</a> created <a href=\"[message:field-node-ref:url]\">[message:field-node-ref:title]</a>','full_html'),('message_type','message_type',0,2,2,'und',1,'[message:field-node-ref:node-teaser]','full_html'),('message_type','message_type',0,3,3,'ar',0,'<p><a href=\"[message:user:url]\">[message:user]</a> joined Forum Plus</p>\r\n','full_html'),('message_type','message_type',0,3,3,'en',0,'<p><a href=\"[message:user:url]\">[message:user]</a> joined Forum Plus</p>\n','full_html'),('message_type','message_type',0,3,3,'fr',0,'<a href=\"[message:user:url]\">[message:user]</a> relié Forum Plus','full_html'),('message_type','message_type',0,3,3,'und',0,'<a href=\"[message:user:url]\">@{message:user:name}</a> registered.','full_html');
/*!40000 ALTER TABLE `field_revision_message_text` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `field_revision_taxonomy_forums`
--

DROP TABLE IF EXISTS `field_revision_taxonomy_forums`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_taxonomy_forums` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `taxonomy_forums_tid` int(10) unsigned DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `taxonomy_forums_tid` (`taxonomy_forums_tid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 5 (taxonomy_forums)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_taxonomy_forums`
--

LOCK TABLES `field_revision_taxonomy_forums` WRITE;
/*!40000 ALTER TABLE `field_revision_taxonomy_forums` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `field_revision_taxonomy_forums` VALUES ('node','forum',0,1,1,'und',0,6),('node','forum',0,3,3,'und',0,5),('node','forum',0,15,15,'und',0,6),('node','forum',0,16,16,'und',0,6),('node','forum',0,17,17,'und',0,10),('node','forum',0,18,18,'und',0,9),('node','forum',0,19,19,'und',0,8),('node','forum',0,20,20,'und',0,3),('node','forum',0,21,21,'und',0,3),('node','forum',0,22,22,'und',0,3),('node','forum',0,47,47,'und',0,5),('node','forum',0,53,53,'und',0,6),('node','forum',0,54,54,'und',0,6),('node','forum',0,55,55,'und',0,6),('node','forum',0,56,56,'und',0,11),('node','forum',0,68,68,'und',0,1),('node','forum',0,69,69,'und',0,1);
/*!40000 ALTER TABLE `field_revision_taxonomy_forums` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `file_managed`
--

DROP TABLE IF EXISTS `file_managed`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `file_managed` (
  `fid` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'File ID.',
  `uid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The users.uid of the user who is associated with the file.',
  `filename` varchar(255) NOT NULL DEFAULT '' COMMENT 'Name of the file with no path components. This may differ from the basename of the URI if the file is renamed to avoid overwriting an existing file.',
  `uri` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL DEFAULT '' COMMENT 'The URI to access the file (either local or remote).',
  `filemime` varchar(255) NOT NULL DEFAULT '' COMMENT 'The file’s MIME type.',
  `filesize` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT 'The size of the file in bytes.',
  `status` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A field indicating the status of the file. Two status are defined in core: temporary (0) and permanent (1). Temporary files older than DRUPAL_MAXIMUM_TEMP_FILE_AGE will be removed during a cron run.',
  `timestamp` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'UNIX timestamp for when the file was added.',
  PRIMARY KEY (`fid`),
  UNIQUE KEY `uri` (`uri`),
  KEY `uid` (`uid`),
  KEY `status` (`status`),
  KEY `timestamp` (`timestamp`)
) ENGINE=InnoDB AUTO_INCREMENT=161 DEFAULT CHARSET=utf8 COMMENT='Stores information for uploaded files.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `file_managed`
--

LOCK TABLES `file_managed` WRITE;
/*!40000 ALTER TABLE `file_managed` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `file_managed` VALUES (36,1,'80c277f193e74f5bd76fe43a7e5ab10b.jpg','public://userpickit/gravatar_eightbit/80c277f193e74f5bd76fe43a7e5ab10b.jpg','image/jpeg',388,1,1405266673),(38,1,'80c277f193e74f5bd76fe43a7e5ab10b','public://userpickit/robohash/80c277f193e74f5bd76fe43a7e5ab10b','application/octet-stream',39368,1,1405266673),(40,1,'80c277f193e74f5bd76fe43a7e5ab10b','public://userpickit/robohash_monsters/80c277f193e74f5bd76fe43a7e5ab10b','application/octet-stream',48160,1,1405266673),(41,1,'80c277f193e74f5bd76fe43a7e5ab10b','public://userpickit/robohash_monsters/80c277f193e74f5bd76fe43a7e5ab10b_0','application/octet-stream',48160,1,1405266676),(43,1,'80c277f193e74f5bd76fe43a7e5ab10b','public://userpickit/robohash_heads/80c277f193e74f5bd76fe43a7e5ab10b','application/octet-stream',43171,1,1405266673),(44,1,'80c277f193e74f5bd76fe43a7e5ab10b','public://userpickit/robohash_heads/80c277f193e74f5bd76fe43a7e5ab10b_0','application/octet-stream',43171,1,1405266676),(61,1,'picture-6-1406367386.png','public://pictures/picture-6-1406367386.png','image/png',18016,1,1406367386),(63,1,'62e243a3f26aafa0eacb0371c4170a49.jpg','public://userpickit/gravatar_monster/62e243a3f26aafa0eacb0371c4170a49_1.jpg','image/jpeg',6799,1,1406367389),(66,1,'62e243a3f26aafa0eacb0371c4170a49.jpg','public://userpickit/gravatar_eightbit/62e243a3f26aafa0eacb0371c4170a49_1.jpg','image/jpeg',363,1,1406367421),(70,1,'picture-2-1406367449.png','public://pictures/picture-2-1406367449.png','image/png',10333,1,1406367449),(77,1,'80c277f193e74f5bd76fe43a7e5ab10b.jpg','public://userpickit/gravatar_identicon/80c277f193e74f5bd76fe43a7e5ab10b_0.jpg','image/jpeg',4619,1,1406387423),(79,1,'c37ecfd46b197a3e9ece634c4714b8cc.jpg','public://userpickit/gravatar_identicon/c37ecfd46b197a3e9ece634c4714b8cc.jpg','image/jpeg',6804,1,1406684503),(86,1,'picture-1-1406684588.jpg','public://pictures/picture-1-1406684588.jpg','image/jpeg',116393,1,1406684588),(87,1,'62e243a3f26aafa0eacb0371c4170a49.jpg','public://userpickit/gravatar/62e243a3f26aafa0eacb0371c4170a49_1.jpg','image/jpeg',6683,1,1406684614),(94,1,'60280914.jpg','public://video_embed_field_thumbnails/vimeo/60280914.jpg','image/jpeg',32831,1,1407806046),(95,1,'FOIjvHjK0Rw.jpg','public://video_embed_field_thumbnails/youtube/FOIjvHjK0Rw.jpg','image/jpeg',37151,1,1407806013),(96,1,'0VqTwnAuHws.jpg','public://video_embed_field_thumbnails/youtube/0VqTwnAuHws.jpg','image/jpeg',38287,1,1407805986),(97,1,'100552392.jpg','public://video_embed_field_thumbnails/vimeo/100552392.jpg','image/jpeg',51983,1,1407805961),(98,1,'27066862.jpg','public://video_embed_field_thumbnails/vimeo/27066862.jpg','image/jpeg',72915,1,1407805906),(99,1,'38.jpg','public://field/blog/38.jpg','image/jpeg',292529,1,1407765701),(100,1,'15.jpg','public://field/blog/15.jpg','image/jpeg',267195,1,1407765855),(101,1,'22.jpg','public://field/blog/22.jpg','image/jpeg',426754,1,1407766864),(102,1,'26.jpg','public://field/blog/26.jpg','image/jpeg',447432,1,1407766964),(103,1,'43.jpg','public://field/blog/43.jpg','image/jpeg',429925,1,1407767018),(110,1,'picture-6-1408183744.jpg','public://pictures/picture-6-1408183744.jpg','image/jpeg',24319,1,1408183744),(111,1,'picture-2-1408184126.jpg','public://pictures/picture-2-1408184126.jpg','image/jpeg',119865,1,1408184126),(112,1,'picture-7-1408185839.jpg','public://pictures/picture-7-1408185839.jpg','image/jpeg',25072,1,1408185839),(120,1,'14.jpg','public://field/collection/14.jpg','image/jpeg',213441,1,1408268585),(121,1,'16.jpg','public://field/collection/16.jpg','image/jpeg',141387,1,1408268598),(122,1,'19.jpg','public://field/collection/19.jpg','image/jpeg',148456,1,1408268610),(123,1,'7.jpg','public://field/collection/7.jpg','image/jpeg',101648,1,1408268684),(124,1,'4.jpg','public://field/collection/4.jpg','image/jpeg',71571,1,1408268709),(125,1,'40.jpg','public://field/collection/40.jpg','image/jpeg',484816,1,1408268763),(126,1,'48.jpg','public://field/collection/48.jpg','image/jpeg',336008,1,1408268783),(127,1,'31.jpg','public://field/collection/31.jpg','image/jpeg',478063,1,1408268919),(128,1,'59.jpg','public://field/collection/59.jpg','image/jpeg',275771,1,1408268979),(129,1,'moto-5.jpg','public://field/collection/moto-5.jpg','image/jpeg',273252,1,1408269253),(130,1,'1.jpg','public://field/collection/1.jpg','image/jpeg',440894,1,1408269364),(131,1,'lshNdiTvNMI.jpg','public://video_embed_field_thumbnails/youtube/lshNdiTvNMI.jpg','image/jpeg',30242,1,1408269392),(132,1,'43.jpg','public://field/collection/43.jpg','image/jpeg',429925,1,1408269476),(134,6,'7D1CQ_LOizA.jpg','public://video_embed_field_thumbnails/youtube/7D1CQ_LOizA.jpg','image/jpeg',37668,1,1408269965),(135,1,'-cUWFLBZU5I.jpg','public://video_embed_field_thumbnails/youtube/-cUWFLBZU5I.jpg','image/jpeg',24141,1,1444038019),(136,1,'r6rllB4-xoE.jpg','public://video_embed_field_thumbnails/youtube/r6rllB4-xoE.jpg','image/jpeg',23413,1,1408270154),(137,1,'58.jpg','public://field/image/58.jpg','image/jpeg',265782,1,1408380992),(138,1,'63.jpg','public://field/image/63.jpg','image/jpeg',239035,1,1408381047),(139,1,'60.jpg','public://field/image/60.jpg','image/jpeg',243333,1,1408381242),(140,1,'28.jpg','public://field/collection/28.jpg','image/jpeg',266109,1,1408381264),(141,1,'30.jpg','public://field/image/30.jpg','image/jpeg',140210,1,1408381329),(142,1,'25.jpg','public://field/collection/25.jpg','image/jpeg',293591,1,1408381380),(143,1,'swimming-1.jpg','public://field/image/swimming-1.jpg','image/jpeg',437254,1,1408381461),(144,1,'swimming-4.jpg','public://field/image/swimming-4.jpg','image/jpeg',465762,1,1408381505),(145,1,'moto-3.jpg','public://field/image/moto-3.jpg','image/jpeg',353896,1,1408381643),(147,1,'36.jpg','public://field/image/36.jpg','image/jpeg',255214,1,1408381733),(148,1,'57.jpg','public://field/image/57.jpg','image/jpeg',203169,1,1408381773),(149,1,'41.jpg','public://field/collection/41.jpg','image/jpeg',455175,1,1408382558),(156,1,'960x460_home.jpg','public://field/product/960x460_home.jpg','image/jpeg',366062,1,1408585633),(157,1,'960x460_home.jpg','public://field/product/960x460_home_0.jpg','image/jpeg',372467,1,1408585683),(158,1,'onepage_960x460_home.jpg','public://field/product/onepage_960x460_home.jpg','image/jpeg',301712,1,1408585698),(159,1,'960x460_home.jpg','public://field/product/960x460_home_1.jpg','image/jpeg',288124,1,1408585713),(160,1,'Zircon II_960x460_home.jpg','public://field/product/Zircon II_960x460_home.jpg','image/jpeg',385354,1,1408585727);
/*!40000 ALTER TABLE `file_managed` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `file_usage`
--

DROP TABLE IF EXISTS `file_usage`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `file_usage` (
  `fid` int(10) unsigned NOT NULL COMMENT 'File ID.',
  `module` varchar(255) NOT NULL DEFAULT '' COMMENT 'The name of the module that is using the file.',
  `type` varchar(64) NOT NULL DEFAULT '' COMMENT 'The name of the object type in which the file is used.',
  `id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The primary key of the object using the file.',
  `count` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The number of times this file is used by this object.',
  PRIMARY KEY (`fid`,`type`,`id`,`module`),
  KEY `type_id` (`type`,`id`),
  KEY `fid_count` (`fid`,`count`),
  KEY `fid_module` (`fid`,`module`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Track where a file is used.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `file_usage`
--

LOCK TABLES `file_usage` WRITE;
/*!40000 ALTER TABLE `file_usage` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `file_usage` VALUES (36,'userpickit','pictures',6,1),(38,'userpickit','pictures',6,1),(40,'userpickit','pictures',6,1),(41,'userpickit','pictures',6,1),(43,'userpickit','pictures',6,1),(44,'userpickit','pictures',6,1),(61,'userpickit_user','user',6,1),(63,'userpickit','pictures',2,1),(66,'userpickit','pictures',2,1),(70,'userpickit_user','user',2,1),(77,'userpickit','pictures',6,1),(79,'userpickit','pictures',1,1),(86,'user','user',1,1),(86,'userpickit_user','user',1,1),(87,'userpickit','pictures',2,1),(99,'file','node',7,1),(100,'file','node',8,1),(101,'file','node',9,1),(102,'file','node',11,1),(103,'file','node',10,1),(110,'user','user',6,1),(111,'user','user',2,1),(112,'user','user',7,1),(120,'file','field_collection_item',9,1),(121,'file','field_collection_item',10,1),(122,'file','field_collection_item',11,1),(123,'file','field_collection_item',12,1),(124,'file','field_collection_item',13,1),(125,'file','field_collection_item',14,1),(126,'file','field_collection_item',15,1),(127,'file','field_collection_item',16,1),(128,'file','field_collection_item',17,1),(129,'file','field_collection_item',18,1),(130,'file','field_collection_item',19,1),(132,'file','field_collection_item',21,1),(137,'file','node',31,1),(138,'file','node',30,1),(139,'file','node',29,1),(140,'file','field_collection_item',26,1),(141,'file','node',28,1),(142,'file','field_collection_item',27,1),(143,'file','node',27,1),(144,'file','node',12,1),(145,'file','node',6,1),(147,'file','node',4,1),(148,'file','node',5,1),(149,'file','field_collection_item',28,1),(156,'file','node',48,1),(157,'file','node',49,1),(158,'file','node',50,1),(159,'file','node',51,1),(160,'file','node',52,1);
/*!40000 ALTER TABLE `file_usage` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `filter`
--

DROP TABLE IF EXISTS `filter`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `filter` (
  `format` varchar(255) NOT NULL COMMENT 'Foreign key: The filter_format.format to which this filter is assigned.',
  `module` varchar(64) NOT NULL DEFAULT '' COMMENT 'The origin module of the filter.',
  `name` varchar(32) NOT NULL DEFAULT '' COMMENT 'Name of the filter being referenced.',
  `weight` int(11) NOT NULL DEFAULT '0' COMMENT 'Weight of filter within format.',
  `status` int(11) NOT NULL DEFAULT '0' COMMENT 'Filter enabled status. (1 = enabled, 0 = disabled)',
  `settings` longblob COMMENT 'A serialized array of name value pairs that store the filter settings for the specific format.',
  PRIMARY KEY (`format`,`name`),
  KEY `list` (`weight`,`module`,`name`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Table that maps filters (HTML corrector) to text formats ...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `filter`
--

LOCK TABLES `filter` WRITE;
/*!40000 ALTER TABLE `filter` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `filter` VALUES ('filtered_html','faq','faq_embed',0,0,'a:0:{}'),('filtered_html','filter','filter_autop',2,1,'a:0:{}'),('filtered_html','filter','filter_html',1,1,'a:3:{s:12:\"allowed_html\";s:110:\"<a> <em> <strong> <cite> <blockquote> <code> <ul> <ol> <li> <dl> <dt> <dd> <footer> <cite> <h1> <h2> <h3> <h4>\";s:16:\"filter_html_help\";i:1;s:20:\"filter_html_nofollow\";i:0;}'),('filtered_html','filter','filter_htmlcorrector',10,1,'a:0:{}'),('filtered_html','filter','filter_html_escape',-10,0,'a:0:{}'),('filtered_html','filter','filter_url',0,1,'a:1:{s:17:\"filter_url_length\";s:2:\"72\";}'),('filtered_html','php','php_code',0,0,'a:0:{}'),('filtered_html','shortcode','shortcode',0,0,'a:13:{s:5:\"quote\";i:0;s:3:\"img\";i:0;s:9:\"highlight\";i:0;s:6:\"button\";i:0;s:7:\"dropcap\";i:0;s:4:\"item\";i:0;s:5:\"clear\";i:0;s:4:\"link\";i:0;s:6:\"random\";i:0;s:13:\"embed_content\";i:0;s:5:\"video\";i:0;s:7:\"tooltip\";i:0;s:8:\"collapse\";i:0;}'),('filtered_html','shortcode','shortcode_text_corrector',0,0,'a:0:{}'),('filtered_html','video_embed_field','video_embed_field',0,0,'a:0:{}'),('full_html','faq','faq_embed',0,0,'a:0:{}'),('full_html','filter','filter_autop',1,1,'a:0:{}'),('full_html','filter','filter_html',-10,0,'a:3:{s:12:\"allowed_html\";s:74:\"<a> <em> <strong> <cite> <blockquote> <code> <ul> <ol> <li> <dl> <dt> <dd>\";s:16:\"filter_html_help\";i:1;s:20:\"filter_html_nofollow\";i:0;}'),('full_html','filter','filter_htmlcorrector',10,1,'a:0:{}'),('full_html','filter','filter_html_escape',-10,0,'a:0:{}'),('full_html','filter','filter_url',0,1,'a:1:{s:17:\"filter_url_length\";s:2:\"72\";}'),('full_html','shortcode','shortcode',0,1,'a:13:{s:5:\"quote\";i:1;s:3:\"img\";i:1;s:9:\"highlight\";i:1;s:6:\"button\";i:1;s:7:\"dropcap\";i:1;s:4:\"item\";i:1;s:5:\"clear\";i:1;s:4:\"link\";i:1;s:6:\"random\";i:1;s:13:\"embed_content\";i:1;s:5:\"video\";i:1;s:7:\"tooltip\";i:1;s:8:\"collapse\";i:1;}'),('full_html','shortcode','shortcode_text_corrector',0,0,'a:0:{}'),('php_code','faq','faq_embed',0,0,'a:0:{}'),('php_code','filter','filter_autop',0,0,'a:0:{}'),('php_code','filter','filter_html',-10,0,'a:3:{s:12:\"allowed_html\";s:74:\"<a> <em> <strong> <cite> <blockquote> <code> <ul> <ol> <li> <dl> <dt> <dd>\";s:16:\"filter_html_help\";i:1;s:20:\"filter_html_nofollow\";i:0;}'),('php_code','filter','filter_htmlcorrector',10,0,'a:0:{}'),('php_code','filter','filter_html_escape',-10,0,'a:0:{}'),('php_code','filter','filter_url',0,0,'a:1:{s:17:\"filter_url_length\";i:72;}'),('php_code','php','php_code',0,1,'a:0:{}'),('php_code','shortcode','shortcode',0,0,'a:0:{}'),('php_code','shortcode','shortcode_text_corrector',0,0,'a:0:{}'),('plain_text','filter','filter_autop',2,1,'a:0:{}'),('plain_text','filter','filter_html',-10,0,'a:3:{s:12:\"allowed_html\";s:74:\"<a> <em> <strong> <cite> <blockquote> <code> <ul> <ol> <li> <dl> <dt> <dd>\";s:16:\"filter_html_help\";i:1;s:20:\"filter_html_nofollow\";i:0;}'),('plain_text','filter','filter_htmlcorrector',10,0,'a:0:{}'),('plain_text','filter','filter_html_escape',0,1,'a:0:{}'),('plain_text','filter','filter_url',1,1,'a:1:{s:17:\"filter_url_length\";i:72;}');
/*!40000 ALTER TABLE `filter` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `filter_format`
--

DROP TABLE IF EXISTS `filter_format`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `filter_format` (
  `format` varchar(255) NOT NULL COMMENT 'Primary Key: Unique machine name of the format.',
  `name` varchar(255) NOT NULL DEFAULT '' COMMENT 'Name of the text format (Filtered HTML).',
  `cache` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'Flag to indicate whether format is cacheable. (1 = cacheable, 0 = not cacheable)',
  `status` tinyint(3) unsigned NOT NULL DEFAULT '1' COMMENT 'The status of the text format. (1 = enabled, 0 = disabled)',
  `weight` int(11) NOT NULL DEFAULT '0' COMMENT 'Weight of text format to use when listing.',
  PRIMARY KEY (`format`),
  UNIQUE KEY `name` (`name`),
  KEY `status_weight` (`status`,`weight`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Stores text formats: custom groupings of filters, such as...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `filter_format`
--

LOCK TABLES `filter_format` WRITE;
/*!40000 ALTER TABLE `filter_format` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `filter_format` VALUES ('filtered_html','Filtered HTML',1,1,0),('full_html','Full HTML',1,1,1),('php_code','PHP code',0,1,11),('plain_text','Plain text',1,1,10);
/*!40000 ALTER TABLE `filter_format` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `flexslider_optionset`
--

DROP TABLE IF EXISTS `flexslider_optionset`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `flexslider_optionset` (
  `name` varchar(255) NOT NULL COMMENT 'The machine-readable option set name.',
  `title` varchar(255) NOT NULL COMMENT 'The human-readable title for this option set.',
  `theme` varchar(255) NOT NULL DEFAULT 'classic' COMMENT 'The flexslider theme.',
  `imagestyle_normal` varchar(255) NOT NULL DEFAULT 'flexslider_full' COMMENT 'The image style for normal images.',
  `imagestyle_thumbnail` varchar(255) NOT NULL DEFAULT 'flexslider_thumbnail' COMMENT 'The image style for thumbnail images.',
  `options` longblob COMMENT 'The options array.',
  PRIMARY KEY (`name`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Store option sets for flexslider instances.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `flexslider_optionset`
--

LOCK TABLES `flexslider_optionset` WRITE;
/*!40000 ALTER TABLE `flexslider_optionset` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `flexslider_optionset` VALUES ('hot_video','hot video','classic','hot_video','flexslider_thumbnail','a:40:{s:9:\"namespace\";s:5:\"flex-\";s:8:\"selector\";s:12:\".slides > li\";s:6:\"easing\";s:5:\"swing\";s:9:\"direction\";s:10:\"horizontal\";s:7:\"reverse\";i:0;s:12:\"smoothHeight\";i:0;s:7:\"startAt\";s:1:\"0\";s:14:\"animationSpeed\";s:3:\"600\";s:9:\"initDelay\";s:1:\"0\";s:6:\"useCSS\";i:1;s:5:\"touch\";i:1;s:5:\"video\";i:0;s:8:\"keyboard\";i:1;s:16:\"multipleKeyboard\";i:0;s:10:\"mousewheel\";i:0;s:17:\"controlsContainer\";s:27:\".flex-control-nav-container\";s:4:\"sync\";s:0:\"\";s:8:\"asNavFor\";s:0:\"\";s:9:\"itemWidth\";s:1:\"0\";s:10:\"itemMargin\";s:1:\"0\";s:8:\"minItems\";s:1:\"0\";s:8:\"maxItems\";s:1:\"0\";s:4:\"move\";s:1:\"0\";s:9:\"animation\";s:4:\"fade\";s:9:\"slideshow\";i:1;s:14:\"slideshowSpeed\";s:4:\"7000\";s:12:\"directionNav\";i:0;s:10:\"controlNav\";s:1:\"0\";s:8:\"prevText\";s:8:\"Previous\";s:8:\"nextText\";s:4:\"Next\";s:9:\"pausePlay\";i:0;s:9:\"pauseText\";s:5:\"Pause\";s:8:\"playText\";s:4:\"Play\";s:9:\"randomize\";i:0;s:13:\"thumbCaptions\";i:0;s:17:\"thumbCaptionsBoth\";i:0;s:13:\"animationLoop\";i:1;s:13:\"pauseOnAction\";i:1;s:12:\"pauseOnHover\";i:0;s:14:\"manualControls\";s:0:\"\";}');
/*!40000 ALTER TABLE `flexslider_optionset` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `flood`
--

DROP TABLE IF EXISTS `flood`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `flood` (
  `fid` int(11) NOT NULL AUTO_INCREMENT COMMENT 'Unique flood event ID.',
  `event` varchar(64) NOT NULL DEFAULT '' COMMENT 'Name of event (e.g. contact).',
  `identifier` varchar(128) NOT NULL DEFAULT '' COMMENT 'Identifier of the visitor, such as an IP address or hostname.',
  `timestamp` int(11) NOT NULL DEFAULT '0' COMMENT 'Timestamp of the event.',
  `expiration` int(11) NOT NULL DEFAULT '0' COMMENT 'Expiration timestamp. Expired events are purged on cron run.',
  PRIMARY KEY (`fid`),
  KEY `allow` (`event`,`identifier`,`timestamp`),
  KEY `purge` (`expiration`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Flood controls the threshold of events, such as the...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `flood`
--

LOCK TABLES `flood` WRITE;
/*!40000 ALTER TABLE `flood` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `flood` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `forum`
--

DROP TABLE IF EXISTS `forum`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `forum` (
  `nid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The node.nid of the node.',
  `vid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Primary Key: The node.vid of the node.',
  `tid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The taxonomy_term_data.tid of the forum term assigned to the node.',
  PRIMARY KEY (`vid`),
  KEY `forum_topic` (`nid`,`tid`),
  KEY `tid` (`tid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Stores the relationship of nodes to forum terms.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `forum`
--

LOCK TABLES `forum` WRITE;
/*!40000 ALTER TABLE `forum` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `forum` VALUES (1,1,6),(3,3,5),(15,15,6),(16,16,6),(17,17,10),(18,18,9),(19,19,8),(20,20,3),(21,21,3),(22,22,3),(47,47,5),(53,53,6),(54,54,6),(55,55,6),(56,56,11),(68,68,1),(69,69,1);
/*!40000 ALTER TABLE `forum` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `forum_index`
--

DROP TABLE IF EXISTS `forum_index`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `forum_index` (
  `nid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The node.nid this record tracks.',
  `title` varchar(255) NOT NULL DEFAULT '' COMMENT 'The title of this node, always treated as non-markup plain text.',
  `tid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The term ID.',
  `sticky` tinyint(4) DEFAULT '0' COMMENT 'Boolean indicating whether the node is sticky.',
  `created` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The Unix timestamp when the node was created.',
  `last_comment_timestamp` int(11) NOT NULL DEFAULT '0' COMMENT 'The Unix timestamp of the last comment that was posted within this node, from comment.timestamp.',
  `comment_count` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The total number of comments on this node.',
  KEY `forum_topics` (`nid`,`tid`,`sticky`,`last_comment_timestamp`),
  KEY `created` (`created`),
  KEY `last_comment_timestamp` (`last_comment_timestamp`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Maintains denormalized information about node/term...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `forum_index`
--

LOCK TABLES `forum_index` WRITE;
/*!40000 ALTER TABLE `forum_index` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `forum_index` VALUES (15,'What does WeebPal do?',6,0,1405266314,1405267046,2),(16,'Headline news',6,1,1405267481,1405267525,1),(18,'Hosting',9,0,1405268124,1405268124,0),(19,'Installing Drush on Shared Hosting Accounts',8,0,1405268196,1405268196,0),(20,'System requirements',3,0,1405268456,1405268456,0),(21,'Web server',3,0,1405268526,1405268526,0),(22,'Database server',3,0,1405268575,1405268575,0),(1,'Learn D7 coding or D8?',6,0,1404031643,1408589899,2),(53,'8 Project Management Tips',6,0,1408184897,1408185924,12),(54,'Column Oriented Databases: Does bigtable, cassandra belong to column store database?',6,0,1408269165,1408269965,1),(55,'Time Travel: Why are people from the future not time traveling to our period?',6,0,1408269327,1408269582,2),(47,'Apple Launches Email Ad Campaign Focusing on Productivity',5,0,1407805139,1408382574,1),(3,'Apple Updates MacBook Pro with Retina Display',5,0,1404550214,1408382644,1),(68,'Headline news ',1,0,1442659410,1442659410,0),(17,'Review front page promotion requests',10,0,1405267880,1405267880,0),(69,'Learn D7 coding or D8? ',1,0,1443955525,1443955525,0),(56,'Drupal Installation',11,0,1443866870,1408270155,1);
/*!40000 ALTER TABLE `forum_index` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `history`
--

DROP TABLE IF EXISTS `history`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `history` (
  `uid` int(11) NOT NULL DEFAULT '0' COMMENT 'The users.uid that read the node nid.',
  `nid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The node.nid that was read.',
  `timestamp` int(11) NOT NULL DEFAULT '0' COMMENT 'The Unix timestamp at which the read occurred.',
  PRIMARY KEY (`uid`,`nid`),
  KEY `nid` (`nid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='A record of which users have read which nodes.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `history`
--

LOCK TABLES `history` WRITE;
/*!40000 ALTER TABLE `history` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `history` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `i18n_block_language`
--

DROP TABLE IF EXISTS `i18n_block_language`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `i18n_block_language` (
  `module` varchar(64) NOT NULL COMMENT 'The block’s origin module, from block.module.',
  `delta` varchar(32) NOT NULL COMMENT 'The block’s unique delta within module, from block.delta.',
  `language` varchar(12) NOT NULL DEFAULT '' COMMENT 'Language code, e.g. ’de’ or ’en-US’.',
  PRIMARY KEY (`module`,`delta`,`language`),
  KEY `language` (`language`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Sets block visibility based on language';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `i18n_block_language`
--

LOCK TABLES `i18n_block_language` WRITE;
/*!40000 ALTER TABLE `i18n_block_language` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `i18n_block_language` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `i18n_string`
--

DROP TABLE IF EXISTS `i18n_string`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `i18n_string` (
  `lid` int(11) NOT NULL DEFAULT '0' COMMENT 'Source string ID. References locales_source.lid.',
  `textgroup` varchar(50) NOT NULL DEFAULT 'default' COMMENT 'A module defined group of translations, see hook_locale().',
  `context` varchar(255) NOT NULL DEFAULT '' COMMENT 'Full string ID for quick search: type:objectid:property.',
  `objectid` varchar(255) NOT NULL DEFAULT '' COMMENT 'Object ID.',
  `type` varchar(255) NOT NULL DEFAULT '' COMMENT 'Object type for this string.',
  `property` varchar(255) NOT NULL DEFAULT '' COMMENT 'Object property for this string.',
  `objectindex` int(11) NOT NULL DEFAULT '0' COMMENT 'Integer value of Object ID.',
  `format` varchar(255) DEFAULT NULL COMMENT 'The filter_format.format of the string.',
  PRIMARY KEY (`lid`),
  KEY `group_context` (`textgroup`,`context`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Metadata for source strings.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `i18n_string`
--

LOCK TABLES `i18n_string` WRITE;
/*!40000 ALTER TABLE `i18n_string` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `i18n_string` VALUES (105,'quicktabs','title:quicktab','quicktab','title','',0,''),(106,'quicktabs','tab:quicktab-0:title','quicktab-0','tab','title',0,''),(107,'quicktabs','tab:quicktab-1:title','quicktab-1','tab','title',0,''),(108,'quicktabs','tab:quicktab-2:title','quicktab-2','tab','title',0,''),(113,'taxonomy','vocabulary:2:name','2','vocabulary','name',2,''),(114,'taxonomy','vocabulary:2:description','2','vocabulary','description',2,''),(115,'taxonomy','vocabulary:3:name','3','vocabulary','name',3,''),(116,'taxonomy','vocabulary:4:name','4','vocabulary','name',4,''),(117,'taxonomy','vocabulary:1:name','1','vocabulary','name',1,''),(118,'taxonomy','vocabulary:1:description','1','vocabulary','description',1,'');
/*!40000 ALTER TABLE `i18n_string` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `i18n_translation_set`
--

DROP TABLE IF EXISTS `i18n_translation_set`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `i18n_translation_set` (
  `tsid` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'The primary identifier for a translation set.',
  `title` varchar(255) NOT NULL DEFAULT '' COMMENT 'The title of this translation set, always treated as non-markup plain text.',
  `type` varchar(32) NOT NULL DEFAULT '' COMMENT 'Object type or entity type.',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'Optional bundle for entity translation sets.',
  `master_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The master object/entity id (the others will be synchronized with this one).',
  `status` int(11) NOT NULL DEFAULT '1' COMMENT 'Status of this translation set. TBD.',
  `created` int(11) NOT NULL DEFAULT '0' COMMENT 'The Unix timestamp when the set was created.',
  `changed` int(11) NOT NULL DEFAULT '0' COMMENT 'The Unix timestamp when the set was most recently saved.',
  PRIMARY KEY (`tsid`),
  KEY `entity_bundle` (`type`,`bundle`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Translation set.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `i18n_translation_set`
--

LOCK TABLES `i18n_translation_set` WRITE;
/*!40000 ALTER TABLE `i18n_translation_set` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `i18n_translation_set` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `image_effects`
--

DROP TABLE IF EXISTS `image_effects`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `image_effects` (
  `ieid` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'The primary identifier for an image effect.',
  `isid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The image_styles.isid for an image style.',
  `weight` int(11) NOT NULL DEFAULT '0' COMMENT 'The weight of the effect in the style.',
  `name` varchar(255) NOT NULL COMMENT 'The unique name of the effect to be executed.',
  `data` longblob NOT NULL COMMENT 'The configuration data for the effect.',
  PRIMARY KEY (`ieid`),
  KEY `isid` (`isid`),
  KEY `weight` (`weight`)
) ENGINE=InnoDB AUTO_INCREMENT=12 DEFAULT CHARSET=utf8 COMMENT='Stores configuration options for image effects.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `image_effects`
--

LOCK TABLES `image_effects` WRITE;
/*!40000 ALTER TABLE `image_effects` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `image_effects` VALUES (2,2,0,'image_scale','a:3:{s:5:\"width\";s:2:\"50\";s:6:\"height\";s:2:\"50\";s:7:\"upscale\";i:1;}'),(5,4,2,'image_scale_and_crop','a:2:{s:5:\"width\";s:3:\"880\";s:6:\"height\";s:3:\"350\";}'),(6,5,1,'image_scale_and_crop','a:2:{s:5:\"width\";s:3:\"416\";s:6:\"height\";s:3:\"261\";}'),(7,6,1,'image_scale_and_crop','a:2:{s:5:\"width\";s:3:\"272\";s:6:\"height\";s:3:\"167\";}'),(8,7,1,'image_scale_and_crop','a:2:{s:5:\"width\";s:3:\"260\";s:6:\"height\";s:3:\"140\";}'),(9,8,1,'image_scale_and_crop','a:2:{s:5:\"width\";s:3:\"350\";s:6:\"height\";s:3:\"300\";}'),(10,9,1,'image_scale_and_crop','a:2:{s:5:\"width\";s:3:\"290\";s:6:\"height\";s:3:\"156\";}'),(11,10,1,'image_scale_and_crop','a:2:{s:5:\"width\";s:2:\"45\";s:6:\"height\";s:2:\"45\";}');
/*!40000 ALTER TABLE `image_effects` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `image_styles`
--

DROP TABLE IF EXISTS `image_styles`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `image_styles` (
  `isid` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'The primary identifier for an image style.',
  `name` varchar(255) NOT NULL COMMENT 'The style machine name.',
  `label` varchar(255) NOT NULL DEFAULT '' COMMENT 'The style administrative name.',
  PRIMARY KEY (`isid`),
  UNIQUE KEY `name` (`name`)
) ENGINE=InnoDB AUTO_INCREMENT=11 DEFAULT CHARSET=utf8 COMMENT='Stores configuration options for image styles.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `image_styles`
--

LOCK TABLES `image_styles` WRITE;
/*!40000 ALTER TABLE `image_styles` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `image_styles` VALUES (2,'thumbnail','Thumbnail (100x100)'),(4,'large','Large (880x350)'),(5,'two_columns','Two Columns'),(6,'three_columns','Three Columns'),(7,'four_columns','Four Columns'),(8,'blog_mix','Blog Mix'),(9,'hot_video','Hot Video'),(10,'small','small (45 x 45)');
/*!40000 ALTER TABLE `image_styles` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `languages`
--

DROP TABLE IF EXISTS `languages`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `languages` (
  `language` varchar(12) NOT NULL DEFAULT '' COMMENT 'Language code, e.g. ’de’ or ’en-US’.',
  `name` varchar(64) NOT NULL DEFAULT '' COMMENT 'Language name in English.',
  `native` varchar(64) NOT NULL DEFAULT '' COMMENT 'Native language name.',
  `direction` int(11) NOT NULL DEFAULT '0' COMMENT 'Direction of language (Left-to-Right = 0, Right-to-Left = 1).',
  `enabled` int(11) NOT NULL DEFAULT '0' COMMENT 'Enabled flag (1 = Enabled, 0 = Disabled).',
  `plurals` int(11) NOT NULL DEFAULT '0' COMMENT 'Number of plural indexes in this language.',
  `formula` varchar(255) NOT NULL DEFAULT '' COMMENT 'Plural formula in PHP code to evaluate to get plural indexes.',
  `domain` varchar(128) NOT NULL DEFAULT '' COMMENT 'Domain to use for this language.',
  `prefix` varchar(128) NOT NULL DEFAULT '' COMMENT 'Path prefix to use for this language.',
  `weight` int(11) NOT NULL DEFAULT '0' COMMENT 'Weight, used in lists of languages.',
  `javascript` varchar(64) NOT NULL DEFAULT '' COMMENT 'Location of JavaScript translation file.',
  PRIMARY KEY (`language`),
  KEY `list` (`weight`,`name`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='List of all available languages in the system.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `languages`
--

LOCK TABLES `languages` WRITE;
/*!40000 ALTER TABLE `languages` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `languages` VALUES ('ar','Arabic','العربية',1,1,0,'','','ar',-9,''),('en','English','English',0,1,0,'','','en',-10,''),('fr','French','Français',0,1,0,'','','fr',-8,'');
/*!40000 ALTER TABLE `languages` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `locales_source`
--

DROP TABLE IF EXISTS `locales_source`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `locales_source` (
  `lid` int(11) NOT NULL AUTO_INCREMENT COMMENT 'Unique identifier of this string.',
  `location` longtext COMMENT 'Drupal path in case of online discovered translations or file path in case of imported strings.',
  `textgroup` varchar(255) NOT NULL DEFAULT 'default' COMMENT 'A module defined group of translations, see hook_locale().',
  `source` blob NOT NULL COMMENT 'The original string in English.',
  `context` varchar(255) NOT NULL DEFAULT '' COMMENT 'The context this string applies to.',
  `version` varchar(20) NOT NULL DEFAULT 'none' COMMENT 'Version of Drupal, where the string was last used (for locales optimization).',
  PRIMARY KEY (`lid`),
  KEY `source_context` (`source`(30),`context`),
  KEY `textgroup_context` (`textgroup`,`context`)
) ENGINE=InnoDB AUTO_INCREMENT=5370 DEFAULT CHARSET=utf8 COMMENT='List of English source strings.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `locales_source`
--

LOCK TABLES `locales_source` WRITE;
/*!40000 ALTER TABLE `locales_source` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `locales_source` VALUES (1,'misc/drupal.js','default','An AJAX HTTP error occurred.','','none'),(2,'misc/drupal.js','default','HTTP Result Code: !status','','none'),(3,'misc/drupal.js','default','An AJAX HTTP request terminated abnormally.','','none'),(4,'misc/drupal.js','default','Debugging information follows.','','none'),(5,'misc/drupal.js','default','Path: !uri','','none'),(6,'misc/drupal.js','default','StatusText: !statusText','','none'),(7,'misc/drupal.js','default','ResponseText: !responseText','','none'),(8,'misc/drupal.js','default','ReadyState: !readyState','','none'),(9,'modules/overlay/overlay-child.js','default','Loading','','7.39'),(10,'modules/overlay/overlay-child.js; misc/vertical-tabs.js','default','(active tab)','','7.39'),(11,'sites/all/modules/module_filter/js/module_filter.js','default','No results','','none'),(12,'sites/all/modules/module_filter/js/module_filter.js','default','clear','','none'),(13,'sites/all/modules/module_filter/js/module_filter_tab.js','default','All','','7.34'),(14,'sites/all/modules/module_filter/js/module_filter_tab.js','default','New','','none'),(15,'sites/all/modules/module_filter/js/module_filter_tab.js','default','Modules installed within the last week.','','none'),(16,'sites/all/modules/module_filter/js/module_filter_tab.js','default','No modules added within the last week.','','none'),(17,'sites/all/modules/module_filter/js/module_filter_tab.js','default','Recent','','none'),(18,'sites/all/modules/module_filter/js/module_filter_tab.js','default','Modules enabled/disabled within the last week.','','none'),(19,'sites/all/modules/module_filter/js/module_filter_tab.js','default','No modules were enabled or disabled within the last week.','','none'),(20,'sites/all/modules/module_filter/js/module_filter_tab.js','default','@enabled of @total','','none'),(21,'modules/block/block.js; sites/all/modules/i18n/i18n_block/i18n_block.js','default','Not restricted','','none'),(22,'modules/block/block.js','default','Restricted to certain pages','','none'),(23,'modules/block/block.js','default','Not customizable','','7.28'),(24,'modules/block/block.js','default','The changes to these blocks will not be saved until the <em>Save blocks</em> button is clicked.','','none'),(25,'modules/block/block.js','default','The block cannot be placed in this region.','','none'),(26,'misc/tabledrag.js','default','Re-order rows by numerical weight instead of dragging.','','none'),(27,'misc/tabledrag.js','default','Show row weights','','none'),(28,'misc/tabledrag.js','default','Hide row weights','','none'),(29,'misc/tabledrag.js','default','Drag to re-order','','none'),(30,'misc/tabledrag.js','default','Changes made in this table will not be saved until the form is submitted.','','none'),(31,'misc/collapse.js','default','Hide','','none'),(32,'misc/collapse.js','default','Show','','7.28'),(33,'sites/all/modules/i18n/i18n_block/i18n_block.js','default','Translatable','','none'),(34,'sites/all/modules/i18n/i18n_block/i18n_block.js','default','Not translatable','','none'),(35,'sites/all/modules/i18n/i18n_block/i18n_block.js','default','Restricted to certain languages','','none'),(36,'sites/all/themes/forum_plus/js/weebpal.js','default','Are you sure you want to reset your theme settings to default theme settings?','','none'),(37,'modules/overlay/overlay-parent.js; sites/all/modules/jquery_update/replace/misc/1.9/overlay-parent.js','default','@title dialog','','none'),(38,'modules/contextual/contextual.js','default','Configure','','7.39'),(39,'misc/machine-name.js','default','Edit','','7.39'),(40,'misc/tableselect.js','default','Select all rows in this table','','none'),(41,'misc/tableselect.js','default','Deselect all rows in this table','','none'),(42,'modules/field/modules/text/text.js','default','Hide summary','','none'),(43,'modules/field/modules/text/text.js','default','Edit summary','','none'),(44,'misc/autocomplete.js','default','Autocomplete popup','','none'),(45,'misc/autocomplete.js','default','Searching for matches...','','none'),(46,'misc/ajax.js','default','Please wait...','','none'),(47,'modules/file/file.js','default','The selected file %filename cannot be uploaded. Only files with the following extensions are allowed: %extensions.','','none'),(48,'modules/menu/menu.js','default','Not in menu','','none'),(49,'modules/book/book.js','default','Not in book','','none'),(50,'modules/book/book.js','default','New book','','none'),(51,'modules/node/node.js','default','New revision','','none'),(52,'modules/node/node.js','default','No revision','','none'),(53,'modules/node/node.js','default','By @name on @date','','none'),(54,'modules/node/node.js','default','By @name','','none'),(55,'modules/node/node.js; modules/node/content_types.js','default','Not published','','7.39'),(56,'modules/path/path.js; sites/all/modules/pathauto/pathauto.js','default','Alias: @alias','','none'),(57,'modules/path/path.js; sites/all/modules/pathauto/pathauto.js','default','No alias','','none'),(58,'modules/comment/comment-node-form.js','default','@number comments per page','','none'),(59,'modules/node/content_types.js','default','Requires a title','','none'),(60,'modules/node/content_types.js','default','Don\'t display post information','','none'),(61,'modules/user/user.permissions.js','default','This permission is inherited from the authenticated user role.','','none'),(62,'sites/all/modules/admin_menu/admin_menu.admin.js','default','Also allow !name role to !permission?','','none'),(63,'sites/all/modules/views/js/views-admin.js','default','Add','','7.39'),(64,'sites/all/modules/views/js/views-admin.js','default','Remove group','','none'),(65,'sites/all/modules/views/js/views-admin.js','default','Apply (all displays)','','none'),(66,'sites/all/modules/views/js/views-admin.js','default','Revert to default','','none'),(67,'sites/all/modules/views/js/views-admin.js','default','Apply (this display)','','none'),(68,'sites/all/modules/token/token.js','default','Loading token browser...','','none'),(69,'sites/all/modules/token/token.js','default','Available tokens','','none'),(70,'sites/all/modules/token/token.js','default','Insert this token into your form','','none'),(71,'sites/all/modules/token/token.js','default','First click a text field to insert your tokens into.','','none'),(72,'/weebpal/forum-plus/admin/structure/views/view/activity_stream?render=overlay&render=overlay','default','Master','','7.39'),(73,'/weebpal/forum-plus/admin/structure/views/view/activity_stream?render=overlay&render=overlay','default','Activity Stream','','7.39'),(74,'/weebpal/forum-plus/admin/structure/views/view/activity_stream?render=overlay&render=overlay','default','more','','7.39'),(75,'/weebpal/forum-plus/admin/structure/views/view/activity_stream?render=overlay&render=overlay','default','Apply','','7.39'),(76,'/weebpal/forum-plus/admin/structure/views/view/activity_stream?render=overlay&render=overlay','default','Reset','','7.39'),(77,'/weebpal/forum-plus/admin/structure/views/view/activity_stream?render=overlay&render=overlay','default','Sort by','','7.39'),(78,'/weebpal/forum-plus/admin/structure/views/view/activity_stream?render=overlay&render=overlay','default','Asc','','7.39'),(79,'/weebpal/forum-plus/admin/structure/views/view/activity_stream?render=overlay&render=overlay','default','Desc','','7.39'),(80,'/weebpal/forum-plus/admin/structure/views/view/activity_stream?render=overlay&render=overlay','default','Items per page','','7.39'),(81,'/weebpal/forum-plus/admin/structure/views/view/activity_stream?render=overlay&render=overlay','default','- All -','','7.39'),(82,'/weebpal/forum-plus/admin/structure/views/view/activity_stream?render=overlay&render=overlay','default','Offset','','7.39'),(83,'/weebpal/forum-plus/admin/structure/views/view/activity_stream?render=overlay&render=overlay','default','« first','','7.39'),(84,'/weebpal/forum-plus/admin/structure/views/view/activity_stream?render=overlay&render=overlay','default','‹ previous','','7.39'),(85,'/weebpal/forum-plus/admin/structure/views/view/activity_stream?render=overlay&render=overlay','default','next ›','','7.39'),(86,'/weebpal/forum-plus/admin/structure/views/view/activity_stream?render=overlay&render=overlay','default','last »','','7.39'),(87,'/weebpal/forum-plus/admin/structure/views/view/activity_stream?render=overlay&render=overlay','default','User','','7.39'),(88,'/weebpal/forum-plus/admin/structure/views/view/activity_stream?render=overlay&render=overlay','default','Message ID','','7.39'),(89,'/weebpal/forum-plus/admin/structure/views/view/activity_stream?render=overlay&render=overlay','default','.','','7.39'),(90,'/weebpal/forum-plus/admin/structure/views/view/activity_stream?render=overlay&render=overlay','default',',','','7.39'),(91,'/weebpal/forum-plus/admin/structure/views/view/activity_stream?render=overlay&render=overlay','default','Picture','','7.39'),(92,'/weebpal/forum-plus/admin/structure/views/view/activity_stream?render=overlay&render=overlay','default','Page','','7.39'),(93,'/weebpal/forum-plus/admin/structure/views/view/blogs?render=overlay&render=overlay','default','Blogs','','7.39'),(94,'/weebpal/forum-plus/admin/structure/views/view/blogs?render=overlay&render=overlay','default','Read more ...','','7.28'),(95,'/weebpal/forum-plus/admin/structure/views/view/blogs?render=overlay&render=overlay','default','<i class=\"fa fa-comments\"></i> [comment_count]','','7.39'),(96,'/weebpal/forum-plus/admin/structure/views/view/blogs?render=overlay&render=overlay','default','<i class=\"fa fa-eye\"></i> [totalcount]','','7.39'),(97,'/weebpal/forum-plus/admin/structure/views/view/blogs/edit?render=overlay&render=overlay','default','author','','7.39'),(98,'/weebpal/forum-plus/admin/structure/views/view/blogs?render=overlay&render=overlay','default','Fieldset','','7.39'),(99,'/weebpal/forum-plus/admin/structure/views/view/blogs?render=overlay&render=overlay','default','Name','','7.39'),(100,'/weebpal/forum-plus/admin/structure/views/view/blogs?render=overlay&render=overlay','default','By [name]','','7.39'),(101,'/weebpal/forum-plus/admin/structure/views/view/recent_blogs?render=overlay&render=overlay','default','Recent Blogs','','7.39'),(102,'/weebpal/forum-plus/admin/structure/views/view/recent_blogs?render=overlay&render=overlay','default','Block','','7.39'),(103,'/weebpal/forum-plus/admin/structure/views/view/recent_blogs?render=overlay&render=overlay','default','Recent Entities','','7.39'),(104,'/weebpal/forum-plus/admin/structure/views/view/recent_blogs/edit/block_1?render=overlay&render=overlay','default','Most Popular','','7.39'),(105,'quicktabs:title:quicktab','quicktabs','Quicktab','title:quicktab','1'),(106,'quicktabs:tab:quicktab-0:title','quicktabs','Recent Entities','tab:quicktab-0:title','1'),(107,'quicktabs:tab:quicktab-1:title','quicktabs','Most Popular','tab:quicktab-1:title','1'),(108,'quicktabs:tab:quicktab-2:title','quicktabs','Best Blogs','tab:quicktab-2:title','1'),(109,'/weebpal/forum-plus/admin/structure/views/view/comments?render=overlay&render=overlay','default','Comments','','7.39'),(110,'/weebpal/forum-plus/admin/structure/views/view/comments?render=overlay&render=overlay','default','Content','','7.39'),(111,'sites/all/modules/pathauto/pathauto.js','default','Automatic alias','','none'),(112,'/weebpal/forum-plus/admin/structure/views/view/articles/edit/page?destination=articles&render=overlay&render=overlay','default','Articles','','7.39'),(113,'taxonomy:vocabulary:2:name','taxonomy','Forums','vocabulary:2:name','1'),(114,'taxonomy:vocabulary:2:description','taxonomy','Forum navigation vocabulary','vocabulary:2:description','1'),(115,'taxonomy:vocabulary:3:name','taxonomy','Categories','vocabulary:3:name','1'),(116,'taxonomy:vocabulary:4:name','taxonomy','Sections','vocabulary:4:name','1'),(117,'taxonomy:vocabulary:1:name','taxonomy','Tags','vocabulary:1:name','1'),(118,'taxonomy:vocabulary:1:description','taxonomy','Use tags to group articles on similar topics into categories.','vocabulary:1:description','1'),(119,'/weebpal/forum-plus/fr','default','Public files','','7.39'),(120,'/weebpal/forum-plus/fr','default','Public local files served by the webserver.','','7.39'),(121,'/weebpal/forum-plus/fr','default','Temporary files','','7.39'),(122,'/weebpal/forum-plus/fr','default','Temporary local files for upload and previews.','','7.39'),(123,'/weebpal/forum-plus/fr','default','Forums','','7.39'),(124,'/weebpal/forum-plus/fr','default','Long','','7.39'),(125,'/weebpal/forum-plus/fr','default','Medium','','7.39'),(126,'/weebpal/forum-plus/fr','default','Short','','7.39'),(127,'/weebpal/forum-plus/fr','default','Comment','','7.39'),(128,'/weebpal/forum-plus/fr','default','Full comment','','7.39'),(129,'/weebpal/forum-plus/fr','default','Blog entry','','7.39'),(130,'/weebpal/forum-plus/fr','default','Use for multi-user blogs. Every user gets a personal blog.','','7.39'),(131,'/weebpal/forum-plus/fr','default','Forum topic','','7.39'),(132,'/weebpal/forum-plus/fr','default','A <em>forum topic</em> starts a new discussion thread within a forum.','','7.39'),(133,'/weebpal/forum-plus/fr','default','Subject','','7.39'),(134,'/weebpal/forum-plus/fr','default','@node_type comment','','7.39'),(135,'/weebpal/forum-plus/fr','default','Taxonomy term','','7.39'),(136,'/weebpal/forum-plus/fr','default','Translation set','','7.39'),(137,'/weebpal/forum-plus/fr','default','Message type category','','7.39'),(138,'/weebpal/forum-plus/fr','default','Message type','','7.39'),(139,'/weebpal/forum-plus/fr','default','Message','','7.39'),(140,'/weebpal/forum-plus/fr','default','Full','','7.39'),(141,'/weebpal/forum-plus/fr','default','Node','','7.39'),(142,'/weebpal/forum-plus/fr','default','Full content','','7.39'),(143,'/weebpal/forum-plus/fr','default','Teaser','','7.39'),(144,'/weebpal/forum-plus/fr','default','RSS','','7.39'),(145,'/weebpal/forum-plus/fr','default','Search index','','7.39'),(146,'/weebpal/forum-plus/fr','default','Search result','','7.32'),(147,'/weebpal/forum-plus/fr','default','File','','7.39'),(148,'/weebpal/forum-plus/fr','default','Taxonomy term page','','7.39'),(149,'/weebpal/forum-plus/fr','default','Taxonomy vocabulary','','7.39'),(150,'/weebpal/forum-plus/fr','default','User account','','7.39'),(151,'/weebpal/forum-plus/fr','default','Print','','7.39'),(152,'/weebpal/forum-plus/fr','default','Tokens','','7.39'),(153,'/weebpal/forum-plus/fr','default','Nodes','','7.39'),(154,'/weebpal/forum-plus/fr','default','Users','','7.39'),(155,'/weebpal/forum-plus/fr','default','Files','','7.39'),(156,'/weebpal/forum-plus/fr','default','Nodes represent the main site content items.','','7.39'),(157,'/weebpal/forum-plus/fr','default','Users who have created accounts on your site.','','7.39'),(158,'/weebpal/forum-plus/fr','default','Uploaded file.','','7.39'),(159,'/weebpal/forum-plus/fr','default','Remark or note that refers to a node.','','7.39'),(160,'/weebpal/forum-plus/fr','default','Taxonomy terms','','7.39'),(161,'/weebpal/forum-plus/fr','default','Taxonomy terms are used for classifying content.','','7.39'),(162,'/weebpal/forum-plus/fr','default','Taxonomy vocabularies','','7.39'),(163,'/weebpal/forum-plus/fr','default','Vocabularies contain related taxonomy terms, which are used for classifying content.','','7.39'),(164,'/weebpal/forum-plus/fr','default','Description','','7.39'),(165,'/weebpal/forum-plus/fr','default','Vocabulary','','7.39'),(166,'/weebpal/forum-plus/fr','default','vocabulary','','7.39'),(167,'/weebpal/forum-plus/fr','default','terms','','7.39'),(168,'/weebpal/forum-plus/fr','default','Title','','7.39'),(169,'/weebpal/forum-plus/fr','default','Body','','7.39'),(170,'/weebpal/forum-plus/fr','default','Home','','7.39'),(171,'/weebpal/forum-plus/fr','default','No new','','7.39'),(172,'/weebpal/forum-plus/fr','default','View user profile.','','7.39'),(173,'/weebpal/forum-plus/fr','default','1 week','','7.34'),(174,'/weebpal/forum-plus/fr','default','@count days','','7.39'),(175,'/weebpal/forum-plus/fr','default','...','','7.39'),(176,'/weebpal/forum-plus/fr','default','!title<br />by !author<br />@date_posted','','7.39'),(177,'/weebpal/forum-plus/fr','default','@count hours','','7.32'),(178,'/weebpal/forum-plus/fr','default','n/a','','7.34'),(179,'/weebpal/forum-plus/fr','default','Forum','','7.39'),(180,'/weebpal/forum-plus/fr','default','Topics','','7.39'),(181,'/weebpal/forum-plus/fr','default','Posts','','7.39'),(182,'/weebpal/forum-plus/fr','default','Last post','','7.39'),(183,'/weebpal/forum-plus/fr','default','View active forum posts','','7.39'),(184,'/weebpal/forum-plus/fr','default','View unanswered forum posts','','7.39'),(185,'/weebpal/forum-plus/fr','default','View new forum posts','','7.39'),(186,'/weebpal/forum-plus/fr','default','Mark all forums read','','7.39'),(187,'/weebpal/forum-plus/fr','default','- Forum Tools -','','7.39'),(188,'/weebpal/forum-plus/fr','default','Go','','7.39'),(189,'/weebpal/forum-plus/fr','default','- Choose -','','7.39'),(190,'/weebpal/forum-plus/fr','default','What\'s Going On?','','7.39'),(191,'/weebpal/forum-plus/fr','default','Currently active users: !current_total','','7.39'),(192,'/weebpal/forum-plus/fr','default','Statistics','','7.39'),(193,'/weebpal/forum-plus/fr','default','Topics: !topics, Posts: !posts, Users: !users','','7.39'),(194,'/weebpal/forum-plus/fr','default','Welcome to our latest members: !users','','7.39'),(195,'/weebpal/forum-plus/fr','default','New posts','','7.39'),(196,'/weebpal/forum-plus/fr','default','No new posts','','7.39'),(197,'/weebpal/forum-plus/fr','default','Headline','','7.39'),(198,'/weebpal/forum-plus/fr','default','Header','','7.39'),(199,'/weebpal/forum-plus/fr','default','Main Menu','','7.39'),(200,'/weebpal/forum-plus/fr','default','Slideshow','','7.39'),(201,'/weebpal/forum-plus/fr','default','Help','','7.39'),(202,'/weebpal/forum-plus/fr','default','Page top','','7.39'),(203,'/weebpal/forum-plus/fr','default','Page bottom','','7.39'),(204,'/weebpal/forum-plus/fr','default','Highlighted','','7.39'),(205,'/weebpal/forum-plus/fr','default','Featured','','7.39'),(206,'/weebpal/forum-plus/fr','default','Sidebar first','','7.39'),(207,'/weebpal/forum-plus/fr','default','Sidebar second','','7.39'),(208,'/weebpal/forum-plus/fr','default','Panel First','','7.39'),(209,'/weebpal/forum-plus/fr','default','Panel Second','','7.39'),(210,'/weebpal/forum-plus/fr','default','Panel Third','','7.39'),(211,'/weebpal/forum-plus/fr','default','Panel Footer 1','','7.39'),(212,'/weebpal/forum-plus/fr','default','Panel Footer 2','','7.39'),(213,'/weebpal/forum-plus/fr','default','Panel Footer 3','','7.39'),(214,'/weebpal/forum-plus/fr','default','Panel Footer 4','','7.39'),(215,'/weebpal/forum-plus/fr','default','Footer','','7.39'),(216,'/weebpal/forum-plus/fr','default','Dashboard (main)','','7.39'),(217,'/weebpal/forum-plus/fr','default','Dashboard (sidebar)','','7.39'),(218,'/weebpal/forum-plus/fr','default','Dashboard (inactive)','','7.39'),(219,'/weebpal/forum-plus/fr','default','User menu','','7.39'),(220,'/weebpal/forum-plus/fr','default','My account','','7.39'),(221,'/weebpal/forum-plus/fr','default','Log out','','7.39'),(222,'/weebpal/forum-plus/fr','default','Search','','7.39'),(223,'/weebpal/forum-plus/fr','default','Enter the terms you wish to search for.','','7.39'),(224,'/weebpal/forum-plus/fr','default','Main menu','','7.39'),(225,'/weebpal/forum-plus/fr','default','Books','','7.39'),(226,'/weebpal/forum-plus/fr','default','View Forums','','7.39'),(227,'/weebpal/forum-plus/fr','default','Active topics','','7.39'),(228,'/weebpal/forum-plus/fr','default','New & updated topics','','7.39'),(229,'/weebpal/forum-plus/fr','default','Unanswered topics','','7.39'),(230,'/weebpal/forum-plus/fr','default','What\'s New','','7.39'),(231,'/weebpal/forum-plus/fr','default','No language match','','7.39'),(232,'/weebpal/forum-plus/fr','default','Languages','','7.39'),(233,'/weebpal/forum-plus/fr','default','Features','','7.39'),(234,'/weebpal/forum-plus/fr','default','Categories','','7.39'),(235,'/weebpal/forum-plus/fr','default','Features menu','','7.28'),(236,'/weebpal/forum-plus/fr','default','Footer menu','','7.39'),(237,'/weebpal/forum-plus/fr','default','Links','','7.39'),(238,'/weebpal/forum-plus/fr','default','Sections','','7.39'),(239,'/weebpal/forum-plus/fr','default','New forum topics','','7.34'),(240,'/weebpal/forum-plus/fr','default','Contact','','7.39'),(241,'/weebpal/forum-plus/fr','default','Management','','7.39'),(242,'/weebpal/forum-plus/fr','default','Navigation','','7.39'),(243,'/weebpal/forum-plus/fr','default','Normal','','7.39'),(244,'/weebpal/forum-plus/fr','default','Default','','7.39'),(245,'/weebpal/forum-plus/fr','default','Administration','','7.39'),(246,'/weebpal/forum-plus/fr','default','Appearance','','7.39'),(247,'/weebpal/forum-plus/fr','default','Select and configure your themes.','','7.39'),(248,'/weebpal/forum-plus/fr','default','List','','7.39'),(249,'/weebpal/forum-plus/fr','default','Select and configure your theme','','7.39'),(250,'/weebpal/forum-plus/fr','default','Settings','','7.39'),(251,'/weebpal/forum-plus/fr','default','Configure default and theme specific settings.','','7.39'),(252,'/weebpal/forum-plus/fr','default','Bartik','','7.39'),(253,'/weebpal/forum-plus/fr','default','Global settings','','7.39'),(254,'/weebpal/forum-plus/fr','default','Seven','','7.39'),(255,'/weebpal/forum-plus/fr','default','Forum Plus','','7.39'),(256,'/weebpal/forum-plus/fr','default','Install new theme','','7.39'),(257,'/weebpal/forum-plus/fr','default','Update','','7.39'),(258,'/weebpal/forum-plus/fr','default','Configuration','','7.39'),(259,'/weebpal/forum-plus/fr','default','Administer settings.','','7.39'),(260,'/weebpal/forum-plus/fr','default','Content authoring','','7.39'),(261,'/weebpal/forum-plus/fr','default','Settings related to formatting and authoring content.','','7.39'),(262,'/weebpal/forum-plus/fr','default','Text formats','','7.39'),(263,'/weebpal/forum-plus/fr','default','Configure how content input by users is filtered, including allowed HTML tags. Also allows enabling of module-provided filters.','','7.39'),(264,'/weebpal/forum-plus/fr','default','Add text format','','7.39'),(265,'/weebpal/forum-plus/fr','default','TagClouds configuration','','7.39'),(266,'/weebpal/forum-plus/fr','default','Configure the tag clouds. Set the order, the number of tags, and the depth of the clouds.','','7.39'),(267,'/weebpal/forum-plus/fr','default','Advanced Forum','','7.39'),(268,'/weebpal/forum-plus/fr','default','Configure Advanced Forum with these settings.','','7.39'),(269,'/weebpal/forum-plus/fr','default','Fivestar','','7.39'),(270,'/weebpal/forum-plus/fr','default','Configure site-wide widgets used for Fivestar rating.','','7.39'),(271,'/weebpal/forum-plus/fr','default','Development','','7.39'),(272,'/weebpal/forum-plus/fr','default','Development tools.','','7.39'),(273,'/weebpal/forum-plus/fr','default','Logging and errors','','7.39'),(274,'/weebpal/forum-plus/fr','default','Settings for logging and alerts modules. Various modules can route Drupal\'s system events to different destinations, such as syslog, database, email, etc.','','7.39'),(275,'/weebpal/forum-plus/fr','default','Maintenance mode','','7.39'),(276,'/weebpal/forum-plus/fr','default','Take the site offline for maintenance or bring it back online.','','7.39'),(277,'/weebpal/forum-plus/fr','default','Performance','','7.39'),(278,'/weebpal/forum-plus/fr','default','Enable or disable page caching for anonymous users and set CSS and JS bandwidth optimization options.','','7.39'),(279,'/weebpal/forum-plus/fr','default','Strongarm','','7.39'),(280,'/weebpal/forum-plus/fr','default','Manage Drupal variable settings that have been strongarmed.','','7.39'),(281,'/weebpal/forum-plus/fr','default','jQuery update','','7.39'),(282,'/weebpal/forum-plus/fr','default','Configure settings related to the jQuery upgrade, the library path and compression.','','7.39'),(283,'/weebpal/forum-plus/fr','default','Media','','7.39'),(284,'/weebpal/forum-plus/fr','default','Media tools.','','7.39'),(285,'/weebpal/forum-plus/fr','default','File system','','7.39'),(286,'/weebpal/forum-plus/fr','default','Tell Drupal where to store uploaded files and how they are accessed.','','7.39'),(287,'/weebpal/forum-plus/fr','default','Image styles','','7.39'),(288,'/weebpal/forum-plus/fr','default','Configure styles that can be used for resizing or adjusting images on display.','','7.39'),(289,'/weebpal/forum-plus/fr','default','Add style','','7.39'),(290,'/weebpal/forum-plus/fr','default','Add a new image style.','','7.39'),(291,'/weebpal/forum-plus/fr','default','List the current image styles on the site.','','7.39'),(292,'/weebpal/forum-plus/fr','default','Image toolkit','','7.39'),(293,'/weebpal/forum-plus/fr','default','Choose which image toolkit to use if you have installed optional toolkits.','','7.39'),(294,'/weebpal/forum-plus/fr','default','People','','7.39'),(295,'/weebpal/forum-plus/fr','default','Configure user accounts.','','7.39'),(296,'/weebpal/forum-plus/fr','default','Account settings','','7.39'),(297,'/weebpal/forum-plus/fr','default','Configure default behavior of users, including registration requirements, e-mails, fields, and user pictures.','','7.39'),(298,'/weebpal/forum-plus/fr','default','Manage display','','7.39'),(299,'/weebpal/forum-plus/fr','default','Manage fields','','7.39'),(300,'/weebpal/forum-plus/fr','default','IP address blocking','','7.39'),(301,'/weebpal/forum-plus/fr','default','Manage blocked IP addresses.','','7.39'),(302,'/weebpal/forum-plus/fr','default','Gravatar','','7.28'),(303,'/weebpal/forum-plus/fr','default','Administer Gravatar integration.','','7.28'),(304,'/weebpal/forum-plus/fr','default','Robohash','','7.28'),(305,'/weebpal/forum-plus/fr','default','Configure Robohash for User Pic Kit','','7.28'),(306,'/weebpal/forum-plus/fr','default','User Pic Kit','','7.28'),(307,'/weebpal/forum-plus/fr','default','Configure User Pic Kit','','7.28'),(308,'/weebpal/forum-plus/fr','default','Maintenance','','7.28'),(309,'/weebpal/forum-plus/fr','default','Migration and maintenance of User Pic Kit.','','7.28'),(310,'/weebpal/forum-plus/fr','default','Picture types','','7.28'),(311,'/weebpal/forum-plus/fr','default','Configure settings for picture types','','7.28'),(312,'/weebpal/forum-plus/fr','default','Regional and language','','7.39'),(313,'/weebpal/forum-plus/fr','default','Regional settings, localization and translation.','','7.39'),(314,'/weebpal/forum-plus/fr','default','Date and time','','7.39'),(315,'/weebpal/forum-plus/fr','default','Configure display formats for date and time.','','7.39'),(316,'/weebpal/forum-plus/fr','default','Formats','','7.39'),(317,'/weebpal/forum-plus/fr','default','Configure display format strings for date and time.','','7.39'),(318,'/weebpal/forum-plus/fr','default','Add format','','7.39'),(319,'/weebpal/forum-plus/fr','default','Allow users to add additional date formats.','','7.39'),(320,'/weebpal/forum-plus/fr','default','Types','','7.39'),(321,'/weebpal/forum-plus/fr','default','Add date type','','7.39'),(322,'/weebpal/forum-plus/fr','default','Add new date type.','','7.39'),(323,'/weebpal/forum-plus/fr','default','Localize','','7.39'),(324,'/weebpal/forum-plus/fr','default','Configure date formats for each locale','','7.39'),(325,'/weebpal/forum-plus/fr','default','Regional settings','','7.39'),(326,'/weebpal/forum-plus/fr','default','Settings for the site\'s default time zone and country.','','7.39'),(327,'/weebpal/forum-plus/fr','default','Configure languages for content and the user interface.','','7.39'),(328,'/weebpal/forum-plus/fr','default','Add language','','7.39'),(329,'/weebpal/forum-plus/fr','default','Detection and selection','','7.39'),(330,'/weebpal/forum-plus/fr','default','Session language detection configuration','','7.39'),(331,'/weebpal/forum-plus/fr','default','URL language detection configuration','','7.39'),(332,'/weebpal/forum-plus/fr','default','Icons','','7.39'),(333,'/weebpal/forum-plus/fr','default','Multilingual settings','','7.39'),(334,'/weebpal/forum-plus/fr','default','Configure extended options for multilingual content and translations.','','7.39'),(335,'/weebpal/forum-plus/fr','default','Multilingual system','','7.39'),(336,'/weebpal/forum-plus/fr','default','Strings','','7.39'),(337,'/weebpal/forum-plus/fr','default','Options for user defined strings.','','7.39'),(338,'/weebpal/forum-plus/fr','default','Translate interface','','7.39'),(339,'/weebpal/forum-plus/fr','default','Translate the built in interface and optionally other text.','','7.39'),(340,'/weebpal/forum-plus/fr','default','Export','','7.39'),(341,'/weebpal/forum-plus/fr','default','Import','','7.39'),(342,'/weebpal/forum-plus/fr','default','Overview','','7.39'),(343,'/weebpal/forum-plus/fr','default','Refresh user defined strings.','','7.39'),(344,'/weebpal/forum-plus/fr','default','Translate','','7.39'),(345,'/weebpal/forum-plus/fr','default','Translation sets','','7.39'),(346,'/weebpal/forum-plus/fr','default','Translation sets overview.','','7.39'),(347,'/weebpal/forum-plus/fr','default','Overview of existing translation sets.','','7.39'),(348,'/weebpal/forum-plus/fr','default','Search and metadata','','7.39'),(349,'/weebpal/forum-plus/fr','default','Local site search, metadata and SEO.','','7.39'),(350,'/weebpal/forum-plus/fr','default','Clean URLs','','7.39'),(351,'/weebpal/forum-plus/fr','default','Enable or disable clean URLs for your site.','','7.39'),(352,'/weebpal/forum-plus/fr','default','Search settings','','7.39'),(353,'/weebpal/forum-plus/fr','default','Configure relevance settings for search and other indexing options.','','7.39'),(354,'/weebpal/forum-plus/fr','default','Clear index','','7.39'),(355,'/weebpal/forum-plus/fr','default','URL aliases','','7.39'),(356,'/weebpal/forum-plus/fr','default','Change your site\'s URL paths by aliasing them.','','7.39'),(357,'/weebpal/forum-plus/fr','default','Add alias','','7.39'),(358,'/weebpal/forum-plus/fr','default','Bulk update','','7.39'),(359,'/weebpal/forum-plus/fr','default','Delete aliases','','7.39'),(360,'/weebpal/forum-plus/fr','default','Patterns','','7.39'),(361,'/weebpal/forum-plus/fr','default','Voting API','','7.39'),(362,'/weebpal/forum-plus/fr','default','Configure sitewide settings for user-generated ratings and votes.','','7.39'),(363,'/weebpal/forum-plus/fr','default','System','','7.39'),(364,'/weebpal/forum-plus/fr','default','General system related configuration.','','7.39'),(365,'/weebpal/forum-plus/fr','default','Actions','','7.39'),(366,'/weebpal/forum-plus/fr','default','Manage the actions defined for your site.','','7.39'),(367,'/weebpal/forum-plus/fr','default','Configure an advanced action','','7.39'),(368,'/weebpal/forum-plus/fr','default','Manage actions','','7.39'),(369,'/weebpal/forum-plus/fr','default','Cron','','7.39'),(370,'/weebpal/forum-plus/fr','default','Manage automatic site maintenance tasks.','','7.39'),(371,'/weebpal/forum-plus/fr','default','Site information','','7.39'),(372,'/weebpal/forum-plus/fr','default','Change site name, e-mail address, slogan, default front page, and number of posts per page, error pages.','','7.39'),(373,'/weebpal/forum-plus/fr','default','Control details about what and how your site logs access statistics.','','7.39'),(374,'/weebpal/forum-plus/fr','default','Message settings','','7.39'),(375,'/weebpal/forum-plus/fr','default','Manage message purging upon cron.','','7.39'),(376,'/weebpal/forum-plus/fr','default','Copy messages text fields','','7.39'),(377,'/weebpal/forum-plus/fr','default','Copy messages text fields from one language to others','','7.39'),(378,'/weebpal/forum-plus/fr','default','AddToAny','','7.28'),(379,'/weebpal/forum-plus/fr','default','Settings for your <a href=\"http://www.addtoany.com/\" target=\"blank\">AddToAny</a> Share/Save buttons.','','7.28'),(380,'/weebpal/forum-plus/fr','default','User interface','','7.39'),(381,'/weebpal/forum-plus/fr','default','Tools that enhance the user interface.','','7.39'),(382,'/weebpal/forum-plus/fr','default','Shortcuts','','7.39'),(383,'/weebpal/forum-plus/fr','default','Add and modify shortcut sets.','','7.39'),(384,'/weebpal/forum-plus/fr','default','Add shortcut set','','7.39'),(385,'/weebpal/forum-plus/fr','default','Module filter','','7.39'),(386,'/weebpal/forum-plus/fr','default','Configure how the modules page looks and acts.','','7.39'),(387,'/weebpal/forum-plus/fr','default','Web services','','7.39'),(388,'/weebpal/forum-plus/fr','default','Tools related to web services.','','7.39'),(389,'/weebpal/forum-plus/fr','default','RSS publishing','','7.39'),(390,'/weebpal/forum-plus/fr','default','Configure the site description, the number of items per feed and whether feeds should be titles/teasers/full-text.','','7.39'),(391,'/weebpal/forum-plus/fr','default','Workflow','','7.39'),(392,'/weebpal/forum-plus/fr','default','Content workflow, editorial workflow tools.','','7.39'),(393,'/weebpal/forum-plus/fr','default','Administration tools.','','7.39'),(394,'/weebpal/forum-plus/fr','default','Administration menu','','7.39'),(395,'/weebpal/forum-plus/fr','default','Adjust administration menu settings.','','7.39'),(396,'/weebpal/forum-plus/fr','default','Administer content and comments.','','7.39'),(397,'/weebpal/forum-plus/fr','default','List and edit site comments and the comment approval queue.','','7.39'),(398,'/weebpal/forum-plus/fr','default','Published comments','','7.39'),(399,'/weebpal/forum-plus/fr','default','Unapproved comments (@count)','','7.39'),(400,'/weebpal/forum-plus/fr','default','Manage your site\'s book outlines.','','7.39'),(401,'/weebpal/forum-plus/fr','default','Messages','','7.39'),(402,'/weebpal/forum-plus/fr','default','A list of all messages.','','7.39'),(403,'/weebpal/forum-plus/fr','default','Dashboard','','7.39'),(404,'/weebpal/forum-plus/fr','default','View and customize your dashboard.','','7.39'),(405,'/weebpal/forum-plus/fr','default','Configure available dashboard blocks','','7.39'),(406,'/weebpal/forum-plus/fr','default','Configure which blocks can be shown on the dashboard.','','7.39'),(407,'/weebpal/forum-plus/fr; modules/dashboard/dashboard.js','default','Customize dashboard','','7.39'),(408,'/weebpal/forum-plus/fr','default','Customize your dashboard.','','7.39'),(409,'/weebpal/forum-plus/fr','default','Index','','7.39'),(410,'/weebpal/forum-plus/fr','default','Modules','','7.39'),(411,'/weebpal/forum-plus/fr','default','Extend site functionality.','','7.39'),(412,'/weebpal/forum-plus/fr','default','Uninstall','','7.39'),(413,'/weebpal/forum-plus/fr','default','Install new module','','7.39'),(414,'/weebpal/forum-plus/fr','default','Manage user accounts, roles, and permissions.','','7.39'),(415,'/weebpal/forum-plus/fr','default','Add user','','7.39'),(416,'/weebpal/forum-plus/fr','default','Find and manage people interacting with your site.','','7.39'),(417,'/weebpal/forum-plus/fr','default','Permissions','','7.39'),(418,'/weebpal/forum-plus/fr','default','Determine access to features by selecting permissions for roles.','','7.39'),(419,'/weebpal/forum-plus/fr','default','Roles','','7.39'),(420,'/weebpal/forum-plus/fr','default','List, edit, or add user roles.','','7.39'),(421,'/weebpal/forum-plus/fr','default','Reports','','7.39'),(422,'/weebpal/forum-plus/fr','default','View reports, updates, and errors.','','7.39'),(423,'/weebpal/forum-plus/fr','default','Field list','','7.39'),(424,'/weebpal/forum-plus/fr','default','Overview of fields on all entity types.','','7.39'),(425,'/weebpal/forum-plus/fr','default','Used in views','','7.39'),(426,'/weebpal/forum-plus/fr','default','Overview of fields used in all views.','','7.39'),(427,'/weebpal/forum-plus/fr','default','Recent log messages','','7.39'),(428,'/weebpal/forum-plus/fr','default','View events that have recently been logged.','','7.39'),(429,'/weebpal/forum-plus/fr','default','Status report','','7.39'),(430,'/weebpal/forum-plus/fr','default','Get a status report about your site\'s operation and any detected problems.','','7.39'),(431,'/weebpal/forum-plus/fr','default','Top \'access denied\' errors','','7.39'),(432,'/weebpal/forum-plus/fr','default','View \'access denied\' errors (403s).','','7.39'),(433,'/weebpal/forum-plus/fr','default','Top \'page not found\' errors','','7.39'),(434,'/weebpal/forum-plus/fr','default','View \'page not found\' errors (404s).','','7.39'),(435,'/weebpal/forum-plus/fr','default','Top search phrases','','7.39'),(436,'/weebpal/forum-plus/fr','default','View most popular search phrases.','','7.39'),(437,'/weebpal/forum-plus/fr','default','Available updates','','7.39'),(438,'/weebpal/forum-plus/fr','default','Get a status report about available updates for your installed modules and themes.','','7.39'),(439,'/weebpal/forum-plus/fr','default','Install new module or theme','','7.39'),(440,'/weebpal/forum-plus/fr','default','Views plugins','','7.39'),(441,'/weebpal/forum-plus/fr','default','Overview of plugins used in all views.','','7.39'),(442,'/weebpal/forum-plus/fr','default','Recent hits','','7.39'),(443,'/weebpal/forum-plus/fr','default','View pages that have recently been visited.','','7.39'),(444,'/weebpal/forum-plus/fr','default','Top pages','','7.39'),(445,'/weebpal/forum-plus/fr','default','View pages that have been hit frequently.','','7.39'),(446,'/weebpal/forum-plus/fr','default','Top referrers','','7.39'),(447,'/weebpal/forum-plus/fr','default','View top referrers.','','7.39'),(448,'/weebpal/forum-plus/fr','default','Top visitors','','7.39'),(449,'/weebpal/forum-plus/fr','default','View visitors that hit many pages.','','7.39'),(450,'/weebpal/forum-plus/fr','default','Structure','','7.39'),(451,'/weebpal/forum-plus/fr','default','Administer blocks, content types, menus, etc.','','7.39'),(452,'/weebpal/forum-plus/fr','default','Blocks','','7.39'),(453,'/weebpal/forum-plus/fr','default','Configure what block content appears in your site\'s sidebars and other regions.','','7.39'),(454,'/weebpal/forum-plus/fr','default','Add block','','7.39'),(455,'/weebpal/forum-plus/fr','default','Content types','','7.39'),(456,'/weebpal/forum-plus/fr','default','Manage content types, including default status, front page promotion, comment settings, etc.','','7.39'),(457,'/weebpal/forum-plus/fr','default','Add content type','','7.39'),(458,'/weebpal/forum-plus/fr','default','Menus','','7.39'),(459,'/weebpal/forum-plus/fr','default','Add new menus to your site, edit existing menus, and rename and reorganize menu links.','','7.39'),(460,'/weebpal/forum-plus/fr','default','Add menu','','7.39'),(461,'/weebpal/forum-plus/fr','default','List menus','','7.39'),(462,'/weebpal/forum-plus/fr','default','Taxonomy','','7.39'),(463,'/weebpal/forum-plus/fr','default','Manage tagging, categorization, and classification of your content.','','7.39'),(464,'/weebpal/forum-plus/fr','default','Add vocabulary','','7.39'),(465,'/weebpal/forum-plus/fr','default','Control forum hierarchy settings.','','7.39'),(466,'/weebpal/forum-plus/fr','default','Add container','','7.39'),(467,'/weebpal/forum-plus/fr','default','Add forum','','7.39'),(468,'/weebpal/forum-plus/fr','default','view','','7.39'),(469,'/weebpal/forum-plus/fr','default','View','','7.39'),(470,'/weebpal/forum-plus/fr','default','views','','7.39'),(471,'/weebpal/forum-plus/fr','default','Views','','7.39'),(472,'/weebpal/forum-plus/fr','default','This action will permanently remove any customizations made to this view.','','7.39'),(473,'/weebpal/forum-plus/fr','default','The view has been reverted.','','7.39'),(474,'/weebpal/forum-plus/fr','default','This action will permanently remove the view from your database.','','7.39'),(475,'/weebpal/forum-plus/fr','default','The view has been deleted.','','7.39'),(476,'/weebpal/forum-plus/fr','default','Enable','','7.39'),(477,'/weebpal/forum-plus/fr','default','Disable','','7.39'),(478,'/weebpal/forum-plus/fr','default','Revert','','7.39'),(479,'/weebpal/forum-plus/fr','default','Delete','','7.39'),(480,'/weebpal/forum-plus/fr','default','Clone','','7.39'),(481,'/weebpal/forum-plus/fr','default','Add a new @plugin','','7.39'),(482,'/weebpal/forum-plus/fr','default','Edit @plugin %title','','7.39'),(483,'/weebpal/forum-plus/fr','default','Clone @plugin %title','','7.39'),(484,'/weebpal/forum-plus/fr','default','Import @plugin','','7.39'),(485,'/weebpal/forum-plus/fr','default','Export @plugin %title','','7.39'),(486,'/weebpal/forum-plus/fr','default','Are you sure you want to revert %title?','','7.39'),(487,'/weebpal/forum-plus/fr','default','This action will permanently remove any customizations made to this item.','','7.39'),(488,'/weebpal/forum-plus/fr','default','The item has been reverted.','','7.39'),(489,'/weebpal/forum-plus/fr','default','Are you sure you want to delete %title?','','7.39'),(490,'/weebpal/forum-plus/fr','default','This action will permanently remove this item from your database..','','7.39'),(491,'/weebpal/forum-plus/fr','default','The item has been deleted.','','7.39'),(492,'/weebpal/forum-plus/fr','default','%title has been created.','','7.39'),(493,'/weebpal/forum-plus/fr','default','%title could not be created.','','7.39'),(494,'/weebpal/forum-plus/fr','default','%title has been updated.','','7.39'),(495,'/weebpal/forum-plus/fr','default','%title could not be updated.','','7.39'),(496,'/weebpal/forum-plus/fr','default','You can import an exported definition by pasting the exported object code into the field below.','','7.39'),(497,'/weebpal/forum-plus/fr','default','@plugin %title was enabled.','','7.39'),(498,'/weebpal/forum-plus/fr','default','@plugin %title was disabled.','','7.39'),(499,'/weebpal/forum-plus/fr','default','There are no @titles to display.','','7.39'),(500,'/weebpal/forum-plus/fr','default','Manage customized lists of content.','','7.39'),(501,'/weebpal/forum-plus/fr','default','Add new view','','7.39'),(502,'/weebpal/forum-plus/fr','default','Add view from template','','7.39'),(503,'/weebpal/forum-plus/fr','default','Advanced','','7.39'),(504,'/weebpal/forum-plus/fr','default','Basic','','7.39'),(505,'/weebpal/forum-plus/fr','default','Contact form','','7.39'),(506,'/weebpal/forum-plus/fr','default','Create a system contact form and set up categories for the form to use.','','7.39'),(507,'/weebpal/forum-plus/fr','default','Add category','','7.39'),(508,'/weebpal/forum-plus/fr','default','Message types','','7.39'),(509,'/weebpal/forum-plus/fr','default','Manage Message types.','','7.39'),(510,'/weebpal/forum-plus/fr','default','Add @entity_type','','7.39'),(511,'/weebpal/forum-plus/fr','default','Import @entity_type','','7.39'),(512,'/weebpal/forum-plus/fr','default','Manage features.','','7.39'),(513,'/weebpal/forum-plus/fr','default','Create feature','','7.39'),(514,'/weebpal/forum-plus/fr','default','Create a new feature.','','7.39'),(515,'/weebpal/forum-plus/fr','default','Manage','','7.39'),(516,'/weebpal/forum-plus/fr','default','Enable and disable features.','','7.39'),(517,'/weebpal/forum-plus/fr','default','Adjust settings for using features module.','','7.39'),(518,'/weebpal/forum-plus/fr','default','Quicktabs','','7.39'),(519,'/weebpal/forum-plus/fr','default','Create blocks of tabbed content.','','7.39'),(520,'/weebpal/forum-plus/fr','default','Add Quicktabs Instance','','7.39'),(521,'/weebpal/forum-plus/fr','default','List quicktabs','','7.39'),(522,'/weebpal/forum-plus/fr','default','Tasks','','7.39'),(523,'/weebpal/forum-plus/fr','default','Reference for usage, configuration, and modules.','','7.39'),(524,'/weebpal/forum-plus/fr','default','block','','7.39'),(525,'/weebpal/forum-plus/fr','default','color','','7.39'),(526,'/weebpal/forum-plus/fr','default','comment','','7.39'),(527,'/weebpal/forum-plus/fr','default','contextual','','7.39'),(528,'/weebpal/forum-plus/fr','default','dashboard','','7.39'),(529,'/weebpal/forum-plus/fr','default','dblog','','7.39'),(530,'/weebpal/forum-plus/fr','default','field','','7.39'),(531,'/weebpal/forum-plus/fr','default','field_sql_storage','','7.39'),(532,'/weebpal/forum-plus/fr','default','field_ui','','7.39'),(533,'/weebpal/forum-plus/fr','default','file','','7.39'),(534,'/weebpal/forum-plus/fr','default','filter','','7.39'),(535,'/weebpal/forum-plus/fr','default','help','','7.39'),(536,'/weebpal/forum-plus/fr','default','image','','7.39'),(537,'/weebpal/forum-plus/fr','default','list','','7.39'),(538,'/weebpal/forum-plus/fr','default','menu','','7.39'),(539,'/weebpal/forum-plus/fr','default','node','','7.39'),(540,'/weebpal/forum-plus/fr','default','number','','7.39'),(541,'/weebpal/forum-plus/fr','default','options','','7.39'),(542,'/weebpal/forum-plus/fr','default','overlay','','7.39'),(543,'/weebpal/forum-plus/fr','default','path','','7.39'),(544,'/weebpal/forum-plus/fr','default','rdf','','7.28'),(545,'/weebpal/forum-plus/fr','default','search','','7.39'),(546,'/weebpal/forum-plus/fr','default','shortcut','','7.39'),(547,'/weebpal/forum-plus/fr','default','system','','7.39'),(548,'/weebpal/forum-plus/fr','default','taxonomy','','7.39'),(549,'/weebpal/forum-plus/fr','default','text','','7.39'),(550,'/weebpal/forum-plus/fr','default','user','','7.39'),(551,'/weebpal/forum-plus/fr','default','update','','7.39'),(552,'/weebpal/forum-plus/fr','default','blog','','7.39'),(553,'/weebpal/forum-plus/fr','default','book','','7.39'),(554,'/weebpal/forum-plus/fr','default','forum','','7.39'),(555,'/weebpal/forum-plus/fr','default','views_slideshow','','7.39'),(556,'/weebpal/forum-plus/fr','default','views_slideshow_cycle','','7.39'),(557,'/weebpal/forum-plus/fr','default','admin_menu','','7.39'),(558,'/weebpal/forum-plus/fr','default','i18n','','7.39'),(559,'/weebpal/forum-plus/fr','default','i18n_block','','7.39'),(560,'/weebpal/forum-plus/fr','default','i18n_string','','7.39'),(561,'/weebpal/forum-plus/fr','default','lang_dropdown','','7.39'),(562,'/weebpal/forum-plus/fr','default','lang_dropdown_hideout','','7.39'),(563,'/weebpal/forum-plus/fr','default','languageicons','','7.39'),(564,'/weebpal/forum-plus/fr','default','locale','','7.39'),(565,'/weebpal/forum-plus/fr','default','contact','','7.39'),(566,'/weebpal/forum-plus/fr','default','statistics','','7.39'),(567,'/weebpal/forum-plus/fr','default','fivestar','','7.39'),(568,'/weebpal/forum-plus/fr','default','features','','7.39'),(569,'/weebpal/forum-plus/fr','default','strongarm','','7.39'),(570,'/weebpal/forum-plus/fr','default','token','','7.39'),(571,'/weebpal/forum-plus/fr','default','gravatar','','7.28'),(572,'/weebpal/forum-plus/fr','default','jquery_update','','7.39'),(573,'/weebpal/forum-plus/fr','default','pathauto','','7.39'),(574,'/weebpal/forum-plus/fr','default','quicktabs','','7.39'),(575,'/weebpal/forum-plus/fr','default','i18n_taxonomy','','7.39'),(576,'/weebpal/forum-plus/fr','default','Field settings','','7.39'),(577,'/weebpal/forum-plus/fr','default','Widget type','','7.39'),(578,'/weebpal/forum-plus/fr','default','Add link','','7.39'),(579,'/weebpal/forum-plus/fr','default','Delete menu','','7.39'),(580,'/weebpal/forum-plus/fr','default','Edit menu','','7.39'),(581,'/weebpal/forum-plus/fr','default','List links','','7.39'),(582,'/weebpal/forum-plus/fr','default','Add term','','7.39'),(583,'/weebpal/forum-plus/fr','default','Terms','','7.39'),(584,'/weebpal/forum-plus/fr','default','AddToAny link','','7.28'),(585,'/weebpal/forum-plus/fr','default','Link provided by the AddToAny module','','7.28'),(586,'/weebpal/forum-plus/fr','default','Book','','7.39'),(587,'/weebpal/forum-plus/fr','default','Top level book','','7.39'),(588,'/weebpal/forum-plus/fr','default','The book the node is in.','','7.39'),(589,'/weebpal/forum-plus/fr','default','Weight','','7.39'),(590,'/weebpal/forum-plus/fr','default','The weight of the book page.','','7.39'),(591,'/weebpal/forum-plus/fr','default','Depth','','7.39'),(592,'/weebpal/forum-plus/fr','default','The depth of the book page in the hierarchy; top level books have a depth of 1.','','7.39'),(593,'/weebpal/forum-plus/fr','default','Hierarchy','','7.39'),(594,'/weebpal/forum-plus/fr','default','The order of pages in the book hierarchy.','','7.39'),(595,'/weebpal/forum-plus/fr','default','Parent','','7.39'),(596,'/weebpal/forum-plus/fr','default','The parent book node.','','7.39'),(597,'/weebpal/forum-plus/fr','default','Book parent','','7.39'),(598,'/weebpal/forum-plus/fr','default','Comments are responses to node content.','','7.39'),(599,'/weebpal/forum-plus/fr','default','The title of the comment.','','7.39'),(600,'/weebpal/forum-plus/fr','default','ID','','7.39'),(601,'/weebpal/forum-plus/fr','default','The comment ID of the field','','7.39'),(602,'/weebpal/forum-plus/fr','default','Author','','7.39'),(603,'/weebpal/forum-plus/fr','default','The name of the comment\'s author. Can be rendered as a link to the author\'s homepage.','','7.39'),(604,'/weebpal/forum-plus/fr','default','Author\'s website','','7.39'),(605,'/weebpal/forum-plus/fr','default','The website address of the comment\'s author. Can be rendered as a link. Will be empty if the author is a registered user.','','7.39'),(606,'/weebpal/forum-plus/fr','default','Hostname','','7.39'),(607,'/weebpal/forum-plus/fr','default','Hostname of user that posted the comment.','','7.39'),(608,'/weebpal/forum-plus/fr','default','Mail','','7.39'),(609,'/weebpal/forum-plus/fr','default','Email of user that posted the comment. Will be empty if the author is a registered user.','','7.39'),(610,'/weebpal/forum-plus/fr','default','Post date','','7.39'),(611,'/weebpal/forum-plus/fr','default','Date and time of when the comment was created.','','7.39'),(612,'/weebpal/forum-plus/fr','default','Language','','7.39'),(613,'/weebpal/forum-plus/fr','default','The language the comment is in.','','7.39'),(614,'/weebpal/forum-plus/fr','default','Updated date','','7.39'),(615,'/weebpal/forum-plus/fr','default','Date and time of when the comment was last updated.','','7.39'),(616,'/weebpal/forum-plus/fr','default','Created date','','7.39'),(617,'/weebpal/forum-plus/fr','default','Date in the form of CCYYMMDD.','','7.39'),(618,'/weebpal/forum-plus/fr','default','Created year + month','','7.39'),(619,'/weebpal/forum-plus/fr','default','Date in the form of YYYYMM.','','7.39'),(620,'/weebpal/forum-plus/fr','default','Created year','','7.39'),(621,'/weebpal/forum-plus/fr','default','Date in the form of YYYY.','','7.39'),(622,'/weebpal/forum-plus/fr','default','Created month','','7.39'),(623,'/weebpal/forum-plus/fr','default','Date in the form of MM (01 - 12).','','7.39'),(624,'/weebpal/forum-plus/fr','default','Created day','','7.39'),(625,'/weebpal/forum-plus/fr','default','Date in the form of DD (01 - 31).','','7.39'),(626,'/weebpal/forum-plus/fr','default','Created week','','7.39'),(627,'/weebpal/forum-plus/fr','default','Date in the form of WW (01 - 53).','','7.39'),(628,'/weebpal/forum-plus/fr','default','Approved','','7.39'),(629,'/weebpal/forum-plus/fr','default','Whether the comment is approved (or still in the moderation queue).','','7.39'),(630,'/weebpal/forum-plus/fr','default','Not Approved','','7.39'),(631,'/weebpal/forum-plus/fr','default','Approved comment','','7.39'),(632,'/weebpal/forum-plus/fr','default','View link','','7.39'),(633,'/weebpal/forum-plus/fr','default','Provide a simple link to view the comment.','','7.39'),(634,'/weebpal/forum-plus/fr','default','Edit link','','7.39'),(635,'/weebpal/forum-plus/fr','default','Provide a simple link to edit the comment.','','7.39'),(636,'/weebpal/forum-plus/fr','default','Delete link','','7.39'),(637,'/weebpal/forum-plus/fr','default','Provide a simple link to delete the comment.','','7.39'),(638,'/weebpal/forum-plus/fr','default','Approve link','','7.39'),(639,'/weebpal/forum-plus/fr','default','Provide a simple link to approve the comment.','','7.39'),(640,'/weebpal/forum-plus/fr','default','Reply-to link','','7.39'),(641,'/weebpal/forum-plus/fr','default','Provide a simple link to reply to the comment.','','7.39'),(642,'/weebpal/forum-plus/fr','default','Display the depth of the comment if it is threaded.','','7.39'),(643,'/weebpal/forum-plus/fr','default','Thread','','7.39'),(644,'/weebpal/forum-plus/fr','default','Sort by the threaded order. This will keep child comments together with their parents.','','7.39'),(645,'/weebpal/forum-plus/fr','default','Nid','','7.39'),(646,'/weebpal/forum-plus/fr','default','The node ID to which the comment is a reply to.','','7.39'),(647,'/weebpal/forum-plus/fr','default','The content to which the comment is a reply to.','','7.39'),(648,'/weebpal/forum-plus/fr','default','Author uid','','7.39'),(649,'/weebpal/forum-plus/fr','default','If you need more fields than the uid add the comment: author relationship','','7.39'),(650,'/weebpal/forum-plus/fr','default','The User ID of the comment\'s author.','','7.39'),(651,'/weebpal/forum-plus/fr','default','Parent CID','','7.39'),(652,'/weebpal/forum-plus/fr','default','The Comment ID of the parent comment.','','7.39'),(653,'/weebpal/forum-plus/fr','default','Parent comment','','7.39'),(654,'/weebpal/forum-plus/fr','default','The parent comment.','','7.39'),(655,'/weebpal/forum-plus/fr','default','Last comment time','','7.39'),(656,'/weebpal/forum-plus/fr','default','Date and time of when the last comment was posted.','','7.39'),(657,'/weebpal/forum-plus/fr','default','Last comment author','','7.39'),(658,'/weebpal/forum-plus/fr','default','The name of the author of the last posted comment.','','7.39'),(659,'/weebpal/forum-plus/fr','default','Comment count','','7.39'),(660,'/weebpal/forum-plus/fr','default','The number of comments a node has.','','7.39'),(661,'/weebpal/forum-plus/fr','default','Updated/commented date','','7.39'),(662,'/weebpal/forum-plus/fr','default','The most recent of last comment posted or node updated time.','','7.39'),(663,'/weebpal/forum-plus/fr','default','Last comment CID','','7.39'),(664,'/weebpal/forum-plus/fr','default','Display the last comment of a node','','7.39'),(665,'/weebpal/forum-plus/fr','default','Last Comment','','7.39'),(666,'/weebpal/forum-plus/fr','default','The last comment of a node.','','7.39'),(667,'/weebpal/forum-plus/fr','default','Last comment uid','','7.39'),(668,'/weebpal/forum-plus/fr','default','The User ID of the author of the last comment of a node.','','7.39'),(669,'/weebpal/forum-plus/fr','default','@entity \"@property\" property.','','7.39'),(670,'/weebpal/forum-plus/fr','default','Machine-readable name','','7.39'),(671,'/weebpal/forum-plus/fr','default','The machine-readable name identifying this @entity.','','7.39'),(672,'/weebpal/forum-plus/fr','default','Internal, numeric @entity ID','','7.39'),(673,'/weebpal/forum-plus/fr','default','The ID used to identify this @entity internally.','','7.39'),(674,'/weebpal/forum-plus/fr','default','Label','','7.39'),(675,'/weebpal/forum-plus/fr','default','The human readable label.','','7.39'),(676,'/weebpal/forum-plus/fr','default','@entity ID','','7.39'),(677,'/weebpal/forum-plus/fr','default','The unique ID of the @entity.','','7.39'),(678,'/weebpal/forum-plus/fr','default','The message type.','','7.39'),(679,'/weebpal/forum-plus/fr','default','The user for which to log the message.','','7.39'),(680,'/weebpal/forum-plus/fr','default','The time the message has been logged.','','7.39'),(681,'/weebpal/forum-plus/fr','default','The message text','','7.39'),(682,'/weebpal/forum-plus/fr','default','The message text with all replacement arguments applied.','','7.39'),(683,'/weebpal/forum-plus/fr','default','Message arguments','','7.39'),(684,'/weebpal/forum-plus/fr','default','The arguments to associate with the message.','','7.39'),(685,'/weebpal/forum-plus/fr','default','Argument @key','','7.39'),(686,'/weebpal/forum-plus/fr','default','The replacement value for @key','','7.39'),(687,'/weebpal/forum-plus/fr','default','Comment ID','','7.39'),(688,'/weebpal/forum-plus/fr','default','The unique ID of the comment.','','7.39'),(689,'/weebpal/forum-plus/fr','default','IP Address','','7.39'),(690,'/weebpal/forum-plus/fr','default','The IP address of the computer the comment was posted from.','','7.39'),(691,'/weebpal/forum-plus/fr','default','The name left by the comment author.','','7.39'),(692,'/weebpal/forum-plus/fr','default','Email address','','7.39'),(693,'/weebpal/forum-plus/fr','default','The email address left by the comment author.','','7.39'),(694,'/weebpal/forum-plus/fr','default','Home page','','7.39'),(695,'/weebpal/forum-plus/fr','default','The home page URL left by the comment author.','','7.39'),(696,'/weebpal/forum-plus/fr','default','The subject of the comment.','','7.39'),(697,'/weebpal/forum-plus/fr','default','URL','','7.39'),(698,'/weebpal/forum-plus/fr','default','The URL of the comment.','','7.39'),(699,'/weebpal/forum-plus/fr','default','Edit URL','','7.39'),(700,'/weebpal/forum-plus/fr','default','The URL of the comment\'s edit page.','','7.39'),(701,'/weebpal/forum-plus/fr','default','Date created','','7.39'),(702,'/weebpal/forum-plus/fr','default','The date the comment was posted.','','7.39'),(703,'/weebpal/forum-plus/fr','default','The comment\'s parent, if comment threading is active.','','7.39'),(704,'/weebpal/forum-plus/fr','default','The node the comment was posted to.','','7.39'),(705,'/weebpal/forum-plus/fr','default','The author of the comment.','','7.39'),(706,'/weebpal/forum-plus/fr','default','Status','','7.39'),(707,'/weebpal/forum-plus/fr','default','Whether the comment is published or unpublished.','','7.39'),(708,'/weebpal/forum-plus/fr','default','Entity Reference','','7.39'),(709,'/weebpal/forum-plus/fr','default','This field reference another entity.','','7.39'),(710,'/weebpal/forum-plus/fr','default','This field stores the ID of a file as an integer value.','','7.39'),(711,'/weebpal/forum-plus/fr','default','Fivestar Rating','','7.39'),(712,'/weebpal/forum-plus/fr','default','Store a rating for this piece of content.','','7.39'),(713,'/weebpal/forum-plus/fr','default','Image','','7.39'),(714,'/weebpal/forum-plus/fr','default','This field stores the ID of an image file as an integer value.','','7.39'),(715,'/weebpal/forum-plus/fr','default','List (integer)','','7.39'),(716,'/weebpal/forum-plus/fr','default','This field stores integer values from a list of allowed \'value => label\' pairs, i.e. \'Lifetime in days\': 1 => 1 day, 7 => 1 week, 31 => 1 month.','','7.39'),(717,'/weebpal/forum-plus/fr','default','List (float)','','7.39'),(718,'/weebpal/forum-plus/fr','default','This field stores float values from a list of allowed \'value => label\' pairs, i.e. \'Fraction\': 0 => 0, .25 => 1/4, .75 => 3/4, 1 => 1.','','7.39'),(719,'/weebpal/forum-plus/fr','default','List (text)','','7.39'),(720,'/weebpal/forum-plus/fr','default','This field stores text values from a list of allowed \'value => label\' pairs, i.e. \'US States\': IL => Illinois, IA => Iowa, IN => Indiana.','','7.39'),(721,'/weebpal/forum-plus/fr','default','Boolean','','7.39'),(722,'/weebpal/forum-plus/fr','default','This field stores simple on/off or yes/no options.','','7.39'),(723,'/weebpal/forum-plus/fr','default','Integer','','7.39'),(724,'/weebpal/forum-plus/fr','default','This field stores a number in the database as an integer.','','7.39'),(725,'/weebpal/forum-plus/fr','default','Decimal','','7.39'),(726,'/weebpal/forum-plus/fr','default','This field stores a number in the database in a fixed decimal format.','','7.39'),(727,'/weebpal/forum-plus/fr','default','Float','','7.39'),(728,'/weebpal/forum-plus/fr','default','This field stores a number in the database in a floating point format.','','7.39'),(729,'/weebpal/forum-plus/fr','default','Term reference','','7.39'),(730,'/weebpal/forum-plus/fr','default','This field stores a reference to a taxonomy term.','','7.39'),(731,'/weebpal/forum-plus/fr','default','Text','','7.39'),(732,'/weebpal/forum-plus/fr','default','This field stores varchar text in the database.','','7.39'),(733,'/weebpal/forum-plus/fr','default','Long text','','7.39'),(734,'/weebpal/forum-plus/fr','default','This field stores long text in the database.','','7.39'),(735,'/weebpal/forum-plus/fr','default','Long text and summary','','7.39'),(736,'/weebpal/forum-plus/fr','default','This field stores long text in the database along with optional summary text.','','7.39'),(737,'/weebpal/forum-plus/fr','default','Autocomplete','','7.39'),(738,'/weebpal/forum-plus/fr','default','An autocomplete text field.','','7.39'),(739,'/weebpal/forum-plus/fr','default','Autocomplete (Tags style)','','7.39'),(740,'/weebpal/forum-plus/fr','default','Stars (rated while viewing)','','7.39'),(741,'/weebpal/forum-plus/fr','default','Stars (rated while editing)','','7.39'),(742,'/weebpal/forum-plus/fr','default','Select list (rated while editing)','','7.39'),(743,'/weebpal/forum-plus/fr','default','Text field','','7.39'),(744,'/weebpal/forum-plus/fr','default','Select list','','7.39'),(745,'/weebpal/forum-plus/fr','default','Check boxes/radio buttons','','7.39'),(746,'/weebpal/forum-plus/fr','default','Single on/off checkbox','','7.39'),(747,'/weebpal/forum-plus/fr','default','Autocomplete term widget (tagging)','','7.39'),(748,'/weebpal/forum-plus/fr','default','Text area (multiple rows)','','7.39'),(749,'/weebpal/forum-plus/fr','default','Text area with a summary','','7.39'),(750,'/weebpal/forum-plus/fr','default','Display the label of the referenced entities.','','7.39'),(751,'/weebpal/forum-plus/fr','default','Entity id','','7.39'),(752,'/weebpal/forum-plus/fr','default','Display the id of the referenced entities.','','7.39'),(753,'/weebpal/forum-plus/fr','default','Rendered entity','','7.39'),(754,'/weebpal/forum-plus/fr','default','Display the referenced entities rendered by entity_view().','','7.39'),(755,'/weebpal/forum-plus/fr','default','Generic file','','7.39'),(756,'/weebpal/forum-plus/fr','default','Table of files','','7.39'),(757,'/weebpal/forum-plus/fr','default','URL to file','','7.39'),(758,'/weebpal/forum-plus/fr','default','As Stars','','7.39'),(759,'/weebpal/forum-plus/fr','default','Rating (i.e. 4.2/5)','','7.39'),(760,'/weebpal/forum-plus/fr','default','Percentage (i.e. 92)','','7.39'),(761,'/weebpal/forum-plus/fr','default','Key','','7.39'),(762,'/weebpal/forum-plus/fr','default','Unformatted','','7.39'),(763,'/weebpal/forum-plus/fr','default','Link','','7.39'),(764,'/weebpal/forum-plus/fr','default','Plain text','','7.39'),(765,'/weebpal/forum-plus/fr','default','RSS category','','7.39'),(766,'/weebpal/forum-plus/fr','default','Trimmed','','7.39'),(767,'/weebpal/forum-plus/fr','default','Summary or trimmed','','7.39'),(768,'/weebpal/forum-plus/fr','default','Link (localized)','','7.39'),(769,'/weebpal/forum-plus/fr','default','Plain text (localized)','','7.39'),(770,'/weebpal/forum-plus/fr','default','Default SQL storage','','7.39'),(771,'/weebpal/forum-plus/fr','default','Stores fields in the local SQL database, using per-field tables.','','7.39'),(772,'/weebpal/forum-plus/fr','default','Field \"@name\".','','7.39'),(773,'/weebpal/forum-plus/fr','default','Summary','','7.39'),(774,'/weebpal/forum-plus/fr','default','Text format','','7.39'),(775,'/weebpal/forum-plus/fr','default','The file.','','7.39'),(776,'/weebpal/forum-plus/fr','default','The file description','','7.39'),(777,'/weebpal/forum-plus/fr','default','Whether the file is being displayed.','','7.39'),(778,'/weebpal/forum-plus/fr','default','The image file.','','7.39'),(779,'/weebpal/forum-plus/fr','default','The \"Alt\" attribute text','','7.39'),(780,'/weebpal/forum-plus/fr','default','The \"Title\" attribute text','','7.39'),(781,'/weebpal/forum-plus/fr','default','Average Rating','','7.39'),(782,'/weebpal/forum-plus/fr','default','User\'s Rating','','7.39'),(783,'/weebpal/forum-plus/fr','default','Rating count','','7.39'),(784,'/weebpal/forum-plus/fr','default','Node ID','','7.39'),(785,'/weebpal/forum-plus/fr','default','The unique ID of the node.','','7.39'),(786,'/weebpal/forum-plus/fr','default','Revision ID','','7.39'),(787,'/weebpal/forum-plus/fr','default','The unique ID of the node\'s revision.','','7.39'),(788,'/weebpal/forum-plus/fr','default','Is new','','7.39'),(789,'/weebpal/forum-plus/fr','default','Whether the node is new and not saved to the database yet.','','7.39'),(790,'/weebpal/forum-plus/fr','default','Content type','','7.39'),(791,'/weebpal/forum-plus/fr','default','The type of the node.','','7.39'),(792,'/weebpal/forum-plus/fr','default','The title of the node.','','7.39'),(793,'/weebpal/forum-plus/fr','default','The language the node is written in.','','7.39'),(794,'/weebpal/forum-plus/fr','default','The URL of the node.','','7.39'),(795,'/weebpal/forum-plus/fr','default','The URL of the node\'s edit page.','','7.39'),(796,'/weebpal/forum-plus/fr','default','Whether the node is published or unpublished.','','7.39'),(797,'/weebpal/forum-plus/fr','default','Promoted to frontpage','','7.39'),(798,'/weebpal/forum-plus/fr','default','Whether the node is promoted to the frontpage.','','7.39'),(799,'/weebpal/forum-plus/fr','default','Sticky in lists','','7.39'),(800,'/weebpal/forum-plus/fr','default','Whether the node is displayed at the top of lists in which it appears.','','7.39'),(801,'/weebpal/forum-plus/fr','default','The date the node was posted.','','7.39'),(802,'/weebpal/forum-plus/fr','default','Date changed','','7.39'),(803,'/weebpal/forum-plus/fr','default','The date the node was most recently updated.','','7.39'),(804,'/weebpal/forum-plus/fr','default','The author of the node.','','7.39'),(805,'/weebpal/forum-plus/fr','default','Translation source node','','7.39'),(806,'/weebpal/forum-plus/fr','default','The original-language version of this node, if one exists.','','7.39'),(807,'/weebpal/forum-plus/fr','default','Revision log message','','7.39'),(808,'/weebpal/forum-plus/fr','default','In case a new revision is to be saved, the log entry explaining the changes for this version.','','7.39'),(809,'/weebpal/forum-plus/fr','default','Creates revision','','7.39'),(810,'/weebpal/forum-plus/fr','default','Whether saving this node creates a new revision.','','7.39'),(811,'/weebpal/forum-plus/fr','default','Term ID','','7.39'),(812,'/weebpal/forum-plus/fr','default','The unique ID of the taxonomy term.','','7.39'),(813,'/weebpal/forum-plus/fr','default','The name of the taxonomy term.','','7.39'),(814,'/weebpal/forum-plus/fr','default','The optional description of the taxonomy term.','','7.39'),(815,'/weebpal/forum-plus/fr','default','The weight of the term, which is used for ordering terms during display.','','7.39'),(816,'/weebpal/forum-plus/fr','default','Node count','','7.39'),(817,'/weebpal/forum-plus/fr','default','The number of nodes tagged with the taxonomy term.','','7.39'),(818,'/weebpal/forum-plus/fr','default','The URL of the taxonomy term.','','7.39'),(819,'/weebpal/forum-plus/fr','default','The vocabulary the taxonomy term belongs to.','','7.39'),(820,'/weebpal/forum-plus/fr','default','Parent terms','','7.39'),(821,'/weebpal/forum-plus/fr','default','The parent terms of the taxonomy term.','','7.39'),(822,'/weebpal/forum-plus/fr','default','All parent terms','','7.39'),(823,'/weebpal/forum-plus/fr','default','Ancestors of the term, i.e. parent of all above hierarchy levels.','','7.39'),(824,'/weebpal/forum-plus/fr','default','Vocabulary ID','','7.39'),(825,'/weebpal/forum-plus/fr','default','The unique ID of the taxonomy vocabulary.','','7.39'),(826,'/weebpal/forum-plus/fr','default','The name of the taxonomy vocabulary.','','7.39'),(827,'/weebpal/forum-plus/fr','default','Machine name','','7.39'),(828,'/weebpal/forum-plus/fr','default','The machine name of the taxonomy vocabulary.','','7.39'),(829,'/weebpal/forum-plus/fr','default','The optional description of the taxonomy vocabulary.','','7.39'),(830,'/weebpal/forum-plus/fr','default','Term count','','7.39'),(831,'/weebpal/forum-plus/fr','default','The number of terms belonging to the taxonomy vocabulary.','','7.39'),(832,'/weebpal/forum-plus/fr','default','User ID','','7.39'),(833,'/weebpal/forum-plus/fr','default','The unique ID of the user account.','','7.39'),(834,'/weebpal/forum-plus/fr','default','The login name of the user account.','','7.39'),(835,'/weebpal/forum-plus/fr','default','Email','','7.39'),(836,'/weebpal/forum-plus/fr','default','The email address of the user account.','','7.39'),(837,'/weebpal/forum-plus/fr','default','The URL of the account profile page.','','7.39'),(838,'/weebpal/forum-plus/fr','default','The url of the account edit page.','','7.39'),(839,'/weebpal/forum-plus/fr','default','Last access','','7.39'),(840,'/weebpal/forum-plus/fr','default','The date the user last accessed the site.','','7.39'),(841,'/weebpal/forum-plus/fr','default','Last login','','7.39'),(842,'/weebpal/forum-plus/fr','default','The date the user last logged in to the site.','','7.39'),(843,'/weebpal/forum-plus/fr','default','Created','','7.39'),(844,'/weebpal/forum-plus/fr','default','The date the user account was created.','','7.39'),(845,'/weebpal/forum-plus/fr','default','User roles','','7.39'),(846,'/weebpal/forum-plus/fr','default','The roles of the user.','','7.39'),(847,'/weebpal/forum-plus/fr','default','Whether the user is active or blocked.','','7.39'),(848,'/weebpal/forum-plus/fr','default','Default theme','','7.39'),(849,'/weebpal/forum-plus/fr','default','The user\'s default theme.','','7.39'),(850,'/weebpal/forum-plus/fr','default','The name of the site.','','7.39'),(851,'/weebpal/forum-plus/fr','default','Slogan','','7.39'),(852,'/weebpal/forum-plus/fr','default','The slogan of the site.','','7.39'),(853,'/weebpal/forum-plus/fr','default','The administrative email address for the site.','','7.39'),(854,'/weebpal/forum-plus/fr','default','The URL of the site\'s front page.','','7.39'),(855,'/weebpal/forum-plus/fr','default','Login page','','7.39'),(856,'/weebpal/forum-plus/fr','default','The URL of the site\'s login page.','','7.39'),(857,'/weebpal/forum-plus/fr','default','Logged in user','','7.39'),(858,'/weebpal/forum-plus/fr','default','The currently logged in user.','','7.39'),(859,'/weebpal/forum-plus/fr','default','Current date','','7.39'),(860,'/weebpal/forum-plus/fr','default','The current date and time.','','7.39'),(861,'/weebpal/forum-plus/fr','default','Current page','','7.39'),(862,'/weebpal/forum-plus/fr','default','Information related to the current page request.','','7.39'),(863,'/weebpal/forum-plus/fr','default','Path','','7.39'),(864,'/weebpal/forum-plus/fr','default','The internal Drupal path of the current page request.','','7.39'),(865,'/weebpal/forum-plus/fr','default','The full URL of the current page request.','','7.39'),(866,'/weebpal/forum-plus/fr','default','File ID','','7.39'),(867,'/weebpal/forum-plus/fr','default','The unique ID of the uploaded file.','','7.39'),(868,'/weebpal/forum-plus/fr','default','File name','','7.39'),(869,'/weebpal/forum-plus/fr','default','The name of the file on disk.','','7.39'),(870,'/weebpal/forum-plus/fr','default','MIME type','','7.39'),(871,'/weebpal/forum-plus/fr','default','The MIME type of the file.','','7.39'),(872,'/weebpal/forum-plus/fr','default','File size','','7.39'),(873,'/weebpal/forum-plus/fr','default','The size of the file, in kilobytes.','','7.39'),(874,'/weebpal/forum-plus/fr','default','The web-accessible URL for the file.','','7.39'),(875,'/weebpal/forum-plus/fr','default','Timestamp','','7.39'),(876,'/weebpal/forum-plus/fr','default','The date the file was most recently changed.','','7.39'),(877,'/weebpal/forum-plus/fr','default','Owner','','7.39'),(878,'/weebpal/forum-plus/fr','default','The user who originally uploaded the file.','','7.39'),(879,'/weebpal/forum-plus/fr','default','If part of a book, the book to which this book page belongs.','','7.39'),(880,'/weebpal/forum-plus/fr','default','Book ancestors','','7.39'),(881,'/weebpal/forum-plus/fr','default','If part of a book, a list of all book pages upwards in the book hierarchy.','','7.39'),(882,'/weebpal/forum-plus/fr','default','Comments allowed','','7.39'),(883,'/weebpal/forum-plus/fr','default','Whether comments are allowed on this node: 0 = no, 1 = closed (read only), 2 = open (read/write).','','7.39'),(884,'/weebpal/forum-plus/fr','default','The node comments.','','7.39'),(885,'/weebpal/forum-plus/fr','default','The number of comments posted on a node.','','7.39'),(886,'/weebpal/forum-plus/fr','default','New comment count','','7.39'),(887,'/weebpal/forum-plus/fr','default','The number of comments posted on a node since the reader last viewed it.','','7.39'),(888,'/weebpal/forum-plus/fr','default','The main body text','','7.39'),(889,'/weebpal/forum-plus/fr','default','This account\'s default language for e-mails, and preferred language for site presentation.','','7.39'),(890,'/weebpal/forum-plus/fr','default','Interface language','','7.39'),(891,'/weebpal/forum-plus/fr','default','The language code of the current user interface language.','','7.39'),(892,'/weebpal/forum-plus/fr','default','Content language','','7.39'),(893,'/weebpal/forum-plus/fr','default','The language code of the current content language.','','7.39'),(894,'/weebpal/forum-plus/fr','default','Number of views','','7.39'),(895,'/weebpal/forum-plus/fr','default','The number of visitors who have read the node.','','7.39'),(896,'/weebpal/forum-plus/fr','default','Views today','','7.39'),(897,'/weebpal/forum-plus/fr','default','The number of visitors who have read the node today.','','7.39'),(898,'/weebpal/forum-plus/fr','default','Last view','','7.39'),(899,'/weebpal/forum-plus/fr','default','The date on which a visitor last read the node.','','7.39'),(900,'/weebpal/forum-plus/fr','default','Associated @label via the @label\'s @property.','','7.39'),(901,'/weebpal/forum-plus/fr','default','Show the message by replacing any tokens with their real value.','','7.39'),(902,'/weebpal/forum-plus/fr','default','(No information available)','','7.39'),(903,'/weebpal/forum-plus/fr','default','Rendered @entity-type','','7.39'),(904,'/weebpal/forum-plus/fr','default','The @entity-type of the current relationship rendered using a view mode.','','7.39'),(905,'/weebpal/forum-plus/fr','default','Entity','','7.39'),(906,'/weebpal/forum-plus/fr','default','Displays a single chosen entity.','','7.39'),(907,'/weebpal/forum-plus/fr','default','@entity:@bundle','','7.39'),(908,'/weebpal/forum-plus/fr','default','Appears in: @bundles.','','7.39'),(909,'/weebpal/forum-plus/fr','default','@group: @field','','7.39'),(910,'/weebpal/forum-plus/fr','default','@group (historical data)','','7.39'),(911,'/weebpal/forum-plus/fr','default','@group (historical data): @field','','7.39'),(912,'/weebpal/forum-plus/fr','default','@label (!name)','','7.39'),(913,'/weebpal/forum-plus/fr','default','- No value -','','7.39'),(914,'/weebpal/forum-plus/fr','default','term from !field_name','','7.39'),(915,'/weebpal/forum-plus/fr','default','@label (!name:!column)','','7.39'),(916,'/weebpal/forum-plus/fr','default','@label:!column','','7.39'),(917,'/weebpal/forum-plus/fr','default','@label (!name:delta)','','7.39'),(918,'/weebpal/forum-plus/fr','default','@label:delta','','7.39'),(919,'/weebpal/forum-plus/fr','default','Delta - Appears in: @bundles.','','7.39'),(920,'/weebpal/forum-plus/fr','default','image from !field_name','','7.39'),(921,'/weebpal/forum-plus/fr','default','Field','','7.39'),(922,'/weebpal/forum-plus/fr','default','This is an alias of @group: @field.','','7.39'),(923,'/weebpal/forum-plus/fr','default','Also known as: !also.','','7.39'),(924,'/weebpal/forum-plus/fr','default','@label (!name:language)','','7.39'),(925,'/weebpal/forum-plus/fr','default','@label:language','','7.39'),(926,'/weebpal/forum-plus/fr','default','Language - Appears in: @bundles.','','7.39'),(927,'/weebpal/forum-plus/fr','default','<No value>','','7.39'),(928,'/weebpal/forum-plus/fr','default','@entity entity referenced from !field_name','','7.39'),(929,'/weebpal/forum-plus/fr','default','Referenced Entity','','7.39'),(930,'/weebpal/forum-plus/fr','default','A bridge to the @entity entity that is referenced via !field_name','','7.39'),(931,'/weebpal/forum-plus/fr','default','Locale source','','7.39'),(932,'/weebpal/forum-plus/fr','default','A source string for translation, in English or the default site language.','','7.39'),(933,'/weebpal/forum-plus/fr','default','LID','','7.39'),(934,'/weebpal/forum-plus/fr','default','The ID of the source string.','','7.39'),(935,'/weebpal/forum-plus/fr','default','Location','','7.39'),(936,'/weebpal/forum-plus/fr','default','A description of the location or context of the string.','','7.39'),(937,'/weebpal/forum-plus/fr','default','Group','','7.39'),(938,'/weebpal/forum-plus/fr','default','The group the translation is in.','','7.39'),(939,'/weebpal/forum-plus/fr','default','Source','','7.39'),(940,'/weebpal/forum-plus/fr','default','The full original string.','','7.39'),(941,'/weebpal/forum-plus/fr','default','Version','','7.39'),(942,'/weebpal/forum-plus/fr','default','The version of Drupal core that this string is for.','','7.39'),(943,'/weebpal/forum-plus/fr','default','Provide a simple link to edit the translations.','','7.39'),(944,'/weebpal/forum-plus/fr','default','Locale target','','7.39'),(945,'/weebpal/forum-plus/fr','default','Translation','','7.39'),(946,'/weebpal/forum-plus/fr','default','The full translation string.','','7.39'),(947,'/weebpal/forum-plus/fr','default','The language this translation is in.','','7.39'),(948,'/weebpal/forum-plus/fr','default','Singular LID','','7.39'),(949,'/weebpal/forum-plus/fr','default','The ID of the parent translation.','','7.39'),(950,'/weebpal/forum-plus/fr','default','Plural','','7.39'),(951,'/weebpal/forum-plus/fr','default','Whether or not the translation is plural.','','7.39'),(952,'/weebpal/forum-plus/fr','default','The node ID.','','7.39'),(953,'/weebpal/forum-plus/fr','default','The content title.','','7.39'),(954,'/weebpal/forum-plus/fr','default','The date the content was posted.','','7.39'),(955,'/weebpal/forum-plus/fr','default','The date the content was last updated.','','7.39'),(956,'/weebpal/forum-plus/fr','default','Type','','7.39'),(957,'/weebpal/forum-plus/fr','default','The content type (for example, \"blog entry\", \"forum post\", \"story\", etc).','','7.39'),(958,'/weebpal/forum-plus/fr','default','Published','','7.39'),(959,'/weebpal/forum-plus/fr','default','Whether or not the content is published.','','7.39'),(960,'/weebpal/forum-plus/fr','default','Published or admin','','7.39'),(961,'/weebpal/forum-plus/fr','default','Filters out unpublished content if the current user cannot view it.','','7.39'),(962,'/weebpal/forum-plus/fr','default','Promoted to front page','','7.39'),(963,'/weebpal/forum-plus/fr','default','Whether or not the content is promoted to the front page.','','7.39'),(964,'/weebpal/forum-plus/fr','default','Promoted','','7.39'),(965,'/weebpal/forum-plus/fr','default','Not promoted','','7.39'),(966,'/weebpal/forum-plus/fr','default','Sticky','','7.39'),(967,'/weebpal/forum-plus/fr','default','Whether or not the content is sticky.','','7.39'),(968,'/weebpal/forum-plus/fr','default','Not sticky','','7.39'),(969,'/weebpal/forum-plus/fr','default','Whether or not the content is sticky. To list sticky content first, set this to descending.','','7.39'),(970,'/weebpal/forum-plus/fr','default','Provide a simple link to the content.','','7.39'),(971,'/weebpal/forum-plus/fr','default','Provide a simple link to edit the content.','','7.39'),(972,'/weebpal/forum-plus/fr','default','Provide a simple link to delete the content.','','7.39'),(973,'/weebpal/forum-plus/fr','default','The aliased path to this content.','','7.39'),(974,'/weebpal/forum-plus/fr','default','Updated year + month','','7.39'),(975,'/weebpal/forum-plus/fr','default','Updated year','','7.39'),(976,'/weebpal/forum-plus/fr','default','Updated month','','7.39'),(977,'/weebpal/forum-plus/fr','default','Updated day','','7.39'),(978,'/weebpal/forum-plus/fr','default','Updated week','','7.39'),(979,'/weebpal/forum-plus/fr','default','The user authoring the content. If you need more fields than the uid add the content: author relationship','','7.39'),(980,'/weebpal/forum-plus/fr','default','Relate content to the user who created it.','','7.39'),(981,'/weebpal/forum-plus/fr','default','User has a revision','','7.39'),(982,'/weebpal/forum-plus/fr','default','All nodes where a certain user has a revision','','7.39'),(983,'/weebpal/forum-plus/fr','default','Content revision','','7.39'),(984,'/weebpal/forum-plus/fr','default','Content revision is a history of changes to content.','','7.39'),(985,'/weebpal/forum-plus/fr','default','Relate a content revision to the user who created the revision.','','7.39'),(986,'/weebpal/forum-plus/fr','default','revision user','','7.39'),(987,'/weebpal/forum-plus/fr','default','The revision NID of the content revision.','','7.39'),(988,'/weebpal/forum-plus/fr','default','Get the actual content from a content revision.','','7.39'),(989,'/weebpal/forum-plus/fr','default','Vid','','7.39'),(990,'/weebpal/forum-plus/fr','default','The revision ID of the content revision.','','7.39'),(991,'/weebpal/forum-plus/fr','default','Log message','','7.39'),(992,'/weebpal/forum-plus/fr','default','The log message entered when the revision was created.','','7.39'),(993,'/weebpal/forum-plus/fr','default','The date the node was last updated.','','7.39'),(994,'/weebpal/forum-plus/fr','default','Provide a simple link to the revision.','','7.39'),(995,'/weebpal/forum-plus/fr','default','Revert link','','7.39'),(996,'/weebpal/forum-plus/fr','default','Provide a simple link to revert to the revision.','','7.39'),(997,'/weebpal/forum-plus/fr','default','Provide a simple link to delete the content revision.','','7.39'),(998,'/weebpal/forum-plus/fr','default','Content access','','7.39'),(999,'/weebpal/forum-plus/fr','default','Access','','7.39'),(1000,'/weebpal/forum-plus/fr','default','Filter by access.','','7.39'),(1001,'/weebpal/forum-plus/fr','default','Filter for content by view access. <strong>Not necessary if you are using node as your base table.</strong>','','7.39'),(1002,'/weebpal/forum-plus/fr','default','Has new content','','7.39'),(1003,'/weebpal/forum-plus/fr','default','Show a marker if the content is new or updated.','','7.39'),(1004,'/weebpal/forum-plus/fr','default','Show only content that is new or updated.','','7.39'),(1005,'/weebpal/forum-plus/fr','default','Score','','7.39'),(1006,'/weebpal/forum-plus/fr','default','The score of the search item. This will not be used if the search filter is not also present.','','7.39'),(1007,'/weebpal/forum-plus/fr','default','Links from','','7.39'),(1008,'/weebpal/forum-plus/fr','default','Other nodes that are linked from the node.','','7.39'),(1009,'/weebpal/forum-plus/fr','default','Links to','','7.39'),(1010,'/weebpal/forum-plus/fr','default','Other nodes that link to the node.','','7.39'),(1011,'/weebpal/forum-plus/fr','default','Search Terms','','7.39'),(1012,'/weebpal/forum-plus/fr','default','The terms to search for.','','7.39'),(1013,'/weebpal/forum-plus/fr','default','Content statistics','','7.39'),(1014,'/weebpal/forum-plus/fr','default','Total views','','7.39'),(1015,'/weebpal/forum-plus/fr','default','The total number of times the node has been viewed.','','7.39'),(1016,'/weebpal/forum-plus/fr','default','The total number of times the node has been viewed today.','','7.39'),(1017,'/weebpal/forum-plus/fr','default','Most recent view','','7.39'),(1018,'/weebpal/forum-plus/fr','default','The most recent time the node has been viewed.','','7.39'),(1019,'/weebpal/forum-plus/fr','default','Access log','','7.39'),(1020,'/weebpal/forum-plus/fr','default','Stores site access information.','','7.39'),(1021,'/weebpal/forum-plus/fr','default','Aid','','7.39'),(1022,'/weebpal/forum-plus/fr','default','Unique access event ID.','','7.39'),(1023,'/weebpal/forum-plus/fr','default','Session ID','','7.39'),(1024,'/weebpal/forum-plus/fr','default','Browser session ID of user that visited page.','','7.39'),(1025,'/weebpal/forum-plus/fr','default','Page title','','7.39'),(1026,'/weebpal/forum-plus/fr','default','Title of page visited.','','7.39'),(1027,'/weebpal/forum-plus/fr','default','Internal path to page visited (relative to Drupal root.)','','7.39'),(1028,'/weebpal/forum-plus/fr','default','Referrer','','7.39'),(1029,'/weebpal/forum-plus/fr','default','Referrer URI.','','7.39'),(1030,'/weebpal/forum-plus/fr','default','Hostname of user that visited the page.','','7.39'),(1031,'/weebpal/forum-plus/fr','default','The user who visited the site.','','7.39'),(1032,'/weebpal/forum-plus/fr','default','Timer','','7.39'),(1033,'/weebpal/forum-plus/fr','default','Time in milliseconds that the page took to load.','','7.39'),(1034,'/weebpal/forum-plus/fr','default','Timestamp of when the page was visited.','','7.39'),(1035,'/weebpal/forum-plus/fr','default','Files maintained by Drupal and various modules.','','7.39'),(1036,'/weebpal/forum-plus/fr','default','The ID of the file.','','7.39'),(1037,'/weebpal/forum-plus/fr','default','The name of the file.','','7.39'),(1038,'/weebpal/forum-plus/fr','default','The path of the file.','','7.39'),(1039,'/weebpal/forum-plus/fr','default','Mime type','','7.39'),(1040,'/weebpal/forum-plus/fr','default','The mime type of the file.','','7.39'),(1041,'/weebpal/forum-plus/fr','default','Extension','','7.39'),(1042,'/weebpal/forum-plus/fr','default','The extension of the file.','','7.39'),(1043,'/weebpal/forum-plus/fr','default','Size','','7.39'),(1044,'/weebpal/forum-plus/fr','default','The size of the file.','','7.39'),(1045,'/weebpal/forum-plus/fr','default','The status of the file.','','7.39'),(1046,'/weebpal/forum-plus/fr','default','Upload date','','7.39'),(1047,'/weebpal/forum-plus/fr','default','The date the file was uploaded.','','7.39'),(1048,'/weebpal/forum-plus/fr','default','User who uploaded','','7.39'),(1049,'/weebpal/forum-plus/fr','default','The user that uploaded the file.','','7.39'),(1050,'/weebpal/forum-plus/fr','default','File Usage','','7.39'),(1051,'/weebpal/forum-plus/fr','default','Content that is associated with this file, usually because this file is in a field on the content.','','7.39'),(1052,'/weebpal/forum-plus/fr','default','A file that is associated with this node, usually because it is in a field on the node.','','7.39'),(1053,'/weebpal/forum-plus/fr','default','A user that is associated with this file, usually because this file is in a field on the user.','','7.39'),(1054,'/weebpal/forum-plus/fr','default','A file that is associated with this user, usually because it is in a field on the user.','','7.39'),(1055,'/weebpal/forum-plus/fr','default','A comment that is associated with this file, usually because this file is in a field on the comment.','','7.39'),(1056,'/weebpal/forum-plus/fr','default','A file that is associated with this comment, usually because it is in a field on the comment.','','7.39'),(1057,'/weebpal/forum-plus/fr','default','Taxonomy Term','','7.39'),(1058,'/weebpal/forum-plus/fr','default','A taxonomy term that is associated with this file, usually because this file is in a field on the taxonomy term.','','7.39'),(1059,'/weebpal/forum-plus/fr','default','A file that is associated with this taxonomy term, usually because it is in a field on the taxonomy term.','','7.39'),(1060,'/weebpal/forum-plus/fr','default','Taxonomy Vocabulary','','7.39'),(1061,'/weebpal/forum-plus/fr','default','A taxonomy vocabulary that is associated with this file, usually because this file is in a field on the taxonomy vocabulary.','','7.39'),(1062,'/weebpal/forum-plus/fr','default','A file that is associated with this taxonomy vocabulary, usually because it is in a field on the taxonomy vocabulary.','','7.39'),(1063,'/weebpal/forum-plus/fr','default','Module','','7.39'),(1064,'/weebpal/forum-plus/fr','default','The module managing this file relationship.','','7.39'),(1065,'/weebpal/forum-plus/fr','default','Entity type','','7.39'),(1066,'/weebpal/forum-plus/fr','default','The type of entity that is related to the file.','','7.39'),(1067,'/weebpal/forum-plus/fr','default','Entity ID','','7.39'),(1068,'/weebpal/forum-plus/fr','default','The ID of the entity that is related to the file.','','7.39'),(1069,'/weebpal/forum-plus/fr','default','Use count','','7.39'),(1070,'/weebpal/forum-plus/fr','default','The number of times the file is used by this entity.','','7.39'),(1071,'/weebpal/forum-plus/fr','default','Module/Theme/Theme engine','','7.39'),(1072,'/weebpal/forum-plus/fr','default','Modules/Themes/Theme engines in your codebase.','','7.39'),(1073,'/weebpal/forum-plus/fr','default','Module/Theme/Theme engine filename','','7.39'),(1074,'/weebpal/forum-plus/fr','default','The path of the primary file for this item, relative to the Drupal root; e.g. modules/node/node.module.','','7.39'),(1075,'/weebpal/forum-plus/fr','default','Module/Theme/Theme engine name','','7.39'),(1076,'/weebpal/forum-plus/fr','default','The name of the item; e.g. node.','','7.39'),(1077,'/weebpal/forum-plus/fr','default','The type of the item, either module, theme, or theme_engine.','','7.39'),(1078,'/weebpal/forum-plus/fr','default','Boolean indicating whether or not this item is enabled.','','7.39'),(1079,'/weebpal/forum-plus/fr','default','Schema version','','7.39'),(1080,'/weebpal/forum-plus/fr','default','The module\'s database schema version number. -1 if the module is not installed (its tables do not exist); 0 or the largest N of the module\'s hook_update_N() function that has either been run or existed when the module was first installed.','','7.39'),(1081,'/weebpal/forum-plus/fr','default','Name of the vocabulary a term is a member of. This will be the vocabulary that whichever term the \"Taxonomy: Term\" field is; and can similarly cause duplicates.','','7.39'),(1082,'/weebpal/forum-plus/fr','default','The taxonomy vocabulary name','','7.39'),(1083,'/weebpal/forum-plus/fr','default','Machine-Name of the vocabulary a term is a member of. This will be the vocabulary that whichever term the \"Taxonomy: Term\" field is; and can similarly cause duplicates.','','7.39'),(1084,'/weebpal/forum-plus/fr','default','Filter the results of \"Taxonomy: Term\" to a particular vocabulary.','','7.39'),(1085,'/weebpal/forum-plus/fr','default','The taxonomy vocabulary ID','','7.39'),(1086,'/weebpal/forum-plus/fr','default','The taxonomy vocabulary description','','7.39'),(1087,'/weebpal/forum-plus/fr','default','The taxonomy vocabulary weight','','7.39'),(1088,'/weebpal/forum-plus/fr','default','Term','','7.39'),(1089,'/weebpal/forum-plus/fr','default','Taxonomy terms are attached to nodes.','','7.39'),(1090,'/weebpal/forum-plus/fr','default','The tid of a taxonomy term.','','7.39'),(1091,'/weebpal/forum-plus/fr','default','Taxonomy term chosen from autocomplete or select widget.','','7.39'),(1092,'/weebpal/forum-plus/fr','default','Representative node','','7.39'),(1093,'/weebpal/forum-plus/fr','default','Obtains a single representative node for each term, according to a chosen sort criterion.','','7.39'),(1094,'/weebpal/forum-plus/fr','default','The taxonomy term name.','','7.39'),(1095,'/weebpal/forum-plus/fr','default','Taxonomy term name.','','7.39'),(1096,'/weebpal/forum-plus/fr','default','Uncategorized','','7.39'),(1097,'/weebpal/forum-plus/fr','default','The term weight field','','7.39'),(1098,'/weebpal/forum-plus/fr','default','Term description','','7.39'),(1099,'/weebpal/forum-plus/fr','default','The description associated with a taxonomy term.','','7.39'),(1100,'/weebpal/forum-plus/fr','default','Term edit link','','7.39'),(1101,'/weebpal/forum-plus/fr','default','Provide a simple link to edit the term.','','7.39'),(1102,'/weebpal/forum-plus/fr','default','Content with term','','7.39'),(1103,'/weebpal/forum-plus/fr','default','Relate all content tagged with a term.','','7.39'),(1104,'/weebpal/forum-plus/fr','default','Has taxonomy term ID','','7.39'),(1105,'/weebpal/forum-plus/fr','default','Display content if it has the selected taxonomy terms.','','7.39'),(1106,'/weebpal/forum-plus/fr','default','Has taxonomy term','','7.39'),(1107,'/weebpal/forum-plus/fr','default','Parent term','','7.39'),(1108,'/weebpal/forum-plus/fr','default','The parent term of the term. This can produce duplicate entries if you are using a vocabulary that allows multiple parents.','','7.39'),(1109,'/weebpal/forum-plus/fr','default','Filter the results of \"Taxonomy: Term\" by the parent pid.','','7.39'),(1110,'/weebpal/forum-plus/fr','default','The parent term of the term.','','7.39'),(1111,'/weebpal/forum-plus/fr','default','Uid','','7.39'),(1112,'/weebpal/forum-plus/fr','default','The user ID','','7.39'),(1113,'/weebpal/forum-plus/fr','default','Content authored','','7.39'),(1114,'/weebpal/forum-plus/fr','default','Relate content to the user who created it. This relationship will create one record for each content item created by the user.','','7.39'),(1115,'/weebpal/forum-plus/fr','default','nodes','','7.39'),(1116,'/weebpal/forum-plus/fr','default','The raw numeric user ID.','','7.39'),(1117,'/weebpal/forum-plus/fr','default','Obtains a single representative node for each user, according to a chosen sort criterion.','','7.39'),(1118,'/weebpal/forum-plus/fr','default','Current','','7.39'),(1119,'/weebpal/forum-plus/fr','default','Filter the view to the currently logged in user.','','7.39'),(1120,'/weebpal/forum-plus/fr','default','The user or author name.','','7.39'),(1121,'/weebpal/forum-plus/fr','default','Name (raw)','','7.39'),(1122,'/weebpal/forum-plus/fr','default','The user or author name. This filter does not check if the user exists and allows partial matching. Does not utilize autocomplete.','','7.39'),(1123,'/weebpal/forum-plus/fr','default','E-mail','','7.39'),(1124,'/weebpal/forum-plus/fr','default','Email address for a given user. This field is normally not shown to users, so be cautious when using it.','','7.39'),(1125,'/weebpal/forum-plus/fr','default','Language of the user','','7.39'),(1126,'/weebpal/forum-plus/fr','default','The user\'s picture, if allowed.','','7.39'),(1127,'/weebpal/forum-plus/fr','default','Has Avatar','','7.39'),(1128,'/weebpal/forum-plus/fr','default','Provide a simple link to the user.','','7.39'),(1129,'/weebpal/forum-plus/fr','default','The date the user was created.','','7.39'),(1130,'/weebpal/forum-plus/fr','default','The user\'s last access date.','','7.39'),(1131,'/weebpal/forum-plus/fr','default','The user\'s last login date.','','7.39'),(1132,'/weebpal/forum-plus/fr','default','Active','','7.39'),(1133,'/weebpal/forum-plus/fr','default','Whether a user is active or blocked.','','7.39'),(1134,'/weebpal/forum-plus/fr','default','Blocked','','7.39'),(1135,'/weebpal/forum-plus/fr','default','Signature','','7.39'),(1136,'/weebpal/forum-plus/fr','default','The user\'s signature.','','7.39'),(1137,'/weebpal/forum-plus/fr','default','Provide a simple link to edit the user.','','7.39'),(1138,'/weebpal/forum-plus/fr','default','Cancel link','','7.39'),(1139,'/weebpal/forum-plus/fr','default','Provide a simple link to cancel the user.','','7.39'),(1140,'/weebpal/forum-plus/fr','default','Data','','7.39'),(1141,'/weebpal/forum-plus/fr','default','Provide serialized data of the user','','7.39'),(1142,'/weebpal/forum-plus/fr','default','Roles that a user belongs to.','','7.39'),(1143,'/weebpal/forum-plus/fr','default','No role','','7.39'),(1144,'/weebpal/forum-plus/fr','default','Permission','','7.39'),(1145,'/weebpal/forum-plus/fr','default','The user permissions.','','7.39'),(1146,'/weebpal/forum-plus/fr','default','Authmap ID','','7.39'),(1147,'/weebpal/forum-plus/fr','default','The Authmap ID.','','7.39'),(1148,'/weebpal/forum-plus/fr','default','Authentication name','','7.39'),(1149,'/weebpal/forum-plus/fr','default','The unique authentication name.','','7.39'),(1150,'/weebpal/forum-plus/fr','default','Authentication module','','7.39'),(1151,'/weebpal/forum-plus/fr','default','The name of the module managing the authentication entry.','','7.39'),(1152,'/weebpal/forum-plus/fr','default','Adds a fieldset to put fields and other fieldsets in.','','7.39'),(1153,'/weebpal/forum-plus/fr','default','Votes','','7.39'),(1154,'/weebpal/forum-plus/fr','default','Vote results','','7.39'),(1155,'/weebpal/forum-plus/fr','default','Value','','7.39'),(1156,'/weebpal/forum-plus/fr','default','The value of an individual cast vote.','','7.39'),(1157,'/weebpal/forum-plus/fr','default','Value type','','7.39'),(1158,'/weebpal/forum-plus/fr','default','The nature of the vote being cast (points, percentage, etc).','','7.39'),(1159,'/weebpal/forum-plus/fr','default','Tag','','7.39'),(1160,'/weebpal/forum-plus/fr','default','An optional tag to group multi-criteria votes.','','7.39'),(1161,'/weebpal/forum-plus/fr','default','The user who cast the vote.','','7.39'),(1162,'/weebpal/forum-plus/fr','default','Individual voter','','7.39'),(1163,'/weebpal/forum-plus/fr','default','Current user','','7.39'),(1164,'/weebpal/forum-plus/fr','default','Restrict votes to those cast by the current user.','','7.39'),(1165,'/weebpal/forum-plus/fr','default','The IP address of the user who cast the vote.','','7.39'),(1166,'/weebpal/forum-plus/fr','default','The time the vote was cast.','','7.39'),(1167,'/weebpal/forum-plus/fr','default','The nature of the results in question (points, percentage, etc).','','7.39'),(1168,'/weebpal/forum-plus/fr','default','An optional tag to group multi-criteria results.','','7.39'),(1169,'/weebpal/forum-plus/fr','default','Function','','7.39'),(1170,'/weebpal/forum-plus/fr','default','The aggregate function used to calculate the result.','','7.39'),(1171,'/weebpal/forum-plus/fr','default','The time the results were calculated.','','7.39'),(1172,'/weebpal/forum-plus/fr','default','Global','','7.39'),(1173,'/weebpal/forum-plus/fr','default','Random','','7.39'),(1174,'/weebpal/forum-plus/fr','default','Randomize the display order.','','7.39'),(1175,'/weebpal/forum-plus/fr','default','Null','','7.39'),(1176,'/weebpal/forum-plus/fr','default','Allow a contextual filter value to be ignored. The query will not be altered by this contextual filter value. Can be used when contextual filter values come from the URL, and a part of the URL needs to be ignored.','','7.39'),(1177,'/weebpal/forum-plus/fr','default','Custom text','','7.39'),(1178,'/weebpal/forum-plus/fr','default','Provide custom text or link.','','7.39'),(1179,'/weebpal/forum-plus/fr','default','View result counter','','7.39'),(1180,'/weebpal/forum-plus/fr','default','Displays the actual position of the view result','','7.39'),(1181,'/weebpal/forum-plus/fr','default','Text area','','7.39'),(1182,'/weebpal/forum-plus/fr','default','Provide markup text for the area.','','7.39'),(1183,'/weebpal/forum-plus/fr','default','Unfiltered text','','7.39'),(1184,'/weebpal/forum-plus/fr','default','Add unrestricted, custom text or markup. This is similar to the custom text field.','','7.39'),(1185,'/weebpal/forum-plus/fr','default','View area','','7.39'),(1186,'/weebpal/forum-plus/fr','default','Insert a view inside an area.','','7.39'),(1187,'/weebpal/forum-plus/fr','default','Result summary','','7.39'),(1188,'/weebpal/forum-plus/fr','default','Shows result summary, for example the items per page.','','7.39'),(1189,'/weebpal/forum-plus/fr','default','Displays messages in the area.','','7.39'),(1190,'/weebpal/forum-plus/fr','default','Contextual Links','','7.39'),(1191,'/weebpal/forum-plus/fr','default','Display fields in a contextual links menu.','','7.39'),(1192,'/weebpal/forum-plus/fr','default','Combine fields filter','','7.39'),(1193,'/weebpal/forum-plus/fr','default','Combine two fields together and search by them.','','7.39'),(1194,'/weebpal/forum-plus/fr','default','Math expression','','7.39'),(1195,'/weebpal/forum-plus/fr','default','Evaluates a mathematical expression and displays it.','','7.39'),(1196,'/weebpal/forum-plus/fr','default','Fields comparison','','7.39'),(1197,'/weebpal/forum-plus/fr','default','Compare database fields against eachother.','','7.39'),(1198,'/weebpal/forum-plus/fr','default','Use fields comparison to filter the result of the view.','','7.39'),(1199,'/weebpal/forum-plus/fr','default','New comments','','7.39'),(1200,'/weebpal/forum-plus/fr','default','The number of new comments on the node.','','7.39'),(1201,'/weebpal/forum-plus/fr','default','Add comment link','','7.39'),(1202,'/weebpal/forum-plus/fr','default','Display the standard add comment link used on regular nodes, which will only display if the viewing user has access to add a comment.','','7.39'),(1203,'/weebpal/forum-plus/fr','default','Comment status','','7.39'),(1204,'/weebpal/forum-plus/fr','default','Whether comments are enabled or disabled on the node.','','7.39'),(1205,'/weebpal/forum-plus/fr','default','User posted or commented','','7.39'),(1206,'/weebpal/forum-plus/fr','default','Display nodes only if a user posted the node or commented on the node.','','7.39'),(1207,'/weebpal/forum-plus/fr','default','Comments of the node','','7.39'),(1208,'/weebpal/forum-plus/fr','default','Relate all comments on the node. This will create 1 duplicate record for every comment. Usually if you need this it is better to create a comment view.','','7.39'),(1209,'/weebpal/forum-plus/fr','default','Link to contact page','','7.39'),(1210,'/weebpal/forum-plus/fr','default','Provide a simple link to the user contact page.','','7.39'),(1211,'/weebpal/forum-plus/fr','default','@entity using @field','','7.39'),(1212,'/weebpal/forum-plus/fr','default','Relate each @entity with a @field set to the term.','','7.39'),(1213,'/weebpal/forum-plus/fr','default','!field_name','','7.39'),(1214,'/weebpal/forum-plus/fr','default','Relate each @entity with a @field set to the image.','','7.39'),(1215,'/weebpal/forum-plus/fr','default','@entity referencing @target_entity from !field_name','','7.39'),(1216,'/weebpal/forum-plus/fr','default','Referencing entity','','7.39'),(1217,'/weebpal/forum-plus/fr','default','A bridge to the @entity entity that is referencing @target_entity via !field_name','','7.39'),(1218,'/weebpal/forum-plus/fr','default','The language the content is in.','','7.39'),(1219,'/weebpal/forum-plus/fr','default','Taxonomy terms on node','','7.39'),(1220,'/weebpal/forum-plus/fr','default','Relate nodes to taxonomy terms, specifiying which vocabulary or vocabularies to use. This relationship will cause duplicated records if there are multiple terms.','','7.39'),(1221,'/weebpal/forum-plus/fr','default','term','','7.39'),(1222,'/weebpal/forum-plus/fr','default','All taxonomy terms','','7.39'),(1223,'/weebpal/forum-plus/fr','default','Display all taxonomy terms associated with a node from specified vocabularies.','','7.39'),(1224,'/weebpal/forum-plus/fr','default','Display content if it has the selected taxonomy terms, or children of the selected terms. Due to additional complexity, this has fewer options than the versions without depth.','','7.39'),(1225,'/weebpal/forum-plus/fr','default','Has taxonomy term ID (with depth)','','7.39'),(1226,'/weebpal/forum-plus/fr','default','Has taxonomy terms (with depth)','','7.39'),(1227,'/weebpal/forum-plus/fr','default','Has taxonomy term ID depth modifier','','7.39'),(1228,'/weebpal/forum-plus/fr','default','Allows the \"depth\" for Taxonomy: Term ID (with depth) to be modified via an additional contextual filter value.','','7.39'),(1229,'/weebpal/forum-plus/fr','default','Topic Icon','','7.39'),(1230,'/weebpal/forum-plus/fr','default','Icon that shows new posts, hot, sticky, locked, etc.','','7.39'),(1231,'/weebpal/forum-plus/fr','default','Topic Pager','','7.39'),(1232,'/weebpal/forum-plus/fr','default','Small pager for individual topics.','','7.39'),(1233,'/weebpal/forum-plus/fr','default','Break lock','','7.39'),(1234,'/weebpal/forum-plus/fr','default','Edit view','','7.39'),(1235,'/weebpal/forum-plus/fr','default','Disable text format','','7.39'),(1236,'/weebpal/forum-plus/fr','default','Run cron','','7.39'),(1237,'/weebpal/forum-plus/fr','default','Run updates','','7.39'),(1238,'/weebpal/forum-plus/fr','default','@project issue queue','','7.39'),(1239,'/weebpal/forum-plus/fr','default','Flush all caches','','7.39'),(1240,'/weebpal/forum-plus/fr','default','CSS and JavaScript','','7.39'),(1241,'/weebpal/forum-plus/fr','default','Page and else','','7.39'),(1242,'/weebpal/forum-plus/fr','default','Menu','','7.39'),(1243,'/weebpal/forum-plus/fr','default','Class registry','','7.39'),(1244,'/weebpal/forum-plus/fr','default','Theme registry','','7.39'),(1245,'/weebpal/forum-plus/fr','default','Update data','','7.39'),(1246,'/weebpal/forum-plus/fr','default','Disable developer modules','','7.32'),(1247,'/weebpal/forum-plus/fr','default','Add content','','7.39'),(1248,'/weebpal/forum-plus/fr','default','Use <em>articles</em> for time-sensitive content like news, press releases or blog posts.','','7.39'),(1249,'/weebpal/forum-plus/fr','default','Use <em>basic pages</em> for your static content, such as an \'About us\' page.','','7.39'),(1250,'/weebpal/forum-plus/fr','default','<em>Books</em> have a built-in hierarchical navigation. Use for handbooks or tutorials.','','7.39'),(1251,'/weebpal/forum-plus/fr','default','Token registry','','7.39'),(1252,'/weebpal/forum-plus/fr','default','Hello <strong>@username</strong>','','7.39'),(1253,'/weebpal/forum-plus/fr','default','If you have problems accessing administrative pages on this site, disable the overlay on your profile page.','','7.39'),(1254,'/weebpal/forum-plus/fr','default','Dismiss this message.','','7.39'),(1255,'/weebpal/forum-plus/fr','default','Add to %shortcut_set shortcuts','','7.39'),(1256,'/weebpal/forum-plus/fr','default','1 comment','','7.39'),(1257,'/weebpal/forum-plus/fr','default','Read the latest forum topics.','','7.39'),(1258,'/weebpal/forum-plus/fr','default','More','','7.39'),(1259,'/weebpal/forum-plus/fr','default','Configure block','','7.39'),(1260,'/weebpal/forum-plus/fr','default','You are here','','7.39'),(1261,'/weebpal/forum-plus/fr','default','Status message','','7.39'),(1262,'/weebpal/forum-plus/fr','default','Error message','','7.39'),(1263,'/weebpal/forum-plus/fr','default','Warning message','','7.39'),(1264,'/weebpal/forum-plus/fr','default','!title !required','','7.39'),(1265,'/weebpal/forum-plus/fr','default','Search form','','7.39'),(1266,'/weebpal/forum-plus/fr','default','Primary tabs','','7.39'),(1267,'/weebpal/forum-plus/fr','default','!local-task-title!active','','7.39'),(1268,'/weebpal/forum-plus/fr','default','Back to Top','','7.39'),(1269,'/weebpal/forum-plus/fr','default','Options for the administrative overlay','','7.39'),(1270,'/weebpal/forum-plus/fr','default','Skip to main content','','7.39'),(1271,'/weebpal/forum-plus/admin/structure/views/view/articles?render=overlay&render=overlay','default','See more ...','','7.39'),(1272,'/weebpal/forum-plus/admin/structure/views/view/recent_topics?render=overlay&render=overlay','default','Recent Topics','','7.39'),(1273,'/weebpal/forum-plus/admin/structure/views/view/calendar?render=overlay&render=overlay','default','Calendar','','7.39'),(1274,'/weebpal/forum-plus/admin/structure/views/view/blogs/edit/page_1?render=overlay&render=overlay','default','Recent Entries','','7.28'),(1275,'modules/filter/filter.admin.js','default','Enabled','','7.39'),(1276,'modules/filter/filter.admin.js','default','Disabled','','7.39'),(1277,'/weebpal/forum-plus/admin/structure/views/view/new_forum_posts?render=overlay&render=overlay','default','New Forum Posts','','7.39'),(1278,'/weebpal/forum-plus/admin/structure/views/view/articles/edit/page?render=overlay&render=overlay','default','metadata','','7.28'),(1279,'/weebpal/forum-plus/admin/structure/views/view/articles/edit/page_2?destination=articles-two-columns&render=overlay&render=overlay','default','<i class=\"fa fa-user\"></i> [name]','','7.28'),(1280,'/weebpal/forum-plus/admin/structure/views/view/articles/edit/page_2?destination=articles-two-columns&render=overlay&render=overlay','default','<i class=\"fa fa-clock-o\"></i> [created]','','7.39'),(1281,'/weebpal/forum-plus/admin/structure/views/view/blogs/edit/page_2?render=overlay&render=overlay','default','Read more','','7.39'),(1282,'/weebpal/forum-plus/admin/structure/views/view/blogs/edit/page_2?render=overlay&render=overlay','default','<i class=\"fa fa-eye\"></i> [counter]','','7.28'),(1283,'/weebpal/forum-plus/admin/structure/views/view/recent_blogs/edit/block?destination=blogs%2Ftwo&render=overlay&render=overlay','default','Best Blogs','','7.39'),(1284,'sites/all/modules/tb_megamenu/js/tb-megamenu-object.js','default','All unsaved changed has been reseted!','','none'),(1285,'sites/all/modules/tb_megamenu/js/tb-megamenu-object.js','default','Saved config sucessfully!','','none'),(1286,'sites/all/modules/tb_megamenu/js/tb-megamenu-object.js','default','Remove this block','','none'),(1287,'/weebpal/forum-plus/admin/structure/views/view/what_is_news/edit?render=overlay&render=overlay','default','What is news?','','7.34'),(1288,'/weebpal/forum-plus/admin/structure/views/view/activity_stream?render=overlay&render=overlay','default','Content entity referenced from field_node_ref','','7.39'),(1289,'/weebpal/forum-plus/admin/structure/views/view/hot_video?render=overlay&render=overlay','default','Hot Video','','7.39'),(1290,'/weebpal/forum-plus/admin/structure/views/view/get_products?render=overlay&render=overlay','default','Get Products','','7.39'),(1291,'/weebpal/forum-plus/admin/structure/views/view/get_products/edit?render=overlay&render=overlay','default','<a href=\"[field_link]\">[field_image]</a>','','7.39'),(1292,'/weebpal/forum-plus/fr/users/jack','default','FAQ','','7.39'),(1293,'/weebpal/forum-plus/fr/users/jack','default','A frequently asked question and its answer.','','7.39'),(1294,'/weebpal/forum-plus/fr/users/jack','default','Question','','7.39'),(1295,'/weebpal/forum-plus/fr/users/jack','default','Answer','','7.28'),(1296,'/weebpal/forum-plus/fr/users/jack','default','Field collection item','','7.39'),(1297,'/weebpal/forum-plus/fr/users/jack','default','Field collection @field','','7.39'),(1298,'/weebpal/forum-plus/fr/users/jack','default','Compose tips','','7.39'),(1299,'/weebpal/forum-plus/fr/users/jack','default','Tags','','7.39'),(1300,'/weebpal/forum-plus/fr/users/jack','default','Message example','','7.39'),(1301,'/weebpal/forum-plus/fr/users/jack','default','Typical UAS (User activity stream).','','7.39'),(1302,'/weebpal/forum-plus/fr/users/jack','default','Loading...','','7.39'),(1303,'/weebpal/forum-plus/fr/users/jack','default','Close Window','','7.39'),(1304,'/weebpal/forum-plus/fr/users/jack','default','Close window','','7.39'),(1305,'/weebpal/forum-plus/fr/users/jack','default','Close','','7.39'),(1306,'/weebpal/forum-plus/fr/users/jack','default','@user\'s picture','','7.39'),(1307,'/weebpal/forum-plus/fr/users/jack','default','History','','7.39'),(1308,'/weebpal/forum-plus/fr/users/jack','default','Member for','','7.34'),(1309,'/weebpal/forum-plus/fr/users/jack','default','Welcome','','7.39'),(1310,'/weebpal/forum-plus/fr/users/jack','default','GMap','','7.39'),(1311,'/weebpal/forum-plus/fr/users/jack','default','Articles Teaser','','7.39'),(1312,'/weebpal/forum-plus/fr/users/jack','default','Two Columns','','7.39'),(1313,'/weebpal/forum-plus/fr/users/jack','default','Three Columns','','7.39'),(1314,'/weebpal/forum-plus/fr/users/jack','default','Blogs Teaser','','7.39'),(1315,'/weebpal/forum-plus/fr/users/jack','default','Account','','7.34'),(1316,'/weebpal/forum-plus/fr/users/jack','default','Default skin','','7.39'),(1317,'/weebpal/forum-plus/fr/users/jack','default','Dark skin','','7.39'),(1318,'/weebpal/forum-plus/fr/users/jack','default','Blue skin','','7.39'),(1319,'/weebpal/forum-plus/fr/users/jack','default','Custom skin','','7.39'),(1320,'/weebpal/forum-plus/fr/users/jack','default','Webform','','7.39'),(1321,'/weebpal/forum-plus/fr/users/jack','default','The open or closed status of a webform.','','7.39'),(1322,'/weebpal/forum-plus/fr/users/jack','default','Webform submissions','','7.39'),(1323,'/weebpal/forum-plus/fr/users/jack','default','Submissions generated from Webform forms.','','7.39'),(1324,'/weebpal/forum-plus/fr/users/jack','default','Sid','','7.39'),(1325,'/weebpal/forum-plus/fr/users/jack','default','The submission ID of the submission.','','7.39'),(1326,'/weebpal/forum-plus/fr/users/jack','default','The webform node this submission was generated from.','','7.39'),(1327,'/weebpal/forum-plus/fr/users/jack','default','Webform Node','','7.39'),(1328,'/weebpal/forum-plus/fr/users/jack','default','The user who sent the webform submission.','','7.39'),(1329,'/weebpal/forum-plus/fr/users/jack','default','Webform Submission User','','7.39'),(1330,'/weebpal/forum-plus/fr/users/jack','default','Draft','','7.39'),(1331,'/weebpal/forum-plus/fr/users/jack','default','Whether or not the submission is a draft.','','7.39'),(1332,'/weebpal/forum-plus/fr/users/jack','default','Submitted','','7.39'),(1333,'/weebpal/forum-plus/fr/users/jack','default','The date this submission was submitted.','','7.34'),(1334,'/weebpal/forum-plus/fr/users/jack','default','Remote address','','7.39'),(1335,'/weebpal/forum-plus/fr/users/jack','default','The remote IP address of the user that submitted this submission.','','7.39'),(1336,'/weebpal/forum-plus/fr/users/jack','default','Provide a simple link to view the submission.','','7.39'),(1337,'/weebpal/forum-plus/fr/users/jack','default','Provide a simple link to edit the submission.','','7.39'),(1338,'/weebpal/forum-plus/fr/users/jack','default','Provide a simple link to delete the submission.','','7.39'),(1339,'/weebpal/forum-plus/fr/users/jack','default','Date','','7.39'),(1340,'/weebpal/forum-plus/fr/users/jack','default','Date (!base_table)','','7.39'),(1341,'/weebpal/forum-plus/fr/users/jack','default','Filter any Views !base_table date field by a date argument, using any common ISO date/period format (i.e. YYYY, YYYY-MM, YYYY-MM-DD, YYYY-W99, YYYY-MM-DD--P3M, P90D, etc). ','','7.39'),(1342,'/weebpal/forum-plus/fr/users/jack','default','Undated','','7.39'),(1343,'/weebpal/forum-plus/fr/users/jack','default','Filter any Views !base_table date field.','','7.39'),(1344,'/weebpal/forum-plus/fr/users/jack','default','The URL of the entity.','','7.39'),(1345,'/weebpal/forum-plus/fr/users/jack','default','Field name','','7.39'),(1346,'/weebpal/forum-plus/fr/users/jack','default','The machine-readable name of the field collection field containing this item.','','7.39'),(1347,'/weebpal/forum-plus/fr/users/jack','default','Host entity','','7.39'),(1348,'/weebpal/forum-plus/fr/users/jack','default','The entity containing the field collection field.','','7.39'),(1349,'/weebpal/forum-plus/fr/users/jack','default','Field collection','','7.39'),(1350,'/weebpal/forum-plus/fr/users/jack','default','This field stores references to embedded entities, which itself may contain any number of fields.','','7.39'),(1351,'/weebpal/forum-plus/fr/users/jack','default','Store a title, href, and attributes in the database to assemble a link.','','7.39'),(1352,'/weebpal/forum-plus/fr/users/jack','default','Hidden','','7.39'),(1353,'/weebpal/forum-plus/fr/users/jack','default','Embedded','','7.39'),(1354,'/weebpal/forum-plus/fr/users/jack','default','Links to field collection items','','7.39'),(1355,'/weebpal/forum-plus/fr/users/jack','default','Field collection items','','7.39'),(1356,'/weebpal/forum-plus/fr/users/jack','default','Fields only','','7.39'),(1357,'/weebpal/forum-plus/fr/users/jack','default','flexslider','','7.39'),(1358,'/weebpal/forum-plus/fr/users/jack','default','Title, as link (default)','','7.39'),(1359,'/weebpal/forum-plus/fr/users/jack','default','Title, as plain text','','7.39'),(1360,'/weebpal/forum-plus/fr/users/jack','default','URL, as link','','7.39'),(1361,'/weebpal/forum-plus/fr/users/jack','default','URL, as plain text','','7.39'),(1362,'/weebpal/forum-plus/fr/users/jack','default','URL, absolute','','7.39'),(1363,'/weebpal/forum-plus/fr/users/jack','default','Domain, as link','','7.39'),(1364,'/weebpal/forum-plus/fr/users/jack','default','Short, as link with title \"Link\"','','7.39'),(1365,'/weebpal/forum-plus/fr/users/jack','default','Label, as link with label as title','','7.39'),(1366,'/weebpal/forum-plus/fr/users/jack','default','Separate title and URL','','7.39'),(1367,'/weebpal/forum-plus/fr/users/jack','default','Video Player','','7.39'),(1368,'/weebpal/forum-plus/fr/users/jack','default','URL to Video','','7.39'),(1369,'/weebpal/forum-plus/fr/users/jack','default','Thumbnail Preview','','7.39'),(1370,'/weebpal/forum-plus/fr/users/jack','default','!label of field %name','','7.39'),(1371,'/weebpal/forum-plus/fr/users/jack','default','The title of the link.','','7.39'),(1372,'/weebpal/forum-plus/fr/users/jack','default','The URL of the link.','','7.39'),(1373,'/weebpal/forum-plus/fr/users/jack','default','Revisions','','7.39'),(1374,'/weebpal/forum-plus/fr/users/jack','default','FAQ short question','','7.39'),(1375,'/weebpal/forum-plus/fr/users/jack','default','The short question text for FAQ nodes.','','7.39'),(1376,'/weebpal/forum-plus/fr/users/jack','default','FAQ detailed question','','7.39'),(1377,'/weebpal/forum-plus/fr/users/jack','default','The long question text for FAQ nodes.','','7.39'),(1378,'/weebpal/forum-plus/fr/users/jack','default','FAQ weight','','7.39'),(1379,'/weebpal/forum-plus/fr/users/jack','default','The weight of the FAQ node.','','7.39'),(1380,'/weebpal/forum-plus/fr/users/jack','default','FAQ category tid','','7.39'),(1381,'/weebpal/forum-plus/fr/users/jack','default','The tid of the FAQ node.','','7.39'),(1382,'/weebpal/forum-plus/fr/users/jack','default','Tid','','7.39'),(1383,'/weebpal/forum-plus/fr/users/jack','default','category','','7.39'),(1384,'/weebpal/forum-plus/fr/users/jack','default','FAQ category','','7.39'),(1385,'/weebpal/forum-plus/fr/users/jack','default','The term of the FAQ node.','','7.39'),(1386,'/weebpal/forum-plus/fr/users/jack','default','@field-label - @property-label','','7.39'),(1387,'/weebpal/forum-plus/fr/users/jack','default','field collection item from !field_name','','7.39'),(1388,'/weebpal/forum-plus/fr/users/jack','default','Entity with the @field (@field_name)','','7.39'),(1389,'/weebpal/forum-plus/fr/users/jack','default','Relate each @entity using @field.','','7.39'),(1390,'/weebpal/forum-plus/fr/users/jack','default','ShareThis Link','','7.39'),(1391,'/weebpal/forum-plus/fr/users/jack','default','Link provided by the ShareThis service.','','7.39'),(1392,'/weebpal/forum-plus/fr/users/jack','default','Webform submission','','7.39'),(1393,'/weebpal/forum-plus/fr/users/jack','default','Webform submissions of the given Webform node.','','7.39'),(1394,'/weebpal/forum-plus/fr/users/jack','default','Webform Submission','','7.39'),(1395,'/weebpal/forum-plus/fr/users/jack','default','Webform submission count','','7.39'),(1396,'/weebpal/forum-plus/fr/users/jack','default','The number of webform submissions on this node.','','7.39'),(1397,'/weebpal/forum-plus/fr/users/jack','default','Webform submissions of the given user.','','7.39'),(1398,'/weebpal/forum-plus/fr/users/jack','default','The number of webform submissions for this user.','','7.39'),(1399,'/weebpal/forum-plus/fr/users/jack','default','Webform edit link','','7.39'),(1400,'/weebpal/forum-plus/fr/users/jack','default','Provide a simple link to edit the webform components and configuration.','','7.39'),(1401,'/weebpal/forum-plus/fr/users/jack','default','Webform results link','','7.39'),(1402,'/weebpal/forum-plus/fr/users/jack','default','Provide a simple link to view the results of a webform.','','7.39'),(1403,'/weebpal/forum-plus/fr/users/jack','default','Webform form body','','7.39'),(1404,'/weebpal/forum-plus/fr/users/jack','default','The Webform form body display for this node.','','7.39'),(1405,'/weebpal/forum-plus/fr/users/jack','default','Book root from current node','','7.39'),(1406,'/weebpal/forum-plus/fr/users/jack','default','Present view results as a Calendar.','','7.39'),(1407,'/weebpal/forum-plus/fr/users/jack','default','Calendar Items (DEPRECATED, switch to Calendar Entities)','','7.39'),(1408,'/weebpal/forum-plus/fr/users/jack','default','Displays each selected node as a Calendar item.','','7.39'),(1409,'/weebpal/forum-plus/fr/users/jack','default','Calendar Entities','','7.39'),(1410,'/weebpal/forum-plus/fr/users/jack','default','Displays each selected entity as a Calendar item.','','7.39'),(1411,'/weebpal/forum-plus/fr/users/jack','default','Display the comment with standard comment view.','','7.39'),(1412,'/weebpal/forum-plus/fr/users/jack','default','Display the comment as RSS.','','7.39'),(1413,'/weebpal/forum-plus/fr/users/jack','default','Date browser','','7.39'),(1414,'/weebpal/forum-plus/fr/users/jack','default','Date back/next navigation to attach to other displays. Requires the Date argument.','','7.39'),(1415,'/weebpal/forum-plus/fr/users/jack','default','Page by date','','7.39'),(1416,'/weebpal/forum-plus/fr/users/jack','default','Page using the value of a date field.','','7.39'),(1417,'/weebpal/forum-plus/fr/users/jack','default','Date browser style','','7.39'),(1418,'/weebpal/forum-plus/fr/users/jack','default','Creates back/next navigation.','','7.39'),(1419,'/weebpal/forum-plus/fr/users/jack','default','Renders a single entity in a specific view mode (e.g. teaser).','','7.39'),(1420,'/weebpal/forum-plus/fr/users/jack','default','Entity Reference Source','','7.39'),(1421,'/weebpal/forum-plus/fr/users/jack','default','Entity Reference list','','7.39'),(1422,'/weebpal/forum-plus/fr/users/jack','default','Inline fields','','7.39'),(1423,'/weebpal/forum-plus/fr/users/jack','default','Displays the fields with an optional template.','','7.39'),(1424,'/weebpal/forum-plus/fr/users/jack','default','FlexSlider','','7.39'),(1425,'/weebpal/forum-plus/fr/users/jack','default','Display the results in a FlexSlider widget.','','7.39'),(1426,'/weebpal/forum-plus/fr/users/jack','default','Display the content with standard node view.','','7.39'),(1427,'/weebpal/forum-plus/fr/users/jack','default','Content ID from URL','','7.39'),(1428,'/weebpal/forum-plus/fr/users/jack','default','Display view in Quicktabs.','','7.39'),(1429,'/weebpal/forum-plus/fr/users/jack','default','Taxonomy term ID from URL','','7.39'),(1430,'/weebpal/forum-plus/fr/users/jack','default','Display the user with standard user view.','','7.39'),(1431,'/weebpal/forum-plus/fr/users/jack','default','User ID from URL','','7.39'),(1432,'/weebpal/forum-plus/fr/users/jack','default','User ID from logged in user','','7.39'),(1433,'/weebpal/forum-plus/fr/users/jack','default','Views fieldsets options','','7.39'),(1434,'/weebpal/forum-plus/fr/users/jack','default','A way to export Views Fieldsets.','','7.39'),(1435,'/weebpal/forum-plus/fr/users/jack','default','Display the results as a slideshow.','','7.39'),(1436,'/weebpal/forum-plus/fr/users/jack','default','Default settings for this view.','','7.39'),(1437,'/weebpal/forum-plus/fr/users/jack','default','Display the view as a page, with a URL and menu links.','','7.39'),(1438,'/weebpal/forum-plus/fr/users/jack','default','Display the view as a block.','','7.39'),(1439,'/weebpal/forum-plus/fr/users/jack','default','Attachment','','7.39'),(1440,'/weebpal/forum-plus/fr/users/jack','default','Attachments added to other displays to achieve multiple views in the same view.','','7.39'),(1441,'/weebpal/forum-plus/fr/users/jack','default','Feed','','7.39'),(1442,'/weebpal/forum-plus/fr/users/jack','default','Display the view as a feed, such as an RSS feed.','','7.39'),(1443,'/weebpal/forum-plus/fr/users/jack','default','Embed','','7.39'),(1444,'/weebpal/forum-plus/fr/users/jack','default','Provide a display which can be embedded using the views api.','','7.39'),(1445,'/weebpal/forum-plus/fr/users/jack','default','Empty display extender','','7.39'),(1446,'/weebpal/forum-plus/fr/users/jack','default','Unformatted list','','7.39'),(1447,'/weebpal/forum-plus/fr/users/jack','default','Displays rows one after another.','','7.39'),(1448,'/weebpal/forum-plus/fr/users/jack','default','HTML list','','7.39'),(1449,'/weebpal/forum-plus/fr/users/jack','default','Displays rows as an HTML list.','','7.39'),(1450,'/weebpal/forum-plus/fr/users/jack','default','Grid','','7.39'),(1451,'/weebpal/forum-plus/fr/users/jack','default','Displays rows in a grid.','','7.39'),(1452,'/weebpal/forum-plus/fr/users/jack','default','Table','','7.39'),(1453,'/weebpal/forum-plus/fr/users/jack','default','Displays rows in a table.','','7.39'),(1454,'/weebpal/forum-plus/fr/users/jack','default','Displays the default summary as a list.','','7.39'),(1455,'/weebpal/forum-plus/fr/users/jack','default','Displays the summary unformatted, with option for one after another or inline.','','7.39'),(1456,'/weebpal/forum-plus/fr/users/jack','default','RSS Feed','','7.39'),(1457,'/weebpal/forum-plus/fr/users/jack','default','Generates an RSS feed from a view.','','7.39'),(1458,'/weebpal/forum-plus/fr/users/jack','default','Fields','','7.39'),(1459,'/weebpal/forum-plus/fr/users/jack','default','Display fields as RSS items.','','7.39'),(1460,'/weebpal/forum-plus/fr/users/jack','default','Fixed value','','7.39'),(1461,'/weebpal/forum-plus/fr/users/jack','default','PHP Code','','7.39'),(1462,'/weebpal/forum-plus/fr/users/jack','default','Raw value from URL','','7.39'),(1463,'/weebpal/forum-plus/fr/users/jack','default','Numeric','','7.39'),(1464,'/weebpal/forum-plus/fr/users/jack','default','None','','7.39'),(1465,'/weebpal/forum-plus/fr/users/jack','default','Will be available to all users.','','7.39'),(1466,'/weebpal/forum-plus/fr/users/jack','default','Role','','7.39'),(1467,'/weebpal/forum-plus/fr/users/jack','default','Access will be granted to users with any of the specified roles.','','7.39'),(1468,'/weebpal/forum-plus/fr/users/jack','default','Access will be granted to users with the specified permission string.','','7.39'),(1469,'/weebpal/forum-plus/fr/users/jack','default','SQL Query','','7.39'),(1470,'/weebpal/forum-plus/fr/users/jack','default','Query will be generated and run using the Drupal database API.','','7.39'),(1471,'/weebpal/forum-plus/fr/users/jack','default','No caching of Views data.','','7.39'),(1472,'/weebpal/forum-plus/fr/users/jack','default','Time-based','','7.39'),(1473,'/weebpal/forum-plus/fr/users/jack','default','Simple time-based caching of data.','','7.39'),(1474,'/weebpal/forum-plus/fr/users/jack','default','Basic exposed form','','7.39'),(1475,'/weebpal/forum-plus/fr/users/jack','default','Input required','','7.39'),(1476,'/weebpal/forum-plus/fr/users/jack','default','An exposed form that only renders a view if the form contains user input.','','7.39'),(1477,'/weebpal/forum-plus/fr/users/jack','default','Display all items','','7.39'),(1478,'/weebpal/forum-plus/fr/users/jack','default','Display all items that this view might find','','7.39'),(1479,'/weebpal/forum-plus/fr/users/jack','default','Display a specified number of items','','7.39'),(1480,'/weebpal/forum-plus/fr/users/jack','default','Display a limited number items that this view might find.','','7.39'),(1481,'/weebpal/forum-plus/fr/users/jack','default','Paged output, full pager','','7.39'),(1482,'/weebpal/forum-plus/fr/users/jack','default','Paged output, full Drupal style','','7.39'),(1483,'/weebpal/forum-plus/fr/users/jack','default','Paged output, mini pager','','7.39'),(1484,'/weebpal/forum-plus/fr/users/jack','default','Mini','','7.39'),(1485,'/weebpal/forum-plus/fr/users/jack','default','Use the mini pager output.','','7.39'),(1486,'/weebpal/forum-plus/fr/users/jack','default','Do not pass admin strings for translation.','','7.39'),(1487,'/weebpal/forum-plus/fr/users/jack','default','Core','','7.39'),(1488,'/weebpal/forum-plus/fr/users/jack','default','Use Drupal core t() function. Not recommended, as it doesn\'t support updates to existing strings.','','7.39'),(1489,'/weebpal/forum-plus/fr/users/jack','default','If you need to translate Views labels into other languages, consider installing the <a href=\"!path\">Internationalization</a> package\'s Views translation module.','','7.39'),(1490,'/weebpal/forum-plus/fr/users/jack','default','Jump menu','','7.39'),(1491,'/weebpal/forum-plus/fr/users/jack','default','Puts all of the results into a select box and allows the user to go to a different page based upon the results.','','7.39'),(1492,'/weebpal/forum-plus/fr/users/jack','default','Forum topic list','','7.39'),(1493,'/weebpal/forum-plus/fr/users/jack','default','Displays the forum topic list as a view.','','7.39'),(1494,'/weebpal/forum-plus/fr/users/jack','default','Overridden','','7.39'),(1495,'/weebpal/forum-plus/fr/users/jack','default','fields','','7.39'),(1496,'/weebpal/forum-plus/fr/users/jack','default','Contextual filters','','7.39'),(1497,'/weebpal/forum-plus/fr/users/jack','default','contextual filters','','7.39'),(1498,'/weebpal/forum-plus/fr/users/jack','default','Contextual filter','','7.39'),(1499,'/weebpal/forum-plus/fr/users/jack','default','contextual filter','','7.39'),(1500,'/weebpal/forum-plus/fr/users/jack','default','Sort criteria','','7.39'),(1501,'/weebpal/forum-plus/fr/users/jack','default','sort criteria','','7.39'),(1502,'/weebpal/forum-plus/fr/users/jack','default','Sort criterion','','7.39'),(1503,'/weebpal/forum-plus/fr/users/jack','default','sort criterion','','7.39'),(1504,'/weebpal/forum-plus/fr/users/jack','default','Filter criteria','','7.39'),(1505,'/weebpal/forum-plus/fr/users/jack','default','filter criteria','','7.39'),(1506,'/weebpal/forum-plus/fr/users/jack','default','Filter criterion','','7.39'),(1507,'/weebpal/forum-plus/fr/users/jack','default','filter criterion','','7.39'),(1508,'/weebpal/forum-plus/fr/users/jack','default','Relationships','','7.39'),(1509,'/weebpal/forum-plus/fr/users/jack','default','relationships','','7.39'),(1510,'/weebpal/forum-plus/fr/users/jack','default','Relationship','','7.39'),(1511,'/weebpal/forum-plus/fr/users/jack','default','header','','7.39'),(1512,'/weebpal/forum-plus/fr/users/jack','default','footer','','7.39'),(1513,'/weebpal/forum-plus/fr/users/jack','default','No results behavior','','7.39'),(1514,'/weebpal/forum-plus/fr/users/jack','default','no results behavior','','7.39'),(1515,'/weebpal/forum-plus/fr/users/jack','default','True','','7.39'),(1516,'/weebpal/forum-plus/fr/users/jack','default','Options','','7.39'),(1517,'/weebpal/forum-plus/fr/users/jack','default','Is one of','','7.39'),(1518,'/weebpal/forum-plus/fr/users/jack','default','in','','7.39'),(1519,'/weebpal/forum-plus/fr/users/jack','default','=','','7.39'),(1520,'/weebpal/forum-plus/fr/users/jack','default','Is not one of','','7.39'),(1521,'/weebpal/forum-plus/fr/users/jack','default','not in','','7.39'),(1522,'/weebpal/forum-plus/fr/users/jack','default','<>','','7.39'),(1523,'/weebpal/forum-plus/fr/users/jack','default','Is empty (NULL)','','7.39'),(1524,'/weebpal/forum-plus/fr/users/jack','default','empty','','7.39'),(1525,'/weebpal/forum-plus/fr/users/jack','default','Is not empty (NOT NULL)','','7.39'),(1526,'/weebpal/forum-plus/fr/users/jack','default','not empty','','7.39'),(1527,'/weebpal/forum-plus/fr/users/jack','default','Sun','','7.39'),(1528,'/weebpal/forum-plus/fr/users/jack','default','Aug','','7.39'),(1529,'/weebpal/forum-plus/fr/users/jack','default','am','','7.39'),(1530,'/weebpal/forum-plus/fr/users/jack','default','Archive','','7.39'),(1531,'/weebpal/forum-plus/fr/users/jack','default','Default Style','','7.39'),(1532,'/weebpal/forum-plus/fr/users/jack','default','Top','','7.39'),(1533,'/weebpal/forum-plus/fr/contact','default','Your name','','7.39'),(1534,'/weebpal/forum-plus/fr/contact','default','Your e-mail address','','7.34'),(1535,'/weebpal/forum-plus/fr/contact','default','Category','','7.34'),(1536,'/weebpal/forum-plus/fr/contact','default','Send yourself a copy.','','7.34'),(1537,'/weebpal/forum-plus/fr/contact','default','Send message','','7.34'),(1538,'/weebpal/forum-plus/fr/contact; sites/all/modules/webform/js/webform.js','default','This field is required.','','7.39'),(1539,'/weebpal/forum-plus/fr/node/40','default','Presents month, day, and year fields.','','7.34'),(1540,'/weebpal/forum-plus/fr/node/40','default','A special textfield that accepts e-mail addresses.','','7.34'),(1541,'/weebpal/forum-plus/fr/node/40','default','Fieldsets allow you to organize multiple fields into groups.','','7.34'),(1542,'/weebpal/forum-plus/fr/node/40','default','Allows creation of grid questions, denoted by radio buttons.','','7.34'),(1543,'/weebpal/forum-plus/fr/node/40','default','A field which is not visible to the user, but is recorded with the submission.','','7.34'),(1544,'/weebpal/forum-plus/fr/node/40','default','Markup','','7.34'),(1545,'/weebpal/forum-plus/fr/node/40','default','Displays text as HTML in the form; does not render a field.','','7.34'),(1546,'/weebpal/forum-plus/fr/node/40','default','Number','','7.39'),(1547,'/weebpal/forum-plus/fr/node/40','default','A numeric input field (either as textfield or select list).','','7.34'),(1548,'/weebpal/forum-plus/fr/node/40','default','Page break','','7.34'),(1549,'/weebpal/forum-plus/fr/node/40','default','Organize forms into multiple pages.','','7.34'),(1550,'/weebpal/forum-plus/fr/node/40','default','Select options','','7.34'),(1551,'/weebpal/forum-plus/fr/node/40','default','Allows creation of checkboxes, radio buttons, or select menus.','','7.34'),(1552,'/weebpal/forum-plus/fr/node/40','default','Textarea','','7.34'),(1553,'/weebpal/forum-plus/fr/node/40','default','A large text area that allows for multiple lines of input.','','7.34'),(1554,'/weebpal/forum-plus/fr/node/40','default','Textfield','','7.34'),(1555,'/weebpal/forum-plus/fr/node/40','default','Basic textfield type.','','7.34'),(1556,'/weebpal/forum-plus/fr/node/40','default','Time','','7.34'),(1557,'/weebpal/forum-plus/fr/node/40','default','Presents the user with hour and minute fields. Optional am/pm fields.','','7.34'),(1558,'/weebpal/forum-plus/fr/node/40','default','Allow users to upload files of configurable types.','','7.34'),(1559,'/weebpal/forum-plus/fr/node/40','default','Wed','','7.39'),(1560,'/weebpal/forum-plus/fr/node/41','default','Submit','','7.34'),(1561,'/weebpal/forum-plus/fr/node/41','default','Thu','','7.39'),(1562,'/weebpal/forum-plus/fr/node/40','default','@count reads','','7.39'),(1563,'/weebpal/forum-plus/fr/node/40','default','Form components','','7.28'),(1564,'/weebpal/forum-plus/fr/node/40','default','E-mails','','7.28'),(1565,'/weebpal/forum-plus/fr/node/40','default','Form settings','','7.28'),(1566,'/weebpal/forum-plus/fr/node/40','default','Outline','','7.39'),(1567,'/weebpal/forum-plus/fr/node/40','default','Results','','7.28'),(1568,'/weebpal/forum-plus/fr/node/40','default','Track','','7.39'),(1569,'/weebpal/forum-plus/fr/node/40','default','Submissions','','7.28'),(1570,'/weebpal/forum-plus/fr/node/40','default','Analysis','','7.28'),(1571,'/weebpal/forum-plus/fr/node/40','default','Download','','7.28'),(1572,'/weebpal/forum-plus/fr/node/40','default','Clear','','7.39'),(1573,'/weebpal/forum-plus/fr/node/40','default','pm','','7.39'),(1574,'/weebpal/forum-plus/fr/node/40','default','Frequently Asked Questions','','7.39'),(1575,'/weebpal/forum-plus/fr/node/40','default','Allows the user to configure the layout of questions and answers on a FAQ page.','','7.39'),(1576,'/weebpal/forum-plus/fr/node/40','default','Allows the user to configure the layout of questions and answers using categories on a FAQ page.','','7.39'),(1577,'/weebpal/forum-plus/fr/node/40','default','General','','7.39'),(1578,'/weebpal/forum-plus/fr/node/40','default','Allows the user to configure the header and descriptive text for the FAQ page.','','7.39'),(1579,'/weebpal/forum-plus/fr/node/40','default','Questions','','7.39'),(1580,'/weebpal/forum-plus/fr/node/40','default','Webform settings','','7.39'),(1581,'/weebpal/forum-plus/fr/node/40','default','Global configuration of webform functionality.','','7.39'),(1582,'/weebpal/forum-plus/fr/node/40','default','Webform hints','','7.28'),(1583,'/weebpal/forum-plus/fr/node/40','default','Administer which of your Webforms will receive the hints effect.','','7.39'),(1584,'/weebpal/forum-plus/fr/node/40','default','Modal forms','','7.39'),(1585,'/weebpal/forum-plus/fr/node/40','default','Adjust Modal forms settings.','','7.39'),(1586,'/weebpal/forum-plus/fr/node/40','default','video style','','7.39'),(1587,'/weebpal/forum-plus/fr/node/40','default','video styles','','7.39'),(1588,'/weebpal/forum-plus/fr/node/40','default','Video Styles','','7.39'),(1589,'/weebpal/forum-plus/fr/node/40','default','Video Embed Styles','','7.39'),(1590,'/weebpal/forum-plus/fr/node/40','default','Administer Video Embed Field\'s video styles.','','7.39'),(1591,'/weebpal/forum-plus/fr/node/40','default','optionset','','7.39'),(1592,'/weebpal/forum-plus/fr/node/40','default','optionsets','','7.39'),(1593,'/weebpal/forum-plus/fr/node/40','default','FlexSlider optionset','','7.39'),(1594,'/weebpal/forum-plus/fr/node/40','default','FlexSlider optionsets','','7.39'),(1595,'/weebpal/forum-plus/fr/node/40','default','Administer FlexSlider presets.','','7.39'),(1596,'/weebpal/forum-plus/fr/node/40','default','Advanced settings','','7.39'),(1597,'/weebpal/forum-plus/fr/node/40','default','Configure the advanced flexslider module settings.','','7.39'),(1598,'/weebpal/forum-plus/fr/node/40','default','Remember me settings','','7.39'),(1599,'/weebpal/forum-plus/fr/node/40','default','Configure settings like session time out for remember_me module.','','7.39'),(1600,'/weebpal/forum-plus/fr/node/40','default','Menu Breadcrumb','','7.39'),(1601,'/weebpal/forum-plus/fr/node/40','default','Configure menu breadcrumb.','','7.39'),(1602,'/weebpal/forum-plus/fr/node/40','default','ShareThis','','7.39'),(1603,'/weebpal/forum-plus/fr/node/40','default','Choose the widget, button family, and services for using ShareThis to share content online.','','7.39'),(1604,'/weebpal/forum-plus/fr/node/40','default','Date API','','7.39'),(1605,'/weebpal/forum-plus/fr/node/40','default','Settings for modules the use the Date API.','','7.39'),(1606,'/weebpal/forum-plus/fr/node/40','default','Calendar administration.','','7.39'),(1607,'/weebpal/forum-plus/fr/node/40','default','Webforms','','7.39'),(1608,'/weebpal/forum-plus/fr/node/40','default','View and edit all the available webforms on your site.','','7.39'),(1609,'/weebpal/forum-plus/fr/node/40','default','Field collections','','7.39'),(1610,'/weebpal/forum-plus/fr/node/40','default','Manage fields on field collections.','','7.39'),(1611,'/weebpal/forum-plus/fr/node/40','default','calendar','','7.39'),(1612,'/weebpal/forum-plus/fr/node/40','default','faq','','7.39'),(1613,'/weebpal/forum-plus/fr/node/40','default','php','','7.39'),(1614,'/weebpal/forum-plus/fr/node/40','default','menu_breadcrumb','','7.39'),(1615,'/weebpal/forum-plus/fr/node/40','default','sharethis','','7.39'),(1616,'/weebpal/forum-plus/fr/node/40','default','webform','','7.39'),(1617,'/weebpal/forum-plus/fr/node/40','default','remember_me','','7.39'),(1618,'/weebpal/forum-plus/fr/node/40','default','field_collection','','7.39'),(1619,'/weebpal/forum-plus/fr/node/40','default','Create a new form or questionnaire accessible to users. Submission results and statistics are recorded and accessible to privileged users.','','7.39'),(1620,'/weebpal/forum-plus/fr/articles','default','Sat','','7.39'),(1621,'/weebpal/forum-plus/fr/articles','default','Jul','','7.39'),(1622,'/weebpal/forum-plus/fr/articles','default','Fri','','7.39'),(1623,'/weebpal/forum-plus/fr/articles','default','Fieldset','views_fieldsets','7.39'),(1624,'/weebpal/forum-plus/fr/articles','default','Go to first page','','7.39'),(1625,'/weebpal/forum-plus/fr/articles','default','Go to previous page','','7.39'),(1626,'/weebpal/forum-plus/fr/articles','default','Go to next page','','7.39'),(1627,'/weebpal/forum-plus/fr/articles','default','Go to last page','','7.39'),(1628,'/weebpal/forum-plus/fr/articles','default','Go to page @number','','7.39'),(1629,'/weebpal/forum-plus/fr/articles','default','Pages','','7.39'),(1630,'/weebpal/forum-plus/fr/articles','default','Tags in @voc','','7.39'),(1631,'/weebpal/forum-plus/fr/articles','default','more tags','','7.39'),(1632,'/weebpal/forum-plus/fr/articles','default','Active forum topics','','7.39'),(1633,'/weebpal/forum-plus/fr/articles','default','@count comments','','7.39'),(1634,'/weebpal/forum-plus/fr/articles','default','The requested page \"@path\" could not be found.','','7.39'),(1635,'/weebpal/forum-plus/fr/js/admin_menu/cache/99bb273a9b7edf772adc4d6f3609e709','default','','','7.39'),(1636,'/weebpal/forum-plus/fr/node/12','default','Vocabulary titles and term names for localizable quicktabs.','','7.39'),(1637,'/weebpal/forum-plus/fr/node/12','default','Vocabulary titles and term names for localizable vocabularies.','','7.39'),(1638,'/weebpal/forum-plus/fr/node/12','default','Configurable blocks titles and content.','','7.39'),(1639,'/weebpal/forum-plus/fr/node/12','default','Add new comment','','7.39'),(1640,'/weebpal/forum-plus/fr/node/12','default','Share your thoughts and opinions related to this posting.','','7.34'),(1641,'/weebpal/forum-plus/fr/node/12','default','Embed FAQ page','','7.39'),(1642,'/weebpal/forum-plus/fr/node/12','default','Embed FAQ page using [faq] type tags.  Disables filter caching so not recommended for all input formats.','','7.39'),(1643,'/weebpal/forum-plus/fr/node/12','default','Limit allowed HTML tags','','7.39'),(1644,'/weebpal/forum-plus/fr/node/12','default','Convert line breaks into HTML (i.e. <code>&lt;br&gt;</code> and <code>&lt;p&gt;</code>)','','7.39'),(1645,'/weebpal/forum-plus/fr/node/12','default','Convert URLs into links','','7.39'),(1646,'/weebpal/forum-plus/fr/node/12','default','Correct faulty and chopped off HTML','','7.39'),(1647,'/weebpal/forum-plus/fr/node/12','default','Display any HTML as plain text','','7.39'),(1648,'/weebpal/forum-plus/fr/node/12','default','PHP evaluator','','7.39'),(1649,'/weebpal/forum-plus/fr/node/12','default','Executes a piece of PHP code. The usage of this filter should be restricted to administrators only!','','7.39'),(1650,'/weebpal/forum-plus/fr/node/12','default','Shortcodes','','7.39'),(1651,'/weebpal/forum-plus/fr/node/12','default','Provides WP like shortcodes to this text format.','','7.39'),(1652,'/weebpal/forum-plus/fr/node/12','default','Shortcodes - html corrector','','7.39'),(1653,'/weebpal/forum-plus/fr/node/12','default','Trying to correct the html around shortcodes. Enable only if you using wysiwyg editor.','','7.39'),(1654,'/weebpal/forum-plus/fr/node/12','default','Video Embedding','','7.39'),(1655,'/weebpal/forum-plus/fr/node/12','default','Replaces [VIDEO::http://www.youtube.com/watch?v=someVideoID::aVideoStyle] tags with embedded videos.','','7.39'),(1656,'/weebpal/forum-plus/fr/node/12','default','delete','','7.39'),(1657,'/weebpal/forum-plus/fr/node/12','default','edit','','7.39'),(1658,'/weebpal/forum-plus/fr/node/12','default','reply','','7.34'),(1659,'/weebpal/forum-plus/fr/node/12','default','The content of this field is kept private and will not be shown publicly.','','7.39'),(1660,'/weebpal/forum-plus/fr/node/12','default','Homepage','','7.39'),(1661,'/weebpal/forum-plus/fr/node/12','default','Authored on','','7.39'),(1662,'/weebpal/forum-plus/fr/node/12','default','Save','','7.39'),(1663,'/weebpal/forum-plus/fr/node/12','default','Preview','','7.39'),(1664,'/weebpal/forum-plus/fr/node/12','default','Webform client form.','','7.39'),(1665,'/weebpal/forum-plus/fr/node/12','default','Author textfield','','7.39'),(1666,'/weebpal/forum-plus/fr/node/12','default','Subject textfield','','7.39'),(1667,'/weebpal/forum-plus/fr/node/12','default','Question details','','7.28'),(1668,'/weebpal/forum-plus/fr/node/12','default','Longer question text','','7.28'),(1669,'/weebpal/forum-plus/fr/node/12','default','Complete rendered message text.','','7.39'),(1670,'/weebpal/forum-plus/fr/node/12','default','Node module element','','7.39'),(1671,'/weebpal/forum-plus/fr/node/12','default','URL path settings','','7.39'),(1672,'/weebpal/forum-plus/fr/node/12','default','Path module form elements','','7.39'),(1673,'/weebpal/forum-plus/fr/node/12','default','Term name textfield','','7.39'),(1674,'/weebpal/forum-plus/fr/node/12','default','Term description textarea','','7.39'),(1675,'/weebpal/forum-plus/fr/node/12','default','User name and password','','7.39'),(1676,'/weebpal/forum-plus/fr/node/12','default','User module account form elements.','','7.39'),(1677,'/weebpal/forum-plus/fr/node/12','default','Timezone','','7.39'),(1678,'/weebpal/forum-plus/fr/node/12','default','User module timezone form element.','','7.39'),(1679,'/weebpal/forum-plus/fr/node/12','default','User module history view element.','','7.39'),(1680,'/weebpal/forum-plus/fr/node/12','default','User picture','','7.39'),(1681,'/weebpal/forum-plus/fr/node/12','default','Administrative overlay','','7.39'),(1682,'/weebpal/forum-plus/fr/node/12','default','Contact user element','','7.39'),(1683,'/weebpal/forum-plus/fr/node/12','default','Language settings','','7.39'),(1684,'/weebpal/forum-plus/fr/node/12','default','Language settings for the user account.','','7.39'),(1685,'/weebpal/forum-plus/fr/node/12','default','Submitted by !username on !datetime','','7.39'),(1686,'/weebpal/forum-plus/fr/node/12','default','<span class=\"author\">By !username</span> <span class=\"created\">!datetime</span>','','7.39'),(1687,'/weebpal/forum-plus/fr/node/12','default','Permalink','','7.34'),(1688,'/weebpal/forum-plus/fr/node/12','default','More information about text formats','','7.39'),(1689,'/weebpal/forum-plus/fr/node/12','default','Web page addresses and e-mail addresses turn into links automatically.','','7.39'),(1690,'/weebpal/forum-plus/fr/node/12','default','Allowed HTML tags: @tags','','7.39'),(1691,'/weebpal/forum-plus/fr/node/12','default','Lines and paragraphs break automatically.','','7.39'),(1692,'/weebpal/forum-plus/fr/node/12','default','Quote','','7.39'),(1693,'/weebpal/forum-plus/fr/node/12','default','Replace the given text formatted like as a quote.','','7.39'),(1694,'/weebpal/forum-plus/fr/node/12','default','Show an image.','','7.39'),(1695,'/weebpal/forum-plus/fr/node/12','default','Highlight','','7.39'),(1696,'/weebpal/forum-plus/fr/node/12','default','Insert a span with highlight css class around the text.','','7.39'),(1697,'/weebpal/forum-plus/fr/node/12','default','Button','','7.39'),(1698,'/weebpal/forum-plus/fr/node/12','default','Insert a link formatted like as a button.','','7.39'),(1699,'/weebpal/forum-plus/fr/node/12','default','Dropcap','','7.39'),(1700,'/weebpal/forum-plus/fr/node/12','default','Replace the given text formatted like as a dropcap.','','7.39'),(1701,'/weebpal/forum-plus/fr/node/12','default','Item','','7.39'),(1702,'/weebpal/forum-plus/fr/node/12','default','Insert div or span around the text with some css classes.','','7.39'),(1703,'/weebpal/forum-plus/fr/node/12','default','Insert a float-clearing div for a proper layout.','','7.39'),(1704,'/weebpal/forum-plus/fr/node/12','default','Makes an aliased link to the given path.','','7.39'),(1705,'/weebpal/forum-plus/fr/node/12','default','Random text','','7.39'),(1706,'/weebpal/forum-plus/fr/node/12','default','Generating random text.','','7.39'),(1707,'/weebpal/forum-plus/fr/node/12','default','Embed content','','7.39'),(1708,'/weebpal/forum-plus/fr/node/12','default','Embed node content into the text.','','7.39'),(1709,'/weebpal/forum-plus/fr/node/12','default','Video macro','','7.39'),(1710,'/weebpal/forum-plus/fr/node/12','default','Inserts embedded video code.','','7.39'),(1711,'/weebpal/forum-plus/fr/node/12','default','Tooltip','','7.39'),(1712,'/weebpal/forum-plus/fr/node/12','default','Replace the given text formatted like as a tooltip.','','7.39'),(1713,'/weebpal/forum-plus/fr/node/12','default','Collapse','','7.39'),(1714,'/weebpal/forum-plus/fr/node/12','default','Replace the given text formatted like as a collapse.','','7.39'),(1715,'/weebpal/forum-plus/fr/node/12','default','[quote (class=\"additional class\" | author=\"author name\")]text[/quote]','','7.39'),(1716,'/weebpal/forum-plus/fr/node/12','default','Formats the text like as a quote. Additional class names can be added by the <em>class</em> parameter.','','7.39'),(1717,'/weebpal/forum-plus/fr/node/12','default','[img scr=\"image.jpg\" (class=\"additional class\"|alt=\"alt text\")/]','','7.39'),(1718,'/weebpal/forum-plus/fr/node/12','default','Inserts an image based on the given image url.','','7.39'),(1719,'/weebpal/forum-plus/fr/node/12','default','[highlight (class=\"additional class\")]text[/highlight]','','7.39'),(1720,'/weebpal/forum-plus/fr/node/12','default','Inserts span.highlight around the text. Additional class names can be added by the <em>class</em> parameter.','','7.39'),(1721,'/weebpal/forum-plus/fr/node/12','default','[button path=\"path\" (class=\"additional class\")]text[/button]','','7.39'),(1722,'/weebpal/forum-plus/fr/node/12','default','Inserts a link formatted like as a button. The <em>path</em> parameter provides the link target (the default is the front page).\n    The <em>title</em> will be formatted as a link title (small tooltip over the link - helps for SEO).\n    Additional class names can be added by the <em>class</em> parameter.','','7.34'),(1723,'/weebpal/forum-plus/fr/node/12','default','[dropcap (class=\"additional class\")]text[/dropcap]','','7.39'),(1724,'/weebpal/forum-plus/fr/node/12','default','Makes dropcap from the text. Additional class names can be added by the <em>class</em> parameter.','','7.39'),(1725,'/weebpal/forum-plus/fr/node/12','default','[item (class=\"additional class\"|id=item id|type=div,d,span,s)]text[/item]','','7.39'),(1726,'/weebpal/forum-plus/fr/node/12','default','Inserts an html item (div or span) around the given text.','','7.39'),(1727,'/weebpal/forum-plus/fr/node/12','default','[clear (class=\"additional class\"|id=item id|type=div,d,span,s)]text[/clear]','','7.39'),(1728,'/weebpal/forum-plus/fr/node/12','default','Inserts a float-clearing html item (div or span) around the given text. Use the simple [clear /].','','7.39'),(1729,'/weebpal/forum-plus/fr/node/12','default','[link path=\"the drupal path\" (title=\"link title\"|class=\"additional class\"|id=item id|style=css style rules)]text[/link]','','7.32'),(1730,'/weebpal/forum-plus/fr/node/12','default','Inserts an aliased drupal path around the text. You can omit the text and the closing [/link], you get back the url only.','','7.32'),(1731,'/weebpal/forum-plus/fr/node/12','default','Inserts a random text with the given length.','','7.39'),(1732,'/weebpal/forum-plus/fr/node/12','default','[video]video url[/video]','','7.39'),(1733,'/weebpal/forum-plus/fr/node/12','default','Embeds the video into the content text. With the <em>width</em> and <em>height</em> parameter you can specify the video size.','','7.32'),(1734,'/weebpal/forum-plus/fr/node/12','default','For YouTube videos you can specify the width with 420, 480, 640, 960 as the default videos sizes, then the height of the video will be added according to the default embed sizes. The default video size is 480x360px.','','7.39'),(1735,'/weebpal/forum-plus/fr/node/12','default','[tooltip (id=\"unique id\" | class=\"additional class\" | placement=\"left|top|bottom|right\" | title=\"tooltip text\" | tag=\"tag\")]text[/tooltip]','','7.39'),(1736,'/weebpal/forum-plus/fr/node/12','default','[collapse][/collapse]','','7.39'),(1737,'/weebpal/forum-plus/fr/node/12','default','Shortcodes usage','','7.39'),(1738,'/weebpal/forum-plus/fr/node/12','default','No HTML tags allowed.','','7.39'),(1739,'/weebpal/forum-plus/fr/node/12','default','You may post PHP code. You should include &lt;?php ?&gt; tags.','','7.39'),(1740,'/weebpal/forum-plus/fr/blogs','default','Video Link','','7.39'),(1741,'/weebpal/forum-plus/fr/blogs','default','Jun','','7.39'),(1742,'/weebpal/forum-plus/fr/blogs','default','Mon','','7.39'),(1743,'/weebpal/forum-plus/fr/blogs','default','Tue','','7.39'),(1744,'/weebpal/forum-plus/fr/blogs','default','Local','','7.39'),(1745,'/weebpal/forum-plus/fr/blogs','default','Previous','','7.39'),(1746,'/weebpal/forum-plus/fr/blogs','default','Next','','7.39'),(1747,'/weebpal/forum-plus/fr/blogs','default','Pause','','7.39'),(1748,'/weebpal/forum-plus/fr/blogs','default','Play','','7.39'),(1749,'/weebpal/forum-plus/fr/blogs','default','Who\'s new','','7.39'),(1750,'/weebpal/forum-plus/fr/blogs','default','There are currently @count users online.','','7.32'),(1751,'/weebpal/forum-plus/fr/blogs','default','Who\'s online','','7.39'),(1752,'/weebpal/forum-plus/fr/blogs','default','Edit quicktab','','7.39'),(1753,'/weebpal/forum-plus/fr/node/7','default','!name\'s blog','','7.32'),(1754,'/weebpal/forum-plus/fr/node/7','default','Rate','','7.39'),(1755,'/weebpal/forum-plus/fr/node/7','default','Select rating','','7.39'),(1756,'/weebpal/forum-plus/fr/node/7','default','Give it @star/@count','','7.39'),(1757,'/weebpal/forum-plus/fr/node/7','default','Average: !stars','','7.39'),(1758,'/weebpal/forum-plus/fr/node/7','default','!cnt vote','','7.34'),(1759,'/weebpal/forum-plus/fr/node/7','default','!username\'s blog','','7.32'),(1760,'/weebpal/forum-plus/fr/node/7','default','Read !username\'s latest blog entries.','','7.34'),(1761,'/weebpal/forum-plus/fr/node/7','default','!instance_label @count','','7.34'),(1762,'/weebpal/forum-plus/fr/forum','default','1 new','','7.28'),(1763,'/weebpal/forum-plus/fr/forum','default','@count min','','7.34'),(1764,'/weebpal/forum-plus/fr/forum','default','1 month','','7.34'),(1765,'/weebpal/forum-plus/fr/forum','default','Information','','7.39'),(1766,'/weebpal/forum-plus/fr/forum','default','Icon Legend','','7.39'),(1767,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Drupal core update status','','7.32'),(1768,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','There is a security update available for your version of Drupal. To ensure the security of your server, you should update immediately!','','7.32'),(1769,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','See the <a href=\"@available_updates\">available updates</a> page for more information and to install your missing updates.','','7.32'),(1770,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Not secure!','','7.32'),(1771,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','(version @version available)','','7.32'),(1772,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Module and theme update status','','7.32'),(1773,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','There are security updates available for one or more of your modules or themes. To ensure the security of your server, you should update immediately!','','7.28'),(1774,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','GD library PNG support','','7.32'),(1775,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','CTools CSS Cache','','7.32'),(1776,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Exists','','7.32'),(1777,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','The timezone has been set to <a href=\"@regional_settings\">@timezone</a>.','','7.32'),(1778,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Sunday','','7.32'),(1779,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Monday','','7.32'),(1780,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Tuesday','','7.39'),(1781,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Wednesday','','7.32'),(1782,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Thursday','','7.34'),(1783,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Friday','','7.32'),(1784,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Saturday','','7.32'),(1785,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','The first day of the week has been set to <a href=\"@regional_settings\">@day</a>.','','7.32'),(1786,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','The medium date format type has been set to to @value. You may find it helpful to add new format types like Date, Time, Month, or Year, with appropriate formats, at <a href=\"@regional_date_time\">Date and time</a> settings.','','7.32'),(1787,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','System date settings','','7.32'),(1788,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Enabled (<a href=\"http://pecl.php.net/package/uploadprogress\">PECL uploadprogress</a>)','','7.28'),(1789,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Upload progress','','7.32'),(1790,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Version 2.0 installed','','7.32'),(1791,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Version %version installed','','7.32'),(1792,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','FlexSlider library installed.','','7.32'),(1793,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','GD library rotate and desaturate effects','','7.32'),(1794,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','jQuery Update','','7.32'),(1795,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','jQuery %jquery and jQuery UI %ui','','7.32'),(1796,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','If the site is experiencing problems with permissions to content, you may have to rebuild the permissions cache. Rebuilding will remove all privileges to content and replace them with permissions based on the current modules and settings. Rebuilding may take some time if there is a lot of content or complex permission settings. After rebuilding has completed, content will automatically use the new permissions.','','7.32'),(1797,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Node Access Permissions','','7.32'),(1798,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Rebuild permissions','','7.32'),(1799,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Drupal','','7.32'),(1800,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Web server','','7.32'),(1801,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','PHP','','7.32'),(1802,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','more information','','7.32'),(1803,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','PHP register globals','','7.32'),(1804,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','PHP extensions','','7.32'),(1805,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Database system','','7.32'),(1806,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Database system version','','7.32'),(1807,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','PHP memory limit','','7.32'),(1808,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Not protected','','7.32'),(1809,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','The file %file is not protected from modifications and poses a security risk. You must change the file\'s permissions to be non-writable.','','7.32'),(1810,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Configuration file','','7.32'),(1811,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Public files directory','','7.32'),(1812,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Temporary files directory','','7.32'),(1813,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','For more information, see the online handbook entry for <a href=\"@cron-handbook\">configuring cron jobs</a>.','','7.32'),(1814,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','@count sec','','7.39'),(1815,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Last run !time ago','','7.32'),(1816,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','You can <a href=\"@cron\">run cron manually</a>.','','7.32'),(1817,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','To run cron from outside the site, go to <a href=\"!cron\">!cron</a>','','7.32'),(1818,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Cron maintenance tasks','','7.32'),(1819,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Writable (<em>public</em> download method)','','7.32'),(1820,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Database updates','','7.32'),(1821,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Up to date','','7.32'),(1822,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Protected','','7.32'),(1823,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Access to update.php','','7.32'),(1824,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Standard PHP','','7.32'),(1825,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','PHP Mbstring Extension','','7.32'),(1826,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Error','','7.32'),(1827,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Unicode library','','7.32'),(1828,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Update notifications','','7.32'),(1829,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','The source node for this current node\'s translation set.','','7.39'),(1830,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','The explanation of the most recent changes made to the node.','','7.39'),(1831,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','The content type of the node.','','7.39'),(1832,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Tokens related to content types.','','7.39'),(1833,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','The name of the content type.','','7.39'),(1834,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','The unique machine-readable name of the content type.','','7.39'),(1835,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','The optional description of the content type.','','7.39'),(1836,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','The number of nodes belonging to the content type.','','7.39'),(1837,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','The URL of the content type\'s edit page.','','7.39'),(1838,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','The URL of the taxonomy term\'s edit page.','','7.39'),(1839,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Parents','','7.39'),(1840,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','An array of all the term\'s parents, starting with the root.','','7.39'),(1841,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Root term','','7.39'),(1842,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','The root term of the taxonomy term.','','7.39'),(1843,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','The unique machine-readable name of the vocabulary.','','7.39'),(1844,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','The URL of the vocabulary\'s edit page.','','7.39'),(1845,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Base name','','7.39'),(1846,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','The base name of the file.','','7.39'),(1847,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','File byte size','','7.39'),(1848,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','The size of the file, in bytes.','','7.39'),(1849,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Account cancellation URL','','7.39'),(1850,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','The URL of the confirm delete page for the user account.','','7.39'),(1851,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','One-time login URL','','7.39'),(1852,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','The URL of the one-time login page for the user account.','','7.39'),(1853,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','The picture of the user.','','7.39'),(1854,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','The user roles associated with the user account.','','7.39'),(1855,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','IP address','','7.39'),(1856,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Menu links','','7.39'),(1857,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Tokens related to menu links.','','7.39'),(1858,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Link ID','','7.39'),(1859,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','The unique ID of the menu link.','','7.39'),(1860,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','The title of the menu link.','','7.39'),(1861,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','The URL of the menu link.','','7.39'),(1862,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','The menu link\'s parent.','','7.39'),(1863,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','An array of all the menu link\'s parents, starting with the root.','','7.39'),(1864,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Root','','7.39'),(1865,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','The menu link\'s root.','','7.39'),(1866,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Tokens related to the current page request.','','7.39'),(1867,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','The title of the current page.','','7.39'),(1868,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','The URL of the current page.','','7.39'),(1869,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Page number','','7.39'),(1870,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','The page number of the current page when viewing paged lists.','','7.39'),(1871,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Query string value','','7.39'),(1872,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','The value of a specific query string field of the current page.','','7.39'),(1873,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Tokens related to URLs.','','7.39'),(1874,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','The path component of the URL.','','7.39'),(1875,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Relative URL','','7.39'),(1876,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','The relative URL.','','7.39'),(1877,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Absolute URL','','7.39'),(1878,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','The absolute URL.','','7.39'),(1879,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Brief URL','','7.39'),(1880,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','The URL without the protocol and trailing backslash.','','7.39'),(1881,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Unaliased URL','','7.39'),(1882,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','The unaliased URL.','','7.39'),(1883,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Arguments','','7.39'),(1884,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','The specific argument of the current page (e.g. \'arg:1\' on the page \'node/1\' returns \'1\').','','7.39'),(1885,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Array','','7.39'),(1886,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Tokens related to arrays of strings.','','7.39'),(1887,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','First','','7.39'),(1888,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','The first element of the array.','','7.39'),(1889,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Last','','7.39'),(1890,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','The last element of the array.','','7.39'),(1891,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Count','','7.39'),(1892,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','The number of elements in the array.','','7.39'),(1893,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Reversed','','7.39'),(1894,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','The array reversed.','','7.39'),(1895,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Keys','','7.39'),(1896,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','The array of keys of the array.','','7.39'),(1897,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Imploded','','7.39'),(1898,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','The values of the array joined together with a custom string in-between each value.','','7.39'),(1899,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','The specific value of the array.','','7.39'),(1900,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','A random number from 0 to @max.','','7.39'),(1901,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Hash','','7.39'),(1902,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','A random hash. The possible hashing algorithms are: @hash-algos.','','7.39'),(1903,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','The book page associated with the node.','','7.39'),(1904,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Tokens for comments posted on the site.','','7.39'),(1905,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','The formatted content of the comment itself.','','7.39'),(1906,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','The date the comment was most recently updated.','','7.39'),(1907,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','The author of the comment, if they were logged in.','','7.39'),(1908,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Tokens related to menus.','','7.39'),(1909,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','The name of the menu.','','7.39'),(1910,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','The unique machine-readable name of the menu.','','7.39'),(1911,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','The optional description of the menu.','','7.39'),(1912,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Menu link count','','7.39'),(1913,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','The number of menu links belonging to the menu.','','7.39'),(1914,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','The URL of the menu\'s edit page.','','7.39'),(1915,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','The menu of the menu link.','','7.39'),(1916,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','The URL of the menu link\'s edit page.','','7.39'),(1917,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Menu link','','7.39'),(1918,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','The menu link for this node.','','7.39'),(1919,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Comment teaser','','7.39'),(1920,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Display a comment teaser.','','7.39'),(1921,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Node teaser','','7.39'),(1922,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Display a node teaser.','','7.39'),(1923,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Tokens related to individual content items, or \"nodes\".','','7.39'),(1924,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Content ID','','7.39'),(1925,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','The unique ID of the content item, or \"node\".','','7.39'),(1926,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','The unique ID of the node\'s latest revision.','','7.39'),(1927,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Translation set ID','','7.39'),(1928,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','The unique ID of the original-language version of this node, if one exists.','','7.39'),(1929,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Content type name','','7.39'),(1930,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','The human-readable name of the node type.','','7.39'),(1931,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','The main body text of the node.','','7.39'),(1932,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','The summary of the node\'s main body text.','','7.39'),(1933,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Tokens for site-wide settings and other global information.','','7.39'),(1934,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Dates','','7.39'),(1935,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Tokens related to times and dates.','','7.39'),(1936,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Tokens related to uploaded files.','','7.39'),(1937,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','URL (brief)','','7.39'),(1938,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','The URL of the site\'s front page without the protocol.','','7.39'),(1939,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Short format','','7.39'),(1940,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','A date in \'short\' format. (%date)','','7.39'),(1941,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Medium format','','7.39'),(1942,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','A date in \'medium\' format. (%date)','','7.39'),(1943,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Long format','','7.39'),(1944,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','August','Long month name','7.28'),(1945,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','A date in \'long\' format. (%date)','','7.39'),(1946,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Custom format','','7.39'),(1947,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','the PHP documentation','','7.39'),(1948,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','A date in a custom format. See !php-date for details.','','7.39'),(1949,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Time-since','','7.39'),(1950,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','@count years','','7.39'),(1951,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','@count months','','7.39'),(1952,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','A date in \'time-since\' format. (%date)','','7.39'),(1953,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Raw timestamp','','7.39'),(1954,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','A date in UNIX timestamp format (%date)','','7.39'),(1955,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','The location of the file relative to Drupal root.','','7.39'),(1956,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Tokens related to taxonomy terms.','','7.39'),(1957,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Vocabularies','','7.39'),(1958,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Tokens related to taxonomy vocabularies.','','7.39'),(1959,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','The number of nodes tagged with terms belonging to the taxonomy vocabulary.','','7.39'),(1960,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','The parent term of the taxonomy term, if one exists.','','7.39'),(1961,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Tokens related to individual user accounts.','','7.39'),(1962,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Tokens related to the currently logged in user.','','7.39'),(1963,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','The URL of the account edit page.','','7.39'),(1964,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Variables','','7.39'),(1965,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Tokens for variable values.','','7.39'),(1966,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','FAQ page title','','7.39'),(1967,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','FAQ page description','','7.39'),(1968,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','FAQ question label','','7.39'),(1969,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','FAQ answer label','','7.39'),(1970,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','FAQ \"back to top\" link','','7.39'),(1971,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Multilingual support','','7.39'),(1972,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Enable multilingual support for this content type. If enabled, a language selection field will be added to the editing form, allowing you to select from one of the <a href=\"!languages\">enabled languages</a>. If disabled, new posts are saved with the default language. Existing content will not be affected by changing this option.','','7.39'),(1973,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Site default language','','7.39'),(1974,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Source for the Main links','','7.39'),(1975,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','No Main links','','7.39'),(1976,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Select what should be displayed as the Main links (typically at the top of the page).','','7.39'),(1977,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Source for the Secondary links','','7.39'),(1978,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','No Secondary links','','7.39'),(1979,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Select the source for the Secondary links.','','7.39'),(1980,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Menu parent','','7.39'),(1981,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Select the menu parent','','7.39'),(1982,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Menu options','','7.39'),(1983,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Select the available menus','','7.39'),(1984,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Length of trimmed posts','','7.39'),(1985,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','The maximum number of characters used in the trimmed version of a post. Drupal will use this setting to determine at which offset long posts should be trimmed. The trimmed version of a post is typically used as a teaser when displaying the post on the main page, in XML feeds, etc. To disable teasers, set to \'Unlimited\'. Note that this setting will only affect new or updated content and will not affect existing teasers.','','7.39'),(1986,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Preview before submitting','','7.39'),(1987,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Must users preview posts before submitting?','','7.39'),(1988,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Default options','','7.39'),(1989,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Users with the <em>administer nodes</em> permission will be able to override these options.','','7.39'),(1990,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Display author and date information.','','7.39'),(1991,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Author username and publish date will be displayed.','','7.39'),(1992,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Site name','','7.39'),(1993,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','The name of this website.','','7.39'),(1994,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Site email address','','7.39'),(1995,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','The <em>From</em> address in automated e-mails sent during registration and new password requests, and other notifications. (Use an address ending in your site\'s domain to help prevent this e-mail being flagged as spam.)','','7.39'),(1996,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Site slogan','','7.39'),(1997,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Your site\'s motto, tag line, or catchphrase (often displayed alongside the title of the site).','','7.39'),(1998,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Anonymous user','','7.39'),(1999,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Anonymous','','7.39'),(2000,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','The name used to indicate anonymous users.','','7.39'),(2001,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Default front page','','7.39'),(2002,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','The home page displays content from this relative URL. If unsure, specify \"node\".','','7.39'),(2003,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Number of posts on main page','','7.39'),(2004,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','The maximum number of posts displayed on overview pages such as the front page.','','7.39'),(2005,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Default 403 (access denied) page','','7.39'),(2006,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','This page is displayed when the requested document is denied to the current user. Leave blank to display a generic \"access denied\" page.','','7.39'),(2007,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Default 404 (not found) page','','7.39'),(2008,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','This page is displayed when no other content matches the requested document. Leave blank to display a generic \"page not found\" page.','','7.39'),(2009,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Feed description','','7.39'),(2010,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Description of your site, included in each feed.','','7.39'),(2011,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Number of items in each feed','','7.39'),(2012,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Default number of items to include in each feed.','','7.39'),(2013,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Feed content','','7.39'),(2014,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Titles only','','7.39'),(2015,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Titles plus teaser','','7.39'),(2016,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Full text','','7.39'),(2017,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Global setting for the default display of content items in each feed.','','7.39'),(2018,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Default country','','7.39'),(2019,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','First day of week','','7.39'),(2020,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Default time zone','','7.39'),(2021,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Users may set their own time zone.','','7.39'),(2022,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Remind users at login if their time zone is not set.','','7.39'),(2023,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Only applied if users may set their own time zone.','','7.39'),(2024,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Time zone for new users','','7.39'),(2025,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Default time zone.','','7.39'),(2026,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Empty time zone.','','7.39'),(2027,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Users may set their own time zone at registration.','','7.39'),(2028,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Date format','','7.39'),(2029,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Put site into maintenance mode','','7.39'),(2030,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','When enabled, only users with the \"Use the site in maintenance mode\" <a href=\"@permissions-url\">permission</a> are able to access your site to perform maintenance; all other visitors see the maintenance mode message configured below. Authorized users can log in directly via the <a href=\"@user-login\">user login</a> page.','','7.39'),(2031,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Maintenance mode message','','7.39'),(2032,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','@site is currently under maintenance. We should be back shortly. Thank you for your patience.','','7.39'),(2033,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Message to show visitors when the site is in maintenance mode.','','7.39'),(2034,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Global theme settings.','','7.39'),(2035,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Theme settings','','7.39'),(2036,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Logo, icons and other specific theme settings.','','7.39'),(2037,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Cache pages for anonymous users','','7.39'),(2038,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Cache blocks','','7.39'),(2039,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Block caching is inactive if you have enabled modules defining content access restrictions.','','7.39'),(2040,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Minimum cache lifetime','','7.39'),(2041,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Cached pages will not be re-created until at least this much time has elapsed.','','7.39'),(2042,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Expiration of cached pages','','7.39'),(2043,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','The maximum time an external cache can use an old version of a page.','','7.39'),(2044,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','External resources can be optimized automatically, which can reduce both the size and number of requests made to your website.','','7.39'),(2045,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Compress cached pages.','','7.39'),(2046,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Aggregate and compress CSS files.','','7.39'),(2047,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Aggregate JavaScript files.','','7.39'),(2048,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Public registrations','','7.39'),(2049,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Require e-mail verification when a visitor creates an account','','7.39'),(2050,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','If this box is checked, new users will be required to validate their e-mail address prior to logging into the site, and will be assigned a system-generated password. With it unchecked, users will be logged in immediately upon registering, and may select their own passwords during registration.','','7.39'),(2051,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','User registration guidelines','','7.39'),(2052,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','This text is displayed at the top of the user registration form and is useful for helping or instructing your users.','','7.39'),(2053,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Available variables are: [site:name], [site:url], [user:name], [user:mail], [site:login-url], [site:url-brief], [user:edit-url], [user:one-time-login-url], [user:cancel-url].','','7.39'),(2054,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Welcome, new user created by administrator','','7.39'),(2055,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Customize welcome e-mail messages sent to new member accounts created by an administrator.','','7.39'),(2056,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Welcome, no approval required','','7.39'),(2057,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Customize welcome e-mail messages sent to new members upon registering, when no administrator approval is required.','','7.39'),(2058,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Welcome, awaiting administrator approval','','7.39'),(2059,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Customize welcome e-mail messages sent to new members upon registering, when administrative approval is required.','','7.39'),(2060,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Password recovery email','','7.39'),(2061,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Customize e-mail messages sent to users who request a new password.','','7.39'),(2062,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Account activation email','','7.39'),(2063,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Enable and customize e-mail messages sent to users upon account activation (when an administrator activates an account of a user who has already registered, on a site where administrative approval is required).','','7.39'),(2064,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Notify user when account is activated.','','7.39'),(2065,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Account blocked email','','7.39'),(2066,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Enable and customize e-mail messages sent to users when their accounts are blocked.','','7.39'),(2067,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Notify user when account is blocked.','','7.39'),(2068,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Account cancellation confirmation','','7.39'),(2069,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Edit the e-mail messages sent to users when they attempt to cancel their accounts.','','7.39'),(2070,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Account deleted email','','7.39'),(2071,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Enable and customize e-mail messages sent to users when their accounts are deleted.','','7.39'),(2072,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Notify user when account is deleted.','','7.39'),(2073,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Signature support','','7.39'),(2074,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Picture support','','7.39'),(2075,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Picture directory','','7.39'),(2076,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Subdirectory in the file upload directory where pictures will be stored.','','7.39'),(2077,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Default picture','','7.39'),(2078,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','URL of picture to display for users with no custom picture selected. Leave blank for none.','','7.39'),(2079,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Picture maximum dimensions','','7.39'),(2080,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Maximum dimensions for pictures, in pixels.','','7.39'),(2081,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Picture maximum file size','','7.39'),(2082,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Maximum file size for pictures, in kB.','','7.39'),(2083,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Picture guidelines','','7.39'),(2084,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','This text is displayed at the picture upload form in addition to the default guidelines. It\'s useful for helping or instructing your users.','','7.39'),(2085,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Hot topic threshold','','7.39'),(2086,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','The number of replies a topic must have to be considered \"hot\".','','7.39'),(2087,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Topics per page','','7.39'),(2088,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Default number of forum topics displayed per page.','','7.39'),(2089,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Date - newest first','','7.39'),(2090,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Date - oldest first','','7.39'),(2091,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Posts - most active first','','7.39'),(2092,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Posts - least active first','','7.39'),(2093,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Default order','','7.39'),(2094,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Default display order for topics.','','7.39'),(2095,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Forum navigation vocabulary','','7.39'),(2096,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Forum containers','','7.39'),(2097,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Languages for content','','7.39'),(2098,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Determines which languages will be allowed for content creation.','','7.39'),(2099,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Enable translation for language','','7.39'),(2100,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Translatable text formats','','7.39'),(2101,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','The translation system only translates strings with the selected text formats. All other strings will be ignored and removed from the list of translatable strings.','','7.39'),(2102,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Source language','','7.39'),(2103,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Language that will be used as the source language for string translations. The default is the site default language.','','7.39'),(2104,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Debug string translation','','7.39'),(2105,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Joined path','','7.39'),(2106,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','The array values each cleaned by Pathauto and then joined with the slash into a string that resembles an URL.','','7.39'),(2107,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Name (localized)','','7.39'),(2108,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Description (localized)','','7.39'),(2109,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Vocabulary (localized)','','7.39'),(2110,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Parent term (localized)','','7.39'),(2111,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Tokens related to views.','','7.39'),(2112,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','The human-readable name of the view.','','7.39'),(2113,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','The description of the view.','','7.39'),(2114,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','The machine-readable name of the view.','','7.39'),(2115,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','The title of current display of the view.','','7.39'),(2116,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','The URL of the view.','','7.39'),(2117,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Tokens related to the current date and time.','','7.39'),(2118,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Original @entity','','7.39'),(2119,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','The original @entity data if the @entity is being updated or saved.','','7.39'),(2120,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','The following properties may be appended to the token: @keys','','7.39'),(2121,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','List of @entities','','7.39'),(2122,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Tokens related to the \"@name\" entities.','','7.39'),(2123,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','@type with delta @delta','','7.39'),(2124,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','The list item with delta @delta. Delta values start from 0 and are incremented by one per list item.','','7.39'),(2125,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','List of @type values','','7.39'),(2126,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Tokens for lists of @type values.','','7.39'),(2127,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','The following tokens or token types are not defined as arrays:','','7.32'),(2128,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','The following tokens or token types are missing required name and/or description information:','','7.32'),(2129,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','The following token types do not have any tokens defined:','','7.32'),(2130,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','The following token types are not defined but have tokens:','','7.32'),(2131,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','The following token or token types are defined by multiple modules:','','7.32'),(2132,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Installed','','7.32'),(2133,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','jQuery Cycle Library','','7.32'),(2134,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','One or more problems were detected with your Drupal installation. Check the <a href=\"@status\">status report</a> for more information.','','7.32'),(2135,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Hide descriptions','','7.32'),(2136,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Compress layout by hiding descriptions.','','7.32'),(2137,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','First sidebar','','7.32'),(2138,'/weebpal/forum-plus/fr/admin/config?render=overlay','default','Close overlay','','7.32'),(2139,'/weebpal/forum-plus/fr/admin/config/search/clean-urls?render=overlay','default','Enable clean URLs','','7.28'),(2140,'/weebpal/forum-plus/fr/admin/config/search/clean-urls?render=overlay','default','Use URLs like <code>example.com/user</code> instead of <code>example.com/?q=user</code>.','','7.28'),(2141,'/weebpal/forum-plus/fr/admin/config/search/clean-urls?render=overlay','default','Save configuration','','7.32'),(2142,'/weebpal/forum-plus/fr/admin/config/search/path?render=overlay','default','Filter aliases','','7.28'),(2143,'/weebpal/forum-plus/fr/admin/config/search/path?render=overlay','default','Filter','','7.28'),(2144,'/weebpal/forum-plus/fr/admin/config/search/path?render=overlay','default','Alias','','7.28'),(2145,'/weebpal/forum-plus/fr/admin/config/search/path?render=overlay','default','Operations','','7.32'),(2146,'/weebpal/forum-plus/fr/admin/config/search/path?render=overlay','default','English','','7.28'),(2147,'/weebpal/forum-plus/fr/admin/config/search/path?render=overlay','default','French','','7.28'),(2148,'/weebpal/forum-plus/fr/admin/config/search/path?render=overlay','default','No URL aliases available. <a href=\"@link\">Add URL alias</a>.','','7.28'),(2149,'/weebpal/forum-plus/fr/admin/config/search/path?render=overlay','default','An alias defines a different name for an existing URL path - for example, the alias \'about\' for the URL path \'node/1\'. A URL path can have multiple aliases.','','7.28'),(2150,'/weebpal/forum-plus/fr/admin/config/search/path?render=overlay','default','sort by @s','','7.32'),(2151,'/weebpal/forum-plus/fr/admin/config/search/path?render=overlay','default','sort descending','','7.28'),(2152,'/weebpal/forum-plus/fr/admin/config/search/path/settings?render=overlay','default','Verbose','','7.28'),(2153,'/weebpal/forum-plus/fr/admin/config/search/path/settings?render=overlay','default','Display alias changes (except during bulk updates).','','7.28'),(2154,'/weebpal/forum-plus/fr/admin/config/search/path/settings?render=overlay','default','Separator','','7.28'),(2155,'/weebpal/forum-plus/fr/admin/config/search/path/settings?render=overlay','default','Character used to separate words in titles. This will replace any spaces and punctuation characters. Using a space or + character can cause unexpected results.','','7.28'),(2156,'/weebpal/forum-plus/fr/admin/config/search/path/settings?render=overlay','default','Character case','','7.28'),(2157,'/weebpal/forum-plus/fr/admin/config/search/path/settings?render=overlay','default','Leave case the same as source token values.','','7.28'),(2158,'/weebpal/forum-plus/fr/admin/config/search/path/settings?render=overlay','default','Change to lower case','','7.28'),(2159,'/weebpal/forum-plus/fr/admin/config/search/path/settings?render=overlay','default','Maximum alias length','','7.28'),(2160,'/weebpal/forum-plus/fr/admin/config/search/path/settings?render=overlay','default','Maximum length of aliases to generate. 100 is the recommended length. @max is the maximum possible length. See <a href=\"@pathauto-help\">Pathauto help</a> for details.','','7.28'),(2161,'/weebpal/forum-plus/fr/admin/config/search/path/settings?render=overlay','default','Maximum component length','','7.28'),(2162,'/weebpal/forum-plus/fr/admin/config/search/path/settings?render=overlay','default','Maximum text length of any component in the alias (e.g., [title]). 100 is the recommended length. @max is the maximum possible length. See <a href=\"@pathauto-help\">Pathauto help</a> for details.','','7.28'),(2163,'/weebpal/forum-plus/fr/admin/config/search/path/settings?render=overlay','default','What should Pathauto do when updating an existing content item which already has an alias?','','7.28'),(2164,'/weebpal/forum-plus/fr/admin/config/search/path/settings?render=overlay','default','Considering installing the <a href=\"!url\">Redirect module</a> to get redirects when your aliases change.','','7.28'),(2165,'/weebpal/forum-plus/fr/admin/config/search/path/settings?render=overlay','default','Update action','','7.28'),(2166,'/weebpal/forum-plus/fr/admin/config/search/path/settings?render=overlay','default','Do nothing. Leave the old alias intact.','','7.28'),(2167,'/weebpal/forum-plus/fr/admin/config/search/path/settings?render=overlay','default','Create a new alias. Leave the existing alias functioning.','','7.28'),(2168,'/weebpal/forum-plus/fr/admin/config/search/path/settings?render=overlay','default','Create a new alias. Delete the old alias.','','7.28'),(2169,'/weebpal/forum-plus/fr/admin/config/search/path/settings?render=overlay','default','Transliterate prior to creating alias','','7.28'),(2170,'/weebpal/forum-plus/fr/admin/config/search/path/settings?render=overlay','default','When a pattern includes certain characters (such as those with accents) should Pathauto attempt to transliterate them into the ASCII-96 alphabet? Transliteration is handled by the Transliteration module.','','7.28'),(2171,'/weebpal/forum-plus/fr/admin/config/search/path/settings?render=overlay','default','Reduce strings to letters and numbers','','7.28'),(2172,'/weebpal/forum-plus/fr/admin/config/search/path/settings?render=overlay','default','Filters the new alias to only letters and numbers found in the ASCII-96 set.','','7.28'),(2173,'/weebpal/forum-plus/fr/admin/config/search/path/settings?render=overlay','default','Strings to Remove','','7.28'),(2174,'/weebpal/forum-plus/fr/admin/config/search/path/settings?render=overlay','default','Words to strip out of the URL alias, separated by commas. Do not use this to remove punctuation.','','7.28'),(2175,'/weebpal/forum-plus/fr/admin/config/search/path/settings?render=overlay','default','Punctuation','','7.28'),(2176,'/weebpal/forum-plus/fr/admin/config/search/path/settings?render=overlay','default','Double quotation marks','','7.34'),(2177,'/weebpal/forum-plus/fr/admin/config/search/path/settings?render=overlay','default','Single quotation marks (apostrophe)','','7.34'),(2178,'/weebpal/forum-plus/fr/admin/config/search/path/settings?render=overlay','default','Back tick','','7.34'),(2179,'/weebpal/forum-plus/fr/admin/config/search/path/settings?render=overlay','default','Comma','','7.34'),(2180,'/weebpal/forum-plus/fr/admin/config/search/path/settings?render=overlay','default','Period','','7.34'),(2181,'/weebpal/forum-plus/fr/admin/config/search/path/settings?render=overlay','default','Hyphen','','7.34'),(2182,'/weebpal/forum-plus/fr/admin/config/search/path/settings?render=overlay','default','Underscore','','7.34'),(2183,'/weebpal/forum-plus/fr/admin/config/search/path/settings?render=overlay','default','Colon','','7.34'),(2184,'/weebpal/forum-plus/fr/admin/config/search/path/settings?render=overlay','default','Semicolon','','7.34'),(2185,'/weebpal/forum-plus/fr/admin/config/search/path/settings?render=overlay','default','Vertical bar (pipe)','','7.34'),(2186,'/weebpal/forum-plus/fr/admin/config/search/path/settings?render=overlay','default','Left curly bracket','','7.34'),(2187,'/weebpal/forum-plus/fr/admin/config/search/path/settings?render=overlay','default','Left square bracket','','7.34'),(2188,'/weebpal/forum-plus/fr/admin/config/search/path/settings?render=overlay','default','Right curly bracket','','7.34'),(2189,'/weebpal/forum-plus/fr/admin/config/search/path/settings?render=overlay','default','Right square bracket','','7.34'),(2190,'/weebpal/forum-plus/fr/admin/config/search/path/settings?render=overlay','default','Plus sign','','7.34'),(2191,'/weebpal/forum-plus/fr/admin/config/search/path/settings?render=overlay','default','Equal sign','','7.34'),(2192,'/weebpal/forum-plus/fr/admin/config/search/path/settings?render=overlay','default','Asterisk','','7.34'),(2193,'/weebpal/forum-plus/fr/admin/config/search/path/settings?render=overlay','default','Ampersand','','7.34'),(2194,'/weebpal/forum-plus/fr/admin/config/search/path/settings?render=overlay','default','Percent sign','','7.34'),(2195,'/weebpal/forum-plus/fr/admin/config/search/path/settings?render=overlay','default','Caret','','7.34'),(2196,'/weebpal/forum-plus/fr/admin/config/search/path/settings?render=overlay','default','Dollar sign','','7.34'),(2197,'/weebpal/forum-plus/fr/admin/config/search/path/settings?render=overlay','default','Number sign (pound sign, hash)','','7.34'),(2198,'/weebpal/forum-plus/fr/admin/config/search/path/settings?render=overlay','default','At sign','','7.34'),(2199,'/weebpal/forum-plus/fr/admin/config/search/path/settings?render=overlay','default','Exclamation mark','','7.34'),(2200,'/weebpal/forum-plus/fr/admin/config/search/path/settings?render=overlay','default','Tilde','','7.34'),(2201,'/weebpal/forum-plus/fr/admin/config/search/path/settings?render=overlay','default','Left parenthesis','','7.34'),(2202,'/weebpal/forum-plus/fr/admin/config/search/path/settings?render=overlay','default','Right parenthesis','','7.34'),(2203,'/weebpal/forum-plus/fr/admin/config/search/path/settings?render=overlay','default','Question mark','','7.34'),(2204,'/weebpal/forum-plus/fr/admin/config/search/path/settings?render=overlay','default','Less-than sign','','7.34'),(2205,'/weebpal/forum-plus/fr/admin/config/search/path/settings?render=overlay','default','Greater-than sign','','7.34'),(2206,'/weebpal/forum-plus/fr/admin/config/search/path/settings?render=overlay','default','Slash','','7.34'),(2207,'/weebpal/forum-plus/fr/admin/config/search/path/settings?render=overlay','default','Backslash','','7.34'),(2208,'/weebpal/forum-plus/fr/admin/config/search/path/settings?render=overlay','default','Remove','','7.34'),(2209,'/weebpal/forum-plus/fr/admin/config/search/path/settings?render=overlay','default','Replace by separator','','7.28'),(2210,'/weebpal/forum-plus/fr/admin/config/search/path/settings?render=overlay','default','No action (do not replace)','','7.28'),(2211,'/weebpal/forum-plus/fr/admin/config/search/path/patterns?render=overlay','default','FAQ category page settings','','7.28'),(2212,'/weebpal/forum-plus/fr/admin/config/search/path/patterns?render=overlay','default','Default path pattern (applies to all FAQ categories with blank patterns below)','','7.28'),(2213,'/weebpal/forum-plus/fr/admin/config/search/path/patterns?render=overlay','default','faq-page/[term:tid]','','7.28'),(2214,'/weebpal/forum-plus/fr/admin/config/search/path/patterns?render=overlay','default','Content paths','','7.28'),(2215,'/weebpal/forum-plus/fr/admin/config/search/path/patterns?render=overlay','default','Default path pattern (applies to all content types with blank patterns below)','','7.28'),(2216,'/weebpal/forum-plus/fr/admin/config/search/path/patterns?render=overlay','default','language neutral','','7.28'),(2217,'/weebpal/forum-plus/fr/admin/config/search/path/patterns?render=overlay','default','Pattern for all @node_type paths','','7.28'),(2218,'/weebpal/forum-plus/fr/admin/config/search/path/patterns?render=overlay','default','Taxonomy term paths','','7.28'),(2219,'/weebpal/forum-plus/fr/admin/config/search/path/patterns?render=overlay','default','Default path pattern (applies to all vocabularies with blank patterns below)','','7.28'),(2220,'/weebpal/forum-plus/fr/admin/config/search/path/patterns?render=overlay','default','Pattern for all %vocab-name paths','','7.28'),(2221,'/weebpal/forum-plus/fr/admin/config/search/path/patterns?render=overlay','default','User paths','','7.28'),(2222,'/weebpal/forum-plus/fr/admin/config/search/path/patterns?render=overlay','default','Pattern for user account page paths','','7.28'),(2223,'/weebpal/forum-plus/fr/admin/config/search/path/patterns?render=overlay','default','Forum paths','','7.28'),(2224,'/weebpal/forum-plus/fr/admin/config/search/path/patterns?render=overlay','default','Pattern for forums and forum containers','','7.28'),(2225,'/weebpal/forum-plus/fr/admin/config/search/path/patterns?render=overlay','default','Blog paths','','7.28'),(2226,'/weebpal/forum-plus/fr/admin/config/search/path/patterns?render=overlay','default','Pattern for blog page paths','','7.28'),(2227,'/weebpal/forum-plus/fr/admin/config/search/path/patterns?render=overlay','default','Replacement patterns','','7.28'),(2228,'/weebpal/forum-plus/fr/admin/config/search/path/patterns?render=overlay','default','Token','','7.28'),(2229,'/weebpal/forum-plus/fr/admin/config/search/path/patterns?render=overlay','default','No tokens available','','7.28'),(2230,'/weebpal/forum-plus/fr/admin/config/search/path/patterns?render=overlay','default','Click a token to insert it into the field you\'ve last clicked.','','7.28'),(2231,'/weebpal/forum-plus/fr/admin/config/regional/language?render=overlay','default','Weight for @title','','7.32'),(2232,'/weebpal/forum-plus/fr/admin/config/regional/language?render=overlay','default','Left to right','','7.32'),(2233,'/weebpal/forum-plus/fr/admin/config/regional/language?render=overlay','default','Enabled languages','','7.32'),(2234,'/weebpal/forum-plus/fr/admin/config/regional/language?render=overlay','default','Default language','','7.32'),(2235,'/weebpal/forum-plus/fr/admin/config/regional/language?render=overlay','default','With multiple languages enabled, interface text can be translated, registered users may select their preferred language, and authors can assign a specific language to content. <a href=\"@translations\">Download contributed translations</a> from Drupal.org.','','7.32'),(2236,'/weebpal/forum-plus/fr/admin/config/regional/language?render=overlay','default','<strong>Warning</strong>: Changing the default language may have unwanted effects on string translations. Check also the <a href=\"@configure-strings\">source language</a> for translations and read more about <a href=\"@i18n_string-help\">String translation</a>','','7.32'),(2237,'/weebpal/forum-plus/fr/admin/config/regional/language?render=overlay','default','Enable !title','','7.32'),(2238,'/weebpal/forum-plus/fr/admin/config/regional/language?render=overlay','default','Set !title as default','','7.32'),(2239,'/weebpal/forum-plus/fr/admin/config/regional/language?render=overlay','default','English name','','7.32'),(2240,'/weebpal/forum-plus/fr/admin/config/regional/language?render=overlay','default','Native name','','7.32'),(2241,'/weebpal/forum-plus/fr/admin/config/regional/language?render=overlay','default','Code','','7.32'),(2242,'/weebpal/forum-plus/fr/admin/config/regional/language?render=overlay','default','Direction','','7.32'),(2243,'/weebpal/forum-plus/fr/admin/config/regional/language/edit/fr?render=overlay','default','Edit language','','7.28'),(2244,'/weebpal/forum-plus/fr/admin/config/regional/language/edit/fr?render=overlay','default','Language code','','7.28'),(2245,'/weebpal/forum-plus/fr/admin/config/regional/language/edit/fr?render=overlay','default','Language name in English','','7.28'),(2246,'/weebpal/forum-plus/fr/admin/config/regional/language/edit/fr?render=overlay','default','Name of the language in English. Will be available for translation in all languages.','','7.28'),(2247,'/weebpal/forum-plus/fr/admin/config/regional/language/edit/fr?render=overlay','default','Native language name','','7.28'),(2248,'/weebpal/forum-plus/fr/admin/config/regional/language/edit/fr?render=overlay','default','Name of the language in the language being added.','','7.28'),(2249,'/weebpal/forum-plus/fr/admin/config/regional/language/edit/fr?render=overlay','default','Path prefix language code','','7.28'),(2250,'/weebpal/forum-plus/fr/admin/config/regional/language/edit/fr?render=overlay','default','Language code or other custom text to use as a path prefix for URL language detection, if your <em>Detection and selection</em> settings use URL path prefixes. For the default language, this value may be left blank. <strong>Modifying this value may break existing URLs. Use with caution in a production environment.</strong> Example: Specifying \"deutsch\" as the path prefix code for German results in URLs like \"example.com/deutsch/contact\".','','7.28'),(2251,'/weebpal/forum-plus/fr/admin/config/regional/language/edit/fr?render=overlay','default','Language domain','','7.28'),(2252,'/weebpal/forum-plus/fr/admin/config/regional/language/edit/fr?render=overlay','default','The domain name to use for this language if URL domains are used for <em>Detection and selection</em>. Leave blank for the default language. <strong>Changing this value may break existing URLs.</strong> Example: Specifying \"de.example.com\" as language domain for German will result in an URL like \"http://de.example.com/contact\".','','7.28'),(2253,'/weebpal/forum-plus/fr/admin/config/regional/language/edit/fr?render=overlay','default','Direction that text in this language is presented.','','7.28'),(2254,'/weebpal/forum-plus/fr/admin/config/regional/language/edit/fr?render=overlay','default','Right to left','','7.32'),(2255,'/weebpal/forum-plus/fr/admin/config/regional/language/edit/fr?render=overlay','default','Save language','','7.28'),(2256,'/weebpal/forum-plus/fr/admin/config/regional/language/configure?render=overlay','default','User interface text','','7.34'),(2257,'/weebpal/forum-plus/fr/admin/config/regional/language/configure?render=overlay','default','Order of language detection methods for user interface text. If a translation of user interface text is available in the detected language, it will be displayed.','','7.34'),(2258,'/weebpal/forum-plus/fr/admin/config/regional/language/configure?render=overlay','default','Order of language detection methods for content. If a version of content is available in the detected language, it will be displayed.','','7.34'),(2259,'/weebpal/forum-plus/fr/admin/config/regional/language/configure?render=overlay','default','Determine the language from the URL (Path prefix or domain).','','7.32'),(2260,'/weebpal/forum-plus/fr/admin/config/regional/language/configure?render=overlay','default','Session','','7.32'),(2261,'/weebpal/forum-plus/fr/admin/config/regional/language/configure?render=overlay','default','Determine the language from a request/session parameter.','','7.32'),(2262,'/weebpal/forum-plus/fr/admin/config/regional/language/configure?render=overlay','default','Follow the user\'s language preference.','','7.32'),(2263,'/weebpal/forum-plus/fr/admin/config/regional/language/configure?render=overlay','default','Browser','','7.32'),(2264,'/weebpal/forum-plus/fr/admin/config/regional/language/configure?render=overlay','default','Determine the language from the browser\'s language settings.','','7.32'),(2265,'/weebpal/forum-plus/fr/admin/config/regional/language/configure?render=overlay','default','Interface','','7.32'),(2266,'/weebpal/forum-plus/fr/admin/config/regional/language/configure?render=overlay','default','Use the detected interface language.','','7.32'),(2267,'/weebpal/forum-plus/fr/admin/config/regional/language/configure?render=overlay','default','URL fallback','','7.32'),(2268,'/weebpal/forum-plus/fr/admin/config/regional/language/configure?render=overlay','default','Use an already detected language for URLs if none is found.','','7.32'),(2269,'/weebpal/forum-plus/fr/admin/config/regional/language/configure?render=overlay','default','Use the default site language (@language_name).','','7.32'),(2270,'/weebpal/forum-plus/fr/admin/config/regional/language/configure?render=overlay','default','@type language detection','','7.32'),(2271,'/weebpal/forum-plus/fr/admin/config/regional/language/configure?render=overlay','default','@title language provider','','7.32'),(2272,'/weebpal/forum-plus/fr/admin/config/regional/language/configure?render=overlay','default','Save settings','','7.32'),(2273,'/weebpal/forum-plus/fr/admin/config/regional/language/configure?render=overlay','default','Define how to decide which language is used to display page elements (primarily text provided by Drupal and modules, such as field labels and help text). This decision is made by evaluating a series of detection methods for languages; the first detection method that gets a result will determine which language is used for that type of text. Define the order of evaluation of language detection methods on this page.','','7.32'),(2274,'/weebpal/forum-plus/fr/admin/config/regional/language/configure?render=overlay','default','Detection method','','7.32'),(2275,'/weebpal/forum-plus/fr/admin/config/regional/language/configure/url?render=overlay','default','Part of the URL that determines language','','7.28'),(2276,'/weebpal/forum-plus/fr/admin/config/regional/language/configure/url?render=overlay','default','Path prefix','','7.28'),(2277,'/weebpal/forum-plus/fr/admin/config/regional/language/configure/url?render=overlay','default','Domain','','7.28'),(2278,'/weebpal/forum-plus/fr/admin/config/regional/language/configure/url?render=overlay','default','<em>Path prefix</em>: URLs like http://example.com/de/contact set language to German (de). <em>Domain</em>: URLs like http://de.example.com/contact set the language to German. <strong>Warning: Changing this setting may break incoming URLs. Use with caution on a production site.</strong>','','7.28'),(2279,'/weebpal/forum-plus/fr/admin/config/regional/language/icons?render=overlay','default','Add language icons','','7.28'),(2280,'/weebpal/forum-plus/fr/admin/config/regional/language/icons?render=overlay','default','Link types to add language icons.','','7.28'),(2281,'/weebpal/forum-plus/fr/admin/config/regional/language/icons?render=overlay','default','Node links','','7.32'),(2282,'/weebpal/forum-plus/fr/admin/config/regional/language/icons?render=overlay','default','Language switcher block','','7.28'),(2283,'/weebpal/forum-plus/fr/admin/config/regional/language/icons?render=overlay','default','These options are currently disabled due to <a href=\"!issue_url\">a bug</a> that cannot currently be resolved. They may be reintroduced at a later stage.','','7.28'),(2284,'/weebpal/forum-plus/fr/admin/config/regional/language/icons?render=overlay','default','Icon placement','','7.28'),(2285,'/weebpal/forum-plus/fr/admin/config/regional/language/icons?render=overlay','default','Before link','','7.28'),(2286,'/weebpal/forum-plus/fr/admin/config/regional/language/icons?render=overlay','default','After link','','7.28'),(2287,'/weebpal/forum-plus/fr/admin/config/regional/language/icons?render=overlay','default','Replace link','','7.28'),(2288,'/weebpal/forum-plus/fr/admin/config/regional/language/icons?render=overlay','default','Where to display the icon, relative to the link title.','','7.28'),(2289,'/weebpal/forum-plus/fr/admin/config/regional/language/icons?render=overlay','default','Icons file path','','7.28'),(2290,'/weebpal/forum-plus/fr/admin/config/regional/language/icons?render=overlay','default','Path for language icons, relative to Drupal installation. \"*\" is a placeholder for language code.','','7.28'),(2291,'/weebpal/forum-plus/fr/admin/config/regional/language/icons?render=overlay','default','Image size','','7.28'),(2292,'/weebpal/forum-plus/fr/admin/config/regional/language/icons?render=overlay','default','Image size for language icons, in the form \"width x height\".','','7.28'),(2293,'/weebpal/forum-plus/fr/admin/config/regional/language/icons?render=overlay','default','To enable multilingual support for specific content types go to <a href=\"@configure_content_types\">configure content types</a>.','','7.28'),(2294,'/weebpal/forum-plus/fr/admin/config/regional/translate?render=overlay','default','Built-in interface','','7.28'),(2295,'/weebpal/forum-plus/fr/admin/config/regional/translate?render=overlay','default','English (built-in)','','7.28'),(2296,'/weebpal/forum-plus/fr/admin/config/regional/translate?render=overlay','default','This page provides an overview of available translatable strings. Drupal displays translatable strings in text groups; modules may define additional text groups containing other translatable strings. Because text groups provide a method of grouping related strings, they are often used to focus translation efforts on specific areas of the Drupal interface.','','7.28'),(2297,'/weebpal/forum-plus/fr/admin/config/regional/translate?render=overlay','default','See the <a href=\"@languages\">Languages page</a> for more information on adding support for additional languages.','','7.28'),(2298,'/weebpal/forum-plus/fr/admin/config/regional/translate/translate?render=overlay','default','String contains','','7.28'),(2299,'/weebpal/forum-plus/fr/admin/config/regional/translate/translate?render=overlay','default','Leave blank to show all strings. The search is case sensitive.','','7.28'),(2300,'/weebpal/forum-plus/fr/admin/config/regional/translate/translate?render=overlay','default','All languages','','7.28'),(2301,'/weebpal/forum-plus/fr/admin/config/regional/translate/translate?render=overlay','default','English (provided by Drupal)','','7.28'),(2302,'/weebpal/forum-plus/fr/admin/config/regional/translate/translate?render=overlay','default','Search in','','7.28'),(2303,'/weebpal/forum-plus/fr/admin/config/regional/translate/translate?render=overlay','default','Both translated and untranslated strings','','7.28'),(2304,'/weebpal/forum-plus/fr/admin/config/regional/translate/translate?render=overlay','default','Only translated strings','','7.28'),(2305,'/weebpal/forum-plus/fr/admin/config/regional/translate/translate?render=overlay','default','Only untranslated strings','','7.28'),(2306,'/weebpal/forum-plus/fr/admin/config/regional/translate/translate?render=overlay','default','Limit search to','','7.28'),(2307,'/weebpal/forum-plus/fr/admin/config/regional/translate/translate?render=overlay','default','All text groups','','7.28'),(2308,'/weebpal/forum-plus/fr/admin/config/regional/translate/translate?render=overlay','default','Filter translatable strings','','7.28'),(2309,'/weebpal/forum-plus/fr/admin/config/regional/translate/translate?render=overlay','default','- None -','','7.28'),(2310,'/weebpal/forum-plus/fr/admin/config/regional/translate/translate?render=overlay','default','Text group','','7.28'),(2311,'/weebpal/forum-plus/fr/admin/config/regional/translate/translate?render=overlay','default','String','','7.32'),(2312,'/weebpal/forum-plus/fr/admin/config/regional/translate/translate?render=overlay','default','Context','','7.34'),(2313,'/weebpal/forum-plus/fr/admin/config/regional/translate/translate?render=overlay','default','No strings available.','','7.28'),(2314,'/weebpal/forum-plus/fr/admin/config/regional/translate/translate?render=overlay','default','This page allows a translator to search for specific translated and untranslated strings, and is used when creating or editing translations. (Note: For translation tasks involving many strings, it may be more convenient to <a href=\"@export\">export</a> strings for offline editing in a desktop Gettext translation editor.) Searches may be limited to strings found within a specific text group or in a specific language.','','7.28'),(2315,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Already added languages','','7.28'),(2316,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Languages not yet added','','7.28'),(2317,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Afar','','7.28'),(2318,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Abkhazian','','7.28'),(2319,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Avestan','','7.28'),(2320,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Afrikaans','','7.28'),(2321,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Akan','','7.28'),(2322,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Amharic','','7.28'),(2323,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Arabic','','7.28'),(2324,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Assamese','','7.28'),(2325,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Asturian','','7.28'),(2326,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Avar','','7.28'),(2327,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Aymara','','7.28'),(2328,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Azerbaijani','','7.28'),(2329,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Bashkir','','7.28'),(2330,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Belarusian','','7.28'),(2331,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Bulgarian','','7.28'),(2332,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Bihari','','7.28'),(2333,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Bislama','','7.28'),(2334,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Bambara','','7.28'),(2335,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Bengali','','7.28'),(2336,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Tibetan','','7.28'),(2337,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Breton','','7.28'),(2338,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Bosnian','','7.28'),(2339,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Catalan','','7.28'),(2340,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Chechen','','7.28'),(2341,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Chamorro','','7.28'),(2342,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Corsican','','7.28'),(2343,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Cree','','7.28'),(2344,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Czech','','7.28'),(2345,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Old Slavonic','','7.28'),(2346,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Chuvash','','7.28'),(2347,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Welsh','','7.28'),(2348,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Danish','','7.28'),(2349,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','German','','7.28'),(2350,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Maldivian','','7.28'),(2351,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Bhutani','','7.28'),(2352,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Ewe','','7.28'),(2353,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Greek','','7.28'),(2354,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','English, British','','7.28'),(2355,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Esperanto','','7.28'),(2356,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Spanish','','7.28'),(2357,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Estonian','','7.28'),(2358,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Basque','','7.28'),(2359,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Persian','','7.28'),(2360,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Fulah','','7.28'),(2361,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Finnish','','7.28'),(2362,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Filipino','','7.28'),(2363,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Fiji','','7.28'),(2364,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Faeroese','','7.28'),(2365,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Frisian','','7.28'),(2366,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Irish','','7.28'),(2367,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Scots Gaelic','','7.28'),(2368,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Galician','','7.28'),(2369,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Guarani','','7.28'),(2370,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Swiss German','','7.28'),(2371,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Gujarati','','7.28'),(2372,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Manx','','7.28'),(2373,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Hausa','','7.28'),(2374,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Hebrew','','7.28'),(2375,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Hindi','','7.28'),(2376,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Hiri Motu','','7.28'),(2377,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Croatian','','7.28'),(2378,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Haitian Creole','','7.28'),(2379,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Hungarian','','7.28'),(2380,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Armenian','','7.28'),(2381,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Herero','','7.28'),(2382,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Interlingua','','7.28'),(2383,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Indonesian','','7.28'),(2384,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Interlingue','','7.28'),(2385,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Igbo','','7.28'),(2386,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Inupiak','','7.28'),(2387,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Icelandic','','7.28'),(2388,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Italian','','7.28'),(2389,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Inuktitut','','7.28'),(2390,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Japanese','','7.28'),(2391,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Javanese','','7.28'),(2392,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Georgian','','7.28'),(2393,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Kongo','','7.28'),(2394,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Kikuyu','','7.28'),(2395,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Kwanyama','','7.28'),(2396,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Kazakh','','7.28'),(2397,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Greenlandic','','7.28'),(2398,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Cambodian','','7.28'),(2399,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Kannada','','7.28'),(2400,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Korean','','7.28'),(2401,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Kanuri','','7.28'),(2402,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Kashmiri','','7.28'),(2403,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Kurdish','','7.28'),(2404,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Komi','','7.28'),(2405,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Cornish','','7.28'),(2406,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Kyrgyz','','7.28'),(2407,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Latin','','7.28'),(2408,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Luxembourgish','','7.28'),(2409,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Luganda','','7.28'),(2410,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Lingala','','7.28'),(2411,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Laothian','','7.28'),(2412,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Lithuanian','','7.28'),(2413,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Latvian','','7.28'),(2414,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Malagasy','','7.28'),(2415,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Marshallese','','7.28'),(2416,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Māori','','7.28'),(2417,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Macedonian','','7.28'),(2418,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Malayalam','','7.28'),(2419,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Mongolian','','7.28'),(2420,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Moldavian','','7.28'),(2421,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Marathi','','7.28'),(2422,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Malay','','7.28'),(2423,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Maltese','','7.28'),(2424,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Burmese','','7.28'),(2425,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Nauru','','7.28'),(2426,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','North Ndebele','','7.28'),(2427,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Nepali','','7.28'),(2428,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Ndonga','','7.28'),(2429,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Dutch','','7.28'),(2430,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Norwegian Bokmål','','7.28'),(2431,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Norwegian Nynorsk','','7.28'),(2432,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','South Ndebele','','7.28'),(2433,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Navajo','','7.28'),(2434,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Chichewa','','7.28'),(2435,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Occitan','','7.28'),(2436,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Oromo','','7.28'),(2437,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Oriya','','7.28'),(2438,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Ossetian','','7.28'),(2439,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Punjabi','','7.28'),(2440,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Pali','','7.28'),(2441,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Polish','','7.28'),(2442,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Pashto','','7.28'),(2443,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Portuguese, International','','7.28'),(2444,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Portuguese, Portugal','','7.28'),(2445,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Portuguese, Brazil','','7.28'),(2446,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Quechua','','7.28'),(2447,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Rhaeto-Romance','','7.28'),(2448,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Kirundi','','7.28'),(2449,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Romanian','','7.28'),(2450,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Russian','','7.28'),(2451,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Kinyarwanda','','7.28'),(2452,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Sanskrit','','7.28'),(2453,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Sardinian','','7.28'),(2454,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Scots','','7.28'),(2455,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Sindhi','','7.28'),(2456,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Northern Sami','','7.28'),(2457,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Sango','','7.28'),(2458,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Serbo-Croatian','','7.28'),(2459,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Sinhala','','7.28'),(2460,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Slovak','','7.28'),(2461,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Slovenian','','7.28'),(2462,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Samoan','','7.28'),(2463,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Shona','','7.28'),(2464,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Somali','','7.28'),(2465,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Albanian','','7.28'),(2466,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Serbian','','7.28'),(2467,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Siswati','','7.28'),(2468,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Sesotho','','7.28'),(2469,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Sudanese','','7.28'),(2470,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Swedish','','7.28'),(2471,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Swahili','','7.28'),(2472,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Tamil','','7.28'),(2473,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Telugu','','7.28'),(2474,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Tajik','','7.28'),(2475,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Thai','','7.28'),(2476,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Tigrinya','','7.28'),(2477,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Turkmen','','7.28'),(2478,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Tagalog','','7.28'),(2479,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Setswana','','7.28'),(2480,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Tonga','','7.28'),(2481,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Turkish','','7.28'),(2482,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Tsonga','','7.28'),(2483,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Tatar','','7.28'),(2484,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Twi','','7.28'),(2485,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Tahitian','','7.28'),(2486,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Uyghur','','7.28'),(2487,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Ukrainian','','7.28'),(2488,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Urdu','','7.28'),(2489,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Uzbek','','7.28'),(2490,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Venda','','7.28'),(2491,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Vietnamese','','7.28'),(2492,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Wolof','','7.28'),(2493,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Xhosa','','7.28'),(2494,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Lolspeak','','7.28'),(2495,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Yiddish','','7.28'),(2496,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Yoruba','','7.28'),(2497,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Zhuang','','7.28'),(2498,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Chinese, Simplified','','7.28'),(2499,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Chinese, Traditional','','7.28'),(2500,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Zulu','','7.28'),(2501,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Import translation','','7.28'),(2502,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Language file','','7.28'),(2503,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','A Gettext Portable Object (<em>.po</em>) file.','','7.28'),(2504,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Import into','','7.28'),(2505,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Choose the language you want to add strings into. If you choose a language which is not yet set up, it will be added.','','7.28'),(2506,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Imported translations will be added to this text group.','','7.28'),(2507,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Mode','','7.28'),(2508,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Strings in the uploaded file replace existing ones, new ones are added. The plural format is updated.','','7.28'),(2509,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Existing strings and the plural format are kept, only new strings are added.','','7.28'),(2510,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','This page imports the translated strings contained in an individual Gettext Portable Object (<em>.po</em>) file. Normally distributed as part of a translation package (each translation package may contain several <em>.po</em> files), a <em>.po</em> file may need to be imported after offline editing in a Gettext translation editor. Importing an individual <em>.po</em> file may be a lengthy process.','','7.28'),(2511,'/weebpal/forum-plus/fr/admin/config/regional/translate/import?render=overlay','default','Note that the <em>.po</em> files within a translation package are imported automatically (if available) when new modules or themes are enabled, or as new languages are added. Since this page only allows the import of one <em>.po</em> file at a time, it may be simpler to download and extract a translation package into your Drupal installation directory and <a href=\"@language-add\">add the language</a> (which automatically imports all <em>.po</em> files within the package). Translation packages are available for download on the <a href=\"@translations\">Drupal translation page</a>.','','7.28'),(2512,'/weebpal/forum-plus/fr/admin/config/regional/translate/i18n_string?render=overlay','default','Select text groups','','7.28'),(2513,'/weebpal/forum-plus/fr/admin/config/regional/translate/i18n_string?render=overlay','default','If a text group is no showing up here it means this feature is not implemented for it.','','7.28'),(2514,'/weebpal/forum-plus/fr/admin/config/regional/translate/i18n_string?render=overlay','default','Clean up left over strings.','','7.28'),(2515,'/weebpal/forum-plus/fr/admin/config/regional/translate/i18n_string?render=overlay','default','Refresh strings','','7.28'),(2516,'/weebpal/forum-plus/fr/admin/config/regional/translate/i18n_string?render=overlay','default','This will create all the missing strings for the selected text groups.','','7.28'),(2517,'/weebpal/forum-plus/fr/admin/config/regional/translate/i18n_string?render=overlay','default','On this page you can refresh and update values for user defined strings.','','7.28'),(2518,'/weebpal/forum-plus/fr/admin/config/regional/translate/i18n_string?render=overlay','default','Use the refresh option when you are missing strings to translate for a given text group. All the strings will be re-created keeping existing translations.','','7.28'),(2519,'/weebpal/forum-plus/fr/admin/config/regional/translate/i18n_string?render=overlay','default','Use the update option when some of the strings had been previously translated with the localization system, but the translations are not showing up for the configurable strings.','','7.28'),(2520,'/weebpal/forum-plus/fr/admin/config/regional/translate/i18n_string?render=overlay','default','To search and translate strings, use the <a href=\"@translate-interface\">translation interface</a> pages.','','7.28'),(2521,'/weebpal/forum-plus/fr/admin/config/regional/translate/i18n_string?render=overlay','default','<strong>Important:</strong> To configure which text formats are safe for translation, visit the <a href=\"@configure-strings\">configure strings</a> page before refreshing your strings.','','7.28'),(2522,'/weebpal/forum-plus/fr/admin/config/regional/translate/export?render=overlay','default','Export translation','','7.28'),(2523,'/weebpal/forum-plus/fr/admin/config/regional/translate/export?render=overlay','default','Language name','','7.28'),(2524,'/weebpal/forum-plus/fr/admin/config/regional/translate/export?render=overlay','default','Select the language to export in Gettext Portable Object (<em>.po</em>) format.','','7.28'),(2525,'/weebpal/forum-plus/fr/admin/config/regional/translate/export?render=overlay','default','Export template','','7.28'),(2526,'/weebpal/forum-plus/fr/admin/config/regional/translate/export?render=overlay','default','Generate a Gettext Portable Object Template (<em>.pot</em>) file with all strings from the Drupal locale database.','','7.28'),(2527,'/weebpal/forum-plus/fr/admin/config/regional/translate/export?render=overlay','default','This page exports the translated strings used by your site. An export file may be in Gettext Portable Object (<em>.po</em>) form, which includes both the original string and the translation (used to share translations with others), or in Gettext Portable Object Template (<em>.pot</em>) form, which includes the original strings only (used to create new translations with a Gettext translation editor).','','7.28'),(2528,'/weebpal/forum-plus/fr/admin/config/regional/i18n?render=overlay','default','Enabled languages only.','','7.28'),(2529,'/weebpal/forum-plus/fr/admin/config/regional/i18n?render=overlay','default','All defined languages will be allowed.','','7.28'),(2530,'/weebpal/forum-plus/fr/admin/config/regional/i18n?render=overlay','default','To set up multilingual options for vocabularies go to <a href=\"@configure_taxonomy\">Taxonomy configuration page</a>.','','7.28'),(2531,'/weebpal/forum-plus/fr/admin/config/regional/i18n?render=overlay','default','To set up multilingual options for blocks go to the <a href=\"@configure_blocks\">Blocks administration page</a>.','','7.28'),(2532,'/weebpal/forum-plus/fr/admin/config/regional/i18n/strings?render=overlay','default','When translating user defined strings that have a text format associated, translators will be able to edit the text before it is filtered which may be a security risk for some filters. An obvious example is when using the PHP filter but other filters may also be dangerous.','','7.28'),(2533,'/weebpal/forum-plus/fr/admin/config/regional/i18n/strings?render=overlay','default','As a general rule <strong>do not allow any filtered text to be translated unless the translators already have access to that text format</strong>. However if you are doing all your translations through this site\'s translation UI or the Localization client, and never importing translations for other textgroups than <i>default</i>, filter access will be checked for translators on every translation page.','','7.28'),(2534,'/weebpal/forum-plus/fr/admin/config/regional/i18n/strings?render=overlay','default','<strong>Important:</strong> After disallowing some text format, use the <a href=\"@refresh-strings\">refresh strings</a> page so forbidden strings are deleted and not allowed anymore for translators.','','7.28'),(2535,'/weebpal/forum-plus/fr/admin/config/regional/i18n_translation?render=overlay','default','Items','','7.28'),(2536,'/weebpal/forum-plus/fr/admin/config/regional/i18n_translation?render=overlay','default','Updated','','7.28'),(2537,'/weebpal/forum-plus/fr/admin/config/regional/i18n_translation?render=overlay','default','No translation sets available.','','7.28'),(2538,'/weebpal/forum-plus/fr/admin/config/regional/i18n_translation?render=overlay','default','sort ascending','','7.32'),(2539,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Andorra','','7.28'),(2540,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','United Arab Emirates','','7.28'),(2541,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Afghanistan','','7.28'),(2542,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Antigua and Barbuda','','7.28'),(2543,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Anguilla','','7.28'),(2544,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Albania','','7.28'),(2545,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Armenia','','7.28'),(2546,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Netherlands Antilles','','7.28'),(2547,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Angola','','7.28'),(2548,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Antarctica','','7.28'),(2549,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Argentina','','7.28'),(2550,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','American Samoa','','7.28'),(2551,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Austria','','7.28'),(2552,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Australia','','7.28'),(2553,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Aruba','','7.28'),(2554,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Aland Islands','','7.28'),(2555,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Azerbaijan','','7.28'),(2556,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Bosnia and Herzegovina','','7.28'),(2557,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Barbados','','7.28'),(2558,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Bangladesh','','7.28'),(2559,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Belgium','','7.28'),(2560,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Burkina Faso','','7.28'),(2561,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Bulgaria','','7.28'),(2562,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Bahrain','','7.28'),(2563,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Burundi','','7.28'),(2564,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Benin','','7.28'),(2565,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Saint Barthélemy','','7.28'),(2566,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Bermuda','','7.28'),(2567,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Brunei','','7.28'),(2568,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Bolivia','','7.28'),(2569,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Caribbean Netherlands','','7.28'),(2570,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Brazil','','7.28'),(2571,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Bahamas','','7.28'),(2572,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Bhutan','','7.28'),(2573,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Bouvet Island','','7.28'),(2574,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Botswana','','7.28'),(2575,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Belarus','','7.28'),(2576,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Belize','','7.28'),(2577,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Canada','','7.28'),(2578,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Cocos (Keeling) Islands','','7.28'),(2579,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Congo (Kinshasa)','','7.28'),(2580,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Central African Republic','','7.28'),(2581,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Congo (Brazzaville)','','7.28'),(2582,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Switzerland','','7.28'),(2583,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Ivory Coast','','7.28'),(2584,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Cook Islands','','7.28'),(2585,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Chile','','7.28'),(2586,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Cameroon','','7.28'),(2587,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','China','','7.28'),(2588,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Colombia','','7.28'),(2589,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Costa Rica','','7.28'),(2590,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Cuba','','7.28'),(2591,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Cape Verde','','7.28'),(2592,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Curaçao','','7.28'),(2593,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Christmas Island','','7.28'),(2594,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Cyprus','','7.28'),(2595,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Czech Republic','','7.28'),(2596,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Germany','','7.28'),(2597,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Djibouti','','7.28'),(2598,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Denmark','','7.28'),(2599,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Dominica','','7.28'),(2600,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Dominican Republic','','7.28'),(2601,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Algeria','','7.28'),(2602,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Ecuador','','7.28'),(2603,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Estonia','','7.28'),(2604,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Egypt','','7.28'),(2605,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Western Sahara','','7.28'),(2606,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Eritrea','','7.28'),(2607,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Spain','','7.28'),(2608,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Ethiopia','','7.28'),(2609,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Finland','','7.28'),(2610,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Falkland Islands','','7.28'),(2611,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Micronesia','','7.28'),(2612,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Faroe Islands','','7.28'),(2613,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','France','','7.28'),(2614,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Gabon','','7.28'),(2615,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','United Kingdom','','7.28'),(2616,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Grenada','','7.28'),(2617,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Georgia','','7.28'),(2618,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','French Guiana','','7.28'),(2619,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Guernsey','','7.28'),(2620,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Ghana','','7.28'),(2621,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Gibraltar','','7.28'),(2622,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Greenland','','7.28'),(2623,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Gambia','','7.28'),(2624,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Guinea','','7.28'),(2625,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Guadeloupe','','7.28'),(2626,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Equatorial Guinea','','7.28'),(2627,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Greece','','7.28'),(2628,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','South Georgia and the South Sandwich Islands','','7.28'),(2629,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Guatemala','','7.28'),(2630,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Guam','','7.28'),(2631,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Guinea-Bissau','','7.28'),(2632,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Guyana','','7.28'),(2633,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Hong Kong S.A.R., China','','7.28'),(2634,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Heard Island and McDonald Islands','','7.28'),(2635,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Honduras','','7.28'),(2636,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Croatia','','7.28'),(2637,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Haiti','','7.28'),(2638,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Hungary','','7.28'),(2639,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Indonesia','','7.28'),(2640,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Ireland','','7.28'),(2641,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Israel','','7.28'),(2642,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Isle of Man','','7.28'),(2643,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','India','','7.28'),(2644,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','British Indian Ocean Territory','','7.28'),(2645,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Iraq','','7.28'),(2646,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Iran','','7.28'),(2647,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Iceland','','7.28'),(2648,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Italy','','7.28'),(2649,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Jersey','','7.28'),(2650,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Jamaica','','7.28'),(2651,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Jordan','','7.28'),(2652,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Japan','','7.28'),(2653,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Kenya','','7.28'),(2654,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Kyrgyzstan','','7.28'),(2655,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Cambodia','','7.28'),(2656,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Kiribati','','7.28'),(2657,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Comoros','','7.28'),(2658,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Saint Kitts and Nevis','','7.28'),(2659,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','North Korea','','7.28'),(2660,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','South Korea','','7.28'),(2661,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Kuwait','','7.28'),(2662,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Cayman Islands','','7.28'),(2663,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Kazakhstan','','7.28'),(2664,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Laos','','7.28'),(2665,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Lebanon','','7.28'),(2666,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Saint Lucia','','7.28'),(2667,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Liechtenstein','','7.28'),(2668,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Sri Lanka','','7.28'),(2669,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Liberia','','7.28'),(2670,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Lesotho','','7.28'),(2671,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Lithuania','','7.28'),(2672,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Luxembourg','','7.28'),(2673,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Latvia','','7.28'),(2674,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Libya','','7.28'),(2675,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Morocco','','7.28'),(2676,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Monaco','','7.28'),(2677,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Moldova','','7.28'),(2678,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Montenegro','','7.28'),(2679,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Saint Martin (French part)','','7.28'),(2680,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Madagascar','','7.28'),(2681,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Marshall Islands','','7.28'),(2682,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Macedonia','','7.28'),(2683,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Mali','','7.28'),(2684,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Myanmar','','7.28'),(2685,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Mongolia','','7.28'),(2686,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Macao S.A.R., China','','7.28'),(2687,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Northern Mariana Islands','','7.28'),(2688,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Martinique','','7.28'),(2689,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Mauritania','','7.28'),(2690,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Montserrat','','7.28'),(2691,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Malta','','7.28'),(2692,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Mauritius','','7.28'),(2693,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Maldives','','7.28'),(2694,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Malawi','','7.28'),(2695,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Mexico','','7.28'),(2696,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Malaysia','','7.28'),(2697,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Mozambique','','7.28'),(2698,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Namibia','','7.28'),(2699,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','New Caledonia','','7.28'),(2700,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Niger','','7.28'),(2701,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Norfolk Island','','7.28'),(2702,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Nigeria','','7.28'),(2703,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Nicaragua','','7.28'),(2704,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Netherlands','','7.28'),(2705,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Norway','','7.28'),(2706,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Nepal','','7.28'),(2707,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Niue','','7.28'),(2708,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','New Zealand','','7.28'),(2709,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Oman','','7.28'),(2710,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Panama','','7.28'),(2711,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Peru','','7.28'),(2712,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','French Polynesia','','7.28'),(2713,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Papua New Guinea','','7.28'),(2714,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Philippines','','7.28'),(2715,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Pakistan','','7.28'),(2716,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Poland','','7.28'),(2717,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Saint Pierre and Miquelon','','7.28'),(2718,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Pitcairn','','7.28'),(2719,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Puerto Rico','','7.28'),(2720,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Palestinian Territory','','7.28'),(2721,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Portugal','','7.28'),(2722,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Palau','','7.28'),(2723,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Paraguay','','7.28'),(2724,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Qatar','','7.28'),(2725,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Reunion','','7.28'),(2726,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Romania','','7.28'),(2727,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Serbia','','7.28'),(2728,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Russia','','7.28'),(2729,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Rwanda','','7.28'),(2730,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Saudi Arabia','','7.28'),(2731,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Solomon Islands','','7.28'),(2732,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Seychelles','','7.28'),(2733,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Sudan','','7.28'),(2734,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Sweden','','7.28'),(2735,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Singapore','','7.28'),(2736,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Saint Helena','','7.28'),(2737,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Slovenia','','7.28'),(2738,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Svalbard and Jan Mayen','','7.28'),(2739,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Slovakia','','7.28'),(2740,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Sierra Leone','','7.28'),(2741,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','San Marino','','7.28'),(2742,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Senegal','','7.28'),(2743,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Somalia','','7.28'),(2744,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Suriname','','7.28'),(2745,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','South Sudan','','7.28'),(2746,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Sao Tome and Principe','','7.28'),(2747,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','El Salvador','','7.28'),(2748,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Sint Maarten','','7.28'),(2749,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Syria','','7.28'),(2750,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Swaziland','','7.28'),(2751,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Turks and Caicos Islands','','7.28'),(2752,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Chad','','7.28'),(2753,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','French Southern Territories','','7.28'),(2754,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Togo','','7.28'),(2755,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Thailand','','7.28'),(2756,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Tajikistan','','7.28'),(2757,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Tokelau','','7.28'),(2758,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Timor-Leste','','7.28'),(2759,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Turkmenistan','','7.28'),(2760,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Tunisia','','7.28'),(2761,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Turkey','','7.28'),(2762,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Trinidad and Tobago','','7.28'),(2763,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Tuvalu','','7.28'),(2764,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Taiwan','','7.28'),(2765,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Tanzania','','7.28'),(2766,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Ukraine','','7.28'),(2767,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Uganda','','7.28'),(2768,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','United States Minor Outlying Islands','','7.28'),(2769,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','United States','','7.28'),(2770,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Uruguay','','7.28'),(2771,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Uzbekistan','','7.28'),(2772,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Vatican','','7.28'),(2773,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Saint Vincent and the Grenadines','','7.28'),(2774,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Venezuela','','7.28'),(2775,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','British Virgin Islands','','7.28'),(2776,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','U.S. Virgin Islands','','7.28'),(2777,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Vietnam','','7.28'),(2778,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Vanuatu','','7.28'),(2779,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Wallis and Futuna','','7.28'),(2780,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Samoa','','7.28'),(2781,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Yemen','','7.28'),(2782,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Mayotte','','7.28'),(2783,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','South Africa','','7.28'),(2784,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Zambia','','7.28'),(2785,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Zimbabwe','','7.28'),(2786,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Africa/Abidjan','','7.28'),(2787,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','@zone: @date','','7.28'),(2788,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Africa/Accra','','7.28'),(2789,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Africa/Addis Ababa','','7.28'),(2790,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Africa/Algiers','','7.28'),(2791,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Africa/Asmara','','7.28'),(2792,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Africa/Bamako','','7.28'),(2793,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Africa/Bangui','','7.28'),(2794,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Africa/Banjul','','7.28'),(2795,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Africa/Bissau','','7.28'),(2796,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Africa/Blantyre','','7.28'),(2797,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Africa/Brazzaville','','7.28'),(2798,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Africa/Bujumbura','','7.28'),(2799,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Africa/Cairo','','7.28'),(2800,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Africa/Casablanca','','7.28'),(2801,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Africa/Ceuta','','7.28'),(2802,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Africa/Conakry','','7.28'),(2803,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Africa/Dakar','','7.28'),(2804,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Africa/Dar es Salaam','','7.28'),(2805,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Africa/Djibouti','','7.28'),(2806,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Africa/Douala','','7.28'),(2807,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Africa/El Aaiun','','7.28'),(2808,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Africa/Freetown','','7.28'),(2809,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Africa/Gaborone','','7.28'),(2810,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Africa/Harare','','7.28'),(2811,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Africa/Johannesburg','','7.28'),(2812,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Africa/Juba','','7.28'),(2813,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Africa/Kampala','','7.28'),(2814,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Africa/Khartoum','','7.28'),(2815,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Africa/Kigali','','7.28'),(2816,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Africa/Kinshasa','','7.28'),(2817,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Africa/Lagos','','7.28'),(2818,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Africa/Libreville','','7.28'),(2819,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Africa/Lome','','7.28'),(2820,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Africa/Luanda','','7.28'),(2821,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Africa/Lubumbashi','','7.28'),(2822,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Africa/Lusaka','','7.28'),(2823,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Africa/Malabo','','7.28'),(2824,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Africa/Maputo','','7.28'),(2825,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Africa/Maseru','','7.28'),(2826,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Africa/Mbabane','','7.28'),(2827,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Africa/Mogadishu','','7.28'),(2828,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Africa/Monrovia','','7.28'),(2829,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Africa/Nairobi','','7.28'),(2830,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Africa/Ndjamena','','7.28'),(2831,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Africa/Niamey','','7.28'),(2832,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Africa/Nouakchott','','7.28'),(2833,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Africa/Ouagadougou','','7.28'),(2834,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Africa/Porto-Novo','','7.28'),(2835,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Africa/Sao Tome','','7.28'),(2836,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Africa/Tripoli','','7.28'),(2837,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Africa/Tunis','','7.28'),(2838,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Africa/Windhoek','','7.28'),(2839,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','America/Adak','','7.28'),(2840,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','America/Anchorage','','7.28'),(2841,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','America/Anguilla','','7.28'),(2842,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','America/Antigua','','7.28'),(2843,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','America/Araguaina','','7.28'),(2844,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','America/Argentina/Buenos Aires','','7.28'),(2845,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','America/Argentina/Catamarca','','7.28'),(2846,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','America/Argentina/Cordoba','','7.28'),(2847,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','America/Argentina/Jujuy','','7.28'),(2848,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','America/Argentina/La Rioja','','7.28'),(2849,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','America/Argentina/Mendoza','','7.28'),(2850,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','America/Argentina/Rio Gallegos','','7.28'),(2851,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','America/Argentina/Salta','','7.28'),(2852,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','America/Argentina/San Juan','','7.28'),(2853,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','America/Argentina/San Luis','','7.28'),(2854,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','America/Argentina/Tucuman','','7.28'),(2855,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','America/Argentina/Ushuaia','','7.28'),(2856,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','America/Aruba','','7.28'),(2857,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','America/Asuncion','','7.28'),(2858,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','America/Atikokan','','7.28'),(2859,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','America/Bahia','','7.28'),(2860,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','America/Bahia Banderas','','7.28'),(2861,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','America/Barbados','','7.28'),(2862,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','America/Belem','','7.28'),(2863,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','America/Belize','','7.28'),(2864,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','America/Blanc-Sablon','','7.28'),(2865,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','America/Boa Vista','','7.28'),(2866,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','America/Bogota','','7.28'),(2867,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','America/Boise','','7.28'),(2868,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','America/Cambridge Bay','','7.28'),(2869,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','America/Campo Grande','','7.28'),(2870,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','America/Cancun','','7.28'),(2871,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','America/Caracas','','7.28'),(2872,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','America/Cayenne','','7.28'),(2873,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','America/Cayman','','7.28'),(2874,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','America/Chicago','','7.28'),(2875,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','America/Chihuahua','','7.28'),(2876,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','America/Costa Rica','','7.28'),(2877,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','America/Creston','','7.28'),(2878,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','America/Cuiaba','','7.28'),(2879,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','America/Curacao','','7.28'),(2880,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','America/Danmarkshavn','','7.28'),(2881,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','America/Dawson','','7.28'),(2882,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','America/Dawson Creek','','7.28'),(2883,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','America/Denver','','7.28'),(2884,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','America/Detroit','','7.28'),(2885,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','America/Dominica','','7.28'),(2886,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','America/Edmonton','','7.28'),(2887,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','America/Eirunepe','','7.28'),(2888,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','America/El Salvador','','7.28'),(2889,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','America/Fortaleza','','7.28'),(2890,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','America/Glace Bay','','7.28'),(2891,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','America/Godthab','','7.28'),(2892,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','America/Goose Bay','','7.28'),(2893,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','America/Grand Turk','','7.28'),(2894,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','America/Grenada','','7.28'),(2895,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','America/Guadeloupe','','7.28'),(2896,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','America/Guatemala','','7.28'),(2897,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','America/Guayaquil','','7.28'),(2898,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','America/Guyana','','7.28'),(2899,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','America/Halifax','','7.28'),(2900,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','America/Havana','','7.28'),(2901,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','America/Hermosillo','','7.28'),(2902,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','America/Indiana/Indianapolis','','7.28'),(2903,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','America/Indiana/Knox','','7.28'),(2904,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','America/Indiana/Marengo','','7.28'),(2905,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','America/Indiana/Petersburg','','7.28'),(2906,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','America/Indiana/Tell City','','7.28'),(2907,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','America/Indiana/Vevay','','7.28'),(2908,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','America/Indiana/Vincennes','','7.28'),(2909,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','America/Indiana/Winamac','','7.28'),(2910,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','America/Inuvik','','7.28'),(2911,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','America/Iqaluit','','7.28'),(2912,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','America/Jamaica','','7.28'),(2913,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','America/Juneau','','7.28'),(2914,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','America/Kentucky/Louisville','','7.28'),(2915,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','America/Kentucky/Monticello','','7.28'),(2916,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','America/Kralendijk','','7.28'),(2917,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','America/La Paz','','7.28'),(2918,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','America/Lima','','7.28'),(2919,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','America/Los Angeles','','7.28'),(2920,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','America/Lower Princes','','7.28'),(2921,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','America/Maceio','','7.28'),(2922,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','America/Managua','','7.28'),(2923,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','America/Manaus','','7.28'),(2924,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','America/Marigot','','7.28'),(2925,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','America/Martinique','','7.28'),(2926,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','America/Matamoros','','7.28'),(2927,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','America/Mazatlan','','7.28'),(2928,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','America/Menominee','','7.28'),(2929,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','America/Merida','','7.28'),(2930,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','America/Metlakatla','','7.28'),(2931,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','America/Mexico City','','7.28'),(2932,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','America/Miquelon','','7.28'),(2933,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','America/Moncton','','7.28'),(2934,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','America/Monterrey','','7.28'),(2935,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','America/Montevideo','','7.28'),(2936,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','America/Montreal','','7.28'),(2937,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','America/Montserrat','','7.28'),(2938,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','America/Nassau','','7.28'),(2939,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','America/New York','','7.28'),(2940,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','America/Nipigon','','7.28'),(2941,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','America/Nome','','7.28'),(2942,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','America/Noronha','','7.28'),(2943,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','America/North Dakota/Beulah','','7.28'),(2944,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','America/North Dakota/Center','','7.28'),(2945,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','America/North Dakota/New Salem','','7.28'),(2946,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','America/Ojinaga','','7.28'),(2947,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','America/Panama','','7.28'),(2948,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','America/Pangnirtung','','7.28'),(2949,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','America/Paramaribo','','7.28'),(2950,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','America/Phoenix','','7.28'),(2951,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','America/Port-au-Prince','','7.28'),(2952,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','America/Port of Spain','','7.28'),(2953,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','America/Porto Velho','','7.28'),(2954,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','America/Puerto Rico','','7.28'),(2955,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','America/Rainy River','','7.28'),(2956,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','America/Rankin Inlet','','7.28'),(2957,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','America/Recife','','7.28'),(2958,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','America/Regina','','7.28'),(2959,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','America/Resolute','','7.28'),(2960,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','America/Rio Branco','','7.28'),(2961,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','America/Santa Isabel','','7.28'),(2962,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','America/Santarem','','7.28'),(2963,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','America/Santiago','','7.28'),(2964,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','America/Santo Domingo','','7.28'),(2965,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','America/Sao Paulo','','7.28'),(2966,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','America/Scoresbysund','','7.28'),(2967,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','America/Shiprock','','7.28'),(2968,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','America/Sitka','','7.28'),(2969,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','America/St Barthelemy','','7.28'),(2970,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','America/St Johns','','7.28'),(2971,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','America/St Kitts','','7.28'),(2972,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','America/St Lucia','','7.28'),(2973,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','America/St Thomas','','7.28'),(2974,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','America/St Vincent','','7.28'),(2975,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','America/Swift Current','','7.28'),(2976,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','America/Tegucigalpa','','7.28'),(2977,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','America/Thule','','7.28'),(2978,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','America/Thunder Bay','','7.28'),(2979,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','America/Tijuana','','7.28'),(2980,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','America/Toronto','','7.28'),(2981,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','America/Tortola','','7.28'),(2982,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','America/Vancouver','','7.28'),(2983,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','America/Whitehorse','','7.28'),(2984,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','America/Winnipeg','','7.28'),(2985,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','America/Yakutat','','7.28'),(2986,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','America/Yellowknife','','7.28'),(2987,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Antarctica/Casey','','7.28'),(2988,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Antarctica/Davis','','7.28'),(2989,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Antarctica/DumontDUrville','','7.28'),(2990,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Antarctica/Macquarie','','7.28'),(2991,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Antarctica/Mawson','','7.28'),(2992,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Antarctica/McMurdo','','7.28'),(2993,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Antarctica/Palmer','','7.28'),(2994,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Antarctica/Rothera','','7.28'),(2995,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Antarctica/South Pole','','7.28'),(2996,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Antarctica/Syowa','','7.28'),(2997,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Antarctica/Vostok','','7.28'),(2998,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Arctic/Longyearbyen','','7.28'),(2999,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Asia/Aden','','7.28'),(3000,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Asia/Almaty','','7.28'),(3001,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Asia/Amman','','7.28'),(3002,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Asia/Anadyr','','7.28'),(3003,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Asia/Aqtau','','7.28'),(3004,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Asia/Aqtobe','','7.28'),(3005,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Asia/Ashgabat','','7.28'),(3006,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Asia/Baghdad','','7.28'),(3007,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Asia/Bahrain','','7.28'),(3008,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Asia/Baku','','7.28'),(3009,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Asia/Bangkok','','7.28'),(3010,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Asia/Beirut','','7.28'),(3011,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Asia/Bishkek','','7.28'),(3012,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Asia/Brunei','','7.28'),(3013,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Asia/Choibalsan','','7.28'),(3014,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Asia/Chongqing','','7.28'),(3015,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Asia/Colombo','','7.28'),(3016,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Asia/Damascus','','7.28'),(3017,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Asia/Dhaka','','7.28'),(3018,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Asia/Dili','','7.28'),(3019,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Asia/Dubai','','7.28'),(3020,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Asia/Dushanbe','','7.28'),(3021,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Asia/Gaza','','7.28'),(3022,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Asia/Harbin','','7.28'),(3023,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Asia/Hebron','','7.28'),(3024,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Asia/Ho Chi Minh','','7.28'),(3025,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Asia/Hong Kong','','7.28'),(3026,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Asia/Hovd','','7.28'),(3027,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Asia/Irkutsk','','7.28'),(3028,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Asia/Jakarta','','7.28'),(3029,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Asia/Jayapura','','7.28'),(3030,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Asia/Jerusalem','','7.28'),(3031,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Asia/Kabul','','7.28'),(3032,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Asia/Kamchatka','','7.28'),(3033,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Asia/Karachi','','7.28'),(3034,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Asia/Kashgar','','7.28'),(3035,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Asia/Kathmandu','','7.28'),(3036,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Asia/Khandyga','','7.28'),(3037,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Asia/Kolkata','','7.28'),(3038,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Asia/Krasnoyarsk','','7.28'),(3039,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Asia/Kuala Lumpur','','7.28'),(3040,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Asia/Kuching','','7.28'),(3041,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Asia/Kuwait','','7.28'),(3042,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Asia/Macau','','7.28'),(3043,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Asia/Magadan','','7.28'),(3044,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Asia/Makassar','','7.28'),(3045,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Asia/Manila','','7.28'),(3046,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Asia/Muscat','','7.28'),(3047,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Asia/Nicosia','','7.28'),(3048,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Asia/Novokuznetsk','','7.28'),(3049,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Asia/Novosibirsk','','7.28'),(3050,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Asia/Omsk','','7.28'),(3051,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Asia/Oral','','7.28'),(3052,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Asia/Phnom Penh','','7.28'),(3053,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Asia/Pontianak','','7.28'),(3054,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Asia/Pyongyang','','7.28'),(3055,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Asia/Qatar','','7.28'),(3056,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Asia/Qyzylorda','','7.28'),(3057,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Asia/Rangoon','','7.28'),(3058,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Asia/Riyadh','','7.28'),(3059,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Asia/Sakhalin','','7.28'),(3060,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Asia/Samarkand','','7.28'),(3061,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Asia/Seoul','','7.28'),(3062,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Asia/Shanghai','','7.28'),(3063,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Asia/Singapore','','7.28'),(3064,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Asia/Taipei','','7.28'),(3065,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Asia/Tashkent','','7.28'),(3066,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Asia/Tbilisi','','7.28'),(3067,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Asia/Tehran','','7.28'),(3068,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Asia/Thimphu','','7.28'),(3069,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Asia/Tokyo','','7.28'),(3070,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Asia/Ulaanbaatar','','7.28'),(3071,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Asia/Urumqi','','7.28'),(3072,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Asia/Ust-Nera','','7.28'),(3073,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Asia/Vientiane','','7.28'),(3074,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Asia/Vladivostok','','7.28'),(3075,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Asia/Yakutsk','','7.28'),(3076,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Asia/Yekaterinburg','','7.28'),(3077,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Asia/Yerevan','','7.28'),(3078,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Atlantic/Azores','','7.28'),(3079,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Atlantic/Bermuda','','7.28'),(3080,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Atlantic/Canary','','7.28'),(3081,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Atlantic/Cape Verde','','7.28'),(3082,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Atlantic/Faroe','','7.28'),(3083,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Atlantic/Madeira','','7.28'),(3084,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Atlantic/Reykjavik','','7.28'),(3085,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Atlantic/South Georgia','','7.28'),(3086,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Atlantic/St Helena','','7.28'),(3087,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Atlantic/Stanley','','7.28'),(3088,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Australia/Adelaide','','7.28'),(3089,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Australia/Brisbane','','7.28'),(3090,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Australia/Broken Hill','','7.28'),(3091,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Australia/Currie','','7.28'),(3092,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Australia/Darwin','','7.28'),(3093,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Australia/Eucla','','7.28'),(3094,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Australia/Hobart','','7.28'),(3095,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Australia/Lindeman','','7.28'),(3096,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Australia/Lord Howe','','7.28'),(3097,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Australia/Melbourne','','7.28'),(3098,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Australia/Perth','','7.28'),(3099,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Australia/Sydney','','7.28'),(3100,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Europe/Amsterdam','','7.28'),(3101,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Europe/Andorra','','7.28'),(3102,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Europe/Athens','','7.28'),(3103,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Europe/Belgrade','','7.28'),(3104,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Europe/Berlin','','7.28'),(3105,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Europe/Bratislava','','7.28'),(3106,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Europe/Brussels','','7.28'),(3107,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Europe/Bucharest','','7.28'),(3108,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Europe/Budapest','','7.28'),(3109,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Europe/Busingen','','7.28'),(3110,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Europe/Chisinau','','7.28'),(3111,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Europe/Copenhagen','','7.28'),(3112,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Europe/Dublin','','7.28'),(3113,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Europe/Gibraltar','','7.28'),(3114,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Europe/Guernsey','','7.28'),(3115,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Europe/Helsinki','','7.28'),(3116,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Europe/Isle of Man','','7.28'),(3117,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Europe/Istanbul','','7.28'),(3118,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Europe/Jersey','','7.28'),(3119,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Europe/Kaliningrad','','7.28'),(3120,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Europe/Kiev','','7.28'),(3121,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Europe/Lisbon','','7.28'),(3122,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Europe/Ljubljana','','7.28'),(3123,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Europe/London','','7.28'),(3124,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Europe/Luxembourg','','7.28'),(3125,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Europe/Madrid','','7.28'),(3126,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Europe/Malta','','7.28'),(3127,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Europe/Mariehamn','','7.28'),(3128,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Europe/Minsk','','7.28'),(3129,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Europe/Monaco','','7.28'),(3130,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Europe/Moscow','','7.28'),(3131,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Europe/Oslo','','7.28'),(3132,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Europe/Paris','','7.28'),(3133,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Europe/Podgorica','','7.28'),(3134,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Europe/Prague','','7.28'),(3135,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Europe/Riga','','7.28'),(3136,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Europe/Rome','','7.28'),(3137,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Europe/Samara','','7.28'),(3138,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Europe/San Marino','','7.28'),(3139,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Europe/Sarajevo','','7.28'),(3140,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Europe/Simferopol','','7.28'),(3141,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Europe/Skopje','','7.28'),(3142,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Europe/Sofia','','7.28'),(3143,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Europe/Stockholm','','7.28'),(3144,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Europe/Tallinn','','7.28'),(3145,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Europe/Tirane','','7.28'),(3146,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Europe/Uzhgorod','','7.28'),(3147,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Europe/Vaduz','','7.28'),(3148,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Europe/Vatican','','7.28'),(3149,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Europe/Vienna','','7.28'),(3150,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Europe/Vilnius','','7.28'),(3151,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Europe/Volgograd','','7.28'),(3152,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Europe/Warsaw','','7.28'),(3153,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Europe/Zagreb','','7.28'),(3154,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Europe/Zaporozhye','','7.28'),(3155,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Europe/Zurich','','7.28'),(3156,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Indian/Antananarivo','','7.28'),(3157,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Indian/Chagos','','7.28'),(3158,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Indian/Christmas','','7.28'),(3159,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Indian/Cocos','','7.28'),(3160,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Indian/Comoro','','7.28'),(3161,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Indian/Kerguelen','','7.28'),(3162,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Indian/Mahe','','7.28'),(3163,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Indian/Maldives','','7.28'),(3164,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Indian/Mauritius','','7.28'),(3165,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Indian/Mayotte','','7.28'),(3166,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Indian/Reunion','','7.28'),(3167,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Pacific/Apia','','7.28'),(3168,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Pacific/Auckland','','7.28'),(3169,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Pacific/Chatham','','7.28'),(3170,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Pacific/Chuuk','','7.28'),(3171,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Pacific/Easter','','7.28'),(3172,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Pacific/Efate','','7.28'),(3173,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Pacific/Enderbury','','7.28'),(3174,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Pacific/Fakaofo','','7.28'),(3175,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Pacific/Fiji','','7.28'),(3176,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Pacific/Funafuti','','7.28'),(3177,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Pacific/Galapagos','','7.28'),(3178,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Pacific/Gambier','','7.28'),(3179,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Pacific/Guadalcanal','','7.28'),(3180,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Pacific/Guam','','7.28'),(3181,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Pacific/Honolulu','','7.28'),(3182,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Pacific/Johnston','','7.28'),(3183,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Pacific/Kiritimati','','7.28'),(3184,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Pacific/Kosrae','','7.28'),(3185,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Pacific/Kwajalein','','7.28'),(3186,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Pacific/Majuro','','7.28'),(3187,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Pacific/Marquesas','','7.28'),(3188,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Pacific/Midway','','7.28'),(3189,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Pacific/Nauru','','7.28'),(3190,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Pacific/Niue','','7.28'),(3191,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Pacific/Norfolk','','7.28'),(3192,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Pacific/Noumea','','7.28'),(3193,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Pacific/Pago Pago','','7.28'),(3194,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Pacific/Palau','','7.28'),(3195,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Pacific/Pitcairn','','7.28'),(3196,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Pacific/Pohnpei','','7.28'),(3197,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Pacific/Port Moresby','','7.28'),(3198,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Pacific/Rarotonga','','7.28'),(3199,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Pacific/Saipan','','7.28'),(3200,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Pacific/Tahiti','','7.28'),(3201,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Pacific/Tarawa','','7.28'),(3202,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Pacific/Tongatapu','','7.28'),(3203,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Pacific/Wake','','7.28'),(3204,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Pacific/Wallis','','7.28'),(3205,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','UTC','','7.28'),(3206,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Locale','','7.28'),(3207,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Time zones','','7.28'),(3208,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','Use ISO-8601 week numbers','','7.28'),(3209,'/weebpal/forum-plus/fr/admin/config/regional/settings?render=overlay','default','IMPORTANT! If checked, First day of week MUST be set to Monday','','7.28'),(3210,'/weebpal/forum-plus/fr/admin/content?render=overlay','default','status','','7.28'),(3211,'/weebpal/forum-plus/fr/admin/content?render=overlay','default','any','','7.28'),(3212,'/weebpal/forum-plus/fr/admin/content?render=overlay','default','published','','7.28'),(3213,'/weebpal/forum-plus/fr/admin/content?render=overlay','default','not published','','7.28'),(3214,'/weebpal/forum-plus/fr/admin/content?render=overlay','default','promoted','','7.28'),(3215,'/weebpal/forum-plus/fr/admin/content?render=overlay','default','not promoted','','7.28'),(3216,'/weebpal/forum-plus/fr/admin/content?render=overlay','default','sticky','','7.28'),(3217,'/weebpal/forum-plus/fr/admin/content?render=overlay','default','not sticky','','7.28'),(3218,'/weebpal/forum-plus/fr/admin/content?render=overlay','default','type','','7.28'),(3219,'/weebpal/forum-plus/fr/admin/content?render=overlay','default','Language neutral','','7.28'),(3220,'/weebpal/forum-plus/fr/admin/content?render=overlay','default','language','','7.28'),(3221,'/weebpal/forum-plus/fr/admin/content?render=overlay','default','Show only items where','','7.28'),(3222,'/weebpal/forum-plus/fr/admin/content?render=overlay','default','where %property is %value','','7.28'),(3223,'/weebpal/forum-plus/fr/admin/content?render=overlay','default','and where','','7.28'),(3224,'/weebpal/forum-plus/fr/admin/content?render=overlay','default','Refine','','7.28'),(3225,'/weebpal/forum-plus/fr/admin/content?render=overlay','default','Undo','','7.28'),(3226,'/weebpal/forum-plus/fr/admin/content?render=overlay','default','Update options','','7.28'),(3227,'/weebpal/forum-plus/fr/admin/content?render=overlay','default','Publish selected content','','7.28'),(3228,'/weebpal/forum-plus/fr/admin/content?render=overlay','default','Unpublish selected content','','7.28'),(3229,'/weebpal/forum-plus/fr/admin/content?render=overlay','default','Promote selected content to front page','','7.28'),(3230,'/weebpal/forum-plus/fr/admin/content?render=overlay','default','Demote selected content from front page','','7.28'),(3231,'/weebpal/forum-plus/fr/admin/content?render=overlay','default','Make selected content sticky','','7.28'),(3232,'/weebpal/forum-plus/fr/admin/content?render=overlay','default','Make selected content not sticky','','7.28'),(3233,'/weebpal/forum-plus/fr/admin/content?render=overlay','default','Delete selected content','','7.28'),(3234,'/weebpal/forum-plus/fr/admin/content?render=overlay','default','Update URL alias','','7.28'),(3235,'/weebpal/forum-plus/fr/admin/content?render=overlay','default','Operation','','7.28'),(3236,'/weebpal/forum-plus/fr/admin/content?render=overlay','default','updated','','7.28'),(3237,'/weebpal/forum-plus/fr/admin/content?render=overlay','default','No content available.','','7.28'),(3238,'/weebpal/forum-plus/fr/admin/content?render=overlay','default','Update @title','','7.28'),(3239,'/weebpal/forum-plus/fr/admin/content?render=overlay','default','Remove from %shortcut_set shortcuts','','7.28'),(3240,'/weebpal/forum-plus/fr/admin/content/webform?render=overlay','default','Components','','7.28'),(3241,'/weebpal/forum-plus/fr/admin/content/webform?render=overlay','default','This page lists all of the content on the site that may have a webform attached to it.','','7.28'),(3242,'/weebpal/forum-plus/fr/node/40/webform?render=overlay','default','Mandatory','','7.28'),(3243,'/weebpal/forum-plus/fr/node/40/webform?render=overlay','default','Secondary tabs','','7.32'),(3244,'/weebpal/forum-plus/fr/node/40/webform?render=overlay','default','New component name','','7.28'),(3245,'/weebpal/forum-plus/fr/node/40/edit?render=overlay','default','<em>Edit @type</em> @title','','7.28'),(3246,'/weebpal/forum-plus/fr/node/40/edit?render=overlay','default','Revision information','','7.34'),(3247,'/weebpal/forum-plus/fr/node/40/edit?render=overlay','default','Create new revision','','7.34'),(3248,'/weebpal/forum-plus/fr/node/40/edit?render=overlay','default','Provide an explanation of the changes you are making. This will help other authors understand your motivations.','','7.34'),(3249,'/weebpal/forum-plus/fr/node/40/edit?render=overlay','default','Authoring information','','7.34'),(3250,'/weebpal/forum-plus/fr/node/40/edit?render=overlay','default','Authored by','','7.34'),(3251,'/weebpal/forum-plus/fr/node/40/edit?render=overlay','default','Leave blank for %anonymous.','','7.34'),(3252,'/weebpal/forum-plus/fr/node/40/edit?render=overlay','default','Format: %time. The date format is YYYY-MM-DD and %timezone is the time zone offset from UTC. Leave blank to use the time of form submission.','','7.34'),(3253,'/weebpal/forum-plus/fr/node/40/edit?render=overlay','default','Publishing options','','7.34'),(3254,'/weebpal/forum-plus/fr/node/40/edit?render=overlay','default','Sticky at top of lists','','7.34'),(3255,'/weebpal/forum-plus/fr/node/40/edit?render=overlay','default','Leave blank to use trimmed value of full text as the summary.','','7.34'),(3256,'/weebpal/forum-plus/fr/node/40/edit?render=overlay','default','Book outline','','7.32'),(3257,'/weebpal/forum-plus/fr/node/40/edit?render=overlay','default','No book selected.','','7.32'),(3258,'/weebpal/forum-plus/fr/node/40/edit?render=overlay','default','Pages at a given level are ordered first by weight and then by title.','','7.32'),(3259,'/weebpal/forum-plus/fr/node/40/edit?render=overlay','default','create a new book','','7.32'),(3260,'/weebpal/forum-plus/fr/node/40/edit?render=overlay','default','none','','7.32'),(3261,'/weebpal/forum-plus/fr/node/40/edit?render=overlay','default','Your page will be a part of the selected book.','','7.32'),(3262,'/weebpal/forum-plus/fr/node/40/edit?render=overlay','default','Change book (update list of parents)','','7.32'),(3263,'/weebpal/forum-plus/fr/node/40/edit?render=overlay','default','Comment settings','','7.34'),(3264,'/weebpal/forum-plus/fr/node/40/edit?render=overlay','default','Open','','7.34'),(3265,'/weebpal/forum-plus/fr/node/40/edit?render=overlay','default','Closed','','7.34'),(3266,'/weebpal/forum-plus/fr/node/40/edit?render=overlay','default','Users with the \"Post comments\" permission can post comments.','','7.34'),(3267,'/weebpal/forum-plus/fr/node/40/edit?render=overlay','default','Users cannot post comments, but existing comments will be displayed.','','7.34'),(3268,'/weebpal/forum-plus/fr/node/40/edit?render=overlay','default','Comments are hidden from view.','','7.34'),(3269,'/weebpal/forum-plus/fr/node/40/edit?render=overlay','default','Users cannot post comments.','','7.34'),(3270,'/weebpal/forum-plus/fr/node/40/edit?render=overlay','default','Order','','7.39'),(3271,'/weebpal/forum-plus/fr/node/40/edit?render=overlay','default','Allows the user to configure the order of questions and answers on a FAQ page.','','7.39'),(3272,'/weebpal/forum-plus/fr/node/40/edit?render=overlay','default','disabled','','7.34'),(3273,'/weebpal/forum-plus/fr/node/40/edit?render=overlay','default','Menu settings','','7.34'),(3274,'/weebpal/forum-plus/fr/node/40/edit?render=overlay','default','Provide a menu link','','7.34'),(3275,'/weebpal/forum-plus/fr/node/40/edit?render=overlay','default','Menu link title','','7.34'),(3276,'/weebpal/forum-plus/fr/node/40/edit?render=overlay','default','Shown when hovering over the menu link.','','7.34'),(3277,'/weebpal/forum-plus/fr/node/40/edit?render=overlay','default','Parent item','','7.34'),(3278,'/weebpal/forum-plus/fr/node/40/edit?render=overlay','default','Menu links with smaller weights are displayed before links with larger weights.','','7.34'),(3279,'/weebpal/forum-plus/fr/node/40/edit?render=overlay','default','Node Class settings','','7.32'),(3280,'/weebpal/forum-plus/fr/node/40/edit?render=overlay','default','Assign CSS classes to the node.','','7.32'),(3281,'/weebpal/forum-plus/fr/node/40/edit?render=overlay','default','CSS class(es)','','7.32'),(3282,'/weebpal/forum-plus/fr/node/40/edit?render=overlay','default','Separate classes with a space.','','7.32'),(3283,'/weebpal/forum-plus/fr/node/40/edit?render=overlay','default','URL alias','','7.34'),(3284,'/weebpal/forum-plus/fr/node/40/edit?render=overlay','default','Optionally specify an alternative URL by which this content can be accessed. For example, type \"about\" when writing an about page. Use a relative path and don\'t add a trailing slash or the URL alias won\'t work.','','7.34'),(3285,'/weebpal/forum-plus/fr/node/40/edit?render=overlay','default','Generate automatic URL alias','','7.34'),(3286,'/weebpal/forum-plus/fr/node/40/edit?render=overlay','default','Uncheck this to create a custom alias below.','','7.34'),(3287,'/weebpal/forum-plus/fr/node/40/edit?render=overlay','default','Configure URL alias patterns.','','7.32'),(3288,'/weebpal/forum-plus/fr/node/40/edit?render=overlay','default','User autocomplete','','7.32'),(3289,'/weebpal/forum-plus/fr/node/40/edit?render=overlay','default','Vertical Tabs','','7.34'),(3290,'/weebpal/forum-plus/fr/admin/config/search/path/edit/63?destination=admin%2Fconfig%2Fsearch%2Fpath%2Flist%2Fcontact-us&render=overlay','default','Edit alias','','7.28'),(3291,'/weebpal/forum-plus/fr/admin/config/search/path/edit/63?destination=admin%2Fconfig%2Fsearch%2Fpath%2Flist%2Fcontact-us&render=overlay','default','Existing system path','','7.28'),(3292,'/weebpal/forum-plus/fr/admin/config/search/path/edit/63?destination=admin%2Fconfig%2Fsearch%2Fpath%2Flist%2Fcontact-us&render=overlay','default','Specify the existing path you wish to alias. For example: node/28, forum/1, taxonomy/term/1.','','7.28'),(3293,'/weebpal/forum-plus/fr/admin/config/search/path/edit/63?destination=admin%2Fconfig%2Fsearch%2Fpath%2Flist%2Fcontact-us&render=overlay','default','Path alias','','7.28'),(3294,'/weebpal/forum-plus/fr/admin/config/search/path/edit/63?destination=admin%2Fconfig%2Fsearch%2Fpath%2Flist%2Fcontact-us&render=overlay','default','Specify an alternative path by which this data can be accessed. For example, type \"about\" when writing an about page. Use a relative path and don\'t add a trailing slash or the URL alias won\'t work.','','7.28'),(3295,'/weebpal/forum-plus/fr/admin/config/search/path/edit/63?destination=admin%2Fconfig%2Fsearch%2Fpath%2Flist%2Fcontact-us&render=overlay','default','A path alias set for a specific language will always be used when displaying this page in that language, and takes precedence over path aliases set for <em>All languages</em>.','','7.28'),(3296,'/weebpal/forum-plus/fr/admin/config/search/path/edit/63?destination=admin%2Fconfig%2Fsearch%2Fpath%2Flist%2Fcontact-us&render=overlay&render=overlay','default','The alias has been saved.','','7.28'),(3297,'/weebpal/forum-plus/fr/node/42','default','%type: !message in %function (line %line of %file).','','7.28'),(3298,'/weebpal/forum-plus/fr/admin/config/search/path/update_bulk?render=overlay','default','Select the types of un-aliased paths for which to generate URL aliases','','7.28'),(3299,'/weebpal/forum-plus/fr/blogs','default','There is currently 1 user online.','','7.39'),(3300,'/weebpal/forum-plus/fr/admin/structure/types/manage/blog?render=overlay','default','The human-readable name of this content type. This text will be displayed as part of the list on the <em>Add new content</em> page. It is recommended that this name begin with a capital letter and contain only letters, numbers, and spaces. This name must be unique.','','7.28'),(3301,'/weebpal/forum-plus/fr/admin/structure/types/manage/blog?render=overlay','default','Add new content','','7.28'),(3302,'/weebpal/forum-plus/fr/admin/structure/types/manage/blog?render=overlay','default','A unique machine-readable name for this content type. It must only contain lowercase letters, numbers, and underscores. This name will be used for constructing the URL of the %node-add page, in which underscores will be converted into hyphens.','','7.28'),(3303,'/weebpal/forum-plus/fr/admin/structure/types/manage/blog?render=overlay','default','Describe this content type. The text will be displayed on the <em>Add new content</em> page.','','7.28'),(3304,'/weebpal/forum-plus/fr/admin/structure/types/manage/blog?render=overlay','default','Submission form settings','','7.28'),(3305,'/weebpal/forum-plus/fr/admin/structure/types/manage/blog?render=overlay','default','Title field label','','7.28'),(3306,'/weebpal/forum-plus/fr/admin/structure/types/manage/blog?render=overlay','default','Optional','','7.28'),(3307,'/weebpal/forum-plus/fr/admin/structure/types/manage/blog?render=overlay','default','Required','','7.28'),(3308,'/weebpal/forum-plus/fr/admin/structure/types/manage/blog?render=overlay','default','Explanation or submission guidelines','','7.28'),(3309,'/weebpal/forum-plus/fr/admin/structure/types/manage/blog?render=overlay','default','This text will be displayed at the top of the page when creating or editing content of this type.','','7.28'),(3310,'/weebpal/forum-plus/fr/admin/structure/types/manage/blog?render=overlay','default','Users with the <em>Administer content</em> permission will be able to override these options.','','7.28'),(3311,'/weebpal/forum-plus/fr/admin/structure/types/manage/blog?render=overlay','default','Display settings','','7.28'),(3312,'/weebpal/forum-plus/fr/admin/structure/types/manage/blog?render=overlay','default','Save content type','','7.28'),(3313,'/weebpal/forum-plus/fr/admin/structure/types/manage/blog?render=overlay','default','Default comment setting for new content','','7.28'),(3314,'/weebpal/forum-plus/fr/admin/structure/types/manage/blog?render=overlay','default','Threading','','7.28'),(3315,'/weebpal/forum-plus/fr/admin/structure/types/manage/blog?render=overlay','default','Show comment replies in a threaded list.','','7.28'),(3316,'/weebpal/forum-plus/fr/admin/structure/types/manage/blog?render=overlay','default','Comments per page','','7.28'),(3317,'/weebpal/forum-plus/fr/admin/structure/types/manage/blog?render=overlay','default','Anonymous commenting','','7.28'),(3318,'/weebpal/forum-plus/fr/admin/structure/types/manage/blog?render=overlay','default','Anonymous posters may not enter their contact information','','7.28'),(3319,'/weebpal/forum-plus/fr/admin/structure/types/manage/blog?render=overlay','default','Anonymous posters may leave their contact information','','7.28'),(3320,'/weebpal/forum-plus/fr/admin/structure/types/manage/blog?render=overlay','default','Anonymous posters must leave their contact information','','7.28'),(3321,'/weebpal/forum-plus/fr/admin/structure/types/manage/blog?render=overlay','default','Allow comment title','','7.28'),(3322,'/weebpal/forum-plus/fr/admin/structure/types/manage/blog?render=overlay','default','Show reply form on the same page as comments','','7.28'),(3323,'/weebpal/forum-plus/fr/admin/structure/types/manage/blog?render=overlay','default','Preview comment','','7.28'),(3324,'/weebpal/forum-plus/fr/admin/structure/types/manage/blog?render=overlay','default','Available menus','','7.28'),(3325,'/weebpal/forum-plus/fr/admin/structure/types/manage/blog?render=overlay','default','The menus available to place links in for this content type.','','7.28'),(3326,'/weebpal/forum-plus/fr/admin/structure/types/manage/blog?render=overlay','default','Request new password','','7.34'),(3327,'/weebpal/forum-plus/fr/admin/structure/types/manage/blog?render=overlay','default','Default parent item','','7.28'),(3328,'/weebpal/forum-plus/fr/admin/structure/types/manage/blog?render=overlay','default','Choose the menu item to be the default parent for a new link in the content authoring form.','','7.28'),(3329,'/weebpal/forum-plus/fr/admin/structure/types/manage/blog?render=overlay','default','A unique machine-readable name. Can only contain lowercase letters, numbers, and underscores.','','7.28'),(3330,'/weebpal/forum-plus/fr/admin/structure/types/manage/blog?render=overlay','default','Comment fields','','7.28'),(3331,'/weebpal/forum-plus/fr/admin/structure/types/manage/blog?render=overlay','default','Comment display','','7.28'),(3332,'/weebpal/forum-plus/fr/admin/structure/types/manage/blog/fields?render=overlay','default','Field type','','7.28'),(3333,'/weebpal/forum-plus/fr/admin/structure/types/manage/blog/fields?render=overlay','default','Widget','','7.28'),(3334,'/weebpal/forum-plus/fr/admin/structure/types/manage/blog/fields?render=overlay','default','No fields are present yet.','','7.28'),(3335,'/weebpal/forum-plus/fr/admin/structure/types/manage/blog/fields?render=overlay','default','Parent for @title','','7.28'),(3336,'/weebpal/forum-plus/fr/admin/structure/types/manage/blog/fields?render=overlay','default','Edit field settings.','','7.28'),(3337,'/weebpal/forum-plus/fr/admin/structure/types/manage/blog/fields?render=overlay','default','Change widget type.','','7.28'),(3338,'/weebpal/forum-plus/fr/admin/structure/types/manage/blog/fields?render=overlay','default','Edit instance settings.','','7.28'),(3339,'/weebpal/forum-plus/fr/admin/structure/types/manage/blog/fields?render=overlay','default','Delete instance.','','7.28'),(3340,'/weebpal/forum-plus/fr/admin/structure/types/manage/blog/fields?render=overlay','default','New field label','','7.28'),(3341,'/weebpal/forum-plus/fr/admin/structure/types/manage/blog/fields?render=overlay','default','Add new field','','7.28'),(3342,'/weebpal/forum-plus/fr/admin/structure/types/manage/blog/fields?render=overlay','default','Weight for new field','','7.28'),(3343,'/weebpal/forum-plus/fr/admin/structure/types/manage/blog/fields?render=overlay','default','Parent for new field','','7.28'),(3344,'/weebpal/forum-plus/fr/admin/structure/types/manage/blog/fields?render=overlay','default','New field name','','7.28'),(3345,'/weebpal/forum-plus/fr/admin/structure/types/manage/blog/fields?render=overlay','default','A unique machine-readable name containing letters, numbers, and underscores.','','7.28'),(3346,'/weebpal/forum-plus/fr/admin/structure/types/manage/blog/fields?render=overlay','default','Type of new field','','7.28'),(3347,'/weebpal/forum-plus/fr/admin/structure/types/manage/blog/fields?render=overlay','default','- Select a field type -','','7.28'),(3348,'/weebpal/forum-plus/fr/admin/structure/types/manage/blog/fields?render=overlay','default','Type of data to store.','','7.28'),(3349,'/weebpal/forum-plus/fr/admin/structure/types/manage/blog/fields?render=overlay','default','Widget for new field','','7.28'),(3350,'/weebpal/forum-plus/fr/admin/structure/types/manage/blog/fields?render=overlay','default','- Select a widget -','','7.28'),(3351,'/weebpal/forum-plus/fr/admin/structure/types/manage/blog/fields?render=overlay','default','Form element to edit the data.','','7.28'),(3352,'/weebpal/forum-plus/fr/admin/structure/types/manage/blog/fields?render=overlay','default','@type: @field (@label)','','7.28'),(3353,'/weebpal/forum-plus/fr/admin/structure/types/manage/blog/fields?render=overlay','default','Existing field label','','7.28'),(3354,'/weebpal/forum-plus/fr/admin/structure/types/manage/blog/fields?render=overlay','default','Add existing field','','7.28'),(3355,'/weebpal/forum-plus/fr/admin/structure/types/manage/blog/fields?render=overlay','default','Weight for added field','','7.28'),(3356,'/weebpal/forum-plus/fr/admin/structure/types/manage/blog/fields?render=overlay','default','Parent for existing field','','7.28'),(3357,'/weebpal/forum-plus/fr/admin/structure/types/manage/blog/fields?render=overlay','default','Existing field to share','','7.28'),(3358,'/weebpal/forum-plus/fr/admin/structure/types/manage/blog/fields?render=overlay','default','- Select an existing field -','','7.28'),(3359,'/weebpal/forum-plus/fr/admin/structure/types/manage/blog/fields?render=overlay','default','Field to share','','7.28'),(3360,'/weebpal/forum-plus/fr/admin/structure/types/manage/blog/fields?render=overlay','default','Widget for existing field','','7.28'),(3361,'/weebpal/forum-plus/fr/admin/structure/types/manage/blog/fields?render=overlay','default','Add new group','','7.28'),(3362,'/weebpal/forum-plus/fr/admin/structure/types/manage/blog/fields?render=overlay','default','Label for new group','','7.28'),(3363,'/weebpal/forum-plus/fr/admin/structure/types/manage/blog/fields?render=overlay','default','Weight for new group','','7.28'),(3364,'/weebpal/forum-plus/fr/admin/structure/types/manage/blog/fields?render=overlay','default','Parent for new group','','7.28'),(3365,'/weebpal/forum-plus/fr/admin/structure/types/manage/blog/fields?render=overlay','default','Machine name for new group','','7.28'),(3366,'/weebpal/forum-plus/fr/admin/structure/types/manage/blog/fields?render=overlay','default','Group name (a-z, 0-9, _)','','7.28'),(3367,'/weebpal/forum-plus/fr/admin/structure/types/manage/blog/fields?render=overlay','default','Refresh','','7.28'),(3368,'/weebpal/forum-plus/fr/admin/structure/types/manage/blog/fields?render=overlay','default','Fieldgroups','','7.28'),(3369,'/weebpal/forum-plus/fr/admin/structure/types/manage/blog/fields?render=overlay','default','<p class=\"fieldgroup-help\">Fields can be dragged into groups with unlimited nesting. Each fieldgroup format comes with a configuration form, specific for that format type.<br />Note that some formats come in pair. These types have a html wrapper to nest its fieldgroup children. E.g. Place accordion items into the accordion, vertical tabs in vertical tab group and horizontal tabs in the horizontal tab group. There is one exception to this rule, you can use a vertical tab without a wrapper when the additional settings tabs are available. E.g. node forms.</p>','','7.28'),(3370,'/weebpal/forum-plus/fr/admin/structure/types/manage/blog/fields?render=overlay','default','Select source view mode or form','','7.28'),(3371,'/weebpal/forum-plus/fr/admin/structure/types/manage/blog/fields?render=overlay','default','Clone fieldgroups from selected view mode to the current display','','7.28'),(3372,'/weebpal/forum-plus/fr/admin/structure/types/manage/blog/display?render=overlay','default','Format','','7.28'),(3373,'/weebpal/forum-plus/fr/admin/structure/types/manage/blog/display?render=overlay','default','No field is displayed.','','7.28'),(3374,'/weebpal/forum-plus/fr/admin/structure/types/manage/blog/display?render=overlay','default','No field is hidden.','','7.28'),(3375,'/weebpal/forum-plus/fr/admin/structure/types/manage/blog/display?render=overlay','default','Above','','7.28'),(3376,'/weebpal/forum-plus/fr/admin/structure/types/manage/blog/display?render=overlay','default','Inline','','7.28'),(3377,'/weebpal/forum-plus/fr/admin/structure/types/manage/blog/display?render=overlay','default','Visible','','7.28'),(3378,'/weebpal/forum-plus/fr/admin/structure/types/manage/blog/display?render=overlay','default','Label display for @title','','7.28'),(3379,'/weebpal/forum-plus/fr/admin/structure/types/manage/blog/display?render=overlay','default','Formatter for @title','','7.28'),(3380,'/weebpal/forum-plus/fr/admin/structure/types/manage/blog/display?render=overlay','default','Image style: @style','','7.28'),(3381,'/weebpal/forum-plus/fr/admin/structure/types/manage/blog/display?render=overlay','default','Linked to content','','7.28'),(3382,'/weebpal/forum-plus/fr/admin/structure/types/manage/blog/display?render=overlay','default','Linked to file','','7.28'),(3383,'/weebpal/forum-plus/fr/admin/structure/types/manage/blog/display?render=overlay','default','Style: @widget, Exposed: @expose, Stars display: @style, Text display: @text','','7.28'),(3384,'/weebpal/forum-plus/fr/admin/structure/types/manage/blog/display?render=overlay','default','Links: @links','','7.28'),(3385,'/weebpal/forum-plus/fr/admin/structure/types/manage/blog/display?render=overlay','default','View mode: @mode','','7.28'),(3386,'/weebpal/forum-plus/fr/admin/structure/types/manage/blog/display?render=overlay','default','Custom display settings','','7.28'),(3387,'/weebpal/forum-plus/fr/admin/structure/types/manage/blog/display?render=overlay','default','Use custom display settings for the following view modes','','7.28'),(3388,'/weebpal/forum-plus/fr/admin/structure/types/manage/blog/display?render=overlay','default','Form','','7.32'),(3389,'/weebpal/forum-plus/fr/admin/structure/types/manage/blog/display?render=overlay','default','Content items can be displayed using different view modes: Teaser, Full content, Print, RSS, etc. <em>Teaser</em> is a short format that is typically used in lists of multiple content items. <em>Full content</em> is typically used when the content is displayed on its own page.','','7.28'),(3390,'/weebpal/forum-plus/fr/admin/structure/types/manage/blog/display?render=overlay','default','Here, you can define which fields are shown and hidden when %type content is displayed in each view mode, and define how the fields are displayed in each view mode.','','7.28'),(3391,'/weebpal/forum-plus/fr/node/add/blog?render=overlay','default','Create @name','','7.34'),(3392,'/weebpal/forum-plus/fr/node/add/blog?render=overlay','default','@size KB','','7.34'),(3393,'/weebpal/forum-plus/fr/node/add/blog?render=overlay','default','@size MB','','7.34'),(3394,'/weebpal/forum-plus/fr/node/add/blog?render=overlay','default','@size GB','','7.34'),(3395,'/weebpal/forum-plus/fr/node/add/blog?render=overlay','default','@size TB','','7.34'),(3396,'/weebpal/forum-plus/fr/node/add/blog?render=overlay','default','@size PB','','7.34'),(3397,'/weebpal/forum-plus/fr/node/add/blog?render=overlay','default','@size EB','','7.34'),(3398,'/weebpal/forum-plus/fr/node/add/blog?render=overlay','default','@size ZB','','7.34'),(3399,'/weebpal/forum-plus/fr/node/add/blog?render=overlay','default','@size YB','','7.34'),(3400,'/weebpal/forum-plus/fr/node/add/blog?render=overlay','default','Files must be less than !size.','','7.34'),(3401,'/weebpal/forum-plus/fr/node/add/blog?render=overlay','default','Allowed file types: !extensions.','','7.34'),(3402,'/weebpal/forum-plus/fr/node/add/blog?render=overlay','default','Video URL','','7.34'),(3403,'/weebpal/forum-plus/fr/node/add/blog?render=overlay','default','Weight for row @number','','7.34'),(3404,'/weebpal/forum-plus/fr/node/add/blog?render=overlay','default','Add another item','','7.34'),(3405,'/weebpal/forum-plus/fr/node/add/blog?render=overlay','default','Upload','','7.34'),(3406,'/weebpal/forum-plus/fr/node/add/blog?render=overlay','default','Choose a file','','7.34'),(3407,'/weebpal/forum-plus/fr/node/add/blog?render=overlay','default','Alternate text','','7.34'),(3408,'/weebpal/forum-plus/fr/node/add/blog?render=overlay','default','This text will be used by screen readers, search engines, or when the image cannot be loaded.','','7.34'),(3409,'/weebpal/forum-plus/fr/node/add/blog?render=overlay','default','The title is used as a tool tip when the user hovers the mouse over the image.','','7.34'),(3410,'/weebpal/forum-plus/fr/node/add/blog?render=overlay','default','Autocomplete taxonomy','','7.28'),(3411,'/weebpal/forum-plus/fr/node/48/edit?render=overlay','default','The link title is limited to @maxlength characters maximum.','','7.28'),(3412,'/weebpal/forum-plus/fr/admin/config/search/path/patterns?render=overlay&render=overlay','default','Unknown variable @name','','7.28'),(3413,'/weebpal/forum-plus/fr/admin/config/search/path/patterns?render=overlay&render=overlay','default','We have no meta information for this variable. Please, ask module developers to declare their variables. See <a href=\"http://drupal.org/project/variable\">Variable module</a>.','','7.28'),(3414,'/weebpal/forum-plus/fr/admin/config/search/path/patterns?render=overlay&render=overlay','default','The configuration options have been saved.','','7.32'),(3415,'/weebpal/forum-plus/fr/node/48/edit?render=overlay&render=overlay','default','@type %title has been updated.','','7.28'),(3416,'/weebpal/forum-plus/fr/undefined','default','Sorry but we could not find the page you are looking for. Please check to make sure you have typed the URL correctly. You may also want to search for what you are looking for.','','7.34'),(3417,'/weebpal/forum-plus/fr/undefined','default','Go to Home Page','','7.34'),(3418,'/weebpal/forum-plus/fr/undefined','default',' <a title=\"@title\" href=\"@url\">Return to the home page</a>','','7.34'),(3419,'/weebpal/forum-plus/fr/blog/undefined','default','Access denied','','7.28'),(3420,'/weebpal/forum-plus/fr/blog/undefined','default','You are not authorized to access this page.','','7.28'),(3421,'/weebpal/forum-plus/fr/forum/6','default','Subscribe to !feed-title','','7.34'),(3422,'/weebpal/forum-plus/fr/forum/6','default','Forum Name','','7.34'),(3423,'/weebpal/forum-plus/fr/forum/6','default','Topic / Topic starter','','7.32'),(3424,'/weebpal/forum-plus/fr/forum/6','default','<span class=\"forum-topic-title\">[title]</span> ','','7.32'),(3425,'/weebpal/forum-plus/fr/forum/6','default','[teaser]','','7.32'),(3426,'/weebpal/forum-plus/fr/forum/6','default','[timestamp] ','','7.32'),(3427,'/weebpal/forum-plus/fr/forum/6','default','<br /> by [name_1]','','7.32'),(3428,'/weebpal/forum-plus/fr/forum/6','default','» [created]','','7.32'),(3429,'/weebpal/forum-plus/fr/forum/6','default','View ','','7.32'),(3430,'/weebpal/forum-plus/fr/forum/6','default',' new','','7.32'),(3431,'/weebpal/forum-plus/fr/forum/6','default','Replies','','7.32'),(3432,'/weebpal/forum-plus/fr/forum/6','default','[comment_count]<br />[new_comments] ','','7.32'),(3433,'/weebpal/forum-plus/fr/forum/6','default','by [last_comment_name]','','7.32'),(3434,'/weebpal/forum-plus/fr/forum/6','default','Yes','','7.32'),(3435,'/weebpal/forum-plus/fr/forum/6','default','No','','7.32'),(3436,'/weebpal/forum-plus/fr/forum/6','default','False','','7.32'),(3437,'/weebpal/forum-plus/fr/forum/6','default','On','','7.32'),(3438,'/weebpal/forum-plus/fr/forum/6','default','Off','','7.32'),(3439,'/weebpal/forum-plus/fr/forum/6','default','Custom','','7.39'),(3440,'/weebpal/forum-plus/fr/forum/6','default','No posts in this forum.','','7.32'),(3441,'/weebpal/forum-plus/fr/forum/6','default','Normal topic','','7.32'),(3442,'/weebpal/forum-plus/fr/forum/6','default','Sticky topic','','7.32'),(3443,'/weebpal/forum-plus/fr/forum/6','default','Page: ','','7.32'),(3444,'/weebpal/forum-plus/fr/forum/6','default','Closed topic','','7.32'),(3445,'/weebpal/forum-plus/fr/forum/6','default','Sticky:','','7.32'),(3446,'/weebpal/forum-plus/fr/forum/6','default','New @node_type','','7.32'),(3447,'/weebpal/forum-plus/fr/forum/6','default','View active posts in this forum','','7.32'),(3448,'/weebpal/forum-plus/fr/forum/6','default','View unanswered posts in this forum','','7.32'),(3449,'/weebpal/forum-plus/fr/forum/6','default','View new posts in this forum','','7.32'),(3450,'/weebpal/forum-plus/fr/forum/6','default','Mark all topics read','','7.32'),(3451,'/weebpal/forum-plus/fr/forum/6','default','- Select a forum -','','7.32'),(3452,'/weebpal/forum-plus/fr/forum/6','default','Order by','','7.32'),(3453,'/weebpal/forum-plus/fr/forum/6','default','Sort','','7.32'),(3454,'/weebpal/forum-plus/fr/forum/6','default','Up','','7.32'),(3455,'/weebpal/forum-plus/fr/forum/6','default','Down','','7.32'),(3456,'/weebpal/forum-plus/fr/forum/6','default','Hot topic with new posts','','7.32'),(3457,'/weebpal/forum-plus/fr/forum/6','default','Hot topic without new posts','','7.32'),(3458,'/weebpal/forum-plus/fr/forum/6','default','Locked topic','','7.32'),(3459,'/weebpal/forum-plus/fr/forum/column-oriented-databases-does-bigtable-cassandra-belong-column-store-database','default','Your rating: <span>!stars</span>','','7.39'),(3460,'/weebpal/forum-plus/fr/forum/column-oriented-databases-does-bigtable-cassandra-belong-column-store-database','default','No votes yet','','7.39'),(3461,'/weebpal/forum-plus/fr/forum/column-oriented-databases-does-bigtable-cassandra-belong-column-store-database','default','Quick reply','','7.39'),(3462,'/weebpal/forum-plus/fr/forum/column-oriented-databases-does-bigtable-cassandra-belong-column-store-database','default','@count posts','','7.34'),(3463,'/weebpal/forum-plus/fr/forum/column-oriented-databases-does-bigtable-cassandra-belong-column-store-database','default','!new new','','7.39'),(3464,'/weebpal/forum-plus/fr/forum/column-oriented-databases-does-bigtable-cassandra-belong-column-store-database','default','Online','','7.39'),(3465,'/weebpal/forum-plus/fr/forum/column-oriented-databases-does-bigtable-cassandra-belong-column-store-database','default','Send @accountname an email.','','7.39'),(3466,'/weebpal/forum-plus/fr/forum/column-oriented-databases-does-bigtable-cassandra-belong-column-store-database','default','Send Email','','7.39'),(3467,'/weebpal/forum-plus/fr/forum/column-oriented-databases-does-bigtable-cassandra-belong-column-store-database','default','Last seen','','7.39'),(3468,'/weebpal/forum-plus/fr/forum/column-oriented-databases-does-bigtable-cassandra-belong-column-store-database','default','!time ago','','7.39'),(3469,'/weebpal/forum-plus/fr/forum/column-oriented-databases-does-bigtable-cassandra-belong-column-store-database','default','Joined','','7.39'),(3470,'/weebpal/forum-plus/fr/forum/column-oriented-databases-does-bigtable-cassandra-belong-column-store-database','default','Edited by','','7.39'),(3471,'/weebpal/forum-plus/fr/forum/column-oriented-databases-does-bigtable-cassandra-belong-column-store-database','default','on','','7.39'),(3472,'/weebpal/forum-plus/fr/forum/column-oriented-databases-does-bigtable-cassandra-belong-column-store-database','default','Jump to top of page','','7.39'),(3473,'/weebpal/forum-plus/fr/forum/column-oriented-databases-does-bigtable-cassandra-belong-column-store-database','default','Offline','','7.32'),(3474,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','A special cache used to store objects that are being edited; it serves to save state in an ordinarily stateless environment.','','7.32'),(3475,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','Table that contains field group entries and settings.','','7.32'),(3476,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','Author Pane (content pane)','','7.32'),(3477,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','Author related variables gathered from helper modules.','','7.32'),(3478,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','Vocabulary terms','','7.32'),(3479,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','All the terms in a vocabulary.','','7.32'),(3480,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','The picture of a user.','','7.32'),(3481,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','User profile','','7.32'),(3482,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','The profile of a user.','','7.32'),(3483,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','User signature','','7.32'),(3484,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','The signature of a user.','','7.32'),(3485,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','Term description.','','7.32'),(3486,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','List of related terms','','7.32'),(3487,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','Terms related to an existing term; may be child, siblings or top level.','','7.32'),(3488,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','Advanced search form','','7.32'),(3489,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','A search form with advanced options.','','7.32'),(3490,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','Keywords','','7.32'),(3491,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','Widgets','','7.32'),(3492,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','Search results','','7.32'),(3493,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','The results of a search using keywords.','','7.32'),(3494,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','Add the action links (local tasks) as content.','','7.32'),(3495,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','Page elements','','7.32'),(3496,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','Breadcrumb','','7.34'),(3497,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','Add the breadcrumb trail as content.','','7.32'),(3498,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','Feed icons','','7.32'),(3499,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','Add the site feed_icons statement as content.','','7.32'),(3500,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','Add the help text of the current page as content.','','7.32'),(3501,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','Site logo','','7.32'),(3502,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','Add the logo trail as content.','','7.32'),(3503,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','Status messages','','7.32'),(3504,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','Add the status messages of the current page as content.','','7.32'),(3505,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','Primary navigation links','','7.32'),(3506,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','Add the primary_links (local tasks) as content.','','7.32'),(3507,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','Secondary navigation links','','7.32'),(3508,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','Add the secondary_links (local tasks) as content.','','7.32'),(3509,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','Add the site\'s slogan as content.','','7.32'),(3510,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','Tabs','','7.32'),(3511,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','Add the tabs (local tasks) as content.','','7.32'),(3512,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','Add the page title as content.','','7.32'),(3513,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','Node form author information','','7.32'),(3514,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','Author information on the Node form.','','7.32'),(3515,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','Node form book options','','7.32'),(3516,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','Book options for the node.','','7.32'),(3517,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','Node form submit buttons','','7.32'),(3518,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','Submit buttons for the node form.','','7.32'),(3519,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','Node form comment settings','','7.32'),(3520,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','Comment settings on the Node form.','','7.32'),(3521,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','Node form languages','','7.32'),(3522,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','The language selection form.','','7.32'),(3523,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','Node form revision log message','','7.32'),(3524,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','Revision log message for the node.','','7.32'),(3525,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','Node form menu settings','','7.32'),(3526,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','Menu settings on the Node form.','','7.32'),(3527,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','Node form url path settings','','7.32'),(3528,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','Publishing options on the Node form.','','7.32'),(3529,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','Node form publishing options','','7.32'),(3530,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','Node form title field','','7.32'),(3531,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','The node title form.','','7.32'),(3532,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','Attached files','','7.32'),(3533,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','A list of files attached to the node.','','7.32'),(3534,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','Node author','','7.32'),(3535,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','The author of the referenced node.','','7.32'),(3536,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','Node body','','7.32'),(3537,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','The body of the referenced node.','','7.32'),(3538,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','Book children','','7.32'),(3539,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','The children menu the book the node belongs to.','','7.32'),(3540,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','Book navigation','','7.34'),(3541,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','The navigation menu the book the node belongs to.','','7.32'),(3542,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','Comment form','','7.32'),(3543,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','A form to add a new comment.','','7.32'),(3544,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','Node comments','','7.32'),(3545,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','The comments of the referenced node.','','7.32'),(3546,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','Node content','','7.32'),(3547,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','The content of the referenced node.','','7.32'),(3548,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','Node created date','','7.32'),(3549,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','The date the referenced node was created.','','7.32'),(3550,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','Node links of the referenced node.','','7.32'),(3551,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','Node terms','','7.32'),(3552,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','Taxonomy terms of the referenced node.','','7.32'),(3553,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','Node title','','7.32'),(3554,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','The title of the referenced node.','','7.32'),(3555,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','Node type description','','7.32'),(3556,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','Node type description.','','7.32'),(3557,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','Node last updated date','','7.32'),(3558,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','The date the referenced node was last updated.','','7.32'),(3559,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','Existing node','','7.32'),(3560,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','Add a node from your site as content.','','7.32'),(3561,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','Entity field','','7.32'),(3562,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','General form','','7.32'),(3563,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','Everything in the form that is not displayed by other content.','','7.32'),(3564,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','Entity extra field','','7.32'),(3565,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','Custom content','','7.32'),(3566,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','The site contact form that allows users to send a message to site administrators.','','7.32'),(3567,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','User contact form','','7.32'),(3568,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','The site contact form that allows users to contact other users.','','7.32'),(3569,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','Comment Reply Form','','7.32'),(3570,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','A form to add a new comment reply.','','7.32'),(3571,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','Message render','','7.32'),(3572,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','Render a message entity.','','7.32'),(3573,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','ShareThis Widget','','7.32'),(3574,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','ShareThis Widget pane','','7.32'),(3575,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','Forum legend','','7.32'),(3576,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','The forum legend widget.','','7.32'),(3577,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','Forum list','','7.32'),(3578,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','A list of forums for the forum.','','7.32'),(3579,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','Forum mark read','','7.32'),(3580,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','Link to mark all forums / individual forum read.','','7.32'),(3581,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','Forum node create list','','7.32'),(3582,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','List of links to create new forum content nodes.','','7.32'),(3583,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','Forum search','','7.32'),(3584,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','The forum search widget.','','7.32'),(3585,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','Forum statistics','','7.32'),(3586,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','The forum statistics widget.','','7.32'),(3587,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','Forum tools','','7.32'),(3588,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','Jump list with various forum destinations.','','7.32'),(3589,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','Forum topic_legend','','7.32'),(3590,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','The forum topic_legend widget.','','7.32'),(3591,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','The list of all topics for a forum.','','7.32'),(3592,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','Forum topic list sort widget','','7.32'),(3593,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','A small select widget to change the sort order of the forum topic list','','7.32'),(3594,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','Field type(s) in use - see <a href=\"@fields-page\">Field list</a>','','7.32'),(3595,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','No update data available','','7.32'),(3596,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','No update information available. <a href=\"@run_cron\">Run cron</a> or <a href=\"@check_manually\">check manually</a>.','','7.32'),(3597,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','\'%name\' block','','7.28'),(3598,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','Block title','','7.28'),(3599,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','Override the default title for the block. Use <em>!placeholder</em> to display no title, or leave blank to use the default block title.','','7.28'),(3600,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','Number of topics','','7.28'),(3601,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','Region settings','','7.28'),(3602,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','Specify in which themes and regions this block is displayed.','','7.28'),(3603,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','Triptych first','','7.32'),(3604,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','Triptych middle','','7.32'),(3605,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','Triptych last','','7.32'),(3606,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','Footer first column','','7.32'),(3607,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','Footer second column','','7.32'),(3608,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','Footer third column','','7.32'),(3609,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','Footer fourth column','','7.32'),(3610,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','!theme (default theme)','','7.28'),(3611,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','!theme (administration theme)','','7.28'),(3612,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','Visibility settings','','7.28'),(3613,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','All pages except those listed','','7.28'),(3614,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','Only the listed pages','','7.28'),(3615,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','Specify pages by using their paths. Enter one path per line. The \'*\' character is a wildcard. Example paths are %blog for the blog page and %blog-wildcard for every personal blog. %front is the front page.','','7.28'),(3616,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','Pages on which this PHP code returns <code>TRUE</code> (experts only)','','7.28'),(3617,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','Pages or PHP code','','7.28'),(3618,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','If the PHP option is chosen, enter PHP code between %php. Note that executing incorrect PHP code can break your Drupal site.','','7.28'),(3619,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','Show block on specific pages','','7.28'),(3620,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','anonymous user','','7.28'),(3621,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','authenticated user','','7.34'),(3622,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','Show block for specific roles','','7.28'),(3623,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','Show this block only for the selected role(s). If you select no roles, the block will be visible to all users.','','7.28'),(3624,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','Customizable per user','','7.28'),(3625,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','Customizable, visible by default','','7.28'),(3626,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','Customizable, hidden by default','','7.28'),(3627,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','Allow individual users to customize the visibility of this block in their account settings.','','7.28'),(3628,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','Save block','','7.28'),(3629,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','Customize the styling of this block by adding CSS classes. Separate multiple classes by spaces.','','7.28'),(3630,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','Show block for specific content types','','7.28'),(3631,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','Show this block only on pages that display content of the given type(s). If you select no types, there will be no type-specific limitation.','','7.28'),(3632,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','This field supports tokens.','','7.28'),(3633,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','This block has generated content, only the title can be translated here.','','7.28'),(3634,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','Make this block translatable','','7.28'),(3635,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','Show this block for these languages','','7.28'),(3636,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','If no language is selected, block will show regardless of language.','','7.28'),(3637,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','Save and translate','','7.28'),(3638,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','Recent comments','','7.34'),(3639,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','Reply to','','7.32'),(3640,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','Recent posts','','7.32'),(3641,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','Last Post','','7.32'),(3642,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','Recent posts for %1','','7.32'),(3643,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','Defaults','','7.32'),(3644,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','No messages created yet.','','7.32'),(3645,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','Monthly archive','','7.34'),(3646,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','%1','','7.34'),(3647,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','Front page feed','','7.32'),(3648,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','Last update','','7.32'),(3649,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','No backlinks found.','','7.32'),(3650,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','Pages that link to %1','','7.32'),(3651,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','What links here','','7.32'),(3652,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','Popular content','','7.34'),(3653,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','Popular (page)','','7.32'),(3654,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','Today (page)','','7.32'),(3655,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','Popular (block)','','7.32'),(3656,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default',' (','','7.32'),(3657,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default',')','','7.32'),(3658,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','Today (block)','','7.32'),(3659,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','Today\'s popular content','','7.32'),(3660,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','No active topics.','','7.32'),(3661,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','Topic','','7.32'),(3662,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','node/[nid]','','7.32'),(3663,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','<br /> by [name_1] ','','7.32'),(3664,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','on [created]','','7.32'),(3665,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','Show active topics in:','','7.32'),(3666,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','Topics with new and updated posts','','7.34'),(3667,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','No new or updated posts.','','7.32'),(3668,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default',' View ','','7.32'),(3669,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','Show new & updated topics in:','','7.32'),(3670,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','Advanced Forum Search','','7.34'),(3671,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','Unanswered forum topics','','7.34'),(3672,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','No unanswered topics.','','7.32'),(3673,'/weebpal/forum-plus/fr/admin/structure/block/manage/forum/active/configure?destination=forum&render=overlay','default','Show unanswered topics in:','','7.32'),(3674,'/weebpal/forum-plus/fr/forum','default','@count new','','7.28'),(3675,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','Create new account','','7.34'),(3676,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','role','','7.28'),(3677,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','Administer blocks','','7.28'),(3678,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','@module module','','7.28'),(3679,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','administer blocks','','7.28'),(3680,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','Access all webform results','','7.28'),(3681,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','Grants access to the \"Results\" tab on all webform content. Generally an administrative permission.','','7.28'),(3682,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','Access own webform results','','7.28'),(3683,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','Grants access to the \"Results\" tab to the author of webform content they have created.','','7.28'),(3684,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','Edit all webform submissions','','7.28'),(3685,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','Allows editing of any webform submission by any user. Generally an administrative permission.','','7.28'),(3686,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','Delete all webform submissions','','7.28'),(3687,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','Allows deleting of any webform submission by any user. Generally an administrative permission.','','7.28'),(3688,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','Access own webform submissions','','7.28'),(3689,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','Edit own webform submissions','','7.28'),(3690,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','Delete own webform submissions','','7.28'),(3691,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','access own webform submissions','','7.28'),(3692,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','delete own webform submissions','','7.28'),(3693,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','edit own webform submissions','','7.28'),(3694,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','access all webform results','','7.28'),(3695,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','access own webform results','','7.28'),(3696,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','delete all webform submissions','','7.28'),(3697,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','edit all webform submissions','','7.28'),(3698,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','Administer block classes','','7.28'),(3699,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','Set CSS classes for blocks.','','7.28'),(3700,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','administer block classes','','7.28'),(3701,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','Administer book outlines','','7.28'),(3702,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','Create new books','','7.28'),(3703,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','Add content and child pages to books','','7.28'),(3704,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','View printer-friendly books','','7.28'),(3705,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','View a book page and all of its sub-pages as a single document for ease of printing. Can be performance heavy.','','7.28'),(3706,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','add content to books','','7.28'),(3707,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','administer book outlines','','7.28'),(3708,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','create new books','','7.28'),(3709,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','access printer-friendly version','','7.28'),(3710,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','Administer comments and comment settings','','7.28'),(3711,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','View comments','','7.28'),(3712,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','Post comments','','7.28'),(3713,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','Skip comment approval','','7.28'),(3714,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','Edit own comments','','7.28'),(3715,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','administer comments','','7.28'),(3716,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','edit own comments','','7.28'),(3717,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','post comments','','7.28'),(3718,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','skip comment approval','','7.28'),(3719,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','access comments','','7.28'),(3720,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','Administer contact forms and contact form settings','','7.28'),(3721,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','Use the site-wide contact form','','7.28'),(3722,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','Use users\' personal contact forms','','7.28'),(3723,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','administer contact forms','','7.28'),(3724,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','access site-wide contact form','','7.28'),(3725,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','access user contact forms','','7.28'),(3726,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','Use contextual links','','7.28'),(3727,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','Use contextual links to perform actions related to elements on a page.','','7.28'),(3728,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','access contextual links','','7.28'),(3729,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','View the administrative dashboard','','7.28'),(3730,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','Customizing the dashboard requires the !permission-name permission.','','7.28'),(3731,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','access dashboard','','7.28'),(3732,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','Administer FAQ module','','7.28'),(3733,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','Administer FAQ order','','7.28'),(3734,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','View FAQ pages','','7.28'),(3735,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','administer faq','','7.28'),(3736,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','administer faq order','','7.28'),(3737,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','view faq page','','7.28'),(3738,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','Administer field collections','','7.28'),(3739,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','Create and delete fields on field collections.','','7.28'),(3740,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','administer field collections','','7.28'),(3741,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','Administer text formats and filters','','7.28'),(3742,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','Use the !text_format text format','','7.28'),(3743,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','Warning: This permission may have security implications depending on how the text format is configured.','','7.28'),(3744,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','administer filters','','7.28'),(3745,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','use text format filtered_html','','7.28'),(3746,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','use text format full_html','','7.28'),(3747,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','use text format php_code','','7.28'),(3748,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','rate content','','7.28'),(3749,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','Administer the FlexSlider module','','7.28'),(3750,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','administer flexslider','','7.28'),(3751,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','Administer image styles','','7.28'),(3752,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','Create and modify styles for generating image modifications such as thumbnails.','','7.28'),(3753,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','administer image styles','','7.28'),(3754,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','Administer languages','','7.28'),(3755,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','Translate interface texts','','7.28'),(3756,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','administer languages','','7.28'),(3757,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','translate interface','','7.28'),(3758,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','Administer menus and menu items','','7.28'),(3759,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','administer menu','','7.28'),(3760,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','Administer message types','','7.28'),(3761,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','Administer message types that can be used to log an event.','','7.28'),(3762,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','Create messages','','7.28'),(3763,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','Log new messages.','','7.28'),(3764,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','administer message types','','7.28'),(3765,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','create messages','','7.28'),(3766,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','Administer Module Filter','','7.28'),(3767,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','Configure how Module Filter performs.','','7.28'),(3768,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','administer module filter','','7.28'),(3769,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','Bypass content access control','','7.28'),(3770,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','View, edit and delete all content regardless of permission restrictions.','','7.28'),(3771,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','Administer content types','','7.28'),(3772,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','Administer content','','7.28'),(3773,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','Access the content overview page','','7.28'),(3774,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','Get an overview of <a href=\"@url\">all content</a>.','','7.28'),(3775,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','View published content','','7.28'),(3776,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','View own unpublished content','','7.28'),(3777,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','View content revisions','','7.28'),(3778,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','Revert content revisions','','7.28'),(3779,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','Delete content revisions','','7.28'),(3780,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','%type_name: Create new content','','7.28'),(3781,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','%type_name: Edit own content','','7.28'),(3782,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','%type_name: Edit any content','','7.28'),(3783,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','%type_name: Delete own content','','7.28'),(3784,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','%type_name: Delete any content','','7.28'),(3785,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','create article content','','7.28'),(3786,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','delete any article content','','7.28'),(3787,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','delete own article content','','7.28'),(3788,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','edit any article content','','7.28'),(3789,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','edit own article content','','7.28'),(3790,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','create page content','','7.28'),(3791,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','delete any page content','','7.28'),(3792,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','delete own page content','','7.28'),(3793,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','edit any page content','','7.28'),(3794,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','edit own page content','','7.28'),(3795,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','create blog content','','7.28'),(3796,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','delete any blog content','','7.28'),(3797,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','delete own blog content','','7.28'),(3798,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','edit any blog content','','7.28'),(3799,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','edit own blog content','','7.28'),(3800,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','create book content','','7.28'),(3801,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','delete any book content','','7.28'),(3802,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','delete own book content','','7.28'),(3803,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','edit any book content','','7.28'),(3804,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','edit own book content','','7.28'),(3805,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','create faq content','','7.28'),(3806,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','delete any faq content','','7.28'),(3807,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','delete own faq content','','7.28'),(3808,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','edit any faq content','','7.28'),(3809,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','edit own faq content','','7.28'),(3810,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','create forum content','','7.28'),(3811,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','delete any forum content','','7.28'),(3812,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','delete own forum content','','7.28'),(3813,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','edit any forum content','','7.28'),(3814,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','edit own forum content','','7.28'),(3815,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','create products content','','7.28'),(3816,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','delete any products content','','7.28'),(3817,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','delete own products content','','7.28'),(3818,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','edit any products content','','7.28'),(3819,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','edit own products content','','7.28'),(3820,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','create video content','','7.28'),(3821,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','delete any video content','','7.28'),(3822,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','delete own video content','','7.28'),(3823,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','edit any video content','','7.28'),(3824,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','edit own video content','','7.28'),(3825,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','create webform content','','7.28'),(3826,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','delete any webform content','','7.28'),(3827,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','delete own webform content','','7.28'),(3828,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','edit any webform content','','7.28'),(3829,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','edit own webform content','','7.28'),(3830,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','delete revisions','','7.28'),(3831,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','revert revisions','','7.28'),(3832,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','view revisions','','7.28'),(3833,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','view own unpublished content','','7.28'),(3834,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','access content','','7.28'),(3835,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','access content overview','','7.28'),(3836,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','administer nodes','','7.28'),(3837,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','administer content types','','7.28'),(3838,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','bypass node access','','7.28'),(3839,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','Access the administrative overlay','','7.28'),(3840,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','View administrative pages in the overlay.','','7.28'),(3841,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','access overlay','','7.28'),(3842,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','Administer URL aliases','','7.28'),(3843,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','Create and edit URL aliases','','7.28'),(3844,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','administer url aliases','','7.28'),(3845,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','create url aliases','','7.28'),(3846,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','Use PHP for settings','','7.28'),(3847,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','use PHP for settings','','7.28'),(3848,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','Administer Quicktabs','','7.28'),(3849,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','administer quicktabs','','7.28'),(3850,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','Administer search','','7.28'),(3851,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','Use search','','7.28'),(3852,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','Use advanced search','','7.28'),(3853,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','administer search','','7.28'),(3854,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','use advanced search','','7.28'),(3855,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','search content','','7.28'),(3856,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','Administer ShareThis','','7.28'),(3857,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','Change the settings for how ShareThis behaves on the site.','','7.28'),(3858,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','administer sharethis','','7.28'),(3859,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','Administer shortcuts','','7.28'),(3860,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','Edit current shortcut set','','7.28'),(3861,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','Editing the current shortcut set will affect other users if that set has been assigned to or selected by other users. Granting \"Select any shortcut set\" permission along with this permission will grant permission to edit any shortcut set.','','7.28'),(3862,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','Select any shortcut set','','7.28'),(3863,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','From all shortcut sets, select one to be own active set. Without this permission, an administrator selects shortcut sets for users.','','7.28'),(3864,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','administer shortcuts','','7.28'),(3865,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','customize shortcut links','','7.28'),(3866,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','switch shortcut sets','','7.28'),(3867,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','Administer statistics','','7.28'),(3868,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','View content access statistics','','7.28'),(3869,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','View content hits','','7.28'),(3870,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','administer statistics','','7.28'),(3871,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','access statistics','','7.28'),(3872,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','view post access counter','','7.28'),(3873,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','Administer modules','','7.28'),(3874,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','Administer site configuration','','7.28'),(3875,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','Administer themes','','7.28'),(3876,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','Administer software updates','','7.28'),(3877,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','Administer actions','','7.28'),(3878,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','Use the administration pages and help','','7.28'),(3879,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','Use the site in maintenance mode','','7.28'),(3880,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','View the administration theme','','7.28'),(3881,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','View site reports','','7.28'),(3882,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','Block IP addresses','','7.28'),(3883,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','administer actions','','7.28'),(3884,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','administer modules','','7.28'),(3885,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','administer themes','','7.28'),(3886,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','block IP addresses','','7.28'),(3887,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','access administration pages','','7.28'),(3888,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','access site in maintenance mode','','7.28'),(3889,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','access site reports','','7.28'),(3890,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','administer site configuration','','7.28'),(3891,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','administer software updates','','7.28'),(3892,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','view the administration theme','','7.28'),(3893,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','Administer vocabularies and terms','','7.28'),(3894,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','Edit terms in %vocabulary','','7.28'),(3895,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','Delete terms from %vocabulary','','7.28'),(3896,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','administer taxonomy','','7.28'),(3897,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','delete terms in 3','','7.28'),(3898,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','delete terms in 2','','7.28'),(3899,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','delete terms in 4','','7.28'),(3900,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','delete terms in 1','','7.28'),(3901,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','edit terms in 3','','7.28'),(3902,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','edit terms in 2','','7.28'),(3903,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','edit terms in 4','','7.28'),(3904,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','edit terms in 1','','7.28'),(3905,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','Administer permissions','','7.28'),(3906,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','Administer users','','7.28'),(3907,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','View user profiles','','7.28'),(3908,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','Change own username','','7.28'),(3909,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','Cancel own user account','','7.28'),(3910,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','Note: content may be kept, unpublished, deleted or transferred to the %anonymous-name user depending on the configured <a href=\"@user-settings-url\">user settings</a>.','','7.28'),(3911,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','Select method for cancelling own account','','7.28'),(3912,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','change own username','','7.28'),(3913,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','access user profiles','','7.28'),(3914,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','administer permissions','','7.28'),(3915,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','administer users','','7.28'),(3916,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','cancel account','','7.28'),(3917,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','select account cancellation method','','7.28'),(3918,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','Administer video styles','','7.28'),(3919,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','Create and modify styles for embedded videos.','','7.28'),(3920,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','administer video styles','','7.28'),(3921,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','Administer Voting API','','7.28'),(3922,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','administer voting api','','7.28'),(3923,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','Administer Webform Hints settings','','7.28'),(3924,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','administer Webform Hints settings','','7.28'),(3925,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','Administer fieldgroups','','7.28'),(3926,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','Display the administration for fieldgroups.','','7.28'),(3927,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','administer fieldgroups','','7.28'),(3928,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','Administer forums','','7.28'),(3929,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','administer forums','','7.28'),(3930,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','Administer pathauto','','7.28'),(3931,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','Allows a user to configure patterns for automated aliases and bulk delete URL-aliases.','','7.28'),(3932,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','Notify of Path Changes','','7.28'),(3933,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','Determines whether or not users are notified.','','7.28'),(3934,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','administer pathauto','','7.28'),(3935,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','notify of path changes','','7.28'),(3936,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','Translate user-defined strings','','7.28'),(3937,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','Translate user-defined strings that are created as part of content or configuration.','','7.28'),(3938,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','Translate admin strings','','7.28'),(3939,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','Translate administrative strings with a very permissive XSS/HTML filter that allows all HTML tags.','','7.28'),(3940,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','translate admin strings','','7.28'),(3941,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','translate user-defined strings','','7.28'),(3942,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','Administer views','','7.28'),(3943,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','Access the views administration pages.','','7.28'),(3944,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','Bypass views access control','','7.28'),(3945,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','Bypass access control when accessing views.','','7.28'),(3946,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','administer views','','7.28'),(3947,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','access all views','','7.28'),(3948,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','Administer Advanced Forum','','7.28'),(3949,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','View Advanced Forum statistics','','7.28'),(3950,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','View last edited notice','','7.28'),(3951,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','administer advanced forum','','7.28'),(3952,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','view forum statistics','','7.28'),(3953,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','view last edited notice','','7.28'),(3954,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','Administer features','','7.28'),(3955,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','Perform administration tasks on features.','','7.28'),(3956,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','Manage features','','7.28'),(3957,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','View, enable and disable features.','','7.28'),(3958,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','Generate features','','7.28'),(3959,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','Allow feature exports to be generated and written directly to site.','','7.28'),(3960,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','administer features','','7.28'),(3961,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','generate features','','7.28'),(3962,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','manage features','','7.28'),(3963,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','Access administration menu','','7.28'),(3964,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','Display the administration menu at the top of each page.','','7.28'),(3965,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','Flush caches','','7.28'),(3966,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','Access links to flush caches in the administration menu.','','7.28'),(3967,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','Display Drupal links','','7.28'),(3968,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','Provide Drupal.org links in the administration menu.','','7.28'),(3969,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','access administration menu','','7.28'),(3970,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','display drupal links','','7.28'),(3971,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','flush caches','','7.28'),(3972,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','permission','','7.28'),(3973,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','active','','7.28'),(3974,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','blocked','','7.28'),(3975,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','Show only users where','','7.28'),(3976,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','Username','','7.34'),(3977,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','Unblock the selected users','','7.28'),(3978,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','Block the selected users','','7.28'),(3979,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','Cancel the selected user accounts','','7.28'),(3980,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','Add a role to the selected users','','7.28'),(3981,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','Remove a role from the selected users','','7.28'),(3982,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','@time ago','','7.28'),(3983,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','@count weeks','','7.34'),(3984,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','No people available.','','7.28'),(3985,'/weebpal/forum-plus/fr/user/2/edit?destination=admin%2Fpeople&render=overlay','default','Spaces are allowed; punctuation is not allowed except for periods, hyphens, apostrophes, and underscores.','','7.28'),(3986,'/weebpal/forum-plus/fr/user/2/edit?destination=admin%2Fpeople&render=overlay','default','E-mail address','','7.32'),(3987,'/weebpal/forum-plus/fr/user/2/edit?destination=admin%2Fpeople&render=overlay','default','A valid e-mail address. All e-mails from the system will be sent to this address. The e-mail address is not made public and will only be used if you wish to receive a new password or wish to receive certain news or notifications by e-mail.','','7.28'),(3988,'/weebpal/forum-plus/fr/user/2/edit?destination=admin%2Fpeople&render=overlay','default','To change the current user password, enter the new password in both fields.','','7.28'),(3989,'/weebpal/forum-plus/fr/user/2/edit?destination=admin%2Fpeople&render=overlay','default','Password','','7.34'),(3990,'/weebpal/forum-plus/fr/user/2/edit?destination=admin%2Fpeople&render=overlay','default','Request new password via e-mail.','','7.34'),(3991,'/weebpal/forum-plus/fr/user/2/edit?destination=admin%2Fpeople&render=overlay','default','Enter your current password to change the %mail or %pass. !request_new.','','7.28'),(3992,'/weebpal/forum-plus/fr/user/2/edit?destination=admin%2Fpeople&render=overlay','default','Notify user of new account','','7.28'),(3993,'/weebpal/forum-plus/fr/user/2/edit?destination=admin%2Fpeople&render=overlay','default','Signature settings','','7.28'),(3994,'/weebpal/forum-plus/fr/user/2/edit?destination=admin%2Fpeople&render=overlay','default','Your signature will be publicly displayed at the end of your comments.','','7.28'),(3995,'/weebpal/forum-plus/fr/user/2/edit?destination=admin%2Fpeople&render=overlay','default','Delete picture','','7.28'),(3996,'/weebpal/forum-plus/fr/user/2/edit?destination=admin%2Fpeople&render=overlay','default','Check this box to delete your current picture.','','7.28'),(3997,'/weebpal/forum-plus/fr/user/2/edit?destination=admin%2Fpeople&render=overlay','default','Upload picture','','7.28'),(3998,'/weebpal/forum-plus/fr/user/2/edit?destination=admin%2Fpeople&render=overlay','default','Your virtual face or picture. Pictures larger than @dimensions pixels will be scaled down.','','7.28'),(3999,'/weebpal/forum-plus/fr/user/2/edit?destination=admin%2Fpeople&render=overlay','default','Cancel account','','7.28'),(4000,'/weebpal/forum-plus/fr/user/2/edit?destination=admin%2Fpeople&render=overlay','default','Contact settings','','7.28'),(4001,'/weebpal/forum-plus/fr/user/2/edit?destination=admin%2Fpeople&render=overlay','default','Personal contact form','','7.28'),(4002,'/weebpal/forum-plus/fr/user/2/edit?destination=admin%2Fpeople&render=overlay','default','Allow other users to contact you via a <a href=\"@url\">personal contact form</a> which keeps your e-mail address hidden. Note that some privileged users such as site administrators are still able to contact you even if you choose to disable this feature.','','7.28'),(4003,'/weebpal/forum-plus/fr/user/2/edit?destination=admin%2Fpeople&render=overlay','default','Locale settings','','7.28'),(4004,'/weebpal/forum-plus/fr/user/2/edit?destination=admin%2Fpeople&render=overlay','default','Time zone','','7.32'),(4005,'/weebpal/forum-plus/fr/user/2/edit?destination=admin%2Fpeople&render=overlay','default','- None selected -','','7.28'),(4006,'/weebpal/forum-plus/fr/user/2/edit?destination=admin%2Fpeople&render=overlay','default','Select the desired local time and time zone. Dates and times throughout this site will be displayed using this time zone.','','7.28'),(4007,'/weebpal/forum-plus/fr/user/2/edit?destination=admin%2Fpeople&render=overlay','default','Confirm password','','7.28'),(4008,'/weebpal/forum-plus/fr/user/2/edit?destination=admin%2Fpeople&render=overlay','default','Password strength:','','7.28'),(4009,'/weebpal/forum-plus/fr/user/2/edit?destination=admin%2Fpeople&render=overlay','default','To make your password stronger:','','7.28'),(4010,'/weebpal/forum-plus/fr/user/2/edit?destination=admin%2Fpeople&render=overlay','default','Make it at least 6 characters','','7.28'),(4011,'/weebpal/forum-plus/fr/user/2/edit?destination=admin%2Fpeople&render=overlay','default','Add lowercase letters','','7.28'),(4012,'/weebpal/forum-plus/fr/user/2/edit?destination=admin%2Fpeople&render=overlay','default','Add uppercase letters','','7.28'),(4013,'/weebpal/forum-plus/fr/user/2/edit?destination=admin%2Fpeople&render=overlay','default','Add numbers','','7.28'),(4014,'/weebpal/forum-plus/fr/user/2/edit?destination=admin%2Fpeople&render=overlay','default','Add punctuation','','7.28'),(4015,'/weebpal/forum-plus/fr/user/2/edit?destination=admin%2Fpeople&render=overlay','default','Make it different from your username','','7.28'),(4016,'/weebpal/forum-plus/fr/user/2/edit?destination=admin%2Fpeople&render=overlay','default','yes','','7.28'),(4017,'/weebpal/forum-plus/fr/user/2/edit?destination=admin%2Fpeople&render=overlay','default','no','','7.28'),(4018,'/weebpal/forum-plus/fr/user/2/edit?destination=admin%2Fpeople&render=overlay','default','Weak','','7.28'),(4019,'/weebpal/forum-plus/fr/user/2/edit?destination=admin%2Fpeople&render=overlay','default','Fair','','7.28'),(4020,'/weebpal/forum-plus/fr/user/2/edit?destination=admin%2Fpeople&render=overlay','default','Good','','7.28'),(4021,'/weebpal/forum-plus/fr/user/2/edit?destination=admin%2Fpeople&render=overlay','default','Strong','','7.28'),(4022,'/weebpal/forum-plus/fr/user/2/edit?destination=admin%2Fpeople&render=overlay','default','Passwords match:','','7.28'),(4023,'/weebpal/forum-plus/fr/user/2/edit?destination=admin%2Fpeople&render=overlay','default','Track page visits','','7.34'),(4024,'/weebpal/forum-plus/fr/user/2/edit?destination=admin%2Fpeople&render=overlay&render=overlay','default','Node type','','7.34'),(4025,'/weebpal/forum-plus/fr/user/2/edit?destination=admin%2Fpeople&render=overlay&render=overlay','default','Text length','','7.32'),(4026,'/weebpal/forum-plus/fr/user/2/edit?destination=admin%2Fpeople&render=overlay&render=overlay','default','Drupal path','','7.32'),(4027,'/weebpal/forum-plus/fr/user/2/edit?destination=admin%2Fpeople&render=overlay&render=overlay','default','File path','','7.32'),(4028,'/weebpal/forum-plus/fr/user/2/edit?destination=admin%2Fpeople&render=overlay&render=overlay','default','Day of week','','7.32'),(4029,'/weebpal/forum-plus/fr/user/2/edit?destination=admin%2Fpeople&render=overlay&render=overlay','default','Theme','','7.32'),(4030,'/weebpal/forum-plus/fr/user/2/edit?destination=admin%2Fpeople&render=overlay&render=overlay','default','Country','','7.32'),(4031,'/weebpal/forum-plus/fr/user/2/edit?destination=admin%2Fpeople&render=overlay&render=overlay','default','Date type','','7.32'),(4032,'/weebpal/forum-plus/fr/user/2/edit?destination=admin%2Fpeople&render=overlay&render=overlay','default','Time interval','','7.32'),(4033,'/weebpal/forum-plus/fr/user/2/edit?destination=admin%2Fpeople&render=overlay&render=overlay','default','User mail text','','7.32'),(4034,'/weebpal/forum-plus/fr/user/2/edit?destination=admin%2Fpeople&render=overlay&render=overlay','default','Properties','','7.32'),(4035,'/weebpal/forum-plus/fr/user/2/edit?destination=admin%2Fpeople&render=overlay&render=overlay','default','Multiple','','7.32'),(4036,'/weebpal/forum-plus/fr/user/2/edit?destination=admin%2Fpeople&render=overlay&render=overlay','default','Mail text','','7.32'),(4037,'/weebpal/forum-plus/fr/user/2/edit?destination=admin%2Fpeople&render=overlay&render=overlay','default','Select','','7.32'),(4038,'/weebpal/forum-plus/fr/user/2/edit?destination=admin%2Fpeople&render=overlay&render=overlay','default','Unknown','','7.32'),(4039,'/weebpal/forum-plus/fr/user/2/edit?destination=admin%2Fpeople&render=overlay&render=overlay','default','Mail parts','','7.32'),(4040,'/weebpal/forum-plus/fr/user/2/edit?destination=admin%2Fpeople&render=overlay&render=overlay','default','Formatted text','','7.32'),(4041,'/weebpal/forum-plus/fr/user/2/edit?destination=admin%2Fpeople&render=overlay&render=overlay','default','Multiple language','','7.32'),(4042,'/weebpal/forum-plus/fr/user/2/edit?destination=admin%2Fpeople&render=overlay&render=overlay','default','@type field.','','7.32'),(4043,'/weebpal/forum-plus/fr/user/2/edit?destination=admin%2Fpeople&render=overlay&render=overlay','default','The changes have been saved.','','7.28'),(4044,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','1 min','','7.34'),(4045,'/weebpal/forum-plus/fr/activity-stream','default','Render message (Get text)','','7.39'),(4046,'/weebpal/forum-plus/fr/activity-stream','default','User uid','','7.39'),(4047,'/weebpal/forum-plus/fr/admin/structure/views?render=overlay','default','Storage','','7.28'),(4048,'/weebpal/forum-plus/fr/admin/structure/views?render=overlay','default','Enabled, name','','7.28'),(4049,'/weebpal/forum-plus/fr/admin/structure/views?render=overlay','default','All storage','','7.28'),(4050,'/weebpal/forum-plus/fr/admin/structure/views?render=overlay','default','In database','','7.28'),(4051,'/weebpal/forum-plus/fr/admin/structure/views?render=overlay','default','In code','','7.28'),(4052,'/weebpal/forum-plus/fr/admin/structure/views?render=overlay','default','Database overriding code','','7.28'),(4053,'/weebpal/forum-plus/fr/admin/structure/views?render=overlay','default','All status','','7.28'),(4054,'/weebpal/forum-plus/fr/admin/structure/views?render=overlay','default','All types','','7.28'),(4055,'/weebpal/forum-plus/fr/admin/structure/views?render=overlay','default','All tags','','7.28'),(4056,'/weebpal/forum-plus/fr/admin/structure/views?render=overlay','default','No tags','','7.28'),(4057,'/weebpal/forum-plus/fr/admin/structure/views?render=overlay','default','All displays','','7.28'),(4058,'/weebpal/forum-plus/fr/admin/structure/views?render=overlay','default','Display','','7.28'),(4059,'/weebpal/forum-plus/fr/admin/structure/views?render=overlay','default','open','','7.28'),(4060,'/weebpal/forum-plus/fr/admin/structure/views?render=overlay','default','Machine name: ','','7.28'),(4061,'/weebpal/forum-plus/fr/admin/structure/views?render=overlay','default','Displays','','7.28'),(4062,'/weebpal/forum-plus/fr/admin/structure/views?render=overlay','default','View all FAQs','','7.34'),(4063,'/weebpal/forum-plus/fr/admin/structure/views?render=overlay','default','Recent FAQs','','7.34'),(4064,'/weebpal/forum-plus/fr/admin/structure/views?render=overlay','default','Random FAQs','','7.34'),(4065,'/weebpal/forum-plus/fr/admin/structure/views?render=overlay','default','Top rated content','','7.28'),(4066,'/weebpal/forum-plus/fr/admin/structure/views?render=overlay','default','Your votes','','7.28'),(4067,'/weebpal/forum-plus/fr/admin/structure/views?render=overlay','default','If you install the advanced help module from !href, Views will provide more and better help. <a href=\"@hide\">You can disable this message at the Views settings page.</a>','','7.28'),(4068,'/weebpal/forum-plus/fr/admin/structure/views?render=overlay','default','View name','','7.28'),(4069,'/weebpal/forum-plus/fr/admin/structure/views?render=overlay','default','No views match the search criteria.','','7.28'),(4070,'/weebpal/forum-plus/fr/admin/structure/views/view/activity_stream/edit?render=overlay','default','Click on an item to edit that item\'s details.','','7.28'),(4071,'/weebpal/forum-plus/fr/admin/structure/views/view/activity_stream/edit?render=overlay','default','* All changes are stored temporarily. Click Save to make your changes permanent. Click Cancel to discard your changes.','','7.28'),(4072,'/weebpal/forum-plus/fr/admin/structure/views/view/activity_stream/edit?render=overlay','default','Modify the display(s) of your view below or add new displays.','','7.28'),(4073,'/weebpal/forum-plus/fr/admin/structure/views/view/activity_stream/edit?render=overlay','default','Cancel','','7.28'),(4074,'/weebpal/forum-plus/fr/admin/structure/views/view/activity_stream/edit?render=overlay','default','edit view name/description','','7.28'),(4075,'/weebpal/forum-plus/fr/admin/structure/views/view/activity_stream/edit?render=overlay','default','analyze view','','7.28'),(4076,'/weebpal/forum-plus/fr/admin/structure/views/view/activity_stream/edit?render=overlay','default','clone view','','7.28'),(4077,'/weebpal/forum-plus/fr/admin/structure/views/view/activity_stream/edit?render=overlay','default','export view','','7.28'),(4078,'/weebpal/forum-plus/fr/admin/structure/views/view/activity_stream/edit?render=overlay','default','reorder displays','','7.28'),(4079,'/weebpal/forum-plus/fr/admin/structure/views/view/activity_stream/edit?render=overlay','default','delete view','','7.28'),(4080,'/weebpal/forum-plus/fr/admin/structure/views/view/activity_stream/edit?render=overlay','default','Add !display','','7.28'),(4081,'/weebpal/forum-plus/fr/admin/structure/views/view/activity_stream/edit?render=overlay','default','@display_title details','','7.28'),(4082,'/weebpal/forum-plus/fr/admin/structure/views/view/activity_stream/edit?render=overlay','default','view @display','','7.28'),(4083,'/weebpal/forum-plus/fr/admin/structure/views/view/activity_stream/edit?render=overlay','default','Go to the real page for this display','','7.28'),(4084,'/weebpal/forum-plus/fr/admin/structure/views/view/activity_stream/edit?render=overlay','default','clone @display_title','','7.28'),(4085,'/weebpal/forum-plus/fr/admin/structure/views/view/activity_stream/edit?render=overlay','default','delete @display_title','','7.28'),(4086,'/weebpal/forum-plus/fr/admin/structure/views/view/activity_stream/edit?render=overlay','default','disable @display_title','','7.28'),(4087,'/weebpal/forum-plus/fr/admin/structure/views/view/activity_stream/edit?render=overlay','default','Display name','','7.28'),(4088,'/weebpal/forum-plus/fr/admin/structure/views/view/activity_stream/edit?render=overlay','default','Filters','','7.28'),(4089,'/weebpal/forum-plus/fr/admin/structure/views/view/activity_stream/edit?render=overlay','default','Pager','','7.28'),(4090,'/weebpal/forum-plus/fr/admin/structure/views/view/activity_stream/edit?render=overlay','default','Exposed form','','7.28'),(4091,'/weebpal/forum-plus/fr/admin/structure/views/view/activity_stream/edit?render=overlay','default','Other','','7.28'),(4092,'/weebpal/forum-plus/fr/admin/structure/views/view/activity_stream/edit?render=overlay','default','Machine Name','','7.28'),(4093,'/weebpal/forum-plus/fr/admin/structure/views/view/activity_stream/edit?render=overlay','default','Change the machine name of this display.','','7.28'),(4094,'/weebpal/forum-plus/fr/admin/structure/views/view/activity_stream/edit?render=overlay','default','No comment','','7.28'),(4095,'/weebpal/forum-plus/fr/admin/structure/views/view/activity_stream/edit?render=overlay','default','Comment or document this display.','','7.28'),(4096,'/weebpal/forum-plus/fr/admin/structure/views/view/activity_stream/edit?render=overlay','default','Change the title that this display will use.','','7.28'),(4097,'/weebpal/forum-plus/fr/admin/structure/views/view/activity_stream/edit?render=overlay','default','Change the way content is formatted.','','7.28'),(4098,'/weebpal/forum-plus/fr/admin/structure/views/view/activity_stream/edit?render=overlay','default','Change settings for this format','','7.28'),(4099,'/weebpal/forum-plus/fr/admin/structure/views/view/activity_stream/edit?render=overlay','default','Change the way each row in the view is styled.','','7.28'),(4100,'/weebpal/forum-plus/fr/admin/structure/views/view/activity_stream/edit?render=overlay','default','Change settings for this style','','7.28'),(4101,'/weebpal/forum-plus/fr/admin/structure/views/view/activity_stream/edit?render=overlay','default','Use AJAX','','7.28'),(4102,'/weebpal/forum-plus/fr/admin/structure/views/view/activity_stream/edit?render=overlay','default','Change whether or not this display will use AJAX.','','7.28'),(4103,'/weebpal/forum-plus/fr/admin/structure/views/view/activity_stream/edit?render=overlay','default','Hide attachments in summary','','7.28'),(4104,'/weebpal/forum-plus/fr/admin/structure/views/view/activity_stream/edit?render=overlay','default','Change whether or not to display attachments when displaying a contextual filter summary.','','7.28'),(4105,'/weebpal/forum-plus/fr/admin/structure/views/view/activity_stream/edit?render=overlay','default','Hide contextual links','','7.28'),(4106,'/weebpal/forum-plus/fr/admin/structure/views/view/activity_stream/edit?render=overlay','default','Change whether or not to display contextual links for this view.','','7.28'),(4107,'/weebpal/forum-plus/fr/admin/structure/views/view/activity_stream/edit?render=overlay','default','Paged, @count items','','7.28'),(4108,'/weebpal/forum-plus/fr/admin/structure/views/view/activity_stream/edit?render=overlay','default','Use pager','','7.28'),(4109,'/weebpal/forum-plus/fr/admin/structure/views/view/activity_stream/edit?render=overlay','default','Change this display\'s pager setting.','','7.28'),(4110,'/weebpal/forum-plus/fr/admin/structure/views/view/activity_stream/edit?render=overlay','default','Change settings for this pager type.','','7.28'),(4111,'/weebpal/forum-plus/fr/admin/structure/views/view/activity_stream/edit?render=overlay','default','More link','','7.28'),(4112,'/weebpal/forum-plus/fr/admin/structure/views/view/activity_stream/edit?render=overlay','default','Specify whether this display will provide a \"more\" link.','','7.28'),(4113,'/weebpal/forum-plus/fr/admin/structure/views/view/activity_stream/edit?render=overlay','default','Group results together','','7.28'),(4114,'/weebpal/forum-plus/fr/admin/structure/views/view/activity_stream/edit?render=overlay','default','Count DISTINCT','','7.28'),(4115,'/weebpal/forum-plus/fr/admin/structure/views/view/activity_stream/edit?render=overlay','default','Sum','','7.28'),(4116,'/weebpal/forum-plus/fr/admin/structure/views/view/activity_stream/edit?render=overlay','default','Average','','7.28'),(4117,'/weebpal/forum-plus/fr/admin/structure/views/view/activity_stream/edit?render=overlay','default','Minimum','','7.28'),(4118,'/weebpal/forum-plus/fr/admin/structure/views/view/activity_stream/edit?render=overlay','default','Maximum','','7.28'),(4119,'/weebpal/forum-plus/fr/admin/structure/views/view/activity_stream/edit?render=overlay','default','Standard deviation','','7.28'),(4120,'/weebpal/forum-plus/fr/admin/structure/views/view/activity_stream/edit?render=overlay','default','Use aggregation','','7.28'),(4121,'/weebpal/forum-plus/fr/admin/structure/views/view/activity_stream/edit?render=overlay','default','Allow grouping and aggregation (calculation) of fields.','','7.28'),(4122,'/weebpal/forum-plus/fr/admin/structure/views/view/activity_stream/edit?render=overlay','default','Query settings','','7.28'),(4123,'/weebpal/forum-plus/fr/admin/structure/views/view/activity_stream/edit?render=overlay','default','Allow to set some advanced settings for the query plugin','','7.28'),(4124,'/weebpal/forum-plus/fr/admin/structure/views/view/activity_stream/edit?render=overlay','default','Current user\'s language','','7.28'),(4125,'/weebpal/forum-plus/fr/admin/structure/views/view/activity_stream/edit?render=overlay','default','Default site language','','7.28'),(4126,'/weebpal/forum-plus/fr/admin/structure/views/view/activity_stream/edit?render=overlay','default','Field Language','','7.28'),(4127,'/weebpal/forum-plus/fr/admin/structure/views/view/activity_stream/edit?render=overlay','default','All fields which support translations will be displayed in the selected language.','','7.28'),(4128,'/weebpal/forum-plus/fr/admin/structure/views/view/activity_stream/edit?render=overlay','default','Unrestricted','','7.28'),(4129,'/weebpal/forum-plus/fr/admin/structure/views/view/activity_stream/edit?render=overlay','default','Specify access control type for this display.','','7.28'),(4130,'/weebpal/forum-plus/fr/admin/structure/views/view/activity_stream/edit?render=overlay','default','Caching','','7.32'),(4131,'/weebpal/forum-plus/fr/admin/structure/views/view/activity_stream/edit?render=overlay','default','Specify caching type for this display.','','7.28'),(4132,'/weebpal/forum-plus/fr/admin/structure/views/view/activity_stream/edit?render=overlay','default','Exposed form in block','','7.28'),(4133,'/weebpal/forum-plus/fr/admin/structure/views/view/activity_stream/edit?render=overlay','default','Allow the exposed form to appear in a block instead of the view.','','7.28'),(4134,'/weebpal/forum-plus/fr/admin/structure/views/view/activity_stream/edit?render=overlay','default','Exposed form style','','7.28'),(4135,'/weebpal/forum-plus/fr/admin/structure/views/view/activity_stream/edit?render=overlay','default','Select the kind of exposed filter to use.','','7.28'),(4136,'/weebpal/forum-plus/fr/admin/structure/views/view/activity_stream/edit?render=overlay','default','Exposed form settings for this exposed form style.','','7.28'),(4137,'/weebpal/forum-plus/fr/admin/structure/views/view/activity_stream/edit?render=overlay','default','CSS class','','7.28'),(4138,'/weebpal/forum-plus/fr/admin/structure/views/view/activity_stream/edit?render=overlay','default','Change the CSS class name(s) that will be added to this display.','','7.28'),(4139,'/weebpal/forum-plus/fr/admin/structure/views/view/activity_stream/edit?render=overlay','default','Get information on how to theme this display','','7.28'),(4140,'/weebpal/forum-plus/fr/admin/structure/views/view/activity_stream/edit?render=overlay','default','Page settings','','7.28'),(4141,'/weebpal/forum-plus/fr/admin/structure/views/view/activity_stream/edit?render=overlay','default','Normal: @title','','7.28'),(4142,'/weebpal/forum-plus/fr/admin/structure/views/view/activity_stream/edit?render=overlay','default','Rearrange','','7.28'),(4143,'/weebpal/forum-plus/fr/admin/structure/views/view/activity_stream/edit?render=overlay','default','!group: !title','','7.28'),(4144,'/weebpal/forum-plus/fr/admin/structure/views/view/activity_stream/edit?render=overlay','default','And/Or, Rearrange','','7.28'),(4145,'/weebpal/forum-plus/fr/admin/structure/views/view/activity_stream/edit?render=overlay','default','Auto preview','','7.28'),(4146,'/weebpal/forum-plus/fr/admin/structure/views/view/activity_stream/edit?render=overlay','default','Preview with contextual filters:','','7.28'),(4147,'/weebpal/forum-plus/fr/admin/structure/views/view/activity_stream/edit?render=overlay','default','Separate contextual filter values with a \"/\". For example, %example.','','7.28'),(4148,'/weebpal/forum-plus/fr/admin/structure/views/view/activity_stream/edit?render=overlay','default','Update preview','','7.28'),(4149,'/weebpal/forum-plus/fr/admin/structure/views/view/activity_stream/edit?render=overlay','default',':','','7.28'),(4150,'/weebpal/forum-plus/fr/admin/structure/views/view/activity_stream/preview/page/ajax','default','Edit @section','','7.28'),(4151,'/weebpal/forum-plus/fr/admin/structure/views/view/activity_stream/preview/page/ajax','default','Add new','','7.28'),(4152,'/weebpal/forum-plus/fr/admin/appearance?render=overlay','default','Screenshot for !theme theme','','7.32'),(4153,'/weebpal/forum-plus/fr/admin/appearance?render=overlay','default','Settings for !theme theme','','7.32'),(4154,'/weebpal/forum-plus/fr/admin/appearance?render=overlay','default','Disable !theme theme','','7.32'),(4155,'/weebpal/forum-plus/fr/admin/appearance?render=overlay','default','Set default','','7.32'),(4156,'/weebpal/forum-plus/fr/admin/appearance?render=overlay','default','Set !theme as default theme','','7.32'),(4157,'/weebpal/forum-plus/fr/admin/appearance?render=overlay','default','default theme','','7.32'),(4158,'/weebpal/forum-plus/fr/admin/appearance?render=overlay','default','Enable !theme theme','','7.32'),(4159,'/weebpal/forum-plus/fr/admin/appearance?render=overlay','default','Enable and set default','','7.32'),(4160,'/weebpal/forum-plus/fr/admin/appearance?render=overlay','default','Enable !theme as default theme','','7.32'),(4161,'/weebpal/forum-plus/fr/admin/appearance?render=overlay','default','Enabled themes','','7.32'),(4162,'/weebpal/forum-plus/fr/admin/appearance?render=overlay','default','Disabled themes','','7.32'),(4163,'/weebpal/forum-plus/fr/admin/appearance?render=overlay','default','Administration theme','','7.32'),(4164,'/weebpal/forum-plus/fr/admin/appearance?render=overlay','default','Choose \"Default theme\" to always use the same theme as the rest of the site.','','7.32'),(4165,'/weebpal/forum-plus/fr/admin/appearance?render=overlay','default','Use the administration theme when editing or creating content','','7.32'),(4166,'/weebpal/forum-plus/fr/admin/appearance?render=overlay','default','no screenshot','','7.32'),(4167,'/weebpal/forum-plus/fr/admin/appearance?render=overlay','default','Theme for the Companies','','7.32'),(4168,'/weebpal/forum-plus/fr/admin/appearance?render=overlay','default','A flexible, recolorable theme with many regions.','','7.32'),(4169,'/weebpal/forum-plus/fr/admin/appearance?render=overlay','default','A simple one-column, tableless, fluid width administration theme.','','7.32'),(4170,'/weebpal/forum-plus/fr/admin/appearance?render=overlay','default','A multi-column theme which can be configured to modify colors and switch between fixed and fluid width layouts.','','7.32'),(4171,'/weebpal/forum-plus/fr/admin/appearance?render=overlay','default','Based on the Blue Lagoon colors of Garland.','','7.32'),(4172,'/weebpal/forum-plus/fr/admin/appearance?render=overlay','default','This theme demonstrates Drupal\'s default HTML markup and CSS styles. To learn how to build your own theme and override Drupal\'s default code, see the <a href=\"http://drupal.org/theme-guide\">Theming Guide</a>.','','7.32'),(4173,'/weebpal/forum-plus/fr/admin/appearance?render=overlay','default','Set and configure the default theme for your website.  Alternative <a href=\"@themes\">themes</a> are available.','','7.32'),(4174,'/weebpal/forum-plus/fr/admin/people?render=overlay','default','1 sec','','7.32'),(4175,'/weebpal/forum-plus/fr/admin/people/permissions?render=overlay','default','Warning: Give to trusted roles only; this permission has security implications.','','7.28'),(4176,'/weebpal/forum-plus/fr/admin/people/permissions?render=overlay','default','Save permissions','','7.28'),(4177,'/weebpal/forum-plus/fr/admin/people/permissions?render=overlay','default','Filter list by module. Use the query operator \"perm\" to filter by permission, e.g., perm:access.','','7.28'),(4178,'/weebpal/forum-plus/fr/admin/people/permissions?render=overlay','default','Filter list','','7.28'),(4179,'/weebpal/forum-plus/fr/admin/people/permissions?render=overlay','default','Permissions let you control what users can do and see on your site. You can define a specific set of permissions for each role. (See the <a href=\"@role\">Roles</a> page to create a role). Two important roles to consider are Authenticated Users and Administrators. Any permissions granted to the Authenticated Users role will be given to any user who can log into your site. You can make any role the Administrator role for the site, meaning this will be granted all new permissions automatically. You can do this on the <a href=\"@settings\">User Settings</a> page. You should be careful to ensure that only trusted users are given this access and level of control of your site.','','7.28'),(4180,'/weebpal/forum-plus/fr/admin/structure/messages?render=overlay','default','manage fields','','7.28'),(4181,'/weebpal/forum-plus/fr/admin/structure/messages?render=overlay','default','manage display','','7.28'),(4182,'/weebpal/forum-plus/fr/admin/structure/messages?render=overlay','default','clone','','7.28'),(4183,'/weebpal/forum-plus/fr/admin/structure/messages?render=overlay','default','revert','','7.28'),(4184,'/weebpal/forum-plus/fr/admin/structure/messages?render=overlay','default','export','','7.28'),(4185,'/weebpal/forum-plus/fr/admin/structure/messages?render=overlay','default','None.','','7.28'),(4186,'/weebpal/forum-plus/fr/admin/structure/messages?render=overlay','default','This configuration is provided by a module, but has been changed.','','7.28'),(4187,'/weebpal/forum-plus/fr/admin/config/system/message?render=overlay','default','Purge settings','','7.28'),(4188,'/weebpal/forum-plus/fr/admin/config/system/message?render=overlay','default','Purge messages','','7.28'),(4189,'/weebpal/forum-plus/fr/admin/config/system/message?render=overlay','default','When enabled, old messages will be deleted.','','7.28'),(4190,'/weebpal/forum-plus/fr/admin/config/system/message?render=overlay','default','Messages quota','','7.28'),(4191,'/weebpal/forum-plus/fr/admin/config/system/message?render=overlay','default','Maximal (approximate) amount of messages.','','7.28'),(4192,'/weebpal/forum-plus/fr/admin/config/system/message?render=overlay','default','Purge messages older than','','7.28'),(4193,'/weebpal/forum-plus/fr/admin/config/system/message?render=overlay','default','Maximal message age in days.','','7.28'),(4194,'/weebpal/forum-plus/fr/admin/config/system/message?render=overlay','default','Auto delete messages referencing the following entities','','7.28'),(4195,'/weebpal/forum-plus/fr/admin/config/system/message?render=overlay','default','Messages that reference entities of these types will be deleted when the referenced entity gets deleted.','','7.28'),(4196,'/weebpal/forum-plus/fr/admin/config/system/message?render=overlay','default','Other settings','','7.28'),(4197,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Provides permission-based access control for actions. Used by Views Bulk Operations.','','7.28'),(4198,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Share buttons by AddToAny, including the AddToAny universal sharing button, Facebook, Twitter, Google+, Pinterest, and over 100 more on the <a href=\'http://www.addtoany.com/\' target=\'_blank\'>AddToAny</a> platform.','','7.28'),(4199,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Administration and debugging functionality for developers and site builders.','','7.28'),(4200,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','@module (<span class=\"admin-enabled\">enabled</span>)','','7.28'),(4201,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','The administration menu module provides a dropdown menu arranged for one- or two-click access to most administrative tasks and other common destinations (to users with the proper permissions). Administration menu also displays the number of anonymous and authenticated users, and allows modules to add their own custom menu items. Integration with the menu varies from module to module; the contributed module <a href=\"@drupal\">Devel</a>, for instance, makes strong use of the administration menu module to provide quick access to development tools.','','7.28'),(4202,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','The administration menu <a href=\"@settings\">settings page</a> allows you to modify some elements of the menu\'s behavior and appearance. Since the appearance of the menu is dependent on your site theme, substantial customizations require modifications to your site\'s theme and CSS files. See the advanced module README.txt file for more information on theme and CSS customizations.','','7.28'),(4203,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','The menu items displayed in the administration menu depend upon the actual permissions of the viewer. First, the administration menu is only displayed to users in roles with the <em>Access administration menu</em> (admin_menu module) permission. Second, a user must be a member of a role with the <em>Access administration pages</em> (system module) permission to view administrative links. And, third, only currently permitted links are displayed; for example, if a user is not a member of a role with the permissions <em>Administer permissions</em> (user module) and <em>Administer users</em> (user module), the <em>User management</em> menu item is not displayed.','','7.28'),(4204,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Configure permissions','','7.28'),(4205,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Provides a dropdown menu to most administrative tasks and other common destinations (to users with the proper permissions).','','7.28'),(4206,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','A better Toolbar.','','7.28'),(4207,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Enables the look and feel of other popular forum software.','','7.28'),(4208,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Aggregates syndicated content (RSS, RDF, and Atom feeds).','','7.28'),(4209,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Gathers information from core and user related contrib modules and displays it in a template.','','7.28'),(4210,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','@module (<span class=\"admin-disabled\">disabled</span>)','','7.28'),(4211,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Create Bean (Block Entities)','','7.28'),(4212,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','@module (<span class=\"admin-missing\">missing</span>)','','7.28'),(4213,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Integrates the Bean module with the Entitycache module','','7.28'),(4214,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Add the ability to create Block Types in the UI','','7.28'),(4215,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Integrate all blocks with beans.','','7.28'),(4216,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','View Bean (Block Entities) Usage','','7.28'),(4217,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Allow deploying bean blocks through Deploy and UUID modules.','','7.28'),(4218,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Enables creating custom jump menus programmatically via the CTools API.','','7.28'),(4219,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','About','','7.28'),(4220,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','The Block module allows you to create boxes of content, which are rendered into an area, or region, of one or more pages of a website. The core Seven administration theme, for example, implements the regions \"Content\", \"Help\", \"Dashboard main\", and \"Dashboard sidebar\", and a block may appear in any one of these regions. The <a href=\"@blocks\">Blocks administration page</a> provides a drag-and-drop interface for assigning a block to a region, and for controlling the order of blocks within regions. For more information, see the online handbook entry for <a href=\"@block\">Block module</a>.','','7.28'),(4221,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Uses','','7.28'),(4222,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Positioning content','','7.28'),(4223,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','When working with blocks, remember that all themes do <em>not</em> implement the same regions, or display regions in the same way. Blocks are positioned on a per-theme basis. Users with the <em>Administer blocks</em> permission can disable blocks. Disabled blocks are listed on the <a href=\"@blocks\">Blocks administration page</a>, but are not displayed in any region.','','7.28'),(4224,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Controlling visibility','','7.28'),(4225,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Blocks can be configured to be visible only on certain pages, only to users of certain roles, or only on pages displaying certain <a href=\"@content-type\">content types</a>. Administrators can also allow specific blocks to be enabled or disabled by users when they edit their <a href=\"@user\">My account</a> page. Some dynamic blocks, such as those generated by modules, will be displayed only on certain pages.','','7.28'),(4226,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Creating custom blocks','','7.28'),(4227,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Users with the <em>Administer blocks</em> permission can <a href=\"@block-add\">add custom blocks</a>, which are then listed on the <a href=\"@blocks\">Blocks administration page</a>. Once created, custom blocks behave just like default and module-generated blocks.','','7.28'),(4228,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Controls the visual building blocks a page is constructed with. Blocks are boxes of content rendered into an area, or region, of a web page.','','7.28'),(4229,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Allows assigning CSS classes to blocks.','','7.28'),(4230,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','This module provides support for multilingual blocks.','','7.28'),(4231,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','You can set up a language for a block or define it as translatable:','','7.28'),(4232,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Blocks with a language will be displayed only in pages with that language.','','7.28'),(4233,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Translatable blocks can be translated using the localization interface.','','7.28'),(4234,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Enables language selector for blocks and optional block translation.','','7.28'),(4235,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','The Blog module allows registered users to maintain an online journal, or <em>blog</em>. Blogs are made up of individual <em>blog entries</em>. By default, the blog entries are displayed by creation time in descending order, with comments enabled, and are promoted to the site\'s front page. For more information, see the online handbook entry for <a href=\'@blog\'>Blog module</a>.','','7.28'),(4236,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Single-user blogs','','7.28'),(4237,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Each user\'s blog entries are automatically displayed with a link to the user\'s main blog page. You can create as many single-user blogs as you have site users with permission to create blog content.','','7.28'),(4238,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Multi-user blogs','','7.28'),(4239,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Blog entries from each single-user blog are also aggregated into one central multi-user blog, which displays the blog content of all users in a single listing.','','7.28'),(4240,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','There is an optional <em>Blogs</em> menu item added to the Navigation menu, which displays all blogs available on your site, and a <em>My blog</em> item displaying the current user\'s blog entries.','','7.28'),(4241,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','The Blog module also creates a default <em>Recent blog posts</em> block that may be enabled at the <a href=\"@blocks\">blocks administration page</a>.','','7.28'),(4242,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Enables multi-user blogs.','','7.28'),(4243,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','The Book module is used for creating structured, multi-page content, such as site resource guides, manuals, and wikis. It allows you to create content that has chapters, sections, subsections, or any similarly-tiered structure. For more information, see the online handbook entry for <a href=\"@book\">Book module</a>.','','7.28'),(4244,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Adding and managing book content','','7.28'),(4245,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','You can assign separate permissions for <em>creating</em>, <em>editing</em>, and <em>deleting</em> book content, as well as <em>adding content to books</em>, and <em>creating new books</em>. Users with the <em>Administer book outlines</em> permission can add <em>any</em> type of content to a book by selecting the appropriate book outline while editing the content. They can also view a list of all books, and edit and rearrange section titles on the <a href=\"@admin-book\">Book administration page</a>.','','7.28'),(4246,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Book pages have a default book-specific navigation block. This navigation block contains links that lead to the previous and next pages in the book, and to the level above the current page in the book\'s structure. This block can be enabled on the <a href=\'@admin-block\'>Blocks administration page</a>. For book pages to show up in the book navigation, they must be added to a book outline.','','7.28'),(4247,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Collaboration','','7.28'),(4248,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Books can be created collaboratively, as they allow users with appropriate permissions to add pages into existing books, and add those pages to a custom table of contents menu.','','7.28'),(4249,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Printing books','','7.28'),(4250,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Users with the <em>View printer-friendly books</em> permission can select the <em>printer-friendly version</em> link visible at the bottom of a book page\'s content to generate a printer-friendly display of the page and all of its subsections.','','7.28'),(4251,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Allows users to create and organize related content in an outline.','','7.28'),(4252,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Performs bulk exporting of data objects known about by Chaos tools.','','7.28'),(4253,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Date and Calendar Documentation','','7.28'),(4254,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','<p>View complete documentation at !link.</p>','','7.28'),(4255,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Views plugin to display views containing dates as Calendars.','','7.28'),(4256,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Base CAPTCHA module for adding challenges to arbitrary forms.','','7.28'),(4257,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','A library of helpful tools by Merlin of Chaos.','','7.28'),(4258,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Shows how to use the power of Chaos AJAX.','','7.28'),(4259,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Shows how an external module can provide ctools plugins (for Panels, etc.).','','7.28'),(4260,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','The Color module allows users with the <em>Administer site configuration</em> permission to quickly and easily change the color scheme of themes that have been built to be compatible with it. For more information, see the online handbook entry for <a href=\"@color\">Color module</a>.','','7.28'),(4261,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Changing colors','','7.28'),(4262,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Using the Color module allows you to easily change the color of links, backgrounds, text, and other theme elements. To change the color settings for a compatible theme, select the <em>Settings</em> link for your theme on the <a href=\'@configure\'>Themes administration page</a>. If you don\'t see a color picker on that page, then your theme is not compatible with the color module. If you are sure that the theme does indeed support the color module, but the color picker does not appear, then <a href=\'@troubleshoot\'>follow these troubleshooting procedures</a>.','','7.28'),(4263,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','The Color module saves a modified copy of the theme\'s specified stylesheets in the files directory. This means that if you make any manual changes to your theme\'s stylesheet, <em>you must save your color settings again, even if they haven\'t changed</em>. This step is required because the module stylesheets (in the files directory) need to be recreated to include your changes.','','7.28'),(4264,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Allows administrators to change the color scheme of compatible themes.','','7.28'),(4265,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','A light-weight, customizable lightbox plugin for jQuery 1.4.3+.','','7.28'),(4266,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','The Comment module allows users to comment on site content, set commenting defaults and permissions, and moderate comments. For more information, see the online handbook entry for <a href=\"@comment\">Comment module</a>.','','7.28'),(4267,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Default and custom settings','','7.28'),(4268,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Each <a href=\'@content-type\'>content type</a> can have its own default comment settings configured as: <em>Open</em> to allow new comments, <em>Hidden</em> to hide existing comments and prevent new comments, or <em>Closed</em> to view existing comments, but prevent new comments. These defaults will apply to all new content created (changes to the settings on existing content must be done manually). Other comment settings can also be customized per content type, and can be overridden for any given item of content. When a comment has no replies, it remains editable by its author, as long as the author has a user account and is logged in.','','7.28'),(4269,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Comment approval','','7.28'),(4270,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Comments from users who have the <em>Skip comment approval</em> permission are published immediately. All other comments are placed in the <a href=\'@comment-approval\'>Unapproved comments</a> queue, until a user who has permission to <em>Administer comments</em> publishes or deletes them. Published comments can be bulk managed on the <a href=\'@admin-comment\'>Published comments</a> administration page.','','7.28'),(4271,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Allows users to comment on and discuss published content.','','7.28'),(4272,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','The Contact module allows visitors to contact site administrators and other users. Users specify a subject, write their message, and can have a copy of their message sent to their own e-mail address. For more information, see the online handbook entry for <a href=\"@contact\">Contact module</a>.','','7.28'),(4273,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','User contact forms','','7.28'),(4274,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Site users can be contacted with a user contact form that keeps their e-mail address private. Users may enable or disable their personal contact forms by editing their <em>My account</em> page. If enabled, a <em>Contact</em> tab leads to a personal contact form displayed on their user profile. Site administrators are still able to use the contact form, even if has been disabled. The <em>Contact</em> tab is not shown when you view your own profile.','','7.28'),(4275,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Site-wide contact forms','','7.28'),(4276,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','The <a href=\"@contact\">Contact page</a> provides a simple form for users with the <em>Use the site-wide contact form</em> permission to send comments, feedback, or other requests. You can create categories for directing the contact form messages to a set of defined recipients. Common categories for a business site, for example, might include \"Website feedback\" (messages are forwarded to website administrators) and \"Product information\" (messages are forwarded to members of the sales department). E-mail addresses defined within a category are not displayed publicly.','','7.28'),(4277,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','When the site-wide contact form is enabled, a link in the main <em>Navigation</em> menu is created, but the link is disabled by default. This menu link can be enabled on the <a href=\'@menu\'>Menus administration page</a>.','','7.28'),(4278,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Customization','','7.28'),(4279,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','If you would like additional text to appear on the site-wide or personal contact page, use a block. You can create and edit blocks on the <a href=\"@blocks\">Blocks administration page</a>.','','7.28'),(4280,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Enables the use of both personal and site-wide contact forms.','','7.28'),(4281,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Makes your site-wide contact forms available as Drupal Blocks.','','7.28'),(4282,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Creates individual contact pages from contact form categories.','','7.28'),(4283,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Makes contact forms additions available for translation.','','7.28'),(4284,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Makes contact categories and replies available for translation.','','7.28'),(4285,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Allows content to be translated into different languages.','','7.28'),(4286,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','The Contextual links module displays links related to regions of pages on your site to users with <em>access contextual links</em> permission. For more information, see the online handbook entry for <a href=\"@contextual\">Contextual links module</a>.','','7.28'),(4287,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Displaying contextual links','','7.28'),(4288,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Contextual links are supplied by modules, to give you quick access to tasks associated with regions of pages on your site. For instance, if you have a custom menu block displayed in a sidebar of your site, the Blocks and Menus modules will supply links to configure the block and edit the menu. The Contextual links module collects these links into a list for display by your theme, and also adds JavaScript code to the page to hide the links initially, and display them when your mouse hovers over the block.','','7.28'),(4289,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Provides contextual links to perform actions related to elements on a page.','','7.28'),(4290,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','A module that provides a FAPI / Field country element and a simple wrapper module to store / update country data.','','7.28'),(4291,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','A configuration utility module to assist storing country specific data.','','7.28'),(4292,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Countries example module','','7.28'),(4293,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Translation of countries.','','7.28'),(4294,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Create custom, exportable, reusable content panes for applications like Panels.','','7.28'),(4295,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Create custom, exportable, reusable access rulesets for applications like Panels.','','7.28'),(4296,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','The Dashboard module provides a <a href=\"@dashboard\">Dashboard page</a> in the administrative interface for organizing administrative tasks and navigation, and tracking information within your site. The Dashboard page contains blocks, which you can add to and arrange using the drag-and-drop interface that appears when you click on the <em>Customize dashboard</em> link. Within this interface, blocks that are not primarily used for site administration do not appear by default, but can be added via the <em>Add other blocks</em> link. For more information, see the online handbook entry for <a href=\"@handbook\">Dashboard module</a>.','','7.28'),(4297,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Tracking user activity','','7.28'),(4298,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','By enabling blocks such as <em>Who\'s online</em> and <em>Who\'s new</em>, site users can track who is logged in and new user signups at a centralized location.','','7.28'),(4299,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Tracking content activity','','7.28'),(4300,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','By enabling blocks such as <em>Recent blog posts</em>, <em>New forum topics</em> and <em>Recent comments</em>, site users can view newly added site content at a glance.','','7.28'),(4301,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Provides a dashboard page in the administrative interface for organizing administrative tasks and tracking information within your site.','','7.28'),(4302,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','The Database logging module logs system events in the Drupal database. For more information, see the online handbook entry for the <a href=\"@dblog\">Database logging module</a>.','','7.28'),(4303,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Monitoring your site','','7.28'),(4304,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','The Database logging module allows you to view an event log on the <a href=\"@dblog\">Recent log messages</a> page. The log is a chronological list of recorded events containing usage data, performance data, errors, warnings and operational information. Administrators should check the log on a regular basis to ensure their site is working properly.','','7.28'),(4305,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Debugging site problems','','7.28'),(4306,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','In case of errors or problems with the site, the <a href=\"@dblog\">Recent log messages</a> page can be useful for debugging, since it shows the sequence of events. The log messages include usage information, warnings, and errors.','','7.28'),(4307,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Logs and records system events to the database.','','7.28'),(4308,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Makes date/time fields available.','','7.28'),(4309,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Adds \'All Day\' functionality to date fields, including an \'All Day\' theme and \'All Day\' checkboxes for the Date select and Date popup widgets.','','7.28'),(4310,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','A Date API that can be used by other modules.','','7.28'),(4311,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Adds an option to the Context module to set a context condition based on the value of a date field.','','7.28'),(4312,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Examples of migrating with the Date module','','7.28'),(4313,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Enables jquery popup calendars and time entry widgets for selecting dates and times.','','7.28'),(4314,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','A Date Repeat API to calculate repeating dates and times from iCal rules.','','7.28'),(4315,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Creates the option of Repeating date fields and manages Date fields that use the Date Repeat API.','','7.28'),(4316,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Tools to import and auto-create dates and calendars.','','7.28'),(4317,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Views integration for date fields and date functionality.','','7.28'),(4318,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Enables modules to work with any entity type and to provide entities.','','7.28'),(4319,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Provides a field that can reference other entities.','','7.28'),(4320,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Provides some example code for implementing Entity Reference behaviors.','','7.28'),(4321,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Provides token replacements for all properties that have no tokens and are known to the entity API.','','7.28'),(4322,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Provides a Views display type that can be attached to entities.','','7.28'),(4323,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Provides bootstrap component to contents.','','7.28'),(4324,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Provides feature management for Drupal.','','7.28'),(4325,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','The Field module allows custom data fields to be defined for <em>entity</em> types (entities include content items, comments, user accounts, and taxonomy terms). The Field module takes care of storing, loading, editing, and rendering field data. Most users will not interact with the Field module directly, but will instead use the <a href=\"@field-ui-help\">Field UI module</a> user interface. Module developers can use the Field API to make new entity types \"fieldable\" and thus allow fields to be attached to them. For more information, see the online handbook entry for <a href=\"@field\">Field module</a>.','','7.28'),(4326,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Enabling field types','','7.28'),(4327,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','The Field module provides the infrastructure for fields and field attachment; the field types and input widgets themselves are provided by additional modules. Some of the modules are required; the optional modules can be enabled from the <a href=\"@modules\">Modules administration page</a>. Drupal core includes the following field type modules: Number (required), Text (required), List (required), Taxonomy (optional), Image (optional), and File (optional); the required Options module provides input widgets for other field modules. Additional fields and widgets may be provided by contributed modules, which you can find in the <a href=\"@contrib\">contributed module section of Drupal.org</a>. Currently enabled field and input widget modules:','','7.28'),(4328,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Managing field data storage','','7.28'),(4329,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Developers of field modules can either use the default <a href=\"@sql-store\">Field SQL storage module</a> to store data for their fields, or a contributed or custom module developed using the <a href=\"@storage-api\">field storage API</a>.','','7.28'),(4330,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Field API to add fields to entities like nodes and users.','','7.28'),(4331,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','The field collection module provides a field, to which any number of fields can be attached. See the <a href=\"@field-help\">Field module help page</a> for more information about fields.','','7.28'),(4332,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Provides a field collection field, to which any number of fields can be attached.','','7.28'),(4333,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Provides the ability to group your fields on both form and display.','','7.28'),(4334,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','The Field SQL storage module stores field data in the database. It is the default field storage module; other field storage mechanisms may be available as contributed modules. See the <a href=\"@field-help\">Field module help page</a> for more information about fields.','','7.28'),(4335,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Stores field data in an SQL database.','','7.28'),(4336,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Translate field properties','','7.28'),(4337,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','The Field UI module provides an administrative user interface (UI) for attaching and managing fields. Fields can be defined at the content-type level for content items and comments, at the vocabulary level for taxonomy terms, and at the site level for user accounts. Other modules may also enable fields to be defined for their data. Field types (text, image, number, etc.) are defined by modules, and collected and managed by the <a href=\"@field\">Field module</a>. For more information, see the online handbook entry for <a href=\"@field_ui\" target=\"_blank\">Field UI module</a>.','','7.28'),(4338,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Planning fields','','7.28'),(4339,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','There are several decisions you will need to make before defining a field for content, comments, etc.:','','7.28'),(4340,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','What the field will be called','','7.28'),(4341,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','A field has a <em>label</em> (the name displayed in the user interface) and a <em>machine name</em> (the name used internally). The label can be changed after you create the field, if needed, but the machine name cannot be changed after you have created the field.','','7.28'),(4342,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','What type of data the field will store','','7.28'),(4343,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Each field can store one type of data (text, number, file, etc.). When you define a field, you choose a particular <em>field type</em>, which corresponds to the type of data you want to store. The field type cannot be changed after you have created the field.','','7.28'),(4344,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','How the data will be input and displayed','','7.28'),(4345,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Each field type has one or more available <em>widgets</em> associated with it; each widget provides a mechanism for data input when you are editing (text box, select list, file upload, etc.). Each field type also has one or more display options, which determine how the field is displayed to site visitors. The widget and display options can be changed after you have created the field.','','7.28'),(4346,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','How many values the field will store','','7.28'),(4347,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','You can store one value, a specific maximum number of values, or an unlimited number of values in each field. For example, an employee identification number field might store a single number, whereas a phone number field might store multiple phone numbers. This setting can be changed after you have created the field, but if you reduce the maximum number of values, you may lose information.','','7.28'),(4348,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Reusing fields','','7.28'),(4349,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Once you have defined a field, you can reuse it. For example, if you define a custom image field for one content type, and you need to have an image field with the same parameters on another content type, you can add the same field to the second content type, in the <em>Add existing field</em> area of the user interface. You could also add this field to a taxonomy vocabulary, comments, user accounts, etc.','','7.28'),(4350,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Some settings of a reused field are unique to each use of the field; others are shared across all places you use the field. For example, the label of a text field is unique to each use, while the setting for the number of values is shared.','','7.28'),(4351,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','There are two main reasons for reusing fields. First, reusing fields can save you time over defining new fields. Second, reusing fields also allows you to display, filter, group, and sort content together by field across content types. For example, the contributed Views module allows you to create lists and tables of content. So if you use the same field on multiple content types, you can create a View containing all of those content types together displaying that field, sorted by that field, and/or filtered by that field.','','7.28'),(4352,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Fields on content items','','7.28'),(4353,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Fields on content items are defined at the content-type level, on the <em>Manage fields</em> tab of the content type edit page (which you can reach from the <a href=\"@types\">Content types page</a>). When you define a field for a content type, each content item of that type will have that field added to it. Some fields, such as the Title and Body, are provided for you when you create a content type, or are provided on content types created by your installation profile.','','7.28'),(4354,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Fields on taxonomy terms','','7.28'),(4355,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Fields on taxonomy terms are defined at the taxonomy vocabulary level, on the <em>Manage fields</em> tab of the vocabulary edit page (which you can reach from the <a href=\"@taxonomy\">Taxonomy page</a>). When you define a field for a vocabulary, each term in that vocabulary will have that field added to it. For example, you could define an image field for a vocabulary to store an icon with each term.','','7.28'),(4356,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Fields on user accounts','','7.28'),(4357,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Fields on user accounts are defined on a site-wide basis on the <a href=\"@fields\">Manage fields tab</a> of the <a href=\"@accounts\">Account settings</a> page. When you define a field for user accounts, each user account will have that field added to it. For example, you could add a long text field to allow users to include a biography.','','7.28'),(4358,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Fields on comments','','7.28'),(4359,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Fields on comments are defined at the content-type level, on the <em>Comment fields</em> tab of the content type edit page (which you can reach from the <a href=\"@types\">Content types page</a>). When you add a field for comments, each comment on a content item of that type will have that field added to it. For example, you could add a website field to the comments on forum posts, to allow forum commenters to add a link to their website.','','7.28'),(4360,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','User interface for the Field API.','','7.28'),(4361,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','The File module defines a <em>File</em> field type for the Field module, which lets you manage and validate uploaded files attached to content on your site (see the <a href=\"@field-help\">Field module help page</a> for more information about fields). For more information, see the online handbook entry for <a href=\"@file\">File module</a>.','','7.28'),(4362,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Attaching files to content','','7.28'),(4363,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','The File module allows users to attach files to content (e.g., PDF files, spreadsheets, etc.), when a <em>File</em> field is added to a given content type using the <a href=\"@fieldui-help\">Field UI module</a>. You can add validation options to your File field, such as specifying a maximum file size and allowed file extensions.','','7.28'),(4364,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Managing attachment display','','7.28'),(4365,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','When you attach a file to content, you can specify whether it is <em>listed</em> or not. Listed files are displayed automatically in a section at the bottom of your content; non-listed files are available for embedding in your content, but are not included in the list at the bottom.','','7.28'),(4366,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Managing file locations','','7.28'),(4367,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','When you create a File field, you can specify a directory where the files will be stored, which can be within either the <em>public</em> or <em>private</em> files directory. Files in the public directory can be accessed directly through the web server; when public files are listed, direct links to the files are used, and anyone who knows a file\'s URL can download the file. Files in the private directory are not accessible directly through the web server; when private files are listed, the links are Drupal path requests. This adds to server load and download time, since Drupal must start up and resolve the path for each file download request, but allows for access restrictions.','','7.28'),(4368,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Defines a file field type.','','7.28'),(4369,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','The Filter module allows administrators to configure text formats. A text format defines the HTML tags, codes, and other input allowed in content and comments, and is a key feature in guarding against potentially damaging input from malicious users. For more information, see the online handbook entry for <a href=\"@filter\">Filter module</a>.','','7.28'),(4370,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Configuring text formats','','7.28'),(4371,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Configure text formats on the <a href=\"@formats\">Text formats page</a>. <strong>Improper text format configuration is a security risk</strong>. To ensure security, untrusted users should only have access to text formats that restrict them to either plain text or a safe set of HTML tags, since certain HTML tags can allow embedding malicious links or scripts in text. More trusted registered users may be granted permission to use less restrictive text formats in order to create rich content.','','7.28'),(4372,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Applying filters to text','','7.28'),(4373,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Each text format uses filters to manipulate text, and most formats apply several different filters to text in a specific order. Each filter is designed for a specific purpose, and generally either adds, removes, or transforms elements within user-entered text before it is displayed. A filter does not change the actual content, but instead, modifies it temporarily before it is displayed. One filter may remove unapproved HTML tags, while another automatically adds HTML to make URLs display as clickable links.','','7.28'),(4374,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Defining text formats','','7.28'),(4375,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','One format is included by default: <em>Plain text</em> (which removes all HTML tags). Additional formats may be created by your installation profile when you install Drupal, and more can be created by an administrator on the <a href=\"@text-formats\">Text formats page</a>.','','7.28'),(4376,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Choosing a text format','','7.28'),(4377,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Users with access to more than one text format can use the <em>Text format</em> fieldset to choose between available text formats when creating or editing multi-line content. Administrators can define the text formats available to each user role, and control the order of formats listed in the <em>Text format</em> fieldset on the <a href=\"@text-formats\">Text formats page</a>.','','7.28'),(4378,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Filters content in preparation for display.','','7.28'),(4379,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Enables fivestar ratings on content, users, etc.','','7.28'),(4380,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Integrate the FlexSlider 2 library with Drupal','','7.28'),(4381,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Sample implementation of FlexSlider','','7.28'),(4382,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Adds a display mode in Fields for FlexSlider','','7.28'),(4383,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Adds a Views style plugin for FlexSlider','','7.28'),(4384,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Iconic font designed for use with Twitter Bootstrap.','','7.28'),(4385,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','The Forum module lets you create threaded discussion forums with functionality similar to other message board systems. Forums are useful because they allow community members to discuss topics with one another while ensuring those conversations are archived for later reference. In a forum, users post topics and threads in nested hierarchies, allowing discussions to be categorized and grouped. The forum hierarchy consists of:','','7.28'),(4386,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Optional containers (for example, <em>Support</em>), which can hold:','','7.28'),(4387,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Forums (for example, <em>Installing Drupal</em>), which can hold:','','7.28'),(4388,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Forum topics submitted by users (for example, <em>How to start a Drupal 6 Multisite</em>), which start discussions and are starting points for:','','7.28'),(4389,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Threaded comments submitted by users (for example, <em>You have these options...</em>).','','7.28'),(4390,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','For more information, see the online handbook entry for <a href=\"@forum\">Forum module</a>.','','7.28'),(4391,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Setting up forum structure','','7.28'),(4392,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Visit the <a href=\"@forums\">Forums page</a> to set up containers and forums to hold your discussion topics.','','7.28'),(4393,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Starting a discussion','','7.28'),(4394,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','The <a href=\"@create-topic\">Forum topic</a> link on the <a href=\"@content-add\">Add new content</a> page creates the first post of a new threaded discussion, or thread.','','7.28'),(4395,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Enabling the Forum module provides a default <em>Forums</em> menu item in the navigation menu that links to the <a href=\"@forums\">Forums page</a>.','','7.28'),(4396,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Moving forum topics','','7.28'),(4397,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','A forum topic (and all of its comments) may be moved between forums by selecting a different forum while editing a forum topic. When moving a forum topic between forums, the <em>Leave shadow copy</em> option creates a link in the original forum pointing to the new location.','','7.28'),(4398,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Locking and disabling comments','','7.28'),(4399,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Selecting <em>Closed</em> under <em>Comment settings</em> while editing a forum topic will lock (prevent new comments on) the thread. Selecting <em>Hidden</em> under <em>Comment settings</em> while editing a forum topic will hide all existing comments on the thread, and prevent new ones.','','7.28'),(4400,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Provides discussion forums.','','7.28'),(4401,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','This module allows users with the \'administer faq\' permission to create question and answer pairs which will be displayed on the faq page.  The faq page is automatically generated from the FAQ nodes configured and the layout of this page can be modified on the settings page.  Users will need the \'view faq page\' permission in order to view the faq page.','','7.28'),(4402,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','To create a question and answer, the user must create a \'FAQ\' node (Create content >> FAQ).  This screen allows the user to edit the question and answer text.  If the \'Taxonomy\' module is enabled and there are some terms configured for the FAQ node type, it will also be possible to put the questions into different categories when editing.','','7.28'),(4403,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','The \'Frequently Asked Questions\' settings configuration screen will allow users with \'administer faq\' permissions to specify different layouts of the questions and answers.','','7.28'),(4404,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','All users with \'view faq page\' permissions will be able to view the generated FAQ page.','','7.28'),(4405,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Manages configuration of questions for a FAQ page.','','7.28'),(4406,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Provides a jquery gallery CCK formatter for imagefield','','7.28'),(4407,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Allows your site to be tracked by Google Analytics by adding a Javascript tracking code to every page.','','7.28'),(4408,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Integrate Gravatar pictures registered at Gravatar.com in Drupal sites','','7.28'),(4409,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','The Help module provides <a href=\"@help-page\">Help reference pages</a> and context-sensitive advice to guide you through the use and configuration of modules. It is a starting point for the online <a href=\"@handbook\">Drupal handbooks</a>. The handbooks contain more extensive and up-to-date information, are annotated with user-contributed comments, and serve as the definitive reference point for all Drupal documentation. For more information, see the online handbook entry for the <a href=\"@help\">Help module</a>.','','7.28'),(4410,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Providing a help reference','','7.28'),(4411,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','The Help module displays explanations for using each module listed on the main <a href=\"@help\">Help reference page</a>.','','7.28'),(4412,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Providing context-sensitive help','','7.28'),(4413,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','The Help module displays context-sensitive advice and explanations on various pages.','','7.28'),(4414,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Manages the display of online help.','','7.28'),(4415,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','The Image module allows you to manipulate images on your website. It exposes a setting for using the <em>Image toolkit</em>, allows you to configure <em>Image styles</em> that can be used for resizing or adjusting images on display, and provides an <em>Image</em> field for attaching images to content. For more information, see the online handbook entry for <a href=\"@image\">Image module</a>.','','7.28'),(4416,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Manipulating images','','7.28'),(4417,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','With the Image module you can scale, crop, resize, rotate and desaturate images without affecting the original image using <a href=\"@image\">image styles</a>. When you change an image style, the module automatically refreshes all created images. Every image style must have a name, which will be used in the URL of the generated images. There are two common approaches to naming image styles (which you use will depend on how the image style is being applied):','','7.28'),(4418,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Based on where it will be used: eg. <em>profile-picture</em>','','7.28'),(4419,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Describing its appearance: eg. <em>square-85x85</em>','','7.28'),(4420,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','After you create an image style, you can add effects: crop, scale, resize, rotate, and desaturate (other contributed modules provide additional effects). For example, by combining effects as crop, scale, and desaturate, you can create square, grayscale thumbnails.','','7.28'),(4421,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Attaching images to content as fields','','7.28'),(4422,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Image module also allows you to attach images to content as fields. To add an image field to a <a href=\'@content-type\'>content type</a>, go to the content type\'s <em>manage fields</em> page, and add a new field of type <em>Image</em>. Attaching images to content this way allows image styles to be applied and maintained, and also allows you more flexibility when theming.','','7.28'),(4423,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Provides image manipulation tools.','','7.28'),(4424,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Provides an image based CAPTCHA.','','7.28'),(4425,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','This module improves support for multilingual content in Drupal sites:','','7.28'),(4426,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Shows content depending on page language.','','7.28'),(4427,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Handles multilingual variables.','','7.28'),(4428,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Extended language option for chosen content types. For these content types transations will be allowed for all defined languages, not only for enabled ones.','','7.28'),(4429,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Provides a block for language selection and two theme functions: <em>i18n_flags</em> and <em>i18n_links</em>.','','7.28'),(4430,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','This is the base module for several others adding different features:','','7.28'),(4431,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Multilingual menu items.','','7.28'),(4432,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Multilingual taxonomy adds a language field for taxonomy vocabularies and terms.','','7.28'),(4433,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','For more information, see the online handbook entry for <a href=\"@i18n\">Internationalization module</a>.','','7.28'),(4434,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Extends Drupal support for multilingual features.','','7.28'),(4435,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Create jQuery-based carousel rotators.','','7.28'),(4436,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Update jQuery and jQuery UI to a more recent version.','','7.28'),(4437,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','This module manages language icons for multilingual sites:','','7.28'),(4438,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Automatically adds icons to language links.','','7.28'),(4439,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Provides related theme functions.','','7.28'),(4440,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','For more information, please see <a href=\"@handbook\">the online handbook section</a>.','','7.28'),(4441,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Adds icons to language links.','','7.28'),(4442,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','The module will populate a new block named \"Language switcher dropdown\" under <a href=\"@block_admin\">blocks admin page</a>.','','7.28'),(4443,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','For more information on blocks, please see <a href=\"@blocks_help\">block help section</a>.','','7.28'),(4444,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','The module Provides same functionality as the core language switcher block but with a better look&feel.','','7.28'),(4445,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','For more information on multilingual sites, please see <a href=\"@locale_help\">locale help section</a>.','','7.28'),(4446,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Marghoob Suleman Custom skin','','7.28'),(4447,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','To create custom skins for Marghoob Suleman output follow these steps:','','7.28'),(4448,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Copy the sample file \"ldsCustom.css.sample\" that you can find in the folder where you installed the module -normally \"sites/all/modules/lang_dropdown/msdropdown/css/msdropdown/ldsCustom.css.sample\"- into the css folder of Marghoob Suleman library path -normally \"sites/all/libraries/ms-Dropdown/css/msdropdown/\"-.','','7.28'),(4449,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Rename the file to ldsCustom.css.','','7.28'),(4450,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Edit the CSS file to your needs.','','7.28'),(4451,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','On the block Marghoob Suleman Settings select to use a custom skin with name ldsCustom.','','7.28'),(4452,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','The name of the custom skin does not neccesarely has to be ldsCustom but if you use other name you must change the name of the corresponding CSS file and the name of the class on all CSS rules on that file. For example if you want \"myskin\" as the name of your custom skin then you must rename the sample CSS file to \"myskin.css\" and edit the CSS so all the rules start with .myskin instead of .ldsCustom.','','7.28'),(4453,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','ddSlick Custom skin','','7.28'),(4454,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','To create custom skins for ddSlick output follow these steps:','','7.28'),(4455,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Copy the sample file \"ddsCustom.css.sample\" that you can find in the folder where you installed the module -normally \"sites/all/modules/lang_dropdown/ddslick/ddsCustom.css.sample\"- into the css folder of ddSlick library path -normally \"sites/all/libraries/ddSlick/\"-.','','7.28'),(4456,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Rename the file to ddsCustom.css.','','7.28'),(4457,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','On the block ddSlick Settings select to use a custom skin with name ddsCustom.','','7.28'),(4458,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','The name of the custom skin does not neccesarely has to be ddsCustom but if you use other name you must change the name of the corresponding CSS file and the name of the class on all CSS rules on that file. For example if you want \"myskin\" as the name of your custom skin then you must rename the sample CSS file to \"myskin.css\" and edit the CSS so all the rules start with .myskin instead of .ddsCustom.','','7.28'),(4459,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Provides a dropdown select to switch between available languages.','','7.28'),(4460,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','This module adds new configuration options to allow you to hide languages for specific roles in your language switcher blocks. Both in \"Language switcher\" blocks provided by locale module and \"Language switcher dropdown\" blocks provided by language switcher dropdown module. Go to <a href=\"@block_admin\">blocks admin page</a> to configure one of those blocks.','','7.28'),(4461,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','To disable a language just use the checkbox for the corresponding role. Take in mind that a language would be hidden from a user if it is hidden for all roles of the user. For example an adminitrator has both authenticated user and adminitrator roles and if the language is only hidden for one of those roles the administrator would be still able to see the language on the switcher.','','7.28'),(4462,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Allow to hide specific languages from the switcher for certain roles.','','7.28'),(4463,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Allows version-dependent and shared usage of external libraries.','','7.28'),(4464,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Defines simple link field types.','','7.28'),(4465,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','The List module defines various fields for storing a list of items, for use with the Field module. Usually these items are entered through a select list, checkboxes, or radio buttons. See the <a href=\"@field-help\">Field module help page</a> for more information about fields.','','7.28'),(4466,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Defines list field types. Use with Options to create selection lists.','','7.28'),(4467,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','The Locale module allows your Drupal site to be presented in languages other than the default English, and to be multilingual. The Locale module works by maintaining a database of translations, and examining text as it is about to be displayed. When a translation of the text is available in the language to be displayed, the translation is displayed rather than the original text. When a translation is unavailable, the original text is displayed, and then stored for review by a translator. For more information, see the online handbook entry for <a href=\"@locale\">Locale module</a>.','','7.28'),(4468,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Translating interface text','','7.28'),(4469,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Translations of text in the Drupal interface may be provided by:','','7.28'),(4470,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Translating within your site, using the Locale module\'s integrated <a href=\'@translate\'>translation interface</a>.','','7.28'),(4471,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Importing files from a set of existing translations, known as a translation package. A translation package enables the display of a specific version of Drupal in a specific language, and contains files in the Gettext Portable Object (<em>.po</em>) format. Although not all languages are available for every version of Drupal, translation packages for many languages are available for download from the <a href=\"@translations\">Drupal translations page</a>.','','7.28'),(4472,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','If an existing translation package does not meet your needs, the Gettext Portable Object (<em>.po</em>) files within a package may be modified, or new <em>.po</em> files may be created, using a desktop Gettext editor. The Locale module\'s <a href=\'@import\'>import</a> feature allows the translated strings from a new or modified <em>.po</em> file to be added to your site. The Locale module\'s <a href=\'@export\'>export</a> feature generates files from your site\'s translated strings, that can either be shared with others or edited offline by a Gettext translation editor.','','7.28'),(4473,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Configuring a multilingual site','','7.28'),(4474,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Language negotiation allows your site to automatically change language based on the domain or path used for each request. Users may (optionally) select their preferred language on their <em>My account</em> page, and your site can be configured to honor a web browser\'s preferred language settings. Site content can be translated using the <a href=\'@content-help\'>Content translation module</a>.','','7.28'),(4475,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Adds language handling functionality and enables the translation of the user interface to languages other than English.','','7.28'),(4476,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Manage Multiple Terms','','7.28'),(4477,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','The Menu module provides an interface for managing menus. A menu is a hierarchical collection of links, which can be within or external to the site, generally used for navigation. Each menu is rendered in a block that can be enabled and positioned through the <a href=\"@blocks\">Blocks administration page</a>. You can view and manage menus on the <a href=\"@menus\">Menus administration page</a>. For more information, see the online handbook entry for the <a href=\"@menu\">Menu module</a>.','','7.28'),(4478,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Managing menus','','7.28'),(4479,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Users with the <em>Administer menus and menu items</em> permission can add, edit and delete custom menus on the <a href=\"@menu\">Menus administration page</a>. Custom menus can be special site menus, menus of external links, or any combination of internal and external links. You may create an unlimited number of additional menus, each of which will automatically have an associated block. By selecting <em>list links</em>, you can add, edit, or delete links for a given menu. The links listing page provides a drag-and-drop interface for controlling the order of links, and creating a hierarchy within the menu.','','7.28'),(4480,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Displaying menus','','7.28'),(4481,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','After you have created a menu, you must enable and position the associated block on the <a href=\"@blocks\">Blocks administration page</a>.','','7.28'),(4482,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Allows administrators to customize the site navigation menu.','','7.28'),(4483,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Allows you to use the menu the current page belongs to for the breadcrumb.','','7.28'),(4484,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Supports translatable custom menu items.','','7.28'),(4485,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','A general message logging utility.','','7.28'),(4486,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Message example.','','7.28'),(4487,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Message integration with Organic groups example.','','7.28'),(4488,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','This module use ctools modal feature to open some common forms in a modal window.','','7.28'),(4489,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Filter the modules list.','','7.28'),(4490,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Extended node options for multilingual content','','7.28'),(4491,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Enables multilingual forum, translates names and containers.','','7.28'),(4492,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','API module for multilingual content selection','','7.28'),(4493,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Send emails to subscribed users.','','7.28'),(4494,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','The Node module manages the creation, editing, deletion, settings, and display of the main site content. Content items managed by the Node module are typically displayed as pages on your site, and include a title, some meta-data (author, creation time, content type, etc.), and optional fields containing text or other data (fields are managed by the <a href=\"@field\">Field module</a>). For more information, see the online handbook entry for <a href=\"@node\">Node module</a>.','','7.28'),(4495,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Creating content','','7.28'),(4496,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','When new content is created, the Node module records basic information about the content, including the author, date of creation, and the <a href=\"@content-type\">Content type</a>. It also manages the <em>publishing options</em>, which define whether or not the content is published, promoted to the front page of the site, and/or sticky at the top of content lists. Default settings can be configured for each <a href=\"@content-type\">type of content</a> on your site.','','7.28'),(4497,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Creating custom content types','','7.28'),(4498,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','The Node module gives users with the <em>Administer content types</em> permission the ability to <a href=\"@content-new\">create new content types</a> in addition to the default ones already configured. Creating custom content types allows you the flexibility to add <a href=\"@field\">fields</a> and configure default settings that suit the differing needs of various site content.','','7.28'),(4499,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Administering content','','7.28'),(4500,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','The <a href=\"@content\">Content administration page</a> allows you to review and bulk manage your site content.','','7.28'),(4501,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Creating revisions','','7.28'),(4502,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','The Node module also enables you to create multiple versions of any content, and revert to older versions using the <em>Revision information</em> settings.','','7.28'),(4503,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','User permissions','','7.28'),(4504,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','The Node module makes a number of permissions available for each content type, which can be set by role on the <a href=\"@permissions\">permissions page</a>.','','7.28'),(4505,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Allows content to be submitted to the site and displayed on pages.','','7.28'),(4506,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Allows assigning CSS classes to nodes.','','7.28'),(4507,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','The Number module defines various numeric field types for the Field module. Numbers can be in integer, decimal, or floating-point form, and they can be formatted when displayed. Number fields can be limited to a specific set of input values or to a range of values. See the <a href=\"@field-help\">Field module help page</a> for more information about fields.','','7.28'),(4508,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Defines numeric field types.','','7.28'),(4509,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Allows users to log into your site using OpenID.','','7.28'),(4510,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','The Options module defines checkbox, selection, and other input widgets for the Field module. See the <a href=\"@field-help\">Field module help page</a> for more information about fields.','','7.28'),(4511,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Defines selection, check box and radio button widgets for text and numeric fields.','','7.28'),(4512,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','The Overlay module makes the administration pages on your site display in a JavaScript overlay of the page you were viewing when you clicked the administrative link, instead of replacing the page in your browser window. Use the close link on the overlay to return to the page you were viewing when you clicked the link. For more information, see the online handbook entry for <a href=\"@overlay\">Overlay module</a>.','','7.28'),(4513,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Displays the Drupal administration interface in an overlay.','','7.28'),(4514,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Provides a UI and API to manage pages within the site.','','7.28'),(4515,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Enhanced control over the page title (in the &lt;head> tag).','','7.28'),(4516,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','The Path module allows you to specify an alias, or custom URL, for any existing internal system path. Aliases should not be confused with URL redirects, which allow you to forward a changed or inactive URL to a new URL. In addition to making URLs more readable, aliases also help search engines index content more effectively. Multiple aliases may be used for a single internal system path. To automate the aliasing of paths, you can install the contributed module <a href=\"@pathauto\">Pathauto</a>. For more information, see the online handbook entry for the <a href=\"@path\">Path module</a>.','','7.28'),(4517,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Creating aliases','','7.28'),(4518,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Users with sufficient <a href=\"@permissions\">permissions</a> can create aliases under the <em>URL path settings</em> section when they create or edit content. Some examples of aliases are: ','','7.28'),(4519,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','<em>member/jane-smith</em> aliased to internal path <em>user/123</em>','','7.28'),(4520,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','<em>about-us/team</em> aliased to internal path <em>node/456</em>','','7.28'),(4521,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Managing aliases','','7.28'),(4522,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','The Path module provides a way to search and view a <a href=\"@aliases\">list of all aliases</a> that are in use on your website. Aliases can be added, edited and deleted through this list.','','7.28'),(4523,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Allows users to rename URLs.','','7.28'),(4524,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Define translations for generic paths','','7.28'),(4525,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Provides a mechanism for modules to automatically generate aliases for the content they manage.','','7.28'),(4526,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Maximum alias and component length','','7.28'),(4527,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','The <strong>maximum alias length</strong> and <strong>maximum component length</strong> values default to 100 and have a limit of @max from Pathauto. This length is limited by the length of the \"alias\" column of the url_alias database table. The default database schema for this column is @max. If you set a length that is equal to that of the one set in the \"alias\" column it will cause problems in situations where the system needs to append additional words to the aliased URL. You should enter a value that is the length of the \"alias\" column minus the length of any strings that might get added to the end of the URL. The length of strings that might get added to the end of your URLs depends on which modules you have enabled and on your Pathauto settings. The recommended and default value is 100.','','7.28'),(4528,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','The PHP filter module adds a PHP filter to your site, for use with <a href=\"@filter\">text formats</a>. This filter adds the ability to execute PHP code in any text field that uses a text format (such as the body of a content item or the text of a comment). <a href=\"@php-net\">PHP</a> is a general-purpose scripting language widely-used for web development, and is the language with which Drupal has been developed. For more information, see the online handbook entry for the <a href=\"@php\">PHP filter module</a>.','','7.28'),(4529,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Enabling execution of PHP in text fields','','7.28'),(4530,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','The PHP filter module allows users with the proper permissions to include custom PHP code that will get executed when pages of your site are processed. While this is a powerful and flexible feature if used by a trusted user with PHP experience, it is a significant and dangerous security risk in the hands of a malicious or inexperienced user. Even a trusted user may accidentally compromise the site by entering malformed or incorrect PHP code. Only the most trusted users should be granted permission to use the PHP filter, and all PHP code added through the PHP filter should be carefully examined before use. <a href=\"@php-snippets\">Example PHP snippets</a> can be found on Drupal.org.','','7.28'),(4531,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Allows embedded PHP code/snippets to be evaluated.','','7.28'),(4532,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Allows your site to capture votes on different topics in the form of multiple choice questions.','','7.28'),(4533,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','The Quicktabs module allows you to create blocks of tabbed content. Clicking on the tabs makes the corresponding content display instantly (it uses jQuery). The content for each tabbed section can be a node, view, block or another Quicktabs instance. You can create an unlimited number of Quicktabs instances, each of which will automatically have an associated block.','','7.28'),(4534,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','The <a href=\"@quicktabs\">quicktabs page</a> displays all quicktabs currently available on your site. Create new quicktabs using the <a href=\"@add-quicktab\">add quicktab page</a> (the block containing a new quicktab must also be enabled on the <a href=\"@blocks\">blocks administration page</a>).','','7.28'),(4535,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Render content with tabs and other display styles','','7.28'),(4536,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Adds predefined tab styles to choose from per Quicktabs instance.','','7.28'),(4537,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Flexible voting options for nodes and comments','','7.28'),(4538,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Add an expiration time to rate widgets','','7.28'),(4539,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Add a slider widget type','','7.28'),(4540,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','The RDF module enriches your content with metadata to let other applications (e.g., search engines, aggregators, and so on) better understand its relationships and attributes. This semantically enriched, machine-readable output for Drupal sites uses the <a href=\"@rdfa\">RDFa specification</a> which allows RDF data to be embedded in HTML markup. Other modules can define mappings of their data to RDF terms, and the RDF module makes this RDF data available to the theme. The core Drupal modules define RDF mappings for their data model, and the core Drupal themes output this RDF metadata information along with the human-readable visual information. For more information, see the online handbook entry for <a href=\"@rdf\">RDF module</a>.','','7.28'),(4541,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Enriches your content with metadata to let other applications (e.g. search engines, aggregators) better understand its relationships and attributes.','','7.28'),(4542,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Allows users to have persistent sessions via a checkbox \"Remember me\" on the login form.','','7.28'),(4543,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Adds a \'\'Remember me\'\' checkbox to login forms.','','7.28'),(4544,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','React on events and conditionally evaluate actions.','','7.28'),(4545,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Schedule the execution of Rules components using actions.','','7.28'),(4546,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Allows translating rules.','','7.28'),(4547,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Administrative interface for managing rules.','','7.28'),(4548,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','The Search module provides the ability to index and search for content by exact keywords, and for users by username or e-mail. For more information, see the online handbook entry for <a href=\"@search-module\">Search module</a>.','','7.28'),(4549,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Searching content and users','','7.28'),(4550,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Users with <em>Use search</em> permission can use the search block and <a href=\"@search\">Search page</a>. Users with the <em>View published content</em> permission can search for content containing exact keywords. Users with the <em>View user profiles</em> permission can search for users containing the keyword anywhere in the user name, and users with the <em>Administer users</em> permission can search for users by email address. Additionally, users with <em>Use advanced search</em> permission can find content using more complex search methods and filtering by choosing the <em>Advanced search</em> option on the <a href=\"@search\">Search page</a>.','','7.28'),(4551,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Indexing content with cron','','7.28'),(4552,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','To provide keyword searching, the search engine maintains an index of words found in the content and its fields, along with text added to your content by other modules (such as comments from the core Comment module, and taxonomy terms from the core Taxonomy module). To build and maintain this index, a correctly configured <a href=\"@cron\">cron maintenance task</a> is required. Users with <em>Administer search</em> permission can further configure the cron settings on the <a href=\"@searchsettings\">Search settings page</a>.','','7.28'),(4553,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Content reindexing','','7.28'),(4554,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Content-related actions on your site (creating, editing, or deleting content and comments) automatically cause affected content items to be marked for indexing or reindexing at the next cron run. When content is marked for reindexing, the previous content remains in the index until cron runs, at which time it is replaced by the new content. Unlike content-related actions, actions related to the structure of your site do not cause affected content to be marked for reindexing. Examples of structure-related actions that affect content include deleting or editing taxonomy terms, enabling or disabling modules that add text to content (such as Taxonomy, Comment, and field-providing modules), and modifying the fields or display parameters of your content types. If you take one of these actions and you want to ensure that the search index is updated to reflect your changed site structure, you can mark all content for reindexing by clicking the \"Re-index site\" button on the <a href=\"@searchsettings\">Search settings page</a>. If you have a lot of content on your site, it may take several cron runs for the content to be reindexed.','','7.28'),(4555,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Configuring search settings','','7.28'),(4556,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Indexing behavior can be adjusted using the <a href=\"@searchsettings\">Search settings page</a>. Users with <em>Administer search</em> permission can control settings such as the <em>Number of items to index per cron run</em>, <em>Indexing settings</em> (word length), <em>Active search modules</em>, and <em>Content ranking</em>, which lets you adjust the priority in which indexed content is returned in results.','','7.28'),(4557,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Search block','','7.28'),(4558,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','The Search module includes a default <em>Search form</em> block, which can be enabled and configured on the <a href=\"@blocks\">Blocks administration page</a>. The block is available to users with the <em>Search content</em> permission.','','7.28'),(4559,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Extending Search module','','7.28'),(4560,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','By default, the Search module only supports exact keyword matching in content searches. You can modify this behavior by installing a language-specific stemming module for your language (such as <a href=\"http://drupal.org/project/porterstemmer\">Porter Stemmer</a> for American English), which allows words such as walk, walking, and walked to be matched in the Search module. Another approach is to use a third-party search technology with stemming or partial word matching features built in, such as <a href=\"http://drupal.org/project/apachesolr\">Apache Solr</a> or <a href=\"http://drupal.org/project/sphinx\">Sphinx</a>. These and other <a href=\"@contrib-search\">search-related contributed modules</a> can be downloaded by visiting Drupal.org.','','7.28'),(4561,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Enables site-wide keyword searching.','','7.28'),(4562,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','This plugin places the ShareThis widget on each node.','','7.28'),(4563,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','The Block pulls the URL from the current page and current Drupal title, the node version pulls it from the node title and url.','','7.28'),(4564,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','The block can be placed anywhere on a page, the node is limited to where nodes normally go','','7.28'),(4565,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','The block module is more likely to be compatible with other plugins that use blocks rather than nodes. (Panels works nicely with the block)','','7.28'),(4566,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','For various configuration options please got to <a href=\"@sharethis\">the settings page</a>.','','7.28'),(4567,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','For more information, please visit <a href=\"@help\">help.sharethis.com</a>.','','7.28'),(4568,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Add the <a href=\"http://www.sharethis.com/\">ShareThis</a> widget to nodes on your site.','','7.28'),(4569,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Provides shortcodes filter framework and API (like WP shortcodes)','','7.28'),(4570,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Provides basic shortcode tags like highlight, dropcap, etc.','','7.28'),(4571,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Provides a shortcode tag for embedding a node content into text.','','7.28'),(4572,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Provides easy video embedding to contents. Supports YouTube sharing.','','7.28'),(4573,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','The Shortcut module allows users to create sets of <em>shortcut</em> links to commonly-visited pages of the site. Shortcuts are contained within <em>sets</em>. Each user with <em>Select any shortcut set</em> permission can select a shortcut set created by anyone at the site. For more information, see the online handbook entry for <a href=\"@shortcut\">Shortcut module</a>.','','7.28'),(4574,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Administering shortcuts','','7.28'),(4575,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Users with the <em>Administer shortcuts</em> permission can manage shortcut sets and edit the shortcuts within sets from the <a href=\"@shortcuts\">Shortcuts administration page</a>.','','7.28'),(4576,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Choosing shortcut sets','','7.28'),(4577,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Users with permission to switch shortcut sets can choose a shortcut set to use from the Shortcuts tab of their user account page.','','7.28'),(4578,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Adding and removing shortcuts','','7.28'),(4579,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','The Shortcut module creates an add/remove link for each page on your site; the link lets you add or remove the current page from the currently-enabled set of shortcuts (if your theme displays it and you have permission to edit your shortcut set). The core Seven administration theme displays this link next to the page title, as a small + or - sign. If you click on the + sign, you will add that page to your preferred set of shortcuts. If the page is already part of your shortcut set, the link will be a - sign, and will allow you to remove the current page from your shortcut set.','','7.28'),(4580,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Displaying shortcuts','','7.28'),(4581,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','You can display your shortcuts by enabling the Shortcuts block on the <a href=\"@blocks\">Blocks administration page</a>. Certain administrative modules also display your shortcuts; for example, the core <a href=\"@toolbar-help\">Toolbar module</a> displays them near the top of the page, along with an <em>Edit shortcuts</em> link.','','7.28'),(4582,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Allows users to manage customizable lists of shortcut links.','','7.28'),(4583,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Display a site map.','','7.28'),(4584,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','The Statistics module shows you how often a given page is viewed, who viewed it, the previous page the user visited (referrer URL), and when it was viewed. These statistics are useful in determining how users are visiting and navigating your site. For more information, see the online handbook entry for the <a href=\"@statistics\">Statistics module</a>.','','7.28'),(4585,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Managing logs','','7.28'),(4586,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','To enable collection of statistics, the <em>Enable access log</em> checkbox on the <a href=\"@statistics-settings\">Statistics settings page</a> must be checked. The <em>Discard access logs older than</em> setting on the settings page specifies the length of time entries are kept in the log before they are deleted. This setting requires a correctly configured <a href=\"@cron\">cron maintenance task</a> to run.','','7.28'),(4587,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Viewing site usage','','7.28'),(4588,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','The Statistics module can help you break down details about your users and how they are using the site. The module offers four reports:','','7.28'),(4589,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','<a href=\"@recent-hits\">Recent hits</a> displays information about the latest activity on your site, including the URL and title of the page that was accessed, the user name (if available) and the IP address of the viewer.','','7.28'),(4590,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','<a href=\"@top-referrers\">Top referrers</a> displays where visitors came from (referrer URL).','','7.28'),(4591,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','<a href=\"@top-pages\">Top pages</a> displays a list of pages ordered by how often they were viewed.','','7.28'),(4592,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','<a href=\"@top-visitors\">Top visitors</a> shows you the most active visitors for your site and allows you to ban abusive visitors.','','7.28'),(4593,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Displaying popular content','','7.28'),(4594,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','The module includes a <em>Popular content</em> block that displays the most viewed pages today and for all time, and the last content viewed. To use the block, enable <em>Count content views</em> on the <a href=\"@statistics-settings\">statistics settings page</a>, and then you can enable and configure the block on the <a href=\"@blocks\">blocks administration page</a>.','','7.28'),(4595,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Page view counter','','7.28'),(4596,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','The Statistics module includes a counter for each page that increases whenever the page is viewed. To use the counter, enable <em>Count content views</em> on the <a href=\"@statistics-settings\">statistics settings page</a>, and set the necessary <a href=\"@permissions\">permissions</a> (<em>View content hits</em>) so that the counter is visible to the users.','','7.28'),(4597,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Logs access statistics for your site.','','7.28'),(4598,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','This module adds support for other modules to translate user defined strings. Depending on which modules you have enabled that use this feature you may see different text groups to translate.','','7.28'),(4599,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','This works differently to Drupal standard localization system: The strings will be translated from the <a href=\"@configure-strings\">source language</a>, which defaults to the site default language (it may not be English), so changing the default language may cause all these translations to be broken.','','7.28'),(4600,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','If you are missing strings to translate, use the <a href=\"@refresh-strings\">refresh strings</a> page.','','7.28'),(4601,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Read more on the <em>Internationalization handbook</em>: <a href=\"http://drupal.org/node/313293\">Translating user defined strings</a>.','','7.28'),(4602,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Provides support for translation of user defined strings.','','7.28'),(4603,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Enforces variable values defined by modules that need settings set to operate properly.','','7.28'),(4604,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Create custom styles for applications such as Panels.','','7.28'),(4605,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Synchronizes taxonomy and fields accross translations of the same content.','','7.28'),(4606,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Logs and records system events to syslog.','','7.28'),(4607,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','The System module is integral to the site, and provides basic but extensible functionality for use by other modules and themes. Some integral elements of Drupal are contained in and managed by the System module, including caching, enabling and disabling modules and themes, preparing and displaying the administrative page, and configuring fundamental site settings. A number of key system maintenance operations are also part of the System module. For more information, see the online handbook entry for <a href=\"@system\">System module</a>.','','7.28'),(4608,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Managing modules','','7.28'),(4609,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','The System module allows users with the appropriate permissions to enable and disable modules on the <a href=\"@modules\">Modules administration page</a>. Drupal comes with a number of core modules, and each module provides a discrete set of features and may be enabled or disabled depending on the needs of the site. Many additional modules contributed by members of the Drupal community are available for download at the <a href=\"@drupal-modules\">Drupal.org module page</a>.','','7.28'),(4610,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Managing themes','','7.28'),(4611,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','The System module allows users with the appropriate permissions to enable and disable themes on the <a href=\"@themes\">Appearance administration page</a>. Themes determine the design and presentation of your site. Drupal comes packaged with several core themes, and additional contributed themes are available at the <a href=\"@drupal-themes\">Drupal.org theme page</a>.','','7.28'),(4612,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Managing caching','','7.28'),(4613,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','The System module allows users with the appropriate permissions to manage caching on the <a href=\'@cache-settings\'>Performance settings page</a>. Drupal has a robust caching system that allows the efficient re-use of previously-constructed web pages and web page components. Pages requested by anonymous users are stored in a compressed format; depending on your site configuration and the amount of your web traffic tied to anonymous visitors, the caching system may significantly increase the speed of your site.','','7.28'),(4614,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Performing system maintenance','','7.28'),(4615,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','In order for the site and its modules to continue to operate well, a set of routine administrative operations must run on a regular basis. The System module manages this task by making use of a system cron job. You can verify the status of cron tasks by visiting the <a href=\"@status\">Status report page</a>. For more information, see the online handbook entry for <a href=\"@handbook\">configuring cron jobs</a>. You can set up cron job by visiting <a href=\"@cron\">Cron configuration</a> page','','7.28'),(4616,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Configuring basic site settings','','7.28'),(4617,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','The System module also handles basic configuration options for your site, including <a href=\"@date-time-settings\">Date and time settings</a>, <a href=\"@file-system\">File system settings</a>, <a href=\"@clean-url\">Clean URL support</a>, <a href=\"@site-info\">Site name and other information</a>, and a <a href=\"@maintenance-mode\">Maintenance mode</a> for taking your site temporarily offline.','','7.28'),(4618,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Configuring actions','','7.28'),(4619,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Actions are individual tasks that the system can do, such as unpublishing a piece of content or banning a user. Modules, such as the <a href=\"@trigger-help\">Trigger module</a>, can fire these actions when certain system events happen; for example, when a new post is added or when a user logs in. Modules may also provide additional actions. Visit the <a href=\"@actions\">Actions page</a> to configure actions.','','7.28'),(4620,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Handles general site configuration for administrators.','','7.28'),(4621,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','TagClouds makes weighted tag clouds from your taxonomy terms.','','7.28'),(4622,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','The Taxonomy module allows you to classify the content of your website. To classify content, you define <em>vocabularies</em> that contain related <em>terms</em>, and then assign the vocabularies to content types. For more information, see the online handbook entry for the <a href=\"@taxonomy\">Taxonomy module</a>.','','7.28'),(4623,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Creating vocabularies','','7.28'),(4624,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Users with sufficient <a href=\"@perm\">permissions</a> can create <em>vocabularies</em> and <em>terms</em> through the <a href=\"@taxo\">Taxonomy page</a>. The page listing the terms provides a drag-and-drop interface for controlling the order of the terms and sub-terms within a vocabulary, in a hierarchical fashion. A <em>controlled vocabulary</em> classifying music by genre with terms and sub-terms could look as follows:','','7.28'),(4625,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','<em>vocabulary</em>: Music','','7.28'),(4626,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','<em>term</em>: Jazz','','7.28'),(4627,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','<em>sub-term</em>: Swing','','7.28'),(4628,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','<em>sub-term</em>: Fusion','','7.28'),(4629,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','<em>term</em>: Rock','','7.28'),(4630,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','<em>sub-term</em>: Country rock','','7.28'),(4631,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','<em>sub-term</em>: Hard rock','','7.28'),(4632,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','You can assign a sub-term to multiple parent terms. For example, <em>fusion</em> can be assigned to both <em>rock</em> and <em>jazz</em>.','','7.28'),(4633,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Terms in a <em>free-tagging vocabulary</em> can be built gradually as you create or edit content. This is often done used for blogs or photo management applications.','','7.28'),(4634,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Assigning vocabularies to content types','','7.28'),(4635,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Before you can use a new vocabulary to classify your content, a new Taxonomy term field must be added to a <a href=\"@ctedit\">content type</a> on its <em>manage fields</em> page. When adding a taxonomy field, you choose a <em>widget</em> to use to enter the taxonomy information on the content editing page: a select list, checkboxes, radio buttons, or an auto-complete field (to build a free-tagging vocabulary). After choosing the field type and widget, on the subsequent <em>field settings</em> page you can choose the desired vocabulary, whether one or multiple terms can be chosen from the vocabulary, and other settings. The same vocabulary can be added to multiple content types, by using the \"Add existing field\" section on the manage fields page.','','7.28'),(4636,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Classifying content','','7.28'),(4637,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','After the vocabulary is assigned to the content type, you can start classifying content. The field with terms will appear on the content editing screen when you edit or <a href=\"@addnode\">add new content</a>.','','7.28'),(4638,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Viewing listings and RSS feeds by term','','7.28'),(4639,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Each taxonomy term automatically provides a page listing content that has its classification, and a corresponding RSS feed. For example, if the taxonomy term <em>country rock</em> has the ID 123 (you can see this by looking at the URL when hovering on the linked term, which you can click to navigate to the listing page), then you will find this list at the path <em>taxonomy/term/123</em>. The RSS feed will use the path <em>taxonomy/term/123/feed</em> (the RSS icon for this term\'s listing will automatically display in your browser\'s address bar when viewing the listing page).','','7.28'),(4640,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Extending Taxonomy module','','7.28'),(4641,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','There are <a href=\"@taxcontrib\">many contributed modules</a> that extend the behavior of the Taxonomy module for both display and organization of terms.','','7.28'),(4642,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Enables the categorization of content.','','7.28'),(4643,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Adds links to taxonomy terms to a menu.','','7.28'),(4644,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','This module adds support for multilingual taxonomy. You can set up multilingual options for each vocabulary:','','7.28'),(4645,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','A language can be assigned globaly for a vocabulary.','','7.28'),(4646,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Different terms for each language with translation relationships.','','7.28'),(4647,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Terms can be common to all languages, but may be localized.','','7.28'),(4648,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Enables multilingual taxonomy.','','7.28'),(4649,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Megamenu solutions for Drupal','','7.28'),(4650,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Controls access to context based upon term depth','','7.28'),(4651,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Provides a framework for unit and functional testing.','','7.28'),(4652,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','The Text module defines various text field types for the Field module. A text field may contain plain text only, or optionally, may use Drupal\'s <a href=\'@filter-help\'>text filters</a> to securely manage HTML output. Text input fields may be either a single line (text field), multiple lines (text area), or for greater input control, a select box, checkbox, or radio buttons. If desired, the field can be validated, so that it is limited to a set of allowed values. See the <a href=\'@field-help\'>Field module help page</a> for more information about fields.','','7.28'),(4653,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Defines simple text field types.','','7.28'),(4654,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Provides a user interface for the Token API and some missing core tokens.','','7.28'),(4655,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Provides a toolbar that shows the top-level administration menu items and links from other modules.','','7.28'),(4656,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Enables tracking of recent content for users.','','7.28'),(4657,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Redirect to translated page when available. SEO for multilingual sites.','','7.28'),(4658,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Simple translation sets API for generic objects','','7.28'),(4659,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Enables actions to be fired on certain system events, such as when new content is created.','','7.28'),(4660,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','The Update manager module periodically checks for new versions of your site\'s software (including contributed modules and themes), and alerts administrators to available updates. In order to provide update information, anonymous usage statistics are sent to Drupal.org. If desired, you may disable the Update manager module from the <a href=\'@modules\'>Module administration page</a>. For more information, see the online handbook entry for <a href=\'@update\'>Update manager module</a>.','','7.28'),(4661,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','The Update manager also allows administrators to update and install modules and themes through the administration interface.','','7.28'),(4662,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Checking for available updates','','7.28'),(4663,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','A report of <a href=\"@update-report\">available updates</a> will alert you when new releases are available for download. You may configure options for the frequency for checking updates (which are performed during <a href=\"@cron\">cron</a> runs) and e-mail notifications at the <a href=\"@update-settings\">Update manager settings</a>  page.','','7.28'),(4664,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Performing updates through the user interface','','7.28'),(4665,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','The Update manager module allows administrators to perform updates directly through the administration interface. At the top of the <a href=\"@modules_page\">modules</a> and <a href=\"@themes_page\">themes</a> pages you will see a link to update to new releases. This will direct you to the <a href=\"@update-page\">update page</a> where you see a listing of all the missing updates and confirm which ones you want to upgrade. From there, you are prompted for your FTP/SSH password, which then transfers the files into your Drupal installation, overwriting your old files. More detailed instructions can be found in the <a href=\"@update\">online handbook</a>.','','7.28'),(4666,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Installing new modules and themes through the user interface','','7.28'),(4667,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','You can also install new modules and themes in the same fashion, through the <a href=\"@install\">install page</a>, or by clicking the <em>Install new module/theme</em> link at the top of the <a href=\"@modules_page\">modules</a> and <a href=\"@themes_page\">themes</a> pages. In this case, you are prompted to provide either the URL to the download, or to upload a packaged release file from your local computer.','','7.28'),(4668,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Checks for available updates, and can securely install or update modules and themes via a web interface.','','7.28'),(4669,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','The User module allows users to register, log in, and log out. It also allows users with proper permissions to manage user roles (used to classify users) and permissions associated with those roles. For more information, see the online handbook entry for <a href=\"@user\">User module</a>.','','7.28'),(4670,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Creating and managing users','','7.28'),(4671,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','The User module allows users with the appropriate <a href=\"@permissions\">permissions</a> to create user accounts through the <a href=\"@people\">People administration page</a>, where they can also assign users to one or more roles, and block or delete user accounts. If allowed, users without accounts (anonymous users) can create their own accounts on the <a href=\"@register\">Create new account</a> page.','','7.28'),(4672,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','User roles and permissions','','7.28'),(4673,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','<em>Roles</em> are used to group and classify users; each user can be assigned one or more roles. By default there are two roles: <em>anonymous user</em> (users that are not logged in) and <em>authenticated user</em> (users that are registered and logged in). Depending on choices you made when you installed Drupal, the installation process may have defined more roles, and you can create additional custom roles on the <a href=\"@roles\">Roles page</a>. After creating roles, you can set permissions for each role on the <a href=\"@permissions_user\">Permissions page</a>. Granting a permission allows users who have been assigned a particular role to perform an action on the site, such as viewing a particular type of content, editing or creating content, administering settings for a particular module, or using a particular function of the site (such as search).','','7.28'),(4674,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','The <a href=\"@accounts\">Account settings page</a> allows you to manage settings for the displayed name of the anonymous user role, personal contact forms, user registration, and account cancellation. On this page you can also manage settings for account personalization (including signatures and user pictures), and adapt the text for the e-mail messages that are sent automatically during the user registration process.','','7.28'),(4675,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Manages the user registration and login system.','','7.28'),(4676,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Translate emails sent from the User module.','','7.28'),(4677,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Allow users to choose a picture from multiple providers.','','7.28'),(4678,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Provide Gravatar pictures.','','7.28'),(4679,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Provide Robohash pictures.','','7.28'),(4680,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Variable Information and basic variable API','','7.28'),(4681,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Variable Administration UI','','7.28'),(4682,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','An example module showing how to use the Variable API and providing some variables.','','7.28'),(4683,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','API to use variable realms from different modules','','7.28'),(4684,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Database storage for variable realms. This is an API module.','','7.28'),(4685,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Multilingual variables that switch language depending on page language.','','7.28'),(4686,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Provides views integration for variable, included a default variable argument.','','7.28'),(4687,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Provides Facebook handler for Video Embed Fields.  This module also serves as an example of how to add handlers to video embed field.','','7.28'),(4688,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Expose a field type for embedding videos from youtube or vimeo.','','7.28'),(4689,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Create customized lists and queries from your database.','','7.28'),(4690,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Provides a way of selecting multiple rows and applying operations to them.','','7.28'),(4691,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Allows Views content to be used in Panels, Dashboard and other modules which use the CTools Content API.','','7.28'),(4692,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Embeds a view inside a view as field','','7.28'),(4693,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Output several Views fields into a fieldset.','','7.28'),(4694,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Provides a View style that displays rows as a jQuery slideshow.  This is an API and requires Views Slideshow Cycle or another module that supports the API.','','7.28'),(4695,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Views Slideshow Cycle help can be found by installing and enabling the !advanced_help','','7.28'),(4696,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Adds a Rotating slideshow mode to Views Slideshow.','','7.28'),(4697,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Administrative interface to views. Without this module, you cannot create or edit your views.','','7.28'),(4698,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Provides a shared voting API for other modules.','','7.28'),(4699,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Optional: Enable Webform on multiple types by visiting the <a href=\"!url\">Webform settings</a> page.','','7.28'),(4700,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','<p>This module lets you create forms or questionnaires and define their content. Submissions from these forms are stored in the database and optionally also sent by e-mail to a predefined address.</p>\n      <p>Here is how to create one:</p>\n      <ul>\n        <li>!webform-types-message</li>\n        <li>Go to <a href=\"!create-content\">Create content</a> and add a !types piece of content.</li>\n        <li>After saving the new content, you will be redirected to the main field list of the form that will be created. Add the fields you would like on your form.</li>\n        <li>Once finished adding fields, you may want to send e-mails to administrators or back to the user who filled out the form. Click on the <em>Emails</em> sub-tab underneath the <em>Webform</em> tab on the piece of content.</li>\n        <li>Finally, visit the <em>Form settings</em> sub-tab under the <em>Webform</em> tab to configure remaining configurations options for your form.\n          <ul>\n          <li>Add a confirmation message and/or redirect URL that is to be displayed after successful submission.</li>\n          <li>Set a submission limit.</li>\n          <li>Determine which roles may submit the form.</li>\n          <li>Advanced configuration options such as allowing drafts or show users a message indicating how they can edit their submissions.</li>\n          </ul>\n        </li>\n        <li>Your form is now ready for viewing. After receiving submissions, you can check the results users have submitted by visiting the <em>Results</em> tab on the piece of content.</li>\n      </ul>\n      <p>Help on adding and configuring the components will be shown after you add your first component.</p>\n      ','','7.28'),(4701,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Enables the creation of forms and questionnaires.','','7.28'),(4702,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Turns field labels into placeholder hints on Webform textareas, textfields, and email fields.','','7.28'),(4703,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Allows to edit content with client-side editors.','','7.28'),(4704,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Bean','','7.28'),(4705,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Performance and scalability','','7.28'),(4706,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Chaos tool suite','','7.28'),(4707,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Multilingual - Internationalization','','7.28'),(4708,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Date/Time','','7.28'),(4709,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Spam control','','7.28'),(4710,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Contact Forms','','7.28'),(4711,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Example modules','','7.28'),(4712,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Shortcode','','7.28'),(4713,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Voting','','7.28'),(4714,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Multilingual','','7.28'),(4715,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','SEO','','7.28'),(4716,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Rules','','7.28'),(4717,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Sharing','','7.28'),(4718,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Taxonomy menu','','7.28'),(4719,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','tb_megamenu','','7.28'),(4720,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','User Picture','','7.28'),(4721,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Variable','','7.28'),(4722,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Unavailable','','7.28'),(4723,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Field Bases','','7.32'),(4724,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Field Instances','','7.32'),(4725,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Menu items','','7.32'),(4726,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Comment reference','','7.32'),(4727,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Node reference','','7.32'),(4728,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Download additional <a href=\"@modules\">contributed modules</a> to extend Drupal\'s functionality.','','7.28'),(4729,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Regularly review and install <a href=\"@updates\">available updates</a> to maintain a secure and current site. Always run the <a href=\"@update-php\">update script</a> each time a module is updated.','','7.28'),(4730,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Requires: !module-list','','7.28'),(4731,'/weebpal/forum-plus/fr/admin/modules?render=overlay','default','Required by: !module-list','','7.28'),(4732,'/weebpal/forum-plus/fr/admin/structure/views/ajax/display/activity_stream/page/access','default','This @display_type (override)','','7.28'),(4733,'/weebpal/forum-plus/fr/admin/structure/views/ajax/display/activity_stream/page/access','default','For','','7.28'),(4734,'/weebpal/forum-plus/fr/admin/structure/views/ajax/display/activity_stream/page/access','default','Access restrictions','','7.28'),(4735,'/weebpal/forum-plus/fr/admin/structure/views/ajax/display/activity_stream/page/access','default','Apply and continue','','7.28'),(4736,'/weebpal/forum-plus/fr/admin/structure/views/ajax/config-item/activity_stream/page/field/message_render','default','Error: missing @component','','7.32'),(4737,'/weebpal/forum-plus/fr/admin/structure/views/ajax/config-item/activity_stream/page/field/message_render','default','Configure @type: @item','','7.28'),(4738,'/weebpal/forum-plus/fr/admin/structure/views/ajax/config-item/activity_stream/page/field/message_render','default','Select the field name to render.','','7.28'),(4739,'/weebpal/forum-plus/fr/admin/structure/views/ajax/config-item/activity_stream/page/field/message_render','default','Partial','','7.28'),(4740,'/weebpal/forum-plus/fr/admin/structure/views/ajax/config-item/activity_stream/page/field/message_render','default','Render only a single delta out of the whole message (in case it is separated in multiple deltas).','','7.28'),(4741,'/weebpal/forum-plus/fr/admin/structure/views/ajax/config-item/activity_stream/page/field/message_render','default','Partial delta','','7.28'),(4742,'/weebpal/forum-plus/fr/admin/structure/views/ajax/config-item/activity_stream/page/field/message_render','default','The delta to use for partial rendering.','','7.28'),(4743,'/weebpal/forum-plus/fr/admin/structure/views/ajax/config-item/activity_stream/page/field/message_render','default','Administrative title','','7.28'),(4744,'/weebpal/forum-plus/fr/admin/structure/views/ajax/config-item/activity_stream/page/field/message_render','default','This title will be displayed on the views edit page instead of the default one. This might be useful if you have the same item twice.','','7.28'),(4745,'/weebpal/forum-plus/fr/admin/structure/views/ajax/config-item/activity_stream/page/field/message_render','default','Create a label','','7.28'),(4746,'/weebpal/forum-plus/fr/admin/structure/views/ajax/config-item/activity_stream/page/field/message_render','default','Enable to create a label for this field.','','7.28'),(4747,'/weebpal/forum-plus/fr/admin/structure/views/ajax/config-item/activity_stream/page/field/message_render','default','Place a colon after the label','','7.28'),(4748,'/weebpal/forum-plus/fr/admin/structure/views/ajax/config-item/activity_stream/page/field/message_render','default','Exclude from display','','7.28'),(4749,'/weebpal/forum-plus/fr/admin/structure/views/ajax/config-item/activity_stream/page/field/message_render','default','Enable to load this field as hidden. Often used to group fields, or to use as token in another field.','','7.28'),(4750,'/weebpal/forum-plus/fr/admin/structure/views/ajax/config-item/activity_stream/page/field/message_render','default','Style settings','','7.28'),(4751,'/weebpal/forum-plus/fr/admin/structure/views/ajax/config-item/activity_stream/page/field/message_render','default','Customize field HTML','','7.28'),(4752,'/weebpal/forum-plus/fr/admin/structure/views/ajax/config-item/activity_stream/page/field/message_render','default','HTML element','','7.28'),(4753,'/weebpal/forum-plus/fr/admin/structure/views/ajax/config-item/activity_stream/page/field/message_render','default','- Use default -','','7.28'),(4754,'/weebpal/forum-plus/fr/admin/structure/views/ajax/config-item/activity_stream/page/field/message_render','default','Choose the HTML element to wrap around this field, e.g. H1, H2, etc.','','7.28'),(4755,'/weebpal/forum-plus/fr/admin/structure/views/ajax/config-item/activity_stream/page/field/message_render','default','Create a CSS class','','7.28'),(4756,'/weebpal/forum-plus/fr/admin/structure/views/ajax/config-item/activity_stream/page/field/message_render','default','You may use token substitutions from the rewriting section in this class.','','7.28'),(4757,'/weebpal/forum-plus/fr/admin/structure/views/ajax/config-item/activity_stream/page/field/message_render','default','Customize label HTML','','7.28'),(4758,'/weebpal/forum-plus/fr/admin/structure/views/ajax/config-item/activity_stream/page/field/message_render','default','Label HTML element','','7.28'),(4759,'/weebpal/forum-plus/fr/admin/structure/views/ajax/config-item/activity_stream/page/field/message_render','default','Choose the HTML element to wrap around this label, e.g. H1, H2, etc.','','7.28'),(4760,'/weebpal/forum-plus/fr/admin/structure/views/ajax/config-item/activity_stream/page/field/message_render','default','Customize field and label wrapper HTML','','7.28'),(4761,'/weebpal/forum-plus/fr/admin/structure/views/ajax/config-item/activity_stream/page/field/message_render','default','Wrapper HTML element','','7.28'),(4762,'/weebpal/forum-plus/fr/admin/structure/views/ajax/config-item/activity_stream/page/field/message_render','default','Choose the HTML element to wrap around this field and label, e.g. H1, H2, etc. This may not be used if the field and label are not rendered together, such as with a table.','','7.28'),(4763,'/weebpal/forum-plus/fr/admin/structure/views/ajax/config-item/activity_stream/page/field/message_render','default','Add default classes','','7.28'),(4764,'/weebpal/forum-plus/fr/admin/structure/views/ajax/config-item/activity_stream/page/field/message_render','default','Use default Views classes to identify the field, field label and field content.','','7.28'),(4765,'/weebpal/forum-plus/fr/admin/structure/views/ajax/config-item/activity_stream/page/field/message_render','default','Rewrite results','','7.28'),(4766,'/weebpal/forum-plus/fr/admin/structure/views/ajax/config-item/activity_stream/page/field/message_render','default','Rewrite the output of this field','','7.28'),(4767,'/weebpal/forum-plus/fr/admin/structure/views/ajax/config-item/activity_stream/page/field/message_render','default','Enable to override the output of this field with custom text or replacement tokens.','','7.28'),(4768,'/weebpal/forum-plus/fr/admin/structure/views/ajax/config-item/activity_stream/page/field/message_render','default','The text to display for this field. You may include HTML. You may enter data from this view as per the \"Replacement patterns\" below.','','7.28'),(4769,'/weebpal/forum-plus/fr/admin/structure/views/ajax/config-item/activity_stream/page/field/message_render','default','Output this field as a link','','7.28'),(4770,'/weebpal/forum-plus/fr/admin/structure/views/ajax/config-item/activity_stream/page/field/message_render','default','If checked, this field will be made into a link. The destination must be given below.','','7.28'),(4771,'/weebpal/forum-plus/fr/admin/structure/views/ajax/config-item/activity_stream/page/field/message_render','default','Link path','','7.28'),(4772,'/weebpal/forum-plus/fr/admin/structure/views/ajax/config-item/activity_stream/page/field/message_render','default','The Drupal path or absolute URL for this link. You may enter data from this view as per the \"Replacement patterns\" below.','','7.28'),(4773,'/weebpal/forum-plus/fr/admin/structure/views/ajax/config-item/activity_stream/page/field/message_render','default','Use absolute path','','7.28'),(4774,'/weebpal/forum-plus/fr/admin/structure/views/ajax/config-item/activity_stream/page/field/message_render','default','Replace spaces with dashes','','7.28'),(4775,'/weebpal/forum-plus/fr/admin/structure/views/ajax/config-item/activity_stream/page/field/message_render','default','External server URL','','7.28'),(4776,'/weebpal/forum-plus/fr/admin/structure/views/ajax/config-item/activity_stream/page/field/message_render','default','Links to an external server using a full URL: e.g. \'http://www.example.com\' or \'www.example.com\'.','','7.28'),(4777,'/weebpal/forum-plus/fr/admin/structure/views/ajax/config-item/activity_stream/page/field/message_render','default','Transform the case','','7.28'),(4778,'/weebpal/forum-plus/fr/admin/structure/views/ajax/config-item/activity_stream/page/field/message_render','default','When printing url paths, how to transform the case of the filter value.','','7.28'),(4779,'/weebpal/forum-plus/fr/admin/structure/views/ajax/config-item/activity_stream/page/field/message_render','default','No transform','','7.28'),(4780,'/weebpal/forum-plus/fr/admin/structure/views/ajax/config-item/activity_stream/page/field/message_render','default','Upper case','','7.28'),(4781,'/weebpal/forum-plus/fr/admin/structure/views/ajax/config-item/activity_stream/page/field/message_render','default','Lower case','','7.28'),(4782,'/weebpal/forum-plus/fr/admin/structure/views/ajax/config-item/activity_stream/page/field/message_render','default','Capitalize first letter','','7.28'),(4783,'/weebpal/forum-plus/fr/admin/structure/views/ajax/config-item/activity_stream/page/field/message_render','default','Capitalize each word','','7.28'),(4784,'/weebpal/forum-plus/fr/admin/structure/views/ajax/config-item/activity_stream/page/field/message_render','default','Link class','','7.28'),(4785,'/weebpal/forum-plus/fr/admin/structure/views/ajax/config-item/activity_stream/page/field/message_render','default','The CSS class to apply to the link.','','7.28'),(4786,'/weebpal/forum-plus/fr/admin/structure/views/ajax/config-item/activity_stream/page/field/message_render','default','Title text','','7.28'),(4787,'/weebpal/forum-plus/fr/admin/structure/views/ajax/config-item/activity_stream/page/field/message_render','default','Text to place as \"title\" text which most browsers display as a tooltip when hovering over the link.','','7.28'),(4788,'/weebpal/forum-plus/fr/admin/structure/views/ajax/config-item/activity_stream/page/field/message_render','default','Rel Text','','7.28'),(4789,'/weebpal/forum-plus/fr/admin/structure/views/ajax/config-item/activity_stream/page/field/message_render','default','Include Rel attribute for use in lightbox2 or other javascript utility.','','7.28'),(4790,'/weebpal/forum-plus/fr/admin/structure/views/ajax/config-item/activity_stream/page/field/message_render','default','Prefix text','','7.28'),(4791,'/weebpal/forum-plus/fr/admin/structure/views/ajax/config-item/activity_stream/page/field/message_render','default','Any text to display before this link. You may include HTML.','','7.28'),(4792,'/weebpal/forum-plus/fr/admin/structure/views/ajax/config-item/activity_stream/page/field/message_render','default','Suffix text','','7.28'),(4793,'/weebpal/forum-plus/fr/admin/structure/views/ajax/config-item/activity_stream/page/field/message_render','default','Any text to display after this link. You may include HTML.','','7.28'),(4794,'/weebpal/forum-plus/fr/admin/structure/views/ajax/config-item/activity_stream/page/field/message_render','default','Target','','7.28'),(4795,'/weebpal/forum-plus/fr/admin/structure/views/ajax/config-item/activity_stream/page/field/message_render','default','Target of the link, such as _blank, _parent or an iframe\'s name. This field is rarely used.','','7.28'),(4796,'/weebpal/forum-plus/fr/admin/structure/views/ajax/config-item/activity_stream/page/field/message_render','default','<p>You must add some additional fields to this display before using this field. These fields may be marked as <em>Exclude from display</em> if you prefer. Note that due to rendering order, you cannot use fields that come after this field; if you need a field not listed here, rearrange your fields.</p>','','7.28'),(4797,'/weebpal/forum-plus/fr/admin/structure/views/ajax/config-item/activity_stream/page/field/message_render','default','<p>The following tokens are available for this field. Note that due to rendering order, you cannot use fields that come after this field; if you need a field not listed here, rearrange your fields.\nIf you would like to have the characters \'[\' and \']\' please use the html entity codes \'%5B\' or  \'%5D\' or they will get replaced with empty space.</p>','','7.28'),(4798,'/weebpal/forum-plus/fr/admin/structure/views/ajax/config-item/activity_stream/page/field/message_render','default','Trim this field to a maximum length','','7.28'),(4799,'/weebpal/forum-plus/fr/admin/structure/views/ajax/config-item/activity_stream/page/field/message_render','default','Enable to trim the field to a maximum length of characters','','7.28'),(4800,'/weebpal/forum-plus/fr/admin/structure/views/ajax/config-item/activity_stream/page/field/message_render','default','Maximum length','','7.28'),(4801,'/weebpal/forum-plus/fr/admin/structure/views/ajax/config-item/activity_stream/page/field/message_render','default','The maximum number of characters this field can be.','','7.28'),(4802,'/weebpal/forum-plus/fr/admin/structure/views/ajax/config-item/activity_stream/page/field/message_render','default','Trim only on a word boundary','','7.28'),(4803,'/weebpal/forum-plus/fr/admin/structure/views/ajax/config-item/activity_stream/page/field/message_render','default','If checked, this field be trimmed only on a word boundary. This is guaranteed to be the maximum characters stated or less. If there are no word boundaries this could trim a field to nothing.','','7.28'),(4804,'/weebpal/forum-plus/fr/admin/structure/views/ajax/config-item/activity_stream/page/field/message_render','default','Add an ellipsis','','7.28'),(4805,'/weebpal/forum-plus/fr/admin/structure/views/ajax/config-item/activity_stream/page/field/message_render','default','If checked, a \"...\" will be added if a field was trimmed.','','7.28'),(4806,'/weebpal/forum-plus/fr/admin/structure/views/ajax/config-item/activity_stream/page/field/message_render','default','Add a read-more link if output is trimmed.','','7.28'),(4807,'/weebpal/forum-plus/fr/admin/structure/views/ajax/config-item/activity_stream/page/field/message_render','default','If checked, a read-more link will be added at the end of the trimmed output','','7.28'),(4808,'/weebpal/forum-plus/fr/admin/structure/views/ajax/config-item/activity_stream/page/field/message_render','default','More link text','','7.28'),(4809,'/weebpal/forum-plus/fr/admin/structure/views/ajax/config-item/activity_stream/page/field/message_render','default','The text which will be displayed on the more link. You may enter data from this view as per the \"Replacement patterns\" above.','','7.28'),(4810,'/weebpal/forum-plus/fr/admin/structure/views/ajax/config-item/activity_stream/page/field/message_render','default','More link path','','7.28'),(4811,'/weebpal/forum-plus/fr/admin/structure/views/ajax/config-item/activity_stream/page/field/message_render','default','The path which is used for the more link. You may enter data from this view as per the \"Replacement patterns\" above.','','7.28'),(4812,'/weebpal/forum-plus/fr/admin/structure/views/ajax/config-item/activity_stream/page/field/message_render','default','Field can contain HTML','','7.28'),(4813,'/weebpal/forum-plus/fr/admin/structure/views/ajax/config-item/activity_stream/page/field/message_render','default','If checked, HTML corrector will be run to ensure tags are properly closed after trimming.','','7.28'),(4814,'/weebpal/forum-plus/fr/admin/structure/views/ajax/config-item/activity_stream/page/field/message_render','default','Strip HTML tags','','7.28'),(4815,'/weebpal/forum-plus/fr/admin/structure/views/ajax/config-item/activity_stream/page/field/message_render','default','If checked, all HTML tags will be stripped.','','7.28'),(4816,'/weebpal/forum-plus/fr/admin/structure/views/ajax/config-item/activity_stream/page/field/message_render','default','Preserve certain tags','','7.28'),(4817,'/weebpal/forum-plus/fr/admin/structure/views/ajax/config-item/activity_stream/page/field/message_render','default','List the tags that need to be preserved during the stripping process. example &quot;&lt;p&gt; &lt;br&gt;&quot; which will preserve all p and br elements','','7.28'),(4818,'/weebpal/forum-plus/fr/admin/structure/views/ajax/config-item/activity_stream/page/field/message_render','default','Remove whitespace','','7.28'),(4819,'/weebpal/forum-plus/fr/admin/structure/views/ajax/config-item/activity_stream/page/field/message_render','default','If checked, all whitespaces at the beginning and the end of the output will be removed.','','7.28'),(4820,'/weebpal/forum-plus/fr/admin/structure/views/ajax/config-item/activity_stream/page/field/message_render','default','Convert newlines to HTML &lt;br&gt; tags','','7.28'),(4821,'/weebpal/forum-plus/fr/admin/structure/views/ajax/config-item/activity_stream/page/field/message_render','default','If checked, all newlines chars (e.g. \\n) are converted into HTML &lt;br&gt; tags.','','7.28'),(4822,'/weebpal/forum-plus/fr/admin/structure/views/ajax/config-item/activity_stream/page/field/message_render','default','No results text','','7.28'),(4823,'/weebpal/forum-plus/fr/admin/structure/views/ajax/config-item/activity_stream/page/field/message_render','default','Provide text to display if this field contains an empty result. You may include HTML. You may enter data from this view as per the \"Replacement patterns\" in the \"Rewrite Results\" section below.','','7.28'),(4824,'/weebpal/forum-plus/fr/admin/structure/views/ajax/config-item/activity_stream/page/field/message_render','default','Count the number 0 as empty','','7.28'),(4825,'/weebpal/forum-plus/fr/admin/structure/views/ajax/config-item/activity_stream/page/field/message_render','default','Enable to display the \"no results text\" if the field contains the number 0.','','7.28'),(4826,'/weebpal/forum-plus/fr/admin/structure/views/ajax/config-item/activity_stream/page/field/message_render','default','Hide if empty','','7.28'),(4827,'/weebpal/forum-plus/fr/admin/structure/views/ajax/config-item/activity_stream/page/field/message_render','default','Enable to hide this field if it is empty. Note that the field label or rewritten output may still be displayed. To hide labels, check the style or row style settings for empty fields. To hide rewritten content, check the \"Hide rewriting if empty\" checkbox.','','7.28'),(4828,'/weebpal/forum-plus/fr/admin/structure/views/ajax/config-item/activity_stream/page/field/message_render','default','Hide rewriting if empty','','7.28'),(4829,'/weebpal/forum-plus/fr/admin/structure/views/ajax/config-item/activity_stream/page/field/message_render','default','Do not display rewritten content if this field is empty.','','7.28'),(4830,'/weebpal/forum-plus/fr/admin/content/message?render=overlay','default','- Any -','','7.28'),(4831,'/weebpal/forum-plus/fr/admin/structure/messages/manage/example_create_comment?render=overlay','default','Edit @label','','7.28'),(4832,'/weebpal/forum-plus/fr/admin/structure/messages/manage/example_create_comment?render=overlay','default','The human-readable description of this message type.','','7.28'),(4833,'/weebpal/forum-plus/fr/admin/structure/messages/manage/example_create_comment?render=overlay','default','A unique machine-readable name for this message type. It must only contain lowercase letters, numbers, and underscores.','','7.28'),(4834,'/weebpal/forum-plus/fr/admin/structure/messages/manage/example_create_comment?render=overlay','default','Default message type category','','7.28'),(4835,'/weebpal/forum-plus/fr/admin/structure/messages/manage/example_create_comment?render=overlay','default','Field language','','7.28'),(4836,'/weebpal/forum-plus/fr/admin/structure/messages/manage/example_create_comment?render=overlay','default','The language code that will be saved with the field values. This is used to allow translation of fields.','','7.28'),(4837,'/weebpal/forum-plus/fr/admin/structure/messages/manage/example_create_comment?render=overlay','default','View modes: !view-modes','','7.28'),(4838,'/weebpal/forum-plus/fr/admin/structure/messages/manage/example_create_comment?render=overlay','default','Replacement tokens','','7.28'),(4839,'/weebpal/forum-plus/fr/admin/structure/messages/manage/example_create_comment?render=overlay','default','Optional: For <a href=\"@url-rules\">Rules</a> module, in order to set argument using Rules actions, a comma-separated list of replacement tokens, e.g. %title or !url, of which the message text makes use of. Each replacement token has to start with one of the special characters \"@\", \"%\" or \"!\". This character controls the sanitization method used, analogously to the <a href=\"!link\">t()</a> function.','','7.28'),(4840,'/weebpal/forum-plus/fr/admin/structure/messages/manage/example_create_comment?render=overlay','default','Clear empty tokens','','7.28'),(4841,'/weebpal/forum-plus/fr/admin/structure/messages/manage/example_create_comment?render=overlay','default','When this option is selected, empty tokens will be removed from display.','','7.28'),(4842,'/weebpal/forum-plus/fr/admin/structure/messages/manage/example_create_comment?render=overlay','default','Override global settings','','7.28'),(4843,'/weebpal/forum-plus/fr/admin/structure/messages/manage/example_create_comment?render=overlay','default','Override global purge settings for messages of this type.','','7.28'),(4844,'/weebpal/forum-plus/fr/admin/structure/messages/manage/example_create_comment?render=overlay','default','Maximal (approximate) amount of messages of this type.','','7.28'),(4845,'/weebpal/forum-plus/fr/admin/structure/messages/manage/example_create_comment?render=overlay','default','Maximal message age in days, for messages of this type.','','7.28'),(4846,'/weebpal/forum-plus/fr/admin/structure/messages/manage/example_create_comment?render=overlay','default','Save message type','','7.28'),(4847,'/weebpal/forum-plus/fr/admin/structure/views/ajax/add-item/activity_stream/page/filter','default','Add @type','','7.28'),(4848,'/weebpal/forum-plus/fr/admin/structure/views/ajax/add-item/activity_stream/page/filter','default','!group: !field','','7.28'),(4849,'/weebpal/forum-plus/fr/admin/structure/views/ajax/add-item/activity_stream/page/filter','default','Selected','','7.28'),(4850,'/weebpal/forum-plus/fr/admin/structure/views/ajax/add-item/activity_stream/page/filter','default','Add and configure @types','','7.28'),(4851,'/weebpal/forum-plus/fr/admin/structure/views/ajax/add-item/activity_stream/page/filter','default','Expose this filter to visitors, to allow them to change it','','7.28'),(4852,'/weebpal/forum-plus/fr/admin/structure/views/ajax/add-item/activity_stream/page/filter','default','This filter is not exposed. Expose it to allow the users to change it.','','7.28'),(4853,'/weebpal/forum-plus/fr/admin/structure/views/ajax/add-item/activity_stream/page/filter','default','Expose filter','','7.28'),(4854,'/weebpal/forum-plus/fr/admin/structure/views/ajax/add-item/activity_stream/page/filter','default','Is equal to','','7.28'),(4855,'/weebpal/forum-plus/fr/admin/structure/views/ajax/add-item/activity_stream/page/filter','default','Is not equal to','','7.28'),(4856,'/weebpal/forum-plus/fr/admin/structure/views/ajax/add-item/activity_stream/page/filter','default','!=','','7.28'),(4857,'/weebpal/forum-plus/fr/admin/structure/views/ajax/add-item/activity_stream/page/filter','default','Contains','','7.28'),(4858,'/weebpal/forum-plus/fr/admin/structure/views/ajax/add-item/activity_stream/page/filter','default','contains','','7.28'),(4859,'/weebpal/forum-plus/fr/admin/structure/views/ajax/add-item/activity_stream/page/filter','default','Contains any word','','7.28'),(4860,'/weebpal/forum-plus/fr/admin/structure/views/ajax/add-item/activity_stream/page/filter','default','has word','','7.28'),(4861,'/weebpal/forum-plus/fr/admin/structure/views/ajax/add-item/activity_stream/page/filter','default','Contains all words','','7.28'),(4862,'/weebpal/forum-plus/fr/admin/structure/views/ajax/add-item/activity_stream/page/filter','default','has all','','7.28'),(4863,'/weebpal/forum-plus/fr/admin/structure/views/ajax/add-item/activity_stream/page/filter','default','Starts with','','7.28'),(4864,'/weebpal/forum-plus/fr/admin/structure/views/ajax/add-item/activity_stream/page/filter','default','begins','','7.28'),(4865,'/weebpal/forum-plus/fr/admin/structure/views/ajax/add-item/activity_stream/page/filter','default','Does not start with','','7.28'),(4866,'/weebpal/forum-plus/fr/admin/structure/views/ajax/add-item/activity_stream/page/filter','default','not_begins','','7.28'),(4867,'/weebpal/forum-plus/fr/admin/structure/views/ajax/add-item/activity_stream/page/filter','default','Ends with','','7.28'),(4868,'/weebpal/forum-plus/fr/admin/structure/views/ajax/add-item/activity_stream/page/filter','default','ends','','7.28'),(4869,'/weebpal/forum-plus/fr/admin/structure/views/ajax/add-item/activity_stream/page/filter','default','Does not end with','','7.28'),(4870,'/weebpal/forum-plus/fr/admin/structure/views/ajax/add-item/activity_stream/page/filter','default','not_ends','','7.28'),(4871,'/weebpal/forum-plus/fr/admin/structure/views/ajax/add-item/activity_stream/page/filter','default','Does not contain','','7.28'),(4872,'/weebpal/forum-plus/fr/admin/structure/views/ajax/add-item/activity_stream/page/filter','default','!has','','7.28'),(4873,'/weebpal/forum-plus/fr/admin/structure/views/ajax/add-item/activity_stream/page/filter','default','Length is shorter than','','7.28'),(4874,'/weebpal/forum-plus/fr/admin/structure/views/ajax/add-item/activity_stream/page/filter','default','shorter than','','7.28'),(4875,'/weebpal/forum-plus/fr/admin/structure/views/ajax/add-item/activity_stream/page/filter','default','Length is longer than','','7.28'),(4876,'/weebpal/forum-plus/fr/admin/structure/views/ajax/add-item/activity_stream/page/filter','default','longer than','','7.28'),(4877,'/weebpal/forum-plus/fr/admin/structure/views/ajax/add-item/activity_stream/page/filter','default','Regular expression','','7.28'),(4878,'/weebpal/forum-plus/fr/admin/structure/views/ajax/add-item/activity_stream/page/filter','default','regex','','7.28'),(4879,'/weebpal/forum-plus/fr/admin/structure/views/ajax/add-item/activity_stream/page/filter','default','Operator','','7.28'),(4880,'/weebpal/forum-plus/fr/admin/structure/views/ajax/config-item/activity_stream/page/filter/language','default','This filter is exposed. If you hide it, users will not be able to change it.','','7.28'),(4881,'/weebpal/forum-plus/fr/admin/structure/views/ajax/config-item/activity_stream/page/filter/language','default','Hide filter','','7.28'),(4882,'/weebpal/forum-plus/fr/admin/structure/views/ajax/config-item/activity_stream/page/filter/language','default','Grouped filters allow a choice between predefined operator|value pairs.','','7.28'),(4883,'/weebpal/forum-plus/fr/admin/structure/views/ajax/config-item/activity_stream/page/filter/language','default','Filter type to expose','','7.28'),(4884,'/weebpal/forum-plus/fr/admin/structure/views/ajax/config-item/activity_stream/page/filter/language','default','Single filter','','7.28'),(4885,'/weebpal/forum-plus/fr/admin/structure/views/ajax/config-item/activity_stream/page/filter/language','default','Grouped filters','','7.28'),(4886,'/weebpal/forum-plus/fr/admin/structure/views/ajax/config-item/activity_stream/page/filter/language','default','Expose operator','','7.28'),(4887,'/weebpal/forum-plus/fr/admin/structure/views/ajax/config-item/activity_stream/page/filter/language','default','Allow the user to choose the operator.','','7.28'),(4888,'/weebpal/forum-plus/fr/admin/structure/views/ajax/config-item/activity_stream/page/filter/language','default','Operator label','','7.28'),(4889,'/weebpal/forum-plus/fr/admin/structure/views/ajax/config-item/activity_stream/page/filter/language','default','This will appear before your operator select field.','','7.28'),(4890,'/weebpal/forum-plus/fr/admin/structure/views/ajax/config-item/activity_stream/page/filter/language','default','Operator identifier','','7.28'),(4891,'/weebpal/forum-plus/fr/admin/structure/views/ajax/config-item/activity_stream/page/filter/language','default','This will appear in the URL after the ? to identify this operator.','','7.28'),(4892,'/weebpal/forum-plus/fr/admin/structure/views/ajax/config-item/activity_stream/page/filter/language','default','Remember the last selection','','7.28'),(4893,'/weebpal/forum-plus/fr/admin/structure/views/ajax/config-item/activity_stream/page/filter/language','default','Enable to remember the last selection made by the user.','','7.28'),(4894,'/weebpal/forum-plus/fr/admin/structure/views/ajax/config-item/activity_stream/page/filter/language','default','Remember exposed selection only for the selected user role(s). If you select no roles, the exposed data will never be stored.','','7.28'),(4895,'/weebpal/forum-plus/fr/admin/structure/views/ajax/config-item/activity_stream/page/filter/language','default','Filter identifier','','7.28'),(4896,'/weebpal/forum-plus/fr/admin/structure/views/ajax/config-item/activity_stream/page/filter/language','default','This will appear in the URL after the ? to identify this filter. Cannot be blank.','','7.28'),(4897,'/weebpal/forum-plus/fr/admin/structure/views/ajax/add-item/activity_stream/page/argument','default','When the filter value is <em>NOT</em> in the URL','','7.28'),(4898,'/weebpal/forum-plus/fr/admin/structure/views/ajax/add-item/activity_stream/page/argument','default','When the filter value <em>IS</em> in the URL or a default is provided','','7.28'),(4899,'/weebpal/forum-plus/fr/admin/structure/views/ajax/add-item/activity_stream/page/argument','default','The contextual filter values is provided by the URL.','','7.28'),(4900,'/weebpal/forum-plus/fr/admin/structure/views/ajax/add-item/activity_stream/page/argument','default','Exceptions','','7.28'),(4901,'/weebpal/forum-plus/fr/admin/structure/views/ajax/add-item/activity_stream/page/argument','default','Exception value','','7.28'),(4902,'/weebpal/forum-plus/fr/admin/structure/views/ajax/add-item/activity_stream/page/argument','default','If this value is received, the filter will be ignored; i.e, \"all values\"','','7.28'),(4903,'/weebpal/forum-plus/fr/admin/structure/views/ajax/add-item/activity_stream/page/argument','default','Override title','','7.28'),(4904,'/weebpal/forum-plus/fr/admin/structure/views/ajax/add-item/activity_stream/page/argument','default','Override the view and other argument titles. Use \"%1\" for the first argument, \"%2\" for the second, etc.','','7.28'),(4905,'/weebpal/forum-plus/fr/admin/structure/views/ajax/add-item/activity_stream/page/argument','default','Display all results for the specified field','','7.32'),(4906,'/weebpal/forum-plus/fr/admin/structure/views/ajax/add-item/activity_stream/page/argument','default','Provide default value','','7.32'),(4907,'/weebpal/forum-plus/fr/admin/structure/views/ajax/add-item/activity_stream/page/argument','default','Hide view','','7.32'),(4908,'/weebpal/forum-plus/fr/admin/structure/views/ajax/add-item/activity_stream/page/argument','default','Display a summary','','7.32'),(4909,'/weebpal/forum-plus/fr/admin/structure/views/ajax/add-item/activity_stream/page/argument','default','Display contents of \"No results found\"','','7.32'),(4910,'/weebpal/forum-plus/fr/admin/structure/views/ajax/add-item/activity_stream/page/argument','default','Display \"Access Denied\"','','7.32'),(4911,'/weebpal/forum-plus/fr/admin/structure/views/ajax/add-item/activity_stream/page/argument','default','Show \"Page not found\"','','7.32'),(4912,'/weebpal/forum-plus/fr/admin/structure/views/ajax/add-item/activity_stream/page/argument','default','Skip default argument for view URL','','7.28'),(4913,'/weebpal/forum-plus/fr/admin/structure/views/ajax/add-item/activity_stream/page/argument','default','Select whether to include this default argument when constructing the URL for this view. Skipping default arguments is useful e.g. in the case of feeds.','','7.28'),(4914,'/weebpal/forum-plus/fr/admin/structure/views/ajax/add-item/activity_stream/page/argument','default','Load default filter from term page','','7.28'),(4915,'/weebpal/forum-plus/fr/admin/structure/views/ajax/add-item/activity_stream/page/argument','default','Load default filter from node page, that\'s good for related taxonomy blocks','','7.28'),(4916,'/weebpal/forum-plus/fr/admin/structure/views/ajax/add-item/activity_stream/page/argument','default','Limit terms by vocabulary','','7.28'),(4917,'/weebpal/forum-plus/fr/admin/structure/views/ajax/add-item/activity_stream/page/argument','default','Multiple-value handling','','7.28'),(4918,'/weebpal/forum-plus/fr/admin/structure/views/ajax/add-item/activity_stream/page/argument','default','Filter to items that share all terms','','7.28'),(4919,'/weebpal/forum-plus/fr/admin/structure/views/ajax/add-item/activity_stream/page/argument','default','Filter to items that share any term','','7.28'),(4920,'/weebpal/forum-plus/fr/admin/structure/views/ajax/add-item/activity_stream/page/argument','default','Also look for a node and use the node author','','7.28'),(4921,'/weebpal/forum-plus/fr/admin/structure/views/ajax/add-item/activity_stream/page/argument','default','PHP contextual filter code','','7.28'),(4922,'/weebpal/forum-plus/fr/admin/structure/views/ajax/add-item/activity_stream/page/argument','default','Enter PHP code that returns a value to use for this filter. Do not use &lt;?php ?&gt;. You must return only a single value for just this filter. Some variables are available: the view object will be \"$view\". The argument handler will be \"$argument\", for example you may change the title used for substitutions for this argument by setting \"argument->validated_title\"\".','','7.28'),(4923,'/weebpal/forum-plus/fr/admin/structure/views/ajax/add-item/activity_stream/page/argument','default','Path component','','7.28'),(4924,'/weebpal/forum-plus/fr/admin/structure/views/ajax/add-item/activity_stream/page/argument','default','The numbering starts from 1, e.g. on the page admin/structure/types, the 3rd path component is \"types\".','','7.28'),(4925,'/weebpal/forum-plus/fr/admin/structure/views/ajax/add-item/activity_stream/page/argument','default','Use path alias','','7.28'),(4926,'/weebpal/forum-plus/fr/admin/structure/views/ajax/add-item/activity_stream/page/argument','default','Use path alias instead of internal path.','','7.28'),(4927,'/weebpal/forum-plus/fr/admin/structure/views/ajax/add-item/activity_stream/page/argument','default','Sort order','','7.28'),(4928,'/weebpal/forum-plus/fr/admin/structure/views/ajax/add-item/activity_stream/page/argument','default','Ascending','','7.28'),(4929,'/weebpal/forum-plus/fr/admin/structure/views/ajax/add-item/activity_stream/page/argument','default','Descending','','7.28'),(4930,'/weebpal/forum-plus/fr/admin/structure/views/ajax/add-item/activity_stream/page/argument','default','Alphabetical','Sort order','7.28'),(4931,'/weebpal/forum-plus/fr/admin/structure/views/ajax/add-item/activity_stream/page/argument','default','Number of records','','7.28'),(4932,'/weebpal/forum-plus/fr/admin/structure/views/ajax/add-item/activity_stream/page/argument','default','Base path','','7.28'),(4933,'/weebpal/forum-plus/fr/admin/structure/views/ajax/add-item/activity_stream/page/argument','default','Define the base path for links in this summary\n        view, i.e. http://example.com/<strong>your_view_path/archive</strong>.\n        Do not include beginning and ending forward slash. If this value\n        is empty, views will use the first path found as the base path,\n        in page displays, or / if no path could be found.','','7.28'),(4934,'/weebpal/forum-plus/fr/admin/structure/views/ajax/add-item/activity_stream/page/argument','default','Display record count with link','','7.28'),(4935,'/weebpal/forum-plus/fr/admin/structure/views/ajax/add-item/activity_stream/page/argument','default','Override number of items to display','','7.28'),(4936,'/weebpal/forum-plus/fr/admin/structure/views/ajax/add-item/activity_stream/page/argument','default','Items to display','','7.28'),(4937,'/weebpal/forum-plus/fr/admin/structure/views/ajax/add-item/activity_stream/page/argument','default','Display items inline','','7.28'),(4938,'/weebpal/forum-plus/fr/admin/structure/views/ajax/add-item/activity_stream/page/argument','default','Hide the \"Go\" button','','7.28'),(4939,'/weebpal/forum-plus/fr/admin/structure/views/ajax/add-item/activity_stream/page/argument','default','If hidden, this button will only be hidden for users with javascript and the page will automatically jump when the select is changed.','','7.28'),(4940,'/weebpal/forum-plus/fr/admin/structure/views/ajax/add-item/activity_stream/page/argument','default','Button text','','7.28'),(4941,'/weebpal/forum-plus/fr/admin/structure/views/ajax/add-item/activity_stream/page/argument','default','Selector label','','7.28'),(4942,'/weebpal/forum-plus/fr/admin/structure/views/ajax/add-item/activity_stream/page/argument','default','The text that will appear as the the label of the selector element. If blank no label tag will be used.','','7.28'),(4943,'/weebpal/forum-plus/fr/admin/structure/views/ajax/add-item/activity_stream/page/argument','default','Choose text','','7.28'),(4944,'/weebpal/forum-plus/fr/admin/structure/views/ajax/add-item/activity_stream/page/argument','default','The text that will appear as the selected option in the jump menu.','','7.28'),(4945,'/weebpal/forum-plus/fr/admin/structure/views/ajax/add-item/activity_stream/page/argument','default','Set this field to display inline','','7.28'),(4946,'/weebpal/forum-plus/fr/admin/structure/views/ajax/add-item/activity_stream/page/argument','default','Select the current contextual filter value','','7.28'),(4947,'/weebpal/forum-plus/fr/admin/structure/views/ajax/add-item/activity_stream/page/argument','default','If checked, the current contextual filter value will be displayed as the default option in the jump menu, if applicable.','','7.28'),(4948,'/weebpal/forum-plus/fr/admin/structure/views/ajax/add-item/activity_stream/page/argument','default','Provide title','','7.28'),(4949,'/weebpal/forum-plus/fr/admin/structure/views/ajax/add-item/activity_stream/page/argument','default','Override breadcrumb','','7.28'),(4950,'/weebpal/forum-plus/fr/admin/structure/views/ajax/add-item/activity_stream/page/argument','default','Provide breadcrumb','','7.28'),(4951,'/weebpal/forum-plus/fr/admin/structure/views/ajax/add-item/activity_stream/page/argument','default','Enter a breadcrumb name you would like to use. See \"Title\" for percent substitutions.','','7.28'),(4952,'/weebpal/forum-plus/fr/admin/structure/views/ajax/add-item/activity_stream/page/argument','default','Specify validation criteria','','7.28'),(4953,'/weebpal/forum-plus/fr/admin/structure/views/ajax/add-item/activity_stream/page/argument','default','Validator','','7.28'),(4954,'/weebpal/forum-plus/fr/admin/structure/views/ajax/add-item/activity_stream/page/argument','default','- Basic validation -','','7.28'),(4955,'/weebpal/forum-plus/fr/admin/structure/views/ajax/add-item/activity_stream/page/argument','default','Article','','7.28'),(4956,'/weebpal/forum-plus/fr/admin/structure/views/ajax/add-item/activity_stream/page/argument','default','Book page','','7.28'),(4957,'/weebpal/forum-plus/fr/admin/structure/views/ajax/add-item/activity_stream/page/argument','default','Basic page','','7.28'),(4958,'/weebpal/forum-plus/fr/admin/structure/views/ajax/add-item/activity_stream/page/argument','default','Products','','7.28'),(4959,'/weebpal/forum-plus/fr/admin/structure/views/ajax/add-item/activity_stream/page/argument','default','Video','','7.28'),(4960,'/weebpal/forum-plus/fr/admin/structure/views/ajax/add-item/activity_stream/page/argument','default','Choose one or more content types to validate with.','','7.28'),(4961,'/weebpal/forum-plus/fr/admin/structure/views/ajax/add-item/activity_stream/page/argument','default','Validate user has access to the content','','7.28'),(4962,'/weebpal/forum-plus/fr/admin/structure/views/ajax/add-item/activity_stream/page/argument','default','Access operation to check','','7.28'),(4963,'/weebpal/forum-plus/fr/admin/structure/views/ajax/add-item/activity_stream/page/argument','default','Filter value format','','7.28'),(4964,'/weebpal/forum-plus/fr/admin/structure/views/ajax/add-item/activity_stream/page/argument','default','Node IDs separated by , or +','','7.28'),(4965,'/weebpal/forum-plus/fr/admin/structure/views/ajax/add-item/activity_stream/page/argument','default','If you wish to validate for specific vocabularies, check them; if none are checked, all terms will pass.','','7.28'),(4966,'/weebpal/forum-plus/fr/admin/structure/views/ajax/add-item/activity_stream/page/argument','default','Filter value type','','7.28'),(4967,'/weebpal/forum-plus/fr/admin/structure/views/ajax/add-item/activity_stream/page/argument','default','Term IDs separated by , or +','','7.28'),(4968,'/weebpal/forum-plus/fr/admin/structure/views/ajax/add-item/activity_stream/page/argument','default','Term name','','7.28'),(4969,'/weebpal/forum-plus/fr/admin/structure/views/ajax/add-item/activity_stream/page/argument','default','Term name converted to Term ID','','7.28'),(4970,'/weebpal/forum-plus/fr/admin/structure/views/ajax/add-item/activity_stream/page/argument','default','Select the form of this filter value; if using term name, it is generally more efficient to convert it to a term ID and use Taxonomy: Term ID rather than Taxonomy: Term Name\" as the filter.','','7.28'),(4971,'/weebpal/forum-plus/fr/admin/structure/views/ajax/add-item/activity_stream/page/argument','default','Transform dashes in URL to spaces in term name filter values','','7.28'),(4972,'/weebpal/forum-plus/fr/admin/structure/views/ajax/add-item/activity_stream/page/argument','default','Type of user filter value to allow','','7.28'),(4973,'/weebpal/forum-plus/fr/admin/structure/views/ajax/add-item/activity_stream/page/argument','default','Only allow numeric UIDs','','7.28'),(4974,'/weebpal/forum-plus/fr/admin/structure/views/ajax/add-item/activity_stream/page/argument','default','Only allow string usernames','','7.28'),(4975,'/weebpal/forum-plus/fr/admin/structure/views/ajax/add-item/activity_stream/page/argument','default','Allow both numeric UIDs and string usernames','','7.28'),(4976,'/weebpal/forum-plus/fr/admin/structure/views/ajax/add-item/activity_stream/page/argument','default','Restrict user based on role','','7.28'),(4977,'/weebpal/forum-plus/fr/admin/structure/views/ajax/add-item/activity_stream/page/argument','default','Restrict to the selected roles','','7.28'),(4978,'/weebpal/forum-plus/fr/admin/structure/views/ajax/add-item/activity_stream/page/argument','default','If no roles are selected, users from any role will be allowed.','','7.28'),(4979,'/weebpal/forum-plus/fr/admin/structure/views/ajax/add-item/activity_stream/page/argument','default','PHP validate code','','7.28'),(4980,'/weebpal/forum-plus/fr/admin/structure/views/ajax/add-item/activity_stream/page/argument','default','Enter PHP code that returns TRUE or FALSE. No return is the same as FALSE, so be SURE to return something if you do not want to declare the argument invalid. Do not use &lt;?php ?&gt;. The argument to validate will be \"$argument\" and the view will be \"$view\". You may change the argument by setting \"$handler->argument\". You may change the title used for substitutions for this argument by setting \"$handler->validated_title\".','','7.28'),(4981,'/weebpal/forum-plus/fr/admin/structure/views/ajax/add-item/activity_stream/page/argument','default','Action to take if filter value does not validate','','7.28'),(4982,'/weebpal/forum-plus/fr/admin/structure/views/ajax/add-item/activity_stream/page/argument','default','Glossary mode','','7.28'),(4983,'/weebpal/forum-plus/fr/admin/structure/views/ajax/add-item/activity_stream/page/argument','default','Glossary mode applies a limit to the number of characters used in the filter value, which allows the summary view to act as a glossary.','','7.28'),(4984,'/weebpal/forum-plus/fr/admin/structure/views/ajax/add-item/activity_stream/page/argument','default','Character limit','','7.28'),(4985,'/weebpal/forum-plus/fr/admin/structure/views/ajax/add-item/activity_stream/page/argument','default','How many characters of the filter value to filter against. If set to 1, all fields starting with the first letter in the filter value would be matched.','','7.28'),(4986,'/weebpal/forum-plus/fr/admin/structure/views/ajax/add-item/activity_stream/page/argument','default','Case','','7.28'),(4987,'/weebpal/forum-plus/fr/admin/structure/views/ajax/add-item/activity_stream/page/argument','default','When printing the title and summary, how to transform the case of the filter value.','','7.28'),(4988,'/weebpal/forum-plus/fr/admin/structure/views/ajax/add-item/activity_stream/page/argument','default','Case in path','','7.28'),(4989,'/weebpal/forum-plus/fr/admin/structure/views/ajax/add-item/activity_stream/page/argument','default','When printing url paths, how to transform the case of the filter value. Do not use this unless with Postgres as it uses case sensitive comparisons.','','7.28'),(4990,'/weebpal/forum-plus/fr/admin/structure/views/ajax/add-item/activity_stream/page/argument','default','Transform spaces to dashes in URL','','7.28'),(4991,'/weebpal/forum-plus/fr/admin/structure/views/ajax/add-item/activity_stream/page/argument','default','Allow multiple values','','7.28'),(4992,'/weebpal/forum-plus/fr/admin/structure/views/ajax/add-item/activity_stream/page/argument','default','If selected, users can enter multiple values in the form of 1+2+3 (for OR) or 1,2,3 (for AND).','','7.28'),(4993,'/weebpal/forum-plus/fr/admin/structure/views/ajax/add-item/activity_stream/page/argument','default','Default sort','Sort order','7.28'),(4994,'/weebpal/forum-plus/fr/admin/structure/views/ajax/display/activity_stream/page/field_language','default','When needed, add the field language condition to the query','','7.28'),(4995,'/weebpal/forum-plus/fr/admin/structure/views/ajax/add-item/activity_stream/page/filter','default','Select all','','7.28'),(4996,'/weebpal/forum-plus/fr/admin/structure/views/ajax/add-item/activity_stream/page/filter','default','No language','','7.28'),(4997,'/weebpal/forum-plus/fr/admin/structure/views/ajax/add-item/activity_stream/page/filter','default','No valid values found on filter: @filter.','','7.28'),(4998,'/weebpal/forum-plus/fr/admin/structure/views/ajax/add-item/activity_stream/page/filter','default','This display has one or more validation errors; please review it.','','7.28'),(4999,'/weebpal/forum-plus/fr/admin/structure/views/view/activity_stream/preview/page/ajax','default','Unable to preview due to validation errors.','','7.28'),(5000,'/weebpal/forum-plus/fr/admin/structure/views/view/activity_stream/edit?render=overlay&render=overlay','default','The view %name has been saved.','','7.28'),(5001,'/weebpal/forum-plus/fr/admin/structure/views/view/activity_stream/edit?render=overlay','default','A calendar view of the \'@field_name\' field in the \'@base_table\' base table.','','7.32'),(5002,'/weebpal/forum-plus/fr/admin/structure/views/view/activity_stream/edit?render=overlay','default','calendar_comment_created','','7.32'),(5003,'/weebpal/forum-plus/fr/admin/structure/views/view/activity_stream/edit?render=overlay','default','Year','','7.32'),(5004,'/weebpal/forum-plus/fr/admin/structure/views/view/activity_stream/edit?render=overlay','default','Month','','7.32'),(5005,'/weebpal/forum-plus/fr/admin/structure/views/view/activity_stream/edit?render=overlay','default','Week','','7.32'),(5006,'/weebpal/forum-plus/fr/admin/structure/views/view/activity_stream/edit?render=overlay','default','Day','','7.32'),(5007,'/weebpal/forum-plus/fr/admin/structure/views/view/activity_stream/edit?render=overlay','default','iCal','','7.32'),(5008,'/weebpal/forum-plus/fr/admin/structure/views/view/activity_stream/edit?render=overlay','default','Upcoming','','7.32'),(5009,'/weebpal/forum-plus/fr/admin/structure/views/view/activity_stream/edit?render=overlay','default','Upcoming events block','','7.32'),(5010,'/weebpal/forum-plus/fr/admin/structure/views/view/activity_stream/edit?render=overlay','default','calendar_comment_changed','','7.32'),(5011,'/weebpal/forum-plus/fr/admin/structure/views/view/activity_stream/edit?render=overlay','default','calendar_message_timestamp','','7.32'),(5012,'/weebpal/forum-plus/fr/admin/structure/views/view/activity_stream/edit?render=overlay','default','calendar_node_last_comment_timestamp','','7.32'),(5013,'/weebpal/forum-plus/fr/admin/structure/views/view/activity_stream/edit?render=overlay','default','calendar_node_created','','7.32'),(5014,'/weebpal/forum-plus/fr/admin/structure/views/view/activity_stream/edit?render=overlay','default','calendar_node_changed','','7.32'),(5015,'/weebpal/forum-plus/fr/admin/structure/views/view/activity_stream/edit?render=overlay','default','calendar_node_timestamp','','7.32'),(5016,'/weebpal/forum-plus/fr/admin/structure/views/view/activity_stream/edit?render=overlay','default','Is the logged in user','','7.32'),(5017,'/weebpal/forum-plus/fr/admin/structure/views/view/activity_stream/edit?render=overlay','default','calendar_user_timestamp','','7.32'),(5018,'/weebpal/forum-plus/fr/admin/structure/views/view/activity_stream/edit?render=overlay','default','calendar_user_created','','7.32'),(5019,'/weebpal/forum-plus/fr/admin/structure/views/view/activity_stream/edit?render=overlay','default','calendar_user_access','','7.32'),(5020,'/weebpal/forum-plus/fr/admin/structure/views/view/activity_stream/edit?render=overlay','default','calendar_user_login','','7.32'),(5021,'/weebpal/forum-plus/fr/admin/structure/views/view/activity_stream/edit?render=overlay','default','Image gallery','','7.32'),(5022,'/weebpal/forum-plus/fr/admin/structure/views/view/activity_stream/edit?render=overlay','default','Gallery page','','7.32'),(5023,'/weebpal/forum-plus/fr/admin/structure/views/view/activity_stream/edit?render=overlay','default','UAS (User activity stream)','','7.32'),(5024,'/weebpal/forum-plus/fr/admin/structure/views/view/activity_stream/edit?render=overlay','default','Bellow is an example of a typical UAS (User activity stream), using the Message module.','','7.32'),(5025,'/weebpal/forum-plus/fr/admin/structure/views/view/activity_stream/edit?render=overlay','default','No messages created yet','','7.32'),(5026,'/weebpal/forum-plus/fr/admin/structure/views/view/activity_stream/edit?render=overlay','default','You should create some activity (manually or with Drush + Devel generate module):\n\n1) Register new users (<code>drush genu 10</code>)\n2) Create new content and comments (<code>drush genc 10 5</code>)\n\n','','7.32'),(5027,'/weebpal/forum-plus/fr/admin/structure/messages/manage/example_create_comment/clone?render=overlay','default','Clone @label','','7.28'),(5028,'/weebpal/forum-plus/fr/admin/structure/messages/manage/example_create_comment/clone?render=overlay','default','Delete message type','','7.28'),(5029,'/weebpal/forum-plus/fr/system/ajax','default','AHAH callback','','7.28'),(5030,'/weebpal/forum-plus/fr/admin/structure/messages/manage/example_create_comment/clone?render=overlay&render=overlay','default','!name field is required.','','7.34'),(5031,'/weebpal/forum-plus/fr/admin/structure/messages/manage/example_create_comment/clone?render=overlay&render=overlay','default','Attempt to create an instance of a field @field_name that doesn\'t exist or is currently inactive.','','7.28'),(5032,'/weebpal/forum-plus/fr/admin/structure/messages/manage/example_create_comment/clone?render=overlay&render=overlay','default','The website encountered an unexpected error. Please try again later.','','7.28'),(5033,'/weebpal/forum-plus/fr/system/ajax','default','The machine-readable name is already in use. It must be unique.','','7.28'),(5034,'/weebpal/forum-plus/fr/admin/structure/messages','default','A custom configuration by a user.','','7.28'),(5035,'/weebpal/forum-plus/fr/admin/structure/messages/manage/example_create_comment_fr/delete?destination=admin%2Fstructure%2Fmessages&render=overlay','default','Delete @label','','7.28'),(5036,'/weebpal/forum-plus/fr/admin/structure/messages/manage/example_create_comment_fr/delete?destination=admin%2Fstructure%2Fmessages&render=overlay','default','Are you sure you want to delete the %entity %label?','','7.28'),(5037,'/weebpal/forum-plus/fr/admin/structure/messages/manage/example_create_comment_fr/delete?destination=admin%2Fstructure%2Fmessages&render=overlay','default','This action cannot be undone.','','7.28'),(5038,'/weebpal/forum-plus/fr/admin/structure/messages/manage/example_create_comment_fr/delete?destination=admin%2Fstructure%2Fmessages&render=overlay','default','Confirm','','7.28'),(5039,'/weebpal/forum-plus/fr/admin/structure/messages/manage/example_create_comment_fr/delete?destination=admin%2Fstructure%2Fmessages&render=overlay&render=overlay','default','Deleted %entity %label.','','7.28'),(5040,'/weebpal/forum-plus/fr/forum/what-does-weebpal-do','default','Topic locked','','7.28'),(5041,'/weebpal/forum-plus/fr/node/1','default','!cnt votes','','7.34'),(5042,'/weebpal/forum-plus/fr/comment/reply/1','default','Your comment has been posted.','','7.28'),(5043,'/weebpal/forum-plus/fr/node/1','default','(!new new)','','7.34'),(5044,'/weebpal/forum-plus/fr/node/1','default','First unread','','7.34'),(5045,'/weebpal/forum-plus/fr/node/1','default','new','','7.34'),(5046,'/weebpal/forum-plus/fr','default','!title<br />by !author<br />@time ago','','7.28'),(5047,'/weebpal/forum-plus/fr/activity-stream','default','September','Long month name','7.28'),(5048,'/weebpal/forum-plus/fr/article/how-do-thoughts-form','default','<span class=\"author\">Submitted by !username</span><span class=\"created\">!datetime</span>','','7.34'),(5049,'/weebpal/forum-plus/fr/comment/17/edit','default','Comment permalink','','7.28'),(5050,'/weebpal/forum-plus/fr/comment/17/edit','default','Edit comment %comment','','7.28'),(5051,'/weebpal/forum-plus/fr/comment/17/edit','default','View comment','','7.28'),(5052,'sites/all/modules/ckeditor/includes/ckeditor.utils.js','default','Content can only be inserted into CKEditor in the WYSIWYG mode.','','none'),(5053,'/forum-plus/admin/config/regional/language?render=overlay','default','There are updates available for one or more of your modules or themes. To ensure the proper functioning of your site, you should update as soon as possible.','','7.32'),(5054,'/forum-plus/admin/config/regional/language?render=overlay','default','Out of date','','7.32'),(5055,'/forum-plus/admin/config/regional/language?render=overlay','default','Webform Hints settings','','7.39'),(5056,'/forum-plus/admin/config/regional/language?render=overlay','default','CKEditor','','7.39'),(5057,'/forum-plus/admin/config/regional/language?render=overlay','default','Configure the rich text editor.','','7.39'),(5058,'/forum-plus/admin/config/regional/language?render=overlay','default','Date views','','7.39'),(5059,'/forum-plus/admin/config/regional/language?render=overlay','default','Configure settings for date views.','','7.39'),(5060,'/forum-plus/admin/config/regional/language?render=overlay','default','Chosen','','7.39'),(5061,'/forum-plus/admin/config/regional/language?render=overlay','default','Configuration for Chosen plugin','','7.39'),(5062,'/forum-plus/admin/config/regional/language?render=overlay','default','Custom tokens','','7.39'),(5063,'/forum-plus/admin/config/regional/language?render=overlay','default','Administrate custom tokens.','','7.39'),(5064,'/forum-plus/admin/config/regional/language?render=overlay','default','Add token','','7.39'),(5065,'/forum-plus/admin/config/regional/language?render=overlay','default','Create custom tokens','','7.39'),(5066,'/forum-plus/admin/config/regional/language?render=overlay','default','Custom token types','','7.39'),(5067,'/forum-plus/admin/config/regional/language?render=overlay','default','View custom token types','','7.39'),(5068,'/forum-plus/admin/config/regional/language?render=overlay','default','Add token type','','7.39'),(5069,'/forum-plus/admin/config/regional/language?render=overlay','default','Create custom token types','','7.39'),(5070,'/forum-plus/admin/config/regional/language?render=overlay','default','List of custom tokens.','','7.39'),(5071,'/forum-plus/admin/config/regional/language?render=overlay','default','token_custom','','7.39'),(5072,'/forum-plus/admin/config/regional/language?render=overlay','default','ckeditor','','7.39'),(5073,'/forum-plus/admin/config/regional/language?render=overlay','default','Serial number','','7.39'),(5074,'/forum-plus/admin/config/regional/language?render=overlay','default','The serial number of the submission.','','7.39'),(5075,'/forum-plus/admin/config/regional/language?render=overlay','default','The value of a component as submitted by a user.','','7.39'),(5076,'/forum-plus/admin/config/regional/language?render=overlay','default','Webform submission data','','7.39'),(5077,'/forum-plus/admin/config/regional/language?render=overlay','default','Relates to a webform submission data','','7.39'),(5078,'/forum-plus/admin/config/regional/language?render=overlay','default','Submission Data','','7.39'),(5079,'/forum-plus/admin/config/regional/language?render=overlay','default','Data field','','7.39'),(5080,'/forum-plus/admin/config/regional/language?render=overlay','default','Value (raw)','','7.39'),(5081,'/forum-plus/admin/config/regional/language?render=overlay','default','The raw value from the database as submitted by a user. Use only when needing to sort on a field value.','','7.39'),(5082,'/forum-plus/admin/config/regional/language?render=overlay','default','Value delta','','7.39'),(5083,'/forum-plus/admin/config/regional/language?render=overlay','default','The delta value of the submitted data in a multi value component (such as checkboxes).','','7.39'),(5084,'/forum-plus/admin/config/regional/language?render=overlay','default','The attributes of the link.','','7.39'),(5085,'/forum-plus/admin/config/regional/language?render=overlay','default','field collection item revision from !field_name','','7.39'),(5086,'/forum-plus/admin/config/regional/language?render=overlay','default','Choose some options','','7.39'),(5087,'/forum-plus/admin/config/regional/language?render=overlay','default','Choose an option','','7.39'),(5088,'/forum-plus/admin/config/regional/language?render=overlay','default','No results match','','7.39'),(5089,'/forum-plus/','default','Rendered submissions','','7.39'),(5090,'/forum-plus/','default','Display the rendered submission','','7.39'),(5091,'/forum-plus/','default','Default Layout','','7.39'),(5092,'/forum-plus/','default','Back to Home','','7.39'),(5093,'/forum-plus/','default','Author Pane','','7.34'),(5094,'/forum-plus/','default','Recent blog posts','','7.34'),(5095,'/forum-plus/','default','Calendar Legend','','7.34'),(5096,'/forum-plus/','default','FAQ Categories','','7.34'),(5097,'/forum-plus/','default','Language switcher dropdown (@type)','','7.34'),(5098,'/forum-plus/','default','Language switcher (@type)','','7.34'),(5099,'/forum-plus/','default','Syndicate','','7.34'),(5100,'/forum-plus/','default','Recent content','','7.34'),(5101,'/forum-plus/','default','Main page content','','7.34'),(5102,'/forum-plus/','default','Powered by Drupal','','7.34'),(5103,'/forum-plus/','default','System help','','7.34'),(5104,'/forum-plus/','default','User login','','7.34'),(5105,'/forum-plus/','default','View: !view','','7.34'),(5106,'/forum-plus/','default','View: !view: !display','','7.34'),(5107,'/forum-plus/','default','See the <a href=\"@available_updates\">available updates</a> page for more information.','','7.32'),(5108,'/forum-plus/','default','Your site is currently configured to send these emails when any updates are available. To get notified only for security updates, !url.','','7.32'),(5109,'/forum-plus/ar/admin/appearance/settings/forum_plus?render=overlay','default','Logo','','7.32'),(5110,'/forum-plus/ar/admin/appearance/settings/forum_plus?render=overlay','default','User pictures in posts','','7.32'),(5111,'/forum-plus/ar/admin/appearance/settings/forum_plus?render=overlay','default','User pictures in comments','','7.32'),(5112,'/forum-plus/ar/admin/appearance/settings/forum_plus?render=overlay','default','User verification status in comments','','7.32'),(5113,'/forum-plus/ar/admin/appearance/settings/forum_plus?render=overlay','default','Shortcut icon','','7.32'),(5114,'/forum-plus/ar/admin/appearance/settings/forum_plus?render=overlay','default','Secondary menu','','7.32'),(5115,'/forum-plus/ar/admin/appearance/settings/forum_plus?render=overlay','default','Toggle display','','7.32'),(5116,'/forum-plus/ar/admin/appearance/settings/forum_plus?render=overlay','default','Enable or disable the display of certain page elements.','','7.32'),(5117,'/forum-plus/ar/admin/appearance/settings/forum_plus?render=overlay','default','Logo image settings','','7.32'),(5118,'/forum-plus/ar/admin/appearance/settings/forum_plus?render=overlay','default','If toggled on, the following logo will be displayed.','','7.32'),(5119,'/forum-plus/ar/admin/appearance/settings/forum_plus?render=overlay','default','Use the default logo','','7.32'),(5120,'/forum-plus/ar/admin/appearance/settings/forum_plus?render=overlay','default','Check here if you want the theme to use the logo supplied with it.','','7.32'),(5121,'/forum-plus/ar/admin/appearance/settings/forum_plus?render=overlay','default','Path to custom logo','','7.32'),(5122,'/forum-plus/ar/admin/appearance/settings/forum_plus?render=overlay','default','The path to the file you would like to use as your logo file instead of the default logo.','','7.32'),(5123,'/forum-plus/ar/admin/appearance/settings/forum_plus?render=overlay','default','Upload logo image','','7.32'),(5124,'/forum-plus/ar/admin/appearance/settings/forum_plus?render=overlay','default','If you don\'t have direct file access to the server, use this field to upload your logo.','','7.32'),(5125,'/forum-plus/ar/admin/appearance/settings/forum_plus?render=overlay','default','Shortcut icon settings','','7.32'),(5126,'/forum-plus/ar/admin/appearance/settings/forum_plus?render=overlay','default','Your shortcut icon, or \'favicon\', is displayed in the address bar and bookmarks of most browsers.','','7.32'),(5127,'/forum-plus/ar/admin/appearance/settings/forum_plus?render=overlay','default','Use the default shortcut icon.','','7.32'),(5128,'/forum-plus/ar/admin/appearance/settings/forum_plus?render=overlay','default','Check here if you want the theme to use the default shortcut icon.','','7.32'),(5129,'/forum-plus/ar/admin/appearance/settings/forum_plus?render=overlay','default','Path to custom icon','','7.32'),(5130,'/forum-plus/ar/admin/appearance/settings/forum_plus?render=overlay','default','The path to the image file you would like to use as your custom shortcut icon.','','7.32'),(5131,'/forum-plus/ar/admin/appearance/settings/forum_plus?render=overlay','default','Upload icon image','','7.32'),(5132,'/forum-plus/ar/admin/appearance/settings/forum_plus?render=overlay','default','If you don\'t have direct file access to the server, use this field to upload your shortcut icon.','','7.32'),(5133,'/forum-plus/ar/admin/appearance/settings/forum_plus?render=overlay','default','Configs','','7.32'),(5134,'/forum-plus/ar/admin/appearance/settings/forum_plus?render=overlay','default','Skin','','7.32'),(5135,'/forum-plus/ar/admin/appearance/settings/forum_plus?render=overlay','default','Background','','7.32'),(5136,'/forum-plus/ar/admin/appearance/settings/forum_plus?render=overlay','default','Layout','','7.32'),(5137,'/forum-plus/ar/admin/appearance/settings/forum_plus?render=overlay','default','Layout Width(px)','','7.32'),(5138,'/forum-plus/ar/admin/appearance/settings/forum_plus?render=overlay','default','Show Skins Menu','','7.32'),(5139,'/forum-plus/ar/admin/appearance/settings/forum_plus?render=overlay','default','Use loading','','7.32'),(5140,'/forum-plus/ar/admin/appearance/settings/forum_plus?render=overlay','default','Reset theme settings','','7.32'),(5141,'/forum-plus/ar/admin/appearance/settings/forum_plus?render=overlay','default','Feedback Form','','7.32'),(5142,'/forum-plus/ar/admin/appearance/settings/forum_plus?render=overlay','default','These options control the display settings for the %name theme. When your site is displayed using this theme, these settings will be used.','','7.32'),(5143,'/forum-plus/ar','default','Please enter some keywords.','','7.32'),(5144,'/forum-plus/ar/search/node/','default','Enter your keywords','','7.32'),(5145,'/forum-plus/ar/search/node/','default','Advanced search','','7.32'),(5146,'/forum-plus/ar/search/node/','default','Containing any of the words','','7.32'),(5147,'/forum-plus/ar/search/node/','default','Containing the phrase','','7.32'),(5148,'/forum-plus/ar/search/node/','default','Containing none of the words','','7.32'),(5149,'/forum-plus/ar/search/node/','default','Only of the type(s)','','7.32'),(5150,'/forum-plus/ar/modal_forms/ajax/login','default','Log in','','7.34'),(5151,'/forum-plus/ar/modal_forms/ajax/login','default','Enter your @s username.','','7.34'),(5152,'/forum-plus/ar/modal_forms/ajax/login','default','Enter the password that accompanies your username.','','7.34'),(5153,'/forum-plus/ar/modal_forms/ajax/login','default','Remember me','','7.34'),(5154,'/forum-plus/ar/modal_forms/ajax/login','default','Create a new user account','','7.34'),(5155,'/forum-plus/ar/forum/6','default','<a href=\"@login\">Log in</a> to post new content in the forum.','','7.32'),(5156,'/forum-plus/ar/forum/headline-news','default','<a href=\"@login\">Log in</a> or <a href=\"@register\">register</a> to post comments','','7.34'),(5157,'/forum-plus/ar/forum/headline-news','default','Rich text editor settings','','7.39'),(5158,'/forum-plus/ar/forum/headline-news','default','1 hour','','7.32'),(5159,'/forum-plus/ar/modal_forms/ajax/login','default','Submission','','7.39'),(5160,'/forum-plus/ar/modal_forms/ajax/login','default','Tokens related to webform submissions.','','7.39'),(5161,'/forum-plus/ar/modal_forms/ajax/login','default','The serial number of this webform submission.','','7.39'),(5162,'/forum-plus/ar/modal_forms/ajax/login','default','Submission ID','','7.39'),(5163,'/forum-plus/ar/modal_forms/ajax/login','default','The unique indentifier for the webform submission.','','7.39'),(5164,'/forum-plus/ar/modal_forms/ajax/login','default','Date submitted','','7.39'),(5165,'/forum-plus/ar/modal_forms/ajax/login','default','The date the webform was submitted.','','7.34'),(5166,'/forum-plus/ar/modal_forms/ajax/login','default','The IP address that was used when submitting the webform.','','7.39'),(5167,'/forum-plus/ar/modal_forms/ajax/login','default','Submitter','','7.39'),(5168,'/forum-plus/ar/modal_forms/ajax/login','default','The user that submitted the webform result.','','7.39'),(5169,'/forum-plus/ar/modal_forms/ajax/login','default','Webform tokens related to URLs.','','7.32'),(5170,'/forum-plus/ar/modal_forms/ajax/login','default','Webform submission values','','7.39'),(5171,'/forum-plus/ar/modal_forms/ajax/login','default','Webform tokens from submitted data. Replace the \"?\" with the \"field key\", including any parent field keys separated by colons. You may append \":label\" for just the label or \":withlabel\" for both the label and value together. Append \":key\" for just the key in a key|label pair.','','7.34'),(5172,'/forum-plus/ar/modal_forms/ajax/login','default','December','Long month name','7.32'),(5173,'/forum-plus/ar/modal_forms/ajax/login','default','User created tokens types using the Custom Tokens module.','','7.39'),(5174,'/forum-plus/ar/modal_forms/ajax/login','default','Required indicator','','7.39'),(5175,'/forum-plus/ar/modal_forms/ajax/login','default','Appends to the hint text of a required component.','','7.39'),(5176,'/forum-plus/ar/modal_forms/ajax/login','default','Login success','','7.34'),(5177,'/forum-plus/ar/forum/headline-news','default','Switch to plain text editor','','7.39'),(5178,'/forum-plus/ar/forum/headline-news','default','Switch to rich text editor','','7.39'),(5179,'/forum-plus/ar/admin/config?render=overlay','default','Chosen JavaScript file','','7.32'),(5180,'/forum-plus/ar/admin/config?render=overlay','default','Not enabled','','7.32'),(5181,'/forum-plus/ar/admin/config?render=overlay','default','Your server is capable of displaying file upload progress, but does not have the required libraries. It is recommended to install the <a href=\"http://pecl.php.net/package/uploadprogress\">PECL uploadprogress library</a> (preferred) or to install <a href=\"http://us2.php.net/apc\">APC</a>.','','7.32'),(5182,'/forum-plus/ar/admin/config?render=overlay','default','The directory %file is not protected from modifications and poses a security risk. You must change the directory\'s permissions to be non-writable. ','','7.32'),(5183,'/forum-plus/ar/admin/config?render=overlay','default','Some modules have database schema updates to install. You should run the <a href=\"@update\">database update script</a> immediately.','','7.32'),(5184,'/forum-plus/ar/admin/config?render=overlay','default','Problems detected','','7.32'),(5185,'/forum-plus/ar/admin/config/regional/language?render=overlay&render=overlay','default','Configuration saved.','','7.32'),(5186,'/forum-plus/ar/faq-page','default','Q:','','7.39'),(5187,'/forum-plus/ar/faq-page','default','A:','','7.39'),(5188,'/forum-plus/ar/faq-page','default','Edit answer','','7.39'),(5189,'/forum-plus/ar/faq-page','default','expand all','','7.32'),(5190,'/forum-plus/ar/faq-page','default','collapse all','','7.32'),(5191,'/forum-plus/ar/calendar','default','Year','datetime','7.32'),(5192,'/forum-plus/ar/calendar','default','Month','datetime','7.32'),(5193,'/forum-plus/ar/calendar','default','Day','datetime','7.32'),(5194,'/forum-plus/ar/calendar','default','Hour','datetime','7.32'),(5195,'/forum-plus/ar/calendar','default','Minute','datetime','7.32'),(5196,'/forum-plus/ar/calendar','default','Second','datetime','7.32'),(5197,'/forum-plus/ar/node/add/forum?render=overlay','default','- Select a value -','','7.34'),(5198,'/forum-plus/ar/articles-teaser','default','Read more<span class=\"element-invisible\"> about @title</span>','','7.34'),(5199,'/forum-plus/ar/articles-teaser','default','Jump to the first comment of this posting.','','7.34'),(5200,'/forum-plus/ar/blog','default','RSS - blogs','','7.32'),(5201,'/forum-plus/ar/blogs/mix','default','Blog Mix','','7.32'),(5202,'/forum-plus/ar/articles-teaser','default','Add a new comment to this page.','','7.34'),(5203,'/forum-plus/ar/blog','default','Create new blog entry','','7.32'),(5204,'/forum-plus/','default','Block - Recent FAQs','','7.32'),(5205,'/forum-plus/','default','Block - Random FAQs','','7.32'),(5206,'/forum-plus/','default','Page - Questions Inline','','7.32'),(5207,'/forum-plus/','default','Page - Questions Top','','7.32'),(5208,'/forum-plus/','default','<h3><a id=\"n[nid]\">[title]</a></h3>','','7.32'),(5209,'/forum-plus/','default','Attachment - Questions Top','','7.32'),(5210,'/forum-plus/','default','faq-questions-top#n[nid]','','7.32'),(5211,'/forum-plus/','default','Page - New Page','','7.32'),(5212,'/forum-plus/','default','Page - Categories Inline - New Page','','7.32'),(5213,'/forum-plus/','default','Resize','','7.32'),(5214,'/forum-plus/','default','Resizing will make images an exact set of dimensions. This may cause images to be stretched or shrunk disproportionately.','','7.32'),(5215,'/forum-plus/','default','Scale','','7.32'),(5216,'/forum-plus/','default','Scaling will maintain the aspect-ratio of the original image. If only a single dimension is specified, the other dimension will be calculated.','','7.32'),(5217,'/forum-plus/','default','Scale and crop','','7.32'),(5218,'/forum-plus/','default','Scale and crop will maintain the aspect-ratio of the original image, then crop the larger dimension. This is most useful for creating perfectly square thumbnails without stretching the image.','','7.32'),(5219,'/forum-plus/','default','Crop','','7.32'),(5220,'/forum-plus/','default','Cropping will remove portions of an image to make it the specified dimensions.','','7.32'),(5221,'/forum-plus/','default','Desaturate','','7.32'),(5222,'/forum-plus/','default','Desaturate converts an image to grayscale.','','7.32'),(5223,'/forum-plus/','default','Rotate','','7.32'),(5224,'/forum-plus/','default','Rotating an image may cause the dimensions of an image to increase to fit the diagonal.','','7.32'),(5225,'/forum-plus/sites/default/files/styles/thumbnail/public/pictures/picture-1-1406684588.jpg?itok=XfUd7YFR','default','Generate image style','','7.32'),(5226,'/forum-plus/sites/default/files/styles/thumbnail/public/pictures/picture-1-1406684588.jpg?itok=XfUd7YFR','default','GD2 image manipulation toolkit','','7.32'),(5227,'/forum-plus/ar/users/admin','default','Blog','','7.34'),(5228,'/forum-plus/ar/users/admin','default','View recent blog entries','','7.34'),(5229,'/forum-plus/ar/admin/config/development/performance?render=overlay','default','Clear cache','','7.32'),(5230,'/forum-plus/ar/admin/config/development/performance?render=overlay','default','Clear all caches','','7.32'),(5231,'/forum-plus/ar/admin/config/development/performance?render=overlay','default','0 sec','','7.32'),(5232,'/forum-plus/ar/admin/config/development/performance?render=overlay','default','1 day','','7.32'),(5233,'/forum-plus/ar/admin/config/development/performance?render=overlay','default','Bandwidth optimization','','7.32'),(5234,'/forum-plus/ar/admin/config/development/performance?render=overlay&render=overlay','default','Simple (with optional filter by bundle)','','7.32'),(5235,'/forum-plus/ar/admin/config/development/performance?render=overlay&render=overlay','default','Views: Filter by an entity reference view','','7.32'),(5236,'/forum-plus/ar/admin/config/development/performance?render=overlay&render=overlay','default','Taxonomy index','','7.32'),(5237,'/forum-plus/ar/admin/config/development/performance?render=overlay&render=overlay','default','Include the term references created by instances of this field carried by node entities in the core {taxonomy_index} table. This will allow various modules to handle them like core term_reference fields.','','7.32'),(5238,'/forum-plus/ar/admin/config/development/performance?render=overlay&render=overlay','default','Render Views filters as select list','','7.32'),(5239,'/forum-plus/ar/admin/config/development/performance?render=overlay&render=overlay','default','Provides a select list for Views filters on this field. This should not be used when there are over 100 entities, as it might cause an out of memory error.','','7.32'),(5240,'/forum-plus/ar/admin/config/development/performance?render=overlay&render=overlay','default','Number of hits','','7.32'),(5241,'/forum-plus/ar/admin/config/development/performance?render=overlay&render=overlay','default','Content revisions','','7.32'),(5242,'/forum-plus/ar/admin/config/development/performance?render=overlay&render=overlay','default','Publish comment','','7.32'),(5243,'/forum-plus/ar/admin/config/development/performance?render=overlay&render=overlay','default','Unpublish comment','','7.32'),(5244,'/forum-plus/ar/admin/config/development/performance?render=overlay&render=overlay','default','Unpublish comment containing keyword(s)','','7.32'),(5245,'/forum-plus/ar/admin/config/development/performance?render=overlay&render=overlay','default','Save comment','','7.32'),(5246,'/forum-plus/ar/admin/config/development/performance?render=overlay&render=overlay','default','Publish content','','7.32'),(5247,'/forum-plus/ar/admin/config/development/performance?render=overlay&render=overlay','default','Unpublish content','','7.32'),(5248,'/forum-plus/ar/admin/config/development/performance?render=overlay&render=overlay','default','Make content sticky','','7.32'),(5249,'/forum-plus/ar/admin/config/development/performance?render=overlay&render=overlay','default','Make content unsticky','','7.32'),(5250,'/forum-plus/ar/admin/config/development/performance?render=overlay&render=overlay','default','Promote content to front page','','7.32'),(5251,'/forum-plus/ar/admin/config/development/performance?render=overlay&render=overlay','default','Remove content from front page','','7.32'),(5252,'/forum-plus/ar/admin/config/development/performance?render=overlay&render=overlay','default','Change the author of content','','7.32'),(5253,'/forum-plus/ar/admin/config/development/performance?render=overlay&render=overlay','default','Save content','','7.32'),(5254,'/forum-plus/ar/admin/config/development/performance?render=overlay&render=overlay','default','Unpublish content containing keyword(s)','','7.32'),(5255,'/forum-plus/ar/admin/config/development/performance?render=overlay&render=overlay','default','Display a message to the user','','7.32'),(5256,'/forum-plus/ar/admin/config/development/performance?render=overlay&render=overlay','default','Send e-mail','','7.32'),(5257,'/forum-plus/ar/admin/config/development/performance?render=overlay&render=overlay','default','Ban IP address of current user','','7.32'),(5258,'/forum-plus/ar/admin/config/development/performance?render=overlay&render=overlay','default','Redirect to URL','','7.32'),(5259,'/forum-plus/ar/admin/config/development/performance?render=overlay&render=overlay','default','Block current user','','7.32'),(5260,'/forum-plus/ar/admin/config/development/performance?render=overlay&render=overlay','default','Update node alias','','7.32'),(5261,'/forum-plus/ar/admin/config/development/performance?render=overlay&render=overlay','default','Update taxonomy term alias','','7.32'),(5262,'/forum-plus/ar/admin/config/development/performance?render=overlay&render=overlay','default','Update user alias','','7.32'),(5263,'/forum-plus/ar/admin/config/development/performance?render=overlay&render=overlay','default','CKEditor profiles','','7.32'),(5264,'/forum-plus/ar/admin/config/development/performance?render=overlay&render=overlay','default','Caches cleared.','','7.32'),(5265,'sites/all/modules/context/plugins/context_reaction_block.js','default','Desired block weight exceeds available weight options, please check weights for blocks before saving','','none'),(5266,'sites/all/modules/context/plugins/context_reaction_block.js','default','Now Editing: ','','none'),(5267,'/forum-plus/user','default','Mobile Menu','','7.32'),(5268,'/forum-plus/ar/users/admin','default','context','','7.34'),(5269,'/forum-plus/ar/users/admin','default','contexts','','7.34'),(5270,'/forum-plus/ar/users/admin','default','Contexts','','7.34'),(5271,'/forum-plus/ar/users/admin','default','Associate menus, views, blocks, etc. with different contexts to structure your site.','','7.34'),(5272,'/forum-plus/ar/users/admin','default','context_layouts','','7.34'),(5273,'/forum-plus/ar/users/admin','default','context_ui','','7.34'),(5274,'/forum-plus/user','default','Context editor','','7.34'),(5275,'/forum-plus/user','default','Unable to send e-mail. Contact the site administrator if the problem persists.','','7.34'),(5276,'/forum-plus/ar','default','Context (any)','','7.34'),(5277,'/forum-plus/ar','default','Set this context on the basis of other active contexts. Put each context on a separate line. The condition will pass if <em>any</em> of the contexts are active. You can use the <code>*</code> character (asterisk) as a wildcard and the <code>~</code> character (tilde) to prevent this context from activating if the listed context is active. Other contexts which use context conditions can not be used to exclude this context from activating.','','7.34'),(5278,'/forum-plus/ar','default','Context (all)','','7.34'),(5279,'/forum-plus/ar','default','Set this context on the basis of other active contexts. Put each context on a separate line. The condition will pass only if <em>all</em> of the contexts are active. You can use the <code>*</code> character (asterisk) as a wildcard and the <code>~</code> character (tilde) to prevent this context from activating if the listed context is active. Other contexts which use context conditions can not be used to exclude this context from activating.','','7.34'),(5280,'/forum-plus/ar','default','Set this context when viewing a node page or using the add/edit form of one of these content types.','','7.34'),(5281,'/forum-plus/ar','default','Sitewide context','','7.34'),(5282,'/forum-plus/ar','default','Should this context always be set? If <strong>true</strong>, this context will be active across your entire site.','','7.34'),(5283,'/forum-plus/ar','default','Default context','','7.34'),(5284,'/forum-plus/ar','default','This context will be set if no other context is active except sitewide contexts.','','7.34'),(5285,'/forum-plus/ar','default','Set this context when any of the paths above match the page path. Put each path on a separate line. You can use the <code>*</code> character (asterisk) as a wildcard and the <code>~</code> character (tilde) to exclude one or more paths. Use &lt;front&gt; for the site front page.','','7.34'),(5286,'/forum-plus/ar','default','Query String','','7.34'),(5287,'/forum-plus/ar','default','Set this context when any of the query strings above match the page query string. Put each query string on a separate line. You can use the \"*\" character as a wildcard and <code>~</code> to exclude one or more query strings.','','7.34'),(5288,'/forum-plus/ar','default','User role','','7.34'),(5289,'/forum-plus/ar','default','Set this context when the current user has one of the selected role(s).','','7.34'),(5290,'/forum-plus/ar','default','User page','','7.34'),(5291,'/forum-plus/ar','default','Set this context when viewing a user page.','','7.34'),(5292,'/forum-plus/ar','default','Set this context when any of the selected menu items belong to the current active menu trail.','','7.34'),(5293,'/forum-plus/ar','default','Set this context when displaying the page of one of these views.','','7.34'),(5294,'/forum-plus/ar','default','Set this context when a node in the selected book is viewed.','','7.34'),(5295,'/forum-plus/ar','default','Book root','','7.34'),(5296,'/forum-plus/ar','default','Set this context when viewing a node whose root book is of the selected type.','','7.34'),(5297,'/forum-plus/ar','default','Set this context when viewing the site in the selected language.','','7.34'),(5298,'/forum-plus/ar','default','Set this context when viewing a node with the selected taxonomy terms.','','7.34'),(5299,'/forum-plus/ar','default','Set this context when viewing a taxonomy term page.','','7.34'),(5300,'/forum-plus/ar','default','Control block visibility using context.','','7.34'),(5301,'/forum-plus/ar','default','Regions','','7.34'),(5302,'/forum-plus/ar','default','Control Region visiblity using context.','','7.34'),(5303,'/forum-plus/ar','default','Set the breadcrumb trail to the selected menu item.','','7.34'),(5304,'/forum-plus/ar','default','Template suggestions','','7.34'),(5305,'/forum-plus/ar','default','Add template suggestions using context.','','7.34'),(5306,'/forum-plus/ar','default','Theme Page','','7.34'),(5307,'/forum-plus/ar','default','Control page theme variables using context.','','7.34'),(5308,'/forum-plus/ar','default','Theme HTML','','7.34'),(5309,'/forum-plus/ar','default','Control HTML theme variables using context.','','7.34'),(5310,'/forum-plus/ar','default','Debug','','7.34'),(5311,'/forum-plus/ar','default','Debug output reaction for SimpleTest.','','7.34'),(5312,'/forum-plus/ar','default','Control menu active class using context.','','7.34'),(5313,'/forum-plus/ar/forum/database-server','default','1 post','','7.39'),(5314,'/forum-plus/ar','default','Search result highlighting input','','7.39'),(5315,'/forum-plus/ar','default','Panel Mobile Menu','','7.34'),(5316,'/forum-plus/ar','default','All values','','7.39'),(5317,'/forum-plus/ar','default','Displays all values as submitted by a user.','','7.39'),(5318,'/forum-plus/ar','default','Result summary with additional tokens','','7.34'),(5319,'/forum-plus/ar','default','Shows result summary, for example the items per page (and links to change the items per page).','','7.34'),(5320,'/forum-plus/ar/activity-stream','default','Webform tokens related to the submission\'s URL.','','7.39'),(5321,'/forum-plus/ar/activity-stream','default','Webform tokens related to the submission\'s Edit URL.','','7.39'),(5322,'/forum-plus/ar/activity-stream','default','February','Long month name','7.34'),(5323,'/forum-plus/ar/activity-stream','default','fontawesome','','7.34'),(5324,'/forum-plus/ar/article/31-healthy-foods-you-should-be-eating-now','default','[link path=\"the Drupal path\"]link text[/link]','','7.39'),(5325,'/forum-plus/ar/article/31-healthy-foods-you-should-be-eating-now','default','Inserts aliased Drupal path around the link text.','','7.39'),(5326,'/forum-plus/ar/article/31-healthy-foods-you-should-be-eating-now','default','Embeds video into the content text. With the <em>width</em> and <em>height</em> parameter you can specify the video size.','','7.39'),(5327,'/forum-plus/ar/contact','default','Your message has been sent.','','7.34'),(5328,'/ar','default','Webform nodes','','7.39'),(5329,'/ar','default','Nodes which have webforms.','','7.39'),(5330,'/ar','default','The node this webform is part of.','','7.39'),(5331,'/ar','default','Node for webform','','7.39'),(5332,'/ar','default','Result summary with an additional token to change the items/page','','7.39'),(5333,'/ar','default','Shows result summary, for example the items per page, plus links to change the items per page.','','7.39'),(5334,'/ar','default','1 year','','7.39'),(5335,'/ar','default','Timestamp when the form was first saved as draft or submitted.','','7.39'),(5336,'/ar','default','Completed','','7.39'),(5337,'/ar','default','Timestamp when the form was submitted as complete (not draft).','','7.39'),(5338,'/ar','default','Modified','','7.39'),(5339,'/ar','default','Timestamp when the form was last saved (complete or draft).','','7.39'),(5340,'/ar','default','Data field (numeric)','','7.39'),(5341,'/ar','default','The numeric value of a component as submitted by a user.','','7.39'),(5342,'/ar','default','Numeric value (raw)','','7.39'),(5343,'/ar','default','The raw value from the database, cast to a number, as submitted by a user. Use only when needing to sort on a field value.','','7.39'),(5344,'/drupal7/forum-plus/en/admin/structure/views/view/blogs/edit/page_4?render=overlay&render=overlay','default','Read more...','','7.39'),(5345,'misc/drupal.js','default','CustomMessage: !customMessage','','none'),(5346,'misc/ajax.js','default','The response failed verification so will not be processed.','','none'),(5347,'misc/ajax.js','default','The callback URL is not local and not trusted: !url','','none'),(5348,'/ar','default','Oct','','7.39'),(5349,'/ar','default','Sep','','7.39'),(5350,'/ar','default','Video Embed Field','','7.39'),(5351,'/ar','default','Video Embed Field configuration','','7.39'),(5352,'/ar','default','Video Embed Field module settings','','7.39'),(5353,'/ar/node/69','default','Inserts a link formatted like as a button. The <em>path</em> parameter provides the link target (the default is the front page).\r\n    The <em>title</em> will be formatted as a link title (small tooltip over the link - helps for SEO).\r\n    Additional class names can be added by the <em>class</em> parameter.','','7.39'),(5354,'/ar/activity-stream','default','Access token','','7.39'),(5355,'/ar/activity-stream','default','The security token used to gain access to this webform submission.','','7.39'),(5356,'/ar/activity-stream','default','The date the webform was first save as draft or completed.','','7.39'),(5357,'/ar/activity-stream','default','Date completed','','7.39'),(5358,'/ar/activity-stream','default','The date the webform was first completed (not draft).','','7.39'),(5359,'/ar/activity-stream','default','Date modified','','7.39'),(5360,'/ar/activity-stream','default','The date the webform was last saved (draft or completed).','','7.39'),(5361,'/ar/activity-stream','default','Webform tokens from submitted data. Replace the \"?\" with the \"field key\", including any parent field keys separated by colons. You can append:','','7.39'),(5362,'/ar/activity-stream','default','the question key for just that one question (grid components).','','7.39'),(5363,'/ar/activity-stream','default','the option key for just that one option (grid and select components).','','7.39'),(5364,'/ar/activity-stream','default','<code>@token</code> for the value without the label (the default).','','7.39'),(5365,'/ar/activity-stream','default','<code>@token</code> for just the label.','','7.39'),(5366,'/ar/activity-stream','default','<code>@token</code> for both the label and value together.','','7.39'),(5367,'/ar/activity-stream','default','<code>@token</code> for just the key in a key|label pair (grid and select components).','','7.39'),(5368,'/ar/activity-stream','default','November','Long month name','7.39'),(5369,'modules/dashboard/dashboard.js','default','Done','','none');
/*!40000 ALTER TABLE `locales_source` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `locales_target`
--

DROP TABLE IF EXISTS `locales_target`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `locales_target` (
  `lid` int(11) NOT NULL DEFAULT '0' COMMENT 'Source string ID. References locales_source.lid.',
  `translation` blob NOT NULL COMMENT 'Translation string value in this language.',
  `language` varchar(12) NOT NULL DEFAULT '' COMMENT 'Language code. References languages.language.',
  `plid` int(11) NOT NULL DEFAULT '0' COMMENT 'Parent lid (lid of the previous string in the plural chain) in case of plural strings. References locales_source.lid.',
  `plural` int(11) NOT NULL DEFAULT '0' COMMENT 'Plural index number in case of plural strings.',
  `i18n_status` int(11) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this translation needs to be updated.',
  PRIMARY KEY (`language`,`lid`,`plural`),
  KEY `lid` (`lid`),
  KEY `plid` (`plid`),
  KEY `plural` (`plural`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Stores translated versions of strings.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `locales_target`
--

LOCK TABLES `locales_target` WRITE;
/*!40000 ALTER TABLE `locales_target` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `locales_target` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `menu_custom`
--

DROP TABLE IF EXISTS `menu_custom`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `menu_custom` (
  `menu_name` varchar(32) NOT NULL DEFAULT '' COMMENT 'Primary Key: Unique key for menu. This is used as a block delta so length is 32.',
  `title` varchar(255) NOT NULL DEFAULT '' COMMENT 'Menu title; displayed at top of block.',
  `description` text COMMENT 'Menu description.',
  PRIMARY KEY (`menu_name`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Holds definitions for top-level custom menus (for example...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `menu_custom`
--

LOCK TABLES `menu_custom` WRITE;
/*!40000 ALTER TABLE `menu_custom` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `menu_custom` VALUES ('features','Features','Menu items for any enabled features.'),('main-menu','Main menu','The <em>Main</em> menu is used on many sites to show the major sections of the site, often in a top navigation bar.'),('management','Management','The <em>Management</em> menu contains links for administrative tasks.'),('menu-categories','Categories',''),('menu-footer-menu','Footer menu',''),('menu-links','Links',''),('menu-sections','Sections',''),('navigation','Navigation','The <em>Navigation</em> menu contains links intended for site visitors. Links are added to the <em>Navigation</em> menu automatically by some modules.'),('user-menu','User menu','The <em>User</em> menu contains links related to the user\'s account, as well as the \'Log out\' link.');
/*!40000 ALTER TABLE `menu_custom` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `menu_links`
--

DROP TABLE IF EXISTS `menu_links`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `menu_links` (
  `menu_name` varchar(32) NOT NULL DEFAULT '' COMMENT 'The menu name. All links with the same menu name (such as ’navigation’) are part of the same menu.',
  `mlid` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'The menu link ID (mlid) is the integer primary key.',
  `plid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The parent link ID (plid) is the mlid of the link above in the hierarchy, or zero if the link is at the top level in its menu.',
  `link_path` varchar(255) NOT NULL DEFAULT '' COMMENT 'The Drupal path or external path this link points to.',
  `router_path` varchar(255) NOT NULL DEFAULT '' COMMENT 'For links corresponding to a Drupal path (external = 0), this connects the link to a menu_router.path for joins.',
  `link_title` varchar(255) NOT NULL DEFAULT '' COMMENT 'The text displayed for the link, which may be modified by a title callback stored in menu_router.',
  `options` blob COMMENT 'A serialized array of options to be passed to the url() or l() function, such as a query string or HTML attributes.',
  `module` varchar(255) NOT NULL DEFAULT 'system' COMMENT 'The name of the module that generated this link.',
  `hidden` smallint(6) NOT NULL DEFAULT '0' COMMENT 'A flag for whether the link should be rendered in menus. (1 = a disabled menu item that may be shown on admin screens, -1 = a menu callback, 0 = a normal, visible link)',
  `external` smallint(6) NOT NULL DEFAULT '0' COMMENT 'A flag to indicate if the link points to a full URL starting with a protocol, like http:// (1 = external, 0 = internal).',
  `has_children` smallint(6) NOT NULL DEFAULT '0' COMMENT 'Flag indicating whether any links have this link as a parent (1 = children exist, 0 = no children).',
  `expanded` smallint(6) NOT NULL DEFAULT '0' COMMENT 'Flag for whether this link should be rendered as expanded in menus - expanded links always have their child links displayed, instead of only when the link is in the active trail (1 = expanded, 0 = not expanded)',
  `weight` int(11) NOT NULL DEFAULT '0' COMMENT 'Link weight among links in the same menu at the same depth.',
  `depth` smallint(6) NOT NULL DEFAULT '0' COMMENT 'The depth relative to the top level. A link with plid == 0 will have depth == 1.',
  `customized` smallint(6) NOT NULL DEFAULT '0' COMMENT 'A flag to indicate that the user has manually created or edited the link (1 = customized, 0 = not customized).',
  `p1` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The first mlid in the materialized path. If N = depth, then pN must equal the mlid. If depth > 1 then p(N-1) must equal the plid. All pX where X > depth must equal zero. The columns p1 .. p9 are also called the parents.',
  `p2` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The second mlid in the materialized path. See p1.',
  `p3` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The third mlid in the materialized path. See p1.',
  `p4` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The fourth mlid in the materialized path. See p1.',
  `p5` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The fifth mlid in the materialized path. See p1.',
  `p6` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The sixth mlid in the materialized path. See p1.',
  `p7` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The seventh mlid in the materialized path. See p1.',
  `p8` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The eighth mlid in the materialized path. See p1.',
  `p9` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The ninth mlid in the materialized path. See p1.',
  `updated` smallint(6) NOT NULL DEFAULT '0' COMMENT 'Flag that indicates that this link was generated during the update from Drupal 5.',
  PRIMARY KEY (`mlid`),
  KEY `path_menu` (`link_path`(128),`menu_name`),
  KEY `menu_plid_expand_child` (`menu_name`,`plid`,`expanded`,`has_children`),
  KEY `menu_parents` (`menu_name`,`p1`,`p2`,`p3`,`p4`,`p5`,`p6`,`p7`,`p8`,`p9`),
  KEY `router_path` (`router_path`(128))
) ENGINE=InnoDB AUTO_INCREMENT=982 DEFAULT CHARSET=utf8 COMMENT='Contains the individual links within a menu.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `menu_links`
--

LOCK TABLES `menu_links` WRITE;
/*!40000 ALTER TABLE `menu_links` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `menu_links` VALUES ('management',1,0,'admin','admin','Administration','a:0:{}','system',0,0,1,0,9,1,0,1,0,0,0,0,0,0,0,0,0),('user-menu',2,0,'user','user','User account','a:1:{s:5:\"alter\";b:1;}','system',1,0,0,0,-10,1,1,2,0,0,0,0,0,0,0,0,0),('navigation',3,0,'comment/%','comment/%','Comment permalink','a:0:{}','system',0,0,1,0,0,1,0,3,0,0,0,0,0,0,0,0,0),('navigation',4,0,'filter/tips','filter/tips','Compose tips','a:0:{}','system',1,0,1,0,0,1,0,4,0,0,0,0,0,0,0,0,0),('navigation',5,0,'node/%','node/%','','a:0:{}','system',0,0,0,0,0,1,0,5,0,0,0,0,0,0,0,0,0),('navigation',6,0,'node/add','node/add','Add content','a:0:{}','system',0,0,1,0,0,1,0,6,0,0,0,0,0,0,0,0,0),('management',7,1,'admin/appearance','admin/appearance','Appearance','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:33:\"Select and configure your themes.\";}}','system',0,0,0,0,-6,2,0,1,7,0,0,0,0,0,0,0,0),('management',8,1,'admin/config','admin/config','Configuration','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:20:\"Administer settings.\";}}','system',0,0,1,0,0,2,0,1,8,0,0,0,0,0,0,0,0),('management',9,1,'admin/content','admin/content','Content','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:32:\"Administer content and comments.\";}}','system',0,0,1,0,-10,2,0,1,9,0,0,0,0,0,0,0,0),('user-menu',10,2,'user/register','user/register','Create new account','a:0:{}','system',-1,0,0,0,0,2,0,2,10,0,0,0,0,0,0,0,0),('management',11,1,'admin/dashboard','admin/dashboard','Dashboard','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:34:\"View and customize your dashboard.\";}}','system',0,0,0,0,-15,2,0,1,11,0,0,0,0,0,0,0,0),('management',12,1,'admin/index','admin/index','Index','a:0:{}','system',-1,0,0,0,-18,2,0,1,12,0,0,0,0,0,0,0,0),('user-menu',13,2,'user/login','user/login','Log in','a:0:{}','system',-1,0,0,0,0,2,0,2,13,0,0,0,0,0,0,0,0),('user-menu',14,0,'user/logout','user/logout','Log out','a:0:{}','system',0,0,0,0,10,1,0,14,0,0,0,0,0,0,0,0,0),('management',15,1,'admin/modules','admin/modules','Modules','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:26:\"Extend site functionality.\";}}','system',0,0,0,0,-2,2,0,1,15,0,0,0,0,0,0,0,0),('navigation',16,0,'user/%','user/%','My account','a:0:{}','system',0,0,1,0,0,1,0,16,0,0,0,0,0,0,0,0,0),('management',17,1,'admin/people','admin/people','People','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:45:\"Manage user accounts, roles, and permissions.\";}}','system',0,0,0,0,-4,2,0,1,17,0,0,0,0,0,0,0,0),('management',18,1,'admin/reports','admin/reports','Reports','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:34:\"View reports, updates, and errors.\";}}','system',0,0,1,0,5,2,0,1,18,0,0,0,0,0,0,0,0),('user-menu',19,2,'user/password','user/password','Request new password','a:0:{}','system',-1,0,0,0,0,2,0,2,19,0,0,0,0,0,0,0,0),('management',20,1,'admin/structure','admin/structure','Structure','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:45:\"Administer blocks, content types, menus, etc.\";}}','system',0,0,1,0,-8,2,0,1,20,0,0,0,0,0,0,0,0),('management',21,1,'admin/tasks','admin/tasks','Tasks','a:0:{}','system',-1,0,0,0,-20,2,0,1,21,0,0,0,0,0,0,0,0),('navigation',22,0,'comment/reply/%','comment/reply/%','Add new comment','a:0:{}','system',0,0,0,0,0,1,0,22,0,0,0,0,0,0,0,0,0),('navigation',23,3,'comment/%/approve','comment/%/approve','Approve','a:0:{}','system',0,0,0,0,1,2,0,3,23,0,0,0,0,0,0,0,0),('navigation',24,3,'comment/%/delete','comment/%/delete','Delete','a:0:{}','system',-1,0,0,0,2,2,0,3,24,0,0,0,0,0,0,0,0),('navigation',25,3,'comment/%/edit','comment/%/edit','Edit','a:0:{}','system',-1,0,0,0,0,2,0,3,25,0,0,0,0,0,0,0,0),('navigation',26,3,'comment/%/view','comment/%/view','View comment','a:0:{}','system',-1,0,0,0,-10,2,0,3,26,0,0,0,0,0,0,0,0),('management',27,17,'admin/people/create','admin/people/create','Add user','a:0:{}','system',-1,0,0,0,0,3,0,1,17,27,0,0,0,0,0,0,0),('management',28,20,'admin/structure/block','admin/structure/block','Blocks','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:79:\"Configure what block content appears in your site\'s sidebars and other regions.\";}}','system',0,0,1,0,0,3,0,1,20,28,0,0,0,0,0,0,0),('navigation',29,16,'user/%/cancel','user/%/cancel','Cancel account','a:0:{}','system',0,0,1,0,0,2,0,16,29,0,0,0,0,0,0,0,0),('management',30,9,'admin/content/comment','admin/content/comment','Comments','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:59:\"List and edit site comments and the comment approval queue.\";}}','system',0,0,0,0,0,3,0,1,9,30,0,0,0,0,0,0,0),('management',31,11,'admin/dashboard/configure','admin/dashboard/configure','Configure available dashboard blocks','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:53:\"Configure which blocks can be shown on the dashboard.\";}}','system',-1,0,0,0,0,3,0,1,11,31,0,0,0,0,0,0,0),('management',32,9,'admin/content/node','admin/content/node','Content','a:0:{}','system',-1,0,0,0,-10,3,0,1,9,32,0,0,0,0,0,0,0),('management',33,8,'admin/config/content','admin/config/content','Content authoring','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:53:\"Settings related to formatting and authoring content.\";}}','system',0,0,1,0,-15,3,0,1,8,33,0,0,0,0,0,0,0),('management',34,20,'admin/structure/types','admin/structure/types','Content types','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:92:\"Manage content types, including default status, front page promotion, comment settings, etc.\";}}','system',0,0,1,0,0,3,0,1,20,34,0,0,0,0,0,0,0),('management',35,11,'admin/dashboard/customize','admin/dashboard/customize','Customize dashboard','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:25:\"Customize your dashboard.\";}}','system',-1,0,0,0,0,3,0,1,11,35,0,0,0,0,0,0,0),('navigation',36,5,'node/%/delete','node/%/delete','Delete','a:0:{}','system',-1,0,0,0,1,2,0,5,36,0,0,0,0,0,0,0,0),('management',37,8,'admin/config/development','admin/config/development','Development','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:18:\"Development tools.\";}}','system',0,0,1,0,-10,3,0,1,8,37,0,0,0,0,0,0,0),('navigation',38,16,'user/%/edit','user/%/edit','Edit','a:0:{}','system',-1,0,0,0,0,2,0,16,38,0,0,0,0,0,0,0,0),('navigation',39,5,'node/%/edit','node/%/edit','Edit','a:0:{}','system',-1,0,0,0,0,2,0,5,39,0,0,0,0,0,0,0,0),('management',40,18,'admin/reports/fields','admin/reports/fields','Field list','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:39:\"Overview of fields on all entity types.\";}}','system',0,0,0,0,0,3,0,1,18,40,0,0,0,0,0,0,0),('management',41,17,'admin/people/people','admin/people/people','List','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:50:\"Find and manage people interacting with your site.\";}}','system',-1,0,0,0,-10,3,0,1,17,41,0,0,0,0,0,0,0),('management',42,7,'admin/appearance/list','admin/appearance/list','List','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:31:\"Select and configure your theme\";}}','system',-1,0,0,0,-1,3,0,1,7,42,0,0,0,0,0,0,0),('management',43,15,'admin/modules/list','admin/modules/list','List','a:0:{}','system',-1,0,0,0,0,3,0,1,15,43,0,0,0,0,0,0,0),('management',44,8,'admin/config/media','admin/config/media','Media','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:12:\"Media tools.\";}}','system',0,0,1,0,-10,3,0,1,8,44,0,0,0,0,0,0,0),('management',45,20,'admin/structure/menu','admin/structure/menu','Menus','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:86:\"Add new menus to your site, edit existing menus, and rename and reorganize menu links.\";}}','system',0,0,1,0,0,3,0,1,20,45,0,0,0,0,0,0,0),('management',46,8,'admin/config/people','admin/config/people','People','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:24:\"Configure user accounts.\";}}','system',0,0,1,0,-20,3,0,1,8,46,0,0,0,0,0,0,0),('management',47,17,'admin/people/permissions','admin/people/permissions','Permissions','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:64:\"Determine access to features by selecting permissions for roles.\";}}','system',-1,0,0,0,0,3,0,1,17,47,0,0,0,0,0,0,0),('management',48,18,'admin/reports/dblog','admin/reports/dblog','Recent log messages','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:43:\"View events that have recently been logged.\";}}','system',0,0,0,0,-1,3,0,1,18,48,0,0,0,0,0,0,0),('management',49,8,'admin/config/regional','admin/config/regional','Regional and language','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:48:\"Regional settings, localization and translation.\";}}','system',0,0,1,0,-5,3,0,1,8,49,0,0,0,0,0,0,0),('navigation',50,5,'node/%/revisions','node/%/revisions','Revisions','a:0:{}','system',-1,0,1,0,2,2,0,5,50,0,0,0,0,0,0,0,0),('management',51,8,'admin/config/search','admin/config/search','Search and metadata','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:36:\"Local site search, metadata and SEO.\";}}','system',0,0,1,0,-10,3,0,1,8,51,0,0,0,0,0,0,0),('management',52,7,'admin/appearance/settings','admin/appearance/settings','Settings','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:46:\"Configure default and theme specific settings.\";}}','system',-1,0,0,0,20,3,0,1,7,52,0,0,0,0,0,0,0),('management',53,18,'admin/reports/status','admin/reports/status','Status report','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:74:\"Get a status report about your site\'s operation and any detected problems.\";}}','system',0,0,0,0,-60,3,0,1,18,53,0,0,0,0,0,0,0),('management',54,8,'admin/config/system','admin/config/system','System','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:37:\"General system related configuration.\";}}','system',0,0,1,0,-20,3,0,1,8,54,0,0,0,0,0,0,0),('management',55,18,'admin/reports/access-denied','admin/reports/access-denied','Top \'access denied\' errors','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:35:\"View \'access denied\' errors (403s).\";}}','system',0,0,0,0,0,3,0,1,18,55,0,0,0,0,0,0,0),('management',56,18,'admin/reports/page-not-found','admin/reports/page-not-found','Top \'page not found\' errors','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:36:\"View \'page not found\' errors (404s).\";}}','system',0,0,0,0,0,3,0,1,18,56,0,0,0,0,0,0,0),('management',57,15,'admin/modules/uninstall','admin/modules/uninstall','Uninstall','a:0:{}','system',-1,0,0,0,20,3,0,1,15,57,0,0,0,0,0,0,0),('management',58,8,'admin/config/user-interface','admin/config/user-interface','User interface','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:38:\"Tools that enhance the user interface.\";}}','system',0,0,1,0,-15,3,0,1,8,58,0,0,0,0,0,0,0),('navigation',59,5,'node/%/view','node/%/view','View','a:0:{}','system',-1,0,0,0,-10,2,0,5,59,0,0,0,0,0,0,0,0),('navigation',60,16,'user/%/view','user/%/view','View','a:0:{}','system',-1,0,0,0,-10,2,0,16,60,0,0,0,0,0,0,0,0),('management',61,8,'admin/config/services','admin/config/services','Web services','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:30:\"Tools related to web services.\";}}','system',0,0,1,0,0,3,0,1,8,61,0,0,0,0,0,0,0),('management',62,8,'admin/config/workflow','admin/config/workflow','Workflow','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:43:\"Content workflow, editorial workflow tools.\";}}','system',0,0,0,0,5,3,0,1,8,62,0,0,0,0,0,0,0),('management',63,46,'admin/config/people/accounts','admin/config/people/accounts','Account settings','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:109:\"Configure default behavior of users, including registration requirements, e-mails, fields, and user pictures.\";}}','system',0,0,0,0,-10,4,0,1,8,46,63,0,0,0,0,0,0),('management',64,54,'admin/config/system/actions','admin/config/system/actions','Actions','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:41:\"Manage the actions defined for your site.\";}}','system',0,0,1,0,0,4,0,1,8,54,64,0,0,0,0,0,0),('management',65,28,'admin/structure/block/add','admin/structure/block/add','Add block','a:0:{}','system',-1,0,0,0,0,4,0,1,20,28,65,0,0,0,0,0,0),('management',66,34,'admin/structure/types/add','admin/structure/types/add','Add content type','a:0:{}','system',-1,0,0,0,0,4,0,1,20,34,66,0,0,0,0,0,0),('management',67,45,'admin/structure/menu/add','admin/structure/menu/add','Add menu','a:0:{}','system',-1,0,0,0,0,4,0,1,20,45,67,0,0,0,0,0,0),('management',68,52,'admin/appearance/settings/bartik','admin/appearance/settings/bartik','Bartik','a:0:{}','system',-1,0,0,0,0,4,0,1,7,52,68,0,0,0,0,0,0),('management',69,51,'admin/config/search/clean-urls','admin/config/search/clean-urls','Clean URLs','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:43:\"Enable or disable clean URLs for your site.\";}}','system',0,0,0,0,5,4,0,1,8,51,69,0,0,0,0,0,0),('management',70,54,'admin/config/system/cron','admin/config/system/cron','Cron','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:40:\"Manage automatic site maintenance tasks.\";}}','system',0,0,0,0,20,4,0,1,8,54,70,0,0,0,0,0,0),('management',71,49,'admin/config/regional/date-time','admin/config/regional/date-time','Date and time','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:44:\"Configure display formats for date and time.\";}}','system',0,0,0,0,-15,4,0,1,8,49,71,0,0,0,0,0,0),('management',72,18,'admin/reports/event/%','admin/reports/event/%','Details','a:0:{}','system',0,0,0,0,0,3,0,1,18,72,0,0,0,0,0,0,0),('management',73,44,'admin/config/media/file-system','admin/config/media/file-system','File system','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:68:\"Tell Drupal where to store uploaded files and how they are accessed.\";}}','system',0,0,0,0,-10,4,0,1,8,44,73,0,0,0,0,0,0),('management',74,52,'admin/appearance/settings/garland','admin/appearance/settings/garland','Garland','a:0:{}','system',-1,0,0,0,0,4,0,1,7,52,74,0,0,0,0,0,0),('management',75,52,'admin/appearance/settings/global','admin/appearance/settings/global','Global settings','a:0:{}','system',-1,0,0,0,-1,4,0,1,7,52,75,0,0,0,0,0,0),('management',76,46,'admin/config/people/ip-blocking','admin/config/people/ip-blocking','IP address blocking','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:28:\"Manage blocked IP addresses.\";}}','system',0,0,1,0,10,4,0,1,8,46,76,0,0,0,0,0,0),('management',77,44,'admin/config/media/image-styles','admin/config/media/image-styles','Image styles','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:78:\"Configure styles that can be used for resizing or adjusting images on display.\";}}','system',0,0,1,0,0,4,0,1,8,44,77,0,0,0,0,0,0),('management',78,44,'admin/config/media/image-toolkit','admin/config/media/image-toolkit','Image toolkit','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:74:\"Choose which image toolkit to use if you have installed optional toolkits.\";}}','system',0,0,0,0,20,4,0,1,8,44,78,0,0,0,0,0,0),('management',79,43,'admin/modules/list/confirm','admin/modules/list/confirm','List','a:0:{}','system',-1,0,0,0,0,4,0,1,15,43,79,0,0,0,0,0,0),('management',80,34,'admin/structure/types/list','admin/structure/types/list','List','a:0:{}','system',-1,0,0,0,-10,4,0,1,20,34,80,0,0,0,0,0,0),('management',81,45,'admin/structure/menu/list','admin/structure/menu/list','List menus','a:0:{}','system',-1,0,0,0,-10,4,0,1,20,45,81,0,0,0,0,0,0),('management',82,37,'admin/config/development/logging','admin/config/development/logging','Logging and errors','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:154:\"Settings for logging and alerts modules. Various modules can route Drupal\'s system events to different destinations, such as syslog, database, email, etc.\";}}','system',0,0,0,0,-15,4,0,1,8,37,82,0,0,0,0,0,0),('management',83,37,'admin/config/development/maintenance','admin/config/development/maintenance','Maintenance mode','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:62:\"Take the site offline for maintenance or bring it back online.\";}}','system',0,0,0,0,-10,4,0,1,8,37,83,0,0,0,0,0,0),('management',84,37,'admin/config/development/performance','admin/config/development/performance','Performance','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:101:\"Enable or disable page caching for anonymous users and set CSS and JS bandwidth optimization options.\";}}','system',0,0,0,0,-20,4,0,1,8,37,84,0,0,0,0,0,0),('management',85,47,'admin/people/permissions/list','admin/people/permissions/list','Permissions','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:64:\"Determine access to features by selecting permissions for roles.\";}}','system',-1,0,0,0,-8,4,0,1,17,47,85,0,0,0,0,0,0),('management',86,30,'admin/content/comment/new','admin/content/comment/new','Published comments','a:0:{}','system',-1,0,0,0,-10,4,0,1,9,30,86,0,0,0,0,0,0),('management',87,61,'admin/config/services/rss-publishing','admin/config/services/rss-publishing','RSS publishing','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:114:\"Configure the site description, the number of items per feed and whether feeds should be titles/teasers/full-text.\";}}','system',0,0,0,0,0,4,0,1,8,61,87,0,0,0,0,0,0),('management',88,49,'admin/config/regional/settings','admin/config/regional/settings','Regional settings','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:54:\"Settings for the site\'s default time zone and country.\";}}','system',0,0,0,0,-20,4,0,1,8,49,88,0,0,0,0,0,0),('management',89,47,'admin/people/permissions/roles','admin/people/permissions/roles','Roles','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:30:\"List, edit, or add user roles.\";}}','system',-1,0,1,0,-5,4,0,1,17,47,89,0,0,0,0,0,0),('management',90,45,'admin/structure/menu/settings','admin/structure/menu/settings','Settings','a:0:{}','system',-1,0,0,0,5,4,0,1,20,45,90,0,0,0,0,0,0),('management',91,52,'admin/appearance/settings/seven','admin/appearance/settings/seven','Seven','a:0:{}','system',-1,0,0,0,0,4,0,1,7,52,91,0,0,0,0,0,0),('management',92,54,'admin/config/system/site-information','admin/config/system/site-information','Site information','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:104:\"Change site name, e-mail address, slogan, default front page, and number of posts per page, error pages.\";}}','system',0,0,0,0,-20,4,0,1,8,54,92,0,0,0,0,0,0),('management',93,52,'admin/appearance/settings/stark','admin/appearance/settings/stark','Stark','a:0:{}','system',-1,0,0,0,0,4,0,1,7,52,93,0,0,0,0,0,0),('management',94,33,'admin/config/content/formats','admin/config/content/formats','Text formats','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:127:\"Configure how content input by users is filtered, including allowed HTML tags. Also allows enabling of module-provided filters.\";}}','system',0,0,1,0,0,4,0,1,8,33,94,0,0,0,0,0,0),('management',95,30,'admin/content/comment/approval','admin/content/comment/approval','Unapproved comments','a:0:{}','system',-1,0,0,0,0,4,0,1,9,30,95,0,0,0,0,0,0),('management',96,57,'admin/modules/uninstall/confirm','admin/modules/uninstall/confirm','Uninstall','a:0:{}','system',-1,0,0,0,0,4,0,1,15,57,96,0,0,0,0,0,0),('navigation',97,38,'user/%/edit/account','user/%/edit/account','Account','a:0:{}','system',-1,0,0,0,0,3,0,16,38,97,0,0,0,0,0,0,0),('management',98,94,'admin/config/content/formats/%','admin/config/content/formats/%','','a:0:{}','system',0,0,1,0,0,5,0,1,8,33,94,98,0,0,0,0,0),('management',99,77,'admin/config/media/image-styles/add','admin/config/media/image-styles/add','Add style','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:22:\"Add a new image style.\";}}','system',-1,0,0,0,2,5,0,1,8,44,77,99,0,0,0,0,0),('management',100,94,'admin/config/content/formats/add','admin/config/content/formats/add','Add text format','a:0:{}','system',-1,0,0,0,1,5,0,1,8,33,94,100,0,0,0,0,0),('management',101,28,'admin/structure/block/list/bartik','admin/structure/block/list/bartik','Bartik','a:0:{}','system',-1,0,0,0,0,4,0,1,20,28,101,0,0,0,0,0,0),('management',102,64,'admin/config/system/actions/configure','admin/config/system/actions/configure','Configure an advanced action','a:0:{}','system',-1,0,0,0,0,5,0,1,8,54,64,102,0,0,0,0,0),('management',103,45,'admin/structure/menu/manage/%','admin/structure/menu/manage/%','Customize menu','a:0:{}','system',0,0,1,0,0,4,0,1,20,45,103,0,0,0,0,0,0),('management',104,34,'admin/structure/types/manage/%','admin/structure/types/manage/%','Edit content type','a:0:{}','system',0,0,1,0,0,4,0,1,20,34,104,0,0,0,0,0,0),('management',105,71,'admin/config/regional/date-time/formats','admin/config/regional/date-time/formats','Formats','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:51:\"Configure display format strings for date and time.\";}}','system',-1,0,1,0,-9,5,0,1,8,49,71,105,0,0,0,0,0),('management',106,28,'admin/structure/block/list/garland','admin/structure/block/list/garland','Garland','a:0:{}','system',-1,0,0,0,0,4,0,1,20,28,106,0,0,0,0,0,0),('management',107,94,'admin/config/content/formats/list','admin/config/content/formats/list','List','a:0:{}','system',-1,0,0,0,0,5,0,1,8,33,94,107,0,0,0,0,0),('management',108,77,'admin/config/media/image-styles/list','admin/config/media/image-styles/list','List','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:42:\"List the current image styles on the site.\";}}','system',-1,0,0,0,1,5,0,1,8,44,77,108,0,0,0,0,0),('management',109,64,'admin/config/system/actions/manage','admin/config/system/actions/manage','Manage actions','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:41:\"Manage the actions defined for your site.\";}}','system',-1,0,0,0,-2,5,0,1,8,54,64,109,0,0,0,0,0),('management',110,63,'admin/config/people/accounts/settings','admin/config/people/accounts/settings','Settings','a:0:{}','system',-1,0,0,0,-10,5,0,1,8,46,63,110,0,0,0,0,0),('management',111,28,'admin/structure/block/list/seven','admin/structure/block/list/seven','Seven','a:0:{}','system',-1,0,0,0,0,4,0,1,20,28,111,0,0,0,0,0,0),('management',112,28,'admin/structure/block/list/stark','admin/structure/block/list/stark','Stark','a:0:{}','system',-1,0,0,0,0,4,0,1,20,28,112,0,0,0,0,0,0),('management',113,71,'admin/config/regional/date-time/types','admin/config/regional/date-time/types','Types','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:44:\"Configure display formats for date and time.\";}}','system',-1,0,1,0,-10,5,0,1,8,49,71,113,0,0,0,0,0),('navigation',114,50,'node/%/revisions/%/delete','node/%/revisions/%/delete','Delete earlier revision','a:0:{}','system',0,0,0,0,0,3,0,5,50,114,0,0,0,0,0,0,0),('navigation',115,50,'node/%/revisions/%/revert','node/%/revisions/%/revert','Revert to earlier revision','a:0:{}','system',0,0,0,0,0,3,0,5,50,115,0,0,0,0,0,0,0),('navigation',116,50,'node/%/revisions/%/view','node/%/revisions/%/view','Revisions','a:0:{}','system',0,0,0,0,0,3,0,5,50,116,0,0,0,0,0,0,0),('management',117,106,'admin/structure/block/list/garland/add','admin/structure/block/list/garland/add','Add block','a:0:{}','system',-1,0,0,0,0,5,0,1,20,28,106,117,0,0,0,0,0),('management',118,111,'admin/structure/block/list/seven/add','admin/structure/block/list/seven/add','Add block','a:0:{}','system',-1,0,0,0,0,5,0,1,20,28,111,118,0,0,0,0,0),('management',119,112,'admin/structure/block/list/stark/add','admin/structure/block/list/stark/add','Add block','a:0:{}','system',-1,0,0,0,0,5,0,1,20,28,112,119,0,0,0,0,0),('management',120,113,'admin/config/regional/date-time/types/add','admin/config/regional/date-time/types/add','Add date type','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:18:\"Add new date type.\";}}','system',-1,0,0,0,-10,6,0,1,8,49,71,113,120,0,0,0,0),('management',121,105,'admin/config/regional/date-time/formats/add','admin/config/regional/date-time/formats/add','Add format','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:43:\"Allow users to add additional date formats.\";}}','system',-1,0,0,0,-10,6,0,1,8,49,71,105,121,0,0,0,0),('management',122,103,'admin/structure/menu/manage/%/add','admin/structure/menu/manage/%/add','Add link','a:0:{}','system',-1,0,0,0,0,5,0,1,20,45,103,122,0,0,0,0,0),('management',123,28,'admin/structure/block/manage/%/%','admin/structure/block/manage/%/%','Configure block','a:0:{}','system',0,0,0,0,0,4,0,1,20,28,123,0,0,0,0,0,0),('navigation',124,29,'user/%/cancel/confirm/%/%','user/%/cancel/confirm/%/%','Confirm account cancellation','a:0:{}','system',0,0,0,0,0,3,0,16,29,124,0,0,0,0,0,0,0),('management',125,104,'admin/structure/types/manage/%/delete','admin/structure/types/manage/%/delete','Delete','a:0:{}','system',0,0,0,0,0,5,0,1,20,34,104,125,0,0,0,0,0),('management',126,76,'admin/config/people/ip-blocking/delete/%','admin/config/people/ip-blocking/delete/%','Delete IP address','a:0:{}','system',0,0,0,0,0,5,0,1,8,46,76,126,0,0,0,0,0),('management',127,64,'admin/config/system/actions/delete/%','admin/config/system/actions/delete/%','Delete action','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:17:\"Delete an action.\";}}','system',0,0,0,0,0,5,0,1,8,54,64,127,0,0,0,0,0),('management',128,103,'admin/structure/menu/manage/%/delete','admin/structure/menu/manage/%/delete','Delete menu','a:0:{}','system',0,0,0,0,0,5,0,1,20,45,103,128,0,0,0,0,0),('management',129,45,'admin/structure/menu/item/%/delete','admin/structure/menu/item/%/delete','Delete menu link','a:0:{}','system',0,0,0,0,0,4,0,1,20,45,129,0,0,0,0,0,0),('management',130,89,'admin/people/permissions/roles/delete/%','admin/people/permissions/roles/delete/%','Delete role','a:0:{}','system',0,0,0,0,0,5,0,1,17,47,89,130,0,0,0,0,0),('management',131,98,'admin/config/content/formats/%/disable','admin/config/content/formats/%/disable','Disable text format','a:0:{}','system',0,0,0,0,0,6,0,1,8,33,94,98,131,0,0,0,0),('management',132,104,'admin/structure/types/manage/%/edit','admin/structure/types/manage/%/edit','Edit','a:0:{}','system',-1,0,0,0,0,5,0,1,20,34,104,132,0,0,0,0,0),('management',133,103,'admin/structure/menu/manage/%/edit','admin/structure/menu/manage/%/edit','Edit menu','a:0:{}','system',-1,0,0,0,0,5,0,1,20,45,103,133,0,0,0,0,0),('management',134,45,'admin/structure/menu/item/%/edit','admin/structure/menu/item/%/edit','Edit menu link','a:0:{}','system',0,0,0,0,0,4,0,1,20,45,134,0,0,0,0,0,0),('management',135,89,'admin/people/permissions/roles/edit/%','admin/people/permissions/roles/edit/%','Edit role','a:0:{}','system',0,0,0,0,0,5,0,1,17,47,89,135,0,0,0,0,0),('management',136,77,'admin/config/media/image-styles/edit/%','admin/config/media/image-styles/edit/%','Edit style','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:25:\"Configure an image style.\";}}','system',0,0,1,0,0,5,0,1,8,44,77,136,0,0,0,0,0),('management',137,103,'admin/structure/menu/manage/%/list','admin/structure/menu/manage/%/list','List links','a:0:{}','system',-1,0,0,0,-10,5,0,1,20,45,103,137,0,0,0,0,0),('management',138,45,'admin/structure/menu/item/%/reset','admin/structure/menu/item/%/reset','Reset menu link','a:0:{}','system',0,0,0,0,0,4,0,1,20,45,138,0,0,0,0,0,0),('management',139,77,'admin/config/media/image-styles/delete/%','admin/config/media/image-styles/delete/%','Delete style','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:22:\"Delete an image style.\";}}','system',0,0,0,0,0,5,0,1,8,44,77,139,0,0,0,0,0),('management',140,77,'admin/config/media/image-styles/revert/%','admin/config/media/image-styles/revert/%','Revert style','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:22:\"Revert an image style.\";}}','system',0,0,0,0,0,5,0,1,8,44,77,140,0,0,0,0,0),('management',141,104,'admin/structure/types/manage/%/comment/display','admin/structure/types/manage/%/comment/display','Comment display','a:0:{}','system',-1,0,0,0,4,5,0,1,20,34,104,141,0,0,0,0,0),('management',142,104,'admin/structure/types/manage/%/comment/fields','admin/structure/types/manage/%/comment/fields','Comment fields','a:0:{}','system',-1,0,1,0,3,5,0,1,20,34,104,142,0,0,0,0,0),('management',143,123,'admin/structure/block/manage/%/%/configure','admin/structure/block/manage/%/%/configure','Configure','a:0:{}','system',-1,0,0,0,-100,5,0,1,20,28,123,143,0,0,0,0,0),('management',144,123,'admin/structure/block/manage/%/%/delete','admin/structure/block/manage/%/%/delete','Delete block','a:0:{}','system',-1,0,0,0,0,5,0,1,20,28,123,144,0,0,0,0,0),('management',145,105,'admin/config/regional/date-time/formats/%/delete','admin/config/regional/date-time/formats/%/delete','Delete date format','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:47:\"Allow users to delete a configured date format.\";}}','system',0,0,0,0,0,6,0,1,8,49,71,105,145,0,0,0,0),('management',146,113,'admin/config/regional/date-time/types/%/delete','admin/config/regional/date-time/types/%/delete','Delete date type','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:45:\"Allow users to delete a configured date type.\";}}','system',0,0,0,0,0,6,0,1,8,49,71,113,146,0,0,0,0),('management',147,105,'admin/config/regional/date-time/formats/%/edit','admin/config/regional/date-time/formats/%/edit','Edit date format','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:45:\"Allow users to edit a configured date format.\";}}','system',0,0,0,0,0,6,0,1,8,49,71,105,147,0,0,0,0),('management',148,136,'admin/config/media/image-styles/edit/%/add/%','admin/config/media/image-styles/edit/%/add/%','Add image effect','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:28:\"Add a new effect to a style.\";}}','system',0,0,0,0,0,6,0,1,8,44,77,136,148,0,0,0,0),('management',149,136,'admin/config/media/image-styles/edit/%/effects/%','admin/config/media/image-styles/edit/%/effects/%','Edit image effect','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:39:\"Edit an existing effect within a style.\";}}','system',0,0,1,0,0,6,0,1,8,44,77,136,149,0,0,0,0),('management',150,149,'admin/config/media/image-styles/edit/%/effects/%/delete','admin/config/media/image-styles/edit/%/effects/%/delete','Delete image effect','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:39:\"Delete an existing effect from a style.\";}}','system',0,0,0,0,0,7,0,1,8,44,77,136,149,150,0,0,0),('management',151,45,'admin/structure/menu/manage/main-menu','admin/structure/menu/manage/%','Main menu','a:0:{}','menu',0,0,0,0,0,4,0,1,20,45,151,0,0,0,0,0,0),('management',152,45,'admin/structure/menu/manage/management','admin/structure/menu/manage/%','Management','a:0:{}','menu',0,0,0,0,0,4,0,1,20,45,152,0,0,0,0,0,0),('management',153,45,'admin/structure/menu/manage/navigation','admin/structure/menu/manage/%','Navigation','a:0:{}','menu',0,0,0,0,0,4,0,1,20,45,153,0,0,0,0,0,0),('management',154,45,'admin/structure/menu/manage/user-menu','admin/structure/menu/manage/%','User menu','a:0:{}','menu',0,0,0,0,0,4,0,1,20,45,154,0,0,0,0,0,0),('main-menu',155,0,'search','search','Search','a:0:{}','system',1,0,0,0,-45,1,1,155,0,0,0,0,0,0,0,0,0),('main-menu',156,155,'search/node','search/node','Content','a:0:{}','system',-1,0,0,0,-10,2,0,155,156,0,0,0,0,0,0,0,0),('main-menu',157,155,'search/user','search/user','Users','a:0:{}','system',-1,0,0,0,0,2,0,155,157,0,0,0,0,0,0,0,0),('management',158,1,'admin/help','admin/help','Help','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:48:\"Reference for usage, configuration, and modules.\";}}','system',0,0,0,0,9,2,0,1,158,0,0,0,0,0,0,0,0),('navigation',159,0,'taxonomy/term/%','taxonomy/term/%','Taxonomy term','a:0:{}','system',0,0,0,0,0,1,0,159,0,0,0,0,0,0,0,0,0),('main-menu',160,156,'search/node/%','search/node/%','Content','a:0:{}','system',-1,0,0,0,0,3,0,155,156,160,0,0,0,0,0,0,0),('navigation',161,16,'user/%/shortcuts','user/%/shortcuts','Shortcuts','a:0:{}','system',-1,0,0,0,0,2,0,16,161,0,0,0,0,0,0,0,0),('management',162,20,'admin/structure/taxonomy','admin/structure/taxonomy','Taxonomy','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:67:\"Manage tagging, categorization, and classification of your content.\";}}','system',0,0,1,0,0,3,0,1,20,162,0,0,0,0,0,0,0),('management',163,18,'admin/reports/search','admin/reports/search','Top search phrases','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:33:\"View most popular search phrases.\";}}','system',0,0,0,0,0,3,0,1,18,163,0,0,0,0,0,0,0),('main-menu',164,157,'search/user/%','search/user/%','Users','a:0:{}','system',-1,0,0,0,0,3,0,155,157,164,0,0,0,0,0,0,0),('management',165,158,'admin/help/block','admin/help/block','block','a:0:{}','system',-1,0,0,0,0,3,0,1,158,165,0,0,0,0,0,0,0),('management',166,158,'admin/help/color','admin/help/color','color','a:0:{}','system',-1,0,0,0,0,3,0,1,158,166,0,0,0,0,0,0,0),('management',167,158,'admin/help/comment','admin/help/comment','comment','a:0:{}','system',-1,0,0,0,0,3,0,1,158,167,0,0,0,0,0,0,0),('management',168,158,'admin/help/contextual','admin/help/contextual','contextual','a:0:{}','system',-1,0,0,0,0,3,0,1,158,168,0,0,0,0,0,0,0),('management',169,158,'admin/help/dashboard','admin/help/dashboard','dashboard','a:0:{}','system',-1,0,0,0,0,3,0,1,158,169,0,0,0,0,0,0,0),('management',170,158,'admin/help/dblog','admin/help/dblog','dblog','a:0:{}','system',-1,0,0,0,0,3,0,1,158,170,0,0,0,0,0,0,0),('management',171,158,'admin/help/field','admin/help/field','field','a:0:{}','system',-1,0,0,0,0,3,0,1,158,171,0,0,0,0,0,0,0),('management',172,158,'admin/help/field_sql_storage','admin/help/field_sql_storage','field_sql_storage','a:0:{}','system',-1,0,0,0,0,3,0,1,158,172,0,0,0,0,0,0,0),('management',173,158,'admin/help/field_ui','admin/help/field_ui','field_ui','a:0:{}','system',-1,0,0,0,0,3,0,1,158,173,0,0,0,0,0,0,0),('management',174,158,'admin/help/file','admin/help/file','file','a:0:{}','system',-1,0,0,0,0,3,0,1,158,174,0,0,0,0,0,0,0),('management',175,158,'admin/help/filter','admin/help/filter','filter','a:0:{}','system',-1,0,0,0,0,3,0,1,158,175,0,0,0,0,0,0,0),('management',176,158,'admin/help/help','admin/help/help','help','a:0:{}','system',-1,0,0,0,0,3,0,1,158,176,0,0,0,0,0,0,0),('management',177,158,'admin/help/image','admin/help/image','image','a:0:{}','system',-1,0,0,0,0,3,0,1,158,177,0,0,0,0,0,0,0),('management',178,158,'admin/help/list','admin/help/list','list','a:0:{}','system',-1,0,0,0,0,3,0,1,158,178,0,0,0,0,0,0,0),('management',179,158,'admin/help/menu','admin/help/menu','menu','a:0:{}','system',-1,0,0,0,0,3,0,1,158,179,0,0,0,0,0,0,0),('management',180,158,'admin/help/node','admin/help/node','node','a:0:{}','system',-1,0,0,0,0,3,0,1,158,180,0,0,0,0,0,0,0),('management',181,158,'admin/help/number','admin/help/number','number','a:0:{}','system',-1,0,0,0,0,3,0,1,158,181,0,0,0,0,0,0,0),('management',182,158,'admin/help/options','admin/help/options','options','a:0:{}','system',-1,0,0,0,0,3,0,1,158,182,0,0,0,0,0,0,0),('management',183,158,'admin/help/overlay','admin/help/overlay','overlay','a:0:{}','system',-1,0,0,0,0,3,0,1,158,183,0,0,0,0,0,0,0),('management',184,158,'admin/help/path','admin/help/path','path','a:0:{}','system',-1,0,0,0,0,3,0,1,158,184,0,0,0,0,0,0,0),('management',186,158,'admin/help/search','admin/help/search','search','a:0:{}','system',-1,0,0,0,0,3,0,1,158,186,0,0,0,0,0,0,0),('management',187,158,'admin/help/shortcut','admin/help/shortcut','shortcut','a:0:{}','system',-1,0,0,0,0,3,0,1,158,187,0,0,0,0,0,0,0),('management',188,158,'admin/help/system','admin/help/system','system','a:0:{}','system',-1,0,0,0,0,3,0,1,158,188,0,0,0,0,0,0,0),('management',189,158,'admin/help/taxonomy','admin/help/taxonomy','taxonomy','a:0:{}','system',-1,0,0,0,0,3,0,1,158,189,0,0,0,0,0,0,0),('management',190,158,'admin/help/text','admin/help/text','text','a:0:{}','system',-1,0,0,0,0,3,0,1,158,190,0,0,0,0,0,0,0),('management',191,158,'admin/help/user','admin/help/user','user','a:0:{}','system',-1,0,0,0,0,3,0,1,158,191,0,0,0,0,0,0,0),('navigation',192,159,'taxonomy/term/%/edit','taxonomy/term/%/edit','Edit','a:0:{}','system',-1,0,0,0,10,2,0,159,192,0,0,0,0,0,0,0,0),('navigation',193,159,'taxonomy/term/%/view','taxonomy/term/%/view','View','a:0:{}','system',-1,0,0,0,0,2,0,159,193,0,0,0,0,0,0,0,0),('management',194,162,'admin/structure/taxonomy/%','admin/structure/taxonomy/%','','a:0:{}','system',0,0,0,0,0,4,0,1,20,162,194,0,0,0,0,0,0),('management',195,162,'admin/structure/taxonomy/add','admin/structure/taxonomy/add','Add vocabulary','a:0:{}','system',-1,0,0,0,0,4,0,1,20,162,195,0,0,0,0,0,0),('management',196,162,'admin/structure/taxonomy/list','admin/structure/taxonomy/list','List','a:0:{}','system',-1,0,0,0,-10,4,0,1,20,162,196,0,0,0,0,0,0),('management',197,51,'admin/config/search/settings','admin/config/search/settings','Search settings','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:67:\"Configure relevance settings for search and other indexing options.\";}}','system',0,0,0,0,-10,4,0,1,8,51,197,0,0,0,0,0,0),('management',198,58,'admin/config/user-interface/shortcut','admin/config/user-interface/shortcut','Shortcuts','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:29:\"Add and modify shortcut sets.\";}}','system',0,0,1,0,0,4,0,1,8,58,198,0,0,0,0,0,0),('management',199,51,'admin/config/search/path','admin/config/search/path','URL aliases','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:46:\"Change your site\'s URL paths by aliasing them.\";}}','system',0,0,1,0,-5,4,0,1,8,51,199,0,0,0,0,0,0),('management',200,199,'admin/config/search/path/add','admin/config/search/path/add','Add alias','a:0:{}','system',-1,0,0,0,0,5,0,1,8,51,199,200,0,0,0,0,0),('management',201,198,'admin/config/user-interface/shortcut/add-set','admin/config/user-interface/shortcut/add-set','Add shortcut set','a:0:{}','system',-1,0,0,0,0,5,0,1,8,58,198,201,0,0,0,0,0),('management',202,194,'admin/structure/taxonomy/%/add','admin/structure/taxonomy/%/add','Add term','a:0:{}','system',-1,0,0,0,0,5,0,1,20,162,194,202,0,0,0,0,0),('management',203,197,'admin/config/search/settings/reindex','admin/config/search/settings/reindex','Clear index','a:0:{}','system',-1,0,0,0,0,5,0,1,8,51,197,203,0,0,0,0,0),('management',204,194,'admin/structure/taxonomy/%/edit','admin/structure/taxonomy/%/edit','Edit','a:0:{}','system',-1,0,0,0,-10,5,0,1,20,162,194,204,0,0,0,0,0),('management',205,198,'admin/config/user-interface/shortcut/%','admin/config/user-interface/shortcut/%','Edit shortcuts','a:0:{}','system',0,0,1,0,0,5,0,1,8,58,198,205,0,0,0,0,0),('management',206,194,'admin/structure/taxonomy/%/list','admin/structure/taxonomy/%/list','List','a:0:{}','system',-1,0,0,0,-20,5,0,1,20,162,194,206,0,0,0,0,0),('management',207,199,'admin/config/search/path/list','admin/config/search/path/list','List','a:0:{}','system',-1,0,0,0,-10,5,0,1,8,51,199,207,0,0,0,0,0),('management',208,205,'admin/config/user-interface/shortcut/%/add-link','admin/config/user-interface/shortcut/%/add-link','Add shortcut','a:0:{}','system',-1,0,0,0,0,6,0,1,8,58,198,205,208,0,0,0,0),('management',209,199,'admin/config/search/path/delete/%','admin/config/search/path/delete/%','Delete alias','a:0:{}','system',0,0,0,0,0,5,0,1,8,51,199,209,0,0,0,0,0),('management',210,205,'admin/config/user-interface/shortcut/%/delete','admin/config/user-interface/shortcut/%/delete','Delete shortcut set','a:0:{}','system',0,0,0,0,0,6,0,1,8,58,198,205,210,0,0,0,0),('management',211,199,'admin/config/search/path/edit/%','admin/config/search/path/edit/%','Edit alias','a:0:{}','system',0,0,0,0,0,5,0,1,8,51,199,211,0,0,0,0,0),('management',212,205,'admin/config/user-interface/shortcut/%/edit','admin/config/user-interface/shortcut/%/edit','Edit set name','a:0:{}','system',-1,0,0,0,10,6,0,1,8,58,198,205,212,0,0,0,0),('management',213,198,'admin/config/user-interface/shortcut/link/%','admin/config/user-interface/shortcut/link/%','Edit shortcut','a:0:{}','system',0,0,1,0,0,5,0,1,8,58,198,213,0,0,0,0,0),('management',214,205,'admin/config/user-interface/shortcut/%/links','admin/config/user-interface/shortcut/%/links','List links','a:0:{}','system',-1,0,0,0,0,6,0,1,8,58,198,205,214,0,0,0,0),('management',215,213,'admin/config/user-interface/shortcut/link/%/delete','admin/config/user-interface/shortcut/link/%/delete','Delete shortcut','a:0:{}','system',0,0,0,0,0,6,0,1,8,58,198,213,215,0,0,0,0),('shortcut-set-1',216,0,'node/add','node/add','Add content','a:0:{}','menu',0,0,0,0,-20,1,0,216,0,0,0,0,0,0,0,0,0),('shortcut-set-1',217,0,'admin/content','admin/content','Find content','a:0:{}','menu',0,0,0,0,-19,1,0,217,0,0,0,0,0,0,0,0,0),('main-menu',218,0,'<front>','','Home','a:0:{}','menu',1,1,0,0,-50,1,1,218,0,0,0,0,0,0,0,0,0),('navigation',219,6,'node/add/article','node/add/article','Article','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:89:\"Use <em>articles</em> for time-sensitive content like news, press releases or blog posts.\";}}','system',0,0,0,0,0,2,0,6,219,0,0,0,0,0,0,0,0),('navigation',220,6,'node/add/page','node/add/page','Basic page','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:77:\"Use <em>basic pages</em> for your static content, such as an \'About us\' page.\";}}','system',0,0,0,0,0,2,0,6,220,0,0,0,0,0,0,0,0),('management',260,18,'admin/reports/updates','admin/reports/updates','Available updates','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:82:\"Get a status report about available updates for your installed modules and themes.\";}}','system',0,0,0,0,-50,3,0,1,18,260,0,0,0,0,0,0,0),('management',261,7,'admin/appearance/install','admin/appearance/install','Install new theme','a:0:{}','system',-1,0,0,0,25,3,0,1,7,261,0,0,0,0,0,0,0),('management',262,15,'admin/modules/update','admin/modules/update','Update','a:0:{}','system',-1,0,0,0,10,3,0,1,15,262,0,0,0,0,0,0,0),('management',263,15,'admin/modules/install','admin/modules/install','Install new module','a:0:{}','system',-1,0,0,0,25,3,0,1,15,263,0,0,0,0,0,0,0),('management',264,7,'admin/appearance/update','admin/appearance/update','Update','a:0:{}','system',-1,0,0,0,10,3,0,1,7,264,0,0,0,0,0,0,0),('management',265,158,'admin/help/update','admin/help/update','update','a:0:{}','system',-1,0,0,0,0,3,0,1,158,265,0,0,0,0,0,0,0),('management',266,260,'admin/reports/updates/install','admin/reports/updates/install','Install new module or theme','a:0:{}','system',-1,0,0,0,25,4,0,1,18,260,266,0,0,0,0,0,0),('management',267,260,'admin/reports/updates/update','admin/reports/updates/update','Update','a:0:{}','system',-1,0,0,0,10,4,0,1,18,260,267,0,0,0,0,0,0),('management',268,260,'admin/reports/updates/list','admin/reports/updates/list','List','a:0:{}','system',-1,0,0,0,0,4,0,1,18,260,268,0,0,0,0,0,0),('management',269,260,'admin/reports/updates/settings','admin/reports/updates/settings','Settings','a:0:{}','system',-1,0,0,0,50,4,0,1,18,260,269,0,0,0,0,0,0),('main-menu',308,627,'blog','blog','Blogs Default','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:0:\"\";}}','system',0,0,0,0,-46,2,1,627,308,0,0,0,0,0,0,0,0),('main-menu',309,0,'book','book','Books','a:0:{}','system',1,0,0,0,-46,1,1,309,0,0,0,0,0,0,0,0,0),('main-menu',310,0,'forum','forum','Forums','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:0:\"\";}}','system',0,0,1,1,-49,1,1,310,0,0,0,0,0,0,0,0,0),('main-menu',311,310,'forum/%','forum/%','Forums','a:0:{}','system',0,0,0,0,0,2,0,310,311,0,0,0,0,0,0,0,0),('main-menu',312,308,'blog/%','blog/%','Admin Blogs','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:0:\"\";}}','system',1,0,0,0,-48,3,1,627,308,312,0,0,0,0,0,0,0),('navigation',313,6,'node/add/blog','node/add/blog','Blog entry','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:58:\"Use for multi-user blogs. Every user gets a personal blog.\";}}','system',0,0,0,0,0,2,0,6,313,0,0,0,0,0,0,0,0),('navigation',314,6,'node/add/book','node/add/book','Book page','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:87:\"<em>Books</em> have a built-in hierarchical navigation. Use for handbooks or tutorials.\";}}','system',0,0,0,0,0,2,0,6,314,0,0,0,0,0,0,0,0),('management',315,9,'admin/content/book','admin/content/book','Books','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:33:\"Manage your site\'s book outlines.\";}}','system',-1,0,0,0,0,3,0,1,9,315,0,0,0,0,0,0,0),('navigation',316,6,'node/add/forum','node/add/forum','Forum topic','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:69:\"A <em>forum topic</em> starts a new discussion thread within a forum.\";}}','system',0,0,0,0,0,2,0,6,316,0,0,0,0,0,0,0,0),('management',317,20,'admin/structure/forum','admin/structure/forum','Forums','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:33:\"Control forum hierarchy settings.\";}}','system',0,0,1,0,0,3,0,1,20,317,0,0,0,0,0,0,0),('navigation',318,5,'node/%/outline','node/%/outline','Outline','a:0:{}','system',-1,0,1,0,2,2,0,5,318,0,0,0,0,0,0,0,0),('management',319,20,'admin/structure/views','admin/structure/views','Views','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:35:\"Manage customized lists of content.\";}}','system',0,0,1,0,0,3,0,1,20,319,0,0,0,0,0,0,0),('management',320,18,'admin/reports/views-plugins','admin/reports/views-plugins','Views plugins','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:38:\"Overview of plugins used in all views.\";}}','system',0,0,0,0,0,3,0,1,18,320,0,0,0,0,0,0,0),('management',321,158,'admin/help/blog','admin/help/blog','blog','a:0:{}','system',-1,0,0,0,0,3,0,1,158,321,0,0,0,0,0,0,0),('management',322,158,'admin/help/book','admin/help/book','book','a:0:{}','system',-1,0,0,0,0,3,0,1,158,322,0,0,0,0,0,0,0),('management',323,158,'admin/help/forum','admin/help/forum','forum','a:0:{}','system',-1,0,0,0,0,3,0,1,158,323,0,0,0,0,0,0,0),('management',324,158,'admin/help/views_slideshow','admin/help/views_slideshow','views_slideshow','a:0:{}','system',-1,0,0,0,0,3,0,1,158,324,0,0,0,0,0,0,0),('management',325,158,'admin/help/views_slideshow_cycle','admin/help/views_slideshow_cycle','views_slideshow_cycle','a:0:{}','system',-1,0,0,0,0,3,0,1,158,325,0,0,0,0,0,0,0),('management',326,319,'admin/structure/views/add','admin/structure/views/add','Add new view','a:0:{}','system',-1,0,0,0,0,4,0,1,20,319,326,0,0,0,0,0,0),('management',327,319,'admin/structure/views/add-template','admin/structure/views/add-template','Add view from template','a:0:{}','system',-1,0,0,0,0,4,0,1,20,319,327,0,0,0,0,0,0),('management',328,319,'admin/structure/views/import','admin/structure/views/import','Import','a:0:{}','system',-1,0,0,0,0,4,0,1,20,319,328,0,0,0,0,0,0),('management',329,315,'admin/content/book/list','admin/content/book/list','List','a:0:{}','system',-1,0,0,0,0,4,0,1,9,315,329,0,0,0,0,0,0),('management',330,319,'admin/structure/views/list','admin/structure/views/list','List','a:0:{}','system',-1,0,0,0,-10,4,0,1,20,319,330,0,0,0,0,0,0),('management',331,317,'admin/structure/forum/list','admin/structure/forum/list','List','a:0:{}','system',-1,0,0,0,-10,4,0,1,20,317,331,0,0,0,0,0,0),('management',332,40,'admin/reports/fields/list','admin/reports/fields/list','List','a:0:{}','system',-1,0,0,0,-10,4,0,1,18,40,332,0,0,0,0,0,0),('navigation',333,318,'node/%/outline/remove','node/%/outline/remove','Remove from outline','a:0:{}','system',0,0,0,0,0,3,0,5,318,333,0,0,0,0,0,0,0),('management',334,315,'admin/content/book/settings','admin/content/book/settings','Settings','a:0:{}','system',-1,0,0,0,8,4,0,1,9,315,334,0,0,0,0,0,0),('management',335,319,'admin/structure/views/settings','admin/structure/views/settings','Settings','a:0:{}','system',-1,0,0,0,0,4,0,1,20,319,335,0,0,0,0,0,0),('management',336,40,'admin/reports/fields/views-fields','admin/reports/fields/views-fields','Used in views','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:37:\"Overview of fields used in all views.\";}}','system',-1,0,0,0,0,4,0,1,18,40,336,0,0,0,0,0,0),('management',337,317,'admin/structure/forum/settings','admin/structure/forum/settings','Settings','a:0:{}','system',-1,0,0,0,5,4,0,1,20,317,337,0,0,0,0,0,0),('management',338,335,'admin/structure/views/settings/advanced','admin/structure/views/settings/advanced','Advanced','a:0:{}','system',-1,0,0,0,1,5,0,1,20,319,335,338,0,0,0,0,0),('management',339,335,'admin/structure/views/settings/basic','admin/structure/views/settings/basic','Basic','a:0:{}','system',-1,0,0,0,0,5,0,1,20,319,335,339,0,0,0,0,0),('management',340,319,'admin/structure/views/view/%','admin/structure/views/view/%','','a:0:{}','system',0,0,0,0,0,4,0,1,20,319,340,0,0,0,0,0,0),('management',341,317,'admin/structure/forum/add/container','admin/structure/forum/add/container','Add container','a:0:{}','system',-1,0,0,0,0,4,0,1,20,317,341,0,0,0,0,0,0),('management',342,317,'admin/structure/forum/add/forum','admin/structure/forum/add/forum','Add forum','a:0:{}','system',-1,0,0,0,0,4,0,1,20,317,342,0,0,0,0,0,0),('management',343,340,'admin/structure/views/view/%/break-lock','admin/structure/views/view/%/break-lock','Break lock','a:0:{}','system',-1,0,0,0,0,5,0,1,20,319,340,343,0,0,0,0,0),('management',344,317,'admin/structure/forum/edit/container/%','admin/structure/forum/edit/container/%','Edit container','a:0:{}','system',0,0,0,0,0,4,0,1,20,317,344,0,0,0,0,0,0),('management',345,317,'admin/structure/forum/edit/forum/%','admin/structure/forum/edit/forum/%','Edit forum','a:0:{}','system',0,0,0,0,0,4,0,1,20,317,345,0,0,0,0,0,0),('management',346,340,'admin/structure/views/view/%/edit','admin/structure/views/view/%/edit','Edit view','a:0:{}','system',-1,0,0,0,-10,5,0,1,20,319,340,346,0,0,0,0,0),('management',347,340,'admin/structure/views/view/%/clone','admin/structure/views/view/%/clone','Clone','a:0:{}','system',-1,0,0,0,0,5,0,1,20,319,340,347,0,0,0,0,0),('management',348,340,'admin/structure/views/view/%/delete','admin/structure/views/view/%/delete','Delete','a:0:{}','system',-1,0,0,0,0,5,0,1,20,319,340,348,0,0,0,0,0),('management',349,340,'admin/structure/views/view/%/export','admin/structure/views/view/%/export','Export','a:0:{}','system',-1,0,0,0,0,5,0,1,20,319,340,349,0,0,0,0,0),('management',350,340,'admin/structure/views/view/%/revert','admin/structure/views/view/%/revert','Revert','a:0:{}','system',-1,0,0,0,0,5,0,1,20,319,340,350,0,0,0,0,0),('management',351,340,'admin/structure/views/view/%/preview/%','admin/structure/views/view/%/preview/%','','a:0:{}','system',-1,0,0,0,0,5,0,1,20,319,340,351,0,0,0,0,0),('management',353,319,'admin/structure/views/ajax/preview/%/%','admin/structure/views/ajax/preview/%/%','','a:0:{}','system',0,0,0,0,0,4,0,1,20,319,353,0,0,0,0,0,0),('management',354,319,'admin/structure/views/nojs/preview/%/%','admin/structure/views/nojs/preview/%/%','','a:0:{}','system',0,0,0,0,0,4,0,1,20,319,354,0,0,0,0,0,0),('management',355,8,'admin/config/administration','admin/config/administration','Administration','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:21:\"Administration tools.\";}}','system',0,0,1,0,0,3,0,1,8,355,0,0,0,0,0,0,0),('management',356,158,'admin/help/admin_menu','admin/help/admin_menu','admin_menu','a:0:{}','system',-1,0,0,0,0,3,0,1,158,356,0,0,0,0,0,0,0),('management',357,355,'admin/config/administration/admin_menu','admin/config/administration/admin_menu','Administration menu','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:36:\"Adjust administration menu settings.\";}}','system',0,0,0,0,0,4,0,1,8,355,357,0,0,0,0,0,0),('management',358,58,'admin/config/user-interface/modulefilter','admin/config/user-interface/modulefilter','Module filter','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:46:\"Configure how the modules page looks and acts.\";}}','system',0,0,0,0,0,4,0,1,8,58,358,0,0,0,0,0,0),('main-menu',359,0,'articles','articles','Articles','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:0:\"\";}}','system',0,0,1,1,-48,1,1,359,0,0,0,0,0,0,0,0,0),('management',360,52,'admin/appearance/settings/forum_plus','admin/appearance/settings/forum_plus','Forum Plus','a:0:{}','system',-1,0,0,0,0,4,0,1,7,52,360,0,0,0,0,0,0),('management',361,28,'admin/structure/block/list/forum_plus','admin/structure/block/list/forum_plus','Forum Plus','a:0:{}','system',-1,0,0,0,-10,4,0,1,20,28,361,0,0,0,0,0,0),('management',363,101,'admin/structure/block/list/bartik/add','admin/structure/block/list/bartik/add','Add block','a:0:{}','system',-1,0,0,0,0,5,0,1,20,28,101,363,0,0,0,0,0),('management',364,158,'admin/help/i18n','admin/help/i18n','i18n','a:0:{}','system',-1,0,0,0,0,3,0,1,158,364,0,0,0,0,0,0,0),('management',365,158,'admin/help/i18n_block','admin/help/i18n_block','i18n_block','a:0:{}','system',-1,0,0,0,0,3,0,1,158,365,0,0,0,0,0,0,0),('management',366,158,'admin/help/i18n_string','admin/help/i18n_string','i18n_string','a:0:{}','system',-1,0,0,0,0,3,0,1,158,366,0,0,0,0,0,0,0),('management',367,158,'admin/help/lang_dropdown','admin/help/lang_dropdown','lang_dropdown','a:0:{}','system',-1,0,0,0,0,3,0,1,158,367,0,0,0,0,0,0,0),('management',368,158,'admin/help/lang_dropdown_hideout','admin/help/lang_dropdown_hideout','lang_dropdown_hideout','a:0:{}','system',-1,0,0,0,0,3,0,1,158,368,0,0,0,0,0,0,0),('management',369,158,'admin/help/languageicons','admin/help/languageicons','languageicons','a:0:{}','system',-1,0,0,0,0,3,0,1,158,369,0,0,0,0,0,0,0),('management',370,158,'admin/help/locale','admin/help/locale','locale','a:0:{}','system',-1,0,0,0,0,3,0,1,158,370,0,0,0,0,0,0,0),('management',371,49,'admin/config/regional/language','admin/config/regional/language','Languages','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:55:\"Configure languages for content and the user interface.\";}}','system',0,0,1,0,-10,4,0,1,8,49,371,0,0,0,0,0,0),('management',372,49,'admin/config/regional/i18n','admin/config/regional/i18n','Multilingual settings','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:69:\"Configure extended options for multilingual content and translations.\";}}','system',0,0,0,0,10,4,0,1,8,49,372,0,0,0,0,0,0),('management',373,49,'admin/config/regional/translate','admin/config/regional/translate','Translate interface','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:59:\"Translate the built in interface and optionally other text.\";}}','system',0,0,1,0,-5,4,0,1,8,49,373,0,0,0,0,0,0),('management',374,371,'admin/config/regional/language/add','admin/config/regional/language/add','Add language','a:0:{}','system',-1,0,0,0,5,5,0,1,8,49,371,374,0,0,0,0,0),('management',375,371,'admin/config/regional/language/configure','admin/config/regional/language/configure','Detection and selection','a:0:{}','system',-1,0,0,0,10,5,0,1,8,49,371,375,0,0,0,0,0),('management',376,373,'admin/config/regional/translate/export','admin/config/regional/translate/export','Export','a:0:{}','system',-1,0,0,0,30,5,0,1,8,49,373,376,0,0,0,0,0),('management',377,371,'admin/config/regional/language/icons','admin/config/regional/language/icons','Icons','a:0:{}','system',-1,0,0,0,10,5,0,1,8,49,371,377,0,0,0,0,0),('management',378,373,'admin/config/regional/translate/import','admin/config/regional/translate/import','Import','a:0:{}','system',-1,0,0,0,20,5,0,1,8,49,373,378,0,0,0,0,0),('management',379,371,'admin/config/regional/language/overview','admin/config/regional/language/overview','List','a:0:{}','system',-1,0,0,0,0,5,0,1,8,49,371,379,0,0,0,0,0),('management',380,71,'admin/config/regional/date-time/locale','admin/config/regional/date-time/locale','Localize','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:38:\"Configure date formats for each locale\";}}','system',-1,0,1,0,-8,5,0,1,8,49,71,380,0,0,0,0,0),('management',381,372,'admin/config/regional/i18n/configure','admin/config/regional/i18n/configure','Multilingual system','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:69:\"Configure extended options for multilingual content and translations.\";}}','system',-1,0,0,0,0,5,0,1,8,49,372,381,0,0,0,0,0),('management',382,373,'admin/config/regional/translate/overview','admin/config/regional/translate/overview','Overview','a:0:{}','system',-1,0,0,0,0,5,0,1,8,49,373,382,0,0,0,0,0),('management',383,372,'admin/config/regional/i18n/strings','admin/config/regional/i18n/strings','Strings','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:33:\"Options for user defined strings.\";}}','system',-1,0,0,0,20,5,0,1,8,49,372,383,0,0,0,0,0),('management',384,373,'admin/config/regional/translate/i18n_string','admin/config/regional/translate/i18n_string','Strings','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:29:\"Refresh user defined strings.\";}}','system',-1,0,0,0,20,5,0,1,8,49,373,384,0,0,0,0,0),('management',385,373,'admin/config/regional/translate/translate','admin/config/regional/translate/translate','Translate','a:0:{}','system',-1,0,0,0,10,5,0,1,8,49,373,385,0,0,0,0,0),('management',386,371,'admin/config/regional/language/delete/%','admin/config/regional/language/delete/%','Confirm','a:0:{}','system',0,0,0,0,0,5,0,1,8,49,371,386,0,0,0,0,0),('management',387,373,'admin/config/regional/translate/delete/%','admin/config/regional/translate/delete/%','Delete string','a:0:{}','system',0,0,0,0,0,5,0,1,8,49,373,387,0,0,0,0,0),('management',388,371,'admin/config/regional/language/edit/%','admin/config/regional/language/edit/%','Edit language','a:0:{}','system',0,0,0,0,0,5,0,1,8,49,371,388,0,0,0,0,0),('management',389,373,'admin/config/regional/translate/edit/%','admin/config/regional/translate/edit/%','Edit string','a:0:{}','system',0,0,0,0,0,5,0,1,8,49,373,389,0,0,0,0,0),('management',390,375,'admin/config/regional/language/configure/session','admin/config/regional/language/configure/session','Session language detection configuration','a:0:{}','system',-1,0,0,0,0,6,0,1,8,49,371,375,390,0,0,0,0),('management',391,375,'admin/config/regional/language/configure/url','admin/config/regional/language/configure/url','URL language detection configuration','a:0:{}','system',-1,0,0,0,0,6,0,1,8,49,371,375,391,0,0,0,0),('management',392,380,'admin/config/regional/date-time/locale/%/edit','admin/config/regional/date-time/locale/%/edit','Localize date formats','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:38:\"Configure date formats for each locale\";}}','system',0,0,0,0,0,6,0,1,8,49,71,380,392,0,0,0,0),('management',393,380,'admin/config/regional/date-time/locale/%/reset','admin/config/regional/date-time/locale/%/reset','Reset date formats','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:47:\"Reset localized date formats to global defaults\";}}','system',0,0,0,0,0,6,0,1,8,49,71,380,393,0,0,0,0),('management',394,123,'admin/structure/block/manage/%/%/translate','admin/structure/block/manage/%/%/translate','Translate','a:0:{}','system',-1,0,0,0,10,5,0,1,20,28,123,394,0,0,0,0,0),('management',395,45,'admin/structure/menu/manage/menu-links','admin/structure/menu/manage/%','Links','a:0:{}','menu',0,0,0,0,0,4,0,1,20,45,395,0,0,0,0,0,0),('menu-links',396,0,'activity-stream','activity-stream',' What’s new','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:0:\"\";}}','menu',0,0,0,0,0,1,1,396,0,0,0,0,0,0,0,0,0),('menu-links',397,0,'articles','articles',' Articles','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:0:\"\";}}','menu',0,0,0,0,0,1,1,397,0,0,0,0,0,0,0,0,0),('menu-links',398,0,'blogs','blogs','Blogs','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:0:\"\";}}','menu',0,0,0,0,0,1,1,398,0,0,0,0,0,0,0,0,0),('menu-links',399,0,'node/2','node/%','Community Guidelines','a:0:{}','menu',0,0,0,0,0,1,0,399,0,0,0,0,0,0,0,0,0),('management',400,45,'admin/structure/menu/manage/menu-footer-menu','admin/structure/menu/manage/%','Footer menu','a:0:{}','menu',0,0,0,0,0,4,0,1,20,45,400,0,0,0,0,0,0),('menu-footer-menu',401,0,'<front>','','Forum Plus','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:0:\"\";}}','menu',0,1,0,0,-50,1,1,401,0,0,0,0,0,0,0,0,0),('menu-footer-menu',403,0,'contact','contact','Contact','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:0:\"\";}}','system',0,0,0,0,-47,1,1,403,0,0,0,0,0,0,0,0,0),('navigation',404,16,'user/%/contact','user/%/contact','Contact','a:0:{}','system',-1,0,0,0,2,2,0,16,404,0,0,0,0,0,0,0,0),('management',405,20,'admin/structure/contact','admin/structure/contact','Contact form','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:71:\"Create a system contact form and set up categories for the form to use.\";}}','system',0,0,1,0,0,3,0,1,20,405,0,0,0,0,0,0,0),('management',406,158,'admin/help/contact','admin/help/contact','contact','a:0:{}','system',-1,0,0,0,0,3,0,1,158,406,0,0,0,0,0,0,0),('management',407,405,'admin/structure/contact/add','admin/structure/contact/add','Add category','a:0:{}','system',-1,0,0,0,1,4,0,1,20,405,407,0,0,0,0,0,0),('management',408,405,'admin/structure/contact/delete/%','admin/structure/contact/delete/%','Delete contact','a:0:{}','system',0,0,0,0,0,4,0,1,20,405,408,0,0,0,0,0,0),('management',409,405,'admin/structure/contact/edit/%','admin/structure/contact/edit/%','Edit contact category','a:0:{}','system',0,0,0,0,0,4,0,1,20,405,409,0,0,0,0,0,0),('navigation',415,0,'tagclouds','tagclouds','Tags','a:0:{}','system',1,0,0,0,0,1,0,415,0,0,0,0,0,0,0,0,0),('navigation',416,415,'tagclouds/chunk/%','tagclouds/chunk/%','Tags','a:0:{}','system',1,0,0,0,0,2,0,415,416,0,0,0,0,0,0,0,0),('management',417,33,'admin/config/content/tagclouds','admin/config/content/tagclouds','TagClouds configuration','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:89:\"Configure the tag clouds. Set the order, the number of tags, and the depth of the clouds.\";}}','system',0,0,0,0,0,4,0,1,8,33,417,0,0,0,0,0,0),('main-menu',418,310,'forum/view','forum/view','View Forums','a:0:{}','system',-1,0,0,0,-100,2,0,310,418,0,0,0,0,0,0,0,0),('management',419,33,'admin/config/content/advanced-forum','admin/config/content/advanced-forum','Advanced Forum','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:45:\"Configure Advanced Forum with these settings.\";}}','system',0,0,0,0,0,4,0,1,8,33,419,0,0,0,0,0,0),('main-menu',423,310,'forum/active','forum/active','Active topics','a:0:{}','system',-1,0,0,0,1,2,0,310,423,0,0,0,0,0,0,0,0),('main-menu',424,310,'forum/new','forum/new','New & updated topics','a:0:{}','system',-1,0,0,0,2,2,0,310,424,0,0,0,0,0,0,0,0),('main-menu',425,310,'forum/unanswered','forum/unanswered','Unanswered topics','a:0:{}','system',-1,0,0,0,1,2,0,310,425,0,0,0,0,0,0,0,0),('user-menu',426,0,'user/login','user/login','Login','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:0:\"\";}}','menu',0,0,0,0,0,1,1,426,0,0,0,0,0,0,0,0,0),('management',427,18,'admin/reports/hits','admin/reports/hits','Recent hits','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:43:\"View pages that have recently been visited.\";}}','system',0,0,0,0,0,3,0,1,18,427,0,0,0,0,0,0,0),('management',428,18,'admin/reports/pages','admin/reports/pages','Top pages','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:41:\"View pages that have been hit frequently.\";}}','system',0,0,0,0,1,3,0,1,18,428,0,0,0,0,0,0,0),('management',429,18,'admin/reports/referrers','admin/reports/referrers','Top referrers','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:19:\"View top referrers.\";}}','system',0,0,0,0,0,3,0,1,18,429,0,0,0,0,0,0,0),('management',430,18,'admin/reports/visitors','admin/reports/visitors','Top visitors','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:34:\"View visitors that hit many pages.\";}}','system',0,0,0,0,2,3,0,1,18,430,0,0,0,0,0,0,0),('navigation',431,5,'node/%/track','node/%/track','Track','a:0:{}','system',-1,0,0,0,2,2,0,5,431,0,0,0,0,0,0,0,0),('management',432,158,'admin/help/statistics','admin/help/statistics','statistics','a:0:{}','system',-1,0,0,0,0,3,0,1,158,432,0,0,0,0,0,0,0),('management',433,18,'admin/reports/access/%','admin/reports/access/%','Details','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:16:\"View access log.\";}}','system',0,0,0,0,0,3,0,1,18,433,0,0,0,0,0,0,0),('management',434,54,'admin/config/system/statistics','admin/config/system/statistics','Statistics','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:68:\"Control details about what and how your site logs access statistics.\";}}','system',0,0,0,0,-15,4,0,1,8,54,434,0,0,0,0,0,0),('navigation',435,16,'user/%/track/navigation','user/%/track/navigation','Track page visits','a:0:{}','system',-1,0,0,0,2,2,0,16,435,0,0,0,0,0,0,0,0),('management',436,158,'admin/help/fivestar','admin/help/fivestar','fivestar','a:0:{}','system',-1,0,0,0,0,3,0,1,158,436,0,0,0,0,0,0,0),('management',437,33,'admin/config/content/fivestar','admin/config/content/fivestar','Fivestar','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:53:\"Configure site-wide widgets used for Fivestar rating.\";}}','system',0,0,0,0,0,4,0,1,8,33,437,0,0,0,0,0,0),('management',438,51,'admin/config/search/votingapi','admin/config/search/votingapi','Voting API','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:65:\"Configure sitewide settings for user-generated ratings and votes.\";}}','system',0,0,0,0,0,4,0,1,8,51,438,0,0,0,0,0,0),('management',439,20,'admin/structure/messages','admin/structure/messages','Message types','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:21:\"Manage Message types.\";}}','system',0,0,1,0,0,3,0,1,20,439,0,0,0,0,0,0,0),('management',440,9,'admin/content/message','admin/content/message','Messages','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:23:\"A list of all messages.\";}}','system',-1,0,0,0,0,3,0,1,9,440,0,0,0,0,0,0,0),('management',441,439,'admin/structure/messages/add','admin/structure/messages/add','','a:0:{}','system',-1,0,0,0,0,4,0,1,20,439,441,0,0,0,0,0,0),('management',442,439,'admin/structure/messages/import','admin/structure/messages/import','','a:0:{}','system',-1,0,0,0,0,4,0,1,20,439,442,0,0,0,0,0,0),('management',443,439,'admin/structure/messages/list','admin/structure/messages/list','List','a:0:{}','system',-1,0,0,0,-10,4,0,1,20,439,443,0,0,0,0,0,0),('management',444,54,'admin/config/system/message','admin/config/system/message','Message settings','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:33:\"Manage message purging upon cron.\";}}','system',0,0,1,0,0,4,0,1,8,54,444,0,0,0,0,0,0),('management',445,444,'admin/config/system/message/text-copy','admin/config/system/message/text-copy','Copy messages text fields','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:53:\"Copy messages text fields from one language to others\";}}','system',0,0,0,0,0,5,0,1,8,54,444,445,0,0,0,0,0),('management',446,439,'admin/structure/messages/manage/%','admin/structure/messages/manage/%','Edit','a:0:{}','system',0,0,1,0,0,4,0,1,20,439,446,0,0,0,0,0,0),('management',447,446,'admin/structure/messages/manage/%/%','admin/structure/messages/manage/%/%','','a:0:{}','system',0,0,0,0,0,5,0,1,20,439,446,447,0,0,0,0,0),('management',448,446,'admin/structure/messages/manage/%/clone','admin/structure/messages/manage/%/clone','Clone','a:0:{}','system',0,0,0,0,0,5,0,1,20,439,446,448,0,0,0,0,0),('management',449,446,'admin/structure/messages/manage/%/edit','admin/structure/messages/manage/%/edit','Edit','a:0:{}','system',-1,0,0,0,0,5,0,1,20,439,446,449,0,0,0,0,0),('navigation',450,0,'message-example','message-example','Message example','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:35:\"Typical UAS (User activity stream).\";}}','system',0,0,0,0,0,1,0,450,0,0,0,0,0,0,0,0,0),('management',451,20,'admin/structure/features','admin/structure/features','Features','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:16:\"Manage features.\";}}','system',0,0,0,0,0,3,0,1,20,451,0,0,0,0,0,0,0),('management',452,158,'admin/help/features','admin/help/features','features','a:0:{}','system',-1,0,0,0,0,3,0,1,158,452,0,0,0,0,0,0,0),('management',453,158,'admin/help/strongarm','admin/help/strongarm','strongarm','a:0:{}','system',-1,0,0,0,0,3,0,1,158,453,0,0,0,0,0,0,0),('management',454,158,'admin/help/token','admin/help/token','token','a:0:{}','system',-1,0,0,0,0,3,0,1,158,454,0,0,0,0,0,0,0),('management',455,451,'admin/structure/features/create','admin/structure/features/create','Create feature','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:21:\"Create a new feature.\";}}','system',-1,0,0,0,10,4,0,1,20,451,455,0,0,0,0,0,0),('management',456,451,'admin/structure/features/manage','admin/structure/features/manage','Manage','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:28:\"Enable and disable features.\";}}','system',-1,0,0,0,0,4,0,1,20,451,456,0,0,0,0,0,0),('management',457,451,'admin/structure/features/settings','admin/structure/features/settings','Settings','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:42:\"Adjust settings for using features module.\";}}','system',-1,0,0,0,11,4,0,1,20,451,457,0,0,0,0,0,0),('management',458,37,'admin/config/development/strongarm','admin/config/development/strongarm','Strongarm','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:59:\"Manage Drupal variable settings that have been strongarmed.\";}}','system',0,0,0,0,0,4,0,1,8,37,458,0,0,0,0,0,0),('management',459,451,'admin/structure/features/%/view','admin/structure/features/%/view','View','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:32:\"Display components of a feature.\";}}','system',-1,0,0,0,-10,4,0,1,20,451,459,0,0,0,0,0,0),('management',460,451,'admin/structure/features/%/recreate','admin/structure/features/%/recreate','Recreate','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:29:\"Recreate an existing feature.\";}}','system',-1,0,0,0,11,4,0,1,20,451,460,0,0,0,0,0,0),('main-menu',483,0,'activity-stream','activity-stream','What\'s New','a:0:{}','system',0,0,0,0,-44,1,1,483,0,0,0,0,0,0,0,0,0),('management',491,158,'admin/help/jquery_update','admin/help/jquery_update','jquery_update','a:0:{}','system',-1,0,0,0,0,3,0,1,158,491,0,0,0,0,0,0,0),('management',492,37,'admin/config/development/jquery_update','admin/config/development/jquery_update','jQuery update','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:83:\"Configure settings related to the jQuery upgrade, the library path and compression.\";}}','system',0,0,0,0,0,4,0,1,8,37,492,0,0,0,0,0,0),('management',503,158,'admin/help/pathauto','admin/help/pathauto','pathauto','a:0:{}','system',-1,0,0,0,0,3,0,1,158,503,0,0,0,0,0,0,0),('management',504,199,'admin/config/search/path/update_bulk','admin/config/search/path/update_bulk','Bulk update','a:0:{}','system',-1,0,0,0,30,5,0,1,8,51,199,504,0,0,0,0,0),('management',505,199,'admin/config/search/path/delete_bulk','admin/config/search/path/delete_bulk','Delete aliases','a:0:{}','system',-1,0,0,0,40,5,0,1,8,51,199,505,0,0,0,0,0),('management',506,199,'admin/config/search/path/patterns','admin/config/search/path/patterns','Patterns','a:0:{}','system',-1,0,0,0,10,5,0,1,8,51,199,506,0,0,0,0,0),('management',507,199,'admin/config/search/path/settings','admin/config/search/path/settings','Settings','a:0:{}','system',-1,0,0,0,20,5,0,1,8,51,199,507,0,0,0,0,0),('management',508,20,'admin/structure/quicktabs','admin/structure/quicktabs','Quicktabs','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:32:\"Create blocks of tabbed content.\";}}','system',0,0,1,0,0,3,0,1,20,508,0,0,0,0,0,0,0),('management',509,158,'admin/help/quicktabs','admin/help/quicktabs','quicktabs','a:0:{}','system',-1,0,0,0,0,3,0,1,158,509,0,0,0,0,0,0,0),('management',510,508,'admin/structure/quicktabs/add','admin/structure/quicktabs/add','Add Quicktabs Instance','a:0:{}','system',-1,0,0,0,0,4,0,1,20,508,510,0,0,0,0,0,0),('management',511,508,'admin/structure/quicktabs/list','admin/structure/quicktabs/list','List quicktabs','a:0:{}','system',-1,0,0,0,0,4,0,1,20,508,511,0,0,0,0,0,0),('management',512,508,'admin/structure/quicktabs/manage/%','admin/structure/quicktabs/manage/%','Edit quicktab','a:0:{}','system',0,0,0,0,0,4,0,1,20,508,512,0,0,0,0,0,0),('management',513,512,'admin/structure/quicktabs/manage/%/clone','admin/structure/quicktabs/manage/%/clone','Clone quicktab','a:0:{}','system',-1,0,0,0,0,5,0,1,20,508,512,513,0,0,0,0,0),('management',514,512,'admin/structure/quicktabs/manage/%/delete','admin/structure/quicktabs/manage/%/delete','Delete quicktab','a:0:{}','system',-1,0,0,0,0,5,0,1,20,508,512,514,0,0,0,0,0),('management',515,512,'admin/structure/quicktabs/manage/%/edit','admin/structure/quicktabs/manage/%/edit','Edit quicktab','a:0:{}','system',-1,0,0,0,0,5,0,1,20,508,512,515,0,0,0,0,0),('management',516,512,'admin/structure/quicktabs/manage/%/export','admin/structure/quicktabs/manage/%/export','Export','a:0:{}','system',-1,0,0,0,0,5,0,1,20,508,512,516,0,0,0,0,0),('management',517,158,'admin/help/i18n_taxonomy','admin/help/i18n_taxonomy','i18n_taxonomy','a:0:{}','system',-1,0,0,0,0,3,0,1,158,517,0,0,0,0,0,0,0),('navigation',518,159,'taxonomy/term/%/translate','taxonomy/term/%/translate','Translate','a:0:{}','system',-1,0,0,0,10,2,0,159,518,0,0,0,0,0,0,0,0),('management',519,49,'admin/config/regional/i18n_translation','admin/config/regional/i18n_translation','Translation sets','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:26:\"Translation sets overview.\";}}','system',0,0,0,0,10,4,0,1,8,49,519,0,0,0,0,0,0),('management',520,194,'admin/structure/taxonomy/%/translate','admin/structure/taxonomy/%/translate','Translate','a:0:{}','system',-1,0,0,0,10,5,0,1,20,162,194,520,0,0,0,0,0),('management',521,519,'admin/config/regional/i18n_translation/configure','admin/config/regional/i18n_translation/configure','Translation sets','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:38:\"Overview of existing translation sets.\";}}','system',-1,0,0,0,0,5,0,1,8,49,519,521,0,0,0,0,0),('management',522,206,'admin/structure/taxonomy/%/list/list','admin/structure/taxonomy/%/list/list','Terms','a:0:{}','system',-1,0,0,0,-20,6,0,1,20,162,194,206,522,0,0,0,0),('management',523,206,'admin/structure/taxonomy/%/list/sets','admin/structure/taxonomy/%/list/sets','Translation sets','a:0:{}','system',-1,0,0,0,0,6,0,1,20,162,194,206,523,0,0,0,0),('management',524,523,'admin/structure/taxonomy/%/list/sets/add','admin/structure/taxonomy/%/list/sets/add','Create new translation','a:0:{}','system',-1,0,0,0,0,7,0,1,20,162,194,206,523,524,0,0,0),('management',525,45,'admin/structure/menu/manage/menu-sections','admin/structure/menu/manage/%','Sections','a:0:{}','menu',0,0,0,0,0,4,0,1,20,45,525,0,0,0,0,0,0),('management',526,45,'admin/structure/menu/manage/menu-categories','admin/structure/menu/manage/%','Categories','a:0:{}','menu',0,0,0,0,0,4,0,1,20,45,526,0,0,0,0,0,0),('menu-sections',527,0,'taxonomy/term/27','taxonomy/term/%','Documentation','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:13:\"Documentation\";}}','taxonomy_menu',0,0,0,1,1,1,0,527,0,0,0,0,0,0,0,0,0),('menu-sections',528,0,'taxonomy/term/28','taxonomy/term/%','Graphic design','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:14:\"Graphic design\";}}','taxonomy_menu',0,0,0,1,2,1,0,528,0,0,0,0,0,0,0,0,0),('menu-sections',529,0,'taxonomy/term/29','taxonomy/term/%','Web development','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:15:\"Web development\";}}','taxonomy_menu',0,0,1,1,4,1,0,529,0,0,0,0,0,0,0,0,0),('menu-sections',530,529,'taxonomy/term/31','taxonomy/term/%','Web maintenance','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:15:\"Web maintenance\";}}','taxonomy_menu',0,0,0,1,0,2,0,529,530,0,0,0,0,0,0,0,0),('menu-sections',531,529,'taxonomy/term/32','taxonomy/term/%','Web services','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:12:\"Web services\";}}','taxonomy_menu',0,0,0,1,1,2,0,529,531,0,0,0,0,0,0,0,0),('menu-sections',532,0,'taxonomy/term/30','taxonomy/term/%','Themes','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:6:\"Themes\";}}','taxonomy_menu',0,0,0,1,5,1,0,532,0,0,0,0,0,0,0,0,0),('menu-categories',533,0,'taxonomy/term/23','taxonomy/term/%','CMS (2)','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:7:\"CMS (2)\";}}','taxonomy_menu',0,0,0,1,0,1,0,533,0,0,0,0,0,0,0,0,0),('menu-categories',534,0,'taxonomy/term/24','taxonomy/term/%','eCommerce (1)','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:13:\"eCommerce (1)\";}}','taxonomy_menu',0,0,0,1,0,1,0,534,0,0,0,0,0,0,0,0,0),('menu-categories',535,0,'taxonomy/term/21','taxonomy/term/%','HTML (1)','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:8:\"HTML (1)\";}}','taxonomy_menu',0,0,0,1,0,1,0,535,0,0,0,0,0,0,0,0,0),('menu-categories',536,0,'taxonomy/term/22','taxonomy/term/%','Marketing (2)','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:13:\"Marketing (2)\";}}','taxonomy_menu',0,0,0,1,0,1,0,536,0,0,0,0,0,0,0,0,0),('menu-categories',537,0,'taxonomy/term/26','taxonomy/term/%','Plugins (1)','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:11:\"Plugins (1)\";}}','taxonomy_menu',0,0,0,1,0,1,0,537,0,0,0,0,0,0,0,0,0),('menu-categories',538,0,'taxonomy/term/25','taxonomy/term/%','PSD (2)','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:7:\"PSD (2)\";}}','taxonomy_menu',0,0,0,1,0,1,0,538,0,0,0,0,0,0,0,0,0),('menu-categories',539,0,'taxonomy/term/20','taxonomy/term/%','Wordpress (0)','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:13:\"Wordpress (0)\";}}','taxonomy_menu',0,0,0,1,0,1,0,539,0,0,0,0,0,0,0,0,0),('main-menu',540,310,'node/add/forum','node/add/forum','New posts','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:0:\"\";}}','menu',0,0,0,0,-50,2,1,310,540,0,0,0,0,0,0,0,0),('management',541,8,'admin/config/date','admin/config/date','Date API','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:42:\"Settings for modules the use the Date API.\";}}','system',0,0,1,0,-10,3,0,1,8,541,0,0,0,0,0,0,0),('management',542,158,'admin/help/calendar','admin/help/calendar','calendar','a:0:{}','system',-1,0,0,0,0,3,0,1,158,542,0,0,0,0,0,0,0),('management',543,541,'admin/config/date/calendar','admin/config/date/calendar','Calendar','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:24:\"Calendar administration.\";}}','system',0,0,0,0,0,4,0,1,8,541,543,0,0,0,0,0,0),('main-menu',544,310,'calendar','calendar','Calendar','a:0:{}','system',0,0,0,0,-49,2,1,310,544,0,0,0,0,0,0,0,0),('main-menu',545,310,'faq-page','faq-page','FAQ','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:0:\"\";}}','system',0,0,0,0,-48,2,1,310,545,0,0,0,0,0,0,0,0),('main-menu',546,545,'faq-page/list','faq-page/list','List','a:0:{}','system',-1,0,0,0,-10,3,0,310,545,546,0,0,0,0,0,0,0),('main-menu',547,545,'faq-page/order','faq-page/order','Order','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:78:\"Allows the user to configure the order of questions and answers on a FAQ page.\";}}','system',-1,0,0,0,-8,3,0,310,545,547,0,0,0,0,0,0,0),('main-menu',548,545,'faq-page/%/list','faq-page/%/list','List','a:0:{}','system',-1,0,0,0,-10,3,0,310,545,548,0,0,0,0,0,0,0),('main-menu',549,545,'faq-page/%/order','faq-page/%/order','Order','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:78:\"Allows the user to configure the order of questions and answers on a FAQ page.\";}}','system',-1,0,0,0,-8,3,0,310,545,549,0,0,0,0,0,0,0),('navigation',550,6,'node/add/faq','node/add/faq','FAQ','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:43:\"A frequently asked question and its answer.\";}}','system',0,0,0,0,0,2,0,6,550,0,0,0,0,0,0,0,0),('management',551,158,'admin/help/faq','admin/help/faq','faq','a:0:{}','system',-1,0,0,0,0,3,0,1,158,551,0,0,0,0,0,0,0),('management',552,33,'admin/config/content/faq','admin/config/content/faq','Frequently Asked Questions','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:79:\"Allows the user to configure the layout of questions and answers on a FAQ page.\";}}','system',0,0,0,0,0,4,0,1,8,33,552,0,0,0,0,0,0),('management',553,552,'admin/config/content/faq/categories','admin/config/content/faq/categories','Categories','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:96:\"Allows the user to configure the layout of questions and answers using categories on a FAQ page.\";}}','system',-1,0,0,0,-8,5,0,1,8,33,552,553,0,0,0,0,0),('management',554,552,'admin/config/content/faq/general','admin/config/content/faq/general','General','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:78:\"Allows the user to configure the header and descriptive text for the FAQ page.\";}}','system',-1,0,0,0,-10,5,0,1,8,33,552,554,0,0,0,0,0),('management',555,552,'admin/config/content/faq/questions','admin/config/content/faq/questions','Questions','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:79:\"Allows the user to configure the layout of questions and answers on a FAQ page.\";}}','system',-1,0,0,0,-9,5,0,1,8,33,552,555,0,0,0,0,0),('menu-footer-menu',562,0,'archive','archive','Archive','a:0:{}','system',0,0,0,0,-48,1,1,562,0,0,0,0,0,0,0,0,0),('menu-footer-menu',563,0,'faq-page','faq-page','FAQ','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:0:\"\";}}','menu',0,0,0,0,-49,1,1,563,0,0,0,0,0,0,0,0,0),('management',564,37,'admin/config/development/modal_forms','admin/config/development/modal_forms','Modal forms','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:28:\"Adjust Modal forms settings.\";}}','system',0,0,0,0,0,4,0,1,8,37,564,0,0,0,0,0,0),('management',565,158,'admin/help/php','admin/help/php','php','a:0:{}','system',-1,0,0,0,0,3,0,1,158,565,0,0,0,0,0,0,0),('main-menu',566,0,'contact','contact','Contact','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:0:\"\";}}','menu',0,0,1,1,-42,1,1,566,0,0,0,0,0,0,0,0,0),('main-menu',567,359,'articles-teaser','articles-teaser','Articles Teaser','a:0:{}','system',0,0,0,0,-50,2,1,359,567,0,0,0,0,0,0,0,0),('main-menu',569,359,'articles-1','articles-1','Articles 1','a:0:{}','system',0,0,0,0,-50,2,1,359,569,0,0,0,0,0,0,0,0),('main-menu',570,359,'articles-2','articles-2','Articles 2','a:0:{}','system',0,0,0,0,-49,2,1,359,570,0,0,0,0,0,0,0,0),('main-menu',571,0,'node/33','node/%','404 page','a:0:{}','menu',1,0,0,0,-41,1,1,571,0,0,0,0,0,0,0,0,0),('management',572,158,'admin/help/menu_breadcrumb','admin/help/menu_breadcrumb','menu_breadcrumb','a:0:{}','system',-1,0,0,0,0,3,0,1,158,572,0,0,0,0,0,0,0),('management',573,58,'admin/config/user-interface/menu-breadcrumb','admin/config/user-interface/menu-breadcrumb','Menu Breadcrumb','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:26:\"Configure menu breadcrumb.\";}}','system',0,0,0,0,0,4,0,1,8,58,573,0,0,0,0,0,0),('main-menu',574,359,'articles-two-columns','articles-two-columns','Two Columns','a:0:{}','system',0,0,0,0,-49,2,1,359,574,0,0,0,0,0,0,0,0),('main-menu',575,359,'articles-three-columns','articles-three-columns','Three Columns','a:0:{}','system',0,0,0,0,-48,2,1,359,575,0,0,0,0,0,0,0,0),('main-menu',576,359,'articles-four-columns','articles-four-columns','Four Columns','a:0:{}','system',0,0,0,0,-47,2,1,359,576,0,0,0,0,0,0,0,0),('management',577,158,'admin/help/sharethis','admin/help/sharethis','sharethis','a:0:{}','system',-1,0,0,0,0,3,0,1,158,577,0,0,0,0,0,0,0),('management',578,61,'admin/config/services/sharethis','admin/config/services/sharethis','ShareThis','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:91:\"Choose the widget, button family, and services for using ShareThis to share content online.\";}}','system',0,0,0,0,0,4,0,1,8,61,578,0,0,0,0,0,0),('navigation',579,6,'node/add/video','node/add/video','Video','a:0:{}','system',0,0,0,0,0,2,0,6,579,0,0,0,0,0,0,0,0),('main-menu',587,627,'blogs/two','blogs/two','Two Columns','a:0:{}','system',0,0,0,0,-47,2,1,627,587,0,0,0,0,0,0,0,0),('main-menu',588,627,'blogs/three','blogs/three','Three Columns','a:0:{}','system',0,0,0,0,-48,2,1,627,588,0,0,0,0,0,0,0,0),('main-menu',589,359,'articles/two','articles/two','Two Columns','a:0:{}','system',0,0,0,0,0,2,0,359,589,0,0,0,0,0,0,0,0),('main-menu',590,359,'articles/three','articles/three','Three Columns','a:0:{}','system',0,0,0,0,0,2,0,359,590,0,0,0,0,0,0,0,0),('main-menu',595,627,'blogs/mix','blogs/mix','Blogs Mix','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:0:\"\";}}','system',0,0,0,0,-50,2,1,627,595,0,0,0,0,0,0,0,0),('navigation',596,5,'node/%/webform-results','node/%/webform-results','Results','a:0:{}','system',-1,0,0,0,2,2,0,5,596,0,0,0,0,0,0,0,0),('navigation',597,6,'node/add/webform','node/add/webform','Webform','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:138:\"Create a new form or questionnaire accessible to users. Submission results and statistics are recorded and accessible to privileged users.\";}}','system',0,0,0,0,0,2,0,6,597,0,0,0,0,0,0,0,0),('navigation',598,5,'node/%/webform','node/%/webform','Webform','a:0:{}','system',-1,0,0,0,1,2,0,5,598,0,0,0,0,0,0,0,0),('management',599,9,'admin/content/webform','admin/content/webform','Webforms','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:54:\"View and edit all the available webforms on your site.\";}}','system',-1,0,0,0,0,3,0,1,9,599,0,0,0,0,0,0,0),('management',600,158,'admin/help/webform','admin/help/webform','webform','a:0:{}','system',-1,0,0,0,0,3,0,1,158,600,0,0,0,0,0,0,0),('navigation',601,596,'node/%/webform-results/analysis','node/%/webform-results/analysis','Analysis','a:0:{}','system',-1,0,0,0,5,3,0,5,596,601,0,0,0,0,0,0,0),('navigation',602,596,'node/%/webform-results/clear','node/%/webform-results/clear','Clear','a:0:{}','system',-1,0,0,0,8,3,0,5,596,602,0,0,0,0,0,0,0),('navigation',603,596,'node/%/webform-results/download','node/%/webform-results/download','Download','a:0:{}','system',-1,0,0,0,7,3,0,5,596,603,0,0,0,0,0,0,0),('navigation',604,598,'node/%/webform/emails','node/%/webform/emails','E-mails','a:0:{}','system',-1,0,0,0,4,3,0,5,598,604,0,0,0,0,0,0,0),('navigation',605,598,'node/%/webform/components','node/%/webform/components','Form components','a:0:{}','system',-1,0,0,0,0,3,0,5,598,605,0,0,0,0,0,0,0),('navigation',606,598,'node/%/webform/configure','node/%/webform/configure','Form settings','a:0:{}','system',-1,0,0,0,5,3,0,5,598,606,0,0,0,0,0,0,0),('navigation',607,596,'node/%/webform-results/submissions','node/%/webform-results/submissions','Submissions','a:0:{}','system',-1,0,0,0,4,3,0,5,596,607,0,0,0,0,0,0,0),('navigation',608,596,'node/%/webform-results/table','node/%/webform-results/table','Table','a:0:{}','system',-1,0,0,0,6,3,0,5,596,608,0,0,0,0,0,0,0),('management',609,33,'admin/config/content/webform','admin/config/content/webform','Webform settings','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:46:\"Global configuration of webform functionality.\";}}','system',0,0,0,0,0,4,0,1,8,33,609,0,0,0,0,0,0),('navigation',610,5,'node/%/submission/%/delete','node/%/submission/%/delete','Delete','a:0:{}','system',-1,0,0,0,2,2,0,5,610,0,0,0,0,0,0,0,0),('navigation',611,5,'node/%/submission/%/edit','node/%/submission/%/edit','Edit','a:0:{}','system',-1,0,0,0,1,2,0,5,611,0,0,0,0,0,0,0,0),('navigation',612,604,'node/%/webform/emails/%','node/%/webform/emails/%','','a:0:{}','system',-1,0,0,0,0,4,0,5,598,604,612,0,0,0,0,0,0),('navigation',613,605,'node/%/webform/components/%','node/%/webform/components/%','','a:0:{}','system',-1,0,0,0,0,4,0,5,598,605,613,0,0,0,0,0,0),('navigation',614,5,'node/%/submission/%/view','node/%/submission/%/view','View','a:0:{}','system',-1,0,0,0,0,2,0,5,614,0,0,0,0,0,0,0,0),('navigation',615,613,'node/%/webform/components/%/delete','node/%/webform/components/%/delete','','a:0:{}','system',-1,0,0,0,0,5,0,5,598,605,613,615,0,0,0,0,0),('navigation',616,612,'node/%/webform/emails/%/delete','node/%/webform/emails/%/delete','','a:0:{}','system',-1,0,0,0,0,5,0,5,598,604,612,616,0,0,0,0,0),('navigation',617,613,'node/%/webform/components/%/clone','node/%/webform/components/%/clone','','a:0:{}','system',-1,0,0,0,0,5,0,5,598,605,613,617,0,0,0,0,0),('main-menu',618,566,'contact','contact','Contact Us','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:0:\"\";}}','menu',0,0,0,0,-50,2,1,566,618,0,0,0,0,0,0,0,0),('management',619,33,'admin/config/content/webform-hints','admin/config/content/webform-hints','Webform Hints settings','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:64:\"Administer which of your Webforms will receive the hints effect.\";}}','system',0,0,0,0,0,4,0,1,8,33,619,0,0,0,0,0,0),('main-menu',620,566,'node/41','node/%','Contact Us 2','a:0:{}','menu',0,0,0,0,-49,2,1,566,620,0,0,0,0,0,0,0,0),('main-menu',621,0,'node/42','node/%','Color','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:0:\"\";}}','menu',0,0,1,1,-43,1,1,621,0,0,0,0,0,0,0,0,0),('main-menu',622,621,'node/43','node/%','Default','a:0:{}','menu',0,0,0,0,-50,2,1,621,622,0,0,0,0,0,0,0,0),('main-menu',623,621,'node/44','node/%','Red','a:0:{}','menu',0,0,0,0,-48,2,1,621,623,0,0,0,0,0,0,0,0),('main-menu',624,621,'node/45','node/%','Yellow','a:0:{}','menu',0,0,0,0,-49,2,1,621,624,0,0,0,0,0,0,0,0),('main-menu',626,627,'blogs/teaser','blogs/teaser','Blogs Teaser','a:0:{}','system',0,0,0,0,-49,2,1,627,626,0,0,0,0,0,0,0,0),('main-menu',627,0,'blogs','blogs','Blogs','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:0:\"\";}}','system',0,0,1,1,-47,1,1,627,0,0,0,0,0,0,0,0,0),('management',628,158,'admin/help/remember_me','admin/help/remember_me','remember_me','a:0:{}','system',-1,0,0,0,0,3,0,1,158,628,0,0,0,0,0,0,0),('management',629,54,'admin/config/system/remember_me','admin/config/system/remember_me','Remember me settings','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:64:\"Configure settings like session time out for remember_me module.\";}}','system',0,0,0,0,0,4,0,1,8,54,629,0,0,0,0,0,0),('management',630,158,'admin/help/flexslider','admin/help/flexslider','flexslider','a:0:{}','system',-1,0,0,0,0,3,0,1,158,630,0,0,0,0,0,0,0),('management',631,44,'admin/config/media/flexslider','admin/config/media/flexslider','FlexSlider','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:30:\"Administer FlexSlider presets.\";}}','system',0,0,0,0,0,4,0,1,8,44,631,0,0,0,0,0,0),('management',632,631,'admin/config/media/flexslider/add','admin/config/media/flexslider/add','Add','a:0:{}','system',-1,0,0,0,0,5,0,1,8,44,631,632,0,0,0,0,0),('management',633,631,'admin/config/media/flexslider/advanced','admin/config/media/flexslider/advanced','Advanced settings','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:50:\"Configure the advanced flexslider module settings.\";}}','system',-1,0,0,0,2,5,0,1,8,44,631,633,0,0,0,0,0),('management',634,631,'admin/config/media/flexslider/import','admin/config/media/flexslider/import','Import','a:0:{}','system',-1,0,0,0,0,5,0,1,8,44,631,634,0,0,0,0,0),('management',635,631,'admin/config/media/flexslider/list','admin/config/media/flexslider/list','List','a:0:{}','system',-1,0,0,0,-10,5,0,1,8,44,631,635,0,0,0,0,0),('management',636,635,'admin/config/media/flexslider/list/%/edit','admin/config/media/flexslider/list/%/edit','Edit','a:0:{}','system',-1,0,0,0,-10,6,0,1,8,44,631,635,636,0,0,0,0),('management',637,635,'admin/config/media/flexslider/list/%/export','admin/config/media/flexslider/list/%/export','Export','a:0:{}','system',-1,0,0,0,0,6,0,1,8,44,631,635,637,0,0,0,0),('navigation',638,6,'node/add/products','node/add/products','Products','a:0:{}','system',0,0,0,0,0,2,0,6,638,0,0,0,0,0,0,0,0),('management',639,20,'admin/structure/field-collections','admin/structure/field-collections','Field collections','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:35:\"Manage fields on field collections.\";}}','system',0,0,1,0,0,3,0,1,20,639,0,0,0,0,0,0,0),('management',640,158,'admin/help/field_collection','admin/help/field_collection','field_collection','a:0:{}','system',-1,0,0,0,0,3,0,1,158,640,0,0,0,0,0,0,0),('navigation',658,0,'field-collection/field-extra-content/%','field-collection/field-extra-content/%','','a:0:{}','system',0,0,1,0,0,1,0,658,0,0,0,0,0,0,0,0,0),('navigation',659,658,'field-collection/field-extra-content/%/delete','field-collection/field-extra-content/%/delete','Delete','a:0:{}','system',-1,0,0,0,0,2,0,658,659,0,0,0,0,0,0,0,0),('navigation',660,658,'field-collection/field-extra-content/%/edit','field-collection/field-extra-content/%/edit','Edit','a:0:{}','system',-1,0,0,0,0,2,0,658,660,0,0,0,0,0,0,0,0),('navigation',661,658,'field-collection/field-extra-content/%/view','field-collection/field-extra-content/%/view','View','a:0:{}','system',-1,0,0,0,-10,2,0,658,661,0,0,0,0,0,0,0,0),('navigation',663,0,'field-collection/field-extra-content/add/%/%','field-collection/field-extra-content/add/%/%','','a:0:{}','system',0,0,0,0,0,1,0,663,0,0,0,0,0,0,0,0,0),('navigation',664,658,'field-collection/field-extra-content/%/revisions/%','field-collection/field-extra-content/%/revisions/%','','a:0:{}','system',0,0,0,0,0,2,0,658,664,0,0,0,0,0,0,0,0),('main-menu',675,621,'node/57','node/%','Green','a:0:{}','menu',0,0,0,0,0,2,0,621,675,0,0,0,0,0,0,0,0),('management',676,20,'admin/structure/token-custom','admin/structure/token-custom','Custom tokens','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:27:\"Administrate custom tokens.\";}}','system',0,0,1,0,0,3,0,1,20,676,0,0,0,0,0,0,0),('management',677,158,'admin/help/token_custom','admin/help/token_custom','token_custom','a:0:{}','system',-1,0,0,0,0,3,0,1,158,677,0,0,0,0,0,0,0),('management',678,676,'admin/structure/token-custom/add','admin/structure/token-custom/add','Add token','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:20:\"Create custom tokens\";}}','system',-1,0,0,0,1,4,0,1,20,676,678,0,0,0,0,0,0),('management',679,676,'admin/structure/token-custom/type','admin/structure/token-custom/type','Custom token types','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:23:\"View custom token types\";}}','system',-1,0,1,0,2,4,0,1,20,676,679,0,0,0,0,0,0),('management',680,676,'admin/structure/token-custom/list','admin/structure/token-custom/list','Custom tokens','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:22:\"List of custom tokens.\";}}','system',-1,0,0,0,0,4,0,1,20,676,680,0,0,0,0,0,0),('management',681,679,'admin/structure/token-custom/type/add','admin/structure/token-custom/type/add','Add token type','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:25:\"Create custom token types\";}}','system',-1,0,0,0,2,5,0,1,20,676,679,681,0,0,0,0,0),('management',682,676,'admin/structure/token-custom/%/delete','admin/structure/token-custom/%/delete','Delete custom token','a:0:{}','system',0,0,0,0,0,4,0,1,20,676,682,0,0,0,0,0,0),('management',683,679,'admin/structure/token-custom/type/%/delete','admin/structure/token-custom/type/%/delete','Delete custom token','a:0:{}','system',0,0,0,0,0,5,0,1,20,676,679,683,0,0,0,0,0),('management',684,158,'admin/help/ckeditor','admin/help/ckeditor','ckeditor','a:0:{}','system',-1,0,0,0,0,3,0,1,158,684,0,0,0,0,0,0,0),('management',685,33,'admin/config/content/ckeditor','admin/config/content/ckeditor','CKEditor','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:31:\"Configure the rich text editor.\";}}','system',0,0,0,0,0,4,0,1,8,33,685,0,0,0,0,0,0),('navigation',686,598,'node/%/webform/conditionals','node/%/webform/conditionals','Conditionals','a:0:{}','system',-1,0,0,0,1,3,0,5,598,686,0,0,0,0,0,0,0),('management',687,71,'admin/config/regional/date-time/date-views','admin/config/regional/date-time/date-views','Date views','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:34:\"Configure settings for date views.\";}}','system',-1,0,0,0,0,5,0,1,8,49,71,687,0,0,0,0,0),('navigation',688,601,'node/%/webform-results/analysis/%','node/%/webform-results/analysis/%','Analysis','a:0:{}','system',-1,0,0,0,0,4,0,5,596,601,688,0,0,0,0,0,0),('navigation',689,688,'node/%/webform-results/analysis/%/more','node/%/webform-results/analysis/%/more','In-depth analysis','a:0:{}','system',-1,0,0,0,0,5,0,5,596,601,688,689,0,0,0,0,0),('management',690,58,'admin/config/user-interface/chosen','admin/config/user-interface/chosen','Chosen','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:31:\"Configuration for Chosen plugin\";}}','system',0,0,0,0,0,4,0,1,8,58,690,0,0,0,0,0,0),('navigation',894,612,'node/%/webform/emails/%/clone','node/%/webform/emails/%/clone','','a:0:{}','system',-1,0,0,0,0,5,0,5,598,604,612,894,0,0,0,0,0),('management',898,52,'admin/appearance/settings/plus','admin/appearance/settings/plus','Plus','a:0:{}','system',-1,0,0,0,0,4,0,1,7,52,898,0,0,0,0,0,0),('management',899,28,'admin/structure/block/list/plus','admin/structure/block/list/plus','Plus','a:0:{}','system',-1,0,0,0,0,4,0,1,20,28,899,0,0,0,0,0,0),('management',900,899,'admin/structure/block/list/plus/add','admin/structure/block/list/plus/add','Add block','a:0:{}','system',-1,0,0,0,0,5,0,1,20,28,899,900,0,0,0,0,0),('management',901,44,'admin/config/media/vef','admin/config/media/vef','Video Embed Field','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:31:\"Video Embed Field configuration\";}}','system',0,0,1,0,0,4,0,1,8,44,901,0,0,0,0,0,0),('management',902,901,'admin/config/media/vef/settings','admin/config/media/vef/settings','Settings','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:33:\"Video Embed Field module settings\";}}','system',0,0,0,0,0,5,0,1,8,44,901,902,0,0,0,0,0),('management',903,901,'admin/config/media/vef/vef_video_styles','admin/config/media/vef/vef_video_styles','Video Embed Styles','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:44:\"Administer Video Embed Field\'s video styles.\";}}','system',0,0,0,0,0,5,0,1,8,44,901,903,0,0,0,0,0),('management',904,903,'admin/config/media/vef/vef_video_styles/add','admin/config/media/vef/vef_video_styles/add','Add','a:0:{}','system',-1,0,0,0,0,6,0,1,8,44,901,903,904,0,0,0,0),('management',905,903,'admin/config/media/vef/vef_video_styles/import','admin/config/media/vef/vef_video_styles/import','Import','a:0:{}','system',-1,0,0,0,0,6,0,1,8,44,901,903,905,0,0,0,0),('management',906,903,'admin/config/media/vef/vef_video_styles/list','admin/config/media/vef/vef_video_styles/list','List','a:0:{}','system',-1,0,0,0,-10,6,0,1,8,44,901,903,906,0,0,0,0),('management',907,906,'admin/config/media/vef/vef_video_styles/list/%/edit','admin/config/media/vef/vef_video_styles/list/%/edit','Edit','a:0:{}','system',-1,0,0,0,-10,7,0,1,8,44,901,903,906,907,0,0,0),('management',908,906,'admin/config/media/vef/vef_video_styles/list/%/export','admin/config/media/vef/vef_video_styles/list/%/export','Export','a:0:{}','system',-1,0,0,0,0,7,0,1,8,44,901,903,906,908,0,0,0),('management',909,20,'admin/structure/migrate_content','admin/structure/migrate_content','Migrate Content','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:23:\"Manage Migrate Content.\";}}','system',0,0,0,0,0,3,0,1,20,909,0,0,0,0,0,0,0),('management',910,909,'admin/structure/migrate_content/create','admin/structure/migrate_content/create','Create','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:23:\"Migrate Content Create.\";}}','system',-1,0,0,0,10,4,0,1,20,909,910,0,0,0,0,0,0),('management',911,909,'admin/structure/migrate_content/import-from-upload','admin/structure/migrate_content/import-from-upload','Import','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:26:\"Upload zip file to import.\";}}','system',-1,0,0,0,11,4,0,1,20,909,911,0,0,0,0,0,0),('management',912,909,'admin/structure/migrate_content/manage','admin/structure/migrate_content/manage','Manage','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:33:\"Enable and disable entity bundle.\";}}','system',-1,0,0,0,0,4,0,1,20,909,912,0,0,0,0,0,0),('management',913,909,'admin/structure/migrate_content/settings','admin/structure/migrate_content/settings','Settings','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:49:\"Adjust settings for using migrate content module.\";}}','system',-1,0,0,0,11,4,0,1,20,909,913,0,0,0,0,0,0),('management',914,52,'admin/appearance/settings/we_backend','admin/appearance/settings/we_backend','WeebPal Backend theme','a:0:{}','system',-1,0,0,0,0,4,0,1,7,52,914,0,0,0,0,0,0),('management',915,28,'admin/structure/block/list/we_backend','admin/structure/block/list/we_backend','WeebPal Backend theme','a:0:{}','system',-1,0,0,0,0,4,0,1,20,28,915,0,0,0,0,0,0),('management',916,915,'admin/structure/block/list/we_backend/add','admin/structure/block/list/we_backend/add','Add block','a:0:{}','system',-1,0,0,0,0,5,0,1,20,28,915,916,0,0,0,0,0),('navigation',917,4,'filter/tips/%','filter/tips/%','Compose tips','a:0:{}','system',0,0,0,0,0,2,0,4,917,0,0,0,0,0,0,0,0),('management',918,639,'admin/structure/field-collections/%','admin/structure/field-collections/%','Manage fields','a:0:{}','system',0,0,0,0,1,4,0,1,20,639,918,0,0,0,0,0,0),('management',919,918,'admin/structure/field-collections/%/display','admin/structure/field-collections/%/display','Manage display','a:0:{}','system',-1,0,0,0,2,5,0,1,20,639,918,919,0,0,0,0,0),('management',920,194,'admin/structure/taxonomy/%/display','admin/structure/taxonomy/%/display','Manage display','a:0:{}','system',-1,0,0,0,2,5,0,1,20,162,194,920,0,0,0,0,0),('management',921,63,'admin/config/people/accounts/display','admin/config/people/accounts/display','Manage display','a:0:{}','system',-1,0,0,0,2,5,0,1,8,46,63,921,0,0,0,0,0),('management',922,918,'admin/structure/field-collections/%/fields','admin/structure/field-collections/%/fields','Manage fields','a:0:{}','system',-1,0,1,0,1,5,0,1,20,639,918,922,0,0,0,0,0),('management',923,194,'admin/structure/taxonomy/%/fields','admin/structure/taxonomy/%/fields','Manage fields','a:0:{}','system',-1,0,1,0,1,5,0,1,20,162,194,923,0,0,0,0,0),('management',924,63,'admin/config/people/accounts/fields','admin/config/people/accounts/fields','Manage fields','a:0:{}','system',-1,0,1,0,1,5,0,1,8,46,63,924,0,0,0,0,0),('management',925,919,'admin/structure/field-collections/%/display/default','admin/structure/field-collections/%/display/default','Default','a:0:{}','system',-1,0,0,0,-10,6,0,1,20,639,918,919,925,0,0,0,0),('management',926,920,'admin/structure/taxonomy/%/display/default','admin/structure/taxonomy/%/display/default','Default','a:0:{}','system',-1,0,0,0,-10,6,0,1,20,162,194,920,926,0,0,0,0),('management',927,921,'admin/config/people/accounts/display/default','admin/config/people/accounts/display/default','Default','a:0:{}','system',-1,0,0,0,-10,6,0,1,8,46,63,921,927,0,0,0,0),('management',928,919,'admin/structure/field-collections/%/display/full','admin/structure/field-collections/%/display/full','Full content','a:0:{}','system',-1,0,0,0,0,6,0,1,20,639,918,919,928,0,0,0,0),('management',929,446,'admin/structure/messages/manage/%/display','admin/structure/messages/manage/%/display','Manage display','a:0:{}','system',-1,0,0,0,2,5,0,1,20,439,446,929,0,0,0,0,0),('management',930,104,'admin/structure/types/manage/%/display','admin/structure/types/manage/%/display','Manage display','a:0:{}','system',-1,0,0,0,2,5,0,1,20,34,104,930,0,0,0,0,0),('management',931,446,'admin/structure/messages/manage/%/fields','admin/structure/messages/manage/%/fields','Manage fields','a:0:{}','system',-1,0,1,0,1,5,0,1,20,439,446,931,0,0,0,0,0),('management',932,104,'admin/structure/types/manage/%/fields','admin/structure/types/manage/%/fields','Manage fields','a:0:{}','system',-1,0,1,0,1,5,0,1,20,34,104,932,0,0,0,0,0),('management',933,920,'admin/structure/taxonomy/%/display/full','admin/structure/taxonomy/%/display/full','Taxonomy term page','a:0:{}','system',-1,0,0,0,0,6,0,1,20,162,194,920,933,0,0,0,0),('management',934,919,'admin/structure/field-collections/%/display/token','admin/structure/field-collections/%/display/token','Tokens','a:0:{}','system',-1,0,0,0,1,6,0,1,20,639,918,919,934,0,0,0,0),('management',935,920,'admin/structure/taxonomy/%/display/token','admin/structure/taxonomy/%/display/token','Tokens','a:0:{}','system',-1,0,0,0,1,6,0,1,20,162,194,920,935,0,0,0,0),('management',936,921,'admin/config/people/accounts/display/token','admin/config/people/accounts/display/token','Tokens','a:0:{}','system',-1,0,0,0,1,6,0,1,8,46,63,921,936,0,0,0,0),('management',937,921,'admin/config/people/accounts/display/full','admin/config/people/accounts/display/full','User account','a:0:{}','system',-1,0,0,0,0,6,0,1,8,46,63,921,937,0,0,0,0),('management',938,923,'admin/structure/taxonomy/%/fields/%','admin/structure/taxonomy/%/fields/%','','a:0:{}','system',0,0,0,0,0,6,0,1,20,162,194,923,938,0,0,0,0),('management',939,922,'admin/structure/field-collections/%/fields/%','admin/structure/field-collections/%/fields/%','','a:0:{}','system',0,0,0,0,0,6,0,1,20,639,918,922,939,0,0,0,0),('management',940,924,'admin/config/people/accounts/fields/%','admin/config/people/accounts/fields/%','','a:0:{}','system',0,0,0,0,0,6,0,1,8,46,63,924,940,0,0,0,0),('management',941,929,'admin/structure/messages/manage/%/display/default','admin/structure/messages/manage/%/display/default','Default','a:0:{}','system',-1,0,0,0,-10,6,0,1,20,439,446,929,941,0,0,0,0),('management',942,930,'admin/structure/types/manage/%/display/default','admin/structure/types/manage/%/display/default','Default','a:0:{}','system',-1,0,0,0,-10,6,0,1,20,34,104,930,942,0,0,0,0),('management',943,929,'admin/structure/messages/manage/%/display/full','admin/structure/messages/manage/%/display/full','Full','a:0:{}','system',-1,0,0,0,0,6,0,1,20,439,446,929,943,0,0,0,0),('management',944,930,'admin/structure/types/manage/%/display/full','admin/structure/types/manage/%/display/full','Full content','a:0:{}','system',-1,0,0,0,0,6,0,1,20,34,104,930,944,0,0,0,0),('management',945,930,'admin/structure/types/manage/%/display/print','admin/structure/types/manage/%/display/print','Print','a:0:{}','system',-1,0,0,0,5,6,0,1,20,34,104,930,945,0,0,0,0),('management',946,930,'admin/structure/types/manage/%/display/rss','admin/structure/types/manage/%/display/rss','RSS','a:0:{}','system',-1,0,0,0,2,6,0,1,20,34,104,930,946,0,0,0,0),('management',947,930,'admin/structure/types/manage/%/display/search_index','admin/structure/types/manage/%/display/search_index','Search index','a:0:{}','system',-1,0,0,0,3,6,0,1,20,34,104,930,947,0,0,0,0),('management',948,930,'admin/structure/types/manage/%/display/search_result','admin/structure/types/manage/%/display/search_result','Search result highlighting input','a:0:{}','system',-1,0,0,0,4,6,0,1,20,34,104,930,948,0,0,0,0),('management',949,930,'admin/structure/types/manage/%/display/teaser','admin/structure/types/manage/%/display/teaser','Teaser','a:0:{}','system',-1,0,0,0,1,6,0,1,20,34,104,930,949,0,0,0,0),('management',950,929,'admin/structure/messages/manage/%/display/token','admin/structure/messages/manage/%/display/token','Tokens','a:0:{}','system',-1,0,0,0,1,6,0,1,20,439,446,929,950,0,0,0,0),('management',951,930,'admin/structure/types/manage/%/display/token','admin/structure/types/manage/%/display/token','Tokens','a:0:{}','system',-1,0,0,0,6,6,0,1,20,34,104,930,951,0,0,0,0),('management',952,939,'admin/structure/field-collections/%/fields/%/delete','admin/structure/field-collections/%/fields/%/delete','Delete','a:0:{}','system',-1,0,0,0,10,7,0,1,20,639,918,922,939,952,0,0,0),('management',953,939,'admin/structure/field-collections/%/fields/%/edit','admin/structure/field-collections/%/fields/%/edit','Edit','a:0:{}','system',-1,0,0,0,0,7,0,1,20,639,918,922,939,953,0,0,0),('management',954,939,'admin/structure/field-collections/%/fields/%/field-settings','admin/structure/field-collections/%/fields/%/field-settings','Field settings','a:0:{}','system',-1,0,0,0,0,7,0,1,20,639,918,922,939,954,0,0,0),('management',955,939,'admin/structure/field-collections/%/fields/%/widget-type','admin/structure/field-collections/%/fields/%/widget-type','Widget type','a:0:{}','system',-1,0,0,0,0,7,0,1,20,639,918,922,939,955,0,0,0),('management',956,931,'admin/structure/messages/manage/%/fields/%','admin/structure/messages/manage/%/fields/%','','a:0:{}','system',0,0,0,0,0,6,0,1,20,439,446,931,956,0,0,0,0),('management',957,932,'admin/structure/types/manage/%/fields/%','admin/structure/types/manage/%/fields/%','','a:0:{}','system',0,0,0,0,0,6,0,1,20,34,104,932,957,0,0,0,0),('management',958,938,'admin/structure/taxonomy/%/fields/%/delete','admin/structure/taxonomy/%/fields/%/delete','Delete','a:0:{}','system',-1,0,0,0,10,7,0,1,20,162,194,923,938,958,0,0,0),('management',959,938,'admin/structure/taxonomy/%/fields/%/edit','admin/structure/taxonomy/%/fields/%/edit','Edit','a:0:{}','system',-1,0,0,0,0,7,0,1,20,162,194,923,938,959,0,0,0),('management',960,938,'admin/structure/taxonomy/%/fields/%/field-settings','admin/structure/taxonomy/%/fields/%/field-settings','Field settings','a:0:{}','system',-1,0,0,0,0,7,0,1,20,162,194,923,938,960,0,0,0),('management',961,938,'admin/structure/taxonomy/%/fields/%/widget-type','admin/structure/taxonomy/%/fields/%/widget-type','Widget type','a:0:{}','system',-1,0,0,0,0,7,0,1,20,162,194,923,938,961,0,0,0),('management',962,940,'admin/config/people/accounts/fields/%/delete','admin/config/people/accounts/fields/%/delete','Delete','a:0:{}','system',-1,0,0,0,10,7,0,1,8,46,63,924,940,962,0,0,0),('management',963,940,'admin/config/people/accounts/fields/%/edit','admin/config/people/accounts/fields/%/edit','Edit','a:0:{}','system',-1,0,0,0,0,7,0,1,8,46,63,924,940,963,0,0,0),('management',964,940,'admin/config/people/accounts/fields/%/field-settings','admin/config/people/accounts/fields/%/field-settings','Field settings','a:0:{}','system',-1,0,0,0,0,7,0,1,8,46,63,924,940,964,0,0,0),('management',965,940,'admin/config/people/accounts/fields/%/widget-type','admin/config/people/accounts/fields/%/widget-type','Widget type','a:0:{}','system',-1,0,0,0,0,7,0,1,8,46,63,924,940,965,0,0,0),('management',966,141,'admin/structure/types/manage/%/comment/display/default','admin/structure/types/manage/%/comment/display/default','Default','a:0:{}','system',-1,0,0,0,-10,6,0,1,20,34,104,141,966,0,0,0,0),('management',967,141,'admin/structure/types/manage/%/comment/display/full','admin/structure/types/manage/%/comment/display/full','Full comment','a:0:{}','system',-1,0,0,0,0,6,0,1,20,34,104,141,967,0,0,0,0),('management',968,141,'admin/structure/types/manage/%/comment/display/token','admin/structure/types/manage/%/comment/display/token','Tokens','a:0:{}','system',-1,0,0,0,1,6,0,1,20,34,104,141,968,0,0,0,0),('management',969,142,'admin/structure/types/manage/%/comment/fields/%','admin/structure/types/manage/%/comment/fields/%','','a:0:{}','system',0,0,0,0,0,6,0,1,20,34,104,142,969,0,0,0,0),('management',970,956,'admin/structure/messages/manage/%/fields/%/delete','admin/structure/messages/manage/%/fields/%/delete','Delete','a:0:{}','system',-1,0,0,0,10,7,0,1,20,439,446,931,956,970,0,0,0),('management',971,957,'admin/structure/types/manage/%/fields/%/delete','admin/structure/types/manage/%/fields/%/delete','Delete','a:0:{}','system',-1,0,0,0,10,7,0,1,20,34,104,932,957,971,0,0,0),('management',972,957,'admin/structure/types/manage/%/fields/%/edit','admin/structure/types/manage/%/fields/%/edit','Edit','a:0:{}','system',-1,0,0,0,0,7,0,1,20,34,104,932,957,972,0,0,0),('management',973,956,'admin/structure/messages/manage/%/fields/%/edit','admin/structure/messages/manage/%/fields/%/edit','Edit','a:0:{}','system',-1,0,0,0,0,7,0,1,20,439,446,931,956,973,0,0,0),('management',974,956,'admin/structure/messages/manage/%/fields/%/field-settings','admin/structure/messages/manage/%/fields/%/field-settings','Field settings','a:0:{}','system',-1,0,0,0,0,7,0,1,20,439,446,931,956,974,0,0,0),('management',975,956,'admin/structure/messages/manage/%/fields/%/widget-type','admin/structure/messages/manage/%/fields/%/widget-type','Widget type','a:0:{}','system',-1,0,0,0,0,7,0,1,20,439,446,931,956,975,0,0,0),('management',976,957,'admin/structure/types/manage/%/fields/%/field-settings','admin/structure/types/manage/%/fields/%/field-settings','Field settings','a:0:{}','system',-1,0,0,0,0,7,0,1,20,34,104,932,957,976,0,0,0),('management',977,957,'admin/structure/types/manage/%/fields/%/widget-type','admin/structure/types/manage/%/fields/%/widget-type','Widget type','a:0:{}','system',-1,0,0,0,0,7,0,1,20,34,104,932,957,977,0,0,0),('management',978,969,'admin/structure/types/manage/%/comment/fields/%/delete','admin/structure/types/manage/%/comment/fields/%/delete','Delete','a:0:{}','system',-1,0,0,0,10,7,0,1,20,34,104,142,969,978,0,0,0),('management',979,969,'admin/structure/types/manage/%/comment/fields/%/edit','admin/structure/types/manage/%/comment/fields/%/edit','Edit','a:0:{}','system',-1,0,0,0,0,7,0,1,20,34,104,142,969,979,0,0,0),('management',980,969,'admin/structure/types/manage/%/comment/fields/%/field-settings','admin/structure/types/manage/%/comment/fields/%/field-settings','Field settings','a:0:{}','system',-1,0,0,0,0,7,0,1,20,34,104,142,969,980,0,0,0),('management',981,969,'admin/structure/types/manage/%/comment/fields/%/widget-type','admin/structure/types/manage/%/comment/fields/%/widget-type','Widget type','a:0:{}','system',-1,0,0,0,0,7,0,1,20,34,104,142,969,981,0,0,0);
/*!40000 ALTER TABLE `menu_links` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `menu_router`
--

DROP TABLE IF EXISTS `menu_router`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `menu_router` (
  `path` varchar(255) NOT NULL DEFAULT '' COMMENT 'Primary Key: the Drupal path this entry describes',
  `load_functions` blob NOT NULL COMMENT 'A serialized array of function names (like node_load) to be called to load an object corresponding to a part of the current path.',
  `to_arg_functions` blob NOT NULL COMMENT 'A serialized array of function names (like user_uid_optional_to_arg) to be called to replace a part of the router path with another string.',
  `access_callback` varchar(255) NOT NULL DEFAULT '' COMMENT 'The callback which determines the access to this router path. Defaults to user_access.',
  `access_arguments` blob COMMENT 'A serialized array of arguments for the access callback.',
  `page_callback` varchar(255) NOT NULL DEFAULT '' COMMENT 'The name of the function that renders the page.',
  `page_arguments` blob COMMENT 'A serialized array of arguments for the page callback.',
  `delivery_callback` varchar(255) NOT NULL DEFAULT '' COMMENT 'The name of the function that sends the result of the page_callback function to the browser.',
  `fit` int(11) NOT NULL DEFAULT '0' COMMENT 'A numeric representation of how specific the path is.',
  `number_parts` smallint(6) NOT NULL DEFAULT '0' COMMENT 'Number of parts in this router path.',
  `context` int(11) NOT NULL DEFAULT '0' COMMENT 'Only for local tasks (tabs) - the context of a local task to control its placement.',
  `tab_parent` varchar(255) NOT NULL DEFAULT '' COMMENT 'Only for local tasks (tabs) - the router path of the parent page (which may also be a local task).',
  `tab_root` varchar(255) NOT NULL DEFAULT '' COMMENT 'Router path of the closest non-tab parent page. For pages that are not local tasks, this will be the same as the path.',
  `title` varchar(255) NOT NULL DEFAULT '' COMMENT 'The title for the current page, or the title for the tab if this is a local task.',
  `title_callback` varchar(255) NOT NULL DEFAULT '' COMMENT 'A function which will alter the title. Defaults to t()',
  `title_arguments` varchar(255) NOT NULL DEFAULT '' COMMENT 'A serialized array of arguments for the title callback. If empty, the title will be used as the sole argument for the title callback.',
  `theme_callback` varchar(255) NOT NULL DEFAULT '' COMMENT 'A function which returns the name of the theme that will be used to render this page. If left empty, the default theme will be used.',
  `theme_arguments` varchar(255) NOT NULL DEFAULT '' COMMENT 'A serialized array of arguments for the theme callback.',
  `type` int(11) NOT NULL DEFAULT '0' COMMENT 'Numeric representation of the type of the menu item, like MENU_LOCAL_TASK.',
  `description` text NOT NULL COMMENT 'A description of this item.',
  `position` varchar(255) NOT NULL DEFAULT '' COMMENT 'The position of the block (left or right) on the system administration page for this item.',
  `weight` int(11) NOT NULL DEFAULT '0' COMMENT 'Weight of the element. Lighter weights are higher up, heavier weights go down.',
  `include_file` mediumtext COMMENT 'The file to include for this element, usually the page callback function lives in this file.',
  PRIMARY KEY (`path`),
  KEY `fit` (`fit`),
  KEY `tab_parent` (`tab_parent`(64),`weight`,`title`),
  KEY `tab_root_weight_title` (`tab_root`(64),`weight`,`title`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Maps paths to various callbacks (access, page and title)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `menu_router`
--

LOCK TABLES `menu_router` WRITE;
/*!40000 ALTER TABLE `menu_router` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `menu_router` VALUES ('activity-stream','','','views_access','a:1:{i:0;b:1;}','views_page','a:2:{i:0;s:15:\"activity_stream\";i:1;s:4:\"page\";}','',1,1,0,'','activity-stream','What\'s New','t','','','a:0:{}',6,'','',0,''),('admin','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','system_admin_menu_block_page','a:0:{}','',1,1,0,'','admin','Administration','t','','','a:0:{}',6,'','',9,'modules/system/system.admin.inc'),('admin/appearance','','','user_access','a:1:{i:0;s:17:\"administer themes\";}','system_themes_page','a:0:{}','',3,2,0,'','admin/appearance','Appearance','t','','','a:0:{}',6,'Select and configure your themes.','left',-6,'modules/system/system.admin.inc'),('admin/appearance/default','','','user_access','a:1:{i:0;s:17:\"administer themes\";}','system_theme_default','a:0:{}','',7,3,0,'','admin/appearance/default','Set default theme','t','','','a:0:{}',0,'','',0,'modules/system/system.admin.inc'),('admin/appearance/disable','','','user_access','a:1:{i:0;s:17:\"administer themes\";}','system_theme_disable','a:0:{}','',7,3,0,'','admin/appearance/disable','Disable theme','t','','','a:0:{}',0,'','',0,'modules/system/system.admin.inc'),('admin/appearance/enable','','','user_access','a:1:{i:0;s:17:\"administer themes\";}','system_theme_enable','a:0:{}','',7,3,0,'','admin/appearance/enable','Enable theme','t','','','a:0:{}',0,'','',0,'modules/system/system.admin.inc'),('admin/appearance/install','','','update_manager_access','a:0:{}','drupal_get_form','a:2:{i:0;s:27:\"update_manager_install_form\";i:1;s:5:\"theme\";}','',7,3,1,'admin/appearance','admin/appearance','Install new theme','t','','','a:0:{}',388,'','',25,'modules/update/update.manager.inc'),('admin/appearance/list','','','user_access','a:1:{i:0;s:17:\"administer themes\";}','system_themes_page','a:0:{}','',7,3,1,'admin/appearance','admin/appearance','List','t','','','a:0:{}',140,'Select and configure your theme','',-1,'modules/system/system.admin.inc'),('admin/appearance/settings','','','user_access','a:1:{i:0;s:17:\"administer themes\";}','drupal_get_form','a:1:{i:0;s:21:\"system_theme_settings\";}','',7,3,1,'admin/appearance','admin/appearance','Settings','t','','','a:0:{}',132,'Configure default and theme specific settings.','',20,'modules/system/system.admin.inc'),('admin/appearance/settings/bartik','','','_system_themes_access','a:1:{i:0;O:8:\"stdClass\":12:{s:8:\"filename\";s:25:\"themes/bartik/bartik.info\";s:4:\"name\";s:6:\"bartik\";s:4:\"type\";s:5:\"theme\";s:5:\"owner\";s:45:\"themes/engines/phptemplate/phptemplate.engine\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:2:\"-1\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:19:{s:4:\"name\";s:6:\"Bartik\";s:11:\"description\";s:48:\"A flexible, recolorable theme with many regions.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:11:\"stylesheets\";a:2:{s:3:\"all\";a:3:{s:14:\"css/layout.css\";s:28:\"themes/bartik/css/layout.css\";s:13:\"css/style.css\";s:27:\"themes/bartik/css/style.css\";s:14:\"css/colors.css\";s:28:\"themes/bartik/css/colors.css\";}s:5:\"print\";a:1:{s:13:\"css/print.css\";s:27:\"themes/bartik/css/print.css\";}}s:7:\"regions\";a:20:{s:6:\"header\";s:6:\"Header\";s:4:\"help\";s:4:\"Help\";s:8:\"page_top\";s:8:\"Page top\";s:11:\"page_bottom\";s:11:\"Page bottom\";s:11:\"highlighted\";s:11:\"Highlighted\";s:8:\"featured\";s:8:\"Featured\";s:7:\"content\";s:7:\"Content\";s:13:\"sidebar_first\";s:13:\"Sidebar first\";s:14:\"sidebar_second\";s:14:\"Sidebar second\";s:14:\"triptych_first\";s:14:\"Triptych first\";s:15:\"triptych_middle\";s:15:\"Triptych middle\";s:13:\"triptych_last\";s:13:\"Triptych last\";s:18:\"footer_firstcolumn\";s:19:\"Footer first column\";s:19:\"footer_secondcolumn\";s:20:\"Footer second column\";s:18:\"footer_thirdcolumn\";s:19:\"Footer third column\";s:19:\"footer_fourthcolumn\";s:20:\"Footer fourth column\";s:6:\"footer\";s:6:\"Footer\";s:14:\"dashboard_main\";s:16:\"Dashboard (main)\";s:17:\"dashboard_sidebar\";s:19:\"Dashboard (sidebar)\";s:18:\"dashboard_inactive\";s:20:\"Dashboard (inactive)\";}s:8:\"settings\";a:1:{s:20:\"shortcut_module_link\";s:1:\"0\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:6:\"engine\";s:11:\"phptemplate\";s:8:\"features\";a:9:{i:0;s:4:\"logo\";i:1;s:7:\"favicon\";i:2;s:4:\"name\";i:3;s:6:\"slogan\";i:4;s:17:\"node_user_picture\";i:5;s:20:\"comment_user_picture\";i:6;s:25:\"comment_user_verification\";i:7;s:9:\"main_menu\";i:8;s:14:\"secondary_menu\";}s:10:\"screenshot\";s:28:\"themes/bartik/screenshot.png\";s:3:\"php\";s:5:\"5.2.4\";s:7:\"scripts\";a:0:{}s:5:\"mtime\";i:1498069849;s:15:\"overlay_regions\";a:5:{i:0;s:14:\"dashboard_main\";i:1;s:17:\"dashboard_sidebar\";i:2;s:18:\"dashboard_inactive\";i:3;s:7:\"content\";i:4;s:4:\"help\";}s:14:\"regions_hidden\";a:2:{i:0;s:8:\"page_top\";i:1;s:11:\"page_bottom\";}s:28:\"overlay_supplemental_regions\";a:1:{i:0;s:11:\"page_bottom\";}}s:6:\"prefix\";s:11:\"phptemplate\";s:11:\"stylesheets\";a:2:{s:3:\"all\";a:3:{s:14:\"css/layout.css\";s:28:\"themes/bartik/css/layout.css\";s:13:\"css/style.css\";s:27:\"themes/bartik/css/style.css\";s:14:\"css/colors.css\";s:28:\"themes/bartik/css/colors.css\";}s:5:\"print\";a:1:{s:13:\"css/print.css\";s:27:\"themes/bartik/css/print.css\";}}s:6:\"engine\";s:11:\"phptemplate\";}}','drupal_get_form','a:2:{i:0;s:21:\"system_theme_settings\";i:1;s:6:\"bartik\";}','',15,4,1,'admin/appearance/settings','admin/appearance','Bartik','t','','','a:0:{}',132,'','',0,'modules/system/system.admin.inc'),('admin/appearance/settings/forum_plus','','','_system_themes_access','a:1:{i:0;O:8:\"stdClass\":13:{s:8:\"filename\";s:43:\"sites/all/themes/forum_plus/forum_plus.info\";s:4:\"name\";s:10:\"forum_plus\";s:4:\"type\";s:5:\"theme\";s:5:\"owner\";s:45:\"themes/engines/phptemplate/phptemplate.engine\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:2:\"-1\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:20:{s:4:\"name\";s:10:\"Forum Plus\";s:11:\"description\";s:23:\"Theme for the Companies\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:6:\"engine\";s:11:\"phptemplate\";s:11:\"stylesheets\";a:1:{s:3:\"all\";a:3:{s:34:\"vendor/bootstrap/css/bootstrap.css\";s:62:\"sites/all/themes/forum_plus/vendor/bootstrap/css/bootstrap.css\";s:40:\"vendor/bootstrap/css/bootstrap-theme.css\";s:68:\"sites/all/themes/forum_plus/vendor/bootstrap/css/bootstrap-theme.css\";s:14:\"css/styles.css\";s:42:\"sites/all/themes/forum_plus/css/styles.css\";}}s:7:\"scripts\";a:8:{s:32:\"vendor/bootstrap/js/bootstrap.js\";s:60:\"sites/all/themes/forum_plus/vendor/bootstrap/js/bootstrap.js\";s:26:\"js/jquery.smooth-scroll.js\";s:54:\"sites/all/themes/forum_plus/js/jquery.smooth-scroll.js\";s:19:\"js/jquery.cookie.js\";s:47:\"sites/all/themes/forum_plus/js/jquery.cookie.js\";s:24:\"js/jquery.matchHeight.js\";s:52:\"sites/all/themes/forum_plus/js/jquery.matchHeight.js\";s:12:\"js/moment.js\";s:40:\"sites/all/themes/forum_plus/js/moment.js\";s:20:\"js/accordion_menu.js\";s:48:\"sites/all/themes/forum_plus/js/accordion_menu.js\";s:13:\"js/weebpal.js\";s:41:\"sites/all/themes/forum_plus/js/weebpal.js\";s:16:\"js/forum_plus.js\";s:44:\"sites/all/themes/forum_plus/js/forum_plus.js\";}s:8:\"features\";a:7:{i:0;s:4:\"logo\";i:1;s:4:\"name\";i:2;s:6:\"slogan\";i:3;s:17:\"node_user_picture\";i:4;s:20:\"comment_user_picture\";i:5;s:25:\"comment_user_verification\";i:6;s:7:\"favicon\";}s:7:\"regions\";a:25:{s:8:\"headline\";s:8:\"Headline\";s:6:\"header\";s:6:\"Header\";s:9:\"main_menu\";s:9:\"Main Menu\";s:9:\"slideshow\";s:9:\"Slideshow\";s:4:\"help\";s:4:\"Help\";s:8:\"page_top\";s:8:\"Page top\";s:11:\"page_bottom\";s:11:\"Page bottom\";s:11:\"highlighted\";s:11:\"Highlighted\";s:8:\"featured\";s:8:\"Featured\";s:7:\"content\";s:7:\"Content\";s:13:\"sidebar_first\";s:13:\"Sidebar first\";s:14:\"sidebar_second\";s:14:\"Sidebar second\";s:7:\"welcome\";s:7:\"Welcome\";s:11:\"panel_first\";s:11:\"Panel First\";s:12:\"panel_second\";s:12:\"Panel Second\";s:11:\"panel_third\";s:11:\"Panel Third\";s:4:\"gmap\";s:4:\"GMap\";s:14:\"panel_footer_1\";s:14:\"Panel Footer 1\";s:14:\"panel_footer_2\";s:14:\"Panel Footer 2\";s:14:\"panel_footer_3\";s:14:\"Panel Footer 3\";s:14:\"panel_footer_4\";s:14:\"Panel Footer 4\";s:6:\"footer\";s:6:\"Footer\";s:14:\"dashboard_main\";s:16:\"Dashboard (main)\";s:17:\"dashboard_sidebar\";s:19:\"Dashboard (sidebar)\";s:18:\"dashboard_inactive\";s:20:\"Dashboard (inactive)\";}s:8:\"settings\";a:7:{s:19:\"sidebar_first_width\";s:1:\"3\";s:20:\"sidebar_second_width\";s:1:\"3\";s:20:\"panel_footer_1_width\";s:1:\"3\";s:20:\"panel_footer_2_width\";s:1:\"3\";s:20:\"panel_footer_3_width\";s:1:\"3\";s:20:\"panel_footer_4_width\";s:1:\"3\";s:20:\"layout_width_default\";s:4:\"1200\";}s:5:\"skins\";a:3:{s:3:\"red\";s:3:\"Red\";s:6:\"yellow\";s:6:\"Yellow\";s:5:\"green\";s:5:\"Green\";}s:7:\"plugins\";a:1:{s:14:\"advanced_forum\";a:1:{s:6:\"styles\";s:23:\"css/advanced_forum/plus\";}}s:11:\"backgrounds\";a:7:{s:4:\"bg-1\";s:12:\"Background 1\";s:4:\"bg-2\";s:12:\"Background 2\";s:4:\"bg-3\";s:12:\"Background 3\";s:4:\"bg-4\";s:12:\"Background 4\";s:4:\"bg-5\";s:12:\"Background 5\";s:4:\"bg-6\";s:12:\"Background 6\";s:4:\"bg-7\";s:12:\"Background 7\";}s:6:\"layout\";a:1:{s:12:\"layout-boxed\";s:12:\"Boxed Layout\";}s:10:\"screenshot\";s:42:\"sites/all/themes/forum_plus/screenshot.png\";s:3:\"php\";s:5:\"5.2.4\";s:5:\"mtime\";i:1499928385;s:15:\"overlay_regions\";a:5:{i:0;s:14:\"dashboard_main\";i:1;s:17:\"dashboard_sidebar\";i:2;s:18:\"dashboard_inactive\";i:3;s:7:\"content\";i:4;s:4:\"help\";}s:14:\"regions_hidden\";a:2:{i:0;s:8:\"page_top\";i:1;s:11:\"page_bottom\";}s:28:\"overlay_supplemental_regions\";a:1:{i:0;s:11:\"page_bottom\";}}s:6:\"prefix\";s:11:\"phptemplate\";s:11:\"stylesheets\";a:1:{s:3:\"all\";a:3:{s:34:\"vendor/bootstrap/css/bootstrap.css\";s:62:\"sites/all/themes/forum_plus/vendor/bootstrap/css/bootstrap.css\";s:40:\"vendor/bootstrap/css/bootstrap-theme.css\";s:68:\"sites/all/themes/forum_plus/vendor/bootstrap/css/bootstrap-theme.css\";s:14:\"css/styles.css\";s:42:\"sites/all/themes/forum_plus/css/styles.css\";}}s:7:\"scripts\";a:8:{s:32:\"vendor/bootstrap/js/bootstrap.js\";s:60:\"sites/all/themes/forum_plus/vendor/bootstrap/js/bootstrap.js\";s:26:\"js/jquery.smooth-scroll.js\";s:54:\"sites/all/themes/forum_plus/js/jquery.smooth-scroll.js\";s:19:\"js/jquery.cookie.js\";s:47:\"sites/all/themes/forum_plus/js/jquery.cookie.js\";s:24:\"js/jquery.matchHeight.js\";s:52:\"sites/all/themes/forum_plus/js/jquery.matchHeight.js\";s:12:\"js/moment.js\";s:40:\"sites/all/themes/forum_plus/js/moment.js\";s:20:\"js/accordion_menu.js\";s:48:\"sites/all/themes/forum_plus/js/accordion_menu.js\";s:13:\"js/weebpal.js\";s:41:\"sites/all/themes/forum_plus/js/weebpal.js\";s:16:\"js/forum_plus.js\";s:44:\"sites/all/themes/forum_plus/js/forum_plus.js\";}s:6:\"engine\";s:11:\"phptemplate\";}}','drupal_get_form','a:2:{i:0;s:21:\"system_theme_settings\";i:1;s:10:\"forum_plus\";}','',15,4,1,'admin/appearance/settings','admin/appearance','Forum Plus','t','','','a:0:{}',132,'','',0,'modules/system/system.admin.inc'),('admin/appearance/settings/garland','','','_system_themes_access','a:1:{i:0;O:8:\"stdClass\":12:{s:8:\"filename\";s:27:\"themes/garland/garland.info\";s:4:\"name\";s:7:\"garland\";s:4:\"type\";s:5:\"theme\";s:5:\"owner\";s:45:\"themes/engines/phptemplate/phptemplate.engine\";s:6:\"status\";s:1:\"0\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:2:\"-1\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:19:{s:4:\"name\";s:7:\"Garland\";s:11:\"description\";s:111:\"A multi-column theme which can be configured to modify colors and switch between fixed and fluid width layouts.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:11:\"stylesheets\";a:2:{s:3:\"all\";a:1:{s:9:\"style.css\";s:24:\"themes/garland/style.css\";}s:5:\"print\";a:1:{s:9:\"print.css\";s:24:\"themes/garland/print.css\";}}s:8:\"settings\";a:1:{s:13:\"garland_width\";s:5:\"fluid\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:6:\"engine\";s:11:\"phptemplate\";s:7:\"regions\";a:12:{s:13:\"sidebar_first\";s:12:\"Left sidebar\";s:14:\"sidebar_second\";s:13:\"Right sidebar\";s:7:\"content\";s:7:\"Content\";s:6:\"header\";s:6:\"Header\";s:6:\"footer\";s:6:\"Footer\";s:11:\"highlighted\";s:11:\"Highlighted\";s:4:\"help\";s:4:\"Help\";s:8:\"page_top\";s:8:\"Page top\";s:11:\"page_bottom\";s:11:\"Page bottom\";s:14:\"dashboard_main\";s:16:\"Dashboard (main)\";s:17:\"dashboard_sidebar\";s:19:\"Dashboard (sidebar)\";s:18:\"dashboard_inactive\";s:20:\"Dashboard (inactive)\";}s:8:\"features\";a:9:{i:0;s:4:\"logo\";i:1;s:7:\"favicon\";i:2;s:4:\"name\";i:3;s:6:\"slogan\";i:4;s:17:\"node_user_picture\";i:5;s:20:\"comment_user_picture\";i:6;s:25:\"comment_user_verification\";i:7;s:9:\"main_menu\";i:8;s:14:\"secondary_menu\";}s:10:\"screenshot\";s:29:\"themes/garland/screenshot.png\";s:3:\"php\";s:5:\"5.2.4\";s:7:\"scripts\";a:0:{}s:5:\"mtime\";i:1498069849;s:15:\"overlay_regions\";a:5:{i:0;s:14:\"dashboard_main\";i:1;s:17:\"dashboard_sidebar\";i:2;s:18:\"dashboard_inactive\";i:3;s:7:\"content\";i:4;s:4:\"help\";}s:14:\"regions_hidden\";a:2:{i:0;s:8:\"page_top\";i:1;s:11:\"page_bottom\";}s:28:\"overlay_supplemental_regions\";a:1:{i:0;s:11:\"page_bottom\";}}s:6:\"prefix\";s:11:\"phptemplate\";s:11:\"stylesheets\";a:2:{s:3:\"all\";a:1:{s:9:\"style.css\";s:24:\"themes/garland/style.css\";}s:5:\"print\";a:1:{s:9:\"print.css\";s:24:\"themes/garland/print.css\";}}s:6:\"engine\";s:11:\"phptemplate\";}}','drupal_get_form','a:2:{i:0;s:21:\"system_theme_settings\";i:1;s:7:\"garland\";}','',15,4,1,'admin/appearance/settings','admin/appearance','Garland','t','','','a:0:{}',132,'','',0,'modules/system/system.admin.inc'),('admin/appearance/settings/global','','','user_access','a:1:{i:0;s:17:\"administer themes\";}','drupal_get_form','a:1:{i:0;s:21:\"system_theme_settings\";}','',15,4,1,'admin/appearance/settings','admin/appearance','Global settings','t','','','a:0:{}',140,'','',-1,'modules/system/system.admin.inc'),('admin/appearance/settings/plus','','','_system_themes_access','a:1:{i:0;O:8:\"stdClass\":11:{s:8:\"filename\";s:61:\"sites/all/themes/forum_plus/css/advanced_forum/plus/plus.info\";s:4:\"name\";s:4:\"plus\";s:4:\"type\";s:5:\"theme\";s:5:\"owner\";s:45:\"themes/engines/phptemplate/phptemplate.engine\";s:6:\"status\";s:1:\"0\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:2:\"-1\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:18:{s:4:\"name\";s:4:\"Plus\";s:11:\"description\";s:43:\"Based on the Blue Lagoon colors of Garland.\";s:7:\"version\";s:7:\"7.x-2.3\";s:10:\"base style\";s:5:\"naked\";s:4:\"core\";s:3:\"7.x\";s:7:\"project\";s:14:\"advanced_forum\";s:9:\"datestamp\";s:10:\"1373223651\";s:6:\"engine\";s:11:\"phptemplate\";s:7:\"regions\";a:12:{s:13:\"sidebar_first\";s:12:\"Left sidebar\";s:14:\"sidebar_second\";s:13:\"Right sidebar\";s:7:\"content\";s:7:\"Content\";s:6:\"header\";s:6:\"Header\";s:6:\"footer\";s:6:\"Footer\";s:11:\"highlighted\";s:11:\"Highlighted\";s:4:\"help\";s:4:\"Help\";s:8:\"page_top\";s:8:\"Page top\";s:11:\"page_bottom\";s:11:\"Page bottom\";s:14:\"dashboard_main\";s:16:\"Dashboard (main)\";s:17:\"dashboard_sidebar\";s:19:\"Dashboard (sidebar)\";s:18:\"dashboard_inactive\";s:20:\"Dashboard (inactive)\";}s:8:\"features\";a:9:{i:0;s:4:\"logo\";i:1;s:7:\"favicon\";i:2;s:4:\"name\";i:3;s:6:\"slogan\";i:4;s:17:\"node_user_picture\";i:5;s:20:\"comment_user_picture\";i:6;s:25:\"comment_user_verification\";i:7;s:9:\"main_menu\";i:8;s:14:\"secondary_menu\";}s:10:\"screenshot\";s:66:\"sites/all/themes/forum_plus/css/advanced_forum/plus/screenshot.png\";s:3:\"php\";s:5:\"5.2.4\";s:11:\"stylesheets\";a:0:{}s:7:\"scripts\";a:0:{}s:5:\"mtime\";i:1499928385;s:15:\"overlay_regions\";a:5:{i:0;s:14:\"dashboard_main\";i:1;s:17:\"dashboard_sidebar\";i:2;s:18:\"dashboard_inactive\";i:3;s:7:\"content\";i:4;s:4:\"help\";}s:14:\"regions_hidden\";a:2:{i:0;s:8:\"page_top\";i:1;s:11:\"page_bottom\";}s:28:\"overlay_supplemental_regions\";a:1:{i:0;s:11:\"page_bottom\";}}s:6:\"prefix\";s:11:\"phptemplate\";s:6:\"engine\";s:11:\"phptemplate\";}}','drupal_get_form','a:2:{i:0;s:21:\"system_theme_settings\";i:1;s:4:\"plus\";}','',15,4,1,'admin/appearance/settings','admin/appearance','Plus','t','','','a:0:{}',132,'','',0,'modules/system/system.admin.inc'),('admin/appearance/settings/seven','','','_system_themes_access','a:1:{i:0;O:8:\"stdClass\":12:{s:8:\"filename\";s:23:\"themes/seven/seven.info\";s:4:\"name\";s:5:\"seven\";s:4:\"type\";s:5:\"theme\";s:5:\"owner\";s:45:\"themes/engines/phptemplate/phptemplate.engine\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:2:\"-1\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:19:{s:4:\"name\";s:5:\"Seven\";s:11:\"description\";s:65:\"A simple one-column, tableless, fluid width administration theme.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:11:\"stylesheets\";a:1:{s:6:\"screen\";a:2:{s:9:\"reset.css\";s:22:\"themes/seven/reset.css\";s:9:\"style.css\";s:22:\"themes/seven/style.css\";}}s:8:\"settings\";a:1:{s:20:\"shortcut_module_link\";s:1:\"1\";}s:7:\"regions\";a:8:{s:7:\"content\";s:7:\"Content\";s:4:\"help\";s:4:\"Help\";s:8:\"page_top\";s:8:\"Page top\";s:11:\"page_bottom\";s:11:\"Page bottom\";s:13:\"sidebar_first\";s:13:\"First sidebar\";s:14:\"dashboard_main\";s:16:\"Dashboard (main)\";s:17:\"dashboard_sidebar\";s:19:\"Dashboard (sidebar)\";s:18:\"dashboard_inactive\";s:20:\"Dashboard (inactive)\";}s:14:\"regions_hidden\";a:3:{i:0;s:13:\"sidebar_first\";i:1;s:8:\"page_top\";i:2;s:11:\"page_bottom\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:6:\"engine\";s:11:\"phptemplate\";s:8:\"features\";a:9:{i:0;s:4:\"logo\";i:1;s:7:\"favicon\";i:2;s:4:\"name\";i:3;s:6:\"slogan\";i:4;s:17:\"node_user_picture\";i:5;s:20:\"comment_user_picture\";i:6;s:25:\"comment_user_verification\";i:7;s:9:\"main_menu\";i:8;s:14:\"secondary_menu\";}s:10:\"screenshot\";s:27:\"themes/seven/screenshot.png\";s:3:\"php\";s:5:\"5.2.4\";s:7:\"scripts\";a:0:{}s:5:\"mtime\";i:1498069849;s:15:\"overlay_regions\";a:5:{i:0;s:14:\"dashboard_main\";i:1;s:17:\"dashboard_sidebar\";i:2;s:18:\"dashboard_inactive\";i:3;s:7:\"content\";i:4;s:4:\"help\";}s:28:\"overlay_supplemental_regions\";a:1:{i:0;s:11:\"page_bottom\";}}s:6:\"prefix\";s:11:\"phptemplate\";s:11:\"stylesheets\";a:1:{s:6:\"screen\";a:2:{s:9:\"reset.css\";s:22:\"themes/seven/reset.css\";s:9:\"style.css\";s:22:\"themes/seven/style.css\";}}s:6:\"engine\";s:11:\"phptemplate\";}}','drupal_get_form','a:2:{i:0;s:21:\"system_theme_settings\";i:1;s:5:\"seven\";}','',15,4,1,'admin/appearance/settings','admin/appearance','Seven','t','','','a:0:{}',132,'','',0,'modules/system/system.admin.inc'),('admin/appearance/settings/stark','','','_system_themes_access','a:1:{i:0;O:8:\"stdClass\":12:{s:8:\"filename\";s:23:\"themes/stark/stark.info\";s:4:\"name\";s:5:\"stark\";s:4:\"type\";s:5:\"theme\";s:5:\"owner\";s:45:\"themes/engines/phptemplate/phptemplate.engine\";s:6:\"status\";s:1:\"0\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:2:\"-1\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:18:{s:4:\"name\";s:5:\"Stark\";s:11:\"description\";s:208:\"This theme demonstrates Drupal\'s default HTML markup and CSS styles. To learn how to build your own theme and override Drupal\'s default code, see the <a href=\"http://drupal.org/theme-guide\">Theming Guide</a>.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:11:\"stylesheets\";a:1:{s:3:\"all\";a:1:{s:10:\"layout.css\";s:23:\"themes/stark/layout.css\";}}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:6:\"engine\";s:11:\"phptemplate\";s:7:\"regions\";a:12:{s:13:\"sidebar_first\";s:12:\"Left sidebar\";s:14:\"sidebar_second\";s:13:\"Right sidebar\";s:7:\"content\";s:7:\"Content\";s:6:\"header\";s:6:\"Header\";s:6:\"footer\";s:6:\"Footer\";s:11:\"highlighted\";s:11:\"Highlighted\";s:4:\"help\";s:4:\"Help\";s:8:\"page_top\";s:8:\"Page top\";s:11:\"page_bottom\";s:11:\"Page bottom\";s:14:\"dashboard_main\";s:16:\"Dashboard (main)\";s:17:\"dashboard_sidebar\";s:19:\"Dashboard (sidebar)\";s:18:\"dashboard_inactive\";s:20:\"Dashboard (inactive)\";}s:8:\"features\";a:9:{i:0;s:4:\"logo\";i:1;s:7:\"favicon\";i:2;s:4:\"name\";i:3;s:6:\"slogan\";i:4;s:17:\"node_user_picture\";i:5;s:20:\"comment_user_picture\";i:6;s:25:\"comment_user_verification\";i:7;s:9:\"main_menu\";i:8;s:14:\"secondary_menu\";}s:10:\"screenshot\";s:27:\"themes/stark/screenshot.png\";s:3:\"php\";s:5:\"5.2.4\";s:7:\"scripts\";a:0:{}s:5:\"mtime\";i:1498069849;s:15:\"overlay_regions\";a:5:{i:0;s:14:\"dashboard_main\";i:1;s:17:\"dashboard_sidebar\";i:2;s:18:\"dashboard_inactive\";i:3;s:7:\"content\";i:4;s:4:\"help\";}s:14:\"regions_hidden\";a:2:{i:0;s:8:\"page_top\";i:1;s:11:\"page_bottom\";}s:28:\"overlay_supplemental_regions\";a:1:{i:0;s:11:\"page_bottom\";}}s:6:\"prefix\";s:11:\"phptemplate\";s:11:\"stylesheets\";a:1:{s:3:\"all\";a:1:{s:10:\"layout.css\";s:23:\"themes/stark/layout.css\";}}s:6:\"engine\";s:11:\"phptemplate\";}}','drupal_get_form','a:2:{i:0;s:21:\"system_theme_settings\";i:1;s:5:\"stark\";}','',15,4,1,'admin/appearance/settings','admin/appearance','Stark','t','','','a:0:{}',132,'','',0,'modules/system/system.admin.inc'),('admin/appearance/settings/we_backend','','','_system_themes_access','a:1:{i:0;O:8:\"stdClass\":13:{s:8:\"filename\";s:43:\"sites/all/themes/we_backend/we_backend.info\";s:4:\"name\";s:10:\"we_backend\";s:4:\"type\";s:5:\"theme\";s:5:\"owner\";s:45:\"themes/engines/phptemplate/phptemplate.engine\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:2:\"-1\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:15:{s:4:\"name\";s:21:\"WeebPal Backend theme\";s:11:\"description\";s:26:\"Backend theme from WeebPal\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:6:\"engine\";s:11:\"phptemplate\";s:11:\"stylesheets\";a:1:{s:3:\"all\";a:1:{s:20:\"assets/css/style.css\";s:48:\"sites/all/themes/we_backend/assets/css/style.css\";}}s:7:\"scripts\";a:1:{s:20:\"assets/js/scripts.js\";s:48:\"sites/all/themes/we_backend/assets/js/scripts.js\";}s:8:\"features\";a:7:{i:0;s:4:\"logo\";i:1;s:4:\"name\";i:2;s:6:\"slogan\";i:3;s:17:\"node_user_picture\";i:4;s:20:\"comment_user_picture\";i:5;s:25:\"comment_user_verification\";i:6;s:7:\"favicon\";}s:7:\"regions\";a:10:{s:6:\"header\";s:6:\"Header\";s:11:\"highlighted\";s:11:\"Highlighted\";s:4:\"help\";s:4:\"Help\";s:7:\"content\";s:7:\"Content\";s:13:\"sidebar_first\";s:13:\"Sidebar first\";s:14:\"sidebar_second\";s:14:\"Sidebar second\";s:6:\"footer\";s:6:\"Footer\";s:14:\"dashboard_main\";s:16:\"Dashboard (main)\";s:17:\"dashboard_sidebar\";s:19:\"Dashboard (sidebar)\";s:18:\"dashboard_inactive\";s:20:\"Dashboard (inactive)\";}s:10:\"screenshot\";s:42:\"sites/all/themes/we_backend/screenshot.png\";s:3:\"php\";s:5:\"5.2.4\";s:5:\"mtime\";i:1499643480;s:15:\"overlay_regions\";a:5:{i:0;s:14:\"dashboard_main\";i:1;s:17:\"dashboard_sidebar\";i:2;s:18:\"dashboard_inactive\";i:3;s:7:\"content\";i:4;s:4:\"help\";}s:14:\"regions_hidden\";a:2:{i:0;s:8:\"page_top\";i:1;s:11:\"page_bottom\";}s:28:\"overlay_supplemental_regions\";a:1:{i:0;s:11:\"page_bottom\";}}s:6:\"prefix\";s:11:\"phptemplate\";s:11:\"stylesheets\";a:1:{s:3:\"all\";a:1:{s:20:\"assets/css/style.css\";s:48:\"sites/all/themes/we_backend/assets/css/style.css\";}}s:7:\"scripts\";a:1:{s:20:\"assets/js/scripts.js\";s:48:\"sites/all/themes/we_backend/assets/js/scripts.js\";}s:6:\"engine\";s:11:\"phptemplate\";}}','drupal_get_form','a:2:{i:0;s:21:\"system_theme_settings\";i:1;s:10:\"we_backend\";}','',15,4,1,'admin/appearance/settings','admin/appearance','WeebPal Backend theme','t','','','a:0:{}',132,'','',0,'modules/system/system.admin.inc'),('admin/appearance/update','','','update_manager_access','a:0:{}','drupal_get_form','a:2:{i:0;s:26:\"update_manager_update_form\";i:1;s:5:\"theme\";}','',7,3,1,'admin/appearance','admin/appearance','Update','t','','','a:0:{}',132,'','',10,'modules/update/update.manager.inc'),('admin/compact','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','system_admin_compact_page','a:0:{}','',3,2,0,'','admin/compact','Compact mode','t','','','a:0:{}',0,'','',0,'modules/system/system.admin.inc'),('admin/config','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','system_admin_config_page','a:0:{}','',3,2,0,'','admin/config','Configuration','t','','','a:0:{}',6,'Administer settings.','',0,'modules/system/system.admin.inc'),('admin/config/administration','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','system_admin_menu_block_page','a:0:{}','',7,3,0,'','admin/config/administration','Administration','t','','','a:0:{}',6,'Administration tools.','',0,'modules/system/system.admin.inc'),('admin/config/administration/admin_menu','','','user_access','a:1:{i:0;s:29:\"administer site configuration\";}','drupal_get_form','a:1:{i:0;s:25:\"admin_menu_theme_settings\";}','',15,4,0,'','admin/config/administration/admin_menu','Administration menu','t','','','a:0:{}',6,'Adjust administration menu settings.','',0,'sites/all/modules/admin_menu/admin_menu.inc'),('admin/config/content','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','system_admin_menu_block_page','a:0:{}','',7,3,0,'','admin/config/content','Content authoring','t','','','a:0:{}',6,'Settings related to formatting and authoring content.','left',-15,'modules/system/system.admin.inc'),('admin/config/content/advanced-forum','','','user_access','a:1:{i:0;s:25:\"administer advanced forum\";}','drupal_get_form','a:1:{i:0;s:28:\"advanced_forum_settings_page\";}','',15,4,0,'','admin/config/content/advanced-forum','Advanced Forum','t','','','a:0:{}',6,'Configure Advanced Forum with these settings.','',0,'sites/all/modules/advanced_forum/includes/settings.inc'),('admin/config/content/ckeditor','','','user_access','a:1:{i:0;s:19:\"administer ckeditor\";}','ckeditor_admin_main','a:0:{}','',15,4,0,'','admin/config/content/ckeditor','CKEditor','t','','','a:0:{}',6,'Configure the rich text editor.','',0,'sites/all/modules/ckeditor/includes/ckeditor.admin.inc'),('admin/config/content/ckeditor/add','','','user_access','a:1:{i:0;s:19:\"administer ckeditor\";}','drupal_get_form','a:2:{i:0;s:27:\"ckeditor_admin_profile_form\";i:1;s:3:\"add\";}','',31,5,0,'','admin/config/content/ckeditor/add','Add a new CKEditor profile','t','','','a:0:{}',0,'Configure the rich text editor.','',0,'sites/all/modules/ckeditor/includes/ckeditor.admin.inc'),('admin/config/content/ckeditor/addg','','','user_access','a:1:{i:0;s:19:\"administer ckeditor\";}','drupal_get_form','a:2:{i:0;s:34:\"ckeditor_admin_global_profile_form\";i:1;s:3:\"add\";}','',31,5,0,'','admin/config/content/ckeditor/addg','Add the CKEditor Global profile','t','','','a:0:{}',0,'Configure the rich text editor.','',0,'sites/all/modules/ckeditor/includes/ckeditor.admin.inc'),('admin/config/content/ckeditor/clone/%','a:1:{i:5;s:21:\"ckeditor_profile_load\";}','','user_access','a:1:{i:0;s:19:\"administer ckeditor\";}','drupal_get_form','a:3:{i:0;s:33:\"ckeditor_admin_profile_clone_form\";i:1;s:5:\"clone\";i:2;i:5;}','',62,6,0,'','admin/config/content/ckeditor/clone/%','Clone the CKEditor profile','t','','','a:0:{}',0,'Configure the rich text editor.','',0,'sites/all/modules/ckeditor/includes/ckeditor.admin.inc'),('admin/config/content/ckeditor/delete/%','a:1:{i:5;s:21:\"ckeditor_profile_load\";}','','user_access','a:1:{i:0;s:19:\"administer ckeditor\";}','drupal_get_form','a:2:{i:0;s:34:\"ckeditor_admin_profile_delete_form\";i:1;i:5;}','',62,6,0,'','admin/config/content/ckeditor/delete/%','Delete the CKEditor profile','t','','','a:0:{}',0,'Configure the rich text editor.','',0,'sites/all/modules/ckeditor/includes/ckeditor.admin.inc'),('admin/config/content/ckeditor/edit/%','a:1:{i:5;s:21:\"ckeditor_profile_load\";}','','user_access','a:1:{i:0;s:19:\"administer ckeditor\";}','drupal_get_form','a:3:{i:0;s:27:\"ckeditor_admin_profile_form\";i:1;s:4:\"edit\";i:2;i:5;}','',62,6,0,'','admin/config/content/ckeditor/edit/%','Edit the CKEditor profile','t','','','a:0:{}',0,'Configure the rich text editor.','',0,'sites/all/modules/ckeditor/includes/ckeditor.admin.inc'),('admin/config/content/ckeditor/editg','','','user_access','a:1:{i:0;s:19:\"administer ckeditor\";}','drupal_get_form','a:2:{i:0;s:34:\"ckeditor_admin_global_profile_form\";i:1;s:4:\"edit\";}','',31,5,0,'','admin/config/content/ckeditor/editg','Edit the CKEditor Global profile','t','','','a:0:{}',0,'Configure the rich text editor.','',0,'sites/all/modules/ckeditor/includes/ckeditor.admin.inc'),('admin/config/content/ckeditor/skinframe','','','user_access','a:1:{i:0;s:19:\"administer ckeditor\";}','ckeditor_skinframe','a:0:{}','',31,5,0,'','admin/config/content/ckeditor/skinframe','Change skin of CKEditor','t','','','a:0:{}',0,'Configure skin for CKEditor.','',0,'sites/all/modules/ckeditor/includes/ckeditor.admin.inc'),('admin/config/content/faq','','','user_access','a:1:{i:0;s:14:\"administer faq\";}','faq_settings_page','a:0:{}','',15,4,0,'','admin/config/content/faq','Frequently Asked Questions','t','','','a:0:{}',6,'Allows the user to configure the layout of questions and answers on a FAQ page.','',0,'sites/all/modules/faq/faq.admin.inc'),('admin/config/content/faq/categories','','','user_access','a:1:{i:0;s:14:\"administer faq\";}','drupal_get_form','a:1:{i:0;s:28:\"faq_categories_settings_form\";}','',31,5,1,'admin/config/content/faq','admin/config/content/faq','Categories','t','','','a:0:{}',132,'Allows the user to configure the layout of questions and answers using categories on a FAQ page.','',-8,'sites/all/modules/faq/faq.admin.inc'),('admin/config/content/faq/general','','','user_access','a:1:{i:0;s:14:\"administer faq\";}','drupal_get_form','a:1:{i:0;s:25:\"faq_general_settings_form\";}','',31,5,1,'admin/config/content/faq','admin/config/content/faq','General','t','','','a:0:{}',140,'Allows the user to configure the header and descriptive text for the FAQ page.','',-10,'sites/all/modules/faq/faq.admin.inc'),('admin/config/content/faq/questions','','','user_access','a:1:{i:0;s:14:\"administer faq\";}','drupal_get_form','a:1:{i:0;s:27:\"faq_questions_settings_form\";}','',31,5,1,'admin/config/content/faq','admin/config/content/faq','Questions','t','','','a:0:{}',132,'Allows the user to configure the layout of questions and answers on a FAQ page.','',-9,'sites/all/modules/faq/faq.admin.inc'),('admin/config/content/fivestar','','','user_access','a:1:{i:0;s:29:\"administer site configuration\";}','drupal_get_form','a:1:{i:0;s:17:\"fivestar_settings\";}','',15,4,0,'','admin/config/content/fivestar','Fivestar','t','','','a:0:{}',6,'Configure site-wide widgets used for Fivestar rating.','',0,'sites/all/modules/fivestar/includes/fivestar.admin.inc'),('admin/config/content/formats','','','user_access','a:1:{i:0;s:18:\"administer filters\";}','drupal_get_form','a:1:{i:0;s:21:\"filter_admin_overview\";}','',15,4,0,'','admin/config/content/formats','Text formats','t','','','a:0:{}',6,'Configure how content input by users is filtered, including allowed HTML tags. Also allows enabling of module-provided filters.','',0,'modules/filter/filter.admin.inc'),('admin/config/content/formats/%','a:1:{i:4;s:18:\"filter_format_load\";}','','user_access','a:1:{i:0;s:18:\"administer filters\";}','filter_admin_format_page','a:1:{i:0;i:4;}','',30,5,0,'','admin/config/content/formats/%','','filter_admin_format_title','a:1:{i:0;i:4;}','','a:0:{}',6,'','',0,'modules/filter/filter.admin.inc'),('admin/config/content/formats/%/disable','a:1:{i:4;s:18:\"filter_format_load\";}','','_filter_disable_format_access','a:1:{i:0;i:4;}','drupal_get_form','a:2:{i:0;s:20:\"filter_admin_disable\";i:1;i:4;}','',61,6,0,'','admin/config/content/formats/%/disable','Disable text format','t','','','a:0:{}',6,'','',0,'modules/filter/filter.admin.inc'),('admin/config/content/formats/add','','','user_access','a:1:{i:0;s:18:\"administer filters\";}','filter_admin_format_page','a:0:{}','',31,5,1,'admin/config/content/formats','admin/config/content/formats','Add text format','t','','','a:0:{}',388,'','',1,'modules/filter/filter.admin.inc'),('admin/config/content/formats/list','','','user_access','a:1:{i:0;s:18:\"administer filters\";}','drupal_get_form','a:1:{i:0;s:21:\"filter_admin_overview\";}','',31,5,1,'admin/config/content/formats','admin/config/content/formats','List','t','','','a:0:{}',140,'','',0,'modules/filter/filter.admin.inc'),('admin/config/content/tagclouds','','','user_access','a:1:{i:0;s:19:\"administer taxonomy\";}','drupal_get_form','a:1:{i:0;s:18:\"tagclouds_settings\";}','',15,4,0,'','admin/config/content/tagclouds','TagClouds configuration','t','','','a:0:{}',6,'Configure the tag clouds. Set the order, the number of tags, and the depth of the clouds.','',0,''),('admin/config/content/webform','','','user_access','a:1:{i:0;s:29:\"administer site configuration\";}','drupal_get_form','a:1:{i:0;s:22:\"webform_admin_settings\";}','',15,4,0,'','admin/config/content/webform','Webform settings','t','','','a:0:{}',6,'Global configuration of webform functionality.','',0,'sites/all/modules/webform/includes/webform.admin.inc'),('admin/config/content/webform-hints','','','user_access','a:1:{i:0;s:33:\"administer Webform Hints settings\";}','drupal_get_form','a:1:{i:0;s:28:\"webform_hints_admin_settings\";}','',15,4,0,'','admin/config/content/webform-hints','Webform Hints settings','t','','','a:0:{}',6,'Administer which of your Webforms will receive the hints effect.','',0,'sites/all/modules/webform_hints/webform_hints.admin.inc'),('admin/config/date','','','user_access','a:1:{i:0;s:29:\"administer site configuration\";}','system_admin_menu_block_page','a:0:{}','',7,3,0,'','admin/config/date','Date API','t','','','a:0:{}',6,'Settings for modules the use the Date API.','left',-10,'modules/system/system.admin.inc'),('admin/config/date/calendar','','','user_access','a:1:{i:0;s:29:\"administer site configuration\";}','drupal_get_form','a:1:{i:0;s:23:\"calendar_admin_settings\";}','',15,4,0,'','admin/config/date/calendar','Calendar','t','','','a:0:{}',6,'Calendar administration.','',0,''),('admin/config/development','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','system_admin_menu_block_page','a:0:{}','',7,3,0,'','admin/config/development','Development','t','','','a:0:{}',6,'Development tools.','right',-10,'modules/system/system.admin.inc'),('admin/config/development/jquery_update','','','user_access','a:1:{i:0;s:29:\"administer site configuration\";}','drupal_get_form','a:1:{i:0;s:27:\"jquery_update_settings_form\";}','',15,4,0,'','admin/config/development/jquery_update','jQuery update','t','','','a:0:{}',6,'Configure settings related to the jQuery upgrade, the library path and compression.','',0,''),('admin/config/development/logging','','','user_access','a:1:{i:0;s:29:\"administer site configuration\";}','drupal_get_form','a:1:{i:0;s:23:\"system_logging_settings\";}','',15,4,0,'','admin/config/development/logging','Logging and errors','t','','','a:0:{}',6,'Settings for logging and alerts modules. Various modules can route Drupal\'s system events to different destinations, such as syslog, database, email, etc.','',-15,'modules/system/system.admin.inc'),('admin/config/development/maintenance','','','user_access','a:1:{i:0;s:29:\"administer site configuration\";}','drupal_get_form','a:1:{i:0;s:28:\"system_site_maintenance_mode\";}','',15,4,0,'','admin/config/development/maintenance','Maintenance mode','t','','','a:0:{}',6,'Take the site offline for maintenance or bring it back online.','',-10,'modules/system/system.admin.inc'),('admin/config/development/modal_forms','','','user_access','a:1:{i:0;s:29:\"administer site configuration\";}','drupal_get_form','a:1:{i:0;s:26:\"modal_forms_admin_settings\";}','',15,4,0,'','admin/config/development/modal_forms','Modal forms','t','','','a:0:{}',6,'Adjust Modal forms settings.','',0,'sites/all/modules/modal_forms/modal_forms.admin.inc'),('admin/config/development/performance','','','user_access','a:1:{i:0;s:29:\"administer site configuration\";}','drupal_get_form','a:1:{i:0;s:27:\"system_performance_settings\";}','',15,4,0,'','admin/config/development/performance','Performance','t','','','a:0:{}',6,'Enable or disable page caching for anonymous users and set CSS and JS bandwidth optimization options.','',-20,'modules/system/system.admin.inc'),('admin/config/development/strongarm','','','user_access','a:1:{i:0;s:29:\"administer site configuration\";}','drupal_get_form','a:1:{i:0;s:20:\"strongarm_admin_form\";}','',15,4,0,'','admin/config/development/strongarm','Strongarm','t','','','a:0:{}',6,'Manage Drupal variable settings that have been strongarmed.','',0,'sites/all/modules/strongarm/strongarm.admin.inc'),('admin/config/media','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','system_admin_menu_block_page','a:0:{}','',7,3,0,'','admin/config/media','Media','t','','','a:0:{}',6,'Media tools.','left',-10,'modules/system/system.admin.inc'),('admin/config/media/file-system','','','user_access','a:1:{i:0;s:29:\"administer site configuration\";}','drupal_get_form','a:1:{i:0;s:27:\"system_file_system_settings\";}','',15,4,0,'','admin/config/media/file-system','File system','t','','','a:0:{}',6,'Tell Drupal where to store uploaded files and how they are accessed.','',-10,'modules/system/system.admin.inc'),('admin/config/media/flexslider','','','ctools_export_ui_task_access','a:2:{i:0;s:27:\"flexslider_ctools_export_ui\";i:1;s:4:\"list\";}','ctools_export_ui_switcher_page','a:2:{i:0;s:27:\"flexslider_ctools_export_ui\";i:1;s:4:\"list\";}','',15,4,0,'','admin/config/media/flexslider','FlexSlider','t','','','a:0:{}',6,'Administer FlexSlider presets.','',0,'sites/all/modules/ctools/includes/export-ui.inc'),('admin/config/media/flexslider/add','','','ctools_export_ui_task_access','a:2:{i:0;s:27:\"flexslider_ctools_export_ui\";i:1;s:3:\"add\";}','ctools_export_ui_switcher_page','a:2:{i:0;s:27:\"flexslider_ctools_export_ui\";i:1;s:3:\"add\";}','',31,5,1,'admin/config/media/flexslider','admin/config/media/flexslider','Add','t','','','a:0:{}',388,'','',0,'sites/all/modules/ctools/includes/export-ui.inc'),('admin/config/media/flexslider/advanced','','','user_access','a:1:{i:0;s:21:\"administer flexslider\";}','drupal_get_form','a:1:{i:0;s:24:\"flexslider_form_settings\";}','',31,5,1,'admin/config/media/flexslider','admin/config/media/flexslider','Advanced settings','t','','','a:0:{}',132,'Configure the advanced flexslider module settings.','',2,'sites/all/modules/flexslider/flexslider.admin.inc'),('admin/config/media/flexslider/import','','','ctools_export_ui_task_access','a:2:{i:0;s:27:\"flexslider_ctools_export_ui\";i:1;s:6:\"import\";}','ctools_export_ui_switcher_page','a:2:{i:0;s:27:\"flexslider_ctools_export_ui\";i:1;s:6:\"import\";}','',31,5,1,'admin/config/media/flexslider','admin/config/media/flexslider','Import','t','','','a:0:{}',388,'','',0,'sites/all/modules/ctools/includes/export-ui.inc'),('admin/config/media/flexslider/list','','','ctools_export_ui_task_access','a:2:{i:0;s:27:\"flexslider_ctools_export_ui\";i:1;s:4:\"list\";}','ctools_export_ui_switcher_page','a:2:{i:0;s:27:\"flexslider_ctools_export_ui\";i:1;s:4:\"list\";}','',31,5,1,'admin/config/media/flexslider','admin/config/media/flexslider','List','t','','','a:0:{}',140,'','',-10,'sites/all/modules/ctools/includes/export-ui.inc'),('admin/config/media/flexslider/list/%','a:1:{i:5;a:1:{s:21:\"ctools_export_ui_load\";a:1:{i:0;s:27:\"flexslider_ctools_export_ui\";}}}','','ctools_export_ui_task_access','a:3:{i:0;s:27:\"flexslider_ctools_export_ui\";i:1;s:4:\"edit\";i:2;i:5;}','ctools_export_ui_switcher_page','a:3:{i:0;s:27:\"flexslider_ctools_export_ui\";i:1;s:4:\"edit\";i:2;i:5;}','',62,6,0,'','admin/config/media/flexslider/list/%','','t','','','a:0:{}',0,'','',0,'sites/all/modules/ctools/includes/export-ui.inc'),('admin/config/media/flexslider/list/%/clone','a:1:{i:5;a:1:{s:21:\"ctools_export_ui_load\";a:1:{i:0;s:27:\"flexslider_ctools_export_ui\";}}}','','ctools_export_ui_task_access','a:3:{i:0;s:27:\"flexslider_ctools_export_ui\";i:1;s:5:\"clone\";i:2;i:5;}','ctools_export_ui_switcher_page','a:3:{i:0;s:27:\"flexslider_ctools_export_ui\";i:1;s:5:\"clone\";i:2;i:5;}','',125,7,0,'','admin/config/media/flexslider/list/%/clone','Clone','t','','','a:0:{}',0,'','',0,'sites/all/modules/ctools/includes/export-ui.inc'),('admin/config/media/flexslider/list/%/delete','a:1:{i:5;a:1:{s:21:\"ctools_export_ui_load\";a:1:{i:0;s:27:\"flexslider_ctools_export_ui\";}}}','','ctools_export_ui_task_access','a:3:{i:0;s:27:\"flexslider_ctools_export_ui\";i:1;s:6:\"delete\";i:2;i:5;}','ctools_export_ui_switcher_page','a:3:{i:0;s:27:\"flexslider_ctools_export_ui\";i:1;s:6:\"delete\";i:2;i:5;}','',125,7,0,'','admin/config/media/flexslider/list/%/delete','Delete','t','','','a:0:{}',0,'','',0,'sites/all/modules/ctools/includes/export-ui.inc'),('admin/config/media/flexslider/list/%/disable','a:1:{i:5;a:1:{s:21:\"ctools_export_ui_load\";a:1:{i:0;s:27:\"flexslider_ctools_export_ui\";}}}','','ctools_export_ui_task_access','a:3:{i:0;s:27:\"flexslider_ctools_export_ui\";i:1;s:7:\"disable\";i:2;i:5;}','ctools_export_ui_switcher_page','a:3:{i:0;s:27:\"flexslider_ctools_export_ui\";i:1;s:7:\"disable\";i:2;i:5;}','',125,7,0,'','admin/config/media/flexslider/list/%/disable','Disable','t','','','a:0:{}',0,'','',0,'sites/all/modules/ctools/includes/export-ui.inc'),('admin/config/media/flexslider/list/%/edit','a:1:{i:5;a:1:{s:21:\"ctools_export_ui_load\";a:1:{i:0;s:27:\"flexslider_ctools_export_ui\";}}}','','ctools_export_ui_task_access','a:3:{i:0;s:27:\"flexslider_ctools_export_ui\";i:1;s:4:\"edit\";i:2;i:5;}','ctools_export_ui_switcher_page','a:3:{i:0;s:27:\"flexslider_ctools_export_ui\";i:1;s:4:\"edit\";i:2;i:5;}','',125,7,1,'admin/config/media/flexslider/list/%','admin/config/media/flexslider/list/%','Edit','t','','','a:0:{}',140,'','',-10,'sites/all/modules/ctools/includes/export-ui.inc'),('admin/config/media/flexslider/list/%/enable','a:1:{i:5;a:1:{s:21:\"ctools_export_ui_load\";a:1:{i:0;s:27:\"flexslider_ctools_export_ui\";}}}','','ctools_export_ui_task_access','a:3:{i:0;s:27:\"flexslider_ctools_export_ui\";i:1;s:6:\"enable\";i:2;i:5;}','ctools_export_ui_switcher_page','a:3:{i:0;s:27:\"flexslider_ctools_export_ui\";i:1;s:6:\"enable\";i:2;i:5;}','',125,7,0,'','admin/config/media/flexslider/list/%/enable','Enable','t','','','a:0:{}',0,'','',0,'sites/all/modules/ctools/includes/export-ui.inc'),('admin/config/media/flexslider/list/%/export','a:1:{i:5;a:1:{s:21:\"ctools_export_ui_load\";a:1:{i:0;s:27:\"flexslider_ctools_export_ui\";}}}','','ctools_export_ui_task_access','a:3:{i:0;s:27:\"flexslider_ctools_export_ui\";i:1;s:6:\"export\";i:2;i:5;}','ctools_export_ui_switcher_page','a:3:{i:0;s:27:\"flexslider_ctools_export_ui\";i:1;s:6:\"export\";i:2;i:5;}','',125,7,1,'admin/config/media/flexslider/list/%','admin/config/media/flexslider/list/%','Export','t','','','a:0:{}',132,'','',0,'sites/all/modules/ctools/includes/export-ui.inc'),('admin/config/media/flexslider/list/%/revert','a:1:{i:5;a:1:{s:21:\"ctools_export_ui_load\";a:1:{i:0;s:27:\"flexslider_ctools_export_ui\";}}}','','ctools_export_ui_task_access','a:3:{i:0;s:27:\"flexslider_ctools_export_ui\";i:1;s:6:\"revert\";i:2;i:5;}','ctools_export_ui_switcher_page','a:3:{i:0;s:27:\"flexslider_ctools_export_ui\";i:1;s:6:\"delete\";i:2;i:5;}','',125,7,0,'','admin/config/media/flexslider/list/%/revert','Revert','t','','','a:0:{}',0,'','',0,'sites/all/modules/ctools/includes/export-ui.inc'),('admin/config/media/image-styles','','','user_access','a:1:{i:0;s:23:\"administer image styles\";}','image_style_list','a:0:{}','',15,4,0,'','admin/config/media/image-styles','Image styles','t','','','a:0:{}',6,'Configure styles that can be used for resizing or adjusting images on display.','',0,'modules/image/image.admin.inc'),('admin/config/media/image-styles/add','','','user_access','a:1:{i:0;s:23:\"administer image styles\";}','drupal_get_form','a:1:{i:0;s:20:\"image_style_add_form\";}','',31,5,1,'admin/config/media/image-styles','admin/config/media/image-styles','Add style','t','','','a:0:{}',388,'Add a new image style.','',2,'modules/image/image.admin.inc'),('admin/config/media/image-styles/delete/%','a:1:{i:5;a:1:{s:16:\"image_style_load\";a:2:{i:0;N;i:1;s:1:\"1\";}}}','','user_access','a:1:{i:0;s:23:\"administer image styles\";}','drupal_get_form','a:2:{i:0;s:23:\"image_style_delete_form\";i:1;i:5;}','',62,6,0,'','admin/config/media/image-styles/delete/%','Delete style','t','','','a:0:{}',6,'Delete an image style.','',0,'modules/image/image.admin.inc'),('admin/config/media/image-styles/edit/%','a:1:{i:5;s:16:\"image_style_load\";}','','user_access','a:1:{i:0;s:23:\"administer image styles\";}','drupal_get_form','a:2:{i:0;s:16:\"image_style_form\";i:1;i:5;}','',62,6,0,'','admin/config/media/image-styles/edit/%','Edit style','t','','','a:0:{}',6,'Configure an image style.','',0,'modules/image/image.admin.inc'),('admin/config/media/image-styles/edit/%/add/%','a:2:{i:5;a:1:{s:16:\"image_style_load\";a:1:{i:0;i:5;}}i:7;a:1:{s:28:\"image_effect_definition_load\";a:1:{i:0;i:5;}}}','','user_access','a:1:{i:0;s:23:\"administer image styles\";}','drupal_get_form','a:3:{i:0;s:17:\"image_effect_form\";i:1;i:5;i:2;i:7;}','',250,8,0,'','admin/config/media/image-styles/edit/%/add/%','Add image effect','t','','','a:0:{}',6,'Add a new effect to a style.','',0,'modules/image/image.admin.inc'),('admin/config/media/image-styles/edit/%/effects/%','a:2:{i:5;a:1:{s:16:\"image_style_load\";a:2:{i:0;i:5;i:1;s:1:\"3\";}}i:7;a:1:{s:17:\"image_effect_load\";a:2:{i:0;i:5;i:1;s:1:\"3\";}}}','','user_access','a:1:{i:0;s:23:\"administer image styles\";}','drupal_get_form','a:3:{i:0;s:17:\"image_effect_form\";i:1;i:5;i:2;i:7;}','',250,8,0,'','admin/config/media/image-styles/edit/%/effects/%','Edit image effect','t','','','a:0:{}',6,'Edit an existing effect within a style.','',0,'modules/image/image.admin.inc'),('admin/config/media/image-styles/edit/%/effects/%/delete','a:2:{i:5;a:1:{s:16:\"image_style_load\";a:2:{i:0;i:5;i:1;s:1:\"3\";}}i:7;a:1:{s:17:\"image_effect_load\";a:2:{i:0;i:5;i:1;s:1:\"3\";}}}','','user_access','a:1:{i:0;s:23:\"administer image styles\";}','drupal_get_form','a:3:{i:0;s:24:\"image_effect_delete_form\";i:1;i:5;i:2;i:7;}','',501,9,0,'','admin/config/media/image-styles/edit/%/effects/%/delete','Delete image effect','t','','','a:0:{}',6,'Delete an existing effect from a style.','',0,'modules/image/image.admin.inc'),('admin/config/media/image-styles/list','','','user_access','a:1:{i:0;s:23:\"administer image styles\";}','image_style_list','a:0:{}','',31,5,1,'admin/config/media/image-styles','admin/config/media/image-styles','List','t','','','a:0:{}',140,'List the current image styles on the site.','',1,'modules/image/image.admin.inc'),('admin/config/media/image-styles/revert/%','a:1:{i:5;a:1:{s:16:\"image_style_load\";a:2:{i:0;N;i:1;s:1:\"2\";}}}','','user_access','a:1:{i:0;s:23:\"administer image styles\";}','drupal_get_form','a:2:{i:0;s:23:\"image_style_revert_form\";i:1;i:5;}','',62,6,0,'','admin/config/media/image-styles/revert/%','Revert style','t','','','a:0:{}',6,'Revert an image style.','',0,'modules/image/image.admin.inc'),('admin/config/media/image-toolkit','','','user_access','a:1:{i:0;s:29:\"administer site configuration\";}','drupal_get_form','a:1:{i:0;s:29:\"system_image_toolkit_settings\";}','',15,4,0,'','admin/config/media/image-toolkit','Image toolkit','t','','','a:0:{}',6,'Choose which image toolkit to use if you have installed optional toolkits.','',20,'modules/system/system.admin.inc'),('admin/config/media/vef','','','user_access','a:1:{i:0;s:23:\"administer video styles\";}','system_admin_menu_block_page','a:0:{}','',15,4,0,'','admin/config/media/vef','Video Embed Field','t','','','a:0:{}',6,'Video Embed Field configuration','',0,'modules/system/system.admin.inc'),('admin/config/media/vef/settings','','','user_access','a:1:{i:0;s:23:\"administer video styles\";}','drupal_get_form','a:1:{i:0;s:31:\"video_embed_field_settings_form\";}','',31,5,0,'','admin/config/media/vef/settings','Settings','t','','','a:0:{}',6,'Video Embed Field module settings','',0,'sites/all/modules/video_embed_field/video_embed_field.admin.inc'),('admin/config/media/vef/vef_video_styles','','','ctools_export_ui_task_access','a:2:{i:0;s:27:\"video_embed_field_export_ui\";i:1;s:4:\"list\";}','ctools_export_ui_switcher_page','a:2:{i:0;s:27:\"video_embed_field_export_ui\";i:1;s:4:\"list\";}','',31,5,0,'','admin/config/media/vef/vef_video_styles','Video Embed Styles','t','','','a:0:{}',6,'Administer Video Embed Field\'s video styles.','',0,'sites/all/modules/ctools/includes/export-ui.inc'),('admin/config/media/vef/vef_video_styles/add','','','ctools_export_ui_task_access','a:2:{i:0;s:27:\"video_embed_field_export_ui\";i:1;s:3:\"add\";}','ctools_export_ui_switcher_page','a:2:{i:0;s:27:\"video_embed_field_export_ui\";i:1;s:3:\"add\";}','',63,6,1,'admin/config/media/vef/vef_video_styles','admin/config/media/vef/vef_video_styles','Add','t','','','a:0:{}',388,'','',0,'sites/all/modules/ctools/includes/export-ui.inc'),('admin/config/media/vef/vef_video_styles/import','','','ctools_export_ui_task_access','a:2:{i:0;s:27:\"video_embed_field_export_ui\";i:1;s:6:\"import\";}','ctools_export_ui_switcher_page','a:2:{i:0;s:27:\"video_embed_field_export_ui\";i:1;s:6:\"import\";}','',63,6,1,'admin/config/media/vef/vef_video_styles','admin/config/media/vef/vef_video_styles','Import','t','','','a:0:{}',388,'','',0,'sites/all/modules/ctools/includes/export-ui.inc'),('admin/config/media/vef/vef_video_styles/list','','','ctools_export_ui_task_access','a:2:{i:0;s:27:\"video_embed_field_export_ui\";i:1;s:4:\"list\";}','ctools_export_ui_switcher_page','a:2:{i:0;s:27:\"video_embed_field_export_ui\";i:1;s:4:\"list\";}','',63,6,1,'admin/config/media/vef/vef_video_styles','admin/config/media/vef/vef_video_styles','List','t','','','a:0:{}',140,'','',-10,'sites/all/modules/ctools/includes/export-ui.inc'),('admin/config/media/vef/vef_video_styles/list/%','a:1:{i:6;a:1:{s:21:\"ctools_export_ui_load\";a:1:{i:0;s:27:\"video_embed_field_export_ui\";}}}','','ctools_export_ui_task_access','a:3:{i:0;s:27:\"video_embed_field_export_ui\";i:1;s:4:\"edit\";i:2;i:6;}','ctools_export_ui_switcher_page','a:3:{i:0;s:27:\"video_embed_field_export_ui\";i:1;s:4:\"edit\";i:2;i:6;}','',126,7,0,'','admin/config/media/vef/vef_video_styles/list/%','','t','','','a:0:{}',0,'','',0,'sites/all/modules/ctools/includes/export-ui.inc'),('admin/config/media/vef/vef_video_styles/list/%/clone','a:1:{i:6;a:1:{s:21:\"ctools_export_ui_load\";a:1:{i:0;s:27:\"video_embed_field_export_ui\";}}}','','ctools_export_ui_task_access','a:3:{i:0;s:27:\"video_embed_field_export_ui\";i:1;s:5:\"clone\";i:2;i:6;}','ctools_export_ui_switcher_page','a:3:{i:0;s:27:\"video_embed_field_export_ui\";i:1;s:5:\"clone\";i:2;i:6;}','',253,8,0,'','admin/config/media/vef/vef_video_styles/list/%/clone','Clone','t','','','a:0:{}',0,'','',0,'sites/all/modules/ctools/includes/export-ui.inc'),('admin/config/media/vef/vef_video_styles/list/%/delete','a:1:{i:6;a:1:{s:21:\"ctools_export_ui_load\";a:1:{i:0;s:27:\"video_embed_field_export_ui\";}}}','','ctools_export_ui_task_access','a:3:{i:0;s:27:\"video_embed_field_export_ui\";i:1;s:6:\"delete\";i:2;i:6;}','ctools_export_ui_switcher_page','a:3:{i:0;s:27:\"video_embed_field_export_ui\";i:1;s:6:\"delete\";i:2;i:6;}','',253,8,0,'','admin/config/media/vef/vef_video_styles/list/%/delete','Delete','t','','','a:0:{}',0,'','',0,'sites/all/modules/ctools/includes/export-ui.inc'),('admin/config/media/vef/vef_video_styles/list/%/disable','a:1:{i:6;a:1:{s:21:\"ctools_export_ui_load\";a:1:{i:0;s:27:\"video_embed_field_export_ui\";}}}','','ctools_export_ui_task_access','a:3:{i:0;s:27:\"video_embed_field_export_ui\";i:1;s:7:\"disable\";i:2;i:6;}','ctools_export_ui_switcher_page','a:3:{i:0;s:27:\"video_embed_field_export_ui\";i:1;s:7:\"disable\";i:2;i:6;}','',253,8,0,'','admin/config/media/vef/vef_video_styles/list/%/disable','Disable','t','','','a:0:{}',0,'','',0,'sites/all/modules/ctools/includes/export-ui.inc'),('admin/config/media/vef/vef_video_styles/list/%/edit','a:1:{i:6;a:1:{s:21:\"ctools_export_ui_load\";a:1:{i:0;s:27:\"video_embed_field_export_ui\";}}}','','ctools_export_ui_task_access','a:3:{i:0;s:27:\"video_embed_field_export_ui\";i:1;s:4:\"edit\";i:2;i:6;}','ctools_export_ui_switcher_page','a:3:{i:0;s:27:\"video_embed_field_export_ui\";i:1;s:4:\"edit\";i:2;i:6;}','',253,8,1,'admin/config/media/vef/vef_video_styles/list/%','admin/config/media/vef/vef_video_styles/list/%','Edit','t','','','a:0:{}',140,'','',-10,'sites/all/modules/ctools/includes/export-ui.inc'),('admin/config/media/vef/vef_video_styles/list/%/enable','a:1:{i:6;a:1:{s:21:\"ctools_export_ui_load\";a:1:{i:0;s:27:\"video_embed_field_export_ui\";}}}','','ctools_export_ui_task_access','a:3:{i:0;s:27:\"video_embed_field_export_ui\";i:1;s:6:\"enable\";i:2;i:6;}','ctools_export_ui_switcher_page','a:3:{i:0;s:27:\"video_embed_field_export_ui\";i:1;s:6:\"enable\";i:2;i:6;}','',253,8,0,'','admin/config/media/vef/vef_video_styles/list/%/enable','Enable','t','','','a:0:{}',0,'','',0,'sites/all/modules/ctools/includes/export-ui.inc'),('admin/config/media/vef/vef_video_styles/list/%/export','a:1:{i:6;a:1:{s:21:\"ctools_export_ui_load\";a:1:{i:0;s:27:\"video_embed_field_export_ui\";}}}','','ctools_export_ui_task_access','a:3:{i:0;s:27:\"video_embed_field_export_ui\";i:1;s:6:\"export\";i:2;i:6;}','ctools_export_ui_switcher_page','a:3:{i:0;s:27:\"video_embed_field_export_ui\";i:1;s:6:\"export\";i:2;i:6;}','',253,8,1,'admin/config/media/vef/vef_video_styles/list/%','admin/config/media/vef/vef_video_styles/list/%','Export','t','','','a:0:{}',132,'','',0,'sites/all/modules/ctools/includes/export-ui.inc'),('admin/config/media/vef/vef_video_styles/list/%/revert','a:1:{i:6;a:1:{s:21:\"ctools_export_ui_load\";a:1:{i:0;s:27:\"video_embed_field_export_ui\";}}}','','ctools_export_ui_task_access','a:3:{i:0;s:27:\"video_embed_field_export_ui\";i:1;s:6:\"revert\";i:2;i:6;}','ctools_export_ui_switcher_page','a:3:{i:0;s:27:\"video_embed_field_export_ui\";i:1;s:6:\"delete\";i:2;i:6;}','',253,8,0,'','admin/config/media/vef/vef_video_styles/list/%/revert','Revert','t','','','a:0:{}',0,'','',0,'sites/all/modules/ctools/includes/export-ui.inc'),('admin/config/people','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','system_admin_menu_block_page','a:0:{}','',7,3,0,'','admin/config/people','People','t','','','a:0:{}',6,'Configure user accounts.','left',-20,'modules/system/system.admin.inc'),('admin/config/people/accounts','','','user_access','a:1:{i:0;s:16:\"administer users\";}','drupal_get_form','a:1:{i:0;s:19:\"user_admin_settings\";}','',15,4,0,'','admin/config/people/accounts','Account settings','t','','','a:0:{}',6,'Configure default behavior of users, including registration requirements, e-mails, fields, and user pictures.','',-10,'modules/user/user.admin.inc'),('admin/config/people/accounts/display','','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:16:\"administer users\";}}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:4:\"user\";i:2;s:4:\"user\";i:3;s:7:\"default\";}','',31,5,1,'admin/config/people/accounts','admin/config/people/accounts','Manage display','t','','','a:0:{}',132,'','',2,'modules/field_ui/field_ui.admin.inc'),('admin/config/people/accounts/display/default','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:4:\"user\";i:1;s:4:\"user\";i:2;s:7:\"default\";i:3;s:21:\"field_ui_admin_access\";i:4;s:11:\"user_access\";i:5;a:1:{i:0;s:16:\"administer users\";}}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:4:\"user\";i:2;s:4:\"user\";i:3;s:7:\"default\";}','',63,6,1,'admin/config/people/accounts/display','admin/config/people/accounts','Default','t','','','a:0:{}',140,'','',-10,'modules/field_ui/field_ui.admin.inc'),('admin/config/people/accounts/display/full','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:4:\"user\";i:1;s:4:\"user\";i:2;s:4:\"full\";i:3;s:21:\"field_ui_admin_access\";i:4;s:11:\"user_access\";i:5;a:1:{i:0;s:16:\"administer users\";}}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:4:\"user\";i:2;s:4:\"user\";i:3;s:4:\"full\";}','',63,6,1,'admin/config/people/accounts/display','admin/config/people/accounts','User account','t','','','a:0:{}',132,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/config/people/accounts/display/token','','','_field_ui_view_mode_menu_access','a:6:{i:0;s:4:\"user\";i:1;s:4:\"user\";i:2;s:5:\"token\";i:3;s:21:\"field_ui_admin_access\";i:4;s:11:\"user_access\";i:5;a:1:{i:0;s:16:\"administer users\";}}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:4:\"user\";i:2;s:4:\"user\";i:3;s:5:\"token\";}','',63,6,1,'admin/config/people/accounts/display','admin/config/people/accounts','Tokens','t','','','a:0:{}',132,'','',1,'modules/field_ui/field_ui.admin.inc'),('admin/config/people/accounts/fields','','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:16:\"administer users\";}}','drupal_get_form','a:3:{i:0;s:28:\"field_ui_field_overview_form\";i:1;s:4:\"user\";i:2;s:4:\"user\";}','',31,5,1,'admin/config/people/accounts','admin/config/people/accounts','Manage fields','t','','','a:0:{}',132,'','',1,'modules/field_ui/field_ui.admin.inc'),('admin/config/people/accounts/fields/%','a:1:{i:5;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:4:\"user\";i:1;s:4:\"user\";i:2;s:1:\"0\";i:3;s:4:\"%map\";}}}','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:16:\"administer users\";}}','drupal_get_form','a:2:{i:0;s:24:\"field_ui_field_edit_form\";i:1;i:5;}','',62,6,0,'','admin/config/people/accounts/fields/%','','field_ui_menu_title','a:1:{i:0;i:5;}','','a:0:{}',6,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/config/people/accounts/fields/%/delete','a:1:{i:5;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:4:\"user\";i:1;s:4:\"user\";i:2;s:1:\"0\";i:3;s:4:\"%map\";}}}','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:16:\"administer users\";}}','drupal_get_form','a:2:{i:0;s:26:\"field_ui_field_delete_form\";i:1;i:5;}','',125,7,1,'admin/config/people/accounts/fields/%','admin/config/people/accounts/fields/%','Delete','t','','','a:0:{}',132,'','',10,'modules/field_ui/field_ui.admin.inc'),('admin/config/people/accounts/fields/%/edit','a:1:{i:5;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:4:\"user\";i:1;s:4:\"user\";i:2;s:1:\"0\";i:3;s:4:\"%map\";}}}','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:16:\"administer users\";}}','drupal_get_form','a:2:{i:0;s:24:\"field_ui_field_edit_form\";i:1;i:5;}','',125,7,1,'admin/config/people/accounts/fields/%','admin/config/people/accounts/fields/%','Edit','t','','','a:0:{}',140,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/config/people/accounts/fields/%/field-settings','a:1:{i:5;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:4:\"user\";i:1;s:4:\"user\";i:2;s:1:\"0\";i:3;s:4:\"%map\";}}}','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:16:\"administer users\";}}','drupal_get_form','a:2:{i:0;s:28:\"field_ui_field_settings_form\";i:1;i:5;}','',125,7,1,'admin/config/people/accounts/fields/%','admin/config/people/accounts/fields/%','Field settings','t','','','a:0:{}',132,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/config/people/accounts/fields/%/widget-type','a:1:{i:5;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:4:\"user\";i:1;s:4:\"user\";i:2;s:1:\"0\";i:3;s:4:\"%map\";}}}','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:16:\"administer users\";}}','drupal_get_form','a:2:{i:0;s:25:\"field_ui_widget_type_form\";i:1;i:5;}','',125,7,1,'admin/config/people/accounts/fields/%','admin/config/people/accounts/fields/%','Widget type','t','','','a:0:{}',132,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/config/people/accounts/groups/%/delete','a:1:{i:5;a:1:{s:21:\"field_group_menu_load\";a:4:{i:0;s:4:\"user\";i:1;s:4:\"user\";i:2;s:1:\"0\";i:3;s:4:\"%map\";}}}','','user_access','a:1:{i:0;s:16:\"administer users\";}','drupal_get_form','a:2:{i:0;s:23:\"field_group_delete_form\";i:1;i:5;}','',125,7,0,'','admin/config/people/accounts/groups/%/delete','Delete','t','','','a:0:{}',0,'','',0,'sites/all/modules/field_group/field_group.field_ui.inc'),('admin/config/people/accounts/groups/%/enable','a:1:{i:5;a:1:{s:21:\"field_group_menu_load\";a:4:{i:0;s:4:\"user\";i:1;s:4:\"user\";i:2;s:1:\"0\";i:3;s:4:\"%map\";}}}','','user_access','a:1:{i:0;s:16:\"administer users\";}','drupal_get_form','a:2:{i:0;s:23:\"field_group_enable_form\";i:1;i:5;}','',125,7,0,'','admin/config/people/accounts/groups/%/enable','Enable','t','','','a:0:{}',0,'','',0,'sites/all/modules/field_group/field_group.field_ui.inc'),('admin/config/people/accounts/settings','','','user_access','a:1:{i:0;s:16:\"administer users\";}','drupal_get_form','a:1:{i:0;s:19:\"user_admin_settings\";}','',31,5,1,'admin/config/people/accounts','admin/config/people/accounts','Settings','t','','','a:0:{}',140,'','',-10,'modules/user/user.admin.inc'),('admin/config/people/ip-blocking','','','user_access','a:1:{i:0;s:18:\"block IP addresses\";}','system_ip_blocking','a:0:{}','',15,4,0,'','admin/config/people/ip-blocking','IP address blocking','t','','','a:0:{}',6,'Manage blocked IP addresses.','',10,'modules/system/system.admin.inc'),('admin/config/people/ip-blocking/delete/%','a:1:{i:5;s:15:\"blocked_ip_load\";}','','user_access','a:1:{i:0;s:18:\"block IP addresses\";}','drupal_get_form','a:2:{i:0;s:25:\"system_ip_blocking_delete\";i:1;i:5;}','',62,6,0,'','admin/config/people/ip-blocking/delete/%','Delete IP address','t','','','a:0:{}',6,'','',0,'modules/system/system.admin.inc'),('admin/config/regional','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','system_admin_menu_block_page','a:0:{}','',7,3,0,'','admin/config/regional','Regional and language','t','','','a:0:{}',6,'Regional settings, localization and translation.','left',-5,'modules/system/system.admin.inc'),('admin/config/regional/date-time','','','user_access','a:1:{i:0;s:29:\"administer site configuration\";}','drupal_get_form','a:1:{i:0;s:25:\"system_date_time_settings\";}','',15,4,0,'','admin/config/regional/date-time','Date and time','t','','','a:0:{}',6,'Configure display formats for date and time.','',-15,'modules/system/system.admin.inc'),('admin/config/regional/date-time/date-views','','','user_access','a:1:{i:0;s:30:\"administer site configuration \";}','drupal_get_form','a:1:{i:0;s:19:\"date_views_settings\";}','',31,5,1,'admin/config/regional/date-time','admin/config/regional/date-time','Date views','t','','','a:0:{}',132,'Configure settings for date views.','',0,''),('admin/config/regional/date-time/formats','','','user_access','a:1:{i:0;s:29:\"administer site configuration\";}','system_date_time_formats','a:0:{}','',31,5,1,'admin/config/regional/date-time','admin/config/regional/date-time','Formats','t','','','a:0:{}',132,'Configure display format strings for date and time.','',-9,'modules/system/system.admin.inc'),('admin/config/regional/date-time/formats/%/delete','a:1:{i:5;N;}','','user_access','a:1:{i:0;s:29:\"administer site configuration\";}','drupal_get_form','a:2:{i:0;s:30:\"system_date_delete_format_form\";i:1;i:5;}','',125,7,0,'','admin/config/regional/date-time/formats/%/delete','Delete date format','t','','','a:0:{}',6,'Allow users to delete a configured date format.','',0,'modules/system/system.admin.inc'),('admin/config/regional/date-time/formats/%/edit','a:1:{i:5;N;}','','user_access','a:1:{i:0;s:29:\"administer site configuration\";}','drupal_get_form','a:2:{i:0;s:34:\"system_configure_date_formats_form\";i:1;i:5;}','',125,7,0,'','admin/config/regional/date-time/formats/%/edit','Edit date format','t','','','a:0:{}',6,'Allow users to edit a configured date format.','',0,'modules/system/system.admin.inc'),('admin/config/regional/date-time/formats/add','','','user_access','a:1:{i:0;s:29:\"administer site configuration\";}','drupal_get_form','a:1:{i:0;s:34:\"system_configure_date_formats_form\";}','',63,6,1,'admin/config/regional/date-time/formats','admin/config/regional/date-time','Add format','t','','','a:0:{}',388,'Allow users to add additional date formats.','',-10,'modules/system/system.admin.inc'),('admin/config/regional/date-time/formats/lookup','','','user_access','a:1:{i:0;s:29:\"administer site configuration\";}','system_date_time_lookup','a:0:{}','',63,6,0,'','admin/config/regional/date-time/formats/lookup','Date and time lookup','t','','','a:0:{}',0,'','',0,'modules/system/system.admin.inc'),('admin/config/regional/date-time/locale','','','user_access','a:1:{i:0;s:29:\"administer site configuration\";}','locale_date_format_language_overview_page','a:0:{}','',31,5,1,'admin/config/regional/date-time','admin/config/regional/date-time','Localize','t','','','a:0:{}',132,'Configure date formats for each locale','',-8,'modules/locale/locale.admin.inc'),('admin/config/regional/date-time/locale/%/edit','a:1:{i:5;N;}','','user_access','a:1:{i:0;s:29:\"administer site configuration\";}','drupal_get_form','a:2:{i:0;s:23:\"locale_date_format_form\";i:1;i:5;}','',125,7,0,'','admin/config/regional/date-time/locale/%/edit','Localize date formats','t','','','a:0:{}',6,'Configure date formats for each locale','',0,'modules/locale/locale.admin.inc'),('admin/config/regional/date-time/locale/%/reset','a:1:{i:5;N;}','','user_access','a:1:{i:0;s:29:\"administer site configuration\";}','drupal_get_form','a:2:{i:0;s:29:\"locale_date_format_reset_form\";i:1;i:5;}','',125,7,0,'','admin/config/regional/date-time/locale/%/reset','Reset date formats','t','','','a:0:{}',6,'Reset localized date formats to global defaults','',0,'modules/locale/locale.admin.inc'),('admin/config/regional/date-time/types','','','user_access','a:1:{i:0;s:29:\"administer site configuration\";}','drupal_get_form','a:1:{i:0;s:25:\"system_date_time_settings\";}','',31,5,1,'admin/config/regional/date-time','admin/config/regional/date-time','Types','t','','','a:0:{}',140,'Configure display formats for date and time.','',-10,'modules/system/system.admin.inc'),('admin/config/regional/date-time/types/%/delete','a:1:{i:5;N;}','','user_access','a:1:{i:0;s:29:\"administer site configuration\";}','drupal_get_form','a:2:{i:0;s:35:\"system_delete_date_format_type_form\";i:1;i:5;}','',125,7,0,'','admin/config/regional/date-time/types/%/delete','Delete date type','t','','','a:0:{}',6,'Allow users to delete a configured date type.','',0,'modules/system/system.admin.inc'),('admin/config/regional/date-time/types/add','','','user_access','a:1:{i:0;s:29:\"administer site configuration\";}','drupal_get_form','a:1:{i:0;s:32:\"system_add_date_format_type_form\";}','',63,6,1,'admin/config/regional/date-time/types','admin/config/regional/date-time','Add date type','t','','','a:0:{}',388,'Add new date type.','',-10,'modules/system/system.admin.inc'),('admin/config/regional/i18n','','','user_access','a:1:{i:0;s:29:\"administer site configuration\";}','drupal_get_form','a:2:{i:0;s:20:\"variable_module_form\";i:1;s:4:\"i18n\";}','',15,4,0,'','admin/config/regional/i18n','Multilingual settings','t','','','a:0:{}',6,'Configure extended options for multilingual content and translations.','',10,''),('admin/config/regional/i18n/configure','','','user_access','a:1:{i:0;s:29:\"administer site configuration\";}','drupal_get_form','a:2:{i:0;s:20:\"variable_module_form\";i:1;s:4:\"i18n\";}','',31,5,1,'admin/config/regional/i18n','admin/config/regional/i18n','Multilingual system','t','','','a:0:{}',140,'Configure extended options for multilingual content and translations.','',0,''),('admin/config/regional/i18n/strings','','','user_access','a:1:{i:0;s:29:\"administer site configuration\";}','drupal_get_form','a:2:{i:0;s:18:\"variable_edit_form\";i:1;a:2:{i:0;s:27:\"i18n_string_allowed_formats\";i:1;s:27:\"i18n_string_source_language\";}}','',31,5,1,'admin/config/regional/i18n','admin/config/regional/i18n','Strings','t','','','a:0:{}',132,'Options for user defined strings.','',20,''),('admin/config/regional/i18n_translation','','','user_access','a:1:{i:0;s:29:\"administer site configuration\";}','i18n_translation_admin_overview','a:0:{}','',15,4,0,'','admin/config/regional/i18n_translation','Translation sets','t','','','a:0:{}',6,'Translation sets overview.','',10,'sites/all/modules/i18n/i18n_translation/i18n_translation.admin.inc'),('admin/config/regional/i18n_translation/configure','','','user_access','a:1:{i:0;s:29:\"administer site configuration\";}','i18n_translation_admin_overview','a:0:{}','',31,5,1,'admin/config/regional/i18n_translation','admin/config/regional/i18n_translation','Translation sets','t','','','a:0:{}',140,'Overview of existing translation sets.','',0,'sites/all/modules/i18n/i18n_translation/i18n_translation.admin.inc'),('admin/config/regional/language','','','user_access','a:1:{i:0;s:20:\"administer languages\";}','drupal_get_form','a:1:{i:0;s:30:\"locale_languages_overview_form\";}','',15,4,0,'','admin/config/regional/language','Languages','t','','','a:0:{}',6,'Configure languages for content and the user interface.','',-10,'modules/locale/locale.admin.inc'),('admin/config/regional/language/add','','','user_access','a:1:{i:0;s:20:\"administer languages\";}','locale_languages_add_screen','a:0:{}','',31,5,1,'admin/config/regional/language','admin/config/regional/language','Add language','t','','','a:0:{}',388,'','',5,'modules/locale/locale.admin.inc'),('admin/config/regional/language/configure','','','user_access','a:1:{i:0;s:20:\"administer languages\";}','drupal_get_form','a:1:{i:0;s:31:\"locale_languages_configure_form\";}','',31,5,1,'admin/config/regional/language','admin/config/regional/language','Detection and selection','t','','','a:0:{}',132,'','',10,'modules/locale/locale.admin.inc'),('admin/config/regional/language/configure/session','','','user_access','a:1:{i:0;s:20:\"administer languages\";}','drupal_get_form','a:1:{i:0;s:38:\"locale_language_providers_session_form\";}','',63,6,0,'','admin/config/regional/language/configure/session','Session language detection configuration','t','','','a:0:{}',4,'','',0,'modules/locale/locale.admin.inc'),('admin/config/regional/language/configure/url','','','user_access','a:1:{i:0;s:20:\"administer languages\";}','drupal_get_form','a:1:{i:0;s:34:\"locale_language_providers_url_form\";}','',63,6,0,'','admin/config/regional/language/configure/url','URL language detection configuration','t','','','a:0:{}',4,'','',0,'modules/locale/locale.admin.inc'),('admin/config/regional/language/delete/%','a:1:{i:5;N;}','','user_access','a:1:{i:0;s:20:\"administer languages\";}','drupal_get_form','a:2:{i:0;s:28:\"locale_languages_delete_form\";i:1;i:5;}','',62,6,0,'','admin/config/regional/language/delete/%','Confirm','t','','','a:0:{}',6,'','',0,'modules/locale/locale.admin.inc'),('admin/config/regional/language/edit/%','a:1:{i:5;N;}','','user_access','a:1:{i:0;s:20:\"administer languages\";}','drupal_get_form','a:2:{i:0;s:26:\"locale_languages_edit_form\";i:1;i:5;}','',62,6,0,'','admin/config/regional/language/edit/%','Edit language','t','','','a:0:{}',6,'','',0,'modules/locale/locale.admin.inc'),('admin/config/regional/language/icons','','','user_access','a:1:{i:0;s:20:\"administer languages\";}','drupal_get_form','a:1:{i:0;s:28:\"languageicons_admin_settings\";}','',31,5,1,'admin/config/regional/language','admin/config/regional/language','Icons','t','','','a:0:{}',132,'','',10,'sites/all/modules/languageicons/languageicons.admin.inc'),('admin/config/regional/language/overview','','','user_access','a:1:{i:0;s:20:\"administer languages\";}','drupal_get_form','a:1:{i:0;s:30:\"locale_languages_overview_form\";}','',31,5,1,'admin/config/regional/language','admin/config/regional/language','List','t','','','a:0:{}',140,'','',0,'modules/locale/locale.admin.inc'),('admin/config/regional/settings','','','user_access','a:1:{i:0;s:29:\"administer site configuration\";}','drupal_get_form','a:1:{i:0;s:24:\"system_regional_settings\";}','',15,4,0,'','admin/config/regional/settings','Regional settings','t','','','a:0:{}',6,'Settings for the site\'s default time zone and country.','',-20,'modules/system/system.admin.inc'),('admin/config/regional/translate','','','user_access','a:1:{i:0;s:19:\"translate interface\";}','locale_translate_overview_screen','a:0:{}','',15,4,0,'','admin/config/regional/translate','Translate interface','t','','','a:0:{}',6,'Translate the built in interface and optionally other text.','',-5,'modules/locale/locale.admin.inc'),('admin/config/regional/translate/delete/%','a:1:{i:5;N;}','','user_access','a:1:{i:0;s:19:\"translate interface\";}','locale_translate_delete_page','a:1:{i:0;i:5;}','',62,6,0,'','admin/config/regional/translate/delete/%','Delete string','t','','','a:0:{}',6,'','',0,'modules/locale/locale.admin.inc'),('admin/config/regional/translate/edit/%','a:1:{i:5;N;}','','user_access','a:1:{i:0;s:19:\"translate interface\";}','drupal_get_form','a:2:{i:0;s:38:\"i18n_string_locale_translate_edit_form\";i:1;i:5;}','',62,6,0,'','admin/config/regional/translate/edit/%','Edit string','t','','','a:0:{}',6,'','',0,'sites/all/modules/i18n/i18n_string/i18n_string.pages.inc'),('admin/config/regional/translate/export','','','user_access','a:1:{i:0;s:19:\"translate interface\";}','locale_translate_export_screen','a:0:{}','',31,5,1,'admin/config/regional/translate','admin/config/regional/translate','Export','t','','','a:0:{}',132,'','',30,'modules/locale/locale.admin.inc'),('admin/config/regional/translate/i18n_string','','','user_access','a:1:{i:0;s:19:\"translate interface\";}','drupal_get_form','a:1:{i:0;s:30:\"i18n_string_admin_refresh_form\";}','',31,5,1,'admin/config/regional/translate','admin/config/regional/translate','Strings','t','','','a:0:{}',132,'Refresh user defined strings.','',20,'sites/all/modules/i18n/i18n_string/i18n_string.admin.inc'),('admin/config/regional/translate/import','','','user_access','a:1:{i:0;s:19:\"translate interface\";}','drupal_get_form','a:1:{i:0;s:28:\"locale_translate_import_form\";}','',31,5,1,'admin/config/regional/translate','admin/config/regional/translate','Import','t','','','a:0:{}',132,'','',20,'modules/locale/locale.admin.inc'),('admin/config/regional/translate/overview','','','user_access','a:1:{i:0;s:19:\"translate interface\";}','locale_translate_overview_screen','a:0:{}','',31,5,1,'admin/config/regional/translate','admin/config/regional/translate','Overview','t','','','a:0:{}',140,'','',0,'modules/locale/locale.admin.inc'),('admin/config/regional/translate/translate','','','user_access','a:1:{i:0;s:19:\"translate interface\";}','locale_translate_seek_screen','a:0:{}','',31,5,1,'admin/config/regional/translate','admin/config/regional/translate','Translate','t','','','a:0:{}',132,'','',10,'modules/locale/locale.admin.inc'),('admin/config/search','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','system_admin_menu_block_page','a:0:{}','',7,3,0,'','admin/config/search','Search and metadata','t','','','a:0:{}',6,'Local site search, metadata and SEO.','left',-10,'modules/system/system.admin.inc'),('admin/config/search/clean-urls','','','user_access','a:1:{i:0;s:29:\"administer site configuration\";}','drupal_get_form','a:1:{i:0;s:25:\"system_clean_url_settings\";}','',15,4,0,'','admin/config/search/clean-urls','Clean URLs','t','','','a:0:{}',6,'Enable or disable clean URLs for your site.','',5,'modules/system/system.admin.inc'),('admin/config/search/clean-urls/check','','','1','a:0:{}','drupal_json_output','a:1:{i:0;a:1:{s:6:\"status\";b:1;}}','',31,5,0,'','admin/config/search/clean-urls/check','Clean URL check','t','','','a:0:{}',0,'','',0,'modules/system/system.admin.inc'),('admin/config/search/path','','','user_access','a:1:{i:0;s:22:\"administer url aliases\";}','path_admin_overview','a:0:{}','',15,4,0,'','admin/config/search/path','URL aliases','t','','','a:0:{}',6,'Change your site\'s URL paths by aliasing them.','',-5,'modules/path/path.admin.inc'),('admin/config/search/path/add','','','user_access','a:1:{i:0;s:22:\"administer url aliases\";}','path_admin_edit','a:0:{}','',31,5,1,'admin/config/search/path','admin/config/search/path','Add alias','t','','','a:0:{}',388,'','',0,'modules/path/path.admin.inc'),('admin/config/search/path/delete/%','a:1:{i:5;s:9:\"path_load\";}','','user_access','a:1:{i:0;s:22:\"administer url aliases\";}','drupal_get_form','a:2:{i:0;s:25:\"path_admin_delete_confirm\";i:1;i:5;}','',62,6,0,'','admin/config/search/path/delete/%','Delete alias','t','','','a:0:{}',6,'','',0,'modules/path/path.admin.inc'),('admin/config/search/path/delete_bulk','','','user_access','a:1:{i:0;s:22:\"administer url aliases\";}','drupal_get_form','a:1:{i:0;s:21:\"pathauto_admin_delete\";}','',31,5,1,'admin/config/search/path','admin/config/search/path','Delete aliases','t','','','a:0:{}',132,'','',40,'sites/all/modules/pathauto/pathauto.admin.inc'),('admin/config/search/path/edit/%','a:1:{i:5;s:9:\"path_load\";}','','user_access','a:1:{i:0;s:22:\"administer url aliases\";}','path_admin_edit','a:1:{i:0;i:5;}','',62,6,0,'','admin/config/search/path/edit/%','Edit alias','t','','','a:0:{}',6,'','',0,'modules/path/path.admin.inc'),('admin/config/search/path/list','','','user_access','a:1:{i:0;s:22:\"administer url aliases\";}','path_admin_overview','a:0:{}','',31,5,1,'admin/config/search/path','admin/config/search/path','List','t','','','a:0:{}',140,'','',-10,'modules/path/path.admin.inc'),('admin/config/search/path/patterns','','','user_access','a:1:{i:0;s:19:\"administer pathauto\";}','drupal_get_form','a:1:{i:0;s:22:\"pathauto_patterns_form\";}','',31,5,1,'admin/config/search/path','admin/config/search/path','Patterns','t','','','a:0:{}',132,'','',10,'sites/all/modules/pathauto/pathauto.admin.inc'),('admin/config/search/path/settings','','','user_access','a:1:{i:0;s:19:\"administer pathauto\";}','drupal_get_form','a:1:{i:0;s:22:\"pathauto_settings_form\";}','',31,5,1,'admin/config/search/path','admin/config/search/path','Settings','t','','','a:0:{}',132,'','',20,'sites/all/modules/pathauto/pathauto.admin.inc'),('admin/config/search/path/update_bulk','','','user_access','a:1:{i:0;s:22:\"administer url aliases\";}','drupal_get_form','a:1:{i:0;s:25:\"pathauto_bulk_update_form\";}','',31,5,1,'admin/config/search/path','admin/config/search/path','Bulk update','t','','','a:0:{}',132,'','',30,'sites/all/modules/pathauto/pathauto.admin.inc'),('admin/config/search/settings','','','user_access','a:1:{i:0;s:17:\"administer search\";}','drupal_get_form','a:1:{i:0;s:21:\"search_admin_settings\";}','',15,4,0,'','admin/config/search/settings','Search settings','t','','','a:0:{}',6,'Configure relevance settings for search and other indexing options.','',-10,'modules/search/search.admin.inc'),('admin/config/search/settings/reindex','','','user_access','a:1:{i:0;s:17:\"administer search\";}','drupal_get_form','a:1:{i:0;s:22:\"search_reindex_confirm\";}','',31,5,0,'','admin/config/search/settings/reindex','Clear index','t','','','a:0:{}',4,'','',0,'modules/search/search.admin.inc'),('admin/config/search/votingapi','','','user_access','a:1:{i:0;s:21:\"administer voting api\";}','drupal_get_form','a:1:{i:0;s:23:\"votingapi_settings_form\";}','',15,4,0,'','admin/config/search/votingapi','Voting API','t','','','a:0:{}',6,'Configure sitewide settings for user-generated ratings and votes.','',0,'sites/all/modules/votingapi/votingapi.admin.inc'),('admin/config/services','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','system_admin_menu_block_page','a:0:{}','',7,3,0,'','admin/config/services','Web services','t','','','a:0:{}',6,'Tools related to web services.','right',0,'modules/system/system.admin.inc'),('admin/config/services/rss-publishing','','','user_access','a:1:{i:0;s:29:\"administer site configuration\";}','drupal_get_form','a:1:{i:0;s:25:\"system_rss_feeds_settings\";}','',15,4,0,'','admin/config/services/rss-publishing','RSS publishing','t','','','a:0:{}',6,'Configure the site description, the number of items per feed and whether feeds should be titles/teasers/full-text.','',0,'modules/system/system.admin.inc'),('admin/config/services/sharethis','','','user_access','a:1:{i:0;s:20:\"administer sharethis\";}','drupal_get_form','a:1:{i:0;s:28:\"sharethis_configuration_form\";}','',15,4,0,'','admin/config/services/sharethis','ShareThis','t','','','a:0:{}',6,'Choose the widget, button family, and services for using ShareThis to share content online.','',0,''),('admin/config/system','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','system_admin_menu_block_page','a:0:{}','',7,3,0,'','admin/config/system','System','t','','','a:0:{}',6,'General system related configuration.','right',-20,'modules/system/system.admin.inc'),('admin/config/system/actions','','','user_access','a:1:{i:0;s:18:\"administer actions\";}','system_actions_manage','a:0:{}','',15,4,0,'','admin/config/system/actions','Actions','t','','','a:0:{}',6,'Manage the actions defined for your site.','',0,'modules/system/system.admin.inc'),('admin/config/system/actions/configure','','','user_access','a:1:{i:0;s:18:\"administer actions\";}','drupal_get_form','a:1:{i:0;s:24:\"system_actions_configure\";}','',31,5,0,'','admin/config/system/actions/configure','Configure an advanced action','t','','','a:0:{}',4,'','',0,'modules/system/system.admin.inc'),('admin/config/system/actions/delete/%','a:1:{i:5;s:12:\"actions_load\";}','','user_access','a:1:{i:0;s:18:\"administer actions\";}','drupal_get_form','a:2:{i:0;s:26:\"system_actions_delete_form\";i:1;i:5;}','',62,6,0,'','admin/config/system/actions/delete/%','Delete action','t','','','a:0:{}',6,'Delete an action.','',0,'modules/system/system.admin.inc'),('admin/config/system/actions/manage','','','user_access','a:1:{i:0;s:18:\"administer actions\";}','system_actions_manage','a:0:{}','',31,5,1,'admin/config/system/actions','admin/config/system/actions','Manage actions','t','','','a:0:{}',140,'Manage the actions defined for your site.','',-2,'modules/system/system.admin.inc'),('admin/config/system/actions/orphan','','','user_access','a:1:{i:0;s:18:\"administer actions\";}','system_actions_remove_orphans','a:0:{}','',31,5,0,'','admin/config/system/actions/orphan','Remove orphans','t','','','a:0:{}',0,'','',0,'modules/system/system.admin.inc'),('admin/config/system/cron','','','user_access','a:1:{i:0;s:29:\"administer site configuration\";}','drupal_get_form','a:1:{i:0;s:20:\"system_cron_settings\";}','',15,4,0,'','admin/config/system/cron','Cron','t','','','a:0:{}',6,'Manage automatic site maintenance tasks.','',20,'modules/system/system.admin.inc'),('admin/config/system/message','','','user_access','a:1:{i:0;s:24:\"administer message types\";}','drupal_get_form','a:1:{i:0;s:27:\"message_user_admin_settings\";}','',15,4,0,'','admin/config/system/message','Message settings','t','','','a:0:{}',6,'Manage message purging upon cron.','',0,'sites/all/modules/message/includes/message.admin.inc'),('admin/config/system/message/text-copy','','','user_access','a:1:{i:0;s:24:\"administer message types\";}','drupal_get_form','a:1:{i:0;s:23:\"message_admin_text_copy\";}','',31,5,0,'','admin/config/system/message/text-copy','Copy messages text fields','t','','','a:0:{}',6,'Copy messages text fields from one language to others','',0,'sites/all/modules/message/includes/message.admin.inc'),('admin/config/system/remember_me','','','user_access','a:1:{i:0;s:29:\"administer site configuration\";}','drupal_get_form','a:1:{i:0;s:26:\"remember_me_admin_settings\";}','',15,4,0,'','admin/config/system/remember_me','Remember me settings','t','','','a:0:{}',6,'Configure settings like session time out for remember_me module.','',0,'sites/all/modules/remember_me/remember_me.admin.inc'),('admin/config/system/site-information','','','user_access','a:1:{i:0;s:29:\"administer site configuration\";}','drupal_get_form','a:1:{i:0;s:32:\"system_site_information_settings\";}','',15,4,0,'','admin/config/system/site-information','Site information','t','','','a:0:{}',6,'Change site name, e-mail address, slogan, default front page, and number of posts per page, error pages.','',-20,'modules/system/system.admin.inc'),('admin/config/system/statistics','','','user_access','a:1:{i:0;s:21:\"administer statistics\";}','drupal_get_form','a:1:{i:0;s:24:\"statistics_settings_form\";}','',15,4,0,'','admin/config/system/statistics','Statistics','t','','','a:0:{}',6,'Control details about what and how your site logs access statistics.','',-15,'modules/statistics/statistics.admin.inc'),('admin/config/user-interface','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','system_admin_menu_block_page','a:0:{}','',7,3,0,'','admin/config/user-interface','User interface','t','','','a:0:{}',6,'Tools that enhance the user interface.','right',-15,'modules/system/system.admin.inc'),('admin/config/user-interface/chosen','','','user_access','a:1:{i:0;s:29:\"administer site configuration\";}','drupal_get_form','a:1:{i:0;s:21:\"chosen_admin_settings\";}','',15,4,0,'','admin/config/user-interface/chosen','Chosen','t','','','a:0:{}',6,'Configuration for Chosen plugin','',0,'sites/all/modules/chosen/chosen.admin.inc'),('admin/config/user-interface/menu-breadcrumb','','','user_access','a:1:{i:0;s:29:\"administer site configuration\";}','drupal_get_form','a:1:{i:0;s:35:\"menu_breadcrumb_admin_settings_form\";}','',15,4,0,'','admin/config/user-interface/menu-breadcrumb','Menu Breadcrumb','t','','','a:0:{}',6,'Configure menu breadcrumb.','',0,''),('admin/config/user-interface/modulefilter','','','user_access','a:1:{i:0;s:24:\"administer module filter\";}','drupal_get_form','a:1:{i:0;s:22:\"module_filter_settings\";}','',15,4,0,'','admin/config/user-interface/modulefilter','Module filter','t','','','a:0:{}',6,'Configure how the modules page looks and acts.','',0,'sites/all/modules/module_filter/module_filter.admin.inc'),('admin/config/user-interface/shortcut','','','user_access','a:1:{i:0;s:20:\"administer shortcuts\";}','shortcut_set_admin','a:0:{}','',15,4,0,'','admin/config/user-interface/shortcut','Shortcuts','t','','','a:0:{}',6,'Add and modify shortcut sets.','',0,'modules/shortcut/shortcut.admin.inc'),('admin/config/user-interface/shortcut/%','a:1:{i:4;s:17:\"shortcut_set_load\";}','','shortcut_set_edit_access','a:1:{i:0;i:4;}','drupal_get_form','a:2:{i:0;s:22:\"shortcut_set_customize\";i:1;i:4;}','',30,5,0,'','admin/config/user-interface/shortcut/%','Edit shortcuts','shortcut_set_title_callback','a:1:{i:0;i:4;}','','a:0:{}',6,'','',0,'modules/shortcut/shortcut.admin.inc'),('admin/config/user-interface/shortcut/%/add-link','a:1:{i:4;s:17:\"shortcut_set_load\";}','','shortcut_set_edit_access','a:1:{i:0;i:4;}','drupal_get_form','a:2:{i:0;s:17:\"shortcut_link_add\";i:1;i:4;}','',61,6,1,'admin/config/user-interface/shortcut/%','admin/config/user-interface/shortcut/%','Add shortcut','t','','','a:0:{}',388,'','',0,'modules/shortcut/shortcut.admin.inc'),('admin/config/user-interface/shortcut/%/add-link-inline','a:1:{i:4;s:17:\"shortcut_set_load\";}','','shortcut_set_edit_access','a:1:{i:0;i:4;}','shortcut_link_add_inline','a:1:{i:0;i:4;}','',61,6,0,'','admin/config/user-interface/shortcut/%/add-link-inline','Add shortcut','t','','','a:0:{}',0,'','',0,'modules/shortcut/shortcut.admin.inc'),('admin/config/user-interface/shortcut/%/delete','a:1:{i:4;s:17:\"shortcut_set_load\";}','','shortcut_set_delete_access','a:1:{i:0;i:4;}','drupal_get_form','a:2:{i:0;s:24:\"shortcut_set_delete_form\";i:1;i:4;}','',61,6,0,'','admin/config/user-interface/shortcut/%/delete','Delete shortcut set','t','','','a:0:{}',6,'','',0,'modules/shortcut/shortcut.admin.inc'),('admin/config/user-interface/shortcut/%/edit','a:1:{i:4;s:17:\"shortcut_set_load\";}','','shortcut_set_edit_access','a:1:{i:0;i:4;}','drupal_get_form','a:2:{i:0;s:22:\"shortcut_set_edit_form\";i:1;i:4;}','',61,6,1,'admin/config/user-interface/shortcut/%','admin/config/user-interface/shortcut/%','Edit set name','t','','','a:0:{}',132,'','',10,'modules/shortcut/shortcut.admin.inc'),('admin/config/user-interface/shortcut/%/links','a:1:{i:4;s:17:\"shortcut_set_load\";}','','shortcut_set_edit_access','a:1:{i:0;i:4;}','drupal_get_form','a:2:{i:0;s:22:\"shortcut_set_customize\";i:1;i:4;}','',61,6,1,'admin/config/user-interface/shortcut/%','admin/config/user-interface/shortcut/%','List links','t','','','a:0:{}',140,'','',0,'modules/shortcut/shortcut.admin.inc'),('admin/config/user-interface/shortcut/add-set','','','user_access','a:1:{i:0;s:20:\"administer shortcuts\";}','drupal_get_form','a:1:{i:0;s:21:\"shortcut_set_add_form\";}','',31,5,1,'admin/config/user-interface/shortcut','admin/config/user-interface/shortcut','Add shortcut set','t','','','a:0:{}',388,'','',0,'modules/shortcut/shortcut.admin.inc'),('admin/config/user-interface/shortcut/link/%','a:1:{i:5;s:14:\"menu_link_load\";}','','shortcut_link_access','a:1:{i:0;i:5;}','drupal_get_form','a:2:{i:0;s:18:\"shortcut_link_edit\";i:1;i:5;}','',62,6,0,'','admin/config/user-interface/shortcut/link/%','Edit shortcut','t','','','a:0:{}',6,'','',0,'modules/shortcut/shortcut.admin.inc'),('admin/config/user-interface/shortcut/link/%/delete','a:1:{i:5;s:14:\"menu_link_load\";}','','shortcut_link_access','a:1:{i:0;i:5;}','drupal_get_form','a:2:{i:0;s:20:\"shortcut_link_delete\";i:1;i:5;}','',125,7,0,'','admin/config/user-interface/shortcut/link/%/delete','Delete shortcut','t','','','a:0:{}',6,'','',0,'modules/shortcut/shortcut.admin.inc'),('admin/config/workflow','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','system_admin_menu_block_page','a:0:{}','',7,3,0,'','admin/config/workflow','Workflow','t','','','a:0:{}',6,'Content workflow, editorial workflow tools.','right',5,'modules/system/system.admin.inc'),('admin/content','','','user_access','a:1:{i:0;s:23:\"access content overview\";}','drupal_get_form','a:1:{i:0;s:18:\"node_admin_content\";}','',3,2,0,'','admin/content','Content','t','','','a:0:{}',6,'Administer content and comments.','',-10,'modules/node/node.admin.inc'),('admin/content/book','','','user_access','a:1:{i:0;s:24:\"administer book outlines\";}','book_admin_overview','a:0:{}','',7,3,1,'admin/content','admin/content','Books','t','','','a:0:{}',132,'Manage your site\'s book outlines.','',0,'modules/book/book.admin.inc'),('admin/content/book/%','a:1:{i:3;s:9:\"node_load\";}','','_book_outline_access','a:1:{i:0;i:3;}','drupal_get_form','a:2:{i:0;s:15:\"book_admin_edit\";i:1;i:3;}','',14,4,0,'','admin/content/book/%','Re-order book pages and change titles','t','','','a:0:{}',0,'','',0,'modules/book/book.admin.inc'),('admin/content/book/list','','','user_access','a:1:{i:0;s:24:\"administer book outlines\";}','book_admin_overview','a:0:{}','',15,4,1,'admin/content/book','admin/content','List','t','','','a:0:{}',140,'','',0,'modules/book/book.admin.inc'),('admin/content/book/settings','','','user_access','a:1:{i:0;s:29:\"administer site configuration\";}','drupal_get_form','a:1:{i:0;s:19:\"book_admin_settings\";}','',15,4,1,'admin/content/book','admin/content','Settings','t','','','a:0:{}',132,'','',8,'modules/book/book.admin.inc'),('admin/content/comment','','','user_access','a:1:{i:0;s:19:\"administer comments\";}','comment_admin','a:0:{}','',7,3,1,'admin/content','admin/content','Comments','t','','','a:0:{}',134,'List and edit site comments and the comment approval queue.','',0,'modules/comment/comment.admin.inc'),('admin/content/comment/approval','','','user_access','a:1:{i:0;s:19:\"administer comments\";}','comment_admin','a:1:{i:0;s:8:\"approval\";}','',15,4,1,'admin/content/comment','admin/content','Unapproved comments','comment_count_unpublished','','','a:0:{}',132,'','',0,'modules/comment/comment.admin.inc'),('admin/content/comment/new','','','user_access','a:1:{i:0;s:19:\"administer comments\";}','comment_admin','a:0:{}','',15,4,1,'admin/content/comment','admin/content','Published comments','t','','','a:0:{}',140,'','',-10,'modules/comment/comment.admin.inc'),('admin/content/message','','','views_access','a:1:{i:0;a:2:{i:0;s:16:\"views_check_perm\";i:1;a:1:{i:0;s:24:\"administer message types\";}}}','views_page','a:2:{i:0;s:7:\"message\";i:1;s:6:\"page_1\";}','',7,3,1,'admin/content','admin/content','Messages','t','','','a:0:{}',132,'A list of all messages.','',0,''),('admin/content/node','','','user_access','a:1:{i:0;s:23:\"access content overview\";}','drupal_get_form','a:1:{i:0;s:18:\"node_admin_content\";}','',7,3,1,'admin/content','admin/content','Content','t','','','a:0:{}',140,'','',-10,'modules/node/node.admin.inc'),('admin/content/webform','','','user_access','a:1:{i:0;s:26:\"access all webform results\";}','webform_admin_content','a:0:{}','',7,3,1,'admin/content','admin/content','Webforms','t','','','a:0:{}',132,'View and edit all the available webforms on your site.','',0,'sites/all/modules/webform/includes/webform.admin.inc'),('admin/dashboard','','','user_access','a:1:{i:0;s:16:\"access dashboard\";}','dashboard_admin','a:0:{}','',3,2,0,'','admin/dashboard','Dashboard','t','','','a:0:{}',6,'View and customize your dashboard.','',-15,''),('admin/dashboard/block-content/%/%','a:2:{i:3;N;i:4;N;}','','user_access','a:1:{i:0;s:17:\"administer blocks\";}','dashboard_show_block_content','a:2:{i:0;i:3;i:1;i:4;}','',28,5,0,'','admin/dashboard/block-content/%/%','','t','','','a:0:{}',0,'','',0,''),('admin/dashboard/configure','','','user_access','a:1:{i:0;s:17:\"administer blocks\";}','dashboard_admin_blocks','a:0:{}','',7,3,0,'','admin/dashboard/configure','Configure available dashboard blocks','t','','','a:0:{}',4,'Configure which blocks can be shown on the dashboard.','',0,''),('admin/dashboard/customize','','','user_access','a:1:{i:0;s:16:\"access dashboard\";}','dashboard_admin','a:1:{i:0;b:1;}','',7,3,0,'','admin/dashboard/customize','Customize dashboard','t','','','a:0:{}',4,'Customize your dashboard.','',0,''),('admin/dashboard/drawer','','','user_access','a:1:{i:0;s:17:\"administer blocks\";}','dashboard_show_disabled','a:0:{}','',7,3,0,'','admin/dashboard/drawer','','t','','','a:0:{}',0,'','',0,''),('admin/dashboard/update','','','user_access','a:1:{i:0;s:17:\"administer blocks\";}','dashboard_update','a:0:{}','',7,3,0,'','admin/dashboard/update','','t','','','a:0:{}',0,'','',0,''),('admin/help','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_main','a:0:{}','',3,2,0,'','admin/help','Help','t','','','a:0:{}',6,'Reference for usage, configuration, and modules.','',9,'modules/help/help.admin.inc'),('admin/help/admin_menu','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/admin_menu','admin_menu','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/block','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/block','block','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/blog','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/blog','blog','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/book','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/book','book','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/calendar','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/calendar','calendar','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/ckeditor','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/ckeditor','ckeditor','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/color','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/color','color','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/comment','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/comment','comment','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/contact','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/contact','contact','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/contextual','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/contextual','contextual','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/dashboard','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/dashboard','dashboard','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/dblog','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/dblog','dblog','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/faq','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/faq','faq','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/features','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/features','features','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/field','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/field','field','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/field_collection','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/field_collection','field_collection','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/field_sql_storage','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/field_sql_storage','field_sql_storage','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/field_ui','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/field_ui','field_ui','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/file','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/file','file','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/filter','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/filter','filter','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/fivestar','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/fivestar','fivestar','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/flexslider','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/flexslider','flexslider','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/forum','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/forum','forum','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/help','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/help','help','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/i18n','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/i18n','i18n','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/i18n_block','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/i18n_block','i18n_block','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/i18n_string','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/i18n_string','i18n_string','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/i18n_taxonomy','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/i18n_taxonomy','i18n_taxonomy','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/image','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/image','image','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/jquery_update','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/jquery_update','jquery_update','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/languageicons','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/languageicons','languageicons','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/lang_dropdown','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/lang_dropdown','lang_dropdown','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/lang_dropdown_hideout','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/lang_dropdown_hideout','lang_dropdown_hideout','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/list','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/list','list','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/locale','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/locale','locale','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/menu','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/menu','menu','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/menu_breadcrumb','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/menu_breadcrumb','menu_breadcrumb','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/node','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/node','node','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/number','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/number','number','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/options','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/options','options','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/overlay','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/overlay','overlay','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/path','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/path','path','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/pathauto','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/pathauto','pathauto','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/php','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/php','php','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/quicktabs','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/quicktabs','quicktabs','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/remember_me','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/remember_me','remember_me','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/search','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/search','search','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/sharethis','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/sharethis','sharethis','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/shortcut','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/shortcut','shortcut','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/statistics','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/statistics','statistics','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/strongarm','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/strongarm','strongarm','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/system','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/system','system','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/taxonomy','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/taxonomy','taxonomy','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/text','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/text','text','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/token','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/token','token','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/token_custom','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/token_custom','token_custom','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/update','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/update','update','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/user','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/user','user','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/views_slideshow','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/views_slideshow','views_slideshow','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/views_slideshow_cycle','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/views_slideshow_cycle','views_slideshow_cycle','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/webform','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/webform','webform','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/index','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','system_admin_index','a:0:{}','',3,2,1,'admin','admin','Index','t','','','a:0:{}',132,'','',-18,'modules/system/system.admin.inc'),('admin/modules','','','user_access','a:1:{i:0;s:18:\"administer modules\";}','drupal_get_form','a:1:{i:0;s:14:\"system_modules\";}','',3,2,0,'','admin/modules','Modules','t','','','a:0:{}',6,'Extend site functionality.','',-2,'modules/system/system.admin.inc'),('admin/modules/install','','','update_manager_access','a:0:{}','drupal_get_form','a:2:{i:0;s:27:\"update_manager_install_form\";i:1;s:6:\"module\";}','',7,3,1,'admin/modules','admin/modules','Install new module','t','','','a:0:{}',388,'','',25,'modules/update/update.manager.inc'),('admin/modules/list','','','user_access','a:1:{i:0;s:18:\"administer modules\";}','drupal_get_form','a:1:{i:0;s:14:\"system_modules\";}','',7,3,1,'admin/modules','admin/modules','List','t','','','a:0:{}',140,'','',0,'modules/system/system.admin.inc'),('admin/modules/list/confirm','','','user_access','a:1:{i:0;s:18:\"administer modules\";}','drupal_get_form','a:1:{i:0;s:14:\"system_modules\";}','',15,4,0,'','admin/modules/list/confirm','List','t','','','a:0:{}',4,'','',0,'modules/system/system.admin.inc'),('admin/modules/uninstall','','','user_access','a:1:{i:0;s:18:\"administer modules\";}','drupal_get_form','a:1:{i:0;s:24:\"system_modules_uninstall\";}','',7,3,1,'admin/modules','admin/modules','Uninstall','t','','','a:0:{}',132,'','',20,'modules/system/system.admin.inc'),('admin/modules/uninstall/confirm','','','user_access','a:1:{i:0;s:18:\"administer modules\";}','drupal_get_form','a:1:{i:0;s:24:\"system_modules_uninstall\";}','',15,4,0,'','admin/modules/uninstall/confirm','Uninstall','t','','','a:0:{}',4,'','',0,'modules/system/system.admin.inc'),('admin/modules/update','','','update_manager_access','a:0:{}','drupal_get_form','a:2:{i:0;s:26:\"update_manager_update_form\";i:1;s:6:\"module\";}','',7,3,1,'admin/modules','admin/modules','Update','t','','','a:0:{}',132,'','',10,'modules/update/update.manager.inc'),('admin/people','','','user_access','a:1:{i:0;s:16:\"administer users\";}','user_admin','a:1:{i:0;s:4:\"list\";}','',3,2,0,'','admin/people','People','t','','','a:0:{}',6,'Manage user accounts, roles, and permissions.','left',-4,'modules/user/user.admin.inc'),('admin/people/create','','','user_access','a:1:{i:0;s:16:\"administer users\";}','user_admin','a:1:{i:0;s:6:\"create\";}','',7,3,1,'admin/people','admin/people','Add user','t','','','a:0:{}',388,'','',0,'modules/user/user.admin.inc'),('admin/people/people','','','user_access','a:1:{i:0;s:16:\"administer users\";}','user_admin','a:1:{i:0;s:4:\"list\";}','',7,3,1,'admin/people','admin/people','List','t','','','a:0:{}',140,'Find and manage people interacting with your site.','',-10,'modules/user/user.admin.inc'),('admin/people/permissions','','','user_access','a:1:{i:0;s:22:\"administer permissions\";}','drupal_get_form','a:1:{i:0;s:22:\"user_admin_permissions\";}','',7,3,1,'admin/people','admin/people','Permissions','t','','','a:0:{}',132,'Determine access to features by selecting permissions for roles.','',0,'modules/user/user.admin.inc'),('admin/people/permissions/list','','','user_access','a:1:{i:0;s:22:\"administer permissions\";}','drupal_get_form','a:1:{i:0;s:22:\"user_admin_permissions\";}','',15,4,1,'admin/people/permissions','admin/people','Permissions','t','','','a:0:{}',140,'Determine access to features by selecting permissions for roles.','',-8,'modules/user/user.admin.inc'),('admin/people/permissions/roles','','','user_access','a:1:{i:0;s:22:\"administer permissions\";}','drupal_get_form','a:1:{i:0;s:16:\"user_admin_roles\";}','',15,4,1,'admin/people/permissions','admin/people','Roles','t','','','a:0:{}',132,'List, edit, or add user roles.','',-5,'modules/user/user.admin.inc'),('admin/people/permissions/roles/delete/%','a:1:{i:5;s:14:\"user_role_load\";}','','user_role_edit_access','a:1:{i:0;i:5;}','drupal_get_form','a:2:{i:0;s:30:\"user_admin_role_delete_confirm\";i:1;i:5;}','',62,6,0,'','admin/people/permissions/roles/delete/%','Delete role','t','','','a:0:{}',6,'','',0,'modules/user/user.admin.inc'),('admin/people/permissions/roles/edit/%','a:1:{i:5;s:14:\"user_role_load\";}','','user_role_edit_access','a:1:{i:0;i:5;}','drupal_get_form','a:2:{i:0;s:15:\"user_admin_role\";i:1;i:5;}','',62,6,0,'','admin/people/permissions/roles/edit/%','Edit role','t','','','a:0:{}',6,'','',0,'modules/user/user.admin.inc'),('admin/reports','','','user_access','a:1:{i:0;s:19:\"access site reports\";}','system_admin_menu_block_page','a:0:{}','',3,2,0,'','admin/reports','Reports','t','','','a:0:{}',6,'View reports, updates, and errors.','left',5,'modules/system/system.admin.inc'),('admin/reports/access-denied','','','user_access','a:1:{i:0;s:19:\"access site reports\";}','dblog_top','a:1:{i:0;s:13:\"access denied\";}','',7,3,0,'','admin/reports/access-denied','Top \'access denied\' errors','t','','','a:0:{}',6,'View \'access denied\' errors (403s).','',0,'modules/dblog/dblog.admin.inc'),('admin/reports/access/%','a:1:{i:3;N;}','','user_access','a:1:{i:0;s:17:\"access statistics\";}','statistics_access_log','a:1:{i:0;i:3;}','',14,4,0,'','admin/reports/access/%','Details','t','','','a:0:{}',6,'View access log.','',0,'modules/statistics/statistics.admin.inc'),('admin/reports/dblog','','','user_access','a:1:{i:0;s:19:\"access site reports\";}','dblog_overview','a:0:{}','',7,3,0,'','admin/reports/dblog','Recent log messages','t','','','a:0:{}',6,'View events that have recently been logged.','',-1,'modules/dblog/dblog.admin.inc'),('admin/reports/event/%','a:1:{i:3;N;}','','user_access','a:1:{i:0;s:19:\"access site reports\";}','dblog_event','a:1:{i:0;i:3;}','',14,4,0,'','admin/reports/event/%','Details','t','','','a:0:{}',6,'','',0,'modules/dblog/dblog.admin.inc'),('admin/reports/fields','','','user_access','a:1:{i:0;s:24:\"administer content types\";}','field_ui_fields_list','a:0:{}','',7,3,0,'','admin/reports/fields','Field list','t','','','a:0:{}',6,'Overview of fields on all entity types.','',0,'modules/field_ui/field_ui.admin.inc'),('admin/reports/fields/list','','','user_access','a:1:{i:0;s:24:\"administer content types\";}','field_ui_fields_list','a:0:{}','',15,4,1,'admin/reports/fields','admin/reports/fields','List','t','','','a:0:{}',140,'','',-10,'modules/field_ui/field_ui.admin.inc'),('admin/reports/fields/views-fields','','','user_access','a:1:{i:0;s:16:\"administer views\";}','views_ui_field_list','a:0:{}','',15,4,1,'admin/reports/fields','admin/reports/fields','Used in views','t','','','a:0:{}',132,'Overview of fields used in all views.','',0,'sites/all/modules/views/includes/admin.inc'),('admin/reports/hits','','','user_access','a:1:{i:0;s:17:\"access statistics\";}','statistics_recent_hits','a:0:{}','',7,3,0,'','admin/reports/hits','Recent hits','t','','','a:0:{}',6,'View pages that have recently been visited.','',0,'modules/statistics/statistics.admin.inc'),('admin/reports/page-not-found','','','user_access','a:1:{i:0;s:19:\"access site reports\";}','dblog_top','a:1:{i:0;s:14:\"page not found\";}','',7,3,0,'','admin/reports/page-not-found','Top \'page not found\' errors','t','','','a:0:{}',6,'View \'page not found\' errors (404s).','',0,'modules/dblog/dblog.admin.inc'),('admin/reports/pages','','','user_access','a:1:{i:0;s:17:\"access statistics\";}','statistics_top_pages','a:0:{}','',7,3,0,'','admin/reports/pages','Top pages','t','','','a:0:{}',6,'View pages that have been hit frequently.','',1,'modules/statistics/statistics.admin.inc'),('admin/reports/referrers','','','user_access','a:1:{i:0;s:17:\"access statistics\";}','statistics_top_referrers','a:0:{}','',7,3,0,'','admin/reports/referrers','Top referrers','t','','','a:0:{}',6,'View top referrers.','',0,'modules/statistics/statistics.admin.inc'),('admin/reports/search','','','user_access','a:1:{i:0;s:19:\"access site reports\";}','dblog_top','a:1:{i:0;s:6:\"search\";}','',7,3,0,'','admin/reports/search','Top search phrases','t','','','a:0:{}',6,'View most popular search phrases.','',0,'modules/dblog/dblog.admin.inc'),('admin/reports/status','','','user_access','a:1:{i:0;s:29:\"administer site configuration\";}','system_status','a:0:{}','',7,3,0,'','admin/reports/status','Status report','t','','','a:0:{}',6,'Get a status report about your site\'s operation and any detected problems.','',-60,'modules/system/system.admin.inc'),('admin/reports/status/php','','','user_access','a:1:{i:0;s:29:\"administer site configuration\";}','system_php','a:0:{}','',15,4,0,'','admin/reports/status/php','PHP','t','','','a:0:{}',0,'','',0,'modules/system/system.admin.inc'),('admin/reports/status/rebuild','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','drupal_get_form','a:1:{i:0;s:30:\"node_configure_rebuild_confirm\";}','',15,4,0,'','admin/reports/status/rebuild','Rebuild permissions','t','','','a:0:{}',0,'','',0,'modules/node/node.admin.inc'),('admin/reports/status/run-cron','','','user_access','a:1:{i:0;s:29:\"administer site configuration\";}','system_run_cron','a:0:{}','',15,4,0,'','admin/reports/status/run-cron','Run cron','t','','','a:0:{}',0,'','',0,'modules/system/system.admin.inc'),('admin/reports/updates','','','user_access','a:1:{i:0;s:29:\"administer site configuration\";}','module_filter_update_status','a:0:{}','',7,3,0,'','admin/reports/updates','Available updates','t','','','a:0:{}',6,'Get a status report about available updates for your installed modules and themes.','',-50,'sites/all/modules/module_filter/module_filter.pages.inc'),('admin/reports/updates/check','','','user_access','a:1:{i:0;s:29:\"administer site configuration\";}','update_manual_status','a:0:{}','',15,4,0,'','admin/reports/updates/check','Manual update check','t','','','a:0:{}',0,'','',0,'modules/update/update.fetch.inc'),('admin/reports/updates/install','','','update_manager_access','a:0:{}','drupal_get_form','a:2:{i:0;s:27:\"update_manager_install_form\";i:1;s:6:\"report\";}','',15,4,1,'admin/reports/updates','admin/reports/updates','Install new module or theme','t','','','a:0:{}',388,'','',25,'modules/update/update.manager.inc'),('admin/reports/updates/list','','','user_access','a:1:{i:0;s:29:\"administer site configuration\";}','module_filter_update_status','a:0:{}','',15,4,1,'admin/reports/updates','admin/reports/updates','List','t','','','a:0:{}',140,'','',0,'sites/all/modules/module_filter/module_filter.pages.inc'),('admin/reports/updates/settings','','','user_access','a:1:{i:0;s:29:\"administer site configuration\";}','drupal_get_form','a:1:{i:0;s:15:\"update_settings\";}','',15,4,1,'admin/reports/updates','admin/reports/updates','Settings','t','','','a:0:{}',132,'','',50,'modules/update/update.settings.inc'),('admin/reports/updates/update','','','update_manager_access','a:0:{}','drupal_get_form','a:2:{i:0;s:26:\"update_manager_update_form\";i:1;s:6:\"report\";}','',15,4,1,'admin/reports/updates','admin/reports/updates','Update','t','','','a:0:{}',132,'','',10,'modules/update/update.manager.inc'),('admin/reports/views-plugins','','','user_access','a:1:{i:0;s:16:\"administer views\";}','views_ui_plugin_list','a:0:{}','',7,3,0,'','admin/reports/views-plugins','Views plugins','t','','','a:0:{}',6,'Overview of plugins used in all views.','',0,'sites/all/modules/views/includes/admin.inc'),('admin/reports/visitors','','','user_access','a:1:{i:0;s:17:\"access statistics\";}','statistics_top_visitors','a:0:{}','',7,3,0,'','admin/reports/visitors','Top visitors','t','','','a:0:{}',6,'View visitors that hit many pages.','',2,'modules/statistics/statistics.admin.inc'),('admin/structure','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','system_admin_menu_block_page','a:0:{}','',3,2,0,'','admin/structure','Structure','t','','','a:0:{}',6,'Administer blocks, content types, menus, etc.','right',-8,'modules/system/system.admin.inc'),('admin/structure/block','','','user_access','a:1:{i:0;s:17:\"administer blocks\";}','block_admin_display','a:1:{i:0;s:10:\"forum_plus\";}','',7,3,0,'','admin/structure/block','Blocks','t','','','a:0:{}',6,'Configure what block content appears in your site\'s sidebars and other regions.','',0,'modules/block/block.admin.inc'),('admin/structure/block/add','','','user_access','a:1:{i:0;s:17:\"administer blocks\";}','drupal_get_form','a:1:{i:0;s:20:\"block_add_block_form\";}','',15,4,1,'admin/structure/block','admin/structure/block','Add block','t','','','a:0:{}',388,'','',0,'modules/block/block.admin.inc'),('admin/structure/block/demo/bartik','','','_block_themes_access','a:1:{i:0;O:8:\"stdClass\":12:{s:8:\"filename\";s:25:\"themes/bartik/bartik.info\";s:4:\"name\";s:6:\"bartik\";s:4:\"type\";s:5:\"theme\";s:5:\"owner\";s:45:\"themes/engines/phptemplate/phptemplate.engine\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:2:\"-1\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:19:{s:4:\"name\";s:6:\"Bartik\";s:11:\"description\";s:48:\"A flexible, recolorable theme with many regions.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:11:\"stylesheets\";a:2:{s:3:\"all\";a:3:{s:14:\"css/layout.css\";s:28:\"themes/bartik/css/layout.css\";s:13:\"css/style.css\";s:27:\"themes/bartik/css/style.css\";s:14:\"css/colors.css\";s:28:\"themes/bartik/css/colors.css\";}s:5:\"print\";a:1:{s:13:\"css/print.css\";s:27:\"themes/bartik/css/print.css\";}}s:7:\"regions\";a:20:{s:6:\"header\";s:6:\"Header\";s:4:\"help\";s:4:\"Help\";s:8:\"page_top\";s:8:\"Page top\";s:11:\"page_bottom\";s:11:\"Page bottom\";s:11:\"highlighted\";s:11:\"Highlighted\";s:8:\"featured\";s:8:\"Featured\";s:7:\"content\";s:7:\"Content\";s:13:\"sidebar_first\";s:13:\"Sidebar first\";s:14:\"sidebar_second\";s:14:\"Sidebar second\";s:14:\"triptych_first\";s:14:\"Triptych first\";s:15:\"triptych_middle\";s:15:\"Triptych middle\";s:13:\"triptych_last\";s:13:\"Triptych last\";s:18:\"footer_firstcolumn\";s:19:\"Footer first column\";s:19:\"footer_secondcolumn\";s:20:\"Footer second column\";s:18:\"footer_thirdcolumn\";s:19:\"Footer third column\";s:19:\"footer_fourthcolumn\";s:20:\"Footer fourth column\";s:6:\"footer\";s:6:\"Footer\";s:14:\"dashboard_main\";s:16:\"Dashboard (main)\";s:17:\"dashboard_sidebar\";s:19:\"Dashboard (sidebar)\";s:18:\"dashboard_inactive\";s:20:\"Dashboard (inactive)\";}s:8:\"settings\";a:1:{s:20:\"shortcut_module_link\";s:1:\"0\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:6:\"engine\";s:11:\"phptemplate\";s:8:\"features\";a:9:{i:0;s:4:\"logo\";i:1;s:7:\"favicon\";i:2;s:4:\"name\";i:3;s:6:\"slogan\";i:4;s:17:\"node_user_picture\";i:5;s:20:\"comment_user_picture\";i:6;s:25:\"comment_user_verification\";i:7;s:9:\"main_menu\";i:8;s:14:\"secondary_menu\";}s:10:\"screenshot\";s:28:\"themes/bartik/screenshot.png\";s:3:\"php\";s:5:\"5.2.4\";s:7:\"scripts\";a:0:{}s:5:\"mtime\";i:1498069849;s:15:\"overlay_regions\";a:5:{i:0;s:14:\"dashboard_main\";i:1;s:17:\"dashboard_sidebar\";i:2;s:18:\"dashboard_inactive\";i:3;s:7:\"content\";i:4;s:4:\"help\";}s:14:\"regions_hidden\";a:2:{i:0;s:8:\"page_top\";i:1;s:11:\"page_bottom\";}s:28:\"overlay_supplemental_regions\";a:1:{i:0;s:11:\"page_bottom\";}}s:6:\"prefix\";s:11:\"phptemplate\";s:11:\"stylesheets\";a:2:{s:3:\"all\";a:3:{s:14:\"css/layout.css\";s:28:\"themes/bartik/css/layout.css\";s:13:\"css/style.css\";s:27:\"themes/bartik/css/style.css\";s:14:\"css/colors.css\";s:28:\"themes/bartik/css/colors.css\";}s:5:\"print\";a:1:{s:13:\"css/print.css\";s:27:\"themes/bartik/css/print.css\";}}s:6:\"engine\";s:11:\"phptemplate\";}}','block_admin_demo','a:1:{i:0;s:6:\"bartik\";}','',31,5,0,'','admin/structure/block/demo/bartik','Bartik','t','','_block_custom_theme','a:1:{i:0;s:6:\"bartik\";}',0,'','',0,'modules/block/block.admin.inc'),('admin/structure/block/demo/forum_plus','','','_block_themes_access','a:1:{i:0;O:8:\"stdClass\":13:{s:8:\"filename\";s:43:\"sites/all/themes/forum_plus/forum_plus.info\";s:4:\"name\";s:10:\"forum_plus\";s:4:\"type\";s:5:\"theme\";s:5:\"owner\";s:45:\"themes/engines/phptemplate/phptemplate.engine\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:2:\"-1\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:20:{s:4:\"name\";s:10:\"Forum Plus\";s:11:\"description\";s:23:\"Theme for the Companies\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:6:\"engine\";s:11:\"phptemplate\";s:11:\"stylesheets\";a:1:{s:3:\"all\";a:3:{s:34:\"vendor/bootstrap/css/bootstrap.css\";s:62:\"sites/all/themes/forum_plus/vendor/bootstrap/css/bootstrap.css\";s:40:\"vendor/bootstrap/css/bootstrap-theme.css\";s:68:\"sites/all/themes/forum_plus/vendor/bootstrap/css/bootstrap-theme.css\";s:14:\"css/styles.css\";s:42:\"sites/all/themes/forum_plus/css/styles.css\";}}s:7:\"scripts\";a:8:{s:32:\"vendor/bootstrap/js/bootstrap.js\";s:60:\"sites/all/themes/forum_plus/vendor/bootstrap/js/bootstrap.js\";s:26:\"js/jquery.smooth-scroll.js\";s:54:\"sites/all/themes/forum_plus/js/jquery.smooth-scroll.js\";s:19:\"js/jquery.cookie.js\";s:47:\"sites/all/themes/forum_plus/js/jquery.cookie.js\";s:24:\"js/jquery.matchHeight.js\";s:52:\"sites/all/themes/forum_plus/js/jquery.matchHeight.js\";s:12:\"js/moment.js\";s:40:\"sites/all/themes/forum_plus/js/moment.js\";s:20:\"js/accordion_menu.js\";s:48:\"sites/all/themes/forum_plus/js/accordion_menu.js\";s:13:\"js/weebpal.js\";s:41:\"sites/all/themes/forum_plus/js/weebpal.js\";s:16:\"js/forum_plus.js\";s:44:\"sites/all/themes/forum_plus/js/forum_plus.js\";}s:8:\"features\";a:7:{i:0;s:4:\"logo\";i:1;s:4:\"name\";i:2;s:6:\"slogan\";i:3;s:17:\"node_user_picture\";i:4;s:20:\"comment_user_picture\";i:5;s:25:\"comment_user_verification\";i:6;s:7:\"favicon\";}s:7:\"regions\";a:25:{s:8:\"headline\";s:8:\"Headline\";s:6:\"header\";s:6:\"Header\";s:9:\"main_menu\";s:9:\"Main Menu\";s:9:\"slideshow\";s:9:\"Slideshow\";s:4:\"help\";s:4:\"Help\";s:8:\"page_top\";s:8:\"Page top\";s:11:\"page_bottom\";s:11:\"Page bottom\";s:11:\"highlighted\";s:11:\"Highlighted\";s:8:\"featured\";s:8:\"Featured\";s:7:\"content\";s:7:\"Content\";s:13:\"sidebar_first\";s:13:\"Sidebar first\";s:14:\"sidebar_second\";s:14:\"Sidebar second\";s:7:\"welcome\";s:7:\"Welcome\";s:11:\"panel_first\";s:11:\"Panel First\";s:12:\"panel_second\";s:12:\"Panel Second\";s:11:\"panel_third\";s:11:\"Panel Third\";s:4:\"gmap\";s:4:\"GMap\";s:14:\"panel_footer_1\";s:14:\"Panel Footer 1\";s:14:\"panel_footer_2\";s:14:\"Panel Footer 2\";s:14:\"panel_footer_3\";s:14:\"Panel Footer 3\";s:14:\"panel_footer_4\";s:14:\"Panel Footer 4\";s:6:\"footer\";s:6:\"Footer\";s:14:\"dashboard_main\";s:16:\"Dashboard (main)\";s:17:\"dashboard_sidebar\";s:19:\"Dashboard (sidebar)\";s:18:\"dashboard_inactive\";s:20:\"Dashboard (inactive)\";}s:8:\"settings\";a:7:{s:19:\"sidebar_first_width\";s:1:\"3\";s:20:\"sidebar_second_width\";s:1:\"3\";s:20:\"panel_footer_1_width\";s:1:\"3\";s:20:\"panel_footer_2_width\";s:1:\"3\";s:20:\"panel_footer_3_width\";s:1:\"3\";s:20:\"panel_footer_4_width\";s:1:\"3\";s:20:\"layout_width_default\";s:4:\"1200\";}s:5:\"skins\";a:3:{s:3:\"red\";s:3:\"Red\";s:6:\"yellow\";s:6:\"Yellow\";s:5:\"green\";s:5:\"Green\";}s:7:\"plugins\";a:1:{s:14:\"advanced_forum\";a:1:{s:6:\"styles\";s:23:\"css/advanced_forum/plus\";}}s:11:\"backgrounds\";a:7:{s:4:\"bg-1\";s:12:\"Background 1\";s:4:\"bg-2\";s:12:\"Background 2\";s:4:\"bg-3\";s:12:\"Background 3\";s:4:\"bg-4\";s:12:\"Background 4\";s:4:\"bg-5\";s:12:\"Background 5\";s:4:\"bg-6\";s:12:\"Background 6\";s:4:\"bg-7\";s:12:\"Background 7\";}s:6:\"layout\";a:1:{s:12:\"layout-boxed\";s:12:\"Boxed Layout\";}s:10:\"screenshot\";s:42:\"sites/all/themes/forum_plus/screenshot.png\";s:3:\"php\";s:5:\"5.2.4\";s:5:\"mtime\";i:1499928385;s:15:\"overlay_regions\";a:5:{i:0;s:14:\"dashboard_main\";i:1;s:17:\"dashboard_sidebar\";i:2;s:18:\"dashboard_inactive\";i:3;s:7:\"content\";i:4;s:4:\"help\";}s:14:\"regions_hidden\";a:2:{i:0;s:8:\"page_top\";i:1;s:11:\"page_bottom\";}s:28:\"overlay_supplemental_regions\";a:1:{i:0;s:11:\"page_bottom\";}}s:6:\"prefix\";s:11:\"phptemplate\";s:11:\"stylesheets\";a:1:{s:3:\"all\";a:3:{s:34:\"vendor/bootstrap/css/bootstrap.css\";s:62:\"sites/all/themes/forum_plus/vendor/bootstrap/css/bootstrap.css\";s:40:\"vendor/bootstrap/css/bootstrap-theme.css\";s:68:\"sites/all/themes/forum_plus/vendor/bootstrap/css/bootstrap-theme.css\";s:14:\"css/styles.css\";s:42:\"sites/all/themes/forum_plus/css/styles.css\";}}s:7:\"scripts\";a:8:{s:32:\"vendor/bootstrap/js/bootstrap.js\";s:60:\"sites/all/themes/forum_plus/vendor/bootstrap/js/bootstrap.js\";s:26:\"js/jquery.smooth-scroll.js\";s:54:\"sites/all/themes/forum_plus/js/jquery.smooth-scroll.js\";s:19:\"js/jquery.cookie.js\";s:47:\"sites/all/themes/forum_plus/js/jquery.cookie.js\";s:24:\"js/jquery.matchHeight.js\";s:52:\"sites/all/themes/forum_plus/js/jquery.matchHeight.js\";s:12:\"js/moment.js\";s:40:\"sites/all/themes/forum_plus/js/moment.js\";s:20:\"js/accordion_menu.js\";s:48:\"sites/all/themes/forum_plus/js/accordion_menu.js\";s:13:\"js/weebpal.js\";s:41:\"sites/all/themes/forum_plus/js/weebpal.js\";s:16:\"js/forum_plus.js\";s:44:\"sites/all/themes/forum_plus/js/forum_plus.js\";}s:6:\"engine\";s:11:\"phptemplate\";}}','block_admin_demo','a:1:{i:0;s:10:\"forum_plus\";}','',31,5,0,'','admin/structure/block/demo/forum_plus','Forum Plus','t','','_block_custom_theme','a:1:{i:0;s:10:\"forum_plus\";}',0,'','',0,'modules/block/block.admin.inc'),('admin/structure/block/demo/garland','','','_block_themes_access','a:1:{i:0;O:8:\"stdClass\":12:{s:8:\"filename\";s:27:\"themes/garland/garland.info\";s:4:\"name\";s:7:\"garland\";s:4:\"type\";s:5:\"theme\";s:5:\"owner\";s:45:\"themes/engines/phptemplate/phptemplate.engine\";s:6:\"status\";s:1:\"0\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:2:\"-1\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:19:{s:4:\"name\";s:7:\"Garland\";s:11:\"description\";s:111:\"A multi-column theme which can be configured to modify colors and switch between fixed and fluid width layouts.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:11:\"stylesheets\";a:2:{s:3:\"all\";a:1:{s:9:\"style.css\";s:24:\"themes/garland/style.css\";}s:5:\"print\";a:1:{s:9:\"print.css\";s:24:\"themes/garland/print.css\";}}s:8:\"settings\";a:1:{s:13:\"garland_width\";s:5:\"fluid\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:6:\"engine\";s:11:\"phptemplate\";s:7:\"regions\";a:12:{s:13:\"sidebar_first\";s:12:\"Left sidebar\";s:14:\"sidebar_second\";s:13:\"Right sidebar\";s:7:\"content\";s:7:\"Content\";s:6:\"header\";s:6:\"Header\";s:6:\"footer\";s:6:\"Footer\";s:11:\"highlighted\";s:11:\"Highlighted\";s:4:\"help\";s:4:\"Help\";s:8:\"page_top\";s:8:\"Page top\";s:11:\"page_bottom\";s:11:\"Page bottom\";s:14:\"dashboard_main\";s:16:\"Dashboard (main)\";s:17:\"dashboard_sidebar\";s:19:\"Dashboard (sidebar)\";s:18:\"dashboard_inactive\";s:20:\"Dashboard (inactive)\";}s:8:\"features\";a:9:{i:0;s:4:\"logo\";i:1;s:7:\"favicon\";i:2;s:4:\"name\";i:3;s:6:\"slogan\";i:4;s:17:\"node_user_picture\";i:5;s:20:\"comment_user_picture\";i:6;s:25:\"comment_user_verification\";i:7;s:9:\"main_menu\";i:8;s:14:\"secondary_menu\";}s:10:\"screenshot\";s:29:\"themes/garland/screenshot.png\";s:3:\"php\";s:5:\"5.2.4\";s:7:\"scripts\";a:0:{}s:5:\"mtime\";i:1498069849;s:15:\"overlay_regions\";a:5:{i:0;s:14:\"dashboard_main\";i:1;s:17:\"dashboard_sidebar\";i:2;s:18:\"dashboard_inactive\";i:3;s:7:\"content\";i:4;s:4:\"help\";}s:14:\"regions_hidden\";a:2:{i:0;s:8:\"page_top\";i:1;s:11:\"page_bottom\";}s:28:\"overlay_supplemental_regions\";a:1:{i:0;s:11:\"page_bottom\";}}s:6:\"prefix\";s:11:\"phptemplate\";s:11:\"stylesheets\";a:2:{s:3:\"all\";a:1:{s:9:\"style.css\";s:24:\"themes/garland/style.css\";}s:5:\"print\";a:1:{s:9:\"print.css\";s:24:\"themes/garland/print.css\";}}s:6:\"engine\";s:11:\"phptemplate\";}}','block_admin_demo','a:1:{i:0;s:7:\"garland\";}','',31,5,0,'','admin/structure/block/demo/garland','Garland','t','','_block_custom_theme','a:1:{i:0;s:7:\"garland\";}',0,'','',0,'modules/block/block.admin.inc'),('admin/structure/block/demo/plus','','','_block_themes_access','a:1:{i:0;O:8:\"stdClass\":11:{s:8:\"filename\";s:61:\"sites/all/themes/forum_plus/css/advanced_forum/plus/plus.info\";s:4:\"name\";s:4:\"plus\";s:4:\"type\";s:5:\"theme\";s:5:\"owner\";s:45:\"themes/engines/phptemplate/phptemplate.engine\";s:6:\"status\";s:1:\"0\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:2:\"-1\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:18:{s:4:\"name\";s:4:\"Plus\";s:11:\"description\";s:43:\"Based on the Blue Lagoon colors of Garland.\";s:7:\"version\";s:7:\"7.x-2.3\";s:10:\"base style\";s:5:\"naked\";s:4:\"core\";s:3:\"7.x\";s:7:\"project\";s:14:\"advanced_forum\";s:9:\"datestamp\";s:10:\"1373223651\";s:6:\"engine\";s:11:\"phptemplate\";s:7:\"regions\";a:12:{s:13:\"sidebar_first\";s:12:\"Left sidebar\";s:14:\"sidebar_second\";s:13:\"Right sidebar\";s:7:\"content\";s:7:\"Content\";s:6:\"header\";s:6:\"Header\";s:6:\"footer\";s:6:\"Footer\";s:11:\"highlighted\";s:11:\"Highlighted\";s:4:\"help\";s:4:\"Help\";s:8:\"page_top\";s:8:\"Page top\";s:11:\"page_bottom\";s:11:\"Page bottom\";s:14:\"dashboard_main\";s:16:\"Dashboard (main)\";s:17:\"dashboard_sidebar\";s:19:\"Dashboard (sidebar)\";s:18:\"dashboard_inactive\";s:20:\"Dashboard (inactive)\";}s:8:\"features\";a:9:{i:0;s:4:\"logo\";i:1;s:7:\"favicon\";i:2;s:4:\"name\";i:3;s:6:\"slogan\";i:4;s:17:\"node_user_picture\";i:5;s:20:\"comment_user_picture\";i:6;s:25:\"comment_user_verification\";i:7;s:9:\"main_menu\";i:8;s:14:\"secondary_menu\";}s:10:\"screenshot\";s:66:\"sites/all/themes/forum_plus/css/advanced_forum/plus/screenshot.png\";s:3:\"php\";s:5:\"5.2.4\";s:11:\"stylesheets\";a:0:{}s:7:\"scripts\";a:0:{}s:5:\"mtime\";i:1499928385;s:15:\"overlay_regions\";a:5:{i:0;s:14:\"dashboard_main\";i:1;s:17:\"dashboard_sidebar\";i:2;s:18:\"dashboard_inactive\";i:3;s:7:\"content\";i:4;s:4:\"help\";}s:14:\"regions_hidden\";a:2:{i:0;s:8:\"page_top\";i:1;s:11:\"page_bottom\";}s:28:\"overlay_supplemental_regions\";a:1:{i:0;s:11:\"page_bottom\";}}s:6:\"prefix\";s:11:\"phptemplate\";s:6:\"engine\";s:11:\"phptemplate\";}}','block_admin_demo','a:1:{i:0;s:4:\"plus\";}','',31,5,0,'','admin/structure/block/demo/plus','Plus','t','','_block_custom_theme','a:1:{i:0;s:4:\"plus\";}',0,'','',0,'modules/block/block.admin.inc'),('admin/structure/block/demo/seven','','','_block_themes_access','a:1:{i:0;O:8:\"stdClass\":12:{s:8:\"filename\";s:23:\"themes/seven/seven.info\";s:4:\"name\";s:5:\"seven\";s:4:\"type\";s:5:\"theme\";s:5:\"owner\";s:45:\"themes/engines/phptemplate/phptemplate.engine\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:2:\"-1\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:19:{s:4:\"name\";s:5:\"Seven\";s:11:\"description\";s:65:\"A simple one-column, tableless, fluid width administration theme.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:11:\"stylesheets\";a:1:{s:6:\"screen\";a:2:{s:9:\"reset.css\";s:22:\"themes/seven/reset.css\";s:9:\"style.css\";s:22:\"themes/seven/style.css\";}}s:8:\"settings\";a:1:{s:20:\"shortcut_module_link\";s:1:\"1\";}s:7:\"regions\";a:8:{s:7:\"content\";s:7:\"Content\";s:4:\"help\";s:4:\"Help\";s:8:\"page_top\";s:8:\"Page top\";s:11:\"page_bottom\";s:11:\"Page bottom\";s:13:\"sidebar_first\";s:13:\"First sidebar\";s:14:\"dashboard_main\";s:16:\"Dashboard (main)\";s:17:\"dashboard_sidebar\";s:19:\"Dashboard (sidebar)\";s:18:\"dashboard_inactive\";s:20:\"Dashboard (inactive)\";}s:14:\"regions_hidden\";a:3:{i:0;s:13:\"sidebar_first\";i:1;s:8:\"page_top\";i:2;s:11:\"page_bottom\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:6:\"engine\";s:11:\"phptemplate\";s:8:\"features\";a:9:{i:0;s:4:\"logo\";i:1;s:7:\"favicon\";i:2;s:4:\"name\";i:3;s:6:\"slogan\";i:4;s:17:\"node_user_picture\";i:5;s:20:\"comment_user_picture\";i:6;s:25:\"comment_user_verification\";i:7;s:9:\"main_menu\";i:8;s:14:\"secondary_menu\";}s:10:\"screenshot\";s:27:\"themes/seven/screenshot.png\";s:3:\"php\";s:5:\"5.2.4\";s:7:\"scripts\";a:0:{}s:5:\"mtime\";i:1498069849;s:15:\"overlay_regions\";a:5:{i:0;s:14:\"dashboard_main\";i:1;s:17:\"dashboard_sidebar\";i:2;s:18:\"dashboard_inactive\";i:3;s:7:\"content\";i:4;s:4:\"help\";}s:28:\"overlay_supplemental_regions\";a:1:{i:0;s:11:\"page_bottom\";}}s:6:\"prefix\";s:11:\"phptemplate\";s:11:\"stylesheets\";a:1:{s:6:\"screen\";a:2:{s:9:\"reset.css\";s:22:\"themes/seven/reset.css\";s:9:\"style.css\";s:22:\"themes/seven/style.css\";}}s:6:\"engine\";s:11:\"phptemplate\";}}','block_admin_demo','a:1:{i:0;s:5:\"seven\";}','',31,5,0,'','admin/structure/block/demo/seven','Seven','t','','_block_custom_theme','a:1:{i:0;s:5:\"seven\";}',0,'','',0,'modules/block/block.admin.inc'),('admin/structure/block/demo/stark','','','_block_themes_access','a:1:{i:0;O:8:\"stdClass\":12:{s:8:\"filename\";s:23:\"themes/stark/stark.info\";s:4:\"name\";s:5:\"stark\";s:4:\"type\";s:5:\"theme\";s:5:\"owner\";s:45:\"themes/engines/phptemplate/phptemplate.engine\";s:6:\"status\";s:1:\"0\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:2:\"-1\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:18:{s:4:\"name\";s:5:\"Stark\";s:11:\"description\";s:208:\"This theme demonstrates Drupal\'s default HTML markup and CSS styles. To learn how to build your own theme and override Drupal\'s default code, see the <a href=\"http://drupal.org/theme-guide\">Theming Guide</a>.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:11:\"stylesheets\";a:1:{s:3:\"all\";a:1:{s:10:\"layout.css\";s:23:\"themes/stark/layout.css\";}}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:6:\"engine\";s:11:\"phptemplate\";s:7:\"regions\";a:12:{s:13:\"sidebar_first\";s:12:\"Left sidebar\";s:14:\"sidebar_second\";s:13:\"Right sidebar\";s:7:\"content\";s:7:\"Content\";s:6:\"header\";s:6:\"Header\";s:6:\"footer\";s:6:\"Footer\";s:11:\"highlighted\";s:11:\"Highlighted\";s:4:\"help\";s:4:\"Help\";s:8:\"page_top\";s:8:\"Page top\";s:11:\"page_bottom\";s:11:\"Page bottom\";s:14:\"dashboard_main\";s:16:\"Dashboard (main)\";s:17:\"dashboard_sidebar\";s:19:\"Dashboard (sidebar)\";s:18:\"dashboard_inactive\";s:20:\"Dashboard (inactive)\";}s:8:\"features\";a:9:{i:0;s:4:\"logo\";i:1;s:7:\"favicon\";i:2;s:4:\"name\";i:3;s:6:\"slogan\";i:4;s:17:\"node_user_picture\";i:5;s:20:\"comment_user_picture\";i:6;s:25:\"comment_user_verification\";i:7;s:9:\"main_menu\";i:8;s:14:\"secondary_menu\";}s:10:\"screenshot\";s:27:\"themes/stark/screenshot.png\";s:3:\"php\";s:5:\"5.2.4\";s:7:\"scripts\";a:0:{}s:5:\"mtime\";i:1498069849;s:15:\"overlay_regions\";a:5:{i:0;s:14:\"dashboard_main\";i:1;s:17:\"dashboard_sidebar\";i:2;s:18:\"dashboard_inactive\";i:3;s:7:\"content\";i:4;s:4:\"help\";}s:14:\"regions_hidden\";a:2:{i:0;s:8:\"page_top\";i:1;s:11:\"page_bottom\";}s:28:\"overlay_supplemental_regions\";a:1:{i:0;s:11:\"page_bottom\";}}s:6:\"prefix\";s:11:\"phptemplate\";s:11:\"stylesheets\";a:1:{s:3:\"all\";a:1:{s:10:\"layout.css\";s:23:\"themes/stark/layout.css\";}}s:6:\"engine\";s:11:\"phptemplate\";}}','block_admin_demo','a:1:{i:0;s:5:\"stark\";}','',31,5,0,'','admin/structure/block/demo/stark','Stark','t','','_block_custom_theme','a:1:{i:0;s:5:\"stark\";}',0,'','',0,'modules/block/block.admin.inc'),('admin/structure/block/demo/we_backend','','','_block_themes_access','a:1:{i:0;O:8:\"stdClass\":13:{s:8:\"filename\";s:43:\"sites/all/themes/we_backend/we_backend.info\";s:4:\"name\";s:10:\"we_backend\";s:4:\"type\";s:5:\"theme\";s:5:\"owner\";s:45:\"themes/engines/phptemplate/phptemplate.engine\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:2:\"-1\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:15:{s:4:\"name\";s:21:\"WeebPal Backend theme\";s:11:\"description\";s:26:\"Backend theme from WeebPal\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:6:\"engine\";s:11:\"phptemplate\";s:11:\"stylesheets\";a:1:{s:3:\"all\";a:1:{s:20:\"assets/css/style.css\";s:48:\"sites/all/themes/we_backend/assets/css/style.css\";}}s:7:\"scripts\";a:1:{s:20:\"assets/js/scripts.js\";s:48:\"sites/all/themes/we_backend/assets/js/scripts.js\";}s:8:\"features\";a:7:{i:0;s:4:\"logo\";i:1;s:4:\"name\";i:2;s:6:\"slogan\";i:3;s:17:\"node_user_picture\";i:4;s:20:\"comment_user_picture\";i:5;s:25:\"comment_user_verification\";i:6;s:7:\"favicon\";}s:7:\"regions\";a:10:{s:6:\"header\";s:6:\"Header\";s:11:\"highlighted\";s:11:\"Highlighted\";s:4:\"help\";s:4:\"Help\";s:7:\"content\";s:7:\"Content\";s:13:\"sidebar_first\";s:13:\"Sidebar first\";s:14:\"sidebar_second\";s:14:\"Sidebar second\";s:6:\"footer\";s:6:\"Footer\";s:14:\"dashboard_main\";s:16:\"Dashboard (main)\";s:17:\"dashboard_sidebar\";s:19:\"Dashboard (sidebar)\";s:18:\"dashboard_inactive\";s:20:\"Dashboard (inactive)\";}s:10:\"screenshot\";s:42:\"sites/all/themes/we_backend/screenshot.png\";s:3:\"php\";s:5:\"5.2.4\";s:5:\"mtime\";i:1499643480;s:15:\"overlay_regions\";a:5:{i:0;s:14:\"dashboard_main\";i:1;s:17:\"dashboard_sidebar\";i:2;s:18:\"dashboard_inactive\";i:3;s:7:\"content\";i:4;s:4:\"help\";}s:14:\"regions_hidden\";a:2:{i:0;s:8:\"page_top\";i:1;s:11:\"page_bottom\";}s:28:\"overlay_supplemental_regions\";a:1:{i:0;s:11:\"page_bottom\";}}s:6:\"prefix\";s:11:\"phptemplate\";s:11:\"stylesheets\";a:1:{s:3:\"all\";a:1:{s:20:\"assets/css/style.css\";s:48:\"sites/all/themes/we_backend/assets/css/style.css\";}}s:7:\"scripts\";a:1:{s:20:\"assets/js/scripts.js\";s:48:\"sites/all/themes/we_backend/assets/js/scripts.js\";}s:6:\"engine\";s:11:\"phptemplate\";}}','block_admin_demo','a:1:{i:0;s:10:\"we_backend\";}','',31,5,0,'','admin/structure/block/demo/we_backend','WeebPal Backend theme','t','','_block_custom_theme','a:1:{i:0;s:10:\"we_backend\";}',0,'','',0,'modules/block/block.admin.inc'),('admin/structure/block/list/bartik','','','_block_themes_access','a:1:{i:0;O:8:\"stdClass\":12:{s:8:\"filename\";s:25:\"themes/bartik/bartik.info\";s:4:\"name\";s:6:\"bartik\";s:4:\"type\";s:5:\"theme\";s:5:\"owner\";s:45:\"themes/engines/phptemplate/phptemplate.engine\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:2:\"-1\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:19:{s:4:\"name\";s:6:\"Bartik\";s:11:\"description\";s:48:\"A flexible, recolorable theme with many regions.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:11:\"stylesheets\";a:2:{s:3:\"all\";a:3:{s:14:\"css/layout.css\";s:28:\"themes/bartik/css/layout.css\";s:13:\"css/style.css\";s:27:\"themes/bartik/css/style.css\";s:14:\"css/colors.css\";s:28:\"themes/bartik/css/colors.css\";}s:5:\"print\";a:1:{s:13:\"css/print.css\";s:27:\"themes/bartik/css/print.css\";}}s:7:\"regions\";a:20:{s:6:\"header\";s:6:\"Header\";s:4:\"help\";s:4:\"Help\";s:8:\"page_top\";s:8:\"Page top\";s:11:\"page_bottom\";s:11:\"Page bottom\";s:11:\"highlighted\";s:11:\"Highlighted\";s:8:\"featured\";s:8:\"Featured\";s:7:\"content\";s:7:\"Content\";s:13:\"sidebar_first\";s:13:\"Sidebar first\";s:14:\"sidebar_second\";s:14:\"Sidebar second\";s:14:\"triptych_first\";s:14:\"Triptych first\";s:15:\"triptych_middle\";s:15:\"Triptych middle\";s:13:\"triptych_last\";s:13:\"Triptych last\";s:18:\"footer_firstcolumn\";s:19:\"Footer first column\";s:19:\"footer_secondcolumn\";s:20:\"Footer second column\";s:18:\"footer_thirdcolumn\";s:19:\"Footer third column\";s:19:\"footer_fourthcolumn\";s:20:\"Footer fourth column\";s:6:\"footer\";s:6:\"Footer\";s:14:\"dashboard_main\";s:16:\"Dashboard (main)\";s:17:\"dashboard_sidebar\";s:19:\"Dashboard (sidebar)\";s:18:\"dashboard_inactive\";s:20:\"Dashboard (inactive)\";}s:8:\"settings\";a:1:{s:20:\"shortcut_module_link\";s:1:\"0\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:6:\"engine\";s:11:\"phptemplate\";s:8:\"features\";a:9:{i:0;s:4:\"logo\";i:1;s:7:\"favicon\";i:2;s:4:\"name\";i:3;s:6:\"slogan\";i:4;s:17:\"node_user_picture\";i:5;s:20:\"comment_user_picture\";i:6;s:25:\"comment_user_verification\";i:7;s:9:\"main_menu\";i:8;s:14:\"secondary_menu\";}s:10:\"screenshot\";s:28:\"themes/bartik/screenshot.png\";s:3:\"php\";s:5:\"5.2.4\";s:7:\"scripts\";a:0:{}s:5:\"mtime\";i:1498069849;s:15:\"overlay_regions\";a:5:{i:0;s:14:\"dashboard_main\";i:1;s:17:\"dashboard_sidebar\";i:2;s:18:\"dashboard_inactive\";i:3;s:7:\"content\";i:4;s:4:\"help\";}s:14:\"regions_hidden\";a:2:{i:0;s:8:\"page_top\";i:1;s:11:\"page_bottom\";}s:28:\"overlay_supplemental_regions\";a:1:{i:0;s:11:\"page_bottom\";}}s:6:\"prefix\";s:11:\"phptemplate\";s:11:\"stylesheets\";a:2:{s:3:\"all\";a:3:{s:14:\"css/layout.css\";s:28:\"themes/bartik/css/layout.css\";s:13:\"css/style.css\";s:27:\"themes/bartik/css/style.css\";s:14:\"css/colors.css\";s:28:\"themes/bartik/css/colors.css\";}s:5:\"print\";a:1:{s:13:\"css/print.css\";s:27:\"themes/bartik/css/print.css\";}}s:6:\"engine\";s:11:\"phptemplate\";}}','block_admin_display','a:1:{i:0;s:6:\"bartik\";}','',31,5,1,'admin/structure/block','admin/structure/block','Bartik','t','','','a:0:{}',132,'','',0,'modules/block/block.admin.inc'),('admin/structure/block/list/bartik/add','','','user_access','a:1:{i:0;s:17:\"administer blocks\";}','drupal_get_form','a:1:{i:0;s:20:\"block_add_block_form\";}','',63,6,1,'admin/structure/block/list/bartik','admin/structure/block','Add block','t','','','a:0:{}',388,'','',0,'modules/block/block.admin.inc'),('admin/structure/block/list/forum_plus','','','_block_themes_access','a:1:{i:0;O:8:\"stdClass\":13:{s:8:\"filename\";s:43:\"sites/all/themes/forum_plus/forum_plus.info\";s:4:\"name\";s:10:\"forum_plus\";s:4:\"type\";s:5:\"theme\";s:5:\"owner\";s:45:\"themes/engines/phptemplate/phptemplate.engine\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:2:\"-1\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:20:{s:4:\"name\";s:10:\"Forum Plus\";s:11:\"description\";s:23:\"Theme for the Companies\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:6:\"engine\";s:11:\"phptemplate\";s:11:\"stylesheets\";a:1:{s:3:\"all\";a:3:{s:34:\"vendor/bootstrap/css/bootstrap.css\";s:62:\"sites/all/themes/forum_plus/vendor/bootstrap/css/bootstrap.css\";s:40:\"vendor/bootstrap/css/bootstrap-theme.css\";s:68:\"sites/all/themes/forum_plus/vendor/bootstrap/css/bootstrap-theme.css\";s:14:\"css/styles.css\";s:42:\"sites/all/themes/forum_plus/css/styles.css\";}}s:7:\"scripts\";a:8:{s:32:\"vendor/bootstrap/js/bootstrap.js\";s:60:\"sites/all/themes/forum_plus/vendor/bootstrap/js/bootstrap.js\";s:26:\"js/jquery.smooth-scroll.js\";s:54:\"sites/all/themes/forum_plus/js/jquery.smooth-scroll.js\";s:19:\"js/jquery.cookie.js\";s:47:\"sites/all/themes/forum_plus/js/jquery.cookie.js\";s:24:\"js/jquery.matchHeight.js\";s:52:\"sites/all/themes/forum_plus/js/jquery.matchHeight.js\";s:12:\"js/moment.js\";s:40:\"sites/all/themes/forum_plus/js/moment.js\";s:20:\"js/accordion_menu.js\";s:48:\"sites/all/themes/forum_plus/js/accordion_menu.js\";s:13:\"js/weebpal.js\";s:41:\"sites/all/themes/forum_plus/js/weebpal.js\";s:16:\"js/forum_plus.js\";s:44:\"sites/all/themes/forum_plus/js/forum_plus.js\";}s:8:\"features\";a:7:{i:0;s:4:\"logo\";i:1;s:4:\"name\";i:2;s:6:\"slogan\";i:3;s:17:\"node_user_picture\";i:4;s:20:\"comment_user_picture\";i:5;s:25:\"comment_user_verification\";i:6;s:7:\"favicon\";}s:7:\"regions\";a:25:{s:8:\"headline\";s:8:\"Headline\";s:6:\"header\";s:6:\"Header\";s:9:\"main_menu\";s:9:\"Main Menu\";s:9:\"slideshow\";s:9:\"Slideshow\";s:4:\"help\";s:4:\"Help\";s:8:\"page_top\";s:8:\"Page top\";s:11:\"page_bottom\";s:11:\"Page bottom\";s:11:\"highlighted\";s:11:\"Highlighted\";s:8:\"featured\";s:8:\"Featured\";s:7:\"content\";s:7:\"Content\";s:13:\"sidebar_first\";s:13:\"Sidebar first\";s:14:\"sidebar_second\";s:14:\"Sidebar second\";s:7:\"welcome\";s:7:\"Welcome\";s:11:\"panel_first\";s:11:\"Panel First\";s:12:\"panel_second\";s:12:\"Panel Second\";s:11:\"panel_third\";s:11:\"Panel Third\";s:4:\"gmap\";s:4:\"GMap\";s:14:\"panel_footer_1\";s:14:\"Panel Footer 1\";s:14:\"panel_footer_2\";s:14:\"Panel Footer 2\";s:14:\"panel_footer_3\";s:14:\"Panel Footer 3\";s:14:\"panel_footer_4\";s:14:\"Panel Footer 4\";s:6:\"footer\";s:6:\"Footer\";s:14:\"dashboard_main\";s:16:\"Dashboard (main)\";s:17:\"dashboard_sidebar\";s:19:\"Dashboard (sidebar)\";s:18:\"dashboard_inactive\";s:20:\"Dashboard (inactive)\";}s:8:\"settings\";a:7:{s:19:\"sidebar_first_width\";s:1:\"3\";s:20:\"sidebar_second_width\";s:1:\"3\";s:20:\"panel_footer_1_width\";s:1:\"3\";s:20:\"panel_footer_2_width\";s:1:\"3\";s:20:\"panel_footer_3_width\";s:1:\"3\";s:20:\"panel_footer_4_width\";s:1:\"3\";s:20:\"layout_width_default\";s:4:\"1200\";}s:5:\"skins\";a:3:{s:3:\"red\";s:3:\"Red\";s:6:\"yellow\";s:6:\"Yellow\";s:5:\"green\";s:5:\"Green\";}s:7:\"plugins\";a:1:{s:14:\"advanced_forum\";a:1:{s:6:\"styles\";s:23:\"css/advanced_forum/plus\";}}s:11:\"backgrounds\";a:7:{s:4:\"bg-1\";s:12:\"Background 1\";s:4:\"bg-2\";s:12:\"Background 2\";s:4:\"bg-3\";s:12:\"Background 3\";s:4:\"bg-4\";s:12:\"Background 4\";s:4:\"bg-5\";s:12:\"Background 5\";s:4:\"bg-6\";s:12:\"Background 6\";s:4:\"bg-7\";s:12:\"Background 7\";}s:6:\"layout\";a:1:{s:12:\"layout-boxed\";s:12:\"Boxed Layout\";}s:10:\"screenshot\";s:42:\"sites/all/themes/forum_plus/screenshot.png\";s:3:\"php\";s:5:\"5.2.4\";s:5:\"mtime\";i:1499928385;s:15:\"overlay_regions\";a:5:{i:0;s:14:\"dashboard_main\";i:1;s:17:\"dashboard_sidebar\";i:2;s:18:\"dashboard_inactive\";i:3;s:7:\"content\";i:4;s:4:\"help\";}s:14:\"regions_hidden\";a:2:{i:0;s:8:\"page_top\";i:1;s:11:\"page_bottom\";}s:28:\"overlay_supplemental_regions\";a:1:{i:0;s:11:\"page_bottom\";}}s:6:\"prefix\";s:11:\"phptemplate\";s:11:\"stylesheets\";a:1:{s:3:\"all\";a:3:{s:34:\"vendor/bootstrap/css/bootstrap.css\";s:62:\"sites/all/themes/forum_plus/vendor/bootstrap/css/bootstrap.css\";s:40:\"vendor/bootstrap/css/bootstrap-theme.css\";s:68:\"sites/all/themes/forum_plus/vendor/bootstrap/css/bootstrap-theme.css\";s:14:\"css/styles.css\";s:42:\"sites/all/themes/forum_plus/css/styles.css\";}}s:7:\"scripts\";a:8:{s:32:\"vendor/bootstrap/js/bootstrap.js\";s:60:\"sites/all/themes/forum_plus/vendor/bootstrap/js/bootstrap.js\";s:26:\"js/jquery.smooth-scroll.js\";s:54:\"sites/all/themes/forum_plus/js/jquery.smooth-scroll.js\";s:19:\"js/jquery.cookie.js\";s:47:\"sites/all/themes/forum_plus/js/jquery.cookie.js\";s:24:\"js/jquery.matchHeight.js\";s:52:\"sites/all/themes/forum_plus/js/jquery.matchHeight.js\";s:12:\"js/moment.js\";s:40:\"sites/all/themes/forum_plus/js/moment.js\";s:20:\"js/accordion_menu.js\";s:48:\"sites/all/themes/forum_plus/js/accordion_menu.js\";s:13:\"js/weebpal.js\";s:41:\"sites/all/themes/forum_plus/js/weebpal.js\";s:16:\"js/forum_plus.js\";s:44:\"sites/all/themes/forum_plus/js/forum_plus.js\";}s:6:\"engine\";s:11:\"phptemplate\";}}','block_admin_display','a:1:{i:0;s:10:\"forum_plus\";}','',31,5,1,'admin/structure/block','admin/structure/block','Forum Plus','t','','','a:0:{}',140,'','',-10,'modules/block/block.admin.inc'),('admin/structure/block/list/garland','','','_block_themes_access','a:1:{i:0;O:8:\"stdClass\":12:{s:8:\"filename\";s:27:\"themes/garland/garland.info\";s:4:\"name\";s:7:\"garland\";s:4:\"type\";s:5:\"theme\";s:5:\"owner\";s:45:\"themes/engines/phptemplate/phptemplate.engine\";s:6:\"status\";s:1:\"0\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:2:\"-1\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:19:{s:4:\"name\";s:7:\"Garland\";s:11:\"description\";s:111:\"A multi-column theme which can be configured to modify colors and switch between fixed and fluid width layouts.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:11:\"stylesheets\";a:2:{s:3:\"all\";a:1:{s:9:\"style.css\";s:24:\"themes/garland/style.css\";}s:5:\"print\";a:1:{s:9:\"print.css\";s:24:\"themes/garland/print.css\";}}s:8:\"settings\";a:1:{s:13:\"garland_width\";s:5:\"fluid\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:6:\"engine\";s:11:\"phptemplate\";s:7:\"regions\";a:12:{s:13:\"sidebar_first\";s:12:\"Left sidebar\";s:14:\"sidebar_second\";s:13:\"Right sidebar\";s:7:\"content\";s:7:\"Content\";s:6:\"header\";s:6:\"Header\";s:6:\"footer\";s:6:\"Footer\";s:11:\"highlighted\";s:11:\"Highlighted\";s:4:\"help\";s:4:\"Help\";s:8:\"page_top\";s:8:\"Page top\";s:11:\"page_bottom\";s:11:\"Page bottom\";s:14:\"dashboard_main\";s:16:\"Dashboard (main)\";s:17:\"dashboard_sidebar\";s:19:\"Dashboard (sidebar)\";s:18:\"dashboard_inactive\";s:20:\"Dashboard (inactive)\";}s:8:\"features\";a:9:{i:0;s:4:\"logo\";i:1;s:7:\"favicon\";i:2;s:4:\"name\";i:3;s:6:\"slogan\";i:4;s:17:\"node_user_picture\";i:5;s:20:\"comment_user_picture\";i:6;s:25:\"comment_user_verification\";i:7;s:9:\"main_menu\";i:8;s:14:\"secondary_menu\";}s:10:\"screenshot\";s:29:\"themes/garland/screenshot.png\";s:3:\"php\";s:5:\"5.2.4\";s:7:\"scripts\";a:0:{}s:5:\"mtime\";i:1498069849;s:15:\"overlay_regions\";a:5:{i:0;s:14:\"dashboard_main\";i:1;s:17:\"dashboard_sidebar\";i:2;s:18:\"dashboard_inactive\";i:3;s:7:\"content\";i:4;s:4:\"help\";}s:14:\"regions_hidden\";a:2:{i:0;s:8:\"page_top\";i:1;s:11:\"page_bottom\";}s:28:\"overlay_supplemental_regions\";a:1:{i:0;s:11:\"page_bottom\";}}s:6:\"prefix\";s:11:\"phptemplate\";s:11:\"stylesheets\";a:2:{s:3:\"all\";a:1:{s:9:\"style.css\";s:24:\"themes/garland/style.css\";}s:5:\"print\";a:1:{s:9:\"print.css\";s:24:\"themes/garland/print.css\";}}s:6:\"engine\";s:11:\"phptemplate\";}}','block_admin_display','a:1:{i:0;s:7:\"garland\";}','',31,5,1,'admin/structure/block','admin/structure/block','Garland','t','','','a:0:{}',132,'','',0,'modules/block/block.admin.inc'),('admin/structure/block/list/garland/add','','','user_access','a:1:{i:0;s:17:\"administer blocks\";}','drupal_get_form','a:1:{i:0;s:20:\"block_add_block_form\";}','',63,6,1,'admin/structure/block/list/garland','admin/structure/block','Add block','t','','','a:0:{}',388,'','',0,'modules/block/block.admin.inc'),('admin/structure/block/list/plus','','','_block_themes_access','a:1:{i:0;O:8:\"stdClass\":11:{s:8:\"filename\";s:61:\"sites/all/themes/forum_plus/css/advanced_forum/plus/plus.info\";s:4:\"name\";s:4:\"plus\";s:4:\"type\";s:5:\"theme\";s:5:\"owner\";s:45:\"themes/engines/phptemplate/phptemplate.engine\";s:6:\"status\";s:1:\"0\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:2:\"-1\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:18:{s:4:\"name\";s:4:\"Plus\";s:11:\"description\";s:43:\"Based on the Blue Lagoon colors of Garland.\";s:7:\"version\";s:7:\"7.x-2.3\";s:10:\"base style\";s:5:\"naked\";s:4:\"core\";s:3:\"7.x\";s:7:\"project\";s:14:\"advanced_forum\";s:9:\"datestamp\";s:10:\"1373223651\";s:6:\"engine\";s:11:\"phptemplate\";s:7:\"regions\";a:12:{s:13:\"sidebar_first\";s:12:\"Left sidebar\";s:14:\"sidebar_second\";s:13:\"Right sidebar\";s:7:\"content\";s:7:\"Content\";s:6:\"header\";s:6:\"Header\";s:6:\"footer\";s:6:\"Footer\";s:11:\"highlighted\";s:11:\"Highlighted\";s:4:\"help\";s:4:\"Help\";s:8:\"page_top\";s:8:\"Page top\";s:11:\"page_bottom\";s:11:\"Page bottom\";s:14:\"dashboard_main\";s:16:\"Dashboard (main)\";s:17:\"dashboard_sidebar\";s:19:\"Dashboard (sidebar)\";s:18:\"dashboard_inactive\";s:20:\"Dashboard (inactive)\";}s:8:\"features\";a:9:{i:0;s:4:\"logo\";i:1;s:7:\"favicon\";i:2;s:4:\"name\";i:3;s:6:\"slogan\";i:4;s:17:\"node_user_picture\";i:5;s:20:\"comment_user_picture\";i:6;s:25:\"comment_user_verification\";i:7;s:9:\"main_menu\";i:8;s:14:\"secondary_menu\";}s:10:\"screenshot\";s:66:\"sites/all/themes/forum_plus/css/advanced_forum/plus/screenshot.png\";s:3:\"php\";s:5:\"5.2.4\";s:11:\"stylesheets\";a:0:{}s:7:\"scripts\";a:0:{}s:5:\"mtime\";i:1499928385;s:15:\"overlay_regions\";a:5:{i:0;s:14:\"dashboard_main\";i:1;s:17:\"dashboard_sidebar\";i:2;s:18:\"dashboard_inactive\";i:3;s:7:\"content\";i:4;s:4:\"help\";}s:14:\"regions_hidden\";a:2:{i:0;s:8:\"page_top\";i:1;s:11:\"page_bottom\";}s:28:\"overlay_supplemental_regions\";a:1:{i:0;s:11:\"page_bottom\";}}s:6:\"prefix\";s:11:\"phptemplate\";s:6:\"engine\";s:11:\"phptemplate\";}}','block_admin_display','a:1:{i:0;s:4:\"plus\";}','',31,5,1,'admin/structure/block','admin/structure/block','Plus','t','','','a:0:{}',132,'','',0,'modules/block/block.admin.inc'),('admin/structure/block/list/plus/add','','','user_access','a:1:{i:0;s:17:\"administer blocks\";}','drupal_get_form','a:1:{i:0;s:20:\"block_add_block_form\";}','',63,6,1,'admin/structure/block/list/plus','admin/structure/block','Add block','t','','','a:0:{}',388,'','',0,'modules/block/block.admin.inc'),('admin/structure/block/list/seven','','','_block_themes_access','a:1:{i:0;O:8:\"stdClass\":12:{s:8:\"filename\";s:23:\"themes/seven/seven.info\";s:4:\"name\";s:5:\"seven\";s:4:\"type\";s:5:\"theme\";s:5:\"owner\";s:45:\"themes/engines/phptemplate/phptemplate.engine\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:2:\"-1\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:19:{s:4:\"name\";s:5:\"Seven\";s:11:\"description\";s:65:\"A simple one-column, tableless, fluid width administration theme.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:11:\"stylesheets\";a:1:{s:6:\"screen\";a:2:{s:9:\"reset.css\";s:22:\"themes/seven/reset.css\";s:9:\"style.css\";s:22:\"themes/seven/style.css\";}}s:8:\"settings\";a:1:{s:20:\"shortcut_module_link\";s:1:\"1\";}s:7:\"regions\";a:8:{s:7:\"content\";s:7:\"Content\";s:4:\"help\";s:4:\"Help\";s:8:\"page_top\";s:8:\"Page top\";s:11:\"page_bottom\";s:11:\"Page bottom\";s:13:\"sidebar_first\";s:13:\"First sidebar\";s:14:\"dashboard_main\";s:16:\"Dashboard (main)\";s:17:\"dashboard_sidebar\";s:19:\"Dashboard (sidebar)\";s:18:\"dashboard_inactive\";s:20:\"Dashboard (inactive)\";}s:14:\"regions_hidden\";a:3:{i:0;s:13:\"sidebar_first\";i:1;s:8:\"page_top\";i:2;s:11:\"page_bottom\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:6:\"engine\";s:11:\"phptemplate\";s:8:\"features\";a:9:{i:0;s:4:\"logo\";i:1;s:7:\"favicon\";i:2;s:4:\"name\";i:3;s:6:\"slogan\";i:4;s:17:\"node_user_picture\";i:5;s:20:\"comment_user_picture\";i:6;s:25:\"comment_user_verification\";i:7;s:9:\"main_menu\";i:8;s:14:\"secondary_menu\";}s:10:\"screenshot\";s:27:\"themes/seven/screenshot.png\";s:3:\"php\";s:5:\"5.2.4\";s:7:\"scripts\";a:0:{}s:5:\"mtime\";i:1498069849;s:15:\"overlay_regions\";a:5:{i:0;s:14:\"dashboard_main\";i:1;s:17:\"dashboard_sidebar\";i:2;s:18:\"dashboard_inactive\";i:3;s:7:\"content\";i:4;s:4:\"help\";}s:28:\"overlay_supplemental_regions\";a:1:{i:0;s:11:\"page_bottom\";}}s:6:\"prefix\";s:11:\"phptemplate\";s:11:\"stylesheets\";a:1:{s:6:\"screen\";a:2:{s:9:\"reset.css\";s:22:\"themes/seven/reset.css\";s:9:\"style.css\";s:22:\"themes/seven/style.css\";}}s:6:\"engine\";s:11:\"phptemplate\";}}','block_admin_display','a:1:{i:0;s:5:\"seven\";}','',31,5,1,'admin/structure/block','admin/structure/block','Seven','t','','','a:0:{}',132,'','',0,'modules/block/block.admin.inc'),('admin/structure/block/list/seven/add','','','user_access','a:1:{i:0;s:17:\"administer blocks\";}','drupal_get_form','a:1:{i:0;s:20:\"block_add_block_form\";}','',63,6,1,'admin/structure/block/list/seven','admin/structure/block','Add block','t','','','a:0:{}',388,'','',0,'modules/block/block.admin.inc'),('admin/structure/block/list/stark','','','_block_themes_access','a:1:{i:0;O:8:\"stdClass\":12:{s:8:\"filename\";s:23:\"themes/stark/stark.info\";s:4:\"name\";s:5:\"stark\";s:4:\"type\";s:5:\"theme\";s:5:\"owner\";s:45:\"themes/engines/phptemplate/phptemplate.engine\";s:6:\"status\";s:1:\"0\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:2:\"-1\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:18:{s:4:\"name\";s:5:\"Stark\";s:11:\"description\";s:208:\"This theme demonstrates Drupal\'s default HTML markup and CSS styles. To learn how to build your own theme and override Drupal\'s default code, see the <a href=\"http://drupal.org/theme-guide\">Theming Guide</a>.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:11:\"stylesheets\";a:1:{s:3:\"all\";a:1:{s:10:\"layout.css\";s:23:\"themes/stark/layout.css\";}}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:6:\"engine\";s:11:\"phptemplate\";s:7:\"regions\";a:12:{s:13:\"sidebar_first\";s:12:\"Left sidebar\";s:14:\"sidebar_second\";s:13:\"Right sidebar\";s:7:\"content\";s:7:\"Content\";s:6:\"header\";s:6:\"Header\";s:6:\"footer\";s:6:\"Footer\";s:11:\"highlighted\";s:11:\"Highlighted\";s:4:\"help\";s:4:\"Help\";s:8:\"page_top\";s:8:\"Page top\";s:11:\"page_bottom\";s:11:\"Page bottom\";s:14:\"dashboard_main\";s:16:\"Dashboard (main)\";s:17:\"dashboard_sidebar\";s:19:\"Dashboard (sidebar)\";s:18:\"dashboard_inactive\";s:20:\"Dashboard (inactive)\";}s:8:\"features\";a:9:{i:0;s:4:\"logo\";i:1;s:7:\"favicon\";i:2;s:4:\"name\";i:3;s:6:\"slogan\";i:4;s:17:\"node_user_picture\";i:5;s:20:\"comment_user_picture\";i:6;s:25:\"comment_user_verification\";i:7;s:9:\"main_menu\";i:8;s:14:\"secondary_menu\";}s:10:\"screenshot\";s:27:\"themes/stark/screenshot.png\";s:3:\"php\";s:5:\"5.2.4\";s:7:\"scripts\";a:0:{}s:5:\"mtime\";i:1498069849;s:15:\"overlay_regions\";a:5:{i:0;s:14:\"dashboard_main\";i:1;s:17:\"dashboard_sidebar\";i:2;s:18:\"dashboard_inactive\";i:3;s:7:\"content\";i:4;s:4:\"help\";}s:14:\"regions_hidden\";a:2:{i:0;s:8:\"page_top\";i:1;s:11:\"page_bottom\";}s:28:\"overlay_supplemental_regions\";a:1:{i:0;s:11:\"page_bottom\";}}s:6:\"prefix\";s:11:\"phptemplate\";s:11:\"stylesheets\";a:1:{s:3:\"all\";a:1:{s:10:\"layout.css\";s:23:\"themes/stark/layout.css\";}}s:6:\"engine\";s:11:\"phptemplate\";}}','block_admin_display','a:1:{i:0;s:5:\"stark\";}','',31,5,1,'admin/structure/block','admin/structure/block','Stark','t','','','a:0:{}',132,'','',0,'modules/block/block.admin.inc'),('admin/structure/block/list/stark/add','','','user_access','a:1:{i:0;s:17:\"administer blocks\";}','drupal_get_form','a:1:{i:0;s:20:\"block_add_block_form\";}','',63,6,1,'admin/structure/block/list/stark','admin/structure/block','Add block','t','','','a:0:{}',388,'','',0,'modules/block/block.admin.inc'),('admin/structure/block/list/we_backend','','','_block_themes_access','a:1:{i:0;O:8:\"stdClass\":13:{s:8:\"filename\";s:43:\"sites/all/themes/we_backend/we_backend.info\";s:4:\"name\";s:10:\"we_backend\";s:4:\"type\";s:5:\"theme\";s:5:\"owner\";s:45:\"themes/engines/phptemplate/phptemplate.engine\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:2:\"-1\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:15:{s:4:\"name\";s:21:\"WeebPal Backend theme\";s:11:\"description\";s:26:\"Backend theme from WeebPal\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:6:\"engine\";s:11:\"phptemplate\";s:11:\"stylesheets\";a:1:{s:3:\"all\";a:1:{s:20:\"assets/css/style.css\";s:48:\"sites/all/themes/we_backend/assets/css/style.css\";}}s:7:\"scripts\";a:1:{s:20:\"assets/js/scripts.js\";s:48:\"sites/all/themes/we_backend/assets/js/scripts.js\";}s:8:\"features\";a:7:{i:0;s:4:\"logo\";i:1;s:4:\"name\";i:2;s:6:\"slogan\";i:3;s:17:\"node_user_picture\";i:4;s:20:\"comment_user_picture\";i:5;s:25:\"comment_user_verification\";i:6;s:7:\"favicon\";}s:7:\"regions\";a:10:{s:6:\"header\";s:6:\"Header\";s:11:\"highlighted\";s:11:\"Highlighted\";s:4:\"help\";s:4:\"Help\";s:7:\"content\";s:7:\"Content\";s:13:\"sidebar_first\";s:13:\"Sidebar first\";s:14:\"sidebar_second\";s:14:\"Sidebar second\";s:6:\"footer\";s:6:\"Footer\";s:14:\"dashboard_main\";s:16:\"Dashboard (main)\";s:17:\"dashboard_sidebar\";s:19:\"Dashboard (sidebar)\";s:18:\"dashboard_inactive\";s:20:\"Dashboard (inactive)\";}s:10:\"screenshot\";s:42:\"sites/all/themes/we_backend/screenshot.png\";s:3:\"php\";s:5:\"5.2.4\";s:5:\"mtime\";i:1499643480;s:15:\"overlay_regions\";a:5:{i:0;s:14:\"dashboard_main\";i:1;s:17:\"dashboard_sidebar\";i:2;s:18:\"dashboard_inactive\";i:3;s:7:\"content\";i:4;s:4:\"help\";}s:14:\"regions_hidden\";a:2:{i:0;s:8:\"page_top\";i:1;s:11:\"page_bottom\";}s:28:\"overlay_supplemental_regions\";a:1:{i:0;s:11:\"page_bottom\";}}s:6:\"prefix\";s:11:\"phptemplate\";s:11:\"stylesheets\";a:1:{s:3:\"all\";a:1:{s:20:\"assets/css/style.css\";s:48:\"sites/all/themes/we_backend/assets/css/style.css\";}}s:7:\"scripts\";a:1:{s:20:\"assets/js/scripts.js\";s:48:\"sites/all/themes/we_backend/assets/js/scripts.js\";}s:6:\"engine\";s:11:\"phptemplate\";}}','block_admin_display','a:1:{i:0;s:10:\"we_backend\";}','',31,5,1,'admin/structure/block','admin/structure/block','WeebPal Backend theme','t','','','a:0:{}',132,'','',0,'modules/block/block.admin.inc'),('admin/structure/block/list/we_backend/add','','','user_access','a:1:{i:0;s:17:\"administer blocks\";}','drupal_get_form','a:1:{i:0;s:20:\"block_add_block_form\";}','',63,6,1,'admin/structure/block/list/we_backend','admin/structure/block','Add block','t','','','a:0:{}',388,'','',0,'modules/block/block.admin.inc'),('admin/structure/block/manage/%/%','a:2:{i:4;N;i:5;N;}','','user_access','a:1:{i:0;s:17:\"administer blocks\";}','drupal_get_form','a:3:{i:0;s:21:\"block_admin_configure\";i:1;i:4;i:2;i:5;}','',60,6,0,'','admin/structure/block/manage/%/%','Configure block','t','','','a:0:{}',6,'','',0,'modules/block/block.admin.inc'),('admin/structure/block/manage/%/%/configure','a:2:{i:4;N;i:5;N;}','','user_access','a:1:{i:0;s:17:\"administer blocks\";}','drupal_get_form','a:3:{i:0;s:21:\"block_admin_configure\";i:1;i:4;i:2;i:5;}','',121,7,3,'admin/structure/block/manage/%/%','admin/structure/block/manage/%/%','Configure','t','','','a:0:{}',140,'','',-100,'modules/block/block.admin.inc'),('admin/structure/block/manage/%/%/delete','a:2:{i:4;N;i:5;N;}','','user_access','a:1:{i:0;s:17:\"administer blocks\";}','drupal_get_form','a:3:{i:0;s:25:\"block_custom_block_delete\";i:1;i:4;i:2;i:5;}','',121,7,0,'','admin/structure/block/manage/%/%/delete','Delete block','t','','','a:0:{}',0,'','',0,'modules/block/block.admin.inc'),('admin/structure/block/manage/%/%/translate','a:2:{i:4;N;i:5;N;}','','i18n_block_translate_tab_access','a:2:{i:0;i:4;i:1;i:5;}','i18n_block_translate_tab_page','a:2:{i:0;i:4;i:1;i:5;}','',121,7,3,'admin/structure/block/manage/%/%','admin/structure/block/manage/%/%','Translate','t','','','a:0:{}',132,'','',10,''),('admin/structure/block/manage/%/%/translate/%','a:3:{i:4;N;i:5;N;i:7;s:18:\"i18n_language_load\";}','','i18n_block_translate_tab_access','a:2:{i:0;i:4;i:1;i:5;}','i18n_block_translate_tab_page','a:3:{i:0;i:4;i:1;i:5;i:2;i:7;}','',242,8,0,'','admin/structure/block/manage/%/%/translate/%','Translate','t','','','a:0:{}',0,'','',10,''),('admin/structure/contact','','','user_access','a:1:{i:0;s:24:\"administer contact forms\";}','contact_category_list','a:0:{}','',7,3,0,'','admin/structure/contact','Contact form','t','','','a:0:{}',6,'Create a system contact form and set up categories for the form to use.','',0,'modules/contact/contact.admin.inc'),('admin/structure/contact/add','','','user_access','a:1:{i:0;s:24:\"administer contact forms\";}','drupal_get_form','a:1:{i:0;s:26:\"contact_category_edit_form\";}','',15,4,1,'admin/structure/contact','admin/structure/contact','Add category','t','','','a:0:{}',388,'','',1,'modules/contact/contact.admin.inc'),('admin/structure/contact/delete/%','a:1:{i:4;s:12:\"contact_load\";}','','user_access','a:1:{i:0;s:24:\"administer contact forms\";}','drupal_get_form','a:2:{i:0;s:28:\"contact_category_delete_form\";i:1;i:4;}','',30,5,0,'','admin/structure/contact/delete/%','Delete contact','t','','','a:0:{}',6,'','',0,'modules/contact/contact.admin.inc'),('admin/structure/contact/edit/%','a:1:{i:4;s:12:\"contact_load\";}','','user_access','a:1:{i:0;s:24:\"administer contact forms\";}','drupal_get_form','a:2:{i:0;s:26:\"contact_category_edit_form\";i:1;i:4;}','',30,5,0,'','admin/structure/contact/edit/%','Edit contact category','t','','','a:0:{}',6,'','',0,'modules/contact/contact.admin.inc'),('admin/structure/features','','','user_access','a:1:{i:0;s:15:\"manage features\";}','drupal_get_form','a:1:{i:0;s:19:\"features_admin_form\";}','',7,3,0,'','admin/structure/features','Features','t','','','a:0:{}',6,'Manage features.','',0,'sites/all/modules/features/features.admin.inc'),('admin/structure/features/%','a:1:{i:3;a:1:{s:12:\"feature_load\";a:1:{i:0;b:1;}}}','','user_access','a:1:{i:0;s:19:\"administer features\";}','drupal_get_form','a:2:{i:0;s:25:\"features_admin_components\";i:1;i:3;}','',14,4,0,'','admin/structure/features/%','','features_get_feature_title','a:1:{i:0;i:3;}','','a:0:{}',0,'Display components of a feature.','',0,'sites/all/modules/features/features.admin.inc'),('admin/structure/features/%/lock','a:1:{i:3;a:1:{s:12:\"feature_load\";a:1:{i:0;b:1;}}}','','user_access','a:1:{i:0;s:15:\"manage features\";}','features_admin_lock','a:3:{i:0;i:3;i:1;i:5;i:2;i:6;}','',29,5,0,'','admin/structure/features/%/lock','Lock','t','','','a:0:{}',0,'Lock a feature or components.','',0,'sites/all/modules/features/features.admin.inc'),('admin/structure/features/%/recreate','a:1:{i:3;a:1:{s:12:\"feature_load\";a:1:{i:0;b:1;}}}','','user_access','a:1:{i:0;s:19:\"administer features\";}','drupal_get_form','a:2:{i:0;s:20:\"features_export_form\";i:1;i:3;}','',29,5,1,'admin/structure/features/%','admin/structure/features/%','Recreate','t','','','a:0:{}',132,'Recreate an existing feature.','',11,'sites/all/modules/features/features.admin.inc'),('admin/structure/features/%/status','a:1:{i:3;a:1:{s:12:\"feature_load\";a:1:{i:0;b:1;}}}','','user_access','a:1:{i:0;s:19:\"administer features\";}','features_feature_status','a:1:{i:0;i:3;}','',29,5,0,'','admin/structure/features/%/status','Status','t','','','a:0:{}',0,'Javascript status call back.','',0,'sites/all/modules/features/features.admin.inc'),('admin/structure/features/%/view','a:1:{i:3;a:1:{s:12:\"feature_load\";a:1:{i:0;b:1;}}}','','user_access','a:1:{i:0;s:19:\"administer features\";}','drupal_get_form','a:2:{i:0;s:25:\"features_admin_components\";i:1;i:3;}','',29,5,1,'admin/structure/features/%','admin/structure/features/%','View','t','','','a:0:{}',140,'Display components of a feature.','',-10,'sites/all/modules/features/features.admin.inc'),('admin/structure/features/cleanup','','','user_access','a:1:{i:0;s:15:\"manage features\";}','features_cleanup','a:0:{}','',15,4,0,'','admin/structure/features/cleanup','Cleanup','t','','','a:0:{}',0,'Clear cache after enabling/disabling a feature.','',1,'sites/all/modules/features/features.admin.inc'),('admin/structure/features/create','','','user_access','a:1:{i:0;s:19:\"administer features\";}','drupal_get_form','a:1:{i:0;s:20:\"features_export_form\";}','',15,4,1,'admin/structure/features','admin/structure/features','Create feature','t','','','a:0:{}',132,'Create a new feature.','',10,'sites/all/modules/features/features.admin.inc'),('admin/structure/features/manage','','','user_access','a:1:{i:0;s:15:\"manage features\";}','drupal_get_form','a:1:{i:0;s:19:\"features_admin_form\";}','',15,4,1,'admin/structure/features','admin/structure/features','Manage','t','','','a:0:{}',140,'Enable and disable features.','',0,'sites/all/modules/features/features.admin.inc'),('admin/structure/features/settings','','','user_access','a:1:{i:0;s:19:\"administer features\";}','drupal_get_form','a:1:{i:0;s:22:\"features_settings_form\";}','',15,4,1,'admin/structure/features','admin/structure/features','Settings','t','','','a:0:{}',132,'Adjust settings for using features module.','',11,'sites/all/modules/features/features.admin.inc'),('admin/structure/field-collections','','','user_access','a:1:{i:0;s:28:\"administer field collections\";}','field_collections_overview','a:0:{}','',7,3,0,'','admin/structure/field-collections','Field collections','t','','','a:0:{}',6,'Manage fields on field collections.','',0,'sites/all/modules/field_collection/field_collection.admin.inc'),('admin/structure/field-collections/%','a:1:{i:3;s:32:\"field_collection_field_name_load\";}','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:28:\"administer field collections\";}}','drupal_get_form','a:3:{i:0;s:28:\"field_ui_field_overview_form\";i:1;s:21:\"field_collection_item\";i:2;i:3;}','',14,4,0,'','admin/structure/field-collections/%','Manage fields','field_collection_admin_page_title','a:1:{i:0;i:3;}','','a:0:{}',6,'','',1,'modules/field_ui/field_ui.admin.inc'),('admin/structure/field-collections/%/display','a:1:{i:3;s:32:\"field_collection_field_name_load\";}','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:28:\"administer field collections\";}}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:21:\"field_collection_item\";i:2;i:3;i:3;s:7:\"default\";}','',29,5,1,'admin/structure/field-collections/%','admin/structure/field-collections/%','Manage display','t','','','a:0:{}',132,'','',2,'modules/field_ui/field_ui.admin.inc'),('admin/structure/field-collections/%/display/default','a:1:{i:3;s:32:\"field_collection_field_name_load\";}','','_field_ui_view_mode_menu_access','a:6:{i:0;s:21:\"field_collection_item\";i:1;i:3;i:2;s:7:\"default\";i:3;s:21:\"field_ui_admin_access\";i:4;s:11:\"user_access\";i:5;a:1:{i:0;s:28:\"administer field collections\";}}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:21:\"field_collection_item\";i:2;i:3;i:3;s:7:\"default\";}','',59,6,1,'admin/structure/field-collections/%/display','admin/structure/field-collections/%','Default','t','','','a:0:{}',140,'','',-10,'modules/field_ui/field_ui.admin.inc'),('admin/structure/field-collections/%/display/full','a:1:{i:3;s:32:\"field_collection_field_name_load\";}','','_field_ui_view_mode_menu_access','a:6:{i:0;s:21:\"field_collection_item\";i:1;i:3;i:2;s:4:\"full\";i:3;s:21:\"field_ui_admin_access\";i:4;s:11:\"user_access\";i:5;a:1:{i:0;s:28:\"administer field collections\";}}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:21:\"field_collection_item\";i:2;i:3;i:3;s:4:\"full\";}','',59,6,1,'admin/structure/field-collections/%/display','admin/structure/field-collections/%','Full content','t','','','a:0:{}',132,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/structure/field-collections/%/display/token','a:1:{i:3;s:32:\"field_collection_field_name_load\";}','','_field_ui_view_mode_menu_access','a:6:{i:0;s:21:\"field_collection_item\";i:1;i:3;i:2;s:5:\"token\";i:3;s:21:\"field_ui_admin_access\";i:4;s:11:\"user_access\";i:5;a:1:{i:0;s:28:\"administer field collections\";}}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:21:\"field_collection_item\";i:2;i:3;i:3;s:5:\"token\";}','',59,6,1,'admin/structure/field-collections/%/display','admin/structure/field-collections/%','Tokens','t','','','a:0:{}',132,'','',1,'modules/field_ui/field_ui.admin.inc'),('admin/structure/field-collections/%/fields','a:1:{i:3;s:32:\"field_collection_field_name_load\";}','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:28:\"administer field collections\";}}','drupal_get_form','a:3:{i:0;s:28:\"field_ui_field_overview_form\";i:1;s:21:\"field_collection_item\";i:2;i:3;}','',29,5,1,'admin/structure/field-collections/%','admin/structure/field-collections/%','Manage fields','t','','','a:0:{}',140,'','',1,'modules/field_ui/field_ui.admin.inc'),('admin/structure/field-collections/%/fields/%','a:2:{i:3;a:1:{s:32:\"field_collection_field_name_load\";a:4:{i:0;s:21:\"field_collection_item\";i:1;i:3;i:2;s:1:\"3\";i:3;s:4:\"%map\";}}i:5;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:21:\"field_collection_item\";i:1;i:3;i:2;s:1:\"3\";i:3;s:4:\"%map\";}}}','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:28:\"administer field collections\";}}','drupal_get_form','a:2:{i:0;s:24:\"field_ui_field_edit_form\";i:1;i:5;}','',58,6,0,'','admin/structure/field-collections/%/fields/%','','field_ui_menu_title','a:1:{i:0;i:5;}','','a:0:{}',6,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/structure/field-collections/%/fields/%/delete','a:2:{i:3;a:1:{s:32:\"field_collection_field_name_load\";a:4:{i:0;s:21:\"field_collection_item\";i:1;i:3;i:2;s:1:\"3\";i:3;s:4:\"%map\";}}i:5;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:21:\"field_collection_item\";i:1;i:3;i:2;s:1:\"3\";i:3;s:4:\"%map\";}}}','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:28:\"administer field collections\";}}','drupal_get_form','a:2:{i:0;s:26:\"field_ui_field_delete_form\";i:1;i:5;}','',117,7,1,'admin/structure/field-collections/%/fields/%','admin/structure/field-collections/%/fields/%','Delete','t','','','a:0:{}',132,'','',10,'modules/field_ui/field_ui.admin.inc'),('admin/structure/field-collections/%/fields/%/edit','a:2:{i:3;a:1:{s:32:\"field_collection_field_name_load\";a:4:{i:0;s:21:\"field_collection_item\";i:1;i:3;i:2;s:1:\"3\";i:3;s:4:\"%map\";}}i:5;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:21:\"field_collection_item\";i:1;i:3;i:2;s:1:\"3\";i:3;s:4:\"%map\";}}}','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:28:\"administer field collections\";}}','drupal_get_form','a:2:{i:0;s:24:\"field_ui_field_edit_form\";i:1;i:5;}','',117,7,1,'admin/structure/field-collections/%/fields/%','admin/structure/field-collections/%/fields/%','Edit','t','','','a:0:{}',140,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/structure/field-collections/%/fields/%/field-settings','a:2:{i:3;a:1:{s:32:\"field_collection_field_name_load\";a:4:{i:0;s:21:\"field_collection_item\";i:1;i:3;i:2;s:1:\"3\";i:3;s:4:\"%map\";}}i:5;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:21:\"field_collection_item\";i:1;i:3;i:2;s:1:\"3\";i:3;s:4:\"%map\";}}}','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:28:\"administer field collections\";}}','drupal_get_form','a:2:{i:0;s:28:\"field_ui_field_settings_form\";i:1;i:5;}','',117,7,1,'admin/structure/field-collections/%/fields/%','admin/structure/field-collections/%/fields/%','Field settings','t','','','a:0:{}',132,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/structure/field-collections/%/fields/%/widget-type','a:2:{i:3;a:1:{s:32:\"field_collection_field_name_load\";a:4:{i:0;s:21:\"field_collection_item\";i:1;i:3;i:2;s:1:\"3\";i:3;s:4:\"%map\";}}i:5;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:21:\"field_collection_item\";i:1;i:3;i:2;s:1:\"3\";i:3;s:4:\"%map\";}}}','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:28:\"administer field collections\";}}','drupal_get_form','a:2:{i:0;s:25:\"field_ui_widget_type_form\";i:1;i:5;}','',117,7,1,'admin/structure/field-collections/%/fields/%','admin/structure/field-collections/%/fields/%','Widget type','t','','','a:0:{}',132,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/structure/field-collections/%/groups/%/delete','a:2:{i:3;a:1:{s:32:\"field_collection_field_name_load\";a:4:{i:0;s:21:\"field_collection_item\";i:1;i:3;i:2;s:1:\"3\";i:3;s:4:\"%map\";}}i:5;a:1:{s:21:\"field_group_menu_load\";a:4:{i:0;s:21:\"field_collection_item\";i:1;i:3;i:2;s:1:\"3\";i:3;s:4:\"%map\";}}}','','user_access','a:1:{i:0;s:28:\"administer field collections\";}','drupal_get_form','a:2:{i:0;s:23:\"field_group_delete_form\";i:1;i:5;}','',117,7,0,'','admin/structure/field-collections/%/groups/%/delete','Delete','t','','','a:0:{}',0,'','',0,'sites/all/modules/field_group/field_group.field_ui.inc'),('admin/structure/field-collections/%/groups/%/enable','a:2:{i:3;a:1:{s:32:\"field_collection_field_name_load\";a:4:{i:0;s:21:\"field_collection_item\";i:1;i:3;i:2;s:1:\"3\";i:3;s:4:\"%map\";}}i:5;a:1:{s:21:\"field_group_menu_load\";a:4:{i:0;s:21:\"field_collection_item\";i:1;i:3;i:2;s:1:\"3\";i:3;s:4:\"%map\";}}}','','user_access','a:1:{i:0;s:28:\"administer field collections\";}','drupal_get_form','a:2:{i:0;s:23:\"field_group_enable_form\";i:1;i:5;}','',117,7,0,'','admin/structure/field-collections/%/groups/%/enable','Enable','t','','','a:0:{}',0,'','',0,'sites/all/modules/field_group/field_group.field_ui.inc'),('admin/structure/forum','','','user_access','a:1:{i:0;s:17:\"administer forums\";}','drupal_get_form','a:1:{i:0;s:14:\"forum_overview\";}','',7,3,0,'','admin/structure/forum','Forums','t','','','a:0:{}',6,'Control forum hierarchy settings.','',0,'modules/forum/forum.admin.inc'),('admin/structure/forum/add/container','','','user_access','a:1:{i:0;s:17:\"administer forums\";}','forum_form_main','a:1:{i:0;s:9:\"container\";}','',31,5,1,'admin/structure/forum','admin/structure/forum','Add container','t','','','a:0:{}',388,'','',0,'modules/forum/forum.admin.inc'),('admin/structure/forum/add/forum','','','user_access','a:1:{i:0;s:17:\"administer forums\";}','forum_form_main','a:1:{i:0;s:5:\"forum\";}','',31,5,1,'admin/structure/forum','admin/structure/forum','Add forum','t','','','a:0:{}',388,'','',0,'modules/forum/forum.admin.inc'),('admin/structure/forum/edit/container/%','a:1:{i:5;s:18:\"taxonomy_term_load\";}','','user_access','a:1:{i:0;s:17:\"administer forums\";}','forum_form_main','a:2:{i:0;s:9:\"container\";i:1;i:5;}','',62,6,0,'','admin/structure/forum/edit/container/%','Edit container','t','','','a:0:{}',6,'','',0,'modules/forum/forum.admin.inc'),('admin/structure/forum/edit/forum/%','a:1:{i:5;s:18:\"taxonomy_term_load\";}','','user_access','a:1:{i:0;s:17:\"administer forums\";}','forum_form_main','a:2:{i:0;s:5:\"forum\";i:1;i:5;}','',62,6,0,'','admin/structure/forum/edit/forum/%','Edit forum','t','','','a:0:{}',6,'','',0,'modules/forum/forum.admin.inc'),('admin/structure/forum/list','','','user_access','a:1:{i:0;s:17:\"administer forums\";}','drupal_get_form','a:1:{i:0;s:14:\"forum_overview\";}','',15,4,1,'admin/structure/forum','admin/structure/forum','List','t','','','a:0:{}',140,'','',-10,'modules/forum/forum.admin.inc'),('admin/structure/forum/settings','','','user_access','a:1:{i:0;s:17:\"administer forums\";}','drupal_get_form','a:1:{i:0;s:20:\"forum_admin_settings\";}','',15,4,1,'admin/structure/forum','admin/structure/forum','Settings','t','','','a:0:{}',132,'','',5,'modules/forum/forum.admin.inc'),('admin/structure/menu','','','user_access','a:1:{i:0;s:15:\"administer menu\";}','menu_overview_page','a:0:{}','',7,3,0,'','admin/structure/menu','Menus','t','','','a:0:{}',6,'Add new menus to your site, edit existing menus, and rename and reorganize menu links.','',0,'modules/menu/menu.admin.inc'),('admin/structure/menu/add','','','user_access','a:1:{i:0;s:15:\"administer menu\";}','drupal_get_form','a:2:{i:0;s:14:\"menu_edit_menu\";i:1;s:3:\"add\";}','',15,4,1,'admin/structure/menu','admin/structure/menu','Add menu','t','','','a:0:{}',388,'','',0,'modules/menu/menu.admin.inc'),('admin/structure/menu/item/%/delete','a:1:{i:4;s:14:\"menu_link_load\";}','','user_access','a:1:{i:0;s:15:\"administer menu\";}','menu_item_delete_page','a:1:{i:0;i:4;}','',61,6,0,'','admin/structure/menu/item/%/delete','Delete menu link','t','','','a:0:{}',6,'','',0,'modules/menu/menu.admin.inc'),('admin/structure/menu/item/%/edit','a:1:{i:4;s:14:\"menu_link_load\";}','','user_access','a:1:{i:0;s:15:\"administer menu\";}','drupal_get_form','a:4:{i:0;s:14:\"menu_edit_item\";i:1;s:4:\"edit\";i:2;i:4;i:3;N;}','',61,6,0,'','admin/structure/menu/item/%/edit','Edit menu link','t','','','a:0:{}',6,'','',0,'modules/menu/menu.admin.inc'),('admin/structure/menu/item/%/reset','a:1:{i:4;s:14:\"menu_link_load\";}','','user_access','a:1:{i:0;s:15:\"administer menu\";}','drupal_get_form','a:2:{i:0;s:23:\"menu_reset_item_confirm\";i:1;i:4;}','',61,6,0,'','admin/structure/menu/item/%/reset','Reset menu link','t','','','a:0:{}',6,'','',0,'modules/menu/menu.admin.inc'),('admin/structure/menu/list','','','user_access','a:1:{i:0;s:15:\"administer menu\";}','menu_overview_page','a:0:{}','',15,4,1,'admin/structure/menu','admin/structure/menu','List menus','t','','','a:0:{}',140,'','',-10,'modules/menu/menu.admin.inc'),('admin/structure/menu/manage/%','a:1:{i:4;s:9:\"menu_load\";}','','user_access','a:1:{i:0;s:15:\"administer menu\";}','drupal_get_form','a:2:{i:0;s:18:\"menu_overview_form\";i:1;i:4;}','',30,5,0,'','admin/structure/menu/manage/%','Customize menu','menu_overview_title','a:1:{i:0;i:4;}','','a:0:{}',6,'','',0,'modules/menu/menu.admin.inc'),('admin/structure/menu/manage/%/add','a:1:{i:4;s:9:\"menu_load\";}','','user_access','a:1:{i:0;s:15:\"administer menu\";}','drupal_get_form','a:4:{i:0;s:14:\"menu_edit_item\";i:1;s:3:\"add\";i:2;N;i:3;i:4;}','',61,6,1,'admin/structure/menu/manage/%','admin/structure/menu/manage/%','Add link','t','','','a:0:{}',388,'','',0,'modules/menu/menu.admin.inc'),('admin/structure/menu/manage/%/delete','a:1:{i:4;s:9:\"menu_load\";}','','user_access','a:1:{i:0;s:15:\"administer menu\";}','menu_delete_menu_page','a:1:{i:0;i:4;}','',61,6,0,'','admin/structure/menu/manage/%/delete','Delete menu','t','','','a:0:{}',6,'','',0,'modules/menu/menu.admin.inc'),('admin/structure/menu/manage/%/edit','a:1:{i:4;s:9:\"menu_load\";}','','user_access','a:1:{i:0;s:15:\"administer menu\";}','drupal_get_form','a:3:{i:0;s:14:\"menu_edit_menu\";i:1;s:4:\"edit\";i:2;i:4;}','',61,6,3,'admin/structure/menu/manage/%','admin/structure/menu/manage/%','Edit menu','t','','','a:0:{}',132,'','',0,'modules/menu/menu.admin.inc'),('admin/structure/menu/manage/%/list','a:1:{i:4;s:9:\"menu_load\";}','','user_access','a:1:{i:0;s:15:\"administer menu\";}','drupal_get_form','a:2:{i:0;s:18:\"menu_overview_form\";i:1;i:4;}','',61,6,3,'admin/structure/menu/manage/%','admin/structure/menu/manage/%','List links','t','','','a:0:{}',140,'','',-10,'modules/menu/menu.admin.inc'),('admin/structure/menu/parents','','','user_access','a:1:{i:0;s:15:\"administer menu\";}','menu_parent_options_js','a:0:{}','',15,4,0,'','admin/structure/menu/parents','Parent menu items','t','','','a:0:{}',0,'','',0,''),('admin/structure/menu/settings','','','user_access','a:1:{i:0;s:15:\"administer menu\";}','drupal_get_form','a:1:{i:0;s:14:\"menu_configure\";}','',15,4,1,'admin/structure/menu','admin/structure/menu','Settings','t','','','a:0:{}',132,'','',5,'modules/menu/menu.admin.inc'),('admin/structure/messages','','','entity_access','a:2:{i:0;s:4:\"view\";i:1;s:12:\"message_type\";}','drupal_get_form','a:2:{i:0;s:26:\"message_type_overview_form\";i:1;s:12:\"message_type\";}','',7,3,0,'','admin/structure/messages','Message types','t','','','a:0:{}',6,'Manage Message types.','',0,'sites/all/modules/entity/includes/entity.ui.inc'),('admin/structure/messages/add','','','entity_access','a:2:{i:0;s:6:\"create\";i:1;s:12:\"message_type\";}','entity_ui_get_form','a:3:{i:0;s:12:\"message_type\";i:1;N;i:2;s:3:\"add\";}','',15,4,1,'admin/structure/messages','admin/structure/messages','','entity_ui_get_action_title','a:2:{i:0;s:3:\"add\";i:1;s:12:\"message_type\";}','','a:0:{}',388,'','',0,'sites/all/modules/message/includes/message.admin.inc'),('admin/structure/messages/import','','','entity_access','a:2:{i:0;s:6:\"create\";i:1;s:12:\"message_type\";}','drupal_get_form','a:4:{i:0;s:27:\"message_type_operation_form\";i:1;s:12:\"message_type\";i:2;N;i:3;s:6:\"import\";}','',15,4,1,'admin/structure/messages','admin/structure/messages','','entity_ui_get_action_title','a:2:{i:0;s:6:\"import\";i:1;s:12:\"message_type\";}','','a:0:{}',388,'','',0,'sites/all/modules/entity/includes/entity.ui.inc'),('admin/structure/messages/list','','','entity_access','a:2:{i:0;s:4:\"view\";i:1;s:12:\"message_type\";}','drupal_get_form','a:2:{i:0;s:26:\"message_type_overview_form\";i:1;s:12:\"message_type\";}','',15,4,1,'admin/structure/messages','admin/structure/messages','List','t','','','a:0:{}',140,'','',-10,'sites/all/modules/entity/includes/entity.ui.inc'),('admin/structure/messages/manage/%','a:1:{i:4;a:1:{s:18:\"entity_object_load\";a:1:{i:0;s:12:\"message_type\";}}}','','entity_access','a:3:{i:0;s:6:\"update\";i:1;s:12:\"message_type\";i:2;i:4;}','entity_ui_get_form','a:2:{i:0;s:12:\"message_type\";i:1;i:4;}','',30,5,0,'','admin/structure/messages/manage/%','Edit','entity_label','a:2:{i:0;s:12:\"message_type\";i:1;i:4;}','','a:0:{}',6,'','',0,'sites/all/modules/message/includes/message.admin.inc'),('admin/structure/messages/manage/%/%','a:2:{i:4;a:1:{s:18:\"entity_object_load\";a:1:{i:0;s:12:\"message_type\";}}i:5;N;}','','entity_access','a:3:{i:0;s:6:\"delete\";i:1;s:12:\"message_type\";i:2;i:4;}','drupal_get_form','a:4:{i:0;s:27:\"message_type_operation_form\";i:1;s:12:\"message_type\";i:2;i:4;i:3;i:5;}','',60,6,0,'','admin/structure/messages/manage/%/%','','t','','','a:0:{}',6,'','',0,'sites/all/modules/entity/includes/entity.ui.inc'),('admin/structure/messages/manage/%/clone','a:1:{i:4;a:1:{s:18:\"entity_object_load\";a:1:{i:0;s:12:\"message_type\";}}}','','entity_access','a:2:{i:0;s:6:\"create\";i:1;s:12:\"message_type\";}','entity_ui_get_form','a:3:{i:0;s:12:\"message_type\";i:1;i:4;i:2;s:5:\"clone\";}','',61,6,0,'','admin/structure/messages/manage/%/clone','Clone','t','','','a:0:{}',6,'','',0,'sites/all/modules/message/includes/message.admin.inc'),('admin/structure/messages/manage/%/display','a:1:{i:4;s:17:\"message_type_load\";}','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:24:\"administer message types\";}}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:7:\"message\";i:2;i:4;i:3;s:7:\"default\";}','',61,6,1,'admin/structure/messages/manage/%','admin/structure/messages/manage/%','Manage display','t','','','a:0:{}',132,'','',2,'modules/field_ui/field_ui.admin.inc'),('admin/structure/messages/manage/%/display/default','a:1:{i:4;s:17:\"message_type_load\";}','','_field_ui_view_mode_menu_access','a:6:{i:0;s:7:\"message\";i:1;i:4;i:2;s:7:\"default\";i:3;s:21:\"field_ui_admin_access\";i:4;s:11:\"user_access\";i:5;a:1:{i:0;s:24:\"administer message types\";}}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:7:\"message\";i:2;i:4;i:3;s:7:\"default\";}','',123,7,1,'admin/structure/messages/manage/%/display','admin/structure/messages/manage/%','Default','t','','','a:0:{}',140,'','',-10,'modules/field_ui/field_ui.admin.inc'),('admin/structure/messages/manage/%/display/full','a:1:{i:4;s:17:\"message_type_load\";}','','_field_ui_view_mode_menu_access','a:6:{i:0;s:7:\"message\";i:1;i:4;i:2;s:4:\"full\";i:3;s:21:\"field_ui_admin_access\";i:4;s:11:\"user_access\";i:5;a:1:{i:0;s:24:\"administer message types\";}}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:7:\"message\";i:2;i:4;i:3;s:4:\"full\";}','',123,7,1,'admin/structure/messages/manage/%/display','admin/structure/messages/manage/%','Full','t','','','a:0:{}',132,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/structure/messages/manage/%/display/token','a:1:{i:4;s:17:\"message_type_load\";}','','_field_ui_view_mode_menu_access','a:6:{i:0;s:7:\"message\";i:1;i:4;i:2;s:5:\"token\";i:3;s:21:\"field_ui_admin_access\";i:4;s:11:\"user_access\";i:5;a:1:{i:0;s:24:\"administer message types\";}}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:7:\"message\";i:2;i:4;i:3;s:5:\"token\";}','',123,7,1,'admin/structure/messages/manage/%/display','admin/structure/messages/manage/%','Tokens','t','','','a:0:{}',132,'','',1,'modules/field_ui/field_ui.admin.inc'),('admin/structure/messages/manage/%/edit','a:1:{i:4;a:1:{s:18:\"entity_object_load\";a:1:{i:0;s:12:\"message_type\";}}}','','entity_access','a:3:{i:0;s:6:\"update\";i:1;s:12:\"message_type\";i:2;i:4;}','entity_ui_get_form','a:2:{i:0;s:12:\"message_type\";i:1;i:4;}','',61,6,1,'admin/structure/messages/manage/%','admin/structure/messages/manage/%','Edit','t','','','a:0:{}',140,'','',0,'sites/all/modules/message/includes/message.admin.inc'),('admin/structure/messages/manage/%/fields','a:1:{i:4;s:17:\"message_type_load\";}','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:24:\"administer message types\";}}','drupal_get_form','a:3:{i:0;s:28:\"field_ui_field_overview_form\";i:1;s:7:\"message\";i:2;i:4;}','',61,6,1,'admin/structure/messages/manage/%','admin/structure/messages/manage/%','Manage fields','t','','','a:0:{}',132,'','',1,'modules/field_ui/field_ui.admin.inc'),('admin/structure/messages/manage/%/fields/%','a:2:{i:4;a:1:{s:17:\"message_type_load\";a:4:{i:0;s:7:\"message\";i:1;i:4;i:2;s:1:\"4\";i:3;s:4:\"%map\";}}i:6;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:7:\"message\";i:1;i:4;i:2;s:1:\"4\";i:3;s:4:\"%map\";}}}','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:24:\"administer message types\";}}','drupal_get_form','a:2:{i:0;s:24:\"field_ui_field_edit_form\";i:1;i:6;}','',122,7,0,'','admin/structure/messages/manage/%/fields/%','','field_ui_menu_title','a:1:{i:0;i:6;}','','a:0:{}',6,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/structure/messages/manage/%/fields/%/delete','a:2:{i:4;a:1:{s:17:\"message_type_load\";a:4:{i:0;s:7:\"message\";i:1;i:4;i:2;s:1:\"4\";i:3;s:4:\"%map\";}}i:6;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:7:\"message\";i:1;i:4;i:2;s:1:\"4\";i:3;s:4:\"%map\";}}}','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:24:\"administer message types\";}}','drupal_get_form','a:2:{i:0;s:26:\"field_ui_field_delete_form\";i:1;i:6;}','',245,8,1,'admin/structure/messages/manage/%/fields/%','admin/structure/messages/manage/%/fields/%','Delete','t','','','a:0:{}',132,'','',10,'modules/field_ui/field_ui.admin.inc'),('admin/structure/messages/manage/%/fields/%/edit','a:2:{i:4;a:1:{s:17:\"message_type_load\";a:4:{i:0;s:7:\"message\";i:1;i:4;i:2;s:1:\"4\";i:3;s:4:\"%map\";}}i:6;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:7:\"message\";i:1;i:4;i:2;s:1:\"4\";i:3;s:4:\"%map\";}}}','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:24:\"administer message types\";}}','drupal_get_form','a:2:{i:0;s:24:\"field_ui_field_edit_form\";i:1;i:6;}','',245,8,1,'admin/structure/messages/manage/%/fields/%','admin/structure/messages/manage/%/fields/%','Edit','t','','','a:0:{}',140,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/structure/messages/manage/%/fields/%/field-settings','a:2:{i:4;a:1:{s:17:\"message_type_load\";a:4:{i:0;s:7:\"message\";i:1;i:4;i:2;s:1:\"4\";i:3;s:4:\"%map\";}}i:6;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:7:\"message\";i:1;i:4;i:2;s:1:\"4\";i:3;s:4:\"%map\";}}}','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:24:\"administer message types\";}}','drupal_get_form','a:2:{i:0;s:28:\"field_ui_field_settings_form\";i:1;i:6;}','',245,8,1,'admin/structure/messages/manage/%/fields/%','admin/structure/messages/manage/%/fields/%','Field settings','t','','','a:0:{}',132,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/structure/messages/manage/%/fields/%/widget-type','a:2:{i:4;a:1:{s:17:\"message_type_load\";a:4:{i:0;s:7:\"message\";i:1;i:4;i:2;s:1:\"4\";i:3;s:4:\"%map\";}}i:6;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:7:\"message\";i:1;i:4;i:2;s:1:\"4\";i:3;s:4:\"%map\";}}}','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:24:\"administer message types\";}}','drupal_get_form','a:2:{i:0;s:25:\"field_ui_widget_type_form\";i:1;i:6;}','',245,8,1,'admin/structure/messages/manage/%/fields/%','admin/structure/messages/manage/%/fields/%','Widget type','t','','','a:0:{}',132,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/structure/messages/manage/%/groups/%/delete','a:2:{i:4;a:1:{s:17:\"message_type_load\";a:4:{i:0;s:7:\"message\";i:1;i:4;i:2;s:1:\"4\";i:3;s:4:\"%map\";}}i:6;a:1:{s:21:\"field_group_menu_load\";a:4:{i:0;s:7:\"message\";i:1;i:4;i:2;s:1:\"4\";i:3;s:4:\"%map\";}}}','','user_access','a:1:{i:0;s:24:\"administer message types\";}','drupal_get_form','a:2:{i:0;s:23:\"field_group_delete_form\";i:1;i:6;}','',245,8,0,'','admin/structure/messages/manage/%/groups/%/delete','Delete','t','','','a:0:{}',0,'','',0,'sites/all/modules/field_group/field_group.field_ui.inc'),('admin/structure/messages/manage/%/groups/%/enable','a:2:{i:4;a:1:{s:17:\"message_type_load\";a:4:{i:0;s:7:\"message\";i:1;i:4;i:2;s:1:\"4\";i:3;s:4:\"%map\";}}i:6;a:1:{s:21:\"field_group_menu_load\";a:4:{i:0;s:7:\"message\";i:1;i:4;i:2;s:1:\"4\";i:3;s:4:\"%map\";}}}','','user_access','a:1:{i:0;s:24:\"administer message types\";}','drupal_get_form','a:2:{i:0;s:23:\"field_group_enable_form\";i:1;i:6;}','',245,8,0,'','admin/structure/messages/manage/%/groups/%/enable','Enable','t','','','a:0:{}',0,'','',0,'sites/all/modules/field_group/field_group.field_ui.inc'),('admin/structure/migrate_content','','','user_access','a:1:{i:0;s:29:\"administer site configuration\";}','drupal_get_form','a:1:{i:0;s:31:\"we_content_migration_admin_form\";}','',7,3,0,'','admin/structure/migrate_content','Migrate Content','t','','','a:0:{}',6,'Manage Migrate Content.','',0,'sites/all/modules/we_content_migration/we_content_migration.admin.inc'),('admin/structure/migrate_content/create','','','user_access','a:1:{i:0;s:29:\"administer site configuration\";}','drupal_get_form','a:1:{i:0;s:32:\"we_content_migration_export_form\";}','',15,4,1,'admin/structure/migrate_content','admin/structure/migrate_content','Create','t','','','a:0:{}',132,'Migrate Content Create.','',10,'sites/all/modules/we_content_migration/we_content_migration.admin.inc'),('admin/structure/migrate_content/import-from-upload','','','user_access','a:1:{i:0;s:29:\"administer site configuration\";}','drupal_get_form','a:1:{i:0;s:44:\"we_content_migration_import_from_upload_form\";}','',15,4,1,'admin/structure/migrate_content','admin/structure/migrate_content','Import','t','','','a:0:{}',132,'Upload zip file to import.','',11,'sites/all/modules/we_content_migration/we_content_migration.admin.inc'),('admin/structure/migrate_content/manage','','','user_access','a:1:{i:0;s:29:\"administer site configuration\";}','drupal_get_form','a:1:{i:0;s:31:\"we_content_migration_admin_form\";}','',15,4,1,'admin/structure/migrate_content','admin/structure/migrate_content','Manage','t','','','a:0:{}',140,'Enable and disable entity bundle.','',0,'sites/all/modules/we_content_migration/we_content_migration.admin.inc'),('admin/structure/migrate_content/settings','','','user_access','a:1:{i:0;s:29:\"administer site configuration\";}','drupal_get_form','a:1:{i:0;s:34:\"we_content_migration_settings_form\";}','',15,4,1,'admin/structure/migrate_content','admin/structure/migrate_content','Settings','t','','','a:0:{}',132,'Adjust settings for using migrate content module.','',11,'sites/all/modules/we_content_migration/we_content_migration.admin.inc'),('admin/structure/quicktabs','','','user_access','a:1:{i:0;s:20:\"administer quicktabs\";}','quicktabs_list','a:0:{}','',7,3,0,'','admin/structure/quicktabs','Quicktabs','t','','','a:0:{}',6,'Create blocks of tabbed content.','',0,'sites/all/modules/quicktabs/quicktabs.admin.inc'),('admin/structure/quicktabs/add','','','user_access','a:1:{i:0;s:20:\"administer quicktabs\";}','drupal_get_form','a:2:{i:0;s:14:\"quicktabs_form\";i:1;s:3:\"add\";}','',15,4,1,'admin/structure/quicktabs','admin/structure/quicktabs','Add Quicktabs Instance','t','','','a:0:{}',388,'','',0,'sites/all/modules/quicktabs/quicktabs.admin.inc'),('admin/structure/quicktabs/list','','','user_access','a:1:{i:0;s:20:\"administer quicktabs\";}','quicktabs_list','a:0:{}','',15,4,1,'admin/structure/quicktabs','admin/structure/quicktabs','List quicktabs','t','','','a:0:{}',140,'','',0,'sites/all/modules/quicktabs/quicktabs.admin.inc'),('admin/structure/quicktabs/manage/%','a:1:{i:4;s:14:\"quicktabs_load\";}','','user_access','a:1:{i:0;s:20:\"administer quicktabs\";}','drupal_get_form','a:3:{i:0;s:14:\"quicktabs_form\";i:1;s:4:\"edit\";i:2;i:4;}','',30,5,0,'','admin/structure/quicktabs/manage/%','Edit quicktab','t','','','a:0:{}',6,'','',0,'sites/all/modules/quicktabs/quicktabs.admin.inc'),('admin/structure/quicktabs/manage/%/clone','a:1:{i:4;s:14:\"quicktabs_load\";}','','user_access','a:1:{i:0;s:20:\"administer quicktabs\";}','quicktabs_clone','a:1:{i:0;i:4;}','',61,6,1,'admin/structure/quicktabs/manage/%','admin/structure/quicktabs/manage/%','Clone quicktab','t','','','a:0:{}',132,'','',0,'sites/all/modules/quicktabs/quicktabs.admin.inc'),('admin/structure/quicktabs/manage/%/delete','a:1:{i:4;s:14:\"quicktabs_load\";}','','user_access','a:1:{i:0;s:20:\"administer quicktabs\";}','drupal_get_form','a:2:{i:0;s:22:\"quicktabs_block_delete\";i:1;i:4;}','',61,6,1,'admin/structure/quicktabs/manage/%','admin/structure/quicktabs/manage/%','Delete quicktab','t','','','a:0:{}',132,'','',0,'sites/all/modules/quicktabs/quicktabs.admin.inc'),('admin/structure/quicktabs/manage/%/edit','a:1:{i:4;s:14:\"quicktabs_load\";}','','user_access','a:1:{i:0;s:20:\"administer quicktabs\";}','drupal_get_form','a:3:{i:0;s:14:\"quicktabs_form\";i:1;s:4:\"edit\";i:2;i:4;}','',61,6,2,'admin/structure/quicktabs/manage/%','admin/structure/quicktabs/manage/%','Edit quicktab','t','','','a:0:{}',140,'','',0,'sites/all/modules/quicktabs/quicktabs.admin.inc'),('admin/structure/quicktabs/manage/%/export','a:1:{i:4;s:14:\"quicktabs_load\";}','','user_access','a:1:{i:0;s:20:\"administer quicktabs\";}','drupal_get_form','a:2:{i:0;s:21:\"quicktabs_export_form\";i:1;i:4;}','',61,6,1,'admin/structure/quicktabs/manage/%','admin/structure/quicktabs/manage/%','Export','t','','','a:0:{}',132,'','',0,'sites/all/modules/quicktabs/quicktabs.admin.inc'),('admin/structure/taxonomy','','','user_access','a:1:{i:0;s:19:\"administer taxonomy\";}','drupal_get_form','a:1:{i:0;s:30:\"taxonomy_overview_vocabularies\";}','',7,3,0,'','admin/structure/taxonomy','Taxonomy','t','','','a:0:{}',6,'Manage tagging, categorization, and classification of your content.','',0,'modules/taxonomy/taxonomy.admin.inc'),('admin/structure/taxonomy/%','a:1:{i:3;s:37:\"taxonomy_vocabulary_machine_name_load\";}','','user_access','a:1:{i:0;s:19:\"administer taxonomy\";}','drupal_get_form','a:2:{i:0;s:23:\"taxonomy_overview_terms\";i:1;i:3;}','',14,4,0,'','admin/structure/taxonomy/%','','entity_label','a:2:{i:0;s:19:\"taxonomy_vocabulary\";i:1;i:3;}','','a:0:{}',6,'','',0,'modules/taxonomy/taxonomy.admin.inc'),('admin/structure/taxonomy/%/add','a:1:{i:3;s:37:\"taxonomy_vocabulary_machine_name_load\";}','','user_access','a:1:{i:0;s:19:\"administer taxonomy\";}','drupal_get_form','a:3:{i:0;s:18:\"taxonomy_form_term\";i:1;a:0:{}i:2;i:3;}','',29,5,1,'admin/structure/taxonomy/%','admin/structure/taxonomy/%','Add term','t','','','a:0:{}',388,'','',0,'modules/taxonomy/taxonomy.admin.inc'),('admin/structure/taxonomy/%/display','a:1:{i:3;s:37:\"taxonomy_vocabulary_machine_name_load\";}','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:19:\"administer taxonomy\";}}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:13:\"taxonomy_term\";i:2;i:3;i:3;s:7:\"default\";}','',29,5,1,'admin/structure/taxonomy/%','admin/structure/taxonomy/%','Manage display','t','','','a:0:{}',132,'','',2,'modules/field_ui/field_ui.admin.inc'),('admin/structure/taxonomy/%/display/default','a:1:{i:3;s:37:\"taxonomy_vocabulary_machine_name_load\";}','','_field_ui_view_mode_menu_access','a:6:{i:0;s:13:\"taxonomy_term\";i:1;i:3;i:2;s:7:\"default\";i:3;s:21:\"field_ui_admin_access\";i:4;s:11:\"user_access\";i:5;a:1:{i:0;s:19:\"administer taxonomy\";}}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:13:\"taxonomy_term\";i:2;i:3;i:3;s:7:\"default\";}','',59,6,1,'admin/structure/taxonomy/%/display','admin/structure/taxonomy/%','Default','t','','','a:0:{}',140,'','',-10,'modules/field_ui/field_ui.admin.inc'),('admin/structure/taxonomy/%/display/full','a:1:{i:3;s:37:\"taxonomy_vocabulary_machine_name_load\";}','','_field_ui_view_mode_menu_access','a:6:{i:0;s:13:\"taxonomy_term\";i:1;i:3;i:2;s:4:\"full\";i:3;s:21:\"field_ui_admin_access\";i:4;s:11:\"user_access\";i:5;a:1:{i:0;s:19:\"administer taxonomy\";}}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:13:\"taxonomy_term\";i:2;i:3;i:3;s:4:\"full\";}','',59,6,1,'admin/structure/taxonomy/%/display','admin/structure/taxonomy/%','Taxonomy term page','t','','','a:0:{}',132,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/structure/taxonomy/%/display/token','a:1:{i:3;s:37:\"taxonomy_vocabulary_machine_name_load\";}','','_field_ui_view_mode_menu_access','a:6:{i:0;s:13:\"taxonomy_term\";i:1;i:3;i:2;s:5:\"token\";i:3;s:21:\"field_ui_admin_access\";i:4;s:11:\"user_access\";i:5;a:1:{i:0;s:19:\"administer taxonomy\";}}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:13:\"taxonomy_term\";i:2;i:3;i:3;s:5:\"token\";}','',59,6,1,'admin/structure/taxonomy/%/display','admin/structure/taxonomy/%','Tokens','t','','','a:0:{}',132,'','',1,'modules/field_ui/field_ui.admin.inc'),('admin/structure/taxonomy/%/edit','a:1:{i:3;s:37:\"taxonomy_vocabulary_machine_name_load\";}','','user_access','a:1:{i:0;s:19:\"administer taxonomy\";}','drupal_get_form','a:2:{i:0;s:24:\"taxonomy_form_vocabulary\";i:1;i:3;}','',29,5,1,'admin/structure/taxonomy/%','admin/structure/taxonomy/%','Edit','t','','','a:0:{}',132,'','',-10,'modules/taxonomy/taxonomy.admin.inc'),('admin/structure/taxonomy/%/fields','a:1:{i:3;s:37:\"taxonomy_vocabulary_machine_name_load\";}','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:19:\"administer taxonomy\";}}','drupal_get_form','a:3:{i:0;s:28:\"field_ui_field_overview_form\";i:1;s:13:\"taxonomy_term\";i:2;i:3;}','',29,5,1,'admin/structure/taxonomy/%','admin/structure/taxonomy/%','Manage fields','t','','','a:0:{}',132,'','',1,'modules/field_ui/field_ui.admin.inc'),('admin/structure/taxonomy/%/fields/%','a:2:{i:3;a:1:{s:37:\"taxonomy_vocabulary_machine_name_load\";a:4:{i:0;s:13:\"taxonomy_term\";i:1;i:3;i:2;s:1:\"3\";i:3;s:4:\"%map\";}}i:5;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:13:\"taxonomy_term\";i:1;i:3;i:2;s:1:\"3\";i:3;s:4:\"%map\";}}}','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:19:\"administer taxonomy\";}}','drupal_get_form','a:2:{i:0;s:24:\"field_ui_field_edit_form\";i:1;i:5;}','',58,6,0,'','admin/structure/taxonomy/%/fields/%','','field_ui_menu_title','a:1:{i:0;i:5;}','','a:0:{}',6,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/structure/taxonomy/%/fields/%/delete','a:2:{i:3;a:1:{s:37:\"taxonomy_vocabulary_machine_name_load\";a:4:{i:0;s:13:\"taxonomy_term\";i:1;i:3;i:2;s:1:\"3\";i:3;s:4:\"%map\";}}i:5;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:13:\"taxonomy_term\";i:1;i:3;i:2;s:1:\"3\";i:3;s:4:\"%map\";}}}','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:19:\"administer taxonomy\";}}','drupal_get_form','a:2:{i:0;s:26:\"field_ui_field_delete_form\";i:1;i:5;}','',117,7,1,'admin/structure/taxonomy/%/fields/%','admin/structure/taxonomy/%/fields/%','Delete','t','','','a:0:{}',132,'','',10,'modules/field_ui/field_ui.admin.inc'),('admin/structure/taxonomy/%/fields/%/edit','a:2:{i:3;a:1:{s:37:\"taxonomy_vocabulary_machine_name_load\";a:4:{i:0;s:13:\"taxonomy_term\";i:1;i:3;i:2;s:1:\"3\";i:3;s:4:\"%map\";}}i:5;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:13:\"taxonomy_term\";i:1;i:3;i:2;s:1:\"3\";i:3;s:4:\"%map\";}}}','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:19:\"administer taxonomy\";}}','drupal_get_form','a:2:{i:0;s:24:\"field_ui_field_edit_form\";i:1;i:5;}','',117,7,1,'admin/structure/taxonomy/%/fields/%','admin/structure/taxonomy/%/fields/%','Edit','t','','','a:0:{}',140,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/structure/taxonomy/%/fields/%/field-settings','a:2:{i:3;a:1:{s:37:\"taxonomy_vocabulary_machine_name_load\";a:4:{i:0;s:13:\"taxonomy_term\";i:1;i:3;i:2;s:1:\"3\";i:3;s:4:\"%map\";}}i:5;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:13:\"taxonomy_term\";i:1;i:3;i:2;s:1:\"3\";i:3;s:4:\"%map\";}}}','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:19:\"administer taxonomy\";}}','drupal_get_form','a:2:{i:0;s:28:\"field_ui_field_settings_form\";i:1;i:5;}','',117,7,1,'admin/structure/taxonomy/%/fields/%','admin/structure/taxonomy/%/fields/%','Field settings','t','','','a:0:{}',132,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/structure/taxonomy/%/fields/%/widget-type','a:2:{i:3;a:1:{s:37:\"taxonomy_vocabulary_machine_name_load\";a:4:{i:0;s:13:\"taxonomy_term\";i:1;i:3;i:2;s:1:\"3\";i:3;s:4:\"%map\";}}i:5;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:13:\"taxonomy_term\";i:1;i:3;i:2;s:1:\"3\";i:3;s:4:\"%map\";}}}','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:19:\"administer taxonomy\";}}','drupal_get_form','a:2:{i:0;s:25:\"field_ui_widget_type_form\";i:1;i:5;}','',117,7,1,'admin/structure/taxonomy/%/fields/%','admin/structure/taxonomy/%/fields/%','Widget type','t','','','a:0:{}',132,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/structure/taxonomy/%/groups/%/delete','a:2:{i:3;a:1:{s:37:\"taxonomy_vocabulary_machine_name_load\";a:4:{i:0;s:13:\"taxonomy_term\";i:1;i:3;i:2;s:1:\"3\";i:3;s:4:\"%map\";}}i:5;a:1:{s:21:\"field_group_menu_load\";a:4:{i:0;s:13:\"taxonomy_term\";i:1;i:3;i:2;s:1:\"3\";i:3;s:4:\"%map\";}}}','','user_access','a:1:{i:0;s:19:\"administer taxonomy\";}','drupal_get_form','a:2:{i:0;s:23:\"field_group_delete_form\";i:1;i:5;}','',117,7,0,'','admin/structure/taxonomy/%/groups/%/delete','Delete','t','','','a:0:{}',0,'','',0,'sites/all/modules/field_group/field_group.field_ui.inc'),('admin/structure/taxonomy/%/groups/%/enable','a:2:{i:3;a:1:{s:37:\"taxonomy_vocabulary_machine_name_load\";a:4:{i:0;s:13:\"taxonomy_term\";i:1;i:3;i:2;s:1:\"3\";i:3;s:4:\"%map\";}}i:5;a:1:{s:21:\"field_group_menu_load\";a:4:{i:0;s:13:\"taxonomy_term\";i:1;i:3;i:2;s:1:\"3\";i:3;s:4:\"%map\";}}}','','user_access','a:1:{i:0;s:19:\"administer taxonomy\";}','drupal_get_form','a:2:{i:0;s:23:\"field_group_enable_form\";i:1;i:5;}','',117,7,0,'','admin/structure/taxonomy/%/groups/%/enable','Enable','t','','','a:0:{}',0,'','',0,'sites/all/modules/field_group/field_group.field_ui.inc'),('admin/structure/taxonomy/%/list','a:1:{i:3;s:37:\"taxonomy_vocabulary_machine_name_load\";}','','user_access','a:1:{i:0;s:19:\"administer taxonomy\";}','drupal_get_form','a:2:{i:0;s:23:\"taxonomy_overview_terms\";i:1;i:3;}','',29,5,1,'admin/structure/taxonomy/%','admin/structure/taxonomy/%','List','t','','','a:0:{}',140,'','',-20,'modules/taxonomy/taxonomy.admin.inc'),('admin/structure/taxonomy/%/list/list','a:1:{i:3;s:37:\"taxonomy_vocabulary_machine_name_load\";}','','user_access','a:1:{i:0;s:19:\"administer taxonomy\";}','drupal_get_form','a:2:{i:0;s:23:\"taxonomy_overview_terms\";i:1;i:3;}','',59,6,1,'admin/structure/taxonomy/%/list','admin/structure/taxonomy/%','Terms','t','','','a:0:{}',140,'','',-20,'modules/taxonomy/taxonomy.admin.inc'),('admin/structure/taxonomy/%/list/sets','a:1:{i:3;s:37:\"taxonomy_vocabulary_machine_name_load\";}','','i18n_taxonomy_vocabulary_translation_tab_sets_access','a:1:{i:0;i:3;}','i18n_taxonomy_translation_sets_overview','a:1:{i:0;i:3;}','',59,6,1,'admin/structure/taxonomy/%/list','admin/structure/taxonomy/%','Translation sets','t','','','a:0:{}',132,'','',0,'sites/all/modules/i18n/i18n_taxonomy/i18n_taxonomy.admin.inc'),('admin/structure/taxonomy/%/list/sets/add','a:1:{i:3;s:37:\"taxonomy_vocabulary_machine_name_load\";}','','i18n_taxonomy_vocabulary_translation_tab_sets_access','a:1:{i:0;i:3;}','drupal_get_form','a:2:{i:0;s:35:\"i18n_taxonomy_translation_term_form\";i:1;i:3;}','',119,7,1,'admin/structure/taxonomy/%/list/sets','admin/structure/taxonomy/%','Create new translation','t','','','a:0:{}',388,'','',0,'sites/all/modules/i18n/i18n_taxonomy/i18n_taxonomy.admin.inc'),('admin/structure/taxonomy/%/list/sets/delete/%','a:2:{i:3;s:37:\"taxonomy_vocabulary_machine_name_load\";i:7;s:34:\"i18n_taxonomy_translation_set_load\";}','','i18n_taxonomy_vocabulary_translation_tab_sets_access','a:1:{i:0;i:3;}','drupal_get_form','a:2:{i:0;s:35:\"i18n_translation_set_delete_confirm\";i:1;i:7;}','',238,8,0,'','admin/structure/taxonomy/%/list/sets/delete/%','Delete translation','t','','','a:0:{}',0,'','',0,''),('admin/structure/taxonomy/%/list/sets/edit/%','a:2:{i:3;s:37:\"taxonomy_vocabulary_machine_name_load\";i:7;s:34:\"i18n_taxonomy_translation_set_load\";}','','i18n_taxonomy_vocabulary_translation_tab_sets_access','a:1:{i:0;i:3;}','drupal_get_form','a:3:{i:0;s:35:\"i18n_taxonomy_translation_term_form\";i:1;i:3;i:2;i:7;}','',238,8,0,'','admin/structure/taxonomy/%/list/sets/edit/%','Edit translation','t','','','a:0:{}',0,'','',0,'sites/all/modules/i18n/i18n_taxonomy/i18n_taxonomy.admin.inc'),('admin/structure/taxonomy/%/translate','a:1:{i:3;s:37:\"taxonomy_vocabulary_machine_name_load\";}','','i18n_object_translate_access','a:2:{i:0;s:19:\"taxonomy_vocabulary\";i:1;i:3;}','i18n_page_translate_localize','a:2:{i:0;s:19:\"taxonomy_vocabulary\";i:1;i:3;}','',29,5,1,'admin/structure/taxonomy/%','admin/structure/taxonomy/%','Translate','t','','','a:0:{}',132,'','',10,'sites/all/modules/i18n/i18n.pages.inc'),('admin/structure/taxonomy/%/translate/%','a:2:{i:3;s:37:\"taxonomy_vocabulary_machine_name_load\";i:5;s:18:\"i18n_language_load\";}','','i18n_object_translate_access','a:2:{i:0;s:19:\"taxonomy_vocabulary\";i:1;i:3;}','i18n_page_translate_localize','a:3:{i:0;s:19:\"taxonomy_vocabulary\";i:1;i:3;i:2;i:5;}','',58,6,0,'','admin/structure/taxonomy/%/translate/%','Translate','t','','','a:0:{}',0,'','',0,'sites/all/modules/i18n/i18n.pages.inc'),('admin/structure/taxonomy/add','','','user_access','a:1:{i:0;s:19:\"administer taxonomy\";}','drupal_get_form','a:1:{i:0;s:24:\"taxonomy_form_vocabulary\";}','',15,4,1,'admin/structure/taxonomy','admin/structure/taxonomy','Add vocabulary','t','','','a:0:{}',388,'','',0,'modules/taxonomy/taxonomy.admin.inc'),('admin/structure/taxonomy/list','','','user_access','a:1:{i:0;s:19:\"administer taxonomy\";}','drupal_get_form','a:1:{i:0;s:30:\"taxonomy_overview_vocabularies\";}','',15,4,1,'admin/structure/taxonomy','admin/structure/taxonomy','List','t','','','a:0:{}',140,'','',-10,'modules/taxonomy/taxonomy.admin.inc'),('admin/structure/token-custom','','','user_access','a:1:{i:0;s:18:\"list custom tokens\";}','token_custom_list_page','a:0:{}','',7,3,0,'','admin/structure/token-custom','Custom tokens','t','','','a:0:{}',6,'Administrate custom tokens.','',0,'sites/all/modules/token_custom/token_custom.admin.inc'),('admin/structure/token-custom/%/delete','a:1:{i:3;s:17:\"token_custom_load\";}','','user_access','a:1:{i:0;s:24:\"administer custom tokens\";}','drupal_get_form','a:2:{i:0;s:32:\"token_custom_delete_confirm_form\";i:1;i:3;}','',29,5,0,'','admin/structure/token-custom/%/delete','Delete custom token','t','','','a:0:{}',6,'','',0,'sites/all/modules/token_custom/token_custom.admin.inc'),('admin/structure/token-custom/%/edit','a:1:{i:3;s:17:\"token_custom_load\";}','','user_access','a:1:{i:0;s:24:\"administer custom tokens\";}','drupal_get_form','a:3:{i:0;s:22:\"token_custom_edit_form\";i:1;s:4:\"edit\";i:2;i:3;}','',29,5,0,'','admin/structure/token-custom/%/edit','Edit token','t','','','a:0:{}',0,'','',10,'sites/all/modules/token_custom/token_custom.admin.inc'),('admin/structure/token-custom/add','','','user_access','a:1:{i:0;s:24:\"administer custom tokens\";}','drupal_get_form','a:2:{i:0;s:22:\"token_custom_edit_form\";i:1;s:3:\"add\";}','',15,4,1,'admin/structure/token-custom','admin/structure/token-custom','Add token','t','','','a:0:{}',388,'Create custom tokens','',1,'sites/all/modules/token_custom/token_custom.admin.inc'),('admin/structure/token-custom/list','','','user_access','a:1:{i:0;s:18:\"list custom tokens\";}','token_custom_list_page','a:0:{}','',15,4,1,'admin/structure/token-custom','admin/structure/token-custom','Custom tokens','t','','','a:0:{}',140,'List of custom tokens.','',0,'sites/all/modules/token_custom/token_custom.admin.inc'),('admin/structure/token-custom/type','','','user_access','a:1:{i:0;s:24:\"administer custom tokens\";}','token_custom_type_list_page','a:0:{}','',15,4,1,'admin/structure/token-custom','admin/structure/token-custom','Custom token types','t','','','a:0:{}',132,'View custom token types','',2,'sites/all/modules/token_custom/token_custom.admin.inc'),('admin/structure/token-custom/type/%/delete','a:1:{i:4;s:22:\"token_custom_type_load\";}','','token_custom_type_forms_access','a:1:{i:0;i:4;}','drupal_get_form','a:2:{i:0;s:37:\"token_custom_type_delete_confirm_form\";i:1;i:4;}','',61,6,0,'','admin/structure/token-custom/type/%/delete','Delete custom token','t','','','a:0:{}',6,'','',0,'sites/all/modules/token_custom/token_custom.admin.inc'),('admin/structure/token-custom/type/%/edit','a:1:{i:4;s:22:\"token_custom_type_load\";}','','token_custom_type_forms_access','a:1:{i:0;i:4;}','drupal_get_form','a:3:{i:0;s:27:\"token_custom_type_edit_form\";i:1;s:4:\"edit\";i:2;i:4;}','',61,6,0,'','admin/structure/token-custom/type/%/edit','Edit token type','t','','','a:0:{}',0,'','',0,'sites/all/modules/token_custom/token_custom.admin.inc'),('admin/structure/token-custom/type/add','','','user_access','a:1:{i:0;s:24:\"administer custom tokens\";}','drupal_get_form','a:2:{i:0;s:27:\"token_custom_type_edit_form\";i:1;s:3:\"add\";}','',31,5,1,'admin/structure/token-custom/type','admin/structure/token-custom','Add token type','t','','','a:0:{}',388,'Create custom token types','',2,'sites/all/modules/token_custom/token_custom.admin.inc'),('admin/structure/types','','','user_access','a:1:{i:0;s:24:\"administer content types\";}','node_overview_types','a:0:{}','',7,3,0,'','admin/structure/types','Content types','t','','','a:0:{}',6,'Manage content types, including default status, front page promotion, comment settings, etc.','',0,'modules/node/content_types.inc'),('admin/structure/types/add','','','user_access','a:1:{i:0;s:24:\"administer content types\";}','drupal_get_form','a:1:{i:0;s:14:\"node_type_form\";}','',15,4,1,'admin/structure/types','admin/structure/types','Add content type','t','','','a:0:{}',388,'','',0,'modules/node/content_types.inc'),('admin/structure/types/list','','','user_access','a:1:{i:0;s:24:\"administer content types\";}','node_overview_types','a:0:{}','',15,4,1,'admin/structure/types','admin/structure/types','List','t','','','a:0:{}',140,'','',-10,'modules/node/content_types.inc'),('admin/structure/types/manage/%','a:1:{i:4;s:14:\"node_type_load\";}','','user_access','a:1:{i:0;s:24:\"administer content types\";}','drupal_get_form','a:2:{i:0;s:14:\"node_type_form\";i:1;i:4;}','',30,5,0,'','admin/structure/types/manage/%','Edit content type','node_type_page_title','a:1:{i:0;i:4;}','','a:0:{}',6,'','',0,'modules/node/content_types.inc'),('admin/structure/types/manage/%/comment/display','a:1:{i:4;s:22:\"comment_node_type_load\";}','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:24:\"administer content types\";}}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:7:\"comment\";i:2;i:4;i:3;s:7:\"default\";}','',123,7,1,'admin/structure/types/manage/%','admin/structure/types/manage/%','Comment display','t','','','a:0:{}',132,'','',4,'modules/field_ui/field_ui.admin.inc'),('admin/structure/types/manage/%/comment/display/default','a:1:{i:4;s:22:\"comment_node_type_load\";}','','_field_ui_view_mode_menu_access','a:6:{i:0;s:7:\"comment\";i:1;i:4;i:2;s:7:\"default\";i:3;s:21:\"field_ui_admin_access\";i:4;s:11:\"user_access\";i:5;a:1:{i:0;s:24:\"administer content types\";}}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:7:\"comment\";i:2;i:4;i:3;s:7:\"default\";}','',247,8,1,'admin/structure/types/manage/%/comment/display','admin/structure/types/manage/%','Default','t','','','a:0:{}',140,'','',-10,'modules/field_ui/field_ui.admin.inc'),('admin/structure/types/manage/%/comment/display/full','a:1:{i:4;s:22:\"comment_node_type_load\";}','','_field_ui_view_mode_menu_access','a:6:{i:0;s:7:\"comment\";i:1;i:4;i:2;s:4:\"full\";i:3;s:21:\"field_ui_admin_access\";i:4;s:11:\"user_access\";i:5;a:1:{i:0;s:24:\"administer content types\";}}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:7:\"comment\";i:2;i:4;i:3;s:4:\"full\";}','',247,8,1,'admin/structure/types/manage/%/comment/display','admin/structure/types/manage/%','Full comment','t','','','a:0:{}',132,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/structure/types/manage/%/comment/display/token','a:1:{i:4;s:22:\"comment_node_type_load\";}','','_field_ui_view_mode_menu_access','a:6:{i:0;s:7:\"comment\";i:1;i:4;i:2;s:5:\"token\";i:3;s:21:\"field_ui_admin_access\";i:4;s:11:\"user_access\";i:5;a:1:{i:0;s:24:\"administer content types\";}}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:7:\"comment\";i:2;i:4;i:3;s:5:\"token\";}','',247,8,1,'admin/structure/types/manage/%/comment/display','admin/structure/types/manage/%','Tokens','t','','','a:0:{}',132,'','',1,'modules/field_ui/field_ui.admin.inc'),('admin/structure/types/manage/%/comment/fields','a:1:{i:4;s:22:\"comment_node_type_load\";}','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:24:\"administer content types\";}}','drupal_get_form','a:3:{i:0;s:28:\"field_ui_field_overview_form\";i:1;s:7:\"comment\";i:2;i:4;}','',123,7,1,'admin/structure/types/manage/%','admin/structure/types/manage/%','Comment fields','t','','','a:0:{}',132,'','',3,'modules/field_ui/field_ui.admin.inc'),('admin/structure/types/manage/%/comment/fields/%','a:2:{i:4;a:1:{s:22:\"comment_node_type_load\";a:4:{i:0;s:7:\"comment\";i:1;i:4;i:2;s:1:\"4\";i:3;s:4:\"%map\";}}i:7;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:7:\"comment\";i:1;i:4;i:2;s:1:\"4\";i:3;s:4:\"%map\";}}}','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:24:\"administer content types\";}}','drupal_get_form','a:2:{i:0;s:24:\"field_ui_field_edit_form\";i:1;i:7;}','',246,8,0,'','admin/structure/types/manage/%/comment/fields/%','','field_ui_menu_title','a:1:{i:0;i:7;}','','a:0:{}',6,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/structure/types/manage/%/comment/fields/%/delete','a:2:{i:4;a:1:{s:22:\"comment_node_type_load\";a:4:{i:0;s:7:\"comment\";i:1;i:4;i:2;s:1:\"4\";i:3;s:4:\"%map\";}}i:7;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:7:\"comment\";i:1;i:4;i:2;s:1:\"4\";i:3;s:4:\"%map\";}}}','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:24:\"administer content types\";}}','drupal_get_form','a:2:{i:0;s:26:\"field_ui_field_delete_form\";i:1;i:7;}','',493,9,1,'admin/structure/types/manage/%/comment/fields/%','admin/structure/types/manage/%/comment/fields/%','Delete','t','','','a:0:{}',132,'','',10,'modules/field_ui/field_ui.admin.inc'),('admin/structure/types/manage/%/comment/fields/%/edit','a:2:{i:4;a:1:{s:22:\"comment_node_type_load\";a:4:{i:0;s:7:\"comment\";i:1;i:4;i:2;s:1:\"4\";i:3;s:4:\"%map\";}}i:7;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:7:\"comment\";i:1;i:4;i:2;s:1:\"4\";i:3;s:4:\"%map\";}}}','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:24:\"administer content types\";}}','drupal_get_form','a:2:{i:0;s:24:\"field_ui_field_edit_form\";i:1;i:7;}','',493,9,1,'admin/structure/types/manage/%/comment/fields/%','admin/structure/types/manage/%/comment/fields/%','Edit','t','','','a:0:{}',140,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/structure/types/manage/%/comment/fields/%/field-settings','a:2:{i:4;a:1:{s:22:\"comment_node_type_load\";a:4:{i:0;s:7:\"comment\";i:1;i:4;i:2;s:1:\"4\";i:3;s:4:\"%map\";}}i:7;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:7:\"comment\";i:1;i:4;i:2;s:1:\"4\";i:3;s:4:\"%map\";}}}','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:24:\"administer content types\";}}','drupal_get_form','a:2:{i:0;s:28:\"field_ui_field_settings_form\";i:1;i:7;}','',493,9,1,'admin/structure/types/manage/%/comment/fields/%','admin/structure/types/manage/%/comment/fields/%','Field settings','t','','','a:0:{}',132,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/structure/types/manage/%/comment/fields/%/widget-type','a:2:{i:4;a:1:{s:22:\"comment_node_type_load\";a:4:{i:0;s:7:\"comment\";i:1;i:4;i:2;s:1:\"4\";i:3;s:4:\"%map\";}}i:7;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:7:\"comment\";i:1;i:4;i:2;s:1:\"4\";i:3;s:4:\"%map\";}}}','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:24:\"administer content types\";}}','drupal_get_form','a:2:{i:0;s:25:\"field_ui_widget_type_form\";i:1;i:7;}','',493,9,1,'admin/structure/types/manage/%/comment/fields/%','admin/structure/types/manage/%/comment/fields/%','Widget type','t','','','a:0:{}',132,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/structure/types/manage/%/comment/groups/%/delete','a:2:{i:4;a:1:{s:22:\"comment_node_type_load\";a:4:{i:0;s:7:\"comment\";i:1;i:4;i:2;s:1:\"4\";i:3;s:4:\"%map\";}}i:7;a:1:{s:21:\"field_group_menu_load\";a:4:{i:0;s:7:\"comment\";i:1;i:4;i:2;s:1:\"4\";i:3;s:4:\"%map\";}}}','','user_access','a:1:{i:0;s:24:\"administer content types\";}','drupal_get_form','a:2:{i:0;s:23:\"field_group_delete_form\";i:1;i:7;}','',493,9,0,'','admin/structure/types/manage/%/comment/groups/%/delete','Delete','t','','','a:0:{}',0,'','',0,'sites/all/modules/field_group/field_group.field_ui.inc'),('admin/structure/types/manage/%/comment/groups/%/enable','a:2:{i:4;a:1:{s:22:\"comment_node_type_load\";a:4:{i:0;s:7:\"comment\";i:1;i:4;i:2;s:1:\"4\";i:3;s:4:\"%map\";}}i:7;a:1:{s:21:\"field_group_menu_load\";a:4:{i:0;s:7:\"comment\";i:1;i:4;i:2;s:1:\"4\";i:3;s:4:\"%map\";}}}','','user_access','a:1:{i:0;s:24:\"administer content types\";}','drupal_get_form','a:2:{i:0;s:23:\"field_group_enable_form\";i:1;i:7;}','',493,9,0,'','admin/structure/types/manage/%/comment/groups/%/enable','Enable','t','','','a:0:{}',0,'','',0,'sites/all/modules/field_group/field_group.field_ui.inc'),('admin/structure/types/manage/%/delete','a:1:{i:4;s:14:\"node_type_load\";}','','user_access','a:1:{i:0;s:24:\"administer content types\";}','drupal_get_form','a:2:{i:0;s:24:\"node_type_delete_confirm\";i:1;i:4;}','',61,6,0,'','admin/structure/types/manage/%/delete','Delete','t','','','a:0:{}',6,'','',0,'modules/node/content_types.inc'),('admin/structure/types/manage/%/display','a:1:{i:4;s:14:\"node_type_load\";}','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:24:\"administer content types\";}}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:4:\"node\";i:2;i:4;i:3;s:7:\"default\";}','',61,6,1,'admin/structure/types/manage/%','admin/structure/types/manage/%','Manage display','t','','','a:0:{}',132,'','',2,'modules/field_ui/field_ui.admin.inc'),('admin/structure/types/manage/%/display/default','a:1:{i:4;s:14:\"node_type_load\";}','','_field_ui_view_mode_menu_access','a:6:{i:0;s:4:\"node\";i:1;i:4;i:2;s:7:\"default\";i:3;s:21:\"field_ui_admin_access\";i:4;s:11:\"user_access\";i:5;a:1:{i:0;s:24:\"administer content types\";}}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:4:\"node\";i:2;i:4;i:3;s:7:\"default\";}','',123,7,1,'admin/structure/types/manage/%/display','admin/structure/types/manage/%','Default','t','','','a:0:{}',140,'','',-10,'modules/field_ui/field_ui.admin.inc'),('admin/structure/types/manage/%/display/full','a:1:{i:4;s:14:\"node_type_load\";}','','_field_ui_view_mode_menu_access','a:6:{i:0;s:4:\"node\";i:1;i:4;i:2;s:4:\"full\";i:3;s:21:\"field_ui_admin_access\";i:4;s:11:\"user_access\";i:5;a:1:{i:0;s:24:\"administer content types\";}}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:4:\"node\";i:2;i:4;i:3;s:4:\"full\";}','',123,7,1,'admin/structure/types/manage/%/display','admin/structure/types/manage/%','Full content','t','','','a:0:{}',132,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/structure/types/manage/%/display/print','a:1:{i:4;s:14:\"node_type_load\";}','','_field_ui_view_mode_menu_access','a:6:{i:0;s:4:\"node\";i:1;i:4;i:2;s:5:\"print\";i:3;s:21:\"field_ui_admin_access\";i:4;s:11:\"user_access\";i:5;a:1:{i:0;s:24:\"administer content types\";}}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:4:\"node\";i:2;i:4;i:3;s:5:\"print\";}','',123,7,1,'admin/structure/types/manage/%/display','admin/structure/types/manage/%','Print','t','','','a:0:{}',132,'','',5,'modules/field_ui/field_ui.admin.inc'),('admin/structure/types/manage/%/display/rss','a:1:{i:4;s:14:\"node_type_load\";}','','_field_ui_view_mode_menu_access','a:6:{i:0;s:4:\"node\";i:1;i:4;i:2;s:3:\"rss\";i:3;s:21:\"field_ui_admin_access\";i:4;s:11:\"user_access\";i:5;a:1:{i:0;s:24:\"administer content types\";}}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:4:\"node\";i:2;i:4;i:3;s:3:\"rss\";}','',123,7,1,'admin/structure/types/manage/%/display','admin/structure/types/manage/%','RSS','t','','','a:0:{}',132,'','',2,'modules/field_ui/field_ui.admin.inc'),('admin/structure/types/manage/%/display/search_index','a:1:{i:4;s:14:\"node_type_load\";}','','_field_ui_view_mode_menu_access','a:6:{i:0;s:4:\"node\";i:1;i:4;i:2;s:12:\"search_index\";i:3;s:21:\"field_ui_admin_access\";i:4;s:11:\"user_access\";i:5;a:1:{i:0;s:24:\"administer content types\";}}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:4:\"node\";i:2;i:4;i:3;s:12:\"search_index\";}','',123,7,1,'admin/structure/types/manage/%/display','admin/structure/types/manage/%','Search index','t','','','a:0:{}',132,'','',3,'modules/field_ui/field_ui.admin.inc'),('admin/structure/types/manage/%/display/search_result','a:1:{i:4;s:14:\"node_type_load\";}','','_field_ui_view_mode_menu_access','a:6:{i:0;s:4:\"node\";i:1;i:4;i:2;s:13:\"search_result\";i:3;s:21:\"field_ui_admin_access\";i:4;s:11:\"user_access\";i:5;a:1:{i:0;s:24:\"administer content types\";}}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:4:\"node\";i:2;i:4;i:3;s:13:\"search_result\";}','',123,7,1,'admin/structure/types/manage/%/display','admin/structure/types/manage/%','Search result highlighting input','t','','','a:0:{}',132,'','',4,'modules/field_ui/field_ui.admin.inc'),('admin/structure/types/manage/%/display/teaser','a:1:{i:4;s:14:\"node_type_load\";}','','_field_ui_view_mode_menu_access','a:6:{i:0;s:4:\"node\";i:1;i:4;i:2;s:6:\"teaser\";i:3;s:21:\"field_ui_admin_access\";i:4;s:11:\"user_access\";i:5;a:1:{i:0;s:24:\"administer content types\";}}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:4:\"node\";i:2;i:4;i:3;s:6:\"teaser\";}','',123,7,1,'admin/structure/types/manage/%/display','admin/structure/types/manage/%','Teaser','t','','','a:0:{}',132,'','',1,'modules/field_ui/field_ui.admin.inc'),('admin/structure/types/manage/%/display/token','a:1:{i:4;s:14:\"node_type_load\";}','','_field_ui_view_mode_menu_access','a:6:{i:0;s:4:\"node\";i:1;i:4;i:2;s:5:\"token\";i:3;s:21:\"field_ui_admin_access\";i:4;s:11:\"user_access\";i:5;a:1:{i:0;s:24:\"administer content types\";}}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:4:\"node\";i:2;i:4;i:3;s:5:\"token\";}','',123,7,1,'admin/structure/types/manage/%/display','admin/structure/types/manage/%','Tokens','t','','','a:0:{}',132,'','',6,'modules/field_ui/field_ui.admin.inc'),('admin/structure/types/manage/%/edit','a:1:{i:4;s:14:\"node_type_load\";}','','user_access','a:1:{i:0;s:24:\"administer content types\";}','drupal_get_form','a:2:{i:0;s:14:\"node_type_form\";i:1;i:4;}','',61,6,1,'admin/structure/types/manage/%','admin/structure/types/manage/%','Edit','t','','','a:0:{}',140,'','',0,'modules/node/content_types.inc'),('admin/structure/types/manage/%/fields','a:1:{i:4;s:14:\"node_type_load\";}','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:24:\"administer content types\";}}','drupal_get_form','a:3:{i:0;s:28:\"field_ui_field_overview_form\";i:1;s:4:\"node\";i:2;i:4;}','',61,6,1,'admin/structure/types/manage/%','admin/structure/types/manage/%','Manage fields','t','','','a:0:{}',132,'','',1,'modules/field_ui/field_ui.admin.inc'),('admin/structure/types/manage/%/fields/%','a:2:{i:4;a:1:{s:14:\"node_type_load\";a:4:{i:0;s:4:\"node\";i:1;i:4;i:2;s:1:\"4\";i:3;s:4:\"%map\";}}i:6;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:4:\"node\";i:1;i:4;i:2;s:1:\"4\";i:3;s:4:\"%map\";}}}','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:24:\"administer content types\";}}','drupal_get_form','a:2:{i:0;s:24:\"field_ui_field_edit_form\";i:1;i:6;}','',122,7,0,'','admin/structure/types/manage/%/fields/%','','field_ui_menu_title','a:1:{i:0;i:6;}','','a:0:{}',6,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/structure/types/manage/%/fields/%/delete','a:2:{i:4;a:1:{s:14:\"node_type_load\";a:4:{i:0;s:4:\"node\";i:1;i:4;i:2;s:1:\"4\";i:3;s:4:\"%map\";}}i:6;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:4:\"node\";i:1;i:4;i:2;s:1:\"4\";i:3;s:4:\"%map\";}}}','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:24:\"administer content types\";}}','drupal_get_form','a:2:{i:0;s:26:\"field_ui_field_delete_form\";i:1;i:6;}','',245,8,1,'admin/structure/types/manage/%/fields/%','admin/structure/types/manage/%/fields/%','Delete','t','','','a:0:{}',132,'','',10,'modules/field_ui/field_ui.admin.inc'),('admin/structure/types/manage/%/fields/%/edit','a:2:{i:4;a:1:{s:14:\"node_type_load\";a:4:{i:0;s:4:\"node\";i:1;i:4;i:2;s:1:\"4\";i:3;s:4:\"%map\";}}i:6;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:4:\"node\";i:1;i:4;i:2;s:1:\"4\";i:3;s:4:\"%map\";}}}','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:24:\"administer content types\";}}','drupal_get_form','a:2:{i:0;s:24:\"field_ui_field_edit_form\";i:1;i:6;}','',245,8,1,'admin/structure/types/manage/%/fields/%','admin/structure/types/manage/%/fields/%','Edit','t','','','a:0:{}',140,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/structure/types/manage/%/fields/%/field-settings','a:2:{i:4;a:1:{s:14:\"node_type_load\";a:4:{i:0;s:4:\"node\";i:1;i:4;i:2;s:1:\"4\";i:3;s:4:\"%map\";}}i:6;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:4:\"node\";i:1;i:4;i:2;s:1:\"4\";i:3;s:4:\"%map\";}}}','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:24:\"administer content types\";}}','drupal_get_form','a:2:{i:0;s:28:\"field_ui_field_settings_form\";i:1;i:6;}','',245,8,1,'admin/structure/types/manage/%/fields/%','admin/structure/types/manage/%/fields/%','Field settings','t','','','a:0:{}',132,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/structure/types/manage/%/fields/%/widget-type','a:2:{i:4;a:1:{s:14:\"node_type_load\";a:4:{i:0;s:4:\"node\";i:1;i:4;i:2;s:1:\"4\";i:3;s:4:\"%map\";}}i:6;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:4:\"node\";i:1;i:4;i:2;s:1:\"4\";i:3;s:4:\"%map\";}}}','','field_ui_admin_access','a:2:{i:0;s:11:\"user_access\";i:1;a:1:{i:0;s:24:\"administer content types\";}}','drupal_get_form','a:2:{i:0;s:25:\"field_ui_widget_type_form\";i:1;i:6;}','',245,8,1,'admin/structure/types/manage/%/fields/%','admin/structure/types/manage/%/fields/%','Widget type','t','','','a:0:{}',132,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/structure/types/manage/%/groups/%/delete','a:2:{i:4;a:1:{s:14:\"node_type_load\";a:4:{i:0;s:4:\"node\";i:1;i:4;i:2;s:1:\"4\";i:3;s:4:\"%map\";}}i:6;a:1:{s:21:\"field_group_menu_load\";a:4:{i:0;s:4:\"node\";i:1;i:4;i:2;s:1:\"4\";i:3;s:4:\"%map\";}}}','','user_access','a:1:{i:0;s:24:\"administer content types\";}','drupal_get_form','a:2:{i:0;s:23:\"field_group_delete_form\";i:1;i:6;}','',245,8,0,'','admin/structure/types/manage/%/groups/%/delete','Delete','t','','','a:0:{}',0,'','',0,'sites/all/modules/field_group/field_group.field_ui.inc'),('admin/structure/types/manage/%/groups/%/enable','a:2:{i:4;a:1:{s:14:\"node_type_load\";a:4:{i:0;s:4:\"node\";i:1;i:4;i:2;s:1:\"4\";i:3;s:4:\"%map\";}}i:6;a:1:{s:21:\"field_group_menu_load\";a:4:{i:0;s:4:\"node\";i:1;i:4;i:2;s:1:\"4\";i:3;s:4:\"%map\";}}}','','user_access','a:1:{i:0;s:24:\"administer content types\";}','drupal_get_form','a:2:{i:0;s:23:\"field_group_enable_form\";i:1;i:6;}','',245,8,0,'','admin/structure/types/manage/%/groups/%/enable','Enable','t','','','a:0:{}',0,'','',0,'sites/all/modules/field_group/field_group.field_ui.inc'),('admin/structure/views','','','ctools_export_ui_task_access','a:2:{i:0;s:8:\"views_ui\";i:1;s:4:\"list\";}','ctools_export_ui_switcher_page','a:2:{i:0;s:8:\"views_ui\";i:1;s:4:\"list\";}','',7,3,0,'','admin/structure/views','Views','t','','','a:0:{}',6,'Manage customized lists of content.','',0,'sites/all/modules/ctools/includes/export-ui.inc'),('admin/structure/views/add','','','user_access','a:1:{i:0;s:16:\"administer views\";}','views_ui_add_page','a:0:{}','',15,4,1,'admin/structure/views','admin/structure/views','Add new view','t','','','a:0:{}',388,'','',0,'sites/all/modules/views/includes/admin.inc'),('admin/structure/views/add-template','','','user_access','a:1:{i:0;s:16:\"administer views\";}','views_ui_add_template_page','a:0:{}','',15,4,1,'admin/structure/views','admin/structure/views','Add view from template','t','','','a:0:{}',388,'','',0,'sites/all/modules/views/includes/admin.inc'),('admin/structure/views/ajax/%/%','a:2:{i:4;N;i:5;s:19:\"views_ui_cache_load\";}','','user_access','a:1:{i:0;s:16:\"administer views\";}','views_ui_ajax_form','a:3:{i:0;b:1;i:1;i:4;i:2;i:5;}','ajax_deliver',60,6,0,'','admin/structure/views/ajax/%/%','','t','','','a:0:{}',0,'','',0,'sites/all/modules/views/includes/admin.inc'),('admin/structure/views/ajax/preview/%/%','a:2:{i:5;s:19:\"views_ui_cache_load\";i:6;N;}','','user_access','a:1:{i:0;s:16:\"administer views\";}','views_ui_preview','a:2:{i:0;i:5;i:1;i:6;}','ajax_deliver',124,7,0,'','admin/structure/views/ajax/preview/%/%','','t','','','a:0:{}',6,'','',0,'sites/all/modules/views/includes/admin.inc'),('admin/structure/views/import','','','views_import_access','a:1:{i:0;s:16:\"administer views\";}','drupal_get_form','a:1:{i:0;s:20:\"views_ui_import_page\";}','',15,4,1,'admin/structure/views','admin/structure/views','Import','t','','','a:0:{}',388,'','',0,'sites/all/modules/views/includes/admin.inc'),('admin/structure/views/list','','','ctools_export_ui_task_access','a:2:{i:0;s:8:\"views_ui\";i:1;s:4:\"list\";}','ctools_export_ui_switcher_page','a:2:{i:0;s:8:\"views_ui\";i:1;s:4:\"list\";}','',15,4,1,'admin/structure/views','admin/structure/views','List','t','','','a:0:{}',140,'','',-10,'sites/all/modules/ctools/includes/export-ui.inc'),('admin/structure/views/nojs/%/%','a:2:{i:4;N;i:5;s:19:\"views_ui_cache_load\";}','','user_access','a:1:{i:0;s:16:\"administer views\";}','views_ui_ajax_form','a:3:{i:0;b:0;i:1;i:4;i:2;i:5;}','',60,6,0,'','admin/structure/views/nojs/%/%','','t','','','a:0:{}',0,'','',0,'sites/all/modules/views/includes/admin.inc'),('admin/structure/views/nojs/preview/%/%','a:2:{i:5;s:19:\"views_ui_cache_load\";i:6;N;}','','user_access','a:1:{i:0;s:16:\"administer views\";}','views_ui_preview','a:2:{i:0;i:5;i:1;i:6;}','',124,7,0,'','admin/structure/views/nojs/preview/%/%','','t','','','a:0:{}',6,'','',0,'sites/all/modules/views/includes/admin.inc'),('admin/structure/views/settings','','','user_access','a:1:{i:0;s:16:\"administer views\";}','drupal_get_form','a:1:{i:0;s:29:\"views_ui_admin_settings_basic\";}','',15,4,1,'admin/structure/views','admin/structure/views','Settings','t','','','a:0:{}',132,'','',0,'sites/all/modules/views/includes/admin.inc'),('admin/structure/views/settings/advanced','','','user_access','a:1:{i:0;s:16:\"administer views\";}','drupal_get_form','a:1:{i:0;s:32:\"views_ui_admin_settings_advanced\";}','',31,5,1,'admin/structure/views/settings','admin/structure/views','Advanced','t','','','a:0:{}',132,'','',1,'sites/all/modules/views/includes/admin.inc'),('admin/structure/views/settings/basic','','','user_access','a:1:{i:0;s:16:\"administer views\";}','drupal_get_form','a:1:{i:0;s:29:\"views_ui_admin_settings_basic\";}','',31,5,1,'admin/structure/views/settings','admin/structure/views','Basic','t','','','a:0:{}',140,'','',0,'sites/all/modules/views/includes/admin.inc'),('admin/structure/views/template/%/add','a:1:{i:4;N;}','','ctools_export_ui_task_access','a:3:{i:0;s:8:\"views_ui\";i:1;s:12:\"add_template\";i:2;i:4;}','ctools_export_ui_switcher_page','a:3:{i:0;s:8:\"views_ui\";i:1;s:12:\"add_template\";i:2;i:4;}','',61,6,0,'','admin/structure/views/template/%/add','Add from template','t','','','a:0:{}',0,'','',0,'sites/all/modules/ctools/includes/export-ui.inc'),('admin/structure/views/view/%','a:1:{i:4;s:19:\"views_ui_cache_load\";}','','user_access','a:1:{i:0;s:16:\"administer views\";}','views_ui_edit_page','a:1:{i:0;i:4;}','',30,5,0,'','admin/structure/views/view/%','','views_ui_edit_page_title','a:1:{i:0;i:4;}','','a:0:{}',6,'','',0,'sites/all/modules/views/includes/admin.inc'),('admin/structure/views/view/%/break-lock','a:1:{i:4;s:19:\"views_ui_cache_load\";}','','user_access','a:1:{i:0;s:16:\"administer views\";}','drupal_get_form','a:2:{i:0;s:27:\"views_ui_break_lock_confirm\";i:1;i:4;}','',61,6,0,'','admin/structure/views/view/%/break-lock','Break lock','t','','','a:0:{}',4,'','',0,'sites/all/modules/views/includes/admin.inc'),('admin/structure/views/view/%/clone','a:1:{i:4;a:1:{s:21:\"ctools_export_ui_load\";a:1:{i:0;s:8:\"views_ui\";}}}','','ctools_export_ui_task_access','a:3:{i:0;s:8:\"views_ui\";i:1;s:5:\"clone\";i:2;i:4;}','ctools_export_ui_switcher_page','a:3:{i:0;s:8:\"views_ui\";i:1;s:5:\"clone\";i:2;i:4;}','',61,6,0,'','admin/structure/views/view/%/clone','Clone','t','','','a:0:{}',4,'','',0,'sites/all/modules/ctools/includes/export-ui.inc'),('admin/structure/views/view/%/delete','a:1:{i:4;a:1:{s:21:\"ctools_export_ui_load\";a:1:{i:0;s:8:\"views_ui\";}}}','','ctools_export_ui_task_access','a:3:{i:0;s:8:\"views_ui\";i:1;s:6:\"delete\";i:2;i:4;}','ctools_export_ui_switcher_page','a:3:{i:0;s:8:\"views_ui\";i:1;s:6:\"delete\";i:2;i:4;}','',61,6,0,'','admin/structure/views/view/%/delete','Delete','t','','','a:0:{}',4,'','',0,'sites/all/modules/ctools/includes/export-ui.inc'),('admin/structure/views/view/%/disable','a:1:{i:4;a:1:{s:21:\"ctools_export_ui_load\";a:1:{i:0;s:8:\"views_ui\";}}}','','ctools_export_ui_task_access','a:3:{i:0;s:8:\"views_ui\";i:1;s:7:\"disable\";i:2;i:4;}','ctools_export_ui_switcher_page','a:3:{i:0;s:8:\"views_ui\";i:1;s:7:\"disable\";i:2;i:4;}','',61,6,0,'','admin/structure/views/view/%/disable','Disable','t','','','a:0:{}',0,'','',0,'sites/all/modules/ctools/includes/export-ui.inc'),('admin/structure/views/view/%/edit','a:1:{i:4;s:19:\"views_ui_cache_load\";}','','user_access','a:1:{i:0;s:16:\"administer views\";}','views_ui_edit_page','a:1:{i:0;i:4;}','',61,6,3,'admin/structure/views/view/%','admin/structure/views/view/%','Edit view','t','','ajax_base_page_theme','a:0:{}',140,'','',-10,'sites/all/modules/views/includes/admin.inc'),('admin/structure/views/view/%/edit/%/ajax','a:2:{i:4;s:19:\"views_ui_cache_load\";i:6;N;}','','user_access','a:1:{i:0;s:16:\"administer views\";}','views_ui_ajax_get_form','a:3:{i:0;s:18:\"views_ui_edit_form\";i:1;i:4;i:2;i:6;}','ajax_deliver',245,8,0,'','admin/structure/views/view/%/edit/%/ajax','','t','','ajax_base_page_theme','a:0:{}',0,'','',0,'sites/all/modules/views/includes/admin.inc'),('admin/structure/views/view/%/enable','a:1:{i:4;a:1:{s:21:\"ctools_export_ui_load\";a:1:{i:0;s:8:\"views_ui\";}}}','','ctools_export_ui_task_access','a:3:{i:0;s:8:\"views_ui\";i:1;s:6:\"enable\";i:2;i:4;}','ctools_export_ui_switcher_page','a:3:{i:0;s:8:\"views_ui\";i:1;s:6:\"enable\";i:2;i:4;}','',61,6,0,'','admin/structure/views/view/%/enable','Enable','t','','','a:0:{}',0,'','',0,'sites/all/modules/ctools/includes/export-ui.inc'),('admin/structure/views/view/%/export','a:1:{i:4;a:1:{s:21:\"ctools_export_ui_load\";a:1:{i:0;s:8:\"views_ui\";}}}','','ctools_export_ui_task_access','a:3:{i:0;s:8:\"views_ui\";i:1;s:6:\"export\";i:2;i:4;}','ctools_export_ui_switcher_page','a:3:{i:0;s:8:\"views_ui\";i:1;s:6:\"export\";i:2;i:4;}','',61,6,0,'','admin/structure/views/view/%/export','Export','t','','','a:0:{}',4,'','',0,'sites/all/modules/ctools/includes/export-ui.inc'),('admin/structure/views/view/%/preview/%','a:2:{i:4;s:19:\"views_ui_cache_load\";i:6;N;}','','user_access','a:1:{i:0;s:16:\"administer views\";}','views_ui_build_preview','a:2:{i:0;i:4;i:1;i:6;}','',122,7,3,'','admin/structure/views/view/%/preview/%','','t','','','a:0:{}',4,'','',0,'sites/all/modules/views/includes/admin.inc'),('admin/structure/views/view/%/preview/%/ajax','a:2:{i:4;s:19:\"views_ui_cache_load\";i:6;N;}','','user_access','a:1:{i:0;s:16:\"administer views\";}','views_ui_build_preview','a:2:{i:0;i:4;i:1;i:6;}','ajax_deliver',245,8,0,'','admin/structure/views/view/%/preview/%/ajax','','t','','ajax_base_page_theme','a:0:{}',0,'','',0,'sites/all/modules/views/includes/admin.inc'),('admin/structure/views/view/%/revert','a:1:{i:4;a:1:{s:21:\"ctools_export_ui_load\";a:1:{i:0;s:8:\"views_ui\";}}}','','ctools_export_ui_task_access','a:3:{i:0;s:8:\"views_ui\";i:1;s:6:\"revert\";i:2;i:4;}','ctools_export_ui_switcher_page','a:3:{i:0;s:8:\"views_ui\";i:1;s:6:\"delete\";i:2;i:4;}','',61,6,0,'','admin/structure/views/view/%/revert','Revert','t','','','a:0:{}',4,'','',0,'sites/all/modules/ctools/includes/export-ui.inc'),('admin/tasks','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','system_admin_menu_block_page','a:0:{}','',3,2,1,'admin','admin','Tasks','t','','','a:0:{}',140,'','',-20,'modules/system/system.admin.inc'),('admin/update/ready','','','update_manager_access','a:0:{}','drupal_get_form','a:1:{i:0;s:32:\"update_manager_update_ready_form\";}','',7,3,0,'','admin/update/ready','Ready to update','t','','','a:0:{}',0,'','',0,'modules/update/update.manager.inc'),('admin/views/ajax/autocomplete/tag','','','user_access','a:1:{i:0;s:16:\"administer views\";}','views_ui_autocomplete_tag','a:0:{}','',31,5,0,'','admin/views/ajax/autocomplete/tag','','t','','','a:0:{}',0,'','',0,'sites/all/modules/views/includes/admin.inc'),('admin/views/ajax/autocomplete/taxonomy','','','user_access','a:1:{i:0;s:14:\"access content\";}','views_ajax_autocomplete_taxonomy','a:0:{}','',31,5,0,'','admin/views/ajax/autocomplete/taxonomy','','t','','ajax_base_page_theme','a:0:{}',0,'','',0,'sites/all/modules/views/includes/ajax.inc'),('admin/views/ajax/autocomplete/user','','','user_access','a:1:{i:0;s:20:\"access user profiles\";}','views_ajax_autocomplete_user','a:0:{}','',31,5,0,'','admin/views/ajax/autocomplete/user','','t','','ajax_base_page_theme','a:0:{}',0,'','',0,'sites/all/modules/views/includes/ajax.inc'),('admin_menu/flush-cache','','','user_access','a:1:{i:0;s:12:\"flush caches\";}','admin_menu_flush_cache','a:0:{}','',3,2,0,'','admin_menu/flush-cache','','t','','','a:0:{}',0,'','',0,'sites/all/modules/admin_menu/admin_menu.inc'),('archive','','','views_access','a:1:{i:0;b:1;}','views_page','a:2:{i:0;s:7:\"archive\";i:1;s:4:\"page\";}','',1,1,0,'','archive','Archive','t','','','a:0:{}',6,'','',0,''),('articles','','','views_access','a:1:{i:0;a:2:{i:0;s:16:\"views_check_perm\";i:1;a:1:{i:0;s:14:\"access content\";}}}','views_page','a:2:{i:0;s:8:\"articles\";i:1;s:4:\"page\";}','',1,1,0,'','articles','Articles','t','','','a:0:{}',6,'','',0,''),('articles-teaser','','','views_access','a:1:{i:0;a:2:{i:0;s:16:\"views_check_perm\";i:1;a:1:{i:0;s:14:\"access content\";}}}','views_page','a:2:{i:0;s:8:\"articles\";i:1;s:6:\"page_1\";}','',1,1,0,'','articles-teaser','Articles Teaser','t','','','a:0:{}',6,'','',0,''),('articles/three','','','views_access','a:1:{i:0;a:2:{i:0;s:16:\"views_check_perm\";i:1;a:1:{i:0;s:14:\"access content\";}}}','views_page','a:2:{i:0;s:8:\"articles\";i:1;s:6:\"page_3\";}','',3,2,0,'','articles/three','Three Columns','t','','','a:0:{}',6,'','',0,''),('articles/two','','','views_access','a:1:{i:0;a:2:{i:0;s:16:\"views_check_perm\";i:1;a:1:{i:0;s:14:\"access content\";}}}','views_page','a:2:{i:0;s:8:\"articles\";i:1;s:6:\"page_2\";}','',3,2,0,'','articles/two','Two Columns','t','','','a:0:{}',6,'','',0,''),('batch','','','1','a:0:{}','system_batch_page','a:0:{}','',1,1,0,'','batch','','t','','_system_batch_theme','a:0:{}',0,'','',0,'modules/system/system.admin.inc'),('blog','','','user_access','a:1:{i:0;s:14:\"access content\";}','blog_page_last','a:0:{}','',1,1,0,'','blog','Blogs','t','','','a:0:{}',20,'','',0,'modules/blog/blog.pages.inc'),('blog/%','a:1:{i:1;s:22:\"user_uid_optional_load\";}','a:1:{i:1;s:24:\"user_uid_optional_to_arg\";}','blog_page_user_access','a:1:{i:0;i:1;}','blog_page_user','a:1:{i:0;i:1;}','',2,2,0,'','blog/%','My blog','t','','','a:0:{}',6,'','',0,'modules/blog/blog.pages.inc'),('blog/%/feed','a:1:{i:1;s:9:\"user_load\";}','','blog_page_user_access','a:1:{i:0;i:1;}','blog_feed_user','a:1:{i:0;i:1;}','',5,3,0,'','blog/%/feed','Blogs','t','','','a:0:{}',0,'','',0,'modules/blog/blog.pages.inc'),('blog/feed','','','user_access','a:1:{i:0;s:14:\"access content\";}','blog_feed_last','a:0:{}','',3,2,0,'','blog/feed','Blogs','t','','','a:0:{}',0,'','',0,'modules/blog/blog.pages.inc'),('blogs','','','views_access','a:1:{i:0;a:2:{i:0;s:16:\"views_check_perm\";i:1;a:1:{i:0;s:14:\"access content\";}}}','views_page','a:2:{i:0;s:5:\"blogs\";i:1;s:6:\"page_1\";}','',1,1,0,'','blogs','Blogs','t','','','a:0:{}',6,'','',0,''),('blogs/mix','','','views_access','a:1:{i:0;a:2:{i:0;s:16:\"views_check_perm\";i:1;a:1:{i:0;s:14:\"access content\";}}}','views_page','a:2:{i:0;s:5:\"blogs\";i:1;s:6:\"page_4\";}','',3,2,0,'','blogs/mix','Blog Mix','t','','','a:0:{}',6,'','',0,''),('blogs/teaser','','','views_access','a:1:{i:0;a:2:{i:0;s:16:\"views_check_perm\";i:1;a:1:{i:0;s:14:\"access content\";}}}','views_page','a:2:{i:0;s:5:\"blogs\";i:1;s:4:\"page\";}','',3,2,0,'','blogs/teaser','Blogs Teaser','t','','','a:0:{}',6,'','',0,''),('blogs/three','','','views_access','a:1:{i:0;a:2:{i:0;s:16:\"views_check_perm\";i:1;a:1:{i:0;s:14:\"access content\";}}}','views_page','a:2:{i:0;s:5:\"blogs\";i:1;s:6:\"page_3\";}','',3,2,0,'','blogs/three','Three Columns','t','','','a:0:{}',6,'','',0,''),('blogs/two','','','views_access','a:1:{i:0;a:2:{i:0;s:16:\"views_check_perm\";i:1;a:1:{i:0;s:14:\"access content\";}}}','views_page','a:2:{i:0;s:5:\"blogs\";i:1;s:6:\"page_2\";}','',3,2,0,'','blogs/two','Two Columns','t','','','a:0:{}',6,'','',0,''),('book','','','user_access','a:1:{i:0;s:14:\"access content\";}','book_render','a:0:{}','',1,1,0,'','book','Books','t','','','a:0:{}',20,'','',0,'modules/book/book.pages.inc'),('book/export/%/%','a:2:{i:2;N;i:3;N;}','','user_access','a:1:{i:0;s:31:\"access printer-friendly version\";}','book_export','a:2:{i:0;i:2;i:1;i:3;}','',12,4,0,'','book/export/%/%','','t','','','a:0:{}',0,'','',0,'modules/book/book.pages.inc'),('calendar','','','views_access','a:1:{i:0;a:2:{i:0;s:16:\"views_check_perm\";i:1;a:1:{i:0;s:14:\"access content\";}}}','views_page','a:2:{i:0;s:8:\"calendar\";i:1;s:4:\"page\";}','',1,1,0,'','calendar','Calendar','t','','','a:0:{}',6,'','',0,''),('ckeditor/disable/wysiwyg/%','a:1:{i:3;N;}','','1','a:1:{i:0;s:19:\"administer ckeditor\";}','ckeditor_disable_wysiwyg','a:1:{i:0;i:3;}','',14,4,0,'','ckeditor/disable/wysiwyg/%','Disable the WYSIWYG module','t','','','a:0:{}',0,'Disable WYSIWYG module.','',0,'sites/all/modules/ckeditor/includes/ckeditor.admin.inc'),('ckeditor/xss','','','1','a:0:{}','ckeditor_filter_xss','a:0:{}','',3,2,0,'','ckeditor/xss','XSS Filter','t','','','a:0:{}',0,'XSS Filter.','',0,'sites/all/modules/ckeditor/includes/ckeditor.page.inc'),('comment/%','a:1:{i:1;N;}','','user_access','a:1:{i:0;s:15:\"access comments\";}','comment_permalink','a:1:{i:0;i:1;}','',2,2,0,'','comment/%','Comment permalink','t','','','a:0:{}',6,'','',0,''),('comment/%/approve','a:1:{i:1;N;}','','user_access','a:1:{i:0;s:19:\"administer comments\";}','comment_approve','a:1:{i:0;i:1;}','',5,3,0,'','comment/%/approve','Approve','t','','','a:0:{}',6,'','',1,'modules/comment/comment.pages.inc'),('comment/%/delete','a:1:{i:1;N;}','','user_access','a:1:{i:0;s:19:\"administer comments\";}','comment_confirm_delete_page','a:1:{i:0;i:1;}','',5,3,1,'comment/%','comment/%','Delete','t','','','a:0:{}',132,'','',2,'modules/comment/comment.admin.inc'),('comment/%/edit','a:1:{i:1;s:12:\"comment_load\";}','','comment_access','a:2:{i:0;s:4:\"edit\";i:1;i:1;}','comment_edit_page','a:1:{i:0;i:1;}','',5,3,1,'comment/%','comment/%','Edit','t','','','a:0:{}',132,'','',0,''),('comment/%/view','a:1:{i:1;N;}','','user_access','a:1:{i:0;s:15:\"access comments\";}','comment_permalink','a:1:{i:0;i:1;}','',5,3,1,'comment/%','comment/%','View comment','t','','','a:0:{}',140,'','',-10,''),('comment/reply/%','a:1:{i:2;s:9:\"node_load\";}','','node_access','a:2:{i:0;s:4:\"view\";i:1;i:2;}','comment_reply','a:1:{i:0;i:2;}','',6,3,0,'','comment/reply/%','Add new comment','t','','','a:0:{}',6,'','',0,'modules/comment/comment.pages.inc'),('contact','','','user_access','a:1:{i:0;s:29:\"access site-wide contact form\";}','drupal_get_form','a:1:{i:0;s:17:\"contact_site_form\";}','',1,1,0,'','contact','Contact','t','','','a:0:{}',20,'','',0,'modules/contact/contact.pages.inc'),('ctools/autocomplete/%','a:1:{i:2;N;}','','user_access','a:1:{i:0;s:14:\"access content\";}','ctools_content_autocomplete_entity','a:1:{i:0;i:2;}','',6,3,0,'','ctools/autocomplete/%','','t','','','a:0:{}',0,'','',0,'sites/all/modules/ctools/includes/content.menu.inc'),('ctools/context/ajax/access/add','','','user_access','a:1:{i:0;s:14:\"access content\";}','ctools_access_ajax_add','a:0:{}','',31,5,0,'','ctools/context/ajax/access/add','','t','','ajax_base_page_theme','a:0:{}',0,'','',0,'sites/all/modules/ctools/includes/context-access-admin.inc'),('ctools/context/ajax/access/configure','','','user_access','a:1:{i:0;s:14:\"access content\";}','ctools_access_ajax_edit','a:0:{}','',31,5,0,'','ctools/context/ajax/access/configure','','t','','ajax_base_page_theme','a:0:{}',0,'','',0,'sites/all/modules/ctools/includes/context-access-admin.inc'),('ctools/context/ajax/access/delete','','','user_access','a:1:{i:0;s:14:\"access content\";}','ctools_access_ajax_delete','a:0:{}','',31,5,0,'','ctools/context/ajax/access/delete','','t','','ajax_base_page_theme','a:0:{}',0,'','',0,'sites/all/modules/ctools/includes/context-access-admin.inc'),('ctools/context/ajax/add','','','user_access','a:1:{i:0;s:14:\"access content\";}','ctools_context_ajax_item_add','a:0:{}','',15,4,0,'','ctools/context/ajax/add','','t','','ajax_base_page_theme','a:0:{}',0,'','',0,'sites/all/modules/ctools/includes/context-admin.inc'),('ctools/context/ajax/configure','','','user_access','a:1:{i:0;s:14:\"access content\";}','ctools_context_ajax_item_edit','a:0:{}','',15,4,0,'','ctools/context/ajax/configure','','t','','ajax_base_page_theme','a:0:{}',0,'','',0,'sites/all/modules/ctools/includes/context-admin.inc'),('ctools/context/ajax/delete','','','user_access','a:1:{i:0;s:14:\"access content\";}','ctools_context_ajax_item_delete','a:0:{}','',15,4,0,'','ctools/context/ajax/delete','','t','','ajax_base_page_theme','a:0:{}',0,'','',0,'sites/all/modules/ctools/includes/context-admin.inc'),('entityreference/autocomplete/single/%/%/%','a:3:{i:3;N;i:4;N;i:5;N;}','','entityreference_autocomplete_access_callback','a:4:{i:0;i:2;i:1;i:3;i:2;i:4;i:3;i:5;}','entityreference_autocomplete_callback','a:4:{i:0;i:2;i:1;i:3;i:2;i:4;i:3;i:5;}','',56,6,0,'','entityreference/autocomplete/single/%/%/%','Entity Reference Autocomplete','t','','','a:0:{}',0,'','',0,''),('entityreference/autocomplete/tags/%/%/%','a:3:{i:3;N;i:4;N;i:5;N;}','','entityreference_autocomplete_access_callback','a:4:{i:0;i:2;i:1;i:3;i:2;i:4;i:3;i:5;}','entityreference_autocomplete_callback','a:4:{i:0;i:2;i:1;i:3;i:2;i:4;i:3;i:5;}','',56,6,0,'','entityreference/autocomplete/tags/%/%/%','Entity Reference Autocomplete','t','','','a:0:{}',0,'','',0,''),('faq-page','','','user_access','a:1:{i:0;s:13:\"view faq page\";}','faq_page','a:0:{}','',1,1,0,'','faq-page','Frequently Asked Questions','t','','','a:0:{}',20,'','',1,''),('faq-page/%','a:1:{i:1;N;}','','user_access','a:1:{i:0;s:13:\"view faq page\";}','faq_page','a:1:{i:0;i:1;}','',2,2,0,'','faq-page/%','Frequently Asked Questions','t','','','a:0:{}',0,'','',0,''),('faq-page/%/list','a:1:{i:1;N;}','','user_access','a:1:{i:0;s:13:\"view faq page\";}','faq_page','a:1:{i:0;i:1;}','',5,3,1,'faq-page/%','faq-page/%','List','t','','','a:0:{}',140,'','',-10,''),('faq-page/%/order','a:1:{i:1;N;}','','user_access','a:1:{i:0;s:20:\"administer faq order\";}','drupal_get_form','a:2:{i:0;s:23:\"faq_order_settings_form\";i:1;i:1;}','',5,3,1,'faq-page/%','faq-page/%','Order','t','','','a:0:{}',132,'Allows the user to configure the order of questions and answers on a FAQ page.','',-8,'sites/all/modules/faq/faq.admin.inc'),('faq-page/list','','','user_access','a:1:{i:0;s:13:\"view faq page\";}','faq_page','a:0:{}','',3,2,1,'faq-page','faq-page','List','t','','','a:0:{}',140,'','',-10,''),('faq-page/order','','','user_access','a:1:{i:0;s:20:\"administer faq order\";}','drupal_get_form','a:1:{i:0;s:23:\"faq_order_settings_form\";}','',3,2,1,'faq-page','faq-page','Order','t','','','a:0:{}',132,'Allows the user to configure the order of questions and answers on a FAQ page.','',-8,'sites/all/modules/faq/faq.admin.inc'),('features/ajaxcallback/%','a:1:{i:2;N;}','','user_access','a:1:{i:0;s:19:\"administer features\";}','features_export_components_json','a:1:{i:0;i:2;}','',6,3,0,'','features/ajaxcallback/%','','features_get_feature_components','','','a:0:{}',0,'Return components of a feature.','',0,'sites/all/modules/features/features.admin.inc'),('features/autocomplete/packages','','','user_access','a:1:{i:0;s:15:\"manage features\";}','features_autocomplete_packages','a:0:{}','',7,3,0,'','features/autocomplete/packages','','t','','','a:0:{}',0,'','',0,'sites/all/modules/features/features.admin.inc'),('field-collection/field-extra-content/%','a:1:{i:2;s:26:\"field_collection_item_load\";}','','field_collection_item_access','a:2:{i:0;s:4:\"view\";i:1;i:2;}','field_collection_item_page_view','a:1:{i:0;i:2;}','',6,3,0,'','field-collection/field-extra-content/%','','t','','','a:0:{}',6,'','',0,'sites/all/modules/field_collection/field_collection.pages.inc'),('field-collection/field-extra-content/%/delete','a:1:{i:2;s:26:\"field_collection_item_load\";}','','field_collection_item_access','a:2:{i:0;s:6:\"delete\";i:1;i:2;}','drupal_get_form','a:2:{i:0;s:36:\"field_collection_item_delete_confirm\";i:1;i:2;}','',13,4,2,'field-collection/field-extra-content/%','field-collection/field-extra-content/%','Delete','t','','','a:0:{}',132,'','',0,'sites/all/modules/field_collection/field_collection.pages.inc'),('field-collection/field-extra-content/%/edit','a:1:{i:2;s:26:\"field_collection_item_load\";}','','field_collection_item_access','a:2:{i:0;s:6:\"update\";i:1;i:2;}','drupal_get_form','a:2:{i:0;s:26:\"field_collection_item_form\";i:1;i:2;}','',13,4,3,'field-collection/field-extra-content/%','field-collection/field-extra-content/%','Edit','t','','','a:0:{}',132,'','',0,'sites/all/modules/field_collection/field_collection.pages.inc'),('field-collection/field-extra-content/%/revisions/%','a:2:{i:2;s:26:\"field_collection_item_load\";i:4;s:35:\"field_collection_item_revision_load\";}','','field_collection_item_access','a:2:{i:0;s:4:\"view\";i:1;i:4;}','field_collection_item_page_view','a:1:{i:0;i:4;}','',26,5,0,'','field-collection/field-extra-content/%/revisions/%','','t','','','a:0:{}',6,'','',0,'sites/all/modules/field_collection/field_collection.pages.inc'),('field-collection/field-extra-content/%/view','a:1:{i:2;s:26:\"field_collection_item_load\";}','','field_collection_item_access','a:2:{i:0;s:4:\"view\";i:1;i:2;}','field_collection_item_page_view','a:1:{i:0;i:2;}','',13,4,1,'field-collection/field-extra-content/%','field-collection/field-extra-content/%','View','t','','','a:0:{}',140,'','',-10,'sites/all/modules/field_collection/field_collection.pages.inc'),('field-collection/field-extra-content/add/%/%','a:2:{i:3;N;i:4;N;}','','1','a:0:{}','field_collection_item_add','a:3:{i:0;s:19:\"field_extra_content\";i:1;i:3;i:2;i:4;}','',28,5,0,'','field-collection/field-extra-content/add/%/%','','t','','','a:0:{}',6,'','',0,'sites/all/modules/field_collection/field_collection.pages.inc'),('field_collection/ajax','','','1','a:0:{}','field_collection_remove_js','a:0:{}','ajax_deliver',3,2,0,'','field_collection/ajax','Remove item callback','t','','ajax_base_page_theme','a:0:{}',0,'','',0,'includes/form.inc'),('file/ajax','','','user_access','a:1:{i:0;s:14:\"access content\";}','file_ajax_upload','a:0:{}','ajax_deliver',3,2,0,'','file/ajax','','t','','ajax_base_page_theme','a:0:{}',0,'','',0,''),('file/progress','','','user_access','a:1:{i:0;s:14:\"access content\";}','file_ajax_progress','a:0:{}','',3,2,0,'','file/progress','','t','','ajax_base_page_theme','a:0:{}',0,'','',0,''),('filter/tips','','','1','a:0:{}','filter_tips_long','a:0:{}','',3,2,0,'','filter/tips','Compose tips','t','','','a:0:{}',20,'','',0,'modules/filter/filter.pages.inc'),('filter/tips/%','a:1:{i:2;s:18:\"filter_format_load\";}','','filter_access','a:1:{i:0;i:2;}','filter_tips_long','a:1:{i:0;i:2;}','',6,3,0,'','filter/tips/%','Compose tips','t','','','a:0:{}',6,'','',0,'modules/filter/filter.pages.inc'),('forum','','','user_access','a:1:{i:0;s:14:\"access content\";}','advanced_forum_page','a:0:{}','',1,1,0,'','forum','Forums','t','','','a:0:{}',6,'','',0,''),('forum/%','a:1:{i:1;s:25:\"advanced_forum_forum_load\";}','','user_access','a:1:{i:0;s:14:\"access content\";}','advanced_forum_page','a:1:{i:0;i:1;}','',2,2,0,'','forum/%','Forums','t','','','a:0:{}',6,'','',0,''),('forum/active','','','views_access','a:1:{i:0;b:1;}','views_page','a:2:{i:0;s:28:\"advanced_forum_active_topics\";i:1;s:6:\"page_1\";}','',3,2,1,'forum','forum','Active topics','t','','','a:0:{}',132,'','',1,''),('forum/active/feed','','','views_access','a:1:{i:0;b:1;}','views_page','a:2:{i:0;s:28:\"advanced_forum_active_topics\";i:1;s:6:\"feed_1\";}','',7,3,0,'','forum/active/feed','','t','','','a:0:{}',0,'','',0,''),('forum/markasread','','','advanced_forum_markasread_access','a:0:{}','advanced_forum_markasread','a:0:{}','',3,2,0,'','forum/markasread','','t','','','a:0:{}',0,'','',0,''),('forum/new','','','views_access','a:1:{i:0;a:2:{i:0;s:17:\"views_check_roles\";i:1;a:1:{i:0;a:1:{i:2;i:2;}}}}','views_page','a:2:{i:0;s:25:\"advanced_forum_new_topics\";i:1;s:6:\"page_1\";}','',3,2,1,'forum','forum','New & updated topics','t','','','a:0:{}',132,'','',2,''),('forum/search','','','views_access','a:1:{i:0;a:2:{i:0;s:16:\"views_check_perm\";i:1;a:1:{i:0;s:14:\"access content\";}}}','views_page','a:2:{i:0;s:21:\"advanced_forum_search\";i:1;s:4:\"page\";}','',3,2,0,'','forum/search','','t','','','a:0:{}',0,'','',0,''),('forum/unanswered','','','views_access','a:1:{i:0;b:1;}','views_page','a:2:{i:0;s:32:\"advanced_forum_unanswered_topics\";i:1;s:6:\"page_1\";}','',3,2,1,'forum','forum','Unanswered topics','t','','','a:0:{}',132,'','',1,''),('forum/unanswered/feed','','','views_access','a:1:{i:0;b:1;}','views_page','a:2:{i:0;s:32:\"advanced_forum_unanswered_topics\";i:1;s:6:\"feed_1\";}','',7,3,0,'','forum/unanswered/feed','','t','','','a:0:{}',0,'','',0,''),('forum/view','','','user_access','a:1:{i:0;s:14:\"access content\";}','advanced_forum_page','a:0:{}','',3,2,1,'forum','forum','View Forums','t','','','a:0:{}',140,'','',-100,''),('i18n/taxonomy/autocomplete/language/%','a:1:{i:4;N;}','','user_access','a:1:{i:0;s:14:\"access content\";}','i18n_taxonomy_autocomplete_language','a:2:{i:0;i:4;i:1;N;}','',30,5,0,'','i18n/taxonomy/autocomplete/language/%','Autocomplete taxonomy','t','','','a:0:{}',0,'','',0,'sites/all/modules/i18n/i18n_taxonomy/i18n_taxonomy.pages.inc'),('i18n/taxonomy/autocomplete/vocabulary/%/%','a:2:{i:4;s:37:\"taxonomy_vocabulary_machine_name_load\";i:5;N;}','','user_access','a:1:{i:0;s:14:\"access content\";}','i18n_taxonomy_autocomplete_language','a:2:{i:0;i:5;i:1;i:4;}','',60,6,0,'','i18n/taxonomy/autocomplete/vocabulary/%/%','Autocomplete taxonomy','t','','','a:0:{}',0,'','',0,'sites/all/modules/i18n/i18n_taxonomy/i18n_taxonomy.pages.inc'),('i18n_string/save','','','user_access','a:1:{i:0;s:23:\"use on-page translation\";}','i18n_string_l10n_client_save_string','a:0:{}','',3,2,0,'','i18n_string/save','Save string','t','','','a:0:{}',0,'','',0,'sites/all/modules/i18n/i18n_string/i18n_string.pages.inc'),('js/admin_menu/cache','','','user_access','a:1:{i:0;s:26:\"access administration menu\";}','admin_menu_js_cache','a:0:{}','admin_menu_deliver',7,3,0,'','js/admin_menu/cache','','t','','','a:0:{}',0,'','',0,''),('message-example','','','views_access','a:1:{i:0;b:1;}','views_page','a:2:{i:0;s:15:\"message_example\";i:1;s:4:\"page\";}','',1,1,0,'','message-example','Message example','t','','','a:0:{}',6,'Typical UAS (User activity stream).','',0,''),('migrate_content/ajaxcallback/%','a:1:{i:2;N;}','','user_access','a:1:{i:0;s:29:\"administer site configuration\";}','we_content_migration_export_components_json','a:1:{i:0;i:2;}','',6,3,0,'','migrate_content/ajaxcallback/%','','Check require bundles','','','a:0:{}',0,'Check require bundles.','',0,'sites/all/modules/we_content_migration/we_content_migration.admin.inc'),('modal_forms/%/comment/reply/%','a:2:{i:1;s:14:\"ctools_js_load\";i:4;s:9:\"node_load\";}','a:1:{i:1;s:16:\"ctools_js_to_arg\";}','user_access','a:1:{i:0;s:13:\"post comments\";}','modal_forms_comment_reply','a:2:{i:0;i:1;i:1;i:4;}','',22,5,0,'','modal_forms/%/comment/reply/%','Comment','t','','','a:0:{}',0,'','',0,'sites/all/modules/modal_forms/modal_forms.pages.inc'),('modal_forms/%/contact','a:1:{i:1;s:14:\"ctools_js_load\";}','a:1:{i:1;s:16:\"ctools_js_to_arg\";}','user_access','a:1:{i:0;s:29:\"access site-wide contact form\";}','modal_forms_contact','a:1:{i:0;i:1;}','',5,3,0,'','modal_forms/%/contact','Contact','t','','','a:0:{}',0,'','',0,'sites/all/modules/modal_forms/modal_forms.pages.inc'),('modal_forms/%/dismiss','a:1:{i:1;s:14:\"ctools_js_load\";}','a:1:{i:1;s:16:\"ctools_js_to_arg\";}','1','a:0:{}','modal_forms_dismiss','a:1:{i:0;i:1;}','',5,3,0,'','modal_forms/%/dismiss','Dismiss','t','','','a:0:{}',0,'','',0,'sites/all/modules/modal_forms/modal_forms.pages.inc'),('modal_forms/%/login','a:1:{i:1;s:14:\"ctools_js_load\";}','a:1:{i:1;s:16:\"ctools_js_to_arg\";}','1','a:0:{}','modal_forms_login','a:1:{i:0;i:1;}','',5,3,0,'','modal_forms/%/login','Log in','t','','','a:0:{}',0,'','',0,'sites/all/modules/modal_forms/modal_forms.pages.inc'),('modal_forms/%/password','a:1:{i:1;s:14:\"ctools_js_load\";}','a:1:{i:1;s:16:\"ctools_js_to_arg\";}','user_is_anonymous','a:0:{}','modal_forms_password','a:1:{i:0;i:1;}','',5,3,0,'','modal_forms/%/password','Password','t','','','a:0:{}',0,'','',0,'sites/all/modules/modal_forms/modal_forms.pages.inc'),('modal_forms/%/register','a:1:{i:1;s:14:\"ctools_js_load\";}','a:1:{i:1;s:16:\"ctools_js_to_arg\";}','user_register_access','a:0:{}','modal_forms_register','a:1:{i:0;i:1;}','',5,3,0,'','modal_forms/%/register','Register','t','','','a:0:{}',0,'','',0,'sites/all/modules/modal_forms/modal_forms.pages.inc'),('modal_forms/%/webform/%','a:2:{i:1;s:14:\"ctools_js_load\";i:3;s:9:\"node_load\";}','a:1:{i:1;s:16:\"ctools_js_to_arg\";}','node_access','a:2:{i:0;s:4:\"view\";i:1;i:3;}','modal_forms_view_webform','a:2:{i:0;i:1;i:1;i:3;}','',10,4,0,'','modal_forms/%/webform/%','Webform','t','','','a:0:{}',0,'','',0,'sites/all/modules/modal_forms/modal_forms.pages.inc'),('node','','','user_access','a:1:{i:0;s:14:\"access content\";}','node_page_default','a:0:{}','',1,1,0,'','node','','t','','','a:0:{}',0,'','',0,''),('node/%','a:1:{i:1;s:9:\"node_load\";}','','node_access','a:2:{i:0;s:4:\"view\";i:1;i:1;}','node_page_view','a:1:{i:0;i:1;}','',2,2,0,'','node/%','','node_page_title','a:1:{i:0;i:1;}','','a:0:{}',6,'','',0,''),('node/%/delete','a:1:{i:1;s:9:\"node_load\";}','','node_access','a:2:{i:0;s:6:\"delete\";i:1;i:1;}','drupal_get_form','a:2:{i:0;s:19:\"node_delete_confirm\";i:1;i:1;}','',5,3,2,'node/%','node/%','Delete','t','','','a:0:{}',132,'','',1,'modules/node/node.pages.inc'),('node/%/done','a:1:{i:1;s:17:\"webform_menu_load\";}','a:1:{i:1;s:19:\"webform_menu_to_arg\";}','webform_confirmation_page_access','a:1:{i:0;i:1;}','_webform_confirmation','a:1:{i:0;i:1;}','',5,3,0,'','node/%/done','Webform confirmation','t','','','a:0:{}',0,'','',0,''),('node/%/edit','a:1:{i:1;s:9:\"node_load\";}','','node_access','a:2:{i:0;s:6:\"update\";i:1;i:1;}','node_page_edit','a:1:{i:0;i:1;}','',5,3,3,'node/%','node/%','Edit','t','','','a:0:{}',132,'','',0,'modules/node/node.pages.inc'),('node/%/outline','a:1:{i:1;s:9:\"node_load\";}','','_book_outline_access','a:1:{i:0;i:1;}','book_outline','a:1:{i:0;i:1;}','',5,3,1,'node/%','node/%','Outline','t','','','a:0:{}',132,'','',2,'modules/book/book.pages.inc'),('node/%/outline/remove','a:1:{i:1;s:9:\"node_load\";}','','_book_outline_remove_access','a:1:{i:0;i:1;}','drupal_get_form','a:2:{i:0;s:16:\"book_remove_form\";i:1;i:1;}','',11,4,0,'','node/%/outline/remove','Remove from outline','t','','','a:0:{}',6,'','',0,'modules/book/book.pages.inc'),('node/%/revisions','a:1:{i:1;s:9:\"node_load\";}','','_node_revision_access','a:1:{i:0;i:1;}','node_revision_overview','a:1:{i:0;i:1;}','',5,3,1,'node/%','node/%','Revisions','t','','','a:0:{}',132,'','',2,'modules/node/node.pages.inc'),('node/%/revisions/%/delete','a:2:{i:1;a:1:{s:9:\"node_load\";a:1:{i:0;i:3;}}i:3;N;}','','_node_revision_access','a:2:{i:0;i:1;i:1;s:6:\"delete\";}','drupal_get_form','a:2:{i:0;s:28:\"node_revision_delete_confirm\";i:1;i:1;}','',21,5,0,'','node/%/revisions/%/delete','Delete earlier revision','t','','','a:0:{}',6,'','',0,'modules/node/node.pages.inc'),('node/%/revisions/%/revert','a:2:{i:1;a:1:{s:9:\"node_load\";a:1:{i:0;i:3;}}i:3;N;}','','_node_revision_access','a:2:{i:0;i:1;i:1;s:6:\"update\";}','drupal_get_form','a:2:{i:0;s:28:\"node_revision_revert_confirm\";i:1;i:1;}','',21,5,0,'','node/%/revisions/%/revert','Revert to earlier revision','t','','','a:0:{}',6,'','',0,'modules/node/node.pages.inc'),('node/%/revisions/%/view','a:2:{i:1;a:1:{s:9:\"node_load\";a:1:{i:0;i:3;}}i:3;N;}','','_node_revision_access','a:1:{i:0;i:1;}','node_show','a:2:{i:0;i:1;i:1;b:1;}','',21,5,0,'','node/%/revisions/%/view','Revisions','t','','','a:0:{}',6,'','',0,''),('node/%/submission/%','a:2:{i:1;a:1:{s:17:\"webform_menu_load\";a:1:{i:0;i:1;}}i:3;a:1:{s:28:\"webform_menu_submission_load\";a:1:{i:0;i:1;}}}','a:1:{i:1;s:19:\"webform_menu_to_arg\";}','webform_submission_access','a:3:{i:0;i:1;i:1;i:3;i:2;s:4:\"view\";}','webform_submission_page','a:3:{i:0;i:1;i:1;i:3;i:2;s:4:\"html\";}','',10,4,0,'','node/%/submission/%','Webform submission','webform_submission_title','a:2:{i:0;i:1;i:1;i:3;}','','a:0:{}',0,'','',0,'sites/all/modules/webform/includes/webform.submissions.inc'),('node/%/submission/%/delete','a:2:{i:1;a:1:{s:17:\"webform_menu_load\";a:1:{i:0;i:1;}}i:3;a:1:{s:28:\"webform_menu_submission_load\";a:1:{i:0;i:1;}}}','a:1:{i:1;s:19:\"webform_menu_to_arg\";}','webform_submission_access','a:3:{i:0;i:1;i:1;i:3;i:2;s:6:\"delete\";}','drupal_get_form','a:3:{i:0;s:30:\"webform_submission_delete_form\";i:1;i:1;i:2;i:3;}','',21,5,1,'node/%/submission/%','node/%/submission/%','Delete','t','','','a:0:{}',132,'','',2,'sites/all/modules/webform/includes/webform.submissions.inc'),('node/%/submission/%/edit','a:2:{i:1;a:1:{s:17:\"webform_menu_load\";a:1:{i:0;i:1;}}i:3;a:1:{s:28:\"webform_menu_submission_load\";a:1:{i:0;i:1;}}}','a:1:{i:1;s:19:\"webform_menu_to_arg\";}','webform_submission_access','a:3:{i:0;i:1;i:1;i:3;i:2;s:4:\"edit\";}','webform_submission_page','a:3:{i:0;i:1;i:1;i:3;i:2;s:4:\"form\";}','',21,5,1,'node/%/submission/%','node/%/submission/%','Edit','t','','','a:0:{}',132,'','',1,'sites/all/modules/webform/includes/webform.submissions.inc'),('node/%/submission/%/resend','a:2:{i:1;a:1:{s:17:\"webform_menu_load\";a:1:{i:0;i:1;}}i:3;a:1:{s:28:\"webform_menu_submission_load\";a:1:{i:0;i:1;}}}','a:1:{i:1;s:19:\"webform_menu_to_arg\";}','webform_results_access','a:1:{i:0;i:1;}','drupal_get_form','a:3:{i:0;s:25:\"webform_submission_resend\";i:1;i:1;i:2;i:3;}','',21,5,0,'','node/%/submission/%/resend','Resend e-mails','t','','','a:0:{}',0,'','',0,'sites/all/modules/webform/includes/webform.submissions.inc'),('node/%/submission/%/view','a:2:{i:1;a:1:{s:17:\"webform_menu_load\";a:1:{i:0;i:1;}}i:3;a:1:{s:28:\"webform_menu_submission_load\";a:1:{i:0;i:1;}}}','a:1:{i:1;s:19:\"webform_menu_to_arg\";}','webform_submission_access','a:3:{i:0;i:1;i:1;i:3;i:2;s:4:\"view\";}','webform_submission_page','a:3:{i:0;i:1;i:1;i:3;i:2;s:4:\"html\";}','',21,5,1,'node/%/submission/%','node/%/submission/%','View','t','','','a:0:{}',140,'','',0,'sites/all/modules/webform/includes/webform.submissions.inc'),('node/%/submissions','a:1:{i:1;s:17:\"webform_menu_load\";}','a:1:{i:1;s:19:\"webform_menu_to_arg\";}','webform_submission_access','a:3:{i:0;i:1;i:1;N;i:2;s:4:\"list\";}','webform_results_submissions','a:3:{i:0;i:1;i:1;b:1;i:2;s:2:\"50\";}','',5,3,0,'','node/%/submissions','Submissions','t','','','a:0:{}',0,'','',0,'sites/all/modules/webform/includes/webform.report.inc'),('node/%/track','a:1:{i:1;s:9:\"node_load\";}','','user_access','a:1:{i:0;s:17:\"access statistics\";}','statistics_node_tracker','a:0:{}','',5,3,1,'node/%','node/%','Track','t','','','a:0:{}',132,'','',2,'modules/statistics/statistics.pages.inc'),('node/%/view','a:1:{i:1;s:9:\"node_load\";}','','node_access','a:2:{i:0;s:4:\"view\";i:1;i:1;}','node_page_view','a:1:{i:0;i:1;}','',5,3,1,'node/%','node/%','View','t','','','a:0:{}',140,'','',-10,''),('node/%/webform','a:1:{i:1;s:17:\"webform_menu_load\";}','a:1:{i:1;s:19:\"webform_menu_to_arg\";}','webform_node_update_access','a:1:{i:0;i:1;}','webform_components_page','a:1:{i:0;i:1;}','',5,3,3,'node/%','node/%','Webform','t','','','a:0:{}',132,'','',1,'sites/all/modules/webform/includes/webform.components.inc'),('node/%/webform-results','a:1:{i:1;s:17:\"webform_menu_load\";}','a:1:{i:1;s:19:\"webform_menu_to_arg\";}','webform_results_access','a:1:{i:0;i:1;}','webform_results_submissions','a:3:{i:0;i:1;i:1;b:0;i:2;s:2:\"50\";}','',5,3,3,'node/%','node/%','Results','t','','','a:0:{}',132,'','',2,'sites/all/modules/webform/includes/webform.report.inc'),('node/%/webform-results/analysis','a:1:{i:1;s:17:\"webform_menu_load\";}','a:1:{i:1;s:19:\"webform_menu_to_arg\";}','webform_results_access','a:1:{i:0;i:1;}','webform_results_analysis','a:1:{i:0;i:1;}','',11,4,1,'node/%/webform-results','node/%','Analysis','t','','','a:0:{}',132,'','',5,'sites/all/modules/webform/includes/webform.report.inc'),('node/%/webform-results/analysis/%','a:2:{i:1;a:1:{s:17:\"webform_menu_load\";a:2:{i:0;i:1;i:1;i:4;}}i:4;a:1:{s:27:\"webform_menu_component_load\";a:2:{i:0;i:1;i:1;i:4;}}}','a:1:{i:1;s:19:\"webform_menu_to_arg\";}','webform_results_access','a:1:{i:0;i:1;}','webform_results_analysis','a:3:{i:0;i:1;i:1;a:0:{}i:2;i:4;}','',22,5,1,'node/%/webform-results/analysis','node/%','Analysis','t','','','a:0:{}',132,'','',0,'sites/all/modules/webform/includes/webform.report.inc'),('node/%/webform-results/analysis/%/more','a:2:{i:1;a:1:{s:17:\"webform_menu_load\";a:2:{i:0;i:1;i:1;i:4;}}i:4;a:1:{s:27:\"webform_menu_component_load\";a:2:{i:0;i:1;i:1;i:4;}}}','a:1:{i:1;s:19:\"webform_menu_to_arg\";}','webform_results_access','a:1:{i:0;i:1;}','webform_results_analysis','a:3:{i:0;i:1;i:1;a:0:{}i:2;i:4;}','',45,6,1,'node/%/webform-results/analysis/%','node/%','In-depth analysis','t','','','a:0:{}',140,'','',0,'sites/all/modules/webform/includes/webform.report.inc'),('node/%/webform-results/clear','a:1:{i:1;s:17:\"webform_menu_load\";}','a:1:{i:1;s:19:\"webform_menu_to_arg\";}','webform_results_clear_access','a:1:{i:0;i:1;}','drupal_get_form','a:2:{i:0;s:26:\"webform_results_clear_form\";i:1;i:1;}','',11,4,1,'node/%/webform-results','node/%','Clear','t','','','a:0:{}',132,'','',8,'sites/all/modules/webform/includes/webform.report.inc'),('node/%/webform-results/download','a:1:{i:1;s:17:\"webform_menu_load\";}','a:1:{i:1;s:19:\"webform_menu_to_arg\";}','webform_results_access','a:1:{i:0;i:1;}','drupal_get_form','a:2:{i:0;s:29:\"webform_results_download_form\";i:1;i:1;}','',11,4,1,'node/%/webform-results','node/%','Download','t','','','a:0:{}',132,'','',7,'sites/all/modules/webform/includes/webform.report.inc'),('node/%/webform-results/download-file','a:1:{i:1;s:17:\"webform_menu_load\";}','a:1:{i:1;s:19:\"webform_menu_to_arg\";}','webform_results_access','a:1:{i:0;i:1;}','webform_results_download_callback','a:1:{i:0;i:1;}','',11,4,0,'','node/%/webform-results/download-file','Download','t','','','a:0:{}',0,'','',0,'sites/all/modules/webform/includes/webform.report.inc'),('node/%/webform-results/submissions','a:1:{i:1;s:17:\"webform_menu_load\";}','a:1:{i:1;s:19:\"webform_menu_to_arg\";}','webform_results_access','a:1:{i:0;i:1;}','webform_results_submissions','a:3:{i:0;i:1;i:1;b:0;i:2;s:2:\"50\";}','',11,4,1,'node/%/webform-results','node/%','Submissions','t','','','a:0:{}',140,'','',4,'sites/all/modules/webform/includes/webform.report.inc'),('node/%/webform-results/table','a:1:{i:1;s:17:\"webform_menu_load\";}','a:1:{i:1;s:19:\"webform_menu_to_arg\";}','webform_results_access','a:1:{i:0;i:1;}','webform_results_table','a:2:{i:0;i:1;i:1;s:2:\"50\";}','',11,4,1,'node/%/webform-results','node/%','Table','t','','','a:0:{}',132,'','',6,'sites/all/modules/webform/includes/webform.report.inc'),('node/%/webform/components','a:1:{i:1;s:17:\"webform_menu_load\";}','a:1:{i:1;s:19:\"webform_menu_to_arg\";}','webform_node_update_access','a:1:{i:0;i:1;}','webform_components_page','a:1:{i:0;i:1;}','',11,4,1,'node/%/webform','node/%','Form components','t','','','a:0:{}',140,'','',0,'sites/all/modules/webform/includes/webform.components.inc'),('node/%/webform/components/%','a:2:{i:1;a:1:{s:17:\"webform_menu_load\";a:2:{i:0;i:1;i:1;i:5;}}i:4;a:1:{s:27:\"webform_menu_component_load\";a:2:{i:0;i:1;i:1;i:5;}}}','a:1:{i:1;s:19:\"webform_menu_to_arg\";}','webform_node_update_access','a:1:{i:0;i:1;}','drupal_get_form','a:4:{i:0;s:27:\"webform_component_edit_form\";i:1;i:1;i:2;i:4;i:3;b:0;}','',22,5,1,'node/%/webform/components','node/%','','t','','','a:0:{}',132,'','',0,'sites/all/modules/webform/includes/webform.components.inc'),('node/%/webform/components/%/clone','a:2:{i:1;a:1:{s:17:\"webform_menu_load\";a:2:{i:0;i:1;i:1;i:5;}}i:4;a:1:{s:27:\"webform_menu_component_load\";a:2:{i:0;i:1;i:1;i:5;}}}','a:1:{i:1;s:19:\"webform_menu_to_arg\";}','webform_node_update_access','a:1:{i:0;i:1;}','drupal_get_form','a:4:{i:0;s:27:\"webform_component_edit_form\";i:1;i:1;i:2;i:4;i:3;b:1;}','',45,6,1,'node/%/webform/components/%','node/%','','t','','','a:0:{}',132,'','',0,'sites/all/modules/webform/includes/webform.components.inc'),('node/%/webform/components/%/delete','a:2:{i:1;a:1:{s:17:\"webform_menu_load\";a:2:{i:0;i:1;i:1;i:5;}}i:4;a:1:{s:27:\"webform_menu_component_load\";a:2:{i:0;i:1;i:1;i:5;}}}','a:1:{i:1;s:19:\"webform_menu_to_arg\";}','webform_node_update_access','a:1:{i:0;i:1;}','drupal_get_form','a:3:{i:0;s:29:\"webform_component_delete_form\";i:1;i:1;i:2;i:4;}','',45,6,1,'node/%/webform/components/%','node/%','','t','','','a:0:{}',132,'','',0,'sites/all/modules/webform/includes/webform.components.inc'),('node/%/webform/conditionals','a:1:{i:1;s:17:\"webform_menu_load\";}','a:1:{i:1;s:19:\"webform_menu_to_arg\";}','webform_node_update_access','a:1:{i:0;i:1;}','drupal_get_form','a:2:{i:0;s:25:\"webform_conditionals_form\";i:1;i:1;}','',11,4,1,'node/%/webform','node/%','Conditionals','t','','','a:0:{}',132,'','',1,'sites/all/modules/webform/includes/webform.conditionals.inc'),('node/%/webform/configure','a:1:{i:1;s:17:\"webform_menu_load\";}','a:1:{i:1;s:19:\"webform_menu_to_arg\";}','webform_node_update_access','a:1:{i:0;i:1;}','drupal_get_form','a:2:{i:0;s:22:\"webform_configure_form\";i:1;i:1;}','',11,4,1,'node/%/webform','node/%','Form settings','t','','','a:0:{}',132,'','',5,'sites/all/modules/webform/includes/webform.pages.inc'),('node/%/webform/emails','a:1:{i:1;s:17:\"webform_menu_load\";}','a:1:{i:1;s:19:\"webform_menu_to_arg\";}','webform_node_update_access','a:1:{i:0;i:1;}','drupal_get_form','a:2:{i:0;s:19:\"webform_emails_form\";i:1;i:1;}','',11,4,1,'node/%/webform','node/%','E-mails','t','','','a:0:{}',132,'','',4,'sites/all/modules/webform/includes/webform.emails.inc'),('node/%/webform/emails/%','a:2:{i:1;a:1:{s:17:\"webform_menu_load\";a:1:{i:0;i:1;}}i:4;a:1:{s:23:\"webform_menu_email_load\";a:1:{i:0;i:1;}}}','a:1:{i:1;s:19:\"webform_menu_to_arg\";}','webform_node_update_access','a:1:{i:0;i:1;}','drupal_get_form','a:3:{i:0;s:23:\"webform_email_edit_form\";i:1;i:1;i:2;i:4;}','',22,5,1,'node/%/webform/emails','node/%','','t','','','a:0:{}',132,'','',0,'sites/all/modules/webform/includes/webform.emails.inc'),('node/%/webform/emails/%/clone','a:2:{i:1;a:1:{s:17:\"webform_menu_load\";a:1:{i:0;i:1;}}i:4;a:1:{s:23:\"webform_menu_email_load\";a:1:{i:0;i:1;}}}','a:1:{i:1;s:19:\"webform_menu_to_arg\";}','webform_node_update_access','a:1:{i:0;i:1;}','drupal_get_form','a:4:{i:0;s:23:\"webform_email_edit_form\";i:1;i:1;i:2;i:4;i:3;b:1;}','',45,6,1,'node/%/webform/emails/%','node/%','','t','','','a:0:{}',132,'','',0,'sites/all/modules/webform/includes/webform.emails.inc'),('node/%/webform/emails/%/delete','a:2:{i:1;a:1:{s:17:\"webform_menu_load\";a:1:{i:0;i:1;}}i:4;a:1:{s:23:\"webform_menu_email_load\";a:1:{i:0;i:1;}}}','a:1:{i:1;s:19:\"webform_menu_to_arg\";}','webform_node_update_access','a:1:{i:0;i:1;}','drupal_get_form','a:3:{i:0;s:25:\"webform_email_delete_form\";i:1;i:1;i:2;i:4;}','',45,6,1,'node/%/webform/emails/%','node/%','','t','','','a:0:{}',132,'','',0,'sites/all/modules/webform/includes/webform.emails.inc'),('node/add','','','_node_add_access','a:0:{}','node_add_page','a:0:{}','',3,2,0,'','node/add','Add content','t','','','a:0:{}',6,'','',0,'modules/node/node.pages.inc'),('node/add/article','','','node_access','a:2:{i:0;s:6:\"create\";i:1;s:7:\"article\";}','node_add','a:1:{i:0;s:7:\"article\";}','',7,3,0,'','node/add/article','Article','check_plain','','','a:0:{}',6,'Use <em>articles</em> for time-sensitive content like news, press releases or blog posts.','',0,'modules/node/node.pages.inc'),('node/add/blog','','','node_access','a:2:{i:0;s:6:\"create\";i:1;s:4:\"blog\";}','node_add','a:1:{i:0;s:4:\"blog\";}','',7,3,0,'','node/add/blog','Blog entry','check_plain','','','a:0:{}',6,'Use for multi-user blogs. Every user gets a personal blog.','',0,'modules/node/node.pages.inc'),('node/add/book','','','node_access','a:2:{i:0;s:6:\"create\";i:1;s:4:\"book\";}','node_add','a:1:{i:0;s:4:\"book\";}','',7,3,0,'','node/add/book','Book page','check_plain','','','a:0:{}',6,'<em>Books</em> have a built-in hierarchical navigation. Use for handbooks or tutorials.','',0,'modules/node/node.pages.inc'),('node/add/faq','','','node_access','a:2:{i:0;s:6:\"create\";i:1;s:3:\"faq\";}','node_add','a:1:{i:0;s:3:\"faq\";}','',7,3,0,'','node/add/faq','FAQ','check_plain','','','a:0:{}',6,'A frequently asked question and its answer.','',0,'modules/node/node.pages.inc'),('node/add/forum','','','node_access','a:2:{i:0;s:6:\"create\";i:1;s:5:\"forum\";}','node_add','a:1:{i:0;s:5:\"forum\";}','',7,3,0,'','node/add/forum','Forum topic','check_plain','','','a:0:{}',6,'A <em>forum topic</em> starts a new discussion thread within a forum.','',0,'modules/node/node.pages.inc'),('node/add/page','','','node_access','a:2:{i:0;s:6:\"create\";i:1;s:4:\"page\";}','node_add','a:1:{i:0;s:4:\"page\";}','',7,3,0,'','node/add/page','Basic page','check_plain','','','a:0:{}',6,'Use <em>basic pages</em> for your static content, such as an \'About us\' page.','',0,'modules/node/node.pages.inc'),('node/add/products','','','node_access','a:2:{i:0;s:6:\"create\";i:1;s:8:\"products\";}','node_add','a:1:{i:0;s:8:\"products\";}','',7,3,0,'','node/add/products','Products','check_plain','','','a:0:{}',6,'','',0,'modules/node/node.pages.inc'),('node/add/video','','','node_access','a:2:{i:0;s:6:\"create\";i:1;s:5:\"video\";}','node_add','a:1:{i:0;s:5:\"video\";}','',7,3,0,'','node/add/video','Video','check_plain','','','a:0:{}',6,'','',0,'modules/node/node.pages.inc'),('node/add/webform','','','node_access','a:2:{i:0;s:6:\"create\";i:1;s:7:\"webform\";}','node_add','a:1:{i:0;s:7:\"webform\";}','',7,3,0,'','node/add/webform','Webform','check_plain','','','a:0:{}',6,'Create a new form or questionnaire accessible to users. Submission results and statistics are recorded and accessible to privileged users.','',0,'modules/node/node.pages.inc'),('overlay-ajax/%','a:1:{i:1;N;}','','user_access','a:1:{i:0;s:14:\"access overlay\";}','overlay_ajax_render_region','a:1:{i:0;i:1;}','',2,2,0,'','overlay-ajax/%','','t','','','a:0:{}',0,'','',0,''),('overlay/dismiss-message','','','user_access','a:1:{i:0;s:14:\"access overlay\";}','overlay_user_dismiss_message','a:0:{}','',3,2,0,'','overlay/dismiss-message','','t','','','a:0:{}',0,'','',0,''),('quicktabs/ajax','','','user_access','a:1:{i:0;s:14:\"access content\";}','quicktabs_ajax','a:0:{}','',3,2,0,'','quicktabs/ajax','','t','','','a:0:{}',0,'','',0,''),('rss.xml','','','user_access','a:1:{i:0;s:14:\"access content\";}','node_feed','a:2:{i:0;b:0;i:1;a:0:{}}','',1,1,0,'','rss.xml','RSS feed','t','','','a:0:{}',0,'','',0,''),('search','','','search_is_active','a:0:{}','search_view','a:0:{}','',1,1,0,'','search','Search','t','','','a:0:{}',20,'','',0,'modules/search/search.pages.inc'),('search/node','','','_search_menu_access','a:1:{i:0;s:4:\"node\";}','search_view','a:2:{i:0;s:4:\"node\";i:1;s:0:\"\";}','',3,2,1,'search','search','Content','t','','','a:0:{}',132,'','',-10,'modules/search/search.pages.inc'),('search/node/%','a:1:{i:2;a:1:{s:14:\"menu_tail_load\";a:2:{i:0;s:4:\"%map\";i:1;s:6:\"%index\";}}}','a:1:{i:2;s:16:\"menu_tail_to_arg\";}','_search_menu_access','a:1:{i:0;s:4:\"node\";}','search_view','a:2:{i:0;s:4:\"node\";i:1;i:2;}','',6,3,1,'search/node','search/node/%','Content','t','','','a:0:{}',132,'','',0,'modules/search/search.pages.inc'),('search/user','','','_search_menu_access','a:1:{i:0;s:4:\"user\";}','search_view','a:2:{i:0;s:4:\"user\";i:1;s:0:\"\";}','',3,2,1,'search','search','Users','t','','','a:0:{}',132,'','',0,'modules/search/search.pages.inc'),('search/user/%','a:1:{i:2;a:1:{s:14:\"menu_tail_load\";a:2:{i:0;s:4:\"%map\";i:1;s:6:\"%index\";}}}','a:1:{i:2;s:16:\"menu_tail_to_arg\";}','_search_menu_access','a:1:{i:0;s:4:\"user\";}','search_view','a:2:{i:0;s:4:\"user\";i:1;i:2;}','',6,3,1,'search/node','search/node/%','Users','t','','','a:0:{}',132,'','',0,'modules/search/search.pages.inc'),('sites/default/files/styles/%','a:1:{i:4;s:16:\"image_style_load\";}','','1','a:0:{}','image_style_deliver','a:1:{i:0;i:4;}','',30,5,0,'','sites/default/files/styles/%','Generate image style','t','','','a:0:{}',0,'','',0,''),('system/ajax','','','1','a:0:{}','ajax_form_callback','a:0:{}','ajax_deliver',3,2,0,'','system/ajax','AHAH callback','t','','ajax_base_page_theme','a:0:{}',0,'','',0,'includes/form.inc'),('system/files','','','1','a:0:{}','file_download','a:1:{i:0;s:7:\"private\";}','',3,2,0,'','system/files','File download','t','','','a:0:{}',0,'','',0,''),('system/files/styles/%','a:1:{i:3;s:16:\"image_style_load\";}','','1','a:0:{}','image_style_deliver','a:1:{i:0;i:3;}','',14,4,0,'','system/files/styles/%','Generate image style','t','','','a:0:{}',0,'','',0,''),('system/temporary','','','1','a:0:{}','file_download','a:1:{i:0;s:9:\"temporary\";}','',3,2,0,'','system/temporary','Temporary files','t','','','a:0:{}',0,'','',0,''),('system/timezone','','','1','a:0:{}','system_timezone','a:0:{}','',3,2,0,'','system/timezone','Time zone','t','','','a:0:{}',0,'','',0,'modules/system/system.admin.inc'),('tagclouds','','','user_access','a:1:{i:0;s:14:\"access content\";}','tagclouds_page_chunk','a:1:{i:0;N;}','',1,1,0,'','tagclouds','Tags','t','','','a:0:{}',20,'','',0,''),('tagclouds/chunk/%','a:1:{i:2;s:19:\"tagclouds_vocs_load\";}','','user_access','a:1:{i:0;s:14:\"access content\";}','tagclouds_page_chunk','a:1:{i:0;i:2;}','',6,3,0,'','tagclouds/chunk/%','Tags','t','','','a:0:{}',20,'','',0,''),('tagclouds/list/%','a:1:{i:2;s:19:\"tagclouds_vocs_load\";}','','user_access','a:1:{i:0;s:14:\"access content\";}','tagclouds_page_list','a:1:{i:0;i:2;}','',6,3,0,'','tagclouds/list/%','Tags','t','','','a:0:{}',0,'','',0,''),('taxonomy/autocomplete','','','user_access','a:1:{i:0;s:14:\"access content\";}','i18n_taxonomy_autocomplete_field','a:0:{}','',3,2,0,'','taxonomy/autocomplete','Autocomplete taxonomy','t','','','a:0:{}',0,'','',0,'sites/all/modules/i18n/i18n_taxonomy/i18n_taxonomy.pages.inc'),('taxonomy/term/%','a:1:{i:2;s:18:\"taxonomy_term_load\";}','','user_access','a:1:{i:0;s:14:\"access content\";}','i18n_taxonomy_term_page','a:1:{i:0;i:2;}','',6,3,0,'','taxonomy/term/%','Taxonomy term','i18n_taxonomy_term_name','a:1:{i:0;i:2;}','','a:0:{}',6,'','',0,'sites/all/modules/i18n/i18n_taxonomy/i18n_taxonomy.pages.inc'),('taxonomy/term/%/edit','a:1:{i:2;s:18:\"taxonomy_term_load\";}','','taxonomy_term_edit_access','a:1:{i:0;i:2;}','drupal_get_form','a:3:{i:0;s:18:\"taxonomy_form_term\";i:1;i:2;i:2;N;}','',13,4,1,'taxonomy/term/%','taxonomy/term/%','Edit','t','','','a:0:{}',132,'','',10,'modules/taxonomy/taxonomy.admin.inc'),('taxonomy/term/%/feed','a:1:{i:2;s:18:\"taxonomy_term_load\";}','','user_access','a:1:{i:0;s:14:\"access content\";}','taxonomy_term_feed','a:1:{i:0;i:2;}','',13,4,0,'','taxonomy/term/%/feed','Taxonomy term','taxonomy_term_title','a:1:{i:0;i:2;}','','a:0:{}',0,'','',0,'modules/taxonomy/taxonomy.pages.inc'),('taxonomy/term/%/translate','a:1:{i:2;s:18:\"taxonomy_term_load\";}','','i18n_object_translate_access','a:2:{i:0;s:13:\"taxonomy_term\";i:1;i:2;}','i18n_page_translate_tab','a:2:{i:0;s:13:\"taxonomy_term\";i:1;i:2;}','',13,4,1,'taxonomy/term/%','taxonomy/term/%','Translate','t','','','a:0:{}',132,'','',10,'sites/all/modules/i18n/i18n.pages.inc'),('taxonomy/term/%/translate/%','a:2:{i:2;s:18:\"taxonomy_term_load\";i:4;s:18:\"i18n_language_load\";}','','i18n_object_translate_access','a:2:{i:0;s:13:\"taxonomy_term\";i:1;i:2;}','i18n_page_translate_tab','a:3:{i:0;s:13:\"taxonomy_term\";i:1;i:2;i:2;i:4;}','',26,5,0,'','taxonomy/term/%/translate/%','Translate','t','','','a:0:{}',0,'','',0,'sites/all/modules/i18n/i18n.pages.inc'),('taxonomy/term/%/view','a:1:{i:2;s:18:\"taxonomy_term_load\";}','','user_access','a:1:{i:0;s:14:\"access content\";}','i18n_taxonomy_term_page','a:1:{i:0;i:2;}','',13,4,1,'taxonomy/term/%','taxonomy/term/%','View','t','','','a:0:{}',140,'','',0,'sites/all/modules/i18n/i18n_taxonomy/i18n_taxonomy.pages.inc'),('token/autocomplete/%','a:1:{i:2;s:15:\"token_type_load\";}','','1','a:0:{}','token_autocomplete_token','a:1:{i:0;i:2;}','',6,3,0,'','token/autocomplete/%','','t','','','a:0:{}',0,'','',0,'sites/all/modules/token/token.pages.inc'),('token/flush-cache','','','user_access','a:1:{i:0;s:12:\"flush caches\";}','token_flush_cache_callback','a:0:{}','',3,2,0,'','token/flush-cache','','t','','','a:0:{}',0,'','',0,'sites/all/modules/token/token.pages.inc'),('token/tree','','','1','a:0:{}','token_page_output_tree','a:0:{}','',3,2,0,'','token/tree','','t','','ajax_base_page_theme','a:0:{}',0,'','',0,'sites/all/modules/token/token.pages.inc'),('user','','','1','a:0:{}','user_page','a:0:{}','',1,1,0,'','user','User account','user_menu_title','','','a:0:{}',6,'','',-10,'modules/user/user.pages.inc'),('user/%','a:1:{i:1;s:9:\"user_load\";}','','user_view_access','a:1:{i:0;i:1;}','user_view_page','a:1:{i:0;i:1;}','',2,2,0,'','user/%','My account','user_page_title','a:1:{i:0;i:1;}','','a:0:{}',6,'','',0,''),('user/%/cancel','a:1:{i:1;s:9:\"user_load\";}','','user_cancel_access','a:1:{i:0;i:1;}','drupal_get_form','a:2:{i:0;s:24:\"user_cancel_confirm_form\";i:1;i:1;}','',5,3,0,'','user/%/cancel','Cancel account','t','','','a:0:{}',6,'','',0,'modules/user/user.pages.inc'),('user/%/cancel/confirm/%/%','a:3:{i:1;s:9:\"user_load\";i:4;N;i:5;N;}','','user_cancel_access','a:1:{i:0;i:1;}','user_cancel_confirm','a:3:{i:0;i:1;i:1;i:4;i:2;i:5;}','',44,6,0,'','user/%/cancel/confirm/%/%','Confirm account cancellation','t','','','a:0:{}',6,'','',0,'modules/user/user.pages.inc'),('user/%/contact','a:1:{i:1;s:9:\"user_load\";}','','_contact_personal_tab_access','a:1:{i:0;i:1;}','drupal_get_form','a:2:{i:0;s:21:\"contact_personal_form\";i:1;i:1;}','',5,3,1,'user/%','user/%','Contact','t','','','a:0:{}',132,'','',2,'modules/contact/contact.pages.inc'),('user/%/edit','a:1:{i:1;s:9:\"user_load\";}','','user_edit_access','a:1:{i:0;i:1;}','drupal_get_form','a:2:{i:0;s:17:\"user_profile_form\";i:1;i:1;}','',5,3,1,'user/%','user/%','Edit','t','','','a:0:{}',132,'','',0,'modules/user/user.pages.inc'),('user/%/edit/account','a:1:{i:1;a:1:{s:18:\"user_category_load\";a:2:{i:0;s:4:\"%map\";i:1;s:6:\"%index\";}}}','','user_edit_access','a:1:{i:0;i:1;}','drupal_get_form','a:2:{i:0;s:17:\"user_profile_form\";i:1;i:1;}','',11,4,1,'user/%/edit','user/%','Account','t','','','a:0:{}',140,'','',0,'modules/user/user.pages.inc'),('user/%/shortcuts','a:1:{i:1;s:9:\"user_load\";}','','shortcut_set_switch_access','a:1:{i:0;i:1;}','drupal_get_form','a:2:{i:0;s:19:\"shortcut_set_switch\";i:1;i:1;}','',5,3,1,'user/%','user/%','Shortcuts','t','','','a:0:{}',132,'','',0,'modules/shortcut/shortcut.admin.inc'),('user/%/track/navigation','a:1:{i:1;s:9:\"user_load\";}','','user_access','a:1:{i:0;s:17:\"access statistics\";}','statistics_user_tracker','a:0:{}','',11,4,1,'user/%','user/%','Track page visits','t','','','a:0:{}',132,'','',2,'modules/statistics/statistics.pages.inc'),('user/%/view','a:1:{i:1;s:9:\"user_load\";}','','user_view_access','a:1:{i:0;i:1;}','user_view_page','a:1:{i:0;i:1;}','',5,3,1,'user/%','user/%','View','t','','','a:0:{}',140,'','',-10,''),('user/autocomplete','','','user_access','a:1:{i:0;s:20:\"access user profiles\";}','user_autocomplete','a:0:{}','',3,2,0,'','user/autocomplete','User autocomplete','t','','','a:0:{}',0,'','',0,'modules/user/user.pages.inc'),('user/login','','','user_is_anonymous','a:0:{}','user_page','a:0:{}','',3,2,1,'user','user','Log in','t','','','a:0:{}',140,'','',0,'modules/user/user.pages.inc'),('user/logout','','','user_is_logged_in','a:0:{}','user_logout','a:0:{}','',3,2,0,'','user/logout','Log out','t','','','a:0:{}',6,'','',10,'modules/user/user.pages.inc'),('user/password','','','1','a:0:{}','drupal_get_form','a:1:{i:0;s:9:\"user_pass\";}','',3,2,1,'user','user','Request new password','t','','','a:0:{}',132,'','',0,'modules/user/user.pages.inc'),('user/register','','','user_register_access','a:0:{}','drupal_get_form','a:1:{i:0;s:18:\"user_register_form\";}','',3,2,1,'user','user','Create new account','t','','','a:0:{}',132,'','',0,''),('user/reset/%/%/%','a:3:{i:2;N;i:3;N;i:4;N;}','','1','a:0:{}','drupal_get_form','a:4:{i:0;s:15:\"user_pass_reset\";i:1;i:2;i:2;i:3;i:3;i:4;}','',24,5,0,'','user/reset/%/%/%','Reset password','t','','','a:0:{}',0,'','',0,'modules/user/user.pages.inc'),('vef/load/%','a:1:{i:2;N;}','','1','a:0:{}','_video_embed_field_show_video','a:1:{i:0;i:2;}','',6,3,0,'','vef/load/%','Video Embed Field - Load Video','t','','','a:0:{}',0,'','',0,''),('views/ajax','','','1','a:0:{}','views_ajax','a:0:{}','ajax_deliver',3,2,0,'','views/ajax','Views','t','','ajax_base_page_theme','a:0:{}',0,'Ajax callback for view loading.','',0,'sites/all/modules/views/includes/ajax.inc'),('webform/ajax/options/%','a:1:{i:3;a:1:{s:17:\"webform_menu_load\";a:1:{i:0;i:3;}}}','a:1:{i:3;s:19:\"webform_menu_to_arg\";}','webform_node_update_access','a:1:{i:0;i:3;}','webform_select_options_ajax','a:0:{}','',14,4,0,'','webform/ajax/options/%','','t','','','a:0:{}',0,'','',0,'sites/all/modules/webform/components/select.inc'),('webform/autocomplete','','','user_access','a:1:{i:0;s:16:\"administer views\";}','webform_views_autocomplete','a:0:{}','',3,2,0,'','webform/autocomplete','Webforms','t','','','a:0:{}',0,'','',0,'sites/all/modules/webform/views/webform.views.inc');
/*!40000 ALTER TABLE `menu_router` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `message`
--

DROP TABLE IF EXISTS `message`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `message` (
  `mid` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'The Unique ID of the message.',
  `type` varchar(255) NOT NULL DEFAULT '' COMMENT 'Reference to a message a type.',
  `arguments` text COMMENT 'Serialized array with the arguments',
  `uid` int(10) unsigned DEFAULT NULL COMMENT 'The user ID of the acting user.',
  `timestamp` int(10) unsigned NOT NULL COMMENT 'When the message instance was recorded.',
  `language` varchar(12) NOT NULL DEFAULT '' COMMENT 'The languages.language of this message.',
  PRIMARY KEY (`mid`),
  KEY `type_index` (`type`),
  KEY `timestamp` (`timestamp`)
) ENGINE=InnoDB AUTO_INCREMENT=121 DEFAULT CHARSET=utf8 COMMENT='An instance of a message type (e.g. like a node is an...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `message`
--

LOCK TABLES `message` WRITE;
/*!40000 ALTER TABLE `message` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `message` VALUES (1,'example_user_register','a:0:{}',2,1404782568,'en'),(2,'example_create_node','a:0:{}',1,1404783193,'en'),(3,'example_create_node','a:0:{}',1,1404783238,'en'),(4,'example_create_node','a:0:{}',1,1404835136,'en'),(5,'example_create_node','a:0:{}',1,1404835190,'en'),(6,'example_create_node','a:0:{}',1,1404835229,'en'),(7,'example_create_node','a:0:{}',1,1404836182,'en'),(8,'example_create_node','a:0:{}',1,1404836269,'en'),(9,'example_create_comment','a:0:{}',1,1404869654,'en'),(10,'example_create_comment','a:0:{}',2,1404869686,'en'),(11,'example_create_comment','a:0:{}',2,1404869706,'en'),(12,'example_create_comment','a:0:{}',2,1404869718,'en'),(13,'example_create_comment','a:0:{}',1,1404869733,'en'),(14,'example_create_node','a:0:{}',1,1405042769,'en'),(15,'example_create_comment','a:0:{}',1,1405042786,'en'),(16,'example_create_node','a:0:{}',1,1405134560,'en'),(17,'example_create_node','a:0:{}',1,1405134591,'en'),(18,'example_create_node','a:0:{}',1,1405266315,'en'),(19,'example_create_comment','a:0:{}',2,1405266476,'en'),(20,'example_user_register','a:0:{}',6,1405266663,'en'),(21,'example_create_comment','a:0:{}',6,1405267046,'en'),(22,'example_create_node','a:0:{}',1,1405267481,'en'),(23,'example_create_comment','a:0:{}',1,1405267525,'en'),(24,'example_create_node','a:0:{}',1,1405267880,'en'),(25,'example_create_node','a:0:{}',1,1405268124,'en'),(26,'example_create_node','a:0:{}',1,1405268198,'en'),(27,'example_create_node','a:0:{}',6,1405268456,'en'),(28,'example_create_node','a:0:{}',6,1405268526,'en'),(29,'example_create_node','a:0:{}',6,1405268575,'en'),(30,'example_create_node','a:0:{}',1,1405268760,'en'),(31,'example_create_node','a:0:{}',1,1405268847,'en'),(32,'example_create_node','a:0:{}',1,1405268886,'en'),(33,'example_create_node','a:0:{}',1,1405268991,'en'),(34,'example_create_node','a:0:{}',1,1406385599,'en'),(35,'example_create_node','a:0:{}',1,1406385654,'en'),(36,'example_create_node','a:0:{}',1,1406385738,'en'),(37,'example_create_node','a:0:{}',1,1406385981,'en'),(38,'example_create_node','a:0:{}',1,1406386042,'en'),(40,'example_create_node','a:0:{}',1,1406684025,'en'),(41,'example_create_node','a:0:{}',1,1407165877,'en'),(42,'example_create_node','a:0:{}',1,1407165964,'en'),(43,'example_create_node','a:0:{}',1,1407166040,'en'),(44,'example_create_node','a:0:{}',1,1407166257,'en'),(45,'example_create_node','a:0:{}',1,1407166392,'en'),(46,'example_create_node','a:0:{}',1,1407198597,'en'),(47,'example_create_node','a:0:{}',1,1407344034,'en'),(48,'example_create_node','a:0:{}',1,1407427674,'en'),(49,'example_create_node','a:0:{}',1,1407688359,'en'),(50,'example_create_node','a:0:{}',1,1407688494,'en'),(51,'example_create_node','a:0:{}',1,1407688533,'en'),(52,'example_create_node','a:0:{}',1,1407688952,'en'),(53,'example_create_node','a:0:{}',1,1407688986,'en'),(54,'example_create_comment','a:0:{}',2,1407764992,'en'),(55,'example_create_comment','a:0:{}',1,1407765206,'en'),(56,'example_create_comment','a:0:{}',2,1407765241,'en'),(57,'example_create_comment','a:0:{}',2,1407765279,'en'),(58,'example_create_node','a:0:{}',1,1407805139,'en'),(59,'example_create_comment','a:0:{}',2,1407806449,'en'),(60,'example_create_comment','a:0:{}',1,1407806469,'en'),(61,'example_create_comment','a:0:{}',1,1407806513,'en'),(62,'example_create_node','a:0:{}',1,1408172039,'en'),(63,'example_create_node','a:0:{}',1,1408172089,'en'),(64,'example_create_node','a:0:{}',1,1408172332,'en'),(65,'example_create_node','a:0:{}',1,1408172387,'en'),(66,'example_create_node','a:0:{}',1,1408172455,'en'),(67,'example_create_node','a:0:{}',1,1408184897,'en'),(68,'example_create_comment','a:0:{}',2,1408185053,'en'),(69,'example_create_comment','a:0:{}',1,1408185153,'en'),(70,'example_create_comment','a:0:{}',2,1408185174,'en'),(71,'example_create_comment','a:0:{}',1,1408185182,'en'),(72,'example_create_comment','a:0:{}',6,1408185237,'en'),(73,'example_create_comment','a:0:{}',2,1408185262,'en'),(74,'example_create_comment','a:0:{}',6,1408185277,'en'),(75,'example_create_comment','a:0:{}',6,1408185292,'en'),(76,'example_create_comment','a:0:{}',1,1408185317,'en'),(77,'example_create_comment','a:0:{}',6,1408185337,'en'),(78,'example_create_comment','a:0:{}',2,1408185360,'en'),(79,'example_user_register','a:0:{}',7,1408185635,'en'),(80,'example_create_comment','a:0:{}',7,1408185924,'en'),(81,'example_create_comment','a:0:{}',7,1408267227,'en'),(82,'example_create_comment','a:0:{}',1,1408267239,'en'),(83,'example_create_comment','a:0:{}',1,1408267244,'en'),(84,'example_create_comment','a:0:{}',1,1408267299,'en'),(85,'example_create_comment','a:0:{}',6,1408267409,'en'),(86,'example_create_comment','a:0:{}',6,1408267427,'en'),(87,'example_create_comment','a:0:{}',6,1408267436,'en'),(88,'example_create_comment','a:0:{}',6,1408267441,'en'),(89,'example_create_comment','a:0:{}',1,1408267499,'en'),(90,'example_create_comment','a:0:{}',1,1408267506,'en'),(91,'example_create_comment','a:0:{}',6,1408267535,'en'),(92,'example_create_comment','a:0:{}',1,1408267667,'en'),(93,'example_create_comment','a:0:{}',1,1408267673,'en'),(94,'example_create_comment','a:0:{}',7,1408267696,'en'),(95,'example_create_comment','a:0:{}',1,1408267711,'en'),(96,'example_create_comment','a:0:{}',1,1408267835,'en'),(97,'example_create_node','a:0:{}',1,1408269165,'en'),(98,'example_create_node','a:0:{}',1,1408269328,'en'),(99,'example_create_comment','a:0:{}',1,1408269496,'en'),(100,'example_create_comment','a:0:{}',6,1408269582,'en'),(101,'example_create_comment','a:0:{}',6,1408269967,'en'),(102,'example_create_node','a:0:{}',6,1408270071,'en'),(103,'example_create_comment','a:0:{}',1,1408270156,'en'),(104,'example_create_node','a:0:{}',1,1408312735,'en'),(105,'example_create_comment','a:0:{}',1,1408377529,'en'),(106,'example_create_comment','a:0:{}',1,1408382574,'en'),(107,'example_create_comment','a:0:{}',6,1408382644,'en'),(108,'example_create_comment','a:0:{}',1,1408589899,'fr'),(109,'example_create_node','a:0:{}',1,1408672600,'en'),(110,'example_create_node','a:0:{}',1,1408672639,'en'),(111,'example_create_node','a:0:{}',1,1408672667,'en'),(112,'example_create_node','a:0:{}',1,1408672689,'en'),(113,'example_create_node','a:0:{}',1,1408672716,'en'),(114,'example_create_node','a:0:{}',1,1408672739,'en'),(115,'example_create_node','a:0:{}',1,1408672751,'en'),(116,'example_create_node','a:0:{}',1,1408672764,'en'),(117,'example_create_node','a:0:{}',1,1408672872,'en'),(118,'example_create_node','a:0:{}',1,1408672894,'en'),(119,'example_create_node','a:0:{}',1,1442659410,'en'),(120,'example_create_node','a:0:{}',1,1442659526,'en');
/*!40000 ALTER TABLE `message` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `message_type`
--

DROP TABLE IF EXISTS `message_type`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `message_type` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT 'Primary Key: Numeric message type ID.',
  `name` varchar(255) NOT NULL DEFAULT '' COMMENT 'The unified identifier for a message type.',
  `category` varchar(255) NOT NULL DEFAULT 'message_type' COMMENT 'Reference to a message type category.',
  `description` varchar(255) NOT NULL DEFAULT '' COMMENT 'Description for this message type.',
  `argument_keys` text COMMENT 'Serialized array with the argument keys',
  `language` varchar(12) NOT NULL DEFAULT '' COMMENT 'The languages.language of this message type.',
  `status` tinyint(4) NOT NULL DEFAULT '1' COMMENT 'The exportable status of the entity.',
  `module` varchar(255) DEFAULT NULL COMMENT 'The name of the providing module if the entity has been defined in code.',
  `arguments` text COMMENT 'Serialized array with the arguments.',
  `data` longtext COMMENT 'Serialized array with general data.',
  PRIMARY KEY (`id`),
  UNIQUE KEY `name` (`name`)
) ENGINE=InnoDB AUTO_INCREMENT=4 DEFAULT CHARSET=utf8 COMMENT='Storage for user-defined message templates.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `message_type`
--

LOCK TABLES `message_type` WRITE;
/*!40000 ALTER TABLE `message_type` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `message_type` VALUES (1,'example_create_comment','message_type','Example - Create comment','a:1:{i:0;s:7:\"!teaser\";}','ar',3,'message_example','N;','a:2:{s:13:\"token options\";a:1:{s:5:\"clear\";i:0;}s:5:\"purge\";a:4:{s:8:\"override\";i:0;s:7:\"enabled\";i:0;s:5:\"quota\";s:0:\"\";s:4:\"days\";s:0:\"\";}}'),(2,'example_create_node','message_type','Example - Create node','a:0:{}','ar',3,'message_example','a:0:{}','a:2:{s:13:\"token options\";a:1:{s:5:\"clear\";i:0;}s:5:\"purge\";a:4:{s:8:\"override\";i:0;s:7:\"enabled\";i:0;s:5:\"quota\";s:0:\"\";s:4:\"days\";s:0:\"\";}}'),(3,'example_user_register','message_type','Example - User register','a:0:{}','ar',3,'message_example','N;','a:2:{s:13:\"token options\";a:1:{s:5:\"clear\";i:0;}s:5:\"purge\";a:4:{s:8:\"override\";i:0;s:7:\"enabled\";i:0;s:5:\"quota\";s:0:\"\";s:4:\"days\";s:0:\"\";}}');
/*!40000 ALTER TABLE `message_type` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `message_type_category`
--

DROP TABLE IF EXISTS `message_type_category`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `message_type_category` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT 'Primary Key: Numeric message type category ID.',
  `category` varchar(255) NOT NULL DEFAULT '' COMMENT 'The unified identifier for a message type category.',
  `description` varchar(255) NOT NULL DEFAULT '' COMMENT 'Description for this message type category.',
  `language` varchar(12) NOT NULL DEFAULT '' COMMENT 'The languages.language of this message type category.',
  `status` tinyint(4) NOT NULL DEFAULT '1' COMMENT 'The exportable status of the entity.',
  `module` varchar(255) DEFAULT NULL COMMENT 'The name of the providing module if the entity has been defined in code.',
  PRIMARY KEY (`id`),
  UNIQUE KEY `category` (`category`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Storage for user-defined message category.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `message_type_category`
--

LOCK TABLES `message_type_category` WRITE;
/*!40000 ALTER TABLE `message_type_category` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `message_type_category` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `node`
--

DROP TABLE IF EXISTS `node`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `node` (
  `nid` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'The primary identifier for a node.',
  `vid` int(10) unsigned DEFAULT NULL COMMENT 'The current node_revision.vid version identifier.',
  `type` varchar(32) NOT NULL DEFAULT '' COMMENT 'The node_type.type of this node.',
  `language` varchar(12) NOT NULL DEFAULT '' COMMENT 'The languages.language of this node.',
  `title` varchar(255) NOT NULL DEFAULT '' COMMENT 'The title of this node, always treated as non-markup plain text.',
  `uid` int(11) NOT NULL DEFAULT '0' COMMENT 'The users.uid that owns this node; initially, this is the user that created it.',
  `status` int(11) NOT NULL DEFAULT '1' COMMENT 'Boolean indicating whether the node is published (visible to non-administrators).',
  `created` int(11) NOT NULL DEFAULT '0' COMMENT 'The Unix timestamp when the node was created.',
  `changed` int(11) NOT NULL DEFAULT '0' COMMENT 'The Unix timestamp when the node was most recently saved.',
  `comment` int(11) NOT NULL DEFAULT '0' COMMENT 'Whether comments are allowed on this node: 0 = no, 1 = closed (read only), 2 = open (read/write).',
  `promote` int(11) NOT NULL DEFAULT '0' COMMENT 'Boolean indicating whether the node should be displayed on the front page.',
  `sticky` int(11) NOT NULL DEFAULT '0' COMMENT 'Boolean indicating whether the node should be displayed at the top of lists in which it appears.',
  `tnid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The translation set id for this node, which equals the node id of the source post in each set.',
  `translate` int(11) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this translation page needs to be updated.',
  PRIMARY KEY (`nid`),
  UNIQUE KEY `vid` (`vid`),
  KEY `node_changed` (`changed`),
  KEY `node_created` (`created`),
  KEY `node_frontpage` (`promote`,`status`,`sticky`,`created`),
  KEY `node_status_type` (`status`,`type`,`nid`),
  KEY `node_title_type` (`title`,`type`(4)),
  KEY `node_type` (`type`(4)),
  KEY `uid` (`uid`),
  KEY `tnid` (`tnid`),
  KEY `translate` (`translate`),
  KEY `language` (`language`)
) ENGINE=InnoDB AUTO_INCREMENT=70 DEFAULT CHARSET=utf8 COMMENT='The base table for nodes.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `node`
--

LOCK TABLES `node` WRITE;
/*!40000 ALTER TABLE `node` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `node` VALUES (1,1,'forum','und','Learn D7 coding or D8?',1,1,1404031643,1404551614,2,0,0,0,0),(2,2,'page','en','Community Guidelines',1,1,1404083058,1404083058,1,0,0,0,0),(3,3,'forum','en','Apple Updates MacBook Pro with Retina Display',1,1,1404550214,1408382603,2,0,0,0,0),(4,4,'article','en','54 Living Room Decorating Ideas',1,1,1404748836,1408771649,2,1,0,0,0),(5,5,'article','en','How do thoughts form?',1,1,1404783192,1408771632,2,1,0,0,0),(6,6,'article','en','Hotel - A Luxury Drupal Themes',1,1,1404783238,1408771488,2,1,0,0,0),(7,7,'blog','en','A Few Days in Off-Season Aspen',1,1,1407513536,1408268642,2,1,0,0,0),(8,8,'blog','en','The 27 Principles to Teaching Yourself Anything',1,1,1407166819,1408268709,2,1,0,0,0),(9,9,'blog','en','22 Ways to Save Money',1,1,1407166373,1408268783,2,1,0,0,0),(10,10,'blog','en','How to Pick a Good Hostel',1,1,1404836182,1407767078,2,1,0,0,0),(11,11,'blog','en','The Best Drawing Art Books',1,1,1404836269,1407766964,2,1,0,0,0),(12,12,'article','en','50 Best Apps and Websites for Travelers',1,1,1405042769,1408771462,2,1,0,0,0),(13,13,'faq','en','Praesent nec nisl a purus',1,1,1405134560,1422337197,2,1,0,0,0),(14,14,'faq','en','Praesent congue erat at massa',1,1,1405134591,1422337197,2,1,0,0,0),(15,15,'forum','en','What does WeebPal do?',1,1,1405266314,1405267382,1,0,0,0,0),(16,16,'forum','en','Headline news',1,1,1405267481,1405267481,2,0,1,0,0),(17,17,'forum','en','Review front page promotion requests',1,1,1405267880,1444037928,2,0,0,0,0),(18,18,'forum','en','Hosting',1,1,1405268124,1405268124,2,0,0,0,0),(19,19,'forum','en','Installing Drush on Shared Hosting Accounts',1,1,1405268196,1405268260,2,0,0,0,0),(20,20,'forum','en','System requirements',6,1,1405268456,1405268456,2,0,0,0,0),(21,21,'forum','en','Web server',6,1,1405268526,1405268526,2,0,0,0,0),(22,22,'forum','en','Database server',6,1,1405268575,1405268575,2,0,0,0,0),(23,23,'page','en','Basic Shortcodes',1,1,1405268760,1405268786,1,0,0,0,0),(24,24,'page','en','Tooltip',1,1,1405268847,1405268847,1,0,0,0,0),(25,25,'page','en','Video',1,1,1405268886,1405268953,1,0,0,0,0),(26,26,'page','en','Collapse',1,1,1405268990,1405268990,1,0,0,0,0),(27,27,'article','en','35 reasons rain is better than sunshine',1,1,1406385599,1408771455,2,1,0,0,0),(28,28,'article','en','20 Decorating Secrets',1,1,1406385654,1408771448,2,1,0,0,0),(29,29,'article','en','Here’s How Much It Costs to Raise a Child',1,1,1406385737,1408771557,2,1,0,0,0),(30,30,'article','en','7 Exercises That Will Transform Your Body',1,1,1406385981,1408771565,2,1,0,0,0),(31,31,'article','en','31 Healthy Foods You Should Be Eating Now',1,1,1406386042,1408771406,2,1,0,0,0),(33,33,'page','en','404 page',1,1,1406684024,1406684051,1,0,0,0,0),(34,34,'video','en','Margaret - Thank You Very Much',1,1,1405869873,1407806046,2,1,0,0,0),(35,35,'video','en','Beautiful Light Music - easy smooth inspirational - long playlist by relaxdaily: Ocean Breeze',1,1,1407165961,1407806013,2,1,0,0,0),(36,36,'video','en','One Direction - What Makes You Beautiful (5 Piano Guys, 1 piano) - ThePianoGuys',1,1,1407166039,1407805986,2,1,0,0,0),(37,37,'video','en','The San Juans. Proven Here.',1,1,1407166253,1407805961,2,1,0,0,0),(38,38,'video','en','Stop Motion',1,1,1407166386,1407805906,2,1,0,0,0),(39,39,'page','en','Mega Menu',1,1,1407198597,1407198894,1,0,0,0,0),(40,40,'webform','en','Contact Us',1,1,1407344033,1407773329,1,0,0,0,0),(41,41,'webform','en','Contact Us 2',1,1,1407427673,1407773369,1,0,0,0,0),(42,42,'page','en','Color',1,1,1407688358,1407688358,1,0,0,0,0),(43,43,'page','en','Default',1,1,1407688494,1407688580,1,0,0,0,0),(44,44,'page','en','Red',1,1,1407688533,1407688533,1,0,0,0,0),(45,45,'page','en','Yellow',1,1,1407688951,1444379051,1,0,0,0,0),(46,46,'page','en','Dark',1,1,1407688986,1407688986,1,0,0,0,0),(47,47,'forum','en','Apple Launches Email Ad Campaign Focusing on Productivity',1,1,1407805139,1408382558,2,0,0,0,0),(48,48,'products','en','Blog',1,1,1408172039,1408586945,2,0,0,0,0),(49,49,'products','en','AutoX',1,1,1408172089,1408585683,2,0,0,0,0),(50,50,'products','en','One Page',1,1,1408172332,1408585698,2,0,0,0,0),(51,51,'products','en','Pinteros',1,1,1408172387,1408585713,2,0,0,0,0),(52,52,'products','en','Zircon',1,1,1408172455,1408585727,2,0,0,0,0),(53,53,'forum','en','8 Project Management Tips',1,1,1408184897,1408184897,2,0,0,0,0),(54,54,'forum','en','Column Oriented Databases: Does bigtable, cassandra belong to column store database?',1,1,1408269165,1408269253,2,0,0,0,0),(55,55,'forum','en','Time Travel: Why are people from the future not time traveling to our period?',1,1,1408269327,1408269476,2,0,0,0,0),(56,56,'forum','en','Drupal Installation',6,1,1443866870,1444038019,2,0,0,0,0),(57,57,'page','en','Green',1,1,1408312735,1408312735,1,0,0,0,0),(58,58,'faq','en','Donec vitae sapien ut',1,1,1408672599,1422337197,2,1,0,0,0),(59,59,'faq','en','Fusce pulvinar interdum lectus sed tempor',1,1,1408672638,1422337197,2,1,0,0,0),(60,60,'faq','en','Lorem ipsum dolor sit amet, consectetuer adipiscing elit',1,1,1408672667,1422337197,2,1,0,0,0),(61,61,'faq','en','Aenean posuere, tortor sed cursus feugiat, nunc augue blandit nunc,',1,1,1408672688,1422337209,2,1,0,0,0),(62,62,'faq','en','Pellentesque egestas neque sit amet',1,1,1408672716,1422337209,2,1,0,0,0),(63,63,'faq','en','Suspendisse enim turpis, dictum sed, iaculis a, condimentum nec, nisi.',1,1,1408672739,1422337209,2,1,0,0,0),(64,64,'faq','en','Morbi mollis tellus ac sapien',1,1,1408672750,1422337209,2,1,0,0,0),(65,65,'faq','en','Proin faucibus arcu quis ante',1,1,1408672764,1422337209,2,1,0,0,0),(66,66,'faq','en','Curabitur non elit faucibus, malesuada elit at, pellentesque tellus',1,1,1408672871,1422337209,2,1,0,0,0),(67,67,'faq','en','Phasellus enim eros, dapibus non pulvinar vel, condimentum quis felis',1,1,1408672894,1422337209,2,1,0,0,0),(68,68,'forum','en','Headline news ',1,1,1442659410,1442659410,2,0,0,0,0),(69,69,'forum','en','Learn D7 coding or D8? ',1,1,1443955525,1444037999,2,0,0,0,0);
/*!40000 ALTER TABLE `node` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `node_access`
--

DROP TABLE IF EXISTS `node_access`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `node_access` (
  `nid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The node.nid this record affects.',
  `gid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The grant ID a user must possess in the specified realm to gain this row’s privileges on the node.',
  `realm` varchar(255) NOT NULL DEFAULT '' COMMENT 'The realm in which the user must possess the grant ID. Each node access node can define one or more realms.',
  `grant_view` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT 'Boolean indicating whether a user with the realm/grant pair can view this node.',
  `grant_update` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT 'Boolean indicating whether a user with the realm/grant pair can edit this node.',
  `grant_delete` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT 'Boolean indicating whether a user with the realm/grant pair can delete this node.',
  PRIMARY KEY (`nid`,`gid`,`realm`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Identifies which realm/grant pairs a user must possess in...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `node_access`
--

LOCK TABLES `node_access` WRITE;
/*!40000 ALTER TABLE `node_access` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `node_access` VALUES (0,0,'all',1,0,0);
/*!40000 ALTER TABLE `node_access` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `node_class`
--

DROP TABLE IF EXISTS `node_class`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `node_class` (
  `nid` varchar(32) NOT NULL,
  `css_class` varchar(255) NOT NULL DEFAULT '' COMMENT 'String containing the classes for the block.',
  PRIMARY KEY (`nid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `node_class`
--

LOCK TABLES `node_class` WRITE;
/*!40000 ALTER TABLE `node_class` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `node_class` VALUES ('10',''),('11',''),('12',''),('13',''),('14',''),('15',''),('16',''),('17',''),('18',''),('19',''),('23',''),('24',''),('25',''),('26',''),('27',''),('28',''),('29',''),('3',''),('30',''),('31',''),('33',''),('34',''),('35',''),('36',''),('37',''),('38',''),('39',''),('4',''),('40','forum-contact1'),('41','forum-contact2'),('42',''),('43',''),('44',''),('45',''),('46',''),('47',''),('48',''),('49',''),('5',''),('50',''),('51',''),('52',''),('53',''),('54',''),('55',''),('56',''),('57',''),('58',''),('59',''),('6',''),('60',''),('61',''),('62',''),('63',''),('64',''),('65',''),('66',''),('67',''),('68',''),('69',''),('7',''),('8',''),('9','');
/*!40000 ALTER TABLE `node_class` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `node_comment_statistics`
--

DROP TABLE IF EXISTS `node_comment_statistics`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `node_comment_statistics` (
  `nid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The node.nid for which the statistics are compiled.',
  `cid` int(11) NOT NULL DEFAULT '0' COMMENT 'The comment.cid of the last comment.',
  `last_comment_timestamp` int(11) NOT NULL DEFAULT '0' COMMENT 'The Unix timestamp of the last comment that was posted within this node, from comment.changed.',
  `last_comment_name` varchar(60) DEFAULT NULL COMMENT 'The name of the latest author to post a comment on this node, from comment.name.',
  `last_comment_uid` int(11) NOT NULL DEFAULT '0' COMMENT 'The user ID of the latest author to post a comment on this node, from comment.uid.',
  `comment_count` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The total number of comments on this node.',
  PRIMARY KEY (`nid`),
  KEY `node_comment_timestamp` (`last_comment_timestamp`),
  KEY `comment_count` (`comment_count`),
  KEY `last_comment_uid` (`last_comment_uid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Maintains statistics of node and comments posts to show ...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `node_comment_statistics`
--

LOCK TABLES `node_comment_statistics` WRITE;
/*!40000 ALTER TABLE `node_comment_statistics` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `node_comment_statistics` VALUES (1,53,1408589898,'',1,2),(2,0,1404083058,NULL,1,0),(3,52,1408382643,'',6,1),(4,0,1404748836,NULL,1,0),(5,16,1407806469,'',1,2),(6,0,1404783238,NULL,1,0),(7,40,1408267535,'',6,12),(8,44,1408267710,'',1,4),(9,45,1408267835,'',1,3),(10,17,1407806513,'',1,1),(11,3,1404869686,'',2,2),(12,7,1405042786,'',1,1),(13,0,1405134560,NULL,1,0),(14,0,1405134591,NULL,1,0),(15,9,1405267046,'',6,2),(16,10,1405267524,'',1,1),(17,0,1405267880,NULL,1,0),(18,0,1405268124,NULL,1,0),(19,0,1405268196,NULL,1,0),(20,0,1405268456,NULL,6,0),(21,0,1405268526,NULL,6,0),(22,0,1405268575,NULL,6,0),(23,0,1405268760,NULL,1,0),(24,0,1405268847,NULL,1,0),(25,0,1405268886,NULL,1,0),(26,0,1405268990,NULL,1,0),(27,0,1406385599,NULL,1,0),(28,0,1406385654,NULL,1,0),(29,0,1406385737,NULL,1,0),(30,14,1407765278,'',2,1),(31,13,1407765241,'',2,3),(33,0,1406684024,NULL,1,0),(34,0,1407165873,NULL,1,0),(35,0,1407165961,NULL,1,0),(36,0,1407166039,NULL,1,0),(37,50,1408377529,'',1,1),(38,0,1407166386,NULL,1,0),(39,0,1407198597,NULL,1,0),(40,0,1407344033,NULL,1,0),(41,0,1407427673,NULL,1,0),(42,0,1407688358,NULL,1,0),(43,0,1407688494,NULL,1,0),(44,0,1407688533,NULL,1,0),(45,0,1407688951,NULL,1,0),(46,0,1407688986,NULL,1,0),(47,51,1408382574,'',1,1),(48,0,1408172039,NULL,1,0),(49,0,1408172089,NULL,1,0),(50,0,1408172332,NULL,1,0),(51,0,1408172387,NULL,1,0),(52,0,1408172455,NULL,1,0),(53,29,1408185924,'',7,12),(54,48,1408269965,'',6,1),(55,47,1408269582,'',6,2),(56,49,1408270154,'',1,1),(57,0,1408312735,NULL,1,0),(58,0,1408672599,NULL,1,0),(59,0,1408672638,NULL,1,0),(60,0,1408672667,NULL,1,0),(61,0,1408672688,NULL,1,0),(62,0,1408672716,NULL,1,0),(63,0,1408672739,NULL,1,0),(64,0,1408672750,NULL,1,0),(65,0,1408672764,NULL,1,0),(66,0,1408672871,NULL,1,0),(67,0,1408672894,NULL,1,0),(68,0,1442659410,NULL,1,0),(69,0,1442659525,NULL,1,0);
/*!40000 ALTER TABLE `node_comment_statistics` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `node_counter`
--

DROP TABLE IF EXISTS `node_counter`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `node_counter` (
  `nid` int(11) NOT NULL DEFAULT '0' COMMENT 'The node.nid for these statistics.',
  `totalcount` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT 'The total number of times the node has been viewed.',
  `daycount` mediumint(8) unsigned NOT NULL DEFAULT '0' COMMENT 'The total number of times the node has been viewed today.',
  `timestamp` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The most recent time the node has been viewed.',
  PRIMARY KEY (`nid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Access statistics for nodes.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `node_counter`
--

LOCK TABLES `node_counter` WRITE;
/*!40000 ALTER TABLE `node_counter` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `node_counter` VALUES (1,41,0,1427771647),(2,5,0,1448274580),(3,10,0,1408382644),(4,26,0,1408771650),(5,46,0,1448260514),(6,57,0,1408771489),(7,214,0,1448351742),(8,62,0,1448015471),(9,42,0,1444039108),(10,22,0,1441359110),(11,63,0,1418971389),(12,32,0,1448347616),(13,2,0,1405134561),(14,2,0,1405134591),(15,32,0,1448273499),(16,128,0,1448265727),(17,8,0,1420513969),(18,6,0,1441004038),(19,7,0,1448273467),(20,14,0,1448271640),(21,6,0,1420514308),(22,55,0,1441350213),(23,10,0,1406330796),(24,4,0,1405532752),(25,5,0,1405269006),(26,4,0,1405532744),(27,17,0,1448345841),(28,36,0,1418978491),(29,31,0,1441337692),(30,57,0,1448360608),(31,195,0,1448361813),(33,91,0,1444379120),(34,10,0,1408170687),(35,5,0,1407806015),(36,8,0,1417152641),(37,21,0,1418111911),(38,27,0,1444123622),(39,26,0,1407689447),(40,78,0,1420515184),(41,39,0,1448347748),(42,39,0,1500259151),(43,50,0,1444379065),(44,40,0,1444379071),(45,60,0,1444379188),(46,36,0,1444379074),(47,23,0,1441004126),(48,6,0,1408586946),(49,2,0,1408172090),(50,2,0,1408172333),(51,2,0,1408172388),(52,2,0,1408172456),(53,92,0,1448352527),(54,27,0,1441274964),(55,25,0,1409929110),(56,5,0,1448349894),(57,24,0,1444379077),(58,2,0,1408672600),(59,5,0,1408672845),(60,2,0,1408672668),(61,2,0,1408672689),(62,2,0,1408672716),(63,2,0,1408672739),(64,2,0,1408672751),(65,2,0,1408672765),(66,2,0,1408672872),(67,3,0,1441005494),(68,3,0,1444038504),(69,62,0,1448361353);
/*!40000 ALTER TABLE `node_counter` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `node_revision`
--

DROP TABLE IF EXISTS `node_revision`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `node_revision` (
  `nid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The node this version belongs to.',
  `vid` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'The primary identifier for this version.',
  `uid` int(11) NOT NULL DEFAULT '0' COMMENT 'The users.uid that created this version.',
  `title` varchar(255) NOT NULL DEFAULT '' COMMENT 'The title of this version.',
  `log` longtext NOT NULL COMMENT 'The log entry explaining the changes in this version.',
  `timestamp` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when this version was created.',
  `status` int(11) NOT NULL DEFAULT '1' COMMENT 'Boolean indicating whether the node (at the time of this revision) is published (visible to non-administrators).',
  `comment` int(11) NOT NULL DEFAULT '0' COMMENT 'Whether comments are allowed on this node (at the time of this revision): 0 = no, 1 = closed (read only), 2 = open (read/write).',
  `promote` int(11) NOT NULL DEFAULT '0' COMMENT 'Boolean indicating whether the node (at the time of this revision) should be displayed on the front page.',
  `sticky` int(11) NOT NULL DEFAULT '0' COMMENT 'Boolean indicating whether the node (at the time of this revision) should be displayed at the top of lists in which it appears.',
  PRIMARY KEY (`vid`),
  KEY `nid` (`nid`),
  KEY `uid` (`uid`)
) ENGINE=InnoDB AUTO_INCREMENT=70 DEFAULT CHARSET=utf8 COMMENT='Stores information about each saved version of a node.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `node_revision`
--

LOCK TABLES `node_revision` WRITE;
/*!40000 ALTER TABLE `node_revision` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `node_revision` VALUES (1,1,1,'Learn D7 coding or D8?','',1404551614,1,2,0,0),(2,2,1,'Community Guidelines','',1404083058,1,1,0,0),(3,3,1,'Apple Updates MacBook Pro with Retina Display','',1408382603,1,2,0,0),(4,4,1,'54 Living Room Decorating Ideas','',1408771649,1,2,1,0),(5,5,1,'How do thoughts form?','',1408771632,1,2,1,0),(6,6,1,'Hotel - A Luxury Drupal Themes','',1408771488,1,2,1,0),(7,7,1,'A Few Days in Off-Season Aspen','',1408268642,1,2,1,0),(8,8,1,'The 27 Principles to Teaching Yourself Anything','',1408268709,1,2,1,0),(9,9,1,'22 Ways to Save Money','',1408268783,1,2,1,0),(10,10,1,'How to Pick a Good Hostel','',1407767078,1,2,1,0),(11,11,1,'The Best Drawing Art Books','',1407766964,1,2,1,0),(12,12,1,'50 Best Apps and Websites for Travelers','',1408771462,1,2,1,0),(13,13,1,'Praesent nec nisl a purus','',1422337197,1,2,1,0),(14,14,1,'Praesent congue erat at massa','',1422337197,1,2,1,0),(15,15,1,'What does WeebPal do?','',1405267382,1,1,0,0),(16,16,1,'Headline news','',1405267481,1,2,0,1),(17,17,1,'Review front page promotion requests','',1444037928,1,2,0,0),(18,18,1,'Hosting','',1405268124,1,2,0,0),(19,19,1,'Installing Drush on Shared Hosting Accounts','',1405268260,1,2,0,0),(20,20,6,'System requirements','',1405268456,1,2,0,0),(21,21,6,'Web server','',1405268526,1,2,0,0),(22,22,6,'Database server','',1405268575,1,2,0,0),(23,23,1,'Basic Shortcodes','',1405268786,1,1,0,0),(24,24,1,'Tooltip','',1405268847,1,1,0,0),(25,25,1,'Video','',1405268953,1,1,0,0),(26,26,1,'Collapse','',1405268990,1,1,0,0),(27,27,1,'35 reasons rain is better than sunshine','',1408771455,1,2,1,0),(28,28,1,'20 Decorating Secrets','',1408771448,1,2,1,0),(29,29,1,'Here’s How Much It Costs to Raise a Child','',1408771557,1,2,1,0),(30,30,1,'7 Exercises That Will Transform Your Body','',1408771565,1,2,1,0),(31,31,1,'31 Healthy Foods You Should Be Eating Now','',1408771406,1,2,1,0),(33,33,1,'404 page','',1406684051,1,1,0,0),(34,34,1,'Margaret - Thank You Very Much','',1407806046,1,2,1,0),(35,35,1,'Beautiful Light Music - easy smooth inspirational - long playlist by relaxdaily: Ocean Breeze','',1407806013,1,2,1,0),(36,36,1,'One Direction - What Makes You Beautiful (5 Piano Guys, 1 piano) - ThePianoGuys','',1407805986,1,2,1,0),(37,37,1,'The San Juans. Proven Here.','',1407805961,1,2,1,0),(38,38,1,'Stop Motion','',1407805906,1,2,1,0),(39,39,1,'Mega Menu','',1407198894,1,1,0,0),(40,40,1,'Contact Us','',1407773329,1,1,0,0),(41,41,1,'Contact Us 2','',1407773369,1,1,0,0),(42,42,1,'Color','',1407688358,1,1,0,0),(43,43,1,'Default','',1407688580,1,1,0,0),(44,44,1,'Red','',1407688533,1,1,0,0),(45,45,1,'Yellow','',1444379051,1,1,0,0),(46,46,1,'Dark','',1407688986,1,1,0,0),(47,47,1,'Apple Launches Email Ad Campaign Focusing on Productivity','',1408382558,1,2,0,0),(48,48,1,'Blog','',1408586945,1,2,0,0),(49,49,1,'AutoX','',1408585683,1,2,0,0),(50,50,1,'One Page','',1408585698,1,2,0,0),(51,51,1,'Pinteros','',1408585713,1,2,0,0),(52,52,1,'Zircon','',1408585727,1,2,0,0),(53,53,1,'8 Project Management Tips','',1408184897,1,2,0,0),(54,54,1,'Column Oriented Databases: Does bigtable, cassandra belong to column store database?','',1408269253,1,2,0,0),(55,55,1,'Time Travel: Why are people from the future not time traveling to our period?','',1408269476,1,2,0,0),(56,56,1,'Drupal Installation','',1444038019,1,2,0,0),(57,57,1,'Green','',1408312735,1,1,0,0),(58,58,1,'Donec vitae sapien ut','',1422337197,1,2,1,0),(59,59,1,'Fusce pulvinar interdum lectus sed tempor','',1422337197,1,2,1,0),(60,60,1,'Lorem ipsum dolor sit amet, consectetuer adipiscing elit','',1422337197,1,2,1,0),(61,61,1,'Aenean posuere, tortor sed cursus feugiat, nunc augue blandit nunc,','',1422337209,1,2,1,0),(62,62,1,'Pellentesque egestas neque sit amet','',1422337209,1,2,1,0),(63,63,1,'Suspendisse enim turpis, dictum sed, iaculis a, condimentum nec, nisi.','',1422337209,1,2,1,0),(64,64,1,'Morbi mollis tellus ac sapien','',1422337209,1,2,1,0),(65,65,1,'Proin faucibus arcu quis ante','',1422337209,1,2,1,0),(66,66,1,'Curabitur non elit faucibus, malesuada elit at, pellentesque tellus','',1422337209,1,2,1,0),(67,67,1,'Phasellus enim eros, dapibus non pulvinar vel, condimentum quis felis','',1422337209,1,2,1,0),(68,68,1,'Headline news ','',1442659410,1,2,0,0),(69,69,1,'Learn D7 coding or D8? ','',1444037999,1,2,0,0);
/*!40000 ALTER TABLE `node_revision` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `node_type`
--

DROP TABLE IF EXISTS `node_type`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `node_type` (
  `type` varchar(32) NOT NULL COMMENT 'The machine-readable name of this type.',
  `name` varchar(255) NOT NULL DEFAULT '' COMMENT 'The human-readable name of this type.',
  `base` varchar(255) NOT NULL COMMENT 'The base string used to construct callbacks corresponding to this node type.',
  `module` varchar(255) NOT NULL COMMENT 'The module defining this node type.',
  `description` mediumtext NOT NULL COMMENT 'A brief description of this type.',
  `help` mediumtext NOT NULL COMMENT 'Help information shown to the user when creating a node of this type.',
  `has_title` tinyint(3) unsigned NOT NULL COMMENT 'Boolean indicating whether this type uses the node.title field.',
  `title_label` varchar(255) NOT NULL DEFAULT '' COMMENT 'The label displayed for the title field on the edit form.',
  `custom` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this type is defined by a module (FALSE) or by a user via Add content type (TRUE).',
  `modified` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this type has been modified by an administrator; currently not used in any way.',
  `locked` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether the administrator can change the machine name of this type.',
  `disabled` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether the node type is disabled.',
  `orig_type` varchar(255) NOT NULL DEFAULT '' COMMENT 'The original machine-readable name of this node type. This may be different from the current type name if the locked field is 0.',
  PRIMARY KEY (`type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Stores information about all defined node types.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `node_type`
--

LOCK TABLES `node_type` WRITE;
/*!40000 ALTER TABLE `node_type` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `node_type` VALUES ('article','Article','node_content','node','Use <em>articles</em> for time-sensitive content like news, press releases or blog posts.','',1,'Title',1,1,0,0,'article'),('blog','Blog entry','blog','blog','Use for multi-user blogs. Every user gets a personal blog.','',1,'Title',0,1,1,0,'blog'),('book','Book page','node_content','node','<em>Books</em> have a built-in hierarchical navigation. Use for handbooks or tutorials.','',1,'Title',1,1,0,0,'book'),('faq','FAQ','faq','faq','A frequently asked question and its answer.','',1,'Question',0,0,1,0,'faq'),('forum','Forum topic','forum','forum','A <em>forum topic</em> starts a new discussion thread within a forum.','',1,'Subject',0,1,1,0,'forum'),('page','Basic page','node_content','node','Use <em>basic pages</em> for your static content, such as an \'About us\' page.','',1,'Title',1,1,0,0,'page'),('products','Products','node_content','node','','',1,'Title',1,1,0,0,'products'),('video','Video','node_content','node','','',1,'Title',1,1,0,0,'video'),('webform','Webform','node_content','node','Create a new form or questionnaire accessible to users. Submission results and statistics are recorded and accessible to privileged users.','',1,'Title',1,1,0,0,'webform');
/*!40000 ALTER TABLE `node_type` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `queue`
--

DROP TABLE IF EXISTS `queue`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `queue` (
  `item_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Primary Key: Unique item ID.',
  `name` varchar(255) NOT NULL DEFAULT '' COMMENT 'The queue name.',
  `data` longblob COMMENT 'The arbitrary data for the item.',
  `expire` int(11) NOT NULL DEFAULT '0' COMMENT 'Timestamp when the claim lease expires on the item.',
  `created` int(11) NOT NULL DEFAULT '0' COMMENT 'Timestamp when the item was created.',
  PRIMARY KEY (`item_id`),
  KEY `name_created` (`name`,`created`),
  KEY `expire` (`expire`)
) ENGINE=InnoDB AUTO_INCREMENT=111 DEFAULT CHARSET=utf8 COMMENT='Stores items in queues.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `queue`
--

LOCK TABLES `queue` WRITE;
/*!40000 ALTER TABLE `queue` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `queue` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `quicktabs`
--

DROP TABLE IF EXISTS `quicktabs`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `quicktabs` (
  `machine_name` varchar(255) NOT NULL COMMENT 'The primary identifier for a qt block.',
  `ajax` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Whether this is an ajax views block.',
  `hide_empty_tabs` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT 'Whether this tabset hides empty tabs.',
  `default_tab` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Default tab.',
  `title` varchar(255) NOT NULL COMMENT 'The title of this quicktabs block.',
  `tabs` mediumtext NOT NULL COMMENT 'A serialized array of the contents of this qt block.',
  `renderer` varchar(255) NOT NULL COMMENT 'The rendering mechanism.',
  `style` varchar(255) NOT NULL COMMENT 'The tab style.',
  `options` mediumtext COMMENT 'A serialized array of the options for this qt instance.',
  PRIMARY KEY (`machine_name`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='The quicktabs table.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `quicktabs`
--

LOCK TABLES `quicktabs` WRITE;
/*!40000 ALTER TABLE `quicktabs` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `quicktabs` VALUES ('quicktab',0,0,0,'Quicktab','a:3:{i:0;a:5:{s:3:\"bid\";s:30:\"views_delta_recent_blogs-block\";s:10:\"hide_title\";i:1;s:5:\"title\";s:15:\"Recent Entities\";s:6:\"weight\";s:4:\"-100\";s:4:\"type\";s:5:\"block\";}i:1;a:5:{s:3:\"bid\";s:32:\"views_delta_recent_blogs-block_1\";s:10:\"hide_title\";i:1;s:5:\"title\";s:12:\"Most Popular\";s:6:\"weight\";s:3:\"-99\";s:4:\"type\";s:5:\"block\";}i:2;a:5:{s:3:\"bid\";s:32:\"views_delta_recent_blogs-block_2\";s:10:\"hide_title\";i:1;s:5:\"title\";s:10:\"Best Blogs\";s:6:\"weight\";s:3:\"-98\";s:4:\"type\";s:5:\"block\";}}','quicktabs','nostyle','a:0:{}');
/*!40000 ALTER TABLE `quicktabs` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `registry`
--

DROP TABLE IF EXISTS `registry`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `registry` (
  `name` varchar(255) NOT NULL DEFAULT '' COMMENT 'The name of the function, class, or interface.',
  `type` varchar(9) NOT NULL DEFAULT '' COMMENT 'Either function or class or interface.',
  `filename` varchar(255) NOT NULL COMMENT 'Name of the file.',
  `module` varchar(255) NOT NULL DEFAULT '' COMMENT 'Name of the module the file belongs to.',
  `weight` int(11) NOT NULL DEFAULT '0' COMMENT 'The order in which this module’s hooks should be invoked relative to other modules. Equal-weighted modules are ordered by name.',
  PRIMARY KEY (`name`,`type`),
  KEY `hook` (`type`,`weight`,`module`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Each record is a function, class, or interface name and...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `registry`
--

LOCK TABLES `registry` WRITE;
/*!40000 ALTER TABLE `registry` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `registry` VALUES ('AccessDeniedTestCase','class','modules/system/system.test','system',0),('AdminMenuCustomizedTestCase','class','sites/all/modules/admin_menu/tests/admin_menu.test','admin_menu',100),('AdminMenuDynamicLinksTestCase','class','sites/all/modules/admin_menu/tests/admin_menu.test','admin_menu',100),('AdminMenuLinkTypesTestCase','class','sites/all/modules/admin_menu/tests/admin_menu.test','admin_menu',100),('AdminMenuPermissionsTestCase','class','sites/all/modules/admin_menu/tests/admin_menu.test','admin_menu',100),('AdminMenuWebTestCase','class','sites/all/modules/admin_menu/tests/admin_menu.test','admin_menu',100),('AdminMetaTagTestCase','class','modules/system/system.test','system',0),('advanced_forum_handler_field_node_topic_icon','class','sites/all/modules/advanced_forum/includes/views/advanced_forum_handler_field_node_topic_icon.inc','advanced_forum',15),('advanced_forum_handler_field_node_topic_pager','class','sites/all/modules/advanced_forum/includes/views/advanced_forum_handler_field_node_topic_pager.inc','advanced_forum',15),('advanced_forum_plugin_style_forum_topic_list','class','sites/all/modules/advanced_forum/includes/views/advanced_forum_plugin_style_forum_topic_list.inc','advanced_forum',15),('AfSimpleAPITest','class','sites/all/modules/advanced_forum/tests/af.test','advanced_forum',15),('ArchiverInterface','interface','includes/archiver.inc','',0),('ArchiverTar','class','modules/system/system.archiver.inc','system',0),('ArchiverZip','class','modules/system/system.archiver.inc','system',0),('Archive_Tar','class','modules/system/system.tar.inc','system',0),('BatchMemoryQueue','class','includes/batch.queue.inc','',0),('BatchQueue','class','includes/batch.queue.inc','',0),('BlockAdminThemeTestCase','class','modules/block/block.test','block',-5),('BlockCacheTestCase','class','modules/block/block.test','block',-5),('BlockClassContextTestCase','class','sites/all/modules/block_class/block_class.test','block_class',0),('BlockClassFeaturesTestCase','class','sites/all/modules/block_class/block_class.test','block_class',0),('BlockClassPermissionTestCase','class','sites/all/modules/block_class/block_class.test','block_class',0),('BlockClassTestCase','class','sites/all/modules/block_class/block_class.test','block_class',0),('BlockClassUpdateDisplayTestCase','class','sites/all/modules/block_class/block_class.test','block_class',0),('BlockHashTestCase','class','modules/block/block.test','block',-5),('BlockHiddenRegionTestCase','class','modules/block/block.test','block',-5),('BlockHTMLIdTestCase','class','modules/block/block.test','block',-5),('BlockInvalidRegionTestCase','class','modules/block/block.test','block',-5),('BlockTemplateSuggestionsUnitTest','class','modules/block/block.test','block',-5),('BlockTestCase','class','modules/block/block.test','block',-5),('BlockViewModuleDeltaAlterWebTest','class','modules/block/block.test','block',-5),('BlogTestCase','class','modules/blog/blog.test','blog',0),('BookTestCase','class','modules/book/book.test','book',0),('calendar_plugin_row','class','sites/all/modules/calendar/includes/calendar_plugin_row.inc','calendar',0),('calendar_plugin_style','class','sites/all/modules/calendar/includes/calendar_plugin_style.inc','calendar',0),('ColorTestCase','class','modules/color/color.test','color',0),('CommentActionsTestCase','class','modules/comment/comment.test','comment',0),('CommentAnonymous','class','modules/comment/comment.test','comment',0),('CommentApprovalTest','class','modules/comment/comment.test','comment',0),('CommentBlockFunctionalTest','class','modules/comment/comment.test','comment',0),('CommentContentRebuild','class','modules/comment/comment.test','comment',0),('CommentController','class','modules/comment/comment.module','comment',0),('CommentFieldsTest','class','modules/comment/comment.test','comment',0),('CommentHelperCase','class','modules/comment/comment.test','comment',0),('CommentInterfaceTest','class','modules/comment/comment.test','comment',0),('CommentNodeAccessTest','class','modules/comment/comment.test','comment',0),('CommentNodeChangesTestCase','class','modules/comment/comment.test','comment',0),('CommentPagerTest','class','modules/comment/comment.test','comment',0),('CommentPreviewTest','class','modules/comment/comment.test','comment',0),('CommentRSSUnitTest','class','modules/comment/comment.test','comment',0),('CommentThreadingTestCase','class','modules/comment/comment.test','comment',0),('CommentTokenReplaceTestCase','class','modules/comment/comment.test','comment',0),('ConfirmFormTest','class','modules/system/system.test','system',0),('ContactPersonalTestCase','class','modules/contact/contact.test','contact',0),('ContactSitewideTestCase','class','modules/contact/contact.test','contact',0),('ContextualDynamicContextTestCase','class','modules/contextual/contextual.test','contextual',0),('CRAUDFaqTestCase','class','sites/all/modules/faq/faq.test','faq',0),('CreateFaqTestCase','class','sites/all/modules/faq/faq.test','faq',0),('CronQueueTestCase','class','modules/system/system.test','system',0),('CronRunTestCase','class','modules/system/system.test','system',0),('CToolsCssCache','class','sites/all/modules/ctools/includes/css-cache.inc','ctools',0),('CtoolsObjectCache','class','sites/all/modules/ctools/tests/css_cache.test','ctools',0),('ctools_context','class','sites/all/modules/ctools/includes/context.inc','ctools',0),('ctools_context_optional','class','sites/all/modules/ctools/includes/context.inc','ctools',0),('ctools_context_required','class','sites/all/modules/ctools/includes/context.inc','ctools',0),('ctools_export_ui','class','sites/all/modules/ctools/plugins/export_ui/ctools_export_ui.class.php','ctools',0),('ctools_math_expr','class','sites/all/modules/ctools/includes/math-expr.inc','ctools',0),('ctools_math_expr_stack','class','sites/all/modules/ctools/includes/math-expr.inc','ctools',0),('ctools_stylizer_image_processor','class','sites/all/modules/ctools/includes/stylizer.inc','ctools',0),('DashboardBlocksTestCase','class','modules/dashboard/dashboard.test','dashboard',0),('Database','class','includes/database/database.inc','',0),('DatabaseCondition','class','includes/database/query.inc','',0),('DatabaseConnection','class','includes/database/database.inc','',0),('DatabaseConnectionNotDefinedException','class','includes/database/database.inc','',0),('DatabaseConnection_mysql','class','includes/database/mysql/database.inc','',0),('DatabaseConnection_pgsql','class','includes/database/pgsql/database.inc','',0),('DatabaseConnection_sqlite','class','includes/database/sqlite/database.inc','',0),('DatabaseDriverNotSpecifiedException','class','includes/database/database.inc','',0),('DatabaseLog','class','includes/database/log.inc','',0),('DatabaseSchema','class','includes/database/schema.inc','',0),('DatabaseSchemaObjectDoesNotExistException','class','includes/database/schema.inc','',0),('DatabaseSchemaObjectExistsException','class','includes/database/schema.inc','',0),('DatabaseSchema_mysql','class','includes/database/mysql/schema.inc','',0),('DatabaseSchema_pgsql','class','includes/database/pgsql/schema.inc','',0),('DatabaseSchema_sqlite','class','includes/database/sqlite/schema.inc','',0),('DatabaseStatementBase','class','includes/database/database.inc','',0),('DatabaseStatementEmpty','class','includes/database/database.inc','',0),('DatabaseStatementInterface','interface','includes/database/database.inc','',0),('DatabaseStatementPrefetch','class','includes/database/prefetch.inc','',0),('DatabaseStatement_sqlite','class','includes/database/sqlite/database.inc','',0),('DatabaseTaskException','class','includes/install.inc','',0),('DatabaseTasks','class','includes/install.inc','',0),('DatabaseTasks_mysql','class','includes/database/mysql/install.inc','',0),('DatabaseTasks_pgsql','class','includes/database/pgsql/install.inc','',0),('DatabaseTasks_sqlite','class','includes/database/sqlite/install.inc','',0),('DatabaseTransaction','class','includes/database/database.inc','',0),('DatabaseTransactionCommitFailedException','class','includes/database/database.inc','',0),('DatabaseTransactionExplicitCommitNotAllowedException','class','includes/database/database.inc','',0),('DatabaseTransactionNameNonUniqueException','class','includes/database/database.inc','',0),('DatabaseTransactionNoActiveException','class','includes/database/database.inc','',0),('DatabaseTransactionOutOfOrderException','class','includes/database/database.inc','',0),('DateFormatTestCase','class','modules/system/system.test','system',0),('DateObject','class','sites/all/modules/date/date_api/date_api.module','date_api',0),('DateTimeFunctionalTest','class','modules/system/system.test','system',0),('date_sql_handler','class','sites/all/modules/date/date_api/date_api_sql.inc','date_api',0),('date_views_argument_handler','class','sites/all/modules/date/date_views/includes/date_views_argument_handler.inc','date_views',0),('date_views_argument_handler_simple','class','sites/all/modules/date/date_views/includes/date_views_argument_handler_simple.inc','date_views',0),('date_views_filter_handler','class','sites/all/modules/date/date_views/includes/date_views_filter_handler.inc','date_views',0),('date_views_filter_handler_simple','class','sites/all/modules/date/date_views/includes/date_views_filter_handler_simple.inc','date_views',0),('date_views_plugin_pager','class','sites/all/modules/date/date_views/includes/date_views_plugin_pager.inc','date_views',0),('DBLogTestCase','class','modules/dblog/dblog.test','dblog',0),('DefaultMailSystem','class','modules/system/system.mail.inc','system',0),('DeleteQuery','class','includes/database/query.inc','',0),('DeleteQuery_sqlite','class','includes/database/sqlite/query.inc','',0),('DrupalCacheArray','class','includes/bootstrap.inc','',0),('DrupalCacheInterface','interface','includes/cache.inc','',0),('DrupalDatabaseCache','class','includes/cache.inc','',0),('DrupalDefaultEntityController','class','includes/entity.inc','',0),('DrupalEntityControllerInterface','interface','includes/entity.inc','',0),('DrupalFakeCache','class','includes/cache-install.inc','',0),('Drupali18nConfigTestCase','class','sites/all/modules/i18n/i18n.test','i18n',10),('Drupali18nTestCase','class','sites/all/modules/i18n/i18n.test','i18n',10),('DrupalLocalStreamWrapper','class','includes/stream_wrappers.inc','',0),('DrupalPrivateStreamWrapper','class','includes/stream_wrappers.inc','',0),('DrupalPublicStreamWrapper','class','includes/stream_wrappers.inc','',0),('DrupalQueue','class','modules/system/system.queue.inc','system',0),('DrupalQueueInterface','interface','modules/system/system.queue.inc','system',0),('DrupalReliableQueueInterface','interface','modules/system/system.queue.inc','system',0),('DrupalSetMessageTest','class','modules/system/system.test','system',0),('DrupalStreamWrapperInterface','interface','includes/stream_wrappers.inc','',0),('DrupalTemporaryStreamWrapper','class','includes/stream_wrappers.inc','',0),('DrupalUpdateException','class','includes/update.inc','',0),('DrupalUpdaterInterface','interface','includes/updater.inc','',0),('EnableDisableTestCase','class','modules/system/system.test','system',0),('Entity','class','sites/all/modules/entity/includes/entity.inc','entity',0),('EntityAPICommentNodeAccessTestCase','class','sites/all/modules/entity/entity.test','entity',0),('EntityAPIController','class','sites/all/modules/entity/includes/entity.controller.inc','entity',0),('EntityAPIControllerExportable','class','sites/all/modules/entity/includes/entity.controller.inc','entity',0),('EntityAPIControllerInterface','interface','sites/all/modules/entity/includes/entity.controller.inc','entity',0),('EntityAPIControllerRevisionableInterface','interface','sites/all/modules/entity/includes/entity.controller.inc','entity',0),('EntityAPIi18nItegrationTestCase','class','sites/all/modules/entity/entity.test','entity',0),('EntityAPIRulesIntegrationTestCase','class','sites/all/modules/entity/entity.test','entity',0),('EntityAPITestCase','class','sites/all/modules/entity/entity.test','entity',0),('EntityBundleableUIController','class','sites/all/modules/entity/includes/entity.ui.inc','entity',0),('EntityContentUIController','class','sites/all/modules/entity/includes/entity.ui.inc','entity',0),('EntityDB','class','sites/all/modules/entity/includes/entity.inc','entity',0),('EntityDBExtendable','class','sites/all/modules/entity/includes/entity.inc','entity',0),('EntityDefaultExtraFieldsController','class','sites/all/modules/entity/entity.info.inc','entity',0),('EntityDefaultFeaturesController','class','sites/all/modules/entity/entity.features.inc','entity',0),('EntityDefaultI18nStringController','class','sites/all/modules/entity/entity.i18n.inc','entity',0),('EntityDefaultMetadataController','class','sites/all/modules/entity/entity.info.inc','entity',0),('EntityDefaultRulesController','class','sites/all/modules/entity/entity.rules.inc','entity',0),('EntityDefaultUIController','class','sites/all/modules/entity/includes/entity.ui.inc','entity',0),('EntityDefaultViewsController','class','sites/all/modules/entity/views/entity.views.inc','entity',0),('EntityDrupalWrapper','class','sites/all/modules/entity/includes/entity.wrapper.inc','entity',0),('EntityExtendable','class','sites/all/modules/entity/includes/entity.inc','entity',0),('EntityExtraFieldsControllerInterface','interface','sites/all/modules/entity/entity.info.inc','entity',0),('EntityFieldHandlerHelper','class','sites/all/modules/entity/views/handlers/entity_views_field_handler_helper.inc','entity',0),('EntityFieldQuery','class','includes/entity.inc','',0),('EntityFieldQueryException','class','includes/entity.inc','',0),('EntityListWrapper','class','sites/all/modules/entity/includes/entity.wrapper.inc','entity',0),('EntityMalformedException','class','includes/entity.inc','',0),('EntityMetadataArrayObject','class','sites/all/modules/entity/includes/entity.wrapper.inc','entity',0),('EntityMetadataIntegrationTestCase','class','sites/all/modules/entity/entity.test','entity',0),('EntityMetadataNodeAccessTestCase','class','sites/all/modules/entity/entity.test','entity',0),('EntityMetadataNodeCreateAccessTestCase','class','sites/all/modules/entity/entity.test','entity',0),('EntityMetadataNodeRevisionAccessTestCase','class','sites/all/modules/entity/entity.test','entity',0),('EntityMetadataTestCase','class','sites/all/modules/entity/entity.test','entity',0),('EntityMetadataWrapper','class','sites/all/modules/entity/includes/entity.wrapper.inc','entity',0),('EntityMetadataWrapperException','class','sites/all/modules/entity/includes/entity.wrapper.inc','entity',0),('EntityMetadataWrapperIterator','class','sites/all/modules/entity/includes/entity.wrapper.inc','entity',0),('EntityPropertiesTestCase','class','modules/field/tests/field.test','field',0),('EntityReferenceAdminTestCase','class','sites/all/modules/entityreference/tests/entityreference.admin.test','entityreference',0),('EntityReferenceBehavior_TaxonomyIndex','class','sites/all/modules/entityreference/plugins/behavior/EntityReferenceBehavior_TaxonomyIndex.class.php','entityreference',0),('EntityReferenceBehavior_ViewsFilterSelect','class','sites/all/modules/entityreference/plugins/behavior/EntityReferenceBehavior_ViewsFilterSelect.class.php','entityreference',0),('EntityReferenceHandlersTestCase','class','sites/all/modules/entityreference/tests/entityreference.handlers.test','entityreference',0),('EntityReferenceTaxonomyTestCase','class','sites/all/modules/entityreference/tests/entityreference.taxonomy.test','entityreference',0),('EntityReference_BehaviorHandler','interface','sites/all/modules/entityreference/plugins/behavior/abstract.inc','entityreference',0),('EntityReference_BehaviorHandler_Abstract','class','sites/all/modules/entityreference/plugins/behavior/abstract.inc','entityreference',0),('EntityReference_BehaviorHandler_Broken','class','sites/all/modules/entityreference/plugins/behavior/abstract.inc','entityreference',0),('entityreference_plugin_display','class','sites/all/modules/entityreference/views/entityreference_plugin_display.inc','entityreference',0),('entityreference_plugin_row_fields','class','sites/all/modules/entityreference/views/entityreference_plugin_row_fields.inc','entityreference',0),('entityreference_plugin_style','class','sites/all/modules/entityreference/views/entityreference_plugin_style.inc','entityreference',0),('EntityReference_SelectionHandler','interface','sites/all/modules/entityreference/plugins/selection/abstract.inc','entityreference',0),('EntityReference_SelectionHandler_Broken','class','sites/all/modules/entityreference/plugins/selection/abstract.inc','entityreference',0),('EntityReference_SelectionHandler_Generic','class','sites/all/modules/entityreference/plugins/selection/EntityReference_SelectionHandler_Generic.class.php','entityreference',0),('EntityReference_SelectionHandler_Generic_comment','class','sites/all/modules/entityreference/plugins/selection/EntityReference_SelectionHandler_Generic.class.php','entityreference',0),('EntityReference_SelectionHandler_Generic_file','class','sites/all/modules/entityreference/plugins/selection/EntityReference_SelectionHandler_Generic.class.php','entityreference',0),('EntityReference_SelectionHandler_Generic_node','class','sites/all/modules/entityreference/plugins/selection/EntityReference_SelectionHandler_Generic.class.php','entityreference',0),('EntityReference_SelectionHandler_Generic_taxonomy_term','class','sites/all/modules/entityreference/plugins/selection/EntityReference_SelectionHandler_Generic.class.php','entityreference',0),('EntityReference_SelectionHandler_Generic_user','class','sites/all/modules/entityreference/plugins/selection/EntityReference_SelectionHandler_Generic.class.php','entityreference',0),('EntityReference_SelectionHandler_Views','class','sites/all/modules/entityreference/plugins/selection/EntityReference_SelectionHandler_Views.class.php','entityreference',0),('EntityStructureWrapper','class','sites/all/modules/entity/includes/entity.wrapper.inc','entity',0),('EntityTokenTestCase','class','sites/all/modules/entity/entity.test','entity',0),('EntityValueWrapper','class','sites/all/modules/entity/includes/entity.wrapper.inc','entity',0),('EntityWebTestCase','class','sites/all/modules/entity/entity.test','entity',0),('entity_views_handler_area_entity','class','sites/all/modules/entity/views/handlers/entity_views_handler_area_entity.inc','entity',0),('entity_views_handler_field_boolean','class','sites/all/modules/entity/views/handlers/entity_views_handler_field_boolean.inc','entity',0),('entity_views_handler_field_date','class','sites/all/modules/entity/views/handlers/entity_views_handler_field_date.inc','entity',0),('entity_views_handler_field_duration','class','sites/all/modules/entity/views/handlers/entity_views_handler_field_duration.inc','entity',0),('entity_views_handler_field_entity','class','sites/all/modules/entity/views/handlers/entity_views_handler_field_entity.inc','entity',0),('entity_views_handler_field_field','class','sites/all/modules/entity/views/handlers/entity_views_handler_field_field.inc','entity',0),('entity_views_handler_field_numeric','class','sites/all/modules/entity/views/handlers/entity_views_handler_field_numeric.inc','entity',0),('entity_views_handler_field_options','class','sites/all/modules/entity/views/handlers/entity_views_handler_field_options.inc','entity',0),('entity_views_handler_field_text','class','sites/all/modules/entity/views/handlers/entity_views_handler_field_text.inc','entity',0),('entity_views_handler_field_uri','class','sites/all/modules/entity/views/handlers/entity_views_handler_field_uri.inc','entity',0),('entity_views_handler_relationship','class','sites/all/modules/entity/views/handlers/entity_views_handler_relationship.inc','entity',0),('entity_views_handler_relationship_by_bundle','class','sites/all/modules/entity/views/handlers/entity_views_handler_relationship_by_bundle.inc','entity',0),('entity_views_plugin_row_entity_view','class','sites/all/modules/entity/views/plugins/entity_views_plugin_row_entity_view.inc','entity',0),('FaqAccessTestClass','class','sites/all/modules/faq/faq.test','faq',0),('FaqTestCase','class','sites/all/modules/faq/faq.test','faq',0),('FeaturesCtoolsIntegrationTest','class','sites/all/modules/features/tests/features.test','features',20),('FeaturesDetectionTestCase','class','sites/all/modules/features/tests/features.test','features',20),('FeaturesEnableTestCase','class','sites/all/modules/features/tests/features.test','features',20),('FeaturesUserTestCase','class','sites/all/modules/features/tests/features.test','features',20),('FeedsMapperFieldTestCase','class','sites/all/modules/entityreference/tests/entityreference.feeds.test','entityreference',0),('FieldAttachOtherTestCase','class','modules/field/tests/field.test','field',0),('FieldAttachStorageTestCase','class','modules/field/tests/field.test','field',0),('FieldAttachTestCase','class','modules/field/tests/field.test','field',0),('FieldBulkDeleteTestCase','class','modules/field/tests/field.test','field',0),('FieldCollectionBasicTestCase','class','sites/all/modules/field_collection/field_collection.test','field_collection',0),('FieldCollectionContentTranslationTestCase','class','sites/all/modules/field_collection/field_collection.test','field_collection',0),('FieldCollectionItemMetadataController','class','sites/all/modules/field_collection/field_collection.info.inc','field_collection',0),('FieldCollectionRulesIntegrationTestCase','class','sites/all/modules/field_collection/field_collection.test','field_collection',0),('FieldCrudTestCase','class','modules/field/tests/field.test','field',0),('FieldDisplayAPITestCase','class','modules/field/tests/field.test','field',0),('FieldException','class','modules/field/field.module','field',0),('FieldFormTestCase','class','modules/field/tests/field.test','field',0),('FieldInfo','class','modules/field/field.info.class.inc','field',0),('FieldInfoTestCase','class','modules/field/tests/field.test','field',0),('FieldInstanceCrudTestCase','class','modules/field/tests/field.test','field',0),('FieldsOverlapException','class','includes/database/database.inc','',0),('FieldSqlStorageTestCase','class','modules/field/modules/field_sql_storage/field_sql_storage.test','field_sql_storage',0),('FieldTestCase','class','modules/field/tests/field.test','field',0),('FieldTranslationsTestCase','class','modules/field/tests/field.test','field',0),('FieldUIAlterTestCase','class','modules/field_ui/field_ui.test','field_ui',0),('FieldUIManageDisplayTestCase','class','modules/field_ui/field_ui.test','field_ui',0),('FieldUIManageFieldsTestCase','class','modules/field_ui/field_ui.test','field_ui',0),('FieldUITestCase','class','modules/field_ui/field_ui.test','field_ui',0),('FieldUpdateForbiddenException','class','modules/field/field.module','field',0),('FieldValidationException','class','modules/field/field.attach.inc','field',0),('field_collection_handler_relationship','class','sites/all/modules/field_collection/views/field_collection_handler_relationship.inc','field_collection',0),('FileFieldAnonymousSubmission','class','modules/file/tests/file.test','file',0),('FileFieldDisplayTestCase','class','modules/file/tests/file.test','file',0),('FileFieldPathTestCase','class','modules/file/tests/file.test','file',0),('FileFieldRevisionTestCase','class','modules/file/tests/file.test','file',0),('FileFieldTestCase','class','modules/file/tests/file.test','file',0),('FileFieldValidateTestCase','class','modules/file/tests/file.test','file',0),('FileFieldWidgetTestCase','class','modules/file/tests/file.test','file',0),('FileManagedFileElementTestCase','class','modules/file/tests/file.test','file',0),('FilePrivateTestCase','class','modules/file/tests/file.test','file',0),('FileTaxonomyTermTestCase','class','modules/file/tests/file.test','file',0),('FileTokenReplaceTestCase','class','modules/file/tests/file.test','file',0),('FileTransfer','class','includes/filetransfer/filetransfer.inc','',0),('FileTransferChmodInterface','interface','includes/filetransfer/filetransfer.inc','',0),('FileTransferException','class','includes/filetransfer/filetransfer.inc','',0),('FileTransferFTP','class','includes/filetransfer/ftp.inc','',0),('FileTransferFTPExtension','class','includes/filetransfer/ftp.inc','',0),('FileTransferLocal','class','includes/filetransfer/local.inc','',0),('FileTransferSSH','class','includes/filetransfer/ssh.inc','',0),('FilterAdminTestCase','class','modules/filter/filter.test','filter',0),('FilterCRUDTestCase','class','modules/filter/filter.test','filter',0),('FilterDefaultFormatTestCase','class','modules/filter/filter.test','filter',0),('FilterDOMSerializeTestCase','class','modules/filter/filter.test','filter',0),('FilterFormatAccessTestCase','class','modules/filter/filter.test','filter',0),('FilterHooksTestCase','class','modules/filter/filter.test','filter',0),('FilterNoFormatTestCase','class','modules/filter/filter.test','filter',0),('FilterSecurityTestCase','class','modules/filter/filter.test','filter',0),('FilterSettingsTestCase','class','modules/filter/filter.test','filter',0),('FilterUnitTestCase','class','modules/filter/filter.test','filter',0),('FivestarBaseTestCase','class','sites/all/modules/fivestar/test/fivestar.base.test','fivestar',0),('FivestarTestCase','class','sites/all/modules/fivestar/test/fivestar.field.test','fivestar',0),('FlexsliderTestCase','class','sites/all/modules/flexslider/flexslider.test','flexslider',0),('flexslider_views_plugin_style_flexslider','class','sites/all/modules/flexslider/flexslider_views/flexslider_views_plugin_style_flexslider.inc','flexslider_views',0),('FloodFunctionalTest','class','modules/system/system.test','system',0),('ForumIndexTestCase','class','modules/forum/forum.test','forum',1),('ForumTestCase','class','modules/forum/forum.test','forum',1),('FrontPageTestCase','class','modules/system/system.test','system',0),('GroupDisplayTestCase','class','sites/all/modules/field_group/tests/field_group.display.test','field_group',1),('GroupUITestCase','class','sites/all/modules/field_group/tests/field_group.ui.test','field_group',1),('HelpTestCase','class','modules/help/help.test','help',0),('HookRequirementsTestCase','class','modules/system/system.test','system',0),('i18nBlocksTestCase','class','sites/all/modules/i18n/i18n_block/i18n_block.test','i18n_block',100),('i18nStringTestCase','class','sites/all/modules/i18n/i18n_string/i18n_string.test','i18n_string',10),('i18nTaxonomyTestCase','class','sites/all/modules/i18n/i18n_taxonomy/i18n_taxonomy.test','i18n_taxonomy',5),('i18n_block_object','class','sites/all/modules/i18n/i18n_block/i18n_block.inc','i18n_block',100),('i18n_object_wrapper','class','sites/all/modules/i18n/i18n_object.inc','i18n',10),('i18n_string_object','class','sites/all/modules/i18n/i18n_string/i18n_string.inc','i18n_string',10),('i18n_string_object_wrapper','class','sites/all/modules/i18n/i18n_string/i18n_string.inc','i18n_string',10),('i18n_string_textgroup_cached','class','sites/all/modules/i18n/i18n_string/i18n_string.inc','i18n_string',10),('i18n_string_textgroup_default','class','sites/all/modules/i18n/i18n_string/i18n_string.inc','i18n_string',10),('i18n_taxonomy_term','class','sites/all/modules/i18n/i18n_taxonomy/i18n_taxonomy.inc','i18n_taxonomy',5),('i18n_taxonomy_translation_set','class','sites/all/modules/i18n/i18n_taxonomy/i18n_taxonomy.inc','i18n_taxonomy',5),('i18n_translation_set','class','sites/all/modules/i18n/i18n_translation/i18n_translation.inc','i18n_translation',0),('ImageAdminStylesUnitTest','class','modules/image/image.test','image',0),('ImageAdminUiTestCase','class','modules/image/image.test','image',0),('ImageDimensionsScaleTestCase','class','modules/image/image.test','image',0),('ImageDimensionsTestCase','class','modules/image/image.test','image',0),('ImageEffectsUnitTest','class','modules/image/image.test','image',0),('ImageFieldDefaultImagesTestCase','class','modules/image/image.test','image',0),('ImageFieldDisplayTestCase','class','modules/image/image.test','image',0),('ImageFieldTestCase','class','modules/image/image.test','image',0),('ImageFieldValidateTestCase','class','modules/image/image.test','image',0),('ImageStyleFlushTest','class','modules/image/image.test','image',0),('ImageStylesPathAndUrlTestCase','class','modules/image/image.test','image',0),('ImageThemeFunctionWebTestCase','class','modules/image/image.test','image',0),('InfoFileParserTestCase','class','modules/system/system.test','system',0),('InsertQuery','class','includes/database/query.inc','',0),('InsertQuery_mysql','class','includes/database/mysql/query.inc','',0),('InsertQuery_pgsql','class','includes/database/pgsql/query.inc','',0),('InsertQuery_sqlite','class','includes/database/sqlite/query.inc','',0),('InvalidMergeQueryException','class','includes/database/database.inc','',0),('InvalidQuickSetException','class','sites/all/modules/quicktabs/quicktabs.classes.inc','quicktabs',0),('IPAddressBlockingTestCase','class','modules/system/system.test','system',0),('LibrariesTestCase','class','sites/all/modules/libraries/tests/libraries.test','libraries',0),('LibrariesUnitTestCase','class','sites/all/modules/libraries/tests/libraries.test','libraries',0),('LinkAttributeCrudTest','class','sites/all/modules/link/tests/link.attribute.test','link',0),('LinkBaseTestClass','class','sites/all/modules/link/tests/link.test','link',0),('LinkContentCrudTest','class','sites/all/modules/link/tests/link.crud.test','link',0),('LinkTokenTest','class','sites/all/modules/link/tests/link.token.test','link',0),('LinkUITest','class','sites/all/modules/link/tests/link.crud_browser.test','link',0),('LinkValidateSpecificURL','class','sites/all/modules/link/tests/link.validate.test','link',0),('LinkValidateTest','class','sites/all/modules/link/tests/link.validate.test','link',0),('LinkValidateTestCase','class','sites/all/modules/link/tests/link.validate.test','link',0),('LinkValidateTestNews','class','sites/all/modules/link/tests/link.validate.test','link',0),('LinkValidateUrlLight','class','sites/all/modules/link/tests/link.validate.test','link',0),('link_views_handler_argument_target','class','sites/all/modules/link/views/link_views_handler_argument_target.inc','link',0),('link_views_handler_filter_protocol','class','sites/all/modules/link/views/link_views_handler_filter_protocol.inc','link',0),('ListDynamicValuesTestCase','class','modules/field/modules/list/tests/list.test','list',0),('ListDynamicValuesValidationTestCase','class','modules/field/modules/list/tests/list.test','list',0),('ListFieldTestCase','class','modules/field/modules/list/tests/list.test','list',0),('ListFieldUITestCase','class','modules/field/modules/list/tests/list.test','list',0),('LocaleBrowserDetectionTest','class','modules/locale/locale.test','locale',0),('LocaleCommentLanguageFunctionalTest','class','modules/locale/locale.test','locale',0),('LocaleConfigurationTest','class','modules/locale/locale.test','locale',0),('LocaleContentFunctionalTest','class','modules/locale/locale.test','locale',0),('LocaleCSSAlterTest','class','modules/locale/locale.test','locale',0),('LocaleDateFormatsFunctionalTest','class','modules/locale/locale.test','locale',0),('LocaleExportFunctionalTest','class','modules/locale/locale.test','locale',0),('LocaleImportFunctionalTest','class','modules/locale/locale.test','locale',0),('LocaleInstallTest','class','modules/locale/locale.test','locale',0),('LocaleJavascriptTranslationTest','class','modules/locale/locale.test','locale',0),('LocaleLanguageNegotiationInfoFunctionalTest','class','modules/locale/locale.test','locale',0),('LocaleLanguageSwitchingFunctionalTest','class','modules/locale/locale.test','locale',0),('LocaleLibraryInfoAlterTest','class','modules/locale/locale.test','locale',0),('LocaleMultilingualFieldsFunctionalTest','class','modules/locale/locale.test','locale',0),('LocalePathFunctionalTest','class','modules/locale/locale.test','locale',0),('LocalePluralFormatTest','class','modules/locale/locale.test','locale',0),('LocaleStringIsSafeTest','class','modules/locale/locale.test','locale',0),('LocaleTranslationFunctionalTest','class','modules/locale/locale.test','locale',0),('LocaleUILanguageNegotiationTest','class','modules/locale/locale.test','locale',0),('LocaleUninstallFrenchFunctionalTest','class','modules/locale/locale.test','locale',0),('LocaleUninstallFunctionalTest','class','modules/locale/locale.test','locale',0),('LocaleUrlRewritingTest','class','modules/locale/locale.test','locale',0),('LocaleUserCreationTest','class','modules/locale/locale.test','locale',0),('LocaleUserLanguageFunctionalTest','class','modules/locale/locale.test','locale',0),('MailSystemInterface','interface','includes/mail.inc','',0),('MemoryQueue','class','modules/system/system.queue.inc','system',0),('MenuNodeTestCase','class','modules/menu/menu.test','menu',0),('MenuTestCase','class','modules/menu/menu.test','menu',0),('MergeQuery','class','includes/database/query.inc','',0),('Message','class','sites/all/modules/message/includes/message.message.inc','message',0),('MessageCron','class','sites/all/modules/message/message.test','message',0),('MessageCrud','class','sites/all/modules/message/message.test','message',0),('MessageEntityDelete','class','sites/all/modules/message/message.test','message',0),('MessageException','class','sites/all/modules/message/includes/message.exception.inc','message',0),('MessageMetadataController','class','sites/all/modules/message/message.info.inc','message',0),('MessageRulesIntegrationTestCase','class','sites/all/modules/message/message.test','message',0),('MessageShowMessage','class','sites/all/modules/message/message.test','message',0),('MessageTokens','class','sites/all/modules/message/message.test','message',0),('MessageType','class','sites/all/modules/message/includes/message.message_type.inc','message',0),('MessageTypeCategory','class','sites/all/modules/message/includes/message.message_type_category.inc','message',0),('MessageTypeUIController','class','sites/all/modules/message/includes/message.admin.inc','message',0),('MessageViewsController','class','sites/all/modules/message/includes/views/message.views.inc','message',0),('message_handler_field_message_render','class','sites/all/modules/message/includes/views/handlers/message_handler_field_message_render.inc','message',0),('message_handler_filter_message_type','class','sites/all/modules/message/includes/views/handlers/message_handler_filter_message_type.inc','message',0),('message_handler_filter_message_type_category','class','sites/all/modules/message/includes/views/handlers/message_handler_filter_message_type_category.inc','message',0),('MigrateDestinationFieldCollection','class','sites/all/modules/field_collection/field_collection.migrate.inc','field_collection',0),('MigrateEntityReferenceFieldHandler','class','sites/all/modules/entityreference/entityreference.migrate.inc','entityreference',0),('MigrateLinkFieldHandler','class','sites/all/modules/link/link.migrate.inc','link',0),('MigrateVideoEmbedFieldFieldHandler','class','sites/all/modules/video_embed_field/video_embed_field.migrate.inc','video_embed_field',0),('ModuleDependencyTestCase','class','modules/system/system.test','system',0),('ModuleRequiredTestCase','class','modules/system/system.test','system',0),('ModuleTestCase','class','modules/system/system.test','system',0),('ModuleUpdater','class','modules/system/system.updater.inc','system',0),('ModuleVersionTestCase','class','modules/system/system.test','system',0),('MultiStepNodeFormBasicOptionsTest','class','modules/node/node.test','node',0),('NewDefaultThemeBlocks','class','modules/block/block.test','block',-5),('NodeAccessBaseTableTestCase','class','modules/node/node.test','node',0),('NodeAccessFieldTestCase','class','modules/node/node.test','node',0),('NodeAccessPagerTestCase','class','modules/node/node.test','node',0),('NodeAccessRebuildTestCase','class','modules/node/node.test','node',0),('NodeAccessRecordsTestCase','class','modules/node/node.test','node',0),('NodeAccessTestCase','class','modules/node/node.test','node',0),('NodeAdminTestCase','class','modules/node/node.test','node',0),('NodeBlockFunctionalTest','class','modules/node/node.test','node',0),('NodeBlockTestCase','class','modules/node/node.test','node',0),('NodeBuildContent','class','modules/node/node.test','node',0),('NodeController','class','modules/node/node.module','node',0),('NodeCreationTestCase','class','modules/node/node.test','node',0),('NodeEntityFieldQueryAlter','class','modules/node/node.test','node',0),('NodeEntityViewModeAlterTest','class','modules/node/node.test','node',0),('NodeFeedTestCase','class','modules/node/node.test','node',0),('NodeLoadHooksTestCase','class','modules/node/node.test','node',0),('NodeLoadMultipleTestCase','class','modules/node/node.test','node',0),('NodeMultiByteUtf8Test','class','modules/node/node.test','node',0),('NodePageCacheTest','class','modules/node/node.test','node',0),('NodePostSettingsTestCase','class','modules/node/node.test','node',0),('NodeQueryAlter','class','modules/node/node.test','node',0),('NodeRevisionPermissionsTestCase','class','modules/node/node.test','node',0),('NodeRevisionsTestCase','class','modules/node/node.test','node',0),('NodeRSSContentTestCase','class','modules/node/node.test','node',0),('NodeSaveTestCase','class','modules/node/node.test','node',0),('NodeTitleTestCase','class','modules/node/node.test','node',0),('NodeTitleXSSTestCase','class','modules/node/node.test','node',0),('NodeTokenReplaceTestCase','class','modules/node/node.test','node',0),('NodeTypePersistenceTestCase','class','modules/node/node.test','node',0),('NodeTypeTestCase','class','modules/node/node.test','node',0),('NodeWebTestCase','class','modules/node/node.test','node',0),('NoFieldsException','class','includes/database/database.inc','',0),('NoHelpTestCase','class','modules/help/help.test','help',0),('NonDefaultBlockAdmin','class','modules/block/block.test','block',-5),('NumberFieldTestCase','class','modules/field/modules/number/number.test','number',0),('OptionsSelectDynamicValuesTestCase','class','modules/field/modules/options/options.test','options',0),('OptionsWidgetsTestCase','class','modules/field/modules/options/options.test','options',0),('PageEditTestCase','class','modules/node/node.test','node',0),('PageNotFoundTestCase','class','modules/system/system.test','system',0),('PagePreviewTestCase','class','modules/node/node.test','node',0),('PagerDefault','class','includes/pager.inc','',0),('PageTitleFiltering','class','modules/system/system.test','system',0),('PageViewTestCase','class','modules/node/node.test','node',0),('PathautoBulkUpdateTestCase','class','sites/all/modules/pathauto/pathauto.test','pathauto',1),('PathautoFunctionalTestCase','class','sites/all/modules/pathauto/pathauto.test','pathauto',1),('PathautoFunctionalTestHelper','class','sites/all/modules/pathauto/pathauto.test','pathauto',1),('PathautoLocaleTestCase','class','sites/all/modules/pathauto/pathauto.test','pathauto',1),('PathautoTestHelper','class','sites/all/modules/pathauto/pathauto.test','pathauto',1),('PathautoTokenTestCase','class','sites/all/modules/pathauto/pathauto.test','pathauto',1),('PathautoUnitTestCase','class','sites/all/modules/pathauto/pathauto.test','pathauto',1),('PathLanguageTestCase','class','modules/path/path.test','path',0),('PathLanguageUITestCase','class','modules/path/path.test','path',0),('PathMonolingualTestCase','class','modules/path/path.test','path',0),('PathTaxonomyTermTestCase','class','modules/path/path.test','path',0),('PathTestCase','class','modules/path/path.test','path',0),('PHPAccessTestCase','class','modules/php/php.test','php',0),('PHPFilterTestCase','class','modules/php/php.test','php',0),('PHPTestCase','class','modules/php/php.test','php',0),('Query','class','includes/database/query.inc','',0),('QueryAlterableInterface','interface','includes/database/query.inc','',0),('QueryConditionInterface','interface','includes/database/query.inc','',0),('QueryExtendableInterface','interface','includes/database/select.inc','',0),('QueryPlaceholderInterface','interface','includes/database/query.inc','',0),('QueueTestCase','class','modules/system/system.test','system',0),('QuickAccordion','class','sites/all/modules/quicktabs/plugins/QuickAccordion.inc','quicktabs',0),('QuickBlockContent','class','sites/all/modules/quicktabs/plugins/QuickBlockContent.inc','quicktabs',0),('QuickCallbackContent','class','sites/all/modules/quicktabs/plugins/QuickCallbackContent.inc','quicktabs',0),('QuickContent','class','sites/all/modules/quicktabs/quicktabs.classes.inc','quicktabs',0),('QuickContentRenderable','interface','sites/all/modules/quicktabs/quicktabs.classes.inc','quicktabs',0),('QuickNodeContent','class','sites/all/modules/quicktabs/plugins/QuickNodeContent.inc','quicktabs',0),('QuickPreRenderedContent','class','sites/all/modules/quicktabs/quicktabs.classes.inc','quicktabs',0),('QuickQtabsContent','class','sites/all/modules/quicktabs/plugins/QuickQtabsContent.inc','quicktabs',0),('QuickQuicktabs','class','sites/all/modules/quicktabs/plugins/QuickQuicktabs.inc','quicktabs',0),('QuickRenderer','class','sites/all/modules/quicktabs/quicktabs.classes.inc','quicktabs',0),('QuickSet','class','sites/all/modules/quicktabs/quicktabs.classes.inc','quicktabs',0),('QuicktabsAdminTestCase','class','sites/all/modules/quicktabs/tests/quicktabs.test','quicktabs',0),('quicktabs_style_plugin','class','sites/all/modules/quicktabs/includes/quicktabs_style_plugin.inc','quicktabs',0),('QuickUiTabs','class','sites/all/modules/quicktabs/plugins/QuickUiTabs.inc','quicktabs',0),('QuickViewContent','class','sites/all/modules/quicktabs/plugins/QuickViewContent.inc','quicktabs',0),('RetrieveFileTestCase','class','modules/system/system.test','system',0),('SchemaCache','class','includes/bootstrap.inc','',0),('SearchAdvancedSearchForm','class','modules/search/search.test','search',0),('SearchBlockTestCase','class','modules/search/search.test','search',0),('SearchCommentCountToggleTestCase','class','modules/search/search.test','search',0),('SearchCommentTestCase','class','modules/search/search.test','search',0),('SearchConfigSettingsForm','class','modules/search/search.test','search',0),('SearchEmbedForm','class','modules/search/search.test','search',0),('SearchExactTestCase','class','modules/search/search.test','search',0),('SearchExcerptTestCase','class','modules/search/search.test','search',0),('SearchExpressionInsertExtractTestCase','class','modules/search/search.test','search',0),('SearchKeywordsConditions','class','modules/search/search.test','search',0),('SearchLanguageTestCase','class','modules/search/search.test','search',0),('SearchMatchTestCase','class','modules/search/search.test','search',0),('SearchNodeAccessTest','class','modules/search/search.test','search',0),('SearchNodeTagTest','class','modules/search/search.test','search',0),('SearchNumberMatchingTestCase','class','modules/search/search.test','search',0),('SearchNumbersTestCase','class','modules/search/search.test','search',0),('SearchPageOverride','class','modules/search/search.test','search',0),('SearchPageText','class','modules/search/search.test','search',0),('SearchQuery','class','modules/search/search.extender.inc','search',0),('SearchRankingTestCase','class','modules/search/search.test','search',0),('SearchSetLocaleTest','class','modules/search/search.test','search',0),('SearchSimplifyTestCase','class','modules/search/search.test','search',0),('SearchTokenizerTestCase','class','modules/search/search.test','search',0),('SelectQuery','class','includes/database/select.inc','',0),('SelectQueryExtender','class','includes/database/select.inc','',0),('SelectQueryInterface','interface','includes/database/select.inc','',0),('SelectQuery_pgsql','class','includes/database/pgsql/select.inc','',0),('SelectQuery_sqlite','class','includes/database/sqlite/select.inc','',0),('sharethis_handler_field_link','class','sites/all/modules/sharethis/views/sharethis_handler_field_link.inc','sharethis',0),('ShortcutLinksTestCase','class','modules/shortcut/shortcut.test','shortcut',0),('ShortcutSetsTestCase','class','modules/shortcut/shortcut.test','shortcut',0),('ShortcutTestCase','class','modules/shortcut/shortcut.test','shortcut',0),('ShutdownFunctionsTest','class','modules/system/system.test','system',0),('SiteMaintenanceTestCase','class','modules/system/system.test','system',0),('SkipDotsRecursiveDirectoryIterator','class','includes/filetransfer/filetransfer.inc','',0),('StatisticsAdminTestCase','class','modules/statistics/statistics.test','statistics',0),('StatisticsBlockVisitorsTestCase','class','modules/statistics/statistics.test','statistics',0),('StatisticsLoggingTestCase','class','modules/statistics/statistics.test','statistics',0),('StatisticsReportsTestCase','class','modules/statistics/statistics.test','statistics',0),('StatisticsTestCase','class','modules/statistics/statistics.test','statistics',0),('StatisticsTokenReplaceTestCase','class','modules/statistics/statistics.test','statistics',0),('StreamWrapperInterface','interface','includes/stream_wrappers.inc','',0),('SummaryLengthTestCase','class','modules/node/node.test','node',0),('SystemAdminTestCase','class','modules/system/system.test','system',0),('SystemAuthorizeCase','class','modules/system/system.test','system',0),('SystemBlockTestCase','class','modules/system/system.test','system',0),('SystemIndexPhpTest','class','modules/system/system.test','system',0),('SystemInfoAlterTestCase','class','modules/system/system.test','system',0),('SystemMainContentFallback','class','modules/system/system.test','system',0),('SystemQueue','class','modules/system/system.queue.inc','system',0),('SystemThemeFunctionalTest','class','modules/system/system.test','system',0),('SystemValidTokenTest','class','modules/system/system.test','system',0),('TableSort','class','includes/tablesort.inc','',0),('TaxonomyEFQTestCase','class','modules/taxonomy/taxonomy.test','taxonomy',0),('TaxonomyHooksTestCase','class','modules/taxonomy/taxonomy.test','taxonomy',0),('TaxonomyLegacyTestCase','class','modules/taxonomy/taxonomy.test','taxonomy',0),('TaxonomyLoadMultipleTestCase','class','modules/taxonomy/taxonomy.test','taxonomy',0),('TaxonomyMenuHierarchyTest','class','sites/all/modules/taxonomy_menu/taxonomy_menu.test','taxonomy_menu',0),('TaxonomyMenuTreeNode','class','sites/all/modules/taxonomy_menu/taxonomy_menu.test','taxonomy_menu',0),('TaxonomyMenuUnitTest','class','sites/all/modules/taxonomy_menu/taxonomy_menu.test','taxonomy_menu',0),('TaxonomyMenuWebTestCase','class','sites/all/modules/taxonomy_menu/taxonomy_menu.test','taxonomy_menu',0),('TaxonomyQueryAlterTestCase','class','modules/taxonomy/taxonomy.test','taxonomy',0),('TaxonomyRSSTestCase','class','modules/taxonomy/taxonomy.test','taxonomy',0),('TaxonomyTermController','class','modules/taxonomy/taxonomy.module','taxonomy',0),('TaxonomyTermFieldMultipleVocabularyTestCase','class','modules/taxonomy/taxonomy.test','taxonomy',0),('TaxonomyTermFieldTestCase','class','modules/taxonomy/taxonomy.test','taxonomy',0),('TaxonomyTermFunctionTestCase','class','modules/taxonomy/taxonomy.test','taxonomy',0),('TaxonomyTermIndexTestCase','class','modules/taxonomy/taxonomy.test','taxonomy',0),('TaxonomyTermTestCase','class','modules/taxonomy/taxonomy.test','taxonomy',0),('TaxonomyThemeTestCase','class','modules/taxonomy/taxonomy.test','taxonomy',0),('TaxonomyTokenReplaceTestCase','class','modules/taxonomy/taxonomy.test','taxonomy',0),('TaxonomyVocabularyController','class','modules/taxonomy/taxonomy.module','taxonomy',0),('TaxonomyVocabularyFunctionalTest','class','modules/taxonomy/taxonomy.test','taxonomy',0),('TaxonomyVocabularyTestCase','class','modules/taxonomy/taxonomy.test','taxonomy',0),('TaxonomyWebTestCase','class','modules/taxonomy/taxonomy.test','taxonomy',0),('testAfFormsTestCase','class','sites/all/modules/advanced_forum/tests/af.test','advanced_forum',15),('TestingMailSystem','class','modules/system/system.mail.inc','system',0),('TextFieldTestCase','class','modules/field/modules/text/text.test','text',0),('TextSummaryTestCase','class','modules/field/modules/text/text.test','text',0),('TextTranslationTestCase','class','modules/field/modules/text/text.test','text',0),('ThemeRegistry','class','includes/theme.inc','',0),('ThemeUpdater','class','modules/system/system.updater.inc','system',0),('TokenArrayTestCase','class','sites/all/modules/token/token.test','token',0),('TokenBlockTestCase','class','sites/all/modules/token/token.test','token',0),('TokenCommentTestCase','class','sites/all/modules/token/token.test','token',0),('TokenCurrentPageTestCase','class','sites/all/modules/token/token.test','token',0),('TokenDateTestCase','class','sites/all/modules/token/token.test','token',0),('TokenEntityTestCase','class','sites/all/modules/token/token.test','token',0),('TokenFileTestCase','class','sites/all/modules/token/token.test','token',0),('TokenMenuTestCase','class','sites/all/modules/token/token.test','token',0),('TokenNodeTestCase','class','sites/all/modules/token/token.test','token',0),('TokenProfileTestCase','class','sites/all/modules/token/token.test','token',0),('TokenRandomTestCase','class','sites/all/modules/token/token.test','token',0),('TokenReplaceTestCase','class','modules/system/system.test','system',0),('TokenScanTest','class','modules/system/system.test','system',0),('TokenTaxonomyTestCase','class','sites/all/modules/token/token.test','token',0),('TokenTestHelper','class','sites/all/modules/token/token.test','token',0),('TokenUnitTestCase','class','sites/all/modules/token/token.test','token',0),('TokenURLTestCase','class','sites/all/modules/token/token.test','token',0),('TokenUserTestCase','class','sites/all/modules/token/token.test','token',0),('TruncateQuery','class','includes/database/query.inc','',0),('TruncateQuery_mysql','class','includes/database/mysql/query.inc','',0),('TruncateQuery_sqlite','class','includes/database/sqlite/query.inc','',0),('UpdateCoreTestCase','class','modules/update/update.test','update',0),('UpdateCoreUnitTestCase','class','modules/update/update.test','update',0),('UpdateQuery','class','includes/database/query.inc','',0),('UpdateQuery_pgsql','class','includes/database/pgsql/query.inc','',0),('UpdateQuery_sqlite','class','includes/database/sqlite/query.inc','',0),('Updater','class','includes/updater.inc','',0),('UpdaterException','class','includes/updater.inc','',0),('UpdaterFileTransferException','class','includes/updater.inc','',0),('UpdateScriptFunctionalTest','class','modules/system/system.test','system',0),('UpdateTestContribCase','class','modules/update/update.test','update',0),('UpdateTestHelper','class','modules/update/update.test','update',0),('UpdateTestUploadCase','class','modules/update/update.test','update',0),('UserAccountLinksUnitTests','class','modules/user/user.test','user',0),('UserAdminTestCase','class','modules/user/user.test','user',0),('UserAuthmapAssignmentTestCase','class','modules/user/user.test','user',0),('UserAutocompleteTestCase','class','modules/user/user.test','user',0),('UserBlocksUnitTests','class','modules/user/user.test','user',0),('UserCancelTestCase','class','modules/user/user.test','user',0),('UserController','class','modules/user/user.module','user',0),('UserCreateTestCase','class','modules/user/user.test','user',0),('UserEditedOwnAccountTestCase','class','modules/user/user.test','user',0),('UserEditRebuildTestCase','class','modules/user/user.test','user',0),('UserEditTestCase','class','modules/user/user.test','user',0),('UserLoginTestCase','class','modules/user/user.test','user',0),('UserPasswordResetTestCase','class','modules/user/user.test','user',0),('UserPermissionsTestCase','class','modules/user/user.test','user',0),('UserPictureTestCase','class','modules/user/user.test','user',0),('UserRegistrationTestCase','class','modules/user/user.test','user',0),('UserRoleAdminTestCase','class','modules/user/user.test','user',0),('UserRolesAssignmentTestCase','class','modules/user/user.test','user',0),('UserSaveTestCase','class','modules/user/user.test','user',0),('UserSignatureTestCase','class','modules/user/user.test','user',0),('UserTimeZoneFunctionalTest','class','modules/user/user.test','user',0),('UserTokenReplaceTestCase','class','modules/user/user.test','user',0),('UserUserSearchTestCase','class','modules/user/user.test','user',0),('UserValidateCurrentPassCustomForm','class','modules/user/user.test','user',0),('UserValidationTestCase','class','modules/user/user.test','user',0),('VariableTestCase','class','sites/all/modules/variable/variable.test','variable',0),('view','class','sites/all/modules/views/includes/view.inc','views',10),('ViewsAccessTest','class','sites/all/modules/views/tests/views_access.test','views',10),('ViewsAnalyzeTest','class','sites/all/modules/views/tests/views_analyze.test','views',10),('ViewsArgumentDefaultTest','class','sites/all/modules/views/tests/views_argument_default.test','views',10),('ViewsArgumentValidatorTest','class','sites/all/modules/views/tests/views_argument_validator.test','views',10),('ViewsBasicTest','class','sites/all/modules/views/tests/views_basic.test','views',10),('ViewsCacheTest','class','sites/all/modules/views/tests/views_cache.test','views',10),('ViewsExposedFormTest','class','sites/all/modules/views/tests/views_exposed_form.test','views',10),('viewsFieldApiDataTest','class','sites/all/modules/views/tests/field/views_fieldapi.test','views',10),('ViewsFieldApiTestHelper','class','sites/all/modules/views/tests/field/views_fieldapi.test','views',10),('ViewsGlossaryTestCase','class','sites/all/modules/views/tests/views_glossary.test','views',10),('ViewsHandlerAreaTextTest','class','sites/all/modules/views/tests/handlers/views_handler_area_text.test','views',10),('viewsHandlerArgumentCommentUserUidTest','class','sites/all/modules/views/tests/comment/views_handler_argument_comment_user_uid.test','views',10),('ViewsHandlerArgumentNullTest','class','sites/all/modules/views/tests/handlers/views_handler_argument_null.test','views',10),('ViewsHandlerArgumentStringTest','class','sites/all/modules/views/tests/handlers/views_handler_argument_string.test','views',10),('ViewsHandlerFieldBooleanTest','class','sites/all/modules/views/tests/handlers/views_handler_field_boolean.test','views',10),('ViewsHandlerFieldCustomTest','class','sites/all/modules/views/tests/handlers/views_handler_field_custom.test','views',10),('ViewsHandlerFieldDateTest','class','sites/all/modules/views/tests/handlers/views_handler_field_date.test','views',10),('viewsHandlerFieldFieldTest','class','sites/all/modules/views/tests/field/views_fieldapi.test','views',10),('ViewsHandlerFieldMath','class','sites/all/modules/views/tests/handlers/views_handler_field_math.test','views',10),('ViewsHandlerFieldTest','class','sites/all/modules/views/tests/handlers/views_handler_field.test','views',10),('ViewsHandlerFieldUrlTest','class','sites/all/modules/views/tests/handlers/views_handler_field_url.test','views',10),('viewsHandlerFieldUserNameTest','class','sites/all/modules/views/tests/user/views_handler_field_user_name.test','views',10),('ViewsHandlerFileExtensionTest','class','sites/all/modules/views/tests/handlers/views_handler_field_file_extension.test','views',10),('ViewsHandlerFilterCombineTest','class','sites/all/modules/views/tests/handlers/views_handler_filter_combine.test','views',10),('viewsHandlerFilterCommentUserUidTest','class','sites/all/modules/views/tests/comment/views_handler_filter_comment_user_uid.test','views',10),('ViewsHandlerFilterCounterTest','class','sites/all/modules/views/tests/handlers/views_handler_field_counter.test','views',10),('ViewsHandlerFilterDateTest','class','sites/all/modules/views/tests/handlers/views_handler_filter_date.test','views',10),('ViewsHandlerFilterEqualityTest','class','sites/all/modules/views/tests/handlers/views_handler_filter_equality.test','views',10),('ViewsHandlerFilterInOperator','class','sites/all/modules/views/tests/handlers/views_handler_filter_in_operator.test','views',10),('ViewsHandlerFilterNumericTest','class','sites/all/modules/views/tests/handlers/views_handler_filter_numeric.test','views',10),('ViewsHandlerFilterStringTest','class','sites/all/modules/views/tests/handlers/views_handler_filter_string.test','views',10),('ViewsHandlerRelationshipNodeTermDataTest','class','sites/all/modules/views/tests/taxonomy/views_handler_relationship_node_term_data.test','views',10),('ViewsHandlerSortDateTest','class','sites/all/modules/views/tests/handlers/views_handler_sort_date.test','views',10),('ViewsHandlerSortRandomTest','class','sites/all/modules/views/tests/handlers/views_handler_sort_random.test','views',10),('ViewsHandlerSortTest','class','sites/all/modules/views/tests/handlers/views_handler_sort.test','views',10),('ViewsHandlersTest','class','sites/all/modules/views/tests/views_handlers.test','views',10),('ViewsHandlerTest','class','sites/all/modules/views/tests/handlers/views_handlers.test','views',10),('ViewsHandlerTestFileSize','class','sites/all/modules/views/tests/handlers/views_handler_field_file_size.test','views',10),('ViewsHandlerTestXss','class','sites/all/modules/views/tests/handlers/views_handler_field_xss.test','views',10),('ViewsModuleTest','class','sites/all/modules/views/tests/views_module.test','views',10),('ViewsNodeRevisionRelationsTestCase','class','sites/all/modules/views/tests/node/views_node_revision_relations.test','views',10),('ViewsPagerTest','class','sites/all/modules/views/tests/views_pager.test','views',10),('ViewsPluginDisplayTestCase','class','sites/all/modules/views/tests/plugins/views_plugin_display.test','views',10),('viewsPluginStyleJumpMenuTest','class','sites/all/modules/views/tests/styles/views_plugin_style_jump_menu.test','views',10),('ViewsPluginStyleMappingTest','class','sites/all/modules/views/tests/styles/views_plugin_style_mapping.test','views',10),('ViewsPluginStyleTestBase','class','sites/all/modules/views/tests/styles/views_plugin_style_base.test','views',10),('ViewsPluginStyleTestCase','class','sites/all/modules/views/tests/styles/views_plugin_style.test','views',10),('ViewsPluginStyleUnformattedTestCase','class','sites/all/modules/views/tests/styles/views_plugin_style_unformatted.test','views',10),('ViewsQueryGroupByTest','class','sites/all/modules/views/tests/views_groupby.test','views',10),('viewsSearchQuery','class','sites/all/modules/views/modules/search/views_handler_filter_search.inc','views',10),('ViewsSqlTest','class','sites/all/modules/views/tests/views_query.test','views',10),('ViewsTestCase','class','sites/all/modules/views/tests/views_query.test','views',10),('ViewsTranslatableTest','class','sites/all/modules/views/tests/views_translatable.test','views',10),('ViewsUiBaseViewsWizard','class','sites/all/modules/views/plugins/views_wizard/views_ui_base_views_wizard.class.php','views_ui',0),('ViewsUiCommentViewsWizard','class','sites/all/modules/views/plugins/views_wizard/views_ui_comment_views_wizard.class.php','views_ui',0),('ViewsUiFileManagedViewsWizard','class','sites/all/modules/views/plugins/views_wizard/views_ui_file_managed_views_wizard.class.php','views_ui',0),('viewsUiGroupbyTestCase','class','sites/all/modules/views/tests/views_groupby.test','views',10),('ViewsUiNodeRevisionViewsWizard','class','sites/all/modules/views/plugins/views_wizard/views_ui_node_revision_views_wizard.class.php','views_ui',0),('ViewsUiNodeViewsWizard','class','sites/all/modules/views/plugins/views_wizard/views_ui_node_views_wizard.class.php','views_ui',0),('ViewsUiTaxonomyTermViewsWizard','class','sites/all/modules/views/plugins/views_wizard/views_ui_taxonomy_term_views_wizard.class.php','views_ui',0),('ViewsUiUsersViewsWizard','class','sites/all/modules/views/plugins/views_wizard/views_ui_users_views_wizard.class.php','views_ui',0),('ViewsUIWizardBasicTestCase','class','sites/all/modules/views/tests/views_ui.test','views',10),('ViewsUIWizardDefaultViewsTestCase','class','sites/all/modules/views/tests/views_ui.test','views',10),('ViewsUIWizardHelper','class','sites/all/modules/views/tests/views_ui.test','views',10),('ViewsUIWizardItemsPerPageTestCase','class','sites/all/modules/views/tests/views_ui.test','views',10),('ViewsUIWizardJumpMenuTestCase','class','sites/all/modules/views/tests/views_ui.test','views',10),('ViewsUIWizardMenuTestCase','class','sites/all/modules/views/tests/views_ui.test','views',10),('ViewsUIWizardOverrideDisplaysTestCase','class','sites/all/modules/views/tests/views_ui.test','views',10),('ViewsUIWizardSortingTestCase','class','sites/all/modules/views/tests/views_ui.test','views',10),('ViewsUIWizardTaggedWithTestCase','class','sites/all/modules/views/tests/views_ui.test','views',10),('ViewsUpgradeTestCase','class','sites/all/modules/views/tests/views_upgrade.test','views',10),('ViewsUserArgumentDefault','class','sites/all/modules/views/tests/user/views_user_argument_default.test','views',10),('ViewsUserArgumentValidate','class','sites/all/modules/views/tests/user/views_user_argument_validate.test','views',10),('ViewsUserTestCase','class','sites/all/modules/views/tests/user/views_user.test','views',10),('ViewsViewTest','class','sites/all/modules/views/tests/views_view.test','views',10),('ViewsWizardException','class','sites/all/modules/views/plugins/views_wizard/views_ui_base_views_wizard.class.php','views_ui',0),('ViewsWizardInterface','interface','sites/all/modules/views/plugins/views_wizard/views_ui_base_views_wizard.class.php','views_ui',0),('views_db_object','class','sites/all/modules/views/includes/view.inc','views',10),('views_display','class','sites/all/modules/views/includes/view.inc','views',10),('views_embed_field_views_handler_field_thumbnail_path','class','sites/all/modules/video_embed_field/views/handlers/views_embed_field_views_handler_field_thumbnail_path.inc','video_embed_field',0),('views_fieldsets_fieldset_field_handler','class','sites/all/modules/views_fieldsets/views/views_fieldsets_fieldset_field_handler.inc','views_fieldsets',0),('views_handler','class','sites/all/modules/views/includes/handlers.inc','views',10),('views_handler_area','class','sites/all/modules/views/handlers/views_handler_area.inc','views',10),('views_handler_area_broken','class','sites/all/modules/views/handlers/views_handler_area.inc','views',10),('views_handler_area_messages','class','sites/all/modules/views/handlers/views_handler_area_messages.inc','views',10),('views_handler_area_result','class','sites/all/modules/views/handlers/views_handler_area_result.inc','views',10),('views_handler_area_text','class','sites/all/modules/views/handlers/views_handler_area_text.inc','views',10),('views_handler_area_text_custom','class','sites/all/modules/views/handlers/views_handler_area_text_custom.inc','views',10),('views_handler_area_view','class','sites/all/modules/views/handlers/views_handler_area_view.inc','views',10),('views_handler_argument','class','sites/all/modules/views/handlers/views_handler_argument.inc','views',10),('views_handler_argument_aggregator_category_cid','class','sites/all/modules/views/modules/aggregator/views_handler_argument_aggregator_category_cid.inc','views',10),('views_handler_argument_aggregator_fid','class','sites/all/modules/views/modules/aggregator/views_handler_argument_aggregator_fid.inc','views',10),('views_handler_argument_aggregator_iid','class','sites/all/modules/views/modules/aggregator/views_handler_argument_aggregator_iid.inc','views',10),('views_handler_argument_broken','class','sites/all/modules/views/handlers/views_handler_argument.inc','views',10),('views_handler_argument_comment_user_uid','class','sites/all/modules/views/modules/comment/views_handler_argument_comment_user_uid.inc','views',10),('views_handler_argument_date','class','sites/all/modules/views/handlers/views_handler_argument_date.inc','views',10),('views_handler_argument_field_list','class','sites/all/modules/views/modules/field/views_handler_argument_field_list.inc','views',10),('views_handler_argument_field_list_string','class','sites/all/modules/views/modules/field/views_handler_argument_field_list_string.inc','views',10),('views_handler_argument_file_fid','class','sites/all/modules/views/modules/system/views_handler_argument_file_fid.inc','views',10),('views_handler_argument_formula','class','sites/all/modules/views/handlers/views_handler_argument_formula.inc','views',10),('views_handler_argument_group_by_numeric','class','sites/all/modules/views/handlers/views_handler_argument_group_by_numeric.inc','views',10),('views_handler_argument_locale_group','class','sites/all/modules/views/modules/locale/views_handler_argument_locale_group.inc','views',10),('views_handler_argument_locale_language','class','sites/all/modules/views/modules/locale/views_handler_argument_locale_language.inc','views',10),('views_handler_argument_many_to_one','class','sites/all/modules/views/handlers/views_handler_argument_many_to_one.inc','views',10),('views_handler_argument_node_created_day','class','sites/all/modules/views/modules/node/views_handler_argument_dates_various.inc','views',10),('views_handler_argument_node_created_fulldate','class','sites/all/modules/views/modules/node/views_handler_argument_dates_various.inc','views',10),('views_handler_argument_node_created_month','class','sites/all/modules/views/modules/node/views_handler_argument_dates_various.inc','views',10),('views_handler_argument_node_created_week','class','sites/all/modules/views/modules/node/views_handler_argument_dates_various.inc','views',10),('views_handler_argument_node_created_year','class','sites/all/modules/views/modules/node/views_handler_argument_dates_various.inc','views',10),('views_handler_argument_node_created_year_month','class','sites/all/modules/views/modules/node/views_handler_argument_dates_various.inc','views',10),('views_handler_argument_node_language','class','sites/all/modules/views/modules/node/views_handler_argument_node_language.inc','views',10),('views_handler_argument_node_nid','class','sites/all/modules/views/modules/node/views_handler_argument_node_nid.inc','views',10),('views_handler_argument_node_tnid','class','sites/all/modules/views/modules/translation/views_handler_argument_node_tnid.inc','views',10),('views_handler_argument_node_type','class','sites/all/modules/views/modules/node/views_handler_argument_node_type.inc','views',10),('views_handler_argument_node_uid_revision','class','sites/all/modules/views/modules/node/views_handler_argument_node_uid_revision.inc','views',10),('views_handler_argument_node_vid','class','sites/all/modules/views/modules/node/views_handler_argument_node_vid.inc','views',10),('views_handler_argument_null','class','sites/all/modules/views/handlers/views_handler_argument_null.inc','views',10),('views_handler_argument_numeric','class','sites/all/modules/views/handlers/views_handler_argument_numeric.inc','views',10),('views_handler_argument_search','class','sites/all/modules/views/modules/search/views_handler_argument_search.inc','views',10),('views_handler_argument_string','class','sites/all/modules/views/handlers/views_handler_argument_string.inc','views',10),('views_handler_argument_taxonomy','class','sites/all/modules/views/modules/taxonomy/views_handler_argument_taxonomy.inc','views',10),('views_handler_argument_term_node_tid','class','sites/all/modules/views/modules/taxonomy/views_handler_argument_term_node_tid.inc','views',10),('views_handler_argument_term_node_tid_depth','class','sites/all/modules/views/modules/taxonomy/views_handler_argument_term_node_tid_depth.inc','views',10),('views_handler_argument_term_node_tid_depth_join','class','sites/all/modules/views/modules/taxonomy/views_handler_argument_term_node_tid_depth_join.inc','views',10),('views_handler_argument_term_node_tid_depth_modifier','class','sites/all/modules/views/modules/taxonomy/views_handler_argument_term_node_tid_depth_modifier.inc','views',10),('views_handler_argument_tracker_comment_user_uid','class','sites/all/modules/views/modules/tracker/views_handler_argument_tracker_comment_user_uid.inc','views',10),('views_handler_argument_users_roles_rid','class','sites/all/modules/views/modules/user/views_handler_argument_users_roles_rid.inc','views',10),('views_handler_argument_user_uid','class','sites/all/modules/views/modules/user/views_handler_argument_user_uid.inc','views',10),('views_handler_argument_vocabulary_machine_name','class','sites/all/modules/views/modules/taxonomy/views_handler_argument_vocabulary_machine_name.inc','views',10),('views_handler_argument_vocabulary_vid','class','sites/all/modules/views/modules/taxonomy/views_handler_argument_vocabulary_vid.inc','views',10),('views_handler_field','class','sites/all/modules/views/handlers/views_handler_field.inc','views',10),('views_handler_field_accesslog_path','class','sites/all/modules/views/modules/statistics/views_handler_field_accesslog_path.inc','views',10),('views_handler_field_aggregator_category','class','sites/all/modules/views/modules/aggregator/views_handler_field_aggregator_category.inc','views',10),('views_handler_field_aggregator_title_link','class','sites/all/modules/views/modules/aggregator/views_handler_field_aggregator_title_link.inc','views',10),('views_handler_field_aggregator_xss','class','sites/all/modules/views/modules/aggregator/views_handler_field_aggregator_xss.inc','views',10),('views_handler_field_boolean','class','sites/all/modules/views/handlers/views_handler_field_boolean.inc','views',10),('views_handler_field_broken','class','sites/all/modules/views/handlers/views_handler_field.inc','views',10),('views_handler_field_comment','class','sites/all/modules/views/modules/comment/views_handler_field_comment.inc','views',10),('views_handler_field_comment_depth','class','sites/all/modules/views/modules/comment/views_handler_field_comment_depth.inc','views',10),('views_handler_field_comment_link','class','sites/all/modules/views/modules/comment/views_handler_field_comment_link.inc','views',10),('views_handler_field_comment_link_approve','class','sites/all/modules/views/modules/comment/views_handler_field_comment_link_approve.inc','views',10),('views_handler_field_comment_link_delete','class','sites/all/modules/views/modules/comment/views_handler_field_comment_link_delete.inc','views',10),('views_handler_field_comment_link_edit','class','sites/all/modules/views/modules/comment/views_handler_field_comment_link_edit.inc','views',10),('views_handler_field_comment_link_reply','class','sites/all/modules/views/modules/comment/views_handler_field_comment_link_reply.inc','views',10),('views_handler_field_comment_node_link','class','sites/all/modules/views/modules/comment/views_handler_field_comment_node_link.inc','views',10),('views_handler_field_comment_username','class','sites/all/modules/views/modules/comment/views_handler_field_comment_username.inc','views',10),('views_handler_field_contact_link','class','sites/all/modules/views/modules/contact/views_handler_field_contact_link.inc','views',10),('views_handler_field_contextual_links','class','sites/all/modules/views/handlers/views_handler_field_contextual_links.inc','views',10),('views_handler_field_counter','class','sites/all/modules/views/handlers/views_handler_field_counter.inc','views',10),('views_handler_field_ctools_dropdown','class','sites/all/modules/views/handlers/views_handler_field_ctools_dropdown.inc','views',10),('views_handler_field_custom','class','sites/all/modules/views/handlers/views_handler_field_custom.inc','views',10),('views_handler_field_date','class','sites/all/modules/views/handlers/views_handler_field_date.inc','views',10),('views_handler_field_entity','class','sites/all/modules/views/handlers/views_handler_field_entity.inc','views',10),('views_handler_field_field','class','sites/all/modules/views/modules/field/views_handler_field_field.inc','views',10),('views_handler_field_file','class','sites/all/modules/views/modules/system/views_handler_field_file.inc','views',10),('views_handler_field_file_extension','class','sites/all/modules/views/modules/system/views_handler_field_file_extension.inc','views',10),('views_handler_field_file_filemime','class','sites/all/modules/views/modules/system/views_handler_field_file_filemime.inc','views',10),('views_handler_field_file_size','class','sites/all/modules/views/handlers/views_handler_field.inc','views',10),('views_handler_field_file_status','class','sites/all/modules/views/modules/system/views_handler_field_file_status.inc','views',10),('views_handler_field_file_uri','class','sites/all/modules/views/modules/system/views_handler_field_file_uri.inc','views',10),('views_handler_field_filter_format_name','class','sites/all/modules/views/modules/filter/views_handler_field_filter_format_name.inc','views',10),('views_handler_field_history_user_timestamp','class','sites/all/modules/views/modules/node/views_handler_field_history_user_timestamp.inc','views',10),('views_handler_field_last_comment_timestamp','class','sites/all/modules/views/modules/comment/views_handler_field_last_comment_timestamp.inc','views',10),('views_handler_field_links','class','sites/all/modules/views/handlers/views_handler_field_links.inc','views',10),('views_handler_field_locale_group','class','sites/all/modules/views/modules/locale/views_handler_field_locale_group.inc','views',10),('views_handler_field_locale_language','class','sites/all/modules/views/modules/locale/views_handler_field_locale_language.inc','views',10),('views_handler_field_locale_link_edit','class','sites/all/modules/views/modules/locale/views_handler_field_locale_link_edit.inc','views',10),('views_handler_field_machine_name','class','sites/all/modules/views/handlers/views_handler_field_machine_name.inc','views',10),('views_handler_field_markup','class','sites/all/modules/views/handlers/views_handler_field_markup.inc','views',10),('views_handler_field_math','class','sites/all/modules/views/handlers/views_handler_field_math.inc','views',10),('views_handler_field_ncs_last_comment_name','class','sites/all/modules/views/modules/comment/views_handler_field_ncs_last_comment_name.inc','views',10),('views_handler_field_ncs_last_updated','class','sites/all/modules/views/modules/comment/views_handler_field_ncs_last_updated.inc','views',10),('views_handler_field_node','class','sites/all/modules/views/modules/node/views_handler_field_node.inc','views',10),('views_handler_field_node_comment','class','sites/all/modules/views/modules/comment/views_handler_field_node_comment.inc','views',10),('views_handler_field_node_counter_timestamp','class','sites/all/modules/views/modules/statistics/views_handler_field_node_counter_timestamp.inc','views',10),('views_handler_field_node_language','class','sites/all/modules/views/modules/locale/views_handler_field_node_language.inc','views',10),('views_handler_field_node_link','class','sites/all/modules/views/modules/node/views_handler_field_node_link.inc','views',10),('views_handler_field_node_link_delete','class','sites/all/modules/views/modules/node/views_handler_field_node_link_delete.inc','views',10),('views_handler_field_node_link_edit','class','sites/all/modules/views/modules/node/views_handler_field_node_link_edit.inc','views',10),('views_handler_field_node_link_translate','class','sites/all/modules/views/modules/translation/views_handler_field_node_link_translate.inc','views',10),('views_handler_field_node_new_comments','class','sites/all/modules/views/modules/comment/views_handler_field_node_new_comments.inc','views',10),('views_handler_field_node_path','class','sites/all/modules/views/modules/node/views_handler_field_node_path.inc','views',10),('views_handler_field_node_revision','class','sites/all/modules/views/modules/node/views_handler_field_node_revision.inc','views',10),('views_handler_field_node_revision_link','class','sites/all/modules/views/modules/node/views_handler_field_node_revision_link.inc','views',10),('views_handler_field_node_revision_link_delete','class','sites/all/modules/views/modules/node/views_handler_field_node_revision_link_delete.inc','views',10),('views_handler_field_node_revision_link_revert','class','sites/all/modules/views/modules/node/views_handler_field_node_revision_link_revert.inc','views',10),('views_handler_field_node_translation_link','class','sites/all/modules/views/modules/translation/views_handler_field_node_translation_link.inc','views',10),('views_handler_field_node_type','class','sites/all/modules/views/modules/node/views_handler_field_node_type.inc','views',10),('views_handler_field_node_version_count','class','sites/all/modules/views/modules/node/views_handler_field_node_version_count.inc','views',10),('views_handler_field_numeric','class','sites/all/modules/views/handlers/views_handler_field_numeric.inc','views',10),('views_handler_field_prerender_list','class','sites/all/modules/views/handlers/views_handler_field_prerender_list.inc','views',10),('views_handler_field_profile_date','class','sites/all/modules/views/modules/profile/views_handler_field_profile_date.inc','views',10),('views_handler_field_profile_list','class','sites/all/modules/views/modules/profile/views_handler_field_profile_list.inc','views',10),('views_handler_field_search_score','class','sites/all/modules/views/modules/search/views_handler_field_search_score.inc','views',10),('views_handler_field_serialized','class','sites/all/modules/views/handlers/views_handler_field_serialized.inc','views',10),('views_handler_field_statistics_numeric','class','sites/all/modules/views/modules/statistics/views_handler_field_statistics_numeric.inc','views',10),('views_handler_field_taxonomy','class','sites/all/modules/views/modules/taxonomy/views_handler_field_taxonomy.inc','views',10),('views_handler_field_term_link_edit','class','sites/all/modules/views/modules/taxonomy/views_handler_field_term_link_edit.inc','views',10),('views_handler_field_term_node_tid','class','sites/all/modules/views/modules/taxonomy/views_handler_field_term_node_tid.inc','views',10),('views_handler_field_time_interval','class','sites/all/modules/views/handlers/views_handler_field_time_interval.inc','views',10),('views_handler_field_url','class','sites/all/modules/views/handlers/views_handler_field_url.inc','views',10),('views_handler_field_user','class','sites/all/modules/views/modules/user/views_handler_field_user.inc','views',10),('views_handler_field_user_language','class','sites/all/modules/views/modules/user/views_handler_field_user_language.inc','views',10),('views_handler_field_user_link','class','sites/all/modules/views/modules/user/views_handler_field_user_link.inc','views',10),('views_handler_field_user_link_cancel','class','sites/all/modules/views/modules/user/views_handler_field_user_link_cancel.inc','views',10),('views_handler_field_user_link_edit','class','sites/all/modules/views/modules/user/views_handler_field_user_link_edit.inc','views',10),('views_handler_field_user_mail','class','sites/all/modules/views/modules/user/views_handler_field_user_mail.inc','views',10),('views_handler_field_user_name','class','sites/all/modules/views/modules/user/views_handler_field_user_name.inc','views',10),('views_handler_field_user_permissions','class','sites/all/modules/views/modules/user/views_handler_field_user_permissions.inc','views',10),('views_handler_field_user_picture','class','sites/all/modules/views/modules/user/views_handler_field_user_picture.inc','views',10),('views_handler_field_user_roles','class','sites/all/modules/views/modules/user/views_handler_field_user_roles.inc','views',10),('views_handler_field_xss','class','sites/all/modules/views/handlers/views_handler_field.inc','views',10),('views_handler_filter','class','sites/all/modules/views/handlers/views_handler_filter.inc','views',10),('views_handler_filter_aggregator_category_cid','class','sites/all/modules/views/modules/aggregator/views_handler_filter_aggregator_category_cid.inc','views',10),('views_handler_filter_boolean_operator','class','sites/all/modules/views/handlers/views_handler_filter_boolean_operator.inc','views',10),('views_handler_filter_boolean_operator_string','class','sites/all/modules/views/handlers/views_handler_filter_boolean_operator_string.inc','views',10),('views_handler_filter_broken','class','sites/all/modules/views/handlers/views_handler_filter.inc','views',10),('views_handler_filter_combine','class','sites/all/modules/views/handlers/views_handler_filter_combine.inc','views',10),('views_handler_filter_comment_user_uid','class','sites/all/modules/views/modules/comment/views_handler_filter_comment_user_uid.inc','views',10),('views_handler_filter_date','class','sites/all/modules/views/handlers/views_handler_filter_date.inc','views',10),('views_handler_filter_entity_bundle','class','sites/all/modules/views/handlers/views_handler_filter_entity_bundle.inc','views',10),('views_handler_filter_equality','class','sites/all/modules/views/handlers/views_handler_filter_equality.inc','views',10),('views_handler_filter_fields_compare','class','sites/all/modules/views/handlers/views_handler_filter_fields_compare.inc','views',10),('views_handler_filter_field_list','class','sites/all/modules/views/modules/field/views_handler_filter_field_list.inc','views',10),('views_handler_filter_field_list_boolean','class','sites/all/modules/views/modules/field/views_handler_filter_field_list_boolean.inc','views',10),('views_handler_filter_file_status','class','sites/all/modules/views/modules/system/views_handler_filter_file_status.inc','views',10),('views_handler_filter_group_by_numeric','class','sites/all/modules/views/handlers/views_handler_filter_group_by_numeric.inc','views',10),('views_handler_filter_history_user_timestamp','class','sites/all/modules/views/modules/node/views_handler_filter_history_user_timestamp.inc','views',10),('views_handler_filter_in_operator','class','sites/all/modules/views/handlers/views_handler_filter_in_operator.inc','views',10),('views_handler_filter_locale_group','class','sites/all/modules/views/modules/locale/views_handler_filter_locale_group.inc','views',10),('views_handler_filter_locale_language','class','sites/all/modules/views/modules/locale/views_handler_filter_locale_language.inc','views',10),('views_handler_filter_locale_version','class','sites/all/modules/views/modules/locale/views_handler_filter_locale_version.inc','views',10),('views_handler_filter_many_to_one','class','sites/all/modules/views/handlers/views_handler_filter_many_to_one.inc','views',10),('views_handler_filter_ncs_last_updated','class','sites/all/modules/views/modules/comment/views_handler_filter_ncs_last_updated.inc','views',10),('views_handler_filter_node_access','class','sites/all/modules/views/modules/node/views_handler_filter_node_access.inc','views',10),('views_handler_filter_node_comment','class','sites/all/modules/views/modules/comment/views_handler_filter_node_comment.inc','views',10),('views_handler_filter_node_language','class','sites/all/modules/views/modules/locale/views_handler_filter_node_language.inc','views',10),('views_handler_filter_node_status','class','sites/all/modules/views/modules/node/views_handler_filter_node_status.inc','views',10),('views_handler_filter_node_tnid','class','sites/all/modules/views/modules/translation/views_handler_filter_node_tnid.inc','views',10),('views_handler_filter_node_tnid_child','class','sites/all/modules/views/modules/translation/views_handler_filter_node_tnid_child.inc','views',10),('views_handler_filter_node_type','class','sites/all/modules/views/modules/node/views_handler_filter_node_type.inc','views',10),('views_handler_filter_node_uid_revision','class','sites/all/modules/views/modules/node/views_handler_filter_node_uid_revision.inc','views',10),('views_handler_filter_node_version_count','class','sites/all/modules/views/modules/node/views_handler_filter_node_version_count.inc','views',10),('views_handler_filter_numeric','class','sites/all/modules/views/handlers/views_handler_filter_numeric.inc','views',10),('views_handler_filter_profile_selection','class','sites/all/modules/views/modules/profile/views_handler_filter_profile_selection.inc','views',10),('views_handler_filter_search','class','sites/all/modules/views/modules/search/views_handler_filter_search.inc','views',10),('views_handler_filter_string','class','sites/all/modules/views/handlers/views_handler_filter_string.inc','views',10),('views_handler_filter_system_type','class','sites/all/modules/views/modules/system/views_handler_filter_system_type.inc','views',10),('views_handler_filter_term_node_tid','class','sites/all/modules/views/modules/taxonomy/views_handler_filter_term_node_tid.inc','views',10),('views_handler_filter_term_node_tid_depth','class','sites/all/modules/views/modules/taxonomy/views_handler_filter_term_node_tid_depth.inc','views',10),('views_handler_filter_term_node_tid_depth_join','class','sites/all/modules/views/modules/taxonomy/views_handler_filter_term_node_tid_depth_join.inc','views',10),('views_handler_filter_tracker_boolean_operator','class','sites/all/modules/views/modules/tracker/views_handler_filter_tracker_boolean_operator.inc','views',10),('views_handler_filter_tracker_comment_user_uid','class','sites/all/modules/views/modules/tracker/views_handler_filter_tracker_comment_user_uid.inc','views',10),('views_handler_filter_user_current','class','sites/all/modules/views/modules/user/views_handler_filter_user_current.inc','views',10),('views_handler_filter_user_name','class','sites/all/modules/views/modules/user/views_handler_filter_user_name.inc','views',10),('views_handler_filter_user_permissions','class','sites/all/modules/views/modules/user/views_handler_filter_user_permissions.inc','views',10),('views_handler_filter_user_roles','class','sites/all/modules/views/modules/user/views_handler_filter_user_roles.inc','views',10),('views_handler_filter_vocabulary_machine_name','class','sites/all/modules/views/modules/taxonomy/views_handler_filter_vocabulary_machine_name.inc','views',10),('views_handler_filter_vocabulary_vid','class','sites/all/modules/views/modules/taxonomy/views_handler_filter_vocabulary_vid.inc','views',10),('views_handler_relationship','class','sites/all/modules/views/handlers/views_handler_relationship.inc','views',10),('views_handler_relationship_broken','class','sites/all/modules/views/handlers/views_handler_relationship.inc','views',10),('views_handler_relationship_entity_reverse','class','sites/all/modules/views/modules/field/views_handler_relationship_entity_reverse.inc','views',10),('views_handler_relationship_groupwise_max','class','sites/all/modules/views/handlers/views_handler_relationship_groupwise_max.inc','views',10),('views_handler_relationship_node_term_data','class','sites/all/modules/views/modules/taxonomy/views_handler_relationship_node_term_data.inc','views',10),('views_handler_relationship_translation','class','sites/all/modules/views/modules/translation/views_handler_relationship_translation.inc','views',10),('views_handler_sort','class','sites/all/modules/views/handlers/views_handler_sort.inc','views',10),('views_handler_sort_broken','class','sites/all/modules/views/handlers/views_handler_sort.inc','views',10),('views_handler_sort_comment_thread','class','sites/all/modules/views/modules/comment/views_handler_sort_comment_thread.inc','views',10),('views_handler_sort_date','class','sites/all/modules/views/handlers/views_handler_sort_date.inc','views',10),('views_handler_sort_group_by_numeric','class','sites/all/modules/views/handlers/views_handler_sort_group_by_numeric.inc','views',10),('views_handler_sort_menu_hierarchy','class','sites/all/modules/views/handlers/views_handler_sort_menu_hierarchy.inc','views',10),('views_handler_sort_ncs_last_comment_name','class','sites/all/modules/views/modules/comment/views_handler_sort_ncs_last_comment_name.inc','views',10),('views_handler_sort_ncs_last_updated','class','sites/all/modules/views/modules/comment/views_handler_sort_ncs_last_updated.inc','views',10),('views_handler_sort_node_language','class','sites/all/modules/views/modules/locale/views_handler_sort_node_language.inc','views',10),('views_handler_sort_node_version_count','class','sites/all/modules/views/modules/node/views_handler_sort_node_version_count.inc','views',10),('views_handler_sort_random','class','sites/all/modules/views/handlers/views_handler_sort_random.inc','views',10),('views_handler_sort_search_score','class','sites/all/modules/views/modules/search/views_handler_sort_search_score.inc','views',10),('views_join','class','sites/all/modules/views/includes/handlers.inc','views',10),('views_join_subquery','class','sites/all/modules/views/includes/handlers.inc','views',10),('views_many_to_one_helper','class','sites/all/modules/views/includes/handlers.inc','views',10),('views_object','class','sites/all/modules/views/includes/base.inc','views',10),('views_plugin','class','sites/all/modules/views/includes/plugins.inc','views',10),('views_plugin_access','class','sites/all/modules/views/plugins/views_plugin_access.inc','views',10),('views_plugin_access_none','class','sites/all/modules/views/plugins/views_plugin_access_none.inc','views',10),('views_plugin_access_perm','class','sites/all/modules/views/plugins/views_plugin_access_perm.inc','views',10),('views_plugin_access_role','class','sites/all/modules/views/plugins/views_plugin_access_role.inc','views',10),('views_plugin_argument_default','class','sites/all/modules/views/plugins/views_plugin_argument_default.inc','views',10),('views_plugin_argument_default_book_root','class','sites/all/modules/views/modules/book/views_plugin_argument_default_book_root.inc','views',10),('views_plugin_argument_default_current_user','class','sites/all/modules/views/modules/user/views_plugin_argument_default_current_user.inc','views',10),('views_plugin_argument_default_fixed','class','sites/all/modules/views/plugins/views_plugin_argument_default_fixed.inc','views',10),('views_plugin_argument_default_node','class','sites/all/modules/views/modules/node/views_plugin_argument_default_node.inc','views',10),('views_plugin_argument_default_php','class','sites/all/modules/views/plugins/views_plugin_argument_default_php.inc','views',10),('views_plugin_argument_default_raw','class','sites/all/modules/views/plugins/views_plugin_argument_default_raw.inc','views',10),('views_plugin_argument_default_taxonomy_tid','class','sites/all/modules/views/modules/taxonomy/views_plugin_argument_default_taxonomy_tid.inc','views',10),('views_plugin_argument_default_user','class','sites/all/modules/views/modules/user/views_plugin_argument_default_user.inc','views',10),('views_plugin_argument_validate','class','sites/all/modules/views/plugins/views_plugin_argument_validate.inc','views',10),('views_plugin_argument_validate_node','class','sites/all/modules/views/modules/node/views_plugin_argument_validate_node.inc','views',10),('views_plugin_argument_validate_numeric','class','sites/all/modules/views/plugins/views_plugin_argument_validate_numeric.inc','views',10),('views_plugin_argument_validate_php','class','sites/all/modules/views/plugins/views_plugin_argument_validate_php.inc','views',10),('views_plugin_argument_validate_taxonomy_term','class','sites/all/modules/views/modules/taxonomy/views_plugin_argument_validate_taxonomy_term.inc','views',10),('views_plugin_argument_validate_user','class','sites/all/modules/views/modules/user/views_plugin_argument_validate_user.inc','views',10),('views_plugin_cache','class','sites/all/modules/views/plugins/views_plugin_cache.inc','views',10),('views_plugin_cache_none','class','sites/all/modules/views/plugins/views_plugin_cache_none.inc','views',10),('views_plugin_cache_time','class','sites/all/modules/views/plugins/views_plugin_cache_time.inc','views',10),('views_plugin_display','class','sites/all/modules/views/plugins/views_plugin_display.inc','views',10),('views_plugin_display_attachment','class','sites/all/modules/views/plugins/views_plugin_display_attachment.inc','views',10),('views_plugin_display_block','class','sites/all/modules/views/plugins/views_plugin_display_block.inc','views',10),('views_plugin_display_default','class','sites/all/modules/views/plugins/views_plugin_display_default.inc','views',10),('views_plugin_display_embed','class','sites/all/modules/views/plugins/views_plugin_display_embed.inc','views',10),('views_plugin_display_extender','class','sites/all/modules/views/plugins/views_plugin_display_extender.inc','views',10),('views_plugin_display_feed','class','sites/all/modules/views/plugins/views_plugin_display_feed.inc','views',10),('views_plugin_display_page','class','sites/all/modules/views/plugins/views_plugin_display_page.inc','views',10),('views_plugin_exposed_form','class','sites/all/modules/views/plugins/views_plugin_exposed_form.inc','views',10),('views_plugin_exposed_form_basic','class','sites/all/modules/views/plugins/views_plugin_exposed_form_basic.inc','views',10),('views_plugin_exposed_form_input_required','class','sites/all/modules/views/plugins/views_plugin_exposed_form_input_required.inc','views',10),('views_plugin_localization','class','sites/all/modules/views/plugins/views_plugin_localization.inc','views',10),('views_plugin_localization_core','class','sites/all/modules/views/plugins/views_plugin_localization_core.inc','views',10),('views_plugin_localization_none','class','sites/all/modules/views/plugins/views_plugin_localization_none.inc','views',10),('views_plugin_localization_test','class','sites/all/modules/views/tests/views_plugin_localization_test.inc','views',10),('views_plugin_pager','class','sites/all/modules/views/plugins/views_plugin_pager.inc','views',10),('views_plugin_pager_full','class','sites/all/modules/views/plugins/views_plugin_pager_full.inc','views',10),('views_plugin_pager_mini','class','sites/all/modules/views/plugins/views_plugin_pager_mini.inc','views',10),('views_plugin_pager_none','class','sites/all/modules/views/plugins/views_plugin_pager_none.inc','views',10),('views_plugin_pager_some','class','sites/all/modules/views/plugins/views_plugin_pager_some.inc','views',10),('views_plugin_query','class','sites/all/modules/views/plugins/views_plugin_query.inc','views',10),('views_plugin_query_default','class','sites/all/modules/views/plugins/views_plugin_query_default.inc','views',10),('views_plugin_row','class','sites/all/modules/views/plugins/views_plugin_row.inc','views',10),('views_plugin_row_aggregator_rss','class','sites/all/modules/views/modules/aggregator/views_plugin_row_aggregator_rss.inc','views',10),('views_plugin_row_comment_rss','class','sites/all/modules/views/modules/comment/views_plugin_row_comment_rss.inc','views',10),('views_plugin_row_comment_view','class','sites/all/modules/views/modules/comment/views_plugin_row_comment_view.inc','views',10),('views_plugin_row_fields','class','sites/all/modules/views/plugins/views_plugin_row_fields.inc','views',10),('views_plugin_row_node_rss','class','sites/all/modules/views/modules/node/views_plugin_row_node_rss.inc','views',10),('views_plugin_row_node_view','class','sites/all/modules/views/modules/node/views_plugin_row_node_view.inc','views',10),('views_plugin_row_rss_fields','class','sites/all/modules/views/plugins/views_plugin_row_rss_fields.inc','views',10),('views_plugin_row_search_view','class','sites/all/modules/views/modules/search/views_plugin_row_search_view.inc','views',10),('views_plugin_row_user_view','class','sites/all/modules/views/modules/user/views_plugin_row_user_view.inc','views',10),('views_plugin_style','class','sites/all/modules/views/plugins/views_plugin_style.inc','views',10),('views_plugin_style_default','class','sites/all/modules/views/plugins/views_plugin_style_default.inc','views',10),('views_plugin_style_grid','class','sites/all/modules/views/plugins/views_plugin_style_grid.inc','views',10),('views_plugin_style_jump_menu','class','sites/all/modules/views/plugins/views_plugin_style_jump_menu.inc','views',10),('views_plugin_style_list','class','sites/all/modules/views/plugins/views_plugin_style_list.inc','views',10),('views_plugin_style_mapping','class','sites/all/modules/views/plugins/views_plugin_style_mapping.inc','views',10),('views_plugin_style_rss','class','sites/all/modules/views/plugins/views_plugin_style_rss.inc','views',10),('views_plugin_style_summary','class','sites/all/modules/views/plugins/views_plugin_style_summary.inc','views',10),('views_plugin_style_summary_jump_menu','class','sites/all/modules/views/plugins/views_plugin_style_summary_jump_menu.inc','views',10),('views_plugin_style_summary_unformatted','class','sites/all/modules/views/plugins/views_plugin_style_summary_unformatted.inc','views',10),('views_plugin_style_table','class','sites/all/modules/views/plugins/views_plugin_style_table.inc','views',10),('views_slideshow_plugin_style_slideshow','class','sites/all/modules/views_slideshow/views_slideshow_plugin_style_slideshow.inc','views_slideshow',0),('views_test_area_access','class','sites/all/modules/views/tests/test_handlers/views_test_area_access.inc','views',10),('views_test_plugin_access_test_dynamic','class','sites/all/modules/views/tests/test_plugins/views_test_plugin_access_test_dynamic.inc','views',10),('views_test_plugin_access_test_static','class','sites/all/modules/views/tests/test_plugins/views_test_plugin_access_test_static.inc','views',10),('views_test_plugin_style_test_mapping','class','sites/all/modules/views/tests/test_plugins/views_test_plugin_style_test_mapping.inc','views',10),('views_ui','class','sites/all/modules/views/plugins/export_ui/views_ui.class.php','views_ui',0),('VotingAPITestCase','class','sites/all/modules/votingapi/tests/votingapi.test','votingapi',0),('votingapi_views_handler_field_value','class','sites/all/modules/votingapi/views/votingapi_views_handler_field_value.inc','votingapi',0),('votingapi_views_handler_relationship','class','sites/all/modules/votingapi/views/votingapi_views_handler_relationship.inc','votingapi',0),('votingapi_views_handler_sort_nullable','class','sites/all/modules/votingapi/views/votingapi_views_handler_sort_nullable.inc','votingapi',0),('WebformComponentsTestCase','class','sites/all/modules/webform/tests/WebformComponentsTestCase.test','webform',-1),('WebformConditionals','class','sites/all/modules/webform/includes/webform.webformconditionals.inc','webform',-1),('WebformConditionalsTestCase','class','sites/all/modules/webform/tests/WebformConditionalsTestCase.test','webform',-1),('WebformGeneralTestCase','class','sites/all/modules/webform/tests/WebformGeneralTestCase.test','webform',-1),('WebformPermissionsTestCase','class','sites/all/modules/webform/tests/WebformPermissionsTestCase.test','webform',-1),('WebformSubmissionTestCase','class','sites/all/modules/webform/tests/WebformSubmissionTestCase.test','webform',-1),('WebformTestCase','class','sites/all/modules/webform/tests/WebformTestCase.test','webform',-1),('webform_exporter','class','sites/all/modules/webform/includes/exporters/webform_exporter.inc','webform',-1),('webform_exporter_delimited','class','sites/all/modules/webform/includes/exporters/webform_exporter_delimited.inc','webform',-1),('webform_exporter_excel_delimited','class','sites/all/modules/webform/includes/exporters/webform_exporter_excel_delimited.inc','webform',-1),('webform_exporter_excel_xlsx','class','sites/all/modules/webform/includes/exporters/webform_exporter_excel_xlsx.inc','webform',-1),('webform_handler_area_result_pager','class','sites/all/modules/webform/views/webform_handler_area_result_pager.inc','webform',-1),('webform_handler_field_form_body','class','sites/all/modules/webform/views/webform_handler_field_form_body.inc','webform',-1),('webform_handler_field_is_draft','class','sites/all/modules/webform/views/webform_handler_field_is_draft.inc','webform',-1),('webform_handler_field_node_link_edit','class','sites/all/modules/webform/views/webform_handler_field_node_link_edit.inc','webform',-1),('webform_handler_field_node_link_results','class','sites/all/modules/webform/views/webform_handler_field_node_link_results.inc','webform',-1),('webform_handler_field_numeric_data','class','sites/all/modules/webform/views/webform_handler_numeric_data.inc','webform',-1),('webform_handler_field_submission_count','class','sites/all/modules/webform/views/webform_handler_field_submission_count.inc','webform',-1),('webform_handler_field_submission_data','class','sites/all/modules/webform/views/webform_handler_field_submission_data.inc','webform',-1),('webform_handler_field_submission_link','class','sites/all/modules/webform/views/webform_handler_field_submission_link.inc','webform',-1),('webform_handler_field_webform_status','class','sites/all/modules/webform/views/webform_handler_field_webform_status.inc','webform',-1),('webform_handler_filter_is_draft','class','sites/all/modules/webform/views/webform_handler_filter_is_draft.inc','webform',-1),('webform_handler_filter_numeric_data','class','sites/all/modules/webform/views/webform_handler_numeric_data.inc','webform',-1),('webform_handler_filter_submission_data','class','sites/all/modules/webform/views/webform_handler_filter_submission_data.inc','webform',-1),('webform_handler_filter_webform_status','class','sites/all/modules/webform/views/webform_handler_filter_webform_status.inc','webform',-1),('webform_handler_relationship_submission_data','class','sites/all/modules/webform/views/webform_handler_relationship_submission_data.inc','webform',-1),('webform_handler_sort_numeric_data','class','sites/all/modules/webform/views/webform_handler_numeric_data.inc','webform',-1),('webform_views_plugin_row_submission_view','class','sites/all/modules/webform/views/webform_plugin_row_submission_view.inc','webform',-1);
/*!40000 ALTER TABLE `registry` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `registry_file`
--

DROP TABLE IF EXISTS `registry_file`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `registry_file` (
  `filename` varchar(255) NOT NULL COMMENT 'Path to the file.',
  `hash` varchar(64) NOT NULL COMMENT 'sha-256 hash of the file’s contents when last parsed.',
  PRIMARY KEY (`filename`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Files parsed to build the registry.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `registry_file`
--

LOCK TABLES `registry_file` WRITE;
/*!40000 ALTER TABLE `registry_file` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `registry_file` VALUES ('includes/actions.inc','f36b066681463c7dfe189e0430cb1a89bf66f7e228cbb53cdfcd93987193f759'),('includes/ajax.inc','3d1c0d2efcdab327224122df1156a665f9bbf60873907dde2f189b018d4e9be3'),('includes/archiver.inc','bdbb21b712a62f6b913590b609fd17cd9f3c3b77c0d21f68e71a78427ed2e3e9'),('includes/authorize.inc','6d64d8c21aa01eb12fc29918732e4df6b871ed06e5d41373cb95c197ed661d13'),('includes/batch.inc','1fe00f9a25481cd43e19fbd6bd37b7ff9dca79f8405ec3e55ffb011be12ec2c3'),('includes/batch.queue.inc','554b2e92e1dad0f7fd5a19cb8dff7e109f10fbe2441a5692d076338ec908de0f'),('includes/bootstrap.inc','fdd02ea25268751b8024237b82792c9c05e596f744bb1c2cda4d36da839c902c'),('includes/cache-install.inc','e7ed123c5805703c84ad2cce9c1ca46b3ce8caeeea0d8ef39a3024a4ab95fa0e'),('includes/cache.inc','033c9bf2555dba29382b077f78cc00c82fd7f42a959ba31b710adddf6fdf24fe'),('includes/common.inc','04e8ed1c7f366c1012909481c118ec0203e3c998782564bfdbc5620c82def903'),('includes/database/database.inc','2ef46543fb9cf61ed9fa9aed4e44dd31630c22604ea6b8e48b57ebd7ad11a111'),('includes/database/log.inc','9feb5a17ae2fabcf26a96d2a634ba73da501f7bcfc3599a693d916a6971d00d1'),('includes/database/mysql/database.inc','32a577354dba6030043500873f8a2a7359c80c179a213284b026c1a9b0452b70'),('includes/database/mysql/install.inc','6ae316941f771732fbbabed7e1d6b4cbb41b1f429dd097d04b3345aa15e461a0'),('includes/database/mysql/query.inc','0212a871646c223bf77aa26b945c77a8974855373967b5fb9fdc09f8a1de88a6'),('includes/database/mysql/schema.inc','2ef729f8d6466d5cd87ba233152d88590bce629d8366040b2509b4e24258d780'),('includes/database/pgsql/database.inc','651bec324e2204aa35a28fdbd876aa8e4f7a9e909e75cc8db811e9c156b0df88'),('includes/database/pgsql/install.inc','39587f26a9e054afaab2064d996af910f1b201ef1c6b82938ef130e4ff8c6aab'),('includes/database/pgsql/query.inc','0df57377686c921e722a10b49d5e433b131176c8059a4ace4680964206fc14b4'),('includes/database/pgsql/schema.inc','1588daadfa53506aa1f5d94572162a45a46dc3ceabdd0e2f224532ded6508403'),('includes/database/pgsql/select.inc','1e509bc97c58223750e8ea735145b316827e36f43c07b946003e41f5bca23659'),('includes/database/prefetch.inc','b5b207a66a69ecb52ee4f4459af16a7b5eabedc87254245f37cc33bebb61c0fb'),('includes/database/query.inc','982d44a294eea1c9619687c14df2987257e3776fcabeba05f01432e934cf61c6'),('includes/database/schema.inc','6ea8e4063eb72d8f6b1a9f8b8908489d9f89b4a158ef37002d21209fb500358c'),('includes/database/select.inc','02a2d4345287df62b163ca2524e99b7370c9ec167bc937245328683d4e3e3d56'),('includes/database/sqlite/database.inc','62f6669c4610557c4b34ada9f0a0f61d6cb7b377e0a9032d2efca7b5f39b0965'),('includes/database/sqlite/install.inc','6620f354aa175a116ba3a0562c980d86cc3b8b481042fc3cc5ed6a4d1a7a6d74'),('includes/database/sqlite/query.inc','0eb02ad036ef61c490fb3f189a4cdc8fc1ae0d442737806346fd63aea8f30db3'),('includes/database/sqlite/schema.inc','3a7d22ec1f0ee09bfa267309b90e30edbe39e453b3025b30cbe3ae7412a4df2d'),('includes/database/sqlite/select.inc','8d1c426dbd337733c206cce9f59a172546c6ed856d8ef3f1c7bef05a16f7bf68'),('includes/date.inc','1de2c25e3b67a9919fc6c8061594442b6fb2cdd3a48ddf1591ee3aa98484b737'),('includes/entity.inc','f06b508f93e72ba70f979d8391be57662c018a03a32fac0a6d3baa752740133d'),('includes/errors.inc','d731bbe3a60508e164cfa90b8edc06400c7f15844f9f9bc3935dd87e44c460db'),('includes/file.inc','f112194214d483ce867165922ad7996c64174bd932369f89f8335af026bbb493'),('includes/file.mimetypes.inc','33266e837f4ce076378e7e8cef6c5af46446226ca4259f83e13f605856a7f147'),('includes/filetransfer/filetransfer.inc','fdea8ae48345ec91885ac48a9bc53daf87616271472bb7c29b7e3ce219b22034'),('includes/filetransfer/ftp.inc','51eb119b8e1221d598ffa6cc46c8a322aa77b49a3d8879f7fb38b7221cf7e06d'),('includes/filetransfer/local.inc','7cbfdb46abbdf539640db27e66fb30e5265128f31002bd0dfc3af16ae01a9492'),('includes/filetransfer/ssh.inc','92f1232158cb32ab04cbc93ae38ad3af04796e18f66910a9bc5ca8e437f06891'),('includes/form.inc','a0e219d53d641f08d6f1d609e53f06f3f8b1c591d20113d0992557c815b44a72'),('includes/graph.inc','8e0e313a8bb33488f371df11fc1b58d7cf80099b886cd1003871e2c896d1b536'),('includes/image.inc','bcdc7e1599c02227502b9d0fe36eeb2b529b130a392bc709eb737647bd361826'),('includes/install.core.inc','189653e4bb7d4828bd6e1b61015fabcc7182e23d9dd8858170f98114d99400c8'),('includes/install.inc','fbb23627b06abb070b4531da786c1e06bf1dbd6f923bb2b404f4808c2340b0f9'),('includes/iso.inc','0ce4c225edcfa9f037703bc7dd09d4e268a69bcc90e55da0a3f04c502bd2f349'),('includes/json-encode.inc','02a822a652d00151f79db9aa9e171c310b69b93a12f549bc2ce00533a8efa14e'),('includes/language.inc','4e08f30843a7ccaeea5c041083e9f77d33d57ff002f1ab4f66168e2c683ce128'),('includes/locale.inc','ca50acc0780cbffeca17f99a0997f91b8b9402f0eec1898c3122e1d73664d01d'),('includes/lock.inc','a181c8bd4f88d292a0a73b9f1fbd727e3314f66ec3631f288e6b9a54ba2b70fa'),('includes/mail.inc','41d0e657119a05f8d7e85ebf32e74b12a1c3107d717a348158414b113e208b9c'),('includes/menu.inc','8e7a8a1a4666a8ca66d1b19cc97be4cf82c3bb0e835e652ee366bec9b74a8c23'),('includes/module.inc','8dab73e50e6bcd680a26f55597d2d103ba68a29089f888e2a2c206fc38eaa669'),('includes/pager.inc','6f9494b85c07a2cc3be4e54aff2d2757485238c476a7da084d25bde1d88be6d8'),('includes/password.inc','fd9a1c94fe5a0fa7c7049a2435c7280b1d666b2074595010e3c492dd15712775'),('includes/path.inc','2dca08d14a46e5ac6a665b7a5dde78045d8de2b35aaa78c6fb811e1125ce4953'),('includes/registry.inc','f47b20859f0fc80bf4bb2849a1282d6c54006957b69da0e5f4691de585ca4cdf'),('includes/session.inc','5851ff6941aba2744dd0c247f077fc02fbbe24e9786e04ea0a3c372d68ca6d16'),('includes/stream_wrappers.inc','b8a5a53f3d3ef26ea868037547f76af8049ce0c55b464810c627310a84f24924'),('includes/tablesort.inc','2d88768a544829595dd6cda2a5eb008bedb730f36bba6dfe005d9ddd999d5c0f'),('includes/theme.inc','5d8b96db9760367eb86821085a17a144a58cb355e6f547e321321ee34535da7b'),('includes/theme.maintenance.inc','39f068b3eee4d10a90d6aa3c86db587b6d25844c2919d418d34d133cfe330f5a'),('includes/token.inc','5e7898cd78689e2c291ed3cd8f41c032075656896f1db57e49217aac19ae0428'),('includes/unicode.entities.inc','2b858138596d961fbaa4c6e3986e409921df7f76b6ee1b109c4af5970f1e0f54'),('includes/unicode.inc','e18772dafe0f80eb139fcfc582fef1704ba9f730647057d4f4841d6a6e4066ca'),('includes/update.inc','25c30f1e61ef9c91a7bdeb37791c2215d9dc2ae07dba124722d783ca31bb01e7'),('includes/updater.inc','d2da0e74ed86e93c209f16069f3d32e1a134ceb6c06a0044f78e841a1b54e380'),('includes/utility.inc','3458fd2b55ab004dd0cc529b8e58af12916e8bd36653b072bdd820b26b907ed5'),('includes/xmlrpc.inc','ea24176ec445c440ba0c825fc7b04a31b440288df8ef02081560dc418e34e659'),('includes/xmlrpcs.inc','925c4d5bf429ad9650f059a8862a100bd394dce887933f5b3e7e32309a51fd8e'),('modules/block/block.test','40d9de00589211770a85c47d38c8ad61c598ec65d9332128a882eb8750e65a16'),('modules/blog/blog.test','f7534b972951c05d34bd832d3e06176b372fff6f4999c428f789fdd7703ed2e2'),('modules/book/book.test','a75a4ec12f930d85adbf7c46d6a1a4ed1356657466874f21e9cc931b6cd41aa0'),('modules/color/color.test','610ba154f42b6af5871fb09cdb0bc7badc29b03845c08d86e0e524840dd27568'),('modules/comment/comment.module','db858137ff6ce06d87cb3b8f5275bed90c33a6d9aa7d46e7a74524cc2f052309'),('modules/comment/comment.test','332d14e197b4ebe85b1b70a15602981d99d332e2293576c0e44cf18a808c7aac'),('modules/contact/contact.test','655e8d5fe7536a972c2233e438a142166b15a118cc644e94b756c2814c375634'),('modules/contextual/contextual.test','023dafa199bd325ecc55a17b2a3db46ac0a31e23059f701f789f3bc42427ba0b'),('modules/dashboard/dashboard.test','125df00fc6deb985dc554aa7807a48e60a68dbbddbad9ec2c4718da724f0e683'),('modules/dblog/dblog.test','79ba7991c3f40f9241e9a03ffa43faf945c82658ca9b52ec62bd13bd80f41269'),('modules/field/field.attach.inc','2df4687b5ec078c4893dc1fea514f67524fd5293de717b9e05caf977e5ae2327'),('modules/field/field.info.class.inc','cf18178e119d43897d3abd882ba3acc0cf59d1ad747663437c57b1ec4d0a4322'),('modules/field/field.module','48b5b83f214a8d19e446f46c5d7a1cd35faa656ccb7b540f9f02462a440cacdd'),('modules/field/modules/field_sql_storage/field_sql_storage.test','315eedaf2022afc884c35efd3b7c400eddab6ea30bec91924bc82ab5cd3e79f2'),('modules/field/modules/list/tests/list.test','c1a214d7efd3247dd947d742a8514ec9649da62593608dfdccee6913d48e5709'),('modules/field/modules/number/number.test','fc8f193904f1c5f87dcf51a279975214b34aa1349fe9c38b09c4e6740b059b49'),('modules/field/modules/options/options.test','1b30956b6f46840ccb41b99bda08f328172f008f1fb4164c65fe9e4047fffa5f'),('modules/field/modules/text/text.test','5c28b9da26417d2ed8a169850989c0b59f2b188a0161eb58e2b87c67994d602d'),('modules/field/tests/field.test','5eaad7a933ef8ea05b958056492ce17858cd542111f0fe81dd1a5949ad8f966e'),('modules/field_ui/field_ui.test','f535e5627c969e9083a63aaf72d4ac645e30709d7b87af15c6c3b870481f283a'),('modules/file/tests/file.test','f2328df0915f0d7235cb147515ed64cb1c510a744646fb680da98c8d9f2523c5'),('modules/filter/filter.test','b8aa5e6b832422c6ad5fe963898ec9526c814614f27ecccb67107ce194997d6a'),('modules/forum/forum.test','d282b29d6312d63183e003ba036d7645a946e828c94448592f930d80fceb42d6'),('modules/help/help.test','bc934de8c71bd9874a05ccb5e8f927f4c227b3b2397d739e8504c8fd6ae5a83c'),('modules/image/image.test','6e7a0cbcb58f6210127b0ac7c1d118d488abd0925fe8db10a3405af87f1d9fe1'),('modules/locale/locale.test','08793bfbabe6147248a3cbbecaec2c3179baf15bd3289b43f3b0dad3bc8280ae'),('modules/menu/menu.test','71efd7117a882fdcdd50971b4a68f7f2895b532e09acf094d747f27a15742c5b'),('modules/node/node.module','70f969229d03819dba439546ae7aef30283b93e410af1b45f5a25b90d3cb8edd'),('modules/node/node.test','35bf40fde62f3a1de95bab9f037b84f20c2f93a1c579d7d19e4a87afe75dc330'),('modules/path/path.test','2004183b2c7c86028bf78c519c6a7afc4397a8267874462b0c2b49b0f8c20322'),('modules/php/php.test','d234f9c1ab18a05834a3cb6dc532fb4c259aa25612551f953ba6e3bb714657b8'),('modules/search/search.extender.inc','013a6a841cc48a6dc991153fb692b8d1546e56b78d9c95e97e0d7e92296d3481'),('modules/search/search.test','e43c21510d510885dfad6484afa931382083b75b7e67286bda56a6aafe265f28'),('modules/shortcut/shortcut.test','0d78280d4d0a05aa772218e45911552e39611ca9c258b9dd436307914ac3f254'),('modules/statistics/statistics.test','7abe4cce7ef548637d709e22cf340f9973b6d77615a470949d20a6426f5b08f2'),('modules/system/system.archiver.inc','faa849f3e646a910ab82fd6c8bbf0a4e6b8c60725d7ba81ec0556bd716616cd1'),('modules/system/system.mail.inc','d31e1769f5defbe5f27dc68f641ab80fb8d3de92f6e895f4c654ec05fc7e5f0f'),('modules/system/system.queue.inc','a77a5913d84368092805ac551ca63737c1d829455504fcccb95baa2932f28009'),('modules/system/system.tar.inc','d0d2f191d79b3227852e7436908386bdd7a25f78c73f3c8bf9ef5903892ae993'),('modules/system/system.test','7a94d94c13eb60684678e62f25cec44d46714a1ca4987f62d86d358e8978902a'),('modules/system/system.updater.inc','9433fa8d39500b8c59ab05f41c0aac83b2586a43be4aa949821380e36c4d3c48'),('modules/taxonomy/taxonomy.module','19992c2e810a7b7a1c228d178b0b6c5f358082d515b8a6e77b0415a430e23997'),('modules/taxonomy/taxonomy.test','ce91ff8a2879d65fdb3477d3f437cad8ef50b8963dadb75ae203854987b2c23a'),('modules/update/update.test','994b66b737f16eb98ee18c9e9ecd62e86de2792159e70b36982e95b48f2746a3'),('modules/user/user.module','b773a1b0f7448546393e6f7b2436d0d91b7965889afdf4a863bba4c0bc0dba69'),('modules/user/user.test','0b55048c0de2dee5ab1c25a38c01b3bd13f476b43e4172bb0c06cb6188d2edc9'),('sites/all/modules/admin_menu/tests/admin_menu.test','185f8244f7a086cda1bd9435ec529e8632598e9b09d1e0d7363b75cf87c04afb'),('sites/all/modules/advanced_forum/includes/views/advanced_forum_handler_field_node_topic_icon.inc','3fdb5a6cf520c9c6a3c842d4e771c34cd57bd28eec39e2217b0e70b7dbce5ffd'),('sites/all/modules/advanced_forum/includes/views/advanced_forum_handler_field_node_topic_pager.inc','0350373ba983c2890d65e75472a22afd5225b82100e4f256cf8ae46d5420c9fb'),('sites/all/modules/advanced_forum/includes/views/advanced_forum_plugin_style_forum_topic_list.inc','a43dfe156401d4dc855f1d532291f403adfe7cfcb90d4dccf2c2f3d601bf9d0b'),('sites/all/modules/advanced_forum/tests/af.test','1e86e10de8115967397fda421008e64de3ab5287685d22f9c08b96a40699144c'),('sites/all/modules/author_pane/author-pane-user-picture.tpl.php','f0f4506dcb92e06c3d82e6df570041a2b972b50dd24e085ba0afdf7f303a8403'),('sites/all/modules/author_pane/author-pane.tpl.php','f9cf0d1dd4a53d5baa97cca2c4ef7c931374aa004a7092589d19be3dc6d9d675'),('sites/all/modules/author_pane/author_pane.module','b26779243612f2454d4cd743ce0f7423a3b9a46c8a9c21db656648af98855e43'),('sites/all/modules/author_pane/modules/contact.author-pane.inc','fda8411ca4376d846898b1941da007471aff54e25e9d5a3c99634063cd27daee'),('sites/all/modules/author_pane/modules/fasttoggle.author-pane.inc','9fc7f06a418a96f486d084e2be47c12c8d4ffab88e14a2a626513ed3918f5524'),('sites/all/modules/author_pane/modules/og.author-pane.inc','2c384f252efbdb0207a88fac682e50ed338dfeae4bd6cc778a3ec1661bcd8db8'),('sites/all/modules/author_pane/modules/userpoints.author-pane.inc','481b09d4d7697009f9d66b9cdbbb77cdaadc47765cb705528677a2c89366946a'),('sites/all/modules/author_pane/modules/user_badges.author-pane.inc','90ac3fb5b77b6d6d2112c289ce1c94c47c57aeb78c4e0b02dc4af7c9e9b2e8cd'),('sites/all/modules/author_pane/modules/user_titles.author-pane.inc','454d1783d77786fd0b99d595a1b482080a2f92ed2cf21e639b16333fc94c4858'),('sites/all/modules/block_class/block_class.test','ad3e6238a7a0c025d2cac75cfa089c90ce721a94241925db4484ceb6a04ec8a4'),('sites/all/modules/calendar/calendar.install','85517f33935a333f0414974417f8be0c42ff18a384c1cf890162c5e73160216b'),('sites/all/modules/calendar/calendar.module','0387183e6dae4f92e4208ccf69d6ef17163f22d506ee4a86e210c70d708b3459'),('sites/all/modules/calendar/includes/calendar.views.inc','89f3265426ed077d0ea32c7462160ed60eeebb562f5e99abc4703fbd22761127'),('sites/all/modules/calendar/includes/calendar.views_template.inc','502a562d7d3ce8f4d935e6ea63350fa422f3f29b0b1907f8a27811aa5cbaa2ff'),('sites/all/modules/calendar/includes/calendar_plugin_row.inc','3eb1f3738276b798e773613e528a8fc36dba46cf98593ec30e46edd2130a85f7'),('sites/all/modules/calendar/includes/calendar_plugin_style.inc','1c4394b0e6ab59c18bed21af2e976d02e7545e8748893846ed9672a00bb000ff'),('sites/all/modules/calendar/theme/calendar-style.tpl.php','9746be8e78f6165db12e1800298bf8e5f771182f049d7c1aa2edbd83a1f48fe4'),('sites/all/modules/calendar/theme/theme.inc','54f635b589c2525f0ed4750b73cea6d5244c3335995866fcd399167c1cb3da25'),('sites/all/modules/ctools/includes/context.inc','4cec11a71872eb916c4315c9f727a184d46758aa64bb950d86877a60b9007157'),('sites/all/modules/ctools/includes/css-cache.inc','db90ff67669d9fa445e91074ac67fb97cdb191a19e68d42744f0fd4158649cfa'),('sites/all/modules/ctools/includes/math-expr.inc','601db581743dd22d67f7aaf228bd8d26298d72033fc675d02385a1fd6d31888f'),('sites/all/modules/ctools/includes/stylizer.inc','3f91f5ed42fb6ee1b65ddef7ac22577b07a5d75ca1eb2df60041243ced5c7079'),('sites/all/modules/ctools/plugins/export_ui/ctools_export_ui.class.php','2fd87a7d80689e4d44673b31c07b762144eb8ac57324fd0b9cd9ede5f4ea34b5'),('sites/all/modules/ctools/tests/css_cache.test','0dbc038efedb1fa06d2617b7c72b3a45d6ee5b5b791dcb1134876f174a2a7733'),('sites/all/modules/date/date_api/date_api.module','107f1668a3a75f9b18e834f8494fc52d8ccf0d6b231c98bd10b9313cfbe18776'),('sites/all/modules/date/date_api/date_api_sql.inc','89e92bdb4eb9b348a57d70ddb933c86e81f6e7a7047cd9e77c83a454c00c5a11'),('sites/all/modules/date/date_views/includes/date_views.views.inc','44b229fd62c349b3c9f56d1cc7b5070308833612d601a7cf0e4cb2aa5275764e'),('sites/all/modules/date/date_views/includes/date_views_argument_handler.inc','acc9d39134d2131fc8a1c3b4206f3db2edc574cf17b3b36a4b696bffed31af01'),('sites/all/modules/date/date_views/includes/date_views_argument_handler_simple.inc','b6e9e4e278ecaae73873a85c044b386eb9723a5d4b12d9975d9cec1f0c2cd825'),('sites/all/modules/date/date_views/includes/date_views_filter_handler.inc','0e10d186c826871e47110ac639789509ac4d8f62c0add4bea6a7f4bf9f6115ed'),('sites/all/modules/date/date_views/includes/date_views_filter_handler_simple.inc','50f21e119928c403e7982068c82cdab6c9ca17c6494cbb80dc2e694609b7efea'),('sites/all/modules/date/date_views/includes/date_views_plugin_pager.inc','25baab739094a43b64ad8b3fde0946edaf43ad72de25594ffcd2d9893f459f0f'),('sites/all/modules/entity/entity.features.inc','47261e1f4f39ac3707a16fdea8a8147c09df1281bcb4b9e46b0c8120603137e8'),('sites/all/modules/entity/entity.i18n.inc','41e0e62af7e2774f62b162d597bb3244551c280296b692b29d039a2c243d7059'),('sites/all/modules/entity/entity.info.inc','8799080b9393c9560e64feae1276fb7d26fef4d92bb0edacc863ee3e7b67bf04'),('sites/all/modules/entity/entity.rules.inc','774199059d1b3ebe6d3fe7a49dbb1550df489055a3d066b5de54edda8dd7ba84'),('sites/all/modules/entity/entity.test','df253128e41f152b45ef30b5674009c51cf4112450e5dad8e815f39ced280db5'),('sites/all/modules/entity/entity_token.module','0c1ad6fb6f8c430e47a81be6d08180883c5a1ee728ce8b5dd0775713b34fb862'),('sites/all/modules/entity/entity_token.tokens.inc','084edf8f860f3c9843e23cc2e06a9084dcb644ee6d99c21cdd7bd924138d518f'),('sites/all/modules/entity/includes/entity.controller.inc','342db185e6170b63c59a9b360a196eb322edb9a5b8c7819f66b0eae48ed13ebd'),('sites/all/modules/entity/includes/entity.inc','57411fa3d7b5cd2afe8b84f20c1741f48c32673a9da07bd2c35d4a11c50c640e'),('sites/all/modules/entity/includes/entity.ui.inc','65739b31af0e6b422919c17805799dc99143fd89cacfb56b9186e26ece2d0df2'),('sites/all/modules/entity/includes/entity.wrapper.inc','0db08cbb6b730035e3e9a483e6e5c06a744a73f19e4ca83936446b44f0c3d158'),('sites/all/modules/entity/views/entity.views.inc','de657f42389ed6832df787e4b618d8d7117b60d145d34ce5dcf3a5b65db29df9'),('sites/all/modules/entity/views/handlers/entity_views_field_handler_helper.inc','4ec395881109a71327ab8d7c5b5702bef30288ca66557e44e8539cc15a2135bb'),('sites/all/modules/entity/views/handlers/entity_views_handler_area_entity.inc','7b7bb88e53861739b7279f705f0492fc83ce95f5b20d89339480f546422ebf25'),('sites/all/modules/entity/views/handlers/entity_views_handler_field_boolean.inc','b28b8eee8761ba7a6af35d97ab7aaee28406e6c227271f9769818560626c5791'),('sites/all/modules/entity/views/handlers/entity_views_handler_field_date.inc','b0f5be5b399de94934b24e84c8cf6053a043f6b00c60dcffa752daeafdd38778'),('sites/all/modules/entity/views/handlers/entity_views_handler_field_duration.inc','ed7bb64cb63b94a20c8cde98cfb053b5ea252804396cf61ac562faf1d850266b'),('sites/all/modules/entity/views/handlers/entity_views_handler_field_entity.inc','4f255918a22fefebe9c7734f200751457a7ca4d3648e32a98511bb51968d7521'),('sites/all/modules/entity/views/handlers/entity_views_handler_field_field.inc','893121efbce2a7181e31147bade260c9cc657cbd33b0d254cb28b2650e57566d'),('sites/all/modules/entity/views/handlers/entity_views_handler_field_numeric.inc','f14e2b063930e8820af381b4f5e83c7278440e7804ab88cfde865b6c94e7c0f6'),('sites/all/modules/entity/views/handlers/entity_views_handler_field_options.inc','27ef31b8ee7b9999930380d6a5fdb477772329c4ddbd5c70cc34bcdc7543ce56'),('sites/all/modules/entity/views/handlers/entity_views_handler_field_text.inc','5fb0a85d35d29944c699ceaf6efed5eda2df757009e44caba8ff2be397568b60'),('sites/all/modules/entity/views/handlers/entity_views_handler_field_uri.inc','79ecaa3eb17dfdd0ca077351b75a2c0adf411ebc04720e7cc0e2397674225f24'),('sites/all/modules/entity/views/handlers/entity_views_handler_relationship.inc','b69bc538d1e1e0f91f8485ca54c3b6e2be025caa47619734c467377cf89041b9'),('sites/all/modules/entity/views/handlers/entity_views_handler_relationship_by_bundle.inc','65300c793c4591d60ad908dc02cf3148fe4e899fa6ad218e875fd92d411374dc'),('sites/all/modules/entity/views/plugins/entity_views_plugin_row_entity_view.inc','ba557790215f2658146424d933e0d17787a0b15180c5815f23428448ccf056a0'),('sites/all/modules/entityreference/entityreference.migrate.inc','617c6c49e6e0fa4d106cfb49b61a6994b5520934ac3b64a8400a9d969eab7c59'),('sites/all/modules/entityreference/plugins/behavior/abstract.inc','a7959ddece2ce3490f92d916162e07aed313e28ca299ca0375bad633b42d93e3'),('sites/all/modules/entityreference/plugins/behavior/EntityReferenceBehavior_TaxonomyIndex.class.php','92fa0cf46ecdf6200659646e6666c562ea506c40efa41a8edd4758dc0c551b92'),('sites/all/modules/entityreference/plugins/behavior/EntityReferenceBehavior_ViewsFilterSelect.class.php','f6805f62bbd376d98676706602aeb1c4d16e645acb429d31032bc3fb37d850d3'),('sites/all/modules/entityreference/plugins/selection/abstract.inc','7ecf94f5dc3456e4a5c87117d19deb98c368617fb07d610505b1dfa351f14a0b'),('sites/all/modules/entityreference/plugins/selection/EntityReference_SelectionHandler_Generic.class.php','e9a8a3c693ed24218d00c10c445cdb21daed10a26e6b55e5c9d6a8c616cfd871'),('sites/all/modules/entityreference/plugins/selection/EntityReference_SelectionHandler_Views.class.php','b1878655779d07b8210ab81c3dd9aae931250f328b044114045a4780a84a0ed7'),('sites/all/modules/entityreference/plugins/selection/views.inc','7bbe8900b6b71c2d41e370deaccca869884d0fe9ca81772d7d5bca5f58ec1cd8'),('sites/all/modules/entityreference/tests/entityreference.admin.test','bcd6516be3099ae87a4c3d41add08edd17eafb4244db8442c5dc15f19ebde7ae'),('sites/all/modules/entityreference/tests/entityreference.feeds.test','320c7480b1758e4d80e91c0a6ea3d43b6b35d1adfe00b6155b61ef786510bb7c'),('sites/all/modules/entityreference/tests/entityreference.handlers.test','2fa170925ac5303c519378f1763e918cc2f111205220d90998b547a08db90d8c'),('sites/all/modules/entityreference/tests/entityreference.taxonomy.test','8e4f7d9ae621df0f587b6fcbf139adea2a35c69305ef018ced88447a41164c5f'),('sites/all/modules/entityreference/views/entityreference_plugin_display.inc','9216a065ea4fdb2daacb1280e5c9549e3400b8553b5293534cf65a0d703ab189'),('sites/all/modules/entityreference/views/entityreference_plugin_row_fields.inc','7f5a58c099c2df6fd1c3ae285197a4648841d44fa107bcb2064bc1edf435ea8b'),('sites/all/modules/entityreference/views/entityreference_plugin_style.inc','ad9a7ea5a37c2d9658c2b1d19ade3011c27ed5d9959423ebf7a390372507e6b0'),('sites/all/modules/faq/faq.admin.inc','5e7c31e8cf51224d8599c89ad885cbb207e2fe633b2ee7665c3f7e6ede708698'),('sites/all/modules/faq/faq.install','11442a65f3c4451fe6c681bb3a836fc786381035aa3bd2b3aaffab4d1d80be0c'),('sites/all/modules/faq/faq.module','0d69551abb58955760ac0815addd09d6f47f08a6f39fac410cb62da30a25f2d6'),('sites/all/modules/faq/faq.test','960816771c1ecd0450d1d1ed1d8cc6f0d86de18fcdc4ab63b278b05be7e442b5'),('sites/all/modules/faq/includes/faq-category-hide-answer.tpl.php','9761021d7af8d6a21d3316d1a9de9e50e469f4cfd6102221f5c2b28d8cd0e51c'),('sites/all/modules/faq/includes/faq-category-new-page.tpl.php','873e648402b3f450f5305d1a7c21b685d7e8b88c51dd1aee465862963980a02e'),('sites/all/modules/faq/includes/faq-category-questions-inline.tpl.php','4a98904f5488e0dc6723273f6d449a26a5039708bcc2e06d9a3a15d5afdc26aa'),('sites/all/modules/faq/includes/faq-category-questions-top-answers.tpl.php','e05f4a804273f589a2ee536305bf30c3d24e5d04efe4484cb766e5609726cd31'),('sites/all/modules/faq/includes/faq-category-questions-top.tpl.php','cf35540c0d62d3902e6c4c86921eb4936ae57a6a6f3ed5954fbf10ee0dbdb26e'),('sites/all/modules/faq/includes/faq-hide-answer.tpl.php','df6bb10ee8fa1f1ae962402a12ed222918588e0be0813894eeb983905a744ad8'),('sites/all/modules/faq/includes/faq-new-page.tpl.php','4e1c0385cbb6c531f0cb63f43de96e9705e63b8026b5b1b6aff2a0ae97da223f'),('sites/all/modules/faq/includes/faq-questions-inline.tpl.php','0e01bad6d166e9a71030ad6fe057a4e3e7aaadf00029e8495e8dd5b2987a5b21'),('sites/all/modules/faq/includes/faq-questions-top.tpl.php','fa05b6bb37215200c5ba4e6fb6df4ace2cbf01bbf4bc596c1f33e9b7732ac7f6'),('sites/all/modules/faq/includes/faq.hide_answer.inc','32600b592a1af563e64d3b5ee7ec23b9a6d66765202b7cc8d18627db6ad38123'),('sites/all/modules/faq/includes/faq.new_page.inc','34008d805beb6359b8b9dd2eb935502b7935e49be00b71f41a4aa38e7ea29bfa'),('sites/all/modules/faq/includes/faq.questions_inline.inc','98c420cc7eca10beabeedcb740ff7060e7c7ba38885af5b9448bd3c636ea5689'),('sites/all/modules/faq/includes/faq.questions_top.inc','3f662ef01efe2415f036b6a9ca1b196091f6733e538410908df8180a3df14e27'),('sites/all/modules/faq/views/faq.views.inc','6f91ca8e0359d788778d991ac6e2fe5f17f7cabab469abf3722b3d90e135ee31'),('sites/all/modules/features/tests/features.test','5fc1c5733eb4c76c32f1a79736c064f1f89001f7987eb7bf183c8d438c8f8baf'),('sites/all/modules/field_collection/field_collection.info.inc','e11b810756dabe6eb24b70a3a84390480a2de7c5d65ea5a1f0d6045802f8405e'),('sites/all/modules/field_collection/field_collection.migrate.inc','2a24762712659caf3d93429d973763e6f0ae4c36d42841893a501f070629aafb'),('sites/all/modules/field_collection/field_collection.test','9d30f2ab55492a10e7d381e5af1985160b798fcc57c14b5516e6d4c7cd997dc8'),('sites/all/modules/field_collection/views/field_collection_handler_relationship.inc','6e8c13805c1ff233410bb408d524786df4ca64fc10ee4bd874a16277243efba1'),('sites/all/modules/field_group/tests/field_group.display.test','68b48634e0311fb4a804d39d8c03acc3de868719df0f4cca495c81e9de4e2035'),('sites/all/modules/field_group/tests/field_group.ui.test','17486a055b85febf5cc55cdb638bf104ef3acab75b76735763650217dd5ab9d4'),('sites/all/modules/fivestar/test/fivestar.base.test','673858a7652d27ab2ba950e4448716c667187cd33186a51f02e200aad5528af2'),('sites/all/modules/fivestar/test/fivestar.field.test','0c15a08ee59b4a74d86491c10c3924adbad0f391fc4e81715f7ff79f3115e4ff'),('sites/all/modules/flexslider/flexslider.test','377205ce1adf7f8235881d5e3a9e465fc9157e1d1dd2cc83da924da82b93086a'),('sites/all/modules/flexslider/flexslider_views/flexslider_views.module','bfb2794b3c8711c84db6f31c60e87314c26b5489903cedb92b9d632812f05496'),('sites/all/modules/flexslider/flexslider_views/flexslider_views.views.inc','6bba7b25386477b60098a754e67f26e93cf9256ef9b85d1f1801adb130b82c73'),('sites/all/modules/flexslider/flexslider_views/flexslider_views_plugin_style_flexslider.inc','a4986b2603f1a0752766d4d327e7be9053cc8809bebd0221578778df4f9f5796'),('sites/all/modules/flexslider/theme/flexslider.theme.inc','d8045c74c4d3e7daa9b0864e14a571d6aa36883f5ba80e065078b80cfb807a95'),('sites/all/modules/i18n/i18n.test','3c3a332aab4ea960daacf77f38dd914a3a019777384e656b2836b72de7809ecd'),('sites/all/modules/i18n/i18n_block/i18n_block.inc','73eb3b7ba1e14cd12b51c7a94dcd2e5d701d1cee5aaf24d907aa282dbc9212c1'),('sites/all/modules/i18n/i18n_block/i18n_block.test','89b3a58fdff661979d8d5f03181c45ccd4807fe9b313352f9b77a6eccc33eb87'),('sites/all/modules/i18n/i18n_object.inc','13118a2525f7ef27040f1c4824fcd05258154fcba128bdb5802c0aac471293c8'),('sites/all/modules/i18n/i18n_string/i18n_string.admin.inc','ace6c13b12cbb5379c803def1f4c4ba073457aa7fe84d1f87a4a4693e28b216c'),('sites/all/modules/i18n/i18n_string/i18n_string.inc','ca15489a06352a16ad86fb2ba510a7c5a34866ffb41bf18efef83d715ef6c33f'),('sites/all/modules/i18n/i18n_string/i18n_string.test','9d8f64d589d8a6a4ad443591e09956686d4ccf73892887a74179549af7911d2c'),('sites/all/modules/i18n/i18n_taxonomy/i18n_taxonomy.admin.inc','1c0addd145245731d2ba8ec708c9557d389d5cece650ec4973d4a69261adb76e'),('sites/all/modules/i18n/i18n_taxonomy/i18n_taxonomy.inc','7bc643c59e25c8a00491bc70258821793bbcb232a70510eff071a02bb1e4343e'),('sites/all/modules/i18n/i18n_taxonomy/i18n_taxonomy.pages.inc','8de7acbdd672e7f276fbe47a67da8c3f4f98b4e6be4983748f30917b45c9247a'),('sites/all/modules/i18n/i18n_taxonomy/i18n_taxonomy.test','29fc8c69345e4d2b8eda25ae5d7775772ff1432452f07d51d66b727857ba3690'),('sites/all/modules/i18n/i18n_translation/i18n_translation.inc','e7e38105a080efcb1d947e7e6d2f1487127b166905b2722c516582827ddaf143'),('sites/all/modules/jquery_update/jquery_update.install','d377a4e1df5c9606b4d603fbf14296f6d4df921bb3e188341a0c602651498388'),('sites/all/modules/jquery_update/jquery_update.module','5550809cea16a9f09ebcd6e70fc36a19a2aa3fd6180039d2e2382b86d659a8c3'),('sites/all/modules/lang_dropdown/lang_dropdown.install','e7c905e92611f915a6b94695717c8b26b69e7ce74fac43e695a597fe3f8055f8'),('sites/all/modules/lang_dropdown/lang_dropdown.module','d289422a831d398e346cc3926b46fd703f89b021b2a2b37fc3aad904e48c4d59'),('sites/all/modules/lang_dropdown/lang_dropdown_hideout/lang_dropdown_hideout.install','2232e6ff3d424993cd73681ebcafcf5e3471a94d245667ece3ab2b6514c8d39c'),('sites/all/modules/lang_dropdown/lang_dropdown_hideout/lang_dropdown_hideout.module','bb44163e1873de81a78c02d1276e9318f7d5c80804fa059619c6792d44b36a63'),('sites/all/modules/libraries/tests/libraries.test','b566140ed33211b04cda3d8773b5bc25f8986065463864a0703fa89979daa817'),('sites/all/modules/link/link.migrate.inc','0a17ff0daa79813174fff92e9db787e75e710fe757b6924eec193c66fe13f3df'),('sites/all/modules/link/link.module','3fdf23f9f409b80df5eee57207a5045c566422cef14128306835f7b1b03a5e66'),('sites/all/modules/link/tests/link.attribute.test','8c21045dbcf346edf8dc70c157d02074dd87372d4f60e7f5a4ae11683cd79399'),('sites/all/modules/link/tests/link.crud.test','de19e2c5e8c6cb02f25d7051bdd1db77852379ac59ce8185c25b4bf927478f22'),('sites/all/modules/link/tests/link.crud_browser.test','07794771164033e14a635625ad08fdbcdc4dafa154db2ec0bd9a95ca30202eb5'),('sites/all/modules/link/tests/link.test','fe5d8cd577fbfc07929e7216e115530a28777ace9b7135fbc853a3a78d550456'),('sites/all/modules/link/tests/link.token.test','930af3b64ccabd58a14c8f596ee4b908596b4bee64174bfa34d55fbab7173da4'),('sites/all/modules/link/tests/link.validate.test','4fb3d9124767f43332f2e40bcca3aba98575dd1f6a286adfc8831607823986c5'),('sites/all/modules/link/views/link_views_handler_argument_target.inc','d77c23c6b085382c63e7dbce3d95afc9756517edcdc4cd455892d8333520d4c9'),('sites/all/modules/link/views/link_views_handler_filter_protocol.inc','e10a0d2de73bfa9a56fadbac023c6ac16022ced40c0444ab6ffed1b5d7ea7358'),('sites/all/modules/menu_breadcrumb/menu_breadcrumb.install','2bbdb94dec4dc305afffa48559ef5cf24533d30d4a483ac83e758689cf2f42a7'),('sites/all/modules/message/includes/message.admin.inc','ec0fddf9bc629337c5dd8672c65b37324b0c9b688d78eb89ff63cde57bca80f6'),('sites/all/modules/message/includes/message.exception.inc','7c7950a893f902d50d6aeefd05e1ec084dfe41df2912e6f56241ef73c84668b0'),('sites/all/modules/message/includes/message.message.inc','9437704e201bdba6c71f9c50c0ed7fd04657adce087f2e3ae1e40cec2dd32ac7'),('sites/all/modules/message/includes/message.message_type.inc','80789e0cabbddeb12de905cc160886ace94f1989956742a6b5876750f5ab14cf'),('sites/all/modules/message/includes/message.message_type_category.inc','e3003666ff21b306fdf96ec7f13fd98317ea4f91e254876b90a6a2f45f60289a'),('sites/all/modules/message/includes/views/handlers/message_handler_field_message_render.inc','e8d66cb1cc14bdb9442594223c23649a06bfd4cb4814d56b5bf0a97792b3183d'),('sites/all/modules/message/includes/views/handlers/message_handler_filter_message_type.inc','db9cdd073a09b4662995f44fc669199a157786645fb50793ead3e0a913fb69fd'),('sites/all/modules/message/includes/views/handlers/message_handler_filter_message_type_category.inc','90aeb149c1c11489700f57bad2b7c2b19ffb3e77d685e889c09a3c7c367be311'),('sites/all/modules/message/includes/views/message.views.inc','48294f4ea5a0316f3e6ca8aa3f338d75783930984e51a69327160af12206c5d5'),('sites/all/modules/message/message.info.inc','1a9f106759c0835c7f0b339e3319e30a7b002392374757c76388f8b39cb79ca1'),('sites/all/modules/message/message.test','6e854506307d3567997abba3e22f779f71fc5191c921de791105d2adfc2f76ca'),('sites/all/modules/module_filter/css/module_filter.css','2813d8a7a9cca73ac2e7a5e3979d6e913f78cc36dbfe5e21c412eeb9a8fe97fc'),('sites/all/modules/module_filter/css/module_filter_tab.css','4e505f0aa9e9ba6306f0c1fe900ec5efcdd6de983748e4eee9491ebb03d85c63'),('sites/all/modules/module_filter/js/module_filter.js','4bb9003d81e4ad063abb22e6820fd35072bb1bcb6a340c7d8034bbc6c5e81b95'),('sites/all/modules/module_filter/js/module_filter_tab.js','bb0ce3b3bddc0255175b2e3d0700206b1c10b645c7382d22ff7b897fedc9e750'),('sites/all/modules/module_filter/module_filter.admin.inc','15784b28ac9e77ba6e299b1a60b5d3176dc6fa3ecaba50dc60a1e0c56f925192'),('sites/all/modules/module_filter/module_filter.install','46a1159d2f88bb2db41a8c4c1378c6385d02d0aa689cc2940ecd4924d508c9f5'),('sites/all/modules/module_filter/module_filter.module','31d1273dbf8896a75abaf22a851b20f3653defacac9432ef5d430dc520998560'),('sites/all/modules/module_filter/module_filter.theme.inc','2f052942faf0585ee84dc90cf88152450a7a0cc09b958dd59526970d363ffe3a'),('sites/all/modules/pathauto/pathauto.test','9204240a755119e02eae68c77e7b9ab816747423ccaaf51742231fbaef1f604f'),('sites/all/modules/quicktabs/includes/quicktabs_style_plugin.inc','4d71357780815656b4bff9d6b6b96e07816a9181e695e878f6e83b474902172e'),('sites/all/modules/quicktabs/plugins/QuickAccordion.inc','772c06425494bb7a51aa1de65e89013989364728eab54ee9fdf8e3744750aca7'),('sites/all/modules/quicktabs/plugins/QuickBlockContent.inc','aa53a853b6d5797780e1beadba3c05672df0a9d083e38aec385ca5de89c5b1ab'),('sites/all/modules/quicktabs/plugins/QuickCallbackContent.inc','416757802a0eb6a4f1564969a7d8bebb6f065ce0b734869d276984f3c495941d'),('sites/all/modules/quicktabs/plugins/QuickNodeContent.inc','38d65ad29e0341deb46d8608ae96515159358b2b8efe9bd546f136bb7be2da4a'),('sites/all/modules/quicktabs/plugins/QuickQtabsContent.inc','1410b450a8b184edfee7dccaefe2e96daf792bee9f4139a200587c4aedf8d46d'),('sites/all/modules/quicktabs/plugins/QuickQuicktabs.inc','1899867e6cf9312992267e7a317a148a6c15e14f6b871bf8bf162ff392269257'),('sites/all/modules/quicktabs/plugins/QuickUiTabs.inc','dec59e70103449784824e96fac41ed00eb8d22b17c3e44508ff8fc101e0281ff'),('sites/all/modules/quicktabs/plugins/QuickViewContent.inc','1f7d7615198538a12e823d129dc88ed5ad6e5c9744ecd22b2f657d5b5f4f3042'),('sites/all/modules/quicktabs/quicktabs.classes.inc','faa28c5c30053d2de019cab4dd887df9bc9469cdf18cf801d5afd8a6433b9e06'),('sites/all/modules/quicktabs/quicktabs.module','99e5180f596b704b5b479ba746a85aacd7c531a75f86140a1b8a952468c0304d'),('sites/all/modules/quicktabs/tests/quicktabs.test','d23f9d8cd89eff02a2a9711858951df1d0c60b13d38ba0fba97b1b56b8104a86'),('sites/all/modules/remember_me/remember_me.install','aadbf30561bcf56311632bb07edef405ec5101836e32e6cea785c7bbd45394e5'),('sites/all/modules/remember_me/remember_me.module','10a69767a17fdd81d5fde5f2ea0c378ce8eaa901c22ef2515c3f6b2a01be7e7f'),('sites/all/modules/sharethis/views/sharethis_handler_field_link.inc','c9af08cd787bf6300cc2836ac5432ff8776b6b6f5dbe997df3cf6038fc1dbaa0'),('sites/all/modules/strongarm/strongarm.admin.inc','5e50651c629ba2bdc71f73051cd876e91f76d523d6fd4ad1d6d66d1f092d3af4'),('sites/all/modules/strongarm/strongarm.install','d198563f5fcc7a1b4b9a98c1ed8439d48a6d7d10577cc966d3a55edd06a4a365'),('sites/all/modules/strongarm/strongarm.module','3e338f1099aff4e501ad99d76bb179aafcc086760d222bbc1bd89fef0bb1c8e5'),('sites/all/modules/taxonomy_menu/taxonomy_menu.batch.inc','e7cf6aa0476da11b29910a108faca5d636e4582340d789ebe9049f3e1f944a5d'),('sites/all/modules/taxonomy_menu/taxonomy_menu.database.inc','ecb8a8713bcb2ec2aec7062137e2bc51dc819bb695da608b03be7be5472902c2'),('sites/all/modules/taxonomy_menu/taxonomy_menu.install','b1b3b627fbc2c55f2dc004d62f2192c51884b4f2667cce63b37da53bb1c9c781'),('sites/all/modules/taxonomy_menu/taxonomy_menu.module','0ee1bc326987ffa350b04287e8e9a20821ad8d8ad2129bdb147a9392c7599705'),('sites/all/modules/taxonomy_menu/taxonomy_menu.test','3a99877ef3d1fb93e110e268ea52771054425ce075e3ad11511ab93bd5728fb6'),('sites/all/modules/token/token.test','79c44cc6bb46caa41eaf371df9c77d7ef98bbee7d96c04ca1039375dc6674961'),('sites/all/modules/variable/includes/forum.variable.inc','84ab5992d648c704b2ae6d680cf8e02d3150cccd8939170f7e8fd82ac054b516'),('sites/all/modules/variable/includes/locale.variable.inc','27173d9c9e526a8ba88c5f48bf516aaac59ad932b64ef654621bc11f1ccd9f7a'),('sites/all/modules/variable/includes/menu.variable.inc','bc776840ee32060a9fda616ca154d3fd315461fbe07ce822d7969b79fccd8160'),('sites/all/modules/variable/includes/node.variable.inc','596064101f8fbd3affdb61ca1240354ce0b51778601a8b02c021a1150bbf4e06'),('sites/all/modules/variable/includes/system.variable.inc','909bae0f1e3a4d85c32c385a92a58c559576fb60fd13a0e4f71127eee27afd3e'),('sites/all/modules/variable/includes/taxonomy.variable.inc','7792f07f8ea088cd8c3350e16f4cacef262c319c2e605dd911f17999a872f09e'),('sites/all/modules/variable/includes/translation.variable.inc','3e4e82f779986bfb32987d6b27bdab9f907ba5e18841847f138a20c42cf725d4'),('sites/all/modules/variable/includes/user.variable.inc','b80094c1db0037f396f197bdd70c19e87afe76f4378c5c6089c4199af3bcb03a'),('sites/all/modules/variable/variable.test','a6614814c24aee5ae1d2f2f8c23c08138466c41a82e57ee670e070d7cdd6e4b2'),('sites/all/modules/video_embed_field/video_embed_field.migrate.inc','f20af0c10bfad5d51decd0a282ef3d0d643f4963797a352f4367ff0b2e47baff'),('sites/all/modules/video_embed_field/views/handlers/views_embed_field_views_handler_field_thumbnail_path.inc','d46f3e07dc50b76b8fd8b3719432746bf6454fe2aa827090d0753148650254e7'),('sites/all/modules/views/handlers/views_handler_area.inc','95d4374c805c057c9855304ded14ce316cdee8aca0744120a74400e2a8173fae'),('sites/all/modules/views/handlers/views_handler_area_messages.inc','de94f83a65b47d55bbb4949fcf93dd4ad628a4a105cea2b47cdc22593f3e5925'),('sites/all/modules/views/handlers/views_handler_area_result.inc','f406d7e4409545ffea2e56c9a10f87f20adef2276c6d6bbc8003885cccc8ca3b'),('sites/all/modules/views/handlers/views_handler_area_text.inc','531d0ac3b64206970593762df0abac60524f607253c3af876dd66ba747786dce'),('sites/all/modules/views/handlers/views_handler_area_text_custom.inc','35b702060c192b0adf6601ed437d0a02effd3accb71c07d6156013c8be9d5a15'),('sites/all/modules/views/handlers/views_handler_area_view.inc','e604b5716d9ea202ab0b8e51d2bd0a4a8eeab461db0a74bf37745d6cbba25c41'),('sites/all/modules/views/handlers/views_handler_argument.inc','1f0498d1878e331f59b9f0cc87b67df330437c736e565a05fe1a14ab65ec3f26'),('sites/all/modules/views/handlers/views_handler_argument_date.inc','1b423d5a437bbd8ed97d0bfb69c635d36f15114699a7bc0056568cc87937477d'),('sites/all/modules/views/handlers/views_handler_argument_formula.inc','5a29748494a7e1c37606224de0c3cac45566efe057e4748b6676a898ac224a61'),('sites/all/modules/views/handlers/views_handler_argument_group_by_numeric.inc','b8d29f27592448b63f15138510128203d726590daef56cf153a09407c90ec481'),('sites/all/modules/views/handlers/views_handler_argument_many_to_one.inc','b2de259c2d00fe7ed04eb5d45eb5107ce60535dd0275823883cc29b04d1a3974'),('sites/all/modules/views/handlers/views_handler_argument_null.inc','26699660fd0915ec078d7eb35a93ef39fd53e3a2a4841c0ac5dbf0bb02207bee'),('sites/all/modules/views/handlers/views_handler_argument_numeric.inc','ae23d847fa0f1e92baec32665a8894e26660999e338bebffb49ee42daac5a063'),('sites/all/modules/views/handlers/views_handler_argument_string.inc','f8fe4daf0a636cc93d520a0d5ff212840d8bdaa704ddc3c59a24667f341ed3a1'),('sites/all/modules/views/handlers/views_handler_field.inc','3d059d737e738436a15651f9ac8374f460a71eb569619ba0a8a14a55a3efc87e'),('sites/all/modules/views/handlers/views_handler_field_boolean.inc','dc00b916a223935e05f51d94a2dffbaf430b162517072f7c2122332af41e8fc2'),('sites/all/modules/views/handlers/views_handler_field_contextual_links.inc','2f54701c9f71a4a525e724a6787b5e0089a3c38e426d1925bf8344d017d571bf'),('sites/all/modules/views/handlers/views_handler_field_counter.inc','865a5ad7df830dae9e167709446e66cebf3e32e91ec05b5c2b887c96d0d6b0d8'),('sites/all/modules/views/handlers/views_handler_field_ctools_dropdown.inc','a78c424ef884ae9878c0b140d532bdf3b116fdc0e8a7cd519848c675d5b1a5a6'),('sites/all/modules/views/handlers/views_handler_field_custom.inc','a3d25fc20401ae0a1af4b7d6e83376a5b7dc18ab0aed17a3c6d81e2314cf19f8'),('sites/all/modules/views/handlers/views_handler_field_date.inc','79cb6583981104d70d20393fe62281c749680f375cb67355635ef00688258934'),('sites/all/modules/views/handlers/views_handler_field_entity.inc','909ab36aff896ad8fa4306d95a052172ec27e471ab385a035fcadef8d019e0f9'),('sites/all/modules/views/handlers/views_handler_field_links.inc','331a7c8e68a9a94a41a0d7e3e2b6a5c8436792cf244b409ffd732f9cbbab3642'),('sites/all/modules/views/handlers/views_handler_field_machine_name.inc','df2fe47cf9c6d2e7de8627c08da809fb60883c38697340966f303c223e22aee4'),('sites/all/modules/views/handlers/views_handler_field_markup.inc','a0c652fdf47f7efe35bbf2371f00e230409fe90ea0038eb101bf0c93ae0718e9'),('sites/all/modules/views/handlers/views_handler_field_math.inc','08c9fb88b20ca346ee3dc29773b2341ea294ba85b659dbd8c1cc92a9ddf900e8'),('sites/all/modules/views/handlers/views_handler_field_numeric.inc','1e36f9d55b4cfeb268068e5c9bd6f326999c04191485d3db4610e94e6f57fad9'),('sites/all/modules/views/handlers/views_handler_field_prerender_list.inc','0fe605bf457886fbca5f041a422fc51c6a1927654dcd06cbfc619496fe57de0e'),('sites/all/modules/views/handlers/views_handler_field_serialized.inc','ad3d82a9f37ae4c71a875526c353839da2ff529351efc7861f8b7c9d4b5a47db'),('sites/all/modules/views/handlers/views_handler_field_time_interval.inc','280d569784312d19dabfb7aeb94639442ae37e16cba02659a8251de08a4f1de2'),('sites/all/modules/views/handlers/views_handler_field_url.inc','7ca57a8dcc42a3d1e7e7ec5defa64a689cb678073e15153ff6a7cafe54c90249'),('sites/all/modules/views/handlers/views_handler_filter.inc','4c8937c5b6399c42bb6659169f5c8563ca415fd7effab1ddeeebf2bb6b9a8011'),('sites/all/modules/views/handlers/views_handler_filter_boolean_operator.inc','f4ca59e4e1f91f219a1b33690a4ad412269946804fe7cacf24f2574b2c6d8599'),('sites/all/modules/views/handlers/views_handler_filter_boolean_operator_string.inc','0ddd32cda535112c187de1c062797849ff90d9b312a8659056e76d2d209f694a'),('sites/all/modules/views/handlers/views_handler_filter_combine.inc','802f033bba6a9965896b02e3c3e0ea4493e4be282f2c5444ebbeec7e8a478072'),('sites/all/modules/views/handlers/views_handler_filter_date.inc','fb63877ecfa64f2be8557a21dcf34e28b59c4a9c5f561f55738162d2301c4aa1'),('sites/all/modules/views/handlers/views_handler_filter_entity_bundle.inc','02db977a67a09f70bdc8e2bbc46a05fff8a6d8bd6423308c95418476e84714a3'),('sites/all/modules/views/handlers/views_handler_filter_equality.inc','2100cdd7f5232348adae494c5122ba41ff051eee0a8cc14aeaf6a66202cb7ed1'),('sites/all/modules/views/handlers/views_handler_filter_fields_compare.inc','e116c3796f1bd409b150f5ab896b9bab956d6e71a82e5770ed6fde44605751b2'),('sites/all/modules/views/handlers/views_handler_filter_group_by_numeric.inc','9401c4c0fe0d678898e5288ef8152784a12e0743df21dec15457353eb2cdb01d'),('sites/all/modules/views/handlers/views_handler_filter_in_operator.inc','8fd7f075468bddde5c4208b1c3a6105f8fea0ac0c214452a37c00fc2f3453a7d'),('sites/all/modules/views/handlers/views_handler_filter_many_to_one.inc','b4a415c2824195d3d7d0e37ada9d69ebec0b9cd833ebcac2439efc20aac15595'),('sites/all/modules/views/handlers/views_handler_filter_numeric.inc','8a999227d17674a70381ab8b45fbdc91269a83a45e5f7514607ed8b4a5bf6a9f'),('sites/all/modules/views/handlers/views_handler_filter_string.inc','140006335ac5b19b6253b431afde624db70385b9d22390b8c275296ae469cc7b'),('sites/all/modules/views/handlers/views_handler_relationship.inc','4fefdb6c9c48b72dcfe86484123b97eb5f5b90b6a440d8026d71f74dccbd1cd6'),('sites/all/modules/views/handlers/views_handler_relationship_groupwise_max.inc','47dcfe351159b10153697c17b3a92607edb34a258ba3b44087c947b9cc88e86f'),('sites/all/modules/views/handlers/views_handler_sort.inc','06aab8d75f3dce81eb032128b8f755bfff752dcefc2e5d494b137bca161fdefa'),('sites/all/modules/views/handlers/views_handler_sort_date.inc','d7e771abf74585bd09cc8e666747a093f40848b451de8ba67c8158317946f1b2'),('sites/all/modules/views/handlers/views_handler_sort_group_by_numeric.inc','4ba1c38c9af32789a951b8f9377e13631ae26bf1dac3371b31a37ead25b32eb8'),('sites/all/modules/views/handlers/views_handler_sort_menu_hierarchy.inc','ccd65ea3b3270366b7175e2cd7cc9167a09c27e1486949e4a05495ff5c7be5c1'),('sites/all/modules/views/handlers/views_handler_sort_random.inc','05a00c3bf76c3278ae0ce39a206a6224089faf5ac4a00dd5b8a558f06fab8e46'),('sites/all/modules/views/includes/base.inc','5ad8155dbc31cc4460b65747d99b70a64a83f6fefa00231c8d965293a7a183ee'),('sites/all/modules/views/includes/handlers.inc','5cab753c012d357ce2a10b645eca4254b3647fdfe2452510eee37c8a12639a14'),('sites/all/modules/views/includes/plugins.inc','11c03b1c69be7e9969ec0665b07ddfe170c9505f8d4e862cb27f1232a2a4240e'),('sites/all/modules/views/includes/view.inc','99e60c217d6dc781ec48ae8fc841e636eee31d977936e1980a34eca28734ad2e'),('sites/all/modules/views/modules/aggregator/views_handler_argument_aggregator_category_cid.inc','97acf41d6694fd4451909c18b118f482db9f39aa4b8c5cfa75d044d410c46012'),('sites/all/modules/views/modules/aggregator/views_handler_argument_aggregator_fid.inc','c37def91d635b01db36809141d147d263cc910895e11c05e73d703e86b39fd43'),('sites/all/modules/views/modules/aggregator/views_handler_argument_aggregator_iid.inc','344f2806344d9c6356f2e19d297522f53bab7a4cebdf23c76d04c85c9e0a0d8e'),('sites/all/modules/views/modules/aggregator/views_handler_field_aggregator_category.inc','252b30b832d8c0097d6878f5d56beecfc8cc1fc7cc8b5a4670d8d95a80b4f17d'),('sites/all/modules/views/modules/aggregator/views_handler_field_aggregator_title_link.inc','1bb18967b11f2f4de62075d27e483f175b5e3431622c2e5e8292afcd000beadf'),('sites/all/modules/views/modules/aggregator/views_handler_field_aggregator_xss.inc','2db2e1f0500e0a252c7367e6a92906870b3247f9d424f999c381368ee2c76597'),('sites/all/modules/views/modules/aggregator/views_handler_filter_aggregator_category_cid.inc','7c7c0690c836ac1b75bca3433aca587b79aec3e7d072ce97dc9b33a35780ad4f'),('sites/all/modules/views/modules/aggregator/views_plugin_row_aggregator_rss.inc','591e5bb7272e389fe5fc2b563f8887dbc3674811ffbb41333d36a7a9a1859e56'),('sites/all/modules/views/modules/book/views_plugin_argument_default_book_root.inc','bd3bd9496bf519b1688cf39396f3afa495a29c8190a3e173c0740f4d20606a53'),('sites/all/modules/views/modules/comment/views_handler_argument_comment_user_uid.inc','5e29f7523010a074bda7c619b24c5d31e0c060cdbe47136b8b16b2f198ed4b4a'),('sites/all/modules/views/modules/comment/views_handler_field_comment.inc','a126d690cc5bf8491cb4bee4cc8237b90e86768bebbbecb8a9409a3c1e00fa9e'),('sites/all/modules/views/modules/comment/views_handler_field_comment_depth.inc','1dc353a31d3c71c67d0b3e6854d9e767e421010fbbf6a8b04a14035e5f7c097f'),('sites/all/modules/views/modules/comment/views_handler_field_comment_link.inc','1f7382f7cb05c65a7cba44e4cd58022bbc6ce5597b96228d1891d7720510bf0e'),('sites/all/modules/views/modules/comment/views_handler_field_comment_link_approve.inc','f6db8a0b4dd9fffba9d8ecb7b7363ba99d3b2dc7176436a0a6dd7a93195a5789'),('sites/all/modules/views/modules/comment/views_handler_field_comment_link_delete.inc','905a4cb1f91a4b40ee1ca1d1ded9958ae18e82286589fec100adb676769b1fe9'),('sites/all/modules/views/modules/comment/views_handler_field_comment_link_edit.inc','8139c932cde20f366a3019111c054b1ed00dbc0c40634b91239b400243b7723a'),('sites/all/modules/views/modules/comment/views_handler_field_comment_link_reply.inc','8807884efb840407696c909b9d5d07f60bde9d7f385a59eca214178ce5369558'),('sites/all/modules/views/modules/comment/views_handler_field_comment_node_link.inc','64746ff2b80a5f8e83b996a325c3d5c8393934c331510b93d5815ea11c1db162'),('sites/all/modules/views/modules/comment/views_handler_field_comment_username.inc','1ce3fa61b3933a3e15466760e4c5d4a85407ba4c8753422b766fc04395fa4d02'),('sites/all/modules/views/modules/comment/views_handler_field_last_comment_timestamp.inc','30c55ec6d55bf4928b757f2a236aab56d34a8e6955944a1471e9d7b7aed057c0'),('sites/all/modules/views/modules/comment/views_handler_field_ncs_last_comment_name.inc','82025f3ad22b63abc57172d358b3f975006109802f4a5ecac93ce3785c505cae'),('sites/all/modules/views/modules/comment/views_handler_field_ncs_last_updated.inc','facfbc5defd843f4dfb60e645f09a784234d87876628c8de98d2dfa6bb98a895'),('sites/all/modules/views/modules/comment/views_handler_field_node_comment.inc','0cf9e8fb416dca35c3b9df3125eb3a8585f798c6a8f8d0e1034b1fccb5cec38b'),('sites/all/modules/views/modules/comment/views_handler_field_node_new_comments.inc','e0830d1f70dea473e46ab2b86e380ef741b2907f033777889f812f46989f2ff7'),('sites/all/modules/views/modules/comment/views_handler_filter_comment_user_uid.inc','f526c2c4153b28d7b144054828261ba7b26566169350477cd4fb3f5b5f280719'),('sites/all/modules/views/modules/comment/views_handler_filter_ncs_last_updated.inc','9369675dfee24891fe19bddf85a847c275b8127949c55112ae5cb4d422977d24'),('sites/all/modules/views/modules/comment/views_handler_filter_node_comment.inc','70706c47bad9180c2426005da6c178ed8d27b75b28cb797ca2a1925a96dcef09'),('sites/all/modules/views/modules/comment/views_handler_sort_comment_thread.inc','a64bc780cba372bd408f08a5ea9289cdf3d40562bdf2f7320657be9a9f6c7882'),('sites/all/modules/views/modules/comment/views_handler_sort_ncs_last_comment_name.inc','9f039e8b8a046c058fda620804e3503be7b3e7e3e4119f0b015ccbae0922635b'),('sites/all/modules/views/modules/comment/views_handler_sort_ncs_last_updated.inc','fa8b9c3614ad5838aa40194940d9dc6935175a16e141ac919f40e74a7428c4e3'),('sites/all/modules/views/modules/comment/views_plugin_row_comment_rss.inc','96f651234e30a3aff805ae9a524c99813a286bf75b5a9fd8da2d7d4fbec50810'),('sites/all/modules/views/modules/comment/views_plugin_row_comment_view.inc','82d7296fa3109ca170f66f6f3b5e1209af98a9519bb5e4a2c42d9fc0e95d7078'),('sites/all/modules/views/modules/contact/views_handler_field_contact_link.inc','ec783b215a06c89c0933107a580c144051118305dd0129ac28a7fea5f95a8fd5'),('sites/all/modules/views/modules/field/views_handler_argument_field_list.inc','eff5152a2c120425a2a75fe7dbcb49ed86e5d48392b0f45b49c2e7abee9fa72b'),('sites/all/modules/views/modules/field/views_handler_argument_field_list_string.inc','534af91d92da7a622580ab8b262f9ef76241671a5185f30ba81898806c7b7f15'),('sites/all/modules/views/modules/field/views_handler_field_field.inc','94ff7382dba773fc637c777e20b810ae7d4aa4936fb0bc067e6a3824ba929d2d'),('sites/all/modules/views/modules/field/views_handler_filter_field_list.inc','3b55cd0a14453c95ebd534507ab842a8505496d0b7e4c7fcd61c186034c7322d'),('sites/all/modules/views/modules/field/views_handler_filter_field_list_boolean.inc','d33035e141ca686b3f18da1e97adaa1ff8e5d1db266340d3030e873a744685e2'),('sites/all/modules/views/modules/field/views_handler_relationship_entity_reverse.inc','060035c5430c81671e4541bcf7de833c8a1eb3fa3f3a9db94dd3cebfa4299ef1'),('sites/all/modules/views/modules/filter/views_handler_field_filter_format_name.inc','fc3f074ffb39822182783a8d5cf2b89ffcc097ccbb2ed15818a72a99e3a18468'),('sites/all/modules/views/modules/locale/views_handler_argument_locale_group.inc','c8545411096da40f48eef8ec59391f4729c884079482e3e5b3cdd5578a1f9ad7'),('sites/all/modules/views/modules/locale/views_handler_argument_locale_language.inc','a1b6505bb26e4b3abce543b9097cd0a7b8cddf00bf1e49fbba86febebb0f4486'),('sites/all/modules/views/modules/locale/views_handler_field_locale_group.inc','5b62afe18f92ee4a5fb49eb0995e65b4744bbe3b9c24ffe8f6c21f3191c04afc'),('sites/all/modules/views/modules/locale/views_handler_field_locale_language.inc','0cc08bd2d42e07f26e7acc92642b36f0ac62bf23ee9ba3fd21e6cab9a80e9f72'),('sites/all/modules/views/modules/locale/views_handler_field_locale_link_edit.inc','3883d3f37030d6d8e397e79ccb99ec3cb715ba7a789510f4b79b7515e314e7ae'),('sites/all/modules/views/modules/locale/views_handler_field_node_language.inc','a6ccdb6c1c4df3b4fd31b714f5aa4ac99771ffce63439d6c5de6c0ae2f09a2c1'),('sites/all/modules/views/modules/locale/views_handler_filter_locale_group.inc','40fbc041bab64f336f59d1e0593f184b879b2a0c9e2a6050709bdc54cceb2716'),('sites/all/modules/views/modules/locale/views_handler_filter_locale_language.inc','3433893d988aad36b918dd6214f5258b701506bc9c0c6a72fd854a036b635e20'),('sites/all/modules/views/modules/locale/views_handler_filter_locale_version.inc','9337ea5216784ffc67a0aa45c946e65ad11fc40849189cc70911a81366b78620'),('sites/all/modules/views/modules/locale/views_handler_filter_node_language.inc','d7edea3f35891cc76aa3bb185b9c1404378623ea7fd214c2a1f0d824df12779a'),('sites/all/modules/views/modules/locale/views_handler_sort_node_language.inc','b7b70efcf7de1f4dee4722ac8aa16031f17d62e60b1b5772f9985cadf91e4415'),('sites/all/modules/views/modules/node/views_handler_argument_dates_various.inc','80ee0e32fd48de1fa9d91645f27f7f26e8700acd3b1120a6d414bb1a794f6d0e'),('sites/all/modules/views/modules/node/views_handler_argument_node_language.inc','7ee3ba02bddaa6aeef9961cdf6af7bb386fc2b12529f095b28520bb98af51775'),('sites/all/modules/views/modules/node/views_handler_argument_node_nid.inc','11c5b62413ffd1b2c66d4b60a2fe21cf6eb839ae40d4ef81c7a938c5be3e30de'),('sites/all/modules/views/modules/node/views_handler_argument_node_type.inc','9e21b4cc4ae861f58c804ea7e2c17fbc5dd2a7938b9abfeb54437b531fc95e6e'),('sites/all/modules/views/modules/node/views_handler_argument_node_uid_revision.inc','675c99f8da9748ac507e202f546914bee3ed4065f6ce83a23a2aaafdaefd084e'),('sites/all/modules/views/modules/node/views_handler_argument_node_vid.inc','7e5da5594a336c1d0f4cf080ab3fcd690e0de1ee6b5e1830b5fb76a46bced19c'),('sites/all/modules/views/modules/node/views_handler_field_history_user_timestamp.inc','7d6d9c8273d317ab908d4873a32086dbd5f78a2b2d07b7ed79975841a2cadea6'),('sites/all/modules/views/modules/node/views_handler_field_node.inc','99a0ef52b68e8913eb3563d5c47097c09e46c6493fcb006f383c6f6798edb7fc'),('sites/all/modules/views/modules/node/views_handler_field_node_link.inc','26d8309a3a9140682d7d90e4d16ff664a3d7ce662af6ccbf75dc4c493515d7d9'),('sites/all/modules/views/modules/node/views_handler_field_node_link_delete.inc','3eeed8c9ffc088ee28b8ffaa5e2b084db24284acc4d1b2e69f90c96cc889016d'),('sites/all/modules/views/modules/node/views_handler_field_node_link_edit.inc','28f8c3b7d3d60c31fec3cdf81c84cfbb20f492220457694a0e150c3ddee030c0'),('sites/all/modules/views/modules/node/views_handler_field_node_path.inc','f392fde21e434fd40fc672546ef684780179d91827350ba9c348bb1cc5924727'),('sites/all/modules/views/modules/node/views_handler_field_node_revision.inc','3f510d58acaa8f844292b86c388cb1e78eac8c732bb5e7c9e92439c425710240'),('sites/all/modules/views/modules/node/views_handler_field_node_revision_link.inc','ace72f296cf4a4da4b7dd7b303532aebf93b6b1c18a5d30b51b65738475e3889'),('sites/all/modules/views/modules/node/views_handler_field_node_revision_link_delete.inc','0a36602f080c4ef2bb5cb7dbddc5533deab7743c2fbf3bd88b9e478432cac7fb'),('sites/all/modules/views/modules/node/views_handler_field_node_revision_link_revert.inc','80ddc7f0c001fde9af491bb22d6044b85324fe90bea611fc3822408fd60008fa'),('sites/all/modules/views/modules/node/views_handler_field_node_type.inc','f8f39c6f238f837270d1b2e42e67bf9ab400a37fe24246c8b86dfcfacc1c4fd9'),('sites/all/modules/views/modules/node/views_handler_field_node_version_count.inc','1298f7f7ee4b6e6e2957b266fbb7c63e102b9d7e9ccca8d5a86592736bce9493'),('sites/all/modules/views/modules/node/views_handler_filter_history_user_timestamp.inc','2970f270e071cad079880e9598d9f7b71d4dd2a2a42a31cd4489029a3cafe158'),('sites/all/modules/views/modules/node/views_handler_filter_node_access.inc','ca625167c8928f1c5b354c27c120ed9b19c1df665dc3b02ed6d96b58194d6243'),('sites/all/modules/views/modules/node/views_handler_filter_node_status.inc','f7099a59d3f237f2870ecb6b0b5e49dd9d785b1085e94baf55687251e7f3231b'),('sites/all/modules/views/modules/node/views_handler_filter_node_type.inc','6842082e7b6e131d6e002e627e6b4490b93ca6ffe7fc0b158d31843217c8c929'),('sites/all/modules/views/modules/node/views_handler_filter_node_uid_revision.inc','2cfe9ba95e5ea8c240a57cfa1bed58385cbfed0c7f35e3d8c4da6d873b5a61fa'),('sites/all/modules/views/modules/node/views_handler_filter_node_version_count.inc','de61f3547604e5905486cdae5f5e94d1a45bdac4d3c43157193dd6fe0dd6473c'),('sites/all/modules/views/modules/node/views_handler_sort_node_version_count.inc','ce2a392319ebed3dbb2b660f3d6f4c6690b1cd46cf6b1c01802f12158114c4c4'),('sites/all/modules/views/modules/node/views_plugin_argument_default_node.inc','7fb79c8f4adb9bcef7c7da4bf4046fe3490e16c244f6ab96fdca97a8567315ff'),('sites/all/modules/views/modules/node/views_plugin_argument_validate_node.inc','f10d3f4081eed5ca32c41b67e9a0e6f35b2f8ba2cd7897230cb5a680b410a6de'),('sites/all/modules/views/modules/node/views_plugin_row_node_rss.inc','1e55454684102fad08c947695c370a890a22ea22c3c9aca3207f2299aa3daf7e'),('sites/all/modules/views/modules/node/views_plugin_row_node_view.inc','6b7dfe1a3b16eae682b2664a48bb6af16f040b4ca2c8e71f8b771a0577a66bae'),('sites/all/modules/views/modules/profile/views_handler_field_profile_date.inc','e206509ef8b592e602e005f6e3fa5ba8ef7222bdb5bacd0aaeea898c4001e9b0'),('sites/all/modules/views/modules/profile/views_handler_field_profile_list.inc','da5fa527ab4bb6a1ff44cc2f9cec91cf3b094670f9e6e3884e1fedce714afe6f'),('sites/all/modules/views/modules/profile/views_handler_filter_profile_selection.inc','758dea53760a1b655986c33d21345ac396ad41d10ddf39dd16bc7d8c68e72da7'),('sites/all/modules/views/modules/search/views_handler_argument_search.inc','9de18defd5d9320b6333dc496627657be1dd8ccb145dfc136a80f1bcee6e1f55'),('sites/all/modules/views/modules/search/views_handler_field_search_score.inc','711af637c864b775672d9f6203fc2da0902ed17404181d1117b400012aac366f'),('sites/all/modules/views/modules/search/views_handler_filter_search.inc','aa2ae23905b84b77ee6042f8f26542eedd7422bdd7518255a289db7da0f6400b'),('sites/all/modules/views/modules/search/views_handler_sort_search_score.inc','9d23dd6c464d486266749106caec1d10cec2da1cc3ae5f907f39056c46badbdf'),('sites/all/modules/views/modules/search/views_plugin_row_search_view.inc','bc25864154d4df0a58bc1ac1148581c76df36267a1d18f8caee2e3e1233c8286'),('sites/all/modules/views/modules/statistics/views_handler_field_accesslog_path.inc','7843e5f4b35f4322d673b5646e840c274f7d747f2c60c4d4e9c47e282e6db37d'),('sites/all/modules/views/modules/statistics/views_handler_field_node_counter_timestamp.inc','a1de51345d268dc0f080104ff9ae4c9ca1f7a2dd45560a59630b2bb03bdc54c9'),('sites/all/modules/views/modules/statistics/views_handler_field_statistics_numeric.inc','b46b6b14e14631941ac2dc9baf0b1290c148f42801f05cb419f84a2091d03e40'),('sites/all/modules/views/modules/system/views_handler_argument_file_fid.inc','e9bf1fdf12f210f0a77774381b670c77ee88e7789971ce732b254f6be5a0e451'),('sites/all/modules/views/modules/system/views_handler_field_file.inc','0fff4adb471c0c164a78f507b035a68d41f404ab10535f06f6c11206f39a7681'),('sites/all/modules/views/modules/system/views_handler_field_file_extension.inc','768aa56198c7e82327391084f5dd27d7efdb8179ff6b8c941f892fe30469a0da'),('sites/all/modules/views/modules/system/views_handler_field_file_filemime.inc','bdd7f1255f3000f7f2900341d4c4ca378244b96390ef52a30db2962d017b61a4'),('sites/all/modules/views/modules/system/views_handler_field_file_status.inc','bfb0b9d796a4dbf95c4bb7a3deef7724bcda9e0d9067939b74ec787da934f2b0'),('sites/all/modules/views/modules/system/views_handler_field_file_uri.inc','350d7dde27ee97cb4279360374eb8633ce7fee115a109346bea85c2c4e3a68c2'),('sites/all/modules/views/modules/system/views_handler_filter_file_status.inc','9210a34795f9db36974525e718c91c03c28554da1199932791925d7c4a2f3b11'),('sites/all/modules/views/modules/system/views_handler_filter_system_type.inc','d27513703a75c4d8af79b489266cf4102a36e350c3d90404dab24403ab637205'),('sites/all/modules/views/modules/taxonomy/views_handler_argument_taxonomy.inc','8962fa76f1e03316932468b0fd805817af94726beb82bf9f4786e0c709264662'),('sites/all/modules/views/modules/taxonomy/views_handler_argument_term_node_tid.inc','e50f47ac64a93c2a43b6bd940119dee46b9f25f79f5d25a93fd0df7d707c93ab'),('sites/all/modules/views/modules/taxonomy/views_handler_argument_term_node_tid_depth.inc','5b2806fbad4a6cc104e733a3a0faf6eb1c19975930c67c4149fb3267976e0b7d'),('sites/all/modules/views/modules/taxonomy/views_handler_argument_term_node_tid_depth_join.inc','ca667646f99645c00e6dfb7eb52e2f54faf848be41c99af5caf2201dcd56926b'),('sites/all/modules/views/modules/taxonomy/views_handler_argument_term_node_tid_depth_modifier.inc','d85ebe68290239b25fc240451655b825325854e9707cf742fbd75de81e0f1aa7'),('sites/all/modules/views/modules/taxonomy/views_handler_argument_vocabulary_machine_name.inc','888647527bec3444b2d0a571a77900396d7c5e884bca04a2a3667a61f6377b5e'),('sites/all/modules/views/modules/taxonomy/views_handler_argument_vocabulary_vid.inc','bf4be783ef6899f004f4dbd06c1bf2cd6dbc322678c825eec36bee81d667e81f'),('sites/all/modules/views/modules/taxonomy/views_handler_field_taxonomy.inc','fcafbbf79b79829eff211aa69580aa746b6d21a29416758bd43e25b5433f9a02'),('sites/all/modules/views/modules/taxonomy/views_handler_field_term_link_edit.inc','3da63f6feb1fa3312853b54585d761d037dac8841b4c06e01e35463c9098064a'),('sites/all/modules/views/modules/taxonomy/views_handler_field_term_node_tid.inc','d7bb6f685b85de9f9cc87500b3e5a07493832f032d826e20700bbd1baa020a61'),('sites/all/modules/views/modules/taxonomy/views_handler_filter_term_node_tid.inc','6ecc68ee0efaaedd1ae8b290e587955a7d6c3ea361f671921167df55d353922e'),('sites/all/modules/views/modules/taxonomy/views_handler_filter_term_node_tid_depth.inc','0b05ec052dcc03081e20338808dda17beb0bdf869b0cfc1375ca96cfb758c22a'),('sites/all/modules/views/modules/taxonomy/views_handler_filter_term_node_tid_depth_join.inc','76d59ca83bdcb40493055829a9132646ed89478d7eb6e468db2d879e66e3794c'),('sites/all/modules/views/modules/taxonomy/views_handler_filter_vocabulary_machine_name.inc','f1787b436b914cfe5ca6f2575d4c0595f4f496795711d6e8a116a39986728b0a'),('sites/all/modules/views/modules/taxonomy/views_handler_filter_vocabulary_vid.inc','2a4d7dfbb6b795d217e2617595238f552bbea04b80217c933f1ee9978ceb7a0e'),('sites/all/modules/views/modules/taxonomy/views_handler_relationship_node_term_data.inc','0bfd4c7882054565fb4ff52cf5697fe8cffca69d24717ebc37e6eacc14fe2312'),('sites/all/modules/views/modules/taxonomy/views_plugin_argument_default_taxonomy_tid.inc','fc4c3ace525162fc922de581af0710c7d92dc355e9630040a29a5c3a6ab7f9af'),('sites/all/modules/views/modules/taxonomy/views_plugin_argument_validate_taxonomy_term.inc','8a9d828e5e4387d831172a5c658fac8ef584d843be6c95e9b4e357af6c8f97de'),('sites/all/modules/views/modules/tracker/views_handler_argument_tracker_comment_user_uid.inc','91f5b7e9537942eee7a1798906f772cb9806eebfdc201c54fcdecf027cd71d0f'),('sites/all/modules/views/modules/tracker/views_handler_filter_tracker_boolean_operator.inc','5efea908902052d68141017b6f29f17381e7bb8ebb6d88245471926f0a552207'),('sites/all/modules/views/modules/tracker/views_handler_filter_tracker_comment_user_uid.inc','05e07f74d1e3978afd4c80a9b4bd72444872b84a44949a512f1d3040ce28421c'),('sites/all/modules/views/modules/translation/views_handler_argument_node_tnid.inc','b0e3c87d3790cfa2e265f3d9700f2b3c2857932aa4b6e003e5d0114fc1b4d499'),('sites/all/modules/views/modules/translation/views_handler_field_node_link_translate.inc','27a1ac81b50d4807d9a1eff4c5dc8929e4472f9d363f70f5391a794db73424a2'),('sites/all/modules/views/modules/translation/views_handler_field_node_translation_link.inc','641ff25cd317bb803de2ace4bd23e8c5f5af5ba4ac38aab7be2fdc58fbb9e86a'),('sites/all/modules/views/modules/translation/views_handler_filter_node_tnid.inc','0942fd793740e3aec032a1abb7132f53788a9cdeaeb3d931cac908ac30b73950'),('sites/all/modules/views/modules/translation/views_handler_filter_node_tnid_child.inc','2a7a96d6caa4a99996549be0457bf40fa619731543a636d4573e55c190c64c7a'),('sites/all/modules/views/modules/translation/views_handler_relationship_translation.inc','9137c85f5ca309d4ee0d3243c470563a5853f5926b8cbd3e843438d4308c9516'),('sites/all/modules/views/modules/user/views_handler_argument_users_roles_rid.inc','72da80e7f3c6980da024d86f37ba3721021cc1ead2cfcc1ab9b27897b7b5077a'),('sites/all/modules/views/modules/user/views_handler_argument_user_uid.inc','a4af1bdc1ec5e40587c22c14e839980050baaa346c9d5934ef3f01794932cdc5'),('sites/all/modules/views/modules/user/views_handler_field_user.inc','1a2141524e43d86b52c7828fe6df61dd603ad433743c1139cfc5cc28ccb5ce74'),('sites/all/modules/views/modules/user/views_handler_field_user_language.inc','5a3da9e08ebeebbcb5abc6a9b16e0d380c5bb5c57b608afb540a3ca6dc1b2959'),('sites/all/modules/views/modules/user/views_handler_field_user_link.inc','5a0f35d5305a29816658385ecbd804bf43c92d4b3629fbe4bd9b8d0e9574b6ff'),('sites/all/modules/views/modules/user/views_handler_field_user_link_cancel.inc','b865881b15ce86b5a00f2892d3fc62f40131417527211275ff9a3d09d485750b'),('sites/all/modules/views/modules/user/views_handler_field_user_link_edit.inc','5d7c1155d9eccbd6b07c7446fe2b6a8848d6a500f508ac3779f16df56816f92b'),('sites/all/modules/views/modules/user/views_handler_field_user_mail.inc','b7355b704f19322afb4876cea27744367e20098d4ed973e480bf2baf1ddd111c'),('sites/all/modules/views/modules/user/views_handler_field_user_name.inc','3be11e273d7a0e8d1e1406b94ba651a6f545f9d48d94758495449b68487f4426'),('sites/all/modules/views/modules/user/views_handler_field_user_permissions.inc','ec37373524bf23ae107adda6b825570c550e6654c0f0956409fc58df2c860903'),('sites/all/modules/views/modules/user/views_handler_field_user_picture.inc','0103d136a91fb219fd981801301b7df00adf90617900ded08efbf6d7df04959b'),('sites/all/modules/views/modules/user/views_handler_field_user_roles.inc','ab5068c4f01a05c6511f7d4b973a77650d5b5c481d4a73f63b7a9b1ef9c0d138'),('sites/all/modules/views/modules/user/views_handler_filter_user_current.inc','7f70b7e3b3c10e75d95f54afc9c2fe2f1af9b7a9eab2308d2961b2588dc05845'),('sites/all/modules/views/modules/user/views_handler_filter_user_name.inc','5225e5d89051313e0e49ea833709bb4dc44369afeee970b0cfaf1818ababa22c'),('sites/all/modules/views/modules/user/views_handler_filter_user_permissions.inc','a72e8d02c1075cebfee33e5b046460eef9193b2a7c1d47ff130457e4485b6fe5'),('sites/all/modules/views/modules/user/views_handler_filter_user_roles.inc','3bb69fbc4e352ce8e4840ec78bdd0f1f29e8709097ce6b29cc2fedd2c74c023e'),('sites/all/modules/views/modules/user/views_plugin_argument_default_current_user.inc','11e729115350deffe46ebfe3a55281fa169a90e38a76c3a9d98f26c87900a22b'),('sites/all/modules/views/modules/user/views_plugin_argument_default_user.inc','fe567f009a8e20f402f104b157fd44c04d6bd886a39b2f3355104f644f905419'),('sites/all/modules/views/modules/user/views_plugin_argument_validate_user.inc','40d623b0a678fa7c292da92582f06449d0396341ab161069f0fe8d1086ab95da'),('sites/all/modules/views/modules/user/views_plugin_row_user_view.inc','6a6c1bfac677eb9ffd25870cd72939c903f2c92d6d18e3abc6c634ac153e5c2b'),('sites/all/modules/views/plugins/export_ui/views_ui.class.php','8cd921da4fc00f0441808c6d521fa9fdfc753976244518a001a6354975eb6fe8'),('sites/all/modules/views/plugins/views_plugin_access.inc','cc16bf7dc4c10eab382e948cfd91902ac1055514b627e3c50932376d3e3f1b91'),('sites/all/modules/views/plugins/views_plugin_access_none.inc','8e0a6b706c60abf63ab84d8624567ca12a5b80ad293e4334790065fbe6fa14d4'),('sites/all/modules/views/plugins/views_plugin_access_perm.inc','1807a9c91485a5abd3fb2f6590ed4bc185fdabe308db37b169be8abdfc30cab2'),('sites/all/modules/views/plugins/views_plugin_access_role.inc','8784836ea87ec6b0974125ed95ed6bbf6fdf91624f496f22c28e9229c695068d'),('sites/all/modules/views/plugins/views_plugin_argument_default.inc','43e593760f0e8f031f2e7b861385caa5e39f37de400fe4595925288c78f52f23'),('sites/all/modules/views/plugins/views_plugin_argument_default_fixed.inc','daaa3b59b54cbb11e411e010303f67a51348bb97a4e06997b475f4c41e91c4e0'),('sites/all/modules/views/plugins/views_plugin_argument_default_php.inc','7a133b603294bfe498bfdeb50fade0b6e3cf8862270376067d86f69e7dc50eb8'),('sites/all/modules/views/plugins/views_plugin_argument_default_raw.inc','4318e0dfa56f167183453cf8cd913f3b7ee539b77a096507905e36db12ded97e'),('sites/all/modules/views/plugins/views_plugin_argument_validate.inc','2ada4fdc59b366f33209c0cfc515b06e765b487091760cfa22e94ca1c028c9cb'),('sites/all/modules/views/plugins/views_plugin_argument_validate_numeric.inc','c050d3b5723dbfdca9ad312c7fa198e509c626057b95eed326820ce733dd9730'),('sites/all/modules/views/plugins/views_plugin_argument_validate_php.inc','56a09922081a5e368d5796907727e35cbf43b0d634e53f947990c8a42d5b5f3e'),('sites/all/modules/views/plugins/views_plugin_cache.inc','870ceb5dd920212f4297849046e696b50dbe35a9ad4ac28b7021a7dd03aa64d9'),('sites/all/modules/views/plugins/views_plugin_cache_none.inc','a0d0ba252e1e2b65350c7ce648b97364726fa8ded5a366bfcce30c62daee4450'),('sites/all/modules/views/plugins/views_plugin_cache_time.inc','fb55f3236b30f00f3ca5228c40115444a0e2f164a4f54e6fe07dee514e183569'),('sites/all/modules/views/plugins/views_plugin_display.inc','dd190a0984bfd20a876e6437898ec691b4f46bc7a8d2e9ef17e054d03294536f'),('sites/all/modules/views/plugins/views_plugin_display_attachment.inc','6124e2ec51eadd7500fb878c25d9c5044b4ae9b6323dbbaa40b4806b69dd4cc0'),('sites/all/modules/views/plugins/views_plugin_display_block.inc','7ad6a90efa396f68276e93e19a6273c88782d514c1f1cea6ed0b046287e16a10'),('sites/all/modules/views/plugins/views_plugin_display_default.inc','91c6554d8f41f848bf30093d44d076051c54e998f6b50bdc2a922bfeeef9c54d'),('sites/all/modules/views/plugins/views_plugin_display_embed.inc','5424f2ea9e031faade7a562b8013aea193db5b0bc1be92b97bd7967de0d7bfff'),('sites/all/modules/views/plugins/views_plugin_display_extender.inc','75fb9f80e7f153715b911690c7140f251df588e6a541fab5881fbfafc0bbf778'),('sites/all/modules/views/plugins/views_plugin_display_feed.inc','f2fb6152e12da300b9bb8e1b45621dfe921c3ce0e769970ee1532e32a3657c53'),('sites/all/modules/views/plugins/views_plugin_display_page.inc','ece0ae5d5d730ef646178b09bc41a59e091c96a6ac3b3db5bdb9e61d194787bb'),('sites/all/modules/views/plugins/views_plugin_exposed_form.inc','0632ce61b4e39f8c0f39866987e4908657020298520fcf7c2712c0135e77d95b'),('sites/all/modules/views/plugins/views_plugin_exposed_form_basic.inc','c736e1862b393e15ecc80deb58663405a1d68c2db07eb620d8e640406876cd17'),('sites/all/modules/views/plugins/views_plugin_exposed_form_input_required.inc','98b81e3b78f7242dd30a3754830bdde2fb1dfe8f002ae0daa06976f1bb64fa75'),('sites/all/modules/views/plugins/views_plugin_localization.inc','d7239cc693994dcd069c1f1e7847a7902c5bd29b8d64a93cdf37c602576661fb'),('sites/all/modules/views/plugins/views_plugin_localization_core.inc','f0900c0640e7c779e9b876223ea395f613c8fe8449f6c8eb5d060e2d54a6afcc'),('sites/all/modules/views/plugins/views_plugin_localization_none.inc','4930c3a13ddc0df3065f4920a836ffdc933b037e1337764e6687d7311f49dd8a'),('sites/all/modules/views/plugins/views_plugin_pager.inc','d7c32e38f149e9009e175395dff2b00ec429867653c7535301b705a7cc69d9ed'),('sites/all/modules/views/plugins/views_plugin_pager_full.inc','60e4dec532de00bf7e785e5fa29a0be43c7b550efa85df0346a1712a3c39f7cd'),('sites/all/modules/views/plugins/views_plugin_pager_mini.inc','0a9d101d5a4217fb888c643bfddd7bf7f2f9c0937faa2753a31452a5ee68190b'),('sites/all/modules/views/plugins/views_plugin_pager_none.inc','822cab1ada25f4902a0505f13db86886061d2ced655438b33b197d031ccceddd'),('sites/all/modules/views/plugins/views_plugin_pager_some.inc','bc6aa7cbf1bc09374eced33334195c8897e4078336b8306d02d71c7aaaa22c99'),('sites/all/modules/views/plugins/views_plugin_query.inc','475a7ff0d4c7c7e27d7971ebd909a87bdb8322c47d6023b68f50f6fe6a1ec059'),('sites/all/modules/views/plugins/views_plugin_query_default.inc','d5f89543721a3cd24f6a18114c630f741d11029d933f1b01d59f349219b747d6'),('sites/all/modules/views/plugins/views_plugin_row.inc','3ca81529526b930cfb0dda202757f203649236b90441e3c035bb79cd419ee2a6'),('sites/all/modules/views/plugins/views_plugin_row_fields.inc','875fb2868cdbcc5f7af03098cbe55b9bb91ef512e5e52ccde89f7a02a0c5fbe2'),('sites/all/modules/views/plugins/views_plugin_row_rss_fields.inc','62f4a0ceef14aec9958ee8b98d352303f10818ddc66031814cc8b9d21752ade9'),('sites/all/modules/views/plugins/views_plugin_style.inc','1ac358d216da612e1731d6b1c730d2ee57ccb8cdd31ad768ae97af542325244f'),('sites/all/modules/views/plugins/views_plugin_style_default.inc','bf411e635d2fd9e09eb245b43581a0a7b670359180ccb042d42a5e579bbe9c30'),('sites/all/modules/views/plugins/views_plugin_style_grid.inc','35094b7f644b7e0692c9026b6b6b4c4c864c37fcdedef04b359dd2bdba496a47'),('sites/all/modules/views/plugins/views_plugin_style_jump_menu.inc','53a438d8a5398877eacdbff97f3b0c418ebc2fa16e69efd5e4a31b0b986e03a3'),('sites/all/modules/views/plugins/views_plugin_style_list.inc','407b928d2c74a91903b681088bccce926d2268d0a9a6a34c185a4849dc0d7e31'),('sites/all/modules/views/plugins/views_plugin_style_mapping.inc','a6b430a148dda1b07ecee314b897c1da41ce375566adf50ee23ae1da822fddf3'),('sites/all/modules/views/plugins/views_plugin_style_rss.inc','ac72d530faffee78a1695a0b3893528ceb8451f18be0521c580485904a5ba57b'),('sites/all/modules/views/plugins/views_plugin_style_summary.inc','872df59f8f389eaf9b019e82d859dd198d31166e26a9102132e3932c7f1f2916'),('sites/all/modules/views/plugins/views_plugin_style_summary_jump_menu.inc','2ec0d225824ee65b6bb61317979e1dabe2be524a66ab19da924c6949dd31af3b'),('sites/all/modules/views/plugins/views_plugin_style_summary_unformatted.inc','c1e6f9dd1d75e29fee271171440d2182e633a1dbbc996cb186f637ff7ad93ed9'),('sites/all/modules/views/plugins/views_plugin_style_table.inc','0cbcc5d256a13953fbd3e5966a33d2426d5c3bd8c228ef370daebf2f428e693c'),('sites/all/modules/views/plugins/views_wizard/views_ui_base_views_wizard.class.php','d8325414c8ddde5c955a5cfb053b77478bb4d73cb2f7d75b857b082bc5a1e12d'),('sites/all/modules/views/plugins/views_wizard/views_ui_comment_views_wizard.class.php','585a8e885a18d4d2dee260859492eb332d70166abf2d201777ebf0d2083d2ebe'),('sites/all/modules/views/plugins/views_wizard/views_ui_file_managed_views_wizard.class.php','5734fb564ba9e2485cfa5d4a49f0c76f65a9be357b78e769ee4af92c4ef9e22a'),('sites/all/modules/views/plugins/views_wizard/views_ui_node_revision_views_wizard.class.php','6faf9ef92501a4f1aeaf86bcff9edaeb47bd7526ba50d06b841c9366149e7725'),('sites/all/modules/views/plugins/views_wizard/views_ui_node_views_wizard.class.php','f10e588fcfe2dc37d0df1c520c3cd797b85d6f729335606b1aa11fcb5884e6eb'),('sites/all/modules/views/plugins/views_wizard/views_ui_taxonomy_term_views_wizard.class.php','87d72dba2aef587994307cb287b638a409d148911e4b90109798ecacf5a721e7'),('sites/all/modules/views/plugins/views_wizard/views_ui_users_views_wizard.class.php','f9fe2fb1ee87a1871e6ad32bad61b2457313f24da1bd5423977ced12de542919'),('sites/all/modules/views/tests/comment/views_handler_argument_comment_user_uid.test','b8b417ef0e05806a88bd7d5e2f7dcb41339fbf5b66f39311defc9fb65476d561'),('sites/all/modules/views/tests/comment/views_handler_filter_comment_user_uid.test','347c6ffd4383706dbde844235aaf31cff44a22e95d2e6d8ef4da34a41b70edd1'),('sites/all/modules/views/tests/field/views_fieldapi.test','53e6d57c2d1d6cd0cd92e15ca4077ba532214daf41e9c7c0f940c7c8dbd86a66'),('sites/all/modules/views/tests/handlers/views_handlers.test','f94dd3c4ba0bb1ffbf42704f600b94a808c1202a9ca26e7bdef8e7921c2724e9'),('sites/all/modules/views/tests/handlers/views_handler_area_text.test','af74a74a3357567b844606add76d7ca1271317778dd7bd245a216cf963c738b4'),('sites/all/modules/views/tests/handlers/views_handler_argument_null.test','1d174e1f467b905d67217bd755100d78ffeca4aa4ada5c4be40270cd6d30b721'),('sites/all/modules/views/tests/handlers/views_handler_argument_string.test','3d0213af0041146abb61dcdc750869ed773d0ac80cfa74ffbadfdd03b1f11c52'),('sites/all/modules/views/tests/handlers/views_handler_field.test','af552bf825ab77486b3d0d156779b7c4806ce5a983c6116ad68b633daf9bb927'),('sites/all/modules/views/tests/handlers/views_handler_field_boolean.test','d334b12a850f36b41fe89ab30a9d758fd3ce434286bd136404344b7b288460ae'),('sites/all/modules/views/tests/handlers/views_handler_field_counter.test','75b31942adf06b107f5ffd3c97545fde8cd1040b1d00f682e3c7c1320026e26c'),('sites/all/modules/views/tests/handlers/views_handler_field_custom.test','1446bc3d5a6b1180a79edfa46a5268dbf7f089836aa3bc45df00ddaff9dd0ce1'),('sites/all/modules/views/tests/handlers/views_handler_field_date.test','02df76a93a42d6131957748b1e69254835f9e44a47dafca1e833914e6b7f88a0'),('sites/all/modules/views/tests/handlers/views_handler_field_file_extension.test','606ca091ad7e5709f7653324aaa021484d1f0e07e8639b3f0f7c26d3cfdee53c'),('sites/all/modules/views/tests/handlers/views_handler_field_file_size.test','49184db68af398a54e81c8a76261acd861da8fd7846b9d51dcf476d61396bfb9'),('sites/all/modules/views/tests/handlers/views_handler_field_math.test','6e39e4f782e6b36151ceafb41a5509f7c661be79b393b24f6f5496d724535887'),('sites/all/modules/views/tests/handlers/views_handler_field_url.test','b41f762a71594b438a2e60a79c8260ba54e6305635725b0747e29f0d3ffe08c9'),('sites/all/modules/views/tests/handlers/views_handler_field_xss.test','f129ee16c03f84673e33990cbb2da5aa88c362f46e9ba1620b2a842ffd1c9cd2'),('sites/all/modules/views/tests/handlers/views_handler_filter_combine.test','05842d83a11822afe7d566835f5db9f0f94fdb27ddfc388d38138767bdf36f8b'),('sites/all/modules/views/tests/handlers/views_handler_filter_date.test','ad2ca901c6a4ac3a82fc349a33826f043c6c80f773f40374be2e95acb39491e3'),('sites/all/modules/views/tests/handlers/views_handler_filter_equality.test','c88f21c9cbf1aae83393b26616908f8020c18fe378d76256c7ba192df2ec17af'),('sites/all/modules/views/tests/handlers/views_handler_filter_in_operator.test','89420a4071677232e0eb82b184b37b818a82bdb2ff90a8b21293f9ecb21808bf'),('sites/all/modules/views/tests/handlers/views_handler_filter_numeric.test','35ac7a34e696b979e86ef7209b6697098d9abe218e30a02cc4fe39fb11f2a852'),('sites/all/modules/views/tests/handlers/views_handler_filter_string.test','b7d090780748faad478e619fd55673d746d4a0cf343d9e40ea96881324c34cbd'),('sites/all/modules/views/tests/handlers/views_handler_sort.test','f4ff79e6bc54e83c4eb2777811f33702b7e9fe7416ef70ae00d100fa54d44fec'),('sites/all/modules/views/tests/handlers/views_handler_sort_date.test','f548584d7c6a71cabd3ce07e04053a38df3f3e1685210ce8114238fd05344c10'),('sites/all/modules/views/tests/handlers/views_handler_sort_random.test','4fdba9bf05a26720ffa97e7a37da65ddc9044bd2832f8c89007b82feb062f182'),('sites/all/modules/views/tests/node/views_node_revision_relations.test','9467497a6d693615b48c8f57611a850002317bcb091b926d2efbbe56a4e61480'),('sites/all/modules/views/tests/plugins/views_plugin_display.test','4a6b136543a60999604c54125fa9d4f5aa61a5dcc71e2133d89325d81bc0fc2d'),('sites/all/modules/views/tests/styles/views_plugin_style.test','92d9a02f87f07d091999b961045b1dd654165059d8d1931b5c2ea1d88d0b439f'),('sites/all/modules/views/tests/styles/views_plugin_style_base.test','54fb7816d18416d8b0db67e9f55aa2aa50ac204eb9311be14b6700b7d7a95ae7'),('sites/all/modules/views/tests/styles/views_plugin_style_jump_menu.test','b88baa8aebe183943a6e4cf2df314fef13ac41b5844cd5fa4aa91557dd624895'),('sites/all/modules/views/tests/styles/views_plugin_style_mapping.test','a4e68bc8cfbeff4a1d9b8085fd115bfe7a8c4b84c049573fa0409b0dc8c2f053'),('sites/all/modules/views/tests/styles/views_plugin_style_unformatted.test','033ca29d41af47cd7bd12d50fea6c956dde247202ebda9df7f637111481bb51d'),('sites/all/modules/views/tests/taxonomy/views_handler_relationship_node_term_data.test','6074f5c7ae63225ea0cd26626ace6c017740e226f4d3c234e39869c31308223d'),('sites/all/modules/views/tests/test_handlers/views_test_area_access.inc','619e39bc4535976865b96751535d0d5aac4a7a87c1d47cb6d4c4bb9c9fa74716'),('sites/all/modules/views/tests/test_plugins/views_test_plugin_access_test_dynamic.inc','6a3ce8c256b84734b6b67a893ab24465a5f62d7bdf9ab5d22082a31849346b7d'),('sites/all/modules/views/tests/test_plugins/views_test_plugin_access_test_static.inc','e345e42d443cfa73db0ed2be61291117ebd57b86196cdb77c6f440e93443def3'),('sites/all/modules/views/tests/test_plugins/views_test_plugin_style_test_mapping.inc','0b2c68626105bd5f6b9074022a37c3d09d3a6bd70b811bb26d5eacad6d74546f'),('sites/all/modules/views/tests/user/views_handler_field_user_name.test','69641b6da26d8daee9a2ceb2d0df56668bf09b86db1d4071c275b6e8d0885f9e'),('sites/all/modules/views/tests/user/views_user.test','fbb63b42a0b7051bd4d33cf36841f39d7cc13a63b0554eca431b2a08c19facae'),('sites/all/modules/views/tests/user/views_user_argument_default.test','6423f2db7673763991b1fd0c452a7d84413c7dd888ca6c95545fadc531cfaaf4'),('sites/all/modules/views/tests/user/views_user_argument_validate.test','c88c9e5d162958f8924849758486a0d83822ada06088f5cf71bfbe76932d8d84'),('sites/all/modules/views/tests/views_access.test','f8b9d04b43c09a67ec722290a30408c1df8c163cf6e5863b41468bb4e381ee6f'),('sites/all/modules/views/tests/views_analyze.test','5548e36c99bb626209d63e5cddbc31f49ad83865c983d2662c6826b328d24ffb'),('sites/all/modules/views/tests/views_argument_default.test','5950937aae4608bba5b86f366ef3a56cc6518bbccfeaeacda79fa13246d220e4'),('sites/all/modules/views/tests/views_argument_validator.test','31f8f49946c8aa3b03d6d9a2281bdfb11c54071b28e83fb3e827ca6ff5e38c88'),('sites/all/modules/views/tests/views_basic.test','655bd33983f84bbea68a3f24bfab545d2c02f36a478566edf35a98a58ff0c6cf'),('sites/all/modules/views/tests/views_cache.test','4e9b8ae1d9e72a9eaee95f5083004316d2199617f7d6c8f4bea40e99d17efcd8'),('sites/all/modules/views/tests/views_exposed_form.test','6962c7ed8a38030ec1cfa94485de07ceb1f9393216985bd8bfecac768f6c0950'),('sites/all/modules/views/tests/views_glossary.test','118d50177a68a6f88e3727e10f8bcc6f95176282cc42fbd604458eeb932a36e8'),('sites/all/modules/views/tests/views_groupby.test','f26ad6857dc4821a4a0780642bda05fcb69ed506968e521f759bb28be4080143'),('sites/all/modules/views/tests/views_handlers.test','a696e3d6b1748da03a04ac532f403700d07c920b9c405c628a6c94ea6764f501'),('sites/all/modules/views/tests/views_module.test','5137e27449639d3e02f1b27206ef3ff96957546333b517318dfe8f58239dc860'),('sites/all/modules/views/tests/views_pager.test','6f448c8c13c5177afb35103119d6281958a2d6dbdfb96ae5f4ee77cb3b44adc5'),('sites/all/modules/views/tests/views_plugin_localization_test.inc','baedcf6c7381f9c5d3a5062f7d256f96808d06e04b6e73eff8e791e5f5293f45'),('sites/all/modules/views/tests/views_query.test','f8cb1649e43c8a2b036fec742e86b8eb9c2c4c095a4c4e7a7c3ca13c6ce8e6e6'),('sites/all/modules/views/tests/views_test.views_default.inc','4c65cc385b3e3c2e17fe054eb7a1ec70f4dd4b0394bdb108de2ddc0a7b435635'),('sites/all/modules/views/tests/views_translatable.test','6899c7b09ab72c262480cf78d200ecddfb683e8f2495438a55b35ae0e103a1b3'),('sites/all/modules/views/tests/views_ui.test','f9687a363d7cc2828739583e3eedeb68c99acd505ff4e3036c806a42b93a2688'),('sites/all/modules/views/tests/views_upgrade.test','c48bd74b85809dd78d963e525e38f3b6dd7e12aa249f73bd6a20247a40d6713a'),('sites/all/modules/views/tests/views_view.test','a52e010d27cc2eb29804a3acd30f574adf11fad1f5860e431178b61cddbdbb69'),('sites/all/modules/views/views_ui.module','418d555f71e72cb771a01ad7bfe7410c4d8191738271fa4e7cbb063940afb2a0'),('sites/all/modules/views_fieldsets/views/views_fieldsets_fieldset_field_handler.inc','2870256bc954a75a21a134dbb32d02cdc77ab8aadf43539ee3e9ab48ba2c9696'),('sites/all/modules/views_slideshow/contrib/views_slideshow_cycle/theme/views_slideshow_cycle.theme.inc','6a074c958bf41f9067a640ca8a40480bee29e64ab9f352fee5f3bb95d7480cdb'),('sites/all/modules/views_slideshow/contrib/views_slideshow_cycle/views_slideshow_cycle.module','4a5cf6b3a8747cd8a8d874c796ffab08c7d3b1921cfd6779ed87526ec446914e'),('sites/all/modules/views_slideshow/contrib/views_slideshow_cycle/views_slideshow_cycle.views_slideshow.inc','fc525602109c8db6173814b73c8f04921331f3373f1fa8666111e252eb3cf9b6'),('sites/all/modules/views_slideshow/theme/views_slideshow.theme.inc','3cbed9cfdc7994fccb3f9882246e6faf282518b84a7248c8d93a55f97585e8f4'),('sites/all/modules/views_slideshow/views_slideshow.module','106f6cd97700ae75adabe1a2ba1ae1e1f4bda1d60e1e56406392cb7358605667'),('sites/all/modules/views_slideshow/views_slideshow.views.inc','95958d4aba955044f00330dd59f35b6759e7057ced744429bfb45732e4ce094c'),('sites/all/modules/views_slideshow/views_slideshow_plugin_style_slideshow.inc','3df328b32c9d209cca54e3d8136e5c0f37b1619d0bcb600ca5568a85bd7da20b'),('sites/all/modules/votingapi/tests/votingapi.test','dd54282d34cff2a3a01f9ffbde51b367e5136e4d97d67b7255fb2fbccfe9933a'),('sites/all/modules/votingapi/views/votingapi_views_handler_field_value.inc','878d014877b0fb86302c7557a598ef1a49923b6ee55557685b6deddf6336bb16'),('sites/all/modules/votingapi/views/votingapi_views_handler_relationship.inc','effdeaa71d58295cac16a56aa4276c0a8b0aa95d2ab438deb26e30e4b3a0fba8'),('sites/all/modules/votingapi/views/votingapi_views_handler_sort_nullable.inc','892d69754cf1945b31c5429f9676efbcfc1dabbdadfef68dd7780339c505f565'),('sites/all/modules/webform/includes/exporters/webform_exporter.inc','d0ecbf7c7b218e10442b6bf1ef32ac4a67862b0cb1c37f10936dbf69b55c75a1'),('sites/all/modules/webform/includes/exporters/webform_exporter_delimited.inc','deb820b134e34386daa833b78aaaacdd4bc78fcb1832a452145c0851909e1bb4'),('sites/all/modules/webform/includes/exporters/webform_exporter_excel_delimited.inc','fe301ec8cba10b2e5ecdfed30c386fef1dbb1a33db21a19fa686533775b72223'),('sites/all/modules/webform/includes/exporters/webform_exporter_excel_xlsx.inc','b3407ce58fb72c05d723ab699440f687db6344d4a8756eca7333deaa9c6f2df3'),('sites/all/modules/webform/includes/webform.webformconditionals.inc','a9097667c37e229b06f6000d3a3e76f6bb850dd28a4d2ce64d6b8815920e5f2b'),('sites/all/modules/webform/tests/WebformComponentsTestCase.test','c049c524ca26457fc0ab02580feeb65ee530a8c6ee929117bfb1588230ea0b2a'),('sites/all/modules/webform/tests/WebformConditionalsTestCase.test','70d4b6d2d29cca00179ed5e12f902c6e5c4d8aabf2f08d0bb6624a117233d2de'),('sites/all/modules/webform/tests/WebformGeneralTestCase.test','4517422697e246f32906bdf73ee4e8351eb1331c7e4f7d662e17df03b51f53d7'),('sites/all/modules/webform/tests/WebformPermissionsTestCase.test','23f0c6b6489d78e13956e0b4d6e0728bf7e461b5b585d1f21907ff24ebdcb3ee'),('sites/all/modules/webform/tests/WebformSubmissionTestCase.test','896ac04995ad9f634d7457ec35424b4be64438f9375dece837ccaa35d7b48310'),('sites/all/modules/webform/tests/WebformTestCase.test','7722ef29dd244fea0468140de978427bc7e73a41303bbeff2c5eb305a68a616c'),('sites/all/modules/webform/views/webform.views.inc','0afd6ebbcb717b1f21f39347bad1ccdc23424d74a7e53e5e2119f888597ba3ea'),('sites/all/modules/webform/views/webform_handler_area_result_pager.inc','23b6f7013773cfed06c540748f7e2f0dc40602289bc97d73fe603ca9c87f0deb'),('sites/all/modules/webform/views/webform_handler_field_form_body.inc','60d708d683c67b553ecee37c7d74b00ee4b06253799e31befef9cb3ff703abb2'),('sites/all/modules/webform/views/webform_handler_field_is_draft.inc','1f1411981bc3e96ae4dccfb4c52a059b2e6488818ad4649fe8074f7de2d324f6'),('sites/all/modules/webform/views/webform_handler_field_node_link_edit.inc','15c6c4755b2ec87f71699399851a831176d515071ef356de4a64b75b76989e89'),('sites/all/modules/webform/views/webform_handler_field_node_link_results.inc','5320f9c4ffa4842d2efc31c6d563c083e0432c682f1eff706ade34fb8e54d630'),('sites/all/modules/webform/views/webform_handler_field_submission_count.inc','1ed985c65786a215a39ecb119ad26c7e78108ecb8f969ed902cc4618c5378232'),('sites/all/modules/webform/views/webform_handler_field_submission_data.inc','eac20f1d2b77d98e1c64e357ac676bb2941f65f6f3521f314e5923f7e372bf45'),('sites/all/modules/webform/views/webform_handler_field_submission_link.inc','faaf698125ac99f18bdb8c4a7b9961e5ad06bdd157c7bbeaf8a8ad7d5be6aa60'),('sites/all/modules/webform/views/webform_handler_field_webform_status.inc','c67f6a8dc4db5c165cb6109dc28c8b8ebe79d130ac208281274caac0df258ce4'),('sites/all/modules/webform/views/webform_handler_filter_is_draft.inc','dfb94fba66085fd0c07b8012f6846228fabc46809b00028bb896d6a304cdfec8'),('sites/all/modules/webform/views/webform_handler_filter_submission_data.inc','74d41b7fc50055de6279fd1d4757752841018374116ca844466b72a6085f9792'),('sites/all/modules/webform/views/webform_handler_filter_webform_status.inc','4a6e3f21703f750b31e868e64fd1fc4b760c01b9a3ca98b250f34c29614fbc69'),('sites/all/modules/webform/views/webform_handler_numeric_data.inc','c5a8fbfa2c74e1db9a4691714cb5c1c6693f2d4350c8a2ea27b4840414b1aa79'),('sites/all/modules/webform/views/webform_handler_relationship_submission_data.inc','10ba625ac9813ee2b7cb3b66b557ea8d60d32ae5bf4300b8bd6ee41be0303fbd'),('sites/all/modules/webform/views/webform_plugin_row_submission_view.inc','728907aaf814b5dc10a6d2c2c60880b160031536e81cff7071ffe04c570a7f60');
/*!40000 ALTER TABLE `registry_file` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `role`
--

DROP TABLE IF EXISTS `role`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `role` (
  `rid` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Primary Key: Unique role ID.',
  `name` varchar(64) NOT NULL DEFAULT '' COMMENT 'Unique role name.',
  `weight` int(11) NOT NULL DEFAULT '0' COMMENT 'The weight of this role in listings and the user interface.',
  PRIMARY KEY (`rid`),
  UNIQUE KEY `name` (`name`),
  KEY `name_weight` (`name`,`weight`)
) ENGINE=InnoDB AUTO_INCREMENT=4 DEFAULT CHARSET=utf8 COMMENT='Stores user roles.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `role`
--

LOCK TABLES `role` WRITE;
/*!40000 ALTER TABLE `role` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `role` VALUES (3,'administrator',2),(1,'anonymous user',0),(2,'authenticated user',1);
/*!40000 ALTER TABLE `role` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `role_permission`
--

DROP TABLE IF EXISTS `role_permission`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `role_permission` (
  `rid` int(10) unsigned NOT NULL COMMENT 'Foreign Key: role.rid.',
  `permission` varchar(128) NOT NULL DEFAULT '' COMMENT 'A single permission granted to the role identified by rid.',
  `module` varchar(255) NOT NULL DEFAULT '' COMMENT 'The module declaring the permission.',
  PRIMARY KEY (`rid`,`permission`),
  KEY `permission` (`permission`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Stores the permissions assigned to user roles.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `role_permission`
--

LOCK TABLES `role_permission` WRITE;
/*!40000 ALTER TABLE `role_permission` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `role_permission` VALUES (1,'access comments','comment'),(1,'access content','node'),(1,'access site-wide contact form','contact'),(1,'rate content','fivestar'),(1,'search content','search'),(1,'use advanced search','search'),(1,'view faq page','faq'),(1,'view forum statistics','advanced_forum'),(2,'access comments','comment'),(2,'access content','node'),(2,'access site-wide contact form','contact'),(2,'access user contact forms','contact'),(2,'create forum content','node'),(2,'delete own forum content','node'),(2,'edit own comments','comment'),(2,'edit own forum content','node'),(2,'edit webform components','webform'),(2,'post comments','comment'),(2,'rate content','fivestar'),(2,'search content','search'),(2,'skip comment approval','comment'),(2,'use advanced search','search'),(2,'use text format filtered_html','filter'),(2,'view faq page','faq'),(2,'view forum statistics','advanced_forum'),(3,'access administration menu','admin_menu'),(3,'access administration pages','system'),(3,'access all views','views'),(3,'access all webform results','webform'),(3,'access comments','comment'),(3,'access content','node'),(3,'access content overview','node'),(3,'access contextual links','contextual'),(3,'access dashboard','dashboard'),(3,'access overlay','overlay'),(3,'access own webform results','webform'),(3,'access own webform submissions','webform'),(3,'access printer-friendly version','book'),(3,'access site in maintenance mode','system'),(3,'access site reports','system'),(3,'access site-wide contact form','contact'),(3,'access statistics','statistics'),(3,'access user contact forms','contact'),(3,'access user profiles','user'),(3,'add content to books','book'),(3,'administer actions','system'),(3,'administer advanced forum','advanced_forum'),(3,'administer block classes','block_class'),(3,'administer blocks','block'),(3,'administer book outlines','book'),(3,'administer ckeditor','ckeditor'),(3,'administer comments','comment'),(3,'administer contact forms','contact'),(3,'administer content types','node'),(3,'administer custom tokens','token_custom'),(3,'administer faq','faq'),(3,'administer faq order','faq'),(3,'administer features','features'),(3,'administer field collections','field_collection'),(3,'administer fieldgroups','field_group'),(3,'administer fields','field'),(3,'administer filters','filter'),(3,'administer flexslider','flexslider'),(3,'administer forums','forum'),(3,'administer image styles','image'),(3,'administer languages','locale'),(3,'administer menu','menu'),(3,'administer message types','message'),(3,'administer module filter','module_filter'),(3,'administer modules','system'),(3,'administer nodes','node'),(3,'administer pathauto','pathauto'),(3,'administer permissions','user'),(3,'administer quicktabs','quicktabs'),(3,'administer search','search'),(3,'administer sharethis','sharethis'),(3,'administer shortcuts','shortcut'),(3,'administer site configuration','system'),(3,'administer software updates','system'),(3,'administer statistics','statistics'),(3,'administer taxonomy','taxonomy'),(3,'administer themes','system'),(3,'administer url aliases','path'),(3,'administer users','user'),(3,'administer video styles','video_embed_field'),(3,'administer views','views'),(3,'administer voting api','votingapi'),(3,'administer Webform Hints settings','webform_hints'),(3,'block IP addresses','system'),(3,'bypass node access','node'),(3,'cancel account','user'),(3,'change own username','user'),(3,'create article content','node'),(3,'create blog content','node'),(3,'create book content','node'),(3,'create faq content','node'),(3,'create forum content','node'),(3,'create messages','message'),(3,'create new books','book'),(3,'create page content','node'),(3,'create products content','node'),(3,'create url aliases','path'),(3,'create video content','node'),(3,'create webform content','node'),(3,'customize ckeditor','ckeditor'),(3,'customize shortcut links','shortcut'),(3,'delete all webform submissions','webform'),(3,'delete any article content','node'),(3,'delete any blog content','node'),(3,'delete any book content','node'),(3,'delete any faq content','node'),(3,'delete any forum content','node'),(3,'delete any page content','node'),(3,'delete any products content','node'),(3,'delete any video content','node'),(3,'delete any webform content','node'),(3,'delete own article content','node'),(3,'delete own blog content','node'),(3,'delete own book content','node'),(3,'delete own faq content','node'),(3,'delete own forum content','node'),(3,'delete own page content','node'),(3,'delete own products content','node'),(3,'delete own video content','node'),(3,'delete own webform content','node'),(3,'delete own webform submissions','webform'),(3,'delete revisions','node'),(3,'delete terms in 1','taxonomy'),(3,'delete terms in 2','taxonomy'),(3,'delete terms in 3','taxonomy'),(3,'delete terms in 4','taxonomy'),(3,'display drupal links','admin_menu'),(3,'edit all webform submissions','webform'),(3,'edit any article content','node'),(3,'edit any blog content','node'),(3,'edit any book content','node'),(3,'edit any faq content','node'),(3,'edit any forum content','node'),(3,'edit any page content','node'),(3,'edit any products content','node'),(3,'edit any video content','node'),(3,'edit any webform content','node'),(3,'edit own article content','node'),(3,'edit own blog content','node'),(3,'edit own book content','node'),(3,'edit own comments','comment'),(3,'edit own faq content','node'),(3,'edit own forum content','node'),(3,'edit own page content','node'),(3,'edit own products content','node'),(3,'edit own video content','node'),(3,'edit own webform content','node'),(3,'edit own webform submissions','webform'),(3,'edit terms in 1','taxonomy'),(3,'edit terms in 2','taxonomy'),(3,'edit terms in 3','taxonomy'),(3,'edit terms in 4','taxonomy'),(3,'flush caches','admin_menu'),(3,'generate features','features'),(3,'list custom tokens','token_custom'),(3,'manage features','features'),(3,'notify of path changes','pathauto'),(3,'post comments','comment'),(3,'rate content','fivestar'),(3,'revert revisions','node'),(3,'search content','search'),(3,'select account cancellation method','user'),(3,'skip comment approval','comment'),(3,'switch shortcut sets','shortcut'),(3,'translate admin strings','i18n_string'),(3,'translate interface','locale'),(3,'translate user-defined strings','i18n_string'),(3,'use advanced search','search'),(3,'use PHP for settings','php'),(3,'use text format filtered_html','filter'),(3,'use text format full_html','filter'),(3,'view faq page','faq'),(3,'view forum statistics','advanced_forum'),(3,'view last edited notice','advanced_forum'),(3,'view own unpublished content','node'),(3,'view post access counter','statistics'),(3,'view revisions','node'),(3,'view the administration theme','system');
/*!40000 ALTER TABLE `role_permission` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `search_dataset`
--

DROP TABLE IF EXISTS `search_dataset`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `search_dataset` (
  `sid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Search item ID, e.g. node ID for nodes.',
  `type` varchar(16) NOT NULL COMMENT 'Type of item, e.g. node.',
  `data` longtext NOT NULL COMMENT 'List of space-separated words from the item.',
  `reindex` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Set to force node reindexing.',
  PRIMARY KEY (`sid`,`type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Stores items that will be searched.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `search_dataset`
--

LOCK TABLES `search_dataset` WRITE;
/*!40000 ALTER TABLE `search_dataset` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `search_dataset` VALUES (1,'node',' learn d7 coding or d8  general discussion i m not a drupal developer but a pro drupal site builder i can read php and able to tweak and even write some code i was thinking about learning the development but came across this idea that in d8 we have symphony and some other big changes now the question is that shall i start learning d8 dev or i should start with d7 dev select rating give it 15 give it 25 give it 35 give it 45 give it 55 your rating none average 45 2 votes  sun 6292014 1648  2 admin online last seen 2 min 57 sec ago joined 6122014 1540 even if d8 goes gold tomorrow even if d8 goes gold tomorrow d7 will be the choice for substantial production sites for a while until a crit mass of modules port and the inevitable bugs shake out and the need to maintain existing d7 sites will be a desired skill for years to come select rating give it 15 give it 25 give it 35 give it 45 give it 55 your rating none average 4 1 vote  drupal themes web development top log in or register to post comments thu 8212014 1058  3 admin online last seen 2 min 57 sec ago joined 6122014 1540 donec venenatis vulputate donec venenatis vulputate lorem donec orci lectus aliquam ut faucibus non euismod id nulla cras dapibus phasellus nec sem in justo pellentesque facilisis mauris sollicitudin fermentum libero select rating give it 15 give it 25 give it 35 give it 45 give it 55 no votes yet drupal themes web development top log in or register to post comments  ',0),(2,'node',' community guidelines at vero eos et accusam et justo duo dolores et ea rebum stet clita kasd gubergren no sea takimata sanctus est lorem ipsum dolor sit amet stet clita kasd gubergren no sea takimata sanctus est lorem ipsum dolor sit amet stet clita kasd gubergren no sea takimata sanctus est lorem ipsum dolor sit amet excepteur sint obcaecat cupiditat non proident sunt in culpa qui officia deserunt mollit anim id est laborum ut wisi enim ad minim veniam quis nostrud exerci tation ullamcorper suscipit lobortis nisl ut aliquip ex ea commodo consequat lorem ipsum dolor sit amet consectetur adipisici elit sed eiusmod tempor incidunt ut labore et dolore magna aliqua duis autem vel eum iriure dolor in hendrerit in vulputate velit esse molestie consequat vel illum dolore eu feugiat nulla facilisis at vero eros et accumsan et iusto odio dignissim qui blandit praesent luptatum zzril delenit augue duis dolore te feugait nulla facilisi stet clita kasd gubergren no sea takimata sanctus est lorem ipsum dolor sit amet lorem ipsum dolor sit amet consetetur sadipscing elitr sed diam nonumy eirmod tempor invidunt ut labore et dolore magna aliquyam erat sed diam voluptua lorem ipsum dolor sit amet consectetuer adipiscing elit sed diam nonummy nibh euismod tincidunt ut laoreet dolore magna aliquam erat volutpat lorem ipsum dolor sit amet stet clita kasd gubergren no sea takimata sanctus est lorem ipsum dolor sit amet stet clita kasd gubergren no sea takimata sanctus est lorem ipsum dolor sit amet stet clita kasd gubergren no sea takimata sanctus est lorem ipsum dolor sit amet stet clita kasd gubergren no sea takimata sanctus est lorem ipsum dolor sit amet at vero eos et accusam et justo duo dolores et ea rebum duis autem vel eum iriure dolor in hendrerit in vulputate velit esse molestie consequat vel illum dolore eu feugiat nulla facilisis at vero eos et accusam et justo duo dolores et ea rebum lorem ipsum dolor sit amet consectetuer adipiscing elit sed diam nonummy nibh euismod tincidunt ut laoreet dolore magna aliquam erat volutpat duis autem vel eum iriure dolor in hendrerit in vulputate velit esse molestie consequat vel illum dolore eu feugiat nulla facilisis ut enim ad minim veniam quis nostrud exercitation ullamco laboris nisi ut aliquid ex ea commodi consequat lorem ipsum dolor sit amet ut wisi enim ad minim veniam quis nostrud exerci tation ullamcorper suscipit lobortis nisl ut aliquip ex ea commodo consequat  ',0),(3,'node',' apple updates macbook pro with retina display news and announcements excepteur sint occaecat cupidatat non proident sunt in culpa qui officia deserunt mollit anim id est laborum sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium totam rem aperiam eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo nulla facilisi cras convallis vel lectus sed convallis duis nec accumsan diam vestibulum blandit tempus nulla suspendisse consectetur cursus elit et scelerisque ligula hendrerit id maecenas ultrices porta nunc quis consectetur risus morbi non metus eget nibh vulputate tincidunt nullam dui quam suscipit a ligula a posuere sagittis magna pellentesque vitae dolor et nunc lobortis vestibulum suspendisse potenti pellentesque cursus purus vitae libero hendrerit congue aenean erat elit aliquet at mi quis sollicitudin sollicitudin libero sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium totam rem aperiam eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo h1 heading 1 sint occaecat cupidatat non proident sunt in culpa qui officia deserunt mollit anim id est laborum sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium totam rem aperiam eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo nemo enim ipsam voluptatem quia voluptas sit aspernatur aut odit aut fugit sed ut perspiciatis unde omnis iste natus error qui dolorem ipsum quia dolor sit amet consectetur adipisci velit h2 heading 2 sint occaecat cupidatat non proident sunt in culpa qui officia deserunt mollit anim id est laborum sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium totam rem aperiam eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo h3 heading 3 sint occaecat cupidatat non proident sunt in culpa qui officia deserunt mollit anim id est laborum sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium totam rem aperiam eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo select rating give it 15 give it 25 give it 35 give it 45 give it 55 no votes yet tue 8192014 124  4 mical offline last seen 1 day 22 hours ago joined 7132014 2351 phasellus a tellus erat phasellus a tellus erat curabitur ut euismod sem proin eu neque a ligula bibendum porta fusce faucibus neque id egestas tristique vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia curae morbi dignissim dictum lectus in tristique suspendisse luctus vehicula metus select rating give it 15 give it 25 give it 35 give it 45 give it 55 no votes yet practice makes perfect  top log in or register to post comments  ',0),(4,'node',' 54 living room decorating ideas praesent ut ligula non mi varius sagittis curabitur nisi phasellus leo dolor tempus non auctor et hendrerit quis nisi curabitur at lacus ac velit ornare lobortis fusce fermentum nunc sed turpis praesent ut ligula non mi varius sagittis curabitur nisi phasellus leo dolor tempus non auctor et hendrerit quis nisi curabitur at lacus ac velit ornare lobortis proin convallis pretium lacus et rhoncus ipsum mollis eget proin convallis pretium lacus et rhoncus ipsum mollis eget mauris pulvinar leo non magna blandit sed viverra neque euismod vestibulum bibendum pretium nibh consequat tincidunt suspendisse consequat tortor nisi eget dictum orci vulputate vel morbi ultrices condimentum lacus semper venenatis leo ultrices sit amet ut et tincidunt purus non venenatis nibh etiam congue quam metus feugiat fringilla nunc congue nec donec ut condimentum justo nam ut leo et nisl consequat commodo donec lobortis nisi vel erat posuere porttitor interdum et malesuada fames ac ante ipsum primis in faucibus curabitur venenatis massa sit amet mi mollis sollicitudin duis ut purus tincidunt lobortis tortor a porttitor erat quisque suscipit mi eu euismod egestas cras quis porta augue morbi porttitor cursus eros fusce aliquam vel lorem ut dignissim fusce commodo nisl et arcu aliquam nec accumsan purus dictum in commodo eleifend justo eu sagittis libero laoreet in someone famous in source title h1 heading 1 sint occaecat cupidatat non proident sunt in culpa qui officia deserunt mollit anim id est laborum sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium totam rem aperiam eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo nemo enim ipsam voluptatem quia voluptas sit aspernatur aut odit aut fugit sed ut perspiciatis unde omnis iste natus error qui dolorem ipsum quia dolor sit amet consectetur adipisci velit h2 heading 2 sint occaecat cupidatat non proident sunt in culpa qui officia deserunt mollit anim id est laborum sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium totam rem aperiam eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo h3 heading 3 sint occaecat cupidatat non proident sunt in culpa qui officia deserunt mollit anim id est laborum sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium totam rem aperiam eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo images drupal themes ',0),(5,'node',' how do thoughts form  praesent ut ligula non mi varius sagittis curabitur nisi phasellus leo dolor tempus non auctor et hendrerit quis nisi curabitur at lacus ac velit ornare lobortis fusce fermentum nunc sed turpis praesent ut ligula non mi varius sagittis curabitur nisi phasellus leo dolor tempus non auctor et hendrerit quis nisi curabitur at lacus ac velit ornare lobortis proin convallis pretium lacus et rhoncus ipsum mollis eget proin convallis pretium lacus et rhoncus ipsum mollis eget mauris pulvinar leo non magna blandit sed viverra neque euismod vestibulum bibendum pretium nibh consequat tincidunt suspendisse consequat tortor nisi eget dictum orci vulputate vel morbi ultrices condimentum lacus semper venenatis leo ultrices sit amet ut et tincidunt purus non venenatis nibh etiam congue quam metus feugiat fringilla nunc congue nec donec ut condimentum justo nam ut leo et nisl consequat commodo donec lobortis nisi vel erat posuere porttitor interdum et malesuada fames ac ante ipsum primis in faucibus curabitur venenatis massa sit amet mi mollis sollicitudin duis ut purus tincidunt lobortis tortor a porttitor erat quisque suscipit mi eu euismod egestas cras quis porta augue morbi porttitor cursus eros fusce aliquam vel lorem ut dignissim fusce commodo nisl et arcu aliquam nec accumsan purus dictum in commodo eleifend justo eu sagittis libero laoreet in someone famous in source title h1 heading 1 sint occaecat cupidatat non proident sunt in culpa qui officia deserunt mollit anim id est laborum sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium totam rem aperiam eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo nemo enim ipsam voluptatem quia voluptas sit aspernatur aut odit aut fugit sed ut perspiciatis unde omnis iste natus error qui dolorem ipsum quia dolor sit amet consectetur adipisci velit h2 heading 2 sint occaecat cupidatat non proident sunt in culpa qui officia deserunt mollit anim id est laborum sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium totam rem aperiam eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo h3 heading 3 sint occaecat cupidatat non proident sunt in culpa qui officia deserunt mollit anim id est laborum sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium totam rem aperiam eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo themes news responsive fusce porttitor nunc ac ante submitted by peter tue aug 12 2014 0908am permalink log in or register to post comments fusce porttitor nunc ac ante pretium sed fermentum turpis malesuada aliquam tempor mollis metus at congue nulla tincidunt at nunc nulla quam congue quis fringilla ut porta id ipsum nullam quis mattis odio nunc condimentum at diam a malesuada nulla facilisi suspendisse vitae gravida nullam phasellus magna nullam submitted by admin tue aug 12 2014 0908am permalink log in or register to post comments phasellus magna nullam cursus lacinia erat maecenas ullamcorper dui et placerat feugiat eros pede varius nisi condimentum viverra felis nunc et lorem nullam accumsan lorem in dui donec vitae orci sed dolor rutrum auctor drupal themes web development ',0),(6,'node',' hotel a luxury drupal themes praesent ut ligula non mi varius sagittis curabitur nisi phasellus leo dolor tempus non auctor et hendrerit quis nisi curabitur at lacus ac velit ornare lobortis fusce fermentum nunc sed turpis praesent ut ligula non mi varius sagittis curabitur nisi phasellus leo dolor tempus non auctor et hendrerit quis nisi curabitur at lacus ac velit ornare lobortis proin convallis pretium lacus et rhoncus ipsum mollis eget proin convallis pretium lacus et rhoncus ipsum mollis eget mauris pulvinar leo non magna blandit sed viverra neque euismod vestibulum bibendum pretium nibh consequat tincidunt suspendisse consequat tortor nisi eget dictum orci vulputate vel morbi ultrices condimentum lacus semper venenatis leo ultrices sit amet ut et tincidunt purus non venenatis nibh etiam congue quam metus feugiat fringilla nunc congue nec donec ut condimentum justo nam ut leo et nisl consequat commodo donec lobortis nisi vel erat posuere porttitor interdum et malesuada fames ac ante ipsum primis in faucibus curabitur venenatis massa sit amet mi mollis sollicitudin duis ut purus tincidunt lobortis tortor a porttitor erat quisque suscipit mi eu euismod egestas cras quis porta augue morbi porttitor cursus eros fusce aliquam vel lorem ut dignissim fusce commodo nisl et arcu aliquam nec accumsan purus dictum in commodo eleifend justo eu sagittis libero laoreet in someone famous in source title h1 heading 1 sint occaecat cupidatat non proident sunt in culpa qui officia deserunt mollit anim id est laborum sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium totam rem aperiam eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo nemo enim ipsam voluptatem quia voluptas sit aspernatur aut odit aut fugit sed ut perspiciatis unde omnis iste natus error qui dolorem ipsum quia dolor sit amet consectetur adipisci velit h2 heading 2 sint occaecat cupidatat non proident sunt in culpa qui officia deserunt mollit anim id est laborum sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium totam rem aperiam eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo h3 heading 3 sint occaecat cupidatat non proident sunt in culpa qui officia deserunt mollit anim id est laborum sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium totam rem aperiam eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo running health ',0),(7,'node',' a few days in offseason aspen admin s blog excepteur sint occaecat cupidatat non proident sunt in culpa qui officia deserunt mollit anim id est laborum sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium totam rem aperiam eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo nulla facilisi cras convallis vel lectus sed convallis duis nec accumsan diam vestibulum blandit tempus nulla suspendisse consectetur cursus elit et scelerisque ligula hendrerit id maecenas ultrices porta nunc quis consectetur risus morbi non metus eget nibh vulputate tincidunt nullam dui quam suscipit a ligula a posuere sagittis magna pellentesque vitae dolor et nunc lobortis vestibulum suspendisse potenti pellentesque cursus purus vitae libero hendrerit congue aenean erat elit aliquet at mi quis sollicitudin sollicitudin libero sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium totam rem aperiam eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo h1 heading 1 sint occaecat cupidatat non proident sunt in culpa qui officia deserunt mollit anim id est laborum sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium totam rem aperiam eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo nemo enim ipsam voluptatem quia voluptas sit aspernatur aut odit aut fugit sed ut perspiciatis unde omnis iste natus error qui dolorem ipsum quia dolor sit amet consectetur adipisci velit h2 heading 2 sint occaecat cupidatat non proident sunt in culpa qui officia deserunt mollit anim id est laborum sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium totam rem aperiam eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo h3 heading 3 sint occaecat cupidatat non proident sunt in culpa qui officia deserunt mollit anim id est laborum sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium totam rem aperiam eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo aliquam eu nunc vestibulum purus quam scelerisque ut mollis sed nonummy id metus vestibulum dapibus nunc ac augue maecenas tempus tellus eget condimentum rhoncus sem quam semper libero sit amet adipiscing sem neque sed ipsum fusce vel dui vivamus consectetuer hendrerit lacus suspendisse faucibus nunc et pellentesque egestas lacus ante convallis tellus vitae iaculis lacus elit id tortor vestibulum suscipit nulla quis orci fusce neque quisque rutrum aliquam eu nunc vestibulum purus quam scelerisque ut mollis sed nonummy id metus vestibulum dapibus nunc ac augue maecenas tempus tellus eget condimentum rhoncus sem quam semper libero sit amet adipiscing sem neque sed ipsum fusce vel dui vivamus consectetuer hendrerit lacus suspendisse faucibus nunc et pellentesque egestas lacus ante convallis tellus vitae iaculis lacus elit id tortor vestibulum suscipit nulla quis orci fusce neque quisque rutrum aliquam eu nunc vestibulum purus quam scelerisque ut mollis sed nonummy id metus vestibulum dapibus nunc ac augue maecenas tempus tellus eget condimentum rhoncus sem quam semper libero sit amet adipiscing sem neque sed ipsum fusce vel dui vivamus consectetuer hendrerit lacus suspendisse faucibus nunc et pellentesque egestas lacus ante convallis tellus vitae iaculis lacus elit id tortor vestibulum suscipit nulla quis orci fusce neque quisque rutrum travel select rating give it 15 give it 25 give it 35 give it 45 give it 55 average 2 1 vote  curabitur a felis in nunc permalink submitted by peter on wed 7092014 935 curabitur a felis in nunc fringilla tristique nullam tincidunt adipiscing enim phasellus tempus proin viverra ligula sit amet ultrices semper ligula arcu tristique sapien a accumsan nisi mauris ac eros nulla sit amet est log in or register to post comments morbi mattis ullamcorper permalink submitted by jack on sun 8172014 1720 morbi mattis ullamcorper velit ut non enim eleifend felis pretium feugiat donec quam felis ultricies nec pellentesque eu pretium quis sem maecenas nec odio et ante tincidunt tempus lorem ipsum dolor sit amet consectetuer adipiscing elit praesent congue erat at massa nam ipsum risus rutrum vitae vestibulum eu molestie vel lacus cras id dui fusce convallis metus id felis luctus adipiscing pellentesque commodo eros a enim log in or register to post comments vivamus elementum semper nisi permalink submitted by admin on sun 8172014 1721 vivamus elementum semper nisi nunc egestas augue at pellentesque laoreet felis eros vehicula leo at malesuada velit leo quis pede proin sapien ipsum porta a auctor quis euismod ut mi suspendisse eu ligula drupal themes web development log in or register to post comments aenean leo ligula porttitor permalink submitted by admin on sun 8172014 1720 aenean leo ligula porttitor eu consequat vitae eleifend ac enim vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia curae fusce id purus sed libero phasellus blandit leo ut odio fusce vel dui nunc sed turpis phasellus viverra nulla ut metus varius laoreet praesent ut ligula non mi varius sagittis nulla consequat massa quis enim suspendisse pulvinar augue ac venenatis condimentum sem libero volutpat nibh nec pellentesque velit pede quis nunc drupal themes web development log in or register to post comments vivamus elementum semper nisi permalink submitted by admin on sun 8172014 1720 vivamus elementum semper nisi nunc egestas augue at pellentesque laoreet felis eros vehicula leo at malesuada velit leo quis pede proin sapien ipsum porta a auctor quis euismod ut mi suspendisse eu ligula drupal themes web development log in or register to post comments vestibulum mattis metus non permalink submitted by mical on sun 8172014 1723 vestibulum mattis metus non nunc venenatis feugiat pellentesque quis scelerisque dolor fusce posuere iaculis dictum cum sociis natoque penatibus et magnis dis parturient montes nascetur ridiculus mus interdum et malesuada fames ac ante ipsum primis in faucibus donec sed eros fringilla nullam practice makes perfect  log in or register to post comments aliquam eu faucibus orci a permalink submitted by mical on sun 8172014 1723 aliquam eu faucibus orci a hendrerit elit sed metus augue euismod tristique risus condimentum elementum faucibus enim praesent interdum lorem ante ut aliquam metus accumsan non integer egestas quis arcu sed ornare maecenas vitae velit vel ipsum fringilla iaculis sed dapibus odio fusce amet practice makes perfect  log in or register to post comments nulla adipiscing quam eros  permalink submitted by mical on sun 8172014 1723 nulla adipiscing quam eros eleifend gravida mi ornare eget proin id nunc dui duis eleifend mi non tellus porta vitae semper eros pulvinar suspendisse adipiscing orci eu porta pretium donec at est sed tortor placerat tempor nec pulvinar nisl proin at arcu vitae sem vestibulum pharetra sed sed practice makes perfect  log in or register to post comments pellentesque placerat permalink submitted by mical on sun 8172014 1724 pellentesque placerat elementum felis nec interdum etiam a felis vel urna egestas molestie class aptent taciti sociosqu ad litora torquent per conubia nostra per inceptos himenaeos aliquam pulvinar eleifend ipsum et imperdiet curabitur quis libero malesuada tincidunt mauris ut aenean suscipit practice makes perfect  log in or register to post comments phasellus viverra nulla ut permalink submitted by admin on sun 8172014 1724 phasellus viverra nulla ut metus varius laoreet suspendisse potenti nam adipiscing donec posuere vulputate arcu sed magna purus fermentum eu tincidunt eu varius ut felis drupal themes web development log in or register to post comments  ',0),(8,'node',' the 27 principles to teaching yourself anything admin s blog lorem ipsum dolor sit amet consectetur adipiscing elit pellentesque eget dolor sit amet lorem vulputate aliquet praesent eu dignissim turpis duis volutpat gravida tincidunt vivamus sodales ligula in accumsan accumsan nunc adipiscing posuere ultricies class aptent taciti sociosqu ad litora torquent per conubia nostra per inceptos himenaeos praesent vehicula justo id nunc facilisis volutpat porttitor id eros ut aliquet sodales purus in pretium risus consequat id proin convallis pretium lacus et rhoncus ipsum mollis eget mauris pulvinar leo non magna blandit sed viverra neque euismod vestibulum bibendum pretium nibh consequat tincidunt suspendisse consequat tortor nisi eget dictum orci vulputate vel morbi ultrices condimentum lacus semper venenatis leo ultrices sit amet ut et tincidunt purus non venenatis nibh etiam congue quam metus feugiat fringilla nunc congue nec donec ut condimentum justo nam ut leo et nisl consequat commodo nullam tempus rutrum massa eu ullamcorper turpis dapibus at vestibulum feugiat ligula eu nibh vehicula varius donec lobortis nisi vel erat posuere porttitor interdum et malesuada fames ac ante ipsum primis in faucibus curabitur venenatis massa sit amet mi mollis sollicitudin duis ut purus tincidunt lobortis tortor a porttitor erat quisque suscipit mi eu euismod egestas cras quis porta augue morbi porttitor cursus eros fusce aliquam vel lorem ut dignissim fusce commodo nisl et arcu aliquam nec accumsan purus dictum in commodo eleifend justo eu sagittis libero laoreet in someone famous in source title aliquam elementum turpis eget felis eleifend id sodales dui ultrices fusce rhoncus libero sed consectetur commodo arcu nisl malesuada sem commodo facilisis risus diam eu sapien aenean iaculis urna id ultrices lacinia lacus lectus commodo neque vel tincidunt lectus quam ac tellus sed interdum mattis neque nec rhoncus lorem laoreet ornare vestibulum dignissim libero non convallis pulvinar leo lectus dignissim risus ac consequat metus purus sed nisi aliquam erat volutpat vivamus elementum feugiat orci nam vitae elementum risus porta luctus tortor proin luctus tristique massa phasellus volutpat id leo sed facilisis vestibulum accumsan libero eu arcu malesuada luctus h2 heading 2 sint occaecat cupidatat non proident sunt in culpa qui officia deserunt mollit anim id est laborum sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium totam rem aperiam eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo h3 heading 3 sint occaecat cupidatat non proident sunt in culpa qui officia deserunt mollit anim id est laborum sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium totam rem aperiam eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo aliquam eu nunc vestibulum purus quam scelerisque ut mollis sed nonummy id metus vestibulum dapibus nunc ac augue maecenas tempus tellus eget condimentum rhoncus sem quam semper libero sit amet adipiscing sem neque sed ipsum fusce vel dui vivamus consectetuer hendrerit lacus suspendisse faucibus nunc et pellentesque egestas lacus ante convallis tellus vitae iaculis lacus elit id tortor vestibulum suscipit nulla quis orci fusce neque quisque rutrum sed magna purus fermentum eu tincidunt eu varius ut felis pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas vivamus aliquet elit ac nisl ut varius tincidunt libero nulla sit amet est proin faucibus arcu quis ante praesent metus tellus elementum eu semper a adipiscing nec purus proin viverra ligula sit amet ultrices semper ligula arcu tristique sapien a accumsan nisi mauris ac eros mauris turpis nunc blandit et volutpat molestie porta ut ligula phasellus accumsan cursus velit skills selfeducation 5 average 45 2 votes  fusce neque ut a nisl id permalink submitted by admin on sun 8172014 1727 fusce neque ut a nisl id ante tempus hendrerit donec interdum metus et hendrerit aliquet dolor diam sagittis ligula eget egestas libero turpis vel mi nullam dictum felis eu pede mollis pretium etiam sollicitudin ipsum eu pulvinar rutrum tellus ipsum laoreet sapien quis venenatis ante odio sit amet eros drupal themes web development log in or register to post comments quisque libero metus  permalink submitted by jack on sun 8172014 1728 quisque libero metus condimentum nec tempor a commodo mollis magna aenean imperdiet lorem ipsum dolor sit amet consectetuer adipiscing elit mauris sollicitudin fermentum libero maecenas tempus tellus eget condimentum rhoncus sem quam semper libero sit amet adipiscing sem neque sed ipsum log in or register to post comments cras varius curabitur permalink submitted by admin on sun 8172014 1728 cras varius curabitur suscipit suscipit tellus sed libero nunc nulla nulla facilisi drupal themes web development log in or register to post comments nullam nulla eros ultricies permalink submitted by admin on sun 8172014 1727 nullam nulla eros ultricies sit amet nonummy id imperdiet feugiat pede vestibulum fringilla pede sit amet augue nam adipiscing aenean ut eros et nisl sagittis vestibulum curabitur ullamcorper ultricies nisi drupal themes web development log in or register to post comments  ',0),(9,'node',' 22 ways to save money admin s blog excepteur sint occaecat cupidatat non proident sunt in culpa qui officia deserunt mollit anim id est laborum sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium totam rem aperiam eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo nulla facilisi cras convallis vel lectus sed convallis duis nec accumsan diam vestibulum blandit tempus nulla suspendisse consectetur cursus elit et scelerisque ligula hendrerit id maecenas ultrices porta nunc quis consectetur risus morbi non metus eget nibh vulputate tincidunt nullam dui quam suscipit a ligula a posuere sagittis magna pellentesque vitae dolor et nunc lobortis vestibulum suspendisse potenti pellentesque cursus purus vitae libero hendrerit congue aenean erat elit aliquet at mi quis sollicitudin sollicitudin libero sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium totam rem aperiam eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo h1 heading 1 sint occaecat cupidatat non proident sunt in culpa qui officia deserunt mollit anim id est laborum sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium totam rem aperiam eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo nemo enim ipsam voluptatem quia voluptas sit aspernatur aut odit aut fugit sed ut perspiciatis unde omnis iste natus error qui dolorem ipsum quia dolor sit amet consectetur adipisci velit h2 heading 2 sint occaecat cupidatat non proident sunt in culpa qui officia deserunt mollit anim id est laborum sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium totam rem aperiam eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo h3 heading 3 sint occaecat cupidatat non proident sunt in culpa qui officia deserunt mollit anim id est laborum sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium totam rem aperiam eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo aenean viverra rhoncus pede in dui magna posuere eget vestibulum et tempor auctor justo nullam dictum felis eu pede mollis pretium vestibulum turpis sem aliquet eget lobortis pellentesque rutrum eu nisl vivamus laoreet praesent congue erat at massa aenean vulputate eleifend tellus vestibulum suscipit nulla quis orci praesent nec nisl a purus blandit viverra nam quam nunc blandit vel luctus pulvinar hendrerit id lorem savings 4 average 4 1 vote  curabitur a felis in nunc permalink submitted by peter on wed 7092014 935 curabitur a felis in nunc fringilla tristique nullam tincidunt adipiscing enim phasellus tempus proin viverra ligula sit amet ultrices semper ligula arcu tristique sapien a accumsan nisi mauris ac eros nulla sit amet est log in or register to post comments in hac habitasse platea permalink submitted by admin on sun 8172014 1730 in hac habitasse platea dictumst vivamus euismod mauris vestibulum fringilla pede sit amet augue aenean commodo ligula eget dolor mauris sollicitudin fermentum libero drupal themes web development log in or register to post comments curabitur a felis in nunc permalink submitted by admin on wed 7092014 935 curabitur a felis in nunc fringilla tristique nullam tincidunt adipiscing enim phasellus tempus proin viverra ligula sit amet ultrices semper ligula arcu tristique sapien a accumsan nisi mauris ac eros nulla sit amet est drupal themes web development log in or register to post comments  ',0),(10,'node',' how to pick a good hostel admin s blog praesent ac massa at ligula laoreet iaculis etiam imperdiet imperdiet orci pellentesque libero tortor tincidunt et tincidunt eget semper nec quam phasellus magna phasellus gravida semper nisi donec interdum metus et hendrerit aliquet dolor diam sagittis ligula eget egestas libero turpis vel mi etiam vitae tortor suspendisse feugiat nulla consequat massa quis enim pellentesque egestas neque sit amet convallis pulvinar justo nulla eleifend augue ac auctor orci leo non est donec pede justo fringilla vel aliquet nec vulputate eget arcu aenean viverra rhoncus pede sed consequat leo eget bibendum sodales augue velit cursus nunc quis gravida magna mi a libero praesent egestas tristique nibh sed aliquam ultrices mauris sed libero cras non dolor proin faucibus arcu quis ante donec interdum metus et hendrerit aliquet dolor diam sagittis ligula eget egestas libero turpis vel mi donec pede justo fringilla vel aliquet nec vulputate eget arcu proin viverra ligula sit amet ultrices semper ligula arcu tristique sapien a accumsan nisi mauris ac eros morbi nec metus proin pretium leo ac pellentesque mollis felis nunc ultrices eros sed gravida augue augue mollis justo cum sociis natoque penatibus et magnis dis parturient montes nascetur ridiculus mus maecenas egestas arcu quis ligula mattis placerat beautiful pictures 4 average 35 2 votes  phasellus volutpat metus permalink submitted by admin on tue 8122014 921 phasellus volutpat metus eget egestas mollis lacus lacus blandit dui id egestas quam mauris ut lacus class aptent taciti sociosqu ad litora torquent per conubia nostra per inceptos hymenaeos etiam rhoncus nunc egestas augue at pellentesque laoreet felis eros vehicula leo at malesuada velit leo quis pede nullam nulla eros ultricies sit amet nonummy id imperdiet feugiat pede fusce fermentum suspendisse faucibus nunc et pellentesque egestas lacus ante convallis tellus vitae iaculis lacus elit id tortor pellentesque libero tortor tincidunt et tincidunt eget semper nec quam praesent ac sem eget est egestas volutpat duis vel nibh at velit scelerisque suscipit drupal themes web development log in or register to post comments  ',0),(11,'node',' the best drawing art books admin s blog donec mi odio faucibus at scelerisque quis convallis in nisi cras id dui phasellus volutpat metus eget egestas mollis lacus lacus blandit dui id egestas quam mauris ut lacus integer ante arcu accumsan a consectetuer eget posuere ut mauris maecenas vestibulum mollis diam nam quam nunc blandit vel luctus pulvinar hendrerit id lorem in ut quam vitae odio lacinia tincidunt donec vitae sapien ut libero venenatis faucibus class aptent taciti sociosqu ad litora torquent per conubia nostra per inceptos hymenaeos etiam ultricies nisi vel augue praesent adipiscing proin faucibus arcu quis ante etiam ultricies nisi vel augue fusce pharetra convallis urna vestibulum eu odio nunc nulla maecenas vestibulum mollis diam vestibulum dapibus nunc ac augue nulla consequat massa quis enim donec vitae orci sed dolor rutrum auctor maecenas vestibulum mollis diam nam at tortor in tellus interdum sagittis aenean tellus metus bibendum sed posuere ac mattis non nunc fusce vulputate eleifend sapien nullam tincidunt adipiscing enim donec mi odio faucibus at scelerisque quis convallis in nisi cras id dui phasellus volutpat metus eget egestas mollis lacus lacus blandit dui id egestas quam mauris ut lacus integer ante arcu accumsan a consectetuer eget posuere ut mauris maecenas vestibulum mollis diam nam quam nunc blandit vel luctus pulvinar hendrerit id lorem in ut quam vitae odio lacinia tincidunt donec vitae sapien ut libero venenatis faucibus class aptent taciti sociosqu ad litora torquent per conubia nostra per inceptos hymenaeos etiam ultricies nisi vel augue praesent adipiscing proin faucibus arcu quis ante etiam ultricies nisi vel augue fusce pharetra convallis urna vestibulum eu odio nunc nulla maecenas vestibulum mollis diam vestibulum dapibus nunc ac augue nulla consequat massa quis enim donec vitae orci sed dolor rutrum auctor maecenas vestibulum mollis diam nam at tortor in tellus interdum sagittis aenean tellus metus bibendum sed posuere ac mattis non nunc fusce vulputate eleifend sapien nullam tincidunt adipiscing enim flower photography 5 average 45 2 votes  praesent metus tellus  permalink submitted by admin on wed 7092014 934 praesent metus tellus elementum eu semper a adipiscing nec purus phasellus nec sem in justo pellentesque facilisis in enim justo rhoncus ut imperdiet a venenatis vitae justo quisque malesuada placerat nisl nunc sed turpis drupal themes web development log in or register to post comments curabitur a felis in nunc permalink submitted by peter on wed 7092014 934 curabitur a felis in nunc fringilla tristique nullam tincidunt adipiscing enim phasellus tempus proin viverra ligula sit amet ultrices semper ligula arcu tristique sapien a accumsan nisi mauris ac eros nulla sit amet est log in or register to post comments  ',0),(12,'node',' 50 best apps and websites for travelers praesent ut ligula non mi varius sagittis curabitur nisi phasellus leo dolor tempus non auctor et hendrerit quis nisi curabitur at lacus ac velit ornare lobortis fusce fermentum nunc sed turpis praesent ut ligula non mi varius sagittis curabitur nisi phasellus leo dolor tempus non auctor et hendrerit quis nisi curabitur at lacus ac velit ornare lobortis proin convallis pretium lacus et rhoncus ipsum mollis eget proin convallis pretium lacus et rhoncus ipsum mollis eget mauris pulvinar leo non magna blandit sed viverra neque euismod vestibulum bibendum pretium nibh consequat tincidunt suspendisse consequat tortor nisi eget dictum orci vulputate vel morbi ultrices condimentum lacus semper venenatis leo ultrices sit amet ut et tincidunt purus non venenatis nibh etiam congue quam metus feugiat fringilla nunc congue nec donec ut condimentum justo nam ut leo et nisl consequat commodo donec lobortis nisi vel erat posuere porttitor interdum et malesuada fames ac ante ipsum primis in faucibus curabitur venenatis massa sit amet mi mollis sollicitudin duis ut purus tincidunt lobortis tortor a porttitor erat quisque suscipit mi eu euismod egestas cras quis porta augue morbi porttitor cursus eros fusce aliquam vel lorem ut dignissim fusce commodo nisl et arcu aliquam nec accumsan purus dictum in commodo eleifend justo eu sagittis libero laoreet in someone famous in source title h1 heading 1 sint occaecat cupidatat non proident sunt in culpa qui officia deserunt mollit anim id est laborum sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium totam rem aperiam eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo nemo enim ipsam voluptatem quia voluptas sit aspernatur aut odit aut fugit sed ut perspiciatis unde omnis iste natus error qui dolorem ipsum quia dolor sit amet consectetur adipisci velit h2 heading 2 sint occaecat cupidatat non proident sunt in culpa qui officia deserunt mollit anim id est laborum sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium totam rem aperiam eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo h3 heading 3 sint occaecat cupidatat non proident sunt in culpa qui officia deserunt mollit anim id est laborum sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium totam rem aperiam eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo cars sports nam quam nunc blandit vel  submitted by admin fri jul 11 2014 0907am permalink log in or register to post comments nam quam nunc blandit vel luctus pulvinar hendrerit id lorem vivamus laoreet phasellus magna in ac felis quis tortor malesuada pretium ut tincidunt tincidunt erat drupal themes web development ',0),(13,'node',' praesent nec nisl a purus ut tincidunt tincidunt erat praesent ac massa at ligula laoreet iaculis donec pede justo fringilla vel aliquet nec vulputate eget arcu nunc nec neque ut varius tincidunt libero phasellus volutpat metus eget egestas mollis lacus lacus blandit dui id egestas quam mauris ut lacus praesent ut ligula non mi varius sagittis quisque rutrum maecenas tempus tellus eget condimentum rhoncus sem quam semper libero sit amet adipiscing sem neque sed ipsum proin faucibus arcu quis ante nunc nonummy metus praesent metus tellus elementum eu semper a adipiscing nec purus morbi nec metus cras sagittis suspendisse nisl elit rhoncus eget elementum ac condimentum eget diam morbi nec metus suspendisse faucibus nunc et pellentesque egestas lacus ante convallis tellus vitae iaculis lacus elit id tortor sed augue ipsum egestas nec vestibulum et malesuada adipiscing dui proin sapien ipsum porta a auctor quis euismod ut mi curabitur at lacus ac velit ornare lobortis etiam iaculis nunc ac metus proin sapien ipsum porta a auctor quis euismod ut mi sed hendrerit sed consequat leo eget bibendum sodales augue velit cursus nunc quis gravida magna mi a libero  ',0),(14,'node',' praesent congue erat at massa duis vel nibh at velit scelerisque suscipit nulla consequat massa quis enim etiam sit amet orci eget eros faucibus tincidunt class aptent taciti sociosqu ad litora torquent per conubia nostra per inceptos hymenaeos etiam feugiat lorem non metus nunc egestas augue at pellentesque laoreet felis eros vehicula leo at malesuada velit leo quis pede ut tincidunt tincidunt erat mauris sollicitudin fermentum libero morbi ac felis nam adipiscing etiam ultricies nisi vel augue phasellus tempus maecenas vestibulum mollis diam fusce egestas elit eget lorem vestibulum purus quam scelerisque ut mollis sed nonummy id metus nullam dictum felis eu pede mollis pretium suspendisse enim turpis dictum sed iaculis a condimentum nec nisi phasellus dolor nullam dictum felis eu pede mollis pretium nulla neque dolor sagittis eget iaculis quis molestie non velit vestibulum rutrum mi nec elementum vehicula eros quam gravida nisl id fringilla neque ante vel mi nullam quis ante suspendisse pulvinar augue ac venenatis condimentum sem libero volutpat nibh nec pellentesque velit pede quis nunc pellentesque posuere  ',0),(15,'node',' what does weebpal do  general discussion we offer 4 main services community contribution premium themes web design development and web maintenance support find more details about us on our homepage and our about page select rating give it 15 give it 25 give it 35 give it 45 give it 55 your rating none average 5 1 vote  sun 7132014 2347  5 peter offline last seen 1 day 13 hours ago joined 7082014 922 donec sodales sagittis magna donec sodales sagittis magna praesent ut ligula non mi varius sagittis donec venenatis vulputate lorem suspendisse eu ligula pellentesque posuere etiam iaculis nunc ac metus fusce a quam suspendisse eu ligula praesent porttitor nulla vitae posuere iaculis arcu nisl dignissim dolor a pretium mi sem ut ipsum phasellus nec sem in justo pellentesque facilisis aliquam lobortis nullam dictum felis eu pede mollis pretium phasellus consectetuer vestibulum elit sed augue ipsum egestas nec vestibulum et malesuada adipiscing dui duis arcu tortor suscipit eget imperdiet nec imperdiet iaculis ipsum curabitur a felis in nunc fringilla tristique fusce vulputate eleifend sapien quisque ut nisi vivamus consectetuer hendrerit lacus in ut quam vitae odio lacinia tincidunt morbi mollis tellus ac sapien suspendisse nisl elit rhoncus eget elementum ac condimentum eget diam in consectetuer turpis ut velit mauris turpis nunc blandit et volutpat molestie porta ut ligula ut id nisl quis enim dignissim sagittis select rating give it 15 give it 25 give it 35 give it 45 give it 55 your rating none average 4 1 vote  top sun 7132014 2357  6 mical offline last seen 1 day 22 hours ago joined 7132014 2351 phasellus leo dolor tempus phasellus leo dolor tempus non auctor et hendrerit quis nisi nullam tincidunt adipiscing enim phasellus gravida semper nisi nulla facilisi ut leo fusce a quam vestibulum turpis sem aliquet eget lobortis pellentesque rutrum eu nisl fusce risus nisl viverra et tempor et pretium in sapien donec elit libero sodales nec volutpat a suscipit non turpis in turpis in hac habitasse platea dictumst vivamus in erat ut urna cursus vestibulum nullam accumsan lorem in dui donec id justo aliquam lorem ante dapibus in viverra quis feugiat a tellus aenean commodo ligula eget dolor quisque malesuada placerat nisl vivamus euismod mauris vestibulum ullamcorper mauris at ligula donec vitae sapien ut libero venenatis faucibus maecenas malesuada nam eget dui nam ipsum risus rutrum vitae vestibulum eu molestie vel lacus pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas nullam accumsan lorem in dui select rating give it 15 give it 25 give it 35 give it 45 give it 55 your rating none average 4 1 vote practice makes perfect  top ',0),(16,'node',' headline news general discussion drupal 6 extended support announcement on february 13 2008 drupal 6 was released the policy of the community is to support only the current and previous stable versions when drupal 6 was released drupal 47x was marked unsupported when drupal 7 came out drupal 5x was marked unsupported this policy was created to prevent core and module maintainers from having to maintain more than 2 active major versions of drupal with the coming drupal 8 release this policy has been questioned we want to ensure that sites that wish to move from drupal 6 to drupal 8 have a supported window within which to do so the drupal core team key module maintainers and representatives of the drupal security team met at drupalcon austin to discuss this as an inperson follow up to the previous discussion at https drupalorg node 2136029  drupal 6 core and modules will transition to unsupported status three months after drupal 8 is released unsupported status means the community will not be providing support or patches in the same way we do now continuing to support drupal 6 would be difficult for many reasons including a lack of automated test coverage the requirement for rigorous manual release testing the slowdown it introduces in the release of security fixes for the vast majority of drupal users on version 7 and the general shift of volunteers in the community moving their attention onto drupal 8 development this gives drupal 6 users a few options 1 upgrade to drupal 7 any time between now and 3 months after drupal 800 is released drupal 7 releases undergo almost 40000 automated tests and drupal 7 will be fully supported at least until drupal 9 comes out given the past history the release of drupal 9 is likely to be around 2018 2 upgrade to drupal 8 after it is released but before drupal 6 is not supported anymore fortunately migrate support for drupal 6 to drupal 8 is already in core and there is migrate ui a contributed module while not all contributed modules will be ready at the time drupal 8 is released drupal 8 s migration path handles most of the critical site data via its cck to entities fields in core migrations 3 find an organization that will provide extended support for drupal 6 the drupal security team will provide a method for companies and or individuals to work together in the private security issue queue to continue developing updates and will provide a reasonable amount of time for companies to provide patches to drupal 6 security issues that also affect drupal 7 or drupal 8 the security team will coordinate access to issues for companies wishing to provide extended support for drupal 6 however the team will not explicitly review or test the patches some team members may do this on their own all code created by these vendors would be released to the community organizations and individuals interested in providing this level of support for their customers and who have the technical knowledge to maintain a drupal core release should go to the security team drupal 6 long term support page both the security team and drupal core leadership feel that a 3month window after drupal 8 s release before eclipsing community support for drupal 6 is a workable compromise between leaving drupal 6 sites on an unsupported version the second drupal 8 comes out and acknowledging that our community s volunteer resources are limited and have shifted focus we hope that organizations that rely on drupal 6 will step up to help maintain it after community support winds down and or help their clients update to d8 select rating give it 15 give it 25 give it 35 give it 45 give it 55 your rating none average 45 2 votes  mon 7142014 5  7 admin online last seen 2 min 57 sec ago joined 6122014 1540 drupal 728 released drupal 728 a maintenance release with numerous bug fixes no security fixes is now available for download see the drupal 728 release notes for a full listing download drupal 728 upgrading your existing drupal 7 sites is recommended there are no major new features in this release for more information about the drupal 7x release series consult the drupal 70 release announcement security information we have a security announcement mailing list and a history of all security advisories as well as an rss feed with the most recent security advisories we strongly advise drupal administrators to sign up for the list drupal 7 includes the builtin update manager module which informs you about important updates to your modules and themes there are no security fixes in this release of drupal core bug reports drupal 7x is being maintained so given enough bug fixes not just bug reports more maintenance releases will be made available according to our monthly release cycle changelog drupal 728 contains bug fixes and small api feature improvements only the full list of changes between the 727 and 728 releases can be found by reading the 728 release notes a complete list of all bug fixes in the stable 7x branch can be found in the git commit log update notes see the 728 release notes for details on important changes in this release known issues changes made to the update manager module in this release may lead to performance slowdowns in certain cases including on rare page loads for site visitors if the site is using the automated cron feature see the release notes for more information select rating give it 15 give it 25 give it 35 give it 45 give it 55 your rating none average 4 2 votes  drupal themes web development top log in or register to post comments  ',0),(17,'node',' review front page promotion requests show off your drupal site excepteur sint occaecat cupidatat non proident sunt in culpa qui officia deserunt mollit anim id est laborum sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium totam rem aperiam eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo nulla facilisi cras convallis vel lectus sed convallis duis nec accumsan diam vestibulum blandit tempus nulla suspendisse consectetur cursus elit et scelerisque ligula hendrerit id maecenas ultrices porta nunc quis consectetur risus morbi non metus eget nibh vulputate tincidunt nullam dui quam suscipit a ligula a posuere sagittis magna pellentesque vitae dolor et nunc lobortis vestibulum suspendisse potenti pellentesque cursus purus vitae libero hendrerit congue aenean erat elit aliquet at mi quis sollicitudin sollicitudin libero sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium totam rem aperiam eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo h1 heading 1 sint occaecat cupidatat non proident sunt in culpa qui officia deserunt mollit anim id est laborum sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium totam rem aperiam eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo nemo enim ipsam voluptatem quia voluptas sit aspernatur aut odit aut fugit sed ut perspiciatis unde omnis iste natus error qui dolorem ipsum quia dolor sit amet consectetur adipisci velit h2 heading 2 sint occaecat cupidatat non proident sunt in culpa qui officia deserunt mollit anim id est laborum sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium totam rem aperiam eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo h3 heading 3 sint occaecat cupidatat non proident sunt in culpa qui officia deserunt mollit anim id est laborum sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium totam rem aperiam eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo select rating give it 15 give it 25 give it 35 give it 45 give it 55 your rating none average 4 1 vote  ',0),(18,'node',' hosting hosting support the hosting section is managed by the drupal association learn how to get listed on the hosting page or other advertising opportunities on advertising on drupalorg page on the drupal association website hosting companies may also be listed in the services section of the marketplace learn how to get listed in the services section of the marketplace on the marketplace guidelines select rating give it 15 give it 25 give it 35 give it 45 give it 55 no votes yet  ',0),(19,'node',' installing drush on shared hosting accounts paid drupal services attention this page does not yet reflect new changes to drush that apparently make composer a prerequisite to drush installation in the newer branches i don t have time to explore this right now if you have the knowledge please update this page to reflect that then remove this message in the meantime users of this page can still install older versions of drush using this method some instructions on installing composer can be found in the comments  if you don t already have shell access request access to ssh for your shared hosting account eg for hostmonster or green geeks open a new support ticket with tech support  update  shell access can now be enabled from cpanel for some hostmonster hosting accounts for other hosting services you may need to upgrade to use ssh  once you have received ssh access to your site open a new terminal and login to your site by typing the following ssh username yourdomaincom or any additional user login string provided by your hosting service enter your password when prompted by default you should be in your home directory if you are not in your home directory navigate yourself there by using the cd cd change directory command the is an alias for your home directory on hostmonster and nearly every other linux shared hosting situation your website directory is located at  publichtml  or more specifically  www htdocs username  confirm you are in your home directory by typing the bash shell command ls which will list the files and folders in the current directory on hostmonster you should see publichtml publicftp and a bunch of other files make special note of a file named bashrc as we will be editing it later download drush by typing wget https githubcom drushops drush archive 6xzip at the time of this edit the drush 6 branch is the recommended version and is no longer available for download on drupalorg extract the zip file by typing in unzip 6x and remove zip file by typing rm 6xzip tip type clear and hit enter this will clear your screen and give you a little more breathing room do this as much as you want to throughout this process  important  if your host s configuration does not allow for the wget command you may alternately download the zip file of the recommended branch currently https githubcom drushops drush tree 6x  and manually upload and extract via the host s cpanel file manager or an ftp program of your choice type ls again to list your directory you should now see drush in the directory if the directory is drush6x rename to drush with mv command  type chmod u x drush to set the correct permissions on the drush command tip type ls la to see the permissions and owners on the items in the directory next in order to use drush across our installation emdash in all of our subfolders emdash we need to add a line to our bashrc file while still in your home directory type the following nano bashrc this will open up bashrc in a text editor named nano note for godaddy accounts there is no nano application for new cpanel accounts nano is available use vim instead so type vim bashrc to edit the file a good vim cheatsheet is  http wwwfprintfnet vimcheatsheethtml  locate user specific aliases and functions underneath that add the following alias drush drush drush save the file by typing ctrl x exit and type y to accept your changes type source bashrc to refresh the alias list and allow the new drush commands to work confirm that drush is working by typing drush at the command prompt and hitting enter you should see a list of drush commands if you do then success if the previous step doesn t work type exit to end your ssh session then log back in see step 2  to restart your session this refreshes bashrc and allows the new drush commands to work some hosting providers such as godaddy  legacy accounts use phpcgi in the command line instead of phpcli  the former is not compatible with drush and if this is your case you have to locate phpcli and then add the following lines to your bashrc or bashprofile file export columnsalias drush usr local php5 bin php drush drushphp alias php usr local php5 bin php you have now added drush hot sauce to your shared host awesome once again this should work on any shared hosting linux platforms that allow shell access on hostmonster or green geeks you have to specifically ask them to turn it on if you do not have a bashrc file in your home directory try making it by typing touch bashrc you can also try using a file named profile bashaliases or bashprofile depending on your server s setup ssh config since you ll be using the ssh login prompt a lot you might consider creating a local alias for your login credentials follow this link for detailed instructions  note that in a drush sitealias configuration you would use the host name configured in this file as remotehost and no remoteuser  editorial comments for all those who didn t really understand the instructions and are just trying to follow it as it is written here s a bit of advice  only use drush if you start to understand it even a little bit shell commands and drush commands are very powerful and not recommended for learning on production sites or sites with a live server deadline because you can mess things up very quickly your shared hosting support won t be happy if you create code loops through failure another bit of advice if you are not a fulltime developer you should always use the stable nonbeta releases of drush and should never use the additional y command to avoid the security question are you sure you want y n to put it another way read the instructions twice understand what the commands mean and what they do don t rely solely on copy paste in the long run you will save your self time which is the whole point of drush in the first place let s take the alias command as an example you can exchange the bashrc alias line with something else like alias ddd drush drush  instead of alias drush drush drush   this actually changes the way you use the drush command later your commands will start with ddd your command  then instead of drush your command   and you can also add other aliases of course like  alias dddl drush drush en   which simplifies thee oftenused drush en command from drush dl to dddl  in short it is well worth your time and safer to go ahead and learn how to properly use bash commands if you plan on using drush the drush documentation is a great place to start it will teach you about drush commands and how to use them select rating give it 15 give it 25 give it 35 give it 45 give it 55 no votes yet  ',0),(20,'node',' system requirements before you start note this page should not be edited without first discussing the changes in a drupal core issue as the requirements for each version of drupal are decided upon by the drupal core developers to install and run drupal your web server must meet certain minimum requirements most web hosting companies meet these requirements however a few stand out by also actively supporting the drupal community if you need hosting consider selecting one of these web hosts  disk space a minimum installation requires 15 megabytes 60 mb is needed for a website with many contributed modules and themes installed keep in mind you need much more for the database files uploaded by the users media backups and other files web server apache nginx or microsoft iis more details about web server requirements database drupal 6 mysql 41 or higher postgresql 71 drupal 7 mysql 5015 or higher with pdo postgresql 83 or higher with pdo sqlite 337 or higher drupal 8 mysql 5015 mariadb percona equivalent or higher with pdo and an innodbcompatible primary storage engine postgresql 83 or higher with pdo sqlite 337 or higher microsoft sql server and oracle are supported by additional modules more details about database requirements php drupal 6 php 52x only warning support for php 4x has been dropped php 53 and later may produce errors or unexpected behaviour drupal 7 php 525 or higher 53 recommended drupal 8 php 54 or higher more details about php requirements  including php memory  see also the site performance section of the administration guide and the webhosting troubleshooting faq  select rating give it 15 give it 25 give it 35 give it 45 give it 55 no votes yet  ',0),(21,'node',' web server before you start drupal works on any web server with php support apache recommended  apache is the most commonly used web server for drupal drupal will work on apache 2x hosted on unix linux os x or windows the majority of drupal development and deployment is done on apache so there is more community experience and testing performed on apache than on other web servers drupal 7 and 6 will likely work on apache 13 you can use the apache modrewrite extension to allow for clean urls  the apache virtualhost configuration must contain the directive allowoverride all to allow drupal s htaccess file to be used nginx nginx is a commonly used web server that focuses on high concurrency performance and low memory usage drupal will work on nginx legacy versions 07x 08x 10x 12x stable 14x versions and mainline 15x versions hosted on unix linux os x or windows nginx is a popular alternative to apache so there is also significant community experience and testing performed on nginx for information on enabling clean urls see clean urls with nginx  hiawatha hiawatha is a web server with a strong focus on security it also aims at being easy to use and being lightweight research performed by independent researchers proves that hiawatha offers a performance comparable to other web servers under normal conditions  but much better while under attack  hiawatha is fully compatible with drupal for information about the required url rewriting rules to use drupal with hiawatha read clean urls with hiawatha  microsoft iis microsoft iis is a web server and set of feature extension modules for use with microsoft windows drupal core will work with iis 5 iis 6 or iis 7 if php is configured correctly to achieve clean urls you may need to use a third party product for iis 7 you can use the microsoft url rewrite module or a third party solution on iis 7 drupal requires windows 2008 server sp2 or later for fastcgi support select rating give it 15 give it 25 give it 35 give it 45 give it 55 no votes yet  ',0),(22,'node',' database server before you start recommended  mysql  or an equivalent such as mariadb or percona server   mysql drupal 6 supports mysql 41 or higher but mysql 5015 or higher is recommended drupal 7 supports mysql 5015 or higher or mysql 5130 or higher and requires the pdo database extension for php see what is pdo   drupal 8 supports mysql 5015 or higher or mysql 5130 or higher with innodb as the primary storage engine and requires the pdo database extension there are several dropin replacements for mysql drupal has been extensively tested with mariadb  and version 5144 or greater is recommended it is also likely that other dropin replacements such as percona server will work well with drupal but they may not have specifically undergone testing notes drupal makes use of some features not available on some inexpensive hosting plans so please check that your host allows database accounts with the following rights select insert update delete create drop index alter these rights are sufficient to run drupal 6 and 7 some contributed modules and also drupal core 5x but not drupal core 6x additionally require the following rights create temporary tables lock tables it may be necessary to set the system variable maxallowedpacket to at least 16m some inexpensive hosting plans set this value too low the mysql default is only 1m in that case you may need to choose a better hosting plan a value of 1m may be sufficient for drupal 5 drupal 7 and earlier support myisam and innodb table types drupal 8 no longer supports myisam as the primary storage engine so innodb table types are recommended ndb tables mysql cluster are not supported note that if your web hosting account is set up with a graphic control panel such as plesk or cpanel it is very likely that you do not need to worry about installing a driver for mysql it is probably already installed on your server you might wish to simply create your database and proceed with installing drupal and then refer back to drupal documentation for specific troubleshooting help if you run into problems postgresql note some contributed modules are not as abstracted from mysqlspecific code as everyone would like if you are familiar with postgresql please file issues with those contributed modules as you find them drupal 6 supports postgresql 71 or higher drupal 7 supports postgresql 83 or higher sqlite sqlite 337 or higher drupal 7 only note some contributed modules are not as abstracted from mysqlspecific code as everyone would like if you are familiar with sqlite please file issues with those contributed modules as you find them other database servers microsoft sql server   oracle  and mongodb are supported by additional modules please see discussions in the enterprise group if you are interested in working on database support select rating give it 15 give it 25 give it 35 give it 45 give it 55 no votes yet  ',0),(23,'node',' basic shortcodes quote example this is my quote shortcode  quote class myquote this is my quote quote  image example shortcode  img src sites all themes forumplus logopng class myimage alt logo image  highlight example this is highlight text shortcode  highlight class myhighlight this is highlight text highlight  button example this is my button shortcode  button path class mybutton this is my button button  dropcap example this is dropcap shortcode  dropcap class mydropcap this is dropcap dropcap  item example this is an item shortcode  item class myitem type span this is an item item  ',0),(24,'node',' tooltip quote example this is my left quote this is my top quote this is my right quote this is my bottom quote shortcode  tooltip class mytooltip placement left title left this is my quote tooltip  ',0),(25,'node',' video video example  http wwwyoutubecom watch v qgluydime4 shortcode  video https wwwyoutubecom watch v qgluydime4 video  ',0),(26,'node',' collapse video example accordion item 1 praesent vestibulum dapibus nibh phasellus viverra nulla ut metus varius laoreet pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas suspendisse feugiat nunc nulla praesent egestas neque eu enim phasellus leo dolor tempus non auctor et hendrerit quis nisi fusce neque in hac habitasse platea dictumst in hac habitasse platea dictumst accordion item 2 quisque id odio nunc interdum lacus sit amet orci nulla sit amet est curabitur ligula sapien tincidunt non euismod vitae posuere imperdiet leo maecenas ullamcorper dui et placerat feugiat eros pede varius nisi condimentum viverra felis nunc et lorem shortcode  collapse accordion title accordion item 1 praesent vestibulum dapibus nibh phasellus viverra nulla ut metus varius laoreet pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas suspendisse feugiat nunc nulla praesent egestas neque eu enim phasellus leo dolor tempus non auctor et hendrerit quis nisi fusce neque in hac habitasse platea dictumst in hac habitasse platea dictumst accordion accordion title accordion item 2 quisque id odio nunc interdum lacus sit amet orci nulla sit amet est curabitur ligula sapien tincidunt non euismod vitae posuere imperdiet leo maecenas ullamcorper dui et placerat feugiat eros pede varius nisi condimentum viverra felis nunc et lorem accordion collapse  ',0),(27,'node',' 35 reasons rain is better than sunshine praesent ut ligula non mi varius sagittis curabitur nisi phasellus leo dolor tempus non auctor et hendrerit quis nisi curabitur at lacus ac velit ornare lobortis fusce fermentum nunc sed turpis praesent ut ligula non mi varius sagittis curabitur nisi phasellus leo dolor tempus non auctor et hendrerit quis nisi curabitur at lacus ac velit ornare lobortis proin convallis pretium lacus et rhoncus ipsum mollis eget proin convallis pretium lacus et rhoncus ipsum mollis eget mauris pulvinar leo non magna blandit sed viverra neque euismod vestibulum bibendum pretium nibh consequat tincidunt suspendisse consequat tortor nisi eget dictum orci vulputate vel morbi ultrices condimentum lacus semper venenatis leo ultrices sit amet ut et tincidunt purus non venenatis nibh etiam congue quam metus feugiat fringilla nunc congue nec donec ut condimentum justo nam ut leo et nisl consequat commodo donec lobortis nisi vel erat posuere porttitor interdum et malesuada fames ac ante ipsum primis in faucibus curabitur venenatis massa sit amet mi mollis sollicitudin duis ut purus tincidunt lobortis tortor a porttitor erat quisque suscipit mi eu euismod egestas cras quis porta augue morbi porttitor cursus eros fusce aliquam vel lorem ut dignissim fusce commodo nisl et arcu aliquam nec accumsan purus dictum in commodo eleifend justo eu sagittis libero laoreet in someone famous in source title h1 heading 1 sint occaecat cupidatat non proident sunt in culpa qui officia deserunt mollit anim id est laborum sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium totam rem aperiam eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo nemo enim ipsam voluptatem quia voluptas sit aspernatur aut odit aut fugit sed ut perspiciatis unde omnis iste natus error qui dolorem ipsum quia dolor sit amet consectetur adipisci velit h2 heading 2 sint occaecat cupidatat non proident sunt in culpa qui officia deserunt mollit anim id est laborum sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium totam rem aperiam eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo h3 heading 3 sint occaecat cupidatat non proident sunt in culpa qui officia deserunt mollit anim id est laborum sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium totam rem aperiam eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo css3 animation ',0),(28,'node',' 20 decorating secrets praesent ut ligula non mi varius sagittis curabitur nisi phasellus leo dolor tempus non auctor et hendrerit quis nisi curabitur at lacus ac velit ornare lobortis fusce fermentum nunc sed turpis praesent ut ligula non mi varius sagittis curabitur nisi phasellus leo dolor tempus non auctor et hendrerit quis nisi curabitur at lacus ac velit ornare lobortis proin convallis pretium lacus et rhoncus ipsum mollis eget proin convallis pretium lacus et rhoncus ipsum mollis eget mauris pulvinar leo non magna blandit sed viverra neque euismod vestibulum bibendum pretium nibh consequat tincidunt suspendisse consequat tortor nisi eget dictum orci vulputate vel morbi ultrices condimentum lacus semper venenatis leo ultrices sit amet ut et tincidunt purus non venenatis nibh etiam congue quam metus feugiat fringilla nunc congue nec donec ut condimentum justo nam ut leo et nisl consequat commodo donec lobortis nisi vel erat posuere porttitor interdum et malesuada fames ac ante ipsum primis in faucibus curabitur venenatis massa sit amet mi mollis sollicitudin duis ut purus tincidunt lobortis tortor a porttitor erat quisque suscipit mi eu euismod egestas cras quis porta augue morbi porttitor cursus eros fusce aliquam vel lorem ut dignissim fusce commodo nisl et arcu aliquam nec accumsan purus dictum in commodo eleifend justo eu sagittis libero laoreet in someone famous in source title h1 heading 1 sint occaecat cupidatat non proident sunt in culpa qui officia deserunt mollit anim id est laborum sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium totam rem aperiam eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo nemo enim ipsam voluptatem quia voluptas sit aspernatur aut odit aut fugit sed ut perspiciatis unde omnis iste natus error qui dolorem ipsum quia dolor sit amet consectetur adipisci velit h2 heading 2 sint occaecat cupidatat non proident sunt in culpa qui officia deserunt mollit anim id est laborum sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium totam rem aperiam eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo h3 heading 3 sint occaecat cupidatat non proident sunt in culpa qui officia deserunt mollit anim id est laborum sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium totam rem aperiam eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo nam ipsum risus rutrum vitae vestibulum eu molestie vel lacus fusce egestas elit eget lorem duis leo vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia curae fusce id purus donec id justo quisque id odio nunc interdum lacus sit amet orci vestibulum dapibus nunc ac augue etiam iaculis nunc ac metus nunc nonummy metus drupal themes ',0),(29,'node',' here s how much it costs to raise a child praesent ut ligula non mi varius sagittis curabitur nisi phasellus leo dolor tempus non auctor et hendrerit quis nisi curabitur at lacus ac velit ornare lobortis fusce fermentum nunc sed turpis praesent ut ligula non mi varius sagittis curabitur nisi phasellus leo dolor tempus non auctor et hendrerit quis nisi curabitur at lacus ac velit ornare lobortis proin convallis pretium lacus et rhoncus ipsum mollis eget proin convallis pretium lacus et rhoncus ipsum mollis eget mauris pulvinar leo non magna blandit sed viverra neque euismod vestibulum bibendum pretium nibh consequat tincidunt suspendisse consequat tortor nisi eget dictum orci vulputate vel morbi ultrices condimentum lacus semper venenatis leo ultrices sit amet ut et tincidunt purus non venenatis nibh etiam congue quam metus feugiat fringilla nunc congue nec donec ut condimentum justo nam ut leo et nisl consequat commodo donec lobortis nisi vel erat posuere porttitor interdum et malesuada fames ac ante ipsum primis in faucibus curabitur venenatis massa sit amet mi mollis sollicitudin duis ut purus tincidunt lobortis tortor a porttitor erat quisque suscipit mi eu euismod egestas cras quis porta augue morbi porttitor cursus eros fusce aliquam vel lorem ut dignissim fusce commodo nisl et arcu aliquam nec accumsan purus dictum in commodo eleifend justo eu sagittis libero laoreet in someone famous in source title h1 heading 1 sint occaecat cupidatat non proident sunt in culpa qui officia deserunt mollit anim id est laborum sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium totam rem aperiam eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo nemo enim ipsam voluptatem quia voluptas sit aspernatur aut odit aut fugit sed ut perspiciatis unde omnis iste natus error qui dolorem ipsum quia dolor sit amet consectetur adipisci velit h2 heading 2 sint occaecat cupidatat non proident sunt in culpa qui officia deserunt mollit anim id est laborum sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium totam rem aperiam eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo h3 heading 3 sint occaecat cupidatat non proident sunt in culpa qui officia deserunt mollit anim id est laborum sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium totam rem aperiam eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo ut varius tincidunt libero sed lectus fusce vel dui aenean commodo ligula eget dolor fusce vulputate eleifend sapien web design ecommerce ',0),(30,'node',' 7 exercises that will transform your body praesent ut ligula non mi varius sagittis curabitur nisi phasellus leo dolor tempus non auctor et hendrerit quis nisi curabitur at lacus ac velit ornare lobortis fusce fermentum nunc sed turpis praesent ut ligula non mi varius sagittis curabitur nisi phasellus leo dolor tempus non auctor et hendrerit quis nisi curabitur at lacus ac velit ornare lobortis proin convallis pretium lacus et rhoncus ipsum mollis eget proin convallis pretium lacus et rhoncus ipsum mollis eget mauris pulvinar leo non magna blandit sed viverra neque euismod vestibulum bibendum pretium nibh consequat tincidunt suspendisse consequat tortor nisi eget dictum orci vulputate vel morbi ultrices condimentum lacus semper venenatis leo ultrices sit amet ut et tincidunt purus non venenatis nibh etiam congue quam metus feugiat fringilla nunc congue nec donec ut condimentum justo nam ut leo et nisl consequat commodo donec lobortis nisi vel erat posuere porttitor interdum et malesuada fames ac ante ipsum primis in faucibus curabitur venenatis massa sit amet mi mollis sollicitudin duis ut purus tincidunt lobortis tortor a porttitor erat quisque suscipit mi eu euismod egestas cras quis porta augue morbi porttitor cursus eros fusce aliquam vel lorem ut dignissim fusce commodo nisl et arcu aliquam nec accumsan purus dictum in commodo eleifend justo eu sagittis libero laoreet in someone famous in source title h1 heading 1 sint occaecat cupidatat non proident sunt in culpa qui officia deserunt mollit anim id est laborum sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium totam rem aperiam eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo nemo enim ipsam voluptatem quia voluptas sit aspernatur aut odit aut fugit sed ut perspiciatis unde omnis iste natus error qui dolorem ipsum quia dolor sit amet consectetur adipisci velit h2 heading 2 sint occaecat cupidatat non proident sunt in culpa qui officia deserunt mollit anim id est laborum sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium totam rem aperiam eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo h3 heading 3 sint occaecat cupidatat non proident sunt in culpa qui officia deserunt mollit anim id est laborum sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium totam rem aperiam eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo design photoshop onepage vestibulum rutrum mi nec submitted by peter mon aug 11 2014 0908pm permalink log in or register to post comments vestibulum rutrum mi nec elementum vehicula eros quam gravida nisl id fringilla neque ante vel mi vestibulum fringilla pede sit amet augue sed a libero fusce convallis metus id felis luctus adipiscing donec pede justo fringilla vel aliquet nec vulputate eget arcu  ',0),(31,'node',' 31 healthy foods you should be eating now praesent ut ligula non mi varius sagittis curabitur nisi phasellus leo dolor tempus non auctor et hendrerit quis nisi curabitur at lacus ac velit ornare lobortis fusce fermentum nunc sed turpis praesent ut ligula non mi varius sagittis curabitur nisi phasellus leo dolor tempus non auctor et hendrerit quis nisi curabitur at lacus ac velit ornare lobortis proin convallis pretium lacus et rhoncus ipsum mollis eget proin convallis pretium lacus et rhoncus ipsum mollis eget mauris pulvinar leo non magna blandit sed viverra neque euismod vestibulum bibendum pretium nibh consequat tincidunt suspendisse consequat tortor nisi eget dictum orci vulputate vel morbi ultrices condimentum lacus semper venenatis leo ultrices sit amet ut et tincidunt purus non venenatis nibh etiam congue quam metus feugiat fringilla nunc congue nec donec ut condimentum justo nam ut leo et nisl consequat commodo sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium totam rem aperiam eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo h1 heading 1 sint occaecat cupidatat non proident sunt in culpa qui officia deserunt mollit anim id est laborum sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium totam rem aperiam eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo nemo enim ipsam voluptatem quia voluptas sit aspernatur aut odit aut fugit sed ut perspiciatis unde omnis iste natus error qui dolorem ipsum quia dolor sit amet consectetur adipisci velit h2 heading 2 sint occaecat cupidatat non proident sunt in culpa qui officia deserunt mollit anim id est laborum sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium totam rem aperiam eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo h3 heading 3 sint occaecat cupidatat non proident sunt in culpa qui officia deserunt mollit anim id est laborum sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium totam rem aperiam eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo phasellus gravida semper nisi praesent congue erat at massa nullam vel sem nullam vel sem vivamus consectetuer hendrerit lacus maecenas tempus tellus eget condimentum rhoncus sem quam semper libero sit amet adipiscing sem neque sed ipsum vivamus laoreet cras sagittis pellentesque auctor neque nec urna nullam quis ante development drupal themes vivamus id interdum odio submitted by peter mon aug 11 2014 0908pm permalink log in or register to post comments vivamus id interdum odio vivamus eu lectus eros aliquam vel nisi sagittis lectus pretium egestas integer nisi ligula pulvinar vitae arcu vitae cursus mattis massa vestibulum tempor metus feugiat condimentum iaculis mauris ornare nec neque eget rhoncus etiam nisi enim blandit non porta amet phasellus nec sem in justo submitted by admin mon aug 11 2014 0908pm permalink log in or register to post comments phasellus nec sem in justo pellentesque facilisis donec interdum metus et hendrerit aliquet dolor diam sagittis ligula eget egestas libero turpis vel mi praesent ut ligula non mi varius sagittis fusce vel dui vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia curae sed aliquam nisi quis porttitor congue elit erat euismod orci ac placerat dolor lectus quis orci drupal themes web development vestibulum rutrum mi nec submitted by peter mon aug 11 2014 0908pm permalink log in or register to post comments vestibulum rutrum mi nec elementum vehicula eros quam gravida nisl id fringilla neque ante vel mi vestibulum fringilla pede sit amet augue sed a libero fusce convallis metus id felis luctus adipiscing donec pede justo fringilla vel aliquet nec vulputate eget arcu  ',0),(33,'node',' 404 page phasellus facilisis feugiat convallis suspendisse vestibulum ante ut sagittis viverra mauris tincidunt id neque ac malesuada aliquam cursus pharetra suscipit fusce non arcu eros nulla pretium dictum felis vitae feugiat dui congue nec phasellus eu enim id leo sodales lacinia eu ultrices odio proin placerat ut ligula vel ornare proin purus lacus hendrerit sed rutrum a condimentum mattis lorem aliquam aliquam elit id suscipit molestie neque est viverra arcu nec vulputate nibh tortor et quam nam dictum nisi in consequat ultricies lacus dui fringilla sem ac luctus mi odio ullamcorper massa integer id neque mauris sed dignissim eget purus vitae ullamcorper donec faucibus malesuada odio et commodo nulla sed adipiscing sem id feugiat diam curabitur dapibus ut mauris at consectetur praesent ut tempus nisl commodo hendrerit dui proin venenatis sit amet nisl id feugiat sed imperdiet luctus felis nunc at neque turpis sed ac neque dolor mauris sollicitudin erat nisi quis venenatis augue lobortis et nulla consectetur urna a dui sagittis et sagittis lorem malesuada suspendisse potenti praesent felis justo ultricies vestibulum mauris et tempor ultricies metus  ',0),(34,'node',' margaret thank you very much lorem ipsum dolor sit amet consectetur adipiscing elit pellentesque eget dolor sit amet lorem vulputate aliquet praesent eu dignissim turpis duis volutpat gravida tincidunt vivamus sodales ligula in accumsan accumsan nunc adipiscing posuere ultricies class aptent taciti sociosqu ad litora torquent per conubia nostra per inceptos himenaeos praesent vehicula justo id nunc facilisis volutpat porttitor id eros ut aliquet sodales purus in pretium risus consequat id proin convallis pretium lacus et rhoncus ipsum mollis eget mauris pulvinar leo non magna blandit sed viverra neque euismod vestibulum bibendum pretium nibh consequat tincidunt suspendisse consequat tortor nisi eget dictum orci vulputate vel morbi ultrices condimentum lacus semper venenatis leo ultrices sit amet ut et tincidunt purus non venenatis nibh etiam congue quam metus feugiat fringilla nunc congue nec donec ut condimentum justo nam ut leo et nisl consequat commodo nullam tempus rutrum massa eu ullamcorper turpis dapibus at vestibulum feugiat ligula eu nibh vehicula varius donec lobortis nisi vel erat posuere porttitor interdum et malesuada fames ac ante ipsum primis in faucibus curabitur venenatis massa sit amet mi mollis sollicitudin duis ut purus tincidunt lobortis tortor a porttitor erat quisque suscipit mi eu euismod egestas cras quis porta augue morbi porttitor cursus eros fusce aliquam vel lorem ut dignissim fusce commodo nisl et arcu aliquam nec accumsan purus dictum in commodo eleifend justo eu sagittis libero laoreet in someone famous in source title aliquam elementum turpis eget felis eleifend id sodales dui ultrices fusce rhoncus libero sed consectetur commodo arcu nisl malesuada sem commodo facilisis risus diam eu sapien aenean iaculis urna id ultrices lacinia lacus lectus commodo neque vel tincidunt lectus quam ac tellus sed interdum mattis neque nec rhoncus lorem laoreet ornare vestibulum dignissim libero non convallis pulvinar leo lectus dignissim risus ac consequat metus purus sed nisi aliquam erat volutpat vivamus elementum feugiat orci nam vitae elementum risus porta luctus tortor proin luctus tristique massa phasellus volutpat id leo sed facilisis vestibulum accumsan libero eu arcu malesuada luctus nulla porta mi quis nisi pellentesque vehicula cras enim mi venenatis quis odio in dapibus venenatis mauris integer et faucibus justo sed mauris odio sodales ut elit scelerisque volutpat pellentesque felis nullam justo lacus tempus a leo id scelerisque hendrerit arcu nulla et nulla sit amet justo pulvinar cursus pellentesque fermentum mollis leo ac iaculis lacus mattis id suspendisse ornare vitae nisl at volutpat aliquam nisi lacus adipiscing at neque ac volutpat interdum nisl ut bibendum elit quam a pharetra augue laoreet eget vestibulum bibendum dui ultrices cursus nisi eu commodo lorem suspendisse placerat risus eu magna congue malesuada nam sed cursus tellus vitae vehicula est donec ut massa elit interdum et malesuada fames ac ante ipsum primis in faucibus video ',0),(35,'node',' beautiful light music easy smooth inspirational long playlist by relaxdaily ocean breeze praesent sit amet enim tempus lobortis eros adipiscing consequat nisl nam eget euismod justo aenean non elit eleifend feugiat augue vitae sagittis nibh vivamus a ante dolor integer pharetra euismod est vitae volutpat enim viverra a vivamus velit augue facilisis vel tortor eu dignissim suscipit urna maecenas pellentesque facilisis sapien non hendrerit aliquam sodales turpis dui sit amet blandit nunc fringilla eget fusce congue massa eu elit molestie tempor id vitae justo maecenas rhoncus egestas felis a ornare magna laoreet vel sed id tincidunt enim aenean vulputate ut felis et consectetur nullam quis viverra augue ut imperdiet orci morbi in vulputate dui eget tempus mi nunc ac convallis justo adipiscing sodales erat nullam venenatis bibendum condimentum aliquam egestas eget mauris sollicitudin egestas curabitur ullamcorper massa est ut faucibus tellus aliquet quis proin eu porta augue aenean eu ligula elementum arcu sagittis iaculis aliquam dapibus pulvinar faucibus cras vel orci suscipit consequat metus gravida convallis eros pellentesque congue tellus non felis sollicitudin bibendum maecenas risus risus accumsan eu lectus a congue massa nunc video ',0),(36,'node',' one direction what makes you beautiful 5 piano guys 1 piano thepianoguys donec posuere vulputate arcu phasellus consectetuer vestibulum elit nam commodo suscipit quam fusce pharetra convallis urna donec sodales sagittis magna vestibulum turpis sem aliquet eget lobortis pellentesque rutrum eu nisl sed magna purus fermentum eu tincidunt eu varius ut felis vivamus laoreet in ut quam vitae odio lacinia tincidunt sed aliquam ultrices mauris sed mollis eros et ultrices tempus mauris ipsum aliquam libero non adipiscing dolor urna a orci fusce risus nisl viverra et tempor et pretium in sapien duis vel nibh at velit scelerisque suscipit nullam vel sem in hac habitasse platea dictumst cras dapibus duis arcu tortor suscipit eget imperdiet nec imperdiet iaculis ipsum proin faucibus arcu quis ante maecenas vestibulum mollis diam praesent blandit laoreet nibh donec quam felis ultricies nec pellentesque eu pretium quis sem phasellus leo dolor tempus non auctor et hendrerit quis nisi vivamus aliquet elit ac nisl fusce a quam suspendisse potenti video music ',0),(37,'node',' the san juans proven here aenean ut eros et nisl sagittis vestibulum suspendisse potenti proin viverra ligula sit amet ultrices semper ligula arcu tristique sapien a accumsan nisi mauris ac eros cras sagittis vivamus consectetuer hendrerit lacus pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas vivamus quis mi etiam sit amet orci eget eros faucibus tincidunt phasellus nec sem in justo pellentesque facilisis fusce egestas elit eget lorem nullam sagittis nullam dictum felis eu pede mollis pretium ut leo quisque malesuada placerat nisl donec vitae orci sed dolor rutrum auctor ut varius tincidunt libero in ut quam vitae odio lacinia tincidunt sed hendrerit nam eget dui aenean viverra rhoncus pedeaenean imperdiet cras sagittis pellentesque libero tortor tincidunt et tincidunt eget semper nec quam fusce a quam sed consequat leo eget bibendum sodales augue velit cursus nunc quis gravida magna mi a libero maecenas egestas arcu quis ligula mattis placerat in auctor lobortis lacus mauris sollicitudin fermentum libero etiam feugiat lorem non metus vestibulum dapibus nunc ac augue maecenas malesuada vestibulum rutrum mi nec elementum vehicula eros quam gravida nisl id fringilla neque ante vel mi vestibulum rutrum mi nec elementum vehicula eros quam gravida nisl id fringilla neque ante vel mi vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia curae sed aliquam nisi quis porttitor congue elit erat euismod orci ac placerat dolor lectus quis orci maecenas tempus tellus eget condimentum rhoncus sem quam semper libero sit amet adipiscing sem neque sed ipsum praesent nonummy mi in odio praesent nonummy mi in odio quisque libero metus condimentum nec tempor a commodo mollis magna vivamus euismod mauris donec pede justo fringilla vel aliquet nec vulputate eget arcu phasellus dolor phasellus magna nulla porta dolor etiam imperdiet imperdiet orci nunc egestas augue at pellentesque laoreet felis eros vehicula leo at malesuada velit leo quis pede video staff picks curabitur ullamcorper permalink submitted by admin on mon 8182014 2358 curabitur ullamcorper ultricies nisi nullam tincidunt adipiscing enim etiam iaculis nunc ac metus curabitur at lacus ac velit ornare lobortis pellentesque commodo eros a enim drupal themes web development log in or register to post comments  ',0),(38,'node',' stop motion lorem ipsum dolor sit amet consectetur adipiscing elit pellentesque eget dolor sit amet lorem vulputate aliquet praesent eu dignissim turpis duis volutpat gravida tincidunt vivamus sodales ligula in accumsan accumsan nunc adipiscing posuere ultricies class aptent taciti sociosqu ad litora torquent per conubia nostra per inceptos himenaeos praesent vehicula justo id nunc facilisis volutpat porttitor id eros ut aliquet sodales purus in pretium risus consequat id proin convallis pretium lacus et rhoncus ipsum mollis eget mauris pulvinar leo non magna blandit sed viverra neque euismod vestibulum bibendum pretium nibh consequat tincidunt suspendisse consequat tortor nisi eget dictum orci vulputate vel morbi ultrices condimentum lacus semper venenatis leo ultrices sit amet ut et tincidunt purus non venenatis nibh etiam congue quam metus feugiat fringilla nunc congue nec donec ut condimentum justo nam ut leo et nisl consequat commodo nullam tempus rutrum massa eu ullamcorper turpis dapibus at vestibulum feugiat ligula eu nibh vehicula varius donec lobortis nisi vel erat posuere porttitor interdum et malesuada fames ac ante ipsum primis in faucibus curabitur venenatis massa sit amet mi mollis sollicitudin duis ut purus tincidunt lobortis tortor a porttitor erat quisque suscipit mi eu euismod egestas cras quis porta augue morbi porttitor cursus eros fusce aliquam vel lorem ut dignissim fusce commodo nisl et arcu aliquam nec accumsan purus dictum in commodo eleifend justo eu sagittis libero laoreet in someone famous in source title aliquam elementum turpis eget felis eleifend id sodales dui ultrices fusce rhoncus libero sed consectetur commodo arcu nisl malesuada sem commodo facilisis risus diam eu sapien aenean iaculis urna id ultrices lacinia lacus lectus commodo neque vel tincidunt lectus quam ac tellus sed interdum mattis neque nec rhoncus lorem laoreet ornare vestibulum dignissim libero non convallis pulvinar leo lectus dignissim risus ac consequat metus purus sed nisi aliquam erat volutpat vivamus elementum feugiat orci nam vitae elementum risus porta luctus tortor proin luctus tristique massa phasellus volutpat id leo sed facilisis vestibulum accumsan libero eu arcu malesuada luctus nulla porta mi quis nisi pellentesque vehicula cras enim mi venenatis quis odio in dapibus venenatis mauris integer et faucibus justo sed mauris odio sodales ut elit scelerisque volutpat pellentesque felis nullam justo lacus tempus a leo id scelerisque hendrerit arcu nulla et nulla sit amet justo pulvinar cursus pellentesque fermentum mollis leo ac iaculis lacus mattis id suspendisse ornare vitae nisl at volutpat aliquam nisi lacus adipiscing at neque ac volutpat interdum nisl ut bibendum elit quam a pharetra augue laoreet eget vestibulum bibendum dui ultrices cursus nisi eu commodo lorem suspendisse placerat risus eu magna congue malesuada nam sed cursus tellus vitae vehicula est donec ut massa elit interdum et malesuada fames ac ante ipsum primis in faucibus video ',0),(39,'node',' mega menu aliquam convallis neque a massa molestie vitae imperdiet enim feugiat nulla bibendum odio eu lobortis faucibus pellentesque consectetur orci diam quis suscipit ligula lobortis eu quisque vel bibendum lacus quis dictum tellus nulla eu justo viverra hendrerit elit vitae tristique quam proin ut aliquam dui fusce vestibulum eros hendrerit tincidunt aliquet dui odio consectetur leo vitae tincidunt lacus leo et lorem praesent euismod erat eget urna fringilla tempus faucibus sem egestas quisque quis consequat nunc ut ultrices cursus eleifend curabitur pharetra felis et auctor vehicula velit arcu convallis purus non tempor augue libero in quam donec congue viverra auctor nullam aliquam rhoncus rutrum donec id arcu ligula nam id lorem placerat eleifend tortor quis pellentesque nibh curabitur tempus purus vel eleifend euismod quisque eu diam nunc morbi sed imperdiet nisl vitae sagittis est mauris euismod sodales lacinia donec euismod enim vel accumsan pretium duis at rutrum nunc lorem ipsum dolor sit amet consectetuer adipiscing elit sed diam nonummy nibh euismod tincidunt ut laoreet dolore magna aliquam erat volutpat nam liber tempor cum soluta nobis eleifend option congue nihil imperdiet doming id quod mazim placerat facer possim assum at vero eos et accusam et justo duo dolores et ea rebum stet clita kasd gubergren no sea takimata sanctus est lorem ipsum dolor sit amet stet clita kasd gubergren no sea takimata sanctus est lorem ipsum dolor sit amet lorem ipsum dolor sit amet consetetur sadipscing elitr sed diam nonumy eirmod tempor invidunt ut labore et dolore magna aliquyam erat lorem ipsum dolor sit amet consetetur sadipscing elitr sed diam nonumy eirmod tempor invidunt ut labore et dolore magna aliquyam erat sed diam voluptua at vero eos et accusam et justo duo dolores et ea rebum at vero eos et accusam et justo duo dolores et ea rebum ut wisi enim ad minim veniam quis nostrud exerci tation ullamcorper suscipit lobortis nisl ut aliquip ex ea commodo consequat stet clita kasd gubergren no sea takimata sanctus est lorem ipsum dolor sit amet excepteur sint obcaecat cupiditat non proident sunt in culpa qui officia deserunt mollit anim id est laborum stet clita kasd gubergren no sea takimata sanctus est lorem ipsum dolor sit amet ut wisi enim ad minim veniam quis nostrud exerci tation ullamcorper suscipit lobortis nisl ut aliquip ex ea commodo consequat duis autem vel eum iriure dolor in hendrerit in vulputate velit esse molestie consequat vel illum dolore eu feugiat nulla facilisis at vero eros et accumsan et iusto odio dignissim qui blandit praesent luptatum zzril delenit augue duis dolore te feugait nulla facilisi at vero eos et accusam et justo duo dolores et ea rebum stet clita kasd gubergren no sea takimata sanctus est lorem ipsum dolor sit amet stet clita kasd gubergren no sea takimata sanctus est lorem ipsum dolor sit amet quis aute iure reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur at vero eos et accusam et justo duo dolores et ea rebum duis autem vel eum iriure dolor in hendrerit in vulputate velit esse molestie consequat vel illum dolore eu feugiat nulla facilisis duis autem vel eum iriure dolor in hendrerit in vulputate velit esse molestie consequat vel illum dolore eu feugiat nulla facilisis at vero eros et accumsan et iusto odio dignissim qui blandit praesent luptatum zzril delenit augue duis dolore te feugait nulla facilisi quis aute iure reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur ut wisi enim ad minim veniam quis nostrud exerci tation ullamcorper suscipit lobortis nisl ut aliquip ex ea commodo consequat lorem ipsum dolor sit amet consetetur sadipscing elitr at accusam aliquyam diam diam dolore dolores duo eirmod eos erat et nonumy sed tempor et et invidunt justo labore stet clita ea et gubergren kasd magna no rebum duis autem vel eum iriure dolor in hendrerit in vulputate velit esse molestie consequat vel illum dolore eu feugiat nulla facilisis at vero eos et accusam et justo duo dolores et ea rebum at vero eos et accusam et justo duo dolores et ea rebum excepteur sint obcaecat cupiditat non proident sunt in culpa qui officia deserunt mollit anim id est laborum nam liber tempor cum soluta nobis eleifend option congue nihil imperdiet doming id quod mazim placerat facer possim assum ut wisi enim ad minim veniam quis nostrud exerci tation ullamcorper suscipit lobortis nisl ut aliquip ex ea commodo consequat ut wisi enim ad minim veniam quis nostrud exerci tation ullamcorper suscipit lobortis nisl ut aliquip ex ea commodo consequat consetetur sadipscing elitr sed diam nonumy eirmod tempor invidunt ut labore et dolore magna aliquyam erat sed diam voluptua lorem ipsum dolor sit amet consetetur sadipscing elitr sed diam nonumy eirmod tempor invidunt ut labore et dolore magna aliquyam erat stet clita kasd gubergren no sea takimata sanctus est lorem ipsum dolor sit amet excepteur sint obcaecat cupiditat non proident sunt in culpa qui officia deserunt mollit anim id est laborum lorem ipsum dolor sit amet quis aute iure reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur  ',0),(40,'node',' contact us your name email subject your comment duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur excepteur sint occaecat cupidatat non proident sunt in culpa qui officia deserunt mollit anim id est laborum sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium totam rem aperiam eaque ipsa quae ab illo inventore veritatis et quasi architecto  alexander street vancouver bc v6a 1e1 canada 123456789 123456789 support weebpalcom ',0),(41,'node',' contact us 2 your name email subject your comment duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur excepteur sint occaecat cupidatat non proident sunt in culpa qui officia deserunt mollit anim id est laborum sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium totam rem aperiam eaque ipsa quae ab illo inventore veritatis et quasi architecto  alexander street vancouver bc v6a 1e1 canada 123456789 123456789 support weebpalcom ',0),(42,'node',' color orem ipsum dolor sit amet consectetur adipiscing elit suspendisse quis ante pharetra porta odio non mattis urna aliquam mattis bibendum lacinia mauris adipiscing tincidunt turpis at sodales aenean in feugiat urna praesent at dictum diam vitae cursus velit donec mauris nisi aliquam ac lectus id luctus imperdiet lacus cras tellus purus eleifend eu gravida vitae aliquam a nunc suspendisse dictum dui in dapibus consequat proin non hendrerit orci sed eget velit turpis pellentesque nec tempor elit proin sit amet ullamcorper est nec vestibulum velit etiam rhoncus lectus a lacinia lobortis nisl risus accumsan ante sed interdum ante lectus sit amet nunc vivamus molestie dolor at dolor sagittis eu consequat orci tristique nunc gravida adipiscing magna sit amet pulvinar aenean nec scelerisque nisl nec ultrices justo phasellus a mollis leo at hendrerit tellus in mollis enim et euismod mattis nunc aliquet sit amet sapien quis ornare nunc rutrum eros in dignissim adipiscing nibh nibh faucibus elit ac faucibus sem enim sit amet eros nulla at lectus vel enim posuere sodales quis pellentesque eros quisque rhoncus nisi sit amet neque fermentum tempus morbi fermentum massa dolor at adipiscing lectus porta sed curabitur fringilla metus a scelerisque blandit donec sit amet nisi id lectus pharetra tincidunt a a augue quisque posuere ante non odio consectetur rhoncus nulla at arcu ultricies nunc placerat posuere eu vitae lacus aenean hendrerit auctor justo sed gravida morbi nunc est vestibulum ac est nec fringilla bibendum arcu etiam id tortor vel ligula dictum adipiscing mollis nec dolor vivamus sed eros a lacus accumsan bibendum vitae eget ante sed aliquam interdum ipsum in bibendum nunc faucibus tellus et vestibulum imperdiet ligula velit tincidunt mi vel porttitor nibh felis non risus phasellus id turpis vitae libero consequat pretium nec sodales erat donec luctus arcu eget nulla luctus tempus pretium non odio sed tempus nec elit quis facilisis in pretium posuere magna sit amet vehicula etiam dapibus sem nec metus laoreet quis imperdiet libero condimentum aliquam fermentum velit eget leo convallis ullamcorper fusce ac consectetur elit id convallis augue praesent gravida aliquet ante vitae suscipit dui fringilla id lorem ipsum dolor sit amet consectetur adipiscing elit duis gravida id erat nec vulputate duis rutrum est id cursus suscipit dui arcu ornare eros vel consequat urna sapien sed libero quisque quis diam ac nisl ultrices blandit quisque cursus feugiat sollicitudin nam vitae risus et metus ornare consequat quis nec diam vestibulum laoreet sem quis dolor congue cursus in aliquam risus semper lacus cursus dictum nunc condimentum lectus sed tellus bibendum sed eleifend mi consectetur fusce cursus pretium ante eget euismod sem imperdiet nec mauris vitae ipsum libero donec eros neque imperdiet quis magna a facilisis venenatis velit sed eu velit et erat vehicula convallis curabitur vestibulum ut purus sed ultrices suspendisse laoreet in risus vitae pulvinar sed ac metus diam sed posuere justo quis est mattis sit amet gravida purus feugiat duis sit amet semper diam suspendisse nulla libero auctor eu lectus id congue suscipit nisi  ',0),(43,'node',' default orem ipsum dolor sit amet consectetur adipiscing elit suspendisse quis ante pharetra porta odio non mattis urna aliquam mattis bibendum lacinia mauris adipiscing tincidunt turpis at sodales aenean in feugiat urna praesent at dictum diam vitae cursus velit donec mauris nisi aliquam ac lectus id luctus imperdiet lacus cras tellus purus eleifend eu gravida vitae aliquam a nunc suspendisse dictum dui in dapibus consequat proin non hendrerit orci sed eget velit turpis pellentesque nec tempor elit proin sit amet ullamcorper est nec vestibulum velit etiam rhoncus lectus a lacinia lobortis nisl risus accumsan ante sed interdum ante lectus sit amet nunc vivamus molestie dolor at dolor sagittis eu consequat orci tristique nunc gravida adipiscing magna sit amet pulvinar aenean nec scelerisque nisl nec ultrices justo phasellus a mollis leo at hendrerit tellus in mollis enim et euismod mattis nunc aliquet sit amet sapien quis ornare nunc rutrum eros in dignissim adipiscing nibh nibh faucibus elit ac faucibus sem enim sit amet eros nulla at lectus vel enim posuere sodales quis pellentesque eros quisque rhoncus nisi sit amet neque fermentum tempus morbi fermentum massa dolor at adipiscing lectus porta sed curabitur fringilla metus a scelerisque blandit donec sit amet nisi id lectus pharetra tincidunt a a augue quisque posuere ante non odio consectetur rhoncus nulla at arcu ultricies nunc placerat posuere eu vitae lacus aenean hendrerit auctor justo sed gravida morbi nunc est vestibulum ac est nec fringilla bibendum arcu etiam id tortor vel ligula dictum adipiscing mollis nec dolor vivamus sed eros a lacus accumsan bibendum vitae eget ante sed aliquam interdum ipsum in bibendum nunc faucibus tellus et vestibulum imperdiet ligula velit tincidunt mi vel porttitor nibh felis non risus phasellus id turpis vitae libero consequat pretium nec sodales erat donec luctus arcu eget nulla luctus tempus pretium non odio sed tempus nec elit quis facilisis in pretium posuere magna sit amet vehicula etiam dapibus sem nec metus laoreet quis imperdiet libero condimentum aliquam fermentum velit eget leo convallis ullamcorper fusce ac consectetur elit id convallis augue praesent gravida aliquet ante vitae suscipit dui fringilla id lorem ipsum dolor sit amet consectetur adipiscing elit duis gravida id erat nec vulputate duis rutrum est id cursus suscipit dui arcu ornare eros vel consequat urna sapien sed libero quisque quis diam ac nisl ultrices blandit quisque cursus feugiat sollicitudin nam vitae risus et metus ornare consequat quis nec diam vestibulum laoreet sem quis dolor congue cursus in aliquam risus semper lacus cursus dictum nunc condimentum lectus sed tellus bibendum sed eleifend mi consectetur fusce cursus pretium ante eget euismod sem imperdiet nec mauris vitae ipsum libero donec eros neque imperdiet quis magna a facilisis venenatis velit sed eu velit et erat vehicula convallis curabitur vestibulum ut purus sed ultrices suspendisse laoreet in risus vitae pulvinar sed ac metus diam sed posuere justo quis est mattis sit amet gravida purus feugiat duis sit amet semper diam suspendisse nulla libero auctor eu lectus id congue suscipit nisi  ',0),(44,'node',' red orem ipsum dolor sit amet consectetur adipiscing elit suspendisse quis ante pharetra porta odio non mattis urna aliquam mattis bibendum lacinia mauris adipiscing tincidunt turpis at sodales aenean in feugiat urna praesent at dictum diam vitae cursus velit donec mauris nisi aliquam ac lectus id luctus imperdiet lacus cras tellus purus eleifend eu gravida vitae aliquam a nunc suspendisse dictum dui in dapibus consequat proin non hendrerit orci sed eget velit turpis pellentesque nec tempor elit proin sit amet ullamcorper est nec vestibulum velit etiam rhoncus lectus a lacinia lobortis nisl risus accumsan ante sed interdum ante lectus sit amet nunc vivamus molestie dolor at dolor sagittis eu consequat orci tristique nunc gravida adipiscing magna sit amet pulvinar aenean nec scelerisque nisl nec ultrices justo phasellus a mollis leo at hendrerit tellus in mollis enim et euismod mattis nunc aliquet sit amet sapien quis ornare nunc rutrum eros in dignissim adipiscing nibh nibh faucibus elit ac faucibus sem enim sit amet eros nulla at lectus vel enim posuere sodales quis pellentesque eros quisque rhoncus nisi sit amet neque fermentum tempus morbi fermentum massa dolor at adipiscing lectus porta sed curabitur fringilla metus a scelerisque blandit donec sit amet nisi id lectus pharetra tincidunt a a augue quisque posuere ante non odio consectetur rhoncus nulla at arcu ultricies nunc placerat posuere eu vitae lacus aenean hendrerit auctor justo sed gravida morbi nunc est vestibulum ac est nec fringilla bibendum arcu etiam id tortor vel ligula dictum adipiscing mollis nec dolor vivamus sed eros a lacus accumsan bibendum vitae eget ante sed aliquam interdum ipsum in bibendum nunc faucibus tellus et vestibulum imperdiet ligula velit tincidunt mi vel porttitor nibh felis non risus phasellus id turpis vitae libero consequat pretium nec sodales erat donec luctus arcu eget nulla luctus tempus pretium non odio sed tempus nec elit quis facilisis in pretium posuere magna sit amet vehicula etiam dapibus sem nec metus laoreet quis imperdiet libero condimentum aliquam fermentum velit eget leo convallis ullamcorper fusce ac consectetur elit id convallis augue praesent gravida aliquet ante vitae suscipit dui fringilla id lorem ipsum dolor sit amet consectetur adipiscing elit duis gravida id erat nec vulputate duis rutrum est id cursus suscipit dui arcu ornare eros vel consequat urna sapien sed libero quisque quis diam ac nisl ultrices blandit quisque cursus feugiat sollicitudin nam vitae risus et metus ornare consequat quis nec diam vestibulum laoreet sem quis dolor congue cursus in aliquam risus semper lacus cursus dictum nunc condimentum lectus sed tellus bibendum sed eleifend mi consectetur fusce cursus pretium ante eget euismod sem imperdiet nec mauris vitae ipsum libero donec eros neque imperdiet quis magna a facilisis venenatis velit sed eu velit et erat vehicula convallis curabitur vestibulum ut purus sed ultrices suspendisse laoreet in risus vitae pulvinar sed ac metus diam sed posuere justo quis est mattis sit amet gravida purus feugiat duis sit amet semper diam suspendisse nulla libero auctor eu lectus id congue suscipit nisi  ',0),(45,'node',' yellow orem ipsum dolor sit amet consectetur adipiscing elit suspendisse quis ante pharetra porta odio non mattis urna aliquam mattis bibendum lacinia mauris adipiscing tincidunt turpis at sodales aenean in feugiat urna praesent at dictum diam vitae cursus velit donec mauris nisi aliquam ac lectus id luctus imperdiet lacus cras tellus purus eleifend eu gravida vitae aliquam a nunc suspendisse dictum dui in dapibus consequat proin non hendrerit orci sed eget velit turpis pellentesque nec tempor elit proin sit amet ullamcorper est nec vestibulum velit etiam rhoncus lectus a lacinia lobortis nisl risus accumsan ante sed interdum ante lectus sit amet nunc vivamus molestie dolor at dolor sagittis eu consequat orci tristique nunc gravida adipiscing magna sit amet pulvinar aenean nec scelerisque nisl nec ultrices justo phasellus a mollis leo at hendrerit tellus in mollis enim et euismod mattis nunc aliquet sit amet sapien quis ornare nunc rutrum eros in dignissim adipiscing nibh nibh faucibus elit ac faucibus sem enim sit amet eros nulla at lectus vel enim posuere sodales quis pellentesque eros quisque rhoncus nisi sit amet neque fermentum tempus morbi fermentum massa dolor at adipiscing lectus porta sed curabitur fringilla metus a scelerisque blandit donec sit amet nisi id lectus pharetra tincidunt a a augue quisque posuere ante non odio consectetur rhoncus nulla at arcu ultricies nunc placerat posuere eu vitae lacus aenean hendrerit auctor justo sed gravida morbi nunc est vestibulum ac est nec fringilla bibendum arcu etiam id tortor vel ligula dictum adipiscing mollis nec dolor vivamus sed eros a lacus accumsan bibendum vitae eget ante sed aliquam interdum ipsum in bibendum nunc faucibus tellus et vestibulum imperdiet ligula velit tincidunt mi vel porttitor nibh felis non risus phasellus id turpis vitae libero consequat pretium nec sodales erat donec luctus arcu eget nulla luctus tempus pretium non odio sed tempus nec elit quis facilisis in pretium posuere magna sit amet vehicula etiam dapibus sem nec metus laoreet quis imperdiet libero condimentum aliquam fermentum velit eget leo convallis ullamcorper fusce ac consectetur elit id convallis augue praesent gravida aliquet ante vitae suscipit dui fringilla id lorem ipsum dolor sit amet consectetur adipiscing elit duis gravida id erat nec vulputate duis rutrum est id cursus suscipit dui arcu ornare eros vel consequat urna sapien sed libero quisque quis diam ac nisl ultrices blandit quisque cursus feugiat sollicitudin nam vitae risus et metus ornare consequat quis nec diam vestibulum laoreet sem quis dolor congue cursus in aliquam risus semper lacus cursus dictum nunc condimentum lectus sed tellus bibendum sed eleifend mi consectetur fusce cursus pretium ante eget euismod sem imperdiet nec mauris vitae ipsum libero donec eros neque imperdiet quis magna a facilisis venenatis velit sed eu velit et erat vehicula convallis curabitur vestibulum ut purus sed ultrices suspendisse laoreet in risus vitae pulvinar sed ac metus diam sed posuere justo quis est mattis sit amet gravida purus feugiat duis sit amet semper diam suspendisse nulla libero auctor eu lectus id congue suscipit nisi  ',0),(46,'node',' dark orem ipsum dolor sit amet consectetur adipiscing elit suspendisse quis ante pharetra porta odio non mattis urna aliquam mattis bibendum lacinia mauris adipiscing tincidunt turpis at sodales aenean in feugiat urna praesent at dictum diam vitae cursus velit donec mauris nisi aliquam ac lectus id luctus imperdiet lacus cras tellus purus eleifend eu gravida vitae aliquam a nunc suspendisse dictum dui in dapibus consequat proin non hendrerit orci sed eget velit turpis pellentesque nec tempor elit proin sit amet ullamcorper est nec vestibulum velit etiam rhoncus lectus a lacinia lobortis nisl risus accumsan ante sed interdum ante lectus sit amet nunc vivamus molestie dolor at dolor sagittis eu consequat orci tristique nunc gravida adipiscing magna sit amet pulvinar aenean nec scelerisque nisl nec ultrices justo phasellus a mollis leo at hendrerit tellus in mollis enim et euismod mattis nunc aliquet sit amet sapien quis ornare nunc rutrum eros in dignissim adipiscing nibh nibh faucibus elit ac faucibus sem enim sit amet eros nulla at lectus vel enim posuere sodales quis pellentesque eros quisque rhoncus nisi sit amet neque fermentum tempus morbi fermentum massa dolor at adipiscing lectus porta sed curabitur fringilla metus a scelerisque blandit donec sit amet nisi id lectus pharetra tincidunt a a augue quisque posuere ante non odio consectetur rhoncus nulla at arcu ultricies nunc placerat posuere eu vitae lacus aenean hendrerit auctor justo sed gravida morbi nunc est vestibulum ac est nec fringilla bibendum arcu etiam id tortor vel ligula dictum adipiscing mollis nec dolor vivamus sed eros a lacus accumsan bibendum vitae eget ante sed aliquam interdum ipsum in bibendum nunc faucibus tellus et vestibulum imperdiet ligula velit tincidunt mi vel porttitor nibh felis non risus phasellus id turpis vitae libero consequat pretium nec sodales erat donec luctus arcu eget nulla luctus tempus pretium non odio sed tempus nec elit quis facilisis in pretium posuere magna sit amet vehicula etiam dapibus sem nec metus laoreet quis imperdiet libero condimentum aliquam fermentum velit eget leo convallis ullamcorper fusce ac consectetur elit id convallis augue praesent gravida aliquet ante vitae suscipit dui fringilla id lorem ipsum dolor sit amet consectetur adipiscing elit duis gravida id erat nec vulputate duis rutrum est id cursus suscipit dui arcu ornare eros vel consequat urna sapien sed libero quisque quis diam ac nisl ultrices blandit quisque cursus feugiat sollicitudin nam vitae risus et metus ornare consequat quis nec diam vestibulum laoreet sem quis dolor congue cursus in aliquam risus semper lacus cursus dictum nunc condimentum lectus sed tellus bibendum sed eleifend mi consectetur fusce cursus pretium ante eget euismod sem imperdiet nec mauris vitae ipsum libero donec eros neque imperdiet quis magna a facilisis venenatis velit sed eu velit et erat vehicula convallis curabitur vestibulum ut purus sed ultrices suspendisse laoreet in risus vitae pulvinar sed ac metus diam sed posuere justo quis est mattis sit amet gravida purus feugiat duis sit amet semper diam suspendisse nulla libero auctor eu lectus id congue suscipit nisi  ',0),(47,'node',' apple launches email ad campaign focusing on productivity news and announcements excepteur sint occaecat cupidatat non proident sunt in culpa qui officia deserunt mollit anim id est laborum sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium totam rem aperiam eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo nulla facilisi cras convallis vel lectus sed convallis duis nec accumsan diam vestibulum blandit tempus nulla suspendisse consectetur cursus elit et scelerisque ligula hendrerit id maecenas ultrices porta nunc quis consectetur risus morbi non metus eget nibh vulputate tincidunt nullam dui quam suscipit a ligula a posuere sagittis magna pellentesque vitae dolor et nunc lobortis vestibulum suspendisse potenti pellentesque cursus purus vitae libero hendrerit congue aenean erat elit aliquet at mi quis sollicitudin sollicitudin libero sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium totam rem aperiam eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo h1 heading 1 sint occaecat cupidatat non proident sunt in culpa qui officia deserunt mollit anim id est laborum sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium totam rem aperiam eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo nemo enim ipsam voluptatem quia voluptas sit aspernatur aut odit aut fugit sed ut perspiciatis unde omnis iste natus error qui dolorem ipsum quia dolor sit amet consectetur adipisci velit h2 heading 2 sint occaecat cupidatat non proident sunt in culpa qui officia deserunt mollit anim id est laborum sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium totam rem aperiam eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo h3 heading 3 sint occaecat cupidatat non proident sunt in culpa qui officia deserunt mollit anim id est laborum sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium totam rem aperiam eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo vestibulum fringilla pede sit amet augue suspendisse enim turpis dictum sed iaculis a condimentum nec nisi mauris sollicitudin fermentum libero praesent ac sem eget est egestas volutpat in enim justo rhoncus ut imperdiet a venenatis vitae justo aliquam erat volutpat sed fringilla mauris sit amet nibh suspendisse enim turpis dictum sed iaculis a condimentum nec nisi morbi ac felis phasellus nec sem in justo pellentesque facilisis select rating give it 15 give it 25 give it 35 give it 45 give it 55 no votes yet tue 8192014 122  8 admin online last seen 2 min 57 sec ago joined 6122014 1540 in hac habitasse platea in hac habitasse platea dictumst morbi vestibulum volutpat enim fusce commodo aliquam arcu quisque libero metus condimentum nec tempor a commodo mollis magna maecenas vestibulum mollis diam select rating give it 15 give it 25 give it 35 give it 45 give it 55 no votes yet drupal themes web development top log in or register to post comments  ',0),(48,'node',' blog nullam accumsan lorem in dui maecenas tempus tellus eget condimentum rhoncus sem quam semper libero sit amet adipiscing sem neque sed ipsum duis arcu tortor suscipit eget imperdiet nec imperdiet iaculis ipsum pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas curabitur nisi fusce commodo aliquam arcu suspendisse potenti cras risus ipsum faucibus ut ullamcorper id varius ac leo sed libero vestibulum rutrum mi nec elementum vehicula eros quam gravida nisl id fringilla neque ante vel mi donec interdum metus et hendrerit aliquet dolor diam sagittis ligula eget egestas libero turpis vel mi praesent nonummy mi in odio cras ultricies mi eu turpis hendrerit fringilla aliquam eu nunc suspendisse potenti nam ipsum risus rutrum vitae vestibulum eu molestie vel lacus praesent adipiscing phasellus a est nam pretium turpis et arcu nam eget dui etiam vitae tortor proin pretium leo ac pellentesque mollis felis nunc ultrices eros sed gravida augue augue mollis justo in consectetuer turpis ut velit vivamus aliquet elit ac nisl vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia curae sed aliquam nisi quis porttitor congue elit erat euismod orci ac placerat dolor lectus quis orci read more ',0),(49,'node',' autox vestibulum ullamcorper mauris at ligula nullam cursus lacinia erat fusce ac felis sit amet ligula pharetra condimentum sed magna purus fermentum eu tincidunt eu varius ut felis cras dapibus aenean commodo ligula eget dolor nam pretium turpis et arcu in auctor lobortis lacus fusce fermentum phasellus ullamcorper ipsum rutrum nunc nam at tortor in tellus interdum sagittis pellentesque dapibus hendrerit tortor in turpis nunc nonummy metus aliquam lorem ante dapibus in viverra quis feugiat a tellus proin magna nunc nec neque praesent ac sem eget est egestas volutpat praesent vestibulum dapibus nibh fusce neque vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia curae sed aliquam nisi quis porttitor congue elit erat euismod orci ac placerat dolor lectus quis orci nulla porta dolor suspendisse pulvinar augue ac venenatis condimentum sem libero volutpat nibh nec pellentesque velit pede quis nunc praesent venenatis metus at tortor pulvinar varius ut id nisl quis enim dignissim sagittis read more ',0),(50,'node',' one page praesent adipiscing vivamus elementum semper nisi aenean imperdiet aliquam lobortis pellentesque libero tortor tincidunt et tincidunt eget semper nec quam donec posuere vulputate arcu donec venenatis vulputate lorem proin faucibus arcu quis ante phasellus ullamcorper ipsum rutrum nunc quisque libero metus condimentum nec tempor a commodo mollis magna vestibulum fringilla pede sit amet augue fusce vulputate eleifend sapien ut non enim eleifend felis pretium feugiat nullam dictum felis eu pede mollis pretium fusce a quam vestibulum turpis sem aliquet eget lobortis pellentesque rutrum eu nisl curabitur vestibulum aliquam leo pellentesque dapibus hendrerit tortor vestibulum facilisis purus nec pulvinar iaculis ligula mi congue nunc vitae euismod ligula urna in dolor curabitur at lacus ac velit ornare lobortis cras risus ipsum faucibus ut ullamcorper id varius ac leo suspendisse nisl elit rhoncus eget elementum ac condimentum eget diam nullam tincidunt adipiscing enim integer tincidunt aliquam erat volutpat read more ',0),(51,'node',' pinteros aenean posuere tortor sed cursus feugiat nunc augue blandit nunc eu sollicitudin urna dolor sagittis lacus sed hendrerit fusce risus nisl viverra et tempor et pretium in sapien etiam iaculis nunc ac metus praesent vestibulum dapibus nibh ut id nisl quis enim dignissim sagittis vivamus quis mi donec posuere vulputate arcu mauris turpis nunc blandit et volutpat molestie porta ut ligula donec interdum metus et hendrerit aliquet dolor diam sagittis ligula eget egestas libero turpis vel mi phasellus nec sem in justo pellentesque facilisis aenean viverra rhoncus pede praesent turpis nunc nonummy metus nullam accumsan lorem in dui etiam ut purus mattis mauris sodales aliquam nam eget dui nullam cursus lacinia erat vestibulum eu odio curabitur nisi quisque id odio suspendisse nisl elit rhoncus eget elementum ac condimentum eget diam mauris turpis nunc blandit et volutpat molestie porta ut ligula sed magna purus fermentum eu tincidunt eu varius ut felis nullam tincidunt adipiscing enim read more ',0),(52,'node',' zircon phasellus gravida semper nisi aenean viverra rhoncus pede curabitur at lacus ac velit ornare lobortis nam eget dui etiam sit amet orci eget eros faucibus tincidunt aliquam eu nunc fusce ac felis sit amet ligula pharetra condimentum in ac felis quis tortor malesuada pretium praesent vestibulum dapibus nibh vestibulum rutrum mi nec elementum vehicula eros quam gravida nisl id fringilla neque ante vel mi phasellus magna donec interdum metus et hendrerit aliquet dolor diam sagittis ligula eget egestas libero turpis vel mi nam quam nunc blandit vel luctus pulvinar hendrerit id lorem cras ultricies mi eu turpis hendrerit fringilla nunc sed turpis aenean vulputate eleifend tellus curabitur a felis in nunc fringilla tristique ut non enim eleifend felis pretium feugiat nunc interdum lacus sit amet orci ut id nisl quis enim dignissim sagittis sed in libero ut nibh placerat accumsan etiam iaculis nunc ac metus curabitur blandit mollis lacus morbi mollis tellus ac sapien nam at tortor in tellus interdum sagittis read more ',0),(53,'node',' 8 project management tips general discussion donec venenatis vulputate lorem maecenas vestibulum mollis diam fusce commodo aliquam arcu donec elit libero sodales nec volutpat a suscipit non turpis phasellus nec sem in justo pellentesque facilisis etiam ut purus mattis mauris sodales aliquam pellentesque posuere maecenas tempus tellus eget condimentum rhoncus sem quam semper libero sit amet adipiscing sem neque sed ipsum pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas vivamus elementum semper nisi 1 get all the facts proin faucibus arcu quis ante nam commodo suscipit quam donec id justo aenean posuere tortor sed cursus feugiat nunc augue blandit nunc eu sollicitudin urna dolor sagittis lacus fusce pharetra convallis urna ut a nisl id ante tempus hendrerit phasellus volutpat metus eget egestas mollis lacus lacus blandit dui id egestas quam mauris ut lacus proin pretium leo ac pellentesque mollis felis nunc ultrices eros sed gravida augue augue mollis justo phasellus a est 2 track the details curabitur at lacus ac velit ornare lobortis ut non enim eleifend felis pretium feugiat morbi vestibulum volutpat enim nulla facilisi morbi nec metus cras dapibus fusce risus nisl viverra et tempor et pretium in sapien in ac felis quis tortor malesuada pretium donec elit libero sodales nec volutpat a suscipit non turpis suspendisse potenti duis lobortis massa imperdiet quam suspendisse nisl elit rhoncus eget elementum ac condimentum eget diam praesent nec nisl a purus blandit viverra nam commodo suscipit quam phasellus dolor cont select rating give it 15 give it 25 give it 35 give it 45 give it 55 no votes yet sat 8162014 1830  9 peter offline last seen 1 day 13 hours ago joined 7082014 922 morbi mollis tellus ac sapien morbi mollis tellus ac sapien nam adipiscing nullam nulla eros ultricies sit amet nonummy id imperdiet feugiat pede phasellus viverra nulla ut metus varius laoreet praesent adipiscing nam eget dui phasellus a est etiam iaculis nunc ac metus phasellus a est nulla neque dolor sagittis eget iaculis quis molestie non velit mauris turpis nunc blandit et volutpat molestie porta ut ligula vivamus euismod mauris fusce ac felis sit amet ligula pharetra condimentum cum sociis natoque penatibus et magnis dis parturient montes nascetur ridiculus mus sed hendrerit select rating give it 15 give it 25 give it 35 give it 45 give it 55 no votes yet top log in or register to post comments sat 8162014 1832  10 admin online last seen 2 min 57 sec ago joined 6122014 1540 suspendisse non nisl sit amet suspendisse non nisl sit amet velit hendrerit rutrum maecenas vestibulum mollis diam integer ante arcu accumsan a consectetuer eget posuere ut mauris nunc nonummy metus ut id nisl quis enim dignissim sagittis aliquam lobortis mauris sollicitudin fermentum libero fusce fermentum odio nec arcu vestibulum purus quam scelerisque ut mollis sed nonummy id metus suspendisse potenti vestibulum fringilla pede sit amet augue phasellus ullamcorper ipsum rutrum nunc cras varius curabitur nisi nullam sagittis select rating give it 15 give it 25 give it 35 give it 45 give it 55 no votes yet drupal themes web development top log in or register to post comments sat 8162014 1832  11 peter offline last seen 1 day 13 hours ago joined 7082014 922 suspendisse non nisl sit amet suspendisse non nisl sit amet velit hendrerit rutrum maecenas vestibulum mollis diam integer ante arcu accumsan a consectetuer eget posuere ut mauris nunc nonummy metus ut id nisl quis enim dignissim sagittis aliquam lobortis mauris sollicitudin fermentum libero fusce fermentum odio nec arcu vestibulum purus quam scelerisque ut mollis sed nonummy id metus suspendisse potenti vestibulum fringilla pede sit amet augue phasellus ullamcorper ipsum rutrum nunc cras varius curabitur nisi nullam sagittis select rating give it 15 give it 25 give it 35 give it 45 give it 55 no votes yet top log in or register to post comments sat 8162014 1833  12 admin online last seen 2 min 57 sec ago joined 6122014 1540 suspendisse non nisl sit amet suspendisse non nisl sit amet velit hendrerit rutrum maecenas vestibulum mollis diam integer ante arcu accumsan a consectetuer eget posuere ut mauris nunc nonummy metus ut id nisl quis enim dignissim sagittis aliquam lobortis mauris sollicitudin fermentum libero fusce fermentum odio nec arcu vestibulum purus quam scelerisque ut mollis sed nonummy id metus suspendisse potenti vestibulum fringilla pede sit amet augue phasellus ullamcorper ipsum rutrum nunc cras varius curabitur nisi nullam sagittis select rating give it 15 give it 25 give it 35 give it 45 give it 55 no votes yet drupal themes web development top log in or register to post comments sat 8162014 1833  13 mical offline last seen 1 day 22 hours ago joined 7132014 2351 aenean id mollis justo aenean id mollis justo praesent nunc arcu fringilla eu odio vel rutrum feugiat dolor praesent quis nibh id est scelerisque interdum non vitae turpis fusce pretium urna vel lacus commodo mattis ut sit amet sapien cursus imperdiet nibh et molestie turpis vestibulum sed odio at elit cras amet select rating give it 15 give it 25 give it 35 give it 45 give it 55 no votes yet practice makes perfect  top log in or register to post comments sat 8162014 1834  14 peter offline last seen 1 day 13 hours ago joined 7082014 922 phasellus et mauris sit amet phasellus et mauris sit amet metus interdum feugiat in sit amet ipsum nulla dignissim adipiscing dictum donec in nunc vel metus fringilla posuere id pellentesque nibh fusce ullamcorper posuere ipsum sit amet gravida elit porttitor non fusce vehicula orci quis scelerisque congue morbi volutpat select rating give it 15 give it 25 give it 35 give it 45 give it 55 no votes yet top log in or register to post comments sat 8162014 1834  15 mical offline last seen 1 day 22 hours ago joined 7132014 2351 donec hendrerit tortor ut donec hendrerit tortor ut iaculis imperdiet leo nisi lacinia sapien et aliquam dolor ipsum quis quam aenean semper dapibus elit molestie imperdiet quam duis dignissim placerat quam non euismod elit consectetur a in ut arcu dignissim ultrices lorem id varius ligula nulla volutpat volutpat select rating give it 15 give it 25 give it 35 give it 45 give it 55 no votes yet practice makes perfect  top log in or register to post comments sat 8162014 1834  16 mical offline last seen 1 day 22 hours ago joined 7132014 2351 pellentesque vel augue sit pellentesque vel augue sit amet ante euismod accumsan non a sapien maecenas molestie velit sed auctor porta augue purus accumsan lectus id faucibus leo est id dui class aptent taciti sociosqu ad litora torquent per conubia nostra per inceptos himenaeos suspendisse sodales tellus sed volutpat select rating give it 15 give it 25 give it 35 give it 45 give it 55 no votes yet practice makes perfect  top log in or register to post comments sat 8162014 1835  17 admin online last seen 2 min 57 sec ago joined 6122014 1540 phasellus volutpat metus phasellus volutpat metus eget egestas mollis lacus lacus blandit dui id egestas quam mauris ut lacus etiam sit amet orci eget eros faucibus tincidunt suspendisse non nisl sit amet velit hendrerit rutrum donec quam felis ultricies nec pellentesque eu pretium quis sem etiam imperdiet imperdiet orci cras dapibus donec venenatis vulputate lorem praesent turpis etiam ut purus mattis mauris sodales aliquam etiam ultricies nisi vel augue cras ultricies mi eu turpis hendrerit fringilla nullam nulla eros ultricies sit amet nonummy id imperdiet feugiat pede nullam vel sem maecenas malesuada sed fringilla mauris sit amet nibh curabitur turpis maecenas nec odio et ante tincidunt tempus in ut quam vitae odio lacinia tincidunt vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia curae sed aliquam nisi quis porttitor congue elit erat euismod orci ac placerat dolor lectus quis orci vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia curae fusce id purus praesent ut ligula non mi varius sagittis morbi vestibulum volutpat enim fusce egestas elit eget lorem vivamus quis mi sed lectus select rating give it 15 give it 25 give it 35 give it 45 give it 55 no votes yet drupal themes web development top log in or register to post comments sat 8162014 1835  18 mical offline last seen 1 day 22 hours ago joined 7132014 2351 duis feugiat libero felis ut duis feugiat libero felis ut cursus enim ullamcorper quis phasellus sem sem imperdiet quis est id porttitor elementum quam sed at elementum eros quis pellentesque enim aliquam bibendum erat vel urna molestie et blandit nibh consequat sed eu auctor dolor cras eu odio ut leo vestibulum amet select rating give it 15 give it 25 give it 35 give it 45 give it 55 no votes yet practice makes perfect  top log in or register to post comments  ',0),(54,'node',' column oriented databases does bigtable cassandra belong to column store database  general discussion excepteur sint occaecat cupidatat non proident sunt in culpa qui officia deserunt mollit anim id est laborum sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium totam rem aperiam eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo nulla facilisi cras convallis vel lectus sed convallis duis nec accumsan diam vestibulum blandit tempus nulla suspendisse consectetur cursus elit et scelerisque ligula hendrerit id maecenas ultrices porta nunc quis consectetur risus morbi non metus eget nibh vulputate tincidunt nullam dui quam suscipit a ligula a posuere sagittis magna pellentesque vitae dolor et nunc lobortis vestibulum suspendisse potenti pellentesque cursus purus vitae libero hendrerit congue aenean erat elit aliquet at mi quis sollicitudin sollicitudin libero sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium totam rem aperiam eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo h1 heading 1 sint occaecat cupidatat non proident sunt in culpa qui officia deserunt mollit anim id est laborum sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium totam rem aperiam eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo nemo enim ipsam voluptatem quia voluptas sit aspernatur aut odit aut fugit sed ut perspiciatis unde omnis iste natus error qui dolorem ipsum quia dolor sit amet consectetur adipisci velit h2 heading 2 sint occaecat cupidatat non proident sunt in culpa qui officia deserunt mollit anim id est laborum sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium totam rem aperiam eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo h3 heading 3 sint occaecat cupidatat non proident sunt in culpa qui officia deserunt mollit anim id est laborum sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium totam rem aperiam eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo in turpis in hac habitasse platea dictumst vivamus quis mi sed consequat leo eget bibendum sodales augue velit cursus nunc quis gravida magna mi a libero quisque malesuada placerat nisl select rating give it 15 give it 25 give it 35 give it 45 give it 55 no votes yet sun 8172014 1806  19 mical offline last seen 1 day 22 hours ago joined 7132014 2351 sed sit amet ullamcorper sed sit amet ullamcorper mauris duis pulvinar at nisl vel auctor etiam hendrerit non nibh at adipiscing aliquam semper eros ut tortor ullamcorper blandit cras mollis auctor orci eu vestibulum aenean vitae volutpat nisi class aptent taciti sociosqu ad litora torquent per conubia nostra posuere select rating give it 15 give it 25 give it 35 give it 45 give it 55 no votes yet practice makes perfect  top log in or register to post comments  ',0),(55,'node',' time travel why are people from the future not time traveling to our period  general discussion excepteur sint occaecat cupidatat non proident sunt in culpa qui officia deserunt mollit anim id est laborum sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium totam rem aperiam eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo nulla facilisi cras convallis vel lectus sed convallis duis nec accumsan diam vestibulum blandit tempus nulla suspendisse consectetur cursus elit et scelerisque ligula hendrerit id maecenas ultrices porta nunc quis consectetur risus morbi non metus eget nibh vulputate tincidunt nullam dui quam suscipit a ligula a posuere sagittis magna pellentesque vitae dolor et nunc lobortis vestibulum suspendisse potenti pellentesque cursus purus vitae libero hendrerit congue aenean erat elit aliquet at mi quis sollicitudin sollicitudin libero sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium totam rem aperiam eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo h1 heading 1 sint occaecat cupidatat non proident sunt in culpa qui officia deserunt mollit anim id est laborum sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium totam rem aperiam eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo nemo enim ipsam voluptatem quia voluptas sit aspernatur aut odit aut fugit sed ut perspiciatis unde omnis iste natus error qui dolorem ipsum quia dolor sit amet consectetur adipisci velit h2 heading 2 sint occaecat cupidatat non proident sunt in culpa qui officia deserunt mollit anim id est laborum sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium totam rem aperiam eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo h3 heading 3 sint occaecat cupidatat non proident sunt in culpa qui officia deserunt mollit anim id est laborum sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium totam rem aperiam eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo quisque rutrum sed consequat leo eget bibendum sodales augue velit cursus nunc quis gravida magna mi a libero suspendisse pulvinar augue ac venenatis condimentum sem libero volutpat nibh nec pellentesque velit pede quis nunc curabitur suscipit suscipit tellus nulla neque dolor sagittis eget iaculis quis molestie non velit select rating give it 15 give it 25 give it 35 give it 45 give it 55 your rating none average 5 1 vote  sun 8172014 1758  20 admin online last seen 2 min 57 sec ago joined 6122014 1540 quisque libero metus quisque libero metus condimentum nec tempor a commodo mollis magna nulla sit amet est donec quam felis ultricies nec pellentesque eu pretium quis sem aenean posuere tortor sed cursus feugiat nunc augue blandit nunc eu sollicitudin urna dolor sagittis lacus curabitur blandit mollis lacus praesent vestibulum dapibus nibh nunc nonummy metus aliquam lobortis cras non dolor etiam feugiat lorem non metus select rating give it 15 give it 25 give it 35 give it 45 give it 55 no votes yet drupal themes web development top log in or register to post comments sun 8172014 1759  21 mical offline last seen 1 day 22 hours ago joined 7132014 2351 nunc lobortis egestas justo nunc lobortis egestas justo id aliquet dolor blandit ut donec vitae tortor enim nulla dictum urna quis fermentum vulputate leo ipsum porta dui eu gravida erat ligula eget eros in vel aliquam libero ac tempus urna fusce quis leo iaculis iaculis magna ut eleifend nulla morbi commodo metus pellentesque at nibh a metus semper laoreet duis accumsan lacinia sodales nulla nec tincidunt erat in auctor massa a accumsan vehicula suspendisse vehicula lorem in elementum facilisis leo magna ullamcorper lacus vitae fermentum felis libero at sapien nam laoreet mattis odio a orci aliquam select rating give it 15 give it 25 give it 35 give it 45 give it 55 no votes yet practice makes perfect  top log in or register to post comments  ',0),(56,'node',' drupal installation installing drupal excepteur sint occaecat cupidatat non proident sunt in culpa qui officia deserunt mollit anim id est laborum sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium totam rem aperiam eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo nulla facilisi cras convallis vel lectus sed convallis duis nec accumsan diam vestibulum blandit tempus nulla suspendisse consectetur cursus elit et scelerisque ligula hendrerit id maecenas ultrices porta nunc quis consectetur risus morbi non metus eget nibh vulputate tincidunt nullam dui quam suscipit a ligula a posuere sagittis magna pellentesque vitae dolor et nunc lobortis vestibulum suspendisse potenti pellentesque cursus purus vitae libero hendrerit congue aenean erat elit aliquet at mi quis sollicitudin sollicitudin libero sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium totam rem aperiam eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo h1 heading 1 sint occaecat cupidatat non proident sunt in culpa qui officia deserunt mollit anim id est laborum sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium totam rem aperiam eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo nemo enim ipsam voluptatem quia voluptas sit aspernatur aut odit aut fugit sed ut perspiciatis unde omnis iste natus error qui dolorem ipsum quia dolor sit amet consectetur adipisci velit h2 heading 2 sint occaecat cupidatat non proident sunt in culpa qui officia deserunt mollit anim id est laborum sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium totam rem aperiam eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo h3 heading 3 sint occaecat cupidatat non proident sunt in culpa qui officia deserunt mollit anim id est laborum sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium totam rem aperiam eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo select rating give it 15 give it 25 give it 35 give it 45 give it 55 no votes yet sun 8172014 309  2 admin last seen 19 hours 5 min ago joined 6122014 40 suspendisse potenti integer suspendisse potenti integer tincidunt ut a nisl id ante tempus hendrerit suspendisse pulvinar augue ac venenatis condimentum sem libero volutpat nibh nec pellentesque velit pede quis nunc vivamus in erat ut urna cursus vestibulum select rating give it 15 give it 25 give it 35 give it 45 give it 55 no votes yet drupal themes web development top log in or register to post comments  ',0),(57,'node',' green lorem ipsum dolor sit amet consectetur adipiscing elit suspendisse quis ante pharetra porta odio non mattis urna aliquam mattis bibendum lacinia mauris adipiscing tincidunt turpis at sodales aenean in feugiat urna praesent at dictum diam vitae cursus velit donec mauris nisi aliquam ac lectus id luctus imperdiet lacus cras tellus purus eleifend eu gravida vitae aliquam a nunc suspendisse dictum dui in dapibus consequat proin non hendrerit orci sed eget velit turpis pellentesque nec tempor elit proin sit amet ullamcorper est nec vestibulum velit etiam rhoncus lectus a lacinia lobortis nisl risus accumsan ante sed interdum ante lectus sit amet nunc vivamus molestie dolor at dolor sagittis eu consequat orci tristique nunc gravida adipiscing magna sit amet pulvinar aenean nec scelerisque nisl nec ultrices justo phasellus a mollis leo at hendrerit tellus in mollis enim et euismod mattis nunc aliquet sit amet sapien quis ornare nunc rutrum eros in dignissim adipiscing nibh nibh faucibus elit ac faucibus sem enim sit amet eros nulla at lectus vel enim posuere sodales quis pellentesque eros quisque rhoncus nisi sit amet neque fermentum tempus morbi fermentum massa dolor at adipiscing lectus porta sed curabitur fringilla metus a scelerisque blandit donec sit amet nisi id lectus pharetra tincidunt a a augue quisque posuere ante non odio consectetur rhoncus nulla at arcu ultricies nunc placerat posuere eu vitae lacus aenean hendrerit auctor justo sed gravida morbi nunc est vestibulum ac est nec fringilla bibendum arcu etiam id tortor vel ligula dictum adipiscing mollis nec dolor vivamus sed eros a lacus accumsan bibendum vitae eget ante sed aliquam interdum ipsum in bibendum nunc faucibus tellus et vestibulum imperdiet ligula velit tincidunt mi vel porttitor nibh felis non risus phasellus id turpis vitae libero consequat pretium nec sodales erat donec luctus arcu eget nulla luctus tempus pretium non odio sed tempus nec elit quis facilisis in pretium posuere magna sit amet vehicula etiam dapibus sem nec metus laoreet quis imperdiet libero condimentum aliquam fermentum velit eget leo convallis ullamcorper fusce ac consectetur elit id convallis augue praesent gravida aliquet ante vitae suscipit dui fringilla id lorem ipsum dolor sit amet consectetur adipiscing elit duis gravida id erat nec vulputate duis rutrum est id cursus suscipit dui arcu ornare eros vel consequat urna sapien sed libero quisque quis diam ac nisl ultrices blandit quisque cursus feugiat sollicitudin nam vitae risus et metus ornare consequat quis nec diam vestibulum laoreet sem quis dolor congue cursus in aliquam risus semper lacus cursus dictum nunc condimentum lectus sed tellus bibendum sed eleifend mi consectetur fusce cursus pretium ante eget euismod sem imperdiet nec mauris vitae ipsum libero donec eros neque imperdiet quis magna a facilisis venenatis velit sed eu velit et erat vehicula convallis curabitur vestibulum ut purus sed ultrices suspendisse laoreet in risus vitae pulvinar sed ac metus diam sed posuere justo quis est mattis sit amet gravida purus feugiat duis sit amet semper diam suspendisse nulla libero auctor eu lectus id congue suscipit nisi  ',0),(58,'node',' donec vitae sapien ut pellentesque dapibus hendrerit tortor nullam quis ante donec sodales sagittis magna etiam iaculis nunc ac metus vestibulum dapibus nunc ac augue donec vitae sapien ut libero venenatis faucibus maecenas tempus tellus eget condimentum rhoncus sem quam semper libero sit amet adipiscing sem neque sed ipsum quisque rutrum phasellus viverra nulla ut metus varius laoreet pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas nam commodo suscipit quam pellentesque commodo eros a enim nam eget dui curabitur ligula sapien tincidunt non euismod vitae posuere imperdiet leo phasellus gravida semper nisi maecenas tempus tellus eget condimentum rhoncus sem quam semper libero sit amet adipiscing sem neque sed ipsum phasellus blandit leo ut odio quisque ut nisi etiam sit amet orci eget eros faucibus tincidunt integer ante arcu accumsan a consectetuer eget posuere ut mauris aenean tellus metus bibendum sed posuere ac mattis non nunc nullam quis ante phasellus leo dolor tempus non auctor et hendrerit quis nisi pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas phasellus dolor  ',0),(59,'node',' fusce pulvinar interdum lectus sed tempor fusce fermentum nulla neque dolor sagittis eget iaculis quis molestie non velit phasellus blandit leo ut odio nullam cursus lacinia erat vestibulum volutpat pretium libero nam adipiscing curabitur a felis in nunc fringilla tristique etiam imperdiet imperdiet orci pellentesque ut neque vestibulum eu odio donec vitae orci sed dolor rutrum auctor proin magna morbi vestibulum volutpat enim nullam cursus lacinia erat donec interdum metus et hendrerit aliquet dolor diam sagittis ligula eget egestas libero turpis vel mi nullam cursus lacinia erat in consectetuer turpis ut velit sed fringilla mauris sit amet nibh curabitur nisi in hac habitasse platea dictumst sed a libero aenean viverra rhoncus pede fusce fermentum praesent egestas neque eu enim etiam ut purus mattis mauris sodales aliquam  ',0),(60,'node',' lorem ipsum dolor sit amet consectetuer adipiscing elit phasellus accumsan cursus velit duis vel nibh at velit scelerisque suscipit lorem ipsum dolor sit amet consectetuer adipiscing elit pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas morbi ac felis fusce commodo aliquam arcu etiam feugiat lorem non metus pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas sed libero praesent ac sem eget est egestas volutpat nunc nonummy metus suspendisse eu ligula vestibulum purus quam scelerisque ut mollis sed nonummy id metus proin magna sed magna purus fermentum eu tincidunt eu varius ut felis etiam rhoncus vivamus aliquet elit ac nisl suspendisse potenti aliquam lorem ante dapibus in viverra quis feugiat a tellus maecenas nec odio et ante tincidunt tempus in auctor lobortis lacus morbi nec metus etiam imperdiet imperdiet orci aenean massa nunc egestas augue at pellentesque laoreet felis eros vehicula leo at malesuada velit leo quis pede  ',0),(61,'node',' aenean posuere tortor sed cursus feugiat nunc augue blandit nunc  aenean posuere tortor sed cursus feugiat nunc augue blandit nunc eu sollicitudin urna dolor sagittis lacus praesent egestas tristique nibh vestibulum rutrum mi nec elementum vehicula eros quam gravida nisl id fringilla neque ante vel mi phasellus consectetuer vestibulum elit aenean tellus metus bibendum sed posuere ac mattis non nunc in ac felis quis tortor malesuada pretium etiam iaculis nunc ac metus donec vitae sapien ut libero venenatis faucibus pellentesque egestas neque sit amet convallis pulvinar justo nulla eleifend augue ac auctor orci leo non est aliquam lorem ante dapibus in viverra quis feugiat a tellus nullam quis ante pellentesque auctor neque nec urna vivamus aliquet elit ac nisl maecenas ullamcorper dui et placerat feugiat eros pede varius nisi condimentum viverra felis nunc et lorem duis vel nibh at velit scelerisque suscipit in consectetuer turpis ut velit nam at tortor in tellus interdum sagittis pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas pellentesque dapibus hendrerit tortor aenean commodo ligula eget dolor praesent nonummy mi in odio cras varius suspendisse feugiat aenean leo ligula porttitor eu consequat vitae eleifend ac enim mauris sollicitudin fermentum libero  ',0),(62,'node',' pellentesque egestas neque sit amet vivamus elementum semper nisi fusce pharetra convallis urna vivamus quis mi curabitur blandit mollis lacus vestibulum facilisis purus nec pulvinar iaculis ligula mi congue nunc vitae euismod ligula urna in dolor ut id nisl quis enim dignissim sagittis pellentesque egestas neque sit amet convallis pulvinar justo nulla eleifend augue ac auctor orci leo non est cras non dolor quisque libero metus condimentum nec tempor a commodo mollis magna vivamus quis mi vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia curae fusce id purus vestibulum eu odio nam commodo suscipit quam morbi mollis tellus ac sapien curabitur nisi sed aliquam ultrices mauris etiam rhoncus donec interdum metus et hendrerit aliquet dolor diam sagittis ligula eget egestas libero turpis vel mi phasellus accumsan cursus velit donec orci lectus aliquam ut faucibus non euismod id nulla nullam dictum felis eu pede mollis pretium curabitur at lacus ac velit ornare lobortis sed aliquam ultrices mauris nullam nulla eros ultricies sit amet nonummy id imperdiet feugiat pede vestibulum volutpat pretium libero  ',0),(63,'node',' suspendisse enim turpis dictum sed iaculis a condimentum nec nisi sed libero aenean ut eros et nisl sagittis vestibulum donec vitae sapien ut libero venenatis faucibus etiam vitae tortor nam eget dui praesent nec nisl a purus blandit viverra in turpis suspendisse enim turpis dictum sed iaculis a condimentum nec nisi vestibulum eu odio phasellus gravida semper nisi vestibulum turpis sem aliquet eget lobortis pellentesque rutrum eu nisl praesent venenatis metus at tortor pulvinar varius etiam iaculis nunc ac metus praesent nonummy mi in odio pellentesque posuere proin viverra ligula sit amet ultrices semper ligula arcu tristique sapien a accumsan nisi mauris ac eros fusce ac felis sit amet ligula pharetra condimentum nam eget dui phasellus magna sed augue ipsum egestas nec vestibulum et malesuada adipiscing dui nullam vel sem cras risus ipsum faucibus ut ullamcorper id varius ac leo vivamus quis mi vestibulum eu odio suspendisse nisl elit rhoncus eget elementum ac condimentum eget diam  ',0),(64,'node',' morbi mollis tellus ac sapien mauris sollicitudin fermentum libero praesent venenatis metus at tortor pulvinar varius curabitur ligula sapien tincidunt non euismod vitae posuere imperdiet leo nam at tortor in tellus interdum sagittis maecenas malesuada fusce ac felis sit amet ligula pharetra condimentum praesent nec nisl a purus blandit viverra in dui magna posuere eget vestibulum et tempor auctor justo nam adipiscing nam adipiscing vivamus euismod mauris nulla porta dolor fusce a quam donec sodales sagittis magna cras id dui cras varius sed in libero ut nibh placerat accumsan donec mollis hendrerit risus ut varius tincidunt libero quisque ut nisi phasellus gravida semper nisi sed magna purus fermentum eu tincidunt eu varius ut felis curabitur vestibulum aliquam leo donec mollis hendrerit risus in enim justo rhoncus ut imperdiet a venenatis vitae justo  ',0),(65,'node',' proin faucibus arcu quis ante fusce risus nisl viverra et tempor et pretium in sapien phasellus ullamcorper ipsum rutrum nunc cras risus ipsum faucibus ut ullamcorper id varius ac leo fusce risus nisl viverra et tempor et pretium in sapien donec venenatis vulputate lorem cum sociis natoque penatibus et magnis dis parturient montes nascetur ridiculus mus sed aliquam ultrices mauris proin magna phasellus leo dolor tempus non auctor et hendrerit quis nisi sed lectus sed aliquam ultrices mauris suspendisse non nisl sit amet velit hendrerit rutrum fusce fermentum odio nec arcu phasellus tempus etiam rhoncus maecenas egestas arcu quis ligula mattis placerat sed libero aenean posuere tortor sed cursus feugiat nunc augue blandit nunc eu sollicitudin urna dolor sagittis lacus nullam vel sem in dui magna posuere eget vestibulum et tempor auctor justo nullam accumsan lorem in dui aliquam lobortis aenean viverra rhoncus pede sed magna purus fermentum eu tincidunt eu varius ut felis in consectetuer turpis ut velit  ',0),(66,'node',' curabitur non elit faucibus malesuada elit at pellentesque tellus curabitur non elit faucibus malesuada elit at pellentesque tellus curabitur pretium dui id quam posuere molestie nulla eget malesuada sem non elementum enim in id porttitor libero proin sodales urna in vehicula fermentum pellentesque scelerisque condimentum augue sit amet suscipit nisi auctor a cras rutrum ex dui ac interdum ex faucibus eu cras ac congue nisi pretium malesuada risus nulla nec dui turpis curabitur lectus nisi dapibus et arcu id feugiat mollis sapien suspendisse non massa nec tellus lobortis lacinia at id mauris sed fermentum ac neque eget auctor in hac habitasse platea dictumst etiam sit amet lobortis neque et tincidunt nisi maecenas nec porta odio aenean a pellentesque nulla nec scelerisque ipsum morbi tempus eros nisi ut semper metus tincidunt vel nullam porta nibh eros id rhoncus velit rutrum et sed diam dui vulputate ac lobortis quis vestibulum et magna donec tristique elementum est quis rhoncus est pretium eu cras nec eleifend dolor nec tristique odio fusce sem metus ornare nec varius quis eleifend non libero cum sociis natoque penatibus et magnis dis parturient montes nascetur ridiculus mus proin sit amet semper posuere  ',0),(67,'node',' phasellus enim eros dapibus non pulvinar vel condimentum quis felis in vel felis fringilla dolor sagittis pulvinar duis ac sapien libero sed elementum nunc sit amet ante aliquam vitae malesuada odio commodo sed rutrum est non ullamcorper finibus pellentesque id aliquam dui morbi nisl dui pulvinar non risus id tristique accumsan nisl quisque euismod vitae lectus dictum lacinia duis sagittis mauris a rhoncus fringilla donec pellentesque accumsan mattis phasellus enim eros dapibus non pulvinar vel condimentum quis felis donec sem dui hendrerit vel dapibus id tristique ac sem cras semper nec velit at scelerisque aenean vel porttitor libero proin viverra pretium nisi nec consectetur sed non turpis ut odio consectetur pharetra id quis lacus nunc at auctor lectus ut rhoncus enim integer venenatis molestie nibh id viverra mauris malesuada a nam quis interdum turpis eget convallis nisl maecenas cursus mattis quam vel pharetra nunc pretium massa ut interdum pharetra magna est facilisis ipsum nec imperdiet metus libero sed nibh aliquam sed urna suscipit feugiat dolor nec convallis arcu vivamus sed diam id nisl lobortis feugiat sit amet efficitur eros integer eu neque metus donec egestas sem ut gravida vulputate leo metus  ',0),(68,'node',' headline news post installation drupal 6 extended support announcement on february 13 2008 drupal 6 was released the policy of the community is to support only the current and previous stable versions when drupal 6 was released drupal 47x was marked unsupported when drupal 7 came out drupal 5x was marked unsupported this policy was created to prevent core and module maintainers from having to maintain more than 2 active major versions of drupal with the coming drupal 8 release this policy has been questioned we want to ensure that sites that wish to move from drupal 6 to drupal 8 have a supported window within which to do so the drupal core team key module maintainers and representatives of the drupal security team met at drupalcon austin to discuss this as an inperson follow up to the previous discussion at https drupalorg node 2136029  drupal 6 core and modules will transition to unsupported status three months after drupal 8 is released unsupported status means the community will not be providing support or patches in the same way we do now continuing to support drupal 6 would be difficult for many reasons including a lack of automated test coverage the requirement for rigorous manual release testing the slowdown it introduces in the release of security fixes for the vast majority of drupal users on version 7 and the general shift of volunteers in the community moving their attention onto drupal 8 development this gives drupal 6 users a few options 1 upgrade to drupal 7 any time between now and 3 months after drupal 800 is released drupal 7 releases undergo almost 40000 automated tests and drupal 7 will be fully supported at least until drupal 9 comes out given the past history the release of drupal 9 is likely to be around 2018 2 upgrade to drupal 8 after it is released but before drupal 6 is not supported anymore fortunately migrate support for drupal 6 to drupal 8 is already in core and there is migrate ui a contributed module while not all contributed modules will be ready at the time drupal 8 is released drupal 8 s migration path handles most of the critical site data via its cck to entities fields in core migrations 3 find an organization that will provide extended support for drupal 6 the drupal security team will provide a method for companies and or individuals to work together in the private security issue queue to continue developing updates and will provide a reasonable amount of time for companies to provide patches to drupal 6 security issues that also affect drupal 7 or drupal 8 the security team will coordinate access to issues for companies wishing to provide extended support for drupal 6 however the team will not explicitly review or test the patches some team members may do this on their own all code created by these vendors would be released to the community organizations and individuals interested in providing this level of support for their customers and who have the technical knowledge to maintain a drupal core release should go to the security team drupal 6 long term support page both the security team and drupal core leadership feel that a 3month window after drupal 8 s release before eclipsing community support for drupal 6 is a workable compromise between leaving drupal 6 sites on an unsupported version the second drupal 8 comes out and acknowledging that our community s volunteer resources are limited and have shifted focus we hope that organizations that rely on drupal 6 will step up to help maintain it after community support winds down and or help their clients update to d8 select rating give it 15 give it 25 give it 35 give it 45 give it 55 no votes yet  ',0),(69,'node',' learn d7 coding or d8  post installation i m not a drupal developer but a pro drupal site builder i can read php and able to tweak and even write some code i was thinking about learning the development but came across this idea that in d8 we have symphony and some other big changes now the question is that shall i start learning d8 dev or i should start with d7 dev see more at  http demoweebpalcom forumplus en node 1 sthashp70hjjcodpuf select rating give it 15 give it 25 give it 35 give it 45 give it 55 no votes yet  ',0);
/*!40000 ALTER TABLE `search_dataset` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `search_index`
--

DROP TABLE IF EXISTS `search_index`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `search_index` (
  `word` varchar(50) NOT NULL DEFAULT '' COMMENT 'The search_total.word that is associated with the search item.',
  `sid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The search_dataset.sid of the searchable item to which the word belongs.',
  `type` varchar(16) NOT NULL COMMENT 'The search_dataset.type of the searchable item to which the word belongs.',
  `score` float DEFAULT NULL COMMENT 'The numeric score of the word, higher being more important.',
  PRIMARY KEY (`word`,`sid`,`type`),
  KEY `sid_type` (`sid`,`type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Stores the search index, associating words, items and...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `search_index`
--

LOCK TABLES `search_index` WRITE;
/*!40000 ALTER TABLE `search_index` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `search_index` VALUES ('07x',21,'node',1),('08x',21,'node',1),('0907am',12,'node',0.749958),('0908am',5,'node',1.47104),('0908pm',30,'node',0.745294),('0908pm',31,'node',2.21308),('1',1,'node',0.972861),('1',3,'node',25.923),('1',4,'node',24.7883),('1',5,'node',24.8879),('1',6,'node',24.8879),('1',7,'node',26.3001),('1',9,'node',26.2146),('1',12,'node',24.5916),('1',15,'node',4.38856),('1',16,'node',0.869951),('1',17,'node',25.9469),('1',26,'node',24),('1',27,'node',24.5916),('1',28,'node',24.9883),('1',29,'node',24.4944),('1',30,'node',24.5916),('1',31,'node',25.1915),('1',36,'node',26),('1',47,'node',24.9883),('1',53,'node',5.82702),('1',54,'node',25.6722),('1',55,'node',26.0481),('1',56,'node',25.8218),('1',68,'node',0.863659),('1',69,'node',11),('10',53,'node',8.2238),('1058',1,'node',0.931053),('10x',21,'node',1),('11',12,'node',0.754681),('11',30,'node',0.749958),('11',31,'node',2.21822),('11',53,'node',7.69621),('12',5,'node',1.47582),('12',53,'node',7.65163),('122',47,'node',0.784336),('123456789',40,'node',2),('123456789',41,'node',2),('124',3,'node',0.851346),('12x',21,'node',1),('13',15,'node',1),('13',16,'node',1),('13',21,'node',1),('13',53,'node',9.83801),('13',68,'node',1),('14',53,'node',7.37415),('14x',21,'node',1),('15',1,'node',2.81919),('15',3,'node',1.63988),('15',7,'node',0.813674),('15',15,'node',2.56366),('15',16,'node',1.08524),('15',17,'node',0.882818),('15',18,'node',1),('15',19,'node',0.437873),('15',20,'node',1.82206),('15',21,'node',0.824901),('15',22,'node',0.699655),('15',47,'node',1.54034),('15',53,'node',14.8577),('15',54,'node',1.53776),('15',55,'node',2.14074),('15',56,'node',1.70635),('15',68,'node',0.600219),('15',69,'node',1),('1540',1,'node',1.92384),('1540',16,'node',0.571798),('1540',47,'node',0.754681),('1540',53,'node',2.05036),('1540',55,'node',0.747619),('15x',21,'node',1),('16',53,'node',7.19372),('1648',1,'node',1),('16m',22,'node',0.945829),('17',53,'node',6.89414),('1720',7,'node',2.03416),('1721',7,'node',0.689612),('1723',7,'node',1.87802),('1724',7,'node',1.18908),('1727',8,'node',1.29283),('1728',8,'node',1.2717),('1730',9,'node',0.736141),('1758',55,'node',0.776703),('1759',55,'node',0.679856),('18',53,'node',6.75366),('1806',54,'node',0.800068),('1830',53,'node',0.863659),('1832',53,'node',1.44961),('1833',53,'node',1.39122),('1834',53,'node',1.98558),('1835',53,'node',1.24234),('19',54,'node',8.77142),('19',56,'node',0.860547),('1e1',40,'node',1),('1e1',41,'node',1),('1m',22,'node',1.81635),('2',1,'node',13.9238),('2',3,'node',17.2194),('2',4,'node',14.9024),('2',5,'node',14.9514),('2',6,'node',14.9514),('2',7,'node',18.2826),('2',8,'node',15.9778),('2',9,'node',17.418),('2',10,'node',0.972861),('2',11,'node',1),('2',12,'node',14.8054),('2',16,'node',3.45524),('2',17,'node',17.2194),('2',19,'node',6.61888),('2',26,'node',24),('2',27,'node',14.8054),('2',28,'node',15.0007),('2',29,'node',14.7574),('2',30,'node',14.8054),('2',31,'node',16.5291),('2',41,'node',26),('2',47,'node',17.9235),('2',53,'node',3.0594),('2',54,'node',17.0896),('2',55,'node',17.6604),('2',56,'node',27.2595),('2',68,'node',1.7974),('20',28,'node',26),('20',55,'node',8.51611),('2008',16,'node',1),('2008',21,'node',9.29854),('2008',68,'node',1),('2014',5,'node',1.47342),('2014',12,'node',0.752312),('2014',30,'node',0.747619),('2014',31,'node',2.21564),('2018',16,'node',0.805455),('2018',68,'node',0.800068),('21',55,'node',7.45733),('2136029',16,'node',11),('2136029',68,'node',11),('22',3,'node',0.830633),('22',9,'node',26),('22',15,'node',0.824901),('22',53,'node',2.61556),('22',54,'node',0.781775),('22',55,'node',0.670377),('2347',15,'node',1),('2351',3,'node',0.816452),('2351',15,'node',0.822065),('2351',53,'node',2.6116),('2351',54,'node',0.769219),('2351',55,'node',0.664818),('2357',15,'node',0.833529),('2358',37,'node',0.839384),('25',1,'node',2.81919),('25',3,'node',1.63663),('25',7,'node',0.810915),('25',15,'node',2.56366),('25',16,'node',1.08373),('25',17,'node',0.879565),('25',18,'node',1),('25',19,'node',0.43709),('25',20,'node',0.822065),('25',21,'node',0.822065),('25',22,'node',0.697623),('25',47,'node',1.5376),('25',53,'node',7.60153),('25',54,'node',1.5349),('25',55,'node',2.13802),('25',56,'node',1.70292),('25',68,'node',0.59873),('25',69,'node',1),('27',8,'node',26),('2x',21,'node',1),('3',1,'node',10.2017),('3',3,'node',14.3913),('3',4,'node',12.4677),('3',5,'node',12.5084),('3',6,'node',12.5084),('3',7,'node',14.6116),('3',8,'node',11.36),('3',9,'node',14.5559),('3',12,'node',12.3871),('3',16,'node',1.59508),('3',17,'node',14.3913),('3',27,'node',12.3871),('3',28,'node',12.5494),('3',29,'node',12.3472),('3',30,'node',12.3871),('3',31,'node',13.8185),('3',47,'node',14.3372),('3',54,'node',14.2836),('3',55,'node',14.1251),('3',56,'node',14.7814),('3',68,'node',1.58446),('309',56,'node',0.873132),('31',31,'node',26),('337',20,'node',1.93076),('337',22,'node',0.731649),('35',1,'node',2.81919),('35',3,'node',1.6334),('35',7,'node',0.808176),('35',10,'node',0.976851),('35',15,'node',2.56366),('35',16,'node',1.08224),('35',17,'node',0.876337),('35',18,'node',1),('35',19,'node',0.436309),('35',20,'node',0.819249),('35',21,'node',0.819249),('35',22,'node',0.695602),('35',27,'node',26),('35',47,'node',1.53488),('35',53,'node',7.5982),('35',54,'node',1.53206),('35',55,'node',2.13532),('35',56,'node',1.69952),('35',68,'node',0.597248),('35',69,'node',1),('3month',16,'node',0.645209),('3month',68,'node',0.641769),('4',1,'node',0.976851),('4',3,'node',9.33156),('4',9,'node',1.63852),('4',10,'node',0.98493),('4',15,'node',2.56366),('4',16,'node',0.482016),('4',17,'node',0.860547),('40',56,'node',0.839384),('40000',16,'node',0.839384),('40000',68,'node',0.833529),('404',33,'node',26),('41',20,'node',1),('41',22,'node',1),('45',1,'node',3.81919),('45',3,'node',1.6302),('45',7,'node',0.805455),('45',8,'node',0.676032),('45',11,'node',1),('45',15,'node',2.56366),('45',16,'node',1.67214),('45',17,'node',0.873132),('45',18,'node',1),('45',19,'node',0.435532),('45',20,'node',0.816452),('45',21,'node',0.816452),('45',22,'node',0.693594),('45',47,'node',1.53218),('45',53,'node',7.5949),('45',54,'node',1.52925),('45',55,'node',2.13263),('45',56,'node',1.69614),('45',68,'node',0.595774),('45',69,'node',1),('47x',16,'node',1),('47x',68,'node',1),('4x',20,'node',0.913226),('5',8,'node',0.679856),('5',11,'node',1),('5',15,'node',12),('5',16,'node',0.587082),('5',21,'node',0.889397),('5',22,'node',0.896076),('5',36,'node',26),('5',55,'node',0.786915),('5',56,'node',0.854391),('50',12,'node',26),('5015',20,'node',1.97685),('5015',22,'node',3),('5130',22,'node',2),('5144',22,'node',1),('525',20,'node',0.876337),('52x',20,'node',0.927431),('53',20,'node',1.77259),('54',4,'node',26),('54',20,'node',0.869951),('55',1,'node',2.81919),('55',3,'node',1.62702),('55',7,'node',0.802752),('55',15,'node',2.56366),('55',16,'node',1.07926),('55',17,'node',0.869951),('55',18,'node',1),('55',19,'node',0.434757),('55',20,'node',0.813674),('55',21,'node',0.813674),('55',22,'node',0.691597),('55',47,'node',1.52949),('55',53,'node',7.59162),('55',54,'node',1.52645),('55',55,'node',2.12997),('55',56,'node',1.69279),('55',68,'node',0.594307),('55',69,'node',1),('57',1,'node',1.92384),('57',16,'node',0.578643),('57',47,'node',0.766757),('57',53,'node',2.05712),('57',55,'node',0.759465),('5x',16,'node',1),('5x',22,'node',1),('5x',68,'node',1),('6',15,'node',9.13696),('6',16,'node',13.1344),('6',19,'node',0.802752),('6',20,'node',1.92743),('6',21,'node',1.8861),('6',22,'node',2.73841),('6',68,'node',13.0875),('60',20,'node',1),('6122014',1,'node',1.92384),('6122014',16,'node',0.573154),('6122014',47,'node',0.757065),('6122014',53,'node',2.0526),('6122014',55,'node',0.749958),('6122014',56,'node',0.842342),('6292014',1,'node',1),('6x',19,'node',8.70145),('6x',22,'node',1),('6xzip',19,'node',1.57739),('7',16,'node',12.673),('7',20,'node',1.87634),('7',21,'node',3.59188),('7',22,'node',4.35829),('7',30,'node',26),('7',68,'node',5.12261),('70',16,'node',0.543537),('7082014',15,'node',1),('7082014',53,'node',2.19677),('7092014',7,'node',0.774192),('7092014',9,'node',1.50898),('7092014',11,'node',1.83965),('71',20,'node',1),('71',22,'node',0.738408),('7132014',3,'node',0.819249),('7132014',15,'node',2.65559),('7132014',53,'node',2.61357),('7132014',54,'node',0.771698),('7132014',55,'node',0.66666),('7142014',16,'node',0.588512),('727',16,'node',0.504001),('728',16,'node',4.26339),('7x',16,'node',1.56625),('8',16,'node',8.99661),('8',20,'node',1.85082),('8',22,'node',1.87634),('8',47,'node',8.59953),('8',53,'node',26),('8',68,'node',8.95892),('800',16,'node',0.851346),('800',68,'node',0.845322),('8122014',10,'node',0.942091),('8162014',53,'node',6.93554),('8172014',7,'node',5.79305),('8172014',8,'node',2.56635),('8172014',9,'node',0.738408),('8172014',54,'node',0.802752),('8172014',55,'node',1.45909),('8172014',56,'node',0.876337),('8182014',37,'node',0.842342),('8192014',3,'node',0.854391),('8192014',47,'node',0.786915),('8212014',1,'node',0.934703),('83',20,'node',1.93897),('83',22,'node',0.736141),('9',16,'node',1.63582),('9',53,'node',9.46601),('9',68,'node',1.6247),('921',10,'node',0.938382),('922',15,'node',1),('922',53,'node',2.19389),('934',11,'node',1.8357),('935',7,'node',0.771698),('935',9,'node',1.50635),('ab',3,'node',4.73288),('ab',4,'node',2.4068),('ab',5,'node',2.41491),('ab',6,'node',2.41491),('ab',7,'node',4.79235),('ab',8,'node',1.43956),('ab',9,'node',4.7773),('ab',12,'node',2.39074),('ab',17,'node',4.73288),('ab',27,'node',2.39074),('ab',28,'node',2.42308),('ab',29,'node',2.3828),('ab',30,'node',2.39074),('ab',31,'node',3.64057),('ab',40,'node',1),('ab',41,'node',1),('ab',47,'node',4.71831),('ab',54,'node',4.70385),('ab',55,'node',4.66115),('ab',56,'node',4.83673),('able',1,'node',1),('able',69,'node',1),('about',1,'node',1),('about',15,'node',2),('about',16,'node',1.07203),('about',19,'node',0.44024),('about',20,'node',30.7763),('about',21,'node',0.931053),('about',22,'node',0.822065),('about',69,'node',1),('abstracted',22,'node',1.49864),('ac',4,'node',3),('ac',5,'node',23.8003),('ac',6,'node',3),('ac',7,'node',5.23293),('ac',8,'node',5.37276),('ac',9,'node',1.47854),('ac',10,'node',4.84832),('ac',11,'node',4.84234),('ac',12,'node',3.72721),('ac',13,'node',4),('ac',14,'node',2),('ac',15,'node',3.47991),('ac',26,'node',2),('ac',27,'node',3),('ac',28,'node',4.51653),('ac',29,'node',3),('ac',30,'node',3),('ac',31,'node',2.70583),('ac',33,'node',3),('ac',34,'node',5.04503),('ac',35,'node',1),('ac',36,'node',1),('ac',37,'node',5.58025),('ac',38,'node',5.09914),('ac',42,'node',5.62937),('ac',43,'node',5.62937),('ac',44,'node',5.62937),('ac',45,'node',5.62937),('ac',46,'node',5.62937),('ac',47,'node',1.68809),('ac',48,'node',4.96498),('ac',49,'node',4),('ac',50,'node',3),('ac',51,'node',2),('ac',52,'node',5),('ac',53,'node',8.70035),('ac',55,'node',1.50532),('ac',56,'node',0.822065),('ac',57,'node',5.63593),('ac',58,'node',5),('ac',60,'node',5),('ac',61,'node',6.97685),('ac',62,'node',3),('ac',63,'node',5),('ac',64,'node',27),('ac',65,'node',1),('ac',66,'node',4),('ac',67,'node',2),('accept',19,'node',0.62674),('access',16,'node',0.697623),('access',19,'node',4.5638),('access',68,'node',0.693594),('according',16,'node',0.514686),('accordion',26,'node',52),('account',19,'node',1),('account',22,'node',0.851346),('accounts',19,'node',28.9011),('accounts',22,'node',1),('accumsan',2,'node',1),('accumsan',3,'node',1),('accumsan',4,'node',0.993146),('accumsan',5,'node',1.69901),('accumsan',6,'node',0.997306),('accumsan',7,'node',2.36942),('accumsan',8,'node',5.07363),('accumsan',9,'node',2.48344),('accumsan',10,'node',1),('accumsan',11,'node',2.84234),('accumsan',12,'node',0.98493),('accumsan',15,'node',1.49643),('accumsan',17,'node',1),('accumsan',27,'node',0.98493),('accumsan',28,'node',1),('accumsan',29,'node',0.980874),('accumsan',30,'node',0.98493),('accumsan',34,'node',3.72492),('accumsan',35,'node',0.961087),('accumsan',37,'node',1),('accumsan',38,'node',3.74386),('accumsan',39,'node',2.50559),('accumsan',42,'node',1.9496),('accumsan',43,'node',1.9496),('accumsan',44,'node',1.9496),('accumsan',45,'node',1.9496),('accumsan',46,'node',1.9496),('accumsan',47,'node',1),('accumsan',48,'node',1),('accumsan',51,'node',1),('accumsan',52,'node',1),('accumsan',53,'node',3.41887),('accumsan',54,'node',1),('accumsan',55,'node',2.28871),('accumsan',56,'node',1),('accumsan',57,'node',1.9496),('accumsan',58,'node',1),('accumsan',60,'node',1),('accumsan',62,'node',1),('accumsan',63,'node',1),('accumsan',64,'node',1),('accumsan',65,'node',1),('accumsan',67,'node',2),('accusam',2,'node',2.86941),('accusam',39,'node',6.33148),('accusantium',3,'node',4.73288),('accusantium',4,'node',2.43481),('accusantium',5,'node',2.44313),('accusantium',6,'node',2.44313),('accusantium',7,'node',4.79235),('accusantium',8,'node',1.46022),('accusantium',9,'node',4.7773),('accusantium',12,'node',2.41835),('accusantium',17,'node',4.73288),('accusantium',27,'node',2.41835),('accusantium',28,'node',2.45151),('accusantium',29,'node',2.4102),('accusantium',30,'node',2.41835),('accusantium',31,'node',3.64057),('accusantium',40,'node',1),('accusantium',41,'node',1),('accusantium',47,'node',4.71831),('accusantium',54,'node',4.70385),('accusantium',55,'node',4.66115),('accusantium',56,'node',4.83673),('achieve',21,'node',0.876337),('acknowledging',16,'node',0.635),('acknowledging',68,'node',0.63167),('across',1,'node',1),('across',19,'node',0.679856),('across',69,'node',1),('active',16,'node',1),('active',68,'node',1),('actively',20,'node',1),('actually',19,'node',0.45757),('ad',2,'node',2.84793),('ad',7,'node',0.595774),('ad',8,'node',1),('ad',10,'node',0.902857),('ad',11,'node',2),('ad',14,'node',1),('ad',34,'node',1),('ad',38,'node',1),('ad',39,'node',3.84557),('ad',47,'node',26),('ad',53,'node',0.641769),('ad',54,'node',0.722831),('add',19,'node',2.343),('added',19,'node',0.570448),('additional',19,'node',1.4849),('additional',20,'node',0.934703),('additional',22,'node',0.716357),('additionally',22,'node',0.997306),('adipisci',3,'node',0.916736),('adipisci',4,'node',0.78951),('adipisci',5,'node',0.792123),('adipisci',6,'node',0.792123),('adipisci',7,'node',0.931053),('adipisci',9,'node',0.927431),('adipisci',12,'node',0.784336),('adipisci',17,'node',0.916736),('adipisci',27,'node',0.784336),('adipisci',28,'node',0.794753),('adipisci',29,'node',0.781775),('adipisci',30,'node',0.784336),('adipisci',31,'node',0.876337),('adipisci',47,'node',0.913226),('adipisci',54,'node',0.909743),('adipisci',55,'node',0.899454),('adipisci',56,'node',0.942091),('adipiscing',2,'node',1.89968),('adipiscing',7,'node',22.4595),('adipiscing',8,'node',5.28767),('adipiscing',9,'node',1.49856),('adipiscing',11,'node',5.81777),('adipiscing',13,'node',3),('adipiscing',14,'node',1),('adipiscing',15,'node',1.76814),('adipiscing',30,'node',0.714225),('adipiscing',31,'node',1.52024),('adipiscing',33,'node',1),('adipiscing',34,'node',2.80275),('adipiscing',35,'node',2),('adipiscing',36,'node',1),('adipiscing',37,'node',1.74676),('adipiscing',38,'node',2.81092),('adipiscing',39,'node',1),('adipiscing',42,'node',6.8422),('adipiscing',43,'node',6.8422),('adipiscing',44,'node',6.8422),('adipiscing',45,'node',6.8422),('adipiscing',46,'node',6.8422),('adipiscing',48,'node',2),('adipiscing',50,'node',2),('adipiscing',51,'node',1),('adipiscing',53,'node',3.30159),('adipiscing',54,'node',0.754681),('adipiscing',57,'node',6.8456),('adipiscing',58,'node',2),('adipiscing',59,'node',1),('adipiscing',60,'node',27),('adipiscing',63,'node',1),('adipiscing',64,'node',2),('adipisici',2,'node',1),('admin',1,'node',1.92384),('admin',5,'node',0.718502),('admin',7,'node',13.5859),('admin',8,'node',12.9317),('admin',9,'node',12.4549),('admin',10,'node',11.9496),('admin',11,'node',11.9809),('admin',12,'node',0.76188),('admin',16,'node',0.585658),('admin',31,'node',0.733888),('admin',37,'node',0.851346),('admin',47,'node',0.779231),('admin',53,'node',2.064),('admin',55,'node',0.771698),('admin',56,'node',0.869951),('administration',20,'node',0.848323),('administrators',16,'node',0.53161),('advertising',18,'node',2),('advice',19,'node',2.48283),('advise',16,'node',0.532778),('advisories',16,'node',1.07385),('aenean',3,'node',0.997306),('aenean',7,'node',19.5808),('aenean',8,'node',2.11199),('aenean',9,'node',3.47882),('aenean',10,'node',1),('aenean',11,'node',2),('aenean',15,'node',0.759465),('aenean',17,'node',0.997306),('aenean',29,'node',0.76431),('aenean',34,'node',0.857458),('aenean',35,'node',3),('aenean',37,'node',2),('aenean',38,'node',0.866793),('aenean',42,'node',2.96109),('aenean',43,'node',2.96109),('aenean',44,'node',2.96109),('aenean',45,'node',2.96109),('aenean',46,'node',2.96109),('aenean',47,'node',0.993146),('aenean',49,'node',1),('aenean',50,'node',1),('aenean',51,'node',2),('aenean',52,'node',2),('aenean',53,'node',3.0289),('aenean',54,'node',1.72516),('aenean',55,'node',1.70406),('aenean',56,'node',1),('aenean',57,'node',2.96109),('aenean',58,'node',1),('aenean',59,'node',1),('aenean',60,'node',1),('aenean',61,'node',29.9849),('aenean',63,'node',1),('aenean',65,'node',2),('aenean',66,'node',1),('aenean',67,'node',1),('affect',16,'node',0.7017),('affect',68,'node',0.697623),('after',16,'node',3.91312),('after',68,'node',3.8952),('again',19,'node',1.27094),('ago',1,'node',1.92384),('ago',3,'node',0.824901),('ago',15,'node',1.82206),('ago',16,'node',0.575885),('ago',47,'node',0.76188),('ago',53,'node',6.86875),('ago',54,'node',0.776703),('ago',55,'node',1.42134),('ago',56,'node',0.848323),('ahead',19,'node',0.446681),('aims',21,'node',1),('alexander',40,'node',1),('alexander',41,'node',1),('alias',19,'node',16.6006),('aliases',19,'node',1.09339),('aliqua',2,'node',1),('aliquam',1,'node',0.902857),('aliquam',2,'node',1.87679),('aliquam',4,'node',1.99315),('aliquam',5,'node',2.73345),('aliquam',6,'node',1.99731),('aliquam',7,'node',20.4286),('aliquam',8,'node',4.1791),('aliquam',10,'node',1),('aliquam',12,'node',1.98493),('aliquam',15,'node',1.76676),('aliquam',27,'node',1.98493),('aliquam',28,'node',2),('aliquam',29,'node',1.97818),('aliquam',30,'node',1.98493),('aliquam',31,'node',1.46468),('aliquam',33,'node',3),('aliquam',34,'node',4.32522),('aliquam',35,'node',2.98493),('aliquam',36,'node',2),('aliquam',37,'node',0.945829),('aliquam',38,'node',4.37285),('aliquam',39,'node',3.98902),('aliquam',42,'node',5.74564),('aliquam',43,'node',5.74564),('aliquam',44,'node',5.74564),('aliquam',45,'node',5.74564),('aliquam',46,'node',5.74564),('aliquam',47,'node',1.57194),('aliquam',48,'node',2.98493),('aliquam',49,'node',2),('aliquam',50,'node',3),('aliquam',51,'node',1),('aliquam',52,'node',1),('aliquam',53,'node',6.61871),('aliquam',54,'node',0.752312),('aliquam',55,'node',1.99282),('aliquam',57,'node',5.74892),('aliquam',59,'node',1),('aliquam',60,'node',2),('aliquam',61,'node',1),('aliquam',62,'node',3),('aliquam',64,'node',1),('aliquam',65,'node',3),('aliquam',67,'node',3),('aliquet',3,'node',0.989021),('aliquet',7,'node',1),('aliquet',8,'node',3.34699),('aliquet',9,'node',1.86366),('aliquet',10,'node',4),('aliquet',13,'node',1),('aliquet',15,'node',0.802752),('aliquet',17,'node',0.989021),('aliquet',30,'node',0.712106),('aliquet',31,'node',1.41904),('aliquet',34,'node',2),('aliquet',35,'node',1),('aliquet',36,'node',2),('aliquet',37,'node',0.896076),('aliquet',38,'node',2),('aliquet',39,'node',1),('aliquet',42,'node',1.90629),('aliquet',43,'node',1.90629),('aliquet',44,'node',1.90629),('aliquet',45,'node',1.90629),('aliquet',46,'node',1.90629),('aliquet',47,'node',0.98493),('aliquet',48,'node',2),('aliquet',50,'node',1),('aliquet',51,'node',1),('aliquet',52,'node',1),('aliquet',54,'node',0.980874),('aliquet',55,'node',1.62825),('aliquet',56,'node',1),('aliquet',57,'node',1.90629),('aliquet',59,'node',1),('aliquet',60,'node',1),('aliquet',61,'node',1),('aliquet',62,'node',1),('aliquet',63,'node',1),('aliquid',2,'node',0.920273),('aliquip',2,'node',1.91323),('aliquip',39,'node',3.8247),('aliquyam',2,'node',0.980874),('aliquyam',39,'node',3.92587),('all',16,'node',2.49529),('all',19,'node',1.20112),('all',21,'node',1),('all',23,'node',1),('all',53,'node',1),('all',68,'node',1.44773),('allow',19,'node',1.91511),('allow',21,'node',12),('allowoverride',21,'node',1),('allows',19,'node',0.597248),('allows',22,'node',1),('almost',16,'node',0.842342),('almost',68,'node',0.836446),('already',16,'node',0.78951),('already',19,'node',1),('already',22,'node',0.810915),('already',68,'node',0.784336),('also',16,'node',0.703756),('also',18,'node',1),('also',19,'node',1.01274),('also',20,'node',1.85746),('also',21,'node',2),('also',22,'node',2),('also',68,'node',0.699655),('alt',23,'node',1),('alter',22,'node',1),('alternately',19,'node',0.727213),('alternative',21,'node',1),('always',19,'node',1.95912),('amet',2,'node',13.4903),('amet',3,'node',0.920273),('amet',4,'node',2.79212),('amet',5,'node',2.79475),('amet',6,'node',2.79475),('amet',7,'node',6.28025),('amet',8,'node',9.19743),('amet',9,'node',4.6251),('amet',10,'node',2.86366),('amet',11,'node',1.68771),('amet',12,'node',2.78691),('amet',13,'node',1),('amet',14,'node',1),('amet',17,'node',0.920273),('amet',26,'node',4),('amet',27,'node',2.78691),('amet',28,'node',3.55928),('amet',29,'node',2.78434),('amet',30,'node',3.50542),('amet',31,'node',4.13768),('amet',33,'node',1),('amet',34,'node',4.75505),('amet',35,'node',2),('amet',37,'node',2.91323),('amet',38,'node',4.77476),('amet',39,'node',10.5687),('amet',42,'node',11.5464),('amet',43,'node',11.5464),('amet',44,'node',11.5464),('amet',45,'node',11.5464),('amet',46,'node',11.5464),('amet',47,'node',2.63346),('amet',48,'node',1),('amet',49,'node',1),('amet',50,'node',1),('amet',52,'node',3),('amet',53,'node',16.7385),('amet',54,'node',2.44429),('amet',55,'node',1.64127),('amet',56,'node',0.945829),('amet',57,'node',11.5562),('amet',58,'node',3),('amet',59,'node',1),('amet',60,'node',27),('amet',61,'node',1),('amet',62,'node',28),('amet',63,'node',2),('amet',64,'node',1),('amet',65,'node',1),('amet',66,'node',2.98902),('amet',67,'node',2),('amount',16,'node',0.707906),('amount',68,'node',0.703756),('an',16,'node',2.91259),('an',19,'node',2.11698),('an',20,'node',0.96498),('an',22,'node',1),('an',23,'node',2),('an',68,'node',2.36722),('and',1,'node',5),('and',3,'node',11),('and',12,'node',26),('and',15,'node',2),('and',16,'node',14.7481),('and',19,'node',17.9588),('and',20,'node',6.64549),('and',21,'node',7.90286),('and',22,'node',9.08836),('and',47,'node',11),('and',68,'node',12.6241),('and',69,'node',3),('anim',2,'node',1),('anim',3,'node',3.76002),('anim',4,'node',2.4717),('anim',5,'node',2.4803),('anim',6,'node',2.4803),('anim',7,'node',3.80333),('anim',8,'node',1.48461),('anim',9,'node',3.79237),('anim',12,'node',2.45469),('anim',17,'node',3.76002),('anim',27,'node',2.45469),('anim',28,'node',2.48896),('anim',29,'node',2.44627),('anim',30,'node',2.45469),('anim',31,'node',2.65477),('anim',39,'node',2.26253),('anim',40,'node',1),('anim',41,'node',1),('anim',47,'node',3.7494),('anim',54,'node',3.73887),('anim',55,'node',3.70775),('anim',56,'node',3.83673),('animation',27,'node',8.46141),('announcement',16,'node',2.08464),('announcement',68,'node',1),('announcements',3,'node',11),('announcements',47,'node',11),('another',19,'node',2.45115),('ante',3,'node',0.779231),('ante',4,'node',1),('ante',5,'node',21.8003),('ante',6,'node',1),('ante',7,'node',5.10865),('ante',8,'node',3.65176),('ante',10,'node',1.85439),('ante',11,'node',4),('ante',12,'node',1),('ante',13,'node',2),('ante',14,'node',2),('ante',15,'node',0.766757),('ante',27,'node',1),('ante',28,'node',1.7717),('ante',29,'node',1),('ante',30,'node',1.72066),('ante',31,'node',2.23488),('ante',33,'node',1),('ante',34,'node',1.75973),('ante',35,'node',1),('ante',36,'node',1),('ante',37,'node',2.91466),('ante',38,'node',1.7796),('ante',42,'node',6.70831),('ante',43,'node',6.70831),('ante',44,'node',6.70831),('ante',45,'node',6.70831),('ante',46,'node',6.70831),('ante',48,'node',2),('ante',49,'node',2),('ante',50,'node',1),('ante',52,'node',1),('ante',53,'node',6.62618),('ante',56,'node',0.830633),('ante',57,'node',6.71156),('ante',58,'node',3),('ante',60,'node',2),('ante',61,'node',3),('ante',62,'node',1),('ante',65,'node',26),('ante',67,'node',1),('any',16,'node',0.863659),('any',19,'node',3.26046),('any',21,'node',1),('any',68,'node',0.857458),('anymore',16,'node',0.797402),('anymore',68,'node',0.792123),('anything',8,'node',26),('apache',20,'node',1),('apache',21,'node',34),('aperiam',3,'node',4.73288),('aperiam',4,'node',2.41902),('aperiam',5,'node',2.42723),('aperiam',6,'node',2.42723),('aperiam',7,'node',4.79235),('aperiam',8,'node',1.4486),('aperiam',9,'node',4.7773),('aperiam',12,'node',2.40279),('aperiam',17,'node',4.73288),('aperiam',27,'node',2.40279),('aperiam',28,'node',2.43548),('aperiam',29,'node',2.39476),('aperiam',30,'node',2.40279),('aperiam',31,'node',3.64057),('aperiam',40,'node',1),('aperiam',41,'node',1),('aperiam',47,'node',4.71831),('aperiam',54,'node',4.70385),('aperiam',55,'node',4.66115),('aperiam',56,'node',4.83673),('api',16,'node',0.508221),('apparently',19,'node',4),('apple',3,'node',26),('apple',47,'node',26),('application',19,'node',0.655756),('apps',12,'node',26),('aptent',7,'node',0.600219),('aptent',8,'node',1),('aptent',10,'node',0.913226),('aptent',11,'node',2),('aptent',14,'node',1),('aptent',34,'node',1),('aptent',38,'node',1),('aptent',53,'node',0.646943),('aptent',54,'node',0.729424),('architecto',3,'node',4.73288),('architecto',4,'node',2.39201),('architecto',5,'node',2.40001),('architecto',6,'node',2.40001),('architecto',7,'node',4.79235),('architecto',8,'node',1.42857),('architecto',9,'node',4.7773),('architecto',12,'node',2.37616),('architecto',17,'node',4.73288),('architecto',27,'node',2.37616),('architecto',28,'node',2.40807),('architecto',29,'node',2.36831),('architecto',30,'node',2.37616),('architecto',31,'node',3.64057),('architecto',40,'node',1),('architecto',41,'node',1),('architecto',47,'node',4.71831),('architecto',54,'node',4.70385),('architecto',55,'node',4.66115),('architecto',56,'node',4.83673),('archive',19,'node',0.810915),('arcu',4,'node',0.997306),('arcu',5,'node',1),('arcu',6,'node',1),('arcu',7,'node',2.56321),('arcu',8,'node',3.93331),('arcu',9,'node',1.48842),('arcu',10,'node',5),('arcu',11,'node',4.84234),('arcu',12,'node',0.989021),('arcu',13,'node',2),('arcu',15,'node',1.94583),('arcu',27,'node',0.989021),('arcu',28,'node',1),('arcu',29,'node',0.98493),('arcu',30,'node',1.69902),('arcu',31,'node',1.43723),('arcu',33,'node',2),('arcu',34,'node',3.4006),('arcu',35,'node',0.993146),('arcu',36,'node',3),('arcu',37,'node',2.8894),('arcu',38,'node',3.43738),('arcu',39,'node',2),('arcu',42,'node',3.75024),('arcu',43,'node',3.75024),('arcu',44,'node',3.75024),('arcu',45,'node',3.75024),('arcu',46,'node',3.75024),('arcu',47,'node',0.738408),('arcu',48,'node',3),('arcu',49,'node',1),('arcu',50,'node',2),('arcu',51,'node',1),('arcu',53,'node',7.56132),('arcu',57,'node',3.75359),('arcu',58,'node',1),('arcu',60,'node',1),('arcu',63,'node',1),('arcu',65,'node',28),('arcu',66,'node',1),('arcu',67,'node',1),('are',16,'node',1.70191),('are',19,'node',5.34408),('are',20,'node',1.93838),('are',22,'node',8.1404),('are',55,'node',26),('are',68,'node',0.625114),('around',16,'node',0.808176),('around',68,'node',0.802752),('art',11,'node',26),('as',16,'node',2.07621),('as',19,'node',4.43283),('as',20,'node',1),('as',22,'node',9.16634),('as',68,'node',1),('ask',19,'node',0.563797),('aspen',7,'node',26),('aspernatur',3,'node',0.942091),('aspernatur',4,'node',0.805455),('aspernatur',5,'node',0.808176),('aspernatur',6,'node',0.808176),('aspernatur',7,'node',0.957226),('aspernatur',9,'node',0.953396),('aspernatur',12,'node',0.800068),('aspernatur',17,'node',0.942091),('aspernatur',27,'node',0.800068),('aspernatur',28,'node',0.810915),('aspernatur',29,'node',0.797402),('aspernatur',30,'node',0.800068),('aspernatur',31,'node',0.896076),('aspernatur',47,'node',0.938382),('aspernatur',54,'node',0.934703),('aspernatur',55,'node',0.923838),('aspernatur',56,'node',0.968904),('association',18,'node',2),('assum',39,'node',1.67598),('at',2,'node',3.86941),('at',3,'node',0.98493),('at',4,'node',2),('at',5,'node',4.19055),('at',6,'node',2),('at',7,'node',5.58868),('at',8,'node',0.980874),('at',9,'node',1.84563),('at',10,'node',3.59181),('at',11,'node',4),('at',12,'node',2),('at',13,'node',2),('at',14,'node',29),('at',15,'node',0.747619),('at',16,'node',3.60233),('at',17,'node',0.98493),('at',19,'node',2.33579),('at',21,'node',1),('at',22,'node',0.953396),('at',27,'node',2),('at',28,'node',2),('at',29,'node',2),('at',30,'node',2),('at',31,'node',2.85439),('at',33,'node',2),('at',34,'node',2.60281),('at',36,'node',1),('at',37,'node',2.58691),('at',38,'node',2.62183),('at',39,'node',8.84439),('at',42,'node',6.96601),('at',43,'node',6.96601),('at',44,'node',6.96601),('at',45,'node',6.96601),('at',46,'node',6.96601),('at',47,'node',0.980874),('at',49,'node',3),('at',50,'node',1),('at',52,'node',2),('at',53,'node',2.27937),('at',54,'node',2.491),('at',55,'node',2.25042),('at',56,'node',1),('at',57,'node',6.96601),('at',60,'node',3),('at',61,'node',2),('at',62,'node',1),('at',63,'node',1),('at',64,'node',2),('at',66,'node',28),('at',67,'node',2),('at',68,'node',3.59166),('at',69,'node',1),('attack',21,'node',10.363),('attention',16,'node',0.889397),('attention',19,'node',16),('attention',68,'node',0.882818),('auctor',4,'node',2),('auctor',5,'node',2.69966),('auctor',6,'node',2),('auctor',7,'node',1.32663),('auctor',9,'node',0.892724),('auctor',10,'node',1),('auctor',11,'node',2),('auctor',12,'node',2),('auctor',13,'node',2),('auctor',15,'node',0.813674),('auctor',26,'node',2),('auctor',27,'node',2),('auctor',28,'node',2),('auctor',29,'node',2),('auctor',30,'node',2),('auctor',31,'node',2.81925),('auctor',36,'node',1),('auctor',37,'node',2),('auctor',39,'node',2),('auctor',42,'node',1.83422),('auctor',43,'node',1.83422),('auctor',44,'node',1.83422),('auctor',45,'node',1.83422),('auctor',46,'node',1.83422),('auctor',49,'node',1),('auctor',53,'node',1.26152),('auctor',54,'node',1.50015),('auctor',55,'node',0.645209),('auctor',57,'node',1.83742),('auctor',58,'node',1),('auctor',59,'node',1),('auctor',60,'node',1),('auctor',61,'node',2),('auctor',62,'node',1),('auctor',64,'node',1),('auctor',65,'node',2),('auctor',66,'node',2),('auctor',67,'node',1),('aug',5,'node',1.47824),('aug',30,'node',0.752312),('aug',31,'node',2.22081),('augue',2,'node',1),('augue',4,'node',1),('augue',5,'node',1),('augue',6,'node',1),('augue',7,'node',5.15055),('augue',8,'node',2.24171),('augue',9,'node',0.729424),('augue',10,'node',4.87634),('augue',11,'node',6),('augue',12,'node',1),('augue',13,'node',2),('augue',14,'node',3),('augue',15,'node',0.972861),('augue',27,'node',1),('augue',28,'node',1.75946),('augue',29,'node',1),('augue',30,'node',1.7185),('augue',31,'node',0.693594),('augue',33,'node',1),('augue',34,'node',1.72034),('augue',35,'node',4),('augue',37,'node',2.88012),('augue',38,'node',1.73923),('augue',39,'node',2.49095),('augue',42,'node',1.88314),('augue',43,'node',1.88314),('augue',44,'node',1.88314),('augue',45,'node',1.88314),('augue',46,'node',1.88314),('augue',47,'node',0.886095),('augue',48,'node',2),('augue',49,'node',1),('augue',50,'node',1),('augue',51,'node',1),('augue',53,'node',7.67956),('augue',54,'node',0.857458),('augue',55,'node',2.43472),('augue',56,'node',0.824901),('augue',57,'node',1.88314),('augue',58,'node',1),('augue',60,'node',1),('augue',61,'node',28),('augue',62,'node',1),('augue',63,'node',1),('augue',65,'node',1),('augue',66,'node',1),('austin',16,'node',1),('austin',68,'node',1),('aut',3,'node',1.86943),('aut',4,'node',1.60015),('aut',5,'node',1.60552),('aut',6,'node',1.60552),('aut',7,'node',1.89923),('aut',9,'node',1.89169),('aut',12,'node',1.58952),('aut',17,'node',1.86943),('aut',27,'node',1.58952),('aut',28,'node',1.61093),('aut',29,'node',1.58426),('aut',30,'node',1.58952),('aut',31,'node',1.77882),('aut',47,'node',1.86213),('aut',54,'node',1.85489),('aut',55,'node',1.8335),('aut',56,'node',1.92221),('aute',39,'node',2.21773),('aute',40,'node',1),('aute',41,'node',1),('autem',2,'node',2.86941),('autem',39,'node',2.99117),('automated',16,'node',2.27665),('automated',68,'node',1.78403),('autox',49,'node',26),('available',16,'node',1.07848),('available',19,'node',1.44089),('available',22,'node',1),('average',1,'node',1.97685),('average',7,'node',0.800068),('average',8,'node',0.677939),('average',9,'node',0.819249),('average',10,'node',0.980874),('average',11,'node',1),('average',15,'node',2.56366),('average',16,'node',1.07486),('average',17,'node',0.863659),('average',55,'node',0.78951),('avoid',19,'node',0.484898),('awesome',19,'node',0.566439),('back',19,'node',0.60322),('back',22,'node',0.78951),('backups',20,'node',1),('bash',19,'node',1.33283),('bashaliases',19,'node',0.553478),('bashprofile',19,'node',1.13505),('bashrc',19,'node',8.24544),('basic',23,'node',26),('bc',40,'node',1),('bc',41,'node',1),('be',1,'node',1.99315),('be',16,'node',6.58453),('be',18,'node',1),('be',19,'node',7.85799),('be',20,'node',1),('be',21,'node',1),('be',22,'node',1.87293),('be',31,'node',26),('be',68,'node',5.04509),('beatae',3,'node',4.73288),('beatae',4,'node',2.38911),('beatae',5,'node',2.3971),('beatae',6,'node',2.3971),('beatae',7,'node',4.79235),('beatae',8,'node',1.42641),('beatae',9,'node',4.7773),('beatae',12,'node',2.3733),('beatae',17,'node',4.73288),('beatae',27,'node',2.3733),('beatae',28,'node',2.40514),('beatae',29,'node',2.36548),('beatae',30,'node',2.3733),('beatae',31,'node',3.63787),('beatae',47,'node',4.71831),('beatae',54,'node',4.70385),('beatae',55,'node',4.66115),('beatae',56,'node',4.83673),('beautiful',10,'node',10.9246),('beautiful',35,'node',26),('beautiful',36,'node',26),('because',19,'node',0.504001),('been',16,'node',1),('been',20,'node',0.906287),('been',22,'node',1),('been',68,'node',1),('before',16,'node',1.44355),('before',20,'node',11),('before',21,'node',11),('before',22,'node',11),('before',68,'node',1.43482),('behaviour',20,'node',0.879565),('being',16,'node',0.520204),('being',21,'node',2),('belong',54,'node',26),('best',11,'node',26),('best',12,'node',26),('better',21,'node',0.949597),('better',22,'node',0.902857),('better',27,'node',26),('between',16,'node',1.99983),('between',68,'node',1.48635),('bibendum',3,'node',0.792123),('bibendum',4,'node',1),('bibendum',5,'node',1),('bibendum',6,'node',1),('bibendum',8,'node',1),('bibendum',10,'node',1),('bibendum',11,'node',2),('bibendum',12,'node',1),('bibendum',13,'node',1),('bibendum',27,'node',1),('bibendum',28,'node',1),('bibendum',29,'node',1),('bibendum',30,'node',1),('bibendum',31,'node',1),('bibendum',34,'node',2.60282),('bibendum',35,'node',1.96498),('bibendum',37,'node',1),('bibendum',38,'node',2.61909),('bibendum',39,'node',2),('bibendum',42,'node',4.73599),('bibendum',43,'node',4.73599),('bibendum',44,'node',4.73599),('bibendum',45,'node',4.73599),('bibendum',46,'node',4.73599),('bibendum',53,'node',0.61241),('bibendum',54,'node',0.863659),('bibendum',55,'node',0.866793),('bibendum',57,'node',4.73924),('bibendum',58,'node',1),('bibendum',61,'node',1),('big',1,'node',1),('big',69,'node',1),('bigtable',54,'node',26),('bin',19,'node',1.14496),('bit',19,'node',2.99536),('blandit',2,'node',1),('blandit',3,'node',1),('blandit',4,'node',1),('blandit',5,'node',1),('blandit',6,'node',1),('blandit',7,'node',1.65755),('blandit',8,'node',1.68764),('blandit',9,'node',2.66998),('blandit',10,'node',0.931053),('blandit',11,'node',4),('blandit',12,'node',21.6673),('blandit',13,'node',1),('blandit',15,'node',0.857458),('blandit',17,'node',1),('blandit',27,'node',1),('blandit',28,'node',1),('blandit',29,'node',1),('blandit',30,'node',1),('blandit',31,'node',1.73614),('blandit',34,'node',1),('blandit',35,'node',1),('blandit',36,'node',1),('blandit',38,'node',1),('blandit',39,'node',1.50065),('blandit',42,'node',1.8736),('blandit',43,'node',1.8736),('blandit',44,'node',1.8736),('blandit',45,'node',1.8736),('blandit',46,'node',1.8736),('blandit',47,'node',1),('blandit',51,'node',3),('blandit',52,'node',2),('blandit',53,'node',4.95195),('blandit',54,'node',1.74298),('blandit',55,'node',3.10068),('blandit',56,'node',1),('blandit',57,'node',1.87695),('blandit',58,'node',1),('blandit',59,'node',1),('blandit',61,'node',27),('blandit',62,'node',1),('blandit',63,'node',1),('blandit',64,'node',1),('blandit',65,'node',1),('blog',7,'node',11),('blog',8,'node',11),('blog',9,'node',11),('blog',10,'node',11),('blog',11,'node',11),('blog',48,'node',26),('body',30,'node',26),('books',11,'node',26),('both',16,'node',0.650439),('both',68,'node',0.646943),('bottom',24,'node',1),('branch',16,'node',0.498827),('branch',19,'node',1.52508),('branches',19,'node',1),('breathing',19,'node',0.752312),('breeze',35,'node',26),('bug',16,'node',3.12853),('bugs',1,'node',1),('builder',1,'node',1),('builder',69,'node',1),('builtin',16,'node',0.528135),('bunch',19,'node',0.857458),('but',1,'node',2),('but',16,'node',0.802752),('but',21,'node',0.957226),('but',22,'node',3),('but',68,'node',0.797402),('but',69,'node',2),('button',23,'node',40),('by',5,'node',1.48772),('by',7,'node',6.58352),('by',8,'node',2.57358),('by',9,'node',2.26037),('by',10,'node',0.953396),('by',11,'node',1.85488),('by',12,'node',0.76431),('by',16,'node',1.17882),('by',18,'node',1),('by',19,'node',9.01054),('by',20,'node',3.9347),('by',21,'node',0.993146),('by',22,'node',0.718502),('by',30,'node',0.759465),('by',31,'node',2.23095),('by',35,'node',26),('by',37,'node',0.854391),('by',68,'node',0.674137),('came',1,'node',1),('came',16,'node',1),('came',68,'node',1),('came',69,'node',1),('campaign',47,'node',26),('can',1,'node',1),('can',16,'node',1.00076),('can',19,'node',7.9776),('can',21,'node',1.85746),('can',69,'node',1),('canada',40,'node',1),('canada',41,'node',1),('cars',12,'node',8.48867),('case',19,'node',0.585658),('case',22,'node',0.913226),('cases',16,'node',0.488796),('cassandra',54,'node',26),('cck',16,'node',0.749958),('cck',68,'node',0.745294),('cd',19,'node',1.91062),('certain',16,'node',0.489781),('certain',20,'node',1),('change',19,'node',0.953396),('changelog',16,'node',0.511433),('changes',1,'node',1),('changes',16,'node',1.49157),('changes',19,'node',5.08183),('changes',20,'node',1),('changes',69,'node',1),('cheatsheet',19,'node',0.646943),('check',22,'node',1),('child',29,'node',26),('chmod',19,'node',0.697623),('choice',1,'node',1),('choice',19,'node',0.707906),('choose',22,'node',0.906287),('cillum',39,'node',2.20847),('cillum',40,'node',1),('cillum',41,'node',1),('class',7,'node',0.601716),('class',8,'node',1),('class',10,'node',0.916736),('class',11,'node',2),('class',14,'node',1),('class',23,'node',6),('class',24,'node',1),('class',34,'node',1),('class',38,'node',1),('class',53,'node',0.648686),('class',54,'node',0.731649),('clean',21,'node',33.8803),('clear',19,'node',1.52377),('clients',16,'node',0.61241),('clients',68,'node',0.609315),('clita',2,'node',7.73881),('clita',39,'node',6.37794),('cluster',22,'node',0.866793),('code',1,'node',1),('code',16,'node',0.679856),('code',19,'node',0.496787),('code',22,'node',1.4913),('code',68,'node',0.676032),('code',69,'node',1),('coding',1,'node',26),('coding',69,'node',26),('collapse',26,'node',28),('color',42,'node',26),('column',54,'node',52),('columnsalias',19,'node',0.580033),('come',1,'node',0.980874),('comes',16,'node',1.45706),('comes',68,'node',1.44812),('coming',16,'node',1),('coming',68,'node',1),('command',19,'node',17.6432),('commands',19,'node',4.67045),('comment',40,'node',1),('comment',41,'node',1),('comments',1,'node',1.77854),('comments',3,'node',0.736141),('comments',5,'node',1.45477),('comments',7,'node',6.39111),('comments',8,'node',2.53844),('comments',9,'node',2.17841),('comments',10,'node',0.810915),('comments',11,'node',1.71601),('comments',12,'node',0.733888),('comments',16,'node',0.47729),('comments',19,'node',22.4318),('comments',30,'node',0.729424),('comments',31,'node',2.19562),('comments',37,'node',0.800068),('comments',47,'node',0.707906),('comments',53,'node',6.68042),('comments',54,'node',0.693594),('comments',55,'node',1.30367),('comments',56,'node',0.776703),('commit',16,'node',0.496787),('commodi',2,'node',0.916736),('commodo',2,'node',1.91323),('commodo',4,'node',2.98633),('commodo',5,'node',2.99315),('commodo',6,'node',2.99315),('commodo',7,'node',0.693594),('commodo',8,'node',5.95349),('commodo',9,'node',0.727213),('commodo',12,'node',2.96989),('commodo',15,'node',0.757065),('commodo',27,'node',2.96989),('commodo',28,'node',2.99731),('commodo',29,'node',3.72366),('commodo',30,'node',2.96989),('commodo',31,'node',1),('commodo',33,'node',2),('commodo',34,'node',6.18201),('commodo',36,'node',1),('commodo',37,'node',1.72435),('commodo',38,'node',6.23895),('commodo',39,'node',3.81893),('commodo',47,'node',1.47234),('commodo',48,'node',1),('commodo',49,'node',1),('commodo',50,'node',1),('commodo',53,'node',3.59116),('commodo',55,'node',1.39342),('commodo',58,'node',2),('commodo',60,'node',1),('commodo',61,'node',1),('commodo',62,'node',2),('commodo',67,'node',1),('commonly',21,'node',2),('community',2,'node',26),('community',15,'node',1),('community',16,'node',5.4573),('community',20,'node',1),('community',21,'node',2),('community',68,'node',5.43706),('companies',16,'node',2.13308),('companies',18,'node',1),('companies',20,'node',1),('companies',68,'node',2.12051),('comparable',21,'node',0.972861),('compatible',19,'node',0.587082),('compatible',21,'node',0.934703),('complete',16,'node',0.499853),('composer',19,'node',8),('compromise',16,'node',0.640063),('compromise',68,'node',0.636679),('concurrency',21,'node',1),('condimentum',4,'node',2),('condimentum',5,'node',3.42877),('condimentum',6,'node',2),('condimentum',7,'node',3.80588),('condimentum',8,'node',3.97171),('condimentum',12,'node',2),('condimentum',13,'node',2),('condimentum',14,'node',2),('condimentum',15,'node',0.873132),('condimentum',26,'node',2),('condimentum',27,'node',2),('condimentum',28,'node',2),('condimentum',29,'node',2),('condimentum',30,'node',2),('condimentum',31,'node',3.57194),('condimentum',33,'node',1),('condimentum',34,'node',2),('condimentum',35,'node',1),('condimentum',37,'node',1.81959),('condimentum',38,'node',2),('condimentum',42,'node',1.7963),('condimentum',43,'node',1.7963),('condimentum',44,'node',1.7963),('condimentum',45,'node',1.7963),('condimentum',46,'node',1.7963),('condimentum',47,'node',2.43765),('condimentum',48,'node',1),('condimentum',49,'node',2),('condimentum',50,'node',2),('condimentum',51,'node',1),('condimentum',52,'node',1),('condimentum',53,'node',2.71149),('condimentum',55,'node',1.59062),('condimentum',56,'node',0.816452),('condimentum',57,'node',1.79955),('condimentum',58,'node',2),('condimentum',61,'node',1),('condimentum',62,'node',1),('condimentum',63,'node',29),('condimentum',64,'node',1),('condimentum',66,'node',1),('condimentum',67,'node',27),('conditions',21,'node',10.572),('config',19,'node',7.13),('configuration',19,'node',1.2656),('configuration',21,'node',1),('configured',19,'node',0.53161),('configured',21,'node',0.882818),('confirm',19,'node',1.51142),('congue',3,'node',1),('congue',4,'node',2),('congue',5,'node',3.46554),('congue',6,'node',2),('congue',7,'node',1.7017),('congue',8,'node',2),('congue',9,'node',1.84832),('congue',12,'node',2),('congue',14,'node',26),('congue',17,'node',1),('congue',27,'node',2),('congue',28,'node',2),('congue',29,'node',2),('congue',30,'node',2),('congue',31,'node',3.56536),('congue',33,'node',1),('congue',34,'node',2.7974),('congue',35,'node',2.91838),('congue',37,'node',0.938382),('congue',38,'node',2.80545),('congue',39,'node',2.69887),('congue',42,'node',1.75923),('congue',43,'node',1.75923),('congue',44,'node',1.75923),('congue',45,'node',1.75923),('congue',46,'node',1.75923),('congue',47,'node',0.997306),('congue',48,'node',0.976851),('congue',49,'node',1),('congue',50,'node',1),('congue',53,'node',1.2767),('congue',54,'node',0.993146),('congue',55,'node',0.980874),('congue',56,'node',1),('congue',57,'node',1.76573),('congue',62,'node',1),('congue',66,'node',1),('consectetuer',2,'node',1.90361),('consectetuer',7,'node',3.21673),('consectetuer',8,'node',1.33503),('consectetuer',11,'node',2),('consectetuer',15,'node',2.75867),('consectetuer',31,'node',0.842342),('consectetuer',36,'node',1),('consectetuer',37,'node',1),('consectetuer',39,'node',1),('consectetuer',48,'node',1),('consectetuer',53,'node',2.11405),('consectetuer',58,'node',1),('consectetuer',59,'node',1),('consectetuer',60,'node',27),('consectetuer',61,'node',2),('consectetuer',65,'node',1),('consectetur',2,'node',1),('consectetur',3,'node',2.91674),('consectetur',4,'node',0.792123),('consectetur',5,'node',0.794753),('consectetur',6,'node',0.794753),('consectetur',7,'node',2.93105),('consectetur',8,'node',1.85439),('consectetur',9,'node',2.92743),('consectetur',12,'node',0.786915),('consectetur',17,'node',2.91674),('consectetur',27,'node',0.786915),('consectetur',28,'node',0.797402),('consectetur',29,'node',0.784336),('consectetur',30,'node',0.786915),('consectetur',31,'node',0.879565),('consectetur',33,'node',2),('consectetur',34,'node',1.86679),('consectetur',35,'node',1),('consectetur',38,'node',1.87634),('consectetur',39,'node',2),('consectetur',42,'node',4.65817),('consectetur',43,'node',4.65817),('consectetur',44,'node',4.65817),('consectetur',45,'node',4.65817),('consectetur',46,'node',4.65817),('consectetur',47,'node',2.91323),('consectetur',53,'node',0.655756),('consectetur',54,'node',2.90974),('consectetur',55,'node',2.89945),('consectetur',56,'node',2.94209),('consectetur',57,'node',4.66482),('consectetur',67,'node',2),('consequat',2,'node',5.69586),('consequat',4,'node',3),('consequat',5,'node',3),('consequat',6,'node',3),('consequat',7,'node',1.31879),('consequat',8,'node',4.82206),('consequat',10,'node',2),('consequat',11,'node',2),('consequat',12,'node',3),('consequat',13,'node',1),('consequat',14,'node',1),('consequat',27,'node',3),('consequat',28,'node',3),('consequat',29,'node',3),('consequat',30,'node',3),('consequat',31,'node',3),('consequat',33,'node',1),('consequat',34,'node',4.83353),('consequat',35,'node',1.97286),('consequat',37,'node',1),('consequat',38,'node',4.84234),('consequat',39,'node',7.79444),('consequat',42,'node',4.71352),('consequat',43,'node',4.71352),('consequat',44,'node',4.71352),('consequat',45,'node',4.71352),('consequat',46,'node',4.71352),('consequat',53,'node',0.610858),('consequat',54,'node',0.869951),('consequat',55,'node',0.873132),('consequat',57,'node',4.72018),('consequat',61,'node',0.980874),('consetetur',2,'node',1),('consetetur',39,'node',3.94831),('consider',19,'node',0.542319),('consider',20,'node',1),('consult',16,'node',0.544759),('cont',53,'node',0.913226),('contact',40,'node',26),('contact',41,'node',26),('contain',21,'node',1),('contains',16,'node',0.510357),('continue',16,'node',0.716357),('continue',68,'node',0.712106),('continuing',16,'node',0.989021),('continuing',68,'node',0.98493),('contributed',16,'node',1.55597),('contributed',20,'node',1),('contributed',22,'node',3.97105),('contributed',68,'node',1.54592),('contribution',15,'node',1),('control',22,'node',0.842342),('conubia',7,'node',0.58995),('conubia',8,'node',1),('conubia',10,'node',0.889397),('conubia',11,'node',2),('conubia',14,'node',1),('conubia',34,'node',1),('conubia',38,'node',1),('conubia',53,'node',0.635),('conubia',54,'node',0.714225),('convallis',3,'node',2),('convallis',4,'node',2),('convallis',5,'node',2),('convallis',6,'node',2),('convallis',7,'node',5.19346),('convallis',8,'node',2.51969),('convallis',9,'node',2),('convallis',10,'node',1.85439),('convallis',11,'node',4),('convallis',12,'node',2),('convallis',13,'node',1),('convallis',17,'node',2),('convallis',27,'node',2),('convallis',28,'node',2),('convallis',29,'node',2),('convallis',30,'node',2.7185),('convallis',31,'node',2.6916),('convallis',33,'node',1),('convallis',34,'node',1.83353),('convallis',35,'node',1.96498),('convallis',36,'node',1),('convallis',38,'node',1.84234),('convallis',39,'node',2),('convallis',42,'node',2.69585),('convallis',43,'node',2.69585),('convallis',44,'node',2.69585),('convallis',45,'node',2.69585),('convallis',46,'node',2.69585),('convallis',47,'node',2),('convallis',53,'node',1),('convallis',54,'node',2),('convallis',55,'node',2),('convallis',56,'node',2),('convallis',57,'node',2.69908),('convallis',61,'node',1),('convallis',62,'node',2),('convallis',67,'node',2),('coordinate',16,'node',0.699655),('coordinate',68,'node',0.695602),('copy',19,'node',0.472657),('core',16,'node',6.35926),('core',20,'node',12),('core',21,'node',0.892724),('core',22,'node',2),('core',68,'node',5.82115),('correct',19,'node',0.693594),('correctly',21,'node',0.879565),('costs',29,'node',26),('course',19,'node',0.456713),('coverage',16,'node',0.949597),('coverage',68,'node',0.945829),('cpanel',19,'node',2.3682),('cpanel',22,'node',0.833529),('cras',1,'node',0.879565),('cras',3,'node',1),('cras',4,'node',1),('cras',5,'node',1),('cras',6,'node',1),('cras',7,'node',1.6956),('cras',8,'node',18.0167),('cras',9,'node',1),('cras',10,'node',1),('cras',11,'node',2),('cras',12,'node',1),('cras',13,'node',1),('cras',17,'node',1),('cras',27,'node',1),('cras',28,'node',1),('cras',29,'node',1),('cras',30,'node',1),('cras',31,'node',0.824901),('cras',34,'node',1.7503),('cras',35,'node',0.976851),('cras',36,'node',1),('cras',37,'node',2),('cras',38,'node',1.76985),('cras',42,'node',1),('cras',43,'node',1),('cras',44,'node',1),('cras',45,'node',1),('cras',46,'node',1),('cras',47,'node',1),('cras',48,'node',2),('cras',49,'node',1),('cras',50,'node',1),('cras',52,'node',1),('cras',53,'node',5.5906),('cras',54,'node',1.74298),('cras',55,'node',1.71),('cras',56,'node',1),('cras',57,'node',1),('cras',61,'node',0.993146),('cras',62,'node',1),('cras',63,'node',1),('cras',64,'node',2),('cras',65,'node',1),('cras',66,'node',3),('cras',67,'node',1),('create',19,'node',0.497805),('create',22,'node',2.78642),('created',16,'node',1.67794),('created',68,'node',1.67414),('creating',19,'node',0.541108),('credentials',19,'node',0.539902),('crit',1,'node',1),('critical',16,'node',0.76188),('critical',68,'node',0.757065),('cron',16,'node',0.482973),('css3',27,'node',8.48867),('ctrl',19,'node',0.630018),('cubilia',3,'node',0.769219),('cubilia',7,'node',0.661163),('cubilia',28,'node',0.769219),('cubilia',31,'node',0.714225),('cubilia',37,'node',0.953396),('cubilia',48,'node',0.993146),('cubilia',49,'node',1),('cubilia',53,'node',1.23266),('cubilia',62,'node',1),('culpa',2,'node',1),('culpa',3,'node',3.76002),('culpa',4,'node',2.48953),('culpa',5,'node',2.49827),('culpa',6,'node',2.49827),('culpa',7,'node',3.80333),('culpa',8,'node',1.49742),('culpa',9,'node',3.79237),('culpa',12,'node',2.47224),('culpa',17,'node',3.76002),('culpa',27,'node',2.47224),('culpa',28,'node',2.50707),('culpa',29,'node',2.46368),('culpa',30,'node',2.47224),('culpa',31,'node',2.67317),('culpa',39,'node',2.27595),('culpa',40,'node',1),('culpa',41,'node',1),('culpa',47,'node',3.7494),('culpa',54,'node',3.73887),('culpa',55,'node',3.70775),('culpa',56,'node',3.83673),('cum',7,'node',0.643484),('cum',10,'node',1),('cum',39,'node',1.71476),('cum',53,'node',0.794753),('cum',65,'node',1),('cum',66,'node',1),('cupidatat',3,'node',3.76002),('cupidatat',4,'node',2.50057),('cupidatat',5,'node',2.5094),('cupidatat',6,'node',2.5094),('cupidatat',7,'node',3.80333),('cupidatat',8,'node',1.50531),('cupidatat',9,'node',3.79237),('cupidatat',12,'node',2.4831),('cupidatat',17,'node',3.76002),('cupidatat',27,'node',2.4831),('cupidatat',28,'node',2.51829),('cupidatat',29,'node',2.47446),('cupidatat',30,'node',2.4831),('cupidatat',31,'node',2.68457),('cupidatat',40,'node',1),('cupidatat',41,'node',1),('cupidatat',47,'node',3.7494),('cupidatat',54,'node',3.73887),('cupidatat',55,'node',3.70775),('cupidatat',56,'node',3.83673),('cupiditat',2,'node',1),('cupiditat',39,'node',2.28423),('curabitur',3,'node',0.808176),('curabitur',4,'node',5),('curabitur',5,'node',5),('curabitur',6,'node',5),('curabitur',7,'node',22.0156),('curabitur',8,'node',18.67),('curabitur',9,'node',41.2291),('curabitur',11,'node',23.6515),('curabitur',12,'node',5),('curabitur',13,'node',1),('curabitur',15,'node',0.931053),('curabitur',26,'node',2),('curabitur',27,'node',5),('curabitur',28,'node',5),('curabitur',29,'node',5),('curabitur',30,'node',5),('curabitur',31,'node',4),('curabitur',33,'node',1),('curabitur',34,'node',0.953396),('curabitur',35,'node',1),('curabitur',37,'node',24.2008),('curabitur',38,'node',0.96498),('curabitur',39,'node',2),('curabitur',42,'node',1.86948),('curabitur',43,'node',1.86948),('curabitur',44,'node',1.86948),('curabitur',45,'node',1.86948),('curabitur',46,'node',1.86948),('curabitur',48,'node',1),('curabitur',50,'node',2),('curabitur',51,'node',1),('curabitur',52,'node',3),('curabitur',53,'node',3.71416),('curabitur',55,'node',1.55203),('curabitur',57,'node',1.87271),('curabitur',58,'node',1),('curabitur',59,'node',2),('curabitur',62,'node',3),('curabitur',64,'node',2),('curabitur',66,'node',29),('curae',3,'node',0.766757),('curae',7,'node',0.659351),('curae',28,'node',0.766757),('curae',31,'node',0.712106),('curae',37,'node',0.949597),('curae',48,'node',0.989021),('curae',49,'node',1),('curae',53,'node',1.23108),('curae',62,'node',1),('current',16,'node',1),('current',19,'node',0.866793),('current',68,'node',1),('currently',19,'node',0.725015),('cursus',3,'node',2),('cursus',4,'node',1),('cursus',5,'node',1.71636),('cursus',6,'node',1),('cursus',7,'node',2),('cursus',8,'node',1.58853),('cursus',9,'node',2),('cursus',10,'node',1),('cursus',12,'node',1),('cursus',13,'node',1),('cursus',15,'node',0.771698),('cursus',17,'node',2),('cursus',27,'node',1),('cursus',28,'node',1),('cursus',29,'node',1),('cursus',30,'node',1),('cursus',31,'node',0.745294),('cursus',33,'node',1),('cursus',34,'node',3.31966),('cursus',37,'node',1),('cursus',38,'node',3.35474),('cursus',39,'node',1),('cursus',42,'node',5.4274),('cursus',43,'node',5.4274),('cursus',44,'node',5.4274),('cursus',45,'node',5.4274),('cursus',46,'node',5.4274),('cursus',47,'node',2),('cursus',49,'node',1),('cursus',51,'node',2),('cursus',53,'node',2.29035),('cursus',54,'node',2.85439),('cursus',55,'node',3.57149),('cursus',56,'node',2.80007),('cursus',57,'node',5.44388),('cursus',59,'node',3),('cursus',60,'node',1),('cursus',61,'node',27),('cursus',62,'node',1),('cursus',65,'node',1),('cursus',67,'node',1),('customers',16,'node',0.66666),('customers',68,'node',0.662985),('cycle',16,'node',0.512513),('d7',1,'node',28.9931),('d7',69,'node',27),('d8',1,'node',30),('d8',16,'node',0.609315),('d8',68,'node',0.606252),('d8',69,'node',28),('dapibus',1,'node',0.876337),('dapibus',7,'node',3.16556),('dapibus',8,'node',1.68869),('dapibus',11,'node',2),('dapibus',15,'node',0.76431),('dapibus',26,'node',2),('dapibus',28,'node',0.76188),('dapibus',33,'node',1),('dapibus',34,'node',1.81367),('dapibus',35,'node',0.98493),('dapibus',36,'node',1),('dapibus',37,'node',1),('dapibus',38,'node',1.82206),('dapibus',42,'node',1.92027),('dapibus',43,'node',1.92027),('dapibus',44,'node',1.92027),('dapibus',45,'node',1.92027),('dapibus',46,'node',1.92027),('dapibus',49,'node',4),('dapibus',50,'node',1),('dapibus',51,'node',1),('dapibus',52,'node',1),('dapibus',53,'node',2.23444),('dapibus',55,'node',0.716357),('dapibus',57,'node',1.92027),('dapibus',58,'node',2),('dapibus',60,'node',1),('dapibus',61,'node',2),('dapibus',66,'node',1),('dapibus',67,'node',28),('dark',46,'node',26),('data',16,'node',0.757065),('data',68,'node',0.752312),('database',20,'node',30.2416),('database',22,'node',42.1719),('database',54,'node',26),('databases',54,'node',26),('day',3,'node',0.833529),('day',15,'node',1.8249),('day',53,'node',4.82702),('day',54,'node',0.784336),('day',55,'node',0.672252),('days',7,'node',26),('ddd',19,'node',5.03587),('dddl',19,'node',6.34666),('deadline',19,'node',0.50505),('decided',20,'node',1),('decorating',4,'node',26),('decorating',28,'node',26),('default',19,'node',0.989021),('default',22,'node',0.927431),('default',43,'node',26),('delenit',2,'node',1),('delenit',39,'node',1.49335),('delete',22,'node',1),('demoweebpalcom',69,'node',11),('depending',19,'node',0.552215),('deployment',21,'node',1),('deserunt',2,'node',1),('deserunt',3,'node',3.76002),('deserunt',4,'node',2.47875),('deserunt',5,'node',2.48741),('deserunt',6,'node',2.48741),('deserunt',7,'node',3.80333),('deserunt',8,'node',1.48968),('deserunt',9,'node',3.79237),('deserunt',12,'node',2.46163),('deserunt',17,'node',3.76002),('deserunt',27,'node',2.46163),('deserunt',28,'node',2.49612),('deserunt',29,'node',2.45315),('deserunt',30,'node',2.46163),('deserunt',31,'node',2.66204),('deserunt',39,'node',2.26784),('deserunt',40,'node',1),('deserunt',41,'node',1),('deserunt',47,'node',3.7494),('deserunt',54,'node',3.73887),('deserunt',55,'node',3.70775),('deserunt',56,'node',3.83673),('design',15,'node',1),('design',29,'node',8.32772),('design',30,'node',8.48867),('desired',1,'node',0.993146),('detailed',19,'node',5.89947),('details',15,'node',1),('details',16,'node',0.494765),('details',20,'node',30.7763),('details',53,'node',0.997306),('dev',1,'node',2),('dev',69,'node',2),('developer',1,'node',1),('developer',19,'node',1.96308),('developer',69,'node',1),('developers',20,'node',1),('developing',16,'node',0.714225),('developing',68,'node',0.71),('development',1,'node',8.17469),('development',5,'node',2.78241),('development',7,'node',10.1893),('development',8,'node',7.65511),('development',9,'node',5.72233),('development',10,'node',3.31103),('development',11,'node',3.59781),('development',12,'node',2.87401),('development',15,'node',1),('development',16,'node',2.80327),('development',21,'node',1),('development',31,'node',11.7572),('development',37,'node',3.26581),('development',47,'node',2.89132),('development',53,'node',8.03705),('development',55,'node',2.77437),('development',56,'node',3.17901),('development',68,'node',0.876337),('development',69,'node',1),('diam',2,'node',3.86596),('diam',3,'node',1),('diam',5,'node',0.725015),('diam',7,'node',1),('diam',8,'node',1.5107),('diam',9,'node',1),('diam',10,'node',2),('diam',11,'node',6),('diam',13,'node',1),('diam',14,'node',1),('diam',15,'node',0.869951),('diam',17,'node',1),('diam',31,'node',0.727213),('diam',33,'node',1),('diam',34,'node',0.863659),('diam',36,'node',1),('diam',38,'node',0.873132),('diam',39,'node',9.26687),('diam',42,'node',4.52508),('diam',43,'node',4.52508),('diam',44,'node',4.52508),('diam',45,'node',4.52508),('diam',46,'node',4.52508),('diam',47,'node',1.72942),('diam',48,'node',1),('diam',50,'node',1),('diam',51,'node',2),('diam',52,'node',1),('diam',53,'node',4.03517),('diam',54,'node',1),('diam',55,'node',1),('diam',56,'node',1),('diam',57,'node',4.53815),('diam',59,'node',1),('diam',62,'node',1),('diam',63,'node',1),('diam',66,'node',1),('diam',67,'node',1),('dicta',3,'node',4.73288),('dicta',4,'node',2.38338),('dicta',5,'node',2.39132),('dicta',6,'node',2.39132),('dicta',7,'node',4.79235),('dicta',8,'node',1.42426),('dicta',9,'node',4.7773),('dicta',12,'node',2.36765),('dicta',17,'node',4.73288),('dicta',27,'node',2.36765),('dicta',28,'node',2.39932),('dicta',29,'node',2.35986),('dicta',30,'node',2.36765),('dicta',31,'node',3.62959),('dicta',47,'node',4.71831),('dicta',54,'node',4.70385),('dicta',55,'node',4.66115),('dicta',56,'node',4.83673),('dictum',3,'node',0.76188),('dictum',4,'node',1.98902),('dictum',5,'node',1.99315),('dictum',6,'node',1.99315),('dictum',7,'node',0.645209),('dictum',8,'node',2.54875),('dictum',9,'node',0.886095),('dictum',12,'node',1.98087),('dictum',14,'node',3),('dictum',15,'node',1),('dictum',27,'node',1.98087),('dictum',28,'node',1.99731),('dictum',29,'node',1.97685),('dictum',30,'node',1.98087),('dictum',31,'node',1),('dictum',33,'node',2),('dictum',34,'node',1.90286),('dictum',37,'node',1),('dictum',38,'node',1.91323),('dictum',39,'node',1),('dictum',42,'node',3.82916),('dictum',43,'node',3.82916),('dictum',44,'node',3.82916),('dictum',45,'node',3.82916),('dictum',46,'node',3.82916),('dictum',47,'node',1.7102),('dictum',50,'node',1),('dictum',53,'node',0.668514),('dictum',55,'node',0.659351),('dictum',57,'node',3.83242),('dictum',62,'node',1),('dictum',63,'node',27),('dictum',67,'node',1),('dictumst',9,'node',0.733888),('dictumst',15,'node',0.779231),('dictumst',26,'node',4),('dictumst',36,'node',1),('dictumst',47,'node',0.745294),('dictumst',54,'node',0.876337),('dictumst',59,'node',1),('dictumst',66,'node',1),('didn',19,'node',0.524706),('difficult',16,'node',0.980874),('difficult',68,'node',0.976851),('dignissim',2,'node',1),('dignissim',3,'node',0.76431),('dignissim',4,'node',1),('dignissim',5,'node',1),('dignissim',6,'node',1),('dignissim',8,'node',3.53685),('dignissim',12,'node',0.993146),('dignissim',15,'node',1.83645),('dignissim',27,'node',0.993146),('dignissim',28,'node',1),('dignissim',29,'node',0.989021),('dignissim',30,'node',0.993146),('dignissim',33,'node',1),('dignissim',34,'node',3.57335),('dignissim',35,'node',1),('dignissim',38,'node',3.60142),('dignissim',39,'node',1.50311),('dignissim',42,'node',1),('dignissim',43,'node',1),('dignissim',44,'node',1),('dignissim',45,'node',1),('dignissim',46,'node',1),('dignissim',49,'node',1),('dignissim',51,'node',1),('dignissim',52,'node',1),('dignissim',53,'node',4.09191),('dignissim',57,'node',1),('dignissim',62,'node',1),('direction',36,'node',26),('directive',21,'node',1),('directory',19,'node',10.5195),('dis',7,'node',0.635),('dis',10,'node',1),('dis',53,'node',0.781775),('dis',65,'node',1),('dis',66,'node',1),('discuss',16,'node',1),('discuss',68,'node',1),('discussing',20,'node',1),('discussion',1,'node',11),('discussion',15,'node',11),('discussion',16,'node',12),('discussion',53,'node',11),('discussion',54,'node',11),('discussion',55,'node',11),('discussion',68,'node',1),('discussions',22,'node',0.714225),('disk',20,'node',19),('display',3,'node',26),('dl',19,'node',3.16148),('do',5,'node',26),('do',15,'node',26),('do',16,'node',2.67493),('do',19,'node',2.39597),('do',22,'node',0.827757),('do',68,'node',2.66696),('documentation',19,'node',4.86896),('documentation',22,'node',0.786915),('does',15,'node',26),('does',19,'node',4.72942),('does',54,'node',26),('doesn',19,'node',0.609315),('dolor',2,'node',16.3598),('dolor',3,'node',1.92027),('dolor',4,'node',2.79212),('dolor',5,'node',3.49645),('dolor',6,'node',2.79475),('dolor',7,'node',3.28367),('dolor',8,'node',3.29268),('dolor',9,'node',2.65607),('dolor',10,'node',3),('dolor',11,'node',2),('dolor',12,'node',2.78691),('dolor',14,'node',2),('dolor',15,'node',3.38481),('dolor',17,'node',1.92027),('dolor',26,'node',2),('dolor',27,'node',2.78691),('dolor',28,'node',2.7974),('dolor',29,'node',3.54622),('dolor',30,'node',2.78691),('dolor',31,'node',4.31053),('dolor',33,'node',1),('dolor',34,'node',2),('dolor',35,'node',1),('dolor',36,'node',2),('dolor',37,'node',3.69965),('dolor',38,'node',2),('dolor',39,'node',13.5522),('dolor',40,'node',1),('dolor',41,'node',1),('dolor',42,'node',6.72829),('dolor',43,'node',6.72829),('dolor',44,'node',6.72829),('dolor',45,'node',6.72829),('dolor',46,'node',6.72829),('dolor',47,'node',1.91674),('dolor',48,'node',1.96109),('dolor',49,'node',3),('dolor',50,'node',1),('dolor',51,'node',2),('dolor',52,'node',1),('dolor',53,'node',5.28324),('dolor',54,'node',1.91323),('dolor',55,'node',4.81777),('dolor',56,'node',1.94583),('dolor',57,'node',6.735),('dolor',58,'node',2),('dolor',59,'node',3),('dolor',60,'node',27),('dolor',61,'node',2),('dolor',62,'node',3),('dolor',64,'node',1),('dolor',65,'node',2),('dolor',66,'node',1),('dolor',67,'node',2),('dolore',2,'node',7.72707),('dolore',39,'node',11.5962),('dolore',40,'node',1),('dolore',41,'node',1),('dolorem',3,'node',0.927431),('dolorem',4,'node',0.794753),('dolorem',5,'node',0.797402),('dolorem',6,'node',0.797402),('dolorem',7,'node',0.942091),('dolorem',9,'node',0.938382),('dolorem',12,'node',0.78951),('dolorem',17,'node',0.927431),('dolorem',27,'node',0.78951),('dolorem',28,'node',0.800068),('dolorem',29,'node',0.786915),('dolorem',30,'node',0.78951),('dolorem',31,'node',0.882818),('dolorem',47,'node',0.923838),('dolorem',54,'node',0.920273),('dolorem',55,'node',0.909743),('dolorem',56,'node',0.953396),('doloremque',3,'node',4.73288),('doloremque',4,'node',2.43161),('doloremque',5,'node',2.4399),('doloremque',6,'node',2.4399),('doloremque',7,'node',4.79235),('doloremque',8,'node',1.45786),('doloremque',9,'node',4.7773),('doloremque',12,'node',2.41519),('doloremque',17,'node',4.73288),('doloremque',27,'node',2.41519),('doloremque',28,'node',2.44825),('doloremque',29,'node',2.40707),('doloremque',30,'node',2.41519),('doloremque',31,'node',3.64057),('doloremque',40,'node',1),('doloremque',41,'node',1),('doloremque',47,'node',4.71831),('doloremque',54,'node',4.70385),('doloremque',55,'node',4.66115),('doloremque',56,'node',4.83673),('dolores',2,'node',2.86941),('dolores',39,'node',6.32426),('doming',39,'node',1.69498),('don',19,'node',2.4745),('done',21,'node',1),('donec',1,'node',2.74681),('donec',4,'node',2),('donec',5,'node',2.7017),('donec',6,'node',2),('donec',7,'node',2.52924),('donec',8,'node',2.63221),('donec',10,'node',4),('donec',11,'node',6),('donec',12,'node',2),('donec',13,'node',1),('donec',15,'node',5.30156),('donec',27,'node',2),('donec',28,'node',2.76431),('donec',29,'node',2),('donec',30,'node',2.71211),('donec',31,'node',2.41904),('donec',33,'node',1),('donec',34,'node',2.78377),('donec',36,'node',3),('donec',37,'node',1.89608),('donec',38,'node',2.80275),('donec',39,'node',3),('donec',42,'node',3.78385),('donec',43,'node',3.78385),('donec',44,'node',3.78385),('donec',45,'node',3.78385),('donec',46,'node',3.78385),('donec',48,'node',1),('donec',50,'node',2),('donec',51,'node',2),('donec',52,'node',1),('donec',53,'node',7.16706),('donec',55,'node',1.39776),('donec',57,'node',3.7871),('donec',58,'node',28),('donec',59,'node',2),('donec',61,'node',1),('donec',62,'node',2),('donec',63,'node',1),('donec',64,'node',3),('donec',65,'node',1),('donec',66,'node',1),('donec',67,'node',3),('down',16,'node',0.613969),('down',68,'node',0.610858),('download',16,'node',1.11851),('download',19,'node',2.33425),('drawing',11,'node',26),('driver',22,'node',0.816452),('drop',22,'node',1),('dropcap',23,'node',30),('dropin',22,'node',2),('dropped',20,'node',0.902857),('drupal',1,'node',9.2057),('drupal',4,'node',8.51611),('drupal',5,'node',2.79862),('drupal',6,'node',26),('drupal',7,'node',10.2118),('drupal',8,'node',7.67638),('drupal',9,'node',5.74823),('drupal',10,'node',3.34579),('drupal',11,'node',3.63897),('drupal',12,'node',2.90006),('drupal',16,'node',45.2517),('drupal',17,'node',11),('drupal',18,'node',2),('drupal',19,'node',11),('drupal',20,'node',20.6546),('drupal',21,'node',10.5853),('drupal',22,'node',15.4508),('drupal',28,'node',8.30149),('drupal',31,'node',11.7351),('drupal',37,'node',3.2996),('drupal',47,'node',2.9177),('drupal',53,'node',8.06188),('drupal',55,'node',2.79862),('drupal',56,'node',40.2003),('drupal',68,'node',36.6762),('drupal',69,'node',2),('drupalcon',16,'node',1),('drupalcon',68,'node',1),('drupalorg',16,'node',11),('drupalorg',18,'node',1),('drupalorg',19,'node',0.784336),('drupalorg',68,'node',11),('drush',19,'node',89.6682),('drush6x',19,'node',0.703756),('drushops',19,'node',8.76481),('drushphp',19,'node',0.571798),('dui',3,'node',1),('dui',5,'node',1.4117),('dui',7,'node',5.48162),('dui',8,'node',1.55916),('dui',9,'node',1.89608),('dui',10,'node',0.927431),('dui',11,'node',4),('dui',13,'node',2),('dui',15,'node',3.18577),('dui',17,'node',1),('dui',26,'node',2),('dui',29,'node',0.766757),('dui',31,'node',0.725015),('dui',33,'node',4),('dui',34,'node',1.67002),('dui',35,'node',2),('dui',37,'node',1),('dui',38,'node',1.68774),('dui',39,'node',2),('dui',42,'node',2.79558),('dui',43,'node',2.79558),('dui',44,'node',2.79558),('dui',45,'node',2.79558),('dui',46,'node',2.79558),('dui',47,'node',1),('dui',48,'node',2),('dui',51,'node',2),('dui',52,'node',1),('dui',53,'node',3.08198),('dui',54,'node',1),('dui',55,'node',1.65576),('dui',56,'node',1),('dui',57,'node',2.79893),('dui',58,'node',1),('dui',61,'node',1),('dui',63,'node',3),('dui',64,'node',2),('dui',65,'node',2),('dui',66,'node',4),('dui',67,'node',3),('duis',2,'node',3.86941),('duis',3,'node',1),('duis',4,'node',1),('duis',5,'node',1),('duis',6,'node',1),('duis',7,'node',1.61241),('duis',8,'node',1.92743),('duis',9,'node',1),('duis',10,'node',0.845322),('duis',12,'node',1),('duis',14,'node',1),('duis',15,'node',0.949597),('duis',17,'node',1),('duis',27,'node',1),('duis',28,'node',1.7717),('duis',29,'node',1),('duis',30,'node',1),('duis',34,'node',1.94209),('duis',36,'node',2),('duis',38,'node',1.9534),('duis',39,'node',5.48213),('duis',40,'node',1),('duis',41,'node',1),('duis',42,'node',2.66531),('duis',43,'node',2.66531),('duis',44,'node',2.66531),('duis',45,'node',2.66531),('duis',46,'node',2.66531),('duis',47,'node',1),('duis',48,'node',1),('duis',53,'node',2.8098),('duis',54,'node',1.76188),('duis',55,'node',1.64694),('duis',56,'node',1),('duis',57,'node',2.67527),('duis',60,'node',1),('duis',61,'node',1),('duis',67,'node',2),('duo',2,'node',2.86941),('duo',39,'node',6.32786),('ea',2,'node',5.69937),('ea',39,'node',10.1396),('each',20,'node',1),('eaque',3,'node',4.73288),('eaque',4,'node',2.41594),('eaque',5,'node',2.42411),('eaque',6,'node',2.42411),('eaque',7,'node',4.79235),('eaque',8,'node',1.44631),('eaque',9,'node',4.7773),('eaque',12,'node',2.39975),('eaque',17,'node',4.73288),('eaque',27,'node',2.39975),('eaque',28,'node',2.43235),('eaque',29,'node',2.39173),('eaque',30,'node',2.39975),('eaque',31,'node',3.64057),('eaque',40,'node',1),('eaque',41,'node',1),('eaque',47,'node',4.71831),('eaque',54,'node',4.70385),('eaque',55,'node',4.66115),('eaque',56,'node',4.83673),('earlier',22,'node',0.892724),('easy',21,'node',1),('easy',35,'node',26),('eating',31,'node',26),('eclipsing',16,'node',0.643484),('eclipsing',68,'node',0.640063),('ecommerce',29,'node',8.30149),('edit',19,'node',1.45414),('edited',20,'node',1),('editing',19,'node',0.833529),('editor',19,'node',0.659351),('editorial',19,'node',8.45016),('efficitur',67,'node',1),('eg',19,'node',1),('egestas',3,'node',0.784336),('egestas',4,'node',1),('egestas',5,'node',1),('egestas',6,'node',1),('egestas',7,'node',5.05741),('egestas',8,'node',2.96488),('egestas',10,'node',9.43103),('egestas',11,'node',4),('egestas',12,'node',1),('egestas',13,'node',4),('egestas',14,'node',2),('egestas',15,'node',1.69612),('egestas',26,'node',4),('egestas',27,'node',1),('egestas',28,'node',1.77419),('egestas',29,'node',1),('egestas',30,'node',1),('egestas',31,'node',1.47733),('egestas',34,'node',0.934703),('egestas',35,'node',3),('egestas',37,'node',3.88282),('egestas',38,'node',0.945829),('egestas',39,'node',1),('egestas',47,'node',0.851346),('egestas',48,'node',2),('egestas',49,'node',1),('egestas',51,'node',1),('egestas',52,'node',1),('egestas',53,'node',4.8642),('egestas',55,'node',1.32234),('egestas',58,'node',2),('egestas',59,'node',2),('egestas',60,'node',4),('egestas',61,'node',3),('egestas',62,'node',28),('egestas',63,'node',1),('egestas',65,'node',1),('egestas',67,'node',1),('eget',3,'node',1),('eget',4,'node',3),('eget',5,'node',3),('eget',6,'node',3),('eget',7,'node',4.15074),('eget',8,'node',5.85493),('eget',9,'node',3.48475),('eget',10,'node',8.62835),('eget',11,'node',4),('eget',12,'node',3),('eget',13,'node',6),('eget',14,'node',3),('eget',15,'node',4.97783),('eget',17,'node',1),('eget',27,'node',3),('eget',28,'node',3.7717),('eget',29,'node',3.76188),('eget',30,'node',3.71),('eget',31,'node',5.9843),('eget',33,'node',1),('eget',34,'node',4.6732),('eget',35,'node',4),('eget',36,'node',2),('eget',37,'node',6.80613),('eget',38,'node',4.69099),('eget',39,'node',1),('eget',42,'node',4.66982),('eget',43,'node',4.66982),('eget',44,'node',4.66982),('eget',45,'node',4.66982),('eget',46,'node',4.66982),('eget',47,'node',1.85135),('eget',48,'node',4),('eget',49,'node',2),('eget',50,'node',4),('eget',51,'node',4),('eget',52,'node',3),('eget',53,'node',9.42318),('eget',54,'node',1.86366),('eget',55,'node',3.34745),('eget',56,'node',1),('eget',57,'node',4.67307),('eget',58,'node',5),('eget',59,'node',2),('eget',60,'node',1),('eget',61,'node',1),('eget',62,'node',1),('eget',63,'node',5),('eget',64,'node',1),('eget',65,'node',1),('eget',66,'node',2),('eget',67,'node',1),('eirmod',2,'node',0.989021),('eirmod',39,'node',3.93534),('eiusmod',2,'node',1),('eleifend',4,'node',0.989021),('eleifend',5,'node',0.993146),('eleifend',6,'node',0.993146),('eleifend',7,'node',3.19211),('eleifend',8,'node',1.74685),('eleifend',9,'node',0.845322),('eleifend',10,'node',1),('eleifend',11,'node',2),('eleifend',12,'node',0.980874),('eleifend',15,'node',0.920273),('eleifend',27,'node',0.980874),('eleifend',28,'node',0.997306),('eleifend',29,'node',1.73873),('eleifend',30,'node',0.980874),('eleifend',34,'node',1.77281),('eleifend',35,'node',1),('eleifend',38,'node',1.79279),('eleifend',39,'node',4.70279),('eleifend',42,'node',1.87957),('eleifend',43,'node',1.87957),('eleifend',44,'node',1.87957),('eleifend',45,'node',1.87957),('eleifend',46,'node',1.87957),('eleifend',50,'node',2),('eleifend',52,'node',2),('eleifend',53,'node',0.968904),('eleifend',55,'node',0.652202),('eleifend',57,'node',1.88282),('eleifend',61,'node',1.97685),('eleifend',62,'node',1),('eleifend',66,'node',2),('elementum',7,'node',37.4055),('elementum',8,'node',3.19261),('elementum',11,'node',0.96498),('elementum',13,'node',2),('elementum',14,'node',1),('elementum',15,'node',0.876337),('elementum',30,'node',0.727213),('elementum',31,'node',0.699655),('elementum',34,'node',2.5405),('elementum',35,'node',0.997306),('elementum',37,'node',1.96621),('elementum',38,'node',2.56782),('elementum',48,'node',1),('elementum',50,'node',2),('elementum',51,'node',1),('elementum',52,'node',1),('elementum',53,'node',3.14156),('elementum',55,'node',0.640063),('elementum',61,'node',1),('elementum',62,'node',1),('elementum',63,'node',1),('elementum',66,'node',2),('elementum',67,'node',1),('elit',2,'node',2.89579),('elit',3,'node',1.98902),('elit',7,'node',5.81577),('elit',8,'node',3.01859),('elit',9,'node',2),('elit',10,'node',0.851346),('elit',13,'node',2),('elit',14,'node',1),('elit',15,'node',2.64995),('elit',17,'node',1.98902),('elit',28,'node',0.774192),('elit',31,'node',0.707906),('elit',33,'node',1),('elit',34,'node',3.40842),('elit',35,'node',2),('elit',36,'node',2),('elit',37,'node',1.9347),('elit',38,'node',3.43292),('elit',39,'node',2),('elit',42,'node',5.73317),('elit',43,'node',5.73317),('elit',44,'node',5.73317),('elit',45,'node',5.73317),('elit',46,'node',5.73317),('elit',47,'node',1.98493),('elit',48,'node',1.97286),('elit',49,'node',1),('elit',50,'node',1),('elit',51,'node',1),('elit',53,'node',6.73885),('elit',54,'node',1.98087),('elit',55,'node',1.9689),('elit',56,'node',2),('elit',57,'node',5.73658),('elit',60,'node',28),('elit',61,'node',2),('elit',63,'node',1),('elit',66,'node',54),('elitr',2,'node',1),('elitr',39,'node',3.94178),('else',19,'node',0.460161),('email',40,'node',1),('email',41,'node',1),('email',47,'node',26),('emdash',19,'node',1.34641),('en',19,'node',3.63671),('en',69,'node',11),('enabled',19,'node',1),('enabling',21,'node',1),('end',19,'node',0.60778),('engine',20,'node',0.949597),('engine',22,'node',1.86995),('enim',2,'node',2.84793),('enim',3,'node',0.957226),('enim',4,'node',0.816452),('enim',5,'node',0.819249),('enim',6,'node',0.819249),('enim',7,'node',5.08134),('enim',9,'node',2.4649),('enim',10,'node',1),('enim',11,'node',5.79525),('enim',12,'node',0.810915),('enim',14,'node',2),('enim',15,'node',1.6503),('enim',17,'node',0.957226),('enim',26,'node',2),('enim',27,'node',0.810915),('enim',28,'node',0.822065),('enim',29,'node',0.808176),('enim',30,'node',0.810915),('enim',31,'node',1.64588),('enim',33,'node',1),('enim',34,'node',0.819249),('enim',35,'node',3),('enim',37,'node',1.65843),('enim',38,'node',0.827757),('enim',39,'node',5.84557),('enim',42,'node',3),('enim',43,'node',3),('enim',44,'node',3),('enim',45,'node',3),('enim',46,'node',3),('enim',47,'node',4.25515),('enim',49,'node',1),('enim',50,'node',2),('enim',51,'node',2),('enim',52,'node',2),('enim',53,'node',5.88851),('enim',54,'node',0.949597),('enim',55,'node',1.59773),('enim',56,'node',0.98493),('enim',57,'node',3),('enim',58,'node',1),('enim',59,'node',2),('enim',61,'node',0.976851),('enim',62,'node',1),('enim',63,'node',27),('enim',64,'node',1),('enim',66,'node',1),('enim',67,'node',28),('enough',16,'node',0.517983),('ensure',16,'node',1),('ensure',68,'node',1),('enter',19,'node',2.37343),('enterprise',22,'node',7.83317),('entities',16,'node',0.747619),('entities',68,'node',0.742984),('eos',2,'node',2.86941),('eos',39,'node',6.33513),('equivalent',20,'node',0.968904),('equivalent',22,'node',1),('erat',2,'node',2.84994),('erat',3,'node',2.6095),('erat',4,'node',2),('erat',5,'node',2.71423),('erat',6,'node',2),('erat',7,'node',1.7017),('erat',8,'node',2.7184),('erat',9,'node',1.84832),('erat',12,'node',2.72502),('erat',13,'node',1),('erat',14,'node',27),('erat',15,'node',0.776703),('erat',17,'node',0.993146),('erat',27,'node',2),('erat',28,'node',2),('erat',29,'node',2),('erat',30,'node',2),('erat',31,'node',1.56328),('erat',33,'node',1),('erat',34,'node',2.76055),('erat',35,'node',1),('erat',37,'node',0.934703),('erat',38,'node',2.79304),('erat',39,'node',5.91178),('erat',42,'node',2.70347),('erat',43,'node',2.70347),('erat',44,'node',2.70347),('erat',45,'node',2.70347),('erat',46,'node',2.70347),('erat',47,'node',1.81965),('erat',48,'node',0.972861),('erat',49,'node',2),('erat',50,'node',1),('erat',51,'node',1),('erat',53,'node',1.22639),('erat',54,'node',0.98493),('erat',55,'node',2.27383),('erat',56,'node',1.80275),('erat',57,'node',2.71007),('erat',59,'node',3),('eros',2,'node',1),('eros',4,'node',1),('eros',5,'node',1.70583),('eros',6,'node',1),('eros',7,'node',20.585),('eros',8,'node',20.9296),('eros',9,'node',1.47611),('eros',10,'node',3.74313),('eros',11,'node',0.842342),('eros',12,'node',1),('eros',14,'node',3),('eros',26,'node',2),('eros',27,'node',1),('eros',28,'node',1),('eros',29,'node',1),('eros',30,'node',1.72283),('eros',31,'node',1.45267),('eros',33,'node',1),('eros',34,'node',1.91323),('eros',35,'node',1.96498),('eros',36,'node',1),('eros',37,'node',6.65916),('eros',38,'node',1.92384),('eros',39,'node',2.50559),('eros',42,'node',5.72189),('eros',43,'node',5.72189),('eros',44,'node',5.72189),('eros',45,'node',5.72189),('eros',46,'node',5.72189),('eros',48,'node',2),('eros',52,'node',2),('eros',53,'node',3.68148),('eros',54,'node',0.747619),('eros',55,'node',0.655756),('eros',57,'node',5.72849),('eros',58,'node',2),('eros',60,'node',1),('eros',61,'node',2),('eros',62,'node',1),('eros',63,'node',2),('eros',66,'node',2),('eros',67,'node',28),('error',3,'node',5.66031),('error',4,'node',3.23605),('error',5,'node',3.24706),('error',6,'node',3.24706),('error',7,'node',5.73444),('error',8,'node',1.46497),('error',9,'node',5.71569),('error',12,'node',3.21425),('error',17,'node',5.66031),('error',27,'node',3.21425),('error',28,'node',3.25815),('error',29,'node',3.20346),('error',30,'node',3.21425),('error',31,'node',4.52338),('error',40,'node',1),('error',41,'node',1),('error',47,'node',5.64215),('error',54,'node',5.62412),('error',55,'node',5.57089),('error',56,'node',5.79012),('errors',20,'node',0.886095),('esse',2,'node',2.86941),('esse',39,'node',5.18936),('esse',40,'node',1),('esse',41,'node',1),('est',2,'node',8.73881),('est',3,'node',3.76002),('est',4,'node',2.46477),('est',5,'node',2.47331),('est',6,'node',2.47331),('est',7,'node',5.16103),('est',8,'node',2.16974),('est',9,'node',5.26606),('est',10,'node',1.84532),('est',11,'node',0.839384),('est',12,'node',2.44785),('est',17,'node',3.76002),('est',26,'node',2),('est',27,'node',2.44785),('est',28,'node',2.48192),('est',29,'node',2.43949),('est',30,'node',2.44785),('est',31,'node',2.64761),('est',33,'node',1),('est',34,'node',0.797402),('est',35,'node',2),('est',38,'node',0.805455),('est',39,'node',8.8803),('est',40,'node',1),('est',41,'node',1),('est',42,'node',4.68031),('est',43,'node',4.68031),('est',44,'node',4.68031),('est',45,'node',4.68031),('est',46,'node',4.68031),('est',47,'node',4.60075),('est',48,'node',1),('est',49,'node',1),('est',53,'node',4.55651),('est',54,'node',3.73887),('est',55,'node',4.44616),('est',56,'node',3.83673),('est',57,'node',4.68686),('est',60,'node',1),('est',61,'node',1),('est',62,'node',1),('est',66,'node',2),('est',67,'node',2),('et',2,'node',12.5891),('et',3,'node',7.5021),('et',4,'node',10.3922),('et',5,'node',11.8126),('et',6,'node',10.403),('et',7,'node',12.5076),('et',8,'node',10.3381),('et',9,'node',7.67338),('et',10,'node',5.70271),('et',12,'node',10.3681),('et',13,'node',2),('et',15,'node',5.67299),('et',17,'node',6.73288),('et',26,'node',10),('et',27,'node',10.3681),('et',28,'node',11.1803),('et',29,'node',10.3561),('et',30,'node',10.3681),('et',31,'node',11.0863),('et',33,'node',4.99731),('et',34,'node',7.29426),('et',35,'node',1),('et',36,'node',4),('et',37,'node',4.95723),('et',38,'node',7.34143),('et',39,'node',27.9171),('et',40,'node',1),('et',41,'node',1),('et',42,'node',3.71203),('et',43,'node',3.71203),('et',44,'node',3.71203),('et',45,'node',3.71203),('et',46,'node',3.71203),('et',47,'node',6.71831),('et',48,'node',4.99731),('et',49,'node',2),('et',50,'node',1),('et',51,'node',5),('et',52,'node',1),('et',53,'node',10.6055),('et',54,'node',6.70385),('et',55,'node',6.65845),('et',56,'node',6.83673),('et',57,'node',3.71856),('et',58,'node',5),('et',59,'node',1),('et',60,'node',5),('et',61,'node',4),('et',62,'node',2),('et',63,'node',2),('et',64,'node',1),('et',65,'node',7),('et',66,'node',5),('etiam',4,'node',1),('etiam',5,'node',1),('etiam',6,'node',1),('etiam',7,'node',0.604732),('etiam',8,'node',1.65755),('etiam',10,'node',2.87634),('etiam',11,'node',4),('etiam',12,'node',1),('etiam',13,'node',1),('etiam',14,'node',3),('etiam',15,'node',1),('etiam',27,'node',1),('etiam',28,'node',1.75946),('etiam',29,'node',1),('etiam',30,'node',1),('etiam',31,'node',1.73614),('etiam',34,'node',1),('etiam',37,'node',3.71345),('etiam',38,'node',1),('etiam',42,'node',2.8775),('etiam',43,'node',2.8775),('etiam',44,'node',2.8775),('etiam',45,'node',2.8775),('etiam',46,'node',2.8775),('etiam',48,'node',1),('etiam',51,'node',2),('etiam',52,'node',2),('etiam',53,'node',4.30378),('etiam',54,'node',0.757065),('etiam',55,'node',0.71),('etiam',57,'node',2.8775),('etiam',58,'node',2),('etiam',59,'node',2),('etiam',60,'node',3),('etiam',61,'node',1),('etiam',62,'node',1),('etiam',63,'node',2),('etiam',65,'node',1),('etiam',66,'node',1),('eu',2,'node',2.86941),('eu',3,'node',0.797402),('eu',4,'node',1.98493),('eu',5,'node',1.98902),('eu',6,'node',1.98902),('eu',7,'node',24.3923),('eu',8,'node',10.5311),('eu',9,'node',1.74011),('eu',11,'node',2.96109),('eu',12,'node',1.97685),('eu',13,'node',1),('eu',14,'node',2),('eu',15,'node',4.53312),('eu',26,'node',2),('eu',27,'node',1.97685),('eu',28,'node',2.76985),('eu',29,'node',1.97286),('eu',30,'node',1.97685),('eu',31,'node',0.76188),('eu',33,'node',2),('eu',34,'node',8.10738),('eu',35,'node',4.95723),('eu',36,'node',4),('eu',37,'node',1),('eu',38,'node',8.16979),('eu',39,'node',9.18204),('eu',40,'node',1),('eu',41,'node',1),('eu',42,'node',4.71056),('eu',43,'node',4.71056),('eu',44,'node',4.71056),('eu',45,'node',4.71056),('eu',46,'node',4.71056),('eu',48,'node',3),('eu',49,'node',2),('eu',50,'node',2),('eu',51,'node',4),('eu',52,'node',2),('eu',53,'node',4.14969),('eu',54,'node',0.738408),('eu',55,'node',2.11024),('eu',57,'node',4.71699),('eu',59,'node',2),('eu',60,'node',3),('eu',61,'node',1.98087),('eu',62,'node',2),('eu',63,'node',3),('eu',64,'node',2),('eu',65,'node',3),('eu',66,'node',2),('eu',67,'node',1),('euismod',1,'node',0.889397),('euismod',2,'node',1.8881),('euismod',3,'node',0.805455),('euismod',4,'node',2),('euismod',5,'node',2),('euismod',6,'node',2),('euismod',7,'node',1.94183),('euismod',8,'node',1.92027),('euismod',9,'node',0.731649),('euismod',12,'node',2),('euismod',13,'node',2),('euismod',15,'node',0.752312),('euismod',26,'node',2),('euismod',27,'node',2),('euismod',28,'node',2),('euismod',29,'node',2),('euismod',30,'node',2),('euismod',31,'node',1.70583),('euismod',34,'node',1.9347),('euismod',35,'node',2),('euismod',37,'node',1.82713),('euismod',38,'node',1.94583),('euismod',39,'node',5),('euismod',42,'node',1.87957),('euismod',43,'node',1.87957),('euismod',44,'node',1.87957),('euismod',45,'node',1.87957),('euismod',46,'node',1.87957),('euismod',48,'node',0.968904),('euismod',49,'node',1),('euismod',50,'node',1),('euismod',53,'node',2.71933),('euismod',57,'node',1.88282),('euismod',58,'node',1),('euismod',62,'node',2),('euismod',64,'node',2),('euismod',67,'node',1),('eum',2,'node',2.86941),('eum',39,'node',2.98858),('even',1,'node',3),('even',19,'node',0.512513),('even',69,'node',1),('every',19,'node',0.931053),('everyone',22,'node',1.48889),('ex',2,'node',2.82996),('ex',39,'node',3.82181),('ex',66,'node',2),('example',19,'node',0.462781),('example',23,'node',96),('example',24,'node',16),('example',25,'node',16),('example',26,'node',16),('excepteur',2,'node',1),('excepteur',3,'node',1),('excepteur',7,'node',1),('excepteur',9,'node',1),('excepteur',17,'node',1),('excepteur',39,'node',2.29268),('excepteur',40,'node',1),('excepteur',41,'node',1),('excepteur',47,'node',1),('excepteur',54,'node',1),('excepteur',55,'node',1),('excepteur',56,'node',1),('exchange',19,'node',0.461904),('exerci',2,'node',1.91323),('exerci',39,'node',3.83352),('exercises',30,'node',26),('exercitation',2,'node',0.934703),('existing',1,'node',0.997306),('existing',16,'node',0.554747),('exit',19,'node',1.23615),('experience',21,'node',2),('explicabo',3,'node',4.73288),('explicabo',4,'node',2.38054),('explicabo',5,'node',2.38847),('explicabo',6,'node',2.38847),('explicabo',7,'node',4.79235),('explicabo',8,'node',1.42213),('explicabo',9,'node',4.7773),('explicabo',12,'node',2.36485),('explicabo',17,'node',4.73288),('explicabo',27,'node',2.36485),('explicabo',28,'node',2.39645),('explicabo',29,'node',2.35709),('explicabo',30,'node',2.36485),('explicabo',31,'node',3.62144),('explicabo',47,'node',4.71831),('explicabo',54,'node',4.70385),('explicabo',55,'node',4.66115),('explicabo',56,'node',4.83673),('explicitly',16,'node',0.691597),('explicitly',68,'node',0.687638),('explore',19,'node',1),('export',19,'node',0.581429),('extended',16,'node',2.42748),('extended',68,'node',2.41904),('extension',21,'node',1.89608),('extension',22,'node',2),('extensively',22,'node',1),('extract',19,'node',1.49813),('facer',39,'node',1.68349),('facilisi',2,'node',1),('facilisi',3,'node',1),('facilisi',5,'node',0.722831),('facilisi',7,'node',1),('facilisi',8,'node',0.63333),('facilisi',9,'node',1),('facilisi',15,'node',0.805455),('facilisi',17,'node',1),('facilisi',39,'node',1.4862),('facilisi',47,'node',1),('facilisi',53,'node',0.961087),('facilisi',54,'node',1),('facilisi',55,'node',1),('facilisi',56,'node',1),('facilisis',1,'node',0.857458),('facilisis',2,'node',2.86941),('facilisis',8,'node',2.66226),('facilisis',11,'node',0.938382),('facilisis',15,'node',1),('facilisis',31,'node',0.731649),('facilisis',33,'node',1),('facilisis',34,'node',2.68572),('facilisis',35,'node',2),('facilisis',37,'node',1),('facilisis',38,'node',2.70376),('facilisis',39,'node',2.97586),('facilisis',42,'node',1.807),('facilisis',43,'node',1.807),('facilisis',44,'node',1.807),('facilisis',45,'node',1.807),('facilisis',46,'node',1.807),('facilisis',47,'node',0.824901),('facilisis',50,'node',1),('facilisis',51,'node',1),('facilisis',53,'node',1),('facilisis',55,'node',0.638366),('facilisis',57,'node',1.81025),('facilisis',62,'node',1),('facilisis',67,'node',1),('facts',53,'node',1),('failure',19,'node',0.49376),('fames',4,'node',1),('fames',5,'node',1),('fames',6,'node',1),('fames',7,'node',0.623497),('fames',8,'node',1.64486),('fames',12,'node',1),('fames',15,'node',0.729424),('fames',26,'node',2),('fames',27,'node',1),('fames',28,'node',1),('fames',29,'node',1),('fames',30,'node',1),('fames',34,'node',1.76761),('fames',37,'node',1),('fames',38,'node',1.78768),('fames',48,'node',1),('fames',53,'node',1),('fames',58,'node',2),('fames',60,'node',2),('fames',61,'node',1),('familiar',22,'node',1.48174),('famous',4,'node',0.972861),('famous',5,'node',0.976851),('famous',6,'node',0.976851),('famous',8,'node',0.873132),('famous',12,'node',0.96498),('famous',27,'node',0.96498),('famous',28,'node',0.980874),('famous',29,'node',0.961087),('famous',30,'node',0.96498),('famous',34,'node',0.886095),('famous',38,'node',0.896076),('faq',20,'node',9.20091),('fastcgi',21,'node',0.836446),('faucibus',1,'node',0.896076),('faucibus',3,'node',1.56111),('faucibus',4,'node',1),('faucibus',5,'node',1),('faucibus',6,'node',1),('faucibus',7,'node',21.069),('faucibus',8,'node',2.32735),('faucibus',10,'node',1.85439),('faucibus',11,'node',6),('faucibus',12,'node',1),('faucibus',13,'node',2),('faucibus',14,'node',1),('faucibus',15,'node',0.745294),('faucibus',27,'node',1),('faucibus',28,'node',1.7717),('faucibus',29,'node',1),('faucibus',30,'node',1),('faucibus',31,'node',0.72066),('faucibus',33,'node',1),('faucibus',34,'node',2.56289),('faucibus',35,'node',1.97685),('faucibus',36,'node',1),('faucibus',37,'node',1.96109),('faucibus',38,'node',2.5909),('faucibus',39,'node',2),('faucibus',42,'node',2.9496),('faucibus',43,'node',2.9496),('faucibus',44,'node',2.9496),('faucibus',45,'node',2.9496),('faucibus',46,'node',2.9496),('faucibus',48,'node',2),('faucibus',49,'node',1),('faucibus',50,'node',2),('faucibus',52,'node',1),('faucibus',53,'node',3.50806),('faucibus',57,'node',2.9496),('faucibus',58,'node',2),('faucibus',61,'node',1),('faucibus',62,'node',2),('faucibus',63,'node',2),('faucibus',65,'node',27),('faucibus',66,'node',28),('feature',16,'node',0.989175),('feature',21,'node',0.899454),('features',16,'node',0.550958),('features',22,'node',1),('february',16,'node',1),('february',68,'node',1),('feed',16,'node',0.536316),('feel',16,'node',0.646943),('feel',68,'node',0.643484),('felis',5,'node',0.703756),('felis',7,'node',26.6101),('felis',8,'node',2.21349),('felis',9,'node',42.0402),('felis',10,'node',1.87634),('felis',11,'node',23.5682),('felis',12,'node',0.727213),('felis',14,'node',4),('felis',15,'node',1.92743),('felis',26,'node',2),('felis',30,'node',0.718502),('felis',31,'node',0.691597),('felis',33,'node',3),('felis',34,'node',1.68131),('felis',35,'node',2.96498),('felis',36,'node',2),('felis',37,'node',1.87634),('felis',38,'node',1.69927),('felis',39,'node',1),('felis',42,'node',0.942091),('felis',43,'node',0.942091),('felis',44,'node',0.942091),('felis',45,'node',0.942091),('felis',46,'node',0.942091),('felis',47,'node',0.830633),('felis',48,'node',1),('felis',49,'node',2),('felis',50,'node',2),('felis',51,'node',1),('felis',52,'node',4),('felis',53,'node',5.54275),('felis',55,'node',1.37114),('felis',57,'node',0.942091),('felis',59,'node',1),('felis',60,'node',3),('felis',61,'node',2),('felis',62,'node',1),('felis',63,'node',1),('felis',64,'node',2),('felis',65,'node',1),('felis',67,'node',28),('fermentum',1,'node',0.848323),('fermentum',4,'node',1),('fermentum',5,'node',1.73614),('fermentum',6,'node',1),('fermentum',7,'node',0.582831),('fermentum',8,'node',1.32893),('fermentum',9,'node',0.725015),('fermentum',10,'node',0.857458),('fermentum',12,'node',1),('fermentum',14,'node',1),('fermentum',27,'node',1),('fermentum',28,'node',1),('fermentum',29,'node',1),('fermentum',30,'node',1),('fermentum',31,'node',1),('fermentum',34,'node',0.805455),('fermentum',36,'node',1),('fermentum',37,'node',1),('fermentum',38,'node',0.813674),('fermentum',42,'node',2.91053),('fermentum',43,'node',2.91053),('fermentum',44,'node',2.91053),('fermentum',45,'node',2.91053),('fermentum',46,'node',2.91053),('fermentum',47,'node',0.863659),('fermentum',49,'node',2),('fermentum',51,'node',1),('fermentum',53,'node',4.21729),('fermentum',55,'node',1.29255),('fermentum',57,'node',2.91053),('fermentum',59,'node',2),('fermentum',60,'node',1),('fermentum',61,'node',0.968904),('fermentum',64,'node',2),('fermentum',65,'node',2),('fermentum',66,'node',2),('feugait',2,'node',1),('feugait',39,'node',1.48857),('feugiat',2,'node',2.86941),('feugiat',4,'node',1),('feugiat',5,'node',1.70583),('feugiat',6,'node',1),('feugiat',7,'node',1.35943),('feugiat',8,'node',3.43059),('feugiat',10,'node',1.86055),('feugiat',12,'node',1),('feugiat',14,'node',1),('feugiat',15,'node',0.76188),('feugiat',26,'node',4),('feugiat',27,'node',1),('feugiat',28,'node',1),('feugiat',29,'node',1),('feugiat',30,'node',1),('feugiat',31,'node',1.73841),('feugiat',33,'node',4),('feugiat',34,'node',2.82668),('feugiat',35,'node',1),('feugiat',37,'node',1),('feugiat',38,'node',2.84234),('feugiat',39,'node',3.97586),('feugiat',42,'node',2.76586),('feugiat',43,'node',2.76586),('feugiat',44,'node',2.76586),('feugiat',45,'node',2.76586),('feugiat',46,'node',2.76586),('feugiat',49,'node',1),('feugiat',50,'node',1),('feugiat',51,'node',1),('feugiat',52,'node',1),('feugiat',53,'node',5.98038),('feugiat',55,'node',1.43292),('feugiat',57,'node',2.77241),('feugiat',60,'node',2),('feugiat',61,'node',29.9849),('feugiat',62,'node',0.993146),('feugiat',65,'node',1),('feugiat',66,'node',1),('feugiat',67,'node',2),('few',7,'node',26),('few',16,'node',0.876337),('few',20,'node',1),('few',68,'node',0.869951),('fields',16,'node',0.745294),('fields',68,'node',0.740689),('file',19,'node',8.00783),('file',21,'node',1),('file',22,'node',1.47938),('files',19,'node',1.72752),('files',20,'node',2),('find',15,'node',1),('find',16,'node',0.740689),('find',22,'node',1.47241),('find',68,'node',0.736141),('finibus',67,'node',1),('first',19,'node',0.466323),('first',20,'node',1),('fixes',16,'node',4.0955),('fixes',68,'node',0.916736),('flower',11,'node',11),('focus',16,'node',0.623497),('focus',21,'node',1),('focus',68,'node',0.620288),('focuses',21,'node',1),('focusing',47,'node',26),('folders',19,'node',0.869951),('follow',16,'node',1),('follow',19,'node',1.05779),('follow',68,'node',1),('following',19,'node',2.88073),('following',22,'node',1.98902),('foods',31,'node',26),('for',1,'node',2.98493),('for',12,'node',26),('for',16,'node',12.1569),('for',19,'node',9.87027),('for',20,'node',3.91323),('for',21,'node',16.5177),('for',22,'node',4.49409),('for',68,'node',8.4497),('form',5,'node',26),('former',19,'node',0.588512),('fortunately',16,'node',0.794753),('fortunately',68,'node',0.78951),('forumplus',23,'node',1),('forumplus',69,'node',11),('found',16,'node',0.999723),('found',19,'node',4),('fri',12,'node',0.759465),('fringilla',4,'node',1),('fringilla',5,'node',1.73165),('fringilla',6,'node',1),('fringilla',7,'node',2.00508),('fringilla',8,'node',1.63167),('fringilla',9,'node',2.23316),('fringilla',10,'node',2),('fringilla',11,'node',0.866793),('fringilla',12,'node',1),('fringilla',13,'node',1),('fringilla',14,'node',1),('fringilla',15,'node',0.927431),('fringilla',27,'node',1),('fringilla',28,'node',1),('fringilla',29,'node',1),('fringilla',30,'node',3.15343),('fringilla',31,'node',3.08082),('fringilla',33,'node',1),('fringilla',34,'node',1),('fringilla',35,'node',1),('fringilla',37,'node',2.84991),('fringilla',38,'node',1),('fringilla',39,'node',1),('fringilla',42,'node',2.8491),('fringilla',43,'node',2.8491),('fringilla',44,'node',2.8491),('fringilla',45,'node',2.8491),('fringilla',46,'node',2.8491),('fringilla',47,'node',1.72336),('fringilla',48,'node',2),('fringilla',50,'node',1),('fringilla',52,'node',3),('fringilla',53,'node',4.69944),('fringilla',57,'node',2.8491),('fringilla',59,'node',2),('fringilla',61,'node',1),('fringilla',67,'node',2),('from',16,'node',2),('from',19,'node',1.45164),('from',22,'node',1.49618),('from',55,'node',26),('from',68,'node',2),('front',17,'node',26),('ftp',19,'node',0.712106),('fugiat',39,'node',2.20618),('fugiat',40,'node',1),('fugiat',41,'node',1),('fugit',3,'node',0.931053),('fugit',4,'node',0.797402),('fugit',5,'node',0.800068),('fugit',6,'node',0.800068),('fugit',7,'node',0.945829),('fugit',9,'node',0.942091),('fugit',12,'node',0.792123),('fugit',17,'node',0.931053),('fugit',27,'node',0.792123),('fugit',28,'node',0.802752),('fugit',29,'node',0.78951),('fugit',30,'node',0.792123),('fugit',31,'node',0.886095),('fugit',47,'node',0.927431),('fugit',54,'node',0.923838),('fugit',55,'node',0.913226),('fugit',56,'node',0.957226),('full',16,'node',1.06364),('fulltime',19,'node',1.96705),('fully',16,'node',0.833529),('fully',21,'node',0.938382),('fully',68,'node',0.827757),('functions',19,'node',0.635),('fusce',3,'node',0.78951),('fusce',4,'node',2.99731),('fusce',5,'node',23.8003),('fusce',6,'node',3),('fusce',7,'node',8.27809),('fusce',8,'node',22.1818),('fusce',10,'node',0.860547),('fusce',11,'node',4),('fusce',12,'node',2.98902),('fusce',14,'node',1),('fusce',15,'node',3.52043),('fusce',26,'node',2),('fusce',27,'node',2.98902),('fusce',28,'node',4.5385),('fusce',29,'node',4.51087),('fusce',30,'node',3.70752),('fusce',31,'node',2.41661),('fusce',33,'node',1),('fusce',34,'node',2.68631),('fusce',35,'node',1),('fusce',36,'node',3),('fusce',37,'node',2),('fusce',38,'node',2.71691),('fusce',39,'node',1),('fusce',42,'node',1.78931),('fusce',43,'node',1.78931),('fusce',44,'node',1.78931),('fusce',45,'node',1.78931),('fusce',46,'node',1.78931),('fusce',47,'node',0.742984),('fusce',48,'node',1),('fusce',49,'node',3),('fusce',50,'node',2),('fusce',51,'node',1),('fusce',52,'node',1),('fusce',53,'node',9.08928),('fusce',55,'node',0.653974),('fusce',57,'node',1.79256),('fusce',59,'node',28),('fusce',60,'node',1),('fusce',62,'node',2),('fusce',63,'node',1),('fusce',64,'node',2),('fusce',65,'node',3),('fusce',66,'node',1),('future',55,'node',26),('geeks',19,'node',1.5638),('general',1,'node',11),('general',15,'node',11),('general',16,'node',11.9029),('general',53,'node',11),('general',54,'node',11),('general',55,'node',11),('general',68,'node',0.899454),('get',18,'node',2),('get',53,'node',1),('git',16,'node',0.497805),('githubcom',19,'node',8.76759),('give',1,'node',14.096),('give',3,'node',8.17371),('give',7,'node',4.04655),('give',15,'node',12.8183),('give',16,'node',5.41273),('give',17,'node',4.38838),('give',18,'node',5),('give',19,'node',2.93863),('give',20,'node',4.0992),('give',21,'node',4.0992),('give',22,'node',3.48012),('give',47,'node',7.68002),('give',53,'node',37.9979),('give',54,'node',7.6662),('give',55,'node',10.6822),('give',56,'node',8.50467),('give',68,'node',2.98778),('give',69,'node',5),('given',16,'node',1.33723),('given',68,'node',0.813674),('gives',16,'node',0.879565),('gives',68,'node',0.873132),('go',16,'node',0.657549),('go',19,'node',0.4475),('go',68,'node',0.653974),('godaddy',19,'node',3.02894),('goes',1,'node',2),('gold',1,'node',2),('good',10,'node',26),('good',19,'node',0.648686),('graphic',22,'node',0.845322),('gravida',5,'node',0.72066),('gravida',7,'node',0.613969),('gravida',8,'node',1),('gravida',10,'node',3),('gravida',13,'node',1),('gravida',14,'node',1),('gravida',15,'node',0.810915),('gravida',30,'node',0.722831),('gravida',31,'node',1.55615),('gravida',34,'node',1),('gravida',35,'node',0.968904),('gravida',37,'node',2.95793),('gravida',38,'node',1),('gravida',42,'node',5.63272),('gravida',43,'node',5.63272),('gravida',44,'node',5.63272),('gravida',45,'node',5.63272),('gravida',46,'node',5.63272),('gravida',48,'node',2),('gravida',52,'node',2),('gravida',53,'node',1.66666),('gravida',54,'node',0.854391),('gravida',55,'node',1.51321),('gravida',57,'node',5.6393),('gravida',58,'node',1),('gravida',61,'node',1),('gravida',63,'node',1),('gravida',64,'node',1),('gravida',67,'node',1),('great',19,'node',0.441832),('greater',22,'node',1),('green',19,'node',1.5638),('green',57,'node',26),('group',22,'node',7.81),('gubergren',2,'node',7.73881),('gubergren',39,'node',6.37106),('guide',20,'node',0.845322),('guidelines',2,'node',26),('guidelines',18,'node',1),('guys',36,'node',26),('h1',3,'node',25.2944),('h1',4,'node',24.9883),('h1',5,'node',25.0895),('h1',6,'node',25.0895),('h1',7,'node',25.7145),('h1',9,'node',25.6082),('h1',12,'node',24.7883),('h1',17,'node',25.2944),('h1',27,'node',24.7883),('h1',28,'node',25.1915),('h1',29,'node',24.6895),('h1',30,'node',24.7883),('h1',31,'node',25.3981),('h1',47,'node',25.1915),('h1',54,'node',25.0895),('h1',55,'node',24.7883),('h1',56,'node',26),('h2',3,'node',17.2851),('h2',4,'node',14.9514),('h2',5,'node',15.0007),('h2',6,'node',15.0007),('h2',7,'node',17.5529),('h2',8,'node',15.4074),('h2',9,'node',17.4852),('h2',12,'node',14.8537),('h2',17,'node',17.2851),('h2',27,'node',14.8537),('h2',28,'node',15.0503),('h2',29,'node',14.8054),('h2',30,'node',14.8537),('h2',31,'node',16.5895),('h2',47,'node',17.2194),('h2',54,'node',17.1543),('h2',55,'node',16.9618),('h2',56,'node',17.7594),('h3',3,'node',14.4457),('h3',4,'node',12.5084),('h3',5,'node',12.5494),('h3',6,'node',12.5494),('h3',7,'node',14.6678),('h3',8,'node',11.3937),('h3',9,'node',14.6116),('h3',12,'node',12.4273),('h3',17,'node',14.4457),('h3',27,'node',12.4273),('h3',28,'node',12.5906),('h3',29,'node',12.3871),('h3',30,'node',12.4273),('h3',31,'node',13.8687),('h3',47,'node',14.3913),('h3',54,'node',14.3372),('h3',55,'node',14.1775),('h3',56,'node',14.8389),('habitant',8,'node',0.693594),('habitant',15,'node',0.736141),('habitant',26,'node',2),('habitant',37,'node',1),('habitant',48,'node',1),('habitant',53,'node',1),('habitant',58,'node',2),('habitant',60,'node',2),('habitant',61,'node',1),('habitasse',9,'node',20.1115),('habitasse',15,'node',0.784336),('habitasse',26,'node',4),('habitasse',36,'node',1),('habitasse',47,'node',1.49525),('habitasse',54,'node',0.882818),('habitasse',59,'node',1),('habitasse',66,'node',1),('hac',9,'node',20.172),('hac',15,'node',0.786915),('hac',26,'node',4),('hac',36,'node',1),('hac',47,'node',1.49761),('hac',54,'node',0.886095),('hac',59,'node',1),('hac',66,'node',1),('handles',16,'node',0.766757),('handles',68,'node',0.76188),('happy',19,'node',0.498827),('has',16,'node',1),('has',20,'node',0.909743),('has',22,'node',1),('has',68,'node',1),('have',1,'node',1),('have',16,'node',2.83042),('have',19,'node',6.27837),('have',22,'node',1),('have',68,'node',2.28124),('have',69,'node',1),('having',16,'node',1),('having',68,'node',1),('heading',3,'node',56.8022),('heading',4,'node',52.258),('heading',5,'node',52.448),('heading',6,'node',52.448),('heading',7,'node',57.705),('heading',8,'node',26.7153),('heading',9,'node',57.4766),('heading',12,'node',51.882),('heading',17,'node',56.8022),('heading',27,'node',51.882),('heading',28,'node',52.6395),('heading',29,'node',51.6961),('heading',30,'node',51.882),('heading',31,'node',55.642),('heading',47,'node',56.581),('heading',54,'node',56.3615),('heading',55,'node',55.7132),('heading',56,'node',58.4014),('headline',16,'node',26),('headline',68,'node',26),('health',6,'node',8.54373),('healthy',31,'node',26),('help',16,'node',1.22952),('help',22,'node',0.779231),('help',68,'node',1.22328),('hendrerit',2,'node',2.86941),('hendrerit',3,'node',2),('hendrerit',4,'node',2),('hendrerit',5,'node',2),('hendrerit',6,'node',2),('hendrerit',7,'node',5.12702),('hendrerit',8,'node',2.01836),('hendrerit',9,'node',2.82776),('hendrerit',10,'node',2),('hendrerit',11,'node',2),('hendrerit',12,'node',2.72942),('hendrerit',13,'node',1),('hendrerit',15,'node',1.71377),('hendrerit',17,'node',2),('hendrerit',26,'node',2),('hendrerit',27,'node',2),('hendrerit',28,'node',2),('hendrerit',29,'node',2),('hendrerit',30,'node',2),('hendrerit',31,'node',3.56881),('hendrerit',33,'node',2),('hendrerit',34,'node',0.808176),('hendrerit',35,'node',1),('hendrerit',36,'node',1),('hendrerit',37,'node',2),('hendrerit',38,'node',0.816452),('hendrerit',39,'node',4.98344),('hendrerit',42,'node',2.96109),('hendrerit',43,'node',2.96109),('hendrerit',44,'node',2.96109),('hendrerit',45,'node',2.96109),('hendrerit',46,'node',2.96109),('hendrerit',47,'node',1.99731),('hendrerit',48,'node',2),('hendrerit',49,'node',1),('hendrerit',50,'node',1),('hendrerit',51,'node',2),('hendrerit',52,'node',3),('hendrerit',53,'node',6.45148),('hendrerit',54,'node',2.74783),('hendrerit',55,'node',1.98087),('hendrerit',56,'node',2.82776),('hendrerit',57,'node',2.96109),('hendrerit',58,'node',2),('hendrerit',59,'node',1),('hendrerit',61,'node',1),('hendrerit',62,'node',1),('hendrerit',64,'node',2),('hendrerit',65,'node',2),('hendrerit',67,'node',1),('here',19,'node',0.517983),('here',29,'node',26),('here',37,'node',26),('hiawatha',21,'node',39.8356),('high',21,'node',1),('higher',20,'node',8.56376),('higher',22,'node',8.19945),('highlight',23,'node',30),('himenaeos',7,'node',0.585658),('himenaeos',8,'node',1),('himenaeos',34,'node',1),('himenaeos',38,'node',1),('himenaeos',53,'node',0.630018),('history',16,'node',1.35358),('history',68,'node',0.808176),('hit',19,'node',0.76188),('hitting',19,'node',0.615536),('home',19,'node',4.99858),('homepage',15,'node',1),('hope',16,'node',0.621888),('hope',68,'node',0.618696),('host',19,'node',2.54733),('host',22,'node',1),('hosted',21,'node',2),('hostel',10,'node',26),('hosting',18,'node',40),('hosting',19,'node',32.5846),('hosting',20,'node',2),('hosting',22,'node',3.69289),('hostmonster',19,'node',4.36216),('hosts',20,'node',11),('hot',19,'node',0.569105),('hotel',6,'node',26),('hours',3,'node',0.827757),('hours',15,'node',1.82206),('hours',53,'node',4.81909),('hours',54,'node',0.779231),('hours',55,'node',0.668514),('hours',56,'node',0.857458),('how',5,'node',26),('how',10,'node',26),('how',18,'node',2),('how',19,'node',0.884501),('how',29,'node',26),('however',16,'node',0.693594),('however',20,'node',1),('however',68,'node',0.689612),('htaccess',21,'node',1),('htdocs',19,'node',3.5843),('http',19,'node',7.0973),('http',25,'node',1),('http',69,'node',11),('https',16,'node',11),('https',19,'node',8.77039),('https',25,'node',1),('https',68,'node',11),('hymenaeos',10,'node',0.879565),('hymenaeos',11,'node',2),('hymenaeos',14,'node',1),('iaculis',7,'node',3.75703),('iaculis',8,'node',1.53997),('iaculis',10,'node',1.85135),('iaculis',13,'node',3),('iaculis',14,'node',2),('iaculis',15,'node',2.93105),('iaculis',28,'node',0.759465),('iaculis',31,'node',0.738408),('iaculis',34,'node',1.65714),('iaculis',35,'node',0.989021),('iaculis',36,'node',1),('iaculis',37,'node',0.830633),('iaculis',38,'node',1.67457),('iaculis',47,'node',1.70697),('iaculis',48,'node',1),('iaculis',50,'node',1),('iaculis',51,'node',1),('iaculis',52,'node',1),('iaculis',53,'node',2.27298),('iaculis',55,'node',2.1293),('iaculis',58,'node',1),('iaculis',59,'node',1),('iaculis',61,'node',1),('iaculis',62,'node',1),('iaculis',63,'node',28),('id',1,'node',0.886095),('id',2,'node',1),('id',3,'node',5.54436),('id',4,'node',2.46822),('id',5,'node',3.20844),('id',6,'node',2.47679),('id',7,'node',12.511),('id',8,'node',27.1579),('id',9,'node',5.62013),('id',10,'node',2.63271),('id',11,'node',6),('id',12,'node',3.18068),('id',13,'node',2),('id',14,'node',2),('id',15,'node',1.61208),('id',17,'node',4.76002),('id',26,'node',2),('id',27,'node',2.45126),('id',28,'node',4.77836),('id',29,'node',2.44286),('id',30,'node',3.89042),('id',31,'node',25.7421),('id',33,'node',6),('id',34,'node',7.15127),('id',35,'node',2),('id',37,'node',1.95793),('id',38,'node',7.19502),('id',39,'node',5.95101),('id',40,'node',1),('id',41,'node',1),('id',42,'node',8.34353),('id',43,'node',8.34353),('id',44,'node',8.34353),('id',45,'node',8.34353),('id',46,'node',8.34353),('id',47,'node',4.7494),('id',48,'node',2),('id',49,'node',1),('id',50,'node',1),('id',51,'node',2),('id',52,'node',3),('id',53,'node',15.1762),('id',54,'node',4.73887),('id',55,'node',5.3671),('id',56,'node',5.66736),('id',57,'node',8.35347),('id',60,'node',1),('id',61,'node',1),('id',62,'node',3.99731),('id',63,'node',1),('id',64,'node',1),('id',65,'node',1),('id',66,'node',5),('id',67,'node',6),('idea',1,'node',1),('idea',69,'node',1),('ideas',4,'node',26),('if',1,'node',2),('if',16,'node',0.484898),('if',19,'node',10.2043),('if',20,'node',1),('if',21,'node',0.886095),('if',22,'node',3.8238),('iis',20,'node',1),('iis',21,'node',28.7994),('illo',3,'node',4.73288),('illo',4,'node',2.4038),('illo',5,'node',2.41189),('illo',6,'node',2.41189),('illo',7,'node',4.79235),('illo',8,'node',1.43733),('illo',9,'node',4.7773),('illo',12,'node',2.38778),('illo',17,'node',4.73288),('illo',27,'node',2.38778),('illo',28,'node',2.42004),('illo',29,'node',2.37986),('illo',30,'node',2.38778),('illo',31,'node',3.64057),('illo',40,'node',1),('illo',41,'node',1),('illo',47,'node',4.71831),('illo',54,'node',4.70385),('illo',55,'node',4.66115),('illo',56,'node',4.83673),('illum',2,'node',2.86941),('illum',39,'node',2.97837),('image',23,'node',27),('images',4,'node',8.54373),('img',23,'node',1),('imperdiet',7,'node',0.584241),('imperdiet',8,'node',1.26667),('imperdiet',10,'node',2.86055),('imperdiet',11,'node',0.931053),('imperdiet',15,'node',1.86576),('imperdiet',26,'node',2),('imperdiet',33,'node',1),('imperdiet',35,'node',1),('imperdiet',36,'node',2),('imperdiet',37,'node',2.76564),('imperdiet',39,'node',3.69498),('imperdiet',42,'node',4.62546),('imperdiet',43,'node',4.62546),('imperdiet',44,'node',4.62546),('imperdiet',45,'node',4.62546),('imperdiet',46,'node',4.62546),('imperdiet',47,'node',0.839384),('imperdiet',48,'node',2),('imperdiet',50,'node',1),('imperdiet',53,'node',6.21285),('imperdiet',57,'node',4.63197),('imperdiet',58,'node',1),('imperdiet',59,'node',2),('imperdiet',60,'node',2),('imperdiet',62,'node',0.997306),('imperdiet',64,'node',2),('imperdiet',67,'node',1),('important',16,'node',1.01733),('important',19,'node',2.94456),('improvements',16,'node',0.506102),('in',1,'node',5.79295),('in',2,'node',6.73881),('in',3,'node',6.93332),('in',4,'node',6.42431),('in',5,'node',10.3676),('in',6,'node',6.44515),('in',7,'node',66.4633),('in',8,'node',12.6711),('in',9,'node',70.826),('in',10,'node',1.80854),('in',11,'node',35.1702),('in',12,'node',8.74488),('in',15,'node',9.08619),('in',16,'node',10.3357),('in',17,'node',3.76002),('in',18,'node',2),('in',19,'node',18.7571),('in',20,'node',2),('in',22,'node',2.33467),('in',26,'node',4),('in',27,'node',6.3831),('in',28,'node',7.23786),('in',29,'node',6.36274),('in',30,'node',8.0076),('in',31,'node',28.0624),('in',33,'node',1),('in',34,'node',7.24073),('in',35,'node',1),('in',36,'node',3),('in',37,'node',7.55082),('in',38,'node',7.29912),('in',39,'node',11.4536),('in',40,'node',3),('in',41,'node',3),('in',42,'node',7.62939),('in',43,'node',7.62939),('in',44,'node',7.62939),('in',45,'node',7.62939),('in',46,'node',7.62939),('in',47,'node',8.49322),('in',48,'node',4),('in',49,'node',5),('in',50,'node',1),('in',51,'node',3),('in',52,'node',4),('in',53,'node',21.4363),('in',54,'node',7.0536),('in',55,'node',8.52795),('in',56,'node',6.37069),('in',57,'node',7.63587),('in',59,'node',3),('in',60,'node',2),('in',61,'node',4.99731),('in',62,'node',2),('in',63,'node',2),('in',64,'node',4),('in',65,'node',5),('in',66,'node',3),('in',67,'node',1),('in',68,'node',5.70964),('in',69,'node',1),('inceptos',7,'node',0.587082),('inceptos',8,'node',1),('inceptos',10,'node',0.882818),('inceptos',11,'node',2),('inceptos',14,'node',1),('inceptos',34,'node',1),('inceptos',38,'node',1),('inceptos',53,'node',0.63167),('incidunt',2,'node',1),('includes',16,'node',0.529288),('including',16,'node',1.4528),('including',20,'node',0.866793),('including',68,'node',0.961087),('independent',21,'node',0.989021),('index',22,'node',1),('individuals',16,'node',1.3998),('individuals',68,'node',1.39168),('inevitable',1,'node',1),('inexpensive',22,'node',1.94209),('information',16,'node',1.57404),('information',21,'node',1.93105),('informs',16,'node',0.525844),('innodb',22,'node',2.75277),('innodbcompatible',20,'node',0.961087),('inperson',16,'node',1),('inperson',68,'node',1),('insert',22,'node',1),('inspirational',35,'node',26),('install',19,'node',1),('install',20,'node',1),('installation',19,'node',1.67603),('installation',20,'node',1),('installation',56,'node',26),('installation',68,'node',11),('installation',69,'node',11),('installed',20,'node',1),('installed',22,'node',0.808176),('installing',19,'node',30),('installing',22,'node',1.614),('installing',56,'node',11),('instead',19,'node',2.15644),('instructions',19,'node',10.886),('integer',7,'node',0.617112),('integer',11,'node',2),('integer',31,'node',0.749958),('integer',33,'node',1),('integer',34,'node',0.813674),('integer',35,'node',1),('integer',38,'node',0.822065),('integer',50,'node',1),('integer',53,'node',2.11843),('integer',56,'node',1.66998),('integer',58,'node',1),('integer',67,'node',2),('interdum',4,'node',1),('interdum',5,'node',1),('interdum',6,'node',1),('interdum',7,'node',1.84696),('interdum',8,'node',2.45209),('interdum',10,'node',2),('interdum',11,'node',2),('interdum',12,'node',1),('interdum',26,'node',2),('interdum',27,'node',1),('interdum',28,'node',1.76188),('interdum',29,'node',1),('interdum',30,'node',1),('interdum',31,'node',22.4331),('interdum',34,'node',3.41776),('interdum',38,'node',3.45514),('interdum',42,'node',1.9496),('interdum',43,'node',1.9496),('interdum',44,'node',1.9496),('interdum',45,'node',1.9496),('interdum',46,'node',1.9496),('interdum',48,'node',1),('interdum',49,'node',1),('interdum',51,'node',1),('interdum',52,'node',3),('interdum',53,'node',1.3503),('interdum',57,'node',1.9496),('interdum',59,'node',27),('interdum',61,'node',1),('interdum',62,'node',1),('interdum',64,'node',1),('interdum',66,'node',1),('interdum',67,'node',2),('interested',16,'node',0.670377),('interested',22,'node',0.707906),('interested',68,'node',0.66666),('into',22,'node',0.776703),('introduces',16,'node',0.923838),('introduces',68,'node',0.920273),('inventore',3,'node',4.73288),('inventore',4,'node',2.40082),('inventore',5,'node',2.40889),('inventore',6,'node',2.40889),('inventore',7,'node',4.79235),('inventore',8,'node',1.43512),('inventore',9,'node',4.7773),('inventore',12,'node',2.38485),('inventore',17,'node',4.73288),('inventore',27,'node',2.38485),('inventore',28,'node',2.41701),('inventore',29,'node',2.37694),('inventore',30,'node',2.38485),('inventore',31,'node',3.64057),('inventore',40,'node',1),('inventore',41,'node',1),('inventore',47,'node',4.71831),('inventore',54,'node',4.70385),('inventore',55,'node',4.66115),('inventore',56,'node',4.83673),('invidunt',2,'node',0.98493),('invidunt',39,'node',3.93216),('ipsa',3,'node',4.73288),('ipsa',4,'node',2.41287),('ipsa',5,'node',2.42102),('ipsa',6,'node',2.42102),('ipsa',7,'node',4.79235),('ipsa',8,'node',1.44405),('ipsa',9,'node',4.7773),('ipsa',12,'node',2.39672),('ipsa',17,'node',4.73288),('ipsa',27,'node',2.39672),('ipsa',28,'node',2.42924),('ipsa',29,'node',2.38873),('ipsa',30,'node',2.39672),('ipsa',31,'node',3.64057),('ipsa',40,'node',1),('ipsa',41,'node',1),('ipsa',47,'node',4.71831),('ipsa',54,'node',4.70385),('ipsa',55,'node',4.66115),('ipsa',56,'node',4.83673),('ipsam',3,'node',0.953396),('ipsam',4,'node',0.813674),('ipsam',5,'node',0.816452),('ipsam',6,'node',0.816452),('ipsam',7,'node',0.968904),('ipsam',9,'node',0.96498),('ipsam',12,'node',0.808176),('ipsam',17,'node',0.953396),('ipsam',27,'node',0.808176),('ipsam',28,'node',0.819249),('ipsam',29,'node',0.805455),('ipsam',30,'node',0.808176),('ipsam',31,'node',0.906287),('ipsam',47,'node',0.949597),('ipsam',54,'node',0.945829),('ipsam',55,'node',0.934703),('ipsam',56,'node',0.980874),('ipsum',2,'node',13.4903),('ipsum',3,'node',1.70054),('ipsum',4,'node',3.79212),('ipsum',5,'node',4.5264),('ipsum',6,'node',3.79475),('ipsum',7,'node',8.66864),('ipsum',8,'node',6.22929),('ipsum',9,'node',0.934703),('ipsum',12,'node',3.78691),('ipsum',13,'node',4),('ipsum',15,'node',3.63836),('ipsum',17,'node',0.923838),('ipsum',27,'node',3.78691),('ipsum',28,'node',5.35087),('ipsum',29,'node',3.78434),('ipsum',30,'node',3.78691),('ipsum',31,'node',4.43015),('ipsum',34,'node',3.75584),('ipsum',36,'node',2),('ipsum',37,'node',1.87865),('ipsum',38,'node',3.77561),('ipsum',39,'node',10.5687),('ipsum',42,'node',3.72862),('ipsum',43,'node',3.72862),('ipsum',44,'node',3.72862),('ipsum',45,'node',3.72862),('ipsum',46,'node',3.72862),('ipsum',47,'node',0.920273),('ipsum',48,'node',5),('ipsum',49,'node',2),('ipsum',50,'node',2),('ipsum',53,'node',6.3277),('ipsum',54,'node',0.916736),('ipsum',55,'node',1.56204),('ipsum',56,'node',0.949597),('ipsum',57,'node',3.73527),('ipsum',58,'node',2),('ipsum',60,'node',27),('ipsum',62,'node',1),('ipsum',63,'node',2),('ipsum',65,'node',2),('ipsum',66,'node',1),('ipsum',67,'node',1),('iriure',2,'node',2.86941),('iriure',39,'node',2.986),('irure',40,'node',1),('irure',41,'node',1),('is',1,'node',1),('is',16,'node',10.3681),('is',18,'node',1),('is',19,'node',9.78123),('is',20,'node',1),('is',21,'node',9.72406),('is',22,'node',17.4165),('is',23,'node',20),('is',24,'node',5),('is',27,'node',26),('is',68,'node',8.20601),('is',69,'node',1),('issue',16,'node',0.72066),('issue',20,'node',11),('issue',68,'node',0.716357),('issues',16,'node',1.89419),('issues',22,'node',1.47704),('issues',68,'node',1.3933),('iste',3,'node',5.66031),('iste',4,'node',3.24263),('iste',5,'node',3.25369),('iste',6,'node',3.25369),('iste',7,'node',5.73444),('iste',8,'node',1.46979),('iste',9,'node',5.71569),('iste',12,'node',3.22073),('iste',17,'node',5.66031),('iste',27,'node',3.22073),('iste',28,'node',3.26483),('iste',29,'node',3.20989),('iste',30,'node',3.22073),('iste',31,'node',4.52338),('iste',40,'node',1),('iste',41,'node',1),('iste',47,'node',5.64215),('iste',54,'node',5.62412),('iste',55,'node',5.57089),('iste',56,'node',5.79012),('it',1,'node',14.096),('it',3,'node',8.17041),('it',7,'node',4.04375),('it',15,'node',12.8183),('it',16,'node',7.75693),('it',17,'node',4.38508),('it',18,'node',5),('it',19,'node',7.0512),('it',20,'node',4.09634),('it',21,'node',5.09634),('it',22,'node',7.09923),('it',29,'node',26),('it',47,'node',7.67725),('it',53,'node',37.9945),('it',54,'node',7.6633),('it',55,'node',10.6794),('it',56,'node',8.50119),('it',68,'node',5.31993),('it',69,'node',5),('item',23,'node',30),('item',26,'node',48),('items',19,'node',0.685676),('its',16,'node',0.752312),('its',68,'node',0.747619),('iure',39,'node',2.2154),('iusto',2,'node',1),('iusto',39,'node',1.50559),('jack',7,'node',0.727213),('jack',8,'node',0.640063),('joined',1,'node',1.92384),('joined',3,'node',0.822065),('joined',15,'node',1.82206),('joined',16,'node',0.574516),('joined',47,'node',0.759465),('joined',53,'node',6.86584),('joined',54,'node',0.774192),('joined',55,'node',1.41897),('joined',56,'node',0.845322),('juans',37,'node',26),('jul',12,'node',0.757065),('just',16,'node',0.516879),('just',19,'node',0.521322),('justo',1,'node',0.863659),('justo',2,'node',2.86941),('justo',4,'node',1.98493),('justo',5,'node',1.98902),('justo',6,'node',1.98902),('justo',8,'node',2.8861),('justo',9,'node',0.889397),('justo',10,'node',4),('justo',11,'node',2.80796),('justo',12,'node',1.97685),('justo',13,'node',1),('justo',15,'node',1.76676),('justo',27,'node',1.97685),('justo',28,'node',2.75746),('justo',29,'node',1.97286),('justo',30,'node',2.68896),('justo',31,'node',21.5024),('justo',33,'node',1),('justo',34,'node',5.324),('justo',35,'node',3),('justo',37,'node',1.89608),('justo',38,'node',5.35912),('justo',39,'node',7.32786),('justo',42,'node',2.83036),('justo',43,'node',2.83036),('justo',44,'node',2.83036),('justo',45,'node',2.83036),('justo',46,'node',2.83036),('justo',47,'node',2.50375),('justo',48,'node',1),('justo',51,'node',1),('justo',53,'node',4.37135),('justo',55,'node',1.32051),('justo',57,'node',2.83356),('justo',61,'node',1),('justo',62,'node',1),('justo',64,'node',3),('justo',65,'node',1),('kasd',2,'node',7.73881),('kasd',39,'node',6.37449),('keep',20,'node',1),('key',16,'node',1),('key',68,'node',1),('knowledge',16,'node',0.661163),('knowledge',19,'node',1),('knowledge',68,'node',0.657549),('known',16,'node',0.49376),('la',19,'node',0.689612),('labore',2,'node',1.98087),('labore',39,'node',3.929),('laboris',2,'node',0.927431),('laborum',2,'node',1),('laborum',3,'node',3.76002),('laborum',4,'node',2.46134),('laborum',5,'node',2.46985),('laborum',6,'node',2.46985),('laborum',7,'node',3.80333),('laborum',8,'node',1.4796),('laborum',9,'node',3.79237),('laborum',12,'node',2.44448),('laborum',17,'node',3.76002),('laborum',27,'node',2.44448),('laborum',28,'node',2.47843),('laborum',29,'node',2.43614),('laborum',30,'node',2.44448),('laborum',31,'node',2.64408),('laborum',39,'node',2.2599),('laborum',40,'node',1),('laborum',41,'node',1),('laborum',47,'node',3.7494),('laborum',54,'node',3.73887),('laborum',55,'node',3.70775),('laborum',56,'node',3.83673),('lacinia',5,'node',0.716357),('lacinia',8,'node',0.836446),('lacinia',11,'node',2),('lacinia',15,'node',0.892724),('lacinia',33,'node',1),('lacinia',34,'node',0.848323),('lacinia',36,'node',1),('lacinia',37,'node',1),('lacinia',38,'node',0.857458),('lacinia',39,'node',1),('lacinia',42,'node',2),('lacinia',43,'node',2),('lacinia',44,'node',2),('lacinia',45,'node',2),('lacinia',46,'node',2),('lacinia',49,'node',1),('lacinia',51,'node',1),('lacinia',53,'node',1.28124),('lacinia',55,'node',0.646943),('lacinia',57,'node',2),('lacinia',59,'node',3),('lacinia',66,'node',1),('lacinia',67,'node',1),('lack',16,'node',0.961087),('lack',68,'node',0.957226),('lacus',4,'node',5),('lacus',5,'node',5),('lacus',6,'node',5),('lacus',7,'node',8.20124),('lacus',8,'node',4.9264),('lacus',10,'node',4.48823),('lacus',11,'node',6),('lacus',12,'node',5),('lacus',13,'node',6),('lacus',15,'node',1.63559),('lacus',26,'node',2),('lacus',27,'node',5),('lacus',28,'node',6.53607),('lacus',29,'node',5),('lacus',30,'node',5),('lacus',31,'node',5.83938),('lacus',33,'node',2),('lacus',34,'node',5.259),('lacus',37,'node',2.82776),('lacus',38,'node',5.29267),('lacus',39,'node',2),('lacus',42,'node',3.79025),('lacus',43,'node',3.79025),('lacus',44,'node',3.79025),('lacus',45,'node',3.79025),('lacus',46,'node',3.79025),('lacus',48,'node',1),('lacus',49,'node',1),('lacus',50,'node',1),('lacus',51,'node',1),('lacus',52,'node',3),('lacus',53,'node',7.53821),('lacus',55,'node',2.07416),('lacus',57,'node',3.7935),('lacus',60,'node',1),('lacus',61,'node',1),('lacus',62,'node',2),('lacus',65,'node',1),('lacus',67,'node',1),('laoreet',2,'node',1.88053),('laoreet',4,'node',0.980874),('laoreet',5,'node',0.98493),('laoreet',6,'node',0.98493),('laoreet',7,'node',2.57313),('laoreet',8,'node',2.36201),('laoreet',9,'node',0.854391),('laoreet',10,'node',1.87634),('laoreet',12,'node',1.70007),('laoreet',13,'node',1),('laoreet',14,'node',1),('laoreet',26,'node',2),('laoreet',27,'node',0.972861),('laoreet',28,'node',0.989021),('laoreet',29,'node',0.968904),('laoreet',30,'node',0.972861),('laoreet',31,'node',0.827757),('laoreet',34,'node',2.52924),('laoreet',35,'node',1),('laoreet',36,'node',2),('laoreet',37,'node',0.879565),('laoreet',38,'node',2.55635),('laoreet',39,'node',1),('laoreet',42,'node',2.6795),('laoreet',43,'node',2.6795),('laoreet',44,'node',2.6795),('laoreet',45,'node',2.6795),('laoreet',46,'node',2.6795),('laoreet',53,'node',0.810915),('laoreet',55,'node',1.28036),('laoreet',57,'node',2.68601),('laoreet',58,'node',1),('laoreet',60,'node',1),('last',1,'node',1.92384),('last',3,'node',0.839384),('last',15,'node',1.8249),('last',16,'node',0.582831),('last',47,'node',0.774192),('last',53,'node',6.89244),('last',54,'node',0.78951),('last',55,'node',1.43901),('last',56,'node',0.866793),('later',19,'node',1.28447),('later',20,'node',0.896076),('later',21,'node',0.839384),('laudantium',3,'node',4.73288),('laudantium',4,'node',2.42843),('laudantium',5,'node',2.4367),('laudantium',6,'node',2.4367),('laudantium',7,'node',4.79235),('laudantium',8,'node',1.45552),('laudantium',9,'node',4.7773),('laudantium',12,'node',2.41206),('laudantium',17,'node',4.73288),('laudantium',27,'node',2.41206),('laudantium',28,'node',2.44503),('laudantium',29,'node',2.40396),('laudantium',30,'node',2.41206),('laudantium',31,'node',3.64057),('laudantium',40,'node',1),('laudantium',41,'node',1),('laudantium',47,'node',4.71831),('laudantium',54,'node',4.70385),('laudantium',55,'node',4.66115),('laudantium',56,'node',4.83673),('launches',47,'node',26),('lead',16,'node',0.492759),('leadership',16,'node',0.648686),('leadership',68,'node',0.645209),('learn',1,'node',26),('learn',18,'node',2),('learn',19,'node',1.78346),('learn',69,'node',26),('learning',1,'node',2),('learning',19,'node',0.509287),('learning',69,'node',2),('least',16,'node',0.830633),('least',22,'node',0.949597),('least',68,'node',0.824901),('leaving',16,'node',0.638366),('leaving',68,'node',0.635),('lectus',1,'node',0.906287),('lectus',3,'node',1.75946),('lectus',7,'node',1),('lectus',8,'node',2.48623),('lectus',9,'node',1),('lectus',17,'node',1),('lectus',29,'node',0.769219),('lectus',31,'node',2.21553),('lectus',34,'node',2.52119),('lectus',35,'node',0.957226),('lectus',37,'node',0.927431),('lectus',38,'node',2.54808),('lectus',42,'node',7.72269),('lectus',43,'node',7.72269),('lectus',44,'node',7.72269),('lectus',45,'node',7.72269),('lectus',46,'node',7.72269),('lectus',47,'node',1),('lectus',48,'node',0.961087),('lectus',49,'node',1),('lectus',53,'node',1.87838),('lectus',54,'node',1),('lectus',55,'node',1),('lectus',56,'node',1),('lectus',57,'node',7.72915),('lectus',59,'node',26),('lectus',62,'node',1),('lectus',65,'node',1),('lectus',66,'node',1),('lectus',67,'node',2),('left',24,'node',3),('legacy',19,'node',0.592848),('legacy',21,'node',1),('leo',4,'node',5),('leo',5,'node',5),('leo',6,'node',5),('leo',7,'node',21.3165),('leo',8,'node',4.63298),('leo',10,'node',4.74308),('leo',12,'node',5),('leo',13,'node',1),('leo',14,'node',2),('leo',15,'node',2.43567),('leo',26,'node',4),('leo',27,'node',5),('leo',28,'node',5.7717),('leo',29,'node',5),('leo',30,'node',5),('leo',31,'node',5),('leo',33,'node',1),('leo',34,'node',6.26652),('leo',36,'node',1),('leo',37,'node',3.75267),('leo',38,'node',6.30034),('leo',39,'node',2),('leo',42,'node',1.91323),('leo',43,'node',1.91323),('leo',44,'node',1.91323),('leo',45,'node',1.91323),('leo',46,'node',1.91323),('leo',48,'node',2),('leo',50,'node',2),('leo',53,'node',2.91735),('leo',54,'node',0.866793),('leo',55,'node',2.81459),('leo',57,'node',1.91323),('leo',58,'node',3),('leo',59,'node',1),('leo',60,'node',2),('leo',61,'node',1.98493),('leo',62,'node',1),('leo',63,'node',1),('leo',64,'node',2),('leo',65,'node',2),('leo',67,'node',1),('let',19,'node',0.464545),('level',16,'node',0.668514),('level',68,'node',0.664818),('liber',39,'node',1.71882),('libero',1,'node',0.845322),('libero',3,'node',1.97286),('libero',4,'node',0.98493),('libero',5,'node',0.989021),('libero',6,'node',0.989021),('libero',7,'node',6.4053),('libero',8,'node',24.5972),('libero',9,'node',2.70776),('libero',10,'node',5.84832),('libero',11,'node',2),('libero',12,'node',0.976851),('libero',13,'node',3),('libero',14,'node',2),('libero',15,'node',1.5348),('libero',17,'node',1.97286),('libero',27,'node',0.976851),('libero',28,'node',0.993146),('libero',29,'node',1.74208),('libero',30,'node',1.69535),('libero',31,'node',2.25014),('libero',34,'node',3.41846),('libero',36,'node',1),('libero',37,'node',5.81608),('libero',38,'node',3.4556),('libero',39,'node',1),('libero',42,'node',4.50054),('libero',43,'node',4.50054),('libero',44,'node',4.50054),('libero',45,'node',4.50054),('libero',46,'node',4.50054),('libero',47,'node',3.56334),('libero',48,'node',3),('libero',49,'node',1),('libero',50,'node',2),('libero',51,'node',1),('libero',52,'node',2),('libero',53,'node',6.2671),('libero',54,'node',2.81363),('libero',55,'node',6.41166),('libero',56,'node',2.81092),('libero',57,'node',4.51035),('libero',58,'node',3),('libero',59,'node',3),('libero',60,'node',1),('libero',61,'node',1.96498),('libero',62,'node',2.98493),('libero',63,'node',2),('libero',64,'node',3),('libero',65,'node',1),('libero',66,'node',2),('libero',67,'node',3),('light',35,'node',26),('lightweight',21,'node',1),('ligula',3,'node',2.79212),('ligula',4,'node',2),('ligula',5,'node',2),('ligula',6,'node',2),('ligula',7,'node',23.4889),('ligula',8,'node',4.69715),('ligula',9,'node',5.70436),('ligula',10,'node',6),('ligula',11,'node',1.69673),('ligula',12,'node',2),('ligula',13,'node',2),('ligula',15,'node',5.3453),('ligula',17,'node',2),('ligula',26,'node',2),('ligula',27,'node',2),('ligula',28,'node',2),('ligula',29,'node',2.76188),('ligula',30,'node',2),('ligula',31,'node',4.19765),('ligula',33,'node',1),('ligula',34,'node',1.99315),('ligula',35,'node',1),('ligula',37,'node',3),('ligula',38,'node',2),('ligula',39,'node',2),('ligula',42,'node',1.90299),('ligula',43,'node',1.90299),('ligula',44,'node',1.90299),('ligula',45,'node',1.90299),('ligula',46,'node',1.90299),('ligula',47,'node',2),('ligula',48,'node',1),('ligula',49,'node',3),('ligula',50,'node',2),('ligula',51,'node',3),('ligula',52,'node',2),('ligula',53,'node',2.86276),('ligula',54,'node',2),('ligula',55,'node',2.65576),('ligula',56,'node',2),('ligula',57,'node',1.90299),('ligula',58,'node',1),('ligula',59,'node',1),('ligula',60,'node',1),('ligula',61,'node',1.98493),('ligula',62,'node',3),('ligula',63,'node',3),('ligula',64,'node',2),('ligula',65,'node',1),('like',19,'node',0.915154),('like',22,'node',1.48411),('likely',16,'node',0.810915),('likely',21,'node',1),('likely',22,'node',1.82776),('likely',68,'node',0.805455),('limited',16,'node',0.62674),('limited',68,'node',0.623497),('line',19,'node',1.71949),('lines',19,'node',0.584241),('link',19,'node',0.537506),('linux',19,'node',1.49255),('linux',21,'node',2),('list',16,'node',2.07427),('list',19,'node',2.81595),('listed',18,'node',3),('listing',16,'node',0.557303),('litora',7,'node',0.594307),('litora',8,'node',1),('litora',10,'node',0.899454),('litora',11,'node',2),('litora',14,'node',1),('litora',34,'node',1),('litora',38,'node',1),('litora',53,'node',0.640063),('litora',54,'node',0.72066),('little',19,'node',1.26611),('live',19,'node',0.506102),('living',4,'node',26),('ll',19,'node',0.545988),('loads',16,'node',0.486839),('lobortis',2,'node',1.91323),('lobortis',3,'node',1),('lobortis',4,'node',4),('lobortis',5,'node',4),('lobortis',6,'node',4),('lobortis',7,'node',1),('lobortis',8,'node',1.90029),('lobortis',9,'node',1.86366),('lobortis',12,'node',4),('lobortis',13,'node',1),('lobortis',15,'node',1.80007),('lobortis',17,'node',1),('lobortis',27,'node',4),('lobortis',28,'node',4),('lobortis',29,'node',4),('lobortis',30,'node',4),('lobortis',31,'node',2),('lobortis',33,'node',1),('lobortis',34,'node',1.93111),('lobortis',35,'node',1),('lobortis',36,'node',1),('lobortis',37,'node',1.8249),('lobortis',38,'node',1.9534),('lobortis',39,'node',5.8247),('lobortis',42,'node',1),('lobortis',43,'node',1),('lobortis',44,'node',1),('lobortis',45,'node',1),('lobortis',46,'node',1),('lobortis',47,'node',1),('lobortis',49,'node',1),('lobortis',50,'node',3),('lobortis',52,'node',1),('lobortis',53,'node',4.01041),('lobortis',54,'node',1),('lobortis',55,'node',3.02964),('lobortis',56,'node',1),('lobortis',57,'node',1),('lobortis',60,'node',1),('lobortis',62,'node',1),('lobortis',63,'node',1),('lobortis',65,'node',1),('lobortis',66,'node',3),('lobortis',67,'node',1),('local',19,'node',1.68761),('locate',19,'node',1.2243),('located',19,'node',0.916736),('lock',22,'node',0.980874),('log',1,'node',3.93765),('log',3,'node',1.64476),('log',5,'node',3.22589),('log',7,'node',14.0855),('log',8,'node',5.59978),('log',9,'node',4.81341),('log',10,'node',1.81478),('log',11,'node',3.81155),('log',12,'node',1.63965),('log',16,'node',1.54995),('log',19,'node',0.604732),('log',30,'node',1.62952),('log',31,'node',4.85762),('log',37,'node',1.79008),('log',47,'node',1.5807),('log',53,'node',14.7233),('log',54,'node',1.54374),('log',55,'node',2.8853),('log',56,'node',1.73692),('login',19,'node',3.08466),('logo',23,'node',1),('logopng',23,'node',1),('long',16,'node',0.655756),('long',19,'node',0.470829),('long',35,'node',26),('long',68,'node',0.652202),('longer',19,'node',0.78951),('longer',22,'node',0.873132),('loops',19,'node',0.495774),('lorem',1,'node',0.913226),('lorem',2,'node',13.4903),('lorem',4,'node',1),('lorem',5,'node',2.4034),('lorem',6,'node',1),('lorem',7,'node',1.32294),('lorem',8,'node',4.35096),('lorem',9,'node',0.827757),('lorem',11,'node',2),('lorem',12,'node',1.72673),('lorem',14,'node',2),('lorem',15,'node',3.26073),('lorem',26,'node',2),('lorem',27,'node',0.997306),('lorem',28,'node',1.7717),('lorem',29,'node',0.993146),('lorem',30,'node',0.997306),('lorem',33,'node',2),('lorem',34,'node',4.5428),('lorem',37,'node',2),('lorem',38,'node',4.57023),('lorem',39,'node',12.5687),('lorem',42,'node',0.902857),('lorem',43,'node',0.902857),('lorem',44,'node',0.902857),('lorem',45,'node',0.902857),('lorem',46,'node',0.902857),('lorem',48,'node',1),('lorem',49,'node',1),('lorem',50,'node',1),('lorem',51,'node',1),('lorem',52,'node',1),('lorem',53,'node',2.89144),('lorem',55,'node',1.34797),('lorem',57,'node',1.90286),('lorem',60,'node',29),('lorem',61,'node',2),('lorem',65,'node',2),('lot',19,'node',0.544759),('low',21,'node',1),('low',22,'node',0.931053),('ls',19,'node',2.28153),('luctus',3,'node',1.53116),('luctus',7,'node',1.35677),('luctus',8,'node',2.44662),('luctus',9,'node',0.833529),('luctus',11,'node',2),('luctus',12,'node',0.731649),('luctus',28,'node',0.771698),('luctus',30,'node',0.716357),('luctus',31,'node',1.40811),('luctus',33,'node',2),('luctus',34,'node',2.48045),('luctus',37,'node',0.961087),('luctus',38,'node',2.50646),('luctus',42,'node',2.85486),('luctus',43,'node',2.85486),('luctus',44,'node',2.85486),('luctus',45,'node',2.85486),('luctus',46,'node',2.85486),('luctus',48,'node',1),('luctus',49,'node',1),('luctus',52,'node',1),('luctus',53,'node',1.23426),('luctus',57,'node',2.85486),('luctus',62,'node',1),('luptatum',2,'node',1),('luptatum',39,'node',1.4982),('luxury',6,'node',26),('macbook',3,'node',26),('made',16,'node',1.00854),('maecenas',3,'node',1),('maecenas',5,'node',0.714225),('maecenas',7,'node',4.86348),('maecenas',8,'node',1.33709),('maecenas',9,'node',1),('maecenas',10,'node',1),('maecenas',11,'node',6),('maecenas',13,'node',1),('maecenas',14,'node',1),('maecenas',15,'node',0.742984),('maecenas',17,'node',1),('maecenas',26,'node',2),('maecenas',31,'node',0.839384),('maecenas',35,'node',2.96498),('maecenas',36,'node',1),('maecenas',37,'node',2.92114),('maecenas',47,'node',1.72942),('maecenas',48,'node',1),('maecenas',53,'node',6.01441),('maecenas',54,'node',1),('maecenas',55,'node',1),('maecenas',56,'node',1),('maecenas',58,'node',2),('maecenas',60,'node',1),('maecenas',61,'node',1),('maecenas',64,'node',1),('maecenas',65,'node',1),('maecenas',66,'node',1),('maecenas',67,'node',1),('magna',2,'node',3.85767),('magna',3,'node',1),('magna',4,'node',1),('magna',5,'node',20.3974),('magna',6,'node',1),('magna',7,'node',1.58283),('magna',8,'node',2.3306),('magna',9,'node',1.89608),('magna',10,'node',2),('magna',12,'node',1.72721),('magna',13,'node',1),('magna',15,'node',2),('magna',17,'node',1),('magna',27,'node',1),('magna',28,'node',1),('magna',29,'node',1),('magna',30,'node',1),('magna',31,'node',1),('magna',34,'node',1.7974),('magna',35,'node',1),('magna',36,'node',2),('magna',37,'node',2.78547),('magna',38,'node',1.80545),('magna',39,'node',4.91902),('magna',42,'node',2.8034),('magna',43,'node',2.8034),('magna',44,'node',2.8034),('magna',45,'node',2.8034),('magna',46,'node',2.8034),('magna',47,'node',1.72942),('magna',49,'node',2),('magna',50,'node',1),('magna',51,'node',1),('magna',52,'node',1),('magna',54,'node',1.85135),('magna',55,'node',3.88168),('magna',56,'node',1),('magna',57,'node',2.80666),('magna',58,'node',1),('magna',59,'node',1),('magna',60,'node',2),('magna',62,'node',1),('magna',63,'node',1),('magna',64,'node',3),('magna',65,'node',3),('magna',66,'node',1),('magna',67,'node',1),('magnis',7,'node',0.636679),('magnis',10,'node',1),('magnis',53,'node',0.784336),('magnis',65,'node',1),('magnis',66,'node',1),('mailing',16,'node',0.542319),('main',15,'node',1),('mainline',21,'node',1),('maintain',1,'node',1),('maintain',16,'node',2.27489),('maintain',68,'node',2.26817),('maintained',16,'node',0.519091),('maintainers',16,'node',2),('maintainers',68,'node',2),('maintenance',15,'node',1),('maintenance',16,'node',1.08489),('major',16,'node',1.55222),('major',68,'node',1),('majority',16,'node',0.913226),('majority',21,'node',1),('majority',68,'node',0.909743),('make',19,'node',4.85439),('makes',3,'node',0.754681),('makes',7,'node',2.42334),('makes',15,'node',0.725015),('makes',22,'node',1),('makes',36,'node',26),('makes',53,'node',2.5677),('makes',54,'node',0.707906),('makes',55,'node',0.625114),('making',19,'node',0.558589),('malesuada',4,'node',1),('malesuada',5,'node',2.45897),('malesuada',6,'node',1),('malesuada',7,'node',2.5368),('malesuada',8,'node',3.31403),('malesuada',10,'node',0.873132),('malesuada',11,'node',0.923838),('malesuada',12,'node',1.72502),('malesuada',13,'node',1),('malesuada',14,'node',1),('malesuada',15,'node',3.18588),('malesuada',26,'node',2),('malesuada',27,'node',1),('malesuada',28,'node',1),('malesuada',29,'node',1),('malesuada',30,'node',1),('malesuada',33,'node',3),('malesuada',34,'node',4.25786),('malesuada',37,'node',3.87364),('malesuada',38,'node',4.3042),('malesuada',48,'node',1),('malesuada',52,'node',1),('malesuada',53,'node',2.55659),('malesuada',54,'node',0.848323),('malesuada',58,'node',2),('malesuada',60,'node',3),('malesuada',61,'node',2),('malesuada',63,'node',1),('malesuada',64,'node',1),('malesuada',66,'node',29),('malesuada',67,'node',2),('managed',18,'node',1),('management',53,'node',26),('manager',16,'node',1.01975),('manager',19,'node',0.714225),('manual',16,'node',0.938382),('manual',68,'node',0.934703),('manually',19,'node',0.72066),('many',16,'node',0.972861),('many',20,'node',1),('many',68,'node',0.968904),('margaret',34,'node',26),('mariadb',20,'node',0.976851),('mariadb',22,'node',22),('marked',16,'node',2),('marked',68,'node',2),('marketplace',18,'node',3),('mass',1,'node',1),('massa',4,'node',1),('massa',5,'node',1),('massa',6,'node',1),('massa',7,'node',1.35567),('massa',8,'node',2.74152),('massa',9,'node',0.848323),('massa',10,'node',2),('massa',11,'node',2),('massa',12,'node',1),('massa',13,'node',1),('massa',14,'node',27),('massa',27,'node',1),('massa',28,'node',1),('massa',29,'node',1),('massa',30,'node',1),('massa',31,'node',1.59508),('massa',33,'node',1),('massa',34,'node',3.56925),('massa',35,'node',2.9534),('massa',38,'node',3.59737),('massa',39,'node',1),('massa',42,'node',0.997306),('massa',43,'node',0.997306),('massa',44,'node',0.997306),('massa',45,'node',0.997306),('massa',46,'node',0.997306),('massa',53,'node',0.923838),('massa',55,'node',0.643484),('massa',57,'node',0.997306),('massa',60,'node',1),('massa',66,'node',1),('massa',67,'node',1),('mattis',5,'node',0.729424),('mattis',7,'node',37.2524),('mattis',8,'node',0.827757),('mattis',10,'node',1),('mattis',11,'node',2),('mattis',31,'node',0.742984),('mattis',33,'node',1),('mattis',34,'node',1.64214),('mattis',37,'node',1),('mattis',38,'node',1.65924),('mattis',42,'node',3.87313),('mattis',43,'node',3.87313),('mattis',44,'node',3.87313),('mattis',45,'node',3.87313),('mattis',46,'node',3.87313),('mattis',51,'node',1),('mattis',53,'node',2.30144),('mattis',55,'node',0.63167),('mattis',57,'node',3.87634),('mattis',58,'node',1),('mattis',59,'node',1),('mattis',61,'node',1),('mattis',65,'node',1),('mattis',67,'node',2),('mauris',1,'node',0.854391),('mauris',4,'node',1),('mauris',5,'node',1),('mauris',6,'node',1),('mauris',7,'node',1.33279),('mauris',8,'node',3.00861),('mauris',9,'node',2.93542),('mauris',10,'node',2.92027),('mauris',11,'node',4.84234),('mauris',12,'node',1),('mauris',13,'node',1),('mauris',14,'node',1),('mauris',15,'node',2.35812),('mauris',27,'node',1),('mauris',28,'node',1),('mauris',29,'node',1),('mauris',30,'node',1),('mauris',31,'node',1.73614),('mauris',33,'node',4.99731),('mauris',34,'node',2.62459),('mauris',35,'node',1),('mauris',36,'node',2),('mauris',37,'node',2.89608),('mauris',38,'node',2.64131),('mauris',39,'node',1),('mauris',42,'node',2.87957),('mauris',43,'node',2.87957),('mauris',44,'node',2.87957),('mauris',45,'node',2.87957),('mauris',46,'node',2.87957),('mauris',47,'node',1.69743),('mauris',49,'node',1),('mauris',51,'node',3),('mauris',53,'node',11.0266),('mauris',54,'node',0.76431),('mauris',57,'node',2.88282),('mauris',58,'node',1),('mauris',59,'node',2),('mauris',61,'node',0.972861),('mauris',62,'node',2),('mauris',63,'node',1),('mauris',64,'node',2),('mauris',65,'node',2),('mauris',66,'node',1),('mauris',67,'node',2),('maxallowedpacket',22,'node',0.957226),('may',16,'node',1.17648),('may',18,'node',1),('may',19,'node',1.72721),('may',20,'node',0.892724),('may',21,'node',0.873132),('may',22,'node',3.78267),('may',68,'node',0.679856),('mazim',39,'node',1.68728),('mb',20,'node',1),('mean',19,'node',0.476356),('means',16,'node',1),('means',68,'node',1),('meantime',19,'node',1),('media',20,'node',1),('meet',20,'node',2),('mega',39,'node',26),('megabytes',20,'node',1),('members',16,'node',0.685676),('members',68,'node',0.681785),('memory',20,'node',9.50024),('memory',21,'node',1),('menu',39,'node',26),('mess',19,'node',0.502958),('message',19,'node',1),('met',16,'node',1),('met',68,'node',1),('method',16,'node',0.733888),('method',19,'node',1),('method',68,'node',0.729424),('metus',3,'node',1.75707),('metus',4,'node',1),('metus',5,'node',1.73389),('metus',6,'node',1),('metus',7,'node',24.2311),('metus',8,'node',21.1511),('metus',9,'node',1),('metus',10,'node',28.923),('metus',11,'node',30.7868),('metus',12,'node',1),('metus',13,'node',6),('metus',14,'node',2),('metus',15,'node',1),('metus',17,'node',1),('metus',26,'node',2),('metus',27,'node',1),('metus',28,'node',2.51175),('metus',29,'node',1),('metus',30,'node',1.7185),('metus',31,'node',3.15943),('metus',33,'node',0.993146),('metus',34,'node',1.83353),('metus',35,'node',0.972861),('metus',37,'node',2.73061),('metus',38,'node',1.84234),('metus',42,'node',3.66443),('metus',43,'node',3.66443),('metus',44,'node',3.66443),('metus',45,'node',3.66443),('metus',46,'node',3.66443),('metus',47,'node',1.73389),('metus',48,'node',1),('metus',49,'node',2),('metus',50,'node',1),('metus',51,'node',3),('metus',52,'node',2),('metus',53,'node',10.377),('metus',54,'node',1),('metus',55,'node',5.2094),('metus',56,'node',1),('metus',57,'node',3.67094),('metus',58,'node',3),('metus',59,'node',1),('metus',60,'node',4),('metus',61,'node',2),('metus',62,'node',2),('metus',63,'node',2),('metus',64,'node',1),('metus',66,'node',2),('metus',67,'node',3),('mi',3,'node',0.980874),('mi',4,'node',4),('mi',5,'node',4),('mi',6,'node',4),('mi',7,'node',4.19892),('mi',8,'node',2.51433),('mi',9,'node',0.993146),('mi',10,'node',3),('mi',11,'node',2),('mi',12,'node',4),('mi',13,'node',4),('mi',14,'node',2),('mi',15,'node',2),('mi',17,'node',0.980874),('mi',27,'node',4),('mi',28,'node',4),('mi',29,'node',4),('mi',30,'node',25.2567),('mi',31,'node',23.0363),('mi',33,'node',1),('mi',34,'node',3.52),('mi',35,'node',1),('mi',37,'node',7.70973),('mi',38,'node',3.55957),('mi',42,'node',1.82916),('mi',43,'node',1.82916),('mi',44,'node',1.82916),('mi',45,'node',1.82916),('mi',46,'node',1.82916),('mi',47,'node',0.976851),('mi',48,'node',5),('mi',50,'node',1),('mi',51,'node',2),('mi',52,'node',4),('mi',53,'node',1.85143),('mi',54,'node',2.69416),('mi',55,'node',1.81548),('mi',56,'node',1),('mi',57,'node',1.83242),('mi',59,'node',1),('mi',61,'node',2.99731),('mi',62,'node',4),('mi',63,'node',2),('mical',3,'node',0.845322),('mical',7,'node',2.48602),('mical',15,'node',0.827757),('mical',53,'node',2.61756),('mical',54,'node',0.794753),('mical',55,'node',0.676032),('microsoft',20,'node',11.4041),('microsoft',21,'node',26.2375),('microsoft',22,'node',7.99934),('might',19,'node',0.543537),('might',22,'node',0.805455),('migrate',16,'node',1.57646),('migrate',68,'node',1.56615),('migration',16,'node',0.771698),('migration',68,'node',0.766757),('migrations',16,'node',0.742984),('migrations',68,'node',0.738408),('min',1,'node',1.92384),('min',16,'node',0.580033),('min',47,'node',0.769219),('min',53,'node',2.0594),('min',55,'node',0.76188),('min',56,'node',0.851346),('mind',20,'node',1),('minim',2,'node',2.84793),('minim',39,'node',3.84252),('minimum',20,'node',2),('modrewrite',21,'node',1),('module',16,'node',3.79783),('module',21,'node',0.854391),('module',68,'node',2.77419),('modules',1,'node',1),('modules',16,'node',2.29664),('modules',20,'node',1.93105),('modules',21,'node',0.896076),('modules',22,'node',4.68528),('modules',68,'node',1.76922),('molestie',2,'node',2.86941),('molestie',7,'node',1.29934),('molestie',8,'node',0.687638),('molestie',14,'node',1),('molestie',15,'node',1.58975),('molestie',28,'node',0.776703),('molestie',33,'node',1),('molestie',35,'node',1),('molestie',39,'node',3.97837),('molestie',42,'node',1),('molestie',43,'node',1),('molestie',44,'node',1),('molestie',45,'node',1),('molestie',46,'node',1),('molestie',48,'node',1),('molestie',51,'node',2),('molestie',53,'node',4.20675),('molestie',55,'node',0.822065),('molestie',57,'node',1),('molestie',59,'node',1),('molestie',66,'node',1),('molestie',67,'node',1),('mollis',4,'node',3),('mollis',5,'node',3.73389),('mollis',6,'node',3),('mollis',7,'node',2.55837),('mollis',8,'node',3.92943),('mollis',9,'node',0.876337),('mollis',10,'node',2.9347),('mollis',11,'node',8),('mollis',12,'node',3),('mollis',13,'node',1),('mollis',14,'node',4),('mollis',15,'node',1.87596),('mollis',27,'node',3),('mollis',28,'node',3),('mollis',29,'node',3),('mollis',30,'node',3),('mollis',31,'node',2),('mollis',34,'node',2.74858),('mollis',36,'node',2),('mollis',37,'node',1.89608),('mollis',38,'node',2.76814),('mollis',42,'node',2.9496),('mollis',43,'node',2.9496),('mollis',44,'node',2.9496),('mollis',45,'node',2.9496),('mollis',46,'node',2.9496),('mollis',47,'node',1.46107),('mollis',48,'node',2),('mollis',50,'node',2),('mollis',52,'node',2),('mollis',53,'node',11.868),('mollis',54,'node',0.742984),('mollis',55,'node',1.45919),('mollis',57,'node',2.9496),('mollis',60,'node',1),('mollis',62,'node',4),('mollis',64,'node',28),('mollis',66,'node',1),('mollit',2,'node',1),('mollit',3,'node',3.76002),('mollit',4,'node',2.47521),('mollit',5,'node',2.48384),('mollit',6,'node',2.48384),('mollit',7,'node',3.80333),('mollit',8,'node',1.48714),('mollit',9,'node',3.79237),('mollit',12,'node',2.45814),('mollit',17,'node',3.76002),('mollit',27,'node',2.45814),('mollit',28,'node',2.49253),('mollit',29,'node',2.4497),('mollit',30,'node',2.45814),('mollit',31,'node',2.65839),('mollit',39,'node',2.26518),('mollit',40,'node',1),('mollit',41,'node',1),('mollit',47,'node',3.7494),('mollit',54,'node',3.73887),('mollit',55,'node',3.70775),('mollit',56,'node',3.83673),('mon',16,'node',0.58995),('mon',30,'node',0.754681),('mon',31,'node',2.22343),('mon',37,'node',0.845322),('money',9,'node',26),('mongodb',22,'node',7.92726),('montes',7,'node',0.63167),('montes',10,'node',1),('montes',53,'node',0.776703),('montes',65,'node',1),('montes',66,'node',1),('monthly',16,'node',0.513597),('months',16,'node',1.85135),('months',68,'node',1.84532),('morbi',3,'node',1.76431),('morbi',4,'node',2),('morbi',5,'node',2),('morbi',6,'node',2),('morbi',7,'node',20.7414),('morbi',8,'node',2.59445),('morbi',9,'node',1),('morbi',10,'node',1),('morbi',12,'node',2),('morbi',13,'node',2),('morbi',14,'node',1),('morbi',15,'node',1.61998),('morbi',17,'node',1),('morbi',26,'node',2),('morbi',27,'node',2),('morbi',28,'node',2),('morbi',29,'node',2),('morbi',30,'node',2),('morbi',31,'node',1),('morbi',34,'node',1.91674),('morbi',35,'node',1),('morbi',37,'node',1),('morbi',38,'node',1.92743),('morbi',39,'node',1),('morbi',42,'node',1.95723),('morbi',43,'node',1.95723),('morbi',44,'node',1.95723),('morbi',45,'node',1.95723),('morbi',46,'node',1.95723),('morbi',47,'node',2.57362),('morbi',48,'node',1),('morbi',52,'node',1),('morbi',53,'node',5.84533),('morbi',54,'node',1),('morbi',55,'node',1.65044),('morbi',56,'node',1),('morbi',57,'node',1.95723),('morbi',58,'node',2),('morbi',59,'node',1),('morbi',60,'node',4),('morbi',61,'node',1),('morbi',62,'node',1),('morbi',64,'node',26),('morbi',66,'node',1),('morbi',67,'node',1),('more',15,'node',1),('more',16,'node',2.5475),('more',19,'node',1.6586),('more',20,'node',31.7763),('more',21,'node',1),('more',48,'node',10.4874),('more',49,'node',11),('more',50,'node',11),('more',51,'node',11),('more',52,'node',11),('more',68,'node',1),('more',69,'node',1),('most',16,'node',1.29944),('most',20,'node',1),('most',21,'node',1),('most',68,'node',0.759465),('motion',38,'node',26),('move',16,'node',1),('move',68,'node',1),('moving',16,'node',0.896076),('moving',68,'node',0.889397),('much',19,'node',0.745294),('much',20,'node',1),('much',21,'node',0.953396),('much',29,'node',26),('much',34,'node',26),('mus',7,'node',0.62674),('mus',10,'node',1),('mus',53,'node',0.769219),('mus',65,'node',1),('mus',66,'node',0.993146),('music',35,'node',26),('music',36,'node',10.9246),('must',20,'node',1),('must',21,'node',1),('mv',19,'node',7.69621),('my',23,'node',14),('my',24,'node',5),('mybutton',23,'node',1),('mydropcap',23,'node',1),('myhighlight',23,'node',1),('myimage',23,'node',1),('myisam',22,'node',1.75605),('myitem',23,'node',1),('myquote',23,'node',1),('mysql',20,'node',2.97685),('mysql',22,'node',36.6079),('mysqlspecific',22,'node',1.49373),('mytooltip',24,'node',1),('nam',4,'node',1),('nam',5,'node',1),('nam',6,'node',1),('nam',7,'node',1.28249),('nam',8,'node',2.45373),('nam',9,'node',0.836446),('nam',11,'node',4),('nam',12,'node',21.6673),('nam',14,'node',1),('nam',15,'node',1.4791),('nam',27,'node',1),('nam',28,'node',1.78178),('nam',29,'node',1),('nam',30,'node',1),('nam',31,'node',1),('nam',33,'node',1),('nam',34,'node',2.63093),('nam',35,'node',1),('nam',36,'node',1),('nam',37,'node',1),('nam',38,'node',2.6478),('nam',39,'node',2.71882),('nam',42,'node',0.889397),('nam',43,'node',0.889397),('nam',44,'node',0.889397),('nam',45,'node',0.889397),('nam',46,'node',0.889397),('nam',48,'node',3),('nam',49,'node',2),('nam',51,'node',1),('nam',52,'node',3),('nam',53,'node',3.5463),('nam',55,'node',0.63333),('nam',57,'node',0.892724),('nam',58,'node',2),('nam',59,'node',1),('nam',61,'node',1),('nam',62,'node',1),('nam',63,'node',2),('nam',64,'node',3),('nam',67,'node',1),('name',19,'node',0.532778),('name',40,'node',1),('name',41,'node',1),('named',19,'node',2.05762),('nano',19,'node',2.6321),('nascetur',7,'node',0.630018),('nascetur',10,'node',1),('nascetur',53,'node',0.774192),('nascetur',65,'node',1),('nascetur',66,'node',1),('natoque',7,'node',0.640063),('natoque',10,'node',1),('natoque',53,'node',0.78951),('natoque',65,'node',1),('natoque',66,'node',1),('natus',3,'node',5.66031),('natus',4,'node',3.23933),('natus',5,'node',3.25037),('natus',6,'node',3.25037),('natus',7,'node',5.73444),('natus',8,'node',1.46737),('natus',9,'node',5.71569),('natus',12,'node',3.21748),('natus',17,'node',5.66031),('natus',27,'node',3.21748),('natus',28,'node',3.26148),('natus',29,'node',3.20666),('natus',30,'node',3.21748),('natus',31,'node',4.52338),('natus',40,'node',1),('natus',41,'node',1),('natus',47,'node',5.64215),('natus',54,'node',5.62412),('natus',55,'node',5.57089),('natus',56,'node',5.79012),('navigate',19,'node',0.968904),('ndb',22,'node',0.869951),('nearly',19,'node',0.934703),('nec',1,'node',0.869951),('nec',3,'node',1),('nec',4,'node',1.99315),('nec',5,'node',1.99731),('nec',6,'node',1.99731),('nec',7,'node',4.27855),('nec',8,'node',4.03861),('nec',9,'node',1.83645),('nec',10,'node',4.84832),('nec',11,'node',1.90682),('nec',12,'node',1.98493),('nec',13,'node',32),('nec',14,'node',3),('nec',15,'node',3.68295),('nec',17,'node',1),('nec',27,'node',1.98493),('nec',28,'node',2),('nec',29,'node',1.98087),('nec',30,'node',23.231),('nec',31,'node',41.9484),('nec',33,'node',2),('nec',34,'node',2.7393),('nec',36,'node',2),('nec',37,'node',5.76179),('nec',38,'node',2.75855),('nec',42,'node',11.3473),('nec',43,'node',11.3473),('nec',44,'node',11.3473),('nec',45,'node',11.3473),('nec',46,'node',11.3473),('nec',47,'node',4.25937),('nec',48,'node',2),('nec',49,'node',2),('nec',50,'node',3),('nec',51,'node',1),('nec',52,'node',1),('nec',53,'node',8.15598),('nec',54,'node',1),('nec',55,'node',3.9586),('nec',56,'node',1.80818),('nec',57,'node',11.3572),('nec',60,'node',2),('nec',61,'node',2),('nec',62,'node',2),('nec',63,'node',29),('nec',64,'node',1),('nec',65,'node',1),('nec',66,'node',7),('nec',67,'node',4),('necessary',22,'node',0.972861),('need',1,'node',1),('need',19,'node',1.67038),('need',20,'node',2),('need',21,'node',0.869951),('need',22,'node',1.73464),('needed',20,'node',1),('nemo',3,'node',0.961087),('nemo',4,'node',0.819249),('nemo',5,'node',0.822065),('nemo',6,'node',0.822065),('nemo',7,'node',0.976851),('nemo',9,'node',0.972861),('nemo',12,'node',0.813674),('nemo',17,'node',0.961087),('nemo',27,'node',0.813674),('nemo',28,'node',0.824901),('nemo',29,'node',0.810915),('nemo',30,'node',0.813674),('nemo',31,'node',0.913226),('nemo',47,'node',0.957226),('nemo',54,'node',0.953396),('nemo',55,'node',0.942091),('nemo',56,'node',0.989021),('neque',3,'node',1.57909),('neque',4,'node',1),('neque',5,'node',1),('neque',6,'node',1),('neque',7,'node',5.01135),('neque',8,'node',22.8241),('neque',10,'node',1),('neque',12,'node',1),('neque',13,'node',2),('neque',14,'node',2),('neque',26,'node',4),('neque',27,'node',1),('neque',28,'node',1),('neque',29,'node',1),('neque',30,'node',1.72066),('neque',31,'node',4.07875),('neque',33,'node',5),('neque',34,'node',3.48154),('neque',37,'node',2.85952),('neque',38,'node',3.50758),('neque',39,'node',1),('neque',42,'node',1.87957),('neque',43,'node',1.87957),('neque',44,'node',1.87957),('neque',45,'node',1.87957),('neque',46,'node',1.87957),('neque',48,'node',2),('neque',49,'node',2),('neque',52,'node',1),('neque',53,'node',1.80545),('neque',55,'node',0.827757),('neque',57,'node',1.88282),('neque',58,'node',2),('neque',59,'node',3),('neque',61,'node',3),('neque',62,'node',27),('neque',66,'node',2),('neque',67,'node',1),('netus',8,'node',0.689612),('netus',15,'node',0.731649),('netus',26,'node',2),('netus',37,'node',1),('netus',48,'node',1),('netus',53,'node',1),('netus',58,'node',2),('netus',60,'node',2),('netus',61,'node',1),('never',19,'node',0.485867),('new',16,'node',0.552215),('new',19,'node',7.87164),('newer',19,'node',1),('news',3,'node',11),('news',5,'node',8.54373),('news',16,'node',26),('news',47,'node',11),('news',68,'node',26),('next',19,'node',0.683725),('nginx',20,'node',1),('nginx',21,'node',41),('nibh',2,'node',1.89193),('nibh',3,'node',1),('nibh',4,'node',2),('nibh',5,'node',2),('nibh',6,'node',2),('nibh',7,'node',1.64869),('nibh',8,'node',2.97685),('nibh',9,'node',1),('nibh',10,'node',1.84234),('nibh',12,'node',2),('nibh',14,'node',2),('nibh',17,'node',1),('nibh',26,'node',2),('nibh',27,'node',2),('nibh',28,'node',2),('nibh',29,'node',2),('nibh',30,'node',2),('nibh',31,'node',2),('nibh',33,'node',1),('nibh',34,'node',2.99315),('nibh',35,'node',1),('nibh',36,'node',2),('nibh',38,'node',3),('nibh',39,'node',2),('nibh',42,'node',2.94209),('nibh',43,'node',2.94209),('nibh',44,'node',2.94209),('nibh',45,'node',2.94209),('nibh',46,'node',2.94209),('nibh',47,'node',1.83063),('nibh',49,'node',2),('nibh',51,'node',1),('nibh',52,'node',2),('nibh',53,'node',3.26107),('nibh',54,'node',1.75468),('nibh',55,'node',3.20111),('nibh',56,'node',1.80818),('nibh',57,'node',2.94209),('nibh',59,'node',1),('nibh',60,'node',1),('nibh',61,'node',2),('nibh',64,'node',1),('nibh',66,'node',1),('nibh',67,'node',2),('nihil',39,'node',1.69887),('nisi',2,'node',0.923838),('nisi',4,'node',6),('nisi',5,'node',6.70376),('nisi',6,'node',6),('nisi',7,'node',36.8844),('nisi',8,'node',4.11028),('nisi',9,'node',1.48344),('nisi',10,'node',2),('nisi',11,'node',6.84234),('nisi',12,'node',6),('nisi',14,'node',2),('nisi',15,'node',2.52611),('nisi',26,'node',4),('nisi',27,'node',6),('nisi',28,'node',6),('nisi',29,'node',6),('nisi',30,'node',6),('nisi',31,'node',8.80353),('nisi',33,'node',2),('nisi',34,'node',5.24053),('nisi',36,'node',1),('nisi',37,'node',2.77562),('nisi',38,'node',5.2865),('nisi',42,'node',3.84998),('nisi',43,'node',3.84998),('nisi',44,'node',3.84998),('nisi',45,'node',3.84998),('nisi',46,'node',3.84998),('nisi',47,'node',1.70058),('nisi',48,'node',1.98493),('nisi',49,'node',1),('nisi',50,'node',1),('nisi',51,'node',1),('nisi',52,'node',1),('nisi',53,'node',4.99751),('nisi',54,'node',0.733888),('nisi',57,'node',3.85319),('nisi',58,'node',3),('nisi',59,'node',1),('nisi',61,'node',1),('nisi',62,'node',2),('nisi',63,'node',29),('nisi',64,'node',2),('nisi',65,'node',1),('nisi',66,'node',5),('nisi',67,'node',1),('nisl',2,'node',1.91323),('nisl',4,'node',1.99731),('nisl',5,'node',2),('nisl',6,'node',2),('nisl',7,'node',0.609315),('nisl',8,'node',22.2043),('nisl',9,'node',1.69699),('nisl',11,'node',0.916736),('nisl',12,'node',1.98902),('nisl',13,'node',27),('nisl',14,'node',1),('nisl',15,'node',5.06637),('nisl',27,'node',1.98902),('nisl',28,'node',2),('nisl',29,'node',1.98493),('nisl',30,'node',2.70968),('nisl',31,'node',1.6956),('nisl',33,'node',2),('nisl',34,'node',4.37858),('nisl',35,'node',1),('nisl',36,'node',3),('nisl',37,'node',3.95793),('nisl',38,'node',4.4149),('nisl',39,'node',4.8247),('nisl',42,'node',2.89272),('nisl',43,'node',2.89272),('nisl',44,'node',2.89272),('nisl',45,'node',2.89272),('nisl',46,'node',2.89272),('nisl',48,'node',2),('nisl',49,'node',1),('nisl',50,'node',2),('nisl',51,'node',3),('nisl',52,'node',2),('nisl',53,'node',10.7524),('nisl',54,'node',1.60181),('nisl',56,'node',0.833529),('nisl',57,'node',2.89608),('nisl',60,'node',1),('nisl',61,'node',2),('nisl',62,'node',1),('nisl',63,'node',4),('nisl',64,'node',1),('nisl',65,'node',3),('nisl',67,'node',4),('no',1,'node',0.842342),('no',2,'node',7.73881),('no',3,'node',1.62386),('no',16,'node',1.63865),('no',18,'node',1),('no',19,'node',2.41115),('no',20,'node',0.810915),('no',21,'node',0.810915),('no',22,'node',1.56595),('no',39,'node',6.36765),('no',47,'node',1.52683),('no',53,'node',7.58837),('no',54,'node',1.52367),('no',55,'node',1.33257),('no',56,'node',1.68946),('no',68,'node',0.592848),('no',69,'node',1),('nobis',39,'node',1.70675),('node',16,'node',11),('node',68,'node',11),('node',69,'node',11),('non',1,'node',0.892724),('non',2,'node',1),('non',3,'node',4.76002),('non',4,'node',8.49686),('non',5,'node',8.50566),('non',6,'node',8.50566),('non',7,'node',24.9164),('non',8,'node',4.32472),('non',9,'node',4.79237),('non',10,'node',2),('non',11,'node',2),('non',12,'node',8.47945),('non',13,'node',1),('non',14,'node',2),('non',15,'node',2.60059),('non',17,'node',4.76002),('non',26,'node',4),('non',27,'node',8.47945),('non',28,'node',8.51452),('non',29,'node',8.47084),('non',30,'node',8.47945),('non',31,'node',10.1419),('non',33,'node',1),('non',34,'node',2.83353),('non',35,'node',2.96498),('non',36,'node',2),('non',37,'node',1),('non',38,'node',2.84234),('non',39,'node',3.28145),('non',40,'node',1),('non',41,'node',1),('non',42,'node',4.83867),('non',43,'node',4.83867),('non',44,'node',4.83867),('non',45,'node',4.83867),('non',46,'node',4.83867),('non',47,'node',4.7494),('non',50,'node',1),('non',52,'node',1),('non',53,'node',11.8417),('non',54,'node',5.49355),('non',55,'node',6.94282),('non',56,'node',4.83673),('non',57,'node',4.83867),('non',58,'node',3),('non',59,'node',1),('non',60,'node',1),('non',61,'node',2),('non',62,'node',3),('non',64,'node',1),('non',65,'node',2),('non',66,'node',30),('non',67,'node',30),('nonbeta',19,'node',0.487816),('none',1,'node',1.97685),('none',15,'node',2.56366),('none',16,'node',1.07632),('none',17,'node',0.866793),('none',55,'node',0.792123),('nonummy',2,'node',1.89579),('nonummy',7,'node',2.55497),('nonummy',8,'node',1.33749),('nonummy',10,'node',0.863659),('nonummy',13,'node',1),('nonummy',14,'node',1),('nonummy',28,'node',0.757065),('nonummy',37,'node',1.80914),('nonummy',39,'node',1),('nonummy',48,'node',1),('nonummy',49,'node',1),('nonummy',51,'node',1),('nonummy',53,'node',5.65634),('nonummy',55,'node',0.714225),('nonummy',60,'node',2),('nonummy',61,'node',1),('nonummy',62,'node',1),('nonummy',63,'node',1),('nonumy',2,'node',0.993146),('nonumy',39,'node',3.93855),('normal',21,'node',10.6148),('nostra',7,'node',0.588512),('nostra',8,'node',1),('nostra',10,'node',0.886095),('nostra',11,'node',2),('nostra',14,'node',1),('nostra',34,'node',1),('nostra',38,'node',1),('nostra',53,'node',0.63333),('nostra',54,'node',0.712106),('nostrud',2,'node',2.84793),('nostrud',39,'node',3.8365),('not',1,'node',1),('not',16,'node',3.78258),('not',19,'node',9.32163),('not',20,'node',1),('not',22,'node',6.1872),('not',55,'node',26),('not',68,'node',3.25146),('not',69,'node',1),('note',19,'node',2.04403),('note',20,'node',1),('note',22,'node',2.35919),('notes',16,'node',2.53128),('notes',22,'node',4),('now',1,'node',1),('now',16,'node',2.41133),('now',19,'node',3.2742),('now',31,'node',26),('now',68,'node',1.83734),('now',69,'node',1),('nulla',1,'node',0.882818),('nulla',2,'node',3.86941),('nulla',3,'node',2),('nulla',5,'node',2.18837),('nulla',7,'node',38.8606),('nulla',8,'node',19.707),('nulla',9,'node',4.31307),('nulla',10,'node',2.86679),('nulla',11,'node',4.83938),('nulla',14,'node',2),('nulla',15,'node',1.80545),('nulla',17,'node',2),('nulla',26,'node',6),('nulla',33,'node',3),('nulla',34,'node',2.43297),('nulla',37,'node',0.889397),('nulla',38,'node',2.45798),('nulla',39,'node',8.66597),('nulla',40,'node',1),('nulla',41,'node',1),('nulla',42,'node',3.77342),('nulla',43,'node',3.77342),('nulla',44,'node',3.77342),('nulla',45,'node',3.77342),('nulla',46,'node',3.77342),('nulla',47,'node',2),('nulla',49,'node',1),('nulla',53,'node',5.35055),('nulla',54,'node',2),('nulla',55,'node',5.52116),('nulla',56,'node',2),('nulla',57,'node',3.77663),('nulla',58,'node',1),('nulla',59,'node',1),('nulla',61,'node',1),('nulla',62,'node',3),('nulla',64,'node',1),('nulla',66,'node',3),('nullam',3,'node',1),('nullam',5,'node',21.5493),('nullam',7,'node',2.3862),('nullam',8,'node',18.7144),('nullam',9,'node',3.38466),('nullam',10,'node',0.869951),('nullam',11,'node',2.86055),('nullam',14,'node',3),('nullam',15,'node',3.30735),('nullam',17,'node',1),('nullam',31,'node',2.51312),('nullam',34,'node',1.80818),('nullam',35,'node',2),('nullam',36,'node',1),('nullam',37,'node',2.83353),('nullam',38,'node',1.81645),('nullam',39,'node',1),('nullam',47,'node',1),('nullam',48,'node',1),('nullam',49,'node',1),('nullam',50,'node',2),('nullam',51,'node',3),('nullam',53,'node',4.1678),('nullam',54,'node',1),('nullam',55,'node',1),('nullam',56,'node',1),('nullam',58,'node',2),('nullam',59,'node',3),('nullam',61,'node',1),('nullam',62,'node',2),('nullam',63,'node',1),('nullam',65,'node',2),('nullam',66,'node',1),('numerous',16,'node',0.567769),('nunc',3,'node',2),('nunc',4,'node',2),('nunc',5,'node',24.9586),('nunc',6,'node',2),('nunc',7,'node',34.8071),('nunc',8,'node',6.43025),('nunc',9,'node',43.9909),('nunc',10,'node',3.73073),('nunc',11,'node',32.3987),('nunc',12,'node',22.6673),('nunc',13,'node',5),('nunc',14,'node',2),('nunc',15,'node',2.78489),('nunc',17,'node',2),('nunc',26,'node',6),('nunc',27,'node',2),('nunc',28,'node',5.03547),('nunc',29,'node',2),('nunc',30,'node',2),('nunc',31,'node',2),('nunc',33,'node',1),('nunc',34,'node',3),('nunc',35,'node',2.9534),('nunc',37,'node',3.70788),('nunc',38,'node',3),('nunc',39,'node',3),('nunc',42,'node',8.75137),('nunc',43,'node',8.75137),('nunc',44,'node',8.75137),('nunc',45,'node',8.75137),('nunc',46,'node',8.75137),('nunc',47,'node',2),('nunc',48,'node',2),('nunc',49,'node',4),('nunc',50,'node',2),('nunc',51,'node',6),('nunc',52,'node',6),('nunc',53,'node',10.1715),('nunc',54,'node',2.85439),('nunc',55,'node',7.17052),('nunc',56,'node',2.80545),('nunc',57,'node',8.75462),('nunc',58,'node',3),('nunc',59,'node',1),('nunc',60,'node',2),('nunc',61,'node',57),('nunc',62,'node',1),('nunc',63,'node',1),('nunc',65,'node',3),('nunc',67,'node',3),('obcaecat',2,'node',1),('obcaecat',39,'node',2.28703),('occaecat',3,'node',3.76002),('occaecat',4,'node',2.50431),('occaecat',5,'node',2.51316),('occaecat',6,'node',2.51316),('occaecat',7,'node',3.80333),('occaecat',8,'node',1.50797),('occaecat',9,'node',3.79237),('occaecat',12,'node',2.48678),('occaecat',17,'node',3.76002),('occaecat',27,'node',2.48678),('occaecat',28,'node',2.52209),('occaecat',29,'node',2.47811),('occaecat',30,'node',2.48678),('occaecat',31,'node',2.68843),('occaecat',40,'node',1),('occaecat',41,'node',1),('occaecat',47,'node',3.7494),('occaecat',54,'node',3.73887),('occaecat',55,'node',3.70775),('occaecat',56,'node',3.83673),('ocean',35,'node',26),('odio',2,'node',1),('odio',5,'node',0.727213),('odio',7,'node',1.97942),('odio',8,'node',0.657549),('odio',11,'node',6),('odio',15,'node',0.896076),('odio',26,'node',2),('odio',28,'node',0.76431),('odio',31,'node',21.6334),('odio',33,'node',3),('odio',34,'node',1.62737),('odio',36,'node',1),('odio',37,'node',2.80571),('odio',38,'node',1.64415),('odio',39,'node',3.50311),('odio',42,'node',2.90029),('odio',43,'node',2.90029),('odio',44,'node',2.90029),('odio',45,'node',2.90029),('odio',46,'node',2.90029),('odio',48,'node',1),('odio',51,'node',2),('odio',53,'node',5.32428),('odio',55,'node',0.630018),('odio',57,'node',2.90029),('odio',58,'node',1),('odio',59,'node',2),('odio',60,'node',1),('odio',61,'node',0.997306),('odio',62,'node',1),('odio',63,'node',3),('odio',65,'node',1),('odio',66,'node',2),('odio',67,'node',2),('odit',3,'node',0.934703),('odit',4,'node',0.800068),('odit',5,'node',0.802752),('odit',6,'node',0.802752),('odit',7,'node',0.949597),('odit',9,'node',0.945829),('odit',12,'node',0.794753),('odit',17,'node',0.934703),('odit',27,'node',0.794753),('odit',28,'node',0.805455),('odit',29,'node',0.792123),('odit',30,'node',0.794753),('odit',31,'node',0.889397),('odit',47,'node',0.931053),('odit',54,'node',0.927431),('odit',55,'node',0.916736),('odit',56,'node',0.961087),('of',1,'node',1),('of',16,'node',11.6971),('of',18,'node',2),('of',19,'node',12.6233),('of',20,'node',2.84832),('of',21,'node',1.89945),('of',22,'node',1.89608),('of',68,'node',9.59635),('off',17,'node',11),('offer',15,'node',1),('offers',21,'node',0.976851),('officia',2,'node',1),('officia',3,'node',3.76002),('officia',4,'node',2.48232),('officia',5,'node',2.491),('officia',6,'node',2.491),('officia',7,'node',3.80333),('officia',8,'node',1.49224),('officia',9,'node',3.79237),('officia',12,'node',2.46514),('officia',17,'node',3.76002),('officia',27,'node',2.46514),('officia',28,'node',2.49974),('officia',29,'node',2.45664),('officia',30,'node',2.46514),('officia',31,'node',2.66572),('officia',39,'node',2.27053),('officia',40,'node',1),('officia',41,'node',1),('officia',47,'node',3.7494),('officia',54,'node',3.73887),('officia',55,'node',3.70775),('officia',56,'node',3.83673),('offline',3,'node',0.842342),('offline',15,'node',1.8249),('offline',53,'node',4.83609),('offline',54,'node',0.792123),('offline',55,'node',0.674137),('offseason',7,'node',26),('oftenused',19,'node',0.452478),('older',19,'node',1),('omnis',3,'node',5.66031),('omnis',4,'node',3.24596),('omnis',5,'node',3.25704),('omnis',6,'node',3.25704),('omnis',7,'node',5.73444),('omnis',8,'node',1.47222),('omnis',9,'node',5.71569),('omnis',12,'node',3.22401),('omnis',17,'node',5.66031),('omnis',27,'node',3.22401),('omnis',28,'node',3.26821),('omnis',29,'node',3.21314),('omnis',30,'node',3.22401),('omnis',31,'node',4.52338),('omnis',40,'node',1),('omnis',41,'node',1),('omnis',47,'node',5.64215),('omnis',54,'node',5.62412),('omnis',55,'node',5.57089),('omnis',56,'node',5.79012),('on',7,'node',6.57447),('on',8,'node',2.57003),('on',9,'node',2.25498),('on',10,'node',0.949597),('on',11,'node',1.84767),('on',15,'node',1),('on',16,'node',4.82502),('on',18,'node',5),('on',19,'node',37.6213),('on',21,'node',13.8483),('on',22,'node',2.50921),('on',37,'node',0.848323),('on',47,'node',26),('on',68,'node',3.82966),('once',19,'node',1.56511),('one',20,'node',1),('one',36,'node',26),('one',50,'node',26),('onepage',30,'node',8.43432),('online',1,'node',1.92384),('online',16,'node',0.584241),('online',47,'node',0.776703),('online',53,'node',2.06169),('online',55,'node',0.769219),('only',16,'node',1.50505),('only',19,'node',2.05875),('only',20,'node',0.923838),('only',22,'node',1.65326),('only',68,'node',1),('onto',16,'node',0.886095),('onto',68,'node',0.879565),('open',19,'node',2.66299),('opportunities',18,'node',1),('option',39,'node',1.70279),('options',16,'node',0.873132),('options',68,'node',0.866793),('or',1,'node',28.786),('or',3,'node',0.745294),('or',5,'node',1.46398),('or',7,'node',6.40021),('or',8,'node',2.54361),('or',9,'node',2.18552),('or',10,'node',0.819249),('or',11,'node',1.72917),('or',12,'node',0.742984),('or',16,'node',4.2083),('or',18,'node',1),('or',19,'node',5.82334),('or',20,'node',10.4466),('or',21,'node',4.57683),('or',22,'node',14.033),('or',30,'node',0.738408),('or',31,'node',2.2055),('or',37,'node',0.810915),('or',47,'node',0.716357),('or',53,'node',6.68999),('or',54,'node',0.699655),('or',55,'node',1.30953),('or',56,'node',0.786915),('or',68,'node',3.71366),('or',69,'node',27),('oracle',20,'node',10.363),('oracle',22,'node',7.95114),('orci',1,'node',0.909743),('orci',3,'node',0.774192),('orci',4,'node',1),('orci',5,'node',1.7017),('orci',6,'node',1),('orci',7,'node',20.4276),('orci',8,'node',2.51767),('orci',9,'node',0.839384),('orci',10,'node',2),('orci',11,'node',2),('orci',12,'node',1),('orci',14,'node',1),('orci',26,'node',2),('orci',27,'node',1),('orci',28,'node',2.53358),('orci',29,'node',1),('orci',30,'node',1),('orci',31,'node',3.12808),('orci',34,'node',1.83353),('orci',35,'node',1.97286),('orci',36,'node',1),('orci',37,'node',5.69517),('orci',38,'node',1.84234),('orci',39,'node',1),('orci',42,'node',2),('orci',43,'node',2),('orci',44,'node',2),('orci',45,'node',2),('orci',46,'node',2),('orci',48,'node',2.92221),('orci',49,'node',3),('orci',52,'node',2),('orci',53,'node',4.37379),('orci',54,'node',0.740689),('orci',55,'node',0.628375),('orci',57,'node',2),('orci',58,'node',1),('orci',59,'node',2),('orci',60,'node',1),('orci',61,'node',1),('orci',62,'node',3),('order',19,'node',0.681785),('orem',42,'node',1),('orem',43,'node',1),('orem',44,'node',1),('orem',45,'node',1),('orem',46,'node',1),('organization',16,'node',0.738408),('organization',68,'node',0.733888),('organizations',16,'node',1.29254),('organizations',68,'node',1.28563),('oriented',54,'node',26),('ornare',4,'node',2),('ornare',5,'node',2),('ornare',6,'node',2),('ornare',7,'node',1.22795),('ornare',8,'node',0.824901),('ornare',12,'node',2),('ornare',13,'node',1),('ornare',27,'node',2),('ornare',28,'node',2),('ornare',29,'node',2),('ornare',30,'node',2),('ornare',31,'node',2.73614),('ornare',33,'node',1),('ornare',34,'node',1.6392),('ornare',35,'node',1),('ornare',37,'node',0.827757),('ornare',38,'node',1.65624),('ornare',42,'node',2.77882),('ornare',43,'node',2.77882),('ornare',44,'node',2.77882),('ornare',45,'node',2.77882),('ornare',46,'node',2.77882),('ornare',50,'node',1),('ornare',52,'node',1),('ornare',53,'node',0.980874),('ornare',57,'node',2.78547),('ornare',62,'node',1),('ornare',66,'node',1),('os',21,'node',2),('other',1,'node',1),('other',18,'node',1),('other',19,'node',3.23854),('other',20,'node',1),('other',21,'node',1.9689),('other',22,'node',12.6708),('other',69,'node',1),('our',15,'node',2),('our',16,'node',1.14693),('our',19,'node',2.01685),('our',55,'node',26),('our',68,'node',0.630018),('out',1,'node',1),('out',16,'node',2.45425),('out',20,'node',1),('out',68,'node',2.44534),('own',16,'node',0.681785),('own',68,'node',0.677939),('owners',19,'node',0.687638),('page',15,'node',1),('page',16,'node',1.13904),('page',17,'node',26),('page',18,'node',2),('page',19,'node',6),('page',20,'node',1),('page',33,'node',26),('page',50,'node',26),('page',68,'node',0.648686),('paid',19,'node',11),('panel',22,'node',0.839384),('pariatur',39,'node',2.20392),('pariatur',40,'node',1),('pariatur',41,'node',1),('parturient',7,'node',0.63333),('parturient',10,'node',1),('parturient',53,'node',0.779231),('parturient',65,'node',1),('parturient',66,'node',1),('party',21,'node',1.715),('password',19,'node',1),('past',16,'node',0.816452),('past',68,'node',0.810915),('paste',19,'node',0.471741),('patches',16,'node',2.39346),('patches',68,'node',2.38542),('path',16,'node',0.769219),('path',23,'node',1),('path',68,'node',0.76431),('pdo',20,'node',3.89714),('pdo',22,'node',13),('pede',5,'node',0.705825),('pede',7,'node',1.97723),('pede',8,'node',1.92269),('pede',9,'node',2.50521),('pede',10,'node',4.7305),('pede',13,'node',1),('pede',14,'node',4),('pede',15,'node',0.997306),('pede',26,'node',2),('pede',30,'node',1.43277),('pede',31,'node',1.38521),('pede',37,'node',2.77241),('pede',47,'node',0.889397),('pede',49,'node',1),('pede',50,'node',2),('pede',51,'node',1),('pede',52,'node',1),('pede',53,'node',3.53956),('pede',55,'node',0.836446),('pede',56,'node',0.808176),('pede',59,'node',1),('pede',60,'node',1),('pede',61,'node',1),('pede',62,'node',1.98902),('pede',65,'node',1),('pedeaenean',37,'node',1),('pellentesque',1,'node',0.860547),('pellentesque',3,'node',2),('pellentesque',7,'node',24.9028),('pellentesque',8,'node',2.39122),('pellentesque',9,'node',2.86366),('pellentesque',10,'node',5.57905),('pellentesque',11,'node',0.942091),('pellentesque',13,'node',1),('pellentesque',14,'node',3),('pellentesque',15,'node',3.53621),('pellentesque',17,'node',2),('pellentesque',26,'node',2),('pellentesque',31,'node',1.55371),('pellentesque',34,'node',3.43288),('pellentesque',35,'node',1.96498),('pellentesque',36,'node',2),('pellentesque',37,'node',4.70447),('pellentesque',38,'node',3.45788),('pellentesque',39,'node',2),('pellentesque',42,'node',2),('pellentesque',43,'node',2),('pellentesque',44,'node',2),('pellentesque',45,'node',2),('pellentesque',46,'node',2),('pellentesque',47,'node',2.8249),('pellentesque',48,'node',2),('pellentesque',49,'node',2),('pellentesque',50,'node',3),('pellentesque',51,'node',1),('pellentesque',53,'node',7.20697),('pellentesque',54,'node',2),('pellentesque',55,'node',4.20756),('pellentesque',56,'node',2.80818),('pellentesque',57,'node',2),('pellentesque',58,'node',4),('pellentesque',59,'node',1),('pellentesque',60,'node',3),('pellentesque',61,'node',4),('pellentesque',62,'node',27),('pellentesque',63,'node',2),('pellentesque',66,'node',29),('pellentesque',67,'node',2),('penatibus',7,'node',0.638366),('penatibus',10,'node',1),('penatibus',53,'node',0.786915),('penatibus',65,'node',1),('penatibus',66,'node',1),('people',55,'node',26),('per',7,'node',1.17848),('per',8,'node',2),('per',10,'node',1.77554),('per',11,'node',4),('per',14,'node',2),('per',34,'node',2),('per',38,'node',2),('per',53,'node',1.26835),('per',54,'node',0.716357),('percona',20,'node',0.972861),('percona',22,'node',22),('perfect',3,'node',0.752312),('perfect',7,'node',2.42175),('perfect',15,'node',0.722831),('perfect',53,'node',2.5658),('perfect',54,'node',0.705825),('perfect',55,'node',0.623497),('performance',16,'node',0.491762),('performance',20,'node',9.3983),('performance',21,'node',1.97286),('performed',21,'node',2.99315),('period',55,'node',26),('permalink',5,'node',16.1554),('permalink',7,'node',72.4756),('permalink',8,'node',28.3505),('permalink',9,'node',24.9241),('permalink',10,'node',10.572),('permalink',11,'node',20.4941),('permalink',12,'node',8.2238),('permalink',30,'node',8.17283),('permalink',31,'node',24.3159),('permalink',37,'node',9.46601),('permissions',19,'node',1.37923),('perspiciatis',3,'node',5.66031),('perspiciatis',4,'node',3.25269),('perspiciatis',5,'node',3.26383),('perspiciatis',6,'node',3.26383),('perspiciatis',7,'node',5.73444),('perspiciatis',8,'node',1.47713),('perspiciatis',9,'node',5.71569),('perspiciatis',12,'node',3.23063),('perspiciatis',17,'node',5.66031),('perspiciatis',27,'node',3.23063),('perspiciatis',28,'node',3.27504),('perspiciatis',29,'node',3.21972),('perspiciatis',30,'node',3.23063),('perspiciatis',31,'node',4.52338),('perspiciatis',40,'node',1),('perspiciatis',41,'node',1),('perspiciatis',47,'node',5.64215),('perspiciatis',54,'node',5.62412),('perspiciatis',55,'node',5.57089),('perspiciatis',56,'node',5.79012),('peter',5,'node',0.766757),('peter',7,'node',0.781775),('peter',9,'node',0.802752),('peter',11,'node',0.869951),('peter',15,'node',1),('peter',30,'node',0.757065),('peter',31,'node',1.49441),('peter',53,'node',2.22359),('pharetra',7,'node',0.60778),('pharetra',11,'node',2),('pharetra',33,'node',1),('pharetra',34,'node',0.802752),('pharetra',35,'node',1),('pharetra',36,'node',1),('pharetra',38,'node',0.810915),('pharetra',39,'node',1),('pharetra',42,'node',1.97685),('pharetra',43,'node',1.97685),('pharetra',44,'node',1.97685),('pharetra',45,'node',1.97685),('pharetra',46,'node',1.97685),('pharetra',49,'node',1),('pharetra',52,'node',1),('pharetra',53,'node',1.79475),('pharetra',57,'node',1.97685),('pharetra',62,'node',1),('pharetra',63,'node',1),('pharetra',64,'node',1),('pharetra',67,'node',3),('phasellus',1,'node',0.873132),('phasellus',3,'node',1.62185),('phasellus',4,'node',2),('phasellus',5,'node',21.3974),('phasellus',6,'node',2),('phasellus',7,'node',17.8141),('phasellus',8,'node',1.49935),('phasellus',9,'node',1.496),('phasellus',10,'node',28.0242),('phasellus',11,'node',3.81014),('phasellus',12,'node',2.72721),('phasellus',13,'node',1),('phasellus',14,'node',2),('phasellus',15,'node',4.43286),('phasellus',26,'node',4),('phasellus',27,'node',2),('phasellus',28,'node',2),('phasellus',29,'node',2),('phasellus',30,'node',2),('phasellus',31,'node',22.6733),('phasellus',33,'node',2),('phasellus',34,'node',0.824901),('phasellus',36,'node',2),('phasellus',37,'node',2.77879),('phasellus',38,'node',0.833529),('phasellus',42,'node',1.93838),('phasellus',43,'node',1.93838),('phasellus',44,'node',1.93838),('phasellus',45,'node',1.93838),('phasellus',46,'node',1.93838),('phasellus',47,'node',0.827757),('phasellus',48,'node',1),('phasellus',49,'node',1),('phasellus',50,'node',1),('phasellus',51,'node',1),('phasellus',52,'node',2),('phasellus',53,'node',11.6414),('phasellus',57,'node',1.93838),('phasellus',58,'node',5),('phasellus',59,'node',1),('phasellus',60,'node',1),('phasellus',61,'node',1),('phasellus',62,'node',1),('phasellus',63,'node',2),('phasellus',64,'node',1),('phasellus',65,'node',3),('phasellus',67,'node',27),('photography',11,'node',11),('photoshop',30,'node',8.46141),('php',1,'node',1),('php',19,'node',1.71405),('php',20,'node',41.2114),('php',21,'node',1.88282),('php',22,'node',1),('php',69,'node',1),('php5',19,'node',1.14633),('phpcgi',19,'node',2.36558),('phpcli',19,'node',4.69677),('piano',36,'node',52),('pick',10,'node',26),('picks',37,'node',9.56946),('pictures',10,'node',10.8792),('pinteros',51,'node',26),('place',19,'node',0.906467),('placement',24,'node',1),('placerat',5,'node',0.707906),('placerat',7,'node',16.9797),('placerat',10,'node',0.997306),('placerat',11,'node',0.920273),('placerat',15,'node',0.754681),('placerat',26,'node',2),('placerat',31,'node',0.705825),('placerat',33,'node',1),('placerat',34,'node',0.800068),('placerat',37,'node',2.92743),('placerat',38,'node',0.808176),('placerat',39,'node',2.68349),('placerat',42,'node',0.96498),('placerat',43,'node',0.96498),('placerat',44,'node',0.96498),('placerat',45,'node',0.96498),('placerat',46,'node',0.96498),('placerat',48,'node',0.96498),('placerat',49,'node',1),('placerat',52,'node',1),('placerat',53,'node',1.27152),('placerat',54,'node',0.845322),('placerat',57,'node',0.96498),('placerat',61,'node',1),('placerat',64,'node',1),('placerat',65,'node',1),('plan',19,'node',0.443437),('plan',22,'node',0.899454),('plans',22,'node',1.94209),('platea',9,'node',20.0515),('platea',15,'node',0.781775),('platea',26,'node',4),('platea',36,'node',1),('platea',47,'node',1.49291),('platea',54,'node',0.879565),('platea',59,'node',1),('platea',66,'node',1),('platforms',19,'node',0.565115),('playlist',35,'node',26),('please',19,'node',1),('please',22,'node',3.19361),('plesk',22,'node',0.836446),('point',19,'node',0.467218),('policy',16,'node',3),('policy',68,'node',3),('popular',21,'node',1),('port',1,'node',1),('porta',3,'node',1.78951),('porta',4,'node',1),('porta',5,'node',1.73165),('porta',6,'node',1),('porta',7,'node',3.55144),('porta',8,'node',2.41467),('porta',9,'node',1),('porta',12,'node',1),('porta',13,'node',2),('porta',15,'node',0.848323),('porta',17,'node',1),('porta',27,'node',1),('porta',28,'node',1),('porta',29,'node',1),('porta',30,'node',1),('porta',31,'node',0.736141),('porta',34,'node',2.57372),('porta',35,'node',1),('porta',37,'node',0.886095),('porta',38,'node',2.60184),('porta',42,'node',1.99315),('porta',43,'node',1.99315),('porta',44,'node',1.99315),('porta',45,'node',1.99315),('porta',46,'node',1.99315),('porta',47,'node',1),('porta',49,'node',1),('porta',51,'node',2),('porta',53,'node',1.45319),('porta',54,'node',1),('porta',55,'node',1.65576),('porta',56,'node',1),('porta',57,'node',1.99315),('porta',64,'node',1),('porta',66,'node',2),('porttitor',4,'node',3),('porttitor',5,'node',23.8003),('porttitor',6,'node',3),('porttitor',7,'node',17.998),('porttitor',8,'node',3.79527),('porttitor',12,'node',3),('porttitor',15,'node',1),('porttitor',27,'node',3),('porttitor',28,'node',3),('porttitor',29,'node',3),('porttitor',30,'node',3),('porttitor',31,'node',0.71),('porttitor',34,'node',3.8397),('porttitor',37,'node',0.942091),('porttitor',38,'node',3.87397),('porttitor',42,'node',0.945829),('porttitor',43,'node',0.945829),('porttitor',44,'node',0.945829),('porttitor',45,'node',0.945829),('porttitor',46,'node',0.945829),('porttitor',48,'node',0.980874),('porttitor',49,'node',1),('porttitor',53,'node',1.89461),('porttitor',57,'node',0.945829),('porttitor',61,'node',0.98493),('porttitor',66,'node',1),('porttitor',67,'node',1),('possim',39,'node',1.67972),('post',1,'node',1.78228),('post',3,'node',0.738408),('post',5,'node',1.45705),('post',7,'node',6.39336),('post',8,'node',2.54015),('post',9,'node',2.18076),('post',10,'node',0.813674),('post',11,'node',1.71926),('post',12,'node',0.736141),('post',16,'node',0.478227),('post',30,'node',0.731649),('post',31,'node',2.19806),('post',37,'node',0.802752),('post',47,'node',0.71),('post',53,'node',6.68279),('post',54,'node',0.695602),('post',55,'node',1.30561),('post',56,'node',0.779231),('post',68,'node',11),('post',69,'node',11),('postgresql',20,'node',2.93897),('postgresql',22,'node',14.5717),('posuere',3,'node',1.76922),('posuere',4,'node',1),('posuere',5,'node',1),('posuere',6,'node',1),('posuere',7,'node',2.8892),('posuere',8,'node',1.96498),('posuere',9,'node',1.89608),('posuere',11,'node',4),('posuere',12,'node',1),('posuere',14,'node',1),('posuere',15,'node',2),('posuere',17,'node',1),('posuere',26,'node',2),('posuere',27,'node',1),('posuere',28,'node',1.76922),('posuere',29,'node',1),('posuere',30,'node',1),('posuere',31,'node',0.716357),('posuere',34,'node',1.98087),('posuere',36,'node',1),('posuere',37,'node',0.957226),('posuere',38,'node',1.99315),('posuere',42,'node',4.73092),('posuere',43,'node',4.73092),('posuere',44,'node',4.73092),('posuere',45,'node',4.73092),('posuere',46,'node',4.73092),('posuere',47,'node',1),('posuere',48,'node',0.997306),('posuere',49,'node',1),('posuere',50,'node',1),('posuere',51,'node',2),('posuere',53,'node',6.67786),('posuere',54,'node',1.71),('posuere',55,'node',1.72721),('posuere',56,'node',1),('posuere',57,'node',4.73412),('posuere',58,'node',3),('posuere',61,'node',28),('posuere',62,'node',1),('posuere',63,'node',1),('posuere',64,'node',2),('posuere',65,'node',2),('posuere',66,'node',1.98902),('potenti',3,'node',1),('potenti',7,'node',1.58283),('potenti',9,'node',1),('potenti',17,'node',1),('potenti',33,'node',1),('potenti',36,'node',1),('potenti',37,'node',1),('potenti',47,'node',1),('potenti',48,'node',2),('potenti',53,'node',3.03438),('potenti',54,'node',1),('potenti',55,'node',0.993146),('potenti',56,'node',2.66998),('potenti',60,'node',1),('powerful',19,'node',0.510357),('practice',3,'node',0.757065),('practice',7,'node',2.42494),('practice',15,'node',0.727213),('practice',53,'node',2.5696),('practice',54,'node',0.71),('practice',55,'node',0.62674),('praesent',2,'node',1),('praesent',4,'node',2),('praesent',5,'node',2),('praesent',6,'node',2),('praesent',7,'node',1.97484),('praesent',8,'node',2.68764),('praesent',9,'node',1.68779),('praesent',10,'node',2.84832),('praesent',11,'node',28.7868),('praesent',12,'node',2),('praesent',13,'node',29),('praesent',14,'node',26),('praesent',15,'node',2),('praesent',26,'node',4),('praesent',27,'node',2),('praesent',28,'node',2),('praesent',29,'node',2),('praesent',30,'node',2),('praesent',31,'node',3.58247),('praesent',33,'node',2),('praesent',34,'node',2),('praesent',35,'node',1),('praesent',36,'node',1),('praesent',37,'node',1.8126),('praesent',38,'node',2),('praesent',39,'node',2.4982),('praesent',42,'node',1.90629),('praesent',43,'node',1.90629),('praesent',44,'node',1.90629),('praesent',45,'node',1.90629),('praesent',46,'node',1.90629),('praesent',47,'node',0.860547),('praesent',48,'node',2),('praesent',49,'node',3),('praesent',50,'node',1),('praesent',51,'node',2),('praesent',52,'node',1),('praesent',53,'node',4.33178),('praesent',55,'node',0.718502),('praesent',57,'node',1.90629),('praesent',59,'node',1),('praesent',60,'node',1),('praesent',61,'node',2),('praesent',63,'node',3),('praesent',64,'node',2),('premium',15,'node',1),('prerequisite',19,'node',1),('pretium',4,'node',3),('pretium',5,'node',3.73614),('pretium',6,'node',3),('pretium',7,'node',2.03667),('pretium',8,'node',3.65755),('pretium',9,'node',0.873132),('pretium',10,'node',1),('pretium',12,'node',3.72502),('pretium',14,'node',2),('pretium',15,'node',2.77853),('pretium',27,'node',3),('pretium',28,'node',3),('pretium',29,'node',3),('pretium',30,'node',3),('pretium',31,'node',3.75231),('pretium',33,'node',1),('pretium',34,'node',3),('pretium',36,'node',2),('pretium',37,'node',1),('pretium',38,'node',3),('pretium',39,'node',1),('pretium',42,'node',3.66554),('pretium',43,'node',3.66554),('pretium',44,'node',3.66554),('pretium',45,'node',3.66554),('pretium',46,'node',3.66554),('pretium',48,'node',2),('pretium',49,'node',1),('pretium',50,'node',2),('pretium',51,'node',1),('pretium',52,'node',2),('pretium',53,'node',5.1395),('pretium',55,'node',0.729424),('pretium',57,'node',3.66879),('pretium',59,'node',1),('pretium',61,'node',1),('pretium',62,'node',1.98493),('pretium',65,'node',2),('pretium',66,'node',3),('pretium',67,'node',2),('prevent',16,'node',1),('prevent',68,'node',1),('previous',16,'node',2),('previous',19,'node',0.61241),('previous',68,'node',2),('primary',20,'node',0.957226),('primary',22,'node',1.86995),('primis',3,'node',0.776703),('primis',4,'node',1),('primis',5,'node',1),('primis',6,'node',1),('primis',7,'node',1.28487),('primis',8,'node',0.945829),('primis',12,'node',1),('primis',27,'node',1),('primis',28,'node',1.7717),('primis',29,'node',1),('primis',30,'node',1),('primis',31,'node',0.722831),('primis',34,'node',1.75584),('primis',37,'node',0.96498),('primis',38,'node',1.77561),('primis',48,'node',1),('primis',49,'node',1),('primis',53,'node',1.23586),('primis',62,'node',1),('principles',8,'node',26),('private',16,'node',0.722831),('private',68,'node',0.718502),('pro',1,'node',1),('pro',3,'node',26),('pro',69,'node',1),('probably',22,'node',0.813674),('problems',22,'node',0.774192),('proceed',22,'node',0.797402),('process',19,'node',0.738408),('produce',20,'node',0.889397),('product',21,'node',0.860547),('production',1,'node',1),('production',19,'node',0.508221),('productivity',47,'node',26),('profile',19,'node',0.554747),('program',19,'node',0.71),('proident',2,'node',1),('proident',3,'node',3.76002),('proident',4,'node',2.49686),('proident',5,'node',2.50566),('proident',6,'node',2.50566),('proident',7,'node',3.80333),('proident',8,'node',1.50266),('proident',9,'node',3.79237),('proident',12,'node',2.47945),('proident',17,'node',3.76002),('proident',27,'node',2.47945),('proident',28,'node',2.51452),('proident',29,'node',2.47084),('proident',30,'node',2.47945),('proident',31,'node',2.68074),('proident',39,'node',2.28145),('proident',40,'node',1),('proident',41,'node',1),('proident',47,'node',3.7494),('proident',54,'node',3.73887),('proident',55,'node',3.70775),('proident',56,'node',3.83673),('proin',3,'node',0.800068),('proin',4,'node',2),('proin',5,'node',2),('proin',6,'node',2),('proin',7,'node',3.30869),('proin',8,'node',3.19173),('proin',9,'node',1.49346),('proin',10,'node',3),('proin',11,'node',2.85746),('proin',12,'node',2),('proin',13,'node',3),('proin',27,'node',2),('proin',28,'node',2),('proin',29,'node',2),('proin',30,'node',2),('proin',31,'node',2),('proin',33,'node',3),('proin',34,'node',1.82776),('proin',35,'node',1),('proin',36,'node',1),('proin',37,'node',1),('proin',38,'node',1.83645),('proin',39,'node',1),('proin',42,'node',2),('proin',43,'node',2),('proin',44,'node',2),('proin',45,'node',2),('proin',46,'node',2),('proin',48,'node',1),('proin',49,'node',1),('proin',50,'node',1),('proin',53,'node',2),('proin',57,'node',2),('proin',59,'node',1),('proin',60,'node',1),('proin',63,'node',1),('proin',65,'node',27),('proin',66,'node',1.98902),('proin',67,'node',1),('project',53,'node',26),('promotion',17,'node',26),('prompt',19,'node',1.16187),('prompted',19,'node',0.993146),('properly',19,'node',0.444243),('proven',37,'node',26),('proves',21,'node',0.980874),('provide',16,'node',3.57945),('provide',68,'node',3.55821),('provided',19,'node',1),('providers',19,'node',0.595774),('providing',16,'node',1.66851),('providing',68,'node',1.66482),('publicftp',19,'node',0.860547),('publichtml',19,'node',4.49952),('pulvinar',4,'node',1),('pulvinar',5,'node',1),('pulvinar',6,'node',1),('pulvinar',7,'node',2.45994),('pulvinar',8,'node',2.47961),('pulvinar',9,'node',0.830633),('pulvinar',10,'node',1),('pulvinar',11,'node',2),('pulvinar',12,'node',1.72942),('pulvinar',14,'node',1),('pulvinar',27,'node',1),('pulvinar',28,'node',1),('pulvinar',29,'node',1),('pulvinar',30,'node',1),('pulvinar',31,'node',1.74762),('pulvinar',34,'node',2.63898),('pulvinar',35,'node',0.980874),('pulvinar',38,'node',2.65602),('pulvinar',42,'node',1.87313),('pulvinar',43,'node',1.87313),('pulvinar',44,'node',1.87313),('pulvinar',45,'node',1.87313),('pulvinar',46,'node',1.87313),('pulvinar',49,'node',2),('pulvinar',50,'node',1),('pulvinar',52,'node',1),('pulvinar',54,'node',0.76188),('pulvinar',55,'node',0.854391),('pulvinar',56,'node',0.827757),('pulvinar',57,'node',1.87634),('pulvinar',59,'node',26),('pulvinar',61,'node',1),('pulvinar',62,'node',2),('pulvinar',63,'node',1),('pulvinar',64,'node',1),('pulvinar',67,'node',29),('purus',3,'node',1),('purus',4,'node',2.98902),('purus',5,'node',2.99315),('purus',6,'node',2.99315),('purus',7,'node',4.79875),('purus',8,'node',6.73004),('purus',9,'node',1.83645),('purus',11,'node',0.953396),('purus',12,'node',2.98087),('purus',13,'node',27),('purus',14,'node',1),('purus',17,'node',1),('purus',27,'node',2.98087),('purus',28,'node',3.76162),('purus',29,'node',2.97685),('purus',30,'node',2.98087),('purus',31,'node',1),('purus',33,'node',2),('purus',34,'node',4.67848),('purus',36,'node',1),('purus',38,'node',4.70896),('purus',39,'node',2),('purus',42,'node',2.74626),('purus',43,'node',2.74626),('purus',44,'node',2.74626),('purus',45,'node',2.74626),('purus',46,'node',2.74626),('purus',47,'node',1),('purus',49,'node',1),('purus',50,'node',1),('purus',51,'node',2),('purus',53,'node',5.90657),('purus',54,'node',1),('purus',55,'node',0.989021),('purus',56,'node',1),('purus',57,'node',2.75267),('purus',59,'node',1),('purus',60,'node',2),('purus',62,'node',2),('purus',63,'node',1),('purus',64,'node',2),('purus',65,'node',1),('put',19,'node',0.481063),('qgluydime4',25,'node',2),('quae',3,'node',4.73288),('quae',4,'node',2.40982),('quae',5,'node',2.41796),('quae',6,'node',2.41796),('quae',7,'node',4.79235),('quae',8,'node',1.44179),('quae',9,'node',4.7773),('quae',12,'node',2.39372),('quae',17,'node',4.73288),('quae',27,'node',2.39372),('quae',28,'node',2.42615),('quae',29,'node',2.38575),('quae',30,'node',2.39372),('quae',31,'node',3.64057),('quae',40,'node',1),('quae',41,'node',1),('quae',47,'node',4.71831),('quae',54,'node',4.70385),('quae',55,'node',4.66115),('quae',56,'node',4.83673),('quam',3,'node',1),('quam',4,'node',1),('quam',5,'node',1.73165),('quam',6,'node',1),('quam',7,'node',23.3742),('quam',8,'node',3.87357),('quam',9,'node',1.83353),('quam',10,'node',2.7686),('quam',11,'node',6),('quam',12,'node',21.6673),('quam',13,'node',2),('quam',14,'node',2),('quam',15,'node',2.69883),('quam',17,'node',1),('quam',27,'node',1),('quam',28,'node',1),('quam',29,'node',1),('quam',30,'node',1.72283),('quam',31,'node',2.52913),('quam',33,'node',1),('quam',34,'node',2.64509),('quam',36,'node',4),('quam',37,'node',5.87115),('quam',38,'node',2.66226),('quam',39,'node',2),('quam',47,'node',1),('quam',48,'node',2),('quam',50,'node',2),('quam',52,'node',2),('quam',53,'node',11.3892),('quam',54,'node',1),('quam',55,'node',1.73614),('quam',56,'node',1),('quam',58,'node',3),('quam',60,'node',1),('quam',61,'node',1),('quam',62,'node',1),('quam',64,'node',1),('quam',66,'node',1),('quam',67,'node',1),('quasi',3,'node',4.73288),('quasi',4,'node',2.39492),('quasi',5,'node',2.40295),('quasi',6,'node',2.40295),('quasi',7,'node',4.79235),('quasi',8,'node',1.43074),('quasi',9,'node',4.7773),('quasi',12,'node',2.37903),('quasi',17,'node',4.73288),('quasi',27,'node',2.37903),('quasi',28,'node',2.41103),('quasi',29,'node',2.37117),('quasi',30,'node',2.37903),('quasi',31,'node',3.64057),('quasi',40,'node',1),('quasi',41,'node',1),('quasi',47,'node',4.71831),('quasi',54,'node',4.70385),('quasi',55,'node',4.66115),('quasi',56,'node',4.83673),('question',1,'node',1),('question',19,'node',0.482973),('question',69,'node',1),('questioned',16,'node',1),('questioned',68,'node',1),('queue',16,'node',0.718502),('queue',68,'node',0.714225),('qui',2,'node',2),('qui',3,'node',4.68745),('qui',4,'node',3.28066),('qui',5,'node',3.29202),('qui',6,'node',3.29202),('qui',7,'node',4.74542),('qui',8,'node',1.49482),('qui',9,'node',4.73076),('qui',12,'node',3.25818),('qui',17,'node',4.68745),('qui',27,'node',3.25818),('qui',28,'node',3.30346),('qui',29,'node',3.24706),('qui',30,'node',3.25818),('qui',31,'node',3.55225),('qui',39,'node',3.77388),('qui',40,'node',1),('qui',41,'node',1),('qui',47,'node',4.67324),('qui',54,'node',4.65914),('qui',55,'node',4.61749),('qui',56,'node',4.79012),('quia',3,'node',1.86987),('quia',4,'node',1.60304),('quia',5,'node',1.60843),('quia',6,'node',1.60843),('quia',7,'node',1.89968),('quia',9,'node',1.89214),('quia',12,'node',1.59237),('quia',17,'node',1.86987),('quia',27,'node',1.59237),('quia',28,'node',1.61385),('quia',29,'node',1.58709),('quia',30,'node',1.59237),('quia',31,'node',1.78242),('quia',47,'node',1.86256),('quia',54,'node',1.85532),('quia',55,'node',1.83391),('quia',56,'node',1.92268),('quickly',19,'node',0.500884),('quis',2,'node',2.84793),('quis',3,'node',1.97685),('quis',4,'node',3),('quis',5,'node',4.46107),('quis',6,'node',3),('quis',7,'node',10.9925),('quis',8,'node',2.95401),('quis',9,'node',2.8284),('quis',10,'node',4.86995),('quis',11,'node',6),('quis',12,'node',3.72502),('quis',13,'node',4),('quis',14,'node',5),('quis',15,'node',2.41514),('quis',17,'node',1.97685),('quis',26,'node',2),('quis',27,'node',3),('quis',28,'node',3),('quis',29,'node',3),('quis',30,'node',3),('quis',31,'node',4.23021),('quis',33,'node',1),('quis',34,'node',2.56313),('quis',35,'node',2),('quis',36,'node',3),('quis',37,'node',5.74227),('quis',38,'node',2.59104),('quis',39,'node',10.0542),('quis',42,'node',9.26178),('quis',43,'node',9.26178),('quis',44,'node',9.26178),('quis',45,'node',9.26178),('quis',46,'node',9.26178),('quis',47,'node',1.97286),('quis',48,'node',1.94216),('quis',49,'node',5),('quis',50,'node',1),('quis',51,'node',2),('quis',52,'node',2),('quis',53,'node',11.1587),('quis',54,'node',3.69325),('quis',55,'node',6.50724),('quis',56,'node',2.80545),('quis',57,'node',9.27819),('quis',58,'node',3),('quis',59,'node',1),('quis',60,'node',2),('quis',61,'node',3),('quis',62,'node',3),('quis',63,'node',1),('quis',65,'node',28),('quis',66,'node',3),('quis',67,'node',29),('quisque',4,'node',1),('quisque',5,'node',1),('quisque',6,'node',1),('quisque',7,'node',2.48904),('quisque',8,'node',18.9014),('quisque',11,'node',0.927431),('quisque',12,'node',1),('quisque',13,'node',1),('quisque',15,'node',1.66791),('quisque',26,'node',2),('quisque',27,'node',1),('quisque',28,'node',1.76431),('quisque',29,'node',1),('quisque',30,'node',1),('quisque',34,'node',0.942091),('quisque',37,'node',1.90286),('quisque',38,'node',0.953396),('quisque',39,'node',3),('quisque',42,'node',3.75831),('quisque',43,'node',3.75831),('quisque',44,'node',3.75831),('quisque',45,'node',3.75831),('quisque',46,'node',3.75831),('quisque',47,'node',0.736141),('quisque',50,'node',1),('quisque',51,'node',1),('quisque',54,'node',0.851346),('quisque',55,'node',2.37015),('quisque',57,'node',3.76501),('quisque',58,'node',2),('quisque',62,'node',1),('quisque',64,'node',1),('quisque',67,'node',1),('quod',39,'node',1.69111),('quote',23,'node',30),('quote',24,'node',31),('rain',27,'node',26),('raise',29,'node',26),('rare',16,'node',0.487816),('rating',1,'node',4.79604),('rating',3,'node',1.64979),('rating',7,'node',0.822065),('rating',15,'node',5.12732),('rating',16,'node',2.16459),('rating',17,'node',1.75952),('rating',18,'node',1),('rating',19,'node',0.438659),('rating',20,'node',0.830633),('rating',21,'node',0.830633),('rating',22,'node',0.703756),('rating',47,'node',1.54867),('rating',53,'node',7.61509),('rating',54,'node',1.54645),('rating',55,'node',2.94114),('rating',56,'node',1.7168),('rating',68,'node',0.60322),('rating',69,'node',1),('read',1,'node',1),('read',19,'node',0.479169),('read',21,'node',0.913226),('read',48,'node',10.5295),('read',49,'node',11),('read',50,'node',11),('read',51,'node',11),('read',52,'node',11),('read',69,'node',1),('reading',16,'node',0.500884),('ready',16,'node',0.774192),('ready',68,'node',0.769219),('really',19,'node',0.523573),('reasonable',16,'node',0.71),('reasonable',68,'node',0.705825),('reasons',16,'node',0.968904),('reasons',27,'node',26),('reasons',68,'node',0.96498),('rebum',2,'node',2.86941),('rebum',39,'node',6.31716),('received',19,'node',1),('recent',16,'node',0.535131),('recommended',16,'node',0.553478),('recommended',19,'node',2.0317),('recommended',20,'node',0.873132),('recommended',21,'node',16),('recommended',22,'node',6.86995),('red',44,'node',26),('refer',22,'node',0.792123),('reflect',19,'node',5),('refresh',19,'node',0.623497),('refreshes',19,'node',0.59873),('register',1,'node',3.9293),('register',3,'node',1.63457),('register',5,'node',3.21563),('register',7,'node',14.0754),('register',8,'node',5.59213),('register',9,'node',4.80289),('register',10,'node',1.79619),('register',11,'node',3.79686),('register',12,'node',1.62952),('register',16,'node',1.05417),('register',30,'node',1.61951),('register',31,'node',4.8466),('register',37,'node',1.77799),('register',47,'node',1.5713),('register',53,'node',14.7127),('register',54,'node',1.53477),('register',55,'node',2.87664),('register',56,'node',1.72554),('relaxdaily',35,'node',26),('release',16,'node',11.2314),('release',68,'node',4.94906),('released',16,'node',6.66413),('released',68,'node',6.07501),('releases',16,'node',1.86706),('releases',19,'node',0.486839),('releases',68,'node',0.842342),('rely',16,'node',0.620288),('rely',19,'node',0.474499),('rely',68,'node',0.617112),('rem',3,'node',4.73288),('rem',4,'node',2.42214),('rem',5,'node',2.43036),('rem',6,'node',2.43036),('rem',7,'node',4.79235),('rem',8,'node',1.45089),('rem',9,'node',4.7773),('rem',12,'node',2.40586),('rem',17,'node',4.73288),('rem',27,'node',2.40586),('rem',28,'node',2.43864),('rem',29,'node',2.3978),('rem',30,'node',2.40586),('rem',31,'node',3.64057),('rem',40,'node',1),('rem',41,'node',1),('rem',47,'node',4.71831),('rem',54,'node',4.70385),('rem',55,'node',4.66115),('rem',56,'node',4.83673),('remotehost',19,'node',0.530446),('remoteuser',19,'node',0.529288),('remove',19,'node',1.7717),('rename',19,'node',0.7017),('replacements',22,'node',2),('reports',16,'node',1.0371),('reprehenderit',39,'node',2.21307),('reprehenderit',40,'node',1),('reprehenderit',41,'node',1),('representatives',16,'node',1),('representatives',68,'node',1),('request',19,'node',1),('requests',17,'node',26),('require',22,'node',0.993146),('required',21,'node',0.927431),('requirement',16,'node',0.945829),('requirement',68,'node',0.942091),('requirements',20,'node',59.7763),('requires',20,'node',1),('requires',21,'node',0.848323),('requires',22,'node',2),('research',21,'node',0.997306),('researchers',21,'node',0.98493),('resources',16,'node',0.630018),('resources',68,'node',0.62674),('responsive',5,'node',8.51611),('restart',19,'node',0.600219),('retina',3,'node',26),('review',16,'node',0.689612),('review',17,'node',26),('review',68,'node',0.685676),('rewrite',21,'node',0.857458),('rewriting',21,'node',0.920273),('rhoncus',4,'node',2),('rhoncus',5,'node',2),('rhoncus',6,'node',2),('rhoncus',7,'node',2.53508),('rhoncus',8,'node',4.01432),('rhoncus',9,'node',0.902857),('rhoncus',10,'node',1.87634),('rhoncus',11,'node',0.934703),('rhoncus',12,'node',2),('rhoncus',13,'node',2),('rhoncus',15,'node',0.879565),('rhoncus',27,'node',2),('rhoncus',28,'node',2),('rhoncus',29,'node',2),('rhoncus',30,'node',2),('rhoncus',31,'node',3.56967),('rhoncus',34,'node',2.70324),('rhoncus',35,'node',1),('rhoncus',37,'node',1.91323),('rhoncus',38,'node',2.72166),('rhoncus',39,'node',1),('rhoncus',42,'node',2.97286),('rhoncus',43,'node',2.97286),('rhoncus',44,'node',2.97286),('rhoncus',45,'node',2.97286),('rhoncus',46,'node',2.97286),('rhoncus',47,'node',0.842342),('rhoncus',48,'node',1),('rhoncus',50,'node',1),('rhoncus',51,'node',2),('rhoncus',52,'node',1),('rhoncus',53,'node',1.91674),('rhoncus',57,'node',2.97286),('rhoncus',58,'node',2),('rhoncus',59,'node',1),('rhoncus',60,'node',1),('rhoncus',62,'node',1),('rhoncus',63,'node',1),('rhoncus',64,'node',1),('rhoncus',65,'node',2),('rhoncus',66,'node',2),('rhoncus',67,'node',2),('ridiculus',7,'node',0.628375),('ridiculus',10,'node',1),('ridiculus',53,'node',0.771698),('ridiculus',65,'node',1),('ridiculus',66,'node',0.997306),('right',19,'node',1),('right',24,'node',1),('rights',22,'node',2.98902),('rigorous',16,'node',0.942091),('rigorous',68,'node',0.938382),('risus',3,'node',1),('risus',7,'node',2.31473),('risus',8,'node',3.49266),('risus',9,'node',1),('risus',15,'node',1.53581),('risus',17,'node',1),('risus',28,'node',0.781775),('risus',34,'node',4.32522),('risus',35,'node',1.92607),('risus',36,'node',1),('risus',38,'node',4.36031),('risus',42,'node',4.58043),('risus',43,'node',4.58043),('risus',44,'node',4.58043),('risus',45,'node',4.58043),('risus',46,'node',4.58043),('risus',47,'node',1),('risus',48,'node',2),('risus',50,'node',1),('risus',51,'node',1),('risus',53,'node',0.949597),('risus',54,'node',1),('risus',55,'node',1),('risus',56,'node',1),('risus',57,'node',4.59021),('risus',63,'node',1),('risus',64,'node',2),('risus',65,'node',3),('risus',66,'node',1),('risus',67,'node',1),('rm',19,'node',0.771698),('room',4,'node',26),('room',19,'node',0.749958),('rss',16,'node',0.537506),('rules',21,'node',0.916736),('run',19,'node',0.469921),('run',20,'node',1),('run',22,'node',1.7767),('running',6,'node',8.57154),('rutrum',5,'node',0.7017),('rutrum',7,'node',3.18377),('rutrum',8,'node',2.35046),('rutrum',9,'node',0.863659),('rutrum',11,'node',2),('rutrum',13,'node',1),('rutrum',14,'node',1),('rutrum',15,'node',1.53848),('rutrum',28,'node',0.779231),('rutrum',30,'node',20.5993),('rutrum',31,'node',18.9438),('rutrum',33,'node',1),('rutrum',34,'node',1),('rutrum',36,'node',1),('rutrum',37,'node',2.96621),('rutrum',38,'node',1),('rutrum',39,'node',2),('rutrum',42,'node',1.89272),('rutrum',43,'node',1.89272),('rutrum',44,'node',1.89272),('rutrum',45,'node',1.89272),('rutrum',46,'node',1.89272),('rutrum',48,'node',2),('rutrum',49,'node',1),('rutrum',50,'node',2),('rutrum',52,'node',1),('rutrum',53,'node',5.52699),('rutrum',55,'node',0.876337),('rutrum',57,'node',1.89608),('rutrum',58,'node',1),('rutrum',59,'node',1),('rutrum',61,'node',1),('rutrum',63,'node',1),('rutrum',65,'node',2),('rutrum',66,'node',2),('rutrum',67,'node',1),('sadipscing',2,'node',1),('sadipscing',39,'node',3.94503),('safer',19,'node',0.448322),('sagittis',3,'node',1),('sagittis',4,'node',2.98493),('sagittis',5,'node',2.98902),('sagittis',6,'node',2.98902),('sagittis',7,'node',1.65397),('sagittis',8,'node',2.17712),('sagittis',9,'node',1),('sagittis',10,'node',2),('sagittis',11,'node',2),('sagittis',12,'node',2.97685),('sagittis',13,'node',2),('sagittis',14,'node',1),('sagittis',15,'node',3.83645),('sagittis',17,'node',1),('sagittis',27,'node',2.97685),('sagittis',28,'node',2.99315),('sagittis',29,'node',2.97286),('sagittis',30,'node',2.97685),('sagittis',31,'node',5.02441),('sagittis',33,'node',3),('sagittis',34,'node',0.899454),('sagittis',35,'node',1.98902),('sagittis',36,'node',1),('sagittis',37,'node',4),('sagittis',38,'node',0.909743),('sagittis',39,'node',1),('sagittis',42,'node',1),('sagittis',43,'node',1),('sagittis',44,'node',1),('sagittis',45,'node',1),('sagittis',46,'node',1),('sagittis',47,'node',1),('sagittis',48,'node',1),('sagittis',49,'node',2),('sagittis',51,'node',3),('sagittis',52,'node',3),('sagittis',53,'node',6.62826),('sagittis',54,'node',1),('sagittis',55,'node',2.54556),('sagittis',56,'node',1),('sagittis',57,'node',1),('sagittis',58,'node',1),('sagittis',59,'node',2),('sagittis',61,'node',2),('sagittis',62,'node',2),('sagittis',63,'node',1),('sagittis',64,'node',2),('sagittis',65,'node',1),('sagittis',67,'node',2),('same',16,'node',1),('same',68,'node',0.997306),('san',37,'node',26),('sanctus',2,'node',7.73881),('sanctus',39,'node',5.62371),('sapien',7,'node',2.08131),('sapien',8,'node',2.19351),('sapien',9,'node',1.48592),('sapien',10,'node',1),('sapien',11,'node',4.84234),('sapien',13,'node',2),('sapien',15,'node',3.3311),('sapien',26,'node',2),('sapien',29,'node',0.76188),('sapien',34,'node',0.860547),('sapien',35,'node',1),('sapien',36,'node',1),('sapien',37,'node',1),('sapien',38,'node',0.869951),('sapien',42,'node',1.89272),('sapien',43,'node',1.89272),('sapien',44,'node',1.89272),('sapien',45,'node',1.89272),('sapien',46,'node',1.89272),('sapien',50,'node',1),('sapien',51,'node',1),('sapien',52,'node',1),('sapien',53,'node',4.57587),('sapien',55,'node',0.635),('sapien',57,'node',1.89608),('sapien',58,'node',28),('sapien',61,'node',1),('sapien',62,'node',1),('sapien',63,'node',2),('sapien',64,'node',27),('sapien',65,'node',2),('sapien',66,'node',1),('sapien',67,'node',1),('sat',53,'node',6.9387),('sauce',19,'node',0.567769),('save',9,'node',26),('save',19,'node',1.10069),('savings',9,'node',9.07391),('scelerisque',3,'node',1),('scelerisque',7,'node',4.20358),('scelerisque',8,'node',0.707906),('scelerisque',9,'node',1),('scelerisque',10,'node',0.842342),('scelerisque',11,'node',2),('scelerisque',14,'node',2),('scelerisque',17,'node',1),('scelerisque',34,'node',1.61909),('scelerisque',36,'node',1),('scelerisque',38,'node',1.6357),('scelerisque',42,'node',1.98087),('scelerisque',43,'node',1.98087),('scelerisque',44,'node',1.98087),('scelerisque',45,'node',1.98087),('scelerisque',46,'node',1.98087),('scelerisque',47,'node',1),('scelerisque',53,'node',3.44839),('scelerisque',54,'node',1),('scelerisque',55,'node',1),('scelerisque',56,'node',1),('scelerisque',57,'node',1.98087),('scelerisque',60,'node',2),('scelerisque',61,'node',1),('scelerisque',66,'node',2),('scelerisque',67,'node',1),('screen',19,'node',0.759465),('sea',2,'node',7.73881),('sea',39,'node',5.63039),('sec',1,'node',1.92384),('sec',16,'node',0.577261),('sec',47,'node',0.76431),('sec',53,'node',2.05485),('sec',55,'node',0.757065),('second',16,'node',0.636679),('second',68,'node',0.63333),('secrets',28,'node',26),('section',18,'node',3),('section',20,'node',9.36481),('security',16,'node',9.32836),('security',19,'node',0.483934),('security',21,'node',1),('security',68,'node',6.05723),('sed',2,'node',4.86596),('sed',3,'node',6.66031),('sed',4,'node',5.25269),('sed',5,'node',6.70167),('sed',6,'node',5.26383),('sed',7,'node',17.9999),('sed',8,'node',9.16204),('sed',9,'node',6.71569),('sed',10,'node',4),('sed',11,'node',4.91323),('sed',12,'node',5.23063),('sed',13,'node',4),('sed',14,'node',2),('sed',15,'node',0.976851),('sed',17,'node',6.66031),('sed',27,'node',5.23063),('sed',28,'node',5.27504),('sed',29,'node',5.98894),('sed',30,'node',5.94914),('sed',31,'node',8.75274),('sed',33,'node',5),('sed',34,'node',5.97009),('sed',35,'node',1),('sed',36,'node',3),('sed',37,'node',4.85557),('sed',38,'node',6.02234),('sed',39,'node',7.53298),('sed',40,'node',1),('sed',41,'node',1),('sed',42,'node',12.9246),('sed',43,'node',12.9246),('sed',44,'node',12.9246),('sed',45,'node',12.9246),('sed',46,'node',12.9246),('sed',47,'node',9.17975),('sed',48,'node',3.98493),('sed',49,'node',2),('sed',51,'node',3),('sed',52,'node',2),('sed',53,'node',10.9017),('sed',54,'node',9.02514),('sed',55,'node',8.16904),('sed',56,'node',6.79012),('sed',57,'node',12.9473),('sed',58,'node',3),('sed',59,'node',29),('sed',60,'node',3),('sed',61,'node',28),('sed',62,'node',2),('sed',63,'node',29),('sed',64,'node',2),('sed',65,'node',6),('sed',66,'node',2),('sed',67,'node',6),('see',16,'node',1.53796),('see',19,'node',3.47074),('see',20,'node',0.860547),('see',21,'node',1),('see',22,'node',1.71423),('see',69,'node',1),('seen',1,'node',1.92384),('seen',3,'node',0.836446),('seen',15,'node',1.8249),('seen',16,'node',0.581429),('seen',47,'node',0.771698),('seen',53,'node',6.88942),('seen',54,'node',0.786915),('seen',55,'node',1.43656),('seen',56,'node',0.863659),('select',1,'node',2.81919),('select',3,'node',1.65314),('select',7,'node',0.824901),('select',15,'node',2.56366),('select',16,'node',1.0898),('select',17,'node',0.896076),('select',18,'node',1),('select',19,'node',0.439448),('select',20,'node',0.833529),('select',21,'node',0.833529),('select',22,'node',1.70376),('select',47,'node',1.55149),('select',53,'node',7.61855),('select',54,'node',1.54938),('select',55,'node',2.15181),('select',56,'node',1.72034),('select',68,'node',0.604732),('select',69,'node',1),('selecting',20,'node',1),('self',19,'node',0.469016),('selfeducation',8,'node',7.49964),('sem',1,'node',0.866793),('sem',3,'node',0.802752),('sem',7,'node',7.02028),('sem',8,'node',3.52445),('sem',9,'node',0.866793),('sem',10,'node',0.848323),('sem',11,'node',0.949597),('sem',13,'node',2),('sem',14,'node',1),('sem',15,'node',2.80275),('sem',31,'node',23.1677),('sem',33,'node',2),('sem',34,'node',0.866793),('sem',36,'node',3),('sem',37,'node',2.82297),('sem',38,'node',0.876337),('sem',39,'node',1),('sem',42,'node',3.68593),('sem',43,'node',3.68593),('sem',44,'node',3.68593),('sem',45,'node',3.68593),('sem',46,'node',3.68593),('sem',47,'node',1.67929),('sem',48,'node',2),('sem',49,'node',2),('sem',50,'node',1),('sem',51,'node',1),('sem',53,'node',5.4702),('sem',55,'node',1.56956),('sem',56,'node',0.813674),('sem',57,'node',3.69249),('sem',58,'node',4),('sem',60,'node',1),('sem',63,'node',2),('sem',65,'node',1),('sem',66,'node',2),('sem',67,'node',3),('semper',4,'node',1),('semper',5,'node',1),('semper',6,'node',1),('semper',7,'node',40.0302),('semper',8,'node',3.71031),('semper',9,'node',1.49093),('semper',10,'node',3.84832),('semper',11,'node',1.80343),('semper',12,'node',1),('semper',13,'node',2),('semper',15,'node',0.808176),('semper',27,'node',1),('semper',28,'node',1),('semper',29,'node',1),('semper',30,'node',1),('semper',31,'node',2.69099),('semper',34,'node',1),('semper',37,'node',2.91323),('semper',38,'node',1),('semper',42,'node',1.75595),('semper',43,'node',1.75595),('semper',44,'node',1.75595),('semper',45,'node',1.75595),('semper',46,'node',1.75595),('semper',48,'node',1),('semper',50,'node',2),('semper',52,'node',1),('semper',53,'node',2.65755),('semper',54,'node',0.749958),('semper',55,'node',0.650439),('semper',57,'node',1.76243),('semper',58,'node',3),('semper',62,'node',1),('semper',63,'node',2),('semper',64,'node',1),('semper',66,'node',1.98902),('semper',67,'node',1),('senectus',8,'node',0.691597),('senectus',15,'node',0.733888),('senectus',26,'node',2),('senectus',37,'node',1),('senectus',48,'node',1),('senectus',53,'node',1),('senectus',58,'node',2),('senectus',60,'node',2),('senectus',61,'node',1),('series',16,'node',0.545988),('server',19,'node',1.05601),('server',20,'node',41.363),('server',21,'node',50.1686),('server',22,'node',56.7566),('servers',21,'node',1.9689),('servers',22,'node',11.6708),('service',19,'node',1),('services',15,'node',1),('services',18,'node',2),('services',19,'node',12),('session',19,'node',1.20498),('set',19,'node',0.695602),('set',21,'node',0.902857),('set',22,'node',2.75932),('setup',19,'node',0.549707),('several',22,'node',1),('shake',1,'node',1),('shall',1,'node',1),('shall',69,'node',1),('shared',19,'node',29.5552),('shell',19,'node',3.96133),('shift',16,'node',0.902857),('shift',68,'node',0.896076),('shifted',16,'node',0.625114),('shifted',68,'node',0.621888),('short',19,'node',0.450806),('shortcode',23,'node',96),('shortcode',24,'node',16),('shortcode',25,'node',16),('shortcode',26,'node',16),('shortcodes',23,'node',26),('should',1,'node',1),('should',16,'node',0.659351),('should',19,'node',6.17642),('should',20,'node',1),('should',31,'node',26),('should',68,'node',0.655756),('should',69,'node',1),('show',17,'node',11),('sign',16,'node',0.530446),('significant',21,'node',1),('simplifies',19,'node',0.454162),('simply',22,'node',0.800068),('since',19,'node',0.547222),('sint',2,'node',1),('sint',3,'node',3.76002),('sint',4,'node',2.50808),('sint',5,'node',2.51696),('sint',6,'node',2.51696),('sint',7,'node',3.80333),('sint',8,'node',1.51066),('sint',9,'node',3.79237),('sint',12,'node',2.49049),('sint',17,'node',3.76002),('sint',27,'node',2.49049),('sint',28,'node',2.52592),('sint',29,'node',2.48179),('sint',30,'node',2.49049),('sint',31,'node',2.69232),('sint',39,'node',2.28984),('sint',40,'node',1),('sint',41,'node',1),('sint',47,'node',3.7494),('sint',54,'node',3.73887),('sint',55,'node',3.70775),('sint',56,'node',3.83673),('sit',2,'node',13.4903),('sit',3,'node',6.59524),('sit',4,'node',6.03562),('sit',5,'node',6.04931),('sit',6,'node',6.04931),('sit',7,'node',11.4159),('sit',8,'node',10.66),('sit',9,'node',10.3558),('sit',10,'node',2.86366),('sit',11,'node',1.69073),('sit',12,'node',6.00851),('sit',13,'node',1),('sit',14,'node',1),('sit',17,'node',6.59524),('sit',26,'node',4),('sit',27,'node',6.00851),('sit',28,'node',6.82498),('sit',29,'node',5.9951),('sit',30,'node',6.72702),('sit',31,'node',7.94043),('sit',33,'node',1),('sit',34,'node',4.75505),('sit',35,'node',2),('sit',37,'node',2.91323),('sit',38,'node',4.77476),('sit',39,'node',10.5687),('sit',40,'node',1),('sit',41,'node',1),('sit',42,'node',11.5464),('sit',43,'node',11.5464),('sit',44,'node',11.5464),('sit',45,'node',11.5464),('sit',46,'node',11.5464),('sit',47,'node',8.29015),('sit',48,'node',1),('sit',49,'node',1),('sit',50,'node',1),('sit',52,'node',3),('sit',53,'node',16.1034),('sit',54,'node',8.08284),('sit',55,'node',7.22625),('sit',56,'node',6.75146),('sit',57,'node',11.5562),('sit',58,'node',3),('sit',59,'node',1),('sit',60,'node',27),('sit',61,'node',1),('sit',62,'node',28),('sit',63,'node',2),('sit',64,'node',1),('sit',65,'node',1),('sit',66,'node',2.98902),('sit',67,'node',2),('site',1,'node',1),('site',16,'node',1.72927),('site',17,'node',11),('site',19,'node',2),('site',20,'node',9.43203),('site',68,'node',0.754681),('site',69,'node',1),('sitealias',19,'node',0.535131),('sites',1,'node',1.99315),('sites',16,'node',2.19016),('sites',19,'node',1.01326),('sites',23,'node',1),('sites',68,'node',1.63333),('situation',19,'node',0.923838),('skill',1,'node',0.989021),('skills',8,'node',7.52097),('slowdown',16,'node',0.931053),('slowdown',68,'node',0.927431),('slowdowns',16,'node',0.490769),('small',16,'node',0.509287),('smooth',35,'node',26),('so',16,'node',1.51798),('so',19,'node',0.650439),('so',21,'node',2),('so',22,'node',1.86995),('so',68,'node',1),('sociis',7,'node',0.641769),('sociis',10,'node',1),('sociis',53,'node',0.792123),('sociis',65,'node',1),('sociis',66,'node',1),('sociosqu',7,'node',0.597248),('sociosqu',8,'node',1),('sociosqu',10,'node',0.906287),('sociosqu',11,'node',2),('sociosqu',14,'node',1),('sociosqu',34,'node',1),('sociosqu',38,'node',1),('sociosqu',53,'node',0.643484),('sociosqu',54,'node',0.725015),('sodales',8,'node',2.85746),('sodales',10,'node',1),('sodales',13,'node',1),('sodales',15,'node',2.78691),('sodales',33,'node',1),('sodales',34,'node',3.68087),('sodales',35,'node',2),('sodales',36,'node',1),('sodales',37,'node',1),('sodales',38,'node',3.69881),('sodales',39,'node',1),('sodales',42,'node',2.93105),('sodales',43,'node',2.93105),('sodales',44,'node',2.93105),('sodales',45,'node',2.93105),('sodales',46,'node',2.93105),('sodales',51,'node',1),('sodales',53,'node',4.18657),('sodales',54,'node',0.860547),('sodales',55,'node',1.50887),('sodales',57,'node',2.93105),('sodales',58,'node',1),('sodales',59,'node',1),('sodales',64,'node',1),('sodales',66,'node',1),('solely',19,'node',0.473576),('sollicitudin',1,'node',0.851346),('sollicitudin',3,'node',1.94971),('sollicitudin',4,'node',1),('sollicitudin',5,'node',1),('sollicitudin',6,'node',1),('sollicitudin',7,'node',1.98217),('sollicitudin',8,'node',2.22193),('sollicitudin',9,'node',2.69897),('sollicitudin',12,'node',1),('sollicitudin',14,'node',1),('sollicitudin',17,'node',1.94971),('sollicitudin',27,'node',1),('sollicitudin',28,'node',1),('sollicitudin',29,'node',1),('sollicitudin',30,'node',1),('sollicitudin',33,'node',1),('sollicitudin',34,'node',0.945829),('sollicitudin',35,'node',1.96498),('sollicitudin',37,'node',1),('sollicitudin',38,'node',0.957226),('sollicitudin',42,'node',0.892724),('sollicitudin',43,'node',0.892724),('sollicitudin',44,'node',0.892724),('sollicitudin',45,'node',0.892724),('sollicitudin',46,'node',0.892724),('sollicitudin',47,'node',2.80542),('sollicitudin',51,'node',1),('sollicitudin',53,'node',3.10972),('sollicitudin',54,'node',1.93388),('sollicitudin',55,'node',2.63345),('sollicitudin',56,'node',2),('sollicitudin',57,'node',0.896076),('sollicitudin',61,'node',1.9689),('sollicitudin',64,'node',1),('sollicitudin',65,'node',1),('soluta',39,'node',1.71074),('solution',21,'node',0.851346),('some',1,'node',2),('some',16,'node',0.687638),('some',19,'node',5.59577),('some',22,'node',5.44073),('some',68,'node',0.683725),('some',69,'node',2),('someone',4,'node',0.976851),('someone',5,'node',0.980874),('someone',6,'node',0.980874),('someone',8,'node',0.876337),('someone',12,'node',0.968904),('someone',27,'node',0.968904),('someone',28,'node',0.98493),('someone',29,'node',0.96498),('someone',30,'node',0.968904),('someone',34,'node',0.889397),('someone',38,'node',0.899454),('something',19,'node',0.461031),('source',4,'node',0.968904),('source',5,'node',0.972861),('source',6,'node',0.972861),('source',8,'node',0.869951),('source',12,'node',0.961087),('source',19,'node',0.625114),('source',27,'node',0.961087),('source',28,'node',0.976851),('source',29,'node',0.957226),('source',30,'node',0.961087),('source',34,'node',0.882818),('source',38,'node',0.892724),('sp2',21,'node',9.26577),('space',20,'node',19),('span',23,'node',1),('special',19,'node',0.854391),('specific',19,'node',0.638366),('specific',22,'node',0.784336),('specifically',19,'node',1.46665),('specifically',22,'node',1),('sports',12,'node',8.46141),('sql',20,'node',10.4041),('sql',22,'node',7.97517),('sqlite',20,'node',1.93485),('sqlite',22,'node',13.2033),('src',23,'node',1),('ssh',19,'node',12.281),('stable',16,'node',1.49883),('stable',19,'node',0.488796),('stable',21,'node',1),('stable',68,'node',1),('staff',37,'node',9.60445),('stand',20,'node',1),('start',1,'node',2),('start',19,'node',1.41135),('start',20,'node',11),('start',21,'node',11),('start',22,'node',11),('start',69,'node',2),('status',16,'node',2),('status',68,'node',2),('step',16,'node',0.618696),('step',19,'node',7.22973),('step',68,'node',0.615536),('stet',2,'node',7.73881),('stet',39,'node',6.38142),('sthashp70hjjcodpuf',69,'node',11),('still',19,'node',1.66482),('stop',38,'node',26),('storage',20,'node',0.953396),('storage',22,'node',1.86995),('store',54,'node',26),('street',40,'node',1),('street',41,'node',1),('string',19,'node',1),('strong',21,'node',1),('strongly',16,'node',0.533952),('subfolders',19,'node',0.672252),('subject',40,'node',1),('subject',41,'node',1),('submitted',5,'node',1.4902),('submitted',7,'node',6.58609),('submitted',8,'node',2.57544),('submitted',9,'node',2.26309),('submitted',10,'node',0.957226),('submitted',11,'node',1.85897),('submitted',12,'node',0.766757),('submitted',30,'node',0.76188),('submitted',31,'node',2.23361),('submitted',37,'node',0.857458),('substantial',1,'node',1),('success',19,'node',0.613969),('such',19,'node',0.594307),('such',22,'node',2.83645),('sufficient',22,'node',1.89608),('sun',1,'node',1),('sun',7,'node',5.79524),('sun',8,'node',2.56818),('sun',9,'node',0.740689),('sun',15,'node',1.83353),('sun',54,'node',0.805455),('sun',55,'node',1.46163),('sun',56,'node',0.879565),('sunshine',27,'node',26),('sunt',2,'node',1),('sunt',3,'node',8.4929),('sunt',4,'node',4.87372),('sunt',5,'node',4.89042),('sunt',6,'node',4.89042),('sunt',7,'node',8.59568),('sunt',8,'node',2.92216),('sunt',9,'node',8.56968),('sunt',12,'node',4.84068),('sunt',17,'node',8.4929),('sunt',27,'node',4.84068),('sunt',28,'node',4.90723),('sunt',29,'node',4.82433),('sunt',30,'node',4.84068),('sunt',31,'node',6.30243),('sunt',39,'node',2.27869),('sunt',40,'node',1),('sunt',41,'node',1),('sunt',47,'node',8.46771),('sunt',54,'node',8.44272),('sunt',55,'node',8.3689),('sunt',56,'node',8.67345),('support',15,'node',1),('support',16,'node',8.77809),('support',18,'node',11),('support',19,'node',2.49985),('support',20,'node',0.916736),('support',21,'node',1.83353),('support',22,'node',1.59315),('support',40,'node',11),('support',41,'node',11),('support',68,'node',8.74669),('supported',16,'node',2.62803),('supported',20,'node',0.938382),('supported',22,'node',1.58216),('supported',68,'node',2.61702),('supporting',20,'node',1),('supports',22,'node',5.3445),('sure',19,'node',0.482016),('suscipit',2,'node',1.91323),('suscipit',3,'node',1),('suscipit',4,'node',1),('suscipit',5,'node',1),('suscipit',6,'node',1),('suscipit',7,'node',4.07479),('suscipit',8,'node',2.88812),('suscipit',9,'node',1.83938),('suscipit',10,'node',0.839384),('suscipit',12,'node',1),('suscipit',14,'node',1),('suscipit',15,'node',1.72901),('suscipit',17,'node',1),('suscipit',27,'node',1),('suscipit',28,'node',1),('suscipit',29,'node',1),('suscipit',30,'node',1),('suscipit',33,'node',2),('suscipit',34,'node',0.938382),('suscipit',35,'node',1.97286),('suscipit',36,'node',3),('suscipit',38,'node',0.949597),('suscipit',39,'node',4.8247),('suscipit',42,'node',2.67214),('suscipit',43,'node',2.67214),('suscipit',44,'node',2.67214),('suscipit',45,'node',2.67214),('suscipit',46,'node',2.67214),('suscipit',47,'node',1),('suscipit',48,'node',1),('suscipit',53,'node',3.84793),('suscipit',54,'node',1),('suscipit',55,'node',2.66127),('suscipit',56,'node',1),('suscipit',57,'node',2.6787),('suscipit',58,'node',1),('suscipit',60,'node',1),('suscipit',61,'node',1),('suscipit',62,'node',1),('suscipit',66,'node',1),('suscipit',67,'node',1),('suspendisse',3,'node',2.75946),('suspendisse',4,'node',1),('suspendisse',5,'node',1.72066),('suspendisse',6,'node',1),('suspendisse',7,'node',7.6789),('suspendisse',8,'node',1.69762),('suspendisse',9,'node',2),('suspendisse',10,'node',1.85439),('suspendisse',12,'node',1),('suspendisse',13,'node',2),('suspendisse',14,'node',2),('suspendisse',15,'node',2.87957),('suspendisse',17,'node',2),('suspendisse',26,'node',2),('suspendisse',27,'node',1),('suspendisse',28,'node',1),('suspendisse',29,'node',1),('suspendisse',30,'node',1),('suspendisse',31,'node',1),('suspendisse',33,'node',2),('suspendisse',34,'node',2.60282),('suspendisse',36,'node',1),('suspendisse',37,'node',1),('suspendisse',38,'node',2.61909),('suspendisse',42,'node',3.74626),('suspendisse',43,'node',3.74626),('suspendisse',44,'node',3.74626),('suspendisse',45,'node',3.74626),('suspendisse',46,'node',3.74626),('suspendisse',47,'node',3.71345),('suspendisse',48,'node',2),('suspendisse',49,'node',1),('suspendisse',50,'node',1),('suspendisse',51,'node',1),('suspendisse',53,'node',9.44792),('suspendisse',54,'node',2),('suspendisse',55,'node',3.4876),('suspendisse',56,'node',4.49773),('suspendisse',57,'node',3.75267),('suspendisse',60,'node',2),('suspendisse',61,'node',0.989021),('suspendisse',63,'node',28),('suspendisse',65,'node',1),('suspendisse',66,'node',1),('symphony',1,'node',1),('symphony',69,'node',1),('system',20,'node',26),('system',22,'node',0.96498),('table',22,'node',1.75277),('tables',22,'node',2.82857),('taciti',7,'node',0.59873),('taciti',8,'node',1),('taciti',10,'node',0.909743),('taciti',11,'node',2),('taciti',14,'node',1),('taciti',34,'node',1),('taciti',38,'node',1),('taciti',53,'node',0.645209),('taciti',54,'node',0.727213),('take',19,'node',0.463662),('takimata',2,'node',7.73881),('takimata',39,'node',5.62703),('tation',2,'node',1.91323),('tation',39,'node',3.83056),('te',2,'node',1),('te',39,'node',1.49095),('teach',19,'node',0.441034),('teaching',8,'node',26),('team',16,'node',6.11526),('team',68,'node',6.09186),('tech',19,'node',1),('technical',16,'node',0.662985),('technical',68,'node',0.659351),('tellus',3,'node',1.61909),('tellus',7,'node',5.65188),('tellus',8,'node',4.8418),('tellus',9,'node',0.842342),('tellus',10,'node',0.854391),('tellus',11,'node',30.7868),('tellus',13,'node',3),('tellus',15,'node',1.64228),('tellus',31,'node',0.836446),('tellus',34,'node',1.63974),('tellus',35,'node',1.96498),('tellus',37,'node',0.920273),('tellus',38,'node',1.6568),('tellus',39,'node',1),('tellus',42,'node',3.82916),('tellus',43,'node',3.82916),('tellus',44,'node',3.82916),('tellus',45,'node',3.82916),('tellus',46,'node',3.82916),('tellus',48,'node',1),('tellus',49,'node',2),('tellus',52,'node',3),('tellus',53,'node',3.27818),('tellus',55,'node',0.830633),('tellus',57,'node',3.83242),('tellus',58,'node',3),('tellus',60,'node',1),('tellus',61,'node',3),('tellus',62,'node',1),('tellus',64,'node',27),('tellus',66,'node',28),('tempor',2,'node',1.98493),('tempor',5,'node',0.736141),('tempor',7,'node',0.610858),('tempor',8,'node',0.636679),('tempor',9,'node',0.896076),('tempor',15,'node',0.792123),('tempor',31,'node',0.740689),('tempor',33,'node',0.997306),('tempor',35,'node',1),('tempor',36,'node',1),('tempor',37,'node',0.902857),('tempor',39,'node',6.64692),('tempor',42,'node',1),('tempor',43,'node',1),('tempor',44,'node',1),('tempor',45,'node',1),('tempor',46,'node',1),('tempor',47,'node',0.733888),('tempor',50,'node',1),('tempor',51,'node',1),('tempor',53,'node',0.942091),('tempor',55,'node',0.745294),('tempor',57,'node',1),('tempor',59,'node',26),('tempor',62,'node',1),('tempor',64,'node',1),('tempor',65,'node',3),('temporary',22,'node',0.989021),('tempus',3,'node',1),('tempus',4,'node',2),('tempus',5,'node',2),('tempus',6,'node',2),('tempus',7,'node',5.00931),('tempus',8,'node',2.99438),('tempus',9,'node',2.49346),('tempus',11,'node',0.860547),('tempus',12,'node',2),('tempus',13,'node',1),('tempus',14,'node',1),('tempus',15,'node',1.63013),('tempus',17,'node',1),('tempus',26,'node',2),('tempus',27,'node',2),('tempus',28,'node',2),('tempus',29,'node',2),('tempus',30,'node',2),('tempus',31,'node',2.83645),('tempus',33,'node',1),('tempus',34,'node',1.80818),('tempus',35,'node',2),('tempus',36,'node',2),('tempus',37,'node',0.923838),('tempus',38,'node',1.81645),('tempus',39,'node',2),('tempus',42,'node',2.85486),('tempus',43,'node',2.85486),('tempus',44,'node',2.85486),('tempus',45,'node',2.85486),('tempus',46,'node',2.85486),('tempus',47,'node',1),('tempus',48,'node',1),('tempus',53,'node',2.62189),('tempus',54,'node',1),('tempus',55,'node',1.65397),('tempus',56,'node',1.82776),('tempus',57,'node',2.85486),('tempus',58,'node',3),('tempus',60,'node',1),('tempus',65,'node',2),('tempus',66,'node',1),('term',16,'node',0.653974),('term',68,'node',0.650439),('terminal',19,'node',1),('test',16,'node',1.64103),('test',68,'node',1.63332),('tested',22,'node',1),('testing',16,'node',0.934703),('testing',21,'node',2),('testing',22,'node',1),('testing',68,'node',0.931053),('tests',16,'node',0.836446),('tests',68,'node',0.830633),('text',19,'node',0.661163),('text',23,'node',2),('than',16,'node',1),('than',21,'node',1),('than',27,'node',26),('than',68,'node',1),('thank',34,'node',26),('that',1,'node',2),('that',16,'node',5.95901),('that',19,'node',7.34929),('that',21,'node',1.97685),('that',22,'node',4.59844),('that',30,'node',26),('that',68,'node',5.93731),('that',69,'node',2),('the',1,'node',5),('the',8,'node',26),('the',11,'node',26),('the',16,'node',32.6709),('the',18,'node',9),('the',19,'node',38.5596),('the',20,'node',8.54812),('the',21,'node',6.78489),('the',22,'node',8.46349),('the',37,'node',26),('the',53,'node',1.99731),('the',55,'node',26),('the',68,'node',24.3993),('the',69,'node',2),('thee',19,'node',0.453319),('their',16,'node',2.85358),('their',68,'node',2.83633),('them',19,'node',1.00193),('them',22,'node',1.47011),('themes',1,'node',7.2057),('themes',4,'node',8.48867),('themes',5,'node',11.362),('themes',6,'node',26),('themes',7,'node',10.2042),('themes',8,'node',7.66925),('themes',9,'node',5.73954),('themes',10,'node',3.33412),('themes',11,'node',3.62515),('themes',12,'node',2.89132),('themes',15,'node',1),('themes',16,'node',2.4467),('themes',20,'node',1),('themes',23,'node',1),('themes',28,'node',8.27543),('themes',31,'node',11.705),('themes',37,'node',3.28826),('themes',47,'node',2.90885),('themes',53,'node',8.05355),('themes',55,'node',2.79049),('themes',56,'node',3.20027),('then',19,'node',3.25966),('then',22,'node',0.794753),('thepianoguys',36,'node',26),('there',16,'node',1.86045),('there',19,'node',1.61684),('there',21,'node',2),('there',22,'node',1),('there',68,'node',0.781775),('these',16,'node',0.676032),('these',20,'node',12),('these',22,'node',1),('these',68,'node',0.672252),('they',19,'node',0.475426),('they',22,'node',1),('things',19,'node',0.501918),('thinking',1,'node',1),('thinking',69,'node',1),('third',21,'node',1.71814),('this',1,'node',1),('this',16,'node',7.28741),('this',19,'node',15.9866),('this',20,'node',1),('this',22,'node',0.942091),('this',23,'node',20),('this',24,'node',5),('this',68,'node',5.21589),('this',69,'node',1),('those',19,'node',0.526987),('those',22,'node',1.47472),('thoughts',5,'node',26),('three',16,'node',1),('three',68,'node',1),('through',19,'node',0.494765),('throughout',19,'node',0.740689),('thu',1,'node',0.938382),('ticket',19,'node',1),('time',16,'node',2.33807),('time',19,'node',2.72189),('time',55,'node',52),('time',68,'node',2.32285),('tincidunt',2,'node',1.8843),('tincidunt',3,'node',1),('tincidunt',4,'node',3),('tincidunt',5,'node',3.73165),('tincidunt',6,'node',3),('tincidunt',7,'node',3.6344),('tincidunt',8,'node',6.1393),('tincidunt',9,'node',2.49856),('tincidunt',10,'node',3.69665),('tincidunt',11,'node',4.86055),('tincidunt',12,'node',4.45003),('tincidunt',13,'node',3),('tincidunt',14,'node',3),('tincidunt',15,'node',1.70031),('tincidunt',17,'node',1),('tincidunt',26,'node',2),('tincidunt',27,'node',3),('tincidunt',28,'node',3),('tincidunt',29,'node',3.76922),('tincidunt',30,'node',3),('tincidunt',31,'node',2),('tincidunt',33,'node',1),('tincidunt',34,'node',4.78443),('tincidunt',35,'node',1),('tincidunt',36,'node',2),('tincidunt',37,'node',5.83353),('tincidunt',38,'node',4.80474),('tincidunt',39,'node',3),('tincidunt',42,'node',2.92645),('tincidunt',43,'node',2.92645),('tincidunt',44,'node',2.92645),('tincidunt',45,'node',2.92645),('tincidunt',46,'node',2.92645),('tincidunt',47,'node',1),('tincidunt',49,'node',1),('tincidunt',50,'node',4),('tincidunt',51,'node',2),('tincidunt',52,'node',1),('tincidunt',53,'node',1.86889),('tincidunt',54,'node',1),('tincidunt',55,'node',1.64521),('tincidunt',56,'node',1.83353),('tincidunt',57,'node',2.92645),('tincidunt',58,'node',2),('tincidunt',60,'node',2),('tincidunt',64,'node',3),('tincidunt',65,'node',1),('tincidunt',66,'node',2),('tip',19,'node',1.45883),('tips',53,'node',26),('title',4,'node',0.96498),('title',5,'node',0.968904),('title',6,'node',0.968904),('title',8,'node',0.866793),('title',12,'node',0.957226),('title',24,'node',1),('title',26,'node',2),('title',27,'node',0.957226),('title',28,'node',0.972861),('title',29,'node',0.953396),('title',30,'node',0.957226),('title',34,'node',0.879565),('title',38,'node',0.889397),('to',1,'node',4.76315),('to',3,'node',0.740689),('to',5,'node',1.45934),('to',7,'node',6.39563),('to',8,'node',28.5402),('to',9,'node',28.1808),('to',10,'node',26.8137),('to',11,'node',1.72254),('to',12,'node',0.738408),('to',16,'node',25.4841),('to',18,'node',2),('to',19,'node',28.9463),('to',20,'node',1),('to',21,'node',8.62526),('to',22,'node',6.24047),('to',29,'node',26),('to',30,'node',0.733888),('to',31,'node',2.20052),('to',37,'node',0.805455),('to',47,'node',0.712106),('to',53,'node',6.68517),('to',54,'node',26.6956),('to',55,'node',27.3056),('to',56,'node',0.781775),('to',68,'node',22.382),('to',69,'node',1),('together',16,'node',0.725015),('together',68,'node',0.72066),('tomorrow',1,'node',2),('too',22,'node',0.934703),('tooltip',24,'node',28),('top',1,'node',19.7304),('top',3,'node',8.24953),('top',15,'node',17.1282),('top',16,'node',5.28126),('top',24,'node',1),('top',47,'node',7.92726),('top',53,'node',73.6435),('top',54,'node',7.74132),('top',55,'node',14.4483),('top',56,'node',8.71335),('torquent',7,'node',0.592848),('torquent',8,'node',1),('torquent',10,'node',0.896076),('torquent',11,'node',2),('torquent',14,'node',1),('torquent',34,'node',1),('torquent',38,'node',1),('torquent',53,'node',0.638366),('torquent',54,'node',0.718502),('tortor',4,'node',2),('tortor',5,'node',2),('tortor',6,'node',2),('tortor',7,'node',3.10731),('tortor',8,'node',3.44151),('tortor',10,'node',3.69665),('tortor',11,'node',2),('tortor',12,'node',2.72502),('tortor',13,'node',1),('tortor',15,'node',0.945829),('tortor',27,'node',2),('tortor',28,'node',2),('tortor',29,'node',2),('tortor',30,'node',2),('tortor',31,'node',1),('tortor',33,'node',1),('tortor',34,'node',2.76985),('tortor',35,'node',1),('tortor',36,'node',1),('tortor',37,'node',1),('tortor',38,'node',2.78984),('tortor',39,'node',1),('tortor',42,'node',0.957226),('tortor',43,'node',0.957226),('tortor',44,'node',0.957226),('tortor',45,'node',0.957226),('tortor',46,'node',0.957226),('tortor',48,'node',2),('tortor',49,'node',3),('tortor',50,'node',2),('tortor',51,'node',1),('tortor',52,'node',2),('tortor',53,'node',3.2534),('tortor',54,'node',0.745294),('tortor',55,'node',1.38656),('tortor',57,'node',0.957226),('tortor',58,'node',1),('tortor',61,'node',30),('tortor',63,'node',2),('tortor',64,'node',2),('tortor',65,'node',1),('totam',3,'node',4.73288),('totam',4,'node',2.42527),('totam',5,'node',2.43352),('totam',6,'node',2.43352),('totam',7,'node',4.79235),('totam',8,'node',1.4532),('totam',9,'node',4.7773),('totam',12,'node',2.40895),('totam',17,'node',4.73288),('totam',27,'node',2.40895),('totam',28,'node',2.44182),('totam',29,'node',2.40087),('totam',30,'node',2.40895),('totam',31,'node',3.64057),('totam',40,'node',1),('totam',41,'node',1),('totam',47,'node',4.71831),('totam',54,'node',4.70385),('totam',55,'node',4.66115),('totam',56,'node',4.83673),('touch',19,'node',0.557303),('track',53,'node',1),('transform',30,'node',26),('transition',16,'node',1),('transition',68,'node',1),('travel',7,'node',9.10533),('travel',55,'node',26),('travelers',12,'node',26),('traveling',55,'node',26),('tree',19,'node',7.95114),('tristique',3,'node',1.54124),('tristique',7,'node',2.13855),('tristique',8,'node',2.19569),('tristique',9,'node',2.98706),('tristique',10,'node',2),('tristique',11,'node',1.706),('tristique',15,'node',1.65773),('tristique',26,'node',2),('tristique',34,'node',0.827757),('tristique',37,'node',2),('tristique',38,'node',0.836446),('tristique',39,'node',1),('tristique',42,'node',1),('tristique',43,'node',1),('tristique',44,'node',1),('tristique',45,'node',1),('tristique',46,'node',1),('tristique',48,'node',1),('tristique',52,'node',1),('tristique',53,'node',1),('tristique',57,'node',1),('tristique',58,'node',2),('tristique',59,'node',1),('tristique',60,'node',2),('tristique',61,'node',2),('tristique',63,'node',1),('tristique',66,'node',2),('tristique',67,'node',2),('troubleshooting',20,'node',9.23322),('troubleshooting',22,'node',0.781775),('try',19,'node',1.11463),('trying',19,'node',0.520204),('tue',3,'node',0.857458),('tue',5,'node',1.48067),('tue',10,'node',0.945829),('tue',47,'node',0.78951),('turn',19,'node',0.561181),('turpis',4,'node',1),('turpis',5,'node',1.73614),('turpis',6,'node',1),('turpis',7,'node',0.657549),('turpis',8,'node',4.8801),('turpis',9,'node',0.869951),('turpis',10,'node',2),('turpis',11,'node',0.913226),('turpis',12,'node',1),('turpis',14,'node',1),('turpis',15,'node',4.82804),('turpis',26,'node',2),('turpis',27,'node',1),('turpis',28,'node',1),('turpis',29,'node',1),('turpis',30,'node',1),('turpis',31,'node',1.72502),('turpis',33,'node',1),('turpis',34,'node',2.87313),('turpis',35,'node',1),('turpis',36,'node',1),('turpis',37,'node',1),('turpis',38,'node',2.88282),('turpis',42,'node',2.93838),('turpis',43,'node',2.93838),('turpis',44,'node',2.93838),('turpis',45,'node',2.93838),('turpis',46,'node',2.93838),('turpis',47,'node',1.71345),('turpis',48,'node',5),('turpis',49,'node',2),('turpis',50,'node',1),('turpis',51,'node',4),('turpis',52,'node',3),('turpis',53,'node',6.96061),('turpis',54,'node',0.889397),('turpis',57,'node',2.93838),('turpis',58,'node',2),('turpis',59,'node',2),('turpis',60,'node',2),('turpis',61,'node',2),('turpis',62,'node',1),('turpis',63,'node',29),('turpis',65,'node',1),('turpis',66,'node',1),('turpis',67,'node',2),('tweak',1,'node',1),('tweak',69,'node',1),('twice',19,'node',0.478227),('type',19,'node',6.03295),('type',23,'node',1),('types',22,'node',1.74952),('typing',19,'node',6.06429),('ui',16,'node',0.784336),('ui',68,'node',0.779231),('ullamco',2,'node',0.931053),('ullamcorper',2,'node',1.91323),('ullamcorper',5,'node',0.712106),('ullamcorper',7,'node',19.6835),('ullamcorper',8,'node',1.62069),('ullamcorper',15,'node',0.749958),('ullamcorper',26,'node',2),('ullamcorper',33,'node',2),('ullamcorper',34,'node',1),('ullamcorper',35,'node',1),('ullamcorper',37,'node',23.2916),('ullamcorper',38,'node',1),('ullamcorper',39,'node',3.82762),('ullamcorper',42,'node',1.90974),('ullamcorper',43,'node',1.90974),('ullamcorper',44,'node',1.90974),('ullamcorper',45,'node',1.90974),('ullamcorper',46,'node',1.90974),('ullamcorper',48,'node',1),('ullamcorper',49,'node',2),('ullamcorper',50,'node',2),('ullamcorper',53,'node',3.38029),('ullamcorper',54,'node',2.27405),('ullamcorper',55,'node',0.636679),('ullamcorper',57,'node',1.90974),('ullamcorper',61,'node',1),('ullamcorper',63,'node',1),('ullamcorper',65,'node',2),('ullamcorper',67,'node',1),('ultrices',3,'node',1.76922),('ultrices',4,'node',2),('ultrices',5,'node',2),('ultrices',6,'node',2),('ultrices',7,'node',2.41823),('ultrices',8,'node',4.37848),('ultrices',9,'node',2.49093),('ultrices',10,'node',3),('ultrices',11,'node',0.845322),('ultrices',12,'node',2),('ultrices',17,'node',1),('ultrices',27,'node',2),('ultrices',28,'node',2.76922),('ultrices',29,'node',2),('ultrices',30,'node',2),('ultrices',31,'node',2.71636),('ultrices',33,'node',1),('ultrices',34,'node',4.51518),('ultrices',36,'node',2),('ultrices',37,'node',1.95723),('ultrices',38,'node',4.54197),('ultrices',39,'node',1),('ultrices',42,'node',2.76586),('ultrices',43,'node',2.76586),('ultrices',44,'node',2.76586),('ultrices',45,'node',2.76586),('ultrices',46,'node',2.76586),('ultrices',47,'node',1),('ultrices',48,'node',1.99731),('ultrices',49,'node',1),('ultrices',53,'node',2.88664),('ultrices',54,'node',1),('ultrices',55,'node',1),('ultrices',56,'node',1),('ultrices',57,'node',2.77241),('ultrices',62,'node',3),('ultrices',63,'node',1),('ultrices',65,'node',2),('ultricies',7,'node',0.71),('ultricies',8,'node',18.6868),('ultricies',10,'node',0.866793),('ultricies',11,'node',4),('ultricies',14,'node',1),('ultricies',33,'node',2.99045),('ultricies',34,'node',1),('ultricies',36,'node',1),('ultricies',37,'node',0.836446),('ultricies',38,'node',1),('ultricies',42,'node',0.968904),('ultricies',43,'node',0.968904),('ultricies',44,'node',0.968904),('ultricies',45,'node',0.968904),('ultricies',46,'node',0.968904),('ultricies',48,'node',1),('ultricies',52,'node',1),('ultricies',53,'node',3.31444),('ultricies',55,'node',0.733888),('ultricies',57,'node',0.968904),('ultricies',62,'node',1),('unde',3,'node',5.66031),('unde',4,'node',3.24931),('unde',5,'node',3.26042),('unde',6,'node',3.26042),('unde',7,'node',5.73444),('unde',8,'node',1.47466),('unde',9,'node',5.71569),('unde',12,'node',3.22731),('unde',17,'node',5.66031),('unde',27,'node',3.22731),('unde',28,'node',3.27161),('unde',29,'node',3.21642),('unde',30,'node',3.22731),('unde',31,'node',4.52338),('unde',40,'node',1),('unde',41,'node',1),('unde',47,'node',5.64215),('unde',54,'node',5.62412),('unde',55,'node',5.57089),('unde',56,'node',5.79012),('under',21,'node',11.3319),('undergo',16,'node',0.845322),('undergo',68,'node',0.839384),('undergone',22,'node',1),('underneath',19,'node',0.63333),('understand',19,'node',1.51225),('unexpected',20,'node',0.882818),('unix',21,'node',2),('unsupported',16,'node',4.63668),('unsupported',68,'node',4.63333),('until',1,'node',1),('until',16,'node',0.827757),('until',68,'node',0.822065),('unzip',19,'node',0.776703),('up',16,'node',2.1464),('up',19,'node',1.16387),('up',22,'node',0.848323),('up',68,'node',1.61397),('update',16,'node',2.12537),('update',19,'node',5),('update',22,'node',1),('update',68,'node',0.60778),('updates',3,'node',26),('updates',16,'node',1.23455),('updates',68,'node',0.707906),('upgrade',16,'node',1.66955),('upgrade',19,'node',1),('upgrade',68,'node',1.65795),('upgrading',16,'node',0.556022),('upload',19,'node',0.718502),('uploaded',20,'node',1),('upon',20,'node',1),('url',21,'node',1.7813),('urls',21,'node',33.8803),('urna',7,'node',0.60322),('urna',8,'node',0.839384),('urna',11,'node',2),('urna',15,'node',0.774192),('urna',31,'node',0.819249),('urna',33,'node',1),('urna',34,'node',0.851346),('urna',35,'node',1),('urna',36,'node',2),('urna',38,'node',0.860547),('urna',39,'node',1),('urna',42,'node',2.89272),('urna',43,'node',2.89272),('urna',44,'node',2.89272),('urna',45,'node',2.89272),('urna',46,'node',2.89272),('urna',50,'node',1),('urna',51,'node',1),('urna',53,'node',3.2888),('urna',55,'node',2.03435),('urna',56,'node',0.802752),('urna',57,'node',2.89608),('urna',61,'node',2),('urna',62,'node',2),('urna',65,'node',1),('urna',66,'node',1),('urna',67,'node',1),('us',15,'node',1),('us',40,'node',26),('us',41,'node',26),('usage',21,'node',1),('use',19,'node',7.75128),('use',21,'node',5.5302),('use',22,'node',1),('used',21,'node',3),('user',19,'node',1.63837),('username',19,'node',4.5709),('users',16,'node',1.78608),('users',19,'node',1),('users',20,'node',1),('users',68,'node',1.77624),('using',16,'node',0.483934),('using',19,'node',3.49937),('usr',19,'node',1.14909),('ut',1,'node',0.899454),('ut',2,'node',9.54283),('ut',3,'node',6.46577),('ut',4,'node',10.2527),('ut',5,'node',10.9955),('ut',6,'node',10.2638),('ut',7,'node',29.8192),('ut',8,'node',28.8396),('ut',9,'node',5.71569),('ut',10,'node',0.920273),('ut',11,'node',8.93105),('ut',12,'node',10.9488),('ut',13,'node',6),('ut',14,'node',2),('ut',15,'node',8.68236),('ut',17,'node',5.66031),('ut',26,'node',2),('ut',27,'node',10.2238),('ut',28,'node',10.275),('ut',29,'node',10.978),('ut',30,'node',10.2238),('ut',31,'node',10.2484),('ut',33,'node',4),('ut',34,'node',8.2568),('ut',35,'node',3),('ut',36,'node',2),('ut',37,'node',4),('ut',38,'node',8.30305),('ut',39,'node',13.8685),('ut',40,'node',1),('ut',41,'node',1),('ut',42,'node',0.876337),('ut',43,'node',0.876337),('ut',44,'node',0.876337),('ut',45,'node',0.876337),('ut',46,'node',0.876337),('ut',47,'node',6.48153),('ut',48,'node',2),('ut',49,'node',2),('ut',50,'node',2),('ut',51,'node',5),('ut',52,'node',3),('ut',53,'node',18.8829),('ut',54,'node',6.36942),('ut',55,'node',6.88244),('ut',56,'node',7.4264),('ut',57,'node',0.879565),('ut',58,'node',31),('ut',59,'node',4),('ut',60,'node',2),('ut',61,'node',2),('ut',62,'node',2),('ut',63,'node',3),('ut',64,'node',5),('ut',65,'node',3),('ut',66,'node',1),('ut',67,'node',4),('v6a',40,'node',1),('v6a',41,'node',1),('value',22,'node',1.83446),('vancouver',40,'node',1),('vancouver',41,'node',1),('variable',22,'node',0.961087),('varius',4,'node',2),('varius',5,'node',2.70376),('varius',6,'node',2),('varius',7,'node',2.47399),('varius',8,'node',19.458),('varius',12,'node',2),('varius',13,'node',2),('varius',15,'node',1),('varius',26,'node',4),('varius',27,'node',2),('varius',28,'node',2),('varius',29,'node',2.76922),('varius',30,'node',2),('varius',31,'node',2.72502),('varius',34,'node',0.993146),('varius',36,'node',1),('varius',37,'node',1),('varius',38,'node',1),('varius',48,'node',1),('varius',49,'node',2),('varius',50,'node',1),('varius',51,'node',1),('varius',53,'node',4.18074),('varius',58,'node',1),('varius',60,'node',1),('varius',61,'node',1.98902),('varius',63,'node',2),('varius',64,'node',4),('varius',65,'node',2),('varius',66,'node',1),('vast',16,'node',0.916736),('vast',68,'node',0.913226),('vehicula',3,'node',0.759465),('vehicula',7,'node',1.33436),('vehicula',8,'node',1.97685),('vehicula',10,'node',0.876337),('vehicula',14,'node',2),('vehicula',30,'node',0.725015),('vehicula',31,'node',0.697623),('vehicula',34,'node',3.6098),('vehicula',37,'node',2.83839),('vehicula',38,'node',3.63321),('vehicula',39,'node',1),('vehicula',42,'node',1.80017),('vehicula',43,'node',1.80017),('vehicula',44,'node',1.80017),('vehicula',45,'node',1.80017),('vehicula',46,'node',1.80017),('vehicula',48,'node',1),('vehicula',52,'node',1),('vehicula',53,'node',0.664818),('vehicula',55,'node',1.28183),('vehicula',57,'node',1.8034),('vehicula',60,'node',1),('vehicula',61,'node',1),('vehicula',66,'node',1),('vel',2,'node',5.73881),('vel',3,'node',1),('vel',4,'node',3),('vel',5,'node',3),('vel',6,'node',3),('vel',7,'node',6.0864),('vel',8,'node',5.05331),('vel',9,'node',1.83353),('vel',10,'node',4.84234),('vel',11,'node',6),('vel',12,'node',23.6646),('vel',13,'node',1),('vel',14,'node',3),('vel',15,'node',0.738408),('vel',17,'node',1),('vel',27,'node',2.99731),('vel',28,'node',3.77419),('vel',29,'node',3.7599),('vel',30,'node',4.43007),('vel',31,'node',6.2812),('vel',33,'node',1),('vel',34,'node',3.73356),('vel',35,'node',2.97286),('vel',36,'node',2),('vel',37,'node',2.83784),('vel',38,'node',3.76539),('vel',39,'node',8.96695),('vel',42,'node',3.79195),('vel',43,'node',3.79195),('vel',44,'node',3.79195),('vel',45,'node',3.79195),('vel',46,'node',3.79195),('vel',47,'node',1),('vel',48,'node',3),('vel',51,'node',1),('vel',52,'node',3),('vel',53,'node',5.19092),('vel',54,'node',1.75946),('vel',55,'node',1.65397),('vel',56,'node',1),('vel',57,'node',3.7953),('vel',59,'node',1),('vel',60,'node',1),('vel',61,'node',2),('vel',62,'node',1),('vel',63,'node',1),('vel',65,'node',1),('vel',66,'node',1),('vel',67,'node',31),('velit',2,'node',2.86941),('velit',3,'node',0.913226),('velit',4,'node',2.78691),('velit',5,'node',2.78951),('velit',6,'node',2.78951),('velit',7,'node',4.23713),('velit',8,'node',0.685676),('velit',9,'node',0.923838),('velit',10,'node',2.71229),('velit',12,'node',2.78177),('velit',13,'node',2),('velit',14,'node',4),('velit',15,'node',0.863659),('velit',17,'node',0.913226),('velit',27,'node',2.78177),('velit',28,'node',2.79212),('velit',29,'node',2.77923),('velit',30,'node',2.78177),('velit',31,'node',2.87313),('velit',35,'node',1),('velit',36,'node',1),('velit',37,'node',2.70409),('velit',39,'node',6.18936),('velit',40,'node',1),('velit',41,'node',1),('velit',42,'node',6.6155),('velit',43,'node',6.6155),('velit',44,'node',6.6155),('velit',45,'node',6.6155),('velit',46,'node',6.6155),('velit',47,'node',0.909743),('velit',48,'node',1),('velit',49,'node',1),('velit',50,'node',1),('velit',52,'node',1),('velit',53,'node',5.18402),('velit',54,'node',1.76068),('velit',55,'node',3.40923),('velit',56,'node',1.74656),('velit',57,'node',6.62195),('velit',59,'node',2),('velit',60,'node',3),('velit',61,'node',2),('velit',62,'node',2),('velit',65,'node',2),('velit',66,'node',1),('velit',67,'node',1),('vendors',16,'node',0.674137),('vendors',68,'node',0.670377),('venenatis',1,'node',1.8335),('venenatis',4,'node',3),('venenatis',5,'node',3),('venenatis',6,'node',3),('venenatis',7,'node',1.29741),('venenatis',8,'node',3.59225),('venenatis',11,'node',2.92743),('venenatis',12,'node',3),('venenatis',14,'node',1),('venenatis',15,'node',1.74529),('venenatis',27,'node',3),('venenatis',28,'node',3),('venenatis',29,'node',3),('venenatis',30,'node',3),('venenatis',31,'node',2),('venenatis',33,'node',2),('venenatis',34,'node',4.57972),('venenatis',35,'node',1),('venenatis',38,'node',4.60805),('venenatis',42,'node',0.879565),('venenatis',43,'node',0.879565),('venenatis',44,'node',0.879565),('venenatis',45,'node',0.879565),('venenatis',46,'node',0.879565),('venenatis',47,'node',0.836446),('venenatis',49,'node',2),('venenatis',50,'node',1),('venenatis',53,'node',1.6235),('venenatis',55,'node',0.848323),('venenatis',56,'node',0.819249),('venenatis',57,'node',0.882818),('venenatis',58,'node',1),('venenatis',61,'node',1),('venenatis',63,'node',2),('venenatis',64,'node',2),('venenatis',65,'node',1),('venenatis',67,'node',1),('veniam',2,'node',2.84793),('veniam',39,'node',3.8395),('veritatis',3,'node',4.73288),('veritatis',4,'node',2.39786),('veritatis',5,'node',2.40591),('veritatis',6,'node',2.40591),('veritatis',7,'node',4.79235),('veritatis',8,'node',1.43292),('veritatis',9,'node',4.7773),('veritatis',12,'node',2.38193),('veritatis',17,'node',4.73288),('veritatis',27,'node',2.38193),('veritatis',28,'node',2.41401),('veritatis',29,'node',2.37404),('veritatis',30,'node',2.38193),('veritatis',31,'node',3.64057),('veritatis',40,'node',1),('veritatis',41,'node',1),('veritatis',47,'node',4.71831),('veritatis',54,'node',4.70385),('veritatis',55,'node',4.66115),('veritatis',56,'node',4.83673),('vero',2,'node',3.86941),('vero',39,'node',7.11051),('version',16,'node',1.54297),('version',19,'node',0.794753),('version',20,'node',1),('version',22,'node',1),('version',68,'node',1.53619),('versions',16,'node',2),('versions',19,'node',1),('versions',21,'node',3),('versions',68,'node',2),('very',19,'node',1.01232),('very',22,'node',0.830633),('very',34,'node',26),('vestibulum',3,'node',2.77923),('vestibulum',4,'node',1),('vestibulum',5,'node',1),('vestibulum',6,'node',1),('vestibulum',7,'node',29.0814),('vestibulum',8,'node',6.98246),('vestibulum',9,'node',5.33484),('vestibulum',11,'node',10),('vestibulum',12,'node',1),('vestibulum',13,'node',1),('vestibulum',14,'node',3),('vestibulum',15,'node',5.01025),('vestibulum',17,'node',2),('vestibulum',26,'node',2),('vestibulum',27,'node',1),('vestibulum',28,'node',3.31028),('vestibulum',29,'node',1),('vestibulum',30,'node',22.3199),('vestibulum',31,'node',22.103),('vestibulum',33,'node',1.99731),('vestibulum',34,'node',4.44881),('vestibulum',36,'node',3),('vestibulum',37,'node',4.93511),('vestibulum',38,'node',4.48115),('vestibulum',39,'node',1),('vestibulum',42,'node',4.66926),('vestibulum',43,'node',4.66926),('vestibulum',44,'node',4.66926),('vestibulum',45,'node',4.66926),('vestibulum',46,'node',4.66926),('vestibulum',47,'node',4.36513),('vestibulum',48,'node',3),('vestibulum',49,'node',3),('vestibulum',50,'node',4),('vestibulum',51,'node',2),('vestibulum',52,'node',2),('vestibulum',53,'node',11.4293),('vestibulum',54,'node',2.73614),('vestibulum',55,'node',2.7095),('vestibulum',56,'node',2.80007),('vestibulum',57,'node',4.67579),('vestibulum',58,'node',1),('vestibulum',59,'node',3),('vestibulum',60,'node',1),('vestibulum',61,'node',2),('vestibulum',62,'node',3.98902),('vestibulum',63,'node',5),('vestibulum',64,'node',2),('vestibulum',65,'node',1),('vestibulum',66,'node',1),('via',16,'node',0.754681),('via',19,'node',0.716357),('via',68,'node',0.749958),('video',25,'node',54),('video',26,'node',26),('video',34,'node',8.74229),('video',35,'node',10.4874),('video',36,'node',10.9704),('video',37,'node',9.6397),('video',38,'node',8.83027),('vim',19,'node',1.9496),('vimcheatsheethtml',19,'node',7.05946),('virtualhost',21,'node',1),('visitors',16,'node',0.485867),('vitae',3,'node',6.73288),('vitae',4,'node',2.38624),('vitae',5,'node',3.81656),('vitae',6,'node',2.3942),('vitae',7,'node',12.485),('vitae',8,'node',2.94395),('vitae',9,'node',6.7773),('vitae',10,'node',1.85135),('vitae',11,'node',6.92743),('vitae',12,'node',2.37047),('vitae',13,'node',1),('vitae',15,'node',3.37978),('vitae',17,'node',6.73288),('vitae',26,'node',2),('vitae',27,'node',2.37047),('vitae',28,'node',3.17892),('vitae',29,'node',2.36266),('vitae',30,'node',2.37047),('vitae',31,'node',5.12662),('vitae',33,'node',2),('vitae',34,'node',2.43368),('vitae',35,'node',3),('vitae',36,'node',1),('vitae',37,'node',2),('vitae',38,'node',2.45871),('vitae',39,'node',4),('vitae',42,'node',8.39415),('vitae',43,'node',8.39415),('vitae',44,'node',8.39415),('vitae',45,'node',8.39415),('vitae',46,'node',8.39415),('vitae',47,'node',7.55184),('vitae',48,'node',2),('vitae',50,'node',1),('vitae',53,'node',1.30174),('vitae',54,'node',7.4373),('vitae',55,'node',7.94043),('vitae',56,'node',6.83673),('vitae',57,'node',8.4039),('vitae',58,'node',28),('vitae',59,'node',1),('vitae',61,'node',1.97685),('vitae',62,'node',1),('vitae',63,'node',2),('vitae',64,'node',2),('vitae',67,'node',2),('vivamus',7,'node',38.6997),('vivamus',8,'node',3.2114),('vivamus',9,'node',1.58911),('vivamus',12,'node',0.729424),('vivamus',15,'node',2.4353),('vivamus',31,'node',24.1387),('vivamus',34,'node',1.83353),('vivamus',35,'node',2),('vivamus',36,'node',2),('vivamus',37,'node',2.89608),('vivamus',38,'node',1.84234),('vivamus',42,'node',1.9496),('vivamus',43,'node',1.9496),('vivamus',44,'node',1.9496),('vivamus',45,'node',1.9496),('vivamus',46,'node',1.9496),('vivamus',48,'node',1),('vivamus',50,'node',1),('vivamus',51,'node',1),('vivamus',53,'node',2.41137),('vivamus',54,'node',0.873132),('vivamus',56,'node',0.805455),('vivamus',57,'node',1.9496),('vivamus',60,'node',1),('vivamus',61,'node',1),('vivamus',62,'node',3),('vivamus',63,'node',1),('vivamus',64,'node',1),('vivamus',67,'node',1),('viverra',4,'node',1),('viverra',5,'node',1.70376),('viverra',6,'node',1),('viverra',7,'node',17.1517),('viverra',8,'node',1.68764),('viverra',9,'node',3.23366),('viverra',10,'node',2),('viverra',11,'node',0.857458),('viverra',12,'node',1),('viverra',15,'node',1.55663),('viverra',26,'node',4),('viverra',27,'node',1),('viverra',28,'node',1),('viverra',29,'node',1),('viverra',30,'node',1),('viverra',31,'node',1),('viverra',33,'node',2),('viverra',34,'node',1),('viverra',35,'node',2),('viverra',36,'node',1),('viverra',37,'node',2),('viverra',38,'node',1),('viverra',39,'node',2),('viverra',49,'node',1),('viverra',51,'node',2),('viverra',52,'node',1),('viverra',53,'node',2.67273),('viverra',58,'node',1),('viverra',59,'node',1),('viverra',60,'node',1),('viverra',61,'node',2),('viverra',63,'node',2),('viverra',64,'node',1),('viverra',65,'node',3),('viverra',67,'node',2),('volunteer',16,'node',0.63167),('volunteer',68,'node',0.628375),('volunteers',16,'node',0.899454),('volunteers',68,'node',0.892724),('voluptas',3,'node',0.945829),('voluptas',4,'node',0.808176),('voluptas',5,'node',0.810915),('voluptas',6,'node',0.810915),('voluptas',7,'node',0.961087),('voluptas',9,'node',0.957226),('voluptas',12,'node',0.802752),('voluptas',17,'node',0.945829),('voluptas',27,'node',0.802752),('voluptas',28,'node',0.813674),('voluptas',29,'node',0.800068),('voluptas',30,'node',0.802752),('voluptas',31,'node',0.899454),('voluptas',47,'node',0.942091),('voluptas',54,'node',0.938382),('voluptas',55,'node',0.927431),('voluptas',56,'node',0.972861),('voluptate',39,'node',2.21076),('voluptate',40,'node',1),('voluptate',41,'node',1),('voluptatem',3,'node',5.68248),('voluptatem',4,'node',3.24896),('voluptatem',5,'node',3.26006),('voluptatem',6,'node',3.26006),('voluptatem',7,'node',5.75733),('voluptatem',8,'node',1.46259),('voluptatem',9,'node',5.73839),('voluptatem',12,'node',3.22699),('voluptatem',17,'node',5.68248),('voluptatem',27,'node',3.22699),('voluptatem',28,'node',3.27124),('voluptatem',29,'node',3.21611),('voluptatem',30,'node',3.22699),('voluptatem',31,'node',4.54342),('voluptatem',40,'node',1),('voluptatem',41,'node',1),('voluptatem',47,'node',5.66414),('voluptatem',54,'node',5.64594),('voluptatem',55,'node',5.5922),('voluptatem',56,'node',5.81358),('voluptua',2,'node',0.972861),('voluptua',39,'node',1.59444),('volutpat',2,'node',1.87308),('volutpat',7,'node',0.650439),('volutpat',8,'node',4.32062),('volutpat',10,'node',26.8695),('volutpat',11,'node',2),('volutpat',13,'node',1),('volutpat',14,'node',1),('volutpat',15,'node',1.64131),('volutpat',34,'node',6.06927),('volutpat',35,'node',1),('volutpat',38,'node',6.11126),('volutpat',39,'node',0.989021),('volutpat',47,'node',2.42194),('volutpat',49,'node',2),('volutpat',50,'node',1),('volutpat',51,'node',2),('volutpat',53,'node',9.16231),('volutpat',54,'node',0.736141),('volutpat',55,'node',0.839384),('volutpat',56,'node',0.810915),('volutpat',59,'node',2),('volutpat',60,'node',1),('volutpat',62,'node',0.989021),('vote',1,'node',0.968904),('vote',7,'node',0.797402),('vote',9,'node',0.816452),('vote',15,'node',2.56366),('vote',17,'node',0.857458),('vote',55,'node',0.784336),('votes',1,'node',1.83938),('votes',3,'node',1.62072),('votes',8,'node',0.674137),('votes',10,'node',0.968904),('votes',11,'node',0.997306),('votes',16,'node',1.07246),('votes',18,'node',1),('votes',19,'node',0.433985),('votes',20,'node',0.808176),('votes',21,'node',0.808176),('votes',22,'node',0.689612),('votes',47,'node',1.52418),('votes',53,'node',7.58514),('votes',54,'node',1.52092),('votes',55,'node',1.3305),('votes',56,'node',1.68616),('votes',68,'node',0.591395),('votes',69,'node',1),('vulputate',1,'node',1.82996),('vulputate',2,'node',2.86941),('vulputate',3,'node',1),('vulputate',4,'node',1),('vulputate',5,'node',1),('vulputate',6,'node',1),('vulputate',7,'node',1.58283),('vulputate',8,'node',2),('vulputate',9,'node',1.84532),('vulputate',10,'node',2),('vulputate',11,'node',2),('vulputate',12,'node',1),('vulputate',13,'node',1),('vulputate',15,'node',1.92027),('vulputate',17,'node',1),('vulputate',27,'node',1),('vulputate',28,'node',1),('vulputate',29,'node',1.76188),('vulputate',30,'node',1.71),('vulputate',31,'node',1.68961),('vulputate',33,'node',1),('vulputate',34,'node',2),('vulputate',35,'node',2),('vulputate',36,'node',1),('vulputate',37,'node',0.892724),('vulputate',38,'node',2),('vulputate',39,'node',2.98344),('vulputate',42,'node',0.896076),('vulputate',43,'node',0.896076),('vulputate',44,'node',0.896076),('vulputate',45,'node',0.896076),('vulputate',46,'node',0.896076),('vulputate',47,'node',1),('vulputate',50,'node',3),('vulputate',51,'node',1),('vulputate',52,'node',1),('vulputate',53,'node',1.6235),('vulputate',54,'node',1),('vulputate',55,'node',1.65576),('vulputate',56,'node',1),('vulputate',57,'node',0.899454),('vulputate',65,'node',1),('vulputate',66,'node',1),('vulputate',67,'node',1),('want',16,'node',1),('want',19,'node',1.22405),('want',68,'node',1),('warning',20,'node',0.920273),('was',1,'node',1),('was',16,'node',5),('was',68,'node',5),('was',69,'node',1),('watch',25,'node',2),('way',16,'node',0.997306),('way',19,'node',0.936828),('way',68,'node',0.993146),('ways',9,'node',26),('we',1,'node',1),('we',15,'node',1),('we',16,'node',3.69131),('we',19,'node',1.50682),('we',68,'node',2.60772),('we',69,'node',1),('web',1,'node',7.19013),('web',5,'node',2.79049),('web',7,'node',10.1967),('web',8,'node',7.66216),('web',9,'node',5.73091),('web',10,'node',3.32253),('web',11,'node',3.61143),('web',12,'node',2.88264),('web',15,'node',2),('web',16,'node',1.92425),('web',20,'node',43),('web',21,'node',42.8718),('web',22,'node',0.854391),('web',29,'node',8.35411),('web',31,'node',2.81502),('web',37,'node',3.27699),('web',47,'node',2.90006),('web',53,'node',8.04528),('web',55,'node',2.78241),('web',56,'node',3.18961),('webhosting',20,'node',9.26577),('website',18,'node',1),('website',19,'node',0.920273),('website',20,'node',1),('websites',12,'node',26),('wed',7,'node',0.776703),('wed',9,'node',1.51163),('wed',11,'node',1.84364),('weebpal',15,'node',26),('weebpalcom',40,'node',11),('weebpalcom',41,'node',11),('well',16,'node',0.538701),('well',19,'node',0.449975),('well',22,'node',1),('wget',19,'node',1.54928),('what',15,'node',26),('what',19,'node',0.952715),('what',22,'node',11),('what',36,'node',26),('when',16,'node',2),('when',19,'node',0.997306),('when',68,'node',2),('which',16,'node',1.52584),('which',19,'node',1.8051),('which',68,'node',1),('while',1,'node',1),('while',16,'node',0.779231),('while',19,'node',0.66666),('while',21,'node',10.4041),('while',68,'node',0.774192),('who',16,'node',0.664818),('who',19,'node',0.525844),('who',68,'node',0.661163),('whole',19,'node',0.468115),('why',55,'node',26),('will',1,'node',1.99315),('will',16,'node',8.31348),('will',19,'node',4.50231),('will',21,'node',3.8894),('will',22,'node',1),('will',30,'node',26),('will',68,'node',7.76265),('window',16,'node',1.64348),('window',68,'node',1.64006),('windows',21,'node',12.1913),('winds',16,'node',0.615536),('winds',68,'node',0.61241),('wish',16,'node',1),('wish',22,'node',0.802752),('wish',68,'node',1),('wishing',16,'node',0.695602),('wishing',68,'node',0.691597),('wisi',2,'node',1.91323),('wisi',39,'node',3.84863),('with',1,'node',1),('with',3,'node',26),('with',16,'node',2.1029),('with',19,'node',3.70916),('with',20,'node',4.89714),('with',21,'node',26.6336),('with',22,'node',8.59418),('with',68,'node',1),('with',69,'node',1),('within',16,'node',1),('within',68,'node',1),('without',20,'node',1),('won',19,'node',0.499853),('work',16,'node',0.727213),('work',19,'node',2.38896),('work',21,'node',3.8894),('work',22,'node',1),('work',68,'node',0.722831),('workable',16,'node',0.641769),('workable',68,'node',0.638366),('working',19,'node',0.618696),('working',22,'node',0.705825),('works',21,'node',1),('worry',22,'node',0.824901),('worth',19,'node',0.449147),('would',16,'node',1.65718),('would',19,'node',0.533952),('would',22,'node',1.48649),('would',68,'node',1.64939),('write',1,'node',1),('write',69,'node',1),('written',19,'node',0.519091),('www',19,'node',3.59781),('wwwfprintfnet',19,'node',7.07833),('wwwyoutubecom',25,'node',2),('years',1,'node',0.98493),('yellow',45,'node',26),('yet',1,'node',0.839384),('yet',3,'node',1.61761),('yet',18,'node',1),('yet',19,'node',4.43322),('yet',20,'node',0.805455),('yet',21,'node',0.805455),('yet',22,'node',0.687638),('yet',47,'node',1.52155),('yet',53,'node',7.58193),('yet',54,'node',1.51818),('yet',55,'node',1.32844),('yet',56,'node',1.68289),('yet',68,'node',0.58995),('yet',69,'node',1),('you',16,'node',0.524706),('you',19,'node',25.4569),('you',20,'node',13),('you',21,'node',13.7306),('you',22,'node',17.9817),('you',31,'node',26),('you',34,'node',26),('you',36,'node',26),('your',1,'node',1.97685),('your',15,'node',2.56366),('your',16,'node',2.15498),('your',17,'node',11.8668),('your',19,'node',24.0074),('your',20,'node',1),('your',22,'node',3.45725),('your',30,'node',26),('your',40,'node',2),('your',41,'node',2),('your',55,'node',0.794753),('yourdomaincom',19,'node',1),('yourself',8,'node',26),('yourself',19,'node',0.96498),('zip',19,'node',2.27594),('zircon',52,'node',26),('zzril',2,'node',1),('zzril',39,'node',1.49577);
/*!40000 ALTER TABLE `search_index` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `search_node_links`
--

DROP TABLE IF EXISTS `search_node_links`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `search_node_links` (
  `sid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The search_dataset.sid of the searchable item containing the link to the node.',
  `type` varchar(16) NOT NULL DEFAULT '' COMMENT 'The search_dataset.type of the searchable item containing the link to the node.',
  `nid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The node.nid that this item links to.',
  `caption` longtext COMMENT 'The text used to link to the node.nid.',
  PRIMARY KEY (`sid`,`type`,`nid`),
  KEY `nid` (`nid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Stores items (like nodes) that link to other nodes, used...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `search_node_links`
--

LOCK TABLES `search_node_links` WRITE;
/*!40000 ALTER TABLE `search_node_links` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `search_node_links` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `search_total`
--

DROP TABLE IF EXISTS `search_total`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `search_total` (
  `word` varchar(50) NOT NULL DEFAULT '' COMMENT 'Primary Key: Unique word in the search index.',
  `count` float DEFAULT NULL COMMENT 'The count of the word in the index using Zipf’s law to equalize the probability distribution.',
  PRIMARY KEY (`word`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Stores search totals for words.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `search_total`
--

LOCK TABLES `search_total` WRITE;
/*!40000 ALTER TABLE `search_total` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `search_total` VALUES ('07x',0.30103),('08x',0.30103),('0907am',0.30103),('0908am',0.225256),('0908pm',0.126464),('1',0.000861097),('10',0.0498373),('1058',0.30103),('10x',0.30103),('11',0.0364583),('12',0.0451506),('122',0.30103),('123456789',0.09691),('124',0.30103),('12x',0.30103),('13',0.030302),('14',0.0552288),('14x',0.30103),('15',0.0112892),('1540',0.0588998),('15x',0.30103),('16',0.0565276),('1648',0.30103),('16m',0.30103),('17',0.0588247),('1720',0.173653),('1721',0.30103),('1723',0.185393),('1724',0.26505),('1727',0.24883),('1728',0.251967),('1730',0.30103),('1758',0.30103),('1759',0.30103),('18',0.0599676),('1806',0.30103),('1830',0.30103),('1832',0.227845),('1833',0.235224),('1834',0.177142),('1835',0.25646),('19',0.0428986),('1e1',0.176091),('1m',0.190487),('2',0.00113427),('20',0.0124035),('2008',0.0368312),('2014',0.0765369),('2018',0.210278),('21',0.0546499),('2136029',0.0193052),('22',0.0103921),('2347',0.30103),('2351',0.0703806),('2357',0.30103),('2358',0.30103),('25',0.0143885),('27',0.0163904),('2x',0.30103),('3',0.00170929),('309',0.30103),('31',0.0163904),('337',0.138492),('35',0.00760239),('3month',0.249691),('4',0.0250555),('40',0.30103),('40000',0.203511),('404',0.0163904),('41',0.176091),('45',0.0130105),('47x',0.176091),('4x',0.30103),('5',0.00982748),('50',0.0163904),('5015',0.0795178),('5130',0.176091),('5144',0.30103),('525',0.30103),('52x',0.30103),('53',0.194278),('54',0.0158693),('55',0.0144392),('57',0.0584834),('5x',0.124939),('6',0.0100504),('60',0.30103),('6122014',0.0587863),('6292014',0.30103),('6x',0.042606),('6xzip',0.213241),('7',0.00802457),('70',0.30103),('7082014',0.118204),('7092014',0.0943146),('71',0.197346),('7132014',0.0541759),('7142014',0.30103),('727',0.30103),('728',0.0915105),('7x',0.214438),('8',0.00764862),('800',0.201231),('8122014',0.156747),('8162014',0.0584962),('8172014',0.0341173),('8182014',0.30103),('8192014',0.206629),('8212014',0.30103),('83',0.137928),('9',0.0328507),('921',0.210711),('922',0.118297),('934',0.188859),('935',0.158053),('ab',0.00670735),('able',0.176091),('about',0.0112688),('abstracted',0.222006),('ac',0.00189923),('accept',0.30103),('access',0.0674152),('according',0.30103),('accordion',0.00827253),('account',0.187562),('accounts',0.0142868),('accumsan',0.00614019),('accusam',0.0448082),('accusantium',0.0066822),('achieve',0.30103),('acknowledging',0.252725),('across',0.137719),('active',0.176091),('actively',0.30103),('actually',0.30103),('ad',0.0103269),('add',0.154364),('added',0.30103),('additional',0.120206),('additionally',0.30103),('adipisci',0.0288941),('adipiscing',0.00308145),('adipisici',0.30103),('admin',0.00591184),('administration',0.30103),('administrators',0.30103),('advertising',0.176091),('advice',0.146985),('advise',0.30103),('advisories',0.285833),('aenean',0.00398011),('affect',0.234171),('after',0.0523355),('again',0.252081),('ago',0.0266135),('ahead',0.30103),('aims',0.30103),('alexander',0.176091),('alias',0.0254037),('aliases',0.282075),('aliqua',0.30103),('aliquam',0.00310675),('aliquet',0.00842491),('aliquid',0.30103),('aliquip',0.0697712),('aliquyam',0.0805547),('all',0.0502976),('allow',0.0301398),('allowoverride',0.30103),('allows',0.211141),('almost',0.202942),('already',0.112418),('also',0.0444742),('alt',0.30103),('alter',0.30103),('alternately',0.30103),('alternative',0.30103),('always',0.179101),('amet',0.00161376),('amount',0.232586),('an',0.0366347),('and',0.00340711),('anim',0.00726481),('animation',0.0485131),('announcement',0.121949),('announcements',0.012965),('another',0.148594),('ante',0.0028506),('any',0.0671378),('anymore',0.211953),('anything',0.0163904),('apache',0.0122345),('aperiam',0.00669635),('api',0.30103),('apparently',0.09691),('apple',0.00827253),('application',0.30103),('apps',0.0163904),('aptent',0.0462955),('architecto',0.00672072),('archive',0.30103),('arcu',0.00359236),('are',0.00981501),('around',0.209719),('art',0.0163904),('as',0.0239007),('ask',0.30103),('aspen',0.0163904),('aspernatur',0.0282346),('association',0.176091),('assum',0.203214),('at',0.00213859),('attack',0.0400075),('attention',0.023774),('auctor',0.00695249),('aug',0.0880121),('augue',0.00382794),('austin',0.176091),('aut',0.0144507),('aute',0.0924027),('autem',0.0684202),('automated',0.0956101),('autox',0.0163904),('available',0.108613),('average',0.0360717),('avoid',0.30103),('awesome',0.30103),('back',0.235027),('backups',0.30103),('bash',0.243108),('bashaliases',0.30103),('bashprofile',0.274394),('bashrc',0.0497137),('basic',0.0163904),('bc',0.176091),('be',0.00821716),('beatae',0.00693847),('beautiful',0.00684755),('because',0.30103),('been',0.0989888),('before',0.011939),('behaviour',0.30103),('being',0.145132),('belong',0.0163904),('best',0.00827253),('better',0.0153193),('between',0.109527),('bibendum',0.00745703),('big',0.176091),('bigtable',0.0163904),('bin',0.272628),('bit',0.125107),('blandit',0.00383491),('blog',0.00532883),('body',0.0163904),('books',0.0163904),('both',0.248165),('bottom',0.30103),('branch',0.174378),('branches',0.30103),('breathing',0.30103),('breeze',0.0163904),('bug',0.120455),('bugs',0.30103),('builder',0.176091),('builtin',0.30103),('bunch',0.30103),('but',0.0432173),('button',0.0107239),('by',0.00675092),('came',0.09691),('campaign',0.0163904),('can',0.0325813),('canada',0.176091),('cars',0.0483657),('case',0.221978),('cases',0.30103),('cassandra',0.0163904),('cck',0.2224),('cd',0.182811),('certain',0.223039),('change',0.30103),('changelog',0.30103),('changes',0.0431485),('cheatsheet',0.30103),('check',0.30103),('child',0.0163904),('chmod',0.30103),('choice',0.20017),('choose',0.30103),('cillum',0.092586),('class',0.0264915),('clean',0.012633),('clear',0.21913),('clients',0.259717),('clita',0.0297237),('cluster',0.30103),('code',0.074497),('coding',0.00827253),('collapse',0.01524),('color',0.0163904),('column',0.00827253),('columnsalias',0.30103),('come',0.30103),('comes',0.128468),('coming',0.176091),('command',0.0239431),('commands',0.0842588),('comment',0.176091),('comments',0.00780639),('commit',0.30103),('commodi',0.30103),('commodo',0.00590332),('commonly',0.176091),('community',0.0104921),('companies',0.0644236),('comparable',0.30103),('compatible',0.219355),('complete',0.30103),('composer',0.0511525),('compromise',0.251211),('concurrency',0.30103),('condimentum',0.00330746),('conditions',0.0392514),('config',0.057001),('configuration',0.15878),('configured',0.232233),('confirm',0.220534),('congue',0.00487833),('consectetuer',0.00857124),('consectetur',0.00592748),('consequat',0.00441349),('consetetur',0.0799367),('consider',0.217056),('consult',0.30103),('cont',0.30103),('contact',0.00827253),('contain',0.30103),('contains',0.30103),('continue',0.230462),('continuing',0.177997),('contributed',0.0507163),('contribution',0.30103),('control',0.30103),('conubia',0.0466),('convallis',0.00540868),('coordinate',0.234698),('copy',0.30103),('core',0.0157524),('correct',0.30103),('correctly',0.30103),('costs',0.0163904),('course',0.30103),('coverage',0.184006),('cpanel',0.118043),('cras',0.00568081),('create',0.115439),('created',0.113383),('creating',0.30103),('credentials',0.30103),('crit',0.30103),('critical',0.219677),('cron',0.30103),('css3',0.0483657),('ctrl',0.30103),('cubilia',0.0505975),('culpa',0.0072422),('cum',0.0654013),('cupidatat',0.00764626),('cupiditat',0.115439),('curabitur',0.00176966),('curae',0.0507061),('current',0.129955),('currently',0.30103),('cursus',0.00377343),('customers',0.243554),('cycle',0.30103),('d7',0.00768777),('d8',0.00727289),('dapibus',0.00580229),('dark',0.0163904),('data',0.220768),('database',0.00439069),('databases',0.0163904),('day',0.0460389),('days',0.0163904),('ddd',0.0786654),('dddl',0.0635447),('deadline',0.30103),('decided',0.30103),('decorating',0.00827253),('default',0.0152848),('delenit',0.146459),('delete',0.30103),('demoweebpalcom',0.0377886),('depending',0.30103),('deployment',0.30103),('deserunt',0.00725585),('design',0.0237166),('desired',0.30103),('detailed',0.0680027),('details',0.0128619),('dev',0.09691),('developer',0.0977184),('developers',0.30103),('developing',0.230994),('development',0.00520799),('diam',0.00535309),('dicta',0.0069447),('dictum',0.00482199),('dictumst',0.0408674),('didn',0.30103),('difficult',0.179206),('dignissim',0.0107568),('direction',0.0163904),('directive',0.30103),('directory',0.0394384),('dis',0.0886355),('discuss',0.176091),('discussing',0.30103),('discussion',0.00634018),('discussions',0.30103),('disk',0.0222764),('display',0.0163904),('dl',0.119357),('do',0.00711209),('documentation',0.0310068),('does',0.00758885),('doesn',0.30103),('dolor',0.00210944),('dolore',0.019904),('dolorem',0.028638),('doloremque',0.00668506),('dolores',0.0448417),('doming',0.201391),('don',0.147405),('done',0.30103),('donec',0.00312307),('down',0.259221),('download',0.110463),('drawing',0.0163904),('driver',0.30103),('drop',0.30103),('dropcap',0.0142404),('dropin',0.176091),('dropped',0.30103),('drupal',0.00138986),('drupalcon',0.176091),('drupalorg',0.0178863),('drush',0.00481654),('drush6x',0.30103),('drushops',0.0469213),('drushphp',0.30103),('dui',0.00515025),('duis',0.00667399),('duo',0.044825),('ea',0.0265885),('each',0.30103),('eaque',0.00669913),('earlier',0.30103),('easy',0.0157943),('eating',0.0163904),('eclipsing',0.250198),('ecommerce',0.0493965),('edit',0.227293),('edited',0.30103),('editing',0.30103),('editor',0.30103),('editorial',0.0485743),('efficitur',0.30103),('eg',0.30103),('egestas',0.00400324),('eget',0.00239278),('eirmod',0.0802916),('eiusmod',0.30103),('eleifend',0.00868522),('elementum',0.0061849),('elit',0.0023992),('elitr',0.0800332),('else',0.30103),('email',0.01524),('emdash',0.241227),('en',0.0287019),('enabled',0.30103),('enabling',0.30103),('end',0.30103),('engine',0.131832),('enim',0.00294995),('enough',0.30103),('ensure',0.176091),('enter',0.152695),('enterprise',0.052179),('entities',0.222942),('eos',0.0447914),('equivalent',0.178372),('erat',0.00403217),('eros',0.00265873),('error',0.00544776),('errors',0.30103),('esse',0.041162),('est',0.00333779),('et',0.00126668),('etiam',0.00604174),('eu',0.00243456),('euismod',0.00650043),('eum',0.0684483),('even',0.0869312),('every',0.30103),('everyone',0.223143),('ex',0.047502),('example',0.00299592),('excepteur',0.0315011),('exchange',0.30103),('exerci',0.0696724),('exercises',0.0163904),('exercitation',0.30103),('existing',0.215983),('exit',0.257429),('experience',0.176091),('explicabo',0.00694835),('explicitly',0.236799),('explore',0.30103),('export',0.30103),('extended',0.0814675),('extension',0.0992207),('extensively',0.30103),('extract',0.222065),('facer',0.20249),('facilisi',0.0307945),('facilisis',0.0110702),('facts',0.30103),('failure',0.30103),('fames',0.0173373),('familiar',0.223985),('famous',0.0398029),('faq',0.0448081),('fastcgi',0.30103),('faucibus',0.00290028),('feature',0.184545),('features',0.216103),('february',0.176091),('feed',0.30103),('feel',0.249183),('felis',0.00235779),('fermentum',0.00775499),('feugait',0.146698),('feugiat',0.00406402),('few',0.014851),('fields',0.223484),('file',0.0395546),('files',0.103213),('find',0.098025),('finibus',0.30103),('first',0.22582),('fixes',0.0790045),('flower',0.0377886),('focus',0.160071),('focuses',0.30103),('focusing',0.0163904),('folders',0.30103),('follow',0.122882),('following',0.0811129),('foods',0.0163904),('for',0.00511622),('form',0.0163904),('former',0.30103),('fortunately',0.212509),('forumplus',0.0347621),('found',0.0791852),('fri',0.30103),('fringilla',0.00634042),('from',0.0129852),('front',0.0163904),('ftp',0.30103),('fugiat',0.0926312),('fugit',0.0285372),('full',0.28784),('fulltime',0.17851),('fully',0.141345),('functions',0.30103),('fusce',0.00248584),('future',0.0163904),('geeks',0.214703),('general',0.00635853),('get',0.124939),('git',0.30103),('githubcom',0.0469072),('give',0.0029036),('given',0.165814),('gives',0.196052),('go',0.195484),('godaddy',0.1239),('goes',0.176091),('gold',0.176091),('good',0.0159987),('graphic',0.025571),('gravida',0.00681918),('great',0.30103),('greater',0.30103),('green',0.0154769),('group',0.0523249),('gubergren',0.0297377),('guide',0.30103),('guidelines',0.0157943),('guys',0.0163904),('h1',0.00101402),('h2',0.00149463),('h3',0.00179799),('habitant',0.0364257),('habitasse',0.0141137),('hac',0.0140822),('handles',0.218582),('happy',0.30103),('has',0.0989105),('have',0.0291778),('having',0.176091),('heading',0.000454361),('headline',0.00827253),('health',0.0480706),('healthy',0.0163904),('help',0.117073),('hendrerit',0.00388687),('here',0.0081917),('hiawatha',0.0107676),('high',0.30103),('higher',0.0251643),('highlight',0.0142404),('himenaeos',0.0341719),('history',0.165122),('hit',0.30103),('hitting',0.30103),('home',0.0792018),('homepage',0.30103),('hope',0.256735),('host',0.107855),('hosted',0.176091),('hostel',0.0163904),('hosting',0.005513),('hostmonster',0.0896382),('hosts',0.0377886),('hot',0.30103),('hotel',0.0163904),('hours',0.0423042),('how',0.0053364),('however',0.152167),('htaccess',0.30103),('htdocs',0.106869),('http',0.0221657),('https',0.0134591),('hymenaeos',0.0995981),('iaculis',0.00664703),('id',0.00159734),('idea',0.176091),('ideas',0.0163904),('if',0.022985),('iis',0.0143347),('illo',0.00671006),('illum',0.0685588),('image',0.0157943),('images',0.0480706),('img',0.30103),('imperdiet',0.00645537),('important',0.0977446),('improvements',0.30103),('in',0.000804057),('inceptos',0.0505471),('incidunt',0.30103),('includes',0.30103),('including',0.115549),('independent',0.30103),('index',0.30103),('individuals',0.132974),('inevitable',0.30103),('inexpensive',0.180387),('information',0.109004),('informs',0.30103),('innodb',0.134582),('innodbcompatible',0.30103),('inperson',0.176091),('insert',0.30103),('inspirational',0.0163904),('install',0.176091),('installation',0.00848656),('installed',0.191184),('installing',0.0100736),('instead',0.16546),('instructions',0.0381674),('integer',0.0284117),('interdum',0.00430361),('interested',0.172898),('into',0.30103),('introduces',0.188159),('inventore',0.00671275),('invidunt',0.0804),('ipsa',0.00670189),('ipsam',0.0279317),('ipsum',0.00245145),('iriure',0.0684762),('irure',0.176091),('is',0.00391273),('issue',0.0335866),('issues',0.0827439),('iste',0.00544385),('it',0.00229848),('item',0.00553249),('items',0.30103),('its',0.221857),('iure',0.161783),('iusto',0.145851),('jack',0.238393),('joined',0.0266419),('juans',0.0163904),('jul',0.30103),('just',0.292966),('justo',0.00382608),('kasd',0.0297307),('keep',0.30103),('key',0.176091),('knowledge',0.155723),('known',0.30103),('la',0.30103),('labore',0.0678919),('laboris',0.30103),('laborum',0.00727709),('lacinia',0.0137536),('lack',0.182212),('lacus',0.00301881),('laoreet',0.0081075),('last',0.0264365),('later',0.124222),('laudantium',0.00668791),('launches',0.0163904),('lead',0.30103),('leadership',0.248675),('learn',0.0077164),('learning',0.0869875),('least',0.141091),('leaving',0.251716),('lectus',0.00418509),('left',0.124939),('legacy',0.211603),('leo',0.00302051),('let',0.30103),('level',0.243038),('liber',0.19915),('libero',0.00270587),('light',0.0163904),('lightweight',0.30103),('ligula',0.00319104),('like',0.151307),('likely',0.0881417),('limited',0.255236),('line',0.199087),('lines',0.30103),('link',0.30103),('linux',0.10935),('list',0.0808031),('listed',0.124939),('listing',0.30103),('litora',0.0464706),('little',0.252809),('live',0.30103),('living',0.0163904),('ll',0.30103),('loads',0.30103),('lobortis',0.00484972),('local',0.202094),('locate',0.259305),('located',0.30103),('lock',0.30103),('log',0.00587093),('login',0.121949),('logo',0.30103),('logopng',0.30103),('long',0.0153592),('longer',0.204514),('loops',0.30103),('lorem',0.00374737),('lot',0.30103),('low',0.18123),('ls',0.15785),('luctus',0.0101934),('luptatum',0.146217),('luxury',0.0163904),('macbook',0.0163904),('made',0.299188),('maecenas',0.00875145),('magna',0.00414069),('magnis',0.0885586),('mailing',0.30103),('main',0.30103),('mainline',0.30103),('maintain',0.0720314),('maintained',0.30103),('maintainers',0.09691),('maintenance',0.170157),('major',0.143582),('majority',0.131695),('make',0.081347),('makes',0.0123025),('making',0.30103),('malesuada',0.00502904),('managed',0.30103),('management',0.0163904),('manager',0.197752),('manual',0.185791),('manually',0.30103),('many',0.127083),('margaret',0.0163904),('mariadb',0.0185016),('marked',0.09691),('marketplace',0.124939),('mass',0.30103),('massa',0.00622997),('mattis',0.00532694),('mauris',0.00450567),('maxallowedpacket',0.30103),('may',0.0408777),('mazim',0.202125),('mb',0.30103),('mean',0.30103),('means',0.176091),('meantime',0.30103),('media',0.30103),('meet',0.176091),('mega',0.0163904),('megabytes',0.30103),('members',0.238368),('memory',0.0395077),('menu',0.0163904),('mess',0.30103),('message',0.30103),('met',0.176091),('method',0.147972),('metus',0.00203743),('mi',0.00275632),('mical',0.0497024),('microsoft',0.00941271),('might',0.240872),('migrate',0.119984),('migration',0.217485),('migrations',0.224025),('min',0.058416),('mind',0.30103),('minim',0.0604964),('minimum',0.176091),('modrewrite',0.30103),('module',0.0548636),('modules',0.0332235),('molestie',0.0136883),('mollis',0.00321581),('mollit',0.00726034),('mon',0.0886972),('money',0.0163904),('mongodb',0.0515951),('montes',0.0887883),('monthly',0.30103),('months',0.103979),('morbi',0.0035634),('more',0.00457302),('most',0.0956476),('motion',0.0163904),('move',0.176091),('moving',0.193146),('much',0.00786806),('mus',0.0891407),('music',0.0116052),('must',0.176091),('mv',0.0530531),('my',0.0222764),('mybutton',0.30103),('mydropcap',0.30103),('myhighlight',0.30103),('myimage',0.30103),('myisam',0.195751),('myitem',0.30103),('myquote',0.30103),('mysql',0.010835),('mysqlspecific',0.222577),('mytooltip',0.30103),('nam',0.00520009),('name',0.144519),('named',0.172018),('nano',0.139856),('nascetur',0.0888642),('natoque',0.0884038),('natus',0.00544581),('navigate',0.30103),('ndb',0.30103),('nearly',0.30103),('nec',0.00145925),('necessary',0.30103),('need',0.0559352),('needed',0.30103),('nemo',0.0277296),('neque',0.00348899),('netus',0.0364516),('never',0.30103),('new',0.0487177),('newer',0.30103),('news',0.00522977),('next',0.30103),('nginx',0.0102192),('nibh',0.00491504),('nihil',0.201022),('nisi',0.00200505),('nisl',0.00272463),('no',0.0107069),('nobis',0.200278),('node',0.012965),('non',0.00148002),('nonbeta',0.30103),('none',0.0559296),('nonummy',0.0160341),('nonumy',0.0801826),('normal',0.0391),('nostra',0.0466427),('nostrud',0.0605473),('not',0.00834519),('note',0.0737458),('notes',0.0618705),('now',0.0120569),('nulla',0.00268424),('nullam',0.00439967),('numerous',0.30103),('nunc',0.00110937),('obcaecat',0.115353),('occaecat',0.00764138),('ocean',0.0163904),('odio',0.00482063),('odit',0.0284364),('of',0.00985718),('off',0.0377886),('offer',0.30103),('offers',0.30103),('officia',0.00725133),('offline',0.0459047),('offseason',0.0163904),('oftenused',0.30103),('older',0.30103),('omnis',0.00544188),('on',0.00394176),('once',0.214561),('one',0.00811789),('onepage',0.0486605),('online',0.0581525),('only',0.0569195),('onto',0.194892),('open',0.138466),('opportunities',0.30103),('option',0.200651),('options',0.197208),('or',0.00332349),('oracle',0.0230889),('orci',0.00465282),('order',0.30103),('orem',0.0791812),('organization',0.225105),('organizations',0.14235),('oriented',0.0163904),('ornare',0.00867358),('os',0.176091),('other',0.0194102),('our',0.0134493),('out',0.0587812),('own',0.23941),('owners',0.30103),('page',0.00481017),('paid',0.0377886),('panel',0.30103),('pariatur',0.0926762),('parturient',0.0887121),('party',0.199505),('password',0.30103),('past',0.208035),('paste',0.30103),('patches',0.0825175),('path',0.144483),('pdo',0.0249704),('pede',0.0101023),('pedeaenean',0.30103),('pellentesque',0.00238969),('penatibus',0.0884814),('people',0.0163904),('per',0.0249109),('percona',0.0185048),('perfect',0.0524387),('performance',0.035148),('performed',0.125187),('period',0.0163904),('permalink',0.00194185),('permissions',0.236799),('perspiciatis',0.00543789),('peter',0.0472715),('pharetra',0.014298),('phasellus',0.00210408),('photography',0.0377886),('photoshop',0.0485131),('php',0.00899039),('php5',0.272386),('phpcgi',0.153122),('phpcli',0.0838295),('piano',0.00827253),('pick',0.0163904),('picks',0.0431654),('pictures',0.0381901),('pinteros',0.0163904),('place',0.30103),('placement',0.30103),('placerat',0.00951258),('plan',0.241711),('plans',0.180387),('platea',0.014145),('platforms',0.30103),('playlist',0.0163904),('please',0.0928813),('plesk',0.30103),('point',0.30103),('policy',0.0669468),('popular',0.30103),('port',0.30103),('porta',0.00808747),('porttitor',0.00482583),('possim',0.202853),('post',0.00786146),('postgresql',0.0241194),('posuere',0.00365181),('potenti',0.0219606),('powerful',0.30103),('practice',0.0522898),('praesent',0.0025893),('premium',0.30103),('prerequisite',0.30103),('pretium',0.00434691),('prevent',0.176091),('previous',0.0852215),('primary',0.131526),('primis',0.0199856),('principles',0.0163904),('private',0.228863),('pro',0.01524),('probably',0.30103),('problems',0.30103),('proceed',0.30103),('process',0.30103),('produce',0.30103),('product',0.30103),('production',0.220901),('productivity',0.0163904),('profile',0.30103),('program',0.30103),('proident',0.00723296),('proin',0.00448634),('project',0.0163904),('promotion',0.0163904),('prompt',0.269672),('prompted',0.30103),('properly',0.30103),('proven',0.0163904),('proves',0.30103),('provide',0.0569437),('provided',0.30103),('providers',0.30103),('providing',0.113944),('publicftp',0.30103),('publichtml',0.0871586),('pulvinar',0.00414766),('purus',0.00349557),('put',0.30103),('qgluydime4',0.176091),('quae',0.00670463),('quam',0.00336655),('quasi',0.00671809),('question',0.146978),('questioned',0.176091),('queue',0.22993),('qui',0.00563282),('quia',0.0144362),('quickly',0.30103),('quis',0.00159436),('quisque',0.00567249),('quod',0.201759),('quote',0.00706185),('rain',0.0163904),('raise',0.0163904),('rare',0.30103),('rating',0.0115528),('read',0.00743394),('reading',0.30103),('ready',0.216935),('really',0.30103),('reasonable',0.232056),('reasons',0.0152754),('rebum',0.0448746),('received',0.30103),('recent',0.30103),('recommended',0.0161898),('red',0.0163904),('refer',0.30103),('reflect',0.0791812),('refresh',0.30103),('refreshes',0.30103),('register',0.00597456),('relaxdaily',0.0163904),('release',0.0260439),('released',0.0328194),('releases',0.118221),('rely',0.199795),('rem',0.00669355),('remotehost',0.30103),('remoteuser',0.30103),('remove',0.194356),('rename',0.30103),('replacements',0.176091),('reports',0.293191),('reprehenderit',0.0924949),('representatives',0.176091),('request',0.30103),('requests',0.0163904),('require',0.30103),('required',0.30103),('requirement',0.184602),('requirements',0.00720523),('requires',0.10032),('research',0.30103),('researchers',0.30103),('resources',0.254233),('responsive',0.0482182),('restart',0.30103),('retina',0.0163904),('review',0.0155816),('rewrite',0.30103),('rewriting',0.30103),('rhoncus',0.00535202),('ridiculus',0.088989),('right',0.176091),('rights',0.125337),('rigorous',0.185197),('risus',0.00641714),('rm',0.30103),('room',0.0159392),('rss',0.30103),('rules',0.30103),('run',0.116612),('running',0.047923),('rutrum',0.00456246),('sadipscing',0.0799851),('safer',0.30103),('sagittis',0.00434196),('same',0.176286),('san',0.0163904),('sanctus',0.0313423),('sapien',0.00404009),('sat',0.0584713),('sauce',0.30103),('save',0.0157366),('savings',0.0454036),('scelerisque',0.0101375),('screen',0.30103),('sea',0.0313272),('sec',0.0585744),('second',0.252221),('secrets',0.0163904),('section',0.0337753),('security',0.0250102),('sed',0.00108546),('see',0.0431053),('seen',0.0264656),('select',0.0138528),('selecting',0.30103),('self',0.30103),('selfeducation',0.0543601),('sem',0.00411382),('semper',0.00441428),('senectus',0.0364387),('series',0.30103),('server',0.00289832),('servers',0.0307274),('service',0.30103),('services',0.0176302),('session',0.262424),('set',0.0897196),('setup',0.30103),('several',0.30103),('shake',0.30103),('shall',0.176091),('shared',0.0144512),('shell',0.0977572),('shift',0.191978),('shifted',0.255736),('short',0.30103),('shortcode',0.00300551),('shortcodes',0.0163904),('should',0.0117411),('show',0.0377886),('sign',0.30103),('significant',0.30103),('simplifies',0.30103),('simply',0.30103),('since',0.30103),('sint',0.00721886),('sit',0.0012532),('site',0.0158427),('sitealias',0.30103),('sites',0.0521996),('situation',0.30103),('skill',0.30103),('skills',0.0542152),('slowdown',0.186977),('slowdowns',0.30103),('small',0.30103),('smooth',0.0163904),('so',0.0576959),('sociis',0.0883259),('sociosqu',0.0463834),('sodales',0.00857193),('solely',0.30103),('sollicitudin',0.0087153),('soluta',0.199904),('solution',0.30103),('some',0.0256934),('someone',0.0396515),('something',0.30103),('source',0.0377801),('sp2',0.04451),('space',0.0222764),('span',0.30103),('special',0.30103),('specific',0.231186),('specifically',0.147802),('sports',0.0485131),('sql',0.0230091),('sqlite',0.027781),('src',0.30103),('ssh',0.033997),('stable',0.0971795),('staff',0.0430156),('stand',0.30103),('start',0.0111617),('status',0.09691),('step',0.0484993),('stet',0.0297166),('sthashp70hjjcodpuf',0.0377886),('still',0.204301),('stop',0.0163904),('storage',0.131679),('store',0.0163904),('street',0.176091),('string',0.30103),('strong',0.30103),('strongly',0.30103),('subfolders',0.30103),('subject',0.176091),('submitted',0.0208327),('substantial',0.30103),('success',0.30103),('such',0.111088),('sufficient',0.183954),('sun',0.027877),('sunshine',0.0163904),('sunt',0.00355936),('support',0.0073776),('supported',0.0526067),('supporting',0.30103),('supports',0.0744903),('sure',0.30103),('suscipit',0.00611537),('suspendisse',0.00334249),('symphony',0.176091),('system',0.0158144),('table',0.196045),('tables',0.131469),('taciti',0.0463395),('take',0.30103),('takimata',0.0313348),('tation',0.0697055),('te',0.146578),('teach',0.30103),('teaching',0.0163904),('team',0.0341949),('tech',0.30103),('technical',0.244583),('tellus',0.00282297),('tempor',0.00737788),('temporary',0.30103),('tempus',0.00522588),('term',0.247145),('terminal',0.30103),('test',0.115745),('tested',0.30103),('testing',0.0811737),('tests',0.20408),('text',0.138548),('than',0.0147233),('thank',0.0163904),('that',0.00771127),('the',0.00179517),('thee',0.30103),('their',0.0703148),('them',0.147529),('themes',0.00327305),('then',0.0957428),('thepianoguys',0.0163904),('there',0.0560502),('these',0.0292599),('they',0.224733),('things',0.30103),('thinking',0.176091),('third',0.199213),('this',0.00749681),('those',0.175968),('thoughts',0.0163904),('three',0.176091),('through',0.30103),('throughout',0.30103),('thu',0.30103),('ticket',0.30103),('time',0.00725258),('tincidunt',0.00336159),('tip',0.226724),('tips',0.0163904),('title',0.0314013),('to',0.00151084),('together',0.228328),('tomorrow',0.176091),('too',0.30103),('tooltip',0.01524),('top',0.00264229),('torquent',0.0465139),('tortor',0.00433844),('totam',0.00669074),('touch',0.30103),('track',0.30103),('transform',0.0163904),('transition',0.176091),('travel',0.0121983),('travelers',0.0163904),('traveling',0.0163904),('tree',0.0514489),('tristique',0.0102456),('troubleshooting',0.0413336),('try',0.278104),('trying',0.30103),('tue',0.0953407),('turn',0.30103),('turpis',0.00355807),('tweak',0.176091),('twice',0.30103),('type',0.0577375),('types',0.196338),('typing',0.0662885),('ui',0.214728),('ullamco',0.30103),('ullamcorper',0.00498918),('ultrices',0.00520819),('ultricies',0.00955535),('unde',0.00543989),('under',0.0367273),('undergo',0.202373),('undergone',0.30103),('underneath',0.30103),('understand',0.22044),('unexpected',0.30103),('unix',0.176091),('unsupported',0.0444907),('until',0.139055),('unzip',0.30103),('up',0.0693844),('update',0.0470825),('updates',0.0152708),('upgrade',0.0902864),('upgrading',0.30103),('upload',0.30103),('uploaded',0.30103),('upon',0.30103),('url',0.193511),('urls',0.012633),('urna',0.00970888),('us',0.00811789),('usage',0.30103),('use',0.0293922),('used',0.124939),('user',0.206924),('username',0.0859237),('users',0.0718015),('using',0.097274),('usr',0.2719),('ut',0.00114857),('v6a',0.176091),('value',0.188962),('vancouver',0.176091),('variable',0.30103),('varius',0.0057301),('vast',0.189339),('vehicula',0.0115198),('vel',0.00222332),('velit',0.00338297),('vendors',0.241487),('venenatis',0.00607484),('veniam',0.060522),('veritatis',0.00671543),('vero',0.0378548),('version',0.0682765),('versions',0.0511525),('very',0.0153244),('vestibulum',0.00191038),('via',0.161442),('video',0.00336221),('vim',0.179817),('vimcheatsheethtml',0.0575345),('virtualhost',0.30103),('visitors',0.30103),('vitae',0.00200118),('vivamus',0.00399673),('viverra',0.00608576),('volunteer',0.253731),('volunteers',0.192562),('voluptas',0.0281337),('voluptate',0.0925406),('voluptatem',0.0054274),('voluptua',0.142863),('volutpat',0.00564142),('vote',0.0596824),('votes',0.0162974),('vulputate',0.00697738),('want',0.117327),('warning',0.30103),('was',0.0347621),('watch',0.176091),('way',0.127628),('ways',0.0163904),('we',0.0384383),('web',0.0026178),('webhosting',0.04451),('website',0.127893),('websites',0.0163904),('wed',0.0941269),('weebpal',0.0163904),('weebpalcom',0.0193052),('well',0.176915),('wget',0.216288),('what',0.00673832),('when',0.0792203),('which',0.0902216),('while',0.0307611),('who',0.187523),('whole',0.30103),('why',0.0163904),('will',0.00804853),('window',0.11546),('windows',0.0342377),('winds',0.258725),('wish',0.132513),('wishing',0.23575),('wisi',0.0695035),('with',0.00575713),('within',0.176091),('without',0.30103),('won',0.30103),('work',0.0471068),('workable',0.250705),('working',0.244275),('works',0.30103),('worry',0.30103),('worth',0.30103),('would',0.074715),('write',0.176091),('written',0.30103),('www',0.106513),('wwwfprintfnet',0.0573908),('wwwyoutubecom',0.176091),('years',0.30103),('yellow',0.0163904),('yet',0.0167626),('you',0.00291095),('your',0.00554508),('yourdomaincom',0.30103),('yourself',0.0158144),('zip',0.158175),('zircon',0.0163904),('zzril',0.146338);
/*!40000 ALTER TABLE `search_total` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `semaphore`
--

DROP TABLE IF EXISTS `semaphore`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `semaphore` (
  `name` varchar(255) NOT NULL DEFAULT '' COMMENT 'Primary Key: Unique name.',
  `value` varchar(255) NOT NULL DEFAULT '' COMMENT 'A value for the semaphore.',
  `expire` double NOT NULL COMMENT 'A Unix timestamp with microseconds indicating when the semaphore should expire.',
  PRIMARY KEY (`name`),
  KEY `value` (`value`),
  KEY `expire` (`expire`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Table for holding semaphores, locks, flags, etc. that...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `semaphore`
--

LOCK TABLES `semaphore` WRITE;
/*!40000 ALTER TABLE `semaphore` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `semaphore` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `sequences`
--

DROP TABLE IF EXISTS `sequences`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `sequences` (
  `value` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'The value of the sequence.',
  PRIMARY KEY (`value`)
) ENGINE=InnoDB AUTO_INCREMENT=19 DEFAULT CHARSET=utf8 COMMENT='Stores IDs.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sequences`
--

LOCK TABLES `sequences` WRITE;
/*!40000 ALTER TABLE `sequences` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `sequences` VALUES (18);
/*!40000 ALTER TABLE `sequences` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `sessions`
--

DROP TABLE IF EXISTS `sessions`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `sessions` (
  `uid` int(10) unsigned NOT NULL COMMENT 'The users.uid corresponding to a session, or 0 for anonymous user.',
  `sid` varchar(128) NOT NULL COMMENT 'A session ID. The value is generated by Drupal’s session handlers.',
  `ssid` varchar(128) NOT NULL DEFAULT '' COMMENT 'Secure session ID. The value is generated by Drupal’s session handlers.',
  `hostname` varchar(128) NOT NULL DEFAULT '' COMMENT 'The IP address that last used this session ID (sid).',
  `timestamp` int(11) NOT NULL DEFAULT '0' COMMENT 'The Unix timestamp when this session last requested a page. Old records are purged by PHP automatically.',
  `cache` int(11) NOT NULL DEFAULT '0' COMMENT 'The time of this user’s last post. This is used when the site has specified a minimum_cache_lifetime. See cache_get().',
  `session` longblob COMMENT 'The serialized contents of $_SESSION, an array of name/value pairs that persists across page requests by this session ID. Drupal loads $_SESSION from here at the start of each request and saves it at the end.',
  PRIMARY KEY (`sid`,`ssid`),
  KEY `timestamp` (`timestamp`),
  KEY `uid` (`uid`),
  KEY `ssid` (`ssid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Drupal’s session handlers read and write into the...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sessions`
--

LOCK TABLES `sessions` WRITE;
/*!40000 ALTER TABLE `sessions` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `sessions` VALUES (1,'3QV5Ae0ANwuTwt8MXjAOg_CobIrc5KhTkGsHK1_UoJc','','192.168.1.34',1512620348,0,''),(1,'ekwlGCPFCrUYPQnYlciV2DEBl3rnwLqYm-LEnTIv4YE','','192.168.1.63',1501063336,0,''),(1,'u24bIdQrh2wrfjWWqKSEHPqkom6akWdk5kwhFHE9z24','','192.168.1.43',1501062371,0,'');
/*!40000 ALTER TABLE `sessions` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `shortcut_set`
--

DROP TABLE IF EXISTS `shortcut_set`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `shortcut_set` (
  `set_name` varchar(32) NOT NULL DEFAULT '' COMMENT 'Primary Key: The menu_links.menu_name under which the set’s links are stored.',
  `title` varchar(255) NOT NULL DEFAULT '' COMMENT 'The title of the set.',
  PRIMARY KEY (`set_name`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Stores information about sets of shortcuts links.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `shortcut_set`
--

LOCK TABLES `shortcut_set` WRITE;
/*!40000 ALTER TABLE `shortcut_set` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `shortcut_set` VALUES ('shortcut-set-1','Default');
/*!40000 ALTER TABLE `shortcut_set` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `shortcut_set_users`
--

DROP TABLE IF EXISTS `shortcut_set_users`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `shortcut_set_users` (
  `uid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The users.uid for this set.',
  `set_name` varchar(32) NOT NULL DEFAULT '' COMMENT 'The shortcut_set.set_name that will be displayed for this user.',
  PRIMARY KEY (`uid`),
  KEY `set_name` (`set_name`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Maps users to shortcut sets.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `shortcut_set_users`
--

LOCK TABLES `shortcut_set_users` WRITE;
/*!40000 ALTER TABLE `shortcut_set_users` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `shortcut_set_users` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `system`
--

DROP TABLE IF EXISTS `system`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `system` (
  `filename` varchar(255) NOT NULL DEFAULT '' COMMENT 'The path of the primary file for this item, relative to the Drupal root; e.g. modules/node/node.module.',
  `name` varchar(255) NOT NULL DEFAULT '' COMMENT 'The name of the item; e.g. node.',
  `type` varchar(12) NOT NULL DEFAULT '' COMMENT 'The type of the item, either module, theme, or theme_engine.',
  `owner` varchar(255) NOT NULL DEFAULT '' COMMENT 'A theme’s ’parent’ . Can be either a theme or an engine.',
  `status` int(11) NOT NULL DEFAULT '0' COMMENT 'Boolean indicating whether or not this item is enabled.',
  `bootstrap` int(11) NOT NULL DEFAULT '0' COMMENT 'Boolean indicating whether this module is loaded during Drupal’s early bootstrapping phase (e.g. even before the page cache is consulted).',
  `schema_version` smallint(6) NOT NULL DEFAULT '-1' COMMENT 'The module’s database schema version number. -1 if the module is not installed (its tables do not exist); 0 or the largest N of the module’s hook_update_N() function that has either been run or existed when the module was first installed.',
  `weight` int(11) NOT NULL DEFAULT '0' COMMENT 'The order in which this module’s hooks should be invoked relative to other modules. Equal-weighted modules are ordered by name.',
  `info` blob COMMENT 'A serialized array containing information from the module’s .info file; keys can include name, description, package, version, core, dependencies, and php.',
  PRIMARY KEY (`filename`),
  KEY `system_list` (`status`,`bootstrap`,`type`,`weight`,`name`),
  KEY `type_name` (`type`,`name`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='A list of all modules, themes, and theme engines that are...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `system`
--

LOCK TABLES `system` WRITE;
/*!40000 ALTER TABLE `system` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `system` VALUES ('modules/aggregator/aggregator.module','aggregator','module','',0,0,-1,0,'a:14:{s:4:\"name\";s:10:\"Aggregator\";s:11:\"description\";s:57:\"Aggregates syndicated content (RSS, RDF, and Atom feeds).\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:15:\"aggregator.test\";}s:9:\"configure\";s:41:\"admin/config/services/aggregator/settings\";s:11:\"stylesheets\";a:1:{s:3:\"all\";a:1:{s:14:\"aggregator.css\";s:33:\"modules/aggregator/aggregator.css\";}}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/aggregator/tests/aggregator_test.module','aggregator_test','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:23:\"Aggregator module tests\";s:11:\"description\";s:46:\"Support module for aggregator related testing.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/block/block.module','block','module','',1,0,7009,-5,'a:13:{s:4:\"name\";s:5:\"Block\";s:11:\"description\";s:140:\"Controls the visual building blocks a page is constructed with. Blocks are boxes of content rendered into an area, or region, of a web page.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:10:\"block.test\";}s:9:\"configure\";s:21:\"admin/structure/block\";s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/block/tests/block_test.module','block_test','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:10:\"Block test\";s:11:\"description\";s:21:\"Provides test blocks.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/blog/blog.module','blog','module','',1,0,0,0,'a:12:{s:4:\"name\";s:4:\"Blog\";s:11:\"description\";s:25:\"Enables multi-user blogs.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:9:\"blog.test\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/book/book.module','book','module','',1,0,0,0,'a:14:{s:4:\"name\";s:4:\"Book\";s:11:\"description\";s:66:\"Allows users to create and organize related content in an outline.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:9:\"book.test\";}s:9:\"configure\";s:27:\"admin/content/book/settings\";s:11:\"stylesheets\";a:1:{s:3:\"all\";a:1:{s:8:\"book.css\";s:21:\"modules/book/book.css\";}}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/color/color.module','color','module','',1,0,7001,0,'a:12:{s:4:\"name\";s:5:\"Color\";s:11:\"description\";s:70:\"Allows administrators to change the color scheme of compatible themes.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:10:\"color.test\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/comment/comment.module','comment','module','',1,0,7009,0,'a:14:{s:4:\"name\";s:7:\"Comment\";s:11:\"description\";s:57:\"Allows users to comment on and discuss published content.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:1:{i:0;s:4:\"text\";}s:5:\"files\";a:2:{i:0;s:14:\"comment.module\";i:1;s:12:\"comment.test\";}s:9:\"configure\";s:21:\"admin/content/comment\";s:11:\"stylesheets\";a:1:{s:3:\"all\";a:1:{s:11:\"comment.css\";s:27:\"modules/comment/comment.css\";}}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/contact/contact.module','contact','module','',1,0,7003,0,'a:13:{s:4:\"name\";s:7:\"Contact\";s:11:\"description\";s:61:\"Enables the use of both personal and site-wide contact forms.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:12:\"contact.test\";}s:9:\"configure\";s:23:\"admin/structure/contact\";s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/contextual/contextual.module','contextual','module','',1,0,0,0,'a:12:{s:4:\"name\";s:16:\"Contextual links\";s:11:\"description\";s:75:\"Provides contextual links to perform actions related to elements on a page.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:15:\"contextual.test\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/dashboard/dashboard.module','dashboard','module','',1,0,0,0,'a:13:{s:4:\"name\";s:9:\"Dashboard\";s:11:\"description\";s:136:\"Provides a dashboard page in the administrative interface for organizing administrative tasks and tracking information within your site.\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:5:\"files\";a:1:{i:0;s:14:\"dashboard.test\";}s:12:\"dependencies\";a:1:{i:0;s:5:\"block\";}s:9:\"configure\";s:25:\"admin/dashboard/customize\";s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/dblog/dblog.module','dblog','module','',1,1,7003,0,'a:12:{s:4:\"name\";s:16:\"Database logging\";s:11:\"description\";s:47:\"Logs and records system events to the database.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:10:\"dblog.test\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/field/field.module','field','module','',1,0,7004,0,'a:14:{s:4:\"name\";s:5:\"Field\";s:11:\"description\";s:57:\"Field API to add fields to entities like nodes and users.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:4:{i:0;s:12:\"field.module\";i:1;s:16:\"field.attach.inc\";i:2;s:20:\"field.info.class.inc\";i:3;s:16:\"tests/field.test\";}s:12:\"dependencies\";a:1:{i:0;s:17:\"field_sql_storage\";}s:8:\"required\";b:1;s:11:\"stylesheets\";a:1:{s:3:\"all\";a:1:{s:15:\"theme/field.css\";s:29:\"modules/field/theme/field.css\";}}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/field/modules/field_sql_storage/field_sql_storage.module','field_sql_storage','module','',1,0,7002,0,'a:13:{s:4:\"name\";s:17:\"Field SQL storage\";s:11:\"description\";s:37:\"Stores field data in an SQL database.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:1:{i:0;s:5:\"field\";}s:5:\"files\";a:1:{i:0;s:22:\"field_sql_storage.test\";}s:8:\"required\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/field/modules/list/list.module','list','module','',1,0,7002,0,'a:14:{s:4:\"name\";s:4:\"List\";s:11:\"description\";s:69:\"Defines list field types. Use with Options to create selection lists.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:2:{i:0;s:5:\"field\";i:1;s:7:\"options\";}s:5:\"files\";a:1:{i:0;s:15:\"tests/list.test\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;s:8:\"required\";b:1;s:11:\"explanation\";s:76:\"Field type(s) in use - see <a href=\"/en/admin/reports/fields\">Field list</a>\";}'),('modules/field/modules/list/tests/list_test.module','list_test','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:9:\"List test\";s:11:\"description\";s:41:\"Support module for the List module tests.\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.56\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/field/modules/number/number.module','number','module','',1,0,0,0,'a:12:{s:4:\"name\";s:6:\"Number\";s:11:\"description\";s:28:\"Defines numeric field types.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:1:{i:0;s:5:\"field\";}s:5:\"files\";a:1:{i:0;s:11:\"number.test\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/field/modules/options/options.module','options','module','',1,0,0,0,'a:12:{s:4:\"name\";s:7:\"Options\";s:11:\"description\";s:82:\"Defines selection, check box and radio button widgets for text and numeric fields.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:1:{i:0;s:5:\"field\";}s:5:\"files\";a:1:{i:0;s:12:\"options.test\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/field/modules/text/text.module','text','module','',1,0,7000,0,'a:14:{s:4:\"name\";s:4:\"Text\";s:11:\"description\";s:32:\"Defines simple text field types.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:1:{i:0;s:5:\"field\";}s:5:\"files\";a:1:{i:0;s:9:\"text.test\";}s:8:\"required\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;s:11:\"explanation\";s:76:\"Field type(s) in use - see <a href=\"/en/admin/reports/fields\">Field list</a>\";}'),('modules/field/tests/field_test.module','field_test','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:14:\"Field API Test\";s:11:\"description\";s:39:\"Support module for the Field API tests.\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:7:\"Testing\";s:5:\"files\";a:1:{i:0;s:21:\"field_test.entity.inc\";}s:7:\"version\";s:4:\"7.56\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/field_ui/field_ui.module','field_ui','module','',1,0,0,0,'a:12:{s:4:\"name\";s:8:\"Field UI\";s:11:\"description\";s:33:\"User interface for the Field API.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:1:{i:0;s:5:\"field\";}s:5:\"files\";a:1:{i:0;s:13:\"field_ui.test\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/file/file.module','file','module','',1,0,0,0,'a:12:{s:4:\"name\";s:4:\"File\";s:11:\"description\";s:26:\"Defines a file field type.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:1:{i:0;s:5:\"field\";}s:5:\"files\";a:1:{i:0;s:15:\"tests/file.test\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/file/tests/file_module_test.module','file_module_test','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:9:\"File test\";s:11:\"description\";s:53:\"Provides hooks for testing File module functionality.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/filter/filter.module','filter','module','',1,0,7010,0,'a:14:{s:4:\"name\";s:6:\"Filter\";s:11:\"description\";s:43:\"Filters content in preparation for display.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:11:\"filter.test\";}s:8:\"required\";b:1;s:9:\"configure\";s:28:\"admin/config/content/formats\";s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/forum/forum.module','forum','module','',1,0,7012,1,'a:14:{s:4:\"name\";s:5:\"Forum\";s:11:\"description\";s:27:\"Provides discussion forums.\";s:12:\"dependencies\";a:2:{i:0;s:8:\"taxonomy\";i:1;s:7:\"comment\";}s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:10:\"forum.test\";}s:9:\"configure\";s:21:\"admin/structure/forum\";s:11:\"stylesheets\";a:1:{s:3:\"all\";a:1:{s:9:\"forum.css\";s:23:\"modules/forum/forum.css\";}}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/help/help.module','help','module','',1,0,0,0,'a:12:{s:4:\"name\";s:4:\"Help\";s:11:\"description\";s:35:\"Manages the display of online help.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:9:\"help.test\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/image/image.module','image','module','',1,0,7005,0,'a:15:{s:4:\"name\";s:5:\"Image\";s:11:\"description\";s:34:\"Provides image manipulation tools.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:1:{i:0;s:4:\"file\";}s:5:\"files\";a:1:{i:0;s:10:\"image.test\";}s:9:\"configure\";s:31:\"admin/config/media/image-styles\";s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;s:8:\"required\";b:1;s:11:\"explanation\";s:76:\"Field type(s) in use - see <a href=\"/en/admin/reports/fields\">Field list</a>\";}'),('modules/image/tests/image_module_test.module','image_module_test','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:10:\"Image test\";s:11:\"description\";s:69:\"Provides hook implementations for testing Image module functionality.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:24:\"image_module_test.module\";}s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/locale/locale.module','locale','module','',1,0,7005,0,'a:13:{s:4:\"name\";s:6:\"Locale\";s:11:\"description\";s:119:\"Adds language handling functionality and enables the translation of the user interface to languages other than English.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:11:\"locale.test\";}s:9:\"configure\";s:30:\"admin/config/regional/language\";s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/locale/tests/locale_test.module','locale_test','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:11:\"Locale Test\";s:11:\"description\";s:42:\"Support module for the locale layer tests.\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.56\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/menu/menu.module','menu','module','',1,0,7003,0,'a:13:{s:4:\"name\";s:4:\"Menu\";s:11:\"description\";s:60:\"Allows administrators to customize the site navigation menu.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:9:\"menu.test\";}s:9:\"configure\";s:20:\"admin/structure/menu\";s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/node/node.module','node','module','',1,0,7016,0,'a:15:{s:4:\"name\";s:4:\"Node\";s:11:\"description\";s:66:\"Allows content to be submitted to the site and displayed on pages.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:2:{i:0;s:11:\"node.module\";i:1;s:9:\"node.test\";}s:8:\"required\";b:1;s:9:\"configure\";s:21:\"admin/structure/types\";s:11:\"stylesheets\";a:1:{s:3:\"all\";a:1:{s:8:\"node.css\";s:21:\"modules/node/node.css\";}}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/node/tests/node_access_test.module','node_access_test','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:24:\"Node module access tests\";s:11:\"description\";s:43:\"Support module for node permission testing.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/node/tests/node_test.module','node_test','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:17:\"Node module tests\";s:11:\"description\";s:40:\"Support module for node related testing.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/node/tests/node_test_exception.module','node_test_exception','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:27:\"Node module exception tests\";s:11:\"description\";s:50:\"Support module for node related exception testing.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/openid/openid.module','openid','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:6:\"OpenID\";s:11:\"description\";s:48:\"Allows users to log into your site using OpenID.\";s:7:\"version\";s:4:\"7.56\";s:7:\"package\";s:4:\"Core\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:11:\"openid.test\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/openid/tests/openid_test.module','openid_test','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:21:\"OpenID dummy provider\";s:11:\"description\";s:33:\"OpenID provider used for testing.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:1:{i:0;s:6:\"openid\";}s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/overlay/overlay.module','overlay','module','',1,1,0,0,'a:12:{s:4:\"name\";s:7:\"Overlay\";s:11:\"description\";s:59:\"Displays the Drupal administration interface in an overlay.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/path/path.module','path','module','',1,0,0,0,'a:13:{s:4:\"name\";s:4:\"Path\";s:11:\"description\";s:28:\"Allows users to rename URLs.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:9:\"path.test\";}s:9:\"configure\";s:24:\"admin/config/search/path\";s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/php/php.module','php','module','',1,0,0,0,'a:12:{s:4:\"name\";s:10:\"PHP filter\";s:11:\"description\";s:50:\"Allows embedded PHP code/snippets to be evaluated.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:8:\"php.test\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/poll/poll.module','poll','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:4:\"Poll\";s:11:\"description\";s:95:\"Allows your site to capture votes on different topics in the form of multiple choice questions.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:9:\"poll.test\";}s:11:\"stylesheets\";a:1:{s:3:\"all\";a:1:{s:8:\"poll.css\";s:21:\"modules/poll/poll.css\";}}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/profile/profile.module','profile','module','',0,0,-1,0,'a:14:{s:4:\"name\";s:7:\"Profile\";s:11:\"description\";s:36:\"Supports configurable user profiles.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:12:\"profile.test\";}s:9:\"configure\";s:27:\"admin/config/people/profile\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/rdf/rdf.module','rdf','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:3:\"RDF\";s:11:\"description\";s:148:\"Enriches your content with metadata to let other applications (e.g. search engines, aggregators) better understand its relationships and attributes.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:8:\"rdf.test\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/rdf/tests/rdf_test.module','rdf_test','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:16:\"RDF module tests\";s:11:\"description\";s:38:\"Support module for RDF module testing.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:12:\"dependencies\";a:1:{i:0;s:4:\"blog\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/search/search.module','search','module','',1,0,7000,0,'a:14:{s:4:\"name\";s:6:\"Search\";s:11:\"description\";s:36:\"Enables site-wide keyword searching.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:2:{i:0;s:19:\"search.extender.inc\";i:1;s:11:\"search.test\";}s:9:\"configure\";s:28:\"admin/config/search/settings\";s:11:\"stylesheets\";a:1:{s:3:\"all\";a:1:{s:10:\"search.css\";s:25:\"modules/search/search.css\";}}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/search/tests/search_embedded_form.module','search_embedded_form','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:20:\"Search embedded form\";s:11:\"description\";s:59:\"Support module for search module testing of embedded forms.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/search/tests/search_extra_type.module','search_extra_type','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:16:\"Test search type\";s:11:\"description\";s:41:\"Support module for search module testing.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/search/tests/search_node_tags.module','search_node_tags','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:21:\"Test search node tags\";s:11:\"description\";s:44:\"Support module for Node search tags testing.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/shortcut/shortcut.module','shortcut','module','',1,0,0,0,'a:13:{s:4:\"name\";s:8:\"Shortcut\";s:11:\"description\";s:60:\"Allows users to manage customizable lists of shortcut links.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:13:\"shortcut.test\";}s:9:\"configure\";s:36:\"admin/config/user-interface/shortcut\";s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/simpletest/simpletest.module','simpletest','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:7:\"Testing\";s:11:\"description\";s:53:\"Provides a framework for unit and functional testing.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:50:{i:0;s:15:\"simpletest.test\";i:1;s:24:\"drupal_web_test_case.php\";i:2;s:18:\"tests/actions.test\";i:3;s:15:\"tests/ajax.test\";i:4;s:16:\"tests/batch.test\";i:5;s:15:\"tests/boot.test\";i:6;s:20:\"tests/bootstrap.test\";i:7;s:16:\"tests/cache.test\";i:8;s:17:\"tests/common.test\";i:9;s:24:\"tests/database_test.test\";i:10;s:22:\"tests/entity_crud.test\";i:11;s:32:\"tests/entity_crud_hook_test.test\";i:12;s:23:\"tests/entity_query.test\";i:13;s:16:\"tests/error.test\";i:14;s:15:\"tests/file.test\";i:15;s:23:\"tests/filetransfer.test\";i:16;s:15:\"tests/form.test\";i:17;s:16:\"tests/graph.test\";i:18;s:16:\"tests/image.test\";i:19;s:15:\"tests/lock.test\";i:20;s:15:\"tests/mail.test\";i:21;s:15:\"tests/menu.test\";i:22;s:17:\"tests/module.test\";i:23;s:16:\"tests/pager.test\";i:24;s:19:\"tests/password.test\";i:25;s:15:\"tests/path.test\";i:26;s:19:\"tests/registry.test\";i:27;s:17:\"tests/schema.test\";i:28;s:18:\"tests/session.test\";i:29;s:20:\"tests/tablesort.test\";i:30;s:16:\"tests/theme.test\";i:31;s:18:\"tests/unicode.test\";i:32;s:17:\"tests/update.test\";i:33;s:17:\"tests/xmlrpc.test\";i:34;s:26:\"tests/upgrade/upgrade.test\";i:35;s:34:\"tests/upgrade/upgrade.comment.test\";i:36;s:33:\"tests/upgrade/upgrade.filter.test\";i:37;s:32:\"tests/upgrade/upgrade.forum.test\";i:38;s:33:\"tests/upgrade/upgrade.locale.test\";i:39;s:31:\"tests/upgrade/upgrade.menu.test\";i:40;s:31:\"tests/upgrade/upgrade.node.test\";i:41;s:35:\"tests/upgrade/upgrade.taxonomy.test\";i:42;s:34:\"tests/upgrade/upgrade.trigger.test\";i:43;s:39:\"tests/upgrade/upgrade.translatable.test\";i:44;s:33:\"tests/upgrade/upgrade.upload.test\";i:45;s:31:\"tests/upgrade/upgrade.user.test\";i:46;s:36:\"tests/upgrade/update.aggregator.test\";i:47;s:33:\"tests/upgrade/update.trigger.test\";i:48;s:31:\"tests/upgrade/update.field.test\";i:49;s:30:\"tests/upgrade/update.user.test\";}s:9:\"configure\";s:41:\"admin/config/development/testing/settings\";s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/simpletest/tests/actions_loop_test.module','actions_loop_test','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:17:\"Actions loop test\";s:11:\"description\";s:39:\"Support module for action loop testing.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/simpletest/tests/ajax_forms_test.module','ajax_forms_test','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:26:\"AJAX form test mock module\";s:11:\"description\";s:25:\"Test for AJAX form calls.\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.56\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/simpletest/tests/ajax_test.module','ajax_test','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:9:\"AJAX Test\";s:11:\"description\";s:40:\"Support module for AJAX framework tests.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/simpletest/tests/batch_test.module','batch_test','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:14:\"Batch API test\";s:11:\"description\";s:35:\"Support module for Batch API tests.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/simpletest/tests/boot_test_1.module','boot_test_1','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:21:\"Early bootstrap tests\";s:11:\"description\";s:39:\"A support module for hook_boot testing.\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.56\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/simpletest/tests/boot_test_2.module','boot_test_2','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:21:\"Early bootstrap tests\";s:11:\"description\";s:44:\"A support module for hook_boot hook testing.\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.56\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/simpletest/tests/common_test.module','common_test','module','',0,0,-1,0,'a:14:{s:4:\"name\";s:11:\"Common Test\";s:11:\"description\";s:32:\"Support module for Common tests.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:11:\"stylesheets\";a:2:{s:3:\"all\";a:1:{s:15:\"common_test.css\";s:40:\"modules/simpletest/tests/common_test.css\";}s:5:\"print\";a:1:{s:21:\"common_test.print.css\";s:46:\"modules/simpletest/tests/common_test.print.css\";}}s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/simpletest/tests/common_test_cron_helper.module','common_test_cron_helper','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:23:\"Common Test Cron Helper\";s:11:\"description\";s:56:\"Helper module for CronRunTestCase::testCronExceptions().\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/simpletest/tests/database_test.module','database_test','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:13:\"Database Test\";s:11:\"description\";s:40:\"Support module for Database layer tests.\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.56\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/simpletest/tests/drupal_autoload_test/drupal_autoload_test.module','drupal_autoload_test','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:25:\"Drupal code registry test\";s:11:\"description\";s:45:\"Support module for testing the code registry.\";s:5:\"files\";a:2:{i:0;s:34:\"drupal_autoload_test_interface.inc\";i:1;s:30:\"drupal_autoload_test_class.inc\";}s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/simpletest/tests/drupal_system_listing_compatible_test/drupal_system_listing_compatible_test.module','drupal_system_listing_compatible_test','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:37:\"Drupal system listing compatible test\";s:11:\"description\";s:62:\"Support module for testing the drupal_system_listing function.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/simpletest/tests/drupal_system_listing_incompatible_test/drupal_system_listing_incompatible_test.module','drupal_system_listing_incompatible_test','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:39:\"Drupal system listing incompatible test\";s:11:\"description\";s:62:\"Support module for testing the drupal_system_listing function.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/simpletest/tests/entity_cache_test.module','entity_cache_test','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:17:\"Entity cache test\";s:11:\"description\";s:40:\"Support module for testing entity cache.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:1:{i:0;s:28:\"entity_cache_test_dependency\";}s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/simpletest/tests/entity_cache_test_dependency.module','entity_cache_test_dependency','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:28:\"Entity cache test dependency\";s:11:\"description\";s:51:\"Support dependency module for testing entity cache.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/simpletest/tests/entity_crud_hook_test.module','entity_crud_hook_test','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:22:\"Entity CRUD Hooks Test\";s:11:\"description\";s:35:\"Support module for CRUD hook tests.\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.56\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/simpletest/tests/entity_query_access_test.module','entity_query_access_test','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:24:\"Entity query access test\";s:11:\"description\";s:49:\"Support module for checking entity query results.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/simpletest/tests/error_test.module','error_test','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:10:\"Error test\";s:11:\"description\";s:47:\"Support module for error and exception testing.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/simpletest/tests/file_test.module','file_test','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:9:\"File test\";s:11:\"description\";s:39:\"Support module for file handling tests.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:16:\"file_test.module\";}s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/simpletest/tests/filter_test.module','filter_test','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:18:\"Filter test module\";s:11:\"description\";s:33:\"Tests filter hooks and functions.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/simpletest/tests/form_test.module','form_test','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:12:\"FormAPI Test\";s:11:\"description\";s:34:\"Support module for Form API tests.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/simpletest/tests/image_test.module','image_test','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:10:\"Image test\";s:11:\"description\";s:39:\"Support module for image toolkit tests.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/simpletest/tests/menu_test.module','menu_test','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:15:\"Hook menu tests\";s:11:\"description\";s:37:\"Support module for menu hook testing.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/simpletest/tests/module_test.module','module_test','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:11:\"Module test\";s:11:\"description\";s:41:\"Support module for module system testing.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/simpletest/tests/path_test.module','path_test','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:15:\"Hook path tests\";s:11:\"description\";s:37:\"Support module for path hook testing.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/simpletest/tests/psr_0_test/psr_0_test.module','psr_0_test','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:16:\"PSR-0 Test cases\";s:11:\"description\";s:44:\"Test classes to be discovered by simpletest.\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.56\";s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/simpletest/tests/psr_4_test/psr_4_test.module','psr_4_test','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:16:\"PSR-4 Test cases\";s:11:\"description\";s:44:\"Test classes to be discovered by simpletest.\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.56\";s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/simpletest/tests/requirements1_test.module','requirements1_test','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:19:\"Requirements 1 Test\";s:11:\"description\";s:80:\"Tests that a module is not installed when it fails hook_requirements(\'install\').\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/simpletest/tests/requirements2_test.module','requirements2_test','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:19:\"Requirements 2 Test\";s:11:\"description\";s:98:\"Tests that a module is not installed when the one it depends on fails hook_requirements(\'install).\";s:12:\"dependencies\";a:2:{i:0;s:18:\"requirements1_test\";i:1;s:7:\"comment\";}s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/simpletest/tests/session_test.module','session_test','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:12:\"Session test\";s:11:\"description\";s:40:\"Support module for session data testing.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/simpletest/tests/system_dependencies_test.module','system_dependencies_test','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:22:\"System dependency test\";s:11:\"description\";s:47:\"Support module for testing system dependencies.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:12:\"dependencies\";a:1:{i:0;s:19:\"_missing_dependency\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/simpletest/tests/system_incompatible_core_version_dependencies_test.module','system_incompatible_core_version_dependencies_test','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:50:\"System incompatible core version dependencies test\";s:11:\"description\";s:47:\"Support module for testing system dependencies.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:12:\"dependencies\";a:1:{i:0;s:37:\"system_incompatible_core_version_test\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/simpletest/tests/system_incompatible_core_version_test.module','system_incompatible_core_version_test','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:37:\"System incompatible core version test\";s:11:\"description\";s:47:\"Support module for testing system dependencies.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"5.x\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/simpletest/tests/system_incompatible_module_version_dependencies_test.module','system_incompatible_module_version_dependencies_test','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:52:\"System incompatible module version dependencies test\";s:11:\"description\";s:47:\"Support module for testing system dependencies.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:12:\"dependencies\";a:1:{i:0;s:46:\"system_incompatible_module_version_test (>2.0)\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/simpletest/tests/system_incompatible_module_version_test.module','system_incompatible_module_version_test','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:39:\"System incompatible module version test\";s:11:\"description\";s:47:\"Support module for testing system dependencies.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/simpletest/tests/system_project_namespace_test.module','system_project_namespace_test','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:29:\"System project namespace test\";s:11:\"description\";s:58:\"Support module for testing project namespace dependencies.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:12:\"dependencies\";a:1:{i:0;s:13:\"drupal:filter\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/simpletest/tests/system_test.module','system_test','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:11:\"System test\";s:11:\"description\";s:34:\"Support module for system testing.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:18:\"system_test.module\";}s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/simpletest/tests/taxonomy_test.module','taxonomy_test','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:20:\"Taxonomy test module\";s:11:\"description\";s:45:\"\"Tests functions and hooks not used in core\".\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:12:\"dependencies\";a:1:{i:0;s:8:\"taxonomy\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/simpletest/tests/theme_test.module','theme_test','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:10:\"Theme test\";s:11:\"description\";s:40:\"Support module for theme system testing.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/simpletest/tests/update_script_test.module','update_script_test','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:18:\"Update script test\";s:11:\"description\";s:41:\"Support module for update script testing.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/simpletest/tests/update_test_1.module','update_test_1','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:11:\"Update test\";s:11:\"description\";s:34:\"Support module for update testing.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/simpletest/tests/update_test_2.module','update_test_2','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:11:\"Update test\";s:11:\"description\";s:34:\"Support module for update testing.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/simpletest/tests/update_test_3.module','update_test_3','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:11:\"Update test\";s:11:\"description\";s:34:\"Support module for update testing.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/simpletest/tests/url_alter_test.module','url_alter_test','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:15:\"Url_alter tests\";s:11:\"description\";s:45:\"A support modules for url_alter hook testing.\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.56\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/simpletest/tests/xmlrpc_test.module','xmlrpc_test','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:12:\"XML-RPC Test\";s:11:\"description\";s:75:\"Support module for XML-RPC tests according to the validator1 specification.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/statistics/statistics.module','statistics','module','',1,1,7000,0,'a:13:{s:4:\"name\";s:10:\"Statistics\";s:11:\"description\";s:37:\"Logs access statistics for your site.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:15:\"statistics.test\";}s:9:\"configure\";s:30:\"admin/config/system/statistics\";s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/syslog/syslog.module','syslog','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:6:\"Syslog\";s:11:\"description\";s:41:\"Logs and records system events to syslog.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:11:\"syslog.test\";}s:9:\"configure\";s:32:\"admin/config/development/logging\";s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/system/system.module','system','module','',1,1,7081,0,'a:14:{s:4:\"name\";s:6:\"System\";s:11:\"description\";s:54:\"Handles general site configuration for administrators.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:6:{i:0;s:19:\"system.archiver.inc\";i:1;s:15:\"system.mail.inc\";i:2;s:16:\"system.queue.inc\";i:3;s:14:\"system.tar.inc\";i:4;s:18:\"system.updater.inc\";i:5;s:11:\"system.test\";}s:8:\"required\";b:1;s:9:\"configure\";s:19:\"admin/config/system\";s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/system/tests/cron_queue_test.module','cron_queue_test','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:15:\"Cron Queue test\";s:11:\"description\";s:41:\"Support module for the cron queue runner.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/system/tests/system_cron_test.module','system_cron_test','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:16:\"System Cron Test\";s:11:\"description\";s:45:\"Support module for testing the system_cron().\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/taxonomy/taxonomy.module','taxonomy','module','',1,0,7011,0,'a:15:{s:4:\"name\";s:8:\"Taxonomy\";s:11:\"description\";s:38:\"Enables the categorization of content.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:1:{i:0;s:7:\"options\";}s:5:\"files\";a:2:{i:0;s:15:\"taxonomy.module\";i:1;s:13:\"taxonomy.test\";}s:9:\"configure\";s:24:\"admin/structure/taxonomy\";s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;s:8:\"required\";b:1;s:11:\"explanation\";s:76:\"Field type(s) in use - see <a href=\"/en/admin/reports/fields\">Field list</a>\";}'),('modules/toolbar/toolbar.module','toolbar','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:7:\"Toolbar\";s:11:\"description\";s:99:\"Provides a toolbar that shows the top-level administration menu items and links from other modules.\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/tracker/tracker.module','tracker','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:7:\"Tracker\";s:11:\"description\";s:45:\"Enables tracking of recent content for users.\";s:12:\"dependencies\";a:1:{i:0;s:7:\"comment\";}s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:12:\"tracker.test\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/translation/tests/translation_test.module','translation_test','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:24:\"Content Translation Test\";s:11:\"description\";s:49:\"Support module for the content translation tests.\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.56\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/translation/translation.module','translation','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:19:\"Content translation\";s:11:\"description\";s:57:\"Allows content to be translated into different languages.\";s:12:\"dependencies\";a:1:{i:0;s:6:\"locale\";}s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:16:\"translation.test\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/trigger/tests/trigger_test.module','trigger_test','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:12:\"Trigger Test\";s:11:\"description\";s:33:\"Support module for Trigger tests.\";s:7:\"package\";s:7:\"Testing\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"version\";s:4:\"7.56\";s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/trigger/trigger.module','trigger','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:7:\"Trigger\";s:11:\"description\";s:90:\"Enables actions to be fired on certain system events, such as when new content is created.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:12:\"trigger.test\";}s:9:\"configure\";s:23:\"admin/structure/trigger\";s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/update/tests/aaa_update_test.module','aaa_update_test','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:15:\"AAA Update test\";s:11:\"description\";s:41:\"Support module for update module testing.\";s:7:\"package\";s:7:\"Testing\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"version\";s:4:\"7.56\";s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/update/tests/bbb_update_test.module','bbb_update_test','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:15:\"BBB Update test\";s:11:\"description\";s:41:\"Support module for update module testing.\";s:7:\"package\";s:7:\"Testing\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"version\";s:4:\"7.56\";s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/update/tests/ccc_update_test.module','ccc_update_test','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:15:\"CCC Update test\";s:11:\"description\";s:41:\"Support module for update module testing.\";s:7:\"package\";s:7:\"Testing\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"version\";s:4:\"7.56\";s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/update/tests/update_test.module','update_test','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:11:\"Update test\";s:11:\"description\";s:41:\"Support module for update module testing.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/update/update.module','update','module','',1,0,7001,0,'a:13:{s:4:\"name\";s:14:\"Update manager\";s:11:\"description\";s:104:\"Checks for available updates, and can securely install or update modules and themes via a web interface.\";s:7:\"version\";s:4:\"7.56\";s:7:\"package\";s:4:\"Core\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:11:\"update.test\";}s:9:\"configure\";s:30:\"admin/reports/updates/settings\";s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/user/tests/user_form_test.module','user_form_test','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:22:\"User module form tests\";s:11:\"description\";s:37:\"Support module for user form testing.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/user/user.module','user','module','',1,0,7019,0,'a:15:{s:4:\"name\";s:4:\"User\";s:11:\"description\";s:47:\"Manages the user registration and login system.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:2:{i:0;s:11:\"user.module\";i:1;s:9:\"user.test\";}s:8:\"required\";b:1;s:9:\"configure\";s:19:\"admin/config/people\";s:11:\"stylesheets\";a:1:{s:3:\"all\";a:1:{s:8:\"user.css\";s:21:\"modules/user/user.css\";}}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('profiles/standard/standard.profile','standard','module','',1,0,0,1000,'a:15:{s:4:\"name\";s:8:\"Standard\";s:11:\"description\";s:51:\"Install with commonly used features pre-configured.\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:21:{i:0;s:5:\"block\";i:1;s:5:\"color\";i:2;s:7:\"comment\";i:3;s:10:\"contextual\";i:4;s:9:\"dashboard\";i:5;s:4:\"help\";i:6;s:5:\"image\";i:7;s:4:\"list\";i:8;s:4:\"menu\";i:9;s:6:\"number\";i:10;s:7:\"options\";i:11;s:4:\"path\";i:12;s:8:\"taxonomy\";i:13;s:5:\"dblog\";i:14;s:6:\"search\";i:15;s:8:\"shortcut\";i:16;s:7:\"toolbar\";i:17;s:7:\"overlay\";i:18;s:8:\"field_ui\";i:19;s:4:\"file\";i:20;s:3:\"rdf\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:5:\"mtime\";i:1498069849;s:7:\"package\";s:5:\"Other\";s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;s:6:\"hidden\";b:1;s:8:\"required\";b:1;s:17:\"distribution_name\";s:6:\"Drupal\";}'),('sites/all/modules/addtoany/addtoany.module','addtoany','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:8:\"AddToAny\";s:11:\"description\";s:214:\"Share buttons by AddToAny, including the AddToAny universal sharing button, Facebook, Twitter, Google+, Pinterest, and over 100 more on the <a href=\'https://www.addtoany.com/\' target=\'_blank\'>AddToAny</a> platform.\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:4:{i:0;s:15:\"addtoany.module\";i:1;s:18:\"addtoany.admin.inc\";i:2;s:46:\"views/addtoany_handler_field_addtoany_link.inc\";i:3;s:24:\"views/addtoany.views.inc\";}s:9:\"configure\";s:28:\"admin/config/system/addtoany\";s:7:\"version\";s:7:\"7.x-4.7\";s:7:\"project\";s:8:\"addtoany\";s:9:\"datestamp\";s:10:\"1425967383\";s:5:\"mtime\";i:1499928385;s:12:\"dependencies\";a:0:{}s:7:\"package\";s:5:\"Other\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/admin_menu/admin_devel/admin_devel.module','admin_devel','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:32:\"Administration Development tools\";s:11:\"description\";s:76:\"Administration and debugging functionality for developers and site builders.\";s:7:\"package\";s:14:\"Administration\";s:4:\"core\";s:3:\"7.x\";s:7:\"scripts\";a:1:{s:14:\"admin_devel.js\";s:55:\"sites/all/modules/admin_menu/admin_devel/admin_devel.js\";}s:7:\"version\";s:11:\"7.x-3.0-rc5\";s:7:\"project\";s:10:\"admin_menu\";s:9:\"datestamp\";s:10:\"1419029284\";s:5:\"mtime\";i:1499928385;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/admin_menu/admin_menu.module','admin_menu','module','',1,0,7304,100,'a:13:{s:4:\"name\";s:19:\"Administration menu\";s:11:\"description\";s:123:\"Provides a dropdown menu to most administrative tasks and other common destinations (to users with the proper permissions).\";s:7:\"package\";s:14:\"Administration\";s:4:\"core\";s:3:\"7.x\";s:9:\"configure\";s:38:\"admin/config/administration/admin_menu\";s:12:\"dependencies\";a:1:{i:0;s:14:\"system (>7.10)\";}s:5:\"files\";a:1:{i:0;s:21:\"tests/admin_menu.test\";}s:7:\"version\";s:11:\"7.x-3.0-rc5\";s:7:\"project\";s:10:\"admin_menu\";s:9:\"datestamp\";s:10:\"1419029284\";s:5:\"mtime\";i:1499928385;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/admin_menu/admin_menu_toolbar/admin_menu_toolbar.module','admin_menu_toolbar','module','',1,0,6300,101,'a:12:{s:4:\"name\";s:33:\"Administration menu Toolbar style\";s:11:\"description\";s:17:\"A better Toolbar.\";s:7:\"package\";s:14:\"Administration\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:1:{i:0;s:10:\"admin_menu\";}s:7:\"version\";s:11:\"7.x-3.0-rc5\";s:7:\"project\";s:10:\"admin_menu\";s:9:\"datestamp\";s:10:\"1419029284\";s:5:\"mtime\";i:1499928385;s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/advanced_forum/advanced_forum.module','advanced_forum','module','',1,0,7200,15,'a:13:{s:4:\"name\";s:14:\"Advanced Forum\";s:11:\"description\";s:58:\"Enables the look and feel of other popular forum software.\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:14:\"Advanced Forum\";s:12:\"dependencies\";a:3:{i:0;s:5:\"forum\";i:1;s:6:\"ctools\";i:2;s:5:\"views\";}s:9:\"configure\";s:35:\"admin/config/content/advanced-forum\";s:5:\"files\";a:4:{i:0;s:63:\"includes/views/advanced_forum_handler_field_node_topic_icon.inc\";i:1;s:64:\"includes/views/advanced_forum_handler_field_node_topic_pager.inc\";i:2;s:63:\"includes/views/advanced_forum_plugin_style_forum_topic_list.inc\";i:3;s:13:\"tests/af.test\";}s:7:\"version\";s:7:\"7.x-2.5\";s:7:\"project\";s:14:\"advanced_forum\";s:9:\"datestamp\";s:10:\"1423590792\";s:5:\"mtime\";i:1499928385;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/author_pane/author_pane.module','author_pane','module','',1,0,0,0,'a:12:{s:4:\"name\";s:11:\"Author Pane\";s:11:\"description\";s:93:\"Gathers information from core and user related contrib modules and displays it in a template.\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:13:{i:0;s:32:\"author-pane-user-picture.tpl.php\";i:1;s:19:\"author-pane.tpl.php\";i:2;s:18:\"author_pane.module\";i:3;s:31:\"modules/contact.author-pane.inc\";i:4;s:34:\"modules/fasttoggle.author-pane.inc\";i:5;s:32:\"modules/location.author-pane.inc\";i:6;s:26:\"modules/og.author-pane.inc\";i:7;s:31:\"modules/profile.author-pane.inc\";i:8;s:29:\"modules/troll.author-pane.inc\";i:9;s:35:\"modules/user_badges.author-pane.inc\";i:10;s:35:\"modules/user_titles.author-pane.inc\";i:11;s:34:\"modules/userpoints.author-pane.inc\";i:12;s:29:\"content_types/author_pane.inc\";}s:7:\"version\";s:7:\"7.x-2.0\";s:7:\"project\";s:11:\"author_pane\";s:9:\"datestamp\";s:10:\"1392987849\";s:5:\"mtime\";i:1499928385;s:12:\"dependencies\";a:0:{}s:7:\"package\";s:5:\"Other\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/bean/bean.module','bean','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:4:\"Bean\";s:11:\"description\";s:28:\"Create Bean (Block Entities)\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:12:{i:0;s:22:\"includes/bean.core.inc\";i:1;s:22:\"includes/bean.info.inc\";i:2;s:28:\"plugins/BeanPlugin.class.php\";i:3;s:29:\"plugins/BeanDefault.class.php\";i:4;s:37:\"includes/translation.handler.bean.inc\";i:5;s:36:\"includes/bean.inline_entity_form.inc\";i:6;s:40:\"views/views_handler_filter_bean_type.inc\";i:7;s:39:\"views/views_handler_field_bean_type.inc\";i:8;s:44:\"views/views_handler_field_bean_edit_link.inc\";i:9;s:46:\"views/views_handler_field_bean_delete_link.inc\";i:10;s:45:\"views/views_handler_field_bean_operations.inc\";i:11;s:9:\"bean.test\";}s:12:\"dependencies\";a:2:{i:0;s:18:\"entity (>=7.x-1.0)\";i:1;s:6:\"ctools\";}s:7:\"package\";s:4:\"Bean\";s:7:\"version\";s:7:\"7.x-1.9\";s:7:\"project\";s:4:\"bean\";s:9:\"datestamp\";s:10:\"1425439382\";s:5:\"mtime\";i:1499928385;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/bean/bean_admin_ui/bean_admin_ui.module','bean_admin_ui','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:13:\"Bean Admin UI\";s:11:\"description\";s:47:\"Add the ability to create Block Types in the UI\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:2:{i:0;s:20:\"bean_admin_ui.module\";i:1;s:28:\"plugins/BeanCustom.class.php\";}s:12:\"dependencies\";a:1:{i:0;s:4:\"bean\";}s:9:\"configure\";s:27:\"admin/structure/block-types\";s:7:\"package\";s:4:\"Bean\";s:7:\"version\";s:7:\"7.x-1.9\";s:7:\"project\";s:4:\"bean\";s:9:\"datestamp\";s:10:\"1425439382\";s:5:\"mtime\";i:1499928385;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/bean/bean_all/bean_all.module','bean_all','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:8:\"Bean All\";s:11:\"description\";s:32:\"Integrate all blocks with beans.\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:15:\"plugins/all.inc\";}s:12:\"dependencies\";a:3:{i:0;s:4:\"bean\";i:1;s:5:\"block\";i:2;s:4:\"menu\";}s:7:\"package\";s:4:\"Bean\";s:7:\"version\";s:7:\"7.x-1.8\";s:7:\"project\";s:4:\"bean\";s:9:\"datestamp\";s:10:\"1412260740\";s:5:\"mtime\";i:1499928385;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/bean/bean_entitycache/bean_entitycache.module','bean_entitycache','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:18:\"Bean - Entitycache\";s:11:\"description\";s:54:\"Integrates the Bean module with the Entitycache module\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:27:\"Performance and scalability\";s:5:\"files\";a:1:{i:0;s:34:\"includes/bean_entitycache.core.inc\";}s:12:\"dependencies\";a:2:{i:0;s:4:\"bean\";i:1;s:11:\"entitycache\";}s:7:\"version\";s:7:\"7.x-1.9\";s:7:\"project\";s:4:\"bean\";s:9:\"datestamp\";s:10:\"1425439382\";s:5:\"mtime\";i:1499928385;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/bean/bean_usage/bean_usage.module','bean_usage','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:10:\"Bean Usage\";s:11:\"description\";s:32:\"View Bean (Block Entities) Usage\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:2:{i:0;s:4:\"bean\";i:1;s:14:\"blockreference\";}s:7:\"package\";s:4:\"Bean\";s:7:\"version\";s:7:\"7.x-1.9\";s:7:\"project\";s:4:\"bean\";s:9:\"datestamp\";s:10:\"1425439382\";s:5:\"mtime\";i:1499928385;s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/bean/bean_uuid/bean_uuid.module','bean_uuid','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:9:\"Bean UUID\";s:11:\"description\";s:60:\"Allow deploying bean blocks through Deploy and UUID modules.\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:2:{i:0;s:4:\"bean\";i:1;s:4:\"uuid\";}s:7:\"package\";s:4:\"Bean\";s:7:\"version\";s:7:\"7.x-1.9\";s:7:\"project\";s:4:\"bean\";s:9:\"datestamp\";s:10:\"1425439382\";s:5:\"mtime\";i:1499928385;s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/bean/tests/bean_test.module','bean_test','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:9:\"Bean Test\";s:11:\"description\";s:29:\"Creates test plugins for bean\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:1:{i:0;s:4:\"bean\";}s:5:\"files\";a:1:{i:0;s:16:\"bean_test.module\";}s:6:\"hidden\";b:1;s:7:\"version\";s:7:\"7.x-1.9\";s:7:\"project\";s:4:\"bean\";s:9:\"datestamp\";s:10:\"1425439382\";s:5:\"mtime\";i:1499928385;s:7:\"package\";s:5:\"Other\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/block_class/block_class.module','block_class','module','',1,0,7103,0,'a:13:{s:4:\"name\";s:11:\"Block Class\";s:11:\"description\";s:39:\"Allows assigning CSS classes to blocks.\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:1:{i:0;s:5:\"block\";}s:5:\"files\";a:1:{i:0;s:16:\"block_class.test\";}s:17:\"test_dependencies\";a:3:{i:0;s:7:\"context\";i:1;s:14:\"features (2.x)\";i:2;s:14:\"features_extra\";}s:7:\"version\";s:7:\"7.x-2.3\";s:7:\"project\";s:11:\"block_class\";s:9:\"datestamp\";s:10:\"1450415951\";s:5:\"mtime\";i:1450415951;s:7:\"package\";s:5:\"Other\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/block_class/tests/block_class_fe_block_test.module','block_class_fe_block_test','module','',0,0,-1,0,'a:14:{s:4:\"name\";s:44:\"Block Class FE Block Integration Test Helper\";s:11:\"description\";s:99:\"Helper module for testing the integration of Block Class with Features through the FE Block module.\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:8:\"Features\";s:12:\"dependencies\";a:1:{i:0;s:8:\"fe_block\";}s:8:\"features\";a:2:{s:17:\"fe_block_settings\";a:1:{i:0;s:11:\"user-online\";}s:12:\"features_api\";a:1:{i:0;s:5:\"api:2\";}}s:6:\"hidden\";b:1;s:7:\"version\";s:7:\"7.x-2.3\";s:7:\"project\";s:11:\"block_class\";s:9:\"datestamp\";s:10:\"1450415951\";s:5:\"mtime\";i:1450415951;s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/calendar/calendar.module','calendar','module','',1,0,7002,0,'a:13:{s:4:\"name\";s:8:\"Calendar\";s:11:\"description\";s:60:\"Views plugin to display views containing dates as Calendars.\";s:12:\"dependencies\";a:3:{i:0;s:5:\"views\";i:1;s:8:\"date_api\";i:2;s:10:\"date_views\";}s:7:\"package\";s:9:\"Date/Time\";s:4:\"core\";s:3:\"7.x\";s:11:\"stylesheets\";a:1:{s:3:\"all\";a:1:{s:25:\"css/calendar_multiday.css\";s:52:\"sites/all/modules/calendar/css/calendar_multiday.css\";}}s:5:\"files\";a:8:{i:0;s:16:\"calendar.install\";i:1;s:15:\"calendar.module\";i:2;s:27:\"includes/calendar.views.inc\";i:3;s:34:\"includes/calendar_plugin_style.inc\";i:4;s:32:\"includes/calendar_plugin_row.inc\";i:5;s:36:\"includes/calendar.views_template.inc\";i:6;s:15:\"theme/theme.inc\";i:7;s:28:\"theme/calendar-style.tpl.php\";}s:7:\"version\";s:7:\"7.x-3.5\";s:7:\"project\";s:8:\"calendar\";s:9:\"datestamp\";s:10:\"1413299943\";s:5:\"mtime\";i:1499928385;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/captcha/captcha.module','captcha','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:7:\"CAPTCHA\";s:11:\"description\";s:61:\"Base CAPTCHA module for adding challenges to arbitrary forms.\";s:7:\"package\";s:12:\"Spam control\";s:4:\"core\";s:3:\"7.x\";s:9:\"configure\";s:27:\"admin/config/people/captcha\";s:5:\"files\";a:5:{i:0;s:14:\"captcha.module\";i:1;s:11:\"captcha.inc\";i:2;s:17:\"captcha.admin.inc\";i:3;s:15:\"captcha.install\";i:4;s:12:\"captcha.test\";}s:7:\"version\";s:7:\"7.x-1.2\";s:7:\"project\";s:7:\"captcha\";s:9:\"datestamp\";s:10:\"1417219372\";s:5:\"mtime\";i:1499928385;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/captcha/image_captcha/image_captcha.module','image_captcha','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:13:\"Image CAPTCHA\";s:11:\"description\";s:32:\"Provides an image based CAPTCHA.\";s:7:\"package\";s:12:\"Spam control\";s:12:\"dependencies\";a:1:{i:0;s:7:\"captcha\";}s:4:\"core\";s:3:\"7.x\";s:9:\"configure\";s:41:\"admin/config/people/captcha/image_captcha\";s:5:\"files\";a:4:{i:0;s:21:\"image_captcha.install\";i:1;s:20:\"image_captcha.module\";i:2;s:23:\"image_captcha.admin.inc\";i:3;s:22:\"image_captcha.user.inc\";}s:7:\"version\";s:7:\"7.x-1.2\";s:7:\"project\";s:7:\"captcha\";s:9:\"datestamp\";s:10:\"1417219372\";s:5:\"mtime\";i:1499928385;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/chosen/chosen.module','chosen','module','',1,0,7203,0,'a:13:{s:4:\"name\";s:6:\"Chosen\";s:11:\"description\";s:104:\"Makes select elements more user-friendly using <a href=\"http://harvesthq.github.com/chosen/\">Chosen</a>.\";s:7:\"package\";s:14:\"User interface\";s:9:\"configure\";s:34:\"admin/config/user-interface/chosen\";s:4:\"core\";s:3:\"7.x\";s:7:\"version\";s:13:\"7.x-2.0-beta4\";s:7:\"project\";s:6:\"chosen\";s:9:\"datestamp\";s:10:\"1394256505\";s:5:\"mtime\";i:1499928385;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/ckeditor/ckeditor.module','ckeditor','module','',1,0,7005,0,'a:13:{s:4:\"name\";s:8:\"CKEditor\";s:11:\"description\";s:76:\"Enables CKEditor (WYSIWYG HTML editor) for use instead of plain text fields.\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:14:\"User interface\";s:9:\"configure\";s:29:\"admin/config/content/ckeditor\";s:7:\"version\";s:8:\"7.x-1.16\";s:7:\"project\";s:8:\"ckeditor\";s:9:\"datestamp\";s:10:\"1413311935\";s:5:\"mtime\";i:1499928385;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/colorbox/colorbox.module','colorbox','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:8:\"Colorbox\";s:11:\"description\";s:63:\"A light-weight, customizable lightbox plugin for jQuery 1.4.3+.\";s:12:\"dependencies\";a:1:{i:0;s:15:\"libraries (2.x)\";}s:4:\"core\";s:3:\"7.x\";s:9:\"configure\";s:27:\"admin/config/media/colorbox\";s:5:\"files\";a:1:{i:0;s:41:\"views/colorbox_handler_field_colorbox.inc\";}s:7:\"version\";s:7:\"7.x-2.8\";s:7:\"project\";s:8:\"colorbox\";s:9:\"datestamp\";s:10:\"1410514129\";s:5:\"mtime\";i:1499928385;s:7:\"package\";s:5:\"Other\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/contact_forms/contact_forms.module','contact_forms','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:13:\"Contact Forms\";s:11:\"description\";s:62:\"Creates individual contact pages from contact form categories.\";s:12:\"dependencies\";a:1:{i:0;s:7:\"contact\";}s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:13:\"Contact Forms\";s:5:\"files\";a:2:{i:0;s:20:\"contact_forms.module\";i:1;s:21:\"contact_forms.install\";}s:9:\"configure\";s:32:\"admin/structure/contact/settings\";s:7:\"version\";s:7:\"7.x-1.8\";s:7:\"project\";s:13:\"contact_forms\";s:9:\"datestamp\";s:10:\"1360197114\";s:5:\"mtime\";i:1499928385;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/contact_forms/contact_forms_int/contact_forms_int.module','contact_forms_int','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:25:\"Contact Forms Translation\";s:11:\"description\";s:56:\"Makes contact forms additions available for translation.\";s:12:\"dependencies\";a:7:{i:0;s:7:\"contact\";i:1;s:13:\"contact_forms\";i:2;s:6:\"locale\";i:3;s:4:\"i18n\";i:4;s:12:\"i18n_contact\";i:5;s:11:\"i18n_string\";i:6;s:8:\"variable\";}s:7:\"package\";s:13:\"Contact Forms\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:2:{i:0;s:25:\"contact_forms_int.install\";i:1;s:24:\"contact_forms_int.module\";}s:7:\"version\";s:7:\"7.x-1.8\";s:7:\"project\";s:13:\"contact_forms\";s:9:\"datestamp\";s:10:\"1360197114\";s:5:\"mtime\";i:1499928385;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/contact_form_blocks/contact_form_blocks.module','contact_form_blocks','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:19:\"Contact Form Blocks\";s:11:\"description\";s:62:\"Makes your site-wide contact forms available as Drupal Blocks.\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:1:{i:0;s:7:\"contact\";}s:7:\"version\";s:11:\"7.x-1.x-dev\";s:7:\"project\";s:19:\"contact_form_blocks\";s:9:\"datestamp\";s:10:\"1334362149\";s:5:\"mtime\";i:1499928385;s:7:\"package\";s:5:\"Other\";s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/context/context.module','context','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:7:\"Context\";s:12:\"dependencies\";a:1:{i:0;s:6:\"ctools\";}s:11:\"description\";s:66:\"Provide modules with a cache that lasts for a single page request.\";s:7:\"package\";s:7:\"Context\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:3:{i:0;s:18:\"tests/context.test\";i:1;s:29:\"tests/context.conditions.test\";i:2;s:28:\"tests/context.reactions.test\";}s:7:\"version\";s:7:\"7.x-3.6\";s:7:\"project\";s:7:\"context\";s:9:\"datestamp\";s:10:\"1420573188\";s:5:\"mtime\";i:1499928385;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/context/context_layouts/context_layouts.module','context_layouts','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:15:\"Context layouts\";s:11:\"description\";s:80:\"Allow theme layer to provide multiple region layouts and integrate with context.\";s:12:\"dependencies\";a:1:{i:0;s:7:\"context\";}s:7:\"package\";s:7:\"Context\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:42:\"plugins/context_layouts_reaction_block.inc\";}s:7:\"version\";s:7:\"7.x-3.6\";s:7:\"project\";s:7:\"context\";s:9:\"datestamp\";s:10:\"1420573188\";s:5:\"mtime\";i:1499928385;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/context/context_ui/context_ui.module','context_ui','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:10:\"Context UI\";s:11:\"description\";s:68:\"Provides a simple UI for settings up a site structure using Context.\";s:12:\"dependencies\";a:1:{i:0;s:7:\"context\";}s:7:\"package\";s:7:\"Context\";s:4:\"core\";s:3:\"7.x\";s:9:\"configure\";s:23:\"admin/structure/context\";s:5:\"files\";a:2:{i:0;s:14:\"context.module\";i:1;s:21:\"tests/context_ui.test\";}s:7:\"version\";s:7:\"7.x-3.6\";s:7:\"project\";s:7:\"context\";s:9:\"datestamp\";s:10:\"1420573188\";s:5:\"mtime\";i:1499928385;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/countries/countries.module','countries','module','',0,0,-1,0,'a:14:{s:4:\"name\";s:9:\"Countries\";s:11:\"description\";s:113:\"A module that provides a FAPI / Field country element and a simple wrapper module to store / update country data.\";s:7:\"package\";s:6:\"Fields\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:6:{i:0;s:50:\"views/views_handler_argument_countries_country.inc\";i:1;s:49:\"views/views_handler_field_countries_continent.inc\";i:2;s:56:\"views/views_handler_filter_countries_continents_list.inc\";i:3;s:45:\"views/views_handler_filter_countries_list.inc\";i:4;s:21:\"countries.migrate.inc\";i:5;s:20:\"tests/countries.test\";}s:9:\"configure\";s:31:\"admin/config/regional/countries\";s:12:\"dependencies\";a:1:{i:0;s:6:\"entity\";}s:10:\"recommends\";a:1:{i:0;s:12:\"countryicons\";}s:7:\"version\";s:7:\"7.x-2.3\";s:7:\"project\";s:9:\"countries\";s:9:\"datestamp\";s:10:\"1409450929\";s:5:\"mtime\";i:1499928385;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/countries/modules/countries_configuration/countries_configuration.module','countries_configuration','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:23:\"Countries configuration\";s:11:\"description\";s:71:\"A configuration utility module to assist storing country specific data.\";s:7:\"package\";s:6:\"Fields\";s:7:\"version\";s:7:\"7.x-2.3\";s:4:\"core\";s:3:\"7.x\";s:7:\"project\";s:9:\"countries\";s:9:\"datestamp\";s:10:\"1409450929\";s:5:\"mtime\";i:1499928385;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/countries/modules/countries_example/countries_example.module','countries_example','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:17:\"Countries Example\";s:11:\"description\";s:24:\"Countries example module\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:15:\"Example modules\";s:12:\"dependencies\";a:1:{i:0;s:9:\"countries\";}s:7:\"version\";s:7:\"7.x-2.3\";s:7:\"project\";s:9:\"countries\";s:9:\"datestamp\";s:10:\"1409450929\";s:5:\"mtime\";i:1499928385;s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/countries/modules/countries_i18n/countries_i18n.module','countries_i18n','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:21:\"Countries translation\";s:11:\"description\";s:25:\"Translation of countries.\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:35:\"Multilingual - Internationalization\";s:12:\"dependencies\";a:2:{i:0;s:9:\"countries\";i:1;s:11:\"i18n_string\";}s:7:\"version\";s:7:\"7.x-2.3\";s:7:\"project\";s:9:\"countries\";s:9:\"datestamp\";s:10:\"1409450929\";s:5:\"mtime\";i:1499928385;s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/ctools/bulk_export/bulk_export.module','bulk_export','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:11:\"Bulk Export\";s:11:\"description\";s:67:\"Performs bulk exporting of data objects known about by Chaos tools.\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:1:{i:0;s:6:\"ctools\";}s:7:\"package\";s:16:\"Chaos tool suite\";s:7:\"version\";s:7:\"7.x-1.9\";s:7:\"project\";s:6:\"ctools\";s:9:\"datestamp\";s:10:\"1440020680\";s:5:\"mtime\";i:1499928385;s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/ctools/ctools.module','ctools','module','',1,0,7001,0,'a:12:{s:4:\"name\";s:11:\"Chaos tools\";s:11:\"description\";s:46:\"A library of helpful tools by Merlin of Chaos.\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:16:\"Chaos tool suite\";s:7:\"version\";s:7:\"7.x-1.9\";s:5:\"files\";a:5:{i:0;s:20:\"includes/context.inc\";i:1;s:22:\"includes/css-cache.inc\";i:2;s:22:\"includes/math-expr.inc\";i:3;s:21:\"includes/stylizer.inc\";i:4;s:20:\"tests/css_cache.test\";}s:7:\"project\";s:6:\"ctools\";s:9:\"datestamp\";s:10:\"1440020680\";s:5:\"mtime\";i:1499928385;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/ctools/ctools_access_ruleset/ctools_access_ruleset.module','ctools_access_ruleset','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:15:\"Custom rulesets\";s:11:\"description\";s:81:\"Create custom, exportable, reusable access rulesets for applications like Panels.\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:16:\"Chaos tool suite\";s:7:\"version\";s:7:\"7.x-1.9\";s:12:\"dependencies\";a:1:{i:0;s:6:\"ctools\";}s:7:\"project\";s:6:\"ctools\";s:9:\"datestamp\";s:10:\"1440020680\";s:5:\"mtime\";i:1499928385;s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/ctools/ctools_ajax_sample/ctools_ajax_sample.module','ctools_ajax_sample','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:33:\"Chaos Tools (CTools) AJAX Example\";s:11:\"description\";s:41:\"Shows how to use the power of Chaos AJAX.\";s:7:\"package\";s:16:\"Chaos tool suite\";s:7:\"version\";s:7:\"7.x-1.9\";s:12:\"dependencies\";a:1:{i:0;s:6:\"ctools\";}s:4:\"core\";s:3:\"7.x\";s:7:\"project\";s:6:\"ctools\";s:9:\"datestamp\";s:10:\"1440020680\";s:5:\"mtime\";i:1499928385;s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/ctools/ctools_custom_content/ctools_custom_content.module','ctools_custom_content','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:20:\"Custom content panes\";s:11:\"description\";s:79:\"Create custom, exportable, reusable content panes for applications like Panels.\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:16:\"Chaos tool suite\";s:7:\"version\";s:7:\"7.x-1.9\";s:12:\"dependencies\";a:1:{i:0;s:6:\"ctools\";}s:7:\"project\";s:6:\"ctools\";s:9:\"datestamp\";s:10:\"1440020680\";s:5:\"mtime\";i:1499928385;s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/ctools/ctools_plugin_example/ctools_plugin_example.module','ctools_plugin_example','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:35:\"Chaos Tools (CTools) Plugin Example\";s:11:\"description\";s:75:\"Shows how an external module can provide ctools plugins (for Panels, etc.).\";s:7:\"package\";s:16:\"Chaos tool suite\";s:7:\"version\";s:7:\"7.x-1.9\";s:12:\"dependencies\";a:4:{i:0;s:6:\"ctools\";i:1;s:6:\"panels\";i:2;s:12:\"page_manager\";i:3;s:13:\"advanced_help\";}s:4:\"core\";s:3:\"7.x\";s:7:\"project\";s:6:\"ctools\";s:9:\"datestamp\";s:10:\"1440020680\";s:5:\"mtime\";i:1499928385;s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/ctools/page_manager/page_manager.module','page_manager','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:12:\"Page manager\";s:11:\"description\";s:54:\"Provides a UI and API to manage pages within the site.\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:1:{i:0;s:6:\"ctools\";}s:7:\"package\";s:16:\"Chaos tool suite\";s:7:\"version\";s:7:\"7.x-1.9\";s:7:\"project\";s:6:\"ctools\";s:9:\"datestamp\";s:10:\"1440020680\";s:5:\"mtime\";i:1499928385;s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/ctools/stylizer/stylizer.module','stylizer','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:8:\"Stylizer\";s:11:\"description\";s:53:\"Create custom styles for applications such as Panels.\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:16:\"Chaos tool suite\";s:7:\"version\";s:7:\"7.x-1.9\";s:12:\"dependencies\";a:2:{i:0;s:6:\"ctools\";i:1;s:5:\"color\";}s:7:\"project\";s:6:\"ctools\";s:9:\"datestamp\";s:10:\"1440020680\";s:5:\"mtime\";i:1499928385;s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/ctools/term_depth/term_depth.module','term_depth','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:17:\"Term Depth access\";s:11:\"description\";s:48:\"Controls access to context based upon term depth\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:1:{i:0;s:6:\"ctools\";}s:7:\"package\";s:16:\"Chaos tool suite\";s:7:\"version\";s:7:\"7.x-1.9\";s:7:\"project\";s:6:\"ctools\";s:9:\"datestamp\";s:10:\"1440020680\";s:5:\"mtime\";i:1499928385;s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/ctools/tests/ctools_export_test/ctools_export_test.module','ctools_export_test','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:18:\"CTools export test\";s:11:\"description\";s:25:\"CTools export test module\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:16:\"Chaos tool suite\";s:7:\"version\";s:7:\"7.x-1.9\";s:12:\"dependencies\";a:1:{i:0;s:6:\"ctools\";}s:6:\"hidden\";b:1;s:5:\"files\";a:1:{i:0;s:18:\"ctools_export.test\";}s:7:\"project\";s:6:\"ctools\";s:9:\"datestamp\";s:10:\"1440020680\";s:5:\"mtime\";i:1499928385;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/ctools/tests/ctools_plugin_test.module','ctools_plugin_test','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:24:\"Chaos tools plugins test\";s:11:\"description\";s:42:\"Provides hooks for testing ctools plugins.\";s:7:\"package\";s:16:\"Chaos tool suite\";s:7:\"version\";s:7:\"7.x-1.9\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:1:{i:0;s:6:\"ctools\";}s:5:\"files\";a:6:{i:0;s:19:\"ctools.plugins.test\";i:1;s:17:\"object_cache.test\";i:2;s:8:\"css.test\";i:3;s:12:\"context.test\";i:4;s:20:\"math_expression.test\";i:5;s:26:\"math_expression_stack.test\";}s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"ctools\";s:9:\"datestamp\";s:10:\"1440020680\";s:5:\"mtime\";i:1499928385;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/ctools/views_content/views_content.module','views_content','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:19:\"Views content panes\";s:11:\"description\";s:104:\"Allows Views content to be used in Panels, Dashboard and other modules which use the CTools Content API.\";s:7:\"package\";s:16:\"Chaos tool suite\";s:12:\"dependencies\";a:2:{i:0;s:6:\"ctools\";i:1;s:5:\"views\";}s:4:\"core\";s:3:\"7.x\";s:7:\"version\";s:7:\"7.x-1.9\";s:5:\"files\";a:3:{i:0;s:61:\"plugins/views/views_content_plugin_display_ctools_context.inc\";i:1;s:57:\"plugins/views/views_content_plugin_display_panel_pane.inc\";i:2;s:59:\"plugins/views/views_content_plugin_style_ctools_context.inc\";}s:7:\"project\";s:6:\"ctools\";s:9:\"datestamp\";s:10:\"1440020680\";s:5:\"mtime\";i:1499928385;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/date/date.module','date','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:4:\"Date\";s:11:\"description\";s:33:\"Makes date/time fields available.\";s:12:\"dependencies\";a:1:{i:0;s:8:\"date_api\";}s:7:\"package\";s:9:\"Date/Time\";s:4:\"core\";s:3:\"7.x\";s:3:\"php\";s:3:\"5.2\";s:5:\"files\";a:7:{i:0;s:16:\"date.migrate.inc\";i:1;s:19:\"tests/date_api.test\";i:2;s:15:\"tests/date.test\";i:3;s:21:\"tests/date_field.test\";i:4;s:23:\"tests/date_migrate.test\";i:5;s:26:\"tests/date_validation.test\";i:6;s:24:\"tests/date_timezone.test\";}s:7:\"version\";s:7:\"7.x-2.8\";s:7:\"project\";s:4:\"date\";s:9:\"datestamp\";s:10:\"1406653438\";s:5:\"mtime\";i:1499928385;s:9:\"bootstrap\";i:0;}'),('sites/all/modules/date/date_all_day/date_all_day.module','date_all_day','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:12:\"Date All Day\";s:11:\"description\";s:142:\"Adds \'All Day\' functionality to date fields, including an \'All Day\' theme and \'All Day\' checkboxes for the Date select and Date popup widgets.\";s:12:\"dependencies\";a:2:{i:0;s:8:\"date_api\";i:1;s:4:\"date\";}s:7:\"package\";s:9:\"Date/Time\";s:4:\"core\";s:3:\"7.x\";s:7:\"version\";s:7:\"7.x-2.8\";s:7:\"project\";s:4:\"date\";s:9:\"datestamp\";s:10:\"1406653438\";s:5:\"mtime\";i:1499928385;s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/date/date_api/date_api.module','date_api','module','',1,0,7001,0,'a:13:{s:4:\"name\";s:8:\"Date API\";s:11:\"description\";s:45:\"A Date API that can be used by other modules.\";s:7:\"package\";s:9:\"Date/Time\";s:4:\"core\";s:3:\"7.x\";s:3:\"php\";s:3:\"5.2\";s:11:\"stylesheets\";a:1:{s:3:\"all\";a:1:{s:8:\"date.css\";s:40:\"sites/all/modules/date/date_api/date.css\";}}s:5:\"files\";a:2:{i:0;s:15:\"date_api.module\";i:1;s:16:\"date_api_sql.inc\";}s:7:\"version\";s:7:\"7.x-2.8\";s:7:\"project\";s:4:\"date\";s:9:\"datestamp\";s:10:\"1406653438\";s:5:\"mtime\";i:1499928385;s:12:\"dependencies\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/date/date_context/date_context.module','date_context','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:12:\"Date Context\";s:11:\"description\";s:99:\"Adds an option to the Context module to set a context condition based on the value of a date field.\";s:7:\"package\";s:9:\"Date/Time\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:2:{i:0;s:4:\"date\";i:1;s:7:\"context\";}s:5:\"files\";a:2:{i:0;s:19:\"date_context.module\";i:1;s:39:\"plugins/date_context_date_condition.inc\";}s:7:\"version\";s:7:\"7.x-2.8\";s:7:\"project\";s:4:\"date\";s:9:\"datestamp\";s:10:\"1406653438\";s:5:\"mtime\";i:1499928385;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/date/date_migrate/date_migrate.module','date_migrate','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:14:\"Date Migration\";s:11:\"description\";s:73:\"Obsolete data migration module. Disable if no other modules depend on it.\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:9:\"Date/Time\";s:6:\"hidden\";b:1;s:7:\"version\";s:7:\"7.x-2.8\";s:7:\"project\";s:4:\"date\";s:9:\"datestamp\";s:10:\"1406653438\";s:5:\"mtime\";i:1499928385;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/date/date_migrate/date_migrate_example/date_migrate_example.module','date_migrate_example','module','',0,0,-1,0,'a:13:{s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:5:{i:0;s:4:\"date\";i:1;s:11:\"date_repeat\";i:2;s:17:\"date_repeat_field\";i:3;s:8:\"features\";i:4;s:7:\"migrate\";}s:11:\"description\";s:42:\"Examples of migrating with the Date module\";s:8:\"features\";a:2:{s:5:\"field\";a:8:{i:0;s:30:\"node-date_migrate_example-body\";i:1;s:36:\"node-date_migrate_example-field_date\";i:2;s:42:\"node-date_migrate_example-field_date_range\";i:3;s:43:\"node-date_migrate_example-field_date_repeat\";i:4;s:41:\"node-date_migrate_example-field_datestamp\";i:5;s:47:\"node-date_migrate_example-field_datestamp_range\";i:6;s:40:\"node-date_migrate_example-field_datetime\";i:7;s:46:\"node-date_migrate_example-field_datetime_range\";}s:4:\"node\";a:1:{i:0;s:20:\"date_migrate_example\";}}s:5:\"files\";a:1:{i:0;s:32:\"date_migrate_example.migrate.inc\";}s:4:\"name\";s:22:\"Date Migration Example\";s:7:\"package\";s:8:\"Features\";s:7:\"project\";s:4:\"date\";s:7:\"version\";s:7:\"7.x-2.8\";s:9:\"datestamp\";s:10:\"1406653438\";s:5:\"mtime\";i:1499928385;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/date/date_popup/date_popup.module','date_popup','module','',0,0,-1,0,'a:14:{s:4:\"name\";s:10:\"Date Popup\";s:11:\"description\";s:84:\"Enables jquery popup calendars and time entry widgets for selecting dates and times.\";s:12:\"dependencies\";a:1:{i:0;s:8:\"date_api\";}s:7:\"package\";s:9:\"Date/Time\";s:4:\"core\";s:3:\"7.x\";s:9:\"configure\";s:28:\"admin/config/date/date_popup\";s:11:\"stylesheets\";a:1:{s:3:\"all\";a:1:{s:25:\"themes/datepicker.1.7.css\";s:59:\"sites/all/modules/date/date_popup/themes/datepicker.1.7.css\";}}s:7:\"version\";s:7:\"7.x-2.8\";s:7:\"project\";s:4:\"date\";s:9:\"datestamp\";s:10:\"1406653438\";s:5:\"mtime\";i:1499928385;s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/date/date_repeat/date_repeat.module','date_repeat','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:15:\"Date Repeat API\";s:11:\"description\";s:73:\"A Date Repeat API to calculate repeating dates and times from iCal rules.\";s:12:\"dependencies\";a:1:{i:0;s:8:\"date_api\";}s:7:\"package\";s:9:\"Date/Time\";s:4:\"core\";s:3:\"7.x\";s:3:\"php\";s:3:\"5.2\";s:5:\"files\";a:2:{i:0;s:22:\"tests/date_repeat.test\";i:1;s:27:\"tests/date_repeat_form.test\";}s:7:\"version\";s:7:\"7.x-2.8\";s:7:\"project\";s:4:\"date\";s:9:\"datestamp\";s:10:\"1406653438\";s:5:\"mtime\";i:1499928385;s:9:\"bootstrap\";i:0;}'),('sites/all/modules/date/date_repeat_field/date_repeat_field.module','date_repeat_field','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:17:\"Date Repeat Field\";s:11:\"description\";s:97:\"Creates the option of Repeating date fields and manages Date fields that use the Date Repeat API.\";s:12:\"dependencies\";a:3:{i:0;s:8:\"date_api\";i:1;s:4:\"date\";i:2;s:11:\"date_repeat\";}s:11:\"stylesheets\";a:1:{s:3:\"all\";a:1:{s:21:\"date_repeat_field.css\";s:62:\"sites/all/modules/date/date_repeat_field/date_repeat_field.css\";}}s:7:\"package\";s:9:\"Date/Time\";s:4:\"core\";s:3:\"7.x\";s:7:\"version\";s:7:\"7.x-2.8\";s:7:\"project\";s:4:\"date\";s:9:\"datestamp\";s:10:\"1406653438\";s:5:\"mtime\";i:1499928385;s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/date/date_tools/date_tools.module','date_tools','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:10:\"Date Tools\";s:11:\"description\";s:52:\"Tools to import and auto-create dates and calendars.\";s:12:\"dependencies\";a:1:{i:0;s:4:\"date\";}s:7:\"package\";s:9:\"Date/Time\";s:4:\"core\";s:3:\"7.x\";s:9:\"configure\";s:23:\"admin/config/date/tools\";s:5:\"files\";a:1:{i:0;s:21:\"tests/date_tools.test\";}s:7:\"version\";s:7:\"7.x-2.8\";s:7:\"project\";s:4:\"date\";s:9:\"datestamp\";s:10:\"1406653438\";s:5:\"mtime\";i:1499928385;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/date/date_views/date_views.module','date_views','module','',1,0,0,0,'a:12:{s:4:\"name\";s:10:\"Date Views\";s:11:\"description\";s:57:\"Views integration for date fields and date functionality.\";s:7:\"package\";s:9:\"Date/Time\";s:12:\"dependencies\";a:2:{i:0;s:8:\"date_api\";i:1;s:5:\"views\";}s:4:\"core\";s:3:\"7.x\";s:3:\"php\";s:3:\"5.2\";s:5:\"files\";a:6:{i:0;s:40:\"includes/date_views_argument_handler.inc\";i:1;s:47:\"includes/date_views_argument_handler_simple.inc\";i:2;s:38:\"includes/date_views_filter_handler.inc\";i:3;s:45:\"includes/date_views_filter_handler_simple.inc\";i:4;s:29:\"includes/date_views.views.inc\";i:5;s:36:\"includes/date_views_plugin_pager.inc\";}s:7:\"version\";s:7:\"7.x-2.8\";s:7:\"project\";s:4:\"date\";s:9:\"datestamp\";s:10:\"1406653438\";s:5:\"mtime\";i:1499928385;s:9:\"bootstrap\";i:0;}'),('sites/all/modules/entity/entity.module','entity','module','',1,0,7003,0,'a:12:{s:4:\"name\";s:10:\"Entity API\";s:11:\"description\";s:69:\"Enables modules to work with any entity type and to provide entities.\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:24:{i:0;s:19:\"entity.features.inc\";i:1;s:15:\"entity.i18n.inc\";i:2;s:15:\"entity.info.inc\";i:3;s:16:\"entity.rules.inc\";i:4;s:11:\"entity.test\";i:5;s:19:\"includes/entity.inc\";i:6;s:30:\"includes/entity.controller.inc\";i:7;s:22:\"includes/entity.ui.inc\";i:8;s:27:\"includes/entity.wrapper.inc\";i:9;s:22:\"views/entity.views.inc\";i:10;s:52:\"views/handlers/entity_views_field_handler_helper.inc\";i:11;s:51:\"views/handlers/entity_views_handler_area_entity.inc\";i:12;s:53:\"views/handlers/entity_views_handler_field_boolean.inc\";i:13;s:50:\"views/handlers/entity_views_handler_field_date.inc\";i:14;s:54:\"views/handlers/entity_views_handler_field_duration.inc\";i:15;s:52:\"views/handlers/entity_views_handler_field_entity.inc\";i:16;s:51:\"views/handlers/entity_views_handler_field_field.inc\";i:17;s:53:\"views/handlers/entity_views_handler_field_numeric.inc\";i:18;s:53:\"views/handlers/entity_views_handler_field_options.inc\";i:19;s:50:\"views/handlers/entity_views_handler_field_text.inc\";i:20;s:49:\"views/handlers/entity_views_handler_field_uri.inc\";i:21;s:62:\"views/handlers/entity_views_handler_relationship_by_bundle.inc\";i:22;s:52:\"views/handlers/entity_views_handler_relationship.inc\";i:23;s:53:\"views/plugins/entity_views_plugin_row_entity_view.inc\";}s:7:\"version\";s:7:\"7.x-1.6\";s:7:\"project\";s:6:\"entity\";s:9:\"datestamp\";s:10:\"1424876582\";s:5:\"mtime\";i:1499928385;s:12:\"dependencies\";a:0:{}s:7:\"package\";s:5:\"Other\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/entity/entity_token.module','entity_token','module','',1,0,0,0,'a:12:{s:4:\"name\";s:13:\"Entity tokens\";s:11:\"description\";s:99:\"Provides token replacements for all properties that have no tokens and are known to the entity API.\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:2:{i:0;s:23:\"entity_token.tokens.inc\";i:1;s:19:\"entity_token.module\";}s:12:\"dependencies\";a:1:{i:0;s:6:\"entity\";}s:7:\"version\";s:7:\"7.x-1.6\";s:7:\"project\";s:6:\"entity\";s:9:\"datestamp\";s:10:\"1424876582\";s:5:\"mtime\";i:1499928385;s:7:\"package\";s:5:\"Other\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/entity/tests/entity_feature.module','entity_feature','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:21:\"Entity feature module\";s:11:\"description\";s:31:\"Provides some entities in code.\";s:7:\"version\";s:7:\"7.x-1.6\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:21:\"entity_feature.module\";}s:12:\"dependencies\";a:1:{i:0;s:11:\"entity_test\";}s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"entity\";s:9:\"datestamp\";s:10:\"1424876582\";s:5:\"mtime\";i:1499928385;s:7:\"package\";s:5:\"Other\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/entity/tests/entity_test.module','entity_test','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:23:\"Entity CRUD test module\";s:11:\"description\";s:46:\"Provides entity types based upon the CRUD API.\";s:7:\"version\";s:7:\"7.x-1.6\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:2:{i:0;s:18:\"entity_test.module\";i:1;s:19:\"entity_test.install\";}s:12:\"dependencies\";a:1:{i:0;s:6:\"entity\";}s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"entity\";s:9:\"datestamp\";s:10:\"1424876582\";s:5:\"mtime\";i:1499928385;s:7:\"package\";s:5:\"Other\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/entity/tests/entity_test_i18n.module','entity_test_i18n','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:28:\"Entity-test type translation\";s:11:\"description\";s:37:\"Allows translating entity-test types.\";s:12:\"dependencies\";a:2:{i:0;s:11:\"entity_test\";i:1;s:11:\"i18n_string\";}s:7:\"package\";s:35:\"Multilingual - Internationalization\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"version\";s:7:\"7.x-1.6\";s:7:\"project\";s:6:\"entity\";s:9:\"datestamp\";s:10:\"1424876582\";s:5:\"mtime\";i:1499928385;s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/entityreference/entityreference.module','entityreference','module','',1,0,7002,0,'a:14:{s:4:\"name\";s:16:\"Entity Reference\";s:11:\"description\";s:51:\"Provides a field that can reference other entities.\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:6:\"Fields\";s:12:\"dependencies\";a:2:{i:0;s:6:\"entity\";i:1;s:6:\"ctools\";}s:5:\"files\";a:11:{i:0;s:27:\"entityreference.migrate.inc\";i:1;s:30:\"plugins/selection/abstract.inc\";i:2;s:27:\"plugins/selection/views.inc\";i:3;s:29:\"plugins/behavior/abstract.inc\";i:4;s:40:\"views/entityreference_plugin_display.inc\";i:5;s:38:\"views/entityreference_plugin_style.inc\";i:6;s:43:\"views/entityreference_plugin_row_fields.inc\";i:7;s:35:\"tests/entityreference.handlers.test\";i:8;s:35:\"tests/entityreference.taxonomy.test\";i:9;s:32:\"tests/entityreference.admin.test\";i:10;s:32:\"tests/entityreference.feeds.test\";}s:7:\"version\";s:7:\"7.x-1.1\";s:7:\"project\";s:15:\"entityreference\";s:9:\"datestamp\";s:10:\"1384973110\";s:5:\"mtime\";i:1499928385;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;s:8:\"required\";b:1;s:11:\"explanation\";s:76:\"Field type(s) in use - see <a href=\"/en/admin/reports/fields\">Field list</a>\";}'),('sites/all/modules/entityreference/examples/entityreference_behavior_example/entityreference_behavior_example.module','entityreference_behavior_example','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:33:\"Entity Reference Behavior Example\";s:11:\"description\";s:71:\"Provides some example code for implementing Entity Reference behaviors.\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:6:\"Fields\";s:12:\"dependencies\";a:1:{i:0;s:15:\"entityreference\";}s:7:\"version\";s:7:\"7.x-1.1\";s:7:\"project\";s:15:\"entityreference\";s:9:\"datestamp\";s:10:\"1384973110\";s:5:\"mtime\";i:1499928385;s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/entityreference/tests/modules/entityreference_feeds_test/entityreference_feeds_test.module','entityreference_feeds_test','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:41:\"Entityreference - Feeds integration tests\";s:11:\"description\";s:65:\"Support module for the Entityreference - Feeds integration tests.\";s:7:\"package\";s:7:\"Testing\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:12:\"dependencies\";a:3:{i:0;s:5:\"feeds\";i:1;s:8:\"feeds_ui\";i:2;s:15:\"entityreference\";}s:7:\"version\";s:7:\"7.x-1.1\";s:7:\"project\";s:15:\"entityreference\";s:9:\"datestamp\";s:10:\"1384973110\";s:5:\"mtime\";i:1499928385;s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/eva/eva.module','eva','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:3:\"Eva\";s:11:\"description\";s:63:\"Provides a Views display type that can be attached to entities.\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:1:{i:0;s:5:\"views\";}s:7:\"package\";s:5:\"Views\";s:5:\"files\";a:1:{i:0;s:29:\"eva_plugin_display_entity.inc\";}s:7:\"version\";s:7:\"7.x-1.2\";s:7:\"project\";s:3:\"eva\";s:9:\"datestamp\";s:10:\"1343701935\";s:5:\"mtime\";i:1499928385;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/faq/faq.module','faq','module','',1,0,7002,0,'a:13:{s:4:\"name\";s:26:\"Frequently Asked Questions\";s:11:\"description\";s:50:\"Manages configuration of questions for a FAQ page.\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:18:{i:0;s:13:\"faq.admin.inc\";i:1;s:11:\"faq.install\";i:2;s:10:\"faq.module\";i:3;s:8:\"faq.test\";i:4;s:41:\"includes/faq-category-hide-answer.tpl.php\";i:5;s:38:\"includes/faq-category-new-page.tpl.php\";i:6;s:46:\"includes/faq-category-questions-inline.tpl.php\";i:7;s:51:\"includes/faq-category-questions-top-answers.tpl.php\";i:8;s:43:\"includes/faq-category-questions-top.tpl.php\";i:9;s:32:\"includes/faq-hide-answer.tpl.php\";i:10;s:29:\"includes/faq-new-page.tpl.php\";i:11;s:37:\"includes/faq-questions-inline.tpl.php\";i:12;s:34:\"includes/faq-questions-top.tpl.php\";i:13;s:28:\"includes/faq.hide_answer.inc\";i:14;s:25:\"includes/faq.new_page.inc\";i:15;s:33:\"includes/faq.questions_inline.inc\";i:16;s:30:\"includes/faq.questions_top.inc\";i:17;s:19:\"views/faq.views.inc\";}s:9:\"configure\";s:24:\"admin/config/content/faq\";s:7:\"version\";s:11:\"7.x-1.0-rc3\";s:7:\"project\";s:3:\"faq\";s:9:\"datestamp\";s:10:\"1415528891\";s:5:\"mtime\";i:1499928385;s:12:\"dependencies\";a:0:{}s:7:\"package\";s:5:\"Other\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/features/features.module','features','module','',1,0,7200,20,'a:14:{s:4:\"name\";s:8:\"Features\";s:11:\"description\";s:39:\"Provides feature management for Drupal.\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:8:\"Features\";s:5:\"files\";a:1:{i:0;s:19:\"tests/features.test\";}s:17:\"test_dependencies\";a:4:{i:0;s:5:\"image\";i:1;s:9:\"strongarm\";i:2;s:8:\"taxonomy\";i:3;s:5:\"views\";}s:9:\"configure\";s:33:\"admin/structure/features/settings\";s:7:\"version\";s:8:\"7.x-2.10\";s:7:\"project\";s:8:\"features\";s:9:\"datestamp\";s:10:\"1461011641\";s:5:\"mtime\";i:1461011641;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/features/tests/features_test/features_test.module','features_test','module','',0,0,-1,0,'a:14:{s:4:\"name\";s:14:\"Features Tests\";s:11:\"description\";s:33:\"Test module for Features testing.\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:7:\"Testing\";s:3:\"php\";s:5:\"5.2.0\";s:12:\"dependencies\";a:5:{i:0;s:8:\"features\";i:1;s:5:\"image\";i:2;s:9:\"strongarm\";i:3;s:8:\"taxonomy\";i:4;s:5:\"views\";}s:8:\"features\";a:10:{s:6:\"ctools\";a:2:{i:0;s:21:\"strongarm:strongarm:1\";i:1;s:23:\"views:views_default:3.0\";}s:12:\"features_api\";a:1:{i:0;s:5:\"api:2\";}s:10:\"field_base\";a:1:{i:0;s:19:\"field_features_test\";}s:14:\"field_instance\";a:1:{i:0;s:38:\"node-features_test-field_features_test\";}s:6:\"filter\";a:1:{i:0;s:13:\"features_test\";}s:5:\"image\";a:1:{i:0;s:13:\"features_test\";}s:4:\"node\";a:1:{i:0;s:13:\"features_test\";}s:8:\"taxonomy\";a:1:{i:0;s:22:\"taxonomy_features_test\";}s:15:\"user_permission\";a:1:{i:0;s:28:\"create features_test content\";}s:10:\"views_view\";a:1:{i:0;s:13:\"features_test\";}}s:6:\"hidden\";s:1:\"1\";s:7:\"version\";s:8:\"7.x-2.10\";s:7:\"project\";s:8:\"features\";s:9:\"datestamp\";s:10:\"1461011641\";s:5:\"mtime\";i:1461011641;s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/field_collection/field_collection.module','field_collection','module','',1,0,7006,0,'a:15:{s:4:\"name\";s:16:\"Field collection\";s:11:\"description\";s:81:\"Provides a field collection field, to which any number of fields can be attached.\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:1:{i:0;s:6:\"entity\";}s:5:\"files\";a:4:{i:0;s:21:\"field_collection.test\";i:1;s:25:\"field_collection.info.inc\";i:2;s:47:\"views/field_collection_handler_relationship.inc\";i:3;s:28:\"field_collection.migrate.inc\";}s:9:\"configure\";s:33:\"admin/structure/field-collections\";s:7:\"package\";s:6:\"Fields\";s:7:\"version\";s:13:\"7.x-1.0-beta8\";s:7:\"project\";s:16:\"field_collection\";s:9:\"datestamp\";s:10:\"1415122384\";s:5:\"mtime\";i:1499928385;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;s:8:\"required\";b:1;s:11:\"explanation\";s:76:\"Field type(s) in use - see <a href=\"/en/admin/reports/fields\">Field list</a>\";}'),('sites/all/modules/field_group/field_group.module','field_group','module','',1,0,7008,1,'a:12:{s:4:\"name\";s:11:\"Field Group\";s:11:\"description\";s:67:\"Provides the ability to group your fields on both form and display.\";s:7:\"package\";s:6:\"Fields\";s:12:\"dependencies\";a:2:{i:0;s:5:\"field\";i:1;s:6:\"ctools\";}s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:2:{i:0;s:25:\"tests/field_group.ui.test\";i:1;s:30:\"tests/field_group.display.test\";}s:7:\"version\";s:7:\"7.x-1.5\";s:7:\"project\";s:11:\"field_group\";s:9:\"datestamp\";s:10:\"1452033709\";s:5:\"mtime\";i:1452033709;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/field_group/tests/field_group_test.module','field_group_test','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:16:\"Field Group Test\";s:11:\"description\";s:27:\"Test module for Field Group\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:6:\"Fields\";s:6:\"hidden\";b:1;s:7:\"version\";s:7:\"7.x-1.5\";s:7:\"project\";s:11:\"field_group\";s:9:\"datestamp\";s:10:\"1452033709\";s:5:\"mtime\";i:1452033709;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/fivestar/fivestar.module','fivestar','module','',1,0,7208,0,'a:15:{s:4:\"name\";s:8:\"Fivestar\";s:11:\"description\";s:48:\"Enables fivestar ratings on content, users, etc.\";s:7:\"package\";s:6:\"Voting\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:1:{i:0;s:9:\"votingapi\";}s:9:\"configure\";s:29:\"admin/config/content/fivestar\";s:5:\"files\";a:2:{i:0;s:23:\"test/fivestar.base.test\";i:1;s:24:\"test/fivestar.field.test\";}s:7:\"version\";s:7:\"7.x-2.1\";s:7:\"project\";s:8:\"fivestar\";s:9:\"datestamp\";s:10:\"1395087839\";s:5:\"mtime\";i:1499928385;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;s:8:\"required\";b:1;s:11:\"explanation\";s:76:\"Field type(s) in use - see <a href=\"/en/admin/reports/fields\">Field list</a>\";}'),('sites/all/modules/flexslider/flexslider.module','flexslider','module','',1,0,7201,0,'a:13:{s:4:\"name\";s:10:\"FlexSlider\";s:11:\"description\";s:46:\"Integrate the FlexSlider 2 library with Drupal\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:10:\"FlexSlider\";s:12:\"dependencies\";a:3:{i:0;s:17:\"libraries (>=2.x)\";i:1;s:6:\"ctools\";i:2;s:5:\"image\";}s:5:\"files\";a:2:{i:0;s:26:\"theme/flexslider.theme.inc\";i:1;s:15:\"flexslider.test\";}s:9:\"configure\";s:29:\"admin/config/media/flexslider\";s:7:\"version\";s:14:\"7.x-2.0-alpha3\";s:7:\"project\";s:10:\"flexslider\";s:9:\"datestamp\";s:10:\"1378663043\";s:5:\"mtime\";i:1499928385;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/flexslider/flexslider_example/flexslider_example.module','flexslider_example','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:18:\"FlexSlider Example\";s:11:\"description\";s:35:\"Sample implementation of FlexSlider\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:10:\"FlexSlider\";s:3:\"php\";s:5:\"5.2.4\";s:12:\"dependencies\";a:9:{i:0;s:7:\"context\";i:1;s:8:\"features\";i:2;s:10:\"flexslider\";i:3;s:17:\"flexslider_fields\";i:4;s:16:\"flexslider_views\";i:5;s:5:\"image\";i:6;s:4:\"menu\";i:7;s:9:\"strongarm\";i:8;s:5:\"views\";}s:8:\"features\";a:9:{s:7:\"context\";a:1:{i:0;s:28:\"flexslider_example_thumbnail\";}s:6:\"ctools\";a:4:{i:0;s:17:\"context:context:3\";i:1;s:38:\"flexslider:flexslider_default_preset:1\";i:2;s:21:\"strongarm:strongarm:1\";i:3;s:23:\"views:views_default:3.0\";}s:12:\"features_api\";a:1:{i:0;s:5:\"api:1\";}s:5:\"field\";a:2:{i:0;s:54:\"node-flexslider_example-field_flexslider_example_image\";i:1;s:56:\"node-flexslider_example-field_flexslider_example_slidesh\";}s:20:\"flexslider_optionset\";a:6:{i:0;s:43:\"flexslider_carousel_with_min_and_max_ranges\";i:1;s:33:\"flexslider_default_basic_carousel\";i:2;s:46:\"flexslider_default_slider_thumbnail_controlnav\";i:3;s:44:\"flexslider_default_slider_w_thumbnail_slider\";i:4;s:37:\"flexslider_default_thumbnail_captions\";i:5;s:35:\"flexslider_default_thumbnail_slider\";}s:11:\"menu_custom\";a:1:{i:0;s:23:\"menu-flexslider-example\";}s:4:\"node\";a:1:{i:0;s:18:\"flexslider_example\";}s:8:\"variable\";a:1:{i:0;s:46:\"field_bundle_settings_node__flexslider_example\";}s:10:\"views_view\";a:1:{i:0;s:24:\"flexslider_views_example\";}}s:7:\"version\";s:14:\"7.x-2.0-alpha3\";s:7:\"project\";s:10:\"flexslider\";s:9:\"datestamp\";s:10:\"1378663043\";s:5:\"mtime\";i:1499928385;s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/flexslider/flexslider_fields/flexslider_fields.module','flexslider_fields','module','',1,0,0,0,'a:12:{s:4:\"name\";s:17:\"FlexSlider Fields\";s:11:\"description\";s:44:\"Adds a display mode in Fields for FlexSlider\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:10:\"FlexSlider\";s:12:\"dependencies\";a:1:{i:0;s:10:\"flexslider\";}s:7:\"version\";s:14:\"7.x-2.0-alpha3\";s:7:\"project\";s:10:\"flexslider\";s:9:\"datestamp\";s:10:\"1378663043\";s:5:\"mtime\";i:1499928385;s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/flexslider/flexslider_views/flexslider_views.module','flexslider_views','module','',1,0,0,0,'a:12:{s:4:\"name\";s:22:\"FlexSlider Views Style\";s:11:\"description\";s:40:\"Adds a Views style plugin for FlexSlider\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:10:\"FlexSlider\";s:12:\"dependencies\";a:2:{i:0;s:5:\"views\";i:1;s:10:\"flexslider\";}s:5:\"files\";a:3:{i:0;s:23:\"flexslider_views.module\";i:1;s:26:\"flexslider_views.views.inc\";i:2;s:44:\"flexslider_views_plugin_style_flexslider.inc\";}s:7:\"version\";s:14:\"7.x-2.0-alpha3\";s:7:\"project\";s:10:\"flexslider\";s:9:\"datestamp\";s:10:\"1378663043\";s:5:\"mtime\";i:1499928385;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/galleryformatter/galleryformatter.module','galleryformatter','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:17:\"Gallery Formatter\";s:11:\"description\";s:54:\"Provides a jquery gallery CCK formatter for imagefield\";s:12:\"dependencies\";a:2:{i:0;s:5:\"image\";i:1;s:4:\"file\";}s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:14:\"User interface\";s:5:\"files\";a:5:{i:0;s:24:\"galleryformatter.install\";i:1;s:23:\"galleryformatter.module\";i:2;s:35:\"includes/galleryformatter.theme.inc\";i:3;s:40:\"includes/galleryformatter_imagecache.inc\";i:4;s:30:\"theme/galleryformatter.tpl.php\";}s:7:\"version\";s:7:\"7.x-1.3\";s:7:\"project\";s:16:\"galleryformatter\";s:9:\"datestamp\";s:10:\"1355821655\";s:5:\"mtime\";i:1499928385;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/google_analytics/googleanalytics.module','googleanalytics','module','',0,0,-1,0,'a:14:{s:4:\"name\";s:16:\"Google Analytics\";s:11:\"description\";s:102:\"Allows your site to be tracked by Google Analytics by adding a Javascript tracking code to every page.\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:10:\"Statistics\";s:9:\"configure\";s:35:\"admin/config/system/googleanalytics\";s:5:\"files\";a:1:{i:0;s:20:\"googleanalytics.test\";}s:17:\"test_dependencies\";a:1:{i:0;s:5:\"token\";}s:7:\"version\";s:7:\"7.x-2.1\";s:7:\"project\";s:16:\"google_analytics\";s:9:\"datestamp\";s:10:\"1417276982\";s:5:\"mtime\";i:1499928385;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/gravatar/gravatar.module','gravatar','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:8:\"Gravatar\";s:11:\"description\";s:70:\"Integrate Gravatar pictures registered at Gravatar.com in Drupal sites\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:3:{i:0;s:15:\"gravatar.module\";i:1;s:16:\"gravatar.install\";i:2;s:18:\"gravatar.admin.inc\";}s:9:\"configure\";s:28:\"admin/config/people/gravatar\";s:7:\"version\";s:7:\"7.x-1.1\";s:7:\"project\";s:8:\"gravatar\";s:9:\"datestamp\";s:10:\"1297971182\";s:5:\"mtime\";i:1499928385;s:12:\"dependencies\";a:0:{}s:7:\"package\";s:5:\"Other\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/i18n/i18n.module','i18n','module','',1,1,7001,10,'a:13:{s:4:\"name\";s:20:\"Internationalization\";s:11:\"description\";s:49:\"Extends Drupal support for multilingual features.\";s:12:\"dependencies\";a:2:{i:0;s:6:\"locale\";i:1;s:8:\"variable\";}s:7:\"package\";s:35:\"Multilingual - Internationalization\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:2:{i:0;s:15:\"i18n_object.inc\";i:1;s:9:\"i18n.test\";}s:9:\"configure\";s:26:\"admin/config/regional/i18n\";s:7:\"version\";s:8:\"7.x-1.13\";s:7:\"project\";s:4:\"i18n\";s:9:\"datestamp\";s:10:\"1430999922\";s:5:\"mtime\";i:1499928385;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/i18n/i18n_block/i18n_block.module','i18n_block','module','',1,0,7001,100,'a:12:{s:4:\"name\";s:15:\"Block languages\";s:11:\"description\";s:68:\"Enables language selector for blocks and optional block translation.\";s:12:\"dependencies\";a:2:{i:0;s:5:\"block\";i:1;s:11:\"i18n_string\";}s:7:\"package\";s:35:\"Multilingual - Internationalization\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:2:{i:0;s:14:\"i18n_block.inc\";i:1;s:15:\"i18n_block.test\";}s:7:\"version\";s:8:\"7.x-1.13\";s:7:\"project\";s:4:\"i18n\";s:9:\"datestamp\";s:10:\"1430999922\";s:5:\"mtime\";i:1499928385;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/i18n/i18n_contact/i18n_contact.module','i18n_contact','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:19:\"Contact translation\";s:11:\"description\";s:63:\"Makes contact categories and replies available for translation.\";s:12:\"dependencies\";a:2:{i:0;s:7:\"contact\";i:1;s:11:\"i18n_string\";}s:7:\"package\";s:35:\"Multilingual - Internationalization\";s:4:\"core\";s:3:\"7.x\";s:7:\"version\";s:8:\"7.x-1.13\";s:7:\"project\";s:4:\"i18n\";s:9:\"datestamp\";s:10:\"1430999922\";s:5:\"mtime\";i:1499928385;s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/i18n/i18n_field/i18n_field.module','i18n_field','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:17:\"Field translation\";s:11:\"description\";s:26:\"Translate field properties\";s:12:\"dependencies\";a:2:{i:0;s:5:\"field\";i:1;s:11:\"i18n_string\";}s:7:\"package\";s:35:\"Multilingual - Internationalization\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:2:{i:0;s:14:\"i18n_field.inc\";i:1;s:15:\"i18n_field.test\";}s:7:\"version\";s:8:\"7.x-1.13\";s:7:\"project\";s:4:\"i18n\";s:9:\"datestamp\";s:10:\"1430999922\";s:5:\"mtime\";i:1499928385;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/i18n/i18n_forum/i18n_forum.module','i18n_forum','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:18:\"Multilingual forum\";s:11:\"description\";s:60:\"Enables multilingual forum, translates names and containers.\";s:12:\"dependencies\";a:3:{i:0;s:5:\"forum\";i:1;s:13:\"i18n_taxonomy\";i:2;s:9:\"i18n_node\";}s:7:\"package\";s:35:\"Multilingual - Internationalization\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:15:\"i18n_forum.test\";}s:7:\"version\";s:8:\"7.x-1.13\";s:7:\"project\";s:4:\"i18n\";s:9:\"datestamp\";s:10:\"1430999922\";s:5:\"mtime\";i:1499928385;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/i18n/i18n_menu/i18n_menu.module','i18n_menu','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:16:\"Menu translation\";s:11:\"description\";s:40:\"Supports translatable custom menu items.\";s:12:\"dependencies\";a:4:{i:0;s:4:\"i18n\";i:1;s:4:\"menu\";i:2;s:11:\"i18n_string\";i:3;s:16:\"i18n_translation\";}s:7:\"package\";s:35:\"Multilingual - Internationalization\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:2:{i:0;s:13:\"i18n_menu.inc\";i:1;s:14:\"i18n_menu.test\";}s:7:\"version\";s:8:\"7.x-1.13\";s:7:\"project\";s:4:\"i18n\";s:9:\"datestamp\";s:10:\"1430999922\";s:5:\"mtime\";i:1499928385;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/i18n/i18n_node/i18n_node.module','i18n_node','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:20:\"Multilingual content\";s:11:\"description\";s:46:\"Extended node options for multilingual content\";s:12:\"dependencies\";a:3:{i:0;s:11:\"translation\";i:1;s:4:\"i18n\";i:2;s:11:\"i18n_string\";}s:7:\"package\";s:35:\"Multilingual - Internationalization\";s:4:\"core\";s:3:\"7.x\";s:9:\"configure\";s:31:\"admin/config/regional/i18n/node\";s:5:\"files\";a:2:{i:0;s:14:\"i18n_node.test\";i:1;s:22:\"i18n_node.variable.inc\";}s:7:\"version\";s:8:\"7.x-1.13\";s:7:\"project\";s:4:\"i18n\";s:9:\"datestamp\";s:10:\"1430999922\";s:5:\"mtime\";i:1499928385;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/i18n/i18n_path/i18n_path.module','i18n_path','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:16:\"Path translation\";s:11:\"description\";s:37:\"Define translations for generic paths\";s:12:\"dependencies\";a:1:{i:0;s:16:\"i18n_translation\";}s:7:\"package\";s:35:\"Multilingual - Internationalization\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:2:{i:0;s:13:\"i18n_path.inc\";i:1;s:14:\"i18n_path.test\";}s:7:\"version\";s:8:\"7.x-1.13\";s:7:\"project\";s:4:\"i18n\";s:9:\"datestamp\";s:10:\"1430999922\";s:5:\"mtime\";i:1499928385;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/i18n/i18n_redirect/i18n_redirect.module','i18n_redirect','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:20:\"Translation redirect\";s:11:\"description\";s:71:\"Redirect to translated page when available. SEO for multilingual sites.\";s:12:\"dependencies\";a:1:{i:0;s:4:\"i18n\";}s:7:\"package\";s:35:\"Multilingual - Internationalization\";s:4:\"core\";s:3:\"7.x\";s:7:\"version\";s:8:\"7.x-1.13\";s:7:\"project\";s:4:\"i18n\";s:9:\"datestamp\";s:10:\"1430999922\";s:5:\"mtime\";i:1499928385;s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/i18n/i18n_select/i18n_select.module','i18n_select','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:19:\"Multilingual select\";s:11:\"description\";s:45:\"API module for multilingual content selection\";s:12:\"dependencies\";a:1:{i:0;s:4:\"i18n\";}s:7:\"package\";s:35:\"Multilingual - Internationalization\";s:4:\"core\";s:3:\"7.x\";s:9:\"configure\";s:33:\"admin/config/regional/i18n/select\";s:5:\"files\";a:1:{i:0;s:16:\"i18n_select.test\";}s:7:\"version\";s:8:\"7.x-1.13\";s:7:\"project\";s:4:\"i18n\";s:9:\"datestamp\";s:10:\"1430999922\";s:5:\"mtime\";i:1499928385;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/i18n/i18n_string/i18n_string.module','i18n_string','module','',1,0,7002,10,'a:13:{s:4:\"name\";s:18:\"String translation\";s:11:\"description\";s:57:\"Provides support for translation of user defined strings.\";s:12:\"dependencies\";a:2:{i:0;s:6:\"locale\";i:1;s:4:\"i18n\";}s:7:\"package\";s:35:\"Multilingual - Internationalization\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:3:{i:0;s:21:\"i18n_string.admin.inc\";i:1;s:15:\"i18n_string.inc\";i:2;s:16:\"i18n_string.test\";}s:9:\"configure\";s:34:\"admin/config/regional/i18n/strings\";s:7:\"version\";s:8:\"7.x-1.13\";s:7:\"project\";s:4:\"i18n\";s:9:\"datestamp\";s:10:\"1430999922\";s:5:\"mtime\";i:1499928385;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/i18n/i18n_sync/i18n_sync.module','i18n_sync','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:24:\"Synchronize translations\";s:11:\"description\";s:74:\"Synchronizes taxonomy and fields accross translations of the same content.\";s:12:\"dependencies\";a:2:{i:0;s:4:\"i18n\";i:1;s:11:\"translation\";}s:7:\"package\";s:35:\"Multilingual - Internationalization\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:5:{i:0;s:16:\"i18n_sync.module\";i:1;s:17:\"i18n_sync.install\";i:2;s:20:\"i18n_sync.module.inc\";i:3;s:18:\"i18n_sync.node.inc\";i:4;s:14:\"i18n_sync.test\";}s:7:\"version\";s:8:\"7.x-1.13\";s:7:\"project\";s:4:\"i18n\";s:9:\"datestamp\";s:10:\"1430999922\";s:5:\"mtime\";i:1499928385;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/i18n/i18n_taxonomy/i18n_taxonomy.module','i18n_taxonomy','module','',1,0,7004,5,'a:12:{s:4:\"name\";s:20:\"Taxonomy translation\";s:11:\"description\";s:30:\"Enables multilingual taxonomy.\";s:12:\"dependencies\";a:3:{i:0;s:8:\"taxonomy\";i:1;s:11:\"i18n_string\";i:2;s:16:\"i18n_translation\";}s:7:\"package\";s:35:\"Multilingual - Internationalization\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:4:{i:0;s:17:\"i18n_taxonomy.inc\";i:1;s:23:\"i18n_taxonomy.pages.inc\";i:2;s:23:\"i18n_taxonomy.admin.inc\";i:3;s:18:\"i18n_taxonomy.test\";}s:7:\"version\";s:8:\"7.x-1.13\";s:7:\"project\";s:4:\"i18n\";s:9:\"datestamp\";s:10:\"1430999922\";s:5:\"mtime\";i:1499928385;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/i18n/i18n_translation/i18n_translation.module','i18n_translation','module','',1,0,0,0,'a:12:{s:4:\"name\";s:16:\"Translation sets\";s:11:\"description\";s:47:\"Simple translation sets API for generic objects\";s:12:\"dependencies\";a:1:{i:0;s:4:\"i18n\";}s:7:\"package\";s:35:\"Multilingual - Internationalization\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:20:\"i18n_translation.inc\";}s:7:\"version\";s:8:\"7.x-1.13\";s:7:\"project\";s:4:\"i18n\";s:9:\"datestamp\";s:10:\"1430999922\";s:5:\"mtime\";i:1499928385;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/i18n/i18n_user/i18n_user.module','i18n_user','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:21:\"User mail translation\";s:11:\"description\";s:43:\"Translate emails sent from the User module.\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:35:\"Multilingual - Internationalization\";s:12:\"dependencies\";a:1:{i:0;s:13:\"i18n_variable\";}s:7:\"version\";s:8:\"7.x-1.13\";s:7:\"project\";s:4:\"i18n\";s:9:\"datestamp\";s:10:\"1430999922\";s:5:\"mtime\";i:1499928385;s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/i18n/i18n_variable/i18n_variable.module','i18n_variable','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:20:\"Variable translation\";s:11:\"description\";s:71:\"Multilingual variables that switch language depending on page language.\";s:12:\"dependencies\";a:3:{i:0;s:4:\"i18n\";i:1;s:24:\"variable_store (7.x-2.x)\";i:2;s:24:\"variable_realm (7.x-2.x)\";}s:7:\"package\";s:35:\"Multilingual - Internationalization\";s:4:\"core\";s:3:\"7.x\";s:9:\"configure\";s:35:\"admin/config/regional/i18n/variable\";s:5:\"files\";a:2:{i:0;s:23:\"i18n_variable.class.inc\";i:1;s:18:\"i18n_variable.test\";}s:7:\"version\";s:8:\"7.x-1.13\";s:7:\"project\";s:4:\"i18n\";s:9:\"datestamp\";s:10:\"1430999922\";s:5:\"mtime\";i:1499928385;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/i18n/tests/i18n_test.module','i18n_test','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:26:\"Internationalization tests\";s:11:\"description\";s:55:\"Helper module for testing i18n (do not enable manually)\";s:12:\"dependencies\";a:3:{i:0;s:6:\"locale\";i:1;s:11:\"translation\";i:2;s:4:\"i18n\";}s:7:\"package\";s:7:\"Testing\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"version\";s:8:\"7.x-1.13\";s:7:\"project\";s:4:\"i18n\";s:9:\"datestamp\";s:10:\"1430999922\";s:5:\"mtime\";i:1499928385;s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/jcarousel/jcarousel.module','jcarousel','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:9:\"jCarousel\";s:11:\"description\";s:38:\"Create jQuery-based carousel rotators.\";s:7:\"package\";s:14:\"User interface\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:3:{i:0;s:16:\"jcarousel.module\";i:1;s:28:\"includes/jcarousel.views.inc\";i:2;s:35:\"includes/jcarousel_style_plugin.inc\";}s:7:\"version\";s:7:\"7.x-2.7\";s:7:\"project\";s:9:\"jcarousel\";s:9:\"datestamp\";s:10:\"1420460282\";s:5:\"mtime\";i:1499928385;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/jquery_update/jquery_update.module','jquery_update','module','',1,0,7000,0,'a:13:{s:4:\"name\";s:13:\"jQuery Update\";s:11:\"description\";s:53:\"Update jQuery and jQuery UI to a more recent version.\";s:7:\"package\";s:14:\"User interface\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:2:{i:0;s:20:\"jquery_update.module\";i:1;s:21:\"jquery_update.install\";}s:9:\"configure\";s:38:\"admin/config/development/jquery_update\";s:7:\"version\";s:7:\"7.x-2.7\";s:7:\"project\";s:13:\"jquery_update\";s:9:\"datestamp\";s:10:\"1445379855\";s:5:\"mtime\";i:1445379855;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/jump_menu/jump_menu.module','jump_menu','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:17:\"Better Jump Menus\";s:11:\"description\";s:71:\"Enables creating custom jump menus programmatically via the CTools API.\";s:12:\"dependencies\";a:3:{i:0;s:6:\"ctools\";i:1;s:5:\"block\";i:2;s:4:\"menu\";}s:7:\"package\";s:16:\"Chaos tool suite\";s:4:\"core\";s:3:\"7.x\";s:7:\"version\";s:7:\"7.x-1.4\";s:7:\"project\";s:9:\"jump_menu\";s:9:\"datestamp\";s:10:\"1339052179\";s:5:\"mtime\";i:1499928385;s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/languageicons/languageicons.module','languageicons','module','',1,0,6200,0,'a:13:{s:4:\"name\";s:14:\"Language Icons\";s:11:\"description\";s:29:\"Adds icons to language links.\";s:12:\"dependencies\";a:1:{i:0;s:6:\"locale\";}s:7:\"package\";s:12:\"Multilingual\";s:4:\"core\";s:3:\"7.x\";s:9:\"configure\";s:36:\"admin/config/regional/language/icons\";s:7:\"version\";s:7:\"7.x-1.1\";s:7:\"project\";s:13:\"languageicons\";s:9:\"datestamp\";s:10:\"1399825730\";s:5:\"mtime\";i:1499928385;s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/lang_dropdown/lang_dropdown.module','lang_dropdown','module','',1,0,7201,0,'a:13:{s:4:\"name\";s:26:\"Language Switcher Dropdown\";s:7:\"package\";s:12:\"Multilingual\";s:11:\"description\";s:65:\"Provides a dropdown select to switch between available languages.\";s:12:\"dependencies\";a:1:{i:0;s:6:\"locale\";}s:9:\"configure\";s:21:\"admin/structure/block\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:2:{i:0;s:20:\"lang_dropdown.module\";i:1;s:21:\"lang_dropdown.install\";}s:7:\"version\";s:7:\"7.x-2.5\";s:7:\"project\";s:13:\"lang_dropdown\";s:9:\"datestamp\";s:10:\"1387127905\";s:5:\"mtime\";i:1499928385;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/lang_dropdown/lang_dropdown_hideout/lang_dropdown_hideout.module','lang_dropdown_hideout','module','',1,0,0,0,'a:13:{s:4:\"name\";s:34:\"Language Switcher Dropdown Hideout\";s:7:\"package\";s:12:\"Multilingual\";s:11:\"description\";s:69:\"Allow to hide specific languages from the switcher for certain roles.\";s:12:\"dependencies\";a:1:{i:0;s:6:\"locale\";}s:9:\"configure\";s:21:\"admin/structure/block\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:2:{i:0;s:28:\"lang_dropdown_hideout.module\";i:1;s:29:\"lang_dropdown_hideout.install\";}s:7:\"version\";s:7:\"7.x-2.5\";s:7:\"project\";s:13:\"lang_dropdown\";s:9:\"datestamp\";s:10:\"1387127905\";s:5:\"mtime\";i:1499928385;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/libraries/libraries.module','libraries','module','',1,0,7200,0,'a:12:{s:4:\"name\";s:9:\"Libraries\";s:11:\"description\";s:64:\"Allows version-dependent and shared usage of external libraries.\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:1:{i:0;s:15:\"system (>=7.11)\";}s:5:\"files\";a:1:{i:0;s:20:\"tests/libraries.test\";}s:7:\"version\";s:7:\"7.x-2.2\";s:7:\"project\";s:9:\"libraries\";s:9:\"datestamp\";s:10:\"1391965716\";s:5:\"mtime\";i:1499928385;s:7:\"package\";s:5:\"Other\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/libraries/tests/libraries_test.module','libraries_test','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:21:\"Libraries test module\";s:11:\"description\";s:36:\"Tests library detection and loading.\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:1:{i:0;s:9:\"libraries\";}s:6:\"hidden\";b:1;s:7:\"version\";s:7:\"7.x-2.1\";s:7:\"project\";s:9:\"libraries\";s:9:\"datestamp\";s:10:\"1362848412\";s:5:\"mtime\";i:1499928385;s:7:\"package\";s:5:\"Other\";s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/libraries/tests/modules/libraries_test_module/libraries_test_module.module','libraries_test_module','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:21:\"Libraries test module\";s:11:\"description\";s:36:\"Tests library detection and loading.\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:7:\"Testing\";s:12:\"dependencies\";a:1:{i:0;s:9:\"libraries\";}s:6:\"hidden\";b:1;s:7:\"version\";s:7:\"7.x-2.2\";s:7:\"project\";s:9:\"libraries\";s:9:\"datestamp\";s:10:\"1391965716\";s:5:\"mtime\";i:1499928385;s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/link/link.module','link','module','',1,0,7001,0,'a:14:{s:4:\"name\";s:4:\"Link\";s:11:\"description\";s:32:\"Defines simple link field types.\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:6:\"Fields\";s:5:\"files\";a:10:{i:0;s:11:\"link.module\";i:1;s:16:\"link.migrate.inc\";i:2;s:15:\"tests/link.test\";i:3;s:25:\"tests/link.attribute.test\";i:4;s:20:\"tests/link.crud.test\";i:5;s:28:\"tests/link.crud_browser.test\";i:6;s:21:\"tests/link.token.test\";i:7;s:24:\"tests/link.validate.test\";i:8;s:44:\"views/link_views_handler_argument_target.inc\";i:9;s:44:\"views/link_views_handler_filter_protocol.inc\";}s:7:\"version\";s:7:\"7.x-1.3\";s:7:\"project\";s:4:\"link\";s:9:\"datestamp\";s:10:\"1413924830\";s:5:\"mtime\";i:1499928385;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;s:8:\"required\";b:1;s:11:\"explanation\";s:76:\"Field type(s) in use - see <a href=\"/en/admin/reports/fields\">Field list</a>\";}'),('sites/all/modules/manage_multiple_terms/manage_multiple_terms.module','manage_multiple_terms','module','',0,0,-1,0,'a:11:{s:4:\"name\";s:21:\"Manage Multiple Terms\";s:11:\"description\";s:21:\"Manage Multiple Terms\";s:7:\"package\";s:8:\"Taxonomy\";s:9:\"configure\";s:30:\"admin/structure/taxonomy/terms\";s:4:\"core\";s:3:\"7.x\";s:5:\"mtime\";i:1499928385;s:12:\"dependencies\";a:0:{}s:7:\"version\";N;s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/memcache/memcache.module','memcache','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:8:\"Memcache\";s:11:\"description\";s:43:\"High performance integration with memcache.\";s:7:\"package\";s:27:\"Performance and scalability\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:4:{i:0;s:12:\"memcache.inc\";i:1;s:19:\"tests/memcache.test\";i:2;s:27:\"tests/memcache-session.test\";i:3;s:24:\"tests/memcache-lock.test\";}s:7:\"version\";s:7:\"7.x-1.5\";s:7:\"project\";s:8:\"memcache\";s:9:\"datestamp\";s:10:\"1422088394\";s:5:\"mtime\";i:1499928385;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/memcache/memcache_admin/memcache_admin.module','memcache_admin','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:14:\"Memcache Admin\";s:11:\"description\";s:60:\"Adds a User Interface to monitor the Memcache for this site.\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:27:\"Performance and scalability\";s:9:\"configure\";s:28:\"admin/config/system/memcache\";s:7:\"version\";s:7:\"7.x-1.5\";s:7:\"project\";s:8:\"memcache\";s:9:\"datestamp\";s:10:\"1422088394\";s:5:\"mtime\";i:1499928385;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/memcache/tests/memcache_test.module','memcache_test','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:13:\"Memcache test\";s:11:\"description\";s:36:\"Support module for memcache testing.\";s:7:\"package\";s:7:\"Testing\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"version\";s:7:\"7.x-1.5\";s:7:\"project\";s:8:\"memcache\";s:9:\"datestamp\";s:10:\"1422088394\";s:5:\"mtime\";i:1499928385;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/menu_breadcrumb/menu_breadcrumb.module','menu_breadcrumb','module','',1,0,6100,0,'a:13:{s:4:\"name\";s:15:\"Menu breadcrumb\";s:11:\"description\";s:74:\"Allows you to use the menu the current page belongs to for the breadcrumb.\";s:12:\"dependencies\";a:1:{i:0;s:4:\"menu\";}s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:23:\"menu_breadcrumb.install\";}s:9:\"configure\";s:43:\"admin/config/user-interface/menu-breadcrumb\";s:7:\"version\";s:7:\"7.x-1.6\";s:7:\"project\";s:15:\"menu_breadcrumb\";s:9:\"datestamp\";s:10:\"1425993992\";s:5:\"mtime\";i:1499928385;s:7:\"package\";s:5:\"Other\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/message/message.module','message','module','',1,0,7012,0,'a:12:{s:4:\"name\";s:7:\"Message\";s:11:\"description\";s:34:\"A general message logging utility.\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:7:\"Message\";s:12:\"dependencies\";a:1:{i:0;s:6:\"entity\";}s:5:\"files\";a:11:{i:0;s:16:\"message.info.inc\";i:1;s:26:\"includes/message.admin.inc\";i:2;s:30:\"includes/message.exception.inc\";i:3;s:42:\"includes/message.message_type_category.inc\";i:4;s:33:\"includes/message.message_type.inc\";i:5;s:28:\"includes/message.message.inc\";i:6;s:12:\"message.test\";i:7;s:32:\"includes/views/message.views.inc\";i:8;s:64:\"includes/views/handlers/message_handler_field_message_render.inc\";i:9;s:63:\"includes/views/handlers/message_handler_filter_message_type.inc\";i:10;s:72:\"includes/views/handlers/message_handler_filter_message_type_category.inc\";}s:7:\"version\";s:7:\"7.x-1.9\";s:7:\"project\";s:7:\"message\";s:9:\"datestamp\";s:10:\"1374541036\";s:5:\"mtime\";i:1499928385;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/message/message_example/message_example.module','message_example','module','',1,0,0,0,'a:14:{s:4:\"name\";s:15:\"Message example\";s:11:\"description\";s:16:\"Message example.\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:7:\"Message\";s:3:\"php\";s:5:\"5.2.4\";s:12:\"dependencies\";a:8:{i:0;s:12:\"entity_token\";i:1;s:15:\"entityreference\";i:2;s:8:\"features\";i:3;s:4:\"list\";i:4;s:7:\"message\";i:5;s:9:\"strongarm\";i:6;s:5:\"token\";i:7;s:5:\"views\";}s:11:\"stylesheets\";a:1:{s:3:\"all\";a:1:{s:23:\"css/message_example.css\";s:65:\"sites/all/modules/message/message_example/css/message_example.css\";}}s:8:\"features\";a:6:{s:6:\"ctools\";a:2:{i:0;s:21:\"strongarm:strongarm:1\";i:1;s:23:\"views:views_default:3.0\";}s:12:\"features_api\";a:1:{i:0;s:5:\"api:1\";}s:5:\"field\";a:6:{i:0;s:48:\"message-example_create_comment-field_comment_ref\";i:1;s:45:\"message-example_create_comment-field_node_ref\";i:2;s:46:\"message-example_create_comment-field_published\";i:3;s:42:\"message-example_create_node-field_node_ref\";i:4;s:43:\"message-example_create_node-field_published\";i:5;s:45:\"message-example_user_register-field_published\";}s:12:\"message_type\";a:3:{i:0;s:22:\"example_create_comment\";i:1;s:19:\"example_create_node\";i:2;s:21:\"example_user_register\";}s:8:\"variable\";a:3:{i:0;s:53:\"field_bundle_settings_message__example_create_comment\";i:1;s:50:\"field_bundle_settings_message__example_create_node\";i:2;s:52:\"field_bundle_settings_message__example_user_register\";}s:10:\"views_view\";a:1:{i:0;s:15:\"message_example\";}}s:7:\"version\";s:7:\"7.x-1.9\";s:7:\"project\";s:7:\"message\";s:9:\"datestamp\";s:10:\"1374541036\";s:5:\"mtime\";i:1499928385;s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/message/message_og_example/message_og_example.module','message_og_example','module','',0,0,-1,0,'a:13:{s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:7:{i:0;s:15:\"entityreference\";i:1;s:8:\"features\";i:2;s:4:\"list\";i:3;s:7:\"message\";i:4;s:15:\"message_example\";i:5;s:2:\"og\";i:6;s:5:\"views\";}s:11:\"description\";s:48:\"Message integration with Organic groups example.\";s:8:\"features\";a:4:{s:6:\"ctools\";a:1:{i:0;s:23:\"views:views_default:3.0\";}s:5:\"field\";a:5:{i:0;s:54:\"message-example_og_post_in_group-field_node_groups_ref\";i:1;s:47:\"message-example_og_post_in_group-field_node_ref\";i:2;s:48:\"message-example_og_post_in_group-field_published\";i:3;s:56:\"message-example_og_user_membership-field_node_groups_ref\";i:4;s:50:\"message-example_og_user_membership-field_published\";}s:12:\"message_type\";a:2:{i:0;s:24:\"example_og_post_in_group\";i:1;s:26:\"example_og_user_membership\";}s:10:\"views_view\";a:1:{i:0;s:18:\"message_og_example\";}}s:4:\"name\";s:18:\"Message OG example\";s:7:\"package\";s:7:\"Message\";s:3:\"php\";s:5:\"5.2.4\";s:7:\"version\";s:7:\"7.x-1.9\";s:7:\"project\";s:7:\"message\";s:9:\"datestamp\";s:10:\"1374541036\";s:5:\"mtime\";i:1499928385;s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/modal_forms/modal_forms.module','modal_forms','module','',1,0,0,0,'a:13:{s:4:\"name\";s:11:\"Modal forms\";s:11:\"description\";s:81:\"This module use ctools modal feature to open some common forms in a modal window.\";s:12:\"dependencies\";a:1:{i:0;s:6:\"ctools\";}s:4:\"core\";s:3:\"7.x\";s:9:\"configure\";s:36:\"admin/config/development/modal_forms\";s:7:\"version\";s:7:\"7.x-1.2\";s:7:\"project\";s:11:\"modal_forms\";s:9:\"datestamp\";s:10:\"1353326875\";s:5:\"mtime\";i:1499928385;s:7:\"package\";s:5:\"Other\";s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/module_filter/module_filter.module','module_filter','module','',1,0,7201,0,'a:13:{s:4:\"name\";s:13:\"Module filter\";s:11:\"description\";s:24:\"Filter the modules list.\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:14:\"Administration\";s:5:\"files\";a:9:{i:0;s:21:\"module_filter.install\";i:1;s:16:\"module_filter.js\";i:2;s:20:\"module_filter.module\";i:3;s:23:\"module_filter.admin.inc\";i:4;s:23:\"module_filter.theme.inc\";i:5;s:21:\"css/module_filter.css\";i:6;s:25:\"css/module_filter_tab.css\";i:7;s:19:\"js/module_filter.js\";i:8;s:23:\"js/module_filter_tab.js\";}s:9:\"configure\";s:40:\"admin/config/user-interface/modulefilter\";s:7:\"version\";s:7:\"7.x-2.0\";s:7:\"project\";s:13:\"module_filter\";s:9:\"datestamp\";s:10:\"1424631189\";s:5:\"mtime\";i:1499928385;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/newsletter/newsletter.module','newsletter','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:10:\"Newsletter\";s:11:\"description\";s:32:\"Send emails to subscribed users.\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:4:\"Mail\";s:12:\"dependencies\";a:3:{i:0;s:15:\"entityreference\";i:1;s:8:\"taxonomy\";i:2;s:5:\"token\";}s:5:\"files\";a:10:{i:0;s:29:\"includes/newsletter.basic.inc\";i:1;s:33:\"includes/newsletter.automated.inc\";i:2;s:30:\"includes/newsletter.custom.inc\";i:3;s:28:\"includes/newsletter.mail.inc\";i:4;s:45:\"includes/newsletter.newsletter.controller.inc\";i:5;s:45:\"includes/newsletter.subscriber.controller.inc\";i:6;s:43:\"includes/newsletter.template.controller.inc\";i:7;s:39:\"includes/newsletter.list.controller.inc\";i:8;s:61:\"includes/views/handlers/newsletter_handler_field_datetime.inc\";i:9;s:15:\"newsletter.test\";}s:9:\"configure\";s:39:\"admin/config/media/newsletter/configure\";s:7:\"version\";s:14:\"7.x-1.0-beta10\";s:7:\"project\";s:10:\"newsletter\";s:9:\"datestamp\";s:10:\"1401923333\";s:5:\"mtime\";i:1499928385;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/node_class/node_class.module','node_class','module','',1,0,0,0,'a:12:{s:4:\"name\";s:10:\"Node Class\";s:11:\"description\";s:38:\"Allows assigning CSS classes to nodes.\";s:4:\"core\";s:3:\"7.x\";s:7:\"version\";s:7:\"7.x-1.3\";s:7:\"project\";s:10:\"node_class\";s:9:\"datestamp\";s:10:\"1388997876\";s:5:\"mtime\";i:1499928385;s:12:\"dependencies\";a:0:{}s:7:\"package\";s:5:\"Other\";s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/page_title/page_title.module','page_title','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:10:\"Page Title\";s:11:\"description\";s:60:\"Enhanced control over the page title (in the &lt;head> tag).\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:3:\"SEO\";s:12:\"dependencies\";a:1:{i:0;s:5:\"token\";}s:5:\"files\";a:6:{i:0;s:17:\"page_title.module\";i:1;s:20:\"page_title.admin.inc\";i:2;s:21:\"page_title.tokens.inc\";i:3;s:15:\"page_title.test\";i:4;s:64:\"views/plugins/page_title_plugin_display_page_with_page_title.inc\";i:5;s:39:\"views_handler_field_node_page_title.inc\";}s:9:\"configure\";s:30:\"admin/config/search/page-title\";s:7:\"version\";s:7:\"7.x-2.7\";s:7:\"project\";s:10:\"page_title\";s:9:\"datestamp\";s:10:\"1336556786\";s:5:\"mtime\";i:1499928385;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/pathauto/pathauto.module','pathauto','module','',1,0,7005,1,'a:14:{s:4:\"name\";s:8:\"Pathauto\";s:11:\"description\";s:95:\"Provides a mechanism for modules to automatically generate aliases for the content they manage.\";s:12:\"dependencies\";a:2:{i:0;s:4:\"path\";i:1;s:5:\"token\";}s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:13:\"pathauto.test\";}s:9:\"configure\";s:33:\"admin/config/search/path/patterns\";s:10:\"recommends\";a:1:{i:0;s:8:\"redirect\";}s:7:\"version\";s:7:\"7.x-1.2\";s:7:\"project\";s:8:\"pathauto\";s:9:\"datestamp\";s:10:\"1344525185\";s:5:\"mtime\";i:1499928385;s:7:\"package\";s:5:\"Other\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/quicktabs/quicktabs.module','quicktabs','module','',1,0,7303,0,'a:13:{s:4:\"name\";s:9:\"Quicktabs\";s:11:\"description\";s:49:\"Render content with tabs and other display styles\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:4:{i:0;s:16:\"quicktabs.module\";i:1;s:21:\"quicktabs.classes.inc\";i:2;s:35:\"includes/quicktabs_style_plugin.inc\";i:3;s:20:\"tests/quicktabs.test\";}s:9:\"configure\";s:25:\"admin/structure/quicktabs\";s:12:\"dependencies\";a:1:{i:0;s:6:\"ctools\";}s:7:\"version\";s:7:\"7.x-3.6\";s:7:\"project\";s:9:\"quicktabs\";s:9:\"datestamp\";s:10:\"1380731929\";s:5:\"mtime\";i:1499928385;s:7:\"package\";s:5:\"Other\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/quicktabs/quicktabs_tabstyles/quicktabs_tabstyles.module','quicktabs_tabstyles','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:16:\"Quicktabs Styles\";s:11:\"description\";s:65:\"Adds predefined tab styles to choose from per Quicktabs instance.\";s:4:\"core\";s:3:\"7.x\";s:9:\"configure\";s:32:\"admin/structure/quicktabs/styles\";s:12:\"dependencies\";a:1:{i:0;s:9:\"quicktabs\";}s:7:\"version\";s:7:\"7.x-3.6\";s:7:\"project\";s:9:\"quicktabs\";s:9:\"datestamp\";s:10:\"1380731929\";s:5:\"mtime\";i:1499928385;s:7:\"package\";s:5:\"Other\";s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/rate/expiration/rate_expiration.module','rate_expiration','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:15:\"Rate Expiration\";s:11:\"description\";s:38:\"Add an expiration time to rate widgets\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:6:\"Voting\";s:12:\"dependencies\";a:2:{i:0;s:4:\"rate\";i:1;s:4:\"date\";}s:5:\"files\";a:2:{i:0;s:23:\"rate_expiration.install\";i:1;s:22:\"rate_expiration.module\";}s:7:\"version\";s:7:\"7.x-1.7\";s:7:\"project\";s:4:\"rate\";s:9:\"datestamp\";s:10:\"1392071605\";s:5:\"mtime\";i:1499928385;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/rate/rate.module','rate','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:4:\"Rate\";s:11:\"description\";s:46:\"Flexible voting options for nodes and comments\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:6:\"Voting\";s:12:\"dependencies\";a:1:{i:0;s:9:\"votingapi\";}s:5:\"files\";a:5:{i:0;s:12:\"rate.install\";i:1;s:11:\"rate.module\";i:2;s:16:\"rate.results.inc\";i:3;s:14:\"rate.hooks.inc\";i:4;s:14:\"rate.admin.inc\";}s:7:\"version\";s:7:\"7.x-1.7\";s:7:\"project\";s:4:\"rate\";s:9:\"datestamp\";s:10:\"1392071605\";s:5:\"mtime\";i:1499928385;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/rate/slider/rate_slider.module','rate_slider','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:11:\"Rate Slider\";s:11:\"description\";s:24:\"Add a slider widget type\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:6:\"Voting\";s:12:\"dependencies\";a:1:{i:0;s:4:\"rate\";}s:7:\"version\";s:7:\"7.x-1.7\";s:7:\"project\";s:4:\"rate\";s:9:\"datestamp\";s:10:\"1392071605\";s:5:\"mtime\";i:1499928385;s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/remember_me/remember_me.module','remember_me','module','',1,0,0,-99,'a:12:{s:4:\"name\";s:11:\"Remember me\";s:11:\"description\";s:47:\"Adds a \'\'Remember me\'\' checkbox to login forms.\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:4:{i:0;s:19:\"remember_me.install\";i:1;s:18:\"remember_me.module\";i:2;s:30:\"includes/remember_me.admin.inc\";i:3;s:24:\"includes/remember_me.inc\";}s:7:\"version\";s:7:\"7.x-1.1\";s:7:\"project\";s:11:\"remember_me\";s:9:\"datestamp\";s:10:\"1492928945\";s:5:\"mtime\";i:1492928945;s:12:\"dependencies\";a:0:{}s:7:\"package\";s:5:\"Other\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/rules/rules.module','rules','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:5:\"Rules\";s:11:\"description\";s:51:\"React on events and conditionally evaluate actions.\";s:7:\"package\";s:5:\"Rules\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:17:{i:0;s:18:\"rules.features.inc\";i:1;s:16:\"tests/rules.test\";i:2;s:18:\"includes/faces.inc\";i:3;s:23:\"includes/rules.core.inc\";i:4;s:24:\"includes/rules.event.inc\";i:5;s:28:\"includes/rules.processor.inc\";i:6;s:26:\"includes/rules.plugins.inc\";i:7;s:24:\"includes/rules.state.inc\";i:8;s:29:\"includes/rules.dispatcher.inc\";i:9;s:21:\"modules/node.eval.inc\";i:10;s:20:\"modules/php.eval.inc\";i:11;s:27:\"modules/rules_core.eval.inc\";i:12;s:23:\"modules/system.eval.inc\";i:13;s:20:\"ui/ui.controller.inc\";i:14;s:14:\"ui/ui.core.inc\";i:15;s:14:\"ui/ui.data.inc\";i:16;s:17:\"ui/ui.plugins.inc\";}s:12:\"dependencies\";a:2:{i:0;s:12:\"entity_token\";i:1;s:6:\"entity\";}s:7:\"version\";s:7:\"7.x-2.9\";s:7:\"project\";s:5:\"rules\";s:9:\"datestamp\";s:10:\"1426527210\";s:5:\"mtime\";i:1499928385;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/rules/rules_admin/rules_admin.module','rules_admin','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:8:\"Rules UI\";s:11:\"description\";s:44:\"Administrative interface for managing rules.\";s:7:\"package\";s:5:\"Rules\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:2:{i:0;s:18:\"rules_admin.module\";i:1;s:15:\"rules_admin.inc\";}s:12:\"dependencies\";a:1:{i:0;s:5:\"rules\";}s:7:\"version\";s:7:\"7.x-2.9\";s:7:\"project\";s:5:\"rules\";s:9:\"datestamp\";s:10:\"1426527210\";s:5:\"mtime\";i:1499928385;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/rules/rules_i18n/rules_i18n.module','rules_i18n','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:17:\"Rules translation\";s:11:\"description\";s:25:\"Allows translating rules.\";s:12:\"dependencies\";a:2:{i:0;s:5:\"rules\";i:1;s:11:\"i18n_string\";}s:7:\"package\";s:35:\"Multilingual - Internationalization\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:3:{i:0;s:19:\"rules_i18n.i18n.inc\";i:1;s:20:\"rules_i18n.rules.inc\";i:2;s:15:\"rules_i18n.test\";}s:7:\"version\";s:7:\"7.x-2.9\";s:7:\"project\";s:5:\"rules\";s:9:\"datestamp\";s:10:\"1426527210\";s:5:\"mtime\";i:1499928385;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/rules/rules_scheduler/rules_scheduler.module','rules_scheduler','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:15:\"Rules Scheduler\";s:11:\"description\";s:57:\"Schedule the execution of Rules components using actions.\";s:12:\"dependencies\";a:1:{i:0;s:5:\"rules\";}s:7:\"package\";s:5:\"Rules\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:9:{i:0;s:25:\"rules_scheduler.admin.inc\";i:1;s:22:\"rules_scheduler.module\";i:2;s:23:\"rules_scheduler.install\";i:3;s:25:\"rules_scheduler.rules.inc\";i:4;s:20:\"rules_scheduler.test\";i:5;s:36:\"includes/rules_scheduler.handler.inc\";i:6;s:42:\"includes/rules_scheduler.views_default.inc\";i:7;s:34:\"includes/rules_scheduler.views.inc\";i:8;s:41:\"includes/rules_scheduler_views_filter.inc\";}s:7:\"version\";s:7:\"7.x-2.9\";s:7:\"project\";s:5:\"rules\";s:9:\"datestamp\";s:10:\"1426527210\";s:5:\"mtime\";i:1499928385;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/rules/rules_scheduler/tests/rules_scheduler_test.module','rules_scheduler_test','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:21:\"Rules Scheduler Tests\";s:11:\"description\";s:45:\"Support module for the Rules Scheduler tests.\";s:7:\"package\";s:7:\"Testing\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:24:\"rules_scheduler_test.inc\";}s:6:\"hidden\";b:1;s:7:\"version\";s:7:\"7.x-2.9\";s:7:\"project\";s:5:\"rules\";s:9:\"datestamp\";s:10:\"1426527210\";s:5:\"mtime\";i:1499928385;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/rules/tests/rules_test.module','rules_test','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:11:\"Rules Tests\";s:11:\"description\";s:35:\"Support module for the Rules tests.\";s:7:\"package\";s:7:\"Testing\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:2:{i:0;s:20:\"rules_test.rules.inc\";i:1;s:29:\"rules_test.rules_defaults.inc\";}s:6:\"hidden\";b:1;s:7:\"version\";s:7:\"7.x-2.9\";s:7:\"project\";s:5:\"rules\";s:9:\"datestamp\";s:10:\"1426527210\";s:5:\"mtime\";i:1499928385;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/rules/tests/rules_test_invocation.module','rules_test_invocation','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:21:\"Rules Test invocation\";s:11:\"description\";s:40:\"Helper module to test Rules invocations.\";s:7:\"package\";s:7:\"Testing\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"version\";s:7:\"7.x-2.9\";s:7:\"project\";s:5:\"rules\";s:9:\"datestamp\";s:10:\"1426527210\";s:5:\"mtime\";i:1499928385;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/sharethis/sharethis.module','sharethis','module','',1,0,7001,0,'a:13:{s:4:\"name\";s:9:\"ShareThis\";s:11:\"description\";s:87:\"Add the <a href=\"http://www.sharethis.com/\">ShareThis</a> widget to nodes on your site.\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:7:\"Sharing\";s:9:\"configure\";s:31:\"admin/config/services/sharethis\";s:5:\"files\";a:1:{i:0;s:38:\"views/sharethis_handler_field_link.inc\";}s:7:\"version\";s:8:\"7.x-2.10\";s:7:\"project\";s:9:\"sharethis\";s:9:\"datestamp\";s:10:\"1422441977\";s:5:\"mtime\";i:1499928385;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/shortcode/shortcode.module','shortcode','module','',1,0,0,0,'a:12:{s:4:\"name\";s:9:\"Shortcode\";s:11:\"description\";s:65:\"Provides shortcodes filter framework and API (like WP shortcodes)\";s:7:\"package\";s:9:\"Shortcode\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:1:{i:0;s:6:\"filter\";}s:7:\"version\";s:7:\"7.x-2.2\";s:7:\"project\";s:9:\"shortcode\";s:9:\"datestamp\";s:10:\"1423035812\";s:5:\"mtime\";i:1499928385;s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/shortcode/shortcode_basic_tags/shortcode_basic_tags.module','shortcode_basic_tags','module','',1,0,0,0,'a:12:{s:4:\"name\";s:20:\"Shortcode Basic Tags\";s:11:\"description\";s:59:\"Provides basic shortcode tags like highlight, dropcap, etc.\";s:7:\"package\";s:9:\"Shortcode\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:1:{i:0;s:9:\"shortcode\";}s:7:\"version\";s:7:\"7.x-2.2\";s:7:\"project\";s:9:\"shortcode\";s:9:\"datestamp\";s:10:\"1423035812\";s:5:\"mtime\";i:1499928385;s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/shortcode/shortcode_embed_content/shortcode_embed_content.module','shortcode_embed_content','module','',1,0,0,0,'a:12:{s:4:\"name\";s:27:\"Shortcode Embed Content Tag\";s:11:\"description\";s:64:\"Provides a shortcode tag for embedding a node content into text.\";s:7:\"package\";s:9:\"Shortcode\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:2:{i:0;s:6:\"filter\";i:1;s:9:\"shortcode\";}s:7:\"version\";s:7:\"7.x-2.2\";s:7:\"project\";s:9:\"shortcode\";s:9:\"datestamp\";s:10:\"1423035812\";s:5:\"mtime\";i:1499928385;s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/shortcode/shortcode_video/shortcode_video.module','shortcode_video','module','',1,0,0,0,'a:12:{s:4:\"name\";s:21:\"Shortcode Video Macro\";s:11:\"description\";s:68:\"Provides easy video embedding to contents. Supports YouTube sharing.\";s:7:\"package\";s:9:\"Shortcode\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:2:{i:0;s:6:\"filter\";i:1;s:9:\"shortcode\";}s:7:\"version\";s:7:\"7.x-2.2\";s:7:\"project\";s:9:\"shortcode\";s:9:\"datestamp\";s:10:\"1423035812\";s:5:\"mtime\";i:1499928385;s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/sitemap/site_map.module','site_map','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:8:\"Site map\";s:11:\"description\";s:19:\"Display a site map.\";s:4:\"core\";s:3:\"7.x\";s:9:\"configure\";s:27:\"admin/config/search/sitemap\";s:12:\"dependencies\";a:1:{i:0;s:4:\"menu\";}s:5:\"files\";a:1:{i:0;s:13:\"site_map.test\";}s:7:\"version\";s:7:\"7.x-1.2\";s:7:\"project\";s:8:\"site_map\";s:9:\"datestamp\";s:10:\"1393897705\";s:5:\"mtime\";i:1499928385;s:7:\"package\";s:5:\"Other\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/strongarm/strongarm.module','strongarm','module','',1,0,7201,-1000,'a:12:{s:4:\"name\";s:9:\"Strongarm\";s:11:\"description\";s:87:\"Enforces variable values defined by modules that need settings set to operate properly.\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:1:{i:0;s:6:\"ctools\";}s:5:\"files\";a:3:{i:0;s:19:\"strongarm.admin.inc\";i:1;s:17:\"strongarm.install\";i:2;s:16:\"strongarm.module\";}s:7:\"version\";s:7:\"7.x-2.0\";s:7:\"project\";s:9:\"strongarm\";s:9:\"datestamp\";s:10:\"1339604214\";s:5:\"mtime\";i:1499928385;s:7:\"package\";s:5:\"Other\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/tagclouds/tagclouds.module','tagclouds','module','',1,0,0,0,'a:13:{s:4:\"name\";s:9:\"TagClouds\";s:11:\"description\";s:61:\"TagClouds makes weighted tag clouds from your taxonomy terms.\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:1:{i:0;s:8:\"taxonomy\";}s:7:\"package\";s:8:\"Taxonomy\";s:9:\"configure\";s:30:\"admin/config/content/tagclouds\";s:7:\"version\";s:8:\"7.x-1.10\";s:7:\"project\";s:9:\"tagclouds\";s:9:\"datestamp\";s:10:\"1404152332\";s:5:\"mtime\";i:1499928385;s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/taxonomy_menu/taxonomy_menu.module','taxonomy_menu','module','',1,0,7000,0,'a:12:{s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:2:{i:0;s:8:\"taxonomy\";i:1;s:4:\"menu\";}s:11:\"description\";s:39:\"Adds links to taxonomy terms to a menu.\";s:4:\"name\";s:13:\"Taxonomy menu\";s:7:\"package\";s:13:\"Taxonomy menu\";s:5:\"files\";a:5:{i:0;s:23:\"taxonomy_menu.batch.inc\";i:1;s:26:\"taxonomy_menu.database.inc\";i:2;s:20:\"taxonomy_menu.module\";i:3;s:18:\"taxonomy_menu.test\";i:4;s:21:\"taxonomy_menu.install\";}s:7:\"version\";s:7:\"7.x-1.5\";s:7:\"project\";s:13:\"taxonomy_menu\";s:9:\"datestamp\";s:10:\"1396359247\";s:5:\"mtime\";i:1499928385;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/tb_megamenu/tb_megamenu.module','tb_megamenu','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:12:\"TB Mega Menu\";s:11:\"description\";s:29:\"Megamenu solutions for Drupal\";s:7:\"package\";s:11:\"tb_megamenu\";s:7:\"version\";s:13:\"7.x-1.0-beta5\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:5:{i:0;s:25:\"tb_megamenu.functions.inc\";i:1;s:22:\"tb_megamenu.themes.inc\";i:2;s:20:\"tb_megamenu.ajax.inc\";i:3;s:21:\"tb_megamenu.admin.inc\";i:4;s:18:\"tb_megamenu.module\";}s:9:\"configure\";s:27:\"admin/structure/tb-megamenu\";s:7:\"project\";s:11:\"tb_megamenu\";s:9:\"datestamp\";s:10:\"1408100329\";s:5:\"mtime\";i:1499928385;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/title/tests/title_test.module','title_test','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:10:\"Title Test\";s:11:\"description\";s:61:\"Testing module for Title module functionality. Do not enable.\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:7:\"Testing\";s:6:\"hidden\";b:1;s:12:\"dependencies\";a:3:{i:0;s:5:\"title\";i:1;s:6:\"entity\";i:2;s:18:\"entity_translation\";}s:7:\"version\";s:14:\"7.x-1.0-alpha7\";s:7:\"project\";s:5:\"title\";s:9:\"datestamp\";s:10:\"1363626024\";s:5:\"mtime\";i:1499928385;s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/title/title.module','title','module','',0,0,7002,100,'a:13:{s:4:\"name\";s:5:\"Title\";s:11:\"description\";s:50:\"Replaces entity legacy fields with regular fields.\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:6:\"Fields\";s:9:\"configure\";s:26:\"admin/config/content/title\";s:12:\"dependencies\";a:1:{i:0;s:14:\"system (>7.14)\";}s:5:\"files\";a:3:{i:0;s:12:\"title.module\";i:1;s:35:\"views/views_handler_title_field.inc\";i:2;s:16:\"tests/title.test\";}s:7:\"version\";s:14:\"7.x-1.0-alpha7\";s:7:\"project\";s:5:\"title\";s:9:\"datestamp\";s:10:\"1363626024\";s:5:\"mtime\";i:1499928385;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/token/tests/token_test.module','token_test','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:10:\"Token Test\";s:11:\"description\";s:39:\"Testing module for token functionality.\";s:7:\"package\";s:7:\"Testing\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:17:\"token_test.module\";}s:6:\"hidden\";b:1;s:7:\"version\";s:7:\"7.x-1.6\";s:7:\"project\";s:5:\"token\";s:9:\"datestamp\";s:10:\"1425149060\";s:5:\"mtime\";i:1499928385;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/token/token.module','token','module','',1,0,7001,0,'a:12:{s:4:\"name\";s:5:\"Token\";s:11:\"description\";s:73:\"Provides a user interface for the Token API and some missing core tokens.\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:10:\"token.test\";}s:7:\"version\";s:7:\"7.x-1.6\";s:7:\"project\";s:5:\"token\";s:9:\"datestamp\";s:10:\"1425149060\";s:5:\"mtime\";i:1499928385;s:12:\"dependencies\";a:0:{}s:7:\"package\";s:5:\"Other\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/token_custom/token_custom.module','token_custom','module','',1,0,7002,0,'a:13:{s:4:\"name\";s:13:\"Custom tokens\";s:11:\"description\";s:61:\"Allow users to define custom tokens to use thoughout the site\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:1:{i:0;s:6:\"filter\";}s:9:\"configure\";s:28:\"admin/structure/token-custom\";s:7:\"version\";s:13:\"7.x-2.0-beta3\";s:7:\"project\";s:12:\"token_custom\";s:9:\"datestamp\";s:10:\"1348426268\";s:5:\"mtime\";i:1499928385;s:7:\"package\";s:5:\"Other\";s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/userpickit/gravatar/userpickit_gravatar.module','userpickit_gravatar','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:22:\"User Pic Kit Gravatars\";s:11:\"description\";s:26:\"Provide Gravatar pictures.\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:12:\"User Picture\";s:12:\"dependencies\";a:2:{i:0;s:8:\"gravatar\";i:1;s:10:\"userpickit\";}s:7:\"version\";s:13:\"7.x-1.0-beta2\";s:7:\"project\";s:10:\"userpickit\";s:9:\"datestamp\";s:10:\"1424504883\";s:5:\"mtime\";i:1499928385;s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/userpickit/robohash/userpickit_robohash.module','userpickit_robohash','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:23:\"User Pic Kit Robohashes\";s:11:\"description\";s:26:\"Provide Robohash pictures.\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:12:\"User Picture\";s:12:\"dependencies\";a:1:{i:0;s:10:\"userpickit\";}s:7:\"version\";s:13:\"7.x-1.0-beta2\";s:7:\"project\";s:10:\"userpickit\";s:9:\"datestamp\";s:10:\"1424504883\";s:5:\"mtime\";i:1499928385;s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/userpickit/userpickit.module','userpickit','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:12:\"User Pic Kit\";s:11:\"description\";s:56:\"Allow users to choose a picture from multiple providers.\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:12:\"User Picture\";s:9:\"configure\";s:30:\"admin/config/people/userpickit\";s:7:\"version\";s:13:\"7.x-1.0-beta2\";s:7:\"project\";s:10:\"userpickit\";s:9:\"datestamp\";s:10:\"1424504883\";s:5:\"mtime\";i:1499928385;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/variable/variable.module','variable','module','',1,1,0,0,'a:12:{s:4:\"name\";s:8:\"Variable\";s:11:\"description\";s:43:\"Variable Information and basic variable API\";s:7:\"package\";s:8:\"Variable\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:9:{i:0;s:27:\"includes/forum.variable.inc\";i:1;s:28:\"includes/locale.variable.inc\";i:2;s:26:\"includes/menu.variable.inc\";i:3;s:26:\"includes/node.variable.inc\";i:4;s:28:\"includes/system.variable.inc\";i:5;s:30:\"includes/taxonomy.variable.inc\";i:6;s:33:\"includes/translation.variable.inc\";i:7;s:26:\"includes/user.variable.inc\";i:8;s:13:\"variable.test\";}s:7:\"version\";s:7:\"7.x-2.5\";s:7:\"project\";s:8:\"variable\";s:9:\"datestamp\";s:10:\"1398250128\";s:5:\"mtime\";i:1499928385;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/variable/variable_admin/variable_admin.module','variable_admin','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:14:\"Variable admin\";s:11:\"description\";s:26:\"Variable Administration UI\";s:12:\"dependencies\";a:1:{i:0;s:8:\"variable\";}s:7:\"package\";s:8:\"Variable\";s:4:\"core\";s:3:\"7.x\";s:7:\"version\";s:7:\"7.x-2.5\";s:7:\"project\";s:8:\"variable\";s:9:\"datestamp\";s:10:\"1398250128\";s:5:\"mtime\";i:1499928385;s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/variable/variable_example/variable_example.module','variable_example','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:16:\"Variable example\";s:11:\"description\";s:83:\"An example module showing how to use the Variable API and providing some variables.\";s:12:\"dependencies\";a:2:{i:0;s:8:\"variable\";i:1;s:14:\"variable_store\";}s:7:\"package\";s:15:\"Example modules\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:29:\"variable_example.variable.inc\";}s:7:\"version\";s:7:\"7.x-2.5\";s:7:\"project\";s:8:\"variable\";s:9:\"datestamp\";s:10:\"1398250128\";s:5:\"mtime\";i:1499928385;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/variable/variable_realm/variable_realm.module','variable_realm','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:14:\"Variable realm\";s:11:\"description\";s:49:\"API to use variable realms from different modules\";s:12:\"dependencies\";a:1:{i:0;s:8:\"variable\";}s:7:\"package\";s:8:\"Variable\";s:4:\"core\";s:3:\"7.x\";s:7:\"version\";s:7:\"7.x-2.5\";s:5:\"files\";a:2:{i:0;s:24:\"variable_realm.class.inc\";i:1;s:30:\"variable_realm_union.class.inc\";}s:7:\"project\";s:8:\"variable\";s:9:\"datestamp\";s:10:\"1398250128\";s:5:\"mtime\";i:1499928385;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/variable/variable_store/variable_store.module','variable_store','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:14:\"Variable store\";s:11:\"description\";s:60:\"Database storage for variable realms. This is an API module.\";s:12:\"dependencies\";a:1:{i:0;s:8:\"variable\";}s:7:\"package\";s:8:\"Variable\";s:4:\"core\";s:3:\"7.x\";s:7:\"version\";s:7:\"7.x-2.5\";s:5:\"files\";a:2:{i:0;s:24:\"variable_store.class.inc\";i:1;s:19:\"variable_store.test\";}s:7:\"project\";s:8:\"variable\";s:9:\"datestamp\";s:10:\"1398250128\";s:5:\"mtime\";i:1499928385;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/variable/variable_views/variable_views.module','variable_views','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:14:\"Variable views\";s:11:\"description\";s:78:\"Provides views integration for variable, included a default variable argument.\";s:12:\"dependencies\";a:2:{i:0;s:8:\"variable\";i:1;s:5:\"views\";}s:7:\"package\";s:8:\"Variable\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:3:{i:0;s:51:\"includes/views_plugin_argument_default_variable.inc\";i:1;s:47:\"includes/views_handler_field_variable_title.inc\";i:2;s:47:\"includes/views_handler_field_variable_value.inc\";}s:7:\"version\";s:7:\"7.x-2.5\";s:7:\"project\";s:8:\"variable\";s:9:\"datestamp\";s:10:\"1398250128\";s:5:\"mtime\";i:1499928385;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/video_embed_field/video_embed_brightcove/video_embed_brightcove.module','video_embed_brightcove','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:22:\"Video Embed Brightcove\";s:11:\"description\";s:51:\"Provides Brightcove handler for Video Embed Fields.\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:5:\"Media\";s:9:\"configure\";s:35:\"admin/config/media/vef_video_styles\";s:12:\"dependencies\";a:1:{i:0;s:17:\"video_embed_field\";}s:7:\"version\";s:14:\"7.x-2.0-beta11\";s:7:\"project\";s:17:\"video_embed_field\";s:9:\"datestamp\";s:10:\"1441639440\";s:5:\"mtime\";i:1499928385;s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/video_embed_field/video_embed_facebook/video_embed_facebook.module','video_embed_facebook','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:20:\"Video Embed Facebook\";s:11:\"description\";s:133:\"Provides Facebook handler for Video Embed Fields.  This module also serves as an example of how to add handlers to video embed field.\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:5:\"Media\";s:9:\"configure\";s:35:\"admin/config/media/vef_video_styles\";s:12:\"dependencies\";a:1:{i:0;s:17:\"video_embed_field\";}s:7:\"version\";s:14:\"7.x-2.0-beta11\";s:7:\"project\";s:17:\"video_embed_field\";s:9:\"datestamp\";s:10:\"1441639440\";s:5:\"mtime\";i:1499928385;s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/video_embed_field/video_embed_field.module','video_embed_field','module','',1,0,7010,0,'a:15:{s:4:\"name\";s:17:\"Video Embed Field\";s:11:\"description\";s:63:\"Expose a field type for embedding videos from youtube or vimeo.\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:5:\"Media\";s:9:\"configure\";s:22:\"admin/config/media/vef\";s:5:\"files\";a:2:{i:0;s:29:\"video_embed_field.migrate.inc\";i:1;s:71:\"views/handlers/views_embed_field_views_handler_field_thumbnail_path.inc\";}s:12:\"dependencies\";a:2:{i:0;s:6:\"ctools\";i:1;s:5:\"image\";}s:7:\"version\";s:14:\"7.x-2.0-beta11\";s:7:\"project\";s:17:\"video_embed_field\";s:9:\"datestamp\";s:10:\"1441639440\";s:5:\"mtime\";i:1499928385;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;s:8:\"required\";b:1;s:11:\"explanation\";s:76:\"Field type(s) in use - see <a href=\"/en/admin/reports/fields\">Field list</a>\";}'),('sites/all/modules/views/tests/views_test.module','views_test','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:10:\"Views Test\";s:11:\"description\";s:22:\"Test module for Views.\";s:7:\"package\";s:5:\"Views\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:1:{i:0;s:5:\"views\";}s:6:\"hidden\";b:1;s:7:\"version\";s:8:\"7.x-3.16\";s:7:\"project\";s:5:\"views\";s:9:\"datestamp\";s:10:\"1491158591\";s:5:\"mtime\";i:1491158591;s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/views/views.module','views','module','',1,0,7302,10,'a:13:{s:4:\"name\";s:5:\"Views\";s:11:\"description\";s:55:\"Create customized lists and queries from your database.\";s:7:\"package\";s:5:\"Views\";s:4:\"core\";s:3:\"7.x\";s:11:\"stylesheets\";a:1:{s:3:\"all\";a:1:{s:13:\"css/views.css\";s:37:\"sites/all/modules/views/css/views.css\";}}s:12:\"dependencies\";a:1:{i:0;s:6:\"ctools\";}s:5:\"files\";a:313:{i:0;s:31:\"handlers/views_handler_area.inc\";i:1;s:40:\"handlers/views_handler_area_messages.inc\";i:2;s:38:\"handlers/views_handler_area_result.inc\";i:3;s:36:\"handlers/views_handler_area_text.inc\";i:4;s:43:\"handlers/views_handler_area_text_custom.inc\";i:5;s:36:\"handlers/views_handler_area_view.inc\";i:6;s:35:\"handlers/views_handler_argument.inc\";i:7;s:40:\"handlers/views_handler_argument_date.inc\";i:8;s:43:\"handlers/views_handler_argument_formula.inc\";i:9;s:47:\"handlers/views_handler_argument_many_to_one.inc\";i:10;s:40:\"handlers/views_handler_argument_null.inc\";i:11;s:43:\"handlers/views_handler_argument_numeric.inc\";i:12;s:42:\"handlers/views_handler_argument_string.inc\";i:13;s:52:\"handlers/views_handler_argument_group_by_numeric.inc\";i:14;s:32:\"handlers/views_handler_field.inc\";i:15;s:40:\"handlers/views_handler_field_counter.inc\";i:16;s:40:\"handlers/views_handler_field_boolean.inc\";i:17;s:49:\"handlers/views_handler_field_contextual_links.inc\";i:18;s:48:\"handlers/views_handler_field_ctools_dropdown.inc\";i:19;s:39:\"handlers/views_handler_field_custom.inc\";i:20;s:37:\"handlers/views_handler_field_date.inc\";i:21;s:39:\"handlers/views_handler_field_entity.inc\";i:22;s:38:\"handlers/views_handler_field_links.inc\";i:23;s:39:\"handlers/views_handler_field_markup.inc\";i:24;s:37:\"handlers/views_handler_field_math.inc\";i:25;s:40:\"handlers/views_handler_field_numeric.inc\";i:26;s:47:\"handlers/views_handler_field_prerender_list.inc\";i:27;s:46:\"handlers/views_handler_field_time_interval.inc\";i:28;s:43:\"handlers/views_handler_field_serialized.inc\";i:29;s:45:\"handlers/views_handler_field_machine_name.inc\";i:30;s:36:\"handlers/views_handler_field_url.inc\";i:31;s:33:\"handlers/views_handler_filter.inc\";i:32;s:50:\"handlers/views_handler_filter_boolean_operator.inc\";i:33;s:57:\"handlers/views_handler_filter_boolean_operator_string.inc\";i:34;s:41:\"handlers/views_handler_filter_combine.inc\";i:35;s:38:\"handlers/views_handler_filter_date.inc\";i:36;s:42:\"handlers/views_handler_filter_equality.inc\";i:37;s:47:\"handlers/views_handler_filter_entity_bundle.inc\";i:38;s:50:\"handlers/views_handler_filter_group_by_numeric.inc\";i:39;s:45:\"handlers/views_handler_filter_in_operator.inc\";i:40;s:45:\"handlers/views_handler_filter_many_to_one.inc\";i:41;s:41:\"handlers/views_handler_filter_numeric.inc\";i:42;s:40:\"handlers/views_handler_filter_string.inc\";i:43;s:48:\"handlers/views_handler_filter_fields_compare.inc\";i:44;s:39:\"handlers/views_handler_relationship.inc\";i:45;s:53:\"handlers/views_handler_relationship_groupwise_max.inc\";i:46;s:31:\"handlers/views_handler_sort.inc\";i:47;s:36:\"handlers/views_handler_sort_date.inc\";i:48;s:39:\"handlers/views_handler_sort_formula.inc\";i:49;s:48:\"handlers/views_handler_sort_group_by_numeric.inc\";i:50;s:46:\"handlers/views_handler_sort_menu_hierarchy.inc\";i:51;s:38:\"handlers/views_handler_sort_random.inc\";i:52;s:17:\"includes/base.inc\";i:53;s:21:\"includes/handlers.inc\";i:54;s:20:\"includes/plugins.inc\";i:55;s:17:\"includes/view.inc\";i:56;s:60:\"modules/aggregator/views_handler_argument_aggregator_fid.inc\";i:57;s:60:\"modules/aggregator/views_handler_argument_aggregator_iid.inc\";i:58;s:69:\"modules/aggregator/views_handler_argument_aggregator_category_cid.inc\";i:59;s:64:\"modules/aggregator/views_handler_field_aggregator_title_link.inc\";i:60;s:62:\"modules/aggregator/views_handler_field_aggregator_category.inc\";i:61;s:70:\"modules/aggregator/views_handler_field_aggregator_item_description.inc\";i:62;s:57:\"modules/aggregator/views_handler_field_aggregator_xss.inc\";i:63;s:67:\"modules/aggregator/views_handler_filter_aggregator_category_cid.inc\";i:64;s:54:\"modules/aggregator/views_plugin_row_aggregator_rss.inc\";i:65;s:56:\"modules/book/views_plugin_argument_default_book_root.inc\";i:66;s:59:\"modules/comment/views_handler_argument_comment_user_uid.inc\";i:67;s:47:\"modules/comment/views_handler_field_comment.inc\";i:68;s:53:\"modules/comment/views_handler_field_comment_depth.inc\";i:69;s:52:\"modules/comment/views_handler_field_comment_link.inc\";i:70;s:60:\"modules/comment/views_handler_field_comment_link_approve.inc\";i:71;s:59:\"modules/comment/views_handler_field_comment_link_delete.inc\";i:72;s:57:\"modules/comment/views_handler_field_comment_link_edit.inc\";i:73;s:58:\"modules/comment/views_handler_field_comment_link_reply.inc\";i:74;s:57:\"modules/comment/views_handler_field_comment_node_link.inc\";i:75;s:56:\"modules/comment/views_handler_field_comment_username.inc\";i:76;s:61:\"modules/comment/views_handler_field_ncs_last_comment_name.inc\";i:77;s:56:\"modules/comment/views_handler_field_ncs_last_updated.inc\";i:78;s:52:\"modules/comment/views_handler_field_node_comment.inc\";i:79;s:57:\"modules/comment/views_handler_field_node_new_comments.inc\";i:80;s:62:\"modules/comment/views_handler_field_last_comment_timestamp.inc\";i:81;s:57:\"modules/comment/views_handler_filter_comment_user_uid.inc\";i:82;s:57:\"modules/comment/views_handler_filter_ncs_last_updated.inc\";i:83;s:53:\"modules/comment/views_handler_filter_node_comment.inc\";i:84;s:53:\"modules/comment/views_handler_sort_comment_thread.inc\";i:85;s:60:\"modules/comment/views_handler_sort_ncs_last_comment_name.inc\";i:86;s:55:\"modules/comment/views_handler_sort_ncs_last_updated.inc\";i:87;s:48:\"modules/comment/views_plugin_row_comment_rss.inc\";i:88;s:49:\"modules/comment/views_plugin_row_comment_view.inc\";i:89;s:52:\"modules/contact/views_handler_field_contact_link.inc\";i:90;s:43:\"modules/field/views_handler_field_field.inc\";i:91;s:59:\"modules/field/views_handler_relationship_entity_reverse.inc\";i:92;s:51:\"modules/field/views_handler_argument_field_list.inc\";i:93;s:57:\"modules/field/views_handler_filter_field_list_boolean.inc\";i:94;s:58:\"modules/field/views_handler_argument_field_list_string.inc\";i:95;s:49:\"modules/field/views_handler_filter_field_list.inc\";i:96;s:57:\"modules/filter/views_handler_field_filter_format_name.inc\";i:97;s:52:\"modules/locale/views_handler_field_node_language.inc\";i:98;s:53:\"modules/locale/views_handler_filter_node_language.inc\";i:99;s:54:\"modules/locale/views_handler_argument_locale_group.inc\";i:100;s:57:\"modules/locale/views_handler_argument_locale_language.inc\";i:101;s:51:\"modules/locale/views_handler_field_locale_group.inc\";i:102;s:54:\"modules/locale/views_handler_field_locale_language.inc\";i:103;s:55:\"modules/locale/views_handler_field_locale_link_edit.inc\";i:104;s:52:\"modules/locale/views_handler_filter_locale_group.inc\";i:105;s:55:\"modules/locale/views_handler_filter_locale_language.inc\";i:106;s:54:\"modules/locale/views_handler_filter_locale_version.inc\";i:107;s:51:\"modules/locale/views_handler_sort_node_language.inc\";i:108;s:53:\"modules/node/views_handler_argument_dates_various.inc\";i:109;s:53:\"modules/node/views_handler_argument_node_language.inc\";i:110;s:48:\"modules/node/views_handler_argument_node_nid.inc\";i:111;s:49:\"modules/node/views_handler_argument_node_type.inc\";i:112;s:48:\"modules/node/views_handler_argument_node_vid.inc\";i:113;s:57:\"modules/node/views_handler_argument_node_uid_revision.inc\";i:114;s:59:\"modules/node/views_handler_field_history_user_timestamp.inc\";i:115;s:41:\"modules/node/views_handler_field_node.inc\";i:116;s:46:\"modules/node/views_handler_field_node_link.inc\";i:117;s:53:\"modules/node/views_handler_field_node_link_delete.inc\";i:118;s:51:\"modules/node/views_handler_field_node_link_edit.inc\";i:119;s:50:\"modules/node/views_handler_field_node_revision.inc\";i:120;s:55:\"modules/node/views_handler_field_node_revision_link.inc\";i:121;s:62:\"modules/node/views_handler_field_node_revision_link_delete.inc\";i:122;s:62:\"modules/node/views_handler_field_node_revision_link_revert.inc\";i:123;s:46:\"modules/node/views_handler_field_node_path.inc\";i:124;s:46:\"modules/node/views_handler_field_node_type.inc\";i:125;s:55:\"modules/node/views_handler_field_node_version_count.inc\";i:126;s:60:\"modules/node/views_handler_filter_history_user_timestamp.inc\";i:127;s:49:\"modules/node/views_handler_filter_node_access.inc\";i:128;s:49:\"modules/node/views_handler_filter_node_status.inc\";i:129;s:47:\"modules/node/views_handler_filter_node_type.inc\";i:130;s:55:\"modules/node/views_handler_filter_node_uid_revision.inc\";i:131;s:56:\"modules/node/views_handler_filter_node_version_count.inc\";i:132;s:54:\"modules/node/views_handler_sort_node_version_count.inc\";i:133;s:51:\"modules/node/views_plugin_argument_default_node.inc\";i:134;s:52:\"modules/node/views_plugin_argument_validate_node.inc\";i:135;s:42:\"modules/node/views_plugin_row_node_rss.inc\";i:136;s:43:\"modules/node/views_plugin_row_node_view.inc\";i:137;s:52:\"modules/profile/views_handler_field_profile_date.inc\";i:138;s:52:\"modules/profile/views_handler_field_profile_list.inc\";i:139;s:58:\"modules/profile/views_handler_filter_profile_selection.inc\";i:140;s:48:\"modules/search/views_handler_argument_search.inc\";i:141;s:51:\"modules/search/views_handler_field_search_score.inc\";i:142;s:46:\"modules/search/views_handler_filter_search.inc\";i:143;s:50:\"modules/search/views_handler_sort_search_score.inc\";i:144;s:47:\"modules/search/views_plugin_row_search_view.inc\";i:145;s:57:\"modules/statistics/views_handler_field_accesslog_path.inc\";i:146;s:65:\"modules/statistics/views_handler_field_node_counter_timestamp.inc\";i:147;s:61:\"modules/statistics/views_handler_field_statistics_numeric.inc\";i:148;s:50:\"modules/system/views_handler_argument_file_fid.inc\";i:149;s:43:\"modules/system/views_handler_field_file.inc\";i:150;s:53:\"modules/system/views_handler_field_file_extension.inc\";i:151;s:52:\"modules/system/views_handler_field_file_filemime.inc\";i:152;s:47:\"modules/system/views_handler_field_file_uri.inc\";i:153;s:50:\"modules/system/views_handler_field_file_status.inc\";i:154;s:51:\"modules/system/views_handler_filter_file_status.inc\";i:155;s:52:\"modules/taxonomy/views_handler_argument_taxonomy.inc\";i:156;s:57:\"modules/taxonomy/views_handler_argument_term_node_tid.inc\";i:157;s:63:\"modules/taxonomy/views_handler_argument_term_node_tid_depth.inc\";i:158;s:68:\"modules/taxonomy/views_handler_argument_term_node_tid_depth_join.inc\";i:159;s:72:\"modules/taxonomy/views_handler_argument_term_node_tid_depth_modifier.inc\";i:160;s:58:\"modules/taxonomy/views_handler_argument_vocabulary_vid.inc\";i:161;s:67:\"modules/taxonomy/views_handler_argument_vocabulary_machine_name.inc\";i:162;s:49:\"modules/taxonomy/views_handler_field_taxonomy.inc\";i:163;s:54:\"modules/taxonomy/views_handler_field_term_node_tid.inc\";i:164;s:55:\"modules/taxonomy/views_handler_field_term_link_edit.inc\";i:165;s:55:\"modules/taxonomy/views_handler_filter_term_node_tid.inc\";i:166;s:61:\"modules/taxonomy/views_handler_filter_term_node_tid_depth.inc\";i:167;s:66:\"modules/taxonomy/views_handler_filter_term_node_tid_depth_join.inc\";i:168;s:56:\"modules/taxonomy/views_handler_filter_vocabulary_vid.inc\";i:169;s:65:\"modules/taxonomy/views_handler_filter_vocabulary_machine_name.inc\";i:170;s:62:\"modules/taxonomy/views_handler_relationship_node_term_data.inc\";i:171;s:65:\"modules/taxonomy/views_plugin_argument_validate_taxonomy_term.inc\";i:172;s:63:\"modules/taxonomy/views_plugin_argument_default_taxonomy_tid.inc\";i:173;s:67:\"modules/tracker/views_handler_argument_tracker_comment_user_uid.inc\";i:174;s:65:\"modules/tracker/views_handler_filter_tracker_comment_user_uid.inc\";i:175;s:65:\"modules/tracker/views_handler_filter_tracker_boolean_operator.inc\";i:176;s:51:\"modules/system/views_handler_filter_system_type.inc\";i:177;s:56:\"modules/translation/views_handler_argument_node_tnid.inc\";i:178;s:63:\"modules/translation/views_handler_field_node_link_translate.inc\";i:179;s:65:\"modules/translation/views_handler_field_node_translation_link.inc\";i:180;s:54:\"modules/translation/views_handler_filter_node_tnid.inc\";i:181;s:60:\"modules/translation/views_handler_filter_node_tnid_child.inc\";i:182;s:62:\"modules/translation/views_handler_relationship_translation.inc\";i:183;s:48:\"modules/user/views_handler_argument_user_uid.inc\";i:184;s:55:\"modules/user/views_handler_argument_users_roles_rid.inc\";i:185;s:41:\"modules/user/views_handler_field_user.inc\";i:186;s:50:\"modules/user/views_handler_field_user_language.inc\";i:187;s:46:\"modules/user/views_handler_field_user_link.inc\";i:188;s:53:\"modules/user/views_handler_field_user_link_cancel.inc\";i:189;s:51:\"modules/user/views_handler_field_user_link_edit.inc\";i:190;s:46:\"modules/user/views_handler_field_user_mail.inc\";i:191;s:46:\"modules/user/views_handler_field_user_name.inc\";i:192;s:53:\"modules/user/views_handler_field_user_permissions.inc\";i:193;s:49:\"modules/user/views_handler_field_user_picture.inc\";i:194;s:47:\"modules/user/views_handler_field_user_roles.inc\";i:195;s:50:\"modules/user/views_handler_filter_user_current.inc\";i:196;s:47:\"modules/user/views_handler_filter_user_name.inc\";i:197;s:54:\"modules/user/views_handler_filter_user_permissions.inc\";i:198;s:48:\"modules/user/views_handler_filter_user_roles.inc\";i:199;s:59:\"modules/user/views_plugin_argument_default_current_user.inc\";i:200;s:51:\"modules/user/views_plugin_argument_default_user.inc\";i:201;s:52:\"modules/user/views_plugin_argument_validate_user.inc\";i:202;s:43:\"modules/user/views_plugin_row_user_view.inc\";i:203;s:31:\"plugins/views_plugin_access.inc\";i:204;s:36:\"plugins/views_plugin_access_none.inc\";i:205;s:36:\"plugins/views_plugin_access_perm.inc\";i:206;s:36:\"plugins/views_plugin_access_role.inc\";i:207;s:41:\"plugins/views_plugin_argument_default.inc\";i:208;s:45:\"plugins/views_plugin_argument_default_php.inc\";i:209;s:47:\"plugins/views_plugin_argument_default_fixed.inc\";i:210;s:45:\"plugins/views_plugin_argument_default_raw.inc\";i:211;s:42:\"plugins/views_plugin_argument_validate.inc\";i:212;s:50:\"plugins/views_plugin_argument_validate_numeric.inc\";i:213;s:46:\"plugins/views_plugin_argument_validate_php.inc\";i:214;s:30:\"plugins/views_plugin_cache.inc\";i:215;s:35:\"plugins/views_plugin_cache_none.inc\";i:216;s:35:\"plugins/views_plugin_cache_time.inc\";i:217;s:32:\"plugins/views_plugin_display.inc\";i:218;s:43:\"plugins/views_plugin_display_attachment.inc\";i:219;s:38:\"plugins/views_plugin_display_block.inc\";i:220;s:40:\"plugins/views_plugin_display_default.inc\";i:221;s:38:\"plugins/views_plugin_display_embed.inc\";i:222;s:41:\"plugins/views_plugin_display_extender.inc\";i:223;s:37:\"plugins/views_plugin_display_feed.inc\";i:224;s:37:\"plugins/views_plugin_display_page.inc\";i:225;s:43:\"plugins/views_plugin_exposed_form_basic.inc\";i:226;s:37:\"plugins/views_plugin_exposed_form.inc\";i:227;s:52:\"plugins/views_plugin_exposed_form_input_required.inc\";i:228;s:42:\"plugins/views_plugin_localization_core.inc\";i:229;s:37:\"plugins/views_plugin_localization.inc\";i:230;s:42:\"plugins/views_plugin_localization_none.inc\";i:231;s:30:\"plugins/views_plugin_pager.inc\";i:232;s:35:\"plugins/views_plugin_pager_full.inc\";i:233;s:35:\"plugins/views_plugin_pager_mini.inc\";i:234;s:35:\"plugins/views_plugin_pager_none.inc\";i:235;s:35:\"plugins/views_plugin_pager_some.inc\";i:236;s:30:\"plugins/views_plugin_query.inc\";i:237;s:38:\"plugins/views_plugin_query_default.inc\";i:238;s:28:\"plugins/views_plugin_row.inc\";i:239;s:35:\"plugins/views_plugin_row_fields.inc\";i:240;s:39:\"plugins/views_plugin_row_rss_fields.inc\";i:241;s:30:\"plugins/views_plugin_style.inc\";i:242;s:38:\"plugins/views_plugin_style_default.inc\";i:243;s:35:\"plugins/views_plugin_style_grid.inc\";i:244;s:35:\"plugins/views_plugin_style_list.inc\";i:245;s:40:\"plugins/views_plugin_style_jump_menu.inc\";i:246;s:38:\"plugins/views_plugin_style_mapping.inc\";i:247;s:34:\"plugins/views_plugin_style_rss.inc\";i:248;s:38:\"plugins/views_plugin_style_summary.inc\";i:249;s:48:\"plugins/views_plugin_style_summary_jump_menu.inc\";i:250;s:50:\"plugins/views_plugin_style_summary_unformatted.inc\";i:251;s:36:\"plugins/views_plugin_style_table.inc\";i:252;s:34:\"tests/handlers/views_handlers.test\";i:253;s:43:\"tests/handlers/views_handler_area_text.test\";i:254;s:47:\"tests/handlers/views_handler_argument_null.test\";i:255;s:49:\"tests/handlers/views_handler_argument_string.test\";i:256;s:39:\"tests/handlers/views_handler_field.test\";i:257;s:47:\"tests/handlers/views_handler_field_boolean.test\";i:258;s:46:\"tests/handlers/views_handler_field_custom.test\";i:259;s:47:\"tests/handlers/views_handler_field_counter.test\";i:260;s:44:\"tests/handlers/views_handler_field_date.test\";i:261;s:54:\"tests/handlers/views_handler_field_file_extension.test\";i:262;s:49:\"tests/handlers/views_handler_field_file_size.test\";i:263;s:44:\"tests/handlers/views_handler_field_math.test\";i:264;s:43:\"tests/handlers/views_handler_field_url.test\";i:265;s:43:\"tests/handlers/views_handler_field_xss.test\";i:266;s:48:\"tests/handlers/views_handler_filter_combine.test\";i:267;s:45:\"tests/handlers/views_handler_filter_date.test\";i:268;s:49:\"tests/handlers/views_handler_filter_equality.test\";i:269;s:52:\"tests/handlers/views_handler_filter_in_operator.test\";i:270;s:48:\"tests/handlers/views_handler_filter_numeric.test\";i:271;s:47:\"tests/handlers/views_handler_filter_string.test\";i:272;s:45:\"tests/handlers/views_handler_sort_random.test\";i:273;s:43:\"tests/handlers/views_handler_sort_date.test\";i:274;s:38:\"tests/handlers/views_handler_sort.test\";i:275;s:46:\"tests/test_handlers/views_test_area_access.inc\";i:276;s:60:\"tests/test_plugins/views_test_plugin_access_test_dynamic.inc\";i:277;s:59:\"tests/test_plugins/views_test_plugin_access_test_static.inc\";i:278;s:59:\"tests/test_plugins/views_test_plugin_style_test_mapping.inc\";i:279;s:39:\"tests/plugins/views_plugin_display.test\";i:280;s:46:\"tests/styles/views_plugin_style_jump_menu.test\";i:281;s:36:\"tests/styles/views_plugin_style.test\";i:282;s:41:\"tests/styles/views_plugin_style_base.test\";i:283;s:44:\"tests/styles/views_plugin_style_mapping.test\";i:284;s:48:\"tests/styles/views_plugin_style_unformatted.test\";i:285;s:23:\"tests/views_access.test\";i:286;s:24:\"tests/views_analyze.test\";i:287;s:22:\"tests/views_basic.test\";i:288;s:33:\"tests/views_argument_default.test\";i:289;s:35:\"tests/views_argument_validator.test\";i:290;s:29:\"tests/views_exposed_form.test\";i:291;s:31:\"tests/field/views_fieldapi.test\";i:292;s:25:\"tests/views_glossary.test\";i:293;s:24:\"tests/views_groupby.test\";i:294;s:25:\"tests/views_handlers.test\";i:295;s:23:\"tests/views_module.test\";i:296;s:22:\"tests/views_pager.test\";i:297;s:40:\"tests/views_plugin_localization_test.inc\";i:298;s:29:\"tests/views_translatable.test\";i:299;s:22:\"tests/views_query.test\";i:300;s:24:\"tests/views_upgrade.test\";i:301;s:34:\"tests/views_test.views_default.inc\";i:302;s:58:\"tests/comment/views_handler_argument_comment_user_uid.test\";i:303;s:56:\"tests/comment/views_handler_filter_comment_user_uid.test\";i:304;s:45:\"tests/node/views_node_revision_relations.test\";i:305;s:61:\"tests/taxonomy/views_handler_relationship_node_term_data.test\";i:306;s:45:\"tests/user/views_handler_field_user_name.test\";i:307;s:43:\"tests/user/views_user_argument_default.test\";i:308;s:44:\"tests/user/views_user_argument_validate.test\";i:309;s:26:\"tests/user/views_user.test\";i:310;s:22:\"tests/views_cache.test\";i:311;s:21:\"tests/views_view.test\";i:312;s:19:\"tests/views_ui.test\";}s:7:\"version\";s:8:\"7.x-3.16\";s:7:\"project\";s:5:\"views\";s:9:\"datestamp\";s:10:\"1491158591\";s:5:\"mtime\";i:1491158591;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/views/views_ui.module','views_ui','module','',1,0,0,0,'a:13:{s:4:\"name\";s:8:\"Views UI\";s:11:\"description\";s:93:\"Administrative interface to views. Without this module, you cannot create or edit your views.\";s:7:\"package\";s:5:\"Views\";s:4:\"core\";s:3:\"7.x\";s:9:\"configure\";s:21:\"admin/structure/views\";s:12:\"dependencies\";a:1:{i:0;s:5:\"views\";}s:5:\"files\";a:2:{i:0;s:15:\"views_ui.module\";i:1;s:57:\"plugins/views_wizard/views_ui_base_views_wizard.class.php\";}s:7:\"version\";s:8:\"7.x-3.16\";s:7:\"project\";s:5:\"views\";s:9:\"datestamp\";s:10:\"1491158591\";s:5:\"mtime\";i:1491158591;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/views_bulk_operations/actions_permissions.module','actions_permissions','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:25:\"Actions permissions (VBO)\";s:11:\"description\";s:84:\"Provides permission-based access control for actions. Used by Views Bulk Operations.\";s:7:\"package\";s:14:\"Administration\";s:4:\"core\";s:3:\"7.x\";s:7:\"version\";s:7:\"7.x-3.2\";s:7:\"project\";s:21:\"views_bulk_operations\";s:9:\"datestamp\";s:10:\"1387798183\";s:5:\"mtime\";i:1499928385;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/views_bulk_operations/views_bulk_operations.module','views_bulk_operations','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:21:\"Views Bulk Operations\";s:11:\"description\";s:74:\"Provides a way of selecting multiple rows and applying operations to them.\";s:12:\"dependencies\";a:2:{i:0;s:6:\"entity\";i:1;s:5:\"views\";}s:7:\"package\";s:5:\"Views\";s:4:\"core\";s:3:\"7.x\";s:3:\"php\";s:5:\"5.2.9\";s:5:\"files\";a:2:{i:0;s:38:\"plugins/operation_types/base.class.php\";i:1;s:56:\"views/views_bulk_operations_handler_field_operations.inc\";}s:7:\"version\";s:7:\"7.x-3.2\";s:7:\"project\";s:21:\"views_bulk_operations\";s:9:\"datestamp\";s:10:\"1387798183\";s:5:\"mtime\";i:1499928385;s:9:\"bootstrap\";i:0;}'),('sites/all/modules/views_fieldsets/views_fieldsets.module','views_fieldsets','module','',1,0,0,0,'a:12:{s:4:\"name\";s:15:\"Views fieldsets\";s:11:\"description\";s:44:\"Output several Views fields into a fieldset.\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:5:\"Views\";s:12:\"dependencies\";a:1:{i:0;s:5:\"views\";}s:5:\"files\";a:1:{i:0;s:48:\"views/views_fieldsets_fieldset_field_handler.inc\";}s:7:\"version\";s:7:\"7.x-1.3\";s:7:\"project\";s:15:\"views_fieldsets\";s:9:\"datestamp\";s:10:\"1425515886\";s:5:\"mtime\";i:1499928385;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/views_field_view/views_field_view.module','views_field_view','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:16:\"Views Field View\";s:11:\"description\";s:36:\"Embeds a view inside a view as field\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:5:\"Views\";s:12:\"dependencies\";a:1:{i:0;s:5:\"views\";}s:5:\"files\";a:2:{i:0;s:39:\"views_field_view_handler_field_view.inc\";i:1;s:27:\"tests/views_field_view.test\";}s:7:\"version\";s:7:\"7.x-1.1\";s:7:\"project\";s:16:\"views_field_view\";s:9:\"datestamp\";s:10:\"1369511162\";s:5:\"mtime\";i:1499928385;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/views_slideshow/contrib/views_slideshow_cycle/views_slideshow_cycle.module','views_slideshow_cycle','module','',1,0,0,0,'a:12:{s:4:\"name\";s:22:\"Views Slideshow: Cycle\";s:11:\"description\";s:50:\"Adds a Rotating slideshow mode to Views Slideshow.\";s:12:\"dependencies\";a:2:{i:0;s:15:\"views_slideshow\";i:1;s:9:\"libraries\";}s:7:\"package\";s:5:\"Views\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:3:{i:0;s:28:\"views_slideshow_cycle.module\";i:1;s:41:\"views_slideshow_cycle.views_slideshow.inc\";i:2;s:37:\"theme/views_slideshow_cycle.theme.inc\";}s:7:\"version\";s:7:\"7.x-3.1\";s:7:\"project\";s:15:\"views_slideshow\";s:9:\"datestamp\";s:10:\"1382584826\";s:5:\"mtime\";i:1499928385;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/views_slideshow/views_slideshow.module','views_slideshow','module','',1,0,0,0,'a:12:{s:4:\"name\";s:15:\"Views Slideshow\";s:11:\"description\";s:155:\"Provides a View style that displays rows as a jQuery slideshow.  This is an API and requires Views Slideshow Cycle or another module that supports the API.\";s:12:\"dependencies\";a:1:{i:0;s:13:\"views (>=3.0)\";}s:7:\"package\";s:5:\"Views\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:4:{i:0;s:22:\"views_slideshow.module\";i:1;s:31:\"theme/views_slideshow.theme.inc\";i:2;s:25:\"views_slideshow.views.inc\";i:3;s:42:\"views_slideshow_plugin_style_slideshow.inc\";}s:7:\"version\";s:7:\"7.x-3.1\";s:7:\"project\";s:15:\"views_slideshow\";s:9:\"datestamp\";s:10:\"1382584826\";s:5:\"mtime\";i:1499928385;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/votingapi/votingapi.module','votingapi','module','',1,0,7203,0,'a:13:{s:4:\"name\";s:10:\"Voting API\";s:11:\"description\";s:47:\"Provides a shared voting API for other modules.\";s:7:\"package\";s:6:\"Voting\";s:4:\"core\";s:3:\"7.x\";s:9:\"configure\";s:29:\"admin/config/search/votingapi\";s:5:\"files\";a:4:{i:0;s:20:\"tests/votingapi.test\";i:1;s:45:\"views/votingapi_views_handler_field_value.inc\";i:2;s:47:\"views/votingapi_views_handler_sort_nullable.inc\";i:3;s:46:\"views/votingapi_views_handler_relationship.inc\";}s:7:\"version\";s:8:\"7.x-2.12\";s:7:\"project\";s:9:\"votingapi\";s:9:\"datestamp\";s:10:\"1407995929\";s:5:\"mtime\";i:1499928385;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/webform/webform.module','webform','module','',1,0,7430,-1,'a:14:{s:4:\"name\";s:7:\"Webform\";s:11:\"description\";s:49:\"Enables the creation of forms and questionnaires.\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:7:\"Webform\";s:9:\"configure\";s:28:\"admin/config/content/webform\";s:3:\"php\";s:3:\"5.3\";s:12:\"dependencies\";a:2:{i:0;s:6:\"ctools\";i:1;s:5:\"views\";}s:17:\"test_dependencies\";a:1:{i:0;s:5:\"token\";}s:5:\"files\";a:27:{i:0;s:40:\"includes/webform.webformconditionals.inc\";i:1;s:49:\"includes/exporters/webform_exporter_delimited.inc\";i:2;s:55:\"includes/exporters/webform_exporter_excel_delimited.inc\";i:3;s:50:\"includes/exporters/webform_exporter_excel_xlsx.inc\";i:4;s:39:\"includes/exporters/webform_exporter.inc\";i:5;s:43:\"views/webform_handler_area_result_pager.inc\";i:6;s:41:\"views/webform_handler_field_form_body.inc\";i:7;s:40:\"views/webform_handler_field_is_draft.inc\";i:8;s:46:\"views/webform_handler_field_node_link_edit.inc\";i:9;s:49:\"views/webform_handler_field_node_link_results.inc\";i:10;s:48:\"views/webform_handler_field_submission_count.inc\";i:11;s:47:\"views/webform_handler_field_submission_data.inc\";i:12;s:47:\"views/webform_handler_field_submission_link.inc\";i:13;s:46:\"views/webform_handler_field_webform_status.inc\";i:14;s:41:\"views/webform_handler_filter_is_draft.inc\";i:15;s:48:\"views/webform_handler_filter_submission_data.inc\";i:16;s:47:\"views/webform_handler_filter_webform_status.inc\";i:17;s:38:\"views/webform_handler_numeric_data.inc\";i:18;s:54:\"views/webform_handler_relationship_submission_data.inc\";i:19;s:44:\"views/webform_plugin_row_submission_view.inc\";i:20;s:23:\"views/webform.views.inc\";i:21;s:36:\"tests/WebformComponentsTestCase.test\";i:22;s:38:\"tests/WebformConditionalsTestCase.test\";i:23;s:33:\"tests/WebformGeneralTestCase.test\";i:24;s:37:\"tests/WebformPermissionsTestCase.test\";i:25;s:36:\"tests/WebformSubmissionTestCase.test\";i:26;s:26:\"tests/WebformTestCase.test\";}s:7:\"version\";s:8:\"7.x-4.15\";s:7:\"project\";s:7:\"webform\";s:9:\"datestamp\";s:10:\"1492107249\";s:5:\"mtime\";i:1492107249;s:9:\"bootstrap\";i:0;}'),('sites/all/modules/webform_hints/webform_hints.module','webform_hints','module','',1,0,0,0,'a:13:{s:4:\"name\";s:13:\"Webform Hints\";s:11:\"description\";s:93:\"Turns field labels into placeholder hints on Webform textareas, textfields, and email fields.\";s:7:\"package\";s:7:\"Webform\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:2:{i:0;s:7:\"webform\";i:1;s:17:\"libraries (>=2.x)\";}s:9:\"configure\";s:34:\"admin/config/content/webform-hints\";s:7:\"version\";s:7:\"7.x-1.5\";s:7:\"project\";s:13:\"webform_hints\";s:9:\"datestamp\";s:10:\"1407952128\";s:5:\"mtime\";i:1499928385;s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/wee_shortcode/wee_shortcode.module','wee_shortcode','module','',1,0,0,0,'a:10:{s:4:\"name\";s:29:\"Extra Shortcode For Bootstrap\";s:11:\"description\";s:41:\"Provides bootstrap component to contents.\";s:7:\"package\";s:9:\"Shortcode\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:1:{i:0;s:9:\"shortcode\";}s:5:\"mtime\";i:1499928385;s:7:\"version\";N;s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/we_content_migration/we_content_migration.module','we_content_migration','module','',1,0,0,0,'a:12:{s:4:\"name\";s:17:\"Content Migration\";s:11:\"description\";s:29:\"Migrate Content for Drupal 7.\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:17:\"Content Migration\";s:7:\"version\";s:11:\"7.x-1.x-dev\";s:7:\"project\";s:20:\"we_content_migration\";s:9:\"datestamp\";s:10:\"1499677744\";s:5:\"mtime\";i:1499652544;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/wysiwyg/tests/wysiwyg_test.module','wysiwyg_test','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:15:\"Wysiwyg testing\";s:11:\"description\";s:50:\"Tests Wysiwyg module functionality. Do not enable.\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:7:\"Testing\";s:6:\"hidden\";b:1;s:12:\"dependencies\";a:1:{i:0;s:7:\"wysiwyg\";}s:5:\"files\";a:1:{i:0;s:19:\"wysiwyg_test.module\";}s:7:\"version\";s:7:\"7.x-2.2\";s:7:\"project\";s:7:\"wysiwyg\";s:9:\"datestamp\";s:10:\"1349213776\";s:5:\"mtime\";i:1499928385;s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/wysiwyg/wysiwyg.module','wysiwyg','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:7:\"Wysiwyg\";s:11:\"description\";s:48:\"Allows to edit content with client-side editors.\";s:7:\"package\";s:14:\"User interface\";s:4:\"core\";s:3:\"7.x\";s:9:\"configure\";s:28:\"admin/config/content/wysiwyg\";s:5:\"files\";a:2:{i:0;s:14:\"wysiwyg.module\";i:1;s:18:\"tests/wysiwyg.test\";}s:7:\"version\";s:7:\"7.x-2.2\";s:7:\"project\";s:7:\"wysiwyg\";s:9:\"datestamp\";s:10:\"1349213776\";s:5:\"mtime\";i:1499928385;s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/themes/forum_plus/css/advanced_forum/plus/plus.info','plus','theme','themes/engines/phptemplate/phptemplate.engine',0,0,-1,0,'a:18:{s:4:\"name\";s:4:\"Plus\";s:11:\"description\";s:43:\"Based on the Blue Lagoon colors of Garland.\";s:7:\"version\";s:7:\"7.x-2.3\";s:10:\"base style\";s:5:\"naked\";s:4:\"core\";s:3:\"7.x\";s:7:\"project\";s:14:\"advanced_forum\";s:9:\"datestamp\";s:10:\"1373223651\";s:6:\"engine\";s:11:\"phptemplate\";s:7:\"regions\";a:12:{s:13:\"sidebar_first\";s:12:\"Left sidebar\";s:14:\"sidebar_second\";s:13:\"Right sidebar\";s:7:\"content\";s:7:\"Content\";s:6:\"header\";s:6:\"Header\";s:6:\"footer\";s:6:\"Footer\";s:11:\"highlighted\";s:11:\"Highlighted\";s:4:\"help\";s:4:\"Help\";s:8:\"page_top\";s:8:\"Page top\";s:11:\"page_bottom\";s:11:\"Page bottom\";s:14:\"dashboard_main\";s:16:\"Dashboard (main)\";s:17:\"dashboard_sidebar\";s:19:\"Dashboard (sidebar)\";s:18:\"dashboard_inactive\";s:20:\"Dashboard (inactive)\";}s:8:\"features\";a:9:{i:0;s:4:\"logo\";i:1;s:7:\"favicon\";i:2;s:4:\"name\";i:3;s:6:\"slogan\";i:4;s:17:\"node_user_picture\";i:5;s:20:\"comment_user_picture\";i:6;s:25:\"comment_user_verification\";i:7;s:9:\"main_menu\";i:8;s:14:\"secondary_menu\";}s:10:\"screenshot\";s:66:\"sites/all/themes/forum_plus/css/advanced_forum/plus/screenshot.png\";s:3:\"php\";s:5:\"5.2.4\";s:11:\"stylesheets\";a:0:{}s:7:\"scripts\";a:0:{}s:5:\"mtime\";i:1499928385;s:15:\"overlay_regions\";a:5:{i:0;s:14:\"dashboard_main\";i:1;s:17:\"dashboard_sidebar\";i:2;s:18:\"dashboard_inactive\";i:3;s:7:\"content\";i:4;s:4:\"help\";}s:14:\"regions_hidden\";a:2:{i:0;s:8:\"page_top\";i:1;s:11:\"page_bottom\";}s:28:\"overlay_supplemental_regions\";a:1:{i:0;s:11:\"page_bottom\";}}'),('sites/all/themes/forum_plus/forum_plus.info','forum_plus','theme','themes/engines/phptemplate/phptemplate.engine',1,0,-1,0,'a:20:{s:4:\"name\";s:10:\"Forum Plus\";s:11:\"description\";s:23:\"Theme for the Companies\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:6:\"engine\";s:11:\"phptemplate\";s:11:\"stylesheets\";a:1:{s:3:\"all\";a:3:{s:34:\"vendor/bootstrap/css/bootstrap.css\";s:62:\"sites/all/themes/forum_plus/vendor/bootstrap/css/bootstrap.css\";s:40:\"vendor/bootstrap/css/bootstrap-theme.css\";s:68:\"sites/all/themes/forum_plus/vendor/bootstrap/css/bootstrap-theme.css\";s:14:\"css/styles.css\";s:42:\"sites/all/themes/forum_plus/css/styles.css\";}}s:7:\"scripts\";a:8:{s:32:\"vendor/bootstrap/js/bootstrap.js\";s:60:\"sites/all/themes/forum_plus/vendor/bootstrap/js/bootstrap.js\";s:26:\"js/jquery.smooth-scroll.js\";s:54:\"sites/all/themes/forum_plus/js/jquery.smooth-scroll.js\";s:19:\"js/jquery.cookie.js\";s:47:\"sites/all/themes/forum_plus/js/jquery.cookie.js\";s:24:\"js/jquery.matchHeight.js\";s:52:\"sites/all/themes/forum_plus/js/jquery.matchHeight.js\";s:12:\"js/moment.js\";s:40:\"sites/all/themes/forum_plus/js/moment.js\";s:20:\"js/accordion_menu.js\";s:48:\"sites/all/themes/forum_plus/js/accordion_menu.js\";s:13:\"js/weebpal.js\";s:41:\"sites/all/themes/forum_plus/js/weebpal.js\";s:16:\"js/forum_plus.js\";s:44:\"sites/all/themes/forum_plus/js/forum_plus.js\";}s:8:\"features\";a:7:{i:0;s:4:\"logo\";i:1;s:4:\"name\";i:2;s:6:\"slogan\";i:3;s:17:\"node_user_picture\";i:4;s:20:\"comment_user_picture\";i:5;s:25:\"comment_user_verification\";i:6;s:7:\"favicon\";}s:7:\"regions\";a:25:{s:8:\"headline\";s:8:\"Headline\";s:6:\"header\";s:6:\"Header\";s:9:\"main_menu\";s:9:\"Main Menu\";s:9:\"slideshow\";s:9:\"Slideshow\";s:4:\"help\";s:4:\"Help\";s:8:\"page_top\";s:8:\"Page top\";s:11:\"page_bottom\";s:11:\"Page bottom\";s:11:\"highlighted\";s:11:\"Highlighted\";s:8:\"featured\";s:8:\"Featured\";s:7:\"content\";s:7:\"Content\";s:13:\"sidebar_first\";s:13:\"Sidebar first\";s:14:\"sidebar_second\";s:14:\"Sidebar second\";s:7:\"welcome\";s:7:\"Welcome\";s:11:\"panel_first\";s:11:\"Panel First\";s:12:\"panel_second\";s:12:\"Panel Second\";s:11:\"panel_third\";s:11:\"Panel Third\";s:4:\"gmap\";s:4:\"GMap\";s:14:\"panel_footer_1\";s:14:\"Panel Footer 1\";s:14:\"panel_footer_2\";s:14:\"Panel Footer 2\";s:14:\"panel_footer_3\";s:14:\"Panel Footer 3\";s:14:\"panel_footer_4\";s:14:\"Panel Footer 4\";s:6:\"footer\";s:6:\"Footer\";s:14:\"dashboard_main\";s:16:\"Dashboard (main)\";s:17:\"dashboard_sidebar\";s:19:\"Dashboard (sidebar)\";s:18:\"dashboard_inactive\";s:20:\"Dashboard (inactive)\";}s:8:\"settings\";a:7:{s:19:\"sidebar_first_width\";s:1:\"3\";s:20:\"sidebar_second_width\";s:1:\"3\";s:20:\"panel_footer_1_width\";s:1:\"3\";s:20:\"panel_footer_2_width\";s:1:\"3\";s:20:\"panel_footer_3_width\";s:1:\"3\";s:20:\"panel_footer_4_width\";s:1:\"3\";s:20:\"layout_width_default\";s:4:\"1200\";}s:5:\"skins\";a:3:{s:3:\"red\";s:3:\"Red\";s:6:\"yellow\";s:6:\"Yellow\";s:5:\"green\";s:5:\"Green\";}s:7:\"plugins\";a:1:{s:14:\"advanced_forum\";a:1:{s:6:\"styles\";s:23:\"css/advanced_forum/plus\";}}s:11:\"backgrounds\";a:7:{s:4:\"bg-1\";s:12:\"Background 1\";s:4:\"bg-2\";s:12:\"Background 2\";s:4:\"bg-3\";s:12:\"Background 3\";s:4:\"bg-4\";s:12:\"Background 4\";s:4:\"bg-5\";s:12:\"Background 5\";s:4:\"bg-6\";s:12:\"Background 6\";s:4:\"bg-7\";s:12:\"Background 7\";}s:6:\"layout\";a:1:{s:12:\"layout-boxed\";s:12:\"Boxed Layout\";}s:10:\"screenshot\";s:42:\"sites/all/themes/forum_plus/screenshot.png\";s:3:\"php\";s:5:\"5.2.4\";s:5:\"mtime\";i:1499928385;s:15:\"overlay_regions\";a:5:{i:0;s:14:\"dashboard_main\";i:1;s:17:\"dashboard_sidebar\";i:2;s:18:\"dashboard_inactive\";i:3;s:7:\"content\";i:4;s:4:\"help\";}s:14:\"regions_hidden\";a:2:{i:0;s:8:\"page_top\";i:1;s:11:\"page_bottom\";}s:28:\"overlay_supplemental_regions\";a:1:{i:0;s:11:\"page_bottom\";}}'),('sites/all/themes/we_backend/we_backend.info','we_backend','theme','themes/engines/phptemplate/phptemplate.engine',1,0,-1,0,'a:15:{s:4:\"name\";s:21:\"WeebPal Backend theme\";s:11:\"description\";s:26:\"Backend theme from WeebPal\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:6:\"engine\";s:11:\"phptemplate\";s:11:\"stylesheets\";a:1:{s:3:\"all\";a:1:{s:20:\"assets/css/style.css\";s:48:\"sites/all/themes/we_backend/assets/css/style.css\";}}s:7:\"scripts\";a:1:{s:20:\"assets/js/scripts.js\";s:48:\"sites/all/themes/we_backend/assets/js/scripts.js\";}s:8:\"features\";a:7:{i:0;s:4:\"logo\";i:1;s:4:\"name\";i:2;s:6:\"slogan\";i:3;s:17:\"node_user_picture\";i:4;s:20:\"comment_user_picture\";i:5;s:25:\"comment_user_verification\";i:6;s:7:\"favicon\";}s:7:\"regions\";a:10:{s:6:\"header\";s:6:\"Header\";s:11:\"highlighted\";s:11:\"Highlighted\";s:4:\"help\";s:4:\"Help\";s:7:\"content\";s:7:\"Content\";s:13:\"sidebar_first\";s:13:\"Sidebar first\";s:14:\"sidebar_second\";s:14:\"Sidebar second\";s:6:\"footer\";s:6:\"Footer\";s:14:\"dashboard_main\";s:16:\"Dashboard (main)\";s:17:\"dashboard_sidebar\";s:19:\"Dashboard (sidebar)\";s:18:\"dashboard_inactive\";s:20:\"Dashboard (inactive)\";}s:10:\"screenshot\";s:42:\"sites/all/themes/we_backend/screenshot.png\";s:3:\"php\";s:5:\"5.2.4\";s:5:\"mtime\";i:1499643480;s:15:\"overlay_regions\";a:5:{i:0;s:14:\"dashboard_main\";i:1;s:17:\"dashboard_sidebar\";i:2;s:18:\"dashboard_inactive\";i:3;s:7:\"content\";i:4;s:4:\"help\";}s:14:\"regions_hidden\";a:2:{i:0;s:8:\"page_top\";i:1;s:11:\"page_bottom\";}s:28:\"overlay_supplemental_regions\";a:1:{i:0;s:11:\"page_bottom\";}}'),('themes/bartik/bartik.info','bartik','theme','themes/engines/phptemplate/phptemplate.engine',1,0,-1,0,'a:19:{s:4:\"name\";s:6:\"Bartik\";s:11:\"description\";s:48:\"A flexible, recolorable theme with many regions.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:11:\"stylesheets\";a:2:{s:3:\"all\";a:3:{s:14:\"css/layout.css\";s:28:\"themes/bartik/css/layout.css\";s:13:\"css/style.css\";s:27:\"themes/bartik/css/style.css\";s:14:\"css/colors.css\";s:28:\"themes/bartik/css/colors.css\";}s:5:\"print\";a:1:{s:13:\"css/print.css\";s:27:\"themes/bartik/css/print.css\";}}s:7:\"regions\";a:20:{s:6:\"header\";s:6:\"Header\";s:4:\"help\";s:4:\"Help\";s:8:\"page_top\";s:8:\"Page top\";s:11:\"page_bottom\";s:11:\"Page bottom\";s:11:\"highlighted\";s:11:\"Highlighted\";s:8:\"featured\";s:8:\"Featured\";s:7:\"content\";s:7:\"Content\";s:13:\"sidebar_first\";s:13:\"Sidebar first\";s:14:\"sidebar_second\";s:14:\"Sidebar second\";s:14:\"triptych_first\";s:14:\"Triptych first\";s:15:\"triptych_middle\";s:15:\"Triptych middle\";s:13:\"triptych_last\";s:13:\"Triptych last\";s:18:\"footer_firstcolumn\";s:19:\"Footer first column\";s:19:\"footer_secondcolumn\";s:20:\"Footer second column\";s:18:\"footer_thirdcolumn\";s:19:\"Footer third column\";s:19:\"footer_fourthcolumn\";s:20:\"Footer fourth column\";s:6:\"footer\";s:6:\"Footer\";s:14:\"dashboard_main\";s:16:\"Dashboard (main)\";s:17:\"dashboard_sidebar\";s:19:\"Dashboard (sidebar)\";s:18:\"dashboard_inactive\";s:20:\"Dashboard (inactive)\";}s:8:\"settings\";a:1:{s:20:\"shortcut_module_link\";s:1:\"0\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:6:\"engine\";s:11:\"phptemplate\";s:8:\"features\";a:9:{i:0;s:4:\"logo\";i:1;s:7:\"favicon\";i:2;s:4:\"name\";i:3;s:6:\"slogan\";i:4;s:17:\"node_user_picture\";i:5;s:20:\"comment_user_picture\";i:6;s:25:\"comment_user_verification\";i:7;s:9:\"main_menu\";i:8;s:14:\"secondary_menu\";}s:10:\"screenshot\";s:28:\"themes/bartik/screenshot.png\";s:3:\"php\";s:5:\"5.2.4\";s:7:\"scripts\";a:0:{}s:5:\"mtime\";i:1498069849;s:15:\"overlay_regions\";a:5:{i:0;s:14:\"dashboard_main\";i:1;s:17:\"dashboard_sidebar\";i:2;s:18:\"dashboard_inactive\";i:3;s:7:\"content\";i:4;s:4:\"help\";}s:14:\"regions_hidden\";a:2:{i:0;s:8:\"page_top\";i:1;s:11:\"page_bottom\";}s:28:\"overlay_supplemental_regions\";a:1:{i:0;s:11:\"page_bottom\";}}'),('themes/garland/garland.info','garland','theme','themes/engines/phptemplate/phptemplate.engine',0,0,-1,0,'a:19:{s:4:\"name\";s:7:\"Garland\";s:11:\"description\";s:111:\"A multi-column theme which can be configured to modify colors and switch between fixed and fluid width layouts.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:11:\"stylesheets\";a:2:{s:3:\"all\";a:1:{s:9:\"style.css\";s:24:\"themes/garland/style.css\";}s:5:\"print\";a:1:{s:9:\"print.css\";s:24:\"themes/garland/print.css\";}}s:8:\"settings\";a:1:{s:13:\"garland_width\";s:5:\"fluid\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:6:\"engine\";s:11:\"phptemplate\";s:7:\"regions\";a:12:{s:13:\"sidebar_first\";s:12:\"Left sidebar\";s:14:\"sidebar_second\";s:13:\"Right sidebar\";s:7:\"content\";s:7:\"Content\";s:6:\"header\";s:6:\"Header\";s:6:\"footer\";s:6:\"Footer\";s:11:\"highlighted\";s:11:\"Highlighted\";s:4:\"help\";s:4:\"Help\";s:8:\"page_top\";s:8:\"Page top\";s:11:\"page_bottom\";s:11:\"Page bottom\";s:14:\"dashboard_main\";s:16:\"Dashboard (main)\";s:17:\"dashboard_sidebar\";s:19:\"Dashboard (sidebar)\";s:18:\"dashboard_inactive\";s:20:\"Dashboard (inactive)\";}s:8:\"features\";a:9:{i:0;s:4:\"logo\";i:1;s:7:\"favicon\";i:2;s:4:\"name\";i:3;s:6:\"slogan\";i:4;s:17:\"node_user_picture\";i:5;s:20:\"comment_user_picture\";i:6;s:25:\"comment_user_verification\";i:7;s:9:\"main_menu\";i:8;s:14:\"secondary_menu\";}s:10:\"screenshot\";s:29:\"themes/garland/screenshot.png\";s:3:\"php\";s:5:\"5.2.4\";s:7:\"scripts\";a:0:{}s:5:\"mtime\";i:1498069849;s:15:\"overlay_regions\";a:5:{i:0;s:14:\"dashboard_main\";i:1;s:17:\"dashboard_sidebar\";i:2;s:18:\"dashboard_inactive\";i:3;s:7:\"content\";i:4;s:4:\"help\";}s:14:\"regions_hidden\";a:2:{i:0;s:8:\"page_top\";i:1;s:11:\"page_bottom\";}s:28:\"overlay_supplemental_regions\";a:1:{i:0;s:11:\"page_bottom\";}}'),('themes/seven/seven.info','seven','theme','themes/engines/phptemplate/phptemplate.engine',1,0,-1,0,'a:19:{s:4:\"name\";s:5:\"Seven\";s:11:\"description\";s:65:\"A simple one-column, tableless, fluid width administration theme.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:11:\"stylesheets\";a:1:{s:6:\"screen\";a:2:{s:9:\"reset.css\";s:22:\"themes/seven/reset.css\";s:9:\"style.css\";s:22:\"themes/seven/style.css\";}}s:8:\"settings\";a:1:{s:20:\"shortcut_module_link\";s:1:\"1\";}s:7:\"regions\";a:8:{s:7:\"content\";s:7:\"Content\";s:4:\"help\";s:4:\"Help\";s:8:\"page_top\";s:8:\"Page top\";s:11:\"page_bottom\";s:11:\"Page bottom\";s:13:\"sidebar_first\";s:13:\"First sidebar\";s:14:\"dashboard_main\";s:16:\"Dashboard (main)\";s:17:\"dashboard_sidebar\";s:19:\"Dashboard (sidebar)\";s:18:\"dashboard_inactive\";s:20:\"Dashboard (inactive)\";}s:14:\"regions_hidden\";a:3:{i:0;s:13:\"sidebar_first\";i:1;s:8:\"page_top\";i:2;s:11:\"page_bottom\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:6:\"engine\";s:11:\"phptemplate\";s:8:\"features\";a:9:{i:0;s:4:\"logo\";i:1;s:7:\"favicon\";i:2;s:4:\"name\";i:3;s:6:\"slogan\";i:4;s:17:\"node_user_picture\";i:5;s:20:\"comment_user_picture\";i:6;s:25:\"comment_user_verification\";i:7;s:9:\"main_menu\";i:8;s:14:\"secondary_menu\";}s:10:\"screenshot\";s:27:\"themes/seven/screenshot.png\";s:3:\"php\";s:5:\"5.2.4\";s:7:\"scripts\";a:0:{}s:5:\"mtime\";i:1498069849;s:15:\"overlay_regions\";a:5:{i:0;s:14:\"dashboard_main\";i:1;s:17:\"dashboard_sidebar\";i:2;s:18:\"dashboard_inactive\";i:3;s:7:\"content\";i:4;s:4:\"help\";}s:28:\"overlay_supplemental_regions\";a:1:{i:0;s:11:\"page_bottom\";}}'),('themes/stark/stark.info','stark','theme','themes/engines/phptemplate/phptemplate.engine',0,0,-1,0,'a:18:{s:4:\"name\";s:5:\"Stark\";s:11:\"description\";s:208:\"This theme demonstrates Drupal\'s default HTML markup and CSS styles. To learn how to build your own theme and override Drupal\'s default code, see the <a href=\"http://drupal.org/theme-guide\">Theming Guide</a>.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.56\";s:4:\"core\";s:3:\"7.x\";s:11:\"stylesheets\";a:1:{s:3:\"all\";a:1:{s:10:\"layout.css\";s:23:\"themes/stark/layout.css\";}}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1498069849\";s:6:\"engine\";s:11:\"phptemplate\";s:7:\"regions\";a:12:{s:13:\"sidebar_first\";s:12:\"Left sidebar\";s:14:\"sidebar_second\";s:13:\"Right sidebar\";s:7:\"content\";s:7:\"Content\";s:6:\"header\";s:6:\"Header\";s:6:\"footer\";s:6:\"Footer\";s:11:\"highlighted\";s:11:\"Highlighted\";s:4:\"help\";s:4:\"Help\";s:8:\"page_top\";s:8:\"Page top\";s:11:\"page_bottom\";s:11:\"Page bottom\";s:14:\"dashboard_main\";s:16:\"Dashboard (main)\";s:17:\"dashboard_sidebar\";s:19:\"Dashboard (sidebar)\";s:18:\"dashboard_inactive\";s:20:\"Dashboard (inactive)\";}s:8:\"features\";a:9:{i:0;s:4:\"logo\";i:1;s:7:\"favicon\";i:2;s:4:\"name\";i:3;s:6:\"slogan\";i:4;s:17:\"node_user_picture\";i:5;s:20:\"comment_user_picture\";i:6;s:25:\"comment_user_verification\";i:7;s:9:\"main_menu\";i:8;s:14:\"secondary_menu\";}s:10:\"screenshot\";s:27:\"themes/stark/screenshot.png\";s:3:\"php\";s:5:\"5.2.4\";s:7:\"scripts\";a:0:{}s:5:\"mtime\";i:1498069849;s:15:\"overlay_regions\";a:5:{i:0;s:14:\"dashboard_main\";i:1;s:17:\"dashboard_sidebar\";i:2;s:18:\"dashboard_inactive\";i:3;s:7:\"content\";i:4;s:4:\"help\";}s:14:\"regions_hidden\";a:2:{i:0;s:8:\"page_top\";i:1;s:11:\"page_bottom\";}s:28:\"overlay_supplemental_regions\";a:1:{i:0;s:11:\"page_bottom\";}}');
/*!40000 ALTER TABLE `system` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `taxonomy_index`
--

DROP TABLE IF EXISTS `taxonomy_index`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `taxonomy_index` (
  `nid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The node.nid this record tracks.',
  `tid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The term ID.',
  `sticky` tinyint(4) DEFAULT '0' COMMENT 'Boolean indicating whether the node is sticky.',
  `created` int(11) NOT NULL DEFAULT '0' COMMENT 'The Unix timestamp when the node was created.',
  KEY `term_node` (`tid`,`sticky`,`created`),
  KEY `nid` (`nid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Maintains denormalized information about node/term...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `taxonomy_index`
--

LOCK TABLES `taxonomy_index` WRITE;
/*!40000 ALTER TABLE `taxonomy_index` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `taxonomy_index` VALUES (1,6,0,1404031643),(15,6,0,1405266314),(16,6,1,1405267481),(18,9,0,1405268124),(19,8,0,1405268196),(20,3,0,1405268456),(21,3,0,1405268526),(22,3,0,1405268575),(11,15,0,1404836269),(11,17,0,1404836269),(10,16,0,1404836182),(38,37,0,1407166386),(37,37,0,1407166253),(37,39,0,1407166253),(36,37,0,1407166039),(36,38,0,1407166039),(35,37,0,1407165961),(34,37,0,1405869873),(53,6,0,1408184897),(7,47,0,1407513536),(8,48,0,1407166819),(8,49,0,1407166819),(9,50,0,1407166373),(54,6,0,1408269165),(55,6,0,1408269327),(47,5,0,1407805139),(3,5,0,1404550214),(31,36,0,1406386042),(31,42,0,1406386042),(31,32,0,1406386042),(31,21,0,1406386042),(28,42,0,1406385654),(28,28,0,1406385654),(28,22,0,1406385654),(27,51,0,1406385599),(27,52,0,1406385599),(27,30,0,1406385599),(27,23,0,1406385599),(12,18,0,1405042769),(12,19,0,1405042769),(12,27,0,1405042769),(12,23,0,1405042769),(6,12,0,1404783238),(6,14,0,1404783238),(6,30,0,1404783238),(6,22,0,1404783238),(29,33,0,1406385737),(29,34,0,1406385737),(29,46,0,1406385737),(29,29,0,1406385737),(29,24,0,1406385737),(30,34,0,1406385981),(30,35,0,1406385981),(30,45,0,1406385981),(30,30,0,1406385981),(30,25,0,1406385981),(5,54,0,1404783192),(5,43,0,1404783192),(5,53,0,1404783192),(5,28,0,1404783192),(5,26,0,1404783192),(4,40,0,1404748836),(4,55,0,1404748836),(4,54,0,1404748836),(4,29,0,1404748836),(4,25,0,1404748836),(68,1,0,1442659410),(17,10,0,1405267880),(69,1,0,1443955525),(56,11,0,1443866870);
/*!40000 ALTER TABLE `taxonomy_index` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `taxonomy_menu`
--

DROP TABLE IF EXISTS `taxonomy_menu`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `taxonomy_menu` (
  `mlid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The taxonomy terms menu_link.mlid.',
  `tid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Tid that is linked to the mlid.',
  `vid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Vid for the tid.',
  PRIMARY KEY (`mlid`,`tid`),
  KEY `vid` (`vid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Links a taxonomy term to a menu item.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `taxonomy_menu`
--

LOCK TABLES `taxonomy_menu` WRITE;
/*!40000 ALTER TABLE `taxonomy_menu` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `taxonomy_menu` VALUES (533,23,3),(534,24,3),(535,21,3),(536,22,3),(537,26,3),(538,25,3),(539,20,3),(527,27,4),(528,28,4),(529,29,4),(530,31,4),(531,32,4),(532,30,4);
/*!40000 ALTER TABLE `taxonomy_menu` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `taxonomy_term_data`
--

DROP TABLE IF EXISTS `taxonomy_term_data`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `taxonomy_term_data` (
  `tid` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Primary Key: Unique term ID.',
  `vid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The taxonomy_vocabulary.vid of the vocabulary to which the term is assigned.',
  `name` varchar(255) NOT NULL DEFAULT '' COMMENT 'The term name.',
  `description` longtext COMMENT 'A description of the term.',
  `format` varchar(255) DEFAULT NULL COMMENT 'The filter_format.format of the description.',
  `weight` int(11) NOT NULL DEFAULT '0' COMMENT 'The weight of this term in relation to other terms.',
  `language` varchar(12) NOT NULL DEFAULT 'und',
  `i18n_tsid` int(10) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`tid`),
  KEY `taxonomy_tree` (`vid`,`weight`,`name`),
  KEY `vid_name` (`vid`,`name`),
  KEY `name` (`name`)
) ENGINE=InnoDB AUTO_INCREMENT=56 DEFAULT CHARSET=utf8 COMMENT='Stores term information.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `taxonomy_term_data`
--

LOCK TABLES `taxonomy_term_data` WRITE;
/*!40000 ALTER TABLE `taxonomy_term_data` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `taxonomy_term_data` VALUES (1,2,'Post installation','Post installation',NULL,0,'und',0),(2,2,'Helps and Supports','',NULL,8,'und',0),(3,2,'Before you start','Before you start',NULL,1,'und',0),(4,2,'General Disscusions','',NULL,9,'und',0),(5,2,'News and announcements','News and announcements',NULL,1,'und',0),(6,2,'General discussion','General discussion',NULL,0,'und',0),(7,2,'Services','',NULL,10,'und',0),(8,2,'Paid Drupal services','Consulting, contracts, RFPs, jobs, bounties, and more. ',NULL,0,'und',0),(9,2,'Hosting support','A forum for helping users host their Drupal site.',NULL,1,'und',0),(10,2,'Show off your Drupal site','Show off your Drupal site',NULL,2,'und',0),(11,2,'Installing Drupal','Having problems installing Drupal? See the Installation Guide for more detailed information.',NULL,2,'und',0),(12,1,'running',NULL,NULL,0,'und',0),(13,1,'healthy',NULL,NULL,0,'und',0),(14,1,'health',NULL,NULL,0,'und',0),(15,1,'flower',NULL,NULL,0,'und',0),(16,1,'beautiful pictures',NULL,NULL,0,'und',0),(17,1,'photography',NULL,NULL,0,'und',0),(18,1,'cars',NULL,NULL,0,'und',0),(19,1,'sports',NULL,NULL,0,'und',0),(20,3,'Wordpress','','filtered_html',0,'und',0),(21,3,'HTML','','filtered_html',0,'und',0),(22,3,'Marketing','','filtered_html',0,'und',0),(23,3,'CMS','','filtered_html',0,'und',0),(24,3,'eCommerce','','filtered_html',0,'und',0),(25,3,'PSD','','filtered_html',0,'und',0),(26,3,'Plugins','','filtered_html',0,'und',0),(27,4,'Documentation','','filtered_html',1,'und',0),(28,4,'Graphic design','','filtered_html',2,'und',0),(29,4,'Web development','','filtered_html',4,'und',0),(30,4,'Themes','','filtered_html',5,'und',0),(31,4,'Web maintenance','','filtered_html',0,'und',0),(32,4,'Web services','','filtered_html',1,'und',0),(33,1,'web',NULL,NULL,0,'und',0),(34,1,'design',NULL,NULL,0,'und',0),(35,1,'photoshop',NULL,NULL,0,'und',0),(36,1,'development',NULL,NULL,0,'und',0),(37,1,'video',NULL,NULL,0,'und',0),(38,1,'music',NULL,NULL,0,'und',0),(39,1,'staff picks',NULL,NULL,0,'und',0),(40,1,'images',NULL,NULL,0,'und',0),(41,1,'freestyle',NULL,NULL,0,'und',0),(42,1,'drupal themes',NULL,NULL,0,'und',0),(43,1,'news',NULL,NULL,0,'und',0),(44,1,'responsive designs',NULL,NULL,0,'und',0),(45,1,'onepage',NULL,NULL,0,'und',0),(46,1,'ecommerce',NULL,NULL,0,'und',0),(47,1,'travel',NULL,NULL,0,'und',0),(48,1,'skills',NULL,NULL,0,'und',0),(49,1,'self-education',NULL,NULL,0,'und',0),(50,1,'savings',NULL,NULL,0,'und',0),(51,1,'css3',NULL,NULL,0,'und',0),(52,1,'animation',NULL,NULL,0,'und',0),(53,1,'responsive',NULL,NULL,0,'und',0),(54,1,'themes',NULL,NULL,0,'und',0),(55,1,'drupal',NULL,NULL,0,'und',0);
/*!40000 ALTER TABLE `taxonomy_term_data` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `taxonomy_term_hierarchy`
--

DROP TABLE IF EXISTS `taxonomy_term_hierarchy`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `taxonomy_term_hierarchy` (
  `tid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Primary Key: The taxonomy_term_data.tid of the term.',
  `parent` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Primary Key: The taxonomy_term_data.tid of the term’s parent. 0 indicates no parent.',
  PRIMARY KEY (`tid`,`parent`),
  KEY `parent` (`parent`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Stores the hierarchical relationship between terms.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `taxonomy_term_hierarchy`
--

LOCK TABLES `taxonomy_term_hierarchy` WRITE;
/*!40000 ALTER TABLE `taxonomy_term_hierarchy` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `taxonomy_term_hierarchy` VALUES (2,0),(4,0),(7,0),(12,0),(13,0),(14,0),(15,0),(16,0),(17,0),(18,0),(19,0),(20,0),(21,0),(22,0),(23,0),(24,0),(25,0),(26,0),(27,0),(28,0),(29,0),(30,0),(33,0),(34,0),(35,0),(36,0),(37,0),(38,0),(39,0),(40,0),(41,0),(42,0),(43,0),(44,0),(45,0),(46,0),(47,0),(48,0),(49,0),(50,0),(51,0),(52,0),(53,0),(54,0),(55,0),(1,2),(3,2),(11,2),(5,4),(6,4),(10,4),(8,7),(9,7),(31,29),(32,29);
/*!40000 ALTER TABLE `taxonomy_term_hierarchy` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `taxonomy_vocabulary`
--

DROP TABLE IF EXISTS `taxonomy_vocabulary`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `taxonomy_vocabulary` (
  `vid` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Primary Key: Unique vocabulary ID.',
  `name` varchar(255) NOT NULL DEFAULT '' COMMENT 'Name of the vocabulary.',
  `machine_name` varchar(255) NOT NULL DEFAULT '' COMMENT 'The vocabulary machine name.',
  `description` longtext COMMENT 'Description of the vocabulary.',
  `hierarchy` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT 'The type of hierarchy allowed within the vocabulary. (0 = disabled, 1 = single, 2 = multiple)',
  `module` varchar(255) NOT NULL DEFAULT '' COMMENT 'The module which created the vocabulary.',
  `weight` int(11) NOT NULL DEFAULT '0' COMMENT 'The weight of this vocabulary in relation to other vocabularies.',
  `language` varchar(12) NOT NULL DEFAULT 'und',
  `i18n_mode` int(10) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`vid`),
  UNIQUE KEY `machine_name` (`machine_name`),
  KEY `list` (`weight`,`name`)
) ENGINE=InnoDB AUTO_INCREMENT=5 DEFAULT CHARSET=utf8 COMMENT='Stores vocabulary information.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `taxonomy_vocabulary`
--

LOCK TABLES `taxonomy_vocabulary` WRITE;
/*!40000 ALTER TABLE `taxonomy_vocabulary` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `taxonomy_vocabulary` VALUES (1,'Tags','tags','Use tags to group articles on similar topics into categories.',0,'taxonomy',0,'und',0),(2,'Forums','forums','Forum navigation vocabulary',1,'forum',-10,'und',0),(3,'Categories','categories','',0,'taxonomy',0,'und',0),(4,'Sections','sections','',0,'taxonomy',0,'und',0);
/*!40000 ALTER TABLE `taxonomy_vocabulary` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `token_custom`
--

DROP TABLE IF EXISTS `token_custom`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `token_custom` (
  `machine_name` varchar(32) NOT NULL COMMENT 'The token’s machine name',
  `name` varchar(128) NOT NULL COMMENT 'The token’s human readable name',
  `description` varchar(255) NOT NULL COMMENT 'The token’s description, as shown on the token listings',
  `type` varchar(128) NOT NULL COMMENT 'The token’s type, defining the context in which it will be available',
  `content` longtext NOT NULL COMMENT 'The content for the token',
  `format` varchar(255) DEFAULT 'php_code' COMMENT 'The format for the content on the token.',
  PRIMARY KEY (`machine_name`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='The database table for the Token Custom module.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `token_custom`
--

LOCK TABLES `token_custom` WRITE;
/*!40000 ALTER TABLE `token_custom` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `token_custom` VALUES ('comment-text-teaser','comment-text-teaser','comment text teaser','comment','<?php\r\n$entity_type = \'comment\';\r\n$entity = $data[\'comment\'];\r\n$wrapper = entity_metadata_wrapper($entity_type, $entity);\r\n\r\n  // Select the right field acoring to the entity type.\r\n  $field_name = $entity_type == \'node\' ? \'body\' : \'comment_body\';\r\n  $field_value = $wrapper->{$field_name}->value();\r\n\r\n  if (!$field_value) {\r\n    return;\r\n  }\r\n\r\n  // Get the safe value.\r\n  $field_value = $wrapper->{$field_name}->value->value();\r\n\r\n  $options = array(\r\n    \'max_length\' => 50,\r\n    \'html\' => true,\r\n  );\r\n  $trim_text = views_trim_text($options, $field_value);\r\n  $trim_text = strip_tags($trim_text);\r\n\r\n  // Checking if we need to add the \"Read more\" link.\r\n  if ($field_value != $trim_text) {\r\n    $uri = entity_uri($entity_type, $entity);\r\n    // Add a \"Read more\" before the closing <p>.\r\n    $trim_text .= \'... \' . l(t(\'Read more\'), $uri[\'path\'], $uri[\'options\']);\r\n  }\r\n\r\n  return $trim_text;\r\n?>','php_code');
/*!40000 ALTER TABLE `token_custom` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `url_alias`
--

DROP TABLE IF EXISTS `url_alias`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `url_alias` (
  `pid` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'A unique path alias identifier.',
  `source` varchar(255) NOT NULL DEFAULT '' COMMENT 'The Drupal path this alias is for; e.g. node/12.',
  `alias` varchar(255) NOT NULL DEFAULT '' COMMENT 'The alias for this path; e.g. title-of-the-story.',
  `language` varchar(12) NOT NULL DEFAULT '' COMMENT 'The language this alias is for; if ’und’, the alias will be used for unknown languages. Each Drupal path can have an alias for each supported language.',
  PRIMARY KEY (`pid`),
  KEY `alias_language_pid` (`alias`,`language`,`pid`),
  KEY `source_language_pid` (`source`,`language`,`pid`)
) ENGINE=InnoDB AUTO_INCREMENT=121 DEFAULT CHARSET=utf8 COMMENT='A list of URL aliases for Drupal paths; a user may visit...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `url_alias`
--

LOCK TABLES `url_alias` WRITE;
/*!40000 ALTER TABLE `url_alias` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `url_alias` VALUES (1,'node/9','blog/22-ways-save-money','und'),(2,'node/11','blog/best-drawing-art-books','und'),(3,'node/10','blog/how-pick-good-hostel','und'),(4,'node/8','blog/27-principles-teaching-yourself-anything','und'),(5,'node/7','blog/few-days-season-aspen','und'),(6,'node/6','article/hotel-luxury-drupal-themes','und'),(7,'node/4','article/54-living-room-decorating-ideas','und'),(8,'node/5','article/how-do-thoughts-form','und'),(9,'taxonomy/term/18','tags/cars','und'),(10,'taxonomy/term/19','tags/sports','und'),(11,'node/12','article/50-best-apps-and-websites-travelers','und'),(12,'taxonomy/term/20','categories/wordpress','und'),(13,'taxonomy/term/21','categories/html','und'),(14,'taxonomy/term/22','categories/marketing','und'),(15,'taxonomy/term/23','categories/cms','und'),(16,'taxonomy/term/24','categories/ecommerce','und'),(17,'taxonomy/term/25','categories/psd','und'),(18,'taxonomy/term/26','categories/plugins','und'),(19,'taxonomy/term/27','sections/documentation','und'),(20,'taxonomy/term/28','sections/graphic-design','und'),(21,'taxonomy/term/29','sections/web-development','und'),(22,'taxonomy/term/30','sections/themes','und'),(23,'taxonomy/term/31','sections/web-maintenance','und'),(24,'taxonomy/term/32','sections/web-services','und'),(25,'node/13','faq/praesent-nec-nisl-purus','en'),(26,'node/14','faq/praesent-congue-erat-massa','en'),(27,'node/15','forum/what-does-weebpal-do','und'),(28,'user/2','users/peter','und'),(29,'user/6','users/mical','und'),(30,'node/16','forum/headline-news','und'),(31,'node/17','forum/review-front-page-promotion-requests','und'),(32,'node/18','forum/hosting','und'),(33,'node/19','forum/installing-drush-shared-hosting-accounts','und'),(34,'node/20','forum/system-requirements','und'),(35,'node/21','forum/web-server','und'),(36,'node/22','forum/database-server','und'),(37,'node/23','page/basic-shortcodes','und'),(38,'node/24','page/tooltip','und'),(39,'node/25','page/video','und'),(40,'node/26','page/collapse','und'),(41,'node/27','article/35-reasons-rain-better-sunshine','und'),(42,'node/28','article/20-decorating-secrets','und'),(43,'taxonomy/term/33','tags/web','und'),(44,'node/29','article/here’s-how-much-it-costs-raise-child','und'),(45,'taxonomy/term/34','tags/design','und'),(46,'taxonomy/term/35','tags/photoshop','und'),(47,'node/30','article/7-exercises-will-transform-your-body','und'),(48,'taxonomy/term/36','tags/development','und'),(49,'node/31','article/31-healthy-foods-you-should-be-eating-now','und'),(51,'node/33','404-page','und'),(52,'user/1','users/admin','und'),(53,'blog/1','blogs/admin','und'),(54,'taxonomy/term/37','tags/video','und'),(55,'node/34','content/margaret-thank-you-very-much','und'),(56,'node/35','video/beautiful-light-music-easy-smooth-inspirational-long-playlist-relaxdaily-ocean-breeze','und'),(57,'taxonomy/term/38','tags/music','und'),(58,'node/36','video/one-direction-what-makes-you-beautiful-5-piano-guys-1-piano-thepianoguys','und'),(59,'taxonomy/term/39','tags/staff-picks','und'),(60,'node/37','video/san-juans-proven-here','und'),(61,'node/38','video/stop-motion','und'),(62,'node/39','megamenu','und'),(63,'node/40','contact-us','und'),(64,'node/41','contact-us-2','und'),(65,'node/42','page/color','und'),(66,'node/43','skins/default','und'),(67,'node/44','skins/red','und'),(68,'node/45','skins/yellow','und'),(69,'node/46','skins/dark','und'),(70,'taxonomy/term/40','tags/images','und'),(71,'taxonomy/term/41','tags/freestyle','und'),(72,'taxonomy/term/42','tags/drupal-themes','und'),(73,'taxonomy/term/43','tags/news','und'),(74,'taxonomy/term/44','tags/responsive-designs','und'),(75,'taxonomy/term/45','tags/onepage','und'),(76,'taxonomy/term/46','tags/ecommerce','und'),(77,'taxonomy/term/47','tags/travel','und'),(78,'taxonomy/term/48','tags/skills','und'),(79,'taxonomy/term/49','tags/self-education','und'),(80,'taxonomy/term/50','tags/savings','und'),(81,'node/47','forum/apple-launches-email-ad-campaign-focusing-productivity','und'),(82,'node/48','product/blog','und'),(83,'node/49','content/autox','und'),(84,'node/50','content/one-page','und'),(85,'node/51','content/pinteros','und'),(86,'node/52','content/zircon','und'),(87,'node/53','forum/8-project-management-tips','und'),(88,'user/7','users/jack','und'),(89,'node/54','forum/column-oriented-databases-does-bigtable-cassandra-belong-column-store-database','und'),(90,'node/55','forum/time-travel-why-are-people-future-not-time-traveling-our-period','und'),(91,'node/56','forum/drupal-installation','und'),(92,'node/57','skins/green','und'),(93,'taxonomy/term/51','tags/css3','und'),(94,'taxonomy/term/52','tags/animation','und'),(95,'node/58','faq/donec-vitae-sapien-ut','en'),(96,'node/59','faq/fusce-pulvinar-interdum-lectus-sed-tempor','en'),(97,'node/60','faq/lorem-ipsum-dolor-sit-amet-consectetuer-adipiscing-elit','en'),(98,'node/61','faq/aenean-posuere-tortor-sed-cursus-feugiat-nunc-augue-blandit-nunc','en'),(99,'node/62','faq/pellentesque-egestas-neque-sit-amet','en'),(100,'node/63','faq/suspendisse-enim-turpis-dictum-sed-iaculis-condimentum-nec-nisi','en'),(101,'node/64','faq/morbi-mollis-tellus-ac-sapien','en'),(102,'node/65','faq/proin-faucibus-arcu-quis-ante','en'),(103,'node/66','faq/curabitur-non-elit-faucibus-malesuada-elit-pellentesque-tellus','en'),(104,'node/67','faq/phasellus-enim-eros-dapibus-non-pulvinar-vel-condimentum-quis-felis','en'),(105,'taxonomy/term/53','tags/responsive','und'),(106,'taxonomy/term/54','tags/themes','und'),(107,'taxonomy/term/55','tags/drupal','und'),(108,'node/68','forum/headline-news-0','en'),(109,'node/69','forum/learn-d7-coding-or-d8','en'),(110,'forum/2','forums/helps-and-supports','und'),(111,'forum/1','forums/post-installation','und'),(112,'forum/3','forums/you-start','und'),(113,'forum/11','forums/installing-drupal','und'),(114,'forum/4','forums/general-disscusions','und'),(115,'forum/6','forums/general-discussion','und'),(116,'forum/5','forums/news-and-announcements','und'),(117,'forum/10','forums/show-your-drupal-site','und'),(118,'forum/7','forums/services','und'),(119,'forum/8','forums/paid-drupal-services','und'),(120,'forum/9','forums/hosting-support','und');
/*!40000 ALTER TABLE `url_alias` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `users`
--

DROP TABLE IF EXISTS `users`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `users` (
  `uid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Primary Key: Unique user ID.',
  `name` varchar(60) NOT NULL DEFAULT '' COMMENT 'Unique user name.',
  `pass` varchar(128) NOT NULL DEFAULT '' COMMENT 'User’s password (hashed).',
  `mail` varchar(254) DEFAULT '' COMMENT 'User’s e-mail address.',
  `theme` varchar(255) NOT NULL DEFAULT '' COMMENT 'User’s default theme.',
  `signature` varchar(255) NOT NULL DEFAULT '' COMMENT 'User’s signature.',
  `signature_format` varchar(255) DEFAULT NULL COMMENT 'The filter_format.format of the signature.',
  `created` int(11) NOT NULL DEFAULT '0' COMMENT 'Timestamp for when user was created.',
  `access` int(11) NOT NULL DEFAULT '0' COMMENT 'Timestamp for previous time user accessed the site.',
  `login` int(11) NOT NULL DEFAULT '0' COMMENT 'Timestamp for user’s last login.',
  `status` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'Whether the user is active(1) or blocked(0).',
  `timezone` varchar(32) DEFAULT NULL COMMENT 'User’s time zone.',
  `language` varchar(12) NOT NULL DEFAULT '' COMMENT 'User’s default language.',
  `picture` int(11) NOT NULL DEFAULT '0' COMMENT 'Foreign key: file_managed.fid of user’s picture.',
  `init` varchar(254) DEFAULT '' COMMENT 'E-mail address used for initial account creation.',
  `data` longblob COMMENT 'A serialized array of name value pairs that are related to the user. Any form values posted during user edit are stored and are loaded into the $user object during user_load(). Use of this field is discouraged and it will likely disappear in a future...',
  PRIMARY KEY (`uid`),
  UNIQUE KEY `name` (`name`),
  KEY `access` (`access`),
  KEY `created` (`created`),
  KEY `mail` (`mail`),
  KEY `picture` (`picture`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Stores user data.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `users`
--

LOCK TABLES `users` WRITE;
/*!40000 ALTER TABLE `users` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `users` VALUES (0,'','','','','',NULL,0,0,0,0,NULL,'',0,'',NULL),(1,'admin','$S$DCmO5bkt2ZmC6/suwlHvd/KAdLjJSEw39iH5yZjXXE9oqndEMdKm','admin@forum-plus.com','','<strong>Drupal Themes & Web Development</strong>','filtered_html',1402558817,1512620348,1512620348,1,'Asia/Krasnoyarsk','en',0,'admin@forum-plus.com','a:10:{s:7:\"contact\";i:1;s:7:\"overlay\";i:1;s:15:\"userpickit_type\";s:4:\"user\";s:8:\"gravatar\";i:1;s:16:\"ckeditor_default\";s:1:\"t\";s:20:\"ckeditor_show_toggle\";s:1:\"t\";s:14:\"ckeditor_width\";s:4:\"100%\";s:13:\"ckeditor_lang\";s:2:\"en\";s:18:\"ckeditor_auto_lang\";s:1:\"t\";s:11:\"remember_me\";b:1;}'),(2,'Peter','$S$D.iLj5Cpx6zz69ILahbI/8BPsAuY.eqr6gsy1cpGNJQysISDIPgJ','peter@mailinator.com','','','filtered_html',1404782568,1409929799,1409929093,1,'Asia/Krasnoyarsk','en',111,'peter@mailinator.com','a:3:{s:7:\"contact\";i:1;s:15:\"userpickit_type\";s:8:\"gravatar\";s:11:\"remember_me\";b:1;}'),(6,'Mical','$S$DN1D7nezujGfqPAlmYCxmY6RCil9QYqsmkD8MPHB/OIi0Esp.c6a','mical@mailinator.com','','Practice makes perfect!','filtered_html',1405266663,1408555290,1408185221,1,'America/Los_Angeles','en',110,'mical@mailinator.com','a:3:{s:7:\"contact\";i:1;s:15:\"userpickit_type\";s:18:\"gravatar_identicon\";s:11:\"remember_me\";b:1;}'),(7,'jack','$S$DIWUc7Fx4Mt0jydVDm4vQalM/ZXkRJjB1DcYb90MRvd2aSpjB6U8','jack@lvh.me','','','filtered_html',1408185635,1424835713,1424831692,1,'America/Los_Angeles','en',112,'jack@lvh.me','a:7:{s:7:\"contact\";i:1;s:11:\"remember_me\";b:1;s:16:\"ckeditor_default\";s:1:\"t\";s:20:\"ckeditor_show_toggle\";s:1:\"t\";s:14:\"ckeditor_width\";s:4:\"100%\";s:13:\"ckeditor_lang\";s:2:\"en\";s:18:\"ckeditor_auto_lang\";s:1:\"t\";}');
/*!40000 ALTER TABLE `users` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `users_roles`
--

DROP TABLE IF EXISTS `users_roles`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `users_roles` (
  `uid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Primary Key: users.uid for user.',
  `rid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Primary Key: role.rid for role.',
  PRIMARY KEY (`uid`,`rid`),
  KEY `rid` (`rid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Maps users to roles.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `users_roles`
--

LOCK TABLES `users_roles` WRITE;
/*!40000 ALTER TABLE `users_roles` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `users_roles` VALUES (1,3);
/*!40000 ALTER TABLE `users_roles` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `variable`
--

DROP TABLE IF EXISTS `variable`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `variable` (
  `name` varchar(128) NOT NULL DEFAULT '' COMMENT 'The name of the variable.',
  `value` longblob NOT NULL COMMENT 'The value of the variable.',
  PRIMARY KEY (`name`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Named variable/value pairs created by Drupal core or any...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `variable`
--

LOCK TABLES `variable` WRITE;
/*!40000 ALTER TABLE `variable` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `variable` VALUES ('additional_settings__active_tab','s:12:\"edit-context\";'),('additional_settings__active_tab_article','s:12:\"edit-comment\";'),('additional_settings__active_tab_blog','s:12:\"edit-display\";'),('additional_settings__active_tab_forum','s:12:\"edit-comment\";'),('additional_settings__active_tab_page','s:9:\"edit-menu\";'),('additional_settings__active_tab_products','s:12:\"edit-comment\";'),('additional_settings__active_tab_video','s:15:\"edit-submission\";'),('additional_settings__active_tab_webform','s:9:\"edit-menu\";'),('addtoany_additional_html','s:0:\"\";'),('addtoany_additional_html_placement','s:6:\"before\";'),('addtoany_additional_js','s:0:\"\";'),('addtoany_buttons_size','s:2:\"16\";'),('addtoany_custom_image','s:0:\"\";'),('addtoany_display_in_nodecont','i:0;'),('addtoany_display_in_nodelink','i:1;'),('addtoany_display_in_teasers','i:1;'),('addtoany_display_weight','s:2:\"40\";'),('addtoany_image','s:10:\"a2a_svg_32\";'),('addtoany_image_attributes','s:11:\"alt=\"Share\"\";'),('addtoany_link_text','s:0:\"\";'),('addtoany_nodetypes','a:5:{s:7:\"article\";s:7:\"article\";s:4:\"blog\";s:4:\"blog\";s:4:\"page\";i:0;s:4:\"book\";i:0;s:5:\"forum\";i:0;}'),('addtoany_no_3p','i:0;'),('admin_theme','s:10:\"we_backend\";'),('advanced_forum_add_local_task','i:1;'),('advanced_forum_collapsible_containers','s:6:\"toggle\";'),('advanced_forum_default_collapsed_list','a:0:{}'),('advanced_forum_disable_breadcrumbs','i:0;'),('advanced_forum_forum_image_field','s:0:\"\";'),('advanced_forum_forum_image_preset','s:0:\"\";'),('advanced_forum_get_new_comments','i:1;'),('advanced_forum_style','s:4:\"plus\";'),('advanced_forum_styled_node_types','a:1:{s:5:\"forum\";s:5:\"forum\";}'),('advanced_forum_style_all_comments','i:0;'),('advanced_forum_style_only_forum_tagged','i:1;'),('advanced_forum_style_teasers','i:1;'),('advanced_forum_topic_title_length','s:2:\"20\";'),('advanced_forum_user_picture_preset','s:0:\"\";'),('advanced_forum_views_as_tabs','i:1;'),('anonymous','s:9:\"Anonymous\";'),('book_allowed_types','a:1:{i:0;s:4:\"book\";}'),('book_child_type','s:4:\"book\";'),('cache_class_cache_ctools_css','s:14:\"CToolsCssCache\";'),('chosen_disable_search','i:1;'),('chosen_disable_search_threshold','s:1:\"0\";'),('chosen_jquery_selector','s:75:\"select#edit-order, select#edit-sort, .forum-tools select, select#edit-forum\";'),('chosen_minimum_multiple','s:2:\"20\";'),('chosen_minimum_single','s:1:\"0\";'),('chosen_minimum_width','s:3:\"170\";'),('chosen_no_results_text','s:16:\"No results match\";'),('chosen_placeholder_text_multiple','s:19:\"Choose some options\";'),('chosen_placeholder_text_single','s:16:\"Choose an option\";'),('chosen_search_contains','i:0;'),('chosen_use_theme','i:1;'),('clean_url','s:1:\"1\";'),('comment_anonymous_article','i:0;'),('comment_anonymous_blog','i:0;'),('comment_anonymous_forum','i:0;'),('comment_anonymous_page','i:0;'),('comment_anonymous_products','i:0;'),('comment_anonymous_video','i:0;'),('comment_anonymous_webform','i:0;'),('comment_article','s:1:\"2\";'),('comment_blog','s:1:\"2\";'),('comment_default_mode_article','i:1;'),('comment_default_mode_blog','i:1;'),('comment_default_mode_forum','i:1;'),('comment_default_mode_page','i:1;'),('comment_default_mode_products','i:1;'),('comment_default_mode_video','i:1;'),('comment_default_mode_webform','i:1;'),('comment_default_per_page_article','s:2:\"10\";'),('comment_default_per_page_blog','s:2:\"10\";'),('comment_default_per_page_forum','s:2:\"10\";'),('comment_default_per_page_page','s:2:\"50\";'),('comment_default_per_page_products','s:2:\"50\";'),('comment_default_per_page_video','s:2:\"50\";'),('comment_default_per_page_webform','s:2:\"50\";'),('comment_form_location_article','i:1;'),('comment_form_location_blog','i:1;'),('comment_form_location_forum','i:1;'),('comment_form_location_page','i:1;'),('comment_form_location_products','i:1;'),('comment_form_location_video','i:1;'),('comment_form_location_webform','i:1;'),('comment_forum','s:1:\"2\";'),('comment_page','s:1:\"0\";'),('comment_preview_article','s:1:\"1\";'),('comment_preview_blog','s:1:\"1\";'),('comment_preview_forum','s:1:\"1\";'),('comment_preview_page','s:1:\"1\";'),('comment_preview_products','s:1:\"1\";'),('comment_preview_video','s:1:\"1\";'),('comment_preview_webform','s:1:\"1\";'),('comment_products','s:1:\"2\";'),('comment_subject_field_article','i:1;'),('comment_subject_field_blog','i:1;'),('comment_subject_field_forum','i:1;'),('comment_subject_field_page','i:1;'),('comment_subject_field_products','i:1;'),('comment_subject_field_video','i:1;'),('comment_subject_field_webform','i:1;'),('comment_video','s:1:\"2\";'),('comment_webform','s:1:\"1\";'),('configurable_timezones','i:1;'),('contact_default_status','i:1;'),('context_block_rebuild_needed','b:1;'),('cron_key','s:43:\"1rX4m8BWJ3B8TQxVoHI9F-EGvxl2FYuNIZtDn38LQ_U\";'),('cron_last','i:1512620327;'),('css_js_query_string','s:6:\"p0kpbc\";'),('ctools_last_cron','i:1512620328;'),('date_api_use_iso8601','i:0;'),('date_api_version','s:3:\"7.2\";'),('date_db_tz_support','b:0;'),('date_default_timezone','s:16:\"Asia/Ho_Chi_Minh\";'),('date_first_day','s:1:\"0\";'),('default_nodes_main','s:1:\"4\";'),('drupal_http_request_fails','b:0;'),('drupal_private_key','s:43:\"oenbX80yz50sMvNkrJat_bw-sT7vOfyYn7X3jj90QZo\";'),('email__active_tab','s:24:\"edit-email-admin-created\";'),('empty_timezone_message','i:0;'),('entityreference:base-tables','a:11:{s:7:\"comment\";a:2:{i:0;s:7:\"comment\";i:1;s:3:\"cid\";}s:21:\"field_collection_item\";a:2:{i:0;s:21:\"field_collection_item\";i:1;s:7:\"item_id\";}s:16:\"i18n_translation\";a:2:{i:0;s:20:\"i18n_translation_set\";i:1;s:4:\"tsid\";}s:21:\"message_type_category\";a:2:{i:0;s:21:\"message_type_category\";i:1;s:2:\"id\";}s:12:\"message_type\";a:2:{i:0;s:12:\"message_type\";i:1;s:2:\"id\";}s:7:\"message\";a:2:{i:0;s:7:\"message\";i:1;s:3:\"mid\";}s:4:\"node\";a:2:{i:0;s:4:\"node\";i:1;s:3:\"nid\";}s:4:\"file\";a:2:{i:0;s:12:\"file_managed\";i:1;s:3:\"fid\";}s:13:\"taxonomy_term\";a:2:{i:0;s:18:\"taxonomy_term_data\";i:1;s:3:\"tid\";}s:19:\"taxonomy_vocabulary\";a:2:{i:0;s:19:\"taxonomy_vocabulary\";i:1;s:3:\"vid\";}s:4:\"user\";a:2:{i:0;s:5:\"users\";i:1;s:3:\"uid\";}}'),('entity_cache_tables_created','N;'),('faq_answer_label','s:2:\"A:\";'),('faq_back_to_top','s:11:\"Back to Top\";'),('faq_category_display','s:17:\"categories_inline\";'),('faq_default_sorting','s:4:\"DESC\";'),('faq_disable_node_links','i:1;'),('faq_display','s:11:\"hide_answer\";'),('faq_hide_qa_accordion','i:0;'),('faq_qa_mark','i:0;'),('faq_question_label','s:2:\"Q:\";'),('faq_question_length','s:4:\"long\";'),('faq_question_listing','s:2:\"ul\";'),('faq_question_long_form','i:1;'),('faq_show_expand_all','i:0;'),('faq_show_node_links','i:0;'),('faq_use_categories','b:0;'),('faq_use_teaser','i:0;'),('features_codecache','a:1:{s:15:\"message_example\";a:3:{s:8:\"variable\";s:32:\"5636e6d56fd3e60b04cd212e95fc7077\";s:5:\"field\";s:32:\"9249f09e7ee33a3aedbeee4a5c96d83a\";s:12:\"dependencies\";s:32:\"97920fdc586d57f0eb485cc4de377a63\";}}'),('features_ignored_orphans','a:0:{}'),('features_semaphore','a:0:{}'),('field_bundle_settings_comment__comment_node_forum','a:2:{s:10:\"view_modes\";a:2:{s:4:\"full\";a:1:{s:15:\"custom_settings\";b:0;}s:5:\"token\";a:1:{s:15:\"custom_settings\";b:0;}}s:12:\"extra_fields\";a:2:{s:4:\"form\";a:2:{s:6:\"author\";a:1:{s:6:\"weight\";s:1:\"0\";}s:7:\"subject\";a:1:{s:6:\"weight\";s:1:\"1\";}}s:7:\"display\";a:0:{}}}'),('field_bundle_settings_field_collection_item__field_extra_content','a:2:{s:10:\"view_modes\";a:2:{s:4:\"full\";a:1:{s:15:\"custom_settings\";b:0;}s:5:\"token\";a:1:{s:15:\"custom_settings\";b:0;}}s:12:\"extra_fields\";a:2:{s:4:\"form\";a:0:{}s:7:\"display\";a:0:{}}}'),('field_bundle_settings_message__example_create_comment','a:2:{s:10:\"view_modes\";a:1:{s:4:\"full\";a:1:{s:15:\"custom_settings\";b:1;}}s:12:\"extra_fields\";a:2:{s:4:\"form\";a:0:{}s:7:\"display\";a:3:{s:24:\"message__message_text__0\";a:2:{s:7:\"default\";a:2:{s:6:\"weight\";s:1:\"0\";s:7:\"visible\";b:1;}s:4:\"full\";a:2:{s:6:\"weight\";s:1:\"0\";s:7:\"visible\";b:1;}}s:24:\"message__message_text__1\";a:2:{s:7:\"default\";a:2:{s:6:\"weight\";s:1:\"1\";s:7:\"visible\";b:1;}s:4:\"full\";a:2:{s:6:\"weight\";s:1:\"1\";s:7:\"visible\";b:1;}}s:24:\"message__message_text__2\";a:2:{s:7:\"default\";a:2:{s:6:\"weight\";s:1:\"2\";s:7:\"visible\";b:1;}s:4:\"full\";a:2:{s:6:\"weight\";s:1:\"2\";s:7:\"visible\";b:1;}}}}}'),('field_bundle_settings_message__example_create_node','a:2:{s:10:\"view_modes\";a:2:{s:4:\"full\";a:1:{s:15:\"custom_settings\";b:1;}s:5:\"token\";a:1:{s:15:\"custom_settings\";b:0;}}s:12:\"extra_fields\";a:2:{s:4:\"form\";a:0:{}s:7:\"display\";a:4:{s:24:\"message__message_text__0\";a:2:{s:7:\"default\";a:2:{s:6:\"weight\";s:1:\"0\";s:7:\"visible\";b:1;}s:4:\"full\";a:2:{s:6:\"weight\";s:1:\"0\";s:7:\"visible\";b:1;}}s:24:\"message__message_text__1\";a:4:{s:28:\"message_notify_email_subject\";a:2:{s:7:\"visible\";b:0;s:6:\"weight\";i:0;}s:25:\"message_notify_email_body\";a:2:{s:7:\"visible\";b:1;s:6:\"weight\";i:0;}s:7:\"default\";a:2:{s:6:\"weight\";s:1:\"1\";s:7:\"visible\";b:1;}s:4:\"full\";a:2:{s:6:\"weight\";s:1:\"1\";s:7:\"visible\";b:1;}}s:33:\"field_comment_babble_comment_form\";a:2:{s:7:\"default\";a:2:{s:6:\"weight\";s:1:\"6\";s:7:\"visible\";b:0;}s:4:\"full\";a:2:{s:6:\"weight\";s:1:\"6\";s:7:\"visible\";b:0;}}s:31:\"field_comment_babble_host_links\";a:2:{s:7:\"default\";a:2:{s:6:\"weight\";s:1:\"2\";s:7:\"visible\";b:0;}s:4:\"full\";a:2:{s:6:\"weight\";s:1:\"2\";s:7:\"visible\";b:0;}}}}}'),('field_bundle_settings_message__example_user_register','a:2:{s:10:\"view_modes\";a:2:{s:4:\"full\";a:1:{s:15:\"custom_settings\";b:1;}s:5:\"token\";a:1:{s:15:\"custom_settings\";b:0;}}s:12:\"extra_fields\";a:2:{s:4:\"form\";a:0:{}s:7:\"display\";a:2:{s:24:\"message__message_text__0\";a:2:{s:7:\"default\";a:2:{s:6:\"weight\";s:1:\"0\";s:7:\"visible\";b:1;}s:4:\"full\";a:2:{s:6:\"weight\";s:1:\"0\";s:7:\"visible\";b:1;}}s:24:\"message__message_text__1\";a:3:{s:28:\"message_notify_email_subject\";a:2:{s:7:\"visible\";b:0;s:6:\"weight\";i:0;}s:25:\"message_notify_email_body\";a:2:{s:7:\"visible\";b:1;s:6:\"weight\";i:0;}s:4:\"full\";N;}}}}'),('field_bundle_settings_node__article','a:2:{s:10:\"view_modes\";a:7:{s:6:\"teaser\";a:1:{s:15:\"custom_settings\";b:1;}s:4:\"full\";a:1:{s:15:\"custom_settings\";b:0;}s:3:\"rss\";a:1:{s:15:\"custom_settings\";b:0;}s:12:\"search_index\";a:1:{s:15:\"custom_settings\";b:0;}s:13:\"search_result\";a:1:{s:15:\"custom_settings\";b:0;}s:5:\"print\";a:1:{s:15:\"custom_settings\";b:0;}s:5:\"token\";a:1:{s:15:\"custom_settings\";b:0;}}s:12:\"extra_fields\";a:2:{s:4:\"form\";a:2:{s:5:\"title\";a:1:{s:6:\"weight\";s:1:\"0\";}s:4:\"path\";a:1:{s:6:\"weight\";s:1:\"4\";}}s:7:\"display\";a:0:{}}}'),('field_bundle_settings_node__blog','a:2:{s:10:\"view_modes\";a:7:{s:6:\"teaser\";a:1:{s:15:\"custom_settings\";b:1;}s:4:\"full\";a:1:{s:15:\"custom_settings\";b:0;}s:3:\"rss\";a:1:{s:15:\"custom_settings\";b:0;}s:12:\"search_index\";a:1:{s:15:\"custom_settings\";b:0;}s:13:\"search_result\";a:1:{s:15:\"custom_settings\";b:0;}s:5:\"print\";a:1:{s:15:\"custom_settings\";b:0;}s:5:\"token\";a:1:{s:15:\"custom_settings\";b:0;}}s:12:\"extra_fields\";a:2:{s:4:\"form\";a:2:{s:5:\"title\";a:1:{s:6:\"weight\";s:1:\"0\";}s:4:\"path\";a:1:{s:6:\"weight\";s:1:\"5\";}}s:7:\"display\";a:0:{}}}'),('field_bundle_settings_node__forum','a:2:{s:10:\"view_modes\";a:7:{s:6:\"teaser\";a:1:{s:15:\"custom_settings\";b:1;}s:4:\"full\";a:1:{s:15:\"custom_settings\";b:0;}s:3:\"rss\";a:1:{s:15:\"custom_settings\";b:0;}s:12:\"search_index\";a:1:{s:15:\"custom_settings\";b:0;}s:13:\"search_result\";a:1:{s:15:\"custom_settings\";b:0;}s:5:\"print\";a:1:{s:15:\"custom_settings\";b:0;}s:5:\"token\";a:1:{s:15:\"custom_settings\";b:0;}}s:12:\"extra_fields\";a:2:{s:4:\"form\";a:2:{s:5:\"title\";a:1:{s:6:\"weight\";s:1:\"0\";}s:4:\"path\";a:1:{s:6:\"weight\";s:1:\"5\";}}s:7:\"display\";a:0:{}}}'),('field_bundle_settings_node__products','a:2:{s:10:\"view_modes\";a:0:{}s:12:\"extra_fields\";a:2:{s:4:\"form\";a:2:{s:5:\"title\";a:1:{s:6:\"weight\";s:2:\"-5\";}s:4:\"path\";a:1:{s:6:\"weight\";s:2:\"30\";}}s:7:\"display\";a:0:{}}}'),('field_bundle_settings_node__video','a:2:{s:10:\"view_modes\";a:7:{s:6:\"teaser\";a:1:{s:15:\"custom_settings\";b:1;}s:4:\"full\";a:1:{s:15:\"custom_settings\";b:0;}s:3:\"rss\";a:1:{s:15:\"custom_settings\";b:0;}s:12:\"search_index\";a:1:{s:15:\"custom_settings\";b:0;}s:13:\"search_result\";a:1:{s:15:\"custom_settings\";b:0;}s:5:\"print\";a:1:{s:15:\"custom_settings\";b:0;}s:5:\"token\";a:1:{s:15:\"custom_settings\";b:0;}}s:12:\"extra_fields\";a:2:{s:4:\"form\";a:2:{s:5:\"title\";a:1:{s:6:\"weight\";s:1:\"0\";}s:4:\"path\";a:1:{s:6:\"weight\";s:1:\"1\";}}s:7:\"display\";a:0:{}}}'),('field_bundle_settings_node__webform','a:2:{s:10:\"view_modes\";a:7:{s:6:\"teaser\";a:1:{s:15:\"custom_settings\";b:1;}s:4:\"full\";a:1:{s:15:\"custom_settings\";b:0;}s:3:\"rss\";a:1:{s:15:\"custom_settings\";b:0;}s:12:\"search_index\";a:1:{s:15:\"custom_settings\";b:0;}s:13:\"search_result\";a:1:{s:15:\"custom_settings\";b:0;}s:5:\"print\";a:1:{s:15:\"custom_settings\";b:0;}s:5:\"token\";a:1:{s:15:\"custom_settings\";b:0;}}s:12:\"extra_fields\";a:2:{s:4:\"form\";a:0:{}s:7:\"display\";a:1:{s:7:\"webform\";a:1:{s:7:\"default\";a:2:{s:6:\"weight\";s:1:\"0\";s:7:\"visible\";b:1;}}}}}'),('file_default_scheme','s:6:\"public\";'),('file_private_path','s:0:\"\";'),('file_public_path','s:19:\"sites/default/files\";'),('file_temporary_path','s:4:\"/tmp\";'),('filter_fallback_format','s:10:\"plain_text\";'),('fivestar_tags','s:4:\"vote\";'),('flexslider_version','s:3:\"2.2\";'),('forum_block_num_active','s:1:\"5\";'),('forum_block_num_new','s:1:\"2\";'),('forum_containers','a:3:{i:0;s:1:\"2\";i:1;s:1:\"4\";i:2;s:1:\"7\";}'),('forum_nav_vocabulary','s:1:\"2\";'),('install_profile','s:8:\"standard\";'),('install_task','s:4:\"done\";'),('install_time','i:1403797519;'),('javascript_parsed','a:31:{i:0;s:14:\"misc/drupal.js\";i:1;s:64:\"sites/all/modules/jquery_update/replace/jquery/1.8/jquery.min.js\";i:2;s:19:\"misc/jquery.once.js\";i:3;s:60:\"sites/all/themes/forum_plus/vendor/bootstrap/js/bootstrap.js\";i:4;s:54:\"sites/all/themes/forum_plus/js/jquery.smooth-scroll.js\";i:5;s:47:\"sites/all/themes/forum_plus/js/jquery.cookie.js\";i:6;s:52:\"sites/all/themes/forum_plus/js/jquery.matchHeight.js\";i:7;s:40:\"sites/all/themes/forum_plus/js/moment.js\";i:8;s:48:\"sites/all/themes/forum_plus/js/accordion_menu.js\";i:9;s:41:\"sites/all/themes/forum_plus/js/weebpal.js\";i:10;s:44:\"sites/all/themes/forum_plus/js/forum_plus.js\";i:11;s:68:\"sites/all/modules/jquery_update/replace/ui/external/jquery.cookie.js\";i:12;s:63:\"sites/all/modules/jquery_update/replace/misc/jquery.form.min.js\";i:13;s:16:\"misc/progress.js\";i:14;s:51:\"sites/all/modules/jquery_update/js/jquery_update.js\";i:15;s:12:\"misc/ajax.js\";i:16;s:76:\"sites/all/modules/jquery_update/replace/ui/ui/minified/jquery.ui.core.min.js\";i:17;s:36:\"sites/all/modules/ctools/js/modal.js\";i:18;s:53:\"sites/all/modules/modal_forms/js/modal_forms_popup.js\";i:19;s:53:\"sites/all/modules/modal_forms/js/modal_forms_login.js\";i:20;s:49:\"sites/all/libraries/ddslick/jquery.ddslick.min.js\";i:21;s:47:\"sites/all/libraries/chosen/chosen.jquery.min.js\";i:22;s:34:\"sites/all/modules/chosen/chosen.js\";i:23;s:48:\"sites/all/modules/lang_dropdown/lang_dropdown.js\";s:10:\"refresh:ar\";s:7:\"waiting\";s:10:\"refresh:fr\";s:7:\"waiting\";i:24;s:21:\"misc/jquery.ba-bbq.js\";i:25;s:33:\"modules/overlay/overlay-parent.js\";i:26;s:32:\"modules/contextual/contextual.js\";i:27;s:42:\"sites/all/modules/admin_menu/admin_menu.js\";i:28;s:69:\"sites/all/modules/admin_menu/admin_menu_toolbar/admin_menu_toolbar.js\";}'),('jquery_update_compression_type','s:3:\"min\";'),('jquery_update_jquery_admin_version','s:0:\"\";'),('jquery_update_jquery_cdn','s:4:\"none\";'),('jquery_update_jquery_version','s:3:\"1.8\";'),('language_content_type_article','s:1:\"0\";'),('language_content_type_blog','s:1:\"0\";'),('language_content_type_forum','s:1:\"0\";'),('language_content_type_page','s:1:\"0\";'),('language_content_type_products','s:1:\"0\";'),('language_content_type_video','s:1:\"0\";'),('language_content_type_webform','s:1:\"0\";'),('language_count','i:3;'),('language_default','O:8:\"stdClass\":11:{s:8:\"language\";s:2:\"en\";s:4:\"name\";s:7:\"English\";s:6:\"native\";s:7:\"English\";s:9:\"direction\";s:1:\"0\";s:7:\"enabled\";i:1;s:7:\"plurals\";s:1:\"0\";s:7:\"formula\";s:0:\"\";s:6:\"domain\";s:0:\"\";s:6:\"prefix\";s:2:\"en\";s:6:\"weight\";s:3:\"-10\";s:10:\"javascript\";s:0:\"\";}'),('language_negotiation_language','a:2:{s:10:\"locale-url\";a:2:{s:9:\"callbacks\";a:3:{s:8:\"language\";s:24:\"locale_language_from_url\";s:8:\"switcher\";s:28:\"locale_language_switcher_url\";s:11:\"url_rewrite\";s:31:\"locale_language_url_rewrite_url\";}s:4:\"file\";s:19:\"includes/locale.inc\";}s:16:\"language-default\";a:1:{s:9:\"callbacks\";a:1:{s:8:\"language\";s:21:\"language_from_default\";}}}'),('language_negotiation_language_content','a:1:{s:16:\"locale-interface\";a:2:{s:9:\"callbacks\";a:1:{s:8:\"language\";s:30:\"locale_language_from_interface\";}s:4:\"file\";s:19:\"includes/locale.inc\";}}'),('language_negotiation_language_url','a:2:{s:10:\"locale-url\";a:2:{s:9:\"callbacks\";a:3:{s:8:\"language\";s:24:\"locale_language_from_url\";s:8:\"switcher\";s:28:\"locale_language_switcher_url\";s:11:\"url_rewrite\";s:31:\"locale_language_url_rewrite_url\";}s:4:\"file\";s:19:\"includes/locale.inc\";}s:19:\"locale-url-fallback\";a:2:{s:9:\"callbacks\";a:1:{s:8:\"language\";s:28:\"locale_language_url_fallback\";}s:4:\"file\";s:19:\"includes/locale.inc\";}}'),('language_types','a:3:{s:8:\"language\";b:1;s:16:\"language_content\";b:0;s:12:\"language_url\";b:0;}'),('lang_dropdown_hideout_language','a:1:{s:16:\"hidden_languages\";a:3:{i:1;a:0:{}i:2;a:0:{}i:3;a:0:{}}}'),('lang_dropdown_language','a:10:{s:7:\"showall\";i:0;s:6:\"tohome\";i:0;s:5:\"width\";s:3:\"165\";s:7:\"display\";s:1:\"1\";s:6:\"widget\";s:1:\"3\";s:10:\"msdropdown\";a:6:{s:12:\"visible_rows\";i:5;s:7:\"rounded\";i:1;s:9:\"animation\";s:9:\"slideDown\";s:5:\"event\";s:5:\"click\";s:4:\"skin\";s:7:\"ldsSkin\";s:11:\"custom_skin\";s:0:\"\";}s:6:\"chosen\";a:2:{s:14:\"disable_search\";i:1;s:15:\"no_results_text\";s:17:\"No language match\";}s:7:\"ddslick\";a:5:{s:14:\"ddslick_height\";s:1:\"0\";s:16:\"showSelectedHTML\";i:1;s:13:\"imagePosition\";s:4:\"left\";s:4:\"skin\";s:10:\"ddsDefault\";s:11:\"custom_skin\";s:0:\"\";}s:13:\"languageicons\";a:1:{s:13:\"flag_position\";s:1:\"1\";}s:7:\"hideout\";a:2:{s:10:\"role_names\";a:3:{i:1;s:14:\"anonymous user\";i:2;s:18:\"authenticated user\";i:3;s:13:\"administrator\";}s:9:\"languages\";a:1:{s:10:\"checkboxes\";a:3:{i:1;a:2:{s:2:\"en\";i:0;s:2:\"fr\";i:0;}i:2;a:2:{s:2:\"en\";i:0;s:2:\"fr\";i:0;}i:3;a:2:{s:2:\"en\";i:0;s:2:\"fr\";i:0;}}}}}'),('locale_language_providers_weight_language','a:5:{s:10:\"locale-url\";s:2:\"-8\";s:14:\"locale-session\";s:2:\"-6\";s:11:\"locale-user\";s:2:\"-4\";s:14:\"locale-browser\";s:2:\"-2\";s:16:\"language-default\";s:2:\"10\";}'),('maintenance_mode','b:0;'),('menu_breadcrumb_append_node_title','i:1;'),('menu_breadcrumb_append_node_url','i:0;'),('menu_breadcrumb_determine_menu','i:1;'),('menu_breadcrumb_hide_on_single_item','i:0;'),('menu_breadcrumb_menus','a:11:{s:9:\"main-menu\";a:5:{s:7:\"enabled\";i:1;s:6:\"weight\";s:1:\"0\";s:4:\"type\";s:4:\"menu\";s:5:\"title\";s:9:\"Main menu\";s:4:\"name\";s:9:\"main-menu\";}s:10:\"management\";a:5:{s:7:\"enabled\";i:1;s:6:\"weight\";s:1:\"0\";s:4:\"type\";s:4:\"menu\";s:5:\"title\";s:10:\"Management\";s:4:\"name\";s:10:\"management\";}s:15:\"menu-categories\";a:5:{s:7:\"enabled\";i:1;s:6:\"weight\";s:1:\"0\";s:4:\"type\";s:4:\"menu\";s:5:\"title\";s:10:\"Categories\";s:4:\"name\";s:15:\"menu-categories\";}s:18:\"menu-features-menu\";a:5:{s:7:\"enabled\";i:1;s:6:\"weight\";s:1:\"0\";s:4:\"type\";s:4:\"menu\";s:5:\"title\";s:13:\"Features menu\";s:4:\"name\";s:18:\"menu-features-menu\";}s:16:\"menu-footer-menu\";a:5:{s:7:\"enabled\";i:1;s:6:\"weight\";s:1:\"0\";s:4:\"type\";s:4:\"menu\";s:5:\"title\";s:11:\"Footer menu\";s:4:\"name\";s:16:\"menu-footer-menu\";}s:10:\"menu-links\";a:5:{s:7:\"enabled\";i:1;s:6:\"weight\";s:1:\"0\";s:4:\"type\";s:4:\"menu\";s:5:\"title\";s:5:\"Links\";s:4:\"name\";s:10:\"menu-links\";}s:13:\"menu-sections\";a:5:{s:7:\"enabled\";i:1;s:6:\"weight\";s:1:\"0\";s:4:\"type\";s:4:\"menu\";s:5:\"title\";s:8:\"Sections\";s:4:\"name\";s:13:\"menu-sections\";}s:28:\"menu_breadcrumb_default_menu\";a:5:{s:7:\"enabled\";i:1;s:6:\"weight\";s:1:\"0\";s:4:\"type\";s:28:\"menu_breadcrumb_default_menu\";s:5:\"title\";s:28:\"menu_breadcrumb_default_menu\";s:4:\"name\";s:28:\"menu_breadcrumb_default_menu\";}s:10:\"navigation\";a:5:{s:7:\"enabled\";i:1;s:6:\"weight\";s:1:\"0\";s:4:\"type\";s:4:\"menu\";s:5:\"title\";s:10:\"Navigation\";s:4:\"name\";s:10:\"navigation\";}s:14:\"shortcut-set-1\";a:5:{s:7:\"enabled\";i:1;s:6:\"weight\";s:1:\"0\";s:4:\"type\";s:4:\"menu\";s:5:\"title\";s:14:\"shortcut-set-1\";s:4:\"name\";s:14:\"shortcut-set-1\";}s:9:\"user-menu\";a:5:{s:7:\"enabled\";i:1;s:6:\"weight\";s:1:\"0\";s:4:\"type\";s:4:\"menu\";s:5:\"title\";s:9:\"User menu\";s:4:\"name\";s:9:\"user-menu\";}}'),('menu_breadcrumb_menu_patterns','s:22:\"/^book-toc-\\d+$/Books/\";'),('menu_breadcrumb_pattern_matches_rebuild','b:0;'),('menu_default_active_menus','a:9:{i:0;s:15:\"menu-categories\";i:1;s:8:\"features\";i:3;s:16:\"menu-footer-menu\";i:4;s:10:\"menu-links\";i:5;s:9:\"main-menu\";i:6;s:10:\"management\";i:7;s:10:\"navigation\";i:8;s:13:\"menu-sections\";i:9;s:9:\"user-menu\";}'),('menu_expanded','a:3:{i:0;s:9:\"main-menu\";i:1;s:15:\"menu-categories\";i:2;s:13:\"menu-sections\";}'),('menu_masks','a:46:{i:0;i:501;i:1;i:493;i:2;i:253;i:3;i:250;i:4;i:247;i:5;i:246;i:6;i:245;i:7;i:242;i:8;i:238;i:9;i:126;i:10;i:125;i:11;i:124;i:12;i:123;i:13;i:122;i:14;i:121;i:15;i:119;i:16;i:117;i:17;i:63;i:18;i:62;i:19;i:61;i:20;i:60;i:21;i:59;i:22;i:58;i:23;i:56;i:24;i:45;i:25;i:44;i:26;i:31;i:27;i:30;i:28;i:29;i:29;i:28;i:30;i:26;i:31;i:24;i:32;i:22;i:33;i:21;i:34;i:15;i:35;i:14;i:36;i:13;i:37;i:12;i:38;i:11;i:39;i:10;i:40;i:7;i:41;i:6;i:42;i:5;i:43;i:3;i:44;i:2;i:45;i:1;}'),('menu_options_article','a:1:{i:0;s:9:\"main-menu\";}'),('menu_options_blog','a:1:{i:0;s:9:\"main-menu\";}'),('menu_options_forum','a:1:{i:0;s:9:\"main-menu\";}'),('menu_options_page','a:2:{i:0;s:10:\"menu-links\";i:1;s:9:\"main-menu\";}'),('menu_options_products','a:1:{i:0;s:9:\"main-menu\";}'),('menu_options_video','a:1:{i:0;s:9:\"main-menu\";}'),('menu_options_webform','a:1:{i:0;s:9:\"main-menu\";}'),('menu_parent_article','s:11:\"main-menu:0\";'),('menu_parent_blog','s:11:\"main-menu:0\";'),('menu_parent_forum','s:11:\"main-menu:0\";'),('menu_parent_page','s:11:\"main-menu:0\";'),('menu_parent_products','s:11:\"main-menu:0\";'),('menu_parent_video','s:11:\"main-menu:0\";'),('menu_parent_webform','s:11:\"main-menu:0\";'),('minimum_word_size','s:1:\"2\";'),('modal_forms_background_color','s:4:\"#000\";'),('modal_forms_comment','i:0;'),('modal_forms_contact','i:0;'),('modal_forms_login','i:1;'),('modal_forms_login_links','s:1:\"2\";'),('modal_forms_opacity','s:4:\"0.85\";'),('modal_forms_pages','s:115:\"admin*\r\nimagebrowser*\r\nimg_assist*\r\nimce*\r\nnode/add/*\r\nnode/*/edit\r\nprint/*\r\nprintpdf/*\r\nsystem/ajax\r\nsystem/ajax/*\";'),('modal_forms_password','i:0;'),('modal_forms_popup_large_height','s:3:\"0.8\";'),('modal_forms_popup_large_type','s:5:\"scale\";'),('modal_forms_popup_large_width','s:3:\"0.8\";'),('modal_forms_popup_medium_height','s:3:\"500\";'),('modal_forms_popup_medium_type','s:5:\"fixed\";'),('modal_forms_popup_medium_width','s:3:\"550\";'),('modal_forms_popup_small_height','s:3:\"350\";'),('modal_forms_popup_small_type','s:5:\"fixed\";'),('modal_forms_popup_small_width','s:3:\"500\";'),('modal_forms_register','i:0;'),('modal_forms_visibility','s:1:\"0\";'),('module_filter_recent_modules','a:0:{}'),('node_admin_theme','i:1;'),('node_cron_last','s:10:\"1444379051\";'),('node_options_article','a:2:{i:0;s:6:\"status\";i:1;s:7:\"promote\";}'),('node_options_blog','a:1:{i:0;s:6:\"status\";}'),('node_options_book','a:1:{i:0;s:6:\"status\";}'),('node_options_forum','a:1:{i:0;s:6:\"status\";}'),('node_options_page','a:1:{i:0;s:6:\"status\";}'),('node_options_products','a:1:{i:0;s:6:\"status\";}'),('node_options_video','a:2:{i:0;s:6:\"status\";i:1;s:7:\"promote\";}'),('node_options_webform','a:1:{i:0;s:6:\"status\";}'),('node_preview_article','s:1:\"1\";'),('node_preview_blog','s:1:\"1\";'),('node_preview_forum','s:1:\"1\";'),('node_preview_page','s:1:\"1\";'),('node_preview_products','s:1:\"1\";'),('node_preview_video','s:1:\"1\";'),('node_preview_webform','s:1:\"1\";'),('node_rank_comments','s:1:\"0\";'),('node_rank_promote','s:1:\"0\";'),('node_rank_recent','s:1:\"0\";'),('node_rank_relevance','s:1:\"0\";'),('node_rank_sticky','s:1:\"0\";'),('node_rank_views','s:1:\"0\";'),('node_submitted_article','i:1;'),('node_submitted_blog','i:1;'),('node_submitted_forum','i:1;'),('node_submitted_page','i:0;'),('node_submitted_products','i:1;'),('node_submitted_video','i:1;'),('node_submitted_webform','i:0;'),('node_type_faq','a:1:{i:0;s:6:\"status\";}'),('overlap_cjk','i:1;'),('pathauto_blog_pattern','s:17:\"blogs/[user:name]\";'),('pathauto_faq_pattern','s:19:\"faq-page/[term:tid]\";'),('pathauto_forum_pattern','s:29:\"[term:vocabulary]/[term:name]\";'),('pathauto_node_article_pattern','s:20:\"article/[node:title]\";'),('pathauto_node_blog_pattern','s:17:\"blog/[node:title]\";'),('pathauto_node_book_pattern','s:0:\"\";'),('pathauto_node_faq_pattern','s:16:\"faq/[node:title]\";'),('pathauto_node_forum_pattern','s:18:\"forum/[node:title]\";'),('pathauto_node_page_pattern','s:17:\"page/[node:title]\";'),('pathauto_node_pattern','s:20:\"content/[node:title]\";'),('pathauto_node_products_pattern','s:20:\"product/[node:title]\";'),('pathauto_node_video_pattern','s:18:\"video/[node:title]\";'),('pathauto_node_webform_pattern','s:17:\"form/[node:title]\";'),('pathauto_punctuation_hyphen','i:1;'),('pathauto_taxonomy_term_categories_pattern','s:0:\"\";'),('pathauto_taxonomy_term_pattern','s:29:\"[term:vocabulary]/[term:name]\";'),('pathauto_taxonomy_term_sections_pattern','s:0:\"\";'),('pathauto_taxonomy_term_tags_pattern','s:0:\"\";'),('pathauto_user_pattern','s:17:\"users/[user:name]\";'),('path_alias_whitelist','a:5:{s:4:\"blog\";b:1;s:5:\"forum\";b:1;s:4:\"node\";b:1;s:8:\"taxonomy\";b:1;s:4:\"user\";b:1;}'),('save_continue_products','s:19:\"Save and add fields\";'),('save_continue_video','s:19:\"Save and add fields\";'),('search_active_modules','a:2:{s:4:\"node\";s:4:\"node\";s:4:\"user\";s:4:\"user\";}'),('search_cron_limit','s:3:\"100\";'),('search_default_module','s:4:\"node\";'),('sharethis_article_options','a:7:{s:4:\"full\";s:4:\"full\";s:6:\"teaser\";s:6:\"teaser\";s:3:\"rss\";i:0;s:12:\"search_index\";i:0;s:13:\"search_result\";i:0;s:5:\"print\";i:0;s:5:\"token\";i:0;}'),('sharethis_blog_options','a:7:{s:4:\"full\";s:4:\"full\";s:6:\"teaser\";s:6:\"teaser\";s:3:\"rss\";i:0;s:12:\"search_index\";i:0;s:13:\"search_result\";i:0;s:5:\"print\";i:0;s:5:\"token\";i:0;}'),('sharethis_book_options','a:7:{s:4:\"full\";i:0;s:6:\"teaser\";i:0;s:3:\"rss\";i:0;s:12:\"search_index\";i:0;s:13:\"search_result\";i:0;s:5:\"print\";i:0;s:5:\"token\";i:0;}'),('sharethis_button_option','s:11:\"stbc_custom\";'),('sharethis_comments','i:0;'),('sharethis_faq_options','a:7:{s:4:\"full\";i:0;s:6:\"teaser\";i:0;s:3:\"rss\";i:0;s:12:\"search_index\";i:0;s:13:\"search_result\";i:0;s:5:\"print\";i:0;s:5:\"token\";i:0;}'),('sharethis_forum_options','a:7:{s:4:\"full\";s:4:\"full\";s:6:\"teaser\";i:0;s:3:\"rss\";i:0;s:12:\"search_index\";i:0;s:13:\"search_result\";i:0;s:5:\"print\";i:0;s:5:\"token\";i:0;}'),('sharethis_late_load','i:0;'),('sharethis_location','s:5:\"links\";'),('sharethis_node_types','a:8:{s:7:\"article\";s:7:\"article\";s:4:\"page\";s:4:\"page\";s:4:\"blog\";i:0;s:4:\"book\";i:0;s:3:\"faq\";i:0;s:5:\"forum\";i:0;s:5:\"video\";i:0;s:7:\"webform\";i:0;}'),('sharethis_option_extras','a:2:{s:23:\"Google Plus One:plusone\";i:0;s:20:\"Facebook Like:fblike\";i:0;}'),('sharethis_option_neworzero','i:0;'),('sharethis_option_onhover','i:1;'),('sharethis_option_shorten','i:1;'),('sharethis_page_options','a:7:{s:4:\"full\";i:0;s:6:\"teaser\";i:0;s:3:\"rss\";i:0;s:12:\"search_index\";i:0;s:13:\"search_result\";i:0;s:5:\"print\";i:0;s:5:\"token\";i:0;}'),('sharethis_publisherID','s:37:\"dr-a85e6aaa-c9f-35e2-a90b-580084f3d3b\";'),('sharethis_service_option','s:41:\"\"Facebook:facebook\",\"Google +:googleplus\"\";'),('sharethis_twitter_handle','s:0:\"\";'),('sharethis_twitter_recommends','s:0:\"\";'),('sharethis_twitter_suffix','s:0:\"\";'),('sharethis_video_options','a:7:{s:4:\"full\";s:4:\"full\";s:6:\"teaser\";s:6:\"teaser\";s:3:\"rss\";i:0;s:12:\"search_index\";i:0;s:13:\"search_result\";i:0;s:5:\"print\";i:0;s:5:\"token\";i:0;}'),('sharethis_webform_options','a:7:{s:4:\"full\";i:0;s:6:\"teaser\";i:0;s:3:\"rss\";i:0;s:12:\"search_index\";i:0;s:13:\"search_result\";i:0;s:5:\"print\";i:0;s:5:\"token\";i:0;}'),('sharethis_weight','s:2:\"10\";'),('sharethis_widget_option','s:8:\"st_multi\";'),('site_403','s:0:\"\";'),('site_404','s:7:\"node/33\";'),('site_default_country','s:0:\"\";'),('site_frontpage','s:5:\"forum\";'),('site_mail','s:13:\"admin@lvh.com\";'),('site_name','s:10:\"Forum Plus\";'),('site_slogan','s:19:\"Wellcome forum plus\";'),('statistics_count_content_views','i:1;'),('statistics_count_content_views_ajax','i:0;'),('statistics_day_timestamp','i:1512620327;'),('statistics_enable_access_log','i:0;'),('statistics_flush_accesslog_timer','s:6:\"259200\";'),('tagclouds_block_tags_1','s:2:\"12\";'),('taxonomy_menu_display_descendants_categories','i:0;'),('taxonomy_menu_display_descendants_sections','i:0;'),('taxonomy_menu_display_num_categories','i:1;'),('taxonomy_menu_display_num_sections','i:0;'),('taxonomy_menu_end_all_categories','b:0;'),('taxonomy_menu_end_all_sections','b:0;'),('taxonomy_menu_expanded_categories','i:1;'),('taxonomy_menu_expanded_sections','i:1;'),('taxonomy_menu_flat_categories','i:0;'),('taxonomy_menu_flat_sections','i:0;'),('taxonomy_menu_hide_empty_terms_categories','i:0;'),('taxonomy_menu_hide_empty_terms_sections','i:0;'),('taxonomy_menu_path_categories','s:26:\"taxonomy_menu_path_default\";'),('taxonomy_menu_path_sections','s:26:\"taxonomy_menu_path_default\";'),('taxonomy_menu_rebuild_categories','i:0;'),('taxonomy_menu_rebuild_sections','i:0;'),('taxonomy_menu_sync_categories','i:1;'),('taxonomy_menu_sync_sections','i:1;'),('taxonomy_menu_term_item_description_categories','i:0;'),('taxonomy_menu_term_item_description_sections','i:0;'),('taxonomy_menu_vocab_menu_categories','s:15:\"menu-categories\";'),('taxonomy_menu_vocab_menu_sections','s:13:\"menu-sections\";'),('taxonomy_menu_vocab_parent_categories','s:1:\"0\";'),('taxonomy_menu_vocab_parent_sections','s:1:\"0\";'),('taxonomy_menu_voc_item_categories','b:0;'),('taxonomy_menu_voc_item_description_categories','i:0;'),('taxonomy_menu_voc_item_description_sections','i:0;'),('taxonomy_menu_voc_item_sections','b:0;'),('taxonomy_menu_voc_name_categories','b:0;'),('taxonomy_menu_voc_name_sections','b:0;'),('theme_default','s:10:\"forum_plus\";'),('theme_forum_plus_settings','a:21:{s:18:\"forum_plus_version\";s:0:\"\";s:4:\"skin\";s:0:\"\";s:10:\"background\";s:10:\"bg-default\";s:6:\"layout\";s:14:\"layout-default\";s:12:\"layout_width\";s:4:\"1250\";s:11:\"toggle_logo\";i:1;s:11:\"toggle_name\";i:0;s:13:\"toggle_slogan\";i:0;s:24:\"toggle_node_user_picture\";i:1;s:27:\"toggle_comment_user_picture\";i:1;s:32:\"toggle_comment_user_verification\";i:1;s:14:\"toggle_favicon\";i:1;s:15:\"show_skins_menu\";i:1;s:12:\"loading_page\";i:0;s:12:\"default_logo\";i:1;s:9:\"logo_path\";s:0:\"\";s:11:\"logo_upload\";s:0:\"\";s:15:\"default_favicon\";i:1;s:12:\"favicon_path\";s:0:\"\";s:14:\"favicon_upload\";s:0:\"\";s:31:\"forum_plus_use_default_settings\";s:1:\"0\";}'),('update_last_check','i:1512620339;'),('update_last_email_notification','i:1512620327;'),('update_notify_emails','a:1:{i:0;s:20:\"admin@forum-plus.com\";}'),('userpickit_migration_user_preferences_uid','i:2;'),('user_admin_role','s:1:\"3\";'),('user_block_max_list_count','s:2:\"10\";'),('user_block_seconds_online','s:3:\"900\";'),('user_block_whois_new_count','s:1:\"5\";'),('user_cancel_method','s:17:\"user_cancel_block\";'),('user_default_timezone','s:1:\"0\";'),('user_email_verification','i:1;'),('user_mail_cancel_confirm_body','s:381:\"[user:name],\r\n\r\nA request to cancel your account has been made at [site:name].\r\n\r\nYou may now cancel your account on [site:url-brief] by clicking this link or copying and pasting it into your browser:\r\n\r\n[user:cancel-url]\r\n\r\nNOTE: The cancellation of your account is not reversible.\r\n\r\nThis link expires in one day and nothing will happen if it is not used.\r\n\r\n--  [site:name] team\";'),('user_mail_cancel_confirm_subject','s:59:\"Account cancellation request for [user:name] at [site:name]\";'),('user_mail_password_reset_body','s:407:\"[user:name],\r\n\r\nA request to reset the password for your account has been made at [site:name].\r\n\r\nYou may now log in by clicking this link or copying and pasting it to your browser:\r\n\r\n[user:one-time-login-url]\r\n\r\nThis link can only be used once to log in and will lead you to a page where you can set your password. It expires after one day and nothing will happen if it\'s not used.\r\n\r\n--  [site:name] team\";'),('user_mail_password_reset_subject','s:60:\"Replacement login information for [user:name] at [site:name]\";'),('user_mail_register_admin_created_body','s:476:\"[user:name],\r\n\r\nA site administrator at [site:name] has created an account for you. You may now log in by clicking this link or copying and pasting it to your browser:\r\n\r\n[user:one-time-login-url]\r\n\r\nThis link can only be used once to log in and will lead you to a page where you can set your password.\r\n\r\nAfter setting your password, you will be able to log in at [site:login-url] in the future using:\r\n\r\nusername: [user:name]\r\npassword: Your password\r\n\r\n--  [site:name] team\";'),('user_mail_register_admin_created_subject','s:58:\"An administrator created an account for you at [site:name]\";'),('user_mail_register_no_approval_required_body','s:450:\"[user:name],\r\n\r\nThank you for registering at [site:name]. You may now log in by clicking this link or copying and pasting it to your browser:\r\n\r\n[user:one-time-login-url]\r\n\r\nThis link can only be used once to log in and will lead you to a page where you can set your password.\r\n\r\nAfter setting your password, you will be able to log in at [site:login-url] in the future using:\r\n\r\nusername: [user:name]\r\npassword: Your password\r\n\r\n--  [site:name] team\";'),('user_mail_register_no_approval_required_subject','s:46:\"Account details for [user:name] at [site:name]\";'),('user_mail_register_pending_approval_body','s:287:\"[user:name],\r\n\r\nThank you for registering at [site:name]. Your application for an account is currently pending approval. Once it has been approved, you will receive another e-mail containing information about how to log in, set your password, and other details.\r\n\r\n\r\n--  [site:name] team\";'),('user_mail_register_pending_approval_subject','s:71:\"Account details for [user:name] at [site:name] (pending admin approval)\";'),('user_mail_status_activated_body','s:461:\"[user:name],\r\n\r\nYour account at [site:name] has been activated.\r\n\r\nYou may now log in by clicking this link or copying and pasting it into your browser:\r\n\r\n[user:one-time-login-url]\r\n\r\nThis link can only be used once to log in and will lead you to a page where you can set your password.\r\n\r\nAfter setting your password, you will be able to log in at [site:login-url] in the future using:\r\n\r\nusername: [user:name]\r\npassword: Your password\r\n\r\n--  [site:name] team\";'),('user_mail_status_activated_notify','i:1;'),('user_mail_status_activated_subject','s:57:\"Account details for [user:name] at [site:name] (approved)\";'),('user_mail_status_blocked_body','s:85:\"[user:name],\r\n\r\nYour account on [site:name] has been blocked.\r\n\r\n--  [site:name] team\";'),('user_mail_status_blocked_notify','i:0;'),('user_mail_status_blocked_subject','s:56:\"Account details for [user:name] at [site:name] (blocked)\";'),('user_mail_status_canceled_body','s:86:\"[user:name],\r\n\r\nYour account on [site:name] has been canceled.\r\n\r\n--  [site:name] team\";'),('user_mail_status_canceled_notify','i:0;'),('user_mail_status_canceled_subject','s:57:\"Account details for [user:name] at [site:name] (canceled)\";'),('user_pictures','i:1;'),('user_picture_default','s:0:\"\";'),('user_picture_dimensions','s:9:\"1024x1024\";'),('user_picture_file_size','s:3:\"800\";'),('user_picture_guidelines','s:0:\"\";'),('user_picture_path','s:8:\"pictures\";'),('user_picture_style','s:9:\"thumbnail\";'),('user_register','s:1:\"2\";'),('user_signatures','i:1;'),('variable_module_list','a:3:{s:6:\"locale\";a:6:{i:0;s:29:\"language_content_type_article\";i:1;s:26:\"language_content_type_page\";i:2;s:26:\"language_content_type_blog\";i:3;s:26:\"language_content_type_book\";i:4;s:27:\"language_content_type_forum\";i:5;s:16:\"language_default\";}s:4:\"i18n\";a:1:{i:0;s:18:\"i18n_language_list\";}s:11:\"i18n_string\";a:4:{i:0;s:33:\"i18n_string_translate_langcode_en\";i:1;s:27:\"i18n_string_allowed_formats\";i:2;s:27:\"i18n_string_source_language\";i:3;s:17:\"i18n_string_debug\";}}'),('views_defaults','a:3:{s:15:\"comments_recent\";b:1;s:7:\"archive\";b:0;s:13:\"taxonomy_term\";b:1;}'),('webform_email_address_individual','i:1;'),('webform_email_html_capable','b:0;'),('webform_hints_forms','a:1:{i:40;i:0;}'),('webform_hints_legacy_support','i:1;'),('webform_hints_required','s:11:\" (required)\";'),('webform_hints_reverse','i:1;'),('webform_node_webform','b:1;');
/*!40000 ALTER TABLE `variable` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `vef_video_styles`
--

DROP TABLE IF EXISTS `vef_video_styles`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `vef_video_styles` (
  `name` varchar(255) NOT NULL COMMENT 'The machine-readable option set name.',
  `title` varchar(255) NOT NULL COMMENT 'The human-readable title for this option set.',
  `data` longblob NOT NULL COMMENT 'The configuration data for the style.',
  PRIMARY KEY (`name`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Stores video embed styles.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `vef_video_styles`
--

LOCK TABLES `vef_video_styles` WRITE;
/*!40000 ALTER TABLE `vef_video_styles` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `vef_video_styles` VALUES ('four_columns','Four Columns','a:3:{s:7:\"youtube\";a:11:{s:5:\"width\";s:5:\"260px\";s:6:\"height\";s:5:\"140px\";s:5:\"theme\";s:4:\"dark\";s:8:\"autoplay\";i:0;s:2:\"vq\";s:5:\"large\";s:3:\"rel\";i:0;s:8:\"showinfo\";i:1;s:14:\"modestbranding\";i:0;s:14:\"iv_load_policy\";s:1:\"1\";s:8:\"autohide\";s:1:\"2\";s:5:\"class\";s:0:\"\";}s:5:\"vimeo\";a:9:{s:5:\"width\";s:5:\"260px\";s:6:\"height\";s:5:\"140px\";s:5:\"color\";s:6:\"00adef\";s:8:\"portrait\";i:1;s:5:\"title\";i:1;s:6:\"byline\";i:1;s:8:\"autoplay\";i:0;s:4:\"loop\";i:0;s:5:\"class\";s:0:\"\";}s:16:\"data__active_tab\";s:15:\"\0dit-data-vimeo\";}'),('large','Large','a:3:{s:7:\"youtube\";a:11:{s:5:\"width\";s:5:\"848px\";s:6:\"height\";s:5:\"350px\";s:5:\"theme\";s:4:\"dark\";s:8:\"autoplay\";i:0;s:2:\"vq\";s:5:\"large\";s:3:\"rel\";i:0;s:8:\"showinfo\";i:1;s:14:\"modestbranding\";i:0;s:14:\"iv_load_policy\";s:1:\"1\";s:8:\"autohide\";s:1:\"2\";s:5:\"class\";s:0:\"\";}s:5:\"vimeo\";a:9:{s:5:\"width\";s:5:\"848px\";s:6:\"height\";s:5:\"350px\";s:5:\"color\";s:6:\"00adef\";s:8:\"portrait\";i:1;s:5:\"title\";i:1;s:6:\"byline\";i:1;s:8:\"autoplay\";i:0;s:4:\"loop\";i:0;s:5:\"class\";s:0:\"\";}s:16:\"data__active_tab\";s:15:\"\0dit-data-vimeo\";}'),('normal','Normal','a:2:{s:7:\"youtube\";a:12:{s:5:\"width\";i:640;s:6:\"height\";i:360;s:8:\"autoplay\";i:0;s:2:\"vq\";s:5:\"large\";s:3:\"rel\";i:0;s:8:\"controls\";i:1;s:8:\"autohide\";i:2;s:8:\"showinfo\";i:1;s:14:\"modestbranding\";i:0;s:5:\"theme\";s:4:\"dark\";s:14:\"iv_load_policy\";i:1;s:5:\"class\";s:0:\"\";}s:5:\"vimeo\";a:10:{s:5:\"width\";i:640;s:6:\"height\";i:360;s:5:\"color\";s:6:\"00adef\";s:8:\"portrait\";i:1;s:5:\"title\";i:1;s:6:\"byline\";i:1;s:8:\"autoplay\";i:0;s:4:\"loop\";i:0;s:10:\"froogaloop\";i:0;s:5:\"class\";s:0:\"\";}}'),('teaser','Teaser','a:2:{s:7:\"youtube\";a:12:{s:5:\"width\";i:480;s:6:\"height\";i:270;s:8:\"autoplay\";i:0;s:2:\"vq\";s:5:\"large\";s:3:\"rel\";i:0;s:8:\"controls\";i:1;s:8:\"autohide\";i:2;s:8:\"showinfo\";i:1;s:14:\"modestbranding\";i:0;s:5:\"theme\";s:4:\"dark\";s:14:\"iv_load_policy\";i:1;s:5:\"class\";s:0:\"\";}s:5:\"vimeo\";a:10:{s:5:\"width\";i:480;s:6:\"height\";i:270;s:5:\"color\";s:6:\"00adef\";s:8:\"portrait\";i:1;s:5:\"title\";i:1;s:6:\"byline\";i:1;s:8:\"autoplay\";i:0;s:4:\"loop\";i:0;s:10:\"froogaloop\";i:0;s:5:\"class\";s:0:\"\";}}'),('three_columns','Three Columns','a:3:{s:7:\"youtube\";a:11:{s:5:\"width\";s:5:\"272px\";s:6:\"height\";s:5:\"167px\";s:5:\"theme\";s:4:\"dark\";s:8:\"autoplay\";i:0;s:2:\"vq\";s:5:\"large\";s:3:\"rel\";i:0;s:8:\"showinfo\";i:1;s:14:\"modestbranding\";i:0;s:14:\"iv_load_policy\";s:1:\"1\";s:8:\"autohide\";s:1:\"2\";s:5:\"class\";s:0:\"\";}s:5:\"vimeo\";a:9:{s:5:\"width\";s:5:\"285px\";s:6:\"height\";s:5:\"175px\";s:5:\"color\";s:6:\"00adef\";s:8:\"portrait\";i:1;s:5:\"title\";i:1;s:6:\"byline\";i:1;s:8:\"autoplay\";i:0;s:4:\"loop\";i:0;s:5:\"class\";s:0:\"\";}s:16:\"data__active_tab\";s:17:\"\0dit-data-youtube\";}'),('two_columns','Two Columns','a:3:{s:7:\"youtube\";a:11:{s:5:\"width\";s:5:\"416px\";s:6:\"height\";s:5:\"261px\";s:5:\"theme\";s:4:\"dark\";s:8:\"autoplay\";i:0;s:2:\"vq\";s:5:\"large\";s:3:\"rel\";i:0;s:8:\"showinfo\";i:1;s:14:\"modestbranding\";i:0;s:14:\"iv_load_policy\";s:1:\"1\";s:8:\"autohide\";s:1:\"2\";s:5:\"class\";s:0:\"\";}s:5:\"vimeo\";a:9:{s:5:\"width\";s:5:\"430px\";s:6:\"height\";s:5:\"270px\";s:5:\"color\";s:6:\"00adef\";s:8:\"portrait\";i:1;s:5:\"title\";i:1;s:6:\"byline\";i:1;s:8:\"autoplay\";i:0;s:4:\"loop\";i:0;s:5:\"class\";s:0:\"\";}s:16:\"data__active_tab\";s:17:\"\0dit-data-youtube\";}');
/*!40000 ALTER TABLE `vef_video_styles` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `views_display`
--

DROP TABLE IF EXISTS `views_display`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `views_display` (
  `vid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The view this display is attached to.',
  `id` varchar(64) NOT NULL DEFAULT '' COMMENT 'An identifier for this display; usually generated from the display_plugin, so should be something like page or page_1 or block_2, etc.',
  `display_title` varchar(64) NOT NULL DEFAULT '' COMMENT 'The title of the display, viewable by the administrator.',
  `display_plugin` varchar(64) NOT NULL DEFAULT '' COMMENT 'The type of the display. Usually page, block or embed, but is pluggable so may be other things.',
  `position` int(11) DEFAULT '0' COMMENT 'The order in which this display is loaded.',
  `display_options` longtext COMMENT 'A serialized array of options for this display; it contains options that are generally only pertinent to that display plugin type.',
  PRIMARY KEY (`vid`,`id`),
  KEY `vid` (`vid`,`position`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Stores information about each display attached to a view.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `views_display`
--

LOCK TABLES `views_display` WRITE;
/*!40000 ALTER TABLE `views_display` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `views_display` VALUES (1,'default','Master','default',1,'a:14:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:6:\"access\";a:1:{s:4:\"type\";s:4:\"perm\";}s:5:\"cache\";a:1:{s:4:\"type\";s:4:\"none\";}s:12:\"exposed_form\";a:1:{s:4:\"type\";s:5:\"basic\";}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"full\";s:7:\"options\";a:7:{s:14:\"items_per_page\";s:1:\"6\";s:6:\"offset\";s:1:\"0\";s:2:\"id\";s:1:\"0\";s:11:\"total_pages\";s:0:\"\";s:8:\"quantity\";s:1:\"9\";s:4:\"tags\";a:4:{s:5:\"first\";s:8:\"« first\";s:8:\"previous\";s:12:\"‹ previous\";s:4:\"next\";s:8:\"next ›\";s:4:\"last\";s:7:\"last »\";}s:6:\"expose\";a:7:{s:14:\"items_per_page\";i:0;s:20:\"items_per_page_label\";s:14:\"Items per page\";s:22:\"items_per_page_options\";s:17:\"5, 10, 20, 40, 60\";s:26:\"items_per_page_options_all\";i:0;s:32:\"items_per_page_options_all_label\";s:7:\"- All -\";s:6:\"offset\";i:0;s:12:\"offset_label\";s:6:\"Offset\";}}}s:12:\"style_plugin\";s:7:\"default\";s:10:\"row_plugin\";s:6:\"fields\";s:6:\"fields\";a:10:{s:5:\"title\";a:22:{s:2:\"id\";s:5:\"title\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:5:\"title\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:2:\"30\";s:13:\"word_boundary\";i:0;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:1;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:1;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:12:\"link_to_node\";i:1;}s:7:\"created\";a:26:{s:2:\"id\";s:7:\"created\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:7:\"created\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:11:\"date_format\";s:6:\"custom\";s:18:\"custom_date_format\";s:13:\"D M d, Y h:ma\";s:25:\"second_date_format_custom\";s:0:\"\";s:18:\"second_date_format\";s:4:\"long\";s:8:\"timezone\";s:0:\"\";}s:11:\"field_image\";a:34:{s:2:\"id\";s:11:\"field_image\";s:5:\"table\";s:22:\"field_data_field_image\";s:5:\"field\";s:11:\"field_image\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:1;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:17:\"click_sort_column\";s:3:\"fid\";s:4:\"type\";s:5:\"image\";s:8:\"settings\";a:2:{s:11:\"image_style\";s:5:\"large\";s:10:\"image_link\";s:7:\"content\";}s:12:\"group_column\";s:0:\"\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";s:3:\"all\";s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";i:0;}s:4:\"body\";a:34:{s:2:\"id\";s:4:\"body\";s:5:\"table\";s:15:\"field_data_body\";s:5:\"field\";s:4:\"body\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:3:\"430\";s:13:\"word_boundary\";i:0;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:1;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:1;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";s:3:\"all\";s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";i:0;}s:10:\"field_tags\";a:34:{s:2:\"id\";s:10:\"field_tags\";s:5:\"table\";s:21:\"field_data_field_tags\";s:5:\"field\";s:10:\"field_tags\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:17:\"click_sort_column\";s:3:\"tid\";s:4:\"type\";s:33:\"i18n_taxonomy_term_reference_link\";s:8:\"settings\";a:0:{}s:12:\"group_column\";s:3:\"tid\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";i:1;s:11:\"delta_limit\";s:3:\"all\";s:12:\"delta_offset\";s:1:\"0\";s:14:\"delta_reversed\";i:0;s:16:\"delta_first_last\";i:0;s:10:\"multi_type\";s:2:\"ul\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";i:0;}s:9:\"view_node\";a:22:{s:2:\"id\";s:9:\"view_node\";s:5:\"table\";s:17:\"views_entity_node\";s:5:\"field\";s:9:\"view_node\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:4:\"text\";s:12:\"See more ...\";}s:8:\"fieldset\";a:23:{s:2:\"id\";s:8:\"fieldset\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:8:\"fieldset\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:8:\"Fieldset\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:0;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:8:\"children\";a:3:{i:0;s:13:\"comment_count\";i:1;s:10:\"totalcount\";i:2;s:9:\"sharethis\";}s:8:\"fieldset\";a:5:{s:4:\"type\";s:3:\"div\";s:7:\"classes\";s:17:\"forum-node-footer\";s:2:\"id\";s:0:\"\";s:11:\"collapsible\";i:0;s:9:\"collapsed\";i:0;}}s:13:\"comment_count\";a:30:{s:2:\"id\";s:13:\"comment_count\";s:5:\"table\";s:23:\"node_comment_statistics\";s:5:\"field\";s:13:\"comment_count\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:1;s:4:\"text\";s:46:\"<i class=\"fa fa-comments\"></i> [comment_count]\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:13:\"set_precision\";b:0;s:9:\"precision\";i:0;s:7:\"decimal\";s:1:\".\";s:9:\"separator\";s:1:\",\";s:13:\"format_plural\";i:0;s:22:\"format_plural_singular\";s:1:\"1\";s:20:\"format_plural_plural\";s:6:\"@count\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";}s:10:\"totalcount\";a:30:{s:2:\"id\";s:10:\"totalcount\";s:5:\"table\";s:12:\"node_counter\";s:5:\"field\";s:10:\"totalcount\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:1;s:4:\"text\";s:38:\"<i class=\"fa fa-eye\"></i> [totalcount]\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:13:\"set_precision\";b:0;s:9:\"precision\";i:0;s:7:\"decimal\";s:1:\".\";s:9:\"separator\";s:1:\",\";s:13:\"format_plural\";i:0;s:22:\"format_plural_singular\";s:1:\"1\";s:20:\"format_plural_plural\";s:6:\"@count\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";}s:9:\"sharethis\";a:21:{s:2:\"id\";s:9:\"sharethis\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:9:\"sharethis\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;}}s:7:\"filters\";a:2:{s:6:\"status\";a:6:{s:5:\"value\";i:1;s:5:\"table\";s:4:\"node\";s:5:\"field\";s:6:\"status\";s:2:\"id\";s:6:\"status\";s:6:\"expose\";a:1:{s:8:\"operator\";b:0;}s:5:\"group\";i:1;}s:4:\"type\";a:4:{s:2:\"id\";s:4:\"type\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:4:\"type\";s:5:\"value\";a:1:{s:7:\"article\";s:7:\"article\";}}}s:5:\"sorts\";a:1:{s:7:\"created\";a:4:{s:2:\"id\";s:7:\"created\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:7:\"created\";s:5:\"order\";s:4:\"DESC\";}}s:5:\"title\";s:8:\"Articles\";s:11:\"row_options\";a:4:{s:22:\"default_field_elements\";i:1;s:6:\"inline\";a:0:{}s:9:\"separator\";s:0:\"\";s:10:\"hide_empty\";i:0;}s:13:\"relationships\";a:0:{}s:9:\"css_class\";s:35:\"forum-blog-view one-column article \";}'),(1,'page','Page','page',2,'a:5:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:4:\"path\";s:8:\"articles\";s:4:\"menu\";a:3:{s:4:\"type\";s:6:\"normal\";s:5:\"title\";s:8:\"Articles\";s:4:\"name\";s:9:\"main-menu\";}s:6:\"fields\";a:10:{s:11:\"field_image\";a:34:{s:2:\"id\";s:11:\"field_image\";s:5:\"table\";s:22:\"field_data_field_image\";s:5:\"field\";s:11:\"field_image\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:1;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:17:\"click_sort_column\";s:3:\"fid\";s:4:\"type\";s:5:\"image\";s:8:\"settings\";a:2:{s:11:\"image_style\";s:5:\"large\";s:10:\"image_link\";s:7:\"content\";}s:12:\"group_column\";s:0:\"\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";s:3:\"all\";s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";i:0;}s:5:\"title\";a:22:{s:2:\"id\";s:5:\"title\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:5:\"title\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:2:\"30\";s:13:\"word_boundary\";i:0;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:1;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:1;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:12:\"link_to_node\";i:1;}s:7:\"created\";a:26:{s:2:\"id\";s:7:\"created\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:7:\"created\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:11:\"date_format\";s:6:\"custom\";s:18:\"custom_date_format\";s:13:\"D M d, Y h:ma\";s:25:\"second_date_format_custom\";s:0:\"\";s:18:\"second_date_format\";s:4:\"long\";s:8:\"timezone\";s:0:\"\";}s:4:\"body\";a:34:{s:2:\"id\";s:4:\"body\";s:5:\"table\";s:15:\"field_data_body\";s:5:\"field\";s:4:\"body\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:3:\"430\";s:13:\"word_boundary\";i:0;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:1;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:1;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";s:3:\"all\";s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";i:0;}s:10:\"field_tags\";a:34:{s:2:\"id\";s:10:\"field_tags\";s:5:\"table\";s:21:\"field_data_field_tags\";s:5:\"field\";s:10:\"field_tags\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:17:\"click_sort_column\";s:3:\"tid\";s:4:\"type\";s:33:\"i18n_taxonomy_term_reference_link\";s:8:\"settings\";a:0:{}s:12:\"group_column\";s:3:\"tid\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";i:1;s:11:\"delta_limit\";s:3:\"all\";s:12:\"delta_offset\";s:1:\"0\";s:14:\"delta_reversed\";i:0;s:16:\"delta_first_last\";i:0;s:10:\"multi_type\";s:2:\"ul\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";i:0;}s:9:\"view_node\";a:22:{s:2:\"id\";s:9:\"view_node\";s:5:\"table\";s:17:\"views_entity_node\";s:5:\"field\";s:9:\"view_node\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:4:\"text\";s:12:\"See more ...\";}s:8:\"fieldset\";a:23:{s:2:\"id\";s:8:\"fieldset\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:8:\"fieldset\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:8:\"Fieldset\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:0;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:8:\"children\";a:3:{i:0;s:13:\"comment_count\";i:1;s:10:\"totalcount\";i:2;s:9:\"sharethis\";}s:8:\"fieldset\";a:5:{s:4:\"type\";s:3:\"div\";s:7:\"classes\";s:17:\"forum-node-footer\";s:2:\"id\";s:0:\"\";s:11:\"collapsible\";i:0;s:9:\"collapsed\";i:0;}}s:13:\"comment_count\";a:30:{s:2:\"id\";s:13:\"comment_count\";s:5:\"table\";s:23:\"node_comment_statistics\";s:5:\"field\";s:13:\"comment_count\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:1;s:4:\"text\";s:46:\"<i class=\"fa fa-comments\"></i> [comment_count]\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:13:\"set_precision\";b:0;s:9:\"precision\";i:0;s:7:\"decimal\";s:1:\".\";s:9:\"separator\";s:1:\",\";s:13:\"format_plural\";i:0;s:22:\"format_plural_singular\";s:1:\"1\";s:20:\"format_plural_plural\";s:6:\"@count\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";}s:10:\"totalcount\";a:30:{s:2:\"id\";s:10:\"totalcount\";s:5:\"table\";s:12:\"node_counter\";s:5:\"field\";s:10:\"totalcount\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:1;s:4:\"text\";s:38:\"<i class=\"fa fa-eye\"></i> [totalcount]\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:13:\"set_precision\";b:0;s:9:\"precision\";i:0;s:7:\"decimal\";s:1:\".\";s:9:\"separator\";s:1:\",\";s:13:\"format_plural\";i:0;s:22:\"format_plural_singular\";s:1:\"1\";s:20:\"format_plural_plural\";s:6:\"@count\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";}s:9:\"sharethis\";a:21:{s:2:\"id\";s:9:\"sharethis\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:9:\"sharethis\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;}}s:8:\"defaults\";a:1:{s:6:\"fields\";b:0;}}'),(1,'page_1','Page','page',3,'a:11:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:6:\"fields\";a:4:{s:11:\"field_image\";a:34:{s:2:\"id\";s:11:\"field_image\";s:5:\"table\";s:22:\"field_data_field_image\";s:5:\"field\";s:11:\"field_image\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:17:\"click_sort_column\";s:3:\"fid\";s:4:\"type\";s:5:\"image\";s:8:\"settings\";a:2:{s:11:\"image_style\";s:5:\"large\";s:10:\"image_link\";s:7:\"content\";}s:12:\"group_column\";s:0:\"\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";s:3:\"all\";s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";i:0;}s:5:\"title\";a:22:{s:2:\"id\";s:5:\"title\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:5:\"title\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:2:\"30\";s:13:\"word_boundary\";i:0;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:1;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:1;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:12:\"link_to_node\";i:1;}s:4:\"body\";a:34:{s:2:\"id\";s:4:\"body\";s:5:\"table\";s:15:\"field_data_body\";s:5:\"field\";s:4:\"body\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:3:\"430\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:1;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:1;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";s:3:\"all\";s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";i:0;}s:9:\"view_node\";a:22:{s:2:\"id\";s:9:\"view_node\";s:5:\"table\";s:17:\"views_entity_node\";s:5:\"field\";s:9:\"view_node\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:4:\"text\";s:12:\"See more ...\";}}s:8:\"defaults\";a:7:{s:6:\"fields\";b:0;s:13:\"relationships\";b:0;s:12:\"style_plugin\";b:0;s:13:\"style_options\";b:0;s:10:\"row_plugin\";b:0;s:11:\"row_options\";b:0;s:9:\"css_class\";b:0;}s:4:\"path\";s:15:\"articles-teaser\";s:13:\"relationships\";a:0:{}s:12:\"style_plugin\";s:7:\"default\";s:13:\"style_options\";a:0:{}s:10:\"row_plugin\";s:4:\"node\";s:11:\"row_options\";a:4:{s:12:\"relationship\";s:4:\"none\";s:9:\"view_mode\";s:6:\"teaser\";s:5:\"links\";i:1;s:8:\"comments\";i:0;}s:4:\"menu\";a:7:{s:4:\"type\";s:6:\"normal\";s:5:\"title\";s:15:\"Articles Teaser\";s:11:\"description\";s:0:\"\";s:4:\"name\";s:9:\"main-menu\";s:6:\"weight\";s:1:\"0\";s:7:\"context\";i:0;s:19:\"context_only_inline\";i:0;}s:9:\"css_class\";s:21:\"forum-articles-teaser\";}'),(1,'page_2','Page','page',4,'a:10:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:4:\"path\";s:12:\"articles/two\";s:4:\"menu\";a:7:{s:4:\"type\";s:6:\"normal\";s:5:\"title\";s:11:\"Two Columns\";s:11:\"description\";s:0:\"\";s:4:\"name\";s:9:\"main-menu\";s:6:\"weight\";s:1:\"0\";s:7:\"context\";i:0;s:19:\"context_only_inline\";i:0;}s:12:\"style_plugin\";s:4:\"grid\";s:8:\"defaults\";a:6:{s:12:\"style_plugin\";b:0;s:13:\"style_options\";b:0;s:10:\"row_plugin\";b:0;s:11:\"row_options\";b:0;s:6:\"fields\";b:0;s:9:\"css_class\";b:0;}s:13:\"style_options\";a:9:{s:8:\"grouping\";a:0:{}s:9:\"row_class\";s:0:\"\";s:17:\"default_row_class\";i:1;s:17:\"row_class_special\";i:1;s:7:\"columns\";s:1:\"2\";s:9:\"alignment\";s:10:\"horizontal\";s:16:\"fill_single_line\";i:1;s:7:\"caption\";s:0:\"\";s:7:\"summary\";s:0:\"\";}s:10:\"row_plugin\";s:6:\"fields\";s:11:\"row_options\";a:4:{s:22:\"default_field_elements\";i:1;s:6:\"inline\";a:0:{}s:9:\"separator\";s:0:\"\";s:10:\"hide_empty\";i:0;}s:6:\"fields\";a:10:{s:11:\"field_image\";a:34:{s:2:\"id\";s:11:\"field_image\";s:5:\"table\";s:22:\"field_data_field_image\";s:5:\"field\";s:11:\"field_image\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:1;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:17:\"click_sort_column\";s:3:\"fid\";s:4:\"type\";s:5:\"image\";s:8:\"settings\";a:2:{s:11:\"image_style\";s:11:\"two_columns\";s:10:\"image_link\";s:7:\"content\";}s:12:\"group_column\";s:0:\"\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";s:3:\"all\";s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";i:0;}s:5:\"title\";a:22:{s:2:\"id\";s:5:\"title\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:5:\"title\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:2:\"30\";s:13:\"word_boundary\";i:0;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:1;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:1;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:12:\"link_to_node\";i:1;}s:7:\"created\";a:26:{s:2:\"id\";s:7:\"created\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:7:\"created\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:11:\"date_format\";s:6:\"custom\";s:18:\"custom_date_format\";s:13:\"D M d, Y h:ma\";s:25:\"second_date_format_custom\";s:0:\"\";s:18:\"second_date_format\";s:4:\"long\";s:8:\"timezone\";s:0:\"\";}s:4:\"body\";a:34:{s:2:\"id\";s:4:\"body\";s:5:\"table\";s:15:\"field_data_body\";s:5:\"field\";s:4:\"body\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:3:\"430\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:1;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:1;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";s:3:\"all\";s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";i:0;}s:10:\"field_tags\";a:34:{s:2:\"id\";s:10:\"field_tags\";s:5:\"table\";s:21:\"field_data_field_tags\";s:5:\"field\";s:10:\"field_tags\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:17:\"click_sort_column\";s:3:\"tid\";s:4:\"type\";s:33:\"i18n_taxonomy_term_reference_link\";s:8:\"settings\";a:0:{}s:12:\"group_column\";s:3:\"tid\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";i:1;s:11:\"delta_limit\";s:3:\"all\";s:12:\"delta_offset\";s:1:\"0\";s:14:\"delta_reversed\";i:0;s:16:\"delta_first_last\";i:0;s:10:\"multi_type\";s:2:\"ul\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";i:0;}s:9:\"view_node\";a:22:{s:2:\"id\";s:9:\"view_node\";s:5:\"table\";s:17:\"views_entity_node\";s:5:\"field\";s:9:\"view_node\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:4:\"text\";s:12:\"See more ...\";}s:8:\"fieldset\";a:23:{s:2:\"id\";s:8:\"fieldset\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:8:\"fieldset\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:8:\"Fieldset\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:0;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:8:\"children\";a:3:{i:0;s:13:\"comment_count\";i:1;s:10:\"totalcount\";i:2;s:9:\"sharethis\";}s:8:\"fieldset\";a:5:{s:4:\"type\";s:3:\"div\";s:7:\"classes\";s:17:\"forum-node-footer\";s:2:\"id\";s:0:\"\";s:11:\"collapsible\";i:0;s:9:\"collapsed\";i:0;}}s:13:\"comment_count\";a:30:{s:2:\"id\";s:13:\"comment_count\";s:5:\"table\";s:23:\"node_comment_statistics\";s:5:\"field\";s:13:\"comment_count\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:1;s:4:\"text\";s:46:\"<i class=\"fa fa-comments\"></i> [comment_count]\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:13:\"set_precision\";b:0;s:9:\"precision\";i:0;s:7:\"decimal\";s:1:\".\";s:9:\"separator\";s:1:\",\";s:13:\"format_plural\";i:0;s:22:\"format_plural_singular\";s:1:\"1\";s:20:\"format_plural_plural\";s:6:\"@count\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";}s:10:\"totalcount\";a:30:{s:2:\"id\";s:10:\"totalcount\";s:5:\"table\";s:12:\"node_counter\";s:5:\"field\";s:10:\"totalcount\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:1;s:4:\"text\";s:38:\"<i class=\"fa fa-eye\"></i> [totalcount]\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:13:\"set_precision\";b:0;s:9:\"precision\";i:0;s:7:\"decimal\";s:1:\".\";s:9:\"separator\";s:1:\",\";s:13:\"format_plural\";i:0;s:22:\"format_plural_singular\";s:1:\"1\";s:20:\"format_plural_plural\";s:6:\"@count\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";}s:9:\"sharethis\";a:21:{s:2:\"id\";s:9:\"sharethis\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:9:\"sharethis\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;}}s:9:\"css_class\";s:34:\"forum-blog-view two-column article\";}'),(1,'page_3','Page','page',5,'a:10:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:4:\"path\";s:14:\"articles/three\";s:4:\"menu\";a:7:{s:4:\"type\";s:6:\"normal\";s:5:\"title\";s:13:\"Three Columns\";s:11:\"description\";s:0:\"\";s:4:\"name\";s:9:\"main-menu\";s:6:\"weight\";s:1:\"0\";s:7:\"context\";i:0;s:19:\"context_only_inline\";i:0;}s:12:\"style_plugin\";s:4:\"grid\";s:8:\"defaults\";a:6:{s:12:\"style_plugin\";b:0;s:13:\"style_options\";b:0;s:10:\"row_plugin\";b:0;s:11:\"row_options\";b:0;s:6:\"fields\";b:0;s:9:\"css_class\";b:0;}s:13:\"style_options\";a:9:{s:8:\"grouping\";a:0:{}s:9:\"row_class\";s:0:\"\";s:17:\"default_row_class\";i:1;s:17:\"row_class_special\";i:1;s:7:\"columns\";s:1:\"3\";s:9:\"alignment\";s:10:\"horizontal\";s:16:\"fill_single_line\";i:1;s:7:\"caption\";s:0:\"\";s:7:\"summary\";s:0:\"\";}s:10:\"row_plugin\";s:6:\"fields\";s:11:\"row_options\";a:4:{s:22:\"default_field_elements\";i:1;s:6:\"inline\";a:0:{}s:9:\"separator\";s:0:\"\";s:10:\"hide_empty\";i:0;}s:6:\"fields\";a:10:{s:11:\"field_image\";a:34:{s:2:\"id\";s:11:\"field_image\";s:5:\"table\";s:22:\"field_data_field_image\";s:5:\"field\";s:11:\"field_image\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:1;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:17:\"click_sort_column\";s:3:\"fid\";s:4:\"type\";s:5:\"image\";s:8:\"settings\";a:2:{s:11:\"image_style\";s:13:\"three_columns\";s:10:\"image_link\";s:7:\"content\";}s:12:\"group_column\";s:0:\"\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";s:3:\"all\";s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";i:0;}s:5:\"title\";a:22:{s:2:\"id\";s:5:\"title\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:5:\"title\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:2:\"30\";s:13:\"word_boundary\";i:0;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:1;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:1;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:12:\"link_to_node\";i:1;}s:7:\"created\";a:26:{s:2:\"id\";s:7:\"created\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:7:\"created\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:11:\"date_format\";s:6:\"custom\";s:18:\"custom_date_format\";s:13:\"D M d, Y h:ma\";s:25:\"second_date_format_custom\";s:0:\"\";s:18:\"second_date_format\";s:4:\"long\";s:8:\"timezone\";s:0:\"\";}s:4:\"body\";a:34:{s:2:\"id\";s:4:\"body\";s:5:\"table\";s:15:\"field_data_body\";s:5:\"field\";s:4:\"body\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:3:\"430\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:1;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:1;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";s:3:\"all\";s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";i:0;}s:10:\"field_tags\";a:34:{s:2:\"id\";s:10:\"field_tags\";s:5:\"table\";s:21:\"field_data_field_tags\";s:5:\"field\";s:10:\"field_tags\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:17:\"click_sort_column\";s:3:\"tid\";s:4:\"type\";s:33:\"i18n_taxonomy_term_reference_link\";s:8:\"settings\";a:0:{}s:12:\"group_column\";s:3:\"tid\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";i:1;s:11:\"delta_limit\";s:3:\"all\";s:12:\"delta_offset\";s:1:\"0\";s:14:\"delta_reversed\";i:0;s:16:\"delta_first_last\";i:0;s:10:\"multi_type\";s:2:\"ul\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";i:0;}s:9:\"view_node\";a:22:{s:2:\"id\";s:9:\"view_node\";s:5:\"table\";s:17:\"views_entity_node\";s:5:\"field\";s:9:\"view_node\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:4:\"text\";s:12:\"See more ...\";}s:8:\"fieldset\";a:23:{s:2:\"id\";s:8:\"fieldset\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:8:\"fieldset\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:8:\"Fieldset\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:0;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:8:\"children\";a:3:{i:0;s:13:\"comment_count\";i:1;s:10:\"totalcount\";i:2;s:9:\"sharethis\";}s:8:\"fieldset\";a:5:{s:4:\"type\";s:3:\"div\";s:7:\"classes\";s:17:\"forum-node-footer\";s:2:\"id\";s:0:\"\";s:11:\"collapsible\";i:0;s:9:\"collapsed\";i:0;}}s:13:\"comment_count\";a:30:{s:2:\"id\";s:13:\"comment_count\";s:5:\"table\";s:23:\"node_comment_statistics\";s:5:\"field\";s:13:\"comment_count\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:1;s:4:\"text\";s:46:\"<i class=\"fa fa-comments\"></i> [comment_count]\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:13:\"set_precision\";b:0;s:9:\"precision\";i:0;s:7:\"decimal\";s:1:\".\";s:9:\"separator\";s:1:\",\";s:13:\"format_plural\";i:0;s:22:\"format_plural_singular\";s:1:\"1\";s:20:\"format_plural_plural\";s:6:\"@count\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";}s:10:\"totalcount\";a:30:{s:2:\"id\";s:10:\"totalcount\";s:5:\"table\";s:12:\"node_counter\";s:5:\"field\";s:10:\"totalcount\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:1;s:4:\"text\";s:38:\"<i class=\"fa fa-eye\"></i> [totalcount]\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:13:\"set_precision\";b:0;s:9:\"precision\";i:0;s:7:\"decimal\";s:1:\".\";s:9:\"separator\";s:1:\",\";s:13:\"format_plural\";i:0;s:22:\"format_plural_singular\";s:1:\"1\";s:20:\"format_plural_plural\";s:6:\"@count\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";}s:9:\"sharethis\";a:21:{s:2:\"id\";s:9:\"sharethis\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:9:\"sharethis\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;}}s:9:\"css_class\";s:36:\"forum-blog-view three-column article\";}'),(2,'default','Master','default',1,'a:14:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:6:\"access\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"cache\";a:1:{s:4:\"type\";s:4:\"none\";}s:12:\"exposed_form\";a:1:{s:4:\"type\";s:5:\"basic\";}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"full\";s:7:\"options\";a:1:{s:14:\"items_per_page\";s:2:\"10\";}}s:12:\"style_plugin\";s:7:\"default\";s:10:\"row_plugin\";s:6:\"fields\";s:6:\"fields\";a:8:{s:7:\"picture\";a:23:{s:2:\"id\";s:7:\"picture\";s:5:\"table\";s:5:\"users\";s:5:\"field\";s:7:\"picture\";s:12:\"relationship\";s:4:\"user\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:21:\"link_photo_to_profile\";i:1;s:11:\"image_style\";s:0:\"\";}s:7:\"created\";a:26:{s:2:\"id\";s:7:\"created\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:7:\"created\";s:12:\"relationship\";s:24:\"field_node_ref_target_id\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:11:\"date_format\";s:6:\"custom\";s:18:\"custom_date_format\";s:13:\"D M d, Y h:ma\";s:25:\"second_date_format_custom\";s:0:\"\";s:18:\"second_date_format\";s:4:\"long\";s:8:\"timezone\";s:0:\"\";}s:14:\"message_render\";a:24:{s:2:\"id\";s:14:\"message_render\";s:5:\"table\";s:7:\"message\";s:5:\"field\";s:14:\"message_render\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:1;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:7:\"<a> <p>\";s:4:\"html\";i:0;}s:12:\"element_type\";s:3:\"div\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:10:\"field_name\";s:12:\"message_text\";s:8:\"partials\";i:0;s:14:\"partials_delta\";s:1:\"0\";}s:11:\"field_image\";a:34:{s:2:\"id\";s:11:\"field_image\";s:5:\"table\";s:22:\"field_data_field_image\";s:5:\"field\";s:11:\"field_image\";s:12:\"relationship\";s:24:\"field_node_ref_target_id\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:1;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:17:\"click_sort_column\";s:3:\"fid\";s:4:\"type\";s:5:\"image\";s:8:\"settings\";a:2:{s:11:\"image_style\";s:6:\"medium\";s:10:\"image_link\";s:7:\"content\";}s:12:\"group_column\";s:0:\"\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";s:3:\"all\";s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";i:0;}s:3:\"mid\";a:30:{s:2:\"id\";s:3:\"mid\";s:5:\"table\";s:7:\"message\";s:5:\"field\";s:3:\"mid\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:1;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:13:\"set_precision\";b:0;s:9:\"precision\";i:0;s:7:\"decimal\";s:1:\".\";s:9:\"separator\";s:1:\",\";s:13:\"format_plural\";i:0;s:22:\"format_plural_singular\";s:1:\"1\";s:20:\"format_plural_plural\";s:6:\"@count\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";}s:4:\"user\";a:30:{s:2:\"id\";s:4:\"user\";s:5:\"table\";s:7:\"message\";s:5:\"field\";s:4:\"user\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:1;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:13:\"set_precision\";b:0;s:9:\"precision\";i:0;s:7:\"decimal\";s:1:\".\";s:9:\"separator\";s:1:\",\";s:13:\"format_plural\";i:0;s:22:\"format_plural_singular\";s:1:\"1\";s:20:\"format_plural_plural\";s:6:\"@count\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";}s:13:\"comment_count\";a:30:{s:2:\"id\";s:13:\"comment_count\";s:5:\"table\";s:23:\"node_comment_statistics\";s:5:\"field\";s:13:\"comment_count\";s:12:\"relationship\";s:24:\"field_node_ref_target_id\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:1;s:4:\"text\";s:46:\"<i class=\"fa fa-comments\"></i> [comment_count]\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:1;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:13:\"set_precision\";b:0;s:9:\"precision\";i:0;s:7:\"decimal\";s:1:\".\";s:9:\"separator\";s:1:\",\";s:13:\"format_plural\";i:0;s:22:\"format_plural_singular\";s:1:\"1\";s:20:\"format_plural_plural\";s:6:\"@count\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";}s:10:\"totalcount\";a:30:{s:2:\"id\";s:10:\"totalcount\";s:5:\"table\";s:12:\"node_counter\";s:5:\"field\";s:10:\"totalcount\";s:12:\"relationship\";s:24:\"field_node_ref_target_id\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:1;s:4:\"text\";s:38:\"<i class=\"fa fa-eye\"></i> [totalcount]\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:1;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:13:\"set_precision\";b:0;s:9:\"precision\";i:0;s:7:\"decimal\";s:1:\".\";s:9:\"separator\";s:1:\",\";s:13:\"format_plural\";i:0;s:22:\"format_plural_singular\";s:1:\"1\";s:20:\"format_plural_plural\";s:6:\"@count\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";}}s:7:\"filters\";a:0:{}s:5:\"sorts\";a:0:{}s:5:\"title\";s:15:\"Activity Stream\";s:13:\"relationships\";a:2:{s:4:\"user\";a:8:{s:2:\"id\";s:4:\"user\";s:5:\"table\";s:7:\"message\";s:5:\"field\";s:4:\"user\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:4:\"User\";s:8:\"required\";i:0;}s:24:\"field_node_ref_target_id\";a:8:{s:2:\"id\";s:24:\"field_node_ref_target_id\";s:5:\"table\";s:25:\"field_data_field_node_ref\";s:5:\"field\";s:24:\"field_node_ref_target_id\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:45:\"Content entity referenced from field_node_ref\";s:8:\"required\";i:0;}}s:9:\"css_class\";s:15:\"activity-stream\";s:9:\"arguments\";a:0:{}}'),(2,'page','Page','page',2,'a:5:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:4:\"path\";s:15:\"activity-stream\";s:4:\"menu\";a:7:{s:4:\"type\";s:6:\"normal\";s:5:\"title\";s:10:\"What\'s New\";s:11:\"description\";s:0:\"\";s:4:\"name\";s:9:\"main-menu\";s:6:\"weight\";s:1:\"0\";s:7:\"context\";i:0;s:19:\"context_only_inline\";i:0;}s:14:\"field_language\";s:22:\"***DEFAULT_LANGUAGE***\";s:27:\"field_language_add_to_query\";i:1;}'),(4,'block','Recent Entities','block',2,'a:7:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:5:\"field\";a:1:{s:5:\"title\";a:1:{s:12:\"link_to_node\";i:1;}}s:5:\"title\";s:15:\"Recent Entities\";s:8:\"defaults\";a:3:{s:5:\"title\";b:0;s:5:\"pager\";b:0;s:13:\"pager_options\";b:0;}s:19:\"display_description\";s:0:\"\";s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"some\";s:7:\"options\";a:2:{s:14:\"items_per_page\";s:1:\"3\";s:6:\"offset\";s:1:\"0\";}}s:13:\"pager_options\";N;}'),(4,'block_1','Most Popular','block',3,'a:6:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:5:\"field\";a:1:{s:5:\"title\";a:1:{s:12:\"link_to_node\";i:1;}}s:5:\"title\";s:12:\"Most Popular\";s:8:\"defaults\";a:2:{s:5:\"title\";b:0;s:5:\"sorts\";b:0;}s:19:\"display_description\";s:0:\"\";s:5:\"sorts\";a:2:{s:10:\"totalcount\";a:9:{s:2:\"id\";s:10:\"totalcount\";s:5:\"table\";s:12:\"node_counter\";s:5:\"field\";s:10:\"totalcount\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"order\";s:4:\"DESC\";s:7:\"exposed\";b:0;s:6:\"expose\";a:1:{s:5:\"label\";s:0:\"\";}}s:7:\"created\";a:4:{s:2:\"id\";s:7:\"created\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:7:\"created\";s:5:\"order\";s:4:\"DESC\";}}}'),(4,'block_2','Best Blogs','block',4,'a:6:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:5:\"field\";a:1:{s:5:\"title\";a:1:{s:12:\"link_to_node\";i:1;}}s:5:\"title\";s:10:\"Best Blogs\";s:8:\"defaults\";a:2:{s:5:\"title\";b:0;s:5:\"sorts\";b:0;}s:19:\"display_description\";s:0:\"\";s:5:\"sorts\";a:3:{s:17:\"field_vote_rating\";a:9:{s:2:\"id\";s:17:\"field_vote_rating\";s:5:\"table\";s:21:\"field_data_field_vote\";s:5:\"field\";s:17:\"field_vote_rating\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"order\";s:4:\"DESC\";s:7:\"exposed\";b:0;s:6:\"expose\";a:1:{s:5:\"label\";s:0:\"\";}}s:10:\"totalcount\";a:9:{s:2:\"id\";s:10:\"totalcount\";s:5:\"table\";s:12:\"node_counter\";s:5:\"field\";s:10:\"totalcount\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"order\";s:4:\"DESC\";s:7:\"exposed\";b:0;s:6:\"expose\";a:1:{s:5:\"label\";s:0:\"\";}}s:7:\"created\";a:4:{s:2:\"id\";s:7:\"created\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:7:\"created\";s:5:\"order\";s:4:\"DESC\";}}}'),(4,'default','Master','default',1,'a:12:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:6:\"access\";a:1:{s:4:\"type\";s:4:\"perm\";}s:5:\"cache\";a:1:{s:4:\"type\";s:4:\"none\";}s:12:\"exposed_form\";a:1:{s:4:\"type\";s:5:\"basic\";}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"some\";s:7:\"options\";a:2:{s:14:\"items_per_page\";s:1:\"3\";s:6:\"offset\";s:1:\"0\";}}s:12:\"style_plugin\";s:7:\"default\";s:10:\"row_plugin\";s:6:\"fields\";s:6:\"fields\";a:4:{s:7:\"picture\";a:23:{s:2:\"id\";s:7:\"picture\";s:5:\"table\";s:5:\"users\";s:5:\"field\";s:7:\"picture\";s:12:\"relationship\";s:3:\"uid\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:21:\"link_photo_to_profile\";i:1;s:11:\"image_style\";s:9:\"thumbnail\";}s:5:\"title\";a:22:{s:2:\"id\";s:5:\"title\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:5:\"title\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:2:\"20\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:1;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:1;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:12:\"link_to_node\";i:1;}s:4:\"name\";a:25:{s:2:\"id\";s:4:\"name\";s:5:\"table\";s:5:\"users\";s:5:\"field\";s:4:\"name\";s:12:\"relationship\";s:3:\"uid\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:1;s:4:\"text\";s:9:\"By [name]\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:12:\"link_to_user\";i:1;s:19:\"overwrite_anonymous\";i:0;s:14:\"anonymous_text\";s:0:\"\";s:15:\"format_username\";i:1;}s:7:\"created\";a:26:{s:2:\"id\";s:7:\"created\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:7:\"created\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:39:\"<i class=\"fa fa-clock-o\"></i> [created]\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:11:\"date_format\";s:6:\"custom\";s:18:\"custom_date_format\";s:13:\"D M d, Y h:ma\";s:25:\"second_date_format_custom\";s:0:\"\";s:18:\"second_date_format\";s:4:\"long\";s:8:\"timezone\";s:0:\"\";}}s:7:\"filters\";a:2:{s:6:\"status\";a:6:{s:5:\"value\";i:1;s:5:\"table\";s:4:\"node\";s:5:\"field\";s:6:\"status\";s:2:\"id\";s:6:\"status\";s:6:\"expose\";a:1:{s:8:\"operator\";b:0;}s:5:\"group\";i:1;}s:4:\"type\";a:4:{s:2:\"id\";s:4:\"type\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:4:\"type\";s:5:\"value\";a:1:{s:4:\"blog\";s:4:\"blog\";}}}s:5:\"sorts\";a:1:{s:7:\"created\";a:4:{s:2:\"id\";s:7:\"created\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:7:\"created\";s:5:\"order\";s:4:\"DESC\";}}s:5:\"title\";s:12:\"Recent Blogs\";s:13:\"relationships\";a:1:{s:3:\"uid\";a:8:{s:2:\"id\";s:3:\"uid\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:3:\"uid\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:6:\"author\";s:8:\"required\";i:0;}}}'),(5,'block','Block','block',2,'a:1:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}}'),(5,'default','Master','default',1,'a:14:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:6:\"access\";a:1:{s:4:\"type\";s:4:\"perm\";}s:5:\"cache\";a:1:{s:4:\"type\";s:4:\"none\";}s:12:\"exposed_form\";a:1:{s:4:\"type\";s:5:\"basic\";}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"some\";s:7:\"options\";a:2:{s:14:\"items_per_page\";s:1:\"3\";s:6:\"offset\";s:1:\"0\";}}s:12:\"style_plugin\";s:7:\"default\";s:10:\"row_plugin\";s:6:\"fields\";s:13:\"relationships\";a:2:{s:3:\"nid\";a:4:{s:2:\"id\";s:3:\"nid\";s:5:\"table\";s:7:\"comment\";s:5:\"field\";s:3:\"nid\";s:8:\"required\";i:1;}s:3:\"uid\";a:8:{s:2:\"id\";s:3:\"uid\";s:5:\"table\";s:7:\"comment\";s:5:\"field\";s:3:\"uid\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:6:\"author\";s:8:\"required\";i:0;}}s:6:\"fields\";a:4:{s:7:\"picture\";a:23:{s:2:\"id\";s:7:\"picture\";s:5:\"table\";s:5:\"users\";s:5:\"field\";s:7:\"picture\";s:12:\"relationship\";s:3:\"uid\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:21:\"link_photo_to_profile\";i:1;s:11:\"image_style\";s:9:\"thumbnail\";}s:7:\"subject\";a:23:{s:2:\"id\";s:7:\"subject\";s:5:\"table\";s:7:\"comment\";s:5:\"field\";s:7:\"subject\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:2:\"30\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:1;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:1;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:15:\"link_to_comment\";i:1;s:12:\"link_to_node\";i:0;}s:4:\"name\";a:25:{s:2:\"id\";s:4:\"name\";s:5:\"table\";s:5:\"users\";s:5:\"field\";s:4:\"name\";s:12:\"relationship\";s:3:\"uid\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:1;s:4:\"text\";s:9:\"By [name]\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:12:\"link_to_user\";i:1;s:19:\"overwrite_anonymous\";i:0;s:14:\"anonymous_text\";s:0:\"\";s:15:\"format_username\";i:1;}s:7:\"created\";a:26:{s:2:\"id\";s:7:\"created\";s:5:\"table\";s:7:\"comment\";s:5:\"field\";s:7:\"created\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:39:\"<i class=\"fa fa-clock-o\"></i> [created]\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:11:\"date_format\";s:6:\"custom\";s:18:\"custom_date_format\";s:13:\"D M d, Y h:ma\";s:25:\"second_date_format_custom\";s:0:\"\";s:18:\"second_date_format\";s:4:\"long\";s:8:\"timezone\";s:0:\"\";}}s:7:\"filters\";a:2:{s:6:\"status\";a:6:{s:5:\"value\";i:1;s:5:\"table\";s:7:\"comment\";s:5:\"field\";s:6:\"status\";s:2:\"id\";s:6:\"status\";s:6:\"expose\";a:1:{s:8:\"operator\";b:0;}s:5:\"group\";i:1;}s:11:\"status_node\";a:7:{s:5:\"value\";i:1;s:5:\"table\";s:4:\"node\";s:5:\"field\";s:6:\"status\";s:12:\"relationship\";s:3:\"nid\";s:2:\"id\";s:11:\"status_node\";s:6:\"expose\";a:1:{s:8:\"operator\";b:0;}s:5:\"group\";i:1;}}s:5:\"sorts\";a:1:{s:7:\"created\";a:4:{s:2:\"id\";s:7:\"created\";s:5:\"table\";s:7:\"comment\";s:5:\"field\";s:7:\"created\";s:5:\"order\";s:4:\"DESC\";}}s:5:\"title\";s:8:\"Comments\";s:11:\"row_options\";a:4:{s:22:\"default_field_elements\";i:1;s:6:\"inline\";a:0:{}s:9:\"separator\";s:0:\"\";s:10:\"hide_empty\";i:0;}s:9:\"css_class\";s:0:\"\";}'),(6,'block','Block','block',2,'a:2:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:5:\"field\";a:1:{s:5:\"title\";a:1:{s:12:\"link_to_node\";i:1;}}}'),(6,'default','Master','default',1,'a:13:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:6:\"access\";a:1:{s:4:\"type\";s:4:\"perm\";}s:5:\"cache\";a:1:{s:4:\"type\";s:4:\"none\";}s:12:\"exposed_form\";a:1:{s:4:\"type\";s:5:\"basic\";}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"some\";s:7:\"options\";a:1:{s:14:\"items_per_page\";s:1:\"2\";}}s:12:\"style_plugin\";s:7:\"default\";s:10:\"row_plugin\";s:6:\"fields\";s:6:\"fields\";a:4:{s:7:\"picture\";a:23:{s:2:\"id\";s:7:\"picture\";s:5:\"table\";s:5:\"users\";s:5:\"field\";s:7:\"picture\";s:12:\"relationship\";s:3:\"uid\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:21:\"link_photo_to_profile\";i:1;s:11:\"image_style\";s:9:\"thumbnail\";}s:5:\"title\";a:22:{s:2:\"id\";s:5:\"title\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:5:\"title\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:2:\"20\";s:13:\"word_boundary\";i:0;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:1;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:1;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:12:\"link_to_node\";i:1;}s:4:\"name\";a:25:{s:2:\"id\";s:4:\"name\";s:5:\"table\";s:5:\"users\";s:5:\"field\";s:4:\"name\";s:12:\"relationship\";s:3:\"uid\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:1;s:4:\"text\";s:9:\"By [name]\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:12:\"link_to_user\";i:1;s:19:\"overwrite_anonymous\";i:0;s:14:\"anonymous_text\";s:0:\"\";s:15:\"format_username\";i:1;}s:7:\"created\";a:26:{s:2:\"id\";s:7:\"created\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:7:\"created\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:39:\"<i class=\"fa fa-clock-o\"></i> [created]\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:11:\"date_format\";s:6:\"custom\";s:18:\"custom_date_format\";s:13:\"D M d, Y h:ma\";s:25:\"second_date_format_custom\";s:0:\"\";s:18:\"second_date_format\";s:4:\"long\";s:8:\"timezone\";s:0:\"\";}}s:7:\"filters\";a:3:{s:6:\"status\";a:6:{s:5:\"value\";i:1;s:5:\"table\";s:4:\"node\";s:5:\"field\";s:6:\"status\";s:2:\"id\";s:6:\"status\";s:6:\"expose\";a:1:{s:8:\"operator\";b:0;}s:5:\"group\";i:1;}s:4:\"type\";a:4:{s:2:\"id\";s:4:\"type\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:4:\"type\";s:5:\"value\";a:1:{s:5:\"forum\";s:5:\"forum\";}}s:7:\"picture\";a:13:{s:2:\"id\";s:7:\"picture\";s:5:\"table\";s:5:\"users\";s:5:\"field\";s:7:\"picture\";s:12:\"relationship\";s:3:\"uid\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:8:\"operator\";s:1:\"=\";s:5:\"value\";s:1:\"1\";s:5:\"group\";s:1:\"1\";s:7:\"exposed\";b:0;s:6:\"expose\";a:11:{s:11:\"operator_id\";b:0;s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:14:\"operator_label\";s:0:\"\";s:8:\"operator\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:1:{i:2;i:2;}}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";i:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}}}s:5:\"sorts\";a:1:{s:7:\"created\";a:4:{s:2:\"id\";s:7:\"created\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:7:\"created\";s:5:\"order\";s:4:\"DESC\";}}s:5:\"title\";s:13:\"Recent Topics\";s:13:\"relationships\";a:1:{s:3:\"uid\";a:8:{s:2:\"id\";s:3:\"uid\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:3:\"uid\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:6:\"author\";s:8:\"required\";i:0;}}s:9:\"css_class\";s:23:\"forum-panel-footer-view\";}'),(8,'default','Master','default',1,'a:14:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:6:\"access\";a:1:{s:4:\"type\";s:4:\"perm\";}s:5:\"cache\";a:1:{s:4:\"type\";s:4:\"none\";}s:12:\"exposed_form\";a:1:{s:4:\"type\";s:5:\"basic\";}s:5:\"pager\";a:2:{s:4:\"type\";s:16:\"date_views_pager\";s:7:\"options\";a:5:{s:7:\"date_id\";s:4:\"date\";s:14:\"pager_position\";s:3:\"top\";s:11:\"link_format\";s:5:\"pager\";s:13:\"date_argument\";s:7:\"Unknown\";s:11:\"granularity\";s:7:\"Unknown\";}}s:12:\"style_plugin\";s:14:\"calendar_style\";s:10:\"row_plugin\";s:15:\"calendar_entity\";s:6:\"fields\";a:2:{s:5:\"title\";a:8:{s:2:\"id\";s:5:\"title\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:5:\"title\";s:5:\"label\";s:0:\"\";s:5:\"alter\";a:8:{s:10:\"alter_text\";i:0;s:9:\"make_link\";i:0;s:8:\"absolute\";i:0;s:4:\"trim\";i:0;s:13:\"word_boundary\";i:0;s:8:\"ellipsis\";i:0;s:10:\"strip_tags\";i:0;s:4:\"html\";i:0;}s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:12:\"link_to_node\";i:1;}s:7:\"created\";a:26:{s:2:\"id\";s:7:\"created\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:7:\"created\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:11:\"date_format\";s:5:\"short\";s:18:\"custom_date_format\";s:0:\"\";s:25:\"second_date_format_custom\";s:0:\"\";s:18:\"second_date_format\";s:4:\"long\";s:8:\"timezone\";s:0:\"\";}}s:7:\"filters\";a:2:{s:6:\"status\";a:6:{s:5:\"value\";i:1;s:5:\"table\";s:4:\"node\";s:5:\"field\";s:6:\"status\";s:2:\"id\";s:6:\"status\";s:6:\"expose\";a:1:{s:8:\"operator\";b:0;}s:5:\"group\";i:1;}s:4:\"type\";a:4:{s:2:\"id\";s:4:\"type\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:4:\"type\";s:5:\"value\";a:1:{s:5:\"forum\";s:5:\"forum\";}}}s:5:\"sorts\";a:1:{s:7:\"created\";a:4:{s:2:\"id\";s:7:\"created\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:7:\"created\";s:5:\"order\";s:4:\"DESC\";}}s:5:\"title\";s:8:\"Calendar\";s:11:\"row_options\";a:7:{s:12:\"relationship\";s:4:\"none\";s:22:\"default_field_elements\";i:1;s:6:\"inline\";a:0:{}s:9:\"separator\";s:0:\"\";s:10:\"hide_empty\";i:0;s:18:\"calendar_date_link\";s:0:\"\";s:6:\"colors\";a:4:{s:6:\"legend\";s:4:\"type\";s:20:\"calendar_colors_type\";a:5:{s:7:\"article\";s:7:\"#ffffff\";s:4:\"page\";s:7:\"#ffffff\";s:4:\"blog\";s:7:\"#ffffff\";s:4:\"book\";s:7:\"#ffffff\";s:5:\"forum\";s:7:\"#ffffff\";}s:14:\"taxonomy_field\";s:0:\"\";s:26:\"calendar_colors_vocabulary\";a:0:{}}}s:13:\"style_options\";a:12:{s:13:\"calendar_type\";s:5:\"month\";s:4:\"mini\";s:1:\"0\";s:9:\"name_size\";s:1:\"3\";s:11:\"with_weekno\";s:1:\"0\";s:9:\"max_items\";s:1:\"5\";s:18:\"max_items_behavior\";s:4:\"more\";s:13:\"groupby_times\";s:4:\"hour\";s:20:\"groupby_times_custom\";N;s:11:\"theme_style\";s:1:\"1\";s:13:\"groupby_field\";s:0:\"\";s:14:\"multiday_theme\";s:1:\"1\";s:15:\"multiday_hidden\";a:0:{}}s:9:\"arguments\";a:1:{s:13:\"date_argument\";a:29:{s:2:\"id\";s:13:\"date_argument\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:13:\"date_argument\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:14:\"default_action\";s:7:\"default\";s:9:\"exception\";a:3:{s:5:\"value\";s:3:\"all\";s:12:\"title_enable\";i:0;s:5:\"title\";s:3:\"All\";}s:12:\"title_enable\";i:0;s:5:\"title\";s:0:\"\";s:17:\"breadcrumb_enable\";i:0;s:10:\"breadcrumb\";s:0:\"\";s:21:\"default_argument_type\";s:4:\"date\";s:24:\"default_argument_options\";a:0:{}s:25:\"default_argument_skip_url\";i:0;s:15:\"summary_options\";a:0:{}s:7:\"summary\";a:3:{s:10:\"sort_order\";s:3:\"asc\";s:17:\"number_of_records\";i:0;s:6:\"format\";s:4:\"none\";}s:18:\"specify_validation\";i:0;s:8:\"validate\";a:2:{s:4:\"type\";s:4:\"none\";s:4:\"fail\";s:9:\"not found\";}s:16:\"validate_options\";a:0:{}s:10:\"year_range\";s:5:\"-3:+3\";s:11:\"granularity\";s:5:\"month\";s:9:\"add_delta\";s:0:\"\";s:10:\"use_fromto\";s:0:\"\";s:12:\"title_format\";s:0:\"\";s:19:\"title_format_custom\";s:0:\"\";s:11:\"date_fields\";a:1:{s:12:\"node.created\";s:12:\"node.created\";}s:11:\"date_method\";s:2:\"OR\";s:10:\"date_group\";s:4:\"date\";}}}'),(8,'page','Page','page',2,'a:3:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:4:\"path\";s:8:\"calendar\";s:4:\"menu\";a:7:{s:4:\"type\";s:6:\"normal\";s:5:\"title\";s:8:\"Calendar\";s:11:\"description\";s:0:\"\";s:4:\"name\";s:9:\"main-menu\";s:6:\"weight\";s:1:\"0\";s:7:\"context\";i:0;s:19:\"context_only_inline\";i:0;}}'),(9,'block','Block','block',3,'a:5:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:8:\"defaults\";a:3:{s:9:\"arguments\";b:0;s:5:\"pager\";b:0;s:13:\"pager_options\";b:0;}s:9:\"arguments\";a:1:{s:18:\"created_year_month\";a:11:{s:2:\"id\";s:18:\"created_year_month\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:18:\"created_year_month\";s:14:\"default_action\";s:7:\"summary\";s:9:\"exception\";a:1:{s:12:\"title_enable\";i:1;}s:12:\"title_enable\";i:1;s:5:\"title\";s:2:\"%1\";s:21:\"default_argument_type\";s:5:\"fixed\";s:7:\"summary\";a:1:{s:6:\"format\";s:15:\"default_summary\";}s:15:\"summary_options\";a:1:{s:14:\"items_per_page\";s:2:\"30\";}s:18:\"specify_validation\";i:1;}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"some\";s:7:\"options\";a:2:{s:14:\"items_per_page\";s:1:\"4\";s:6:\"offset\";s:1:\"0\";}}s:13:\"pager_options\";N;}'),(9,'default','Master','default',1,'a:11:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:1:{s:13:\"query_comment\";b:0;}}s:5:\"title\";s:15:\"Monthly archive\";s:6:\"access\";a:1:{s:4:\"type\";s:4:\"none\";}s:5:\"cache\";a:1:{s:4:\"type\";s:4:\"none\";}s:12:\"exposed_form\";a:1:{s:4:\"type\";s:5:\"basic\";}s:5:\"pager\";a:1:{s:4:\"type\";s:4:\"full\";}s:12:\"style_plugin\";s:7:\"default\";s:10:\"row_plugin\";s:4:\"node\";s:5:\"sorts\";a:1:{s:7:\"created\";a:4:{s:2:\"id\";s:7:\"created\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:7:\"created\";s:5:\"order\";s:4:\"DESC\";}}s:9:\"arguments\";a:1:{s:18:\"created_year_month\";a:11:{s:2:\"id\";s:18:\"created_year_month\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:18:\"created_year_month\";s:14:\"default_action\";s:7:\"summary\";s:9:\"exception\";a:1:{s:12:\"title_enable\";i:1;}s:12:\"title_enable\";i:1;s:5:\"title\";s:2:\"%1\";s:21:\"default_argument_type\";s:5:\"fixed\";s:7:\"summary\";a:2:{s:10:\"sort_order\";s:4:\"desc\";s:6:\"format\";s:15:\"default_summary\";}s:15:\"summary_options\";a:2:{s:8:\"override\";b:1;s:14:\"items_per_page\";s:2:\"30\";}s:18:\"specify_validation\";i:1;}}s:7:\"filters\";a:2:{s:6:\"status\";a:6:{s:2:\"id\";s:6:\"status\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:6:\"status\";s:5:\"value\";i:1;s:5:\"group\";i:0;s:6:\"expose\";a:1:{s:8:\"operator\";b:0;}}s:4:\"type\";a:13:{s:2:\"id\";s:4:\"type\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:4:\"type\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:8:\"operator\";s:2:\"in\";s:5:\"value\";a:1:{s:4:\"blog\";s:4:\"blog\";}s:5:\"group\";s:1:\"1\";s:7:\"exposed\";b:0;s:6:\"expose\";a:12:{s:11:\"operator_id\";b:0;s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:14:\"operator_label\";s:0:\"\";s:8:\"operator\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:1:{i:2;i:2;}s:6:\"reduce\";b:0;}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";i:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}}}}'),(9,'page','Page','page',2,'a:3:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:4:\"path\";s:7:\"archive\";s:4:\"menu\";a:7:{s:4:\"type\";s:6:\"normal\";s:5:\"title\";s:7:\"Archive\";s:11:\"description\";s:0:\"\";s:4:\"name\";s:16:\"menu-footer-menu\";s:6:\"weight\";s:1:\"0\";s:7:\"context\";i:0;s:19:\"context_only_inline\";i:0;}}'),(10,'block','Block','block',2,'a:4:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:5:\"field\";a:1:{s:5:\"title\";a:1:{s:12:\"link_to_node\";i:1;}}s:6:\"fields\";a:4:{s:7:\"picture\";a:23:{s:2:\"id\";s:7:\"picture\";s:5:\"table\";s:5:\"users\";s:5:\"field\";s:7:\"picture\";s:12:\"relationship\";s:3:\"uid\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:21:\"link_photo_to_profile\";i:1;s:11:\"image_style\";s:5:\"small\";}s:5:\"title\";a:22:{s:2:\"id\";s:5:\"title\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:5:\"title\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:2:\"20\";s:13:\"word_boundary\";i:0;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:1;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:1;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:12:\"link_to_node\";i:1;}s:4:\"name\";a:25:{s:2:\"id\";s:4:\"name\";s:5:\"table\";s:5:\"users\";s:5:\"field\";s:4:\"name\";s:12:\"relationship\";s:3:\"uid\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:1;s:4:\"text\";s:9:\"By [name]\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:12:\"link_to_user\";i:1;s:19:\"overwrite_anonymous\";i:0;s:14:\"anonymous_text\";s:0:\"\";s:15:\"format_username\";i:1;}s:7:\"created\";a:26:{s:2:\"id\";s:7:\"created\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:7:\"created\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:39:\"<i class=\"fa fa-clock-o\"></i> [created]\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:11:\"date_format\";s:6:\"custom\";s:18:\"custom_date_format\";s:13:\"D M d, Y h:ma\";s:25:\"second_date_format_custom\";s:0:\"\";s:18:\"second_date_format\";s:4:\"long\";s:8:\"timezone\";s:0:\"\";}}s:8:\"defaults\";a:1:{s:6:\"fields\";b:0;}}'),(10,'default','Master','default',1,'a:12:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:6:\"access\";a:1:{s:4:\"type\";s:4:\"perm\";}s:5:\"cache\";a:1:{s:4:\"type\";s:4:\"none\";}s:12:\"exposed_form\";a:1:{s:4:\"type\";s:5:\"basic\";}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"some\";s:7:\"options\";a:2:{s:14:\"items_per_page\";s:1:\"3\";s:6:\"offset\";s:1:\"0\";}}s:12:\"style_plugin\";s:7:\"default\";s:10:\"row_plugin\";s:6:\"fields\";s:6:\"fields\";a:4:{s:7:\"picture\";a:23:{s:2:\"id\";s:7:\"picture\";s:5:\"table\";s:5:\"users\";s:5:\"field\";s:7:\"picture\";s:12:\"relationship\";s:3:\"uid\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:21:\"link_photo_to_profile\";i:1;s:11:\"image_style\";s:9:\"thumbnail\";}s:5:\"title\";a:22:{s:2:\"id\";s:5:\"title\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:5:\"title\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:2:\"20\";s:13:\"word_boundary\";i:0;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:1;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:1;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:12:\"link_to_node\";i:1;}s:4:\"name\";a:25:{s:2:\"id\";s:4:\"name\";s:5:\"table\";s:5:\"users\";s:5:\"field\";s:4:\"name\";s:12:\"relationship\";s:3:\"uid\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:1;s:4:\"text\";s:9:\"By [name]\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:12:\"link_to_user\";i:1;s:19:\"overwrite_anonymous\";i:0;s:14:\"anonymous_text\";s:0:\"\";s:15:\"format_username\";i:1;}s:7:\"created\";a:26:{s:2:\"id\";s:7:\"created\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:7:\"created\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:39:\"<i class=\"fa fa-clock-o\"></i> [created]\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:11:\"date_format\";s:6:\"custom\";s:18:\"custom_date_format\";s:13:\"D M d, Y h:ma\";s:25:\"second_date_format_custom\";s:0:\"\";s:18:\"second_date_format\";s:4:\"long\";s:8:\"timezone\";s:0:\"\";}}s:7:\"filters\";a:2:{s:6:\"status\";a:6:{s:5:\"value\";i:1;s:5:\"table\";s:4:\"node\";s:5:\"field\";s:6:\"status\";s:2:\"id\";s:6:\"status\";s:6:\"expose\";a:1:{s:8:\"operator\";b:0;}s:5:\"group\";i:1;}s:4:\"type\";a:13:{s:2:\"id\";s:4:\"type\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:4:\"type\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:8:\"operator\";s:2:\"in\";s:5:\"value\";a:1:{s:5:\"forum\";s:5:\"forum\";}s:5:\"group\";s:1:\"1\";s:7:\"exposed\";b:0;s:6:\"expose\";a:12:{s:11:\"operator_id\";b:0;s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:14:\"operator_label\";s:0:\"\";s:8:\"operator\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:1:{i:2;i:2;}s:6:\"reduce\";b:0;}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";i:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}}}s:5:\"sorts\";a:1:{s:7:\"created\";a:4:{s:2:\"id\";s:7:\"created\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:7:\"created\";s:5:\"order\";s:4:\"DESC\";}}s:5:\"title\";s:15:\"New Forum Posts\";s:13:\"relationships\";a:1:{s:3:\"uid\";a:8:{s:2:\"id\";s:3:\"uid\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:3:\"uid\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:6:\"author\";s:8:\"required\";i:0;}}}'),(11,'default','Master','default',1,'a:14:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:6:\"access\";a:1:{s:4:\"type\";s:4:\"perm\";}s:5:\"cache\";a:1:{s:4:\"type\";s:4:\"none\";}s:12:\"exposed_form\";a:1:{s:4:\"type\";s:5:\"basic\";}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"full\";s:7:\"options\";a:7:{s:14:\"items_per_page\";s:1:\"6\";s:6:\"offset\";s:1:\"0\";s:2:\"id\";s:1:\"0\";s:11:\"total_pages\";s:0:\"\";s:8:\"quantity\";s:1:\"9\";s:4:\"tags\";a:4:{s:5:\"first\";s:8:\"« first\";s:8:\"previous\";s:12:\"‹ previous\";s:4:\"next\";s:8:\"next ›\";s:4:\"last\";s:7:\"last »\";}s:6:\"expose\";a:7:{s:14:\"items_per_page\";i:0;s:20:\"items_per_page_label\";s:14:\"Items per page\";s:22:\"items_per_page_options\";s:17:\"5, 10, 20, 40, 60\";s:26:\"items_per_page_options_all\";i:0;s:32:\"items_per_page_options_all_label\";s:7:\"- All -\";s:6:\"offset\";i:0;s:12:\"offset_label\";s:6:\"Offset\";}}}s:12:\"style_plugin\";s:7:\"default\";s:10:\"row_plugin\";s:4:\"node\";s:6:\"fields\";a:14:{s:11:\"field_image\";a:34:{s:2:\"id\";s:11:\"field_image\";s:5:\"table\";s:22:\"field_data_field_image\";s:5:\"field\";s:11:\"field_image\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:1;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:17:\"click_sort_column\";s:3:\"fid\";s:4:\"type\";s:5:\"image\";s:8:\"settings\";a:2:{s:11:\"image_style\";s:5:\"large\";s:10:\"image_link\";s:7:\"content\";}s:12:\"group_column\";s:0:\"\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";s:3:\"all\";s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";i:0;}s:16:\"field_video_link\";a:34:{s:2:\"id\";s:16:\"field_video_link\";s:5:\"table\";s:27:\"field_data_field_video_link\";s:5:\"field\";s:16:\"field_video_link\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:1;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:17:\"click_sort_column\";s:9:\"video_url\";s:4:\"type\";s:17:\"video_embed_field\";s:8:\"settings\";a:1:{s:11:\"video_style\";s:5:\"large\";}s:12:\"group_column\";s:0:\"\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";s:3:\"all\";s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";i:0;}s:7:\"picture\";a:23:{s:2:\"id\";s:7:\"picture\";s:5:\"table\";s:5:\"users\";s:5:\"field\";s:7:\"picture\";s:12:\"relationship\";s:3:\"uid\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:1;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:21:\"link_photo_to_profile\";i:1;s:11:\"image_style\";s:9:\"thumbnail\";}s:8:\"fieldset\";a:23:{s:2:\"id\";s:8:\"fieldset\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:8:\"fieldset\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:8:\"Fieldset\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:0;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:8:\"children\";a:3:{i:0;s:5:\"title\";i:1;s:4:\"name\";i:2;s:7:\"created\";}s:8:\"fieldset\";a:5:{s:4:\"type\";s:3:\"div\";s:7:\"classes\";s:14:\"forum-metadata\";s:2:\"id\";s:0:\"\";s:11:\"collapsible\";i:0;s:9:\"collapsed\";i:0;}}s:5:\"title\";a:8:{s:2:\"id\";s:5:\"title\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:5:\"title\";s:5:\"label\";s:0:\"\";s:5:\"alter\";a:8:{s:10:\"alter_text\";i:0;s:9:\"make_link\";i:0;s:8:\"absolute\";i:0;s:4:\"trim\";i:0;s:13:\"word_boundary\";i:0;s:8:\"ellipsis\";i:0;s:10:\"strip_tags\";i:0;s:4:\"html\";i:0;}s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:12:\"link_to_node\";i:1;}s:4:\"name\";a:25:{s:2:\"id\";s:4:\"name\";s:5:\"table\";s:5:\"users\";s:5:\"field\";s:4:\"name\";s:12:\"relationship\";s:3:\"uid\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:1;s:4:\"text\";s:9:\"By [name]\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:12:\"link_to_user\";i:1;s:19:\"overwrite_anonymous\";i:0;s:14:\"anonymous_text\";s:0:\"\";s:15:\"format_username\";i:1;}s:7:\"created\";a:26:{s:2:\"id\";s:7:\"created\";s:5:\"table\";s:5:\"users\";s:5:\"field\";s:7:\"created\";s:12:\"relationship\";s:3:\"uid\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:39:\"<i class=\"fa fa-clock-o\"></i> [created]\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:11:\"date_format\";s:6:\"custom\";s:18:\"custom_date_format\";s:13:\"D M d, Y h:ma\";s:25:\"second_date_format_custom\";s:0:\"\";s:18:\"second_date_format\";s:4:\"long\";s:8:\"timezone\";s:0:\"\";}s:4:\"body\";a:34:{s:2:\"id\";s:4:\"body\";s:5:\"table\";s:15:\"field_data_body\";s:5:\"field\";s:4:\"body\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:3:\"300\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:1;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:1;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";s:3:\"all\";s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";i:0;}s:10:\"field_tags\";a:34:{s:2:\"id\";s:10:\"field_tags\";s:5:\"table\";s:21:\"field_data_field_tags\";s:5:\"field\";s:10:\"field_tags\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:17:\"click_sort_column\";s:3:\"tid\";s:4:\"type\";s:33:\"i18n_taxonomy_term_reference_link\";s:8:\"settings\";a:0:{}s:12:\"group_column\";s:3:\"tid\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";i:1;s:11:\"delta_limit\";s:3:\"all\";s:12:\"delta_offset\";s:1:\"0\";s:14:\"delta_reversed\";i:0;s:16:\"delta_first_last\";i:0;s:10:\"multi_type\";s:2:\"ul\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";i:0;}s:9:\"view_node\";a:22:{s:2:\"id\";s:9:\"view_node\";s:5:\"table\";s:17:\"views_entity_node\";s:5:\"field\";s:9:\"view_node\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:4:\"text\";s:9:\"Read more\";}s:10:\"fieldset_1\";a:23:{s:2:\"id\";s:10:\"fieldset_1\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:8:\"fieldset\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:8:\"Fieldset\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:0;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:8:\"children\";a:3:{i:0;s:13:\"comment_count\";i:1;s:10:\"totalcount\";i:2;s:9:\"sharethis\";}s:8:\"fieldset\";a:5:{s:4:\"type\";s:3:\"div\";s:7:\"classes\";s:17:\"forum-node-footer\";s:2:\"id\";s:0:\"\";s:11:\"collapsible\";i:0;s:9:\"collapsed\";i:0;}}s:13:\"comment_count\";a:30:{s:2:\"id\";s:13:\"comment_count\";s:5:\"table\";s:23:\"node_comment_statistics\";s:5:\"field\";s:13:\"comment_count\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:1;s:4:\"text\";s:46:\"<i class=\"fa fa-comments\"></i> [comment_count]\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:13:\"set_precision\";b:0;s:9:\"precision\";i:0;s:7:\"decimal\";s:1:\".\";s:9:\"separator\";s:1:\",\";s:13:\"format_plural\";i:0;s:22:\"format_plural_singular\";s:1:\"1\";s:20:\"format_plural_plural\";s:6:\"@count\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";}s:10:\"totalcount\";a:30:{s:2:\"id\";s:10:\"totalcount\";s:5:\"table\";s:12:\"node_counter\";s:5:\"field\";s:10:\"totalcount\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:1;s:4:\"text\";s:38:\"<i class=\"fa fa-eye\"></i> [totalcount]\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:13:\"set_precision\";b:0;s:9:\"precision\";i:0;s:7:\"decimal\";s:1:\".\";s:9:\"separator\";s:1:\",\";s:13:\"format_plural\";i:0;s:22:\"format_plural_singular\";s:1:\"1\";s:20:\"format_plural_plural\";s:6:\"@count\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";}s:9:\"sharethis\";a:21:{s:2:\"id\";s:9:\"sharethis\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:9:\"sharethis\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;}}s:7:\"filters\";a:2:{s:6:\"status\";a:6:{s:5:\"value\";i:1;s:5:\"table\";s:4:\"node\";s:5:\"field\";s:6:\"status\";s:2:\"id\";s:6:\"status\";s:6:\"expose\";a:1:{s:8:\"operator\";b:0;}s:5:\"group\";i:1;}s:4:\"type\";a:13:{s:2:\"id\";s:4:\"type\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:4:\"type\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:8:\"operator\";s:2:\"in\";s:5:\"value\";a:2:{s:4:\"blog\";s:4:\"blog\";s:5:\"video\";s:5:\"video\";}s:5:\"group\";s:1:\"1\";s:7:\"exposed\";b:0;s:6:\"expose\";a:12:{s:11:\"operator_id\";b:0;s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:12:\"use_operator\";b:0;s:14:\"operator_label\";s:0:\"\";s:8:\"operator\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"required\";b:0;s:8:\"remember\";b:0;s:8:\"multiple\";b:0;s:14:\"remember_roles\";a:1:{i:2;i:2;}s:6:\"reduce\";b:0;}s:10:\"is_grouped\";b:0;s:10:\"group_info\";a:10:{s:5:\"label\";s:0:\"\";s:11:\"description\";s:0:\"\";s:10:\"identifier\";s:0:\"\";s:8:\"optional\";b:1;s:6:\"widget\";s:6:\"select\";s:8:\"multiple\";b:0;s:8:\"remember\";i:0;s:13:\"default_group\";s:3:\"All\";s:22:\"default_group_multiple\";a:0:{}s:11:\"group_items\";a:0:{}}}}s:5:\"sorts\";a:1:{s:7:\"created\";a:4:{s:2:\"id\";s:7:\"created\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:7:\"created\";s:5:\"order\";s:4:\"DESC\";}}s:5:\"title\";s:5:\"Blogs\";s:11:\"row_options\";a:3:{s:10:\"build_mode\";s:6:\"teaser\";s:5:\"links\";b:1;s:8:\"comments\";b:0;}s:13:\"relationships\";a:1:{s:3:\"uid\";a:3:{s:2:\"id\";s:3:\"uid\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:3:\"uid\";}}s:9:\"css_class\";s:26:\"forum-blog-view one-column\";}'),(11,'page','Page','page',2,'a:6:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:4:\"path\";s:12:\"blogs/teaser\";s:4:\"menu\";a:7:{s:4:\"type\";s:6:\"normal\";s:5:\"title\";s:12:\"Blogs Teaser\";s:11:\"description\";s:0:\"\";s:4:\"name\";s:9:\"main-menu\";s:6:\"weight\";s:1:\"0\";s:7:\"context\";i:0;s:19:\"context_only_inline\";i:0;}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"full\";s:7:\"options\";a:7:{s:14:\"items_per_page\";s:1:\"4\";s:6:\"offset\";s:1:\"0\";s:2:\"id\";s:1:\"0\";s:11:\"total_pages\";s:0:\"\";s:8:\"quantity\";s:1:\"9\";s:4:\"tags\";a:4:{s:5:\"first\";s:8:\"« first\";s:8:\"previous\";s:12:\"‹ previous\";s:4:\"next\";s:8:\"next ›\";s:4:\"last\";s:7:\"last »\";}s:6:\"expose\";a:7:{s:14:\"items_per_page\";i:0;s:20:\"items_per_page_label\";s:14:\"Items per page\";s:22:\"items_per_page_options\";s:17:\"5, 10, 20, 40, 60\";s:26:\"items_per_page_options_all\";i:0;s:32:\"items_per_page_options_all_label\";s:7:\"- All -\";s:6:\"offset\";i:0;s:12:\"offset_label\";s:6:\"Offset\";}}}s:8:\"defaults\";a:2:{s:5:\"pager\";b:0;s:13:\"pager_options\";b:0;}s:13:\"pager_options\";N;}'),(11,'page_1','Page','page',3,'a:12:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:4:\"path\";s:5:\"blogs\";s:4:\"menu\";a:7:{s:4:\"type\";s:6:\"normal\";s:5:\"title\";s:5:\"Blogs\";s:11:\"description\";s:0:\"\";s:4:\"name\";s:9:\"main-menu\";s:6:\"weight\";s:1:\"0\";s:7:\"context\";i:0;s:19:\"context_only_inline\";i:0;}s:12:\"style_plugin\";s:7:\"default\";s:8:\"defaults\";a:8:{s:12:\"style_plugin\";b:0;s:13:\"style_options\";b:0;s:10:\"row_plugin\";b:0;s:11:\"row_options\";b:0;s:13:\"relationships\";b:0;s:6:\"fields\";b:0;s:5:\"pager\";b:0;s:13:\"pager_options\";b:0;}s:13:\"style_options\";a:0:{}s:10:\"row_plugin\";s:6:\"fields\";s:11:\"row_options\";a:4:{s:22:\"default_field_elements\";i:1;s:6:\"inline\";a:0:{}s:9:\"separator\";s:0:\"\";s:10:\"hide_empty\";i:0;}s:13:\"relationships\";a:1:{s:3:\"uid\";a:8:{s:2:\"id\";s:3:\"uid\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:3:\"uid\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:6:\"author\";s:8:\"required\";i:0;}}s:6:\"fields\";a:13:{s:11:\"field_image\";a:34:{s:2:\"id\";s:11:\"field_image\";s:5:\"table\";s:22:\"field_data_field_image\";s:5:\"field\";s:11:\"field_image\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:1;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:17:\"click_sort_column\";s:3:\"fid\";s:4:\"type\";s:5:\"image\";s:8:\"settings\";a:2:{s:11:\"image_style\";s:5:\"large\";s:10:\"image_link\";s:7:\"content\";}s:12:\"group_column\";s:0:\"\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";s:3:\"all\";s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";i:0;}s:16:\"field_video_link\";a:34:{s:2:\"id\";s:16:\"field_video_link\";s:5:\"table\";s:27:\"field_data_field_video_link\";s:5:\"field\";s:16:\"field_video_link\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:1;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:17:\"click_sort_column\";s:9:\"video_url\";s:4:\"type\";s:17:\"video_embed_field\";s:8:\"settings\";a:1:{s:11:\"video_style\";s:5:\"large\";}s:12:\"group_column\";s:0:\"\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";s:3:\"all\";s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";i:0;}s:8:\"fieldset\";a:23:{s:2:\"id\";s:8:\"fieldset\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:8:\"fieldset\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:8:\"Fieldset\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:0;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:8:\"children\";a:3:{i:0;s:5:\"title\";i:1;s:4:\"name\";i:2;s:7:\"created\";}s:8:\"fieldset\";a:5:{s:4:\"type\";s:3:\"div\";s:7:\"classes\";s:14:\"forum-metadata\";s:2:\"id\";s:0:\"\";s:11:\"collapsible\";i:0;s:9:\"collapsed\";i:0;}}s:5:\"title\";a:8:{s:2:\"id\";s:5:\"title\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:5:\"title\";s:5:\"label\";s:0:\"\";s:5:\"alter\";a:8:{s:10:\"alter_text\";i:0;s:9:\"make_link\";i:0;s:8:\"absolute\";i:0;s:4:\"trim\";i:0;s:13:\"word_boundary\";i:0;s:8:\"ellipsis\";i:0;s:10:\"strip_tags\";i:0;s:4:\"html\";i:0;}s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:12:\"link_to_node\";i:1;}s:4:\"name\";a:25:{s:2:\"id\";s:4:\"name\";s:5:\"table\";s:5:\"users\";s:5:\"field\";s:4:\"name\";s:12:\"relationship\";s:3:\"uid\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:1;s:4:\"text\";s:9:\"By [name]\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:12:\"link_to_user\";i:1;s:19:\"overwrite_anonymous\";i:0;s:14:\"anonymous_text\";s:0:\"\";s:15:\"format_username\";i:1;}s:7:\"created\";a:26:{s:2:\"id\";s:7:\"created\";s:5:\"table\";s:5:\"users\";s:5:\"field\";s:7:\"created\";s:12:\"relationship\";s:3:\"uid\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:39:\"<i class=\"fa fa-clock-o\"></i> [created]\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:11:\"date_format\";s:6:\"custom\";s:18:\"custom_date_format\";s:13:\"D M d, Y h:ma\";s:25:\"second_date_format_custom\";s:0:\"\";s:18:\"second_date_format\";s:4:\"long\";s:8:\"timezone\";s:0:\"\";}s:4:\"body\";a:34:{s:2:\"id\";s:4:\"body\";s:5:\"table\";s:15:\"field_data_body\";s:5:\"field\";s:4:\"body\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:3:\"300\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:1;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:1;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";s:3:\"all\";s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";i:0;}s:10:\"field_tags\";a:34:{s:2:\"id\";s:10:\"field_tags\";s:5:\"table\";s:21:\"field_data_field_tags\";s:5:\"field\";s:10:\"field_tags\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:17:\"click_sort_column\";s:3:\"tid\";s:4:\"type\";s:33:\"i18n_taxonomy_term_reference_link\";s:8:\"settings\";a:0:{}s:12:\"group_column\";s:3:\"tid\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";i:1;s:11:\"delta_limit\";s:3:\"all\";s:12:\"delta_offset\";s:1:\"0\";s:14:\"delta_reversed\";i:0;s:16:\"delta_first_last\";i:0;s:10:\"multi_type\";s:2:\"ul\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";i:0;}s:9:\"view_node\";a:22:{s:2:\"id\";s:9:\"view_node\";s:5:\"table\";s:17:\"views_entity_node\";s:5:\"field\";s:9:\"view_node\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:4:\"text\";s:12:\"Read more...\";}s:10:\"fieldset_1\";a:23:{s:2:\"id\";s:10:\"fieldset_1\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:8:\"fieldset\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:8:\"Fieldset\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:0;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:8:\"children\";a:3:{i:0;s:13:\"comment_count\";i:1;s:10:\"totalcount\";i:2;s:9:\"sharethis\";}s:8:\"fieldset\";a:5:{s:4:\"type\";s:3:\"div\";s:7:\"classes\";s:17:\"forum-node-footer\";s:2:\"id\";s:0:\"\";s:11:\"collapsible\";i:0;s:9:\"collapsed\";i:0;}}s:13:\"comment_count\";a:30:{s:2:\"id\";s:13:\"comment_count\";s:5:\"table\";s:23:\"node_comment_statistics\";s:5:\"field\";s:13:\"comment_count\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:1;s:4:\"text\";s:46:\"<i class=\"fa fa-comments\"></i> [comment_count]\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:13:\"set_precision\";b:0;s:9:\"precision\";i:0;s:7:\"decimal\";s:1:\".\";s:9:\"separator\";s:1:\",\";s:13:\"format_plural\";i:0;s:22:\"format_plural_singular\";s:1:\"1\";s:20:\"format_plural_plural\";s:6:\"@count\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";}s:10:\"totalcount\";a:30:{s:2:\"id\";s:10:\"totalcount\";s:5:\"table\";s:12:\"node_counter\";s:5:\"field\";s:10:\"totalcount\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:1;s:4:\"text\";s:38:\"<i class=\"fa fa-eye\"></i> [totalcount]\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:13:\"set_precision\";b:0;s:9:\"precision\";i:0;s:7:\"decimal\";s:1:\".\";s:9:\"separator\";s:1:\",\";s:13:\"format_plural\";i:0;s:22:\"format_plural_singular\";s:1:\"1\";s:20:\"format_plural_plural\";s:6:\"@count\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";}s:9:\"sharethis\";a:21:{s:2:\"id\";s:9:\"sharethis\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:9:\"sharethis\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;}}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"full\";s:7:\"options\";a:7:{s:14:\"items_per_page\";s:1:\"4\";s:6:\"offset\";s:1:\"0\";s:2:\"id\";s:1:\"0\";s:11:\"total_pages\";s:0:\"\";s:8:\"quantity\";s:1:\"9\";s:4:\"tags\";a:4:{s:5:\"first\";s:8:\"« first\";s:8:\"previous\";s:12:\"‹ previous\";s:4:\"next\";s:8:\"next ›\";s:4:\"last\";s:7:\"last »\";}s:6:\"expose\";a:7:{s:14:\"items_per_page\";i:0;s:20:\"items_per_page_label\";s:14:\"Items per page\";s:22:\"items_per_page_options\";s:17:\"5, 10, 20, 40, 60\";s:26:\"items_per_page_options_all\";i:0;s:32:\"items_per_page_options_all_label\";s:7:\"- All -\";s:6:\"offset\";i:0;s:12:\"offset_label\";s:6:\"Offset\";}}}s:13:\"pager_options\";N;}'),(11,'page_2','Page','page',4,'a:11:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:4:\"path\";s:9:\"blogs/two\";s:4:\"menu\";a:7:{s:4:\"type\";s:6:\"normal\";s:5:\"title\";s:11:\"Two Columns\";s:11:\"description\";s:0:\"\";s:4:\"name\";s:9:\"main-menu\";s:6:\"weight\";s:1:\"0\";s:7:\"context\";i:0;s:19:\"context_only_inline\";i:0;}s:12:\"style_plugin\";s:4:\"grid\";s:8:\"defaults\";a:7:{s:12:\"style_plugin\";b:0;s:13:\"style_options\";b:0;s:10:\"row_plugin\";b:0;s:11:\"row_options\";b:0;s:13:\"relationships\";b:0;s:6:\"fields\";b:0;s:9:\"css_class\";b:0;}s:13:\"style_options\";a:9:{s:8:\"grouping\";a:0:{}s:9:\"row_class\";s:0:\"\";s:17:\"default_row_class\";i:1;s:17:\"row_class_special\";i:1;s:7:\"columns\";s:1:\"2\";s:9:\"alignment\";s:10:\"horizontal\";s:16:\"fill_single_line\";i:1;s:7:\"caption\";s:0:\"\";s:7:\"summary\";s:0:\"\";}s:10:\"row_plugin\";s:6:\"fields\";s:11:\"row_options\";a:4:{s:22:\"default_field_elements\";i:1;s:6:\"inline\";a:0:{}s:9:\"separator\";s:0:\"\";s:10:\"hide_empty\";i:0;}s:13:\"relationships\";a:1:{s:3:\"uid\";a:8:{s:2:\"id\";s:3:\"uid\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:3:\"uid\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:6:\"author\";s:8:\"required\";i:0;}}s:6:\"fields\";a:13:{s:11:\"field_image\";a:34:{s:2:\"id\";s:11:\"field_image\";s:5:\"table\";s:22:\"field_data_field_image\";s:5:\"field\";s:11:\"field_image\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:1;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:17:\"click_sort_column\";s:3:\"fid\";s:4:\"type\";s:5:\"image\";s:8:\"settings\";a:2:{s:11:\"image_style\";s:11:\"two_columns\";s:10:\"image_link\";s:7:\"content\";}s:12:\"group_column\";s:0:\"\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";s:3:\"all\";s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";i:0;}s:16:\"field_video_link\";a:34:{s:2:\"id\";s:16:\"field_video_link\";s:5:\"table\";s:27:\"field_data_field_video_link\";s:5:\"field\";s:16:\"field_video_link\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:1;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:17:\"click_sort_column\";s:9:\"video_url\";s:4:\"type\";s:17:\"video_embed_field\";s:8:\"settings\";a:1:{s:11:\"video_style\";s:11:\"two_columns\";}s:12:\"group_column\";s:0:\"\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";s:3:\"all\";s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";i:0;}s:8:\"fieldset\";a:23:{s:2:\"id\";s:8:\"fieldset\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:8:\"fieldset\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:8:\"Fieldset\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:0;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:8:\"children\";a:3:{i:0;s:5:\"title\";i:1;s:4:\"name\";i:2;s:7:\"created\";}s:8:\"fieldset\";a:5:{s:4:\"type\";s:3:\"div\";s:7:\"classes\";s:14:\"forum-metadata\";s:2:\"id\";s:0:\"\";s:11:\"collapsible\";i:0;s:9:\"collapsed\";i:0;}}s:5:\"title\";a:22:{s:2:\"id\";s:5:\"title\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:5:\"title\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:2:\"30\";s:13:\"word_boundary\";i:0;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:1;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:1;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:12:\"link_to_node\";i:1;}s:4:\"name\";a:25:{s:2:\"id\";s:4:\"name\";s:5:\"table\";s:5:\"users\";s:5:\"field\";s:4:\"name\";s:12:\"relationship\";s:3:\"uid\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:1;s:4:\"text\";s:9:\"By [name]\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:12:\"link_to_user\";i:1;s:19:\"overwrite_anonymous\";i:0;s:14:\"anonymous_text\";s:0:\"\";s:15:\"format_username\";i:1;}s:7:\"created\";a:26:{s:2:\"id\";s:7:\"created\";s:5:\"table\";s:5:\"users\";s:5:\"field\";s:7:\"created\";s:12:\"relationship\";s:3:\"uid\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:39:\"<i class=\"fa fa-clock-o\"></i> [created]\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:11:\"date_format\";s:6:\"custom\";s:18:\"custom_date_format\";s:13:\"D M d, Y h:ma\";s:25:\"second_date_format_custom\";s:0:\"\";s:18:\"second_date_format\";s:4:\"long\";s:8:\"timezone\";s:0:\"\";}s:4:\"body\";a:34:{s:2:\"id\";s:4:\"body\";s:5:\"table\";s:15:\"field_data_body\";s:5:\"field\";s:4:\"body\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:3:\"280\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:1;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:1;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";s:3:\"all\";s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";i:0;}s:10:\"field_tags\";a:34:{s:2:\"id\";s:10:\"field_tags\";s:5:\"table\";s:21:\"field_data_field_tags\";s:5:\"field\";s:10:\"field_tags\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:17:\"click_sort_column\";s:3:\"tid\";s:4:\"type\";s:33:\"i18n_taxonomy_term_reference_link\";s:8:\"settings\";a:0:{}s:12:\"group_column\";s:3:\"tid\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";i:1;s:11:\"delta_limit\";s:3:\"all\";s:12:\"delta_offset\";s:1:\"0\";s:14:\"delta_reversed\";i:0;s:16:\"delta_first_last\";i:0;s:10:\"multi_type\";s:2:\"ul\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";i:0;}s:9:\"view_node\";a:22:{s:2:\"id\";s:9:\"view_node\";s:5:\"table\";s:17:\"views_entity_node\";s:5:\"field\";s:9:\"view_node\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:4:\"text\";s:12:\"Read more...\";}s:10:\"fieldset_1\";a:23:{s:2:\"id\";s:10:\"fieldset_1\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:8:\"fieldset\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:8:\"Fieldset\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:0;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:8:\"children\";a:3:{i:0;s:13:\"comment_count\";i:1;s:10:\"totalcount\";i:2;s:9:\"sharethis\";}s:8:\"fieldset\";a:5:{s:4:\"type\";s:3:\"div\";s:7:\"classes\";s:17:\"forum-node-footer\";s:2:\"id\";s:0:\"\";s:11:\"collapsible\";i:0;s:9:\"collapsed\";i:0;}}s:13:\"comment_count\";a:30:{s:2:\"id\";s:13:\"comment_count\";s:5:\"table\";s:23:\"node_comment_statistics\";s:5:\"field\";s:13:\"comment_count\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:1;s:4:\"text\";s:46:\"<i class=\"fa fa-comments\"></i> [comment_count]\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:13:\"set_precision\";b:0;s:9:\"precision\";i:0;s:7:\"decimal\";s:1:\".\";s:9:\"separator\";s:1:\",\";s:13:\"format_plural\";i:0;s:22:\"format_plural_singular\";s:1:\"1\";s:20:\"format_plural_plural\";s:6:\"@count\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";}s:10:\"totalcount\";a:30:{s:2:\"id\";s:10:\"totalcount\";s:5:\"table\";s:12:\"node_counter\";s:5:\"field\";s:10:\"totalcount\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:1;s:4:\"text\";s:38:\"<i class=\"fa fa-eye\"></i> [totalcount]\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:13:\"set_precision\";b:0;s:9:\"precision\";i:0;s:7:\"decimal\";s:1:\".\";s:9:\"separator\";s:1:\",\";s:13:\"format_plural\";i:0;s:22:\"format_plural_singular\";s:1:\"1\";s:20:\"format_plural_plural\";s:6:\"@count\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";}s:9:\"sharethis\";a:21:{s:2:\"id\";s:9:\"sharethis\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:9:\"sharethis\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;}}s:9:\"css_class\";s:26:\"forum-blog-view two-column\";}'),(11,'page_3','Page','page',5,'a:11:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:4:\"path\";s:11:\"blogs/three\";s:4:\"menu\";a:7:{s:4:\"type\";s:6:\"normal\";s:5:\"title\";s:13:\"Three Columns\";s:11:\"description\";s:0:\"\";s:4:\"name\";s:9:\"main-menu\";s:6:\"weight\";s:1:\"0\";s:7:\"context\";i:0;s:19:\"context_only_inline\";i:0;}s:12:\"style_plugin\";s:4:\"grid\";s:8:\"defaults\";a:7:{s:12:\"style_plugin\";b:0;s:13:\"style_options\";b:0;s:10:\"row_plugin\";b:0;s:11:\"row_options\";b:0;s:13:\"relationships\";b:0;s:6:\"fields\";b:0;s:9:\"css_class\";b:0;}s:13:\"style_options\";a:9:{s:8:\"grouping\";a:0:{}s:9:\"row_class\";s:0:\"\";s:17:\"default_row_class\";i:1;s:17:\"row_class_special\";i:1;s:7:\"columns\";s:1:\"3\";s:9:\"alignment\";s:10:\"horizontal\";s:16:\"fill_single_line\";i:1;s:7:\"caption\";s:0:\"\";s:7:\"summary\";s:0:\"\";}s:10:\"row_plugin\";s:6:\"fields\";s:11:\"row_options\";a:4:{s:22:\"default_field_elements\";i:1;s:6:\"inline\";a:0:{}s:9:\"separator\";s:0:\"\";s:10:\"hide_empty\";i:0;}s:13:\"relationships\";a:1:{s:3:\"uid\";a:8:{s:2:\"id\";s:3:\"uid\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:3:\"uid\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:6:\"author\";s:8:\"required\";i:0;}}s:6:\"fields\";a:13:{s:11:\"field_image\";a:34:{s:2:\"id\";s:11:\"field_image\";s:5:\"table\";s:22:\"field_data_field_image\";s:5:\"field\";s:11:\"field_image\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:1;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:17:\"click_sort_column\";s:3:\"fid\";s:4:\"type\";s:5:\"image\";s:8:\"settings\";a:2:{s:11:\"image_style\";s:13:\"three_columns\";s:10:\"image_link\";s:7:\"content\";}s:12:\"group_column\";s:0:\"\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";s:3:\"all\";s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";i:0;}s:16:\"field_video_link\";a:34:{s:2:\"id\";s:16:\"field_video_link\";s:5:\"table\";s:27:\"field_data_field_video_link\";s:5:\"field\";s:16:\"field_video_link\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:1;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:17:\"click_sort_column\";s:9:\"video_url\";s:4:\"type\";s:17:\"video_embed_field\";s:8:\"settings\";a:1:{s:11:\"video_style\";s:13:\"three_columns\";}s:12:\"group_column\";s:0:\"\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";s:3:\"all\";s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";i:0;}s:8:\"fieldset\";a:23:{s:2:\"id\";s:8:\"fieldset\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:8:\"fieldset\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:8:\"Fieldset\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:0;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:8:\"children\";a:3:{i:0;s:5:\"title\";i:1;s:4:\"name\";i:2;s:7:\"created\";}s:8:\"fieldset\";a:5:{s:4:\"type\";s:3:\"div\";s:7:\"classes\";s:14:\"forum-metadata\";s:2:\"id\";s:0:\"\";s:11:\"collapsible\";i:0;s:9:\"collapsed\";i:0;}}s:5:\"title\";a:22:{s:2:\"id\";s:5:\"title\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:5:\"title\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:2:\"20\";s:13:\"word_boundary\";i:0;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:1;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:1;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:12:\"link_to_node\";i:1;}s:4:\"name\";a:25:{s:2:\"id\";s:4:\"name\";s:5:\"table\";s:5:\"users\";s:5:\"field\";s:4:\"name\";s:12:\"relationship\";s:3:\"uid\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:1;s:4:\"text\";s:9:\"By [name]\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:12:\"link_to_user\";i:1;s:19:\"overwrite_anonymous\";i:0;s:14:\"anonymous_text\";s:0:\"\";s:15:\"format_username\";i:1;}s:7:\"created\";a:26:{s:2:\"id\";s:7:\"created\";s:5:\"table\";s:5:\"users\";s:5:\"field\";s:7:\"created\";s:12:\"relationship\";s:3:\"uid\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:39:\"<i class=\"fa fa-clock-o\"></i> [created]\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:11:\"date_format\";s:6:\"custom\";s:18:\"custom_date_format\";s:13:\"D M d, Y h:ma\";s:25:\"second_date_format_custom\";s:0:\"\";s:18:\"second_date_format\";s:4:\"long\";s:8:\"timezone\";s:0:\"\";}s:4:\"body\";a:34:{s:2:\"id\";s:4:\"body\";s:5:\"table\";s:15:\"field_data_body\";s:5:\"field\";s:4:\"body\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:3:\"280\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:1;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:1;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";s:3:\"all\";s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";i:0;}s:10:\"field_tags\";a:34:{s:2:\"id\";s:10:\"field_tags\";s:5:\"table\";s:21:\"field_data_field_tags\";s:5:\"field\";s:10:\"field_tags\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:17:\"click_sort_column\";s:3:\"tid\";s:4:\"type\";s:33:\"i18n_taxonomy_term_reference_link\";s:8:\"settings\";a:0:{}s:12:\"group_column\";s:3:\"tid\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";i:1;s:11:\"delta_limit\";s:3:\"all\";s:12:\"delta_offset\";s:1:\"0\";s:14:\"delta_reversed\";i:0;s:16:\"delta_first_last\";i:0;s:10:\"multi_type\";s:2:\"ul\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";i:0;}s:9:\"view_node\";a:22:{s:2:\"id\";s:9:\"view_node\";s:5:\"table\";s:17:\"views_entity_node\";s:5:\"field\";s:9:\"view_node\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:4:\"text\";s:12:\"Read more...\";}s:10:\"fieldset_1\";a:23:{s:2:\"id\";s:10:\"fieldset_1\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:8:\"fieldset\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:8:\"Fieldset\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:0;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:8:\"children\";a:3:{i:0;s:13:\"comment_count\";i:1;s:10:\"totalcount\";i:2;s:9:\"sharethis\";}s:8:\"fieldset\";a:5:{s:4:\"type\";s:3:\"div\";s:7:\"classes\";s:17:\"forum-node-footer\";s:2:\"id\";s:0:\"\";s:11:\"collapsible\";i:0;s:9:\"collapsed\";i:0;}}s:13:\"comment_count\";a:30:{s:2:\"id\";s:13:\"comment_count\";s:5:\"table\";s:23:\"node_comment_statistics\";s:5:\"field\";s:13:\"comment_count\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:1;s:4:\"text\";s:46:\"<i class=\"fa fa-comments\"></i> [comment_count]\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:13:\"set_precision\";b:0;s:9:\"precision\";i:0;s:7:\"decimal\";s:1:\".\";s:9:\"separator\";s:1:\",\";s:13:\"format_plural\";i:0;s:22:\"format_plural_singular\";s:1:\"1\";s:20:\"format_plural_plural\";s:6:\"@count\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";}s:10:\"totalcount\";a:30:{s:2:\"id\";s:10:\"totalcount\";s:5:\"table\";s:12:\"node_counter\";s:5:\"field\";s:10:\"totalcount\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:1;s:4:\"text\";s:38:\"<i class=\"fa fa-eye\"></i> [totalcount]\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:13:\"set_precision\";b:0;s:9:\"precision\";i:0;s:7:\"decimal\";s:1:\".\";s:9:\"separator\";s:1:\",\";s:13:\"format_plural\";i:0;s:22:\"format_plural_singular\";s:1:\"1\";s:20:\"format_plural_plural\";s:6:\"@count\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";}s:9:\"sharethis\";a:21:{s:2:\"id\";s:9:\"sharethis\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:9:\"sharethis\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;}}s:9:\"css_class\";s:28:\"forum-blog-view three-column\";}'),(11,'page_4','Page','page',6,'a:11:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:4:\"path\";s:9:\"blogs/mix\";s:4:\"menu\";a:7:{s:4:\"type\";s:6:\"normal\";s:5:\"title\";s:8:\"Blog Mix\";s:11:\"description\";s:0:\"\";s:4:\"name\";s:9:\"main-menu\";s:6:\"weight\";s:1:\"0\";s:7:\"context\";i:0;s:19:\"context_only_inline\";i:0;}s:12:\"style_plugin\";s:7:\"default\";s:8:\"defaults\";a:7:{s:12:\"style_plugin\";b:0;s:13:\"style_options\";b:0;s:10:\"row_plugin\";b:0;s:11:\"row_options\";b:0;s:13:\"relationships\";b:0;s:6:\"fields\";b:0;s:9:\"css_class\";b:0;}s:13:\"style_options\";a:0:{}s:10:\"row_plugin\";s:6:\"fields\";s:11:\"row_options\";a:4:{s:22:\"default_field_elements\";i:1;s:6:\"inline\";a:0:{}s:9:\"separator\";s:0:\"\";s:10:\"hide_empty\";i:0;}s:13:\"relationships\";a:1:{s:3:\"uid\";a:8:{s:2:\"id\";s:3:\"uid\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:3:\"uid\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:6:\"author\";s:8:\"required\";i:0;}}s:6:\"fields\";a:13:{s:11:\"field_image\";a:34:{s:2:\"id\";s:11:\"field_image\";s:5:\"table\";s:22:\"field_data_field_image\";s:5:\"field\";s:11:\"field_image\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:1;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:17:\"click_sort_column\";s:3:\"fid\";s:4:\"type\";s:5:\"image\";s:8:\"settings\";a:2:{s:11:\"image_style\";s:8:\"blog_mix\";s:10:\"image_link\";s:7:\"content\";}s:12:\"group_column\";s:0:\"\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";s:3:\"all\";s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";i:0;}s:16:\"field_video_link\";a:34:{s:2:\"id\";s:16:\"field_video_link\";s:5:\"table\";s:27:\"field_data_field_video_link\";s:5:\"field\";s:16:\"field_video_link\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:1;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:17:\"click_sort_column\";s:9:\"video_url\";s:4:\"type\";s:27:\"video_embed_field_thumbnail\";s:8:\"settings\";a:2:{s:11:\"image_style\";s:8:\"blog_mix\";s:10:\"image_link\";s:7:\"content\";}s:12:\"group_column\";s:0:\"\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";s:3:\"all\";s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";i:0;}s:8:\"fieldset\";a:23:{s:2:\"id\";s:8:\"fieldset\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:8:\"fieldset\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:8:\"Fieldset\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:0;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:8:\"children\";a:3:{i:0;s:5:\"title\";i:1;s:4:\"name\";i:2;s:7:\"created\";}s:8:\"fieldset\";a:5:{s:4:\"type\";s:3:\"div\";s:7:\"classes\";s:14:\"forum-metadata\";s:2:\"id\";s:0:\"\";s:11:\"collapsible\";i:0;s:9:\"collapsed\";i:0;}}s:5:\"title\";a:8:{s:2:\"id\";s:5:\"title\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:5:\"title\";s:5:\"label\";s:0:\"\";s:5:\"alter\";a:8:{s:10:\"alter_text\";i:0;s:9:\"make_link\";i:0;s:8:\"absolute\";i:0;s:4:\"trim\";i:0;s:13:\"word_boundary\";i:0;s:8:\"ellipsis\";i:0;s:10:\"strip_tags\";i:0;s:4:\"html\";i:0;}s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:12:\"link_to_node\";i:1;}s:4:\"name\";a:25:{s:2:\"id\";s:4:\"name\";s:5:\"table\";s:5:\"users\";s:5:\"field\";s:4:\"name\";s:12:\"relationship\";s:3:\"uid\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:1;s:4:\"text\";s:9:\"By [name]\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:12:\"link_to_user\";i:1;s:19:\"overwrite_anonymous\";i:0;s:14:\"anonymous_text\";s:0:\"\";s:15:\"format_username\";i:1;}s:7:\"created\";a:26:{s:2:\"id\";s:7:\"created\";s:5:\"table\";s:5:\"users\";s:5:\"field\";s:7:\"created\";s:12:\"relationship\";s:3:\"uid\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:39:\"<i class=\"fa fa-clock-o\"></i> [created]\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:11:\"date_format\";s:6:\"custom\";s:18:\"custom_date_format\";s:13:\"D M d, Y h:ma\";s:25:\"second_date_format_custom\";s:0:\"\";s:18:\"second_date_format\";s:4:\"long\";s:8:\"timezone\";s:0:\"\";}s:4:\"body\";a:34:{s:2:\"id\";s:4:\"body\";s:5:\"table\";s:15:\"field_data_body\";s:5:\"field\";s:4:\"body\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:3:\"300\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:1;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:1;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:17:\"click_sort_column\";s:5:\"value\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:12:\"group_column\";s:5:\"value\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";s:3:\"all\";s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";i:0;}s:10:\"field_tags\";a:34:{s:2:\"id\";s:10:\"field_tags\";s:5:\"table\";s:21:\"field_data_field_tags\";s:5:\"field\";s:10:\"field_tags\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:17:\"click_sort_column\";s:3:\"tid\";s:4:\"type\";s:33:\"i18n_taxonomy_term_reference_link\";s:8:\"settings\";a:0:{}s:12:\"group_column\";s:3:\"tid\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";i:1;s:11:\"delta_limit\";s:3:\"all\";s:12:\"delta_offset\";s:1:\"0\";s:14:\"delta_reversed\";i:0;s:16:\"delta_first_last\";i:0;s:10:\"multi_type\";s:2:\"ul\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";i:0;}s:9:\"view_node\";a:22:{s:2:\"id\";s:9:\"view_node\";s:5:\"table\";s:17:\"views_entity_node\";s:5:\"field\";s:9:\"view_node\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:4:\"text\";s:12:\"Read more...\";}s:10:\"fieldset_1\";a:23:{s:2:\"id\";s:10:\"fieldset_1\";s:5:\"table\";s:5:\"views\";s:5:\"field\";s:8:\"fieldset\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:8:\"Fieldset\";s:7:\"exclude\";b:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";b:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";b:0;s:8:\"external\";b:0;s:14:\"replace_spaces\";b:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";b:1;s:8:\"ellipsis\";b:1;s:9:\"more_link\";b:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";b:0;s:4:\"trim\";b:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";b:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:1;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";b:0;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";b:0;s:16:\"hide_alter_empty\";b:1;s:8:\"children\";a:3:{i:0;s:13:\"comment_count\";i:1;s:10:\"totalcount\";i:2;s:9:\"sharethis\";}s:8:\"fieldset\";a:5:{s:4:\"type\";s:3:\"div\";s:7:\"classes\";s:17:\"forum-node-footer\";s:2:\"id\";s:0:\"\";s:11:\"collapsible\";i:0;s:9:\"collapsed\";i:0;}}s:13:\"comment_count\";a:30:{s:2:\"id\";s:13:\"comment_count\";s:5:\"table\";s:23:\"node_comment_statistics\";s:5:\"field\";s:13:\"comment_count\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:1;s:4:\"text\";s:46:\"<i class=\"fa fa-comments\"></i> [comment_count]\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:13:\"set_precision\";b:0;s:9:\"precision\";i:0;s:7:\"decimal\";s:1:\".\";s:9:\"separator\";s:1:\",\";s:13:\"format_plural\";i:0;s:22:\"format_plural_singular\";s:1:\"1\";s:20:\"format_plural_plural\";s:6:\"@count\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";}s:10:\"totalcount\";a:30:{s:2:\"id\";s:10:\"totalcount\";s:5:\"table\";s:12:\"node_counter\";s:5:\"field\";s:10:\"totalcount\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:1;s:4:\"text\";s:38:\"<i class=\"fa fa-eye\"></i> [totalcount]\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:13:\"set_precision\";b:0;s:9:\"precision\";i:0;s:7:\"decimal\";s:1:\".\";s:9:\"separator\";s:1:\",\";s:13:\"format_plural\";i:0;s:22:\"format_plural_singular\";s:1:\"1\";s:20:\"format_plural_plural\";s:6:\"@count\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";}s:9:\"sharethis\";a:21:{s:2:\"id\";s:9:\"sharethis\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:9:\"sharethis\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;}}s:9:\"css_class\";s:24:\"forum-blog-view mix-blog\";}'),(12,'block','Block','block',2,'a:1:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}}'),(12,'default','Master','default',1,'a:12:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:5:\"title\";s:13:\"What is news?\";s:15:\"use_more_always\";b:0;s:6:\"access\";a:1:{s:4:\"type\";s:4:\"perm\";}s:5:\"cache\";a:1:{s:4:\"type\";s:4:\"none\";}s:12:\"exposed_form\";a:1:{s:4:\"type\";s:5:\"basic\";}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"some\";s:7:\"options\";a:1:{s:14:\"items_per_page\";s:1:\"1\";}}s:12:\"style_plugin\";s:7:\"default\";s:10:\"row_plugin\";s:6:\"fields\";s:6:\"fields\";a:3:{s:11:\"field_image\";a:34:{s:2:\"id\";s:11:\"field_image\";s:5:\"table\";s:22:\"field_data_field_image\";s:5:\"field\";s:11:\"field_image\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:17:\"click_sort_column\";s:3:\"fid\";s:4:\"type\";s:5:\"image\";s:8:\"settings\";a:2:{s:11:\"image_style\";s:12:\"four_columns\";s:10:\"image_link\";s:7:\"content\";}s:12:\"group_column\";s:0:\"\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";s:3:\"all\";s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";i:0;}s:5:\"title\";a:5:{s:2:\"id\";s:5:\"title\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:5:\"title\";s:5:\"label\";s:0:\"\";s:5:\"alter\";a:2:{s:13:\"word_boundary\";b:0;s:8:\"ellipsis\";b:0;}}s:4:\"body\";a:7:{s:2:\"id\";s:4:\"body\";s:5:\"table\";s:15:\"field_data_body\";s:5:\"field\";s:4:\"body\";s:5:\"label\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:4:\"type\";s:23:\"text_summary_or_trimmed\";s:8:\"settings\";a:1:{s:11:\"trim_length\";s:3:\"300\";}}}s:5:\"sorts\";a:1:{s:7:\"created\";a:4:{s:2:\"id\";s:7:\"created\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:7:\"created\";s:5:\"order\";s:4:\"DESC\";}}s:7:\"filters\";a:3:{s:6:\"status\";a:6:{s:2:\"id\";s:6:\"status\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:6:\"status\";s:5:\"value\";i:1;s:5:\"group\";i:1;s:6:\"expose\";a:1:{s:8:\"operator\";b:0;}}s:4:\"type\";a:4:{s:2:\"id\";s:4:\"type\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:4:\"type\";s:5:\"value\";a:1:{s:4:\"blog\";s:4:\"blog\";}}s:15:\"field_image_fid\";a:4:{s:2:\"id\";s:15:\"field_image_fid\";s:5:\"table\";s:22:\"field_data_field_image\";s:5:\"field\";s:15:\"field_image_fid\";s:8:\"operator\";s:9:\"not empty\";}}}'),(13,'block','Block','block',2,'a:2:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:5:\"field\";a:1:{s:5:\"title\";a:1:{s:12:\"link_to_node\";i:1;}}}'),(13,'default','Master','default',1,'a:12:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:6:\"access\";a:1:{s:4:\"type\";s:4:\"perm\";}s:5:\"cache\";a:1:{s:4:\"type\";s:4:\"none\";}s:12:\"exposed_form\";a:1:{s:4:\"type\";s:5:\"basic\";}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"some\";s:7:\"options\";a:2:{s:14:\"items_per_page\";s:1:\"1\";s:6:\"offset\";s:1:\"0\";}}s:12:\"style_plugin\";s:7:\"default\";s:10:\"row_plugin\";s:6:\"fields\";s:6:\"fields\";a:1:{s:16:\"field_video_link\";a:34:{s:2:\"id\";s:16:\"field_video_link\";s:5:\"table\";s:27:\"field_data_field_video_link\";s:5:\"field\";s:16:\"field_video_link\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:17:\"click_sort_column\";s:9:\"video_url\";s:4:\"type\";s:27:\"video_embed_field_thumbnail\";s:8:\"settings\";a:2:{s:11:\"image_style\";s:0:\"\";s:10:\"image_link\";s:7:\"content\";}s:12:\"group_column\";s:0:\"\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";s:3:\"all\";s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";i:0;}}s:7:\"filters\";a:2:{s:6:\"status\";a:6:{s:5:\"value\";i:1;s:5:\"table\";s:4:\"node\";s:5:\"field\";s:6:\"status\";s:2:\"id\";s:6:\"status\";s:6:\"expose\";a:1:{s:8:\"operator\";b:0;}s:5:\"group\";i:1;}s:4:\"type\";a:4:{s:2:\"id\";s:4:\"type\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:4:\"type\";s:5:\"value\";a:1:{s:5:\"video\";s:5:\"video\";}}}s:5:\"sorts\";a:2:{s:10:\"totalcount\";a:9:{s:2:\"id\";s:10:\"totalcount\";s:5:\"table\";s:12:\"node_counter\";s:5:\"field\";s:10:\"totalcount\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"order\";s:4:\"DESC\";s:7:\"exposed\";b:0;s:6:\"expose\";a:1:{s:5:\"label\";s:0:\"\";}}s:7:\"created\";a:4:{s:2:\"id\";s:7:\"created\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:7:\"created\";s:5:\"order\";s:4:\"DESC\";}}s:5:\"title\";s:9:\"Hot Video\";s:13:\"style_options\";a:4:{s:8:\"grouping\";a:0:{}s:9:\"row_class\";s:0:\"\";s:17:\"default_row_class\";i:1;s:17:\"row_class_special\";i:1;}}'),(14,'block','Block','block',2,'a:2:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:5:\"field\";a:1:{s:5:\"title\";a:1:{s:12:\"link_to_node\";i:1;}}}'),(14,'default','Master','default',1,'a:13:{s:5:\"query\";a:2:{s:4:\"type\";s:11:\"views_query\";s:7:\"options\";a:0:{}}s:6:\"access\";a:1:{s:4:\"type\";s:4:\"perm\";}s:5:\"cache\";a:1:{s:4:\"type\";s:4:\"none\";}s:12:\"exposed_form\";a:1:{s:4:\"type\";s:5:\"basic\";}s:5:\"pager\";a:2:{s:4:\"type\";s:4:\"some\";s:7:\"options\";a:1:{s:14:\"items_per_page\";s:1:\"5\";}}s:12:\"style_plugin\";s:10:\"flexslider\";s:10:\"row_plugin\";s:6:\"fields\";s:6:\"fields\";a:2:{s:10:\"field_link\";a:34:{s:2:\"id\";s:10:\"field_link\";s:5:\"table\";s:21:\"field_data_field_link\";s:5:\"field\";s:10:\"field_link\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:1;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:0;s:4:\"text\";s:0:\"\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:0;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:17:\"click_sort_column\";s:3:\"url\";s:4:\"type\";s:10:\"link_plain\";s:8:\"settings\";a:0:{}s:12:\"group_column\";s:0:\"\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";s:3:\"all\";s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";i:0;}s:11:\"field_image\";a:34:{s:2:\"id\";s:11:\"field_image\";s:5:\"table\";s:22:\"field_data_field_image\";s:5:\"field\";s:11:\"field_image\";s:12:\"relationship\";s:4:\"none\";s:10:\"group_type\";s:5:\"group\";s:7:\"ui_name\";s:0:\"\";s:5:\"label\";s:0:\"\";s:7:\"exclude\";i:0;s:5:\"alter\";a:26:{s:10:\"alter_text\";i:1;s:4:\"text\";s:40:\"<a href=\"[field_link]\">[field_image]</a>\";s:9:\"make_link\";i:0;s:4:\"path\";s:0:\"\";s:8:\"absolute\";i:0;s:8:\"external\";i:0;s:14:\"replace_spaces\";i:0;s:9:\"path_case\";s:4:\"none\";s:15:\"trim_whitespace\";i:0;s:3:\"alt\";s:0:\"\";s:3:\"rel\";s:0:\"\";s:10:\"link_class\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:6:\"target\";s:0:\"\";s:5:\"nl2br\";i:0;s:10:\"max_length\";s:0:\"\";s:13:\"word_boundary\";i:1;s:8:\"ellipsis\";i:1;s:9:\"more_link\";i:0;s:14:\"more_link_text\";s:0:\"\";s:14:\"more_link_path\";s:0:\"\";s:10:\"strip_tags\";i:0;s:4:\"trim\";i:0;s:13:\"preserve_tags\";s:0:\"\";s:4:\"html\";i:0;}s:12:\"element_type\";s:0:\"\";s:13:\"element_class\";s:0:\"\";s:18:\"element_label_type\";s:0:\"\";s:19:\"element_label_class\";s:0:\"\";s:19:\"element_label_colon\";b:0;s:20:\"element_wrapper_type\";s:0:\"\";s:21:\"element_wrapper_class\";s:0:\"\";s:23:\"element_default_classes\";i:1;s:5:\"empty\";s:0:\"\";s:10:\"hide_empty\";i:1;s:10:\"empty_zero\";i:0;s:16:\"hide_alter_empty\";i:1;s:17:\"click_sort_column\";s:3:\"fid\";s:4:\"type\";s:5:\"image\";s:8:\"settings\";a:2:{s:11:\"image_style\";s:0:\"\";s:10:\"image_link\";s:0:\"\";}s:12:\"group_column\";s:0:\"\";s:13:\"group_columns\";a:0:{}s:10:\"group_rows\";b:1;s:11:\"delta_limit\";s:3:\"all\";s:12:\"delta_offset\";i:0;s:14:\"delta_reversed\";b:0;s:16:\"delta_first_last\";b:0;s:10:\"multi_type\";s:9:\"separator\";s:9:\"separator\";s:2:\", \";s:17:\"field_api_classes\";i:0;}}s:7:\"filters\";a:2:{s:6:\"status\";a:6:{s:5:\"value\";i:1;s:5:\"table\";s:4:\"node\";s:5:\"field\";s:6:\"status\";s:2:\"id\";s:6:\"status\";s:6:\"expose\";a:1:{s:8:\"operator\";b:0;}s:5:\"group\";i:1;}s:4:\"type\";a:4:{s:2:\"id\";s:4:\"type\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:4:\"type\";s:5:\"value\";a:1:{s:8:\"products\";s:8:\"products\";}}}s:5:\"sorts\";a:1:{s:7:\"created\";a:4:{s:2:\"id\";s:7:\"created\";s:5:\"table\";s:4:\"node\";s:5:\"field\";s:7:\"created\";s:5:\"order\";s:4:\"DESC\";}}s:5:\"title\";s:12:\"Get Products\";s:13:\"style_options\";a:4:{s:8:\"grouping\";a:0:{}s:9:\"optionset\";s:9:\"hot_video\";s:12:\"captionfield\";s:0:\"\";s:2:\"id\";s:0:\"\";}s:9:\"css_class\";s:15:\"forum-hot-video\";}');
/*!40000 ALTER TABLE `views_display` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `views_view`
--

DROP TABLE IF EXISTS `views_view`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `views_view` (
  `vid` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'The view ID of the field, defined by the database.',
  `name` varchar(128) NOT NULL DEFAULT '' COMMENT 'The unique name of the view. This is the primary field views are loaded from, and is used so that views may be internal and not necessarily in the database. May only be alphanumeric characters plus underscores.',
  `description` varchar(255) DEFAULT '' COMMENT 'A description of the view for the admin interface.',
  `tag` varchar(255) DEFAULT '' COMMENT 'A tag used to group/sort views in the admin interface',
  `base_table` varchar(64) NOT NULL DEFAULT '' COMMENT 'What table this view is based on, such as node, user, comment, or term.',
  `human_name` varchar(255) DEFAULT '' COMMENT 'A human readable name used to be displayed in the admin interface',
  `core` int(11) DEFAULT '0' COMMENT 'Stores the drupal core version of the view.',
  PRIMARY KEY (`vid`),
  UNIQUE KEY `name` (`name`)
) ENGINE=InnoDB AUTO_INCREMENT=15 DEFAULT CHARSET=utf8 COMMENT='Stores the general data for a view.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `views_view`
--

LOCK TABLES `views_view` WRITE;
/*!40000 ALTER TABLE `views_view` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `views_view` VALUES (1,'articles','','default','node','Articles',7),(2,'activity_stream','','default','message','Activity Stream',7),(4,'recent_blogs','','default','node','Recent Blogs',7),(5,'comments','','default','comment','Comments',7),(6,'recent_topics','','default','node','Recent Topics',7),(8,'calendar','','default','node','Calendar',7),(9,'archive','Display a list of months that link to content for that month.','default','node','Archive',0),(10,'new_forum_posts','','default','node','New Forum Posts',7),(11,'blogs','','default','node','Blogs',7),(12,'what_is_news','','default','node','What is news',7),(13,'hot_video','','default','node','Hot Video',7),(14,'get_products','','default','node','Get Products',7);
/*!40000 ALTER TABLE `views_view` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `votingapi_cache`
--

DROP TABLE IF EXISTS `votingapi_cache`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `votingapi_cache` (
  `vote_cache_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `entity_type` varchar(64) NOT NULL DEFAULT 'node',
  `entity_id` int(10) unsigned NOT NULL DEFAULT '0',
  `value` float NOT NULL DEFAULT '0',
  `value_type` varchar(64) NOT NULL DEFAULT 'percent',
  `tag` varchar(64) NOT NULL DEFAULT 'vote',
  `function` varchar(64) NOT NULL DEFAULT '',
  `timestamp` int(10) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`vote_cache_id`),
  KEY `content` (`entity_type`,`entity_id`),
  KEY `content_function` (`entity_type`,`entity_id`,`function`),
  KEY `content_tag_func` (`entity_type`,`entity_id`,`tag`,`function`),
  KEY `content_vtype_tag` (`entity_type`,`entity_id`,`value_type`,`tag`),
  KEY `content_vtype_tag_func` (`entity_type`,`entity_id`,`value_type`,`tag`,`function`)
) ENGINE=InnoDB AUTO_INCREMENT=81 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `votingapi_cache`
--

LOCK TABLES `votingapi_cache` WRITE;
/*!40000 ALTER TABLE `votingapi_cache` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `votingapi_cache` VALUES (15,'node',7,1,'percent','vote','count',1404868412),(16,'node',7,40,'percent','vote','average',1404868412),(19,'node',11,2,'percent','vote','count',1404868423),(20,'node',11,90,'percent','vote','average',1404868423),(23,'node',10,2,'percent','vote','count',1404868426),(24,'node',10,70,'percent','vote','average',1404868426),(27,'node',9,1,'percent','vote','count',1404868442),(28,'node',9,80,'percent','vote','average',1404868442),(31,'node',8,2,'percent','vote','count',1404868445),(32,'node',8,90,'percent','vote','average',1404868445),(43,'comment',8,1,'percent','vote','count',1405267649),(44,'comment',8,80,'percent','vote','average',1405267649),(47,'comment',9,1,'percent','vote','count',1405267651),(48,'comment',9,80,'percent','vote','average',1405267651),(51,'node',15,1,'percent','vote','count',1405267653),(52,'node',15,100,'percent','vote','average',1405267653),(55,'comment',10,2,'percent','vote','count',1405267667),(56,'comment',10,80,'percent','vote','average',1405267667),(59,'node',16,2,'percent','vote','count',1405267670),(60,'node',16,90,'percent','vote','average',1405267670),(63,'node',17,1,'percent','vote','count',1405267888),(64,'node',17,80,'percent','vote','average',1405267888),(71,'node',1,2,'percent','vote','count',1407804961),(72,'node',1,90,'percent','vote','average',1407804961),(75,'comment',1,1,'percent','vote','count',1407804965),(76,'comment',1,80,'percent','vote','average',1407804965),(79,'node',55,1,'percent','vote','count',1408269483),(80,'node',55,100,'percent','vote','average',1408269483);
/*!40000 ALTER TABLE `votingapi_cache` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `votingapi_vote`
--

DROP TABLE IF EXISTS `votingapi_vote`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `votingapi_vote` (
  `vote_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `entity_type` varchar(64) NOT NULL DEFAULT 'node',
  `entity_id` int(10) unsigned NOT NULL DEFAULT '0',
  `value` float NOT NULL DEFAULT '0',
  `value_type` varchar(64) NOT NULL DEFAULT 'percent',
  `tag` varchar(64) NOT NULL DEFAULT 'vote',
  `uid` int(10) unsigned NOT NULL DEFAULT '0',
  `timestamp` int(10) unsigned NOT NULL DEFAULT '0',
  `vote_source` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`vote_id`),
  KEY `content_uid` (`entity_type`,`entity_id`,`uid`),
  KEY `content_uid_2` (`entity_type`,`uid`),
  KEY `content_source` (`entity_type`,`entity_id`,`vote_source`),
  KEY `content_value_tag` (`entity_type`,`entity_id`,`value_type`,`tag`)
) ENGINE=InnoDB AUTO_INCREMENT=21 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `votingapi_vote`
--

LOCK TABLES `votingapi_vote` WRITE;
/*!40000 ALTER TABLE `votingapi_vote` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `votingapi_vote` VALUES (1,'node',11,100,'percent','vote',1,1404868403,'::1'),(2,'node',10,80,'percent','vote',1,1404868406,'::1'),(3,'node',8,80,'percent','vote',1,1404868409,'::1'),(4,'node',7,40,'percent','vote',1,1404868412,'::1'),(5,'node',11,80,'percent','vote',0,1404868423,'::1'),(6,'node',10,60,'percent','vote',0,1404868426,'::1'),(7,'node',9,80,'percent','vote',0,1404868442,'::1'),(8,'node',8,100,'percent','vote',0,1404868445,'::1'),(9,'node',16,80,'percent','vote',1,1405267571,'::1'),(10,'comment',10,80,'percent','vote',1,1405267635,'::1'),(11,'comment',8,80,'percent','vote',6,1405267649,'::1'),(12,'comment',9,80,'percent','vote',6,1405267651,'::1'),(13,'node',15,100,'percent','vote',6,1405267653,'::1'),(14,'comment',10,80,'percent','vote',6,1405267667,'::1'),(15,'node',16,100,'percent','vote',6,1405267670,'::1'),(16,'node',17,80,'percent','vote',1,1405267888,'::1'),(17,'node',1,80,'percent','vote',1,1407804930,'::1'),(18,'node',1,100,'percent','vote',2,1407804961,'::1'),(19,'comment',1,80,'percent','vote',2,1407804965,'::1'),(20,'node',55,100,'percent','vote',1,1408269483,'::1');
/*!40000 ALTER TABLE `votingapi_vote` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `watchdog`
--

DROP TABLE IF EXISTS `watchdog`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `watchdog` (
  `wid` int(11) NOT NULL AUTO_INCREMENT COMMENT 'Primary Key: Unique watchdog event ID.',
  `uid` int(11) NOT NULL DEFAULT '0' COMMENT 'The users.uid of the user who triggered the event.',
  `type` varchar(64) NOT NULL DEFAULT '' COMMENT 'Type of log message, for example "user" or "page not found."',
  `message` longtext NOT NULL COMMENT 'Text of log message to be passed into the t() function.',
  `variables` longblob NOT NULL COMMENT 'Serialized array of variables that match the message string and that is passed into the t() function.',
  `severity` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT 'The severity level of the event; ranges from 0 (Emergency) to 7 (Debug)',
  `link` varchar(255) DEFAULT '' COMMENT 'Link to view the result of the event.',
  `location` text NOT NULL COMMENT 'URL of the origin of the event.',
  `referer` text COMMENT 'URL of referring page.',
  `hostname` varchar(128) NOT NULL DEFAULT '' COMMENT 'Hostname of the user who triggered the event.',
  `timestamp` int(11) NOT NULL DEFAULT '0' COMMENT 'Unix timestamp of when event occurred.',
  PRIMARY KEY (`wid`),
  KEY `type` (`type`),
  KEY `uid` (`uid`),
  KEY `severity` (`severity`)
) ENGINE=InnoDB AUTO_INCREMENT=49 DEFAULT CHARSET=utf8 COMMENT='Table that contains logs of all system events.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `watchdog`
--

LOCK TABLES `watchdog` WRITE;
/*!40000 ALTER TABLE `watchdog` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `watchdog` VALUES (1,0,'cron','Cron run completed.','a:0:{}',5,'','http://local2.weebpal.com/drupal7/forum-plus/','http://local2.weebpal.com/drupal7/forum-plus/install.php?profile=standard&locale=en','192.168.1.49',1499928570),(2,1,'user','Session opened for %name.','a:1:{s:5:\"%name\";s:5:\"admin\";}',5,'','http://local2.weebpal.com/drupal7/forum-plus/en/modal_forms/ajax/login','http://local2.weebpal.com/drupal7/forum-plus/','192.168.1.49',1499928582),(3,1,'system','%module module installed.','a:1:{s:7:\"%module\";s:20:\"we_content_migration\";}',6,'','http://local2.weebpal.com/drupal7/forum-plus/en/admin/modules/list/confirm?render=overlay','http://local2.weebpal.com/drupal7/forum-plus/en/admin/modules?render=overlay','192.168.1.49',1499928651),(4,1,'system','%module module enabled.','a:1:{s:7:\"%module\";s:20:\"we_content_migration\";}',6,'','http://local2.weebpal.com/drupal7/forum-plus/en/admin/modules/list/confirm?render=overlay','http://local2.weebpal.com/drupal7/forum-plus/en/admin/modules?render=overlay','192.168.1.49',1499928651),(5,0,'cron','Attempting to re-run cron while it is already running.','a:0:{}',4,'','http://local2.weebpal.com/drupal7/forum-plus/en/page/color','http://local2.weebpal.com/drupal7/forum-plus/','192.168.1.49',1500259151),(6,0,'cron','Attempting to re-run cron while it is already running.','a:0:{}',4,'','http://local2.weebpal.com/drupal7/forum-plus/en/activity-stream','http://local2.weebpal.com/drupal7/forum-plus/en/page/color','192.168.1.49',1500259154),(7,0,'cron','Attempting to re-run cron while it is already running.','a:0:{}',4,'','http://local2.weebpal.com/drupal7/forum-plus/en/blogs','http://local2.weebpal.com/drupal7/forum-plus/en/activity-stream','192.168.1.49',1500259156),(8,0,'cron','Attempting to re-run cron while it is already running.','a:0:{}',4,'','http://local2.weebpal.com/drupal7/forum-plus/en/forum','http://local2.weebpal.com/drupal7/forum-plus/en/blogs','192.168.1.49',1500259156),(9,0,'cron','Cron run completed.','a:0:{}',5,'','http://local2.weebpal.com/drupal7/forum-plus/','','192.168.1.49',1500259162),(10,1,'user','Session opened for %name.','a:1:{s:5:\"%name\";s:5:\"admin\";}',5,'','http://local2.weebpal.com/drupal7/forum-plus/user','http://local2.weebpal.com/drupal7/forum-plus/user','192.168.1.49',1500259169),(11,0,'cron','Cron run completed.','a:0:{}',5,'','http://local2.weebpal.com/drupal7/forum-plus/','','192.168.1.49',1500277501),(12,0,'cron','Cron run completed.','a:0:{}',5,'','http://local2.weebpal.com/drupal7/forum-plus/','','192.168.1.49',1500346509),(13,0,'cron','Attempting to re-run cron while it is already running.','a:0:{}',4,'','http://local2.weebpal.com/drupal7/forum-plus/en/user/login','http://local2.weebpal.com/drupal7/forum-plus/','192.168.1.43',1501055005),(14,1,'user','Session opened for %name.','a:1:{s:5:\"%name\";s:5:\"admin\";}',5,'','http://local2.weebpal.com/drupal7/forum-plus/en/user/login','http://local2.weebpal.com/drupal7/forum-plus/en/user/login','192.168.1.43',1501055009),(15,1,'php','%type: !message in %function (line %line of %file).','a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"!message\";s:54:\"Object of class stdClass could not be converted to int\";s:9:\"%function\";s:21:\"drupal_write_record()\";s:5:\"%file\";s:48:\"/data/dev/drupal7/forum-plus/includes/common.inc\";s:5:\"%line\";i:7340;s:14:\"severity_level\";i:5;}',5,'','http://local2.weebpal.com/drupal7/forum-plus/en/user/login','http://local2.weebpal.com/drupal7/forum-plus/en/user/login','192.168.1.43',1501055009),(16,1,'php','%type: !message in %function (line %line of %file).','a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"!message\";s:36:\"Trying to get property of non-object\";s:9:\"%function\";s:42:\"views_handler_field_user_picture->render()\";s:5:\"%file\";s:102:\"/data/dev/drupal7/forum-plus/sites/all/modules/views/modules/user/views_handler_field_user_picture.inc\";s:5:\"%line\";i:82;s:14:\"severity_level\";i:5;}',5,'','http://local2.weebpal.com/drupal7/forum-plus/en/users/admin','http://local2.weebpal.com/drupal7/forum-plus/en/user/login','192.168.1.43',1501055009),(17,0,'cron','Attempting to re-run cron while it is already running.','a:0:{}',4,'','http://local2.weebpal.com/drupal7/forum-plus/en/users/admin','http://local2.weebpal.com/drupal7/forum-plus/en/user/login','192.168.1.43',1501055010),(18,1,'php','%type: !message in %function (line %line of %file).','a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"!message\";s:36:\"Trying to get property of non-object\";s:9:\"%function\";s:42:\"views_handler_field_user_picture->render()\";s:5:\"%file\";s:102:\"/data/dev/drupal7/forum-plus/sites/all/modules/views/modules/user/views_handler_field_user_picture.inc\";s:5:\"%line\";i:82;s:14:\"severity_level\";i:5;}',5,'','http://local2.weebpal.com/drupal7/forum-plus/en','http://local2.weebpal.com/drupal7/forum-plus/en/users/admin','192.168.1.43',1501055013),(19,1,'php','%type: !message in %function (line %line of %file).','a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"!message\";s:36:\"Trying to get property of non-object\";s:9:\"%function\";s:42:\"views_handler_field_user_picture->render()\";s:5:\"%file\";s:102:\"/data/dev/drupal7/forum-plus/sites/all/modules/views/modules/user/views_handler_field_user_picture.inc\";s:5:\"%line\";i:82;s:14:\"severity_level\";i:5;}',5,'','http://local2.weebpal.com/drupal7/forum-plus/en','http://local2.weebpal.com/drupal7/forum-plus/en/users/admin','192.168.1.43',1501055013),(20,1,'php','%type: !message in %function (line %line of %file).','a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"!message\";s:36:\"Trying to get property of non-object\";s:9:\"%function\";s:42:\"views_handler_field_user_picture->render()\";s:5:\"%file\";s:102:\"/data/dev/drupal7/forum-plus/sites/all/modules/views/modules/user/views_handler_field_user_picture.inc\";s:5:\"%line\";i:82;s:14:\"severity_level\";i:5;}',5,'','http://local2.weebpal.com/drupal7/forum-plus/en','http://local2.weebpal.com/drupal7/forum-plus/en/users/admin','192.168.1.43',1501055013),(21,0,'cron','Attempting to re-run cron while it is already running.','a:0:{}',4,'','http://local2.weebpal.com/drupal7/forum-plus/en','http://local2.weebpal.com/drupal7/forum-plus/en/users/admin','192.168.1.43',1501055014),(22,0,'cron','Attempting to re-run cron while it is already running.','a:0:{}',4,'','http://local2.weebpal.com/drupal7/forum-plus/en/js/admin_menu/cache/06fcdf9a30d28a909a278a01c730365a','http://local2.weebpal.com/drupal7/forum-plus/en','192.168.1.43',1501055014),(23,0,'cron','Attempting to re-run cron while it is already running.','a:0:{}',4,'','http://local2.weebpal.com/drupal7/forum-plus/en/admin/modules?render=overlay','http://local2.weebpal.com/drupal7/forum-plus/en','192.168.1.43',1501055015),(24,0,'cron','Attempting to re-run cron while it is already running.','a:0:{}',4,'','http://local2.weebpal.com/drupal7/forum-plus/en/admin/config/content/advanced-forum?render=overlay','http://local2.weebpal.com/drupal7/forum-plus/en','192.168.1.43',1501055028),(25,0,'cron','Cron run completed.','a:0:{}',5,'','http://local2.weebpal.com/drupal7/forum-plus/','','192.168.1.43',1501055033),(26,1,'php','%type: !message in %function (line %line of %file).','a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"!message\";s:36:\"Trying to get property of non-object\";s:9:\"%function\";s:42:\"views_handler_field_user_picture->render()\";s:5:\"%file\";s:102:\"/data/dev/drupal7/forum-plus/sites/all/modules/views/modules/user/views_handler_field_user_picture.inc\";s:5:\"%line\";i:82;s:14:\"severity_level\";i:5;}',5,'','http://local2.weebpal.com/drupal7/forum-plus/','','192.168.1.43',1501061388),(27,1,'php','%type: !message in %function (line %line of %file).','a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"!message\";s:36:\"Trying to get property of non-object\";s:9:\"%function\";s:42:\"views_handler_field_user_picture->render()\";s:5:\"%file\";s:102:\"/data/dev/drupal7/forum-plus/sites/all/modules/views/modules/user/views_handler_field_user_picture.inc\";s:5:\"%line\";i:82;s:14:\"severity_level\";i:5;}',5,'','http://local2.weebpal.com/drupal7/forum-plus/','','192.168.1.43',1501061388),(28,1,'php','%type: !message in %function (line %line of %file).','a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"!message\";s:36:\"Trying to get property of non-object\";s:9:\"%function\";s:42:\"views_handler_field_user_picture->render()\";s:5:\"%file\";s:102:\"/data/dev/drupal7/forum-plus/sites/all/modules/views/modules/user/views_handler_field_user_picture.inc\";s:5:\"%line\";i:82;s:14:\"severity_level\";i:5;}',5,'','http://local2.weebpal.com/drupal7/forum-plus/','','192.168.1.43',1501061388),(29,0,'php','%type: !message in %function (line %line of %file).','a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"!message\";s:36:\"Trying to get property of non-object\";s:9:\"%function\";s:42:\"views_handler_field_user_picture->render()\";s:5:\"%file\";s:102:\"/data/dev/drupal7/forum-plus/sites/all/modules/views/modules/user/views_handler_field_user_picture.inc\";s:5:\"%line\";i:82;s:14:\"severity_level\";i:5;}',5,'','http://local2.weebpal.com/drupal7/forum-plus/','','13.76.241.210',1501061391),(30,0,'php','%type: !message in %function (line %line of %file).','a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"!message\";s:36:\"Trying to get property of non-object\";s:9:\"%function\";s:42:\"views_handler_field_user_picture->render()\";s:5:\"%file\";s:102:\"/data/dev/drupal7/forum-plus/sites/all/modules/views/modules/user/views_handler_field_user_picture.inc\";s:5:\"%line\";i:82;s:14:\"severity_level\";i:5;}',5,'','http://local2.weebpal.com/drupal7/forum-plus/','','13.76.241.210',1501061391),(31,0,'php','%type: !message in %function (line %line of %file).','a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"!message\";s:36:\"Trying to get property of non-object\";s:9:\"%function\";s:42:\"views_handler_field_user_picture->render()\";s:5:\"%file\";s:102:\"/data/dev/drupal7/forum-plus/sites/all/modules/views/modules/user/views_handler_field_user_picture.inc\";s:5:\"%line\";i:82;s:14:\"severity_level\";i:5;}',5,'','http://local2.weebpal.com/drupal7/forum-plus/','','13.76.241.210',1501061391),(32,0,'php','%type: !message in %function (line %line of %file).','a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"!message\";s:36:\"Trying to get property of non-object\";s:9:\"%function\";s:42:\"views_handler_field_user_picture->render()\";s:5:\"%file\";s:102:\"/data/dev/drupal7/forum-plus/sites/all/modules/views/modules/user/views_handler_field_user_picture.inc\";s:5:\"%line\";i:82;s:14:\"severity_level\";i:5;}',5,'','http://local2.weebpal.com/drupal7/forum-plus/','','13.76.241.210',1501061391),(33,0,'php','%type: !message in %function (line %line of %file).','a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"!message\";s:36:\"Trying to get property of non-object\";s:9:\"%function\";s:42:\"views_handler_field_user_picture->render()\";s:5:\"%file\";s:102:\"/data/dev/drupal7/forum-plus/sites/all/modules/views/modules/user/views_handler_field_user_picture.inc\";s:5:\"%line\";i:82;s:14:\"severity_level\";i:5;}',5,'','http://local2.weebpal.com/drupal7/forum-plus/','','13.76.241.210',1501061391),(34,0,'php','%type: !message in %function (line %line of %file).','a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"!message\";s:36:\"Trying to get property of non-object\";s:9:\"%function\";s:42:\"views_handler_field_user_picture->render()\";s:5:\"%file\";s:102:\"/data/dev/drupal7/forum-plus/sites/all/modules/views/modules/user/views_handler_field_user_picture.inc\";s:5:\"%line\";i:82;s:14:\"severity_level\";i:5;}',5,'','http://local2.weebpal.com/drupal7/forum-plus/','','13.76.241.210',1501061391),(35,0,'php','%type: !message in %function (line %line of %file).','a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"!message\";s:36:\"Trying to get property of non-object\";s:9:\"%function\";s:42:\"views_handler_field_user_picture->render()\";s:5:\"%file\";s:102:\"/data/dev/drupal7/forum-plus/sites/all/modules/views/modules/user/views_handler_field_user_picture.inc\";s:5:\"%line\";i:82;s:14:\"severity_level\";i:5;}',5,'','http://local2.weebpal.com/drupal7/forum-plus/','','192.168.1.63',1501061395),(36,0,'php','%type: !message in %function (line %line of %file).','a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"!message\";s:36:\"Trying to get property of non-object\";s:9:\"%function\";s:42:\"views_handler_field_user_picture->render()\";s:5:\"%file\";s:102:\"/data/dev/drupal7/forum-plus/sites/all/modules/views/modules/user/views_handler_field_user_picture.inc\";s:5:\"%line\";i:82;s:14:\"severity_level\";i:5;}',5,'','http://local2.weebpal.com/drupal7/forum-plus/','','192.168.1.63',1501061395),(37,0,'php','%type: !message in %function (line %line of %file).','a:6:{s:5:\"%type\";s:6:\"Notice\";s:8:\"!message\";s:36:\"Trying to get property of non-object\";s:9:\"%function\";s:42:\"views_handler_field_user_picture->render()\";s:5:\"%file\";s:102:\"/data/dev/drupal7/forum-plus/sites/all/modules/views/modules/user/views_handler_field_user_picture.inc\";s:5:\"%line\";i:82;s:14:\"severity_level\";i:5;}',5,'','http://local2.weebpal.com/drupal7/forum-plus/','','192.168.1.63',1501061395),(38,1,'user','Session opened for %name.','a:1:{s:5:\"%name\";s:5:\"admin\";}',5,'','http://local2.weebpal.com/drupal7/forum-plus/en/modal_forms/ajax/login','http://local2.weebpal.com/drupal7/forum-plus/','192.168.1.63',1501061407),(39,0,'cron','Cron run completed.','a:0:{}',5,'','http://forum-plus.local2.weebpal.com/','','27.74.249.234',1502692756),(40,0,'cron','Cron run completed.','a:0:{}',5,'','http://forum-plus.local2.weebpal.com/','','192.168.1.170',1508307529),(41,0,'cron','Attempting to re-run cron while it is already running.','a:0:{}',4,'','http://forum-plus.local2.weebpal.com/en/user/login','http://forum-plus.local2.weebpal.com/en','192.168.1.170',1508496337),(42,1,'user','Session opened for %name.','a:1:{s:5:\"%name\";s:5:\"admin\";}',5,'','http://forum-plus.local2.weebpal.com/en/user/login','http://forum-plus.local2.weebpal.com/en/user/login','192.168.1.170',1508496343),(43,0,'cron','Attempting to re-run cron while it is already running.','a:0:{}',4,'','http://forum-plus.local2.weebpal.com/en/users/admin','http://forum-plus.local2.weebpal.com/en/user/login','192.168.1.170',1508496344),(44,0,'cron','Attempting to re-run cron while it is already running.','a:0:{}',4,'','http://forum-plus.local2.weebpal.com/en/admin/modules?render=overlay','http://forum-plus.local2.weebpal.com/en/users/admin','192.168.1.170',1508496352),(45,0,'cron','Cron run completed.','a:0:{}',5,'','http://forum-plus.local2.weebpal.com/en','','192.168.1.170',1508496365),(46,1,'user','Session closed for %name.','a:1:{s:5:\"%name\";s:5:\"admin\";}',5,'','http://forum-plus.local2.weebpal.com/en/user/logout','http://forum-plus.local2.weebpal.com/en/users/admin','192.168.1.170',1508496775),(47,0,'cron','Cron run completed.','a:0:{}',5,'','http://forum-plus.local2.weebpal.com/','','192.168.1.34',1512620339),(48,1,'user','Session opened for %name.','a:1:{s:5:\"%name\";s:5:\"admin\";}',5,'','http://forum-plus.local2.weebpal.com/user','http://forum-plus.local2.weebpal.com/user','192.168.1.34',1512620348);
/*!40000 ALTER TABLE `watchdog` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `we_content_migration_mapping`
--

DROP TABLE IF EXISTS `we_content_migration_mapping`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `we_content_migration_mapping` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'The primary identifier',
  `old_entity_type` varchar(128) DEFAULT NULL COMMENT 'The machine name of the old entity',
  `old_bundle` varchar(128) DEFAULT NULL COMMENT 'The old bundle’s name',
  `old_entity_id` int(11) DEFAULT NULL COMMENT 'The old entity id',
  `new_entity_type` varchar(128) NOT NULL COMMENT 'The machine name of the new entity',
  `new_bundle` varchar(128) NOT NULL COMMENT 'The new bundle’s name',
  `new_entity_id` int(11) NOT NULL COMMENT 'The new entity id',
  PRIMARY KEY (`id`),
  KEY `mapping` (`old_entity_type`,`old_bundle`,`old_entity_id`,`new_entity_type`,`new_bundle`,`new_entity_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='The table to save the mapping.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `we_content_migration_mapping`
--

LOCK TABLES `we_content_migration_mapping` WRITE;
/*!40000 ALTER TABLE `we_content_migration_mapping` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `we_content_migration_mapping` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `we_content_migration_mapping_reference`
--

DROP TABLE IF EXISTS `we_content_migration_mapping_reference`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `we_content_migration_mapping_reference` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'The primary identifier',
  `entity_type` varchar(128) NOT NULL COMMENT 'The machine name of the entity',
  `bundle` varchar(128) NOT NULL COMMENT 'The bundle’s name',
  `eid` int(11) NOT NULL COMMENT 'The entity id',
  `field_name` varchar(32) NOT NULL COMMENT 'The field name',
  `field_value` text NOT NULL COMMENT 'The field value string',
  `language` varchar(12) NOT NULL DEFAULT '',
  `status` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `mapping_reference` (`entity_type`,`bundle`,`eid`,`field_name`,`status`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='The table to save all reference field data.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `we_content_migration_mapping_reference`
--

LOCK TABLES `we_content_migration_mapping_reference` WRITE;
/*!40000 ALTER TABLE `we_content_migration_mapping_reference` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `we_content_migration_mapping_reference` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `webform`
--

DROP TABLE IF EXISTS `webform`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `webform` (
  `nid` int(10) unsigned NOT NULL COMMENT 'The node identifier of a webform.',
  `confirmation` text NOT NULL COMMENT 'The confirmation message or URL displayed to the user after submitting a form.',
  `confirmation_format` varchar(255) DEFAULT NULL COMMENT 'The filter_format.format of the confirmation message.',
  `redirect_url` varchar(2048) DEFAULT '<confirmation>' COMMENT 'The URL a user is redirected to after submitting a form.',
  `status` tinyint(4) NOT NULL DEFAULT '1' COMMENT 'Boolean value of a webform for open (1) or closed (0).',
  `block` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'Boolean value for whether this form be available as a block.',
  `allow_draft` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'Boolean value for whether submissions to this form be saved as a draft.',
  `auto_save` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'Boolean value for whether submissions to this form should be auto-saved between pages.',
  `submit_notice` tinyint(4) NOT NULL DEFAULT '1' COMMENT 'Boolean value for whether to show or hide the previous submissions notification.',
  `submit_text` varchar(255) DEFAULT NULL COMMENT 'The title of the submit button on the form.',
  `submit_limit` tinyint(4) NOT NULL DEFAULT '-1' COMMENT 'The number of submissions a single user is allowed to submit within an interval. -1 is unlimited.',
  `submit_interval` int(11) NOT NULL DEFAULT '-1' COMMENT 'The amount of time in seconds that must pass before a user can submit another submission within the set limit.',
  `total_submit_limit` int(11) NOT NULL DEFAULT '-1' COMMENT 'The total number of submissions allowed within an interval. -1 is unlimited.',
  `total_submit_interval` int(11) NOT NULL DEFAULT '-1' COMMENT 'The amount of time in seconds that must pass before another submission can be submitted within the set limit.',
  `progressbar_bar` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'Boolean value indicating if the bar should be shown as part of the progress bar.',
  `progressbar_page_number` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'Boolean value indicating if the page number should be shown as part of the progress bar.',
  `progressbar_percent` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'Boolean value indicating if the percentage complete should be shown as part of the progress bar.',
  `progressbar_pagebreak_labels` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'Boolean value indicating if the pagebreak labels should be included as part of the progress bar.',
  `progressbar_include_confirmation` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'Boolean value indicating if the confirmation page should count as a page in the progress bar.',
  `progressbar_label_first` varchar(255) DEFAULT NULL COMMENT 'Label for the first page of the progress bar.',
  `progressbar_label_confirmation` varchar(255) DEFAULT NULL COMMENT 'Label for the last page of the progress bar.',
  `preview` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'Boolean value indicating if this form includes a page for previewing the submission.',
  `preview_next_button_label` varchar(255) DEFAULT NULL COMMENT 'The text for the button that will proceed to the preview page.',
  `preview_prev_button_label` varchar(255) DEFAULT NULL COMMENT 'The text for the button to go backwards from the preview page.',
  `preview_title` varchar(255) DEFAULT NULL COMMENT 'The title of the preview page, as used by the progress bar.',
  `preview_message` text NOT NULL COMMENT 'Text shown on the preview page of the form.',
  `preview_message_format` varchar(255) DEFAULT NULL COMMENT 'The filter_format.format of the preview page message.',
  `preview_excluded_components` text NOT NULL COMMENT 'Comma-separated list of component IDs that should not be included in this form’s confirmation page.',
  `next_serial` int(10) unsigned NOT NULL DEFAULT '1' COMMENT 'The serial number to give to the next submission to this webform.',
  `confidential` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'Boolean value for whether to anonymize submissions.',
  PRIMARY KEY (`nid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Table for storing additional properties for webform nodes.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `webform`
--

LOCK TABLES `webform` WRITE;
/*!40000 ALTER TABLE `webform` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `webform` VALUES (40,'','filtered_html','<confirmation>',1,0,0,0,1,'Send message',-1,-1,-1,-1,0,0,0,0,0,NULL,NULL,0,NULL,NULL,NULL,'',NULL,'',1,0),(41,'',NULL,'<confirmation>',1,0,0,0,1,'',-1,-1,-1,-1,0,0,0,0,0,NULL,NULL,0,NULL,NULL,NULL,'',NULL,'',1,0);
/*!40000 ALTER TABLE `webform` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `webform_component`
--

DROP TABLE IF EXISTS `webform_component`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `webform_component` (
  `nid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The node identifier of a webform.',
  `cid` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'The identifier for this component within this node, starts at 0 for each node.',
  `pid` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'If this component has a parent fieldset, the cid of that component.',
  `form_key` varchar(128) DEFAULT NULL COMMENT 'When the form is displayed and processed, this key can be used to reference the results.',
  `name` text NOT NULL,
  `type` varchar(16) DEFAULT NULL COMMENT 'The field type of this component (textfield, select, hidden, etc.).',
  `value` text NOT NULL COMMENT 'The default value of the component when displayed to the end-user.',
  `extra` text NOT NULL COMMENT 'Additional information unique to the display or processing of this component.',
  `required` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'Boolean flag for if this component is required.',
  `weight` smallint(6) NOT NULL DEFAULT '0' COMMENT 'Determines the position of this component in the form.',
  PRIMARY KEY (`nid`,`cid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Stores information about components for webform nodes.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `webform_component`
--

LOCK TABLES `webform_component` WRITE;
/*!40000 ALTER TABLE `webform_component` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `webform_component` VALUES (40,1,0,'your_name','Your Name','textfield','','a:4:{s:13:\"title_display\";s:4:\"none\";s:7:\"private\";i:0;s:8:\"disabled\";i:0;s:6:\"unique\";i:0;}',1,0),(40,2,0,'email','Email','email','','a:4:{s:13:\"title_display\";s:4:\"none\";s:7:\"private\";i:0;s:8:\"disabled\";i:0;s:6:\"unique\";i:0;}',1,1),(40,3,0,'subject','Subject','textfield','','a:4:{s:13:\"title_display\";s:4:\"none\";s:7:\"private\";i:0;s:8:\"disabled\";i:0;s:6:\"unique\";i:0;}',1,2),(40,4,0,'your_comment','Your Comment','textarea','','a:4:{s:13:\"title_display\";s:4:\"none\";s:7:\"private\";i:0;s:9:\"resizable\";i:1;s:8:\"disabled\";i:0;}',1,3),(41,1,0,'your_name','Your Name','textfield','','a:4:{s:13:\"title_display\";s:6:\"before\";s:7:\"private\";i:0;s:8:\"disabled\";i:0;s:6:\"unique\";i:0;}',1,0),(41,2,0,'email','Email','email','','a:4:{s:13:\"title_display\";s:6:\"before\";s:7:\"private\";i:0;s:8:\"disabled\";i:0;s:6:\"unique\";i:0;}',1,1),(41,3,0,'subject','Subject','textfield','','a:4:{s:13:\"title_display\";s:6:\"before\";s:7:\"private\";i:0;s:8:\"disabled\";i:0;s:6:\"unique\";i:0;}',1,2),(41,4,0,'your_comment','Your Comment','textarea','','a:4:{s:13:\"title_display\";i:0;s:7:\"private\";i:0;s:9:\"resizable\";i:1;s:8:\"disabled\";i:0;}',1,3);
/*!40000 ALTER TABLE `webform_component` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `webform_conditional`
--

DROP TABLE IF EXISTS `webform_conditional`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `webform_conditional` (
  `nid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The node identifier of a webform.',
  `rgid` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'The rule group identifier for this group of rules.',
  `andor` varchar(128) DEFAULT NULL COMMENT 'Whether to AND or OR the actions in this group. All actions within the same crid should have the same andor value.',
  `weight` smallint(6) NOT NULL DEFAULT '0' COMMENT 'Determines the position of this conditional compared to others.',
  PRIMARY KEY (`nid`,`rgid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Holds information about conditional logic.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `webform_conditional`
--

LOCK TABLES `webform_conditional` WRITE;
/*!40000 ALTER TABLE `webform_conditional` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `webform_conditional` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `webform_conditional_actions`
--

DROP TABLE IF EXISTS `webform_conditional_actions`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `webform_conditional_actions` (
  `nid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The node identifier of a webform.',
  `rgid` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'The rule group identifier for this group of rules.',
  `aid` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'The rule identifier for this conditional action.',
  `target_type` varchar(128) DEFAULT NULL COMMENT 'The type of target to be affected. Currently always "component". Indicates what type of ID the "target" column contains.',
  `target` varchar(128) DEFAULT NULL COMMENT 'The ID of the target to be affected. Typically a component ID.',
  `invert` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'If inverted, execute when rule(s) are false.',
  `action` varchar(128) DEFAULT NULL COMMENT 'The action to be performed on the target.',
  `argument` text COMMENT 'Optional argument for action.',
  PRIMARY KEY (`nid`,`rgid`,`aid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Holds information about conditional actions.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `webform_conditional_actions`
--

LOCK TABLES `webform_conditional_actions` WRITE;
/*!40000 ALTER TABLE `webform_conditional_actions` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `webform_conditional_actions` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `webform_conditional_rules`
--

DROP TABLE IF EXISTS `webform_conditional_rules`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `webform_conditional_rules` (
  `nid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The node identifier of a webform.',
  `rgid` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'The rule group identifier for this group of rules.',
  `rid` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'The rule identifier for this conditional rule.',
  `source_type` varchar(128) DEFAULT NULL COMMENT 'The type of source on which the conditional is based. Currently always "component". Indicates what type of ID the "source" column contains.',
  `source` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'The component ID being used in this condition.',
  `operator` varchar(128) DEFAULT NULL COMMENT 'Which operator (equal, contains, starts with, etc.) should be used for this comparison between the source and value?',
  `value` text COMMENT 'The value to be compared with source.',
  PRIMARY KEY (`nid`,`rgid`,`rid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Holds information about conditional logic.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `webform_conditional_rules`
--

LOCK TABLES `webform_conditional_rules` WRITE;
/*!40000 ALTER TABLE `webform_conditional_rules` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `webform_conditional_rules` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `webform_emails`
--

DROP TABLE IF EXISTS `webform_emails`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `webform_emails` (
  `nid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The node identifier of a webform.',
  `eid` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'The e-mail identifier for this row’s settings.',
  `email` text COMMENT 'The e-mail address that will be sent to upon submission. This may be an e-mail address, the special key "default" or a numeric value. If a numeric value is used, the value of a component will be substituted on submission.',
  `subject` text COMMENT 'The e-mail subject that will be used. This may be a string, the special key "default" or a numeric value. If a numeric value is used, the value of a component will be substituted on submission.',
  `from_name` text COMMENT 'The e-mail "from" name that will be used. This may be a string, the special key "default" or a numeric value. If a numeric value is used, the value of a component will be substituted on submission.',
  `from_address` text COMMENT 'The e-mail "from" e-mail address that will be used. This may be a string, the special key "default" or a numeric value. If a numeric value is used, the value of a component will be substituted on submission.',
  `template` text COMMENT 'A template that will be used for the sent e-mail. This may be a string or the special key "default", which will use the template provided by the theming layer.',
  `excluded_components` text NOT NULL COMMENT 'A list of components that will not be included in the %email_values token. A list of CIDs separated by commas.',
  `html` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT 'Determines if the e-mail will be sent in an HTML format. Requires Mime Mail module.',
  `attachments` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT 'Determines if the e-mail will include file attachments. Requires Mime Mail module.',
  `extra` text NOT NULL COMMENT 'A serialized array of additional options for the e-mail configuration, including excluded components and value mapping for the TO and FROM addresses for select lists.',
  `exclude_empty` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT 'Determines if the e-mail will include component with an empty value.',
  `status` tinyint(3) unsigned NOT NULL DEFAULT '1' COMMENT 'Whether this email is enabled.',
  PRIMARY KEY (`nid`,`eid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Holds information regarding e-mails that should be sent...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `webform_emails`
--

LOCK TABLES `webform_emails` WRITE;
/*!40000 ALTER TABLE `webform_emails` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `webform_emails` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `webform_last_download`
--

DROP TABLE IF EXISTS `webform_last_download`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `webform_last_download` (
  `nid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The node identifier of a webform.',
  `uid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The user identifier.',
  `sid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The last downloaded submission number.',
  `requested` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Timestamp of last download request.',
  PRIMARY KEY (`nid`,`uid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Stores last submission number per user download.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `webform_last_download`
--

LOCK TABLES `webform_last_download` WRITE;
/*!40000 ALTER TABLE `webform_last_download` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `webform_last_download` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `webform_roles`
--

DROP TABLE IF EXISTS `webform_roles`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `webform_roles` (
  `nid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The node identifier of a webform.',
  `rid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The role identifier.',
  PRIMARY KEY (`nid`,`rid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Holds access information regarding which roles are...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `webform_roles`
--

LOCK TABLES `webform_roles` WRITE;
/*!40000 ALTER TABLE `webform_roles` DISABLE KEYS */;
set autocommit=0;
INSERT INTO `webform_roles` VALUES (40,1),(40,2),(41,1),(41,2);
/*!40000 ALTER TABLE `webform_roles` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `webform_submissions`
--

DROP TABLE IF EXISTS `webform_submissions`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `webform_submissions` (
  `sid` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'The unique identifier for this submission.',
  `nid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The node identifier of a webform.',
  `uid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The id of the user that completed this submission.',
  `is_draft` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'Is this a draft of the submission?',
  `submitted` int(11) NOT NULL DEFAULT '0' COMMENT 'Timestamp of when the form was submitted.',
  `remote_addr` varchar(128) DEFAULT NULL COMMENT 'The IP address of the user that submitted the form.',
  `serial` int(10) unsigned NOT NULL COMMENT 'The serial number of this submission.',
  `completed` int(11) NOT NULL DEFAULT '0' COMMENT 'Timestamp when the form was submitted as complete (not draft).',
  `modified` int(11) NOT NULL DEFAULT '0' COMMENT 'Timestamp when the form was last saved (complete or draft).',
  `highest_valid_page` smallint(6) NOT NULL DEFAULT '0' COMMENT 'For drafts, the highest validated page number.',
  PRIMARY KEY (`sid`),
  UNIQUE KEY `sid_nid` (`sid`,`nid`),
  UNIQUE KEY `nid_serial` (`nid`,`serial`),
  KEY `nid_uid_sid` (`nid`,`uid`,`sid`),
  KEY `nid_sid` (`nid`,`sid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Holds general information about submissions outside of...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `webform_submissions`
--

LOCK TABLES `webform_submissions` WRITE;
/*!40000 ALTER TABLE `webform_submissions` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `webform_submissions` ENABLE KEYS */;
UNLOCK TABLES;
commit;

--
-- Table structure for table `webform_submitted_data`
--

DROP TABLE IF EXISTS `webform_submitted_data`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `webform_submitted_data` (
  `nid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The node identifier of a webform.',
  `sid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The unique identifier for this submission.',
  `cid` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'The identifier for this component within this node, starts at 0 for each node.',
  `no` varchar(128) NOT NULL DEFAULT '0' COMMENT 'Usually this value is 0, but if a field has multiple values (such as a time or date), it may require multiple rows in the database.',
  `data` mediumtext NOT NULL COMMENT 'The submitted value of this field, may be serialized for some components.',
  PRIMARY KEY (`nid`,`sid`,`cid`,`no`),
  KEY `nid` (`nid`),
  KEY `sid_nid` (`sid`,`nid`),
  KEY `data` (`data`(64))
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Stores all submitted field data for webform submissions.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `webform_submitted_data`
--

LOCK TABLES `webform_submitted_data` WRITE;
/*!40000 ALTER TABLE `webform_submitted_data` DISABLE KEYS */;
set autocommit=0;
/*!40000 ALTER TABLE `webform_submitted_data` ENABLE KEYS */;
UNLOCK TABLES;
commit;
/*!40103 SET TIME_ZONE=@OLD_TIME_ZONE */;

/*!40101 SET SQL_MODE=@OLD_SQL_MODE */;
/*!40014 SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS */;
/*!40014 SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS */;
/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
/*!40111 SET SQL_NOTES=@OLD_SQL_NOTES */;

-- Dump completed on 2017-12-07 11:19:13
